c
c    print out response values in a file cresp.out from all response
c    files in a directory using filenr.lis. Sorting after instrument
c    type and component
c
c    may 95 by jh: a bit clean up
c    mar 3 99 by jh : ----------- version 7.0 check -------------------
c                     station to 5 chars
c    may 11 00  lo  : use read_resp routine
c    may 16 01  jh  : fix common block, change output format
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'

      logical gse_resp          ! true if gse format
      logical sei_resp          ! true if seisan format
      integer nfa               ! number of frequencies and amplitude
      character*120 htext       ! explanation text

c   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      real xpole(10)
      REAL FFILT(10)
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
c   sensor type 2: seismometer, 3: accelerometer
      integer sentyp
      real g1hz  ! gain at 1 hz
c   individual response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
      
      real g5hz  ! gain at 1 hz
      complex res
c   variables for sorting
      character*80 fil(1000),outf(1000)
      character*14 fils
      integer istat,nstat,nout,nfile,outn(1000)
c
      INTEGER I,J,k,iresp,nfil
      character*80 filename(1000)
      character*27 filt_text(5)         ! text for filters
      real filtl(10)                    ! low pass filters
      real filth(10)                    ! high pass filters
      integer polel(10),poleh(10)       ! poles
      integer nlow,nhigh                ! number of low and high pass filters
      integer nfilt_text                ! number of filter pairs for output
      logical ftab                      ! if true, force tabulated values


c
c response common block
c
      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa

      equivalence (xpole,pole)



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      nfil=0

      write(6,*)' Program writes a table of response values for'
      write(6,*)' response functions found in CAL. Program must be'
      write(6,*)' run in CAL and there must be a filenr.lis file'
      write(6,*)' with a list of the response files to be listed'
      write(6,*)' The output is in file pr_resp.out'
      write(6,*)' Return to continue'
      read(5,'(a)') i
      open(1,file='filenr.lis',status='old')
      open(2,file='pr_resp.out',status='unknown')
      write(2,'(a,a,a)')' STAT  COMP  YEAR DATE  PERIOD  DAMP  GENCON',
     *            '   AGAIN   REGAIN    FLOW  P  FHIG  P   G 1 HZ   ',
     *            'G 5 HZ' 
c
c
c   loop for reading response files
c
      nfile=0
  1   continue
      nfile=nfile+1
      read(1,'(7x,a)',end=9) filename(nfile)
      if(filename(nfile)(1:5).eq.'     ') goto 9
      goto 1
  9   continue
      write(6,*)' Number of response files: ',nfile-1
c
c   find number of identical stations
c
      istat=0
      nstat=1
c
  10  continue
      istat=istat+1
      if(istat.gt.nfile-1) goto 99    ! finished 
      fil(nstat)=filename(istat)
      if(filename(istat)(1:5).ne.filename(istat+1)(1:5)) goto 11
      nstat=nstat+1
      goto 10
  11  continue
c
c  now all identical stations found
c
      write(6,*) nstat
c
c   sort after type and component
c
      do i=1,nstat
        outn(i)=0
      enddo
      nout=1
c
c   short period
c
      do i=1,nstat
         if(fil(i)(5:5).eq.'S'.and.fil(i)(8:8).eq.'Z'.and.outn(i).ne.1)
     *   then
            outn(i)=1
            outf(nout)=fil(i)
            nout=nout+1
            fils=fil(i)(5:18)
            fils(4:4)='N'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first n-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
      
            fils(4:4)='E'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first e-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
         endif
      enddo
c
c   accelerometer
c
      do i=1,nstat
         if(fil(i)(5:5).eq.'A'.and.fil(i)(8:8).eq.'Z'.and.outn(i).ne.1)
     *   then
            outn(i)=1
            outf(nout)=fil(i)
            nout=nout+1
            fils=fil(i)(5:18)
            fils(4:4)='N'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first n-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
      
            fils(4:4)='E'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first e-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
         endif
      enddo
c
c   long period
c
      do i=1,nstat
         if(fil(i)(5:5).eq.'L'.and.fil(i)(8:8).eq.'Z'.and.outn(i).ne.1)
     *   then
            outn(i)=1
            outf(nout)=fil(i)
            nout=nout+1
            fils=fil(i)(5:18)
            fils(4:4)='N'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first n-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
      
            fils(4:4)='E'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first e-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
         endif
      enddo
c
c   broad band
c
      do i=1,nstat
         if(fil(i)(5:5).eq.'B'.and.fil(i)(8:8).eq.'Z'.and.outn(i).ne.1)
     *   then
            outn(i)=1
            outf(nout)=fil(i)
            nout=nout+1
            fils=fil(i)(5:18)
            fils(4:4)='N'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first n-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
      
            fils(4:4)='E'
            do k=1,nstat
               if(fil(k)(5:18).eq.fils.and.outn(k).ne.1) then
                  outf(nout)=fil(k)          ! save first e-component
                  nout=nout+1
                  outn(k)=1                       ! mark file used
               endif
            enddo
         endif
      enddo
c
c    find files not selected
c
        do i=1,nstat
           if(outn(i).ne.1) then
              outf(nout)=fil(i)
              nout=nout+1
           endif
        enddo
c
c----------------------------------------------------------------------
c   sorting finished, now start reading response files
c----------------------------------------------------------------------
c
        do 1000 iresp=1,nstat
        nfil=nfil+1
        write(6,'(i6,2x,a)') nfil,outf(iresp)(1:40)
c
c   open response file
c
c      open(3,file=outf(iresp),status='old')
c
c   read file
c
c      do i=1,13            
c        j=(i-1)*80 + 1     
c        k=j+79             
c        read(3,'(a80)') header(j:k)
c      enddo                
c      close(3)
c
c  read values
c
c      call get_resp(header)
       wav_resp_file = outf(iresp)
       call read_resp
c
c   find how many low and high pass filters
c
c
c   blank filter text
c
      do i=1,5
        filt_text(i)=' '
      enddo
      nlow=0
      nhigh=0
      if(nfilt.gt.0) then
         do i=1,nfilt
             if(pole(i).lt.0) then
                  nhigh=nhigh+1
                  filth(nhigh)=ffilt(i)
                  poleh(nhigh)=iabs(pole(i))
             else
                  nlow=nlow+1
                  filtl(nlow)=ffilt(i)
                  polel(nlow)=iabs(pole(i))
             endif
          enddo 
c
c   make filter text
c
          if(nhigh.gt.0) then
             do i=1,nhigh
                write(filt_text(i)(1:6),'(f6.2)') filth(i)
c                write(filt_text(i)(8:8),'(i1)') poleh(i)
                write(filt_text(i)(8:9),'(i2)') poleh(i)
             enddo
          endif
          if(nlow.gt.0) then
             do i=1,nlow
                write(filt_text(i)(10:15),'(f6.2)') filtl(i)
c                write(filt_text(i)(18:18),'(i1)') polel(i)
                write(filt_text(i)(17:18),'(i2)') polel(i)
             enddo
          endif
          nfilt_text=nlow
          if(nhigh.gt.nlow) nfilt_text=nhigh
        endif
c
c   calculate response at 5 hz
c
      call calc_resp(5.0,res)
      g5hz=cabs(res)
c     write(6,*)'At 5 hz',g5hz 
c
c   now print out in a table
c
c      write(2,200) header(1:9),header(11:12),header(18:19),
c     *             header(21:22),
c     *             period,dampin,gencon,gain,
c     *             int(regain),filt_text(1),
c     *             g1hz/1000000000.0,g5hz,header(81:160)

c
c if instrument constants given
c
      if (period.ne.0) then
        write(2,200) wav_resp_stat(1:5),wav_resp_comp(1:4),
     *             wav_resp_year,wav_resp_month,wav_resp_day,
     *             period,dampin,gencon,gain,
     *             int(regain),filt_text(1)(1:18),
     *             g1hz/1000000000.0,g5hz
      elseif (nfa.gt.0) then
         write(2,201) wav_resp_stat(1:5),wav_resp_comp(1:4),
     *             wav_resp_year,wav_resp_month,wav_resp_day,
     *             ' Response given as FAP '

      elseif (npol.gt.0) then
         write(2,201) wav_resp_stat(1:5),wav_resp_comp(1:4),
     *             wav_resp_year,wav_resp_month,wav_resp_day,
     *             ' Response given as PAZ '

      endif

 200  format(1x,a5,1x,a4,2x,i4,1x,2i2,
c     *       2x,f6.2,2x,f4.2,1x,f7.1,2x,f6.1,
     *       1x,f7.2,2x,f4.2,1x,f7.1,2x,f6.1,
     *       2x,i7,2x,a18,
     *       2x,f7.4,2x,f7.3)
c     htext(2:10)=' STAT  COMP  YEAR DATE  PERIOD  DAMP  GENCON   AGAIN',
c    *            '   REGAIN   FILT  P  FILT  P   G 1 HZ   G 5 HZ' 
 201  format(1x,a5,1x,a4,' | ',i4,'.',i2,'.',i2,' | ',a)
c
c   more filter lines
c
      if(nfilt_text.gt.1) then
        do i=2,nfilt_text
c           write(2,'(69x,a18)') filt_text(i)
           write(2,'(63x,a18)') filt_text(i)
        enddo
      endif
c
 1000 continue
c
c   get next set of identical stations
c
      nstat=1
      goto 10
c
 99   continue
      stop
      end

CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX           
C                                                                               
C   TIME SUBROUTINES                                                            
c                                                                               
c   lates update:                                                               
c   jan 92 by jh: add date_doy                                                  
c   aug 98      : ----------- version 7.0  check ---------------
c                 add century to output for year in sectim
*                                                                               
*   TIMSEC  - Converts time in year, month, day hour, minutes and seconds       
*             to double precision seconds after 1.1.1900                        
*   SECTIM  - Converts double precision seconds after 1.1.1900 to year,         
*             day-of-year and date                                              
*   DTE     - Converts day-of-year to date (month,day)                          
*   TIMDIF  - Calculates time-difference in double precision seconds of         
*             two input dates (year,month,day,hour,minute,second)               
*   TIMADD  - Adds double precision seconds to date, and returns the new        
*             date                                                              
*   MONTH_DAY Find number of days in a month from month and year                
*                                                                               
*   DATE_DOY  Find doy from date                                                
*-------------------------------------------------------------------------      
*                                                                               
* Routine to convert from time to seconds after 1.1 1900, 00:00:00.00           
*                                                                               
*                                                         Leif Kvamme 9-4-87    
       subroutine TIMSEC (YEAR,MTH,DAY,HR,MIN,SECS,MSECS)                         
*
       implicit none                                                                               
c-- Total seconds to be returned   
       double precision MSECS                  
c--                                
       real             SECS                   
c-- Input date                     
       integer          YR,YEAR,MTH,DAY,HR,MIN      
c-- Flag for leap-year             
       integer          DYR                    
c-- Number of leap-years since 1900
       integer          IYR                    
c-- Number of days in current year 
       integer          YDY                    
*                                    
       yr=year                                           
       if (YEAR .ge. 1900) YR = YEAR - 1900                                         
       DYR = 0                                                                  
       if (mod(YR,4) .eq. 0) DYR = 1                                            
       IYR = YR/4 - DYR                                                         
c-- Seconds to beginning of     
       MSECS = real(IYR*366) + real((YR-IYR)*365) 
c-- current year                
       MSECS = MSECS*86400.0                      
c-- January                     
       if (MTH .eq. 1) YDY = DAY                  
c-- February                    
       if (MTH .eq. 2) YDY = DAY + 31             
c-- ....                        
       if (MTH .eq. 3) YDY = DAY + DYR + 59       
       if (MTH .eq. 4) YDY = DAY + DYR + 90                                     
       if (MTH .eq. 5) YDY = DAY + DYR + 120                                    
       if (MTH .eq. 6) YDY = DAY + DYR + 151                                    
       if (MTH .eq. 7) YDY = DAY + DYR + 181                                    
       if (MTH .eq. 8) YDY = DAY + DYR + 212                                    
       if (MTH .eq. 9) YDY = DAY + DYR + 243                                    
       if (MTH .eq.10) YDY = DAY + DYR + 273                                    
       if (MTH .eq.11) YDY = DAY + DYR + 304                                    
       if (MTH .eq.12) YDY = DAY + DYR + 334                                    
       MSECS = MSECS + real(YDY*86400 + HR*3600 + MIN*60) + SECS                
       return                                                                   
       end                                                                      
*=========================================================================      
* Routine to convert from seconds after year 1900 to time and date              
*  NOTE: Routine calculates only from 1.1.1901 to 31.12.2099                    
*                                                                               
*                                                         Leif Kvamme 21-4-87   
       subroutine SECTIM (MSECS,YR,DOY,MTH,DAY,HR,MIN,SEC)                      
*                   
       implicit none                                                            
c-- Input seconds             
       double precision MSECS                       
c-- Temporary seconds         
       double precision SSEC                        
c-- Seconds per day           
       double precision SECDAY                      
c-- Seconds per year          
       double precision SECYR                       
c--                           
       real             SEC                         
c-- Date and day-time         
       integer          YR, MTH, DAY, HR, MIN       
c--                           
       integer          DOY                         
c-- Leap-year indicators      
       real             IND, SIN                    
c-- Counter                   
       integer          I                           
*                                                                               
       data SECDAY,SECYR /86400.0,31536000.0/                                   
*-------------------------------------------------------------------------      
*  Find year:                                                                   
*                                                                               
      SSEC = 0.0                                                                
      do 1 I = 1,200                                                            
           IND = 0.0                                                            
c-- Leap year                 
           if (mod(I,4) .eq. 0) IND = 1.0           
c-- Add years                 
           SSEC = SSEC + SECYR + IND*SECDAY         
c-- Year found                
           if (SSEC .gt. MSECS) goto 2              
           SIN = IND                                                            
    1  continue                                                                 
    2  YR = I - 1
c
c   make sure century is there
c
       yr=yr+1900
c                                                               
*                                                                               
*  Find day-of-year and date:                                                   
*                                                                               
c-- Reset remaining seconds   
       SSEC = MSECS - (SSEC - SECYR - IND*SECDAY)   
       do 3 I = 1, 366                                                          
           SSEC = SSEC - SECDAY                                                 
           if (SSEC .lt. 0) goto 4                                              
    3  continue                                                                 
    4  I = I - 1                                                                
c-- 366 days of year          
       if (SIN .gt. 0.0) I = I + 1                  
c--                           
       if (I .eq. 0) then                           
c-- Justifying if change      
          YR = YR - 1                               
c-- of year                   
          I  = 365                                  
          if (mod(YR,4) .eq. 0) I = 366                                         
       endif                                                                    
       DOY = I                                                                  
c-- convert from doy to date  
       call DTE (i,DAY,MTH,yr)                      
*                                                                               
*  Find hour:                                                                   
*                                                                               
       SSEC = SSEC + SECDAY                                                     
       do 5 I = 1, 24                                                           
           SSEC = SSEC - 60.0*60.0                                              
           if (SSEC .lt. 0) goto 6                                              
    5  continue                                                                 
    6  HR = I - 1                                                               
*                                                                               
*  Find minutes and remaining seconds:                                          
*                                                                               
       SSEC = SSEC + 60.0*60.0                                                  
       do 7 I = 1, 60                                                           
           SSEC = SSEC - 60.0                                                   
           if (SSEC .lt. 0) goto 8                                              
    7  continue                                                                 
    8  MIN = I - 1                                                              
       SEC = SSEC + 60.0                                                        
       return                                                                   
       end                                                                      
*=========================================================================      
*                                                                               
* Routine to convert from day-of-year to date                                   
*                                                         Leif Kvamme 12-1-85   
       subroutine DTE (DOY,DAY,MON,YR)                                          
*                   
       implicit none                                                            
       integer DOY,DAY,MON,YR,MTH(12),J,M,N                                     
*                                                                               
       do 1 J = 1,7,2                                                           
           MTH(J) = 31                                                          
    1  continue                                                                 
       do 2 J = 8,12,2                                                          
           MTH(J) = 31                                                          
    2  continue                                                                 
       MTH(2) = 28                                                              
       MTH(4) = 30                                                              
       MTH(6) = 30                                                              
       MTH(9) = 30                                                              
       MTH(11)= 30                                                              
       if (mod(YR,4) .eq. 0) MTH(2) = 29                                        
       M = 0                                                                    
       do 3 J = 1,12                                                            
       M = M + MTH(J)                                                           
       N = DOY - M                                                              
       if (N .le. 0) then                                                       
           MON = J                                                              
           DAY = N + MTH(J)                                                     
           goto 4                                                               
       endif                                                                    
    3  continue                                                                 
    4  return                                                                   
       end                                                                      
*==========================================================================     
*                                                                               
* Routine to calculate time-difference in seconds (MSDIF = TIME_1 - TIME_2)     
*                                                                               
*                                                         Leif Kvamme 24-4-87   
       subroutine TIMDIF (YR1,MN1,DA1,HR1,MI1,SC1,                              
     .                    YR2,MN2,DA2,HR2,MI2,SC2,MSDIF)                        
*                   
       implicit none                                                            
c-- Time in seconds        
       double precision SEC1,SEC2                      
c-- Difference (returned)  
       double precision MSDIF                          
       real             SC1, SC2                                                
c-- Time 1                 
       integer          YR1,MN1,DA1,HR1,MI1            
c-- Time 2                 
       integer          YR2,MN2,DA2,HR2,MI2            
*                                                                               
c-- Convert time 2         
       call TIMSEC (yr1,mn1,da1,hr1,mi1,sc1,SEC1)      
c-- Convert time 2         
       call TIMSEC (yr2,mn2,da2,hr2,mi2,sc2,SEC2)      
*                                                                               
c-- Calculate difference   
       MSDIF = SEC1 - SEC2                             
       return                                                                   
       end                                                                      
*___________________________________________________________________            
*                                                                               
* Routine to add time in seconds to date- and day-time (TIME_2 = TIME_1 + MSDIF)
*                                                                               
*                                                         Leif Kvamme 24-4-87   
       subroutine TIMADD (YR1,MN1,DA1,HR1,MI1,SC1,MSDIF,                        
     .                    YR2,MN2,DA2,HR2,MI2,SC2)                              
*                   
       implicit none                                                            
c-- Seconds to be added    
       double precision MSDIF                          
c-- Time in seconds        
       double precision SEC1,SEC2                      
       real             SC1, SC2                                                
c-- Time 1                 
       integer          YR1,MN1,DA1,HR1,MI1            
c-- Time 2 (returned)      
       integer          YR2,MN2,DA2,HR2,MI2,DOY        
*                                                                               
c-- Convert time 1         
       call TIMSEC (yr1,mn1,da1,hr1,mi1,sc1,SEC1)      
*                                                                               
c-- Adding                 
       SEC2 = SEC1 + MSDIF                             
*                                                                               
c-- Reconverting           
       call SECTIM (sec2,YR2,DOY,MN2,DA2,HR2,MI2,SC2)  
       return                                                                   
       end                                                                      
*=========================================================================      
*                                                                               
* Routine to convert from month to number of days in a month                    
*                                                         J. Havskov oct 91     
*                                                         Leif Kvamme 12-1-85   
       subroutine MONTH_DAY(YR,MON,DAY)                                         
*                                                                               
       implicit none                                                            
       integer DAY,MON,YR,MTH(12),J                                             
*                                                                               
       do 1 J = 1,7,2                                                           
           MTH(J) = 31                                                          
    1  continue                                                                 
       do 2 J = 8,12,2                                                          
           MTH(J) = 31                                                          
    2  continue                                                                 
       MTH(2) = 28                                                              
       MTH(4) = 30                                                              
       MTH(6) = 30                                                              
       MTH(9) = 30                                                              
       MTH(11)= 30                                                              
       if (mod(YR,4) .eq. 0) MTH(2) = 29                                        
       DAY=MTH(MON)                                                             
       return                                                                   
       end                                                                      
                                                                                
*=========================================================================      
*                                                                               
* Routine to convert from date to day-of-year                                   
* j. havskov 1992 and Leif Kvamme 12-1-85                                       
*                                                                               
       subroutine DATE_DOY (DOY,DAY,MON,YR)                                     
*  
       implicit none                                                                             
       integer DOY,DAY,MON,YR,MTH(12),J                                     
*                                                                               
       do 1 J = 1,7,2                                                           
           MTH(J) = 31                                                          
    1  continue                                                                 
       do 2 J = 8,12,2                                                          
           MTH(J) = 31                                                          
    2  continue                                                                 
       MTH(2) = 28                                                              
       MTH(4) = 30                                                              
       MTH(6) = 30                                                              
       MTH(9) = 30                                                              
       MTH(11)= 30                                                              
       if (mod(YR,4) .eq. 0) MTH(2) = 29                                        
c                                                                               
       doy=0                                                                    
       do j=1,mon-1                                                             
         doy=doy+mth(j)                                                         
       enddo                                                                    
       doy=doy+day	   		 	                                                      
c                                                                               
       return                                                                   
       end                                                                      

C     CRISIS INCLUDED WITH SEISAN
c**************************************************************
c This are obsolete metacommands, needed when compiling with 
c MS-FORTAN 5
c$large
c$DEBUG   
c**************************************************************
	
c
c   changes
c
c   june 99 by jh : --------------   version 7.0 ----------------
c                   use seisan unix-pc date routines
c                   use variable input file name
c                   open(26+I changed from binary to unformatted
c   june 13, 99 lo: replaced in write statement \ by `\'
c                   removed the AUTOMATIC declaration
c   sep 17      jh: replace '\' by  - , did not compile on pc
c   sep 24      lo: put AUTOMATIC back in
c**************************************************************
C   This block is to be used when constructing a DLL
C      INTEGER FUNCTION CRISIS () 
C!MS$ATTRIBUTES ALIAS:'CRISIS' :: CRISIS
C!MS$ATTRIBUTES DLLEXPORT :: CRISIS
C**************************************************************


C**************************************************************
C   This lines for a standalone CRISIS
c     PROGRAM CRISIS
C**************************************************************


C**************************************************************
C
C     PROGRAM FOR COMPUTING SEISMIC RISK
C     March, 1992
C     MARIO ORDAZ. NATIONAL AUTONOMOUS UNIVERSITY OF MEXICO
C
c     Modificado en mayo-junio de 1998 por M Ordaz, J Arboleda y
c     A Aguilar
c
c********************************************************************  




c********************************************************************
c
c   seisan time strings
c
      character*12 t1
      character*14 t2
 
c
c               Dimensiones máximas de los arreglos  
c
      INTEGER MODMAX,NCMAX,NTMAX,NREGMAX,NMAGMAX,NRMAX,NMCX,NMMAX
      INTEGER NTRIMAX,NVMAX,NPGMAX,NVGMAX
c
      PARAMETER (MODMAX=5,NCMAX=20,NTMAX=15,NREGMAX=200,NMAGMAX=10,
     .           NRMAX=21,NMCX=4000,NMMAX=30,NVMAX=25,
     .           NTRIMAX=NREGMAX*NVMAX,NPGMAX=10,NVGMAX=30)     
     
C
c     MODMAX:  No. maximo de modelos de atenuacion
C     NCMAX :  No. de aceleraciones de calculo
C     NTMAX :  No. de periodos estructurales
c     NREGMAX: No. de fuentes
c     NMAGMAX: No. de magnitudes en la tabla de atenuacion
c     NRMAX  : No. de distancias en la tabla de atenuacion
c     NMCX   : No. de distancias en una fuente
c     NMMAX  : No. de magnitudes para integraci¢n
c     NTRIMAX: No. total de triangulos para todas las regiones
c     NVMAX  : No. de vertices para un poligono
c     NPGMAX : No. de polígonos de reducción de malla
c     NVGMAX : No. de vértices de poligonos de malla 
C
c********************************************************************

      REAL MU(10),MU1(10),WM(10),WM1(10)  
      REAL B(10),WB(10)
      REAL A0(NCMAX),AU(NCMAX),DA(NCMAX)
      REAL T(NTMAX),COEF(NTMAX)
      REAL EVP(NCMAX,NTMAX),ANU(NCMAX,NTMAX) 
      
      REAL RR

      REAL VECT(NCMAX)
      REAL MINF,MMAX,MAG,M0,MBP

      REAL LAS,LOS,LAI,LOI
      REAL PARSIS(NREGMAX,9)
      REAL VB(5),SUMA
      INTEGER NBIN(5)
      INTEGER IC(NREGMAX),IE(NREGMAX),IMO(NREGMAX)
      
      INTEGER ANO,MES,DIA,DIAdos 
 
      CHARACTER*80 TITGEN,BASURA
      CHARACTER*80 TITULO(NREGMAX)
      CHARACTER*200 ARCHEN,ARCHSAL,ARCHGRA,ARCHBAS,ARCHMA
	CHARACTER*200 FN
      CHARACTER*200 MODELO(MODMAX)
	CHARACTER*2 NUM2
	CHARACTER*1 NUM1
      REAL T00


      REAL ACEL,DMAG,DRAD,SLA,RINF,DDLA,DDLO,DRADOR,WAMAX
      INTEGER NMAG,NRAD,NLA,NLO
C
      REAL VER,DM,RMAX
      REAL DIST,EB,CB,EMU,SMU,SM

      REAL SEM,SEM2,BL,AMBP,EL0,C,AMED,CALACA,FG1,FG2,FNORAC,PM
      REAL WQ1,WQ2,EMT,D,F,SMT,AMU,AME,AK,CEF
      REAL TE,A1,A2,ANU1,ANU2,EME,TREG,SECS,TSITIO,TTOTAL

      INTEGER NREG,NREGP,NREGC,NMOD,NT,NA,NM,NB,NBBM,NREF,IMG
      INTEGER I,J,K,L,N,IA,IB,ILAT,ILON,NR,JINC,IT,IR,IM
      INTEGER NUBAN
        
      REAL DISTA,ZC,AREA3D,VLM1 
      
      INTEGER LONGFILE
      
      REAL TR(5)
C
C     *******************************************
C     NUEVAS VARIABLES P/TRIANGULOS
      INTEGER NS(NREGMAX),POSI(NREGMAX)
      REAL XYS(3,NVMAX) 
      INTEGER KI,KF,NBAN,KBAN
      INTEGER ANS(1)
      REAL AREA(NMCX)  
      INTEGER NTRI    
c     ---- Arreglos general y local de triangulos
      REAL XYTRI (1:3,1:3,1:NTRIMAX)
      REAL LOCTRI(1:3,1:3,1:NVMAX)
      REAL FMIN,RMIN
      REAL XSITE,YSITE,WPESO,HSITE       
      INTEGER KTR

c     Nuevas variables para archivos graficos para cada periodo estructural  
      CHARACTER*200 ARCHGRAT(NTMAX)
	REAL NULO

c	NUEVAS VARIABLES REDUCCION MALLA
	INTEGER NPOLGRID

C	MAXIMO NPGNMAX POLIGONOS Y NVGMAX VERTICES POR POLIGONO	 
	DOUBLE PRECISION LATGRID(NPGMAX,NVGMAX),LONGGRID(NPGMAX,NVGMAX)
	DOUBLE PRECISION NVERGRID(NVGMAX)
	INTEGER NVERG
      DOUBLE PRECISION VCLGRID(2,NVGMAX),PT(2)		 
	INTEGER IGRID,JGRID,INOUT
	INTEGER PUNTOSMA,NREFTOT
                                       
C     *********************************************************************
c
c                                  COMMONS
c
      COMMON/ATENUA/ACEL(MODMAX,NTMAX,NMAGMAX,NRMAX),SLA(MODMAX,NTMAX),
     1              MINF(MODMAX),DMAG(MODMAX),RINF(MODMAX),DRAD(MODMAX),
     2              NMAG(MODMAX),NRAD(MODMAX),WAMAX(MODMAX,NTMAX)
c     
      COMMON/TRIAN/KTR,RR(NMCX),WPESO(NMCX),XSITE,YSITE,HSITE,RMAX,
     *             RMIN,FMIN
c
C     *********************************************************************

C     *********************************************************************
c
c                    DATAS
c
      DATA VER/99.1/
c     ---- Datos p/subdivision de triangulos
      DATA FMIN,RMIN / 3.0,11.0/
C     ----  Concentraciones distribucion normal ----------
      DATA MU1/-4.859,-3.581,-2.484,-1.466,-0.4849,0.4849,
     1         1.466,2.484,3.581,4.859/                         
      DATA WM1/0.000004311,0.0007581,0.01911,0.1355,
     1         0.3446,0.3446,0.1355,0.01911,0.0007581,0.000004311/
c     ----  Numero de concentraciones NB 
      DATA NB/2/
c     ----  Intervalos DM para integrar con respecto a la magnitud      
      DATA NM/10/
     	DATA NULO/0.0/
C     **********************************************************************

c     **********************************************************************


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

 	TTOTAL=0

C     WHEN BUILDING A DLL UNCOMMENT FOLLOWING LINE:
C      CRISIS=0

	NREFTOT=0
	PUNTOSMA=0

	FN='filename.nam'
	 
C     LECTURA DEL NOMBRE DEL ARCHIVO DE DATOS (*.dat)
      write(6,*)' Input file name'
      read(5,'(a)') archen
c     OPEN(25,FILE=FN,STATUS='old',err=2101)
c     READ(25,'(A)') ARCHEN
      write(6,*)' Output file name without extension like out'
      read(5,'(a)') archbas

C     LECTURA DEL NOMBRE BASE PARA LOS ARCHIVOS DE RESULTADOS 
c     READ(25,'(A)') ARCHBAS
c     CLOSE(25)

C     THIS LINE COMPUTES THEN LENGTH OF STRING ARCHBAS, WITHOUT
C     TRAILING BLANKS
      LONGFILE=OURLEN(ARCHBAS)
	I=LONGFILE+1
C     ******************************************************************** 


C     ******************************************************************** 
C     APERTURA DE ARCHIVOS
      OPEN(15,FILE=ARCHEN,STATUS='OLD')   

      ARCHSAL=ARCHBAS(1:I-1)//'.res'
      CALL ABRIR (16,ARCHSAL)

      ARCHGRA=ARCHBAS(1:I-1)//'.gra'
      CALL ABRIR (7,ARCHGRA) 

      ARCHMA=ARCHBAS(1:I-1)//'.map'
      CALL ABRIR (9,ARCHMA)
c     *********************************************************************

C     This function gets the system date 
c     CALL GETDAT (ANO,MES,DIA)
c
c   seisan date insteqd of pc data only
c
      call systime(t1,t2)
      read(t1,'(3i2)') ano,mes,dia
 
      READ (15,'(A80)') TITGEN
	READ (15,*) NREG,NMOD,NT,NA  
      WRITE(16,6000) VER,TITGEN,ANO,MES,DIA
      WRITE(16,6135) MODMAX,NCMAX,NTMAX,NREGMAX,NMAGMAX,NRMAX,NMCX     
      WRITE(16,6001) NREG,NMOD,NT,NA,NM

C     REVISA VALORES MAXIMOS DE LOS PARAMETROS
      IF (NREG .GT. NREGMAX .OR. NMOD .GT. MODMAX .OR.
     .    NT   .GT. NTMAX   .OR. NA   .GT. NCMAX  .OR. 
     .    NM   .GT. NMMAX) THEN
          WRITE(16,*) 'ALGUN PARAMETRO EXCEDE EL VALOR MAXIMO'
		CALL CIERRA()
C		CRISIS=2
C		RETURN
C         STOP
      ENDIF
C    
      WRITE( 9,6000) VER,TITGEN,ANO,MES,DIA
      WRITE( 7,6000) VER,TITGEN,ANO,MES,DIA
	WRITE(7,9070)


      DO 1 I=1,NT
          READ(15,*) T(I),A0(I),AU(I)
          WRITE(16,6010) I,T(I),A0(I),AU(I),NA
          A0(I)=LOG(A0(I))
          AU(I)=LOG(AU(I))
          DA(I)=( AU(I)-A0(I) )/(NA-1)
C         LECTURA DE NOMBRES DE ARCHIVOS.GRA PARA CADA PERIODO
          IF (I .LT. 10) THEN
             WRITE(NUM1,'(I1)') I
             ARCHGRAT(I)=ARCHBAS(1:LONGFILE)//'.B'//NUM1
		ELSE
		   WRITE(NUM2,'(I2)') I
             ARCHGRAT(I)=ARCHBAS(1:LONGFILE)//'.B'//NUM2
		ENDIF   	
c         OPEN(26+I,FILE=Archgrat(I),STATUS='UNKNOWN',FORM='BINARY')
          OPEN
     *    (26+I,FILE=Archgrat(I),STATUS='UNKNOWN',FORM='unformatted')
1     CONTINUE

C     LECTURA DE RMAX Y PERIODOS PARA CALCULO DE TASAS DE EXCEDENCIA FIJAS 
      READ (15,*) RMAX,(TR(I),I=1,5)
	WRITE(9,9050)
      WRITE(9,9060) (TR(I),I=1,5)
	WRITE(16,6020) RMAX

C     LECTURA DE MALLA DE PUNTOS
	READ (15,*) LOI,LAI,DDLO,DDLA,NLO,NLA
	WRITE(16,6024)
      WRITE(16,6025) LOI,LAI,DDLO,DDLA,NLO,NLA

C     NUEVOS DATOS MALLA
	READ (15,*) NPOLGRID
	IF (NPOLGRID.GT.0) THEN
	  IF (NPOLGRID .GT. NPGMAX) THEN
	     WRITE(16,*) 'ERROR: NPOLGRID>NPGMAX'
	     CALL CIERRA ()
C		 CRISIS=3
C		 RETURN
C		 STOP 'ERRORS IN GENERAL DATA FILE'
	  ENDIF
	  WRITE(16,6026)
	  WRITE(16,6027) NPOLGRID 
	END IF

	DO I=1,NPOLGRID
        READ(15,*) NVERGRID(I)
	  WRITE(16,6028)NVERGRID(I) 
        IF (NVERGRID(I) .GT. NVGMAX) THEN
	     WRITE(16,*) 'ERROR: NVERGRID>NVGMAX'
		 CALL CIERRA()
C  		 CRISIS=4
C		 RETURN
C		 STOP 'ERRORS IN GENERAL DATA FILE'
	  ENDIF
	  WRITE(16,6029)
     	  DO J=1,NVERGRID(I)
           READ(15,*) LATGRID(I,J),LONGGRID(I,J)
           WRITE(16,6030) LATGRID(I,J),LONGGRID(I,J)
        END DO
	END DO
C      
C
C     ******************** LECTURA DE MATRIZ DE ATENUACION  ************
      WRITE (16,6810)
      DO 700 I=1,NMOD
         READ (15,'(A200)') MODELO(I)
         OPEN (8,FILE=MODELO(I),STATUS='OLD')
         READ (8,*) MINF(I),MMAX,NMAG(I)
         DMAG(I)=(MMAX-MINF(I))/(NMAG(I)-1)
         READ (8,*) RINF(I),MMAX,NRAD(I)
         WRITE (16,6820) I,MODELO(I)
	   WRITE (16,6821)
	   WRITE(16,6825) NMAG(I),MINF(I),DMAG(I)
	   WRITE(16,6822)
	   DRADOR=(MMAX-RINF(I))/(NRAD(I)-1)
	   WRITE(16,6826) NRAD(I),RINF(I),DRADOR
	   RINF(I)=ALOG(RINF(I))
	   MMAX=ALOG(MMAX)
         DRAD(I)=(MMAX-RINF(I))/(NRAD(I)-1)   
         DO 680 J=1,NT 
           READ(8,*) MMAX,SLA(I,J),WAMAX(I,J)
           DO 601 K=1,NMAG(I)
             READ (8,*,ERR=2200) (ACEL(I,J,K,L),L=1,NRAD(I))
601        CONTINUE
680      CONTINUE
         CLOSE (8)
700   CONTINUE

      WRITE (16,6830)             
      DO 710 J=1,NT               
        WRITE (16,6840) J,(SLA(I,J),I=1,NMOD)
710   CONTINUE      
      WRITE (16,6850)             
      DO 720 J=1,NT               
        WRITE (16,6840) J,(WAMAX(I,J),I=1,NMOD)
720   CONTINUE                  
C     ******************************************************************      



C     ********************  LECTURA DE DATOS DE SISMICIDAD  ************
C     Se leen tambien los datos de localizaci¢n y se triangula cuando
c     procede

      NREGP=0
      NREGC=0

c     En NUMTRI llevamos cuenta de los triangulos,lineas o puntos que 
C     se tengan. KI y KF son los contadores de posici¢n de puntos,
C     l¡neas o triangulos
      KI=0
      KF=0
      NBAN=0

	WRITE (16,6066) 


      DO 1000 N=1,NREG   

        KBAN=0
        READ(15,'(A80)') TITULO(N)
        READ (15,*) IC(N),IE(N),IMO(N)
c       ---- IE=0,Poligono; IE=1,polilinea; IE=2, punto

        IF(IC(N) .EQ.1) THEN
           NREGP=NREGP+1                         
        ELSE
          NREGC=NREGC+1
        ENDIF                

        READ(15,*) NS(N)
C       SI EL NUMERO DE VERTICES SUPERA AL LIMITE REALIZA LECTURA
C       PERO SE BRINCARA AL POLIGONO FORMADO POR DICHOS VERTICES        
        IF (NS(N) .GT. NVMAX) THEN
           NBAN=NBAN+1
           KBAN=1
           DO I=1,NS(N)
             READ(15,'(A80)') BASURA
           ENDDO
        ELSE
           DO I=1,NS(N)        
             READ (15,*) XYS(1,I),XYS(2,I),XYS(3,I)
           ENDDO 
        ENDIF

c       ESCRITURA DE DATOS DE LAS FUENTES
        WRITE (16,6067) N,TITULO(N)

C	  IC=1 POISSON MODEL
	  IF (IC(N).EQ.1) THEN
	      WRITE (16,9010)
	  ELSE
	      WRITE	(16,9015)
	  END IF

C	  IE=0 AREA SOURCE IE=1 FAULT SOURCE IE=2 POINT SOURCE
	  IF (IE(N).EQ.0) WRITE (16,9020)
        IF (IE(N).EQ.1) WRITE (16,9025)
        IF (IE(N).EQ.2) WRITE (16,9030)

C       IMO= NUMBER OF ATTENUATION MODEL
	  WRITE(16,9035) MODELO(IMO(N))

C       NS=NUMBER OF VERTEX
	  WRITE(16,9040) NS(N)
        WRITE (16,6071) 
        IF (KBAN .EQ. 1) THEN
           WRITE (16,1100) N,NVMAX 
        ELSE
           DO I=1,NS(N)
             WRITE (16,6072) XYS(1,i),XYS(2,i),XYS(3,I)
           ENDDO
        ENDIF                         
      
        IF (KBAN .EQ. 0) THEN

           POSI(N)=KI+1

           IF (IE(N) .EQ. 0) THEN
              ANS(1)=NS(N)
              CALL TRIANGULATE(1,NS(N),ANS,XYS,NTRI,LOCTRI)
              IF (NTRI.NE.NS(N)-2)THEN
                NBAN=NBAN+1
                WRITE(16,*)'ERROR EN LA GEOMETRIA DE LA FUENTE',N
              ENDIF
              AREA(N)=0.0
              DO I=1,NTRI
C			  WRITE(16,*) '  '                                    
                DO J=1,3
                   XYTRI(1,J,I+KI)=LOCTRI(1,J,I)
                   XYTRI(2,J,I+KI)=LOCTRI(2,J,I)
                   XYTRI(3,J,I+KI)=LOCTRI(3,J,I)
C           	   WRITE(16,'(3(F10.3,2X))') (XYTRI(K,J,I+KI),K=1,3)
                ENDDO 
c               CALCULO DEL AREA DE CADA TRIANGULO PARA OBTENER EL
C               AREA DEL POLIGONO, QUE SE ASIGNA A AREA(N)
                VLM1=AREA3D(LOCTRI(1,1,I),LOCTRI(2,1,I),LOCTRI(3,1,I),
     .                      LOCTRI(1,2,I),LOCTRI(2,2,I),LOCTRI(3,2,I),
     .                      LOCTRI(1,3,I),LOCTRI(2,3,I),LOCTRI(3,3,I))
                AREA(N)=AREA(N)+VLM1
C		  IF (AREA(N) .EQ. 0) THEN
C        		WRITE(16,*)'ERROR EN LA GEOMETRIA DE LA FUENTE',N
C				NBAN=NBAN+1
C		  ENDIF
              ENDDO
C             *****************************************************  

           ELSE 

              IF ( IE(N) .EQ. 1) THEN

C             *****************************************************  
c                UNA POLILINEA            
                 NTRI=NS(N)-1
                 AREA(N)=0.0
                 DO I=1,NTRI 
                    XYTRI(1,1,I+KI)=XYS(1,I)
                    XYTRI(1,2,I+KI)=XYS(1,I+1)
                    XYTRI(2,1,I+KI)=XYS(2,I)
                    XYTRI(2,2,I+KI)=XYS(2,I+1)      
                    XYTRI(3,1,I+KI)=XYS(3,I)
                    XYTRI(3,2,I+KI)=XYS(3,I+1)                      
C                   CALCULO DE LA LONGITUD TOTAL DE LA LINEA 
                    ZC=ABS(XYTRI(3,1,I+KI)-XYTRI(3,2,I+KI))   
                    DISTA=DIST(XYTRI(2,1,I+KI),XYTRI(1,1,I+KI),
     +                         XYTRI(2,2,I+KI),XYTRI(1,2,I+KI),ZC)  
                    AREA(N)=AREA(N)+DISTA
                 ENDDO         
C             *****************************************************  
                 
              ELSE

C             *****************************************************  
C                PUNTOS
                 NTRI=NS(N)
                 AREA(N)=NS(N)
                 DO I=1,NTRI
                    XYTRI(1,1,I+KI)=XYS(1,I)
                    XYTRI(2,1,I+KI)=XYS(2,I)
                    XYTRI(3,1,i+KI)=XYS(3,I)
                 ENDDO

              ENDIF

           ENDIF

           KI=KI+NTRI

        ENDIF  
        
        IF (IC(N) .EQ. 1) THEN        
C          LECTURA DE DATOS DE SISMICIDAD DE MODELO DE POISSON
           READ (15,*) (PARSIS(N,I),I=1,7)  
        ELSE
C          LECTURA DE DATOS DE SISMICIDAD DE MODELO CARACTERISTICO
           READ (15,*) (PARSIS(N,I),I=1,7)  
        END IF


1000  CONTINUE

      IF (NBAN .NE. 0) THEN
	  write(16,*) '  '	
	  write(16,*) '*************************************'	
        WRITE(16,*) 'LA CORRIDA NO PUEDE CONTINUAR POR'
	  WRITE(16,*) 'ERRORES EN ALGUNOS DATOS DE GEOMETRIA'
	  write(16,*) '*************************************'	
	  CALL CIERRA ()
C	  CRISIS=5
C	  RETURN
C       STOP ' ERRORES DE GEOMETRIA'
      ENDIF
         
                   

C     *********************************************************************
C     ESCRIBE SISMICIDAD DE POISSON
      IF (NREGP .GT. 0) THEN
	  WRITE(16,6039)
	  WRITE(16,6035)
        WRITE (16,6040)
        DO 1130 N=1,NREG
          IF (IC(N) .EQ. 1) WRITE (16,6041) N,(PARSIS(N,I),I=1,7)
1130    CONTINUE
      ENDIF 

C     ESCRIBE SISMICIDAD CARACTERISTICA
      IF (NREGC .GT. 0) THEN
	  WRITE(16,6044)
	  WRITE(16,6042)
        WRITE(16,6045)
        DO 1140 N=1,NREG
          IF (IC(N) .NE. 1) WRITE (16,6046) N,(PARSIS(N,I),I=1,7)
1140    CONTINUE
      ENDIF
C     ******************************************************************
c
c
C     ***************   INICIA CALCULOS  *******************************
C                                                    
      DO 2000 ILAT=1,NLA

          LAS=LAI+(ILAT-1)*DDLA
		PT(2)=LAS
C           
          DO 1900 ILON=1,NLO

            LOS=LOI+(ILON-1)*DDLO
		  PT(1)=LOS
            TSITIO=SECS()

		  WRITE(*,1001) LOS,LAS
C	REVISA SI ESTE PUNTO DE LA MALLA SE DEBE CALCULAR

		  DO IGRID=1,NPOLGRID
			NVERG=NVERGRID(IGRID)
			DO JGRID=1,NVERG
				VCLGRID(1,JGRID)=LATGRID(IGRID,JGRID)
				VCLGRID(2,JGRID)=LONGGRID(IGRID,JGRID)
		    END DO
	        CALL POLINS(NVERG,VCLGRID,PT,INOUT)
C			INOUT=0 EL PUNTO ESTA EN EL LIMITE DEL POLIGONO
C			INOUT=1 EL PUNTO ESTA DENTRO DEL POLIGONO
C			INOUT=-1 EL PUNTO ESTA FUERA DEL POLIGONO
C			INOUT=-2 ERROR EN PARAMETROS
C             SI EL PUNTO ESTA DENTRO, VA A HACER CALCULOS 
			IF (INOUT.EQ.0.OR.INOUT.EQ.1) THEN
			   GOTO  135
			ELSE
				DO IT=1,NT
					DO IA=1,NA
C					ASIGNA AL PUNTO QUE NO SE CALCULO INTENSIDAD=0 PARA FINES
C					DE GENERACION DE MAPAS DE PELIGRO CON CRISIS98 PARA WINDOWS	
					    WRITE(26+IT)NULO
 					END DO
 				END DO
				GOTO 1900			  
			ENDIF

			IF (INOUT.EQ.-2) THEN
C         
C		 		WHEN BUILDING A DLL, UNCOMMENT FOLLOWING LINES
C 				CRISIS=6
				CALL CIERRA()
c 				RETURN
C
C				WHEN BUILDING A STANDALONE, UNCOMMENT FOLLOWING LINE
C               STOP 'ERRORS IN GENERAL DATA FILE'       
		 
			ENDIF

		  END DO

135		  CONTINUE


            WRITE (16,6500) LOS,LAS
	      PUNTOSMA=PUNTOSMA+1
            WRITE (16,6550) PUNTOSMA
            WRITE (16,6610)
		
            DO 138 I=1,NA                                                
            DO 138 J=1,NT
138         ANU(I,J)=0.0
C                                          
            DO 1800 N=1,NREG

               TREG=SECS()

               DO 137 I=1,NA
               DO 137 J=1,NT
137            EVP(I,J)=0.0
C          
C              ASIGNACION A VARIABLES GLOBALES DE SUBDIVISION
               KTR=0
               XSITE=LOS
               YSITE=LAS

C              ***********************************************************
C              SUBDIVIDE OBJETOS

               IF (IE(N) .EQ. 0) THEN

c                 ****************************************************
c                 SE TRATA DE UNA AREA:  
                  KI=POSI(N)
                  KF=KI+(NS(N)-2)-1
                  DO I=KI,KF     
                    CALL DIVREC( XYTRI(1,1,I),XYTRI(2,1,I),XYTRI(3,1,I),
     +                           XYTRI(1,2,I),XYTRI(2,2,I),XYTRI(3,2,I),
     +                           XYTRI(1,3,I),XYTRI(2,3,I),XYTRI(3,3,I))
                  ENDDO
c                 ****************************************************

               ELSE

                  IF (IE(N) .EQ. 1) THEN

c                 ****************************************************
C                   SE TRATA DE UNA LINEA
                    KI=POSI(N)
                    KF=KI+(NS(N)-1)-1
                    DO I=KI,KF
                     CALL DIVLIN(XYTRI(1,1,I),XYTRI(2,1,I),XYTRI(3,1,I),
     +                           XYTRI(1,2,I),XYTRI(2,2,I),XYTRI(3,2,I))
                    ENDDO
c                 ****************************************************

                  ELSE

c                 ****************************************************
C                   SE TRATA DE PUNTOS
                    KI=POSI(N)
                    KF=KI+(NS(N))-1
                    DO I=KI,KF     
                      DISTA=DIST(XYTRI(2,1,I),XYTRI(1,1,I),YSITE,XSITE,
     .                           XYTRI(3,1,I))
                      IF(DISTA.LT.RMAX)THEN   
                         KTR=KTR+1
                         RR(KTR)=DISTA
                         WPESO(KTR)=1.0
                      ENDIF
                    ENDDO
                  ENDIF
               ENDIF     
C              ***********************************************************
C
               NR=KTR
               DO I=1,NR      
C                AREA SUBFUENTES/AREA FUENTE      
                 WPESO(I)=WPESO(I)/AREA(N)
               ENDDO                  
c
               IF (IC(N) .EQ. 1) THEN

C                *************** PROCESO DE POISSON ********************
                 EL0=PARSIS(N,1)
                 EB=PARSIS(N,2)
                 CB=PARSIS(N,3)
                 EMU=PARSIS(N,4)
                 SMU=PARSIS(N,5)
                 MMAX=PARSIS(N,6)
                 M0=PARSIS(N,7)
C
C                ***************  CONCENTRACIONES PARA  Mu ************
                 SM=0.
                 DO 110 J=1,10     
                    MU(J)=MU1(J)*SMU+EMU
                    IF( MU(J) .LT. MMAX .OR. MU(J) .LT. M0 ) THEN
                      WM(J)=0.
                    ELSE 
                       WM(J)=WM1(J)
                    ENDIF
                    SM=SM+WM(J)
 110             CONTINUE
C
                 NBBM=0
                 SEM=0.
                 SEM2=0.
                 DO 120 J=1,10
                    WM(J)=WM(J)/SM
                    SEM=SEM+MU(J)*WM(J)
                    SEM2=SEM2+MU(J)*MU(J)*WM(J)
                    IF (WM(J) .NE. 0.00 .AND. NBBM .EQ. 0) THEN
                      JINC=J
                      NBBM=1
                    ENDIF
 120             CONTINUE
                 IF (SMU .EQ. 0.0) THEN
                   JINC=10
                   WM(10)=1.0
                 ENDIF
                 SEM2=SEM2-SEM*SEM
                 IF (SEM2 .LT. 0.) SEM2=0.0
                 SEM2=SQRT(SEM2)
C
C                ***************  CONCENTRACIONES PARA á ************
                 IF(CB .LE. 0.1) NB=1
                 IF (NB .LE. 1) THEN
                   NB=1
                   B(1)=EB
                   WB(1)=1.0
                 ELSE
                   MBP=1./CB/CB
                   BL=MBP/EB
                   AMBP=MBP
                   CALL LAGUER (NB,AMBP,BL,B,WB)
                 ENDIF
C
C               *************** INICIA EL PROCESO DE INTEGRACION *****


                 DO 670 IT=1,NT
                   NREF=NR
                   CALL CERO (VECT,NA)
                   DO 650 IR=1,NR
c	              Write(16,9095) RR(IR)
                      DO 640 IB=1,NB
                        DO 630 IM=JINC,10
                          DM=(MU(IM)-M0)/(NM-1)

                          DO 160 IA=1,NA

                            C=A0(IT)+(IA-1)*DA(IT)
                            C=EXP(C)
                            AMED=CALACA(IMO(N),IT,MU(IM),RR(IR))
 	               FG1=FNTRUNC(C,AMED,WAMAX(IMO(N),IT),SLA(IMO(N),IT))
                            FG2=PM(MU(IM),M0,B(IB),MU(IM))
                            WQ1=FG1*FG2
                            AMED=CALACA(IMO(N),IT,M0,RR(IR))
   	               FG1=FNTRUNC(C,AMED,WAMAX(IMO(N),IT),SLA(IMO(N),IT))
                            FG2=PM(M0,M0,B(IB),MU(IM))
                            WQ2=FG1*FG2
                            VECT(IA)=VECT(IA)+
     1                      (WQ2+WQ1)*WB(IB)*WM(IM)*DM*WPESO(IR)

                            DO 140 IMG=2,NM-1
                              MAG=M0+(IMG-1)*DM
                              AMED=CALACA(IMO(N),IT,MAG,RR(IR))
 	               FG1=FNTRUNC(C,AMED,WAMAX(IMO(N),IT),SLA(IMO(N),IT))
                              FG2=PM(MAG,M0,B(IB),MU(IM))
                              WQ2=FG1*FG2
                              VECT(IA)=VECT(IA)+
     1                        WQ2*WB(IB)*WM(IM)*DM*wpeso(IR)
140                         CONTINUE

160                       CONTINUE
630                     CONTINUE
640                   CONTINUE
		
			

650                CONTINUE
C
                   DO 660 IA=1,NA 
                     EVP(IA,IT)=VECT(IA)*EL0 
660                CONTINUE

670              CONTINUE

C             ******************   TERMINA PROCESO POISSON  ********

               ELSE   

C             ***************  PROCESO CARACTERISTICO  **************

                 EMT=PARSIS(N,1)
             write(*,*) EMT
                 T00=PARSIS(N,2)    
             write(*,*) T00
                 D=  PARSIS(N,3)  
                 F=  PARSIS(N,4)  
                 SMT=PARSIS(N,5)    
                 M0= PARSIS(N,6) 
                 AMU=PARSIS(N,7)  

                 JINC=0 
                 NREF=NR
                 AME=MAX(M0,D+F*LOG(T00))
                 DM=(AMU-M0)/(NM-1)

                 DO 2500 IR=1,NR

                     DO 2450 IT=1,NT

                       DO 2420 IA=1,NA

                         C=A0(IT)+(IA-1)*DA(IT)
                         C=EXP(C)   
                         suma=0.0
                         AMED=CALACA(IMO(N),IT,M0,RR(IR))
	               FG1=FNTRUNC(C,AMED,WAMAX(IMO(N),IT),SLA(IMO(N),IT))
                         FG2=EXP(-0.5*((M0-AME)/SMT)**2)
                         WQ1=FG1*FG2                 
                         AMED=CALACA(IMO(N),IT,AMU,RR(IR))
	               FG1=FNTRUNC(C,AMED,WAMAX(IMO(N),IT),SLA(IMO(N),IT))
                         FG2=EXP(-0.5*((AMU-AME)/SMT)**2)
                         WQ2=FG1*FG2
                         suma=suma+((wq1+wq2)*wpeso(IR))/2

                         DO 2400 IM=2,NM-1
                           MAG=M0+(IM-1)*DM
                           AMED=CALACA(IMO(N),IT,MAG,RR(IR))
 	               FG1=FNTRUNC(C,AMED,WAMAX(IMO(N),IT),SLA(IMO(N),IT))
                          FG2=EXP(-0.5*((MAG-AME)/SMT)**2)
                           WQ1=FG1*FG2
                           suma=suma+wq1*wpeso(IR)
2400                     CONTINUE

                         EVP(IA,IT)=EVP(IA,IT)+suma

2420                   CONTINUE
2450                 CONTINUE
2500             CONTINUE
             
                 AK=FNORAC( (AMU-AME)/SMT )-FNORAC( (M0-AME)/SMT )
                 CEF=DM/(EMT*SQRT(2*3.1416)*SMT*AK)
                 DO 2555 IA=1,NA
                 DO 2555 IT=1,NT
2555             EVP(IA,IT)=EVP(IA,IT)*CEF
 
               ENDIF            
               
               DO 2600 IT=1,NT
                 DO 2550 IA=1,NA
                   ANU(IA,IT)=ANU(IA,IT)+EVP(IA,IT)
2550             CONTINUE
2600           CONTINUE    


c               CALL GETDAT (ANO,MES,DIAdos)  
c
c   seisan date instead of above
c
      call systime(t1,t2)
      read(t1,'(3i2)') ano,mes,diados


	         If(DIAdos.EQ.dia) then
                  TREG=SECS()-TREG
               ELSE
			    DIA=DIAdos
	            TREG=0
	            TSITIO=0
				TREG=SECS()-TREG
			 END IF

               NREFTOT=NREFTOT+NREF
               IF (NREF .GT. 0) WRITE (16,6600) N,NREF,IC(N),JINC,TREG
c	         IF	(NREF.GT.0) WRITE (16,6650 ) NREFTOT

1800        CONTINUE       

C           *******  IMPRESION EN EL ARCHIVO DE RESULTADOS ********
            WRITE(16,6415)
            CALL PRIMA (ANU,NA,NT,A0,DA,T,COEF)

C           *******  IMPRESION EN EL ARCHIVO DE GRAFICAS *************
            NUBAN=0
	      WRITE(7,7900) LOS,LAS
            DO 1500 IT=1,NT
	       WRITE(7,7910) IT
             DO 1400 IA=1,NA
              C=A0(IT)+(IA-1)*DA(IT)
              C=EXP(C)
              WRITE(7,7000)C,ANU(IA,IT) 
C             ESCRIBE TASA DE EXCEDENCIA EN UN ARCHIVO PARA CADA PERIODO ESTRUCTURAL              
              WRITE(26+IT)ANU(IA,IT)
              IF ( ANU(IA,IT) .LE. 0 ) NUBAN=1
1400         CONTINUE
1500        CONTINUE          



C           ****** INTERPOLACION PARA TASAS DE EXCEDENCIA FIJAS:
             DO 1631 IT=1,NT
               DO 1626 I=1,5
	           TE=1.0/TR(I)
                 NBIN(I)=0 
                 IF (ANU(1,IT) .LE. TE) THEN

                    A1=A0(IT)
                    A2=A0(IT)+DA(IT)
				  IF (ANU(1,IT) .LE. 0.0 .OR. ANU(2,IT) .LE. 0.0) THEN	
					VB(I)=0.0
					NBIN(I)=2
				  ELSE
                      ANU1=LOG(ANU(1,IT))
                      ANU2=LOG(ANU(2,IT))
                      EME=(ANU2-ANU1)/(A2-A1)
                      VB(I)=EXP(A1+(LOG(TE)-ANU1)/EME)
                      NBIN(I)=1   
				  ENDIF

                 ELSE IF (ANU(NA,IT) .GT. TE) THEN

                    A1=A0(IT)+(NA-1-1)*DA(IT)
                    A2=A1+DA(IT)
			  IF (ANU(NA,IT) .LE. 0.0 .OR. ANU(NA-1,IT) .LE. 0.0) THEN	
				  	VB(I)=0.0
					NBIN(I)=2
				  ELSE
				    ANU1=LOG(ANU(NA-1,IT))
					ANU2=LOG(ANU(NA,IT))
				    EME=(ANU2-ANU1)/(A2-A1)
				    VB(I)=EXP(A1+(LOG(TE)-ANU1)/EME)
				    NBIN(I)=1
				  ENDIF

                 ELSE
                    
				  DO 1621 K=2,NA

                      IF (ANU(K,IT) .LE. TE) THEN
                        A1=A0(IT)+(K-1-1)*DA(IT)
                        A2=A1+DA(IT)
			  IF (ANU(K,IT) .LE. 0.0 .OR. ANU(K-1,IT) .LE. 0.0) THEN	
		    	    	  VB(I)=0.0
					      NBIN(I)=2
				      ELSE
                            ANU1=LOG(ANU(K-1,IT))
                            ANU2=LOG(ANU(K,IT))
                            EME=(ANU2-ANU1)/(A2-A1)
                            VB(I)=EXP(A1+(LOG(TE)-ANU1)/EME)   
					  ENDIF
                        GOTO 1622
                        
                      ENDIF
1621                CONTINUE      
1622                CONTINUE
                 ENDIF
1626           CONTINUE
               WRITE (9,8120) LOS,LAS,IT,VB(1),VB(2),VB(3),VB(4),VB(5),
     .					    NBIN(1),NBIN(2),NBIN(3),NBIN(4),NBIN(5)         
1631         CONTINUE
         

            TSITIO=(SECS()-TSITIO)/60.0
            WRITE (16,6225) TSITIO
	      TTOTAL=TTOTAL+TSITIO
	      WRITE	(16,6226) TTOTAL


1900      CONTINUE

2000  CONTINUE

      CLOSE (15)
      CLOSE (16)
      CLOSE (7)
      CLOSE (9)   
      
      DO I=1,NT
        CLOSE(26+I)
      ENDDO
 

C	  WHEN BUILDING A DLL, UNCOMMENT FOLLOWING LINES:      
C	  CRISIS=1        
C	  RETURN

C	  WHEN BUILDING A STANDALONE, UNCOMMENT FOLLOWING LINE:
      STOP 'SUCCESFUL TERMINATION'
 
2101  CONTINUE
C	STOP 'FILENAM.NAM DOES NOT EXIST'
C	CRISIS=7
	CALL CIERRA()
C	RETURN 
		
2200	CONTINUE
C	CRISIS=8
	CALL CIERRA()
C	RETURN

1100  FORMAT (' POLIGON IN REGION ',I4,' HAS MORE THAN ',I4,'VERTICES')
1001  FORMAT (3x,'Longitude: ',F8.3,'  Latitude: ',F8.3)
5000  FORMAT (16I5)
5005  FORMAT (I2)
5010  FORMAT (3F9.3) 
5029  FORMAT (6F9.0)
5030  FORMAT (10F9.0)
5031  FORMAT (4F9.0,2I9)
6000  FORMAT(1H1//5X,'PROGRAM CRISIS VERSION ',F5.2//
     1       5X,A80//
     2       5X,'Date : ',I4,'/',I2,'/',I2//)
6001  FORMAT(5X,'VALUES OF PARAMETERS FOR THE PRESENT PROJECT'/
     3          5X,'Number of regions:                    ',I5/
     4       5X,'Number of attenuation models:         ',I5/
     5       5X,'Number of structural periods:         ',I5/
     6       5X,'Number of intensity levels:           ',I5/
     7       5X,'Number of magnitudes for integration: ',I5//
     8       5X,'                INTENSITIES           ',/
     9       5X,' I     T(I)        A0(I)        AU(I)        NA  '
     .         ,'     '/)
6010  FORMAT (4X,I3,1X,3(1PE11.3,1X),5x,I3,2(1PE11.3,1X))
6020  FORMAT(/5X,'Max. dist. of integration:',T50,1PE11.3/) 
6024	FORMAT(/5X,'INITIAL GRID OF POINTS IN WHICH HAZARD WANTS TO BE COM
     1PUTED')
6025  FORMAT(/5X,'Initial site longitude',T50,1PE11.3/
     3        5X,'Initial site latitude',T50,1PE11.3/
     4        5X,'Longitude increment',T50,1PE11.3/
     5        5X,'Latitude increment',T50,1PE11.3/
     6        5X,'No. of points in longitude',T50,I11/
     7        5X,'No. of points in latitude',T50,I11//)
6026  FORMAT(5X,'THE INITIAL GRID WAS MODIFIED WITH THE FOLLOWING POLYGO
     1NS')
6027  FORMAT(/5X,'Number of polygons  ',I2)
6028  FORMAT(5X,'Number of vertex   ',F4.0)
6029  FORMAT(5X,'    LONG            LAT')
6030  FORMAT(5X,F10.3,5X,F10.3)
6035  FORMAT(/5X,'ALFA= Expected value of Alfa',
     1       /5X,'BETA= Expected value of Beta',
     2       /5X,'CBETA=Coefficient of variation of Beta',
     3       /5X,'EMU=  Expected value of the maximum magnitude',
     4       /5X,'SMU=  Standard deviation of the maximum magnitude',
     5       /5X,'MMAX= Maximum observed magnitude',
     6       /5X,'M0=   Treshold magnitude')
6039  FORMAT(/17X,'DEFINITION OF LOCAL POISSONIAN SEISMICITY:')
6040  FORMAT(/,'    REGION   ALFA    BETA   CBETA    EMU',
     .'    SMU       MMAX    MO')
6041  FORMAT (4X,I3,3X,F6.2,3X,F6.2,3X,F5.2,3X,F5.3,3X,F5.3,
     .        3X,F6.2,3X,F4.2,3X,F3.1,3X,F3.1)

6042  FORMAT(/5X,'EMT=  Median value of the time between characteristic 
     .earthquakes (CE)',/5X,'T0=   Time elapsed since the last ocurrence
     .of a CE',/5X,'D=    Parameter defining the expected magnitude',/5
     .X,'F=    Parameter defining the expected magnitude',/5X,'SMT=  Sta
     .ndard deviation of the magnitude of the CE',/5X,'MMIN= Minimum pos   
     .sible magnitude of a CE',/5X,'MU=   Maximum magnitude of the CE')
6044  FORMAT (/16X,'DEFINITION OF LOCAL CHARACTERISTIC SEISMICITY:')
6045  FORMAT (/,'   REGION   EMT      T0        D        F',
     .'      SMT     MMIN    MU')
6046  FORMAT(3X,I3,3X,F6.2,3X,F7.3,3X,F6.2,3X,F6.2,3X,F5.2,3X,F5.2,3X,
     .       F4.2,3X,F3.1,3X,F3.1,3x,F3.1)
6065  FORMAT(//5X,'MAXIMUM MAGNITUDE'/3X,'I',3X,'MU(I)',7X,'P(Mu)')
6066  FORMAT(/'                          PROPERTIES OF THE SOURCES')
6067  FORMAT(/'REGION:',I3,1X,A20)

6070  FORMAT(2X,I3)     
6071  format('        Long     Lat      Depth(km)')     
6072  FORMAT(5X,F7.2,3X,F7.2,3X,F7.2)
     
6074  FORMAT(2X,I2,2X,F6.3,3X,1PE12.4)
6075  FORMAT(//5X,'EPMU= ',F6.3/5X,'SPMU= ',F6.3)
6080  FORMAT(//5X,'BETA'/3X,'I',4X,'B(I)',8X,'P(B)')
6190  FORMAT (3X,'Latitude ',I3,'/',I3,3X,
     .           'Longitude ',I3,'/',I3,3X,
     .           'Region ',I3,'/',I3,3X)
6225  FORMAT (/5X,' Computation time for this site: ',F7.2,' min.')
6226  FORMAT (/5X,' Computation time till this site: ',F7.2,' min.')
6300  FORMAT(//5X,'FOCAL DISTANCE CONCENTRATIONS:'/)
6310  FORMAT(5X,I5,2X,F8.3,2X,F8.3)
6135  FORMAT (/5X,'MAXIMUM VALUES OF PARAMETERS SET IN THE PROGRAM'/
     .         5X,'Attenuation Models :',T50,I3/
     .         5X,'Intensity levels : ',T50,I3/
     .         5X,'Structural periods:',T50,I3/
     .         5X,'Number of regions:',T50,I3/
     .         5X,'Magnitudes in attenuation model:',T50,I3/  
     .         5X,'Distances in attenuation model:',T50,I3/
     .         5X,'Number of subsources per region:',T49,I4/)
6415  FORMAT (//5X,
     *       'INTENSITY versus EXPECTED EXCEEDANCE RATE')
6500  FORMAT (//'****************************************************',
     .          '**************************'/
     .          '****************************************************',
     .          '**************************'//
     .        9X,'Longitude and latitude of the site: ',2(1PE11.3,3X))

6550  FORMAT (/9X,'Number of site:                    ',I6)

6610  FORMAT (/12X,'      SUMMARY OF COMPUTATIONS FOR THIS SITE'//
     . 2X,'Considered   Points used to    Ocurrence    JINC     Time '
     . /2X,'Region       integrate with	   Model'
     . /2x,'             respect to dist.  ' )
6600  FORMAT (3X,I3,14X,I4,9X, I2,12X,I2,3X,F8.2)
6650  FORMAT (/,'Total integration points',I6)
6810  FORMAT (/10X,'                ATTENUATION MODELS      '/
     .'  I       MODEL'   )

6820  FORMAT (1X,I2,3X,A200)
6821  FORMAT (6X,'No. of Mag.',8x,'Lower Mag.',8x,'Magnitude Increment')
6822  FORMAT (6X,'No. of Dist.',7x,'Lower Dist.',7x,'Distance Increment'
     .)
6825  FORMAT (10X,I3,18X,F4.2,15X,F5.3)
6826  FORMAT (10X,I3,18X,F4.2,15X,F8.3)

6830  FORMAT (/13X,'MATRIX OF STANDARD DEVIATIONS OF INTENSITIES'/
     .'  Period -  Model -->')
6840  FORMAT (5X,I2,10(3X,F8.3))
6850  FORMAT (/13X,'MATRIX OF MAXIMUM VALUES OF INTENSITIES'/
     .'  Period  -  Model -->')
6910  FORMAT (///5X,'FINAL RESULTS:'/
     1           5X,'   T         Copt         Pmin           EEER'//)
7000  FORMAT (2(1PE11.3,1X))
7010  FORMAT (1PE11.3,1X)
7500  FORMAT (4X,F6.3,4X,F8.2,4X,2(1PE12.4,4X),' (SEE NOTE 2)')
7510  FORMAT (4X,F6.3,4X,F8.2,4X,2(1PE12.4,4X),' (SEE NOTE 1)')
7520  FORMAT (4X,F6.3,4X,F8.2,4X,2(1PE12.4,4X))
7530  FORMAT (/5X,
     1 'NOTE 1. OPTIMUM NOT FOUND. MINIMUM VALUES ARE GIVEN')
7540  format (5X,
     1 'NOTE 2. OPTIMUM NOT FOUND. MAXIMUM VALUES ARE GIVEN'/)
7900  FORMAT('SITE: ',F8.2,3X,F8.2)
7910  FORMAT('  INTENSITY ',I2)
8120  FORMAT (F8.2,3X,F8.2,3X,I2,5X,F8.2,5X,F8.2,5X,F8.2,5X,F8.2,5X,
     .F8.2,5X,I1,1X,I1,1X,I1,1X,I1,1X,I1)
9000  FORMAT (1X,'[2J','[1m','[12;31H',
     1        'C R I S I S  v ',F3.1,'[0m','[20;60H',
     2        'REGION      ',I2,'/',I2)

9010  FORMAT(2X,'Poisson model')
9015  FORMAT(2X,'Characteristic model')
9020  FORMAT(2X,'Area source')
9025  FORMAT(2X,'Fault source')
9030  FORMAT(2X,'Point source')
9035  FORMAT(2X,'Attenuation model:',2x,A200)
9040  FORMAT(2X,'Number of vertex',I3)
9050  FORMAT(2x,'INTENSITY LEVELS FOR FIXED RETURN PERIODS'
     .)
9060  FORMAT('    Long.       Lat.  NT',5(5X,F8.2),'        NNP'/)
9070  FORMAT('INTENSITY versus EXPECTED EXCEEDANCE RATE')
9090  FORMAT('INOUT ',I2)
9095  FORMAT(5X, F8.2)

      END

C********************************************************************

      SUBROUTINE PRIMA (A,NA,NT,A0,DA,T,CC)
      INTEGER MODMAX,NCMAX,NTMAX,NREGMAX,NMAGMAX,NRMAX,NMCX,NMMAX
      INTEGER NTRIMAX,NVMAX
                          
      PARAMETER (MODMAX=5,NCMAX=20,NTMAX=15,NREGMAX=200,NMAGMAX=10,
     .           NRMAX=21,NMCX=4000,NMMAX=30,NVMAX=25,
     .           NTRIMAX=NREGMAX*NVMAX,NPGMAX=10,NVGMAX=30)     

      DIMENSION A(NCMAX,NTMAX),A0(NT),DA(NT),T(NT),CC(NT)
      NV=1
      NB=0
10    CONTINUE  
      KI=(NV-1)*3+1
      KF=KI+2
      IF (KF .GE. NT) THEN
        KF=NT
        NB=1
      ENDIF
       WRITE(16,5900)
       WRITE(16,6000) (T(K),K=KI,KF)
      DO 100 IA=1,NA
        DO 50 K=KI,KF
          CC(K)=A0(K)+(IA-1)*DA(K)
          CC(K)=EXP(CC(K))
50      CONTINUE  
        WRITE(16,6100) (CC(K),A(IA,K),K=KI,KF)
100   CONTINUE
      NV=NV+1
      IF (NB .EQ. 0) GOTO 10
      RETURN

5900  FORMAT (//)
6000  FORMAT (3(12X,1PE11.3,1X))
6100  FORMAT (6(1PE11.3,1X))


      END

C*********************************************************
      SUBROUTINE ABRIR (UNIT,ARCH)
      INTEGER UNIT
      CHARACTER*200 ARCH
50    CONTINUE                 
      OPEN (UNIT,FILE=ARCH,STATUS='unknown')
      RETURN
100   CONTINUE
      END
C**************************************************************

        FUNCTION DIST (LA1,LO1,LA2,LO2,H)
        REAL LA0,LO0,LAS,LOS
        REAL LA1,LO1,LA2,LO2
        DATA PI/3.141592654/
        LAS=LA1
        LA0=LA2
        LOS=LO1
        LO0=LO2
        IF (ABS(LAS-LA0).LT.1E-3) THEN
           LAS=LAS+1E-4
        ENDIF
        IF (ABS(LOS-LO0).LT.1E-3) THEN
           LOS=LOS+1E-4
        ENDIF
        AA=(90.-LA0)*PI/180.
        BB=(90.-LAS)*PI/180.
        CC=(LOS-LO0)*PI/180.
        B1=ATAN( COS((BB-AA)/2.)/COS((BB+AA)/2.)/TAN(CC/2.) )
        B2=ATAN( SIN((BB-AA)/2.)/SIN((BB+AA)/2.)/TAN(CC/2.) )
        IF (SIN(B2) .EQ. 0) THEN
          WRITE(*,*) LAS,LOS
          WRITE(*,*) LA0,LO0,H
          STOP
        ENDIF
        C1=TAN((BB-AA)/2.)*SIN(B1)/SIN(B2) 
        C1=ATAN(C1)*2.*180./PI
        C1=C1*60*1.852
        DIST=SQRT(C1**2+H**2)
        RETURN
        END

C**********************************************************

      SUBROUTINE CERO (A,N)
      DIMENSION A(N)
      DO 1 I=1,N
1     A(I)=0.0
      RETURN
      END

C***************************************************************

      FUNCTION SECS()
      INTEGER*2 IH,IM,IS,ICS
      CALL GETTIM (IH,IM,IS,ICS)
      SECS=FLOAT(IH)*3600.+FLOAT(IM)*60.+FLOAT(IS)+FLOAT(ICS)/100.
      RETURN
      END

C****************************************************************

      SUBROUTINE LAGUER (NCON,AK,L,R,PROB)
      DIMENSION COEF(30),R(NCON),PROB(NCON),PKN1(30),PK1N1(30)
      REAL L
      CALL COEFI (COEF,NCON,NCON+1,AK,L)
      cnor=coef(ncon+1)/abs(coef(ncon+1))
      do 50 i=1,ncon+1
      coef(i)=coef(i)*cnor
 50   continue
      CALL RAIZ (COEF,NCON,NCON+1,R,AK/L,IER)
      IF(IER .NE. NCON ) THEN
        WRITE(*,*)'***** ERROR EN CALCULO DE B(.) *******'
        WRITE(*,*)'***** IMPOSIBLE CONTINUAR ************'
c        WRITE(1,*)
c     *  '***** ERROR IN COMPUTING CONCENTRATIONS FOR B(.) *******'
        WRITE(*,*)
     *  '***** IMPOSSIBLE TO CONTINUE ************'
        STOP
      ENDIF
      N=NCON-1
      CALL COEFI (COEF,N,N+1,AK,L)
      DO 100 J=1,NCON
         CALL EVALUA ( R(J),PKN1(J),COEF,N,N+1)
 100  CONTINUE
      AK=AK+1
      CALL COEFI(COEF,N,N+1,AK,L)
      DO 200 J=1,NCON
         CALL EVALUA (R(J),PK1N1(J),COEF,N,N+1)
 200  CONTINUE
      SUM=0
      DO 300 J=1,NCON
         PROB(J)=1./(PKN1(J)*PK1N1(J))
         SUM=SUM+PROB(J)
 300  CONTINUE
      DO 400 J=1,NCON
         PROB(J)=PROB(J)/SUM
 400  CONTINUE
      RETURN
      END
C
C**************************************************************
C
      SUBROUTINE COEFI ( COEF,N,N1,AK,L )
C
      DIMENSION COEF(N1)
      REAL L
      GAKN=GAMMA( FLOAT(N)+AK )
      DO 400 M=0,N
         CM=GAKN
         CM=CM-GAMMA( FLOAT(N-M+1) )
         CM=CM+GAMMA( FLOAT(N+1) )
         CM=CM-GAMMA( FLOAT(M)+AK )
         CM=CM-GAMMA( FLOAT(M+1) )
         CM=(-1)**M*EXP(CM)
         COEF(M+1)=CM/L**(N-M)
 400  CONTINUE
      RETURN
      END
C
C*****************************************************************
C
      SUBROUTINE EVALUA (X,Y,COEF,N,N1)
C
C   SUBRUTINA PARA EVALUAR POLINOMIO DE GRADO N
C
      DIMENSION COEF(N1)
      Y=COEF(1)
      DO 100 I=1,N
 100  Y=Y+COEF(I+1)*X**I
      RETURN
      END
C
C********************************************************************
C
      SUBROUTINE RAIZ (A,KN,N1,X,PT,IER)
C
C  SUBRUTINA PARA EL CALCULO DE RAICES DE POLINOMIOS
C  DE GRADO KN. N1=KN+1. LA SUBRUTINA ALTERA LOS COE-
C  FICIENTES DEL POLINOMIO ( ARREGLO A(.) ). LAS RA--
C  ICES REGRESAN EN EL ARREGLO X.
C          SOLO RAICES POSITIVAS
C
C
      DIMENSION A(N1),X(KN)
      DIMENSION D1(20),D2(20),AA(20)
      IER=0
      N=KN
      R1=PT
      K=N
      M=N+1
      DO 200 JJ=1,N-2
         DO 150 I=1,N
            D1(I)=A(I+1)*I
 150     CONTINUE
         DO 170 I=1,N
            D2(I)=D1(I+1)*I
 170     CONTINUE
C
         NIT=0
         NB=0
 175     CONTINUE
         NIT=NIT+1
         S1=0.
         S2=0.
         S3=0.
         DO 180 I=1,N+1
            II=I-1
            S1=S1+A(I)*R1**II
            IF (I .GT. N) GOTO 180
            S2=S2+D1(I)*R1**II
            IF (I .GT. N-1) GOTO 180
            S3=S3+D2(I)*R1**II
 180     CONTINUE
         MM=N-1
         H=(N-1)*((N-1)*S2*S2-N*S1*S3)
         IF( H .LT. 0. ) THEN
            IER=100+IER
            RETURN
         ENDIF
         R2=R1-N*S1/(S2+SQRT(H))
         ER=ABS((R2-R1)/R1)
         IF (ER .LT. 1.E-5 .OR. ABS(S1) .LT. 1.E-3) GOTO 188
         IF (NIT .GT. 200) THEN
            IF(NB .EQ. 1) THEN
               IER=100+IER
               RETURN
            ELSE
               NB=1
               R1=PT
               NIT=0
               GOTO 175
            ENDIF
         ENDIF
         R1=R2
         S1=0.
         S2=0.
         S3=0.
         GOTO 175
 188     CONTINUE
         X(JJ)=R2
         IER=IER+1
         N=N-1
         R1=R2
         NN=N-JJ+1
         M=M-1
         AA(M)=A(M+1)
         DO 190 I=1,M-1
            AA(M-I)=AA(M+1-I)*R2+A(M+1-I)
 190     CONTINUE
         DO 195 I=1,M
            A(I)=AA(I)
 195     CONTINUE
 200  CONTINUE
C
      D=A(2)*A(2)-4.*A(3)*A(1)
      IF( D .LT. 0. ) THEN
        IER=98
        RETURN
      ENDIF
      D=SQRT(D)
      MM=K-1
      X(MM)=(D-A(2))/2./A(3)
      X(K)=(-D-A(2))/2./A(3)
      IER=IER+2
      RETURN
      END
C
C***************************************************************
C
      FUNCTION GAMMA (X)
C
C   CALCULO DEL LOGARITMO NATURAL DE LA FUNCION GAMMA
C         X>=0
C
      DATA A,B,C,D,E/.918938534,12.,360.,1260.,1680./
      XM1=X+1
      GAMMA=(XM1-.5)*ALOG(XM1)-XM1+A
      GAMMA=GAMMA+1./(B*XM1)-1./(C*XM1**3.)
      GAMMA=GAMMA+1./(D*XM1**5.)-1./(E*XM1**7.)
      GAMMA=GAMMA-ALOG(X)
      RETURN
      END
C
c****+*****************************************************************
C
      FUNCTION CALACA (IMO,NT,MAG,RR)
      IMPLICIT NONE
C
      INTEGER MODMAX,NCMAX,NTMAX,NREGMAX,NMAGMAX,NRMAX,NMCX,NMMAX
      INTEGER NVMAX,NTRIMAX,NPGMAX,NVGMAX
       
      PARAMETER (MODMAX=5,NCMAX=20,NTMAX=15,NREGMAX=200,NMAGMAX=10,
     .           NRMAX=21,NMCX=4000,NMMAX=30,NVMAX=25,
     .           NTRIMAX=NREGMAX*NVMAX,NPGMAX=10,NVGMAX=30)     
       
c
      REAL MAG,MINF,R,ACEL,SLA,DMAG,RINF,DRAD,WAMAX
      REAL M1,r1,u,t,calaca,cl,RR
      INTEGER IMO,NT,NMAG,NRAD,NM,NR
C
      COMMON/ATENUA/ACEL(MODMAX,NTMAX,NMAGMAX,NRMAX),SLA(MODMAX,NTMAX),
     1              MINF(MODMAX),DMAG(MODMAX),RINF(MODMAX),DRAD(MODMAX),
     2              NMAG(MODMAX),NRAD(MODMAX),WAMAX(MODMAX,NTMAX)
C     
      R=ALOG(RR)
      NM=INT( (MAG-MINF(IMO))/DMAG(IMO))+1
      NR=INT( (R-RINF(IMO))/DRAD(IMO))+1
C
      IF (NM .LT. 1) NM=1
      IF (NR .LT. 1)  NR=1
      IF (NM .GT. NMAG(IMO)-1) NM=NMAG(IMO)-1
      IF (NR .GT. NRAD(IMO)-1) NR=NRAD(IMO)-1
c
      M1=MINF(IMO)+(NM-1)*DMAG(IMO)
      R1=RINF(IMO)+(NR-1)*DRAD(IMO) 
      T=(MAG-M1)/DMAG(IMO)
      U=(R  -R1)/DRAD(IMO)
      CL=(1-T)*(1-U)*ALOG(ACEL(IMO,NT,NM  ,NR  ))+
     .     T  *(1-U)*ALOG(ACEL(IMO,NT,NM+1,NR  ))+
     .     T  *  U  *ALOG(ACEL(IMO,NT,NM+1,NR+1))+
     .   (1-T)*  U  *ALOG(ACEL(IMO,NT,NM  ,NR+1))

      CALACA=EXP(CL)
      RETURN
      END      
        
c
C
C***********************************************************************
C       SUBROUTINE TO EVALUATE THE GAUSSIAN PROBABILITY DISTRIBUTION      
C       TAKEN FROM ABRAMOWITZ AND STEGUN, HANDBOOK OF MATHEMATICAL
C       FUNCTIONS, PAGE 932.(NOVEMBER, 1991)
C
        FUNCTION FNORAC (ARG)
        IMPLICIT NONE
        REAL B(5),ARG,FNORAC,T,TT,S
        INTEGER I
C
        DATA B/0.319381530,-0.356563782,1.781477937,
     1        -1.821255978, 1.330274429/
C
        T=1./(1.+0.2316419*ABS(ARG))
        TT=T
        S=0.0
        DO 100 I=1,5
            S=S+TT*B(I)
            TT=TT*T
100     CONTINUE
        S=0.3989423*EXP(-0.5*ARG*ARG)*S
        IF (ARG .GE. 0.0) THEN
          FNORAC=1.0-S
        ELSE
            FNORAC=S
        ENDIF
        RETURN
        END                           
C
C***************************************************************
C
      FUNCTION PM(MAG,M0,B,MU)
      IMPLICIT NONE
      REAL MAG,M0,MU,B,PM
      IF (MAG .GE. M0 .AND. MAG .LT. MU) THEN
        PM=B*EXP(-B*MAG)/( EXP(-B*M0) - EXP (-B*MU) )
      ELSE
        PM=0.0
      ENDIF
      RETURN
      END
CC
C     FUNCTION RADIO (AMAG,R,H)
c     RBAS=SQRT(R*R-H*H)
c     REQ=SQRT(10.0**(AMAG-4)/3.1416)
c     R1=RBAS-REQ
c     IF (R1 .LT. 0.0) R1=0.0
c     RADIO=SQRT(R1*R1+H*H)
C     RADIO=R
C     RETURN
C     END
C                     

c========================================================== 

      subroutine triangulate(np,nstot,ns,xys,ntri,xytri)

      PARAMETER (MODMAX=5,NCMAX=20,NTMAX=15,NREGMAX=200,NMAGMAX=10,
     .           NRMAX=21,NMCX=4000,NMMAX=30,NVMAX=25,
     .           NTRIMAX=NREGMAX*NVMAX,NPGMAX=10,NVGMAX=30)     

      dimension ns(1:np),xys(1:3,1:nstot),xytri(1:3,1:3,1:ntri)
      DIMENSION XYTMP (1:3,1:NTRIMAX)
      dimension ixy(500),ixy3(3,500)
      INTEGER SEPUEDE
      INTEGER NUM
      data idebug / 0 /             ! 1 for debug output

	DO I=1,3
		SEPUEDE=PLANO(I,NS(1),XYS,XYTMP)	
		IF (SEPUEDE .NE. 0) THEN
			NUM=NUMERA(NS(1),XYTMP)
			IF (NUM .NE. 0) THEN
				GOTO 100
			ELSE
				NTRI=0
				RETURN
			ENDIF
		ENDIF
	ENDDO
	NTRI=0
	RETURN

100	CONTINUE

	k=0
      ntri=0
      do 10 i=1,np
        nsi=ns(i)
        do 15 j=1,nsi
          k=k+1
          ixy(j)=k
15      continue
        call deldivide (nsi,ixy,XYTMP,m,ixy3,idebug)
        do 20 j=1,m
          ntri=ntri+1
          itri1=ixy3(1,j)
          itri2=ixy3(2,j)
          itri3=ixy3(3,j)
          xytri(1,1,ntri)=xys(1,itri1)
          xytri(1,2,ntri)=xys(1,itri2)
          xytri(1,3,ntri)=xys(1,itri3)
          xytri(2,1,ntri)=xys(2,itri1)
          xytri(2,2,ntri)=xys(2,itri2)
          xytri(2,3,ntri)=xys(2,itri3)
C         MODIFICACION PARA INCLUIR Z
          xytri(3,1,ntri)=xys(3,itri1)
          xytri(3,2,ntri)=xys(3,itri2)
          xytri(3,3,ntri)=xys(3,itri3)
20      continue
10    continue

      return
      end

c==========================================================
      subroutine deldivide (n,ixy,xy,m,ixy3,idebug)
      dimension ixy(n),xy(3,n),ixy3(3,m)

      m=0
      do 10 i=n,3,-1
      ii = i
      m=m+1
      call delsplit (ii,ixy,xy,ixy3(1,m),idebug)
10    continue
      return
      end

c==========================================================
      subroutine delsplit (n,ixy,xy,ixy3,idebug)
      dimension ixy(n),ixy3(3),xy(3,n)

      if (n.eq.3) then
            ixy3(1) = ixy(1)
            ixy3(2) = ixy(2)
            ixy3(3) = ixy(3)
            ixy(1) = 0
            ixy(2) = 0
            ixy(3) = 0
            n = 0
      else if (n.gt.3) then
            do 10 j2=1,n
                  j1 = j2-1
                  if (j1.le.0) j1=j1+n
                  j3 = j2+1
                  if (j3.gt.n) j3=j3-n
                  ixyj1=ixy(j1)
                  ixyj2=ixy(j2)
                  ixyj3=ixy(j3)
                  call delaunay(n,ixy,xy,ixyj1,ixyj2,ixyj3,
     .                  idel,idebug)
                  if (idel.eq.1.or.idel.eq.2) then
                        ielim1=ixy(j1)
                        ielim2=ixy(j2)
                        ielim3=ixy(j3)
                        ixy3(1) = ixy(j1)
                        ixy3(2) = ixy(j2)
                        ixy3(3) = ixy(j3)
                        do 20 j=j2,n-1
                              ixy(j)=ixy(j+1)   
20                      continue
                        ixy(n)=0
                        n=n-1
                        go to 11
                  endif
10          continue
11    continue
      endif
      return
      end

c==========================================================
      SUBROUTINE DELAUNAY(n,ixy,xy,j1,j2,j3,IDEL,idebug)
      dimension ixy(1),xy(3,1)
      
      xj1=xy(1,j1)
      xj2=xy(1,j2)
      xj3=xy(1,j3)
      yj1=xy(2,j1)
      yj2=xy(2,j2)
      yj3=xy(2,j3)

      dx23=xj3-xj2
      dx31=xj1-xj3
      dx12=xj2-xj1
      sx23=xj3+xj2
      sx31=xj1+xj3
      sx12=xj2+xj1

      dy23=yj3-yj2
      dy31=yj1-yj3
      dy12=yj2-yj1
      sy23=yj3+yj2
      sy31=yj1+yj3
      sy12=yj2+yj1

      term1=(dx23*sy23)-(dy23*sx23)
      term2=(dx31*sy31)-(dy31*sx31)
      term3=(dx12*sy12)-(dy12*sx12)

      area=-0.25*(term1+term2+term3)

         if (area.lt.0) idel=5
         if (area.eq.0) idel=4
         if (area.gt.0) idel=3

      CALL CIRCUM(xj1,yj1,xj2,yj2,xj3,yj3,X0,Y0,RSQ)
         if (idel.gt.3) return
      if (idebug.eq.1) then
            if (rsq.ge.0.) then
                  rr=sqrt(rsq)
            else
                  rr=-999.
            endif
      endif
      if (rsq.eq.-999) goto 30

      do 10 k=1,n
      kj=ixy(k)
      if (xy(1,kj).eq.xy(1,j1).and.xy(2,kj).eq.xy(2,j1)) goto 10
      if (xy(1,kj).eq.xy(1,j2).and.xy(2,kj).eq.xy(2,j2)) goto 10
      if (xy(1,kj).eq.xy(1,j3).and.xy(2,kj).eq.xy(2,j3)) goto 10
      dx=xy(1,kj)-x0
      dy=xy(2,kj)-y0
      r2=(dx*dx)+(dy*dy)

         if (r2.lt.rsq) goto 30
         if (r2.eq.rsq) then
            idel=2
         endif
   10 continue
      idel=1
      return
   30 idel=3
      return
      end

c==========================================================
      SUBROUTINE CIRCUM(x1,y1,x2,y2,x3,y3,X0,Y0,RSQ)

       x0 = -999.0
       y0 = -999.0
      rsq = -999.0
      sx13=0.5*(x1+x3)
      sy13=0.5*(y1+y3)
      dx13=(x3-x1)
      dy13=(y3-y1)
      sx12=0.5*(x1+x2)
      sy12=0.5*(y1+y2)
      dx12=(x2-x1)
      dy12=(y2-y1)
      den = (dx13*dy12) - (dx12*dy13)

      if (den.eq.0) return
      xfac1 =  (sy13*dy13) + (sx13*dx13) 
      xfac2 =  (sy12*dy12) + (sx12*dx12) 
      yfac1 =  (sx13*dx13) + (sy13*dy13)
      yfac2 =  (sx12*dx12) + (sy12*dy12)
      xnum  =  (xfac1*dy12) - (xfac2*dy13)
      ynum  =  (yfac1*dx12) - (yfac2*dx13)
      x0    =  xnum/den
      y0    =  -ynum/den
      dx10  =  x1-x0
      dx20  =  x2-x0
      dx30  =  x3-x0
      dy10  =  y1-y0
      dy20  =  y2-y0
      dy30  =  y3-y0
      rsq1  =  (dx10*dx10)+(dy10*dy10)
      rsq2  =  (dx20*dx20)+(dy20*dy20)
      rsq3  =  (dx30*dx30)+(dy30*dy30)
      rsq = rsq1
      return
      end

c==================================================
C******************************************************************
      Function areatr(uno,dos,tres)
      real uno,dos,tres,a,beta,b,c,m
      real areatr,x1,x2,x3,y1,y2,y3,PI
      data PI/3.141592654/
      
      a=min(uno,dos,tres)
      c=max(uno,dos,tres)

      if(a.eq.uno.and.c.eq.dos)then
      b=tres
      else
      if(a.eq.uno.and.c.eq.tres)then
      b=dos                         
      else
      if(a.eq.dos.and.c.eq.uno)then
      b=tres
      else
      if(a.eq.dos.and.c.eq.tres)then
      b=uno
      else
      if(a.eq.tres.and.c.eq.uno)then
      b=dos
      else
      b=uno
      endif
      endif
      endif
      endif
      endif            
      
      m=(a**2+c**2-b**2)/(2*a*c)      

      Beta=Acos(m)
      x1=0.0
      y1=a
      x2=c*cos((90.0*PI/180)-beta)
      y2=(c*sin((90.0*PI/180)-beta))-a
      x3=x2
      y3=(c*sin((90.0*PI/180)-beta))

      areatr=0.5*((x2-x1)*(y3-y1)-(x3-x1)*(y2-y1))
      
      return
      
      end

C================================================================
      FUNCTION AREA3D (X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3)
C     FUNCION QUE EVALUA EL AREA DE UN TRIANGULO EN EL ESPACIO

      REAL X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3

      XX2=DIST(Y1,X1,Y1,X2,0.)*SGN(X2-X1)
      YY2=DIST(Y1,X1,Y2,X1,0.)*SGN(Y2-Y1)

      XX3=DIST(Y1,X1,Y1,X3,0.)*SGN(X3-X1)
      YY3=DIST(Y1,X1,Y3,X1,0.)*SGN(Y3-Y1)
      ZZ2=Z2-Z1
      ZZ3=Z3-Z1
      FI=(YY2*ZZ3-YY3*ZZ2)**2+(XX3*ZZ2-XX2*ZZ3)**2+(XX2*YY3-XX3*YY2)**2
      AREA3D=0.5*SQRT(FI)
      RETURN
      END
C================================================================


      SUBROUTINE DIVREC(X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3)
c
c     ************************************************************
c     Subrutina recursiva (indirecta) de subdivision en triangulos
c     ************************************************************
c
      PARAMETER (MODMAX=5,NCMAX=20,NTMAX=15,NREGMAX=200,NMAGMAX=10,
     .           NRMAX=21,NMCX=4000,NMMAX=30,NVMAX=25,
     .           NTRIMAX=NREGMAX*NVMAX,NPGMAX=10,NVGMAX=30)     


      COMMON/TRIAN/KTR,RR(NMCX),WPESO(NMCX),XSITE,YSITE,HSITE,RMAX,
     *             RMIN,FMIN

      AUTOMATIC U1,U2,U3,U4,U5,U6
      AUTOMATIC V1,V2,V3,V4,V5,V6
      AUTOMATIC W1,W2,W3,W4,W5,W6

      X22=X2-X1
      X33=X3-X1
      Y22=Y2-Y1
      Y33=Y3-Y1
      Z22=Z2-Z1
      Z33=Z3-Z1

C     ---- Calcula coord. del centroide
      XC=X1+(X22+X33)/3.
      YC=Y1+(Y22+Y33)/3.
      ZC=Z1+(Z22+Z33)/3.
C
      DISTA=DIST(YC,XC,YSITE,XSITE,ZC)   
      TAM=SQRT(AREA3D(X1,Y1,Z1,X2,Y2,Z2,X3,Y3,Z3))
      FACTOR = DISTA/TAM   
 

C     SI FACTOR.GT.FMIN SIGNIFICA QUE LA FUENTE ESTA MUY LEJANA O ES MUY 
C     PEQUE¥A Y NO REQUIERE SUBDIVIDIRSE
C     SI TAM. LT. RMIN LA FUENTE ES YA MUY PEQUE¥A Y NO REQUIERE SUBD

      IF (FACTOR.GT.FMIN .OR. TAM .LT. RMIN) THEN

         IF (DISTA .LT. RMAX) THEN
           KTR = KTR + 1
           IF (KTR .GT. NMCX) THEN 
             WRITE(16,*) 'DEMASIADAS CELDAS EN LA REGION'
             CLOSE(15)
             CLOSE(16)
             STOP 'ERROR CRITICO. DEMASIADAS CELDAS EN LA REGION'
           ENDIF
           RR(KTR)=DISTA
           WPESO(KTR)= TAM*TAM

c          ---- Escritura temporal para pruebas ----------------- 
C          write (21,2100) KTR,XC,YC,WPESO(KTR)
C          write (22,*) 'READ 4'
C          write (22,2200)x1,y1
C          write (22,2200)x2,y2
C          write (22,2200)x3,y3
C          write (22,2200)x1,y1
C          IF (MOD(KTR,20) .EQ. 0) WRITE(22,'(A)') 'PLOT 0 0'
C2100       format(i5,3f10.4)
C2200       format(2f10.4)
c          -------------------------------------------------------
           RETURN

C        SI LA FUENTE ESTA A UNA DISTANCIA MATOR A RMAX NO SE CONSIDERARA
         ELSE
           RETURN
         END IF

      END IF
 
c     ----  Calcula v‚rtices de nuevos tri ngulos ---------
      U1=X1
      U2=X1+X22/2.0
      U3=X1+X33/2.0
      U4=X2
      U5=X1+(X33+X22)/2.0
      U6=X3
      V1=Y1
      V2=Y1+Y22/2.0
      V3=Y1+Y33/2.0
      V4=Y2
      V5=Y1+(Y33+Y22)/2.0           
      V6=Y3

      W1=Z1
      W2=Z1+Z22/2.0 
      W3=Z1+Z33/2.0
      W4=Z2
      W5=Z1+(Z22+Z33)/2.0
      W6=Z3

c     ---- Subdivide los cuatro tri ngulos
      CALL DAVREC(U1,V1,W1,U2,V2,W2,U3,V3,W3)
      CALL DAVREC(U2,V2,W2,U4,V4,W4,U5,V5,W5)
      CALL DAVREC(U2,V2,W2,U5,V5,W5,U3,V3,W3)
      CALL DAVREC(U3,V3,W3,U5,V5,W5,U6,V6,W6)
       
      RETURN
      END

c*****************************************************************************
c
      SUBROUTINE DAVREC (U1,V1,W1,U2,V2,W2,U3,V3,W3)
c     **** Subrutina para simular la recur- **** 
c     **** sividad directa.                 ****
      AUTOMATIC A1,A2,A3,B1,B2,B3
      A1=U1
      A2=U2
      A3=U3
      B1=V1
      B2=V2
      B3=V3
      C1=W1
      C2=W2
      C3=W3
      CALL DIVREC (A1,B1,C1,A2,B2,C2,A3,B3,C3)
      RETURN      
      END

C     ***************************************************************
      SUBROUTINE DIVLIN(X1,Y1,Z1,X2,Y2,Z2)
c
c     ************************************************************
c     Subrutina recursiva (indirecta) de subdivision en lineas
c     ************************************************************
c
      PARAMETER (MODMAX=5,NCMAX=20,NTMAX=15,NREGMAX=200,NMAGMAX=10,
     .           NRMAX=21,NMCX=4000,NMMAX=30,NVMAX=25,
     .           NTRIMAX=NREGMAX*NVMAX,NPGMAX=10,NVGMAX=30)     

      
      COMMON/TRIAN/KTR,RR(NMCX),WPESO(NMCX),XSITE,YSITE,HSITE,RMAX,
     *             RMIN,FMIN

      AUTOMATIC U1,U2,U3
      AUTOMATIC V1,V2,V3
      AUTOMATIC W1,W2,W3 

      FMIN=10
      
      X22=X2-X1
      Y22=Y2-Y1
      Z22=Z2-Z1

C     ---- Calcula coord. del centroide
      XC=X1+X22/2.0
      YC=Y1+Y22/2.0       
      ZC=Z1+Z22/2.0
      DISTA=DIST(YC,XC,YSITE,XSITE,ZC)
      TAM=DIST(Y1,X1,Y2,X2,ABS(Z22))
      FACTOR = DISTA/TAM

      IF (FACTOR.GT.FMIN .OR. TAM .LT. RMIN) THEN  

         IF (DISTA .LT. RMAX) THEN
           KTR = KTR + 1
           RR(KTR)=DISTA
           WPESO(KTR)= TAM           
c          ---- Escritura temporal para pruebas ----------------- 
C          write (21,2100) KTR,XC,YC,WPESO(KTR)
C          write (22,*) 'READ 2'
C          write (22,2200)x1,y1
C          write (22,2200)x2,y2
C          IF (MOD(KTR,20) .EQ. 0) WRITE(22,'(A)') 'PLOT 0 0'
C2100       format(i5,3f10.4)
C2200       format(2f10.4)
c          -------------------------------------------------------
           RETURN
         ELSE
           RETURN
         END IF

      END IF   
      U1=X1
      U2=X2
      U3=XC
      V1=Y1
      V2=Y2
      V3=YC
      W1=Z1
      W2=Z2
      W3=ZC
 
c     ---- Subdivide las dos lineas
      CALL DAVLIN(U1,V1,W1,U3,V3,W3)
      CALL DAVLIN(U3,V3,W3,U2,V2,W2)
       
      RETURN
      END
c*****************************************************************************
c
      SUBROUTINE DAVLIN (U1,V1,W1,U2,V2,W2)
c     **** Subrutina para simular la recur- **** 
c     **** sividad directa.                 ****
      AUTOMATIC A1,A2,B1,B2,C1,C2
      A1=U1   
      B1=V1
      C1=W1
      A2=U2
      B2=V2
      C2=W2
      CALL DIVLIN (A1,B1,C1,A2,B2,C2)
      RETURN      
      END

c *************************************************************************
C
      FUNCTION SGN(X)
      IF (X .EQ. 0) THEN
         SGN=0.0
      ELSE
         SGN=X/ABS(X)
      ENDIF
      RETURN
      END

C **********************************************************************
      SUBROUTINE POLINS(NVERG,VCLGRID,PT,INOUT)
	IMPLICIT LOGICAL (A-Z)
cC
cC     Driver program for testing routines PTPOLG.
cC     Routines called:
cC        INITCB, PTPOLG
cC
      DOUBLE PRECISION PI,TOL
      COMMON /GCONST/ PI,TOL
cC
      INTEGER MAXN
      PARAMETER (MAXN = 30)
C
      INTEGER I,INOUT,IPRT,IRDR,PGIND(0:MAXN),NVERG
      DOUBLE PRECISION DTOL,NRML(3),PT(2),VCLGRID(2,MAXN)
C
	I=0
      IRDR = 5
      IPRT = 6
C      CALL INITCB(0.0D0)
C      DTOL = 10.0D0*TOL
C     LECTURA DEL NUMERO DE VERTICES DEL POLIGONO
cc      READ (IRDR,*) NVERG
      IF (NVERG .LT. 3) STOP
      IF (NVERG .GT. MAXN) THEN
c	  WRITE (IPRT,600) 'MAXN',NVERG
	  STOP
      ENDIF
C LECTURA DE COORDENADAS DE CADA VERTICE
cc      READ (IRDR,*) (VCLGRID(1,I),VCLGRID(2,I),I=1,NVERG)
      PGIND(0) = NVERG
      DO 10 I = 1,NVERG
	  PGIND(I) = I
C	  WRITE (IPRT,620) I,(VCL(J,I),J=1,DIM)
c	  WRITE (16,620) I,(VCLgrid(j,I),j=1,2)
c	    write(16,*) vclgrid(1,I)
c		write(16,*) VCLGRID(2,I)
   10 CONTINUE
c      WRITE (IPRT,620)
C   20 CONTINUE
C	LECTURA DEL PUNTO A EVALUAR
cc	  READ (IRDR,*,END=30) PT(1),PT(2)
	  CALL PTPOLG(2,2,NVERG,1,PGIND,VCLGRID,PT,NRML,DTOL,INOUT)
c        WRITE (IPRT,630) INOUT,(PT(I),I=1,2)
	 RETURN
C      GO TO 20
   30 CONTINUE
C
  600 FORMAT (1X,'*** ',A,' must be increased to',I8)
  610 FORMAT (1X,'DIM=',I2,3X,'A,B=',2F15.7)
  620 FORMAT (1X,I5,3F15.7)
  630 FORMAT (1X,'INOUT=',I3,3X,'PT=',3F15.7)
      END
     	    
      SUBROUTINE PTPOLG(DIM,LDV,NVERG,INC,PGIND,VCLGRID,PT,NRML,DTOL,
     .                  INOUT)
      IMPLICIT LOGICAL (A-Z)
      INTEGER DIM,INC,INOUT,LDV,NVERG,PGIND(0:*)
      DOUBLE PRECISION DTOL,NRML(3),PT(DIM),VCLGRID(LDV,*)
C
C     Purpose: Determine whether a point lies inside, outside, or on
C        boundary of a planar polygon in 2 or 3 dimensional space.
C        It is assumed that point lies in plane of polygon.
C
C     Input parameters:
C        DIM - dimension of polygon (2 or 3)
C        LDV - leading dimension of VCL array in calling routine
C        NV - number of vertices in polygon
C        INC - increment for PGIND indicating indices of polygon
C        PGIND(0:NV*INC) - indices in VCL of polygon vertices are in
C              PGIND(0), PGIND(INC), ..., PGIND(NV*INC) with first and
C              last vertices identical
C        VCL(1:DIM,1:*) - vertex coordinate list
C        PT(1:DIM) - point for which in/out test is applied
C        NRML(1:3) - unit normal vector of plane containing polygon,
C              with vertices oriented CCW wrt normal (used iff DIM = 3);
C              normal is assumed to be (0,0,1) if DIM = 2
C        DTOL - absolute tolerance to determine whether a point is on
C              a line or plane
C
C     Output parameters:
C        INOUT - +1, 0, or -1 depending on whether point PT is inside
C              polygon, on boundary of polygon, or outside polygon;
C              or -2 if error in input parameters
C
      DOUBLE PRECISION PI,TOL
      COMMON /GCONST/ PI,TOL
      SAVE /GCONST/
C
      DOUBLE PRECISION CP(3),DIR(3),DE(3),NR(4),RHS(3)
      DOUBLE PRECISION DIST,DOTP,LEN1,LEN2,T,TA
      INTEGER I,J,K,L,LA,LB,M,N,S,SA,SB
C
c	do I=1,nverg
c	   write(16,*) '2',vclgrid(1,I)
c	   write(16,*)'2', VCLGRID(2,I)
c	end do

      INOUT = -2
      IF (DIM .LT. 2 .OR. DIM .GT. 3) RETURN
C
C     Direction of ray is from PT through midpoint of first edge
C     such that PT is not collinear with edge. NR is normal of plane
C     containing ray, which is also orthogonal to NRML.
C
      I = 0
      LB = PGIND(0)
   10 CONTINUE
	 I = I + 1
	 IF (I .GE. NVERG) RETURN
         LA = LB
         LB = PGIND(I*INC)
	 DO 20 J = 1,DIM
	    DE(J) = VCLGRID(J,LB) - VCLGRID(J,LA)
	    DIR(J) = PT(J) - VCLGRID(J,LA)
   20    CONTINUE
	 IF (DIM .EQ. 2) THEN
	    LEN1 = DE(1)**2 + DE(2)**2
	    LEN2 = DIR(1)**2 + DIR(2)**2
	 ELSE
	    LEN1 = DE(1)**2 + DE(2)**2 + DE(3)**2
	    LEN2 = DIR(1)**2 + DIR(2)**2 + DIR(3)**2
	 ENDIF
	 IF (LEN1 .EQ. 0.0D0) THEN
	    GO TO 10
	 ELSE IF (LEN2 .EQ. 0.0D0) THEN
	    INOUT = 0
	    RETURN
	 ENDIF
	 IF (DIM .EQ. 2) THEN
	    DOTP = ABS(DE(1)*DIR(1) + DE(2)*DIR(2))/SQRT(LEN1*LEN2)
	 ELSE
	    DOTP = ABS(DE(1)*DIR(1) + DE(2)*DIR(2) + DE(3)*DIR(3))/
     $         SQRT(LEN1*LEN2)
	 ENDIF
      IF (DOTP .GE. 1.0D0 - TOL) GO TO 10
C
      IF (DIM .EQ. 2) THEN
         DIR(1) = 0.5D0*(VCLGRID(1,LA) + VCLGRID(1,LB)) - PT(1)
         DIR(2) = 0.5D0*(VCLGRID(2,LA) + VCLGRID(2,LB)) - PT(2)
         DIST = SQRT(DIR(1)**2 + DIR(2)**2)
         DIR(1) = DIR(1)/DIST
         DIR(2) = DIR(2)/DIST
	 DIR(3) = 0.0D0
         NR(1) = -DIR(2)
         NR(2) = DIR(1)
         NR(3) = 0.0D0
         NR(4) = NR(1)*PT(1) + NR(2)*PT(2)
         DIST = NR(1)*VCLGRID(1,LB) + NR(2)*VCLGRID(2,LB) - NR(4)
      ELSE
         DIR(1) = 0.5D0*(VCLGRID(1,LA) + VCLGRID(1,LB)) - PT(1)
         DIR(2) = 0.5D0*(VCLGRID(2,LA) + VCLGRID(2,LB)) - PT(2)
         DIR(3) = 0.5D0*(VCLGRID(3,LA) + VCLGRID(3,LB)) - PT(3)
         DIST = SQRT(DIR(1)**2 + DIR(2)**2 + DIR(3)**2)
         DIR(1) = DIR(1)/DIST
         DIR(2) = DIR(2)/DIST
         DIR(3) = DIR(3)/DIST
         NR(1) = NRML(2)*DIR(3) - NRML(3)*DIR(2)
         NR(2) = NRML(3)*DIR(1) - NRML(1)*DIR(3)
         NR(3) = NRML(1)*DIR(2) - NRML(2)*DIR(1)
         NR(4) = NR(1)*PT(1) + NR(2)*PT(2) + NR(3)*PT(3)
         DIST = NR(1)*VCLGRID(1,LB)+NR(2)*VCLGRID(2,LB)+NR(3)*VCLGRID
     .   (3,LB) - NR(4)
      ENDIF
      IF (DIST .GT. 0.0D0) THEN
	 SB = 1
      ELSE
	 SB = -1
      ENDIF
      M = 1
      IF (ABS(DIR(2)) .GT. ABS(DIR(1))) M = 2
      IF (ABS(DIR(3)) .GT. ABS(DIR(M))) M = 3
      K = 1
C
C     For remaining edges of polygon, check whether ray intersects edge.
C     Vertices or edges lying on ray are handled by looking at preceding
C     and succeeding edges not lying on ray.
C
      N = I
      I = I + 1
   30 CONTINUE
	 LA = LB
	 LB = PGIND(I*INC)
	 SA = SB
	 IF (DIM .EQ. 2) THEN
            DIST = NR(1)*VCLGRID(1,LB) + NR(2)*VCLGRID(2,LB) - NR(4)
	 ELSE
            DIST = NR(1)*VCLGRID(1,LB) + NR(2)*VCLGRID(2,LB) + NR(3)
     .	  *VCLGRID(3,LB)
     $         - NR(4)
	 ENDIF
	 IF (ABS(DIST) .LE. DTOL) THEN
	    SB = 0
         ELSE IF (DIST .GT. 0.0D0) THEN
	    SB = 1
         ELSE
	    SB = -1
         ENDIF
	 S = SA*SB
	 IF (S .LT. 0) THEN
	    IF (DIM .EQ. 2) THEN
	       DE(1) = VCLGRID(1,LA) - VCLGRID(1,LB)
	       DE(2) = VCLGRID(2,LA) - VCLGRID(2,LB)
	       RHS(1) = VCLGRID(1,LA) - PT(1)
	       RHS(2) = VCLGRID(2,LA) - PT(2)
	       T = (RHS(1)*DE(2) - RHS(2)*DE(1))/(DIR(1)*DE(2) -
     $            DIR(2)*DE(1))
	    ELSE
	       DE(1) = VCLGRID(1,LA) - VCLGRID(1,LB)
	       DE(2) = VCLGRID(2,LA) - VCLGRID(2,LB)
	       DE(3) = VCLGRID(3,LA) - VCLGRID(3,LB)
	       RHS(1) = VCLGRID(1,LA) - PT(1)
	       RHS(2) = VCLGRID(2,LA) - PT(2)
	       RHS(3) = VCLGRID(3,LA) - PT(3)
	       CP(1) = DIR(2)*DE(3) - DIR(3)*DE(2)
	       CP(2) = DIR(3)*DE(1) - DIR(1)*DE(3)
	       CP(3) = DIR(1)*DE(2) - DIR(2)*DE(1)
	       L = 1
	       IF (ABS(CP(2)) .GT. ABS(CP(1))) L = 2
	       IF (ABS(CP(3)) .GT. ABS(CP(L))) L = 3
	       IF (L .EQ. 1) THEN
	          T = (RHS(2)*DE(3) - RHS(3)*DE(2))/CP(1)
	       ELSE IF (L .EQ. 2) THEN
	          T = (RHS(3)*DE(1) - RHS(1)*DE(3))/CP(2)
	       ELSE
	          T = (RHS(1)*DE(2) - RHS(2)*DE(1))/CP(3)
	       ENDIF
	    ENDIF
	    IF (T .GT. DTOL) THEN
	       K = K + 1
	    ELSE IF (T .GE. -DTOL) THEN
	       INOUT = 0
	       RETURN
	    ENDIF
	 ELSE IF (S .EQ. 0) THEN
	    L = LB
   40       CONTINUE
	    I = I + 1
	    IF (I .GT. NVERG) I = 1
	    IF (I .EQ. N) RETURN
	    LA = LB
	    LB = PGIND(I*INC)
	    IF (DIM .EQ. 2) THEN
               DIST = NR(1)*VCLGRID(1,LB) + NR(2)*VCLGRID(2,LB) - NR(4)
	    ELSE
               DIST = NR(1)*VCLGRID(1,LB) + NR(2)*VCLGRID(2,LB) +
     $            NR(3)*VCLGRID(3,LB) - NR(4)
	    ENDIF
	    IF (ABS(DIST) .LE. DTOL) THEN
	       GO TO 40
            ELSE IF (DIST .GT. 0.0D0) THEN
	       SB = 1
            ELSE
	       SB = -1
            ENDIF
	    T = (VCLGRID(M,L) - PT(M))/DIR(M)
	    IF (ABS(T) .LE. DTOL) THEN
	       INOUT = 0
	       RETURN
	    ENDIF
	    IF (LA .NE. L) THEN
	       TA = (VCLGRID(M,LA) - PT(M))/DIR(M)
	       IF (ABS(TA) .LE. DTOL .OR. T*TA .LT. 0.0D0) THEN
	          INOUT = 0
	          RETURN
	       ENDIF
	    ENDIF
	    IF (SA*SB .LT. 0 .AND. T .GT. 0.0D0) K = K + 1
	 ENDIF
         I = I + 1
         IF (I .GT. NVERG) I = 1
      IF (I .NE. N) GO TO 30
C
C     Point lies inside polygon if number of intersections K is odd.
C
      IF (MOD(K,2) .EQ. 1) THEN
	 INOUT = 1
      ELSE
	 INOUT = -1
      ENDIF
      END
C
C
	FUNCTION FNTRUNC (A,AMED,AMAX,SIGMA)
C
C     **************************************************
C       FUNCION PARA CALCULAR PROBABILIDAD DE EXCEDENCIA
C       EN UNA LOG-NORMAL (AMED,SIGMA), TRUNCADA A AMAX
C     ************************************************* 
	ARG1=LOG(A/AMED)/SIGMA
	IF (AMAX .GT. 0) THEN
		IF (A .GE. AMAX ) THEN
			FNTRUNC=0.0
		ELSE
			ARG2=LOG(AMAX/AMED)/SIGMA
			FNTRUNC=1.0-FNORAC(ARG1)/FNORAC(ARG2)
		ENDIF
	ELSE
	    FNTRUNC=1.0-FNORAC(ARG1)
	ENDIF
	RETURN
	END

C	 *************************************************
	FUNCTION PLANO(IPLANO,NV,XYZ,XYTMP) 

      PARAMETER (MODMAX=5,NCMAX=20,NTMAX=15,NREGMAX=200,NMAGMAX=10,
     .           NRMAX=21,NMCX=4000,NMMAX=30,NVMAX=25,
     .           NTRIMAX=NREGMAX*NVMAX,NPGMAX=10,NVGMAX=30)     

C	Si Iplano=1 se revisa en X-Y
C	Si Iplano=2 se revisa en X-Z
C	Si Iplano=3 se revisa en Y-Z

	INTEGER I,J,K
			
	REAL x1,y1,Z1
	REAL x3,y3,Z3
	REAL Compi,Compj,Compk,norma,N1,N3
	REAL XYZ(3,NVMAX),XYTMP(3,NVMAX)	
 
	PLANO = 0
 
	DO I=1,3
		DO J=1,NV
			XYTMP(I,J)=XYZ(I,J)

		END DO
	ENDDO

	IF (IPLANO .EQ. 2) THEN
		DO J=1,NV
			XYTMP(2,J)=-XYZ(3,J)
		ENDDO
	ENDIF

	IF (IPLANO .EQ. 3) THEN
		DO J=1,NV
			XYTMP(1,J)=XYZ(2,J)
			XYTMP(2,J)=-XYZ(3,J)
		ENDDO
      ENDIF
	 
	DO I=1,NV 

		j = i + 1
		If (j .GT.Nv) j = 1
		k = j + 1
		If (k .GT.Nv) k = 1
C		Pivoteamos en el vértice j
		x1 = XYTMP(1,i) - XYTMP(1,j)
		Y1 = XYTMP(2,i) - XYTMP(2,j)
		Z1 = XYTMP(3,i) - XYTMP(3,j)
		N1=SQRT(X1**2+Y1**2+Z1**2)
		x3 = XYTMP(1,K) - XYTMP(1,j)
		Y3 = XYTMP(2,K) - XYTMP(2,j)
		Z3 = XYTMP(3,K) - XYTMP(3,j)
		N3=SQRT(X3**2+Y3**2+Z3**2)

   		IF (N3 .EQ. 0.0 .OR. N1 .EQ. 0) THEN
			PLANO=0
			RETURN
		ENDIF

C		Calculamos componentes del producto cruz
		Compi = y1 * Z3 - y3 * Z1
		Compj = -(x1 * Z3 - x3 * Z1)
		Compk = x1 * y3 - x3 * y1
		Norma = SqrT(Compi ** 2 + Compj**2 + Compk**2)
   
		If (Norma .EQ. 0) Then
C			LOS PUNTOS SON COLINEALES EN EL PLANO QUE SE REVISA
		ELSE
			Compi = Compi / Norma
			Compj = Compj / Norma
			Compk = Compk / Norma
			If( Abs(Compk) .LT. 0.000001) Then
				Plano = 0
				RETURN
			ENDIF
		End If
 
	ENDDO
 
	Plano = 1

	RETURN
	END
c
      FUNCTION NUMERA (NV,C)
c
C	Funcion para verificar si la numeracion de una region es correcta
C	Regresa -1 si la numeración es antihoraria y 0 si es horaria
	REAL C(3,NV)
	
      If (Nv .LT. 3) Then
		Numera=0
		RETURN
	End If
 
	DO i = 1,Nv
 
		j = i + 1
		If (j .GT. Nv) j = 1
		k = j + 1
		If (k .GT. Nv) k = 1

C		Calculamos centro del círculo
		CALL Circum (C(1,I),C(2,I),C(1,J),C(2,J),C(1,K),C(2,K),
     .				 X0,Y0,R)
   

c     Vemos si no son colineales
		If(r .gt.0.0 .And. r .lt. 100000) Then
   
c		   	No son colineales

c			Calculamos sentido del angulo
			x1 = C(1,I) - C(1,J)
			x3 = C(1,K) - C(1,J)
			y1 = C(2,I) - C(2,J)
			y3 = C(2,K) - C(2,J)
			Area = x1 * y3 - x3 * y1

			If (Area .lt. 0) Then

				x1 = C(1,I) - x0
				x2 = C(1,J) - x0
				x3 = C(1,K) - x0
				y1 = C(2,I) - y0
				y2 = C(2,J) - y0
				y3 = C(2,K) - y0
				alfa1 = Atn2(x1, y1)
				s = Sin(alfa1)
				CC = Cos(alfa1)
				xp1 = CC * x1 + s * y1
				xp2 = CC * x2 + s * y2
				xp3 = CC * x3 + s * y3
				yp1 = -s * x1 + CC * y1
				yp2 = -s * x2 + CC * y2
				yp3 = -s * x3 + CC * y3
      
				alfa2 = Atn2(xp2, yp2)
				alfa3 = Atn2(xp3, yp3)
				If (alfa2 .LT. alfa3) Then
					Numera=-1
				Else
					Numera=0
				End If
				RETURN
      
			End If

		endif

     	enddo
  
	Numera=0
	return
	end
c
	FUNCTION ATN2(X,Y)
	DATA Pi/3.141592654/
 
C	Excepciones
	If (x .EQ. 0.0) Then
		IF (Y .GT. 0.0) THEN
			Atn2 = Pi / 2
		ELSE
     			IF (Y .LT. 0.0) THEN
				Atn2 = 3 * Pi / 2
			ELSE
				ATN2=0.0
			ENDIF
		ENDIF
		RETURN
	End If

	If (Y .EQ. 0.0) Then
		IF (X .GT. 0.0) THEN
			Atn2 = 0.0
		ELSE
     			IF (X .LT. 0.0) THEN
				Atn2 = Pi 
			ELSE
				ATN2=0.0
			ENDIF
		ENDIF
		RETURN
	End If 
 
 
	IF (X .GT. 0.0) THEN
	    If (y .GT. 0.0) Then
C			Primer cuadrante
			Atn2 = Atan(y / x)
		Else
C			Cuarto cuadrante
			Atn2 = 2 * Pi - Atan(Abs(y / x))
     		end If
	else
		If (y .gt. 0.0) Then
c			Segundo cuadrante
			Atn2 = Pi - Atan(Abs(y / x))
		else
c			Tercer cuadrante
			Atn2 = Pi + Atan(Abs(y / x))
		End If
	End if
   	return
	End 

	FUNCTION OURLEN(A)
	CHARACTER*200 A
	N=LEN(A)

	DO I=1,N
		IF (A(I:I) .EQ. ' ') THEN
			OURLEN=I-1
			RETURN
		ENDIF
	ENDDO

	OURLEN=N
	RETURN
	END
C
	SUBROUTINE CIERRA()
	CLOSE (15)
	CLOSE (16)
	CLOSE (7)
	CLOSE (8)
	CLOSE (9)
	CLOSE (25)
	DO I=1,15
		CLOSE(26+I)
	ENDDO
	RETURN
	END

cDEBUG
c
c  convert chinees files to seisan format
c
c
c  j. havskov, march 99
c  b. moreno, sep 99
c    may 11  00    lo : use read_resp_head
c
c  updates:
c
c  sep 22  99 by bmt: tested on linux
c  sep 28  99 by bmt: tested on WINDOWS
c  oct 30  99 by bmt: small change
c  dec 07  99 by bmt: joint in one file

      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
c-- input data vector     
      integer*4 data(max_sample)
c-- input file name       
      character*80 infile
      integer seiclen      ! function
      character*80 text
c
c-----------------------------------------------------------------------
c   start block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile        
c-- number of stations
      integer nchan      
c-- channel to calculate channel header for
      integer ichan,century,doy
c-- network code
      character*5 net_code        
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)         
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times          
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)
      character*80  temp_netcode        
c
c--end block of definitions most conversion programs
c---------------------------------------------------------------------
c

c-- infile indicator; in=0: one file, in=1: many files
      integer in          
c-- question
      character*80 question,fname,indice          
c--Counters etc
          integer i,j,l,k,line,rest
      integer code   ! error code
c-- computer type
      logical pc,sun,linux        
c
       include 'bgisei.inc'   

      call print_ver(' SEISAN 7.1.0, May 18, 2000')
      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
      text='bgisei.def'
      call read_def_chan(text,mainhead_text,net_code)
      temp_netcode=net_code
c
       open(10,file='filenr.out',status='unknown',form='formatted')      
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)        
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.infile(1:10).eq.
     *'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c  file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
          i=seiclen(infile)   ! length of file name
      write(6,'(1x,a)') infile(1:i)
c
c   convert file to ascii using bgiasc program 
c
cc      call systemc
cc     *('bgiasc1 '//infile(1:i)//'> bgiasc.out',22+i)
      call bgiasc(infile(1:i),i)
c     open file and read header info
c
       open(1,file='bgiasc.evt',status='old')
c
c   skiping the header
c
       read(1,'(a)') text
       read(text(31:33),'(i3)') nchan

c       do j=1,11
c        read(1,'(a)') text
c       end do
c get all stats, comps start times etc, remeber station are 5 chars !
c
      
       do i=1,nchan
       read(1,'(a)') text
       stat(i)=text(1:5)
       comp(i)=' '
       comp(i)(1:4)=text(6:9)
c   number of samples , rate and start time
c
c
       read(text(45:50),'(i6)') nsamp(i)
       read(text(37:43),'(f7.2)') rate(i)
       read(text(10:35),'(i1,i2,1x,i3,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3)') 
     *    century,year(i),doy,month(i),day(i),
     *    hour(i),min(i),sec(i)
        year(i)=year(i)+1900+century*100
c   continueif not at the data section
c
c
 
c
c   put in definition from def file
c
      
       call set_def_chan(i,stat(i),comp(i))
      
    
c   read data
c
c
     
c      do j=1,12
c         read(1,'(a)') text
c      enddo

cc      read(1,*,end=222) (data(j),j=1,nsamp(i))
       
c   end of file on solaris is incoplete causing an end of file, so the
c   end=222 is added above and all samples are set to 0 before reading. 
c   in this wasy any missing samples will be zero
c
 222  continue
c
      end do

      close(1)
     
      open(1,file='bgiasc.evt',status='old')
c   make seisan headers
      ichan=1
      cbyte(1)='4'   ! 4 byte data
      net_code=temp_netcode
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)
      write(6,200) outfile(1:29)
      write(10,*) outfile(1:29)                                             
 200  format(/,' Output file name is: ',a29)   
                             
c   open output file
      open(2,file=outfile,status='unknown',form='unformatted')
 
c       do j=1,12
        read(1,'(a)') text
c       end do
  
      do j=1,12
         write(2)mainhead(j)
c         write(6,'(1x,a)')mainhead(j)(1:79)
      enddo

      do i=1,nchan
       read(1,'(a)') text
       stat(i)=text(1:5)
       comp(i)=' '
       comp(i)(1:4)=text(6:9)
c
       read(text(45:50),'(i6)') nsamp(i)
       read(text(37:43),'(f7.2)') rate(i)
       read(text(10:35),'(i1,i2,1x,i3,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3)') 
     *    century,year(i),doy,month(i),day(i),
     *    hour(i),min(i),sec(i)
        year(i)=year(i)+1900+century*100

c      do j=1,12
c         read(1,'(a)') text
c      enddo

       call set_def_chan(i,stat(i),comp(i))
      ichan=i
      cbyte(i)='4'   ! 4 byte data
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)
c   read response curve into header
c

      call read_resp_head(chahead)                                            
c
      net_code=' '
      do j=1,nsamp(i)
         data(j)=0
      enddo
      if(i.lt.10) then
       write(indice,'(i1)') i
      else
       write(indice,'(i2)') i
      endif  
        fname = 'chan.'// indice
      open(3,file=fname,status='old')
      read(3,*,end=223) (data(j),j=1,nsamp(i))
 223  continue
      close(3)
c
        
c   write data
      write(6,'(1x,a)')chahead(1:79)
      write(2) chahead
c
      write(2)(data(j),j=1,nsamp(i))
      write(6,*)
      end do
        close(1)
      close(2)
c
c  back for next file if many
c
      if(in.eq.1) goto 1000                                                               
      close(10)
      write(*,*) 'finished'
      stop
      end                                                         
                                                                  

c
c  converts Cityshark ascii files to SEISAN
c
c  jh  jan 2002, little tested
c
c  components S  Z, S  N, S  E, can be changed with
c  def file, assume 3 channels, all channels same rate and number of samples
c
c  if a channel is missing, no check on components
c
c  
c  updates:
c  
c
      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
c-- input data vector	  
      integer data1(max_sample),data2(max_sample),data3(max_sample)

c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text
c-- channel header
      character*1040 chahead
c-- output file name, definition file 
      character*80 outfile, deffile
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code        
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
      character*80 text         ! text 
      character*1 time_error    ! if blank, no error

c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question
c--Counters etc
          integer i

      logical no_net                    ! flag if net_code set



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c

      mainhead_text=' '
      time_error=' '
c
c   get def file for station codes, give file name
c
      deffile='citsei.def'
      no_net = .FALSE.
      net_code=' '

      call read_def_chan(deffile,mainhead_text,net_code)

      if (net_code.eq.' ') no_net = .true.

c
c   get file name
c
19    continue
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c   open file to read
c
       open(1,file=infile,status='old')
c
c   read 13 header lines
c
       read(1,'(a)') text
       read(1,'(22x,a4)') stat(1)(1:4)
       stat(1)(5:5)=' '
       read(1,'(a)') text
       read(1,'(a)') text
       read(1,'(15x,i2,1x,i2,1x,i4)') day(1),month(1),year(1)
       read(1,'(15x,i2,1x,i2,1x,f6.6)') hour(1),min(1),sec(1)
       read(1,'(13x,i3)') i
       rate(1)=i
       do i=1,6
           read(1,'(a)') text
       enddo
       write(6,*) year(1),month(1),day(1),hour(1),min(1),sec(1)
c
c   read to end of file always assume 3 channels
c
       i=0

 555   continue
       i=i+1
       read(1,*,end=556) data1(i),data2(i),data3(i)
       goto 555
 556   continue
       nsamp(1)=i

       nchan=3

       write(6,*) 'nchan=',nchan,'   nsamp=',nsamp(1),'   rate',rate(1)
c
c  enter loop to define header info
c
       cbyte(1)='4'
       do ichan=1,nchan
c
c   first put in defaults in case no def file
c
          
            stat(ichan)=stat(1)
           
            if(ichan.eq.1) comp(ichan)='S  Z'
            if(ichan.eq.2) comp(ichan)='S  N'
            if(ichan.eq.3) comp(ichan)='S  E'

c
c   assume same start and stop time and sample rate for all channels
c            
         year(ichan)=year(1)
         month(ichan)=month(1)
         day(ichan)=day(1)
         hour(ichan)=hour(1)
         min(ichan)=min(1)
         sec(ichan)=sec(1)
         rate(ichan)=rate(1)
         cbyte(ichan)='4'
         nsamp(ichan)=nsamp(1)
c
         write(6,'(1x,a5,i4,4i3,f7.1)') stat(ichan),
     *   year(ichan),month(ichan),
     *   day(ichan),hour(ichan),min(ichan),sec(ichan)
       enddo
c
c   look for values in def file
c
       do i=1,nchan
         call set_def_chan(i,stat(i),comp(i)) 
       enddo

c
c   make seisan headers
c
      ichan=1
      if (no_net) net_code=stat(1)(1:5)
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,
     *                 stat,comp,nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
      write(6,'(a22,a40)')' Output file name is: ',outfile(1:40)
      open(2,file=outfile,status='unknown',form='unformatted')	  
      mainhead(1)(2:29)=mainhead_text
c
c   write main header
c
      write(6,'(1x,a)') mainhead(1)(1:75)
      do i=1,12
         write(2)mainhead(i)
      enddo
C
C   enter channel  loop
c
      do ichan=1,nchan
c
c   make channel header	
c
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,
     *                 stat,comp,nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c                                                                               
c   get response            
c                                                                                                                
        call read_resp_head(chahead)

        write(2)chahead
        write(6,'(1x,a)') chahead(1:70)
        if(ichan.eq.1) write(2) (data1(i),i=1,nsamp(ichan))
        if(ichan.eq.2) write(2) (data2(i),i=1,nsamp(ichan))
        if(ichan.eq.3) write(2) (data3(i),i=1,nsamp(ichan))

c   end of channels loop
c
      enddo
      write(6,*)
      close(2)
c
c  back for next file if many
c
      if (in.eq.1) goto 1000                                                               
      goto 19
      stop
      end	   	  	  	         	  	  
								  

c   Signal and spectral processing routines. This colllection of routines were
c   put together january, 2001 by gneralizing earlier routines belonging to
c   mulplt, spec and qlg


c     spec_select: select a time window of digitial data acording to given
c                  phase etc
c
c     smooth     : smoothing of a signal, usully a spectrum
c
c     remove_resp: correct a time signal for response
c
c     prepare    : prepare signal for spectral analysis, taper
c
c     spectrum   : make the complex spectrum
c
c     precoh1    : predicted coherence method for 3-comp analysis
c
c     cross      : corss correlaiton
c
c     rotate_comp: component rotation
c
c     spec_values: get corrected spectral levels at given frequencies
c
c     check_clipped: check if signal is clipped
c
c     applytaper: taper signal
c
c
c
c  updates:
c
c 01.02.2001 lo : change in spec_value, dont modify input signal
c 11.03.2001 lo : add ipow to the arguments of spev_values
c 22.06.2001 lo : free dimension of buff in smooth
c 15.08.2008 lo : add applytaper routine
c
c-----------------------------------------------------------------------------

      subroutine spec_select(data,nhead,nrecord,rotate,
     *           station,component,
     *           sel_crit,start,tstart,t0,nsamp,error,
     *           err_text)           
c
c                                                                               
c                                                                               
c   selects data for spectral analysis. Given a station and compoenent,
c   the chennel is selected from the waveform file and the time of the first
c   sample to use is calculated from start criterias and the header
c   time in the waveform file
c   the routine assumes that the general waveform reading routines are used
c
c   input:  data     : nordic
c           nhead    : number of headers
c           nrecord  : number of records
c           rotate   : rotate or not
c           station  : station to use
c           component: Component to use
c           nhead    : number of headers in Noridc file
c           nrecord  : number of records in --------
c           sel_crit: 1: ptime, 2: stime, 3: S from P time, 4: abs start
c           start:    start time from origin time in units of                   
c                     p or s-travel times, if sel_crit is 4, in secs                     
c
c   output:                            
c           tstart:   time of first sample in window relative to start          
c                     of waveform data file data trace       
c           t0:       time of origin relative to first sample in wav. file
c                     data trace
c           nsamp:    number of points in selected trace                                 
c           rate:     samples pr sec                                            
c           error:    number of errors found, should be zero                    
c           err_text  text of error
c                                                                               
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      character*80 data(1)
      integer nhead,nrecord
      logical rotate
      character*80 err_text
c-- trace file name                                
      character*80 trace_file
      integer nfile
      integer sel_crit
      real baz(max_trace)  ! back azimuth angles each trace
c-- station code                                  
      character*5  station,sta
      integer plotoption
c-- component                                           
      character*4  component			
c-- phase                                               
      character*1  phasex		
c-- see above                             
      real start,tstart    
c-- start of window relative origin time                                            
      real win_start
c-- number of channels in w-file          
      integer nchan                     
c-- number of samples in one channel      
      integer nsamp                     
c-- 1: test output, 0: no output                            
      integer check			
c-- origin date                                  
      integer oyear,omonth,oday		
c-- origin time                                         
      integer ohour,omin		
c-- origin time                                              
      real    osec			
c-- origin time relative time of first sample
      real t0
c-- phase time                                               
      integer phahour,phamin		
c-- -----                                 
      real    phasec                      
c-- abs times                            
      double precision phatime,wtime,otime	
c-- error variables                                     
      integer error		
c-- channel number to select                                 
      integer chan		
c-- directory separater char
      character*1 dchar	
c-- help variables                                
      integer	i,k,seiclen
      error=0                                                                   
      check=0
      call dir_char(dchar)                                                                   
c                                                                               
c   read origin time                                           
c                                                                               
      read(data(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)')                               
     *oyear,omonth,oday,ohour,omin,osec                                         
c                                                                               
c   get absolute origin time in secs                                            
c                                                                               
      call timsec(oyear,omonth,oday,ohour,omin,osec,otime)                      
c                                                                               
c   find station and  p-phase if so required                                                
c                                              
      if(sel_crit.eq.1.or.sel_crit.eq.3) then                                 
         do i=nhead+1,nrecord
            read(data(i),'(1x,a5,4x,a1)') sta,phasex                                                              
            if(sta.eq.station.and.phasex.eq.'P') go to  6                           
         enddo           
      endif                                                     
c                                                                               
c   find station and s-phase if so required                                                
c                                              
      if(sel_crit.eq.2) then                                 
         do i=nhead+1,nrecord
            read(data(i),'(1x,a5,4x,a1)') sta,phasex                                                              
            if(sta.eq.station.and.phasex.eq.'S') go to  6                           
         enddo                                                                
      endif
c                                                                               
c   find only station if abs time is used                                      
c                                              
      if(sel_crit.eq.4) then                                 
         do i=nhead+1,nrecord
            read(data(i),'(1x,a5,4x,a1)') sta,phasex                           
            if(sta.eq.station) go to  6                           
         enddo
c
c   no station was found, can still continue if station in waveform file
c
           goto 7                                                                
      endif
c
c  if here, data not found, write error message
c
      if(sel_crit.eq.1.or.sel_crit.eq.3)
     *write(err_text,200) station,data(1)(1:20)
 200  format(' P for station ',a5,' not found for event ',a20)                  
      if(sel_crit.eq.2) write(err_text,210) station,data(1)(1:20)                                      
 210  format(' S for station ',a5,' not found for event ',a20)                  
      if(sel_crit.eq.4) write(err_text,220) station,data(1)(1:20)                                      
 220  format(' Station ',a5,' not found for event ',a20)                  
      error=error+1                                                             
      return                                                                    
c                                                                               
c   station or (station and phase) found, now read it                                      
c                                                                               
 6    continue                                                                  
      read(data(i),'(1x,a5,4x,a1,7x,2i2,f6.1)')                                
     *sta,phasex,phahour,phamin,phasec
c
 7    continue
c
c   calculate time from origin to start of data window
c
      if(sel_crit.eq.4) then              ! abs time not related to any phase
         win_start=start
      endif
c
      if(sel_crit.eq.1.or.sel_crit.eq.2.or.sel_crit.eq.3) then
c                                                                               
c   calculate abs phase time                                                         
c                                                                               
         call timsec(oyear,omonth,oday,phahour,phamin,phasec,phatime)
c                                                                               
c   calculate start from origin                                         
c      
         phatime=phatime-otime
         if(sel_crit.eq.3) then           ! calculate s time from p time                                                                         
            phatime=phatime*1.78                                
         endif
c
c   phatime is now start time of window from origin time, now multiply
c   by factor to give number of start times or just move it a bit
c
         win_start=phatime*start            
      endif
c                                                                               
c   get trace data file names                                                  
c               
      call auto_tr(data,nhead,nfile,wav_filename)
c
c   check if ifles exist and where
c
       k=0
       do i=1,nfile
          call  get_full_wav_name(wav_filename(i),trace_file)
          if(trace_file.eq.' ') then
              write(6,'(1x,a,a)') ' No such file: ',
     *        wav_filename(i)(1:seiclen(wav_filename(i)))
         else
            k=k+1
            wav_filename(k)=trace_file
         endif
       enddo
       nfile=k
c     write(6,*) nfile
c
c   check if any name given
c
      if(nfile.eq.0) then
         write(err_text,'(a,a)')
     * ' No waveform file given for event', data(1)(1:20)
         error=error+1
         return
      endif
c                                                                               
c   initialize waveform file info
c
      call wav_init

c          
c   read all header information from all files
c          
       wav_nfiles=k
       do i=1,wav_nfiles
          call read_wav_header(i)
       enddo
c       write(6,'(a,a)')' Read headers from files:'
c       do i=1,wav_nfiles
c          write(6,'(1x,a)') wav_filename(i)(1:80)
c       enddo

c                                                                               
c   find channel number corresponding to station and                            
c   component, also get header time                                
c            
      call wav_find_chan(station,component,chan)
         if(chan.eq.0) then
         error=error+1                                                          
         write(err_text,'(a,a,a)')
     *   ' Station and component not found in trace file  ',
     *   station,component
         return
      endif                                                                     
c
c   if rotate, find back azimuths, read and rotate
c   else just read channel
c
      wav_out_start(1)=wav_delay(chan)   ! normally no delay
      if(rotate) then
          call get_baz(wav_nchan,wav_stat,data,nhead,nrecord,baz)
          call wav_read_2channel(chan)  ! read 2 channels
          nsamp=wav_out_duration(1)*wav_rate(chan)+1
          if(wav_comp(chan)(4:4).eq.'N') wav_rot_comp(chan)='R'
          if(wav_comp(chan)(4:4).eq.'E') wav_rot_comp(chan)='T'
          call rotate_comp(nsamp,
     *    wav_out_first_sample(wav_current_chan(2)),
     *    wav_out_first_sample(wav_current_chan(3)),
     *    wav_rot_comp(chan),
     *    baz(chan),signal1,signal2,signal3)  ! rotated signal now in signal1
      else
c        write(*,*) wav_year(chan),wav_month(chan),wav_day(chan),
c     &    wav_hour(chan),wav_min(chan),wav_stat(chan),wav_comp(chan)
c commented out by mistake in 8.1.1 lot
          call wav_read_channel(chan)
          nsamp=wav_nsamp(chan)
      endif
c

c                                                                               
c  get abs trace file start time                                                
c                                    
       wtime=wav_abs_time(chan)+wav_out_start(1)-wav_delay(chan)
c                                                                               
c   calculate start time for window relative to first                      
c   sample in trace data                                                        
c                                                                               
      tstart=win_start-(wtime-otime)                                           
c                                                                               
c   extract origin time t0 relative to time of first sample                     
c                                                                               
      t0=otime-wtime                          
c
c   if abs time, correct
c
      if(sel_crit.eq.4) then
         tstart=start
c lot 2005
c        t0=0.0
      endif
c                                                                               
c   close trace data file                                                       
c                                                                               
c                                                                               
      return                                                                    
      end                                                                       
                                                                                
                                                                                
                                                                                
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC        
C                                                                               
      SUBROUTINE SMOOTH(BUFF,JJ,ISMO)                                           
C                                                                               
C     BUFF  = BUFFER TO BE SMOOTHED --  DIMENSION : BUFF(JJ)                    
C     ISMO  = NUMBER OF PASSES                                                  
C                                                                               
c      DIMENSION BUFF(1)                                                         
      DIMENSION BUFF(*)                                                         
C                                                                               
      IF(ISMO.LE.0)     RETURN                                                  
C                                                                               
      DO 50  IS=1,ISMO                                                          
C                                                                               
      J1=JJ-1                                                                   
      A=.54*BUFF(1)+.46*BUFF(2)                                                 
      B=.54*BUFF(JJ)+.46*BUFF(J1)                                               
      SJ=BUFF(1)                                                                
      SK=BUFF(2)                                                                
C                                                                               
      DO 10  J=2,J1                                                             
      SI=SJ                                                                     
      SJ=SK                                                                     
      SK=BUFF(J+1)                                                              
   10 BUFF(J)=.54*SJ+.23*(SI+SK)                                                
C                                                                               
      BUFF(1)=A                                                                 
      BUFF(JJ)=B                                                                
C                                                                               
   50 CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       



      subroutine remove_resp(y,y_com,nsamp,rate,disp_vel,
     *f_low,f_high,pole_low,pole_high)
c                                                                               
c     Routine to remove instrument response from a trace. The response
c     informaiton is suppose to already have been read in and available
c     in the waveform common block, has to be checked outside this routine
c
c     The trace is restored to nm, nm/s, or nm/s*s
c
c     input:  y           : data vector
c             nsamp       : number of samples in data vector
c             rate        : sample rate
c             disp_vel    : displacement ,velocity or acceelration out (1-3)
c             f_low,_high _ filter limits
c             pole_low,pole_high: poles of filters
c     output  Y           : corrected signal
c             y_com       : complex equivalent, only there to use external
c                           memory definition
c                                                                               
c     Written by C. Lindholm Jan. -90, substantially changed by jh                                           
c
c-- common block         
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'

      real y(*)
c-- percentage of tapering (fixed)                       
      real taper/10./				
c-- length of input vector                                 
      integer nsamp				
c-- length after padding                                    
      integer ipow				
c-- vector padded with npad zeros                           
      integer npad				
c-- Fixed to 1 for system rem.                        
      integer rem_resp/1/			                       
c-- counters,etc                                               
      integer i,j
      real f_low,f_high            ! added filter to use
      integer pole_low,pole_high   ! -------------------
      real rate                    ! sample rate
      integer disp_vel             ! displacemnt, velocity or acceleration
      complex y_com(*)
      double precision ttime

      ttime=0.
c                                                                               
c------- prepare data.     Pad with zeros and taper 10%.                        
c                                                                               
      call prepare(nsamp,y,taper,ipow,npad,y_com)
c
c-------- Calculate the spectrum, and remove the system response
c         q, qzero, kappa and travel time set to zero 
c
      call spectrum(y_com,ipow,disp_vel,rem_resp,rate,
     +     f_low,f_high,pole_low,pole_high,0.0,0.0,
     *     0.0,ttime)
c                                                                               
c-------Do inverse FFT -------                                                  
c                                                                               
      j = ipow                                                                  
      do i = 1,20                                                               
        j = j/2                                                                 
          if (j .eq. 1)then                                                     
            j = i                                                               
            go to 222                                                           
          endif                                                                 
      enddo                                                                     
222   continue                                                                  
                                                                                
      call fft(j,1.,y_com)                                                        
c                                                                               
c------Normalize                     
c                                                                               
      do i=1,nsamp                                                               
        y(i) = (1./real(ipow)) * real(y_com(i))                                   
      enddo                                      
      return
      end                                                                       
                                                                                
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc           
      subroutine prepare(nsamp,y,taper,ipow,npad,y_com)                        
c                                                                               
c     Subroutine to pad data with zeros up to a number that is power of 2,      
c     and to taper the data.                                                    
c     Returned is the complex vector with the data prepared for FFT             
c                                                                               
c     Written by C. Lindholm Jan -90
c     jan 2001, jh: Put all input output in call
c                                                                               
c     input:   nsamp        Samples in data vector
c              y            Data vector
c     output:  npad         Number of zeros added                               
c              ipow         Length of new data vector
c              y_com        Complex data vector
c
      implicit none
c-- percentage of tapering                                    
      real taper				
      real pi/3.1415972/
      real y(*)
      complex y_com(*)
c-- dummy variable                                             
      real arg					
c-- number of samples to taper                              
      integer ntap				
      integer nsamp                                                             
c-- max = 2**20                                             
      integer ipow				
      integer npad                                                              
c-- counters                                               
      integer i				
c-- used in dc-removal                                    
      integer ndc
      real dc				
                                                                                
c                                                                               
c---------- Remove dc ------                                                    
c                                                                               
      ndc = 0                                                                   
      call remove_dc(y,ndc,dc,nsamp)                                         
c                                                                               
c-------Taper if wanted ------                                                  
c                                                                               
      if (taper .gt. 0.0) then                                                  
        call applytaper(y,nsamp,taper)
c        ntap = (nsamp/2) * (taper/100)                                          
c        arg = pi / 2 / ntap                                                     
c        do i = 1,ntap                                                           
c         y(i) = y(i) * sin((i-1) * arg)                                   
c         y(nsamp-i+1) = y(nsamp-i+1) * sin((i-1) * arg)                   
c        enddo                                                                   
      endif                                                                     
c                                                                               
c-------Now pad with zeros -------                                              
c                                                                               
      ipow = 1                                                                  
      do i = 1,20				                                                           
          ipow = ipow*2                                                            
       if(ipow .ge. nsamp) go to 10                                             
      enddo                                                                     
10    continue                                                                  
                                                                                
      npad = ipow - nsamp                                                       
c                                                                               
c-------fill complex vector                                                     
c                                                                               
      do i = 1,ipow                                                             
        if(i .le. nsamp)then                                                    
          y_com(i) = cmplx(y(i),0.0)                                           
        else                                                                    
          y_com(i) = cmplx(0.0,0.0)                                               
          y(i) = 0.0                                                         
        endif                                                                   
      enddo                                                                     
                                                                                
      return                                                                    
      end                                                                       

      subroutine applytaper(y,nsamp,taper)
c
c apply sine taper, originally in subroutine prepare
c
      implicit none
      real y(*)
      real taper     ! per cent 
      integer nsamp,i,ntap
      real pi,arg

      pi=acos(-1.)

      ntap = (nsamp/2) * (taper/100)
      arg = pi / 2 / (ntap-1)
      do i = 1,ntap
         y(i) = y(i) * sin((i-1) * arg)
         y(nsamp-i+1) = y(nsamp-i+1) * sin((i-1) * arg)
      enddo
      return
      end
                                                                                


      subroutine spectrum(y_com,ipow,disp_vel,rem_resp,srate,
     +     f_low,f_high,pole_low,pole_high,q0,qalpha,
     *     kappa,travel_time)
c
c     Routine to do the FFT and to remove instrument response
c     from the data. 
c
c     Written by C. Lindholm Jan. -90
c
c     updates:
c     oct 19, 90 by j.h. : fix all kinds of spectra
c     nov 1   90    j.h. : add q correction
c     jul 93        jh   : remove assumption that response cureves for
c                          accellerometers is g, now assume m
c     jan 2001      jh   : all data through window, no reference to mulplt.inc
c
c     input:      y_com       Complex vector with data in real part
c                 ipow        Length of complex vector
c                 disp_vel    response: 1 = displacement
c                                       2 = velocity
c                                       3 = acceleration
c                 rem_resp    Switch to remove or not remove response.
c                                       1 = remove response
c                 srate       Sampling rate
c                 f_low,f_high,pole_low,pole_high: frequecy and poles for filter
c                 q,qalpha  : Q
c                 travel_time: travel time needed for q-correction, to start
c                             window
c                 kappa     : near surface term
c        
c     
c     output:     y_com
c                 ipow
c
      implicit none
      complex y_com(*)                          ! data vector
      real f_low,f_high                         ! filter band
      integer pole_low,pole_high                ! filter poles
      real q0,qalpha                            ! q
      integer disp_vel                          ! kind of spectrum
c      real travel_time   ! before 10 May, 2001
      double precision travel_time              ! changed lo, 10 may 2001
      real kappa                                ! kappa
      complex hs                                ! help variable
      complex respons				! complex respons
      real freq					! frequency corresp. to spectrum
      real srate
      real delta				! 1. / srate
      real xx					! dummy variabel
      real pi/3.1415972/
      integer ipow
      integer iresp				! power factor for response type
      integer rem_resp
      integer i,inv,j				! counter
      integer spstart,spstop			! bounds for spectr. counter

      delta = 1. / srate

c
c   it is assumed that all response curves are in displacement, also
c   for accelerometers
c
         iresp=disp_vel-1               

c
c------- Do FFT -------
c
      j = ipow
      do i = 1,20
        j = j/2
          if (j .eq. 1)then
            j = i
            go to 222
          endif
      enddo
222   continue
      call fft(j,-1.,y_com)
c
c--------Remove response------
c
      spstart = 2
      spstop = ((ipow/2) + 1)

      if(rem_resp .eq. 1) then
        xx = ipow*delta
        do i = spstart,spstop
         freq = (i-1)/xx
c
c-------Butterworth filter ---------------------
c
         if((f_low.gt.0.0.and.pole_low. gt.0).or.(
     *      f_high.gt.0.0.and.pole_high.gt.0)) then
               if(f_low.gt.0.0.and.pole_low.gt.0) then
                  call bworth(freq,f_low,-pole_low,hs) 
                  y_com(i) = y_com(i) * hs
               endif
               if(f_high.gt.0.and.pole_high.gt.0) then
                   call bworth(freq,f_high,pole_high,hs) 
                   y_com(i) = y_com(i) * hs
               endif
               inv = ipow - i + 2
                y_com(inv) = conjg (y_com(i))
         endif
c
c--------Q--------------------------------------
c
         if(q0.gt.0) then
           y_com(i)=y_com(i)*exp(pi*freq*travel_time/(q0*freq**qalpha))
         endif
c
c   correct for kappa
c
          if(kappa.gt.0) then
             y_com(i)=y_com(i)*exp(pi*freq*kappa)
          endif

c
c-------- Calculate the response, it is assumed that the response parameters
c         for the current channel has already been read in and available
c         in resonse common block
c
           call calc_resp(freq,respons)
c
c-------Now correct spectrum -----------
c
           hs=(0,1)*(2*pi*freq)
           y_com(i) = (y_com(i) / respons ) *hs**iresp
           inv = ipow - i + 2
           y_com(inv) = conjg (y_com(i))
        enddo				! end of loop
      endif				! end of response removed

      return
      end




      SUBROUTINE PRECOH1(Z,MPTS,IPTS,LPTS,PVEL,COHER,
     *AZIM,VELO,RMSAMP)
      REAL Z(MPTS,3)
      real dc(3)
C
C  S/R TO DO 3-COMPONENT AZIMUTH AND VELOCITY ESTIMATION FOR A P-PHASE
C  FOR A FIXED USER SPECIFIED TIME WINDOW.
C  METHOD: PREDICTED COHERENCE (R. ROBERTS, UPPSALA)
c 
c  jan 94 add remove dc
C
C  INPUT:
C     Z(MPTS,3) - DATA MATRIX
C                 Z(*,1) - VERTICAL CHANNEL (POSITIVE DIRECTION UP)
C                 Z(*,2) - NORTH CHANNEL
C                 Z(*,3) - EAST CHANNEL
C     MPTS      - USED FOR DIMENSIONING OF DATA MATRIX
C     IPTS      - FIRST SAMPLE IN TIME INTERVAL
C     LPTS      - LAST SAMPLE IN TIME INTERVAL
C     PVEL      - LOCAL P-WAVE VELOCITY AT SITE
C
C  OUTPUT:
C     COHER     - PREDICTED COHERENCE, SHOULD BE POSITIVE AND
C                 LARGER THAN ABOUT 0.1 FOR A P-PHASE
C     AZIM      - P-PHASE AZIMUTH (TOWARDS EVENT) IN DEGREES
C     VELO      - P-WAVE APPARENT VELOCITY IN KM/SEC
C     RMSAMP    - ROOT MEAN SQUARE AMPLITUDE
C
C  NOTE: IF COHER IS LESS THAN ABOUT 0.1 AZIMUTH AND VELOCITY ESTIMATE SHOULD
C        NOT BE USED   
C
      DATA RADDEG/57.2958/
      DATA PSRAT/1.73/   
c
c   remove dc
c
      do i=1,3
        dc(i)=0.0
      enddo
      do i=ipts,lpts
         do k=1,3
            dc(k)=dc(k)+z(i,k)
         enddo
      enddo
      do i=1,3
        dc(i)=dc(i)/(lpts-ipts+1)
        do k=ipts,lpts
          z(k,i)=z(k,i)-dc(i)
        enddo
      enddo
C
C  MODEL 8 - P WAVES ONLY
C  CALCULATE THE AUTO AND CROSS CORRELATIONS
C
      LENWIN=LPTS-IPTS+1
      CALL CROSS(Z(IPTS,2),Z(IPTS,2),LENWIN,XX)
      CALL CROSS(Z(IPTS,2),Z(IPTS,3),LENWIN,XY)
      CALL CROSS(Z(IPTS,2),Z(IPTS,1),LENWIN,XZ)
      CALL CROSS(Z(IPTS,3),Z(IPTS,3),LENWIN,YY)
      CALL CROSS(Z(IPTS,3),Z(IPTS,1),LENWIN,YZ)
      CALL CROSS(Z(IPTS,1),Z(IPTS,1),LENWIN,ZZ)
      YX=XY
      ZX=XZ
      ZY=YZ
      POWER=(XX+YY+ZZ)/LENWIN
      RMSAMP = SQRT(POWER)
C
C  CALCULATE AZIMUTH AND VERTICAL/RADIAL AMPLITUDE RATIO
C
      AZI=ATAN2(-YZ,-XZ)
      AZIM=AZI*RADDEG
      IF(AZIM.LT.0.) AZIM = AZIM + 360.
      ZOVERR=ZZ/SQRT(XZ*XZ+YZ*YZ)
      A=-ZOVERR*COS(AZI)
      B=-ZOVERR*SIN(AZI)
c     A=ZOVERR*COS(AZI)
c     B=ZOVERR*SIN(AZI)
c     write(6,*)'a,b,',a,b
C
C  CALCULATE PREDICTED COHERENCE
C
      ERR=0.
c     write(6,*) ipts,lpts
      DO 50 II=IPTS,LPTS
        CC=Z(II,1)-A*Z(II,2)-B*Z(II,3)
        ERR=ERR+CC*CC
 50   CONTINUE
      COHER=1.-ERR/ZZ
C
C  SIMPLE BIASED VELOCITY ESTIMATION (TO OBTAIN AN UNBIASED ESTIMATE
C  ONE NEED TO KNOW THE NOISE AMPLITUDE)
C
      SVEL=PVEL/PSRAT
      AI=ATAN(1./ZOVERR)
      VELO=SVEL/SIN(AI/2.)
C
      RETURN
      END


      SUBROUTINE CROSS(X,Y,L,A)
C-----------------------------------------------------------------------
C CALCULATES UNNORMALISED CROSS CORRELATION BETWEEN THE TWO
C REAL TIME SERIES X AND Y OF LENGTH L.
C THE RESULT IS RETURNED IN A.
C-----------------------------------------------------------------------
      DIMENSION X(L),Y(L)
      A=0.
      DO 1 I=1,L
        A=A+X(I)*Y(I)
 1    CONTINUE
      RETURN
      END


      subroutine rotate_comp(nsamp,start1,start2,
     *component,backazi,y1,y2,y3)
c
c   rotates the signal in y2(ns) and y3(ew), the result is put
c   variable y1. The output component must be specifed as T or R. Rotation
c   is done on nsamp samples starting from the first sample first1 and first2
c   in input arrays and starting with first sample in output array.
c   backazi is the backazimuth

      implicit none
      real y1(*),y2(*),y3(*)
      real backazi,caz,saz
      integer i,start1,start2,nsamp
      character*1 component
c
c   rotation parameters
c
      caz = -cos(backazi*3.14159/180.)
      saz = -sin(backazi*3.14159/180.)

      if(component.eq.'R') then
         do i=1,nsamp
            y1(i) = caz*y2(i+start1-1) + saz*y3(i+start2-1)  ! radial component
         enddo
      endif
c
      if(component.eq.'T') then
         do i=1,nsamp
           y1(i) = -saz*y2(i+start1-1) + caz*y3(i+start2-1)  ! transverse comp.
         enddo
      endif
c
      return
      end



      subroutine spec_value(current,sig,nsamp,nsmooth,f_low,
     &  f_high,disp_vel,farray,nfreq,write1,level,y_com,ipow)

c
c subroutine to take out spectral level at given frequencies
c lo 2000
c
c genralized by jh jan 2001
c 
c input:  current - current channel ID
c         sig     - input time signal
c         nsamp   - number of samples
c         f_low,f_high - frequency limits for spectrum
c         farray  - frequency value array
c         nfreq   - 
c         write1  - output unit, 0 if none
c
c output: level   - spectral amplitude levels, averaged around frequencies
c                   given in farray
c         y_com   - complex spectrum
c         ipow    - spectral values in y_com between 2 and (ipow/2+1)
c         
c changes
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      include 'waveform.inc'
 
      integer i,j,b,c         ! counters
      integer current         ! current trace number
      integer nsamp           ! number of samples in signal
      real sig(*)             ! the signal, time domain
      real y(max_sample)      ! the signal
      complex y_com(*)        ! complex spectrum
      real f_low,f_high       ! low and high limit for spactrum
      integer disp_vel
      integer nfreq           ! number of frequencies in farray
      integer n(max_sample)   ! counters
      real farray(*)          ! array with selected frequencies
      real level(*)           ! spectral level atfrequencies given in farray
      integer write1          ! output unit, 0 for no output

      integer npad            ! vector padded with npad zeros
      integer ipow            ! length after padding
      real ff                 ! frequency
      real taper/5./          ! percentage of tapering (fixed)
      integer rem_resp        ! 1 if remove
      integer nsmooth         ! number of times to smooth
      real fdelta             ! width for averaging of spectra around 
                              ! selected frequencies
      real window             ! time length of window
      real level_next_f(max_sample)  ! level at next f outside desired f window
      double precision ttime

      i=current
c      nsmooth=5
cjh      disp_vel=1
      rem_resp=1
      fdelta=0.12

      do j=1,nsamp ! lo keep original signal
        y(j)=sig(j)
      enddo

      window = nsamp / wav_rate(i)

c
c------- prepare data.     Pad with zeros and taper 10%.
c
      call prepare(nsamp,y,taper,ipow,npad,y_com)

c
c remove response and get spectrum, no q or kappa correction,
c no filters
c
      ttime=0.
      call spectrum(y_com,ipow,disp_vel,rem_resp,wav_rate(i),
     +          0.,0.,0,0,0.,0.,0.,ttime)

c
c   calculate real spectrum, limit to frequencies ffmin and ffmax
c
      c = 0
      do b = 2,((ipow/2) + 1)
       ff = (b-1)*wav_rate(i)/ipow
       if(ff .ge.f_low.and. ff .le. f_high) then
         c = c + 1
         y(c) = ((1/wav_rate(i))**2)*(y_com(b)*conjg(y_com(b)))
         y(c) = sqrt(y(c))         
       endif
      enddo
c
c   smooth
c
c      call smooth(y,c,nsmooth)

c
c now extract values from spectrum
c
      do j=1,nfreq
        level(j)=0.
        level_next_f(j)=-1.
        n(j)=0
      enddo

      c = 0
      do b = 2,((ipow/2) + 1)
       ff = (b-1)*wav_rate(i)/ipow
       if(ff .ge.f_low.and. ff .le. f_high)then
         c = c + 1
         if (write1.ne.0) write(write1,'(f10.3,1x,f15.7)') ff,y(c)
         do j=1,nfreq
           if (ff.ge.farray(j)-fdelta*ff.and.
     &       ff.le.farray(j)+fdelta*ff) then
c           if (ff.ge.farray(j)-sqrt(ff*fdelta*wav_rate(i)/ipow).and.
c     &       ff.le.farray(j)+sqrt(ff*fdelta*wav_rate(i)/ipow)) then
                level(j)=level(j)+y(c)
                n(j) = n(j) + 1
           elseif (ff.gt.farray(j)+fdelta*ff.and.level_next_f(j).eq.-1.) 
     &     then
             level_next_f(j) = y(c)
           endif
         enddo
       endif
      enddo
      if (write1.ne.0) write(write1,'(a1)') '>'

c
c average levels around center frequency
c
      do j=1,nfreq
        if (n(j).gt.0) then
          level(j)=level(j)/float(n(j))
c
c take level at next frequency
c
        else
          level(j)=level_next_f(j)
        endif
      enddo
  
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine check_clipped(x,nsamp,clipped)
c
c routine to check if signal is clipped, which is if the max amplitude is 
c reapeated more than 25 times
c
c input:  x       - time series
c         nsamp   - number of samples in x
c output: clipped - true if signal is clipped
c

      implicit none
      real x(*)                         ! data
      integer nsamp,i,max_cnt           ! number of samples, counters
      real max                          ! max value
      logical clipped                   ! flag to show that signal is clipped

      max=0.
      max_cnt=0.
      clipped=.false.
      do i=1,nsamp
        if (abs(x(i)).gt.max) then
          max=abs(x(i)) 
        endif
      enddo
      do i=1,nsamp
        if (abs(x(i)).gt.max*.99) then
          max_cnt=max_cnt+1
        endif
      enddo
c
c if the max amplitude appears several times, the signal is considered
c to be clipped
c

c
c changed to 10, 13 March 2001, lo
c
      if (max_cnt.ge.100) then
        clipped=.true.
      endif

      return
      end

      real function crosscorr(y1,y2,nsamp,mode)
c
c Lars Ottemoller, 06/03/2008
c
c compute cross-correlation of signals y1 and y2, both
c of length nsamp, cross-correlation output in yout, mode see below
c
c mode 1: 
c              sum (y1(i)-y1_mean) * (y2(i)-y2_mean)
c   yout = -------------------------------------------------
c          sqrt (sum (y1(i)-y1_mean)^2 * (y2(i)-y2_mean)^2 )
c
      implicit none
      include 'seidim.inc'
      real y1(*),y2(*)        ! data vectors
      real yout               ! cc output
      double precision a1,a2  ! dc of the two data vectors
      integer nsamp           ! number of samples
      integer mode            ! operation mode
      real n1,n2              ! auto correlations
      integer i

      a1=0.
      a2=0.
c get mean (a1,a2) of both signals
      do i=1,nsamp
        a1=a1+y1(i)
        a2=a2+y1(i)
      enddo
      a1=a1/float(nsamp)
      a2=a2/float(nsamp)
c remove mean and calculate yout
      yout=0.
      n1=0.
      n2=0.
      do i=1,nsamp
        n1 = n1 + (y1(i)-a1)**2
        n2 = n2 + (y2(i)-a2)**2
        yout = yout + (y1(i)-a1) * (y2(i)-a2) 
      enddo
c normalize
      yout=yout/sqrt(n1*n2)
      crosscorr=yout
      return 
      end

      subroutine cor_time(y1,nsamp1,y2,nsamp2,cc,nsampcc)
c
c Lars Ottemoller, 06/03/2008
c
c compute cross-correlation in time domain 
c
      implicit none
      include 'seidim.inc'
      real y1(*),y2(*),cc(*)
      real y1work(max_sample),y2work(max_sample)
      integer mode
      integer nsamp1,nsamp2,nsampcc,nsamps,nsampl
      integer i,k,n
      real crosscorr

      mode=1 ! cross correlation normalized with 
c              sqrt of both auto-correlation functions

c
c set nsamp to larger of the two samples 
c y1work is used for shorter data vector
c
      if (nsamp1.ge.nsamp2) then
        nsampl=nsamp1 
        nsamps=nsamp2 
        do i=1,nsamp2
          y1work(i)=y2(i)
        enddo
      else
        nsampl=nsamp2 
        nsamps=nsamp1 
        do i=1,nsamp1
          y1work(i)=y1(i)
        enddo
      endif

c compute correlation function
      do i=1,nsampl
        n=0
        do k=i,i-1+nsamps
          n=n+1
          if (nsampl.eq.nsamp2) then
            if (k.le.nsamp2) then
              y2work(n)=y2(k)
            else
              y2work(n)=0.
            endif
          else
            if (k.le.nsamp1) then
              y2work(n)=y1(k)
            else
              y2work(n)=0.
            endif
          endif
        enddo
        cc(i)=crosscorr(y1work,y2work,nsamps,mode)
      enddo
      nsampcc=nsampl
      return
      end

      subroutine cor_freq(y1,nsamp1,y2,nsamp2,yout)
c
c compute cross-correlation function
c
      implicit none
      include 'seidim.inc'
      real y1(*),y2(*),yout(*)
      real y1work(max_sample),y2work(max_sample)
      real max1,max2,option
      double precision scale,a1,a2
      integer nsamp1,nsamp2,nsampout,i,j,k,l,n,ndc,nn
      real rdc
      complex ans(2*max_sample),dummy(2*max_sample)

      scale=0.
      max1=1.
      ndc=0
      a1=0.
c
c find smallest number x=2**y > nsamp1
c
      nn=2
      do while(nn.lt.nsamp1)
        nn=nn*2
      enddo
      write(*,*) ' nn = ',nn
      do i=nsamp1+1,nn
        y1(i)=0.
      enddo
      do i=1,nn
        y1work(i)=y1(i)
      enddo
c
c get auto-correlation of first signal
c
      call correl(y1work,y1work,nn,ans,dummy)
      a1=real(ans(1))
      do i=1,n
        write(33,*) i,real(ans(i))
      enddo
      do i=1,nsamp2
c
c copy signal of length nsamp1
c
        n=0
        do k=i,i-1+nn
          n=n+1
          if (k.le.nsamp2) then
            y2work(n)=y2(k)
          else
            y2work(n)=0.
          endif
        enddo
c remove dc
        call remove_dc(y2work,ndc,rdc,nn)
        call correl(y2work,y2work,nn,ans,dummy)
        a2=real(ans(1))
        call correl(y1work,y2work,nn,ans,dummy)
c normalise so that maximum of auto-correlation is 1
        yout(i)=real(ans(1))/sqrt(a1*a2)
      enddo
      return
      end

      SUBROUTINE correl(data1,data2,n,ans,fft)
      REAL data1(*),data2(*)
      COMPLEX ans(*),fft(*)
CU    USES realft,twofft
      INTEGER i,no2,n
      call twofft(data1,data2,fft,ans,n)
      no2=n/2
      do 11 i=1,no2+1
        ans(i)=fft(i)*conjg(ans(i))/float(no2)
11    continue
      ans(1)=cmplx(real(ans(1)),real(ans(no2+1)))
      call realft(ans,n,-1)
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software K25,)5.

      SUBROUTINE realft(data,n,isign)
      INTEGER isign,n
      REAL data(*)
CU    USES four1
      INTEGER i,i1,i2,i3,i4,n2p3
      REAL c1,c2,h1i,h1r,h2i,h2r,wis,wrs
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      theta=3.141592653589793d0/dble(n/2)
      c1=0.5
      if (isign.eq.1) then
        c2=-0.5
        call four1(data,n/2,+1)
      else
        c2=0.5
        theta=-theta
      endif
      wpr=-2.0d0*sin(0.5d0*theta)**2
      wpi=sin(theta)
      wr=1.0d0+wpr
      wi=wpi
      n2p3=n+3
      do 11 i=2,n/4
        i1=2*i-1
        i2=i1+1
        i3=n2p3-i2
        i4=i3+1
        wrs=sngl(wr)
        wis=sngl(wi)
        h1r=c1*(data(i1)+data(i3))
        h1i=c1*(data(i2)-data(i4))
        h2r=-c2*(data(i2)+data(i4))
        h2i=c2*(data(i1)-data(i3))
        data(i1)=h1r+wrs*h2r-wis*h2i
        data(i2)=h1i+wrs*h2i+wis*h2r
        data(i3)=h1r-wrs*h2r+wis*h2i
        data(i4)=-h1i+wrs*h2i+wis*h2r
        wtemp=wr
        wr=wr*wpr-wi*wpi+wr
        wi=wi*wpr+wtemp*wpi+wi
11    continue
      if (isign.eq.1) then
        h1r=data(1)
        data(1)=h1r+data(2)
        data(2)=h1r-data(2)
      else
        h1r=data(1)
        data(1)=c1*(h1r+data(2))
        data(2)=c1*(h1r-data(2))
        call four1(data,n/2,-1)
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software K25,)5.

      SUBROUTINE twofft(data1,data2,fft1,fft2,n)
      INTEGER n
      REAL data1(*),data2(*)
      COMPLEX fft1(*),fft2(*)
CU    USES four1
      INTEGER j,n2
      COMPLEX h1,h2,c1,c2
      c1=cmplx(0.5,0.0)
      c2=cmplx(0.0,-0.5)
      do 11 j=1,n
        fft1(j)=cmplx(data1(j),data2(j))
11    continue
      call four1(fft1,n,1)
      fft2(1)=cmplx(aimag(fft1(1)),0.0)
      fft1(1)=cmplx(real(fft1(1)),0.0)
      n2=n+2
      do 12 j=2,n/2+1
        h1=c1*(fft1(j)+conjg(fft1(n2-j)))
        h2=c2*(fft1(j)-conjg(fft1(n2-j)))
        fft1(j)=h1
        fft1(n2-j)=conjg(h1)
        fft2(j)=h2
        fft2(n2-j)=conjg(h2)
12    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software K25,)5.
      SUBROUTINE four1(data,nn,isign)
      include 'seidim.inc'
      INTEGER isign,nn
      REAL data(4*max_sample)
      INTEGER i,istep,j,m,mmax,n
      REAL tempi,tempr
      DOUBLE PRECISION theta,wi,wpi,wpr,wr,wtemp
      n=2*nn
      j=1
      do 11 i=1,n,2
        if(j.gt.i)then
          tempr=data(j)
          tempi=data(j+1)
          data(j)=data(i)
          data(j+1)=data(i+1)
          data(i)=tempr
          data(i+1)=tempi
        endif
        m=n/2
1       if ((m.ge.2).and.(j.gt.m)) then
          j=j-m
          m=m/2
        goto 1
        endif
        j=j+m
11    continue
      mmax=2
2     if (n.gt.mmax) then
        istep=2*mmax
        theta=6.28318530717959d0/(isign*mmax)
        wpr=-2.d0*sin(0.5d0*theta)**2
        wpi=sin(theta)
        wr=1.d0
        wi=0.d0
        do 13 m=1,mmax,2
          do 12 i=m,n,istep
            j=i+mmax
            tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
            tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
            data(j)=data(i)-tempr
            data(j+1)=data(i+1)-tempi
            data(i)=data(i)+tempr
            data(i+1)=data(i+1)+tempi
12        continue
          wtemp=wr
          wr=wr*wpr-wi*wpi+wr
          wi=wi*wpr+wtemp*wpi+wi
13      continue
        mmax=istep
      goto 2
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software K25,)5.

C***********************************************************************
C                                                                    
c  nov 9 98  jh -----------verison7.0 check, no change ------------------------
c
      SUBROUTINE LSQLIN(N,X,Y,A,B,CORR,RMS)                               
C                                                                       
C  REGRESSION LINE WITH PARAMETERS A AND B
C  Y=A+BX                              
C                                                                       
      DIMENSION X(*),Y(*)
      INTRINSIC SQRT                                         
      REAL NEV
      SX=0.0                                                            
      SY=0.0                                                            
      SXY=0.0                                                           
      SXS=0.0                                                       
      DO 1 I=1,N                                                       
      SX=SX+X(I)                                                        
      SY=SY+Y(I)                                                        
      SXY=SXY+X(I)*Y(I)                                                 
      SXS=SXS+X(I)*X(I)                                                 
 1    CONTINUE                                                          
      D1=REAL(N*SXS-SX*SX)                                                   
      IF (ABS(D1).LT.10E-6) GOTO 3     
      A=REAL(SY*SXS-SX*SXY)/(D1)                                            
      B=REAL(SXY*N-SX*SY)/(D1)
      RMS=0.0               
      TEL=0.0
      WVX=0.0
      WVY=0.0
      RX=SX/REAL(N)
      RY=SY/REAL(N)                              
      DO 2 I=3,N
      TEL=TEL+(X(I)-RX)*(Y(I)-RY)
      WVX=WVX+(X(I)-RX)**2
      WVY=WVY+(Y(I)-RY)**2
      RMS=RMS+(Y(I)-A-B*X(I))**2
 2    CONTINUE
      ARG=WVX*WVY
      IF (ARG.LT.10E-6) GOTO 4
      NEV=SQRT(ARG)
      CORR=TEL/NEV
      RMS=SQRT(RMS/N)
      RETURN                       
 3    A=0.0                                      
      B=0.0  
 4    RMS=0.0                                                           
      CORR=0.0
      RETURN                                                            
      END                                                               
C
C############################################################################
C
      SUBROUTINE SDV(N,X,AV,SD)
C
C   CALCULATES STANDARD DEVIATION SD AND AVERAGE OF
C   N DATA SAMPLES X. IF N LT 10, WEIGHT IS (N-1)
C
      DIMENSION X(*)
C
      IF(N.EQ.0) RETURN
      SD=0.0
      AV=0.0
      DO 1 I=1,N
      AV=AV+X(I)
 1    CONTINUE
      AV=AV/N
      IF(N.EQ.1) RETURN
      DO 2 I=1,N
      SD=SD+(AV-X(I))*(AV-X(I))
 2    CONTINUE
      IF(N.GE.10) SD=SQRT(SD/N)
      IF(N.LT.10) SD=SQRT(SD/(N-1))
      RETURN
      END

c changes:
c
c  nov 13, 2001 jh : wrong argument to set_def_chan, check for null chars 
cv                   in stat code
c  dec 18  2002 jh : station and component check not implemented in 
c                    read_sacasc_to_seisan
c  may 8 2003 lo   : check for sacaux in reading routine
c  apr 11 2006 lot : dont set beg to 0 if negative
c  dec 2  2006 lot : new sac routines
c  oct 5  2007 lot : add byte swap for reading
c  nov 14   07 lot : add network code to read/write binary
c

      subroutine write_seisan_to_sacbin(ichan,keep_path,
     *          wav_out,eqla,eqlo,eqel,nerr)
c 
c routine to write sac file for trace of data read by  wav_read_channel
c data and header are known from the wav common block, the SAC libraries
c are required
c
c input:  ichan - channel id from Seisan WAV structure
c         keep_path - true if path remains in output file, otherwise false
c         wav_out - true if data in wav_out structure
c         eqla,eqlo,eqel - event lat, lon and elevation
c         nerr - error code given by SAC, 0 if ok
c
c Lars Ottemoeller, 11 May 2000
c

      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer seiclen         ! function to get length of string
      integer jday            ! julian day
      integer ichan           ! trace index
      logical keep_path       ! true if complete path in output file
      logical wav_out         ! true if wav_out
      integer i,j             ! counters
      real stla,stlo,stel     ! station location
      character*80 outfile    ! output file name
      character*80 infile     ! input file name
      real cmpaz,cmpinc       ! channel orientation
      real eqla,eqlo,eqel     ! event location
      integer nerr            ! sac header error code
      real data_x(1)          ! x axis data, not used if data evenly spaced
      logical set_comp        ! true if cmpaz and cmpinc set
      integer ind             ! index
      character*1 dchar       ! directory delim.
      real beg                ! begin time
      parameter (beg=0.)
      integer year,month,day,hour,min
      real sec
      character*5 stat
      character*4 comp
      character*2 network
      real rate
      integer nsamp
      real duration
      character*80 deffile
      character*5 net_code              ! network code
      character*29 mainhead_text
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)

      data_x(1) = 1

      call dir_char(dchar)
c
c   get def file for station codes, give file name
c
      deffile='sacsei.def'
c      no_net = .FALSE.
      net_code=' '

      call read_def_chan(deffile,mainhead_text,net_code)

c
c read variables
c
      if (wav_out) then
        year=wav_out_year(ichan)
        month=wav_out_month(ichan)
        day=wav_out_day(ichan)
        hour=wav_out_hour(ichan)
        min=wav_out_min(ichan)
        sec=wav_out_sec(ichan)
        stat=wav_stat(wav_out_chan(ichan))
        comp=wav_comp(wav_out_chan(ichan))
        network=wav_network(wav_out_chan(ichan))
        infile = wav_filename(wav_file_nr_chan
     *                       (wav_out_chan(ichan)))
        nsamp=wav_out_nsamp(ichan)
        rate=wav_out_rate(ichan)
        duration=wav_out_duration(ichan)
      else
        year=wav_year(ichan)
        month=wav_month(ichan)
        day=wav_day(ichan)
        hour=wav_hour(ichan)
        min=wav_min(ichan)
        sec=wav_sec(ichan)
        stat=wav_stat(ichan)
        comp=wav_comp(ichan)
        network=wav_network(ichan)
        infile = wav_filename(wav_file_nr_chan(ichan))
        nsamp=wav_nsamp(ichan)
        rate=wav_rate(ichan)
        duration=wav_duration(ichan)
      endif
    
c
c get julian day
c
      call date_doy(jday,day,month,year)

c
c convert comp and station name
c
      call set_def_chan(1,stat,comp) 

c
c get station location
c
      call stat_loc(stat,'0',stla,stlo,stel)

c
c make sac file name
c
         outfile = ' '

         outfile= infile(1:seiclen(infile)) 
         if (.not.keep_path) then
           ind=-1
           do i=seiclen(outfile),1,-1
             if (outfile(i:i).eq.dchar.and.ind.eq.-1) then
               ind=i+1
             endif
           enddo
           if (ind.ne.-1) then
             outfile = outfile(ind:seiclen(outfile))
           endif
         endif
         outfile = outfile(1:seiclen(outfile)) // '_'
     &         // stat(1:5) // '_' //
     &           comp(1:4)  // '_SAC'

         j= seiclen(outfile)
         do i=1,j
           if (outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo
         write(6,*) ' SAC output filename: ',
     *       outfile(1:seiclen(outfile))

c
c write sac header
c
        call newhdr
c number of points
        call setnhv('NPTS',nsamp,nerr)
c beginning and ending value of data
        call setfhv('B',beg,nerr)
        call setfhv('E',duration,nerr)
c type of file
        call setihv('IFTYPE','ITIME',nerr)
c evenly spaced
        call setlhv('LEVEN',.true.,nerr)
c sample rate
        call setfhv('DELTA',1/rate,nerr)
c date and time
        call setnhv('NZYEAR',year,nerr)
        call setnhv('NZJDAY',jday,nerr)
        call setnhv('NZHOUR',hour,nerr)
        call setnhv('NZMIN',min,nerr)
        call setnhv('NZSEC',int(sec),nerr)
        call setnhv('NZMSEC',int(1000.*(sec-
     *        int(sec))),nerr)
c station coord
        call setfhv('STLA',stla,nerr)
        call setfhv('STLO',stlo,nerr)
        call setfhv('STEL',stel,nerr)
c station and comp name
        call setkhv('KSTNM',stat,nerr)
        call setkhv('KCMPNM',comp,nerr)
c network code
        call setkhv('KNETWK',network,nerr)
c hyp
        if (eqla.ne.0.or.eqlo.ne.0) then
          call setfhv('EVLA',eqla,nerr)
          call setfhv('EVLO',eqlo,nerr)
          call setfhv('EVEL',eqel,nerr)
        endif
 
        set_comp = .false.

c az and ic of components
        if (comp(4:4).eq.'Z'.or.comp(3:3).
     *            eq.'Z') then
          cmpaz=0.
          cmpinc=0. 
          set_comp=.true.
        elseif (comp(4:4).eq.'N'.or.comp(3:3).
     *            eq.'N') then
          cmpaz=0.
          cmpinc=90.
          set_comp=.true.
        elseif (comp(4:4).eq.'E'.or.comp(3:3).
     *            eq.'E') then
          cmpaz=90.
          cmpinc=90.
          set_comp=.true.
        endif
        if (set_comp) then
          call setfhv('CMPAZ',cmpaz,nerr)
          call setfhv('CMPINC',cmpinc,nerr)
        endif

c
c write sac data
c
        call wsac0(outfile,data_x,signal1,nerr)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      subroutine read_sacbin_to_seisan(infile,ichan,nerr)
c
c   read binary sac
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer seiclen
      integer ichan               ! channel id
      character*80 infile         ! input file name
      integer nerr                ! sac error code
      real del                    ! delta 
      real max                    ! max number of samples from rsac
      real beg,en                 ! beginning and end of trace
      integer jday                ! julian day
      integer isec,msec           ! sec and millisec
      double precision dpsec      ! absolute time
      integer i                   ! counter
      integer nlen
      character*80 deffile
      character*29 mainhead_text
      character*5 net_code      
      character*80 sacaux
      integer swap
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)

c      write(*,*) ' reading sacbin '
c
c check if SACAUX defined
c
c      call get_env_sacaux(sacaux)
c     if (seiclen(sacaux).le.0) then
c      return
c      endif

c
c   get def file for station codes, give file name
c
      deffile='sacsei.def'
      net_code=' '

      call read_def_chan(deffile,mainhead_text,net_code)

c
c set defaults      
c
      wav_cbyte(ichan)='4'

      beg=0.
      max=max_sample
      swap=0
c      write(*,*) ' attempting to read sac no byte swapping '
      call rsac1(infile,signal1,nlen,beg,del,max,swap,nerr)
c
c attemt byte swapping
c
      if(nerr.ne.0) then
c        write(*,*) ' attempting to read sac byte swapping '
        swap=1
        call rsac1(infile,signal1,nlen,beg,del,max,swap,nerr)
      endif

      if(nerr.ne.0) then
        nerr=-1
        return
      endif
c
c get header values
c

c number of points
        call getnhv('NPTS',wav_nsamp(ichan),nerr)
c begining and ending value of data
        call getfhv('B',beg,nerr)
c 11/04/2006 lot change to add to start time
c          if (beg.lt.0.0001) beg = 0.
        call getfhv('E',en,nerr)
c sample rate
        call getfhv('DELTA',del,nerr)
        wav_rate(ichan) = 1/del
c station and comp name
        call getkhv('KSTNM',wav_stat(ichan),nerr)
c
c check for null
c
        do i=1,5
           if(ichar(wav_stat(ichan)(i:i)).eq.0) wav_stat(ichan)(i:i)=' '
        enddo
c
        call getkhv('KCMPNM',wav_comp(ichan),nerr)
        do i=seiclen(wav_comp(ichan))+1,4
           wav_comp(ichan)(i:i) = ' '
        enddo
        call set_def_chan(ichan,wav_stat(ichan),wav_comp(ichan))
        do i=seiclen(wav_network(ichan))+1,2
           wav_network(ichan)(i:i) = ' '
        enddo
c network code
        call getkhv('KNETWK',wav_network(ichan),nerr)
c set location code 
        wav_location(ichan)='  '
c date and time
        call getnhv('NZYEAR',wav_year(ichan),nerr)
          if (wav_year(ichan).lt.100) wav_year(ichan)=
     *        wav_year(ichan)+1900
        call getnhv('NZJDAY',jday,nerr)
        call dte(jday,wav_day(ichan),wav_month(ichan),wav_year(ichan))
        call getnhv('NZHOUR',wav_hour(ichan),nerr)
        call getnhv('NZMIN',wav_min(ichan),nerr)
        call getnhv('NZSEC',isec,nerr)
        call getnhv('NZMSEC',msec,nerr)
        wav_sec(ichan)=isec+msec/1000.

c
c add beg to absolute time
c
        call timsec(wav_year(ichan),wav_month(ichan),wav_day(ichan),
     *      wav_hour(ichan),wav_min(ichan),wav_sec(ichan),dpsec)
        dpsec=dpsec+beg
        call sectim(dpsec,wav_year(ichan),jday,wav_month(ichan),
     *    wav_day(ichan),wav_hour(ichan),wav_min(ichan),wav_sec(ichan))

        wav_abs_time(ichan)=dpsec

c
c duration
c
        wav_duration(ichan) = wav_nsamp(ichan) / wav_rate(ichan)

      return
      end




      subroutine read_sacasc_to_seisan(infile,ichan,nerr)

      implicit none
      include 'libsei.inc' 
      external sei open,                  ! Open file routine.
     &         sei close                  ! Close file routine
      integer  read1,                     ! Input unit 1
     &         code                       ! Local condition
      logical  bflag                      ! Flag end of file
      include 'seidim.inc'
      include 'waveform.inc'
      integer seiclen
      integer ichan               ! channel id
      character*80 infile         ! input file name
      character*80 text           ! input text line
      integer nerr                ! sac error code
      real del                    ! delta
      real max                    ! max number of samples from rsac
      real beg,en                 ! beginning and end of trace
      integer jday                ! julian day
      integer isec,msec           ! sec and millisec
      double precision dpsec      ! absolute time
      integer i,n,tt,stoploop     ! counter
      real rate                   ! sample rate
      character*80 deffile
      character*29 mainhead_text
      character*5 net_code

      n=0
      nerr=0
c
c   get def file for station codes, give file name
c
      deffile='sacsei.def'
      net_code=' '



c
c  open ascii file and read variables
c
        call sei open( old$+warn$,             ! Open file (stop on error).
     &                     ' ',                ! No prompt.
     &                     infile,             ! This filename.
     &                     read1,              ! On unit.
     &                     bflag,              ! Exists!!
     &                     code )     
   
        if (.not.bflag) then
          nerr=-1 
          return
        endif

c
c read from asc header
c
c
c line : 1
       read(read1,'(a)',err=998) text

       call SEI GET VALUES( 5, text, CODE )
       if (code.ne.0) goto 998

       rate=ARRAY$(1)
       wav_rate(ichan)=1/rate

c-- read lines
c skip until line 14
       do i=1,13
          read(read1,*,err=998)
       enddo

c-- read start time
c line 15
       read(read1,'(a)',err=998) text

       call SEI GET VALUES( 5, text, CODE )
       if (code.ne.0) goto 998

        wav_year(ichan)=ARRAY$(1)
        jday=ARRAY$(2)
        call dte(jday,wav_day(ichan),wav_month(ichan),wav_year(ichan))
        wav_hour(ichan)=ARRAY$(3)
        wav_min(ichan)=ARRAY$(4)
        isec=ARRAY$(5)

c line 16
        read(read1,'(a)') text
        call SEI GET VALUES( 5, text, CODE )
        msec=ARRAY$(1)
        wav_sec(ichan)=isec+msec/1000.

c-- number of samples
        wav_nsamp(ichan)=ARRAY$(5)

c-- skip until 22
        do i=1,6
          read(read1,*)
        enddo

c-- read station
       read(read1,'(a)') text
       read(text(1:5),'(a5)') wav_stat(ichan)
c
c check for null
c
        do i=1,5
           if(ichar(wav_stat(ichan)(i:i)).eq.0) wav_stat(ichan)(i:i)=' '
        enddo
   

c-- skip lines until 28
       do i=1,5
          read(read1,*)
       enddo

c-- read channel
c line 29
       read(read1,'(a)') text
       read(text(17:20),'(a4)') wav_comp(ichan)
c
c   fix station and component names
c
        call set_def_chan(ichan,wav_stat(ichan),wav_comp(ichan))

       read(read1,'(a)') text
c
c read waveform data
c
       stoploop=int(wav_nsamp(ichan)/5)+1
       do i=1,stoploop
          read(read1,'(a)',end=999) text

          do tt=1,80

            if (text(tt:tt).eq.'.') then
              if (text(tt+1:tt+7).eq.'0000000') then
                text(tt+1:tt+7)='       '
              elseif (text(tt+7:tt+7).eq.'0') then
                text(tt+7:tt+7)=' '
              endif
             endif
          enddo

c227545.0000000-381483.0000000-492502.0000000-646966.0000000-711058.0000000
c827626.0000000-1120953.0000000-1584441.0000000-1508225.0000000-880364.0000000
          if (n.LE.wav_nsamp(ichan)) THEN
             call SEI GET VALUES( 5, text, CODE )
             do tt=1,5
               n=n+1
               if (n.LE.wav_nsamp(ichan)) THEN
                 signal1(n)=ARRAY$(tt)
               endif
             enddo
          ELSE
            GOTO 999
          ENDIF

       enddo

      goto 999

  998 continue
      nerr=-1

  999 CONTINUE
      call sei close( close$, read1, code )
      if (nerr.ne.-1) then
c
c duration
c
        wav_duration(ichan) = wav_nsamp(ichan) / wav_rate(ichan)
        wav_chan_nr_file(ichan)=1
        wav_cbyte(ichan)='4'
      endif

      return
      end

      subroutine select_volcano_subclass(sub_class)
c
c
c   changes
c
c   oct 18 2002  jh  : small change in write statement to compile on pc
c
      implicit none
 
      include 'seisan.inc'
      include 'libsei.inc'                 ! Library definitions & data defns.

c-- User entered sub-class flag
      CHARACTER*(*)     sub_class
c-- sub class code
      CHARACTER*6       s_class(60)
c-- sub class number
      INTEGER           n_class(60)
c-- user entered number
      INTEGER           n_select
c-- sub-class description array
      CHARACTER*40      description
c-- true if sub_class is in s_class()
      LOGICAL           valid_class
c-- full pathname of VOLCANO.DEF
      CHARACTER*80      vol_file
c-- comment text
      character*80 comment
c-- flag
      logical exist
c-- counter
      integer i,code,read2
c-- path to seismo
      character*60 top_directory
c-- directory separator
      character*1 dchar
c-- computer type
      logical pc,sun,linux
c-- function to get length of character string
      integer seiclen
c-- flag for special events
      logical star_flag

      call computer_type(sun,pc,linux)
      call dir_char(dchar)   ! directory separation character
      call topdir(top_directory)


C bjb 18/3/97
C If a local volcanic event then we want register a sub class defined in
C the file VOLCANO.DEF located in the DAT directory.
C The format of this file will be one line of text (80A) followed by
C i2,1x,6A,1X,40A for number, code, space, description
c
c next lines moved down to be run only if 'V' LO, 04.97
c
      valid_class=.FALSE.
      sub_class='  '
C Create path name for VOLCANO.DEF on sun or PC
      vol_file=top_directory(1:60)
      vol_file(seiclen(top_directory)+1:
     *        seiclen(top_directory)+1)=dchar
      vol_file(seiclen(vol_file)+1:seiclen(vol_file)+3)='DAT'
      vol_file(seiclen(vol_file)+1:seiclen(vol_file)+1)=dchar
      vol_file(seiclen(vol_file)+1:)='VOLCANO.DEF'

      CALL sei open(check$,
     &                  ' ',
     &                  vol_file,
     &                  0,
     &                  exist,
     &                  code)
      IF(.not.exist) THEN
         WRITE(6,*)
     *   'Warning: Cannot find VOLCANO.DEF file in DAT dir'
         sub_class='NONE'
         return    
      ENDIF
c
C If we are here then we want to open up VOLCANO.DEF file and print to
C the screen and let the user select which code he wishes to enter
C in line 1 col 56
c
      CALL sei open(old$,
     &                ' ',
     &                 vol_file,
     &                read2,
     &                exist,
     &                code)
 10   READ(read2,'(a80)') comment
      WRITE(6,*)' '
      WRITE(6,*) comment

      WRITE(6,*)'---------------------------------------'
      Write(6,*)'Number Sub-Class Description'
      WRITE(6,*)'---------------------------------------'
      DO i=1,60
         READ(read2,'(i2,1x,a6,1x,a40)') n_class(i),s_class(i),
     &                                    description
         WRITE(6,'(4x,i2,1x,a6,4x,40a)') n_class(i),s_class(i),
     &                                    description

         IF(description.eq.'QUIT') GOTO 20
      ENDDO
 20   CONTINUE
      WRITE(6,*)'---------------------------------------'
      WRITE(6,*) 'Please enter number for sub-class : '
cjh      WRITE(6,*) '(Negative number to add \'*\' to sub-class)'      
      WRITE(6,*) '(Negative number to add to sub-class)'
      call flush (6)
      star_flag=.false. 
      READ(5,'(i2)') n_select
      if (n_select.lt.0) then
        n_select=abs(n_select)
        star_flag=.true. 
      endif
C Test for valid sub_class code number
      DO i=1,60
         IF(n_select.eq.n_class(i)) then
                    valid_class=.TRUE.
                    sub_class=s_class(i)
c insert star if special event
                    if (star_flag) 
     &          sub_class=sub_class(1:seiclen(sub_class))//'*'
                    WRITE(6,*)'Sub-class ', sub_class, ' selected.'
         endif
      ENDDO
      IF(.not.valid_class) THEN
         WRITE(6,*)'Invalid Sub-class code. Try again'
         REWIND(read2)
         GOTO 10
      ENDIF
      CALL sei close(close$,read2,code)

      return
      end

c
c  sample program to illustrate how to read waveform files in SEISAN
c  all supported seisan formats can be read
c  jh, June 2001
c
c  oct  20, 2004 jh : write out samples from channel 1 instead of 2
c  mar 5    2007 jh : add use of filenr.lis
c

      implicit none
      include 'seidim.inc'                    ! for giving dimensions
      include 'libsei.inc'                    ! for all seisan subroutines
      include 'waveform.inc'                  ! waveform data
      include 'seisan.inc'                    ! seisan general parameters
      integer nstat,nphase,nhead,nrecord,id   ! for reading s-file
      character*1 type,exp                    ! -----------------
      character*80 sfilname                   ! s-file name
      character*80 data(max_data)             ! one s-file
      integer npresent                        ! number of wav files present
      character*80 text                       ! general text string
      character*80 question                   ! question
      integer k,i,in
c
c  use a waveform file name directly or the waveform files in an s-file
c


c
c   get s-file name or wav name
c
      write(6,*)' S-file name, return for wav-name directly'
      read(5,'(a)') sfilname
      if(sfilname.ne.' ') then
c
c   open s-file
c
         open(1,file=sfilname,status='old')
c
c  read s-file
c
         call indata
     *   (1,nstat,nphase,nhead,nrecord,type,exp,data,id)
         close(1)

c
c   get waveform file names, could be several
c
         call auto_tr(data,nhead,wav_nfiles,wav_filename)

      else
c
c   get file name directly, can be one or many
c
        in=0
        question=' File name, # or filenr.lis for all'
        call filename(question,wav_filename(1))
        if(wav_filename(1)(1:10).eq.'filenr.lis'.or.
     *  wav_filename(1)(1:10).eq.'FILENR.LIS') then
           open(8,file='filenr.lis',status='old',err=20)
           goto 21
 20        continue
           write(6,*)' No filenr.lis'
           stop
 21        continue
           in=1
        endif
        wav_nfiles=1     ! there is only one file at the time in this case
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)')wav_filename(1) 
         if(wav_filename(1)(1:4).eq.'    ') stop
      endif
c
c   find how many waveform files are present,
c   replace the origial names without path, with the present files
c   full path like
c
       npresent=0                      ! no files initially
       do i=1,wav_nfiles
          call  get_full_wav_name(wav_filename(i),text)            
          if(text.ne.' ') then
             npresent=npresent+1
             wav_filename(npresent)=text
          endif
      enddo
c
c   print how many files were found
c
      wav_nfiles=npresent
      write(6,*)' Number of wav-files present', wav_nfiles

c
c   terminate if no waveform files
c
      if(wav_nfiles.eq.0) stop

c
      wav_nchan=0
c
c   loop to read all headers of all files
c
      do i=1,wav_nfiles
         write(6,'(1x,a)') wav_filename(i)
c
c   read all headers of file i
c
         call read_wav_header(i)
c
c   output possible errors
c
         if(wav_error_message.ne.' ') write(6,'(1x,a)') 
     *   wav_error_message
c
c   write out the format
c
         write(6,'(1x,a,a)') 'Format ',wav_file_format(i)

      enddo
c
      write(6,*)' Total number of channels available:',wav_nchan
c
c   terminate if no channels
c
      if(wav_nchan.eq.0) stop
c
c   write some input info for each channnel on screen
c
      write(6,'(a,a)')
     *'CHA STAT  COMP  YEAR MO DA HR MI    SEC   NSAMP ',
     *'    RATE    DELAY DURATION'
      do i=1,wav_nchan
         write(6,'(i3,1x,a,1x,a,1x,i5,4i3,f7.3,i8,3f9.3)')
     *   i, wav_stat(i),wav_comp(i),
     *   wav_year(i),wav_month(i),wav_day(i),wav_hour(i),wav_min(i),
     *   wav_sec(i),wav_nsamp(i),wav_rate(i),wav_delay(i),
     *   wav_duration(i)
      enddo
c
c----------------------------------------------------------
c  Data from any one channel can now be read, in example
c  read from channel 1
c-----------------------------------------------------------
c
      k=1
c
c   read whole channel
c
      call wav_read_channel(k)
c
c   write first 10 samples on screen, remember originaly they are integer
c   however, when read by SEISAN, they are converted to real
c
      write(6,*)
      write(6,*)' 10 first samples from channel 1'

      write(6,'(5f10.1)') (signal1(i),i=1,10)   ! signal1 is a common block variable 

c
c   if a list of files, go back to read next
c
      if(in.eq.1) goto 1000
      stop
      end

c***************************************************************************
c
c     Program: sample_read_cont
c
c
c     program is a simple example of reading from continuous waveform data base 
c
c     how it works: start program with command sample_read_cont yyyymmddhhmmss timewindow
c                this will extract interval timewindow in minutes starting at time
c                yyymmddhhmmss using all continous data bases as defined in SIESAN.DEF,
c                program WAVETOOL can be used to extract also specific channels
c
c
c     May 2003  jh        
c
c***************************************************************************

      implicit none 

c
c read SEISAN include files
c
      include 'seidim.inc'   ! dimensions
      include 'seisan.inc'   ! general seisan parameters including contiuous data base names
      include 'waveform.inc' ! for waveform handling

      character*80 outfile   ! name of output seisan  waveform file
      character*1040 chead   ! seisan channel header
      character*80 mainhead(max_trace) ! seisan waveform main header
      character*5 net_code   ! code of network
      character*80 arg(5)    ! arguments to cfile
      integer nargs          ! number of arguments
      real min               ! minute

      integer i,l            ! counter

c
c  signal that reading is from a continous data base
c
      cwav=.true.
c
c   get seisan defaults including names of continuous waveform data bases
c
      call get_seisan_def 
c
c check if cont databases defined, n_cont_base gives the number of data bases
c
      if (n_cont_base.eq.0) then
         write(*,*) ' No continuous database defined in SEISAN.DEF '
         stop
      endif
c
c write out the database names
c
      write(*,*)'Databases are:'
      do i=1,n_cont_base
 	 write(*,*)'    ',cont_base(i)
      enddo
c
c get arguments, first is start time in yyyymmdd... and second is interval in min
c this argument function is SEISAN general, has the same form on all computer platforms
c
      call get_arguments(nargs,arg)
c
c check if any arguments
c
      if (nargs.eq.0) then
         write(*,*)
     *  'Start time (yymmdd...) and time',
     *  ' interval (min) must be given'
         stop
      endif
c
c   store the start time
c
      cwav_start_time = arg(1)
c
c read the time interval and convert to seconds
c

      read(arg(2),'(f5.0)') min
      cont_interval=min*60.

c
c   calculate end time and extended start time, needed in order to
c   make sure enough files read in
c
      call cwav_time_limits(0)
c
c  read the header information for all files in allo bases in time
c  interval, assume info available in common block
c
      call cwav_read_bases     
c
c   make and write seisan output header
c
      net_code='TEST '
      call wav_sheads(1,net_code,outfile,mainhead,chead)   ! make headers
      write(6,*) outfile
      open(66,file=outfile,status='unknown',form='unformatted')
c
c   write headers, assumem maximum of 30 channels, since only 12 headers are written out
c
      do i=1,12
          write(66) mainhead(i)
      enddo
c
c  read the waveform data, one trace at a time
c
      do i=1,n_cont_trace
          call wav_read_channel(i)                            ! read one trace, read as integer, converted to real
          call wav_sheads(i,net_code,outfile,mainhead,chead)  ! make channel header
          write(66) chead                                     ! write channel header
          write(66)(int(signal1(l)),l=1,wav_nsamp(i))         ! write trace, converted to integer
      enddo

      stop
      end

c$debug
c
c    PROGRAM TO CHECK S FILES
c
c
c   LATEST UPDATE
c   NOV 22, 88, J.H.: FIRST VERSION
c   JUN 28, 90  J.H.: ONLY USE HEADER LINES, ONLY NORDIC FORMAT
c   AUG 10  90      : MORE CHECKS
c       22          : ----------
c   Nov.    91  C.L.: Transfer to Unix with some minor changeS
c   apr 14  93 by jh: fix for new indata
c   jun 1   93      : output file
c   jul 7   93    jh: version 3.0 *********************************
c   aug 23          : filename to 80 
c   nov 24, 1994  : opening files changed
c   feb     1999  jh: -------------    version 7.0 check -----------
c                     year to 4 digits
c


c Checkre is a small program that performs some elementary
c checking of the data in a Nordic file. If the files in some fields
c are inconsistent or invalid parameters are used a warning is 
c printed out. The program is good for checcking large data files
c that are going to be split and put into the database. The things checked
c are the following: 
c 1. If depth is greater than 30 km a warning is written
c 2. If a travel time residual is greater than 5 seconds or the rms value of

c  the residuals are greater than 2 seconds the user is warned.
c 3. Correct polarity.
c 4. Correct type of event.
c 5. May be most important: It is checked that the events are in chronological
c    order.
c
      implicit none
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! Dimentions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c INPUT FILE                                 
      character file1*80
c FILE TYPES P,F, OR S                        
      integer type
c ERROR FLAG FOR OUTPUT 
      integer errflag
c NUMBER OF CODA READINGS                        
      integer ncoda
c EVENT TYPE, L,R OR D                     
      character evtype1*1
c RECORDS IN FILE 1                     
      character data1(max_data)*80
c TIME IN SEC SINCE 1900 EVENT 1         
      double precision time1
c OLD -------------     
      double precision time1_old
c DATES AND TIMES                   
      integer year1, month1, day1, hr1, min1
c SECONDS                                           
      real sec1
c OUTPUT INDICATOR                                 
      integer out
c EXPLOSION INDICATOR                        
      character exp1*1
c NUMBER OF STATIONS                            
      integer nstat1
c NUMBER OF RECORDS and phasesFOR EVENT                 
      integer nrecord1,nphase
c NUMBER OF HEADERS FOR EVENT                   
      integer nhead1
c NUMBER OF STATIONS FROM HEADER                  
      integer nsta
c LATITUDE AND LONGITUDE                          
      real lat, lon
c DEPTH AND RMS                                 
      real depth, rms
c MAGNITUDES                                    
      real mag1, mag2
c MAGNITUDE TYPES                    
      character magtyp1*1, magtyp2*1
c RESIDUAL                                           
      real res
c id line number
      integer id
c indicator for compact file
      logical compact
c EVENT COUNTERS          
      integer nl, nr, nd, ne, np, nu, nevent
c number of errors
      integer nerror
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1
       integer          read01
c write unit #1
       integer          write01
c
c
c    SET DEFAULTS AND INITIAL PARAMETERS
c
c COUNTER                                           
      integer i
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      nevent = 0
      nd = 0
      nl = 0
      nr = 0
      ne = 0
      np = 0
c
c  OPEN FILES
c
c PREVIOUS EVENT VERY OLD               
      time1_old = 0
      write(6, fmt=*) ' INPUT FILE  NAME'
      read(5, fmt='(A)') file1
      write(6, fmt=*) 
     &'OUTPUT OF ALL HEADER LINES(1) OR ERROR ONLY(2)'
      read(5, fmt=*) out
             call sei open(old$+warn$,            ! Open a existing file.
     &                     ' ',                   ! Prompt file name (n/a).
     &                     file1,                 ! File name
     &                     read01,                ! Read unit #1
     &                     b_old,                 ! Already exists? (n/a).
     &                     code)                  ! Returned condition.
      if (.not. b_old) go to 999
      call sei open(unknown$+warn$,        ! Open a unknown status file.
     &              ' ',                   ! Prompt file name (n/a).
     &              'checkre.out',         ! File name
     &              write01,               ! Write unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.
      errflag = 0
c
c   find if full file or compact file
c
      call nortype(read01,compact)
      type=2
      if(compact) type=1
c
c   READ  EVENT 
c
    1 continue
      nrecord1 = 1
      if (type .eq. 2) then
          call indata(read01, nstat1, nphase,
     *         nhead1, nrecord1, evtype1, exp1, data1,id)
      else
         read(read01,'(a80)',iostat=code) data1(1)
         call sei code(fort$,code,read01,b_eof)
         if (b_eof) go to 2
c
c   CHECK FOR EOF
c
      end if
c
c   GET ABS TIME FOR  EVENT 1, READ FROM HEADER
c
c EOF                                  
      if (nrecord1 .eq. 0) goto 2
      read(data1(1), fmt=
     &'(1X,I4,1X,2I2,1X,2I2,F5.1,1X,2A1,  F7.3,F8.3,F5.0
     &,5X,I3,F4.1,1X,F3.0,A1,4X,F3.0,A1)') year1, month1, day1, hr1, 
     &min1, sec1, evtype1, exp1, lat, lon, depth, nsta, rms, mag1, 
     &magtyp1, mag2, magtyp2
c
c   check format in file
c
         call check_s(data1,                     ! file
     &                nrecord1,                  ! number of records
     &                file1,                     ! file name
     &                nerror,                    ! number of errors
     &                2,                         ! output destination
     &                write01)                   ! unit number
c
c   CHECK MAGNITUDE
c
       IF(MAG1.NE.0.0.AND.MAG2.NE.0.0) THEN
          IF(ABS(MAG1-MAG2).GE.0.5) then 
           WRITE(6,*)
     *   ' LARGER THEN 0.5 MAGNITUDE DEVIATION'
           WRITE(write01,*)
         write(write01,*,iostat=code)
     *   ' LARGER THEN 0.5 MAGNITUDE DEVIATION'
         call sei code(fort$,code,write01,b_eof)
          endif
          ERRFLAG=1
       ENDIF
c
c  CHECK CODA MAGNITUDE
c
c ABS TIME     
      call timsec(year1, month1, day1, hr1, min1, sec1, time1)
C      if ((mag1 .eq. 0.0) .and. (magtyp1 .eq. 'C')) then
C      write(6, fmt=*) ' CODA READINGS MISSING'
C      errflag = 1
C      end if
c
c   CHECK DEPTH
c
      if (depth .gt. 30.0) then
      write(6, fmt=*) ' DEPTH  LARGER THEN 30'
         write(write01,*,iostat=code) ' DEPTH  LARGER THEN 30'
         call sei code(fort$,code,write01,b_eof)
      errflag = 1
c
c   CHECK RMS
c
      end if
      if (rms .gt. 2.0) then
      write(6, fmt=*) ' RMS LARGER THEN 2.0'
         write(write01,*,iostat=code) ' RMS LARGER THEN 2.0'
         call sei code(fort$,code,write01,b_eof)
      errflag = 1
c
c   CHECK RESIDUALS AND MORE
c
      end if
      if (type .eq. 2) then
c
c  residuals
c
      ncoda = 0
      do i = nhead1 + 1, nrecord1 - 1
      read(data1(i), fmt='(63X,F5.1)') res
      if (abs(res) .gt. 5.0) then
      write(6, fmt=*) ' RESIDUAL LARGER THEN 5'
         write(write01,*,iostat=code) ' RESIDUAL LARGER THEN 5'
         call sei code(fort$,code,write01,b_eof)
      errflag = 1
c
c   CODA READING CHECK, NOT FOR PURE NORSAR REPORTS
c
      end if
c
c CHECK FOR COMPRESSION-DILATATION INDICATOR
c
      if (data1(i)(30:33) .ne. '    ') ncoda = ncoda + 1
      if (((data1(i)(17:17) .ne. ' ') .and. (data1(i)(17:17) .ne. 'C'))
     & .and. (data1(i)(17:17) .ne. 'D')) then
      write(6, fmt=*) ' WRONG POLARITY'
         write(write01,*,iostat=code) ' WRONG POLARITY'
         call sei code(fort$,code,write01,b_eof)
      errflag = 1
      end if
      end do
      if (((ncoda .eq. 0) .and. (data1(1)(46:48) .ne. 'NAO')) .and. ((
     &evtype1 .eq. 'R') .or. (evtype1 .eq. 'L'))) then
      write(6, fmt=*) ' NO CODA READINGS'
         write(write01,*,iostat=code) ' NO CODA READINGS'
         call sei code(fort$,code,write01,b_eof)
      errflag = 1
      end if
c
c   CHECK TIME
c
      end if
      if (time1 .lt. time1_old) then
      write(6, fmt=*) ' *** EVENT OUT OF ORDER ***'
         write(write01,*,iostat=code) ' *** EVENT OUT OF ORDER ***'
         call sei code(fort$,code,write01,b_eof)
      errflag = 1
      end if
c
c   CHECK TYPES
c
      time1_old = time1
      if (((evtype1 .ne. 'L') .and. (evtype1 .ne. 'D')) .and. (evtype1
     & .ne. 'R')) then
      write(6, fmt=*) ' *** EVENT HAS WRONG OR NO TYPE ***'
         write(write01,*,iostat=code)
     *           ' *** EVENT HAS WRONG OR NO TYPE ***'
         call sei code(fort$,code,write01,b_eof)
      errflag = 1
      end if
      if (((exp1 .ne. 'E') .and. (exp1 .ne. 'P')) .and. (exp1 .ne. ' ')
     &) then
      write(6, fmt=*) ' *** EXPLOSION TYPE WRONG ***'
      write(write01,*,iostat=code) ' *** EXPLOSION TYPE WRONG ***'
      call sei code(fort$,code,write01,b_eof)
      errflag = 1
c
c   OUTPUT
c
      end if
      if ((out .eq. 1) .or. (errflag .eq. 1)) 
     *write(6,'(a)' ) 
     &data1(1)
      if ((out .eq. 1) .or. (errflag .eq. 1)) then 
          write(write01,'(a)',iostat=code) data1(1)
          call sei code(fort$,code,write01,b_eof)
      end if
c
c   COUNT EVENTS
c
      errflag = 0
      nevent = nevent + 1
      if (evtype1 .eq. 'L') nl = nl + 1
      if (evtype1 .eq. 'R') nr = nr + 1
      if (evtype1 .eq. 'D') nd = nd + 1
      if (exp1 .eq. 'E') ne = ne + 1
c
c  BACK FOR NEXT EVENT
c
      if (exp1 .eq. 'P') np = np + 1
c
c   EOF, WRITE SUMMARY
c
      goto 1
    2 continue
      write(6, fmt=202) nl, nr, nd, ne, np, nevent
      write(write01,fmt=202,iostat=code) nl, nr, nd, ne, np, nevent
      call sei code(fort$,code,write01,b_eof)
  202 format(/,27h NUMBER OF LOCAL EVENTS:   ,i5,/,
     &27h NUMBER OF REGIONAL EVENTS:,i5,/,27h NUMBER OF DISTANT EVENTS: 
     &,i5,/,27h NUMBER OF EXPLOSIONS:     ,i5,/,
     &27h NUMBER OF PROB. EXPLOSIONS,i5,//,
     &27h TOTAL NUMBER OF EVENTS:   ,i5,/)
      nu = ((nevent - nl) - nr) - nd
      if (nu .gt. 0) write(6, fmt=*) 
     &' *** NUMBER OF UNIDINTIFIED EVENTS', ' ***', nu
      if (nu .gt. 0) write(write01, fmt=*) 
     &' *** NUMBER OF UNIDINTIFIED EVENTS', ' ***', nu
      write(6,*)
      write(6,*)
      write(6,*)'Output file name is checkre.out'
      write(6,*)
          call sei close (close$,read01,code)
999   continue
      stop 
      end

      subroutine findevin                                                  
     *(base_name,start_time,end_time,key,from_eev,event_no,                    
     *evfile,fstart,new_month,status)                                           
c                                                                               
c   routine finds an event in event index file given input parameters           
c                                                                               
c   jens havskov dec 88                                                         
c                                                                               
c   latest updates:                                                                
c   jul 94 jh      : enable continous search with empty months
c   nov 24, 1994   : opening files changed
c   jan 95         : reorganizing completely so index files are not used
c   jan 18, 95     : bug
c   jan 31 96      : enable eev to go over months
c   mar 25 97      : stop for NEXT if end of list for local directory
c                    see comment 25-3
c   sep 5  97      : bug when deleting from index file, return with first
c                    event to eev without reading files again
C   sep 11         : continue into next month also if last part of month
c                    has no data
c
c   feb 98         : year 2000
c   sep            : ------------  version 7.0 check------------------------
c                    5 char base name
c   sep 17         : bugs with alt base, base ,,,,, to ,,
c   jan 4 99       : bug when going from one year to next
c   jan 6            one more of above
c   march 17       : data base logging
c   may 24  bmt    : bug fixed (Work Directory)
c   jun 10  jh     : modify so there can be a '-' in directory name, fstart cal.
c   jul 24         : improve date for index file, clean up
c   oct 29  jh     : change base_update: convert base to upper case, do not
c                    write if nevents=0
c   march29 00 jh  : allow to use year 1900
c   feb 17 02  jh  : give message if not allowed to update REA.LOG
c   mar 23         : replace seiopen with read-write 77 in log subroutines
c                    to avoid error message 'too many files open'
c   jun 16 05  jh  : check for error in s-file name
c   9 may 2008 pv  : subroutine base_address now accept database year <=2099
c
c   input: base_name :-blank : local data base       
c                     -5 letter name: another data base                     
c                     -local index file name: use that index file               
c                      a local index file is identified to have a '.' or        
c                      be longer than 5 chars.                          
c                      ,, : files in local directory        
c          start_time: time to find first event:c-y-m-d-hr-min-sec (7a2)          
c          end_time  : time of last event,-----------------------, if           
c                      blank default to end of month. If a local index file     
c                      is used, both start and end time can be blank,           
c                      indicating that the whole index file is used.            
c          key       : key to select event or index file update                 
c                                           Dxxhh  : go to day xx and hour hh 
c                                                    in current month or in. file                        
c                                           #xxx : go to event #xxx -------     
c                                                  also work without #
c                                           sxxx : find next event within xxx secs
c                                           next : go to next event             
c                                           blank: ----------------- 
c                                           back : back one event           
c                                           same : same event (return)
c                                           del  : delete event
c                                           ren  : read in event list          
c          from_eev   : 1 if call comes from eev, else 0
c                       2 call from ev, over several months
c                                           and output                          
c                                                                               
c   output: evfile   : file name of event file found                            
c           fstart   : character # start of event id                            
c           event_no : event number                                             
c           new_month: indicate if a new month has been entered                 
c                      0: same month, 1: new month                              
c           status   : 0: event found, key is next, # or date                   
c                      1: event not found, -----------------                    
c                      2: end of index file, not data base                      
c                      3: end of time period                                    
c                      4: next index file missing, key: next                    
c                      5: wrong time interval                                   
c                      6: start time is blank when using a database, e.g. REA   
c                      9: something fatally wrong
c
C
       implicit none
c
C    Seisan library inserts and routines...
C    ======================================
C
       save
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! Seisan dimensions    
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c
c--- total number of event names 
      integer total_no_events
c--- events without directory info
      character*19 sfiles(max_index$)
c--- year and month infor used with index files
      character*4 syear(max_index$)
      character*2 smonth(max_index$)
c-- directory where event files are, s-files
      character*80 sdir
c-- lenght of sdir
      integer slength
c-- call from eev indicator
      integer from_eev
c-- see above                                       
      character*14      start_time      
c-- start_time at return from call         
      character*14      old_start_time  
c-- same as start_time in time since 1900 
      double precision  time1           
c-- see above                                        
      character*14      end_time        
c-- end_time at return form call             
      character*14      old_end_time    
c-- same as end_time                      
      double precision  time2           
c-- current time                          
      double precision  time,tim1,tim2
c-- maximum time difference for associating 2 events            
      integer time_dif,old_time_dif
c-- see above                                        
      character*40      base_name       
c agency
      character*5 def_base
c-- base_name at return from call           
      character*40      old_base_name   
      character*80      text
c-- top directory of data base, def REA         
      character*5       base_dir        
c-- dirctory separation character
      character*1 dchar
c-- see above                                        
      character*10      key             
c-- see above                                     
      character*80      evfile          
c-- saved version of evfile               
      character*80      old_evfile      
c-- top directory of system                 
      character*60      top_directory   
c-- see above                                            
      integer           new_month       
c-- see above                             
      integer           status          
c-- date                                             
      integer year,month,day    
c-- 1: index file/list is open, 0: not open                  
      integer           index_open      
c-- counters                                           
      integer           i,j,i2,q      
c-- start of ev id in full name string                    
      integer           fstart          
c-- index numbers                                         
      integer           old_no          
c-- event numbers                             
      integer event_no,ev_no_wanted     
c-- day number in month  and hour         
      integer ev_day_wanted,current_day,hour_wanted,current_hour 
c logical for existing file or not
       logical          b_old
c logical for first closing file
       logical          first
c returned code
       integer          code
c read unit #1 
       integer          read01

ctest  write(6,'(a6,1x,a5,1x,a5,1x)') ' base',base_name,old_base_name               
c        write(6,'(1x,a,1x,3i3)')                                             
c     * 'ichar base',(ichar(base_name(i:i)),i=1,3)                          
c      write(6,'(1x,a,1x,a,1x,a)')'st,ost',start_time,old_start_time           
c      write(6,'(1x,a,1x,a,1x,a)')'et,oet',end_time,old_end_time               
c      write(6,*)'status',status                                               
c      write(6,*)' fstart', fstart                                          
ctest         write(6,'(1x,a)') key
c                                                                               
c   set some defaults                                                            
c
      first = .true.
      call get_def_base(def_base)
      call dir_char(dchar)
c                                                                               
c-- clear new month flag                                      
c
      new_month=0                       
c                                                                               
c  top directory                                                  
c
	call topdir(top_directory)                             
c                                                                               
c  find which kind of data base: if 5 letters must be a normal              
c  type data base, if containing a . or larger than 5 letters must              
c  be an index file, which is indicated by a blank base_dir.
c  If ,, only s-files in local directory.               
c                                                                               
c-- default is no standard data base
c                
      base_dir=base_name(1:5)   
      if(base_name(1:5).eq.'     ') base_dir=def_base    
c
c   cases where an index file is assumed indicated by base_dir = '     '
c   or a file longer than 5 chars, or a . in name
c
      if(start_time.eq.'              ') base_dir='     '                                                         
	  i=index(base_name,' ')                                                       
      if(i.gt.6) base_dir='     '   
      do i=1,40                                                                 
         if(base_name(i:i).eq.'.') base_dir='     '                                
      enddo             
c
c  make shure a real base name has 5 non blank characters
c
      if(base_dir(1:1).ne.' '.and.base_dir(1:2).ne.',,') then
        do i=2,5
          if(base_dir(i:i).eq.' ') base_dir(i:i)='_'
        enddo
      endif          
c
c   case of local data base
c
      if(base_name(1:2).eq.',,') base_dir=',,   '        ! no base, local dir                                          
c
c   save base_dir
c
      call put_env_base(base_dir)
c                                                                               
c   if start time has no month, put in january                                  
c                                                                               
      if(start_time(5:6).eq.'  ') start_time(5:6)='01'                          
      do i=7,14                                                                 
         if(start_time(i:i).eq.' ') start_time(i:i)='0'                          
      enddo                                                                     
c                                                                               
c   If start time year is blank, should be first event in an index file,   
c   or local data base (events in local directory),
c   then start from year 1900. If end time in that case is also blank, go to      
c   end of file indicated by year 2099                                               
c                                                                               
      if(start_time(1:2).eq.'  ') then                                          
	     if(base_dir.ne.'     '.and.base_dir(1:2).ne.',,') then                                             
	       status=6                                                            
	       return                                                              
	    else                                                                   
	       start_time(1:4)='1900'                                                
	       if(end_time(1:2).eq.'  ')  end_time(1:4)='2099'                       
	     endif                                                                  
      endif                                                                     
c                                                                               
c   if end time year is blank, must be to end of month, put in                  
c   same year-month as start time                                               
c                                                                               
c-- end of month   
      if(end_time(1:2).eq.'  ')  end_time(1:6)=start_time(1:6) 
c                                                         
c   make sure end time is to end of month, day etc if left blank                
c                                                                               
      if(end_time(5:6).eq.'  ') end_time(5:6)='12'                              
      if(end_time(7:8).eq.'  ') then                                            
      read(end_time(1:6),'(i4,i2)',err=7354) year,month
	  goto 7355
 7354 continue
	  write(6,*)' Something wrong with end time'  
	  status=9
	  return
 7355 continue
      call month_day(year,month,day)                                         
      write(end_time(7:8),'(i2)') day                                        
      if(end_time(7:7).eq.' ') end_time(7:7)='0'                             
      endif                                                                     
      if(end_time(9:10).eq.'  ') end_time(9:10)='23'                              
      if(end_time(11:12).eq.'  ' ) end_time(11:12)='59'                           
      if(end_time(13:14).eq.'  ') end_time(13:14)='59'                          
ctest      write(6,*) end_time
c                                                                               
c-------------------------------------------------------------------------      
c   check if time interval or data base has changed since last call             
c   when the index list was loaded                                                  
c-------------------------------------------------------------------------      
c
      if(old_start_time.ne.start_time.or.old_end_time.ne.end_time.              
     *or.old_base_name.ne.base_name) then                                       
         if (.not. first) then
             continue
         else
             first = .false.
         end if
      index_open=0                                                           
      endif                                                                     
c-- save base characteristecs                     
      if(index_open.eq.0) then          
      old_start_time=start_time                                              
      old_end_time=end_time                                                  
      old_base_name=base_name  
      endif                                                                     
c      write(6,'(1x,a,1x,a)')' base_dir',base_dir
c      write(6,'(1x,a,1x,a,1x,a)')' stt  end t', start_time,end_time
c
c-------------------------------------------------------------------------      
c   check for file list update if there is index is open                   
c-------------------------------------------------------------------------      
c
      if((key(1:3).eq.'DEL'.or.key(1:3).eq.'REN')                              
     *    .and.index_open.eq.1) then               
          if(base_dir.ne.'     ') then   ! a data base   
             write(6,'(1x,i4,1x,i2,1x,$)') year,month
             call sfil
     *       (sdir,slength,sfiles,max_index$,total_no_events)
c
c   update log file
c
             call base_update(total_no_events,base_dir,year,month)
c
             if(total_no_events.eq.0) then
                write(6,*)' No more events'
                status=9
                index_open=0
                return
             endif
          else                         ! an index file
             if(key(1:3).eq.'DEL') then
                total_no_events=total_no_events-1
                if(total_no_events.eq.0) then   ! no more
                   write(6,*)' No more events'
                   status=9
                   index_open=0
                   return
                else
                   do i=event_no,total_no_events
                      sfiles(i)=sfiles(i+1)
                      smonth(i)=smonth(i+1)
                      syear(i)=syear(i+1)
                   enddo
c
c   rewrite index file
c
                   call sei open(old$+warn$,            ! Open a existing file.
     &             ' ',                   ! Prompt file name (n/a).
     &             base_name,             ! File name
     &             read01,                ! Read unit #1
     &             b_old,                 ! Already exists? (n/a).
     &             code)                  ! Returned condition
                   if (code .ne. e_ok$) then
                       write(6,*)' No such index file'
                       status=9
                       return
                   endif

                   do i=1,total_no_events
                      sdir(slength-7:slength-4)=syear(i)
                      sdir(slength-2:slength-1)=smonth(i)
                      write(read01,'(7x,a)')
     *                sdir(1:slength)//sfiles(i)
                   enddo
                   write(read01,'(a)') '                            '
                   call sei close (close$,read01,code)
                endif
              endif
          endif
c
c   position event at event after deleted event or at first
c   event if that was the last
c
          if(event_no.gt.total_no_events) event_no=1   ! at end of list
             if(slength.gt.0) then
                if(base_dir.eq.'     ') then    ! index file, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
                evfile=sdir(1:slength)//sfiles(event_no)
             else
                evfile=sfiles(event_no)
             endif
          old_evfile=evfile 
          status=0
          return
      endif                                                                     
c----------------------------------------------------------------------         
c   get list of files if not there, first check if base or special file            
c----------------------------------------------------------------------         
c                           
      if(index_open.eq.0) then                  
c                                                                               
c   first check if time interval is valid, get abs time from 1900               
c                                                                               
	    call abstim(start_time,0,time1)                                        
	    call abstim(end_time,0,time2)                                          
	    if(time1.ge.time2) then                                                
	       write(6,*)' ********* wrong time interval *************'            
	       status=5                                                            
	       return                                                              
	    endif                                                                  
c                                                                               
c-- standard type s-file data base             
c
c      write(6,*)' base_dir',base_dir
	  if(base_dir.ne.'     '.and.base_dir(1:2).ne.',,') then     
	     i2=index(top_directory,' ')-1                                       
         sdir(1:i2)=top_directory(1:i2)
         sdir(i2+1:i2+1)=dchar
         sdir(i2+2:i2+4)='REA'
         sdir(i2+5:i2+5)=dchar
         sdir(i2+6:i2+10)=base_dir    ! data base
         sdir(i2+11:i2+11)=dchar
	     sdir(i2+12:i2+15)=start_time(1:4)    ! year   
         read(start_time(1:4),'(i4)',err=2736) year
         if(year.ge.2099.or.year.lt.1900) then
            write(6,*)'Wrong year'
            stop
         endif
         sdir(i2+16:i2+16)=dchar
         sdir(i2+17:i2+18)=start_time(5:6)   ! month
         read(start_time(5:6),'(i2)',err=2736) month
         if(month.gt.12.or.month.le.0) then
            write(6,*)'Wrong month'
            stop
         endif
		 sdir(i2+19:i2+19)=dchar
         slength=i2+19
         goto  2737
 2736    continue
            write(6,*)' Something wrong with year or month'
            stop
 2737    continue
c
c   get list of s-files
c
c        write(6,*) 'call sfil'
         write(6,'(1x,i4,1x,i2,1x,$)') year,month
         call sfil(sdir,slength,sfiles,max_index$,total_no_events)
c
c   update log file
c
         call base_update(total_no_events,base_dir,year,month)
c
c
c-- flag index file is open                            
	     index_open=1                        
c-- must be a new month                                
	     new_month=1                         
             event_no=0
c
c----------------------------------------------------------------------
c   check if no files, if so go to next month if
c   within time interval
c--------------------------------------------------------------------
c
 7363    continue     ! get here from below in this section to check
         if(total_no_events.eq.0) goto 7364
	     goto 1       ! there was data
 7364    continue
	     write(6,'(a,i4,1x,i2)')' No data for year and month: ',
     *   year,month
 7365    continue     ! to here from section of positioning (goto 1)
c
c-- time of next month                             
c
	     month=month+1                               
	     if(month.eq.13) then                                                   
	        month=1                                                             
	        year=year+1                                                         
	     endif                                                                  
c                                                                               
c   get abs time from 1900                                                      
c                                                                               
	     call timsec(year,month,1,0,0,0.0,time)                                 
c-- not yet end of desired time interval       
	     if(time.lt.time2) then      
c-- make new sdir
            write(sdir(i2+12:i2+15),'(i4)') year
            write(sdir(i2+17:i2+18),'(i2)') month    
            if(sdir(i2+14:i2+14).eq.' ') sdir(i2+14:i2+14)='0'
            if(sdir(i2+17:i2+17).eq.' ') sdir(i2+17:i2+17)='0'
            write(6,'(1x,i4,1x,i2,1x,$)') year,month
            call sfil(sdir,slength,sfiles,max_index$,total_no_events)
c
c   update log file
c
            call base_update(total_no_events,base_dir,year,month)
c

	        goto 7363    ! back to check again for empty file
c-- end of time interval                                           
	     else                
	        status=3                                                            
	        return                                                              
	     endif                                                                  
      endif               ! end section s data base
c
c-----------------------------------------------------------------------        
c   Files in local directory
c-----------------------------------------------------------------------
c
      if(base_dir(1:2).eq.',,') then   ! local directory only
         do q=1,79
          sdir(q:q)=' '
	   enddo 
         slength=0
         call sfil(sdir,slength,sfiles,max_index$,total_no_events)
c
c   update log file
c
          call base_update(total_no_events,base_dir,year,month)
c

          if(total_no_events.eq.0) then
             write(6,*)' No events in local directory'
             status=9
             return
          endif
          status=0
          index_open=1
          new_month=1
          event_no=0
      endif
c
c---------------------------------------------------------------------
c   Index file
c---------------------------------------------------------------------
c                                                                   
      if(base_dir.eq.'     ') then
              call sei open(old$+warn$,            ! Open a existing file.
     &                      ' ',                   ! Prompt file name (n/a).
     &                      base_name,             ! File name
     &                      read01,                ! Read unit #1
     &                      b_old,                 ! Already exists? (n/a).
     &                      code)                  ! Returned condition
         if (code .ne. e_ok$) then
            write(6,*)' No such index file'
            status=9
            return
         endif
c
c-- flag index file is open                            
	     index_open=1                        
c-- must be a new month                                
	     new_month=1                         
             event_no=0
c
c   read file
c
         i=0
 77      continue
         i=i+1
         read(read01,'(a)',end=78) text
         if(text(8:12).eq.'    ') goto 78
c        j=index(text,'-')-2
         call get_fstart(text,j)
         sfiles(i)=text(j:j+18)    ! save file name without path
         if(j.gt.8) then           ! only if 5 letter data base
            smonth(i)=text(j-3:j-2)   ! save month and year since it might
            syear(i)= text(j-8:j-5)   ! - change in index file
         endif
c
         if(i.eq.1) then
            if(j.gt.8) then             ! must have a path
               sdir(1:j-8)=text(8:j-1)  ! save path  test2000
c			   write(6,'(1x,a)') sdir
               slength=j-8
            else
               slength=0                ! local index file with no path. but
            endif                       ! is it used anymore ???, yes, 1-98 jh
            fstart=slength+1
         endif
         goto 77
 78      continue
c        write(6,*)'fs,sle',fstart,slength
         call sei close (close$,read01,code)
         i=i-1
         total_no_events=i
         if(i.eq.0.or.(i.eq.1.and.sfiles(1)(1:3).eq.'   ')) then
            write(6,*)' No events in index file'
            index_open=0
            total_no_events=0
            status=9
            return
         else
            write(6,*)' Number of events in index file: ',
     *      total_no_events
         endif
      endif
c
c-----------------------------------------------------------------------        
c  Loop to start time if a data base or first event if a local base 
c  or index file                                             
c-----------------------------------------------------------------------        
c
 1       continue          
         event_no=0
 111     continue
c         write(6,*)' loop to time'                                                     
             event_no=event_no+1
             if(event_no.gt.total_no_events) goto 2   ! at end of list, below
             if(slength.gt.0) then
                if(base_dir.eq.'     ') then    ! index file, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
                evfile=sdir(1:slength)//sfiles(event_no)
             else
                evfile=sfiles(event_no)
             endif
	         old_evfile=evfile 
c			 write(6,'(1x,a)') evfile                                                     
c                                                                               
c  check time of this event against start time.                                 
c                                                                               
c       fstart=index(evfile,'-')-2
        call get_fstart(evfile,fstart)
c        write(6,*)'fstart',fstart
       call abstim(evfile,fstart,time) 
c
c-- position not found or passed              
c
	 if(time.lt.time1) go to 111     ! loop above to try next event         
c
c-- position found to nearest sec                    
c
	 if(time.le.time2) then
	    status=0
c-- save index number
	    old_no=event_no
	    return
	 else
c-- first event found was after end time
	    status=3
	    index_open = 0
	    return
	 endif

c                                                                               
c-- end of list of files for month or in index file
c   if a data base, there might be more months to check since there
c   could be data in the next month
c
 2       continue                               
         if(base_dir.ne.'     ') then  ! not an index file
            goto 7365                  ! check if next month has data in the
         endif                         ! - the interval
c
c-- position not found                                       
	 status=1                               
c-- at beginning of file, no is 1                 
	 old_no=1               
	 return                                                                 
      endif     
										
c-----------------------------------------------------------------------------  
c  SAME EVENT # SELECTED                                                          
c-----------------------------------------------------------------------------  
c                                                                               
c  same event by number, can be a different event
c
      if(key(1:4).eq.'same'.or.key(1:4).eq.'SAME')then                          
         event_no=old_no
         if(event_no.eq.0) then
            write(6,*)' No more events'
            status=9
            return
         endif
         if(event_no.gt.total_no_events) then
            event_no=1
         endif                                                                             
        if(slength.gt.0) then
                if(base_dir.eq.'     ') then    ! index file, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
           evfile=sdir(1:slength)//sfiles(event_no)
        else
           evfile=sfiles(event_no)
        endif
        old_evfile=evfile                                                   
c- save current event number                
	    old_no=event_no                     
        status=0
	  return                 
      endif                                                                     
c                                                                               
c---------------------------------------------------------------------------    
c  PREVIOUS EVENT SELECTED                                                      
c---------------------------------------------------------------------------    
										
      if(key(1:4).eq.'BACK'.or.key(1:4).eq.'back') then                         
c-- cannot backspace from beginning of list         
	     if(old_no.ne.1) then   
           event_no=event_no-1
           if(slength.gt.0) then
                if(base_dir.eq.'     ') then    ! index file, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
               evfile=sdir(1:slength)//sfiles(event_no)
           else
              evfile=sfiles(event_no)
           endif
	       old_evfile=evfile                                                   
c-- save current event number                
	       old_no=event_no                     
	       status=0                                                            
	    endif                                                                  
	    return                                                                 
      endif                                                                     
										
c---------------------------------------------------------------------------    
c  FIND EVENT BY NUMBER                                                         
c---------------------------------------------------------------------------    
										
c                                                                               
c   find event number in current index file                                     
c                                                                               
      if(key(1:1).eq.'#'.or.key(1:1).eq.'1'.or.key(1:1).eq.'2'.
     *   or.key(1:1).eq.'3'.or.key(1:1).eq.'4'.or.key(1:1).eq.'5'.
     *   or.key(1:1).eq.'6'.or.key(1:1).eq.'7'.or.key(1:1).eq.'8'.
     *   or.key(1:1).eq.'9'.or.key(1:1).eq.'0') then                                                  
	 if(key(1:1).eq.'#') then
	 if(key(2:2).ne.' ') read(key(2:2),'(i1)',err=374) ev_no_wanted                 
	 if(key(3:3).ne.' ') read(key(2:3),'(i2)',err=374) ev_no_wanted                 
	 if(key(4:4).ne.' ') read(key(2:4),'(i3)',err=374) ev_no_wanted                 
	 if(key(5:5).ne.' ') read(key(2:5),'(i4)',err=374) ev_no_wanted                 
	 if(key(6:6).ne.' ') read(key(2:6),'(i5)',err=374) ev_no_wanted                 
      else  
	 if(key(1:1).ne.' ') read(key(1:1),'(i1)',err=374) ev_no_wanted
	 if(key(2:2).ne.' ') read(key(1:2),'(i2)',err=374) ev_no_wanted                 
	 if(key(3:3).ne.' ') read(key(1:3),'(i3)',err=374) ev_no_wanted                 
	 if(key(4:4).ne.' ') read(key(1:4),'(i4)',err=374) ev_no_wanted                 
	 if(key(5:5).ne.' ') read(key(1:5),'(i5)',err=374) ev_no_wanted                 
	 endif
	 if(ev_no_wanted.eq.0) ev_no_wanted=1
	 goto 375
 374     continue
	 write(6,*)' Number not valid'
	 status=9
	 return
 375     continue
c                                                                               
c   start of search loop, one file only                                         
c                                                                               
             if(ev_no_wanted.gt.total_no_events) then
               if(total_no_events.eq.0) then
                  write(6,*)' No more events'
                  status=9
                  return
               endif
               write(6,*)' Number too large'
               status=1
               return
             endif
c            old_evfile=evfile   !!!????? should it be here ?????             
             event_no=ev_no_wanted
             if(slength.gt.0) then
                if(base_dir.eq.'     ') then    ! index file, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
                evfile=sdir(1:slength)//sfiles(event_no)
             else
                evfile=sfiles(event_no)
             endif
	    status=0                                                            
c-- save current index number                       
        old_evfile=evfile                
	    old_no=event_no                     
	    return                                                              
c-- end of number select block                                    
      endif                                     
c                                                                               
c-----------------------------------------------------------------------------  
c   FIND EVENT FROM DATE OF CURRENT MONTH                                       
c-----------------------------------------------------------------------------  
c                                                                               
c   go to nearest date in current month, local index file or local data base                     
c                                                                               
										
      if(key(1:1).eq.'d'.or.key(1:1).eq.'D') then                               
      if(key(2:2).ne.' ') then
	    read(key(2:2),'(i1)',err=628) ev_day_wanted
	  endif
	  if(key(3:3).ne.' ') then 
	     read(key(2:3),'(i2)',err=628) ev_day_wanted                
	  endif
	  read(key(4:5),'(i2)',err=628) hour_wanted
	  goto 629
 628     continue
	  write(6,*)' Invalid date'
      return
 629     continue
c
c-- start searching from beginning if one month in regular data base,
c   if index file or local data base, find next event with EXACT match of day
c
         if(base_dir.ne.'     '.and.base_dir(1:2).ne.',,') event_no=0
 8       continue
            event_no=event_no+1            
            if(base_dir.eq.'     '.or.base_dir(1:2).eq.',,') then
               if(event_no.gt.total_no_events) event_no=1 ! wrap around                                                   
               if(event_no.eq.old_no) goto 9              ! gone round once, stop
            else
               if(event_no.gt.total_no_events) goto 9
            endif

             if(slength.gt.0) then
c
c   if an index file with a complete path, the data base year and  month
c   might change throughout the file. Since sdir only hase one name for the
c   first file, it must be corrected.
c
                if(base_dir.eq.'     ') then    ! index file, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
                evfile=sdir(1:slength)//sfiles(event_no)
             else
                evfile=sfiles(event_no)
             endif
        call get_fstart(evfile,fstart)
      read(evfile(fstart:fstart+4),'(i2,1x,i2)',err=3847) 
     *current_day,current_hour
      goto 3848
 3847 continue
      write(6,'(a,a)')' Error in s-file name ',evfile
      stop
 3848 continue
c
c   check date and time
c
      if(base_dir.eq.'     '.or.base_dir(1:2).eq.',,') then ! local base or in.
         if(current_day.eq.ev_day_wanted.and.current_hour.ge.
     *      hour_wanted) then   
	        status=0                                                            
	        old_no=event_no                                                     
	        return                                                              
	      endif
      else                                                                  
	     if(current_day.ge.ev_day_wanted.and.current_hour.ge.
     *      hour_wanted) then                                  
	        status=0                                                            
	        old_no=event_no                                                     
	        return                                                              
	     endif
      endif                                                                  
c-- try next event                                            
	  go to 8                                
c-- no date larger then current                              
 9       continue                               
    	 evfile=old_evfile                                                      
        event_no=old_no
	  status=1                                                               
      return                                                                 
c-- end of day select block                                       
      endif                                     
										
c                                                                               
c-----------------------------------------------------------------------------  
c   Find events associated in time
c-----------------------------------------------------------------------------  
c                                                                               
c   go to nearest date in current month or local index file                     
c                                                                               
										
      if(key(1:1).eq.'s'.or.key(1:1).eq.'S') then                               
c
c   get abstime  of current event
c
	 call abstim(old_evfile,fstart,tim1) 
c
c   get max time differnece, first set default if not set before
c
	 if(old_time_dif.le.0.or.old_time_dif.gt.9999) old_time_dif=180
	     if(key(2:2).eq.' ') time_dif=old_time_dif
	 if(key(2:2).ne.' ') 
     *      read(key(2:2),'(i1)',err=1628) time_dif
	 if(key(3:3).ne.' ') 
     *      read(key(2:3),'(i2)',err=1628) time_dif                
	 if(key(4:4).ne.' ') 
     *      read(key(2:4),'(i3)',err=1628) time_dif                
	 if(key(5:5).ne.' ') 
     *      read(key(2:5),'(i4)',err=1628) time_dif                
	 if(key(6:6).ne.' ') 
     *      read(key(2:6),'(i5)',err=1628) time_dif                
	 if(key(7:7).ne.' ') 
     *      read(key(2:7),'(i6)',err=1628) time_dif                
	 goto 1629
 1628    continue
	 write(6,*)' Invalid time difference'
	 return
 1629    continue
c-- start searching from current position                           
 1608    continue
            event_no=event_no+1
            if(event_no.gt.total_no_events) goto 1609
             if(slength.gt.0) then
                if(base_dir.eq.'     ') then    ! index file, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
                evfile=sdir(1:slength)//sfiles(event_no)
             else
                evfile=sfiles(event_no)
             endif
	 old_evfile=evfile                                                      
        call get_fstart(evfile,fstart)
c
c   get abs time current event
c
	 call abstim(evfile,fstart,tim2)
c
c   check if within difference
c
	 if(abs(tim1-tim2).lt.time_dif) then                                  
	    status=0                                                            
	    old_no=event_no                                     
	    old_time_dif=time_dif                
	    return                                                              
	 endif                                                                  
c-- try next event                       
	 tim1=tim2                     
	 go to 1608                             
c-- no more associations                              
 1609    continue                               
         
	 status=1                                                               
	 return                                                                 
c-- end of time association block                                       
      endif                                     
c----------------------------------------------------------------------------   
c   GO TO NEXT EVENT                                                            
c----------------------------------------------------------------------------   
c                                                                               
c  go to next event                                                             
c                                                                               
      if(key(1:4).eq.'next'.or.key(1:4).eq.'NEXT'                               
     *.or.key(1:4).eq.'    ') then                                              
 5        continue                                                               
          event_no=event_no+1
          if(event_no.gt.total_no_events) then
             if(from_eev.eq.0.or.from_eev.eq.2) then ! eev over months
c                write(6,*)' goto 6'
                goto 6                  ! next month
             else
                event_no=1              ! start again
c
c   indicate wrap around with a blank line
c
             write(6,*)
c                goto 5                  ! true january ??
             endif
          endif
          if(slength.gt.0) then
                if(base_dir.eq.'     ') then  ! 3 letter data base, fix year and month
                   sdir(slength-7:slength-4)=syear(event_no)
                   sdir(slength-2:slength-1)=smonth(event_no)
                endif
             evfile=sdir(1:slength)//sfiles(event_no)
          else
             evfile=sfiles(event_no)
          endif
          old_evfile=evfile                                                      
c-- save current event number                   
          old_no=event_no                        
c
c   if call from eev, return since time check not needed
c
          if(from_eev.eq.1) then
             status=0
             return
          endif
c                                                                               
c  check if inside time window

          call get_fstart(evfile,fstart)
          call abstim(evfile,fstart,time)                                        
c-- still within time window                    
	      if(time.le.time2) then                 
	         status=0                                                            
	         return                                                              
c-- end of time window                                  
          else                                           
	         status=3                                                            
	         index_open = 0                                                      
	         return                                                              
	      endif                                                                  
c                                                                               
c-- end of month, go to next month                          
c
 6        continue                                   
	      index_open=0             
c          write(6,*)'base dir',base_dir              
         
c                                                                               
c  only continue if standard data base type                                     
c                                                                               
c             if(base_dir.eq.'   ') then  ! until 25-3-97                                           
	      if(base_dir.eq.'     '.or.base_dir(1:2).eq.',,') then                                             
c-- end of single index file                              
	         status=2                            
	         return                                                              
	      endif                                                                  
c                                                                               
c-- year and month, time of next index file                             
c
          month=month+1                          
	      if(month.eq.13) then                                                   
	         month=1                                                             
	         year=year+1                                                         
	      endif                                                                  
c                                                                               
c   get abs time from 1900                                                      
c                                                                               
	      call timsec(year,month,1,0,0,0.0,time)                                 
c          write(6,*) year,month
c          write(6,*)'t,t2',time,time2
c-- not yet end of desired time interval       
	      if(time.lt.time2) then         
c-- make new sdir
             write(sdir(i2+12:i2+15),'(i4)') year
             write(sdir(i2+17:i2+18),'(i2)') month    
             if(sdir(i2+14:i2+14).eq.' ') sdir(i2+14:i2+14)='0'
             if(sdir(i2+17:i2+17).eq.' ') sdir(i2+17:i2+17)='0'
c             write(6,*)'new index',sdir,slength
              write(6,'(1x,i4,1x,i2,1x,$)') year,month

             call sfil
     *       (sdir,slength,sfiles,max_index$,total_no_events)
c
c   update log file
c
             call base_update(total_no_events,base_dir,year,month)
c

c
c   check if no events for new month, if so  write a message
c
             if (total_no_events.eq.0) go to 9364
c-- new month                                         
             new_month=1                                 
             event_no=0
	         index_open=1                                                        
             goto 5
 9364        continue
	         write(6,'(a,i4,1x,i2)')' No data for year and month: ',
     *       year,month
	         goto 5
c-- end of time interval                                           
	     else           
	        status=3                                                            
	        return                                                              
	     endif                                                                  
      endif                                                                     
c										
      return                                                                    
      end                                                                       
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                               

      subroutine base_address(year,month,base_no,pointer)
c
c   calulate address of data base info in data base log file
c   addres is in terms of 4 byte pointers
c
      implicit none
      integer base_no      ! base no
      integer year, month
      integer pointer      ! address in log file
c
c pv  if(year.lt.1900.or.year.gt.2049) then
      if(year.lt.1900.or.year.gt.2099) then
         write(6,*)' Wrong year:',year
         stop
      endif
      pointer=((year-1900)*12+month-1)*100+200+base_no
c
      return 
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine base_get_bases(nbase,base)
c
c     get a list of all data bases (base) in data base, nbase
c     is the number of bases
c     if nbase is  -1, some error has occurred
c     if the central data base file does not exist, create it
c
      implicit none
      include 'libsei.inc'
      character*60 top_directory ! seisan top directory name
      character*800 bases     ! all bases in one string
      character*8   bas(100)  ! -----------
      character*5 base(100)   ! individual bases
      integer nbase           ! number of bases
      character*80 base_file  ! data base log file
      integer ini(100)        ! to initialize
      integer code            ! error code
      integer log_unit        ! unit to read and write from
      logical b_old           ! logical if file is old
      integer i
c
      equivalence (bases,bas)
c
c
c   get location of log file
c
      call topdir(top_directory)
      i=index(top_directory,' ')-1

      base_file = top_directory(1:i)//'/REA/REA.LOG'
      nbase=-1
c

c
c   open data base log file
c
      chr_f_access$='direct'
      f_recl$=800

      call sei open(old$+warn$,           ! Open a existing file.
     &             ' ',                   ! Prompt file name (n/a).
     &             base_file,             ! File name
     &             log_unit,              ! Read unit #1
     &             b_old,                 ! Already exists? (n/a).
     &             code)                  ! Returned condition
      if (code .ne. e_ok$) then
        write(6,*)' No data base log file, now make it'
c
        chr_f_access$='direct'
        f_recl$=400
        call sei open(new$+warn$,         ! Open a existing file.
     &             ' ',                   ! Prompt file name (n/a).
     &             base_file,             ! File name
     &             log_unit,              ! Read unit #1
     &             b_old,                 ! Already exists? (n/a).
     &             code)                  ! Returned condition

        if (code .ne. e_ok$) then
           nbase=-1
           return
        endif
c
        bases=' '
c
c   put blank for base names
c
        write(log_unit,rec=1) bases(1:400)
        write(log_unit,rec=2) bases(1:400)
c
c   put -1 for number of events pr month
c
        do i=1,100
          ini(i)=0
        enddo
c
c   initialize for 150 years, 150*12
c
        do i=3,1802
          write(log_unit,rec=i) ini
        enddo
        call sei close(close$,log_unit,code)                       
        nbase=0
        return
      endif
c
c-------------------------------------
c   a data base log file was present
c-------------------------------------
c
c
c   read data base names and find how many
c
      read(log_unit,rec=1) bases
      do i=1,100
        base(i)=bas(i)(1:5)
        if(base(i)(1:1).eq.' ') then
          nbase=i-1
c          write(6,*)' found',i
          call sei close(close$,log_unit,code)                       
         return
        endif
      enddo
c
      return
      end
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine base_update(nevents,base,year,month)
c
c     updata data base log file with new number of events, nevents 
c     for a particular year and month for a given base
c
      implicit none
      include 'libsei.inc'
      integer nevents,year,month
      character*5 base
      character*60 top_directory ! seisan top directory name
      character*5 bases(100)  ! max 100 data bases
      character*800 b800      ! -----------------
      character*8   bas(100)  ! -----------
      integer nbases          ! number of bases
      character*80 base_file  ! data base log file
      integer code            ! error code
      integer log_unit        ! unit to read and write from
      logical b_old           ! logical if file is old
      integer pointer         ! address of element with data base info
      integer ibase           ! number of the data base
      character*1 ucase
      integer i
c
      equivalence (b800,bas)
      log_unit=77
c
c   if no events, return
c
      if(nevents.eq.0) return
c
c   do not update a local data base or a local index file
c
      if(base(1:2).eq.',,'.or.base.eq.'     ') return
c
c   make sure only upper case is used
c
      do i=1,5
        base(i:i)= ucase(base(i:i))
      enddo

c
c   get location of log file
c
      call topdir(top_directory)
      i=index(top_directory,' ')-1

      base_file = top_directory(1:i)//'/REA/REA.LOG'
c
c  get number of data bases
c
      call base_get_bases(nbases,bases)
      if(nbases.eq.-1) goto 99
c     write(6,*)' Number of bases ',nbases
c
c  find the number of the data base to use
c
      ibase=0
      do i=1,nbases
        if(base.eq.bases(i)) then
           ibase=i
           goto 1
        endif
      enddo
 1    continue
c
c   check if data base was registered in data base log file, if not, do it
c
      if(ibase.eq.0) then
         ibase=nbases+1                     ! number of new data base
         nbases=nbases+1                    ! number of bases after adding one
c
c   open data base log file
c
c        chr_f_access$='direct'
c        f_recl$=800
c
c        call sei open(old$+warn$,        ! Open a existing file.
c    &             ' ',                   ! Prompt file name (n/a).
c    &             base_file,             ! File name
c    &             log_unit,              ! Read unit #1
c    &             b_old,                 ! Already exists? (n/a).
c    &             code)                  ! Returned condition
c                  if(code.ne.e_ok$) goto 99
         open(77,file=base_file,access='direct',recl=800)
c
c   put name in string and write it
c
         bases(ibase)=base
         b800=' '
         do i=1,nbases
           bas(i)(1:5)=bases(i)
           bas(i)(6:8)=' '
         enddo
         write(log_unit,rec=1,err=99) b800
c        call sei close(close$,log_unit,code)
         close(77)
         write(6,*)' Data base log file updated with a new data base'
      endif                       
c
c   open data base file 
c
c      chr_f_access$='direct'
c      f_recl$=4
c      call sei open(old$+warn$,          ! Open a existing file.
c    &             ' ',                   ! Prompt file name (n/a).
c    &             base_file,             ! File name
c    &             log_unit,              ! Read unit #1
c    &             b_old,                 ! Already exists? (n/a).
c    &             code)                  ! Returned condition
c                  if(code.ne.e_ok$) goto 99
c
       open(77,file=base_file,access='direct',recl=4)
c   calculate address to put info
c
      call base_address(year,month,ibase,pointer)
c
c  write info
c
c     write(6,*) 'nev,point',nevents,pointer
      write(log_unit,rec=pointer,err=99) nevents
c     call sei close(close$,log_unit,code)
      close(77)
c
      return
c
 99   continue
      write(6,*)' Error with data base log file, REA.LOG'
      write(6,*)' or you do not have write permission'
      return
      end

      subroutine get_fstart(filename,fstart)
c
c     find start of s-file name and check name
c
      implicit none
      integer fstart,sei clen,i1,i2,i3,i4
      character*80 filename
c
c 
      fstart=sei clen(filename)-18

      read(filename(fstart:fstart+18),'(i2,1x,i4,1x,i2,3x,i6)',  ! check name
     *err=1)i1,i2,i3,i4
      if(filename(fstart+2:fstart+2).ne.'-'.and.
     *   filename(fstart+7:fstart+7).ne.'-') then
         goto 1
      endif
      goto 2
c
c    errror
c
 1    continue
         write(6,*)' Corrupted S-file name, name is:'
         write(6,'(1x,a)') filename
         write(6,*)' Return to stop'
         read(5,'(a)') filename
         stop

 2    continue

      return
      end

c
c   sample program to make graphics
c
c   changes
c
c   june 20 2005 jh : plt to eps


      include 'winplot1.inc'     ! graphics include for pc, a dummy fiel on unix
c     implicit none              ! cannot be used on pc due to windows include
      include 'seiplot.inc'      ! seisan graphics
      real x,y                   ! x-y posiiton
      character*80 text          ! general text
      character*80 answer        ! answer
      integer ich                ! mouse return character
      include 'winplot2.inc'     ! graphics include for pc 

c
c   open an output file
c
      open(1,file='sample_graphics.out',status='unknown') 
c
c   set size in % of sreeen size of plot, only for unix
c
      wsize=60         ! common block variable
c
c   assign file unit for postscriptt file
c
      plotunit=65      ! common block variable

c
c   hard copy unit 0: tektronics, 1: postscript (only 1 works)
c
      hctype=1         ! common block variable
c
c  set defaults for output: 0: screem, 1: screen + file, 2: only file
c
      plotoption=1     ! common block variable
c
c   open postscript output file
c
      open(65,file='sample_graphics.eps',status='unknown')
c
c   open plotter (display and initial output in postscript file)
c
      call open_display
c
c   put a title at 750,700, bottom left corenr is (0,0), max x is 1024,
c   max y is 780.0
c
      text='Sample_graphics program'
c
      call  tchars(text,23,750.0,700.0)  ! this only comes on screen
      call  pchars(text,23,750.0,700.0)  ! this only comes in plot file
c
c  move cursor to (10.0,500.0)
c
      call xmovabs(10.0,500.0)
c
c   draw a line to 300.0, 550.0
c
      call xdrwabs(300.0,550.0)
c
c   draw a text string with a question and get an answer, position 50.0,200.0,
c   the text string has 42 characters and the answer maximum 30
c
      text='Enter a text string, terminate with return'
      call oneline(text,42,answer,30,50.0,300.0)
      write(1,'(a)')' Answer from keyboard:'
      write(1,'(1x,a)') answer      ! write answer to file
      write(1,*)                 ! blank line
      write(1,'(a)')' Character  ASCii value       x      y'
c
c   call up cursor to be moved with the the mouse, when cursor is
c   pushed, the key ascii code is stored in ich and the posiiton in
c   x and y. Enter a loop with mouse where a line is drawn to
c   each mouse click or character press, terminates with character q.
c   mouse click characters and position is output in file.
c
c   first give info text
c
      text='Press mouse to mark position, q to terminate'
      call  tchars(text,80,20.0,20.0)  ! this only comes on screenc
c
c   put cursor in midle o fscreen
c
      call xmovabs(512.0,390.0)
c
c   start of loop
c
 10   continue
c
c   call up cursor
c
      call xscursr(ich,x,y)
c
c   write values in file
c
      write(1,'(9x,a1,7x,i6,1x,2f7.1)') char(ich),ich,X,Y
c
c   check if finish
c
      if(char(ich).eq.'q') goto 20
c
c   draw a line to cursor
c
      call xdrwabs(x,y)
c
c   back to call up cursor again
c
      goto 10
c
c   finished
c
  20  continue

c
c   close postscript output
c
      call close_post
c
c   close output plot file
c 
      close(65)
c
c   close display and back to alpha screen
c          
c
      call clear_to_alpha
      close(1)           ! close output file
      write(6,*) 'Output file in sample_graphics.out'
      write(6,*) 'Putput graphics file in sample_graphics.eps'
c
c   on pc, puse to see final text screen, else it disappears
c   on stop
c
      write(6,*) 'Return to stop'  !
      read(5,'(a)') ich   
      stop
      end

c--------------------------------------------------------------------------
c  plot travel times
c--------------------------------------------------------------------------c
c
c      implicit none                       ! force delcaration of all variables
      include 'winplot1.inc' 
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common block
      include 'version.inc'
      include 'libsei.inc'

      include 'seiplot.inc'               ! seisan graphics
      character*1 cha(10)                 ! dummy for xy_plot

      character*1 make_plot

      character*80 text(1000)             ! general text
      character*80 txt(100)
      character*80 title                  ! title for plot
      character*80 answer                 ! input text
      character*30 xtext,ytext            ! axis title
      character*80 data(max_data)         ! s-file with data in text array
      character*80 infile                 ! input file
      character*10 phase(max_data)        ! phase name     
      character*5  stat(max_data)         ! stations with p
      real         time(max_data)         ! abs arrival time
      real         res(max_data)          ! travel time residual
      real         dist(max_data)         ! distance from earthquake
      real         timecalp(max_data),timecals(max_data)      
                                          ! calclualeted first times
      real         distcal(max_data)
      character*10 sel_phase(max_data)    ! ------------------------
      character*5  sel_stat(max_data)     ! same as data above for
      real         sel_time(max_data)     ! selected stations
      real         sel_res(max_data)      ! selected stations
      real         sel_dist(max_data)     ! ------------------------
      real corr, rms                      ! correlation coefficient and rms
      real xm,ym                          ! cursor input
      real xc,yc                          ! scaling factors
      real*8 ot                           ! origin time
      real mindist,maxdist,xdist          ! distance range
      real maxtime
      integer ndist                       ! number of distances to calculate phases

      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer seiclen
      integer il                          ! line counter
      integer i,k,l,n,j                   ! counter
      real y                              ! y plot coordinate
      real dist1,dist2                    ! distance range

      include 'winplot2.inc'

      dist1=0.
      dist2=99999.
c
c   start writing from line 1
c
c   check if input via argumants
c
      call get_arguments(n,infile)
c
      if(n.lt.1) then
c
c   get input file name, check if exist
c
 9       continue
         write(6,*) 'Give input file'
         read(5,'(a)') infile
      endif
c
c check that event local or regional
c 
      open(1,file=infile,status='old',err=10)
      call rea_event_in(1,all,data,code)
      close(1)
      if (hyp_dist_id(1).ne.'L'.and.hyp_dist_id(1).ne.'R') then
        write(*,*) ' ttplot only works for local and regional events '
        stop
      endif
c
c   set text for no write out for hyp for some operations
c
      txt(1)='hyp non interactive'
      write(6,*)
      write(6,*)' **** now locating with hyp as a preparation ***'
      write(6,*)
      call put_seisan_message(txt(1))
      call systemc('hyp',3)            ! locate
      open(1,file='hyp.out',status='old',err=10)

      goto 11
 10   continue
      write(6,*)' No such input file'
      goto 9
 11   continue

      all=.true.                  ! read all parameters
c
c   open output file
c
      open(2,file='ttplot.out',status='unknown')  
c
c
c   read all parameters for one event from file unit 1
c
      call rea_event_in(1,all,data,code)
c
c   check if end of file (code=1), if so terminate program
c
      if(code.eq.1) goto 1000
c
c   write the whole first header line
c
      write(6,'(a)') data(1)(1:79)
      write(text(il),'(a)') data(1)(1:79)
c
c compute abs origin time
c
      call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     &   hyp_hour(1),hyp_min(1),hyp_sec(1),ot)
c      write(*,*) ' time ',hyp_year(1),hyp_month(1),hyp_day(1),
c     &   hyp_hour(1),hyp_min(1),hyp_sec(1),ot
c
c store phases
c
      mindist=9999.
      maxdist=0.
      maxtime=0.
      k=1
      do i=1,rea_nphase
        if (rea_phase(i)(1:2).ne.'AM'.and.
     *      rea_phase(i)(1:1).ne.'E'.and. rea_phase(i)(1:1).ne.'I') then
c travel time
         if (rea_dist(i).ne.-999.) then
           call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     &       rea_hour(i),rea_min(i),rea_sec(i),rea_abs_time(i))
           time(k)=rea_abs_time(i)-ot
           stat(k)=rea_stat(i)
           dist(k)=rea_dist(i)
           res(k)=rea_res(i)
           phase(k)=rea_phase(i)
c
c find distance range
c
           if (dist(k).gt.maxdist) maxdist=dist(k)
           if (dist(k).lt.mindist) mindist=dist(k)
           if (time(k).gt.maxtime) maxtime=time(k)
           k=k+1
         endif
        endif
      enddo
      k=k-1
c
c write all phases to output
c
      do i=1,k
        write(2,'(a5,1x,a10,1x,f6.1,1x,f6.1,1x,f6.2)')
     &      stat(i),phase(i),dist(i),time(i),res(i)
      enddo

c
c calculate phases
c
      ndist=100
      call traveltimes(hyp_model(1),mindist,maxdist,ndist,hyp_depth(1),
     *   timecalp,timecals,distcal)
c
c   put into x and y variables for least squares
c
c      do i=2,k
c        x(i-1)=stat_y(i)/stat_x(i)
c        y(i-1)=time_p(i)/stat_x(i)
c      enddo
c      call lsqlin(k,x,y,py,px,corr,rms)


c
c  set defaults for output on screen and one hardcopy file
c
          open(65,file='ttplot.eps',status='unknown')
          plotunit=65
          plotoption=1
          hctype=1
          wsize=60
c
c   open plotter
c
c
c   set some postscipt scalings
c
          write(65,*) ' 1.0 0.55 scale'

          xtext=' Distance-km '
          ytext=' Travel time-sec '

c
c   open display
c
        call open_display
50      continue
        call clear_display
c
c selection
c
       l=0
       do i=1,k  
         if (dist(i).ge.dist1.and.dist(i).le.dist2) then
           l=l+1
           sel_dist(l)=dist(i)
           sel_phase(l)=phase(i)
           sel_stat(l)=stat(i)
           sel_time(l)=time(i)
           sel_res(l)=res(i)
         endif
       enddo

c
c   plot points
c
        call xy_plot
     *    (1,l,sel_dist,sel_time,title,xtext,ytext,
     *    600.0,600.0,100.0,100.0,1,1,20.0,
     *    0,cha,i,dist,time)
c
c plot calculated times
c
        k=0
        do j=1,ndist
          if (distcal(j).le.maxdist.and.
     *        timecalp(j).le.maxtime) k=j
        enddo
        call xy_plot
     *    (1,k,distcal,timecalp,title,xtext,ytext,
     *    0.,600.0,100.0,100.0,2,1,20.0,
     *    0,cha,i,dist,time)
        k=0
        do j=1,ndist
          if (distcal(j).le.maxdist.and.
     *        timecals(j).le.maxtime) k=j
        enddo
        call xy_plot
     *    (1,k,distcal,timecals,title,xtext,ytext,
     *    0.,600.0,100.0,100.0,2,1,20.0,
     *    0,cha,i,dist,time)

c  plot line
c
c          call xy_plot_line(px,py,100.0,100.0)
c
c plot text
c
          txt(1)='Select station by'
          txt(2)='clicking near symbol'
          call xmessage(txt,2,25,720.0,650.0)
c
c help text
c
          txt(1)='Press   R for Replot   D for Distance selection'//
     &           '   Q for Quit '
          call xmessage(txt,1,seiclen(txt(1)),200.0,720.0)

c
c  call up cursxor so plots remains
c
 55       continue
          call xy_plot_input(100.0,100.0,cha(1),xm,ym,xc,yc)
c
c check if distance selection
c
          if (cha(1).eq.'d'.or.cha(1).eq.'D') then
            txt(1)='Give distance range (d1,d2) '
            call oneline(txt(1),seiclen(txt(1)),answer,20,150.,500.)
            call sei get values(2,answer,code)
            dist1=ARRAY$(1)
            dist2=ARRAY$(2)
            goto 50
          elseif (cha(1).eq.'r'.or.cha(1).eq.'R') then
            dist1=0.
            dist2=99999.
            goto 50
          endif
 
c
c   find corresponding station
c
          txt(1)='Too far from symbol,'
          txt(2)='try again'
          do i=3,10
            txt(i)=' '
          enddo
          j=2
          y=500.
          call xmessage(txt,10,40,720.0,y)
          do i=1,l
              if(abs(xm-sel_dist(i))*xc.lt.10.0.and.   ! distance in pixels
     *           abs(ym-sel_time(i))*yc.lt.8.0) then
                 txt(1)='STAT  PHASE      DIST   TIME    RES'
                 write(txt(j),
     *             '(a5,1x,a8,1x,f6.1,1x,f6.1,1x,f6.2)')
     *  sel_stat(i),sel_phase(i),sel_dist(i),sel_time(i),sel_res(i)
                 if (j.eq.2) j=1
                 call xmessage(txt,10,40,720.0,y)
                 txt(1)=' '
                 txt(2)=' '
                 y=y-20.
              endif
          enddo

          if(cha(1).ne.'q') goto 55   ! next input

c 
c   close postscript
c
          call close_post
c
c   close output plot file
c
          close(65)
c
c   close display and back to alpha screen
c
         write(6,*)
         write(6,*)' Plot file is ttplot.eps'
 30   call clear_to_alpha

c
c     end of file
c
 1000 continue
c
      write(6,*)            ! blank line
      write(6,*) ' Output file is ttplot.out'


      stop
      end


      subroutine xy_plot_input(x0,y0,c,x,y,xc,yc)
c
c  reads positions from the screen much like the main routine
c  all scaling values from routine xy_plot via common
c  x0,y0 are lower left hand corner of plot
c
c  x0,y0 : same input as main routine
c  x,y   : output in scaled units
c  c     : character pressed
c  xc    : xscale
c
       implicit none
       character*1 c
       integer ichar
       reaL xc,yc   ! same as x and yscale
       real x1,x,y1,y   ! help variables
       real xfirst,yfirst,x0,y0,xscale,yscale,ymin,ymax,xmin,xmax ! see xy_plot
       common/xy_plot_common/xfirst,yfirst,xscale,yscale,ymin,
     *                       ymax,xmin,xmax
c
c   call up cursor
c

   1        continue
            call xscursr(ichar,x1,y1)
            if (char(ichar).eq.'#') goto 1
            c=char(ichar)
            x=(x1-x0)/xscale+xfirst
            y=(y1-y0)/yscale+yfirst
            xc=xscale
            yc=yscale
c
      return
      end

      subroutine traveltimes(model,mindist,maxdist,ndist,depth,
     *   timep,times,distance)

c**********************************************************************
c subroutine to calculate travel times for given model and distance range
c modified from program ttlayer
c***********************************************************************
     
      implicit none
      include 'hypparm.inc'
      character*1 model
      real mindist,maxdist,depth,delta_dist
      integer ndist
      real timep(*),times(*),distance(*)
      character*80 infile,outfile  
      character*80 indat,testdat
      character*1 reff,ucase,prmd,prm2
      character*4 stat
      character*8 phsid
      real vpp(nlayer)
      logical exist
      character*60 top_directory
      character*1 dchar
      real rearth
      integer seiclen
      real pi,degtorad,testj,xnear,xfar,dist,tmin,delta,tpp,ann
      integer i,j,nmoho,nconrad,iulst,nd,iflag,minflag,iustat

      pi=3.141593
      degtorad=pi/180.
      rearth=6371.                         

c
c get directory structure
c
      call topdir(top_directory)
      call dir_char(dchar)         ! dirctory delimiter character
      infile='STATION0.HYP'
      if (model.ne.' ') write(infile(8:8),'(a1)') model

c
c find station file
c
      inquire(file=infile, exist=exist)
      if (.not.exist) then

         infile = top_directory(1:seiclen(top_directory)) // dchar // 
     &         'DAT' // dchar //
     &         infile(1:seiclen(infile))

         inquire(file=infile, exist=exist)
         if (.not.exist) then
           write(*,*) 'station file does not exist !'
           stop
         endif
      endif
      open(9,file=infile)
      outfile = 'ttlayer.out'
      open(10,file=outfile)
      iustat=9         
      open(14,file='out')
c    set test parameter defaults
        call settest(test)

c    read test parameter changes and station data
c    changed 4/94 to read character string and check for ")" so reset test(1) is OK
        stat='xxxx'
        j=-1
        
        do while (stat.ne. '    '.and.j.ne.0)
         read(iustat,'(a80)')testdat
         if(testdat(14:14).eq.')')then
          read(testdat,'(a4,t12,i2,t16,f9.4)')stat,j,testj
         elseif(testdat(13:13).eq.')')then
          read(testdat,'(a4,t12,i1,t15,f9.4)')stat,j,testj
         else
          read(testdat,'(a4)')stat
          j=-1
         endif
         if(j.gt.0)then
          test(j)=testj
         endif
        end do

      indat='XXXXXXXX'
      do while (indat(1:8).ne.'        ')
       read(9,'(a80)')indat
      end do

c read the velocity model
        i=1
        iustat=9
        
c    reff is used to specify the moho layer for PN calculation
5       read(iustat,101,end=99)v(i),d(i),vs(i),reff
101     format(3f7.3,a1)
        if(ucase(reff).eq.'N')nmoho=i

c 4/94: added nconrad variable
        if(ucase(reff).eq.'B')nconrad=i
        
        if(v(i).eq.0.0)go to 6
        i=i+1
        go to 5

c    nl is the number of layers in the velocity model
6       nl=i-1

c    read in trial depth and vp/vs ratio
        read(iustat,'(3f5.0,f5.2)',end=99)ztr,xnear,xfar,pos

c    if vs(1)=0 then set vs(i)=v(i)/pos
        if(vs(1).eq.0.0)then
          do i=1,nl
            vs(i)=v(i)/pos
          end do
        endif

c  store thicknesses in parm
        do i=1,nl-1
          parm(nl+i)=d(i+1)-d(i)

c    change 10/93: add maximum elevation to upper layer thickness
c    if test(40)=0.0 Need this because dtdx2 origin is always at maxelv
c          if(i.eq.1.and.test(40).eq.0.0)then
c            parm(nl+i)=d(i+1)-d(i)
c          endif
        end do
        do i=1,nl
          parm(i)=v(i)
        end do
c       nn=2*nl-1

      minflag=int(test(63))      
        
c    xs(1), xs(2) are the station long. and lat.
      x0(1)=0.0
      x0(2)=0.0
      x0(3)=0.0
      
      prmd=' '                        
      prm2=' '

      iulst=10
      nd=100

      xh(2)=0.0
      xh(3)=depth

c
c write some info
c
      delta_dist=(maxdist-mindist)/float(ndist)
      dist=mindist
      ndist=0    ! now used as counter
      do while (dist.le.maxdist) 
       ndist=ndist+1
       do i=1,nl
         parm(i)=v(i)
       end do
       xh(1)=dist/rearth
c
c p time
c
       call dtdx2(xh,x0,prmd,nmoho,nconrad,iulst,tmin,
     &  dx,delta,ann,iflag,phsid)
       if(iflag.eq.0)tmin=0.0
       tpp=tmin
       do i=1,nl
          parm(i)=vs(i)
          vpp(i)=v(i)
       end do
c
c s time
c
       call dtdx2(xh,x0,prmd,nmoho,nconrad,iulst,tmin,
     &  dx,delta,ann,iflag,phsid)
       if(iflag.eq.0)tmin=0.0
       
       do i=1,nl
         v(i)=vs(i)
       enddo
       timep(ndist)=tpp
       times(ndist)=tmin
       distance(ndist)=dist
       write(10,'(5f12.3)')dist,tpp,tmin
       dist=dist+delta_dist
       do i=1,nl
         v(i)=vpp(i)
       enddo
      end do
      
99    continue
      close(9)
      close(10)

      end
      

C   computer dependent subroutines including dummy routines to be
c  able to use same programs on linux, pc and sun
c
c    ***** this file is for sun and linux******
c
c
c  Updates:
c
c  jul 20 94 by jh    : add get_display
c  nov 24       jh    : add clear_to_text
cJAB(BGS)Jan95        : add get_arch to find SEISAN operating system environment
cJAB(BGS)Jul95        : add dummy PC_TO_TEXT which on PC clears to alpha.
cJAB(BGS)Jul95        : add random number generator 
c  jun 96       jh    : add editor name
c  feb 97       lo    : add cputimer
c  feb 24 97    jh    : add tektronics dummy routines
c  oct 6              : add put_env_string and get_env_string
c  sep 98       jh    : -----------   version 7.0 check -----------------
c                       data base to 5 chars
c  sep 98       linux :  removed ieee_flag, drand  
c  nov 4 98 by jh     : linux logic removed from this file whcih was
c                       renamed comp_unix
c  mar 23, 99  lo     : in get_env_base put _ if blank
c  mar 30 99 bmt      : remove pc_to_text
c  sep 16, 99  lo     : send_plot, use sleep
c  jan 18 2000 bmt    : add put_env_seistop     
c  dec 14 2000 lo     : change in uncompress routine
c  feb 21 2001 lo     : changed arguments to subroutines to variable length
c  jul 18 2005 lo     : added get_env_sacaux
c  oct 28 2005 jh     : initilize arguments
c
      subroutine topdir(top_directory)
c
c  path-name for main directory of seisan seismic analysis system
      character*(*)      top_directory
c   change following line if needed, now only on vax, sometimes on pc:
c
c   get top dir from enviromental variable, usually defined in ../COM/.SEISAN
c
      call getenv('SEISAN_TOP',top_directory)
      return
      end
c
      subroutine get_editor(eev_edit)
c
c   get editor name for eev
c
      character*(*) eev_edit
      integer sei clen
c
c  get env variable
c
      call getenv('SEISAN_EDITOR',eev_edit)
c
c   set to default if not set
c
      if(sei clen(eev_edit).eq.0) eev_edit='vi'
      return
      end

c
c get env variable SEISAN_EXTENSION
c
      subroutine get_env_seisan_extension(text)
      implicit none
      character text*(*)
      call getenv('SEISAN_EXTENSION',text)
      return
      end

c
c get operator id
c
      subroutine get_env_op(text)
      implicit none
      character*(*) text
      call getenv('SEISAN_OPERATOR',text)
      return
      end

c
c    get event name if any
c
      subroutine get_env_event(event)
      implicit none
      character*(*) event
      call getenv('TRANSFER_EVENT',event)
      return
      end
c
c   put event in memory
c
      subroutine put_env_event(event)
      implicit none
      character*(*) event
      character*100 text
      write(text,'(a,a)')'TRANSFER_EVENT=',event
      call putenvsun(text)   !c call
      return
      end
c
c   put base name in memory
c
      subroutine put_env_base(base)
      implicit none
      character*(*) base
      character*100 text
      write(text,'(a,a)')'TRANSFER_BASE=',base
      call putenvsun(text)   !c call
      return
      end

      subroutine put_env_seistop(path)
      implicit none
      character*(*) path
      character*100 text
      write(text,'(a,a)')'SEISAN_TOP=',path
      call putenvsun(text)   !c call
      return
      end

      subroutine put_env_op(op)
      implicit none
      character*(*) op
      character*100 text
      write(text,'(a,a)')'SEISAN_OPERATOR=',op 
      call putenvsun(text)   !c call
      return
      end


c
c    get base  name if any
c
      subroutine get_env_base(base)
      implicit none
      character*(*) base 
      call getenv('TRANSFER_BASE',base)
      return
      end
c
c    get alternative cal directory if there 
c
      subroutine get_env_cal(local_cal)
      implicit none
      character*(*) local_cal
      local_cal=' '
      call getenv('LOCAL_CAL',local_cal)
      return
      end

c
c get SACAUX
c
      subroutine get_env_sacaux(text)
      implicit none
      character*(*) text
      text=' '
      call getenv('SACAUX',text)
      return
      end

c
c
      subroutine get_def_base(def_base)
c
c   get enviromental variable def_base 
c
      character*(*) def_base 
      integer i
      call getenv('DEF_BASE',def_base)
      if (def_base(1:1).ne.' ') then
        do i=2,5
          if (def_base(i:i).eq.' ') def_base(i:i) = '_'
        enddo
      endif
      if(def_base.eq.'   '.or.ichar(def_base).eq.0) def_base='AGA__'
      return
      end
c
c
c
c    get a general string from any program
c
      subroutine get_env_string(text)
      implicit none
      character*(*) text
      text=' '
      call getenv('ANY_STRING',text)
      return
      end
c
c
c   put a general string  to enviromental variable
c
      subroutine put_env_string(text)
      implicit none
      character*(*) text
      character*100 text1
c      integer seiclen
      text1=' '
      write(text1,'(a,a)')'ANY_STRING=',text
      call putenvsun(text1)   !c call
      return
      end



      subroutine get_agency(agency)
c
c   get agency 
c
      character*(*) agency 
      call getenv('AGENCY',agency)
      return
      end
c
c   get Environment Architecture...
c
      integer function get_arch( chr_arch )
      character    chr_arch *(20)          ! Operating system
      call getenv('SEISARCH',chr_arch)
      chr_arch = chr_arch(:index(chr_arch,' ')-1) //
     &           char(0)                   ! Add a null.
      get_arch = 0                         ! Return a success.
      return
      end
c
c
c  send plot to laser
c
      subroutine send_plot(t,ilength)
      character*(*) t
      character*240 text
      integer ilength
      text=t
      call systemc('lpr '//text(1:ilength),ilength+4)
c     call systemc('lp -c '//text(1:ilength),ilength+6)
c     call system('lp -c '//text(1:ilength))
c
c due to problem on Solaris, wait for 5 secs after each plot
c
      call sleep(5)
      return
      end

      subroutine get_display(display_type)
      implicit none
      integer display_type
      character*80 text
c
c   get display type
c
      call getenv('DISPLAY',text)
      display_type=1                        ! x-window
      if(text(1:2).eq.'  ')display_type=0   ! tektronics 
      return
      end

c
      subroutine dir_char(dchar)
c   directory separator character
      implicit none
      character*1 dchar
      dchar='/'
      return
      end
c
c   input of arguments using sun calls
c
      subroutine get_arguments(nars,argument)
      implicit none
      integer nars,i,iargc
c      character*80 argument(*)
      character*(*) argument(*)
c
c   get number of arguments
c
      nars=iargc()
c
c   get actual arguments
c
      if(nars.gt.0) then
         do i=1, nars
           argument(i)=' '    ! jh oct 08
           call getarg(i,argument(i))
         enddo
      endif
c
      return
      end
c
c  clear underflow on sun to gewt rid of message at end of execution
c
      subroutine clear_underflow
c      j=ieee_flags('clear','exception','all')
c     write(6,*)'clear'
      return
      end
c      
      real function sei rand( function )
CSTART**************************************************************************
C                                                                              *
C   Supplier          : BGS/GSRG Applications Programming Unit                 *
C   System            : SEISAN                                                 *
C   Procedure Name    : SEI RAND                                               *
C   Purpose           : To set up a random sequence (seed 1) or return a       *
C                       a random number depending on function                  *
C   Arguments  -input : function (I) function to perform. Values are:          *       
C                                    OPEN$ - seed the generator                *
C                                    READ$ - read a random value               *
C   Note              : For use on SUN                                         *
C                       Function value returns random number (-1.0 -> +1.0)    *
C   Author            : J. A. Bolton                                           *
C   Date              : 4 July 1995                                            *
C   Version           : V01                                                    *
C                                                                              *
CEND****************************************************************************
c
      external     drand                   ! Random # generator (0.0->1.0)
     &            ,sei code                ! Error handler.
      real*8       drand                   ! & function.
c
c    System definitions...
c    =====================
c
      include 'libsei.inc'                 ! Library definitions.               
c
c    Arguments...
c    ============
c
      integer      function                ! Function toperform.
c
c    Local variable...
c    =================
c
      real*8       value                   ! & value.
      logical      b_flag                  ! Dummy operations flag.
c
c    Initialise...
c    =============
c
      if( function .eq. open$ ) then       ! Set up.
c      value = drand(1)                     ! Start the randomiser.
      value = 0.0d0                        ! Re-set returned value.
c            
c    Read a random number...
c    =======================
c
      else if( function .eq. read$ ) then  ! Get a random number.
      value = -1.0d0 + 2.0d0 ! *drand(0)      ! & value.
c
c    Invalid function...
c    ===================
c
      else                                ! Invalid.
      call sei code( stop$, e_init$, 0, b_flag ) ! Abort, bad initialisation.
      end if                              !
c
c     Return to Caller...
c     ===================
c
9999  sei rand = value                    ! Install the number.
      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   dummies
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c

      subroutine gettim(i1,i2,i3,i4,i5)
c dummy from pc
      implicit none
      integer*2 i1,i2,i3,i4,i5
      return
      end
c
      subroutine getdat(i1,i2,i3)
c   dummy from pc
      integer*2 i1,i2,i3
      return
      end
c
c
      subroutine clear_to_text()
      return
      end
c
      subroutine set_color_pc(color)
      return
      end
c
      subroutine sscursr(key,ix,iy)
      integer key,ix,iy
      return
      end
c
      subroutine set_back_pc(color)
      integer color
      return
      end
c
      subroutine dirf_pc(dir,file,n)
      character*(*) dir
      character*(*) file(*)
      integer n
      return
      end
c

      subroutine movabs(ix,iy)
      integer ix,iy
      return
      end
c
      subroutine drwabs(ix,iy)
      integer ix,iy
      return
      end
c
      subroutine initt(baud)
      integer baud
      return
      end
c
      subroutine finitt(k,j)
      integer k,j
      return
      end
c
      subroutine erase()
      return
      end
c
      subroutine tsend()
      return
      end
c
      subroutine anstr(char,i)
      integer i
      character*1 char(*)
      return
      end
c
      subroutine scursr(ich,ix,iy)
      integer ich,ix,iy
      return
      end
c
      subroutine ancho(i)
      integer i
      return
      end

      subroutine anstrpc(it,k,ix,iy)
      integer it
      character*80 k
      integer ix,iy
      return
      end

      subroutine get_env_psscale(xscale,yscale)
c
c   get scaling parameters 
c
      implicit none
c      character*80 text
      character*5 scale 
      real xscale,yscale
      integer sei clen
c
c  get SEISAN_PSSCALE_X variable
c
      call getenv('SEISAN_PSSCALE_X',scale)
c
c   set to default if not set
c
      if (sei clen(scale).eq.0) then
         xscale=0.55
      else
        read(scale,'(f5.2)') xscale
      endif

c
c  get SEISAN_PSSCALE_Y variable
c
      call getenv('SEISAN_PSSCALE_Y',scale)
c
c   set to default if not set
c
      if (sei clen(scale).eq.0) then
        yscale=1.0
      else
        read(scale,'(f5.2)') yscale
      endif

      return
      end


      subroutine uncompress_file(file)
c
c check if file is compressed and uncompress
c

      implicit none

      character*(*) file      ! file name
      character*220 text     ! system call
      character*60 top_dir   ! Seisan top directory
      character*1 dchar      ! Directory deliminator
      character*20 compression_format
      integer seiclen
      integer i,j            ! counters

      call topdir(top_dir)
      call dir_char(dchar)

      compression_format = ' '

c
c check which compression format used  
c
      if (file(seiclen(file)-1:seiclen(file)).eq.'gz') then
        compression_format = 'gzip'
      elseif (file(seiclen(file)-2:seiclen(file)).eq.'zip') then
        compression_format = 'zip'
      elseif (file(seiclen(file)-1:seiclen(file)).eq.'.Z') then
        compression_format = 'compress'
      elseif (file(seiclen(file)-2:seiclen(file)).eq.'bz2') then
        compression_format = 'bzip2'
      endif

      if (compression_format.eq.' ') then
        return
      endif

c
c copy file to TMP directory
c
      text = ' '
      text = 'cp -f ' // file(1:seiclen(file)) // ' ' //
     *         top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar

      write(*,*) text(1:seiclen(text))
      call systemc(text,seiclen(text))

c
c set j to last '/'
c
      j=0
      do i=seiclen(file),1,-1
        if (file(i:i).eq.'/'.and.j.eq.0) j=i
      enddo
      j=j+1

c 
c uncompress if gzip
c   
      text = ' '
      if (compression_format.eq.'gzip') then
        text = 'gunzip -f ' // top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file))
        write(*,*) text(1:seiclen(text))
        call systemc(text,seiclen(text))
        file = top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file)-3)

c 
c uncompress if zip 
c   
      elseif (compression_format.eq.'zip') then
        text = 'unzip ' // top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file))
        write(*,*) text(1:seiclen(text))
        call systemc(text,seiclen(text))
        file = top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file)-4)
c 
c uncompress if compress
c   
      elseif (compression_format.eq.'compress') then
        text = 'uncompress ' // top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file))
        write(*,*) text(1:seiclen(text))
        call systemc(text,seiclen(text))
        file = top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file)-2)
c 
c uncompress if bzip2
c   
      elseif (compression_format.eq.'bzip2') then
        text = 'bzip2 -d ' // top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file))
        write(*,*) text(1:seiclen(text))
        call systemc(text,seiclen(text))
        file = top_dir(1:seiclen(top_dir)) // dchar //
     *         'TMP' // dchar //
     *         file(j:seiclen(file)-4)

      endif

      return
      end

      program sacsei

c
c by Lars Ottemoeller
c
c program to convert between sac and seisan, detects if ASCII
c or binary, uses SEISAN wav structure
c
c 
c      options are: sac        -> seisan bin
c                   seisan bin -> sac bin
c ---------------------- SEISAN 7.0 ----------------------------------
c 14 ap 99 bmt  : name of the component was changed
c 08/06 99 lo   : use routine filename
c june 11 99 lo : convert station and components using sacsei.def file
c aug  18 99 lo : bug fixed with net_code
c nov  09 99 lo : dimension of fheader changed to max_trace, bug on linux fixed
c nov  11 99 lo : add cname to outfile, using seiclen
c dec  06 99 lo : add 1900 if year lt 100
c --- major change ----------------------- 
c may  12 00 lo : use new routines
c nov 13 2001jh : remove component change since already in basic 
c                 sac reading routine
c dec 18 2002 jh: make sure net_code is blank to get station name in 
c                 file name, note not net code can be used in scasei.def
c                 since sacsei.def is read in sac subroutines

      implicit none

C    Seisan library inserts and routines...
C    ======================================
C
      include 'libsei.inc'                ! Open file definitions
      include 'seidim.inc'
      include 'waveform.inc'
      external computer_type              ! Get platform type.
      external sei open,                  ! Open file routine.
     &         sei close                  ! Close file routine.
      integer sei clen
c --------------------------------------------------------------

      character*80 infile,outfile       ! file name
      integer max                       ! max number of samples
      integer nerr                      ! error 
      integer*4 idata(max_sample)
      character*1 choice                ! choice
      character*80 mainhead(max_trace)  ! file headers
      character*1040 chead              ! trace header
      integer i,c                       ! counter
      integer in                 ! 1 if filenr.lis is input file
      integer nars                      ! number of args
      character*80 args(5)              ! arguments
      logical from_eev                  ! true if from eev
      character*80 evfile               ! name of sfile
      real eqla,eqlo,eqel               ! hypocenter coordinates
      character*80 line                 ! some text line
      logical hyp                       ! if hyp given in sfile
      character*80 question,deffile     ! text
      character*5 net_code              ! network code
c jh dec 2002     logical no_net                    ! flag if net_code set
      character*29 mainhead_text
      


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver


c
c   get def file for station codes, give file name
c
c     deffile='sacsei.def'
c     no_net = .FALSE.
      net_code=' '

c     call read_def_chan(deffile,mainhead_text,net_code)

c     if (net_code.eq.' ') no_net = .true.

c get arguments
      call get_arguments(nars,args)
      in = 0
      max = max_sample 
      from_eev=.false.
      hyp = .false.

      if (nars.eq.3) then

        if (args(1).eq.'eev') then

          infile=args(2)
          call get_env_event(evfile)

          open(1,file=evfile,status='old')
          read(1,'(a80)') line
          close (1)
c
c read eq hypocenter coord
c 
          if (line(24:38).ne.'               ') then
            hyp=.true.
          endif
          read(line(24:30),'(f7.3)') eqla
          read(line(31:38),'(f7.3)') eqlo  
          read(line(39:43),'(f5.2)') eqel 
          from_eev=.true.
          goto 500
        endif
      endif

      write(*,*) ' (1) sac (ASCII or BINARY) -> seisan binary'
      write(*,*) ' (2) seisan binary -> sac binary'
      write(*,*) ' Choice ?'
      read(*,'(a1)') choice 
      call casefold(choice)
c
c jump to seisan input
c
      if (choice.eq.'2') then 
        goto 500
      elseif (choice.eq.'1') then
        goto 21 
      else
        write(*,*) ' wrong choice'
        stop
      endif 

c 
c read SAC
c

21    continue
      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)

      if (infile(1:3).eq.'EOF') STOP
      if(infile(1:10).eq.'filenr.lis') then
        open(1,file='filenr.lis',status='old',err=22)
        in=1
      endif
      goto 23

22    continue

      write(*,*) ' filenr.lis not found'
      stop

23    continue

      if(in.eq.1) then
        read(1,'(7x,a)') infile
        if(infile(1:4).eq.'    ') stop
      endif

c
c first try if file is binary SAC
c
      call read_sacbin_to_seisan(infile,1,nerr)

c
c if not check if SAC ascii
c
      if (nerr.ne.0) then
        nerr=0
        call read_sacasc_to_seisan(infile,1,nerr)
      endif

      if (nerr.ne.0) then
        write(*,*) ' input file is not SAC: ',infile(1:seiclen(infile))
        if (in.eq.1) goto 23
        stop
      endif

c
c write Seisan file
c

c
c write file header
c
      outfile = ' '

c     call set_def_chan(1,wav_stat(1),wav_comp(1))

c
c   make seisan headers
c
       net_code=' '

       wav_nchan=1
       call wav_sheads(1,net_code,outfile,mainhead,chead)

       write(*,*) chead(1:80)

       do i=1,wav_nsamp(1)
         idata(i)=int(signal1(i))
       enddo
       outfile = outfile(1:seiclen(outfile)) // '_' // 
     &   wav_comp(1)(1:seiclen(wav_comp(1)))
       do i=1,seiclen(outfile)
         if (outfile(i:i).eq.' ') outfile(i:i)='_'
       enddo
       write(*,*) ' output file: ',outfile(1:seiclen(outfile))
       open(66,file=outfile,status='unknown',form='unformatted')
       do i=1,12
          write(66) mainhead(i)
       enddo
       write(66) chead
       write(66) (idata(i),i=1,wav_nsamp(1))
       close(66)


      if (in.eq.1) goto 23
      goto 21
      
 499  continue
      stop

 500  continue

c
c this part is for seisan binary to sac binary
c

      if (from_eev) goto 523


521   continue

      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)

      if (infile(1:3).eq.'EOF') STOP
      if(infile(1:10).eq.'filenr.lis') then
          open(1,file='filenr.lis',status='old',err=522)
          in=1
      endif
      eqla=0.
      eqlo=0.
      eqel=0.
      goto 523

522   continue

      write(*,*) ' filenr.lis not found'
      stop

523   continue

      if(in.eq.1) then
        read(1,'(7x,a)') infile
        if(infile(1:4).eq.'    ') stop
      endif

c
c read seisan traces
c
      call wav_init
      wav_filename(1)=infile
      call read_wav_header(1) 

      write(*,*) ' number of traces: ',wav_nchan

      do c=1,wav_nchan

        write(*,*) 'trace: ',c
        call wav_read_channel(c)
        write(*,'(a5,1x,a4,1x,i4,1x,4(i2,1x),f5.2)') 
     *       wav_stat(c),wav_comp(c),
     *       wav_year(c),wav_month(c),wav_day(c),
     *       wav_hour(c),wav_min(c),wav_sec(c)

        call write_seisan_to_sacbin(c,.false.,.false.,
     *        eqla,eqlo,eqel,nerr)
        if (nerr.ne.0) then
          write(*,*) ' Error when writing SAC file '
        endif

      enddo
      if (in.eq.1) goto 523
      if (.not.from_eev) goto 521
 
9999  continue

      stop
      end

ccccccccccccccccccccccccccccccccccccc
c
c   changes
c
c  june 24 2003 jh : put in gmt_scaling
c


      subroutine gmt_xy_par(unit,set,npoint,x,y)
c
c   write out parameters and data to unit for gmt xy routine
c   if set is 1, main parameters, if set is differnet from 1,
c   trace parameters. the number of points is npoint and
c   the values are stored in x and y
c
c
      implicit none
      include 'gmt_xy_par.inc'
      integer unit,set
      integer npoint
      real x(*), y(*)
      character*80 text   ! output string
      integer i           ! counter
      real x1             ! help variable
c
c   find max and min of x-y values
c
      gmt_maxx=-1.0e30
      gmt_maxy=gmt_maxx
      gmt_minx=1.0e30
      gmt_miny=gmt_minx
c
      do i=1,npoint
         if(y(i).gt.gmt_maxy) gmt_maxy=y(i)
         if(y(i).lt.gmt_miny) gmt_miny=y(i)
         if(x(i).gt.gmt_maxx) gmt_maxx=x(i)
         if(x(i).lt.gmt_minx) gmt_minx=x(i)
      enddo
c
c   if scaling to fit inside borders, do it here
c
      if(gmt_scaling.ne.1.0) then
         x1=(gmt_scaling-1.0)*(gmt_maxx-gmt_minx)
         gmt_maxx=gmt_maxx+x1
         gmt_minx=gmt_minx-x1
         x1=(gmt_scaling-1.0)*(gmt_maxy-gmt_miny)
         gmt_maxy=gmt_maxy+x1
         gmt_miny=gmt_miny-x1
      endif
c
      text=' '
      text(1:1)='#'
c
c   main headers
c
      if(set.eq.1) then

         text(2:80)=' '
         text(3:11)='OFILENAME'
         text(15:80)=gmt_ofilename(1:66)
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='MAINTITLE'
         text(15:80)=gmt_maintitle(1:66)
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:16)='MAIN_FONT_SIZE'
         write(text(25:34),'(i10)') gmt_main_font_size
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:16)='MAIN_FONT_TYPE'
         text(18:80)=gmt_main_font_type(1:63)
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='XTITLE   '
         text(15:80)=gmt_xtitle(1:66)
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='XSIZE    '
         write(text(25:34),'(f10.2)') gmt_xsize
         text(35:80)=' '
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='XLOG     '
         write(text(25:34),'(i10)') gmt_xlog
         text(35:80)=' '         
         write(unit,'(a)') text
     
         text(2:80)=' '
         text(3:11)='YTITLE   '
         text(15:80)=gmt_Ytitle(1:66)
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='YSIZE    '
         write(text(25:34),'(f10.2)') gmt_ysize
         text(35:80)=' '
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='YLOG     '
         write(text(25:34),'(i10)') gmt_ylog
         text(35:80)=' '         
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='GRID_X   '
         write(text(25:34),'(i10)') gmt_grid_x   
         text(35:80)=' '         

         write(unit,'(a)') text
         text(2:80)=' '
         text(3:11)='GRID_Y   '
         write(text(25:34),'(i10)') gmt_grid_y   
         text(35:80)=' '         
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='NTRACES  '
         write(text(25:34),'(i10)') gmt_ntraces
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:12)='LEGEND    '
         write(text(23:34),'(i12)') gmt_legend         
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:12)='BAR_WIDTH '
         write(text(23:34),'(f12.5)') gmt_bar_width      
         write(unit,'(a)') text
      else
c
c   trace
c
         write(unit,*)

         text(2:80)=' '
         text(3:12)='TRACETITLE'
         text(15:80)=gmt_tracetitle(1:66)
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:12)='TRACECOLOR'
         text(15:80)=gmt_tracecolor(1:66)
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:13)='TRACESYMBOL'
         text(15:15)=gmt_tracesymbol       
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:13)='SYMBOL_SIZE'
         write(text(25:34),'(f10.2)') gmt_symbol_size         
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:12)='LINE_WIDTH'
         write(text(23:34),'(i12)') gmt_line_width         
         write(unit,'(a)') text


         text(2:80)=' '
         text(3:13)='LINESTYLE  '
         text(15:20)=gmt_linestyle      
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:13)='MINX      '
         write(text(15:34),'(g20.8)') gmt_minx
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='MAXX    '
         write(text(15:34),'(g20.8)') gmt_maxx
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='MINY    '
         write(text(15:34),'(g20.8)') gmt_miny
         write(unit,'(a)') text

         text(2:80)=' '
         text(3:11)='MAXY    '
         write(text(15:34),'(g20.8)') gmt_maxy
         write(unit,'(a)') text
 
         do i=1,npoint
            write(unit,*) x(i),y(i)
         enddo
      endif
      return
      end

  
      subroutine gmt_xy_init

      implicit none
      include 'gmt_xy_par.inc'
c
c   set default values for gmt_xy_par routine
c

c   set some defaults main block
c
      data gmt_ofilename /'gmtxy.out'/
      data gmt_maintitle /' '/
      data gmt_main_font_type /'Times-Roman'/
      data gmt_main_font_size /18/
      data gmt_xtitle /' '/
      data gmt_xsize /12.0/
      data gmt_xlog  /0/
      data gmt_ytitle /' '/
      data gmt_ysize /12.0/
      data gmt_ylog /0/
      data gmt_legend /1/
      data gmt_ntraces /1/
      data gmt_grid_x /1/
      data gmt_grid_y /1/
      data gmt_bar_width /1.0/

c
c   set defaults for trace block
c
      data gmt_tracetitle /' '/
      data gmt_tracecolor/'black'/
      data gmt_tracesymbol /' '/
      data gmt_symbol_size /0.6/
      data gmt_ncolor /8/
      data gmt_linestyle /'solid'/
      data gmt_line_width /5/
      data gmt_color(1)	/'black    '/
      data gmt_color(2)	/'blue     '/      
      data gmt_color(3)	/'purple   '/      
      data gmt_color(4)	/'red      '/
      data gmt_color(5)	/'green    '/
      data gmt_color(6)	/'orange   '/      
      data gmt_color(7)	/'yellow   '/      
      data gmt_color(8)	/'pink     '/
      data gmt_scaling  /1.0/

      return
      end

c$debug
c
c   converts geophysical instittute of israel bukletin files to nordic format
c
c   jh august 1998
c   updates:
c   oct 6  jh : fix blank station
c   june 1999 jh ----------------  version 7 -----------------------
c   oct 2 2001 change SP to SZ


c
       implicit none
C  array with original readings
      character*80 data(1000)
      character*80 text
      character*3 agency
      character*4 trms
      integer idist                ! distance
      real dist                    ! distance
      character*80 infile
      real mag1                    ! magnitude
c  number of different stations in data
      integer nstat
      integer year,month,day,hour,min
      real sec
c  decimal latitude and longitude
      real dlat,dlon
c  depth,  rms of residuals
      real depth,rms
      integer i,NEVENT,ID


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      nevent=0

c
      write(6,*)' Input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old')
      open(2,file='giinor.out',status='unknown')
c
c   next event
c
 50   continue
c
c   find next header line
c
      read(1,'(a)',end=99) text
      if(text(1:5).ne.'=====') goto 50
c
c   event reading loop
c

 51   continue
      read(1,'(a)',end=99) text
      nevent=nevent+1
      read(text(7:10) ,'(i4)') year
      read(text(12:13),'(i2)') month
      read(text(15:16),'(i2)') day

      if(text(20:20).eq.':') then
         read(text(18:19),'(i2)') hour
         read(text(21:22),'(i2)') min
         read(text(24:29),'(f6.3)') sec
      else
         read(text(19:20),'(i2)') hour
         read(text(22:23),'(i2)') min
         read(text(25:30),'(f6.3)') sec
       endif
c
c   lat,lon,depth
c
      read(1,'(a)') text
      read(text(7:12), '(f6.3)') dlat
      read(text(22:28),'(f7.3)') dlon
      read(text(38:42),'(f5.1)') depth
      if(text(14:14).eq.'S') dlat=-dlat
      if(text(30:30).eq.'W') dlon=-dlon
      write(6,*) dlat,dlon,depth
c
c   magnitude
c
      read(1,'(3x,f4.1)') mag1
c
c  rms
c
      read(1,'(4x,f7.3)') rms
c
c   write header line
c
         do i=1,80
           data(1)(i:i)=' '
         enddo

         id=1

         agency='XXX'
         write(data(1)(2:20),'(i4,1x,2i2,1x,2i2,1x,f4.1)')
     *   year,month,day,hour,min,sec
         trms='    '
         if(rms.gt.0.0)write(trms,'(f4.1)') rms
         if(nstat.gt.999) nstat=999
         write(data(1)(46:55),'(a3,i3,A4)') agency,nstat,trms
         write(data(1)(24:43),'(f7.3,f8.3,f5.1)') dlat,dlon,depth
         write(data(1)(57:63),'(f3.1,a4)')mag1,agency 
         data(1)(22:22)='L'
c
c   6 input lines
c
      do i=1,6
        read(1,'(a)') text
      enddo
c
 20   continue
c
c   read phases
c
      read(1,'(a)') text
      if(text(1:5).eq.'=====') then
        write(2,'(a)') (data(i),i=1,id)
        write(2,*)'                                 '
        go to 50    ! next event
      endif
c
      id=id+1
      do i=1,80
        data(id)(i:i)=' '
      enddo
c
      data(id)(2:5)=text(2:5)              ! station
      if(data(id)(2:5).eq.'    ') data(id)(2:5)=data(id-1)(2:5)
      data(id)(7:8)='SZ'
      data(id)(10:14)=text(28:32)          ! phase
      data(id)(15:15)=text(52:52)          ! weight
      if(text(35:35).eq.'d') data(id)(17:17)='D'   ! polarity
      if(text(35:35).eq.'c') data(id)(17:17)='C'
      if(text(38:38).eq.':') then
         data(id)(19:20)=text(36:37)          ! hour
         data(id)(21:22)=text(39:40)          ! min
         data(id)(24:28)=text(42:46)          ! sec
      else
         data(id)(19:20)=text(37:38)          ! hour
         data(id)(21:22)=text(40:41)          ! min
         data(id)(24:28)=text(43:47)          ! sec
      endif
      data(id)(64:68)=text(54:58)          ! residual
      read(text(15:20),'(f5.1)') dist      ! distance
      idist=dist+0.5
c
c   only write dist and axz for p-phase, s has none
c
      if(text(29:29).ne.'S') write(data(id)(71:75),'(i5)') idist
      if(text(29:29).ne.'S') data(id)(77:79)=text(23:25)          ! azimuth
c
c   next phase
c
      goto 20

 99   continue

      write(6,*)' Number of events converted', nevent
      write(6,*) 'Output file name is giinor.out'
      stop
      end 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c seed.for
c Routines for reading SEED files and writung miniseed files
c 
c Author: Rodrigo Canabrava
c E-mail: rlpcfr@yahoo.com.br
c Universitetet i Bergen - Department of Earth Sciences
c
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   This routine writes big endian miniseed by default on all platforms,
c   if litte endian is desired, change variable force_len to true
c


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Summarizes the contents of the file
c The summary is put on the common /file_summary/
c
c
c   changes
c
c june 16 2005 jh: Too many cases of wrong integrity constat. This caused
c                  may files to not be read and also wrong time gap calculation.
c                   The reading routine is now allowed to
c                  continue. Not sure if a real problem. 
c                  Commnt, look for jh 050615
c nov   3 2005 jh : when writing miniseed, header times were wrong by 1
c                   sample
c nov 9   2005 jh: add variable seed_blk_read
c dec 21       jh: fix pc writing, check for platform so reading in nanometrics
c                  way happens directly (is really just pc writing)
c                  which means consistent little endian way
c mar 22 2006  jh: fix so it is possibel to write little or big endian on
c                  all platforms, look for variable force_len
c oct 6  2006  jh: add seed_network
c nove16 2006  jh: convert fracsec to real in one case forgotten
c october 2007 Jh: make reading of network work
c november 10 07 : add time gap to calculation of number of smaples
c                  for one channel
c june 19 08   jh: check also for location code when checking for a 
c                  multiplexed file
c sep 4 08     jh: check first 5 blocks for being multiplexed
c oct 31. 08   jh: check firdt 10 -------------------------

c Parameters:
c - filename: file name
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE seed_contents(filename)

        IMPLICIT NONE
        INCLUDE 'seed.inc.f'
        INCLUDE 'seed_internal.inc.f'

        integer*4 blk_count     ! block counter
        character*80 filename   ! name of file

        logical*1 is_seed_data_record ! auxiliary function
        logical*1 seed_read_block ! auxiliary function
        logical*1 is_seed       ! auxiliary function
        integer*4 get_seed_blk_size ! auxiliary function
        integer*4 read_seed_headers ! auxiliary function 

        BLK_SIZE = 256
        nb_channels = 0

c     open file
        OPEN(STDIN, file = filename, RECL=BLK_SIZE, 
     &       ACCESS='DIRECT', STATUS='OLD')

c     check block size
        IF (is_seed(STDIN)) THEN
           BLK_SIZE = get_seed_blk_size(STDIN)
           IF (BLK_SIZE .GT. MAX_BLK_SIZE) THEN
              WRITE(error_msg,*) 'Blocksize (', BLK_SIZE,') too big!'
              WRITE(*,*) error_msg
              CLOSE(STDIN)
              RETURN
           ENDIF
        ENDIF

c     reopen file, with aproppriate BLK_SIZE
        CLOSE (STDIN)
        OPEN(STDIN, file = filename, RECL=BLK_SIZE,
     &       ACCESS='DIRECT', STATUS='OLD')

c     read SEED headers
        blk_count = read_seed_headers(STDIN)

c     check if block size of data part is the same as in the
c     header part
        IF (seed_read_block(STDIN, blk_count) 
     &       .AND. is_seed_data_record()) THEN
           IF (2**rec_length .NE. BLK_SIZE) THEN
              blk_count = ((blk_count-1)*BLK_SIZE)/(2**rec_length)+1
              BLK_SIZE = 2**rec_length
              CLOSE(STDIN)
              OPEN(STDIN, file = filename, RECL=BLK_SIZE,
     &             ACCESS='DIRECT', STATUS='OLD')
           ENDIF
        ENDIF

        CALL seed_summarize(STDIN, blk_count)

        CLOSE(STDIN)
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Finds the block that "contains" the given time.
c It starts looking at the block given by "start_point". This means the 
c function can be used sequentially to chop the file, using the
c return value of one run as the "start_point" value to the next run.
c
c Start point is the number of the block in the file, where the search will 
c start.  The parameter can be used if some prior knowledge is availabel
c of where the start block might be. If no knowlwde, use  1. Wrong usage 
c of this parameter migh result in the time start block not being found 
c despite it being in the file. If start point is previous the first 
c block of the channel,  start searching from first block of channel.
c
c Parameters:
c - filename:    file name
c - n:           name of the channel
c - time:        time you want to look for (in seconds from year 1900)
c - start_point: block number where the function should start the search
c - block:       (output) number of block (according to description below)
c
c Return conditions are:
c
c If time is found:
c     return 0      block = block with time
c If time is previous then the beginning of the channel
c     return 1      block = first block of the channel
c If time is after the end of the channel
c     return 2      block = end of the channel
c If start_point is after the end of the channel
c     return 3      block = end of the channel
c If time is before the start point
c     return 4      block = start point
c If time is in a time gap
c     return 5      block = first block after the gap
c
c After calling the routine, the common block /section_summary/ is set
c to hold the information of that block (start time, sample rate, etc.).
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      INTEGER*2 FUNCTION chop_chn(filename, n, time, start_point, block)

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'
         INCLUDE 'seed_internal.inc.f'

         character*80 filename  ! name of input file
         integer*4 n            ! channel index
         real*8 time            ! time in seconds from year 1900
         integer*4 start_point  ! start point of search
         integer*4 block        ! (output) the block where "time" is

         integer*2 day, month   ! day and month
         real*8 btime           ! start time of block in seconds from 1900
         real*8 endtime         ! end time of block

         real*8    time_to_sec  ! auxiliary function
         logical*1 seed_read_block ! auxiliary function
         logical*1 is_seed_data_record ! auxiliary function
         integer*4 i            ! loop counter

         OPEN(STDIN, file = filename, RECL=BLK_SIZE, 
     &        ACCESS='DIRECT', STATUS='OLD')

c     If time is previous than channel begin, return 1
         CALL get_day_month(day, month, chn_day(n), chn_year(n))
         btime = time_to_sec(chn_year(n), month, day, chn_hour(n),
     &        chn_minute(n), chn_second(n)) + real(chn_fracsec(n))/10000
         IF (time .LT. btime) THEN
            block = chn_begin(n)
            chop_chn = 1
            CALL update_section_summary(STDIN, n, block)
            CLOSE(STDIN)
            RETURN
         ENDIF

c     If start point is previous than beginning of channel, we start
c     in the end of the channel.
         i = start_point
         IF (start_point .LT. chn_begin(n)) THEN
            i = chn_begin(n)
         ENDIF

c     If start point is after the end of the channel, return 3
         IF (start_point .GT. chn_end(n)) THEN
            block = chn_end(n)
            chop_chn = 3
            CALL update_section_summary(STDIN, n, block)
            CLOSE(STDIN)
            RETURN
         ENDIF

c     If time is previous than start point, we return 4:
         IF (seed_read_block(STDIN, i)
     &        .AND. is_seed_data_record()
     &        .AND. (station .EQ. stn_name(n))
     &        .AND. (channel .EQ. chn_name(n))
     &        .AND. (location .EQ. chn_location(n))) THEN
            CALL get_day_month(day, month, day_of_year, year)
            btime = time_to_sec(year,month,day,hour,minute,second)
            btime = btime + real(fracsec)/10000
            IF (time .LT. btime) THEN
               block = start_point
               chop_chn = 4
               CALL update_section_summary(STDIN, n, block)
               CLOSE(STDIN)
               RETURN
            ENDIF            
         ENDIF

         DO WHILE (i .LE. chn_end(n))
            IF (seed_read_block(STDIN,i) 
     &           .AND. is_seed_data_record()
     &           .AND. (station .EQ. stn_name(n)) 
     &           .AND. (channel .EQ. chn_name(n))
     &           .AND. (location .EQ. chn_location(n))) THEN
               CALL get_day_month(day, month, day_of_year, year)
               btime = time_to_sec(year,month,day,hour,minute,second)
               btime = btime + real(fracsec)/10000
               endtime = btime + (n_samples + 1)/chn_sample_rate(n)
c               WRITE(*,*) time, btime, endtime
               IF ((btime .LT. time) .AND. (time .LT. endtime)) THEN
                  block = i
                  chop_chn = 0
                  CALL update_section_summary(STDIN, n, block)
                  CLOSE(STDIN)
                  RETURN
c     if time is in a gap, it was not found before, but we passed it.
c     Then we return 5
               ELSEIF (time .LT. btime) THEN
                  block = i
                  chop_chn = 5
                  CALL update_section_summary(STDIN, n, block)
                  CLOSE(STDIN)
                  RETURN
               ENDIF
            ENDIF
            i = i + 1
         ENDDO

c     if it got here, than the requested time is after the end of the channel
c     so we return 2 
         block = chn_end(n)
         chop_chn = 2
         CALL update_section_summary(STDIN, n, block)
         CLOSE(STDIN)
         RETURN
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Gets the data of the specified channel.
c It uses the information on /file_summary/ in order to locate the channel.
c The channel is specified by its index number on the /file_summary/.
c The function returns the number of samples actually read.
c Information about the section, like start time, sample rate, etc. is
c
c The parameters "first" and "last" are used in order to extract just a
c section of the channel. They are the number of blocks in the file.
c
c If "first" happens before the beginning of the channel, the function
c starts from the beginning of the channel.
c
c If "last" is greater then the end of the channel, or equal to zero, the
c function reads until the end of the channel.
c
c Parameters:
c - fname: file name
c - n:     number of the channel
c - buf:   (output) buffer where samples should be placed
c - first: first block to be read
c - last:  last block to be read
c
c Return: number of samples read in the request
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION seed_read_chn(fname, n, buf, first, last)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'
         INCLUDE 'seed.inc.f'

         character*80 fname     ! input file name
         integer*4 n            ! number of the channel

         integer*4 buf(*)    ! place to put samples
         integer*4 input(32768/4) ! input to decompression routines
         character*32768 c_input ! temporary for casting 
         integer*4 end_buf      ! pointer to next empty position in buf
         logical*1 nanometrics  ! checks if file is nanometrics style
         logical*1 is_first_blk ! .TRUE. if it's the first requested block
         integer*4 first, first_ ! first block that is to be read
         integer*4 last, last_  ! last block that is to be read
         integer*4 blk_count    ! number of blocks read in file
         integer*2 day, month   ! day and month
         equivalence(c_input, input)

         logical*1 seed_read_block ! auxiliary function
         logical*1 is_seed_data_record ! auxiliary function
         logical*1 read_steim1  ! auxiliary function
         integer*4 read_chn_nanometrics ! auxiliary function
         real*8    time_to_sec  ! auxiliary function
         integer*4 i            ! loop counter
         integer*2 get_doy
         logical computer_word_order  ! function

c
c jh   find which platform
c
         seed_pc=.true.       ! default is pc-linux
         if (computer_word_order()) seed_pc=.false.               

        OPEN(STDIN, file = fname, RECL=BLK_SIZE, 
     &       ACCESS='DIRECT', STATUS='OLD')

         end_buf = 1
         blk_count = 1
         nanometrics = .FALSE.

         first_ = first
         last_ = last

         IF (first_ .LT. chn_begin(n)) THEN
            first_ = chn_begin(n)
         ENDIF
         IF ((last_ .EQ. 0)) last_ = chn_end(n)
         IF (last_ .GT. chn_end(n)) last_ = chn_end(n)

         is_first_blk = .TRUE.
c        decompresses one block at a time
         DO i = first_, last_
           IF (seed_read_block(STDIN,i) 
     &           .AND. is_seed_data_record()
     &           .AND. (station .EQ. stn_name(n)) 
     &           .AND. (channel .EQ. chn_name(n))
     &           .AND. (location .EQ. chn_location(n))
     &           .AND. (end_buf + n_samples .LE. MAX_SAMP)
     &           .AND. (.NOT. nanometrics)) THEN

              CALL get_day_month(day, month, day_of_year, year)
              seed_blk_time(blk_count) = time_to_sec(year, month, day,
     &             hour, minute, second) + real(fracsec)/10000
              seed_blk_index(blk_count) = end_buf
              blk_count = blk_count + 1

              IF (is_first_blk) THEN
                 CALL update_section_summary(STDIN, n, i)
                 is_first_blk = .FALSE.
              ELSE
                 seed_end(n) = i
              ENDIF
              IF (questionable_time_tag) seed_bad_time_tag(n) = .TRUE.

              c_input = seed_record(data_p+1:BLK_SIZE)
              IF (is_swapped) THEN
                 CALL swap_buffer(input, (BLK_SIZE - data_p)/4 )
              ENDIF
c
c   if data written on pc platform it will probably be on nanometrics order
c   only working for steim1     cjh
c
              if((seed_pc.and.encoding.eq.steim_1.and..not.is_swapped).
     *        or.(.not.seed_pc.and.encoding.eq.steim_1.and.is_swapped))
     *        then
                nanometrics=.true.
                goto 1000
              endif

c             call the correct reading function
              IF (encoding .EQ. STEIM_1) THEN    
c     On the first trial, the reader tries to read the program as a
c     standard Steim1. If, in any attempt, it fails (read_steim1 returns
c     false), it gives up standard steim1, resets the reading, and from 
c     that moment on it tries to read the blocks as a Nanometrics "Steim1"
c     style.
                 nanometrics = .NOT. read_steim1(input, 
     &                buf(end_buf), n_samples)
              ELSEIF (encoding .EQ. STEIM_2) THEN
                 CALL read_steim2(input, buf(end_buf), n_samples)
              ELSEIF (encoding .EQ. INT_32BIT) THEN
                 CALL read_32bit(input, buf(end_buf), n_samples)
              ELSE
                 WRITE(error_msg, *) 'ERROR - Unknown encoding format!'
                 WRITE(STDOUT,*) error_msg
                 seed_read_chn = 0
                 RETURN
              ENDIF

              end_buf = end_buf + n_samples
           ENDIF
        ENDDO

c
cjh   
c
 1000    continue
         IF (nanometrics) THEN
            seed_nsamp(n) = read_chn_nanometrics(STDIN, n, buf)
            seed_read_chn = seed_nsamp(n)
            CLOSE(STDIN)
            RETURN
         ENDIF

c     reports error message if the buf is not big enough
        IF ((end_buf + n_samples) .GT. MAX_SAMP) THEN
           WRITE(error_msg,*) 'Number of samples (',end_buf + n_samples,
     &          ') not supported. Number of samples read: ', end_buf - 1
           WRITE(STDOUT,*) error_msg
        ENDIF

        seed_nsamp(n) = end_buf - 1
        seed_read_chn = end_buf - 1

        CLOSE(STDIN)
c

        seed_blk_read=blk_count-1
        RETURN

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Updates the section summary
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE update_section_summary(file, n, blk_number)

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! input file number
         integer*4 n            ! number of channel
         integer*4 blk_number   ! number of a block
         integer*2 day          ! day of start of section
         integer*2 month        ! month of start of section

         logical*1 is_seed_data_record ! auxiliary function
         logical*1 seed_read_block ! auxiliary function

         IF (seed_read_block(STDIN, blk_number)
     &        .AND. is_seed_data_record()) THEN
            seed_station(n) = station
            seed_comp(n) = channel
            seed_location(n) = location
            seed_network(n) = network
c           write(6,*)'seed net',network
            seed_year(n) = year
            CALL get_day_month(day, month, day_of_year, year)
            seed_month(n) = month
            seed_day(n) = day
            seed_hour(n) = hour
            seed_minute(n) = minute
            seed_second(n) = second + real(fracsec)/10000.0
            seed_rate(n) = sample_rate
            seed_bad_time_tag(n) = questionable_time_tag
            seed_nsamp(n) = n_samples
            seed_begin(n) = blk_number
            seed_end(n) = blk_number
         ENDIF
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Checks if the file is multiplexed or not, and calls the 
c appropriate function to summarize the file.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE seed_summarize(file, blk_count)

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! file number
         integer*4 blk_count    ! block counter

         logical*1 miniseed_is_multiplexed ! auxiliary function

         IF (miniseed_is_multiplexed(file, blk_count)) THEN
            WRITE(*,*) 'multiplexed'
            CALL summarize_multiplexed(file, blk_count)
         ELSE
            CALL summarize_sequential(file, blk_count)
         ENDIF
         
         CALL reset_section_summary()

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Summarizes the file as if it contains sequential channels
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE summarize_sequential(file, blk_count)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'
         INCLUDE 'seed.inc.f'

         integer*4 file         ! input file
         integer*4 blk_count    ! block counter
         real*8 seed_this_chan_time  ! abs time of current channel
         real*8 time_gap         ! time gap two blocks
         integer*4 nsample_in_time_gap ! time gap in samples
         real sample_rate_this_block
         integer*2 day, month   ! day and month
         real*8    time_to_sec  ! auxiliary function
         real*4    calculate_sample_rate ! auxiliary function

         logical*1 is_seed_data_record ! auxiliary function
         logical*1 seed_read_block ! auxiliary function

         DO WHILE (seed_read_block(file, blk_count))
            IF (is_seed_data_record()) THEN
               
c     if it's not the same channel as the previous one,
c     then it's a new channel
               IF (nb_channels .NE. 0) THEN 
                  IF ((station .NE. stn_name(nb_channels))
     &                 .OR.(channel .NE. chn_name(nb_channels))
     &                 .OR. (location .NE. chn_location(nb_channels))) 
     &                 THEN
                     CALL seed_add_chn(blk_count)
                  ELSE
c     if it is the same channel, update values
                     chn_end(nb_channels) = blk_count
c
c   calculate abs time for block start time in following block 
c   and store for this channes
c   first get abs time of thsi block
c
              CALL get_day_month(day, month, day_of_year, year)
              seed_this_chan_time = time_to_sec(year, month, day,
     &             hour, minute, second) + real(fracsec)/10000
c
c   calculating sample rate
c
                     sample_rate_this_block = 
     *               calculate_sample_rate(sample_rate_factor,
     &               sample_rate_multiplier)
c
c  check for a time gap
c
                    time_gap=seed_this_chan_time-
     *              seed_chan_time(nb_channels)
c
c   calculate time of next block this channel and store 
c
                     seed_chan_time(nb_channels)=n_samples/
     *               sample_rate_this_block+seed_this_chan_time
c
c                    write(17,'(3(1x,i5),1x,f5.1,2f13.1,1x,f6.2)') 
c    *               blk_count,nb_channels,n_samples,
c    *               sample_rate_this_block,
c    *               seed_this_chan_time, 
c    *               seed_chan_time(nb_channels),
c    *               time_gap 
c
c   calculate how many samples in time gap,if less than one sample
c   it is rounded off to 0
c
                     nsample_in_time_gap=
     *               time_gap*sample_rate_this_block
                     chn_samples(nb_channels) = 
     &                    chn_samples(nb_channels) + n_samples
c
c   add the time gap smaples to toal number of samples if positive
c   and 'reasonable', less than 100 000
c
                     if(nsample_in_time_gap.gt.0.and.
     *                  nsample_in_time_gap.lt.100000) 
     *               then
                       write(6,*)
     *                 ' Time gap', nsample_in_time_gap
                       chn_samples(nb_channels)=
     *                 chn_samples(nb_channels)
     *                 + nsample_in_time_gap
                     endif
c
c   stop if too big time gap
c
                     if(nsample_in_time_gap.gt.100000) then
                       write(6,*) 'Time gap in samples',
     *                 nsample_in_time_gap
                       write(6,*)'Unrealistic, will stop'
                     endif

c
c   if time gap is negative, only a warning that data is unrelaible
c
                     if(nsample_in_time_gap.lt.0) then
                        write(6,*)
     *                  ' Negative time gap, data unreliable'
                     endif
                     IF (questionable_time_tag) THEN
                        chn_questionable_time_tag(nb_channels) = .TRUE.
                     ENDIF
                  ENDIF
               ELSE
                  CALL seed_add_chn(blk_count)
               ENDIF
            ENDIF 
            blk_count = blk_count + 1
         ENDDO
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Resets the /section_summary/, so it will be identical as the 
c /file_summary/
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE reset_section_summary()

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'

         integer*4 i            ! loop counter
         integer*2 day, month   ! day and month

         DO i = 1, nb_channels
            seed_station(i) = stn_name(i)
            seed_comp(i) = chn_name(i)
            seed_location(i) = chn_location(i)
            seed_network(i) = chn_network(i)
            seed_begin(i) = chn_begin(i)
            seed_end(i) = chn_end(i)
            seed_nsamp(i) = chn_samples(i)
            seed_bad_time_tag(i) = chn_questionable_time_tag(i)
            seed_rate(i) = chn_sample_rate(i)
            seed_second(i) = chn_second(i) + real(chn_fracsec(i))/10000
            seed_minute(i) = chn_minute(i)
            seed_hour(i) = chn_hour(i)
            CALL get_day_month(day, month, chn_day(i), chn_year(i))
            seed_day(i) = day
            seed_month(i) = month
            seed_year(i) = chn_year(i)

         ENDDO
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Summarizes the file as if it has intercalated (multiplexed) channels
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE summarize_multiplexed(file, blk_count)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'
         INCLUDE 'seed.inc.f'

         integer*4 file         ! input file
         integer*4 blk_count    ! block counter
         integer*4 index        ! index number of channel

         logical*1 is_seed_data_record ! auxiliary function
         logical*1 seed_read_block ! auxiliary function
         integer*4 get_channel_index ! auxiliary function

         DO WHILE (seed_read_block(file, blk_count))
            IF (is_seed_data_record()) THEN
               index = get_channel_index(station, channel, location)
c     if it does not have an index, it's a new channel
               IF (index .EQ. 0) THEN
                  CALL seed_add_chn(blk_count)
               ELSE
c     if it already has a summary, update values
                  chn_end(index) = blk_count
                  chn_samples(index) = chn_samples(index) + n_samples
                  IF (questionable_time_tag) THEN
                     chn_questionable_time_tag(index) = .TRUE.
                  ENDIF
               ENDIF
            ENDIF
            blk_count = blk_count + 1
         ENDDO

      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Checks if the records order is multiplexed or grouped by channel
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL FUNCTION miniseed_is_multiplexed(file, start)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4   file     ! input file
         integer*4   start    ! beginning of data records section
         character*5 station1 ! station of first block
         character*3 channel1 ! channel of first block
         character*5 station2 ! station of second block
         character*3 channel2 ! channel of second block
         character*2 location1 ! loication code of first block
         character*2 location2 ! location coode of second block
         integer i

         logical*1 seed_read_block ! auxiliary function

         miniseed_is_multiplexed = .FALSE.
         IF (seed_read_block(file, start)) THEN
            station1 = station
            channel1 = channel
            location1 = location      ! jh june 2008
         ELSE
            RETURN
         ENDIF
c
c   first 10 blocks must tbe idendical, if not multiplexed
c
         do i=1,9
         IF (seed_read_block(file, start + i)) THEN
            station2 = station
            channel2 = channel
            location2 =location
            if(station2.ne.station1.or.location2.ne.location1.or.
     *      channel2.ne.channel1) then
               miniseed_is_multiplexed = .TRUE.
               return
            endif
         ELSE
            RETURN
         ENDIF
         enddo
         ! if there are 2 channels in the first 2 blocks then
         ! the file is multiplexed
c         IF ((station1 .EQ. station2) 
c     &      .AND. 
c     *   (channel1 .NE. channel2.or.location1.ne.location2))  
c     *   THEN
c            miniseed_is_multiplexed = .TRUE.
c         ENDIF
         RETURN 

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Gives the index in the table for this station|channel.
c Returns zero if the pair station|channel is not found.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION get_channel_index(station, channel, location)
      
         IMPLICIT NONE
         INCLUDE 'seed.inc.f'

         character*5 station ! station name
         character*3 channel ! channel id
         character*2 location ! location id

         integer i ! loop counter

         get_channel_index = 0
         DO i = 1, nb_channels
            IF ((station .EQ. stn_name(i)) 
     &           .AND. (channel .EQ. chn_name(i))
     &           .AND. (location .EQ. chn_location(i))) THEN
               get_channel_index = i
               RETURN
            ENDIF
         ENDDO
         RETURN
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Adds an entry for the channel in the file summary.
c The summary is on the common /file_summary/
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE seed_add_chn(blk_count)
         
         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'
         INCLUDE 'seed.inc.f'
         
         integer*2 day, month   ! day and month
         real*8    time_to_sec  ! auxiliary function
         
         integer*4 blk_count ! the number of current block (in the file)

         nb_channels = nb_channels + 1
         chn_name(nb_channels) = channel
         stn_name(nb_channels) = station
         chn_location(nb_channels) = location
         chn_network(nb_channels) = network
c        write(6,*)'seed 2. net',network
         chn_begin(nb_channels) = blk_count
         chn_end(nb_channels) = blk_count
         chn_samples(nb_channels) = n_samples
         chn_year(nb_channels) = year
         chn_day(nb_channels) = day_of_year
         chn_hour(nb_channels) = hour
         chn_minute(nb_channels) = minute
         chn_second(nb_channels) = second
         chn_fracsec(nb_channels) = fracsec
         chn_sample_rate(nb_channels) = sample_rate
c
c  abs time for time gap checking
c
         CALL get_day_month(day, month, day_of_year, year)
         seed_chan_time(nb_channels) = time_to_sec(year, month, day,
     &   hour, minute, second) + real(fracsec)/10000
c
c   calculate time of next block this channel and store 
c
          seed_chan_time(nb_channels)=n_samples/
     *    sample_rate+seed_chan_time(nb_channels)
c
         IF (questionable_time_tag) THEN
            chn_questionable_time_tag(nb_channels) = .TRUE.
         ELSE
            chn_questionable_time_tag(nb_channels) = .FALSE.
         ENDIF
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads channels from a nonometrics file.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION read_chn_nanometrics(file, n, buf)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'
         INCLUDE 'seed.inc.f'

         integer*4 file         ! file number
         integer*4 n            ! channel number
         integer*4 buf(*)    ! buffer for decompressed samples
         integer*4 input(32768/4) ! input to decompression routines
         character*32768 c_input ! temporary for casting 
         integer*4 end_buf      ! pointer to next empty position in buf
         logical*1 is_first_blk ! true if it is the first block

         equivalence(c_input, input)

         logical*1 seed_read_block ! auxiliary function
         logical*1 is_seed_data_record ! auxiliary function

         integer*4 i            ! counter

         end_buf = 1
         is_first_blk = .TRUE.

         DO i = chn_begin(n), chn_end(n)
           IF (seed_read_block(file,i) 
     &           .AND. is_seed_data_record()
     &           .AND. (station .EQ. stn_name(n)) 
     &           .AND. (channel .EQ. chn_name(n))
     &           .AND. (location .EQ. chn_location(n))
     &           .AND. (end_buf + n_samples .LE. MAX_SAMP)) THEN

              IF (is_first_blk) THEN
                 CALL update_section_summary(file, n, i)
                 is_first_blk = .FALSE.
              ELSE
                 seed_end(n) = i
              ENDIF
              IF (questionable_time_tag) seed_bad_time_tag(n) = .TRUE.


              c_input = seed_record(data_p+1:BLK_SIZE)
              CALL read_nanometrics(input, buf(end_buf), n_samples, 
     &             is_swapped )
              end_buf = end_buf + n_samples
           ENDIF
        ENDDO
        
        read_chn_nanometrics = end_buf -1

        IF ((end_buf + n_samples) .GT. MAX_SAMP) THEN
           WRITE(error_msg,*) 'Number of samples (',end_buf + n_samples,
     &          ') not supported. Number of samples read: ', end_buf - 1
           WRITE(STDOUT,*) error_msg
        ENDIF

        RETURN

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Read a block from a file
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION seed_read_block(file, n)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'
         INCLUDE 'seed.inc.f'

         integer*4 file         ! input file
         integer*4 n            ! number of block

         integer*4 ios          ! io status

         READ(file, REC=n, IOSTAT=ios) seed_record(1:BLK_SIZE)
         IF (ios .NE. 0) THEN
            seed_read_block = .FALSE.
            RETURN
         ENDIF
         
         seed_read_block = .TRUE.
         RETURN

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Tests if the file is SEED.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION is_seed(file)

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! input file

         logical*1 seed_read_block ! auxiliary function

         IF (seed_read_block(file, 1)) THEN
            IF (seed_record(1:8) .EQ. '000001V ') THEN
               is_seed = .TRUE.
               RETURN
            ENDIF       
         ENDIF

         is_seed = .FALSE.
         RETURN

      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Checks if the block is a data record.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION is_seed_data_record()

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         logical*1 seed_is_swapped ! auxiliary function
         integer*2 toint        ! auxiliary function
         real*4    calculate_sample_rate ! auxiliary function

c         WRITE(*,*) seed_record(1:8)
         IF ( (header_type .EQ. 'D')
     &        .OR. (header_type .EQ. 'R')
     &        .OR. (header_type .EQ. 'Q')) THEN
            
c     converting 1-byte fields
            hour = toint(hour_)
            minute = toint(minute_)
            second = toint(second_)

c        checking if file has different byte order
            is_swapped = seed_is_swapped()
            IF (is_swapped) THEN
               CALL seed_swap_header()
            ENDIF

c        calculating sample rate
            sample_rate = calculate_sample_rate(sample_rate_factor,
     &           sample_rate_multiplier)

            CALL miniseed_read_blockettes()
            CALL seed_treat_flags()

c            WRITE (*,*) seq_number, year, day_of_year, hour, minute, 
c     &           second, fracsec, ',    ', real(n_samples)/sample_rate,
c     &           encoding

            is_seed_data_record = .TRUE.
            RETURN
         ENDIF       

         is_seed_data_record = .FALSE.
         RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads a block of Volume Control Header
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION read_seed_volume_header(file, n)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! input file
         integer*4 n            ! number of block

         logical*1 seed_read_block ! auxiliary function

         IF (seed_read_block(file, n)) THEN
            IF (header_type .EQ. 'V') THEN
               read_seed_volume_header = .TRUE.
               RETURN
            ENDIF       
         ENDIF

         read_seed_volume_header = .FALSE.
         RETURN
         
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads a block of Abbreviation Control Header
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION read_seed_abbrv_header(file, n)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! input file
         integer*4 n            ! number of block

         logical*1 seed_read_block ! auxiliary function

         IF (seed_read_block(file, n)) THEN
            IF (header_type .EQ. 'A') THEN
               read_seed_abbrv_header = .TRUE.
               RETURN
            ENDIF       
         ENDIF

         read_seed_abbrv_header = .FALSE.
         RETURN
         
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads a block of Station Control Header
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION read_seed_station_header(file, n)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! input file
         integer*4 n            ! number of block

         logical*1 seed_read_block ! auxiliary function

         IF (seed_read_block(file, n)) THEN
            IF (header_type .EQ. 'S') THEN
               read_seed_station_header = .TRUE.
               RETURN
            ENDIF       
         ENDIF

         read_seed_station_header = .FALSE.
         RETURN
         
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads a block of Time Span Control Header
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION read_seed_time_header(file, n)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! input file
         integer*4 n            ! number of block

         logical*1 seed_read_block ! auxiliary function

         IF (seed_read_block(file, n)) THEN
            IF (header_type .EQ. 'T') THEN
               read_seed_time_header = .TRUE.
               RETURN
            ENDIF       
         ENDIF

         read_seed_time_header = .FALSE.
         RETURN
         
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Defines the block size of the SEED file.
c It checks the Volume control headers from the blockette 5, 8 or 10.
c The first blockette of the file must be one of those.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION get_seed_blk_size(file)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4   file     ! input file
         character*3 blk_type ! type of blockette

         logical*1 read_seed_volume_header ! auxiliary function

         IF (read_seed_volume_header(file, 1)) THEN

            blk_type = seed_record(9:11)

            IF ((blk_type .EQ. '005')
     &           .OR. (blk_type .EQ. '008')
     &           .OR. (blk_type .EQ. '010')) THEN

               READ(seed_record(20:21), *) rec_length
               get_seed_blk_size = 2**rec_length
               RETURN

            ENDIF

         ENDIF


c     wrong file
         get_seed_blk_size = 0
         RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads the SEED headers.
c Returns the number of the block where the data records start.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION read_seed_headers(file)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4 file         ! input file
         integer*4 nb           ! number of blocks on header section

         logical*1 read_seed_volume_header  ! auxiliary function
         logical*1 read_seed_abbrv_header   ! auxiliary function
         logical*1 read_seed_station_header ! auxiliary function
         logical*1 read_seed_time_header    ! auxiliary function

         nb = 1

c     Volume Control Headers
         DO WHILE (read_seed_volume_header(file, nb))
c            WRITE (*,*) seed_record(1:50)
            nb = nb + 1
         ENDDO

c     Abbreviation Dictionary Control Headers
         DO WHILE (read_seed_abbrv_header(file, nb))
c            WRITE (*,*) seed_record(1:8)
            CALL interp_abbr_hdr()
            nb = nb + 1
         ENDDO

c     Station Control Headers
         DO WHILE (read_seed_station_header(file, nb))
c            WRITE (*,*) seed_record(1:8)
            CALL interp_stn_hdr()
            nb = nb + 1
         ENDDO

c     Time Span Control Headers
         DO WHILE (read_seed_time_header(file, nb))
c            WRITE (*,*) seed_record(1:8)
            nb = nb + 1
         ENDDO

         read_seed_headers = nb
         RETURN         

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Interprets the information on the abbreviation header block
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE interp_abbr_hdr()

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'
         INCLUDE 'seed_internal.inc.f'

         integer*4   p          ! pointer to position in seed_record
         character*3 blk_type   ! blockette type
         integer*4   size       ! size of blockette

         logical*1 is_valid_abbr_blk ! auxiliary function

         SAVE p, blk_type, size

         IF (continuation .NE. '*') THEN
            p = 9
         ELSE
            p = p - BLK_SIZE + 8
         ENDIF

         DO WHILE ((p .LE. BLK_SIZE)
     &        .AND. is_valid_abbr_blk(seed_record(p:p+2)))

            blk_type = seed_record(p:p+2)

            IF (blk_type .EQ. '030') THEN
               CALL parse_30(p)
            ENDIF

            READ(seed_record(p+3:p+6),*) size

            p = p + size

         ENDDO

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Interprets the information on the station header block
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE interp_stn_hdr()

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'
         INCLUDE 'seed_internal.inc.f'

         integer*4   p          ! pointer to position in seed_record
         character*3 blk_type   ! blockette type
         integer*4   size       ! size of blockette
         character*5 stn        ! station name

         logical*1 is_valid_stn_blk ! auxiliary function

         SAVE p, blk_type, size, stn

         IF (continuation .NE. '*') THEN
            p = 9
         ELSE
            p = p - BLK_SIZE + 8
         ENDIF


         DO WHILE ((p .LE. BLK_SIZE) 
     &        .AND. is_valid_stn_blk(seed_record(p:p+2)))

            blk_type = seed_record(p:p+2)

            IF (blk_type .EQ. '050') THEN
c               stn = seed_record(p+7:p+11)

            ELSEIF (blk_type .EQ. '052') THEN
c               nb_channels = nb_channels + 1
c               stn_name(nb_channels) = stn
c               chn_name(nb_channels) = seed_record(p+9:p+11)
c               WRITE(*,*) stn
               CALL parse_52(p)
            ENDIF

            READ(seed_record(p+3:p+6),*) size

            p = p + size

         ENDDO

      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Detects if blockette type is valid in Abbreviation Control Headers
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION is_valid_abbr_blk(type)

         IMPLICIT NONE
         
         integer*4   i          ! loop counter
         character*3 type       ! type to test
         character*3 types(14)  ! types of blockette
         data types / '030','031','032','033','034','035','041','042',
     &              '043','044','045','046','047','048'  /

         DO i = 1, 14
            IF (type .EQ. types(i)) THEN
               is_valid_abbr_blk = .TRUE.
               RETURN
            ENDIF
         ENDDO

         is_valid_abbr_blk = .FALSE.
         RETURN

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Detects if blockette type is valid in Station Control Headers
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION is_valid_stn_blk(type)

         IMPLICIT NONE
         
         integer*4   i          ! loop counter
         character*3 type       ! type to test
         character*3 types(13)  ! types of blockette
         data types / '050','051','052','053','054','055','056','057',
     &              '058','059','060','061','062'  /

         DO i = 1, 13
            IF (type .EQ. types(i)) THEN
               is_valid_stn_blk = .TRUE.
               RETURN
            ENDIF
         ENDDO

         is_valid_stn_blk = .FALSE.
         RETURN

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Parses blockette 30
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE parse_30(p)

         IMPLICIT NONE
         INCLUDE 'seed.inc.f'
         INCLUDE 'seed_internal.inc.f'

         integer*4    p, q      ! pointer to beginning of blockette
         integer*4    tilde     ! position of tilde in variable length fields
         character*3  blk_type  ! blockette type
         integer*4    size      ! size of blockette
         character*50 description ! description of encoding format
         character*4  format_code ! format identifier code
         character*3  family_type ! data family type
         character*2  n_keys    ! number of decoder keys
         character*5  keys(50)  ! decoder keys

         

         blk_type = seed_record(p:p+2)
         READ(seed_record(p+3:p+6),*) size

c     next (short descriptive name) field is variable length.
c     So, we have to look for the tilde, in order to know where it ends.
c     And the following fields will have their position determined by
c     an offset from this tilde.
         tilde = INDEX(seed_record(p+7:p+56), '~')
         q = p+7+tilde
         description = seed_record(p+7:q-1)

c         WRITE(*,*) blk_type, description

c     If the description has any of the following: steim2, Steim2,
c     STEIM2, steim 2, steim-2, steim_2, steim level 2, etc.,
c     than the encoding format is Steim 2. 
c     If description has: steim, Steim 1, Steim-1, etc, than the
c     encoding is Steim 1.
         CALL upper_s(description)
         IF (INDEX(description, S_STEIM) .NE. 0) THEN
            IF (INDEX(description, '2') .NE. 0) THEN
               encoding = STEIM_2
            ELSE
               encoding = STEIM_1
            ENDIF
         ENDIF

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Parses blockette 52.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE parse_52(p)

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*4    p,q       ! pointer to beginning of blockette
         integer*4    tilde     ! position of tilde in variable length fields
         character*3  blk_type  ! blockette type
         integer*4    size      ! size of blockette
         character*2  loc       ! location identifier
         character*3  chn       ! channel name
         character*4  subchn    ! subchannel id
         character*3  instrument ! instrument id
         character*30 comment   ! optional variable length comment
         character*3  sig_unit  ! units of signal response
         character*3  cal_unit  ! units of calibration input
         real*4       latitude  ! latitude
         real*4       longitude ! longitude
         real*4       elevation ! elevation
         real*4       depth     ! local depth
         real*4       azimuth   ! azimuth (degrees)
         real*4       dip       ! dip
         character*4  encode_id ! format identifier code
         real*4       s_rate    ! sample rate
         real*4       clk_drift ! max clock drift
         character*4  n_comments ! number of comments
         character*26 chn_flags ! channel flags
         character*22 start_date ! start date
         character*22 end_date  ! end date

         blk_type = seed_record(p:p+2)
         READ(seed_record(p+3:p+6),*) size
         loc = seed_record(p+7:p+8)
         chn = seed_record(p+9:p+11)
         subchn = seed_record(p+12:p+15)
         instrument = seed_record(p+16:p+18)
c     next field is variable length
         tilde = INDEX(seed_record(p+19:p+48), '~')
         q = p+19+tilde
         comment = seed_record(p+19:q-1)
         sig_unit = seed_record(q:q+2)
         cal_unit = seed_record(q+3:q+5)
c         READ(seed_record(q+6:q+15),*) latitude
c         READ(seed_record(q+16:q+26),*) longitude
c         READ(seed_record(q+27:q+33),*) elevation
c         READ(seed_record(q+34:q+38),*) depth
c         READ(seed_record(q+39:q+43),*) azimuth
c         READ(seed_record(q+44:q+48),*) dip
         encode_id = seed_record(q+49:q+52)
c         READ(seed_record(q+53:q+54),*) rec_length
c         READ(seed_record(q+55:q+64),*) s_rate
c         READ(seed_record(q+65:q+74),*) clk_drift
         n_comments = seed_record(q+75:q+78)
c     other variable length fields:
         tilde = INDEX(seed_record(q+79:q+104), '~')
         chn_flags = seed_record(q+79:q+79+tilde-1)
         q = q+79+tilde
         tilde = INDEX(seed_record(q:q+21), '~')
         start_date = seed_record(q:q+tilde-1)
         q = q+tilde
         tilde = INDEX(seed_record(q:q+21), '~')
         end_date = seed_record(q:q+tilde-1)
         

c         WRITE(*,*) blk_type, size
c         WRITE(*,*) loc, ' ', chn, ' ', subchn, ' ', instrument
c         WRITE(*,*) rec_length, s_rate, ' ',seed_record(q+55:q+64)
c         WRITE(*,*) chn_flags
c         WRITE(*,*) start_date
c         WRITE(*,*) end_date
         

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Searches for blockettes, and extract the information wanted from each one.
c So far only checks blockettes 100 and 1000
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE miniseed_read_blockettes()

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*2 swap_2byte, toint ! auxiliary functions
         integer*4 swap_4byte        ! auxiliary function

c Nasty trick in order to convert from char to an integer
         integer*2   next          ! offset to next blockette
         character*2 c_next        ! temp in order to make casting
         equivalence(next, c_next)

         integer*2   type       ! type of blockette
         character*2 c_type     ! temp in order to make casting
         equivalence(type, c_type)

         character*4 c_sample   ! sample rate in blockette 100
         integer*4 sample_i     ! auxiliary variable
         real*4    sample_r     ! auxiliary variable
         equivalence(c_sample, sample_rate)
         equivalence(sample_i, sample_r)


c         equivalence(sample, sample_rate)

c        Gets first block
         next = first_blk

         DO WHILE (next .NE. 0)

c           Gets blocks type
            c_type = seed_record(next+1: next+2)       
            IF (is_swapped) THEN
               type = swap_2byte(type)
            ENDIF
c            WRITE(*,*) 'Blockette ', type, next

c           Gets the information wanted in the current blockette
            IF (type .EQ. 100) THEN
c     First, we cast from character*4 to real*4.
               c_sample = seed_record(next+5:next+8)
c     But if we have to swap it, we have to cast to integer.
               sample_r = sample_rate
               IF (is_swapped) THEN
                  sample_i = swap_4byte(sample_i)
                  sample_rate = sample_r
               ENDIF
            ELSEIF (type .EQ. 1000) THEN
               encoding = toint(seed_record(next+5:next+5))
               rec_length = toint(seed_record(next+7: next+7))
c               WRITE (*,*) encoding, rec_length, 
c     &              toint(seed_record(next+6:next+6))
            ELSEIF (type .EQ. 1001) THEN
               timing_quality = toint(seed_record(next+5:next+5))
               usec = toint(seed_record(next+6:next+6))
               n_frames = toint(seed_record(next+8:next+8))
c               WRITE(*,*) timing_quality, usec, n_frames
            ENDIF

c           Go to next blockette
            c_next = seed_record(next+3:next+4)
            IF (is_swapped) THEN
               next = swap_2byte(next)
            ENDIF

         END DO

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Treat some flags
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE seed_treat_flags()
      
         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'
      
         integer*2 toint ! auxiliary function
         integer*2 seed_qual_missing_data         ! mask
         integer*2 seed_qual_questionable_timetag ! mask
         integer*2 seed_act_begin_event           ! mask
         data seed_qual_missing_data /z'0010'/
         data seed_qual_questionable_timetag /z'0080'/
         data seed_act_begin_event /z'0004'/

         questionable_time_tag = .FALSE.
         IF (IAND(toint(activity_flags), 
     &      seed_act_begin_event) .NE. 0) THEN
            WRITE (*,*) 'WARNING - beginning of event in record ',
     &           seq_number
         ENDIF

         IF (IAND(toint(quality_flags), 
     &      seed_qual_missing_data) .NE. 0) THEN
            WRITE (*,*) 'WARNING - data missing in record ',
     &           seq_number
         ENDIF
         IF (IAND(toint(quality_flags), 
     &      seed_qual_questionable_timetag) .NE. 0) THEN
            questionable_time_tag = .TRUE.
            WRITE (*,*) 'WARNING - questionable time tag in ',
     &           'record ', seq_number
         ENDIF

      END 


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Tests if data must be swapped.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL FUNCTION seed_is_swapped()
         
         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         IF ((day_of_year .GT. 366) .OR. (day_of_year .LT. 0)
     &        .OR. (fracsec .GT. 9999) .OR. (fracsec .LT. 0)
     &        .OR. (year .GT. 2056) .OR. (year .LT. 1950)) THEN
            seed_is_swapped = .TRUE.
c            WRITE(*,*) 'SWAPPED!!!'
         ELSE
            seed_is_swapped = .FALSE.
c            WRITE(*,*) 'NOT SWAPPED!!!'
         ENDIF

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Swaps fields in header
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE seed_swap_header()

         IMPLICIT NONE
         INCLUDE 'seed_internal.inc.f'

         integer*2 swap_2byte ! auxiliary function
         integer*4 swap_4byte ! auxiliary function

         year = swap_2byte(year)
         day_of_year = swap_2byte(day_of_year)
         fracsec = swap_2byte(fracsec)
         n_samples = swap_2byte(n_samples)
         sample_rate_factor = swap_2byte(sample_rate_factor)
         sample_rate_multiplier = swap_2byte(sample_rate_multiplier)
         time_correction = swap_4byte(time_correction)
         data_p = swap_2byte(data_p)
         first_blk = swap_2byte(first_blk)

      END



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Swaps fields in output header 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE seed_swap_output_header()

         IMPLICIT NONE
c        INCLUDE 'seed_internal.inc.f'
         include 'write_mseed_internal.inc.f'

         integer*2 swap_2byte ! auxiliary function
         integer*4 swap_4byte ! auxiliary function

         year_ = swap_2byte(year_)
         day_of_year_ = swap_2byte(day_of_year_)
         fracsec_ = swap_2byte(fracsec_)
         n_samples = swap_2byte(n_samples)
         sample_rate_factor = swap_2byte(sample_rate_factor)
         sample_rate_multiplier = swap_2byte(sample_rate_multiplier)
         time_correction = swap_4byte(time_correction)
         data_p = swap_2byte(data_p)
         first_blk = swap_2byte(first_blk)
         blk_type_1000=swap_2byte(blk_type_1000)
         next_1000=swap_2byte(next_1000)

      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Returns the integer value inside the character variable
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*2 FUNCTION toint(input)

         IMPLICIT NONE
         character*1 input            ! input
         character*2 char             ! a temporary
         integer*2 out                ! output
         equivalence(out, char)
         logical computer_word_order  ! function

         out = 0
         IF (computer_word_order()) THEN
            char(2:2) = input
         ELSE
            char(1:1) = input
         ENDIF
         toint = out
         RETURN
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Returns the integer value as a 4-byte integer.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION toint4(input)

         IMPLICIT NONE
         character*1 input
         character*4 char
         integer*4 out
         equivalence(out, char)
         logical computer_word_order ! function

         out = 0
         IF (computer_word_order()) THEN
            char(4:4) = input
         ELSE
            char(1:1) = input
         ENDIF
         toint4 = out
         RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     swaps a word of 2 bytes
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*2 FUNCTION swap_2byte(i2j)

           integer*2 i2j,i2
           character*1 i1(2),k
           equivalence (i1(1),i2)

           i2 = i2j
           k = i1(1)
           i1(1) = i1(2)
           i1(2) = k
           swap_2byte = i2
           RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     swaps a word of 4 bytes
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION swap_4byte(i2j)

           integer*4 i2j,i4
           character*1 i1(4),k,l
           equivalence (i1(1),i4)

           i4 = i2j
           k = i1(1)
           l = i1(2)
           i1(1) = i1(4)
           i1(2) = i1(3)
           i1(3) = l
           i1(4) = k
           swap_4byte = i4
           RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     defines the byte order of the computer
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      logical FUNCTION computer_word_order()

         LOGICAL LITTLE_ENDIAN, BIG_ENDIAN
         PARAMETER(LITTLE_ENDIAN = .FALSE.)
         PARAMETER(BIG_ENDIAN = .TRUE.)
         integer*4 int     ! an integer to test the byte order
         character*4 char  ! an equivalence to allow putting bytes into "int"
         equivalence(int, char)

         integer*4 pillar  ! the value "int" will have in a big endian
         data pillar /Z'31323334'/

         char(1:1) = '1'
         char(2:2) = '2'
         char(3:3) = '3'
         char(4:4) = '4'

         IF (int .EQ. pillar) THEN
            computer_word_order = BIG_ENDIAN
         ELSE
            computer_word_order = LITTLE_ENDIAN
         ENDIF

         RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Calculates sample rate from data record
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      REAL*4 FUNCTION calculate_sample_rate(factor, multiplier)

         IMPLICIT NONE
         integer*2 factor, multiplier ! inputs
         REAL*4 rate ! output

c         WRITE(*,*) factor, multiplier

         IF (factor .LT. 0) THEN 
            rate = -1.00/factor
         ELSE
            rate = 1.00*factor
         ENDIF
         IF (multiplier .LT. 0) THEN
            rate = - rate / multiplier
         ELSE
            rate = rate * multiplier
         ENDIF

         calculate_sample_rate = rate
         RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads numbers from input as 32 bit integers, and puts them in output.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE read_32bit(input, output, nsamp)

         IMPLICIT NONE

         integer*4 input(*)   ! input data
         integer*4 output(*)  ! output data
         integer*2 nsamp      ! number of samples

         integer*2 i ! loop counter

         DO i = 1, nsamp
            output(i) = input(i)
         ENDDO

      END



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads the input that is compressed with steim 1, and put the 
c decompressed samples in "output".
c
c The size of "output" is set on the calling routine. But it must be big
c enough to hold "nsamp" samples.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION read_steim1 (input, output, nsamp)

         IMPLICIT NONE

         integer*4 FRAME_SIZE
         PARAMETER (FRAME_SIZE = 16)

         integer*4 input(*)     ! input (compressed) samples
         integer*2 nsamp        ! # of samples informed in header
         integer*4 output(*)    ! output (decompressed) samples

         integer*4 i, j         ! loop counters
         integer*4 ic8, ic16    ! auxiliary functions

         integer*4 n            ! # of samples decompressed
         integer*4 integr       ! integrity check
         integer*4 rev_integr   ! reverse integrity check
         integer*4 w0           ! first word of frame, with the nibles
         integer*4 nible        ! nible referencing current word

         integer*4 word         ! current word

         integr = input(2)
         rev_integr = input(3)
c         WRITE (*,*) 'INTEGR: ', integr, rev_integr, nsamp

         n = 1
         output(1) = integr

c        for each frame of 16 words
         i = 0
         DO WHILE ((n .LT. nsamp))

c           w0 holds all the nibles of the frame
            w0 = input(i*FRAME_SIZE + 1)
            j = 1

c           for each word in the frame
            DO WHILE ((n .LT. nsamp) .AND. (j .LE. FRAME_SIZE))
c               WRITE(*,"('Frame Header ', Z8, I3, I3)") w0, i, j
c              get the corresponding nible
               nible = ibits(w0, 2*(FRAME_SIZE - j), 2)
               word = input(i*FRAME_SIZE + j)
c               WRITE(*,"(I3, ' ', Z8)") nible, word

c              4 samples in the word
               IF (nible .EQ. 1) THEN

c                 This ignores the very first difference of the record
c                 because it is taken in reference to the last sample
c                 of the previous one, and different Mini-SEED
c                 generators disagree in the interpretation of this
c                 value when the record is the first one
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                     output(n+1) = output(n)+ ic8(ibits(word, 24, 8))
                     n = n + 1
                  ENDIF
                  output(n+1) = output(n) + ic8(ibits(word, 16, 8))
                  output(n+2) = output(n+1) + ic8(ibits(word, 8, 8))
                  output(n+3) = output(n+2) + ic8(ibits(word, 0, 8))
                  n = n+3

c              2 samples in the word
               ELSEIF (nible .EQ. 2) THEN

c                 Ignoring the very first difference of the record
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                     output(n+1) = output(n) + ic16(ibits(word, 16, 16))
                     n = n+1
                  ENDIF
                  output(n+1) = output(n) + ic16(ibits(word, 0, 16))
                  n = n+1

c              1 sample in the word
               ELSEIF (nible .EQ. 3) THEN
                     IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                        output(n+1) = output(n) + word 
                        n = n+1
                     ENDIF
               ENDIF

               j = j + 1
            ENDDO
            i = i + 1
         ENDDO

c         WRITE(*,*) output(n-1), output(n)
c        checking the integrity constants
         read_steim1 = .TRUE.
         IF (n .NE. nsamp) THEN
            WRITE (*,*) 'Number of samples (',n,') does not ',
     &           'agree with header (',nsamp,').' 
         ENDIF
         IF (output(1) .NE. integr) THEN
            WRITE(*,
     &    "('first sample ',i9, ' does not agree with '
     &    'integrity constant ',i9)") output(1), integr
         ENDIF
         IF (output(n) .NE. rev_integr) THEN
            WRITE(*,
     &    "('last sample ',i9, ' does not agree with reverse'
     &    ' integrity constant ',i9)") output(n), rev_integr
            read_steim1 = .FALSE.
         ENDIF
         RETURN
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Decompress Nanometrics Steim1 file
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE read_nanometrics (input, output, nsamp, is_swapped)

         IMPLICIT NONE

         integer*4 FRAME_SIZE
         PARAMETER (FRAME_SIZE = 16)

         integer*4 input(*)     ! input (compressed) samples
         integer*2 nsamp        ! # of samples informed in header
         integer*4 output(*)    ! output (decompressed) samples
         logical is_swapped   ! if the file is swapped

         integer*4 i, j         ! loop counters
         integer*4 ic8          ! auxiliary functions
         integer*4 toint4       ! auxiliary function
         integer*2 swap_2byte   ! auxiliary function
         integer*4 swap_4byte   ! auxiliary function

         integer*4 n            ! # of samples decompressed
         integer*4 integr       ! integrity check
         integer*4 rev_integr   ! reverse integrity check
         integer*4 w0           ! first word of frame, with the nibles
         integer*4 nible        ! nible referencing current word
         
         integer*4 word, word1  ! current word
         character*1 c_word(4)  ! auxiliary variable
         integer*2   h_word(2)  ! auxiliary variable
         equivalence(word1, h_word)
         equivalence(word, c_word)

         integr = input(2)
         rev_integr = input(3)

         IF (is_swapped) THEN
            integr = swap_4byte(integr)
            rev_integr = swap_4byte(rev_integr)
         ENDIF

c         WRITE (*,*) 'INTEGR: ', integr, rev_integr, nsamp

         n = 1
         output(1) = integr

c        for each frame of 16 words
         i = 0
         DO WHILE ((n .LT. nsamp))

c           w0 holds all the nibles of the frame
            w0 = input(i*FRAME_SIZE + 1)

            IF (is_swapped) THEN
               w0 = swap_4byte(w0)
            ENDIF
            j = 1

c           for each word in the frame
            DO WHILE ((n .LT. nsamp) .AND. (j .LE. FRAME_SIZE))
c               WRITE(*,"('Frame Header ', Z8, I3, I3)") w0, i, j
c              get the corresponding nible
               nible = ibits(w0, 2*(FRAME_SIZE - j), 2)
               word = input(i*FRAME_SIZE + j)
c               WRITE(*,"(I3, ' ', Z8)") nible, word

c              4 samples in the word
               IF (nible .EQ. 1) THEN

c                 This ignores the very first difference of the record
c                 because it is taken in reference to the last sample
c                 of the previous one, and different Mini-SEED
c                 generators disagree in the interpretation of this
c                 value when the record is the first one
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                     output(n+1) = output(n)+ ic8(toint4(c_word(1)))
                     n = n + 1
                  ENDIF
                  output(n+1) = output(n) + ic8(toint4(c_word(2)))
                  output(n+2) = output(n+1) + ic8(toint4(c_word(3)))
                  output(n+3) = output(n+2) + ic8(toint4(c_word(4)))
                  n = n+3

c              2 samples in the word
               ELSEIF (nible .EQ. 2) THEN
c     "word" was already equivalenced to something else, so, in order
c     to get the half words and swap them, we had to copy it to word1.
                  word1 = word
                  IF (is_swapped) THEN
                     h_word(1) = swap_2byte(h_word(1))
                     h_word(2) = swap_2byte(h_word(2))
                  ENDIF
c                 Ignoring the very first difference of the record
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                     output(n+1) = output(n) + h_word(1)
                     n = n+1
                  ENDIF
                  output(n+1) = output(n) + h_word(2)
                  n = n+1

c              1 sample in the word
               ELSEIF (nible .EQ. 3) THEN
                  IF (is_swapped) THEN
                     word = swap_4byte(word)
                  ENDIF
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                     output(n+1) = output(n) + word 
                     n = n+1
                  ENDIF
               ENDIF

               j = j + 1
            ENDDO
            i = i + 1
         ENDDO

c         WRITE(*,*) output(n-1), output(n)
c        checking the integrity constants
         IF (n .NE. nsamp) THEN
            WRITE (*,*) 'Number of samples (',n,') does not ',
     &           'agree with header (',nsamp,').' 
         ENDIF
         IF (output(1) .NE. integr) THEN
            WRITE(*,
     &    "('first sample ',i9, ' does not agree with '
     &    'integrity constant ',i9)") output(1), integr
         ENDIF
         IF (output(n) .NE. rev_integr) THEN
            WRITE(*,
     &    "('last sample ',i5, ' does not agree with reverse'
     &    ' integrity constant ',i5)") output(n), rev_integr
         ENDIF

      END



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Reads the input that is compressed with steim 2, and put the 
c decompressed samples in "output".
c
c The size of "output" is set on the calling routine. But it must be big
c enough to hold "nsamp" samples.
c
c This algorithom is very similar to the Steim 1, so repeated comments
c will be ommited.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE read_steim2 (input, output, nsamp)

         IMPLICIT NONE

         integer*4 FRAME_SIZE
         PARAMETER (FRAME_SIZE = 16)

         integer*4 input(*)! where compressed samples are
         integer*2 nsamp   ! # of samples on input
         integer*4 output(*) ! where decompressed samples should be put

         integer*4 integr     ! integrity check
         integer*4 rev_integr ! reverse integrity check

         integer*4 i, j ! loop counters
         integer*4 ic8  ! auxiliary functions

         integer*4 n     ! number of decompressed samples
         integer*4 w0    ! first word of the frame (the nibles)
         integer*4 word  ! current word being decompressed
         integer*4 nible ! nible referencing current word

         integr = input(2)
         rev_integr = input(3)
c         WRITE(*,*) integr, rev_integr, nsamp

         n = 1
         output(1) = integr

         i = 0
         DO WHILE ((n .LT. nsamp))
            
            w0 = input(i*FRAME_SIZE + 1)
c            WRITE(*,*) ' '
c            WRITE(*,'(Z8)') w0
            j = 1
            
            DO WHILE ((n .LT. nsamp) .AND. (j .LE. FRAME_SIZE))

               nible = ibits(w0, 2*(FRAME_SIZE - j), 2)
               word = input(i*FRAME_SIZE + j)
c               WRITE(*,'(Z8, Z10)') nible, word

c              exactly like in Steim 1
               IF (nible .EQ. 1) THEN
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                     output(n+1) = output(n)+ ic8(ibits(word, 24, 8))
                     n = n + 1
                  ENDIF
                  output(n+1) = output(n) + ic8(ibits(word, 16, 8))
                  output(n+2) = output(n+1) + ic8(ibits(word, 8, 8))
                  output(n+3) = output(n+2) + ic8(ibits(word, 0, 8))
                  n = n+3

c              1, 2 or 3 samples
               ELSEIF (nible .EQ. 2) THEN
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                    CALL decode_steim2_nible2(word, output, n, .TRUE.)
                  ELSE
                    CALL decode_steim2_nible2(word, output, n, .FALSE.)
                  ENDIF
                  
c              5, 6 or 7 samples
               ELSEIF (nible .EQ. 3) THEN
                  IF ((i .NE. 0) .OR. (j .NE. 4)) THEN
                    CALL decode_steim2_nible3(word, output, n, .TRUE.)
                  ELSE
                    CALL decode_steim2_nible3(word, output, n, .FALSE.)
                  ENDIF

               ENDIF

               j = j + 1
            ENDDO
            i = i + 1
         ENDDO
c        checking the integrity constants
         IF (n .NE. nsamp) THEN
            WRITE (*,*) 'Number of samples (',n,') does not ',
     &           'agree with header (',nsamp,').' 
         ENDIF
         IF (output(1) .NE. integr) THEN
            WRITE(*,
     &    "('first sample ',i9, ' does not agree with '
     &    'integrity constant ',i9)") output(1), integr
         ENDIF
         IF (output(n) .NE. rev_integr) THEN
            WRITE(*,
     &    "('last sample ',i9, ' does not agree with reverse'
     &    ' integrity constant ',i9)") output(n), rev_integr
         ENDIF
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c decodes word steim2 compressed, when nible is 2
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE decode_steim2_nible2(word, output, n, isNotFirst)

         IMPLICIT NONE

         integer*4 word     ! current word
         integer*4 output(*)! place where decompressed samples should be placed
         integer*4 n        ! last position of the output that has a value
         logical isNotFirst ! is first word of the record
         integer*4 dnib ! extra nible in steim 2 (last 2 bytes of each word)

         integer*4 ic30, ic15, ic10 ! auxiliary functions

         dnib = ibits(word, 30, 2)
                  
c        1 sample
         IF (dnib .EQ. 1) THEN
            IF (isNotFirst) THEN
               output(n+1) = output(n) + ic30(ibits(word, 0, 30))
               n = n + 1
            ENDIF

c        2 samples
         ELSEIF (dnib .EQ. 2) THEN
            IF (isNotFirst) THEN
               output(n+1) = output(n) + ic15(ibits(word, 15, 15))
               n = n + 1
            ENDIF
            output(n+1) = output(n) + ic15(ibits(word, 0, 15))
            n = n + 1

c        3 samples
         ELSEIF (dnib .EQ. 3) THEN
            IF (isNotFirst) THEN
               output(n+1) = output(n) + ic10(ibits(word, 20, 10))
               n = n + 1
            ENDIF
            output(n+1) = output(n) + ic10(ibits(word, 10, 10))
            output(n+2) = output(n+1) + ic10(ibits(word, 0, 10))
            n = n + 2

         ELSE
            WRITE (*,*) 'ERROR decompressing Steim2!'
            STOP
         ENDIF
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c decompresses word steim2 compressed, when nible is equal to 3
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE decode_steim2_nible3(word, output, n, isNotFirst)

         IMPLICIT NONE

         integer*4 word     ! current word
         integer*4 output(*)! place where decompressed samples should be placed
         integer*4 n        ! last position of the output that has a value
         logical isNotFirst ! check if is not first word of the record
         integer*4 dnib ! extra nible in steim 2 (last 2 bytes of each word)

         integer*4 ic6, ic5, ic4 ! auxiliary functions
         integer*4 i ! loop counter

         dnib = ibits(word, 30, 2)

c        5 samples
         IF (dnib .EQ. 0) THEN
            IF (isNotFirst) THEN
               output(n+1) = output(n) + ic6(ibits(word, 24, 6))
               n = n + 1
            ENDIF
            DO i = 1, 4
               output(n+1) = output(n) + ic6(ibits(word, 6*(4-i), 6))
               n = n + 1
            ENDDO 

c        6 samples
         ELSEIF (dnib .EQ. 1) THEN
            IF (isNotFirst) THEN
               output(n+1) = output(n) + ic5(ibits(word, 25, 5))
               n = n + 1
            ENDIF
            DO i = 1, 5
               output(n+1) = output(n) + ic5(ibits(word, 5*(5-i), 5))
               n = n + 1
            ENDDO

c        7 samples
         ELSEIF (dnib .EQ. 2) THEN
            IF (isNotFirst) THEN
               output(n+1) = output(n) + ic4(ibits(word, 24, 4))
               n = n + 1
            ENDIF
            DO i = 1, 6
               output(n+1) = output(n) + ic4(ibits(word, 4*(6-i),4))
               n = n + 1
            ENDDO

         ELSE
            WRITE(*,*) 'ERROR decompressing Steim2!'
            STOP
         ENDIF

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Swaps bytes of all integers in input
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE swap_buffer(input, size)
         
        IMPLICIT NONE
        integer*4 input(*)   ! array of integers
        integer size         ! number of elements in input
        integer i            ! loop counter
        integer*4 swap_4byte ! function

        DO i = 1, size
          input(i) = swap_4byte(input(i))
        ENDDO
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 4th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic4(iarg)
         data mask/z'fffffff0'/
         ic4=iarg
         if(btest(iarg,3))ic4=or(iarg,mask)
         return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 5th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic5(iarg)
         data mask/z'ffffffe0'/
         ic5=iarg
         if(btest(iarg,4))ic5=or(iarg,mask)
         return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 6th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic6(iarg)
         data mask/z'ffffffc0'/
         ic6=iarg
         if(btest(iarg,5))ic6=or(iarg,mask)
         return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 8th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic8(iarg)
         data mask/z'ffffff00'/
         ic8=iarg
         if(btest(iarg,7))ic8=or(iarg,mask)
         return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 10th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic10(iarg)

         data mask/z'fffffc00'/
         ic10=iarg
         if(btest(iarg,9))ic10=or(iarg,mask)
         return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 15th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic15(iarg)

         data mask/z'ffff8000'/
         ic15=iarg
         if(btest(iarg,14))ic15=or(iarg,mask)
         return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 16th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic16(iarg)
c
c     pads with 1's word "ic16" if its rightmost 2-byte half
c     has a 1 as most significant bit (this because
c     bytes 0,1 have to be interpreted as a signed number)
c
      data mask/z'ffff0000'/
      ic16=iarg
      if(btest(iarg,15))ic16=or(iarg,mask)
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c If 30th bit of iarg is "1", pads with 1 more significant bits.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*4 FUNCTION ic30(iarg)

         data mask/z'c0000000'/
         ic30=iarg
         if(btest(iarg,29))ic30=or(iarg,mask)
         return
      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Converts a string to uppercase
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE upper_s(str)

         IMPLICIT NONE

         character*50 str      ! string to be converted
         character*1 uppercase ! auxiliary function
         integer*4   i         ! loop counter
         
         DO i = 1, LEN(str)
            str(i:i) = uppercase(str(i:i))
         ENDDO

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c convert lower case single char to upper case - machine independent
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      CHARACTER*1 FUNCTION uppercase(a)

         character*1 chr(26),ucchr(26),a
         data chr/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     &     'n','o','p','q','r','s','t','u','v','w','x','y','z'/
         data ucchr/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     &     'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
         do i=1,26
            if(a.eq.chr(i))then
              uppercase=ucchr(i)
              return
            endif
         end do 
         uppercase=a
         return
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Routine to convert from date to day-of-year
c j. havskov 1992 and Leif Kvamme 12-1-85
c corrected leap year definition 15/12/04
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       INTEGER*2 FUNCTION get_doy (DAY,MON,YR)
  
          implicit none
          integer*4 DAY,MON,YR,MTH(12),J
          logical*1 isleap

          integer*2 year

          year = YR

          DO J = 1,7,2
             MTH(J) = 31
          ENDDO
          DO J = 8,12,2
             MTH(J) = 31
          ENDDO
          MTH(2) = 28
          MTH(4) = 30
          MTH(6) = 30
          MTH(9) = 30
          MTH(11)= 30
          IF (isleap(year)) MTH(2) = 29
          
          get_doy=0
          DO j=1,mon-1
             get_doy=get_doy+mth(j)
          ENDDO
          get_doy=get_doy+day
          
          RETURN
       END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Converts day of year to day, month
c j. havskov 1992 and Leif Kvamme 12-1-85  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       SUBROUTINE get_day_month (DAY,MON,DOY,YR)
                   
       implicit none
       integer*2 DOY,DAY,MON,YR,MTH(12),J,M,N

       do 1 J = 1,7,2
           MTH(J) = 31
    1  continue

       do 2 J = 8,12,2
           MTH(J) = 31
    2  continue

       MTH(2) = 28
       MTH(4) = 30
       MTH(6) = 30
       MTH(9) = 30
       MTH(11)= 30
       if (mod(YR,4) .eq. 0) MTH(2) = 29
       M = 0
       do 3 J = 1,12
       M = M + MTH(J)
       N = DOY - M
       if (N .le. 0) then
           MON = J
           DAY = N + MTH(J)
           goto 4
       endif
    3  continue
    4  return
       end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Routine to convert from time to seconds after 1.1 1900, 00:00:00.00
c                                                  Leif Kvamme 9-4-87
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       REAL*8 FUNCTION time_to_sec (YEAR,MTH,DAY,HR,MIN,SECS)

          implicit none
c--   Total seconds to be returned   
          double precision MSECS ! REAL*8                 
c--                                                  
c--   Input date                     
          integer*2 YR,YEAR,MTH,DAY,HR,MIN,SECS      
c--   Flag for leap-year             
          integer          DYR                    
c--   Number of leap-years since 1900
          integer          IYR                    
c--   Number of days in current year 
          integer          YDY                    
*                                    
          yr=year                                           
          if (YEAR .ge. 1900) YR = YEAR - 1900
          DYR = 0
          if (mod(YR,4) .eq. 0) DYR = 1
          IYR = YR/4 - DYR
c--   Seconds to beginning of     
          MSECS = real(IYR*366) + real((YR-IYR)*365)
c--   current year
          MSECS = MSECS*86400.0
c--   January
          if (MTH .eq. 1) YDY = DAY
c--   February
          if (MTH .eq. 2) YDY = DAY + 31             
c--   ....
          if (MTH .eq. 3) YDY = DAY + DYR + 59
          if (MTH .eq. 4) YDY = DAY + DYR + 90
          if (MTH .eq. 5) YDY = DAY + DYR + 120                 
          if (MTH .eq. 6) YDY = DAY + DYR + 151                  
          if (MTH .eq. 7) YDY = DAY + DYR + 181                  
          if (MTH .eq. 8) YDY = DAY + DYR + 212
          if (MTH .eq. 9) YDY = DAY + DYR + 243
          if (MTH .eq.10) YDY = DAY + DYR + 273
          if (MTH .eq.11) YDY = DAY + DYR + 304
          if (MTH .eq.12) YDY = DAY + DYR + 334
          MSECS = MSECS + real(YDY*86400 + HR*3600 + MIN*60) + SECS
          time_to_sec = MSECS
          RETURN
       END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Opens the file, with the desirable block size.
c It checks if the block size is valid, and returns .TRUE. only if
c the file is open.
c
c Parameters:
c - filenumber: file number
c - filename:   file name
c - length:     (the exponent in the power of 2) of the block length
c
c Return: .TRUE. in case of success
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION open_file(filenumber, filename, length)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 filenumber   ! file number
         character*80 filename  ! name of the file
         integer length       ! length as a power of 2

         open_file = .FALSE.
         BLK_SIZE = 2**length
         IF (BLK_SIZE .LT. 256) RETURN
         IF (BLK_SIZE .GT. MAX_BLK_SIZE) RETURN
         OPEN(filenumber, file = filename, RECL=BLK_SIZE, 
     &        ACCESS='DIRECT', STATUS='UNKNOWN')
         length_ = length
         open_file = .TRUE.
         RETURN
        
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Writes buffer related to channel (in common block) to file.
c
c Parameters:
c - file: file number
c - buf:  buffer with the samples
c - n_blocks: (input/output) number of the (start) block in the file
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE seed_write_chn(file, buf, n_blocks)

         IMPLICIT NONE
         INCLUDE 'write_mseed.inc.f'
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 file         ! output file
         integer*4 buf(*)       ! buffer with input data
         integer*4 n_blocks     ! counter of blocks on file

         integer*4 comp         ! number of samples already compressed
         integer*4 seq          ! sequence number for current channel
         integer*2 factor, multiplier ! sample rate components
         integer*4 last         ! last sample of decompressed sample

         logical*1 calc_rate  ! auxiliary function
         integer*2 get_doy
         logical computer_word_order  ! function

c
c jh   find which platform
c
         seed_pc=.true.       ! default is pc-linux
         if (computer_word_order()) seed_pc=.false.         
c
c jh   set if writing little endian or big endian
c
         force_len=.false.     ! write big endian

         seq = 1
         comp = 0
         last = 0
c         BLK_SIZE = 4096

         year = mseed_year
         doy = get_doy(mseed_day, mseed_month, mseed_year)
         hour = mseed_hour
         minute = mseed_minute
         second = mseed_second
         fracsec = (mseed_second - second)*10000
         encoding = mseed_encoding

         DO WHILE (comp .LT. mseed_total_samples)
            CALL clean_seed_record
            WRITE(seq_number,'(i6.6)') seq
            CALL fill_header
c
c     trying to set sample rate parameters. If there is lost in precision
c     then use blockette 100
c
            IF (.NOT. calc_rate(factor, multiplier, mseed_sample_rate)) 
     &           THEN
               CALL make_blk_100()
            ENDIF
            sample_rate_factor = factor
            sample_rate_multiplier = multiplier
c            WRITE(*,*) 'debug'
            CALL encode(buf(comp+1), mseed_total_samples - comp, last)
            comp = comp + n_samples
c            WRITE(*,*) 'Number of samples', comp, n_samples
c
c   swap if desired, that is writing litte endian on sun or
c   big endian on pc
c
            if((.not.seed_pc.and.force_len).or.
     *         (seed_pc.and..not.force_len)) 
     *         call seed_swap_output_header()
c 
            WRITE(file, REC=n_blocks) seed_record(1:BLK_SIZE)
c
c   swap back since some variables might be used again
c
            if((.not.seed_pc.and.force_len).or.
     *         (seed_pc.and..not.force_len)) 
     *         call seed_swap_output_header()
c 

            n_blocks = n_blocks + 1

            seq = seq + 1

            CALL update_time(n_samples)

        ENDDO
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Encodes data.
c Updates encoding_ field (in blockette 1000).
c Sets n_samples field (in fixed header).
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE encode(buf, n_rem, last)

         IMPLICIT NONE
         INCLUDE 'write_mseed.inc.f'
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 buf(*)       ! input (uncompressed) data
         integer*4 n_rem        ! number of remaining data
         integer*4 last         ! last sample of previous data record
         integer*2 n_frames     ! number of frames

         integer*4 write_steim1 ! auxiliary function
         integer*4 write_32bit  ! auxiliary function
         character*1 tochar     ! auxiliary function
         integer*4      output(1024)
         character*4096 c_output
         equivalence (output, c_output)

         CALL clean_array(output, BLK_SIZE/4)

         n_frames = (BLK_SIZE - data_p) / (FRAMESIZE*4)
c         WRITE(*,*) 'debug encode'
         IF (encoding .EQ. INT_32BIT) THEN
            n_samples = write_32bit(output, n_frames*FRAMESIZE, 
     &           buf, n_rem)
         ELSEIF (encoding .EQ. STEIM1) THEN
            n_samples = write_steim1(output, n_frames, 
     &           buf, n_rem, last)
         ELSE
            WRITE(*,*) 'ERROR - unknown format code, so using Steim1.'
            encoding = STEIM1
            n_samples = write_steim1(output, n_frames,
     &           buf, n_rem, last)
         ENDIF
c
         if((.not.seed_pc.and.force_len).or.
     *      (seed_pc.and..not.force_len)) then 
           call swap_buffer(output,blk_size/4)
         endif
c
         encoding_ = tochar(encoding)
         seed_record(data_p+1:BLK_SIZE) = c_output(1:BLK_SIZE - data_p)
c         WRITE(*,'(Z8, Z8, Z8)') output(1), output(2), output(3)

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Writes data as 32-bit integers
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION write_32bit(output, limit, input, n_samp)

         IMPLICIT NONE

         integer*4 output(*)    ! output buffer
         integer*4 input(*)     ! input buffer
         integer*4 limit        ! max number of samples in the block
         integer*4 n_samp       ! number of samples in input

         integer*4 i            ! loop counter

         i = 1
         DO WHILE ((i .LE. limit) .AND. i .LE. n_samp)
            output(i) = input(i)
            i = i + 1
         ENDDO
         write_32bit = i - 1
         RETURN
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Compresses data from input with steim1 algorithm and puts it in output.
c Returns the number of samples actually compressed.
c
c It works as a DFA. The input is the difference between 2 samples. Depending
c on whether this difference needs 1, 2 or 4 bytes to be represented, we
c choose the next state.
c
c The buffer "diff" holds differences that have been calculated, but it still
c has not been decided how they will be compressed (4 1-byte, 2 2-byte or
c 1 4-byte).
c
c Each state has a particular condition of the "diff" buffer. State 0 is the
c start state. It has no samples. States 4, 22 and 1111 are final. This means
c they will compress the data and put it on output.
c State 4 writes 1 4-byte difference. State 22 writes 2 2-bytes differences.
c State 1111 writes 4 1-byte differences.
c
c State 999 checks if the frame is full. So it follows the final states.
c
c     state      diff    # bytes  next_state    add
c               buffer  of input                  n
c         0          0         1          10     +1
c         0          0         2          20     +1
c         0          0         4           4     +1
c        10   1 1-byte         1         110     +1
c        10   1 1-byte         2          22     +1
c        10   1 1-byte         4           4      0
c        20  1 2-bytes         2          22     +1
c        20  1 2-bytes         4           4      0
c       110   2 1-byte         1        1110     +1
c       110   2 1-byte         4          22      0
c      1110   3 1-byte         1        1111     +1
c      1110   3 1-byte         4          22     -1
c         4   1 4-byte         -         999      0
c        22  2 2-bytes         -         999      0
c      1111  4 1-bytes         -         999      0
c       999          0         -           0      0

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION write_steim1(output,n_frames,input,n_samp,last)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 output(*)    ! compressed data
         integer*4 input(*)     ! uncompressed data
         integer*2 n_frames     ! max number of frames that fit
         integer*4 n_samp       ! number of uncompressed samples
         integer*4 last         ! value of last sample put on output


         f_count = 0
         f_pos = 4      ! 1st frame starts on 4th. The others start on 2nd.
         w0 = 0
         state = 0
         n = 0
         output(2) = input(1)   ! integrity constant
c         WRITE(*,*) 'debug steim1'

         DO WHILE ((f_count .LT. n_frames) .AND. (n .LT. n_samp))

            IF (state .EQ. 0) THEN
               CALL state_0(output, input(n+1)-last)

            ELSEIF (state .EQ. 10) THEN
               CALL state_10(output, input(n+1) - input(n))

            ELSEIF (state .EQ. 20) THEN
               CALL state_20(output, input(n+1) - input(n))

            ELSEIF (state .EQ. 110) THEN
               CALL state_110(output, input(n+1) - input(n))

            ELSEIF (state .EQ. 1110) THEN
               CALL state_1110(output, input(n+1) - input(n))

            ELSE
               WRITE(*,*) 'ERROR in algorithm! DFA is wrong!'
            ENDIF
            last = input(n)
         ENDDO

c     If the previous loop ended for the condition (n < n_samp)
c     than we might have samples that were put on the limbo,
c     but were not yet been put on output, because no final
c     stage was reached for them. In these cases, we have to
c     do the following:

c     if there is one sample left...
c     We can treat it as one 4-byte difference
         IF ((state .EQ. 10) .OR. (state .EQ. 20)) THEN
            CALL state_4(output)

c     if there are 2 samples left
c     We can treat them as 2 2-bytes differences.
         ELSEIF (state .EQ. 110) THEN
            CALL state_22(output)

c     if there are 3 samples left...
c     In this case, we have space for 2, putting them as 2-byte differences.
c     But it is not garanteed that there is space for one more word, so
c     we have to check that...
         ELSEIF (state .EQ. 1110) THEN
            CALL state_22(output)
c     if we have space for the last sample, we put it as a 4-byte difference,
c     but if not, we undo it, and tell the calling function that it will
c     need to write another data record...
            IF ((f_pos .LE. FRAMESIZE) 
     &           .OR. (f_count .LT. n_frames)) THEN
               diff(1) = diff(3)
               CALL state_4(output)
            ELSE
               n = n - 1
            ENDIF
         ENDIF

         IF (f_count .LT. n_frames) THEN
            w0 = ISHFT(w0, 2*(16-f_pos+1))
c            WRITE(*,"('W0', Z8)") w0
            output(f_count*FRAMESIZE+1) = w0
         ENDIF
            

         last = input(n)
         output(3) = input(n)  ! reversal integrity constant
         write_steim1 = n      
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 0 of DFA.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_0(output, next_diff)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 next_diff    ! next difference
         integer*4 output(*)    ! place where to put next output

         logical*1 is_1byte, is_2byte ! auxiliary functions

         n = n+1
         diff(1) = next_diff
c         WRITE(*,*) 'debug state 0', diff(1)
         IF (is_1byte(diff(1))) THEN
c            WRITE(*,*) 'debug go to state 10'
            state = 10
         ELSEIF (is_2byte(diff(1))) THEN
c            WRITE(*,*) 'debug go to state 20'
            state = 20
         ELSE
c            WRITE(*,*) 'debug go to state 4'
            CALL state_4(output)
         ENDIF

      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 4 of DFA. It is a final state.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_4 (output)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 output(*)    ! place to put next output

c         WRITE(*,*) 'debug state 4', diff(1)
         output(f_count*FRAMESIZE + f_pos) = diff(1)
         w0 = ISHFT(w0, 2) + 3
         CALL state_999(output)

      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 22 of DFA. It is a final state.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_22 (output)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 output(*)    ! place to put the output
         integer*4 combine2     ! auxiliary function

c         WRITE(*,*) 'debug state 22', diff(1), diff(2)
c
cjh change, could have been done in combine2 routine instead
c
          if(force_len) then
            output(f_count*FRAMESIZE + f_pos) = 
     *      combine2(diff(2), diff(1))
          else
            output(f_count*FRAMESIZE + f_pos) = 
     *      combine2(diff(1), diff(2))
          endif
         w0 = ISHFT(w0, 2) + 2
         CALL state_999(output)
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 10 of DFA.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_10(output, next_diff)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 next_diff    ! next difference to queue
         integer*4 output(*)

         logical*1 is_1byte, is_2byte ! auxliary functions

         n = n + 1
         diff(2) = next_diff
c         WRITE(*,*) 'debug state 10', diff(2)
         IF (is_1byte(diff(2))) THEN
c            WRITE(*,*) 'debug go to state 110'
            state = 110
         ELSEIF (is_2byte(diff(2))) THEN
c            WRITE(*,*) 'debug go to state 22'
            CALL state_22(output)
         ELSE
c            WRITE(*,*) 'debug go to state 4'
            n = n - 1
            CALL state_4(output)
         ENDIF

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 20 of DFA
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_20(output, next_diff)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 next_diff    ! next difference to queue
         integer*4 output(*)    ! place to put next output

         logical*1 is_2byte     ! auxiliary function

c         WRITE(*,*) 'debug state 20'
         diff(2) = next_diff
         n = n + 1
         IF (is_2byte(diff(2))) THEN
c            WRITE(*,*) 'debug go to state 22'
            CALL state_22(output)
         ELSE
c            WRITE(*,*) 'debug go to state 4'
            n = n - 1
            CALL state_4(output)
         ENDIF
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 110 of DFA
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_110(output, next_diff)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 next_diff    ! next difference to queue
         integer*4 output(*)    ! place to put next output

         logical*1 is_1byte     ! auxiliary function

         diff(3) = next_diff
         n = n + 1
c         WRITE(*,*) 'debug state 110', diff(3)
         IF (is_1byte(diff(3))) THEN
c            WRITE(*,*) 'debug go to state 1110'
            state = 1110
         ELSE
            n = n - 1
            CALL state_22(output)
         ENDIF
      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 1110 of DFA
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_1110(output, next_diff)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 next_diff    ! next difference to queue
         integer*4 output(*)    ! place to put next output

         logical*1 is_1byte     ! auxiliary function

         diff(4) = next_diff
         n = n + 1
c         WRITE(*,*) 'debug state 1110', diff(4)
         IF (is_1byte(diff(4))) THEN
c            WRITE(*,*) 'debug go to state 1111'
            CALL state_1111(output)
         ELSE
            n = n - 2
            CALL state_22(output)
         ENDIF
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c State 1111 of DFA. It is a final state.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_1111(output)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 output(*)       ! place to put the next output
         integer*4 combine4     ! auxiliary function

c         WRITE(*,*) 'debug state 1111', diff(1), diff(2), 
c     &        diff(3), diff(4)
         output(f_count*FRAMESIZE + f_pos) = combine4(diff)
         w0 = ISHFT(w0, 2) + 1
         CALL state_999(output)
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE state_999(output)

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         integer*4 output(*)

         f_pos = f_pos + 1
c         WRITE(*,*) 'debug state 999', f_count, f_pos
         IF (f_pos .GT. FRAMESIZE) THEN
            output(f_count*FRAMESIZE+1) = w0
            w0 = 0
            f_pos = 2
            f_count = f_count+1
c            WRITE(*,*) 'End of frame'
         ENDIF
         state = 0
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Puts 2 words (the first 16 bits of each) together, in a 32 bit integer.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION combine2(int1, int2)

         IMPLICIT NONE
         integer*4 int1, int2   ! input

         combine2 = ISHFT(ibits(int1,0,16), 16) + ibits(int2, 0, 16)

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Puts 4 words (the first 8 bits of each) together, in a 32 bit integer.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 FUNCTION combine4(int)
         implicit none
         INCLUDE 'write_mseed_internal.inc.f'    ! jh include
         integer*4 int(4)
         integer*4 temp
         

cjh add pc option

        if(force_len) then
            temp = ISHFT(ibits(int(4), 0, 8), 8) + 
     *             ibits(int(3), 0, 8)
            temp = ISHFT(temp, 8) + ibits(int(2), 0, 8)
            combine4 = ISHFT(temp, 8) + ibits(int(1), 0, 8)
         else
            temp = ISHFT(ibits(int(1), 0, 8), 8) + 
     *      ibits(int(2), 0, 8)
            temp = ISHFT(temp, 8) + ibits(int(3), 0, 8)
            combine4 = ISHFT(temp, 8) + ibits(int(4), 0, 8)
         endif

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Updates the start time of the next block, by adding
c samples / sample_rate
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE update_time(samples)

         IMPLICIT NONE
         INCLUDE 'write_mseed.inc.f'
         INCLUDE 'write_mseed_internal.inc.f'

         integer*2 samples      ! number of samples
         integer*4 time_to_add  ! time to add in fractions of seconds
         logical*1 isleap       ! auxliliary function
c change jh ock 2005, change samples +1 to samples in next line
         time_to_add = ((samples) * 10000) / mseed_sample_rate
c         WRITE (*,*) 'debug ',time_to_add

         time_to_add = time_to_add + fracsec
         fracsec = MOD (time_to_add, 10000)
         time_to_add = time_to_add/10000 ! now time_to_add is in seconds
         time_to_add = time_to_add + second
         second = MOD(time_to_add, 60)
         time_to_add = time_to_add/60 ! now it is in minutes
         time_to_add = time_to_add + minute
         minute = MOD(time_to_add, 60)
         time_to_add = time_to_add/60 ! now it is in hours
         time_to_add = time_to_add + hour
         hour = MOD (time_to_add, 24)
         time_to_add = time_to_add/24 ! now it is in days
         doy = doy + time_to_add
         DO WHILE (doy .GT. 366)
            year = year + 1
            IF (isleap(year)) THEN 
               doy = doy - 366
            ELSE 
               doy = doy - 365
            ENDIF
         ENDDO
         IF ((.NOT. isleap(year)) 
     &        .AND. (doy .EQ. 366)) THEN
            doy = 1 
            year = year + 1
         ENDIF
c         WRITE(*,*) mseed_year, mseed_day_of_year, mseed_hour, 
c     &        mseed_minute, mseed_second, mseed_fracsec
      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Fill header.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE fill_header()

         IMPLICIT NONE
         INCLUDE 'write_mseed.inc.f'
         INCLUDE 'write_mseed_internal.inc.f'

         logical   computer_word_order ! auxiliary function
         character*1 tochar     ! auxiliary function
         integer*2   int        ! auxiliary variable


         header_type = 'D'
         continuation = ' '
         station_ = mseed_station
         location_ = mseed_location
         channel_ = mseed_channel
         network_ = mseed_network
         year_ = year
         day_of_year_ = doy
         hour_ = tochar(hour)
         minute_ = tochar(minute)
         second_ = tochar(second)
         fracsec_ = fracsec
         time_correction = 0
         int = 1
         n_blockettes = tochar(int)
         data_p = 64
         first_blk = 48
         blk_type_1000 = 1000
         next_1000 = 0
         rec_length = tochar(length_)


c     defining byte order is done with IF/THEN/ELSE instead using the values
c     of .TRUE. and .FALSE. because on Windows, the integer values of 
c     .TRUE. and .FALSE. are the opposite as in the other systems.
c     this will give byte order om system writing
c     since we now want to control byte order indpendent of system
c     this has been replace by a fixed byte order
c
         int = 1       ! assume default big endian
         if(force_len) int=0
         byte_order = tochar(int)
c
c        IF (computer_word_order()) THEN
cjh         int = 1
cjh         byte_order = tochar(int)
cjh      ELSE
cjh         int = 0
cjh         byte_order = tochar(int)
cjh      ENDIF

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Inserts blockette 100 in data record.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE make_blk_100()

         IMPLICIT NONE
         INCLUDE 'write_mseed.inc.f'
         INCLUDE 'write_mseed_internal.inc.f'

         integer*2   blk_type_100
         integer*2   next_100
         real*4      rate
         character*1 flags

         equivalence(seed_record(65:66), blk_type_100)
         equivalence(seed_record(67:68), next_100)
         equivalence(seed_record(69:72), rate)
         equivalence(seed_record(73:73), flags)

         integer*2 int          ! temp variable
         character*1 tochar     ! auxiliary function
         integer*2   toint      ! auxiliary function

         data_p = 128
         next_1000 = 64
         blk_type_100 = 100
         next_100 = 0
         int = toint(n_blockettes)+1
         n_blockettes = tochar(int)
         rate = mseed_sample_rate

      END


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Defines factor and multiplier, integers, from a real sample rate.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION calc_rate(factor, multiplier, rate)

         IMPLICIT NONE

         integer*2 factor       ! sample rate factor
         integer*2 multiplier   ! sample rate multiplier
         real*4    rate         ! sample rate
         integer*2 i            ! counter
         integer*2 exponent     ! exponent of sample rate
         integer*4 fraction     ! fraction part of sample rate

         integer*4 i_rate
         real*4    r_rate
         equivalence(i_rate, r_rate)

         real*4 calculate_sample_rate ! auxiliary function

         r_rate = rate
         fraction = ibits(i_rate, 0, 23)
         fraction = ibset(fraction, 23)

         i = 0
         DO WHILE (.NOT. BTEST(fraction, 0))
            fraction = ISHFT(fraction, -1)
            i = i + 1
         ENDDO

         exponent = ibits(i_rate,23,8) -127 - 23 + i

c     trying to adjust exponent
         IF (exponent .GT. 14) THEN
            fraction = ISHFT(fraction, exponent - 14)
            exponent = 14
         ELSEIF (exponent .LT. -15) THEN
            fraction = ISHFT(fraction, exponent + 15) ! loosing precision
            exponent = -15
         ENDIF

c     trying to adjust fraction, loosing precision
         DO WHILE (fraction .GT. (2**15) - 1)
            fraction = ISHFT(fraction, -1)
            exponent = exponent + 1
         ENDDO

         IF (exponent .GT. 14) THEN
            calc_rate = .FALSE.
            factor = 0
            multiplier = 0
            RETURN
         ENDIF

         factor = fraction
         IF (exponent .LT. 0) THEN
            multiplier = -2**(-exponent)
         ELSE
            multiplier = 2**exponent
         ENDIF

         calc_rate = (calculate_sample_rate(factor, multiplier)
     &        .EQ. rate)
         RETURN

      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Cleans seed_record.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE clean_seed_record()

         IMPLICIT NONE
         INCLUDE 'write_mseed_internal.inc.f'

         character*4 char
         integer*4   int
         equivalence(int, char)

         integer*4 i

         int = 0

         DO i = 0, BLK_SIZE/4, 4
            seed_record(i+1:i+4) = char
         ENDDO

      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Fills the array with zeros.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE clean_array(array, size)

         IMPLICIT NONE
         integer*4 i            ! counter
         integer*4 array(*)     ! array to be cleaned
         integer*4 size         ! size of array

         DO i = 1, size
            array(i) = 0
         ENDDO

      END

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Converts a 2-byte integer into a 1-byte character.
c The integer must be small enough to fit in 1-byte. There is no
c overflow check in this function.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      CHARACTER*1 FUNCTION tochar(int)

         IMPLICIT NONE

         integer*2 int, int2          ! integer to be converted
         character*2 char       ! equivalence char

         equivalence(int2, char)

         logical computer_word_order ! auxiliary function

         int2 = int
         IF (computer_word_order()) THEN
            tochar = char(2:2)
         ELSE
            tochar = char(1:1)
         ENDIF
         RETURN

      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Checks if input can be represented with 1 byte.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION is_1byte(int)

         IMPLICIT NONE

         integer*4 int

         is_1byte = ((int .LE. 127) .AND. (int .GE. -128))
         RETURN
      END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Checks if input can be represented with 2 bytes.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION is_2byte(int)

         IMPLICIT NONE

         integer*4 int

         is_2byte = ((int .LE. 32767) .AND. (int .GE.-32768))
         RETURN
      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Returns if the year is a leap year (ie with 366 days)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LOGICAL*1 FUNCTION isleap(year)

         IMPLICIT NONE

         integer*2 year

         isleap = ((MOD(year, 100) .NE. 0) .AND. (MOD(year,4) .EQ. 0)) 
     &        .OR. (MOD(year, 400) .EQ. 0)
         RETURN
      END

C 
C	PROGRAM FOCMEC
C
C	Calculates acceptable focal mechanisms based on polarities
C		and (S/P) amplitude ratios.
C	Inspired by the Georgia Tech program with statistics
C		from Kisslinger's.  Conventions are those in
C		Herrmann as well as Aki & Richards
C
C	Code is written in Fortran 77 for a PDP 11/34 operating
C		under RSX version 4.1
C ---------------------------------------------------------------
C
C Seisan program FOCMEC modified to run original FOCMEC program (focmec_exe)
C L. Ottemoller, January 2002
C
C Current program converted for use under pc/ms dos, ms-fortran 5.0
C R. Arvidsson, 1992.
c 
changes
c
c oct   92 by jh: adopted to SEISAN 
c nov 8 92 by jh: Fix a stroke, focmec.out in lowe case
c nov 27        ; fix initialize minbadp
c feb 14 93     ; change dip strike rake to strike dip rake in all files,
c                 circles for C an D, strike dip rake on plot
c sep 14 93     : version 3.0, why not before ??????
c     17        : add focinp, change to foc_prepare
c nov 93        : latest bl routine, plot station option
c mar 22 93     : bug with ---, az
c may 5  94     : new hypocenter
c july 28       : fix common block to include minbadp in all
c sep 94        : incxrease dimentions
c nov 7         : do not run foc_prepare if any argument
c dec 8         : dimensions
c feb 7 95      : bug
CJAB(BGS)Jan95      : Install error and file handling.
CJAB(BGS)Feb95      : Tidy up some loose ends.
c mar 28, 94 by jh  : set window size correctly
c apr 28 95 jh  : add angle calculation as an option, c for composite
c may 18        : bug
c nov 23, 95 jh : make sure only P-phases are used
c feb 13m 95    : only assume full weight polarities, however interanlly
c                 full weight polarities still count for 2 and + anf -
c                 for 1, so + and - can still be used.
c nov 7 96      : adjust for large number of polarities when comp. f. sol
c nov 24        : bug in ---------
c mar 1 98      : enable plotting of several soluttion sform s-file, type 'OF'
c mar 1 99      : ----------- version 7.0 check ----------------------------
C                 station to 5 chars
c mar 23 99 bmt : include winplot.inc 
c apr 20   bmt : include winplot3.inc
c sep 22    jh  : also possible to plot faultplane sol. without a location
c oct 28   jh   : weighted  phases now used, error with 5 char stations
c nov 3    jh   : when doing angles, do no tstop after one calculation
c                 as again, mostly so result do not disappear on pc
c aug 16 02 lot : changed SH(T) to SG(T)
c aug 19 02 lot : fixed bug with increment
c apr 29 03 lot : change in sterpol to ignore replot
c jul  1 03 lot : delete routines that are no longer used
c                 changed call to FMREPS
c jul 15    jh  : add momten to calls of pttpin and dsrin
c jun 20 05 jh  : plt to eps
c dec 10 06 jh  : fix so fps can be plotted without readings
C----------------------------------------------------------------
C
C	Arthur Snoke   Virginia Tech  1984
C	23 October 1984: Added the possibility for using SH
C		amplitudes instead of only SV on the vertical.
C		Also, if the input line key is V (for SV) or H
C		(for SH), the program expects to find a polarity
C		for the S and a comment following the log(ratio).
C		Entering R for the key will work as before: assumes
C		the ratio is for SV on vertical and there is no
C		polarity or comment.  The output now includens the
C		theoretical S polarity, but it does not use it in
C		the search.  Another small change which only acts
C		to speed up the search is that for a B axis plunge
C		of 90 degrees there is only one trend tried.
C		The SH amplitude case has not been checked yet.
C	$ December 1984:  Eliminated double solutions when plunge
C		of B is 0 degrees.  (Only allowed trend to vary
C		between 0 and 180 degrees.  This could affect
C		searches for small parts of the focal sphere.)
C
C         MARCH 1990: CHANGED TO PC-DOS R.N.ARVIDSSON
C
C-
      include 'winplot1.inc'
c        include 'pc.inc'
c        PROGRAM FOCMEC
C
C    SEISAN library/JAB inclusions...
c    --------------------------------
C
      include 'libsei.inc'                 ! Library definitions & data defns.
      include 'seidim.inc'                 ! array dimentions
      include 'seisan.inc'
      include 'seiplot.inc'                ! plotting parameters
c
      external
     &         sei open,                   ! File open handler.
     &         sei close,                  ! & closure.
     &         sei clen,                   ! & length of string.
     &         sei integer,                ! Integer decoder.
     &         sei code                    ! Error condition handler.
      integer  sei clen,                   ! & function.
     &         sei integer                 ! Ditto.
      integer  code,                       ! Condition.
     &         NSOL                        ! # solutions found.
      logical  b_exit                      ! Force exit routine.
c
      integer  read1,                      ! Read unit1.
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write3,                     ! & 3.
     &         write4,                     ! & 4.
     &         write5,                     ! & 4.
     &         write6                      ! & 6
      common /foc_unit$ /
     &         read1,                      ! Read unit1.
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write3,                     ! & 3.
     &         write4,                     ! & 4.
     &         write5                      ! & 5.
c
      logical  b_flag                      ! Flag existance or is a dummy!!
C
C    ------- End of details -------
C
C-
	PARAMETER (MAX = max_data)	
C---------!  Max no. of polarities or polarities
	PARAMETER (MAX2 = 2*max)	
C----------!  Twice MAX
	REAL*4 XYZ(6,MAX2)	
C----------!  R & Theta station coordinates
	REAL*4 PSTATN(MAX)	
C----------!  Stations with polarity data
	REAL*4 RSTATN(MAX)	
C----------!  Stations with amplitude-ratio data
C				   X = north, Y east, Z down
	INTEGER*2 POLRTY(MAX)	
C----------!  1 for C, -1 for D
	INTEGER*2 NPOL,NRATIO
C----------!  Number of Polarities read in
	INTEGER*2 KEYPOL(MAX)	
C----------!  Keys polarity data relative to input
	REAL*4 LOGRAT(MAX)	
C----------!  Log10 of (SV/P) or (SH/P) including
C				   free surface correction, etc.
	INTEGER*2 NRAT		
C----------!  Number of ratios read in
	INTEGER*2 KEYRAT(MAX)	
C-----------!  Keys ratios data relative to input
	CHARACTER SVSH(2,max)	
C-----------! First element V or H for SV or SH, DIMENSION = MAX
C				  Second element polarity: F or B for SV
C				  L or R for SH (back to station)
	INTEGER*2 MAXSOL	
C------------!  Exit after this many accept. aols.
	INTEGER*2 NERRP,NERRA   ! allowed errors for pol and amp ratio
        REAL max_amp_error      ! maximum allowed amplitude ratio error
        INTEGER MINERRP		
C-------------!  Allowed number of polarity errors
	REAL*4 BADPOL(MAX)	
C------------!  Stations with a polarity error
	INTEGER*2 NERRR		
C------------!  Allowed number of ratio errors
	REAL*4 ERRRAT		
C------------!  Maximum allowed Log10 ratio error
	REAL*4 THERAT(MAX)	
C------------!  Theoretical Log10 of (SV/P)
	INTEGER*2 WTRAT(MAX)	
C------------!  1 if that ratio used, 0 otherwise
	REAL*4 VPVS3,VPVS
C------------!  Cube of P/S velocity ratio
	REAL*4 BTMIN,BTDEL,BTMAX	
C------------!  Search range in B axis trend
	REAL*4 BPMIN,BPDEL,BPMAX	
C------------!  Search range in B axis plunge
	REAL*4 AAMIN,AADEL,AAMAX	
C------------!  Search range in A axis angle
C					   measured from B trend
C
	COMMON /FOCM/ PSTATN,RSTATN,XYZ,RD,POLRTY,NPOL,LOGRAT,
     1		NRAT,MAXSOL,NERRP,NERRR,ERRRAT,THERAT,WTRAT,VPVS3,
     2		BTMIN,BTDEL,BTMAX,BPMIN,BPDEL,BPMAX,AAMIN,AADEL,AAMAX,
     3		BADPOL,KEYRAT,KEYPOL,minbadp
        COMMON /FOCCHAR/ SVSH
      logical stat_plot  ! plot station codes if true
      real    iwid
      character*1 xpol,cchar,type,exp
      character*80 text,data(max_data)
      character    chr_solution *(80)      ! Selected solution.
      integer deldeg                       ! search increment
c -- tektronix options
      integer nars   ! number of arguments
      character*80 arg(5) ! arguments
C---
      CHARACTER answer*1
      character*80 editor
C ---
      LOGICAL    merge
      real xx(4)      ! store strike,dip and rake, number of bad polarities
      logical sun,pc,linux
C --------------
c
      include 'version.inc'
      include 'winplot2.inc'


c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)
      call get_seisan_def
      call get_editor(editor)

c
c    Initialise...
c    =============
c
      code   = e_ok$                            ! Local condition.
      b_exit = .false.                          ! No forced exit.
      nsol   = 0                                ! No solutions found.
      write(*,*)
      write(*,*)'============ FOCMEC ============'
      read1  = 0                                ! & unit.
      write1 = 0                                ! Ditto.
      write2 = 0                                ! Ditto.
      write3 = 0                                ! Ditto.
      write4 = 0                                ! Ditto.
      write5 = 0                                ! Ditto.
c
      chr_solution = ' '                        ! Empty.
c
c    Get command line arguments...
c    -----------------------------
c
      call get_arguments(nars,arg)
c
c prepare input from print.out from hyp unless there is an argument 
c which is either a for angle calculations or c for composite solution
c
      if(nars.gt.0) then
         if(arg(1)(1:1).eq.'a'.or.arg(1)(1:1).eq.'A') then
            call angles
            stop
         endif
         if(arg(1)(1:1).ne.'c'.and.arg(1)(1:1).ne.'C') then   
            write(6,*)' Invalid argument, use:'
            write(6,*)' a: Calculate angles'
            write(6,*)' c: Composite fault plane solution, from EEV'
            write(6,*)' None: Fault plane solution after using HYP'
            stop
         endif
      else
         call foc_prepare(npol,nratio,vpvs)
      endif
c
c   both hard copy file and screen plot
c
      plotoption=1      
c--- hard copy type is postscript                                 
      hctype=1		
c-- set xwindow sixe
      wsize=80
c-- no graphics yet
      disp_open=0
c--- Merge polarities, t,p, and faultplane
      merge=.true.
c--- Minimum bad polarities
      minbadp=1000
c--- size of circle
      rcircle=330.0
c--- no new solution
      inew=0
c
c   Open files...
c   =============
c   focmec.inp is input in nordic format
c
      call sei open( old$,                 ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'focmec.inp',         ! File name to open.
     &               read1,                ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).
c
      call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'focmec.lst',         ! File name to open.
     &               write1,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).

      call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'focmec.out',         ! File name to open.
     &               write2,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).

      call sei open( scratch$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'scratch1.out',       ! File name to open (n/a).
     &               write3,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).
c
      call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'scratch2.out',       ! File name to open (n/a).
     &               write4,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).
c
      call sei open( scratch$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'scratch3.out',       ! File name to open (n/a).
     &               write5,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).
c
c   make sure focmec.out is empty
c
       write(write2,*,iostat=code)
       call sei code(fort$,code,write2,b_flag) ! Process outcome.
       rewind(write2,iostat=code)
       call sei code(fort$,code,write2,b_flag) ! Process outcome.
c
c--------------------------------------------------------------------
c   back here for decisions
CJAB(BGS)Jan95 ....it seems logical to prompt user to save any 
CJAB(BGS)Jan95     solutions at this point, rather than when quiting
CJAB(BGS)Jan95     the routine. The user can then plot the solution
CJAB(BGS)Jan95     without having to come back in to the program
c---------------------------------------------------------------------
C     Treat any selected solutions...
c     ===============================
c     write in input file if so chosen and if a new solution has been selected
c
100   if(inew.eq.1) then
         write(6,*)' Save solution (y/n)'
         read(5,'(a1)') answer
         if(answer.eq.'y'.or.answer.eq.'Y') then
            inew = 0                               ! Re-set.
            rewind(read1,iostat=code)
            call sei code(fort$,code,read1,b_flag) ! Process outcome.
            call indata(read1,nstat,nphas,nhead,
     &                  nrecord,type,exp,data,id)
c
c  check if any solution from before, if so overwrite, else add
c
            ifoc=0
            chr_solution(79:80)=' F'
            chr_solution(71:78)='FOCMEC  '
            do i=2,nhead
               if(data(i)(79:80).eq.' F') then
                  ifoc=1
                  data(i)=chr_solution
               endif
            enddo
            if(ifoc.eq.0) then
               do i=nrecord,nhead,-1
                  data(i+1)=data(i)
               enddo
               data(nhead)=chr_solution
               nrecord=nrecord+1
            endif
            rewind(read1,iostat=code)
            call sei code(fort$,code,read1,b_flag)
            write(read1,'(a80)',iostat=code)(data(i),i=1,nrecord)
            call sei code(fort$,code,read1,b_flag)
         endif
c
c    If exit has been forced, then do so...
c    --------------------------------------
c
      if( b_exit ) goto 999                  ! & exit.
      endif
c
c     Main menu....
c     =============
c
150   write(6,*)
      write(6,*) ' Stop                     (0)'
      write(6,*) ' Plot saved solution(s)   (1)'
      write(6,*) ' Plot new solutions       (2)'
      write(6,*) ' Plot selected solution   (3)'
      write(6,*) ' Find new solutions       (4)'
      write(6,*) ' -1, -2, -3 also plot station'
c
      read(*,'(a)') text                        ! Get reply.
      iselect = sei integer( text, code )       ! & decode it.
c
c    Process the outcome...
c    ======================
c    Invalid alpha text...
c    =====================
c
      if( code .ne. e_ok$ ) then                ! Unable to decode.
      write(*,*)
      write(*,*)'**** WARN: invalid option ...try again'
      goto 100                                  ! & menu.
c
c    Numeric options...
c    ==================
c
      else                                      ! Otherwise.
      stat_plot = iselect .lt. 0                ! Plot stations?.
         if( iselect .ne. -4  .and.             ! & re-set.
     &       iselect .lt. 0 ) then              ! Ensure positive.
         iselect = -iselect                     !
         end if                                 !
      end if                                    !
c
c    Finished...
c    ===========
c    If save solution flagged, then go back and try again...
c    -------------------------------------------------------
c
      if( iselect .eq. 0 ) then                 ! Exit.
         if( inew .eq. 1 ) then                 ! Try again.
         b_exit = .true.                        ! Flag exit.
         goto 100                               !
c
         else                                   ! Otherwise exit.
         goto 999                               !
         end if                                 !
c
c    Plot saved solutions...
c    =======================
c
      else if( iselect .eq. 1 ) then            ! Plot saved solutions.
      rewind(read1,iostat=code)                 ! Rewind all files.
      call sei code(fort$,code,read1,b_flag)    ! Process outcome.

      rewind(write1,iostat=code)                !
      call sei code(fort$,code,write1,b_flag)   ! Process outcome.

      rewind(write2,iostat=code)                !
      call sei code(fort$,code,write2,b_flag)   ! Process outcome.
c
      rewind(write4,iostat=code)                !
      call sei code(fort$,code,write4,b_flag)   ! Process the outcome.
c
         iold=0
         call indata(read1,nstat,nphas,nhead,nrecord,
     &               type,exp,data,id)
c
c  select prime fault plane solution and other solutions 'OF'
c
         write(write4,'(a)')'    Strike       Dip     Rake'
         do i=1,nhead
            if(data(i)(79:80).eq.' F'.or.data(i)(79:80).eq.'OF') then
              if(iold.eq.0) then
c                 do k=1,7
c                 do k=1,10  ! lot 18.01.2002
c lot Feb 4, 2002
                write(write4,'(a)',iostat=code) data(i)
                call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c                 enddo
              else
                 write(write4,'(a)',iostat=code) data(i)
              endif
c
              call sei code(fort$,code,write4,b_flag) ! Process the outcome.
              iold=1
            endif
         enddo
         rewind(write4,iostat=code)
c
c   check if any old solution, else go back to main menu
c
         if( iold .ne. 1 ) then
         write(*,*)
         write(*,*)'**** WARN: no solution in S-file'
         goto 100
         end if
c
c  Plot new solutions...
c  ---------------------
c  ...there must be at least 7 lines in focmec.out file
c
      else if( NSOL    .gt. 0   .and.           ! New solutions available.
     &         iselect .eq. 2 ) then            ! Plot new solutions.
      rewind(read1,iostat=code)                 !
      call sei code(fort$,code,read1,b_flag)    ! Process outcome.

      rewind(write1,iostat=code)                !
      call sei code(fort$,code,write1,b_flag)   ! Process outcome.

      rewind(write2,iostat=code)                !
      call sei code(fort$,code,write2,b_flag)   ! Process outcome.

      rewind(write4,iostat=code)                !
      call sei code(fort$,code,write4,b_flag)   ! Process the outcome.
c
         do i=1,9000
            read(write2,'(a)',iostat=code) text
            call sei code(fort$,code,write2,b_flag) ! Process outcome.
            if( b_flag ) goto 95                    ! End of file.
            write(write4,'(a)',iostat=code) text
            call sei code(fort$,code,write4,b_flag) ! Process the outcome.
         enddo
c
95       rewind(write2,iostat=code)
         call sei code(fort$,code,write2,b_flag) ! Process outcome.
c
         rewind(write4,iostat=code)
         call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c
c    Invalid file information...
c
         if( i .lt. 7 ) then                        ! Must be 7 lines.
         write(*,*)
         write(*,*)'**** WARN: no new solutions available'
         goto 100
         end if
c
c     No solutions available...
c     -------------------------
c
      else if( iselect .eq. 2 ) then             !
      write(*,*)
      write(*,*)'**** WARN: no new solutions available'
      goto 100                                   ! Back to menu.
c
c   Plot selected solution...
c   -------------------------
c
      else if( NSOL    .gt. 0   .and.            ! Selection available.
     &         iselect .eq. 3 ) then             ! Plot selected solution.
         rewind(write4,iostat=code)
         call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c
         rewind(write3,iostat=code)
         call sei code(fort$,code,write3,b_flag) ! Process outcome.
c
c    Loop entries, must be at least 7...
c
c         do i=1,7
c         do i=1,10   ! lot 18.01.2002

          write(write4,'(a)')'    Strike       Dip     Rake'
          text = 'xxx'
          do while (text.ne.'    Strike       Dip     Rake')
            read(write3,'(a)',iostat=code) text     !
          enddo
          read(write3,'(a)',iostat=code) text     !
          call sei code(fort$,code,write3,b_flag) ! Process outcome.
c
c       ... end of file...
c
               if( b_flag ) then                    ! End of file.
               write(*,*)                           !
               write(*,*)
     &    '**** WARN: no selected solution available'
               goto 100                             ! Menu.
               end if                               !
c
c     Otherwise write out...
c
            write(write4,'(a)',iostat=code) text
            call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c         enddo
c
         rewind(write3,iostat=code)
         call sei code(fort$,code,write3,b_flag) ! Process outcome.
c
         rewind(write4,iostat=code)
         call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c
c     No solutions available...
c     -------------------------
c
      else if( iselect .eq. 3 ) then             !
      write(*,*)
      write(*,*)'**** WARN: no selected solution available'
      goto 100                                   ! Back to menu.
c
c     Get more solutions...
c     =====================
c
      else if( iselect .eq. 4 ) then             ! Get more solutions
        rewind(read1,iostat=code)
        call sei code(fort$,code,read1,b_flag)     ! Process outcome.

        rewind(write1,iostat=code)
        call sei code(fort$,code,write1,b_flag)    ! Process outcome.

        rewind(write2,iostat=code)
        call sei code(fort$,code,write2,b_flag)    ! Process outcome.
c
c   input data for iterations
c	
c        CALL FOCINP
c
c
c   calculate focal mechanisms
c
c         CALL SRCHFM( NSOL )                    ! Get # solutions.
c

c
c create input file to run focmec, lot 16.01.2002
c
        write(*,'(a,i3,a)') ' There are ',npol,' polarity readings '
135     continue
        write(*,'(a)') ' Maximum number of allowed polarity errors or '
     &   // '-1 to show best solutions only '
c        read(*,*,err=135) nerrp
        read(*,'(a)') text                        ! Get reply.
        nerrp = sei integer( text, code )       ! & decode it.

        minerrp=nerrp

136     continue
        if (nratio.gt.0) then
          write(*,'(a,i3,a)') ' There are ',nratio,' amp ratio readings' 
          write(*,'(a)') ' Maximum number of allowed amplitude ' //
     &          'ratio errors '
c          read(*,*,err=136) nerra
          read(*,'(a)') text                        ! Get reply.
          nerra = sei integer( text, code )       ! & decode it.
          if (nerra.gt.nratio) nerra=nratio
          write(*,'(a)') ' Maximum amplitude ratio error, '
     &     // ' return for default of .2 '
c          read(*,*,err=136) max_amp_error
          read(*,'(a)') text                        ! Get reply.
          read(text,'(f5.2)',err=136) max_amp_error
          if (max_amp_error.eq.0.) max_amp_error=.2
        endif
        if (nerrp.eq.-1) then   ! search for solutions with nerrp,
                                ! max number of solution is 99999,
                                ! automatically find best solutions
          nerrp=int(sqrt(float(npol))+.5)
          minerrp=99999
        endif

c
c   since no longer half polarities counted, multiply by 2
c
c        nerrp=nerrp*2   ! taken out, lot 18.01.2002
        IF (NERRP .GT. NPOL) NERRP = NPOL

        write(6,*)'Degree increment in search'
        read(5,*) deldeg
c
c write focmec command input
c
        call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'focmec.run',         ! File name to open (n/a).
     &               write6,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).

      
        write(write6,'(a)') 'fm_new.out'    
        write(write6,'(a)') '-----'    
        if (linux) 
     &    write(write6,'(a)') ' '    
c        write(write6,'(a)') '/* Comment is previous line: Input file '
c     &             //'for focmec is next '
        write(write6,'(a)') 'focmec.dat'
        write(write6,'(a)') '        correct file  [y] '
        write(write6,'(a)') '        relative weighting..[n] '
        if (nerrp.le.9) then
          write(write6,'(i1,a)') nerrp,
     &   '       allowed P polarity erors..[0] '
        elseif (nerrp.le.99) then
          write(write6,'(i2,a)') nerrp,
     &   '      allowed P polarity erors..[0] '
        else
          write(write6,'(i3,a)') nerrp,
     &   '     allowed P polarity erors..[0] '
        endif
        if (nratio.gt.0) then
          write(write6,'(f4.2,4x,a)') vpvs,'vp/vs ratio'
c          write(write6,'(8x,a)') 'maximum allowed log10 of ratio'
          write(write6,'(f4.2,4x,a)') max_amp_error,
     &      'maximum allowed log10 of ratio'
          write(write6,'(i1,7x,a)') nerra,'allowed amplitude errors'
          write(write6,'(f4.2,4x,a)') .05,
     &           'lower limit P cutoff'
          write(write6,'(f4.2,4x,a)') .15,
     &           'lower limit S cutoff'
        endif
        if (minerrp.eq.99999) then    ! in this case find best solutions
          write(write6,'(a)') 
     &   '99999   exit after this many acceptable solutions...[100] '
        else
          write(write6,'(i4.4,a)') focmec_maxsol,
     &   '    exit after this many acceptable solutions...[100] '
        endif
        write(write6,'(a)') '        minimum B trend  [0] '
        write(write6,'(i3.3,a)') deldeg,'     B increment  [5] '
        write(write6,'(a)') '        maximum B trend  [355] '
        write(write6,'(a)') '        min B plunge..[0] '
        write(write6,'(i3.3,a)') deldeg,'     increment  [5] '
        write(write6,'(a)') '        maximum..[90] '
        write(write6,'(a)') '        minimum A angle..[0] '
        write(write6,'(i3.3,a)') deldeg,'     increment  [5] '
        write(write6,'(a)') '        maximum  [85] '
        call sei close( close$, write6, code ) ! Close plot file.
c
c option to edit focmec.run
c
        write(*,*) ' Do you want to edit focmec.run (y/n) ? '
        answer=' '
        read(5,'(a1)') answer 
        if (answer.eq.'y'.or.answer.eq.'Y' ) then
          text=editor(1:seiclen(editor))// ' focmec.run'
          write(*,*) text(1:seiclen(text))
          call systemc(text,seiclen(text))
        endif

c
c run focmec, lot 16.01.2002
c
        text='focmec_exe < focmec.run > focmec.log '
        write(*,*) text(1:seiclen(text))
        
        call sei close( close$, write1, code ) ! Close plot file.
        call sei close( close$, write2, code ) ! Close plot file.

        call systemc(text,seiclen(text))

        call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'focmec.lst',         ! File name to open.
     &               write1,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).
        call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'focmec.out',         ! File name to open.
     &               write2,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).

c
c copy output from fm_new.out to focmec.out
c
        call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'fm_new.out',         ! File name to open (n/a).
     &               write6,               ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).

        if(minerrp.ne.99999) goto 191
c
c find solutions with minimum polarity errors
c
        i=0
        text='x'
c read headers
        do while (text(1:23).ne.'    Dip   Strike   Rake')
          read(write6,'(a)') text
        enddo
190     continue
        read(write6,'(a)',end=191) text
c        i=i+1
c        if (i.gt.9) then 
          read(text,'(3f8.2,f11.1)') xx(1),xx(2),xx(3),xx(4)
          if (xx(4).le.float(minerrp)) then
            minerrp=int(xx(4))
          endif
c        endif
        goto 190
191     continue
        rewind(write6,iostat=code)
        write(*,*)
        write(*,*)'...Minimum number of bad fits are ',minerrp
        write(*,*)

        i=0
c skip header
        do while (text(1:23).ne.'    Dip   Strike   Rake')
c          i=i+1
          read(write6,'(a)') text
          if (text(1:23).eq.'    Dip   Strike   Rake') then
            write(*,'(a)') '    Strike       Dip     Rake Pol: P     '//
     &           'SV    SH   Rat Err  RMS RErr   RErr (All)'
            write(write2,'(a)') 
     &           '    Strike       Dip     Rake Pol: P     '//
     &           'SV    SH   Rat Err  RMS RErr   RErr (All)'
          else
            write(*,'(a)') text
            write(write2,'(a)') text
          endif
        enddo
c        if (i.eq.9) 
c        text='    Strike       Dip      Rake    '
c        write(write2,'(a)') text
c        write(*,'(a)') text
        i=0
192     continue
        read(write6,'(a)',end=193) text
        read(text,'(3f8.2,f11.1)') xx(1),xx(2),xx(3),xx(4)
        if (xx(4).le.float(minerrp)) then
           write(text(1:36),'(3f10.4,i6)') xx(2),xx(1),xx(3),int(xx(4))
        else
           text='skip'
        endif
        if (text.ne.'skip') then
          write(write2,'(a)') text
          write(*,'(a)') text
        endif
        
        goto 192
193     continue

        call sei close( close$, write6, code ) ! Close plot file.

c
c get number of new solutions
c
        rewind(write2,iostat=code)
        nsol=-1
195     continue
        read(write2,'(a)',end=196) text
        if (text(1:20).eq.'    Strike       Dip') then
          nsol = 0
        elseif (nsol.ne.-1) then
          nsol=nsol+1
        endif
        goto 195

196     continue
        write(*,*)' There are ',nsol,' acceptable solutions. '
        if (nsol.ge.100) then
            write(*,*)
     &      ' NOTE: The maximum of 100 solutions has been reached'
     &      // ' and the search is stoped ! '
        endif

        rewind(write2,iostat=code)

c        write(*,*)
c        write(*,*)'...Minimum number of bad fits are ',minbadp/2
c
c   back to main menu
c
        goto 100
c
c    Invalid option...
c    =================
c
      else
        write(*,*)
        write(*,*)'**** WARN: invalid option ...try again'
        goto 100
      endif
c
c---------------------------------------------------------------------
c   start of plotting section
c---------------------------------------------------------------------
c
 200  continue
c
c   rewind all files before continuing
c
      rewind(read1,iostat=code)
      call sei code(fort$,code,read1,b_flag)  ! Process outcome.

      rewind(write1,iostat=code)
      call sei code(fort$,code,write1,b_flag) ! Process outcome.

      rewind(write2,iostat=code)
      call sei code(fort$,code,write2,b_flag) ! Process outcome.

      rewind(write3,iostat=code)
      call sei code(fort$,code,write3,b_flag) ! Process outcome.
c
      rewind(write4,iostat=code)
      call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c
      rewind(write5,iostat=code)
      call sei code(fort$,code,write5,b_flag) ! process the outcome.
c
c--  open plot file                                                            
c
      call sei open( unknown$,             ! Open (default stop on error).
     &               ' ',                  ! No prompt.
     &               'focmec.eps',         ! File name to open.
     &               plotunit,             ! On unit.
     &               b_flag,               ! Flag exists.
     &               code )                ! Condition (n/a).
c
c   open plotting
c
      call open_display
c
c   scale tec plot to postscript
c
      write(plotunit,*,iostat=code)' 1.0 0.55 scale'
      call sei code(fort$,code,plotunit,b_flag) ! Process outcome.
c
      CALL STERMEC(answer,iwid,merge,rcircle)
      CALL STERPOL(answer,IWID,merge,rcircle,stat_plot)

c
c   Give prompt...
c
         call xset_color(color_prompt)
         if( iselect .eq. 2 ) then
         text = 'Enter Q to quit or'
         call tchars(text,seiclen(text),670.0,700.0)
         text = 'press <return> to continue or'
         call tchars(text,seiclen(text),670.0,680.0)
         text = 'move the cursor and enter P or T'
         call tchars(text,seiclen(text),670.0,660.0)
         text = 'to select your preferred solution.'
         call tchars(text,seiclen(text),670.0,640.0)
         else
         text = 'Enter Q to quit or'
         call tchars(text,seiclen(text),670.0,700.0)
         text = 'press <return> to continue.'
         call tchars(text,seiclen(text),670.0,680.0)
         end if
c
c  make sure plot is finished
c
      call tsend
c
c   get up cursor to select solution by selecting a p or t axis
c
 250  continue
      call xscursr(ichar,x,y)
      call tsend
c
c   check if P, T or Q
c
      cchar=char(ichar)
      if(cchar.eq.'p') cchar='P'
      if(cchar.eq.'t') cchar='T'
      if(cchar.eq.'q') cchar='Q'
      if(cchar.eq.'r') cchar='R'
c
      if( cchar .eq. 'Q' ) then
      call clear_to_alpha
      call close_post
      call sei close( close$, plotunit, code ) ! Close plot file.
      goto 999                                 ! Finished.
c
c replot, go back to xscursor, lot April 2003
c
      elseif ( cchar .eq. 'R' .or.  
     &         cchar .eq. '#' ) then           ! lot 01/07/2003
        goto 250

      elseif( cchar .ne. 'P'   .and.          ! Back to menu.
     &         cchar .ne. 'T' ) then
        call clear_to_alpha
        call close_post
        call sei close( close$, plotunit, code ) ! Close plot file.
          if( iselect .eq. 1 ) then             ! Do not prompt for save.
          goto 150                              !
          else                                  ! Otherwise prompt if flagged!
          goto 100                              !
          end if                                !
c
c   check if a solution has been selected, if so find it
c   by finding the minimum distance to one of the tek coordinates
c   P or T axis, stored in unit "write5", a scratch file
c
      else                                    ! Solution selected.
      rewind(write5,iostat=code)
      call sei code(fort$,code,write5,b_flag) ! process the outcome.
c
         dmin=10000.0
         do i=1,1000
            read(write5,'(a1,2f8.1)',iostat=code)xpol,xx1,yy1
            call sei code(fort$,code,write5,b_flag) ! process the outcome.
            if( b_flag ) goto 900
c
            if(cchar.eq.xpol) then
               dist=sqrt((x-xx1)**2+(y-yy1)**2)
               if(dist.lt.dmin) then
                 imin=i
                 dmin=dist
               endif
            endif
         enddo
 900     continue
         inew=1
c
c   now find corresponding fault plane solution, first calculate
c   fault plane solution number ipos
c
         ipos=imin
         if(cchar.eq.'T') ipos=ipos+1
         ipos=ipos/2
         rewind(write2,iostat=code)
         call sei code(fort$,code,write2,b_flag)   ! Process outcome.
c
c   read forward to solution, there are 6 headers
c
c         do i=1,6+ipos
c         do i=1,9+ipos   ! lot, 17.01.2002
c           read(write2,'(a)',iostat=code) chr_solution
c           call sei code(fort$,code,write2,b_flag) ! Process outcome.
c         enddo
         chr_solution = 'xxx'
         do while (chr_solution(1:29).ne.
     &        '    Strike       Dip     Rake') 
           read(write2,'(a)',iostat=code) chr_solution
           call sei code(fort$,code,write2,b_flag) ! Process outcome.
         enddo
         do i=1,ipos
           read(write2,'(a)',iostat=code) chr_solution
           call sei code(fort$,code,write2,b_flag) ! Process outcome.
         enddo
         
c
c   write solution out in scratch file for future plotting
c
c         do i=1,7
c         do i=1,10   ! lot 17.01.2002
c           write(write3,'(a)',iostat=code) chr_solution
c           call sei code(fort$,code,write3,b_flag) ! Process outcome.
c         enddo
          write(write3,'(a)',iostat=code) 
     &          '    Strike       Dip      Rake    '
          call sei code(fort$,code,write3,b_flag) ! Process outcome.
          write(write3,'(a)',iostat=code) chr_solution
          call sei code(fort$,code,write3,b_flag) ! Process outcome.
c
c   Close PostScript and go back to alpha window...
c
      call xmovabs(1.0,1.0)
      call clear_to_alpha
      call close_post
      call sei close( close$, plotunit, code ) ! Close the plot file.
c
c   back to main menu
c
      goto 100
      end if                                   !
c
c   Finished...
c   ===========
c
999   write(*,*)
      write(*,*) ' Plot file is called focmec.eps'
      write(*,*) ' Input for GMT pspolar is called pspolar.inp '
c
c    Close all files before leaving...
c    =================================
c
      call sei close(delete$,write3, code )     ! Delete scratch.
      call sei close(delete$,write4, code )     ! Delete scratch.
      call sei close(delete$,write5, code )     ! Delete scratch.
      call sei close(close$+all$, 0, code )     ! Close everything.
      stop
      end
C+
C	SUBROUTINE DPSTRK(A,N,ANGS)
C
C
C	CALCULATES DIP, STRIKE AND RAKE (ANGS) FROM A AND N
C-
	SUBROUTINE DPSTRK(A,N,ANGS)
	REAL N(3)
	DIMENSION A(3),ANGS(3)
	PI = 4.0*ATAN(1.0)
	IF (.NOT.(N(1) .EQ. 0.0 .AND.N(2) .EQ. 0.0)) THEN
	ANGS(2) = ATAN2(-N(1),N(2))
	ELSE
	ANGS(2) = 0.0
	END IF
	IF (ABS(SIN(ANGS(2))) .LT. 0.1) GO TO 100
	ANGS(1) = ATAN2(-N(1)/SIN(ANGS(2)),-N(3))
	GO TO 200
  100	ANGS(1) = ATAN2(N(2)/COS(ANGS(2)),-N(3))
  200	A1 = A(1)*COS(ANGS(2)) + A(2)*SIN(ANGS(2))
	IF (ABS(SIN(ANGS(1))) .LT. 0.1) GO TO 300
	ANGS(3) = ATAN2(-A(3)/SIN(ANGS(1)),A1)
	GO TO 400
  300	A2 = A(1)*SIN(ANGS(2)) - A(2)*COS(ANGS(2))
	ANGS(3) = ATAN2(A2/COS(ANGS(2)),A1)
400	IF (ANGS(1) .GE. 0.0) GO TO 500
		ANGS(1) = ANGS(1) + PI
		ANGS(3) = PI - ANGS(3)
		IF (ANGS(3) .GT. PI) ANGS(3) = ANGS(3) - 2*PI
  500	IF(ANGS(1).LE.0.5*PI) GO TO 600
  	ANGS(1)=PI-ANGS(1)
	ANGS(2)=ANGS(2)+PI
	ANGS(3)=-ANGS(3)
	IF (ANGS(2) .GE. 2*PI) ANGS(2) = ANGS(2) - 2*PI
600	IF (ANGS(2) .LT. 0.0) ANGS(2) = ANGS(2) + 2.0*PI
	RETURN
	END
c
c******************SUBROUTINE INVERT*********************
c
      subroutine invert(mat)
c
c  inverts a 3x3 matrix
c  written by S.Ihnen, November 1980
c
      double precision mat(3,3),xmat(3,3)
      double precision a,b,c,det
c
c  define elements of determinant
c
      a=mat(1,1)*(mat(2,2)*mat(3,3)-mat(2,3)*mat(3,2))
      b=mat(1,2)*(mat(2,1)*mat(3,3)-mat(3,1)*mat(2,3))
      c=mat(1,3)*(mat(2,1)*mat(3,2)-mat(3,1)*mat(2,2))
      det=a-b+c
c
c  construct matrix of cofactors of original matrix
c
      xmat(1,1)=mat(2,2)*mat(3,3)-mat(3,2)*mat(2,3)
      xmat(1,2)=-mat(2,1)*mat(3,3)+mat(3,1)*mat(2,3)
      xmat(1,3)=mat(2,1)*mat(3,2)-mat(2,2)*mat(3,1)
      xmat(2,1)=-mat(1,2)*mat(3,3)+mat(3,2)*mat(1,3)
      xmat(2,2)=-mat(3,1)*mat(1,3)+mat(3,3)*mat(1,1)
      xmat(2,3)=-mat(1,1)*mat(3,2)+mat(3,1)*mat(1,2)
      xmat(3,1)=mat(1,2)*mat(2,3)-mat(1,3)*mat(2,2)
      xmat(3,2)=-mat(1,1)*MAT(2,3)+mat(2,1)*mat(1,3)
      xmat(3,3)=mat(1,1)*mat(2,2)-mat(2,1)*mat(1,2)
c
c  inverse of original matrix is just the transpose of
c  the adfoint matrix divided by the dterminant of the
c  original matrix
c
      do 100 i=1,3
      do 99 j=1,3
      mat(i,j)=xmat(j,i)/det
99     continue
100    continue
      return
      end

       SUBROUTINE STERMEC(device,iwid,merge,rcircle)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     Program to draw the sterographic projection,  for focal mechan.
C     for a number of different solutions.
C
C     R. Arvidsson. 1990-04-27
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c      IMPLICIT INTEGER*2 (V,j-n)
C ---
        include 'seiplot.inc'
c
c    Libsei details...
c    =================
c
      include 'libsei.inc'                 ! Library definitions & data defns.
      external sei code                    ! Error condition handler.
      integer  code                        ! Condition.
      logical  b_flag                      ! Flag!!
c
      integer  read1,                      ! Read unit1.
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write3,                     ! & 3.
     &         write4,                     ! & 4.
     &         write5                      ! & 5.
      common /foc_unit$ /
     &         read1,                      ! Read unit1.
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write3,                     ! & 3.
     &         write4,                     ! & 4.
     &         write5                      ! & 5.
c
c    End of list...
c    ==============
c
      real IX, IY, R, IX3(4), x(1000),
     1          IDEVH,  IN1, IN2,
     2          XBTP(2), IXBTP, IYBTP, ixb(4), iwid
C ---
      CHARACTER WHET(4)*1,
     1          DUMMY*80, CBTP(3)*1, device*1
C ---
c      REAL ANBTP(6), ANGS(3), ANGS2(3), PTTP(4), DIP(200), STRIKE(200),
c     1     RAKE(200),  rcircle
      REAL ANBTP(6),ANGS(3),ANGS2(3),PTTP(4),DIP(1000),STRIKE(1000),
     1     RAKE(1000),rcircle
      REAL*8 xo, yo, xp, yp, fi, delta, ox, alfa, az, ax, btp(2),
     1       zo, alfa2, fi2
C ---
      REAL*4 MOMTEN(6)
      LOGICAL AN, PT, RIGHT, MT
      logical   merge
C ---
c      common /profil/ merge, rcircle
C ---
      DATA WHET /'N','S','E','W'/
      DATA CBTP /'B','T','P'/
      DATA ZERO/0/,ONE/1/
c
c    Initialise...
c    =============
c
      code = e_ok$                        ! Local condition.
c
C ---
      PI = 4.*atan(1.)
C ---
      RIGHT=.TRUE.
c
      call xset_color(color_frame)
C -------Draw circle
      IX = 500
      IY = 350
      IX3(1)=IX
      IX3(2)=IY
      if (rcircle .lt. 0.0001 ) then
	     R =  150
      else
	     r= rcircle
      endif
      IN1= 20
      IN2 = IY + RCIRCLE*1.6
      CALL FCIRCL(R, IX,IY)
C --- Circle for B,P and T axes
      if ( merge ) then
         ixbtp = ix
         iybtp = iy
      else
         ixbtp = IX +2.25*RCIRCLE
         iybtp = iy
      endif
cjens      CALL FCIRCL(R,IXBTP,IYBTP)
C --- Label the circle
      IX3(1)= IX
      IX3(2)= IY + R + 15
      call xchars(whet(1),1,ix3(1),ix3(2))
c      ISTAT = VGTEXT(IDEVH,IX3(1),IX3(2),WHET(1))
      IX3(2)= IY + R
      IX3(3)= IX3(1)
      IX3(4)= IX3(2) - 5
      call xmovabs(ix3(1),ix3(2))
      call xdrwabs(ix3(3),ix3(4))
c      ISTAT = VPLINE(IDEVH,2,IX3)
      IX3(2)= IY - R
      IX3(4)= IX3(2) + 5
      call xmovabs(ix3(1),ix3(2))
      call xdrwabs(ix3(3),ix3(4))
c      ISTAT = VPLINE(IDEVH,2,IX3)
C --- Label the circle for P, T and B axis
      IXB(1)= IXBTP
      IXB(2)= IYBTP + R + 15
      call xchars(whet(1),1,ixb(1),ixb(2))
c      ISTAT = VGTEXT(IDEVH,IXB(1),IXB(2),WHET(1))
      IXB(2)= IXB(2) - 15
      IXB(3)= IXB(1)
      IXB(4)= IXB(2) - 5
      call xmovabs(ixb(1),ixb(2))
      call xdrwabs(ixb(3),ixb(4))
c      ISTAT = VPLINE(IDEVH,2,IXB)
      IXB(2)= IYBTP - R
      IXB(4)= IXB(2) + 5
      call xmovabs(ixb(1),ixb(2))
      call xdrwabs(ixb(3),ixb(4))
c      ISTAT = VPLINE(IDEVH,2,IXB)
C ------ Read input data
C ------------------------
cjens       open(unit=3,file='test')
       ICOUNT=1
C ----------------------------------------------
c     do 20 k = 1, 6
c
c read headers
c
      DUMMY = ' xxx '
      do while (DUMMY(1:29).ne.
     &    '    Strike       Dip     Rake') 
          read(write4,'(A)',iostat=code) DUMMY
          call sei code(fort$,code,write4,b_flag) ! Process the outcome.
      enddo
c 20      continue

C ----------------------------------------------
10     READ(write4,112,iostat=code) strike(icount),DIP(icount),
     1                  RAKE(icount)

c10         READ(write4,112,iostat=code) dip(icount),strike(icount),   ! lot 16.01.2002
c     &                  RAKE(icount)
           call sei code( warn$, code, write4, b_flag )
           if( b_flag .or. code .ne. e_ok$ ) goto 99
           ANGS(1)=DIP(ICOUNT)
           ANGS(2)=STRIKE(ICOUNT)
           ANGS(3)=RAKE(ICOUNT)
C ------- Calculate auxiliary planes
           mt=.false.
           CALL FMREPS(ANBTP,ANGS,PTTP,ANGS2,AN,PT,RIGHT,MT,MOMTEN,
     &        0,0)
           DIP(ICOUNT+1)=ANGS2(1)
           STRIKE(ICOUNT+1)=ANGS2(2)
           RAKE(ICOUNT+1)=ANGS2(3)
C ------- Plot B,T and B axes
c ------- First set graphics text alignment, .i.e. center the symbol
c           istat=vstaln(one,one)
              do 30 jj = 2, 3
                 if ( jj .eq. 1 ) then
C --------- B axis --------------------------------------------------------
C                    btp(1)=anbtp(5)
C                    btp(2)=anbtp(6) 
                 elseif ( jj .eq. 2 ) then
C --------- T axis
                    btp(1)=pttp(3)
                    btp(2)=pttp(4)
                 elseif ( jj .eq. 3 ) then
C --------- P axis
                    btp(1)=pttp(1)
                    btp(2)=pttp(2)
                 endif
C -------- plunge -----------------------------------------------------                 
                 btp(2)= btp(2)*pi/180
C -------  trend
                 az    = btp(1)*pi/180.0

C ------- calculate sterographic projection of a line
                 ax= r*dtan(pi/4.0- btp(2)/2.0)
                 xbtp(1) = ax*dsin(az) + ixbtp
                 xbtp(2) = ax*dcos(az) + iybtp
                 if(cbtp(jj).eq.'P') call xset_color(color_foc_p)
                 if(cbtp(jj).eq.'T') call xset_color(color_foc_t)
                 call xchars(cbtp(jj),1,xbtp(1),xbtp(2))
c                 if(cbtp(jj).eq.'P') then
                   write(write5,'(a1,2f8.1)',iostat=code)
     &                   cbtp(jj),xbtp(1),xbtp(2)
                  call sei code(fort$,code,write5,b_flag) ! process the outcome.
c                 endif
c    	         istat = vgtext(idevh,xbtp(1),xbtp(2),cbtp(jj))
30         continue
c ------ reset graphics text alignment
c           istat=vstaln(zero,zero)
C ---
           icount=icount+2
           GOTO 10
C ---------------------------------------------------------------------
99       CONTINUE
         icount=icount-1
         call xset_color(color_foc_plane)
C ------- Plot mechanism
       do 1000 j = 1 , icount
         delta  = dip(j)*pi/180.
         fi = strike(j)*pi/180.
         ii=1
         do 100 i = 1, 181
           alfa=(i-1)*pi/180. -pi/2.

C ------- calculate sterographic projection of plane
c            fi2=pi/2- acos( cos(alfa)*cos(pi/2-fi) )
C ------- coordinate transformation to the x,y,z (E,N,Z) coordinates.
C ------- The xp, yp are the coordinates in the plane of the fault.
C ------- xp direction of dip and yp direction of strike.
            xp=dcos(alfa)
            yp=dsin(alfa)
            zo=xp*dsin(delta)
            xo=( yp*(dsin(fi)) + xp*(dcos(delta)*dcos(fi)) )
            yo=( yp*(dcos(fi)) - xp*(dcos(delta)*dsin(fi)) )
            fi2 = datan(zo/dsqrt(xo*xo + yo*yo))
            if ( xo .gt. 0 .and. yo .gt. 0 ) then
               alfa2 = datan(xo/yo)
            elseif ( xo .gt. 0 .and. yo .lt. 0 ) then
               alfa2 = datan(dabs(yo)/dabs(xo)) + pi/2.
            elseif ( xo .lt. 0 .and. yo .lt. 0 ) then
               alfa2 = datan(dabs(xo)/dabs(yo)) + pi
            elseif ( xo .lt. 0 .and. yo .gt. 0 ) then
               alfa2 = datan(dabs(yo)/dabs(xo)) + 3.*pi/2. 
            endif
            ox=dtan(pi/4.-fi2/2.)
            xo= real(ix) + real(r)*ox*dsin(alfa2)
            yo= real(iy) + real(r)*ox*dcos(alfa2)
            x(ii)   = xo
            x(ii+1) = yo
c ------------- Plot focal mechanism
            if (i .eq. 1) then
               call xmovabs(x(ii),x(ii+1))
            else
               call xdrwabs(x(ii),x(ii+1))
            endif
            ii=ii+2
100      continue
c
c  make a stroke
c
          call xout(10.0,10.0)
C ------  Plot focal mechanism
c         ISTAT=VPLINE(IDEVH,180,X)
1000  continue
112   FORMAT(f10.4,f10.4,f10.4)
c 112   FORMAT(f8.2,f8.2,f8.2)   ! lot 16.01.2002
       call xset_color(color_def)
      RETURN
      END
C-----------------------------------------------------------------
      subroutine sterpol(device,iwid,merge,rcircle,stat_plot)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C Plots polarities on the focal sphere, lower hemisphere projection
C
C R.N.Arvidsson, 1990-05-09
Ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      IMPLICIT INTEGER*2 (V,J-N)
C ---
      include 'seidim.inc'
      include 'seiplot.inc'
c
c    Libsei details...
c    =================
c
      include 'libsei.inc'                 ! Library definitions & data defns.
      external sei code                    ! Error condition handler.
      integer  code                        ! Condition.
      logical  b_flag                      ! Flag!!
c
      integer  read1,                      ! Read unit1.
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write3,                     ! & 3.
     &         write4,                     ! & 4.
     &         write5                      ! & 5.
      common /foc_unit$ /
     &         read1,                      ! Read unit1.
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write3,                     ! & 3.
     &         write4,                     ! & 4.
     &         write5                      ! & 5.
c
c    End of list...
c    ==============
c
      real IX, IY, R, IX3(4), x(2), 
     1          ISTAT, IDEVH, IBC, ISTEX, ISTEY, YE(8), IN1, IN2, 
     2          lx(4), lc(30), iwid, one
C ---
      CHARACTER STA(max_data)*5, INPUT*40, TEXT*3, HEADER*60, WHET(4)*1,
     1          POL(max_data)*1, device*1, type*1,exp*1
      integer nhead,nrecord,nphas,nstat
      character*80 data(max_data),txt
C ---
      REAL*8 ax, ANGLE(max_data), AZ(max_data), PI, SP(max_data)
      real sangle(max_data),saz(max_data)
      character*5 stat(max_data)
      logical stat_plot
C ---
      real   rcircle
c ---
      LOGICAL DSR, merge
      real xsta1,xsta2,ysta1,ysta2,ysta3,ysta4
C ---
      COMMON /BLCK7/ ISTAT, IDEVH, IBC, ISTEY, ISTEX, YE
c      common /profil/ merge, rcircle
c ---
      DATA WHET /'N','S','E','W'/
c
c    Initialise...
c    =============
c
      code = e_ok$                        ! Local condition.
c
C --- 
      PI = 4.*atan(1.)
      call xset_color(color_frame)
c
c  initialize for station code plottong around mechanism
c
      xsta1=75.0
      xsta2=930.0
      ysta1=670.0
      ysta2=10.0
      ysta3=650.0
      ysta4=10.0

C -------Draw circle
      if ( merge ) then
        IX = 500.0
        IY = 350.0
      else
        ix = 100 + 4.5*RCIRCLE
        IY = 200
      endif
      IX3(1)=IX
      IX3(2)=IY
      if ( rcircle .gt. 0.001 ) then
         r=rcircle
      else
         R =  150
      endif
C --- Label the circle
      IX3(1)= IX
      IX3(2)= IY + R + 15
      call xchars(whet(1),1,ix3(1),ix3(2))
      IX3(2)= IX3(2) - 15
      IX3(3)= IX3(1)
      IX3(4)= IX3(2) - 5
      call xmovabs(ix3(1),ix3(4))
      call xdrwabs(ix3(3),ix3(4))
      IX3(2)= IY - R
      IX3(4)= IX3(2) + 5
      call xmovabs(ix3(1),ix3(4))
      call xdrwabs(ix3(3),ix3(4))
c
c plot polarity legend
c
c      txt='COMPRESSION'
c      call draw_circle(650.,756.,6.)
c      call xchars(txt,11,670.,750.)
c      txt='EMERGENT COMPR.'
c      call draw_plus(800.,756.,6.)
c      call xchars(txt,15,820.,750.)
c      txt='DILATATION'
c      call draw_triangle(650.,736.,6.)
c      call xchars(txt,10,670.,730.)
c      txt='EMERGENT DILAT.'
c      call draw_minus(800.,736.,6.)
c      call xchars(txt,15,820.,730.)
      
C ------------------------
C   read input event data
c
         call indata(read1,nstat,nphas,nhead,nrecord,
     &               type,exp,data,id)
c
c   plot header
c
         call xset_color(color_title)
         call xchars(data(1),79,0.0,760.0)
c
c   plot solution
c
         rewind(write4,iostat=code)
         call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c
         do i=1,20
           read(write4,'(a)',end=3939) txt
c           if(i.ge.7) call xchars(txt,79,0.0,740.0-(i-7)*20)
           if(i.ge.10) call xchars(txt,79,0.0,740.0-(i-7)*20)
         enddo
 3939    continue
         rewind(write4,iostat=code)
         call sei code(fort$,code,write4,b_flag) ! Process the outcome.
c
c   get polarities etc
c
         CALL GETPOL(NHEAD,NRECORD,DATA,ICOUNT,POL,SANGLE,SAZ,stat)
         do i=1,icount
           angle(i)=sangle(i)
           az(i)=saz(i)
         enddo
		 call tsend

C ------- Plot mechanism
         do 100 i = 1, icount
           if ( angle(i) .gt. 90.0 ) then
                angle(i) = 180.0 - angle(i)
                az(i)    = 180.0 + az(i)
           endif
           angle(i) = pi/2.0 - angle(i)*pi/180.0
           az(i)    = az(i)*pi/180.0

C ------- calculate sterographic projection of plane
            ax= r*dtan(pi/4.0-angle(i)/2.0)
            x(1) = ax*dsin(az(i)) + ix
            x(2) = ax*dcos(az(i)) + iy
c
c   plot station code is selected
c
            if(stat_plot) then
                call xset_color(color_frame)
c               call xchars(stat(i),4,x(1)-30.0,x(2)-20.0)
               call xmovabs(x(1),x(2))
c
c   select where line go to for station code
c
               if(x(1).lt.500.0.and.x(2).gt.350.0.and.ysta1.gt.0.0) 
     *            then
                  call xdrwabs(xsta1,ysta1+7.0)
                  call xchars(stat(i),5,xsta1-40.0,ysta1)
                  call xchars(pol(i),1,xsta1-70.0,ysta1)
                  ysta1=ysta1-20.0
               endif
               if(x(1).lt.500.0.and.x(2).le.350.0.and.ysta1.lt.750.0)
     *         then
                  call xdrwabs(xsta1,ysta2+7.0)
                  call xchars(stat(i),5,xsta1-40.0,ysta2)
                  call xchars(pol(i),1,xsta1-70.0,ysta2)
                  ysta2=ysta2+20.0
               endif
               if(x(1).ge.500.0.and.x(2).gt.350.0.and.ysta3.gt.0.0) 
     *            then
                  call xdrwabs(xsta2,ysta3+7.0)
                  call xchars(stat(i),5,xsta2,ysta3)
                  call xchars(pol(i),1,xsta2+65.0,ysta3)
                  ysta3=ysta3-20.0
               endif
               if(x(1).ge.500.0.and.x(2).le.350.0.and.ysta4.lt.750.0) 
     *            then
                 call xdrwabs(xsta2,ysta4+7.0)
                  call xchars(stat(i),5,xsta2,ysta4)
                  call xchars(pol(i),1,xsta2+65.0,ysta4)
                  ysta4=ysta4+20.0
               endif
            endif
            if ( pol(i) .eq. '+' ) then
                call xset_color(color_foc_comp)   ! lot 21.01.2002
                call draw_plus(x(1),x(2),6.0)
c                call draw_circle(x(1),x(2),3.5)
            elseif ( pol(i) .eq. 'C' ) then
                call xset_color(color_foc_comp)
                call draw_circle(x(1),x(2),6.0)
            elseif ( pol(i) .eq. '-' ) then
                call xset_color(color_foc_comp)
                call draw_minus(x(1),x(2),6.)   ! lot 21.02.2002
            elseif ( pol(i) .eq. 'D' ) then
                call xset_color(color_foc_dilat)
                call draw_triangle(x(1),x(2),6.)   ! lot 16.01.2002
            elseif ( pol(i) .eq. 'V' ) then
               call xchars('V',1,x(1),x(2))
            elseif ( pol(i) .eq. 'S' ) then
               call xchars('S',1,x(1),x(2))
            elseif ( pol(i) .eq. 'H' ) then
               call xchars('H',1,x(1),x(2))
            endif           
100      continue
1000  continue
      call xset_color(color_def)
C ---
111   FORMAT(A)
112   FORMAT(a4,f4.0,f8.0,4x,a1,f7.0)
      RETURN
      END
c------------------------------------------------------------------
      subroutine getpol(nhead,nrecord,data,npol,pol,ain,az,stat)
c
c   get polarity data, jh, sep 92
c
c    input nhead,nrecord,data, see indata routine
c    output npol : number of polarity data
c           ain  : angle of incidence
c           az   : azimuths
c           stat : stations
c
       implicit none
      integer nhead,nrecord
      character*80 data(*)
      character*5 stat(*)
      character*1 pol(*),sense
      integer npol
        real ain(*),az(*)
c--reading same as integers
        integer iain,iaz
c--counter 
        integer i
c
c
      npol=0
      do i=nhead+1,nrecord-1
c         if((data(i)(17:17).eq.'D'.or.data(i)(17:17).eq.'C'.or.
c     *       data(i)(17:17).eq.'-'.or.data(i)(17:17).eq.'+').
c     *       and.data(i)(11:11).eq.'P') then
      call get_sense(data(i),sense,0)
      if (sense.ne.' ') then
            if(data(i)(58:60).ne.'   '.and.data(i)(77:79).ne.'   ') 
     *      then
               npol=npol+1
c               pol(npol)=data(i)(17:17)
               pol(npol)=sense   ! lot 21.01.2002
               read(data(i)(58:60),'(i3)') iain
               ain(npol)=iain
               read(data(i)(77:79),'(i3)') iaz
               az(npol)=iaz
               stat(npol)=data(i)(2:6)
            endif
         endif
      enddo
c
      return
      end
c---------------------------------------------------------


      subroutine get_sense(text,sense,option)
c
c return sense as defined in original version of focmec
c Lars Ottemoller, 21.01.2002
c
      implicit none
      character*80 text    ! phase line
      character*1 sense    ! output sense
      integer option       ! 0: use E or I     (used for plotting)
                           ! 1: ignore E or I  (used for computation)

      sense=' '
c compression
      if (text(17:17).eq.'C'.or.text(17:17).eq.'U') then
        if (text(11:11).eq.'P') then
          if (text(10:10).eq.'I'.or.
     &        text(10:10).eq.' '.or.
     &        option.eq.1) then
            sense='C'
          elseif (text(10:10).eq.'E') then
             sense='+'
          endif
        endif   ! P
           
c dilatation
      elseif (text(17:17).eq.'D') then
        if (text(11:11).eq.'P') then
          if (text(10:10).eq.'I'.or.
     &         text(10:10).eq.' '.or.
     &         option.eq.1) then
             sense='D'
          elseif (text(10:10).eq.'E') then
             sense='-'
          endif
        endif   ! P
      elseif (text(17:17).eq.'V') then
        sense='V'
      elseif (text(17:17).eq.'S') then
        sense='S'
      elseif (text(17:17).eq.'H') then
        sense='H'
      endif
      return
      end

c-----------------------------------------------------------------
      SUBROUTINE FCIRCL(R,X,Y)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  INPUT R - RADIUS
C        X - CENTER OF CIRCLE
C        Y - CENTER OF CIRCLE
C PURPOSE PLOTS A FILLED CIRCLE 
C
C R.N. Arvidsson 1990-05-04
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c      implicit integer*2 (v,j-n)
      real  r, x, y, pi
      real ix(722), istat, idevh, ibc, istey, istex, ye(8)
      COMMON /BLCK7/ ISTAT, IDEVH, IBC, ISTEY, ISTEX, YE
      pi = 4.d0*asin(1.d0/(sqrt(2.d0)))
      ii=1
      do 100 i = 1, 361
c        ix(ii)  = x + r*dcos(i*pi/180.)
         ix(ii)  = x + r*cos(i*pi/180.)
c        ix(ii+1)= y + r*dsin(i*pi/180.)
         ix(ii+1)= y + r*sin(i*pi/180.)
c ---------- Plot circe
         if (ii .eq. 1) then
            call xmovabs(ix(ii),ix(ii+1))
         else
            call xdrwabs(ix(ii),ix(ii+1))
         endif
         ii=ii+2
100   continue
      return
      end

      subroutine draw_circle(x,y,r)
c
c  draws and open circle
c
      call xmovabs(x,y)
      call xdrwabs(x,y+r)
      call xmovabs(x+r,y)
	  k=12
	  z=6.28/k
      do i=1,k
         x1=r*cos(i*z)+x
         y1=r*sin(i*z)+y
         call xdrwabs(x1,y1)
      enddo
      return
      end

      subroutine closed_circle(x,y,r)
      ir=r
      call xmovabs(x,y)
      call xdrwabs(x,y)
      do i=2,ir
        call draw_circle(x,y,float(i))
      enddo
      return
      end

      subroutine draw_triangle(x,y,r)
c
c draw triangle inside circle of radius r
c lot 16.01.2002
c
      implicit none
      real x,y,r
      call xmovabs(x,y)
      call xdrwabs(x,y+r)
      call xdrwabs(x-r*sin(3.14/3.),y-r*cos(3.14/3.))
      call xdrwabs(x+r*sin(3.14/3.),y-r*cos(3.14/3.))
      call xdrwabs(x,y+r)

      return
      end

      subroutine draw_square(x,y,r)
c
c draw triangle inside circle of radius r
c lot 16.01.2002
c
      implicit none
      real x,y,r,a
      a=r*cos(45./180.*3.14)
      call xmovabs(x-a,y+a)
      call xdrwabs(x-a,y-a)
      call xdrwabs(x+a,y-a)
      call xdrwabs(x+a,y+a)
      call xdrwabs(x-a,y+a)

      return
      end

      subroutine draw_plus(x,y,r)
c
c draw plus inside circle of radius r
c lot 16.01.2002
c
      implicit none
      real x,y,r,a
c the plus
      call xmovabs(x,y+r)
      call xdrwabs(x,y-r)
      call xmovabs(x-r,y)
      call xdrwabs(x+r,y)

c square around it
c      call draw_square(x,y,r/cos(45./180.*3.14))

      return
      end

      subroutine draw_minus(x,y,r)
c
c draw minus inside circle of radius r
c lot 16.01.2002
c
      implicit none
      real x,y,r,a
      call xmovabs(x-r,y)
      call xdrwabs(x+r,y)
c square around it
c      call draw_square(x,y,r/cos(45./180.*3.14))

      return
      end




      subroutine foc_prepare(npol,nratio,vpvs)
c
c  routine reads the hyp print.out and hyp.out files and make an
c  input file to focmec called focmec.inp having the same content
c  as the hyp.out except that angles of incidence are now
c  written in column under signal to noise ratio. If more than 
c  one event is present, it is assumed that all should be used in a 
c  composite fault plane solution and only header lines for the first
c  event is used.
C
C
C   J. HAVSKOV, october 1992 
C
C
C   LATEST UPDATE:
c nov 93   lates bl routine
c sep 94   multiple events for composite fault plane solutions
c
COMPUTERTYPE
       IMPLICIT NONE
c
c    Libsei details...
c    =================
c
      include 'libsei.inc'                 ! Library definitions & data defns.
	  include 'seidim.inc'
      external sei code,                   ! Error condition handler.
     &         sei open,                   ! Open file handler.
     &         sei close                   ! Close file handler.
      integer  code                        ! Condition.
      logical  b_flag                      ! Flag!!
c
      integer  read1,                      ! Read unit1
     &         read2,                      ! Ditto 2
     &         write1,                     ! Write unit1
     &         write2,                     ! Write unit2
     &         write3                      ! Write unit3
c
c    End of list...
c    ==============
c
c--data array for one event
      CHARACTER*80 DATA(max_data)		
      character*80 text
C  NUMBER OF DIFFERENT STATIONS IN DATA
      INTEGER NSTAT			
C  NUMBER OF HEADERS AND RECORDS IN DATA
      INTEGER NHEAD,NRECORD		
C  ANGLE OF INCIDENCE AND AZIMUTH
      REAL ANGINC,AZ
      integer iang
C  NUMBER OF DIFFERENT PHASE FOR EVENT
      INTEGER NPHASE			
      INTEGER I,id,k,iprint,c,ind
      integer nevent  ! number of events			
c  NUMBER OF POLARITIES AND NUMBER OF AMPLITUDE RATIOS
      integer*2 npol,nratio
c number of amplitude readings
      integer namp
c amplitude
      real amp
c station codes for amp readings
      character*5 amp_stat(max_data)
c amplitude readings: 1:P on Z, 2: P on R, 3: SV on Z, 4: SV on R, 5: SH on T
      real amp_raw(max_data,5)
c corrected ratios, 1: SV/P, 2: SH/P, 3: SV/SH
      real corrected_ratio(max_data,3)
c amplitude distance and azimuth
      real amp_dist(max_data),amp_az(max_data)
c---event type etc
      character*1 type,exp
c-- sense - one-character key for polarity, C=cpompression,D=Dilatation,+=emergent C,- = eme.dil.
      character*1 sense
c-- one line in print file
      character*80 oneline(max_data+100)         	
c velocity model
      integer max_layer
      parameter (max_layer=200)
      real vdepth(max_layer),vp(max_layer),vs(max_layer)
      integer imoho,nlayer
      real vpvs
c distance and depth
      real dist,depth
c angle of emergance at station
      real aemrgp,aemrgs
c phase name
      character*3 phasenm
c free surface correction
      real correction
c amp ratio
      real ratio
c ratio name
      character*11 ratio_name
c flag 
      logical new
      real xx



c
c    Initialise...
c    =============
c
      code = e_ok$                        ! Local condition.
      nevent=0
      nlayer=0
      npol=0
      nratio=0
      namp=0
      amp_stat(1)=' '
c
c   open print file
c
      call sei open( old$,                ! Open (stop on error).
     &               ' ',                 ! No prompt.
     &               'print.out',         ! This file.
     &               read1,               ! On this unit.
     &               b_flag,              ! Exists?!! (n/a).
     &               code )               ! Returned condition.
c
c   open hyp.out file
c
      call sei open( old$,                ! Open (stop on error).
     &               ' ',                 ! No prompt.
     &               'hyp.out',           ! This file.
     &               read2,               ! On this unit.
     &               b_flag,              ! Exists?!! (n/a).
     &               code )               ! Returned condition.
c
c   open output file
c
      call sei open( unknown$,            ! Open (stop on error).
     &               ' ',                 ! No prompt.
     &               'focmec.inp',        ! This file.
     &               write1,              ! On this unit.
     &               b_flag,              ! Exists?!! (n/a).
     &               code )               ! Returned condition.
      call sei open( unknown$,            ! Open (stop on error).
     &               ' ',                 ! No prompt.
     &               'pspolar.inp',        ! This file.
     &               write2,              ! On this unit.
     &               b_flag,              ! Exists?!! (n/a).
     &               code )               ! Returned condition.
      call sei open( unknown$,            ! Open (stop on error).
     &               ' ',                 ! No prompt.
     &               'focmec.dat',        ! This file.
     &               write3,              ! On this unit.
     &               b_flag,              ! Exists?!! (n/a).
     &               code )               ! Returned condition.
c
c   here starts loop to read hyp.out and print.out
c
1     call INDATA(read2,nstat,nphase,NHEAD,
     &            NRECORD,TYPE,EXP,DATA,id)
c
c   check for end of file
c
      if(nrecord.eq.0) goto 99
      nevent=nevent+1
c
c  read forward to station lines in print file
c
22    read(read1,'(a80)',iostat=code) oneline(1)
c      write(6,*) oneline(1)
      call sei code(fort$,code,read1,b_flag) ! Process the outcome.
         if( b_flag ) then
3423       continue             ! Premature end of file.
           write(6,*)
     *    ' No stations in file or no location,',
     *    ' only old solutions can be ploted'
           write(6,*)' or'
           write(6,*)' Focmec operated outside EEV and hyp.out and'
           write(6,*)' print.out do not correspond, relocate with HYP'
           write(6,*)' and run focmec again'
           write(6,*)' Continue (y/n) ? '
           read(5,'(a)')text 
           if(text(1:1).eq.'y'.or.text(1:1).eq.'Y') then
             data(1)(72:72)='.'   ! indicate only fp
             write(write1,'(a80)',iostat=code) (data(i),i=1,nhead)
             goto 3
           endif
         call sei close(delete$,write1,code) ! Delete output file.
         call sei close(close$,read2, code)  ! Close inputdata.
         call sei close(close$,read1, code)  ! Ditto print.out.
c
c        write(*,*)
c    &'****                                                ****'
c        write(*,*)
c    &'**** WARN: "hyp.out" contains non-locatable events  ****'
c        write(*,*)
c    &'****       which do not appear in "print.out".      ****'
c        write(*,*)
c    &'****       ...Re-locate locatable events with "HYP" ****'
c        write(*,*)
c    &'****       before using "FOCMEC"    ... Aborting... ****'
c
c        chr_err_msg$ =                      ! Use this output for message.
c    &'****                                                ****'
c        call sei code( stop$,               ! When stopping program
c    &                  e_init$,             ! With bad initialisation.
c    &                  0,                   ! Unit (n/a).
c    &                  b_flag )             ! Flag (n/a).
c
         goto 9999                           ! Return to caller.
         end if                              !
c
c read vp/vs ratio, lot jan 2002
c
      if(oneline(1)(23:29).eq.'Vp/Vs =') then
        read(oneline(1)(31:35),'(f5.2)') vpvs
      endif

c
c read model, lot jan 2002
c
      if(oneline(1)(1:32).eq.' Depth, km   Vp, km/s   Vs, km/s'.and.
     &    nlayer.eq.0) then
        do while (oneline(1).ne.' ')
          nlayer=nlayer+1
          read(read1,'(a80)',end=3423) oneline(1)
          read(oneline(1)(1:32),'(f10.2,1x,f10.2,1x,f10.2)')
     &       vdepth(nlayer),vp(nlayer),vs(nlayer)
          if(oneline(1)(36:36).eq.'N')imoho=nlayer
        enddo
        nlayer=nlayer-1
c        do i=1,nlayer
c          write(*,*) i,vdepth(i),vp(i),vs(i)
c        enddo
      endif

      if(oneline(1)(2:4).eq.'stn') go to 3
      go to 22     
c
c  station line found
c
 3    continue
c
c  read print file for one event
c
      iprint=1
4     read(read1,'(a80)',iostat=code) oneline(iprint)
      call sei code(fort$,code,read1,b_flag )! Process the outcome.
      if( b_flag ) goto 99                   ! End of file.
c
c   check for end of phases for one event
c	  
      if(oneline(iprint)(1:13).eq.'          ') go to 80
      iprint=iprint+1
      goto 4 
c
c   event read
c
80    iprint=iprint-1
c
c  find print line for all data lines with a polartity
c
      read(data(1)(39:43),'(f5.1)') depth
      do i=nhead+1,nrecord-1
c
c   clear out apparent velocity column
c
         data(i)(57:60)='    '
         if((data(i)(17:17).eq.'D'.or.data(i)(17:17).eq.'C'.or.
     *      data(i)(17:17).eq.'-'.or.data(i)(17:17).eq.'+').
     *      and.data(i)(11:11).eq.'P') then

c
c   find station in print file
c
            do k=1,iprint
c	  
c   check if station 
c
c               if(oneline(k)(1:4).eq.data(i)(2:5)) then  
                 if(oneline(k)(2:6).eq.data(i)(2:6)) then  
c
c   check if normal phase line or az line, and correct phase
c
                   if(oneline(k)(26:27).ne.'AZ'.and.
c                  if(oneline(k)(27:28).ne.'AZ'.and.
     *                oneline(k)(19:24).ne.'      '.and.
     *                data(i)(11:14).eq.oneline(k)(26:29)) then
c    *                data(i)(11:14).eq.oneline(k)(27:31)) then
                       READ(oneline(k),101) anginc
c01                    FORMAT(18x,f6.1)
101                    FORMAT(17x,f6.1)
                      read(data(i)(71:75),'(f5.0)') amp_dist(1)
c
c call get_ang_emrg to check what is in print.out, lot Feb 4, 2002
c
                      phasenm=oneline(k)(34:36)
                     
                      if (data(1)(22:22).eq.'L') then
                         call get_ang_emrg(depth,amp_dist(1),
     &                     nlayer,vp,vs,vdepth,imoho,
     &                     phasenm,aemrgp,xx)
                         if (anginc.gt.xx+.5.or.
     &                       anginc.lt.xx-.5) then

            write(*,*) ' WARNING: angle of incidance may be wrong '
            write(*,*) oneline(k)
            write(*,*) '          is ',anginc,' should be ',xx     
                         endif
                      endif

                       iang=anginc+0.5
                       WRITE(DATA(I)(58:60),'(I3)')iang
c
c write calculated phase
c
                       data(i)(11:13)=oneline(k)(34:36)
c
c write gmt pspolar input
c
                       write(write2,'(a5,1x,a3,1x,i3,1x,a1)') 
     &                        data(i)(2:6),data(i)(77:79),
     &                        iang,data(i)(17:17)
                       goto 70
                    endif 
                 endif
              enddo
 70        continue
           endif
      enddo
c
c
c   end of one event
c
      if(nevent.eq.1) then                    ! write headers for first event
          write(write1,'(a80)',iostat=code) (data(i),i=1,nhead)
          write(write3,'(a80)',iostat=code) data(1)(2:79) ! lot 16.01.2002
      endif
      call sei code(fort$,code,write1,b_flag) ! Process outcome.

c
c read depth, lot Jan 2002
c
      read(data(1)(39:43),'(f5.1)') depth
      
      do i=nhead+1,nrecord-1
c         if((data(i)(17:17).eq.'D'.or.data(i)(17:17).eq.'C'.or.
c     *      data(i)(17:17).eq.'-'.or.data(i)(17:17).eq.'+').
c     *      and.data(i)(11:11).eq.'P') then  ! only write polarities

         call get_sense(data(i),sense,1)
         if (sense.ne.' ') then
               write(write1,'(a80)',iostat=code) data(i)
               call sei code(fort$,code,write1,b_flag) ! Process outcome.
c
c write input for focmec_exe, lot 16.01.2002
c
               read(data(i)(11:12),'(a2)') phasenm
               read(data(i)(77:79),'(f3.0)') az
               read(data(i)(58:60),'(f3.0)') anginc
               read(data(i)(71:75),'(f5.0)') dist

               write(write3,'(a4,2f8.2,a1,18x,a)') 
     *           data(i)(2:5),az,anginc,sense,data(i)(10:15)
               npol=npol+1  ! count polarity readings

         elseif (data(i)(11:12).eq.'AM'.and.nevent.eq.1) then
c
c amplitudes
c
c               read(data(i)(14:14),'(a1)') phasenm

c
c check if new station
c
               ind=-1
               c=1
               do while (amp_stat(c).ne.data(i)(2:6).and.
     &                   c.le.namp)
                 c=c+1
               enddo
               if (amp_stat(c).eq.data(i)(2:6)) then
                 ind=c   ! station found
                 new=.FALSE.
               else
                 namp=namp+1   ! new station
                 amp_stat(namp)=data(i)(2:6)
                 ind=c
                 do k=1,5      ! init amplitudes
                   amp_raw(ind,k)=0.
                 enddo
                 new = .TRUE.
               endif

               read(data(i)(34:40),'(g7.1)') amp
               if (new) then
                 read(data(i)(77:79),'(f3.0)') amp_az(ind)
                 read(data(i)(71:75),'(f5.0)') amp_dist(ind)
               endif

c
c save amplitude to amp array
c
               if (data(i)(8:8).eq.'Z'.and.data(i)(13:14).eq.'PG') then
                 amp_raw(ind,1)=amp     ! P on Z
           elseif (data(i)(8:8).eq.'R'.and.data(i)(13:14).eq.'PG') then
                 amp_raw(ind,2)=amp     ! S on R
           elseif (data(i)(8:8).eq.'Z'.and.data(i)(13:14).eq.'SG') then
                 amp_raw(ind,3)=amp     ! S on Z
           elseif (data(i)(8:8).eq.'R'.and.data(i)(13:14).eq.'SG') then
                 amp_raw(ind,4)=amp     ! S on R
           elseif (data(i)(8:8).eq.'T'.and.data(i)(13:14).eq.'SG') then
                 amp_raw(ind,5)=amp     ! S on T, SH
               endif
        endif
      enddo
c
c get emergence angle at station
c

      do i=1,namp

c
c get emergance angles for P and S
c
c         write(*,*) ' station: ',amp_stat(i)
         phasenm='PG'
         call get_ang_emrg(depth,amp_dist(i),nlayer,vp,vs,vdepth,imoho,
     &           phasenm,aemrgp,anginc)
c         write(*,*) ' P emergance angle: ',aemrgp
c         write(*,*) ' P take off  angle: ',anginc
         write(*,'(a,a5,a,f5.1)') ' amplitude reading - station: ',
     &     amp_stat(i),' P takeoff: ', anginc 
         phasenm='SG'
         call get_ang_emrg(depth,amp_dist(i),nlayer,vp,vs,vdepth,imoho,
     &           phasenm,aemrgs,anginc)
c         write(*,*) ' S emergance angle: ',aemrgs
c         write(*,*) ' S take off  angle: ',anginc

         if (amp_raw(i,1).ne.0..and.(amp_raw(i,3).ne.0.
     &      .or.amp_raw(i,4).ne.0.)) then
c SV(Z)/P(Z)
           if (amp_raw(i,3).ne.0.) then
             ratio_name = 'SV(Z)/P(Z)'
c SV(R)/P(Z)
           else
             ratio_name = 'SV(R)/P(Z)'
           endif
           call freesurf_ratio(vpvs,ratio_name,aemrgp,aemrgs,correction)
           write(*,*) ratio_name//' correction = ',correction
           corrected_ratio(i,1) = 
     &          log10(amp_raw(i,3)/amp_raw(i,1)*correction)
           write(*,*) ' corrected log10 ratio SV/P = ',
     &        corrected_ratio(i,1)
c
c write to focmec input file
c
           nratio=nratio+1
           write(write3,'(a4,2f8.2,a1,f8.4,1x,a1,1x,f6.2,1x,a)')
     *       amp_stat(i)(1:4),amp_az(i),anginc,'V',
     *       corrected_ratio(i,1),' ',aemrgp,ratio_name
c write to focmec.inp
            write(write1,'(1x,a5,10x,a1,40x,i3,16x,i3)') 
     *         amp_stat(i),'V',int(anginc),int(amp_az(i))
         endif

         if ((amp_raw(i,3).ne.0..or.amp_raw(i,4).ne.0)
     &      .and.amp_raw(i,5).ne.0.) then
c SV(Z)/SH(T)
           if (amp_raw(i,3).ne.0.) then
             ratio_name = 'SV(Z)/SG(T)'
c SV(R)/SH(T)
           elseif (amp_raw(i,4).ne.0.) then
             ratio_name = 'SV(R)/SG(T)'
           endif
           call freesurf_ratio(vpvs,ratio_name,aemrgp,aemrgs,correction)
           write(*,*) ratio_name//' correction = ',correction
           if (amp_raw(i,3).ne.0.) then
             corrected_ratio(i,3) =
     &          log10(amp_raw(i,3)/amp_raw(i,5)*correction)
           elseif (amp_raw(i,4).ne.0.) then
             corrected_ratio(i,3) =
     &          log10(amp_raw(i,4)/amp_raw(i,5)*correction)
           endif
           write(*,*) ' corrected log10 ratio SV/SH = ',
     &        corrected_ratio(i,3)
c
c write to focmec input file
c
           nratio=nratio+1
           write(write3,'(a4,2f8.2,a1,f8.4,1x,a1,1x,f6.2,1x,a)')
     *       amp_stat(i)(1:4),amp_az(i),anginc,'S',
     *       corrected_ratio(i,3),' ',aemrgp,ratio_name
c write to focmec.inp
            write(write1,'(1x,a5,10x,a1,40x,i3,16x,i3)')
     *         amp_stat(i),'S',int(anginc),int(amp_az(i))

c SG(T)/P(Z)
         elseif (amp_raw(i,5).ne.0..and.amp_raw(i,1).ne.0.) then
           ratio_name = 'SG(T)/P(Z)'

           call freesurf_ratio(vpvs,ratio_name,aemrgp,aemrgs,correction)
           write(*,*) ratio_name//' correction = ',correction
           corrected_ratio(i,2) =
     &          log10(amp_raw(i,5)/amp_raw(i,1)*correction)
           write(*,*) ' corrected log10 ratio SH/P = ',
     &        corrected_ratio(i,2)
c
c write to focmec input file
c
           nratio=nratio+1
           write(write3,'(a4,2f8.2,a1,f8.4,1x,a1,1x,f6.2,1x,a)')
     *       amp_stat(i)(1:4),amp_az(i),anginc,'H',
     *       corrected_ratio(i,1),' ',aemrgp,ratio_name
c write to focmec.inp
            write(write1,'(1x,a5,10x,a1,40x,i3,16x,i3)')
     *         amp_stat(i),'H',int(anginc),int(amp_az(i))
         endif
      enddo


c
c   back for next event
c
      goto 1
c
c   End of file...
c   ==============
c   ...end of all events
c
99    write(write1,*,iostat=code)
     &           '                  '         ! last line is blank
      call sei code(fort$,code,write1,b_flag) ! Process outcome.
      call sei close(close$,read1,code)       ! Close print.out.
      call sei close(close$,read2,code)       ! & data input.
      call sei close(close$,write1,code)      ! & output.
      call sei close(close$,write2,code)      ! & output.
      call sei close(close$,write3,code)      ! & output.
      goto 9999                               ! Return to caller.
c
c   Return to Caller...
c   ===================
c
9999  return
      end 
c
      subroutine angles
c
c   interactively calculate different fault plane solution angles
c   using focmec subroutines
c
      real PTTP(4)          ! strike and dip of P and T
      real ANGS(3)          ! dip, strike and rake of principal fault plane
      real ANGS2(3)         ! dip, strike and rake of auilary ------------
      real ANBTP(6) 
      real momten(6)
      real pi,degrad
      integer i
      character*1 choice
c
      PI = 4.0*ATAN(1.0)
      degrad=180.0/pi
c
 50   continue
      write(6,*)
      write(6,*) ' Relation between fault plane solution angles:'
      write(6,*) ' 1: Strike, dip and rake from P and T'
      write(6,*) ' 2: Other plane and P and T from first plane'
      write(6,*) ' Return to stop'
      read(5,'(a1)') choice
      if(choice.eq.'1') goto 1
      if(choice.eq.'2') goto 2
      if(choice.eq.' ') return
c
 1    continue
      write(6,*)' Enter strike and dip of P and strike and dip of T'
      read(5,*)pttp
c      aa=.true.
c      bb=.false. 
      do i=1,4
         pttp(i)=pttp(i)/degrad
      enddo
      call pttpin(pttp,angs,angs2,anbtp,momten,pi)
      do i=1,3
        angs(i)=angs(i)*degrad
        angs2(i)=angs2(i)*degrad
      enddo
      write(6,'(a,2x,3f8.1)')
     *' Strike, dip and rake of principle fault plane'
     *,angs(2),angs(1),angs(3)
      write(6,'(a,2x,3f8.1)')
     *' Strike, dip and rake of auxilary fault plane'
     *,angs2(2),angs2(1),angs2(3)
c      call
c     *FMREPS(ANBTP,ANGS,PTTP,ANGS2,bb,aa,bb,-1,-1)
c      write(6,*)angs
c       return
       goto 50
c
c
2     continue
c
c   calculate from strike dip and rake
c
      write(6,*)' Enter strike, dip and rake'
      read(5,*) angs(2),angs(1),angs(3)
      do i=1,3
        angs(i)=angs(i)/degrad
      enddo
	  call DSRIN (ANGS,ANBTP,ANGS2,PTTP,momten,PI)
      do i=1,3
        angs2(i)=angs2(i)*degrad
      enddo
      do i=1,4
        pttp(i)=pttp(i)*degrad
      enddo

      write(6,'(a,2x,3f8.1)')
     *' Strike, dip and rake of auxiliary fault plane'
     *,angs2(2),angs2(1),angs2(3)
      write(6,*)' Strike and dip of P and strike and dip of T'
      write(6,*) pttp
      goto 50

       return
       end

      subroutine get_ang_emrg(evdepth,dist,mnlayer,mvp,mvs,mdepth,imoho,
     &           phasenm,aemrg,ann)
c
c Lars Ottemoller, Jan 2002
c determine emergance angle at station for given velocity model,
c distance and event depth
c
      implicit none
      include 'hypparm.inc'
      integer seiclen

      real dist                  ! distance in km
      real evdepth               ! hyp depth in km
      real mvp(*),mvs(*),mdepth(*) ! layer velocity model
      integer mnlayer            ! number of layers
      integer imoho,iconrad      ! index for moho 
      real aemrg                 ! angle of emergance for p and s
      real rearth                ! Earth radius
      character*(*) phasenm      ! phase name, PN,PG,P,SN,SG,S
      real pi
      real radtodeg
      integer i
      character*8 phsid
      character*1 prmd,prm2
      real tmin,delta,ann
      integer iflag,unit,minflag,iustat

      if (dist.eq.0.) then
        aemrg=0.
        return
      endif

      unit=99
      pi=asin(1.)*2.
      radtodeg=45./atan(1.)
      rearth=6371.
      iconrad=0

c    set test parameter defaults
      call settest(test)

      do i=1,mnlayer
        v(i)=0.
        if (phasenm(1:1).eq.'S') v(i)=mvs(i)
        if (phasenm(1:1).eq.'P') v(i)=mvp(i)
        parm(i)=v(i)
        d(i)=mdepth(i)
        if (v(i).eq.0.) return
      enddo
      do i=1,mnlayer-1
        parm(mnlayer+i)=mdepth(i+1)-mdepth(i)
      enddo
      nl=mnlayer  ! used in dtdx2
      prmd=' '
      if (seiclen(phasenm).eq.2) prmd=phasenm(2:2)

      xh(1)=dist/rearth
      xh(2)=0.
      xh(3)=evdepth

      x0(1)=0.
      x0(2)=0.
      x0(3)=0.

      call dtdx2(xh,x0,prmd,imoho,iconrad,unit,tmin,
     &  dx,delta,ann,iflag,phsid)
c
c compute emergance angle from horizontal slowness
c
      aemrg = radtodeg * asin(dx(1)/rearth*v(1)) 
c      write(*,*) ' aemrg = ',aemrg,' ain= ',ann,
c     &     ' tmin = ',tmin

      return
      end


      subroutine freesurf_ratio(vpvs,ratio_name,aemrgp,aemrgs,ratio)
      implicit none 
c
c compute free surface correction based on emergance angle, based
c on program freesurf by A. Snoke
c
c Lars Ottemoller, 31.01.2002
c
c input:   vpvs - ratio vp/vs
c          ratio_name - ratio to be computed, see below
c          aemrgp,aemrgs - emergance angle for p and s
c
c output:  ratio - amplitude correction factor
c
c 

      real radtodeg          ! factor for rad to deg
      real vpvs,vsvp         ! ratios vp/vs and vs/vp
      real aemrgp,aemrgs     ! emergance angle at station
      real apv,asv,apr,asr   ! vertical and radial displacement
      real ash               !
      real phr               ! for sv inc beyonf critical, phv=phr+90.
      real ratio             ! amplitude correction
      character*(*)ratio_name! name of ratio to be returned in ratio
  
      radtodeg=45./atan(1.)
      vsvp=1./vpvs
      ash = 2.

c get p amplitudes
      call gdmot(radtodeg,1,vsvp,aemrgp,apr,phr,apv)
c get s amplitudes
      call gdmot(radtodeg,2,vsvp,aemrgs,asr,phr,asv)
      asr = abs(asr)
      asv = abs(asv)

      write(*,*) 'P amplitudes on Z and R:',apv, apr
      write(*,*) 'S amplitudes on Z and R:',asv, asr

      if (ratio_name.eq.'SV(R)/P(Z)') then
        ratio = apv/asr
      elseif (ratio_name.eq.'SV(Z)/P(Z)') then
        ratio = apv/asv
c SG(T) is SH
      elseif (ratio_name.eq.'SV(R)/SG(T)') then
        ratio = ash/asr
      elseif (ratio_name.eq.'SV(Z)/SG(T)') then
        ratio = ash/asv
      elseif (ratio_name.eq.'SV(R)/SV(Z)') then
        ratio = asr/asv
      endif

      return
      end

C                                                                               
C                       
C  Program to make a compact file from a Nordic file                                  
c  Earlier name of program was compact
C                                                                               
C  J. Havskov  1990 ?
c
c  updates
c  feb 15, 96 jh: copy magnitudes from following lines
c
c  nov  9  98 :-------------   version 7.0 check ------------------------
c              no change                                                                               
c
      implicit none
      include 'seidim.inc'        ! dimensions
      CHARACTER*80 DATA(max_data)                                                    
      CHARACTER*1 TYPE,EXP                                                      
      logical mag                 ! if true, get magnitudes from other lines
      integer nstat,nphase,nhead,nrecord
c---number of arguments
      integer nars
c---files as arguments
      character*80 file(5)
c---unit for output
      integer out
      integer n,id
c--compact or not
      logical compact


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

       mag=.false.

c 
c   check if input from file given in argument
c
 1      continue
        call get_arguments(nars,file)
        if(nars.eq.0.or.nars.gt.3) then
           write(6,*)' You must give arguments, first is input file,'
           write(6,*)' optional second is output file, if an optional'
           write(6,*)' second or 3. is -mag, magnitudes from following'
           write(6,*)' header lines are moved up to empty magnitude'
           write(6,*)' spaces on first line'
           stop
        endif
c
c   case with output on standard output
c
        if(nars.eq.1) then
          out=6
        endif
c
c   output in file or magnitude copy
c
        if(nars.eq.2) then
          if(file(2)(1:4).eq.'-mag') then 
             mag=.true.
             out=6
          else
             out=2
             open(2,file=file(2),status='unknown')
          endif
        endif
c
c   output in file and magnitude copy
c
        if(nars.eq.3.and.
     *    (file(2)(1:4).ne.'-mag'.and.file(3)(1:4).ne.'-mag')) then
           nars=0
           goto 1
        endif
c
        if(nars.eq.3) then
          if(file(2)(1:4).eq.'-mag') then 
             mag=.true.
             out=2
             open(2,file=file(3),status='unknown')
          endif
          if(file(3)(1:4).eq.'-mag') then 
             mag=.true.
             out=2
             open(2,file=file(2),status='unknown')
          endif
        endif
c
c   open input file name, is first argument
c
        open(1,file=file(1),status='old')
c
c   check that not already a compact file
c
        call nortype(1,compact)
        if(compact) then
           write(6,*)' Input file alredy compact'
           stop
        endif
c
c   read and write to end of file
c
        n=0
  10    continue
        CALL INDATA(1,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
        if(nrecord.eq.0) goto 99
        if(mag) call get_mag(data,nhead)
        n=n+1
        write(out,'(a)')data(1)
        goto 10
c
 99     continue
        write(6,*)
        write(6,*)' The input file had ',n,' events'
        stop
        end
                       
        subroutine get_mag(data,nhead)
c
c  if not all positions occupied with magnitudes in first line, move
c  up magnitudes from following header lines. take in order they
c  appear.
c
c       
        character*80 data(*)
        integer nhead        ! number of header lines
        character*7 magtext(3)  ! magnitude with type and agency
        integer i,k

        if(nhead.lt.2) return      ! only one header line, nothing to find
c
c   find number of available magnitude positions 
c
        nfree=0
        if(data(1)(57:59).eq.'   ') then
           nfree=nfree+1
        endif
        if(data(1)(65:67).eq.'   ') then
           nfree=nfree+1
        endif
        if(data(1)(73:75).eq.'   ') then
           nfree=nfree+1
        endif
c
        if(nfree.eq.0) return     ! no room for more
c
c   search following header lines 
c
        k=0
        do i=2,nhead
           if(data(i)(80:80).eq.'1') then
              if(data(i)(57:59).ne.'   ') then
                 k=k+1
                 nfree=nfree-1
                 magtext(k)=data(i)(57:63)
                 if(nfree.eq.0) goto 10
              endif
              if(data(i)(65:67).ne.'   ') then
                 k=k+1
                 nfree=nfree-1
                 magtext(k)=data(i)(65:71)
                 if(nfree.eq.0) goto 10
              endif
              if(data(i)(73:75).ne.'   ') then
                 k=k+1
                 nfree=nfree-1
                 magtext(k)=data(i)(73:79)
                 if(nfree.eq.0) goto 10
              endif
           endif
        enddo
c
c   now put in magnitudes found
c
 10     continue
        if(k.eq.0) return   ! no new magnitudes
        i=1
        if(data(1)(57:59).eq.'   ') then
           data(1)(57:63)=magtext(i)
           i=i+1
           if(i.gt.k) goto 20             ! no more magnitudes
        endif
        if(data(1)(65:67).eq.'   ') then
           data(1)(65:71)=magtext(i)
           i=i+1
           if(i.gt.k) goto 20             ! no more magnitudes
        endif
        if(data(1)(73:75).eq.'   ') then
           data(1)(73:79)=magtext(i)
           i=i+1
           if(i.gt.k) goto 20             ! no more magnitudes
        endif
c
 20     continue
        return
        end

c$debug
C
C    PROGRAM SPLIT                                                              
C                                                                               
c
c
C    SPLITS AN  S-FILE TO INDIVIDUAL FILES. FILENAME                        
C    IS DETERMINED BY  (IN ORDER: ID, TIME IN HEADER, OR IF NO TIME IN HEADER,                     
C    THEN A HEADER TIME IS MADE FROM EARLIEST ARRIVAL TIME IN FILE. IF NO ID LINE
C    IS GIVEN, IT WILL BE PUT IN, TYPE I.                                                                    
C
C                                                                               
C    MADE BY JENS HAVSKOV NOVEMBER 1988                                         
C                                                                               
C                                                                               
C    LATEST UPDATE    
C
c    nov 94          : ****************   version 5.0 *******************
c    nov 24, 1994    : opening files changed
c    dec 13          : create new index if same file name
c    jan 11          : new get def base call
c    jan 31  1995    : bug
c    jan 31 1996     : split of compact file
c    dec 23 96       : bug when 2 header lines and 2 header line not a help
c                      line, 2 header line was then lost.
c    jan 22 98 jh    : *********  year 2000 changes ***********************
c                    : remove to LIB routine inc_id
c    spe 98 by jh    : ---------- version 7.0 check ----------------
c                      5 char base names, only use long S-file names, include
c                      seidim to dimention DATA
c    oct 25, 00 jh:   high accuracy
C
       implicit none

C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! dimentions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c-- INPUT FILE                                         
      CHARACTER*80 FILE				
c-- OUTPUT FILE NAME                                   
      CHARACTER*80 OUTFL			
      integer nf            ! length of file name
c-- EVENT TYPE, L,R OR D                              
      CHARACTER*1  EVTYPE			
c-- idline
      character*80 idline
c-- TOP DIR FOR REA               
      CHARACTER*40 TOP_DIRECTORY                
C-- SYSTEM TIME FOR USED FOR TIME OF OPERATION
      CHARACTER*12 p_time
      character*14 proc_time 
C-- OPERATOR ID
      CHARACTER*4 OPERATOR
c-- dir separator
      character*1 dchar
c-- RECORDS IN FILE                                
      CHARACTER*80 DATA(max_data)
c-- TIME IN SEC SINCE 1900 EVENT                    
      DOUBLE PRECISION TIME			
c-- OLD -------------             
      DOUBLE PRECISION TIME_OLD                 
c-- MINIMUM TIME --------------   
      DOUBLE PRECISION MIN_TIME                 
c-- DAY OF YEAR, NOT USED                                    
      INTEGER DOY				
c-- DATES AND TIMES                             
      INTEGER YEAR,MONTH		        
     *,DAY,HR,MIN,ISEC                                                          
c-- SECONDS                                                    
      REAL SEC					
c-- EXPLOSION INDICATOR                                
      CHARACTER*1 EXP	  			
c-- INDICATOR FOR USE OF DATA BASE                      
      CHARACTER*5 BASE				
c-- HELP FORMAT LINE 0: NO, 1: YES               
      INTEGER FORMAT_INDICATOR			
c-- NUMBER OF STATIONS                                     
      INTEGER NSTAT				
c-- NUMBER OF RECORDS FOR EVENT                          
      INTEGER NRECORD				
c-- NUMBER OF HEADERS FOR EVENT                            
      INTEGER NHEAD				
c-- NUMBER OF PHASES FOR EVENT	  
      INTEGER NPHASE
C-- ID LINE NUMBER
      INTEGER ID
      character*1 answer    ! answer
      logical compact       ! compact input file or not
c-- EVENT COUNTERS                  
      INTEGER NL,NR,ND,NE,NP,NU,NEVENT       	
c-- TOTAL NUMBER OF RECORDS                            
      INTEGER REC_TOTAL				
c-- COUNTER                                                  
      INTEGER I,K				
c   length of top_directory
      integer topdirlen
c  def base
      character*5 def_base
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1 
       integer          read01
c write unit #1
       integer          write01
c file name
       character*80     chr_file
       logical          nwrite_all,owrite_all  ! for witing files
       logical          ignore_all            ! ignore all dublicates
       character*1      choise                ! choise form questions

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

C                                                                               
C    SET DEFAULTS AND INITIAL PARAMETERS                                        
C
      call topdir(top_directory)
      call get_def_base(def_base)
      topdirlen=index(top_directory,' ') -1
      call dir_char(dchar)
      nwrite_all=.false.
      owrite_all=.false.
      ignore_all=.false.
      b_f_debug$=.false.                  ! file debugging
c
      idline(1:40)= ' ACTION:                   OP:     STATU'                                                  
      idline(41:80)='S:               ID:                   I'
      NEVENT=0                                                                  
      ND=0                                                                      
      NL=0                                                                      
      NR=0                                                                      
      NE=0                                                                      
      NP=0                                                                      
                                                                                
c-- PREVIOUS TIME VERY OLD                         
      TIME_OLD=0               
C                                                                               
C  OPEN FILES                                                                   
C                                       
 101  continue                                        
      WRITE(6,*)' INPUT FILE NAME'                                              
      READ(5,'(A)') FILE                                                      
c
c   open and check if file available
c
            call sei open(old$,                  ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    file,                  ! File name
     &                    read01,                ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
c
      if(.not.b_old) goto 101     ! try again
c
c   check type
c
      call nortype(read01,compact)
      if(compact) then
         write(6,*)' Input file is compact, do you want to split (y/n)'
         read(5,'(a)') answer
         if(answer.ne.'y'.and.answer.ne.'Y') stop
         write(6,*)' Really sure ??????? (y/n)'
         read(5,'(a)') answer
         if(answer.ne.'y'.and.answer.ne.'Y') stop
      endif
      WRITE(6,*)' BASE NAME FOR OUTPUT FILES:'                                             
      WRITE(6,'(a,a,a)')'   ',def_base,'  FOR STANDARD DATA BASE: '                               
      WRITE(6,*)'   1-5 LETTER CODE FOR OTHER BASE'                           
      WRITE(6,*)'   RETURN FOR SPLIT UP IN LOCAL DIRECTORY'                     
      READ(5,'(A5)') BASE
      WRITE(6,*)' OPERATOR ID, MAX 4 CHARS'
 777  CONTINUE
      READ(5,'(A)') OPERATOR
      IF(OPERATOR.EQ.'        ') THEN
         WRITE(6,*)' YOU MUST GIVE OPERATOR ID '
         GOTO 777
      ENDIF           
c
c   fill out blanks in base name 
c
      if(base.ne.'     ') then
         do i=2,5
           if(base(i:i).eq.' ') base(i:i)='_'
         enddo
      endif                                            
C
C   GET SYSTEM TIME
C
      CALL SYSTIME(p_time,PROC_TIME)
C                                                                                
C
C   START OF LOOP-------------------------------------------------
C                                       
                                                                                
 1    CONTINUE                                                                  
C                                                                               
C   READ  EVENT                                                                 
C          
      if(compact) then
         read(read01,'(a)',end=2) data(1)
         data(2)=' '
         nrecord=2
         nhead=1
         nphase=0
         evtype=data(1)(22:22)
         exp=data(1)(23:23)
         id=0
      else                                                                     
         CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,
     *   EVTYPE,EXP,DATA,ID)
      endif
C                                                                               
C   CHECK FOR EOF                                                               
C                                                                               
      IF(NRECORD.EQ.0) GO TO 2
C
C   CHECK IF ID LINE PRESENT, IF NOT GET TIME FROM EVENT DATA
C
      IF(ID.EQ.0) THEN
C                                                                               
C   GET ABS TIME FOR  EVENT, READ YEAR,MONTH AND DAY FROM HEADER,               
C   HR, MIN AND SEC FROM EARLIEST STATION IF NOT GIVEN IN HEADER
C                                                                               
         READ(DATA(1),'(1X,i4,1X,2I2,1X,2I2,1X,F4.1)')                             
     *   YEAR,MONTH,DAY,HR,MIN,SEC
C
C   ASSUME 1900 IF NO CENTURY GIVENT
C
C                                                                               
C   CHECK IF HR AND MIN IN HEADER                                               
C                                                                               
c-- FIND EARLIEST TIME                   
         IF(DATA(1)(12:15).EQ.'    '.and.(.not.compact)) THEN		
            MIN_TIME=10E20                                                         
            DO I=NHEAD+1,NRECORD-1                                                 
               READ(DATA(I),'(18X,2I2,F6.1)') HR,MIN,SEC                        
c-- ABS TIME              
               CALL TIMSEC(YEAR,MONTH,DAY,HR,MIN,SEC,TIME)	
               IF(TIME.LT.MIN_TIME) MIN_TIME=TIME                                  
            ENDDO                                                                  
            CALL SECTIM(MIN_TIME,YEAR,DOY,MONTH,DAY,HR,MIN,SEC)                    
c--  EARLIEST TIME  
            WRITE(DATA(1)(1:20),'(1X,I4,1X,2I2,1X,2I2,1X,F4.1)') 
     *      YEAR,MONTH,DAY,HR,MIN,SEC                   
            DATA(1)(80:80)='1'
         ENDIF                                                                     
      ELSE
         READ(DATA(ID)(61:74),'(i4,5I2)')YEAR,MONTH,DAY,HR,MIN,ISEC
         SEC=ISEC
      ENDIF
      WRITE(6,201) YEAR,MONTH,DAY,HR,MIN,SEC,EVTYPE,EXP,                        
     *NRECORD                                                                   
c
c   temporary fixes 
c
c     data(1)(45:45)='*'
c     data(1)(72:79)=data(1)(56:63)
c     data(1)(56:63)=' '
c
c   temporary fixes end, make sure above is commented out
c
 201  FORMAT(1X,i4,2(I3),2X,I2,':',I2,F5.1,2X,A1,1X,A1,                            
     *'     RECORDS:',I4)                                                       
C                                                                               
C   CHECK TIME                                                                  
C                                                                               
      IF(TIME.LT.TIME_OLD) THEN                                                 
         WRITE(6,*)' *** EVENT OUT OF ORDER ***'                                
      ENDIF                                                                     
      TIME_OLD=TIME                                                             
C                                                                               
C   CHECK TYPES                                                                 
C                                                                               
      IF(EVTYPE.NE.'L'.AND.EVTYPE.NE.'D'.AND.EVTYPE.NE.'R') then
c         WRITE(6,*)' *** EVENT HAS WRONG OR NO DISTANCE INDICATOR ***'
c         write(6,*) 'Type will be set to L'
          if(evtype.eq.' ') evtype='D'
          data(1)(22:22)='D'
       endif
c      IF(EXP.NE.'E'.AND.EXP.NE.'P'.AND.EXP.NE.' ')                              
c     *   WRITE(6,*)' *** EXPLOSION TYPE WRONG ***'                              
C                                                                               
C   COUNT EVENTS                                                                
C                                                                               
      NEVENT=NEVENT+1                                                           
      IF(EVTYPE.EQ.'L') NL=NL+1                                                 
      IF(EVTYPE.EQ.'R') NR=NR+1                                                 
      IF(EVTYPE.EQ.'D') ND=ND+1                                                 
      IF(EXP.EQ.'E') NE=NE+1                                                    
      IF(EXP.EQ.'P') NP=NP+1                                                    
C                                                                               
C  GENERATE OUTPUT FILE NAME                                                    
C                                                                               
      ISEC=SEC                                                                  
C                                                                               
C   CHECK IF DATA BASE OR NOT                                                   
C
      IF(BASE.NE.'     ') THEN
         WRITE                                                                  
     *   (OUTFL,307) dchar,BASE,dchar,YEAR,dchar,MONTH,dchar,
     *   DAY,HR,MIN,ISEC,EVTYPE,YEAR,MONTH
 307     FORMAT(
     *   a1,A5,a1,I4,a1,I2,a1,I2,'-',2i2,'-',i2,a1,'.S',i4,I2)               
C
         DO I=1,34                                                              
            IF(OUTFL(I:I).EQ.' ') OUTFL(I:I)='0'                                
         ENDDO   
         nf=34                                                           
      ELSE                                                                      
         WRITE(OUTFL,303)DAY,HR,MIN,ISEC,EVTYPE,'S',YEAR,MONTH                      
 303     FORMAT(I2,'-',2i2,'-',i2,a1,'.',a1,i4,I2)                                  
         DO I=1,19                                                                 
            IF(OUTFL(I:I).EQ.' ') OUTFL(I:I)='0'                                   
         ENDDO
         nf=19          
      ENDIF
c
c   put in id if not there
c
      if(id.ne.0) idline=data(id)
      if(id.eq.0) THEN
         WRITE(IDLINE(61:75),'(i4,6I2)')
     *   YEAR,MONTH,DAY,HR,MIN,ISEC
         DO I=61,74
            IF(IDLINE(I:I).EQ.' ') IDLINE(I:I)='0'
         ENDDO
      ENDIF
      WRITE(IDLINE(31:34),'(A)')OPERATOR
      WRITE(IDLINE(13:26),'(A)')PROC_TIME
      WRITE(IDLINE(9:11),'(A)')'SPL' 
C                                                                               
C   CHECK IF FORMAT EXPLANATORY LINE IN FILE                        
C                                                                               
      FORMAT_INDICATOR=0                                                        
      DO K=1,NHEAD                                                              
         IF(DATA(K)(80:80).EQ.'7') FORMAT_INDICATOR=1                           
      ENDDO                                                                     
C                                                                               
C  OPEN AND WRITE OUTPUT FILE                                                   
C
      goto 4                                                                               
 3    continue                 ! get here from below when file did not exist
         call sei close (close$,write01,code) ! opened below
 4    continue
      IF(BASE.NE.'     ') THEN                                                    
         chr_file = top_directory(1:topdirlen)//dchar//'REA'//outfl
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    chr_file,              ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
      ELSE
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    outfl,                 ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
      ENDIF
c
c   check if file exists, if not continue. If file exists, check what to do
c
c   ignore
c
      if(b_old.and.ignore_all) then ! was there but do not overwrite
         call sei close (close$,write01,code) ! opened below
         write(6,*)' New event ignored'
         goto 1       ! never overwrite
      endif
c
c   over write
c
      if(b_old.and.owrite_all) then
         write(6,*)' New event overwriting old'
         go to 10     ! overwrite all
      endif
c
c   make new index
c
      if((b_old.and.nwrite_all).or.(b_old.and.(choise.eq.'N'.or.
     *    choise.eq.'n'))) then
          write(6,*)' Creating a new id for event'
          call inc_id(idline,outfl,nf)
          goto 3                            ! go and try to open again
      endif
 5    continue            ! only go here if no valid choise
c
c   make choises here
c
      if(b_old) then
          write(6,*)
          write(6,'(a)')' File already exists, options are:'
          write(6,'(a)')' Ignore (leave old event):             Return'
          write(6,'(a)')' Ignore all                            I'
          write(6,'(a)')' Overwrite duplicate:                  O'
          write(6,'(a)')' Overwite all duplicates               A'
          write(6,'(a)')' Create a new event, different ID:     N'
          write(6,'(a,$)')' Create new events for ALL duplicates: *'
          read(5,'(a)') choise
          write(6,*)
        
          if(choise.eq.' ') then
             call sei close (close$,write01,code) 
             goto 1     ! get next event
          endif
          if(choise.eq.'i'.or.choise.eq.'I') then
             ignore_all=.true.
             goto 1
          endif
          if(choise.eq.'a'.or.choise.eq.'A') then
             write(6,*)' Sure you want to overwrite ALL (y/n)'
             read(5,'(a)') choise
             if(choise.eq.'y'.or.choise.eq.'Y') then
                 owrite_all=.true.
                 goto 10  ! overwrite
             endif
             goto 5 ! another choise  
          endif
          if(choise.eq.'o'.or.choise.eq.'O') then
             write(6,*)' Sure you want to overwrite(y/n)'
             read(5,'(a)') choise
             if(choise.eq.'y'.or.choise.eq.'Y') goto 10  ! overwrite
             goto 5   
          endif
          if(choise.eq.'n'.or.choise.eq.'N'.or.choise.eq.'*') then
             call inc_id(idline,outfl,nf)
             if(choise.eq.'*') nwrite_all=.true.
             goto 3     ! test again
          endif
          goto 5   ! no valid choise
      endif
c
  10  continue 
      choise=' '    ! reset choise
C
C   WRITE FILE
C                                                                     
c-- ORIGINAL HEADER LINES FIRST, MINUS FORMAT INDICATOR IF THERE,
C   IF NO ID LINE, PUT IN AS NUMBER 2
C
          write(write01,'(a80)',iostat=code) data(1)
          call sei code(fort$,code,write01,b_eof)
c
c  if new id line, write as #2, else where it was before
c
      if(id.eq.0) then
          write(write01,'(a80)',iostat=code) idline
          call sei code(fort$,code,write01,b_eof)
      else
         data(id)=idline
      endif
c
c   write rest of header lines except help line
c
      if(nhead.ge.2) then 
         do i=2,nhead
            if(data(i)(80:80).ne.'7')
     *      write(write01,'(a80)',iostat=code)data(i)
            call sei code(fort$,code,write01,b_eof)
         enddo
      endif
C
c-- write help line if not a compact file
C
      if(.not.compact) then
         write(write01,243,iostat=code)
         call sei code(fort$,code,write01,b_eof)
      endif
 243  FORMAT(
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO ',
c     *'SNR AR TRES W  DIS CAZ7')              
     *'AIN AR TRES W  DIS CAZ7')              
c-- WRITE REST OF EVENT         
       write(write01,'(a80)',iostat=code)
     * (data(i),i=nhead+1,nrecord)
      call sei code(fort$,code,write01,b_eof)
      call sei close (close$,write01,code)
C                                                                               
C   COUNT RECORDS                                                               
C                                                                               
      REC_TOTAL=REC_TOTAL+NRECORD                                               
c-- ONE WAS ADDED           
      IF(FORMAT_INDICATOR.EQ.0.and..not.compact) REC_TOTAL=REC_TOTAL+1 
C                                                                               
C  BACK FOR NEXT EVENT                                                          
C                                                                               
      GO TO 1                                                                   
C                                                                               
C   EOF, WRITE SUMMARY                                                          
C                                                                               
 2    CONTINUE                                                                  
      WRITE(6,202)NL,NR,ND,NE,NP,NEVENT,REC_TOTAL                               
 202  FORMAT(/,' NUMBER OF LOCAL EVENTS:   ',I5,                                
     *       /,' NUMBER OF REGIONAL EVENTS:',I5,                                
     *       /,' NUMBER OF DISTANT EVENTS: ',I5,                                
     *       /,' NUMBER OF EXPLOSIONS:     ',I5,                                
     *       /,' NUMBER OF PROB. EXPLOSIONS',I5,                                
     *       //,' TOTAL NUMBER OF EVENTS:   ',I5,                               
     *       //,' TOTAL NUMBER OF RECORDS:  ',I5/)                              
                                                                                
      NU=NEVENT-NL-NR-ND                                                        
      IF(NU.GT.0) WRITE(6,*) ' *** NUMBER OF UNIDINTIFIED EVENTS',              
     *' ***',NU
      call sei close (close$,read01,code)
      STOP                                                                      
      END                                                                       
                                                                                

c
c   converts pde monthly and weekly bulletins files to nordic format
c   files can be received on email or picked up  at 
c   hazards.cr.usgs.gov, dir pde for monthly files and
c   hazards.cr.usgs.gov, weekly  for weekly files, must be ehdf type.
c
c   reads monthly filefes in both formats before 2004 and after
c
c   jh august 1993
c   updates:
c   apr 14, 96 by jh: add automatic year,month reading, weekly files
c   apr 19          : fix name, append weekly files
c   apr 25          : fix monthly if retransmitted mail
c   may 30, 97      : format read for weekly files was wrong in latitude
c   jun 23          : new PDE format
c   sep 9           : bug
c   dec 19          : bug with s and w for weekly files
c                     be able to read yearly files in monthly format
c   fen 4   99 jh   : ---------   version 7.0 ---------------------
c   jan 27 2002 jh  : make all events type D, put weekly file sin PDEWE base
c   feb 19          : also split to s-files
c   mar 12          : more fixing in above
c   apr 4           _ --------------------
c   aug 20          : put in line type 1
c   mar 24 2003     : for monthly files, number of stations was GAP, fixed
c   may 10 2004     : more comments
c   jul 7  2005     : small format change for monthly files
c   dec 7  2005 jh  :  more changes to monthly files, some #$@%^% changed
c                     the format jan 01, 2004, 
c   oct 28 2008 jh  : file_open initial value of false was commented out,
c                     so it did not work on linux, rms gives wrong values
c                     on weekly files and linux, do not write out of larger
c                     then 5.0


c
       IMPLICIT NONE
c  ARRAY WITH ORIGINAL READINGS, only header here
      CHARACTER*80 DATA
      character*80 data1(10)   ! more lines
c-- TOP DIR FOR REA
      CHARACTER*40 TOP_DIRECTORY
c   length of top_directory
      integer topdirlen
      character*80 text,new_text
      character*5 base         ! data base to write to
c-- dir separator
      character*1 dchar
      CHARACTER*3 AGENCY
      integer id                ! id line number
      character*4 trms
      character*80 outfile
      logical file_open          ! true if outfile is open
      character*3 tmonth(12)     ! first 3 letters of month
      character*80 infile
      character*4  type          ! file type
      character*4  magaga1,magaga2 ! magnitude type and agency
      character*4  magaga3,magaga4 ! magnitude type and agency
      real mag1,mag2,mag3,mag4     ! magnitude
c---time of writing s-file
      character*12 p_time
      character*14 proc_time
c---operator id
      character*4 operator
C  NUMBER OF DIFFERENT STATIONS IN DATA
      INTEGER NSTAT
      INTEGER YEAR,MONTH,DAY,HOUR,MIN
      integer old_month            ! previous month
      REAL SEC
C  DECIMAL LATITUDE AND LONGITUDE
      REAL DLAT,DLON
C  DEPTH,  RMS OF RESIDUALS
      REAL DEPTH,RMS
      INTEGER IDEPTH
      integer nhead, nrecord
c magntudes
      character*3 ms,mb
      INTEGER I,nevent,l,k
      data tmonth/'JAN','FEB','MAR','APR','MAY','JUN',
     *            'JUL','AUG','SEP','OCT','NOV','DEC'/



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

C
c
c   get system time so time of update can be time stamped
c
      call systime(p_time,proc_time)


      nevent=0
c     file_open=.false.
      old_month=999
      call topdir(top_directory)
      topdirlen=index(top_directory,' ') -1
      call dir_char(dchar)
      write(6,*)' Input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old')

 6666    continue 
         WRITE(6,*)'OPERATOR ID (max 4 char):'
         READ(5,'(A4)') OPERATOR
c
         IF(OPERATOR.EQ.'    ') then
           write(6,*) ' You must give operator'
           goto 6666
         endif
c
c   find which type of file, monthly or weekly, have different format
c
      type='    '
      do i=1,80
        read(1,'(a)') text
c      enddo
      if(text(1:2).eq.'GS') then
         type='week'
         write(6,*)' Weekly file'
         write(6,*)' Enter to continue'
         read(5,'(a)') k
         goto 3333
      endif
      if(text(3:4).eq.'  '.and.
     *(text(24:24).eq.'N'.or.text(24:24).eq.'S')) then
         type='mont'
         write(6,*) ' Monthly file'
         write(6,*)' Enter to continue'
         read(5,'(a)') k
         goto 3333
      endif
      enddo
 3333 continue
c
      if(type.eq.'mont') then
c
c   find year and month
c
         rewind 1
c
c   find first header line
c
  20     continue
         read(1,'(a)') text
         if(text(1:3).ne.'DAY') goto 20
c
c   find line with year and month
c
 30      continue
         backspace 1
         backspace 1
         backspace 1
         backspace 1
         backspace 1
         read(1,'(a)') text
         if(text.eq.' ') goto 30
c
c  get rid of blanks
c
         do i=1,80
          if(text(i:i).ne.' ') goto 40
         enddo
40       continue
         k=0
         new_text=' '
         do l=i,80,2
           k=k+1
           new_text(k:k)=text(l:l)
         enddo
c        write(6,*) new_text
c
c  find year and month
c
         do i=1,80
           if(new_text(i:i).eq.' ') then
              read(new_text(i+1:i+4),'(i4)') year
              goto 45
           endif
          enddo
          write(6,*) 'Year and month ',year,month
 45       continue
c
c   find month
c
         do i=1,12
           if(tmonth(i).eq.new_text(1:3)) then
             month=i
             goto 2233
           endif
         enddo
         write(6,*)' Could not find a valid month'
         stop
 2233    continue
         write(6,*) 'Year and month ',year,month
      endif
      if(type.eq.'    ') then
         write(6,*)' Not a PDE type input file'
         stop
      endif
      rewind 1
c
c   reading loop
c
 50   continue 
      read(1,'(a)',end=99) text
      if(text(1:20).eq.'                    ') goto 50
      if(text(24:24).ne.'N'.and.text(24:24).ne.'S'.and.
     *text(26:26).ne.'N'.and.text(26:26).ne.'S') goto 50
      if(text(35:35).ne.'W'.and.text(35:35).ne.'E'.and.
     *text(33:33).ne.'W'.and.text(33:33).ne.'E') goto 50
      mag1=-10.0
      mag2=-10.0
      mag3=-10.0
      mag4=-10.0
      magaga1='    '
      magaga2='    '
      magaga3='    '
      magaga4='    '
      nevent=nevent+1
      if(type.eq.'mont') then
c        write(6,*) text(1:70)
         read(text(1:14),'(i2,2x,i2,1x,i2,1x,f4.1)') day,hour,min,sec
         read(text(17:22),'(f6.3)')dlat 
         read(text(27:33),'(f7.3)')dlon
         if(year.lt.2004) read(text(38:40),'(i3)') idepth
         if(year.ge.2004) read(text(37:39),'(i3)') idepth
         depth=idepth
         if(year.lt.2004) read(text(45:51),'(a3,1x,a3)')mb,ms
         if(year.ge.2004) read(text(44:50),'(a3,1x,a3)')mb,ms  ! changed dec7, 2005 , jh
         if(mb.ne.'   ') then
            read(mb,'(f3.1)') mag1
            magaga1='BPDE'
         endif
         if(ms.ne.'   ') then
            read(ms,'(f3.1)') mag2
            magaga2='SPDE'
         endif
         if(year.lt.2004) read(text(53:56),'(f4.1)') rms
         if(year.ge.2004) read(text(54:57),'(f4.1)') rms    ! change july 2005 jh
         if(year.lt.2004) read(text(62:66),'(i5)') nstat    
         if(year.ge.2004) read(text(63:67),'(i5)') nstat    ! change dec 7, 2005 jh
         if(text(24:24).eq.'S') dlat=-dlat
         if(text(35:35).eq.'W') dlon=-dlon
      else
         read(text(5:25),'(i4,4i2,f4.2,f5.3)')
     *   year,month,day,hour,min,sec,dlat
c
c   check if a new month
c
         if(month.ne.old_month) then
            file_open=.false.
            old_month=month
         endif
         read(text(27:32),'(f6.3)') dlon
         mb(1:2)=text(48:49)
         ms(1:2)=text(52:53)
         if(mb(1:2).ne.' ') then
            read(mb(1:2),'(f2.1)') mag1
            magaga1='BPDE'
         endif
         if(ms(1:2).ne.' ') then
            read(ms(1:2),'(f2.1)') mag2
            magaga2='SPDE'
         endif
         read(text(34:37),'(f4.1)') depth
         if(text(26:26).eq.'S') dlat=-dlat
         if(text(33:33).eq.'W') dlon=-dlon
         if(text(57:59).ne.'   ') then
            read(text(57:59),'(f3.2)') mag3
            magaga3=text(61:64)
            if(magaga3(1:1).eq.'D') magaga3(1:1)='C'
         endif
         if(text(67:69).ne.'   ') then
            read(text(67:69),'(f3.2)') mag4
            magaga4=text(71:74)
            if(magaga4(1:1).eq.'D') magaga4(1:1)='C'
         endif
         read(text(41:43),'(i3)') nstat
      endif
C
         do i=1,80
           data(i:i)=' '
         enddo
         agency='PDE'
         WRITE(DATA(2:20),'(I4,1X,2I2,1X,2I2,1X,F4.1)')
     *   YEAR,MONTH,DAY,HOUR,MIN,SEC
         trms='    '
         if(rms.gt.0.0.and.rms.lt.5.0)write(trms,'(f4.1)') rms ! jh oct 08
         if(nstat.gt.999) nstat=999
         WRITE(DATA(46:55),'(A3,I3,a4)') AGENCY,NSTAT,TRMS
         WRITE(DATA(24:43),'(F7.3,F8.3,F5.1)') DLAT,DLON,DEPTH
c
c   reshuffel magnitudes
c
         if(mag3.gt.-9.9) then
            if(mag1.eq.-10.0) then
               mag1=mag3
               magaga1=magaga3
               mag3=-10.0
            elseif(mag2.eq.-10.0) then
               mag2=mag3
               magaga2=magaga3
               mag3=-10.0
            endif
         endif
         if(mag4.gt.-10.0) then
            if(mag1.eq.-10.0) then
               mag1=mag4
               magaga1=magaga4
               mag4=-10.0
            elseif(mag2.eq.-10.0) then
               mag2=mag4
               magaga2=magaga4
               mag4=-10.0
            elseif(mag3.eq.-10.0) then
               mag3=mag4
               magaga3=magaga4
               mag4=-10.0
            endif
         endif
      if(mag1.gt.-9.0) write(data(57:63),'(f3.1,a4)')mag1,magaga1 
      if(mag2.gt.-9.0) write(data(65:71),'(f3.1,a4)')mag2,magaga2 
      if(mag3.gt.-9.0) write(data(73:79),'(f3.1,a4)')mag3,magaga3 
c
c   open file if not already open
c
      if(.not.file_open) then
         write(outfile,'(i4,i2)') year,month
         do i=1,6
           if(outfile(i:i).eq.' ') outfile(i:i)='0'
         enddo
         outfile(7:10)='.CAT'
c
c   set path to where PDE is, if a weekly file, append to a possible older file
c

         write(6,*)'Open file for year and month', year,month
         if(type.eq.'week') then
          open(2,file=top_directory
     *    (1:topdirlen)//dchar//'REA'//dchar//'PDEWE'//dchar//'CAT'
     *    //dchar//outfile,
     *    status='unknown',access='append')
          base='PDEWE'
         else
          open(2,file=top_directory
     *    (1:topdirlen)//dchar//'REA'//dchar//'PDE__'//dchar//'CAT'
     *    //dchar//outfile,
     *    status='unknown')
          base='PDE__'
         endif

         file_open=.true.
      endif
c
c   set event type to distant
c
      data(22:22)='D'
      write(2,'(a)') data
c
c   put in line type
c
      data(80:80)='1'
c
c   put in s-file
c
       data1(1)=data
       data1(2)=' '
       nhead=1
       nrecord=2
       id=0         ! no id line

       call write_sfile
     *(data1,base,proc_time,operator,nhead,nrecord,id)

      goto 50
99    continue
      write(6,*)
      write(6,*)' Number of events converted', nevent
      write(6,'(1x,a,a)') 'Output file name ',outfile
      stop
      end 



      subroutine write_sfile
     *(data,base,proc_time,operator,nhead,nrecord,id)
c
c  routine runs the split function on one event in seisan data base base.
c  data in data
c  only one event is written out. 
c  proc_time and operator as in program update.
c  special for this version is that the file name and id is always taken
c  from the origin time since it is used in connection with update.
c
c
       implicit none

C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'seidim.inc'
       include 'libsei.inc'                ! Open file definitions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c-- OUTPUT FILE NAME                                   
      CHARACTER*80 OUTFL
      integer nf            ! length of file name
c-- EVENT TYPE, L,R OR D                              
      CHARACTER*1  EVTYPE			
c-- idline
      character*80 idline
c-- TOP DIR FOR REA               
      CHARACTER*40 TOP_DIRECTORY                
c-- dir separator
      character*1 dchar
C-- SYSTEM TIME FOR USED FOR TIME OF OPERATION
      character*14 proc_time 
C-- OPERATOR ID
      CHARACTER*4 OPERATOR
c-- HELP FORMAT LINE 0: NO, 1: YES               
      INTEGER FORMAT_INDICATOR			
c-- RECORDS IN FILE                                
      CHARACTER*80 DATA(*)			
c-- DATES AND TIMES                             
      INTEGER century,YEAR,MONTH		        
     *,DAY,HR,MIN,ISEC                                                          
c-- SECONDS                                                    
      REAL SEC					
      character*1 answer
c-- INDICATOR FOR USE OF DATA BASE                      
      CHARACTER*5 BASE				
c-- NUMBER OF RECORDS FOR EVENT                          
      INTEGER NRECORD				
c-- NUMBER OF HEADERS FOR EVENT                            
      INTEGER NHEAD				
C-- ID LINE NUMBER
      INTEGER ID
c-- TIME IN SEC SINCE 1900 EVENT                    
      DOUBLE PRECISION TIME			
c-- MINIMUM TIME --------------   
      DOUBLE PRECISION MIN_TIME                 
c-- DAY OF YEAR, NOT USED                                    
      INTEGER DOY				
c-- COUNTER                                                  
      INTEGER I,K	
c   length of top_directory
      integer topdirlen
c  agency
      character*3 agency
      character*80 sfil    ! name of sfile returned
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c write unit #1
       integer          write01
c file name
       character*80     chr_file
C                                                                               
C    SET DEFAULTS AND INITIAL PARAMETERS                                        
C
      call topdir(top_directory)
      call get_def_base(agency)
      topdirlen=index(top_directory,' ') -1
      call dir_char(dchar)
      b_f_debug$=.false.                  ! file debugging

C                                                                               
C   CHECK IF FORMAT EXPLANATORY LINE IN FILE                        
C                                                                               
      FORMAT_INDICATOR=0                                                        
      DO K=1,NHEAD                                                              
         IF(DATA(K)(80:80).EQ.'7') FORMAT_INDICATOR=1                           
      ENDDO                                                                     
C                                                                               
C   GET ABS TIME FOR  EVENT, READ YEAR,MONTH AND DAY FROM HEADER,               
C   HR, MIN AND SEC FROM EARLIEST STATION IF NOT GIVEN IN HEADER
C                                                                               
      READ(DATA(1),'(1X,2I2,1X,2I2,1X,2I2,1X,F4.1)')                             
     *CENTURY,YEAR,MONTH,DAY,HR,MIN,SEC
C
C   ASSUME 1900 IF NO CENTURY GIVEN
C
      IF(CENTURY.EQ.0) CENTURY=19
      year=century*100+year                                                               
      evtype=data(1)(22:22)
C                                                                               
C   CHECK IF HR AND MIN IN HEADER                                               
C                                                                               
c-- FIND EARLIEST TIME if phase records available                  
      IF(DATA(1)(12:15).EQ.'    '.and.(nrecord-1).gt.nhead) THEN		
         MIN_TIME=10E20                                                         
         DO I=NHEAD+1,NRECORD-1                                                 
            READ(DATA(I),'(18X,2I2,1X,F5.1)') HR,MIN,SEC                        
c-- ABS TIME              
            CALL TIMSEC(YEAR,MONTH,DAY,HR,MIN,SEC,TIME)	
            IF(TIME.LT.MIN_TIME) MIN_TIME=TIME                                  
         ENDDO                                                                  
         CALL SECTIM(MIN_TIME,YEAR,DOY,MONTH,DAY,HR,MIN,SEC)                    
c--  EARLIEST TIME  
         WRITE(DATA(1)(1:20),'(1X,I4,1X,2I2,1X,2I2,1X,F4.1)') 
     *   YEAR,MONTH,DAY,HR,MIN,SEC                   
         DATA(1)(80:80)='1'
      ENDIF                                                                     
c
C                                                                               
C  GENERATE OUTPUT FILE NAME                                                    
C     
      ISEC=SEC      
C
      IF(BASE.NE.'     '.and.base(1:2).ne.',,') THEN
         WRITE                                                                  
     *   (OUTFL,307)BASE,YEAR,MONTH,DAY,HR,MIN,ISEC,EVTYPE,YEAR,MONTH           
 307     FORMAT(
     *   '/',A5,'/',I4,'/',I2,'/',I2,'-',2i2,'-',i2,a1,'.S',i4,I2)               
C
         DO I=1,34                                                              
            IF(OUTFL(I:I).EQ.' ') OUTFL(I:I)='0'                                
         ENDDO   
         nf=34                                                               
      ELSE                                                                      
         WRITE(OUTFL,303)DAY,HR,MIN,ISEC,EVTYPE,'S',YEAR,MONTH                      
 303     FORMAT(I2,'-',2i2,'-',i2,a1,'.',a1,i4,I2)                                  
         DO I=1,19                                                                 
            IF(OUTFL(I:I).EQ.' ') OUTFL(I:I)='0'                                   
         ENDDO
         nf=19          
      ENDIF
c
c   make id line if not there, else update current id line
c
      if(id.ne.0) idline=data(id)
      if(id.eq.0) THEN
         idline(1:40)= ' ACTION:                   OP:     STATU'
         idline(41:80)='S:               ID:                   I'
         WRITE(IDLINE(31:34),'(A)')OPERATOR
         WRITE(IDLINE(13:26),'(A)')PROC_TIME
         WRITE(IDLINE(9:11),'(A)')'SPL' 
      endif
c
c  update id line
c
      WRITE(IDLINE(61:75),'(i4,5I2)')
     *YEAR,MONTH,DAY,HR,MIN,ISEC
      DO I=61,74
         IF(IDLINE(I:I).EQ.' ') IDLINE(I:I)='0'
      ENDDO
C                                                                               
C  OPEN AND WRITE OUTPUT FILE                                                   
C
 3    continue                 ! get here from below when file did exist
      IF(BASE(1:2).NE.',,') THEN                                                    
         chr_file=' '
         chr_file = top_directory(1:topdirlen)//dchar//'REA'//
     *   outfl(1:nf)
c        write(6,*) chr_file
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    chr_file,              ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
            sfil=chr_file
      ELSE
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    outfl,                 ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
            sfil=outfl
      ENDIF
      write(6,'(a)') data(1)(1:78)
      
c
c   make new index
c
      if(b_old) then
          write(6,*)' Creating a new id for event'
          write(6,*)' Please confirm (y/n)'
          read(5,'(a)') answer
          if(answer.eq.'y') then
             call inc_id(idline,outfl,nf)
             call sei close (close$,write01,code) ! close
             goto 3                            ! go and try to open again
          endif
      endif
c
  10  continue 
C
C   WRITE FILE
C                                  

C                                                                     
c-- ORIGINAL HEADER LINES FIRST
C   IF NO ID LINE, PUT IN AS NUMBER 2
C
          write(write01,'(a80)',iostat=code) data(1)
          call sei code(fort$,code,write01,b_eof)
c
c  if new id line, write as #2, else where it was before
c
      if(id.eq.0) then
          write(write01,'(a80)',iostat=code) idline
          call sei code(fort$,code,write01,b_eof)
      else
         data(id)=idline
      endif
c
c   write rest of header lines, skip format help lines
c
      if(nhead.ge.2) then
	     do i=2,nhead 
            if(data(i)(80:80).ne.'7') then
               write(write01,'(a80)',iostat=code) data(i)
            endif
	     enddo
      endif
      call sei code(fort$,code,write01,b_eof)
C
c-- write help line 
C
      write(write01,243,iostat=code)
      call sei code(fort$,code,write01,b_eof)
 243  FORMAT(
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO ',
c     *'SNR AR TRES W  DIS CAZ7')              
     *'AIN AR TRES W  DIS CAZ7')              
c-- WRITE REST OF EVENT         
       write(write01,'(a80)',iostat=code)
     * (data(i),i=nhead+1,nrecord)
      call sei code(fort$,code,write01,b_eof)
      call sei close (close$,write01,code)
c
 2    continue
      return                                                                      
      END                                                                       
                                                                                

	function lgstr(str)
c-----
c	function to find the length of a string
c	this will only be used with file system path names
c	thus the first blank 
c	indicates the end of the string
c-----
	implicit none
	character*(*) str
	integer*4 lgstr
	integer n, i
	n = len(str)
	lgstr = 1
	do 1000 i=n,1,-1
		lgstr = i
		if(str(i:i).ne.' ')goto 100
 1000	continue
  100   continue
        return
	end

c$debug
c
c    program to enter CRISIS parameters and put in CRISIS paramter files
c    program reads a CRISIS parameter file, optionally edits it
c    and writes out a new
c
c    jh jan 95
c    mar 24 95 by jh: fix bugs
c    jun 12         : --------
c
      implicit none
      character*40 text(100)     ! description of parameters
      character*80 title         ! general title of each parameter set
      real par(200)              ! parameters
      character*60 par_text(200) ! pameters as text, e.g files
      character*80 file_att      ! file name, attenuation input file
      character*80 file_cri      ! file name, crisis input
	  character*80 outfile       ! ----------------  output
      real tx                    ! value used as flag if parameter is text
      integer npar               ! number of parameters
      integer choise             ! choise of parameter set to enter
      integer natt_model_file    ! number of attenuation models in file
      integer natt_model
      integer nordinate_file     ! number of ordinates ----------------
      integer nordinate
	  character*1 answer
      integer nregion_file       ! number of regions in file
      integer nregion
      integer out                ! 0 not output, 1: output
      integer k,i
      logical finish
      common tx,title,finish
      tx=-9999.9
	  out=1                      ! assume output initially
      finish=.false.             ! assume all sets changed
c
 1    continue
      write(6,'(a,$)')' Set parameters for CRIATT (1) or CRISIS (2): '
      read(5,*,err=1) choise
      if(choise.ne.1.and.choise.ne.2) then
        write(6,*)' Wrong input'
        goto 1
      endif
c
      if(choise.eq.2) goto 1000
c
c   set defaults and text for criatt
c
      call set_att(text,par,npar)
      write(6,*) 
     *' Enter filename for input attenuation file, return for no file'
      read(5,'(a)') file_att
      if(file_att(1:5).ne.'     ') then      
         call read_att(file_att,par,npar)
      endif
c
c  edit parameters
c
      call get_par(npar,text,par,par_text)
c
c   write attenuation pars
c
      call write_att(file_att,par,npar)
c
      stop
c
c---------------------------------------------------------------------
c  section crisis
c---------------------------------------------------------------------
c
 1000 continue
c
c   set defs for 1. parameter set
c
      call set_cri1(text,par,npar,par_text)
c
      write(6,*) 
     *' Enter filename for CRISIS input file, return for no file'
      read(5,'(a)') file_cri
      if(file_cri(1:5).ne.'     ') then      
         call read_cri1(file_cri,par,npar,par_text)
c
c   save number of models and number of ordinates in original file, 
c   might change
c        
         natt_model_file=int(par(3))
         nordinate_file=int(par(4))
         nregion_file=int(par(2))
      endif
c
 5    continue
      write(6,*)' File name for output CRISIS parameter file,',
     *' return for no output'
      read(5,'(a)') outfile
      if(outfile(1:3).eq.'   ') then
         out=0
		 goto 20
      endif
      open(2,file=outfile,status='new',err=10)
	  goto 20
 10   continue
      write(6,*)' File already exists, overwrite(y/n)'
      read(5,'(a)') answer
      if(answer.eq.'y'.or.answer.eq.'Y') then
          open(2,file=outfile,status='unknown')
      else
          goto 5
      endif
 20   continue

c
c   edit parameters
c
      call get_par(npar,text,par,par_text)
c
c   check some of the parameters
c
      if(par(3).lt.1)  par(3)=1
      if(par(4).lt.1)  par(4)=1
      if(par(2).lt.1)  par(2)=1
      natt_model=int(par(3))
      nordinate=int(par(4))
      nregion=int(par(2))
c
c  write out
c
      call write_cri1(par,npar,par_text,out)
c      
c   one or several sets of spectral ordinates, the last entered value counts
c
      do k=1,nordinate
c
c   set defs for ordinates
c
         call set_cri2(text,par,npar,par_text)
         write(title(59:60),'(i2)') k           ! indicate which set
c
c   read from file which could contain more or less sets than
c   now wanted, if more, they are lost
c
         if(file_cri(1:5).ne.'     ') then      
            if(k.le.nordinate_file) 
     *      call read_cri2(file_cri,par,npar)
         endif
c
c   edit parameters
c
         call get_par(npar,text,par,par_text)
         call write_cri2(par,npar,out)
      enddo
c
c   if there were more parameter sets in file than now desired, read them
c
      if(nordinate_file.gt.nordinate) then
         do i=nordinate,nordinate_file-1
            call read_cri2(file_cri,par,npar)
         enddo
      endif
c
c   continue with more crisis parameters
c
c
c   set defs for 3. parameter set
c
      call set_cri3(text,par,npar,par_text)
c
      if(file_cri(1:5).ne.'     ') then      
         call read_cri3(file_cri,par,npar)
      endif
c
c   edit parameters
c
      call get_par(npar,text,par,par_text)
      call write_cri3(par,npar,out)
c
c   attenuation files
c
      npar=natt_model
      call set_cri_att(text,par,npar,par_text)
      if(file_cri(1:5).ne.'     ') then
         do i=1,natt_model_file
            read(7,'(a)') par_text(i)
         enddo
      endif
      call get_par(npar,text,par,par_text)
      if(out.ne.0) write(2,'(a)')(par_text(i),i=1,npar)
c
c--------------------------------------------------------------------
c   set defs for  parameters for each region 
c---------------------------------------------------------------------
c
      do k=1,nregion

         call set_cri4(text,par,npar,par_text)
         write(title(59:60),'(i2)') k
c
c   read from file which could contain more or less sets than
c   now wanted, if more, they are lost and will no tbe read.
c
         if(file_cri(1:5).ne.'     ') then      
            if(k.le.nregion_file) 
     *      call read_cri4(file_cri,par,npar,par_text)
         endif
c
c   edit parameters
c
         call get_par(npar,text,par,par_text)
         call write_cri4(par,npar,par_text,out)
c
c   set defs for model types, two possible
c
         if(par(2).eq.1) then
            call set_cri_poi(text,par,npar)
         else
            call set_cri_cha(text,par,npar)
         endif
         write(title(59:60),'(i2)') k
c
         if(file_cri(1:5).ne.'     ') then      
            if(k.le.nregion_file)
     *      call read_cri5(file_cri,par,npar)
         endif
c
c   edit parameters
c
          call get_par(npar,text,par,par_text)
          call write_cri5(par,npar,out)
      enddo
      close(2)      
      stop
      end
c
c
      subroutine get_par(npar,text,par,par_text)
c
c   get parameters
c
c     npar:   number of parameters
c     text:   text of parameter
c     par:    the parameter
c
c     
      implicit none
      real par(*)
      character*60 par_text(*)
      character*40 text(*)
      character*80 title
      character*80 chr_string   ! input for paramter #
      real sei real num         ! function to get real number from string
      integer code              ! errro code for ------
      real tx
      integer npar
      logical finish
      integer i,k,k1,k2,iscreen,nscreen
      common tx,title,finish
c
c   if no change, return
c
      if(finish) return
c
c   find number of screens needed to show all
c
      nscreen=npar/18+1
      iscreen=1
      k1=-17
c
  1   continue
c
c   start loop to enter parameters
c
      k1=k1+18
      k2=k1+17
      if(k2.gt.npar) k2=npar

  5   continue
c
c   write general title
c
      write(6,*)
      write(6,'(1x,a)') title
      write(6,*)
      do k=k1,k2
        if(par(k).eq.tx) then    ! a text entry
           write(6,'(1x,i2,2x,a,a)') k,text(k)(1:20),par_text(k)
        else
           write(6,'(1x,i2,2x,a,a,f9.3)') 
     *     k,text(k),' Value is: ',par(k)
        endif
      enddo
      write(6,*)
 10   continue
      write(6,'(a,a,$)')
     *'Parameter number to change, x to exit, return',
     *' for next parameter set '
      read(5,'(a)',err=10) chr_string
      if(chr_string(1:1).eq.'x'.or.chr_string(1:1).eq.'X') then
         finish=.true.
         return
      endif
      if(chr_string(1:2).eq.'  ') goto 30
      i=int(sei real num(chr_string,code)) 
      if(i.gt.k2) then
         write(6,*)' Number too large'
         goto 5
      endif
      if(i.lt.k1) then
         write(6,*)' Number too small'
         goto 5
      endif
 20   continue
      if(par(i).eq.tx) then
         write(6,'(a,a,a)')' Give a new value for ',text(i),'  '
         read(5,'(a)') par_text(i)
      else
         write(6,'(a,a,a$)')' Give a new value for ',text(i),'  '
         read(5,*,err=20) par(i)
      endif
      goto 5
c
 30   continue
      iscreen=iscreen+1
      if(iscreen.le.nscreen) goto 1         ! another screen
c
c  
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine set_att(text,par,npar)
c
c   set values for attenuation
c
      implicit none
      character*40 text(*)
      integer npar
      real tx
      character*80 title
      real par(*)
      call blank
      title='Attenuation model parameters'
c
      text(1)= 'source model type (1=omega**2)          '
      par(1)=1
      text(2)= 'stress drop (bars)                      '
      par(2)=100.0
      text(3)= 'attenuation Q0                          '
      par(3)=500.0
      text(4)= 'epsilon (Q = Q0 * f exp(epsilon))       '
      par(4)=1.0
      text(5)= 'shear wave velocity (cm/sec)            '
      par(5)=3.5
      text(6)= 'density (g/cm*cm)                       '
      par(6)=2.7
      text(7)= 'high frequency decay factor (Kappa0)    '
      par(7)=0.025
      text(8)= 'high frequency decay factor (Kappa1)    '
      par(8)=0
      text(9)= 'moment magnitude (Mw)                   '
      par(9)=4.0
      text(10)='minimum site to source distance (km)    '
      par(10)=20.0
      text(11)='site factor g(f)                        '
      par(11)=2.0
      text(12)='duration coefficient (td)               '
      par(12)=0.05
      text(13)='minimum distance, Rmin (km)             '
      par(13)=10.0
      text(14)='maximum distance, Rmax (km)             '
      par(14)=600
      text(15)='minimum magnitude, Mmin                 '
      par(15)=4.0
      text(16)='maximum magnitude, Mmax                 '
      par(16)= 7.0
      text(17)='minimum structural period (sec)         '
      par(17)=0.005
      text(18)='maximum structural period (sec)         '
      par(18)=2.5
      text(19)='number of points between Rmin and Rmax  '
      par(19)=10
      text(20)='number of points between Mmin and Mmax  '
      par(20)=10
      text(21)='number of structural periods eq.sp.per  '
      par(21)=1
      text(22)='st. dev. of the structural periods (n)  '
      par(22)=0.7
      text(23)='st. dev. of the structural periods (n+1)'
      par(23)=0.7
      npar=23

c
      return
      end
c
c     
      subroutine read_att(file_att,par,npar)
c
c read attenuation file
c
      implicit none
      real par(*)
      character*80 file_att
      integer npar,i
c
c  assume npar is 23
c
      npar=23
      open(1,file=file_att,status='old',err=20)
      goto 19
 20   continue
      write(6,*)' No such file'
      stop
 19   continue
c
      read(1,*,err= 1) (par(i),i=1,npar)
      close(1)
      goto 2
 1    continue
      write(6,*)' Something wrong with attenuation file'
      stop
 2    continue
      return
      end
c
      subroutine write_att(file_att,par,npar)
c
c write attenuation file
c
      implicit none
      real par(*)
      character*80 outfile
	  character*1 answer
      character*80 file_att
      integer npar,i
c
 5    continue
      write(6,*)' File name for output attenuation file,',
     *' return for no output'
      read(5,'(a)') outfile
	  if(outfile(1:2).eq.' ') stop
      open(1,file=outfile,status='new',err=10)
      goto 20
 10   continue
      write(6,*)' File already exists, overwrite(y/n)'
      read(5,'(a)') answer
      if(answer.eq.'y'.or.answer.eq.'Y') then
          open(1,file=outfile,status='unknown')
      else
          goto 5
      endif
 20   continue
c
      write(1,'(i8)') int(par(1))
      write(1,'(10f8.3)') (par(i),i=2,11)
      write(1,'(f8.3)') par(12)
      write(1,'(6f8.3)') (par(i),i=13,18)
      write(1,'(3i8)') (int(par(i)),i=19,21)
      write(1,'(2f8.3)') par(22),par(23)
      close(1)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc	  
      subroutine write_cri1(par,npar,par_text,out)
c
c read attenuation file
c
      implicit none
      real par(*)
      character*80 outfile
	  character*1 answer
      character*80 file_att
      character*60 par_text(*)
      integer npar,i,out
	  if(out.eq.0) return
c      out=1                        ! normally write out, if 0 no
c
c
      write(2,'(a)') par_text(1)
      write(2,'(5i5)') (int(par(i)),i=2,6)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine write_cri2(par,npar,out)
c
c
      implicit none
      real par(*)
      integer npar,i,out
      if(out.eq.0) return
c
      write(2,'(3f8.1,2f8.3)') (par(i),i=1,5)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine write_cri3(par,npar,out)
c
c 
c
      implicit none
      real par(*)
      integer npar,i,out
      if(out.eq.0) return
c
      write(2,'(2f8.3,f8.1,4f8.3)') (par(i),i=1,7)
      write(2,'(4f8.3,2i8)')
     *(par(i),i=8,11),(int(par(i)),i=12,13)
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine write_cri4(par,npar,par_text,out)
c
c 
c
      implicit none
      real par(*)
      character*60 par_text(*)
      integer npar,i,out
      if(out.eq.0) return
      write(2,'(a)') par_text(1)
      write(2,'(4i5)') (int(par(i)),i=2,5)
      write(2,'(6f8.2)') (par(i),i=6,11)
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine write_cri5(par,npar,out)
c
c 
c
      implicit none
      real par(*)
      integer npar,i,out
      if(out.eq.0) return
c
      write(2,'(9f8.3)') ((par(i)),i=1,9)
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine set_cri1(text,par,npar,par_text)
c
c   set values for crisis, first 5 parameters and title
c
      implicit none
      character*40 text(*)
      character*80 title
      character*60 par_text(*)
      integer npar
      real tx
      real par(*)
      common tx,title
      call blank
c
      title(1:44)=
     *'Crisis parameters: Title and first 5 global parameters'
      text(1)= 'general title                           '
      par_text(1)='Seismic hazard of Africa'
      par(1)=tx           
      text(2)='# of earthquake source zones             '
      par(2)=2
      text(3)='# of attenuation models (i.e. tables)    '
      par(3)=1
      text(4)='# of spectral ordinates to be computed   '
      par(4)=2
      text(5)='# of levels of intensity (e.g. for PGA)  '
      par(5)=10
      text(6)='# of mag.intervals for re-interpolation  '
      par(6)=10
      npar=6
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine set_cri2(text,par,npar,par_text)
c
c   set values for crisis, spectral oridinate parameters
c
      implicit none
      character*40 text(*)
      character*60 par_text(*)
      character*80 title
      integer npar
      real tx
      real par(*)
      common tx,title
c
      call blank
      title(1:47)='Crisis parameters: Spectral ordinates for set #'
      text(1)='structural period (in sec)              '
      par(1)=0.0
      text(2)='min. intensity level (e.g.for PGA)      '
      par(2)=20
      text(3)='max. intensity level                    '
      par(3)=3500
      text(4)='median of Z (for hazard it must be 1)   '
      par(4)=1
      text(5)='st.dev.of Z (must be ca.zero if MZ is 1)'
      par(5)=0.001
      npar=5
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine set_cri3(text,par,npar,par_text)
c
c   set values for crisis, global parameters
c
      implicit none
      character*40 text(*)
      character*80 title
      character*60 par_text(*)
      integer npar
      real tx
      real par(*)
      common tx,title
      call blank
      title(1:36)='Crisis parameters: Global parameters'
      text(1)='discount rate (per year)                '
      par(1)=0.05
      text(2)='magnitude interval used in integrals    '
      par(2)=0.1
      text(3)='max. distance for hazard computation(km)'
      par(3)=2500.0
      text(4)='COEFK cost parameter,not used for hazard'
      par(4)=2.8
      text(5)='COEFA:cost parameter,not used for hazard'
      par(5)=1.2
      text(5)='COEFU:cost parameter,not used for hazard'
      par(6)=0
      text(7)='COEFQ:cost par. (must be zero if hazard)'
      par(7)=0
      text(8)='latitude of the grid origin             '
      par(8)=-15.0
      text(9)='longitude of the grid origin            '
      par(9)=26.0
      text(10)='latitude increment                      '
      par(10)=2.0
      text(11)='longitude increment                     '
      par(11)=2.0
      text(12)='# of grids in latitude                  '
      par(12)=8
      text(13)='# of grids in longitude                 '
      par(13)=9
      npar=13
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine set_cri_att(text,par,npar,par_text)
      implicit none
      character*40 text(*)
      character*80 title
      integer npar
      real tx
      real par(*)
      character*60 par_text(*)
      common tx,title
      call blank

      title(1:45)=
     *'Crisis parameters: Names of attenuation files'
      text(1)='1. attenuation file                     '
      par(1)=tx
      par_text(1)='atten.001'

      text(2)='2. attenuation file                     '
      par(2)=tx
      par_text(2)='atten.002'

      text(3)='3. attenuation file                     '
      par(3)=tx
      par_text(3)='atten.003'

      text(4)='4. attenuation file                     '
      par(4)=tx
      par_text(4)='atten.004'

      text(5)='5. attenuation file                     '
      par(5)=tx
      par_text(5)='atten.005'

      text(6)='6. attenuation file                     '
      par(6)=tx
      par_text(6)='atten.006'

      text(7)='7. attenuation file                     '
      par(7)=tx
      par_text(7)='atten.007'

      text(8)='8. attenuation file                     '
      par(8)=tx
      par_text(8)='atten.008'

      text(9)='9. attenuation file                     '
      par(9)=tx
      par_text(9)='atten.009'
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine set_cri4(text,par,npar,par_text)
c
c   set values for crisis, grid points
c
      implicit none
      character*40 text(*)
      character*80 title
      integer npar
      real tx
      real par(*)
      character*60 par_text(*)
      common tx,title
      call blank
      title(1:54)=
     *'Crisis parameters: Data defining seimicity in region #'
      text(1)='title of region                         '
      par(1)=tx
      par_text(1)='title of region'
      text(2)='flag, 1: Poisson, 2: characteristic eq. '
      par(2)=1
      text(3)='flag for intermediate results,0:no 1:yes'
      par(3)=0
      text(4)='attenuation model # for this source      '
      par(4)=1
      text(5)='# of cells to subdivide source (max.3x3) '
      par(5)=3
      text(6)='latitude of the source centre point      '
      par(6)=-6.0
      text(7)='longitude of the source centre point     '
      par(7)=30.0
      text(8)='source size in latitude (in degrees)     '
      par(8)=4.0
      text(9)='source size in longitude (in degrees)    '
      par(9)=1.0
      text(10)='depth of the source (in km)             '
      par(10)=10.0
      par(11)=0.0
      text(11)='source inclination angle (deg)          '
      par(10)=0.0
      npar=11
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine set_cri_poi(text,par,npar)
c
c   set values for crisis, grid points
c
      implicit none
      character*40 text(*)
      character*80 title
      integer npar
      real tx
      real par(*)
      common tx,title
      call blank
      title(1:54)=
     *'Crisis parameters: Poisson model for region #             '
      text(1)='# of earthq. > treshold magnitude       '
      par(1)=100
      text(2)='catalogue time span (in years)          '
      par(2)=100
      text(3)='beta (ln10 * b-value)                   '
      par(3)=2.3
      text(4)='coefficient of variation for beta       '
      par(4)=0.0
      text(5)='# of probability concentrations (max.5) '
      par(5)=1.0
      text(6)='maximum expected magnitude              '
      par(6)= 7.0
      text(7)='st.dev. of maximum expected magnitude   '
      par(7)=0.2
      text(8)='maximum observed magnitude              '
      par(8)=6.5
      text(9)='threshold magnitude                     '
      par(9)=4.0
      npar=9
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine set_cri_cha(text,par,npar)
c
c   set values for crisis, grid points
c
      implicit none
      character*40 text(*)
      character*80 title
      integer npar
      real tx
      real par(*)
      common tx,title
      call blank
      title(1:54)=
     *'Crisis parameters: Characteristic earthq.model for region  #'
      text(1)='return period of char.eq. (CE) (median) '
      par(1)=30
      text(2)='st.dev. of natural log of above         '
      par(2)=0.3
      text(3)='time elapsed since last occurence of CE '
      par(3)=15
      text(4)='maximum time in integration             '
      par(4)=99
      text(5)='slip predictable model parameter 1      '
      par(5)=5.36
      text(6)='slip predictable model parameter 2      '
      par(6)= 0.621
      text(7)='st.dev. of the magnitude of CE          '
      par(7)=0.3
      text(8)='minimum possible magnitude for CE       '
      par(8)=7.0
      text(9)='maximum possible magnitude for CE       '
      par(9)=8.5
      npar=9
      return
      end
c
      subroutine read_cri1(file_cri,par,npar,par_text)
c
c read file
c
      implicit none
      real par(*)
      character*60 par_text(*)
      real tx
      character*80 file_cri,title
      integer npar,i
      common tx,title

c
      open(7,file=file_cri,status='old',err=20)
      goto 19
 20   continue
      write(6,*)' No such file'
      stop
 19   continue
c
      read(7,'(a)') par_text(1)
      par(1)=tx   ! indicate text
      read(7,*,err=30)(par(i),i=2,6)
      goto 40
  30  continue
      write(6,*)' Something wrong with CRISIS input file'
      stop
  40  continue
      npar=6
      return
      end
c
      subroutine read_cri2(file_cri,par,npar)
c
c read file
c
      implicit none
      real par(*)
      real tx
      character*80 file_cri,title
      integer npar,i
      common tx,title
c
c   assume file opened in read_cri1
c
c
      read(7,'(5f8.3)',err=30)(par(i),i=1,5)
      goto 40
  30  continue
      write(6,*)' Something wrong with CRISIS input file'
      stop
  40  continue
      npar=5
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine read_cri3(file_cri,par,npar)
c
c read file
c
      implicit none
      real par(*)
      real tx
      character*80 file_cri,title
      integer npar,i,i2,i3
      common tx,title
c
c   assume file opened in read_cri1
c
c
      read(7,'(7f8.3)',err=30)(par(i),i=1,7)
      read(7,'(4f8.3,2i8)',err=30)(par(i),i=8,11),i2,i3
      par(12)=i2
      par(13)=i3 
      goto 40
  30  continue
      write(6,*)' Something wrong with CRISIS input file'
      stop
  40  continue
      npar=13
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine read_cri4(file_cri,par,npar,par_text)
c
c read file
c
      implicit none
      real par(*)
      character*60 par_text(*)
      real tx
      character*80 file_cri,title
      integer npar,i
      common tx,title
c
c   assume file opened in read_cri1
c
c
      read(7,'(a)') par_text(1)
      par(1)=tx
      read(7,*,err=30)(par(i),i=2,5)
      read(7,'(6f8.2)',err=30)(par(i),i=6,11)
      goto 40
  30  continue
      write(6,*)' Something wrong with CRISIS input file'
      stop
  40  continue
      npar=11
      return
      end
c
      subroutine read_cri5(file_cri,par,npar)
c
c read file
c
      implicit none
      real par(*)
      real tx
      character*80 file_cri,title
      integer npar,i
      common tx,title
c
c   assume file opened in read_cri1
c
c
      read(7,'(9f8.3)',err=30)(par(i),i=1,9)
      goto 40
  30  continue
      write(6,*)' Something wrong with CRISIS input file'
      stop
  40  continue
      npar=9
      return
      end

      subroutine blank
      real tx
      character*80 title
      common tx,title
      do i=1,80
        title(i:i)=' '
      enddo
      return
      end

c     program rhwvinta
c
c  may 99 by jh --------------- version 7.0 check --------------
c               include numarg and mchdep70
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME VI                                                      c
c                                                                     c
c      PROGRAM: RHWVINTA                                              c
c                                                                     c
c      COPYRIGHT 1985 R. B. Herrmann                                  c
c                                                                     c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      parameter (LER=0,LIN=5,LOT=6)
      parameter(NL=100)
      common/c/cmax,c1,c2,cmin 
      common/model/d(NL),a(NL),b(NL),rho(NL),mmax,qa(NL),qb(NL) 
      common/jout/jsrc(10) 
      dimension ar(10),ai(10) 
      common/virt/ data(10,2) 
      character*4 icchar(11) 
      character*50 names 
c-----rhwvinta rearranges the hspec8 jsrc mapping 
      dimension lsrc(10) 
      data lsrc/1,2,3,4,9,5,6,10,7,8/ 
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c-----
c     call machine dependent initialization
c-----
      call mchdep()
      write(LOT,*)' enter name of input file' 
      read(LIN,60)names 
   60 format(a) 
      open(unit=2,file=names,access='sequential',form= 
     1 'unformatted',status='old') 
      write(LOT,*)' enter name of output file' 
      read(LIN,60)names 
      open(unit=4,file=names,access='sequential',form= 
     1 'unformatted',status='new') 
      rewind 2 
      icchar(1)=' z1 ' 
      icchar(2) = ' r1 ' 
      icchar(3) = ' z2 ' 
      icchar(4) = ' r2 ' 
      icchar(5) = ' t2 ' 
      icchar(6) = ' z3 ' 
      icchar(7) = ' r3 ' 
      icchar(8) = ' t3 ' 
      icchar(9) = ' z4 ' 
      icchar(10) = ' r4 ' 
      icchar(11) = ' xx ' 
      read(LIN,1) cmax,c1,c2,cmin 
      write(LOT,2)cmax,c1,c2,cmin 
c     cosine taper between cmax-c1 and c2-cmin 
c     unity response between c1 and c2 
c      zero response outside these windows 
c     the cmax,c1,c2, and cmin are inverse phase velocities 
      read(2)  alpha,depth,fl,fu,dt,n,n1,n2,df,nyq2 
      read(2)jsrc 
      read(2) d,a,b,rho,mmax,qa,qb 
      write(4) alpha,depth,fl,fu,dt,n,n1,n2,df,nyq2 
      write(4)jsrc 
c-----write out lsrc indexing since rhwvinta changes order 
      write(4)lsrc 
      write(4)d,a,b,rho,mmax,qa,qb 
  500 continue 
      rewind 2 
      read(LIN,1) r,tshift,vred 
c 
      read(2)  alpha,depth,fl,fu,dt,n,n1,n2,df,nyq2 
      read(2)jsrc 
      read(2)d,a,b,rho,mmax,qa,qb 
    1 format(4f10.5,i5) 
      write(LOT,2)r,tshift,vred 
    2 format(1h ,4f10.4) 
c     r = epicentral distance 
c     r .le. 0 terminate phase 
c     tshift .eq. 0 use reduced travel time,otherwise use tshift read in 
      if(vred.eq.0.0) vred=1.0e+10 
      t0 = tshift + r/vred
      write(4) r,t0 
      if(r.lt.0.0) go to 9998 
        call setup(depth,r) 
c     reduced travel time time shift 
c     evaluation of wavenumber integrals 
      do 250 jj=1,10 
  250 write(4) icchar(jj) 
      do 300 i=n1,n2 
      freq=(i-1)*df 
      fac=6.2831853*freq*t0 
      xr = cos(fac) 
      xi = sin(fac) 
      call wvint(r,ar,ai,depth) 
      j=1 
      k=2 
      do 310 jj=1,10 
      data(jj,j) = xr*ar(jj) - xi*ai(jj) 
      data(jj,k) = xr*ai(jj) + xi*ar(jj) 
  310 continue 
      do 305 jj=1,10 
      if(jsrc(lsrc(jj)).eq.1)write(4) data(jj,j),data(jj,k) 
  305 continue 
  300 continue 
      go to 500 
 9998 continue 
      close(2) 
      close(4) 
      stop 
      end 
     
      subroutine wvint(r,ar,ai,depth) 
c-----to work with potentially large disk files, we cannot read in
c-----all wavenumbers at once. We only work with neighboring
c-----points at any time. The first two are for the DC correction,
c-----followed by wavenumbers in decreasing order
      common/c/cmax,c1,c2,cmin 
      common/jout/jsrc(10) 
      common/fct/fact ,fact0
        common/asym/j0k0,j0k1,j0k2,j0k3,j1k0,j1k1,j1k2,j1k3, 
     1  j2k0,j2k1,j2k2,j2k3 
        real j0k0,j0k1,j0k2,j0k3,j1k0,j1k1,j1k2,j1k3,j2k0,j2k1, 
     1  j2k2,j2k3 
      dimension ar(10),ai(10) 
        complex aa(10),bb(10),cc(10) 
      complex gg,gg1,sumc 
      complex h0,h1 
      complex g(10,2) 
      complex smm(10) 
      complex sumd 
      complex f(2)
      dimension wvn(2) 
      real j0,j1,j01,j11 
      logical iasymp
      read(2)  omega,nk 
       call bufini(0,ierr)
      nkm2 = nk -2
c choose proper strategy for integration, e.g. 
c whether or not to use asymptotic technique 
c-----get the last wavenumber and g values
      call getgk(g,2,jsrc,wvn(2))
c-----get the second last values
      call getgk(g,1,jsrc,wvn(1))
c-----
c     find asymptotic coefficients using these values
c-----
      nlow = 1
      nupp = 2
      do 102 j=1,10
            call solu(g(j,nlow),g(j,nupp),wvn(nlow),wvn(nupp),
     1                  depth,j,aa(j),bb(j),cc(j) ) 
  102 continue
c-----
c     we no longer need the first value to shift
      wvnosv = wvn(2)
      call shift(g,wvn)
c-----
c-----
c     get first usable wavenumber which is the largest
c-----
      call getgk(g,1,jsrc,wvn(1))
c-----
c     decide whether to invoke asymptotic correction
c-----
      if(wvn(1).gt.wvnosv)then
            iasymp = .false.
      else
            iasymp = .true.
      endif
c-----
c     initialize integral
c-----
      call intini(smm,aa,bb,cc,iasymp,r)
c-----
c     we now can procede with integration
c-----
c-----
c     in the variables below the t0,j0,j1,sum refer to upper limit
c     of integration and t01,j01,j11 and sum1 refer to the lower limit
c-----
      wvcm=omega*cmax 
      wvc1=omega*c1 
      wvc2=omega*c2 
      wvcn=omega*cmin 
      wvno = wvn(1)
      t0 =wvno*r
      call hank(t0,1.0,h0,h1)
      j0 = real(h0)
      j1 = real(h1)
      if(iasymp)then
            call gasym(g,aa,bb,cc,wvn,1,depth,jsrc)
      endif
c-----
c     perform wavenumber filtering
c-----
      call wvfilt(cmax,wvcm,wvc1,wvc2,wvcn,wvno,fact)
      do 200 ik = nkm2,1,-1
      i = 2
      if(ik.lt.nkm2)then
      call shift(g,wvn)
      call getgk(g,1,jsrc,wvn(1))
      endif
c------to avoid trouble ignore sets of identical waveumbers
      if(wvn(1).eq.wvn(2))goto 200
c-----
c     now g(2) and wvn(2) refer to upper limit
c     now g(1) and wvn(1) refer to lower limit
c-----
c-----for the first wavenumber small use asymptotic values
                if(wvno.lt.1.0e-8.and.ik.eq.2)then 
                        g(4,1)=g(4,2) 
                        g(9,1)=g(9,2) 
                endif 
      i1 = i-1
      wvno1 = wvn(i1)
      t01 = wvno1 * r
      dkk = (wvno - wvno1) * r
      call hank(t01,1.0,h0,h1) 
      j01=real(h0) 
      j11=real(h1) 
c-----
c     if the asymptotic technique is invoked, the functional
c     values must be changed
c-----
      if(iasymp)then
            call gasym(g,aa,bb,cc,wvn,1,depth,jsrc)
      endif
c-----
c     perform windowing in wavenumber domain to pass
c     certain ranges of phase velocity
c-----
      call wvfilt(cmax,wvcm,wvc1,wvc2,wvcn,wvno,fact0)
      if(jsrc(1).eq.1)then
        call fmake(f,1,0,i,wvn,0,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,0,dkk,ik) 
        smm(1) = smm(1) + sumd 
      endif
      if(jsrc(2).eq.1)then
        call fmake(f,2,0,i,wvn,1,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,1,dkk,ik) 
        smm(2) = smm(2) + sumd 
      endif
      if(jsrc(3).eq.1)then
        call fmake(f,3,0,i,wvn,0,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,1,dkk,ik) 
        smm(3) = smm(3) + sumd 
      endif
      sumc = cmplx(0.0,0.0)
c-----
c           only include near field term if both SH and P-SV
c           computed
c-----
      if(jsrc(4).eq.1.and.jsrc(9).eq.1)then
        call fmake(f,4,9,i,wvn,0,g,gg,gg1)
        call wint(sumc,gg,gg1,j0,j01,j1,j11,t0,t01,1,dkk,ik) 
      endif
      if(jsrc(4).eq.1)then
        call fmake(f,4,0,i,wvn,1,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,0,dkk,ik) 
        smm(4) = smm(4) + sumd - sumc/r 
      endif
      if(jsrc(9).eq.1)then
        call fmake(f,9,0,i,wvn,1,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,0,dkk,ik) 
        smm(5) = smm(5) + sumd - sumc/r 
      endif
      if(jsrc(5).eq.1)then
        call fmake(f,5,0,i,wvn,0,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,2,dkk,ik) 
        smm(6) = smm(6) + sumd 
      endif
      sumc = cmplx(0.0,0.0)
c-----
c           only include near field term if both SH and P-SV
c           computed
c-----
      if(jsrc(6).eq.1.and.jsrc(10).eq.1)then
        call fmake(f,6,10,i,wvn,0,g,gg,gg1)
        call wint(sumc,gg,gg1,j0,j01,j1,j11,t0,t01,2,dkk,ik) 
      endif
      if(jsrc(6).eq.1)then
        call fmake(f,6,0,i,wvn,1,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,1,dkk,ik) 
        smm(7) = smm(7) + sumd - 2.*sumc/r 
      endif
      if(jsrc(10).eq.1)then
        call fmake(f,10,0,i,wvn,1,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,1,dkk,ik) 
        smm(8) = smm(8) + sumd - 2.*sumc/r 
      endif
      if(jsrc(7).eq.1)then
        call fmake(f,7,0,i,wvn,0,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,0,dkk,ik) 
        smm(9) = smm(9) + sumd 
      endif
      if(jsrc(8).eq.1)then
        call fmake(f,8,0,i,wvn,1,g,gg,gg1)
        call wint(sumd,gg,gg1,j0,j01,j1,j11,t0,t01,1,dkk,ik) 
        smm(10) = smm(10) + sumd 
      endif
  201 continue 
      t0=t01
      j1=j11 
      j0 = j01
      wvno = wvno1
      fact = fact0
  200 continue 
c     sign change due to k j(-1) 
      smm(2) = -smm(2) 
      smm(10) = -smm(10) 
      do 300 i = 1,10 
      smm(i)=smm(i)/r 
      ar(i) = real(smm(i)) 
      ai(i) = aimag(smm(i)) 
  300 continue 
      return 
      end 
     
      subroutine wint(smm,g,g1,j0,j01,j1,j11,t0,t01,n,dkk,ik) 
      common/fct/fact1 ,fact0
      complex smm,g,g1 
      real j0,j1,j01,j11 
      real j2,j21
      nn = n + 1 
c-----
c     trapezoidal rule
c-----
c     if(ik.eq.1)then
c           fact = 0.5*fact0
c     else
c           fact = fact0
c     endif
c-----
c       if commented out then rectangular rule
c-----
      fact = fact0
      go to (1,2,3),nn 
    1 continue 
c      integral (c + d z) * j0(z) dz 
      smm = fact * g1 * j01 * dkk
      return 
    2 continue 
c      integral (c + d z) j1(z) dz 
      smm = fact * g1 * j11 * dkk
      return 
    3 continue 
      if(t0.eq.0.0)then
            j2 = 0.0
      else
            j2 = 2.*j1/t0 - j0
      endif
      if(t01.eq.0.0)then
            j21 = 0.0
      else
            j21 = 2.*j11/t01 - j01
      endif
c      integral (c + d z) j2(z) dz 
      smm = fact * g1 * j21 * dkk
      return 
      end 
     
      subroutine hank(wvno,r,h0,h1) 
      complex h0,h1 
      real j0,j1,j1z 
      z = wvno*r 
      if(z.gt.0.0) go to 100 
      h0=cmplx(1.0,0.0) 
      h1=cmplx(0.0,0.0) 
      return 
  100 if(z.gt.3.0) go to 200 
      x = (z/3.)*(z/3.) 
      j0 = 1.-x*(2.2499997-x*(1.2656208-x*(.3163866-x*( 
     1.0444479-x*(.0039444-x*(.0002100)))))) 
      j1z = 0.5-x*(.56249985-x*(.21093573-x*(.03954289-x*( 
     1.00443319-x*(.00031761-x*(.00001109)))))) 
      j1 = z * j1z 
      h0 = cmplx(j0,0.0) 
      h1 = cmplx(j1,0.0) 
      return 
  200 continue 
      x = 3./z 
      fac = 1./sqrt(z) 
      f0 = .79788456+x*(-.00000077 + x*(-.00552740 + x*( 
     1-.00009512+x*(.00137237+x*(-.00072805+x*(.00014476)))) 
     2)) 
      t0 = z - .78539816+x*(-.04166397+x*(-.00003954+x*( 
     1.00262573+x*(-.00054125+x*(-.00029333+x*(.00013558)))) 
     2)) 
      f1 = .79788456+x*(.00000156+x*(.01659667+x*(.00017105+ 
     1x*(-.00249511+x*(.00113653+x*(-.00020033)))))) 
      t1 = z-2.35619449+x*(.12499612+x*(.00005650+x*( 
     1 -.00637879+x*(.00074348+x*(.00079824+x*(-.00029166))) 
     2))) 
      j0 = fac * f0 * cos(t0) 
      j1 = fac * f1 * cos(t1) 
      h0 = cmplx(j0,0.0) 
      h1 = cmplx(j1,0.0) 
      return 
      end 
     
        subroutine solu(y1,y2,x1,x2,h,j,a,b,c) 
c we ndo not solve for a,b,c together, only two at most 
c thus we only need two values of wavenumber, x1 and x2 
        complex y1,y2,a,b,c 
        c=cmplx(0.0,0.0) 
        go to (300,200,300,200,300,200,300,200,200,200),j 
  100   continue 
c---------aexp(-kh) 
        b=cmplx(0.0,0.0) 
        a=y1*exp(x1*h) 
        return 
  200   continue 
c---------[ a + b k  ]exp(-kh) 
        u1=x1*h 
        u2=x2*h 
        det=x2-x1 
        a= x2*y1*exp(u1)-x1*y2*exp(u2) 
        a=a/det 
        b= y2*exp(u2) - y1*exp(u1) 
        b=b/det 
        return 
  300   continue 
c---------[ a + b k  ]  k exp(-kh) 
        u1=x1*h 
        u2=x2*h 
        det=x2-x1 
        a = cmplx(0.0,0.0) 
        b = x2*y1*exp(u1)/x1 - x1*y2*exp(u2)/x2 
        b = b/det 
        c= y2*exp(u2)/x2 - y1*exp(u1)/x1 
        c = c/det 
        return 
  400   continue 
c-------- a k*k*exp(-kh) 
        a = cmplx(0.0,0.0) 
        b = cmplx(0.0,0.0) 
        c = y1 * exp(x1*h)/(x1)**2 
        return 
  500   continue 
c-------- a k exp(-kh) 
        a = cmplx(0.0,0.0) 
        b = y1 * exp(x1*h)/ x1 
        return 
        end 
     
        subroutine setup(zz,rr) 
c---------------------------------------------------------- 
c 
c       jnkm = r integral exp(-kh) ksup m j sub n (kr) dk 
c 
c       the r in front takes into account the 1/r in the 
c       do 300 of subroutine wvint 
c---------------------------------------------------------- 
        implicit double precision (a-h,o-z)
        real*4 rr,zz
        common/asym/j0k0,j0k1,j0k2,j0k3,j1k0,j1k1,j1k2,j1k3, 
     1  j2k0,j2k1,j2k2,j2k3 
        real*4 j0k0,j0k1,j0k2,j0k3,j1k0,j1k1,j1k2,j1k3,j2k0,j2k1, 
     1  j2k2,j2k3 
        r = dble(rr)
        z = dble(zz)
        dist=dsqrt(r*r + z*z) 
        dist3=dist**3 
        dist5=dist**5 
        dist7=dist**7 
        rz=r*z 
        z2=z*z 
        r2=r*r 
        r3=r*r2 
        z3=z*z2 
        rz2=r*z2 
        rz3=r*z3 
        zor = z/dist
        zor2= zor*zor
        zor3= zor*zor2
        j0k0 = sngl( r/dist   )
        j0k1 = sngl( rz/dist3   )
        j0k2 = sngl( (2.*rz2 - r3)/dist5   )
        j0k3 = sngl( (6.*rz3 - 9.*z*r3)/dist7   )
        j1k0 = sngl( 1. -z/dist   )
        j1k1 = sngl( r2/dist3   )
        j1k2 = sngl( 3.*z*r2/dist5   )
        j1k3 = sngl( 3.*r2*(4.*z2 - r2)/dist7   )
        j2k0 = sngl(  ( 1. -zor)*(1.-zor)*(dist/r)  )
        j2k1 = sngl(  (1-zor)*(1-zor)*(2.+zor)/r  )
        j2k2 = sngl( 3.*r3/dist5   )
        j2k3 = sngl( 15.*z*r3/dist7   )
        return 
        end 
     
      subroutine fmake(f,j,k,i,wvn,l,g,gg,gg1)
      dimension wvn(*)
      complex f(2),g(10,2)
      complex gg,gg1
      do 100 ii=1,2
          ll= i - 2 + ii
          f(ii) = g(j,ll)
          if(k.gt.0) f(ii) = f(ii) + g(k,ll)
          if(l.gt.0) f(ii) = f(ii)*wvn(ll)
  100 continue
      gg = f(2)
      gg1= f(1)
      return
      end
     
      subroutine getgk(g,j,jsrc,wvno)
c-----
c     read input to obtain elements of g(10,j) array
c-----
      complex g(10,2)
      dimension jsrc(10)
      call bufrd(wvno,ierr)
      do 101 i=1,10
            if(jsrc(i).eq.1)then
                  call bufrd(xr,ierr)
                  call bufrd(xi,ierr)
                  g(i,j)=cmplx(xr,xi)
            endif
  101 continue
      return
      end
     
      subroutine shift(g,wvn)
c-----
c     do interchange g(j,1) -> g(j,2)
c                 wvn(1)-> wvn(2)
c-----
      complex g(10,2)
      dimension wvn(*)
      wvn(2)=wvn(1)
      do 100 i=1,10
  100 g(i,2)=g(i,1)
      return
      end
     
      subroutine intini(smm,aa,bb,cc,iasymp,r)
        common/asym/j0k0,j0k1,j0k2,j0k3,j1k0,j1k1,j1k2,j1k3, 
     1  j2k0,j2k1,j2k2,j2k3 
      common/jout/jsrc(10) 
        real j0k0,j0k1,j0k2,j0k3,j1k0,j1k1,j1k2,j1k3,j2k0,j2k1, 
     1  j2k2,j2k3 
      complex aa(*),bb(*),cc(*),smm(*),sumd
      logical iasymp
      if(iasymp)then
c-----set up sum arrays, but put in asymptotic value now 
c-----of setting to zero and then resetting 
                smm(1)=        aa(1)*j0k0 + bb(1)*j0k1 + cc(1)*j0k2 
                smm(2)=        aa(2)*j1k1 + bb(2)*j1k2 + cc(2)*j1k3 
                smm(3)=        aa(3)*j1k0 + bb(3)*j1k1 + cc(3)*j1k2 
            if(jsrc(9).eq.1 .and. jsrc(4).eq.1)then
                sumd  = (aa(4)+aa(9))*j1k0 + (bb(4)+bb(9))*j1k1 + 
     1                  (cc(4)+cc(9))*j1k2 
            else
                  sumd = cmplx(0.0,0.0)
            endif
                sumd        = -sumd/r 
                smm(4)=sumd + aa(4)*j0k1 + bb(4)*j0k2 + cc(4)*j0k3 
                smm(5)=sumd + aa(9)*j0k1 + bb(9)*j0k2 + cc(9)*j0k3 
                smm(6)=  aa(5)*j2k0 + bb(5)*j2k1 + cc(5)*j2k2 
            if(jsrc(6).eq.1 .and. jsrc(10).eq.1)then
                sumd= (aa(6)+aa(10))*j2k0 + (bb(6)+bb(10))*j2k1 + 
     1               (cc(6)+cc(10))*j2k2 
            else
                  sumd = cmplx(0.0,0.0)
            endif
                sumd        = -2.*sumd/r 
                smm(7)=sumd + aa(6)*j1k1 + bb(6)*j1k2 + cc(6)*j1k3 
                smm(8)=sumd + aa(10)*j1k1+ bb(10)*j1k2+cc(10)*j1k3 
                smm(9)=aa(7)*j0k0        + bb(7)*j0k1 + cc(7)*j0k2 
                smm(10)=      aa(8)*j1k1 + bb(8)*j1k2 + cc(8)*j1k3 
      else
            do 100 i=1,10
  100       smm(i)=cmplx(0.0,0.0)
        endif 
      return
      end
     
      subroutine gasym(g,aa,bb,cc,wvn,i,depth,jsrc)
c-----
c     remove asymptotic trend from integrands
c-----
      complex g(10,2),aa(*),bb(*),cc(*)
      dimension jsrc(10)
      real wvn(*)
      wvno = wvn(i)
      ex = exp(-wvno*depth)
      do 130 j=1,10
            if(jsrc(j).eq.1)then
                  g(j,i)=g(j,i) - ex*(aa(j)+wvno*(bb(j)+
     1                        wvno*(cc(j))))
            endif
  130 continue
      return
      end
     
      subroutine bufini(irdwr,ierr)
c------initialize buffer pointer
c------irdwr = 0 read initialize
c------irdwr = 1 write initialize
      integer BUFMAX
       parameter(BUFMAX=2000)
       common/buf/iptr,max,buffer(BUFMAX)
       save /buf/
      iptr = 1
      if(irdwr.eq.0)call getbuf(ierr)
      return
      end
     
        subroutine buflsh
c------flush output buffer
      integer BUFMAX
      parameter(BUFMAX=2000)
        common/buf/iptr,max,buffer(BUFMAX)
      save /buf/
      ipt = iptr -1
      if(ipt.gt.0)write(2)ipt,(buffer(i),i=1,ipt)
        iptr = 1
      return
      end

     
        subroutine bufwr(x)
c------fill buffer with floating point variable x,
c------flush buffer as necessary
      integer BUFMAX
      parameter(BUFMAX=2000)
      common/buf/iptr,max,buffer(BUFMAX)
      save /buf/
      buffer(iptr) = x
      iptr = iptr + 1
      if(iptr.gt.BUFMAX)call buflsh
      return
      end

     
        subroutine getbuf(ierr)
c------read in file contents into buffer, taking care not to
c------read beyond the contents of the file
      integer BUFMAX
      parameter(BUFMAX=2000)
      common/buf/iptr,max,buffer(BUFMAX)
      save /buf/
c------ierr = 0 successful read
c------     = 1 read error
c------     = 2 end of file
c------
      read(2,err=1000,end=2000)max,(buffer(i),i=1,max)
      iptr = 1
      ierr = 0
      return
 1000 ierr = 1
      return
 2000 ierr = 2
      return
      end
     
      subroutine bufrd(x,ierr)
c-----retrieve a value from buffer array, red in new array
c-----as necessary
c-----iptr is here the next array element to be read
c-----it is always >= 1. We do not worry the upper limit
c-----since the calling program must worry about this
c-----because read always follows a complete write
      integer BUFMAX
      parameter(BUFMAX=2000)
      common/buf/iptr,max,buffer(BUFMAX)
      save /buf/
c       only yank in new data if actually required
      if(iptr.gt.max)call getbuf(ierr)
      x = buffer(iptr)
      iptr = iptr + 1
      return
      end
      subroutine wvfilt(cmax,wvcm,wvc1,wvc2,wvcn,wvno,fact)
      pi = 3.1415927 
      if(cmax.lt.0.0)then
            fact = 1.0
      elseif(wvno.ge.wvc1.and.wvno.le.wvc2) then
            fact=1.0 
      elseif(wvno.ge.wvcm.and.wvno.lt.wvc1)then
            fact=(1.-cos(pi*(wvno-wvcm)/ (wvc1-wvcm)))/2. 
      elseif(wvno.gt.wvc2.and.wvno.le.wvcn)then
            fact=(1.-cos(pi*(wvno-wvcn)/ (wvc2-wvcn)))/2. 
      else
            fact = 0.0
      endif
      return
      end

	function numarg()
	integer numarg
	numarg = iargc()
	return
	end
 
      subroutine mchdep()
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME VI                                                      c
c                                                                     c
c      PROGRAM: MCHDEP                                                c
c                                                                     c
c      COPYRIGHT 1985                                                 c
c      R. B. Herrmann                                                 c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      return
      end

c
c  program to split seisan waveform files
c
c  j. havskov, march 1993
c  Updates:
c  jul 8 93 by jh  : version 3.0
c  jan 2 94        : bug with outfile if same on pc
c  jun 94          : 999 channels, bug when first and secon outfiles same on pc
c  dec 7           : include seidim
C  dec 8        : Installed file & error handling (libsei)
c  dec 13         ************** version 5.0 *************************
c  jul 27 95 jh    : bug with 30 channles
c  aug 21          : still ------------
c  nov 1  95 jh    : new seisinc routine
c  march 8 99      : ----------------   verison 7.0 check ---------------
c                    stat, year 2000
c  jan5 99 jh      : file name wrong for 2000
c  apr  08 lo      : use filenr.lis and use station in filename if all
c                    channels form same station
c
      implicit none
c
c  dimentions include defs.
c
      include 'seidim.inc'
c-- main header
      character*80 mainhead(max_trace/3+3)
c-- channel header
      character*1040 chahead	  
c-- input file names
      character*80 infile
c-- output file name 
      character*80 outfile,first_outfile
c-- input question
      character*80 question	  	  
c-- station counter
      integer nstat	  
c-- indicator if first or second file to make
      integer file_sel
      character*5 net_code
c-- number of stations and samples
      integer nsamp,nchan,nchan_out	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- main header date and time
      integer myear,mmonth,mday,mdoy,mhour,mmin
      real msec	  
c-- channel start time and interval
      real cstart(max_trace)
      double precision cinter(max_trace)
c-- event start time
      double precision ev_time
c-- number of channels to remove
      integer n_remove	  	  
c-- channel number to remove
      integer chan_remove(max_trace)
c-- channels marked for removal
      integer chan_sel(max_trace)
c-- total window length
      real total_window
c-- channel absolute start time relative earliest channel, from  1900, in sec 
      double precision cabstim(max_trace)     	  	  
c-- channel end time absolute
      double precision cendtim(max_trace)
c-- maximum and minumum of above and their difference
      double precision first_time,last_time
c-- data samples
      integer*2 data2(2*max_sample)
      integer*4 data4(max_sample)	  	  
c-- counters
      integer i,j,k,l,ichan
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code,                  ! Error encoder.
     &          sei real num               ! Get real number
C
       integer  write01,                   ! Output unit 1.
     &          read01,                    ! Input unit1.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       real sei real num                   ! Real number
c-- for component rotation, not used in this routine
      real caz,saz
      real baz(max_trace)
      real        del_rot       ! delay rotated trace
      character*1 rot_comp(max_trace)  ! T or R
      logical rotate
      integer nchan_last                   ! save number of channels
      integer in                           ! 1 for filenr.lis
      logical singleflag                   ! true if all channels from single station
      character*5 singlestat
c
      real x(max_sample)
      equivalence (data2,data4)
c      equivalence (data4,x)
      common /signalx/x,rotate,baz,rot_comp,del_rot
C
C    ============= end of list ==========
      include 'version.inc'


c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c      question=' Filename or number'
c
c  get file name
c
      in=0
      nchan_last=0
      question=' Filename, ?, number or filenr.lis for all'
      call filename(question,infile)
c
c   check which type of input file
c
      if(infile(1:10).eq.'filenr.lis'
     *   .or.infile.eq.'FILENR.LIS') then
            open(8,file='filenr.lis',status='old')
            in=1
      endif
      write(6,*)'No of channels to remove'
      read(5,*)n_remove 
      write(6,*)'Channels to remove'
      read(5,*)(chan_remove(i),i=1,n_remove)

10    continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         write(6,*)
         write(6,'(1x,a)') infile
         if(infile(1:4).eq.'    ') goto 99
      endif

      if(infile(1:3).eq.'EOF') goto 99       
          chr_f_access$='direct'
          f_recl$=2048
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   infile,           ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
c
c   now read headers for input event
c	  
      call seisinc                                                             
     *(read01,0,nchan,0,MAINHEAD,chahead,0.0,0.0)                     
c
c check that number of channels is the same
c
      if (nchan_last.ne.0.and.nchan.ne.nchan_last) then
        write(*,*) ' number of channels changed -> exit '
        goto 99
      endif
      nchan_last=nchan
c
c-- date and time of first channel
c
      read(mainhead(1)(34:59),'(i3,5x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3)')
     *myear,mmonth,mday,mhour,mmin,msec 	   	  	 
      myear=myear+1900
      call timsec
     *(myear,mmonth,mday,mhour,mmin,msec,ev_time)
c
c-- get channel codes, start times and durations
c
      nstat=1
      do i=3,(nchan-1)/3+3
         read(mainhead(i),'(3(1x,2a4,a1,f7.2,1x,f8.2))')
     *   stat(nstat)(1:4),comp(nstat),stat(nstat)(5:5),
     *   cstart(nstat),cinter(nstat),
     *   stat(nstat+1)(1:4),comp(nstat+1),stat(nstat+1)(5:5),
     *   cstart(nstat+1),cinter(nstat+1),	 
     *   stat(nstat+2)(1:4),comp(nstat+2),stat(nstat+2)(5:5),
     *   cstart(nstat+2),cinter(nstat+2)	 
         do k=1,3
            l=nstat+k-1		 		 
            cabstim(l)=ev_time+cstart(l)
            cendtim(l)=cabstim(l)+cinter(l)			
         enddo		 
         nstat=nstat+3		   		 
      enddo
      rewind read01	  
c
c--------------------------------------------------------
c   file header read, sort out channels to extract/delete
c--------------------------------------------------------
c
c   mark channels to remove
c	
      do ichan=1,nchan
        chan_sel(ichan)=0  	  	 
        do k=1,n_remove
           if(chan_remove(k).eq.ichan) then
              chan_sel(ichan)=1
           endif
        enddo
      enddo
	  
c---------------------------------------------------------
c   back here after making file without selected channels
c   selected with variable file_sel 0: traces not selected
c                                   1: traces selected
c---------------------------------------------------------
c
      file_sel=0
      first_outfile(1:30)='                              '
c
 1000 continue
	  
c
c   find earliest trace and total time window 
c
      first_time=1.0e20
      last_time=0.0	  
      singleflag=.true.
      singlestat=' '
      do i=1,nchan
         if(chan_sel(i).eq.file_sel) then 
           if(cabstim(i).lt.first_time) first_time=cabstim(i)
           if(cendtim(i).gt.last_time)  last_time=cendtim(i)
           if (singlestat.ne.' '.and.singlestat.ne.stat(i))
     &       singleflag=.false.
           singlestat=stat(i)
         endif
      enddo
      if (.not.singleflag) singlestat=' '
c
c   find new start times relative to new main header
c
      do i=1,nchan
         if(chan_sel(i).eq.file_sel) cstart(i)=cabstim(i)-first_time
      enddo	
c
      total_window=last_time-first_time
c
c   make new main header, clear first
c
      if(nchan.gt.30) then
         k=(nchan-31)/3+13
      else
         k=12
      endif
      do i=1,k
         do j=1,80
            mainhead(i)(j:j)=' '
         enddo
      enddo		 					 	  
      k=0
      do i=1,nchan
        if(chan_sel(i).eq.file_sel) k=k+1
      enddo
      write(mainhead(1)(31:33),'(i3)') k
      nchan_out=k
c-- start time	  
      call sectim(first_time,myear,mdoy,mmonth,mday,mhour,mmin,msec)
      write(mainhead(1)(34:69),'(i3,1x,i3,1x,i2,1x,i2,1x,i2,1x,
     *i2,1x,f6.3,1x,f9.3)') myear-1900,mdoy,mmonth,mday,mhour,mmin,msec,
     *total_window
c
c-- channels, check for channels not used
c
      l=2
      k=3	  
      do j=1,nchan
        if(chan_sel(j).eq.file_sel) then
           write(mainhead(k)(l:l+24),'(2a4,a1,f7.2,1x,f8.2)')	  	 
     *     stat(j)(1:4),comp(j),stat(j)(5:5),cstart(j),cinter(j)   
           l=l+26
           if(l.gt.60) then
              l=2
              k=k+1
           endif
        endif
      enddo		
c
c   determine net code
c
      if (singleflag) then
        net_code=singlestat
      else
        net_code=mainhead(1)(2:6)
      endif
      if(net_code(1:1).eq.' ') net_code='SPLIT'
      do i=1,5
         if(net_code(i:i).eq.' ') net_code(i:i)='_'
      enddo
c                                                                               
c  make file name
c
c    century
c
         if(myear.ge.2000) then
           outfile(1:2)='20'
         else
           outfile(1:2)='19'
         endif
c             
c-- year                          
         outfile(3:5)=mainhead(1)(35:36)//'-'               
c-- month                                    
         outfile(6:7)=mainhead(1)(42:43)		
         outfile(8:8)='-'
c-- day                                      
         outfile(9:10)=mainhead(1)(45:46)		
         outfile(11:11)='-'
c-- hr                                       
         outfile(12:13)=mainhead(1)(48:49)		
c-- min                                    
         outfile(14:15)=mainhead(1)(51:52)		
         outfile(16:16)='-'
c-- sec                                    
         outfile(17:18)=mainhead(1)(54:55)		
         outfile(19:20)='S.'
c-- network or station code                  
         outfile(21:25)=net_code		
         outfile(26:26)='_'
c-- number of channels
         outfile(27:29)=mainhead(1)(31:33)
c-- check for blanks                                        
         do i=1,29				
            if(outfile(i:i).eq.' ') outfile(i:i)='0'                            
         enddo                                                                  
         write(6,200) outfile(1:29)                                             
 200     format(/,' Output file name is: ',a29)                                
c
c   check that outfile name is not the same as the input
c   file or first output file name 
c   in which case the event should not be written out
c   on sun that should not happend often since file name is to nearest
c   second and number of channels is given
c
         if(infile(1:29).eq.outfile(1:29).or.outfile(1:29).eq.
     *      first_outfile(1:29)) then
            write(6,*)'**************************************'
            write(6,*)'Output file already exists, stop '
            write(6,*)'**************************************'
            stop 
          endif
c
c   save filename to be able to compare when second file is written out
c
         if(file_sel.eq.0) first_outfile=outfile
c
c   open file and write main header
c
          chr_f_form$ = 'unformatted'
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
c-- calculate number of main header lines
         if(nchan_out.gt.30) then
            k=(nchan_out-31)/3+13
         else
            k=12
         endif
      do i=1,k
         write(write01)mainhead(i)
         write(6,'(a80)') mainhead(i)		 
      enddo
c
c   channel loop
c 
          call seisinc                                                             
     *    (read01,0,nchan,0,MAINHEAD,chahead,0.0,0.0)                     
c
         do j=1,nchan	
c
c-- write out again if not selected out
c-- put in response in future
c
            if(chan_sel(j).eq.file_sel) then
               call seisinc                                                             
     *         (read01,j,nchan,2,MAINHEAD,chahead,0.0,0.0)                     
               read(chahead(45:50),'(i6)') nsamp
               write(write01) chahead
               write(6,*) ' Channel copied --------------------'
               write(6,'(1x,a)') chahead(1:60)			
               if(chahead(77:77).eq.'4') then
                  do i=1,nsamp
                     data4(i)=x(i)
                  enddo
                  write(write01)(data4(i),i=1,nsamp)
               else
                  do i=1,nsamp
                     data2(i)=x(i)
                  enddo
                  write(write01)(data2(i),i=1,nsamp)
               endif
            else
c	           write(6,*) ' Channel selected out, not copied *****' 
            endif
         enddo
         call sei close(close$,write01,code)
c
c   check if going back and making second file
c
         if(file_sel.eq.0) then
            file_sel=1
            goto 1000
         endif
c
      goto 10
99    continue

      call sei close(close$+all$,read01, code)       ! Close all open files.
      stop
      end	  	  	 

      subroutine syntsel(data,ndata,t0,window,t0synt,dtt,nsynt,codsyn)
c
c     updates jan 25
c
c     jan 95   jh    *********version 5.0 ******************************
c     feb 95         new findchan
c     april 28 , 95  fix rotaion bug with angle
c     may  8     95  new seisinc common block
c     oct 95 by jh    : new seisinc, use delays by default
c     april 99 by jh  : --------------   version 7.0 check ----------------
c                       stats to 5 char, year 2000
c     august 99       : wrong year in synthetic data
c                       call get_seisan_def
c     may 30          : wrong year write out of synt data for 2000
c     feb 19, 2001 lo : changed common block signal
c
c
c   Puts together synthetic data from WKBJ  and real data
c   from corresponding Seisnor file to one Seisnor file. One real
c   trace is followed by one synthetic.
c   The time window starts at the seism origin + t0
c 
c
c   input:  data      the hyp.out file
c           ndata:    number of records in hyp.out
c           t0    :   start time of the plot in seconds from seism origin time
c           window:   time window to plot(secs)
c           t0synt:   start time of the synthetics at each station
c                                 in seconds from seism origin time 
c           dtt   :   sampling interval of the synthetics (secs)
c           nsynt:    number of samples in a synthetic signal
c           codsyn:   'SW '(for WKBJ), 
c                           'SH '(for Herrmann) or 'SB '(for Bouchon)
c
c
       implicit none
       include 'seidim.inc'                  ! dimensions
       include 'libsei.inc'                  ! file open etc
c-- single trace file header
      character*1040	chead,cheadsave
c-- main header
      character*80      mhead(max_trace),mmhead(max_trace)
c-- data array for s-file
      character*80 data(*)
c-- trace file name
      character*80 trace_file,tt,file
c-- network code
      character*5 net_code		
c-- dummy
      character*80 dummy		
c-- station code
      character*5  stat(max_trace)		
c-- code for labelling the synthetic components
      character*3 codsyn
c-- file units
      integer wav_unit,unit_out
c-- code for component orientation
      logical radial
c-- component
      character*4  comp(max_trace)	,compd(max_trace)
c-- amplitudes of the transfer fonctions at 1Hz
      real ampln,ample,dampl
c-- station and component
      character*9 statcomp(max_trace)
c-- start time of plot and synthetic relative to seism origin time
      real t0,t0synt(max_trace),dtt
c-- start time to plot relative to first sample
      real tstart(max_trace)
c--  time window selected
      real window
c-- ---------
      integer n,ns
c-- read function
      real sei real num
c-- header parameters
      real strike,dip,rake,depth
      integer istrike,idip,irake
c-- path to seismo
      character*60 top_directory		
c-- number of channels in w-file
      integer nchan
c-- .true. if waform file exists
      logical exist			
c-- number of samples in one channel
      integer nsamp
c-- 1: test output, 0: no output
      integer check			
c-- origin date
      integer oyear,omonth,oday,odoy		
c-- origin time
      integer ohour,omin		
c-- origin time
      real    osec			
c-- date of first sample
      integer wyear,wmonth,wday		
c-- time of ------------
      integer whour,wmin		
c-- --------------------
      real    wsec
c-- date of first sample for synthetics
      integer syear,smonth,sday,sdoy		
c-- time of ------------
      integer shour,smin		
c-- --------------------
      real    ssec
c-- abs times
      double precision wtime,otime,stime
c-- sample rate
      real    rate			
c-- error variables
      integer error,ierr		
c-- channel numbers to select
      integer chan(max_trace)			
c-- interval each channel
      real cinter(max_trace)
c-- delay of first sample selected relative to origin time
      real delay(max_trace)
c-- addtional channel delay
      real delay_chan(max_trace)
c-- text string
      character*80 text
c-- number of signals in synthetic traces
      integer nsynt
c-- sample rate synthetic data
      real syntrate
c-- station number corresponding to a given channel
      integer jstat(max_trace)
c-- p-residual
      real p_residual
c-- azimuth for rotating the horizontal seismograms
      real backazi,caz,saz
c-- help variables
      real c_delay
      integer	i,j,l,n1,n2,k,ichan,kchan,ilec,ndata,ncbid,code
c-- seismic signal
      integer*2 isignal2(max_sample*2)
      integer b_flag                         ! used with file opening
      real signal(max_sample)			
      real signaln(max_sample),signale(max_sample)
      integer isignal(max_sample)
      real baz(max_trace)
      character*1 rot_comp(max_trace)  ! T or R
      real        del_rot       ! delay rotated trace
      logical rotate
c
      equivalence(signal,isignal)
c
c      common /signal/signal,rotate,baz,rot_comp,del_rot
      common /signalx/signal
      error=0
      check=0
c
c   get seisan defaults
c
      call get_seisan_def
c
c   read seism origin time
c
      read(data(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)')
     *oyear,omonth,oday,ohour,omin,osec
c
c   get seism origin time in secs
c
      call timsec(oyear,omonth,oday,ohour,omin,osec,otime)
c
c   calculate plot origin time in secs
c
      otime = otime + t0
      call sectim(otime,oyear,odoy,omonth,oday,ohour,omin,osec)
c
c   read if Radial-Transverse or North-East components
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: COMPON-:') then
            radial=.false.
            if  (data(i)(20:25).eq.'RADIAL') radial=.true.
         endif
      enddo
c
c   find number of channels to display, if component is blank, use all,else
c   only use component selected. At least the type of instrument must be
c   specified, e.g. S
c
      nchan=0
      do i=1,ndata
         if(data(i)(80:80).eq.'3'.and.data(i)(2:15).eq.
     *      'SYNT: STATION:'.and.data(i)(22:23).ne.'  ')
     *   then
            do k=1,nchan
              if(statcomp(k).eq.data(i)(17:25)) goto 80
            enddo
c
c   channel(s) was not counted before
c
            nchan=nchan+1
            statcomp(nchan)=data(i)(17:25)
            if(statcomp(nchan)(9:9).eq.' ') then
               statcomp(nchan)(9:9)='Z'
               statcomp(nchan+1)=statcomp(nchan)
               statcomp(nchan+1)(9:9)='N'
               if (radial) statcomp(nchan+1)(9:9)='R'
               statcomp(nchan+2)=statcomp(nchan)
               statcomp(nchan+2)(9:9)='E'
               if (radial) statcomp(nchan+2)(9:9)='T'
               nchan=nchan+2
            endif
 80         continue
         endif
      enddo
      write(6,*)'Number of channels to display', nchan
c
c  make codes for real and synthetic channels which will be every second
c
      k=1
      j=0
      do i=1,nchan*2,2
         stat(i)=statcomp(k)(1:5)
         stat(i+1)=stat(i)
         comp(i)=statcomp(k)(6:9)
         compd(i)=comp(i)
         if (compd(i)(4:4).eq.'R')  compd(i)(4:4)='N'
         if (compd(i)(4:4).eq.'T')  compd(i)(4:4)='E'
         comp(i+1)(1:3)=codsyn
	     comp(i+1)(4:4)=statcomp(k)(9:9)
         if (i.eq.1.or.stat(i).ne.stat(i-2))  j=j+1
         jstat(i+1)=j
         k=k+1
      enddo
c
c   get trace data file name from s-file
c
c     rewind 15
c     call auto_filename(trace_file,15,dummy)
      rewind 1
      call auto_filename(trace_file,1 ,dummy)
      exist=.false.
      if(trace_file(1:3).eq.'EOF') then
         write(6,*) 'No waveform file name available for event'
         exist=.false.
c
c   look for waveform file first in own direcrtory, then in WAV
c
      else
        i=index(trace_file,' ')-1
        write(6,'(1x,a,a)') ' File to look for: ',trace_file(1:i)
c       chr_f_form$ = 'unformatted'
        chr_f_access$ = 'direct'            ! Type of file.
        f_recl$=2048                        ! Record length

        call sei get file( check$+warn$,    ! Find and open without messages.
c       call sei get file( open$,    ! Find and open without messages.
     &                       0,         ! On file unit.
c    &                       wav_unit,         ! On file unit.
     &                   code,             ! Condition (n/a).
     &                   'WAV',            ! Alternative directory to search.
     &                   trace_file   )    ! For this file.
c     chr_f_form$ = 'unformatted'                 ! Type of file.
      do i=1,80
         if(ichar(trace_file(i:i)).eq.0) trace_file(i:i)=' '
      enddo
c     write(6,*)' Open', trace_file

       call sei open( old$+warn$,                        ! Open old file.
     &               ' ',                         ! No prompt.
     &               trace_file,                       ! This file.
     &               wav_unit,                   ! On this unit.
     &               b_flag,                      ! Exists?.
     &               code )                       ! Returned condition.


        if(wav_unit.gt.0) exist=.true.    ! set flag if file ok

      endif
c
c---------------------------------------------------------
c   enter loop for channels, first read header only,
c---------------------------------------------------------
c
      do 1000 ichan=1,2*nchan,2
        if (ichan.gt.1.and.stat(ichan).eq.stat(ichan-2))   then 
           delay_chan(ichan)= delay_chan(ichan-2)
           delay_chan(ichan+1)= delay_chan(ichan-1)
        else
c
c   find first station to be modelled, read P time residual
c
        do i=2,ndata
           if(data(i)(2:6).eq.stat(ichan).
     &                   and.data(i)(11:11).eq.'P') then
             read(data(i)(64:68),'(f5.1)') p_residual
             goto 300
           endif
        enddo
 350    write(6,*)'No P-reading '
        p_residual=0.0
 300    continue
c
c   read how to delay the data trace to make sure synthetic and real
c   signal are aligned.
c
        delay_chan(ichan)=0.0
c       if (chan(ichan).ne.0)   then
          write(6,'(a,a,a,f7.3)')
     *    ' At station ',stat(ichan),', the P-residual is :',p_residual
          write(6,'(a)')
     *  ' By how much do you want to delay the data trace ?'
          write(6,'(a$)') 
     &   ' Return for P-residual delay, which align P-phases '
           read(5,'(a)') text
          c_delay=sei real num(text, code)
c         write(6,*) c_delay
          if(text(1:4).eq.'    ') then
              delay_chan(ichan)=-p_residual
          else
              delay_chan(ichan)=c_delay
          endif
c          if(text(1:4).ne.'    ')   read(text,*) delay_chan(ichan)
c       endif
c
c   do not delay the synthetic traces
c
        delay_chan(ichan+1)=0.0
c
      endif
c
c   find channel number corresponding to station and
c   component, also get header time
c
         if (exist) then
           call seisinc
     *     (wav_unit,0,ncbid,0,mmhead,chead,0.0,0.0)
c          rewind wav_unit 
           call findchan
     *     (mmhead,stat(ichan),compd(ichan),chan(ichan),wyear,wmonth,
     *     wday,whour,wmin,wsec,ierr)
           if(ierr.eq.1) then
              error=error+1
              write(6,'(1x,a5,a4,1x,a)')
     *        stat(ichan),compd(ichan),' Not found in trace file'
           endif
         endif
         if(.not.exist.or.ierr.eq.1) then
           write(6,*)' Cannot find waveform file',ierr
           chan(ichan)=0
	   cinter(ichan)=0.0
	   tstart(ichan)=0.0
         else
           if(check.eq.1) write(6,*)'chan',chan(ichan)
c          rewind wav_unit 
           call seisinc
     *     (wav_unit,chan(ichan),ncbid,2,mmhead,chead,0.0,0.0)
c
c   get sample rate and number of samples
c
           read(chead(37:43),'(f7.2)')rate
           read(chead(45:50),'(i6)') nsamp
c
c  get abs trace file start time
c
           call timsec(wyear,wmonth,wday,whour,wmin,wsec,wtime)
           if(check.eq.1) write(6,*) wyear,wmonth
c
c   calculate start time for window  (origin time) relative to first
c   sample in trace data and check if window length should be reduced
c
           tstart(ichan)=otime-wtime -delay_chan(ichan)
           delay(ichan)=0.0
           cinter(ichan)=amin1(window,(nsamp-1)/rate-tstart(ichan))
           if(tstart(ichan).lt.0.0) then
              cinter(ichan)=amin1(window+tstart(ichan),(nsamp-1)/rate)
              delay(ichan)=abs(tstart(ichan))
              tstart(ichan)=0.0
           endif
         endif
c
c   put in data for synthetic channels
c
         tstart(ichan+1)=t0-t0synt(jstat(ichan+1)) -delay_chan(ichan+1)
         delay(ichan+1)=0.0
         cinter(ichan+1)=amin1(window,dtt*(nsynt-1)-tstart(ichan+1))
         if(tstart(ichan+1).lt.0.0) then
            cinter(ichan+1)=amin1(window+tstart(ichan+1),dtt*(nsynt-1))
            delay(ichan+1)=abs(tstart(ichan+1))
            tstart(ichan+1)=0.0
         endif
c
 1000 continue
c
c   make main header and file name
c
      net_code='     '
      call mfhead(oyear,omonth,oday,ohour,omin,osec,window,nchan*2,
     *           net_code,stat,comp,delay,cinter,file,mhead)
c
c   get vital info for header
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: ST-D-RK:') 
     &         read(data(i),'(15x,3f10.2)') strike, dip, rake
         if(data(i)(2:15).eq.'SYNT: DEPTH--:') 
     &         read(data(i),'(15x,f10.2)') depth
      enddo
      istrike=strike+0.5
      idip=dip+0.5
      irake=rake+0.5
c 
      write(mhead(1)(2:30),271) depth,istrike,idip,irake,nsynt
 271  format('H',f5.1,1x,'SDR',i4,i3,i4,1x,'N',i4)

      chr_f_form$ = 'unformatted'


      if (codsyn.eq.'SB ')  
     *    call sei open( unknown$,                ! Open file.
     &                   ' ',                     ! No prompt.
     &                   'bousei.out',            ! On this file.
     &                   unit_out,                ! On this unit.
     &                   b_flag,                  ! File exists?
     &                   code )                   ! Returned condition.

      if (codsyn.eq.'SH ')  
     *    call sei open( unknown$,                ! Open file.
     &                   ' ',                     ! No prompt.
     &                   'hersei.out',            ! On this file.
     &                   unit_out,                ! On this unit.
     &                   b_flag,                  ! File exists?
     &                   code )                   ! Returned condition.
      if (codsyn.eq.'SW ')  
     *    call sei open( unknown$,                ! Open file.
     &                   ' ',                     ! No prompt.
     &                   'wkbjsei.out',           ! On this file.
     &                   unit_out,                ! On this unit.
     &                   b_flag,                  ! File exists?
     &                   code )                   ! Returned condition.
c
c   read channels and write out, first header
c
c
      write(6,'(1x,a)') mhead(1)(1:70)
      do i=1,12
         write(unit_out)mhead(i)
      enddo
c
c
c   write remaining main header lines if more than 30
c
         if(nchan.gt.30) then
            k=(nchan-31)/3+1
            do i=13,k+12
               write(unit_out) mhead(i)
            enddo
         endif

c
c---------------------------------
      do 2000 ichan=1,2*nchan,2
c---------------------------------
c
      kchan=ichan
      ilec=0
c
c      if transverse, skip the reading
c      if radial, read the EAST component after having read the NORTH
c
      if (comp(ichan)(4:4).eq.'T')  goto 61
  60  continue
      if (comp(ichan)(4:4).eq.'R'.and.ilec.eq.1) kchan=ichan+2
c
c   rewind output file from main program
c
      rewind 20
c
c   read one trace
c
      if(check.eq.1) write(6,*)'call seisin'
c
c   if the channel is there, then read it, else generate some data
c
      if(chan(kchan).ne.0) then
c        rewind wav_unit 
         call seisinc(wav_unit,chan(kchan),ncbid,2,mmhead,chead,0.0,0.0)
c
c   get sample rate and number of samples
c
         read(chead(37:43),'(f7.2)')rate
         read(chead(45:50),'(i6)') nsamp
         if(check.eq.1) write(6,*)'rate,nsamp',rate,nsamp
c
c   select window
c
         n1=tstart(kchan)*rate+1
         n2=(tstart(kchan)+cinter(kchan))*rate+1
         j=0
         do i=n1,n2
           j=j+1
           signal(j)=signal(i)
         enddo
         n=j
      else
         do i=1,1040
           chead(i:i)=' '
         enddo
         chead(1:5)=stat(kchan)
         chead(6:9)=comp(kchan)
         signal(1)=0
         n=1
         rate=50.0
      endif
c
      if (.not.radial.or.compd(kchan)(4:4).eq.'Z')  then
        cheadsave=chead
        goto 70
      endif
c
c
      if (radial.and.compd(kchan)(4:4).eq.'N')   then
        do i=1,n
          signaln(i)=signal(i)
        enddo
        cheadsave=chead
        ilec=1
        goto 60
      endif
      if (radial.and.compd(kchan)(4:4).eq.'E')   then
c           verify that the two components have compatible parameters
        if(chead(1:5).ne.cheadsave(1:5).or.
     *      chead(10:77).ne.cheadsave(10:77))    then
          write (*,'(a)') 'incompatible headers for horizontal compo:'
          write (*,'(a)') cheadsave(1:77)
          write (*,'(a)') chead(1:77)
          stop
        endif
c           verify that the transfer fonctions are similar at 5%
          read (cheadsave(241:249),'(g8.3)')  ampln
          read (chead(241:249),'(g8.3)')  ample
              write (*,'(a,a,2g8.3)')
     *        'transfer functions at ',stat(ichan),ampln,ample
          if(ampln.eq.0..and.ample.eq.0.)   goto 65
          dampl=2.*(ampln-ample)/(ampln+ample)
          if (dampl.gt.0.05) write (*,'(a,a,2g8.3)')
     * 'transfer functions quite different at ',stat(ichan),ampln,ample
 65       continue
        do i=1,n
          signale(i)=signal(i)
        enddo
      endif
c   put to zero the part of the header concerning instrument
      do i=81,1040
        cheadsave(i:i)=' '
      enddo
c
c    reading the backazimuth
c
      do i=1,ndata
        if(stat(ichan).eq.data(i)(17:21).and.
     *      data(i)(47:55).eq.' BAZIMUT:'.and.data(i)(80:80).eq.'3')
     *      read(data(i)(56:65),'(f10.1)') backazi
      enddo
      caz = -cos(backazi*3.14159/180.)
      saz = -sin(backazi*3.14159/180.)
c
c       making the radial component (away from the source)
c
      do i=1,n
        signal(i) = caz*signaln(i) + saz*signale(i)
      enddo
      goto 62
 61   continue
c
c       making the transversal component
c
      do i=1,n
        signal(i) = -saz*signaln(i) + caz*signale(i)
      enddo
 62   continue
c
c  modify channel header for new start time, which should be origin time, same
c  as mainhead, or, if a delay, unchanged in time relative to original
c  main header.
c  write the data elements in cheadsave, because chead is used to write
c  the elements related to the synthetics, and we have to write
c  alternatively data R, synthetics R, data E and synthetics E
c  (therefore some mix-up occurs if one uses chead in all cases)
c
 70   continue
      if(delay(ichan).eq.0.0) then
        cheadsave(10:35)=mhead(1)(34:59)
      else
        cheadsave(10:35)=mmhead(1)(34:59)
      endif
      write(cheadsave(45:50),'(i6)') n
      write(cheadsave(37:43),'(f7.2)') rate
      cheadsave(6:9)=comp(ichan)
c   write down the header for the data
      write(unit_out) cheadsave
      write(6,'(1x,a)') cheadsave(1:70)
c
c   convert to integers
c
      if(cheadsave(77:77).eq.'4') then
         do i=1,n
           isignal(i)=signal(i)
         enddo
         write(unit_out) (isignal(i),i=1,n)
      else
         do i=1,n
            isignal2(i)=signal(i)
         enddo
         write(unit_out) (isignal2(i),i=1,n)
      endif
c
c   find synthetics in output file, only check that component is ok,
c   assume that stations are in correct order

c
 700  continue
      read(20,'(a)',end=701) text
        if(text(1:5).eq.stat(ichan).and.
     *     text(9:9).eq.comp(ichan+1)(4:4)) then
           read(20,*) (signal(i),i=1,nsynt)
        else
           goto 700
        endif
      goto 702
  701 continue
      write(6,'(1x,a5,a4,a)') stat(ichan),comp(ichan+1),
     *              ' Not found in synthetic file, will zero'
      do i=1,nsynt
        signal(i)=0
      enddo
  702 continue
c
c   write synthetic channel
c
      chead(6:9)=comp(ichan+1)
      syntrate=1./dtt
      write(chead(37:43),'(f7.2)') syntrate
      do i=81,1040
        chead(i:i)=' '
      enddo
c
c   indicate 4 byte integers
c
      chead(77:77)='4'
c
c  calculate header time
c
      stime=otime+delay(ichan+1)
      call sectim(stime,syear,sdoy,smonth,sday,shour,smin,ssec)
      write(chead(10:35),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *               syear-1900,sdoy,smonth,sday,shour,smin,ssec
c
c   shift synthetic signal according to delay
c
      n1=tstart(ichan+1)*syntrate+1
      n2=(tstart(ichan+1)+cinter(ichan+1))*syntrate+1
      j=0
      do i=n1,n2
        j=j+1
        isignal(j)=signal(i)
      enddo
      ns=j
      write(chead(45:50),'(i6)') ns
c
c  write header and data
c
      write(unit_out) chead
      write(6,'(1x,a)') chead(1:78)
      write(unit_out)(isignal(i),i=1,ns)
      if(check.eq.1) write(6,*)
     *' rate,tstart,ns,nsynt',syntrate,tstart(ichan+1),ns,nsynt
	  if(check.eq.1) write(6,*)(signal(i),i=1,10)
 2000 continue
c
c   close files
c
      if(exist)call sei close( close$, wav_unit, code ) ! Close (Default stop on error).
c     call sei close( close$, unit_out, code ) ! Close (Default stop on error).

      return
      end
c
c----------------------------------------------------------------------------

c************************************************************************        
       subroutine delip(m,n,np,res,test,smajax,sminax,thetadeg,
     &distind,iflagd,c_lat,std_1)
c
c   subroutine to calculated 
c
c
c            Yochai Ben Horin 1998 
c The covariance matrix is normalized with statistic for n+1 degrees of 
c freedom, the first step is to change the normalization to 2 degrees of 
c freedom and to move from calculation in degrees to km by multipyling
c with the radius of the earth 6378km  then performing rotation on the 2x2
c matrix in order to get diagonal matrix.
c
c
c   m -> number of columns in the SVD matrix
c   n -> number of rows in the SVD matrix
c   np-> number of eigenvectors used in subroutine corr (hyposub2.for)
c   res-> squared weighted sum
c   c_lat->Latitude
c   output
c   smajax, sminax and thetadeg
c  reference: "Confidence Regions and Error Determinations for Seismic Event 
c            Event Location" E.A. Flinn, Reviews of Geophysics Vol.3 1965. 
c             
C
c
c************************************************************************
c      
c     implicit none
      include 'hypparm.inc'
      include 'libsei.inc'
c     include 'comm1.inc'
c     dimension test(1)
      real pi,twopi,halfpi,rad,deg,syy,sxx,sxy,theta
      real smajax,smajaxt,sminax,sminaxt,thetadeg
      real c,si,cc,sisi,rearth,rearth2
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (rearth=6378.)
c************************************************************************
c replacing the F-distribution for np+1 degrees of freedom with F-dist 
c************************************************************************
c local event degs 
      degfb=test(86)    !changed test(87) to test(86) 6/98 BRL
      errb=test(85)
c distant case
      if(distind.eq.'D'.or.iflagd.eq.1)then  !changed 6/98, brl
       degfb=test(92)
       errb=test(91)
      endif
      ndeg=int(degfb+0.499999) !this is K IDC use 99999
c this part reproduce the statistical parameters which were used in the corr function in order
c to normelize the covariance matrix 
      cres=(degfb*errb**2+res)/(degfb+float(n)-float(np+1))
      rs=float(np+1)*cres*fdist(np+1,ndeg+n-np-1,test(87))
c************************************************************************       
c  Statistical factors for two dimention ellipse
      cres2=(degfb*errb**2+res)/(degfb+float(n)-float(2))
      rs2=float(2)*cres2*fdist(2,ndeg+n-2,test(87))
c************************************************************************       
c     write(6,*)var(2,2),var(1,1),var(1,2)
      rearth2=rearth*rearth
      rearthx=rearth*cos(c_lat*rad) ! from epicenter to rotation axis
      syy=var(2,2)*rearth2/rs !deg->km; removing of statistical factors
      sxx=var(1,1)*rearthx*rearthx/rs
      sxy=var(1,2)*rearth*rearthx/rs
      szz=var(3,3)*rearth*rearth/rs
      szy=var(3,2)*rearth*rearth/rs
      szx=var(3,1)*rearth*rearthx/rs
      std_1(1,1)=sqrt(sxx*rs2) !std_1(1,#) is the errors WITH statistics IN (2d)
      std_1(1,2)=sqrt(syy*rs2)
      std_1(1,3)=sqrt(szz*rs2)
      std_1(1,4)=szy*rs2
      std_1(1,5)=szx*rs2
      std_1(1,6)=sxy*rs2
      std_1(2,1)=sqrt(sxx)  !std_1(2,#) is the errors WITHOUT statistics IN (2d)
      std_1(2,2)=sqrt(syy)
      std_1(2,3)=sqrt(szz)
      std_1(2,4)=szy
      std_1(2,5)=szx
      std_1(2,6)=sxy
c set error to 999.9
      do i=1,2
        do j=1,3
           if(std_1(i,j).gt.999.9)std_1(i,j)=999.9
           if(std_1(i,j).eq.0.0)std_1(i,j)=999.9
        enddo
      enddo
      if(m.eq.2)std_1(1,3)=0.0
      if(m.eq.2)std_1(2,3)=0.0
c
	theta=0.5*atan2(2.0*sxy,syy-sxx) !calculating rotation angle
	c=cos(theta)
	si=sin(theta)
	cc=c*c
	sisi=si*si
	smajaxt=sxx*sisi+2.0*sxy*si*c+syy*cc !calculating eigenvalues
	sminaxt=sxx*cc-2.0*sxy*si*c+syy*sisi
      if(smajaxt.lt.0.0.or.sminaxt.lt.0.0)goto22
	smajax=sqrt(smajaxt*rs2) ! axis  including statistical factor for 2-d
	sminax=sqrt(sminaxt*rs2)
	if(theta.lt.0.0) theta=theta+twopi
	if(theta.gt.twopi) theta=theta-twopi
	if(theta.gt.pi) theta=theta-pi
	thetadeg=deg*theta
	goto 23
  22    smajax=-1.
	sminax=-1.
	thetadeg=-1.
  23    return
        end

c################################################################               
c                                                                               
      subroutine abstim(timestring,fstart,time)                                 
c                                                                               
c   converts a data base timestring to to abs time, time,                       
c   from 1900. if fstart ne 0, the time string is the data                      
c   base file name, else a simple time string                                   
c                                                                               
c   oct 91 by j. havskov                                                        
c                                                                               
c   updates:     
c   aug 15 92 by jh : bgs type                                                               
c   jan 98    by jh : year 2000
c   aug 98          : --------- version 7.0 check --------------
c                   : long file names
c             
      implicit none                                                             
      character*80 timestring                                                   
	  double precision time                                                        
	  integer fstart                                                               
	  integer year,month,day,hour,min,isec                                         
	  real sec                                                                     
c                                                                               
c   read time                                                                   
c
       if(fstart.eq.0) then                                                      
	     read(timestring(1:14),
     *   '(i4,5i2)') year,month,day,hour,min,isec           
       else                                                                      
           read(timestring(fstart:fstart+19),                     
     *    '(i2,1x,2i2,1x,i2,3x,i4,i2)')                                     
     *    day,hour,min,isec,year,month                                          
       endif                                                                        
       sec=isec                                                                     
c                                                                               
c   convert                                                                     
c                                                                               
      call timsec(year,month,day,hour,min,sec,time)                             
	  return                                                                       
	  end                                                                          

      SUBROUTINE SEISINC
     *(UNIT,ICH,NCHAN,MODE,MAINHEAD,TRACEHEAD,START,WINDOW)
c
C                                                                               
C   READS ONE TRACE FROM SEISAN FILE, OUTPUT TRACE IN X                        
C   AS REALS. UNIT IS UNIT TO READ FROM, ICH IS CHANNEL                        
C   WANTED, NCHAN IS NUMBER OF CHANNLES AVAILABLE.                              
C   MAINHEAD AND TRACEHEAD ARE SEISAN HEADERS
C   START IS START TIME RELATIVE TO MAIN HEADER AND WINDOW IS WINDOW
C   IN SECS. IF BOTH ZERO, USE WHOLE TRACE.                                  
C   IF A CHANNEL IS ASKED FOR WHICH IS NOT THERE,  a stop command is issued             
c
c   The file must be opened with direct access and record lenght of 2048
c
c   If rotate is set, and both horizontal channels are there, R is 
c   returned instead of N and T instead of E. The rotation angle is in
c   backazimuth.
c                                                                               
C   mode: 0: read main header only                                                 
c         2: read channel only
c         3: read channel header only                                                  
c                                                                               
C                                                                               
C    J. HAVSKOV MAR 91                                                          
C                                                                               
c    updates
c    feb 1 92 by j.h.: add 4 byte integer option
c    aug 93          : fix up
c    sep 16          : check for neg or zero number of samples
c    sep 27          : reduce more if maxdim approached
c    dec 93          : also use start tiem and window, fix output if too many
c    jun 94          : 999 channels
C!JAB(BGS)Dec94      : Install File & error handlers..
c    mar 95          : 3 component rotation
c    apr 28, 94      : az bug
c    oct 95          : new direct access routine
c    nov 20          : change comparison old-new
c    dec 13          : compare 250 chars instead of 80, failed with 80
c    feb 11 97       : in buf_read, check of enough channels moved down so no
c                      stop when mode =0
c    dec 9           : take gain constant into new consideration
c    mar 24 98       : reset old_chan if rotate
c    sep 98 by jh    : --------------   version 7.0 check ---------------------
c                      correct century, change for 5 character stations
c    oct 23          : bug when using rotation and 30 channels
c    nov2      jh    : add linux capability
c    feb 4  99 jh    : bug with correction of oct 23
c    feb 28          : read gain constant from 148:159 instad of 149:160
c                      there was a conflict with signalling in mulplt
c    sep 24 99       : a wrong eof casused crash sometimes
c    sep 25 99       : stop if not a seisan file
c    april 8 2000    : enable to read channel header only
c    nov 17 2004 jh  : buffer not dimensioned to enough channels
c    june 10 2008 jh : enable reading of 64 bit write, only tested on linux
c
      implicit none
      save
c-- array dimentions
c
      include 'seidim.inc'              ! array dimentions
c-- MAIN HEADERS                                
      CHARACTER*80 	MAINHEAD(*)		
c-- SINGLE TRACE HEADER                           
      CHARACTER*1040	TRACEHEAD		
      character*35 chead_first          ! part of trace head used with rotation
c-- FILE UNIT TO READ FROM                                  
      INTEGER		UNIT			
c-- NUMBER OF CHANNELS                             
      INTEGER		NCHAN,nchannel		
c-- CHANNEL CHOSEN                                  
      INTEGER           ICH			
c-- operating mode                                          
      integer		mode			
c-- ALL DATA, one channel                                      
      REAL		X(max_sample)			
      real      y(max_sample)   ! work space used when rotating
      character*5 stat(max_trace)  ! stations
      character*4 comp(max_trace)  ! components
      character*5 station       ! station to look for
      real        del( max_trace) ! delay each trace
      real        dur( max_trace) ! duration each trace
      real        del_rot       ! delay rotated trace
      real        dur_rot       ! duration --------
      integer     nstart1,nstart2,nstop1,nstop2 ! start and stop point each ch.
      character*4 other_component  ! other horizontal component
      integer other_chan        ! channel number of other hozontal channel
c-- NUMBER OF SAMPLES                                      
      INTEGER		NSAMP	
c-- time of main header and channel header
      integer myear,mmonth,mday,mhour,mmin,cyear,
     *cmonth,cday,chour,cmin,doy
      real msec,csec
      double precision mtime,ctime
c-- start and window
      real start,window
      integer nstart,nstop
c-- sample rate and delay
      real rate,delay
c-- for component rotation
cx      real caz,saz
cx      real baz(max_trace)
cx      character*1 rot_comp(max_trace)  ! T or R
cx      logical rotate
c-- COUNTERS                                          
      INTEGER		I,k,j
c
cx      common /signal/x,rotate,baz,rot_comp,del_rot
      common /signalx/x
C
C    Seisan library inserts and routines...
C    ======================================
C
       include  'libsei.inc'               ! Library definitions & data defns.
       external  sei code                  ! Error encoder.
C
C    ============= end of list ==========
c
c
       other_chan=0    ! initially only read one channel
cx       del_rot=-9999.9 ! no delay due to rotation initially
c
c  read data
c
      call buf_read(unit,ich,nchannel,mode,mainhead,tracehead)
c     write(6,*) ich,nchannel
c                                                                               
c   return nchan and save nchannel                                              
c                                                                               
      nchan=nchannel                                                            
c                                                                               
c   return if only main header read                                             
c                                                                               
      if(mode.eq.0) return                                                      
c
c   read number of samples
c
      READ(TRACEHEAD,'(43X,I7)') NSAMP
c
c---------------------------------------------------------------------
c   check if a time window is selected                                                              
c---------------------------------------------------------------------
c                                    
      if(window.ne.0.0.and.start.ne.0.0) then
c
c   get header times
c
         read(mainhead(1)(34:59),
     *  '(i3,1x,i3,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3)')
     *   myear,doy,mmonth,mday,mhour,mmin,msec                        
         myear=myear+1900
         call timsec(myear,mmonth,mday,mhour,mmin,msec,mtime)                      
         read(tracehead(10:35),
     *   '(i3,1x,i3,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3)')
     *   cyear,doy,cmonth,cday,chour,cmin,csec
         cyear=cyear+1900      ! correct for missing century                                           
         call timsec(cyear,cmonth,cday,chour,cmin,csec,ctime)                      
         read(tracehead(37:43),'(f7.3)') rate
c
c   calculate samples to extract, first check if start point available
c
         delay=ctime-mtime
         if(delay.gt.start) then
            write(6,*)' Data start not available'
            goto 800                         
         endif

         nstart=(start-delay)*rate+1
         nstop=nstart+window*rate
c
c   check if enough data
c
         if(nstop.ge.nsamp) then
            write(6,*)' Too much data required, beyound end of trace'
            goto 800
         endif
c
         nsamp=window*rate+1
c
c   select data
c
         do i=1,nsamp
           x(i)=x(i+nstart-1)
         enddo        
         goto 900
c
c   put in dummy samples if somthing is wrong
c
 800  continue
         nsamp=3                         
         x(1)=1.0
         x(2)=1.001
         x(3)=1.01
 900  continue
c
c   update trace head with samples written in output array
c
         write(tracehead(44:50),'(i7)') nsamp
      endif
cx      if(.not.rotate) rot_comp(ich)=tracehead(9:9)
c
c--------------------------------------------------------------------
c  check if rotation
c--------------------------------------------------------------------
c
cx      if(.not.rotate) return
c
c   check if a horizontal component
c
cx      if(tracehead(9:9).ne.'N'.and.tracehead(9:9).ne.'E') return
c 
c   check if angle is available, if not, return
c
cx      if(baz(ich).eq.999.0) return
c
c   look for availability of other channel
c
cx      other_component=tracehead(6:9)
cx      station=tracehead(1:5)
cx      if(tracehead(9:9).eq.'N') then 
cx         other_component(4:4)='E'
cx      else
cx         other_component(4:4)='N'
cx      endif
cxc
c   read header info
c
cx      j=1
cx      do i= 3,(nchannel-1)/3+3
cx         read(mainhead(i),100)
cx     *   stat(j)  (1:4),comp(j),  stat(j)  (5:5),del(j),  dur(j),
cx     *   stat(j+1)(1:4),comp(j+1),stat(j+1)(5:5),del(j+1),dur(j+1),
cx     *   stat(j+2)(1:4),comp(j+2),stat(j+2)(5:5),del(j+2),dur(j+2)
cx100      format(1x,a4,a4,a1,f7.2,1x,f8.2,1x,a4,a4,
cx     *   a1,f7.2,1x,f8.2,1x,a4,a4,a1,f7.2,1x,f8.2)
cx         j=j+3
cx      enddo
cxc
c   find if channel is there
c
cx      other_chan=0
cx      do i=1,nchan
cx         if(station.eq.stat(i).and.other_component.eq.comp(i))
cx     *   other_chan=i
cx      enddo
c
c   return if channel not found, the horizontal channel remain unchanged
c
cx      if(other_chan.eq.0) return
cx      nstart1=1
cx      nstart2=1
cx      read(tracehead(37:43),'(f7.3)') rate  ! assume same s. rate N and E
cx      nstop1=dur(ich)*rate+1    
cx      nstop2=dur(other_chan)*rate+1
c
c   check if both channels have the same start time and duration
c
cx      if(dur(other_chan).ne.dur(ich).or.del(other_chan).ne.del(ich)) 
cx     *then                     ! channels different, must be corrected
c
c   find common start time, first and last point in each channel
c   if other chan starts later, use that for header time, if current
c   channel start later, save that time and put into header for rotated
c   channel after rotation
c
cx         if(del(other_chan).gt.del(ich)) then
cx            chead_first='                                   ' ! not start time
cx            del_rot=del(other_chan)
cx            nstart1=(del(other_chan)-del(ich))*rate+1
cx         else
cx            del_rot=del(ich)
cx            chead_first=tracehead(1:35)   ! save rotated channel start time
cx            nstart2=(del(ich)-del(other_chan))*rate+1
cx         endif
c
c   find end points
c
cx         if((dur(ich)+del(ich)).gt.(dur(other_chan)+del(other_chan)))
cx     *   then
cx            nstop1=(dur(ich)-
cx     *      ((dur(ich)+del(ich))-(dur(other_chan)+del(other_chan))))*
cx     *      rate
cx         else
cx            nstop2=(dur(other_chan)-
cx     *      ((dur(other_chan)+del(other_chan))-(dur(ich)+del(ich))))*
cx     *      rate
cx          endif
cx          dur_rot=float(nstop1-nstart1-1)/rate
cx      endif
c
c   save first channel
c
cx      k=1
cx      do i=nstart1,nstop1
cx         y(k)=x(i)
cx         k=k+1
cx      enddo
c
c   read second horizontal channel 
c
cx      call buf_read(unit,other_chan,nchannel,mode,mainhead,tracehead)
c
c   check if both channels have the same start time and duration
c   if not, select appropriate window
c
cx      if(nstart1.ne.nstart2.and.nstop1.ne.nstop2) then
cx         k=1
cx         do i=nstart2,nstop2
cx            x(k)=x(i)
cx            k=k+1
cx         enddo
cx         nsamp=nstop1-nstart1+1
cxc
c   update trace head with samples written in output array
c
cx         write(tracehead(44:50),'(i7)') nsamp
c
c   get correct start time for channel
c
cx         if(chead_first(11:19).ne.'         ')
cx     *   tracehead(11:35)=chead_first(11:35)
cx      endif
c
c   do rotation, two components are in x and y, however they can be
c   either N or S, so check when rotating
c
cx      caz = -cos(baz(ich)*3.14159/180.)
cx      saz = -sin(baz(ich)*3.14159/180.)
c
c       making the radial component (away from the source)
c
cx      if(other_component(4:4).eq.'E') then
cx         do i=1,nsamp
cx           x(i) = caz*y(i) + saz*x(i)    ! y is N
cx         enddo
cx         tracehead(9:9)='R'              ! indicate different component
cx      else
c
c       making the transversal component
c
cx         do i=1,nsamp
cx            x(i) = -saz*x(i) + caz*y(i)  ! x is N
cx         enddo
cx         tracehead(9:9)='T'
cx       endif
c
c   clear other_chan so a new rotation can be made
c
cx       other_chan=0
cx       rot_comp(ich)=tracehead(9:9)
c

      RETURN                                                                    
      END                                                                       
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine buf_read
     *(unit,chan_wanted,nchan,mode,main_head,chan_head)
c
c   reads one channel of seisan waveform data from a binary file written
c   on sun, linux or pc, not tested on other computers
c
      implicit none
      save
      include 'seidim.inc'
      integer unit                        ! unit to read from
      integer mode                        ! see seisinc
      character*29000 buffer              ! buffer when reading
      character*250   old_buffer          ! first chars of old file
      character*80 main_head(*)
      character*1040 chan_head            ! channel header
      character*3 computer                ! computer where file was written
      integer rec_size                    ! number of bytes in one read
      character*4 swap4                   ! used for swapping 4 byte data
      character*1 swap2                   ! used for swapping 2 byte data
      integer i,j,k,l,m
      integer record_to_read              ! next record to read, also current
      integer record_read                 ! last record read
      integer byte_nr_used                ! last byte nr used in file
      integer byte_nr_read                ! last byte nr read in file
      integer buf_byte_nr_read            ! last byte read into buffer
      integer buf_byte_nr_used            ! last byte used in buffer
      integer head_bytes                  ! number of bytes in main header
      integer head_lines                  ! number of lines in main header
      integer nsamp                       ! number of samples in buffer
      integer nchan                       ! number of channels in file
      integer nbuf                        ! number of buffers to read in one go
      integer chan_bytes                  ! number of bytes, one channel
      integer bytes_sample                ! number of bytes pr sample
      integer byte_nr_chan(max_trace+1)   ! byte nr of start of channel
      integer chan_current                ! current channel number
      integer old_chan                    ! previous channel number
      integer chan_wanted                 ! channel nr wanted
      integer khead                       ! number of bytes in block separater
      logical bit64                       ! if true, a 64 bit system
      character *1 data_byte(max_sample*4) ! data as characters
      integer*2    data2(max_sample*2)     ! data as 2 byte integers
      integer*4    data4(max_sample)       ! data as 4 byte integers
      real gain                            ! gain factor to get real sample values
      real x(max_sample)                   ! data as reals
      logical sun,linux,pc                 ! current computer type
c-- for component rotation, not used in this routine
cx      real baz(max_trace)
cx      real        del_rot       ! delay rotated trace
cx      character*1 rot_comp(max_trace)  ! T or R
cx      logical rotate
c
      equivalence (data2,data4)
      equivalence ( data_byte,data2)
c     equivalence (data4,x)
cx      common /signal/x,rotate,baz,rot_comp,del_rot
      common /signalx/x,data4
c
c   get computer type
c
      call computer_type(sun,pc,linux)
c
c   set record size, at least 2048
c
      rec_size=2048
      record_to_read=1
c
c   read first record
c
      read(unit,rec=record_to_read,err=10) buffer(1:rec_size)
c
c   determine where file was written
c
      computer='   '
      bit64=.false.
      khead=4
c
      if(buffer(1:2).eq.'KP')  computer='pc '
      if(buffer(1:1).eq.'P')   computer='lin'
      if(buffer(4:4).eq.'P')   computer='sun'
      if((buffer(89:89).eq.'P'.and.buffer(185:185).eq.'P'.and.
     *   buffer(281:281).eq.'P').or. 
     *  (buffer(96:96).eq.'P'.and.buffer(192:192).eq.'P'.and.
     *   buffer(288:288).eq.'P')) then
         bit64=.true.
         khead=8
      endif
c     write(6,*) 'bit64',bit64
      if(computer.eq.'   ') then
         write(6,*)
     *  ' The input waveform file does not have SEISAN format'
         write(6,*)' Return to stop'
         read(5,'(a)') computer
         stop
      endif
c
c   check if file already has been used by comparing old and new buffer.
c   for some reason, the non initialized
c   text string old_buffer will compare equal to the read text string
c   buffer, so the strings cannot be compared and the sum of the ascii
c   values are used instead
c
      k=0
      l=0
c     do i=1,80
c        k=k+ichar(old_buffer(i:i))
c     enddo
c     do i=1,80
c        l=l+ichar(buffer(i:i))
c     enddo
c       if(k.eq.l) then
       if(old_buffer.eq.buffer(1:250)) then
c          write(6,*)'old buffer'
c                                                                               
c   return if same channel is selected as privious time unless rotate is set
c   in which case it might have to be read in again                         
c                                                                               
cx          if(chan_wanted.eq.old_chan.and.mode.eq.2.and.(.not.rotate)) 
          if(chan_wanted.eq.old_chan.and.mode.eq.2) 
     *    return
          if(mode.eq.0) return             ! header already read
c
c   find until which channel file already read
c
         do i=1,chan_wanted
            if(byte_nr_chan(i).eq.-1) then
                chan_current=i-2          ! one added below, so -2
                goto 1                    ! wanted channel not read
            endif
         enddo
         chan_current=chan_wanted-1       ! subtract one since one added below
         goto 1                           ! wanted channel already read
      else
c          write(6,*) 'NEW BUFFER'
         do i=1,max_trace+1
            byte_nr_chan(i)=-1            ! initialize pointer
            old_chan=-1                   ! no old chan
         enddo
      endif   
      old_buffer=buffer(1:250)
c      write(6,'(a,a)') ' File written on ',computer
c
c  get number of channels to decide if more buffers must be read
c  to get complete main header
c
      if(computer.eq.'sun'.or.computer.eq.'lin'.and..not.bit64)
     * read(buffer,'(34x,i3)') nchan
      if((computer.eq.'sun'.or.computer.eq.'lin').and.bit64) 
     * read(buffer,'(38x,i3)') nchan
      if(computer.eq.'pc ') read(buffer,'(32x,i3)') nchan

c      write(6,*) 'nchan',nchan    ! test out
c
c   calculate how many buffers are needed to read all main headers
c
c        head_lines=12            ! always at least 12 lines
         buf_byte_nr_read=rec_size
         if(nchan.gt.30) then
            head_lines=(nchan-31)/3+13
         else
            head_lines=12
         endif
            if(computer.eq.'pc ') head_bytes=head_lines*82+2
            if(computer.eq.'sun'.or.computer.eq.'lin') 
c64  *        head_bytes=head_lines*88
     *        head_bytes=head_lines*(80+2*khead)
            nbuf=(head_bytes-1)/rec_size+1
            k=rec_size+1
            if(nbuf.gt.1) then
               do record_to_read=2,nbuf
                  read(unit,rec=record_to_read) buffer(k:k+rec_size-1)
                  k=k+rec_size
               enddo
c               buf_byte_nr_read=k-1
               record_to_read=nbuf
            endif
c        endif
         buf_byte_nr_read=record_to_read*rec_size
c
c   put in main header records in variables by stripping away record
c   separators, different on sun and pc and 64 bit systems
c
      if(computer.eq.'sun'.or.computer.eq.'lin') then
c64     k=5
        k=khead+1
        j=k+79
        do i=1,head_lines
           main_head(i)=buffer(k:j)
           buf_byte_nr_used=j
c64        k=k+88
           k=k+80+2*khead
           j=k+79
        enddo
      endif
      if(computer.eq.'pc ') then
        k=3
        j=k+79
        do i=1,head_lines
           main_head(i)=buffer(k:j)
           buf_byte_nr_used=j
           k=k+82
           j=k+79
        enddo
      endif
c     do i=1,head_lines
c       do j=1,80
c         if(ichar(main_head(i)(j:j)).eq.0) main_head(i)(j:j)=' '
c       enddo
c     enddo
c
c   calculate byte nr of first byte in first channel header
c
      byte_nr_chan(1)=buf_byte_nr_used+1
    
c      do i=1,head_lines
c        write(6,'(1x,a)') main_head(i)
c      enddo
c
c   return if only header is read
c
      if(mode.eq.0) return
c                                                                               
c   check if channel is available                                               
c
      if(chan_wanted.gt.nchan) then
         write(6,*)' Too high channel number demanded'
         write(6,*)' Channel wanted: ',chan_wanted
         write(6,*)' Number of channels available ',nchan
         stop
      endif                                                                     
c	  
c   read down to channel chan_wanted
c
      chan_current=0
c
c--------------------------------------------------------------------------
c   start of loop for reading channels
c--------------------------------------------------------------------------
c
       
 1    continue                  
      chan_current=chan_current+1
c
c   calculate record to read to get channel header
c
      record_to_read=(byte_nr_chan(chan_current)-1)/rec_size+1   
c
c   read record into buffer
c
c2000      read(unit,rec=record_to_read,end=60,err=10) buffer(1:rec_size)
      read(unit,rec=record_to_read,err=60) buffer(1:rec_size)
c
c  allow eof here could be near end of file
c
  60  continue
      byte_nr_read=record_to_read*rec_size
c
c   calculate byte nr where header starts in buffer meaning the first
c   byte of the record separator in front of all header bytes meaning
c   both the end of the previous and the start of the next buffer
c
      k=rec_size - byte_nr_read + byte_nr_chan(chan_current)
c	  write(6,*) 'kstart,bread,bchan',k,byte_nr_read,byte_nr_chan
c
c   calculate if there are enough bytes in the buffer to get the whole
c   header, else read the next record 
c
       buf_byte_nr_read=rec_size
c64    if(rec_size-k.lt.1068) then    ! why 1068, not 1048 ??
       if(rec_size-k.lt.1060+khead*2) then
         record_to_read=record_to_read+1
c2000 pc         read(unit,rec=record_to_read,end=61,err=10) buffer(rec_size+1:
         read(unit,rec=record_to_read,err=61) buffer(rec_size+1:
     *   rec_size+rec_size)
c
c   allow eof here, could be ok
c
 61      continue
	     buf_byte_nr_read=buf_byte_nr_read+rec_size

         byte_nr_read=byte_nr_read+rec_size
      endif       
c
c   fish out the channel record, 1040 bytes long
c
      if(computer.eq.'sun'.or.computer.eq.'lin') then
c64      chan_head=buffer(k+8:k+1047)    ! no separaters
         chan_head=buffer(k+khead*2:k+1039+khead*2)    ! no separaters
c64      buf_byte_nr_used=k+1047
         buf_byte_nr_used=k+1039+khead*2
      else
         j=1
         do i=1,8
           chan_head(j:j+127)=buffer(k+2:k+2+127) ! a separater every 128 bytes
           k=k+130
           j=j+128
         enddo
         chan_head(j:j+15)=buffer(k+2:k+15+2)
         buf_byte_nr_used=k+15+2
      endif

c	  k=1
c	  do i=1,13
c	    l=k+79
c        write(6,'(1x,a80)')chan_head(k:l)
c        k=k+80
c      enddo
c
c   calculate last byte used, this does not include last record separater
c
      byte_nr_used=record_to_read*rec_size-
     *             (buf_byte_nr_read-buf_byte_nr_used)

c
c  check if that was the channel wanted
c
c      write(6,*)'buf_byte_nr_used,byte_nr_used',buf_byte_nr_used,
c     *byte_nr_used
c      write(6,*)'buf_byte_nr',buf_byte_nr_read
c      write(6,*) 'channel',chan_current
c      if(chan_current.lt.chan_wanted) goto 1    ! get next channel
c
c   get number of samples and if 2 or 4 byte samples
c
       read(chan_head(44:50),'(i7)') nsamp

c
c   check for number of samples
c
         if(nsamp.gt.max_sample-100) then
            write(6,*) nsamp, 'Too many samples'
            stop
         endif
c
       if(chan_head(77:77).eq.' ') bytes_sample=2
       if(chan_head(77:77).eq.'2') bytes_sample=2
       if(chan_head(77:77).eq.'4') bytes_sample=4
        
c
c   calculate which record to read to get the start of the next channel header,
c   first calculate how many bytes chan_bytes there are in following channel
c   excluding the channel header and including record separators at start
c   and end.
c
      if(computer.eq.'sun'.or.computer.eq.'lin') then
c64     chan_bytes=nsamp*bytes_sample+8
        chan_bytes=nsamp*bytes_sample+2*khead
      else    ! pc
        chan_bytes=nsamp*bytes_sample  ! number of bytes without separator
        chan_bytes=((chan_bytes-1)/128+1)*2+chan_bytes
      endif
c      write(6,*)'nsamp,chan_bytes',nsamp,chan_bytes
c
c   calculate the byte number from start of file where next channel
c   starts (first byte of header meaning first byte of record separater,
c   of last preceeding record)
c
      byte_nr_chan(chan_current+1)=byte_nr_used+chan_bytes+1
      record_read=record_to_read              ! save last buffer number read
      record_to_read=(byte_nr_chan(chan_current+1)-1)/rec_size+1  ! next header

c
c   if this is the channel wanted, jump down to read all data
c
      if(chan_current.eq.chan_wanted) goto 1000
c
c   save position in file of next channel
c
c      byte_nr_chan_all(chan_current+1)=byte_nr_chan
c      record_to_read_all(chan_curent+1)=record_to_read
c
c  go to next channel
c
      goto 1                                    
c
c---------------------------------------------------------------------
c  waveform data read and possibly swapped
c---------------------------------------------------------------------
c
 1000 continue
c
c   if only header wanted, return
c
      if(mode.eq.3) return              ! april 2000
c
c   put remaining buffer data into data buffer and then read the rest
c

      if(computer.eq.'sun'.or.computer.eq.'lin') then
         k=1
c64      do i=buf_byte_nr_used+9,buf_byte_nr_read ! out with record separater
         do i=buf_byte_nr_used+khead*2+1,buf_byte_nr_read ! out with record separater
            data_byte(k)=buffer(i:i)
            k=k+1
         enddo
c         write(6,*)' bytes remaining in header buffer before w',k-1
         do i=record_read+1,record_to_read
c2000 pc            read(unit,rec=i,end=1100) (data_byte(j),j=k,k+rec_size-1)           
            read(unit,rec=i,err=1100) (data_byte(j),j=k,k+rec_size-1)            
            goto 1101
c
c   end of file hit if here, if the last channel, this is ok since the 
c   number of records normally does not fit the file. However all bytes are read
c   so it should be ok
c
 1100       continue
c
c   error only allowed  if last record of last channel
c
            if(i.ne.record_to_read.and.chan_current.ne.nchan) 
     *      goto 10
 1101       continue
            k=k+rec_size    ! count total number of bytes for w. data
c            write(6,*)'k reading wav',k, 'rec',i
         enddo 
      endif      
c
      if(computer.eq.'pc ') then
         k=1
c         write(6,*)'buf_byte_nr_used,read',buf_byte_nr_used,
c     *   buf_byte_nr_read
         do i=buf_byte_nr_used+1,buf_byte_nr_read
            data_byte(k)=buffer(i:i)
            k=k+1
         enddo
c         write(6,*)' bytes remaining in header buffer before w',k-1

         do i=record_read+1,record_to_read
c2000            read(unit,rec=i,end=1102) (data_byte(j),j=k,k+rec_size-1)
            read(unit,rec=i,err=1102) (data_byte(j),j=k,k+rec_size-1)
            goto 1103
 1102       continue
c
c   error only allowed  if last record of last channel
c
            if(i.ne.record_to_read.and.chan_current.ne.nchan) 
     *      goto 10
 1103       continue
            k=k+rec_size
         enddo
c         write(6,*)(ichar(data_byte(i)),i=1,100) 
         
         

c
c   shift all bytes to remove record separaters
c
         j=0
         m=0
         do i=1,k,130
            m=m+2
            do l=1,128
               j=j+1
               m=m+1
               data_byte(j)=data_byte(m)
            enddo
         enddo
      endif
c         write(6,*)'after shift'
c         write(6,*)(ichar(data_byte(i)),i=1,100) 
c      write(6,*)' bytes read',k
c      if(bytes_sample.eq.4) write(6,*) (data4(i),i=1,10)
c      if(bytes_sample.eq.2) write(6,*) (data2(i),i=1,10)
c
c   check if byte swapping, this means that data was written on a
c   computer different from this one. Linux and pc have the same byte order
c
      if( ( pc.and.computer.eq.'sun').or.(sun.  and.computer.eq.'pc ')
     *.or.(sun.and.computer.eq.'lin').or.(linux.and.computer.eq.'sun')) 
     *then
c
c   do byte swap, 2 or 4 byte
c 
         if(bytes_sample.eq.4) then
            do i=1,nsamp
               j=(i-1)*4+1
               swap4(1:1)=data_byte(j)
               swap4(2:2)=data_byte(j+1)
               swap4(3:3)=data_byte(j+2)
               swap4(4:4)=data_byte(j+3)
               data_byte(j)  =swap4(4:4)
               data_byte(j+1)=swap4(3:3)
               data_byte(j+2)=swap4(2:2)
               data_byte(j+3)=swap4(1:1)
            enddo
          else
            do i=1,nsamp
               j=(i-1)*2+1
               swap2=data_byte(j)
               data_byte(j)  =data_byte(j+1)
               data_byte(j+1)=swap2
            enddo
          endif
      endif
 
c      if(bytes_sample.eq.4) write(6,*) (data4(i),i=1,10)
c      if(bytes_sample.eq.2) write(6,*) (data2(i),i=1,10)
c
c   put data in real array
c
      if(bytes_sample.eq.4) then
c          write(6,*)'4 bbytes'
         do i=1,nsamp
            x(i)=data4(i)
c            if(i.lt.10) write(6,*) data4(i),x(i)
         enddo
      else
c         write(6,*) '2 byrtes'
         do i=1,nsamp
            x(i)=data2(i)
c            if(i.lt.10) write(6,*) data2(i),x(i)
         enddo
       endif
c
c   check if a gain constant is used
c
       if(chan_head(76:76).eq.'G') then
          read(chan_head(148:159),'(g12.7)') gain
          do i=1,nsamp
            x(i)=x(i)*gain
          enddo
       endif     
c
c  check for zero or negative number of samples
c
       if(nsamp.le.0) then
          nsamp=3                         
          x(1)=1.0
          x(2)=1.001
          x(3)=1.01
c
c   put new number of samples in header
c
          write(chan_head(44:50),'(i7)') nsamp
      endif
      goto 20
 10   continue
      write(6,*)'error in seisinc'
 20   continue
c
c   save channel number read
c
      old_chan=chan_wanted
c
c   if reurn a rotated channel, order screwed up so reset
c
cx      if(rotate) old_chan=1
	  return
	  end

c############################################################################ C
C---------------------------------------------------------------------------
C
      SUBROUTINE QUARRYCHECK(evfile)
C
C     This program has been adapted from the quarry blast 
C     discrimination program ** QUARRYCHECK ** written by 
C     R.M.W. Musson 5 Aug 1987, which ran on EMAS.
C     This revised version runs on the VAX and must be linked with
C     the NERCLIB library.
C
C     Amendments made by Sheila Alexander, September 1991
C
C     NOLONG NEED TO LINK WITH NERCLIB - NOV 1991 - BY ENRU LIU
C     MODIFIED FOR NEW PHASE DATA FORMAT - DEC 1991 - BY E LIU
C   
C     Modified for new database of quarries J Exton 30.10.98
C
C     Ported to UNIX with a few changes to file opening statements,
C     and modifications for the newer S file
C     format (line type '8' to '83' and compressions given as 'C' rather than
C     'U'
C         J Exton 5.8.2002




C     Declare variables
      CHARACTER *(*) evfile

      CHARACTER ANS*1, FMR*1, RTN*1, NLIND*2, QLIST*1, UPPER*1,
     +          PHASNAM*100, QUARRYFILE*80, QNAME(350)*50, QLOC(350)*50,
     +          QTYPE(350)*38, QOP(350)*50, QTEL(350)*20, 
     +          NOS(5)*5, MSAGES(5)*40, TREC*80, PDUM*3, PDOUT*1
C
      INTEGER KEYBRD, SCREEN, QDFIL, PHASFIL, EVFIL, PDFIL,
     +        YR, DAY, HRS, EVOUT, PERR, ESYM, QSYM
C
      REAL MAG1, KME, KMN
C
      DIMENSION QE(350),QN(350),DIS(350),IQFL(5),IND(350)
C
      DATA KEYBRD, SCREEN, QDFIL, PHASFIL, EVFIL, PDFIL 
     +/ 5, 6, 7, 9, 10, 11/
C
      DATA NOS/'  (i)',' (ii)','(iii)',' (iv)','  (v)'/

      DATA MSAGES/' Event is too deep to be a quarry blast',
     +' Event is too big to be a quarry blast',
     +' Wrong time of day for a quarry blast',
     +' There are no quarries near this event',
     +' There is at least one dilation'/
C
      PERR = 10
      ESYM = 134
      QSYM = 125
      EVOUT = 1
      

      WRITE (6,*) 'Working with event: ', evfile
C
C     Write program header to screen

      WRITE(SCREEN,10)
   10 FORMAT(26X,'***************'/26X,':             :'
     +/26X,': QUARRYCHECK :'/26X,':             :'/
     +26X,'***************'//' UK Quarry and mine database'
     +,' checking programme for dubious seismic events'/)
C
   20 CONTINUE
C
C     Open phase file and the quarry database file QUARRY.DAT,& skip 
C     headings
C     Newquarry.dat put in $ANALYST_BGS_DIR on UNIX  JE 7.8.02


c      CALL getenv2('ANALYST_BGS_DIR', QUARRYFILE)
      CALL getenv('ANALYST_BGS_DIR', QUARRYFILE) ! lot
      QUARRYFILE = QUARRYFILE(1:LNBLNK(QUARRYFILE))//'/newquarry.dat'


c      OPEN(UNIT=QDFIL,FILE=QUARRYFILE,READONLY,STATUS='OLD')
      OPEN(UNIT=QDFIL,FILE=QUARRYFILE,STATUS='OLD')
      read(qdfil,*)
      OPEN(UNIT=PHASFIL,FILE=evfile,STATUS='OLD',ERR=470)
C
C     Prompt for estimated radius of uncertainty in eq location
C
   60 WRITE(SCREEN,70)PERR
   70 FORMAT(//' Enter estimated radius of uncertainty in earthquake',
     +' location (',I3,') km > ',$)
      READ (KEYBRD,100)PDUM
      IF (PDUM(1:1).NE.' ') READ (PDUM,*,ERR=60)PERR
C
C     Initialise counters for first motion statistics
C
      NOCOMS=0
      NODILS=0
C
C     Begin reading records from seismic activity readings file
C     Read whole record in as a string then pick out the required bits
C
   90 READ  (PHASFIL,100,END=470)TREC
  100 FORMAT(A)
      IF (TREC(1:10).EQ.'          ') GOTO 90
      READ (TREC(2:20),110) YR, MON, DAY, HRS, MINS, SECS
  110 FORMAT(I4,2(1X,2I2),1X,F4.0)
      READ (TREC(39:43),120) DEPTH
  120 FORMAT(F5.0)
      READ(TREC(57:59),130) MAG1
  130 FORMAT(F3.0)
C
C     Check column 80 for next line type indicator
C     Read in Earthquake location and first motion identifier 
C
  140 CONTINUE
      READ (TREC(79:80),100)NLIND
      IF (NLIND.EQ.'83') THEN
        READ (TREC(2:17),*)KME,KMN
C	write(6,*) kme, kmn
        READ (PHASFIL,100,END=160)TREC
        GOTO 140
      ELSEIF (NLIND(2:2).EQ.'4' .OR. NLIND(2:2).EQ.' ') THEN
        READ (TREC(17:17),100)FMR
        IF (FMR.EQ.'C') NOCOMS=NOCOMS+1
        IF (FMR.EQ.'D') NODILS=NODILS+1
        READ (PHASFIL,100,END=160)TREC
        GOTO 140
      ELSE
        READ (PHASFIL,100,END=160)TREC
        GOTO 140
      ENDIF
      
C
C     IQFL is an array of indicators which are set to show which
C     earthquake diagnostics are present
C
C  160       write(6,*) KME, KMN, YR, MON, DAY, HRS, MINS, SECS

  
  160 IF(NODILS.GT.0) THEN 
         IQFL(5)=0
      ELSE
         IQFL(5)=1
      ENDIF
C
C     Now check out those events obviously not quarry blasts based on
C     depth, magnitude and time
C
      IF(DEPTH.GT.5) THEN
         IQFL(1)=0
      ELSE
         IQFL(1)=1
      ENDIF
C
      IF(MAG1.GT.2.7) THEN
         IQFL(2)=0
      ELSE
         IQFL(2)=1
      ENDIF
C
      IF(HRS.LT.07 .OR. HRS.GT.18) THEN
         IQFL(3)=0
      ELSE
         IQFL(3)=1
      ENDIF
C
C     Cycle through the quarry data file looking for close ones
C
      NQ=1
      RMINDI=999.0
      DO 180 I=1,5000
      READ(QDFIL,170,END=200) QNAME(NQ),QLOC(NQ),QE(NQ),QN(NQ), 
     + QTYPE(NQ), QOP(NQ), QTEL(NQ)        
  170 FORMAT(A40,A26,T80,F6.0,3x,f7.0,T98,A20,A41,A15)
      QE(NQ)=QE(NQ)/1000
      QN(NQ)=QN(NQ)/1000

      DIS(NQ)=QDIS(KME,KMN,QE(NQ),QN(NQ))
      IF(DIS(NQ).LT.RMINDI) RMINDI=DIS(NQ)
      IF(DIS(NQ).LE.PERR) NQ=NQ+1
  180 CONTINUE
C
  200 IF(NQ.EQ.1) THEN
         IQFL(4)=0
      ELSE
         IQFL(4)=1
      ENDIF
C
C     Calculate the number of signs that this may be an earthquake
C
      NOEVTS=0
      DO 210 I=1,5
        IF (IQFL(I).EQ.0) NOEVTS=NOEVTS+1
  210 CONTINUE
      NOSFL=0
C
C     Output results. If it is a quarry inform user then move to 
C     section to list quarries within the vicinity.
C     Otherwise, list indications of earthquake and polarities
C     for the event.
C
      IF (NOEVTS.EQ.0) THEN
        WRITE (SCREEN,220)
  220   FORMAT(/' All evidence is consistent with this being a',
     +  ' quarry blast.')
C        GOTO 255
      ELSE
        WRITE(SCREEN,230)NOEVTS
  230   FORMAT(/' The',I2,' indications that this may be an',
     +  ' earthquake are:')
        DO 250 I=1,5
          IF(IQFL(I).EQ.0) THEN
            NOSFL=NOSFL+1
            WRITE (SCREEN,240)NOS(NOSFL),MSAGES(I)
  240       FORMAT(1X,A5,1X,A40)
          ENDIF
  250   CONTINUE
      ENDIF

C
  255   WRITE (SCREEN,260) NOCOMS,NODILS,INT(RMINDI)
  260   FORMAT(/' The polarities for this event are:',
     +  /1X,I2,' Compressions'/1X,I2,' Dilations',
     +  //' The nearest quarry is',I4,' km away')
C
C     List the quarries near the event
C
      IF(NQ.GT.1) THEN
         NQ=NQ-1
  270    WRITE (SCREEN,280)NQ
  280    FORMAT(/' The number of quarries near this event is ',I3,
     +   //' Would you like a list of them? (Y/N) : ',$)
         READ (KEYBRD,100)QLIST
         QLIST = UPPER(QLIST)
         IF (QLIST.EQ.'N') GOTO 400
         IF (QLIST.NE.'Y') GOTO 270
C
C     Check whether output required to screen, file or both
C
  290    WRITE (SCREEN,300)
  300    FORMAT (//' Would you like results output to :- ',
     +   /' 1) Screen ',
     +   /' 2) File ',
     +   /' 3) Both ',
     +   /' > ',$)
         READ (KEYBRD,310)EVOUT
  310    FORMAT(I1)
         IF (EVOUT.LT.1 .OR. EVOUT.GT.3) GOTO 290
         IF (EVOUT.EQ.2 .OR. EVOUT.EQ.3) THEN
           OPEN(UNIT=EVFIL,FILE='EVENTS.DAT',STATUS='UNKNOWN')
         ENDIF
C
C     Check if user wishes to ouput a point data file for plotting
C     at a later stage. If yes, write out the earthquake location
C     and symbol number.
C
  315    WRITE (SCREEN,320)
  320    FORMAT(/' Do you wish to ouput file with point data for',
     +   ' plotting? (Y/N) :',$)
         READ (KEYBRD,100)PDOUT
         PDOUT = UPPER(PDOUT)
         IF (PDOUT.EQ.'N') GOTO 325
         IF (PDOUT.NE.'Y') GOTO 315
         OPEN(UNIT=PDFIL,FILE='EQPOINT.DAT',STATUS='UNKNOWN')
         WRITE(PDFIL,355)KME*1000,KMN*1000,ESYM
C
C     Sort out quarry data
C
  325    CALL QSORT(IND,DIS,NQ)
         IF (EVOUT.NE.2) WRITE (SCREEN,330)
         WRITE (EVFIL,330)
  330    FORMAT(/' They are as follows: ')
C
C     Write out quarry details. If ouput is to screen write 18 lines
C     then wait for a carriage return. If point data option was
C     selected write quarry location and symbol to point data file
C
         NOLINES = 0
         DO 370 I=1,NQ
           IF (EVOUT.NE.2) THEN
             WRITE (SCREEN,'(a,t41,a,F5.1,a)')
     +                                 ' Pit name: '//QNAME(IND(I)), 
     +                                 'Distance: ',DIS(ind(I)),'km'
             write (screen,'(a,2(1X,F7.2))')' Grid Ref: ',QE(IND(I)), 
     +                                                    QN(IND(I))
             WRITE(SCREEN,'(a,t41,a30)')' Location:  '//QLOC(IND(I)),
     +                                  'Product:   '//QTYPE(IND(I))
             WRITE (SCREEN,'(a,t41,a)')' Operator:  '//QOP(IND(I)),
     +                                  'Telephone: '//QTEL(IND(I))
             write(screen,*)

             NOLINES = NOLINES+6
           ENDIF
C
             WRITE (EVFIL,'(a,t41,a,F5.1,a)')
     +                                 ' Pit name: '//QNAME(IND(I)), 
     +                                 'Distance: ',DIS(ind(I)),'km'
             write (EVFIL,'(a,2(1X,F7.2))')' Grid Ref: ',QE(IND(I)), 
     +                                                    QN(IND(I))
             WRITE(EVFIL,'(a,t41,a30)')' Location:  '//QLOC(IND(I)),
     +                                  'Product:   '//QTYPE(IND(I))
             WRITE (EVFIL,'(a,t41,a)')' Operator:  '//QOP(IND(I)),
     +                                  'Telephone: '//QTEL(IND(I))
             write(EVFIL,*)
C           WRITE (EVFIL,350)QLOC(IND(I)),QTYPE(IND(I)),QOP(IND(I)),
C     +                         QTEL(IND(I))
C
           IF (PDOUT.EQ.'Y') THEN
             WRITE(PDFIL,355)QE(IND(I))*1000,QN(IND(I))*1000,QSYM
           ENDIF
C
  340      FORMAT(/1X,A27,' Grid ref.',2(1X,F7.2),' at a distance of ',
     +     F5.1,' km')
  350      FORMAT(A,A,A,A)
  355      FORMAT(2F10.1,3X,I3)
C
           IF (EVOUT.NE.2) THEN
C             IF (JMOD(NOLINES,18).EQ.0) THEN    ! changed lot 07/04/2003
             IF (INT(NOLINES/18.).EQ.FLOAT(NOLINES)/18.) THEN
               WRITE (SCREEN,360)
  360          FORMAT(/' Press <CR> for more ')
               READ (KEYBRD,100)RTN
             ENDIF
           ENDIF
  370    CONTINUE
      ENDIF
C
C     Close files and inform user of output files if required
C
  400 CONTINUE
      IF (EVOUT.EQ.1) THEN
        CLOSE (UNIT=EVFIL,STATUS='DELETE')
      ELSE
        CLOSE (UNIT=EVFIL)
        WRITE(SCREEN,420)
  420   FORMAT(/' List of quarries written to EVENTS.DAT ')
      ENDIF
C
      IF (PDOUT.EQ.'Y') THEN
        CLOSE(UNIT=PDFIL)
        WRITE(SCREEN,430)
  430   FORMAT(/' Point data written to EQPOINT.DAT ')
      ENDIF
      CLOSE (UNIT=PHASFIL)
      CLOSE (UNIT=QDFIL)
      GOTO 500
C
C     Cope with empty readings file
C
  470 WRITE (SCREEN,480)PHASNAM
  480 FORMAT(//' The readings file ',A,' is empty ',
     +/' Enter R to reenter or Q to quit > ',$)
      READ (KEYBRD,100)ANS
      ANS = UPPER(ANS)
      IF (ANS.EQ.'R') GOTO 20
      IF (ANS.EQ.'Q') GOTO 500
      GOTO 470
C
C     Inform user that program is finishing
C
  500 WRITE (SCREEN,510)
  510 FORMAT(/' QUARRYCHECK program finishing at user''s request ')
      END
C
C------------------------------------------------
C
      FUNCTION QDIS(A,B,C,D)
C
C     Pythagorean distance calculation
C
      QDIS=SQRT(((A-C)**2)+((B-D)**2))
      RETURN
      END
C
      SUBROUTINE QSORT(IND,DIS,NQ)
      DIMENSION IND(NQ),DIS(NQ)
      RMAX=-1
      DO 30 I=1,NQ
      RMIN=99999.9
      DO 20 J=1,NQ
      IF(DIS(J).LE.RMIN.AND.DIS(J).GE.RMAX) THEN
         DO 10 K=1,I-1
         IF(J.EQ.IND(K)) GOTO 20
   10    CONTINUE
         RMIN=DIS(J)
         IND(I)=J
      ENDIF
   20 CONTINUE
      RMAX=DIS(IND(I))
   30 CONTINUE
      RETURN
      END
C--------------------------------------------------------------------------
      FUNCTION UPPER (LINE)
      CHARACTER *(*) UPPER,LINE
      N=LEN(LINE)
      DO 100 I=1,N
      IC=ICHAR(LINE(I:I))
      IF (IC.GE.97.AND.IC.LE.122) IC=IC-32
 100  UPPER(I:I)=CHAR(IC)
      RETURN
      END
C--------------------------------------------------------------------------
C-------------------------------------------------------------------


C This subroutine is a wrapper for the non-standard SUN getenv function	
c lot, not sure if needed
	
	subroutine getenv2 (ename, evalue)
	
	character*(*) ename, evalue
	
	call getenv (ename, evalue)
	
	return
	end
	

c******************************************************************************
c   Latest major features, march 2000
c
c   multi model:
c
c   fixed vp/vs, determined by vp/vs on control line
c   no check for impossibel models
c   does not work with weight 9
c   not tried with fixed depth, multiple models
c   best 10 models written out, however in order so if first model
c   happens to be the best, only one is written out
c
c   multiple depths, n depths, start, increment, put in control line
c
C   LATEST UPDATE :  6/98 BRL: added include file, eventno to hypocent window
c                    removed unused variables, minor changes to 
c                    interactive section
c   may 11 94 by jh : do double sorting
c   may 27 94       : put include statement one down
c   may 30          : clear old magnitudes
c   jun 15          : mw magnitude
c   jul 22          : bug with sorting
c   jul 25          : delete print.out at start up
c   sep 28          : do not delete agency if hypocenter fixed
c   dec 7           : clear underflow on sun
c   jan 3   95      : use env variable for file name
c   jan 9           : new find_ev_index
CJAB(BGS)Jan95      : Install error and file handling...
CJAB(BGS)Jan95        Note that "tau.for" has not been changed,thus unit 22
CJAB(BGS)Jan95        must be supplied to variable "read3". This will not
CJAB(BGS)Jan95        effect "libsei" routines since units are opened 64,63..
CJAB(BGS)Jan95        and is unlikely ever to reach the value of 22. If "tau"
CJAB(BGS)Jan95        is changed at some future data, no action need be taken.
CJAB(BGS)Jan95        Note also that all "hyp*" routines linked to "hyp.for"
CJAB(BGS)Jan95        which just "write" or "read" MAY need to be modified
c   jan 25          : make sure close when using eev, look for STATION0.HYP
c                     for seisan detection
c apr 6 95 jh       : bug
c jun 9   jh        : do not write loc. agency when no locate
c aug 16  jh        : do not modify event if no locate flag * is set
c jan 23 96         : q option when listing event
c mar 14 96         : modify clear_old, read_stat..
c sep 19 96         : clear 3 magnitude if default agency
c oct 11, 96        : fix sorting to use time so P comes before S
c dec 19, 96        : enable local data base and index file
c mar 20  97        : if hypocenter fixed, keep old location agency
c mar 24            : clear 3 magnitude, wrong place
c may 16            : sort even if not located
c feb 12 98         : clear residuals etc before locating, not after
c jun  6 98      lo : check for message
c jun 8 98          : BRL added datsave
c sep 1998   jh     : ---------------- version 7.0 check ------------------
c                     year 2000, 5 char bases, 5 char station
C oct 28  1998  bmt : linux changed, save option include                     
c jul 26 1999   jh  : add variable use_eev to hypocent and read_stat_model call
c sep 24            : add get_seisan_def and include seisan.inc to get new 
c                     geometrical spreading function in spec
c oct 19            : new hyposub1 and hypoloc1, weitght 4 prohblem
c nov 2, 99         : if input from file, any name longer than 5 chars can be
c nov 26 99 jh      : make it possible to use an input file name of 80 chars
c                     used also if no ','. and shorter if a '.'
c dec 8             : fix overflow in year 2000 output in routines hypoloc
c                     and hyposub1
c jan 2000          : multi model search
c feb 16 ,2000      : add output to update_spec, so no mw out if output false
c march 10, 2000    : move call clear_old up before location
c april 27, 2000    : give input file as argument
C august 2000       : grid search
c oct 30            : compiled for high accuracy, no changes
c feb 2001  lo      : BGS changes
c mar 4, 2001, jh   : enable magnitude calculation without locaiton, test 106
c mar 19            : closing multi model operation properly
c jan 28, 2002      : write old locaiton
c apr 2002 jh       : input with file as argument changed so that output
c                     is the same as for eev
c apr 14 2002 bmt   : set maxline=1000 for jseisan
c may 26 2005 lot   : BGS extension, read model from sfile
c
C
c 4/94: added eventno, dlt, yter & isort to hypocent window
c

c added include file 3/31/94
      implicit none
      include 'hypparm.inc'
      include 'seisan.inc'
C
C    SEISAN library/JAB inclusions...
c    --------------------------------
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c   BRL 6/98: Note to modifiers of this program:
c    Please observe the C-style justification 
c    in statements you add, particularly in existing 
c    code, e.g.,
c     do i=1,n
c      do j=1,m
c       if (i.gt.1) then
c         if (j.gt.2) then
c          write (*,*)
c          ADDED STATEMENT
c     &     CONTINUATION OF ABOVE     
c         end if
c        end if
c       end do
c      end do
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<         
C
      include 'libsei.inc'                 ! Library definitions & data defns.
      include 'seidim.inc'                 ! array dimentions
      external sei open,                   ! File open handler.
     &         sei close,                  ! & closure.
     &         sei clen,                   ! String length.
     &         sei code                    ! Error condition handler.
      integer  sei clen                    ! & function.
      integer  code,                       ! Condition.
     &         text_c,                     ! Text length.
     &         read1,                      ! Read unit1.
     &         read2,                      ! Ditto 2. opened elsewhere.
     &         read3,                      ! Ditto 3, opened in tau.for
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write3                      ! & 3.
      parameter (text_c = 80)              ! & value.
      logical  b_flag                      ! Flag!!
      character chr_text   *(text_c)       ! Text string.
C
C    ------- End of details -------
C
c---name of top directory
      character*60 top_directory
c---one event in nordic format, one line of data  
c---iaspei file name
      character*80 modnam
c---original header buffer
      character*80 datsave,data_old ! could they be the same ??
c---location indicator, can be L, R or D
      character*1 loc_indicator(3)
      logical locate
c--- event type, indcator of explosion, indicator of fixing depth  
      character*1 typ,exp,fixdepth
c---indicator if output on screen  
      character*1 yter,yter1
      logical output
c---agency for magnitude  
      character*3 agency
c---directory separator character
      character*1 dchar
c---number of header lines, records, stations in nordic file, help variables
      integer nhead,nrecord,nstat,nfind,k,nphase,i
c---id line indicator
      integer id
c---model type or number
      character*1 model  
C-- hypocenter help variable
      integer init
c-- help varibale
      character*80 text
c-- line counter and max number of line pr page
      integer nline,maxline
c-- save year, month ,day for old location
      integer year,month,day
c-- hour and difference in hours between solutions shifted one day
      integer hour,delhour
c-- min and sec of phase
      integer min
      real sec
c-- abs times for above
      double precision abstim1,abstim2
c-- covarriance matrix, origin time error
      real covar(3,3),oterr
c-- # phases      
      integer nphs
c
c   for multimodel
c
      integer nvelocity1,ivelocity1,nvelocity2,ivelocity2,
     *        nvelocity3,ivelocity3,nvelocity4,ivelocity4,
     *        nvelocity5,ivelocity5,nvelocity6,ivelocity6,
     *        nvelocity7,ivelocity7,nvelocity8,ivelocity8
      integer ndepth1,idepth1,ndepth2,idepth2,ndepth3,idepth3,
     *        ndepth4,idepth4,ndepth5,idepth5,ndepth6,idepth6,
     *        ndepth7,idepth7,ndepth8,idepth8
      real    v_start(10),d_start(10),v_min(10,10),d_min(10,10) ! start and best
      real    d_delta(10),v_delta(10)                      ! step
      real    rmssum_min                                   ! min rms
      real    rms_min(10)        ! lowest rms, several models
c     logical multi_model        ! true if multimodel
      integer imin               ! counter for imin
      integer nmin               ! number fo best models stored
      integer kmax               ! counter for max rms
      real    rmax               ! largest rms of stored values
c
c   for grid search
c
      real minlat,maxlat,dellat         ! lat grid for search
      real minlon,maxlon,dellon         ! lon grid for search
      integer nlat,nlon                 ! number of grid points
      real  grid_rms,g_rms              ! minumum rms
      real grid_lat,grid_lon            ! corressponding location
      logical grid_search               ! true if grid search
      integer ilo,ila
      real bnglat,bnglon,bnge,bngn,bngerr ! variables to convert to BNG 
c
      integer j,m,l



c-- indicator if program is used in connection with EEV in seisan
      logical use_eev
c-- indicator if seisan data base present
      logical seisan
C
C  next for data base operation
C
      character*10 keys                      !next choice key
      character*14 starttime,endtime         ! time interval for location
      character*80 basename                  ! data base or file name
      character*80 infile                    ! input file or base name
      character*80 eventfile                 ! single event file name
      integer status,eventno,newmonth,fstart ! 
      integer base                           ! 0: data base, 1: single file
c
c---minimum number of stations to locate
      integer minstat
c---minimum number of phases to locate  
      integer minphase
c---code for current model  
      character*20 model_code  
c---magnitude Ml coefficients
c      real a,b,c,d  
c---number of arguments and function
       integer nars
       character*80 args(10)

c---added 4/94: sort arrays for sorting output by distanace
      integer ksort(narriv)     
      integer lsort(narriv)
      character*5 old_dist
      character*5 old_stat
      integer isindex
      integer lunit
      logical terminal,isatty
c      logical bgs_seisan
      character*10 extension


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call get_arguments(nars,args)

c      call get_bgs_seisan(bgs_seisan)
      call get_env_seisan_extension(extension)
C
C    initialise...
C    =============
C
      grid_rms=99999999.0
c
c   check for grid search
c
      grid_search=.false.
      if(nars.gt.0) then
        if(args(1)(1:11).eq.'-gridsearch') then
           grid_search=.true.
           nars=0
        endif
      endif
c
      rmssum_min=999999.0
      code   = e_ok$                             ! Local condition.
      b_f_debug$ = .false.                       ! Debug to screen/file?
      read1  = 0                                 ! & file units.
      read2  = 0                                 ! Ditto.
      read3  = 22                                ! Ditto.
      write1 = 0                                 ! Ditto.
      write2 = 0                                 ! Ditto.
      write3 = 0                                 ! Ditto.
c                                                           
c   get computer specifics
c
      call dir_char(dchar)         ! dirctory delimiter character
c     call gradual_underflow()
c
c
c   get seisan defaults
c
      call get_seisan_def

c   set max number of lines pr page for screen print out
c      maxline=20
c modified to allow output to a pipe without expecting
c a reply from the terminal (bjb 2001/02/14)
c Function ISATTY may only be available on Solaris???
      lunit=6
      terminal=isatty(lunit)
      if(terminal) then
         maxline=20
      else
         maxline=1000
      endif

c 
c   get directory structure
c
      call topdir(top_directory)
c
c   check if SEISAN data base is present indicated by the presense of
c   the file station0.hyp in DAT directory
c
      chr_text = top_directory(:seiclen(top_directory)) //
     &           dchar // 'DAT' //dchar                 //
     &           'STATION0.HYP'
c
      call sei open( check$,            ! Check existance.
     &               ' ',               ! No prompt.
     &               chr_text, read1,   ! File & unnit.
     &               seisan,            ! File exists?.
     &               code )             ! Local condition (n/a).
c
      if( seisan ) then                 ! Multiple files.
      base = 0                          ! General database.
      else                              ! Otherwise only a single file.
      base = 1                          ! Only a single file.
      end if                            !
c
c   check if input of a file as argument, however if argument is
c   -gridsearch, continue
c
      call get_env_event(eventfile)
      if(nars.gt.0) then
        if(args(1)(1:5).ne.'-grid') then
           eventfile=args(1)(1:80)
           maxline=1000
        endif
      endif
c
c  check if non interactive, then no output
c
      call get_seisan_message(text)
c
c   find if program will run from within EEV indicated by the presenses of file
c   name in an enviromental variable
c
  
      use_eev =  eventfile(1:1)        .ne. ' '    .and.
     &           ichar(eventfile(1:1)) .ne. 0  
      if(use_eev) then
C
C   open data base input single event file and read it
c   set flag for single event nrecord= -1
c
         nrecord = -1
         call sei open( old$,            ! Open old file (stop on error).
     &                  ' ',             ! No prompt.
     &                  eventfile, read1,! File & unit.
     &                  b_flag,          ! File exists? (n/a).
     &                  code )           ! Local condition (n/a).
         call indata(read1,nstat,nphase,nhead,nrecord,
     &               typ,exp,data,id)
         datsave=data(1)
         call sei close( close$, read1, code ) ! Close file (stop on error).
c
         model = data(1)(21:21)
         yter = 'Y'                            ! output on screen
         output=.true.


      if (text.eq.'hyp non interactive') then
           yter='N' 
           output = .false.
      endif


         goto 20                               ! jump remaining questions
      endif

c
c   input data base name and time interval
c
      if(seisan) then
         write(*,*) ' Arrival time data input - select one:'
         write(*,*)
         WRITE(*,*) 
     *  '    SEISAN data base or                             :',
     &  'RETURN '
         write(*,*) 
     *  '    Alternative data base, give 1-5 letter code or  :'  
         WRITE(*,*) 
     *  '    Local index file, name must start with index or :'
         WRITE(*,*) 
     *  '    Local data base, write ,, or                    :'
         WRITE(*,*) 
     *  '    Filename for one file, min. 6 chars or with a . : '
      else
         WRITE(*,*) 'Filename for file in NORDIC format     : '
      endif
      write(*,*)
c     write(*,'(''    '',$)')

        read(*,'(a)') infile
      basename=infile(1:80)
                       
      write(*,*)
C
c   check if this is a single multiple event file (base=1),
c   general data base (base=0) or local data base, only check if seisan
c   data base is present
C
      if(seisan) then
         starttime=' '
         endtime=' '
         if(basename(1:5).eq.'INDEX'.or.basename(1:5).eq.'index'.
     *   or.basename(1:2).eq.',,') then
            base=0
            goto 2929
         endif
         if(seiclen(basename).lt.6.and.index(basename,'.').eq.0) 
     *   then
            base=0
            goto 2929
         endif
         base = 1                                  ! Single event file
 2929    continue
      endif
C
      if(base.eq.0.and.
     *basename(1:2).ne.',,'.and.basename(1:5).
     *ne.'INDEX'.and.basename(1:5).ne.'index') then 
                 ! only ask time interval for true base
         write(*,'('' Start Time           (YYYYMMDDHHMMSS): '',$)')
         read(*,'(a14)') starttime
         write(*,'('' End Time, RETURN is to end of month:   '',$)')
         read(*,'(a14)') endtime
         write(*,*)
      endif
C
C   check if interactive operation, 
C   changed to remove CR 3/94
c      if(nars.lt.1) then
      if (yter.ne.'N') then
        write(*,'('' Interactive operation (N/Y=default)'',$)')
        read(*,'(a1)')  yter
      endif
      yter1=' '       
      write(*,*)
      call sei upc( yter )
      if(yter.eq.' ') yter='Y'
      if(yter.eq.'Y') output=.true.
c
c   start with standard model
c
      model=' '     
c
c   enter here if used with eev
c
  20  continue
C
C   do not fix depth  
C
      fixdepth=' '
C
C   open  output files
C
      call sei open( unknown$,            ! Open print file.
     &               ' ',                 ! No prompt.
     &               'print.out', write1, ! File & unit.
     &               b_flag,              ! File exists?.
     &               code )               ! Condition (n/a).
c
c   on  sun, old events seem to remain in print.out file, so delete and reopen
c
      call sei close( delete$, write1, code ) ! Delete it (stop on error).
      call sei open( unknown$,                ! Open print file.
     &               ' ',                     ! No prompt.
     &               'print.out', write1,     ! File & unit.
     &               b_flag,                  ! File exists?.
     &               code )                   ! Condition (n/a).
c
      call sei open( unknown$,                ! Open hyp file.
     &               ' ',                     ! No prompt.
     &               'hyp.out', write2,       ! File & unit.
     &               b_flag,                  ! File exists?.
     &               code )                   ! Condition (n/a).
c
      call sei open( unknown$,                ! Open hyp file.
     &               ' ',                     ! No prompt.
     &               'hypsum.out', write3,    ! File & unit.
     &               b_flag,                  ! File exists?.
     &               code )                   ! Condition (n/a).
c
c 4/94: write input filename to print output....
c
      write( write1,                               ! Details to print file.
     &       '('' Input File: '',a40,/)',          ! On format.
     &       iostat=code ) basename                ! On condition, the basename.
      call sei code( fort$, code, write1, b_flag ) ! Process the outcoe.
C
C   open hypocenter file with model and station and read
c   file is first searched for in your local directory, then in SEISAN
c   DAT directory
c
      call read_stat_mod
     & (agency,model_code,model,minstat,minphase
     & ,modnam,loc_indicator,read2,write2,write1,
     & write3,read3,isort,
     &test,dlt,yter1,maxline,use_eev)
c
c   check if model file was there
c
      if(model.eq.'@') then
         write(6,*)' No STATION0.HYP file'
         goto 999 
      endif
c
c   if used with eev, jump straight at location
c
      if(use_eev) goto 1000
C
C   open input event file if multiple event single file option has
C   has been selected 
      if(base.eq.1) then
C
      call sei open( old$,            ! Open old file (stop on error).
     &               ' ',             ! No prompt.
     &               infile, read1,   ! File & unit.
     &               b_flag,          ! File exists? (n/a).
     &               code )           ! Local condition (n/a).
      eventno = 0
      endif
c
c   section on grid searching for a model
c
c   find if model seaching is done, open parameter file
c
      ndepth1=1
      ndepth2=1
      ndepth3=1
      ndepth4=1
      ndepth5=1
      ndepth6=1
      ndepth7=1
      ndepth8=1
      nvelocity1=1
      nvelocity2=1
      nvelocity3=1
      nvelocity4=1
      nvelocity5=1
      nvelocity6=1
      nvelocity7=1
      nvelocity8=1
      imin=0
      nmin=10
      do i=1,nmin
        rms_min(i)=100.0 - i
        do k=1,10
           v_min(i,k)=0.0
           d_min(i,k)=0.0
        enddo
      enddo
c
c--------------------------------------------------------------------------
c   check if multi model is allowed in this mode which is only input from
c   a multi event file and no interactive output
c--------------------------------------------------------------------------
c
      if(use_eev.or.yter.eq.'Y') goto 8877
c
      multi_model=.false.
      open(2,file='h_models.par',status='old', err=8877)
      read(2,'(a)') text    ! info header line
      i=0
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(1),v_delta(1),nvelocity1,d_start(1),d_delta(1),ndepth1
      i=i+1
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(2),v_delta(2),nvelocity2,d_start(2),d_delta(2),ndepth2
      i=i+1
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(3),v_delta(3),nvelocity3,d_start(3),d_delta(3),ndepth3
      i=i+1
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(4),v_delta(4),nvelocity4,d_start(4),d_delta(4),ndepth4
      i=i+1
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(5),v_delta(5),nvelocity5,d_start(5),d_delta(5),ndepth5
      i=i+1
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(6),v_delta(6),nvelocity6,d_start(6),d_delta(6),ndepth6
      i=i+1
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(7),v_delta(7),nvelocity7,d_start(7),d_delta(7),ndepth7
      i=i+1
      read(2,'(10x,2f10.3,i10,2f10.3,i10)',end=8765)
     *v_start(8),v_delta(8),nvelocity8,d_start(8),d_delta(8),ndepth8
      i=i+1
c
 8765 continue
      close(2)
      if(i.ge.2) then
         multi_model=.true.
c
c   calculate number of tests
c
      k=ndepth2*ndepth3*ndepth4*ndepth5*ndepth6*ndepth7*ndepth8
      k=k*nvelocity1*nvelocity2*nvelocity3*nvelocity4*nvelocity5
     **nvelocity6*nvelocity7*nvelocity8
c      write(6,*)
c     *ndepth1,ndepth2,ndepth3,ndepth4,ndepth5,ndepth6,ndepth7,ndepth8
c      write(6,*)nvelocity1,nvelocity2,nvelocity3,nvelocity4,nvelocity5
c     *,nvelocity6,nvelocity7,nvelocity8
         nl=i
         write(6,*)' Multi model mode, number of layers:',i
         write(6,*)' Number of models: ',k
         write(6,*)' Continue(n/y=return) ?'
         read(5,'(a)') text
         if(text(1:1).ne.' '.and.text(1:1).ne.'y') stop
         open(2,file='h_models.out',status='unknown')
      endif
 8877 continue

      do ivelocity1=1,nvelocity1
      if(multi_model) then
         v(1)=v_start(1)+(ivelocity1-1)*v_delta(1)
         vs(1)=v(1)/pos
      endif
      do ivelocity2=1,nvelocity2
      if(multi_model) then
         v(2)=v_start(2)+(ivelocity2-1)*v_delta(2)
         vs(2)=v(2)/pos
      endif
      do idepth2=1,ndepth2
      if(multi_model) then
         d(2)=d_start(2)+(idepth2-1)*d_delta(2)
      endif
      do ivelocity3=1,nvelocity3
      if(multi_model) then
         v(3)=v_start(3)+(ivelocity3-1)*v_delta(3)
         vs(3)=v(3)/pos
      endif
      do idepth3=1,ndepth3
      if(multi_model) then
         d(3)=d_start(3)+(idepth3-1)*d_delta(3)
      endif
      do ivelocity4=1,nvelocity4
      if(multi_model) then
         v(4)=v_start(4)+(ivelocity4-1)*v_delta(4)
         vs(4)=v(4)/pos
      endif
      do idepth4=1,ndepth4
      if(multi_model) then
         d(4)=d_start(4)+(idepth4-1)*d_delta(4)
      endif
      do ivelocity5=1,nvelocity5
      if(multi_model) then
         v(5)=v_start(5)+(ivelocity5-1)*v_delta(5)
         vs(5)=v(5)/pos
      endif
      do idepth5=1,ndepth5
      if(multi_model) then
         d(5)=d_start(5)+(idepth5-1)*d_delta(5)
      endif
      do ivelocity6=1,nvelocity6
      if(multi_model) then
         v(6)=v_start(6)+(ivelocity6-1)*v_delta(6)
         vs(6)=v(6)/pos
      endif
      do idepth6=1,ndepth6
      if(multi_model) then
         d(6)=d_start(6)+(idepth6-1)*d_delta(6)
      endif
      do ivelocity7=1,nvelocity7
      if(multi_model) then
         v(7)=v_start(7)+(ivelocity7-1)*v_delta(7)
         vs(7)=v(7)/pos
      endif
      do idepth7=1,ndepth7
      if(multi_model) then
         d(7)=d_start(7)+(idepth7-1)*d_delta(7)
      endif
      do ivelocity8=1,nvelocity8
      if(multi_model) then
         v(8)=v_start(8)+(ivelocity8-1)*v_delta(8)
         vs(8)=v(8)/pos
      endif
      do idepth8=1,ndepth8
      if(multi_model) then
         d(8)=d_start(8)+(idepth8-1)*d_delta(8)
      endif


      keys(1:4)='NEXT'    ! start with next event

c 3/94: added init call to zero residual summary

      call hypocent(4,read2,write2,write1,write3,read3,init,
     &'N',data,modnam,eventno,dlt,isort,test,yter1,maxline,nstat,
     &locate,covar,oterr,nhead,nrecord,use_eev)
C
c
c---------------------------------------------------------------------
c  event loop starts here, always come back here after locating one event
c  or to make a new choice in interactive mode
c---------------------------------------------------------------------
c
 50   continue
c
C----------------------------------------------------------------------
C   Point to same, next or another event 
C----------------------------------------------------------------------
C
      if(base.eq.0) then              ! data base event
         call findevin
     *   (basename,starttime,endtime,keys,0,eventno,
     *   eventfile,fstart,newmonth,status)
c
c   check if end of time interval or errors, then
c   close hyp.out and stop
C     
         if(status.gt.0) then
            write(6,*)' STOP WITH STATUS=',status
            GOTO 900   ! stop
         endif
C
C   open data base input single event file and read it
c   set flag for single event nrecord= -1
c
         nrecord=-1
         call sei open( old$,            ! Open old file (stop on error).
     &                  ' ',             ! No prompt.
     &                  eventfile, read1,! File & unit.
     &                  b_flag,          ! File exists? (n/a).
     &                  code )           ! Local condition (n/a).
         call indata(read1,nstat,nphase,nhead,nrecord,
     &               typ,exp,data,id)
         datsave=data(1)
         call sei close( close$, read1, code ) ! Close file (stop on error).
c
      else                             ! single file  multiple event mode
c
         if(keys(1:4).eq.'NEXT') then
         call indata(read1,nstat,nphase,nhead,nrecord,
     &               typ,exp,data,id)
         datsave=data(1)
         if(nrecord.eq.0) goto 900   ! check for end of file
         eventno=eventno+1
         endif
c
c  selection by number 
c
         if(keys(1:1).eq.'#') keys(1:4)=keys(2:5)
         if(keys(1:1).eq.'1'
     *   .or.keys(1:1).eq.'2'.or.keys(1:1).eq.'3'
     *   .or.keys(1:1).eq.'4'.or.keys(1:1).eq.'5'
     *   .or.keys(1:1).eq.'6'.or.keys(1:1).eq.'7'
     *   .or.keys(1:1).eq.'8'.or.keys(1:1).eq.'9') then
            read(keys(1:4),'(i4)') nfind
            if(keys(4:4).eq.' ') read(keys(1:3),'(i3)') nfind
            if(keys(3:3).eq.' ') read(keys(1:2),'(i2)') nfind
            if(keys(2:2).eq.' ') read(keys(1:1),'(i1)') nfind
            if(nfind.eq.0) goto 75    ! make choice
            if(nfind.eq.eventno) goto 75
c
            if(nfind.lt.eventno) then
            rewind( read1, iostat=code )                ! Rewind unit.
            call sei code( fort$, code, read1, b_flag ) ! Process outcome.
            eventno = 0
            k = nfind
c
            else
            k = nfind - eventno
            endif
c
            do i=1,k
               call indata(read1,nstat,nphase,nhead,nrecord
     *         ,typ,exp,data,id)
               datsave=data(1)
               eventno=eventno+1
               if(nrecord.eq.0) then
                  write(6,*)' no such number ',nfind
                  rewind( read1, iostat=code )                ! Rewind unit.
                  call sei code( fort$, code, read1, b_flag ) ! Process outcome.
                  eventno=0
                  keys(1:4)='NEXT'
                  goto 50
               endif
            enddo
        endif
      endif
c
c--------------------------------------------------------------
c  decide what to do next if in interactive mode
c--------------------------------------------------------------
c
 75   continue
      if(yter.eq.'Y') then

c 4/94: inserted section to calculate the real # phases, nphs
c I want ALL the phases and NOT including azimuths (BRL)
        isindex=2
        do while (data(isindex)(80:80).ne.'4'.and.data(isindex)(80:80)
     &  .ne.' ')
          isindex=isindex+1
        enddo
        isindex=isindex-1  
        nphs=nrecord-1-isindex                   
        
          write(6,289) eventno,data(1)(1:22),nphs
 289      format(1x,'#',i5,1x,a22,' NPHS=',i4,3x,'T Q L #XXX ', $)
          read(5,'(a)') keys
          if(keys(1:4).eq.'    ') keys(1:4)='NEXT'
          if ( keys(1:1) .eq. 'Q'.or. keys(1:1) .eq. 'q' ) goto 900
c
c   type event
c
         if (keys(1:1).eq.'t'.or.keys(1:1).eq.'T') then
              write(6,*)
              nline=0
              do i=1,nrecord
                 write(6,'(a)')data(i)
                 nline=nline+1
                 if(nline.gt.maxline) then
                    nline=0

c   changed to not give CR (BRL)
                    write(6,'('' Return to continue'',$)')
                    
                    read(5,'(a)') text
                 endif
               enddo
               keys(1:4)='SAME'      ! use same event
               goto 50               ! back for new choice
          endif
c
c   back one event
c
          if(keys(1:1).eq.'b'.or.keys(1:1).eq.'B') then
              keys(1:4)='BACK'
              goto 50
          endif
c
c  scroll in print.out file
c
          if(keys(1:1).eq.','.or.keys(1:1).eq.'.') then
              call hyp_print(write1,keys(1:1),maxline)
              keys(1:4)='SAME'
              goto 50 
          endif
C 
C   if location has been chosen go on, else restart in 50
C
          if(keys(1:1).ne.'l'.and.keys(1:1).ne.'L') goto 50
      endif
C
C------------------------------------------------------------------------
c   location start here
C--------------------------------------------------------------------------
C
 1000 continue
c
c   assume this is after year 1900 and put in header
C
      if(data(1)(2:3).eq.'  ') data(1)(2:3)='19'
c
c   check if disable location has been set on for this event, in which case
c   event is passed on with no modification to hyp.out
c
      if(data(1)(45:45).eq.'*') then
        write(6,*)'Event flagged not to be located'
        keys(1:4)='NEXT'
        goto 31               ! go to outputs
      endif
c
c   check if a new model has to be read in
c
      if(model.ne.data(1)(21:21)) then
c         write(*,*)model,data(1)(21:21)
         model=data(1)(21:21)
         call read_stat_mod
     *   (agency,model_code,model,minstat,minphase,
     *   modnam,loc_indicator,read2,write2,
     &   write1,write3,read3,isort,test,dlt,
     *   yter1,maxline,use_eev)
         if(model.eq.'@') then
            write(6,*)' No alternative model available for this event'
         else
            write(*,*)' Model changed'
         endif
      endif

c
c set xnear, xfar and starting depth from sfile
c
      xxfar=-1.
      xxnear=-1.
      if (test(107).eq.1.) then
        do i=1,nhead
          if (data(i)(2:6).eq.'XNEAR'.and.data(i)(80:80).eq.'3') then
cXNEAR  150.0 XFAR  300.0 SDEP 7.5
c format changed lot 20/12/2005
            read(data(i)(2:37),'(6x,f6.1,6x,f6.1,6x,f5.1)') 
     &           xxnear,xxfar,ztr
            if(write1.gt.0) then
              write(write1,*)
              write(write1,'(a)') 
     &          ' starting depth, xnear, xfar '//
     &          'from event file '
              write(write1,'(4(f6.2,1x))') ztr,xxnear,xxfar
            endif
          endif
        enddo
      endif

c
c set velocity model from event file, BGS, lot 11/5/2005
c
      if(extension(1:3).eq.'BGx') then
        xxfar=-1.
        xxnear=-1.
        k=0
        do i=1,nhead
          if (data(i)(79:80).eq.'93') then
c4.00  0.00/ 5.90  2.52/ 6.45  7.55/ 7.00 18.87/ 8.00 34.15/                  93
            read(data(i),'(6(f5.2,1x,f5.2,1x))')
     &        v(k+1),d(k+1),v(k+2),d(k+2),v(k+3),d(k+3),v(k+4),d(k+4),
     &        v(k+5),d(k+5),v(k+6),d(k+6)
            k=k+6
c            write(*,*) data(i)
          elseif (data(i)(79:80).eq.'A3') then
c  0. 100. 200. 1.73                                                          A3
            read(data(i),'(3f5.0,f5.2)') ztr,xxnear,xxfar,pos
c            write(*,*) data(i)
          endif
        enddo
        if (k.gt.0.and.pos.gt.0.) then
          nl=0 
          do i=1,k
            if (v(i).ne.0.) then
c              write(*,*) v(i),d(i)
              nl=nl+1
              vs(i)=v(i)/pos
            endif
          enddo
c
c output
c
          write(*,*) 
     &    ' Using model and location parameters from event file '
          if(write1.gt.0) write(write1,*)
          if(write1.gt.0)
     &  write(write1,'('' Model taken from event file'',/)')
          if(write1.gt.0)
     &    write(write1,'('' Depth, km   Vp, km/s   Vs, km/s'')')
          do  i=1,nl
c         reff=' '
c         if(i.eq.nconrad)reff='B'
c         if(i.eq.nmoho)reff='N'
           if(write1.gt.0)write(write1,'(1x,f9.2,2f11.2,3x)')
     &      d(i),v(i),vs(i)
c,reff
          end do
          
          if(write1.gt.0) then
            write(write1,*)
            write(write1,'(a)') ' starting depth, xnear, xfar, vp/vs '//
     &        'from event file '
             write(write1,'(4(f6.2,1x))') ztr,xxnear,xxfar,pos
          endif

c convert depths to thicknesses and store parameters in parm(i)
          do i=1,nl-1
            parm(nl+i)=d(i+1)-d(i)
c            if(i.eq.1.and.test(40).eq.0.0)then
c              parm(nl+i)=d(i+1)-d(i)+float(maxelv)*.001
c            endif
          end do
          do i=1,nl
            parm(i)=v(i)
          enddo
        endif
      endif
C
C check if type of event should be located 
C
      locate=.false.
      do i=1,3 
         if(typ.eq.loc_indicator(i)) locate=.true.
      enddo
c
c   check if only magnitudes should be calculated
c
      if(test(106).eq.1.0) then
         locate=.false.
         goto 30
      endif
c
c  check if event has enough phases and stations and if it
c  should be located
c      
      if(nphase.ge.minphase.and.locate.
     *and.nstat.ge.minstat) then  
c
c   set fixdepth indicator
c
         if(fixdepth .ne. ' ')then
            data(1)(44:44)=fixdepth
         endif
c
c  if type is E or P, fix depth to 0.0 km
c
         if(exp.eq.'P'.or.exp.eq.'E') then
            data(1)(39:44)='  0.0F'
         endif
      else
         write(6,291)typ,nphase
 291     format
     *   (1x,'type',1x,a1,2x,'NPHASE=',
     *   i2,'  NOT LOCATABLE') 
         if(nphase.lt.minphase) write(6,*)' Too few phases'
         if(nstat.lt.minstat) write(6,*) ' Too few stations'
c
c  check if location indicator is set or correctly set
c
         if(typ.ne.'L'.and.typ.ne.'R'.and.typ.ne.'D')
     *   write(6,*)' Missing or wrong event type, must be L,R or D'
         keys='NEXT'
         locate=.false.       ! was not located
C
C  No location, still try to calculate magnitudes  
C
         go to 30
      endif
C
c    locate one event
C
      init=2
      if(yter.eq.'Y') write(6,*)
c
c   if interactive output, position print file at end
c
      if(yter.eq.'Y') call hyp_print(write1,'e',maxline) 
c
c   clear old parameters
c
      call clear_old(data,nhead,nrecord,agency)

      do i=nhead+1,nrecord
         data(i)(61:70)='          '
c
c   keep distance if coda is there, so that magnitude can be calculated
c   in case not enough data for a location
c
         if(data(i)(30:33).eq.'    ') data(i)(71:75)='     '
         data(i)(76:79)='    '
      enddo

c
c   save year month and day before updating and calculate abs time
c
      read(data(1),'(1x,i4,1x,2i2)') year,month,day
      call  TIMSEC (year,month,day,0,0,0.0,abstim1)
c
c   save old header line
c
      data_old=data(1)
c     if(multi_model) then
c     write(6,*)' call hyp'
c     call hypocent(2,read2,write2,-1,write3,read3,
c    &init,'N',data,modnam,eventno,
c    &dlt,isort,test,yter1,maxline,nstat,locate,
c    &covar,oterr,nhead,nrecord,use_eev)
c     write(6,*) 'fin call hyp'
c     else


c -----------------------------------------------------------
c   check if grid search
c -----------------------------------------------------------
c
      if(grid_search) then
         multi_model=.true.   ! limit output
         open(27,file='gridsearch.out',status='unknown')
 4636    continue
         write(6,*) 'Latitude range and step'
         read(5,*) minlat,maxlat,dellat
         write(6,*) ' Longitude range and step'
         read(5,*)minlon,maxlon,dellon
         nlat=(maxlat-minlat+0.0001)/dellat+1
         nlon=(maxlon-minlon+0.0001)/dellon+1
         if(nlat.gt.71.or.nlon.gt.71) then
             write(6,*)
     *       ' Number of latitude and longitude points are: ',nlat,nlon
             write(6,*)' Max number is 71, choose again'
             goto 4636
         endif
c
c   write to contouring file
c
         write(27,'(a)')' Fields to use'
         write(27,'(a,2f10.3,i10)')
     *   ' Latitude range and number of values    ',
     *   minlat,maxlat,nlat
         write(27,'(a,2f10.3,i10)')
     *   ' Longitude range and number of values   ',
     *   minlon,maxlon,nlon
         write(27,'(a,a)')
     *   ' Contour level to plot and color          90.0'
         write(27,'(a,a)')
     *   ' Contour level to plot and color          50.0'
         write(27,'(a,a)')
     *   ' Contour level to plot and color          20.0'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           5.0'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           2.0'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           1.8'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           1.6'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           1.4'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           1.2'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           1.0'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.9'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.8'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.7'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.6'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.5'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.4'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.3'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.2'
         write(27,'(a,a)')
     *   ' Contour level to plot and color           0.1'
         data(1)(44:45)='FF'        ! fix hypocenter
         do ila=1,nlat
            grid_lat=minlat+dellat*(ila-1)
            write(6,*) 'Lat=',grid_lat
            do ilo=1,nlon
               grid_lon=minlon+dellon*(ilo-1)
               write(data(1)(24:38),'(f7.3,f8.3)') grid_lat,grid_lon
               call hypocent(2,read2,write2,write1,write3,read3,
     &         init,'N',data,modnam,eventno,
     &         dlt,isort,test,yter1,maxline,nstat,locate,
     &         covar,oterr,nhead,nrecord,use_eev)
               g_rms=one_rms
               write(27,*) grid_lon,grid_lat,g_rms
               if(g_rms.lt.grid_rms) then
                  grid_rms=g_rms
                  maxlat=grid_lat
                  maxlon=grid_lon
               endif
            enddo
         enddo
c
c   get output at best location
c
         multi_model=.false.
         write(data(1)(24:38),'(f7.3,f8.3)') maxlat,maxlon
         call hypocent(2,read2,write2,write1,write3,read3,
     &   init,'N',data,modnam,eventno,
     &   dlt,isort,test,yter1,maxline,nstat,locate,
     &   covar,oterr,nhead,nrecord,use_eev)
         write(6,*)maxlat,maxlon,grid_rms
         close(27)
      else

c
c   normal soulution
c

         call hypocent(2,read2,write2,write1,write3,read3,
     &   init,'N',data,modnam,eventno,
     &   dlt,isort,test,yter1,maxline,nstat,locate,
     &   covar,oterr,nhead,nrecord,use_eev)
      endif
 
c   if multi model mode, go to next event
c
       if(multi_model) then
          write(6,2838) eventno,data(1)(1:71)
          data(1)=datsave
          goto 50
       endif 
c
c   check if located
c
      if(.not.locate) goto 30
c
c   check if day has changed, if so correct all arrival times by + or -24 hours
c
      read(data(1),'(1x,i4,1x,2i2)') year,month,day
      call  TIMSEC (year,month,day,0,0,0.0,abstim2)
      if(dabs(abstim2-abstim1).gt.10.0) then  ! add 10 for posible round off err
         delhour=(dabs(abstim1-abstim2)+10.0)/3600
         if(abstim2.gt.abstim1) delhour=-delhour
         write(6,*)' Day has changed, hours added:', delhour
         write(write1,*,iostat=code)
     &         ' Day has changed, hours added:', delhour
         call sei code( fort$, code, write1, b_flag ) ! Process the outcoe.
c
         do i=nhead+1,nrecord-1
            read(data(i)(19:20),'(i2)') hour
            hour=hour+delhour
            write(data(i)(19:20),'(i2)') hour
         enddo
      endif
c
c   print out event on screen 
C
         if(yter.eq.'Y')
     *   call hyp_print(write1,'p',maxline) ! get output from print file
         if(yter.eq.'Y') write(6,*)
c
c-----------------------------------------------------------------------
c   enter here if event could not be located to only calculate magnitude
c   or no locate is desired by test 106 set
c-----------------------------------------------------------------------
c
 30   continue
c
c   clear old magnitudes, except 3.
c
      data(1)(57:72)='                '
      if(data(1)(77:79).eq.agency) data(1)(72:79)=' '
c
c   in case event not located, clear out old locations etc, however
c   keep 3. magnitude, unless same agency
c   if location is fixed, do not clean out header info
c   if test 106 set, do not clean location or location agency
c
      if(.not.locate.and.test(106).eq.0.0) then
         if(data(1)(44:44).ne.'F')data(1)(39:43)='     '
         if(data(1)(45:45).ne.'F')data(1)(24:38)='               '
         if(data(1)(44:45).ne.'FF') data(1)(46:48)='   ' ! keep old aga if fixe
         data(1)(49:72)='                        '
       endif

c
c   enter here if no location is made by using flag *
c
 31   continue
c
c  put in agency unless both epicenter and depth has been fixed
c  in which case it must the existing agency resposible for hypocenter
c  or if no location done
c
      if(data(1)(44:45).ne.'FF'.and.data(1)(45:45).ne.'*') 
     *data(1)(46:48)=agency
C
c   calculate  magnitudes, if no location flag is not set
C
         if(data(1)(45:45).ne.'*') then
            call update_mag(data,nhead,nrecord,agency,test,output)
c
c  update and average spectral information
c
            call update_spec(data,nrecord,nhead,agency,output)
         endif

c   output header line on screen, if not interactive, event number must be there
C
         if(yter.eq.'Y') then
            write(6,'(a)') data(1)(1:79)
c
c   write any second header line with additional magnitudes for prime solution
c
            do i=2,nhead
               if(data(1)(1:23).eq.data(i)(1:23).and.data(1)(46:48).eq.
     *            data(i)(46:48)) write(6,'(a)') data(i)(1:79)
            enddo
            write(6,'(a,a)') ' OLD:',data_old(6:79)
            if(extension(1:3).eq.'BGS') then
             if (data(1)(22:22).eq.'L') then
               read(data(1)(24:39),'(f7.3,f8.3)') bnglat,bnglon
               call latlon2ukgrid(bngerr,bnglat,bnglon,bnge,bngn)
               write(6,
     *      '('' Grid ref    : '',f9.3,'' East /'',f9.3,'' North'')')
     *            bnge,bngn
             endif
            endif
            write(6,*)
         else
            write(6,2838) eventno,data(1)(1:71)
 2838       format(1x,'#',i5,1x,a71)
         endif
C
C
c  write normal output file, sort first if event has been located
C

c 4/94: added sort by distance option
c
c     if(test(71).ne.0.0.and.locate)then
      if(test(71).ne.0.0)then
        do i=nhead+1,nrecord-1
         read(data(i)(71:75),'(f5.0)')dlt(i-nhead)
        end do

        call r4sort(nrecord-1-nhead,dlt,isort)
c
c   now sort so the distance sorted phase lines, for each group of
c   as in the original file
c
        old_dist=data(isort(1)+nhead)(71:75)
        old_stat=data(isort(1)+nhead)(2:6)
        k=0
        l=0
        do i=nhead+1,nrecord-1
           l=l+1
           read(data(isort(l)+nhead),'(18x,2i2,f6.2)') hour,min,sec
           if(data(isort(l)+nhead)(71:75).eq.old_dist.and.
     *     data(isort(l)+nhead)(2:6).eq.old_stat) then 
              k=k+1
              lsort(k)=isort(l)
              dlt(k)=sec+min*60+hour*3600
              if(i.ne.nrecord-1) goto 73   ! at the end, always sort what is left
              l=l+1                        ! since this is last value
           endif
c
c   if here, new distance or station or last group
c
           if(k.gt.1) then
               call r4sort(k,dlt,ksort)
               m=1
               do j=l-k,l-1
                  isort(j)=lsort(ksort(m))
                  m=m+1
               enddo 
           endif
           if(i.eq.nrecord-1) goto 73
           old_dist=data(isort(l)+nhead)(71:75)
           old_stat=data(isort(l)+nhead)(2:6)
           k=1    ! this is the first of the next group
           dlt(k)=sec+min*60+hour*3600
           lsort(k)=isort(l)
 73        continue
         enddo
c
c   write out
c
        do i=1,nhead
        write(write2,'(a80)',iostat=code) data(i)
        call sei code(fort$,code,write2,b_flag) ! process outcome.
        enddo 
c
        do i=nhead+1,nrecord-1
        write(write2,'(a80)',iostat=code)
     &        data(isort(i-nhead)+nhead)
        call sei code(fort$,code,write2,b_flag) ! process outcome.
        end do          
c
        write(write2,'(a80)',iostat=code) data(nrecord)
        call sei code(fort$,code,write2,b_flag) ! process outcome.
      else
      write(write2,'(a80)',iostat=code)
     &      (data(i),i=1,nrecord)
      call sei code(fort$,code,write2,b_flag) ! process outcome.
      endif    
c
c write out brief format output
c
      if(extension(1:3).eq.'BGS') then
         call make_hypoc_brief(data,nstat,nphase,nhead,nrecord)
      endif
c
c   stop here if using eev
c
      if(use_eev) goto 999 
c
      if(yter.ne.'Y') keys='NEXT'
      if(yter.eq.'Y') keys='SAME'

      data(1)=datsave
      go to 50                                        
C
c   this was the end
C
  900 continue
      if(yter.eq.'Y') call hyp_print(write1,'e',maxline) 
      if(yter.ne.'Y'.and.(.not.multi_model)) 
     *write(6,*)' Making residual summary'
      call hypocent(3,read2,write2,write1,write3,read3,
     &init,'N',data,modnam,eventno,
     &dlt,isort,test,yter1,maxline,nstat,locate,
     &covar,oterr,nhead,nrecord,use_eev)
      
c
c  multi model inversion
c
      if(multi_model) then
         if(rmssum.lt.rmssum_min.and.rmssum.gt.0.0001) then
            rmssum_min=rmssum
         endif
c
c   check range of min models, if smaller than largest one, add
c

         rmax=-1.0 
         do k=1,nmin
            if(rms_min(k).gt.rmax) then
                rmax=rms_min(k)
                kmax=k
            endif
         enddo
         if(rmssum.lt.rmax) then
            do i=1,nl
              v_min(kmax,i)=v(i)
              d_min(kmax,i)=d(i)
              rms_min(kmax)=rmssum
            enddo
         endif
c
         rewind(read1)
c
c  inv
c
         write(2,'(f7.3,2x,16f6.2)') rmssum,(v(i),d(i),i=1,nl)
      endif 
      enddo 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo 
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      if(multi_model) then
         write(2,*)
         write(2,*)' Minimum rms', rmssum_min
         write(2,*)
         write(2,*)' The best models'
         write(2,*)
         write(6,*)' Minimum rms', rmssum_min
         do k=1,nmin
            write(2,'(f7.3,2x,16f6.2)') 
     *      rms_min(k),(v_min(k,i),d_min(k,i),i=1,nl)
         enddo
      endif

c  close files (BRL 4/94)
      
      write(6,*)' print output in file print.out'
      write(6,*)' CAT-file in file hyp.out'
      write(6,*)' Summary file in hypsum.out'
  999 continue
      call sei close( close$+all$, 0, code ) ! Close all files.
c     call clear_underflow
      stop
      end                                                               
c
      subroutine hyp_print(unit,action,maxline)
      implicit none
      include 'libsei.inc'
      external sei code
c
      integer   code          ! Local condition.
      logical   b_flag        ! Flag a situation?.
c
c   scroll forth and back in print.out file
c
      integer unit           ! unit for print.out file
      character*80 text      ! one line of text
      integer maxline        ! number of lines to print
      character*1 action     ! what to do
      integer i,nline
c
c   print solution from station line
c
      if(action.eq.'p') then
         nline=0
 1       continue
         backspace( unit,iostat=code)
         call sei code(fort$,code,unit,b_flag)
c
         read(unit,'(a)',iostat=code) text 
         call sei code(fort$,code,unit,b_flag)
         if( b_flag ) goto 99
c
         if(text(4:7).eq.'date') goto 2
         backspace( unit,iostat=code)
         call sei code(fort$,code,unit,b_flag)
         goto 1
  2      continue
c
c  epi line found, write out
c
         write(6,'(a)') text
         nline=nline+1
         read(unit,'(a)',iostat=code) text
         call sei code(fort$,code,unit,b_flag)
         if( b_flag ) goto 99
         write(6,'(a)') text
         nline=nline+1
c
c   now go to station lines
c
 3       continue
         read(unit,'(a)',iostat=code) text 
         call sei code(fort$,code,unit,b_flag)
         if( b_flag ) goto 99
         if(text(2:4).eq.'stn') goto 4
         goto 3
c
 4       continue
         write(6,'(a)') text
         nline=nline+1
 5       continue
         read(unit,'(a)',iostat=code)text 
         call sei code(fort$,code,unit,b_flag)
         if( b_flag ) goto 99
c
c   check for end of phases
c
         if(text(1:13).eq.'          ') go to 6
c
c   write station lines 
c
         write(6,'(a80)') text 
         nline=nline+1
         if(nline.gt.maxline) then
            nline=0
            write(6,'('' Return to continue, q to end listing '',$)')
            read(5,'(a)') text
            if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') goto 6
         endif
         goto 5
 6       continue
         return
      endif
c
c   go back one screen
c
      if(action.eq.'.') then
         do i=1,maxline*2
           backspace (unit,iostat=code)
           call sei code(fort$,code,unit,b_flag)
         enddo
         do i=1,maxline
           read(unit,'(a)',iostat=code) text
           call sei code(fort$,code,unit,b_flag)
           if( b_flag ) goto 99
           write(6,'(a)') text
         enddo
         return
      endif
c
c  go foreward one screen
c
      if(action.eq.',') then
         do i=1,maxline
            read(unit,'(a)',iostat=code) text
            call sei code(fort$,code,unit,b_flag)
            if( b_flag ) goto 99
            write(6,'(a)') text
         enddo
         return
       endif
c
c   goto end of file
c
       if(action.eq.'e') then
 12        continue
           read(unit,'(a)',iostat=code) text
           call sei code(fort$,code,unit,b_flag)
           if( b_flag ) goto 99
           goto 12
       endif
c
 99    continue
       backspace( unit, iostat=code)
       call sei code(fort$,code,unit,b_flag)
 999   continue
       return
       end
c
      subroutine find_file_type(unit,type)
      save
      include 'libsei.inc'
      external sei code
c
      integer   code          ! Local condition.
      logical   b_flag        ! Flag a situation?.
c
c  find if an input file is Nordic (type=1) or index file (type 2) or
c  something else (type = 3)
c
      character*80 text
      integer i,unit,type 

      rewind( unit,iostat=code)
      call sei code(fort$,code,unit,b_flag)
      type=3
c
c   check if nordic file
c
      
c
c  one of the first 2 lines should be a header
c
      do i=1,2
        read(unit,'(a80)',iostat=code) text
        call sei code(fort$,code,unit,b_flag)
        if( b_flag ) goto 10                      ! End of file.
        if((text(22:22).ne.'L'.and.text(22:22).ne.'R'.
     *  and.text(22:22).ne.'D'.and.text(22:22).ne.' ').
     *  or.(text(11:11).ne.' '.or.text(16:16).eq.' '))
     *  type=3
      enddo
c
c
c   check for index file
c
       rewind( unit,iostat=code)
       call sei code(fort$,code,unit,b_flag)
c
       read(unit,'(a)',iostat=code) text
       call sei code(fort$,code,unit,b_flag)
       if( b_flag ) goto 10
c
       do i=1,80
        if((text(i:i+2).eq.'L.S'.or.text(i:i+3).eq.'D.S'.or.
     *     text(i:i+2).eq.'R.S').and.text(6:7).eq.'  ') then
           type=2
           return
        endif
       enddo 
c
 10    continue
       return
        end

cc
c   scpectral calculations in mulplt
c
c   problems: seems like corner frequnecy-stress drop is no calculated correctly
c                   for spectral modelling , jh ocy 07


c   updates
c   
c   jun 6 by jh : add mb filter
c   jul 25      : do not calculate moment etc if no distance
c   dec 28      : ******** version 5.0 ********************* (no change)
c                 put in new xy_plot routine
c   fef 95      : -------------------------- with axis text
c   mar 21      : bug in get_3_chan
CJAB(BGS)Apr95  : Give prompt text the prompt text colour in remove_resp, so 
CJAB(BGS)Apr95.   that it always shows.
c   apr 21 95 jh : ratation in get_3_chan
c   april 28  jh : az bug
c   jun 7        : only ask once for disp vel in multitrace mode
c   nov 17       : ffmin and ffmax as parameters from MULPLT.DEF
c   dec 95       : plot response
c   jan 23   96  : noise spectrum
c   jan 31       : spectral fitting
c   feb 14       : enter moment interactively
c   mar 20       : message if response from header
c   jul 25       : fix picking error if 3 comp
c   aug 2        : do not calculate hbypocentral distance, now in convert
c                  use seiget for spectral modeling
c   sep 24       : power spectrum
c   dec 96       : remove all reference to depth in calc moment
c   feb 97   97  : ms response
c   feb 19       : new message in resp and spec
c   feb 20       : remove disp_vel from call and spectrum input, put in
c                  mulplt.inc
c   sep 22       : limit wa response to 20 hz
c   oct          : spectral output
c   oct 29       : check if no zero lenght spectrum 
c   nov 30       : do not ask question if waveform out
c   jan 23 98    : do not save chead since now done in sys_resp
c   feb 17       : small changes to selection
c   feb 18       : fix spectral bug with p spectra, auto selection of velocity
c-----------------------------------------------------------------------------
c   sep 98 jh    : ----------- year 2000 check -----------------------------
c                  year 2000, 5 character station code
c   nov 4  jh    : linux logig
c   nov 5        : change c-routines having '_'
c   nov 26 jh    : change use of kappa, also kappa in spectrum
c   dec 18       : bug turning off permanenly response removel if one trace
c                  did not have a response file
c   march 17, 99 : bug in 3 comp
c
c   mar 24 bmt   : clear input in oneline
c   may 27 jh    : hardwire  petersen noise curves
c   may 2        : fix noise spectrum level                
c   jul 14       : put correct petersen curves
c   aug 23       : do not correct for q and kappa when making noise spectra
c   sep 19       : add routien spec_dist, change geometrical spreading calcula
c   sep 23       : add geo_distance
c   sep 27       : put kappa correction back in, where did it go ????
c   nov 9 99 jh  : do not calculate moment if not displacment spec
c                  clean up display a bit
c   nov 26       : add date to response plot, shift a bit dec 6
c   dec 08 lo    : in get_3_chan read more then 30 stations from header
c   mar 30 00 jh : fix text for plotting response file
c   oct 26       : frequency limits in spectral plotting is determined by
c                  filter used, overdides defualts
c   dec  14      : scale power noise spectra after peterson curves
c   dec  17      : choice of lin x-axis in plot, chose fmin, fmax, t*
c   jan 2001     : remove mulplt.inc from prepare, spectrum, rem_resp
c                  remove prpare, remove_resp, pectrum precoh1,cross
c                  and rotate_comp form this file
c   feb 2001 bgs : bgs added choise of axis types and what else ?
c                  t* disabled again
c   mar 28     lo: seesm that lars corrected the power spectrum
c   may 27     jh: make log-log the defualt spectrum again
c   june  10   jh: some correction to above
c   june 22    lo: set dimension of nnspec in amp_spec to 3
c   jul 10     jh: add output of modeled spectrum in spectral_fit.out
c   sep 10       : add selection of type of spectrum
c   sep 21       : more spectrum selection fixing
c   jan 26 04  jh: if not 3 channels, do not refesh readings, were lost 
c   nov 22 04  jh: plot whole response type instead of one letter
c   sep 3  07  jh: check for p or s velocity when spectrun do not have
c                  a phase read
c   oct 12 07  jh: fix new way of calculating source radius
c   feb 13 08  lo: add particle motion
c   oct 29 08  jh: bettere message if spectral limit too small
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc             
      subroutine amp_spec                                                 
c                                                                               
c     routine to make a real spectrum                
c     The tapering of  the data is fixed to 10%                                 
c                                                                               
c     First written by C. Lindholm Jan. -90  Jh june 93                                         
c
      implicit none                                                                               
c                                                                                
c-- common block     
c                                
      include 'mulplt.inc'			
      include 'libsei.inc'
      include 'seiplot.inc'
      include 'seisan.inc'
c
c-- percentage of tapering (fixed)                       
      real taper/10./				
c-- length of input vector                                 
      integer nsamp				
c-- length after padding                                    
      integer ipow				
c-- vector padded with npad zeros                           
      integer npad				
c-- indicator for response removal or not (1 or 0).                        
      integer rem_resp			
      real ff ! frequency
c-- number of points in spectrum
      integer nspec
      real f_low,f_high
      integer pole_low,pole_high
c-- if several data sets, number of points in each
c      integer nnspec(2)
      integer nnspec(3)   ! lo, 22 June 2001
      integer xy_cursor             ! for call to xy_plot
      real xlength                  ! x-axis length for spectrum
      real save_q0,save_kappa       ! temporary storage
c-- counters and help variables                                               
      integer i,j
      real aa,bb,corr,rms           ! output from least squares
      real tstar                    ! tstar atteneuation, same as kk
      character*80 text, text1
      character*30 xtext,ytext      ! axis text
      character*1 ch                ! retuern from spectral type select
      character*1 ch1               ! return from axes type select (bjb 2001/02/22)
      real xx,yy                    ! help variables
      real amp_average              ! average log amplitude spectra
      real norm_factor              ! normalization factor for source fit
      real qq,qa,kk,f0              ! source test parameters:Q0, qalpha,diminu
                                    ! -ation parameter, cornor frequency
      integer code                  ! return status code
c--returns from spectral plot
      character*1 c_spec(20)
      character*80 message(10)      ! text to screen
      character*80 blank(10)        ! blank text strings
      real average_moment           ! moment read from data
      real ssdrop                   ! sress drop calculated in spectral fitting
      real sei real num             ! function
      real x0                       ! left corner of spectrum
c-- origin time
      integer oyear,omonth,oday,ohour,omin
      real osec
      double precision otime
      real cx(20),cy(20)
      integer nc,k
      real geo_factor     ! geometrical spreading factor
      real x_work(max_sample)
      logical power    ! if true, make power spectrum
      logical linx     ! if true, linear x-axis in spec
c-- axis type variable for spectra
c-- 1=Log-Linear
c-- 2=Log-Log
c-- 3=Linear-Linear
      integer iaxes_type
      character*80 answer
      logical sun,pc,linux
      real low_f(22),high_f(14),low_l(22),high_l(14) ! petersen noise
      equivalence(x_work,com)
c
c   petersen noise curves, log f and db
c
      data high_f/   1.000000,    6.575773E-01,    4.948500E-01,
     *           9.691001E-02,   -5.797836E-01,   -6.627579E-01,
     *           -7.993407E-01,  -8.976271E-01,   -1.187521,
     *           -1.301030,       -2.549984,       -4.000000,
     *            -4.477121, -5.0/
      data high_l/ -91.5,-97.4,-110.5,-120.0,-97.9,-96.5,-101.0,
     *             -113.5,-120.0,-138.5,-126.0,-80.1,-65.0,-48.5/ 

      data low_f/    1.000000,    7.695511E-01,    3.979400E-01,
     *             9.691001E-02, -9.342168E-02,   -3.802112E-01,
     *            -6.334685E-01,  -6.989700E-01,  -7.781512E-01,
     *             -1.000000,       -1.079181,       -1.193125,
     *              -1.340444, -1.50, -1.65, -1.89, -2.0,
     *              -2.19,-2.51,-2.78,-4.0,-5.0/
      data low_l/   -168.0,-166.7,-166.7,-169.2,-163.7,-148.6,
     *              -141.1,-141.1,-149.0,-163.8,-166.2,-162.1,
     *              -177.5,-185.0,-187.5,-187.5,-185.0,-184.9,
     *              -187.5,-184.4,-151.9,-103.1/ 
c
      do i=1,10
        blank(i)=' '
      enddo
      linx=.false.      ! normally log x axis
      call computer_type(sun,pc,linux)
c
c   check if enough points
c
      if((last-first).lt.20) then
         text=' Window too short for transformation, nothing done'
         call xmessage(text,1,80,10.0,60.0)
         return
      endif
                 
      average_moment=0.0
c-- indicator for type of spectrum fixed to 1 for displacement                 
      disp_vel=1			

      iaxes_type=2  ! defualt log-log axis
c
c   display general parameters
c
 400  continue
c
c   find if p or s spectrum
c
      if(spec_phase.eq.'P') spec_velocity=pvelocity
      if(spec_phase.eq.'S'.or.spec_phase.eq.'N') spec_velocity=svelocity
      if(spec_phase.eq.'N') spec_phase='?'  ! unknown spectrum
c
      message(1)='General parameters, '//spec_phase//'-spectrum'
      write(message(2),'(a,f5.1,a,f5.2,a,i5)')  'Vel ',spec_velocity,
     *' Dens',density, ' Dist',int(sdistance)
      write(message(3),'(a,i5,a,f5.2,a,f5.3)')
     *'Q0  ',int(q0),' Qalp',
     *   qalpha,' k   ',kappa
      call xmessage(message,3,30,620.0,100.0)
    
      
c
c   first check if response is to be removed and if available
c
      rem_resp=0
      message(1)='Displacement:    D'
      message(2)='Velocity:        V'
      message(3)='Acceleration:    A'
      message(4)='Raw spectrum:    R'
      message(5)='Change velocity: C'
      message(6)='Change moment:   M'
      message(7)='Noise Pow. spec: N'
      message(8)='Lin axis:        L'
      message(9)='New spec f-lim.. F'
      message(10)='Change spectrum  S'
      call xmessage(message,10,40,620.0,180.0)
c
c   get answer
c
      call xscursr(i,xx,yy)
      ch=char(i)
      if(ch.eq.'c'.or.ch.eq.'C') then
         call xmessage(blank,10,40,620.0,180.0)
	   text = '                    '
         call oneline('New velocity',12,text,20,620.0,300.0)
         read(text,'(f8.2)') spec_velocity
         if(sun.or.linux) call xscursr(i,xx,yy)  ! on sun buffer not cleared, why ?
         goto 400   ! start again
      endif

      if(ch.eq.'f'.or.ch.eq.'F') then
         call xmessage(blank,10,40,620.0,180.0)
	   text = '                    '
         call oneline('Spec fmin, fmax',15,text,20,620.0,300.0)
         call sei get values(2,text,code)
         ffmin=array$(1)
         ffmax=array$(2)
         if(sun.or.linux) call xscursr(i,xx,yy)  ! on sun buffer not cleared, why ?
         goto 400   ! start again
      endif

c commented following option for linear axes bjb 22/02/2001
c      if(ch.eq.'l'.or.ch.eq.'L') then
c          linx=.true.   ! linar x-axis
c         call xmessage(blank,9,40,620.0,180.0)
c           text = '                    '
c         call oneline('New velocity',12,text,20,620.0,350.0)
c         read(text,'(f8.2)') spec_velocity
c         if(sun.or.linux) call xscursr(i,xx,yy)  ! on sun buffer not cleared, why ?
c         goto 400   ! start again
c      endif

       if(ch.eq.'l') then
c
c Ask for axes type log-log or log-linear or linear-linear (bjb 01/03/2000)
c
           message(1)='Log(x)-Linear(y)    1'
           message(2)='Log(x)-Log(y)       2'
           message(3)='Linear(x)-Linear(y) 3'
           message(4)='Linear(x)-Log(y)    4'
     
           call xmessage(message,4,30,800.0,275.0)
c
c   get answer
c
           call xscursr(i,xx,yy)
           ch1=char(i)
           call xmessage(blank,3,30,800.0,275.0)

           iaxes_type=1
           if(ch1.eq.'1') iaxes_type=1 
           if(ch1.eq.'2') iaxes_type=2
           if(ch1.eq.'3') iaxes_type=3
           if(ch1.eq.'4') iaxes_type=4
           goto 400
      endif

      if(ch.eq.'m'.or.ch.eq.'M') then
         call xmessage(blank,10,40,620.0,180.0)
	   text = '                    '
         call oneline('New moment',12,text,20,620.0,300.0)
         read(text,'(f8.2)') average_moment
         goto 400   ! start again
      endif
c
      if(ch.eq.'s'.or.ch.eq.'S') then
 7654    continue
         call xmessage(blank,10,40,620.0,180.0)
	   text = '                    '
         call oneline('Enter p or s for type',21,text,5,620.0,300.0)
         spec_phase=text(1:1)
         if(spec_phase.eq.'p') spec_phase='P'
         if(spec_phase.eq.'s') spec_phase='S'
         if(spec_phase.ne.'P'.and.spec_phase.ne.'S') goto 7654
         goto 400   ! start again
      endif
c
c   final clear before going on
c
      call xmessage(blank,10,40,620.0,180.0)
 
         
      disp_vel=0
      power=.false.
      if(ch.eq.'A'.or.ch.eq.'a') disp_vel=3
      if(ch.eq.'V'.or.ch.eq.'v') disp_vel=2
      if(ch.eq.'D'.or.ch.eq.'d') disp_vel=1
      if(ch.eq.'D'.or.ch.eq.'V'.or.ch.eq.'A') power=.true.
      if(ch.eq.'n'.or.ch.eq.'N') then
        power=.true.
        disp_vel=3
        ch='N'
      endif
      if(disp_vel.gt.0) rem_resp=1
      if(rem_resp.eq.1) then
         wav_resp_file = ' '
         call read_resp
         if(wav_resp_status(1:1).eq.'9') then
            write(text(1:20),'(a)')'No response info ***'
            call tchars(text,20,620.0,225.0)
            rem_resp=0
         endif
         if(wav_resp_status.eq.'8') then
            write(text(1:33),'(a)')'Response from waweform header ***'
            call tchars(text,33,620.0,320.0)
         endif
      endif
c
c   check if velocity given for displacment spectrum
c
      if(disp_vel.eq.1.and.spec_phase.eq.'?') then
 9765        continue
             text='Spectrum not defined, enter p or s'
             call oneline(text,35,answer,2,500.0,500.0)
             spec_phase=answer(1:1)
             if(spec_phase.eq.'p') spec_phase='P'
             if(spec_phase.eq.'s') spec_phase='S'
             if(spec_phase.ne.'S'.and.spec_phase.ne.'P') goto 9765
c
c   check for velocity, added by jh sep 3 2007
c
             if(spec_phase.eq.'P') spec_velocity=pvelocity
             if(spec_phase.eq.'S'.or.spec_phase.eq.'N')
     *       spec_velocity=svelocity
      endif
c                                                                               
c--------put part of the signal into local datavector, can be noise or signal
c
 1    continue                  ! back here if a noise spectrum made
c                                                                               
      if(noise_spectrum.eq.2) then   ! use start of signal for noise spectrum
         last=last-first
         first=1
         do i = 1,last                                                         
            y(i)=signal1(i)                                                              
         enddo
      else                      ! use selected time window
         j =  0                                                                    
         do i = first,last                                                         
            j = j + 1                                                               
            y(j) = y(i)                                                            
         enddo                                                                     
      endif
                                                                                
      nsamp = last-first+1                                                                 
c                                                                               
c------- prepare data.     Pad with zeros and taper 10%.                        
c                                                                               
      call prepare(nsamp,y,taper,ipow,npad,com)                                
c
c   check for max number of points
c
      if(ipow.ge.max_sample/2) then
           call clear_to_alpha
           write(6,*)' Too many points in spectrum'
           write(6,*)' Max number is ', max_sample/2
           stop
      endif                                

c
c   calculate travel time for q correction, first get origin time
c   but only if running from data base (opmode = 0)
c
      if(opmode.eq.0) read(data(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)')                                     
     *oyear,omonth,oday,ohour,omin,osec                                         
c                                                                               
c   get absolute origin time in secs                                            
c                                                                               
      if(opmode.eq.0) 
     *call timsec(oyear,omonth,oday,ohour,omin,osec,otime)                      
c
c   calculate travel time. ffsec is waveform file abs start time from
c   routine convert in mulplt, stime is time from start of wave form file
c   to first sample in spectral window
c
      if(opmode.eq.0) travel_time=ffsec-otime+stime
c
c   put in some defaults if opmode not 0
c
      if(opmode.ne.0) then
         travel_time=1.0
      endif

c                                                                               
c-------- Calculate the spectrum, and remove the system response
c         if desired. If noise sepctrum, do not use q and kappa                
c              
      if(ch.eq.'N') then
         save_q0=q0
         save_kappa=kappa
         kappa=0
         q0=0          ! do not use q and kappa
         spec_phase='N'
      endif
c
c   rewrite message since it might have changed
c
      message(1)='General parameters, '//spec_phase//'-spectrum'
      write(message(2),'(a,f5.1,a,f5.2,a,i5)')  'Vel ',spec_velocity,
     *' Dens',density, ' Dist',int(sdistance)
      write(message(3),'(a,i5,a,f5.2,a,f5.3)')
     *'Q0  ',int(q0),' Qalp',
     *   qalpha,' k   ',kappa
      call xmessage(message,3,30,620.0,100.0)
      pole_low=0
      pole_high=0
      if(filt.gt.0) then
         f_low=flow(filt)
         f_high=fhigh(filt)
         pole_low=8
         pole_high=8
      endif
      call spectrum(com,ipow,disp_vel,rem_resp,rate,
     +     f_low,f_high,pole_low,pole_high,q0,qalpha,
     *     kappa,travel_time)

c
      if(ch.eq.'N') then          ! put values back in
         q0=save_q0                            
         kappa=save_kappa
         iaxes_type=2             ! only allow log-log
      endif

c
c   write out spectrum if not a noise spectrum and flag set
c
      if(noise_spectrum.lt.2.and.abs(spec_out).eq.1) then
          open(15,file='com_spec.out',status='unknown')
          write(15,*) ipow,rate,swindow
          write(15,'(4E15.8)')(com(i),i=1,ipow/2+1)
          close(15)
          spec_out=-1   ! indicate this was first spectrum
      endif
c
c   calculate real spectrum, limit to frequencies ffmin and ffmax
c
      j = 0
 
      do i = 2,((ipow/2) + 1)
       ff = (i-1)*rate/ipow
       if((filt.ne.0.and.ff .ge. flow(filt) .and. ff .le. fhigh(filt)).
     * or.(filt.eq.0.and.ff .ge. ffmin      .and. ff .le. ffmax)) then
         j = j + 1
         if(power) then
c            y(j) = ((com(i)*conjg(com(i)))/nsamp)    ! stationary signal
c changed March 28, 2001, lo, psd as defined in the numerical recip.
c
            y(j) =2*com(i)*conjg(com(i))/(rate*nsamp)    ! stationary signal
         else
            y(j) = ((1/rate)**2)*(com(i)*conjg(com(i)))    ! transient signal
            y(j) = sqrt(y(j))              ! j.h. change
         endif

c         y(j) = log10( y(j) )                        ! take the logarithm
c
c Set the axes type (bjb 22/02/2001) 
c
         if(iaxes_type.eq.1) then
           x_work(j) = log10(ff)
           ytext='    Amplitude                '
           x0=-110.0                  ! indicate antilog on x-axis notation
         endif
         if(iaxes_type.eq.2) then
           y(j) = log10( y(j) )       ! take the logarithm
           x_work(j) = log10(ff)      
           ytext='Log amplitude                '
           x0=-110.0                  ! indicate antilog on x-axis notation
         endif
         if(iaxes_type.eq.3) then
           x_work(j) = ff
           ytext='    Amplitude                '
           x0=110.0                   
         endif
         if(iaxes_type.eq.4) then
           y(j) = log10( y(j) )       ! take the logarithm
           x_work(j) = ff             
           ytext='Log amplitude                '
           x0=110.0                   
         endif

         if(ch.eq.'N') y(j)=(y(j)-18.0)*10.0  ! db (m/s**2)**2

c         if(linx) then
c            x_work(j) = (ff)
c         else
c            x_work(j) = log10(ff)
c         endif

       endif
      enddo
c
c   text for kind of spectrum
c
      if(disp_vel.eq.0) write(text,'(a)')'Uncorrected  '
      if(disp_vel.eq.3) write(text,'(a)')'Acceleration '
      if(disp_vel.eq.2) write(text,'(a)')'Velocity     '
      if(disp_vel.eq.1) write(text,'(a)')'Displacement '
      if(power.and.ch.ne.'N') text=text(1:12)//', power'
      if(ch.eq.'N') text=text(1:12)//', power, db(m/s**2)**2/Hz'

c
c  possibly clculate slope and t*
c
      if(linx.and.noise_spectrum.lt.2) then
         call lsqlin(j,x_work,y,aa,bb,corr,rms)
         tstar=bb*0.879    ! 0.879 = 1/(pi * log10(e))
         message(1)(1:12)='Lin fit: t*='
         write(message(1)(13:20),'(f8.3)') tstar
         message(1)(21:22)=' c '
         write(message(1)(23:30),'(f8.3)') corr
         call xmessage(message,1,30,620.0,20.0)
      endif
c
c   possibly write out amplitude spectrum
c

      if(noise_spectrum.lt.2.and.abs(spec_out).eq.1) then
          open(15,file='amp_spec.out',status='unknown')
          write(15,'(a)') text
          if(linx) then
             do i=1,j
               write(15,*) x_work(i),y(i)
             enddo
          else
             do i=1,j
               write(15,*) 10.0**x_work(i),y(i)
             enddo
          endif
          spec_out=-1           ! indicate a spectrum written out
          close(15)
      endif
c
c   check that filter limits for spectral output give at least 3 points
c
      if(j.lt.3) then
         call clear_to_alpha
         write(6,*)' Too few points in spectrum or limits wrong'
         write(6,*)' see mulplt.def'
         write(6,*)' Enter to stop'
         read(5,'(a)') i
         stop
      endif
c
c   find some kind of average to use with spectral fitting when
c   the signal spectrum is in y
c
      if(noise_spectrum.lt.2) then
c        amp_average=(y(j/2) +y(j/2-5)+y(j/2+10))/3.0
          do i=3,j/4
             amp_average=amp_average+y(i)
          enddo
          amp_average=amp_average/(j/4-3+1)
      endif
      nspec=j
c
c   clear top part of screen and display new choises
c
      call xset_color(color_back)
      call fillbox(0.0,690.0,1024.0,780.0)
      
c
c   plot spectrum
c
      xtext='          Frequency (Hz)     '
c commented following line (bjb 22/02/2001)
c      ytext='Log amplitude                '
      nnspec(1)=nspec
      if(linx) then
         x0=110.0
      else
c commented following line (bjb 22/02/2001)
c         x0=-110.0      ! indicate antilog on x-axis notation
      endif
      xlength=500.0    ! length of x-axis
      if(noise_spectrum.eq.0.or.noise_spectrum.eq.2) then
         xy_cursor=4   ! stop with cursor, signal or noise after sign spectrum
         if(noise_spectrum.eq.2) xlength=0.0  ! same scale as signal spectrum
      else
         xy_cursor=0   ! do not call up cursor
      endif
c
c   display new choises
c
      message(1)=
     *'Valid input is now:  Mouse click to select 3 points in spectrum'
	  message(2)=
     *'                     R: Replot     F: Foreward or next trace   ' 
      message(3)=
     *'                     Q: Quit       S: Make spectral modeling   '
      call xmessage(message,3,64,10.0,700.0)

c
c   add noise limits if power noise spectrum, only log-log
c
      if(ch.eq.'N') then
        k=0
        do i=1,22
          ff = 10.0**low_f(i)
          if(ff .ge. ffmin .and. ff .le. ffmax) then
             j=j+1
             k=k+1
                x_work(j)=low_f(i)
                y(j)=low_l(i)
           endif
        enddo
        nnspec(2)=k
        k=0
        do i=1,14
          ff = 10.0**high_f(i)
          if(ff .ge. ffmin .and. ff .le. ffmax) then
             j=j+1
             k=k+1
               x_work(j)=high_f(i)
               y(j)=high_l(i)
          endif
        enddo
        nnspec(3)=k
        xy_cursor=4   ! stop after plot
       endif

       k=1
       if(ch.eq.'N') k=3

      call xy_plot
     *(k,nnspec,x_work,y,text,xtext,ytext,xlength,270.0,
     *x0,70.0,2,1,30.0
     *,xy_cursor,c_spec,nc,cx,cy)

c
c   if noise spectrum (not power noise), go back to the beginning, 
c   but first reset
c   noise spectrum indicator
c
      if(noise_spectrum.eq.1.and.ch.ne.'N') then
         noise_spectrum=2     ! indicate next spectrum to be a noise spectrum
         goto 1
      else
         noise_spectrum=0     ! reset
      endif
      if(c_spec(nc).eq.'f'.or.c_spec(nc).eq.'F') choice='FINI'
      if(c_spec(nc).eq.'r'.or.c_spec(nc).eq.'R') choice='REPL'
      if(c_spec(nc).eq.'q'.or.c_spec(nc).eq.'Q') choice='QUIT'
      if(c_spec(nc).eq.'s'.or.c_spec(nc).eq.'S') choice='FIT '
c
c   calculate and write spectral values if at least 3 points sampled,
c   last point is exit, use 3 values before that.
c   
c
      omega0=0.0
      cornerf=0.0
      if(nc.gt.3) then
            if(ch.eq.'D'.or.ch.eq.'d') then   ! only calculate parameters for
            omega0=(cy(nc-3)+cy(nc-2))/2.0    ! displacement spectrum
            cornerf=10.0**cx(nc-2)
            if((cx(nc-2)-cx(nc-1)).ne.0.0)
     *      sslope=-(cy(nc-2)-cy(nc-1))/(cx(nc-2)-cx(nc-1))
            moment=0.0
            sdrop=0.0
            call calcmoment
c
c  output on screen
c
            message(1)= 'Amplitude spectral parameters'
            write(message(2),
     *      '(a,f6.2,a,f6.1,a,f5.1)') 'Mo  ',moment,
     *      ' ST ',sdrop,' OM  ',omega0
            write(message(3),'(a,f7.3,a,f5.1,a,f5.1)')
     *      'f0 ',cornerf,' R   ',radius,' MW  ',mw
            message(4)= ' '
            message(5)='Push any key to continue, R to replot '
            call xmessage(message,5,40,620.0,275.0)
         else
            moment=0.0
            sdrop=0.0
            message(1)='No spectral parameters calculated'
            message(2)='Not a displacement spectrum'
            message(3)='Push any key to continue, R to replot '
            call xmessage(message,3,40,620.0,275.0)
         endif
c
c   if choice is forward, stop so display remain
c
         call xscursr(i,xx,yy)			
         if(char(i).eq.'r'.or.char(i).eq.'R') choice='REPL'
         if(char(i).eq.'s'.or.char(i).eq.'S') choice='FIT '
      endif
c
c------------------------------------------------
c   calculate spectral fitting parameters
c------------------------------------------------
c
      if(choice.eq.'FIT ') then      
c
c   get moment if available and if not already entered manually
c
         if(average_moment.eq.0.0) then
            do i=2,nhead
              if(data(i)(2:13).eq.'SPEC AVERAGE') then
                 read(data(i)(18:22),'(f5.2)',err=3846) average_moment
                 goto 3847
              endif
 3846         continue
              average_moment=0.0    ! is log moment
            enddo
 3847       continue              ! moment found
         endif
c
c   if no distance, set to 1.0
c
         if(sdistance.eq.0.0) sdistance=1.0
 7464    continue
c
c   read parameters
c

         write(text1,'(a3,f5.1,a17)')'f0=',f0,' enter new/return'
	   text = '                    '
         call oneline(text1,25,text,8,630.0,250.0)
         if(text(1:4).ne.'    ') then
            call sei get values (1,text,code)
            f0=array$(1)
         endif
         write(text1,'(a3,f5.3,a17)')'k =',kk,' enter new/return'
	   text = '                    '
         call oneline(text1,25,text,8,630.0,250.0)
         if(text(1:4).ne.'    ') then
            call sei get values (1,text,code)
            kk=array$(1)
         endif
         write(text1,'(a3,i5,a17)')'Q0=',int(qq),' enter new/return'
         text = '                    '
	   call oneline(text1,25,text,8,630.0,250.0)
         if(text(1:4).ne.'    ') then
            call sei get values (1,text,code)
            qq=array$(1)
         endif
         write(text1,'(a3,f5.3,a17)')'qa=',qa,' enter new/return'
         text = '                    '
	   call oneline(text1,25,text,10,630.0,250.0)
         if(text(1:4).ne.'    ') then
            call sei get values (1,text,code)
            qa=array$(1)
         endif



c
c   check q
c
         if(qq.eq.0.0) qq=99999.0   ! a large q is like no q
c
c  calculate f0 or stress drop dependent on what was entered
c
c
c   if cornor frequency not used, enter stress drop
c
         if(f0.eq.0.0) then
	      text = '                    '
            call oneline('Stress drop',11,text,20,630.0,250.0)
            ssdrop=sei real num(text,i)  ! i is error code
c
c   calculate f0 from stress drop
c
            if(average_moment.gt.0.0.and.svelocity.gt.0.0) then 
              f0=ssdrop*1e14*svelocity**3/(8.5*10**average_moment)
              f0=f0**0.333333
            else
              f0=1.0
            endif
         else
c
c  calculate stress drop from f0
c
            if(average_moment.gt.0.0.and.svelocity.gt.0.0) then
              ssdrop=(1e-14)*8.5*10**average_moment*f0**3/svelocity**3
            else
              ssdrop=-1.0
            endif
         endif
c
c   calculate theroretical spectrum
c
         j=0
         do i = 2,((ipow/2) + 1)
           ff = (i-1)*rate/ipow
           if((filt.ne.0.and.ff .ge. flow(filt) .
     *     and. ff .le. fhigh(filt)).
     *     or.(filt.eq.0.and.ff .ge. ffmin
     *     .and. ff .le. ffmax)) then
              j = j + 1
              y(j) = ((2*3.14*ff)**(disp_vel-1)/(1+ff*ff/(f0*f0)))*  ! source
     *               exp(-3.14*sdistance*ff/(spec_velocity*qq*(ff**qa))) ! Q
     *               *exp(-3.14*kk*ff)      ! surface correction
              y(j) = log10( y(j) )      ! take the logarithm
c              if(linx) then
c                x_work(j)=ff
c              else
                x_work(j) = log10(ff)     ! this after use of com, equivalent
c              endif
            endif
         enddo
c
c   normalize values, use middle frequency value for normalizing, 
c   first calculate constant due to remaining factors
c
         norm_factor=average_moment     ! moment, here it is logaritmic
         norm_factor=norm_factor+log10(1.2)   ! rad. pat, free surface
         norm_factor=norm_factor+log10(1.0/   ! the rest, 1000 to convert metr.
     *               (4*3.14*(density*1000)*((1000*spec_velocity)**3)))
c
c   geometrical spreading
c
         call spec_dist
     *   (spec_phase,edistance,edepth,geo_factor)
         norm_factor=norm_factor-log10(1000.0/geo_factor)
         geo_distance=1.0/geo_factor
c        if(sdistance.lt.100.0) then           ! distance correction
c           norm_factor=norm_factor-log10(sdistance*1000.0)
c        else
c           norm_factor=norm_factor-log10(1000.0*sqrt(100.0*sdistance))
c        endif

         norm_factor=norm_factor+9             ! convert to nanometers
c
c   add factor
c
         do i=1,nspec
            y(i)=y(i)+norm_factor
         enddo
c
c   factor to normalize plot
c
          norm_factor=0.0
          do i=3,j/4
             norm_factor=norm_factor+y(i)
          enddo
          norm_factor=norm_factor/(j/4-3+1)
         norm_factor=amp_average - norm_factor

c        norm_factor=amp_average - 
c    *   (y(nspec/2)+y(nspec/2-5)+y(nspec/2+10))/3.0
c
c   output
c
c
         message(1)= 'Spectral fitting parameters'
         write(message(2),'(a,f6.2)') 'Obs - calc level', norm_factor
         write(message(3),'(a,f6.2,a,i5)')      'Moment ',
     *   average_moment, ' Geo_dist ',int(geo_distance)
         write(message(4),'(a,f9.2,a,f5.1)') 
     *   'Stress drop', ssdrop,' f0 ',f0
         write(message(5),'(a,f5.3,a,i5,a,f5.2)')
     *   'k   ',kk,' q   ',int(qq),' qa ',qa 
         call xmessage(message,5,30,620.0,275.0)
         do i=1,nspec
           y(i)=y(i)+norm_factor
         enddo
         xlength=0.0     ! use same scale as before
c
c   check type of axis
c

        do j=1,nspec
           if(iaxes_type.eq.3.or.iaxes_type.eq.4)
     *     then
             x_work(j)=10.0**x_work(j)
           endif
           if(iaxes_type.eq.3.or.iaxes_type.eq.1) then
              y(j)=10.0**y(j)
           endif
        enddo
c
c   put in a file
c
        open(15,file='spectral_fit.out',status='unknown')
        write(6,*) 'sepctral fit f, amp'
        do i=1,nspec
          write(15,*) x_work(i),y(i)
        enddo
        close(15)


         call xy_plot
     *   (1,nnspec,x_work,y,text,xtext,ytext,xlength,270.0,
     *   x0,70.0,2,1,30.0
     *   ,xy_cursor,c_spec,nc,cx,cy)
         if(c_spec(nc).eq.'f'.or.c_spec(nc).eq.'F') choice='FINI'
         if(c_spec(nc).eq.'r'.or.c_spec(nc).eq.'R') choice='REPL'
         if(c_spec(nc).eq.'q'.or.c_spec(nc).eq.'Q') choice='QUIT'
         if(c_spec(nc).eq.'s'.or.c_spec(nc).eq.'S') choice='FIT '
c
c   try again
c
         if(choice.eq.'FIT ') goto 7464
 7465    continue
      endif

      return                                                                    
      end                                                                       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc            
      subroutine calcmoment
c
c     Subroutine to calculate log10(seismic moment)
c     and stressdrop.
c     Author: C. Lindholm, July, 1993
c
c     Returned parameters:
c       log10(seismic moment)
c       stress drop
c
c       output is newton-meter for moment and km for radius
c       input is nanometer-sec for spectral level and else in 
c       km/sec, g/cm*cm and km

      implicit none
      include 'mulplt.inc'      
      include 'seisan.inc'
      real pi
      real geo_factor  ! geometrical spreading factor
      real surface,radpat  !  surface effect and radiation pattern effect 
      real factor
c
      pi=3.14159265
      surface=2.0
      radpat=0.6
c      radius=0.35*svelocity/cornerf ! 
      radius=0.37*spec_velocity/cornerf ! changed nov 07 jh
c
      if(sdistance.eq.0) then
         moment=0.0
         sdrop=0.0
         mw=0.0
         return
      endif
c
c   geometrical spreading
c
      call spec_dist
     *(spec_phase,edistance,edepth,geo_factor)
      geo_distance=1.0/geo_factor
      factor= 4*pi*(density*1000.0)*((spec_velocity*1000.0)**3)
c     moment = factor*(sdistance*1000.0)*  ! old geo spreading
      moment = factor*(1000.0/geo_factor)*
     *(10.0**omega0)/(radpat*surface*1.0e9)
      sdrop = (0.44*moment)/(1.0e14*radius**3)
      moment = log10(moment)
      if(moment.gt.0.0) mw=moment*0.667-6.06

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine get_3_chan
c                
c  does 3 component analysis, azimut calculation and component
c  rotation
c                                                               
      include 'mulplt.inc'
      include 'seiplot.inc'                                                             
c                                                                               
c-- No. of channels in file                     
      integer nchan		
c-- number of samples
      integer nsamp
c-- counters,etc                                         
      integer i,j,k,nsamp1			
c-- general text string
      character*80 text
c-- Station and component info    
      character*5 station(max_trace),stat_c
      character*4 comp(max_trace),comp_c
c-- time of main header and channel header
      integer myear,mmonth,mday,mhour,mmin,cyear,
     *cmonth,cday,chour,cmin,doy
      real msec,csec
c-- index for channels this station
      integer chan_z,chan_e, chan_n
c-- 3 component parmeters, coherence and rms
       real COHER,RMSAMP
c-- azimuth for rotating the horizontal seismograms
      real backazi,caz,saz
c-- channel delay
      real delay
      double precision mtime,ctime
c-- stat time and window relative main header
      real start,window
      integer first1,last1   ! local counters
c-- save xscale
      real x_old_scale
c-- 1: error, 0: no error                                  
      integer error
      integer code    ! error code
c-- save rotate flag
      logical save_rotate
      integer first_org			
      integer hl,c_chan
      integer current_chan_3com  ! channel number on entry of routine
c
      backazi=10000    ! always ask for backazimuth, this parameter gives
c
c   save current channel from which call was made
c
      current_chan_3com=wav_current_chan(1)
c
c   get and check rotation paramters
c
      if(rotate) then
        if(backazi.gt.999) then    ! no azimuth given, enter manually
            text = '                    '
            call oneline(' Give back-azimuth ',19,text,10,500.0,35.0)
            backazi=sei real num(text,code)
        endif
      endif
c
c   save old xscale
c
      x_old_scale=xscale
      error=0
      j = 1                                                                     
c
c   read 3 channels
c
      current_chan_3com=wav_current_chan(1)    ! save active channel
      first_org=first
      rate=wav_rate(wav_current_chan(1))
c
      call wav_read_3channel(current_chan_3com)
c
c   check if both horizontal channels there
c                  
      if(wav_current_chan(2).eq.0.or.wav_current_chan(3).eq.0) then
         error=1                                                               
         write(text,'(a)')' Not both horizontal channels, replot'
         call xchars(text,37,100.0,350.0)
         goto 500
      endif
c
c   calculate start time for all 3 channels, check if data is there
c
cfix
      wav_out_nchan=3
      do i= 1,3
        k=wav_current_chan(i)
        wav_out_chan(i)=k  ! index of 3 channels
        wav_out_start(k)=wav_delay(current_chan_3com)+(first-1)/rate !same start
        wav_out_duration(k)=(last-first+1)/rate
      enddo
c
      call wav_get_interval          ! find where and if data available
c
c   write out if a problem
c
      if(wav_out_status(wav_current_chan(1)).ne.4.or.wav_out_status
     *(wav_current_chan(2)).ne.4.or.wav_out_status
     *(wav_current_chan(3)).ne.4) then
         error=1                         
         write(text,'(a)')' Data not available same interval, replot'
         call xchars(text,36,100.0,350.0)
         goto 500
      endif
c
c   select, filter, remove response, save in work array
c
      nsamp=wav_out_duration(wav_current_chan(1))*rate ! assume same for3 chan.
      do i=1,3
         numb_samp=wav_nsamp(wav_current_chan(i))
         call trans_filt(i)
         first1=wav_out_first_sample(wav_current_chan(i))
         last1=first1+nsamp-1   ! cfix
c
c   put window in beginning of array
c		 
         do k=first1,last1
            if(i.eq.1)
     *      wav_y1(k-first1+1)=wav_y1(k)
            if(i.eq.2)
     *      wav_y2(k-first1+1)=wav_y2(k)
            if(i.eq.3)
     *      wav_y3(k-first1+1)=wav_y3(k)
         enddo
      enddo
      numb_samp=nsamp
c                                                                               
c   calculate start second for lower plot, will be the same for all 3 channels 
c 
cfix                                                                           
         fsec=wav_sec(wav_current_chan(1))+(first-1)/rate                      
         fmin=wav_min(wav_current_chan(1))+(first-1)/(rate*60.0)
                       
c                                                                               
c  set plotting parameters etc
c
      ypos=270                                                                  
      height=90        
      pframe=3     ! plot only top and sides
      paxis=0      ! no axis tics
      paxisnumb=0  ! no axis numbers                                           
      pmax=0       ! plot no max below trace
      ppick=0      ! no picking mode
      page_time=time2-time1                                                     
c                                                                               
c    plot z channel                                                         
c                 
         first=1
         last=nsamp
         do i=1,nsamp
            y(i)=wav_y1(i)
         enddo                                                              
         call plotw	                                                        
         i=max+0.5                                                        
         write(text,'(i9)') i                                             
         call xchars(text,9,900.0,ypos+height-22)	
         text(1:1)='Z'
         call xchars(text,1,20.0,ypos+height-22)	
         if(rotate) then
            i=backazi+0.5
            write(text,'(a,i4)')'baz=',i
            call xchars(text,8,50.0,ypos+height-22)
         endif
c
c   plot picks
c
         page_start=0.0
         k=wav_current_chan(1)
c
c   pics are referenced in time to channel where zoom was made,
c   therefore use trace start time from current_chan_3com
c
         wav_rot_comp(k)=' '
c
c   save picks from original channel displayed on top
c
         call convert(wav_abs_time(current_chan_3com),
     *   wav_stat(current_chan_3com),wav_comp(current_chan_3com),1)
c
c   load picks from z-channel
c
         call convert(wav_abs_time(current_chan_3com),
     *   wav_stat(k),wav_comp(k),-1)
         first=first_org   ! original zoom start

         call tecpic       ! plot picks

         first=1           ! now data put into array starting with zoom start
         
c
c  set rotation parameters
c
      caz = -cos(backazi*3.14159/180.)
      saz = -sin(backazi*3.14159/180.)
c
c  plot nw channel
c
      pframe=2    ! plot side of frame only
      ypos=180
c
      do i=1,nsamp
        if(rotate) then
           y(i) = caz*wav_y2(i) + saz*wav_y3(i)  ! make radial component
        else
           y(i)=wav_y2(i)
        endif
      enddo
c
c   load picks from n-channel
c
         call convert(wav_abs_time(current_chan_3com),
     *   wav_stat(wav_current_chan(2)),
     *   wav_comp(wav_current_chan(2)),-1)
         first=first_org   ! original zoom start
         call tecpic
         first=1
c                                                                               
c   plot                                                              
c                                                                               
      call plotw	                                                        
      i=max+0.5                                                        
      write(text,'(i9)') i                                             
      call xchars(text,9,900.0,ypos+height-22)	
      text(1:1)='N'
      if(rotate) text(1:1)='R'
      call xchars(text,1,20.0,ypos+height-22)	
c
c  plot ew channel, transverse channel if rotate
c
      ypos=90                                                                  
      paxis=1      ! plot axis again
      paxisnumb=1                                    
c
c   put signal in plotting array
c
      do i=1,nsamp
        if(rotate) then
           y(i) = -saz*wav_y2(i) + caz*wav_y3(i)  ! transvers component
        else
           y(i)=wav_y3(i)
        endif
      enddo
c                                                                               
c   plot ew                                         
c                                                                               
c
c   load picks from ew-channel
c
      call convert(wav_abs_time(current_chan_3com),
     *wav_stat(wav_current_chan(3)),
     *wav_comp(wav_current_chan(3)),-1)
      first=first_org   ! original zoom start
      call tecpic
      first=1
      call plotw	                
      i=max+0.5                                                        
      write(text,'(i9)') i                                             
      call xchars(text,9,900.0,ypos+height-22)	
      text(1:1)='E'
      if(rotate) text(1:1)='T'
      call xchars(text,1,20.0,ypos+height-22)	
c
c   do 3 component analysis
c
      do i=1,nsamp
         wav_y3comp(i,1)=wav_y1(i)
         wav_y3comp(i,2)=wav_y2(i)
         wav_y3comp(i,3)=wav_y3(i)
      enddo
      call PRECOH1(wav_y3comp,max_sample,1,nsamp,three_comp_velocity,
     *COHER,AZIM,VELI,RMSAMP)
      i=azim+0.5
      write(text,333) i,veli,coher
 333  format('Az ',i4,1x,'Vel ',f7.1,1x,'Co ',f6.1)
      call xchars(text,31,1.0,3.0)
c
 500  continue

c
c   load in original channel, disable rotate
c
      rotate=.false.
      call wav_read_channel(current_chan_3com)
c
c   put in original picks unlsess an errror occured (jh, jan 04)
c
      if(error.ne.1) then
         call convert(wav_abs_time(current_chan_3com),
     *   wav_stat(current_chan_3com),wav_comp(current_chan_3com),0)
      endif

      first=1
      numb_samp=wav_nsamp(wav_current_chan(1))
c
c   rest plot parameters
c
      pframe=1                                                                  
      paxis=1                                                                   
      paxisnumb=1                                                               
      phelp=1                                                                   
      pmax=1                                                                    
      ppick=1                                                                   
      ptitle=1                                                                  
      filt=0
      ypos=450.0
      height=200.0
      xscale=x_old_scale
c     write(39,*) 'first,last',first,last
c     write(39,*)'p st,last_ix',page_start,last_ix
c     write(39,*)'pictim',(pictim(i),i=1,5)
c     write(39,*)'xscale,rate,xpos',xscale,rate,xpos
c
      return                                                                    
      end                                                                       




      subroutine plot_resp                                                 
c                                                                               
c     routine to plot response function                
c                                                                                
c-- common block     
c                                
      include 'mulplt.inc'	
      include 'seiplot.inc'		
c
c-- indicator for response removal or not (1 or 0).                        
      integer rem_resp			
      real ff ! frequency
c-- number of points in spectrum
      integer nspec
c-- if several data sets, number of points in each
      integer nnspec(2)
c-- counters and help variables                                               
      integer i,j				
c-- response value
      complex respons
      character*80 text
      character*80 message(10)
      character*30 xtext,ytext      ! axis text
c--returns from spectral plot
      character*1 c_spec(20)
      real x0                       ! left corner of spectrum
      real cx(20),cy(20)
      real ix,iy                    ! mouse position
      integer nc
      real x_work(max_sample)
c-- counter bounds for spectrum                    
      equivalence(x_work,com)                                                     
      
c
c   first check if response is available
c
      rem_resp=0
         wav_resp_file = ' '
         call read_resp
         if(wav_resp_status.eq.'9') then
            write(text(1:20),'(a)')'No response info ***'
            call tchars(text,20,600.0,225.0)
            write(text(1:24),'(a)')'Push any key to continue'
            call tchars(text,23,600.0,190.0)
c
c-- call up cursor                               
c
            call xscursr(i,ix,iy)			
            choice='REPL'
            return
         endif
         if(wav_resp_status(1:1).eq.'8') then
            write(text(1:33),'(a)')'Response from waweform header ***'
            call tchars(text,33,600.0,320.0)
         endif
c
c  the amplitude response
c
      j=0
      do i = -260,190,1    ! log frequencies
         j=j+1
         ff=10**(i/100.0)
         call calc_resp(ff,respons)
         y(j)=log10(cabs(respons))
         x_work(j) = log10(ff)          
 1243    continue
      enddo
      nspec=j
c
c   clear top part of screen and display new choises
c
      call xset_color(color_back)
      call fillbox(0.0,700.0,1024.0,780.0)
      message(1)='Valid input is now:  R: Replot          '
      message(2)='                     Q: Quit            '
      message(3)='                     F: Foreward or next'
      call xmessage(message,3,40,10.0,700.0)
      
c
c   plot spectrum
c
      xtext='      Log frequency (Hz)     '
      ytext='Log amplitude                '
      write(text,'(a)')'Amplitude Response, count/nm '
      text(30:80)=' '
      if(wav_resp_status.eq.' ') then
         write(text(34:42),'(i4,1x,2i2)') wav_resp_year,wav_resp_month,
     *                                 wav_resp_day
      endif
      if(wav_resp_status.eq.'8') then
         text(34:41)='W header'
      endif
      text(44:49)=wav_resp_type(1:6)
      nnspec(1)=nspec
      x0=100.0                
      call xy_plot
     *(1,nnspec,x_work,y,text,xtext,ytext,380.0,270.0,
     *x0,70.0,2,1,30.0
     *,0,c_spec,nc,cx,cy)
c
c  the phase response
c
      j=0
      do i = -260,190,1    ! log frequencies
         j=j+1
         ff=10**(i/100.0)
         call calc_resp(ff,respons)
         y(j)=180.0*atan2(imag(respons),real(respons))/3.141592654
         x_work(j) = log10(ff)          
      enddo
      nspec=j
c
c   unwrap phases
c
c      call unwrap_phase(y,nspec,y)
c
c   plot spectrum
c
      ytext='Phase                '
      write(text,'(a)')'Phase response '
      nnspec(1)=nspec
      x0=620.0                
      call xy_plot
     *(1,nnspec,x_work,y,text,xtext,ytext,380.0,270.0,
     *x0,70.0,2,1,30.0
     *,1,c_spec,nc,cx,cy)
      if(c_spec(nc).eq.'f'.or.c_spec(nc).eq.'F') choice='FINI'
      if(c_spec(nc).eq.'r'.or.c_spec(nc).eq.'R') choice='REPL'
      if(c_spec(nc).eq.'q'.or.c_spec(nc).eq.'Q') choice='QUIT'
      return
      end                                                                       





      subroutine plot_pm(start_time,stop_time)
c
c     routine to plot particle motion
c
c-- common block
c
      implicit none
      include 'mulplt.inc'
      include 'seiplot.inc'
c      include 'waveform.inc'
 
      integer i,c,ind,j
      character*80 text
      character*80 message(10)
      character*30 xtext,ytext      ! axis text
c--returns from spectral plot
      character*1 c_spec(20)
      real cx(20),cy(20)
      real ix,iy                    ! mouse position
      integer nc
      character*1 cha(20)
      integer cind(3)               ! channel index Z,N,E or Z,R,T
      real dx(max_sample),dy(max_sample),dz(max_sample)
      real dr(max_sample),dt(max_sample)
      integer np
      real xlength
      real x0,y0
      integer draw,xyc
      real start_time,stop_time,time
      real dc

c settings
      text=' '
      xlength=200
      y0=70
      xyc=0

      do i=1,3
        cind(i)=0
      enddo
      c=0  ! counter for selected channels
      do i=1,wav_nchan
        if (channelname(i).gt.0) then
          c=c+1
          ind=channelname(i)
          if (wav_comp(ind)(4:4).eq.'Z') cind(1)=ind
          if (wav_comp(ind)(4:4).eq.'N') cind(2)=ind
          if (wav_comp(ind)(4:4).eq.'E') cind(3)=ind
        endif
      enddo
c      write(*,*) ' nchan = ',c
c
c check
c
      if (c.ne.3) then
        write(*,*) ' Three channels required for particle motion plot ',
     &    wav_nchan
        return
      endif
      do i=2,c
c        write(*,*) wav_stat(cind(i)),wav_comp(cind(i))
        if (wav_stat(cind(1)).ne.wav_stat(cind(i))) then
          write(*,*) ' not all channels from same station '
        endif
      enddo
      do i=1,3
        if (cind(i).lt.1) then
          write(*,*) ' 3-comp data required '
        endif
      enddo

c
c read data
c
      call wav_read_3channel(cind(1))
c
c filter
c
      if (filt.ne.0) then
        do i=1,3
          call trans_filt(i)
c copy data from y to signal
          do j=1,wav_nsamp(cind(i))
            if (i.eq.1) signal1(j)=y(j)
            if (i.eq.2) signal2(j)=y(j)
            if (i.eq.3) signal3(j)=y(j)
          enddo
        enddo
      else
c remove dc if not filtered
        do i=1,3
          if (i.eq.1) call remove_dc
     &     (signal1,wav_nsamp(cind(i)),dc,wav_nsamp(cind(i)))
          if (i.eq.2) call remove_dc
     &     (signal2,wav_nsamp(cind(i)),dc,wav_nsamp(cind(i)))
          if (i.eq.3) call remove_dc
     &     (signal3,wav_nsamp(cind(i)),dc,wav_nsamp(cind(i)))
        enddo
      endif
        
      np=0
      do i=1,wav_nsamp(cind(1))
        time=wav_delay(cind(1))+i/wav_rate(cind(1))   ! relative to first channel in file
        if (time.ge.start_time.and.time.le.stop_time) then
          if (i.le.wav_nsamp(cind(2)).and.
     &        i.le.wav_nsamp(cind(3))) then
            np=np+1
            dz(np)=signal1(i)
            dy(np)=signal2(i)
            dx(np)=signal3(i)
          endif
        endif 
      enddo
c
c rotate
c
      if (rotate) then
        call rotate_comp(np,1,1,
     *     'R',baz(cind(1)),dr,dy,dx)
        call rotate_comp(np,1,1,
     *     'T',baz(cind(1)),dt,dy,dx)
      endif
c
c plot 
c
      if (rotate) then
      x0=125.
      draw=-2
      xtext=wav_comp(cind(1))(1:2)//wav_comp(cind(1))(4:4)
      ytext=wav_comp(cind(1))(1:2)//'R'
      call xy_plot(1,np,dz,dr,text,xtext,ytext,xlength,xlength,x0,y0,
     &    draw,1,0.,xyc,cha,nc,cx,cy)
      draw=1
      call xy_plot(1,2,dz,dr,text,xtext,ytext,0.,0.,x0,y0,
     &    draw,1,20.,xyc,cha,nc,cx,cy)
      x0=425.
      draw=-2
      xtext=wav_comp(cind(1))(1:2)//wav_comp(cind(1))(4:4)
      ytext=wav_comp(cind(1))(1:2)//'T'
      call xy_plot(1,np,dz,dt,text,xtext,ytext,xlength,xlength,x0,y0,
     &    draw,1,0.,xyc,cha,nc,cx,cy)
      draw=1
      call xy_plot(1,2,dz,dt,text,xtext,ytext,0.,0.,x0,y0,
     &    draw,1,20.,xyc,cha,nc,cx,cy)
      x0=725.
      draw=-2
      xtext=wav_comp(cind(1))(1:2)//'R'
      ytext=wav_comp(cind(1))(1:2)//'T'
      call xy_plot(1,np,dr,dt,text,xtext,ytext,xlength,xlength,x0,y0,
     &    draw,1,0.,xyc,cha,nc,cx,cy)
      draw=1
      call xy_plot(1,2,dr,dt,text,xtext,ytext,0.,0.,x0,y0,
     &    draw,1,20.,xyc,cha,nc,cx,cy)

      else

      x0=125.
      draw=-2
      xtext=wav_comp(cind(1))(1:2)//wav_comp(cind(1))(4:4)
      ytext=wav_comp(cind(2))(1:2)//wav_comp(cind(2))(4:4)
      call xy_plot(1,np,dz,dy,text,xtext,ytext,xlength,xlength,x0,y0,
     &    draw,1,0.,xyc,cha,nc,cx,cy)
      draw=1
      call xy_plot(1,2,dz,dy,text,xtext,ytext,0.,0.,x0,y0,
     &    draw,1,20.,xyc,cha,nc,cx,cy)
      x0=425.
      draw=-2
      xtext=wav_comp(cind(1))(1:2)//wav_comp(cind(1))(4:4)
      ytext=wav_comp(cind(3))(1:2)//wav_comp(cind(3))(4:4)
      call xy_plot(1,np,dz,dx,text,xtext,ytext,xlength,xlength,x0,y0,
     &    draw,1,0.,xyc,cha,nc,cx,cy)
      draw=1
      call xy_plot(1,2,dz,dx,text,xtext,ytext,0.,0.,x0,y0,
     &    draw,1,20.,xyc,cha,nc,cx,cy)
      x0=725.
      draw=-2
      xtext=wav_comp(cind(3))(1:2)//wav_comp(cind(3))(4:4)
      ytext=wav_comp(cind(2))(1:2)//wav_comp(cind(2))(4:4)
      call xy_plot(1,np,dx,dy,text,xtext,ytext,xlength,xlength,x0,y0,
     &    draw,1,0.,xyc,cha,nc,cx,cy)
      draw=1
      call xy_plot(1,2,dx,dy,text,xtext,ytext,0.,0.,x0,y0,
     &    draw,1,20.,xyc,cha,nc,cx,cy)
      endif
 
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c   program to  merge single  event files to one file from
c   standard data base or a base an d a file. Two events are merged together
c   if they are less than maxdif seconds apart 
c
c   jens havskov, jan 88
C   uppdates:
c   mar 8 by j.h   : also merge distant events
c   jan 19   j.h.  : adaption new data base, file name length
c
c   aug 6    c.l.  : new merge routine implemented
c   feb 17, 92 r.a.: fixed for SUN
c   feb 18,    r.a.: fixed for time difference at new month
c   jul 93    version 3.0
c   aug 23         : filenames to 80
c   nov 24, 1994   : opening files changed
c   dec 94         : ********* version 5.0 ********************
c   jan 11         : new find ev in
c   feb 7 99 jh    : ---------Version 7.0 ---------------------
c                    fix year, start and end times
c   sep 23   jh    : put in confirm overrride, error if dir name had a '-'
c                    put in time routines
c   nov 6,00       : bug: seconds were not used
c   feb 2001       : merge from data base and a file
c   mar 23 2004 jh : also write out events used for merging if from a file

        implicit none	
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! File operations.
       include 'seidim.inc'                ! Dimentions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
       character*80	data1(max_data),data2(max_data)	
c event data
       character*1	exp		
c exp indicator
       character*1      type1,type2,type
c event type
       character*1      answer		
c answer
       integer		nrecord		
c number of recors for event
       integer		nhead		 
c  number of header lines
       integer		nrecord2	
       character*1      confirm     ! y: confirm delete, n, do not confirm
c  number of recors for event
       integer		nhead2		
c   number of header lines
       integer		nstat, nphas
c number of stations
       character*14     start_time,end_time 
c start and end time of select
       character*40	base_name	
c data base name if not rea (blank)
       character*80	evfile1,evfile2, text	
c event file name
       character*10     key		
c select key
       integer		status,new_month,fstart,event_no 
c see subroutine find...
       integer nass,ndel,nmer 		
c counters for events, records etc.
       integer		maxdif		
c maximum difference in secs b. ev.
       integer		year1,month1,day1,hr1,min1,sec1
       integer		year2,month2,day2,hr2,min2,sec2
       real sec11,sec22
       double precision t1,t2,diff
c time in day-hr-min-sec
       integer		choice		
c choice for merging, see below
       integer		first		
c indicate first time read 1: first
       integer 		i,id		
c print unit
       integer          printu
c logical for existing file or not
       logical          b_old
c returned code                                   
       integer          code
c read unit #1 
       integer          readu1
c read unit #2
       integer          readu2
       integer          npos       ! position of flag
       logical          afile      ! true if file comparison used
       character*80     infile     ! file name
       logical          merged     ! true if event used for merge
c function
       real seirealnum


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   open output file
c
      call sei open(unknown$,              ! Open a unknown status file. 
     &              ' ',                   ! Prompt file name (n/a).
     &              'associ.out',       ! File name
     &              printu,                ! Print unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.
c
c   input base name and time interval
c
       write(6,*)' Base name, return for default'
       read(5,'(a40)') base_name
       write(6,*)' Start time'
       read(5,'(a14)') start_time
       write(6,*)' End time, return for end of month'
       read(5,'(a14)') end_time
c
 3     continue
c
c Give time difference between events to be associated
c
13     write(*,*) 
     * ' Give maximum time difference between two events to associcate'
       write(6,*) ' default is 150 s (return):'
       read(5,'(a)') text
       maxdif= sei real num (text,code)
       if (maxdif .eq. 0 ) maxdif=150		 
c
c  associate from a file or from same base
c
c
       write(6,*)' Associate from a file        :  Enter file name'
       write(6,*)' Associate from same data base:  Enter          '
       read(5,'(a)') infile
       afile=.false.
       if(infile.ne.' ') afile=.true. ! associate from infile'
c
c   open file if associate from file
c
       if(afile) then
 344      continue
          open(3,file=infile,status='old',err=345)
          goto 346
 345      continue
          write(6,*)' Error opening file, enter file name'
          read(5,'(a)') infile
          goto 344
 346      continue
        endif

       if(.not.afile) then
       write(6,*)
     *' check events which can be associated                    (1)'
       write(6,*)
     *' associate and merge events, do NOT delete merged events (2)'      
       write(6,*)
     *' associate and merge events, delete merged events        (3)'
       read(5,*) choice
       if(choice.ne.1.and.choice.ne.2.and.choice.ne.3) then
c
c check choice
c
          write(6,*) 'wrong choice, try again'
          goto 3
       endif
       endif
       if(afile) then
 33    continue
       write(6,*)
     *' check events which can be associated                    (1)'
       write(6,*)
     *' associate and merge events                              (2)'
       read(5,*) choice
       if(choice.ne.1.and.choice.ne.2) then
c
c check choice
c
          write(6,*) 'Wrong choice, try again'
          goto 33
       endif
       endif
c
c always use next event
c
       confirm='n'
       if(choice.gt.1) then
          write(6,*)' Confirm merge (y/n)'
          read(5,'(a)') confirm
       endif

       key='          '
c
c  reset counters
c
       nass=0
       nmer=0
       ndel=0
       first=1
c
c
c----------------------------------------------------------------
c   merge from same base
c----------------------------------------------------------------
c
       if(.not.afile) then


 4     continue
c
c   read first event or first event after a merge
c
       CALL findevin
     * (base_name,start_time,end_time,key,0,
     * event_no,evfile1,fstart,new_month,status)
       if(first.eq.1) then		
c  check if first time around
          new_month=0			
c lower new month flag
          first=0                       
c  lower first flag
       endif

c  return if eof or other erorrs

       if(status.ne.0) go to 99
c
c indicate that no comparisom possible
c
       t1=-1				

       write(6,208) event_no,evfile1(1:50),int(t1)
       goto 6
c
c  read and write loop until pair found
c
 5     continue
c
c   shift to next event, save previous
c
       evfile1=evfile2
       key='          '		
c always use next event
 6     continue			
c start here the first time
       CALL findevin	
c get name of next event
     * (base_name,start_time,end_time,key,0,
     * event_no,evfile2,fstart,new_month,status)

c return if eof or other erorrs

       if(status.ne.0) goto 99
c
c   compare times
c
       call time_evname(evfile1,year1,month1,day1,hr1,min1,sec1,type1)
       call time_evname(evfile2,year2,month2,day2,hr2,min2,sec2,type2)
       sec11=sec1
       sec22=sec2
       call TIMSEC (YEAR1,month1,DAY1,HR1,MIN1,SEC11,t1)
       call TIMSEC (YEAR2,month2,DAY2,HR2,MIN2,SEC22,t2)
       write(6,208) event_no,evfile2(1:55),int(t2-t1)
 208   format(1x,'#',i4,1x,a55,' Diff=',i8,' s')
c
c   check types before comparing times
c
C       if(type1.eq.'D'.or.type2.eq.'D') go to 5	
c do not merge distant events
       if(dabs(t2-t1).lt.maxdif) then
c
c   count events associated 
c
          nass=nass+1
          if(choice.eq.1) then	
c only show which events are associated
             write(printu,217,iostat=code)
     *       evfile2(fstart:fstart+18),evfile1(fstart:fstart+18)
             call sei code(stop$,          ! Force stop on error.
     &                     code,           ! Fortran i/o condition.
     &                     printu,         ! Unit with condition.
     &                     b_old)          ! Flag (n/a).
C
             write(6,217)
     *       evfile2(fstart:fstart+18),evfile1(fstart:fstart+18)
 217         format(1x,'   ***** ',a,' is associated with ',a,' *****')
          else
c
c merge associated events
c
c  question merge
c
            write(6,207) event_no,
     *      evfile2(fstart:fstart+10),evfile1(fstart:fstart+10)
 207        format(1x,'    **** merge #',i3,2x,a,' with ',a,' y/n ****')
            if(confirm.eq.'N'.or.confirm.eq.'n') then
               answer='y'
            else
               read(5,'(a1)') answer
            endif
            if(answer.eq.'y'.or.answer.eq.'Y') then
               call sei open(old$,                  ! Open a existing file.
     &                       ' ',                   ! Prompt file name (n/a).
     &                       evfile1,               ! File name
     &                       readu1,                ! Read unit #1
     &                       b_old,                 ! Already exists? (n/a).
     &                       code)                  ! Returned condition.
               call sei open(old$,                  ! Open a existing file.
     &                       ' ',                   ! Prompt file name (n/a).
     &                       evfile2,               ! File name
     &                       readu2,                ! Read unit #2
     &                       b_old,                 ! Already exists? (n/a).
     &                       code)                  ! Returned condition.
c
c   read two input files
c
               call indata
     *         (readu1,nstat,nphas,nhead,nrecord,type,exp,data1,id)
               call indata
     *         (readu2,nstat,nphas,nhead2,nrecord2,type,exp,data2,id)

              
c
c   merge events
c
               call merge_f(data1,data2,nhead,nhead2,nrecord,nrecord2)

               rewind( readu1, iostat=code )
               call sei code(stop$,             ! Stop program on error.
     &                       code,              ! Fortran i/o condition.
     &                       readu1,            ! Unit with condition.
     &                       b_old)             ! Flag (n/a).
C
               write(readu1,'(a80)',iostat=code)
     &                         (data1(i),i=1,nrecord)   
               call sei code(stop$,             ! Stop program on error.
     &                       code,              ! Fortran i/o condition.
     &                       readu1,            ! Unit with condition.
     &                       b_old)             ! Flag (n/a).
C
c write event
c
c   close and delete file 2 if choice is 3
c
               nmer=nmer+1		
c count merged events
               if(choice.eq.3) then
                  call sei close (delete$+warn$,readu2,code)
                  if (code .eq. e_ok$) write(6,*)
     *                '    **** event',event_no,' deleted ****'
                  ndel=ndel+1		
c count deleted events
               else
                  call sei close (close$,readu2,code)
               endif
               call sei close (close$,readu1,code)
               go to 4	  
c go and read one extra event before continuing
            endif
         endif
       endif
      
       goto 5 ! next event

      endif

c
c-----------------------------------------------------------------
c  merge from file and base
c----------------------------------------------------------------
c-
c
      if(afile) then

        open(4,file='associ_rest.out',status='unknown')
        open(8,file='associ_merg.out',status='unknown')
c
c   initialize by read one event from each source
c                                                
c
c   read event of data base
c
       CALL findevin
     * (base_name,start_time,end_time,key,0,
     * event_no,evfile1,fstart,new_month,status)
       if(first.eq.1) then		
c  check if first time around
          new_month=0			
c lower new month flag
          first=0                       
c  lower first flag
       endif
c
c  return if eof or other erorrs
c
       if(status.ne.0) go to 99
c
c   read first event from file
c
       merged=.false.                ! flag to indicate event not tmerged
       call indata
     * (3,nstat,nphas,nhead2,nrecord2,type,exp,data2,id)
       if(nrecord2.eq.0) goto 99     ! end of file
c
c   compare times
c
       call time_evname(evfile1,year1,month1,day1,hr1,min1,sec1,type1)
       read(data2(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)')
     * year2,month2,day2,hr2,min2,sec22
       sec11=sec1
       call TIMSEC (YEAR1,month1,DAY1,HR1,MIN1,SEC11,t1)
       call TIMSEC (YEAR2,month2,DAY2,HR2,MIN2,SEC22,t2)
       diff=t2-t1
       write(printu,'(a,2x,f12.1)') evfile1(fstart:fstart+19), diff
c
c   merge if difference small enough
c
       if(dabs(diff).le.maxdif) then
         merged=.true.                    ! event merged, do not write out
         npos=2222
         goto 5555   ! merge point
       endif
 2222  continue

c
c  loop for reading in base and file
c

  250  continue
c
c   advance in file until file time has passed data base time
c   check if any events to be merged
c
       do while(t2.le.t1)
c
c   if previous event was not used for merge, write out event in
c   file for not merged events, else write in file for events
c   which were used for merging. note, the actual merged events are written 
c   out in a different file
c
          if(.not.merged) then
              write(4,'(a)') (data2(i),i=1,nrecord2)
              ndel=ndel+1
          else
              write(8,'(a)') (data2(i),i=1,nrecord2)
          endif
c
          call indata
     *    (3,nstat,nphas,nhead2,nrecord2,type,exp,data2,id)
          if(nrecord2.eq.0) goto 99
          merged=.false.                              ! reset merge flag
c          write(6,*)'advance indata'
          read(data2(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)')
     *    year2,month2,day2,hr2,min2,sec22
          call TIMSEC (YEAR2,month2,DAY2,HR2,MIN2,SEC22,t2)
          diff=t2-t1
          write(printu,'(a,2x,f12.1)') evfile1(fstart:fstart+19), diff
          if(dabs(diff).lt.maxdif) then
             merged=.true.       ! event used for merge
c             ndata=ndata+1
             npos=3333
             goto 5555
          endif
 3333     continue
c           if(ndata.gt.0) call data_back(3,ndata)
c           ndata=0
        enddo             
c
c   advance data base one event
c
       CALL findevin
     * (base_name,start_time,end_time,key,0,
     * event_no,evfile1,fstart,new_month,status)
c
c  return if eof or other erorrs
c
       if(status.ne.0) go to 99
       call time_evname(evfile1,year1,month1,day1,hr1,min1,sec1,type1)
       sec11=sec1
       call TIMSEC(YEAR1,month1,DAY1,HR1,MIN1,SEC11,t1)
       diff=t2-t1
       write(printu,'(a,2x,f12.1)') evfile1(fstart:fstart+19), diff
       if(dabs(diff).lt.maxdif) then
          merged=.true.                   ! INDECATE EVENT MERGED
          npos=4444
          goto 5555
       endif
 4444  continue
c
c   back up to check file
c
       goto 250




 5555  continue

c
c   count events associated 
c
          nass=nass+1

          if(choice.eq.1) then
c
c only show which events are associated
c
             write(6,217)
     *       evfile1(fstart:fstart+18),data2(1)(1:20)
             write(printu,217)
     *       evfile1(fstart:fstart+18),data2(1)(1:20)

          else
c
c merge associated events
c

c
c  question merge
c
            write(6,207) event_no,
     *      evfile1(fstart:fstart+10),data2(1)(1:20)
c
            write(printu,207) event_no,
     *      evfile1(fstart:fstart+10),data2(1)(1:20)

            if(confirm.eq.'N'.or.confirm.eq.'n') then
               answer='y'
            else
               read(5,'(a1)') answer
            endif
            if(answer.eq.'y'.or.answer.eq.'Y') then
               call sei open(old$,                  ! Open a existing file.
     &                       ' ',                   ! Prompt file name (n/a).
     &                       evfile1,               ! File name
     &                       readu1,                ! Read unit #1
     &                       b_old,                 ! Already exists? (n/a).
     &                       code)                  ! Returned condition.
c
c   read data base file
c
               call indata
     *         (readu1,nstat,nphas,nhead,nrecord,type,exp,data1,id)
           
c
c   merge events
c
               call merge_f(data1,data2,nhead,nhead2,nrecord,nrecord2)

               rewind( readu1, iostat=code )
               call sei code(stop$,             ! Stop program on error.
     &                       code,              ! Fortran i/o condition.
     &                       readu1,            ! Unit with condition.
     &                       b_old)             ! Flag (n/a).
C
               write(readu1,'(a80)',iostat=code)
     &                         (data1(i),i=1,nrecord)   
               call sei code(stop$,             ! Stop program on error.
     &                       code,              ! Fortran i/o condition.
     &                       readu1,            ! Unit with condition.
     &                       b_old)             ! Flag (n/a).
               
               call sei close (close$,readu1,code)
             endif
c
c   count merged events
c
             nmer=nmer+1
          endif
c
c  back to where merge was initiated from
c
         if(npos.eq.2222) goto 2222
         if(npos.eq.3333) goto 3333
         if(npos.eq.4444) goto 4444

       endif
c-------------------------------------------------------------------



 99    continue
       if(afile) then
c
c   if merge from file, write out rest of events from file not used
c
          if(.not.merged) then
             write(4,'(a)') (data2(i),i=1,nrecord2)
             ndel=ndel+1
          endif
 90       continue
          call indata
     *    (3,nstat,nphas,nhead2,nrecord2,type,exp,data2,id)
          if(nrecord2.eq.0) goto 199     ! end of file
          write(4,'(a)')(data2(i),i=1,nrecord2)
          ndel=ndel+1
          goto 90
 199      continue
       endif
 
c
c  print out statistics
c

      write(6,*)
      write(6,*)
      if(.not.afile) write(6,201) nass,nmer,ndel
      if(afile) then
        write(6,*) ' Number of associated events from file',nass
        write(6,*) ' Number of merged events              ',nmer
        write(6,*) ' Number of remaining events in file   ',ndel
        write(6,*)
      endif
        

      write(printu,*,iostat=code)
      call sei code( stop$, code, printu, b_old)
C
      write(printu,*,iostat=code)
      call sei code( stop$, code, printu, b_old)
C
      write(printu,201,iostat=code) nass, nmer, ndel
      call sei code( stop$, code, printu, b_old)
C

 201  format(' Total number of associated events',i7,
     *     /,' Total number of merged events    ',i7
     *     /,' Total number of deleted events   ',i7)
c
      write(6,*)' Output of statistics id associ.out'
      if(afile) then
        write(6,*)
     *' Events in file not used for merge: associ_rest.out'
        write(6,*)
     *' Events in file used for merge: associ_merg.out'
      endif
      stop
      end
     

      subroutine time_evname(evname,year,month,day,hr,min,sec,type)
c
c  finds date and event type from seisan data base evname.
c  Possible disk or directory names are of no importance.
c
      implicit none
      integer year,month,day,hr,min,sec
      character*80 evname	
c event file name inc possibly disk name
      character*1  type		
c event type
      integer i
      call get_fstart(evname,i)
      i=i+2
c     i = index(evname,'-')                
c find first '-' in name
      read(evname(i-2:i-1),'(i2)') day
      read(evname(i+1:i+2),'(i2)') hr
      read(evname(i+3:i+4),'(i2)') min
      read(evname(i+6:i+7),'(i2)') sec
      read(evname(i+8:i+8),'(a1)') type
      read(evname(i+11:i+14),'(i4)') year
      read(evname(i+15:i+16),'(i2)') month
         
c
      return
      end
c -----------------------------------------------------


      subroutine data_back(unit,ndata)
c
c   backspace one or several events, not tested
c
      implicit none

      integer ndata,unit,k
      character*80 text
      k=0

  10  continue
      backspace(unit)
      backspace(unit)
      read(unit,'(a)') text
      if(text.eq.' ') k=k+1
      if(k.eq.ndata) return
      goto 10

      return
      end
         

c  Program name: wgssei
c
c  convert wgsn files to seisan format, PC, Sun and Linux
c
c  this is a fist version, only tested with a few files
c
c  j. havskov, aug 2001
c
c
c   program do not seem to work on sun !!!!!!
c
c  updates:
c 
c  apr 04   jh: fix on component read, a mess, seems it can be anywhere


      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
      integer*4  data(max_sample)     ! output samples
      character*80 text               ! general text
c
c   block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	
ccccccccccccccccccccccccccccccccccccc  end

c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
          integer i,k,l,np,nz
c-- computer type
      logical pc,sun,linux	  
c


c
c print version
c
      include 'version.inc'
      out_version_date='ASugust 28, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       call read_def_chan('wgssei.def',mainhead_text,net_code)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files, here use text header files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old')
	   
c
c   read all header lines
c
       nchan=1
 1     continue
c
c   read first line                                 
c
       read(1,'(a)') text
c
c   station  and component
c
       read(1,'(a)') text
       stat(1)=text(1:5)
       comp(1)=' '
       comp(1)(1:1)=text(15:15)
       comp(1)(4:4)=text(16:16)
       if(text(17:17).ne.' ') then
          comp(1)(2:2)=text(16:16)
          comp(1)(4:4)=text(17:17)
       endif
c
c   try another one for comp
c
       if(comp(1)(1:1).eq.' ') then
          comp(1)(1:1)=text(10:10)
          comp(1)(4:4)=text(12:12)
       endif
c
c   put in definition from def file
c
       call set_def_chan(1,stat(1),comp(1))

c
c   time, sec has to be fixed, for now assume integer
c
       read(1,'(i4,5i2)') year(1),month(1),day(1),hour(1),min(1),i
       sec(1)=i
c
c   number of samples
c
       read(1,*) nsamp(1)
c
c   sample rate in ms
c
       read(1,*) rate(1)
       rate(1)=1000.0/rate(1)
c
c   response info, maybe, not used
c
       do i=1,5
          read(1,'(a)') text
       enddo
c
c   number of zeros and poles, not used
c
       read(1,*) nz,np
c
c   zeros and poles, not used
c
       do i=1,nz+np
           read(1,*) text
       enddo
c
c   station coord, not used
c
       read(1,'(a)') text
c
c  end of reading header file
c
       write(6,*)' year, month, day, hour, nsamp, rate',
     * year(1),day(1),hour(1),nsamp(1),rate(1)
c
c   make seisan headers
c
      ichan=1
      cbyte(1)='4'
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   add component code to output file
c
      outfile(1:32)=outfile(1:29)//'_'//comp(1)(1:1)//comp(1)(4:4)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
      mainhead(1)(2:29)=mainhead_text    ! put in header text
c
      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo

C
C   enter channel  loop
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,
     *                    stat,comp,nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
c                                                                               
c   get response            
c                                                                               
         call read_resp_head(chahead)                                            
c
c   read data samples for one channel
c
         read(1,*)(data(i),i=1,nsamp(ichan))
c
c   write data
c
         write(2)chahead
         write(2) (data(i),i=1,nsamp(ichan))
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  

c
c   converts usgs CD rom hypocenters to  nordic format
c   most of the informaiton is used. if more than 3 magnitudes available,
c   only the 3 first are used. number of stations are included when available.
c   depth is indicated as fixed in all cases where operator has been used (A,
c   N, G). macroseismic info is included with max intensity. the residuals 
c   standard deviation is put into rms column. event types are set to R.
c   magnitude types: UK is made blank
c                    b is replaced by B
c                    s is replaced by S
c                    D is replaced by C
c                    w is replaced by W
c   
c
c   jh dec 1995
c
      implicit none
      character*120 text           ! one input line
      character*80  data           ! one output line
      character*80  dataf          ! --------------, felt event 
      integer nmag                 ! number of magnitudes, one event
      character*80 infile
      integer nevent               ! event counter
      integer i
      real x


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c
      nevent=0
c
      write(6,*)' Input file name'
      read(5,'(a)') infile
      open(1,file=infile,status='old')
      open(2,file='usgsnor.out',status='unknown')
c
c  hypocenter read and write loop
c
  1   continue
      read(1,'(a)',end=99) text
      data=' '
      data(2:5)=text(7:10)    ! year
      data(7:10)=text(12:15) ! month day
      data(12:15)=text(16:19)! hour min
c
c  give all type regional
c
      data(22:22)='R'
      if(text(20:24).ne.'     ') then
         read(text(20:24),'(f5.2)') x
         write(data(17:20),'(f4.1)') x   ! seconds
      endif
      data(24:30)=text(27:33)            ! latitude
      data(31:38)=text(34:41)            ! longitude
      if(text(42:44).ne.'   ') then
         read(text(42:44),'(i3)') i
         write(data(39:43),'(f5.1)') float(i) ! depth
      endif
      read(text(90:92),'(i3)',err=222) i  ! if it can be read, a number
      data(49:51)=text(90:92)   ! number of stations
 222  continue                  ! if jump to here, no number for stations
      if(text(50:53).ne.'    ') then ! standard deviation, put in rms column
         read(text(50:53),'(f4.2)') x
         write(data(52:55),'(f4.1)') x
      endif
      data(46:48)=text(1:3)   ! hypocenter agency
      if(text(47:47).eq.'G'.or.text(47:47).eq.'A'.or.
     *   text(47:47).eq.'N') data(44:44)='F'
      nmag=0
      if(text(54:56).ne.'   ') then           ! mb magnitude
         data(60:60)='B'
         data(61:63)=text(1:3)                ! agency
         data(57:59)=text(54:56)
         nmag=nmag+1
      endif
      if(text(59:61).ne.'   ') then           ! ms magnitude
         nmag=nmag+1
         if(nmag.eq.1) then
            data(60:60)='S'
            data(61:63)=text(1:3)                ! agency
            data(57:59)=text(59:61)
         endif
         if(nmag.eq.2) then
            data(68:68)='S'
            data(69:71)=text(1:3)                ! agency
            data(65:67)=text(59:61)
         endif
      endif
      if(text(65:68).ne.'    ') then           ! other magnitude
         read(text(65:68),'(f4.2)') x
         nmag=nmag+1
         if(nmag.eq.1) then
            data(60:60)=text(70:70)
            data(61:63)=text(71:73)                ! agency
            write(data(57:59),'(f3.1)') x
         endif
         if(nmag.eq.2) then
            data(68:68)=text(70:70)
            data(69:71)=text(71:73)                ! agency
            write(data(65:67),'(f3.1)') x
         endif
         if(nmag.eq.3) then
            data(76:76)=text(70:70)
            data(77:79)=text(71:73)                ! agency
            write(data(73:75),'(f3.1)') x
         endif
      endif
      if(text(76:79).ne.'    ') then           ! other magnitude
         read(text(76:79),'(f4.2)') x
         nmag=nmag+1
         if(nmag.eq.1) then
            data(60:60)=text(81:81)
            data(61:63)=text(82:84)                ! agency
            write(data(57:59),'(f3.1)') x
         endif
         if(nmag.eq.2) then
            data(68:68)=text(81:81)
            data(69:71)=text(82:84)                ! agency
            write(data(65:67),'(f3.1)') x
         endif
         if(nmag.eq.3) then
            data(76:76)=text(81:81)
            data(77:79)=text(82:84)                ! agency
            write(data(73:75),'(f3.1)') x
         endif
      endif
c
c   check magnitude types
c
      if(data(60:60).eq.'K') data(60:60)=' ' ! make unknow mag type blank
      if(data(60:60).eq.'D') data(60:60)='C' ! make dur mag type  C
      if(data(60:60).eq.'b') data(60:60)='B' ! make 
      if(data(60:60).eq.'s') data(60:60)='S' ! make 
      if(data(60:60).eq.'w') data(60:60)='W' ! make 
      if(data(68:68).eq.'K') data(68:68)=' ' ! make unknow mag type blank
      if(data(68:68).eq.'D') data(68:68)='C' ! make dur mag type  C
      if(data(68:68).eq.'b') data(68:68)='B' ! make 
      if(data(68:68).eq.'s') data(68:68)='S' ! make 
      if(data(68:68).eq.'w') data(68:68)='W' ! make 
      if(data(76:76).eq.'K') data(76:76)=' ' ! make unknow mag type blank
      if(data(76:76).eq.'D') data(76:76)='C' ! make dur mag type  C
      if(data(76:76).eq.'b') data(76:76)='B' ! make 
      if(data(76:76).eq.'s') data(76:76)='S' ! make 
      if(data(76:76).eq.'w') data(76:76)='W' ! make 
      data(80:80)='1'

c
c   write out
c
      write(2,'(a)') data
c
c  check if felt info
c
      if(text(94:94).ne.' '.and.text(94:94).ne.'.') then
        dataf=' '
        dataf(80:80)='2'
        dataf(25:25)=text(94:94) 
        dataf(29:29)=text(93:93)
        if(dataf(29:29).eq.'.') dataf(29:29)=' '
        write(2,'(a)') dataf
      endif
      write(2,*)'                                            '
      nevent=nevent+1
      goto 1
c
 99   continue
      write(6,*)' Number of events converted:', nevent
      write(6,*)' Output file name is usgsnor.out'
      stop
      end

c$debug
      PROGRAM INVRAD
c   march 31 99 by jh   ----verson 7.0 check--------- no changes
C
C  Program to invert amplitudes of different phases for an
C    earthquake source, using the Langston, BSSA, 1981, p. 1 moment
C    tensor formulation.  Written by John E. Ebel, Summer, 1987
C    at the Geophysical Institute, University of Karlsruhe, W. Germany.
C    Paper on method being published in GEOPHYSICAL JOURNAL.
C    Please report all errors, improvements, etc. to John E. Ebel at Weston
C    Observatory of Boston College (EBEL@BCVMS.BITNET).
C
C  A bug in the SH radiation pattern part of the program was fixed 8/5/92
C
      DIMENSION VTOPP(50), VBOTP(50), GRP(50), TH(50), DEPTOP(50)
      DIMENSION VTOPS(50), VBOTS(50), GRS(50)
      DIMENSION R(50),AZ(50),AMP(50),D(50),P(50),HDC(3),DM0(50)
      DIMENSION HGREEN(6)
      CHARACTER*4 SN(50),PS(50)*2,COMP(50)*1,HEAD*40
      DIMENSION LEGDUPP(50), LEGDUPS(50)
      CHARACTER*40 FNAME, TYPE*10, ANS*1
      REAL MTENS(3,3),M0,N
      DIMENSION G(50,5),RESM(5,5),RESD(50,50),DM(6),VARM(5)
      DIMENSION S(3),N(3),B(3),AMPCOR(50),SDRMOM(6)



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver


      NMAX=50  !  Maximum number of stations allowed at present
      RHO=2.7  !  Assumed density in g/cm**3 in source region
      FPIRHO=4.*3.14159265*RHO
      TAREA=.01    ! Assumed area of time function in sec

C
C  Open output file
C
      OPEN(7,FILE='invrad.out')
C
C***Get input from the screen
C
1000  continue
cjh      WRITE(6,*)' Give file name for CRUSTAL MODEL (blank for STANDARD M
cjh     *ODEL):'
cjh      READ(5,1) FNAME
      fname='invrad.mod'   ! cjh
1     FORMAT(A)
      IF(FNAME(1:1).EQ.' ') FNAME='MODEL1.DAT'
C
cjh      WRITE(6,*)' Give SOURCE DEPTH in km:'
cjh      READ(5,*) SRCEDEP
c
c   simple fix to get depth from fixed input file
c
      open(1,file='invrad.inp',status='old')
      read(1,'(a1)') i        ! comment line
      read(1,'(i5,2f5.1)') i,srcedep,datsd
      close(1)
      
C
      if(srcedep.eq.0.0) then
         write(6,*)' Source depth cannot be zero'
         WRITE(6,*)' Give SOURCE DEPTH in km:'
         READ(5,*) SRCEDEP
      endif
c
      WRITE(7,144) SRCEDEP
144   FORMAT(' Source depth: ',F5.2,' km')
C
      if(datsd.eq.0.0) then
        write(6,*)' Readings must have errors'
        WRITE(6,*)' Give ERROR in data readings:'
         READ(5,*) DATSD
      endif
C
cjh      WRITE(6,*)' Read STATION DATA from SCREEN (Y or N)?'
cjh      READ(5,1) ANS
      ans='n'
      IUNIT=9   !  Unit number for input station data
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
         CALL SCRDAT(NMAX,HEAD,NSTAT,SN,COMP,PS,R,AZ,AMP,IUNIT)
        ELSE
         CALL FILDAT(NMAX,HEAD,NSTAT,SN,COMP,PS,R,AZ,AMP,-1,IUNIT)
      END IF
C
C***Read in model and set up crustal arrays
      CALL ZERO(50,VTOPP)
      CALL ZERO(50,VTOPS)
      CALL ZERO(50,VBOTP)
      CALL ZERO(50,VBOTS)
      CALL ZERO(50,TH)
      CALL ZERO(50,GRP)
      CALL ZERO(50,GRS)
      CALL ZERO(50,DEPTOP)
      XTEST=.01
      CALL GETMODEL(FNAME,VTOPP,VBOTP,TH,GRP,DEPTOP,NLAYER)
      CALL SRCELAYR(VTOPP,VBOTP,TH,GRP,DEPTOP,NLAYER,SRCEDEP,LAYBELSR)
C
      WRITE(6,*)' '
      WRITE(6,*)'               *****CRUSTAL MODEL*****'
      WRITE(6,*) '     VTOPP     VTOPS     GRP       TH       DEPTOP'
      WRITE(7,*)' '
      WRITE(7,*)'               *****CRUSTAL MODEL*****'
      WRITE(7,*) '     VTOPP     VTOPS     GRP       TH       DEPTOP'
      DO 101 J=1, NLAYER
      VTOPS(J)=VTOPP(J)/SQRT(3.)
      VBOTS(J)=VBOTP(J)/SQRT(3.)
      WRITE(7,1001) VTOPP(J), VTOPS(J), GRP(J), TH(J), DEPTOP(J)
101   WRITE(6,1001) VTOPP(J), VTOPS(J), GRP(J), TH(J), DEPTOP(J)
1001  FORMAT(2X,F8.2,2X,F8.2,2X,F8.5,2X,F8.2,2X,F8.2)
      WRITE(6,*)' '
C
      DO 500 J=1,NSTAT
      CALL ZEROI(50,LEGDUPP)
      CALL ZEROI(50,LEGDUPS)
      TYPE='P'
      IF(PS(J).EQ.' P'.OR.PS(J).EQ.'P '.OR.PS(J).EQ.' p'.OR.PS(J).EQ.
     *'p ') THEN
            CALL PATHDEF(TYPE,NLAYER,LAYBELSR,VTOPP,MANTOP,LEGDUPP)
        ELSE
            CALL PATHDEF(TYPE,NLAYER,LAYBELSR,VTOPP,MANTOP,LEGDUPS)
      END IF
C***Iterate in on the correct ray parameter and travel time using the
C    Newton Divided Differences method
      RR=R(J)   !  Needed for HP EMA statement
      CALL NEWTTME(RR,XTEST,LEGDUPP,LEGDUPS,VTOPP,VBOTP,GRP,VTOPS,
     *VBOTS,GRS,TH,NLAYER,LAYBELSR,MANTOP,XMAX,T,PP,NITER)
      P(J)=PP  !  Needed for the HP EMA statement
      IF(PS(J).EQ.' P'.OR.PS(J).EQ.'P '.OR.PS(J).EQ.' p'.OR.PS(J).EQ.
     *'p ') THEN
          PP=P(J)  !  Needed for the HP EMA statement
          CALL PTHLEN(LAYBELSR-1,TH,VTOPP,PP,RTOT)
        ELSE
          PP=P(J)  !  Needed for the HP EMA statement
          CALL PTHLEN(LAYBELSR-1,TH,VTOPS,PP,RTOT)
      END IF
      INDR=0
      IF(PS(J).EQ.'SH'.OR.PS(J).EQ.'sh') THEN
          INDR=4
          V=VTOPS(LAYBELSR-1)
        ELSE IF (PS(J).EQ.'SV'.OR.PS(J).EQ.'sv') THEN
          INDR=3
          V=VTOPS(LAYBELSR-1)
        ELSE IF(PS(J).EQ.' P'.OR.PS(J).EQ.'P '.OR.PS(J).EQ.' p'.OR.
     *PS(J).EQ.'p ') THEN
          INDR=5
          V=VTOPP(LAYBELSR-1)
      END IF
      PP=P(J)  !  Needed for the HP EMA statement
      CALL VRAD(INDR,PP,V,-1.,HDC)
      AAZZ=AZ(J)  !  Needed for the HP EMA statement
      CALL MTGREEN(INDR,AAZZ,HDC,HGREEN)
      NTYPE=0
      IF(COMP(J).EQ.'Z'.OR.COMP(J).EQ.'z') THEN
          NTYPE=1
        ELSE IF(COMP(J).EQ.'R'.OR.COMP(J).EQ.'r') THEN
          NTYPE=2
        ELSE IF(COMP(J).EQ.'T'.OR.COMP(J).EQ.'t') THEN
          NTYPE=3
      END IF
      PP=P(J)  !  Needed for the HP EMA statement
      VTP=VTOPP(1)  !  Needed for the HP EMA statement
      VTS=VTOPS(1)  !  Needed for the HP EMA statement
      CALL RECEVH(INDR,PP,NTYPE,VTP,VTS,RCV)
C***Check if ray past critical anlge at free surface
      IF(RCV.EQ.-99999.) THEN
         WRITE(7,231) SN(J),COMP(J),PS(J)
         write(6,231) SN(J),COMP(J),PS(J)
231      FORMAT('  WARNING!!!  ',A,1X,A,1X,A,'  past critical angle
     * at free surface!')
      END IF
C***Scale Green's functions by receiver function times geometric factor
C     and divide them by 4*PI*RHO times the area of the time function
C     (units of seconds).
      AMPCOR(J)=RCV/(RTOT*TAREA*FPIRHO)
      AA=AMPCOR(J)  !  Needed for the HP EMA statement
      CALL RESCALE(AA,5,HGREEN)
      DO 600 I=1,5
600   G(J,I)=HGREEN(I)
500   CONTINUE
C
C
C***Invert the data
      CALL CLSPCK(50,5,G,NSTAT,5)
      CALL GENINV(NSTAT,5,G,AMP,DM,RESM,RESD,VARM)
C***Get the strike, dip, rake and moment from the moment tensor
      DM(6)=-DM(1)-DM(2)   !  Making the trace of the moment tensor zero
      CALL GLTOM(MTENS,DM)
      CALL FGMRTI(S,N,B,M0,MTENS,CLVDM)
      CALL FGI(ST,DP,RK,S,N,B)
      CALL CNFG(S,N,B)   !  Other alternative representation of source
      CALL FGI(ST1,DP1,RK1,S,N,B)
C***Calculate the displacements expected from the best model
      CALL SDTOM(ST,DP,RK,SDRMOM)
      CALL OPNPCK(50,5,G,NSTAT,5)
      DO 520 J=1,NSTAT
      DO 521 II=1,5
521   HGREEN(II)=G(J,II)
      CALL DISPS(HGREEN,SDRMOM,DD) ! Calculate amps from double-couple mom tens
      CALL DISPS(HGREEN,DM,DM0(J)) ! Calculate amps from original mom tens
520   D(J)=DD  !  Needed for HP EMA statement
      CALL RESCALE(M0,NSTAT,D)
C***Find the RMS error of the expected compared to the observed amplitudes
      ERRRMS=0.
      DO 505 J=1,NSTAT
505   ERRRMS=ERRRMS+(D(J)-AMP(J))*(D(J)-AMP(J))
      ERRRMS=SQRT(ERRRMS/NSTAT)
C***Unpack the data resolution matrix
      CALL OPNPCK(50,50,RESD,NSTAT,NSTAT)
C***Find the standard deviation of the moment tensor and use to find the
C     standard deviation of the strike, dip, rake and seismic moment
      DO 506 J=1,5
506   IF(VARM(J).NE.0.) VARM(J)=DATSD*SQRT(VARM(J))
      CALL SDRM0SD(VARM,M0,ST,DP,RK,SDM0,SDST,SDDP,SDRK)
C***Write it all out
      WRITE(6,1100)
      WRITE(7,1100)
      CALL OUTINV(M0,SDM0,HEAD,NSTAT,SN,COMP,PS,R,AZ,AMP,D,DM0,
     * ST,DP,RK,ST1,DP1,RK1,SDST,SDDP,SDRK,ERRRMS,CLVDM,7)
1100  FORMAT(' ')
      WRITE(7,1101)
1101  FORMAT(' MODEL RESOLUTION MATRIX')
      DO 701 J=1,5
701   WRITE(7,702)(RESM(J,I),I=1,5)
702   FORMAT(18(F6.3,1X),F6.3)
      WRITE(7,1100)
      WRITE(7,1102)
1102  FORMAT(' DATA RESOLUTION MATRIX')
      DO 704 J=1,NSTAT
704   WRITE(7,702)(RESD(J,I),I=1,NSTAT)
      WRITE(7,1100)
      WRITE(7,1100)
      WRITE(6,1100)
999   continue
cjh     WRITE(6,*)' Do another run (Y/N)?'
cjh      READ(5,1)ANS
      ans='n'
      IF (ANS.EQ.'Y'.OR.ANS.EQ.'y') GO TO 1000
      CLOSE(7)
      END
C
C
C
      SUBROUTINE PTHLEN(NLAYERS,TH,V,P,R)
C
C  Subroutine to compute the total length of the travel path for a direct P or
C    S wave.  The result can be used for geometric spreading corrections.
C
C  Inputs:  NLAYERS - # of layers traversed by ray
C           TH - array of layer thickness values
C           V - array of layer velocities.  V(I) corresponds to TH(I).
C           P - ray parameter of direct ray
C
C  Output:  R - total travel length of ray
C
      DIMENSION TH(NLAYERS),V(NLAYERS)
      R=0.
      IF(NLAYERS.LE.0) RETURN
      DO 1 J = 1, NLAYERS
1     R = R + TH(J) / SQRT(1.-P*P*V(J)*V(J))
      RETURN
      END
C
C
C
      SUBROUTINE HRAD (IND,AZ,ST,DP,RK,A)
C
C  Subroutine to calculate the Ai horizontal, farfield radiation pattern
C   terms, after Langston and Helmberger, GJRAS, v. 42, pp 117-130, 1975
C   equations (2).
C
C  Inputs:  IND - =3 for SV wave; =4 for SH wave; or =5 for P wave, as i
C                 takes off from the source
C           AZ - station azimuth from North in degrees
C           ST - fault strike from North in degrees
C           DP - fault dip in degrees
C           RK - fault rake in degrees
C
C  Outputs: A(I) - Ai terms, A1, A2, and A3, for the corresponding phase
C                  indicated by the value of IND
C
      DIMENSION A(3)
      PIBY180 = 3.14159265/180.
      THETA = (AZ-ST)*PIBY180
      DPRAD = DP * PIBY180
      RKRAD = RK * PIBY180
      IF (IND.LT.3.OR.IND.GT.5) THEN
          A(1) = 0.
          A(2) = 0.
          A(3) = 0.
          RETURN
        ELSE IF (IND.EQ.4) THEN
C***SH wave
          A(1) = COS(2.*THETA)*COS(RKRAD)*SIN(DPRAD) - .5*SIN(2.*THETA)
     &*SIN(RKRAD)*SIN(2.*DPRAD)
          A(2) = -SIN(THETA)*COS(RKRAD)*COS(DPRAD) - COS(THETA)*
     &SIN(RKRAD)*COS(2.*DPRAD)
          A(3) = 0.
        ELSE
C***P or SV wave
          A(1) = SIN(2.*THETA)*COS(RKRAD)*SIN(DPRAD) + COS(2.*THETA)
     &*SIN(RKRAD)*SIN(2.*DPRAD)/2.
          A(2) = COS(THETA)*COS(RKRAD)*COS(DPRAD) - SIN(THETA)*
     &SIN(RKRAD)*COS(2.*DPRAD)
          A(3) = SIN(RKRAD)*SIN(2.*DPRAD)/2.
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE MTGREEN (IND,AZ,HDC,HMT)
C
C  Subroutine to calculate moment tensor formulation Green's functions
C    from the far-field, first-motion approximation, double-couple Greens
C    functions; after Langston, BSSA, v. 71, pp 1-24, 1981, equations (6)
C    are an example.
C    The SH Green's functions have been multiplied by -1 to make the Langston
C    formulation of the problem have the same moment tensor and receiver
C    coordinate system as Aki&Richards (equations 4.87, 4.91, and Box 9.10)
C    where the receiver coordinate system is: Positive Up, Positive radially
C    Toward source, and Positive to Right facing away from source.  This
C    makes the formulation directly compatible with the Aki&Richards moment
C    tensor (Box 4.4) which is -1 times the Langston moment tensor.  See
C    Aki&Richards Figure 4.20 for the complete coordinate system.
C
C  Inputs:   IND - =3 for SV wave; =4 for SH wave; =5 for P wave, as ray
C                  leaves from the source
C            AZ - station azimuth from North in degrees
C            HDC(J) - =Cj terms for P waves (j=1,2,3)
C                     =SVj terms for SV waves (j=1,2,3)
C                     =SHj terms for SH waves (j=1,2)
C                     These are the vertical radiation pattern terms after
C            Langston & Helmberger, GJRAS, v.42, pp. 117-130, 1975, equations
C            (7).
C
C  Output:  HMT(1) = Green's function for M11
C           HMT(2) = Green's function for M22
C           HMT(3) = Green's function for M12
C           HMT(4) = Green's function for M13
C           HMT(5) = Green's function for M23
C           HMT(6) = Green's function for M33
C
      DIMENSION HDC(3),HMT(6)
      AZRAD = AZ * 3.14159265 / 180.
      IF (IND.LT.3.OR.IND.GT.5) THEN
          DO 1 J=1,6
1         HMT(J) = 0.
          RETURN
        ELSE IF (IND.EQ.4) THEN
C***SH wave
          HMT(1) = -1.*(HDC(1) * SIN(2.*AZRAD) / 2.)
          HMT(2) = -1.*(-HDC(1) * SIN(2.*AZRAD) / 2.)
          HMT(3) = -1.*(-HDC(1) * COS (2.*AZRAD))
          HMT(4) = -1.*(-HDC(2) * SIN(AZRAD))
          HMT(5) = -1.*(HDC(2) * COS(AZRAD))
          HMT(6) = 0.
        ELSE
C***P or SV wave
          HMT(1) = -HDC(1) * COS(2.*AZRAD) / 2. + HDC(3) / 2.
          HMT(2) = HDC(1) * COS(2.*AZRAD) / 2. + HDC(3) / 2.
          HMT(3) = -HDC(1) * SIN(2.*AZRAD)
          HMT(4) = HDC(2) * COS(AZRAD)
          HMT(5) = HDC(2) * SIN(AZRAD)
          HMT(6) = 0.
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE VRAD (IND,P,V,E,H)
C
C  Subroutine to compute the vertical, far-field, radiation patterns from
C    a double-couple source, equations (7) from Langston and Helmberger,
C    GJRAS, v. 42, pp. 117-130, 1975.
C
C  Inputs:  IND - =3 for SVj terms (SV waves from source)
C                 =4 for SHj terms (SH waves from source)
C                 =5 for Cj terms (P waves from source)
C           P - ray parameter for ray from source
C           V - velocity of particular wave (P or S) at source
C           E - =+1 for downgoing ray from source; =-1 for upgoing ray from
C               source
C
C  Output: H(I) - =Ci for P waves; SVi for SV waves; or SHi for SH waves
C                 depending upon value of IND
C
      DIMENSION H(3)
      IF (IND.LT.3.OR.IND.GT.5) THEN
          H(1) = 0.
          H(2) = 0.
          H(3)=0.
          RETURN
        ELSE IF (IND.EQ.5) THEN
C***P wave
          ETA2 = 1./(V*V) - P*P
          IF (ETA2.LT.0.) THEN
            H(1) = 0.
            H(2) = 0.
            H(3) = 0.
            RETURN
          END IF
          ETA = SQRT(ETA2)
          H(1) = -P*P
          H(2) = 2.*E*P*ETA
          H(3) = P*P - 2.*ETA2
        ELSE
          ETB2 = 1./(V*V) - P*P
          IF (ETB2.LE.0.) THEN
            H(1) = 0.
            H(2) = 0.
            H(3) = 0.
            RETURN
          END IF
          ETB = SQRT(ETB2)
          IF (IND.EQ.3) THEN
C***SV wave
            H(1) = -E*P*ETB
            H(2) = ETB2 - P*P
            H(3) = 3.*E*P*ETB
           ELSE
C***SH wave
            H(1) = 1./(V*V)
            H(2) = -E*ETB / (V*V*P)
            H(3) = 0.
          END IF
      END IF
      RETURN
      END
C
C
C
      SUBROUTINE SDTOM(ST,DP,RK,M)
C
C  Subroutine to convert strike, dip and rake to moment tensor components.
C    After Langston, BSSA, v. 71, pp 1-24, 1981, equations (4), but multiplied
C    all components by -1 to be compatible with Aki&Richards formulation,
C    Box 4.4.
C
C  Inputs:  ST - fault strike from North in degrees
C           DP - fault dip in degrees
C           RK - fault rake in degrees
C
C  Output:  M - moment tensor components with:
C               M(1)=M11
C               M(2)=M22
C               M(3)=M12
C               M(4)=M13
C               M(5)=M23
C               M(6)=M33
C
      DIMENSION M(6)
      REAL M
      PIBY180 = 3.14159265 / 180.
      STRAD = ST * PIBY180
      DPRAD = DP * PIBY180
      RKRAD = RK * PIBY180
      M(1) = SIN(STRAD)*SIN(STRAD)*SIN(RKRAD)*SIN(2.*DPRAD) +
     &SIN(2.*STRAD)*COS(RKRAD)*SIN(DPRAD)
      M(2) = COS(STRAD)*COS(STRAD)*SIN(RKRAD)*SIN(2.*DPRAD) -
     &SIN(2.*STRAD)*COS(RKRAD)*SIN(DPRAD)
      M(3) = -.5*SIN(2.*STRAD)*SIN(RKRAD)*SIN(2.*DPRAD) -
     &COS(2.*STRAD)*COS(RKRAD)*SIN(DPRAD)
      M(4) = COS(STRAD)*COS(RKRAD)*COS(DPRAD) + SIN(STRAD)
     &*SIN(RKRAD)*COS(2.*DPRAD)
      M(5) = -COS(STRAD)*SIN(RKRAD)*COS(2.*DPRAD) + SIN(STRAD)
     &*COS(RKRAD)*COS(DPRAD)
      M(6) = -M(1) - M(2)
C***Multiply all components by -1 to be compatible with Aki&Richards
      DO 1 J=1,6
1     M(J) = -1.*M(J)
      RETURN
      END
C
C
C
      SUBROUTINE FGMRTI(S,N,B,M0,M,MCLVD)
C
C  Subroutine to compute the the fault geometry unit vectors slip (S),
C    normal (N), and null (B), as well as moment M0, from the moment tensor
C    M.  This version is
C    for X, Y, Z - (North, East, Down) coordinates.  From Karl Koch,
C    by John Ebel, 3/18/87.
C
C  Revised to calculate the smallest CLVD of the moment tensor.  J. Ebel,
C     Apr. 8, 1987.
C
C  ###Calls CROSSV, FGPAF, FGPAI, and JACOBI
C
C  Inputs:  M(I,J) - Moment tensor component Mij
C
C  Outputs: S(I) - Slip vector components in X, Y, Z coordinate system
C           N(I) - Normal vector components in X, Y, Z coordinate system
C           B(I) - Null vector components in X, Y, Z coordinate system
C           M0 - Seismic moment
C           MCLVD - Moment of smallest compensated linear vector dipole
C                    component
C
      REAL S(3),N(3),B(3),M0,M(3,3),P(3),T(3),EV(3),VEC(3,3),MCLVD
C ??? CALL FGPAF(S,N,P,T)  ! Statement as received from K. Koch
C***Decompose the matrix into eigenvalues and eigenvectors
      CALL JACOBI(3,M,EV,VEC,NROT)
C***Find the maximum and minimum eigenvalues
      EMAX=EV(1)
      EMIN=EMAX
      NP=1
      NT=1
      DO 2 K=2,3
      IF (EV(K).GE.EMIN) GO TO 3
      EMIN=EV(K)
      NP=K
3     IF(EV(K).LE.EMAX) GO TO 2
      EMAX=EV(K)
      NT=K
2     CONTINUE
C***Compute S and N
      SP=SIGN(1.,VEC(3,NP))
      ST=SIGN(1.,VEC(3,NT))
      DO 4 K=1,3
      P(K)=-SP*VEC(K,NP)
4     T(K)=-ST*VEC(K,NT)
      CALL CROSSV(P,T,B)
C***Compute the moment of the double couple source
      M0=.5*(EV(NT)-EV(NP))
C***Compute the moment of the smallest compensated linear vector dipole
C     component
      MCLVD=.5*(EV(NT)+EV(NP))
      CALL FGPAI(S,N,P,T)
      RETURN
      END
C
C
C
      SUBROUTINE CROSSV(A,B,C)
C
C  Subroutine to compute the vector product C = A X B, where A, B, and C
C    are all three vectors.  Programmed on 30 Oct., 1978 by R. Buland.
C
      DIMENSION A(3),B(3),C(3)
      C(1)=A(2)*B(3)-A(3)*B(2)
      C(2)=A(3)*B(1)-A(1)*B(3)
      C(3)=A(1)*B(2)-B(1)*A(2)
      RETURN
      END
C
C
C
      SUBROUTINE FGPAI(S,N,P,T)
C
C  Subroutine to convert unit vectors defining the principal axis coordinate
C    system P, T, and B to the unit vectors S, N, and B defining the fault
C    geometry coordinate system (see subroutine FGFXY for a definition of
C    the fault geometry coordinate system).  The P, T, and B unit vectors are
C    colinear with the P, T, and B axes such that P(3) <= 0 and T = B X P
C    (where B = N X S).  B is not needed as it is common to both systems.
C    Programmed on 30 Oct. 1978 by R. Buland.
C
      REAL S(3),N(3),P(3),T(3)
      DATA CON/.70710678/
      CN=CON
      IF(T(3)+P(3).GT.0.) CN=-CN
      DO 2 K=1,3
      N(K)=CN*(T(K)+P(K))
2     S(K)=CN*(T(K)-P(K))
      RETURN
      END
C
C
C
      SUBROUTINE FGI(SIG,DEL,GAM,S,N,B)
C
C  Subroutine to compute the strike (SIG), dip (DEL), and slip (GAM) from
C    the fault geometry unit vectors slip (S), normal (N), and null (B).
C    The strike is measured clockwise from North in the (X,Y) plane such
C    that if one faces in the strike direction the fault plane dips to the
C    right at an acute angle.  The strike is defined to fall in the range
C    (0<=SIG<360).  The dip is the acute angle between the (X,Y) plane
C    and the fault plane measured in the plane normal to the strike with
C    (0<=DIP<=90).  Slip is the direction the hanging wall moves relative to
C    the foot wall measured counterclockwise from the strike in the fault
C    plane, with (0<=GAM<360).  S is the unit vector in the fault plane in
C    the direction of slip.  N is the unit vector normal to the fault plane
C    such that N(3)<=0.  B = N X S.
C    Vectors are in Cartesian coordinates: X is North, Y is East, and Z is
C    positive down.  All angles are given in degrees.  Programmed by K. Koch
C    on 1 Jun., 1985.
C
      REAL S(3),N(3),B(3)
      DATA CNI/57.29578/
      DEL=ACOS(-N(3))
      SIG=ATAN2(-N(1),N(2))
      GAM=CNI*ATAN2(-S(3)/SIN(DEL),S(2)*SIN(SIG)+S(1)*COS(SIG))
      DEL=CNI*DEL
      SIG=CNI*SIG
      IF (SIG.LT.0.) SIG=SIG+360.
      IF (GAM.LT.0.) GAM=GAM+360.
      RETURN
      END
C
C
C
      SUBROUTINE FGF(SIG,DEL,GAM,S,N,B)
C
C  Subroutine to convert from a despription of fault geometry in terms of
C    the angles strike (SIG), dip (DEL), and slip (GAM) to fault geometry
C    unit vectors slip (S), normal (N), and null (B).
C    The strike is measured clockwise from North in the (X,Y) plane such
C    that if one faces in the strike direction the fault plane dips to the
C    right at an acute angle.  The strike is defined to fall in the range
C    (0<=SIG<360).  The dip is the acute angle between the (X,Y) plane
C    and the fault plane measured in the plane normal to the strike with
C    (0<=DIP<=90).  Slip is the direction the hanging wall moves relative to
C    the foot wall measured counterclockwise from the strike in the fault
C    plane, with (0<=GAM<360).  S is the unit vector in the fault plane in
C    the direction of slip.  N is the unit vector normal to the fault plane
C    such that N(3)<=0.  B = N X S.
C    Vectors are in Cartesian coordinates: X is North, Y is East, and Z is
C    positive down.  All angles are given in degrees.  Programmed by K.
C    Koch on 1 Jun., 1985.
C
      REAL S(3),N(3),B(3)
      DATA CON/.017453293/
      SS=SIN(SIG*CON)
      CS=COS(SIG*CON)
      SD=SIN(DEL*CON)
      CD=COS(DEL*CON)
      SG=SIN(GAM*CON)
      CG=COS(GAM*CON)
      S(1)=CS*CG+SS*CD*SG
      S(2)=SS*CG-CS*CD*SG
      S(3)=-SD*SG
      N(1)=-SS*SD
      N(2)=CS*SD
      N(3)=-CD
      CALL CROSSV(N,S,B)
      RETURN
      END
C
C
C
      SUBROUTINE CNFG(S,N,B)
C
C  Subroutine which uses S, N, and B (see subroutine FGF) defining a
C    unique fault geometry to compute S, N, and B for the conjugate
C    fault geometry.  Programmed on 30 Oct 1978 by R. Buland.
C
      REAL P(3),T(3),B(3),S(3),N(3)
      CALL FGPAF(S,N,P,T)
      DO 1 K=1,3
      T(K)=-T(K)
1     B(K)=-B(K)
      CALL FGPAI(S,N,P,T)
      RETURN
      END
C
C
C
      SUBROUTINE FGMRTF(S,N,B,M0,M)
C
C  Subroutine to convert the unit vectors in the fault geometry of slip
C    (S) and normal (N) and the moment M0 to a moment tensor M.  See
C    subroutine FGF for details about the vectors and coordinate system.
C    Programmed by R. Buland on 30 Oct. 1978.
C
      REAL S(3),N(3),B(3),M0,M(3,3)
      DO 1 K=1,3
      DO 1 J=1,3
1     M(J,K)=M0*(S(K)*N(J)+S(J)*N(K))
      RETURN
      END
C
C
C
      SUBROUTINE FGPAF(S,N,P,T)
C
C  Subroutine to convert the unit vectors defining the fault geometry
C    coordinate system slip (S) and normal (N) to the unit vectors defining
C    the principal axis coordinate system: P, T, and B.  These unit vectors
C    are colinear with the P, T, and B axes such that P(3) <= 0 and T = B X P
C    (where B = N X S).  B is not needed as it is common to both systems
C    See subroutine FGF for details on the coordinate system used.
C    Programmed on 30 Oct. 1978 by R. Buland.
C    Updated on 11 Sep 1986 by K. Koch.
C
      REAL S(3),N(3),P(3),T(3)
      DATA CON/.70710678/
      CN=CON
      IF(N(3)-S(3).GT.0.) CN=-CN
      DO 1 K=1,3
      P(K)=CN*(N(K)-S(K))
1     T(K)=CN*(N(K)+S(K))
      RETURN
      END
C
C
C
      SUBROUTINE MTOGL(M,G)
C
C  Subroutine to convert a moment tensor M into a six-vector representation
C    G where G is compatible with the formulation of Langston, BSSA, v. 71,
C    pp. 1-24, 1981.  G(1)=M11; G(2)=M22; G(3)=M12; G(4)=M13; G(5)=M23;
C    G(6)=M33.
C    Programmed by J. Ebel, 3/18/1987.
C
      REAL M(3,3),G(6)
      G(1)=M(1,1)
      G(2)=M(2,2)
      G(3)=M(1,2)
      G(4)=M(1,3)
      G(5)=M(2,3)
      G(6)=M(3,3)
      RETURN
      END
C
C
C
      SUBROUTINE GLTOM(M,G)
C
C  Subroutine to convert the six-vector G into moment tensor M, where G is
C    compatible with the formulation of Langston, BSSA, v. 71, pp. 1-24,
C    1981.  Programmed by J. Ebel on 3/18/87.
C
      REAL M(3,3),G(6)
      M(1,1)=G(1)
      M(2,2)=G(2)
      M(1,2)=G(3)
      M(2,1)=M(1,2)
      M(1,3)=G(4)
      M(3,1)=M(1,3)
      M(2,3)=G(5)
      M(3,2)=M(2,3)
      M(3,3)=G(6)
      RETURN
      END
C
C
C
      SUBROUTINE PAF(ZETA,ETA,S,N,B)
C
C  Subroutine which converts an angular description (in degrees) of a set
C    of principal axes into the fault geometry coordinate system defined by
C    unit vectors S, N, and B (see subroutine FGF for a description of the
C    coordinate system).  The portion of each axis below the (X,Y) plane is
C    described by an azimuth, ZETA, measured clockwise from North in the
C    (X,Y) plane (0<=ZETA<360) and a plunge, ETA, the acute angle between the
C    (X,Y) plane and the axis measured in the plane of the axis and the
C    Z-axis (0<=ETA<=90).  ZETA(I) and ETA(I) describe the compression or
C    P axis (I=1), the tension or T axis (I=2), and the null or B axis (I=3).
C    Since the geometry is uniquely defined by the P and T axes, the B axis
C    (ZETA(3) and ETA(3)) is computed by PAF.  The unit vectors S, N, and B
C    define on the the two conjugate fault
C    planes consistent with the principal axes (subroutine CNFG will calculate
C    S, N, and B for the other).  This routine is defined in a (X, Y, Z)
C    coordinate system with orientation (North, East, Down), see Aki and
C    Richards, p 119ff.  Programmed by K. Koch, June 1, 1985.
C
C   Calls CROSSV and FGPAI
C
      REAL ZETA(3),ETA(3),S(3),N(3),B(3),P(3),T(3)
      DATA CON,CNI,TOL,TOL2/.017453293,57.29578,1E-5,2E-5/
      CE=COS(ETA(1)*CON)
      P(1)=COS(ZETA(1)*CON)*CE
      P(2)=SIN(ZETA(1)*CON)*CE
      P(3)=SIN(ETA(1)*CON)
      CE=COS(ETA(2)*CON)
      T(1)=COS(ZETA(2)*CON)*CE
      T(2)=SIN(ZETA(2)*CON)*CE
      T(3)=SIN(ETA(2)*CON)
      CALL CROSSV(P,T,B)
      CALL FGPAI(S,N,P,T)
C***Calculate ZETA and ETA for the B axis.
      CE=SIGN(1.,B(3))
      ZETA(3)=0.
      IF(ABS(B(1))+ABS(B(2)).GT.TOL2) ZETA(3)=CNI*ATAN2(CE*B(2),
     1   CE*B(1))
      ETA(3)=CNI*ASIN(CE*B(3))
      IF(ZETA(3).LT.0.) ZETA(3)=ZETA(3)+360.
      IF((ABS(B(3)).LE.TOL).AND.(ZETA(3).GT.180.)) ZETA(3)=ZETA(3)-180.
      RETURN
      END
C
C
C
      SUBROUTINE PAI(ZETA,ETA,S,N,B)
C
C  Subroutine to convert fault geometry coordinate system unit vectors slip
C    (S), normal (N), and null (B) into an angular description (in degrees)
C    of a set of principal axes.  This is the inverse of subroutine PAF.
C    See subroutine PAF for a description of the coordinate system, and
C    Aki and Richards p. 119ff.  Programmed by K. Koch on June 1, 1985.
C
      REAL ZETA(3),ETA(3),S(3),N(3),B(3),P(3),T(3)
      DATA CNI,TOL,TOL2/57.29578,1E-5,2E-5/
      CALL FGPAF(S,N,P,T)
      DO 2 K=1,3
2     ZETA(K)=0.
      CE=SIGN(1.,P(3))
      IF(ABS(P(1))+ABS(P(2)).GT.TOL2) ZETA(1)=CNI*ATAN2(CE*P(2),
     1  CE*P(1))
      ETA(1)=CNI*ASIN(CE*P(3))
      CE=SIGN(1.,T(3))
      IF(ABS(T(1))+ABS(T(2)).GT.TOL2) ZETA(2)=CNI*ATAN2(CE*T(2),
     1  CE*T(1))
      ETA(2)=CNI*ASIN(CE*T(3))
      CE=SIGN(1.,B(3))
      IF(ABS(B(1))+ABS(B(2)).GT.TOL2) ZETA(3)=CNI*ATAN2(CE*B(2),
     1  CE*B(1))
      ETA(3)=CNI*ASIN(CE*B(3))
      DO 1 K=1,3
      IF(ZETA(K).LT.0.) ZETA(K)=ZETA(K)+360.
1     CONTINUE
C***Put zeta into canonical form if ETA is nearly zero.
      IF((ABS(P(3)).LE.TOL).AND.(ZETA(1).GT.180.)) ZETA(1)=ZETA(1)-180.
      IF((ABS(T(3)).LE.TOL).AND.(ZETA(2).GT.180.)) ZETA(2)=ZETA(2)-180.
      IF((ABS(B(3)).LE.TOL).AND.(ZETA(3).GT.180.)) ZETA(3)=ZETA(3)-180.
      RETURN
      END
C
C
C
      SUBROUTINE PATHDEF(TYPE,NLAYER,NLAYSR,VTOP,MANTOP,LEGDUP)
C
C   Subroutine to calculate the number of P wave traverses through each
C    layer of a crustal model.  The crustal model may have vertical gradients.
C
C   Inputs:  TYPE - Name of ray path, i.e. pPmPmP
C            NLAYSR - Number of layer immediately below source
C            VTOP(J) - Velocity at the top of layer J
C            NLAYER - Number of layers for velocity model
C
C   Outputs: MANTOP - Index of first mantle layer (i.e. layer below Moho)
C            LEGDUP(J) - Number of traverses through layer J
C
      CHARACTER*(*) TYPE
      DIMENSION VTOP(*), LEGDUP(*)
C***Find first mantle layer
      DO 1 J=1, NLAYER+1
      IF (VTOP(J).GE.8.0) GO TO 2
1     CONTINUE
2     MANTOP = J
C***Define number of times ray traverses model above and below source
      IF (TYPE.EQ.'P') THEN
           DUPOVSR=1      ! Number of traverses above source
           DUPBLSR=0      ! Number of traverses below source
        ELSE IF (TYPE.EQ.'PmP') THEN
           DUPOVSR=1
           DUPBLSR=2
        ELSE IF (TYPE.EQ.'pPmP') THEN
           DUPOVSR=3
           DUPBLSR=2
        ELSE IF (TYPE.EQ.'PmPmP') THEN
           DUPOVSR=3
           DUPBLSR=4
      ENDIF
C***Now set up only for case of source above Moho
      IF (NLAYSR.EQ.1) GO TO 101
      DO 10 J=1, NLAYSR-1
10    LEGDUP(J) = DUPOVSR
101   IF (NLAYSR.GE.(MANTOP-1)) GO TO 102
      DO 11 J=NLAYSR, MANTOP-1
11    LEGDUP(J) = DUPBLSR
102   RETURN
      END
C
C
      SUBROUTINE GETMODEL (FNAME,VTOP,VBOT,TH,GR,DEPTOP,NLAYER)
C
C   Subroutine to set up the crustal model.  The model is read in as a
C    velocity vs depth function assuming a constant gradient for the velocity
C    between the depths specified.  A discontinuity in velocity is entered as
C    two velocities at the same depth, with the first being above the inter-
C    face and the second being below the interface.
C
C   The output of the subroutine is the crustal model parameters for each
C    layer.
C
C   Input:   FNAME - Name of file with velocity-depth function (must be
C                    specified from the surface downward).
C
C   Outputs: VTOP(J) - Velocity at top of layer J
C            VBOT(J) - Velocity at bottom of layer J
C            TH(J) - Thickness of layer J
C            GR(J) - Gradient in layer J
C            DEPTOP(J) - Depth to top of layer J
C            NLAYER - Number of layers in model.  Note: halfspace is NLAYER
C
      CHARACTER*(*) FNAME
      DIMENSION VTOP(*), VBOT(*), TH(*), GR(*), DEPTOP(*)
      DIMENSION H(100), V(100)
      LMAX = 100
C***LMAX is the maximum number of vel-depth pairs that can be read in.  If
C     more than 100 values are desired, change the values in the preceding
C     two lines and recompile.
C
C***Open and read the file with the velocity-depth function (2F10.4 format).
C
      OPEN(UNIT=19,FILE=FNAME,STATUS='OLD',ERR=999)
      READ(19,1,END=10)(H(I),V(I),I=1,LMAX)
1     FORMAT(2F10.4)
10    CLOSE(19)
      NVEL=I-1
C***Get the thickness and gradient of each layer, and set up the output
C     parameters
      J = 0
      DO 11 I=1, NVEL-1
      IF (H(I).EQ.H(I+1)) GO TO 11
         J = J + 1
         TH(J) = H(I+1) - H(I)
         VTOP(J) = V(I)
         VBOT(J) = V(I+1)
         GR(J) = (VBOT(J) - VTOP(J)) / TH(J)
         DEPTOP(J) = H(I)
11    CONTINUE
      NLAYER = J
      VTOP(J+1) = V(NVEL)
      RETURN
999   WRITE(6,998) FNAME
998   FORMAT(' FILE ',A,' NOT FOUND, PROGRAM WILL STOP!')
      STOP
      END
C
C
C
      SUBROUTINE SRCELAYR(VTOP,VBOT,TH,GR,DEPTOP,NLAYERS,SRCEDEP,
     *LAYBELSR)
C
C   Subroutine to put a source into a crustal model.  An interface is
C    constructed at the source depth, and the layer in which the source
C    occurs is divided into two separate layers.
C
C   Inputs:  VTOP(J) - Velocity at the top of layer J
C            VBOT(J) - Velocity at the bottom of layer J
C            TH(J) - Thickness of layer J
C            GR(J) - Velocity gradient in layer J
C            DEPTOP(J) - Depth to the top of layer J
C            NLAYERS - Number of layers in the crustal model
C            SRCEDEP - Source Depth
C
C   Outputs: LAYBELSR - Index of layer number immediately below source
C            Recomputed arrays VTOP, VBOT, TH, GR, DEPTOP, and
C            recomputed number of layers NLAYERS
      DIMENSION VTOP(*), VBOT(*), TH(*), GR(*), DEPTOP(*)
C***Find layer is which source lies
      DO 1 J=1, NLAYERS
1     IF (SRCEDEP.LT.DEPTOP(J)) GO TO 2
2     NLAYSR = J - 1
C***Increase all layer indices by 1, thus creating space for the new layer
      VTOP(NLAYERS+2) = VTOP(NLAYERS+1)
      DO 3 J=NLAYERS, NLAYSR+1, -1
          VTOP(J+1) = VTOP(J)
          VBOT(J+1) = VBOT(J)
          TH(J+1) = TH(J)
          GR(J+1) = GR(J)
          DEPTOP(J+1) = DEPTOP(J)
3     CONTINUE
C***Divide up layer with source into 2 layers by first putting in the new
C    interface and constructing the layer above the source, and then con-
C    structing the layer below the source.
      TH(NLAYSR) = SRCEDEP - DEPTOP(NLAYSR)
      VBOT(NLAYSR+1) = VBOT(NLAYSR)
      VBOT(NLAYSR) = VTOP(NLAYSR) + GR(NLAYSR) * TH(NLAYSR)
C***The layer above the source has been constructed, now create the one
C    below the source
      TH(NLAYSR+1) = DEPTOP(NLAYSR+1) - SRCEDEP
      VTOP(NLAYSR+1) = VBOT(NLAYSR)
      GR(NLAYSR+1) = GR(NLAYSR)
      DEPTOP(NLAYSR+1) = SRCEDEP
      NLAYERS = NLAYERS + 1
      LAYBELSR = NLAYSR + 1
      RETURN
      END
C
C
C
      SUBROUTINE XANDT (P,LEGDUPP,LEGDUPS,VTOPP,VBOTP,GRP,VTOPS,VBOTS,
     *GRS,TH,NLAYERS,X,T)
C
C   Subroutine to compute the travel time and epicentral distance of a ray
C    given a crustal model and ray parameter.  The earth model is with planar
C    layers.
C
C   Inputs:  P - Ray parameter for ray
C            VTOPP(J) - P velocity at the top of layer J
C            VTOPS(J) - S velocity at the top of layer J
C            VBOTP(J) - P velocity at the bottom of layer J
C            VBOTS(J) - S velocity at the bottom of layer J
C            GRP(J) - P velocity gradient in layer J
C            GRS(J) - S velocity gradient in layer J
C            TH(J) - Thickness of layer J
C            LEGDUPP(J) - Number of P ray path traverses in layer J
C            LEGDUPS(J) - Number of S ray path traverses in layer J
C            NLAYERS - Number of layers in crustal model
C
C   OUTPUTS: X - Epicentral distance for ray
C            T - Travel time for ray
C
      DIMENSION VTOPP(*), VTOPS(*), VBOTP(*), VBOTS(*), GRP(*), GRS(*)
      DIMENSION LEGDUPP(*), LEGDUPS(*), TH(*)
C***Find X and T
      X=0.
      T=0.
      DO 1 J=1, NLAYERS
C
C***P wave legs
C
      IF (LEGDUPP(J).EQ.0) THEN
             XP = 0.
             TP = 0.
             GO TO 10
      ENDIF
C***No gradient section
      IF (GRP(J).EQ.0.) THEN
            XPDEN = 1./(P*P) - VTOPP(J) * VTOPP(J)
            XP = LEGDUPP(J) * VTOPP(J) * TH(J) / SQRT(XPDEN)
            TP = LEGDUPP(J) * TH(J) / (P * VTOPP(J) * SQRT(XPDEN))
C***Gradient section
        ELSE IF (P.LE.(1./VBOTP(J))) THEN  ! Ray turns below this layer
            XP2 = 1./(P*P) - VBOTP(J) * VBOTP(J)
            IF (XP2.EQ.0.) XP2 = 1.E-20  ! Ray turns at layer bottom
            XP1 = 1./(P*P) - VTOPP(J) * VTOPP(J)
            XP2 = SQRT(XP2)
            XP1 = SQRT(XP1)
            XP = LEGDUPP(J) * (XP1 - XP2) / GRP(J)
            XP2 = (1./P + XP2) / VBOTP(J)
            XP1 = (1./P + XP1) / VTOPP(J)
            XP2 = ALOG(XP2)
            XP1 = ALOG(XP1)
            TP = LEGDUPP(J) * (XP1 - XP2) / GRP(J)
         ELSE IF (P.LE.(1./VTOPP(J))) THEN ! Ray turns in layer
            XP1 = 1./(P*P) - VTOPP(J) * VTOPP(J)
            IF (XP1.EQ.0.) XP1 = 1.E-20
            XP1 = SQRT(XP1)
            XP = LEGDUPP(J) * XP1 / GRP(J)
            XP1 = (1./P + XP1) / VTOPP(J)
            XP1 = ALOG(XP1)
            TP = LEGDUPP(J) * XP1 / GRP(J)
         ELSE   ! Ray turns above this layer
            XP = 0.
            TP = 0.
      ENDIF
C
C***S wave legs
C
10    IF (LEGDUPS(J).EQ.0) THEN
            XS = 0.
            TS = 0.
            GO TO 11
      ENDIF
C***No gradient case
      IF (GRS(J).EQ.0.) THEN
            XSDEN = 1./(P*P) - VTOPS(J) * VTOPS(J)
            XS = LEGDUPS(J) * VTOPS(J) * TH(J) / SQRT(XSDEN)
            TS = LEGDUPS(J) * TH(J) / (P * VTOPS(J) * SQRT(XSDEN))
C***Gradient case
        ELSE IF (P.LE.(1./VBOTS(J))) THEN ! Ray turns below layer
            XS1 = 1./(P*P) - VTOPS(J) * VTOPS(J)
            XS2 = 1./(P*P) - VBOTS(J) * VBOTS(J)
            IF (XS2.EQ.0.) XS2 = 1.E-20  ! Ray turns at bottom of layer
            XS1 = SQRT(XS1)
            XS2 = SQRT(XS2)
            XS = LEGDUPS(J) * (XS1 - XS2) / GRS(J)
            XS2 = (1./P + XS2) / VBOTS(J)
            XS1 = (1./P + XS1) / VTOPS(J)
            XS2 = ALOG(XS2)
            XS1 = ALOG(XS1)
            TS = LEGDUPS(J) * (XS1 - XS2) / GRS(J)
         ELSE IF (P.LE.(1./VTOPS(J))) THEN ! Ray turns in layer
            XS1 = 1./(P*P) - VTOPS(J) * VTOPS(J)
            IF (XS1.EQ.0.) XS1 = 1.E-20
            XS1 = SQRT(XS1)
            XS = LEGDUPS(J) * XS1 / GRS(J)
            XS1 = (1./P + XS1) / VTOPS(J)
            XS1 = ALOG(XS1)
            TS = LEGDUPS(J) * XS1 / GRS(J)
         ELSE   ! Ray turns above this layer
            XS = 0.
            TS = 0.
      ENDIF
11    X = X + XP + XS
      T = T + TP + TS
1     CONTINUE
      RETURN
      END
C
C
      SUBROUTINE INSRT(X,NX,XIN,INDEX,IORDER)
C
C  Subroutine to insert a new value into its proper place in an array
C   of monotonically increasing or decreasing values.
C
C  Inputs:  X - Array of values
C           NX - Number of values of array X
C           XIN - New value to be inserted into array X
C           IORDER - Any positive integer indicates array X contains
C                    progressively increasing values, while any negative
C                    integer indicates progressively decreasing values.
C                    If IORDER=0, XIN is not inserted and X and NX are
C                    returned unchanged.
C
C  Outputs: X - New array of values with XIN inserted in proper place
C           NX - New number of array values of X
C           INDEX - Index of array element where XIN was inserted.  This
C                   is set to 0 if IORDER=0.
C
      DIMENSION X(*)
C
      IF (IORDER.EQ.0) THEN
         INDEX=0
         RETURN
      ENDIF
C
      IF (IORDER.GT.0) THEN
C***Array has increasing values
          DO 1 INDEX=1, NX-1
            IF (XIN.EQ.X(INDEX)) RETURN  ! XIN is already in list
1         IF (XIN.LT.X(INDEX)) GO TO 2
C***Section to insert XIN at end of X array
      IF (XIN.EQ.X(NX)) THEN
          INDEX = NX
          RETURN
      END IF
          IF (XIN.LT.X(NX)) THEN
             X(NX+1) = X(NX)
             X(NX) = XIN
             INDEX = NX
             NX = NX + 1
             RETURN
          ELSE
             X(NX+1) = XIN
             NX = NX + 1
             INDEX = NX
             RETURN
          ENDIF
C***Section to insert XIN in the middle of X array
2         DO 3 J=NX, INDEX, -1
3         X(J+1) = X(J)
          X(INDEX) = XIN
          NX = NX + 1
          RETURN
      ELSE
C***Section for decreasing values in X
          DO 11 INDEX=1, NX-1
            IF (XIN.EQ.X(INDEX)) RETURN  ! XIN is already in list
11        IF (XIN.GT.X(INDEX)) GO TO 12
C***Section to insert XIN at end of X array
      IF (XIN.EQ.X(NX)) THEN
         INDEX = NX
         RETURN
      END IF
          IF (XIN.GT.X(NX)) THEN
             X(NX+1) = X(NX)
             X(NX) = XIN
             INDEX = NX
             NX = NX + 1
             RETURN
           ELSE
             X(NX+1) = XIN
             NX = NX + 1
             INDEX = NX
           RETURN
          ENDIF
C***Section to insert XIN in the middle of X array
12        DO 13 J=NX, INDEX, -1
13        X(J+1) = X(J)
          X(INDEX) = XIN
          NX = NX + 1
          RETURN
      ENDIF
      RETURN
      END
C
C
      SUBROUTINE NEWTTME(X,XTEST,LEGDUPP,LEGDUPS,VTOPP,VBOTP,GRP,
     *VTOPS,VBOTS,GRS,TH,NLAYER,NLAYSR,MANTOP,XMAX,T,P,NITER)
C
C  Subroutine to iterate into the proper ray parameter and travel time
C   for a ray given a known epicentral distance and crustal model. The
C   Newton Divided Difference interpolation scheme is used in the itera-
C   tion.  If ray does not exist, T and P are set to -99.
C
C   Subroutine is set up only for direct or Moho reflected phases.
C
C
C  Inputs:  X - Value of epicentral distance for which the ray parameter
C               and travel time are being sought
C           XTEST - When the subroutine finds a ray parameter and travel
C                   time for a ray in the range of X-XTEST and X+XTEST,
C                   or when it has performed 20 iterations, the search
C                   islterminated and the values for T, P and NITER are
C                   returned.
C           VTOPP(J) and VTOPS(J) - P and S velocities respectively at the
C                                   top of layer J
C           VBOTP(J) and VBOTS(J) - P and S velocities respectively at the
C                                   bottom of layer J
C           GRP(J) and GRS(J) - P and S wave velocity gradients respectively
C                               in layer J
C           TH(J) - Thickness of layer J
C           LEGDUPP(J) and LEGDUPS(J) - Number of traverses of P and S waves
C                                       in layer J for ray
C           NLAYER - Number of layers in crustal model
C           NLAYSR - Index of layer immediately below source
C           MANTOP - Index of first mantle layer
C
C  Outputs: T - Travel time for ray
C           P - Ray parameter for ray
C           XMAX - Maximum distance at which ray can be seen
C           NITER - Number of iterations needed to find T and P
C
      DIMENSION VTOPP(*), VTOPS(*), VBOTP(*), VBOTS(*), GRP(*), GRS(*)
      DIMENSION LEGDUPP(*), LEGDUPS(*), TH(*)
      DIMENSION XTEMP(12), PTEMP(12)
      MAXTRMN = 10
C***Set up for a maximum 10th order polynomial to be used in the interpolation
C    at present.  If other values are desired, increment the preceding two
C    lines accordingly and recompile.  Remember to check NEWTDIF to be sure
C    it can handle the order of the polynomial being specified here.
C
C***Find maximum distance ray can be seen
      XMAX = 99999.
      PMAX = 99999.
      IF ((LEGDUPP(NLAYSR).NE.0).OR.(LEGDUPS(NLAYSR).NE.0)) THEN
C***Downgoing ray case
         IF (GRP(MANTOP-1).GT.0.) THEN  ! Ray can turn in bottom layer
            PMAX = 1. / VBOTP(MANTOP-1)  ! Maximum ray parameter
            CALL XANDT(PMAX,LEGDUPP,LEGDUPS,VTOPP,VBOTP,GRP,VTOPS,VBOTS,
     *      GRS,TH,NLAYER,XMAX,TMAX)
            IF (X.GT.XMAX) THEN   ! Ray does not exist
               NITER = 0
               T = -99.
               P = -99.
               RETURN
            ENDIF
            IF((ABS(XMAX-X)).LT.XTEST) THEN ! Stumbled on correct value
               P = PMAX
               T = TMAX
               NITER = 0
               RETURN
            ENDIF
         ELSE
C***Find smallest P velocity along path
             VMAXP = 0.0
             DO 5 JJ=1, MANTOP-1
             IF (VBOTP(JJ).GT.VMAXP) VMAXP = VBOTP(JJ)
5            IF (VTOPP(JJ).GT.VMAXP) VMAXP = VTOPP(JJ)
             PMAX = .99 / VMAXP  ! Largest ray parameter allowed
         ENDIF
      ELSE
C***Direct ray case
        IF(LEGDUPP(NLAYSR-1).NE.0) THEN
         PMAX = .999999 / VBOTP(NLAYSR-1) ! PMAX for direct ray
        ELSE
         PMAX = .999999 / VBOTS(NLAYSR-1) ! PMAX for direct ray
        END IF
      ENDIF
C
C  Starting values for the iteration.  Can be reset if desired.
C
C***First starting value
      PTEMP(1) = .0001  ! Smallest ray parameter expected
      PP=PTEMP(1)    !  Needed for HP EMA statement
      CALL XANDT(PP,LEGDUPP,LEGDUPS, VTOPP,VBOTP,GRP,VTOPS,
     *VBOTS,GRS,TH,NLAYER,XX,T)
      XTEMP(1)=XX   !  Needed for HP EMA statement
      IF ((ABS(X-XTEMP(1))).LT.XTEST) THEN
         P = PTEMP(1)
         NITER = 0
         RETURN
      ENDIF
C***Second starting value
      IF((LEGDUPP(NLAYSR).GT.0).OR.(LEGDUPS(NLAYSR).GT.0)) THEN
            PTEMP(2) = 1. / VTOPP(MANTOP)  ! Critical ray parameter
        ELSE
           IF(LEGDUPP(NLAYSR-1).NE.0) THEN
            PTEMP(2) = .995 / VBOTP(NLAYSR-1)  ! Starting value for direct ray
           ELSE
            PTEMP(2) = .995 / VBOTS(NLAYSR-1)  ! Starting value for direct ray
           END IF
      ENDIF
      PP=PTEMP(2)    !  Needed for HP EMA statement
      CALL XANDT(PP,LEGDUPP,LEGDUPS,VTOPP,VBOTP,GRP,VTOPS,
     *VBOTS,GRS,TH,NLAYER,XX,T)
      XTEMP(2)=XX   !  Needed for HP EMA statement
      IF((ABS(X-XTEMP(2))).LT.XTEST) THEN
         P = PTEMP(2)
         NITER = 0
         RETURN
      ENDIF
      NTERMS = 2
C***If ray is past critical angle at the Moho or if a direct ray
C    add a third starting value
      IF ((LEGDUPP(NLAYSR).GT.0).OR.(LEGDUPS(NLAYSR).GT.0)) THEN
            IF ((X.GT.XTEMP(2)).AND.(GRP(MANTOP-1).GT.0.)) THEN
               PTEMP(3) = PMAX
               XTEMP(3) = XMAX
               NTERMS = 3
            ENDIF
         ELSE
           PTEMP(3) = .999 / VBOTP(NLAYSR-1)
           PP=PTEMP(3)   !  Needed for HP EMA statement
           CALL XANDT(PP,LEGDUPP,LEGDUPS,VTOPP,VBOTP,GRP,
     *     VTOPS,VBOTS,GRS,TH,NLAYER,XX,T)
           XTEMP(3)=XX   !  Needed for HP EMA statement
           IF ((ABS(X-XTEMP(3))).LT.XTEST) THEN
              P = PTEMP(3)
              NITER = 0
              RETURN
           ENDIF
           NTERMS = 3
      ENDIF
C***
C  I'M NOT SURE IF THE NEXT SECTION OF CODE IS NEEDED OR NOT
C
C      IF(PTEMP(3).LT.PTEMP(2)) THEN
C         STOREP=PTEMP(3)
C         STOREX=XTEMP(3)
C         PTEMP(3)=PTEMP(2)
C         XTEMP(3)=XTEMP(2)
C         PTEMP(2)=STOREP
C         XTEMP(2)=STOREX
C      END IF
C***
C***Perform the iterations
      IORDER = 1  ! XTEMP contains increasing values of distance
      DO 1 JJ=1, 20
C
      NITER = JJ
      CALL NEWTDIF(NTERMS, XTEMP, PTEMP, X, P)
C***If ray parameter falls outside range of possible values, then bump
C     back into the appropriate range.  This is to keep the program from
C     wandering onto the wrong branch of the travel time curve or into unreal
C     values of the ray parameter.
C
C
      IF (P.LT.0.) P = -P
      IF (P.GT.PMAX) THEN
         DO 21 J=2, NTERMS
         IF (X.LT.XTEMP(J)) THEN
             P = (PTEMP(J) + PTEMP(J-1)) / 2. ! Average appropriate values
             GO TO 22
         ENDIF
21       CONTINUE
         P = (PMAX + PTEMP(NTERMS)) /2.
22       CONTINUE
      ENDIF
C
C
      CALL XANDT(P,LEGDUPP,LEGDUPS,VTOPP,VBOTP,GRP,VTOPS,VBOTS,
     *GRS,TH,NLAYER,XOUT,T)
C***Test the result
      IF ((ABS(X-XOUT)).LT.XTEST) GO TO 99
C***Result not good enough, update the arrays of known values and try again
      CALL INSRT(XTEMP,NTERMS,XOUT,INDEX,IORDER)
      IF (INDEX.EQ.NTERMS) THEN
          PTEMP(NTERMS) = P
        ELSE
          DO 10 J=NTERMS, INDEX, -1
10        PTEMP(J+1) = PTEMP(J)
          PTEMP(INDEX) = P
      ENDIF
C***Test end points of XTEMP and throw out one most different from X
      IF (NTERMS.GT.MAXTRMN) THEN
         IF((ABS(XTEMP(1)-X)).GT.(ABS(XTEMP(NTERMS)-X))) THEN
            IF (INDEX.EQ.NTERMS) THEN   !Scheme not converging
              NITER = 99
              GO TO 99
            END IF
            DO 11 J=1, NTERMS-1
            XTEMP(J) = XTEMP(J+1)
11          PTEMP(J) = PTEMP(J+1)
         ENDIF
      NTERMS = MAXTRMN
      ENDIF
1     CONTINUE
99    RETURN
      END
C
C
C
      SUBROUTINE MINSN(LX,X,XMIN,INDEX)
      DIMENSION X(LX)
      INDEX=1
      DO 1 I=1,LX
      IF(X(INDEX).GT.X(I))INDEX=I
1     CONTINUE
      XMIN=X(INDEX)
      RETURN
      END
C
C
C
      SUBROUTINE MAXSN(LX,X,XMAX,INDEX)
      DIMENSION X(LX)
      INDEX=1
      DO 1 I=1,LX
      IF(X(INDEX).LT.X(I)) INDEX=I
1     CONTINUE
      XMAX=X(INDEX)
      RETURN
      END
C
C
C
      SUBROUTINE MAXABS(LX,X,XABS,INDEX)
      DIMENSION X(LX)
      INDEX=1
      DO 1 I=1,LX
      IF(ABS(X(I)).GT.ABS(X(INDEX))) INDEX=I
1     CONTINUE
      XABS=ABS(X(INDEX))
      RETURN
      END
C
C
C
      SUBROUTINE MOVE(LX,X,Y)
      DIMENSION X(LX),Y(LX)
      DO 1 I=1,LX
1     Y(I)=X(I)
      RETURN
      END
C
C
C
      SUBROUTINE RECEVH(MR,P,NTYPE,VP,VS,RCV)
C
C  Subroutine to compute the receiver functions (real values) for a receiver
C    on a half space.
C
C  Inputs:  MR - =3 for incident SV wave; =4 for incident SH wave; =5 for
C                   incident P wave
C           P - Ray parameter for ray
C           NTYPE - =1 for vertical component; =2 for radial component; =3
C                   for tangential component
C           VP - P velocity for surface layer
C           VS - S velocity for surface layer
C
C  Output:  RCV - Value of receiver function
C
      RCV=0.
      IF (MR.EQ.4) GO TO 50
      EA = CR(P,VP)
      EB = CR(P,VS)
C***Check to see if past a critical angle
      IF(EA.EQ.0.0.OR.EB.EQ.0.0) THEN
        IF(P.NE.0.0) THEN
C***Yes, we are past a critical angle.  Pass a dummy value back through RCV
           RCV=-99999.
           RETURN
        END IF
      END IF
      RP = (EB*EB - P*P)**2 + 4.*P*P*EB*EA
      RPB = RP*VS*VS
      IF (MR.EQ.3) GO TO 10
C***Compute receiver function for P waves
      IF (NTYPE.EQ.1) THEN
        SR = 2.*EA*(EB*EB - P*P)
       ELSE IF (NTYPE.EQ.2) THEN
        SR = -4.*EA*EB*P
       ELSE IF (NTYPE.EQ.3) THEN
        SR = 4.*EA*EB
       ELSE
        SR = 0.
      END IF
      RCV = SR / RPB
      RETURN
10    CONTINUE
C***Compute receiver function for SV waves
      IF (NTYPE.EQ.1) THEN
        SR = 4.*EA*EB*P
       ELSE IF (NTYPE.EQ.2) THEN
        SR = 2.*EB*(EB*EB - P*P)
       ELSE IF (NTYPE.EQ.3) THEN
        SR = -2.*EB*(EB*EB - P*P)/P
       ELSE
        SR = 0.
      END IF
      RCV = SR / RPB
      RETURN
50    CONTINUE
C***Compute receiver function for SH waves
      IF (NTYPE.EQ.2) THEN
        RCV = 2.
       ELSE IF (NTYPE.EQ.3) THEN
        RCV = 2.*P
       ELSE
        RCV = 0.
      END IF
      RETURN
      END
C
C
C
      FUNCTION CR(P,V)
C
C  Function to calculate ETA function (vertical slowness) of Helmberger
C    notation.
C
C  Inputs:  P - Ray parameter of ray
C           V - Velocity of ray
C
C  Output:  CR - SQRT(1/V**2 - P**2)
C
C  Note: this is a real valued version
C
      CR2 = 1./(V*V) - P*P
      IF (CR2.LE.0.) THEN
        CR = 0.
        RETURN
      END IF
      CR = SQRT(CR2)
      RETURN
      END
C
C
C
      SUBROUTINE DISPS(HMT,M,D)
C
C  Subroutine to compute a particular component of displacement from Greens
C    functions and moment tensor.
C
C  Inputs:  HMT(I) - Six-vector of Green's functions
C           M(I) - Six-vector of moment tensor elements, where M(I)
C                corresponds to HMT(I)
C
C  Output: D - Displacement from sum of Green's functions times moment tensor
C               elements
C
      REAL M(6),HMT(6),D
      D = 0.
      DO 1 J=1,6
1     D = D + HMT(J)*M(J)
      RETURN
      END
C
C
C
      SUBROUTINE FILDAT(NMAX,HEAD,NSTAT,SN,COMP,PS,R,AZ,AMP,IND,IUNIT)
C
C  Subroutine to read in and write out data for phase amplitude inversion
C    for moment tensor components.
C
C  Inputs:  NMAX - Maximum number of ampliutde readings allowed
C           HEAD - Header line describing event
C           NSTAT - Number of amplitude readings
C           SN(I) - Name of station for observation I
C           COMP(I) - Z, R, or T component of motion for observation I
C           PS(I) - Phase type (P, SV, or SH) for observation I
C           R(I) - Epicentral distance to station SN(I)
C           AZ(I) - Azimuth from north (in degrees) for station SN(I)
C           AMP(I) - Amplitude of ground motion in microns for station SN(I)
C           IND - is NEGATIVE if data is to be READ from the file
C                 is POSITIVE if data is to be WRITTEN to the file
C           IUNIT - Unit number to be assigned to file being opened for
C                     reading or writing
C
C  Output:  If IND is negative, NSTAT, SN, COMP, PS, R, AZ and AMP are all
C             read from the file and output from the subroutine.
C           If IND is positive, there is no output.
C
      CHARACTER*(*) SN(NMAX),PS(NMAX),COMP(NMAX),HEAD
      CHARACTER*40 FNAME
      DIMENSION R(NMAX),AZ(NMAX),AMP(NMAX)
1     FORMAT(A)
      IF (IND.GT.0) THEN
          IF (NSTAT.GT.NMAX) THEN
            WRITE(6,*)' Dimension of NMAX is too small, exit FILDAT'
            RETURN
          END IF
          WRITE(6,*)' Give name of FILE for WRITING DATA:'
          READ(5,1)FNAME
          OPEN(IUNIT,FILE=FNAME,STATUS='NEW',ERR=999)
          WRITE(IUNIT,1) HEAD
          WRITE(IUNIT,101) NSTAT
101   FORMAT(I5)
          DO 10 J=1,NSTAT
10        WRITE(IUNIT,102) SN(J),COMP(J),PS(J),R(J),AZ(J),AMP(J)
102   FORMAT(1X,A,1X,A,1X,A,1X,F6.2,4X,F7.2,3X,E12.4)
          CLOSE(IUNIT)
          RETURN
        ELSE
cjh          WRITE(6,*)' Give name of FILE for READING DATA:'
cjh          READ(5,1)FNAME
          fname='invrad.inp'
          OPEN(IUNIT,FILE=FNAME,STATUS='OLD',ERR=999)
          READ(IUNIT,1) HEAD
          READ(IUNIT,101) NSTAT
          IF (NSTAT.GT.NMAX) THEN
            CLOSE(IUNIT)
            NSTAT=0
            WRITE(6,*)' Dimension of NMAX is too small, exit FILDAT'
            RETURN
          END IF
          DO 20 J=1,NSTAT
20        READ(IUNIT,102)SN(J),COMP(J),PS(J),R(J),AZ(J),AMP(J)
          CLOSE(IUNIT)
          RETURN
      END IF
999   WRITE(6,902)
902   FORMAT('Error opening file in FILDAT, exit subroutine')
      RETURN
      END
C
C
C
      SUBROUTINE SCRDAT(NMAX,HEAD,NSTAT,SN,COMP,PS,R,AZ,AMP,IUNIT)
C
C  Subroutine to get amplitude data from screen and write to file for moment
C    tensor inversion program.
C
C  Inputs: NMAX - Maximum number of observations allowed
C          IUNIT - Unit number of file to be opened for storing data
C
C Outputs: HEAD - Header line describing event
C          NSTAT - Number of observations
C          SN(J) - Name of station for observation J
C          COMP(J) - Z, R, or T component of motion for observation J
C          PS(J) - P, SV or SH type of wave for observation J
C          R(J) - Epicentral distance to station SN(J)
C          AZ(J) - Azimuth to station SN(J)
C          AMP(J) - Amplitude observation in microns for station SN(J)
C
      DIMENSION R(NMAX),AZ(NMAX),AMP(NMAX)
      CHARACTER*(*) SN(NMAX),PS(NMAX),COMP(NMAX),HEAD
      CHARACTER*1 ANS
1     FORMAT(A)
      WRITE(6,*)' Give EVENT HEADER:'
      READ(5,1) HEAD
      DO 10 J=1,NMAX
      WRITE(6,*)' Give STA NAME, COMP(Z, R, or T), and WAVE TYPE (P, SV,
     * or SH)'
      WRITE(6,*)' Enter blanks to quit'
      WRITE(6,*)' Reenter STA NAME, COMP and WAVE TYPE to replace old or
     *incorrect data'
      WRITE(6,*)' Separate each entry by a space (STA NAME is 4 chars)'
      READ(5,2) SN(J),COMP(J),PS(J)
2     FORMAT(A,1X,A,1X,A)
      IF (SN(J).EQ.'    ') GO TO 900
      WRITE(6,*)' Give DIST, AZ, and AMP'
      READ(5,*) R(J),AZ(J),AMP(J)
      IF (J.GT.1) THEN
        DO 11 I=1,J-1
        IF (SN(J).EQ.SN(I).AND.COMP(J).EQ.COMP(I).AND.PS(J).EQ.PS(I))
     *   THEN
            R(I)=R(J)
            AZ(I)=AZ(J)
            AMP(I)=AMP(J)
c           J=J-1 ******masked 
            GO TO 10
        END IF
11      CONTINUE
      END IF
10    CONTINUE
900   IF(J.NE.NMAX+1) NSTAT=J-1
899   WRITE(6,*)' # STA C PS  DIST     AZ      AMP'
      DO 21 J=1,NSTAT
21    WRITE(6,201)J,SN(J),COMP(J),PS(J),R(J),AZ(J),AMP(J)
201   FORMAT(I2,1X,A,1X,A,1X,A,1X,F6.2,1X,F7.2,1X,E12.5)
      WRITE(6,*)' DELETE any data (Y or N)?'
      READ(5,1)ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
        WRITE(6,*)' Give # of data to be deleted:'
        READ(5,*) ND
        IF(ND.EQ.NSTAT) GO TO 23
        DO 22 J=ND,NSTAT-1
        SN(J)=SN(J+1)
        COMP(J)=COMP(J+1)
        PS(J)=PS(J+1)
        R(J)=R(J+1)
        AZ(J)=AZ(J+1)
22      AMP(J)=AMP(J+1)
23      NSTAT=NSTAT-1
        GO TO 899
      END IF
      CALL FILDAT(NMAX,HEAD,NSTAT,SN,COMP,PS,R,AZ,AMP,+1,IUNIT)
      RETURN
      END
C
C
C
      SUBROUTINE OUTALL(EMOM,SDEV,HEAD,NST,SN,COMP,PS,R,AZ,AMP,D,SMOM,
     * ST,DP,RK,IUNIT)
C
C  Subroutine to write out observed and calculated data from moment tensor
C    programs.
C
C  Inputs:  EMOM - Seismic moment of event, in units of 1 E16 dyne-cm
C           SDEV - Standard deviation of moment
C           HEAD - Header line describing event
C           NST - Number of amplitude readings
C           SN(I) - Name of station for observation I
C           COMP(I) - Z, R, or T component of motion for observation I
C           PS(I) - Phase type (P, SV, or SH) for observation I
C           R(I) - Epicentral distance to station SN(I)
C           AZ(I) - Azimuth from north (in degrees) for station SN(I)
C           AMP(I) - Amplitude of ground motion in microns for station SN(I)
C           D(I) - Calculated amplitude of ground motion in microns for SN(I)
C           SMOM(I) - Calculated moment in dyne-cm x E16 at station SN(I)
C           ST - Event strike
C           DP - Event dip
C           RK - Event rake
C           IUNIT - Unit number for output file
C
      CHARACTER*(*) SN(NST),COMP(NST),PS(NST),HEAD
      DIMENSION R(NST),AZ(NST),AMP(NST),D(NST),SMOM(NST)
      WRITE(IUNIT,1) HEAD
1     FORMAT(A)
      WRITE(6,1) HEAD
      WRITE(6,900)
      WRITE(IUNIT,900)
      WRITE(IUNIT,910) ST,DP,RK
      WRITE(6,910) ST,DP,RK
910   FORMAT('*** FOR STRIKE=',F7.2,'  DIP=',F6.2,'  RAKE=',F7.2,' ***')
      WRITE(6,901) EMOM,SDEV
      WRITE(IUNIT,901) EMOM,SDEV
901   FORMAT(' EVENT MOMENT=',F10.2,' +-',F10.2,' x E16 DYNE-CM')
      WRITE(6,900)
      WRITE(IUNIT,900)
900   FORMAT(' ')
      WRITE(6,902)
      WRITE(IUNIT,902)
902   FORMAT(' STA  C PS  DIST    AZ      AMP OBS      AMP CALC    MOM
     *x E16')
      DO 4 J=1,NST
      WRITE(6,903) SN(J),COMP(J),PS(J),R(J),AZ(J),AMP(J),D(J),SMOM(J)
      WRITE(IUNIT,903) SN(J),COMP(J),PS(J),R(J),AZ(J),AMP(J),D(J),
     *  SMOM(J)
903   FORMAT(1X,A,1X,A,1X,A,F6.2,1X,F7.2,1X,E12.5,1X,E12.5,1X,F10.2)
4     CONTINUE
      WRITE(IUNIT,900)
      WRITE(IUNIT,900)
      RETURN
      END
C
C
C
      SUBROUTINE OUTINV(EMOM,SDEV,HEAD,NST,SN,COMP,PS,R,AZ,AMP,D,DM0,
     * ST,DP,RK,ST1,DP1,RK1,SDST,SDDP,SDRK,ERRRMS,CLVDM,IUNIT)
C
C  Subroutine to write out observed and calculated data from moment tensor
C    inversion program.
C
C  Inputs:  EMOM - Seismic moment of event, in units of 1 E16 dyne-cm
C           SDEV - Standard deviation of moment
C           HEAD - Header line describing event
C           NST - Number of amplitude readings
C           SN(I) - Name of station for observation I
C           COMP(I) - Z, R, or T component of motion for observation I
C           PS(I) - Phase type (P, SV, or SH) for observation I
C           R(I) - Epicentral distance to station SN(I)
C           AZ(I) - Azimuth from north (in degrees) for station SN(I)
C           AMP(I) - Amplitude of ground motion in microns for station SN(I)
C           D(I) - Calculated amplitude of ground motion in microns for SN(I)
C           DM0(I) - Calc. amp. of ground motion in microns from original moment
C                    tensor solution
C           ST - Event strike
C           DP - Event dip
C           RK - Event rake
C           ST1 - Event strike (second possible plane)
C           DP1 - Event dip (second possible plane)
C           RK1 - Event rake (second possible plane)
C           SDST - Standard deviation of event strike
C           SDDP - Standard deviation of event dip
C           SDRK - Standard deviation of event rake
C           ERRRMS - RMS error of difference between calculated and observed
C                    amplitudes
C           CLVDM - Moment of compensated linear vector dipole component of
C                     moment tensor
C           IUNIT - Unit number for output file
C
      CHARACTER*(*) SN(NST),COMP(NST),PS(NST),HEAD
      DIMENSION R(NST),AZ(NST),AMP(NST),D(NST),DM0(NST)
      WRITE(IUNIT,1100)
1100  FORMAT(' Inversion results for:')
      WRITE(IUNIT,1) HEAD
1     FORMAT(A)
      WRITE(6,1) HEAD
      WRITE(6,900)
      WRITE(IUNIT,900)
      WRITE(IUNIT,910) ST,SDST,DP,SDDP,RK,SDRK
      WRITE(IUNIT,910) ST1,SDST,DP1,SDDP,RK1,SDRK
      WRITE(6,910) ST,SDST,DP,SDDP,RK,SDRK
      WRITE(6,910) ST1,SDST,DP1,SDDP,RK1,SDRK
910   FORMAT('STRIKE=',F7.2,' +-',F7.2,'  DIP=',F6.2,' +-',F6.2,'  RAKE=
     *',F7.2,' +-',F7.2)
      WRITE(6,901) EMOM,SDEV
      WRITE(IUNIT,901) EMOM,SDEV
901   FORMAT(' EVENT MOMENT=',F10.2,' +-',F10.2,' x E16 DYNE-CM')
      WRITE(IUNIT,921) CLVDM
      WRITE(6,921) CLVDM
921   FORMAT('    CLVD MOMENT FROM MOMENT TENSOR=',F10.2,' x E16 DYNE-CM
     *')
      WRITE(6,900)
      WRITE(IUNIT,900)
900   FORMAT(' ')
      WRITE(6,902)
      WRITE(IUNIT,902)
902   FORMAT(' STA  C PS  DIST    AZ      AMP OBS    MT AMP CALC
     *  DC AMP CALC')
      DO 4 J=1,NST
      WRITE(IUNIT,903) SN(J),COMP(J),PS(J),R(J),AZ(J),AMP(J),
     *DM0(J),D(J)
      WRITE(6,903) SN(J),COMP(J),PS(J),R(J),AZ(J),AMP(J),DM0(J),D(J)
903   FORMAT(1X,A,1X,A,1X,A,F6.2,1X,F7.2,1X,E12.5,1X,E12.5,1X,E12.5)
4     CONTINUE
C***Find the RMS error of the expected compared to the observed amplitudes
C   for the moment tensor result.
      RMSMT=0.
      DO 505 J=1,NST
505   RMSMT=RMSMT+(DM0(J)-AMP(J))*(DM0(J)-AMP(J))
      RMSMT=SQRT(RMSMT/NST)
C      WRITE(IUNIT,900)
      WRITE(6,900)
      WRITE(6,1102)RMSMT
      WRITE(IUNIT,1102)RMSMT
1102  FORMAT('  MT RMS error=',E12.5,' microns')
      WRITE(6,900)
      WRITE(6,1101)ERRRMS
      WRITE(IUNIT,1101) ERRRMS
1101  FORMAT('  DC RMS error=',E12.5,' microns')
C      WRITE(IUNIT,900)
      RETURN
      END
C
C
C
      SUBROUTINE SDRM0SD(SDDM,M0,ST,DP,RK,SDM0,SDST,SDDP,SDRK)
C  Subroutine to calculate the standard deviations of the strike, dip, rake
C    and seismic moment given the standard deviation of the moment tensor
C    elements.  This is all calculated from Langston, BSSA, 1981, p.1,
C    formulation.
C
C  Inputs:  SDDM - Vector array of moment tensor errors, as ordered in
C                  the formulation of Langston, 1981.
C           M0 - Calculated seismic moment of event
C           ST - Calculated strike of event in degrees
C           DP - Calculated dip of event in degrees
C           RK - Calculated rake of event in degrees
C
C  Outputs: SDM0 - Standard deviation of seismic moment
C           SDST - Standard deviation in degrees of fault strike
C           SDDP - Standard deviation in degrees of fault dip
C           SDRK - Standard deviation in degrees of fault rake
C
      DIMENSION SDDM(5),VECERR(4),G(5,4),GT(4,5),GTG(4,4)
      DIMENSION GINVLS(4,5),GINV(4,4)
      REAL M0
      PIBY180=3.14159265/180.
C***Form the tensor relating the errors in the strike, dip, rake and seismic
C     moment to the errors in the moment tensor elements.
      STSIN=SIN(ST*PIBY180)
      STCOS=COS(ST*PIBY180)
      ST2SIN=SIN(2.*ST*PIBY180)
      ST2COS=COS(2.*ST*PIBY180)
      DPSIN=SIN(DP*PIBY180)
      DPCOS=COS(DP*PIBY180)
      DP2SIN=SIN(2.*DP*PIBY180)
      DP2COS=COS(2.*DP*PIBY180)
      RKSIN=SIN(RK*PIBY180)
      RKCOS=COS(RK*PIBY180)
      G(1,1)=(2.*STSIN*STCOS*RKSIN*DP2SIN+2.*ST2COS*RKCOS*DPSIN)*M0
      G(1,2)=(STSIN*STSIN*RKCOS*DP2SIN-ST2SIN*RKSIN*DPSIN)*M0
      G(1,3)=(2.*STSIN*STSIN*RKSIN*DP2COS+ST2SIN*RKCOS*DPCOS)*M0
      G(1,4)=STSIN*STSIN*RKSIN*DP2SIN+ST2SIN*RKCOS*DPSIN
      G(2,1)=(-2.*STSIN*STCOS*RKSIN*DP2SIN-2.*ST2COS*RKCOS*DPSIN)*M0
      G(2,2)=(STCOS*STCOS*RKCOS*DP2SIN+ST2SIN*RKSIN*DPSIN)*M0
      G(2,3)=(2.*STCOS*STCOS*RKSIN*DP2COS-ST2SIN*RKCOS*DPCOS)*M0
      G(2,4)=STCOS*STCOS*RKSIN*DP2SIN-ST2SIN*RKCOS*DPSIN
      G(3,1)=(-ST2COS*RKSIN*DP2COS+2.*ST2SIN*RKCOS*DPSIN)*M0
      G(3,2)=(-.5*ST2SIN*RKCOS*DP2SIN+ST2COS*RKSIN*DPSIN)*M0
      G(3,3)=(-ST2SIN*RKSIN*DP2COS-ST2COS*RKCOS*DPCOS)*M0
      G(3,4)=-.5*ST2SIN*RKSIN*DP2SIN-ST2COS*RKCOS*DPSIN
      G(4,1)=(-STSIN*RKCOS*DPCOS+STCOS*RKSIN*DP2COS)*M0
      G(4,2)=(-STCOS*RKSIN*DPCOS+STSIN*RKCOS*DP2COS)*M0
      G(4,3)=(-STCOS*RKCOS*DPSIN-2.*STSIN*RKSIN*DP2SIN)*M0
      G(4,4)=STCOS*RKCOS*DPCOS+STSIN*RKSIN*DP2COS
      G(5,1)=(STSIN*RKSIN*DP2COS+STCOS*RKCOS*DPCOS)*M0
      G(5,2)=(-STCOS*RKCOS*DP2COS-STSIN*RKSIN*DPCOS)*M0
      G(5,3)=(2.*STCOS*RKSIN*DP2SIN-STSIN*RKCOS*DPSIN)*M0
      G(5,4)=-STCOS*RKSIN*DP2COS+STSIN*RKCOS*DPCOS
C***Multiply G matrix by -1 to change from Langston to Aki&Richards formula-
C     tion
      DO 22 JJ=1,4
      DO 22 II=1,5
22    G(II,JJ)=-G(II,JJ)
C***Form G transpose and multiply into G
      CALL TRANSP(5,4,G,GT)
      CALL MATMULT(4,5,GT,4,G,GTG)
C***Form the inverse of G transpose times G and then multiply into G transpose
      CALL MAINE(4,GTG,GINV)
      CALL MATMULT(4,4,GINV,5,GT,GINVLS)
C***Get the solution vector
      CALL MATMULT(4,5,GINVLS,1,SDDM,VECERR)
C***Sort out the components and exit subroutine
      SDM0=ABS(VECERR(4))
      SDST=ABS(VECERR(1))/PIBY180
      SDDP=ABS(VECERR(3))/PIBY180
      SDRK=ABS(VECERR(2))/PIBY180
      RETURN
      END
C
C
C
      SUBROUTINE ATA(N,M,A,ATAM)
C  Subroutine to calculate the matrix product A transpose times A where
C     A is a real, second order matrix
C
C  Inputs:  A - Real matrix with N rows and M columns
C
C  Output:  ATAM - Output matrix product A transpose times A
C
      DIMENSION A(N,M),ATAM(M,M)
      CALL ZERO(M*M,ATAM)
      DO 1 J=1,M
      DO 1 I=J,M
      DO 2 K=1,N
2     ATAM(J,I)=ATAM(J,I)+A(K,J)*A(K,I)
1     ATAM(I,J)=ATAM(J,I)
      RETURN
      END
C
C
C
      SUBROUTINE CLSPCK(NMAX,MMAX,A,N,M)
C  Subroutine to close pack a two dimension array.  The purpose of it
C    is to eliminate the zeros between non-zero elements due to the use
C    of an array which is smaller than the maximum dimensions specified
C    in the dimension statement.
C
C  Inputs:  A - Array with maximum dimensions of NMAX rows and MMAX columns
C                 to be close packed in storage as an array with N rows
C                 and M columns.
C
      DIMENSION A(NMAX,MMAX)
      L=1
      K=N
      DO 1 J=2,M
      DO 1 I=1,N
      K=K+1
      IF(K.GT.NMAX) THEN
         L=L+1
         K=1
      END IF
1     A(K,L)=A(I,J)
      NLEFT=NMAX*MMAX-N*M
      CALL ZERO(NLEFT,A(K+1,L))
      RETURN
      END
C
C
C
      SUBROUTINE OPNPCK(NMAX,MMAX,A,N,M)
C  Subroutine to open pack a two dimension array.  The purpose of it
C    is to put in the zeros between non-zero elements due to the use
C    of an array which is smaller than the maximum dimensions specified
C    in the dimension statement.
C
C  Inputs:  A - Array with dimensions of N rows and M columns
C                 to be open packed in storage as an array with NMAX row
C                 and MMAX columns.
C
      DIMENSION A(NMAX,MMAX)
      L=M*N/NMAX+1
      K=MOD(N*M,NMAX)+1
      DO 1 J=M,2,-1
        DO 2 II=NMAX,N+1,-1
2       A(II,J)=0.
      DO 1 I=N,1,-1
      K=K-1
      IF(K.EQ.0) THEN
         L=L-1
         K=NMAX
      END IF
1     A(I,J)=A(K,L)
      DO 3 II=NMAX,N+1,-1
3     A(II,1)=0.
      RETURN
      END
C
C
C
      SUBROUTINE TRANSP(N,M,A,AT)
C  Subroutine to calculate the transpose of a second order real matrix
C
C  Inputs:  A - Real matrix of N rows and M columns to be transposed
C
C  Ouptuts: AT - Transpose of A
C
      DIMENSION A(N,M),AT(M,N)
      DO 1 J=1,N
      DO 1 I=1,M
1     AT(I,J)=A(J,I)
      RETURN
      END
C
C
C
      SUBROUTINE MATMULT(NA,MA,A,MB,B,C)
C  Subroutine to form the matrix product of A times B to get matrix C,
C    where A, B, and C are real matrices.
C
C  Inputs:  A - Left-hand matrix in the multiplication with NA rows
C                 and MA columns
C           B - Right-hand matrix in the multiplication with MA rows and MB
C                columns
C
C  Outputs: C - Product of A times B with NA rows and MB columns
C
      DIMENSION A(NA,MA),B(MA,MB),C(NA,MB)
      CALL ZERO(NA*MB,C)
      DO 1 J=1,NA
      DO 1 I=1,MB
      DO 2 K=1,MA
2     C(J,I)=C(J,I) + A(J,K)*B(K,I)
1     CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE GENINV(N,M,G,DAT,DM,RESM,RESD,VARM)
C  Subroutine to use a generalized inverse to calculate the solution M of
C    the vector equation D = G times M where D is a data vector, G is
C    usually a derivative matrix, and M is the model vector.
C
C  Inputs:  G - Matrix with N rows and M columns which relates D to M.
C                 G is often the derivative matrix dDi/dMj.
C           DAT - Column vector of length N of data points (observations)
C
C  Outputs: DM - Column vector of model parameters of length M found using
C                 the generalized inverse
C           RESM - Resolution matrix of M rows and M columns which shows the
C                   independence of the model parameters found in the
C                   inversion
C           RESD - Resolution matrix of N rows and N columns which shows the
C                   independence of the data parameters used in the inversion
C           VARM - Column vector of length M which contains the variance
C                  values of the model parameters.  VARM(I) corresponds to
C                  DM(I).  The subroutine assumes that the variances of all
C                  the input data are independent and equal as in Aki&
C                  Richards eq 12.107 ff.  The values of VARM are normalized
C                  to unit data variance, and only the diagonal elements of
C                  the variance matrix are found (i.e. the cross terms are
C                  not calculated).
C
C  Based on Aki&Richards section 12.3.
C
      DIMENSION G(N,M),DAT(N),DM(M),RESM(M,M),RESD(N,N),VARM(M)
      DIMENSION GTEMP(400),D(20),V(400),GINV(400),GINVP(400)
      DIMENSION U(400),UPT(400)
C***The subroutine is set up presently for maximum dimensions of 20 for N
C     and 20 for M.  If these must be changed, adjust the next two statements
C     and the corresponding dimensions in the DIMENSION statements above
C     The values in the DIMENSION statements above are either MM or MM*MM
C     where MM is the larger of NMAX or MMAX.
C     Also please change the values in this comment statement.
      NMAX=20
      MMAX=20
      IF(N.GT.NMAX.OR.M.GT.MMAX) THEN
         WRITE(6,*)' Array dimensions in GENINV too small, exit subrouti
     *ne!'
         RETURN
      END IF
C
C  Start finding the solution for the generalized inverse
C
C***Form the matrix G transpose times G
      CALL ATA(N,M,G,GTEMP)
C***Find the eigenvalues for G transpose times G.
      CALL JACOBI(M,GTEMP,D,V,NROT)
C***Look for zero eigenvalues.  If none, use Least-squares inverse.
      DO 10 J=1,M
10    IF(D(J).EQ.0.0) GO TO 500
C***All eigenvalues are non-zero, use Least-squares inverse (no damping at
C     present).
      CALL MAINE(M,GTEMP,GINV)
      CALL TRANSP(N,M,G,GTEMP)
      CALL MATMULT(M,M,GINV,N,GTEMP,GINVP)
      GO TO 900
C***The problem is underdetermined, use the generalized inverse
500   CONTINUE
      K=0
      DO 501 J=1,M
      IF(D(J).EQ.0.) GO TO 501
      K=K+1   !  Count the number of non-zero eigenvalues
      EIGEN=1./SQRT(D(J))
C***Form the Vp times LAMBDA inverse matrix
      DO 502 I=1,M
502   GTEMP((K-1)*M+I)=V((J-1)*M+I)*EIGEN
C***Find a row of the Up transpose matrix
      CALL MATMULT(N,M,G,1,V((J-1)*M+1),U((K-1)*M+1))
      CALL RESCALE(EIGEN,N,U((K-1)*M+1))
501   CONTINUE
C***Form Up transpose
      CALL TRANSP(N,K,U,UPT)
C***Form the generalized inverse matrix
      CALL MATMULT(M,K,GTEMP,N,UPT,GINVP)
900   CONTINUE
C***Get the solution vector
      CALL MATMULT(M,N,GINVP,1,DAT,DM)
C***Get the model resolution matrix
      CALL MATMULT(M,N,GINVP,M,G,RESM)
C***Get the data resolution matrix
      CALL MATMULT(N,M,G,N,GINVP,RESD)
C***Get the normalized variance of the model parameters.  These must be
C     multiplied by the variance of the observations to get the true
C     variance of the model parameters.
C     Note:  This only gets the diagonal elements of the variance matrix
C     and does not compute the cross terms.  See A&R eq. 12.107.
      DO 901 J=1,M
      VARM(J)=0.
      DO 901 I=1,N
901   VARM(J)=VARM(J)+GINVP((I-1)*M+J)*GINVP((I-1)*M+J)
      RETURN
      END
C
C
C
      SUBROUTINE NORMEN(LX,X)
      DIMENSION X(LX)
      E=0.
      DO 10 I=1,LX
10    E=E+X(I)*X(I)
      E=SQRT(E)
      DO 20 I=1,LX
20    X(I)=X(I)/E
      RETURN
      END
C
C
C
      SUBROUTINE RESCALE(S,LX,X)
      DIMENSION X(LX)
      DO 1 I=1,LX
1     X(I)=S*X(I)
      RETURN
      END
C
C
C
      SUBROUTINE JACOBI(N,A,D,V,NROT)
C
C  Subroutine to find all of the eigenvalues and eigenvectors of the
C    N by N real, symmetric matrix A by Jacobi's method.  N must be less
C    than or equal to 50 (determined by the dimensions of B and Z below)
C    The unordered eigenvalues are returned in real N vector D and the
C    corresponding eigenvectors are in the respective columns of N by N
C    real matrix V.  The number of Jacobi rotations needed are returned
C    in NROT.  Taken from LINEAR ALGEBRA, volume II, by Wilkinson and
C    Reinsch, 1971, Springer-Verlag.  The algorithm is published (in
C    ALGOL) by H. Rutishauser on pages 202-211.  Converted to FORTRAN by
C    R. Buland, 30 Oct., 1978.
C
      INTEGER P,Q,P1,P2,Q1,Q2
      DIMENSION A(N,N),D(N),V(N,N),B(50),Z(50)
      N1=N-1
      NN=N*N
C***Initialize the storage array
      DO 1 P=1,N
      DO 2 Q=1,N
2     V(P,Q)=0.
      V(P,P)=1.
      B(P)=A(P,P)
      D(P)=B(P)
1     Z(P)=0.
      NROT=0
C***Make up to 50 passes rotating each off-diagonal element.
      DO 3 I=1,50
      SM=0.
      DO 4 P=1,N1
      P1=P+1
      DO 4 Q=P1,N
4     SM=SM+ABS(A(P,Q))
C***Exit if all off-diagonal elements have underflowed.
      IF (SM.EQ.0.) GO TO 13
      TRESH=0.
      IF (I.LT.4) TRESH=.2*SM/NN
C***Loop over each off-diagonal element
      DO 5 P=1,N1
      P1=P+1
      P2=P-1
      DO 5 Q=P1,N
      Q1=Q+1
      Q2=Q-1
      G=100.*ABS(A(P,Q))
C***Skip this element if it has already underflowed.
      IF((I.LE.4).OR.(ABS(D(P))+G.NE.ABS(D(P))).OR.
     1  (ABS(D(Q))+G.NE.ABS(D(Q)))) GO TO 6
      A(P,Q)=0.
      GO TO 5
6     IF(ABS(A(P,Q)).LE.TRESH) GO TO 5
C***Compute the rotation.
      H=D(Q)-D(P)
      IF(ABS(H)+G.EQ.ABS(H)) GO TO 7
      THETA=.5*H/A(P,Q)
      T=1./(ABS(THETA)+SQRT(1.+THETA*THETA))
      IF (THETA.LT.0.) T=-T
      GO TO 14
7     T=A(P,Q)/H
14    C=1./SQRT(1.+T*T)
      S=T*C
      TAU=S/(1.+C)
C***Rotate the diagonal.
      H=T*A(P,Q)
      Z(P)=Z(P)-H
      Z(Q)=Z(Q)+H
      D(P)=D(P)-H
      D(Q)=D(Q)+H
      A(P,Q)=0.
C***Rotate the off diagonal.  Note that only the upper-diagonal
C      elements are touched.  This allows the recovery of matrix A later.
      IF(P2.LT.1) GO TO 15
      DO 8 J=1,P2
      G=A(J,P)
      H=A(J,Q)
      A(J,P)=G-S*(H+G*TAU)
8     A(J,Q)=H+S*(G-H*TAU)
15    IF(Q2.LT.P1) GO TO 16
      DO 9 J=P1,Q2
      G=A(P,J)
      H=A(J,Q)
      A(P,J)=G-S*(H+G*TAU)
9     A(J,Q)=H+S*(G-H*TAU)
16    IF(N.LT.Q1) GO TO 17
      DO 10 J=Q1,N
      G=A(P,J)
      H=A(Q,J)
      A(P,J)=G-S*(H+G*TAU)
10    A(Q,J)=H+S*(G-H*TAU)
C***Rotate the eigenvector matrix.
17    DO 11 J=1,N
      G=V(J,P)
      H=V(J,Q)
      V(J,P)=G-S*(H+G*TAU)
11    V(J,Q)=H+S*(G-H*TAU)
      NROT=NROT+1
5     CONTINUE
C***Reset the temporary storage for the next rotation pass.
      DO 3 P=1,N
      D(P)=B(P)+Z(P)
      B(P)=D(P)
3     Z(P)=0.
C***All finished.  Prepare for exiting by reconstructing the upper
C     triangle of A from the untouched lower triangle.
13    DO 12 P=1,N1
      P1=P+1
      DO 12 Q=P1,N
12    A(P,Q)=A(Q,P)
      RETURN
      END
C
C
C
      SUBROUTINE ZERO(LX,X)
      DIMENSION X(LX)
      IF(LX.LE.0) RETURN
      DO 1 J=1,LX
1     X(J)=0.
      RETURN
      END
C
C
C
      SUBROUTINE MAINE(N,A,B)
      DIMENSION A(N,N),B(N,N)
      DO 5 I=1,N
      DO 5 J=1,N
5     B(I,J)=0.0
      B(1,1)=1./A(1,1)
      IF(N.EQ.1) RETURN
      DO 40 M=2,N
      K=M-1
      EK=A(M,M)
      DO 10 I=1,K
      DO 10 J=1,K
10    EK=EK-A(M,I)*B(I,J)*A(J,M)
      B(M,M)=1./EK
      DO 30 I=1,K
      DO 20 J=1,K
20    B(I,M)=B(I,M)-B(I,J)*A(J,M)/EK
30    B(M,I)=B(I,M)
      DO 40 I=1,K
      DO 40 J=1,K
40    B(I,J)=B(I,J)+B(I,M)*B(M,J)*EK
      RETURN
      END
C
C
C
      SUBROUTINE ZEROI(LX,IX)
      DIMENSION IX(LX)
      IF(LX.LE.0) RETURN
      DO 1 J=1,LX
1     IX(J)=0
      RETURN
      END
C
C
C
      SUBROUTINE DCDERIV(ST,DP,RK,M0,NSTAT,G,GDER)
C  Subroutine to calculate the derivative matrix for a double-couple source
C    given the starting strike, dip, rake and seismic moment.  All of this
C    uses the moment tensor formulation of Barker & Langston, GJRAS,
C    1982, p 777 and from Langston, BSSA, 1981, p 1.  All moment tensor
C    derivative components have been multiplied by -1 to be compatible
C    with the A&R coordinate system (see subroutine SDTOM).
C
C  Inputs:  G - Tensor array of Greens functions for each station.  Column
C            number i of G(i,j) has the 5 Greens functions of Langston, BSSA,
C            1981, p 1 for station j.  The dimensions of G are 5 by NSTAT.
C           M0 - Calculated seismic moment of event
C           ST - Calculated strike of event in degrees
C           DP - Calculated dip of event in degrees
C           RK - Calculated rake of event in degrees
C           NSTAT - Number of station observations in data set
C
C  Output: GDER - Matrix of NSTAT rows by 4 columns where the first column
C           contains the derivatives with respect to the fault strike,
C           the second column contains the derivatives with respect to the
C           fault dip, the third row contains the derivatives with respect
C           to the fault rake, and the fourth row contains the
C           derivatives with respect to the moment.  Row i correpsonds tO
C           station i as ordered in the G matrix.
C
      DIMENSION G(5,NSTAT),GDER(NSTAT,4)
      REAL M0
      PIBY180=3.14159265/180.
C***Form the tensor relating the errors in the strike, dip, rake and seismic
C     moment to the errors in the moment tensor elements.
      STSIN=SIN(ST*PIBY180)
      STCOS=COS(ST*PIBY180)
      ST2SIN=SIN(2.*ST*PIBY180)
      ST2COS=COS(2.*ST*PIBY180)
      DPSIN=SIN(DP*PIBY180)
      DPCOS=COS(DP*PIBY180)
      DP2SIN=SIN(2.*DP*PIBY180)
      DP2COS=COS(2.*DP*PIBY180)
      RKSIN=SIN(RK*PIBY180)
      RKCOS=COS(RK*PIBY180)
      DO 100 J=1,NSTAT
      DST1=(2.*STSIN*STCOS*RKSIN*DP2SIN+2.*ST2COS*RKCOS*DPSIN)*M0
      DRK1=(STSIN*STSIN*RKCOS*DP2SIN-ST2SIN*RKSIN*DPSIN)*M0
      DDP1=(2.*STSIN*STSIN*RKSIN*DP2COS+ST2SIN*RKCOS*DPCOS)*M0
      DM01=STSIN*STSIN*RKSIN*DP2SIN+ST2SIN*RKCOS*DPSIN
      DST2=(-2.*STSIN*STCOS*RKSIN*DP2SIN-2.*ST2COS*RKCOS*DPSIN)*M0
      DRK2=(STCOS*STCOS*RKCOS*DP2SIN+ST2SIN*RKSIN*DPSIN)*M0
      DDP2=(2.*STCOS*STCOS*RKSIN*DP2COS-ST2SIN*RKCOS*DPCOS)*M0
      DM02=STCOS*STCOS*RKSIN*DP2SIN-ST2SIN*RKCOS*DPSIN
      DST3=(-ST2COS*RKSIN*DP2COS+2.*ST2SIN*RKCOS*DPSIN)*M0
      DRK3=(-.5*ST2SIN*RKCOS*DP2SIN+ST2COS*RKSIN*DPSIN)*M0
      DDP3=(-ST2SIN*RKSIN*DP2COS-ST2COS*RKCOS*DPCOS)*M0
      DM03=-.5*ST2SIN*RKSIN*DP2SIN-ST2COS*RKCOS*DPSIN
      DST4=(-STSIN*RKCOS*DPCOS+STCOS*RKSIN*DP2COS)*M0
      DRK4=(-STCOS*RKSIN*DPCOS+STSIN*RKCOS*DP2COS)*M0
      DDP4=(-STCOS*RKCOS*DPSIN-2.*STSIN*RKSIN*DP2SIN)*M0
      DM04=STCOS*RKCOS*DPCOS+STSIN*RKSIN*DP2COS
      DST5=(STSIN*RKSIN*DP2COS+STCOS*RKCOS*DPCOS)*M0
      DRK5=(-STCOS*RKCOS*DP2COS-STSIN*RKSIN*DPCOS)*M0
      DDP5=(2.*STCOS*RKSIN*DP2SIN-STSIN*RKCOS*DPSIN)*M0
      DM05=-STCOS*RKSIN*DP2COS+STSIN*RKCOS*DPCOS
      GDER(J,1)=G(1,J)*DST1+G(2,J)*DST2+G(3,J)*DST3+G(4,J)*DST4+G(5,J)
     &*DST5
      GDER(J,1)=-GDER(J,1)
      GDER(J,2)=G(1,J)*DDP1+G(2,J)*DDP2+G(3,J)*DDP3+G(4,J)*DDP4+G(5,J)
     &*DDP5
      GDER(J,2)=-GDER(J,2)
      GDER(J,3)=G(1,J)*DRK1+G(2,J)*DRK2+G(3,J)*DRK3+G(4,J)*DRK4+G(5,J)
     &*DRK5
      GDER(J,3)=-GDER(J,3)
      GDER(J,4)=G(1,J)*DM01+G(2,J)*DM02+G(3,J)*DM03+G(4,J)*DM04+G(5,J)
     &*DM05
      GDER(J,4)=-GDER(J,4)
100   CONTINUE
      RETURN
      END
C
C
C
      SUBROUTINE NEWTDIF(N,XI,YI,X,Y)
C
C  Subroutine to perform Newton Divided Difference interpolation of unequally
C   spaced data.
C
C  Inputs:  N - Number of input pairs XI and YI along curve to be inter-
C               polated
C           XI - Array of independent coordinate values along curve to
C                be interpolated (must be in ascending order)
C           YI - Array of dependent coordinate values along curve to be
C                interpolated.  Each YI(J) corresponds to XI(J)
C           X - Independent coordinate at which function is to be evaluated
C
C  Output: Y - Interpolated value of X
C
      DIMENSION XI(*), YI(*)
      DIMENSION DELTAR(10)
      NTEMP=10
C***A maximum of 10 values can be used at the present time.  To increase
C    the number of points being used in the interpolation, change the
C    number 10 in the previous two lines and in this comment and recompile.
      NN=N
      IF (NN.GT.NTEMP) THEN
         WRITE(6,1) NTEMP
1        FORMAT(' WARNING, ONLY ',I2,' TERMS WILL BE USED FOR INTERPOL
     *ATION!')
         NN = NTEMP
      ENDIF
C***Form the divided differences
      DO 10 J=1, NN
10    DELTAR(J) = YI(J)
      XDIF = 1.
      Y = YI(1)
      DO 20 J=1, NN-1
         DO 30 I=1, NN-J
30       DELTAR(I) = (DELTAR(I+1) - DELTAR(I)) / (XI(I+J) - XI(I))
      XDIF = (X - XI(J)) * XDIF
20    Y = Y + XDIF * DELTAR(1)
      RETURN
      END

cSTART**************************************************************************
C      PROGRAM SELECT
c
c
c  arguments: If only one argument, it is name of select.inp parameter
c             file. If several arguments (at least 3), all inputs via
c             arguments. The arguments are:
c 
c             -base   : 5 letter data base 
c             -seisweb: if set, input from seisweb, output to seisweb
c             -time   : time interval
c             -web_out: complete path to where data is placed, only
c                        active if seisweb set. 3 filers made: 
c                       web_out.id  : id's, like index.out without # 
c                       web_out.all : like select.out
c                       web_out.head: header lines
c             -area   : lat-lon grid, minlat,maxlat,minlon,maxlon
c             -depth  : depth range, mindepth,maxdepth
c             -mag    : magnitude range, minmag,maxmag
c             -nstat  : range of number of stations, min,max
c             -gap    : range of gap, min,max
c             -rms    : range of rms, min,max
c             -mgtypes  : up to 5 mag types, one string
c             -disttype : -------dist------------------
c             -eventtype: ------event------------------
  
C
C     WRITTEN BY:   C. LINDHOLM
C     MODIFIED BY : J. HAVSKOV
C     LAST REVISED: AUGUST 18, 1987
C     LAST REVISED: DEC 20, 1988.  POSSIBILITY TO RUN ON COMPACT FILES INCLUDED
C     LAST REVISED: jan 6, 1988.  POSSIBILITY TO RUN EVENTS WITH
C                                 DISTANCEID=BLANK
C     LAST REVISED  APRIL 19 -89  POSSIBILITY RUN ON DATABASE INCLUDED
C
C                   1990-01-30,R.N.ARVIDSSON, TO PC-DOS
C     LAST REVISED  1990-01-30,RNA, COMMON BLOCK STRUCTURE CHANGED BECAUSE
C                                   IT IS NOT POSSIBLE TO MIX CHARACTERS
C                                   WITH INTEGER TYPES.
C                   1990-02-16,RNA, COMMON BLOCK STRUCTURE AGAIN THE SAME
c                                   PROBLEM.
C                   1990-02-22,RNA, FILENR.LIS OPTION REMOVED
C                   JUL 27, 90, JH, MAJOR REVISION
C                   AUG 2   90  J.H BUGS
C                       6           BUGS
C                      17           REMOVE REFERENCE TO DCL
c                      24           back to vax, card from 120 to 140 chars
C                   OCT 18  90   J.H: MULTIPLE DATA BASE OPTION
c                   nov 19  90      : I5 for event number in index file
c                   sep 19  91   jh : include call to topdirectory
c                   oct 07          : pc adoption, see vax comments, 12 char time
c                                     main data base is rea not base
c                   nov 4           : findev.. to find_ev...
c                   nov 24          : new version of indata, some clean up
C                   AUG 18, 92    JH: NEW SELECT ON EVENT TYPE
c                   sep 15 92       : select on earthquakes (q) and magnitude type
c                   oct 7,12        : bug with magnitude selection
C                   OCT 29          : ADD OUTPUT OF WAVEFORM FILE NAMES
c                   oct6 30         : bug
c                   nov 15          : check for wrong header lines in episel
C                   MAR 25, 93      : BUG WITH MAG SELECTION
c                   jul 93 by jh    : version 3.0*******************************
c                                     REA to agency, EPI to CAT
c                   aug 20          : bug in episelect when one file only
c                                   : filenames to 80
c                                   : bug with station selection
c                   sep 10          : bug with filnr.lis on pc, put null char
c                   sep 17          : bug wirht index file open, more info
c                       18          : do not select non locate deqs, select no mags
c                       22          ; neg rms means larger than for rms
c                   dec 29          : split question about nag and rms
c                   mar 2, 94       : bug when reading mag-rms limits
c                   mar 21 94       : make filenr.lis in local dir
c                   may 31 94       : write out number of events selected, each
c                                     new data base file
c                   nov 07,94 by Carlos Eduardo Vieira
c                                     routine SELCRIT changed allowing
c                                     choose which defaults are going to be
c                                     changed using menu (routine DRAW_SCREEN)
C!JAB(BGS)Nov94                     : Installed file & error handling (libsei)
c
c                  dec 94           : ********** version 5.0 ****************
c                  dec 13           : last check
c                  jan 11   95 jh   : new call to get base
c                  feb 7            : also use lolat and lolon in def
c                  feb16            : make index file also when searching in
c                                     a file
c                  apr 5    95 jh   : fix selection when no magnitude type
c                  may 8            : bog in above
c                  may 11   95      : select any event types
c                  may 15           : use actual number of station if event file
c                                     instead of number in header
c                  dec 7 95 jh      : if selecting in a file, do not stop if
c                                     data is not in chronological order
c                  feb 8 96         : possible to select in all header lines
c                  feb 16           : fix error limits for hypocneter errors,
c                  feb 20           : put in waveform file select
c                  mar 4 96         : bug
c                  june 10, 96      : do not use event type to make file name
c                                     from a second header line
c                  oct 25, 96       : stop if no data in data base
c                  dec 96           : do not use filenr.lis
c                  feb 27   97      : bug in above
c                  mar 25           : bug in magnitude selection
c                  jan 13, 98       : use century as default,  ***year 2000***
c                                     and a few more improvements
c------------------------------------------------------------------------------
c                  oct-nov 98 by jh :  version 7.0 check, commands input file
c                  jan 99 by bmt    :  initialization of magtypest,disttypet,eventtypet 
c                  jun 16 99 jh     : select.cmd to selec.inp
c                  aug 18,99        :  selection for gap
c                  aug 22,99        : selection for epicenter distance
c                  sep 7            : bug with gap selection
c                  sep 14           : bug with magnitude agency in select.inp
c                                     hypocenter agency
c
c                  sep 22           : bug with start in year 2000
c                  oct 18           : for polarity selection, only select if
c                                     polarity is for P, do not use + and -
c                  oct 21           : century selection wrong, combinaitons
c                                     gap and other not exclusive
c jan 13, 2000 jh : another year 2000 problem, end date not found if after
c                   year 2000, thanks fernando
c mar 13       jh : input with prompt
c mar 22            more of the above
c may 11       jh : always stop if wrong time interval
c nov 8           : do not write out in index file if input form a file,
c                   allow filenames shorter than 6 if containing a .
c jan 10, 2001 lo : init seisweb, since true on Linux
c mar 5   2001 jh : distance to real
c mar 08  2001 lo : change in default area setting
c apr 30  2001 jh : select by phase, individually and by station
c may 10          : distce acan be either epicentral or hypocentral
c may 25          : select did not work with negative magnitudes !!!!!!!
c jun 25          : comment change
c jul 5           : fix so distance type and mag types do not cance each
c                   other, seems to only be a display problem
c nov 7   2001 bm : now can use output file given in the prompt line after 
c                   given "select.inp" (make same output like SEISWEB command)
c                   e.i. select  select.inp  select.out
c nov 7   2001 bm : clear the output file when nothing is found
c nov 23       jh : bug: station selection did not non located events
c mar20           : option to use s-files
c apr 15          : bug in above, did not work with select.inp
c aug 22  2002 jh : select stations, even when all have weight 4
c sep 12  2002 lo : select volcanic sub-classes
c apr 22  2003 jh : small format change
c may 27          : wavefor.out to waveform_names.out
c sep 11  2003 jh : increase fild for number of evets
c feb 20  2007 jh : header_check was not initilized so all headers were
c                   always checked
c sep 30  2008 jh : blank input of time is now between 1980 and 2015
c
      IMPLICIT NONE
      include 'seidim.inc'        ! dimensions
      integer seiclen             ! function
      CHARACTER*1 DISTANCEID,EXP,EVENTID,DEPTHID,MAGTYPES(5),
     *DISTTYPE(5),EVENTTYPE(5),magtype
      character*6 volcanictype(10)   ! volcanic subclasses
      character*3 AGENCY,MAGAGENCY
      CHARACTER*80 DATA(max_data)
      character*80 web_out           ! path and file name for web output
      character*6 basetype           ! type of base CAT or sfile
      logical seisweb                ! true if call from seisweb
      integer narg                   ! number fo arguments
      INTEGER NRECORD,NHEAD
c-- see subroutine find...       
      integer		status,new_month,fstart,event_no 
c-- select key                                       
      character*10     key
c-- event file name                                   
      character*80	evfile
      character*80 choise_file       ! file with choises, none if blank
      integer max_cat_files          ! maximum number of cat files
      real dist                      ! epicentral distance
      parameter(max_cat_files=2000)
      character*80 cat_files(max_cat_files)   ! cat file nemes
      integer ncat_files             ! number of cat_files
C  NUMBER OF STATIONS TO BE PRESENT AND number of stations for event
      INTEGER		stat_present,NSTAT
      logical       all_stat         ! if true,  all must be present
c  number of hypocenter agencies present
      integer           hypa_present
c  number of magnitude agencies present
      integer           maga_present
C  NUMBER OF PHASES FOR ONE EVENT
      INTEGER NPHASE	  
c  id line number
      integer id
C  1: EVENT CONTAIN REQ. STATION, 0: NO
      INTEGER		STATIONOK	
C  STATIONS CODES TO SELCT BY
      CHARACTER*7	STATSELECT(50)
      character*4       stat_phase(50)  ! phases to select with stations
      integer mindist(50),maxdist(50)   ! distance range for station 
      logical hyp_dist                  ! if true, use hypocentral distance
c  hypocenter agencies
      character*3       hypaselect(10)
c  magnitude agencies
      character*3       magaselect(10)
C  ONE STATION CODE and component
      CHARACTER*7	STATIONCODE	
C  INPUT FILE NAME IN DATA BASE 
      CHARACTER*80	SFILE
C  Name of database
      CHARACTER*80	basename
      character*5 agency_loc
c  first and last file in data base
C  starttime for processing data
      CHARACTER*14      starttime
c  century
      CHARACTER*14	endtime
C  NUMBER OF EVENTS IN FILES
      INTEGER		NEVENT		
C  NUMBER OF LOCAL EVENTS IN FILES
      INTEGER		NLOCAL		
C  NUMBER OF REGIONAL EVENTS IN FILES
      INTEGER		NREGIONAL	
C  NUMBER OF DISTANT EVENTS IN FILES
      INTEGER		NDISTANT	
C  NUMBER OF LOC. AND REG. EVENTS SELECTED
      INTEGER           NOUT		
C  NUMBER OF WAVEFORM FILES
      INTEGER NWAVE
c  number of indexes out
      integer nid
c  end and start of time indicator 
      logical end_of_time,start_of_time
c  logical to indicate compact file  
      logical compact
c  logical to indicate fault plane solution found
      logical fpsolutf
c  logical to indicate earthquake felt found
      logical eqfeltf
c  logical to indicate hypocenter error latitude found
      logical helatf
c  logical to indicate hypocenter error longitude found
      logical helonf
c  logical to indicate hypocenter error depth found
      logical hedepthf
c  variable reading from the file
      real filevar
C  OPTION OF INPUT
      INTEGER           inputoption
C  COUNTERS
      integer		j,i,k,n
C  SELECTION CRITERIAS: LATITUDE, LONGITUDE, MAGNITUDE, DEPTH, MAX AND MIN RMS
C                       MAX AND MIN HYPOCENTER ERROR LAT, LONG AND DEPTH
      REAL MAG, HILAT,LOLAT,HILON,LOLON,MAXMAG,MINDEPTH,MAXDEPTH,
     *     maxrms,minrms,maxgap,mingap,
     *     minhelat, maxhelat,
     *     minhelon, maxhelon,
     *     minhedepth, maxhedepth
      integer igap   ! gap read from file
     
C  SELECTION CRITERIAS: TIME INTERVAL,MIN AND MAX # OF STATIONS
      INTEGER MINSTATION, MAXSTATION 
      double precision time1,time2,timcen
C  STATUS PARAMETER, EPIBASE
      INTEGER nstatus
C  EVENT ACCEPTED OR NOT
      LOGICAL  ACCEPTED,default
C  DATE,TIME AND NUMBER OF STAITONS
      integer YEAR,MONTH,DAY,HOUR,MINUTES,NUMBEROFSTATIONS
C  SECOND, LATITUDE,LONGITUDE,DEPTH, TIME, MINUMUM MAG AND RMS
      real    SEC,LATI,LONG,DEPTH,minmag,rmsvalue
      integer isec
c  top directory name
      character*60 top_directory
c   directory delimiter
      character*1 dchar
c   text
      character*80 text
c   dir name for EPI now cat
      character*80 dir
c   fault plane solution
      logical fpsolut
c   earthquake felt
      logical eqfelt
      logical header_check       ! if or not all header lines checked
      logical wave               ! true if correct wave form file name found
      character*40 wave_check    ! string to identify wave from file name
      integer n_header_check     ! number of header lines to check
      real ypol(max_polyn$,2)    ! array defining polygon
      integer iant               ! number of points of the polygon
      integer mnupol             ! minumum number of polarities
      integer cnupol             ! counter for number of polarities
      character*4 phase(6)       ! phase names to select
      logical singleout          ! true if output file is given in the command line
      character*80 outfile       ! output file  name given in the command line
c
      COMMON/EPIVALUE/YEAR,MONTH,DAY,HOUR,MINUTES,SEC,LATI,LONG,DEPTH,
     *                 NUMBEROFSTATIONS,RMSVALUE,MAG,ACCEPTED,nstat
C
      COMMON/EPICHAR/DISTANCEID,EVENTID,DEPTHID,AGENCY,
     *                    MAGTYPE,MAGAGENCY
C
      common/epicrite/hilat,lolat,hilon,
     *                lolon,minmag,maxmag,minrms,maxrms,mindepth,
     *                maxdepth,minhelat,maxhelat,minhelon,maxhelon,
     *                minhedepth,maxhedepth,ypol,iant,mnupol
      common/epicrit2/fpsolut,eqfelt,statselect
      common/epicrit1/mindist,maxdist,
     *                hypaselect,magaselect 
      common/epicrit3/default,eventtype,disttype,magtypes,volcanictype
      common/epicrit4/minstation,maxstation,stat_present,hypa_present,
     *                maga_present,header_check,wave_check
      common/epicrit5/time1,time2,timcen,all_stat,mingap,maxgap,phase,
     *                stat_phase,hyp_dist
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
       integer  write1,                    ! Output unit 1.
     &          write3,                    ! Ditto 3.
     &          write4,                    ! Ditto 4.
     &          write5,                    ! Ditto 4.
     &          read1,                     ! Input unit1.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
C
C    ============= end of list ==========
C


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      b_f_debug$=.false.                   ! file io debugging
C
C   INITIALIZE 
C
      NEVENT=0
      NLOCAL=0
      NREGIONAL=0
      NDISTANT=0
      NOUT=0
      NWAVE=0
      nid=0
      basetype='CAT'
      do i=1,6
         phase(i)=' '
      enddo
      compact=.false.
      seisweb=.false.
      singleout=.false.
      header_check=.false.      ! 2-2007 jh
      wave_check=' '
      hyp_dist=.false.
      call dir_char(dchar)
      call get_def_base(agency_loc)

C   USE STANDARD DATA BASE BY DEFAULT
C
      BASENAME(1:10)='          ' 
c
c   check if prompt input with file name of input file with choises
c
      choise_file=' '
c
      call get_arguments(narg,data)
c
c     check if  output file is given
c
      if(narg.eq.2) then
        outfile = data(2)
        singleout = .true.
        narg = 1
      endif
c
      if(narg.eq.1) then
         choise_file=data(1)
         write(6,'(a,a)')' Choises from file: ',choise_file
         open(1,file=choise_file,status='old',err=3334)
         goto 3335
 3334    continue
         write(6,'(a,a)')' File does not exist: ',choise_file
         stop
 3335    continue
         read(1,'(32x,a)') basename
         read(1,'(32x,a)') basetype
         close(1)
      endif
c
c   find out if all choises from promt line and get them if true
c
      call selcrit_prompt
     *(narg,data,starttime,endtime,basename,seisweb,
     * web_out)


c
c     INQUIRE TYPE OF INPUT if not from file or argument string
C
 435  CONTINUE
      if(choise_file.eq.' '.and.narg.lt.3) then
         WRITE(*,*)' POSSIBLE INPUT IS: '
         WRITE(*,*)'    STANDARD CAT DATA BASE: RETURN'
         WRITE(*,*)'    ALTERNATIVE DATA BASE, GIVE 1-5 LETTER CODE:'                
         WRITE(*,*)'    FILENAME FOR ONE FILE, ',
     *              'MUST BE 6 OR MORE CHARACTERS OR HAVE A .'
         READ(5,'(A)') BASENAME
c
c   do not ask for type of base if input is a file
c
         i=index(basename,' ')-1
         j=index(basename,'.')
         if(.not.(I.GT.5.or.j.ne.0)) then
            write(6,*) ' Type of base: CAT (Return) or Sfiles (s):'
            read(5,'(a)') text
            if(text(1:1).eq.'s'.or.text(1:1).eq.'S') 
     *      basetype='SFILES'
         endif
      endif
C
C  DETERMINE TYPE OF INPUT
C
      if(.not.seisweb) then
      i=index(basename,' ')-1
      j=index(basename,'.')
      IF(BASENAME(1:5).EQ.'     ') THEN
         INPUTOPTION=1
         BASENAME(1:5)=agency_loc
      ENDIF
c
      IF(I.lt.6.and.j.eq.0) then
         INPUTOPTION=1          ! data base
         do k=2,5
           if(basename(k:k).eq.' ') basename(k:k)='_'
         enddo
      endif
      IF(I.GT.5.or.j.ne.0) INPUTOPTION=2  ! file

c
c   set type of base
c
      if(inputoption.eq.1.and.basetype.eq.'SFILES') inputoption=3
c
C   OPEN FILE
C
      IF(INPUTOPTION.EQ.2) THEN
          call sei open( old$+warn$,       ! Open file & warn of erro.
     &                   ' ',              ! Prompt (n/a).
     &                   BASENAME,         ! Filename.
     &                   read1,            ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
          if( code .ne. e_ok$ ) then       ! An error or does not exist.
             code = e_ok$                     ! Re-set condition.
             if(choise_file.eq.' ') then
                goto 435                         ! & re-prompt.
             else
                write(6,'(a,a)') ' File does not exist: ',basename
                stop                          ! stop if input from choise file
             endif                           !
           endif
      ENDIF
      else
c         i=seiclen(basename)
c         top_directory=basename(1:i-9)   ! put in path
c         basename(1:5)=basename(i-4:i)   ! put in base name
c         basename(6:80)=' '
c         call put_env_seistop(top_directory) ! put in environment
         inputoption=1      ! only choise from seisweb
c         write(6,'(0x,a24)')'Content-type: text/plain' ! needed for seisweb'
c         write(6,'(0x,a0)') ''     
      endif

c
c   data base indexing
c
      IF(INPUTOPTION.EQ.1) THEN
c
         write(6,'(a,a)')' Updating data base ',basename(1:5)
c
c   get top dir name and make cat dir name
c
         call topdir(top_directory)
         i=index(top_directory,' ')-1
         dir(1:i)=top_directory(1:i)
         dir(i+1:i+1)=dchar
         dir(i+2:i+4)='REA'
         dir(i+5:i+5)=dchar
         dir(i+6:i+10)=basename(1:5)
         dir(i+11:i+11)=dchar
         dir(i+12:i+14)='CAT'
c
c   make listing of files in  CAT
c
         call getfiles(dir,i+14,cat_files,max_cat_files,n)
c
         k=0
c
c   sort out non cat files
c
         do i=1,n
            if(cat_files(i)(7:10).eq.'.CAT') then
               k=k+1
               cat_files(k)=cat_files(i)
            endif
         enddo
c
c   stop if no files
c
         if(k.lt.1) then
           write(6,'(a,a)')
     *     ' No data in data base specified: ', basename(1:5)
           if(seisweb) write(6,*)
     *     'select_terminated: error no data in base'
           stop
         endif
c
         write(6,'(a,a5,a,i4,a)')
     *' The data base ',basename(1:5),' has ',k,' files'
         write(6,'(a,a)')' The first file starts: ',cat_files(1)(1:6) 
         write(6,'(a,a)')' The  last file starts: ',cat_files(k)(1:6)
         write(6,*)
         ncat_files=k
      ENDIF
c
c   open output files
c
      if(singleout) then
        seisweb=.true.
        web_out = outfile
      endif

      if(seisweb) then

           call sei open( unknown$,        ! Open file (default stop on error).
     &               ' ',                  ! Prompt (n/a).
     &               web_out(1:seiclen(web_out))//'.all',  ! Filename.
     &               write1,               ! Unit opened on.
     &               b_flag,               ! Flag (n/a).
     &               code )                ! Returned condition (n/a).
           endfile write1                  ! need to be clear up
           rewind write1
         call sei open( unknown$,         ! Open file (default=stop on error)
     &                  ' ',              ! Prompt (n/a).
     &       web_out(1:seiclen(web_out))//'.id',      
     &                  write3,           ! Unit opened on.
     &                  b_flag,           ! Flag (n/a).
     &                  code )            ! Returned condition (n/a).
           endfile write3                 ! need to be clear up
           rewind write3
c
c   file with header lines
c
         call sei open( unknown$,         ! Open file (default=stop on error)
     &                  ' ',              ! Prompt (n/a).
     &       web_out(1:seiclen(web_out))//'.head',      
     &                  write5,           ! Unit opened on.
     &                  b_flag,           ! Flag (n/a).
     &                  code )            ! Returned condition (n/a).
           endfile write5                 ! need to be clear up
           rewind write5
      else
C
             call sei open( unknown$,      ! Open file (default stop on error).
     &               ' ',                  ! Prompt (n/a).
     &               'select.out',         ! Filename.
     &               write1,               ! Unit opened on.
     &               b_flag,               ! Flag (n/a).
     &               code )                ! Returned condition (n/a).
c
c   open and make sure it is empty
c
             call sei open( unknown$,      ! Open file (default=stop on error)
     &                  ' ',              ! Prompt (n/a).
     &                  'index.out',      ! Filename.
     &                  write3,           ! Unit opened on.
     &                  b_flag,           ! Flag (n/a).
     &                  code )            ! Returned condition (n/a).
             call sei close(delete$,write3,code)  ! delete
             call sei open( unknown$,      ! Open file (default=stop on error)
     &                  ' ',              ! Prompt (n/a).
     &                  'index.out',      ! Filename.
     &                  write3,           ! Unit opened on.
     &                  b_flag,           ! Flag (n/a).
     &                  code )            ! Returned condition (n/a).
      endif
C
C   GET SELECTON CRITERIA
C

         CALL SELCRIT(STARTTIME,ENDTIME,basename,basetype,
     *   choise_file,narg)
c
c   open file with waveform file names
c
       call sei open( unknown$,         ! Open file (default=stop on error)
     &                ' ',              ! Prompt (n/a).
     &                'waveform_names.out',   ! Filename.
     &                write4,           ! Unit opened on.
     &                b_flag,           ! Flag (n/a).
     &                code )            ! Returned condition (n/a).
C
C     INPUT IS NORDIC COMPACT FILE OR NORDIC FILE
C
      if(inputoption.eq.2) then
c
c   find if compact or not
c
          call nortype(read1,compact)
          if(compact) THEN
             write(6,*)
             write(6,*)' File type is compact'
             write(6,*)
          endif
          GOTO 10
      endif


C---------------------------------------------------------------------
C  MAIN READING LOOP STARTS HERE 
C---------------------------------------------------------------------
c
10    CONTINUE
      nstat=0
C
C    CAT DATA BASE
C
      IF(INPUTOPTION.EQ.1) THEN
         call epibase(basename,starttime,endtime,
     *   nstat,nphase,nhead,nrecord,distanceid,exp,data,id,nstatus,
     *   compact,nout,ncat_files,cat_files)
         IF(NSTATUS.EQ.1) GOTO 999
      ENDIF	  
C
C   single file
C
      IF(INPUTOPTION.EQ.2)THEN	
         if(compact) then
            nhead=1
            read(read1,'(a80)',iostat=code ) data(1) ! Read record.
            call sei code(fort$,                     ! Stop on error.
     &                    code,                      ! Condition code.
     &                    read1,                     ! For fortran unit.
     &                    b_flag )                   ! Flag end of file.
            if( b_flag ) goto 999                    ! End of file, skip.
            DISTANCEID=DATA(1)(22:22)
            NRECORD=1
         else
            CALL INDATA(read1,nstat,NPHASE,NHEAD,NRECORD, !
     *      DISTANCEID,EXP,DATA,ID)
c            write(6,*)DATA(1)
            if(nrecord.eq.0) goto 999
         endif
      ENDIF

c
c  s-file data base
c

      if(inputoption.eq.3) then
         key=' '        ! always use next event
         CALL findevin                                                       
     *   (basename,starttime,endtime,key,0,
     *   event_no,evfile,fstart,new_month,status)                                 
         if(status.eq.0) then                                                     
            nrecord=-1
            open(97,file=evfile,status='unknown')
            call indata(97,nstat,nphase,nhead,nrecord,
     *      distanceid,exp,data,id)
            close(97)
         else
            goto 999
         endif
      endif
 
c
c	  
C------------------------------------------------------------------------
C   HERE STARTS EVENT CHECKING
C------------------------------------------------------------------------
C
C   CHECK FOR INFO IN HEADERS
C
      data(1)(80:80)='1'       ! older data might not have a 1 in first line
      if(header_check) then    ! find if all header are checked
         n_header_check=nhead
      else
         n_header_check=1
      endif
      do i=1,n_header_check
         if(data(i)(80:80).eq.'1') then
            CALL EPISELEC(DATA(i),start_of_time,end_of_time)
            if(accepted) goto 6968    ! jump out of loop if selected
         endif
      enddo
 6968 continue
c
c   if end of time, no more data input unless a single file is used
c   and the data is mixed up chronologically
c
      if(end_of_time.and.inputoption.eq.2) goto 10
      if(end_of_time) goto 999
c
c   if not yet at start of time interval, get next event
c
      if(start_of_time) goto 10
C
C   EVENT COUNTING only for events within time interval
C
      NEVENT=NEVENT+1
C
C   COUNT LOCAL EVENTS
C	  			
      IF(DISTANCEID.EQ.'L'.OR.DISTANCEID.EQ.' ') THEN
          IF(DISTANCEID.EQ.'L') NLOCAL=NLOCAL+1
      ENDIF
C	  	  	
C  COUNT REGIONAL  EVENTS
C
      IF(DISTANCEID.EQ.'R') NREGIONAL=NREGIONAL+1	
C
C   COUNT DISTANT EVENTS
C
      IF(DISTANCEID.EQ.'D') NDISTANT=NDISTANT+1
c
c   check for gap
c
      if(accepted) then
      if(mingap.ne.0.0.or.maxgap.ne.360.0) then
         igap=-1                ! initailly no gap
         accepted=.false.
         if(.not.compact) then
            do i=1, nhead
              if(data(i)(80:80).eq.'E'.and.data(i)(2:4).eq.'GAP') 
     *           then
                 read(data(i)(6:8),'(i3)') igap
                 if(float(igap).le.maxgap.and.float(igap).ge.mingap)
     *           accepted=.true.
              endif
            enddo
         endif
      endif
      endif

c
c check for volcanic subclass
c
      if (accepted) then
        if (seiclen(volcanictype(1)).gt.0) then
          accepted=.false.
          do i=1,nhead
            if (data(i)(1:10).eq.' VOLC MAIN') then
              do j=1,10
                if (data(i)(12:17).eq.volcanictype(j)) then
                  accepted=.true.
                endif
              enddo          
            endif
          enddo
        endif
      endif
C
C   CHECK FOR REQUIRED STATIONS IF WANTED, AT LEAST ONE OF STATIONS IN
C   STATSELECT MUST BE PRESENT TO SELECT EVENT, skip if compact file
C
C  CHECK IF DEFAULT OR ALL STATIONS INCLUDED, ELSE CHECK WHICH STATION
c  also check distance range. If no distance, reject station
C
      if(accepted) then
      STATIONOK=1
c     write(6,*)'nstat=',nstat,' stat_pr',stat_present
      IF(.not.compact.AND.STAT_present.GT.0) THEN
         STATIONOK=0
         if(nstat.ge.0) then
            DO I=1,STAT_PRESENT
                DO J=NHEAD+1,NRECORD-1
                   READ(DATA(J),'(1X,A7)') STATIONCODE
                   if(data(j)(71:75).ne.' ') then
                       read(data(j)(71:75),'(f5.0)') dist
                   else
                       dist=-1   ! indicate no distance available
                   endif
c
c   case of both station and component  and phase
c
c
c
c   if hypocentral distance, calculate here
c
                   if(hyp_dist) then
c                     write(88,*) dist,depth
                      if(dist.gt.-0.1) dist=sqrt(dist*dist+depth*depth)
c                     write(88,*) dist
                   endif
c
c   case of station and component
c
                   IF( statselect(i)(1:5).ne.'     '.and.
     *                 statselect(i)(6:7).ne.'  '   .and.
     *                 STATSELECT(I).EQ.STATIONCODE .and.
     *                 ((dist.ge.mindist(i).and.dist.le.maxdist(i))
     *                  .or.dist.lt.0).
     *                 and.((data(j)(11:14).eq.stat_phase(i).and.
     *                 stat_phase(i).ne.' ').or.(stat_phase(i).eq.
     *                 '____'.and.data(j)(11:14).eq.' ')
     *                 .or.stat_phase(i).eq.' ')) then
                          STATIONOK=stationok+1
                          goto 1616             ! only count first occurrence
                   endif
c
c   case of only station
c
                   IF( statselect(i)(1:5).ne.'     '.and.
     *                 statselect(i)(6:7).eq.'  '   .and.
     *                 STATSELECT(I)(1:5).EQ.STATIONCODE(1:5).and. 
     *                 ((dist.ge.mindist(i).and.dist.le.maxdist(i))
     *                  .or.dist.lt.0).
     *                 and.((data(j)(11:14).eq.stat_phase(i).and.
     *                 stat_phase(i).ne.' ').or.(stat_phase(i).eq.
     *                 '____'.and.data(j)(11:14).eq.' ')
     *                 .or.stat_phase(i).eq.' ')) then

                          STATIONOK=stationok+1
                          goto 1616
                   endif
c
c   case of only component
c
                   IF( statselect(i)(1:5).eq.'     '.and.
     *                 statselect(i)(6:7).ne.'  '   .and.
     *                 STATSELECT(I)(6:7).EQ.STATIONCODE(6:7).and.
     *                 ((dist.ge.mindist(i).and.dist.le.maxdist(i))
     *                  .or.dist.lt.0).
     *                 and.((data(j)(11:14).eq.stat_phase(i).and.
     *                 stat_phase(i).ne.' ').or.(stat_phase(i).eq.
     *                 '____'.and.data(j)(11:14).eq.' ')
     *                 .or.stat_phase(i).eq.' ')) then
                          STATIONOK=stationok+1
                          goto 1616
                   endif
                enddo
 1616           continue
            enddo
         endif
      ENDIF
c
c   case of all stations and components must be present
c
      IF(all_stat.and.STATIONOK.NE.stat_present)  ACCEPTED = .FALSE.
c
c   case of any one of stations and components must be present
c
      IF(.not.all_stat.and.STATIONOK.eq.0      )  ACCEPTED = .FALSE.
c
      endif
c
c  polarity
c
       if (accepted) then
          if (.not. compact .and. mnupol .gt. 0) then
              cnupol = 0
              do j = 1,nrecord
                 if ((data(j) (80:80) .eq. ' ' .or. 
     *               data(j) (80:80) .eq. '4').and.
     *               data(j)(11:11).eq.'P') then
                     if (data(j) (17:17) .eq. 'C' .or.
     *                   data(j) (17:17) .eq. 'D') 
c    *                   data(j) (17:17) .eq. '-' .or.
c    *                   data(j) (17:17) .eq. '+') 
     *                   cnupol = cnupol + 1
                 end if
              end do
              if (cnupol .lt. mnupol) accepted = .false.
          end if
      end if

c
c------------------------------------------------------------
c  phases
c------------------------------------------------------------
c
        if (accepted) then
           if (phase(1).ne.' ') then
              do j = nhead+1,nrecord-1
                  do k=1,6
                     if((data(j)(11:14).eq.phase(k).and.
     *               phase(k).ne.' ').or.
     *               (data(j)(11:14).eq.' '.and.phase(k).eq.'____'))
     *               goto 3746
                   enddo
              end do
              accepted=.false.  ! went through whole loop without finding phase
 3746         continue
            end if
        end if

      fpsolutf = .false.
      eqfeltf = .false.
      helatf = .false.
      helonf = .false.
      hedepthf = .false.
      if (accepted) then
          if (.not. compact .and. (minhelat .ne. 0.0 .or. 
     *        maxhelat .ne. 99999.)) then
              do j = 1,nrecord
                 if (data(j) (80:80) .eq. 'E' .or.
     *               data(j) (80:80) .eq. 'e') then
                     read (data(j) (24:30),'(f7.0)') filevar
                     if (filevar .ge. minhelat .and.
     *                   filevar .le. maxhelat) then
                         helatf = .true.
                     end if
                 end if
              end do
              if (.not. helatf) accepted = .false.
          end if
      end if
      if (accepted) then
          if (.not. compact .and. (minhelon .ne. 0. .or. 
     *        maxhelon .ne. 99999.)) then
              do j = 1,nrecord
                 if (data(j) (80:80) .eq. 'E' .or.
     *               data(j) (80:80) .eq. 'e') then
                     read (data(j) (31:38),'(f8.0)') filevar
                     if (filevar .ge. minhelon .and.
     *                   filevar .le. maxhelon) then
                         helonf = .true.
                     end if
                 end if
              end do
              if (.not. helonf) accepted = .false.
          end if
      end if
      if (accepted) then
          if (.not. compact .and. (minhedepth .ne. -99 .or. 
     *        maxhedepth .ne. 99999.0)) then
              do j = 1,nrecord
                 if (data(j) (80:80) .eq. 'E' .or.
     *               data(j) (80:80) .eq. 'e') then
                     read (data(j) (39:43),'(f5.0)') filevar
                     if (filevar .ge. minhedepth .and.
     *                   filevar .le. maxhedepth) then
                         hedepthf = .true.
                     end if
                 end if
              end do
              if (.not. hedepthf) accepted = .false.
          end if
      end if
      if (accepted) then
          if (.not. compact .and. fpsolut) then
              do j = 1,nrecord
                 if (data(j) (80:80) .eq. 'F' .or.
     *               data(j) (80:80) .eq. 'f') then 
                    fpsolutf = .true.
                 end if
              end do
              if (.not. fpsolutf) accepted = .false.
          end if
      end if
      if (accepted) then
          if (.not. compact .and. eqfelt) then
              do j = 1,nrecord
                 if (data(j) (80:80) .eq. '2') then
                     eqfeltf = .true.
                 end if
              end do
              if (.not. eqfeltf) accepted = .false.
          end if
      end if
c
c   wave form file names
c
      if (accepted) then
          if (.not.compact.and.wave_check.ne.' ') then
              wave=.false.
              k=sei clen(wave_check)
              do j = 2,nhead
                 if (data(j) (80:80) .eq. '6') then
                    if(wave_check(1:1).eq.'*') then ! any wave form
                       wave=.true.
                    else      ! loook for part of string
                       read(data(j)(2:79),'(a)') text    ! wave form name
                       do i=1,sei clen(text)-k+1
                         if(text(i:i+k-1).eq.wave_check(1:k))wave=.true.
                       enddo
                    endif
                 end if
              end do
              if (.not. wave) accepted = .false.
          end if
      end if


C
C
C   WRITE OUT EVENT IF SELECTED
C
      IF (ACCEPTED)THEN
C
C   FIND WAVEFORM FILE NAMES IF A WHOLE FILE IS USED
C
         IF(.not.compact) THEN
            DO I=2,NHEAD
               IF(DATA(I)(80:80).EQ.'6') THEN
               K=INDEX(DATA(I)(2:79),' ')
C
               write(write4,'(i5,2x,A)',iostat=code)
     *         nwave,DATA(I)(2:k)
               call sei code(fort$,              ! stop on error.
     &                       code,               ! Error condition.
     &                       write4,             ! For fortran unit.
     &                       b_flag )            ! Flag (n/a).
c
               NWAVE=NWAVE+1
               ENDIF
            ENDDO
         ENDIF	  
C
         write(write1,'(A80)',iostat=code)(DATA(I),I=1,NRECORD)
         call sei code(fort$,                    ! stop on error.
     &                 code,                     ! Error condition.
     &                 write1,                   ! For fortran unit.
     &                 b_flag )                  ! Flag (n/a).
c
c  if input from data base, both compact and full nordic files can
c  be input, therefore always have a blank line between events
c
         if(compact.and.inputoption.eq.1)
     &   write(write1,'(a5)',iostat=code)'     '
         call sei code(fort$,                    ! stop on error.
     &                 code,                     ! Error condition.
     &                 write1,                   ! For fortran unit.
     &                 b_flag )                  ! Flag (n/a).
c
c   if seisweb option, also make a compact file
c
         if(seisweb) then
            write(write5,'(a80)',iostat=code) data(1)
         endif
C
C   COUNT SELECTED EVENTS AND WRITE INDEXES IF id is PRESENT 
c   if input is not from data base, no data base reference
c   can be made
C
         NOUT=NOUT+1		
         IF(.not.compact)THEN
            if(id.ne.0) then
               nid=nid+1
               read(data(id)(61:74),'(i4,5i2)') 
     *         year,month,day,hour,minutes,isec
               call sfilname
     *         (year,month,day,hour,minutes,isec,basename(1:5),
     *          distanceid,sfile,k)
C
               if(seisweb) then
                  write(write3,'(a)') sfile(1:k)
               else
                  if(inputoption.ne.2) then   ! only write out if from data base
                    write(write3,'(I5,2X,A)',iostat=code) !
     &              NID,SFILE(1:k)                  !
                    call sei code(fort$,               ! stop on error.
     &                       code,                   ! Error condition.
     &                       write3,                 ! For fortran unit.
     &                       b_flag )                ! Flag (n/a).
                  endif
               endif
            endif
         ENDIF
      ENDIF

998   CONTINUE

C
C   BACK TO GET NEXT EVENT
C
      id=0
      GO TO 10		
c
C-------------------------------------------------------------------
C   FINISHED, WRITE OUT STATISTICS
C-------------------------------------------------------------------
999   CONTINUE
c
c   write last file statisitcs if from epibase
c
      if(inputoption.eq.1.and.nstatus.ne.1) then
         nstatus=-1
         call epibase(basename,starttime,endtime,
     *   nstat,nphase,nhead,nrecord,distanceid,exp,data,id,nstatus,
     *   compact,nout,ncat_files,cat_files)
      endif

      write(6,*)' '
      WRITE(6,*)' TOTAL NUMBER OF EVENTS IN TIME INTERVAL ',NEVENT
      WRITE(6,*)' NUMBER OF DISTANT EVENTS   - - - - -    ',NDISTANT
      WRITE(6,*)' NUMBER OF REGIONAL EVENTS  - - - - -    ',NREGIONAL
      WRITE(6,*)' NUMBER OF LOCAL EVENTS     - - - - -    ',NLOCAL
      write(6,*)' ---------------------------------------------------'
      WRITE(6,*)' NUMBER OF EVENTS SELECTED ************* ',NOUT
      WRITE(6,*)' NUMBER OF WAVEFORM FILES SELECTED       ',NWAVE
      write(6,*)' NUMBER OF INDEXES SELECTED              ',NID
      WRITE(6,*)' SELECTED EARTHQUAKES ARE IN FILE: select.out '
      WRITE(*,*)' LOCAL INDEX FILE IN:              index.out'
      WRITE(6,*)
     *' NAMES FOR WAVEFORM FILES IN FILE: waveform_names.out'
      write(6,*)' SELECT COMMANDS IN FILE:          select.inp'
      write(6,*) ' '
c
c   message for seisweb
c
      if(seisweb) then
         write(6,*)  'select_terminated: ok ',nout 
      endif

      STOP
      END
C -------------------------------------------------------------------
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     ROUTINE INQUIRES EPICENTER SELECTION CRITERIA
C     AND RETURN THESE PARAMETERS TO CALLING PROGRAM
C     PARAMETERS TO RETURN IN COMMON BLOCK: EPICRITE , EPICRIT2
C                                           EPICRIT3 AND EPICRIT4
C     THE ROUTINE IS INTENDED TO BE USED TOGETHER WITH
C     ROUTINE EPISELECT AND ROUTINE INDATA
C     WRITTEN BY: C. LINDHOLM
C     MODIFIED BY J. HAVSKOV TO INCLUDE STATION SELECTION and a lot more
C     LAST REVISED:  AUGUST 18, 1987
c                    may -89. Poosibility to run on database facilitated c.l.
C     CHANGED:       1990-01-30, R.N.ARVIDSSON TO PC-DOS.
C     LAST REVISED:  1990-01-30, RNA, COMMON BLOCK STRUCTURE.
C     LAST REVISED:  1990-02-01, RNA, INPUT OF YYYMMDDHHMM CHANGED.
C                    1990-02-16, RNA, COMMON BLOCK STRUCTURE.
C                    1990-04-27, JH,  SPECIAL SEISNOR STATION Q REMOVED
C                    1991-04-03, CL,  FACILITATE USE OF BLANK ENDTIME
C                    1991-19-09  JH   MAJOR CLEANUP WITH START AND STOP TIMES
C                    OCT 91           MORE CLEANUP
C
C     OUTPUT: ALL PARAMETERS IN COMMON BLOCK:'CRITERIA'
C             TIME1,TIME2 :  TIME-LIMITS
C             HILON,LOLON,HILAT,LOLAT: LONGITUDE/LATITUDE -LIMITS
C             MINSTATION: MINIMUM NUMBER OF STATIONS
C             MAXSTATION: MAXIMUM NUMBER OF STATIONS
C             MINMAG,MAXMAG: MAGNITUDE LIMITS
C             MINDEPTH,MAXDEPTH: DEPTH LIMITS
C             MINRMS: MINIMUM RMSVALUE
C             MAXRMS: MAXIMUM RMSVALUE
c             minhelat, maxhelat: hypocenter error lat limits
c             minhelon, maxhelon: hypocenter error long limits
c             minhedepth, maxhedepth: hypocenter error depth limits
C             DEFAULT: LOGICAL WITH VALUE=.TRUE. IF NO SELECTION
C                                         -PARAMETERS ARE SET
C             STAT_present:  NUMBER OF STATIONS THAT MUST BE PRESENT
C                      IF ZERO, NO IMPORTANCE
C             hypa_present:  NUMBER OF HYPOCENTER AGENCIES THAT MUST BE PRESENT
C                      IF ZERO, NO IMPORTANCE
C             maga_present:  NUMBER OF MAGNITUDE AGENCIES THAT MUST BE PRESENT
C                      IF ZERO, NO IMPORTANCE
C             STATSELECT: STATIONS WHICH MUST BE PRESENT TO SELECT EVENT
C             HYPASELECT: HYPOCENTER AGENCIES WHICH MUST BE PRESENT
C             MAGASELECT: MAGNITUDE AGENCIES WHICH MUST BE PRESENT
C     

		
c-this subroutine reads the starttime and endtime for the selction
c-from the database and calls the subroutine which shows the screen
c-with the opitions to be changed.
c
      subroutine selcrit(starttime,endtime,basename,basetype,
     *choise_file,narg)
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      character*14 starttime, endtime,stime
      character*6 basetype  ! type of data base, CAT or SFILES
      character*80 choise_file  ! file with choises, if blank, no file
c  start time and end time inc. century
c  abs times
      double precision time1,time2,timcen
c  century
      integer cen1,cen2,month,day,year
c  number of stations to be present
      integer           stat_present
      integer           narg         ! number of arguments
      logical       all_stat         ! if true,  all must be present
c  number of hypocenter agencies to be present
      integer           hypa_present
c  number of magnitude agencies to be present
      integer           maga_present
      logical default
      character*80 option
      real minmag, minrms, maxrms, hilat, lolat, hilon, lolon, maxmag,
     *     mindepth, maxdepth,maxgap,mingap,
     *     minhelat, maxhelat,
     *     minhelon, maxhelon,
     *     minhedepth, maxhedepth
      integer minstation, maxstation, i
      character*1 eventtype(5), disttype(5), magtypes(5)
      character*7 statselect(50)
      character*4 stat_phase(50)
      integer mindist(50),maxdist(50)  ! distance range for station	
      character*3 hypaselect(10), magaselect(10)
      character*80 basename      ! data base of file name of input
c   fault plane solution
      logical fpsolut
c   earthquake felt
      logical eqfelt
      character*40 wave_check    ! string to identify wave form file name
      character*80 text
      logical header_check
      real ypol(max_polyn$,2)    ! array defining polygon
      integer iant               ! number of points of the polygon
      integer mnupol             ! minumum number of polarities
      integer w1                 ! file unit
      integer code               ! for sei open
      logical hyp_dist           ! if true, use hypocentral distance
      logical b_flag             ! ------------
      character*4 phase(6)       ! phase names to select
      character*6 volcanictype(10)   ! volcanic subclasses

      common/epicrite/hilat,lolat,hilon,
     *                lolon,minmag,maxmag,minrms,maxrms,mindepth,
     *                maxdepth,minhelat,maxhelat,minhelon,maxhelon,
     *                minhedepth,maxhedepth,ypol,iant,mnupol
      common/epicrit2/fpsolut,eqfelt,statselect
      common/epicrit1/mindist,maxdist,
     *                hypaselect,magaselect 
      common/epicrit3/default,eventtype,disttype,magtypes,volcanictype
      common/epicrit4/minstation,maxstation,stat_present,hypa_present,
     *                maga_present,header_check,wave_check
      common/epicrit5/time1,time2,timcen,all_stat,mingap,maxgap,phase,
     *                stat_phase,hyp_dist

      option(1:3) = '000'

c
c   if input of choises is from a file, open and read from that file
c
       if(choise_file.ne.' ') then
c
c   read choises
c
      call sei open( unknown$,             ! Open file (default stop on error).
     &               ' ',                  ! Prompt (n/a).
     &               choise_file,         ! Filename.
     &               w1,                   ! Unit opened on.
     &               b_flag,               ! Flag (n/a).
     &               code )                ! Returned condition (n/a).
      read(w1,'(31x,1x,a)')  text          ! is base name, read before
      read(w1,'(31x,1x,a)') basetype
      read(w1,'(31x,1x,a)')  starttime     
      read(w1,'(31x,1x,a)') endtime
      read(w1,'(31x,i15)')  minstation           
      read(w1,'(31x,i15)')   maxstation         
      read(w1,'(31x,f15.3)') lolat
      read(w1,'(31x,f15.3)') hilat               
      read(w1,'(31x,f15.3)') lolon
      read(w1,'(31x,f15.3)') hilon  
      read(w1,'(31x,f15.3)') minmag   
      read(w1,'(31x,f15.3)') maxmag   
      maga_present=0
      hypa_present=0
      read(w1,'(31x,1x,10a3)')  magaselect
      read(w1,'(31x,1x,10a3)')  hypaselect
      do i=1,10
        if(magaselect(i).ne.'   ') maga_present=maga_present+1
        if(hypaselect(i).ne.'   ') hypa_present=hypa_present+1
      enddo
      read(w1,'(31x,f15.3)') minrms 
      read(w1,'(31x,f15.3)') maxrms
      read(w1,'(31x,f15.3)') mindepth   
      read(w1,'(31x,f15.3)') maxdepth 
      read(w1,'(31x,f15.3)') minhelat
      read(w1,'(31x,f15.3)') maxhelat
      read(w1,'(31x,f15.3)') minhelon 
      read(w1,'(31x,f15.3)') maxhelon 
      read(w1,'(31x,f15.3)') minhedepth 
      read(w1,'(31x,f15.3)') maxhedepth
      read(w1,'(31x,1x,5a1)')magtypes
      read(w1,'(31x,1x,5a1)')disttype
      read(w1,'(31x,1x,5a1)')eventtype
      read(w1,'(31x,i15)')   mnupol           
      read(w1,'(31x,14x,l1)')eqfelt 
      read(w1,'(31x,14x,l1)')fpsolut 
      read(w1,'(31x,14x,l1)')header_check 
      read(w1,'(31x,1x,a)')  wave_check
      read(w1,'(31x,f15.3)') mingap
      read(w1,'(31x,f15.3)') maxgap
      read(w1,'(31x,1x,6a4)')   phase
      read(w1,'(31x,1x,10a6)') volcanictype
      read(w1,'(a)') text                      ! explanation line
      read(w1,'(31x,13x,2l1)') all_stat,hyp_dist        
c
c   read and find how many stations present
c
      
      do i=1,9999
         read(w1,'(1x,a7,2i7,1x,a4)')statselect(i),mindist(i),
     *   maxdist(i),
     *   stat_phase(i)
         if(statselect(i).eq.'       ') goto 2999
      enddo
 2999 continue
      stat_present=i-1
c
      read(w1,'(a)') text                      ! explanation line
c      write(6,*) basename
c      write(6,'(1x,a,a)') starttime,endtime
      do i=1,9999
        read(w1,'(2f10.3)',end=9876) ypol(i,2),ypol(i,1)
      enddo
 9876 continue
      iant=i-1

c
c      write(6,*)' max',maxhedepth
      call sei close(close$,w1,code ) ! Close but stop on error.
      endif


C
C     NOW INQUIRE BOUNDARY VALUES
C

 111   continue
       if(choise_file.eq.' '.and.narg.lt.3) then
          write(6,'(1x,a,$)')  
     *  ' Start time (blank is 1980), yyyymmddhhmmss:'
          read(5,'(a14)') starttime
          if(starttime.eq.' ') then
             write(6,'(1x,a,$)')
     *     ' End time, enter for  2015                 :'
          else 
             write(6,'(1x,a,$)')
     *  ' End time, enter for end of month          :'
          endif
          read(5,'(a14)') endtime
       endif
c
c   if start time has ny year, put in 1980
c
       if(starttime(1:4).eq.' ') then
          starttime(1:4)='1980'
          if(endtime(1:4).eq.' ') endtime(1:4)='2015'
       endif
c
c   if start time has no month, put in january
c
      if(starttime(5:6).eq.'  ') starttime(5:6)='01'
      do i=7,14
        if(starttime(i:i).eq.' ') starttime(i:i)='0'
      enddo
c
c   if end time year is blank, must be to end of month, put in
c   same year-month as start time
c
c-- end of month
      if(endtime(1:4).eq.'    ')  endtime(1:6)=starttime(1:6)
c
c   make sure end time is to end of month, day etc if left blank
c
      if(endtime(5:6).eq.'  ') endtime(5:6)='12'
      if(endtime(7:8).eq.'  ') then
         read(endtime(1:6),'(i4,i2)') year,month
         call month_day(year,month,day)
         write(endtime(7:8),'(i2)') day
         if(endtime(7:7).eq.' ') endtime(7:7)='0'
      endif
      if(endtime(9:10).eq.'  ') endtime(9:10)='23'
      if(endtime(11:12).eq.'  ' ) endtime(11:12)='59'
      if(endtime(13:14).eq.'  ') endtime(13:14)='59'
ctest      write(6,*) endtime
c
c   get century
c
         read(starttime,'(i2)') cen1
         read(endtime, '(i2)') cen2
c
c   check if time interval is valid, get abs time from 1900 if time later
c   then 1900
c
CC2000   if(cen1.lt.19) then
            stime=starttime
            stime(1:2)='19'      ! make sure calculation goes from 1900,
            call abstim(stime,0,time1)    ! - century corrected for below
CC       else
CC          call abstim(starttime,0,time1)
CC       endif
c
CC       if(cen2.lt.19) then
            stime=endtime
            stime(1:2)='19'
            call abstim(stime,0,time2)
CC       else
CC          call abstim(endtime,0,time2)
CC       endif
ctest            WRITE(6,'(a,a)') STARTTIME,ENDTIME
ctest            WRITE(6,*) TIME1,TIME2
c
c   add century
c
         call abstim('19991231235960',0,timcen)  ! time of one century
         time1=time1+cen1*timcen
         time2=time2+cen2*timcen
ctest            write(6,*) 'C1,C2,TC,T1,T2', CEN1,CEN2,TIMCEN,TIME1,TIME2
c
c   check interval
c
         if(time1.ge.time2) then
            write(6,*)' ********* wrong time interval *************'
c            if(choise_file.ne.' ') then
               stop
c           else
c              goto 111
c           endif
         endif
c
c   return if input from choise file or argument string
c
         if(choise_file.ne.' '.or.narg.gt.2) return
c
c-calling the subroutine which draws the screen with options
c
         call draw_screen(option)

c-if enter, default is choosen
         if (option(1:1).eq.' ') then
            default = .true.
         end if

      do while (option(1:3) .ne. '000')

      if (option(1:3) .eq. '1  ' .or. option(1:3) .eq. '2  ' .or.
     *    option(1:3) .eq. '3  ' .or. option(1:3) .eq. '4  ' .or.
     *    option(1:3) .eq. '5  ' .or. option(1:3) .eq. '6  ' .or.
     *    option(1:3) .eq. '7  ' .or. option(1:3) .eq. '8  ' .or.
     *    option(1:3) .eq. '9  ' .or. option(1:3) .eq. '10 ' .or.
     *    option(1:3) .eq. '11 ' .or. option(1:3) .eq. '12 ' .or.
     *    option(1:3) .eq. '13 ' .or. option(1:3) .eq. '14 ' .or.
     *    option(1:3) .eq. '15 ' .or. option(1:3) .eq. '16 ' .or.
     *    option(1:3) .eq. '17 ' .or. option(1:3) .eq. '18 ' .or.
     *    option(1:3) .eq. '19 ' .or. option(1:3) .eq. '20 ' .or.
     *    option(1:3) .eq. '21 ' .or. option(1:3) .eq. '22 ' .or.
     *    option(1:3) .eq. '23 ' .or. option(1:3) .eq. '24 ') then
         call draw_screen(option)
      else if (option(1:1) .eq. ' ') then 
           option(1:3) = '000'
      else if (option(1:3) .ne. '1  ' .and.
     *         option(1:3) .ne. '2  ' .and.
     *         option(1:3) .ne. '3  ' .and.
     *         option(1:3) .ne. '4  ' .and.
     *         option(1:3) .ne. '5  ' .and.
     *         option(1:3) .ne. '6  ' .and.
     *         option(1:3) .ne. '7  ' .and.
     *         option(1:3) .ne. '8  ' .and.
     *         option(1:3) .ne. '9  ' .and.
     *         option(1:3) .ne. '10 ' .and.
     *         option(1:3) .ne. '11 ' .and.
     *         option(1:3) .ne. '12 ' .and.
     *         option(1:3) .ne. '13 ' .and.
     *         option(1:3) .ne. '14 ' .and.
     *         option(1:3) .ne. '15 ' .and.
     *         option(1:3) .ne. '16 ' .and.
     *         option(1:3) .ne. '17 ' .and.
     *         option(1:3) .ne. '18 ' .and.
     *         option(1:3) .ne. '19 ' .and.
     *         option(1:3) .ne. '20 ' .and.
     *         option(1:3) .ne. '21 ' .and.
     *         option(1:3) .ne. '22 ' .and.
     *         option(1:3) .ne. '23 ' .and.
     *         option(1:3) .ne. '24'        ) then
           option(1:1) = '?'
         call draw_screen(option)
      end if    
      end do
c
c   write out choices
c
      call sei open( unknown$,             ! Open file (default stop on error).
     &               ' ',                  ! Prompt (n/a).
     &               'select.inp',         ! Filename.
     &               w1,                   ! Unit opened on.
     &               b_flag,               ! Flag (n/a).
     &               code )                ! Returned condition (n/a).
      write(w1,'(a,1x,a)')   ' Base or file name            :',
     *basename
      write(w1,'(a,1x,a)')   ' Base type                    :',
     *basetype
      write(w1,'(a,1x,a  )') ' Start time                   :',
     *starttime     
      write(w1,'(a,1x,a)')   ' End time                     :',
     *endtime
      write(w1,'(a,i15)')    ' Minimum number of stations   :',
     *minstation           != 0
      write(w1,'(a,i15)')    ' Maximum number of stations   :',
     *maxstation           != 999
      write(w1,'(a,f15.3)')  ' Minimum latitude             :',
     *lolat                != -90.0 
      write(w1,'(a,f15.3)')  ' Maximum latitude             :',
     * hilat               != 90.0
      write(w1,'(a,f15.3)')  ' Minimum longitude            :',
     *lolon                != -360.0
      write(w1,'(a,f15.3)')  ' Maximum longitude            :',
     * hilon               != 360.0
      write(w1,'(a,f15.3)')  ' Minimum magnitude            :',
     *minmag               != -990.0
      write(w1,'(a,f15.3)')  ' Maximum magnitude            :',
     *maxmag               != +999.0
      write(w1,'(a,1x,10a3)')   ' Magnitude agencies           :',
     *magaselect
      write(w1,'(a,1x,10a3)')   ' Hypocenter agencies          :',
     *hypaselect
      write(w1,'(a,f15.3)')  ' Minimum rms                  :',
     *minrms               != 0
      write(w1,'(a,f15.3)')  ' Maximum rms                  :',
     *maxrms               != 999.0
      write(w1,'(a,f15.3)')  ' Minimum depth                :',
     *mindepth             != -99.0
      write(w1,'(a,f15.3)')  ' Maximum depth                :',
     *maxdepth             != 99999.0 
      write(w1,'(a,f15.3)')  ' Minimum error in latitude    :',
     *minhelat              != .0
      write(w1,'(a,f15.3)')  ' Maximum error in latitude    :',
     *maxhelat              != 99999.0
      write(w1,'(a,f15.3)')  ' Minimum error in longitude   :',
     *minhelon             != .0
      write(w1,'(a,f15.3)')  ' Maximum error in longitude   :',
     *maxhelon              != 99999.0
      write(w1,'(a,f15.3)')  ' Minimum error in depth       :',
     *minhedepth            != -99.0
      write(w1,'(a,f15.3)')  ' Maximum error in depth       :',
     *maxhedepth            != 99999.0
      write(w1,'(a,1x,5a1)') ' Magnitude types (L,C,B,S,W)  :',
     *magtypes
      write(w1,'(a,1x,5a1)') ' Distance (ID) types (L,R,D)  :',
     *disttype
      write(w1,'(a,1x,5a1)') ' Event types (e.g. E,V,P)     :',
     *eventtype

      write(w1,'(a,i15)')    ' Minimum number of polarities :',
     *mnupol           
c      default = .false.
c      fpsolut = .false.
      write(w1,'(a,14x,l1)') ' Felt earthquakes             :',
     *eqfelt 
      write(w1,'(a,14x,l1)') ' Fault plane solution         :',
     *fpsolut 
      write(w1,'(a,14x,l1)') ' Check all header lines       :',
     *header_check 
      write(w1,'(a,1x,a)')   ' Waveform files to check      :',
     *wave_check
      write(w1,'(a,f15.3)')  ' Minimum gap                  :',
     *mingap               != 0
      write(w1,'(a,f15.3)')  ' Maximum gap                  :',
     *maxgap               != 999.0
      write(w1,'(a,1x,6a4)') ' Phases                       :',
     *phase
      write(w1,'(a,1x,10a6)')' Volcanic subclasses          :',
     *volcanictype
      write(w1,'(a,a)') 
     *' Stat., comp. dist range, phase (1x,a5,a2,2i7,1x,a4)',
     *' one pr line, end blank line:'
      write(w1,'(a,2l1)') 
     *' STAT CO Mindis Maxdis Phas All stat hdist->',
     * all_stat,hyp_dist
      if(stat_present.gt.0) then
         do i=1,stat_present
           write(w1,'(1x,a7,2i7,1x,a4)')statselect(i),mindist(i),
     *                                  maxdist(i),stat_phase(i)
         enddo
      endif
      write(w1,*)
      write(w1,'(a,a)')        ' Polygon points (lat,lon), one pair pr',
     *' line, end with blank line :'
      do i=1,iant
        write(w1,'(2f10.3)') ypol(i,2),ypol(i,1)
      enddo

      return
      end 
   

 
c-this subroutine checks which option was selected and makes
c-all the questions necessaries for the selection depending of
c-the option. By CARLOS EDUARDO VIEIRA
      subroutine draw_screen(option)
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      real minmag, maxmag         ! minimum and maximum magnitude
      real lolat, hilat           ! lower and upper latitude
      real lolon, hilon           ! lower and upper longitude
      real mindepth, maxdepth     ! minimum and maximum depth
      real minrms                 ! minimum rms
      real maxrms                 ! maximum rms
      real maxgap,mingap          ! gap range
      integer minstation          ! minimum number of stations
      integer maxstation          ! maximum number of stations
      real minhelat               ! minimum hypocenter error lat
      real maxhelat               ! maximum hypocenter error lat
      real minhelon               ! minimum hypocenter error long
      real maxhelon               ! maximum hypocenter error long
      real minhedepth             ! minimum hypocenter error depth
      real maxhedepth             ! maximum hypocenter error depth
      logical fpsolut             ! fault plane solution
      logical eqfelt              ! earthquake felt
      character*1 eventtype(5)    ! event id
      character*1 disttype(5)     ! distance id
      character*1 magtypes(5)     ! magnitude type
      character*7 statselect(50)  ! station code
      character*4 stat_phase(50)  ! phase to select with station
      integer mindist(50),maxdist(50)  ! distance range for station	
      character*3 hypaselect(10)  ! hypocenter agencies
      character*3 magaselect(10)  ! magnitude agencies
      character*80 option         ! option
      integer stat_present        ! number of stations codes
      logical       all_stat         ! if true,  all must be present
      integer hypa_present        ! number of hypocenter agencies
      integer maga_present        ! number of magnitude agencies
      real ypol(max_polyn$,2)     ! array defining polygon
      integer iant                ! number of points of the polygon
      integer idist               ! indicator if distances requred
      integer mnupol              ! minumum number of polarities
      integer status, statusaux   ! iostatus
      character*1 eventtypet(5)   ! aux screen for event id
      character*1 disttypet(5)    ! aux screen for distance id
      character*1 magtypest(5)    ! aux screen for magnitude type
      character*80 reading        ! aux for read integer/real variable
      character*3 minstationa     ! aux char for minimum number of stations
      character*3 maxstationa     ! aux char for maximum number of stations
      character*4 minrmsa         ! aux char for minimum rms
      character*4 maxrmsa         ! aux char for maximum rms
      character*5 mindeptha, maxdeptha ! aux char for min and max depth
      character*6 minmaga, maxmaga ! aux char for min and max magnitude
      character*7 lolata, hilata  ! aux char for lower and upper latitude
      character*8 lolona, hilona  ! aux char for lower and upper longitude
      character*8 maxgapa, mingapa  ! aux char for lower and upper gap
      character*5 minhedeptha     ! aux char for minimum hypocenter error depth
      character*5 maxhedeptha     ! aux char for maximum hypocenter error depth
      character*7 minhelata       ! aux char for minimum hypocenter error lat
      character*7 maxhelata       ! aux char for maximum hypocenter error lat
      character*8 minhelona       ! aux char for minimum hypocenter error long
      character*8 maxhelona       ! aux char for maximum hypocenter error long
      character*5 mnupola         ! aux char minumum number of polarities
      integer stcodes             ! status codes
      integer count               ! counter for blank input
      integer index, inde1,       
     *        inde2, inde3        ! aux index
      character*1 fpsolutin       ! reading for ftpsolut
      character*1 eqfeltin        ! reading for eqfelt
      character*40 wave_check    ! string to identify wave form file name
      logical header_check        ! checking all headers
      logical found               ! aux for loop
      logical default             ! Previously undefined (JAB).
      integer ind                 ! Indicator            (JAB).
      integer  i,code
      logical hyp_dist           ! if true, use hypocentral distance

      character*4 phase(6)       ! phase names to select
      character*6 volcanictype(10)   ! volcanic subclasses
      integer seiclen

      double precision time1,time2,timcen
C
      common/epicrite/hilat,lolat,hilon,
     *                lolon,minmag,maxmag,minrms,maxrms,mindepth,
     *                maxdepth,minhelat,maxhelat,minhelon,maxhelon,
     *                minhedepth,maxhedepth,ypol,iant,mnupol
      common/epicrit2/fpsolut,eqfelt,statselect
      common/epicrit1/mindist,maxdist,
     *                hypaselect,magaselect 
      common/epicrit3/default,eventtype,disttype,magtypes,volcanictype
      common/epicrit4/minstation,maxstation,stat_present,hypa_present,
     *                maga_present,header_check,wave_check
      common/epicrit5/time1,time2,timcen,all_stat,mingap,maxgap,phase,
     *                stat_phase,hyp_dist


      idist=0
c      do i=1,5  
c  5-7-200 jh    magtypest(i)=' '
c  ----------    disttypet(i)=' '
c  ---------    eventtypet(i)=' '
c      end do                        ! not sure why it was here

c-formats used in the subroutine

 900  format ('  SELECT NUMBER TO CHANGE PARAMETER, RETURN TO SEARCH: '
     *,$)
 901  format ('  Maximum RMS, return for default: ',$)
 902  format ('  Minimum Number of Stations, return for default: ',$)
 903  format ('  Magnitude Type. Any combinations of C, L, B, S, E.G. ' 
     *        ,'CB for CODA and MB.'
     *       /,'  Return for all types.',
     *        ' Enter with the value for Magnitude Type: ',$)
 904  format ('  Distance ID. Any combinations of L, R, D, E.G. LR '
     *        ,'for Local and Regional.'
     *       /,'  Return for all types.',
     *        ' Enter with the value(s) for Distance ID: ',$)
 905  format ('  Event ID. Any combinations of E, P, V, S, Q, E.G. '
     *        ,'QE for Quakes and Explosions.'
     *       /,'  Return for all types.',
     *        ' Enter with the value(s) for Event ID: ',$)
 906  format ('  Minimum Magnitude, return for default: ',$)
 907  format ('  Maximum Magnitude, return for default: ',$)
 908  format ('  Lower Latitude Limit, return for default: ',$)
 909  format ('  Upper Latitude Limit, return for default: ',$)
 910  format ('  Lower Longitude Limit, return for default: ',$)
 911  format ('  Upper Longitude Limit, return for default: ',$)
 912  format ('  Minimum Depth Limit, return for default: ',$)
 913  format ('  Maximum Depth Limit, return for default: ',$)
 914  format ('            ',$)
 915  format ('  Something wrong. Default value assumed.')
 916  format ('  Some wrong value not considerated.')
 917  format ('  Default value assumed.')
 918  format ('  Ok. Input realized successfully.')
 919  format 
     *       ('  Station, component, distance range and phase',
     *        ' which at least one '
     *        ,'should be present.'
     *       /, '  Example is BERG LZ, BERGE,     LZ'
     *       /,'  One per line, end with return, or return for '
     *        ,'defaults: '
     *       /,'            STAT CO MINDIS MAXDIS PHAS') 
 920  format (6x,'10  - RMS Limits',30x,f5.1,6x,f5.1)
 921  format (6x,'6   - Magnitude Limits',23x,f6.1,5x,f6.1)
 922  format (6x,'7   - Latitude Limits',23x,f7.3,4x,f7.3)
 923  format (6x,'8   - Longitude Limits',21x,f8.3,3x,f8.3)
 924  format (6x,'9   - Depth Limits',25x,f8.1,3x,f8.1)
 925  format ('  Fault Plane Solution. Yes or No: ',$)
 926  format ('  Earthquake Felt. Yes or No: ',$)
 927  format ('  Minimum RMS, return for default: ',$)
 928  format ('  Maximum Number of Stations, return for default: ',$)
 929  format (6x,'12  - Hypocenter Errors Latitude Limits',5x,f9.2,
     *        4x,f9.2)
 930  format (6x,'13  - Hypocenter Errors Longitude Limits',4x,f9.2,
     *        4x,f9.2)
 931  format (6x,'14  - Hypocenter Errors Depth Limits',10x,f8.1,
     *        6x,f8.1)
 932  format ('  Minimum hypocenter error latitude, return for  
     *        default: ',$)
 933  format ('  Maximum hypocenter error latitude, return for  
     *        default: ',$)
 934  format ('  Minimum hypocenter error longitude, return for  
     *        default: ',$)
 935  format ('  Maximum hypocenter error longitude, return for  
     *        default: ',$)
 936  format ('  Minimum hypocenter error depth, return for  
     *        default: ',$)
 937  format ('  Maximum hypocenter error depth, return for  
     *        default: ',$)
 938  format
     *(6x,'18  - Station Codes, components, distance range and phase')
 939  format (6x,'18  - Stat-comp Codes: ',6(a7,1x))
 940  format (29x,6(a7,1x))
 941  format ('  Hypocenter agencies for agencies of which at least '
     *        ,'one should be present.'
     *       /,'  One per line, end with return, or return for '
     *        ,'defaults: ')
 942  format ('  Magnitude agencies for agencies of which at least '
     *        ,'one should be present.'
     *       /,'  One per line, end with return, or return for '
     *        ,'defaults: ')
 943  format (6x,'16  - Hypocenter Agencies')
 944  format (6x,'16  - Hypocenter Agencies: ',10a4)
 945  format (6x,'17  - Magnitude Agencies')
 946  format (6x,'17  - Magnitude Agencies:  ',10a4)
 947  format (6x,'19  - Polygon')
 948  format ('  Minimum number of polarities, return for  
     *        default: ',$)
 949  format (6x,'15  - Minimum Number of Polarities')
 950  format (6x,'15  - Minimum Number of Polarities: ',10x,i5)
 951  format ('  Points of polygon where events should be inside. '
     *        ,'Minimum of 3 points required.'
     *       /,'  One (lat-lon) pair per line, end with return,',
     *          ' or return for '
     *        ,'defaults: ')
 952  format ('  Some wrong point not considered.') 
 953  format ('  Less than 3 points defined. Default value assumed.')
 954  format (14x,'Latitude:  ',f7.1,1x,f7.1,1x,f7.1,1x,f7.1,1x,f7.1,1x)
 955  format (14x,'Longitude: ',f7.1,1x,f7.1,1x,f7.1,1x,f7.1,1x,f7.1,1x)
 956  format ('  Check all header lines. Yes or No: ',$)
 957  format ('  Give waveform file name chars, * for any name ',$)
 958  format ('  Minimum gap, return for default: ',$)
 959  format ('  Maximum gap, return for default: ',$)
 960  format
     *('  Phases, max 6 phases of 4 chars each ( e.g. P   SSS S): ',$)
 961  format ('  Volcanic subclasses, max 10 classes of 6 char, press en
     *ter after each type: ')


c-variables inicialization

      stcodes = 9
      statusaux = 0

c-for each option where the reading variable is integer or real,
c-it checks iostatus. if iostatus not equal 0, sets variable 
c-stcodes for an error message and current variable reading with default.
c-checks if the current variable reading is blank. If yes, sets variable
c-stcodes for a default message and current variable reading with default.
c-If not, sets variable stcodes for a succesfully input.

c-checking if option equal 1 
         if (option(1:3) .eq. '1  ') then
c-writing message and reading value for fault plane solution
             fpsolut = .false.
             write (6,*) ' '
             write (6,925)
             read (5,'(a)') reading
             call aligncha(reading)
             fpsolutin(1:1) = reading(1:1)
             if (fpsolutin .eq. 'y' .or. fpsolutin .eq. 'Y') then
                 fpsolut = .true.
                 stcodes = 0
             else if (fpsolutin .eq. 'n' .or. fpsolutin .eq. 'N') then 
                 stcodes = 0
             else 
                 stcodes = 2
             end if
         else if (option(1:3) .eq. '20 ') then
c-writing message and reading value for checking all header lines
             header_check = .false.
             write (6,*) ' '
             write (6,956)
             read (5,'(a)') reading
             call aligncha(reading)
             fpsolutin(1:1) = reading(1:1)
             if (reading(1:1) .eq. 'y' .or. reading(1:1) .eq. 'Y') then
                 header_check = .true.
                 stcodes = 0
             else if (reading(1:1) .eq. 'n' .or. reading(1:1) .eq. 'N')
     *       then 
                 stcodes = 0
             else 
                 stcodes = 2
             end if
         else if (option(1:3) .eq. '21 ')then
c-writing message and reading value for getting events with given wave file 
c name
             wave_check = ' '
             write (6,*) ' '
             write (6,957)
             read (5,'(a)') wave_check
             stcodes = 0

c-checking if option equal 2
         else if (option(1:3) .eq. '2  ') then
c-writing message and reading value for earthquake felt
             eqfelt = .false.
             write (6,*) ' '
             write (6,926)
             read (5,'(a)') reading
             call aligncha(reading)
             eqfeltin = reading
             if (eqfeltin .eq. 'y' .or. eqfeltin .eq. 'Y') then
                 eqfelt = .true.
                 stcodes = 0
             else if (eqfeltin .eq. 'n' .or. eqfeltin .eq. 'N') then
                 stcodes = 0
             else 
                 stcodes = 2
             end if

c-checking if option equal 3
         else if (option(1:3) .eq. '3  ') then
c-writing message and reading value for magnitude type
             count = 0
             write (6,*) ' '
             write (6,903)
             read (5,'(a)') reading
             call aligncha(reading)
             do ind = 1,5
                magtypes(ind) = reading(ind:ind)
             end do
c             read (5,'(5a1)') magtypes
             do ind = 1,5
                magtypest(ind) = ' '
c-checking if some wrong value was typed
                if (magtypes(ind) .ne. ' ' .and.
     *              magtypes(ind) .ne. '_' .and.    ! blank magnitudes
     *              magtypes(ind) .ne. 'C' .and. 
     *              magtypes(ind) .ne. 'c' .and.
     *              magtypes(ind) .ne. 'N' .and.    ! no magnitude
     *              magtypes(ind) .ne. 'n' .and.
     *              magtypes(ind) .ne. 'B' .and.
     *              magtypes(ind) .ne. 'b' .and.
     *              magtypes(ind) .ne. 'L' .and.
     *              magtypes(ind) .ne. 'l' .and. 
     *              magtypes(ind) .ne. 'S' .and.
     *              magtypes(ind) .ne. 's' .and.
     *              magtypes(ind) .ne. 'W' .and.
     *              magtypes(ind) .ne. 'w') then
                    stcodes = 3
                    magtypes(ind) = ' '
                else 
c-making upper case for valid values
                    if (magtypes(ind) .eq. 'c') then
                        magtypes(ind) = 'C'
                    else if (magtypes(ind) .eq. 'b') then
                        magtypes(ind) = 'B'
                    else if (magtypes(ind) .eq. 'l') then
                        magtypes(ind) = 'L'
                    else if (magtypes(ind) .eq. 'n') then
                        magtypes(ind) = 'N'
                    else if (magtypes(ind) .eq. 's') then
                        magtypes(ind) = 'S'
                    else if (magtypes(ind) .eq. 'w') then
                        magtypes(ind) = 'W'
                    end if
                end if
             end do
             index = 5
             do ind = 5,1,-1
                if (magtypes(ind) .ne. ' ') then
                    magtypest(index) = magtypes(ind)
                    index = index - 1
c-counting blank magnitude types
                else if (magtypes(ind) .eq. ' ') then
                    count = count + 1
                end if
             end do
c-checking if number of magnitude type equal 5. If yes, sets 
c-variable stcodes for default message. If no, checks if stcodes
c-still has the original value (9) avoiding to overwrite stcodes
c-in case of different value.
             if (count .eq. 5) then
                 stcodes = 2
             else 
                  if (stcodes .eq. 9) stcodes = 0
             end if
c
c  replace blank types with a *
c
             do i=2,5
               if(magtypes(i).eq.' ') magtypes(i)='*'
             enddo

c-checking if option equal 4
         else if (option(1:3) .eq. '4  ') then
             count = 0 
c-writing message and reading value for distance id
             write (6,*) ' '
             write (6,904)
             read (5,'(a)') reading
             call aligncha(reading)
             do ind = 1,5
                disttype(ind) = reading(ind:ind)
             end do
c             read (5,'(5a1)') disttype
             do ind = 1,5
                disttypet(ind) = ' '
c-checking if some wrong value was typed
                if (disttype(ind) .ne. ' ' .and.
     *              disttype(ind) .ne. 'L' .and.
     *              disttype(ind) .ne. 'l' .and.
     *              disttype(ind) .ne. 'R' .and.
     *              disttype(ind) .ne. 'r' .and.
     *              disttype(ind) .ne. 'D' .and.
     *              disttype(ind) .ne. 'd') then
                    stcodes = 3 
                    disttype(ind) = '%'
                else 
c-making upper case for valid values
                    if (disttype(ind) .eq. 'l') then
                        disttype(ind) = 'L'
                    else if (disttype(ind) .eq. 'r') then
                        disttype(ind) = 'R'
                    else if (disttype(ind) .eq. 'd') then
                        disttype(ind) = 'D'
                    end if
                end if
             end do
             index = 5
             do ind = 5,1,-1
                if (disttype(ind) .ne. ' ' .and. 
     *              disttype(ind) .ne. '%') then
                    disttypet(index) = disttype(ind)
                    index = index - 1
c-counting blank distance id
                else if (disttype(ind) .eq. ' ' .or.
     *                   disttype(ind) .eq. '%') then
                    count = count + 1
                end if
             end do

c-checking if number of magnitude type equal 5. If yes, sets
c-variable stcodes for default message. If no, checks if stcodes
c-still has the original value (9) avoiding to overwrite stcodes
c-in case of different value.
             if (count .eq. 5) then
                 stcodes = 2
             else
                  if (stcodes .eq. 9) stcodes = 0
             end if
             if (disttype(1) .ne. ' ') then
                 do ind = 1,5
c-if blank, making sure the type is set with something not used
                   if (disttype(ind) .eq. ' ') then
                       disttype(ind) = '%'
                   end if
                 end do 
             end if

c-checking if option equal 5
         else if (option(1:3) .eq. '5  ') then
             count = 0
c-writing message and reading value for event id
             write (6,*) ' '
             write (6,905)
             read (5,'(a)') reading
             call aligncha(reading)
             do ind = 1,5
                eventtype(ind) = reading(ind:ind)
             end do
c             read (5,'(5a1)') eventtype
             do ind = 1,5
                eventtypet(ind) = ' '
c-checking if some wrong value was typed
c               if (eventtype(ind) .ne. ' ' .and.
c    *              eventtype(ind) .ne. 'E' .and.
c    *              eventtype(ind) .ne. 'e' .and.
c    *              eventtype(ind) .ne. 'P' .and.
c    *              eventtype(ind) .ne. 'p' .and.
c    *              eventtype(ind) .ne. 'V' .and.
c    *              eventtype(ind) .ne. 'v' .and.
c    *              eventtype(ind) .ne. 'S' .and.
c    *              eventtype(ind) .ne. 's' .and.
c    *              eventtype(ind) .ne. 'Q' .and.
c    *              eventtype(ind) .ne. 'q') then
c                   stcodes = 3
c                   eventtype(ind) = '%'
c               else
c-making upper case for valid values
                    if (eventtype(ind) .eq. 'e') then
                        eventtype(ind) = 'E'
                    else if (eventtype(ind) .eq. 'p') then
                        eventtype(ind) = 'P'
                    else if (eventtype(ind) .eq. 'v') then
                        eventtype(ind) = 'V'
                    else if (eventtype(ind) .eq. 's') then
                        eventtype(ind) = 'S'
                    else if (eventtype(ind) .eq. 'q') then
                        eventtype(ind) = 'Q'
                    end if
c               end if
             end do
             index = 5
             do ind = 5,1,-1
                if (eventtype(ind) .ne. ' ' .and.
     *              eventtype(ind) .ne. '%') then
                    eventtypet(index) = eventtype(ind)
                       index = index - 1
c-counting blank event id
                else if (eventtype(ind) .eq. ' ' .or.
     *                   eventtype(ind) .eq. '%') then
                    count = count + 1
                end if
             end do
c-checking if number of magnitude type equal 5. If yes, sets
c-variable stcodes for default message. If no, checks if stcodes
c-still has the original value (9) avoiding to overwrite stcodes
c-in case of different value.
             if (count .eq. 5) then
                 stcodes = 2
             else
                  if (stcodes .eq. 9) stcodes = 0
             end if
             if (eventtype(1) .ne. ' ') then
                 do ind = 1,5
c-if blank, making sure the type is set with something not used
                   if (eventtype(ind) .eq. ' ') then
                       eventtype(ind) = '%'
                   end if
                 end do
             end if


c-checking if option equal 23            ! phase names
         else if (option(1:3) .eq. '23  ') then
             count = 0
c-writing message and reading value for phases
             write (6,*) ' '
             write (6,960)
             read (5,'(6a4)') phase
         else if (option(1:3) .eq. '24  ') then
             write (6,*) ' '
             write (6,961)
             ind=0
1961         continue
             ind=ind+1
             read(5,'(a6)') volcanictype(ind)
             if (seiclen(volcanictype(ind)).gt.0) goto 1961

c-------------------------------------------------------------------------



c-checking if option equal 6
         else if (option(1:3) .eq. '6  ') then
c-writing message and reading value for minimum magnitude 
             write (6,*) ' '
             write (6,906)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:6),'(a6)') minmaga 
             read (reading (1:6),'(f6.0)',err=103,iostat=status) minmag
 103         continue
             if (status .ne. 0) then  
                 stcodes = 1
                 statusaux = status
                 minmag = -990.0
             else
                  if (ichar(minmaga(1:1)) .eq. 32) then
                      minmag = -990.0
                      stcodes = 2
                  else if (ichar(minmaga(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum magnitude
             write (6,*) ' '
             write (6,907)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:6),'(a6)') maxmaga 
             read (reading (1:6),'(f6.0)',err=104,iostat=status) maxmag
 104         continue
             if (status .ne. 0) then  
                 maxmag = 999.0
                 stcodes = 1
             else
                  if (ichar(maxmaga(1:1)) .eq. 32) then
                      maxmag = 999.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxmaga(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if

c-checking if option equal 7
         else if (option(1:3) .eq. '7  ') then
c-writing message and reading value for minimum latitude
             write (6,*) ' '
             write (6,908)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:7),'(a7)') lolata 
             read (reading (1:7),'(f7.0)',err=105,iostat=status) lolat
 105         continue
             if (status .ne. 0) then    
                 statusaux = status
                 lolat = -90.0
                 stcodes = 1
             else
                  if (ichar(lolata(1:1)) .eq. 32) then
                      lolat = -90.0
                      stcodes = 2
                  else if (ichar(lolata(1:1)) .ne. 32) then
                           stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum latitude
             write (6,*) ' '
             write (6,909)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:7),'(a7)') hilata 
             read (reading (1:7),'(f7.0)',err=106,iostat=status) hilat
 106         continue
             if (status .ne. 0) then    
                 hilat = 90.0
                 stcodes = 1
             else
                  if (ichar(hilata(1:1)) .eq. 32) then
                      hilat = 90.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(hilata(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0 
                      end if
                  end if
             end if


c-checking if option equal 22
         else if (option(1:3) .eq. '22 ') then
c-writing message and reading value for minimum gap
             write (6,*) ' '
             write (6,958)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:8),'(a8)') mingapa
             read (reading (1:8),'(f8.0)',err=1077,iostat=status) mingap
 1077        continue
             if (status .ne. 0) then    
                 statusaux = status
                 mingap = 0.0
                 stcodes = 1
             else
                  if (ichar(mingapa(1:1)) .eq. 32) then
                      mingap = 0.0
                      stcodes = 2
                  else if (ichar(mingapa(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum longitude
             write (6,*) ' '
             write (6,959)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:8),'(a8)') maxgapa 
             read (reading (1:8),'(f8.0)',err=1088,iostat=status) maxgap
 1088        continue
             if (status .ne. 0) then     
                 maxgap = 360.0
                 stcodes = 1
             else
                  if (ichar(maxgapa(1:1)) .eq. 32) then
                      maxgap = 360.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxgapa(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if


c-checking if option equal 8
         else if (option(1:3) .eq. '8  ') then
c-writing message and reading value for minimum longitude
             write (6,*) ' '
             write (6,910)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:8),'(a8)') lolona 
             read (reading (1:8),'(f8.0)',err=107,iostat=status) lolon
 107         continue
             if (status .ne. 0) then    
                 statusaux = status
                 lolon = -360.0
                 stcodes = 1
             else
                  if (ichar(lolona(1:1)) .eq. 32) then
                      lolon = -360.0
                      stcodes = 2
                  else if (ichar(lolona(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum longitude
             write (6,*) ' '
             write (6,911)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:8),'(a8)') hilona 
             read (reading (1:8),'(f8.0)',err=108,iostat=status) hilon
 108         continue
             if (status .ne. 0) then     
                 hilon = 360.0
                 stcodes = 1
             else
                  if (ichar(hilona(1:1)) .eq. 32) then
                      hilon = 360.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(hilona(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if


c-checking if option equal 9
         else if (option(1:3) .eq. '9  ') then
c-writing message and reading value for minimum depth
             write (6,*) ' '
             write (6,912)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:5),'(a5)') mindeptha 
             read (reading (1:5),'(f5.0)',err=109,iostat=status) 
     *             mindepth
 109         continue
             if (status .ne. 0) then   
                 statusaux = status
                 mindepth = -99.0
                 stcodes = 1
             else
                  if (ichar(mindeptha(1:1)) .eq. 32) then
                      mindepth = -99.0
                      stcodes = 2
                  else if (ichar(mindeptha(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum depth
             write (6,*) ' '
             write (6,913)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:5),'(a5)') maxdeptha 
             read (reading (1:5),'(f5.0)',err=110,iostat=status) 
     *             maxdepth
 110         continue
             if (status .ne. 0) then    
                 maxdepth = 99999.0
                 stcodes = 1
             else
                  if (ichar(maxdeptha(1:1)) .eq. 32) then
                      maxdepth = 99999.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxdeptha(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if

c-checking if option equal 10
         else if (option(1:3) .eq. '10 ') then
c-writing message and reading value for minimum rms
             write (6,*) ' '
             write (6,927)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:4),'(a4)') minrmsa
             read (reading (1:4),'(f4.0)',err=112,iostat=status) minrms
 112         continue
             if (status .ne. 0) then
                stcodes = 1
                statusaux = status
                minrms = 0
             else
                  if (ichar(minrmsa(1:1)) .eq. 32) then
                      minrms = 0
                      stcodes = 2
                  else if (ichar(minrmsa(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum rms
             write (6,*) ' '
             write (6,901)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:4),'(a4)') maxrmsa
             read (reading (1:4),'(f4.0)',err=101,iostat=status) maxrms
 101         continue
             if (status .ne. 0) then
                stcodes = 1
                maxrms = 999
             else
                  if (ichar(maxrmsa(1:1)) .eq. 32) then
                      maxrms = 999
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxrmsa(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if

c-checking if option equal 11
         else if (option(1:3) .eq. '11 ') then
c-writing message and reading value for minimum number of stations
             write (6,*) ' '
             write (6,902)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:3),'(a3)') minstationa
             read (reading (1:3),'(i3)',err=102,iostat=status)
     *             minstation
 102         continue
             if (status .ne. 0) then
                 stcodes = 1
                 minstation = 0
             else
                  if (ichar(minstationa(1:1)) .eq. 32) then
                      minstation = 0
                      stcodes = 2
                  else if (ichar(minstationa(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum number of stations
             write (6,*) ' '
             write (6,928)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:3),'(a3)') maxstationa
             read (reading (1:3),'(i3)',err=113,iostat=status)
     *             maxstation
 113         continue
             if (status .ne. 0) then
                 stcodes = 1
                 statusaux = status
                 maxstation = 999
             else
                  if (ichar(maxstationa(1:1)) .eq. 32) then
                      maxstation = 999
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxstationa(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if

c-checking if option equal 12 
         else if (option(1:3) .eq. '12 ') then
c-writing message and reading value for minimum hypocenter error latitude
             write (6,*) ' '
             write (6,932)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:7),'(a7)') minhelata
             read (reading (1:7),'(f7.0)',err=114,iostat=status) 
     *             minhelat
 114         continue
             if (status .ne. 0) then
                 statusaux = status
                 minhelat = .0
                 stcodes = 1
             else
                  if (ichar(minhelata(1:1)) .eq. 32) then
                      minhelat = .0
                      stcodes = 2
                  else if (ichar(minhelata(1:1)) .ne. 32) then
                      stcodes=0
                  end if
             end if
c-writing message and reading value for maximum hypocenter error latitude
             write (6,*) ' '
             write (6,933)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:7),'(a7)') maxhelata
             read (reading (1:7),'(f7.0)',err=115,iostat=status) 
     *             maxhelat
 115         continue
             if (status .ne. 0) then
                 maxhelat = 99999.0
                 stcodes = 1
             else
                  if (ichar(maxhelata(1:1)) .eq. 32) then
                      maxhelat = 99999.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxhelata(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if

c-checking if option equal 13 
         else if (option(1:3) .eq. '13 ') then
c-writing message and reading value for minimum  hypocenter error longitude
             write (6,*) ' '
             write (6,934)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:8),'(a8)') minhelona
             read (reading (1:8),'(f8.0)',err=116,iostat=status) 
     *             minhelon
 116         continue
             if (status .ne. 0) then
                 statusaux = status
                 minhelon = .0
                 stcodes = 1
             else
                  if (ichar(minhelona(1:1)) .eq. 32) then
                      minhelon = .0
                      stcodes = 2
                  else if (ichar(minhelona(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum hypocenter error longitude
             write (6,*) ' '
             write (6,935)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:8),'(a8)') maxhelona
             read (reading (1:8),'(f8.0)',err=117,iostat=status) 
     *             maxhelon
 117         continue
             if (status .ne. 0) then
                 maxhelon = 99999.0
                 stcodes = 1
             else
                  if (ichar(maxhelona(1:1)) .eq. 32) then
                      maxhelon = 99999.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxhelona(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if

c-checking if option equal 14 
         else if (option(1:3) .eq. '14 ') then
c-writing message and reading value for minimum  hypocenter error depth
             write (6,*) ' '
             write (6,936)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:5),'(a5)') minhedeptha
             read (reading (1:5),'(f5.0)',err=118,iostat=status)
     *             minhedepth
 118         continue
             if (status .ne. 0) then
                 statusaux = status
                 minhedepth = -99.0
                 stcodes = 1
             else
                  if (ichar(minhedeptha(1:1)) .eq. 32) then
                      minhedepth = -99.0
                      stcodes = 2
                  else if (ichar(minhedeptha(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if
c-writing message and reading value for maximum hypocenter error depth
             write (6,*) ' '
             write (6,937)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:5),'(a5)') maxhedeptha
             read (reading (1:5),'(f5.0)',err=119,iostat=status)
     *             maxhedepth
 119         continue
             if (status .ne. 0) then
                 maxhedepth = 99999.0
                 stcodes = 1
             else
                  if (ichar(maxhedeptha(1:1)) .eq. 32) then
                      maxhedepth = 99999.0
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 2
                      end if
                  else if (ichar(maxhedeptha(1:1)) .ne. 32) then
                      if (stcodes .ne. 1 .and. stcodes .ne. 2) then
                          stcodes = 0
                      end if
                  end if
             end if

c-checking if option equal 15
         else if (option(1:3) .eq. '15 ') then
c-writing message and reading value for minimum number of polarities
             write (6,*) ' '
             write (6,948)
             read (5,'(a)') reading
             call alignnum(reading)
             read (reading (1:5),'(a5)') mnupola
             read (reading (1:5),'(i5)',err=126,iostat=status) mnupol
 126         continue
             if (status .ne. 0) then
                 stcodes = 1
                 statusaux = status
                 mnupol = 0
             else
                  if (ichar(mnupola(1:1)) .eq. 32) then
                      mnupol = 0
                      stcodes = 2
                  else if (ichar(mnupola(1:1)) .ne. 32) then
                      stcodes = 0
                  end if
             end if

c-checking if option equal 16
         else if (option(1:3) .eq. '16 ') then
             do ind = 1,10
                hypaselect(ind) = ' '
             end do
c-writing message and reading value for hypocenter agencies
             hypa_present = 0
             write (6,*) ' '
             write (6,941)
 120  continue
             write (6,914)
             read (5,'(a)') reading
             call aligncha(reading)
             hypaselect(hypa_present + 1) = reading
c             read (5,'(a3)') hypaselect(hypa_present + 1)
             if (hypaselect(hypa_present + 1) .ne. '    ') then
                 hypa_present = hypa_present + 1
                 if (hypa_present .lt. 10) then
                    goto 120
                 else
                    write (6,*) ' '
                    write (6,*) '  Array completed'
                 end if
             end if
             if (hypa_present .eq. 0) then
                 stcodes = 2
             else
                 stcodes = 0
             end if

c-checking if option equal 17
         else if (option(1:3) .eq. '17 ') then
             do ind = 1,10
                magaselect(ind) = ' '
             end do
c-writing message and reading value for hypocenter agencies
             maga_present = 0
             write (6,*) ' '
             write (6,942)
 121  continue
             write (6,914)
             read (5,'(a)') reading
             call aligncha(reading)
             magaselect(maga_present + 1) = reading
c             read (5,'(a3)') magaselect(maga_present + 1)
             if (magaselect(maga_present + 1) .ne. '    ') then
                 maga_present = maga_present + 1
                 if (maga_present .lt. 10) then
                    goto 121
                 else
                    write (6,*) ' '
                    write (6,*) '  Array completed'
                 end if
             end if
             if (maga_present .eq. 0) then
                 stcodes = 2
             else
                 stcodes = 0
             end if

c-checking if option equal 18
         else if (option(1:3) .eq. '18 ') then
             do ind = 1,50
                statselect(ind) = ' '
                mindist(ind)=0
                maxdist(ind)=99999
                stat_phase(ind)=' '
             end do
c-writing message and reading value for station codes
             stat_present = 0
             write (6,*) ' '
             write (6,919)
 100  continue
             write (6,914)
             read (5,'(a)') reading
c             call aligncha(reading)
             statselect(stat_present + 1) = reading(1:7)
             if(reading(8:14).ne.' ') then
                 read(reading(8:14),'(i7)') mindist(stat_present+1) 
                 idist=idist+1    ! count if any distance required
             endif
             if(reading(15:21).ne.' ')  then
                read(reading(15:21),'(i7)') maxdist(stat_present+1) 
                idist=idist+1
             endif
             stat_phase(stat_present+1)=reading(23:26)
c             read (5,'(a5)') statselect(stat_present + 1)
c
             if (statselect(stat_present + 1) .ne. '       ') then
                 stat_present = stat_present + 1
                 if (stat_present .lt. 50) then
                    goto 100
                 else
                    write (6,*) ' '
                    write (6,*) '  Array completed'
                 end if
             end if
             if (stat_present .eq. 0) then
                 stcodes = 2
             else
c
c   enter if all must be present
c
                 write(6,'(a)')
     *           ' Must all stat-comps be present (y/n=return)'
                 read(5,'(a)') reading
                 all_stat=.false.
                 if(reading(1:1).eq.'Y'.or.reading(1:1).eq.'y')
     *           all_stat=.true.
                 stcodes = 0
c
c  if distances used, ask if epicentral or hypocentreal
c
                if(idist.gt.0) then
                    write(6,'(a)')
     *             ' Epecentral (Return) or hypocentral distance (h) ?'
                    read(5,'(a)') reading
                    hyp_dist=.false.
                    if(reading(1:1).eq.'h'.or.reading(1:1).eq.'H')
     *              hyp_dist=.true.
                endif
             end if

c-checking if option equal 19
         else if (option(1:3) .eq. '19 ') then
             do ind = 1,20
                ypol(ind,1) = 0
                ypol(ind,2) = 0
             end do
             count = 0
c-writing message and reading value for polygon points
             write (6,*) ' '
             write (6,951)
 124  continue
             inde1 = 0
             inde2 = 0
             inde3 = 0
             found = .false.
             count = count + 1
             write (6,914)
             read (5,'(a)') reading
             if(reading(1:5).eq.'     ') go to 888   ! end of input
             call sei get values(2,reading,code)
             ypol(count,2)=array$(1)
             ypol(count,1)=array$(2)
             goto 124

ccccccccccccccc skipped, some problems
             
c-finding the exactly position for x, (,), y in the variable
             do while (.not. found .and. inde1 .ne. 80)
               inde1 = inde1 + 1
c               write(6,*) inde1
               if (reading (inde1:inde1) .ne. ' ') found = .true.
             end do
             inde2 = inde1
             if (reading (inde1:inde1) .eq. ',') then

ccc in following section, all 81 has been replaced by 80 feb 98
                 inde1 = 80
             else
                 found = .false.
             end if
             do while (.not. found .and. inde2 .ne. 80)
               inde2 = inde2 + 1
               if (reading (inde2:inde2) .eq. ',' .or.
     *             reading (inde2:inde2) .eq. ' ') found = .true.
             end do
             found = .false.
             inde3 = inde2
             do while (.not. found .and. inde3 .ne. 80)
               inde3 = inde3 + 1
               if (reading (inde3:inde3) .ne. ',' .and.
     *             reading (inde3:inde3) .ne. ' ') found = .true.
             end do
c-reading from the auxiliary variable to the array
             read (reading (inde1:inde2 - 1),'(f5.0)',err=125,
     *             iostat=status) ypol(count,2)   
             read (reading (inde3:inde3 + 5),'(f5.0)',err=125,
     *             iostat=status) ypol(count,1)
 125  continue
c-checking iostatus. if not zero, goes 1 position back in the array
             if (status .ne. 0 .and. (inde1 .ne. 80 .or.
     *           inde2 .ne. 80 .or. inde3 .ne. 80)) then
                 stcodes = 4
                 ypol(count,1) = 0
                 ypol(count,2) = 0
                 count = count - 1
             end if
             if (count .lt. 20) then
c-if inde1/2/3 not 80 means that return was not pressed for end of reading
                 if (inde1 .ne. 80 .or. inde2 .ne. 80 .or.
     *               inde3 .ne. 80) go to 124
             else
                 if (inde1 .ne. 80 .or. inde2 .ne. 80 .or.
     *               inde3 .ne. 80) then
                     write (6,*) ' '
                     write (6,*) '  Array completed'
                     count = count + 1
                 end if
             end if
 888         continue                  ! to jump section not working
             iant = count - 1
             if (iant .eq. 0) then
c-no points were written
                stcodes = 2
             else
                  if (iant .lt. 3) then
c-less than 3 points were written
                      do ind = 1,20
                        ypol(ind,1) = 0
                        ypol(ind,2) = 0
                      end do
                      stcodes = 5
                      iant = 0
                  else 
c-input ok 
                       if (stcodes .ne. 4) stcodes = 0
                  end if
             end if
         end if

c-writing main screen. When default, value is not printed

         write (6,*) ' '
         write (6,*) '            PARAMETERS'
         write (6,*) ' '
         if (fpsolut) then
             write (6,'(6x,a,21x,a)') '1   - Fault Plane Solution',
     *                                ' Yes'
         else
             write (6,'(6x,a)') '1   - Fault Plane Solution'
         end if
         if (eqfelt) then
             write (6,'(6x,a,27x,a)') '2   - Earthquake Felt','Yes' 
         else
             write (6,'(6x,a)') '2   - Earthquake Felt'
         end if
         write (6,'(6x,a,23x,5a1)') '3   - Magnitude Type(s)',
     *                            magtypest
         write (6,'(6x,a,26x,5a1)') '4   - Distance ID(s)',disttypet
         write (6,'(6x,a,29x,5a1)') '5   - Event ID(s)',eventtypet
         if (minmag .ne. -990 .or. maxmag .ne. 999) then
             write (6,921) minmag, maxmag
         else
             write (6,'(6x,a)') '6   - Magnitude Limits'
         end if
         if (lolat .ne. -90 .or. hilat .ne. 90) then
             write (6,922) lolat, hilat
         else 
             write (6,'(6x,a)') '7   - Latitude Limits'
         end if
         if (lolon .ne. -360.0 .or. hilon .ne. 360.0) then
             write (6,923) lolon, hilon
         else
             write (6,'(6x,a)') '8   - Longitude Limits'
         end if
         if (mindepth .ne. -99 .or. maxdepth .ne. 99999) then
             write (6,924) mindepth, maxdepth
         else 
             write (6,'(6x,a)') '9   - Depth Limits'
         end if
         if (minrms .ne. 0 .or. maxrms .ne. 999) then
             write (6,920) minrms, maxrms
         else
             write (6,'(6x,a)') '10  - RMS Limits'
         end if  
         if (minstation .ne. 0 .or. maxstation .ne. 999) then
             write (6,'(6x,a,a,17x,i3,8x,i3)') '11  - Number of '
     *              ,'Stations Limits', minstation, maxstation
         else
             write (6,'(6x,a)') '11  - Number of Stations Limits'
         end if
         if (minhelat .ne. 0. .or. maxhelat .ne. 99999.) then
             write (6,929) minhelat, maxhelat
         else
             write (6,'(6x,a,a)') '12  - Hypocenter Errors Latitude',
     *                          ' Limits'
         end if
         if (minhelon .ne. 0. .or. maxhelon .ne. 99999.) then
             write (6,930) minhelon, maxhelon
         else
             write (6,'(6x,a,a)') '13  - Hypocenter Errors Longitude',
     *                          ' Limits'
         end if
         if (minhedepth.ne. -99 .or. maxhedepth .ne. 99999) then
             write (6,931) minhedepth, maxhedepth
         else
             write (6,'(6x,a,a)') '14  - Hypocenter Errors Depth Limits'
         end if
         if (mnupol .eq. 0) then
             write (6,949)
         else
             write (6,950) mnupol
         end if
         if (hypa_present .eq. 0) then
             write (6,943)
         else 
             write (6,944) (hypaselect(ind),ind = 1,10)
         end if
         if (maga_present .eq. 0) then
             write (6,945)
         else
             write (6,946) (magaselect(ind),ind = 1,10)
         end if
         if (stat_present .eq. 0) then
             write (6,938)
         else if (stat_present .ge. 1 .and.
     *            stat_present .le. 6) then
             write (6,939) (statselect(ind),ind = 1,6)
         else if (stat_present .ge. 7 .and.
     *            stat_present .le. 12) then
             write (6,939) (statselect(ind),ind = 1,6)
             write (6,940) (statselect(ind),ind = 7,12)
         else if (stat_present .ge. 13 .and.
     *            stat_present .le. 16) then
             write (6,939) (statselect(ind),ind = 1,6)
             write (6,940) (statselect(ind),ind = 7,12)
             write (6,940) (statselect(ind),ind = 13,18)
         else if (stat_present .ge. 19 .and.
     *            stat_present .le. 24) then
             write (6,939) (statselect(ind),ind = 1,6)
             write (6,940) (statselect(ind),ind = 7,12)
             write (6,940) (statselect(ind),ind = 13,18)
             write (6,940) (statselect(ind),ind = 19,24)
         else if (stat_present .ge. 25 .and.
     *            stat_present .le. 30) then
             write (6,939) (statselect(ind),ind = 1,6)
             write (6,940) (statselect(ind),ind = 7,12)
             write (6,940) (statselect(ind),ind = 13,18)
             write (6,940) (statselect(ind),ind = 19,24)
             write (6,940) (statselect(ind),ind = 25,30)
         end if
         if (iant .eq. 0) then
             write (6,947)
         else if (iant .le. 5) then
              write (6,947)
              write (6,954) (ypol(ind,2),ind = 1,iant)
              write (6,955) (ypol(ind,1),ind = 1,iant)
         else if (iant .le. 10) then
              write (6,947)
              write (6,954) (ypol(ind,2),ind = 1,5)
              write (6,955) (ypol(ind,1),ind = 1,5)
              write (6,*) ' '
              write (6,954) (ypol(ind,2),ind = 6,iant)
              write (6,955) (ypol(ind,1),ind = 6,iant)
         else if (iant .le. 15) then
              write (6,947)
              write (6,954) (ypol(ind,2),ind = 1,5)
              write (6,955) (ypol(ind,1),ind = 1,5)
              write (6,*) ' '
              write (6,954) (ypol(ind,2),ind = 6,10)
              write (6,955) (ypol(ind,1),ind = 6,10)
              write (6,*) ' '
              write (6,954) (ypol(ind,2),ind = 11,iant)
              write (6,955) (ypol(ind,1),ind = 11,iant)
         else if (iant .le. 20) then
              write (6,947)
              write (6,954) (ypol(ind,2),ind = 1,5)
              write (6,955) (ypol(ind,1),ind = 1,5)
              write (6,*) ' '
              write (6,954) (ypol(ind,2),ind = 6,10)
              write (6,955) (ypol(ind,1),ind = 6,10)
              write (6,*) ' '
              write (6,954) (ypol(ind,2),ind = 11,15)
              write (6,955) (ypol(ind,1),ind = 11,15)
              write (6,*) ' '
              write (6,954) (ypol(ind,2),ind = 16,iant)
              write (6,955) (ypol(ind,1),ind = 16,iant)
         end if
         if (header_check) then
            write (6,'(6x,a,27x,a)') '20  - Use all header lines','Yes' 
         else
             write (6,'(6x,a)') '20  - Use all header lines'
         end if
         if(wave_check.ne.' ') then
            write(6,'(6x,a,a,7x,a)') '21  - Look for wave form file',
     *      ' names ',wave_check
         else
            write(6,'(6x,a,a,7x)')    '21  - Look for wave form file',
     *      ' names'
         endif

         if(maxgap.ne.360.0.or.mingap.ne.0.0) then
            write(6,'(6x,a,a,7x,f6.1,6x,f6.1)') 
     *      '22  - Gap range               ',
     *      '       ',mingap,maxgap
         else
            write(6,'(6x,a,a,7x)')    '22  - Gap range              ',
     *      '     '
         endif
         write(6,'(6x,a,a,7x,6a4)')   '23  - Phases                 ',
     *      '     ',phase
         write(6,'(6x,a,a,7x,10a6)')   '24  - Volcanic subclasses    ',
     *      '     ',volcanictype


         write (6,*) ' '

c-checkins status codes and printing messages.
c-stcodes equal 0 - everything is ok
c-stcodes equal 1 - status not equal 0
c-stcodes equal 2 - default assumed
c-stcodes equal 3 - some wrong value
c-stcodes equal 4 - wrong polygon point not considerated 
c-stcodes equal 5 - less then 3 points defined
         if (stcodes .eq. 0) then
             if (statusaux .ne. 0) then
                 write (6,915)
                 statusaux = 0 
             else if (statusaux .eq. 0) then
                 write (6,918)
             end if
         else if (stcodes .eq. 1) then
             write (6,915)
         else if (stcodes .eq. 2) then
             write (6,917)
         else if (stcodes .eq. 3) then
             write (6,916)
         else if (stcodes .eq. 4) then
             write (6,952)
         else if (stcodes .eq. 5) then
             write (6,953)
         end if
         if (option(1:1) .eq. '?') then
             write (6,*) '  Invalid Option.'
         end if
         write (6,900)
         read (5,'(a)') option
         call alignnum(option)

      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C     SUBROUTINE THAT SELECTS EVENTS AFTER GIVEN
C     CRITERIAS GIVEN IN COMMON BLOCKS
C
C     INPUT: STRING.  FIRST LINE IN THE FILE (NORDIC FORMAT)
C     OUTPUT: ALL PARAMETERS OF EVENT IN COMMON BLOCKS:'EPIVALUES'
C             AND 'EPICHAR'
C             ACCEPTED: LOGICAL THAT CAN BE TESTED ON IN THE CALLING PROGRAM
C             TIME,YEAR,MONTH,DAY,HOUR,MINUTES,SEC: TIME OF THE EVENT
C             LATI,LONG,DEPTH: LOCATION OF EVENT
C             MAG1,MAG2,MAG3,RMSVALUE,NUMBEROFSTATIONS,
C             AGENCY,MAGAGENCY,MAGTYPE
C             DEPTHID :  OTHER EVENT CHARACTERISTICS
c             start_of_time: true if not yet at start of time interval
c             end_of_time: true if behind end  of time interval
C
      SUBROUTINE EPISELEC(STRING,start_of_time,end_of_time)
      implicit none
      include 'seidim.inc'
      CHARACTER*80 STRING
	  CHARACTER*1 EVENTTYPE(5),DISTTYPE(5),MAGTYPES(5)
C--MAGNITUDE TYPE AND AGENCY
      CHARACTER*1 MAGT(3),MAGA(3)
C--MAGNITUDE IN ASCII
      CHARACTER*4 XMAG(3)
C--COUNTER FOR MAGNITUDES
      INTEGER IMAG
      CHARACTER DISTANCEID*1,EVENTID*1,DEPTHID*1,AGENCY*3,
     *           MAGTYPE*1,MAGAGENCY*3
      character*1 distanceid_local   ! for use inside routine

C  NUMBER OF STATIONS TO BE PRESENT
      INTEGER 		STAT_present		
      logical       all_stat         ! if true,  all must be present
c  number of hypocenter agencies to be present
      integer           hypa_present
c  number of magnitude agencies to be present
      integer           maga_present
C  STATION CODES FOR ABOVE
      CHARACTER*7 	STATSELECT(50)
      character*4       stat_phase(50)
      integer mindist(50),maxdist(50)  ! distance range for station	
c  hypocenter agencies
      character*3       hypaselect(10)
c  magnitude agencies
      character*3       magaselect(10)
      logical start_of_time,end_of_time
      INTEGER YEAR,MONTH,DAY,MINUTES,NUMBEROFSTATIONS,HOUR,
     *          MINSTATION,MAXSTATION,century
      double precision time1,time2,timcen,time
      REAL SEC,LATI,LONG,DEPTH,RMSVALUE,SMAG,LOLAT,
     *        HILAT,LOLON,HILON,MINMAG,MINRMS,MAXRMS,MAXMAG,
     *        MAXDEPTH,MINDEPTH,mag,maxgap,mingap,
     *     minhelat, maxhelat,
     *     minhelon, maxhelon,
     *     minhedepth, maxhedepth
      LOGICAL ACCEPTED,DEFAULT,MGT
      integer i,ind,nstat
c   fault plane solution
      logical fpsolut
c   earthquake felt
      logical eqfelt
      character*40 wave_check    ! string to identify wave form file name
      logical header_check        ! checking all headers
      real ypol(max_polyn$,2)    ! array defining polygon
      integer iant               ! number of points of the polygon
      logical insidepol          ! true - event is inside polygon
      logical hyp_dist           ! if true, use hypocentral distance

      integer mnupol             ! minumum number of polarities
      character*4 phase(6)       ! phase names to select
      character*6 volcanictype(10)   ! volcanic subclasses

      COMMON/EPIVALUE/YEAR,MONTH,DAY,HOUR,MINUTES,SEC,LATI,LONG,DEPTH,
     *                 NUMBEROFSTATIONS,RMSVALUE,MAG,ACCEPTED,nstat
C
      COMMON/EPICHAR/DISTANCEID,EVENTID,DEPTHID,AGENCY,
     *                    MAGTYPE,MAGAGENCY
C
      common/epicrite/hilat,lolat,hilon,
     *                lolon,minmag,maxmag,minrms,maxrms,mindepth,
     *                maxdepth,minhelat,maxhelat,minhelon,maxhelon,
     *                minhedepth,maxhedepth,ypol,iant,mnupol
      common/epicrit2/fpsolut,eqfelt,statselect
      common/epicrit1/mindist,maxdist,
     *                hypaselect,magaselect 
      common/epicrit3/default,eventtype,disttype,magtypes,volcanictype
      common/epicrit4/minstation,maxstation,stat_present,hypa_present,
     *                maga_present,header_check,wave_check
      common/epicrit5/time1,time2,timcen,all_stat,mingap,maxgap,phase,
     *                stat_phase,hyp_dist
C
      READ(STRING,10,ERR=20)
     *CENTURY,YEAR,MONTH,DAY,HOUR,MINUTES,SEC,DISTANCEID_LOCAL,
     *           EVENTID,LATI,LONG,DEPTH,DEPTHID,AGENCY,
     *           NUMBEROFSTATIONS,RMSVALUE,XMAG(1),MAGT(1),MAGA(1),
     *           XMAG(2),MAGT(2),MAGA(2),XMAG(3),MAGT(3),MAGA(3)
10    FORMAT(1X,2I2,1x,2I2,1X,I2,I2,1X,F4.0,1X,A1,A1,F7.0,F8.0,F5.0,
     *      A1,1X,A3,I3,F4.1,A4,A1,A3,A4,A1,A3,A4,A1,A3)
c
c   if number of stations is there, there might be stations since there will
c   only be a number in the header if the event could be located, therefore
c   check with nstat
c
      if(numberofstations.eq.0) numberofstations=nstat
      goto 25
c
c  give error message and try next record
c
20    CONTINUE
         write(6,*)'Something wrong with input record'
         write(6,'(1x,a)') string
         accepted=.false.
         goto 9999                        ! Return to caller.
25    continue


      ACCEPTED=.FALSE.
      end_of_time=.false.
      start_of_time=.false.
c                                                                               
c   convert to seconds since 1900, even if century is not 1900
c   since this is corrected for below. 
c                                                                               
c
c   add century, assume 1900 if not there 
c
      if(century.eq.0) century=19
      year=year+1900
      call timsec(year,month,day,hour,minutes,sec,time)                        
      time=time+century*timcen
ctest     write(6,*)'temcen,century',timcen,century
ctest             write(6,*)'time,time1,time2',time,time1,time2
         if(time.gt.time2) end_of_time=.true.
         if(time.lt.time1) start_of_time=.true.
         if(end_of_time.or.start_of_time) goto 99
C
C
C     RETURN EPIVALUESPARAMETERS IF NO SELECTION PARAMETERS
C     EXCEPT TIME ARE ACTIVE
C    
      IF(DEFAULT)THEN
            ACCEPTED=.TRUE.
            goto 9999                        ! Return to caller.
      ENDIF
C
C     MAGNITUDE SELECTION, TYPE MUST BE CORRECT OR DEFAULT INDICATED
C     BY MAGTYPES(1).EQ.' '. IF TYPE IS OK, LARGEST MAGNITUDE IS SELECTED
C     OF THE TYPES PERMITTED. IF XMAG IS BLANK, THERE IS NO MAGNITUDE
C
c
c   special option, if magtype is N, only events with no magnitude in 
c   first position is chosen
c
      if(magtypes(1).eq.'N'.and.xmag(1).eq.'    ') goto 501
      if(magtypes(1).eq.'_') magtypes(1)='_'
   
      MAG=-1000.0
C
C   FIRST CHECK IF MAG TYPE OK
C
      MGT=.FALSE.
      IF(MAGTYPES(1).EQ.' ') MGT=.TRUE.
      IF(.NOT.MGT) THEN
         DO IMAG=1,3
            IF(XMAG(IMAG).NE.'    ') THEN
               DO I=1,5
                  IF(MAGT(IMAG).EQ.MAGTYPES(I)) MGT=.TRUE.
                  if(magt(imag).eq.' '.and.magtypes(i).eq.'_') 
     *            mgt=.true.   ! magnitudes with no magnitude type
               ENDDO
            ENDIF
         ENDDO
      ENDIF
      IF(.NOT.MGT) GOTO 99
C
C   SELECT FOR MAGNITUDE SIZE, IF MINMAG IS -990, and
c   maxmag is 999.0, NO SELECTION ON MAG
C
      IF(.not.(MINMAG.eq.-990.0.and.maxmag.eq.999.0)) then
         DO IMAG=1,3
            IF(XMAG(IMAG).NE.'    ') THEN
               DO I=1,5
                  IF(MAGT(IMAG).EQ.MAGTYPES(I).OR.MAGTYPES(1).EQ.' ')
     *            THEN
                     READ(XMAG(imag),'(F4.1)') SMAG
                     IF(SMAG.GT.MAG) THEN
                        MAG=SMAG
                        MAGAGENCY=MAGA(IMAG)
                        MAGTYPE=MAGT(IMAG)
                     ENDIF
                  ENDIF
               ENDDO
            ENDIF
         ENDDO
         IF (MAG.LT.MINMAG.OR.MAG.GT.MAXMAG)GO TO 99
      ENDIF
C
  501 continue                  ! enter here if special mag selection
c
      if (numberofstations .lt. minstation .or.
     *    numberofstations .gt. maxstation) go to 99
C	  
C   SELECT FOR EVENT TYPES
C
      if(disttype(1).eq.'_'.or.disttype(1).eq.'%') then
         disttype(1)='L' 
         disttype(2)='R'
         disttype(3)='D'
      endif
      IF(DISTTYPE(1).NE.' ') THEN
         DO I=1,5
           IF(DISTANCEID_LOCAL.EQ.DISTTYPE(I)) GOTO 50
         ENDDO
         GOTO 99
      ENDIF
 50   CONTINUE
C
C   SELECT ON EVENTTYPE, A BLANK IN NORDIC FILE MEANS EARTHQUAKE,
C   WHICH IS INDICATED BY Q IN SELECTION CRITERIAS. IF EVENTTYPE(1)
C   IS BLANK, ALL EVENT TYPES ARE USED
c
c   if eventtype(1) is '_', is same as blank
C
      if(eventtype(1).eq.'_') eventtype(1)=' '
	  
      IF(EVENTTYPE(1).NE.' ') THEN
	     DO I=1,5
		    IF(EVENTID.EQ.EVENTTYPE(I)) GOTO 55
            IF(EVENTID.EQ.' '.AND.EVENTTYPE(I).EQ.'Q') 
     *      GOTO 55
         ENDDO
         GOTO 99
      ENDIF
 55   CONTINUE
c
c   if there is no location and lat lon depth is not default
c   event is not selected
c
      if (string(24:30).eq.'       ') then
c changed lo 08 March 2001 for seisweb
        if
     *    ((hilat.ne.90.0.or.hilon.ne.360.0.or.lolat.ne.-90.0.
     *    or.lolon.ne.-360.0).and.     
     *    (hilat.ne.90.0.or.hilon.ne.180.0.or.lolat.ne.-90.0.
     *    or.lolon.ne.-180.0)) then
            goto 99
        endif
      endif
      IF (LATI.LT.LOLAT.OR.LATI.GT.HILAT) GO TO 99
      IF (LONG.LT.LOLON.OR.LONG.GT.HILON) GO TO 99
      IF (DEPTH.LT.MINDEPTH.OR.DEPTH.GT.MAXDEPTH) GO TO 99
c
c   negative rms means larger than
c
      IF (maxrms .lt. 0.0) then
          if (rmsvalue .ge. abs(minrms) .and.
     *        rmsvalue .le. abs(maxrms)) goto 999
          goto 99
      else
          if (rmsvalue .lt. minrms .or.
     *        rmsvalue .gt. maxrms) go to 99
      endif

c
c   calling routine for check if event is inside polygon
c
      if (iant .ge. 3) then
          call polos(lati,long,ypol,iant,insidepol)
          if (.not. insidepol) go to 99
      end if

c  
c   check for required hypocenter agencies if wanted, at least one of agencies 
c   in hypaselect must be present to select event
      if (hypa_present .gt. 0) then
          do ind=1,hypa_present
            if (hypaselect(ind) .eq. agency) go to 999
          end do
          go to 99
      end if
c 
c   check for required magnitude agencies if wanted, at least one of agencies
c   in magaselect must be present to select event
      if (maga_present .gt. 0) then
          do ind=1,maga_present
            if (magaselect(ind) .eq. string (61:63)) go to 999
            if (magaselect(ind) .eq. string (69:71)) go to 999
            if (magaselect(ind) .eq. string (77:79)) go to 999
          end do
          go to 99
      end if
C
      GO TO 999
99    ACCEPTED=.FALSE.         
      goto 9999                                ! Return to caller.
999   ACCEPTED=.TRUE.
C
C    Return to caller...
C    ===================
C
9999  return
      END

      subroutine epibase(basename,starttime,endtime,
     *nstat,nphase,nhead,nrecord,typ,exp,data,id,status,compact,nout,
     *ncat_files,cat_files)
c
c     Subroutine to operate on the epicenter database.
c     Routine is called in a loop, and returns one event
c     return variables nstat etc as in main program
c
c     input: basename: e.g. agency 
c            starttime: 14 char standard time
c            endtime:   --------------------- end time
c            century1,century2: start and end century
c            ncat_files : number of cat files
c            cat_files  : cat file names
c     output: standard
c             status: 0: ok
c                     1: end of data base, if -1 on input, just write statistics
      implicit none
c--standard variables
      integer nstat,nphase,nhead,nrecord,id
      character*1 typ,exp
      character*80 data(*)
      character*80 cat_files(*)
      integer ncat_files
      integer nout_start                 ! # events at start of new cat file
      integer n_event_cat                ! coute events in one cat file
c-- number of events selected so far
      integer nout
c-- name of file to read
      character*80 filename	
c! data base name
      character*80 basename	  	
c-- status of read 0: ok 1: end of data
      integer status				
c-- times
      integer time1,time2,time			
      character*14 starttime,endtime
c  help text
c-- epi file name
      character*80 epifile
c  top directory structure
      character*60 top_directory	
c-- century
c-- logicals for file open etc
      logical epi_open,base_open,compact
c--help variables
      integer i2,nfile
      character*1 dchar
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
      integer*4 
     &          read2,                     ! Ditto 2.
     &          code                       ! Local condition.
      logical*4 b_flag                     ! Flag end of file?.
      character chr_text *(80)             ! Text string.
C
C     *********** End of inserts *********
c
c     inizialize
c
      if(status.eq.-1) goto 999
      status=0
      call dir_char(dchar)
c
c   open epicenter data base meaning finding correct position in list
c   of data base file names according to start time
c
         if(.not.base_open) then
            nout_start=0
c
c  get starttime and end time to nearest month
c
            read(starttime(1:6),'(i6)') time1
            read(endtime(1:6),'(i6)') time2
            write(6,*)' '
c
c  get topdirectory structure
c
            call topdir(top_directory)
            i2=index(top_directory,' ')-1
            base_open=.true.
c
c   find base index file name
c
            filename(1:i2)=top_directory(1:i2)
            filename(i2+1:i2+1)=dchar
            filename(i2+2:i2+4)='REA'
            filename(i2+5:i2+5)=dchar
            filename(i2+6:i2+10)=basename(1:5)
            filename(i2+11:i2+11)=dchar
            filename(i2+12:i2+14)='CAT'
            filename(i2+15:i2+15)=dchar
c           
c   position pointer at first cat file to use 
c
            nfile=0
 450        continue                                    ! loop to find file
               nfile=nfile+1                            ! next file
               if(nfile.gt.ncat_files)     goto 460     ! last file
               epifile=cat_files(nfile)                 ! select file
               read(epifile,'(i6)') time                ! start time of file
C
c   check if containing start time
c
               if(time.gt.time1) then                   ! after start time
                  nfile=nfile-1                         ! back one file
                  if(nfile.le.0) nfile=1
                  goto 470                              ! found, go out
               else
                   goto 450                             ! try next
               endif
c
 460        continue
c
c   no file was found that has a start time equal to or smaller than 
c   requested time. However, if there was at least one cat file covering  
c   several months, start time could be in that file. Therefore try to use 
c   cat file before.
c
            if(nfile.gt.0) then
                 nfile=nfile-1
               if(nfile.le.0) nfile=1
            endif
 470        continue
            nfile=nfile-1     ! -1 since added again before oepning below
         endif                ! end of block finding right first epi file 
c
c  check if epifile is open
c
 475  continue
C
      if(.not.epi_open) then
         nfile=nfile+1
         if(nfile.gt.ncat_files) goto 480
c
c   check that next file is not beyond time limit
c
            epifile=cat_files(nfile)
            read(epifile,'(i6)') time
            if(time.gt.time2) goto 480
            chr_text = filename(1:i2+15) //  ! Construct filename.
     &                 epifile               !
            call sei open( old$,             ! Open file (default=stop on error)
     &                     ' ',              ! Prompt (n/a).
     &                     chr_text,         ! Filename.
     &                     read2,            ! Unit opened on.
     &                     b_flag,           ! Flag.
     &                     code )            ! Returned condition.
c
c   check if compact file
c
            call nortype(read2,compact)      !
            if(compact) write(6,*)' File type is compact'
            epi_open=.true.
            n_event_cat=0                    ! count number of events in file
            nout_start=nout                  ! save # of events selected
            goto 485
C
C    End of list...Close down filenr.lis and return to caller...
C    -----------------------------------------------------------
C
480         continue 
            status=1
            goto 9999                          ! Return to caller.
C
 485        continue
         endif
c
c   read one event
c
        if(.not.compact) then
           call indata(read2,nstat,nphase,nhead,  !
     &                 nrecord,typ,exp,data,id)
        else
           read(read2,'(a)',iostat=code) data(1)  ! Read record.
           call sei code(fort$,                   ! Stop on error.
     &                   code,                    ! Condition.
     &                   read2,                   ! Of fortran unit.
     &                   b_flag)                  ! Flag end of file.
           if( b_flag ) goto 150                  ! & go there!!.
C
           nstat=0
           nphase=0
           nhead=1
           nrecord=1
           typ=data(1)(22:22)
           exp=data(1)(23:23)
           goto 151
 150       continue
              nrecord=0
 151       continue
        endif
c
c   check if end of file
c
 999    continue
        if(nrecord.eq.0.or.status.eq.-1) then
           epi_open=.false.
           if(status.eq.-1) n_event_cat=n_event_cat-1
c
c   write out number of events selected so far and events in cat file
c
           write(6,'(1x,a,2x,a,i7,2x,a,i6,2x,a,i7)') 
     *     epifile(1:10),'No of events:', 
     *     n_event_cat,'Selected:',nout-nout_start,
     *     'Selected total:', nout
           if(status.ne.-1) then
              call sei close(close$,read2,code ) ! Close but stop on error.
              goto 475
           else
              return
           endif
        endif
        n_event_cat=n_event_cat+1              ! count number of events
        status=0
C
C    Return to Caller...
C    ===================
C
9999    return
        end



      subroutine alignnum(reading)
      implicit none
      integer ind, index                    ! index
      integer counter                       ! counter
      character*80 auxreading               ! aux for reading
      character*80 reading                  ! reading

      index = 0
      counter = 0

c-selecting only numeric characters
      do ind = 1,80
         if (reading(ind:ind) .eq. '0'.or. 
     *       reading(ind:ind) .eq. '1' .or.
     *       reading(ind:ind) .eq. '2' .or.
     *       reading(ind:ind) .eq. '3' .or.
     *       reading(ind:ind) .eq. '4' .or.
     *       reading(ind:ind) .eq. '5' .or.
     *       reading(ind:ind) .eq. '6' .or.
     *       reading(ind:ind) .eq. '7' .or.
     *       reading(ind:ind) .eq. '8' .or.
     *       reading(ind:ind) .eq. '9' .or.
     *       reading(ind:ind) .eq. '-' .or.
     *       reading(ind:ind) .eq. '+' .or.
     *       reading(ind:ind) .eq. '.') then
             index = index + 1
             auxreading (index:index) = reading (ind:ind)
         else
             if (reading(ind:ind) .eq. ' ') counter = counter + 1
         end if
      end do
c-if counter ne 80 means some not blank character has been reading
c-if index eq 0 means no valid character has been reading
c-checking if there is some unvalid character
      if (counter .ne. 80 .and. index .eq. 0) then
          index = index + 1
          auxreading (index:index) = '?'
      end if
c-completing variable whit blank
      do while (index .ne. 80)
         index = index + 1
         auxreading (index:index) = ' '
      end do
      reading = auxreading
      end


      subroutine aligncha(reading)
      implicit none
      integer ind, index                    ! index
      character*80 auxreading               ! aux for reading
      character*80 reading                  ! reading

      index = 0

c-moving non blank characters for the begining
      do ind = 1,80
         if (reading(ind:ind) .ne. ' ') then
             index = index + 1
             auxreading (index:index) = reading (ind:ind)
         end if
      end do
c-completing variable whit blank
      do while (index .ne. 80)
         index = index + 1
         auxreading (index:index) = ' '
      end do
      reading = auxreading
      end


      subroutine selcrit_prompt
     *(narg,arg,starttime,endtime,basename,seisweb,
     * web_out)
c
c   routine fills in choises if from prompt line
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      integer   seiclen    ! function
      integer narg         ! number of arguments
      character*80 arg(*)  ! arguments
      character*14 starttime, endtime !  start time and end time inc. century
c  abs times

      double precision time1,time2,timcen
c  number of stations to be present
      integer           stat_present
      logical       all_stat         ! if true,  all must be present
c  number of hypocenter agencies to be present
      integer           hypa_present
c  number of magnitude agencies to be present
      integer           maga_present
      logical default
      logical seisweb  ! true if called from seisweb
      real minmag, minrms, maxrms, hilat, lolat, hilon, lolon, maxmag,
     *     mindepth, maxdepth,maxgap,mingap,
     *     minhelat, maxhelat,
     *     minhelon, maxhelon,
     *     minhedepth, maxhedepth
      integer minstation, maxstation, i, ind, j
      character*1 eventtype(5), disttype(5), magtypes(5)
      character*7 statselect(50)
      character*4 stat_phase(50)
      integer mindist(50),maxdist(50)  ! distance range for station	
      character*3 hypaselect(10), magaselect(10)
      character*80 basename      ! data base of file name of input
      character*80 userid        ! id for user, used by seisweb
c   fault plane solution
      logical fpsolut
c   earthquake felt
      logical eqfelt
      character*40 wave_check    ! string to identify wave form file name
      character*80 web_out       ! path and file name of web output
      logical header_check
      real ypol(max_polyn$,2)    ! array defining polygon
      integer iant               ! number of points of the polygon
      integer mnupol             ! minumum number of polarities
      integer code               ! error code
      logical hyp_dist           ! if true, use hypocentral distance
      character*4 phase(6)       ! phase names to select
      character*6 volcanictype(10)   ! volcanic subclasses

      common/epicrite/hilat,lolat,hilon,
     *                lolon,minmag,maxmag,minrms,maxrms,mindepth,
     *                maxdepth,minhelat,maxhelat,minhelon,maxhelon,
     *                minhedepth,maxhedepth,ypol,iant,mnupol
      common/epicrit2/fpsolut,eqfelt,statselect
      common/epicrit1/mindist,maxdist,
     *                hypaselect,magaselect 
      common/epicrit3/default,eventtype,disttype,magtypes,volcanictype
      common/epicrit4/minstation,maxstation,stat_present,hypa_present,
     *                maga_present,header_check,wave_check
      common/epicrit5/time1,time2,timcen,all_stat,mingap,maxgap,phase,
     *                stat_phase,hyp_dist

      starttime = '0500'
      endtime ='2050'
      minstation = 0
      maxstation = 999
      hilat = 90.0 
      lolat = -90.0
      hilon = 360.0
      lolon = -360.0
      minmag = -990.0
      maxmag = +999.0
      minrms = 0
      maxrms = 999.0
      mindepth = -99.0
      maxdepth = 99999.0 
      minhelat = .0
      maxhelat = 99999.0
      minhelon = .0
      maxhelon = 99999.0
      minhedepth = -99.0
      maxhedepth = 99999.0
      mingap=0.0
      maxgap=360.0
      do ind = 1,5
         magtypes(ind) = ' '
         disttype(ind) = ' '
         eventtype(ind) = ' '
      end do
      do ind = 1,10
        magaselect(ind)=' '
        hypaselect(ind)=' '
      enddo
      default = .false.
      fpsolut = .false.
      eqfelt = .false.
c
c   return if not enough arguments
c
      if(narg.lt.3) return

c
c   read arguments to fill in choises
c
      do i=1,narg
         if(arg(i)(1:7).eq.'-userid') then
             userid=arg(i)
         endif
         if(arg(i)(1:8).eq.'-web_out') then
            web_out=arg(i+1) 
c
c        clear output file for seisweb call
c
           open(1,file=web_out(1:seiclen(web_out))
     &//'.head',status='unknown')
           endfile 1 
           close(1)                  ! need to be clear up
         endif

         if(arg(i)(1:8).eq.'-seisweb') then
             seisweb=.true.
         endif
         if(arg(i)(1:5).eq.'-base') then
             basename=arg(i+1)
         endif
         if(arg(i)(1:7).eq.'-mgtype') then
             do j=1,5
                magtypes(j)=arg(i+1)(j:j)
             enddo
         endif
         if(arg(i)(1:9).eq.'-disttype') then
             do j=1,5
                disttype(j)=arg(i+1)(j:j)
             enddo
         endif
         if(arg(i)(1:10).eq.'-eventtype') then
             do j=1,5
                eventtype(j)=arg(i+1)(j:j)
                if(eventtype(j).eq.' ') eventtype(j)='%'
             enddo
         endif

         if(arg(i)(1:5).eq.'-area') then
             call sei get values(1,arg(i+1),code)
             lolat=array$(1)
             call sei get values(1,arg(i+2),code)
             hilat=array$(1)
             call sei get values(1,arg(i+3),code)
             lolon=array$(1)
             call sei get values(1,arg(i+4),code)
             hilon=array$(1)
         endif
         if(arg(i)(1:4).eq.'-mag') then
             call sei get values(1,arg(i+1),code)
             minmag=array$(1)
             call sei get values(1,arg(i+2),code)
             maxmag=array$(1)
         endif
         if(arg(i)(1:6).eq.'-depth') then
             call sei get values(1,arg(i+1),code)
             mindepth=array$(1)
             call sei get values(1,arg(i+2),code)
             maxdepth=array$(1)
         endif
         if(arg(i)(1:6).eq.'-nstat') then
             call sei get values(1,arg(i+1),code)
             minstation=array$(1)
             call sei get values(1,arg(i+2),code)
             maxstation=array$(1)
         endif
         if(arg(i)(1:4).eq.'-gap') then
             call sei get values(1,arg(i+1),code)
             mingap=array$(1)
             call sei get values(1,arg(i+2),code)
             maxgap=array$(1)
         endif
         if(arg(i)(1:4).eq.'-rms') then
             call sei get values(1,arg(i+1),code)
             minrms=array$(1)
             call sei get values(1,arg(i+2),code)
             maxrms=array$(1)
         endif
         if(arg(i)(1:5).eq.'-time') then
             starttime=arg(i+1)(1:14)
             endtime  =arg(i+2)(1:14)
         endif
      enddo
c
      return
      end

	
       subroutine CreateDBox(xi,yi,xf,yf)
       integer xi,yi,xf,yf
       integer fdialog	
       integer nitem,x1,y1,x2,y2
       integer   nDrawX
       integer   nDrawY	
       common /RESWIND/nDrawX,nDrawY
       common /dialog/nitem,fdialog,x1,y1,x2,y2
       fdialog = 1
       nitem = 0
       x1 = xi
       y1 = yi
       x2 = xf
       y2 = yf 
       return	
       end


	subroutine AddLabel(x,y,c,lb)
	integer x,y,c ! c for number of character
	character*80 lb
	character*80 caption(20)
	integer titem(20) ! type of item
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog	 !indicate when DBox is create 
	integer nitem,x1,y1,x2,y2,ident(20)
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
	if ( fdialog .eq. 1) then
	nitem = nitem + 1
	titem(nitem) = 1  !type of item 
	 caption(nitem) = lb
	nchar(nitem) = c
	cx(nitem) = x1+x
	cy(nitem) = y1+y
	endif
	return
	end


	subroutine AddEditText(x,y,c,lb,id)
	integer x,y,id,c ! c for number of character
	character*80 lb
	character*80 caption(20)
	integer titem(20)
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog
	integer nitem,x1,y1,x2,y2,ident(20)
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
	if ( fdialog .eq. 1 ) then
	nitem = nitem + 1
	titem(nitem) = 2  
	caption(nitem) = lb
	nchar(nitem) = c
	cx(nitem) = x1+x
	cy(nitem) = y1+y
	ident(nitem) = id
	endif
	return
	end

	subroutine AddButton(x,y,c,lb,id)
	integer x,y,id,c ! c for number of character
	character*80 lb
	character*80 caption(20)
	integer titem(20)
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog
	integer nitem,x1,y1,x2,y2,ident(20)
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
	if ( fdialog .eq. 1) then
	nitem = nitem + 1
	titem(nitem) = 3  
	caption(nitem) = lb
	nchar(nitem) = c
	cx(nitem) = x1+x
	cy(nitem) = y1+y
	ident(nitem) = id
	endif
	return
	end

	subroutine AddRadio(x,y,c,id)
	integer x,y,c,id ! c for number of character
	character*80 caption(20)
	integer titem(20)
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog
	character*80 rcaption(20,10)
	integer rcx(20,10),rcy(20,10)
	integer idchoice(20,10),rident(20,10)
	integer nitem,x1,y1,x2,y2,ident(20),nritem(20)
	common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
	if ( fdialog .eq. 1) then
	idchoice(id,1) = 1
	do i=2,10
	idchoice(id,i) = 0
	enddo
	nritem(id) = 0
	nitem = nitem + 1
	titem(nitem) = 4  
	cx(nitem) = x1+x
	cy(nitem) = y1+y
	ident(nitem) = id
	nchar(nitem) = c
	endif
	return
	end


	subroutine AddRadioItem(id,lb)
	integer id ! c for number of character
	character*80 lb
	character*80 caption(20)
	integer titem(20)
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog
	integer idchoice(20,10),rident(20,10)
	character*80 rcaption(20,10)
	integer rcx(20,10),rcy(20,10)
	integer nitem,x1,y1,x2,y2,ident(20),nritem(20)
	common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
	if ( fdialog .eq. 1) then
	nritem(id) = nritem(id) + 1
	rcx(id,nritem(id)) = cx(id)+10
	rcy(id,nritem(id)) = cy(id)+(nritem(id)-1)*20+10
	rident(id,nritem(id)) = nritem(id)
	rcaption(id,nritem(id)) = lb
	endif
	return
	end

	subroutine AddCheckBox(x,y,c,id)
	integer x,y,c,id ! c for number of character
	character*80 caption(20)
	integer titem(20)
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog
	character*80 rcaption(20,10)
	integer rcx(20,10),rcy(20,10)
	integer idchoice(20,10),rident(20,10)
	integer nitem,x1,y1,x2,y2,ident(20),nritem(20)
	common /Radio/rcaption,idchoice,nritem,rident,rcx,rcy
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
	if ( fdialog .eq. 1) then
	do i=1,10
	idchoice(id,i) = 0
	enddo
	nritem(id) = 0
	nitem = nitem + 1
	titem(nitem) = 5  
	cx(nitem) = x1+x
	cy(nitem) = y1+y
	ident(nitem) = id
	nchar(nitem) = c
	endif
	return
	end

	subroutine AddCheckBoxItem(id,lb)
	integer id ! c for number of character
	character*80 lb
	character*80 caption(20)
	integer titem(20)
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog
	integer idchoice(20,10),rident(20,10)
	character*80 rcaption(20,10)
	integer rcx(20,10),rcy(20,10)
	integer nitem,x1,y1,x2,y2,ident(20),nritem(20)
	common /Radio/rcaption,idchoice,nritem,rident,rcx,rcy
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
	if ( fdialog .eq. 1) then
	nritem(id) = nritem(id) + 1
	rcx(id,nritem(id)) = cx(id)+10
	rcy(id,nritem(id)) = cy(id)+(nritem(id)-1)*20+10
	rident(id,nritem(id)) = nritem(id)
	rcaption(id,nritem(id)) = lb
	endif
	return
	end


	subroutine ShowDBox(id)
	integer id
	integer idchoice(20,10),rident(20,10),nritem(20)
	integer   nDrawX
        integer   nDrawY	
	common /RESWIND/nDrawX,nDrawY
	character*80 rcaption(20,10)
   	integer rcx(20,10),rcy(20,10)
	common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
	character*80 caption(20)
	integer titem(20)
	integer nchar(20) ! number of character
	integer cx(20)   !coord of x for plot
	integer cy(20)   !coord of y for plot
	integer fdialog  
	integer nitem,x1,y1,x2,y2,ident(20)
	integer flag,kchar,flagkey,flagMouse
        real xmouse,ymouse
 	common /mousekey/flag,xmouse,ymouse,kchar,flagkey,flagMouse
	integer quit,n,prior,i,j
	common /dialog/nitem,fdialog,x1,y1,x2,y2
	common /item/caption,titem,nchar,cx,cy,ident
c
c	
	if ( fdialog .eq. 1 ) then
	call drawbox(x1,y1,x2,y2)
	call drawbox(x1+3,y1+3,x2-3,y2-3)
	do i=1,nitem 
	if (titem(i).eq.1) call ShowLabel(i)
	if (titem(i).eq.2) call ShowEditText(i)
	if (titem(i).eq.3) call ShowButton(i)
	if (titem(i).eq.4) call ShowRadio(i)
	if (titem(i).eq.5) call ShowCheckBox(i)
	end do
	quit = 0
	n = nchar(id)
	prior = id
	flagKey = 0
	flagMouse = 0
	if (id.ne.0) then
      call oneline(' ',1,caption(id),n,cx(id),cy(id)) 
	else
	call xscursr(kchar,xmouse,ymouse)
	endif
	do while(quit .eq. 0)
	if (kchar .eq. 32) then
	flagMouse = 0
	i = 1
	 do while(i .le. nitem)
	  if ( (xmouse>cx(i)) .and. (xmouse<(cx(i)+nchar(i)*10+20)))
     *    then
	   if ((titem(i) .eq. 3) .and. ((ymouse)>cy(i)) .and. 
     *        ((ymouse)<(cy(i)+30))) then
	     quit = 1
	     id = ident(i)
	     goto 20
	   else
	   if ((titem(i) .eq. 2) .and. ((ymouse)>cy(i)) .and. 
     *        ((ymouse)<(cy(i)+25))) then

	     call ShowEditText(prior)
	     prior = i
	 	 n = nchar(i)
		 call oneline(' ',1,caption(i),n,cx(i),cy(i)) 
	   	 i = nitem+1
	   endif
	   if ((titem(i) .eq. 4) .and. ((ymouse)>cy(i)) .and. 
     *        ((ymouse)<(cy(i)+nritem(i)*20))) then

	    call FindRadioItem(i,xmouse,ymouse,j)
		call SetRadioItem(i,j)
	    endif
		if ((titem(i) .eq. 5) .and. ((ymouse)>cy(i)) .and. 
     *        ((ymouse)<(cy(i)+nritem(i)*20))) then
		  call FindCheckBoxItem(i,xmouse,ymouse,j)
	      call SetCheckBoxItem(i,j)

	   endif
	   endif
	endif
	 i = i + 1
	 enddo
	if ((i.eq.nitem+1) .and. (id .ne. 0)) then
	 call oneline(' ',1,caption(prior),n,
     *            cx(prior),cy(prior)) 	  
	else
	call xscursr(kchar,xmouse,ymouse) 
	endif
	else      !KeyDown
	if (kchar .eq. 13) then
	 i = prior+1
	 FlagKey = 0
	 do while((i .le. nitem) .and. (titem(i) .ne. 2))
	 i = i + 1
	 enddo
	 if (i .eq. (nitem+1)) then
	  id = 0
	  goto 20
	 endif 
	 call ShowEditText(prior)
	 if ( i .le. nitem ) then
	   prior = i
	 	 n = nchar(i)
		 call oneline(' ',1,caption(i),n,cx(i),cy(i)) 
		else
	     prior = id
	 	 n = nchar(id)
		 call oneline(' ',1,caption(id),n,cx(id),cy(id)) 
		endif
		else
		call xscursr(kchar,xmouse,ymouse) 
    	endif
		endif
	    
	  enddo
	  endif
20	  call clearwindow(real(x1),real(y1-2),real(x2+10),real(y2))
	  return
	  end

    

		subroutine ShowLabel(i)
    	        integer i
		character*80 caption(20)
		integer titem(20)
		integer nchar(20) ! number of character
		integer cx(20)   !coord of x for plot
		integer cy(20)   !coord of y for plot
		integer fdialog
		integer nitem,x1,y1,x2,y2,ident(20)
		common /dialog/nitem,fdialog,x1,y1,x2,y2
		common /item/caption,titem,nchar,cx,cy,ident
		if ( fdialog .eq. 1 ) then
		call xchars(caption(i),nchar(i),real(cx(i)),real(cy(i))) 
		endif
		return
		end

		subroutine ShowEditText(i)
		integer i
		character*80 caption(20)
		character*80 text
		integer titem(20)
		integer nchar(20) ! number of character
		integer cx(20)   !coord of x for plot
		integer cy(20)   !coord of y for plot
		integer fdialog
		integer nitem,x1,y1,x2,y2,ident(20)
		integer ix1,iy1,ix2,iy2
		common /dialog/nitem,fdialog,x1,y1,x2,y2
		common /item/caption,titem,nchar,cx,cy,ident
		if ( fdialog .eq. 1 ) then
		ix1=cx(i)
		  iy1=cy(i)
		  ix2=cx(i)+nchar(i)*10+30
		  iy2=cy(i)+25
		call drawbox(ix1,iy1,ix2,iy2)
		do j=1,nchar(i)
		text(1:1) = caption(i)(j:j)
		call xchars(text,1,real(cx(i)+10*j),real(cy(i)+7)) 
		enddo 
		endif
		return
		end

		subroutine ShowButton(i)
		integer i
		character*80 caption(20)
		integer titem(20)
		integer nchar(20) ! number of character
		integer cx(20)   !coord of x for plot
		integer cy(20)   !coord of y for plot
		integer fdialog
		integer nitem,x1,y1,x2,y2,ident(20)
		integer ix1,iy1,ix2,iy2
		common /dialog/nitem,fdialog,x1,y1,x2,y2
		common /item/caption,titem,nchar,cx,cy,ident
		if ( fdialog .eq. 1 ) then
		ix1=cx(i)
		  iy1=cy(i)
		  ix2=cx(i)+nchar(i)*10+20
		  iy2=cy(i)+30
		call drawbox(ix1,iy1,ix2,iy2)
		call drawbox(ix1+1,iy1+2,ix2-2,iy2-1)
		call xchars(caption(i),nchar(i),real(cx(i)+10),
     *   real(cy(i)+10)) 
		endif
		return
		end

		subroutine ShowRadio(i)
		integer i
		character*80 caption(20)
		integer titem(20)
		integer nchar(20) ! number of character
		integer cx(20)   !coord of x for plot
		integer cy(20)   !coord of y for plot
		integer fdialog
		integer nitem,x1,y1,x2,y2,ident(20)
		integer idchoice(20,10),rident(20,10)
 		character*80 rcaption(20,10)
		integer rcx(20,10),rcy(20,10),nritem(20)
		common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
		integer ix1,iy1,ix2,iy2
		common /dialog/nitem,fdialog,x1,y1,x2,y2
		common /item/caption,titem,nchar,cx,cy,ident
		if ( fdialog .eq. 1 ) then
		ix1=cx(i)
		  iy1=cy(i)
		  ix2=cx(i)+nchar(i)*10+25 
		  iy2=cy(i)+20*nritem(i)
		call drawbox(ix1,iy1,ix2,iy2)
		do j=1,nritem(i)
		call ShowRadioItem(i,j)
		enddo
                call SetRadioItem(i,1)
		endif
		return
		end

		subroutine ShowCheckBox(i)
		integer i
		character*80 caption(20)
		integer titem(20)
		integer nchar(20) ! number of character
		integer cx(20)   !coord of x for plot
		integer cy(20)   !coord of y for plot
		integer fdialog
		integer nitem,x1,y1,x2,y2,ident(20)
		integer idchoice(20,10),rident(20,10)
 		character*80 rcaption(20,10)
		integer rcx(20,10),rcy(20,10),nritem(20)
		common /Radio/rcaption,idchoice,nritem,rident,rcx,rcy
		integer ix1,iy1,ix2,iy2
		common /dialog/nitem,fdialog,x1,y1,x2,y2
		common /item/caption,titem,nchar,cx,cy,ident
		if ( fdialog .eq. 1 ) then
		ix1=cx(i)
		  iy1=cy(i)
		  ix2=cx(i)+nchar(i)*10+25 
		  iy2=cy(i)+20*nritem(i)
		call drawbox(ix1,iy1,ix2,iy2)
		do j=1,nritem(i)
		call ShowCheckBoxItem(i,j)
		enddo
		endif
		return
		end


		subroutine ShowRadioItem(i,j)
		integer i,j
		character*80 caption(20)
		integer titem(20)
		integer nchar(20) ! number of character
		integer cx(20)   !coord of x for plot
		integer cy(20)   !coord of y for plot
		integer fdialog
		integer nitem,x1,y1,x2,y2,ident(20)
		integer idchoice(20,10),rident(20,10)
 		character*80 rcaption(20,10)
		integer rcx(20,10),rcy(20,10),nritem(20)
		common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
		common /dialog/nitem,fdialog,x1,y1,x2,y2
		common /item/caption,titem,nchar,cx,cy,ident
		if ( fdialog .eq. 1 ) then
                  call circle(rcx(i,j),rcy(i,j),5)
		call xchars(rcaption(i,j),nchar(i),real(rcx(i,j)+10),
     *          real(rcy(i,j)-7))
		endif
		return
		end

		subroutine ShowCheckBoxItem(i,j)
		integer i,j
		character*80 caption(20)
		integer titem(20)
		integer nchar(20) ! number of character
		integer cx(20)   !coord of x for plot
		integer cy(20)   !coord of y for plot
		integer fdialog
		integer nitem,x1,y1,x2,y2,ident(20)
		integer idchoice(20,10),rident(20,10)
 		character*80 rcaption(20,10)
		integer rcx(20,10),rcy(20,10),nritem(20)
		common /Radio/rcaption,idchoice,nritem,rident,rcx,rcy
		common /dialog/nitem,fdialog,x1,y1,x2,y2
		common /item/caption,titem,nchar,cx,cy,ident
		if ( fdialog .eq. 1 ) then
		call drawbox(rcx(i,j)-5,rcy(i,j)-5,rcx(i,j)+5,rcy(i,j)+5)
		call xchars(rcaption(i,j),nchar(i),real(rcx(i,j)+10),
     *          real(rcy(i,j)-7))
		endif
		return
		end

 

		subroutine FindRadioItem(i,xmouse,ymouse,j)
		integer i,j
                real xmouse,ymouse 
 			integer   nDrawX
		  integer   nDrawY	
  		  common /RESWIND/nDrawX,nDrawY

  		  integer idchoice(20,10),rident(20,10)
  		  character*80 rcaption(20,10)
		  integer rcx(20,10),rcy(20,10),nritem(20)
		  common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
		  j=0
		  do k=1,nritem(i)
		  if ( (xmouse>(rcx(i,k)-5)) .and. (xmouse<(rcx(i,k)+5))
     *    .and. ((ymouse)>(rcy(i,k)-5)) .and. 	
     *        ((ymouse)<(rcy(i,k)+5))) then
		  j = k
		  return
		  endif
		  enddo
		  return
		  end

		subroutine FindCheckBoxItem(i,xmouse,ymouse,j)
		integer i,j
                real xmouse,ymouse 
 		integer   nDrawX
		  integer   nDrawY	
  		common /RESWIND/nDrawX,nDrawY

  		  integer idchoice(20,10),rident(20,10)
  		  character*80 rcaption(20,10)
		  integer rcx(20,10),rcy(20,10),nritem(20)
		  common /Radio/rcaption,idchoice,nritem,rident,rcx,rcy
		  j=0
		  do k=1,nritem(i)
		  if ( (xmouse>(rcx(i,k)-5)) .and. (xmouse<(rcx(i,k)+5))
     *    .and. ((ymouse)>(rcy(i,k)-5)) .and.  
     *        ((ymouse)<(rcy(i,k)+5))) then
		  j = k
		  return
		  endif
		  enddo
		  return
		  end



		  subroutine SetRadioItem(i,k)
		  integer i,k
		  !interface
		  !integer function GetRadioItem(l)
		  !integer  l
		  !end function
		  !end interface
  		  integer idchoice(20,10),rident(20,10)
  		  character*80 rcaption(20,10)
		  integer rcx(20,10),rcy(20,10),nritem(20)
		  common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
		  if (k.eq.0) return
		  j = k
		  call fillcircle(rcx(i,j),rcy(i,j),5)
		  call GetRadioItem(i,j)
		  if (j.ne.k) then
		  call xset_color(5)
		  call fillcircle(rcx(i,j),rcy(i,j),5)
		  call xset_color(1)
		  call circle(rcx(i,j),rcy(i,j),5)
		  idchoice(i,j) = 0
		  endif
		  idchoice(i,k) = 1
		  return
		  end

		 subroutine GetRadioItem(l,j)
		  integer  l,j
  		  integer idchoice(20,10),rident(20,10),k
  		  character*80 rcaption(20,10)
		  integer rcx(20,10),rcy(20,10),nritem(20)
		  common /radio/rcaption,idchoice,nritem,rident,rcx,rcy
		  j = 0
		  do k=1,10
		  if (idchoice(l,k).ne.0) j = k
		  enddo
		  return 
		  end

		subroutine CheckBoxItem(i,k,flag)
		  integer i,k,flag
  		  integer idchoice(20,10),rident(20,10)
  		  character*80 rcaption(20,10)
		  integer rcx(20,10),rcy(20,10),nritem(20)
		  common /Radio/rcaption,idchoice,nritem,rident,rcx,rcy
		  if (idchoice(i,k).eq.0) then
		  flag =  0
		  else
		  flag =  1
		  endif 
                  return
		  end


		  subroutine SetCheckBoxItem(i,k)
		  integer i,k
  		  integer idchoice(20,10),rident(20,10)
  		  character*80 rcaption(20,10)
		  integer rcx(20,10),rcy(20,10),nritem(20)
		  common /Radio/rcaption,idchoice,nritem,rident,rcx,rcy
		  if (k.eq.0) return
		  j = k
		  idchoice(i,j) = 1 - idchoice(i,j)
                  if (idchoice(i,j) .eq. 1) then
		  call xset_color(1)
		  call fillbox(real(rcx(i,j)-5),real(rcy(i,j)-5),
     *            real(rcx(i,j)+5),real(rcy(i,j)+5))
                  else
		  call xset_color(5)
		  call fillbox(real(rcx(i,j)-5),real(rcy(i,j)-5),
     *            real(rcx(i,j)+5),real(rcy(i,j)+5))
		  call xset_color(1)
		  call drawbox(rcx(i,j)-5,rcy(i,j)-5,rcx(i,j)+5,rcy(i,j)+5)
                  endif
		  return
		  end

		  subroutine GetEditText(i,answer)
		  integer i
		  character*80 answer
		  character*80 caption(20)
		  integer titem(20)
		  integer nchar(20) ! number of character
		  integer cx(20)   !coord of x for plot
		  integer cy(20)   !coord of y for plot
		  integer fdialog
		  integer nitem,x1,y1,x2,y2,ident(20)
		  integer j
		  common /dialog/nitem,fdialog,x1,y1,x2,y2
		  common /item/caption,titem,nchar,cx,cy,ident
		  answer = ''
		  j = 1
		  if ( fdialog .eq. 1 ) then
		   do while( (ident(j) .ne. i) .and. (j.le.nitem) )
		    j = j+1
		   enddo
		   if (j.le.nitem) answer = caption(j)
		  endif
		  return
		  end

      program volcano_statistics
c
c program to generate GMT histograms of counts and energy distribution
c over time for selected volcanic subclasses, the programs reads s-files
c directly from the database
c
c Lars Ottemoller, 27/09/2002, Montserrat
c
c changes:
c   28012003 lot - added total counts
c                  added output of countes by date, changes done at MVO
c   20022003 lot - renamed program
c   20030704 lot - added date on time axis and changed filename to volcstat
c   20050124 lot - fix bug with grid and range for count plot
c
      implicit none
      include 'seidim.inc'
c
c    Seisan library inserts and routines...
c    ======================================
      include 'libsei.inc'                ! Open file definitions
      external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
      integer seiclen
C    ======================================
c-- event data
      character*80	data(max_data)	
c-- exp indicator                                         
      character*1	exp		
c-- event type                                      
      character*1      type		
c-- output indicator for comp. or norm.	  
      character*1      outf            
c-- number of recors for event                           
      integer		nrecord		
c-- number of header lines                                 
      integer		nhead		
c-- number of stations                                     
      integer		nstat		
c-- number of phases
      integer nphase
c-- start and end time of select      
      character*14    start_time,end_time 
c-- data base name if not agency (blank)               
      character*40	base_name	
c-- event file name                                   
      character*80	evfile		
c-- select key                                       
      character*10     key		
c-- see subroutine find...       
      integer		status,new_month,fstart,event_no 
c-- counters for events, records etc.      
      integer nr,nd,nl,records,nevent	
c-- counter                                                   
      integer i,j,ind,k,l,m
c-- true if file exists (CLK)             
      logical          exist           
c-- Arguments passed
      character*80     arg(20)
c-- id line number
      integer id
c---number of arguments and function
      integer nars
c logical for end of file
      logical          b_eof
c logical for existing file or not
      logical          b_old
c returned code
      integer          code
c read unit #1
      integer          read01
c write unit  #1
      integer          write01,write02,write03,write04,write05
c max number of subclasses
      integer maxsubclass
      parameter (maxsubclass=10)
c volcanic subclasses
      character*1 subclass(maxsubclass)
      integer nsubclass
c maximum number of days
      integer maxdays
      parameter (maxdays=10000)
c subclass counts
      integer totalcount(maxsubclass)
      integer daycount(maxsubclass,1000000)
      integer bin_count(maxsubclass,maxdays) 
      real bin_energy(maxsubclass,maxdays)
      integer bin_max
      integer dailycount
c date and time
      integer year,month,day,hour,min,doy
      real sec
c time in sec
      double precision msec
c time of first day in year of first event in seconds
      double precision ystart_sec,end_sec,start_sec
c day after first 
      integer daycounter
      integer last_day,first_day,prev_day
c bin width in days
      integer bindays
c text for bin width setting
      character*5 width_text
c text
      character*80 input
c gmt command
      character*240 gmt_text,gmt_var_text
      character*10 text
      character*80 range_text,grid_text,symbol_text,xx
      integer day_grid
      real y_grid
c vertical scale
      real ysize
c selected station
      character*5 selstat
      character*4 selcomp
      real energy,max_energy(10)
      real bin,binhigh
      character*10 outdate
      character*1 choice
     
c
c print version
c
      include 'version.inc'
      out_version_date='September 27, 2002'
      if (version_new) out_version_date=version_date
      call print_ver

c init
      nevent=0
      nsubclass=0
      ystart_sec=0.
      call timsec(2099,12,31,0,0,0.,start_sec)
      end_sec=0.
      bindays=1
      last_day=0
      selstat='     '
      selcomp='    '
      first_day=9999999
      do i=1,maxsubclass
        subclass(i)=' '
        daycount(i,1)=0
        totalcount(i)=0
        do j=1,maxdays
          bin_energy(i,j)=0.
          bin_count(i,j)=0
        enddo
        max_energy(i)=0.
      enddo

      start_time = ' '
      nars = 0
      call get_arguments(nars,arg)    ! get arguments 
      if(nars .ne. 0) then
         end_time = ' '
         base_name = ' '
         outf = ' '
         do i = 1,nars
            if(arg(i)(1:11) .eq. '-start_time')then
                read(arg(i+1),'(a14)') start_time
            endif
            if(arg(i)(1:9) .eq. '-end_time')then
              read(arg(i+1),'(a14)') end_time
            endif
            if(arg(i)(1:10).eq. '-base_name')then
              read(arg(i+1),'(a40)') base_name
            endif
            if(arg(i)(1:10).eq. '-bin_width')then
              read(arg(i+1),'(i10)') bindays
            endif
            if(arg(i)(1:8).eq. '-classes')then
              read(arg(i+1),'(10a1)') subclass
            endif
            if(arg(i)(1:5).eq. '-stat')then
              read(arg(i+1),'(a5)') selstat
            endif
            if(arg(i)(1:5).eq. '-comp')then
              read(arg(i+1),'(a4)') selcomp
            endif
            if(arg(i)(1:2).eq.'-h')then
              write(*,*)' Command line input:'
              write(*,*)'   -base_name XXX (blank=default)'
              write(*,*)'   -start_time yyyymmdd...'
              write(*,*)'   -end_time yyyymmdd...(blank=end of month)'
              write(*,*)'   -classes, max 10a1'
              write(*,*)'   -bin_width days'
c              write(*,*)'   -stat, max a5'
c              write(*,*)'   -comp, max a4'
              stop
            endif
         enddo
      endif
      if(start_time .ne. ' ') go to 50 
c                                             
c   input base name and time interval                                      
c                                                                               
      write(6,*)' Base name, ,, for local directory, ',
     *'name of index file'
      write(6,*)' or return for default base'                               
      read(5,'(a40)') base_name                                                
      write(6,'(1x,a,$)')' Start time                       : ' 
      read(5,'(a14)') start_time                                               
      write(6,'(1x,a,$)')' End time, return for end of month: ' 
      read(5,'(a14)') end_time                                                 
      write(6,'(1x,a,$)')' Bin width in days (Return for 1 day): ' 
      read(5,'(a10)') input
      if (seiclen(input).gt.0) read(input,'(i10)') bindays

      write(6,'(1x,a,$)') ' Give subclasses, max 20a1: ' 
      read(5,'(10a1)') subclass
c
c this part not used until apmengfft writes to sfiles again
c
c      write(6,'(1x,a,$)') ' Select station, max a5: ' 
c      read(5,'(a5)') selstat
c      write(6,'(1x,a,$)') ' Select component, max a4: ' 
c      read(5,'(a4)') selcomp
 1    continue                                                                 
	                                                                    
                                                                               
 50   continue                                                                 
      do i=1,10
        if (subclass(i).ne.' ') then
          nsubclass=nsubclass+1
        endif
      enddo
      do i=1,4
        if (selcomp(i:i).eq.'_') selcomp(i:i)=' '
      enddo

c                                                                               
c  start read and write loop                                                    
c                                                                               
 5     continue                                                                 
c-- always use next event                                
       key='          '		
       CALL findevin                                                       
     * (base_name,start_time,end_time,key,0,
     * event_no,evfile,fstart,new_month,status)                                 
       if(status.eq.0) then                                                     
c--   (CLK)     
         inquire(file=evfile,exist=exist)                         
c--   (CLK)     
         if (exist) then                                          
            call sei open(old$+warn$,            ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    evfile,                ! File name
     &                    read01,                ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
           call indata(read01,nstat,nphase,nhead,nrecord,
     &            type,exp,data,id)
           nevent=nevent+1                                                      
           read(data(1)(2:20),'(i4,1x,2i2,1x,2i2,1x,f4.1)')
     &       year,month,day,hour,min,sec
       write(*,*) data(1)(1:78)
c check that year is i4
           if (year.le.50) then
             year=year+1900
c           else
c             year=year+2000
           endif
           if (nevent.eq.1) then
             call timsec(year,1,1,0,0,0.,ystart_sec)
           endif
c
c find day
c
           msec=0.
           call timsec(year,month,day,hour,min,sec,msec)
           daycounter=int((msec-ystart_sec)/(60.*60.*24.))+1
           if (daycounter.gt.last_day) last_day=daycounter
           if (daycounter.lt.first_day) first_day=daycounter
c           if (msec.gt.end_sec) end_sec=msec
           if (msec.le.start_sec) then
             call timsec(year,month,day,0,0,1.,msec)
             start_sec=msec
           endif

c
c check for volcanic subclass
c
           if (data(1)(23:23).eq.'V') then
c             do i=2,nhead
             do i=2,nrecord    ! lot 06/02/2003
               if (data(i)(2:10).eq.'VOLC MAIN') then
                 ind=0
                 do j=1,nsubclass
                   if (data(i)(12:12).eq.subclass(j)) then
                     ind=j
                   endif
                 enddo
c
c count total of events
c
                 totalcount(ind)=totalcount(ind)+1
c
c store date in array
c
                 if (ind.ne.0) then
                   daycount(ind,1)=daycount(ind,1)+1
                   daycount(ind,daycount(ind,1)+1)=daycounter
                 endif
               endif
             enddo
c             do i=2,nhead
             do i=2,nrecord    ! lot 06/02/2003
               if (data(i)(2:5).eq.'VOLC'.and.
     &                 data(i)(7:11).eq.selstat.and.
     &                 data(i)(12:15).eq.selcomp) then
                 read(data(i)(30:37),'(e8.2)') energy
                 if (ind.ne.0) then
                   bin_energy(ind,daycounter)=
     &                 bin_energy(ind,daycounter)+energy
                 endif
               endif
             enddo
           endif
           call sei close (close$,read01,code)
         else                                                      
           write(6,'(1x,a60,a)') evfile(1:60),' doesn''t exist.'         
         endif                                                     
c-- back for next event                                         
         goto 5			
       else                                                                     
c-- 3 is end of time period                       
          if(status.eq.2) write(6,*)' End of index file'
          if(status.gt.3)       
     *    write(6,*)' ****** Something wrong, status= ', status                 
       endif                                                                    

c
c open outputfile for counts
c
       call sei open(unknown$+warn$,           ! Open a unknown status file.

     &                    ' ',                   ! Prompt file name (n/a).
     & 'volcstat_counts_total.out',  ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
c
c write out totals
c
      do i=1,nsubclass
        write(write01,'(a1,1x,i10)') subclass(i),totalcount(i)
      enddo
      call sei close(close$,write01,code)
      do i=1,nsubclass
c                                                                               
c   open output file                                                            
c                                                                               
        if (subclass(i).ne.' ') then
          call sei open(unknown$+warn$,           ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     & 'volcstat_counts_'//subclass(i)//'.out',  ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
          call sei open(unknown$+warn$,           ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     & 'volcstat_daily_'//subclass(i)//'.out',  ! File name
     &                    write04,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
c          call sei open(unknown$+warn$,           ! Open a unknown status file.
c     &                    ' ',                   ! Prompt file name (n/a).
c     & 'volcstat_energy_'//subclass(i)//'.out',  ! File name
c     &                    write02,               ! Write unit #1
c     &                    b_old,                 ! Already exists? (n/a).
c     &                    code)                  ! Returned condition.
          prev_day=first_day
          dailycount=0
          do j=2,daycount(i,1)+1
            write(write01,*) daycount(i,j)
c
c count events until new date
c
            if (daycount(i,j).eq.prev_day) then
              dailycount=dailycount+1
            else
c
c write out dates and number of events
c
              call sectim(ystart_sec+(prev_day-1)*86400,
     &            year,doy,month,day,hour,min,sec)
              write(write04,'(i4,2i2.2,1x,i6)') 
     &         year,month,day,dailycount
              dailycount=1
              prev_day=daycount(i,j)
            endif
          enddo
          if (daycount(i,1).eq.0) then
            write(write01,*) -1
          endif
          energy=0.
          bin=bindays
          if (bindays.gt.2) bin=0
          binhigh=bin+bindays/2.
          do j=1,maxdays
            if (j.ge.binhigh) then
c              write(write02,*) bin,energy
              if (energy.gt.max_energy(i))
     &                max_energy(i)=energy
              energy=0.
              bin=bin+float(bindays)
              binhigh=bin+bindays/2.
            endif
            energy=energy+bin_energy(i,j)
          enddo
        endif
        call sei close (close$,write01,code)
c        call sei close (close$,write02,code)
      enddo
c
c plot graphs using GMT
c
      call sei open(unknown$,            ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    'volcstat.batch',      ! File name
     &                    write03,               ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
      gmt_text=' '
      gmt_text='gmtset MEASURE_UNIT cm'
      call systemc(gmt_text,seiclen(gmt_text))
      write(write03,*) gmt_text(1:seiclen(gmt_text))
      gmt_text=' '
      gmt_text='gmtset PAPER_MEDIA a4+'
      call systemc(gmt_text,seiclen(gmt_text))
      write(write03,*) gmt_text(1:seiclen(gmt_text))
      gmt_text=' '
      gmt_text='gmtset ANOT_FONT Helvetica'
      call systemc(gmt_text,seiclen(gmt_text))
      write(write03,*) gmt_text(1:seiclen(gmt_text))
      gmt_text=' '
      gmt_text='gmtset ANOT_FONT_SIZE 10p'
      call systemc(gmt_text,seiclen(gmt_text))
      write(write03,*) gmt_text(1:seiclen(gmt_text))
      gmt_text=' '
      gmt_text='gmtset LABEL_FONT Helvetica'
      call systemc(gmt_text,seiclen(gmt_text))
      write(write03,*) gmt_text(1:seiclen(gmt_text))
      gmt_text=' '
      gmt_text='gmtset LABEL_FONT_SIZE 10p'
      call systemc(gmt_text,seiclen(gmt_text))
      write(write03,*) gmt_text(1:seiclen(gmt_text))
      gmt_text=' '
      gmt_text='gmtset TICK_LENGTH .05c'
      call systemc(gmt_text,seiclen(gmt_text))
      write(write03,*) gmt_text(1:seiclen(gmt_text))

      if (bindays.lt.10) then
        write(width_text,'(a2,i1)') '-W',bindays
      elseif (bindays.lt.100) then
        write(width_text,'(a2,i2)') '-W',bindays
      endif

c
c set figure size 
c
c      ysize=(24.-((nsubclass-2)*1.5))/nsubclass 
      ysize=(22.-((nsubclass-2)*.5))/nsubclass 
      if (ysize.gt.5.) ysize=5.
c
c delete output files
c
      gmt_text=' '
      gmt_text='rm -f volcstat_counts.ps'
      call systemc(gmt_text,seiclen(gmt_text))
      gmt_text=' '
      gmt_text='rm -f volcstat_energy.ps'
      call systemc(gmt_text,seiclen(gmt_text))
      do i=1,nsubclass

c
c find bin range for counts plot
c
          bin_max=0
          do m=first_day,last_day,bindays
            l=0
            do k=2,daycount(i,1)+1
              if (daycount(i,k).ge.m.and.
     &           daycount(i,k).le.m+bindays-1) then
                l=l+1
              endif
            enddo
            if (l.gt.bin_max) bin_max=l+int(l*.1)
          enddo
          if (bin_max.eq.0) bin_max=1

c set day grid
          day_grid=int((last_day-first_day)/10.)
          if (day_grid.eq.0) day_grid=1

          if (i.eq.1) then
            write(text,'(f4.1)') 27.-ysize 
            gmt_var_text='-P -K -X2.5 -Y'//text(1:4)//' > '
c          elseif (i.eq.nsubclass) then
c            write(text,'(f4.1)') -ysize -1.5
c            gmt_var_text='-O -X0. -Y'//text(1:4)//' >> '
          else
c            write(text,'(f4.1)') -ysize -1.5
            write(text,'(f4.1)') -ysize -0.5
            gmt_var_text='-K -O -X0. -Y'//text(1:4)//' >> '
          endif
  
c
c use pshistogram for count plots
c
          gmt_text=' '
          gmt_text='gmtset D_FORMAT %lg'
          call systemc(gmt_text,seiclen(gmt_text))

c set grid text
          y_grid=float(bin_max)/3.
          if (int(y_grid).eq.0.) y_grid=1.
          write(grid_text,*)
c     &     '-B',day_grid,':"days":/',int(y_grid),':"counts  '
c     &      //subclass(i)//'":WSne '
     &     '-B',day_grid,'/',int(y_grid),':"counts  '
     &      //subclass(i)//'":Wsne '
          xx=' '
          k=0
          do m=1,seiclen(grid_text)
            if (seiclen(grid_text(m:m)).ne.0.or.
     &         grid_text(m-1:m-1).eq.'y') then
              k=k+1
              xx(k:k)=grid_text(m:m)
            endif
          enddo
          grid_text=xx(1:seiclen(xx))
c          do m=1,seiclen(grid_text)
c            if (grid_text(m:m).eq.' ') 
c     &          grid_text=grid_text(1:m-1)//grid_text(m+1:)
c          enddo
c set range text
          write(range_text,*)'-R',first_day-1,'/',last_day+1,'/0/',
     &       int(bin_max*1.1)
c          do m=1,seiclen(range_text)
c            if (range_text(m:m).eq.' ') 
c     &          range_text=range_text(1:m-1)//range_text(m+1:)
c          enddo
          xx=' '
          k=0
          do m=1,seiclen(range_text)
            if (seiclen(range_text(m:m)).ne.0) then
              k=k+1
              xx(k:k)=range_text(m:m)
            endif
          enddo
          range_text=xx(1:seiclen(xx))

          write(text,'(f3.1)') ysize
          gmt_text=' '
          gmt_text='pshistogram volcstat_counts_'//subclass(i)//
     &      '.out '//width_text(1:seiclen(width_text))//' '//
     &      range_text(1:seiclen(range_text))//' '//
     &      grid_text(1:seiclen(grid_text))//
     &      ' -G200 -JX18./'//text(1:3)//
     &      ' -C -L '
     &      //gmt_var_text(1:seiclen(gmt_var_text))//
     &      ' volcstat_counts.ps'
          call systemc(gmt_text,seiclen(gmt_text))
          write(write03,*) gmt_text(1:seiclen(gmt_text))
c
c add date x-axis after last plot
c
          if (i.eq.nsubclass) then
c
c work out spacing, axis is 18 cm, number of days is last_day-first_day
c plot 10 dates 
c
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &              'volcstat_date_axis.out',   ! File name
     &                    write05,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
            start_sec=start_sec-(24.*3600.)
            end_sec=start_sec+(last_day-first_day+2)*(24.*3600.)
            msec=start_sec

            k=0
            do m=first_day-1,last_day+1
              call sectim(msec,year,doy,month,day,hour,min,sec)
              if (int((m-first_day)/float(day_grid))
     &          .eq.(m-first_day)/float(day_grid).and.
     &          m.ne.first_day-1.and.m.ne.last_day+1) then
              outdate=' '
              write(outdate,'(i4.4,a1,i2.2,a1,i2.2)')
     &          year,'/',month,'/',day
              write(write05,'(f4.1,1x,f3.1,1x,a,a10)') 
     &          k*18./(last_day-first_day+2),
     &          2.,' 10 90. 0 MR ',outdate
              endif
              msec=msec+24.*3600.
              k=k+1
            enddo
            call sei close (close$,write05,code)
            gmt_text=' '
            gmt_text='pstext volcstat_date_axis.out -JX18/3 -R0/18/-3/3'
     &       // ' -P -O -X0. -Y-3. >>  volcstat_counts.ps '
            write(write03,*) gmt_text(1:seiclen(gmt_text))
            call systemc(gmt_text,seiclen(gmt_text))
          endif

          goto 9000
c
c use psxy for energy plots
c
          gmt_text=' '
          gmt_text='gmtset D_FORMAT %4.2e'
          call systemc(gmt_text,seiclen(gmt_text))

          if (i.eq.nsubclass) then
            write(text,'(f4.1)') -ysize -1.5
            gmt_var_text='-O -K -X0. -Y'//text(1:4)//' >> '
          endif
c set grid text
          y_grid=max_energy(i)/3.
          if (y_grid.eq.0) then
            y_grid=1.
            max_energy(i)=1.
          endif
          write(grid_text,*)
c     &     '-B',day_grid,':"days":/',y_grid,':"energy '
     &     '-B/',y_grid,':"energy '
     &      //subclass(i)//'":WSne '
          xx=' '
          k=0
          do m=1,seiclen(grid_text)
            if (seiclen(grid_text(m:m)).ne.0.or.
     &         grid_text(m-1:m-1).eq.'y') then
              k=k+1
              xx(k:k)=grid_text(m:m)
            endif
          enddo
          grid_text=xx(1:seiclen(xx))
c set range text
          range_text=' '
          write(range_text,*)
     &       '-R',first_day-1,'/',last_day+1,'/0/',
     &       max_energy(i)*1.1
          xx=' '
          k=0
          do m=1,seiclen(range_text)
            if (seiclen(range_text(m:m)).ne.0) then
              k=k+1
              xx(k:k)=range_text(m:m)
            endif
          enddo
          range_text=xx(1:seiclen(xx))
c set symbol text
          xx=' '
          k=0
          write(symbol_text,*)'-Sb',
     &       18./float(last_day-first_day+2)*float(bindays)
          do m=1,seiclen(symbol_text)
            if (seiclen(symbol_text(m:m)).ne.0) then
              k=k+1
              xx(k:k)=symbol_text(m:m)
            endif
          enddo
          symbol_text=xx(1:seiclen(xx))

          write(text,'(f3.1)') ysize
          gmt_text=' '
          gmt_text='psxy volcstat_energy_'//subclass(i)//
     &      '.out '//width_text(1:seiclen(width_text))//' '//
     &      range_text(1:seiclen(range_text))//' '//
     &      grid_text(1:seiclen(grid_text))//' '//
     &      symbol_text(1:seiclen(symbol_text))//
     &      ' -W.25 -G200 -JX18./'//text(1:3)//
     &      ' '
     &      //gmt_var_text(1:seiclen(gmt_var_text))//
     &      ' volcstat_energy.ps'
          call systemc(gmt_text,seiclen(gmt_text))
          write(write03,*) gmt_text(1:seiclen(gmt_text))

c
c plot day scale, since on energy plot y axis is 4.2e
c
          gmt_text=' '
          gmt_text='gmtset D_FORMAT %lg'
          call systemc(gmt_text,seiclen(gmt_text)) 
          if (i.eq.nsubclass) then
            gmt_var_text='-O >> '
          else
            gmt_var_text='-K -O >> '
          endif
c set range text
          range_text=' '
          write(range_text,*)
     &       '-R',first_day-1,'/',last_day+1,'/0/1'
          xx=' '
          k=0
          do m=1,seiclen(range_text)
            if (seiclen(range_text(m:m)).ne.0) then
              k=k+1
              xx(k:k)=range_text(m:m)
            endif
          enddo
          range_text=xx(1:seiclen(xx))
          write(grid_text,*)
     &     '-B',day_grid,':"days":S '
          xx=' '
          k=0
          do m=1,seiclen(grid_text)
            if (seiclen(grid_text(m:m)).ne.0.or.
     &         grid_text(m-1:m-1).eq.'y') then
              k=k+1
              xx(k:k)=grid_text(m:m)
            endif
          enddo
          grid_text=xx(1:seiclen(xx))
c set range text
          gmt_text='psxy volcstat_energy_'//subclass(i)//
     &        '.out '//width_text(1:seiclen(width_text))//' '//
     &        range_text(1:seiclen(range_text))//' '//
     &        grid_text(1:seiclen(grid_text))//' '//
     &        symbol_text(1:seiclen(symbol_text))//
     &        ' -G200 -JX18./0.01'//
     &        ' '
     &        //gmt_var_text(1:seiclen(gmt_var_text))//
     &        ' volcstat_energy.ps'
          call systemc(gmt_text,seiclen(gmt_text))
          write(write03,*) gmt_text(1:seiclen(gmt_text))
9000    continue
      enddo
      call sei close (close$,write03,code)

      write(*,*)
      write(6,'(a)') ' Output files: '
      write(6,'(a)') '                volcstat.batch '//
     &        '- batch file to produce GMT output '
      write(6,'(a)') '                volcstat_counts_x.out '//
     &        '- counts data for subclass x '
      write(6,'(a)') '                volcstat_energy_x.out '//
     &        '- energy data for subclass x '
      write(6,'(a)') '                volcstat_daily_x.out '//
     &        '- counts per day for subclass x '
      write(6,'(a)') '                volcstat_counts_total.out '//
     &        '- total counts for subclasses '
      write(6,'(a)') '                volcstat_counts.ps '//
     &        '- counts Postscript output file '
c      write(6,'(a)') '                volcstat_energy.ps '//
c     &        '- energy Postscript output file '
      if(nars .eq. 0) then
        write(*,*)
        write(*,'(a,$)') ' Plot results with ghostscript ? '
        read(5,'(a1)') choice
        if (choice.eq.'y'.or.choice.eq.'Y')
     &     call systemc('gs volcstat_counts.ps',21)
      endif
      stop                                                                      
      end                                                                       
                                                                                
                                                                                

c
c   wadati plot, input is one file in nordic format 
c
c
c   j. havskov, september 2000
c
c   updates
c   oct 8 2004 jh : do not plot if no data
c   jun  20 05 jh: plt to eps
c   feb 9  05  jh: higher accuracy in plot out of s-p

      include 'winplot1.inc'
      include 'seidim.inc'
      include 'seisan.inc'
c      implicit none
      include 'seiplot.inc'   ! seisan graphics
      real x,y
      character*1 cha(10)                 ! dummy for xy_plot
      character*80 text                   ! general text
      character*80 txt(100)
      character*80 title                  ! title for plot      
      character*30 xtext,ytext            ! axis title
      real xc,yc                          ! screen scaling
      character*1 make_plot 
      integer n,i,id,nwad,l 
      integer*4 hh
c
c   nordic file parameters
c
      CHARACTER*80 DATA(max_data)                                                    
      CHARACTER*1 TYPE,EXP
      logical compact
      integer nstat,nphase,nhead,nrecord,nars
      character*80 file(10)
c
      real a,b,corr,rms 
      real vps,t_origin
      real tp(500)   ! p-times
      real tsp(500)  ! s-p times
      character*30 phase_p(500),phase_s(500) ! info on phases used
      real tor       ! arbitrary origin time, only for line plot
      character*5 stat(500)   ! station codes
c
c   origin time
c
      integer hour,min
      real sec

      include 'version.inc'
      include 'winplot2.inc'



c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   check if input via argument
c
      call get_arguments(nars,file)
      if(nars.lt.1) then
         write(6,*)'File name'
         read(5,'(a)') file(1)
      endif

      open(1,file=file(1),err = 30,status='old') 

c
c   check that not a compact file
c
      call nortype(1,compact)
      if(compact) then
         write(6,*)' Input file compact, cannot use'
         stop
      endif
c
c   read event
c
      call indata(1,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)

      if(nrecord.eq.0) then
         write(6,*)' No data'
         stop
      endif
c
      close(1)
c
c   do wadati analysis
c
      call wadati_s(data,nhead,nrecord,3,nwad,vps,hour,
     *  min,sec,rms,corr,tp,tsp,tor,stat,phase_p,phase_s)

c
c   write result for wadati
c
      if(nwad.ge.2) then
           write(6,'(1x,a,a,2i2,f6.1,a,i4,a,f5.2,a,f6.2,a,f6.3)')
     *     data(1)(1:20),' T0: ',hour,min,sec,' N: ',nwad,' VPS: ',
     *     vps,' RMS: ',rms,' CORR: ',corr
      else
           write(6,'(1x,a,a)') data(1)(1:20),' No data for Wadati'
           stop
      endif

      write(6,*) ' Plot relation (y=default/n)'
      read(5,'(a)') make_plot
      if((make_plot.eq.'y') .or. (make_plot.eq.' ')) then 
c
c  set defaults for output on screen and one hardcopy file
c
          open(65,file='wad_plot.eps',status='unknown')
          plotunit=65
          plotoption=1
          hctype=1
          wsize=60
c
c   open plotter
c
c
c   set some postscipt scalings
c
          write(65,*) ' 1.0 0.55 scale'

          write(title,'(a,2i2,1x,f5.1,a,f6.2)')
     *    ' Wadati diagram:  T0 ',hour,min,sec,'  VP/VS ', vps
          xtext='     P-time, seconds'
          ytext='S-P time    seconds           '
c
c   open display
c
	call open_display 
c
c   plot points
c
          call xy_plot
     *    (1,nwad,tp,tsp,title,xtext,ytext,
     *    600.0,600.0,100.0,100.0,1,1,20.0,
     *    0,cha,i,x,y)	   
c             
c  plot line
c
          call xy_plot_line(vps-1.0,tor,100.0,100.0)
          txt(1)='Select station by'
          txt(2)='clicking near symbol'
          call xmessage(txt,2,25,720.0,650.0)
c
c   plot all stations
c
          i=1
          l=2
          txt(1)='STAT PS  S-P  STAT PS  S-P'
 554      continue
          txt(l)=' '
          do k=1,2
             if(k.eq.1) then
                write(txt(l)(1:13),'(a5,a1,a1,f5.2)')
     *          stat(i),phase_p(i)(11:11),phase_s(i)(11:11),tsp(i)
                i=i+1
                if(i.gt.nwad) goto 555
             endif
             if(k.eq.2) then
                write(txt(l)(16:28),'(a5,a1,a1,f5.2)')
     *          stat(i),phase_p(i)(11:11),phase_s(i)(11:11),tsp(i)
                i=i+1
                l=l+1
                if(i.gt.nwad) goto 555
                goto 554
             endif
          enddo
 555      continue
          if(k.eq.2) l=l-1
          call xmessage(txt,l,28,710.0,10.0)
c
c  call up cursxor so plots remains
c
 55       continue
          call xy_plot_input(100.0,100.0,cha(1),x,y,xc,yc)
c
c   find corresponding station
c
          txt(1)=' '
          txt(1)='Too far from symbol,'
          txt(2)='try again'
          txt(3)=' '
c          write(27,*) x,y
          do i=1,nwad
              if(abs(x-tp(i))*xc.lt.10.0.and.   ! distance in pixels
     *           abs(y-tsp(i))*yc.lt.8.0) then
                 txt(1)(1:25)='STAT CO IPHASW HRMM   SEC'
                 txt(2)(1:25)=phase_p(i)(1:25)
                 txt(3)(1:25)=phase_s(i)(1:25)
c                 write(27,*) x,y,stat(i),phase_p(i),phase_s(i)
c                 write(27,*) txt(1),txt(2),txt(3)
              endif
          enddo
          call xmessage(txt,3,25,720.0,650.0)
          if(cha(1).ne.'q') goto 55   ! next input
           
c          call xscursr(i,xm,ym)                

c
c   close postscript
c
          call close_post
c
c   close output plot file
c 
          close(65)
c
c   close display and back to alpha screen
c
      endif
 30   call clear_to_alpha
      write(6,*)' Plot file is wad_plot.eps'
        
      stop
      end
C
c-----------------------------------------------------------------------------
      subroutine wadati_s
     *(data,nhead,nrecord,min_weight,nwad,vps,hour,min,sec,rms,
     *corr,tp,tsp,tor,statt,phase_p,phase_s)
c
c   routine makes wadati analysis of one event, special version for
c   graphics program
c   jh, february 1998
c
c   input
c
c   data,nhead,nrecord: data, number of headers, number of records 
c   min_weight        : smallest weight to use (0,1,2,3)
c   
c   output
c
c   nwad              : number of points used
c   vps               : vp to vs ratio
c   hour,min,sec      : origin time
c   rms               : rms of fit
c   corr              : correlation coefficient of fit
c   tp,tsp            : p and s-p times
c   tor               : arbitrary origin time
c   statt             : station codes
c   phase_p           : P-phase etc
c   phase_s           : S-phase etc
c
      implicit none
      character*80 data(*)
      integer nhead,nrecord,min_weight,nwad
      real vps,t_origin,rms,corr
      real tp(500)   ! p-times
      real tsp(500)  ! s-p times
      character*5 statt(500) ! station codes
      character*30 phase_p(500),phase_s(500)  ! info phases used
      real sec
      real tor       ! origin
      integer timep  ! hours and minutes in secs
      integer hour,min
      integer hourmin,minmin,tmin  ! earliest p
      character*5 stat   ! one station code
      character*2 phase,phases  ! phase
      character*1 phtype ! if not blank, used all
      integer i,k,iw
      
c
      write(6,*) 'Only use same phase type (e.g. PG and SG) n/y=return'
      read(5,'(a)') phtype
c
c
      nwad=0
      tmin=9999999.0
c
c   find pairs of readings, assume same phase, weight can be in column 9 if
c   phase is long
c
      do i=nhead+1,nrecord
        read(data(i)(15:15),'(i1)',err=50) iw     ! read assigned weight
        goto 51
 50     continue
        read(data(i)(9:9),'(i1)') iw              ! read assigned weight
 51     continue
c
c   find p and s-p for wadati
c
          
        if(data(i)(11:11).eq.'P'.and.iw.le.min_weight) then  ! if valid P
           stat=data(i)(2:6)
           phase=data(i)(11:12)  ! p-phase
           if(phtype.ne.' '.and.phtype.ne.'y') phase(2:2)=' ' ! check if same
           phase_p(nwad+1)=' '
           phase_p(nwad+1)(1:14)=data(i)(2:15)
           phase_p(nwad+1)(16:25)=data(i)(19:28)
           phase(1:1)='S'        ! corresponding s-phase
           do k=nhead+1,nrecord
             read(data(i)(15:15),'(i1)',err=60) iw     ! read assigned weight
             goto 61
  60         continue
             read(data(i)(9:9),'(i1)') iw              ! read assigned weight
  61         continue
             phases=data(k)(11:12)
             if(phtype.ne.' '.and.phtype.ne.'y') phases(2:2)=' '! check if same
             if(phases.eq.phase.and.data(k)(2:6).eq.stat.
     *       and.iw.le.min_weight) then  ! same S
                nwad=nwad+1
                phase_s(nwad)=' '
                phase_s(nwad)(1:14)=data(k)(2:15)
                phase_s(nwad)(16:25)=data(k)(19:28)
                read(data(i)(19:28),'(2i2,f6.1)') hour,min,sec
                tp(nwad)=hour*3600.0+min*60.0+sec
                if(tp(nwad).lt.tmin) then
                   hourmin=hour           ! find earliest for scaling
                   minmin=min
                   tmin=tp(nwad)
                endif
                read(data(k)(19:28),'(2i2,f6.1)') hour,min,sec
                tsp(nwad)=hour*3600.0+min*60.0+sec-tp(nwad)
                statt(nwad)=stat
             endif
           enddo
        endif
      enddo
      timep=hourmin*3600+minmin*60  
      do i=1,nwad
        tp(i)=tp(i)-timep    ! make values smaller so better fit in lsq
      enddo

c
c  all readings done, now do wadati analysis
c
      if(nwad.ge.2) then
         call lsqlin(nwad,tp,tsp,t_origin,vps,corr,rms)
         tor=t_origin
         t_origin=-t_origin/vps+timep
         vps=vps+1
         hour=t_origin/3600
         min=(t_origin-hour*3600)/60
         sec=t_origin-hour*3600-min*60
      endif

      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine xy_plot_input(x0,y0,c,x,y,xc,yc)
c
c  reads positions from the screen much like the main routine
c  all scaling values from routine xy_plot via common
c  x0,y0 are lower left hand corner of plot
c
c  x0,yo : same input as main routine
c  x,y   : output in scaled units
c  c     : character pressed
c  xc    : xscale
c
       implicit none
       character*1 c
       integer ichar
       reaL xc,yc   ! same as x and yscale
       real x1,x,y1,y   ! help variables
       real xfirst,yfirst,x0,y0,xscale,yscale,ymin,ymax,xmin,xmax   ! see xy_plot
       common/xy_plot_common/xfirst,yfirst,xscale,yscale,ymin,
     *                       ymax,xmin,xmax
c
c   call up cursor
c

1           continue
            call xscursr(ichar,x1,y1)
            if (char(ichar).eq.'#') goto 1
            c=char(ichar)
            x=(x1-x0)/xscale+xfirst
            y=(y1-y0)/yscale+yfirst
            xc=xscale
            yc=yscale
c
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c write_mseed.for
c Parameters and variables for writing miniseed files.
c 
c Author: Rodrigo Canabrava
c E-mail: rlpcfr@yahoo.com.br
c Universitetet i Bergen - Department of Earth Sciences
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      INTEGER*4 OUT             ! number of output file
      PARAMETER(OUT = 12)
      
      INTEGER*2 INT_32BIT       ! code number of encoding format
      INTEGER*2 STEIM1, STEIM2  ! code numbers of encoding formats
      PARAMETER(INT_32BIT = 3)
      PARAMETER(STEIM1 = 10)
      PARAMETER(STEIM2 = 11)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c The variables in the following common block must be set before calling
c the function.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      character*5    mseed_station ! station name
      character*2    mseed_location ! location id
      character*3    mseed_channel ! channel name
      character*2    mseed_network ! network id
      integer*4      mseed_year ! year
      integer*4      mseed_month ! month
      integer*4      mseed_day ! day
      integer*4      mseed_hour ! hour
      integer*4      mseed_minute ! minute
      real*4         mseed_second ! second
      integer*4      mseed_total_samples ! total number of samples

      integer*4 mseed_encoding ! encoding format
      real*4    mseed_sample_rate ! sample rate

      COMMON / write_mseed_param / mseed_sample_rate, 
     &     mseed_year, mseed_month, mseed_day, mseed_hour, mseed_minute, 
     &     mseed_second, mseed_total_samples, 
     &     mseed_encoding, mseed_station, mseed_location,
     &     mseed_channel, mseed_network

      SUBROUTINE svbksbx(u,w,v,m,n,mp,np,b,x)
      INTEGER m,mp,n,np,NMAX
      REAL b(mp),u(mp,np),v(np,np),w(np),x(np)
      PARAMETER (NMAX=1000)
      INTEGER i,j,jj
      REAL s,tmp(NMAX)
      do 12 j=1,n
        s=0.
        if(w(j).ne.0.)then
          do 11 i=1,m
            s=s+u(i,j)*b(i)
11        continue
          s=s/w(j)
        endif
        tmp(j)=s
12    continue
      do 14 j=1,n
        s=0.
        do 13 jj=1,n
          s=s+v(j,jj)*tmp(jj)
13      continue
        x(j)=s
14    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.
      SUBROUTINE svdcmpx(a,m,n,mp,np,w,v)
      INTEGER m,mp,n,np,NMAX
      REAL a(mp,np),v(np,np),w(np)
      PARAMETER (NMAX=1000)
CU    USES pythag
      INTEGER i,its,j,jj,k,l,nm
      REAL anorm,c,f,g,h,s,scale,x,y,z,rv1(NMAX),pythag
      g=0.0
      scale=0.0
      anorm=0.0
      do 25 i=1,n
        l=i+1
        rv1(i)=scale*g
        g=0.0
        s=0.0
        scale=0.0
        if(i.le.m)then
          do 11 k=i,m
            scale=scale+abs(a(k,i))
11        continue
          if(scale.ne.0.0)then
            do 12 k=i,m
              a(k,i)=a(k,i)/scale
              s=s+a(k,i)*a(k,i)
12          continue
            f=a(i,i)
            g=-sign(sqrt(s),f)
            h=f*g-s
            a(i,i)=f-g
            do 15 j=l,n
              s=0.0
              do 13 k=i,m
                s=s+a(k,i)*a(k,j)
13            continue
              f=s/h
              do 14 k=i,m
                a(k,j)=a(k,j)+f*a(k,i)
14            continue
15          continue
            do 16 k=i,m
              a(k,i)=scale*a(k,i)
16          continue
          endif
        endif
        w(i)=scale *g
        g=0.0
        s=0.0
        scale=0.0
        if((i.le.m).and.(i.ne.n))then
          do 17 k=l,n
            scale=scale+abs(a(i,k))
17        continue
          if(scale.ne.0.0)then
            do 18 k=l,n
              a(i,k)=a(i,k)/scale
              s=s+a(i,k)*a(i,k)
18          continue
            f=a(i,l)
            g=-sign(sqrt(s),f)
            h=f*g-s
            a(i,l)=f-g
            do 19 k=l,n
              rv1(k)=a(i,k)/h
19          continue
            do 23 j=l,m
              s=0.0
              do 21 k=l,n
                s=s+a(j,k)*a(i,k)
21            continue
              do 22 k=l,n
                a(j,k)=a(j,k)+s*rv1(k)
22            continue
23          continue
            do 24 k=l,n
              a(i,k)=scale*a(i,k)
24          continue
          endif
        endif
        anorm=max(anorm,(abs(w(i))+abs(rv1(i))))
25    continue
      do 32 i=n,1,-1
        if(i.lt.n)then
          if(g.ne.0.0)then
            do 26 j=l,n
              v(j,i)=(a(i,j)/a(i,l))/g
26          continue
            do 29 j=l,n
              s=0.0
              do 27 k=l,n
                s=s+a(i,k)*v(k,j)
27            continue
              do 28 k=l,n
                v(k,j)=v(k,j)+s*v(k,i)
28            continue
29          continue
          endif
          do 31 j=l,n
            v(i,j)=0.0
            v(j,i)=0.0
31        continue
        endif
        v(i,i)=1.0
        g=rv1(i)
        l=i
32    continue
      do 39 i=min(m,n),1,-1
        l=i+1
        g=w(i)
        do 33 j=l,n
          a(i,j)=0.0
33      continue
        if(g.ne.0.0)then
          g=1.0/g
          do 36 j=l,n
            s=0.0
            do 34 k=l,m
              s=s+a(k,i)*a(k,j)
34          continue
            f=(s/a(i,i))*g
            do 35 k=i,m
              a(k,j)=a(k,j)+f*a(k,i)
35          continue
36        continue
          do 37 j=i,m
            a(j,i)=a(j,i)*g
37        continue
        else
          do 38 j= i,m
            a(j,i)=0.0
38        continue
        endif
        a(i,i)=a(i,i)+1.0
39    continue
      do 49 k=n,1,-1
        do 48 its=1,30
          do 41 l=k,1,-1
            nm=l-1
            if((abs(rv1(l))+anorm).eq.anorm)  goto 2
            if((abs(w(nm))+anorm).eq.anorm)  goto 1
41        continue
1         c=0.0
          s=1.0
          do 43 i=l,k
            f=s*rv1(i)
            rv1(i)=c*rv1(i)
            if((abs(f)+anorm).eq.anorm) goto 2
            g=w(i)
            h=pythag(f,g)
            w(i)=h
            h=1.0/h
            c= (g*h)
            s=-(f*h)
            do 42 j=1,m
              y=a(j,nm)
              z=a(j,i)
              a(j,nm)=(y*c)+(z*s)
              a(j,i)=-(y*s)+(z*c)
42          continue
43        continue
2         z=w(k)
          if(l.eq.k)then
            if(z.lt.0.0)then
              w(k)=-z
              do 44 j=1,n
                v(j,k)=-v(j,k)
44            continue
            endif
            goto 3
          endif
          if(its.eq.30) pause 'no convergence in svdcmp'
          x=w(l)
          nm=k-1
          y=w(nm)
          g=rv1(nm)
          h=rv1(k)
          f=((y-z)*(y+z)+(g-h)*(g+h))/(2.0*h*y)
          g=pythag(f,1.0)
          f=((x-z)*(x+z)+h*((y/(f+sign(g,f)))-h))/x
          c=1.0
          s=1.0
          do 47 j=l,nm
            i=j+1
            g=rv1(i)
            y=w(i)
            h=s*g
            g=c*g
            z=pythag(f,h)
            rv1(j)=z
            c=f/z
            s=h/z
            f= (x*c)+(g*s)
            g=-(x*s)+(g*c)
            h=y*s
            y=y*c
            do 45 jj=1,n
              x=v(jj,j)
              z=v(jj,i)
              v(jj,j)= (x*c)+(z*s)
              v(jj,i)=-(x*s)+(z*c)
45          continue
            z=pythag(f,h)
            w(j)=z
            if(z.ne.0.0)then
              z=1.0/z
              c=f*z
              s=h*z
            endif
            f= (c*g)+(s*y)
            x=-(s*g)+(c*y)
            do 46 jj=1,m
              y=a(jj,j)
              z=a(jj,i)
              a(jj,j)= (y*c)+(z*s)
              a(jj,i)=-(y*s)+(z*c)
46          continue
47        continue
          rv1(l)=0.0
          rv1(k)=f
          w(k)=x
48      continue
3       continue
49    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.
      FUNCTION pythag(a,b)
      REAL a,b,pythag
      REAL absa,absb
      absa=abs(a)
      absb=abs(b)
      if(absa.gt.absb)then
        pythag=absa*sqrt(1.+(absb/absa)**2)
      else
        if(absb.eq.0.)then
          pythag=0.
        else
          pythag=absb*sqrt(1.+(absa/absb)**2)
        endif
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.
      SUBROUTINE svdvar(v,ma,np,w,cvm,ncvm)
      INTEGER ma,ncvm,np,MMAX
      REAL cvm(ncvm,ncvm),v(np,np),w(np)
      PARAMETER (MMAX=1000)
      INTEGER i,j,k
      REAL sum,wti(MMAX)
      do 11 i=1,ma
        wti(i)=0.
        if(w(i).ne.0.) wti(i)=1./(w(i)*w(i))
11    continue
      do 14 i=1,ma
        do 13 j=1,i
          sum=0.
          do 12 k=1,ma
            sum=sum+v(i,k)*v(j,k)*wti(k)
12        continue
          cvm(i,j)=sum
          cvm(j,i)=sum
13      continue
14    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.
      SUBROUTINE lubksbx(a,n,np,indx,b)
      INTEGER n,np,indx(n)
      real a(np,np),b(n),sum
      INTEGER i,ii,j,ll
      ii=0
      do 12 i=1,n
        ll=indx(i)
        sum=b(ll)
        b(ll)=b(i)
        if (ii.ne.0)then
          do 11 j=ii,i-1
            sum=sum-a(i,j)*b(j)
11        continue
        else if (sum.ne.0.) then
          ii=i
        endif
        b(i)=sum
12    continue
      do 14 i=n,1,-1
        sum=b(i)
        do 13 j=i+1,n
          sum=sum-a(i,j)*b(j)
13      continue
        b(i)=sum/a(i,i)
14    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.
      SUBROUTINE ludcmpx(a,n,np,indx,d)
      INTEGER n,np,indx(n),NMAX
      real d,a(np,np),TINY
      PARAMETER (NMAX=1000,TINY=1.0e-20)
      INTEGER i,imax,j,k
      real aamax,dum,sum,vv(NMAX)
      d=1.
      do 12 i=1,n
        aamax=0.
        do 11 j=1,n
          if (abs(a(i,j)).gt.aamax) aamax=abs(a(i,j))
11      continue
        if (aamax.eq.0.) write(*,*) i, 'singular matrix in ludcmp'
c        if (aamax.eq.0.) pause 'singular matrix in ludcmp'
        vv(i)=1./aamax
12    continue
      do 19 j=1,n
        do 14 i=1,j-1
          sum=a(i,j)
          do 13 k=1,i-1
            sum=sum-a(i,k)*a(k,j)
13        continue
          a(i,j)=sum
14      continue
        aamax=0.
        do 16 i=j,n
          sum=a(i,j)
          do 15 k=1,j-1
            sum=sum-a(i,k)*a(k,j)
15        continue
          a(i,j)=sum
          dum=vv(i)*abs(sum)
          if (dum.ge.aamax) then
            imax=i
            aamax=dum
          endif
16      continue
        if (j.ne.imax)then
          do 17 k=1,n
            dum=a(imax,k)
            a(imax,k)=a(j,k)
            a(j,k)=dum
17        continue
          d=-d
          vv(imax)=vv(j)
        endif
        indx(j)=imax
        if(a(j,j).eq.0.)a(j,j)=TINY
        if(j.ne.n)then
          dum=1./a(j,j)
          do 18 i=j+1,n
            a(i,j)=a(i,j)*dum
18        continue
        endif
19    continue
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.

c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine component(incomp,outcomp)
c
c     Routine to convert from component notations of datafile to
c     notations as used in S files
c
c     Written by C. Lindholm,  Oct. 1989
c     update
c     oct 8 93 by jh : include BV components
c     jan 4 94       : include SV ---------
c     mar 95         : include transverse and radial
c     oct 95         : include B  Z etc
c     jan 8          : include LV Z etc
c     april 5, 98    : include LH and SH
c     sep 98         : ----------------- version 7.0 check ------------
c                      always return a 2 component code, even if not defined
c                      then use first and last letter fo input component
c
c     Input:  incomp   :  Datafile type component
c     Output: outcomp  :  S file type component
c
      implicit  none
      character*4 incomp
      character*2 outcomp

      outcomp = '  '
      if(incomp.eq.'S  Z')outcomp = 'SZ'
      if(incomp.eq.'S  N')outcomp = 'SN'
      if(incomp.eq.'S  E')outcomp = 'SE'
      if(incomp.eq.'L  Z')outcomp = 'LZ'
      if(incomp.eq.'L  N')outcomp = 'LN'
      if(incomp.eq.'L  E')outcomp = 'LE'
      if(incomp.eq.'AL Z')outcomp = 'AZ'
      if(incomp.eq.'AL N')outcomp = 'AN'
      if(incomp.eq.'AL E')outcomp = 'AE'
      if(incomp.eq.'AH Z')outcomp = 'AZ'
      if(incomp.eq.'AH N')outcomp = 'AN'
      if(incomp.eq.'AH E')outcomp = 'AE'
      if(incomp.eq.'A  Z')outcomp = 'AZ'
      if(incomp.eq.'A  N')outcomp = 'AN'
      if(incomp.eq.'A  E')outcomp = 'AE'
      if(incomp.eq.'BV Z')outcomp = 'BZ'
      if(incomp.eq.'BV N')outcomp = 'BN'
      if(incomp.eq.'BV E')outcomp = 'BE'
      if(incomp.eq.'BH Z')outcomp = 'BZ'
      if(incomp.eq.'BH N')outcomp = 'BN'
      if(incomp.eq.'BH E')outcomp = 'BE'
      if(incomp.eq.'B  Z')outcomp = 'BZ'
      if(incomp.eq.'B  N')outcomp = 'BN'
      if(incomp.eq.'B  E')outcomp = 'BE'
      if(incomp.eq.'SV Z')outcomp = 'SZ'
      if(incomp.eq.'SV N')outcomp = 'SN'
      if(incomp.eq.'SV E')outcomp = 'SE'
      if(incomp.eq.'SH Z')outcomp = 'SZ'
      if(incomp.eq.'SH N')outcomp = 'SN'
      if(incomp.eq.'SH E')outcomp = 'SE'
      if(incomp.eq.'LV Z')outcomp = 'VZ'
      if(incomp.eq.'LV N')outcomp = 'VN'
      if(incomp.eq.'LV E')outcomp = 'VE'
c
c  rotated components
c
      if(incomp.eq.'S  R')outcomp = 'SR'
      if(incomp.eq.'S  T')outcomp = 'ST'
      if(incomp.eq.'L  R')outcomp = 'LR'
      if(incomp.eq.'L  T')outcomp = 'LT'
      if(incomp.eq.'AL R')outcomp = 'AR'
      if(incomp.eq.'AL T')outcomp = 'AT'
      if(incomp.eq.'AH R')outcomp = 'AR'
      if(incomp.eq.'AH T')outcomp = 'AT'
      if(incomp.eq.'A  R')outcomp = 'AR'
      if(incomp.eq.'A  T')outcomp = 'AT'
      if(incomp.eq.'BV R')outcomp = 'BR'
      if(incomp.eq.'BV T')outcomp = 'BT'
      if(incomp.eq.'SV R')outcomp = 'SR'
      if(incomp.eq.'SV T')outcomp = 'ST'
c
c   if no component is recognized, use first and last letter of
c   component
c
      if(outcomp.eq.'  ') then
         outcomp(1:1)=incomp(1:1)
         outcomp(2:2)=incomp(4:4)
      endif
      return
      end

c
c basic routines and functions used in geneteic algorithm routines
c

      character*(*) function dec_to_bin(x,ll)
c
c convert real number to binary
c
      implicit none
      real x,y
      character*24 text
      integer i,ll,c
c      integer seiclen
      y=x
      c=0
      text='                        '
      do i=ll,1,-1
        c=c+1
        if (y-(2.**(i-1)).gt.0.) then
          y=y-(2.**(i-1))
          write(text(c:c),'(a1)') '1'
        else
          write(text(c:c),'(a1)') '0'
        endif
      enddo
      dec_to_bin = text(1:c)
      end


      real function bin_to_dec(j,ll)
c
c convert binary to decimal number
c
      implicit none
      integer ll,i,j(*)
      real x
      x=0.
      do i=1,ll
        x=x+float(j(i))*2.**(float(i-1))
      enddo
      bin_to_dec=x
      end


      subroutine text_to_array(tt,j,ll)
c
c read numbers in text string into integer array
c
      implicit none
      character*(*) tt
      integer j(*),ll,i,a
      a=0
      do i=ll,1,-1
        a=a+1
        read(tt(i:i),'(i1)') j(a)
      enddo
      return
      end

c$debug
c
c   changes
c
c  sep 98 by jh :   --------- sesian version 7.0 check, no change --------------
c
c  oct 28 98 bmt : linux changed, iargc vs iiargc, abort vs aabort
c                  because are reserved function
c  jul  27   jh  : change message
c  jul 21 03 jh  : diff to dif
c
      function iiargc(n)
c
c $$$$$ calls getcl $$$$$
c
c   Iargc returns the number of command line arguments present.
c   To use command line arguments see the comments in getarg.
c   Argument n of iargc is a dummy and is never used.
c   Programmed on 28 January 1981 by R. Buland.
c
      character*100 ib
      common/gtarc1/nsw,narg,lb
      common/gtarc2/ib
c   Read in the command line into ib if it hasn't already been done.
      n=0
      if(nsw.lt.0) call getcl
      iiargc=narg
      return
      end

      subroutine aabort(msg)
c
c $$$$$ calls VMS library routines $$$$$
c
c   Subroutine abort issues the VMS style fatal error message:
c
c      USRMSG-F-ABORT, <string>
c
c   accompanied by a standard FORTRAN traceback, where <string> is the
c   string in character variable msg.  Subroutine warn issues the VMS
c   style warning:
c
c      USRMSG-W-WARN, <string>
c
c   also accompanied by a FORTRAN traceback.  Calling abort terminates
c   the calling program.  However, warn returns control to the caller
c   after issuing the traceback.  Programmed on 15 June 1983 by
c   R. Buland.
c
      character*80 msg
      write(*,*)msg
c      stop 
      return
c   Subroutine warn.
      entry warn(msg)
      write(*,*)msg
c      pause
      return
      end

      subroutine asnag1(lu,mode,n,ia,ib)
c
c $$$$$ calls assign, iargc, and getarg $$$$$
c
c   Asnag1 assigns logical unit lu to a direct access disk file
c   with mode "mode" and record length "len".  See dasign for
c   details.  The n th argument is used as the model name.  If there
c   is no n th argument and ib is non-blank, it is taken to be the
c   model name.  If ib is blank, the user is prompted for the
c   model name using the character string in variable ia as the
c   prompt.  Programmed on 8 October 1980 by R. Buland.
c
      save
      logical log

c changed BRL
      character*80 ia,ib

c
      i=0
      if(iiargc(i).lt.n) go to 1
      call ggetarg(n,ib)
      go to 2
c
 1    if(ib.ne.' ') go to 2
      call query(ia,log)
      read(*,100)ib
 100  format(a)
c
 2    nb=index(ib,' ')-1
      if(nb.le.0) nb=len(ib)

c changed BRL: added char(0)
      ia=ib(1:nb)//char(0)
      call assign(lu,mode,ia)

      return
      end

      subroutine assign(lu,mode,ia)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine assign opens (connects) logical unit lu to the disk file
c   named by the character string ia with mode mode.  If iabs(mode) = 1,
c   then open the file for reading.  If iabs(mode) = 2, then open the
c   file for writing.  If iabs(mode) = 3, then open a scratch file for
c   writing.  If mode > 0, then the file is formatted.  If mode < 0,
c   then the file is unformatted.  All files opened by assign are
c   assumed to be sequential.  Programmed on 3 December 1979 by
c   R. Buland.
c
      save
      character*80 ia
      logical exst
c
      if(mode.ge.0) nf=1
      if(mode.lt.0) nf=2
      ns=iabs(mode)
      if(ns.le.0.or.ns.gt.3) ns=3
      go to (1,2),nf
 1    go to (11,12,13),ns
 11   open(lu,file=ia,status='old',form='formatted')
      rewind lu
      return
 12   inquire(file=ia,exist=exst)
      if(exst) go to 11
 13   open(lu,file=ia,status='new',form='formatted')
      return
 2    go to (21,22,23),ns
 21   open(lu,file=ia,status='old',form='unformatted')
      rewind lu
      return
 22   inquire(file=ia,exist=exst)
      if(exst) go to 21
 23   open(lu,file=ia,status='new',form='unformatted')
      return
      end

      subroutine bkin(lu,nrec,length,buf)
c
c $$$$$ calls no other routines $$$$$
c
c   Bkin reads a block of length double precision words into array buf(len)
c   from record nrec of the direct access unformatted file connected to
c   logical unit lu.
c
      save
      double precision buf(length),tmp
c
      if(nrec.le.0) go to 1
      read(lu,rec=nrec)buf
c      write(10,'(6e12.4)')(buf(i),i=1,length)
      tmp=buf(1)
      return
c   If the record doesn't exist, zero fill the buffer.
 1    do 2 i=1,length
 2    buf(i)=0d0
c      write(10,*)'nrec=0'
      return
      end

      subroutine brnset(nn,pcntl,prflg)
c
c   Brnset takes character array pcntl(nn) as a list of nn tokens to be
c   used to select desired generic branches.  Prflg(3) is the old
c   prnt(2) debug print flags in the first two elements plus a new print
c   flag which controls a branch selected summary from brnset.  Note that
c   the original two flags controlled a list of all tau interpolations
c   and a branch range summary respectively.  The original summary output
c   still goes to logical unit 10 (ttim1.lis) while the new output goes
c   to the standard output (so the caller can see what happened).  Each
c   token of pcntl may be either a generic branch name (e.g., P, PcP,
c   PKP, etc.) or a keyword (defined in the data statement for cmdcd
c   below) which translates to more than one generic branch names.  Note
c   that generic branch names and keywords may be mixed.  The keywords
c   'all' (for all branches) and 'query' (for an interactive token input
c   query mode) are also available.
c
      save
      parameter(ncmd=4,lcmd=16)
      include 'ttlim.inc'
      logical prflg(3),segmsk,prnt,fnd,all
      character*80 fnam
      character*8 pcntl(nn)
      character*8 phcd,segcd(jbrn),cmdcd(ncmd),cmdlst(lcmd),phtmp,
     1 phlst(jseg),phcd1
      double precision zs,pk,pu,pux,tauu,xu,px,xt,taut,coef,tauc,xc,
     1 tcoef,tp
      dimension nsgpt(jbrn),ncmpt(2,ncmd)
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
c   Segmsk is a logical array that actually implements the branch
c   editing in depset and depcor.
      common/prtflc/segmsk(jseg),prnt(2)
c
c   The keywords do the following:
c      P      gives P-up, P, Pdiff, PKP, and PKiKP
c      P+     gives P-up, P, Pdiff, PKP, PKiKP, PcP, pP, pPdiff, pPKP,
c             pPKiKP, sP, sPdiff, sPKP, and sPKiKP
c      S+     gives S-up, S, Sdiff, SKS, sS, sSdiff, sSKS, pS, pSdiff,
c             and pSKS
c      basic  gives P+ and S+ as well as ScP, SKP, PKKP, SKKP, PP, and
c             P'P'
c   Note that generic S gives S-up, Sdiff, and SKS already and so
c   doesn't require a keyword.
c
      data cmdcd/'P','P+','basic','S+'/
      data cmdlst/'P','PKiKP','PcP','pP','pPKiKP','sP','sPKiKP','ScP',
     1 'SKP','PKKP','SKKP','PP','S','ScS','sS','pS'/
      data ncmpt/1,2,1,7,1,13,13,16/
c
c   Take care of the print flags.
      prnt(1)=prflg(1)
      prnt(2)=prflg(2)
      if(prnt(1)) prnt(2)=.true.
c   Copy the token list into local storage.
      no=min0(nn,jseg)
      do 23 i=1,no
 23   phlst(i)=pcntl(i)
c   See if we are in query mode.
      if(no.gt.1.or.(phlst(1).ne.'query'.and.phlst(1).ne.'QUERY'))
     1 go to 1
c
c   In query mode, get the tokens interactively into local storage.
c
 22   write(*,1000)
1000  format(' Enter desired branch control list at the prompts:',$)
      no=0
 21   fnam=char(0)
      call query(fnam,fnd)
      if(no.ge.jseg) go to 1
      no=no+1
      read 100,phlst(no)
 100  format(a)
c   Terminate the list of tokens with a blank entry.
      if(phlst(no).ne.' ') go to 21
      no=no-1
      if(no.gt.0) go to 1
c   If the first token is blank, help the user out.
      print *,'You must enter some branch control information!'
      print *,'     possibilities are:'
      print *,'          all'
      print 101,cmdcd
 101  format(11x,a)
      print *,'          or any generic phase name'
      go to 22
c
c   An 'all' keyword is easy as this is already the default.
 1    all=.false.
      if(no.eq.1.and.(phlst(1).eq.'all'.or.phlst(1).eq.'ALL'))
     1 all=.true.
      if(all.and..not.prflg(3)) return
c
c   Make one or two generic branch names for each segment.  For example,
c   the P segment will have the names P and PKP, the PcP segment will
c   have the name PcP, etc.
c
      kseg=0
      j=0
c   Loop over the segments.
      do 2 i=1,nseg
      if(.not.all) segmsk(i)=.false.
c   For each segment, loop over associated branches.
 9    j=j+1
      phtmp=phcd(j)
c   Turn the specific branch name into a generic name by stripping out
c   the crustal branch and core phase branch identifiers.
      do 3 l=2,8
 6    if(phtmp(l:l).eq.' ') go to 4
      if(phtmp(l:l).ne.'g'.and.phtmp(l:l).ne.'b'.and.phtmp(l:l).ne.'n')
     1 go to 5
       phcd1=phtmp(l+1:)
      if(l.lt.8) phtmp(l:)=phcd1(1:8-l)
      if(l.ge.8) phtmp(l:)=' '
      go to 6
 5    if(l.ge.8) go to 3
      if(phtmp(l:l+1).ne.'ab'.and.phtmp(l:l+1).ne.'ac'.and.
     1 phtmp(l:l+1).ne.'df') go to 3
      phtmp(l:l+1)='  '
      go to 4
 3    continue
 4    continue
c    print *,'j phcd phtmp =',j,' ',phcd(j),' ',phtmp
c
c   Make sure generic names are unique within a segment.
      if(kseg.lt.1) go to 7
      if(phtmp.eq.segcd(kseg)) go to 8
 7    kseg=kseg+1
      segcd(kseg)=phtmp
      nsgpt(kseg)=i
c      if(prflg(3)) print *,'kseg nsgpt segcd =',kseg,nsgpt(kseg),' ',
c     1 segcd(kseg)
 8    if(jidx(j).lt.indx(i,2)) go to 9
 2    continue
      if(all) go to 24
c
c   Interpret the tokens in terms of the generic branch names.
c
      do 10 i=1,no
c   Try for a keyword first.
      do 11 j=1,ncmd
      if(phlst(i).eq.cmdcd(j)) go to 12
 11   continue
c
c   If the token isn't a keyword, see if it is a generic branch name.
      fnd=.false.
      do 14 k=1,kseg
      if(phlst(i).ne.segcd(k)) go to 14
      fnd=.true.
      l=nsgpt(k)
      segmsk(l)=.true.
c      print *,'Brnset:  phase found - i k l segcd =',i,k,l,' ',
c     1 segcd(k)
 14   continue
c   If no matching entry is found, warn the caller.
      if(.not.fnd) print *,'Brnset:  phase ',phlst(i),' not found.'
      go to 10
c
c   If the token is a keyword, find the matching generic branch names.
 12   j1=ncmpt(1,j)
      j2=ncmpt(2,j)
      do 15 j=j1,j2
      do 15 k=1,kseg
      if(cmdlst(j).ne.segcd(k)) go to 15
      l=nsgpt(k)
      segmsk(l)=.true.
c      print *,'Brnset:  cmdlst found - j k l segcd =',j,k,l,' ',
c     1 segcd(k)
 15   continue
 10   continue
c
c   Make the caller a list of the generic branch names selected.
c
 24   if(.not.prflg(3)) return
      fnd=.false.
      j2=0
c   Loop over segments.
      do 16 i=1,nseg
      if(.not.segmsk(i)) go to 16
c   If selected, find the associated generic branch names.
      j2=j2+1
      do 17 j1=j2,kseg
      if(nsgpt(j1).eq.i) go to 18
 17   continue
      print *,'Brnset:  Segment pointer (',i,') missing?'
      go to 16
 18   do 19 j2=j1,kseg
      if(nsgpt(j2).ne.i) go to 20
 19   continue
      j2=kseg+1
c   Print the result.
 20   j2=j2-1
      if(.not.fnd) print *,'Brnset:  the following phases have '//
     1 'been selected for calculation-'
      fnd=.true.
      print 102,i,(segcd(j),j=j1,j2)
 102  format(10x,i5,5(2x,a))
 16   continue
      return
      end

      subroutine depcor(nph)
      save
      include 'ttlim.inc'
      character*8 phcd
      logical noend,noext,segmsk,prnt
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp,ua,taua
      double precision tup(jrec),umod,zmod,tauus1(2),tauus2(2),xus1(2),
     1 xus2(2),ttau,tx,sgn,umin,dtol,u0,u1,z0,z1,fac,du
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      common/pdec/ua(5,2),taua(5,2),deplim,ka
      common/prtflc/segmsk(jseg),prnt(2)
      equivalence (tauc,tup)
      data tol,dtol,deplim,ka,lpower/.01,1d-6,1.1,4,7/
c
c      write(10,*)'depcor:  nph nph0 nin',nph,nph0,nin

      if(nph.eq.nph0) go to 1
      nph0=nph
      us(nph)=umod(zs,isrc,nph)
c   If we are in a high slowness zone, find the slowness of the lid.
      umin=us(nph)
      ks=isrc(nph)
c      write(10,*)'ks us',ks,sngl(umin)
      do 2 i=1,ks
      if(pm(i,nph).gt.umin) go to 2
      umin=pm(i,nph)
 2    continue
c   Find where the source slowness falls in the ray parameter array.
      n1=ku(nph)+1
      do 3 i=2,n1
      if(pu(i,nph).gt.umin) go to 4
 3    continue
      k2=n1
      if(pu(n1,nph).eq.umin) go to 50
      call aabort('Source slowness too large.')
 4    k2=i
  50  continue
c 50   write(10,*)'k2 umin',k2,sngl(umin)
c
c   Read in the appropriate depth correction values.
c
      noext=.false.
      sgn=1d0
      if(msrc(nph).eq.0) msrc(nph)=1
c   See if the source depth coincides with a model sample
      ztol=xn*tol/(1.-xn*odep)
      if(dabs(zs-zm(ks+1,nph)).gt.ztol) go to 5
      ks=ks+1
      go to 6
 5    if(dabs(zs-zm(ks,nph)).gt.ztol) go to 7
c   If so flag the fact and make sure that the right integrals are
c   available.
 6    noext=.true.
      if(msrc(nph).eq.ks) go to 8
      call bkin(nin,ndex(ks,nph),ku(nph)+km(nph),tup)
      go to 11
c   If it is necessary to interpolate, see if appropriate integrals
c   have already been read in.
 7    if(msrc(nph).ne.ks+1) go to 9
      ks=ks+1
      sgn=-1d0
      go to 8
 9    if(msrc(nph).eq.ks) go to 8
c   If not, read in integrals for the model depth nearest the source
c   depth.
      if(dabs(zm(ks,nph)-zs).le.dabs(zm(ks+1,nph)-zs)) go to 10
      ks=ks+1
      sgn=-1d0
 10   call bkin(nin,ndex(ks,nph),ku(nph)+km(nph),tup)
c   Move the depth correction values to a less temporary area.
 11   do 31 i=1,ku(nph)
 31   tauu(i,nph)=tup(i)
      k=ku(nph)
      do 12 i=1,km(nph)
      k=k+1
      xc(i)=tup(k)
 12   xu(i,nph)=tup(k)
c      write(10,*)'bkin',ks,sngl(sgn),sngl(tauu(1,nph)),sngl(xu(1,nph))
c
c   Fiddle pointers.
c
 8    msrc(nph)=ks
c      write(10,*)'msrc sgn',msrc(nph),sngl(sgn)
      noend=.false.
      if(dabs(umin-pu(k2-1,nph)).le.dtol*umin) k2=k2-1
      if(dabs(umin-pu(k2,nph)).le.dtol*umin) noend=.true.
      if(msrc(nph).le.1.and.noext) msrc(nph)=0
      k1=k2-1
      if(noend) k1=k2
c      write(10,*)'noend noext k2 k1',noend,noext,k2,k1
      if(noext) go to 14
c
c   Correct the integrals for the depth interval [zm(msrc),zs].
c
      ms=msrc(nph)
      if(sgn)15,16,16
 16   u0=pm(ms,nph)
      z0=zm(ms,nph)
      u1=us(nph)
      z1=zs
      go to 17
 15   u0=us(nph)
      z0=zs
      u1=pm(ms,nph)
      z1=zm(ms,nph)
 17   mu=1
c      write(10,*)'u0 z0',sngl(u0),sngl(z0)
c      write(10,*)'u1 z1',sngl(u1),sngl(z1)
      do 18 k=1,k1
      call tauint(pu(k,nph),u0,u1,z0,z1,ttau,tx)
      tauc(k)=tauu(k,nph)+sgn*ttau
      if(dabs(pu(k,nph)-pux(mu,nph)).gt.dtol) go to 18
      xc(mu)=xu(mu,nph)+sgn*tx
c      write(10,*)'up x:  k mu',k,mu,sngl(xu(mu,nph)),sngl(xc(mu))
      mu=mu+1
 18   continue
      go to 39
c   If there is no correction, copy the depth corrections to working
c   storage.
 14   mu=1
      do 40 k=1,k1
      tauc(k)=tauu(k,nph)
      if(dabs(pu(k,nph)-pux(mu,nph)).gt.dtol) go to 40
      xc(mu)=xu(mu,nph)
c      write(10,*)'up x:  k mu',k,mu,sngl(xu(mu,nph)),sngl(xc(mu))
      mu=mu+1
 40   continue
c
c   Calculate integrals for the ray bottoming at the source depth.
c
 39   xus1(nph)=0d0
      xus2(nph)=0d0
      mu=mu-1
      if(dabs(umin-us(nph)).gt.dtol.and.dabs(umin-pux(mu,nph)).le.dtol)
     1  mu=mu-1
c   This loop may be skipped only for surface focus as range is not
c   available for all ray parameters.
      if(msrc(nph).le.0) go to 1
      is=isrc(nph)
      tauus2(nph)=0d0
      if(dabs(pux(mu,nph)-umin).gt.dtol.or.dabs(us(nph)-umin).gt.dtol)
     1  go to 48
c   If we happen to be right at a discontinuity, range is available.
      tauus1(nph)=tauc(k1)
      xus1(nph)=xc(mu)
c      write(10,*)'is ks tauus1 xus1',is,ks,sngl(tauus1(nph)),
c     1 sngl(xus1(nph)),'  *'
      go to 33
c   Integrate from the surface to the source.
 48   tauus1(nph)=0d0
      j=1
      if(is.lt.2) go to 42
      do 19 i=2,is
      call tauint(umin,pm(j,nph),pm(i,nph),zm(j,nph),zm(i,nph),ttau,tx)
      tauus1(nph)=tauus1(nph)+ttau
      xus1(nph)=xus1(nph)+tx
 19   j=i
c      write(10,*)'is ks tauus1 xus1',is,ks,sngl(tauus1(nph)),
c     1 sngl(xus1(nph))
 42   if(dabs(zm(is,nph)-zs).le.dtol) go to 33
c   Unless the source is right on a sample slowness, one more partial
c   integral is needed.
      call tauint(umin,pm(is,nph),us(nph),zm(is,nph),zs,ttau,tx)
      tauus1(nph)=tauus1(nph)+ttau
      xus1(nph)=xus1(nph)+tx
c      write(10,*)'is ks tauus1 xus1',is,ks,sngl(tauus1(nph)),
c     1 sngl(xus1(nph))
 33   if(pm(is+1,nph).lt.umin) go to 41
c   If we are in a high slowness zone, we will also need to integrate
c   down to the turning point of the shallowest down-going ray.
      u1=us(nph)
      z1=zs
      do 35 i=is+1,mt(nph)
      u0=u1
      z0=z1
      u1=pm(i,nph)
      z1=zm(i,nph)
      if(u1.lt.umin) go to 36
      call tauint(umin,u0,u1,z0,z1,ttau,tx)
      tauus2(nph)=tauus2(nph)+ttau
 35   xus2(nph)=xus2(nph)+tx
  36  continue
c 36   write(10,*)'is ks tauus2 xus2',is,ks,sngl(tauus2(nph)),
c     1 sngl(xus2(nph))
      z1=zmod(umin,i-1,nph)
      if(dabs(z0-z1).le.dtol) go to 41
c   Unless the turning point is right on a sample slowness, one more
c   partial integral is needed.
      call tauint(umin,u0,umin,z0,z1,ttau,tx)
      tauus2(nph)=tauus2(nph)+ttau
      xus2(nph)=xus2(nph)+tx
c      write(10,*)'is ks tauus2 xus2',is,ks,sngl(tauus2(nph)),
c     1 sngl(xus2(nph))
c
c   Take care of converted phases.
c
 41   iph=mod(nph,2)+1
      xus1(iph)=0d0
      xus2(iph)=0d0
      tauus1(iph)=0d0
      tauus2(iph)=0d0
      go to (59,61),nph
 61   if(umin.gt.pu(ku(1)+1,1)) go to 53
c
c   If we are doing an S-wave depth correction, we may need range and
c   tau for the P-wave which turns at the S-wave source slowness.  This
c   would bd needed for sPg and SPg when the source is in the deep mantle.
c
      do 44 j=1,nbrn
      if((phcd(j)(1:2).ne.'sP'.and.phcd(j)(1:2).ne.'SP').or.
     1 px(j,2).le.0d0) go to 44
c      write(10,*)'Depcor:  j phcd px umin =',j,' ',phcd(j),px(j,1),
c     1 px(j,2),umin
      if(umin.ge.px(j,1).and.umin.lt.px(j,2)) go to 45
 44   continue
      go to 53
c
c   If we are doing an P-wave depth correction, we may need range and
c   tau for the S-wave which turns at the P-wave source slowness.  This
c   would be needed for pS and PS.
c
 59   do 60 j=1,nbrn
      if((phcd(j)(1:2).ne.'pS'.and.phcd(j)(1:2).ne.'PS').or.
     1 px(j,2).le.0d0) go to 60
c      write(10,*)'Depcor:  j phcd px umin =',j,' ',phcd(j),px(j,1),
c     1 px(j,2),umin
      if(umin.ge.px(j,1).and.umin.lt.px(j,2)) go to 45
 60   continue
      go to 53
c
c   Do the integral.
 45   j=1
c      write(10,*)'Depcor:  do pS or sP integral - iph =',iph
      do 46 i=2,mt(iph)
      if(umin.ge.pm(i,iph)) go to 47
      call tauint(umin,pm(j,iph),pm(i,iph),zm(j,iph),zm(i,iph),ttau,tx)
      tauus1(iph)=tauus1(iph)+ttau
      xus1(iph)=xus1(iph)+tx
 46   j=i
 47   z1=zmod(umin,j,iph)
      if(dabs(zm(j,iph)-z1).le.dtol) go to 53
c   Unless the turning point is right on a sample slowness, one more
c   partial integral is needed.
      call tauint(umin,pm(j,iph),umin,zm(j,iph),z1,ttau,tx)
      tauus1(iph)=tauus1(iph)+ttau
      xus1(iph)=xus1(iph)+tx
c      write(10,*)'is ks tauusp xusp',j,ks,sngl(tauus1(iph)),
c     1 sngl(xus1(iph))
c
 53   ua(1,nph)=-1d0
c     if(odep.ge.deplim.or.odep.le..1) go to 43
      if(odep.ge.deplim) go to 43
      do 57 i=1,nseg
      if(.not.segmsk(i)) go to 57
      if(nafl(i,1).eq.nph.and.nafl(i,2).eq.0.and.iidx(i).le.0) go to 58
 57   continue
      go to 43
c
c   If the source is very shallow, we will need to insert some extra
c   ray parameter samples into the up-going branches.
c
 58   du=amin1(1e-5+(odep-.4)*2e-5,1e-5)
c      write(10,*)'Add:  nph is ka odep du us =',nph,is,ka,odep,
c     1 sngl(du),sngl(us(nph))
      lp=lpower
      k=0
      do 56 l=ka,1,-1
      k=k+1
      ua(k,nph)=us(nph)-(l**lp)*du
      lp=lp-1
      taua(k,nph)=0d0
      j=1
      if(is.lt.2) go to 54
      do 55 i=2,is
      call tauint(ua(k,nph),pm(j,nph),pm(i,nph),zm(j,nph),zm(i,nph),
     1 ttau,tx)
      taua(k,nph)=taua(k,nph)+ttau
 55   j=i
c      write(10,*)'l k ua taua',l,k,sngl(ua(k,nph)),sngl(taua(k,nph))
 54   if(dabs(zm(is,nph)-zs).le.dtol) go to 56
c   Unless the source is right on a sample slowness, one more partial
c   integral is needed.
      call tauint(ua(k,nph),pm(is,nph),us(nph),zm(is,nph),zs,ttau,tx)
      taua(k,nph)=taua(k,nph)+ttau
c      write(10,*)'l k ua taua',l,k,sngl(ua(k,nph)),sngl(taua(k,nph))
 56   continue
      go to 43
c
c   Construct tau for all branches.
c
 1    mu=mu+1
 43   j=1
c      write(10,*)'mu',mu
c      write(10,*)'killer loop:'
      do 20 i=1,nseg
      if(.not.segmsk(i)) go to 20
c      write(10,*)'i iidx nafl nph',i,iidx(i),nafl(i,1),nph
      if(iidx(i).gt.0.or.iabs(nafl(i,1)).ne.nph.or.(msrc(nph).le.0.and.
     1 nafl(i,1).gt.0)) go to 20
c
      iph=nafl(i,2)
      kph=nafl(i,3)
c   Handle up-going P and S.
      if(iph.le.0) iph=nph
      if(kph.le.0) kph=nph
      sgn=isign(1,nafl(i,1))
      i1=indx(i,1)
      i2=indx(i,2)
c      write(10,*)'i1 i2 sgn iph',i1,i2,sngl(sgn),iph
      m=1
      do 21 k=i1,i2
      if(pt(k).gt.umin) go to 22
 23   if(dabs(pt(k)-pu(m,nph)).le.dtol) go to 21
      m=m+1
      go to 23
 21   tau(1,k)=taut(k)+sgn*tauc(m)
      k=i2
c      write(10,*)'k m',k,m
      go to 24
  22  continue
c 22   write(10,*)'k m',k,m
      if(dabs(pt(k-1)-umin).le.dtol) k=k-1
      ki=ki+1
      kk(ki)=k
      pk(ki)=pt(k)
      pt(k)=umin
      fac=fcs(i,1)
c      write(10,*)'ki fac',ki,sngl(fac)
      tau(1,k)=fac*(tauus1(iph)+tauus2(iph)+tauus1(kph)+tauus2(kph))+
     1 sgn*tauus1(nph)
c      write(10,*)'&&&&& nph iph kph tauus1 tauus2 tau =',
c     1 nph,iph,kph,sngl(tauus1(1)),sngl(tauus1(2)),sngl(tauus2(1)),
c     2 sngl(tauus2(2)),sngl(tau(1,k))
 24   m=1
 26   if(jndx(j,1).ge.indx(i,1)) go to 25
      j=j+1
      go to 26
 25   jndx(j,2)=min0(jidx(j),k)
      if(jndx(j,1).lt.jndx(j,2)) go to 37
      jndx(j,2)=-1
      go to 20
  37  continue
c 37   write(10,*)'j jndx jidx',j,jndx(j,1),jndx(j,2),jidx(j),' ',
c     1 phcd(j)
      do 30 l=1,2
 28   if(dabs(pux(m,nph)-px(j,l)).le.dtol) go to 27
      if(m.ge.mu) go to 29
      m=m+1
      go to 28
 27   xbrn(j,l)=xt(j,l)+sgn*xc(m)
c      write(10,*)'x up:  j l m  ',j,l,m
      go to 30
 29   xbrn(j,l)=fac*(xus1(iph)+xus2(iph)+xus1(kph)+xus2(kph))+
     1 sgn*xus1(nph)
c      write(10,*)'x up:  j l end',j,l
c      write(10,*)'&&&&& nph iph kph xus1 xus2 xbrn =',
c     1 nph,iph,kph,sngl(xus1(1)),sngl(xus1(2)),sngl(xus2(1)),
c     2 sngl(xus2(2)),sngl(xbrn(j,l))
 30   continue
      if(j.ge.nbrn) go to 20
      j=j+1
      if(jndx(j,1).le.k) go to 25
 20   continue
      return
      end

      subroutine depset(dep,usrc)
      save 
      include 'ttlim.inc'
      logical dop,dos,segmsk,prnt
      character*8 phcd
      real usrc(2)
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      common/prtflc/segmsk(jseg),prnt(2)
      data segmsk,prnt/jseg*.true.,2*.false./
c
      if(amax1(dep,.011).ne.odep) go to 1
      dop=.false.
      dos=.false.
      do 2 i=1,nseg
      if(.not.segmsk(i).or.iidx(i).gt.0) go to 2
      if(iabs(nafl(i,1)).le.1) dop=.true.
      if(iabs(nafl(i,1)).ge.2) dos=.true.
 2    continue
      if(.not.dop.and..not.dos) return
      go to 3
c
 1    nph0=0
      int0(1)=0
      int0(2)=0
      mbr1=nbrn+1
      mbr2=0
      dop=.false.
      dos=.false.
      do 4 i=1,nseg
      if(.not.segmsk(i)) go to 4
      if(iabs(nafl(i,1)).le.1) dop=.true.
      if(iabs(nafl(i,1)).ge.2) dos=.true.
 4    continue
      do 5 i=1,nseg
      if(nafl(i,2).gt.0.or.odep.lt.0.) go to 5
      ind=nafl(i,1)
      k=0
      do 15 j=indx(i,1),indx(i,2)
      k=k+1
 15   pt(j)=tp(k,ind)
 5    iidx(i)=-1
      do 6 i=1,nbrn
 6    jndx(i,2)=-1
      if(ki.le.0) go to 7
      do 8 i=1,ki
      j=kk(i)
 8    pt(j)=pk(i)
      ki=0
c   Sample the model at the source depth.
 7    odep=amax1(dep,.011)
      rdep=dep
      if(rdep.lt..011) rdep=0.
      zs=amin1(alog(amax1(1.-rdep*xn,1e-30)),0.)
      hn=1./(pn*(1.-rdep*xn))
c      if(prnt(1).or.prnt(2)) write(10,100)dep
 100  format(/1x,'Depth =',f7.2/)
c
 3    if(nph0.gt.1) go to 12
      if(dop) call depcor(1)
      if(dos) call depcor(2)
      go to 14
 12   if(dos) call depcor(2)
      if(dop) call depcor(1)
c
c   Interpolate all tau branches.
c
 14   j=1
      do 9 i=1,nseg
      if(.not.segmsk(i)) go to 9
      nph=iabs(nafl(i,1))
c      write(10,*)'i iidx nph msrc nafl =',i,iidx(i),nph,msrc(nph),
c     &nafl(i,1)
      if(iidx(i).gt.0.or.(msrc(nph).le.0.and.nafl(i,1).gt.0)) go to 9
      iidx(i)=1
      if(nafl(i,2).le.0) int=nafl(i,1)
      if(nafl(i,2).gt.0.and.nafl(i,2).eq.iabs(nafl(i,1)))
     1  int=nafl(i,2)+2
      if(nafl(i,2).gt.0.and.nafl(i,2).ne.iabs(nafl(i,1)))
     1  int=iabs(nafl(i,1))+4
      if(nafl(i,2).gt.0.and.nafl(i,2).ne.nafl(i,3)) int=nafl(i,2)+6
 11   if(jndx(j,1).ge.indx(i,1)) go to 10
      j=j+1
      go to 11
 10   idel(j,3)=nafl(i,1)
c      write(10,*)'spfit:  j int =',j,int 
      call spfit(j,int)
      mbr1=min0(mbr1,j)
      mbr2=max0(mbr2,j)

      if(j.ge.nbrn) go to 9

      j=j+1
c      write(10,*)'j jidx indx jndx =',j,jidx(j),indx(i,2),jndx(j,2)
      if(jidx(j).le.indx(i,2).and.jndx(j,2).gt.0) go to 10
 9    continue
c      write(10,*)'mbr1 mbr2',mbr1,mbr2
c      write(10,*)'msrc isrc odep zs us',msrc,isrc,odep,sngl(zs),
c     1 sngl(us(1)),sngl(us(2))
c      write(10,200)ki,(i,iidx(i),kk(i),pk(i),i=1,nseg)
c 200  format(/10x,i5/(1x,3i5,f12.6))
      usrc(1)=us(1)/pn
      usrc(2)=us(2)/pn
      return
      end

      subroutine findtt(jb,x0,max,n,tt,dtdd,dtdh,dddp,phnm)
      save
      include 'ttlim.inc'
      character*8 phnm(max)
      character*8 phcd
      character*80 msg
      dimension tt(max),dtdd(max),dtdh(max),dddp(max)
      double precision us,pt,tau,xlim,xbrn,dbrn
      double precision x,x0(3),p0,p1,arg,dp,dps,delp,tol,ps,deps
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/pcdc/phcd(jbrn)
      data tol/3d-6/,deps/1d-10/
c
      nph=iabs(idel(jb,3))
      hsgn=isign(1,idel(jb,3))*hn
      dsgn=(-1.)**idel(jb,1)*dn
      dpn=-1./tn
      do 10 ij=idel(jb,1),idel(jb,2)
      x=x0(ij)
      dsgn=-dsgn
      if(x.lt.xbrn(jb,1).or.x.gt.xbrn(jb,2)) go to 12
      j=jndx(jb,1)
      is=j+1
      ie=jndx(jb,2)
      do 1 i=is,ie
      if(x.le.xlim(1,j).or.x.gt.xlim(2,j)) go to 8
      le=n
      p0=pt(ie)-pt(j)
      p1=pt(ie)-pt(i)
      delp=dmax1(tol*(pt(i)-pt(j)),1d-3)
      if(dabs(tau(3,j)).gt.1d-30) go to 2
      dps=(x-tau(2,j))/(1.5d0*tau(4,j))
      dp=dsign(dps*dps,dps)
      dp0=dp
      if(dp.lt.p1-delp.or.dp.gt.p0+delp) go to 9
      if(n.ge.max) go to 13
      n=n+1
      ps=pt(ie)-dp
      tt(n)=tn*(tau(1,j)+dp*(tau(2,j)+dps*tau(4,j))+ps*x)
      dtdd(n)=dsgn*ps
      dtdh(n)=hsgn*sqrt(abs(sngl(us(nph)*us(nph)-ps*ps)))
      dddp(n)=dpn*.75d0*tau(4,j)/dmax1(dabs(dps),deps)
      phnm(n)=phcd(jb)
      in=index(phnm(n),'ab')
      if(in.le.0) go to 8
      if(ps.le.xbrn(jb,3)) phnm(n)(in:in+1)='bc'
      go to 8
 2    do 4 jj=1,2
      go to (5,6),jj
 5    arg=9d0*tau(4,j)*tau(4,j)+32d0*tau(3,j)*(x-tau(2,j))
      if(arg.ge.0d0) go to 3
      write(msg,100)arg
 100  format('Bad sqrt argument:',1pd11.2,'.')
      call warn(msg(1:30))
 3    dps=-(3d0*tau(4,j)+dsign(dsqrt(dabs(arg)),tau(4,j)))/(8d0*
     1 tau(3,j))
      dp=dsign(dps*dps,dps)
      dp0=dp
      go to 7
 6    dps=(tau(2,j)-x)/(2d0*tau(3,j)*dps)
      dp=dsign(dps*dps,dps)
 7    if(dp.lt.p1-delp.or.dp.gt.p0+delp) go to 4
      if(n.ge.max) go to 13
      n=n+1
      ps=pt(ie)-dp
      tt(n)=tn*(tau(1,j)+dp*(tau(2,j)+dp*tau(3,j)+dps*tau(4,j))+ps*x)
      dtdd(n)=dsgn*ps
      dtdh(n)=hsgn*sqrt(abs(sngl(us(nph)*us(nph)-ps*ps)))
      dddp(n)=dpn*(2d0*tau(3,j)+.75d0*tau(4,j)/dmax1(dabs(dps),deps))
      phnm(n)=phcd(jb)
      in=index(phnm(n),'ab')
      if(in.le.0) go to 4
      if(ps.le.xbrn(jb,3)) phnm(n)(in:in+1)='bc'
 4    continue
 9    if(n.gt.le) go to 8
      write(msg,101)phcd(jb),x,dp0,dp,p1,p0
 101  format('Failed to find phase:  ',a,f8.1,4f7.4)
      call warn(msg)
 8    j=i
 1    continue
c
 12   if(x.lt.dbrn(jb,1).or.x.gt.dbrn(jb,2)) go to 10
      if(n.ge.max) go to 13
      j=jndx(jb,1)
      i=jndx(jb,2)
      dp=pt(i)-pt(j)
      dps=dsqrt(dabs(dp))
      n=n+1
      tt(n)=tn*(tau(1,j)+dp*(tau(2,j)+dp*tau(3,j)+dps*tau(4,j))+
     1 pt(j)*x)
      dtdd(n)=dsgn*sngl(pt(j))
      dtdh(n)=hsgn*sqrt(abs(sngl(us(nph)*us(nph)-pt(j)*pt(j))))
      dddp(n)=dpn*(2d0*tau(3,j)+.75d0*tau(4,j)/dmax1(dps,deps))
      ln=index(phcd(jb),' ')-1
      if(ln.le.0) ln=len(phcd(jb))
c jul 2003      phnm(n)=phcd(jb)(1:ln)//'diff'
      phnm(n)=phcd(jb)(1:ln)//'dif'
 10   continue
      return
 13   write(msg,102)max
 102  format('More than',i3,' arrivals found.')
      call warn(msg(1:28))
      return
      end

      subroutine fitspl(i1,i2,tau,x1,xn,coef)
c
c $$$$$ calls only library routines $$$$$
c
c   Given ray parameter grid p;i (p sub i), i=1,2,...,n, corresponding
c   tau;i values, and x;1 and x;n (x;i = -dtau/dp|p;i); tauspl finds
c   interpolation I such that:  tau(p) = a;1,i + Dp * a;2,i + Dp**2 *
c   a;3,i + Dp**(3/2) * a;4,i where Dp = p;n - p and p;i <= p < p;i+1.
c   Interpolation I has the following properties:  1) x;1, x;n, and
c   tau;i, i=1,2,...,n are fit exactly, 2) the first and second
c   derivitives with respect to p are continuous everywhere, and
c   3) because of the paramaterization d**2 tau/dp**2|p;n is infinite.
c   Thus, interpolation I models the asymptotic behavior of tau(p)
c   when tau(p;n) is a branch end due to a discontinuity in the
c   velocity model.  Note that array a must be dimensioned at least
c   a(4,n) though the interpolation coefficients will be returned in
c   the first n-1 columns.  The remaining column is used as scratch
c   space and returned as all zeros.  Programmed on 16 August 1982 by
c   R. Buland.
c
      save
      include 'ttlim.inc'
      double precision tau(4,i2),x1,xn,a(2,100),ap(3),
     &b(100),alr,g1,gn,coef(5,i2)
c
      if(i2-i1)13,1,2
 1    tau(2,i1)=x1
 13   return
 2    n=0
      do 3 i=i1,i2
      n=n+1
      b(n)=tau(1,i)
      do 3 j=1,2
 3    a(j,n)=coef(j,i)
      do 4 j=1,3
 4    ap(j)=coef(j+2,i2)
      n1=n-1
c
c   Arrays ap(*,1), a, and ap(*,2) comprise n+2 x n+2 penta-diagonal
c   matrix A.  Let x1, tau, and xn comprise corresponding n+2 vector b.
c   Then, A * g = b, may be solved for n+2 vector g such that
c   interpolation I is given by I(p) = sum(i=0,n+1) g;i * G;i(p).
c
c   Eliminate the lower triangular portion of A to form A'.  A
c   corresponding transformation applied to vector b is stored in
c   a(4,*).
      alr=a(1,1)/coef(3,i1)
      a(1,1)=1d0-coef(4,i1)*alr
      a(2,1)=a(2,1)-coef(5,i1)*alr
      b(1)=b(1)-x1*alr
      j=1
      do 5 i=2,n
      alr=a(1,i)/a(1,j)
      a(1,i)=1d0-a(2,j)*alr
      b(i)=b(i)-b(j)*alr
 5    j=i
      alr=ap(1)/a(1,n1)
      ap(2)=ap(2)-a(2,n1)*alr
      gn=xn-b(n1)*alr
      alr=ap(2)/a(1,n)
c   Back solve the upper triangular portion of A' for coefficients g;i.
c   When finished, storage g(2), a(4,*), g(5) will comprise vector g.
      gn=(gn-b(n)*alr)/(ap(3)-a(2,n)*alr)
      b(n)=(b(n)-gn*a(2,n))/a(1,n)
      j=n
      do 6 i=n1,1,-1
      b(i)=(b(i)-b(j)*a(2,i))/a(1,i)
 6    j=i
      g1=(x1-coef(4,i1)*b(1)-coef(5,i1)*b(2))/coef(3,i1)
c
      tau(2,i1)=x1
      is=i1+1
      ie=i2-1
      j=1
      do 7 i=is,ie
      j=j+1
 7    tau(2,i)=coef(3,i)*b(j-1)+coef(4,i)*b(j)+coef(5,i)*b(j+1)
      tau(2,i2)=xn
      return
      end

      function iupcor(phnm,dtdd,xcor,tcor)
      save
      include 'ttlim.inc'
      character*8 phnm
      character*8 phcd
      double precision us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,xu,
     1 px,xt,taut,coef,tauc,xc,tcoef,tp
      double precision x,dp,dps,ps,cn
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      data oldep,jp,js/-1.,2*0/,cn/57.295779d0/
c
      iupcor=1
c     print *,'oldep odep',oldep,odep
      if(oldep.eq.odep) go to 1
      oldep=odep
c   Find the upgoing P branch.
c     print *,'mbr1 mbr2',mbr1,mbr2
      do 2 jp=mbr1,mbr2
c     print *,'jp phcd xbrn',jp,'  ',phcd(jp),xbrn(jp,1)
c changed BRL
      if((phcd(jp)(1:2).eq.'Pg'.or.phcd(jp)(1:2).eq.'Pb'.or.
     &phcd(jp)(1:2).eq.'Pn'.or.phcd(jp)(1:1).eq.'P').and.
     &xbrn(jp,1).le.0d0) go to 3

 2    continue
      jp=0
c   Find the upgoing S branch.
 3    do 4 js=mbr1,mbr2
c     print *,'js phcd xbrn',js,'  ',phcd(js),xbrn(js,1)
c changed BRL
      if((phcd(js)(1:2).eq.'Sg'.or.phcd(js)(1:2).eq.'Sb'.or.
     &phcd(js)(1:2).eq.'Sn'.or.phcd(js)(1:1).eq.'S').and.
     &xbrn(js,1).le.0d0) go to 1

 4    continue
      js=0
c
c1    print *,'jp js',jp,js
c changed BRL
 1    if(phnm(1:1).ne.'P'.and.phnm(1:1).ne.'p') go to 5

      jb=jp
      if(jb)14,14,6
c
c changed BRL
 5    if(phnm(1:1).ne.'S'.and.phnm(1:1).ne.'s') go to 13

      jb=js
      if(jb)14,14,6
c
 6    is=jndx(jb,1)+1
      ie=jndx(jb,2)
      ps=abs(dtdd)/dn
c     print *,'jb is ie dtdd dn ps',jb,is,ie,dtdd,dn,ps
      if(ps.lt.pt(is-1).or.ps.gt.pt(ie)) go to 13
      do 7 i=is,ie
c     print *,'i pt',i,pt(i)
      if(ps.le.pt(i)) go to 8
 7    continue
      go to 13
c
 8    j=i-1
      dp=pt(ie)-ps
      dps=dsqrt(dabs(dp))
      x=tau(2,j)+2d0*dp*tau(3,j)+1.5d0*dps*tau(4,j)
c     print *,'j pt dp dps x',j,pt(ie),dp,dps,x
      tcor=tn*(tau(1,j)+dp*(tau(2,j)+dp*tau(3,j)+dps*tau(4,j))+ps*x)
      xcor=cn*x
c     print *,'iupcor xcor tcor',iupcor,xcor,tcor
      return
c
 13   iupcor=-1
 14   xcor=0.
      tcor=0.
c     print *,'iupcor xcor tcor',iupcor,xcor,tcor
      return
      end

      subroutine pdecu(i1,i2,x0,x1,xmin,int,length)
      save
      include 'ttlim.inc'
      double precision us,pt,tau,xlim,xbrn,dbrn,ua,taua
      double precision x0,x1,xmin,dx,dx2,sgn,rnd,xm,axm,x,h1,h2,hh,xs
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/pdec/ua(5,2),taua(5,2),deplim,ka
c
c      write(10,*)'Pdecu:  ua =',sngl(ua(1,int))
      if(ua(1,int).le.0d0) go to 17
c      write(10,*)'Pdecu:  fill in new grid'
      k=i1+1
      do 18 i=1,ka
      pt(k)=ua(i,int)
      tau(1,k)=taua(i,int)
 18   k=k+1
      pt(k)=pt(i2)
      tau(1,k)=tau(1,i2)
      go to 19
c
 17   is=i1+1
      ie=i2-1
      xs=x1
      do 11 i=ie,i1,-1
      x=xs
      if(i.ne.i1) go to 12
      xs=x0
      go to 14
 12   h1=pt(i-1)-pt(i)
      h2=pt(i+1)-pt(i)
      hh=h1*h2*(h1-h2)
      h1=h1*h1
      h2=-h2*h2
      xs=-(h2*tau(1,i-1)-(h2+h1)*tau(1,i)+h1*tau(1,i+1))/hh
 14   if(dabs(x-xs).le.xmin) go to 15
 11   continue
c      length=i2
      return
 15   ie=i
      if(dabs(x-xs).gt..75d0*xmin.or.ie.eq.i2) go to 16
      xs=x
      ie=ie+1
 16   n=max0(idint(dabs(xs-x0)/xmin+.8d0),1)
      dx=(xs-x0)/n
      dx2=dabs(.5d0*dx)
      sgn=dsign(1d0,dx)
      rnd=0d0
      if(sgn.gt.0d0) rnd=1d0
      xm=x0+dx
      k=i1
      m=is
      axm=1d10
      do 1 i=is,ie
      if(i.lt.ie) go to 8
      x=xs
      go to 5
 8    h1=pt(i-1)-pt(i)
      h2=pt(i+1)-pt(i)
      hh=h1*h2*(h1-h2)
      h1=h1*h1
      h2=-h2*h2
      x=-(h2*tau(1,i-1)-(h2+h1)*tau(1,i)+h1*tau(1,i+1))/hh
 5    if(sgn*(x-xm).le.dx2) go to 2
      if(k.lt.m) go to 3
      do 4 j=m,k
 4    pt(j)=-1d0
 3    m=k+2
      k=i-1
      axm=1d10
 7    xm=xm+dx*idint((x-xm-dx2)/dx+rnd)
 2    if(dabs(x-xm).ge.axm) go to 1
      axm=dabs(x-xm)
      k=i-1
 1    continue
      if(k.lt.m) go to 9
      do 6 j=m,k
 6    pt(j)=-1d0
 9    k=i1
      do 10 i=is,i2
      if(pt(i).lt.0d0) go to 10
      k=k+1
      pt(k)=pt(i)
      tau(1,k)=tau(1,i)
 10   continue
 19   length=k
c      write(10,300)(i,pt(i),tau(1,i),i=i1,length)
c 300  format(/(1x,i5,0pf12.6,1pd15.4))
      return
      end

      subroutine query(ia,log)
c
c $$$$$ calls tnoua $$$$$
c
c   Subroutine query scans character string ia (up to 78 characters) for
c   a question mark or a colon.  It prints the string up to and
c   including the flag character plus two blanks with no newline on the
c   standard output.  If the flag was a question mark, query reads the
c   users response.  If the response is 'y' or 'yes', log is set to
c   true.  If the response is 'n' or 'no', log is set to false.  Any
c   other response causes the question to be repeated.  If the flag was
c   a colon, query simply returns allowing user input on the same line.
c   If there is no question mark or colon, the last non-blank character
c   is treated as if it were a colon.  If the string is null or all
c   blank, query prints an astrisk and returns.  Programmed on 3
c   December 1979 by R. Buland.
c
c last character of string MUST be a blank (BRL)

      save
      logical log
      character*80 ia
      character*80 ib
      character*4 ans
      nn=len(ia)
      log=.true.
      ifl=1
      k=0
c   Scan ia for flag characters or end-of-string.
      do 1 i=1,nn
       ib(i:i)=ia(i:i)
       if(ib(i:i).eq.':') go to 7
       if(ib(i:i).eq.'?') go to 3
       if(ib(i:i).eq.'\0') go to 5
       if(ib(i:i).ne.' ') k=i
 1    continue
c   If we fell off the end of the string, branch if there were any non-
c   blank characters.
 5    if(k.gt.0) go to 6
c   Handle a null or all blank string.
      i=1
      ib(i:i)='*'
      go to 4
c   Handle a string with no question mark or colon but at least one
c   non-blank character.
 6    i=k
c   Append two blanks and print the string.
 7    i=i+2
      ib(i-1:i-1)=' '
      ib(i:i)=' '
c   Tnoua prints the first i characters of ib without a newline.
 4    call tnoua(ib(1:i)//char(0))
      if(ifl.gt.0) return
c   If the string was a yes-no question read the response.
      read 102,ans
 102  format(a4)
      call uctolc(4,ans,-1)
c   If the response is yes log is already set properly.
      if(ans.eq.'y   '.or.ans.eq.'yes ') return
c   If the response is no set log to false.  Otherwise repeat the
c   question.
      if(ans.ne.'n   '.and.ans.ne.'no  ') go to 4
      log=.false.
      return
 3    ifl=-ifl
      go to 7
      end

      subroutine r4sort(n,rkey,iptr)
c
c $$$$$ calls no other routine $$$$$
c
c   R4sort sorts the n elements of array rkey so that rkey(i),
c   i = 1, 2, 3, ..., n are in asending order.  R4sort is a trivial
c   modification of ACM algorithm 347:  "An efficient algorithm for
c   sorting with minimal storage" by R. C. Singleton.  Array rkey is
c   sorted in place in order n*alog2(n) operations.  Coded on
c   8 March 1979 by R. Buland.  Modified to handle real*4 data on
c   27 September 1983 by R. Buland.
c
      save
      dimension rkey(n),iptr(n),il(10),iu(10)
c   Note:  il and iu implement a stack containing the upper and
c   lower limits of subsequences to be sorted independently.  A
c   depth of k allows for n<=2**(k+1)-1.
      if(n.le.0) return
      do 1 i=1,n
 1    iptr(i)=i
      if(n.le.1) return
      r=.375
      m=1
      i=1
      j=n
c
c   The first section interchanges low element i, middle element ij,
c   and high element j so they are in order.
c
 5    if(i.ge.j) go to 70
 10   k=i
c   Use a floating point modification, r, of Singleton's bisection
c   strategy (suggested by R. Peto in his verification of the
c   algorithm for the ACM).
      if(r.gt..58984375) go to 11
      r=r+.0390625
      go to 12
 11   r=r-.21875
 12   ij=i+(j-i)*r
      if(rkey(iptr(i)).le.rkey(iptr(ij))) go to 20
      it=iptr(ij)
      iptr(ij)=iptr(i)
      iptr(i)=it
 20   l=j
      if(rkey(iptr(j)).ge.rkey(iptr(ij))) go to 39
      it=iptr(ij)
      iptr(ij)=iptr(j)
      iptr(j)=it
      if(rkey(iptr(i)).le.rkey(iptr(ij))) go to 39
      it=iptr(ij)
      iptr(ij)=iptr(i)
      iptr(i)=it
 39   tmpkey=rkey(iptr(ij))
      go to 40
c
c   The second section continues this process.  K counts up from i and
c   l down from j.  Each time the k element is bigger than the ij
c   and the l element is less than the ij, then interchange the
c   k and l elements.  This continues until k and l meet.
c
 30   it=iptr(l)
      iptr(l)=iptr(k)
      iptr(k)=it
 40   l=l-1
      if(rkey(iptr(l)).gt.tmpkey) go to 40
 50   k=k+1
      if(rkey(iptr(k)).lt.tmpkey) go to 50
      if(k.le.l) go to 30
c
c   The third section considers the intervals i to l and k to j.  The
c   larger interval is saved on the stack (il and iu) and the smaller
c   is remapped into i and j for another shot at section one.
c
      if(l-i.le.j-k) go to 60
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 80
 60   il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 80
c
c   The fourth section pops elements off the stack (into i and j).  If
c   necessary control is transfered back to section one for more
c   interchange sorting.  If not we fall through to section five.  Note
c   that the algorighm exits when the stack is empty.
c
 70   m=m-1
      if(m.eq.0) return
      i=il(m)
      j=iu(m)
 80   if(j-i.ge.11) go to 10
      if(i.eq.1) go to 5
      i=i-1
c
c   The fifth section is the end game.  Final sorting is accomplished
c   (within each subsequence popped off the stack) by rippling out
c   of order elements down to their proper positions.
c
 90   i=i+1
      if(i.eq.j) go to 70
      if(rkey(iptr(i)).le.rkey(iptr(i+1))) go to 90
      k=i
      kk=k+1
      ib=iptr(kk)
 100  iptr(kk)=iptr(k)
      kk=k
      k=k-1
      if(rkey(ib).lt.rkey(iptr(k))) go to 100
      iptr(kk)=ib
      go to 90
      end

      subroutine retrns(lu)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine retrns closes (disconnects) logical unit lu from the
c   calling program.  Programmed on 3 December 1979 by R. Buland.
c
      save
      close(unit=lu)
      return
      end

      subroutine spfit(jb,int)
      save
      include 'ttlim.inc'
      character*3 disc
      character*8 phcd
      character*80 fnam
      logical newgrd,makgrd,segmsk,prnt
c     logical log
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp
      double precision pmn,dmn,dmx,hm,shm,thm,p0,p1,tau0,tau1,x0,x1,pe,
     1 pe0,spe0,scpe0,pe1,spe1,scpe1,dpe,dtau,dbrnch,cn,x180,x360,dtol,
     2 ptol,xmin
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      common/prtflc/segmsk(jseg),prnt(2)
      data dbrnch,cn,x180,x360,xmin,dtol,ptol/2.5307274d0,57.295779d0,
     1 3.1415927d0,6.2831853d0,3.92403d-3,1d-6,2d-6/
c
      if(prnt(1)) write(10,102)
      i1=jndx(jb,1)
      i2=jndx(jb,2)
c      write(10,*)'Spfit:  jb i1 i2 pt =',jb,i1,i2,sngl(pt(i1)),
c     1 sngl(pt(i2))
      if(i2-i1.gt.1.or.dabs(pt(i2)-pt(i1)).gt.ptol) go to 14
      jndx(jb,2)=-1
      return
 14   newgrd=.false.
      makgrd=.false.
      if(dabs(px(jb,2)-pt(i2)).gt.dtol) newgrd=.true.
c      write(10,*)'Spfit:  px newgrd =',sngl(px(jb,2)),newgrd
      if(.not.newgrd) go to 10
      k=mod(int-1,2)+1
      if(int.ne.int0(k)) makgrd=.true.
c      write(10,*)'Spfit:  int k int0 makgrd =',int,k,int0(k),makgrd
      if(int.gt.2) go to 12
c      call query('Enter xmin: ',log)
c     read *,xmin
c     xmin=xmin*xn
      xmin=xn*amin1(amax1(2.*odep,2.),25.)
c      write(10,*)'Spfit:  xmin =',xmin,xmin/xn
      call pdecu(i1,i2,xbrn(jb,1),xbrn(jb,2),xmin,int,i2)
      jndx(jb,2)=i2
 12   nn=i2-i1+1
      if(makgrd) call tauspl(1,nn,pt(i1),tcoef(1,1,k))
c      write(10,301,iostat=ios)jb,k,nn,int,newgrd,makgrd,
c     1 xbrn(jb,1),xbrn(jb,2),(i,pt(i-1+i1),tau(1,i-1+i1),
c     2 (tcoef(j,i,k),j=1,5),i=1,nn)
c 301  format(/1x,4i3,2l3,2f12.8/(1x,i5,0p2f12.8,1p5d10.2))
      call fitspl(1,nn,tau(1,i1),xbrn(jb,1),xbrn(jb,2),tcoef(1,1,k))
      int0(k)=int
      go to 11
 10   continue
c      write(10,*)'xbrn ',jb,xbrn(jb,1),xbrn(jb,2)
       call fitspl(i1,i2,tau,xbrn(jb,1),xbrn(jb,2),coef)
c       write(10,*)'i1,i2,tau ',i1,i2,tau(1,i1),tau(2,i1)
 11   pmn=pt(i1)
      dmn=xbrn(jb,1)
      dmx=dmn
      mxcnt=0
      mncnt=0
c     call appx(i1,i2,xbrn(jb,1),xbrn(jb,2))
c      write(10,300)(i,pt(i),(tau(j,i),j=1,3),i=i1,i2)
c 300  format(/(1x,i5,4f12.6))
      pe=pt(i2)
      p1=pt(i1)
      tau1=tau(1,i1)
      x1=tau(2,i1)
      pe1=pe-p1
      spe1=dsqrt(dabs(pe1))
      scpe1=pe1*spe1
      j=i1
      is=i1+1
      do 2 i=is,i2
      p0=p1
      p1=pt(i)
      tau0=tau1
      tau1=tau(1,i)
      x0=x1
      x1=tau(2,i)
      dpe=p0-p1
      dtau=tau1-tau0
      pe0=pe1
      pe1=pe-p1
      spe0=spe1
      spe1=dsqrt(dabs(pe1))
      scpe0=scpe1
      scpe1=pe1*spe1
      tau(4,j)=(2d0*dtau-dpe*(x1+x0))/(.5d0*(scpe1-scpe0)-1.5d0*spe1*
     1 spe0*(spe1-spe0))
      tau(3,j)=(dtau-dpe*x0-(scpe1+.5d0*scpe0-1.5d0*pe1*spe0)*tau(4,j))/
     1 (dpe*dpe)
      tau(2,j)=(dtau-(pe1*pe1-pe0*pe0)*tau(3,j)-(scpe1-scpe0)*tau(4,j))/
     1 dpe
      tau(1,j)=tau0-scpe0*tau(4,j)-pe0*(pe0*tau(3,j)+tau(2,j))
      xlim(1,j)=dmin1(x0,x1)
      xlim(2,j)=dmax1(x0,x1)
      if(xlim(1,j).ge.dmn) go to 5
      dmn=xlim(1,j)
      pmn=pt(j)
      if(x1.lt.x0) pmn=pt(i)
 5    disc=' '
      if(dabs(tau(3,j)).le.1d-30) go to 4
      shm=-.375d0*tau(4,j)/tau(3,j)
      hm=shm*shm
      if(shm.le.0d0.or.(hm.le.pe1.or.hm.ge.pe0)) go to 4
 7    thm=tau(2,j)+shm*(2d0*shm*tau(3,j)+1.5d0*tau(4,j))
      xlim(1,j)=dmin1(xlim(1,j),thm)
      xlim(2,j)=dmax1(xlim(2,j),thm)
      if(thm.ge.dmn) go to 6
      dmn=thm
      pmn=pe-hm
 6    disc='max'
      if(tau(4,j).lt.0d0) disc='min'
      if(disc.eq.'max') mxcnt=mxcnt+1
      if(disc.eq.'min') mncnt=mncnt+1
 4    continue
c      if(prnt(1)) write(10,100,iostat=ios)disc,j,pt(j),
c      1 (tau(k,j),k=1,4),(cn*xlim(k,j),k=1,2)
c 100  format(1x,a,i5,f10.6,1p4e10.2,0p2f7.2)
      dmx=dmax1(dmx,xlim(2,j))
 2    j=i
c     if(prnt(1)) write(10,100,iostat=ios)'   ',j,pt(j)
      xbrn(jb,1)=dmn
      xbrn(jb,2)=dmx
      xbrn(jb,3)=pmn
      idel(jb,1)=1
      idel(jb,2)=1
      if(xbrn(jb,1).gt.x180) idel(jb,1)=2
      if(xbrn(jb,2).gt.x180) idel(jb,2)=2
      if(xbrn(jb,1).gt.x360) idel(jb,1)=3
      if(xbrn(jb,2).gt.x360) idel(jb,2)=3
      if(int.gt.2) go to 1
      phcd(jb)=phcd(jb)(1:1)
      i=jb
      do 8 j=1,nbrn
      i=mod(i,nbrn)+1
c changed BRL
      if(phcd(i)(1:1).eq.phcd(jb)(1:1).and.phcd(i)(2:2).ne.'P'
     &.and.(pe.ge.px(i,1).and.pe.le.px(i,2))) go to 9

 8    continue
      go to 1
 9    phcd(jb)=phcd(i)
      if(dabs(pt(i2)-pt(jndx(i,1))).le.dtol) phcd(jb)=phcd(i-1)
 1    if(prnt(1).and.prnt(2)) write(10,102)
 102  format()
      if(dbrn(jb,1).le.0d0) go to 3
      dbrn(jb,1)=dmx
      dbrn(jb,2)=dbrnch
      if(prnt(2)) write(10,101,iostat=ios)phcd(jb),
     1 (jndx(jb,k),k=1,2),(cn*xbrn(jb,k),k=1,2),xbrn(jb,3),
     2 (cn*dbrn(jb,k),k=1,2),(idel(jb,k),k=1,3),int,newgrd,makgrd
 101  format(1x,a,2i5,2f8.2,f8.4,2f8.2,4i3,2l2)
      go to 15
 3    if(prnt(2)) write(10,103,iostat=ios)phcd(jb),
     1 (jndx(jb,k),k=1,2),(cn*xbrn(jb,k),k=1,2),xbrn(jb,3),
     2 (idel(jb,k),k=1,3),int,newgrd,makgrd
 103  format(1x,a,2i5,2f8.2,f8.4,16x,4i3,2l2)
 15   if(mxcnt.gt.mncnt.or.mncnt.gt.mxcnt+1)then
      fnam='Bad interpolation on '//phcd(jb)//char(0)
         call warn(fnam)
         write(*,*)mxcnt,mncnt
      endif
      return
      end

      subroutine tabin(inunit,modnam)
      save
      include 'ttlim.inc'
      character*80 modnam
      character*80 fnam
c     logical log
      character*8 phcd,phdif(6)
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn,zs,pk,pu,pux,tauu,
     1 xu,px,xt,taut,coef,tauc,xc,tcoef,tp,ccc(5)
c
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      common/brkc/zs,pk(jseg),pu(jtsm0,2),pux(jxsm,2),tauu(jtsm,2),
     1 xu(jxsm,2),px(jbrn,2),xt(jbrn,2),taut(jout),coef(5,jout),
     2 tauc(jtsm),xc(jxsm),tcoef(5,jbrna,2),tp(jbrnu,2),odep,
     3 fcs(jseg,3),nin,nph0,int0(2),ki,msrc(2),isrc(2),nseg,nbrn,ku(2),
     4 km(2),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),iidx(jseg),
     5 jidx(jbrn),kk(jseg)
      common/pcdc/phcd(jbrn)
      data tauc,xc/jtsm*0d0,jxsm*0d0/
c
      nin=inunit
      phdif(1)='P'
      phdif(2)='S'
      phdif(3)='pP'
      phdif(4)='sP'
      phdif(5)='pS'
      phdif(6)='sS'
c++
c      call asnag1(nin,-1,1,'Enter model name:',modnam)
c++
       nb=index(modnam,' ')-1
       fnam=modnam(1:nb)//'.HED'//char(0)
       call assign(nin,-1,fnam)

c split up this read to isolate a weird problem in MS Fortran 5.1
c (see below)
      read(nin) nasgr,nl,len2,xn,pn,tn,mt,nseg,nbrn,ku,km,fcs
      do i=1,jseg
        read(nin)(nafl(i,j),j=1,3)
        read(nin)(indx(i,j),j=1,2)
        read(nin)(kndx(i,j),j=1,2)
      enddo
      do i=1,nsr0
        read(nin)(pm(i,j),j=1,2)
        read(nin)(zm(i,j),j=1,2)
      end do
      do i=1,nsr0
        read(nin)(ndex(i,j),j=1,2)
      end do
      do i=1,nsl1
        read(nin)(pu(i,j),j=1,2)
      end do
      do i=1,jbrn
        read(nin)(pux(i,j),j=1,2)
      end do
      read(nin) phcd
      do i=1,jbrn
        read(nin)(px(i,j),j=1,2)
        read(nin)(xt(i,j),j=1,2)
        read(nin)(jndx(i,j),j=1,2)
      end do
      read(nin) pt,taut
      do i=1,jout

c this patch gets around a bug in MS Fortran 5.1, running under
c Windows, which causes an unformatted read of an array > 64Kb to
c set some of the values to zero 
       read(nin)(ccc(j),j=1,5)
       do j=1,5
         coef(j,i)=ccc(j)
       end do

      end do

      call retrns(nin)
c
      fnam=modnam(1:nb)//'.TBL'
      call dasign(nin,-1,fnam,nasgr)
c      call dasign(nin,-1,modnam(1:nb),nasgr)
c
      do 11 nph=1,2
 11   pu(ku(nph)+1,nph)=pm(1,nph)
c
c      write(10,*)'nasgr nl len2',nasgr,nl,len2
c      write(10,*)'nseg nbrn mt ku km',nseg,nbrn,mt,ku,km
c      write(10,*)'xn pn tn',xn,pn,tn
c      write(10,200)(i,(ndex(i,j),pm(i,j),zm(i,j),j=1,2),i=1,mt(2))
c 200  format(/(1x,i3,i7,2f12.6,i7,2f12.6))
c      write(10,201)(i,(pu(i,j),j=1,2),i=1,ku(2)+1)
c 201  format(/(1x,i3,2f12.6))
c      write(10,201)(i,(pux(i,j),j=1,2),i=1,km(2))
c      write(10,202)(i,(nafl(i,j),j=1,3),(indx(i,j),j=1,2),(kndx(i,j),
c     1 j=1,2),(fcs(i,j),j=1,3),i=1,nseg)
c 202  format(/(1x,i3,7i5,3f5.0))
      cn=180./3.1415927
c      write(10,203)(i,(jndx(i,j),j=1,2),(px(i,j),j=1,2),(cn*xt(i,j),
c     1 j=1,2),phcd(i),i=1,nbrn)
c 203  format(/(1x,i3,2i5,2f12.6,2f12.2,2x,a))
c       write(10,204)(i,pt(i),taut(i),(coef(j,i),j=1,5),i=1,jout)
c  204  format(/(1x,i5,0p2f12.6,1p5d10.2))
c
      tn=1./tn
      dn=3.1415927/(180.*pn*xn)
      odep=-1.
      ki=0
      msrc(1)=0
      msrc(2)=0
      k=1
      do 3 i=1,nbrn
      jidx(i)=jndx(i,2)
      do 4 j=1,2
 4    dbrn(i,j)=-1d0
 8    if(jndx(i,2).le.indx(k,2)) go to 7
      k=k+1
      go to 8
 7    if(nafl(k,2).gt.0) go to 9
      ind=nafl(k,1)
      l=0
      do 10 j=jndx(i,1),jndx(i,2)
      l=l+1
 10   tp(l,ind)=pt(j)
 9    if(nafl(k,1).gt.0.and.(phcd(i)(1:1).eq.'P'.or.
     1 phcd(i)(1:1).eq.'S')) go to 3
      do 5 j=1,6
      if(phcd(i).eq.phdif(j)) go to 6
 5    continue
      go to 3
 6    dbrn(i,1)=1d0
      phdif(j)=' '
 3    continue
c      write(10,205)(i,phcd(i),(dbrn(i,j),j=1,2),jidx(i),i=1,nbrn)
 205  format(/(1x,i5,2x,a,2f8.2,i5))
c      write(10,206)(i,(tp(i,j),j=1,2),i=1,jbrnu)
c 206  format(/(1x,i5,2f12.6))
      return
      end

      subroutine tauint(ptk,ptj,pti,zj,zi,tau,x)
      save
c
c $$$$$ calls warn $$$$$
c
c   Tauint evaluates the intercept (tau) and distance (x) integrals  for
c   the spherical earth assuming that slowness is linear between radii
c   for which the model is known.  The partial integrals are performed
c   for ray slowness ptk between model radii with slownesses ptj and pti
c   with equivalent flat earth depths zj and zi respectively.  The partial
c   integrals are returned in tau and x.  Note that ptk, ptj, pti, zj, zi,
c   tau, and x are all double precision.
c
      character*80 msg
      double precision ptk,ptj,pti,zj,zi,tau,x
      double precision xx,b,sqk,sqi,sqj,sqb
c
      if(dabs(zj-zi).le.1d-9) go to 13
      if(dabs(ptj-pti).gt.1d-9) go to 10
      if(dabs(ptk-pti).le.1d-9) go to 13
      b=dabs(zj-zi)
      sqj=dsqrt(dabs(ptj*ptj-ptk*ptk))
      tau=b*sqj
      x=b*ptk/sqj
      go to 4
 10   if(ptk.gt.1d-9.or.pti.gt.1d-9) go to 1
c   Handle the straight through ray.
      tau=ptj
      x=1.5707963267948966d0
      go to 4
 1    b=ptj-(pti-ptj)/(dexp(zi-zj)-1d0)
      if(ptk.gt.1d-9) go to 2
      tau=-(pti-ptj+b*dlog(pti/ptj)-b*dlog(dmax1((ptj-b)*pti/
     1 ((pti-b)*ptj),1d-30)))
      x=0d0
      go to 4
 2    if(ptk.eq.pti) go to 3
      if(ptk.eq.ptj) go to 11
      sqk=ptk*ptk
      sqi=dsqrt(dabs(pti*pti-sqk))
      sqj=dsqrt(dabs(ptj*ptj-sqk))
      sqb=dsqrt(dabs(b*b-sqk))
      if(sqb.gt.1d-30) go to 5
      xx=0d0
      x=ptk*(dsqrt(dabs((pti+b)/(pti-b)))-dsqrt(dabs((ptj+b)/
     1 (ptj-b))))/b
      go to 6
 5    if(b*b.lt.sqk) go to 7
      xx=dlog(dmax1((ptj-b)*(sqb*sqi+b*pti-sqk)/((pti-b)*
     1 (sqb*sqj+b*ptj-sqk)),1d-30))
      x=ptk*xx/sqb
      go to 6
 7    xx=dasin(dmax1(dmin1((b*pti-sqk)/(ptk*dabs(pti-b)),1d0),-1d0))-
     1 dasin(dmax1(dmin1((b*ptj-sqk)/(ptk*dabs(ptj-b)),1d0),-1d0))
      x=-ptk*xx/sqb
 6    tau=-(sqi-sqj+b*dlog((pti+sqi)/(ptj+sqj))-sqb*xx)
      go to 4
 3    sqk=pti*pti
      sqj=dsqrt(dabs(ptj*ptj-sqk))
      sqb=dsqrt(dabs(b*b-sqk))
      if(b*b.lt.sqk) go to 8
      xx=dlog(dmax1((ptj-b)*(b*pti-sqk)/((pti-b)*(sqb*sqj+b*ptj-sqk)),
     1 1d-30))
      x=pti*xx/sqb
      go to 9
 8    xx=dsign(1.5707963267948966d0,b-pti)-dasin(dmax1(dmin1((b*ptj-
     1 sqk)/(pti*dabs(ptj-b)),1d0),-1d0))
      x=-pti*xx/sqb
 9    tau=-(b*dlog(pti/(ptj+sqj))-sqj-sqb*xx)
      go to 4
 11   sqk=ptj*ptj
      sqi=dsqrt(dabs(pti*pti-sqk))
      sqb=dsqrt(dabs(b*b-sqk))
      if(b*b.lt.sqk) go to 12
      xx=dlog(dmax1((ptj-b)*(sqb*sqi+b*pti-sqk)/((pti-b)*(b*ptj-sqk)),
     1 1d-30))
      x=ptj*xx/sqb
      go to 14
 12   xx=dasin(dmax1(dmin1((b*pti-sqk)/(ptj*dabs(pti-b)),1d0),-1d0))-
     1 dsign(1.5707963267948966d0,b-ptj)
      x=-ptj*xx/sqb
 14   tau=-(b*dlog((pti+sqi)/ptj)+sqi-sqb*xx)
c
c   Handle various error conditions.
c
 4    if(x.ge.-1d-10) go to 15
      write(msg,100)ptk,ptj,pti,tau,x
 100  format('Bad range: ',1p5d12.4)
      call warn(msg)
 15   if(tau.ge.-1d-10) go to 16
      write(msg,101)ptk,ptj,pti,tau,x
 101  format('Bad tau: ',1p5d12.4)
      call warn(msg(1:69))
 16   return
c   Trap null integrals and handle them properly.
 13   tau=0d0
      x=0d0
      return
      end

      subroutine tauspl(i1,i2,pt,coef)
c
c $$$$$ calls only library routines $$$$$
c
c   Given ray parameter grid pt;i (pt sub i), i=i1,i1+1,...,i2, tauspl
c   determines the i2-i1+3 basis functions for interpolation I such
c   that:
c
c      tau(p) = a;1,i + Dp * a;2,i + Dp**2 * a;3,i + Dp**(3/2) * a;4,i
c
c   where Dp = pt;n - p, pt;i <= p < pt;i+1, and the a;j,i's are
c   interpolation coefficients.  Rather than returning the coefficients,
c   a;j,i, which necessarily depend on tau(pt;i), i=i1,i1+1,...,i2 and
c   x(pt;i) (= -d tau(p)/d p | pt;i), i=i1,i2, tauspl returns the
c   contribution of each basis function and its derivitive at each
c   sample.  Each basis function is non-zero at three grid points,
c   therefore, each grid point will have contributions (function values
c   and derivitives) from three basis functions.  Due to the basis
c   function normalization, one of the function values will always be
c   one and is not returned in array coef with the other values.
c   Rewritten on 23 December 1983 by R. Buland.
c
      save
      double precision pt(i2),coef(5,i2)
      double precision del(5),sdel(5),deli(5),d3h(4),d1h(4),dih(4),
     1 d(4),ali,alr,b3h,b1h,bih,th0p,th2p,th3p,th2m
c
      n2=i2-i1-1
      if(n2.le.-1) return
      is=i1+1
c
c   To achieve the requisite stability, proceed by constructing basis
c   functions G;i, i=0,1,...,n+1.  G;i will be non-zero only on the
c   interval [p;i-2,p;i+2] and will be continuous with continuous first
c   and second derivitives.  G;i(p;i-2) and G;i(p;i+2) are constrained
c   to be zero with zero first and second derivitives.  G;i(p;i) is
c   normalized to unity.
c
c   Set up temporary variables appropriate for G;-1.  Note that to get
c   started, the ray parameter grid is extrapolated to yeild p;i, i=-2,
c   -1,0,1,...,n.
      del(2)=pt(i2)-pt(i1)+3d0*(pt(is)-pt(i1))
      sdel(2)=dsqrt(dabs(del(2)))
      deli(2)=1d0/sdel(2)
      m=2
      do 1 k=3,5
      del(k)=pt(i2)-pt(i1)+(5-k)*(pt(is)-pt(i1))
      sdel(k)=dsqrt(dabs(del(k)))
      deli(k)=1d0/sdel(k)
      d3h(m)=del(k)*sdel(k)-del(m)*sdel(m)
      d1h(m)=sdel(k)-sdel(m)
      dih(m)=deli(k)-deli(m)
 1    m=k
      l=i1-1
      if(n2.le.0) go to 10
c   Loop over G;i, i=0,1,...,n-3.
      do 2 i=1,n2
      m=1
c   Update temporary variables for G;i-1.
      do 3 k=2,5
      del(m)=del(k)
      sdel(m)=sdel(k)
      deli(m)=deli(k)
      if(k.ge.5) go to 3
      d3h(m)=d3h(k)
      d1h(m)=d1h(k)
      dih(m)=dih(k)
 3    m=k
      l=l+1
      del(5)=pt(i2)-pt(l+1)
      sdel(5)=dsqrt(dabs(del(5)))
      deli(5)=1d0/sdel(5)
      d3h(4)=del(5)*sdel(5)-del(4)*sdel(4)
      d1h(4)=sdel(5)-sdel(4)
      dih(4)=deli(5)-deli(4)
c   Construct G;i-1.
      ali=1d0/(.125d0*d3h(1)-(.75d0*d1h(1)+.375d0*dih(1)*del(3))*
     1 del(3))
      alr=ali*(.125d0*del(2)*sdel(2)-(.75d0*sdel(2)+.375d0*del(3)*
     1 deli(2)-sdel(3))*del(3))
      b3h=d3h(2)+alr*d3h(1)
      b1h=d1h(2)+alr*d1h(1)
      bih=dih(2)+alr*dih(1)
      th0p=d1h(1)*b3h-d3h(1)*b1h
      th2p=d1h(3)*b3h-d3h(3)*b1h
      th3p=d1h(4)*b3h-d3h(4)*b1h
      th2m=dih(3)*b3h-d3h(3)*bih
c   The d;i's completely define G;i-1.
      d(4)=ali*((dih(1)*b3h-d3h(1)*bih)*th2p-th2m*th0p)/((dih(4)*b3h-
     1 d3h(4)*bih)*th2p-th2m*th3p)
      d(3)=(th0p*ali-th3p*d(4))/th2p
      d(2)=(d3h(1)*ali-d3h(3)*d(3)-d3h(4)*d(4))/b3h
      d(1)=alr*d(2)-ali
c   Construct the contributions G;i-1(p;i-2) and G;i-1(p;i).
c   G;i-1(p;i-1) need not be constructed as it is normalized to unity.
      coef(1,l)=(.125d0*del(5)*sdel(5)-(.75d0*sdel(5)+.375d0*deli(5)*
     1 del(4)-sdel(4))*del(4))*d(4)
      if(i.ge.3) coef(2,l-2)=(.125d0*del(1)*sdel(1)-(.75d0*sdel(1)+
     1 .375d0*deli(1)*del(2)-sdel(2))*del(2))*d(1)
c   Construct the contributions -dG;i-1(p)/dp | p;i-2, p;i-1, and p;i.
      coef(3,l)=-.75d0*(sdel(5)+deli(5)*del(4)-2d0*sdel(4))*d(4)
      if(i.ge.2) coef(4,l-1)=-.75d0*((sdel(2)+deli(2)*del(3)-
     1 2d0*sdel(3))*d(2)-(d1h(1)+dih(1)*del(3))*d(1))
      if(i.ge.3) coef(5,l-2)=-.75d0*(sdel(1)+deli(1)*del(2)-
     1 2d0*sdel(2))*d(1)
 2    continue
c   Loop over G;i, i=n-2,n-1,n,n+1.  These cases must be handled
c   seperately because of the singularities in the second derivitive
c   at p;n.
 10   do 4 j=1,4
      m=1
c   Update temporary variables for G;i-1.
      do 5 k=2,5
      del(m)=del(k)
      sdel(m)=sdel(k)
      deli(m)=deli(k)
      if(k.ge.5) go to 5
      d3h(m)=d3h(k)
      d1h(m)=d1h(k)
      dih(m)=dih(k)
 5    m=k
      l=l+1
      del(5)=0d0
      sdel(5)=0d0
      deli(5)=0d0
c   Construction of the d;i's is different for each case.  In cases
c   G;i, i=n-1,n,n+1, G;i is truncated at p;n to avoid patching across
c   the singularity in the second derivitive.
      if(j.lt.4) go to 6
c   For G;n+1 constrain G;n+1(p;n) to be .25.
      d(1)=2d0/(del(1)*sdel(1))
      go to 9
c   For G;i, i=n-2,n-1,n, the condition dG;i(p)/dp|p;i = 0 has been
c   substituted for the second derivitive continuity condition that
c   can no longer be satisfied.
 6    alr=(sdel(2)+deli(2)*del(3)-2d0*sdel(3))/(d1h(1)+dih(1)*del(3))
      d(2)=1d0/(.125d0*del(2)*sdel(2)-(.75d0*sdel(2)+.375d0*deli(2)*
     1 del(3)-sdel(3))*del(3)-(.125d0*d3h(1)-(.75d0*d1h(1)+.375d0*
     2 dih(1)*del(3))*del(3))*alr)
      d(1)=alr*d(2)
      if(j-2)8,7,9
c   For G;n-1 constrain G;n-1(p;n) to be .25.
 7    d(3)=(2d0+d3h(2)*d(2)+d3h(1)*d(1))/(del(3)*sdel(3))
      go to 9
c   No additional constraints are required for G;n-2.
 8    d(3)=-((d3h(2)-d1h(2)*del(4))*d(2)+(d3h(1)-d1h(1)*del(4))*
     1 d(1))/(d3h(3)-d1h(3)*del(4))
      d(4)=(d3h(3)*d(3)+d3h(2)*d(2)+d3h(1)*d(1))/(del(4)*sdel(4))
c   Construct the contributions G;i-1(p;i-2) and G;i-1(p;i).
 9    if(j.le.2) coef(1,l)=(.125d0*del(3)*sdel(3)-(.75d0*sdel(3)+.375d0*
     1 deli(3)*del(4)-sdel(4))*del(4))*d(3)-(.125d0*d3h(2)-(.75d0*
     2 d1h(2)+.375d0*dih(2)*del(4))*del(4))*d(2)-(.125d0*d3h(1)-(.75d0*
     3 d1h(1)+.375d0*dih(1)*del(4))*del(4))*d(1)
      if(l-i1.gt.1) coef(2,l-2)=(.125d0*del(1)*sdel(1)-(.75d0*sdel(1)+
     1 .375d0*deli(1)*del(2)-sdel(2))*del(2))*d(1)
c   Construct the contributions -dG;i-1(p)/dp | p;i-2, p;i-1, and p;i.
      if(j.le.2) coef(3,l)=-.75d0*((sdel(3)+deli(3)*del(4)-
     1 2d0*sdel(4))*d(3)-(d1h(2)+dih(2)*del(4))*d(2)-(d1h(1)+
     2 dih(1)*del(4))*d(1))
      if(j.le.3.and.l-i1.gt.0) coef(4,l-1)=0d0
      if(l-i1.gt.1) coef(5,l-2)=-.75d0*(sdel(1)+deli(1)*del(2)-
     1 2d0*sdel(2))*d(1)
 4    continue
      return
      end

      subroutine trtm(delta,max,n,tt,dtdd,dtdh,dddp,phnm)
      save
      include 'ttlim.inc'
      character*8 phnm(max)
      character*8 ctmp(100)
      dimension tt(max),dtdd(max),dtdh(max),dddp(max),tmp(100,4),
     1 iptr(100)
      double precision us,pt,tau,xlim,xbrn,dbrn
      double precision x(3),cn,dtol,pi,pi2
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      data cn,dtol,atol,pi,pi2/.017453292519943296d0,1d-6,.005,
     1 3.1415926535897932d0,6.2831853071795865d0/
c
      n=0
      if(mbr2.le.0) return
      x(1)=dmod(dabs(cn*delta),pi2)
      if(x(1).gt.pi) x(1)=pi2-x(1)
      x(2)=pi2-x(1)
      x(3)=x(1)+pi2
      if(dabs(x(1)).gt.dtol) go to 9
      x(1)=dtol
      x(3)=-10d0
 9    if(dabs(x(1)-pi).gt.dtol) go to 7
      x(1)=pi-dtol
      x(2)=-10d0
 7    do 1 j=mbr1,mbr2
 1    if(jndx(j,2).gt.0) call findtt(j,x,max,n,tmp,tmp(1,2),tmp(1,3),
     1 tmp(1,4),ctmp)
      if(n-1)3,4,5
 4    iptr(1)=1
      go to 6
 5    call r4sort(n,tmp,iptr)
 6    k=0
      do 2 i=1,n
      j=iptr(i)
      if(k.le.0) go to 8
      if(phnm(k).eq.ctmp(j).and.abs(tt(k)-tmp(j,1)).le.atol) go to 2
 8    k=k+1
      tt(k)=tmp(j,1)
      dtdd(k)=tmp(j,2)
      dtdh(k)=tmp(j,3)
      dddp(k)=tmp(j,4)
      phnm(k)=ctmp(j)
 2    continue
      n=k
 3    return
      end

      subroutine uctolc(n,ia,ifl)
c
c $$$$$ calls gchar and schar $$$$$
c
c   Subroutine uctolc converts the first n characters in string ia from
c   upper case to lower case.  If ifl<0 all characters are converted.
c   Otherwise characters enclosed by single quotes are left unchanged.
c   Programmed on 21 January by R. Buland.
c
      save
      character*80 ia
      data nfl/1/

      if(ifl.lt.0) nfl=1
c   Scan the string.
      do 1 i=1,n
      if(ifl.lt.0) go to 2
c   Look for single quotes.
      if(ia(i:i).eq.'''') nfl=-nfl
c   If we are in a quoted string skip the conversion.
      if(nfl.lt.0) go to 1
c   Do the conversion.
 2    if(ichar(ia(i:i)).ge.65.and.ichar(ia(i:i)).le.90)
     1 ia(i:i)=char(ichar(ia(i:i))+32)
 1    continue
      return
      end

      double precision function umod(zs,isrc,nph)
      save
      include 'ttlim.inc'
      character*80 msg
      double precision pm,zm,us,pt,tau,xlim,xbrn,dbrn
      double precision zs,uend,dtol,zmod
      dimension isrc(2)
      common/umdc/pm(jsrc,2),zm(jsrc,2),ndex(jsrc,2),mt(2)
      common/tabc/us(2),pt(jout),tau(4,jout),xlim(2,jout),xbrn(jbrn,3),
     1 dbrn(jbrn,2),xn,pn,tn,dn,hn,jndx(jbrn,2),idel(jbrn,3),mbr1,mbr2
      data dtol/1d-6/
c
      m1=mt(nph)
      do 1 i=2,m1
      if(zm(i,nph).le.zs) go to 2
 1    continue
      dep=(1d0-dexp(zs))/xn
      write(msg,100)dep
      write(6,100)dep
 100  format('Source depth (',f6.1,') too deep.')
      call aabort(msg)
 2    if(dabs(zs-zm(i,nph)).le.dtol.and.dabs(zm(i,nph)-zm(i+1,nph)).le.
     1 dtol) go to 3
      j=i-1
      isrc(nph)=j
      umod=pm(j,nph)+(pm(i,nph)-pm(j,nph))*(dexp(zs-zm(j,nph))-1d0)/
     1 (dexp(zm(i,nph)-zm(j,nph))-1d0)
      return
 3    isrc(nph)=i
      umod=pm(i+1,nph)
      return
c
      entry zmod(uend,js,nph)
      i=js+1
      zmod=zm(js,nph)+dlog(dmax1((uend-pm(js,nph))*(dexp(zm(i,nph)-
     1 zm(js,nph))-1d0)/(pm(i,nph)-pm(js,nph))+1d0,1d-30))
      return
      end

      subroutine dasign(lu,mode,ia,length)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine dasign opens (connects) logical unit lu to the disk file
c   named by the character string ia with mode mode.  If iabs(mode) = 1,
c   then open the file for reading.  If iabs(mode) = 2, then open the
c   file for writing.  If iabs(mode) = 3, then open a scratch file for
c   writing.  If mode > 0, then the file is formatted.  If mode < 0,
c   then the file is unformatted.  All files opened by dasign are
c   assumed to be direct access.  Programmed on 3 December 1979 by
c   R. Buland.
c
      character*80 ia
      if(mode.ge.0) nf=1
      if(mode.lt.0) nf=2
      ns=iabs(mode)
      if(ns.le.0.or.ns.gt.4) ns=3
      go to (1,2),nf
 1    go to (11,12,13,14),ns
 11   open(lu,file=ia,status='old',form='formatted',
     1 access='direct',recl=length)
      return
 12   open(lu,file=ia,status='new',form='formatted',
     1 access='direct',recl=length)
      return
 13   open(lu,file=ia,status='new',form='formatted',
     1 access='direct',recl=length)
      return
 14   open(lu,file=ia,status='old',form='formatted',
     1 access='direct',recl=length)
      return

c BRL 92: this line changed from nn=(len+3)/4 - caused direct record
c         overflow
 2    nn=length

      go to (21,22,23,24),ns
 21   open(lu,file=ia,status='unknown',form='unformatted',access=
     &'direct',recl=nn)
      return
 22   open(lu,file=ia,status='unknown',form='unformatted',access=
     &'direct',recl=nn)
      return
 23   open(lu,file=ia,status='unknown',form='unformatted',access=
     1 'direct',recl=nn)
      return
 24   open(lu,file=ia,status='unknown',form='unformatted',access=
     &'direct',recl=nn)
      return
      end
      subroutine ggetarg(n,ia)
c
c $$$$$ calls getcl and nxarg $$$$$
c
c   Getarg returns the n th command line argument in character
c   variable ia.  For this to work you must run your job 'foreign'.
c   For example, suppose your executable file is named xxx.exe and
c   is in directory [zzz].  Make a global symbol as follows:
c
c   yyy:==$dba0:[zzz]xxx
c
c   Your program is executed by typing:
c
c   yyy arg1 arg2 ... argn
c
c   Arguments must be seperated from the global symbol and from each
c   other by one or more blanks.  Characters other than alphanumeric
c   ones usually give strange results.  Most special characters will
c   work if preceeded by an alphanumeric.  Alphabetic characters
c   are converted to upper case.  Note that ia will be blank if the
c   n th argument doesn't exist.  The argument will be truncated
c   if longer than ia and ia will be blank padded to the right if
c   longer than the argument.  Programmed on 28 January 1981 by
c   R. Buland.
c
      character*80 ia
      character*100 ib
      common/gtarc1/nsw,narg,lb
      common/gtarc2/ib
c   Read the command line into ib if it hasn't already been done.
      if(nsw.lt.0) call getcl
c   Check for a valid argument.
      if(n.ge.0.and.n.le.narg) go to 1
c   Return a blank field if not.
      ia=' '
      return
 1    k=0
c   Skip to the n th argument.
      do 2 i=1,n
 2    j=nxarg(k)
      la=len(ia)
c   Copy the argument into ia.
      do 3 i=1,la
      ia(i:i)=ib(k:k)
      k=k+1
      if(k.gt.lb.or.ib(k:k).eq.' ') go to 4
 3    continue
      return
c   Blank pad if necessary.
 4    ia(i+1:la)=' '
      return
      end
      subroutine getcl
c
c $$$$$ calls only VMS library routines $$$$$
c
c   Getcl reads in the command line of a job run 'foreign' and
c   counts the number of arguments (delimited by blanks).
c   Programmed on 28 January 1981 by R. Buland.
c
      character*100 ib
      common/gtarc1/nsw,narg,lb
      common/gtarc2/ib
      data nsw/-1/
c   Flag that the command line has been read.
      nsw=1
c   Read the command line.
c      call lib$get_foreign(ib,,lb)
c   Count the arguments.
      narg=0
      k=0
 1    if(nxarg(k).le.0) go to 13
      narg=narg+1
      go to 1
 13   return
      end

      function nxarg(k)
c
c $$$$$ calls no other routine $$$$$
c
c   Nxarg assumes that the k th character of the command line
c   buffer, ib, is the first character of an argument or k=0.
c   It skips the remainder of the argument and the blanks
c   delimiting the next argument.  On normal return k will
c   point to the first character of the next argument and
c   nxarg will be set to 1.  If there is no next argument,
c   nxarg will be set to 0.  Programmed on 28 January 1981
c   by R. Buland.
c
      character*100 ib
      common/gtarc1/nsw,narg,lb
      common/gtarc2/ib
c   Exit if k already points beyond the end of the buffer.
      if(k.ge.lb) go to 13
c   Don't skip over the argument if we haven't found the first
c   one yet.
      if(k.le.0) go to 3
      k=k+1
c   Skip the remainder of the current argument.
 4    if(ib(k:k).eq.' ') go to 3
      k=k+1
      if(k-lb)4,4,13
 3    k=k+1
c   Skip blanks until the next argument or end of buffer.
 5    if(ib(k:k).ne.' ') go to 2
      k=k+1
      if(k-lb)5,5,13
c   Flag normal termination.
 2    nxarg=1
      return
c   Flag no next argument.
 13   nxarg=0
      return
      end

      subroutine tnoua(ia)
c
c $$$$$ calls no other routine $$$$$
c
c   Subroutine tnoua writes the character string ia to the standard
c   output without the trailing newline (allowing user input on the
c   same line).  Programmed on 17 September 1980 by R. Buland.
c
      save
      character*80 ia
      do i=1,80
       if(ia(i:i).eq.char(0))go to 200
      end do
200   ib=i-1
      if(ib.ge.1)write(*,100)ia(1:ib)

c $ is no line feed on both SUN & PC
 100  format(1x,a,$)
      return
      end

      subroutine vexit(ierr)
      if(ierr.eq.1) call aabort('Terminated with errors.')
      end

c
c    selecting subsection of mapfiles within a given grid, to be
c    used with the very detail large files of world coordinates
c
c    jh april 99
c    changes
c
c    oct 6  by jh : fix selection bug
c
      implicit none
      real lat(500000),lon(500000)
      integer n    ! number fo points in each segment
      real minlat,maxlat,minlon,maxlon  ! grid to search in
      logical select
      character*80 infile
      integer nseg,nmap
      integer i


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      nseg=0
      nmap=0
c
      write(6,*) 'Input file name'
      read(5,'(a)') infile
      open(1,file=infile,status='old')
      open(2,file='selmap.out',status='unknown')
      write(6,*)'Latitude range, min to max'
      read(5,*)minlat,maxlat
      write(6,*)'Longitude range, min to max'
      read(5,*)minlon,maxlon
c
 1    continue
c
c   read one segment
c
      select=.false.
      read(1,'(i4)',end=99) n
      nmap=nmap+1
      read(1,'(10f8.3)')(lat(i),lon(i),i=1,n)
c
c  find if any point is inside
c
      do i=1,n
        if(lat(i).le.maxlat.and.lat(i).ge.minlat.and.
     *     lon(i).le.maxlon.and.lon(i).ge.minlon) select=.true.
      enddo
      if(select) then
         nseg=nseg+1
         write(6,*)' Area selected',n
         write(2,'(i4)') n
         write(2,'(10f8.3)')(lat(i),lon(i),i=1,n) 
      endif
c
      goto 1
c
 99   continue
c
      write(6,*)'Number of segments in input file',nmap
      write(6,*)'Number of segments selected     ',nseg
      write(6,*)'Output file name is selmap.out'
      stop
      end

      subroutine text_sort(text_in,text_out,order_out,n)
c
c
c      input: text_in: text string to be sorted in 80 char array, only first
c                      70 chars can be used
c             n:       number of strings
c      output text_out: sorted strings
c      order out: order of strings out
c
c      jh april 2003
c
c     changes:
c
      implicit none
c      character*80 text_in(*),text_out(*)
c changed lot 21/4/2006
      character*(*) text_in(*),text_out(*)
      integer order_out(*)
      integer n,i



c   transfer input data
c
          do i=1,n
             text_out(i)(1:80)=text_in(i)
          enddo
c
c   add a number for getting order
c
          do i=1,n
             write(text_out(i)(71:80),'(i8)') i
          enddo
c
c   sort array
c
          call sortfi(text_out,n)
c 
c   find order of sorting and transfer text to output array
c
          do i=1,n
             read(text_out(i)(71:80),'(i8)') order_out(i)
             text_out(i)(71:80)=' '
          enddo 
	  
          return
	  end

c
c   system response subroutines
c
c   changes:
c   dec 95 by jh : poles and zeros
c                  unwrap routine
c   may 20, 96   : change error position from 1024 to 160, allow the use of
c                  internal file header use
c   may 30, 96   : fix bug , do not use header 160 to check, use 161..
c   aug 96  96   : changed phase response , seem that there was
c                        an error, term with 2 * i * damp changed sign
c   dec 96       : no filenr.lis needed to get list of cal files
c   feb 97 lo    : added subroutine inter_p from resp.for
c   mar 21 jh    : more precision in poles and zero routine
c   jan 23 98 jh : in read_resp, save first 80 chars, done in main prog. before
c   feb 15       : improve interp
c-----------------------------------------------------------------------------
c   oct 98  jh   : ------------ version 7.0 --------------------------------
c                  year 2000, longer station names, new resp file names
c   nov4         : remove computer specifics
c   feb 4 99 mv  : gencon=0 was set at a wrong place when using tabulated values
c   mar 1 99 jh  : fix forced header read
c   nov 30       : save date of respons file in comments field in read_resp
c   mar 23, 00 lo: mistake in resp_f fixed, was correct before aug 96
c   mar 26 00 lo : bug fixes in reading PAZ
c   mar 29 00 lo : if only filters use resp_f, not interpolation
c   mar 29 00 jh : implement read of gse files
c   april        : new wav structure
c   sep 27 00 lo : new routine find_resp_file
c   nov  1 00 lo : change in reading gse cal2 line, was gse2.1 before 
c   nov  3 00 lo : another change in the GSE resp reading
c   dec 12 00 lo : major changes in read_gse_resp
c   jan 29 00 jh : new flag to force table read in seisan format
c   feb 16    jh : fix forced read of seisan heders or optional read of
c                  seisan header if no file in cal
c   jun 08 01 lo : set wav_resp_filename in read_resp
c   jul 13 07 lo : changes in gse resp reading routine
c   nov    04 lo : read seed response files
c   nov 22 04 jh : make wav_resp_type always 6 chars
c   nov 26 04 lo : read seed files with names RESP....
c   dec 09 04 lo : deal with location code when checking seed filename
c   may    05 lo : seed response files
c   sep 26    lo : fix in reading format to handle files created by pc rdseed
c   sep 19 06 jh : do not write out all response file names
c   jan 24 08 lo : add _ to component codes for ' ' when looking for seed files
c   aug 14 08 jh : read resp files first from local dir
c   sep 11 08 jh : add findging also mininseed files in
c                  CAL and local dir. use routime find_resp also in 
c                  read_resp so files are 
c                  found using only one routine. thsi also incluide seed
c   oct 30 08 lo : set istart=1 in read_resp when plotting from file
c
c
      subroutine get_seisan_resp(header)
c
c   read seisan response values from header and return them in common 
c   block response
c
      implicit none
      include 'seidim.inc'
      logical gse_resp          ! true if gse format
      logical sei_resp          ! true if seisan format
      integer nfa               ! number of frequencies and amplitude
      logical ftab              ! if true, force tabulated values
c
C   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      real xpole(10)
      REAL FFILT(10)
      real pp(max_resp_value*2),pz(max_resp_value*2) ! PAZ, real and im.
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
c   sensor type 2: seismometer, 3: accelerometer
      integer sentyp
      real g1hz  ! gain at 1 hz
c   individual response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
C   SEISAN HEADER
      CHARACTER*1040 HEADER
      character*80 chead(13)
      INTEGER I,J,I1,I2,I3,I4,I5,I6,J1,J2,k,line
c
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c  THIS COMMON BLOCK ALSO IN pr_resp and presp
c  should have been in an include file
c***********************************************************************
c
      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa
      equivalence (xpole,pole)
      period=0.
      dampin=0.
      gencon=0.
c
c   if gse response, return since values read in directly
c
      if(gse_resp) return
c
c   first check if seisan poles and zeros, read if so
c
      npol=0
      nzero=0
      if(header(78:78).eq.'P') then       
         do i=1,13
           chead(i)=header((i-1)*80+1:i*80)
         enddo
         read(header(161:182),'(1x,2i5,g11.4)') npol,nzero,norm
         k=23
         line=3
         do i=1,npol*2
            read(chead(line)(k:k+10),'(g11.4)') pp(i)
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
         enddo
c         do i=1,nzero ! before march 2000
         do i=1,nzero*2
            read(chead(line)(k:k+10),'(g11.4)') pz(i)
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
         enddo
c
c   convert to complex
c
         k=0
         do i=1,npol*2,2
            k=k+1
c           pol(i)=cmplx(pp(i),pp(i+npol)) ! before March 2000
           pol(k)=cmplx(pp(i),pp(i+1))
c           write(*,*) pol(i)
         enddo
         k=0
         do i=1,nzero*2,2
           k=k+1
c          zero(i)=cmplx(pz(i),pz(i+nzero)) ! before March 2000
           zero(k)=cmplx(pz(i),pz(i+1))
c           write(*,*) zero(i)
         enddo
         return
       endif
c
c    get sensor type
c
      sentyp=2                           ! initially assume velocity transducer
      if(header(6:6).eq.'A') sentyp=3    ! A must be given for accelerometer 
c
c   read response parameters from header
c  
c      read(header(161:240), '(10g8.3)',err=999) 
      read(header(161:240), '(10g8.3)') 
     &    period, dampin, gencon,gain, 
     &    regain, g1hz, ffilt(1), xpole(1), ffilt(2), xpole(2)
      read(header(241:320), '(10g8.3)') (ffilt(i), xpole(i),i=3,7)
c
c   check if interpolation
c
      ftab=.false.
      if(header(78:78).eq.'T') then
         ftab=.true.                ! force table calculation 
         nfa=30                     ! always 30 in seisan format
      endif
c
c   poles are integers
c
      do i=1,7
        pole(i)=xpole(i)
      enddo
c
c   find how many filters
c
      nfilt=0
      do i=1,7
        if(ffilt(i).ne.0.0.and.pole(i).ne.0) nfilt=nfilt+1
      enddo
c
c   read individual response values from header
c
      do i=1,3                                                                  
         j1=(i-1)*10+1                                                          
         j2=j1+9                                                                
         i1=320+(i-1)*240+1                                                     
         i2=i1+79                                                               
         i3=400+(i-1)*240+1                                                     
         i4=i3+79                                                               
         i5=480+(i-1)*240+1                                                     
         i6=i5+79
         
         read(header(i1:i2),'(10g8.3)') (freq_val(j),j=j1,j2)                       
         read(header(i3:i4),'(10g8.3)') (gain_val(j),j=j1,j2)                       
         read(header(i5:i6),'(10g8.3)') (phas_val(j),j=j1,j2)                       
      enddo                              
999   continue
c
      return
      end                                       

      subroutine calc_resp(f,respons)                                    
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                               
c  Subroutine to calculate the response. Response is        
c  given in counts/Nanometer.  If no parameters are given, response
c  is calculated by interpolating the table values. This is decided by looking
c  at the gencon value, which must then be zero.
c  Response values are on common block response
c                                                                               
c  Input:                                                                       
c    f      - Frequency at which respons is calculated                          
c           - Response info in common block
c                                                                               
c  Output:                                                                      
c    respons - Complex response of system                                       
c                                                                               
c                                                                               
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
      include 'seidim.inc'                                                                                
c--frequency                                                       
      real f			
c--response                                        
      complex respons
      logical gse_resp            ! true if gse response
      logical sei_resp            ! true if seisan format
      integer nfa                 ! number of frequencies and amplitude
      logical ftab              ! if true, force tabulated values

c		
C   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      REAL FFILT(10)
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
      real g1hz   ! gain at 1 hz
c   individul response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
      integer sentyp  ! sensor type
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
c
      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa
c
c   could be poles and zeros
c
        if(npol.ne.0.or.nzero.ne.0) then
           call pazresp (f, norm, nzero, zero,
     $     npol, pol,  respons)
           goto 500
        endif
c                                                                               
c  Decide response calculation or interpolation    
c                                                                               
         if(.not.ftab) then  ! jh jan 2001
c       if(gencon.ne.0.0.or.nfilt.ne.0)  ! before jan 2001  
          call resp_f(f,respons)                                         
        else                                                                    
          call interp(f,respons)                                         
        endif 
c                 
 500  continue                 
c
c   convert to nanometers
c
      respons=respons/1.0e9
c                                
      return                                                                    
      end                                                                       
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine resp_f(f,respon)
c
C
C   CALCULATES DISPLACEMENT RESPONSE OF A SEISMIC SYSTEM INCLUDING
C   SENSORS, AMPLIFIER, FILTERS ETC.
c
c   Input is frequency f, and output
c   is response respon. Response info is in common block response
C
C   ALL UNITS ARE IN METERS AND SECONDS EXCEPT ACCELERATION
C   WHICH IS SUPPOSED TO BE IN G.
C
      IMPLICIT NONE
      include 'seidim.inc'
C
C   VARIABLES
C
      logical gse_resp            ! true if gse response
      logical sei_resp            ! true if seisan response
      integer nfa                 ! number of frequencies and amplitude
      logical ftab              ! if true, force tabulated values

C   COMPLEX RESPONSE OF SYSTEM FOR NF VALUES
      COMPLEX RESPON,xx
C   FREQUENCY FOR CALCULATIONS
      REAL F
C   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      REAL FFILT(10)
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
C   FLAG FOR TYPE OF SENSOR 1: NONE 2: SEISMOMETER 3: ACCELEROMETER
      INTEGER SENTYP
C   RESPONSE CURVE CORRECTION EXPONENT
      INTEGER RESCOR
C   CONSTANT
      REAL PI
      real g1hz   ! gain at 1 hz
c   individul response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
C   HELP VARIABLES
      COMPLEX CX
      REAL X
      INTEGER J
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa
      DATA PI/3.141592654/
C
C   CALCULATE EXPONENT FOR SENSOR TYPE 
C        
      IF(SENTYP.EQ.2) RESCOR=0
      IF(SENTYP.EQ.3) RESCOR=-2
C
C   NOW READY FOR CALCULATIONS, FIRST CALCULATE CONSTANT FACTORS  
C
      RESPON=1.0
      IF (GENCON.eq.0.) GOTO 15 ! if only filters
C
C  AMP GAIN AND RECORDING MEDIA GAIN
C
      RESPON=RESPON*10**(GAIN/20.0)*REGAIN
C
C  SEISMOMETER IF ANY
C
      IF(SENTYP.EQ.2) THEN
         RESPON=RESPON*PI*(0.0,2.0)*GENCON*(-1.0)*PERIOD**2
      ENDIF
C
C  ACCELEROMETER IF ANY, CONVERT FROM G TO M/SS
C
      IF(SENTYP.EQ.3) RESPON=RESPON*GENCON/9.81
C
C   SEISMOMETER
C
         IF(SENTYP.EQ.2) THEN
            X=PERIOD*F
            RESPON=RESPON*F**3/(1.+(0.,2.)*DAMPIN*X-X*X)   ! before aug 96 and after 03-00
c            RESPON=RESPON*F**3/(1.-(0.,2.)*DAMPIN*X-X*X)  ! after aug 96, was wrong
         ENDIF
c
c   type of sensor and response type
c
          xx=(0.0,1.0)*2*pi*f
          respon=RESPON/(xx**rescor)
C
C   FILTERS
C
 15      CONTINUE

         IF(NFILT.GT.0) THEN
            DO 20, J=1,NFILT
               CALL BWORTH(F,FFILT(J),POLE(J),CX)
               RESPON=RESPON*CX
 20         CONTINUE
         ENDIF
c   
         return
         end
c---------------------------------------------------------------------------    
                                                                                
      subroutine interp(f,respons)                                       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                               
c   interpolation of response values               
c                                                                               
c      input   :    f       : frequency                                         
c                                                                               
c      output  :    response: interpolated response value at frequency f        
c                                                       
c                                                                               
c    J. Havskov, Jun 22, 1988                                                   
c    Modified R. Hansen                                                         
c                                                                               
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
      include 'seidim.inc'
      logical gse_resp            ! true if gse response
      logical sei_resp            ! true if seisan response
      integer nfa                 ! number of frequencies and amplitude
      logical ftab              ! if true, force tabulated values
C   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      REAL FFILT(10)
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
c   sensor type 2: seismometer, 3: accelerometer
      integer sentyp
      real g1hz   ! gain at 1 hz
c   individul response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
      INTEGER J
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
c
      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa
c-- frequency                                                      
      real		f		
      complex		respons 	
c-- gain and phase at f                                                  
      real		gainf,phasf		
c-- phase at f                              
c                                                                               
c   do linear interpolation
c
c   if desired frequency lower than lowest, use the lowest                                                     
c                                                         
      if(f.le.freq_val(1)) then
         gainf=gain_val(1)
         phasf=phas_val(1)
         goto 2
      endif
c                      
c-- max nfa values                                             
      do j=1,nfa-1				
         if(f.ge.freq_val(j).and.f.le.freq_val(j+1)) go to 1 ! interpolate                           
c
         if(freq_val(j+1).eq.0.0.or.j.eq.nfa-1) then ! not high enough value, use highest
            gainf=gain_val(j)
            phasf=phas_val(j)
            goto 2
         endif	
      enddo                                                                    
                                                                               
 1    continue                                                                 
      gainf=gain_val(j)+(f-freq_val(j))*(gain_val(j+1)-gain_val(j))/                           
     *(freq_val(j+1)-freq_val(j))                                                      
      phasf=phas_val(j)+(f-freq_val(j))*(phas_val(j+1)-phas_val(j))/                           
     *(freq_val(j+1)-freq_val(j))                                                      
                                                                               
c      if(freq_val(j+1).eq.0.0.or.j.eq.nfa-1) 
c     *write(6,*)' response suspicious'
 
 2    continue
c                                                                               
c   calculate complex response value                                            
c                                                                               
      respons=g1hz*gainf*cmplx(cos(phasf/57.3),sin(phasf/57.3))                        
      return                                                                    
      end                                                                       
                                                                                

c--------------------------------------------------------------------------     
                                                                                
                                                                                
      subroutine read_resp                                              
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                                               
c  Subroutine to read response header from CAL directory or local directory                    
c                                                                               
c  Input: Is taken from waveform common block
c                    
c     sta  -  Station name (a5) (e.g. KTK1 )                                     
c     comp -  Station component (a4) (e.g. SH Z)                                
c     date -  Date: year,month,,day,hour,min                    
c                                                                               
c  Output:                                                                      
c     response in response common block                 
c                                                                               
c  Programmed by R. A. Hansen   June 21, 1988                                   
c  Changes:                                                                     
c  3-1-90 by j.h.   : small cleanup and comments,                               
c                     return if no file found, not chrash                       
c  dec 7 91         : return 9 in header(1040) if no file
c  sep 11 92        : add a close 88 after read filenr.lis
c  nov 4            : clear header(1040:1040) for flag
c  dec 93           : pc adoption
c  may 95           : rotated components
c  dec 95           : poles and zeros
c  dec 96           : no filenr.lis to get cal files
c  oct 98           : year 2000 and much more
c                                                                               
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
      include 'seidim.inc'           
      include 'waveform.inc'
C
C    SEISAN library inclusions...
c    ----------------------------
C
      include 'libsei.inc'                 ! Library definitions & data defns.
      integer  code                        ! Condition.
      logical  b_flag                      ! Flag!!
      logical ftab              ! if true, force tabulated values
    
      double precision time_cal,time_event ! time of cal file and event file
      double precision seed_start
                                                               
c--file name we are looking for                       
      character*10   file			
c-- calibration files
      character*29 cal_files(max_cal_files$)
      character*80 cal_file
c--file name to open                              
      character*80   filename
      integer istart                    ! start of resp file name
      character*5    stat     		! station code
      character*4    comp               ! component			
      character*80   local_cal  ! alternative directory for cal files
c-- top dir                                   
      character*60   top_directory		
      character*1040 header                                                     
      integer year                  
      integer ical  ! cal file number found                                            
c--do loop indices                                         
      integer i,j,k				
c--character counter                                          
      integer nt				
c-- number of calibration files in directory
      integer ncal_files
      integer imon,idy,ihr,imin,idoy
      real sec
c--number of files with sta-comp                          
      integer seiclen
      character*1 dchar
      integer read1       ! file unit
c used for comparison with seed file
      character*4 seed_comp 

c
c   for common block
c
      logical gse_resp          ! true if gse format
      logical sei_resp          ! true if seisan format
      logical seed_resp         ! true if seed response
      integer nfa               ! number of frequencies and amplitude
C   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      REAL FFILT(10)
      real pp(max_resp_value*2),pz(max_resp_value*2) ! PAZ, real and im.
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
c   sensor type 2: seismometer, 3: accelerometer
      integer sentyp
      real g1hz  ! gain at 1 hz
c   individual response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa

      call dir_char(dchar)
c
c clear flag incating if a response and from where
c
      wav_resp_status=' '
c     wav_resp_action=' ' !! jh feb , why cleared ??
      wav_resp_type=' '
      wav_resp_filename=' '
c     wav_resp_seisan_chead=' '  ! jh feb 2001 , should not be cleared  
      sei_resp=.true.
      gse_resp=.false.      ! default seisan response file
      seed_resp=.false.

c
c  if wav_resp_file set the skip 
c
      if (wav_resp_file.ne.' ') then
        cal_file = wav_resp_file
        ical=1
        istart=1
        cal_files(ical)=cal_file
        goto 250
      endif

c
c   check if response values MUST be read from SEISAN header
c   then read it and return, in future could also be used for GSE
c
      if(wav_resp_action(1:1).eq.'F') then
         wav_resp_status(1:1)='8' ! indicate header response
         wav_resp_type='SEISAN'
c
c   read response values to common block
c
         call get_seisan_resp(wav_resp_seisan_chead)
         return
      endif
c
      file(1:5)=wav_stat(wav_current_chan(1))
      file(6:9)=wav_comp(wav_current_chan(1))
      time_event=wav_abs_time(wav_current_chan(1))
c
c  rotated components are assumed to have same response
c  as horizontal components
c
         if(file(9:9).eq.'R') file(9:9)='N'
         if(file(9:9).eq.'T') file(9:9)='E'
         nt=9                                                                      
c         do i=1,nt                                                             
c           if(file(i:i).eq.' '.or.file(i:i).eq.char(0)) file(i:i)='_'
c         enddo                                                                 
c                                                                               
c  get list of cal files in CAL directory, local directory is first searched,
c  then the main cal directory and finally subdirectories of the cal directory
c  
      stat=file(1:5)
      comp=file(6:9)


      cal_file=' '    
c      write(6,*) stat,comp,time_event                                                                         
      call find_resp_file(stat,comp,time_event,cal_file,istart)
c      write(6,*)' find',cal_file,istart
c
c   case no file found
c
      if(cal_file.eq.' ') goto 77
c      
c
c---------------------------------------
c   cal file found, now read it
c---------------------------------------
c
 250  continue
c
c  save time of cal file if not a seed file
c
      if (cal_file(istart:istart+3).ne.'RESP') then
        wav_resp_stat=stat
        wav_resp_comp=comp
c
c store name of file in common block
c
        wav_resp_filename=cal_file(istart:)

        read(cal_file(istart+10:istart+13),'(i4)') wav_resp_year
        read(cal_file(istart+15:istart+16),'(i2)') wav_resp_month
        read(cal_file(istart+18:istart+19),'(i2)') wav_resp_day
      else
        wav_resp_stat=stat
        wav_resp_comp=comp
      endif

c                                                                               
c                                                                               
c   open response file and read                                                 
c                                                                               

            call sei open( old$,               ! Open file (stop on error).
     &                     ' ',                ! No prompt.
     &                     cal_file,           ! This filename.
     &                     read1,              ! On unit.
     &                     b_flag,             ! Exists!!
     &                     code )              !
            if( code .ne. e_ok$ ) goto 77      ! Does not exist.


c
c   read response file, first determine type
c
      if(cal_file(istart+26:istart+28).eq.'GSE') then
          gse_resp=.true.
          sei_resp=.false.
      endif   
      if(cal_file(istart:istart+3).eq.'RESP') then
          seed_resp=.true.
c        write(*,*) ' seed response '
          sei_resp=.false.
      endif   
c
c
c   seisan response file
c
      if(sei_resp) then
         wav_resp_type='SEISAN'
         do i=1,13                                                              
           j=(i-1)*80 + 1                                                      
           k=j+79                                                               
           read(read1,'(a80)') header(j:k)
         enddo
         wav_resp_seisan_chead=header ! to be used if response put into s. head.
      endif
c
c   read gse response file
c
      if(gse_resp) then
         wav_resp_type='GSE   '
         call read_gse_resp(read1)
      endif  
c
c   read seed
c                                                                   
      if (seed_resp) then
         wav_resp_type='SEED  '
         call read_seed_resp(read1,time_event,seed_start)
         call sectim(seed_start,year,idoy,imon,idy,ihr,imin,sec)
         wav_resp_year=year
         wav_resp_month=imon
         wav_resp_day=idy
c         write(*,*) norm
c         do i=1,npol
c           write(*,*) pol(i)
c         enddo
c         do i=1,nzero
c           write(*,*) zero(i)
c         enddo
      endif                                                                     
      call sei close( close$, read1, code )           ! Close cal file
c
c   read response values to common block
c
      if (sei_resp) then
        call get_seisan_resp(header)
      endif
c
      goto 78

 77   continue
      wav_resp_status(1:1)='9'  ! indicate no response file in cal
c
c   check if response values in header in which case only seisan
c   response is available
c
      if(wav_resp_seisan_chead(161:208).ne.' '.and.
     &   seiclen(wav_resp_seisan_chead(161:208)).ne.0) then
         gse_resp=.false.
         sei_resp=.true.
         wav_resp_type='SEISAN'
         wav_resp_status(1:1)='8'    ! indicate seisan header response available
c
c   read response values to common block
c
         call get_seisan_resp(wav_resp_seisan_chead)
      endif
 78   continue
c
      return                                                                    
      end                                                                       
c------------------------------------------------------------------------       
                                                                                
                                                                                
      subroutine bworth(f,fo,np,hs)                                             
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc   
ccccc                                                                           
c    bworth cal the response of a np pole butterworth filter up to              
c    as many poles as the arrays s and t are dimensioned                        
c                                                                               
c    f-frequency(hz)                                                            
c    fo-the corner frequency of the filter                                      
c    np-the number of poles, negative for high pass                             
c    hs-complex response of the filter                                          
c                                                                               
c    the formula used -- h(s)=1/(s-s1)(s-s2)...(s-sk)                           
c                        i*pi*(1/2+((2*k-1)/(2*np)))                            
c    where         sk=exp                                                       
c                                   k=1,2, ... np                               
c                  s = i(f/fo)                                                  
c                                                                               
c    ref theory and application of digital signal processing                    
c    rabiner and gold page 227 prentice-hall 1975                               
c                                                                               
c    Adapted to Vax/VMS by R. A. Hansen                                         
c                                                                               
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc   
ccccc                                                                           
c                                                                               
      complex s(20),t(20),as,bk,hs                                              
      hs=cmplx(1.0,0.0)                                                         
      n=iabs(np)                                                                
      if(np .eq. 0) go to 6                                                     
      if(f .eq. 0.0 .and. np .lt. 0) hs=cmplx(0.0,0.0)                          
      if(f .eq. 0.0 .and. np .lt. 0) go to 6                                    
      do 1 k=1,n                                                                
      an=float(k)                                                               
      ak=3.141592654*(0.5+(((2.*an)-1.)/(2.*float(n))))                         
      bk=cmplx(0.0,ak)                                                          
 1    s(k)=cexp(bk)                                                             
      ss=f/fo                                                                   
      as=cmplx(0.0,ss)                                                          
      if(np.lt.0) as=1./as                                                      
      t(1)=as-s(1)                                                              
      if(n.eq.1) go to 5                                                        
      do 2 i=2,n                                                                
 2    t(i)=(as-s(i))*t(i-1)                                                     
 5    continue                                                                  
      hs=1./t(n)                                                                
 6    return                                                                    
      end                                                                       
                                                                                

      subroutine pazresp (freq, pazconstant, numzeros, zeros,
     $     numpoles, poles,  clxrsp)
      implicit none
      complex zeros(*), poles(*), clxrsp
      real     freq, pazconstant
      integer    numzeros, numpoles


c.======================================================================
c.    Purpose                                                           
c     Compute_response_from_poles_and_zeros                       resp<<
c.----------------------------------------------------------------------
c.    Keywords                                                          
c.----------------------------------------------------------------------
c.    Package                                                           
c.    Visible                                                           
c.    Standard_fortran_77                                               
c.    Use_only                                                          
c.----------------------------------------------------------------------
c.    Input                                                             
c     
c..   freq        - Frequency (Hz)
c..   pazconstant - Constant in paz representation
c..   numzeros    - Number of zeros
c..   zeros       - Complex zeros
c..   numpoles    - Number of poles
c..   poles       - Complex poles
c
c.    Output
c
c..   clxrsp     - Complex amplitude in counts/m
c     
c.----------------------------------------------------------------------
c.    Programmer    Tormod Kvaerna                                     
c.    Creation_date 080395
c.    Made_at  
c     NORSAR
c     Granaveien 33
c     N-2007 Kjeller
c     
c.    Modification
c.    dec 17, 95 : simplification, use single precision
c.    Correction                                                        
c.======================================================================

c----
c     Internal declarations
c----
      complex*16      s, tzero, tpole
      real            pi, omega
      integer         i

      pi   = 3.141592654d0
c----
c     Poles and zeros response
c----
      omega = 2.0*pi*freq
      s     = cmplx(0.0, omega)
      tzero = (1.0,0.0)
      tpole = (1.0,0.0)
      do 1000 i = 1, numzeros
         tzero = tzero*(s-zeros(i))
 1000 continue
      do 2000 i = 1, numpoles
         tpole = tpole*(s-poles(i))
 2000 continue

      clxrsp    = cmplx(pazconstant,0.0)*tzero/tpole

      return

      end
      subroutine unwrap_phase (wrapped, nphase, unwrapped)

      real        wrapped(*), unwrapped(*)
      integer       nphase

c.======================================================================
c.    Purpose                                                           
c     Convert_wrapped_phase_to_unwrapped                          resp<<
c.----------------------------------------------------------------------
c.    Keywords                                                          
c.----------------------------------------------------------------------
c.    Package                                                           
c.    Visible                                                           
c.    Standard_fortran_77                                               
c.    Use_only                                                          
c.----------------------------------------------------------------------
c.    Input                                                             
c     
c..   wrapped    - Array of wrapped phases (degrees)
c..   nphase     - Number of phase elements
c
c.    Output
c
c..   unwrapped  - Array of unwrapped phases(degrees)
c     
c.----------------------------------------------------------------------
c.    Programmer    Tormod Kvaerna                                     
c.    Creation_date 080395
c.    Made_at  
c     NORSAR
c     Granaveien 33
c     N-2007 Kjeller
c     
c.    Modification
c.                
c.    Correction                                                        
c.======================================================================

c----
c     Internal declarations
c----
      integer       i
      real        wrapadd, diff1, diff2

      wrapadd = 0.0
      unwrapped(1) = wrapped(1)
      do 1000 i = 2, nphase
         diff1 = wrapped(i) - wrapped(i-1)
         diff2 = wrapped(i) - wrapped(i-1) - 360.0
         if (abs(diff2).lt.abs(diff1)) then
            wrapadd = wrapadd + 360.0
         endif
         diff2 = wrapped(i) - wrapped(i-1) + 360.0
         if (abs(diff2).lt.abs(diff1)) then
            wrapadd = wrapadd - 360.0
         endif
         unwrapped(i) = wrapped(i) - wrapadd
         
 1000 continue

      return

      end



      subroutine inter_p(nresp,normtab,
     *freq_val,gain_val,phas_val,f,respons)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   interpolation of response values
c
c      nresp   : number of values in
c      normtab : value to multiply with
c      freq_val,gain_val,phas_val : frequency, amplitude and phase in

c      f       : frequency for desired output
c      response: interpolated response value at frequency f
c
c
c    J. Havskov, feb 97
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      implicit none
      real normtab   ! multiplying factor
c   individul response values
      real freq_val(*),gain_val(*),phas_val(*)
      INTEGER J
c-- frequency
      real              f
      integer nresp
      complex           respons
c-- gain and phase at f
      real              gainf,phasf
c           
c   do linear interpolation, first find which 2 frequencies to use
c           
      do j=1,nresp-1
         if(freq_val(j+1).eq.0.0) go to 1       ! no more response values
         if(f.ge.freq_val(j).and.f.le.freq_val(j+1)) go to 1
      enddo 

 1    continue
      gainf=gain_val(j)+(f-freq_val(j))*(gain_val(j+1)-gain_val(j))/
     *(freq_val(j+1)-freq_val(j))
      phasf=phas_val(j)+(f-freq_val(j))*(phas_val(j+1)-phas_val(j))/
     *(freq_val(j+1)-freq_val(j))

c      if(freq_val(j+1).eq.0.0.or.j.eq.nresp-1)
c     *write(6,*)' response suspicious'

c           
c   calculate complex response value
c

      respons=normtab*gainf*cmplx(cos(phasf/57.3),sin(phasf/57.3))
      return
      end


      subroutine read_gse_resp(read1)
c
c   read response values from GSE file and put in common block,
c   for GSE1/2 and FAP/PAZ
c
      implicit none
      include 'seidim.inc'
      logical gse_resp          ! true if gse format
      logical sei_resp          ! true if seisan format
      integer nfa               ! number of frequencies and amplitude
      logical ftab              ! if true, force tabulated values
      integer read1             ! file unit

c
C   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      REAL FFILT(10)
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
c   sensor type 2: seismometer, 3: accelerometer
      integer sentyp
      real g1hz  ! gain at 1 hz
c   individual response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
      INTEGER x,c
c gse line 
      character*90 gseline 
      character*2 g1comp                         ! component GSE1
      double precision scale                     ! sensitivity build up from 
                                                 ! components
      double precision sfactor                   ! component sens.
      double precision system_sensitivity        ! overall system sens. nm/count
      integer gsever                             ! gse1 or gse2
      real re,im                                 ! real and imaginary part
      integer iphase                             ! integer phase
      real calper                                ! calibration period
      integer pol_cnt,zero_cnt                   ! counters
      real f                                     ! frequency array
      complex respons

      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa

      scale=1.
      pol_cnt=0
      zero_cnt=0

100   continue
      read(read1,'(a)',end=9999) gseline
c        write(*,*) gseline

c
c ignore comments
c
      if (gseline(2:2).eq.'(') goto 100     

c 
c gse1 response to be added
c
      if (gseline(1:4).eq.'CAL1') then
         write(*,*) ' gse1 response not supported '
         return
      endif

c
c CAL2 line, GSE2.0
c
      if (gseline(1:4).eq.'CAL2') then
c
c system sensitivity is given in nm/count
c
         read(gseline(28:37),'(e10.2)') system_sensitivity
         read(gseline(39:45),'(f7.3)') calper
         goto 100
      endif


c response in GSE1
c      if (gsever.eq.1) then
c         if (g1format.eq.'PAZ') then
c read poles
c           read(gseline(1:8),'(i8)') npol  ! get number of poles
c           do x=1,npol
c             read(read1,'(a)') gseline
c             read(gseline(1:8),'(g8.3)') re 
c             read(gseline(9:16),'(g8.3)') im
c             pol(x)=cmplx(re,im)
c           enddo
c
c           read(read1,'(a)',end=9999) gseline
c read zeros 
c           read(gseline(1:8),'(i8)') nzero  ! get number of poles
c           do x=1,nzero
c             read(read1,'(a)') gseline
c             read(gseline(1:8),'(g8.3)') re
c             read(gseline(9:16),'(g8.3)') im
c             zero(x)=cmplx(re,im)
c           enddo 
c
c read normalization constant 
c           read(read1,'(a)',end=9999) gseline
c           read(gseline(1:16),'(g16.3)')  g1calib
c           norm=1E9/g1calib
c
c         elseif (g1format.eq.'FAP') then 
c
c           gencon=0.0
c read FAP  
c           read(read1,'(a)',end=9999) gseline
c           read(gseline(1:8),'(i8)') nfa  ! get number of fap 
c           do x=1,nfa
c             read(read1,'(a)') gseline
c             read(gseline,'(e10.5,1x,e10.5,1x,e10.4)')
c     &         freq_val(x),gain_val(x),phas_val(x)
c             g1hz=1E9
c           enddo
c         endif

c
c read GSE2 response
c

c
c PAZ2
c
      if (gseline(1:4).eq.'PAZ2') then
        read(gseline(11:25),'(e15.8)') sfactor
        scale=scale*sfactor
 
c           norm = scalib / sfactor    ! CAL2 already contains scaling for all 
c                                      ! stages
        read(gseline(41:43),'(i3)') npol
        read(gseline(45:47),'(i3)') nzero

        do c=1,npol     ! read the poles
           read(read1,'(a)',end=9999) gseline
           read(gseline(2:16),'(g15.8)') re 
           read(gseline(18:32),'(g15.8)') im
           pol_cnt=pol_cnt+1
           pol(pol_cnt)=cmplx(re,im)
        enddo
 
        do c=1,nzero    ! read the zeros
           read(read1,'(a)',end=9999) gseline
           read(gseline(2:16),'(g15.8)') re 
           read(gseline(18:32),'(g15.8)') im
           zero_cnt=zero_cnt+1
           zero(zero_cnt)=cmplx(re,im)
        enddo
     
        goto 100
      endif
c
c DIG2
c
      if (gseline(1:4).eq.'DIG2') then
        read(gseline(9:23),'(e15.8)') sfactor
        scale=scale*sfactor
        goto 100
      endif
       
c
c FAP2
c
      if (gseline(1:4).eq.'FAP2') then
        read(gseline(25:27),'(i3)') nfa
        gencon=0.0
        do c=1,nfa
          read(read1,'(a)',end=9999) gseline
          read(gseline(2:11),'(f10.5)') freq_val(c)
          read(gseline(13:27),'(e15.8)') gain_val(c)
          read(gseline(29:32),'(i4)') iphase
          phas_val(c)=iphase
        enddo
        goto 100
      endif 
      
9999  continue
c
c set npol and nzero
c
      npol=pol_cnt
      nzero=zero_cnt
 
c
c check sensitivity and set seisan normalization constant (c/m)
c
      norm = scale * 1.E9     ! convert c/nm -> c/m

c
c compute system sensitivity at calperiod
c
      f=1/calper
      call calc_resp(f,respons)
      g1hz = 1.E9*cabs(respons)  ! in c/m

      if (1./cabs(respons).ge.1.05*system_sensitivity.or.
     &    1./cabs(respons).le.0.95*system_sensitivity) 
     &      write(*,*) ' total system sensitivity not equal ' //
     &      'sum of all components, should be ',1./cabs(respons)
 
c
c check if paz2 section normalized
c
      if (cabs(respons).le.1.025.and.cabs(respons).ge.0.9975) then
        write(*,*) ' PAZ section normalized to 1 at calperiod ' //
     &    '-> using sensitivity from CAL2 line '
        norm=norm/system_sensitivity   ! units already converted
      endif
        
c
c if FAP
c
c      g1hz = 1.E9/system_sensitivity

      return
      end


      subroutine read_resp_head(header)
c
c add response to header
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'

      integer year,month,day,hour,min   ! date and time
      real sec
      character*1040 header                  ! header

      wav_resp_seisan_chead=' '         ! there should be nothing since new
      wav_stat(1)=header(1:5)
      wav_comp(1)=header(6:9)
      wav_current_chan(1)=1
      read(header(10:35),'(i3,5x,4(i2,1x),f6.3)',err=99) 
     *year,month,day,
     *hour,min,sec
      year=year+1900
      goto 199
 99   continue
      write(6,*)' Something wrong with channel header generated'
      stop
 199  continue
      call timsec(year,month,day,hour,min,sec,wav_abs_time(1))
      wav_resp_file=' '
      call read_resp
      header(78:1040)=wav_resp_seisan_chead(78:1040)

      if (wav_resp_type.eq.'GSE   ') then
        write(6,*)
     *       ' Response is in GSE format -------'
      elseif(wav_resp_status(1:1).eq.'9') then
        write(6,*)
     *       ' No response file for this channel --------'
      endif

      return
      end

c------------------------------------------------------------------------------------------
c------------------------------------------------------------------------------------------

      subroutine find_resp_file(stat,comp,time_event,cal_file,istart)
c
c routine searches for path and filename to CAL file
c    
c      input is station,stat, component,comp, time of event, time_event
c      output is complet cal file name with path, start of name at istart


      implicit none

      include 'seidim.inc'
      character*1 dchar
      double precision time_event,time_cal
      character*10   file
      integer istart
      character*5 stat
      character*4 comp
c used for comparison with seed file
      character*4 seed_comp 
      integer i,k,j
      character*80   local_cal,filename,cal_file
      integer ncal_files
      character*29 cal_files(max_cal_files$)
      integer seiclen
      integer year,imon,idy,ihr,imin,ical
      character*60   top_directory

      call dir_char(dchar)
      cal_file = ' '

c
c set station and component names in filenam
c
      file(1:5)=stat
      file(6:9)=comp
      do i=1,9 
        if(file(i:i).eq.' '.or.file(i:i).eq.char(0)) file(i:i)='_'
      enddo

c      write(*,*) ' resp: ',file(1:9)


c
c-----------------------------------------------------------
c  case of local working directory
c-----------------------------------------------------------
c
         filename='.'//dchar//file(1:9)      
c
c   read file names
c
         call respfil(filename,11,cal_files,
     *   max_cal_files$,ncal_files)
c        write(6,*) 'ncal',ncal_files
c
c   check time
c
         if(ncal_files.gt.0) then            ! now check date
           ical=0
           do i=1,ncal_files
c              write(6,*) cal_files(i)
              read(cal_files(i)(11:25),
     *        '(i4,1x,i2,1x,i2,1x,2i2)') year,imon,idy,ihr,imin
c
c calculate abs time of cal file
c
              call timsec(year,imon,idy,ihr,imin,0.0,time_cal)

c
c  search for response file with nearest date
c
              if (time_cal.le.time_event) then   ! found file
                 ical=i
              endif
           enddo
           if(ical.ne.0) then
              cal_file=cal_files(ical)(1:29)
              istart=1
              return
           endif
         endif

c
c-----------------------------------------------------------
c  case of a local CAL directory, variable local_cal is set
c-----------------------------------------------------------
c
      call get_env_cal(local_cal)
      if(local_cal(1:3).ne.'   ') then
         k=seiclen(local_cal)
         filename=local_cal(1:k)//file(1:9)
c
c   read file names
c
         call respfil(filename,k+9,cal_files,
     *   max_cal_files$,ncal_files)
c
c   check time
c
         if(ncal_files.gt.0) then            ! now check date
           ical=0
           do i=1,ncal_files
              read(cal_files(i)(11:25),
     *        '(i4,1x,i2,1x,i2,1x,2i2)') year,imon,idy,ihr,imin
c
c calculate abs time of cal file
c
              call timsec(year,imon,idy,ihr,imin,0.0,time_cal)

c
c  search for response file with nearest date
c
              if (time_cal.le.time_event) then   ! found file
                 ical=i
              endif
           enddo
           if(ical.ne.0) then
              cal_file=filename(1:k)//cal_files(ical)(1:29)
              istart=k+1
              return
           endif
         endif

      endif

c
c------------------------------
c   case of CAL main directory
c------------------------------
c
      call topdir(top_directory)
      k=index(top_directory,' ')-1

c
c   make directory name and start of file name for that station and component
c
      filename=
     *top_directory(1:k)//dchar//'CAL'//dchar//file(1:9)
c
c   read files
c
      call respfil(filename,k+14,cal_files,
     *max_cal_files$,ncal_files)
c
c   check time
c
      if(ncal_files.gt.0) then
        ical=0
        do i=1,ncal_files
           read(cal_files(i)(11:25),
     *     '(i4,1x,i2,1x,i2,1x,2i2)') year,imon,idy,ihr,imin
c
c calculate abs time of cal file
c
           call timsec(year,imon,idy,ihr,imin,0.0,time_cal)
c
c  search for response file with nearest date
c
           if (time_cal.le.time_event) then  ! found one
              ical=i
           endif
         enddo
         if(ical.ne.0) then
            cal_file=filename(1:k+5)//cal_files(ical)(1:29)
            istart=k+6
            return
         endif
      endif

c
c----------------------------------
c   case of CAL  subdirectory
c----------------------------------
c
      filename=
     *top_directory(1:k)//dchar//
     *'CAL'//dchar//file(1:5)//dchar//file(1:9)
c
c   read files
c
      call respfil(filename,k+20,cal_files,
     *max_cal_files$,ncal_files)

      if(ncal_files.gt.0) then
        ical=0
        do i=1,ncal_files
           read(cal_files(i)(11:25),
     *     '(i4,1x,i2,1x,i2,1x,2i2)') year,imon,idy,ihr,imin
c
c calculate abs time of cal file
c
           call timsec(year,imon,idy,ihr,imin,0.0,time_cal)
c
c  search for response file with nearest date
c
           if (time_cal.le.time_event) then     ! found one
             ical=i
           endif
        enddo
        if(ical.ne.0) then
           cal_file=filename(1:k+11)//cal_files(ical)(1:29)
           istart=k+12
           return
        endif
      endif


c
c-----------------------------------------------------------------------
c seed response file, e.g. RESP.GE.DSB..HHZ, in local working directory
c-----------------------------------------------------------------------
c
c   make directory name and start of file name for that station and component
c
      filename='.'//dchar//'RESP.'
c
c   read all seed response files 
c
      call respfilseed(filename,7,cal_files,
     *max_cal_files$,ncal_files)
      
c      write(6,*) ' number of seed calibration files', ncal_files

      if(ncal_files.gt.0) then
         ical=0
         do i=1,ncal_files
c           write(6,*)cal_files(i)
c           write(6,*)cal_files(i)(9:8+seiclen(wav_stat
c     *             (wav_current_chan(1))))
c     *              ,wav_stat(wav_current_chan(1))
c     *              (1:seiclen(wav_stat(wav_current_chan(1))))
c     *              ,cal_files(i)(seiclen(cal_files(i))-2:
c     *              seiclen(cal_files(i)))
c     *              ,wav_comp(wav_current_chan(1))(1:2)//
c     *              wav_comp(wav_current_chan(1))(4:4)

           seed_comp=comp
           do j=1,seiclen(seed_comp)
              if (seed_comp(j:j).eq.' ')seed_comp(j:j)='_'
           enddo
c          write(*,*) ' xxx ',cal_files(i),
c     &    wav_stat(wav_current_chan(1)),seed_comp

           if (cal_files(i)(9:8+seiclen(stat))
     &     .eq.stat(1:seiclen(stat)) 
     &     .and.cal_files(i)(seiclen(cal_files(i))-2:
     &     seiclen(cal_files(i)))
     &     .eq.seed_comp(1:2)//seed_comp(4:4)) then
              cal_file=filename(1:k+5)//cal_files(i)
     &        (1:seiclen(cal_files(i)))
              ical=i
              cal_file=cal_files(i)
              istart=1
              return  
           endif                                               
        enddo
      endif


c
c-----------------------------------------------------------------------
c seed response file, e.g. RESP.GE.DSB..HHZ, in cal directory
c-----------------------------------------------------------------------
c
c   make directory name and start of file name for that station and component
c
      filename=
     *top_directory(1:k)//dchar//'CAL'//dchar//'RESP.'
c
c   read all seed response files 
c
      call respfilseed(filename,k+10,cal_files,
     *max_cal_files$,ncal_files)
      
c      write(6,*) ' number of seed calibration files', ncal_files

      if(ncal_files.gt.0) then
         ical=0
         do i=1,ncal_files
c           write(6,*)cal_files(i)
c           write(6,*)cal_files(i)(9:8+seiclen(wav_stat
c     *             (wav_current_chan(1))))
c     *              ,wav_stat(wav_current_chan(1))
c     *              (1:seiclen(wav_stat(wav_current_chan(1))))
c     *              ,cal_files(i)(seiclen(cal_files(i))-2:
c     *              seiclen(cal_files(i)))
c     *              ,wav_comp(wav_current_chan(1))(1:2)//
c     *              wav_comp(wav_current_chan(1))(4:4)

           seed_comp=comp
           do j=1,seiclen(seed_comp)
              if (seed_comp(j:j).eq.' ')seed_comp(j:j)='_'
           enddo
c          write(*,*) ' xxx ',cal_files(i),
c     &    wav_stat(wav_current_chan(1)),seed_comp

           if (cal_files(i)(9:8+seiclen(stat))
     &     .eq.stat(1:seiclen(stat)) 
     &     .and.cal_files(i)(seiclen(cal_files(i))-2:
     &     seiclen(cal_files(i)))
     &     .eq.seed_comp(1:2)//seed_comp(4:4)) then
              cal_file=filename(1:k+5)//cal_files(i)
     &        (1:seiclen(cal_files(i)))
              ical=i
              cal_file=filename(1:k+5)//cal_files(i)
              istart=k+6
              return  
           endif                                               
        enddo
      endif


      return
      end


      subroutine read_seed_resp(read01,event_time,seed_start)
c
c read seed response file from unit read01 for time given by
c event_time, response is put into Seisan common block,
c so far only paz supported
c
c lot 16/11/2004
c
      implicit none
      include 'seidim.inc'
      include 'resp.inc'
      integer read01
      double precision event_time,seed_start,seed_end,now
      character*120 line
      integer year,month,day,doy,hour,min,isec
      real sec
      integer max_stage,stage,max_pz
      parameter (max_stage=50)
      parameter (max_pz=50)
      character*1 transfer_function_type(max_stage)
      character*80 in_units(max_stage) 
      character*80 out_units(max_stage) 
      real a0_norm(max_stage),norm_f(max_stage)
      integer seed_np(max_stage),seed_nz(max_stage)
      complex seed_p(max_stage,max_pz),seed_z(max_stage,max_pz)
      complex z
      real x,y
      real seed_gain(max_stage)
      logical flag,found
      real overall_sens,f_sens
      real pi
      parameter (pi=3.141592654)
      integer i,j
      character*12 t
      character*14 t1
      complex test_p(max_pz),test_z(max_pz)
      integer test_np,test_nz
      real test_f,test_norm

c      write(*,*) ' reading seed response '
c
c get system time
c
      call systime(t,t1)
      read(t,'(6i2)') year,month,day,hour,min,isec
      year=year+2000
      sec=float(isec)
      call timsec(year,month,day,hour,min,sec,now)
      if (event_time.eq.0.) event_time=now

      flag=.true.
      found=.false.
10    continue
      read(read01,'(a)',end=900) line
c      write(*,'(a)') line

c
c parse seed response
c

c
c exit if response already found, to deal with response data from different
c time periods
c
      if (line(1:7).eq.'B050F03') then
        if (found) then
          goto 900
        endif
c start date and time
      elseif (line(1:7).eq.'B052F22') then
        read(line(26:),'(i4,1x,i3,1x,i2,1x,i2,1x,f4.1)')
     &     year,doy,hour,min,sec
        call dte(doy,day,month,year)
        seed_start=0.
        call timsec(year,month,day,hour,min,sec,seed_start)                    
      elseif (line(1:7).eq.'B052F23') then
        if (line(26:26).ne.'N') then
          read(line(26:),'(i4,1x,i3,1x,i2,1x,i2,1x,f4.1)')
     &      year,doy,hour,min,sec
          call dte(doy,day,month,year)
          call timsec(year,month,day,hour,min,sec,seed_end)
        else
          seed_end=0.
        endif
c
c check if date correct
c
c        write(*,*) seed_start,event_time,seed_end
        if (event_time.ge.seed_start) then
          if (seed_end.eq.0..or.event_time.lt.seed_end) then
            write(*,*) ' found date and time: ',
     &          year,month,day,hour,min,sec
            found=.true.
            stage=0
            do i=1,max_stage
              seed_np(i)=0
              seed_nz(i)=0
              a0_norm(i)=1.
              seed_gain(i)=0.
            enddo
c            write(*,*) ' resetting seed response '
          endif
        endif
c paz section
      elseif (line(1:7).eq.'B053F03'.or.
     &    line(1:7).eq.'B043F05') then
        flag=.true.
        stage=stage+1
        read(line(52:52),'(a1)') transfer_function_type(stage)
      elseif (line(1:7).eq.'B053F05'.or.
     &    line(1:7).eq.'B043F06') then
        read(line(52:),'(a)') in_units(stage)
      elseif (line(1:7).eq.'B053F06'.or.
     &    line(1:7).eq.'B043F07') then
        read(line(52:),'(a3)') out_units(stage)
      elseif (line(1:7).eq.'B053F07'.or.
     &    line(1:7).eq.'B043F08') then
        read(line(52:),*) a0_norm(stage)
      elseif (line(1:7).eq.'B053F08'.or.
     &    line(1:7).eq.'B043F09') then
        read(line(52:),*) norm_f(stage)
      elseif (line(1:10).eq.'B053F10-13'.or.
     &    line(1:7).eq.'B043F14') then
c        read(line(16:43),'(2e14.2)') x,y
        read(line(16:),*) x,y
        if (transfer_function_type(stage).eq.'B') then
          x=x*2.*pi
          y=y*2.*pi
          a0_norm(stage)=a0_norm(stage)/(2.*pi)
        endif
        seed_nz(stage)=seed_nz(stage)+1
        seed_z(stage,seed_nz(stage))=cmplx(x,y)
      elseif (line(1:10).eq.'B053F15-18'.or.
     &    line(1:10).eq.'B043F16-19') then
c        read(line(16:43),'(2e14.2)') x,y
        read(line(16:),*) x,y
        if (transfer_function_type(stage).eq.'B') then
          x=x*2.*pi
          y=y*2.*pi
          a0_norm(stage)=a0_norm(stage)*(2.*pi)
        endif
        seed_np(stage)=seed_np(stage)+1
        seed_p(stage,seed_np(stage))=cmplx(x,y)
      elseif (line(1:7).eq.'B058F04'.and.flag) then
        if (seed_gain(stage).eq.0.) read(line(52:),*) seed_gain(stage)
c decimation
      elseif (line(1:7).eq.'B054F03') then
        stage=stage+1
        read(line(52:52),'(a1)') transfer_function_type(stage)
      elseif (line(1:7).eq.'B061F03') then
        stage=stage+1
        read(line(52:52),'(a1)') transfer_function_type(stage)
c overall sensitivity
      elseif (line(1:7).eq.'B058F03'.and.line(52:52).eq.'0') then
c        write(*,*) ' stage 0 '
        flag=.false.   
      elseif (line(1:7).eq.'B058F04'.and..not.flag) then
        read(line(52:),*) overall_sens
      elseif (line(1:7).eq.'B058F05'.and..not.flag) then
        read(line(52:),*) f_sens
      endif

      goto 10
c
c end of file
c
900   continue

c
c convert response to Seisan
c
      nfilt=0
      gain=1.
      gencon=0.
      dampin=0.
      period=0.
      ftab=.false.
      regain=0.
      g1hz=0.
      sentyp=0
      npol=0
      nzero=0
      norm=1. 
      nfa=0
      gse_resp=.false.
      sei_resp=.false.

      if (.not.found) return

c
c loop over all stages
c
      do i=1,stage
c
c test paz normalisation 
c
c        write(*,*) ' stage ',i
        if (seed_np(i).gt.0.and.seed_nz(i).gt.0) then
          test_np=seed_np(i)
          test_nz=seed_nz(i)
          do j=1,seed_np(i)
            test_p(j)=seed_p(i,j)
          enddo
          do j=1,seed_nz(i)
            test_z(j)=seed_z(i,j)
          enddo
          test_f=norm_f(i)
          test_norm=a0_norm(i)
          call pazresp(test_f,test_norm,test_nz,test_z,
     &      test_np,test_p,z)
          test_norm=cabs(z)
          if (test_norm.lt..95.or.test_norm.gt.1.05) then
            write(*,*) ' paz not normalized, stage = ',i
            write(*,*) ' amplitude at ',test_f,' Hz = ',test_norm
c
c calculate what norm should be
c
            test_norm=1.
            call pazresp(test_f,test_norm,test_nz,test_z,
     &        test_np,test_p,z)
            a0_norm(i)=1./cabs(z)   
            write(*,*) ' a0 changed to ',a0_norm(i)
          endif
        endif

        if (seed_gain(i).ne.0.) then
c          write(*,*) ' seed_gain ',seed_gain(i)
          norm=norm*seed_gain(i)
        endif
        if (a0_norm(i).ne.0.) then 
c          write(*,*) ' a0_norm ',a0_norm(i)
          norm=norm*a0_norm(i)
        endif
        do j=1,seed_np(i)
          npol=npol+1  
          pol(npol)=seed_p(i,j)
c          write(*,*) pol(npol)
        enddo
        do j=1,seed_nz(i)
          nzero=nzero+1  
          zero(nzero)=seed_z(i,j)
c convert from velocity to displacement
c          write(*,*) zero(nzero)
          if (j.eq.seed_nz(i)) then
            nzero=nzero+1  
            zero(nzero)=cmplx(0,0)
          endif
        enddo
      enddo
  
      call calc_resp(1.,z)
      g1hz = 1.E9*cabs(z)  ! in c/m

      return
      end


      subroutine write_gse_resp(sta,comp,time)
c
c write out gse paz response from seisan common block
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      include 'resp.inc'
      external seiopen,seiclose
      integer seiclen,code
      logical b_flag
      character*80 deffile
      character*96 gsetext
      integer gse_stage
      logical no_net
      character*(5) net_code
      character*(*) sta,comp
      character*14 time
      integer year,month,day,hour,min,i,write01
      character*29 mainhead_text

      if (npol.eq.0.and.nzero.eq.0) then
        write(*,*) ' sorry this only works for paz '
        stop
      endif
c
c   get def file for station codes, give file name
c
      deffile='gsesei.def'
      no_net = .FALSE.
      net_code=' '
      call read_def_chan(deffile,mainhead_text,net_code)

      call sei open( unknown$,                 ! Open file (stop on error).
     &                     ' ',                ! No prompt.
     &                     'gseresp.out',      ! This filename.
     &                     write01,            ! On unit.
     &                     b_flag,             ! Exists!!
     &                     code )              !
   
      read(time,'(i4,4i2)') year,month,day,hour,min

c
c header line, CAL2
c
      gsetext(1:96)='                                        '
     &// '                                                        '
      gsetext(1:4)='CAL2'
      gsetext(6:10)=sta(1:5)
c
c convert component to GSE
c
      call set_def_chan(1,sta,comp)
      if (seiclen(comp).gt.3) then
        gsetext(12:13)=comp(1:2)
        gsetext(14:14)=comp(4:4)
      else
        gsetext(12:14)=comp(1:3)
      endif

c
c product of all stage scaling factors, in nm/count
c
      write(gsetext(28:37),'(e10.2)') 1.e9/g1hz
      write(gsetext(44:45),'(a2)') '1.'
c      write(gsetext(47:56),'(f10.5)') gse_rate

      write(gsetext(58:67),'(i4.4,a1,i2.2,a1,i2.2)')
     &       year,'/',month,'/',day
      write(gsetext(69:73),'(i2.2,a1,i2.2)') hour,':',min

      write(write01,'(a96)') gsetext

c
c paz
c
      gse_stage=1
      gsetext(1:96)='                                        '
     &// '                                                        '
      gsetext(1:6)='PAZ2  '
      write(gsetext(11:25),'(e15.8)') norm/1.E9
      write(gsetext(41:43),'(i3)') npol
      write(gsetext(45:47),'(i3)') nzero
      write(gsetext(49:65),'(a17)') 'Laplace transform'

      write(gsetext(7:7),'(i1)') gse_stage
      gsetext(9:9)='V'             ! Volts
      write(write01,'(a96)') gsetext

      do i=1,npol
            write(write01,'(1x,e15.8,1x,e15.8)') real(pol(i)),
     &      aimag(pol(i))
      enddo
      do i=1,nzero
            write(write01,'(1x,e15.8,1x,e15.8)') real(zero(i)),
     &      aimag(zero(i))
      enddo
      call sei close( close$, write01, code )           ! Close cal file

      return
      end
     

c
c      program fk

C==========================================================================
C    Program/subroutine fk reads data from file 'waveform.out'
C    asks values of parameters from keybord and feeds everyfing into
C    subroutine 'slbbkfk' to calculate wide-band slowness estimate
C    Then subrouatine 'conte' is called and relative power is drawn in 
C    slowness space
C--------------------------------------------------------------------------
C    For input and output parameters see in text of 'slbbfk.for'
C--------------------------------------------------------------------------
C    writen by Andrius Pacesa
C    May , 1999
C    Bergen University
C    Institute of Solid Earth Physics
C-------------------------------------------------------------------------
C    the first chanel coordinates are reference coordinates
C     
c
c changes
c
c 20 mai 99   : Postscript output, include conte, pc test
c 28 mai 99   : Plotting of date, time and stations used added to graph window
c 28 sep 99 lo: check for waveform.out
c 05 oct    jh: stop if a missing station
c 02 may 00 lo: fixed for new waveform structure
c 11 sep 00 lo: use character to specify station file
c 19 oct 00 jh: only ask for station file char if station not found
c               more accuracy in output
c               more error messages
c 20 jun 05 jh: plt to eps
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


c     implicit none !comment for pc
      include 'winplot1.inc'    !     related to graphics
      include 'mulplt.inc'
      include 'seiplot.inc'     !     seisan graphics

c     variables for fk

      INTEGER       n        , i       , k
      INTEGER       cftpts(100), cftptr(100)
      INTEGER       NFFT
      INTEGER       YEAR,  MONTH, DAY,  HOUR
      INTEGER       MINU
      REAL          SECO, TMWIN
      REAL          pi       , ctrlat  , ctrlong 
      REAL          stlat(20), stlong(20), stelev(20)
      REAL          smprate
      REAL          array(99,99)     !  used for contouring
      REAL          xm, ym      ! requre subrautine xscursr pos of mouse
      REAL          xdim, ydim  ! scaling for subautine 'contour'
      CHARACTER     LEVNUM*1    ! indicator to plott level numbers
      CHARACTER     TEXT1*10    ! to read from key bord

c     variables for subroutine SLBBFK

      COMPLEX*8     CLXBUF(10000)
      REAL*4        CHNDAT(200000), DELTA(20), START(20)
      REAL*4        STOP(20)  , FRQLOW
      REAL*4        FRQHIG   , SLWMAX   , ALPHA
      REAL*4        BETA     , THETA
      REAL*4        WRKBUF(20000), APPVEL     , AZIMUT
      REAL*4        SXMAX    , SYMAX
      REAL*4        XCOORD(20), YCOORD(20), ZCOORD(20)
      REAL*4        OUTLOW   , OUTHIG
      REAL*4        POWER    , ABSPOW
      REAL*4        SLX(10000)      , SLY(10000)
      INTEGER*4     CHNPTR(20), CHNPTS(20), NCHAN
      INTEGER*4     GRDPTS   , WRKDIM
      INTEGER*4     CLXDIM   , IFKQ     , TYPCTL
      CHARACTER     IDENT(20)*10 , INSTR*8    , ERRMSG*70
      CHARACTER     TEXT*10
      logical exist,pc,sun,linux
      character*1 modelc
      include 'version.inc'
      include 'winplot2.inc'    !     dummy for SUN, related to graphics

c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)

      pi=4.*ATAN(1.)

      TYPCTL=0          ! Verbosity level
      modelc='0'        ! use STATION0.HYP as default


c----
c      read data from 'waveform.out'
c----

111   continue
      wav_filename(1)='waveform.out'
c
c   check if file is there
c
      inquire(file='waveform.out',exist=exist)
      if(.not.exist) then
         write(6,*)' File waveform.out not present, file might not'
         write(6,*)' have been generated properly by mulplt'
         if(pc) then
            write(6,*)' Return to stop'
            read(5,'(a)') text1
         endif
         stop
      endif
c
c  read header 
c
      call wav_init
      call read_wav_header(1)
      if(wav_error_message.ne.' ') then
         write(6,'(1x,a)') wav_error_message
         if(pc) then
           write(6,*) ' Return to stop'
           read(5,'(a)') text1
         endif
         stop  
      endif

      nchan=wav_nchan

c
c set date and time
c
      year=wav_year(wav_first)
      month=wav_month(wav_first)
      day=wav_day(wav_first)
      hour=wav_hour(wav_first)
      minu=wav_min(wav_first)
      seco=wav_sec(wav_first)

c---
c   read all channels
c---

       CHNPTR(1)=1           ! pointer of the first element of data array

 222   continue              ! from below, read again with different stat file

       DO n=1,nchan

        call wav_read_channel(n)

        if (n.eq.1) then
           tmwin=wav_duration(n)
           write(*,*) year,month,day,hour,minu,seco,tmwin
        endif
        IDENT(n) = wav_stat(n)(1:5) // wav_comp(n)(1:4)

        CHNPTS(n)=wav_nsamp(n)
        DELTA(n)=1/ANINT(wav_rate(n))
        START(n)=0
        STOP(n)=wav_duration(n)
        CHNPTR (n+1)=CHNPTR(n)+CHNPTS(n)

        IF (DELTA (1).NE.DELTA (n)) THEN    ! Checks if samlpe rate is the same
          WRITE (6,*) 'CHANEL ',IDENT(n),' HAS A DIFFERENT SAMPLE RATE'
        ENDIF

        DO i=CHNPTR(n), CHNPTR(n)+CHNPTS(n)-1
          CHNDAT(i)=signal1(i-CHNPTR(n)+1)
        ENDDO
c----
c    looking for station coordinates
c----
        call stat_loc(wav_stat(n),modelc,stlat(n),stlong(n),
     *  stelev(n))
        if(stlat(n).eq.0.0.and.stlong(n).eq.0.0) then
           write(6,'(1x,a,a)') 
     *   ' Station not found in STATION0.HYP file ',wav_stat(n)
         write(6,*)' Do you want to try another station file, if so'
         write(6,*) ' enter character in station file (STATION?.HYP) '
         write(6,*) ' else return to stop ********************'
         read(5,'(a1)') modelc
         if (modelc.eq.'') then
           stop
         else
           goto  222          ! read again from above
         endif
        endif
        ZCOORD (n)=stelev(n)

        XCOORD(n)=2*pi*6371*1000/360*COS(stlat(1)*2*pi/360)
     +  *(stlong(n)-stlong(1))
        YCOORD(n)=2*pi*6371*1000/360*(stlat(n)-stlat(1))

        IF (TYPCTL.GT.2) THEN
          WRITE(6,*)
          write(6,*) 'NUMBER OF CHANEL  ', n
c          WRITE(6,*) 'HEADER OF CHANEL  '
c          WRITE(6,*)  chead(1:75)
          WRITE(6,*) 'COORDINATES OF CHANEL (lat, long, elev.)'
          WRITE(6,*) stlat(n), stlong(n), stelev(n)
          WRITE(6,*) 'RELETIVE CHN. COORDINATES (m)',XCOORD(n),
     +                YCOORD(n)
          write(6,*) 'CHNPTR ', CHNPTR(n), ' CHNPTS ', CHNPTS(n)
          write(6,*) 'DELTA ', DELTA (n), ' START ', START (n),
     +               ' STOP ', STOP (n)
c         write(6,*) 'SIG', (signal(k),k=1,5)
c         write(6,*) 'DAT', (CHNDAT(k),k=CHNPTR(n),CHNPTR(n)+4)
       ENDIF

       ENDDO

       CHNPTR(n)=0       ! to remove pointer of unexist chanel

C----
C   Assigning coordinates of the first chanel as a reference coordinates
C----

      ctrlat = stlat(1)
      ctrlong = stlong(1)

      INSTR='VERTICAL'

c      close(22)

C----
C   Enter parameters from keybord
C----

      WRITE(6,*) 'Enter lower frequency,<ENTER> for default value 1 Hz'
      READ (5,'(a)') TEXT
      IF ( TEXT.EQ.' ') THEN
        FRQLOW=1.0
        GOTO 20
      ELSE
        READ ( TEXT,*,ERR=40) FRQLOW
        GOTO 20
      ENDIF    

40    WRITE (6,*) 'Bad entry, lower frequency=1 Hz'
      FRQLOW=1.0


20    WRITE(6,*)'Enter higher frequency,<ENTER> for default value 5 Hz'
      READ (5,'(a)') TEXT
      IF ( TEXT.EQ.' ') THEN
        FRQHIG=5.0
        GOTO 35
      ELSE
        READ ( TEXT,*,ERR=30) FRQHIG
        GOTO 35
      ENDIF

30    WRITE (6,*) 'Bad entry, higher frequency=5 Hz'
      FRQHIG=5.0

35    CONTINUE

      WRITE(6,*) 'Enter max slownes, <ENTER> for default value 0.4 s/km'
      READ (5,'(a)') TEXT
      IF ( TEXT.EQ.' ') THEN
        SLWMAX=0.4
        GOTO 60
      ELSE
        READ ( TEXT,*,ERR=65) SLWMAX
        GOTO 60
      ENDIF
65    WRITE (6,*) 'Bad entry, max slownes=0.4 s/km)'
      SLWMAX=0.4

60    CONTINUE

      WRITE(6,*) 'Enter No of grid points, <ENTER> for default value 51'
      READ (5,'(a)') TEXT
      IF ( TEXT.EQ.' ') THEN
        GRDPTS=51
        GOTO 70
      ELSE
        READ ( TEXT,*,ERR=75) GRDPTS
        GOTO 70
      ENDIF
75    WRITE (6,*) 'Bad entry, No of grid points=51'
      GRDPTS=51

70    CONTINUE

      WRITE(6,*) 'Do you want to plot level numbers, N/Y, <ENTER>=Y'
      READ (5,'(a)') TEXT
      IF ( TEXT.EQ.'n'.OR.TEXT.EQ.'N') THEN
        LEVNUM='N'
        GOTO 80
      ENDIF
      LEVNUM='Y'
     
80    CONTINUE

      THETA=90.0

      ALPHA=10

      BETA=10

C     WRITE(6,*) FRQLOW, FRQHIG, SLWMAX, GRDPTS

c     Calculation of CLXDIM
c
c     NFFT comes from SLFOUT 
c     NFFT have to be larger than INTPTS(I), number of points 
c     of physical sequence for each chanel, and NFFT have to
c     be pover of 2.
c     As INTPTS(I) .LE. CHNPTS(I), therefore INTPTS(I)=CHNPTS(I)

      NFFT =  8

      DO i=1, NCHAN
 
2     CONTINUE
         IF ( NFFT .GE. CHNPTS(i) ) THEN
            GO TO    3
         ELSE
            NFFT = NFFT * 2 
            GO TO  2
         ENDIF
3     CONTINUE


         IF ( i .EQ. 1) THEN
            CFTPTR (i) = 1
         ELSE
           cftptr(i) = cftptr( i-1 ) + cftpts( i - 1 )
         ENDIF
         CFTPTS (i) = NFFT / 2 + 1
         CLXDIM=cftptr(i) + cftpts(i)
      END DO

c     Calculation of WRKDIM
c
c     Normaly WRKDIM has to be =GRDPTS**2+GRDPTS/2
c     but in case peases of seismograms are long
c     WRKDIM has to be =NFFT*2, requirement from SLFOUT

      WRKDIM=GRDPTS*GRDPTS+GRDPTS/2

      IF (NFFT*2.GT.(GRDPTS*GRDPTS+GRDPTS/2)) THEN
       WRKDIM=NFFT*2
      END IF


      WRITE(6,*) 'It will take some time ...'

      call SLBBFK ( CHNDAT, CHNPTR, CHNPTS, DELTA , START ,
     +              STOP  , IDENT , INSTR , FRQLOW, FRQHIG,
     +              XCOORD, YCOORD, ZCOORD, SLWMAX, NCHAN ,
     +              ALPHA , BETA  , THETA , GRDPTS, WRKBUF,
     +              WRKDIM, CLXBUF, CLXDIM, APPVEL, AZIMUT,
     +              SXMAX , SYMAX , OUTLOW, OUTHIG, POWER ,
     +              ABSPOW, IFKQ  , ERRMSG, TYPCTL, SLX   ,
     +              SLY)

C   OUTPUT

      WRITE (6, 210) APPVEL, INT(AZIMUT)
210   FORMAT (' APPARENT VELOCITY  ',F5.2,
     +        '   AZIMUTH          ',I3)
      WRITE (6, 220) POWER, ABSPOW
220   FORMAT (' NORM. POWER MAX    ',F5.2, 
     +        '   POWER MAX IN dB  ',F5.2)  
      WRITE (6, 230)  SXMAX,  SYMAX
230   FORMAT (' MAX X SLOWNESS     ',F5.2,
     +        '   MAX Y SLOWNESS   ',F5.2)
      WRITE (6, 240) OUTLOW, OUTHIG
240   FORMAT (' LOW FREQUENCY      ',F5.2,
     +        '   HIGH FREQUENCY   ',F5.2)
      WRITE (6, *) 'QUALITY (1=best, 4=worst)', IFKQ
      IF (ERRMSG.NE.' ') THEN
        WRITE (6, *) 'ERROR MESSAGE ', ERRMSG
      ENDIF
c      WRITE (6, *) 'IRC ',    IRC


C----
CAP   Draw contours
C----
      xdim=1.3     ! scaling for 'contour'
      ydim=1.3     ! see in 'contour'

C                  Transfer data from WRKBUF to ARRAY used by Contor
      n=1
      DO i=1, GRDPTS
        DO k=1, GRDPTS
         ARRAY(i,k)= WRKBUF(n)
         n=n+1 
        ENDDO
      ENDDO


c----
c  set defaults for output on screen and one hardcopy file
c----
             open(65,file='fk.eps',status='unknown')
             plotunit=65
             plotoption=1
             hctype=1
             wsize=60


      call open_display

c----
c set some postscipt scalings
c----
           write(65,*) ' 1.0 0.55 scale'



      call CONTOR (GRDPTS , GRDPTS , ARRAY  , SLWMAX  ,
     +             SXMAX  , SYMAX  , AZIMUT , APPVEL ,
     +             POWER, LEVNUM, OUTLOW, OUTHIG,
     +             YEAR, MONTH, DAY, HOUR, MINU, SECO,
     +             NCHAN, IDENT, xdim, ydim, TMWIN)


c----
c   close postscript
c----

           call close_post

c----
c   close output plot file
c----
           close(65)

C---
C     STARTS WRITING OUTPUT FILE
C---
      open(2, file='fk.out',status='unknown')

      WRITE(2,250) year,month,day,hour,minu,seco,tmwin
250   FORMAT(1X,'DATE, TIME AND WINDOW LENGTH',4X,
     *i4,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3,1x,f8.3)

      WRITE (2, 210) APPVEL, INT(AZIMUT)
      WRITE (2, 220) POWER, ABSPOW
      WRITE (2, 230)  SXMAX,  SYMAX
      WRITE (2, 240) OUTLOW, OUTHIG
      WRITE (2, *) 'QUALITY (1=best, 4=worst)', IFKQ
      IF (ERRMSG.NE.' ') THEN
        WRITE (2, *) 'ERROR MESSAGE ', ERRMSG
      ENDIF


112   call xscursr(i,xm,ym)

            
      IF (i.eq.113.or.i.eq.81) THEN       ! Checck if Q
        GOTO 50
      ENDIF

      if (char(i).eq.'#') goto 112

      IF(i.eq.114.or.i.eq.82) THEN       ! check if R
        call clear_to_alpha
        CLOSE(2)
        GOTO 111
      ENDIF

      IF (i.eq.109.or.i.eq.77.or.i.eq.32) THEN   ! check if M
         SXMAX=((xm/520)-0.5)/xdim
         SYMAX=((ym/390)-0.5)/ydim

         IF (SXMAX.lt.0.0.or.SXMAX.gt.1.0) THEN
            GOTO 112
         ENDIF

         IF (SYMAX.lt.0.0.or.SYMAX.gt.1.0) THEN
            GOTO 112
         ENDIF

         SXMAX=(SXMAX-0.5)*2*SLWMAX
         SYMAX=(SYMAX-0.5)*2*SLWMAX

         AZIMUT=90-ATAN(SYMAX/SXMAX)/(2*pi)*360
         IF (SXMAX.lt.0.0) THEN
           AZIMUT=AZIMUT+180
         ENDIF
         APPVEL=1/SQRT(SXMAX*SXMAX+SYMAX*SYMAX)

         WRITE (TEXT(1:5),'(I3)') INT(AZIMUT)
         call contxmess ('MAN',1,3,0.4,-0.22)
         call contxmess (TEXT,1,5,0.5,-0.22)
         WRITE (TEXT(1:5),'(F5.2)') APPVEL
         call contxmess ('MAN',1,3,0.4,-0.27)
         call contxmess (TEXT,1,5,0.5,-0.27)
         GOTO 112
      ENDIF

      IF (i.eq.115.or.i.eq.83) THEN       ! check if S
        WRITE(2,'(A15)') ' VALUES TO SAVE:    ' 
        WRITE(2, 210) APPVEL, INT(AZIMUT)
        GOTO 280
      ENDIF


50    call clear_to_alpha

      write(6,*)' Plot file is fk.eps'

      WRITE(2,*)'VALUES TO SAVE:    '
                    
280   WRITE(2,*) 'Station         Long       Lat   Elev'//
     +'    Xcoord    Ycoord Zcoord'

      DO n=1, NCHAN

        WRITE(2,260) IDENT(n), stlong(n), stlat(n), 
     +  INT(stelev(n)),INT(XCOORD(n)), INT(YCOORD(n)),
     +  INT(ZCOORD(n))
260     FORMAT(1X, A10, F10.5, 1X, F9.5, 1X, I6, 1X,
     +          I9, 1X, I9, 1X, I6)
         
      END DO

      WRITE(2,'(A )') ' XSLOW   YSLOW  POWER'

      DO i=1, WRKDIM
      IF (SLX(i).EQ.0 .AND. SLY(i).EQ.0 .AND. 
     +    WRKBUF(i).EQ.0) THEN
        GO TO 100
      ELSE
        WRITE (2,'(1X, F5.2,3X, F5.2,2X, F5.3)')
     +    SLX(i), SLY(i), WRKBUF(i)
      END IF
      END DO

100   CONTINUE


      CLOSE(2)

      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c-----
c fk analysis subroutines 
c-----

      SUBROUTINE SLBBFK ( CHNDAT, CHNPTR, CHNPTS, DELTA , START ,
     +                    STOP  , IDENT , INSTR , FRQLOW, FRQHIG,
     +                    XCOORD, YCOORD, ZCOORD, SLWMAX, NCHAN ,
     +                    ALPHA , BETA  , THETA , GRDPTS, WRKBUF,
     +                    WRKDIM, CLXBUF, CLXDIM, APPVEL, AZIMUT,
     +                    SXMAX , SYMAX , OUTLOW, OUTHIG, POWER ,
     +                    ABSPOW, IFKQ  , ERRMSG, TYPCTL, SLX   ,
     +                    SLY)

      COMPLEX*8     CLXBUF(*)
      REAL*4        CHNDAT(*), DELTA(*) , START(*) , STOP(*)  , FRQLOW
      REAL*4        FRQHIG   , SLWMAX   , ALPHA    , BETA     , THETA
      REAL*4        WRKBUF(*), APPVEL   , AZIMUT   , SXMAX    , SYMAX
      REAL*4        XCOORD(*), YCOORD(*), ZCOORD(*), OUTLOW   , OUTHIG
      REAL*4        POWER    , ABSPOW
      REAL*4        SLX(*)   , SLY(*)
      INTEGER*4     CHNPTR(*), CHNPTS(*), NCHAN    , GRDPTS   , WRKDIM
      INTEGER*4     CLXDIM   , IFKQ     , TYPCTL, XDB
      CHARACTER*(*) IDENT(*) , INSTR    , ERRMSG
C.======================================================================
C.    PURPOSE
C     slbbfk                                                        SS<<
C     To calculate wide-band slowness estimates
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C     Parameters:
C
C..   CHNDAT - Array of data
C
C..   CHNPTR - Pointer of start of each channel in CHNDAT
C
C..   CHNPTS - points for each channel
C
C..   DELTA  - Sampling interval for each channel
C
C..   START  - Start of analysis interval (seconds), if analysis
C              window .eq. the full data window => START = 0.0
C
C..   STOP   - Stop of analysis interval (seconds), if analysis
C              window .eq. the full data window => STOP = CHNPTS*DELTA
C
C..   IDENT  - Channel identification (A0Z, A0N, A0E, C1Z, C2Z,...)
C
C..   INSTR  - If 'VERTICAL', then only vertical sensors processed,
C
C              if '3COMP', three-comp. processing of P-waves.
C
C..   FRQLOW - Lower frequency limit
C
C..   FRQHIG - Higher frequency limit
C
C..   XCOORD - Relative X-coordinate (EW) of channel in meters
C
C..   YCOORD - Relative Y-coordinate (NS) of channel in meters
C
C..   ZCOORD - Elevation of channel in meters
C
C..   SLWMAX - Maximum slowness in search
C
C..   NCHAN  - channels to process
C
C..   THETA  - Angle of incidence for elevation correction, if THETA
C
C              is set to 90.0 ==> no elevation correction with THETA
C
C..   ALPHA  - local P-wave velocity, if known and THETA not set,
C              
c              used for P-phase elevation corrections. Unknow mean any 
c
c              value larger than 10 km/s.
C
C..   BETA   - local S-wave velocity, if known and THETA not set,
C              
c              used for S-phase elevation corrections. Unknow mean any 
c
c              value larger than 10 km/s.
C
C..   GRDPTS - points in one slowness search row.
C
C..   WRKDIM - dimension of WRKBUF, should be .GE. GRDPTS**2 + GRDPTS/2
C
C..   CLXBUF - complex work array for storing fourier transforms
C
C..   CLXDIM - dimension of CLXBUF, should be .GT. (NFFT/2 + 1)*NCHAN
C
C..   TYPCTL - Verbosity level,i.e. 0=no printout(terminal),1,2,3
C              more details.
C
C
C.    OUTPUT
C..   WRKBUF - array of power estimates in slowness space, stored in
C
C              standard lexicographical order
C
C..   APPVEL - Apparent velocity of power maximum, interpolated.
C
C..   AZIMUT - Azimuth of power maximum, interpolated
C
C..   SXMAX  - Horizontal slowness Sx of power maximum, interpolated
C
C..   SYMAX  - Horizontal slowness Sy of power maximum, interpolated
C
C..   OUTLOW - Corrected lower frequency
C
C..   OUTHIG - Corrected higher frequency
C
C..   POWER  - Normalized power maximum
C
C..   ABSPOW - Power maximum in dB, comparable to narrow-band F-K
C
C..   IFKQ   - F-K quality measure (see FKQUAL FORTRAN)
C
C..   ERRMSG - Error message
C
C..   IRC    - Return code
C            = 0  No error
C            = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Tormod Kvaerna
C.    CREATION_DATE December 1, 1986
C.    MADE_AT       NTNF/NORSAR
C                   Pb. 51
C                   N-2007 Kjeller
C
C.    MODIFICATION  June 6, 1988
C                   June 6, 1988: Implementation of quality measure
C                   Nov   , 1988: Trying to increase performace. Jan Fyen
C
C                   Oct 26, 1994: Changes for elevation corrections. JS
C.    CORRECTION    Nov 18, 1994
C                   Nov 18, 1994: ABSPOWER in 3comp-case corrected. JS
C.======================================================================
C
C     COMMENT:
C
C=======================================================================
 
C----
C   Internal declarations
C----
 
      PARAMETER ( NDIM = 100 )
 
      COMPLEX*8 CSPEC        , CTEMP       , CARR(NDIM), QDIR(3)
      REAL*8    DOTPOW       , DTEMP       , DTEMP1
      REAL*8    DBLTMP
      REAL*4    XX(NDIM)     , YY(NDIM)    , ZZ(NDIM), XREF, YREF, ZREF
      REAL*4    FARR (NDIM)  , WC(2)
      REAL*4    GSCAL, GSCAL1, PI2, PI, VEL0, TEMP0, TEMP4
      INTEGER*4 INTPTR (NDIM), INTPTS(NDIM), CFTPTR(NDIM) , INDCH(NDIM)
      INTEGER*4 CFTPTS (NDIM), IERR        , LIMIT        , CENTER
      LOGICAL   INHOM
      CHARACTER*1 COMP
 
C---
C JF set default output values for errors in fk-results.
C---
      SYMAX  = 0.0
      SXMAX  = 0.0
      AZIMUT = 0.0
      APPVEL = 999.8
      POWER  = 0.01
      ABSPOW = 0.01
      OUTLOW = FRQLOW
      OUTHIG = FRQHIG
      IFKQ   = 5
C---
      ERRMSG = ' '
      WC(1)  = 0.0
      WC(2)  = 0.0
C j.s. PI     = 3.14159265
      PI     = 4.* atan(1.)
      TWOPI  = 2.0*PI
      PI2    = PI / 2.
      TEMP0  = 0.
      GSCAL1 = 0.
      LIMIT  = GRDPTS / 2
      CENTER = LIMIT + 1
c---
c JF 95/06/01 : I tried to figure out why deltas is negative and
c               found after some trials that Sx, Sy does not follow
c               the slowness coordinates for FK plot. I.e. SX is NOT
c               positive towards east. It actually follow the direction
c               of the wave, just like NORSAR UX,UY slowness coordinates.
c               I.e.  a slowness vector with positive XSX and positive YSY
c               components, points towards south-west.
c---
      DELTAS = -SLWMAX / FLOAT (LIMIT)
      THETEN = THETA * PI / 180.0
CJF
      COSTHE = COS(THETEN)
      SINTHE = SIN(THETEN)
      IF( SINTHE .LE. 0.0  ) THEN
          WRITE(ERRMSG,'(2X,''***> SLBBFK Sin(THETA)  '',2F10.3)')
     +                        SINTHE,THETA
          RETURN
      END IF
      TANTHE = COSTHE/SINTHE
CJF
 
      IF( TYPCTL.GT.0 ) THEN
          WRITE(6,'(2X,''---> SLBBFK Clear WRKBUF'',I6)') WRKDIM
          WRITE(6,'(7X,''Points,center,deltas'',2I5,E14.6)')
     +              GRDPTS,CENTER,DELTAS
      END IF
      IF( FRQLOW.LE.0.0.OR.
     +    FRQHIG.LE.0.0.OR.
     +    FRQHIG.LE.FRQLOW ) THEN
          WRITE(ERRMSG,'(2X,''***> SLBBFK Wrong freq  '',2F10.3)')
     +                        FRQLOW,FRQHIG
          RETURN
      END IF
 
      CALL CHZERO ( WRKBUF(1), WRKDIM )
 
C----
C   Prepare input to fourier transform calculation
C----

      CALL SLSUBI ( NCHAN , CHNPTR, NCHAN , CHNPTS, NCHAN , START ,
     +              NCHAN , STOP  , NCHAN , NDIM  , INTPTR, INTPTS,
     +              DELTA , ERRMSG, IERR  , TYPCTL )

      IF ( ERRMSG .NE. ' ' ) THEN
 
         RETURN
 
      ENDIF
 
C----
C   Fourier transform calculation
C----

      CALL SLFOUT ( CHNDAT, NCHAN , INTPTR, NDIM  , INTPTS, NDIM  ,
     +              WRKBUF, WRKDIM, CLXBUF, CLXDIM, CFTPTR, NDIM  ,
     +              CFTPTS, NDIM  , ERRMSG, IERR  , TYPCTL )
 
      IF ( ERRMSG .NE. ' ' ) THEN

         RETURN
 
      ENDIF
 
      IF( TYPCTL.GT.0 ) THEN
          WRITE(6,'(2X,''---> SLBBFK Clear WRKBUF'',I6)') WRKDIM
      END IF
      CALL CHZERO ( WRKBUF(1), WRKDIM )
 
C----
C   Calculate centroid of channels
C----
 
      CALL SLCENT ( XCOORD, YCOORD, ZCOORD, XREF, YREF, ZREF, NCHAN )
 
C----
C   Store corrected coordinates in tables
C----
 
      DO 1000 ICHAN = 1, NCHAN
 
         XX(ICHAN) = ( XCOORD(ICHAN) - XREF ) / 1000.0
         YY(ICHAN) = ( YCOORD(ICHAN) - YREF ) / 1000.0
         ZZ(ICHAN) = ( ZCOORD(ICHAN) - ZREF ) / 1000.0
 
	 IF ( INSTR .EQ. '3COMP' ) THEN
C---
C Choose what component from last character of name being 'z','n','e'.
C---

C
C AP Next line is changed, old: NC    = IC0LEN(IDENT(ICHAN))
C

            NC    = LEN(IDENT(ICHAN))
            COMP  = IDENT(ICHAN)(NC:NC)

            IF( COMP.EQ.'z' .OR. COMP.EQ.'Z' ) THEN
	        INDCH(ICHAN) = 1

            ELSE IF( COMP.EQ.'n' .OR. COMP.EQ.'N' ) THEN
	        INDCH(ICHAN) = 2

            ELSE IF( COMP.EQ.'e' .OR. COMP.EQ.'E' ) THEN
	        INDCH(ICHAN) = 3

            ELSE 
 
                ERRMSG = '***> SLBBFK (3-comp): Illegal channel '//
     +                           'id '
                ERRMSG(43:50) = IDENT(ICHAN)(1:8)
 
                RETURN
 
            ENDIF

         ENDIF
 
 1000 CONTINUE
 
C----
C   Calculate start and stop points of FFT from low and high
C   frequency bounds, assuming all channels to have same sampling rate
C----
 
      XNFFT   = 2.0*FLOAT(CFTPTS(1) - 1)
      K1      = IFIX ( (DELTA(1) * FRQLOW * XNFFT ) + 1.001)
      K2      = IFIX ( (DELTA(1) * FRQHIG * XNFFT ) + 1.001)
 
      THLP    = TWOPI / ( ( XNFFT ) * DELTA(1) )
 
      IF ( K1 .LT. 1 ) THEN
 
         K1 = 1
 
      ENDIF
 
      IF ( K2 .GT. CFTPTS(1) ) THEN
 
         K2 = CFTPTS(1)
 
      ENDIF
 
      OUTLOW  = FLOAT (K1 - 1) * THLP / TWOPI
 
      OUTHIG  = FLOAT (K2 - 1) * THLP / TWOPI
      IF( TYPCTL.GT.0 ) THEN
          WRITE(6,'(2X,''...> SLBBFK K1,K2'',2I5,F7.1,F9.3)')
     +                        K1,K2,XNFFT,THLP
          WRITE(6,'(2X,''...> SLBBFK Outlow,high'',2F9.3)')
     +                        OUTLOW,OUTHIG
      END IF
 
      DOTPOW = 0.0D0
 
      DO 1200 IFRQ = K1, K2
 
         IFRQ1 = IFRQ - 1
         DO 1100 ICHAN = 1, NCHAN
 
            IND    = CFTPTR(ICHAN) + IFRQ1
            DBLTMP = CABS( CLXBUF(IND) )
            DOTPOW = DOTPOW + DBLTMP*DBLTMP

 1100    CONTINUE
 
 1200 CONTINUE
 
C----
C   Scaling factor
C----
 
      DTEMP1 = ( DFLOAT (NCHAN) * DOTPOW )
      IF( TYPCTL.GT.0 ) THEN
          WRITE(6,'(2X,''...> SLBBFK Scale DTEMP1,DOTPOW,N'',
     +              2E14.6,I4)')
     +              DTEMP1,DOTPOW,NCHAN
      END IF
C---
C  JF : for bad data, DOTPOW and DTEMP1 may turn zero.
C---
      IF( DTEMP1.LE.0.0.OR.DOTPOW.LE.0.0 ) THEN
          ERRMSG = '***> SLBBFK zero dot power (bad data)'
 
          RETURN
 
      END IF
C----
C   Now, do the calculation for vertical sensors
C----
 
      IF ( INSTR (1:8) .EQ. 'VERTICAL' ) THEN
 
C----
C   Loop over Sy
C----
 
         DO 3000 I = -LIMIT, LIMIT
 
            YSY = FLOAT(I) * DELTAS
            YS2 = YSY*YSY
C----
C   Loop over Sx
C----
 
            DO 2900 J = -LIMIT, LIMIT
 
               XSX = FLOAT(J) * DELTAS
 
C----
C   Time element of phase lag (with or without elevation corrections)
C----
 
               VINV = SQRT ( YS2 + (XSX*XSX) )
 
CJF            TEMP = VINV*COS(THETEN) / SIN(THETEN)
C----
CJS            TEMP = VINV*TANTHE
C
C   Johannes Schweitzer 26. Oct. 1994
C   Elevation phase correction included for all cases.
C
C   Assuming that ALPHA and BETA give local velocity 
C   under the array then THETA and the corresponding 
C   elevation correction can be calculated.
C
C   If incidenc angle THETA (i.e. THETA.ne.90 deg) is given, 
C   this value is used anyway.
C----

               IF ( THETA.GE.90. .AND. (ALPHA.LT. 10. .OR. 
     +	            BETA.LT. 10.)) THEN

		  VEL0 = 999. 

                  IF(ALPHA.LT. 10.)    VEL0 = ALPHA

	          IF(VINV.GT.1./VEL0 .AND. BETA.LT. 10.) 
     +                                 VEL0 = BETA

	          IF(VINV.GE.1./VEL0)  THEN
		     TEMP = 0.
		  ELSE
	             THETEN = ASIN (VEL0 * VINV)
                     TEMP = COS ( THETEN ) / VEL0
		  ENDIF

               ELSE

		  TEMP = VINV*TANTHE

               ENDIF
 
C----
C   Store coordinate phase contribution in tables
C----
 
               DO 2100 JK = 1, NCHAN
 
                  FARR (JK) = ( (XSX * XX (JK) ) + (YSY * YY (JK) ) ) +
     +                        TEMP * ZZ(JK)
 
 2100          CONTINUE
 
C----
C   Loop over angular frequency
C----
 
               DTEMP = 0.0D0
 
               DO 2300 K = K1, K2
 
                  OMEGA = THLP * FLOAT (K - 1)
 
C----
C   Loop over channels
C----
 
                  CTEMP = CMPLX (0.0, 0.0)
 
                  DO 2200 L = 1, NCHAN
 
                     ARG   = OMEGA * FARR(L)
 
                     CSPEC = CMPLX ( COS(ARG), SIN(ARG) )
 
                     IND   = CFTPTR(L) + K - 1
 
                     CTEMP = CTEMP + CLXBUF(IND) * CSPEC
 
2200              CONTINUE
 
                  DBLTMP = CABS (CTEMP)
                  DTEMP  = DTEMP + DBLTMP*DBLTMP
 
2300           CONTINUE
 
C----
C   And now, store the final value
C----
 
               I1 = J + CENTER + ( I + CENTER - 1 ) * GRDPTS
 
               WRKBUF (I1) = SNGL ( DTEMP / DTEMP1 )

C
C AP To store slowness values in arrays SLX, SLY 
C

               SLX (I1) = XSX

               SLY (I1) = YSY
 
               IF( TYPCTL.GT.6 .OR.
     +            (TYPCTL.GT.2 .AND.IABS(I).EQ.IABS(J))) THEN
                   VKM  = VINV
                   VANG = 0.0
                   IF( YSY.NE.0.0.AND.XSX.NE.0.0 ) VANG=ATAN2(XSX,YSY)
                   VANG = VANG*180.0/3.14159257
                   IF( VINV.NE.0.0 ) VKM = 1.0/VINV
                   WRITE(6,'(2X, 3I5,2F8.4,F7.3,F8.2,E14.6)')
     +                       I,J,I1,YSY,XSX,VKM ,VANG,DTEMP
               END IF
 
 
2900        CONTINUE
 
3000     CONTINUE
 
C----
C   Three-component method comes here
C----
 
      ELSE IF ( INSTR(1:5) .EQ. '3COMP') THEN

C----
C   Loop over Sy
C----
 
         DO 5000 I = -LIMIT, LIMIT
 
            YSY = FLOAT(I) * DELTAS
 
C----
C   Loop over Sx
C----
 
            DO 4900 J = -LIMIT, LIMIT
 
               XSX = FLOAT(J) * DELTAS
 
C----
C   Time element of phase lag (with or without elevation corrections)
C----
 
               VINV = SQRT ( (YSY*YSY) + (XSX*XSX) )
 
CJF            TEMP = VINV*COS(THETEN) / SIN(THETEN)
C----
CJS            TEMP = VINV*TANTHE
C
C   Johannes Schweitzer 26. Oct. 1994
C   Elevation phase correction included for all cases 
C
C   Assuming that ALPHA and BETA give local velocity 
C   under the array then THETA and the corresponding 
C   elevation correction can be calculated.
C
C   If incidenc angle THETA (i.e. THETA ne 90 deg) is given, 
C   this value is used anyway.
c----

               IF ( THETA.GE.90. .AND. (ALPHA.LT. 10. .OR. 
     +	            BETA.LT. 10.)) THEN
		
		  VEL0 = 999.

                  IF(ALPHA.LT. 10.)    VEL0 = ALPHA

	          IF(VINV.GT.1./VEL0 .AND. BETA.LT. 10.) 
     +                                 VEL0 = BETA

	          IF(VINV.GE.1./VEL0)  THEN
		     THETEN = PI2
		     TEMP = 0.
		  ELSE
	             THETEN = ASIN (VEL0 * VINV)
                     TEMP = COS ( THETEN ) / VEL0
		  ENDIF

               ELSE

		  TEMP = VINV*TANTHE
C----
C    Use ALPHA and BETA default values from NORESS if set 
C    (ever needed for 3comp fk!).
C----
CJF              IF (ALPHA.GE.999.) ALPHA = 6.0
CJF              IF (BETA .GE.999.) BETA  = 3.46

               ENDIF
 
C----
C   Call P-phase direction vector estimate for this slowness
C----
               INHOM = .TRUE.
	       TEMP4 = 0.
 
	       IF ( VINV .LE. 1./ALPHA ) THEN
                  CALL SLDIR3 ( XSX, YSY, ALPHA, BETA, QDIR, INHOM )
               ENDIF
 
               IF ( INHOM ) GO TO 4700

               GSCAL = 0.0

               DO 4400 JK = 1, NCHAN
 
                 IF ( INDCH(JK).EQ.1 ) THEN
 
                    CARR(JK) = QDIR(1)
                    GSCAL    = GSCAL + CABS ( (QDIR(1) )**2 )

                 ELSE IF ( INDCH(JK).EQ.2 ) THEN
 
                    CARR(JK) = QDIR(2)
                    GSCAL    = GSCAL + CABS ( (QDIR(2) )**2 )
 
                 ELSE IF ( INDCH(JK).EQ.3 ) THEN
   
                    CARR(JK) = QDIR(3)
                    GSCAL    = GSCAL + CABS ( (QDIR(3) )**2 )
 
                 ENDIF
 
C----
C   Store coordinate phase contribution in tables
C----
 
                 FARR (JK) = ( (XSX * XX (JK) ) + (YSY * YY (JK) ) ) +
     +                       TEMP * ZZ(JK)
 
4400           CONTINUE
 
C----
C   Loop over angular frequency
C----
 
               DTEMP = 0.0D0
 
               DO 4600 K = K1, K2
 
                  OMEGA = THLP * FLOAT (K - 1)
 
C----
C   Loop over channels
C----
 
                  CTEMP = CMPLX (0.0, 0.0)
 
                  DO 4500 L = 1, NCHAN

                     ARG   = OMEGA * FARR(L)
 
                     CSPEC = CMPLX ( COS(ARG), SIN(ARG) )
 
                     IND   = CFTPTR(L) + K - 1
 
                     CTEMP = CTEMP + CLXBUF(IND) * CSPEC*
     +                          CONJG ( CARR(L) )
 
4500              CONTINUE
 
                  DTEMP = DTEMP + DBLE(CABS(CTEMP))**2.0D0
 
4600           CONTINUE
 
               TEMP4 = SNGL (DTEMP / DOTPOW) / GSCAL

C----
C   To save the GSCAL of the MAXIMUM FK-result
C   (To get the right ABSPOW-value)
C   Johannes Schweitzer
C----
	       IF(TEMP4.GT.TEMP0) THEN

	         GSCAL1 = GSCAL
	         TEMP0  = TEMP4

	       ENDIF

C----
C   And now, store the final value
C----

4700           CONTINUE

               I1 = J + CENTER + ( I + CENTER - 1 ) * GRDPTS

               WRKBUF (I1) = TEMP4
 
4900        CONTINUE
 
5000     CONTINUE
 
      ENDIF
 
      IF( TYPCTL.GT.0 ) THEN
          WRITE(6,'(2X,''...> SLBBFK That took some time ...   '')')
      END IF
 
C----
C   Measure maximum of slowness matrix
C----
 
      CALL SLFKMS ( WRKBUF, GRDPTS, SLWMAX, WC, 1.0, SYMAX, SXMAX,
     +              AZIMUT, APPVEL, POWER )
 
C----
C   Calculate absolute power, analogue to narrow-band F-K
C----
 
      IF ( INSTR (1:8) .EQ. 'VERTICAL' ) THEN
         ABSPOW = POWER * SNGL(DTEMP1) / FLOAT(K2-K1+1)
 
      ELSE IF ( INSTR (1:5) .EQ. '3COMP' ) THEN
         ABSPOW = POWER * SNGL(DOTPOW)*GSCAL1 / FLOAT(K2-K1+1)
 
      ENDIF

      ABSPOW = ABSPOW / ( FLOAT (NCHAN*NCHAN) )
      ABSPOW = ABSPOW * DELTA(1) / ( FLOAT (INTPTS(1) ) )
 
      IF ( ABSPOW .GT. 0.0 ) THEN
         ABSPOW = 10.0 * ALOG10 (ABSPOW)
      ELSE
         ABSPOW = 0.0
      ENDIF
 
C----
C   Calculate F-K quality measure
C----
 
      IPOINT = (GRDPTS*GRDPTS) + 1
 
      XDB = 7.0
 
      CALL SLFKQA (WRKBUF, GRDPTS, POWER, XDB, WRKBUF(IPOINT), IFKQ )
 
C----
C   That's it|
C----
 
      RETURN
 
      END
      SUBROUTINE SLCENT (X, Y, Z, XREF, YREF, ZREF, NCHAN)
      REAL*4    XREF, YREF, ZREF
      REAL*4    X(1), Y(1), Z(1)
      INTEGER*4 NCHAN

C.======================================================================
C.    PURPOSE
C     Slcent                                                        SS<< 
C     This function returns the centroid of NCHAN given stations
C
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C..   X, Y, Z      - Coordinates of stations in meters
C
C..   NCHAN        - Number of channels
C
C
C
C.    OUTPUT
C..   XREF, YREF, ZREF - Coordinates of reference point in meters
C
C
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Tormod Kvaerna
C.    CREATION_DATE November 19, 1986
C.    MADE_AT       NTNF/NORSAR
C                   Pb. 51
C                   N-2007 Kjeller
C
C.    MODIFICATION
C.    CORRECTION
C.======================================================================
C.@PROCESS OPT(3)
C 
C.OPT(3)
C=======================================================================
C
C     COMMENT:
C
C=======================================================================
 
      XREF = 0.0
      YREF = 0.0
      ZREF = 0.0
 
      DO 100 I = 1, NCHAN
 
         XREF = XREF + X(I)
         YREF = YREF + Y(I)
         ZREF = ZREF + Z(I)
 
100   CONTINUE
 
      ZREF = ZREF / FLOAT (NCHAN)
      YREF = YREF / FLOAT (NCHAN)
      XREF = XREF / FLOAT (NCHAN)
 
      RETURN
 
      END
      SUBROUTINE SLDIR3 ( SX, SY, ALPHA, BETA, QDIR, INHOM )
      REAL*4      SX, SY, ALPHA, BETA
      COMPLEX     QDIR (3)
      LOGICAL     INHOM
C.======================================================================
C.    PURPOSE
C     sldir3                                                        SS<<
C     Subroutine to calculate direction vector for P- waves on a
C     3C - station. The direction vector is scaled to unity.
C
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C..   SX     - Horizontal wavenumber in EW-direction
C
C..   SY     - Horizontal wavenumber in NS-direction
C
C..   ALPHA  - Surface P-wave velocity
C
C..   BETA   - Surface S-wave velocity
C
C
C.    OUTPUT
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C
C..   QDIR   - Direction vectors for displacement
C
C..   QDIR(1)- Direction vector for Z-comp
C
C..   QDIR(2)- Direction vector for NS-comp
C
C..   QDIR(3)- Direction vector for EW-comp
C
C.----------------------------------------------------------------------
C.    PROGRAMMER    Tormod Kvaerna   
C.    CREATION_DATE 
C.    MADE_AT       NTNF/NORSAR
C                   Pb. 51
C                   N-2007 Kjeller
C
C.    MODIFICATION  
C.                  Restricted to P-wave slowness space.
C.                  Johannes Schweitzer, Novmeber 1994
C.    CORRECTION
C.======================================================================
C.@PROCESS OPT(3)
C.OPT(3)
C-----------------------------------------------------------------------
C
C
C
C
C
C----
 
 
 
 
 
C----
C   Declaration of internal variables
C----
 
 
      INHOM = .FALSE.
 
      IF ( (SX .LT. 0.0001) .AND. (SY .LT. 0.0001)   .AND.
     %     (SX .GT. -0.0001) .AND. (SY .GT. -0.0001) ) THEN
 
         QDIR (1) = CMPLX (1.0, 0.0)
         QDIR (2) = CMPLX (0.0, 0.0)
         QDIR (3) = CMPLX (0.0, 0.0)
 
      ELSE
 
C----
C   Calculate some terms
C----
 
         SXSY2    = SX**2 + SY**2
 
         P        = SQRT ( SXSY2 )
CJS      PLIMIT   = SQRT ( 1.0 / (2.0 * BETA * BETA) )
         PLIMIT   = 1.0 / P
 
C----
C   Ray parameter must be less than PLIMIT
C----
 
         IF ( P .LE. PLIMIT ) THEN
 
            PBETA2   = (P**2) * (BETA**2)
 
            TERM1    = (1.0 - 2.0*PBETA2)**2
 
            TERM2    = 4.0 * PBETA2 * (1.0 - PBETA2)
 
            TERM3    = 1.0 / ( SXSY2 * ( 1.0 + ( TERM1 / TERM2 ) ) )
 
            TERM4    = 1.0 / ( 1.0 + ( TERM2 / TERM1 ) )
 
            A        = SQRT (TERM3)
 
            TK1      = SQRT (TERM4)
 
            QDIR(1)  = CMPLX (TK1, 0.0)
 
            TK1      =  A * SY
 
            QDIR(2)  = CMPLX (TK1, 0.0)
 
            TK1      =  A * SX
 
            QDIR(3)  = CMPLX (TK1, 0.0)
 
         ELSE
 
            QDIR(1) = CMPLX (0.0, 0.0)
 
            QDIR(2) = CMPLX (0.0, 0.0)
 
            QDIR(3) = CMPLX (0.0, 0.0)
 
            INHOM = .TRUE.
 
         ENDIF
 
      ENDIF
 
C----
C   The correct vector is now hopefully calculated
C----
 
      RETURN
 
      END
      SUBROUTINE SLFFT(XREAL, XIMAG, N, IDIR)
      DIMENSION XREAL(1), XIMAG(1), TCOS(2049), TSIN(2049)
      DOUBLE PRECISION FUND, COSINE, SINE
C.======================================================================
C.    PURPOSE
C     Slfft                                                         SS<<
C     Program to compute the FFT of a sequence.
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C
C
C.    OUTPUT
C..   XREAL(*)        -   The real part of the sequence is stored in
C                         this array.
C..   XIMAG(*)        -   The imaginary part is stored here.
C..   TCOS(*),TSIN(*) -   Cosine and sine tables.
C..   N               -   The length of the sequence.
C..   LOGN            -   The base-two logarithm of N.
C..   IDIR            -   Variable to indicate the direction of the transform.
C                         For a forward transform IDIR=-1 and for an inverse
C                         transform IDIR=1.  Normalization is performed
C                         for IDIR=1.
C     The transform result is returned in XREAL and XIMAG.
C     The initial sequence is destroyed.
C
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Dave Harris
C.    CREATION_DATE 
C.    MADE_AT       Livermore, CA, USA 
C
C.    MODIFICATION  November 14, 1977
C.    CORRECTION
C.======================================================================
C.@PROCESS OPT(3)
C.OPT(3)
C---------------------------------------------------------------------
C
C - FFT
C
C----
 
 
      NBY2 = N/2
      LOGN = 1
    3 CONTINUE
        IF (  2**LOGN  .EQ.  N ) THEN
          GO TO    4
        ELSE
          LOGN = LOGN+1
        END IF
      GO TO    3
    4 CONTINUE
C----
C     Table generator
C----
      FUND = 3.141592653589793D0*2.0D0
      FUND = FUND/FLOAT(N)
      COSINE = DCOS(FUND)
      SINE = DSIN(FUND)
      IF (  IDIR .EQ. -1 ) THEN
        SINE = -SINE
      END IF
      TCOS(1) = 1.
      TSIN(1) = 0.
      DO    5 I = 2, NBY2
        TCOS(I) = COSINE*TCOS(I-1) - SINE*TSIN(I-1)
        TSIN(I) = COSINE*TSIN(I-1) + SINE*TCOS(I-1)
    5 CONTINUE
C----
C     Bit reverse code
C----
        NM1 = N-1
        J = 1
        DO    6 I = 1, NM1
        IF (  I .LT. J ) THEN
          TEMP = XREAL(I)
          XREAL(I) = XREAL(J)
          XREAL(J) = TEMP
          TEMP = XIMAG(I)
          XIMAG(I) = XIMAG(J)
          XIMAG(J) = TEMP
        END IF
        K = NBY2
    7   CONTINUE
        IF (.NOT.( K .LT. J )) GO TO    8
          J = J-K
          K = K/2
        GO TO    7
    8   CONTINUE
        J = J+K
    6   CONTINUE
C----
C     Indexing code
C----
        NBLOCK = N
        IREL = 1
        DO    9 NSTAGE = 1, LOGN
          IF (  NSTAGE .GT. 1 ) THEN
            IREL = IREL*2
          END IF
          I = -IREL
          NBLOCK = NBLOCK/2
          DO   10 IBLOCK = 1, NBLOCK
            I = I+IREL
            ITI = 1-NBLOCK
            DO   11 ICOUNT = 1, IREL
              I = I+1
              ITI = ITI+NBLOCK
              I1 = I+IREL
C----
C             Butterfly code
C----
              IF (  NSTAGE  .GT.  1 ) THEN
                SINE = TSIN(ITI)
                COSINE = TCOS(ITI)
                TEMP = XREAL(I1)*COSINE-XIMAG(I1)*SINE
                XIMAG(I1) = XREAL(I1)*SINE+XIMAG(I1)*COSINE
                XREAL(I1) = TEMP
              END IF
              TEMP = XREAL(I)+XREAL(I1)
              XREAL(I1) = XREAL(I)-XREAL(I1)
              XREAL(I) = TEMP
              TEMP = XIMAG(I)+XIMAG(I1)
              XIMAG(I1) = XIMAG(I)-XIMAG(I1)
              XIMAG(I) = TEMP
C
   11       CONTINUE
   10     CONTINUE
    9   CONTINUE
C----
C  If reverse transform, divide through by N
C----
        IF (  IDIR  .EQ.  1 ) THEN
          SCALE = 1./FLOAT(N)
          DO   12 I = 1, N
            XREAL(I) = XREAL(I)*SCALE
            XIMAG(I) = XIMAG(I)*SCALE
   12     CONTINUE
        END IF
C
C  BYE
C
      RETURN
      END
      SUBROUTINE SLFIT2(H, X, Y)
      DIMENSION H(-1:1, -1:1), PHI(0:2, 0:2)
C.======================================================================
C.    PURPOSE
C     Slfit2                                                     SS<<
C     Calculates parabolic refinement of estimated peak location from
C     grid values.
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C..   H  -   Input grid
C
C.    OUTPUT
C..   X  -   Peak location x coordinate
C..   Y  -   Peak location y coordinate
C
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Dave Harris.
C.    CREATION_DATE 
C.    MADE_AT       Livermore, CA, USA
C
C.    MODIFICATION  February 15, 1985 (NORSAR)
C                   November   , 1988 (Jan Fyen,performance)
C
C.    CORRECTION
C.======================================================================
C
C----
C.@PROCESS OPT(3)

CJF   INTEGER*4 SLBAS(9)
CJF   DATA SLBAS/1,-1,1,1,0,0,1,1,1/
C----
C  Construct correlations
C----

        DO   23 I = 0, 2
          I4       = I+4
          DO   24 J = 0, 2
            J4       = J+4
            PHI(I,J) = 0.
            DO   25 M = -1, 1
              MM = M*3
              DO   26 N = -1, 1
                PHI(I,J) = PHI(I,J) + H(M,N)*SLBAS(M,I)*SLBAS(N,J)
CJF             JFI      = MM+I4
CJF             JFJ      = 3*N+J4
CJF             PHI(I,J) = PHI(I,J) + H(M,N)*SLBAS(JFI)*SLBAS(JFJ)
C.Modified for performance
CJ.Fyen       M  I   SLBAS    N  J   SLBAS         (1+M)*3+I+1=  3M+I+4
C            -1**0   1       -1**0   1        1    1
C            -1**1  -1       -1**1  -1        2    2
C            -1**2   1       -1**2   1        3    3
C             0**0   1        0**0   1        4    4
C             0**1   0        0**1   0        5    5
C             0**2   0        0**2   0        6    6
C             1**0   1        1**0   1        7    7
C             1**1   1        1**1   1        8    8
C             1**2   1        1**2   1        9    9

   26         CONTINUE

   25       CONTINUE

   24     CONTINUE

   23   CONTINUE

        A = PHI(2,0)/2. - PHI(0,0)/3.
        B = PHI(1,1)/4.
        C = PHI(0,2)/2. - PHI(0,0)/3.
        D = PHI(1,0)/6.
        E = PHI(0,1)/6.

        DENOM = B**2 - 4.*A*C
        X = (2.*C*D - B*E)/DENOM
        Y = (2.*A*E - B*D)/DENOM

      RETURN
      END
C-----------------------------------------------------------------------
C
C----
CCC
      REAL FUNCTION SLBAS(N,I)


        IF (  I .EQ. 0 ) THEN

          SLBAS = 1.

        ELSE

          SLBAS = N**I

        END IF

      RETURN

      END

      SUBROUTINE SLFKMS(FKS, ISMPSZ, WAVNUM, WC,
     &                  FREQ, RKNMAX, RKEMAX, AZIM,
     &                  VAP, SMAX)
C.======================================================================
C.    PURPOSE
C     Slfkms                                                        SS<<
C     SLFKMS -- Code to find spectral FK maximum, then calculate
C               apparent velocity and bearing from its location.
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C..   FKS           -   REAL*4 array containing estimated FK spectrum
C
C..   SAMPLE_SIZE   -   INTEGER variable containing ^[ samples along
C                       each axis of FK spectrum.
C
C..   WAVENUMBER    -   REAL*4 variable containing maximum wavenumber
C                       along each axis, in cycles/kilometer.
C
C
C..   WINDOW_CENTER -   REAL*4 array containing the center of the FK
C                       window that is passed.  XY coordinates in
C                       wavenumber.
C
C..   FREQUENCY     -   REAL*4 variable containing analysis frequency.
C
C
C
C.    OUTPUT
C..   KN_MAX        -   REAL*4 variable containing north wavenumber
C                       of spectral maximum.
C
C..   KE_MAX        -   REAL*4 variable containing east wavenumber
C                       of spectral maximum.
C
C..   AZIMUTH       -   REAL*4 variable containing azimuth of event
C
C..   V_APPARENT    -   REAL*4 variable containing apparent velocity
C
C..   SPECTRAL_MAX  -   REAL*4 variable containing spectral maximum
C
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Dave Harris
C.    CREATION_DATE 
C.    MADE_AT       Livermore, CA, USA
C
C.    MODIFICATION  February 15, 1985 (NORSAR)
C                   November   , 1988 (Jan Fyen,performance)
C.    CORRECTION
C.======================================================================
C.@PROCESS OPT(3)
C.OPT(3)
C-----------------------------------------------------------------------
C
C
C  Replacements
C----
 
 
 
C----
C  Declarations
C----
        DIMENSION  FKS(1), H(-1:1, -1:1)
        INTEGER CENTER
        REAL*4 WC(2)
 
C----
C  Initializations
C----
 
        PI = 3.14159265
        LIMIT = ISMPSZ/2
        CENTER = LIMIT + 1
 
C----
C  Search for spectral maximum
C
C
C    Find wavenumber of spectral maximum
C----
 
          SMAX = 0.
          IMAX=0
          JMAX=0
 
          DO   19 I= -LIMIT, LIMIT
 
            KKC = CENTER + (I + CENTER - 1) * ISMPSZ
            DO   20 J= -LIMIT, LIMIT
 
              K = J + KKC
              VALUE = FKS(K)
 
              IF (  VALUE .GE. SMAX ) THEN
 
                IMAX=I
                JMAX=J
                SMAX = VALUE
 
              END IF
 
 
   20       CONTINUE
 
 
   19     CONTINUE
 
C----
C    Refine estimate if it is in the interior
C----
 
          DELTAK = WAVNUM/FLOAT(LIMIT)
 
          IF (  IABS(IMAX) .LT. LIMIT .AND. IABS(JMAX) .LT. LIMIT ) THEN
 
            DO   21 I = -1, 1
 
              KKJ = JMAX+CENTER + (IMAX+I+CENTER-1)*ISMPSZ
 
              DO   22 J = -1, 1
 
                K = J+KKJ
                H(I,J) = FKS(K)
 
   22         CONTINUE
 
   21       CONTINUE
 
            CALL SLFIT2(H, YINC, XINC)
 
            RKEMAX = (FLOAT(JMAX) + XINC)*DELTAK + WC(1)
            RKNMAX = (FLOAT(IMAX) + YINC)*DELTAK + WC(2)
 
          ELSE
 
            RKEMAX = DELTAK*FLOAT(JMAX) + WC(1)
            RKNMAX = DELTAK*FLOAT(IMAX) + WC(2)
 
          END IF
 
C----
C    Calculate azimuth and apparent velocity of event
C----
          AZIM = ATAN2(RKEMAX, RKNMAX)/PI*180.
          IF (  AZIM .LT. 0. ) THEN
            AZIM = AZIM + 360.
          END IF
          RADIUS = SQRT(RKNMAX*RKNMAX + RKEMAX*RKEMAX)
          VAP = FREQ/RADIUS
C----
C  Bye
C----
      RETURN
      END
C
 
      SUBROUTINE SLFKQA ( WRKBUF, GRDPTS, POWER , XDB, Z, IFKQ )
      REAL*4        WRKBUF(*), Z(*), POWER
      INTEGER*4     GRDPTS   , XDB, IFKQ
C.======================================================================
C.    PURPOSE
C     Slfkqa                                                        SS<<
C     To calculate F-K quality measure
C     This routine searches for peaks in WRKBUF matrix.
C     It scans the lexicographically stored matrix for for local
C     maxima within XDB dB of the largest peak.
C     The program assigns a quality measure IFKQ as a function of
C     the amplitude AMP of the second highest peak,
C     according to the following criteria.
C     6.0 \= AMP \<       :  IFKQ \= 1
C     4.0 \= AMP \< 6.0  :  IFKQ \= 2
C     1.0 \= AMP \< 4.0  :  IFKQ \= 3
C
C            AMP  1.0  :  IFKQ \= 3 if double peak (only one secondary
C                                             peak within 1.0 dB).
C            A double peak is characterized by the fact that the second
C            highest peak is less than 1 dB down from the maximum, and
C            the third highest peak is more than 1 dB down from the
C            maximum.  I.e., if more than two peaks within 1 dB,
C            the solution is bad.
C
C                       :  IFKQ \= 4 if bad solution
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C
C..   WRKBUF - Array of linear power estimates
C
C..   GRDPTS - points in one slowness search row
C
C..   POWER  - Linear power of maximum peak
C
C..   XDB    - Searching criterion for secondary peaks
C
C..   Z      - Work array (length at least 1600 elements)
C
C
C
C.    OUTPUT
C..   IFKQ   - F-K quality measure
C
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Anne Henson
C.    CREATION_DATE August 1986
C.    MADE_AT       SAIC
C                   10210 Campus Point Drive
C                   San Diego, CA 92121
C
C
C
C.    MODIFICATION Tormod Kvaerna, June 6, 1988, NORSAR
C.    CORRECTION
C.======================================================================
C.@PROCESS OPT(2)
C
C     COMMENT:
C
C=======================================================================
 
      ISIZ1 = GRDPTS - 1
      IFKQ  = 1
 
C----
C   Search for local maxima and store them
C----
 
      K = 0
 
      DO 1100 I = 2, ISIZ1
         DO 1000 J = 2, ISIZ1
 
            ICENT = J + (I - 1)*GRDPTS
            IF (WRKBUF(ICENT) .LE. 0.0) GO TO 1000
 
            Y = 10.0*ALOG10(POWER / WRKBUF(ICENT))
            IF (Y .GT. XDB) GO TO 1000
 
            I1    = J - 1 + (I - 2)*GRDPTS
            I2    = J +     (I - 2)*GRDPTS
            I3    = J + 1 + (I - 2)*GRDPTS
            I4    = J - 1 + (I - 1)*GRDPTS
            I5    = J + 1 + (I - 1)*GRDPTS
            I6    = J - 1 +       I*GRDPTS
            I7    = J +           I*GRDPTS
            I8    = J + 1 +       I*GRDPTS
 
            X  = WRKBUF(ICENT)
            X1 = WRKBUF(I1)
            X2 = WRKBUF(I2)
            X3 = WRKBUF(I3)
            X4 = WRKBUF(I4)
            X5 = WRKBUF(I5)
            X6 = WRKBUF(I6)
            X7 = WRKBUF(I7)
            X8 = WRKBUF(I8)
 
            IF ( (X1.LT.X).AND.(X2.LT.X).AND.(X3.LT.X).AND.
     +           (X4.LT.X).AND.(X5.LT.X).AND.(X6.LT.X).AND.
     +           (X7.LT.X).AND.(X8.LT.X) )                     THEN
 
 
               K = K + 1
               Z(K) = Y
 
            ENDIF
 
 1000    CONTINUE
 1100 CONTINUE
 
      NK = K
 
C----
C   Distinguish between single, double, and bad solutions
C----
 
      I1 = 0
 
      DO 1200 K = 1, NK
         IF ( Z(K) .LT. 1.0) I1 = I1 + 1
 1200 CONTINUE
 
      IF (I1 .EQ. 1) THEN
         ISOL = 1
      ELSE IF (I1 .EQ. 2 ) THEN
         ISOL = 2
      ELSE
         ISOL = 3
      ENDIF
 
C----
C   Assign F-K quality measure
C----
 
      IF (ISOL .EQ. 1) THEN
 
         DO 1300 K = 1, NK
 
            Y = Z(K)
 
            IF (Y .LT. 1.0) THEN
               GO TO 1300
            ELSE IF ( (Y .GE. 4.0) .AND. (Y .LT. 6.0) ) THEN
               IFKQ = MAX0(IFKQ,2)
            ELSE IF ( (Y .GE. 1.0) .AND. (Y .LT. 4.0) ) THEN
               IFKQ = 3
            ENDIF
 
 1300    CONTINUE
 
      ELSE IF (ISOL .EQ. 2) THEN
         IFKQ = 3
      ELSE
         IFKQ = 4
      ENDIF
 
      RETURN
 
      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      SUBROUTINE SLFOUT ( CHNDAT , NSEQU  , INTPTR ,
     +                    PTRDIM , INTPTS , PTSDIM , WRKBUF ,
     +                    BUFDIM , CFFT   , CFTDIM , CFTPTR ,
     +                    CPRDIM , CFTPTS , CPSDIM , ERRMSG , IERR ,
     +                    TYPCTL)

      INTEGER*4  TYPCTL
      REAL*4     CHNDAT(*)
      INTEGER*4  NSEQU
      INTEGER*4  INTPTR(*)
      INTEGER*4  PTRDIM
      INTEGER*4  INTPTS(*)
      INTEGER*4  PTSDIM
      REAL*4     WRKBUF(*)
      INTEGER*4  BUFDIM
      COMPLEX*8  CFFT(*)
      INTEGER*4  CFTDIM
      INTEGER*4     CFTPTR(*)
      INTEGER*4     CPRDIM
      INTEGER*4     CFTPTS(*)
      INTEGER*4     CPSDIM
      CHARACTER*(*) ERRMSG
      INTEGER*4     IERR
C.======================================================================
C.    PURPOSE
C     Slfout                                                        SS<<
C     Subroutine to compute fast FOUrier TRAnsforms
C     of any number of sequences. ( Only the positive part is output ).
C     Number of sequences are given by NSEQU.
C     Start of (sub)-sequence N is given by INTPTR(N),
C     dimension of INTPTR is PTRDIM.
C     points of (sub)-sequence N is given by INTPTS (N),
C     dimension of INTPTS is PTSDIM.
C     As working space we have array WRKBUF with dimension BUFDIM,
C     BUFDIM have to be twice the length of the fourier transform
C     of the longest sequence.
C     The resulting positive FFT's are stored in the
C     one dimensional complex array CFFT with dimension CFTDIM. The
C     positive FFT's are the NFFT/2 + 1 first samples of
C     the total FFT.
C     The first sample of the positive FFT of sequence N is given
C     by CFTPTR (N). Dimension of CFTPTR is CPRDIM.
C     Number of samples of the positive FFT of sequence N is given
C     by CFTPTS (N). Dimension of CFTPTS is CPSDIM.
C     Any reported mistakes is returned through ERRMSG and
C     type of error is given by IERR
C
C
C   Applications so far: Wide-Band Slowness Analysis.
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C
C..   CHNDAT(*)    - Array containing input sequences.
C..   NSEQU        - Number of sequences. ( Channels ).
C..   INTPTR(*)    - Start of (sub)-sequence N in CHNDAT
C..   PTRDIM       - Dimension of array INTPTR.
C..   INTPTS(*)      (sub)-sequence.
C..   PTSDIM       - Dimension of array INTPTS.
C..   WRKBUF(*)    - Working array
C..   BUFDIM       - Dimension of working array WRKBUF.
C
C
C.    OUTPUT
C..   CFFT(*)      - Output array containing positive
C                                  FFT's of all sequences.
C..   CFTDIM       - Dimension of array CFFT
C..   CFTPTR(*)    - Pointer array to start of positive
C                                  FFT's in CFFT.
C..   CPRDIM       - Dimension of array CFTPTR.
C..   CFTPTS(*)    - Number of points for each positive
C                                  FFT.
C..   CPSDIM       - Dimension of array CFTPTS.
C..   ERRMSG       - Error message
C..   IERR         - IERR =  0 : Everything O.K.
C.                 - IERR =  1 : Warning, calculation
C                                continues.
C.                 - IERR = -1 : Severe error,
C                                calculation stopped and
C                                return from subroutine.
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Tormod Kvaerna
C.    CREATION_DATE 
C.    MADE_AT       NTNF/NORSAR
C                   Pb. 51
C                   N-2007 Kjeller
C
C.    MODIFICATION  August 15, 1986
C.    CORRECTION
C.======================================================================
C.@PROCESS OPT(3)
C.OPT(3)
C----
 
C----
 
      INTEGER*4     PXI,PXR
 
C----
C   Initiate quality variables
C----
 
      IERR   = 0
 
C----
C   Some checks on array dimensions to avoid ABEND CODE
C----
 
C----
C   Check on array CHNPTR
C----
 
      IF (  NSEQU .GT. PTRDIM ) THEN
 
         ERRMSG = '***>SLFOUT: Length of array INTPTR is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Check on array CHNPNT
C----
 
      IF (  NSEQU .GT. PTSDIM ) THEN
 
         ERRMSG = '***>SLFOUT: Length of array INTPTS is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Check on array CFTPTR
C----
 
      IF (  NSEQU .GT. CPRDIM ) THEN
 
         ERRMSG = '***>SLFOUT: Length of array CFTPTR is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Check on array CFTPTS
C----
 
      IF (  NSEQU .GT. CPSDIM ) THEN
 
         ERRMSG = '***>SLFOUT: Length of array CFTPTS is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Channel loop
C----
 
      DO 1 I = 1, NSEQU
 
C----
C   FFT size must be equal to or larger than the length of the
C   sequences
C----
 
         NFFT =  8
 
    2    CONTINUE
 
         IF ( NFFT .GE. INTPTS(I) ) GO TO    3
 
            NFFT = NFFT * 2
 
         GO TO    2
 
    3    CONTINUE

C----
C   Check on array WRKBUF
C----
 
         IF (  NFFT .GT. BUFDIM/2 ) THEN
 
           ERRMSG = '***>SLFOUT: Length of array WRKBUF is exceeded'
c          WRITE(ERRMSG(64:70),'(I6)') NFFT
 
            IERR = -1
 
            RETURN
 
         END IF
 
C----
C    Store fourier transforms in buffer
C----
 
         PXR =  1
         PXI =  PXR + BUFDIM/2
 
         IF( TYPCTL.GT.2 ) WRITE(6,'(2X,''...> SLFOUT Zero WRKBUF'',
     +                                  2I6)') PXR,NFFT
         CALL CHZERO ( WRKBUF(PXR), NFFT )
         IF( TYPCTL.GT.2 ) WRITE(6,'(2X,''...> SLFOUT Zero WRKBUF'',
     +                                  2I6)') PXI,NFFT
         CALL CHZERO ( WRKBUF(PXI), NFFT )
         IF( TYPCTL.GT.2 ) WRITE(6,'(2X,''...> SLFOUT Move from DAT'',
     +                              I6,'' to WRKBUF'',2I6)')
     +                              INTPTR(I),PXR,INTPTS(I)
         CALL CHMOVE ( WRKBUF(PXR), CHNDAT( INTPTR(I) ), INTPTS(I) )
         IF( TYPCTL.GT.2 ) WRITE(6,'(2X,''...> SLFOUT FFT WRKBUF'',
     +                              I6,'' R,I '',2I6)')
     +                              PXR,PXI,NFFT
         CALL SLFFT  ( WRKBUF(PXR), WRKBUF(PXI), NFFT, -1 )

C----
C   Create pointer arrays to CFFT
C----
 
         IF ( I .EQ. 1) THEN
 
            CFTPTR (I) = 1
 
         ELSE
 
            CFTPTR (I) = CFTPTR ( I - 1) + CFTPTS ( I - 1 )
 
         ENDIF
 
         CFTPTS (I) = NFFT / 2 + 1

C----
C   Check on array CFFT
C----
 
         IF (  CFTPTR(I)+CFTPTS(I) .GT. CFTDIM ) THEN
 
            ERRMSG = '***>SLFOUT: Length of array CFFT is exceeded'
 
            IERR = -1
 
            RETURN
 
         END IF
C---
C   Store positive part of FFT in CFFT
C---
 
         IF( TYPCTL.GT.1 ) WRITE(6,'(2X,''...> SLFOUT Store WRKBUF'',
     +                              2I6,'' to CFFT'',2I6)')
     +                              PXR,PXI,CFTPTR(I),CFTPTS(I)
 
         DO    4 J = 1, CFTPTS(I)
 
            CFFT ( CFTPTR (I) + J - 1 ) = CMPLX( WRKBUF (PXR + J - 1),
     %                                           WRKBUF (PXI + J - 1) )
 
    4    CONTINUE
 
    1 CONTINUE
 
C----
C   That's it|
C----
 
      RETURN
 
      END
      SUBROUTINE SLSUBI ( NSEQU  , CHNPTR , PTRDIM , CHNPTS , PTSDIM ,
     +                    START  , STRDIM , STOP   , STPDIM , INTDIM ,
     +                    INTPTR , INTPTS , DELTA  , ERRMSG , IERR   ,
     +                    TYPCTL )
      INTEGER*4     NSEQU
      INTEGER*4     CHNPTR(*)
      INTEGER*4     PTRDIM
      INTEGER*4     CHNPTS(*)
      REAL*4        START (*)
      INTEGER*4     PTSDIM
      INTEGER*4     STRDIM
      REAL*4        STOP  (*)
      REAL*4        DELTA  (*)
      INTEGER*4     STPDIM
      INTEGER*4     INTDIM
      INTEGER*4     INTPTR(*)
      INTEGER*4     INTPTS(*)
      CHARACTER*(*) ERRMSG
      INTEGER*4     IERR  , TYPCTL
C.======================================================================
C.    PURPOSE
C     Slsubi                                                          SS<<
C     Subroutine to find first physical element of a sequence
C     sub-interval given the start and stop of each sequence.
C     Number of sequences is NSEQU
C     The first sample of sequence N is given by CHNPTR (N),
C     dimension of CHNPTR is PTRDIM.
C     Number of sampels of sequence N is given by CHNPTS (N),
C     dimension of CHNPTS is PTSDIM.
C     The first sample of sub-sequence N in sequence N is given by
C     START(N) with dimension STRDIM.
C     The last sample of sub-sequence N in sequence N is given by
C     STOP(N) with dimension STPDIM.
C     The output of this subroutine is the physical pointers to
C     each sub-sequence given by INTPTR(N).  The dimension of INTPTR
C     is INTDIM.
C     points of each sub-sequence is INTPTS(N).  The dimension
C     if INTPTS is also INTDIM
C     Sampling interval is given by DELTA
C     By physical pointers we mean pointers to the one-dimensional
C     array where the sequences are physically stored.
C     Any reported mistakes is returned through ERRMSG and
C     type of error is given by IERR
C
C
C     Applications so far: Preparation of input to subroutine FOUTRA
C
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C..   NSEQU      - Number of sequences
C..   CHNPTR(*)  - Array containing pointer to start
C                     of sequence N.
C..   PTRDIM     - Dimension of array CHNPTR.
C..   CHNPTS(*)  - Array containing number of samples
C                     of sequence N.
C..   PTSDIM     - Dimension of array CHNPTS.
C..   START (*)  - Pointer array to start of each
C                     sub-sequence, referenced to start
C                     of each sequence.
C..   STRDIM     - Dimension of array START
C..   STOP  (*)  - Pointer array to stop  of each
C                     sub-sequence, referenced to start
C                     of each sequence.
C
C..   DELTA  (*) - Sampling interval for channel N
C..   STPDIM     - Dimension of array START
C..   INTDIM     - Dimension of array INTPTR.
C
C
C
C
C.    OUTPUT
C..   INTPTR(*)  - Pointer array containing physical
C                     pointers to each sub-sequence
C                     referenced to start of the one-
C                     dimensional data array.
C
C..   INTPTS(*)  - Array containing points
C                     of each sub-sequence.
C
C..   ERRMSG     - Error message
C
C..   IERR  , TYPCTL            - IERR =  0 : Everything O.K.
C.                               - IERR =  1 : Warning, calculation
C                                                continues.
C.                               - IERR = -1 : Severe error,
C                                              calculation stopped and
C                                              return from subroutine.
C..   IRC     - Return code
C             = 0  No error
C             = ?  Fatal error
C.----------------------------------------------------------------------
C.    PROGRAMMER    Tormod Kvaerna
C.    CREATION_DATE December 2, 1986
C.    MADE_AT       NTNF/NORSAR
C                   Pb. 51
C                   N-2007 Kjeller
C
C.    MODIFICATION  October  1988 Jan Fyen
C.    CORRECTION
C.======================================================================
C.@PROCESS OPT(3)
C.OPT(3)
 
C----
C   Initiate quality variables
C----
 
      IERR   = 0
 
C----
C   Some checks on array dimensions to avoid ABEND CODE
C----
 
C----
C   Check on array CHNPTR
C----
 
      IF (  NSEQU .GT. PTRDIM ) THEN
 
         ERRMSG = '***>SLSUBI: Length of array CHNPTR is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Check on array CHNPTS
C----
 
      IF (  NSEQU .GT. PTSDIM ) THEN
 
         ERRMSG = '***>SLSUBI: Length of array CHNPTS is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Check on array START
C----
 
      IF (  NSEQU .GT. STRDIM ) THEN
 
         ERRMSG = '***>SLSUBI: Length of array START is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Check on array STOP
C----
 
      IF (  NSEQU .GT. STPDIM ) THEN
 
         ERRMSG = '***>SLSUBI: Length of array STOP is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Check on array INTPTR
C----
 
      IF (  NSEQU .GT. INTDIM ) THEN
 
         ERRMSG = '***>SLSUBI: Length of array INTPTR is exceeded'
 
         IERR = -1
 
         RETURN
 
      END IF
 
C----
C   Channel loop
C----
 
      DO 1 I = 1, NSEQU
 
         ISAMP      = 0
         SMPFRQ     = 1.0 / DELTA(I)
         ISAMP      = NINT(START(I)*SMPFRQ)
         INTPTR (I) = CHNPTR(I) + ISAMP
         ISAMP      = 0
         ISAMP      = NINT(STOP(I)*SMPFRQ)
         NRIGHT     = CHNPTR(I) + ISAMP
         INTPTS (I) = NRIGHT - INTPTR(I)
 
         IF( TYPCTL.GT.2 ) THEN
             WRITE(6,'(2X,''...> SLSUBI'', I3,3F9.3,2I6)')
     +                 I,START(I),STOP(I),SMPFRQ,INTPTR(I),INTPTS(I)
         END IF
C----
C   Check that start of sub-sequence is within sequence, return
C   with warning.
C----
 
         IF ( INTPTR(I) .GT. CHNPTR(I) + CHNPTS(I) - 1 ) THEN
 
            ERRMSG = '...>SLSUBI: Start sub-sequence exceeeds sequence'
 
            IERR = 1
 
         ENDIF
 
    1 CONTINUE
 
C----
C   That's it|
C----
 
      RETURN
 
      END
C.@PROCESS OPT(3)
      SUBROUTINE CHMOVE (A, B, N)
      INTEGER*4  N
      REAL*4     A(*),B(*)
C.======================================================================
C.    PURPOSE
C     Make copy of an array. Move from  B to A.                     CH<<
C.----------------------------------------------------------------------
C.    KEYWORDS  CHNDAT
C.----------------------------------------------------------------------
C.    PACKAGE  CHNxxx
C.    VISIBLE
C.    STANDARD_FORTRAN_77
C.    USE_ONLY
C.----------------------------------------------------------------------
C.    INPUT
C..   N  - Number of elements to move from B to A.
C..   B  - Array to copy.
C.    OUTPUT
C..   A  - Resulting copy of array B.
C.----------------------------------------------------------------------
C.    PROGRAMMER    Jan Fyen
C.    CREATION_DATE 21 Apr 1988
C.    MADE_AT  NTNF/NORSAR
C     Pb. 51
C     N-2007 Kjeller
C
C.    MODIFICATION
C.    CORRECTION
C.======================================================================
 
C.OPT(3)
 
      DO  100 I = 1, N
 
         A(I) = B(I)
 
100   CONTINUE
 
      RETURN
 
      END
      SUBROUTINE CHZERO (A, N)
      INTEGER*4  N
      REAL*4     A(*)
C.======================================================================
C.    PURPOSE
C     Zero one array.                                               CH<<
C.----------------------------------------------------------------------
C.    KEYWORDS  CHNDAT
C.----------------------------------------------------------------------
C.    PACKAGE  CHNxxx
C.    VISIBLE
C.    STANDARD_FORTRAN_77
C.    USE_ONLY
C.----------------------------------------------------------------------
C.    INPUT
C..   N  - Number of elements to zero in A.
C.    OUTPUT
C.----------------------------------------------------------------------
C.    PROGRAMMER    Jan Fyen
C.    CREATION_DATE 21 Apr 1988
C.    MADE_AT  NTNF/NORSAR
C     Pb. 51
C     N-2007 Kjeller
C
C.    MODIFICATION
C.    CORRECTION
C.======================================================================
C.OPT(3)
 
 
      IF( N.LE.0 ) RETURN
 
      DO  100 I = 1, N
 
         A(I) = 0.0
 
100   CONTINUE
 
      RETURN
 
      END

c-----------------------------------------------------------------
c
c
c
      SUBROUTINE CONTOR (IIYMX , IIXMX , ARRAY  , SLWMAX ,
     +                   SXMAX , SYMAX , AZIMUT , APPVEL,
     +                   POWER, LEVNUM, OUTLOW, OUTHIG,
     +                   YEAR, MONTH, DAY, HOUR, MINU, SECO,
     +                   NCHAN, IDENT, xdim, ydim, TMWIN)


C     *****************************                                                
C     ** CONTOUR PLOT SUBROUTINE **                                                
C     *****************************                                                
C                                                                               
C     THIS SUBROUTINE PLOTS 'NCLEV' CONTOURS EACH TIME IT IS CALLED             
c
c     routine uses whole screen in range -0.5 to 1.5
c     for contour plott routine uses span 0 to 1 with center 0.5
C                                                                               
C     ARRAY(IR,IC) = DATA INPUT ARRAY                                           
C     IR  CORRESPONDS TO ROWS FROM IYMN TO IYMX                                 
C     IC  CORRESPONDS TO COLUMNS FROM IXMN TO IXMX                              
C     CLEV(I) = THE CONTOUR LEVELS TO BE PLOTTED                                
C     PLEV(I) = THE NUMBERS WHICH ARE PRINTED ON THE PLOT. PLEV(I)              
C     CORRESPONDS WITH CLEV(I)                                                  
C     NCLEV = THE NUMBER OF LEVELS TO PLOT                                      
C     IIXMX = number of x elements                                     
C     IIYMY = number of y elements                                             
C     THE ROWS EXTEND IN THE HORIZONTAL DIRECTION, THE COLUMNS IN THE           
C     VERTICAL DIRECTION.                                                       
C
c      implicit none
C
C     Variables comming from upper programm
C
      INTEGER      IIYMAX, IIXMAX
      REAL*4        ARRAY(99,99)
      REAL         SXMAX, SYMAX       ! max slownes at max power 
      REAL*4       AZIMUT             ! azimut of max power
      REAL*4       APPVEL             ! app. vel of max power
      REAL*4       POWER              ! normalized max powere
      REAL         OUTLOW, OUTHIG     ! used frequency band
      CHARACTER    LEVNUM*1           ! indicator to plott level numbers
      INTEGER       YEAR,  MONTH, DAY,  HOUR
      INTEGER       MINU
      REAL          SECO, TMVIN
      CHARACTER    IDENT(20)*10
      INTEGER*4    NCHAN
      REAL         xdim, ydim

C----
C     Internal variables
C----

      INTEGER      idim
      integer ncon         ! unit to read contours from
c     parameter (idim=51)
      DIMENSION    ENDPT(10000), STPT(10000),                 
     *             XGRID(99)   , YGRID(99)  ,
     *             CLEV(20)    , PLEV(20) 
      INTEGER      STPT , ENDPT
      CHARACTER*12 ANOT             ! to write anotation and text on graph dis
      CHARACTER*60 TXTOUT           ! to write text on graph displ
      CHARACTER*10 xlev(20)         ! contour levels
    
      COMMON/AA/ IXMN,IXMX,IYMN,IYMX,NLX,NRX,NTY,NBY
C
C
      ixmx=iixmx  ! transfer since in common block
      iymx=iiymx 

c
c   fix contour levels to 0 to 1
c
       nclev=11
       do i=1,11
          clev(i)=(i-1)*0.1
          plev(i)=clev(i)
          xlev(i)=' '
          write(xlev(i)(1:3),'(f3.1)') clev(i)
       enddo
C
	  iymn=1
	  ixmn=1
c
c   set old versatec dimensions to somehting reasonble so it is easy to
c   scale afterwards, cannot be too big, scaling goes funny, scaling up
c   to seisan is done in routines plot and number.
c
c      xdim=1.3
c      ydim=1.3 
C                                                                               
C   INITIALIZE ARRAYS                                                           
C                                                                               
      IDIM=99                                                                 
C                                                                               
      KMAX=IDIM*IDIM                                                            
 80   DO 90 I=1,KMAX                                                            
      STPT(I)=0                                                                 
 90   ENDPT(I)=0                                                                
C                                                                               
C   COMPUTE QUADRANT SIZE AND GRID DISPLACEMENTS                                
C                                                                               
      XSCAL = XDIM/(IXMX-IXMN)                                                  
      YSCAL = YDIM/(IYMX-IYMN)                                                  
      DO 110 I=1,IDIM                                                           
      XGRID(I) = (I-1)* XSCAL                                                   
 110  YGRID(I) = (I-1)* YSCAL                                                   
      NLX = XGRID(IXMN) *100. + .5                                              
      NRX = XGRID(IXMX) *100. + .5                                              
      NTY = YGRID(IYMN) *100. + .5                                              
      NBY = YGRID(IYMX) *100. + .5                                              
      IXMN1 = IXMN + 1                                                          
      IYMN1 = IYMN + 1                                                          

C----
CAP   Plott box and zerrow axes 
C----
      call plot (0.0*xdim, 0.0*ydim, 3)
      call plot (1.0*xdim, 0.0*ydim, 2)
      call plot (1.0*xdim, 1.0*ydim, 2)
      call plot (0.0*xdim, 1.0*ydim, 2)
      call plot (0.0*xdim, 0.0*ydim, 2)
C
      call plot (0.5*xdim, 0.0*ydim, 3)
      call plot (0.5*xdim, 1.0*ydim, 2)
C
      call plot (0.0*xdim, 0.5*ydim, 3)
      call plot (1.0*xdim, 0.5*ydim, 2)
C----
CAP   Loop to draw ticks
C----
      DO i=(-1)*FLOAT(INT(SLWMAX*10)), FLOAT(INT(SLWMAX*10))
         call plot ((0.5/SLWMAX*i/10+0.5)*xdim, 0.0*ydim, 3)
         call plot ((0.5/SLWMAX*i/10+0.5)*xdim, 0.01*ydim, 2)
         call plot ((0.5/SLWMAX*i/10+0.5)*xdim, 1.0*ydim, 3)
         call plot ((0.5/SLWMAX*i/10+0.5)*xdim, 0.99*ydim, 2)
         call plot (0.0*xdim, (0.5/SLWMAX*i/10+0.5)*ydim, 3)
         call plot (0.005*xdim, (0.5/SLWMAX*i/10+0.5)*ydim, 2)
         call plot (1.0*xdim, (0.5/SLWMAX*i/10+0.5)*ydim, 3)
         call plot (0.995*xdim, (0.5/SLWMAX*i/10+0.5)*ydim, 2)
      ENDDO
C----
CAP   Write slownes values
C----
      IF ((SLWMAX-FLOAT(INT(SLWMAX*10))/10).eq.0.0) THEN
        WRITE (ANOT(1:4),'(f3.1)') SLWMAX        ! one decimal case
      ELSE
        WRITE (ANOT(1:4),'(f4.2)') SLWMAX        ! two decimal case
      ENDIF
C----
CAP   Plott slowness anotation
C----
c                                                 plott max slownes number
      call number (ANOT, 0.98*xdim, -0.06*ydim)
c      call number (ANOT, 0.98*xdim, 1.03*ydim)
      call number (ANOT, -0.08*xdim, 0.99*ydim)
c      call number (ANOT, 1.03*xdim, 0.99*ydim)
c
      ANOT='-'//ANOT                            ! plot min sloness number
      call number (ANOT, -0.08*xdim, -0.01*ydim)
c      call number (ANOT, 1.03*xdim, -0.01*ydim)
      call number (ANOT, -0.02*xdim, -0.06*ydim)
c      call number (ANOT, -0.02*xdim, 1.03*ydim)
c
      ANOT='0.0       '                         ! plot zerow slowness number
      call number (ANOT, 0.48*xdim, -0.06*ydim)
c      call number (ANOT, 0.48*xdim, 1.03*ydim)
      call number (ANOT, -0.08*xdim, 0.49*ydim)
c      call number (ANOT, 1.03*xdim, 0.49*ydim)
c                                                                               
c
      DO 700 J=1,NCLEV                                                          
C   LOOP ONCE FOR EACH DB CONTOUR  ***************M4                            
      K=0                                                                       
C                                                                               
C   TEST ALL SQUARES FOR DB LEVEL CROSSING                                      
C                                                                               
      DO 690 N=IYMN1,IYMX                                                       
      DO 690 I=IXMN1,IXMX                                                       
      PT1 = RATIO(ARRAY(N-1,I-1),ARRAY(N-1,I),XGRID(I-1),XGRID(I),              
     1CLEV(J))                                                                  
      PT2 = RATIO(ARRAY(N-1,I-1),ARRAY(N,I-1),YGRID(N-1),YGRID(N),              
     1CLEV(J))                                                                  
      PT3 = RATIO(ARRAY(N,I-1),ARRAY(N,I),XGRID(I-1),XGRID(I),CLEV(J))          
      PT4 = RATIO(ARRAY(N-1,I),ARRAY(N,I),YGRID(N-1),YGRID(N),CLEV(J))          
C                                                                               
C   TEST IF ANY SIDE HAS AN INTERSECTION                                        
C                                                                               
      IF (PT1+PT2+PT3+PT4) 450,690,450                                          
C                                                                               
C     TEST IF ALL SIDES HAVE INTERSECTIONS                                      
C                                                                               
 450  IF (PT1*PT2*PT3*PT4) 660,460,660                                          
C                                                                               
C     THIS IS THE TWO SIDE CASE - DETERMINE WHICH TWO                           
C                                                                               
 460  IF (PT1) 480,470,480                                                      
 470  IF (PT2) 500,560,500                                                      
 490  IF (PT3) 520,530,520                                                      
 480  IF (PT2) 510,490,510                                                      
 500  IF (PT3) 540,550,540                                                      
 510  LDIR=1                                                                    
      GO TO 570                                                                 
 520  LDIR=2                                                                    
      GO TO 570                                                                 
 530  LDIR=3                                                                    
      GO TO 570                                                                 
 540  LDIR=4                                                                    
      GO TO 570                                                                 
 550  LDIR=5                                                                    
      GO TO 570                                                                 
 560  LDIR=6                                                                    
C                                                                               
C                                                                               
C   ASSIGN LINE START COORDINATES BY LINE DIRECTION                             
 570  GO TO (580,580,580,590,590,600),LDIR                                      
 580  STX = PT1                                                                 
      STY = YGRID(N-1)                                                          
      GO TO 610                                                                 
 590  STX = XGRID(I-1)                                                          
      STY = PT2                                                                 
      GO TO 610                                                                 
 600  STX = PT3                                                                 
      STY = YGRID(N)                                                            
C                                                                               
C   ASSIGN LINE END COORDINATES BY LINE DIRECTION                               
C                                                                               
 610  GO TO (620,630,640,630,640,640),LDIR                                      
 620  ENDX = XGRID(I-1)                                                         
      ENDY = PT2                                                                
      GO TO 650                                                                 
 630  ENDX = PT3                                                                
      ENDY = YGRID(N)                                                           
      GO TO 650                                                                 
 640  ENDX = XGRID(I)                                                           
      ENDY = PT4                                                                
C                                                                               
C   OUTPUT LINE SEGMENT                                                         
C                                                                               
 650  CALL PUT(STX,STY,ENDX,ENDY,MSTRT,MEND)                                    
      K=K+1                                                                     
      STPT(K) = MSTRT                                                           
      ENDPT(K) = MEND                                                           
      IF (K-KMAX ) 690,790,790                                                  
C                                                                               
C   THIS IS THE FOUR SIDE CASE - DETERMINE MOST PROBABLE PAIR OF LINES          
C   USING DIAGONALS                                                             
C                                                                               
 660  IF (ABS(CLEV(J)-(ARRAY(N-1,I)+ARRAY(N,I-1))/2.)-ABS(CLEV(J)-              
     1(ARRAY(N-1,I-1)+ARRAY(N,I))/2.)) 680,670,670                              
C                                                                               
C   LINES DIRECTION PAIR 1 AND 6                                                
C                                                                               
 670  STX = PT1                                                                 
      STY = YGRID(N-1)                                                          
      ENDX = XGRID(I-1)                                                         
      ENDY = PT2                                                                
C                                                                               
C   OUTPUT LINE SEGMENT                                                         
C                                                                               
      CALL PUT(STX,STY,ENDX,ENDY,MSTRT,MEND)                                    
      K=K+1                                                                     
      STPT(K)= MSTRT                                                            
      ENDPT(K)= MEND                                                            
      IF (K-KMAX ) 675,790,790                                                  
 675  STX = PT3                                                                 
      STY = YGRID(N)                                                            
      ENDX = XGRID(I)                                                           
      ENDY = PT4                                                                
C                                                                               
C   OUTPUT LINE SEGMENT                                                         
C                                                                               
      CALL PUT(STX,STY,ENDX,ENDY,MSTRT,MEND)                                    
      K=K+1                                                                     
      STPT(K)=MSTRT                                                             
      ENDPT(K) = MEND                                                           
      IF (K-KMAX ) 690,790,790                                                  
C                                                                               
C   LINE DIRECTION PAIR 4 AND 3                                                 
C                                                                               
 680  STX = PT1                                                                 
      STY = YGRID(N-1)                                                          
      ENDX = XGRID(I)                                                           
      ENDY = PT4                                                                
      CALL PUT(STX,STY,ENDX,ENDY,MSTRT,MEND)                                    
      K=K+1                                                                     
      STPT(K) = MSTRT                                                           
      ENDPT(K) = MEND                                                           
      IF (K-KMAX ) 685,790,790                                                  
 685  STX = XGRID(I-1)                                                          
      STY = PT2                                                                 
      ENDX = PT3                                                                
      ENDY = YGRID(N)                                                           
      CALL PUT(STX,STY,ENDX,ENDY,MSTRT,MEND)                                    
      K=K+1                                                                     
      STPT(K)=MSTRT                                                             
      ENDPT(K)=MEND                                                             
      IF (K-KMAX ) 690,790,790                                                  
 690  CONTINUE                                                                  
C                                                                               
C   ANY DATA THIS LEVEL                                                         
C                                                                               
C     IF (K) 810,810,9100                                               DBUG    
      IF (K) 810,810,910                                                        
 810  continue
c      WRITE(6,140) PLEV(J)                                                      
c 140  FORMAT(' NO DATA FOR DB LEVEL ',F8.4)                                     
      GO TO 700                                                                 
C                                                                               
C   CONNECT POINTS AND PLOT                                                     
C                                                                               
C9100 WRITE(3,9101) J                                                   DBUG    
C9101 FORMAT('1DATA FOR LEVEL',I5/)                                     DBUG    
C     WRITE(3,9102) (STPT(IKJ),ENDPT(IKJ),IKJ=1,K)                      DBUG    
C9102 FORMAT(1X,5(2I11,3X))                                             DBUG    
 910  NN=1                                                                      
C                                                                               
C   DOES START OR END POINT START ON THE EDGE                                   
C                                                                               
 915  IST = 0                                                                   
      MX = MAX0(NN-1,K-NN)                                                      
      DO 925 LL=1,MX                                                            
      L=NN + LL                                                                 
      IF (L-K) 916,916,920                                                      
 916  IF (STPT(L)) 930,920,917                                                  
 917  IF (ENDPT(L)) 950,918,918                                                 
 918  IF (IST) 920,919,920                                                      
 919  IST=L                                                                     
 920  L = NN - LL                                                               
      IF (L-1) 925,921,921                                                      
 921  IF (STPT(L)) 930,925,922                                                  
 922  IF (ENDPT(L)) 950,923,923                                                 
 923  IF (IST) 925,924,925                                                      
 924  IST = L                                                                   
 925  CONTINUE                                                                  
C                                                                               
C   ANY MORE DATA VALUES LEFT                                                   
C                                                                               
      IF (IST) 926,700,926                                                      
 926  L = IST                                                                   
      NIS = STPT(L)                                                             
C                                                                               
C   BEGIN ON START EDGE                                                         
C                                                                               
 930  STPT(L) = IABS(STPT(L))                                                   
      CALL PT(STPT(L),XS,YS)                                                    
C     WRITE(3,9103) L,XS,YS                                             DBUG    
C9103 FORMAT(' START ',I5,2(2X,F8.2))                                   DBUG    
C  JF  CHANGES MADE FOR THE SUBMATRIX CASE                                      
 2133 IF(IXMN-1) 790, 2001, 2000                                                
 2000 XS=XS-(IXMN-1)*XSCAL                                                      
 2001 IF(IYMN-1) 790, 2003, 2002                                                
 2002 YS=YS+(IYMN-1)*YSCAL                                                      
 2003 CALL PLOT(XS,YS,3)                                                        
      XMX = XS                                                                  
      YMY = YS                                                                  
C                                                                               
C                                                                               
C   CONTINUE ON START VALUES                                                    
C                                                                               
 940  LAST = ENDPT(L)                                                           
      GO TO 970                                                                 
C                                                                               
C   BEGIN ON END EDGE                                                           
C                                                                               
 950  ENDPT(L) = IABS(ENDPT(L))                                                 
      CALL PT(ENDPT(L),XS,YS)                                                   
C     WRITE(3,9103) L,XS,YS                                             DBUG    
 2134 IF(IXMN-1) 790, 2005, 2004                                                
 2004 XS=XS-(IXMN-1)*XSCAL                                                      
 2005 IF(IYMN-1) 790, 2007, 2006                                                
 2006 YS=YS+(IYMN-1)*YSCAL                                                      
 2007 CALL PLOT(XS,YS,3)                                                        
      XMX = XS                                                                  
      YMY = YS                                                                  
C                                                                               
C   CONTINUE ON END VALUES                                                      
C                                                                               
 960  LAST = STPT(L)                                                            
 970  STPT(L) = 0                                                               
      ENDPT(L) = 0                                                              
C                                                                               
C   IS THIS THE LAST VALUE                                                      
C                                                                               
      IF (LAST) 975,975,980                                                     
 975  LAST = IABS(LAST)                                                         
      CALL PT(LAST,XS,YS)                                                       
C     WRITE(3,9104) L,XS,YS                                             DBUG    
C9104 FORMAT('   END ',I5,2(2X,F8.2))                                   DBUG    
 2135 IF(IXMN-1) 790, 2009, 2008                                                
 2008 XS=XS-(IXMN-1)*XSCAL                                                      
 2009 IF(IYMN-1) 790, 2011, 2010                                                
 2010 YS=YS+(IYMN-1)*YSCAL                                                      
 2011 CALL PLOT(XS,YS,2)                                                        
      NN = L                                                                    
      IF (YMY - YS) 976,1010,1010                                               
 976  XMX = XS                                                                  
      YMY = YS                                                                  
C   START ON NEW POINT AFTER LABEL ROUTINE                                      
C                                                                               
C   START ON NEW POINT AFTER LABEL ROUTINE                                      
C                                                                               
      GO TO 1010                                                                
C                                                                               
C   CONTINUE IN ROUTINE                                                         
 980  CALL PT(LAST,XS,YS)                                                       
C     WRITE(3,9105) L,XS,YS                                             DBUG    
C9105 FORMAT('       ',I5,2(2X,F8.2))                                   DBUG    
 2136 IF(IXMN-1) 790, 2013, 2012                                                
 2012 XS=XS-(IXMN-1)*XSCAL                                                      
 2013 IF(IYMN-1) 790, 2015, 2014                                                
 2014 YS=YS+(IYMN-1)*YSCAL                                                      
 2015 CALL PLOT(XS,YS,2)                                                        
      IF (YMY-YS) 981,985,985                                                   
 981  XMX = XS                                                                  
      YMY = YS                                                                  
 985  MX = MAX0(L-1,K-L)                                                        
      NN = L                                                                    
      DO 1000 LL=1,MX                                                           
      L = NN + LL                                                               
      IF (L-K)  986,986,990                                                     
 986  IF (STPT(L)) 987,990,987                                                  
 987  IF (STPT(L)-LAST) 988,940,988                                             
 988  IF (ENDPT(L)-LAST) 990,960,990                                            
 990  L = NN - LL                                                               
      IF (L-1) 1000,991,991                                                     
 991  IF (STPT(L)) 992,1000,992                                                 
 992  IF (STPT(L)-LAST) 993,940,993                                             
 993  IF (ENDPT(L)-LAST) 1000,960,1000                                          
 1000 CONTINUE                                                                  
      CALL PT(NIS,XS,YS)                                                        
C     WRITE(3,9104) L,XS,YS                                             DBUG    
 2137 IF(IXMN-1) 790, 2017, 2016                                                
 2016 XS=XS-(IXMN-1)*XSCAL                                                      
 2017 IF(IYMN-1) 790, 2019, 2018                                                
 2018 YS=YS+(IYMN-1)*YSCAL                                                      
 2019 CALL PLOT(XS,YS,2)                                                        
C     CALL PLOT (XS,YS,2)                                                       
C                                                                               
C   LABEL HIGHEST POINT ON CONTOUR                                              
C                                                                               
 1010 CRT = PLEV(J)                                                             
c
c   here is some number displacemnts which is assumed to be in inches
c   since whole plot is now from 0 to 1 in both directions, must be changed
c   somehow. for the time being is just disabled
c
c     ADD=0.02
      IF(PLEV(J)-10.0) 4000,4001,4001                                           
 4000 ADD=0.1                                                                   
      GO TO 4002                                                                
 4001 ADD=0.15                                                                  
 4002 YMY=YMY+0.02                                                              
c     XMX=XMX-ADD                                                               
c      CALL NUMBER (XMX,YMY,.1,CRT,0.,-1)

      IF (LEVNUM.EQ.'y'.or.LEVNUM.EQ.'Y') THEN
        call number(xlev(j),xmx,ymy)  
        GOTO 915
      ENDIF
      GO TO 915                                                                 
C
 790  WRITE ( 3,8100)
 8100 FORMAT(' TOO MANY POINTS, THIS LEVEL IGNORED')
c
 700  CONTINUE                                                                  

C----
CAP   Marks maximum power
C----
      call plot ((0.5/SLWMAX*SXMAX-0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX-0.007+0.5)*ydim, 3)
      call plot ((0.5/SLWMAX*SXMAX+0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX+0.007+0.5)*ydim, 2)
      call plot ((0.5/SLWMAX*SXMAX-0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX+0.007+0.5)*ydim, 3)
      call plot ((0.5/SLWMAX*SXMAX+0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX-0.007+0.5)*ydim, 2)
      call plot ((0.5/SLWMAX*SXMAX+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX+0.007+0.5)*ydim, 3)
      call plot ((0.5/SLWMAX*SXMAX+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX-0.007+0.5)*ydim, 2)

      call plot ((0.5/SLWMAX*SXMAX+0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX+0.007+0.5)*ydim, 3)
      call plot ((0.5/SLWMAX*SXMAX-0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX+0.007+0.5)*ydim, 2)
      call plot ((0.5/SLWMAX*SXMAX-0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX-0.007+0.5)*ydim, 2)
      call plot ((0.5/SLWMAX*SXMAX+0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX-0.007+0.5)*ydim, 2)
      call plot ((0.5/SLWMAX*SXMAX+0.007+0.5)*xdim,
     + (0.5/SLWMAX*SYMAX+0.007+0.5)*ydim, 2)

C----
CAP   DRAW line from origin to power max in case LEVNUM='N'
C----
      IF (LEVNUM.EQ.'N') THEN
        call plot (0.5*xdim, 0.5*ydim, 3)
        call plot ((0.5/SLWMAX*SXMAX+0.5)*xdim,
     +    (0.5/SLWMAX*SYMAX+0.5)*ydim, 2)
      ENDIF

C----
CAP  Write date and time and time window
C----
      ANOT='          '
      WRITE (ANOT(1:4), '(A4)') 'Date'

      call contxchar ('DATE',4, -0.45, 1.4)
      ANOT='          '
      WRITE (ANOT(1:4),'(I4)') YEAR
      WRITE (ANOT(5:5),'(a1)') '.'
      WRITE (ANOT(6:7),'(I2)') MONTH
      WRITE (ANOT(8:8),'(a1)') '.'
      WRITE (ANOT(9:10),'(I2)') DAY
      call contxchar (ANOT,10, -0.30, 1.4)

      call contxchar ('TIME',4, 0.0, 1.4)
      ANOT='          '
      WRITE (ANOT(1:2),'(I2)') HOUR
      WRITE (ANOT(3:3),'(a1)') ':'
      WRITE (ANOT(4:5),'(I2)') MINU
      WRITE (ANOT(6:6),'(a1)') ':'
      WRITE (ANOT(7:12),'(F6.3)') SECO
      call contxchar (ANOT,12, 0.15, 1.4)

      call contxchar ('WINDOW LENGTH, SEC',18, 0.5, 1.4)
      ANOT='          '
      WRITE (ANOT(1:8),'(F8.3)') TMWIN
      call contxchar (ANOT, 8, 0.9, 1.4)

C---
CAP  Write id of used chanels
C----

      call number ('CHAN. USED', -0.45, 1.30)

      DO n=1, NCHAN
        ANOT='          '
        WRITE (ANOT(1:10),'(a10)') IDENT(n)
        call number (ANOT, -0.45, 1.25-n*0.05)
      ENDDO

C----
CAP*  Write output parameters of F-K analysis
C----

      call contxchar ('AZIMUTH',7, -0.25, -0.2)
      ANOT='          '
      WRITE (ANOT(1:3),'(I3)') INT(AZIMUT)
      call contxchar (ANOT,3, 0.25, -0.2)
      call contxchar('APPARENT VELOCITY',17,-0.25,-0.25)
      ANOT='          '
      WRITE (ANOT(1:4),'(F4.1)') APPVEL
      call contxchar (ANOT,4, 0.25, -0.25)
      call contxchar('NORM. POWER MAX',15,-0.25, -0.3)
      ANOT='          '
      WRITE (ANOT(1:4),'(F4.2)') POWER
      call contxchar (ANOT,4,  0.25, -0.3)
                                            
      call contxchar('LOW FREQUENCY',13,0.65, -0.2)
      ANOT='          '
      WRITE (ANOT(1:5),'(F5.2)') OUTLOW
      call contxchar (ANOT,5, 1.10, -0.2)
      call contxchar('HIGH FREQUENCY',14, 0.65, -0.25)
      ANOT='          '
      WRITE (ANOT(1:5),'(F5.2)') OUTHIG
      call contxchar (ANOT,5, 1.10, -0.25)
      call contxchar('NO OF GRID POINTS',17, 0.65, -0.3)
      ANOT='          '
      WRITE (ANOT(1:2),'(I2)') IIXMX
      call contxchar (ANOT,2, 1.10, -0.3)

c----
cAP  Write on screen only meanings of keys
c----
      call contxmess ('R-Redo',1,6, -0.35,-0.45)
      call contxmess ('M-Mouse',1,7,0.10,-0.45)
      call contxmess ('S-Save and quit',1,15, 0.50,-0.45)
      call contxmess ('Q-Quit',1, 6, 1.0, -0.45)
                          
c
c    Return to Caller...
c    ===================
c

 9999  continue

      return
      END                                                                       

cccccccccccccccccccccccccccccccccccccccccccccccccccccc


      subroutine number(xnumber,x,y)
c
c  plot a number xnumber at position x,y
c
      implicit none
      character*10 xnumber      ! the text string to plot with the number
      real xx,yy          ! to projection routine
      real x,y

      xx=(x+0.5)*520.0                                                           
      yy=(y+0.5)*390.0
   	  call xchars(xnumber,10,xx,yy)
      return
      end

c-----------------------------------------

      subroutine contxchar (outtxt,n,x,y)

c---
cAP   plot some text of i lines and n characters at coordinates x y  
c     x and y ranges from -0.5 to 1.5 according to subrautine contor
c---  

      implicit none
      character*60 outtxt    ! the text string to plot
      real xx,yy             ! to projection routine
      real x,y
      integer n

      xx=(x+0.5)*520.0                                                           
      yy=(y+0.5)*390.0
          call xchars (outtxt,n,xx,yy)

      return
      end
c-----------------------------------------

      subroutine contxmess (outtxt,i,n,x,y)

c---
cAP   plot some text of i lines and n characters at coordinates x y on
c     screen only
c     x and y ranges from -0.5 to 1.5 according to subrautine contor
c---  

      implicit none
      character*60 outtxt    ! the text string to plot
      real xx,yy             ! to projection routine
      real x,y
      integer i, n

      xx=(x+0.5)*520.0                                                           
      yy=(y+0.5)*390.0
          call xmessage (outtxt,i,n,xx,yy)
      return
      end


c-----------------------------------------

      subroutine plot(x,y,n)
c
c  x and y  : input values to plot
c  n        : 2: pen down  3: pen up
c
c  used with contor routine to use verstec calls and do the scaling and
c  and map projection
c
      real xx,yy          ! to projection routine
      real x,y
      integer n,nold,nn         ! pen up or down
c
       nn=n
          if(nold.eq.3) then
            nn=3
            nold=2  ! draw to next time
          endif

c       else
c          nold=3    ! move to for next value inside
c          return    ! point is outside, do not plot
c       endif

        xx=(x+0.5)*520.0                                                           
        yy=(y+0.5)*390.0

        if(nn.eq.3) call xmovabs(xx,yy)
        if(nn.eq.2) call xdrwabs(xx,yy)
        return
        end

c--------------------------------------------------

      SUBROUTINE PUT (STX,STY,ENDX,ENDY,MSTRT,MEND)                             
C                                                                               
      COMMON/AA/ IXMN,IXMX,IYMN,IYMX,NLX,NRX,NTY,NBY                            
      MSTRTX = STX*100. + .5                                                    
      MSTRTY = STY*100. + .5                                                    
      MENDX = ENDX*100. + .5                                                    
      MENDY = ENDY*100. + .5                                                    
      MSTRT = MSTRTX*100000 + MSTRTY                                            
      MEND = MENDX*100000 + MENDY                                               
      IF (MSTRT-MEND) 5,200,5                                                   
 5    IF(MSTRTX-NLX) 10,40,10                                                   
 10   IF(MSTRTY-NTY) 20,40,20                                                   
 20   IF(MSTRTY-NBY) 30,40,30                                                   
 30   IF(MSTRTX-NRX) 50,40,50                                                   
 40   MSTRT = - MSTRT                                                           
 50   IF(MENDX-NRX) 60,90,60                                                    
 60   IF(MENDX-NLX) 70,90,70                                                    
 70   IF(MENDY-NBY) 80,90,80                                                    
 80   IF(MENDY-NTY) 100,90,100                                                  
 90   MEND = - MEND                                                             
 100  RETURN                                                                    
 200  MEND=0                                                                    
      MSTRT=0                                                                   
      RETURN                                                                    
      END                                                                       
C                                                                               
      FUNCTION RATIO(A,B,C,D,VAL)                                               
C                                                                               
      IF(A-VAL) 30,20,20                                                        
 20   IF(B-VAL) 50,60,60                                                        
 30   IF(B-VAL) 60,50,50                                                        
 50   RATIO = ((VAL-A)/(B-A))*(D-C) + C                                         
      RETURN                                                                    
 60   RATIO = 0                                                                 
      RETURN                                                                    
C                                                                               
C                                                                               
C  ORIGINAL 'RATIO'                                                             
C. . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .          
C     ABIAS=0                                                                   
C     BBIAS=0                                                                   
C     IF (A-VAL) 30,10,20                                                       
C10   ABIAS =  .00001                                                           
C20   IF (B-VAL) 50,60,60                                                       
C40   BBIAS = .00001                                                            
C30   IF (B-VAL) 60,40,50                                                       
C50   RATIO = ((VAL-A-ABIAS)/(BBIAS+B-A-ABIAS))*(D-C)+C                         
C     GO TO 70                                                                  
C60   RATIO = 0                                                                 
C70   RETURN                                                                    
      END                                                                       
C
      SUBROUTINE PT(IUV,X,Y)                                                    
C                                                                               
      X   = IUV/100000 * .01                                                   
      Y    = MOD(IUV,100000) * .01                                              
cjh       Y = - Y                                                                  
      RETURN                                                                    
      END                                                                       
C                                                                               

c     file VELESTCOMMON.FOR                        Version ETH-19SEP91
c******************************************
c     common-blocks of program VELEST     *  by Urs Kradolfer
c******************************************
c
c
c-----------------------------------------------------------------------------
c
c     IN THIS SECTION YOU CAN CHANGE THE ARRAY-SIZES:
c
      integer ieq,inshot,itotmodels,inltot,ist,
     &        maxobsperevent 
      parameter(ieq=800)      ! number of earthquakes (Simultaneous mode)
cs      parameter(ieq=1)        ! number of earthquakes (single event mode ONLY)
      parameter(inshot=50,    ! max. number of shots (for simultaneous mode)
     &          itotmodels=2, ! max. number of velocity models
     &          inltot=100,    ! max. number of layers per velocity model
     &          ist=650,      ! max. number of stations in stationlist
     &          maxobsperevent=180) ! max. number of observations per event
c
c
c-----------------------------------------------------------------------------
c
      integer ilip,inva,ikva,inrpmax
      parameter(ilip=(4*ieq+inshot+inltot+ist))
      parameter(inva=(ilip-1))
      parameter(ikva=(inva*ilip/2))
      parameter(inrpmax=(2*inltot+2))
c
c     Control-parameters:
c
      integer nvar,nvareff,kvar,nsta,ksta,legs,lip,neqs,
     &        nsinv,nshcor,nshfix,icount,nshot 
      common/DIMEN/nvar,nvareff,kvar,nsta,ksta,legs,lip,neqs,nshot,
     &             nsinv,nshcor,nshfix, icount
      integer ittmax,invertratio,iresolcalc,ifixsolution
      real    zmin,zmininput,delmin,veladj,swtfac,xythet,
     &        zadj,vthet,othet,zthet,stathet,rmsmin,dmax 
      common/PARAM/ zmin,zmininput,ittmax,delmin,veladj,swtfac,xythet,
     &              invertratio,iresolcalc,
     &              zadj,vthet,othet,zthet,stathet,rmsmin,
     &              dmax,ifixsolution
      integer icnvout,istaout,ismpout,irayout,idrvout,ialeout,idspout,
     &        irflout,irfrout,iresout 
      common/OUTPUTFILES/ icnvout,istaout,ismpout,
     &                    irayout,idrvout,ialeout,idspout,
     &                    irflout,irfrout,iresout
      real zshift
      common/CORR/ zshift
      logical single_turbo
      integer icoordsystem,itrial,ised,isingle,itopo,iturbo,
     &        lowveloclay,ielev,iuseelev,iusestacorr
      real    ztrial
      common/COORDSYST/ icoordsystem, itrial, ztrial, ised, isingle,
     &                  itopo, iturbo,lowveloclay, single_turbo,
     &                  ielev(ist), iuseelev, iusestacorr
c
c     Model-parameters:
c
      integer nmod,nsp,nltot,nplay,laysum
      common/MODELA/ nmod,nsp,nltot,nplay(inltot),laysum(inltot)
      real    v,vsq,h,thk,tkj,delta
      integer jl
      common/LAYER/ v(inltot),vsq(inltot),h(inltot),thk(inltot),jl,tkj,
     &              delta
      real    vp,hp,vdamp,
     &        thkp,vpvs
      integer ireflector,lmax
      character*1 reflchar
      common/LAYVEL/ vp(itotmodels,inltot),hp(itotmodels,inltot),
     &               vdamp(itotmodels,inltot),
     &               thkp(itotmodels,inltot),vpvs,
     &               ireflector,lmax, reflchar       ! lmax added 5.4.91 uk
c
c     Station-parameters:
c
      real     ptcor,stcor,d,x
      integer  map1,map2,model 
      common/STATN/ ptcor(ist),stcor(ist),d(ist,3,ieq),
     &              model(itotmodels*ist),    ! to be verified !!! (hrm 30.3.92)
     &              x(ist,3),map1(ist),map2(ist)
      real     xla,xlo
      common/STLTLN/ xla(ist),xlo(ist)
cccc      character*1 cns,cew
      character*1 prmk
      real        pt,w,sphase,
     &            depthsofinput,tcalc,amx,prx
      integer     kpwt,istm,iphase,knobs,
     &            iain,nobswithw0,idelta,nactualsta,
     &            nstaeff
      common/OBB/ pt(ist,ieq),kpwt(ist,ieq),istm(ist,ieq),w(ist,ieq),
     &            iphase(ist,ieq),sphase(ist,ieq),knobs(ieq),
     &            depthsofinput(ieq),
     &            tcalc(ist),iain(ist),
     &            nobswithw0,amx(ist),prx(ist),idelta(ist),
     &            prmk(ist,2),nactualsta(ist),nstaeff
      real tctime
      common/EXTRA/ tctime(ist,ieq)
c89      character*4 smn,stn,blank,blank0
      character*4 smn,stn,blank,blank0
c89      data blank,blank0 /'    ','0   '/
      common/CHARc/ smn(ist,ieq),stn(ist),blank,blank0
c
c     Event-parameters:
c
      character*32 regionname
      integer      iyr,imo,iday,ihr,imin,ifx,isconstrain,iconstrain,
     &             nmag,nreg
      real         e,emag,xmagni,xmagnitude,sdxmagnitude
      common/EVENT/iyr(ieq),imo(ieq),iday(ieq),ihr(ieq),imin(ieq),
     &             e(4,ieq),emag(ieq),ifx(ieq),
     &             xmagni(ist),nmag,xmagnitude,sdxmagnitude,
     &             regionname,nreg,
     &             isconstrain(3), iconstrain(ieq)
ccc     &             , effdeltaz(ieq)
      integer igap
      common/GAP/ igap(ieq)   ! max. ieq events
c
c     'Normal-equations-parameters':
c
      real rht,res,rms,b,s,avres,steplen
      character*80 smpline
      common/A4/ rht(inva*2),res(ist,ieq),rms(ieq),b(inva*2),s(inva*2),
     &           avres(ieq), steplen,smpline
      real  scale
      common /FIX1/scale(7)
      real g
      common /GMATRIX/g(ikva*2)
      real gcopy
      common /GSAVE/gcopy(60,inva*2)
      real dtdv,dtdr
      common/DTTX/ dtdv(inltot),dtdr(3)
      real gg2,ggt,ggg,gtg,ggti,drm
      common/DATARESOL/gg2(maxobsperevent,4),ggt(4,maxobsperevent),
     &                 ggg(4,maxobsperevent),gtg(4,4),ggti(4,4),
     &                 drm(maxobsperevent,maxobsperevent)
c
      real Rc,Rs,SV,COVc,COVs,ale,R3,GG
      common/goodness/ Rc(4,4),Rs(4,4), SV(4), COVc(4,4),COVs(4),
     &                 ale(ieq),R3(3,3),
     &                 GG(100,100)
c
c     Statistics-parameters:
c
      integer irefrlayer,ihypoclayer,noheadwave,irefllayer
      real    refraylen,avhraylen,avvraylen,hitlay,sterr,
     & direrr,refrerr,reflerr
      common /HITL/ irefrlayer(inltot), ihypoclayer(inltot), noheadwave,
     &              refraylen(inltot), avhraylen,avvraylen,
     &              hitlay(inltot,3),
     &              irefllayer(inltot),sterr,direrr,refrerr,reflerr
      real avrefrres,avotheres,avreflres,abrefrres,
     & abotheres,abreflres,stnazires
      integer nrrefrres,nrotheres,nrreflres
      common /RESIDUALS/ avrefrres,avotheres,avreflres,
     &                   abrefrres,abotheres,abreflres,
     &                   nrrefrres,nrotheres,nrreflres,
     &                   stnazires(ist,8)
      integer ibackups
      real davar1,xmsqrs1
      common/A3/ ibackups,davar1,xmsqrs1
      real spread
      common/QUALITY/ spread
c
c     Files:
c
      common/files/ modelfilename,stationfilename,seismofilename,
     &             scratchfilename
      character*80 modelfilename,stationfilename,seismofilename,
     &             scratchfilename
      common/infiles/ phasefile,shotfile,topo1file,topo2file,
     &                regnamfile,regkoordfile
      character*80 phasefile,shotfile,topo1file,topo2file,
     &             regnamfile,regkoordfile
      common/outfiles/ velfile,cnvfile,rayfile,outfile,smpfile,stafile,
     &                 drvfile,alefile,dsprfile,rflfile,rfrfile,resfile
      character*80 velfile,cnvfile,rayfile,outfile,smpfile,stafile,
     &             drvfile,alefile,dsprfile,rflfile,rfrfile,resfile
c
c     Various other parameters:
c
      character*80 fm, headerline
      integer      iabort,nitt
      common/FORM/ fm, iabort, nitt, headerline(3)
c
c**************   end of VELESTCOMMON.FOR  *******************************

c****************************************************************
c Modified version of Ray Buland's program REMODL, for generating
c random-access tables used in calculating global seismic
c travel times

c must be linked with tau.for and emiasp91.for
c the velocity model is hard-wired in the subroutine
c emiasp91.for. To change it, you need to edit this

c generates the two random access files remodl.hed & remodl.tbl
c which are read by the second program, setbrn.for
c
c  mar 1 99 by jh   --------  version 7.0 check----------------
c                   no changes
c  mar 18 99   lo   call abort without arguments
c  mar 30 99 jh     remove abort
c  dec 09    lo     changed emiask to remodl_emiask

      program remodl
      save
      include 'limits.inc'
      character*8 code
      character*80 fnam
      character*20 modnam
c     logical ldum
      dimension mt(2),kb(2),lt(2),lvz(nlvz0,2)
      double precision taup(nsl1,2),xp(nsl1,2),ttau,tx,pb,pm,zm,pmj,pmi,
     1 zmj,zmi,zmax,zic,zoc,taul(nlvz0,2),xl(nlvz0,2)
      common/pgridc/delx(2),dpmax(2),drmax(2),pp(nsl1,2),xx(nsl1,2),
     1 rr(nsl1,2)
      common/zgridc/pb(nsl1),pm(ndp1,2),zm(ndp1,2),zm0(ndp1,2),
     1 ndex(ndp1,2),n
      common/brkptb/lcb(2),lbb(2),lbrk(nbr2,2)
      common/brkptc/code(nbr1,2)
      common/emodc/r(nmd0),vp(nmd0),vs(nmd0)
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
      common/crtptc/ucrt(ncp0),nc
      common/roughc/ric,roc
      data nout,delx,dpmax,drmax,tol,dtol,xtol,dmax/1,2*200.,2*.01,
     1 2*75.,1e-6,1d-6,1.,800./
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call rough(50.,nk,ncr,modnam)
      a0=r(1)
      fnam='remodl1.lis'//char(0)
      call assign(10,2,fnam)
      write(10,200)nk,ncr,a0,(i,r(i),vp(i),vs(i),i=1,nk)
 200  format(/1x,2i5,f10.2/(i5,f10.2,2f10.4))
      pn=vs(1)
      xn=1/r(1)
      tn=pn*xn
      do 1 i=1,nk
      rn=r(i)*xn
      z(i)=alog(rn)
      u(i,1)=rn*pn/vp(i)
      if(i.le.ncr) u(i,2)=rn*pn/vs(i)
 1    if(i.gt.ncr) u(i,2)=u(i,1)
      write(10,201)(i,r(i),a0*z(i),(u(i,j),j=1,2),i=1,nk)
 201  format(/(1x,i5,2f10.2,2f12.6))
      write(10,202)delx,dpmax,drmax
 202  format(/1x,'delx =',2f10.2/1x,'dpmax -',2f12.6/1x,'drmax =',
     1 2f10.2)
      delx(1)=xn*delx(1)
      delx(2)=xn*delx(2)
      xtol=xtol/a0
c
      call findcp(ncr)
      write(10,203)(i,ucrt(i),i=1,nc)
 203  format(/1x,'critical points'/(1x,i5,f12.6))
c     call assign(11,-2,'crtpt.dat')
c     write(11)nc,(ucrt(i),i=1,nc)
c     call retrns(11)
c
      call pgrid(1,n1,xtol)
c     write(10,204)pp(1,1),xx(1,1),rr(1,1)
c204  format(/5x,'1',f12.6,12x,f12.6,10x,f10.2)
c     write(10,205,iostat=ios)(i,pp(i,1),(pp(i-1,1)-pp(i,1)),xx(i,1),
c    1 a0*(xx(i,1)-xx(i-1,1)),rr(i,1),rr(i-1,1)-rr(i,1),i=2,n1)
c205  format(1x,i5,3f12.6,3f10.2)
      call pgrid(2,n2,xtol)
c     write(10,204)pp(1,2),xx(1,2),rr(1,2)
c     write(10,205,iostat=ios)(i,pp(i,2),(pp(i-1,2)-pp(i,2)),xx(i,2),
c    1 a0*(xx(i,2)-xx(i-1,2)),rr(i,2),rr(i-1,2)-rr(i,2),i=2,n2)
c
      n=0
      j1=1
      k1=1
      do 2 i=1,nc
      ii=i+1
      if(pp(1,1).ge.ucrt(i)-tol) go to 3
      j=1
      go to 4
 3    do 5 j=j1,n1
      if(abs(pp(j,1)-ucrt(ii)).le.tol) go to 4
 5    continue
      j=n1
 4    do 6 k=k1,n2
      if(abs(pp(k,2)-ucrt(ii)).le.tol) go to 7
 6    continue
      k=n2
 7    if(j-j1.le.k-k1) go to 8
      do 9 l=j1,j
      n=n+1
 9    pb(n)=pp(l,1)
      go to 10
 8    do 11 l=k1,k
      n=n+1
 11   pb(n)=pp(l,2)
 10   j1=j+1
 2    k1=k+1
      call retrns(10)
      fnam='remodl2.lis'//char(0)
      call assign(10,2,fnam)
      write(10,211)pb(1)
 211  format(/5x,'1',f12.6)
      write(10,212,iostat=ios)(i,pb(i),(pb(i-1)-pb(i)),i=2,n)
 212  format(1x,i5,0pf12.6,1pe12.2)
      call efe8(n,pb)
      n1=n
      n=n-1
c
      call zgrid(1,mt(1))
      mm=mt(1)
      write(10,206,iostat=ios)(i,pm(i,1),zm(i,1),a0*(zm0(i,1)-
     1 zm0(i+1,1)),a0*(zm(i,1)-zm(i+1,1)),ndex(i,1),i=1,mm)
 206  format(/(1x,i5,0p2f12.6,f10.2,1pe12.4,i5))
      write(10,208,iostat=ios)mm+1,pm(mm+1,1),zm(mm+1,1),ndex(mm+1,1)
 208  format(1x,i5,0p2f12.6,22x,i5)
      call zgrid(2,mt(2))
      mm=mt(2)
      write(10,206,iostat=ios)(i,pm(i,2),zm(i,2),a0*(zm0(i,2)-
     1 zm0(i+1,2)),a0*(zm(i,2)-zm(i+1,2)),ndex(i,2),i=1,mm)
      write(10,208,iostat=ios)mm+1,pm(mm+1,2),zm(mm+1,2),ndex(mm+1,2)
c
c   Set up break pointers.
      call brkpts(mt(1),1)
      write(10,209)(lbrk(i,1),i=1,lbb(1))
 209  format(/(1x,20i5))
      write(10,210)(i,code(i,1),i=1,lcb(1))
 210  format(/(1x,i5,2x,a))
      kb(1)=lbrk(lbb(1),1)
      call brkpts(mt(2),2)
      write(10,209)(lbrk(i,2),i=1,lbb(2))
      write(10,210)(i,code(i,2),i=1,lcb(2))
      kb(2)=lbrk(lbb(2),2)
      write(10,*)
      write(10,*)'n1 kb',n1,kb
c
      ndasr  = 8*(1+2*kb(2))+4
      fnam='remodl.tbl'//char(0)
      call dasign(nout,-2,fnam,ndasr)
      write(10,*) 'reclength for dasign:', ndasr
      n1=kb(2)
      zmax=alog((a0-dmax)*xn)
      zic=alog(ric*xn)
      zoc=alog(roc*xn)
      zlim=zmax
      write(10,*)
      write(10,*)'zmax zoc zic',zmax,zoc,zic
      write(10,*)
c
c   Loop over phases.
c
      nrec=0
      do 17 nph=1,2
      j=1
      lz=0
      n1=kb(nph)
      do 16 i=1,n1
      taup(i,nph)=0d0
 16   xp(i,nph)=0d0
      taup(n1,nph)=tn*1d-6
      xp(n1,nph)=xn*1d-6
      n=n1-1
      mm=mt(nph)+1
      ndex(1,nph)=-1
      zmi=zm(1,nph)
      pmi=pm(1,nph)
c
c   Loop over model slownesses.
c
      do 18 i=2,mm
      zmj=zmi
      zmi=zm(i,nph)
      pmj=pmi
      pmi=pm(i,nph)
      if(dabs(zmj-zmi).le.0d0) go to 19
c
c   Collect the tau and x integrals.
      do 20 k=1,n
      if(pmi.lt.pb(k)) go to 21
      call tauint(pb(k),pmj,pmi,zmj,zmi,ttau,tx)
c     print *,'int',i,k,pb(k),pmj,pmi,dz,ttau,tx
      taup(k,nph)=taup(k,nph)+ttau
 20   xp(k,nph)=xp(k,nph)+tx
      go to 22
 21   n=k-1
 22   if(n.le.1) go to 23
      if(pb(n).eq.pb(n-1)) n=n-1
 23   if(zmj.lt.zlim) go to 18
      j=j+1
      if(zmj.ge.zmax) nrec=nrec+1
      zm(j,nph)=zmi
      pm(j,nph)=pmi
      ndex(j,nph)=nrec
      if(zmj.lt.zmax) go to 18
      write(10,*)'lev1',j,n,nph,sngl(pm(j,nph)),sngl(zm(j,nph))
      write(nout,rec=nrec)zmi,n,(taup(k,nph),k=1,n),(xp(k,nph),k=1,n)
      go to 18
 19   if(dabs(zmi-zoc).gt.dtol.and.dabs(zmi-zic).gt.dtol) go to 25
      if(dabs(zmi-zm(j,nph)).le.dtol) go to 18
      j=j+1
      nrec=nrec+1
      zm(j,nph)=zmi
      pm(j,nph)=pmi
      ndex(j,nph)=nrec
      write(10,*)'lev2',j,n,nph,sngl(pm(j,nph)),sngl(zm(j,nph))
      write(nout,rec=nrec)zmi,n1,(taup(k,nph),k=1,n1),(xp(k,nph),k=1,n1)
      go to 26
 25   if(zmi.lt.zmax) go to 26
      if(dabs(zmi-zm(j-1,nph)).gt.dtol) j=j+1
      zm(j,nph)=zmi
      pm(j,nph)=pmi
      ndex(j,nph)=ndex(j-1,nph)
 26   if(pmi.le.pmj) go to 18
      if(lz.le.0) go to 27
      if(lvz(lz,nph).eq.n) go to 18
 27   lz=lz+1
      lvz(lz,nph)=n
      taul(lz,nph)=taup(n,nph)
      xl(lz,nph)=xp(n,nph)
      write(10,*)'lvz ',lz,n,nph,sngl(taul(lz,nph)),sngl(xl(lz,nph))
 18   continue
      j=j+1
      nrec=nrec+1
      zm(j,nph)=zmi
      pm(j,nph)=pmi
      ndex(j,nph)=nrec
      write(10,*)'lev3',j,n,nph,sngl(pm(j,nph)),sngl(zm(j,nph))
      write(10,*)
      write(nout,rec=nrec)zmi,n1,(taup(k,nph),k=1,n1),(xp(k,nph),k=1,n1)
      mt(nph)=j
      lt(nph)=lz
      if(lz.le.1) go to 34
      call efe4(lz,lvz(1,nph))
      call efe8(lz,taul(1,nph))
      call efe8(lz,xl(1,nph))
c
 34   if(nph.ge.2) go to 17
      do 30 i=1,mm
      if(zm(i,1).lt.zmax) go to 31
 30   continue
      i=mm
 31   plim=pm(i,1)
      write(10,*)'i zmax plim zm(i,1) =',i,zmax,plim,zm(i,1)
      do 32 i=1,mm
      if(pm(i,2).le.plim) go to 33
 32   continue
      i=mm
 33   zlim=zm(i,2)
      write(10,*)'i plim zlim =',i,plim,zlim
c
 17   continue
      call retrns(nout)
c
      fnam='remodl.hed'//char(0)
      call assign(nout,-2,fnam)

      write(nout)ndasr,modnam,zmax,zoc,zic,kb,(pb(i),i=1,n1),
     1 mt,lt,lbb,lcb,xn,pn,tn
      write(nout)((lbrk(i,nph),i=1,lbb(nph)),(code(i,nph),
     1 i=1,lcb(nph)),(zm(i,nph),pm(i,nph),ndex(i,nph),i=1,mt(nph)),
     2 (lvz(i,nph),taul(i,nph),xl(i,nph),i=1,lt(nph)),nph=1,2)
      call retrns(nout)
      call retrns(10)
      call vexit(0)
      end
c
      subroutine rough(dr,n,ncr,modnam)
c
c $$$$$ calls emdld and emdlv $$$$$
c
c   Rough provides a rough interpolation of the earth model available
c   through routine emdlv.  The model radii, compressional velocity, and
c   shear velocity are provided in arrays r, vp, and vs respectively.
c   Between first order discontinuities available through routine emdld,
c   the radii are equally spaced as close to spacing dr as possible.  The
c   number of radii used is returned in variable n and the index of the
c   core-mantle radius is returned in ncr.  Note that emdld returns the
c   radii of the discontinuities from the center of the earth out while
c   rough returns the model from the surface in.  Also note that in the
c   model returned by rough, each discontinuity will be represented by
c   two model ajacent model points with the same radius.
c
      save
      include 'limits.inc'
      character*20 modnam
      dimension rd(30)
      common/emodc/r(nmd0),vp(nmd0),vs(nmd0)
      common/roughc/ric,roc
      data tol,vtol/1e-6,2e-5/
c
c   Get the radii of model discontinuities.
      call emdld(np,rd,modnam)
c   Save the radii of the inner core-outer core and core-mantle boundaries
c   respectively.
      ric=rd(1)
      roc=rd(2)
c
c   Begin the interpolation.
c
      n=0
      i=np-1
      r1=rd(np)
c   Loop over each layer (between two discontinuities).
 1    r0=r1
      r1=.001
      if(i.gt.0) r1=rd(i)
      l=(r0-r1)/dr-.5
      dx=(r0-r1)/(l+1)
c   Set the outer most point of the layer.
      n=n+1
      r(n)=r0
      call emdlv(r0*(1.-tol),vp(n),vs(n))
c   Check for continuity across an apparant discontinuity.
      if(n.le.1) go to 2
c   If vp is close to continuous, force it.
      if(abs(vp(n-1)-vp(n)).gt.vtol*vp(n)) go to 6
      vp(n-1)=.5*(vp(n-1)+vp(n))
      vp(n)=vp(n-1)
c   If vs is close to continuous, force it.
 6    if(abs(vs(n-1)-vs(n)).gt.vtol*vs(n)) go to 2
      vs(n-1)=.5*(vs(n-1)+vs(n))
      vs(n)=vs(n-1)
c   Make P and S velocity the same if we are in a fluid.
 2    if(i.le.1) vs(n)=vp(n)
c   Interpolate the model throughout the layer.
      if(l.le.0) go to 4
      do 3 j=1,l
      n=n+1
      r(n)=r0-j*dx
      call emdlv(r(n),vp(n),vs(n))
c   Make P and S velocity the same if we are in a fluid.
 3    if(i.le.1) vs(n)=vp(n)
c   Set the inner most point of the layer.
 4    n=n+1
      r(n)=r1
      call emdlv(r1*(1.+tol),vp(n),vs(n))
c   Make P and S velocity the same if we are in a fluid.
      if(i.le.1) vs(n)=vp(n)
c   Set the index to the core-mantle radius.
      if(i.eq.2) ncr=n
      i=i-1
c   If there is another layer, go do it.
      if(i.ge.0) go to 1
      return
      end
c
      subroutine findcp(ncr)
c
c $$$$$ calls crtpt $$$$$
c
c        find critical points
      save
      include 'limits.inc'
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
      common/crtptc/ucrt(ncp0),nc
      data tol/1e-6/
c
      ifl=1
      kfl=1
      j=1
      call crtpt(1,1)
      call crtpt(1,2)
      do 5 i=2,nk
      if(abs(z(j)-z(i)).gt.tol) go to 6
      call crtpt(j,1)
      call crtpt(i,1)
      if(j.le.ncr) call crtpt(j,2)
      if(i.le.ncr) call crtpt(i,2)
      go to 5
 6    go to (7,8),ifl
 7    if(u(i,1).le.u(j,1)) go to 2
      ifl=2
      call crtpt(j,1)
      go to 2
 8    if(u(i,1).ge.u(j,1)) go to 2
      ifl=1
      call crtpt(j,1)
 2    if(i.gt.ncr) go to 5
      go to (3,4),kfl
 3    if(u(i,2).le.u(j,2)) go to 5
      kfl=2
      call crtpt(j,2)
      go to 5
 4    if(u(i,2).ge.u(j,2)) go to 5
      kfl=1
      call crtpt(j,2)
 5    j=i
      ucrt(nc+1)=0.
      return
      end
c
      subroutine crtpt(k,nph)
c
c $$$$$ calls no other routine $$$$$
c
c   For each critical point (slowness corresponding to a first order
c   discontinuity) save slowness u(k,nph) in array ucrt and sort it
c   into descending order.  Note that k indexes an equivalent depth and
c   nph indexes either P or V slownesses.
c
      save
      include 'limits.inc'
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
      common/crtptc/ucrt(ncp0),nc
      data nc/0/,tol/1e-6/
c   Eliminate duplicates.
      if(nc.le.0) go to 3
      do 2 i=1,nc
      if(abs(ucrt(i)-u(k,nph)).gt.tol) go to 2
      write(10,*)'duplicate critical value eliminated:',u(k,nph)
      return
 2    continue
c
 3    nc=nc+1
      ucrt(nc)=u(k,nph)
      if(nc.le.1) return
      j=nc
      do 1 i=2,nc
      if(ucrt(j-1).ge.ucrt(j)) return
      utmp=ucrt(j-1)
      ucrt(j-1)=ucrt(j)
      ucrt(j)=utmp
 1    j=j-1
      return
      end
c
      subroutine pgrid(nph,n0,xtol)
      save 
      parameter(mxtmp=200)
      include 'limits.inc'
      dimension ps(mxtmp),xs(mxtmp),pb(3),xb(3)
      common/pgridc/delx(2),dpmax(2),drmax(2),pp(nsl1,2),xx(nsl1,2),
     1 rr(nsl1,2)
      common/emodc/r(nmd0),vp(nmd0),vs(nmd0)
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
      common/crtptc/ucrt(ncp0),nc
      data tol/1e-5/
c
      a0=1./xn
      do 1 i=1,nc
      if(abs(u(1,nph)-ucrt(i)).le.tol) go to 2
 1    continue
 2    ic=i
c
      n=0
      j=ic+1
      do 20 i=ic,nc 
      write(10,210)'i',i,ucrt(i),ucrt(j)
 210  format(10x,a,i5,2f12.6)
c
      ifl=1
      ps(1)=ucrt(i)
      xs(1)=xmod(ucrt(i),nph,1,nr,r0)
      x0=xmod(ucrt(j),nph,-1,nr,r1)
      l=max0(int(abs(x0-xs(1))/delx(nph)+.8),1)
      du=(ps(1)-ucrt(j))/(l*l)
c     write(10,*)'overflow???  x0 x1 l du nr r1',
c    1 xs(1),x0,l+1,du,nr,r1
      l=l-1
      do 3 k=1,l
      ps(k+1)=ps(1)-k*k*du
 3    xs(k+1)=xmod(ps(k+1),nph,1,nr,r2)
      l=l+2
      ps(l)=ucrt(j)
      xs(l)=x0
c     write(10,*)'***** i l',i,l
c
 19   x0=xs(2)-xs(1)
      do 4 k=3,l
      if((xs(k)-xs(k-1))*x0.le.0.) go to 5
 4    continue
      go to 6
c
 5    ifl=ifl+1
      r2=r1
      write(10,210)'caustic'
      k=k-1
      kk=k-2
      do 7 m=1,3
      kk=kk+1
      pb(m)=ps(kk)
 7    xb(m)=xs(kk)
      sgn=sign(1.,.5*(xb(1)+xb(3))-xb(2))
 11   u0=.5*(pb(1)+pb(2))
      x0=xmod(u0,nph,1,nr,r1)
      if(sgn*(xb(2)-x0).lt.0.) go to 8
      pb(3)=pb(2)
      xb(3)=xb(2)
      pb(2)=u0
      xb(2)=x0
      go to 9
 8    pb(1)=u0
      xb(1)=x0
      u0=.5*(pb(2)+pb(3))
      x0=xmod(u0,nph,1,nr,r1)
      if(sgn*(xb(2)-x0).lt.0.) go to 10
      pb(1)=pb(2)
      xb(1)=xb(2)
      pb(2)=u0
      xb(2)=x0
      go to 9
 10   pb(3)=u0
      xb(3)=x0
 9    if(abs(xb(3)-xb(1)).gt.xtol) go to 11
      ps(k)=pb(2)
      xs(k)=xb(2)
      lsav=l
      l=k
c
 6    if(i.ne.ic) go to 21
      n=n+1
      pp(n,nph)=ps(1)
      xx(n,nph)=xs(1)
      rr(n,nph)=r0
      write(10,201)'first ',n,pp(n,nph),xx(n,nph),rr(n,nph)
 21   k=max0(int(abs(xs(l)-xs(1))/delx(nph)+.8),1)
      dx=(xs(l)-xs(1))/k
      x0=xs(1)
      rsav=r0
      mm=2
 12   x0=x0+dx
      n=n+1
      if(abs(x0-xs(l)).gt.tol) go to 24
      pp(n,nph)=ps(l)
      xx(n,nph)=xs(l)
      rr(n,nph)=r1
      go to 22
 24   do 14 kk=mm,l
      if((x0-xs(kk))*(x0-xs(kk-1)).le.0.) go to 15
 14   continue
      kk=l
 15   mm=kk
      call finrng(x0,nph,n,ps(kk),ps(kk-1),xs(kk),xs(kk-1),xtol,nr)
      write(10,201)'sol   ',n,pp(n,nph),xx(n,nph),rr(n,nph),nr,
     1 pp(n-1,nph)-pp(n,nph),a0*(xx(n,nph)-xx(n-1,nph)),rsav-rr(n,nph)
 201  format(1x,a6,i5,2f10.6,f9.2,i5,f10.6,2f9.2)
 22   if(abs(pp(n,nph)-pp(n-1,nph)).le.dpmax(nph)) go to 16
      ll=max0(int(abs(ps(l)-pp(n-1,nph))/dpmax(nph)+.99),1)
      pp(n,nph)=pp(n-1,nph)+(ps(l)-pp(n-1,nph))/ll
      xx(n,nph)=xmod(pp(n,nph),nph,1,nr,rr(n,nph))
      write(10,201)' dpmax',n,pp(n,nph),xx(n,nph),rr(n,nph),nr,
     1 pp(n-1,nph)-pp(n,nph),a0*(xx(n,nph)-xx(n-1,nph)),rsav-rr(n,nph)
      k=max0(int(abs(xs(l)-xx(n,nph))/delx(nph)+.8),1)
      dx=(xs(l)-xx(n,nph))/k
      x0=xx(n,nph)
      mm=2
 16   if(abs(rr(n,nph)-rsav).le.drmax(nph)) go to 23
      rnew=rsav-drmax(nph)
 26   if(rnew.le.r(nr)) go to 25
      nr=nr-1
      go to 26
 25   if(nr.lt.nk) du=abs(pp(n-1,nph)-u(nr,nph)*(rnew/r(nr))**
     1 (alog(u(nr+1,nph)/u(nr,nph))/alog(r(nr+1)/r(nr))))
      if(nr.ge.nk) du=abs(pp(n-1,nph)-u(nk,nph)*rnew/r(nk))
      ll=max0(int(abs(ps(l)-pp(n-1,nph))/du+.99),1)
      pp(n,nph)=pp(n-1,nph)+(ps(l)-pp(n-1,nph))/ll
      xx(n,nph)=xmod(pp(n,nph),nph,1,nr,rr(n,nph))
      write(10,201)' drmax',n,pp(n,nph),xx(n,nph),rr(n,nph),nr,
     1 pp(n-1,nph)-pp(n,nph),a0*(xx(n,nph)-xx(n-1,nph)),rsav-rr(n,nph)
      k=max0(int(abs(xs(l)-xx(n,nph))/delx(nph)+.8),1)
      dx=(xs(l)-xx(n,nph))/k
      x0=xx(n,nph)
      mm=2
 23   rsav=rr(n,nph)
      if(abs(x0-xs(l)).gt.tol) go to 12
c
 17   write(10,201)'end   ',n,pp(n,nph),xx(n,nph),rr(n,nph),nr,
     1 pp(n-1,nph)-pp(n,nph),a0*(xx(n,nph)-xx(n-1,nph)),rr(n-1,nph)-
     2 rr(n,nph)
      ifl=ifl-1
      if(ifl.le.0) go to 20
      k=0
      do 18 m=l,lsav
      k=k+1
      ps(k)=ps(m)
 18   xs(k)=xs(m)
c     write(10,*)'+++++ i l lsav k',i,l,lsav,k
      l=lsav-l+1
      r0=r1
      r1=r2
      go to 19
c
 20   j=j+1
      n0=n
      return
      end
c
      function xmod(pk,nph,ipart,nr,rb)
c        partial tau integrals
      save 
      include 'limits.inc'
      common/emodc/r(nmd0),vp(nmd0),vs(nmd0)
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
c
      if(pk.gt.0.) go to 4
      x=-1.5707963
      nr=nk
      rb=0.
      go to 3
 4    p2=pk*pk
      x=0.
      j=1
      do 1 i=2,nk
      if(pk.gt.u(i,nph)) go to 2
      if(u(j,nph).ne.u(i,nph)) x=x+(z(i)-z(j))*
     1 (acos(pk/u(j,nph))-acos(pk/u(i,nph)))/alog(u(j,nph)/u(i,nph))
      if(pk.ne.u(i,nph).or.ipart.ge.0) go to 1
      nr=i
      rb=r(i)
      go to 3
 1    j=i
      nr=nk
      rb=r(nk)*pk/u(nk,nph)
      zb=alog(rb*xn)
      if(u(nk,nph).gt.pk) x=x+(zb-z(nk))*acos(pk/u(nk,nph))/
     1 alog(u(nk,nph)/pk)
      go to 3
 2    nr=j
      rb=r(j)*(pk/u(j,nph))**(alog(r(i)/r(j))/alog(u(i,nph)/u(j,nph)))
      zb=alog(rb*xn)
      if(u(j,nph).gt.pk) x=x+(zb-z(j))*acos(pk/u(j,nph))/
     1 alog(u(j,nph)/pk)
 3    xmod=-2.*x
      return
      end
c
      subroutine finrng(xg,nph,n,p0,p1,x0,x1,xtol,nr)
c        iteration on range
c
c $$$$$ calls xmod $$$$$
c
c   Function find0 returns x0 for which f(x0) = 0 where f(x) is a
c   function supplied by the user (specified external in the calling
c   routine).  X1 and x2 are the starting trial points.  Function
c   evaluations are made until x0 is determined to a relative precision
c   of eps by a process of inverse iterative interpolation using
c   Aitken's method.
c
c                                                     -rpb
      save 
      include 'limits.inc'
      character*80 msg
      common/pgridc/delx(2),dpmax(2),drmax(2),pp(nsl1,2),xx(nsl1,2),
     1 rr(nsl1,2)
      common/findc/x(20),y(20),m
c
      m=1
      if((x1-xg)*(x0-xg).le.0.) go to 7
      stop 'Root not bracketed.'
c   If the limits are already close together, there is no point in
c   iterating.
 7    if(abs(x0-x1).gt.xtol) go to 3
      pp(n,nph)=.5*(p0+p1)
      xx(n,nph)=xmod(pp(n,nph),nph,1,nr,rr(n,nph))
      return
c   Set up iteration with first two trial points, x1 and x2.
 3    y(1)=x0-xg
      if(abs(y(1)).gt.xtol) go to 4
      pp(n,nph)=p0
      xx(n,nph)=xmod(pp(n,nph),nph,1,nr,rr(n,nph))
      return
 4    x(1)=p0
      yi=x1-xg
      if(abs(yi).gt.xtol) go to 5
      pp(n,nph)=p1
      xx(n,nph)=xmod(pp(n,nph),nph,1,nr,rr(n,nph))
      return
 5    if(y(1).gt.yi) go to 8
      ps0=p0
      xs0=y(1)
      ps1=p1
      xs1=yi
      go to 9
 8    ps0=p1
      xs0=yi
      ps1=p0
      xs1=y(1)
 9    xi=(p0*yi-p1*y(1))/(yi-y(1))
c   Iterate.
      do 1 m=2,20
      if((xi-ps0)*(xi-ps1).le.0.) go to 10
      xi=.5*(ps0+ps1)
c   Save the current best guess of the zero.
 10   y(m)=yi
      x(m)=xi
c   Start iteration at the current best guess of the zero.
      yi=xmod(xi,nph,1,nr,r0)-xg
c   Check for convergence.
      if(abs(yi).le.xtol) go to 6
      if(yi.gt.0.) go to 11
      ps0=xi
      xs0=yi
      go to 2
 11   ps1=xi
      xs1=yi
 2    do 1 j=1,m
 1    xi=(x(j)*yi-xi*y(j))/(yi-y(j))
      write(6,100)n,nph,xg
 100  format('Iteration did not converge:  n, nph, xg -',i4,i2,f7.4)
c     call abort
c      call abort(msg)
      stop
c   Return the final best guess of the zero.
 6    pp(n,nph)=xi
      xx(n,nph)=yi+xg
      rr(n,nph)=r0
      return
      end
c
      subroutine zgrid(nph,m0)
c         depth grid
      save 
      include 'limits.inc'
      double precision pb,pm,zm
      common/zgridc/pb(nsl1),pm(ndp1,2),zm(ndp1,2),zm0(ndp1,2),
     1 ndex(ndp1,2),n
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
      data tol/1e-6/
c
      n1=n+1
      do 1 i=n1,1,-1
      if(abs(u(1,nph)-sngl(pb(i))).le.tol) go to 2
 1    continue
 2    n1=i
      write(10,*)'zgrid',n1,u(1,nph),sngl(pb(n1))
      l=1
      i=n1-1
      j=1
      pm(1,nph)=pb(n1)
      zm(1,nph)=z(1)
      zm0(1,nph)=1.
      ndex(1,nph)=n1
 9    if(u(j+1,nph).le.pb(i)) go to 10
      if(u(j+1,nph).gt.u(j,nph)) go to 11
      j=j+1
      go to 9
 11   i=i+2
 12   if(u(j+1,nph)-pb(i)) 15,16,10
 15   j=j+1
      go to 12
 16   j=j+1
 10   l=l+1
      pm(l,nph)=pb(i)
      zm(l,nph)=findep(sngl(pb(i)),j,nph)
      zm0(l,nph)=dexp(zm(l,nph))
      ndex(l,nph)=i
      if(i.le.2) go to 14
      i=i-1
      go to 9
 14   m=l
      m1=m+1
      pm(m1,nph)=pb(1)
      zm(m1,nph)=-1d6
      zm0(m1,nph)=0.
      ndex(m1,nph)=1
      m0=m
      return
      end
c
      function findep(u0,k,nph)
c
c $$$$$ calls emdlv $$$$$
c
c   Function findep returns the equivalent depth for which the model
c   slowness is u0.  If nph = 1, P slownesses are searched.  If nph = 2,
c   S slownesses are searched.  K is taken as the index into equivalent
c   depth near where the desired slowness should be found.  Function
c   evaluations are made until u0 is fit to a relative precision of aep
c   by a process of inverse iterative interpolation using Aitken's method.
c
      save
      include 'limits.inc'
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
      common/roughc/ric,roc
      common/findc/x(20),y(20),m
      data aep/1e-6/
c
      m=1
      a0=1./xn
      if(abs(z(k)-z(k+1)).le.-aep*z(k)) go to 14
      kph=nph
      x1=exp(z(k+1))
      x2=exp(z(k))
      if(a0*x1.lt.roc) kph=1
c   Set up iteration with first two trial points, x1 and x2.
      if(k+1.ge.nk) go to 3
      if(abs(z(k+1)-z(k+2)).gt.-aep*z(k+1)) go to 3
      call emdlv(a0*x1*(1.+aep),vp,vs)
      go to 4
 3    call emdlv(a0*x1,vp,vs)
 4    if(kph.eq.1) y(1)=pn*x1/vp-u0
      if(kph.eq.2) y(1)=pn*x1/vs-u0
      if(abs(y(1)).gt.aep*u0) go to 7
      findep=z(k+1)
      return
 7    x(1)=x1
      if(k.le.1) go to 5
      if(abs(z(k-1)-z(k)).gt.-aep*z(k)) go to 5
      call emdlv(a0*x2*(1.-aep),vp,vs)
      go to 6
 5    call emdlv(a0*x2,vp,vs)
 6    if(kph.eq.1) yi=pn*x2/vp-u0
      if(kph.eq.2) yi=pn*x2/vs-u0
      if(abs(yi).le.aep*u0.or.yi.eq.y(1)) go to 14
      xi=(x1*yi-x2*y(1))/(yi-y(1))
      if(abs(xi-x1).le.aep*amax1(abs(xi),aep).or.abs(xi-x2).le.
     1 aep*amax1(abs(xi),aep)) go to 13
c   Iterate.
      do 1 m=2,20
c   Save the current best guess of the zero.
      y(m)=yi
      x(m)=xi
c   Start iteration at the current best guess of the zero.
      call emdlv(a0*xi,vp,vs)
      if(kph.eq.1) yi=pn*xi/vp-u0
      if(kph.eq.2) yi=pn*xi/vs-u0
      do 2 j=1,m
      if(yi.eq.y(j)) go to 13
 2    xi=(x(j)*yi-xi*y(j))/(yi-y(j))
c   Check for convergence.
 1    if(abs(xi-x(m)).le.aep*amax1(abs(xi),aep)) go to 13
      m=0
c   Return the final best guess of the zero.
 13   findep=alog(amax1(xi,aep))
      return
 14   findep=z(k)
      return
      end
c
      subroutine brkpts(m,nph)
c
c $$$$$ calls efec, efe4, efe8, and phcod $$$$$
c
c        sets up discontinuity information
      save
      include 'limits.inc'
      character*8 code,tmp
      double precision pb,pm,zm
      common/zgridc/pb(nsl1),pm(ndp1,2),zm(ndp1,2),zm0(ndp1,2),
     1 ndex(ndp1,2),n
      common/brkptb/lcb(2),lbb(2),lbrk(nbr2,2)
      common/brkptc/code(nbr1,2)
      data dtol/1d-6/
c
      lb=1
      lbrk(1,nph)=ndex(1,nph)
      lc=0
      i=1
      isw=1
c   Search for discontinuities.
 17   if(dabs(zm(i,nph)-zm(i+1,nph)).le.-zm(i+1,nph)*dtol) go to 18
      if(i.ge.m) go to 22
      i=i+1
c   No discontinuity.
      go to (29,30),isw
c   Have we hit a high slowness zone?
 29   if(pm(i,nph).le.pm(i-1,nph)) go to 17
c   Yes, flag it.
      isw=2
c   If the high slowness zone is topped with a discontinuity, go back
c   to the usual processing.
      if(lbrk(lb,nph).eq.ndex(i-1,nph)) go to 17
c   Otherwise, mark the grazing ray to the top of the zone.
      lb=lb+1
      lbrk(lb,nph)=ndex(i-1,nph)
      call phcod(lc,nph,sngl(zm(i-1,nph)),-1)
      go to 17
c   We are already in a high slowness zone.  See if we have hit bottom.
 30   if(pm(i,nph).ge.pm(i-1,nph)) go to 17
c   Yes we have.  Reset the high slowness zone flag.
      isw=1
      go to 17
c   Discontinuity!  See what kind.
 18   if(pm(i+1,nph).gt.pm(i,nph)) go to 19
c   Velocity increase.  Flag the bottom of the step.
      lb=lb+1
      lbrk(lb,nph)=ndex(i,nph)
      call phcod(lc,nph,sngl(zm(i,nph)),1)
      if(lbrk(lb,nph).lt.lbrk(lb-1,nph)) go to 20
      lb=lb-1
      lc=lc-1
      code(lc,nph)=code(lc+1,nph)
c   Find the top of the discontinuity.
 20   if(i.ge.m) go to 22
      i=i+1
      if(dabs(zm(i,nph)-zm(i+1,nph)).le.-zm(i+1,nph)*dtol) go to 20
c   Flag the top of the step.
      lb=lb+1
      lbrk(lb,nph)=ndex(i,nph)
      if(lbrk(lb,nph).lt.lbrk(lb-1,nph)) go to 17
      lb=lb-1
      lc=lc-1
      go to 17
c   Velocity decrease. Flag the top of the step.
 19   lb=lb+1
      lbrk(lb,nph)=ndex(i,nph)
      call phcod(lc,nph,sngl(zm(i,nph)),-1)
c   Find the bottom of the discontinuity.
 21   if(i.ge.m) go to 22
      i=i+1
      if(dabs(zm(i,nph)-zm(i+1,nph))+zm(i+1,nph)*dtol)21,21,17
c   We have hit the bottom of the model.
 22   call phcod(lc,nph,sngl(zm(m,nph)),-1)
      call efe4(lb,lbrk(1,nph))
      call efec(lc,code(1,nph),tmp)
      lbb(nph)=lb
      lcb(nph)=lc
      return
      end
c
      subroutine phcod(lc,nph,z0,kfl)
c         set up phase codes
      save 
      include 'limits.inc'
      character*8 code
      character*1 tag,suf
      character*2 pre
      character*4 dep
      character*10 buf
      common/brkptc/code(nbr1,2)
      common/xmodc/z(nmd0),u(nmd0,2),xn,tn,pn,nk
      common/roughc/ric,roc
      data ln/8/
c
      d0=(1.-exp(z0))/xn
      r0=1./xn-d0
      idep=d0+.5
      if(lc.gt.0) go to 1
      lc=1
      pre=' '
      suf=' '
      if(nph.le.1) tag='P'
      if(nph.ge.2) tag='S'
      code(lc,nph)='t'//tag//'g'
      go to 2
 1    lc=lc+1
      if(idep.gt.70) go to 3
      code(lc,nph)='t'//tag//'b'
      if(code(lc-1,nph)(3:3).eq.'b') code(lc-1,nph)(3:3)='g'
      if(code(lc-2,nph)(3:3).eq.'b') code(lc-2,nph)(3:3)='g'
      go to 2
 3    if(pre.eq.' ') code(lc,nph)='t'//tag
      if(pre.ne.' ') code(lc,nph)='t'//tag//pre//suf//tag
      if(code(lc-2,nph)(3:3).ne.'g'.and.code(lc-2,nph)(3:3).ne.'b')
     1  go to 9
      code(lc,nph)(3:3)='n'
      code(lc-1,nph)='r'//tag//'m'//tag
 9    j=0
      do 4 i=1,ln
      if(code(lc,nph)(i:i).eq.' ') go to 4
      j=j+1
      code(lc,nph)(j:j)=code(lc,nph)(i:i)
 4    continue
      if(j.lt.ln) code(lc,nph)(j+1:ln)=' '
      if(code(lc,nph)(2:4).eq.'PKP') code(lc,nph)(2:6)='PKPab'
      if(code(lc,nph)(2:6).eq.'PKIKP') code(lc,nph)(2:6)='PKPdf'
      if(code(lc,nph)(2:4).eq.'SKS') code(lc,nph)(2:6)='SKSab'
      if(code(lc,nph)(2:6).eq.'SKIKS') code(lc,nph)(2:6)='SKSdf'
      if(abs(r0-roc).gt.20.) go to 5
      pre='K'
      if(kfl.le.0) return
      lc=lc+1
      code(lc,nph)='r'//tag//'c'//tag
      return
 5    if(abs(r0-ric).gt.20.) go to 2
      pre='KI'
      suf='K'
      if(kfl.le.0) return
      lc=lc+1
      code(lc,nph)='r'//tag//'KiK'//tag
      return
 2    if(kfl.le.0) return
      lc=lc+1
      write(dep,100)idep
 100  format(i4)
      buf=tag//pre//'d'//dep//suf//tag
      code(lc,nph)='r'
      j=1
      do 8 i=1,10
      if(buf(i:i).eq.' '.or.j.ge.ln) go to 8
      j=j+1
      code(lc,nph)(j:j)=buf(i:i)
 8    continue
      if(j.lt.ln) code(lc,nph)(j+1:ln)=' '
      return
      end
c
      subroutine efe4(n,na)
c
c $$$$$ calls no other routine $$$$$
c
c   Integer array na(n) is transposed end-for-end.
c
      save
      dimension na(n)
c
      if(n.le.1) return
      n2=n/2
      j=n
      do 1 i=1,n2
      nb=na(i)
      na(i)=na(j)
      na(j)=nb
 1    j=j-1
      return
      end
c
      subroutine efe8(n,da)
c
c $$$$$ calls no other routine $$$$$
c
c   Double precision array da(n) is transposed end-for-end.
c
      save
      double precision da(n)
      double precision db
c
      if(n.le.1) return
      n2=n/2
      j=n
      do 2 i=1,n2
      db=da(i)
      da(i)=da(j)
      da(j)=db
 2    j=j-1
      return
      end
c
      subroutine efec(n,ia,ib)
c
c $$$$$ calls no other routine $$$$$
c
c   Character array ia(n) is transposed end-for-end.  Ib must be a
c   character variable with the same character width as each element of
c   array ia.
c
      save
      character*8 ia(n),ib
c
      if(n.le.1) return
      n2=n/2
      j=n
      do 3 i=1,n2
      ib=ia(i)
      ia(i)=ia(j)
      ia(j)=ib
 3    j=j-1
      return
      end

      subroutine emdlv(r,vp,vs)
c         set up information on earth model (specified by
c         subroutine call emiasp)
c         set dimension of cpr,rd  equal to number of radial
c         discontinuities in model
      save
      character*20 modnam,name
      dimension cpr(11)
      common/emdlc/np,rd(11)
      data np,rd/11,1217.1,3482.0,3631.,5611.,5711.,5961.,6161.,
     1 6251.,6336.,6351.,6371./,rn,vn/1.5696123e-4,6.8501006/
      data modnam/'IASP91 '/
c
      call remodl_emiask(rn*r,rho,vp,vs)
      vp=vn*vp
      vs=vn*vs
      return
c
      entry emdld(n,cpr,name)
      n=np
      name=modnam
      do 1 i=1,np
 1    cpr(i)=rd(i)
      return
      end
c
      subroutine remodl_emiask(x0,ro,vp,vs)
c
c $$$$$ calls no other routine $$$$$
c
c   Emiask returns model parameters for the IASPEI working model 
c   (September 1990.1).  
c   Given non-dimensionalized radius x0, emiasp returns
c   non-dimensionalized density, ro, compressional velocity, vp, and
c   shear velocity, vs.  Non-dimensionalization is according to the
c   scheme of Gilbert in program EOS:  x0 by a (the radius of the
c   Earth), ro by robar (the mean density of the Earth), and velocity
c   by a*sqrt(pi*G*robar) (where G is the universal gravitational
c   constant.
c
c
      save
      dimension r(14),d(13,4),p(13,4),s(13,4)
      data r/0.      ,1217.1  ,3482.0  ,3631.  ,5611.   ,5711.   ,
     1 5961.   ,6161.   ,6251.   ,6336.   ,6351.    ,6371.    ,
     2 6371.,6371./
      data d/13.01219,12.58416, 6.8143 , 6.8143 , 6.8143 ,11.11978,
     1  7.15855, 7.15855, 7.15855,  2.92  , 2.72   , 2*0.,
     2        0.     ,-1.69929,-1.66273,-1.66273,-1.66273,-7.87054,
     2 -3.85999,-3.85999,-3.85999,4*0.,
     3       -8.45292,-1.94128,-1.18531,-1.18531,-1.18531,8*0.,
     4        0.     ,-7.11215,11*0./
      data p/11.24094,10.03904,14.49470,25.1486 ,25.969838,29.38896,
     1 30.78765,25.41389, 8.785412, 6.5   , 5.8   ,2*0.,
     2        0.   , 3.75665, -1.47089,-41.1538, -16.934118,-21.40656,
     2-23.25415,-17.69722,-0.7495294, 4*0.,
     3       -4.09689,-13.67046, 0.0  ,51.9932,9*0.,
     4        0.     , 0.      , 0.     ,-26.6083,9*0./
      data s/ 3.56454, 0.      , 8.16616,12.9303 ,20.768902,17.70732,
     1 15.24213,5.750203, 6.706232, 3.75   , 3.36   ,2*0.,
     2        0.     , 0.      ,-1.58206,-21.2590,-16.531471,-13.50652,
     2-11.08553,-1.274202,-2.248585, 4*0.,
     3       -3.45241, 0.      , 0.0    ,27.8988 ,9*0.,
     4        0.     , 0.      , 0.     ,-14.1080,9*0./
      data xn,rn,vn/6371.,.18125793,.14598326/,i/1/
c
      x=amax1(x0,0.)
      x1=xn*x
 2    if(x1.ge.r(i)) go to 1
      i=i-1
      go to 2
 1    if(x1.le.r(i+1).or.i.ge.11) go to 3
      i=i+1
      if(i.lt.11) go to 1
 3    ro=rn*(d(i,1)+x*(d(i,2)+x*(d(i,3)+x*d(i,4))))
      vp=vn*(p(i,1)+x*(p(i,2)+x*(p(i,3)+x*p(i,4))))
      vs=vn*(s(i,1)+x*(s(i,2)+x*(s(i,3)+x*s(i,4))))
      return
      end

c
c  converts Geosys GRS16 and GBV to SEISAN format
c  has also been tested with GSR 24, only for 3 channels, nver tested with
c  more than 3 channels so hardwired to a a max of 3, would probably
c  also work with more channels if changed
c  channels can only be defined using the grssei.def definition file
c
c  j. havskov, april 98
c
c    may 11  00    lo : use read_resp_head
c
c  Testdata and help was provided by Geosys
c
c  updates:
c  march 24, 99 by jh : read number of channels
c  march 28           : sample rate was wrong
c  may 6, 99 by jh    : -----------   version 7.0 ----------------------
c                       standard conversion program features, 5 char stat
c                       year 2000
c  may 24             : null net code
c  august 23          : use station code defined in file instead of ser. number
c  sep 22 lo          : moved routine bcd to LIB
c  feb 15 2000 jh     : if channels larger than 3, set to 3, needed to read
c                       older gsr file without number of channels given
c  sep 10 2003 jh     : adopt to 4 byte data, correct for preevent, group delay and millisecs
c  oct 22 2004 jh     : bug in above
c  aug 06      jh     : more info output, make it work with GSR24
c

      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      include 'version.inc'
c-----------------------------------------------------------------------
c   start block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace),doy
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)
      double precision total_time	  
c
c--end block of definitions most conversion programs
c---------------------------------------------------------------------

c-- output data vector	  
      integer*2  data(max_sample)
      integer*4  data4(max_sample)
      character*80 text   ! general text
      character*512 block  ! input file header
      integer*2 i_rate
      character*2 c_rate
      character*2 c_group_delay
      integer*2 group_delay
      character*2 c_millisec
      integer*2   millisec
      
c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question
c-- 2 or 4 byte
      logical four_byte	  
c--Counters etc
	  integer i,irec
c-- computer type
      logical pc,sun,linux
      integer seiclen	  
c---------------------------
c-- help for swap
      character*4 xs
      integer ixs
      integer i_samp    ! number of samples
      character*4 c_samp! ----------------
      integer*2 pre_event  ! preevent time in seconds
      character*2 c_pre_event
      real time_correction
      integer*2 nch               ! number of channels
      character*2 c_nch
      character*5 s_number        ! seriel number of current station
c
      equivalence(i_rate,c_rate)
      equivalence (c_samp,i_samp)
      equivalence (ixs,xs)
      equivalence (c_nch,nch)
      equivalence (c_group_delay,group_delay)
      equivalence (c_millisec,millisec)
      equivalence (c_pre_event,pre_event)
c

c
c  by default, 2 byte data
c

      four_byte=.false.
c
c print version
c

      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   get def file for station codes, give file name
c
       text='gsrsei.def'
       net_code=' '
       call read_def_chan(text,mainhead_text,net_code)

c
      call computer_type(sun,pc,linux)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile(1:seiclen(infile))
c
c  open file 
c
       open(1,file=infile,status='old',access='direct',recl=512)
c
c   read header block to get start time etc
c
c
 1     continue
       read(1,rec=1,err=99) block
       close(1)
c
c   open again with record length 2 to read samples later,
c   thsi is for GBV
c
       
      open(1,file=infile,status='old',access='direct',recl=2)

c
c   write instrument type
c
      write(6,'(1x,a,a)') 'Instrument type  ',block(106:115)
c
c   find byte lenght of data from instrument type
c
      if(block(106:111).eq.'GSR-24'.or.
     *   block(106:111).eq.'GSR-18'.or.
     *   block(106:112).eq.'GBD-118')      four_byte=.true.
 
      if(four_byte) then
        write(6,*) '4 byte data'
      else
        write(6,*) '2 byte data'
      endif

c
c   number of channels
c
      if(four_byte) then
         c_nch(1:1)=block(308:308)
         c_nch(2:2)=char(0) 
      else
         c_nch(1:1)=block(22:22)
         c_nch(2:2)=char(0) 
      endif
      if(sun) call swap2_one(nch)
c
      write(6,*)'Number of channels', nch
c
c   number of samples
c
       c_samp=block(9:12)
c
c   seriel number
c
       s_number=block(116:120)
c
c  replace garbage chars with 0
c
       do i=1,5
         if(ichar(s_number(i:i)).lt.48.or.
     *      ichar(s_number(i:i)).gt.57) s_number(i:i)='0'
       enddo
c
c    code for sample rate
c
          i_rate=200   ! default rate
          call bcd(block(121:121),i)
          if(i.eq.2) i_rate=100
          if(i.eq.1) i_rate=50
          if(i.eq.0) i_rate=25
          write(6,*) 'Sampling code and sample rate',i,i_rate

c
c   swap a few numbers if on sun
c
       if(sun) then
          call swap4_one(i_samp)
       endif
c
c   number of channels
c
       nchan=nch
       if(nchan.gt.3) nchan=3  ! in older files, nchan is always 3
       if(nchan.eq.0) nchan=3  !if read wrong, assume 3 
c
c   get trigger time
c
c   seconds
       call bcd(block(35:35),i)
       sec(1)=i   ! whole sec
       call bcd(block(36:36),i)
       sec(1)=sec(1)+i/100.0   ! hundreds of seconds
c   minutes
       call bcd(block(34:34),min(1))
c   hour
       call bcd(block(33:33),hour(1))
c   day
       call bcd(block(37:37),day(1))
c   month
       call bcd(block(38:38),month(1))
c   year
       call bcd(block(40:40),year(1))
       if(year(1).gt.50) year(1)=year(1)+1900
       if(year(1).le.50) year(1)=year(1)+2000
       write(6,'(a,1x,i4,1x,4i3,1x,f6.3)')' yy,mm,dd,hh,mm,sec',
     * year(1),month(1),day(1),hour(1),min(1),sec(1)
c
c   initially use seriel numbers padded with 0 for station codes, 
       
       write(6,'(1x,a,1x,a)') 'Seriel number',s_number
       write(6,*) 'Number of samples',i_samp
       stat(1)=s_number
c
c   if station defined, use that
c
       if(block(271:273).ne.'   ') then
          stat(1)=block(271:273)//'  '
       endif
c
c   preevent time
c
c       call bcd(block(17:17),pre_event)  ! seems that it was bcd before !!!
       c_pre_event(1:1)=block(17:17)
       c_pre_event(2:2)=char(0)

       if(sun) then
          call swap2_one(pre_event)
       endif
       
       write(6,*)'Pre-event time', pre_event
c
c   group delay of filter, byte 81 82
c
        c_group_delay=block(129:130)
c
c   milli seconds
c
        c_millisec(1:1)=block(41:41)
        c_millisec(2:2)=char(0)


c
c   swap a few numbers if on sun
c
       if(sun) then
          call swap2_one(group_delay)
          call swap2_one(millisec)
       endif


        write(6,*) 'Group delay        ', group_delay/1000.0,
     *  '  milli seconds ', millisec

c
c   correct file start time for preevent (negative) etc. 
c
c   not sure why four-byte was used (jh oct 2004)
c         if(four_byte) time_correction=pre_event + group_delay/1000.0
         time_correction=pre_event - group_delay/1000000.0 -
     *   millisec/1000.0
c
c  correct date etc
c
         call timsec
     *   (year(1),month(1),day(1),hour(1),min(1),sec(1),total_time)
         total_time=total_time-time_correction
         write(6,*)' Total time and time correction', total_time,
     *   time_correction
         call sectim(total_time,year(1),doy,month(1),
     *   day(1),hour(1),min(1),sec(1))
       write(6,'(a,1x,i4,1x,4i3,1x,f6.3)')' yy,mm,dd,hh,mm,sec',
     * year(1),month(1),day(1),hour(1),min(1),sec(1)


c   assume same start time etc. for all channels
c
       do i=1,nchan
          year(i)=year(1)
          month(i)=month(1)
          day(i)=day(1)
          hour(i)=hour(1)
          min(i)=min(1)
          sec(i)=sec(1)
          rate(i)=i_rate
          nsamp(i)=i_samp
          cbyte(i)=' '
          if(four_byte) cbyte(i)='4'
          comp(i)='S  Z'
          stat(i)=stat(1)
       enddo
c
c   assume components in case no def file for first 3 components
c       
       comp(1)='S  E'
       comp(2)='S  N'
       comp(3)='S  Z'
c
c  enter loop to define channels if a def file
c
       do i=1,nchan
          call set_def_chan(i,stat(i),comp(i))
       enddo

c
c   make seisan headers
c
      ichan=1      ! only main head
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
c
      mainhead(1)(2:29)=mainhead_text    ! put in header text
      write(6,'(a)') mainhead(1)
      do i=1,12
         write(2)mainhead(i)
      enddo
c
C-----------------------------------------
C   enter channel  loop
c-----------------------------------------
c

      if(four_byte) then
         close(1)
         open(1,file=infile,status='old',access='direct',recl=4)
      endif
c

      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,stat,comp,
     *                    nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
         write(6,'(2a)') ' Outfile: ',outfile
c
c   get response info
c

         call read_resp_head(chahead)                                            
c
c   read samples, one at a time, a bit slow on sun
c
c   if 4 bytes, assume an extra 512 byte header as in GSR 24
c
          if(four_byte) then

             do i=1,i_samp
               irec=257+(i-1)*(nchan+1)+(ichan-1) ! always one extra dummy chann.
               read(1,rec=irec) data4(i)
             enddo
          
c
c   swap
c
             if(sun) then
                call swap4(i_samp,data4)
             endif
c
c   write data
c
             write(2) chahead
             write(2) (data4(i),i=1,i_samp)
         
c
          else
          
             do i=1,i_samp
                irec=257+(i-1)*(nchan+1)+(ichan-1) ! always one extra dummy chann.
                read(1,rec=irec) data(i)
             enddo         
c
c   swap
c
             if(sun) then
                call swap2(i_samp,data)
             endif
c
c   write data
c
c
             write(2)chahead
             write(2) (data(i),i=1,i_samp)
         endif
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  

c$debug
c  This program reorders hypocenter lines in a CAT file acording to agency 
c  either given by a file cat_aga.par or interactively
c
c  J Havskov, 1996
c-----------------------------------------------------------------------
c
c   updates
c feb 1999  by jh ---------------   version 7.0 chech --------------------
c                 no changes
c
      character*80 data(2000)
      integer nrecord,nstat,nhead,id,nphas
      character*1 exp,type
      character*80 filename 
      character*3 agency(200)! agency to use
      integer nagency        ! number of agencies
      integer i              ! counters etc
      logical compact        ! true if compact file
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   get parameter file if there 
c
         i=1
         open(1,file='cat_aga.par',status='old',err=56)
 49      continue
         read(1,'(a3)',end=56) agency(i)
         i=i+1
         goto 49
 56      continue
         nagency=i-1
         if(nagency.gt.0) then
            write(6,*)' Number of agencies', nagency
         else
            write(6,*)' Enter agencies, one pr line, end with return'
            i=1
 59         continue
            read(5,'(a3)') agency(i)
            i=i+1
            if(agency(i-1).ne.'   ') goto 59
            nagency=i-2
         endif
         if(nagency.le.1) then
            write(6,*)' At least two agencies required'
            stop
         endif
c
c   open output file
c
      open(2,file='cat_aga.out',status='unknown')
c
c   loop for reading files --------------------------------------------------
c
 500  continue
      write(6,*)' File name, if no more, return'
      read(5,'(a)') filename
      if(filename(1:5).eq.'     ') goto 999
      open(1,file=filename,status='old',err=5005)
      goto 5006
 5005 continue
      write(6,*)' No such file'
      goto 500
 5006 continue
c
c  find which type of input file
c
      call nortype(1,compact)
      if(compact) then 
         write(6,*)' Input file is compact'
         write(6,*)' File must be a CAT file'
         goto 500
      endif
c
c   loop for reading events
c
  1   continue
c
c   read one event or one header line
c
      call indata(1,nstat,nphas,nhead,nrecord,type,exp,data,id)
         if(nrecord.le.0) then
            close(1)
            goto 500   ! check if more files
         endif
c
c   reorganize hypocenter solutions
c
      call agency_order(data,nhead,agency,nagency)
c
c   
      write(2,'(a)')(data(i),i=1,nrecord)
      goto 1
c
c   end of all files
c
 999  continue
      write(6,*)' Output file is cat_aga.out'
      stop
      end
c
c
c
      subroutine agency_order(data,nhead,agency,nagency)
c
c     j havskov jan 96
c
c   order hypocenter lines acording to priority given in agency list
c   data,nhead         : the usual stuff
c   agency             : the 3 letter codes
c   nagency            : number of agencues
c
      implicit none
      character*80 data(*)
      character*3  agency(*)
      character*80 temp_data(400)    ! temporary to store headers
      logical      selected (400)    ! indicate if line is selected
      integer nhead,nagency
      integer i,k,j,nout
c
      nout=0                         ! counter of ouput records
      do i=1,400
         selected(i)=.false.
      enddo
c
c  make sure there is a line type 1 in first line
c
      data(1)(80:80)='1'
c
c  go through line by line of data looking for hypocenter lines
c
      do i=1,nagency
         do k=1,nhead
            if(data(k)(46:48).eq.agency(i).and..not.selected(k).
     *      and.data(k)(80:80).eq.'1') then
               nout=nout+1
               temp_data(nout)=data(k)
               selected(k)=.true.
c
c   move other lines along until next hypocenter line or type 7 line
c   or type 4 line
c
               j=1
 50            continue
               if(data(k+j)(80:80).ne.'7'.and.data(k+j)(80:80).ne.'1' 
     *         .and..not.selected(k+j).and.(k+j).le.nhead)then
                 nout=nout+1
                 temp_data(nout)=data(k+j)
                 selected(k+j)=.true.
                 j=j+1
                 goto 50
               endif
            endif
         enddo
      enddo
c
c   put in what remains in original order
c
      do i=1,nhead
         if(.not.selected(i)) then
            nout=nout+1
            temp_data(nout)=data(i)
         endif
      enddo
c
c   put back in original arrray
c
      do i=1,nhead
        data(i)=temp_data(i)
      enddo
c
      return
      end
    

C**************************************************************************
c                                                                               
c     Program to pick phase arrival times and write to SEISAN data base.        
c                                                                               
c     Written by Jens Havskov                               
c
ccccccccccccc   mulplt scematically ccccccccccccccccccccccccccccccccccccccccc
c
c  mulplt has 3 important loops where goto is used. below is seen the
c  loop labels (1000, 1100 and 2000) to the right and to the left is shown
c  all instances of goto to these labels.
c
c
c     program start
c
c     initialize mulplt
c        - get parameters from mulplt.def
c        - get iasp synthetic readings
c        - find if input from eev (opmode 0) or filenr.lis (opmode 1)
c          opmode 1 can also be cont data base
c
c---------------------------------------------------------------------------
c
c 1000 continue   ! loop back point for next event, filenr.lis or eev
c
c      if (input from eev, opmode = 0) then
c         if (plot finished) then
c            stop
c            return to eev
c         else
c            read waveform file names from s-file
c            select waveform files to use
c         endif
c      endif
c
c      if(input from filenr.lis, opmode = 1) then     
c         get file name of first or next event
c         if(filename(1:4) = 'cont') then
c             continuous data base input, cwaw=.true.
c             read start time and interval
c             goto 1050
c         endif
c         if(filename = 'filenr.lis') then
c            opmode=2              ! many hard copy plots
c            enter input of multi event plot parameters
c         endif
c      endif
c
c      if(opmode = 2)  then
c         read next waveform file name
c         if(no more files) stop                              --- goto 999
c      endif
c
c      check if waveform file exist and where it is
c
c      if(not exist)   get next event or back to eev          --- goto 1000
c
c      read waveform file(s) headers and initilize variables
c
c      if(opmode = 2) then
c         plot one event, hard copy only
c         back for next event                                ---  goto 1000
c      endif
c
c 1050 continue   
c      if(cwav)
c         read cont event headers
c      endif
c
c      if(opmode.eq.1) make an s-file
c-----------------------------------------------------------------------------
c
c      input of general options 0-6
c
c      if(option 4-6) then
c         continuous plot
c         stop
c      endif
c
c-----------------------------------------------------------------------
c  multi trace mode
c-----------------------------------------------------------------------
c
c      if(option 1-3) then
c
c         additional questions for multi trace option
c
c 1100    continue  ! loop back point for multitrace choices
c
c            -multi trace plot
c            -fk                                         
c            -pick                                      
c            -registation
c            -etc, for all above return to 1100          --- goto 1100
c
c            - go to single channel mode                 --- goto 2000
c
c            - delete s-file                            
c            - merge s-files                            
c            - delete wav-file(s)    
c            - register, input from eev                 
c            - other waveform file       
c            - next event
c            - for all above, return to 1000             --- goto 1000
c      endif
c
c--------------------------------------------------------------------------
c  single trace mode
c--------------------------------------------------------------------------
c
c     if(option 0) then
c
c        additional questions for single trace mode
c
c 2000   continue  ! loop back point when finished one channel
c          - single channel options                      ---- goto 2000
c          - jump to multi trace mode                    ---- goto 1100
c          - end of channels                             ---- goto 99
c        goto 2000
c     endif
c
c 99   continue
c
c      If input from filenr.lis, goto to next event      ---- goto 1000
c
c 999  continue
c
c      possibly send plot to plotter
c
c      close files
c
c      stop
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Latest update:                                                            
c     nov 20         : major clean up for 5.0
C!JAB(BGS)Dec94      : Install file & error handling (libsei)
c     jh jan 95      : file open problem, not properly closed
c     feb 20 95      : add question for hard copy plot
C!JAB(BGS)Mar95      : Accomodate large filenames in commands.
C!JAB(BGS)Mar95      : Accomodate the large suffix filenames.
C!JAB(BGS)Mar95      : If filename given, do not crash out if no filenr.lis
C!JAB(BGS)Mar95        exists!.
c     March 20 by jh : Resolution in mulplt.def file
c     March 21       : Separate resolution in screen and hc
c                      correct bug if readings from next day realtive to
c                      nordic header
C!JAB(BGS)Mar95      : Prevent core crashing for invalid user entry.
c april 10 94 jh     : Bugs with saving pics when not using data base
c april 21 94 jh     : component rotation
c april 26 94 jh     : extrac option for hc
c may 11             : enter both distance id and event type for registration
C!JAB(BGS)Jun95      : Use "sei get file" rather than "sei open" to open wave
C!JAB(BGS)Jun95        files in all cases, except where its pathname has already
C!JAB(BGS)Jun95        been found.
c jun 8       jh     : indicate in boxes if phases read
c jun 9              : fix problem with option OTHER
c sep 21             : disable rotate after traceplot
c oct 95             : new seisinc, add ffmin and ffmax to MULPLT.DEF,
c                      allow omega0 to be less than zero
c dec 95             : continous plotting
c dec 21             : check amplitude
c jan 8 96           : do not use synthetic data if not form the same date
c                      as the readings
c jan 16             : bug in above
c jan 31             : include nhead and nrecord in mulplt.inc
c feb 6              : bug cont. plot
c feb 13             : get distance irrespective of channel
c 5 3 96             : bug iasp in multitrace mode
c 12 3 96            : put routine convert into picsub
c aug 1 96           : fix problems wiht shifts in time  multi trace - single tr
c     8              : one extra return cleared in hc input
c    12              : wrong header in output when not using data base
c    28              : add hourr to commom block
c dec 27             : some modifications to phases: mouse is now blan on sun
c                      as on pc, lg put on = or \, sn has no i or e, L and l
c                      is locate
c feb 12, 97         : bug with hardcopy in single trace mode
c feb 20, 97,        : add write when locate
c bjb(BGS)Mar97	     : allow sub-classes for LV events to be entered in S-file
c                      and phase picks to be saved to s-file
c apr 16, 97 lo      : minor changes on volcanic part to solve Solaris problem
c apr 23, 97 lo      : plot iasp.out phases, when header date in S-file 0709
c aug 2      jh      : convert a sun wav name to pc format if on pc
c oct 97             : muilti file, spectral output
c nov 18             : revision
c dec 3              : output of file
c feb 11 98          : enable seach in several wav data bases
c feb 18             : both p and s velocity for spectral analysis
c feb 25             : fix eev connection
c mar 2              : more -------------
c mar 9
c mar 22             : fix rotation and amplitude
c jul 9  lo          : fix sfile gets lost when merge on solaris
c --------------------------------------------------------------------
c sep 98 jh          : ----------   version 6.0 check ----------------
c                      year 2000, 5 char station names, 5 char base
c oct 7              : bugs
c nov 4  jh          : put logical for linux
c nov 5              : systemc to systemc
c nov 26 98 jh       : add kappa
c jan 04 98 lo       : bug, read 5 characters when register
c jan 7     jh       : bug on merge, enlarge fileds for wav file name
c feb 3              : mores space for box_text
c feb 28             : fix fixed scaling, weigh 8 will not work on sun
c mar 19             : use save in main program
c mar 22 bmt         : include winplot.inc
c may 18 lo          : save fstart and ev_number when starting mulplt
c                    : save sfile when permanent merging
c may 28 jh          : put in FK
c jun 10             : add phase AMP
c jun 13 jh          : main_time to time, wrong addressing
c aug 16             : day was written wrongly in mulplt.out
c aug 26 lo          : fix some text output on Linux
c sep  8 jh          : put waveform file name in mulplt.out
c sep  9 lo          : fix bug in new_s_file
c sep  9 lo          : when register and no phase read, del synth phases
c sep 21 jh          : save menu show to eev so it can get back to mulplt
c sep 22             : add fk reading
c sep 30             : bug in above
c oct  1 lo          : read CODA AUTO as 0/1
c oct  4             : bug in above
c oct 22 jh          : new picsub, revise channel selection
c nov 5              : add variable long_text to copy files to wav, text too
c                      short
c nov 28             : variable channelname put into mulplt.inc in order to fix
c                      amplitude picking in multi trace mode
c dec 10             : put in response spectrum, channels name in mulplt
c                      mide, fixed in picsub
c feb 16 2000 jh     : option for plotting output ffrom modeling directly
c feb 29             : add copy_wav_dir to copy directly to data base
c april 2000         : new waveform structure
c may 25 2000 lo     : fix call for extract in fk
c may 30      jh     : error with hard copy plotting
c may 31      jh     : terminate PostScript file also on quit
c jun 5              : option o in single trace fixed in case of defaults
c jun 18      jh     : error when jumping intoi single trace mode from
c                      channel other then one
c october 20         : do not use upper character e and i for phases, I used
c                      for iasp option
c Nov 5, 2000        : ******** MAJOR CLEAN UP ************************
c Jan 14 2001        : fix bug so it is possible to pick more than one iasp
c                      phase for one staiton in multi trace mode
c jan 24             : more filters choises for ml, mb and ms
c feb 14             : pathname stripped from wavefilename for registration
c                    : user selected filters defined in MULPLT.DEF
c                    : FILTER_TYPE defined to allow use of bndpas or recfil
c                    : Year and month for wave database registration changed
c                    : to use header variables rather than filename syntax
c feb 20          lo : Changed length of xhead
c mar 9           jh : bug in routine write_s_file, no error check on write
c apr  23         jh : remove last check for hard copy, caused crash at end
c june 14         jh : change a filter from 0.8 haz to 1.25 hz
c sep 11             : def wa-filter set to 8 poles
c nov 11             : extract from cont data base
c nov 18             : back option in multi trace mode
c feb  1, 2002    lo : write out message when register s-file,used by seisantool
c feb 7           jh : do not allow filter lower than 0.1 for cont mode
c april  2003     jh : multiple screens for one event, extract to wavetool,
c                      also extract filtered and response corrected traces,
c                      stations alphabetical
c june 25         jh : 1000 channels and files, multiple selection screens
c july 10         lo : ask for stat/comp for continuous plotting
c july 21         jh : G and N to g and n for crustal phases
c sep 4           jh : make it possibel to quit after reg. in cont. mode
c oct 3           lo : set time_scale to 0 at 1100 to fix linux problem
c dec 2004        jh : seed 
c jan 12 2005     jh : fix some menu problems
c mar 11 2005     jh : initilize n_wav_file and n_wav_del to 0, not doing so
c                      created problem for wav deletiopn on linux
c jun 20 2005     jh:  plt to eps
c nov 11 2005     jh:  initialize cwav and cseed
c mar 06 2006     lo : added selection of continuous databases
c mar 24 2006     lo : init cseed at start
c jan    2006     rl : some changes, set n_wav_file=0 after 1000
c jun 1  2006     jh : Above, nsynt also set to zero, so iasp option from
c                      mulplt did not work, nsynt=0 commented out
c mar 15 2007     jh : do not use nsort_distance_save, dist can only be 
c                      turned on
c jul 30 2007     lo : write file to give cbase to wavetool
c oct    2007     lo:  read list of continuous databases from file
c oct 16 2007     jh : add init of mem function
c feb 13 2008     lo : add particle motion
c apr 25 2008     jh : change ms and mb filters, see manual version 8.2
c sep 12 2008     jh : small change in writing out waveform file name
c oct 23 2008     jh:  error in format writing out in cbase.inp, made soemtimes
c                      a blank in form of base on Linux
c
c        implicit none           ! does not work on pc due to graphics include
        include 'winplot1.inc'  ! dummy on unix
        include 'mulplt.inc'    ! mulplt includes
        include 'seiplot.inc'
        include 'seisan.inc'

c          
c-- operator
       character*4 operator
c       logical cseed  in common block                         ! if true, part of large seed file
c-- header for plot                                   
       character*160 xhead			
       character*80 question                                                    
c-- path to seismo                             
       character*60 top_directory		
c-- answer                                            
       character*1 answer			
c-- directory for s files                             
       character*40 s_dir			
c--  file number when reading many from filenr.lis
       integer filenumber
       integer n_wav_file                       ! # wav files in s-file
       integer n_wav_out                        ! # wav files selected
       integer n_wav_del                        ! # ------ for deletion
       integer n_wav_mer                        ! # ------ for merging
       character*80 wav_file_text               ! info on wav files(s)
       character*40 extra_wav                   ! extra wav file from S-file
c                                                 used with synthetics
c-- general text                                       
       character*80  text,text1 
       character*80  file_out                   ! complete wav name
       character   long_text*200
c-- time scal ein cm/sec                                
       real time_scale				
c-- multi trace start time                              
       real start_time				
c-- multi trace stop time                                
       real stop_time				
c-- stop_time - start_time                                  
       real window				
      logical  one_plot         ! true if one plot made
      character*10      keys                    

c-- single channel windows, not used presently       
       real wt1(max_trace),wt2(max_trace)                     
c-- save filter for option 0
c       real flow_def,fhigh_def ! now in common block 6-98
       integer filt_def
c-- operation mode 0: with SEISAN                        
c--       integer opmode	in common block			
c         0: single files, from eev 
c         1: mult. fil., 2: many file auto hard copy only plot
c                                                                               
c-- counters for above
      integer nsynt			
      character*10 synt_head  ! date of synthetic records
      character*80 data1(max_data)
c-- unit for default file
      integer def_unit
c-- Length in sec. of datafile                           
      real total_time				
c-- plot option, see below                              
      integer p_option				
      integer old_plotoption         ! save plot option
      integer npick                  ! number of time picking routine is called form traceplot
c-- Vector with selected channels                 
      integer old_chan(max_trace)			
c-- Number of selected channels                            
      integer nchan,old_nchan				
c-- See routine: 'indata'                      
      integer nstat,nphase		
c-- counters                                    
      integer i,j,k,l,ichan,x
c-- See routine: 'indata'                            
      character*1 type,exp			
c-- type and kind
      character*2 type_kind
c-- Indicator if default parameters are chosen                   
      logical default                
c-- filename of datafile including path                              
      character*80 filen			
c-- filename of datafile excluding path (bjb)                              
      character*80 trace_file			
c-- --------------------          
c-- name of current S file                             
      character*80 xsfile
c-- ---- new--- after registration                 
      character*80 new_sfile			
      character*5 stat_def(max_trace)
      character*4 comp_def(max_trace)   ! default channels
      integer nchan_def                       ! number of -----
      integer channelname_win(max_trace) ! initial selection of channels for multi windows
c-- dummy                                              
      character*6 dummy				
c-- See above                                            
      integer iswitch				
c-- id line number 
      integer id
c--- for extract of cont data
      double precision window_abs_time
      integer year,month,day,hour,min
      real sec
c-- .true. if a file exists                          
      logical exist				
c-- defualt for input parameters
      logical default_org
c-- save number of channels before interactive multi channel selection
      integer nchan_initial
c-- indicate if baz has been calculated
      logical no_baz
c-- directory separator
      character*1 dchar
c-- computer type
      logical pc,sun,linux
      character*5 station_code
      character*4 component_code
      character*(5) cbase_sel(max_cont) 


C--Variables for volcanic sub-classification
c bjb 18/3/97 
c
C-- comment line in VOLCANO.DEF
      CHARACTER*80 	comment
c-- User entered sub-class flag 
      CHARACTER*6	sub_class_flag
c-- sub-class descriptor
c      CHARACTER*40  	sub_class_descriptor
c-- sub class code
      CHARACTER*6       s_class(60)
c-- sub class number 
      INTEGER           n_class(60)
c-- user entered number 
      INTEGER           n_select
c-- sub-class description array
      CHARACTER*40  	description
c-- true if sub_class is in s_class()
      LOGICAL  		valid_class
c-- full pathname of VOLCANO.DEF
      CHARACTER*80	vol_file
c-- bjb variables for last dir character
      integer r_index,lastsl
      character*4 cwavyear
      character*2 cwavmon



C
C    SEISAN library inclusions...
c    ----------------------------
C
      include 'libsei.inc'                 ! Library definitions & data defns.
      external sei get file,               ! Find & open file.
     &         sei get values,             ! Extract from text string.
     &         sei open,                   ! File open handler.
     &         sei close,                  ! & closure.
     &         sei real num,               ! Extract real number from string.
     &         sei integer,                ! Extract integer from string.
     &         sei clen,                   ! Length of string.
     &         sei code                    ! Error condition handler.
      integer  sei clen,                   ! & function.
     &         sei integer                 ! Ditto.
      real     sei real num                ! Ditto.
      integer  code,                       ! Condition.
     &         ix,                         ! Very local.
     &         read1,                      ! Read unit1.
     &         read2,                      ! Ditto 2.
     &         read4,                      ! & 4.
     &         write1,                     ! Write unit1.
     &         write2,                     ! Ditto 2.
     &         write44,                    ! 
     *         readfk,
     *         any_unit
      logical  b_flag,                     ! Flag!!
     &         b_filenr                    ! Using filenr.lis?.
C
C    ------- End of details -------
      include 'version.inc'
       include 'winplot2.inc'
c                                                                               

c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver
cccccc    inizialize     ccccccccccccccc                                        
c     b_f_debug$ = .true.
      b_filenr$  = .false.      !JAB(BGS)Mar95. Not using filenr.lis yet!
      max_count  = 0            ! for fixed scaling
      no_baz=.true.    ! initially, no back azimuth angles have been calculated
      one_plot=.false. ! no plot made yet
      wav_interactive=.true.
c lot 24/03/2006, problem on RH Enterprise Linux
      cwav=.false.
      cseed=.false.

c-- postscript hard copy                                          
      hctype=1		
      rotate=.false.      ! cfix
c	  
c-- x-window size in % max
c
      wsize=90.0
c
c  initilize memory handling
c
      call wav_mem_init
c
c  position top frame in multi trace mode
c
      max_ypos=678.0
c
c  graphic display not yet open
c
      disp_open=0
c
c  by default, no default are chosen
c
      default=.false.
      default_org=.false.
      current_seq_chan=0     ! no active channel in traceplot
      npasses=0              ! filter
      cont_window=.false.    ! no change to window for cont plotting
      n_wav_file=0           ! initialy 0
      n_wav_del=0            ! initially 0
c
c                                                                               
c   get path to seismo                                                          
c                                                                               
      call topdir(top_directory)                                                
c
      call dir_char(dchar)   ! directory separation character
c
c   get computertype
c    
      call computer_type(sun,pc,linux)
c
c  no operator
c
      operator='    '
c                                                                               
c   agency directory by default                                                    
c                                                                               
      s_dir='                                        '                          
      do i  = 1,16                                                              
        phase(i) = ' '                                                          
      enddo                                                                     
      do i = 1,max_trace                                                       
        channelname(i) = 0                                                      
      enddo                                                                     
c                                                                               
c---------------------------------------------------------------------------                                                                               
c  get default parameters from MULPLT.DEF.  
c---------------------------------------------------------------------------
c
       call get_mulplt_def(def_unit,stat_def,comp_def,                        
     + nchan_def)     
c        
c   get seisan defaults
c
      call get_seisan_def

c---------------------------------------------------------------------                                                                               
c   get synthetic readings if file iasp.out exists    cccccc                          
c---------------------------------------------------------------------
c
       call get_synt(nsynt,synt_head)
c
c---------------------------------------------------------------
c   look for s-file reference to check if from eev                             
c---------------------------------------------------------------
c
      call get_env_event(sfile)
      call put_env_event(sfile)    ! put back in so iasp can use it
c
      opmode=0                     ! default from eev
      if(sfile(1:3).eq.'   '.or.ichar(sfile(1:1)).eq.0) then
         opmode=1
         nrecord=0
         nhead=0
         sfile='mulplt.out'   ! make an initial s-file
         open(1,file=sfile,status='unknown')
         write(1,*)
         close(1)
      else
         extra_wav=' '  ! initially no extra wav file
         call get_env_string(text)  ! get options from eev
c        write(6,*)'mulplt eev mes',text
         if(text(1:1).eq.'o'.or.text(1:1).eq.'O') then
           default=.true.
           default_org=.true.
           filt_def=filt
         endif
         read(text(3:8),'(i6)') event_no    ! get event number
         read(text(12:12),'(i1)') show_menu  ! get menu show option
         extra_wav(1:40)=text(40:79)
         seisan_base=text(16:20)
         eev_start_time=text(21:34)
      endif

c
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c   enter here if: 
c   1: one or several waveform files deleted from s-file
c   2: merge  
c   3: next from eev
c   4: next or previous file from filenr.lis
c   5: select other waveform files
c------------------------------------------------------------------------
c
 1000 continue                                          
c
c   initialize waveform file info
c
      call wav_init
c     nsynt = 0                 ! RL 1/2006
      n_wav_file = 0            ! RL 1/2006


c
c-----------------------------------------------------                                                                     
c-- data base, next file or other actions, from eev                                                 
c-----------------------------------------------------
c
       if(opmode.eq.0) then
c
c   directly from data base, select eev action if one plot already done
c   and return to eev
c
         if(one_plot) then
               text= ' '
               text(1:10)=keys
               write(text(12:12),'(i1)') show_menu  ! save menu option
               call put_seisan_message(text(1:seiclen(text)))
               stop
         endif
         one_plot=.true.   ! if passing here, there must come a plot
c
c   read old  picks
c
         call read_s_file
c
c   find if any waveform files
c
         if(extra_wav.eq.' ') then            ! no special wav file from EEV
            call auto_tr(data,nhead,n_wav_file,wav_filename)
            if(n_wav_file.eq.0) then   ! if no waveform, stop, if single file
               write(6,*)' No waveform file name in S-file'
               write(6,*)' Return to continue'
               call flush (6)
               read(5,'(a)') i
               keys(1:4)='    '          ! go  back to same event
               goto 1000
            endif
c
c   select file(s) to use if more than one if all defaults not chosen
c
            if(n_wav_file.gt.1.and.(.not.default)) then
               plotoption=0           ! only display
               call open_display      ! 
               call wav_select(n_wav_file,n_wav_out)                            
               call clear_to_alpha
c
c   stop if no files selected
c
               if(n_wav_out.eq.0) then
                  write(6,*) ' Waveform files not selected'
                  write(6,*) ' Return to stop'
                  read(5,'(a)') i
                  stop
               endif
            else
                n_wav_out=n_wav_file  ! use all if default or one if not def.  
            endif
            default=default_org       ! default could have been diabled, if
                                      ! optin other wav file used
         else            ! for separate wav
            wav_filename(1)(1:40)=extra_wav
            n_wav_out=1
         endif
      endif
c                                                                               
c-------------------------------------------------------------------            
c   next file from filenr.lis                                          
c-------------------------------------------------------------------            
c                                                                               
c                                                                               
c   get waveform data file name if single files are used, if question is
c   #Next_file#, then the next number is chosen from filenr.lis AND
c   no question is asked. if question is #Back_file#, previous file
c   is used and no question asked.
c                                                                               
      if(opmode.eq.1) then
         call wav_init              ! new file
         n_wav_out=1                ! only one file at a time  
         sfile='mulplt.out'                            !mar19
         if( b_filenr$      .and.                      !JAB(BGS)Mar95. Next!!.
     &       (question(1:11) .eq. '#Next_file#'.or.
     &        question(1:11) .eq. '#Back_file#' )) then 
             continue                                  !JAB(BGS)Mar95.
         else                                          !JAB(BGS)Mar95.
            question=                                                          
     *    ' Filename, number, filenr.lis (all), cont for cont base,'//
     *    ' conts for large SEED'                                 
         endif
         call filename(question,wav_filename(1))
c
c   check if continuous data bases
c
         if(wav_filename(1)(1:4).eq.'cont')
     *   then
            cwav=.true.
            cseed=.false.
            if(wav_filename(1)(5:5).eq.'s') cseed=.true. ! large seed volume
            if(.not.cseed) then
                write(6,*) 'Give start time, yyyymmddhhmmss'
                read(5,'(a)') cwav_start_time
                write(6,*) 'Interval in min'
                read(5,*) cont_interval
                cont_interval=cont_interval*60.0
c
c select waveform databases
c
                plotoption=0           ! only display
                call open_display      ! 
                call cbase_select(cont_base,cont_base_def,n_cont_base,i)
                n_cont_base=i
                n_cont_base_sel=i
c
c save selection, this is overwritten by calls to get_seisan_def
c
                if (n_cont_base_sel.eq.0) then
                   write(*,*) ' no database selected '
                   stop
                 endif
                 call clear_to_alpha
             endif
             if(cseed) then
                cwav=.false.
 500            continue
                question=' Seed file name or number'                              
                call filename(question,wav_filename(1))

	        inquire(file=wav_filename(1),exist=exist)
	        if(.not.exist) then
	           write(6,*) ' No such file, try again'
	           goto 500
	        endif 
                call wav_init
                call read_wav_header(1)
                write(6,*)
                write(6,*) ' Available data in SEED file'
                write(6,'(a,a)')
     *          ' STAT  COMP LO YEAR MO DA HR MN    SEC',
     *          ' DUR: DA HR MN  SEC'
                do i=1,wav_nchan
                   min=wav_duration(i)/60.0
                   sec=wav_duration(i)-min*60.0
                   hour=min/60.0
                   min=min-hour*60.0
                   day=hour/24.0
                   hour=hour-day*24.0
                   write(6,'(1x,a5,1x,a4,1x,a,1x,i4,4i3,f7.3,
     *             5x,i3,1x,i2,1x,i2,f5.1)') 
     *             wav_stat(i),wav_comp(i),wav_location(i),
     *             wav_year(i),
     *             wav_month(i),wav_day(i),wav_hour(i),wav_min(i),
     *             wav_sec(i),day,hour,min,sec
                enddo
                WRITE(6,*)
                write(6,*) 'Give start time, yyyymmddhhmmss,',
     *          ' enter for start time in first channel'
                read(5,'(a)') cwav_start_time
                IF(cwav_start_time.eq.' ') then
                  write(cwav_start_time,'(i4,5i2)') 
     *            wav_year(1),
     *            wav_month(1),wav_day(1),wav_hour(1),wav_min(1),
     *            int(wav_sec(1)+0.1) ! make sure start in first block
                endif
                write(6,*) 'Interval in min'
                read(5,*) cont_interval
                cont_interval=cont_interval*60.0
            endif
            call cwav_time_limits(0)  ! set times
            goto 1050
         endif
c
         b_filenr = wav_filename(1)(1:10).eq.'filenr.lis' .or.   
     *              wav_filename(1)(1:10).eq.'FILENR.LIS'        
c
c   clear question
c
         question(1:11)='           '                                          
c-- no more files                    
         if(wav_filename(1)(1:3).eq.'EOF') goto 999          
c
         if( b_filenr ) then                           !JAB(BGS)Mar95.
            opmode=2                                                            
            display_type=0    ! make sure nothing is sent to x
c
            call sei open( old$,              ! Open old file.
     &                     ' ',               ! No prompt.
     &                     'filenr.lis',      ! This filename.
     &                     read2,             ! On this unit.
     &                     b_flag,            ! Existance?.
     &                     code )             ! Returned consition (n/a).
c                                                                               
c   get scaling parameters                                                      
c                                                                               
            write(6,*)' Resolution in cm/sec, ',                                
     *              '0: plot all on one page (default)'                         
            call flush (6)
            read(5,'(a)') text                                                  
            if(text(1:5).eq.'     ') then                                       
               time_scale=0.0                                                   
            else
            time_scale = sei real num( text, code ) ! Get time.
            code = e_ok$                            ! Ignore conversion errors.
            endif                                                               
            write(6,*)
     *      ' Low and high cut for filter, return for no filter'
             call flush (6)
             read(5,'(a)') text
             if(text(1:4).eq.'    ') then
               filt=0
             else
c-- use index 9 for variable filter
                call sei get values( 2, text, code )   ! Extract 2 values.
                code = e_ok$                           ! re-store.
                flow(9) = array$(1)                    ! Retrieve.
                fhigh(9)= array$(2)                    ! Ditto.
                filt=9
             endif
         endif                                                                  
      endif
c
c----------------------------------------------------------------------                                                                               
c   many files to plot sequentially, names in filenr.lis                                     
c-----------------------------------------------------------------------
c
      if(opmode.eq.2) then                                                      
         call wav_init
         n_wav_out=1
         read(read2,'(2x,i3,2x,a)',iostat=code) filenumber,
     *   wav_filename(1)
         call sei code( fort$, code, read2, b_flag )             ! Process e.
         if( b_flag ) goto 999                                   ! end of file.
c-- no more files                        
         if(wav_filename(1)(1:5).eq.'     ') goto 999	
      endif                                                                     


c
c-------------------------------------------------------------------------------
c   check if file(s) exist, read waveform file(s) headers
c-------------------------------------------------------------------------------
c

c
c   file name text
c
       wav_file_text=' '
       if(n_wav_out.gt.1) then
          wav_file_text='Many waveform files'
       else
          wav_file_text=wav_filename(1)(1:seiclen(wav_filename(1)))
       endif
c
c   check if files exist and where
c
       k=0
       do i=1,n_wav_out
          call  get_full_wav_name(wav_filename(i),file_out)
          if(file_out.eq.' ') then
              write(6,'(1x,a,a)') ' No such file: ',
     *        wav_filename(i)(1:seiclen(wav_filename(i)))
         else
            k=k+1
            wav_filename(k)=file_out
         endif
       enddo                       
c
c   action if no files available, assume that if opmode 2, file must exist
c
       if(k.eq.0) then            !
         write(6,*)' No waveform files found, return to continue'
         read(5,'(a)') i
         keys(1:4)='    '    
         goto 1000
       endif                                
c                                                                               
c   read all header information from all files selected or available           
c                              
       wav_nfiles=k
       do i=1,wav_nfiles
          call read_wav_header(i)
          if(wav_nchan.gt.max_trace) then
              write(6,*)' Too many channels'
              write(6,*)' Return to stop'
              read(5,'(a)') k
              stop
          endif   
       enddo
       write(6,'(a,a)')' Read headers from files:'
       do i=1,wav_nfiles
          write(6,'(1x,a)') wav_filename(i)(1:80)
       enddo                          

c                                                                               
c  set default start time and window                                            
c                                                                               
       start_time=0.0       
       total_time=wav_total_time                                                    
       window=wav_total_time                                                        
       stop_time=start_time+window                                              
c                                                                               
c--------------------------------------------------------------------------     
c   if in multi event only hard copy plotting mode, do it here                       
c--------------------------------------------------------------------------     
c                                                                               
       if(opmode.eq.2) then                                                     
c-- only hard copy plot                                   
          p_option=3				
c-- resolution                                           
          resolu=resolu_hc
c-- use all channels                         
          nchan=wav_nchan 		
          do i=1,wav_nchan                                             
             channelname(i)=i                                                   
          enddo                                                                 
c                                                                               
c   plot header for traceplot                                                   
c                                                                               
          do i=1,160
            xhead(i:i)=' '
          enddo
          xhead(1:28)=wav_header_text(1)(1:28)
          xhead(30:30)=' '
          xhead(31:)  =wav_file_text(1:seiclen(wav_file_text))
c
c   check for null chars
c
          do i=1,160
            if(ichar(xhead(i:i)).eq.0) xhead(i:i)=' '
          enddo
c                                                                               
c   open plot file                                                              
c                                                                               
          call sei open( unknown$,      ! Open file.
     &                   ' ',           ! No prompt.
     &                   'mulplt.eps',  ! This file.
     &                   plotunit,      ! On this unit.
     &                   b_flag,        ! Existance.
     &                   code )         ! Condition not applicable.
c--                             
          plotoption=p_option-1			
c
c  sort after distance or time
c
      call channel_order(wav_stat,wav_delay,nchan,nsynt)                   
c
c                                                                               
c   plot                                                                        
c                                                                               
         call open_display      ! display here is only postscript file

c
         call traceplot                                                         
     *   (nchan,time_scale,start_time,stop_time,wav_delay,xhead)
c
c   close plot in post script file
c
         if(hctype.eq.1)  call close_post                                
c                                                                               
c   send hard copy plot to laser                                             
c                                                                               
         call sei close( close$, plotunit, code ) ! Close (stop on error).
         call send_plot("mulplt.eps",10)
         write(6,*)' ...Plotfile sent'
c
c   go back for next event                                                      
c                                                                               
         goto 1000                                                              
      endif                                                                     
c                                                                               
c-------end of multiplot hard copy only--------------
c
c
c-----------------------------------------------------------------
c   cont multiple data bases
c-----------------------------------------------------------------
c

 1050 continue   ! enter here if cont mode

      if(cwav.or.cseed) then
         
         if(cseed) then
            call wav_seed_read_header_interval ! find position in file of window
         else
            call cwav_read_bases   ! read all base info in interval
         endif
c                                                                              
c  set default start time and window                                            
c                                                                               
         start_time=0.0       
cx         total_time_window=cwav_abs_end_time-cwav_abs_start_time
         window=wav_total_time
cx         window=total_time_window
         stop_time=start_time+window
      endif

c--------------------------------------------------------------------------
c
c  if this is a run without data base, put in time in header from
c  main header currently used, no check on change of day !!!!!!!!
c
      if(opmode.eq.1) then
         do i=1,80
            data(1)(i:i)=' '
            data(2)(i:i)=' '
            data(3)(i:i)=' '
            data(4)(i:i)=' '
         enddo
         write(data(1)(2:5),'(i4)') wav_year(wav_first)
         write(data(1)(7:20),'(2i2,1x,2i2,f5.1)') wav_month(wav_first),
     *   wav_day(wav_first),wav_hour(wav_first),wav_min(wav_first),
     *   wav_sec(wav_first)
         data(1)(22:22)='L'
         data(1)(80:80)='1'
c
c   put in waveform file name, if cont base, not correct
c
         data(2)(2:seiclen(wav_filename(1))+1)=
     *   wav_filename(1)(1:seiclen(wav_filename(1)))
         data(2)(80:80)='6'
         data(3)(1:57)=
     *   ' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO '           
c         data(3)(58:80)='SNR AR TRES W  DIS CAZ7'
         data(3)(58:80)='AIN AR TRES W  DIS CAZ7'
         nhead=3
         nrecord=4
c
c   write s-file
c
         call write_s_file
      endif

c          
c----------------------------------------------------------------------         
ccccc     General options entred here         
c----------------------------------------------------------------------
c

c
c   set the default plotting option
c
      p_option=1          
c
c   check if in default multichannel mode
c
      if(.not.default) then   ! get input
c
c   get plotting output device and type of plot, make sure 
c   not in graphics mode                                 
c                         
         call clear_to_alpha
c                                                      
2222     write(6,*)'                                                   '          
         write(6,*)' Plot options: Interactive picking          Return '         
         write(6,*)'               Multi trace plot on screen, def (0) '  
         write(6,*)'               Multi trace plot on screen      (1) '           
         write(6,*)'               Multi trace plot on screen+laser(2) '           
         write(6,*)'               Multi trace plot on laser       (3) '
         write(6,*)'               Continuoues on screen           (4) '
         write(6,*)'               Continuoues on screen + laser   (5) '
         write(6,*)'               Continuoues on laser            (6) '
         write(6,*)                                                          
     *             '               Stop                            (q) '
         call flush (6)
         read(5,'(a)') dummy                                                       
         if(dummy(1:1).eq.'q'.or.dummy(1:1).eq.'Q') goto 999
         if(dummy(1:1).ne.' ') then
            ix = sei integer( dummy, code )        
            if( code .ne. e_ok$ ) then             
               write(*,*)'****       ... try again...'
               goto 2222                           
            else if(ix.lt.0.or.ix.gt.6) then
               write(*,*)                             
               write(*,*)                             
     &         '** WARN: option is out of range ...try again      **'
               goto 2222                              
            end if                                 
 2639       continue
            write(6,*)                                                          
     *      ' Low and high cut for filter, return for no filter'                  
            call flush (6)
            read(5,'(a)') text                                                  
            if(text(1:4).eq.'    ') then                                        
               filt=0                                                           
            else                                                                
c-- use index 9 for variable filter   
               call sei get values( 2, text, code )   ! Extract 2 values.
               code = e_ok$                           ! re-store.
               flow(9) = array$(1)                    ! Retrieve.
               fhigh(9)= array$(2)                    ! Ditto.
               filt=9
               flow_def=flow(9)
               fhigh_def=fhigh(9)                                                  
c
c   check filter lower bound in cont mode
c
               if(ix.gt.3.and.flow(9).lt.0.1.and.flow(9).gt.0.0) 
     *         then
                  write(6,*)
     *            ' In this mode, lowest filter can only be 0.1'
                  write(6,*)
     *           ' Use low pass instead by gving 0 as low cut'
                  goto 2639
               endif
       
            endif                
            filt_def=filt                                               
         endif
c
c   check if all defaults
c
         default=.false.
         if(dummy(1:1).eq.'0') then
           default=.true.
           default_org=default
           dummy(1:1)='1'
         endif

         read(dummy,'(i1)') p_option                                               
c-- default output on screen                                
         plotoption=0
      endif
c
c   put in default filter
c
      if(default) then
         flow(9)=flow_def
         fhigh(9)=fhigh_def
         filt=filt_def
      endif
      if(p_option.gt.1) then                              
c-- for graphics device                              
          plotoption=p_option-1			
      endif
c
c----------------------------------------------------------------------
c CONTINOUES PLOTTING, ONE CHANNEL
c----------------------------------------------------------------------
c
      if(p_option.ge.4.and.p_option.le.6) then
        plotoption=p_option-4
         write(6,*)' Seconds pr line'
         call flush (6)
         read(5,*) page_time
         if(opmode.eq.0) then
            write(6,*)' End time (ymd..), return is to end of month'
            call flush (6)
            read(5,'(a)') eev_end_time
         endif
         write(6,*)' Max count'
         call flush (6)
         read(5,*) max_count
         write(6,*)' Number of lines pr page'
         call flush (6)
         read(5,*) k
         if(k.lt.1) k=1
c         write(6,*)' Channel number'
c         call flush (6)
c         read(5,*) current_chan
          write(6,*) ' Station code, 5 chars max '
          call flush (6)
          read(5,'(a5)') station_code
          write(6,*) ' Component code, 4 chars max '
          call flush (6)
          read(5,'(a4)') component_code
          
c
c  open plot file if needed
c
         if(plotoption.ge.1) then                              
             call sei open( unknown$,      ! Open file.
     &                      ' ',           ! No prompt.
     &                      'mulplt.eps',  ! This file.
     &                      plotunit,      ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.
         endif                                                                 
c 
c open display, could be just postscript file
c
         call open_display
c
c   plot continoues, put in original name without path in order to
c   be able to find event in filenr.lis, could be read form TMP if
c   decompressed
c
c         call plot_cont(k,wav_file_text)
         call plot_cont(k,wav_file_text,station_code,
     &    component_code)
c
         call clear_to_alpha                                                 
         stop
      endif
                                                                              
c                                                                               
c----------------------------------------------------------------------         
c MULTI CHANNEL OPTIONS                                                          
c----------------------------------------------------------------------         
c                                                                                
      if(p_option.gt.0) then                                                    
c
c   check if plotting parameter should be entered
c
        if(.not.default.and.p_option.eq.3) then
c                                                                               
c   get scaling parameters                                                      
c                                                                               
            write(6,*)' Resolution in cm/sec, ',                                
     *                 '0: plot all on one page (default)'                      
            call flush (6)
            read(5,'(a)') text                                                  
            if(text(1:5).eq.'     ') then                                       
               time_scale=0.0                                                   
            else                                                                
               time_scale = sei realnum(text,code) ! Extract real number.
               code       = e_ok$                  ! Restore.
            endif                                                               
c                                                                            
c   get window                                                                  
c                                                                               
            window=stop_time-start_time                                         
            write(6,277) start_time,window                                      
 277        format(1x,'Selected start time and window is:',2f8.1,              
     *      ' Ok, else enter new value?')                                    
            call flush (6)
            read(5,'(a)' )text                                                 
            if(text(1:4).ne.'    ') then                                  
               call sei get values( 2, text, code ) ! Extract 2 variables.
               code = e_ok$                         ! Restore.
               start_time = array$(1)               ! Retrieve.
               window     = array$(2)               !
               if(start_time.eq.0.0.and.window.eq.0.0) window=total_time        
               if(window.eq.0.and.start_time.ne.0.0)                            
     *            window=total_time-start_time                                  
               stop_time=start_time+window                                      
            endif                                                              
c
c   now enter defaults
c
        else
           time_scale=0.0 
           window=stop_time-start_time
        endif
c                                                                               
c   show (if not default) which channels selected and possibly select others                     
c
        call channelselect(wav_nchan,wav_stat,wav_comp,                       
     *  nchan,nchan_def,stat_def,comp_def,default)
c
c   save all selected channel numbers, could be more than used for one screen
c
c        write(17,*)' save org'
        do i=1,nchan
           channelname_org(i)=channelname(i)   ! the new total selection
c           channelname_win(i)=channelname(i)   ! the origial total selection used for the first windows
        enddo
c
c   save original number of channels, used if several screens are plotted
c
        nchan_org=nchan
c
c   set screen number
c
        n_screen=1
c
c   clear to alpha if no screen plot
c
        if(p_option.eq.3) call clear_to_alpha                                                 
c
c   stop if zero number of channels, can be caused by a q in selection
c
        if(nchan.eq.0) goto 999
c
c   reset default, could have been temporaryly disabled
c

        default=default_org
c
c---------------------------------------------------------------------------
c---------------------------------------------------------------------------
c   Main loop start point in multitrace mode, come back here after most
c   choises
c---------------------------------------------------------------------------
c---------------------------------------------------------------------------
c
 1099   continue
c
c   select channels for screen number n_screen
c   channelname_org: channels selected after initial channel selection screen
c                    or after selection when all windows has been plotted
c   channelname_win: the original selection for each window
c
c
c  when starting a new set of windows, save the chennel selection available
c  then. thsi selection might be different form the very first selection due
c  to selection in the multi trace window so cannelname_org migh have been
c  chages in picsub
c
        if(n_screen.eq.1) then     ! new set of windows
           do i=1,nchan_org
              channelname_win(i)=channelname_org(i)
           enddo
           do i=nchan_org+1,max_trace
              channelname_win(i)=0
           enddo
c
c   for first screen, calculate totoal number of windows to show 
c
        total_n_screen=(nchan_org-1)/n_chan_screen +1
c        write(17,*) total_n_screen
        endif
c
c   now select channels for window
c
        l=1
        nchan=0
c        write(17,*) 'nscreen before',n_screen
        k=(n_screen-1)*n_chan_screen+1
        do i=k,k+n_chan_screen-1
c           write(17,*) 'i,chan', i, channelname_org(i)
           if(channelname_win(i).gt.0) then
               channelname(l)=channelname_win(i)
               nchan=nchan+1
               l=l+1
           else  ! no more channels to plot, return to first screen next time
c               n_screen=0
           endif
        enddo
c        write(17,*) 'nchna,nscreen',nchan,n_screen

        if(nchan.eq.0) then       ! could be that last screen has zero channels, then go to first
          n_screen=1
          goto 1099
        endif
        nchan_initial=nchan_org
c
c------------------------------------------------------------------
c   enter here for replot
c------------------------------------------------------------------
c
 1100   continue
 
        time_scale=0.  ! lo 03/10/2003

c
c  check if change of window in cont plotting
c
        if(cont_window.and.(cwav.or.cseed)) then
           cont_window=.false.
           call cwav_time_limits(1)             ! calculate new lim         
	     if(cseed) then
              call wav_seed_read_header_interval ! find position in file of window
           else
              call cwav_read_bases   ! read all base info in interval
           endif
           call wav_index_total  ! testing this


c                                                                              
c  set default start time and window                                            
c                                                                               
           start_time=0.0       
           window=wav_total_time
           stop_time=start_time+window
        endif
c          write(6,*)' wav_total_time',  wav_total_time
c 
c                                                                               
c   plot header for traceplot                                                   
c                                                                               
        do i=1,160
           xhead(i:i)=' '
        enddo
        i=index(filen,' ')                                               
        xhead(1:28)=wav_header_text(1)(1:28)
        xhead(30:30)=' '
        xhead(31:)  = wav_file_text            
c
c   check for null chars
c
        do i=1,160
           if(ichar(xhead(i:i)).eq.0) xhead(i:i)=' '
        enddo
c                                                                               
c   Get old picks                                                               
c                                                                               
        call read_s_file
c
c   add synthetic readings if any
c
        call add_synt_readings(nsynt,synt_head)
c                                                                               
c  plot, set resolution to 1000 if on screen, else 3000 (defaults)
c                                                                               
        resolu=resolu_x
        if(p_option.gt.1) resolu=resolu_hc
c
c  sort after distance or time
c
        call channel_order(wav_stat,wav_delay,nchan,nsynt)                               
c
c   check if baz angles should be calculated
c
        if(rotate.and.no_baz) then
            call get_baz
     *      (wav_nchan,wav_stat,data,nhead,nrecord,baz)
            no_baz=.false.      ! indicate that baz has been calculated
        endif
c
c   close plot file if open to make sure that another plot is not put on top
c   this means that if a replot is made, only the last plot can be sent for
c   hardcopy
c
        if(plotoption.ge.1.and.plotunit.gt.10)  then 
           call sei close( close$, plotunit, code ) ! Close (stop on error).
        endif
c
c
c  open plot file if needed
c
        if(plotoption.ge.1) then                              
             call sei open( unknown$,      ! Open file.
     &                      ' ',           ! No prompt.
     &                      'mulplt.eps',  ! This file.
     &                      plotunit,      ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.
        endif                                                                 
c 
c open display, could be just postscript file
c
        call open_display

c
c   clear menu choises
c
         do i=1,13
           onbox(i)=0
         enddo
         do i=15,42
           onbox(i)=0
         enddo
c
c   multi trace plot
c
        call traceplot                                                         
     *  (nchan,time_scale,start_time,stop_time,wav_delay,xhead)

c
c--------------------------------------------------------------------------
c particle motion plot
c--------------------------------------------------------------------------
c
        if(do_pmp) then
          call plot_pm(start_time,stop_time)
        endif

c
c   reset temporary settings due to hc plot and submit plot
c
        if(choice.eq.'HCAL') then
           do l=1,old_nchan
              channelname(l)=old_chan(l)
           enddo
           call close_post                               
           call sei close( close$, plotunit, code ) ! Close (stop on error).
           nchan=old_nchan
           plotoption=old_plotoption
           call send_plot("mulplt.eps",10)
           resolu=resolu_x
        endif
c
c   count number of calls to pic routine
c
        npick=0
c                                                                               
c   activate channel select if not only hardcopy is made, also enter here
c   for more choices
c   if only hard copy done, choice is assumed to be the next event
c
        if(p_option.eq.3) choice='FINI'
c
c--------------------------------------------------------------------------
c   block where interactive graphics is used
c--------------------------------------------------------------------------
c
        if(p_option.le.2) then     ! remain in graphics mode                                                  
c
c   save old channel selection if only one selected, might want to
c   got back to old selection
c   also used when resetting for temporary hc plot
c
           do i=1,nchan
              old_chan(i)=channelname(i)
           enddo
           old_nchan=nchan
c
c---------------------------------------------------------------------------
c   get up cursor for choises
c---------------------------------------------------------------------------
c

           call chasel(nchan,wt1,wt2,start_time,stop_time)
c
c--------------------------------------------------------------
c   Multiple window handling
c--------------------------------------------------------------
c

           if(choice.eq.'NEXW') then
c
c   only go to next screen if all channels of current screen are selected
c
c               if(nchan_org.eq.nchan_initial) n_screen=n_screen+1
               n_screen=n_screen+1
               if(n_screen.gt.total_n_screen) n_screen=1
c               write(17,*) 'nscreen new', n_screen
               choice=' '
               goto 1099
           endif

c
c--------------------------------------------------------------------------
c   check if pick, remain in picking loop as long as picks are chosen
c--------------------------------------------------------------------------
c
           do while(choice.eq.'PICP') 
              npick=npick+1
              call add_synt_readings(nsynt,synt_head)
              iswitch = 0  ! convert readings before calling picking routine
              call convert(wav_abs_time(wav_first),
     *        wav_stat(current_chan),                     
     +        wav_comp(current_chan),                            
     +        iswitch)
              chan_delay=start_time 
              first=1
              call tecpic
              chan_delay=0.0  ! make sure no delay if going into s. chan. mode
              iswitch = 1  ! convert readings  back to nordic format
              call convert(wav_abs_time(wav_first),
     *        wav_stat(current_chan),                     
     +        wav_comp(current_chan),                               
     +        iswitch)                                         
c                          
c   save any new picks
c          
              if(npick.gt.0) then
                npick=0
                call write_s_file
              endif
c
c   get cursor up, if a pick, remain in picking loop, else continue
c
              call chasel(nchan,wt1,wt2,start_time,stop_time)       
           enddo
c
c----------------------------------------------------------------------------
c  hard copy of all
c---------------------------------------------------------------------------
c
           if(choice.eq.'HCAL') then
              do i=1,wav_nchan
                 channelname(i)=i
              enddo
              nchan=wav_nchan
              old_plotoption=plotoption
              plotoption=1                  ! temporarely reset plot option
              resolu=resolu_hc
              goto 1100                     ! hc plot
           endif
c
c---------------------------------------------------------------------------
c check if help
c---------------------------------------------------------------------------
c
           if(choice.eq.'HELP') then
              call mulplt_help            ! print help file
              goto 1100                   ! replot		   
           endif
c
c--------------------------------------------------------------------------
c iasp
c--------------------------------------------------------------------------
c
           if(choice.eq.'IASP') then
              call systemc('iasp',4)        ! calculate synthetic phases
              call get_synt(nsynt,synt_head)   ! read synthetic phases
              goto 1100
           endif
c
c---------------------------------------------------------------------------
c check if write out of waveform file, either isolated or to use with FK
c---------------------------------------------------------------------------
c
           if(choice.eq.'WOUT'.or.choice.eq.'FK  ') then
c
c   open and write in file for choises to wavetool program
c
              call sei open( unknown$,     ! Open file.
     &                      ' ',           ! No prompt.
     &                      'extract.inp', ! This file.
     &                      any_unit    ,  ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.
c
              window=stop_time-start_time
              write(any_unit,*) nchan
              do i=1,nchan
                 if(cwav.or.cseed) then ! cont use first sample and whole window
                    write(any_unit,'(i3,a)') channelname(i),' 0.0 0.0'
                 else
                    write(any_unit,'(i3,1x,2f10.3)')
     *              channelname(i),start_time,window
                 endif
              enddo
              call sei close( close$, any_unit, code )
              wave_out=.false.
c
c   filter resp text
c

              text=' '
              if(filt_old.gt.0) then
                  write(text,'(a,2f10.4)') 
     *            ' -filter ',filt_old_low,filt_old_high
              endif
              if(remove_response_old.eq.1) then
                   write(text(31:43),'(a,i3)') ' -ground ',
     *             disp_vel_old
              endif
c              write(17,*) filt_old,disp_vel_old,
c     *                    remove_response_old
c
c   extract/wavetool file
c
              if(cwav.or.cseed) then
	           if(cseed) then
	              window_abs_time=wav_abs_time(wav_first)
     *              +start_time
	           else
                    window_abs_time=cwav_abs_start_time+start_time
	           endif
                 call sectim
     *           (window_abs_time,year,i,month,day,hour,min,sec)
                 i=sec+0.5
                 write(text,'(i4,5i2)')year,month,day,hour,min,i
                 do i=1,14
                    if(text(i:i).eq.' ') text(i:i)='0'
                 enddo
                 write(text1(1:10),'(f10.1)') window

                if(cseed) then
                 if (choice.eq.'FK  ') then
                   long_text='wavetool -start '//text(1:14)//
     *             ' -cwav -duration '//text1(1:10)
     *             //' -chansel extract.inp -wav_out_file waveform.out'
                 else
                   long_text='wavetool -start '//text(1:14)//
     *             ' -cseed -duration '//text1(1:10)
     *              //' -sfile '//sfile(1:seiclen(sfile))
     *             //' -chansel extract.inp -wav_out_file SEISAN'
                 endif
                else           !  cwac  option
                 if (choice.eq.'FK  ') then
                   long_text='wavetool -start '//text(1:14)//
     *             ' -cwav -duration '//text1(1:10)
     *             //' -chansel extract.inp -wav_out_file waveform.out'
                 else
                   long_text='wavetool -start '//text(1:14)//
     *             ' -cwav -duration '//text1(1:10)
     *             //' -chansel extract.inp -wav_out_file SEISAN'
c
c only selected databases
c
                   if (n_cont_base_sel.gt.0) then
                     call sei open( unknown$,     ! Open file.
     &                      ' ',           ! No prompt.
     &                      'cbase.inp', ! This file.
     &                      any_unit    ,  ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.
                     do i=1,n_cont_base_sel
c                     long_text=long_text(1:seiclen(long_text))//
c     *                 ' -cbase '//
c     *                 cont_base(i)(1:seiclen(cont_base(i)))//' ' 
                       write(any_unit,'(a)')
     *                 cont_base(i)(1:seiclen(cont_base(i)))//' ' 
                     enddo
                     call sei close( close$, any_unit, code )
                     long_text=long_text(1:seiclen(long_text))//
     *                 ' -cbase cbase.inp '
                   endif
                 endif
                endif
              else     ! a normal file
                 if (choice.eq.'FK  ') then
                   long_text='wavetool -sfile '//sfile(1:seiclen(sfile))
     *             //' -chansel extract.inp -wav_out_file waveform.out'
                 else
                   long_text='wavetool -sfile '//sfile(1:seiclen(sfile))
     *             //' -chansel extract.inp -wav_out_file SEISAN'
     *             //text(1:42)
                 endif
              endif

              write(6,*) long_text
c              write(17,*) long_text
              call systemc(long_text,seiclen(long_text))
              if(choice.ne.'FK  ') goto 1100    ! replot
           endif
c
c--------------------------------------------------------------
c    FK analysis if waveform file has been written out
c--------------------------------------------------------------
c
           if(.not.wave_out.and.choice.eq.'FK  ') then
              call systemc('fk',2)
              fk=.false.
c
c     some problem to make sei open work
c
c   open file with results
c
c             call sei open( old$+ignore$,            
c    &               ' ',                     ! No prompt.
c    &               'fk.out',                ! This file.
c    &               readfk,                  ! On unit.
c    &               exist,                   ! File exists?.
c    &               code )                   ! Condition.
c
c    File exists and is open!!..
c
             open(29,file='fk.out',status='old',err=9362)
             goto 9361
 9362        continue
             write(6,*)' No fk.out file'
             goto  9365
 9361        continue
             readfk=29
c            if(exist) then
                do i=1,8
                   read(readfk,'(a)',err=9364) text
c                  write(6,'(a)',err=9364) text
                enddo
c
c   check if results
c
                if(text(2:9).eq.'APPARENT') then
                   read(text(21:25),'(f5.1)',err=9364) veli
                   read(text(45:48),'(i4)',err=9364) k
                   azim=k
                   goto 9365
                else
                   write(6,*)' No FK values were selected'
                   veli=0
                   azim=0
                   goto 9365
                endif
 9364           continue
                write(6,*)' Something wrong with fk.out'
 9365           continue
c               call sei close( close$, readfk, code ) ! Close 
                close(29)
              choice='    '      ! clear FK choice
              goto 1100          ! replot
           endif

c
c----------------------------------------------------------
c check if locate event
c----------------------------------------------------------
c
           if(choice.eq.'LOCA') then
               call clear_to_alpha
c
c   if no data base, put name mulplt.out in as an s-file for location
c
              if(opmode.eq.1) call put_env_event('mulplt.out')
              call systemc('hyp',3)  ! locate and put screen output
                                      ! in hyp.tmp
              write(6,*)' Return to continue'
			  call flush (6)
			  read(5,'(a)') text      ! pause for input
c
c   make an iasp.out file with theoretical arrival times
c
              call make_res_file(nrecord,data,nsynt) ! calulate residual
              synt_head=data(1)(1:10)
              call add_synt_readings(nsynt,synt_head)
              goto 1100               ! replot             
           endif
c
c-------------------------------------------------------------------
c   check if quit
c------------------------------------------------------------------
c
           if(choice.eq.'QUIT') then
              goto 999                                            
           endif
c
c----------------------------------------------------------------------
c   replot traces with new choice of parameters, if any picks were made
c   go to reread picks
c-----------------------------------------------------------------------
c
           if(choice.eq.'REPL') then
              goto 1100
           endif
c
c-------------------------------------------------------------------                        
c   check if going into pick mode, toggle mode
c-------------------------------------------------------------------
c
           if(choice.eq.'TOGL') then
             if(plotoption.ge.1)
     *       call sei close( close$, plotunit, code ) ! Close (stop on error).
             i=0
             goto 2000      ! this is far below in single trace plotting
           endif
c
c---------------------------------------------------------------------
c   check if merge of multiple files
c-------------------------------------------------------------------
c
           if(choice.eq.'MERG') then
              call wav_select_mer(wav_nfiles,n_wav_mer)
           endif
c
c----------------------------------------------------------------
c   check if multi file delete, then display delete box
c----------------------------------------------------------------
c
           if(choice(1:4).eq.'DEL '.and.n_wav_file.gt.1) then
              call wav_select_del(wav_nfiles,n_wav_del)            
c
c   replot traces, if no files deleted or at least 2 selected for merge.
c   go to reread picks
c
              if((choice(1:4).eq.'DEL '.or.choice(1:4).eq.'MERG').and.
     *        n_wav_del.eq.0.and.n_wav_mer.lt.2.and.opmode.eq.0) then
                 goto 1100
              endif
           endif

        endif           ! this endif is end of options in graphics mode
c
c---------------------------------------------------------------------
c   for the remaining options, screen must be cleared and cursor moved
c   to text window 
c---------------------------------------------------------------------
c
        call clear_to_alpha                                                          
c
        write(6,*)
c
c-------------------------------------------------------
c   Delete S-file
c------------------------------------------------------
c
        if(choice.eq.'DELS'.and.opmode.eq.0) then
          write(*,*) ' deleting s-file ...'  ! lot 22-04-2002
           keys(1:4)='D   '
            goto 1000
        endif
c 
c---------------
c   merge files
c---------------
c
        if(choice.eq.'MERG'.and.n_wav_mer.gt.1) then
c
c   write s-file so merge can be done
c
              xsfile = sfile
              call write_s_file

c
c   make a list of files to merge for extract
c
              call sei open( unknown$,          ! Open file.
     &                      ' ',           ! No prompt.
     &                      'extract.inp', ! This file.
     &                      any_unit    ,  ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.
c
              do i=1,n_wav_mer
                  write(any_unit,'(7x,a)') wav_filename(i)
              enddo
              call sei close( close$, any_unit, code )
c
c   merge files
c
              long_text='wavetool -wav_files extract.inp'// 
     *        '  -wav_out_file SEISAN'
              write(6,*) long_text
              call systemc(long_text,seiclen(long_text))
c
c   find if merge was ok
c
              call get_message('extract',text)
              if(text(1:2).ne.'OK') then
                 write(6,*)' Merged failed ************'
                 write(6,*)' Return to continue        '
                 call flush (6)
                 read(5,'(a)')text 
              else
                 filen(1:60)=text(3:62)   ! new file name
c
c   read s-file with new name of waveform file
c
                 sfile = xsfile
                 call read_s_file
c
c   remove merged files from s-file if more than one
c
                 if(n_wav_mer.gt.1) then
                    k=2
                    do i=2,nrecord
                      if(data(i)(80:80).eq.'6'.and.data(i)(1:1).eq.'*')
     *                then
                         continue    ! just skip line
                      else
                         data(k)=data(i)
                         k=k+1
                      endif
                    enddo
c
c   put in new name of merged file in line 2
c
                    do i=nrecord,2,-1
                       data(i+1)=data(i)
                    enddo
                    data(2)=' '
                    data(2)(2:61)=filen(1:60)
                    data(2)(80:80)='6'
                    nrecord=nrecord-n_wav_mer+1
                    nhead=nhead-n_wav_mer+1
                    data(nrecord)=' '
                 endif 
c
c   write s file again
c
                 call write_s_file
c
c  go and select again from very start
c
cx                 keys(1:4)='    '   ! same event in eev
                 one_plot=.false.   ! do not return to eev
                 goto 1000
              endif
        endif

c
C---------------------------------------------------------------------                                                    
C   DELETE FILES ?                                                         
C-------------------------------------------------------------------
c          
        if(choice.eq.'DEL ') then                                            
           if(choice.eq.'DEL ') 
     *     WRITE(6,'(a,$)')
     *  '  SURE YOU WANT TO DELETE WAVEFORM FILE (Y/N) ??????? '        
           call flush (6)
           READ(5,'(A1)') answer                                             
           IF(answer.EQ.'Y'.or.answer.eq.'y') then                      
c
c-- CLOSE and DELETE FILE(S)
c
c   check if one or several of many files to delete 
c
c suggested change RL 1/20006, kept at 0 lot
c               if(n_wav_del.gt.1) then   ! many files, must be from s-file
c               if(n_wav_del.gt.0) then   ! many files, must be from s-file
                if (opmode.eq.0) then    ! lot 17/05/2006
                  do i=1,n_wav_del       ! delete
                     if(sun.or.linux) then
                         write(text,'(a,a)')'rm ',wav_filename(i)(1:60)
                      else
                         write(text,'(a,a)')'del ',wav_filename(i)(1:60)
                      endif
c no delete from s-file                       call systemc( text,seiclen(text) )
                  enddo
c
c   remove deleted files from s-file
c
                  k=2
                  do i=2,nrecord
                     if(data(i)(80:80).eq.'6'.and.data(i)(1:1).eq.'*')
     *               then
                        continue    ! just skip line
                     else
                        data(k)=data(i)
                        k=k+1
                     endif
                  enddo
                  nrecord=nrecord-n_wav_del
                  nhead=nhead-n_wav_del
                  data(nrecord)=' '
c
c   convert possible readings and write the corrected s-file
c
                  iswitch=0
                  call convert(wav_abs_time(wav_first),
     *            wav_stat(current_chan),                     
     +            wav_comp(current_chan),                            
     +            iswitch)
c
c   write s-file
c
                  call write_s_file
c
c  go and select again from very start
c
                  keys(1:4)='    '   ! same event in eev
                  one_plot=.false.
                  goto 1000
               else
c
c   one input file
c                     
                  if(sun.or.linux) then
                     write(text,'(a,a)')'rm ',wav_filename(1)(1:60)
                  else
                     write(text,'(a,a)')'del ',wav_filename(1)(1:60)
                  endif
                  call systemc( text,seiclen(text) )
 
                  if(opmode.eq.1) then
                     if(default) then
                        question(1:11)='#Next_file#'
                     else
                        question(1:11)='           '
                     endif
                  endif
c
c-- new event                                       
c
                  keys(1:4)='NEXT'   ! in case from eev
                  goto 1000   
               endif   ! endif of delete many files
           endif       ! endif of confirm delite
c
c   if here, assumed wrong choice,  close plot file (if any)
c   and replot
c
           if(plotoption.ge.1) call sei close( close$,   ! Close plot.
     &                                      plotunit, ! Unit.
     &                                      code )    ! Condition (n/a).
           goto 1100                                                             
        endif            ! endif of delete section                                                    
c
c---------------------------------------------------------------------                                                                               
c   register  (put) event using eev                                                              
c---------------------------------------------------------------------
c
        if(choice.eq.'PUT '.and.opmode.eq.0) then
           write(*,*) ' register existing s-file ... '
           keys(1:3)='REG'
           goto 1000
        endif          
c
c---------------------------------------------------------------------                                                                               
c   register  (put) event  using filenr.lis or cont base                                                           
c---------------------------------------------------------------------
c          
        if(choice.eq.'PUT ') then                            
           write(6,*)                                                         
           WRITE(6,'(a,$)')
     &  '  ENTER EVENT TYPE L,R OR D '
           call flush (6)
           READ(5,'(A2)')TYPE_kind                                                 
 846       CONTINUE                                                           
           IF(TYPE_kind(1:1).EQ.'l') type_kind(1:1)='L'                                           
           IF(TYPE_kind(1:1).EQ.'d') type_kind(1:1)='D'                                           
           IF(TYPE_kind(1:1).EQ.'r') type_kind(1:1)='R'                                           
           IF(TYPE_kind(1:1).NE.'L'.AND.TYPE_kind(1:1).NE.'D'
     *        .AND.TYPE_kind(1:1).NE.'R') THEN               
              WRITE(6,*)' WRONG TYPE, TRY AGAIN'                              
              call flush (6)
              READ(5,'(A2)') TYPE_kind                                             
              GOTO 846                                                        
           ENDIF                                                              

C bjb 18/3/97 
C If a local volcanic event then we want register a sub class defined in
C the file VOLCANO.DEF located in the DAT directory.
C The format of this file will be one line of text (80A) followed by
C i2,1x,6A,1X,40A for number, code, space, description
c
c next lines moved down to be run only if 'V' LO, 04.97
c
c      valid_class=.FALSE.
c      sub_class_flag='  '
c
           IF(TYPE_kind(2:2).eq.'v') TYPE_kind(2:2)='V'
              IF(TYPE_kind(1:1).eq.'L'.and.TYPE_kind(2:2).eq.'V') THEN

c
c call routine to select subclass, lo May 27, 2002
c
              call select_volcano_subclass(sub_class_flag)
 
c              valid_class=.FALSE.
c              sub_class_flag='  '
cC Create path name for VOLCANO.DEF on sun or PC
c              vol_file=top_directory(1:60)
c              vol_file(seiclen(top_directory)+1:
c     *        seiclen(top_directory)+1)=dchar
c              vol_file(seiclen(vol_file)+1:seiclen(vol_file)+3)='DAT'
c              vol_file(seiclen(vol_file)+1:seiclen(vol_file)+1)=dchar
c              vol_file(seiclen(vol_file)+1:)='VOLCANO.DEF'
c
c              CALL sei open(check$,
c     &                  ' ',
c     &                  vol_file,
c     &                  0,
c     &                  exist,
c     &                  code)
c              IF(.not.exist) THEN 
c                 WRITE(6,*)
c     *           'Warning: Cannot find VOLCANO.DEF file in DAT dir'
c                 GOTO 3413
c              ENDIF
cc
cC If we are here then we want to open up VOLCANO.DEF file and print to
cC the screen and let the user select which code he wishes to enter
cC in line 1 col 56
cc
c              CALL sei open(old$,
c     &                ' ',
c     &                 vol_file,
c     &                read2,
c     &                exist,
c     &                code)
c 3922         READ(read2,'(a80)') comment
c              WRITE(6,*)' '
c              WRITE(6,*) comment
c
c              WRITE(6,*)'---------------------------------------'
c              Write(6,*)'Number Sub-Class Description'
c              WRITE(6,*)'---------------------------------------'
c              DO i=1,60
c                 READ(read2,'(i2,1x,a6,1x,a40)') n_class(i),s_class(i),
c     &                                    description
c                 WRITE(6,'(4x,i2,1x,a6,4x,40a)') n_class(i),s_class(i),
c     &                                    description
c
c                 IF(description.eq.'QUIT') GOTO 3923
c              ENDDO
c 3923         CONTINUE
c              WRITE(6,*)'---------------------------------------'
c              WRITE(6,*) 'Please Enter number for sub-class : '
c              call flush (6)
c              READ(5,'(i2)') n_select 
cC Test for valid sub_class code number
c              DO i=1,60
c                 IF(n_select.eq.n_class(i)) then
c                    valid_class=.TRUE.
c                    sub_class_flag=s_class(i)
c                    WRITE(6,*)'Sub-class ', sub_class_flag, ' selected.'
c                 endif
c              ENDDO
c              IF(.not.valid_class) THEN
c                 WRITE(6,*)'Invalid Sub-class code. Try again'
c                 REWIND(read2)
c                 GOTO 3922
c              ENDIF
c              CALL sei close(close$,read2,code)
           ENDIF        ! end of volcanic section

c
c   get operator code
c
 3413     continue    ! enter here if no operator code
          if(operator.eq.'    ') then
             write(6,*)' Give operator code (max 4 char)'
             call flush (6)
             read(5,'(a4)') operator
             write(6,*)
     *     ' Give 2-5 letter data base, ,, for local dir,',
     *     ' return for default base'
             call flush (6)
             read(5,'(a5)')s_dir(1:5)
             if (s_dir(1:1).ne.' ') then
                do x=2,5
                   if (s_dir(x:x).eq.' ') s_dir(x:x)='_'
                enddo
             endif
             if(operator.eq.'    ') goto 3413
          endif
c     
c take out the synthetic phases for register , lo 09/99
c
          do k=1,nrecord
             data1(k)=data(k)
          enddo
          do k=1,max_data
                data(k) = ' '
          enddo
          i=0
          do k=1,nrecord
               if (data1(k)(10:10).ne.'y') then
                 i=i+1
                 data(i) = data1(k)
               endif
           enddo
           nrecord = i
c
c   generate extract file if cont data base or large seed volume 
c
           if(cwav.or.cseed) then

c
c   open and write in file for choises to extract program
c
              call sei open( unknown$,     ! Open file.
     &                      ' ',           ! No prompt.
     &                      'extract.inp', ! This file.
     &                      any_unit    ,  ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.
c
              window=stop_time-start_time
              write(any_unit,*) nchan
              do i=1,nchan
                 write(any_unit,'(i3,a)') channelname(i),' 0.0 0.0'
              enddo
              call sei close( close$, any_unit, code )
              wave_out=.false.
c
c   extract file
c
              if(cseed) then
                 window_abs_time=wav_abs_time(wav_first)+
     *           start_time
	        else
                  window_abs_time=cwav_abs_start_time+start_time
              endif
              call sectim
     *        (window_abs_time,year,i,month,day,hour,min,sec)
              i=sec+0.5
              write(text,'(i4,5i2)')year,month,day,hour,min,i
              do i=1,14
                 if(text(i:i).eq.' ') text(i:i)='0'
              enddo
              if(cwav) then
              write(text1(1:10),'(f10.1)') window
                long_text='wavetool -start '//text(1:14)//
     *          ' -cwav -duration '//text1(1:10)
     *          //' -chansel extract.inp -wav_out_file SEISAN'
c
c only selected databases
c
c                   do i=1,n_cont_base_sel
c                     long_text=long_text(1:seiclen(long_text))//
c     *                 ' -cbase '//
c     *                 cont_base(i)(1:seiclen(cont_base(i)))//' ' 
c                   enddo
                   if (n_cont_base_sel.gt.0) then
                     call sei open( unknown$,     ! Open file.
     &                      ' ',           ! No prompt.
     &                      'cbase.inp', ! This file.
     &                      any_unit    ,  ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.

                     do i=1,n_cont_base_sel
                       write(any_unit,'(a)')
     *                 cont_base(i)(1:seiclen(cont_base(i)))//' '
                     enddo
                     long_text=long_text(1:seiclen(long_text))//
     *                 ' -cbase cbase.inp '
                     call sei close( close$, any_unit, code )
                   endif

              else
                write(text1(1:10),'(f10.1)') window
                long_text='wavetool -start '//text(1:14)//
     *          ' -cseed -duration '//text1(1:10)
     *           //' -sfile '//sfile(1:seiclen(sfile))
     *          //' -chansel extract.inp -wav_out_file SEISAN'
              endif

              write(6,*) long_text
              call systemc(long_text,seiclen(long_text))
c
c   get file name
c
              call get_message('extract',long_text)
c
c   check if ok
c
              if(long_text(1:2).ne.'OK') then
                  write(6,*)
     *            ' Something wrong with wavetool, return to continue'
                  read(5,'(a)') i
                  goto 1100
              else
                  trace_file=' '
                  trace_file(1:29)=long_text(3:31)
              endif
              CALL new_s_file(year,month,
     *            day,hour,min,sec,type_kind, 
     *            s_dir,trace_file,new_sfile,data,operator,
     *            sub_class_flag,nhead,nrecord)
           else
c
c    case of normal file
c    bjb 2001/02/13 Remove path from filename if normal waveform file
c
              lastsl=r_index(wav_filename(1),dchar)
              trace_file=wav_filename(1)(lastsl+1:)

              CALL new_s_file(wav_year(wav_first),wav_month(wav_first),
     *            wav_day(wav_first),wav_hour(wav_first),
     *            wav_min(wav_first),
     *            wav_sec(wav_first),type_kind, 
     *            s_dir,trace_file,new_sfile,data,operator,
     *            sub_class_flag,nhead,nrecord)
           endif
c  
c-- CHECK IF S-FILE ALREADY EXIST, this section the same for single files
c   and cont data base
c
           call sei open( check$,              ! Check file exists.
     &                      ' ',                 ! No prompt.
     &                      new_sfile,           ! This filename.
     &                      0,                   ! Unit (n/a).
     &                      exist,               ! File exists?.
     &                      code )               ! Condition (n/a).
           write(6,*)                                                         
           write(6,'(a,2x,a)')' S-file name: ',new_sfile(1:
     &              seiclen(new_sfile))
           if(exist) THEN                                                     
                write(6,*)' S-FILE ALREADY EXISTS, OPTIONS ARE:       '
                write(6,*)' Ignore (leave old event)            Return'
                write(6,*)' Overwrite duplicate                 o     '
                write(6,*)' Create new event, different ID:     n     '
                call flush (6)
                READ(5,'(A1)') answer
c
c   overwrite
c
                IF(answer.EQ.'o'.OR.answer.EQ.'O') THEN                         
                   WRITE(6,*)' REALLY, REALLY SURE ?'
                   call flush (6)
                   READ(5,'(A1)') answer                                        
                ENDIF
c
c   ignore
c 
                if(answer.eq.' ') then
                   write(6,*)' Event not registered, return to continue'
                   call flush (6)
                   read(5,'(a)') answer
                   answer=' '   ! make sure a y do not come here
                endif
c
c   new id
c
                if(answer.eq.'n'.or.answer.eq.'N') then
                   i=seiclen(new_sfile)
                   k=1
 5857              continue
                   write(6,*) ' Creating a new id for event'
                   call inc_id(data(2),new_sfile,i) ! id line is assumed to be in line # 2
                   inquire(file=new_sfile,exist=exist)
                   k=k+1
c
c   check if not too many duplicates
c
                   if(k.gt.59) then
                      write(6,*)
     *                ' Cannot make a duplicate,',
     *                ' more than 60 events with same second'
                      write(6,*)' Return to stop'
                      call flush (6)
                      read(5,'(a)') answer
                      stop
                   endif
                   if(exist) then
                      goto 5857    ! try again
                   else
                      answer='y'   ! accept new event
                   endif
                endif
           ELSE                  ! file do not exist
                WRITE(6,739)                                           
 739            FORMAT(' GO AHEAD (Y/N)')              
                call flush (6)
                READ(5,'(A1)') answer                                           
           ENDIF                                                              
C                                                                               
C  OPEN AND WRITE S-FILE                                                        
C                                                                               
           if(answer.EQ.'Y'.OR.answer.EQ.'y') then                            
              call sei open( unknown$,        ! Open file.
     &                      ' ',             ! No prompt.
     &                      new_sfile,       ! This file.
     &                      write44,         ! On this unit.
     &                      b_flag,          ! exist
     &                      code )           ! Condition (n/a).

              WRITE(write44,'(A80)',iostat=code)
     &                 (DATA(I),I=1,nrecord) ! Write record.
c             WRITE(6,'(A80)',iostat=code)
c    &                 (DATA(I),I=1,nrecord) ! Write record.
              call sei code( fort$, code, write44, b_flag )     ! Process outcome.
              call sei close( close$, write44, code )           ! Close down.
c
c   now write following picks to data base, but only if not cont
c
              if(.not.cwav) then
                 sfile=new_sfile                 ! mar 19
                 call put_env_event(sfile)       ! mar 19, make sfile available
             
c
c   optinally start a process
c
              if(auto_process.gt.0) then
                 if(auto_process.eq.2) then
                    write(6,'(a,a)') ' Run process(y/return=n)? '
     *              ,auto_process_name
                     call flush (6)
                     read(5,'(a1)') answer
                     if(answer.eq.'y'.or.answer.eq.'Y') then
                        call systemc(auto_process_name,10)
                     endif
                  else
                     call systemc(auto_process_name,10)
                  endif
              endif  ! end of start a process
                  
c
c run hypocenter
c
              if(auto_locate.gt.0) then
                 if(auto_locate.eq.2) then
                    write(6,'(a,a)') 
     &              ' Locate event (y/return=n))? '
                    call flush (6)
                    read(5,'(a1)') answer
                    if(answer.eq.'y'.or.answer.eq.'Y') then
                       call systemc('hyp',3)
                    endif
                 else
                    call systemc('hyp',3)
                 endif
c
c  save location in s-file if desired 
c
                 if(auto_update.gt.0) then
                    if(auto_update.eq.2) then
                        write(6,*)
     &                  ' Do you want to save location, (y/return=n) ?'
                         call flush (6)
                         read(5,'(a1)') answer
                         if(answer.eq.'y'.or.answer.eq.'Y') then
                            if(sun.or.linux)call 
     &                      systemc('cp hyp.out '//sfile,91) 
                            if(pc) call 
     &                      systemc('copy hyp.out '//sfile,80)
                         endif
                      else
                         if(sun.or.linux)call
     &                   systemc('cp hyp.out '//sfile,91)
                         if(pc) call
     &                   systemc('copy hyp.out '//sfile,80)   ! bug ??
                      endif 
                   endif
c
c end of auto-location section
c
              endif
              endif   ! of not cont
c                                                                               
c   copy trace file name to WAV
c
              write(cwavyear,'(I4.4)') wav_year(1)
              write(cwavmon,'(I2.2)') wav_month(1)

              if(cwav.or.cseed) then
                 filen=trace_file
              else
                 filen=wav_filename(1)    ! assume only one
              endif
              if( pc ) then
                 if(copy_wav_dir.eq.' ') then
                    long_text = 'copy ' // filen(:seiclen(filen)) //
     &                 ' '                                    //
     &               top_directory(:seiclen(top_directory)) //
     &               dchar//'WAV'//dchar                    //
     &               filen(:seiclen(filen))
                 else
                    long_text = 'copy ' // filen(:seiclen(filen)) //
     &                 ' '                                    //
     &               top_directory(:seiclen(top_directory)) //
     &               dchar//'WAV'//dchar                    //
     &               copy_wav_dir//dchar//cwavyear(1:4)//dchar //
     &               cwavmon(1:2)//dchar
c     &               copy_wav_dir//dchar//filen(1:4)//dchar //
c     &               filen(6:7)//dchar                     
c     &               filen(:seiclen(filen))
                 endif
c
c bjb modified wavefile name to remove path when writing into S-file
c
              else if( sun.or.linux ) then
                 if(copy_wav_dir.eq.' ') then
                    long_text = 'cp   ' // filen(:seiclen(filen)) //
     &                 ' '                                    //
     &               top_directory(:seiclen(top_directory)) //
     &               dchar//'WAV'//dchar                    //
     &               trace_file(:seiclen(trace_file))
                  else
                     long_text = 'cp   ' // filen(:seiclen(filen)) //
     &                 ' '                                    //
     &               top_directory(:seiclen(top_directory)) //
     &               dchar//'WAV'//dchar                    //
     &               copy_wav_dir//dchar//cwavyear(1:4)//dchar //
     &               cwavmon(1:2)//dchar
c     &               copy_wav_dir//dchar//trace_file(1:4)//dchar //
c     &               trace_file(6:7)//dchar                      //
c     &               trace_file(:seiclen(trace_file))
                  endif
              else
                  chr_err_msg$ = 
     &'**** ERROR: could not determine the computer type'
                  call sei code( stop$, e_init$, 0, b_flag ) ! Halt program
              end if                                     !
c
              write(6,'(1x,a)') long_text                                          
c
c now copy
c
              call systemc( long_text,
     &                         seiclen(long_text) )
c
c  check that file got there
c
              call sei open( check$,              ! Check file exists.
     &                      ' ',                 ! No prompt.
     &        long_text(7+seiclen(filen):seiclen(long_text)),
     &                      0,                   ! Unit (n/a).
     &                      exist,               ! File exists?.
     &                      code )               ! Condition (n/a).
              if(exist) then
                  write(6,*)' File transferred to WAV **********'               
              else
                  write(6,*)' Failure to transfer to WAV ****'
                  write(6,*)' Return to continue'
                  call flush (6)
                  read(5,'(a4)') i
              endif
              write(6,*)                                                      
c
c   event was registered, go to next or another according to opmode,
c   however if in cont mode, replot
c
              if(cwav.or.cseed) then
                 choice='REPL'
                 write(6,*)' Continue plot(y/n=default)'
                 read(5,'(a)') text
                 if(text(1:1).eq.'y') then
                    goto 1100
                 else
                   goto 999 
                 endif
              else
                 choice='FINI'
              endif
           else
               write(6,*)' You did not register event'
c
c   if here, assume  pressed by mistake, replot
c   clean out data fil by resetting line counters
c
               nrecord=0
               nhead=0
c
               goto 1100                                                      
           endif                                                              
        endif               ! end of register (PUT) section
c
c-----------------------------------------------------------------
c   for remaining options, there might be a hard copy file which
c   could be sent to the plotter, check !                     
c-----------------------------------------------------------------
c
c   make hard copy plot                                                         
c                                                                               
        if(p_option.gt.1) then                                               
              call close_post
              call sei close( close$, plotunit, code ) ! Close (stop on error).
              write(6,'(a,$)')' Submit plot (y=return/n) '                      
              call flush (6)
              read(5,'(a)') dummy                                               
              if(dummy.eq.' '.or.dummy.eq.'Y'.or.dummy.eq.'y') 
     *        call send_plot("mulplt.eps",10)
        endif
c
c------------------------------------------------------------------------
c   check if other channels 
c------------------------------------------------------------------------
c
        if(choice.eq.'OTHE') then
              if(default) then         ! unset default in order to set ch.
                 default_org=default
                 default=.false.
              endif
c
c   show menu of other channels
c
              call channelselect(wav_nchan,wav_stat,wav_comp, 
     *        nchan,nchan_def,stat_def,comp_def,default)
c
c   stop if zero number of channels, can be caused by a q in selection
c
              if(nchan.eq.0) goto 999
        do i=1,nchan
           channelname_org(i)=channelname(i)
        enddo
c
c   save original number of channels, used if several screens are plotted
c
        nchan_org=nchan
c
c   set screen number
c
        n_screen=1
c
c
c   reset default
c
              default=default_org
              goto 1099                ! other channels
        endif
c
c-----------------------------------------------------------------------
c    check if other waveform file when called from eev
c-----------------------------------------------------------------------
c
        if(choice.eq.'OTWA' ) then
             if(opmode.eq.0) then
                one_plot=.false.   ! allow one more plot
                default=.false.    ! only if no default will file menu be shown
                goto 1000
             endif
        endif
c
c------------------------------------------------------------------------
c   check if next or another event from filenr.lis or next event
c   from eev is wanted, also next cont interval
c------------------------------------------------------------------------
c
        if(choice.eq.'FINI') then
              if(cwav.or.cseed) then            ! cont base
                  cwav_abs_start_time=cwav_abs_start_time+  ! advance start
     *            cont_interval*0.8
                  call cwav_time_limits(1)             ! calculate new lim
                  goto 1050                            ! next window
              endif
              if(opmode.eq.1) then     ! from filenr.lis
                 if(default ) then    
                     question(1:11)='#Next_file#' ! next event chosen, no quesitons
                 else
                     question(1:11)='           '
                 endif
                 goto 1000            ! get next file from filenr.lis
              else
                 if(opmode.eq.0) then
                   keys='NEXT'          ! - from data base, next event
                   goto 1000
                 else
                   goto 999             ! stop if called from eev
                 endif
              endif
        endif
c
c------------------------------------------------------------------------
c   check if back an event from filenr.lis or back one event
c   from eev is wanted, also back in cont interval
c------------------------------------------------------------------------
c
        if(choice.eq.'BACK') then
              if(cwav.or.cseed) then            ! cont base
                  cwav_abs_start_time=cwav_abs_start_time-  ! advance start
     *            cont_interval*0.8
                  call cwav_time_limits(1)             ! calculate new lim
                  goto 1050                            ! next window
              endif
              if(opmode.eq.1) then     ! from filenr.lis
                 if(default ) then    
                     question(1:11)='#Back_file#' ! next event chosen, no quesitons
                 else
                     question(1:11)='           '
                 endif
                 goto 1000            ! get next file from filenr.lis
              else
                 if(opmode.eq.0) then
                   keys='BACK'          ! - from data base, next event
                   goto 1000
                 else
                   goto 999             ! stop if called from eev
                 endif
              endif
        endif

c
c   end of multitrace option                                                    
c                                                                               
      endif                                                                     



         
c----------------------------------------------------------------------------------                                                                               
c-----------------------------------------------------------------------        
cccccc      start of section where channel data are picked   cccccccc
c           single trace option 0, only option left so no if
c-----------------------------------------------------------------------
c----------------------------------------------------------------------------------
c
c


c
c   select channels
c
       call channelselect(wav_nchan,wav_stat,wav_comp,                   
     * nchan,nchan_def,stat_def,comp_def,default)
c
c  sort after distance or time
c
       call channel_order(wav_stat,wav_delay,nchan,nsynt)                               
c
c  save original selection
c
       do i=1,nchan
          old_chan(i)=channelname(i)
       enddo
       old_nchan=nchan
c
c   stop if zero number of channels, can be cause by a q in selection
c
       if(nchan.eq.0) goto 999
c
c-------------------------------------------------------------------------
c   single trace mode loop startsn here, also get here if jump out
c   of multi trace mode above
c-------------------------------------------------------------------------
c
      i=0           ! start with channel one

 2000 continue
c                                                                               
      i=i+1
      if(i.le.0) i=1
      if(i.gt.nchan) goto 99    ! jump out of loop to stop
c                                                                               
c  read one channel data                                                        
c                                                                               
         ichan=channelname(i)   
c
c   check if baz angles should be calculated
c
         if(rotate.and.no_baz) then
            call get_baz
     *      (wav_nchan,wav_stat,data,nhead,nrecord,baz)
            no_baz=.false.      ! indicate that baz has been calculated
         endif
         resolu=resolu_x
c
c   read one channel, might have to be rotated in which case both horizontal
c   must be read
c

         wav_rot_comp(ichan)=' '
         wav_rot_delay(ichan)=0.0
          if(rotate.and.baz(ichan).lt.400.0.
     *    and.wav_comp(ichan)(4:4).ne.'Z') then
             call wav_read_2channel(ichan)
             numb_samp=wav_out_duration(1)*wav_rate(ichan)+1
             if(wav_comp(ichan)(4:4).eq.'N') wav_rot_comp(ichan)='R'
             if(wav_comp(ichan)(4:4).eq.'E') wav_rot_comp(ichan)='T'
             call rotate_comp(numb_samp,
     *       wav_out_first_sample(wav_current_chan(2)),
     *       wav_out_first_sample(wav_current_chan(3)),
     *       wav_rot_comp(ichan),
     *       baz(ichan),signal1,signal2,signal3)
c
c   replace parmeters for current channel due to rotation, time
c   start and interval might be different if 2 horizontal channels
c   have different start times
c
             wav_rot_delay(ichan)=wav_out_start(1)
     *       -wav_delay(ichan) ! normally zero
          else
             call wav_read_channel(ichan)
             numb_samp=wav_nsamp(ichan)
          endif

         rate=wav_rate(ichan) 
c                                                                               
c   make plot header, rotated times could be different                         
c                          
         head=' '
         head(1:40)=wav_file_text(1:40)
         head(41:45)=wav_stat(ichan)
         head(47:50)=wav_comp(ichan)
         if(wav_rot_comp(ichan).ne.' ') 
     *   head(50:50)=wav_rot_comp(ichan)
         if(rotate) then
            write(head(54:80),'(i4,4i2,f6.3)')wav_out_year(1),
     *      wav_out_month(1),wav_out_day(1),
     *      wav_out_hour(1),
     *      wav_out_min(1),wav_out_sec(1)                 
         else
            write(head(54:80),'(i4,4i2,f6.3)')wav_year(ichan),
     *      wav_month(ichan),wav_day(ichan),wav_hour(ichan),
     *      wav_min(ichan),wav_sec(ichan)                 
         endif
c         
c check for null chars
c
         do k=1,80
           if(ichar(head(k:k)).eq.0) head(k:k)=' '
         enddo
c                                                                               
cccccc   Get old picks       ccccccccccccccc                                    
c                                                                               
         call read_s_file
         if(nrecord.ge.max_data) then
              write(6,*)
     *      ' Too many lines in readings file'
              write(6,*)' Maximum is ',max_data
              goto 999 
          endif
c
c   add synthetic readings if any                                         
c
          call add_synt_readings(nsynt,synt_head)
c
         iswitch = 0
         call convert(wav_abs_time(ichan),wav_stat(ichan),                        
     +   wav_comp(ichan),iswitch)
c                                                                               
ccccc   plot the data and pick phases   ccccccccccccccccccc                                   
c
c  open plot file if needed
c
         if(plotoption.ge.1) then                              
             call sei open( unknown$,      ! Open file.
     &                      ' ',           ! No prompt.
     &                      'mulplt.eps',  ! This file.
     &                      plotunit,      ! On this unit.
     &                      b_flag,        ! Existance.
     &                      code )         ! Condition not applicable.
         endif                                                                 
c                 
         call open_display
c
         call picc   ! pick phases, make spec etc, one channel, most done here                                                               
c
c   close plot file, note everything done in picing mode is on one page !
c
        if(plotoption.ge.1)  then 
           call close_post                               
           call sei close( close$, plotunit, code ) ! Close (stop on error).
        endif
c                                                                               
c   make hard copy plot                                                         
c                                                                               
        if(p_option.gt.1) then                                               
           call clear_to_alpha
           write(6,'(a,$)')' Submit plot (y=return/n) '                      
           call flush (6)
           read(5,'(a)') dummy                                               
           if(dummy.eq.' '.or.dummy.eq.'Y'.or.dummy.eq.'y') 
     *     call send_plot("mulplt.eps",10)
        endif
c
c-----------------------------------------------------------------
c   if replot, assume this or previous choice was rotate, 
c   go and read other horizontal channel and plot again
c-----------------------------------------------------------------
c
        if(choice.eq.'REPL') then
           i=i-1    ! use same channel
           goto 2000
        endif
c
c------------------------------------------------------------------                                                                               
c   Always save readings, also when quitting         
c------------------------------------------------------------------

         iswitch = 1                                                            
                                                                                
         call convert(wav_abs_time(ichan),wav_stat(ichan),                     
     +   wav_comp(ichan),iswitch)
c
         call write_s_file
c
c                                                                               
c   decide what to do next                                                      
c                                                                               
         if(choice.eq.'QUIT') then       ! save also if quit                   
             call clear_to_alpha
             goto 999
         endif

c-----------------------------------
c  check if multi channel plot
c-----------------------------------
c
        if(choice.eq.'TOGL') then
c
c   if only one channel was selected above, assume you want to go
c   back to old multi channel selection 
c
           if(nchan.eq.1) then
              do l=1,old_nchan
                 channelname(l)=old_chan(l)
              enddo
              nchan=old_nchan
           endif
           goto 1100
        endif
c
c----------------------------------
c-- chose other channels                        
c----------------------------------
c
        if(choice.eq.'OTHE') then
           if(default) then         ! unset default in order to set ch.
              default_org=default
              default=.false.
           endif
           call channelselect(wav_nchan,wav_stat,wav_comp,
     *     nchan,nchan_def,stat_def,comp_def,default)
           default=default_org
c
c   stop if zero number of channels, can be cause by a q in selection
c
           if(nchan.eq.0) goto 999
c
c  sort after distance or time
c
           call channel_order(wav_stat,wav_delay,nchan,nsynt)                  
           i=0
c
           goto 2000              ! start again
        endif
c
c check if going back one channel
c
        if(choice.eq.'BACK') i=i-2 
        goto 2000
c 
c---------------------------------------------------------------------------
c   End of channel picking loop in single channel mode
c---------------------------------------------------------------------------
c---------------------------------------------------------------------------                                                                  

 99    continue    

c
c-------------------------------------------------------------------------- 
c
      if(opmode.eq.1) then ! if in multiple event mode
         call clear_to_alpha
         goto 1000         ! another event
      endif                                                      
c                                                                               
 999  continue                                                                  
      call clear_to_alpha                                                     
c
c   there might be a hard copy file which
c   could be sent to the plotter, check !   ! 4-2001 jh: there never seesm to
c                                                        to be a plot, caused
c                                                        crash
c
c   make hard copy plot
c
c          if(p_option.gt.10) then     
c             call close_post
c             call sei close( close$, plotunit, code ) ! Close (stop on error).
c             write(6,'(a,$)')' Submit plot (y=return/n) '
c             call flush (6)
c             read(5,'(a)') dummy
c             if(dummy.eq.' '.or.dummy.eq.'Y'.or.dummy.eq.'y')
c    *        call send_plot("mulplt.eps",10)
c          endif

c                                                                               
c    Close down all files...
c
      call sei close( close$+all$,               ! Close all files.
     &                0,                         ! Unit (n/a).
     &                code )                     ! Condition (n/a).
      
      stop                                                                      
      end                                                                       
                                                                                
c------------------------------------------------------------------------------ 
      subroutine channelselect(number_of_channels,station,comp,                 
     *           nchan,nchan_def,stat_def,comp_def,
     *           default)                               
c                                                                               
c                                                                               
c     Routine to show default channels and select channels to plot.             
c                                                                               
c     written by  j. havskov                                     
c                                                                               
c     Input:   number_of_channels   : in input file                             
c              station, comp        : station and component in input file       
c              stat_def,comp_def    : default channels
c              nchan_def            : number of default channels
c              default              : if default or not for selection
c                                                                               
c     Input/Output:  channelname    : channel numbers selected,now in common                  
c                    nchan          : number of channels selected               
c
      implicit none
      include 'mulplt.inc'
c
c------------------------------------------------------
      include 'libsei.inc'              ! Library definitions & data defns.
      external   sei integer            ! Extract integer from string.
      integer    sei integer            ! & function.
      integer    code                   ! Condition code.
c---------------- end of sei lib changes --------------
c-- channels selected                             
c     integer channelname(max_trace)			
c-- number of channels in file                  
      integer number_of_channels
      integer nchan_def		
c-- station and components                
      character*5 station(max_trace)
      character*4 comp(max_trace)		
      character*5 stat_def(*)
      character*4 comp_def(*)
      character*2 answer     
c--- next 3 for sorting
      character*80 cha_sort_in(max_trace)
      character*80 cha_sort_out(max_trace)
      integer order_out(max_trace)                                                   
c-- selected array                               
      character*1 selected(max_trace)			
      integer on(max_trace)
      integer on_temp(max_trace)
c-- output text                                     
      character*75 text(12)
      character*80 box_text(max_trace)
      character*120 title
      character*80 box_text_temp(max_trace)
      character*1  ph(max_trace)  ! mark if a phase present
c-- number of ch. selected                                 
      integer nchan				
c-- last character pushed in input_box
      character*1 last_char
c-- number of lines print.                             
      integer lines_out				
      character*2 comp_short   ! short version of component notation
      integer nchan_in_box     ! number of channels used for selkection if more than 250
      logical default
c-- Counters                                               
      integer i,j,k,box,l
      box=1

c
c   initialize channel names
c
      do i=1,max_trace
         channelname(i)=0
      enddo	
	  
      do i=1,number_of_channels
         ph(i)=' '
      enddo
c
c   sort channels 
c
      do i=1,number_of_channels
          cha_sort_in(i)(1:10)=station(i)//'A '//comp(i)
c
c   get components in right order
c
          if(comp(i)(4:4).eq.'Z') cha_sort_in(i)(7:7)='1'
          if(comp(i)(1:1).eq.'A') cha_sort_in(i)(6:6)='B'     ! acceleration channels at end
          if(comp(i)(4:4).eq.'N') cha_sort_in(i)(7:7)='2'
          if(comp(i)(4:4).eq.'E') cha_sort_in(i)(7:7)='3'
      enddo
      call  text_sort(cha_sort_in,cha_sort_out,order_out,
     *                number_of_channels)        

c                                                                               
c   find which default channels are present, initially selected if the
c   default option is used                                     
c                                                                               
      do i=1,number_of_channels
         k=order_out(i)
c         write(17,*) 
c     *   i,station(i),comp(i),order_out(i),station(k),comp(k)
      enddo

      k=0                                                                       
      do i=1,number_of_channels                                                 
         do j=1,nchan_def                                                       
c            write(17,*) station(i),stat_def(j),comp(i),comp_def(j)
            l=i
            if(chan_sort) l=order_out(i)
            if(station(l).eq.stat_def(j).and.comp(l).eq.
     *         comp_def(j)) then                
c               write(17,*) k, selected,order_out(i)
               k=k+1                                                            
               channelname(k)=l
            endif                                                               
         enddo                                                                  

c
c   find if any reading this channel
c
         if(nrecord.gt.0) then
          do j=nhead+1,nrecord-1
            call component(comp(i),comp_short) ! get short version of component
            if(station(i).eq.data(j)(2:6)
     *      .and.comp_short.eq.
     *      data(j)(7:8)) 
     *      ph(i)='*'
          enddo
         endif
      enddo                                                                     
      nchan = k                                                                 
      do i=1,nchan
c         write(17,*) i,channelname(i)
      enddo
c
c   check if not too many channels
c
      if(k.gt.max_trace) then
         write(6,*)' Too many channels, will define ',max_trace
         k=max_trace ! look like it does not work, is it needed ?
      endif
c
c   if no default channels, select all
c
      if(nchan.eq.0) then
         do i=1,number_of_channels
            if(chan_sort) then
               channelname(i)=order_out(i)
            else
               channelname(i)=i
            endif
         enddo
         nchan=number_of_channels
      endif 	  
	  
c
c   return if default
c
      if(default) return

c                                                                               
c  mark channels already selected                                               
c                                                                               
      do i=1,number_of_channels
        on(i)=0
      enddo
      do i=1,number_of_channels                                                 
        on(i)=0                                                     
        do k=1,nchan                                                            
           if(chan_sort.and.channelname(k).eq.order_out(i))                            
     *       on(i)=1
           if(.not.chan_sort.and.channelname(k).eq.i)
     *       on(i)=1
        enddo                                                                   
      enddo
c
c
c  put in text for boxes
c
      do k=1,number_of_channels
            if(chan_sort) then
                i=order_out(k)
            else
                i=k
            endif
            box_text(k)=station(i)//comp(i)//ph(i)
            channelname(i)=0
      enddo
c
c   display channels
c
         title=
     *   'SELECT CHANNELS, FILLED OUT BOXES INDICATE SELECTION,'//
     *   ' A * INDICATES A PHASE READ '
         title(81:120)=' '
c
c   less than 250 channels
c
      if(number_of_channels.le.250) then
         box_text(number_of_channels+1)='All Z'
         call input_box
     *   (number_of_channels+1,on,10,90.0,15.0,box_text,10,
     *                     3.0,685.0,title,last_char,1,0)
       endif

c
c   Quit...
c
      if(last_char.eq.'Q'.or.last_char.eq.'q') then
         nchan=0
         return
      end if   
c
c   250 to 500 channels
c
      if(number_of_channels.gt.250) then

         do i=1,number_of_channels
           on_temp(i)=on(i)
           box_text_temp(i)=box_text(i)
         enddo
c
c  show 1-250
c
         title(85:111)='MORE CHANNELS, PUSH OK OR F'

         nchan_in_box=250
         box_text(nchan_in_box+1)='All Z'
         do i=1,nchan_in_box
            on_temp(i)=on(i)
         enddo
         call input_box(nchan_in_box+1,on_temp,10,90.0,15.0,box_text,10,
     *                     3.0,710.0,title,last_char,1,0)

c   Quit...
c
         if(last_char.eq.'Q'.or.last_char.eq.'q') then
            nchan=0
            return
         end if   
c
c   save choises
c
         do i=1,250
             on(i)=on_temp(i)
         enddo
      endif
c
c   show 251-500
c
      if(number_of_channels.gt.250) then 
         if(number_of_channels.gt.500) then
             title(85:111)='MORE CHANNELS, PUSH OK OR F'
             nchan_in_box=250
         else
             nchan_in_box=number_of_channels-250
             title(85:111)=' '
         endif  
         do i=1,nchan_in_box
            on_temp(i)=on_temp(i+250)
            box_text(i)=box_text_temp(i+250)   ! use original text
         enddo

         box_text(nchan_in_box+1)='All Z'
         call input_box
     *   (nchan_in_box+1,on_temp,10,90.0,15.0,box_text,10,
     *                     3.0,710.0,title,last_char,1,0)
c   Quit...
c
         if(last_char.eq.'Q'.or.last_char.eq.'q') then
            nchan=0
            return
         endif

c
c   save choises
c
         do i=1,nchan_in_box
             on(i+250)=on_temp(i)
         enddo         
      endif
c
c   show 501-750
c

      if(number_of_channels.gt.500) then
         if(number_of_channels.gt.750) then
             title(85:111)='MORE CHANNELS, PUSH OK OR F'
             nchan_in_box=250
         else
             nchan_in_box=number_of_channels-500
             title(85:111)=' '
         endif
         do i=1,nchan_in_box
            on_temp(i)=on_temp(i+500)
            box_text(i)=box_text_temp(i+500)   ! use original text
         enddo
         box_text(nchan_in_box+1)='All Z'
         call input_box
     *   (nchan_in_box+1,on_temp,10,90.0,15.0,box_text,10,
     *                     3.0,710.0,title,last_char,1,0)
c   Quit...
c
         if(last_char.eq.'Q'.or.last_char.eq.'q') then
            nchan=0
            return
         endif

c
c   save choises
c
         do i=1,nchan_in_box
            on(i+500)=on_temp(i)
         enddo
      endif
c
c   show 750-1000
c
      if(number_of_channels.gt.750) then
         if(number_of_channels.gt.1000) then
             write(6,*)' Number of channels too large'
             stop
         else
             nchan_in_box=number_of_channels-750
             title(85:111)=' '
         endif
         do i=1,nchan_in_box
            on_temp(i)=on_temp(i+750)
            box_text(i)=box_text_temp(i+750)   ! use original text
         enddo

         box_text(nchan_in_box+1)='All Z'
         call input_box
     *   (nchan_in_box+1,on_temp,10,90.0,15.0,box_text,10,
     *                     3.0,710.0,title,last_char,1,0)
c   Quit...
c
         if(last_char.eq.'Q'.or.last_char.eq.'q') then
            nchan=0
            return
         endif

c
c   save choises
c
         do i=1,nchan_in_box
             on(i+750)=on_temp(i)
         enddo
      endif

c
c   take out selected channels
c
      k=1
      do i=1,number_of_channels
         if(on(i).eq.1) then
            if(chan_sort) then
               channelname(k)=order_out(i)   
            else
               channelname(k)=i
            endif
            k=k+1
         endif
      enddo

      nchan=k-1                                                         
                                                                 
      return                                                                    
      end                                                                       
******************************************************************              

      subroutine channel_order(station,                 
     *           delay,nchan,nsynt)                               
c                                                                               
c                                                                               
c     Routine to order channels in aproximate distance              
c                                                                               
c     written j. havskov, oct 95                                     
c                                                                               
c     Input:                                
c              station              : station       
c              trace_delay          : delay each trace relative to main header
c              nsynt                : number of sybthetic readings
c
c     Input/Output:  channelname    : channel numbers reordered,now in common                  
c                    nchan          : number of channels selected               
c     
c
      implicit none
      include 'mulplt.inc'
c
c-- channels selected                             
c     integer channelname(*)			
      real delay(*)                      ! channel delay
      integer new_channelname(max_trace) ! for reordering channels
      logical not_used(max_trace)        ! if channel reordered or not
      integer min             ! channel number of channel with minumum delay
      real mindel             ! minimum delay
      integer nsynt
c-- station                 
      character*5 station(*)
c-- number of ch. selected                                 
      integer nchan				
c-- Counters                                               
      integer i,j,k,l
	  
c
c  check if stations are to be plotted in distance order, nsort_distance must
c  be positive
c
 
c      write(6,*)nsort_distance,nrecord,nhead
       if(nsort_distance.eq.0) return
c
         do i=1, nchan
            not_used(i)=.true.          ! no channels are ordered initially
         enddo
c
c  plot in order as given in s-file, if a station not in s-file, put at end
c
         if(nrecord-nhead-nsynt.gt.nsort_distance) then ! only do if enough readings
c         write(6,*)'phas'
            k=0                         ! count channels reordered
            do j=nhead+1,nrecord-1      ! put in same order as in s-file
               do i=1,nchan             ! check every prev. selected channel
                  if(station(channelname(i)).eq.data(j)(2:6).
     *            and.not_used(i)) then
                     k=k+1
                     not_used(i)=.false.     ! channel now ordered
                     new_channelname(k)=channelname(i)
                  endif
               enddo
            enddo
            do i=1,nchan                 ! put channels not ordered at the end
               if(not_used(i)) then
                  k=k+1
                  new_channelname(k)=channelname(i)
               endif
            enddo
            do i=1,nchan                 ! put channel order back in org. array
               channelname(i)=new_channelname(i)
            enddo
         else                           
c
c   use waveform file header time order
c
c            write(6,*)'time order'
             i=1
 10             continue
                mindel=9999999.0      ! initialize minumum delay
                   do l=1,nchan          ! find minimum delay of remaining stats.
                      if(delay(channelname(l)).lt.mindel.and.
     *                not_used(l))  then 
                         mindel=delay(channelname(l))
                         min=l
                      endif
                   enddo
                   not_used(min)=.false.     ! channel now ordered
                   new_channelname(i)=channelname(min)
                   k=0                      ! number of channels, same station
                   do l=1,nchan             ! make sure remaining channels
                      if(station(channelname(l)).eq.   ! - of same station are
     *                station(channelname(min)).and.not_used(l)) then 
                         not_used(l)=.false.      ! - selected together
                         i=i+1
                         new_channelname(i)=channelname(l)
                      endif                   
                   enddo
               i=i+1
               if(i.le.nchan) goto 10
            do i=1,nchan                 ! put channel order back in org. array
               channelname(i)=new_channelname(i)
            enddo
         endif
                         
c
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine get_mulplt_def(def_unit,stat_def
     *,comp_def,nchan_def)               
c                                                                               
C     get mulplt defaults                                            
c                                                                               
c     written by  J. Havskov                                     
c                                                                               
c     Input:   def_unit  : unit to read from (changed to output..JAB(BGS)Dec94)
c              data      : work array                                               
c     Output:  defaults, through window, default channels to plot,
c                        the rest through common block                                                      
c                  
      implicit none
      external sei get file,                 ! Search directories & open file.
     &         sei close,                    ! Close file open.
     &         sei code                      ! Error processor.
      include 'libsei.inc'                   ! Library definitions & data defns
      integer  code                          ! Condition.
      logical  b_eof                         ! End of file?.
c
      include 'mulplt.inc'
      include 'seiplot.inc'
      character*5 stat_def(*)
      character*4 comp_def(*)			
c-- unit for file
      integer def_unit
c-- directory separator char
      character*1 dchar
c-- path to seismo                             
      character*60 top_directory			
c-- number of default channels                                
      integer nchan_def
c-- Counters and help variables
      character*1 amouse            
      real xmouse,x_screen_size,xres,xsort_distance,ca,xin
                                        
      integer i,k,nline				
      logical sun,pc,linux
c
      call dir_char(dchar)
      call topdir(top_directory)
      call computer_type(sun,pc,linux)
c
c   set default parameters in case there is no mulplt.def
c
c-- mouse is blank                                               
c
      if(sun.or.linux) mouse=ichar(' ')
      if(pc) mouse=ichar(' ')
      resolu_x=1000
      resolu_hc=3000
      nchan_def=0
      numb_keys=0
      numb_weights=0
      q0=0.0
      kappa=0
      qalpha=1.0
      travel_time=1.0
      pvelocity=6.0
      svelocity=3.5
      density=3.0
      three_comp_velocity=5.0
      nsort_distance=0
      ffmin=0.05
      ffmax=50.0
      auto_locate=0.0
      auto_update=0.0
      auto_process=0.0
      auto_process_name=' '
      spec_out=0.0
      filt=0
      coda_h=10.0
      coda_l=5.0
      coda_sta=5.0
      coda_ratio=1.5
      do_auto_coda=.FALSE.
      ms_high=0.1000
      ms_low=0.038
      ms_low_pole=2
      ms_high_pole=1
      mb_low=0.9
      mb_high=1.8
      mb_low_pole=2
      mb_high_pole=3
      ml_high = 20.0
      ml_high_pole=8
      ml_low=1.25
      ml_low_pole=8
c
c   others
c
      n_chan_screen=99 ! max 99 channels per screen
      chan_sort=.true. ! sort alphabetically
c
c Set time domain recursive filter type to 0 (use function bndpas bjb 2001/02/14)
c
      filter_type=0
c                                                                               
c   Initially set mulplt filters (bjb 2001/02/13)
c                                                                               
      flow(1)=0.01                                                             
      fhigh(1)=.1
      flow(2)=.1                                                              
      fhigh(2)=1.0
      flow(3)=1.0                                                               
      fhigh(3)=5.0                                                             
      flow(4)=5.0                                                              
      fhigh(4)=10.0                                                             
      flow(5)=10.0                                                              
      fhigh(5)=15.0                                                             
      flow(6)=15.0                                                              
      fhigh(6)=23.0                                                             
      flow(7)=2.0
      fhigh(7)=4.0
c                                                                               
c   get path to seismo                                                          
c                                                                               
      k=index(top_directory,' ')-1                                              
c                                                                               
c   open and read default file with stations and components to use              
c   --------------------------------------------------------------
c
      call sei get file( open$+ignore$,    ! Find and open without messages.
     &                   def_unit,         ! On file unit.
     &                   code,             ! Condition (n/a).
     &                   'DAT',            ! Alternative directory to search.
     &                   'MULPLT.DEF' )    ! For this file.
c                                                                               
c   read file if there...
c   ------------
c                                                                               
      if(code.ne.e_ok$)  goto 666

      i=1                                                                       
10    read(def_unit,'(a)',iostat=code) data(i) ! Read from file.
      call sei code( fort$,                    ! Process fortran i/o condition.
     &               code,                     ! Condition.
     &               def_unit,                 ! On unit.
     &               b_eof )                   ! End of file?.
c
      if( b_eof ) then                         ! End of file.
      nline=i                                  ! Store records in file.
      call sei close( close$, def_unit, code ) ! Close (Default stop on error).
c
      else                                     ! Otherwise.
      i=i+1                                    ! Increment record number.
      goto 10                                  ! Read another record.
      end if                                   !
c
c   find default chanels
c
      do i=1,nline
         if(data(i)(1:15).eq.'DEFAULT CHANNEL'.and.
     *      data(i)(41:50).ne.'          ') then
            nchan_def=nchan_def+1
            stat_def(nchan_def)=data(i)(41:45)
            comp_def(nchan_def)=data(i)(51:54)
         endif
      enddo		 
c
c   find keys assigned to phases
c
      do i=1,nline
         if(data(i)(1:14).eq.'PHASE NAME KEY'.and.
     *      data(i)(41:50).ne.'          ') then
            numb_keys=numb_keys+1
            ascip(numb_keys)=data(i)(41:41)
            phs(numb_keys)=data(i)(51:59)
         endif
c
c  weight keys assigned
c
         if(data(i)(1:16).eq.'PHASE WEIGHT KEY'.and.
     *      data(i)(41:50).ne.'          ') then
            numb_weights=numb_weights+1
            if(numb_weights.gt.10) then
               write(6,*)' You have defined too many weights'
               write(6,*)' Reduce to 10 or less in MULPLT.DEF'
               stop
            endif
            key_weight(numb_weights)=data(i)(41:41)
            i_weight(numb_weights)=data(i)(51:51)
         endif
      enddo
c
c   find if a mouse definition, can be a character or ascii code
c
      do i=1,nline
         if(data(i)(1:15).eq.'PHASE MOUSE KEY'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)', err=273 ) xmouse
            mouse=xmouse
            goto 274
 273        continue
c
c   was not a number, try a character
c
            amouse=data(i)(41:41)
            mouse=ichar(amouse)
 274        continue
         endif
      enddo
c
c   find and set spectral and other parameters
c
      do i=1,nline
         if(data(i)(1:11).eq.'SPECTRAL Q0'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) q0
         endif
         if(data(i)(1:15).eq.'SPECTRAL QALPHA'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) qalpha
         endif
         if(data(i)(1:14).eq.'SPECTRAL KAPPA'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99)kappa
         endif
         if(data(i)(1:19).eq.'SPECTRAL S-VELOCITY'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) svelocity
         endif
         if(data(i)(1:19).eq.'SPECTRAL P-VELOCITY'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) pvelocity
         endif
         if(data(i)(1:16).eq.'SPECTRAL DENSITY'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) density
         endif
         if(data(i)(1:15).eq.'SPECTRAL F-BAND'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) ffmin,ffmax
         endif
         if(data(i)(1:15).eq.'BANDPASS FILTER'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) flow_def,fhigh_def
            filt=9
         endif
         if(data(i)(1:15).eq.'SPECTRAL OUTPUT'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(f10.1)',err=99) spec_out
         endif
         if(data(i)(1:22).eq.'WOOD ANDERSON HIGH CUT'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(f10.1)',err=99) ml_high
            ml_high_pole=8
         endif

         if(data(i)(1:21).eq.'ML HIGH CUT AND POLES'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) ml_high,xin
            ml_high_pole=xin
            if(ml_high_pole.eq.0) ml_high_pole=8
         endif

         if(data(i)(1:21).eq.'MS HIGH CUT AND POLES'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) ms_high,xin
            ms_high_pole=xin
            if(ms_high_pole.eq.0) ms_high_pole=8
         endif

         if(data(i)(1:20).eq.'ML LOW CUT AND POLES'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) ml_low,xin
            ml_low_pole=xin
            if(ml_low_pole.eq.0) ml_low_pole=8
         endif


         if(data(i)(1:20).eq.'MS LOW CUT AND POLES'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) ms_low,xin
            ms_low_pole=xin
            if(ms_low_pole.eq.0) ms_low_pole=8
         endif

         if(data(i)(1:21).eq.'MB HIGH CUT AND POLES'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) mb_high,xin
            mb_high_pole=xin
            if(mb_high_pole.eq.0) mb_high_pole=8
         endif

         if(data(i)(1:20).eq.'MB LOW CUT AND POLES'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:60),'(2f10.1)',err=99) mb_low,xin
            mb_low_pole=xin
            if(mb_low_pole.eq.0) mb_low_pole=8
         endif
c
c   velocity for 3c analysis
c
         if(data(i)(1:14).eq.'3COMP VELOCITY'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) three_comp_velocity
         endif
c
c   autoprocessing and location
c
         if(data(i)(1:11).eq.'AUTO_LOCATE'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99)auto_locate 
            read(data(i)(51:60),'(f10.1)',err=99)auto_update 
         endif


         if(data(i)(1:12).eq.'AUTO_PROCESS'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) auto_process
            auto_process_name(1:10)=data(i)(51:60)
         endif

c
c Read filter type parameter from MULPLT.DEF (bjb 2001/02/14)
c
         if(data(i)(1:11).eq.'FILTER TYPE'.and.
     *      data(i)(41:50).ne.'          ') then

            read(data(i)(41:50),'(f10.1)') filter_type
         endif

c
c Read filter parameters for up to 7 filters from MULPLT.DEF (bjb 2001/02/13)
c
         if(data(i)(1:8).eq.'FILTER 1'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)') flow(1)
            read(data(i)(51:60),'(f10.1)') fhigh(1)
         endif

         if(data(i)(1:8).eq.'FILTER 2'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)') flow(2)
            read(data(i)(51:60),'(f10.1)') fhigh(2)
         endif

         if(data(i)(1:8).eq.'FILTER 3'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)') flow(3)
            read(data(i)(51:60),'(f10.1)') fhigh(3)
         endif

         if(data(i)(1:8).eq.'FILTER 4'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)') flow(4)
            read(data(i)(51:60),'(f10.1)') fhigh(4)
         endif

         if(data(i)(1:8).eq.'FILTER 5'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)') flow(5)
            read(data(i)(51:60),'(f10.1)') fhigh(5)
         endif

         if(data(i)(1:8).eq.'FILTER 6'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)') flow(6)
            read(data(i)(51:60),'(f10.1)') fhigh(6)
         endif

         if(data(i)(1:8).eq.'FILTER 7'.and.
     *      data(i)(41:50).ne.'          '
     *     .and.data(i)(51:60).ne.'          ') then
            read(data(i)(41:50),'(f10.1)') flow(7)
            read(data(i)(51:60),'(f10.1)') fhigh(7)
         endif
c
c   number of phases to do sorting, or no sortingó
c
         if(data(i)(1:14).eq.'NSORT_DISTANCE'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99)xsort_distance 
            nsort_distance=xsort_distance
         endif
c
c   x screen size
c
         if(data(i)(1:13).eq.'X_SCREEN_SIZE'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99) x_screen_size
            wsize=x_screen_size
         endif                      
c
c  resolution
c
         if(data(i)(1:11).eq.'RESOLUTIONX'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99)xres
            resolu_x=xres
         endif
         if(data(i)(1:12).eq.'RESOLUTIONHC'.and.
     *      data(i)(41:50).ne.'          ') then
            read(data(i)(41:50),'(f10.1)',err=99)xres
            resolu_hc=xres
         endif
c
c parameters for automatic coda
c
         if(data(i)(1:15).eq.'AUTOCODA FILTER') then
           if (data(i)(41:50).ne.'          ') then
              read(data(i)(41:50),'(f10.1)',err=99) coda_l
           endif
           if (data(i)(51:60).ne.'          ') then
              read(data(i)(51:60),'(f10.1)',err=99) coda_h
           endif
         endif

         if(data(i)(1:12).eq.'AUTOCODA STA'.and.
     *       data(i)(41:50).ne.'          ') then
             read(data(i)(41:50),'(f10.1)',err=99) coda_sta
         endif

         if(data(i)(1:14).eq.'AUTOCODA RATIO'.and.
     *       data(i)(41:50).ne.'          ') then
             read(data(i)(41:50),'(f10.1)',err=99) coda_ratio
         endif

         if(data(i)(1:9).eq.'CODA AUTO') then
             read(data(i)(41:50),'(f10.1)',err=99)ca 
               k = int(ca)
             if (k.eq.0) do_auto_coda=.FALSE.
             if (k.eq.1) do_auto_coda=.TRUE.
         endif
c
c  number of traces to one screen
c
         if(data(i)(1:16).eq.'NCHAN PER SCREEN') then
             read(data(i)(41:50),'(f10.1)',err=99)ca 
               k = int(ca)
             if (k.gt.0) n_chan_screen=k
         endif

        if(data(i)(1:15).eq.'CHANNEL SORTING') then
             read(data(i)(41:50),'(f10.1)',err=99)ca 
               k = int(ca)
             if (k.gt.0) chan_sort=.true.
             if (k.eq.0) chan_sort=.false.
         endif



      enddo
c
c 
  666   continue
c
c   if no phases were defined, do it here
c
       if(numb_keys.eq.0) then	
c-- IP	! - default                                         

c-- IP	! - default                                         
          ascip(1)='1'	
          phs(1)='IP       '                                                       
c-- EP                                                     
          ascip(2)='2'	
          phs(2)='EP       '                                                       
c-- EPG                                                    
          ascip(3)='3'	
          phs(3)='IPg      '                                                       
c-- EPG                                                    
          ascip(4)='4'	
          phs(4)='EPg      '                                                       
c-- IPN                                                    
          ascip(5)='5'	
          phs(5)='IPn      '                                                       
c-- EPN                                                    
          ascip(6)='6'	
          phs(6)='EPn      '	                                                      
c-- IS                                                     
          ascip(7)='7'	
          phs(7)='IS       '                                                       
c-- ES                                                     
          ascip(8)='8'	
          phs(8)='ES       '                                                       
c-- ISG                                                    
          ascip(9)='9'	
          phs(9)='ISg      '                                                       
c-- ESG                                                   
          ascip(10)='0'	
          phs(10)='ESg      '                                                      
c--  SN                                                   
          if(pc.or.linux)ascip(11)='+'	
          if(sun)ascip(11)='-'	
          phs(11)=' Sn      '                                                      
c-- ESN                                                   
c         ascip(13)='}'	
c         if(pc) ascip(13)=dchar
c         phs(13)='ESn      '                                                      
c-- LG                                                    
           if(sun) ascip(12)='='	
           if(pc.or.linux) ascip(12)=dchar
           phs(12)=' Lg      '                                                      
c         ascip(14)='l'	
c         phs(14)='Lg       '                                                      
c-- coda                                                  
          ascip(15)='c'	
          phs(15)='CODA     '                                                      
c-- coda                                                  
c
          ascip(16)='C'	
          phs(16)='CODA     '                                                      
c-- i     
          ascip(17)='i'
          phs(17)='I        '
c          ascip(18)='I'
c          phs(18)='I        '                                                      
c-- e     
          ascip(19)='e'
          phs(19)='E        '
c          ascip(20)='E'
c          phs(20)='E        '                                                      
c-- A
          ascip(21)='A'
          phs(21)=' AMP'
          numb_keys=21    

      endif
c                                                                               
c   define keys for weight if not done above                                  
c                                           
      if(numb_weights.eq.0) then                                 
c--	 upper case 1                                          
      key_weight(1)='!'
c-- upper case 2                                          
      key_weight(2)='@'
      if(pc) key_weight(2)='"'	
c-- upper case 3                                          
      key_weight(3)='#'	
c-- upper case 4                                          
      key_weight(4)='$'
c-- upper case 5                                          
      key_weight(5)='%'	
c-- upper case 6                                          
      key_weight(6)='^'	
      if(pc)key_weight(6)='&'
c-- upper case 7                                          
      key_weight(7)='&'	
      if(pc) key_weight(7)='/'
c-- upper case 8                                          
c     key_weight(8)='*'   ! temporary fix on sun	
      if(pc) key_weight(8)='('
c-- upper case 9                                          
      key_weight(9)='('	
      if(pc) key_weight(9)=')'
c-- upper case 0                                          
      key_weight(10)=')'
      if(pc) key_weight(10)='='
c                                                                               
c  assign weights asci values                                                   
c                                                                               
      i_weight(1)='1'                                                           
      i_weight(2)='2'                                                           
      i_weight(3)='3'                                                           
      i_weight(4)='4'                                                           
      i_weight(5)='5'                                                           
      i_weight(6)='6'                                                           
      i_weight(7)='7'                                                           
      i_weight(8)='8'                                                           
      i_weight(9)='9'                                                           
      i_weight(10)=' '          
      endif                      

c
c  save value of nsort_distance, might be temporarely turned off
c
c3-07-jh      nsort_distance_save=nsort_distance                          
c
c    Return to Caller...
c    ===================
c
c   errror
c
      goto 9999
99    continue
      write(6,*)' Errror in MULPLT.DEF'
      write(6,*)' Enter to to continue'
      call flush (6)
      read(5,'(a)') i
      stop
c
9999  return
      end
c
c******************************************************************             
                                                                                
      subroutine new_s_file(year,month,day,hr,min,sec,type,                     
     *            sdir,trace_file,event_name,data,operator,
     *            sub_class_flag,nhead,nrecord)                    
c                                                                               
c     Makes an initial S-file name from trace data file data                    
c                                                                               
c      J. Havskov, December 1988                                                
c                                                                               
c  last update:                                                                 
c  jan 16, 89 by j.h. : change comment line from type 3 to 7                    
c  sep 15  89    j.h. : new directory structure adaption                        
c  mar 22  89         : remove [wave] from file name output                     
c  aug 14  90         : pos+17 changed to pos+18 in blank string                
c  oct 01  91    j.h. : some unix clean up
c  nov 26  91         : new nordic format
c  jan 31  92    c.l. : Always write type on first header line
c  mar 18  97    bjb  : subclass information and number of headers
c                       and records are passed to subroutine
c                       a type 3 line is created if volcanic
c                       subclass info is desired.
c                       Phase readings are saved in the array DATA
c                       so these can be written out when event is 
c                       registered
c                                                                               
c     Input: Year,month,day,hr,min,sec: time of event                           
c            type: event type:L,R or D                                          
c	     sub_class: for local volcanic events only. See 
C 			VOLCANO.DEF in DAT dir                                        
c            sdir: dirctory for S-files, deafault (blank) is agency:...            
c            trace_file: trace file name                                        
c     Output:event_name: S - file name                                         
c            data: standard data readings array with one help line              
c                                                                               
c                                    
      implicit none
      integer year,month,day,hr,min                               
c--input-output                                
      character*80      event_name	
c--------------                                
      character*80      trace_file	
c--------------                                     
      character*40      sdir		
c--------------                                           
      character*2	type		
c--------------                                           
      character*6	sub_class_flag
c--------------                                     
      character*80  	data(*)		
c-- seconds                                                      
      real		sec		
c-- seconds                                        
      integer		isec            
c-- disk and directory name lengths                       
      integer		l1	
c-- number of header lines in temp. s-file
      integer nhead
c-- number of additional header lines to be added
      integer nh
c-- number of record lines in temp. s-file including headers
      integer nrecord
c-- system time
      character*12 p_time
      character*14 proc_time
c-- id line
      character*80 idline
c-- operator
      character*4 operator
      character*5 agency
      integer 		i	
c-- volcano line
      character*80 volc_line
c-- counter
      integer x


      call get_def_base(agency)

c
c   check on default data base
c
      if(sdir(1:5).eq.'     ') sdir(1:5)=agency

      do x=2,5
        if (sdir(x:x).eq.' ') sdir(x:x)='_'  
      enddO
c                                                                               
c   make output file name                                                       
c                                                                               
      isec=sec
      call sfilname
     *(year,month,day,hr,min,isec,sdir(1:5),type(1:1),event_name,l1)
c
c  make sure nhead and nrecord has reasonable values
c
      if(nrecord.lt.2) then
         nrecord=3
         nhead=2
      endif
c
c  shift possible readings
c
c     nh=2   ! changed lo
      nh=1
      if(type(2:2).eq.'V') nh=nh+1
      do i=nrecord,nhead+1,-1
        data(i+nh)=data(i)
      enddo
      nhead=nhead+nh
      nrecord=nrecord+nh
c                                                                               
c   write header line in file always with type '1' at the end        
c                                                                               
      write(data(1),'(1x,i4,1x,2i2,1x,2i2,1x,f4.1,1x,a2)')                      
     *year,month,day,hr,min,sec,type                                            
      write(data(1)(80:80),'(a1)')'1'
c
c   next line is id line
c
      idline(1:40)= ' ACTION:                   OP:     STATU'
      idline(41:80)='S:               ID:                   I'
      WRITE(IDLINE(61:75),'(i4,5I2)')
     *YEAR,MONTH,DAY,HR,MIN,ISEC
      DO I=61,74
         IF(IDLINE(I:I).EQ.' ') IDLINE(I:I)='0'
      ENDDO
      call systime(p_time,proc_time)
      WRITE(IDLINE(31:34),'(A)')OPERATOR
      WRITE(IDLINE(13:26),'(A)')PROC_TIME
      WRITE(IDLINE(9:11),'(A)')'REG'
      data(2)=idline

c
c-- next line is trace data file name                   
c                                                                               
c  trace file name                                                 
c                                                                               
c-- blank whole string                        
      do i=1,80
        data(3)(i:i)=' '
      enddo
      i=index(trace_file,' ')-1
      data(3)(2:i+1)=trace_file(1:i)                                            
      data(3)(80:80)='6'

c
c construct the volcano line if required
c
      if(type(2:2).eq.'V') then 
        do i=1,80
          volc_line(i:i)=' '
        enddo
        volc_line(2:10)='VOLC MAIN'
        volc_line(12:17)=sub_class_flag
        volc_line(80:80)='3'
        data(4)=volc_line

        data(5)(1:57)=
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO '               
c        data(5)(58:80)='SNR AR TRES W  DIS CAZ7'
        data(5)(58:80)='AIN AR TRES W  DIS CAZ7'

      else

        data(4)(1:57)=
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO '               
c        data(4)(58:80)='SNR AR TRES W  DIS CAZ7'
        data(4)(58:80)='AIN AR TRES W  DIS CAZ7'

      endif


c-- blank last line                                    
      do i=1,80                                                                 
         data(nrecord)(i:i)=' '		
      enddo                                                                     
      return                                                                    
      end                  
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c                                                     
        subroutine make_res_file(nrecord,data,nsynt)
c
c   update array data so residuals have been added to the travel times
c   and put at end of array as synthetics for residual plotting
c
        implicit none
        include 'seidim.inc'
        include 'libsei.inc'             !  Library definitions & data defns.
        character*80 data(*), data_out(max_data)
        character*80 text
        integer nrecord
        integer hour,min
		integer unit           ! file unit
        logical exist          ! true if file exist
        integer code           ! code for open
        integer nsynt          ! number of calculated phases
        real sec
        real res               ! residual
        real time              ! time in seconds
        integer i,k
c
c   read results from print.out file
c
      call sei open( old$+ignore$,            ! Try to open & warn.
     &               ' ',                     ! No prompt.
     &               'print.out',             ! This file.
     &               unit,                    ! On unit.
     &               exist,                   ! File exists?.
     &               code )                   ! Condition.
c
c    File exists and is open!!..
c
c   find start of event
c
  10    continue
        read(unit,'(a)',end=50) text
        if(text(2:4).eq.'stn') goto 20
        goto 10
  20    continue
c
c   read results
c
        k=1
  30    continue
        read(unit,'(a)') text
        if(text(2:6).eq.'    ') goto 40   ! end of stations
        data_out(k)=' '
        data_out(k)(2:6)=text(2:6)
        data_out(k)(11:18)=text(34:41)    ! output phase
        read(text(42:50),'(2i2,f5.2)') hour,min,sec
        read(text(65:71),'(f7.2)') res
        time=hour*3600+min*60.0+sec-res
        if(time.ge.0.0) then
           hour= time/3600
           min=(time-hour*3600)/60
           sec=time-hour*3600-min*60
           write(data_out(k)(19:28),'(2i2,1x,f5.2)') hour,min,sec
        else
           write(data_out(k)(19:28),'(2i2,1x,f5.1)') hour,min,time
        endif
        data_out(k)(10:10)='y'      ! indicate calculated time
        k=k+1
        goto 30
c
c   finish station list
c
  40    continue
c
c   put back in data array, first clear other synthetic readings
c
          do i=1,nsynt
             data(max_data-i+1)=' '
          enddo
c
          nsynt=k-1
          do i=1,nsynt
             data(max_data-i+1)=data_out(i)
          enddo
            if((nrecord+nsynt).ge.max_data) then
              call clear_to_alpha
              write(6,*)
     *      ' Too many real and synthetic phases'
              stop
            endif
c
c   no data
c
 50      continue
c
c   close print.out file
c
         call sei close( close$, unit, code ) ! Close (default stop on error).
         return
         end                 
c
                                                                                              
cc      subroutine auto_tr(data,nhead,nfile,filename)
ccc moved to LIB
ccc
ccc   routine to get trace file names for nordic file
ccc
ccc   input:
ccc   data: nordic S-file
ccc   nhead: number of headers in file
ccc   output:
ccc   nfile: number of waveform files
ccc   filename: waveform files
ccc
cc      implicit none
cc      character*80 data(*)
cc      character*80 filename(*)
cc      integer nhead,nfile
c
c-- help variables
c
cc      integer i
cc      nfile=0
c
cc      do i=2,nhead
cc         if(data(i)(80:80).eq.'6') then
cc            nfile=nfile+1
cc            filename(nfile)(1:78)=data(i)(2:79)
cc            filename(nfile)(79:80)=' '
cc          endif
cc      enddo
ccc
cc      return
cc      end


c----------------------------------------------------------------------------   
      subroutine cbase_select(cbase,cbase_def,n_cbase_in,n_cbase_out)         
c                                                                               
c                                                                               
c     Routine toselect continuous databases.
c                                                                               
c     Input:   cbase                : list of continuous databases              
c              cbase_def            : index list of default databases (SEISAN.DEF)
c              n_cbase_in           : number of databases in
c                                                                               
c     Output   n_cbase_out          : number of databases in
c
      implicit none
      include 'mulplt.inc'
c
c------------------------------------------------------
      include 'libsei.inc'              ! Library definitions & data defns.
      external   sei integer            ! Extract integer from string.
      integer    sei integer            ! & function.
c---------------- end of sei lib changes --------------
c-- number of file names in file                  
      integer n_cbase_in
c-- number of files selected
      integer n_cbase_out
      character*(*) cbase(*)
      integer cbase_def(*)
c-- selected array                               
      integer on(80)
      integer order_out(1000)      ! order after sorting
      character*80 box_text(1000),box_text_local(80)
      character*120 title
c-- last character pushed in input_box
      character*1 last_char
      integer nfile_page           ! number of files, one page
      integer npage                ! number of pages
c-- Counters                                               
      integer i,k,ipage		

c
c   sort file names
c
      call  text_sort(cbase,box_text,order_out,
     *                n_cbase_in)        

c
c  put in text for boxes if no sorting, else done above
c
      if(.not.chan_sort) then
         do i=1,n_cbase_in
           box_text(i)=' '
           box_text(i)=cbase(i)
           on(i)=cbase_def(i)
         enddo
      endif
c
c   display boxes
c
      title=
     *'SELECT DATABASES, FILLED OUT BOXES INDICATE SELECTION'

c
c   loop to show many pages of file names
c
      npage=(n_cbase_in-1)/75+1           ! max 75 names per page
      k=1                                 ! counter for selected files

       
      do ipage=1,npage
c
c   check if last page
c
          if(ipage.eq.npage) then
              title(81:120)=' '
              nfile_page=n_cbase_in-(ipage-1)*75
          else
              title(81:120)=' More databases, push OK or F'
              nfile_page=75
          endif
c
c   transfer data to local array
c
          do i=1,nfile_page
             box_text_local(i)=box_text(i+(ipage-1)*75)
          enddo
c
c   display one page
c     
          call input_box(nfile_page,on,3,330.0,15.0,
     *                     box_text_local,35,
     *                     3.0,max_ypos+30.0,title,last_char,1,0)
c
c   Quit...
c
         if(last_char.eq.'Q'.or.last_char.eq.'q') then
            n_cbase_out=0
            return
         end if                           !
c
c   put selected files at top of list
c
         do i=1,nfile_page
            if(on(i).eq.1) then
               cbase(k)=box_text(i+(ipage-1)*75)
               k=k+1
               on(i)=0       ! clear for next page
            endif
         enddo
      enddo

      n_cbase_out=k-1
                                                            
      return                                                                    
      end                                                                       

c----------------------------------------------------------------------------   
      subroutine wav_select(n_wav_file,n_wav_out)                               
c                                                                               
c                                                                               
c     Routine to show wav file names and select files to plot.             
c                                                                               
c     written by  j. havskov                                     
c                                                                               
c     Input:   n_wav_file           : in input file                             
c              wav_filename         : all waveform file names       
c                                                                               
c     Output   n_wav_out            : number of wav files selected               
c              wav_filename         : selected files
c
      implicit none
      include 'mulplt.inc'
c
c------------------------------------------------------
      include 'libsei.inc'              ! Library definitions & data defns.
      external   sei integer            ! Extract integer from string.
      integer    sei integer            ! & function.
c---------------- end of sei lib changes --------------
c-- channels selected                             
c-- number of file names in file                  
      integer n_wav_file
c-- number of files selected
      integer n_wav_out
c-- selected array                               
      integer on(80)
      integer order_out(1000)      ! order after sorting
      character*80 box_text(1000),box_text_local(80)
      character*120 title
c-- last character pushed in input_box
      character*1 last_char
      integer nfile_page           ! number of files, one page
      integer npage                ! number of pages
c-- Counters                                               
      integer i,k,ipage		

c
c   sort file names
c

      call  text_sort(wav_filename,box_text,order_out,
     *                n_wav_file)        

  
c
c  put in text for boxes if no sorting, else done above
c
      if(.not.chan_sort) then
         do i=1,n_wav_file
           box_text(i)(1:35)=wav_filename(i)(1:35)
         enddo
      endif
c
c   display boxes
c
      title=
     *'SELECT FILENAMES, FILLED OUT BOXES INDICATE SELECTION'

c
c   loop to show many pages of file names
c
      npage=(n_wav_file-1)/75+1           ! max 75 names per page
      k=1                                 ! counter for selected files

       
      do ipage=1,npage
c
c   check if last page
c
          if(ipage.eq.npage) then
              title(81:120)=' '
              nfile_page=n_wav_file-(ipage-1)*75
          else
              title(81:120)=' More files, push OK or F'
              nfile_page=75
          endif
c
c   transfer data to local array
c
          do i=1,nfile_page
             box_text_local(i)=box_text(i+(ipage-1)*75)
          enddo
c
c   display one page
c     
          call input_box(nfile_page,on,3,330.0,15.0,
     *                     box_text_local,35,
     *                     3.0,max_ypos+30.0,title,last_char,1,0)
c
c   Quit...
c
         if(last_char.eq.'Q'.or.last_char.eq.'q') then
            n_wav_out=0
            return
         end if                           !
c
c   put selected files at top of list
c
         do i=1,nfile_page
            if(on(i).eq.1) then
               wav_filename(k)=box_text(i+(ipage-1)*75)
               k=k+1
               on(i)=0       ! clear for next page
            endif
         enddo
      enddo

      n_wav_out=k-1
c
c   mark in s-file if more than one
c
cfix  is this really needed, cannot see it, delete ???
c      k=2
c      if(n_wav_out.gt.1) then
c        do i=1,n_wav_file
c 200       continue
c           if(k.gt.nhead) then
c              write(6,*)' Something wrong in file selection'
c              stop
c           endif
c           if(data(k)(80:80).eq.'6') then
c              if(on(i).eq.1) data(k)(1:1)='*'
c              k=k+1
c           else
c              k=k+1
c              goto 200
c           endif
c        enddo
c      endif
                     
                                                            
      return                                                                    
      end                                                                       
c----------------------------------------------------------------------------   
      subroutine wav_select_del(n_wav_file,n_wav_out)                               
c                                                                               
c                                                                               
c     Routine to show wav file names and select files to delete.             
c                                                                               
c     written by  j. havskov                                     
c                                                                               
c     Input:   n_wav_file           : input file                             
c              wav_filename         : all waveform file names       
c
c     Output:  n_wav_out            : number of wav files selected     
c                                   : selected files
c
      implicit none
      include 'mulplt.inc'
c
c------------------------------------------------------
      include 'libsei.inc'              ! Library definitions & data defns.
      external   sei integer            ! Extract integer from string.
      integer    sei integer            ! & function.
c---------------- end of sei lib changes --------------
c-- channels selected                             
      integer n_wav_file
c-- number of files selected
      integer n_wav_out
c-- selected array                               
      integer on(100)
      character*80 box_text(100),title
c-- last character pushed in input_box
      character*1 last_char
c-- Counters                                               
      integer i,k,knew,l
      character*1 dchar
c
      call dir_char(dchar)
	  
c
c  put in text for boxes
c
      k=0
      do i=1,n_wav_file
        if(wav_filename(i)(1:1).ne.dchar) then
           k=k+1
           box_text(k)(1:35)=wav_filename(i)(1:35)
        endif
      enddo
      knew=k
c
c   display boxes
c
      title=
     *'SELECT FILES FOR DELETION'
cx      if(n_wav_file.gt.22) then
      if(knew.gt.22) then
cx         call input_box(n_wav_file,on,2,300.0,20.0,box_text,35,
         call input_box(knew,on,2,300.0,20.0,box_text,35,
     *                    400.0,max_ypos-50.0,title,last_char,0,0)
      else
         call input_box(knew,on,1,300.0,20.0,box_text,35,
cx         call input_box(n_wav_file,on,1,300.0,20.0,box_text,35,
     *                    700.0,max_ypos-50.0,title,last_char,0,0)
      endif
c
c   Quit...
c
      if(last_char.eq.'Q'.or.last_char.eq.'q') then
         n_wav_out=0
         return
      end if                           !
c
c   put  selected files at top of list
c
      k=1
cx      do i=1,n_wav_file
      do i=1,knew
         if(on(i).eq.1) then
cx            wav_filename(k)=wav_filename(i)
            wav_filename(k)=' '
            wav_filename(k)(1:35)=box_text(i)(1:35)
            k=k+1
         endif
      enddo
      n_wav_out=k-1
c
c   mark in s-file files to be deleted if one or more
c
      k=2
      if(n_wav_out.ge.1) then
cx        do i=1,n_wav_file
        do i=1,knew
 200       continue
           if(k.gt.nhead) then
              write(6,*)' Something wrong in file selection'
              stop
           endif
           if(data(k)(80:80).eq.'6') then
              do l=1,n_wav_out
                 if(wav_filename(l)(1:35).eq.data(k)(2:36)) 
     *           data(k)(1:1)='*'
              enddo
cx              if(on(i).eq.1) data(k)(1:1)='*'
              k=k+1
           else
              k=k+1
              goto 200
           endif
        enddo
      endif
                     
                                                            
      return                                                                    
      end                                                                       
c----------------------------------------------------------------------------   
      subroutine wav_select_mer(n_wav_file,n_wav_out)                               
c                                                                               
c                                                                               
c     Routine to show wav file names and select files to merge.             
c                                                                               
c     written by  j. havskov                                     
c                                                                               
c     Input:   n_wav_file           : input file                             
c              wav_filename         : all waveform file names       
c
c     Output:  n_wav_out            : number of wav files selected     
c
      implicit none
      include 'mulplt.inc'
c
c------------------------------------------------------
      include 'libsei.inc'              ! Library definitions & data defns.
      external   sei integer            ! Extract integer from string.
      integer    sei integer            ! & function.
c---------------- end of sei lib changes --------------
c-- number of file names in file                  
      integer n_wav_file
c-- number of files selected
      integer n_wav_out
c-- selected array                               
      integer on(100)
      character*80 box_text(100)
      character*120 title
c-- last character pushed in input_box
      character*1 last_char
c-- Counters                                               
      integer i,k,l,knew		
      character*1 dchar
     
      call dir_char(dchar)
      n_wav_out=0    ! initially nothing selected	  
c
c  put in text for boxes, only select files in working directory
c
      k=0
      do i=1,n_wav_file
        if(wav_filename(i)(1:1).ne.dchar) then
           k=k+1
           box_text(k)(1:35)=wav_filename(i)(1:35)
        endif
      enddo
      knew=k

c
c   display boxes
c
      title=
     *'Select files for merging in current directory'
      if(knew.gt.22) then
         call input_box(knew,on,2,300.0,20.0,box_text,35,
     *                    400.0,max_ypos-50.0,title,last_char,0,0)
      else
         call input_box(knew,on,1,300.0,20.0,box_text,35,
     *                    700.0,max_ypos-50.0,title,last_char,0,0)
      endif

c
c   Quit...
c
      if(last_char.eq.'Q'.or.last_char.eq.'q') then
         n_wav_out=0
         return
      end if                           !
c
c   put  selected files at top of list
c
      k=1
      do i=1,knew
         if(on(i).eq.1) then
            wav_filename(k)=' '
            wav_filename(k)(1:35)=box_text(i)(1:35)
            k=k+1
         endif
      enddo
c
      n_wav_out=k-1
c
c   mark in s-file if two or more
c
      k=2
      if(n_wav_out.ge.1) then
        do i=1,knew
 200       continue
           if(k.gt.nhead) then
              write(6,*)' Something wrong in file selection'
              stop
           endif
           if(data(k)(80:80).eq.'6') then
              do l=1,n_wav_out
                 if(wav_filename(l)(1:35).eq.data(k)(2:36))
     *           data(k)(1:1)='*'
              enddo
              k=k+1
           else
              k=k+1
              goto 200
           endif
        enddo
      endif


                                                            
      return                                                                    
      end                                                                       
******************************************************************              
      subroutine read_s_file

c
c   open and read s-file, close
c
c   see main program for variables
c
      implicit none
      include 'mulplt.inc'
      include 'libsei.inc'
      integer read_unit
      logical b_flag
      integer code,nstat,nphase,id
      character*1 exp,type
      
              call sei open( old$,                 ! Open old file.
     &                  ' ',                  ! No prompt.
     &                  sfile,                ! This file.
     &                  read_unit,            ! On this unit.
     &                  b_flag,               ! Existance?.
     &                  code )                ! Condition (n/a).
             call indata
     *       (read_unit,nstat,nphase,nhead,nrecord,type,exp,data,id)
             call sei close(close$,read_unit,code)    ! Close (stop on error).
       return
       end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine write_s_file

c
c   open and write s-file, close 
c   do not write synthetic phases
c
c   see main program for variables
c
      implicit none
      include 'mulplt.inc'
      include 'libsei.inc'
      integer write_unit
      logical b_flag
      integer code,i,nrecord_old
      
              call sei open( old$,            ! Open old file.
     &                  ' ',                  ! No prompt.
     &                  sfile,                ! This file.
     &                  write_unit,           ! On this unit.
     &                  b_flag,               ! Existance?.
     &                  code )                ! Condition (n/a).
              if( code .ne. e_ok$ ) then                     !
                 code = e_ok$                                ! Restore.
                 write(6,*)' Error opening S-file'
                 write(6,*)
     *           ' You might not be allowed to change data base'
c                write(6,*)' Return to continue'
                 call flush (6)
c                read(5,'(a)') i
                 goto 1                                        ! & skip out.
              endif

              do i=1,nrecord
                 if(.not.(data(i)(10:10).eq.'y'.and.i.gt.nhead))
     *           write(write_unit,'(a80)',err=10)data(i)
              enddo
              goto 1
 10           continue
c
c   only write message first time if no change
c
                 if(nrecord_old.ne.nrecord) then
                    write(6,*)' Error writing to S-file,',
     *              ' you might not be allowed to change data base'
c                   write(6,*)' Return to continue'
                    call flush (6)
c                   read(5,'(a)') i
                    nrecord_old=nrecord
                 endif
 1           continue
             call sei close(close$,write_unit,code)    ! Close (stop on error).
       return
       end

       subroutine get_synt(nsynt,synt_head)
c
c   put possibele syntethic readings into data array
c
c   variable names as defined in mulplt main
c
       implicit none
       include 'mulplt.inc'
       include 'libsei.inc'
       character*80 text
       integer read1,code,nsynt,k
       character*10 synt_head
       logical exist

      call sei open( old$+ignore$,            ! Try to open & warn.
     &               ' ',                     ! No prompt.
     &               'iasp.out',              ! This file.
     &               read1,                   ! On unit.
     &               exist,                   ! File exists?.
     &               code )                   ! Condition.
c
c    File exists and is open!!..
c
      if (exist) then                                                           
      code = e_ok$                            ! Re-set condition.
c
c  delete all from data and down
c
      do k=nrecord+1,max_data
         data(k)=' '
      enddo
c
c  read
c
          k=0
          read(read1,'(a)',end=99) text       ! header line
 1        continue
          read(read1,'(a)',end=99) data(max_data-k) ! read into end of array
          if(k.ge.max_data-300) then  ! leave room for at least 300 phase lines
              write(6,*)
     *      ' Too many synthetic phases, check iasp.out'
              nsynt=k
              return
          endif
          if(data(max_data-k).eq.' ') goto 99
          k=k+1
          goto 1
c
 99       continue
c
c  all data read
c
          nsynt=k
          synt_head=text(1:10)   ! save date of synthetic data
          call sei close( close$, read1, code ) ! Close (default stop on error).
      endif

      return
      end

      subroutine add_synt_readings(nsynt,synt_head)
c
c   add synthetic readings if any, however only if the data is from
c   the same day
c
c   for explanation of variables, see main program
c
      implicit none
      include 'mulplt.inc'
      integer nsynt,k
      character*10 synt_head  ! date of synthetic records
c
c if character 7 or 9 of data(1)=0, make blank   LO , apr 97
c
      if (data(1)(7:7).eq.'0') data(1)(7:7)=' '
      if (data(1)(9:9).eq.'0') data(1)(9:9)=' '
         if(nsynt.gt.0.and.synt_head(4:10).eq.data(1)(4:10)) then      
            if((nrecord+nsynt).ge.max_data) then
               write(6,*)
     *         ' Too many real and synthetic phases'
                write(6,*)' Return to continue'
                call flush (6)
                read(5,'(a)') k
                stop
             endif
          data(nrecord+nsynt)=data(nrecord)
          do k=1,nsynt
             data(nrecord-1+k)=data(max_data-k+1)
          enddo
          nrecord=nrecord+nsynt
       endif
       return
       end

c$debug
C                                                                               
C                       
C  Program to make output files with comapct information from a nordic file                                  
c  The program will also make a compact output file where the only change
c  to the header lines, is the magnitude order and selection
C                                                                               
C  J. Havskov  1998
c
c  updates
c  
c  ---------------------------------   version 7.0 ------------------------
c  nov 5 98 by jh : linux logic                                                                             
c  sep 19         : was done wrongly
c  sep 27         : error in clear fps
c  mar 15, 02  jh : add report.inp file
c  aug 29  03     : small spelling mistake
c
      implicit none
      include 'seidim.inc'        ! dimensions
      include 'libsei.inc'
      CHARACTER*80 DATA(max_data),text ! data arrays
      CHARACTER*1 TYPE,EXP                                                      
      integer nstat,nphase,nhead,nrecord
c--- fault plane solution
      character*8 mag_out(3) ! magnitude and agency
      real strike,dip,rake
      character*1 answer
      integer istrike,idip,irake
c---number of arguments
      integer nars
c---files as arguments
      character*80 file(5)
      character*80 choise_file      ! optional file with choises
c---unit for output
      character*80 r(100),tr(100)   ! text for input and output
      character*80 tdata(100)       ! the real data
      integer nr(100),ntr(100)      ! number of characters in above
      integer nrout(100)            ! number of item to print out
      integer nin,nout              ! number of fields in and out
      integer nspec,nevent,nerror,nmc,nml,nmb,nms,nmw,nfault! statistics
      integer n,id,i,l,k,code
c--compact or not
      logical compact
      logical sun,pc,linux   ! computer types


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      b_f_message$=.false.
c
      call computer_type(sun,pc,linux)
c
      nin=28
      nout=0
      nevent=0
      nspec=0
      nfault=0
      nerror=0
      nmc=0
      nml=0
      nmb=0
      nms=0
      nmw=0
c
c  define parameters to use, below is seen how selection string looks
c
c Date TimeE L E LatE LonE DepE F Aga Nsta Rms Gap McA MlA MbA MsA MwA Fp Spec
c 1    2   3 4 5 6  7 9  9 10 111213  14   15  16  1718192021222324252627 28                      

      r(1)(1:5)='Date '
      nr(1)=5

      tr(1)(1:9)='Year Date'
      ntr(1)=9
      r(2)(1:4)='Time'
      nr(2)=4
      tr(2)(1:9)='HRMM  Sec'
      ntr(2)=9
      r(3)(1:2)='E '
      nr(3)=2
      tr(3)(1:5)='Error'
      ntr(3)=5
      r(4)(1:2)='L '
      nr(4)=2
      tr(4)(1:1)='L'
      ntr(4)=1      
      r(5)(1:2)='E '
      nr(5)=2
      tr(5)(1:1)='E'
      ntr(5)=1
      r(6)(1:3)='Lat'
      nr(6)=3
      tr(6)(1:7)='Latitud'
      ntr(6)=7
      r(7)(1:2)='E '
      nr(7)=2
      tr(7)(1:5)='Error'
      ntr(7)=5
      r(8)(1:3)='Lon'
      nr(8)=3
      tr(8)(1:8)='Longitud'
      ntr(8)=8
      r(9)(1:2)='E '
      nr(9)=2
      tr(9)(1:5)='Error'
      ntr(9)=5
      r(10)(1:4)='Dep '
      nr(10)=4
      tr(10)(1:5)='Depth'
      ntr(10)=5
      r(11)(1:2)='E '
      nr(11)=2
      tr(11)(1:5)='Error'
      ntr(11)=5
      r(12)(1:2)='F '
      nr(12)=2
      tr(12)(1:2)='FF'
      ntr(12)=2
      r(13)(1:4)='Aga '
      nr(13)=4
      tr(13)(1:3)='AGA'
      ntr(13)=3
      r(14)(1:5)='Nsta '
      nr(14)=5
      tr(14)(1:3)='NST'
      ntr(14)=3
      r(15)(1:4)='Rms '
      nr(15)=4
      tr(15)=' RMS'
      ntr(15)=4
      r(16)(1:4)='Gap '
      nr(16)=4
      tr(16)(1:3)='GAP'
      ntr(16)=3
      r(17)(1:2)='Mc'
      nr(17)=2
      tr(17)(1:4)='  Mc'
      ntr(17)=4
      r(18)(1:2)='A '
      nr(18)=2
      tr(18)(1:3)='   '
      ntr(18)=3
      r(19)(1:2)='Ml'
      nr(19)=2
      tr(19)(1:4)='  Ml'
      ntr(19)=4
      r(20)(1:2)='A '
      nr(20)=2
      tr(20)(1:3)='   '
      ntr(20)=3
      r(21)(1:2)='Mb'
      nr(21)=2
      tr(21)(1:4)='  Mb'
      ntr(21)=4
      r(22)(1:2)='A '
      nr(22)=2
      tr(22)(1:3)='   '
      ntr(22)=3
      r(23)(1:2)='Ms'
      nr(23)=2
      tr(23)(1:4)='  Ms'
      ntr(23)=4
      r(24)(1:2)='A '
      nr(24)=2
      tr(24)(1:3)='   '
      ntr(24)=3
      r(25)(1:2)='Mw'
      nr(25)=2
      tr(25)(1:4)='  Mw'
      ntr(25)=4
      r(26)(1:2)='A '
      nr(26)=2
      tr(26)(1:3)='   '
      ntr(26)=3
      r(27)(1:3)='Fp '
      nr(27)=3
      tr(27)(1:15)='STRIK  DIP RAKE'
      ntr(27)=15
      r(28)(1:20)='Spec '
      nr(28)=5
      tr(28)(1:20)='  Mom Strs   f0    r'
      ntr(28)=20
c 
c   check if input from file given in argument
c
 1      continue
        call get_arguments(nars,file)
        if(nars.eq.0.or.nars.gt.3) then
           write(6,*)' You must give input file as an argument'
           stop
        endif
c
c   open input file name, is first argument
c
        open(1,file=file(1),status='old')
c
c   check that not already a compact file
c
        call nortype(1,compact)
        if(compact) then
           write(6,*)' Input file is compact, only some parameters',
     *               ' can be selected, continue(y/n)'
           read(5,'(a)') answer
           if(answer.eq.'y'.or.answer.eq.'Y') then
              continue
           else
              stop
           endif
        endif

c
c   check if prompt input with file name of input file with choises
c   2. argument
c
      choise_file=' '
      if(nars.eq.2) then
         choise_file=file(2)
         write(6,'(a,a)')' Choises from file: ',choise_file
         open(9,file=choise_file,status='old',err=3334)
         read(9,'(a)') text          ! read help line, not used
         read(9,'(a)') text          ! read choises
         goto 3335
 3334    continue
         write(6,'(a,a)')' File does not exist: ',choise_file
         stop
 3335    continue
         close(9)
      endif
c
c   find out if all choises from promt line and get them if true
c   if choise from input file, skip manual input

c
        if(choise_file.eq.' ') then
        write(6,*)
     *  ' Below is shown parameters which can be chosen for output.'
        write(6,*)
     *  ' A return will chose all, placing any character under a field'
        write(6,*)
     *  ' will chose that parameter in the output. Each field starts'
        write(6,*)
     *  ' with a capital letter and ends within the following blank.'
        write(6,*)
     *  ' The order of the output can be changed by placing a number'
        write(6,*)
     *  ' under the field and fields will be written out in the order'
        write(6,*)
     *  ' of the numbers. E after time, lat, lon and dep are errors,'
        write(6,*)
     *  ' L E is distance and event id s, F is both fix flags and A is'
        write(6,*)
     *  ' agency for magnitude.'
        write(6,*)
     *  ' The following example shows that Mc, Depth(Dep) and Time with'
        write(6,*)
     *  ' error are selected and written out in given order.' 
        if(pc)write(6,'(1x,28a)')(r(i)(1:nr(i)),i=1,nin)
        if(sun.or.linux)write(6,'(28a)')(r(i)(1:nr(i)),i=1,nin)
        write(6,'(1x,a)')
     *  '     30  45              20                       10'

        write(6,*)

c
c   get choises
c
        do i=1,100
          nrout(i)=0
        enddo
c
        if(pc)write(6,'(1x,28a)')(r(i)(1:nr(i)),i=1,nin)
        if(sun.or.linux)write(6,'(28a)')(r(i)(1:nr(i)),i=1,nin)
        read(5,'(a)') text
        endif

        l=1
c
        do i=1,nin
          k=l+nr(i)
           if(text(l:k-1).ne.' ') then
              call sei get values(1,text(l:k-1),code)
              if(code.ne.0) goto 222   ! this was not a number
              n=array$(1)
           else
              n=0          ! no choise for this field
           endif
          goto 223         
 222      continue         ! choise was not a number
          n=i              ! no choise of order
 223      continue
          if(n.ne.0) then
             nout=nout+1
             nrout(n)=i
          endif
          l=k
        enddo
c
c   if nothing is chosen, all is chosen
c
        if(nout.eq.0) then
           do i=1,nin
             nrout(i)=i
           enddo
           nout=nin
        endif
        write(6,*)' Number of output fields ',nout
c
c   put choises in correct order
c
          k=0
          do i=1,100
             if(nrout(i).ne.0) then
                k=k+1
                nrout(k)=nrout(i)
             endif
          enddo
c
c   open output files

        open(2,file='report.out',status='unknown')
        open(3,file='report_n.out',status='unknown')
c
c      write header line
c
        write(2,'(1x,28(a,1x))')(tr(nrout(i))(1:ntr(nrout(i))),i=1,nout)
c
c   read and write to end of file
c
      n=0
  10  continue
      if(compact) then
         read(1,'(a)',end=99) data(1)
         nrecord=1
         nhead=1
      else
         CALL INDATA(1,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      endif
      if(nrecord.eq.0) goto 99
c
c   take out data from header line
c
      do i=1,100
         tdata(i)=' '
      enddo
c
      tdata(1)(1:9)=data(1)(2:10)
      tdata(2)(1:9)=data(1)(12:20)
      tdata(4)(1:1)= data(1)(22:22)      
      tdata(5)(1:1)= data(1)(23:23)
      tdata(6)(1:7)= data(1)(24:30)
      tdata(8)(1:8)= data(1)(31:38)
      tdata(10)(1:5)= data(1)(39:43)
      tdata(12)(1:2)= data(1)(44:45)
      tdata(13)(1:3)= data(1)(46:48)      
      tdata(14)(1:3)= data(1)(49:51)  ! nst
      tdata(15)(1:4)= data(1)(52:55)  ! rms
      
c
c  get errors, only from first line encountered
c     
      if(.not.compact) then
      do i=2,nhead
        if(data(i)(80:80).eq.'E') then
           nerror=nerror+1
           tdata(16)(1:5)=data(i)(6:8)
           tdata(3)(1:5)=data(i)(16:20)
           tdata(7)(1:5)=data(i)(26:30)
           tdata(9)(1:5)=data(i)(34:38)
           tdata(11)(1:5)=data(i)(39:43)
           goto 2001
        endif
      enddo
 2001 continue
c
c   spectral parameters, first encounter used
c
cSPEC AVERAGE  MO 13.1 ST  3.1 OM  2.4 f0 4.54 R   .27 AL 2.20 WI 10.5 MW  2.7 3
c
      do i=2,nhead
        if(data(i)(2:13).eq.'SPEC AVERAGE') then
           nspec=nspec+1

           tdata(28)(1:20)=data(i)(18:22)//data(i)(26:30)//
     *                     data(i)(42:46)//data(i)(50:54)
                           
           goto 2002
        endif
      enddo
 2002 continue
c
c   fault plane solution, first encounter used
c
      do i=2,nhead
         if(data(i)(80:80).eq.'F') then
            nfault=nfault+1
            read(data(i),'(3f10.0)') strike,dip,rake
            istrike=strike+0.5
            idip=dip+0.5
            irake=rake+0.5
            write(tdata(27)(1:15),'(3i5)') istrike,idip,irake
            goto 2003
          endif
      enddo
 2003 continue
      endif
c
c   get magnitudes, use first occurence
c
      call get_mag_type('C',data,nhead,tdata(17)(1:5),tdata(18)(1:3))
      if(tdata(17)(1:4).ne.'    ') nmc=nmc+1
      call get_mag_type('L',data,nhead,tdata(19)(1:5),tdata(20)(1:3))
      if(tdata(19)(1:4).ne.'    ') nml=nml+1
      call get_mag_type('B',data,nhead,tdata(21)(1:5),tdata(22)(1:3))
      if(tdata(21)(1:4).ne.'    ') nmb=nmb+1
      call get_mag_type('S',data,nhead,tdata(23)(1:5),tdata(24)(1:3))
      if(tdata(23)(1:4).ne.'    ') nms=nms+1
      call get_mag_type('W',data,nhead,tdata(25)(1:5),tdata(26)(1:3))
      if(tdata(25)(1:4).ne.'    ') nmw=nmw+1
c
c   select for nordic output file
c
      do i=1,3
        mag_out(i)=' '
      enddo

      k=0   ! number of magnitudes out
      do i=1,nout
        if(nrout(i).eq.17.or.nrout(i).eq.19.or.nrout(i).eq.21.
     *   or.nrout(i).eq.23.or.nrout(i).eq.25) then
            k=k+1
            if(k.gt.3) goto 1234
            mag_out(k)=tdata(nrout(i))(1:5)//tdata(nrout(i)+1)(1:3)
        endif
      enddo
 1234 continue
c
      data(1)(56:63)=mag_out(1)
      data(1)(64:71)=mag_out(2)
      data(1)(72:79)=mag_out(3)
c
c   write selected data
c
      write(2,'(28(1x,a))') (tdata(nrout(i))(1:ntr(nrout(i))),i=1,nout)
      write(3,'(a)')(data(i),i=1,nrecord)
c
        nevent=nevent+1
c
c   next event
c
        goto 10
c
 99     continue
        write(6,*)
        write(6,*)' Number of events                           ',nevent
        write(6,*)' Number of events with spectra:             ',nspec
        write(6,*)' Number of events with fault plane solution:',nfault
        write(6,*)' Number of events with error estimates:     ',nerror
        write(6,*)' Number of events with mc             :     ',nmc
        write(6,*)' Number of events with ml             :     ',nml
        write(6,*)' Number of events with mb             :     ',nmb
        write(6,*)' Number of events with ms             :     ',nms
        write(6,*)' Number of events with mw             :     ',nmw
c
        write(6,*)
        write(6,*)' Output report file is report.out'
        write(6,*)' Output nordic file is report_n.out'
        write(6,*)' Output of choises used in report.inp'
        write(6,*)
c
c   write out choises
c
        open(1,file='report.inp',status='unknown')
        write(1,'(28a)')(r(i)(1:nr(i)),i=1,nin)
        write(1,'(a)') text
        close (1)        
        stop

        end
                       
        subroutine get_mag_type(mag_type,data,nhead,mag,mag_aga)
c
c   get first occurrece of a given magnutde with type C,L,B,S,W
c   return magnitude and agency in two text strings
c       
        character*80 data(*)
        character*1 mag_type
        character*5 mag
        character*3 mag_aga
        integer nhead        ! number of header lines
        integer i,k
c
        mag=' '
        mag_aga=' '
c
c   search header lines 
c
        k=0
        do i=1,nhead
           if(data(i)(80:80).eq.'1') then
              if(data(i)(60:60).eq.mag_type) then
                 mag=data(i)(56:60)
                 mag_aga=data(i)(61:63)
                 return
              endif
              if(data(i)(68:68).eq.mag_type) then
                 mag=data(i)(64:68)
                 mag_aga=data(i)(69:71)
                 return
              endif
              if(data(i)(76:76).eq.mag_type) then
                 mag=data(i)(72:76)
                 mag_aga=data(i)(77:79)
                 return
              endif
           endif
        enddo
        return
        end

c**********************************************************************
c This program generates a set of travel times using the one-dimensional
c velocity in the station0.hyp file 
c
c  Barry Lienert June 1998
c
c***********************************************************************
c ------------------- SEISAN 7.0 -------------------
c june 10, 99 lo: check for station file in DAT directory
c june 24     jh: cut out dx of argument list to dtdg
c sep  21  99 lo: improve output
c may 15 2000 jh: remove nn,parm from calls to dtdx...,add hypparm.inc.
c                 and change a bit to mak eit work, use real vs instead of
c                 vs/pos
c
      include 'hypparm.inc'
      character*80 infile,outfile  
      character*80 indat,testdat
      character*1 reff,ucase,prmd,prm2
      character*4 stat
      character*8 phsid
      real vpp(nlayer)
      logical exist
cx in comm block      parameter (nlayer=50)
cx    real v(nlayer),vs(nlayer),d(nlayer),test(200)
cx      real xh(3),x0(3),dx(3)
      character*60 top_directory
      character*1 dchar
      real rearth
      integer seiclen


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      pi=3.141593
      degtorad=pi/180.
      rearth=6371.                         

c
c get directory structure
c

      call topdir(top_directory)

      call dir_char(dchar)         ! dirctory delimiter character

      
      write(*,*)' Program to generate a travel time table in'
      write(*,*)' a named file using a STATION0.HYP format '
      write(*,*)' velocity model'
      write(*,*)
      write(*,'('' Input Filename ?(RET for STATION0.HYP)'')')
      read(*,'(a40)')infile
      if(infile.eq.'                                        ')then
       infile='STATION0.HYP'
      endif 

c
c
c
c  TO BE ADDED IS SEARCH IN DAT DIRECTORY
c
c
      inquire(file=infile, exist=exist)
      if (.not.exist) then

         infile = top_directory(1:seiclen(top_directory)) // dchar // 
     &         'DAT' // dchar //
     &         infile(1:seiclen(infile))

         inquire(file=infile, exist=exist)
         if (.not.exist) then
           write(*,*) 'station file does not exist !'
           stop
         endif
      endif
      open(9,file=infile)
      outfile = 'ttlayer.out'
c      outfile='test'
      open(10,file=outfile)
      iustat=9         
      open(14,file='out')
c    set test parameter defaults
        call settest(test)

c    read test parameter changes and station data
c    changed 4/94 to read character string and check for ")" so reset test(1) is OK
        stat='xxxx'
        j=-1
        
        do while (stat.ne. '    '.and.j.ne.0)
         read(iustat,'(a80)')testdat
         if(testdat(14:14).eq.')')then
          read(testdat,'(a4,t12,i2,t16,f9.4)')stat,j,testj
         elseif(testdat(13:13).eq.')')then
          read(testdat,'(a4,t12,i1,t15,f9.4)')stat,j,testj
         else
          read(testdat,'(a4)')stat
          j=-1
         endif
         if(j.gt.0)then
          test(j)=testj
c          if(iulst.gt.0)write(iulst,'(1x,''Reset test('',i2,'')='',
c     &    f10.4)')j,testj
         endif
        end do

      indat='XXXXXXXX'
      do while (indat(1:8).ne.'        ')
       read(9,'(a80)')indat
c       write(*,'(a80)')indat
      end do

c read the velocity model
        i=1
        iustat=9
        
c    reff is used to specify the moho layer for PN calculation
5       read(iustat,101,end=99)v(i),d(i),vs(i),reff
101     format(3f7.3,a1)
        if(ucase(reff).eq.'N')nmoho=i

c 4/94: added nconrad variable
        if(ucase(reff).eq.'B')nconrad=i
        
        if(v(i).eq.0.0)go to 6
        i=i+1
        go to 5

c    nl is the number of layers in the velocity model
6       nl=i-1

      
c    read in trial depth and vp/vs ratio
        read(iustat,'(3f5.0,f5.2)',end=99)ztr,xnear,xfar,pos

c    if vs(1)=0 then set vs(i)=v(i)/pos
        if(vs(1).eq.0.0)then
          do i=1,nl
            vs(i)=v(i)/pos
          end do
        endif

c  store thicknesses in parm
        do i=1,nl-1
          parm(nl+i)=d(i+1)-d(i)

c    change 10/93: add maximum elevation to upper layer thickness
c    if test(40)=0.0 Need this because dtdx2 origin is always at maxelv
c          if(i.eq.1.and.test(40).eq.0.0)then
c            parm(nl+i)=d(i+1)-d(i)
c          endif
        end do
        do i=1,nl
          parm(i)=v(i)
        end do
c       nn=2*nl-1

      minflag=int(test(63))      
        
c    xs(1), xs(2) are the station long. and lat.
      x0(1)=0.0
      x0(2)=0.0
      x0(3)=0.0
      
      prmd=' '                        
      prm2=' '

      write(*,'('' Maximum delta in km:'')')
      read(*,*)delta_max
      write(*,'('' Delta increment in km:'')')
      read(*,*)delta_dist 
      write(*,'('' Hypocentral depth in km:'')')
      read(*,*)depth 
      write(*,'('' Phase type (N, G, RET for minimum):'')')
      read(*,'(a1)')prmd
      iulst=10
      nd=100

      xh(2)=0.0
      xh(3)=depth

      dist=0.0
c
c write some info
c
      write(10,'(a)') 'TTLAYER OUTPUT FILE'
      write(10,'(a)') '----------------------------------------' //
     &    '----------------------------------------'
      write(10,'(a)') ' input '
      write(10,'(a,f6.1)') ' Maximum delta in km: ',delta_max
      write(10,'(a,f6.1)') ' Delta increment in km: ',delta_dist
      write(10,'(a,f6.1)') ' Hypocentral depth in km: ',depth
      write(10,'(a,a1)') ' Phase type: ',prmd
      write(10,'(a)') '----------------------------------------' //
     &    '----------------------------------------'
      write(10,'(a)') ' output (layer=layer model, grad=gradient model'
      write(10,'(a)') '    distance  tp (layer)   tp (grad)' //
     &      '  ts (layer)   ts (grad)'
      write(10,'(a)') '----------------------------------------' //
     &    '----------------------------------------'

      do while (dist.le.delta_max) 
       do i=1,nl
         parm(i)=v(i)
       end do
       xh(1)=dist/rearth
       call dtdx2(xh,x0,prmd,nmoho,nconrad,iulst,tmin,
     &  dx,delta,ann,iflag,phsid)
       if(iflag.eq.0)tmin=0.0
       tpp=tmin
       call dtdxg(xh,x0,prmd,nmoho,nconrad,iulst,ttg,
c     &  dx,delta,ann,iflag,phsid)
     &  delta,ann,iflag,phsid)
       do i=1,nl
cx        parm(i)=v(i)/pos
          parm(i)=vs(i)
          vpp(i)=v(i)
       end do
       call dtdx2(xh,x0,prmd,nmoho,nconrad,iulst,tmin,
     &  dx,delta,ann,iflag,phsid)
       if(iflag.eq.0)tmin=0.0
       
       do i=1,nl
         v(i)=vs(i)
       enddo
       call dtdxg(xh,x0,prmd,nmoho,nconrad,iulst,ttsg,
c     &  dx,delta,ann,iflag,phsid)
     &  delta,ann,iflag,phsid)
c       write(10,'(5f12.3,i3)')dist,tpp,ttg,tmin,ttsg,iflag
       write(10,'(5f12.3)')dist,tpp,ttg,tmin,ttsg
       dist=dist+delta_dist
       do i=1,nl
         v(i)=vpp(i)
       enddo
      end do
      
99    continue
      close(9)
      close(10)

      write(*,'(a)') ' Output file: ttlayer.out'
      end
      

C########################################################################### 
   
      SUBROUTINE INDATA
     *(FILE,NSTAT,NPHAS,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
C
C   ROUTINE READS ONE EVENT IN NORDIC FORMAT INTO TEXT
C   ARRAY DATA. FILE IS OPENED OUTSIDE ROUTINE  AND IT IS
C   ASSUMED THAT NEXT RECORD TO READ IS A HEADER.
C
c   FIRST VERSION FROM AROUND 1984
C
C
c   updates:
c   1990-01-30, R.N.ARVIDSSON TO FIT PC-DOS.
c   apr 4 91 by j.h. : GIVE OUT NUMBER OF PHASES AND STATIONS
C   NOV 23 91        : CHANGE TO NEW NORDIC FORMAT, SOME CLEAN UP
c   jan 16 92        : do not count phasses and stations weighted out
C   AUG 28 92        : MAKE SURE LAST LINE IS 80 CHARS BLANK
c   jul    93 by jh  : version 3.0
c   nov 12 93        : count number of stations taking into account that
c                      stations might not follow each other in file
C!JAB(BGS)Nov94      : install error handling.
c   feb 7     jh     : fix up blank line handling a bit, no message,
c                      check for ctl z in file on PC
c   dec 14, 95       : check for array dimension in data
c   dec 7   97 jh    : count phases and stations correctly in case of weight
c                      4 and 9
c   sep 98, jh       : ------ version 7.0 check: year 2000, 5 char station
c   october 29,99 jh : nhead not defined if only header lines and no blank 
c                      line at end
c
C   INPUT :   FILE: FILE NUMBER TO READ FROM
c             nrecord: if -1, always read to end of file
C
C   OUTPUT:   NSTAT:   NUMBER OF STATIONS
C             NPHAS:   NUMBER OF PHASES FOR EVENT
C             NHEAD:   NUMBER OF HEADER RECORDS
C             NRECORD: TOTAL NUMBER OF RECORDS FOR EVENT INCLUDING LAST
C                      BLANK, IF ZERO, END OF FILE IS HIT
C             TYPE:    EVENT TYPE (D,R OR L)
C             EXP:     E FOR EXPLOSION
C             DATA:    EVENT RECORDS
C             ID:      RECORD NUMBER FOR ID LINE, 0: NO ID LINE
C
C    NOTE*** nphas and nstat are not counted for weighted out phases
c
      IMPLICIT NONE
      include 'seidim.inc'
C---TYPE OF LINE
      CHARACTER*1 LINE_TYPE  
C---SEE ABOVE  
      CHARACTER*1 TYPE,EXP
C---STATION CODES 
      CHARACTER*5 OLDSTA,NEWSTA
C---DATA AND A BLANK LINE 
      CHARACTER*80 DATA(*),BLANK
C---LOGICAL FILE NUMBER FOR READ 
      INTEGER FILE
C---SEE ABOVE  
      INTEGER NPHAS,NRECORD,NHEAD,NSTAT,ID
c-- endof line read or not
      logical end_of_file,test
C---HELP VARIABLE
      INTEGER IERR,i       
C
C    Seisan library inserts and routines...
C    ======================================
C
       include  'libsei.inc'               ! Library definitions & data defns.
       external  sei code                  ! Error encoder.
       integer   code                      ! local condition
       logical   b_eof                     ! Flag end of file.
C
C    ============= end of list ==========
C
c
c   check if read should be done to end of file, this is
c   an option used if it is known that only one event is available
c   and can be used to avoid problems if an extra blank line is present
c
      end_of_file=.false.
      if(nrecord.eq.-1) end_of_file=.true.
c
      do i=1,80
        blank(i:i)=' '
      enddo
c
      NRECORD=1
      IERR=0
      ID=0
      NSTAT=0
      nphas=0
      OLDSTA='****'
C
C   READ FIRST HEADER, ALSO BACK HERE IF FIRST LINE IS BLANK
C
 150  CONTINUE
      READ(FILE,'(A80)',iostat=code) DATA(1)
      call sei code( fort$,                      ! Stop on error.
     &               code,                       ! Condition.
     &               file,                       ! File with condition.
     &               b_eof )                     ! Flag end of file.
      if( b_eof ) goto 9999                      ! Return to caller.
C
      do i=1,80
        if(ichar(data(1)(i:i)).eq.26) goto 150  ! skip ctl z
      enddo
      IF(DATA(1).EQ.BLANK) THEN
         WRITE(6,*)'**********  BLANK HEADER LINE ***************'
         IERR=1
         GO TO 150
      ENDIF
      READ(DATA(1),'(21X,2A1,56X,A1)') TYPE,EXP,LINE_TYPE
      IF(IERR.EQ.1) THEN
C
C     WRITE DATE ETC BEFORE BLANK HEADER LINE
C
         WRITE(6,'(A80)') DATA(1)
         IERR=0
      ENDIF
C
C   LOOP FOR READING HEADERS
C
 1    CONTINUE
         NRECORD=NRECORD+1 
         if(nrecord.gt.max_data) then
            write(6,*) ' Data dimension max_data exeded, is now ',
     *      max_data
            write(6,*) ' Can be changed in seidim.inc'
            stop
         endif
 111     continue                                   ! from just below
         READ(FILE,'(A80)',IOSTAT=CODE) DATA(NRECORD)
         call sei code( fort$,                      ! Stop on error.
     &                  code,                       ! Condition.
     &                  file,                       ! File with condition.
     &                  b_eof )                     ! End of file?.
         if( b_eof ) then
             nhead=nrecord                          ! will add blank line
             goto 3                         
         endif
C
         do i=1,80
           if(ichar(data(nrecord)(i:i)).eq.26) goto 111  ! skip ctl z
         enddo
         READ(DATA(NRECORD),'(79X,A1)') LINE_TYPE   
C
C   CHECK FOR ID LINE
C
         IF(DATA(NRECORD)(80:80).EQ.'I') ID=NRECORD
C
C   CHECK IF MORE HEADERS
C
         IF(LINE_TYPE.NE.' '.AND.LINE_TYPE.NE.'4') THEN
            GO TO 1
         ENDIF
         NHEAD=NRECORD-1
C
C   READ PHASE RECORDS UNTIL BLANK LINE OR END OF FILE
c   always to eof if flag set, used with single events to trap
c   blank lines
C
 2    CONTINUE
      IF(DATA(NRECORD)(1:40).EQ.BLANK(1:40)) then 
         if(end_of_file) then
c
c   check if last line, then ok
c
            READ(FILE,'(A80)',IOSTAT=CODE) DATA(NRECORD)
            call sei code( fort$,                   ! Stop on error.
     &                     code,                    ! Condition.
     &                     file,                    ! File with condition.
     &                     b_eof )                  ! End of file?.
            if( b_eof ) goto 3                      ! & skip
C
c            write(6,*) ' Blank line in file, check !!'
c            goto 10
             goto 3
         else
            goto 3
         endif
      endif
 10   continue
c
c   if phase is weighted out, phase and station is not counted
c
      if(data(nrecord)(15:15).ne.'4'.and.data(nrecord)(15:15).ne.'9') 
     *then  
C
C   COUNT AZIMUTH AS A PHASE
C
         if(data(nrecord)(47:51).ne.'     ') nphas=nphas+1  
C
C  COUNT PHASES
C
         if(data(nrecord)(11:13).ne.'   ') nphas=nphas+1    
c
c   count stations, check all previous stations
c
         newsta=data(nrecord)(2:6)
         test=.false.
         do i=nhead+1,nrecord-1
           if(newsta.eq.data(i)(2:6).
     *     and.data(i)(15:15).ne.'4'.and.data(i)(15:15).ne.'9') 
     *     test=.true.
         enddo
         if(.not.test) nstat=nstat+1
      endif
c
c   position at next record
c
      nrecord=nrecord+1 
         if(nrecord.gt.max_data) then
            write(6,*) ' Data dimension max_data exeded, is now ',
     *      max_data
            write(6,*) ' Can be changed in seidim.inc'
            stop
         endif

 777  continue                                ! from just below
      READ(FILE,'(A80)',IOSTAT=CODE) DATA(NRECORD)
      call sei code( fort$,                   ! Stop on error.
     &               code,                    ! Condition.
     &               file,                    ! File with condition.
     &               b_eof )                  ! End of file?.
      if( b_eof ) then                        ! & skip.
         goto 3                                  ! 
      else                                    ! Otherwise.
         if(ichar(data(nrecord)(1:1)).eq.26) goto 777  ! skip ctl z
         GO TO 2                              ! Next to check.
      end if                                  !
C
C   END OF DATA FOR ONE EVENT
C
 3    CONTINUE
C
C   MAKE SURE LAST RECORD REALLY IS BLANK, COULD BE  ANYTHING IF
C   LAST LINE IF FILE WAS NOT 80 CHARS OR NOT BLANK
C
      DATA(NRECORD)=BLANK
      RETURN
C
C   END OF FILE
C
9999  NRECORD=0
      RETURN
      END

c                                                                               
C                       
C  Program to identify seismic swarms
c
c  Input to the program is a CAT file with many events and some manually
c  entrred parameters. Output is identified swarms. The output file swarm.out
c  contains all swarms organized as 'events'. In the header line is given
c  center for area identified and the 'magnutde' is the number of events in
c  area divided by 10. The rest of line is info from first event in swarm.                                   
c
c  Principle of selection:
c
c  Area is divided into a lat-lon grid. Around each gridpoint, there is a 
c  cell with radius small_r. The program first checks how many events there 
c  are in each cell for the whole catalog. It then checks each cell which
c  has more than the minimum number of events to constitute a swarm, if 
c  enough events are within the required time window. For each time window 
c  with enough events, a swarm is dclared so a swarm lasting e.g. twice the 
c  time window will be declared as two swarms.
c  An additional condition is that the number of event is larger than
c  the normalized background activity. The normalized activity is calculated
c  as the activity in the large cell normalized for area to the small cell,
c  and normalized in time to the window for the swarm
C                                                                               
C  J. Havskov  Feb 2000
c
c  updates
c
      implicit none
      include 'seidim.inc'        ! dimensions
      character*80 data(max_data)                                              
      integer nq                  ! max number of events
      integer ng                  ! max number of gridpoints in each direction
      parameter (nq=50000)
      parameter (ng=200)
      character*1 type,exp                                                      
      character*80 text           ! general text
      integer nstat,nphase,nhead,nrecord
      integer n,id,i,k,l,ii
      character*80 infile     ! input file name
      logical compact !compact or not
      character*80 header(nq)
      real lat(nq),lon(nq),sec(nq) ! hypocenter parameters
      integer year(nq),month(nq),day(nq),hour(nq),min(nq) ! hypocenter pars.
      real small_r,large_r    ! radius for count and radius for background
      integer nswarm                   ! number of swarms
      character*80 out_file            ! output file name of individual swarm
      character*80 parm                ! parameters in text string
      real minlat,maxlat,minlon,maxlon ! area to search
      real dellat,dellon               ! step in latitude and longitude
      integer nlat,nlon                ! number of gridpoints in lat and lon
      real grid_point(2,ng,ng)         ! grid points of lat and lon
      integer n_grid_small(ng,ng)      ! number of events in small cells
      integer n_grid_large(ng,ng)      ! --------------------large ---- 
      integer n_grid(1000,ng,ng)       ! event #'s of events in small cells
      real delta                       ! distance, km
      real ratio                       ! area ratio between large and small cell
      double precision t(nq)           ! absolute time of event
      double precision t1,t2,tw        ! time of events and time window
      double precision total_time      ! total time of catalog in secs
      real total_days                  ! ------------------------ days
      integer n1,n2,nw                 ! index of events and # ev. in time win.
      integer min_nw                   ! minimum number of events in swarm
      real background                  ! normalized background activity


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   initialize
c
        nswarm=0
c   
        write(6,*) ' Input file name '
        read(5,'(a)') infile
c
c   open input file 
c
        open(1,file=infile,status='old')
        write(6,*) ' Latitude range and grid size (deg)'
        read(5,*) minlat,maxlat,dellat 
        write(6,*)' Longitude range and grids size (deg)'
        read(5,*) minlon,maxlon,dellon
        write(6,*)
     *  ' Radius of cell and radius of background cell (deg)'
        read(5,*)small_r,large_r
        write(6,*)' Time window in days'
        read(5,*) tw
        tw=tw*24*3600.0    ! convert to seconds
        write(6,*)' Minimum number of events in window'
        read(5,*) min_nw
        write(6,*) 
     *  ' Minimum ratio of number of events to background activity'
        read(5,*) ratio
c
c   put all parameter on parm line
c
        parm=' '
        write(parm,'(1x,9f7.3,i4,f7.3)') 
     *  minlat,maxlat,dellat,minlon,maxlon,dellon,
     *  small_r,large_r,tw/(24*3600.0),min_nw,ratio
        parm(80:80)='3'
c
c   check if a compact file
c
        call nortype(1,compact)
        if(compact) then
           write(6,*)' Input file compact'
        endif
c
c   open output file
c
        open(2,file='swarm.out',status='unknown')
c
c   calculate grid points and initilize counters
c
        nlat=(maxlat-minlat)/dellat+1
        nlon=(maxlon-minlon)/dellon+1
        if(nlat.gt.ng) then
           write(6,*)' Too many latitude grid points, max is ',ng
           stop
        endif
        if(nlon.gt.ng) then
           write(6,*)' Too many longitude grid points, max is ',ng
           stop
        endif
        do i=1, nlat
           do k=1,nlon
              grid_point(1,i,k)=minlat+(i-1)*dellat
              grid_point(2,i,k)=minlon+(k-1)*dellon
              n_grid_small(i,k)=0
              n_grid_large(i,k)=0
           enddo
        enddo 
        write(6,*)' Number of grid points', nlat*nlon
c
c   read to end of file
c
        n=0
        write(6,*)
        write(6,*)' Reading events'
  10    continue
        if(compact) then
           read(1,'(a)',end=99) data(1)
        else
           call indata(1,nstat,nphase,nhead,nrecord,type,exp,data,id)
           if(nrecord.eq.0) goto 99
        endif
c
c   read parameters
c
        n=n+1
        read(data(1)(2:20),'(i4,1x,2i2,1x,2i2,1x,f5.1)') 
     *  year(n),month(n),day(n),hour(n),min(n),sec(n)
        read(data(1)(24:38),'(f7.3,f8.3)') lat(n),lon(n)
        header(n)=data(1)
c
c   calculate time since 1900
c
        call timsec(year(n),month(n),day(n),hour(n),min(n),sec(n),
     *              t(n))
        goto 10
c
 99     continue
        write(6,*)
        write(6,*)' The input file had ',n,' events'
        total_time=t(n)-t(1)
        total_days=total_time/(24*3600.0)
        write(6,*)' Total number of days in catalog', total_days
        write(6,*)
        write(6,*)' Count events in cells'
        write(6,*)
c
c   count number of events in large and small cells and index the events
c
        do l=1,n
        do i=1,nlat
            do k=1,nlon
               call dist_cl(grid_point(1,i,k),grid_point(2,i,k),
     *         lat(l),lon(l),delta)
               if(delta.le.small_r) then
                  n_grid_small(i,k)=n_grid_small(i,k)+1 
                  n_grid(n_grid_small(i,k),i,k)=l    ! store which event in grid
               endif
               if(delta.le.large_r)
     *         n_grid_large(i,k)=n_grid_large(i,k)+1 
            enddo
        enddo
        enddo
c

        write(6,*) ' Make time sequece'
c
c
c   find clusters in time
c
c
        do i=1,nlat
            do k=1,nlon
               if(n_grid_small(i,k).gt.min_nw) then
                  n1=1          ! first event in series
                  n2=2          ! second event
                  nw=1          ! number of events in window
 1000             continue                  
                  if(n2.gt.n_grid_small(i,k)) goto 2000 ! no more data this one
                  t1=t(n_grid(n1,i,k))  ! get times
                  t2=t(n_grid(n2,i,k))
                  if(t2-t1.le.tw) then
                     nw=nw+1            ! one more in window
                     n2=n2+1            ! move pointer to next event
                     goto 1000          ! test again
                  else                  ! next event was not in window
                     background=
     *               n_grid_large(i,k)*                     ! number in large
     *               ((small_r*small_r)/(large_r*large_r))* ! norm. area
     *               (tw/(total_days*24*3600.0))            ! norm time

                     if(nw.gt.min_nw.and.   ! enough to write out swarm
c
c   before declaring a swarm, also check if actvity is larger than 
c   background activity
c
     *                (nw.gt.(ratio*background)))
     *                then
                       nswarm=nswarm+1       ! count number of swarms
                       write(6,*)' Swarm number ',nswarm
                       write(6,*)grid_point(1,i,k),
     *                 grid_point(2,i,k),n_grid_small(i,k),nw         
c                      write(6,*) n_grid_large(i,k), 
c    *                 large_r,small_r,tw,total_days
                       text=header(n_grid(n1,i,k))
                       text(44:79)=' '
                       write(text(24:38),'(f7.3,f8.3)') 
     *                 grid_point(1,i,k),grid_point(2,i,k)
                       ii=nw
                       if(ii.gt.99) then    ! cannot write a number larger 99 
                         ii=99
                       endif
                       write(text(57:59),'(f3.1)') ii/10.0
                       text(60:64)='NSWM'
                       write(2,'(a)') text
                       if(nswarm.eq.1) write(2,'(a)') parm   ! parameters 
                       text=' '
                       text(20:37)='Number of events: '
                       write(text(39:42),'(i4)') nw
                       text(45:56)='Background: '
                       write(text(57:65),'(f9.5)') background
                       text(2:10)='Swarm No '
                       write(text(11:14),'(i4)') nswarm
                       text(80:80)='3'
                       write(2,'(a)') text
c
c   open individual swarm file, make sequential name
c
                       out_file(1:5)='swarm'
                       write(out_file(6:8),'(i3)') nswarm
                       out_file(9:12)='.out'
                       do ii=6,7
                         if(out_file(ii:ii).eq.' ') 
     *                   out_file(ii:ii)='_'
                       enddo
                       open(8,file=out_file,status='unknown')
                       do l=n1,n2-1         ! write all in swarm
                          write(2,'(a)') header(n_grid(l,i,k))
                          write(8,'(a)') header(n_grid(l,i,k))
                       enddo
                       close(8)
                       write(2,*) ' '
                       nw=1             ! reset
                       n1=n2            ! start a new series at end of old
                       n2=n2+1
                     else               ! no cluster
c                      n1=n2            ! start at end of current interval
c                      nw=1
                       n1=n1+1          ! move start one event ahead only
                       nw=nw-1          ! one less event in window
                       if(nw.lt.1) nw=1
c                      n2=n2+1 
                       if(n2.eq.n1) n2=n2+1
                     endif
                     goto 1000
                  endif
 2000             continue
               endif
            enddo
        enddo

        stop
        end



      subroutine dist_cl(alats,alongs,alatr,alongr,delta)
c
c   simplified version of azibazi in LIB
c
c
c   changes
c
c   sep 98 by jh ----------- version 7.0 check ------------------
c                no changes
c    
c   INPUT:  alats, alongs: latitude and longitude of the source
c           alatr, alongr: latitude and longitude of the receiver
c   OUTPUT: delta: the epicentral distance
c           azim : the azimuth at the source
c           bazim: the back-azimuth at the station
c   Note: all the elements are angles given in degrees. 
c         this subroutine does not account for the Earth's ellipticity
c
c   There is no garantee that the subroutine will work in absolutely all
c   cases, but it has been tested and should work across the line of change
c   of day for example.
c   December 1994. Valerie Maupin.
c
      degpi = 180./3.14159
c
      alon = alongr-alongs
      if (alon.lt.-180.) alon=alon+360.
      if (alon.gt.180.) alon=alon-360.
      if (alon.ge.0.)  then
        c = alon/degpi
        aa = (90. - alats)/degpi
        bb = (90. - alatr)/degpi
      else
        c = -alon/degpi
        aa = (90. - alatr)/degpi
        bb = (90. - alats)/degpi
      endif
      cc = cos(aa)*cos(bb) + sin(aa)*sin(bb)*cos(c)
      cc = acos(cc)
      a = (cos(aa) - cos(bb)*cos(cc))/(sin(bb)*sin(cc))
      a = acos(a)
      b = (cos(bb) - cos(aa)*cos(cc))/(sin(aa)*sin(cc))
      b = acos(b)
c
c ... calculate the epicentral distance 
c                 you must choose between degrees or kilometers 
c                 and comment out one of these two lines 
      delta = cc*degpi
c     delta = cc*6371. 
c
c ... calculate the azimut and backazimuth
c
c     if (alon.ge.0.)   then
c       azim = b*degpi
c       bazim = 360. - a*degpi
c     else
c       azim = 360. - a*degpi
c       bazim = b*degpi
c     endif
c
c.......calculate the coordinates of the mid-point
c                          (if this element is of interest to you,
c                          add (alat,along) in the argument list)
c
c     cc=cc/2.
c     dd = cos(aa)*cos(cc) + sin(aa)*sin(cc)*cos(b)
c     dd = acos(dd)
c     alat= 90. - dd*degpi
c     c3 = (sin(bb)*cos(cc)- sin(cc)*cos(bb)*cos(a))/sin(dd)
c     c3 = acos(c3)
c     if (alon.ge.0.)  along = alongr - c3*degpi
c     if (alon.lt.0.)  along = alongs - c3*degpi
c     if (along.lt.-180.) along=along+360.
c     if (along.gt.180.) along=along-360.
c
      return 
      end

c$debug
c
c    changes
c
c    jul 21 03 jh : diff to dif
c
c*************************************************************************
c this function is used to calculate derivatives, travel times, weights
c and the rms misfit for a set of phases, tp(i), i=1,nphase, and an event
c location, xh(i), i=1,3
c The derivatives are put in the COMMON array g(i,j)
c
c                   Version 4.0 6/98
c
c         Modified bisquare residual weighting section -
c         this was erroneously removing the average travel time
c         residual, preventing this type of weighting from working 
c         added distind to window and logic to force local or
c         IASP91 travel times/derivatives
c
c       inputs:  
c                hypocenter                xh  
c                average residual          dtav
c                number of phases          nphase
c                layered velocity  model   v,vs,nl,nmoho,nconrad
c                distance indicator        distind
c                arrival times/azimuths    tp  
c                station delays            dl
c                phase ID's                phase
c                station coordinates       x0, y0, iselv
c
c       outputs:
c                mean residual             dtav
c                centered residuals        dt
c                residual weights          dtw1
c                travel times              tpc1
c                matched phase ID's        trphs
c                angles of incidence       aninc
c                partial derivatives       g
c
c
c change 10/93: added minflag to window
c change 4/94: changed to include 'b' phases
c
c 4/94 changed so function now returns with centered residuals & origin time
c dtav no longer needed

c 10/94:  added iflagd to window
CJAB(BGS)Jan95 : Installed error handling to file I/O
c 1/95: added duplicate phase check
c 2/95: added fixor & ires to window
c jul 95 by jh: fix bug pointed out by barry: pz=sqrt(abs...
c jun 98 BRL: updates from my version added          
c 6/98 BRL: changed ielv to iselv
c sep 98 by jh : ------------ seisan version 6.0 check ------------------
c                added double precision az1 to travel time routine                
c sep 23 by bl : changed to rmd calculation to be consistent with 
c                seisan version 6.0
c oct  15   jh : 5 character station codes
c
c oct 28 1998 bmt : linux changed, save and *
c jl 13 99 jh     : weight 4 work again
c oct 19 99 jh    : change test(99) to test(94) for residual weight 
c                   reintroduction of weighted out phases
c nov 99   jh     : remove parm,v,vs,nl from window, in common block
c jan feb         : multi layer 
c jan 8, 2001, jh : fix problem of Pn for deep enevet when using IASP
c                   software
c aug 20 2002 jh+bl : fix problem of wrong location in sequence
c
c apr 8 2005  jh   : more problem with wrong origin time for events
c                    in sequence. event was not properly identified as
c                   distant if onlyu SS PP phases etc, not clear where
c                   problem we was, proably in calculation of ditance.
c                   problem solved by reintroducing force of using iasp91
c                  when event is distant.  look for variable iflagd
c may 2008 bl : fix problem of az weight were previously weighted to zero
c
c
      function rmsv(nphase,st,phase,tp,x0,y0,xh,ndata,nmoho,
     &nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc1,dl,
     &iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,trphs,dtav,
     &minflag,data,imatch,depthlim,iflagd,ires,fixor,scorr)

      save
      include 'hypparm.inc'
      include 'libsei.inc'                    ! Library definitons.

      external sei code                       ! Error encoder.
      integer  code,                          ! Condition.
     &         iulst                          ! Output diagnostics.
      logical  b_flag                         ! Flag it?.
c
      character*1 ucase,prm1,prm2,prmd
      character*8 phsid,prevphs
      character*5 prevstat
      
      integer ires
      real usrc(2)    ! added aug 2002 by jh, barry's suggestion
      rmsv=0.0        ! ----------------------------------------

      imflag=0
      pi=3.14159265
      degtorad=pi/180.
 
c 11/94 change from 6378.2 to mean radius
      rearth=6371.

c    set L velocity to test(51)

      vl=test(51)
      nn=2*nl-1

c----------------------------------------------------------
c change 10/93 BRL. iflagd now defined outside the next do loop 
c I now test all phases at this point to determine whether
c to use the IASP91 routines (iflagd=1)

C
      iflagd=0   !removed 6/98, BRL , put in again jh apr 2005

c      do i=1,nphase
c        call distaz(y0(i)/degtorad,x0(i)/degtorad,xh(2)/degtorad,
c     &  xh(1)/degtorad,dedeg,azz,azb)
c        delta=dedeg*degtorad*rearth
c        if(delta.gt.test(57).and.distind.ne.'L')then
c         iflagd=1
c         write(*,*)st(i),phase(i),delta
c        endif 
c      end do

c remove this comment to force IASP91 calculation for 'D' events
c below put in again apr 2005 by jh
      if(distind.eq.'D')iflagd=1
c      write(*,*)' iflagd ',iflagd

c remove this comment for 'R' events to be treated as local
c            if(distind.eq.'R')iflagd=0
c------------------------------------------------------------
c       adjust origin time to input dtav
c      tph=tph+dtav
c 1/95: added prevstat, prevphs & ipcount
      prevstat='    '
      prevphs='        '
 
      do ii=1,nphase
 
c 1/95: added section to get ipcount, the # of duplicate phases at the same stat
       if(st(ii).ne.prevstat)then
        ipcount=0
        prevphs=phase(ii)
       else   !changed 6/98, BRL
        if(phase(ii)(1:4).ne.'    '.and.phase(ii).eq.prevphs
     &   .and.dtwt(ii).gt.0.0)then
         dtwt(ii)=-1.0  !change 6/98 - weight duplicate phases to 0
         write(iulst,'(a5,1x,a8,'' - duplicate phase: weighted to -1''
     &    )')st(ii),phase(ii)
         ipcount=ipcount+1
        else
c 2/95: changed ipcount=1 to ipcount=0
         ipcount=0
        endif
       endif 
       prevstat=st(ii)
       prevphs=phase(ii)

c 11/22 changed to assign iflagd for each phase
c jh april 2005       iflagd=0

       call distaz(y0(ii)/degtorad,x0(ii)/degtorad,xh(2)/degtorad,
     &  xh(1)/degtorad,dedeg,azz,azb)
       delta=dedeg*degtorad*rearth    !added 6/98
       if(azb.lt.0.0)azb=azb+360.
c        azback(ii)=azb
       if(delta.gt.test(57).and.distind.ne.'L')then
        iflagd=1
       endif
c----------------------------------------------------------------
c change 10/93 BRL. Put contents of this loop in subroutine trtime
c         write(16,*)st(i),x0(i)/degtorad,y0(i)/degtorad,iselv(i),
c     &xh(1)/degtorad, xh(2)/degtorad,xh(3)

c trtime returns with dtw1 set to dtwt*distance weight,
c or to -1 for invalid phases 
c 1/95: added ipcount to window
         call trtime(ii,ipcount,st,phase,tp,x0,y0,xh,ndata,
     &   nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &   tpc1,dl,iselv,maxelv,ip,dt,xfar,xnear,tph,aninc,trphs,
     &   iflagd,minflag,data,distind,imatch,depthlim,scorr,ph,dx)
c----------------------------------------------------------------
c         write(iulst,*iostat=code)st(i),tpc1(i),dtw1(i)
         call sei code(fort$,code,iulst,b_flag) ! Process error.
      end do

c <<<<<<<<<<<<<<<<<<<<<<<<<<<  end phase loop  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c      call r4sort(nphase,azback,isortaz)  !added 6/98,BRL

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c
c                      RMS CALCULATION      
c
c change 10/93: changed this whole section (it's finally in one place!!)

c    S-P and S-L pairs  (P phase has a weight of 9)

      do i=1,nphase
        if(ip(i).eq.9)then
          prm1=ucase(phase(i)(1:1))
          if(prm1.eq.'P')then

c    Use time difference derivatives for  L and S phases at this station

            do j=1,nphase
              if(st(j).eq.st(i).and.i.ne.j)then
                prm2=ucase(phase(j)(1:1))
                if(prm2.eq.'L'.or.prm2.eq.'S')then

c   set the travel times and derivatives equal to their differences
c   ips(j)=1 in the S or L phase position signifies a P-S or P-L difference. 
c   The time difference is stored in the S-phase index position.

c  only set the raw data to the differences once
                  if(ips(j).eq.0)then
                   ips(j)=1
                   tp(j)=tp(j)-tp(i)
c                   write(iulst,*,iostat=code)tp(j)-tp(i)
                   call sei code(fort$,code,iulst,b_flag) ! Process error.
                  endif

c since the theoretical travel times and derivatives are
c recalculated each time, recalculate their differences
c every time
                  tpc1(j)=tpc1(j)-tpc1(i)
c                  write(iulst,*,iostat=code)st(j),phase(j),tpc1(j)
                  call sei code(fort$,code,iulst,b_flag) ! Process error.
                  g(j,1)=g(j,1)-g(i,1)
                  g(j,2)=g(j,2)-g(i,2)
                  g(j,3)=g(j,3)-g(i,3)

c #################  P-S RESIDUALS  #############################
                  dt(j)=tp(j)-tpc1(j)-dl(j)+dl(i)            
                  
c                  write(iulst,*,iostat=code)' dt1 ',
c     &               st(j),phase(j),dt(j)
                  call sei code(fort$,code,iulst,b_flag) ! Process error.
c---------------------------------------------------------------
c change 10/93 BRL. Put wt calculation inside this loop.
c Previously the last phase's wt was being used for all phases

c         distance weight factor, wt

                  call distaz(y0(j)/degtorad,x0(j)/degtorad,
     &            xh(2)/degtorad,xh(1)/degtorad,dedeg,azz0,azb)
                  delta=rearth*dedeg*degtorad
                  wt=1.0
                  if(xfar.ne.0.0)then
                    if(delta.gt.xfar)wt=0.0
                    if(delta.gt.xnear.and.delta.le.xfar)
     &              wt=(xfar-delta)/(xfar-xnear)
                  endif
c------------------------------------------------------------------

c        use S or L weight for time difference

c change 10/93: don't reset negative weights
c start with initial weights, dtwt
                  if(dtw1(j).gt.0.0)then
                    if(iflagd.eq.0)dtw1(j)=dtwt(j)*wt
                    if(iflagd.eq.1)dtw1(j)=dtwt(j)
                  endif

c                 write(iulst,*,iostat=code)dtw1(j),dtw1(i),i
                  call sei code(fort$,code,iulst,b_flag) ! Process error.

c     if other phase is invalid, difference is too

                  if(dtw1(i).lt.0.0)dtw1(j)=-1.0
c----------------------------------------------------------------
c change BRL 10/93: put this back in, but using trphs(j) instead
c of phase(j)

                 write(trphs(j),'(a2,''-P'')')phase(j)(1:2)
c---------------------------------------------------------------
                endif
              endif
            end do
          endif
        endif
      end do

c icount is a counter used to repeat the rms calculation after residual
c weighting is applied. This is necessary since the rms is needed first 
c to determine if residual weighting should be applied using test(36).
      icount=0    
c      dtav=0.0   !removed 6/98, BRL                                              

8700  icount=icount+1

c calculate dt(i) of non-zero weight absolute arrivals, 
c and their sum (used for dtav)

c changed to calculate weighted sum 4/94: also only calculate dtav 1st time thru
c      if(icount.eq.1)then
       sum=0.0
       ndata1=0       
       wsum=0.0                                 

c   calculate origin time using the weighted mean of all absolute
c   times (exclude azimuths & P-S diffs) minus their calculated values
       do i=1,nphase
        ww=0.0

        if(dtw1(i).gt.0.0)ww=dtw1(i)*dtw1(i)  !changed 6/98, BRL

c the dt(i) are calculated here using the input origin time
c 10/94: exclude difference phases and azimuths
        if(ips(i).ne.1.and.phase(i)(1:2).ne.'AZ')then
         dt(i)=tp(i)-tpc1(i)-dl(i)-tph
c 6/98, BRL: correct minute errors
         if(abs(dt(i)).gt.50..and.abs(dt(i)).lt.70..and.icflag.eq.1
     &    .and.dtw1(i).ge.0.0.and.test(97).gt.0.0)then
          write(iulst,*)st(i),phase(i),' minute corrected'
          if(dt(i).lt.0.0)then
           dt(i)=dt(i)+60.
           tp(i)=tp(i)+60.
          else
           dt(i)=dt(i)-60.
           tp(i)=tp(i)-60.
          endif              
          dtwt(i)=1.0
          dtw1(i)=1.0
          ww=1.0      
          imflag=1
         endif           
c 6/98 BRL: exclude PS phases   Before fix below, jul 99 (jh)
c        if(dtwt(i).eq.0.0.and.abs(dt(i)).le.5..and.icflag.eq.1
c    &    .and.ip(i).ne.9)then
c         write(iulst,*)st(i),phase(i),' added'
c         dtwt(i)=1.0
c         dtw1(i)=1.0
c        endif 
c  6/99  changed residual limit from 5 to test(99) so re-addition of zero
c  weight phases
c  can be disabled
c  19-10 99 changed test(99) to test(94) since already used
         if(dtwt(i).eq.0.0.and.abs(dt(i)).lt.test(94)
     &     .and.icflag.eq.1.and.ip(i).ne.9)then
          write(iulst,*)st(i),phase(i),' added'
          dtwt(i)=1.0
          dtw1(i)=1.0
         endif

        endif 
c 10/94: change ge.0 to gt.0 also moved below dt(i) calculation
        if(dtw1(i).gt.0.0.and.phase(i)(1:2).ne.'AZ'.and.
     &  ips(i).ne.1)then    !changed eq.0 to ne.1 6/98, BRL
          sum=sum+dt(i)*ww
          wsum=wsum+ww
          ndata1=ndata1+1
        endif
c        tph1=tph
c        if(ips(i).eq.1)tph1=0.0
c        write(iulst,*,iostat=code)st(i),phase(i),ips(i),tpc1(i),
c     &        tp(i)-tph1,dtw1(i)
        call sei code(fort$,code,iulst,b_flag)
       end do
c########################################################################
c      write(iulst,'(10f8.1)',iostat=code)(dt(i),i=1,nphase)
       call sei code(fort$,code,iulst,b_flag) ! Process error.
c      write(iulst,'(10f8.3)',iostat=code)(dtw1(i),i=1,nphase)
       call sei code(fort$,code,iulst,b_flag) ! Process error.
       rmsv=999.
       dtav=0.0
       if(wsum.gt.0.0)dtav=sum/wsum        
c      endif
       
c      write(iulst,*,iostat=code)' dtav',dtav
      call sei code(fort$,code,iulst,b_flag) ! Process error.

c  update average input residual
c       dtav=dtav+dtav1
 
c   update origin time using new (weighted) average residual
c      tph=tph+dtav1   
 
c      write(iulst,*,iostat=code)' dtav',dtav,icount
      call sei code(fort$,code,iulst,b_flag) ! Process error.

c-----------------------------------------------------------------------------
c        calculate rmsv
c
c****************************************************************
c 9/20/98: changed this calculation to make it consistent with the
c definition of weighted mean given in "The Statistical Analysis
c of Experimental Data", John Mandel, Dover Publications, NY, 1964
c p 132. 
c
c Mandel uses mean{t_i}=sum{w_i*t_i}/sum{w_i}
c and rms=sum{w_i*t_i^2}/sum{w_i}
c
c This is different for both the previous methods I used in v 3.2 
c and 4.0, athough the differences are small except when azimuth
c data is included
c******************************************************************

c ndata is the total number of valid data with dtw1(i)>0, wsum is
c the sum of their weights and sum is the sum of squared residuals
      ndata=0
      sum=0.0
      wsum=0.0                     
      wsum1=0.0

      do i=1,nphase
        dtav2=dtav  
        ww=0.0       !added 6/98, BRL
        
c  don't center PS, PL differences
        if(ips(i).eq.1.or.phase(i)(1:2).eq.'AZ')dtav2=0.0


c don't use negative weighted phases
        if(dtw1(i).gt.0.0.and.phase(i)(1:2).ne.'AZ'.and
     &   .ips(i).eq.0)then
          ww=dtw1(i)
          wsum=wsum+ww  !change 9/98, BRL
        endif
c
c added may 2008 bl - was previously weighing azimuths to zeroe in rms, added 
c next

        if(dtw1(i).gt.0.0. and. phase (i)(1:2).eq.'AZ') then
           ww=dtw1(i)
        endif

c include everything (including azimuths) in weighted rms 
        if(dtw1(i).gt.0.0)then
          sum=sum+ww*(dt(i)-dtav2)**2 
          wsum1=wsum1+ww  !change 9/98, BRL
          ndata=ndata+1
        endif
c         write(iulst,'(2a4,2f8.2)',iostat=code)st(i),
c     &           phase(i),dtw1(i),dt(i)-dtav2
        call sei code(fort$,code,iulst,b_flag) ! Process error.
      end do
c      write(iulst,*,iostat=code)' ndata,dtav,tph ',
c     &          ndata,ndata1,dtav,tph
      call sei code(fort$,code,iulst,b_flag) ! Process error.

      if(wsum.ne.0.0)then
       rmsv=sqrt(sum/wsum1)
      else
       rmsv=9999.
      endif  
c      write(iulst,*,iostat=code)' rms, tph ',rmsv,tph
      call sei code(fort$,code,iulst,b_flag) ! Process error.
c      write(iulst,*)icount,dtav,iflagd,tph,rmsv,test(88)

      if(icount.eq.1)then
       iweightflag=0
       if((rmsv.le.test(36).and.iflagd.eq.0).or.(rmsv.le.
     &  test(88).and.iflagd.eq.1))iweightflag=1
      endif






     
c 10/94: changed condition to both distant and local
c      if(icount.eq.2.or.iweightflag.eq.0)then
       do i=1,nphase
        dtav2=dtav
        
c  don't center PS, PL differences
        if(ips(i).eq.1.or.phase(i)(1:2).eq.'AZ')dtav2=0.0

c 2/95: don't center if origin time fixed. ires.eq.9 removed 6/98, BRL
        if(ires.eq.2.or.ucase(fixor).eq.'F'.or.test(31).eq.0.0)dtav2=0.0 

c #################### CENTER THE RESIDUALS  #######################
        dt(i)=dt(i)-dtav2    
       end do 

c 6/98, BRL: update the origin time
       if(ires.ne.2.and.ucase(fixor).ne.'F'
     & .and.test(31).gt.0.0)then
        tph=tph+dtav   
       endif  

       if(iweightflag.eq.0.or.icount.eq.3)return         ! PAU !!

c 10/93: inserted bisquare weighting section - formerly in hyploc

c ++++++++++++++++ bisquare weighting section +++++++++++++++++++++++++++++++
c    bisquare residual weighting... see Anderson, Phys. Earth 
c    Planet. Int. 30 (1982)

c change 10/94: use test(36) for local, test(88) for distant
c calculate the number of non-zero weight absolute arrivals, ndata,
c and their sum (used for dtav)

c change 4/94: repeat this k loop twice to redetermine weights using weighted dtav
         c=test(35)

c find the absolute values of the residuals
         do i=1,nphase
c          write(iulst,*,iostat=code)st(i),phase(i),dt(i),dtav2
          call sei code(fort$,code,iulst,b_flag) ! Process error.
          dt2(i)=abs(dt(i))                 
         end do

c get their median, sm - this is less affected by outliers than the mean
         call median(dt2,dtw1,phase,nphase,sm,ips)                      
         
c set sm to test(34) if sm<test(34)        
         if(sm.lt.test(34))sm=test(34)

c         write(iulst,*,iostat=code)c,sm
         call sei code(fort$,code,iulst,b_flag) ! Process error.

c now calculate the residual weights
         sum=0.0
         wsum=0.0  
         ndata=0 !added 6/98, BRL
         
         do i=1,nphase
          if(dtw1(i).gt.0.0.and.phase(i)(1:2).ne.'AZ')then
             dt2(i)=dt2(i)*0.6745/abs(sm)
c changed 6/98, BRL  <<<<<<<<<<<<<<<<<<<<<<<<<<          
            if(abs(dt2(i)).le.c)then
             ndata=ndata+1
             dtw1(i)=1.-(dt2(i)/c)**2    !*dtw1(i)
            else
             dtw1(i)=0. 
            endif 
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c 4/94: set residual weights < 0.01 to zero
C            if(dtw1(i).lt.0.01)dtw1(i)=0.0 
c            if(k.eq.2)write(iulst,'(2a4,2f12.2)',
c     &                   iostat=code)st(i),phase(i),dtw1(i)
            call sei code(fort$,code,iulst,b_flag) ! Process error.
c          removed 6/98, BRL
c          if(dtw1(i).gt.0.0.and.phase(i)(1:2).ne.'AZ'.and.
c     &    ips(i).eq.0)then
c            sum=sum+dt(i)*dtw1(i)
c            wsum=wsum+dtw1(i)
          endif  
c         dtav=0.0                  !removed 6/98
        end do

        if (ndata.eq.0)return   !moved outside loop 6/98
c update dtav, the mean residual so that its newly weighted will be used for k=2
c this reduces the "skewing" due to large outliers, as these will be weighted
c to 0 the second time through
c         if(wsum.gt.0.0)dtav=sum/wsum    !removed 6/98

c       recalculate rmsv
        go to 8700
c------------------------------------------------------------------
      return
      end

c*****************************************************************
c  subroutine added 10/93 to calculate individual travel times
c 4/94: modified depth origin - input xh(3) is now always relative 
c to sea level

c  last parameter, minflag, is defined as follows:
c       minflag = 0:   match 4 char. phase ID in phase(i)
c                      2nd letter is case insensitive
c       minflag = 1    use minimum time for 1st letter phase(i)(1:1)
c       minflag = 2    use refracted 'n' phases, set other phase 
c                      weights=-1
c       minflag = 3    use surface 'g' phases
c       minflag = 4    use Conrad 'b' phases
c       minflag = 5    use only minimum time P, Pn, Pg and pP phases no PKP's
c                      all other phases weighted to 0

c 10/94: included station elevation, xsd(3), in ellipticity correction
c 1/95: added ipcount, the # of duplicate phases at the same station
 
      subroutine trtime(ii,ipcount,st,phase,tp,x0,y0,xh,ndata,
     &   nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &   tpc1,dl,iselv,maxelv,ip,dt,xfar,xnear,tph,aninc,trphs,
     &   iflagd,minflag,data,distind,imatch,depthlim,scorr,ph,dx)

       save
       include 'hypparm.inc'
c      include 'comm1.inc'
c      include 'param.inc'
c
      include 'libsei.inc'                    ! Library definitons.
      external sei code                       ! Error encoder.
      integer  code,                          ! Condition.
     &         iulst                          ! Output diagnostics.
      logical  b_flag                         ! Flag it?.   
      character*1 ucase,prm1,prm2,prmd
      character*8 phsid 
      integer ii,ipcount
      double precision az1                              ! added jh sep  18 , 98
      real xsd(3),xhc(3)
c
      pi=3.14159265
      degtorad=pi/180.

c 11/94: changed from 6378.2 to mean radius
      rearth=6371.
      
      nn=2*nl-1      
      
c 4/94: find depth of moho & conrad
      dconrad=0.0
      dmoho=0.0 
      sum=0.0
      do k=1,nl
       if(dconrad.eq.0.0.and.k.eq.nconrad)dconrad=sum
       if(dmoho.eq.0.0.and.k.eq.nmoho)dmoho=sum
       sum=sum+parm(nl+k)                  
      end do                                      
      dcorr=0.0
      if(test(40).eq.0.0)dcorr=float(maxelv)*.001
      
c    set L velocity to test(51)
      vl=test(51)

c    xs(1), xs(2) are the station long. and lat.
      xs(1)=x0(ii)
      xs(2)=y0(ii)

c xs is only used by dtdx2, which uses the maximum elevation station as its depth origin
      xs(3)=float(maxelv-iselv(ii))*0.001

c 10/94: added station coords xsd
      xsd(1)=xs(1)
      xsd(2)=xs(2)
      xsd(3)=-float(iselv(ii))*.001
      
      prm1=ucase(phase(ii)(1:1))
      prm2=ucase(phase(ii)(2:2))

c change 10/93: minimum time calc
      if(minflag.eq.0)prmd=prm2
      if(minflag.eq.1.or.minflag.eq.5)prmd=' '
      if(minflag.eq.2)prmd='N'
      if(minflag.eq.3)prmd='G'
      if(minflag.eq.4)prmd='B'

c 10/93: if phase is not the one specified by minflag, exit with dtw1(ii)=0.0
c 5/94: changed prm2.ne.' ' to prmd.ne.' '
c 7/94: changed weight from -1 to 0
      if(prm2.ne.prmd.and.prmd.ne.' '.and.minflag.ne.5)then
        dtw1(ii)=-1.0
        return
      endif

c 10/94: added test(90) to exclude core phases
      if(test(90).eq.0.0)then
       iflag2=0
       do j=1,8
        if(phase(ii)(j:j).eq.'K')iflag2=1
       enddo 
       if(iflag2.eq.1)then
        dtw1(ii)=-2.0
       endif 
      endif
       
c 4/95: added minflag=5: exclude secondary phases  (saves time at this point)    
      if(minflag.eq.5)then

c 10/94: changed iflag to iflag2 
       iflag2=0

       if(prm1.eq.'S'.or.prm2.eq.'S')iflag2=1
       if(phase(ii)(2:2).eq.'K'.or.phase(ii)(3:3).eq.'K')iflag2=1
       do k=1,4
        if(ucase(phase(ii)(k:k)).eq.'S')iflag2=1
        if(ucase(phase(ii)(k:k)).eq.'I')iflag2=1
        if(ucase(phase(ii)(k:k)).eq.'C')iflag2=1
        if(ucase(phase(ii)(k:k)).eq.'''')iflag2=1
       enddo 
       if(phase(ii)(2:3).eq.'KK')iflag2=1
       if(phase(ii)(1:2).eq.'PP'.or.phase(ii)(2:3).eq.'PP')iflag2=1
       if(iflag2.eq.1)then

c 7/94: flag secondary arrivals with -2 weight - set to zero later
        dtw1(ii)=-2.0
c        return
       endif                               
      endif                  
      
c 10/94: exclude depth phases if test(89)=0.0
      if(test(89).eq.0.0)then
       if(phase(ii)(1:1).eq.'p'.or.phase(ii)(1:1).eq.'s')then
        dtw1(ii)=-2.0
       endif
      endif        
      
c added 4/94 to exit for blank phases with imatch=1
      if(phase(ii)(1:4).eq.'    '.and.imatch.eq.1)then
        dtw1(ii)=-1.0
        return
      endif
      
c get delta and azimuth for this phase
      call distaz(xs(2)/degtorad,xs(1)/degtorad,xh(2)/degtorad,
     &xh(1)/degtorad,dedeg,azz,azb)
      delta=dedeg*degtorad*rearth

c distance weight factor, wt (only used for local events)
      wt=1.0
      if(xfar.ne.0.0)then
        if(delta.gt.xfar)wt=0.0
        if(delta.gt.xnear.and.delta.le.xfar)
     &  wt=(xfar-delta)/(xfar-xnear)
      endif

c change 10/94: no longer set dtw1(ii)=-1.0

c   P and S phases:
      if(prm1.eq.'P'.or.prm1.eq.'S'.or.prm1.eq.' ')then

c    only recognizes 'N', 'G', 'B' or ' ' phases in local case

c icount is used to allow two changes of a refracted "N" phase to a "B"
c then a "G" surface phase
        icount=0

777     continue

c 10/93: distind now forces layered model times
        if(iflagd.eq.0.or.distind.eq.'L'.and.prm1.ne.' ')then

c 7/94: forces depset call for next distant event
          iflagi=0                               
          
c moho, conrad check - transferred from hypoloc 4/94 - only want
c in layered model case
         if(prmd.eq.'B'.and.nconrad.eq.0) then
c          write(*,*)prmd,phase(ii),minflag
          write(*,*)' B phase specified, Conrad not defined'
          if(iulst.gt.0.and.(.not.multi_model))
     *    write(iulst,*,iostat=code)
     &    ' B phase specified,',
     &    ' Conrad not defined'
          call sei code(fort$,code,iulst,b_flag) ! Process error.
          trphs(ii)='        '
          dtw1(ii)=-1.0
          tmin=0.0
          return
         endif

         if(prmd.eq.'N'.and.nmoho.eq.0) then
          write(*,*)' N phase specified, moho not defined'
          if(iulst.gt.0.and.(.not.multi_model))
     *    write(iulst,*,iostat=code)
     &    ' N phase specified,',
     &    ' moho not defined'
          call sei code(fort$,code,iulst,b_flag) ! Process error.
          trphs(ii)='        '
          dtw1(ii)=-1.0
          tmin=0.0
          return
         endif

c    If N phases, don't allow xh(3) > d(nmoho)
c         write(iulst,*)prmd,xh(3),dmoho,dcorr
         call sei code(fort$,code,iulst,b_flag)
         if(prmd.eq.'N'.and.xh(3).gt.dmoho-dcorr)
     &    then
c          write(iulst,*)phase(ii),dmoho,dcorr
          if(test(47).eq.1.0)then  
           xh(3)=0.999*dmoho                                         
           if(test(40).eq.0.0)xh(3)=0.999*(dmoho-dcorr)
           call sei code(fort$,code,iulst,b_flag) ! Process error.
           if(iulst.gt.0.and.(.not.multi_model))
     *     write(iulst,'('' depth limited to moho at '',
     &     f6.1,'' km'')')xh(3)
           write(*,'('' depth limited to moho at '',
     &     f6.1,'' km'')')xh(3)
           depthlim=xh(3)
          endif
         endif 

c    If B phases, don't allow xh(3) > d(nconrad)
         if(prmd.eq.'B'.and.xh(3).gt.dconrad-dcorr)then
c changed 6/98, BRL <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
          if(test(47).eq.1.0)then          
           xh(3)=0.999*dconrad
           if(test(40).eq.0.0)xh(3)=0.999*(dconrad-dcorr)
           if(iulst.gt.0.and.(.not.multi_model))
     *     write(iulst,'('' depth limited to Conrad at '',
     &      f6.1,'' km'')',iostat=code)xh(3)
           call sei code(fort$,code,iulst,b_flag) ! Process error.
           write(*,'('' depth limited to Conrad at '',
     &     f6.1,'' km'')')xh(3)
           depthlim=dconrad
          else
           trphs(ii)='        '
           dtw1(ii)=-1.0
           tmin=0.0
           return
          endif            
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
         endif

         if(prmd.eq.'N'.or.prmd.eq.'G'.or.prmd.eq.' '.or.prmd.eq.'B'
     &   )then
c BRL 11/95 changed prm1 to prmd so blank phase not reset back to 'N'
           trphs(ii)(1:1)=prmd
           do k=1,nl                      
            if(prm1.eq.'P')parm(k)=v(k)
            if(prm1.eq.'S')parm(k)=vs(k)
           end do
c            write(iulst,*,iostat=code)xs(1)/degtorad,
c     &      xs(2)/degtorad,xh(1)/degtorad,
c     &      xh(2)/degtorad,xh(3)
           call sei code(fort$,code,iulst,b_flag) ! Process error.
           iflag=1
           iu=0

c change 10/93: print dtdx2 errors if test(66)>0
           if(test(66).gt.0.0)iu=iulst
            
           xhc(1)=xh(1)
           xhc(2)=xh(2)
           xhc(3)=xh(3)

c 4/94: correct xhc(3) for dtdx2 if test(40)=0
c       since the dtdx2 origin is at maxelv, maxelv must
c       be added to the hypocentral depth, xh(3), relative
c       to sea level
           if(test(40).eq.0.0)xhc(3)=xh(3)+float(maxelv)*.001

           if(test(105).eq.0.0)then
            call dtdx2(xhc,xs,prmd,nmoho,nconrad,iu,tmin,
     &      dx,delta,ann,iflag,phsid)               
           endif
c           if(test(105).gt.0.0)then
c            call dtdxg(nn,parm,xhc,xs,prmd,nmoho,nconrad,iu,tmin,
c     &       dx,delta,ann,iflag,phsid)               
c           endif
c          write(iulst,*,iostat=code)st(ii),phase(ii),tp(ii)-tph,
c     &                              tmin,iflag
           call sei code(fort$,code,iulst,b_flag) ! Process error.
         else
            iflag=0
            trphs(ii)='        '
         endif
         if(iflag.eq.0)then

c change 10/93 to only print message 1st time through
            if(iulst.gt.0.and.dtw1(ii).ge.0.0.and.test(66).
     *        ne.0.0.and.(.not.multi_model))then
              write(iulst,'('' No dtdx2 travel time for '',a5,
     &        1x,a4)',iostat=code)st(ii),phase(ii)
              call sei code(fort$,code,iulst,b_flag) ! Process error.
c             write(*,'('' No dtdx2 travel time for '',a4,
c     &       1x,a4)')sti),phase(ii)
            endif
            
            aninc(ii)=0

c set dtw1=-1.0 for invalid phases
            trphs(ii)='        '
            dtw1(ii)=-1.0
            tmin=0.0

         else

c set trphs(ii) to requested phase when iflagd=0 and iflag=1
c change 4/94: set trphs to phase calculated
            trphs(ii)=phsid
            trphs(ii)(1:1)=prm1

            if(dtw1(ii).ne.-2.0)then
             dtw1(ii)=dtwt(ii)*wt
            else
             dtw1(ii)=0.0
            endif  
            tpc1(ii)=tmin
            aninc(ii)=ann
         endif
      
c 10/94: added dtw1(ii).ne.-2.
        elseif(iflagd.eq.1.or.distind.eq.'D')then

c 10/94: reset depthlim to TEST(70) for distant case
          depthlim=test(70)

c 4/95: added minflag=5 option - exclude 'S' phases
c          if(minflag.eq.5)then
c           if(ucase(phase(ii)(1:1)).ne.'P'.or.(phase(ii)(1:1).eq.'p'
c     &     .and.phase(ii)(2:2).ne.'P'))then
c             trphs(ii)='        '
c             aninc(ii)=0
c             dtw1(ii)=-1.0
c           endif 
c          endif 
          
c   use iasp91 program if iflagd=1
c          write(iulst,*,iostat=code)st(ii),dedeg,xh(3),tmin,dtdd,dtdz
         call sei code(fort$,code,iulst,b_flag) ! Process error.

c change 10/93: only call depset if depth has changed - saves CPU time
c iflagi<>1 signifies 1st call to depset for new run
c 4/94: also added check that dedeg has changed - saves time          
           if(xh(3).ne.olddep.or.iflagi.ne.1)then
            call depset(xh(3),usrc)
c            write(iulst,*,iostat=code)' depset ',xh(3)
            call sei code(fort$,code,iulst,b_flag) ! Process error.
            iflagi=1
            olddep=xh(3)

c 7/94: forces new trtm call when depth changes
            dedegold=-1.0
            
           endif
c          write(iulst,'('' dedeg '',f12.3)',iostat=code)dedeg
           call sei code(fort$,code,iulst,b_flag) ! Process error.
           if(dedeg.ne.dedegold)then
            call trtm(dedeg,niasp,n,tt,dtdl,dtdh,dddp,phcd)
            dedegold=dedeg
           endif 
           if(n.lt.1)go to 784
           iflag=1
c         write(iulst,*,iostat=code)'iasp91 tt ',phcd(1),tt(1),
c     &                        dtdl(1),dtdh(1)
c     &   ,ierr
           call sei code(fort$,code,iulst,b_flag) ! Process error.

c ************** MATCHED PICK (imatch=1)**************************************
c look for the phase in the iasp91 list (n phases)

c 5/94: always match first arrival, even for autopick-add P,S,PKP,Pn
          if(imatch.eq.1.or.(
     &     phase(ii)(1:4).eq.'P   '.or.phase(ii)(1:4)
     &    .eq.'S   '.or.phase(ii)(1:3).eq.'PKP'.or.phase(ii)(1:4).eq.
     &    'Pn  '.or.phase(ii)(1:4).eq.'Sn  '))then
          
c these indices are used to store the first S, P and PKP phases:
c If no match is found for 'P   ', 'S   ', or 'PKP ', this first
c phase is used
c change 3/94: added SKS & PKS indices
c 1/95 added PKiKP index
           indexfs=0
           indexfp=0
           indpkp=0
           indpki=0
           indpks=0
           indskp=0
           indsks=0
           inddpp=0
           inddps=0

c 1/95: indices to find # of P???????, S??????? & PK?????? arrivals found
           infprpt=0
           infsrpt=0
           inpkrpt=0
 
           do 770 j=1,n

c 6/94 use PnPn for PP and SnSn for SS
             if(phcd(j)(1:4).eq.'PnPn'.and.phase(ii)(1:3).eq.'PP ')
     &       go to 765        
             if(phcd(j)(1:4).eq.'SnSn'.and.phase(ii)(1:3).eq.'SS ')then
              go to 765                                                 
             endif 

c change made 11/6/92 to exclude diffracted phases  
c changed 1/5 to match ipcount to infprpt
             if(phcd(j)(1:1).eq.'P'.and.indexfp.eq.0
c jul 2003     &       .and.(phcd(j)(2:5).ne.'diff'.or.dedeg.lt.test(69)
     &       .and.(phcd(j)(2:4).ne.'dif'.or.dedeg.lt.test(69)
     &       ))then
              if(ipcount.eq.infprpt)indexfp=j
              infprpt=infprpt+1
             endif

c 4/94: exclude SKi?? and SKP?? phases
c 7/95 BRL: exclude ScP, added infsrpt increment
c             write(iulst,*)phase(ii),phcd(j),indexfs,infsrpt
             if(phcd(j)(1:1).eq.'S'.and.indexfs.eq.0.
     &        and.phcd(j)(1:3).ne.'SKi'.and.phcd(j)(1:3).ne.'SKP'
     &        .and.phcd(j)(1:3).ne.'ScP')then
              if(ipcount.eq.infsrpt)indexfs=j
              infsrpt=infsrpt+1
             endif

c change 10/93: added 2 indices to look for 1st pP and pS phases
             if(phcd(j)(1:2).eq.'pP'.and.inddpp.eq.0)inddpp=j
             if(phcd(j)(1:2).eq.'pS'.and.inddps.eq.0.and.phcd(j)(2:4)
     &       .ne.'SKi'.and.phcd(j)(2:4).ne.'SKP')inddps=j

c--------------------------------------------------------------------------
c changed following lines 4/94 to stop dual selection of phases in indexfs 
c & indexfp
c changed 4/94 to exclude SKiK?? and SKP??

c I test for both PKP and PKiKP so that the event can be moved out to
c satisfy the minimum delta (about 140 degrees) for PKP, using the
c PKiKP derivatives and travel times
c changed 1/95 to remove j.ne.indexfp.and.dedeg.lt.test(69)
c             if((phcd(j)(1:3).eq.'PKP').and.indpkp.eq.0)then
             if(phcd(j)(1:3).eq.'PKP'.or.phcd(j)(1:5).eq.'PKiKP')then
              inpkrpt=inpkrpt+1
              if(ipcount.eq.inpkrpt)indpkp=j
             endif

c look for first PKS, SKP & SKS 
             if(phcd(j)(1:3).eq.'PKS'.and.indpks.eq.0
     &       .and.j.ne.indexfp)indpks=j
             if(phcd(j)(1:3).eq.'SKP'.and.indskp.eq.0
     &       .and.j.ne.indexfs)indskp=j
             if(phcd(j)(1:3).eq.'SKS'.and.indsks.eq.0
     &       .and.j.ne.indexfs)indsks=j
c--------------------------------------------------------------------------

c change 10/93: make 1st letter case-sensitive
             if(phase(ii)(1:1).ne.phcd(j)(1:1))go to 770

c 7/95 BRL: 'P   ' and 'S   ' are always first arrivals
             if(phase(ii)(1:4).eq.'P   '.or.
     &         phase(ii)(1:4).eq.'S   ')go to 770

c 4/94: minflag=5 cases (only first P & pP)
c             if(minflag.eq.5)go to 770
             
c 4/94: change to 8 char check
             do k=2,8
              if(ucase(phase(ii)(k:k)).ne.ucase(phcd(j)(k:k)))go to 770                        
             end do

765          tmin=tt(j)
             dtdd=dtdl(j)
             dtdz=dtdh(j) 

c change 3/94: set indexfs and indexfp to 0 if phase is found:
c this means 'P   ' and 'S   ' must be next phase after this one
             if(phase(ii)(1:1).eq.'S')indexfs=0
             if(phase(ii)(1:1).eq.'P')indexfp=0
             if(phase(ii)(1:2).eq.'pS')inddps=0
             if(phase(ii)(1:2).eq.'pP')inddpp=0
             if(phase(ii)(1:3).eq.'PKP')indpkp=0
             if(phase(ii)(1:3).eq.'PKi')indpki=0
             if(phase(ii)(1:3).eq.'PKS')indpks=0
             if(phase(ii)(1:3).eq.'SKP')indskp=0
             if(phase(ii)(1:3).eq.'SKS')indsks=0

c set trphs(ii) to IASP91 phase
             trphs(ii)=phcd(j)

c            write(iulst,*,iostat=code)phcd(j)
             call sei code(fort$,code,iulst,b_flag) ! Process error.
c            write(iulst,*,iostat=code)st(ii),phase(ii),
c     &                dedeg,phcd(j),tmin
             call sei code(fort$,code,iulst,b_flag) ! Process error.
             go to 785
770        continue
          endif

c**********************  AUTOPICK (imatch=0)*********************************          
c section added 4/94 to match phase based on closest IASP91 travel time            
c modified this 4/94 to exclude PPP & SSS since IASPEI91 doesn't 
c calculate these
c 1/95: changed elseif(... to if(imatch.eq.0.and....
          if(imatch.eq.0.and.phase(ii)(1:3).ne.'SSS'.and.phase(ii)(1:3).
     &    ne.'PPP'.and.phase(ii)(2:4).ne.'SSS'.and.phase(ii)(2:4).ne.
     &    'PPP')then
           otime=sngl(tp(ii)-tph)-dl(ii)          
           diff=1.e32  
           minind=0
           iflag=1
           k=0
           do while (iflag.eq.1.and.k.le.n)  
            k=k+1
            tdiff=abs(otime-tt(k))
            if(tdiff.lt.diff)then
c            .and.(phase(ii)(1:1).eq.phcd(k)(1:1).or.
c     &       phase(ii)(1:1).eq.' '))then
             diff=tdiff
             minind=k
            else
             iflag=0
            endif
           enddo
c           write(iulst,'(1x,a4,1x,a4,1x,a8,2f10.2)',iostat=code)
c     &                 st(ii),phase(ii),
           call sei code(fort$,code,iulst,b_flag) ! Process error.
c     &     phcd(minind),tt(minind),otime              
           tmin=tt(minind)
           dtdd=dtdl(minind)
           dtdz=dtdh(minind)
           trphs(ii)=phcd(minind)
           go to 785
          endif

          if(minflag.eq.5)then

c 6/94 include operator specified PKP
c 9/94 added Pn phases 
           if((phase(ii)(1:3).eq.'P  '.or.phase(ii)(1:2).eq.'Pn'
     &     .or.phase(ii)(1:3).eq.'PKP').and.indexfp.ne.0)then
            tmin=tt(indexfp)
            dtdd=dtdl(indexfp)
            dtdz=dtdh(indexfp)
            trphs(ii)=phcd(indexfp)                  
            go to 785
           elseif(phase(ii)(1:4).eq.'pP  '.and.inddpp.ne.0)then
            tmin=tt(inddpp)
            dtdd=dtdl(inddpp)
            dtdz=dtdh(inddpp)
            trphs(ii)=phcd(inddpp)                  
            go to 785
           else
c 10/94: calculate time for secondary phases
c            trphs(ii)='        '
c            tmin=-1.0
           endif 
c           if(trphs(ii)(2:5).eq.'diff'.or.trphs(ii)(3:6).eq.'diff'.
c     &     or.trphs(ii)(1:4).eq.'PKiK'.or.trphs(ii)(2:5).eq.'PKiK')
c     &     tmin=-1.0 
c 10/94: moved go to 785 above to recognized 1st arrivals so secondary
c        arrivals still are assigned travel times
          endif
          
c if we get to this point, no match has been found:
c set to the minimum travel time for the following cases
c changed 10/93 to force minimum times when minflag=1
c also use minimum times for 'g' and 'n' phases when
c these are not calculated
c          write(iulst,*,iostat=code)phase(ii),indpkp,
c     &                  indsks,indskp,indpks,n
          call sei code(fort$,code,iulst,b_flag) ! Process error.
c 2/95: added PKP - set to first P if not found
c          write(iulst,*)st(ii),phase(ii),dedeg,indexfp,indexfs
          if(indexfp.ne.0.and.(phase(ii)(1:4).eq.'P   '.or.
     &     (phase(ii)(1:1).eq.'P'.and.minflag.eq.1).or.
     &     (phase(ii)(1:1).eq.'P'.and.ucase(phase(ii)(2:2)).
     &     eq.'N'.and.minflag.eq.0).or.phase(ii)(1:3).eq.'PKP'))then
 
c 11/94: exclude G phases
c     .or.(phase(ii)(1:1).eq.'P'.
c     &     and.ucase(phase(ii)(2:2)).eq.'G'.and.minflag.eq.0)))then

            tmin=tt(indexfp)
            dtdd=dtdl(indexfp)
            dtdz=dtdh(indexfp)
            trphs(ii)=phcd(indexfp)                  
            indexfp=0
            go to 785
          endif

          if(indexfs.ne.0.and.(phase(ii)(1:4).eq.'S   '.or.
     &     (phase(ii)(1:1).eq.'S'.and.minflag.eq.1).or.(phase(ii)(1:1).
     &     eq.'S'.and.ucase(phase(ii)(2:2)).eq.'N'.and.minflag.eq.0).or.
     &     (phase(ii)(1:1).eq.'S'.and.ucase(phase(ii)(2:2)).eq.'G'.and.
     &     minflag.eq.0)))then
            tmin=tt(indexfs)
            dtdd=dtdl(indexfs)
            dtdz=dtdh(indexfs)
            trphs(ii)=phcd(indexfs)
            indexfs=0
            go to 785
          endif

c change BRL 1/94: need this for depth phases
          if(inddpp.ne.0.and.(phase(ii)(1:4).eq.'pP  '.or.
     &     (phase(ii)(1:2).
     &    eq.'pP'.and.minflag.eq.1).or.(phase(ii)(1:2).eq.'pP'.and.
     &    ucase(phase(ii)(3:3)).eq.'N'.and.minflag.eq.0).or.
     &    (phase(ii)(1:2).eq.'pP'.and.ucase(phase(ii)(3:3)).eq.'G'.and.
     &    minflag.eq.0)))then
            tmin=tt(inddpp)
            dtdd=dtdl(inddpp)
            dtdz=dtdh(inddpp)
            trphs(ii)=phcd(inddpp)
            inddpp=0
            go to 785
          endif

           if(inddps.ne.0.and.(phase(ii)(1:4).eq.'pS  '.or.
     &     (phase(ii)(1:2).eq.'pS'.and.minflag.eq.1).or.
     &     (phase(ii)(1:2).eq.'pS'.and.ucase(phase(ii)(3:3))
     &     .eq.'N'.and.minflag.eq.0).or.(phase(ii)(1:2).eq.'pS'
     &     .and.ucase(phase(ii)(3:3)).eq.'G'.and.minflag.eq.0)))then
             tmin=tt(inddps)
             dtdd=dtdl(inddps)
             dtdz=dtdh(inddps)
             trphs(ii)=phcd(inddps)
             inddps=0
             go to 785
           endif

c 10/93: P' now recognized as PKP
           if(indpkp.ne.0.and.(phase(ii)(1:3).eq.'PKP'.or.phase(ii)(2:2)
     &     .eq.'P'''))then
            tmin=tt(indpkp)
            dtdd=dtdl(indpkp)
            dtdz=dtdh(indpkp)
            trphs(ii)=phcd(indpkp)
            indpkp=0
            go to 785
           endif

c 3/94: added PKS, SKP & SKS
           if(indpks.ne.0.and.phase(ii)(1:3).eq.'PKS')then
            tmin=tt(indpks)
            dtdd=dtdl(indpks)
            dtdz=dtdh(indpks)
            trphs(ii)=phcd(indpks)
            indpks=0
            go to 785
           endif

           if(indskp.ne.0.and.phase(ii)(1:3).eq.'SKP')then
            tmin=tt(indskp)
            dtdd=dtdl(indskp)
            dtdz=dtdh(indskp)
            trphs(ii)=phcd(indskp)
            indskp=0
            go to 785
           endif

           if(indsks.ne.0.and.phase(ii)(1:3).eq.'SKS')then
            tmin=tt(indsks)
            dtdd=dtdl(indsks)
            dtdz=dtdh(indsks)
            trphs(ii)=phcd(indsks)
            indsks=0
            go to 785
           endif

c  phase not identified: set it to blank and tmin=-1
          trphs(ii)='        '

784       tmin=-1.0
785       continue

c 1/95: weight core phases out if test(90)=0
          do j=1,8
           if(test(90).eq.0.0.and.ucase(trphs(ii)(j:j)).eq.'K')then
c            write(iulst,*)phase(ii),trphs(ii)
            dtw1(ii)=-2.0
           endif
          enddo

c weight out core phases in range 135-150 deg if test(95)>0            
          if(test(95).gt.0.0.and.delta.ge.15344.
     &     .and.delta.le.16902.)dtw1(ii)=-2.0
          
          if(tmin.lt.0.0)then
            if(iulst.gt.0.and.dtw1(ii).ge.0.0.and.test(66).
     *        ne.0..and.(.not.multi_model))then
              if(data(1).ne.dataprev)then
c                write(iulst,*,iostat=code)data(1)(1:78)
               call sei code(fort$,code,iulst,b_flag) ! Process error.
              endif
              write(iulst,'('' No IASP91 travel time for '',a5,
     &        1x,a4)',iostat=code)st(ii),phase(ii)
              call sei code(fort$,code,iulst,b_flag) ! Process error.
            endif
            if(dtw1(ii).ge.0.0.and.test(66).ne.0.)then
              if(data(1).ne.dataprev)then
c                write(*,*)data(1)(1:78)
                dataprev=data(1)
              endif
              if(phase(ii)(1:4).ne.'    ')
     &         write(*,'('' No IASP91 travel time''
     &        '' for '',a5,1x,a4)')st(ii),phase(ii)
            endif
c            trphs(ii)='        '
            aninc(ii)=0
            dtw1(ii)=-1.0

          else

c  VALID PHASE-------------------------------------------------------------
c 2/95 BRL: time correction for PKPdf phase
c            write(iulst,*)phase(ii),trphs(ii),delta,imatch
            if(trphs(ii)(1:5).eq.'PKPdf'.or.trphs(ii)(2:6)
     &       .eq.'PKPdf')then
             if(dedeg.ge.137..and.dedeg.le.149.5.and.imatch.eq.1)then
c              write(iulst,*)(dedeg-145.)*1.087
c              tmin=tmin+(dedeg-145.)*1.087
             endif
            endif            


c dddd is the horizontal slowness (dt/ddelta) in sec/km
            dddd=dtdd/rearth/degtorad      
            
c 4/94: add station altitude correction
c I use the velocity in the top layer of the layered model as the velocity
c between sea level and the station
c 10/94:  changed velocity to top layer of IASPEI91 model
            rr=1.
            call emiask(rr,ro,vpp,vss)
            vpp=vpp*6.8501006
            vss=vss*6.8501006
            if(ucase(prm1).eq.'P')vvv=vpp
            if(ucase(prm1).eq.'S')vvv=vss

c            pz=sqrt(abs(1./vvv*vvv-dddd*dddd)) !removed 6/98 BRL

c 7/94: changed to use angle of incidence at station, aninst,
c      to calculate vertical slowness
           if(trphs(ii)(1:2).ne.'Pg'.and.trphs(ii)(1:2).ne.'Sg')then 
            arg=vvv*dddd
            if(arg.gt.1.)arg=1.
            aninst=asin(arg)
            pz=cos(aninst)/vvv
            ph=sin(aninst)/vvv  !added 6/98
            tcorr=float(iselv(ii))*.001*pz
           else
            tcorr=0.0
           endif   

c 11/95 BRL: added spherical harmonic station corrections
            if(test(98).ne.0.0)then
             thetamax=35.
             thetamin=15.                        
             aninstr=aninst/degtorad
             costh=cos(pi*(thetamax-aninstr)/(thetamax-thetamin))
             backaz=azb*degtorad
             stcorr=scorr(ii,1)+scorr(ii,2)*plgndr(1,0,costh)
             stcorr=stcorr+(scorr(ii,3)*cos(backaz)+scorr(ii,4)
     &       *sin(backaz))*plgndr(1,1,costh)        
             stcorr=stcorr+scorr(ii,5)*plgndr(2,0,costh)
             stcorr=stcorr+(scorr(ii,6)*cos(backaz)+scorr(ii,7)
     &       *sin(backaz))*plgndr(2,1,costh)
             stcorr=stcorr+(scorr(ii,8)*cos(2.*backaz)+scorr(ii,9)
     &       *sin(2.*backaz))*plgndr(2,2,costh)
             if(ucase(prm1).eq.'S')stcorr=stcorr*vss/vpp
             tcorr=tcorr+stcorr

c            write(iulst,'(a8,3f10.4)')st(ii),scorr(ii,1),stcorr
            endif

c            write(iulst,'('' tcorr '',a8,f10.2)',iostat=code)
c     &                      trphs(ii),tcorr
            call sei code(fort$,code,iulst,b_flag) ! Process error.
c set dtw1 to the initial phase weight
            if(dtw1(ii).ne.-2.0)then
             dtw1(ii)=dtwt(ii)
            else
             dtw1(ii)=0.0
            endif  

c 6/94: added ellipticity correction. Changed station coord to xsd 10/94
c       station elevation correction now included in ellipticity corrn.
            if(test(84).gt.0.0)then
             ecr=ellipcor(xsd,xh,trphs(ii))
             if(ecr.gt.2.0)then
              write(iulst,*,iostat=code)
     &              ' ellip corr > 2 ',trphs(ii),ecr,xh(3)
              call sei code(fort$,code,iulst,b_flag) ! Process error.
              write(*,*)' ellip corr > 2 ',trphs(ii),ecr,xh(3)
             endif 
            else
             ecr=0.0
            endif  
            tpc1(ii)=tmin+tcorr+ecr
c            write(iulst,*,iostat=code)st(ii),phase(ii),ecr
            call sei code(fort$,code,iulst,b_flag) ! Process error.
            az=azb*degtorad

c change 12/29: multiply dx(3) by earth's radius to keep consistency
c with dtdx2, i.e., keep dx(3) in sec/km,
            dx(3)=dtdz*rearth

            dx(1)=-dtdd*sin(az)*cos(xh(2))/degtorad
            dx(2)=-dtdd*cos(az)/degtorad

c  get velocity at location depth using iasp91 model

c change 10/93: delz is depth of event 
c corrected 4/94: xh(3) is now always relative to sea level
            delz=xh(3)

c find angle of incidence using IASPEI91 model
            rr=(rearth-delz)/rearth
            call emiask(rr,ro,vpp,vss)
            vpp=vpp*6.8501006
            vss=vss*6.8501006
            if(ucase(prm1).eq.'P')vvv=vpp
            if(ucase(prm1).eq.'S')vvv=vss

c 4/94: prevents asin arguments>1            
            arg=vvv*dddd
            if(arg.gt.1.)arg=1.
            aninc(ii)=asin(arg)/degtorad
c
c   iasp91 should calculate g if event deep, but it labels phase n and calcualte
c   wrong angle of incidence. correct here
c
            if(dtdz.gt.0.0) then
               aninc(ii)=180.0-aninc(ii) ! barry+jh jan-01
               if(trphs(ii)(2:2).eq.'n') trphs(ii)(2:2)='G'
            endif

          endif
        endif

c        if(dtw1(ii).ge.0.0)then
c          dt(ii)=sngl(tp(ii)-tph)-tpc1(ii)-dl(ii)
c        else
c          dt(ii)=0.0
c        endif
c        write(16,*)' tt ',st(ii),phase(ii),tmin,dt(ii)

c    L & R phase derivatives
c change 10/93 to include R phases and only use 'G'
c changed 1/94 - don't use 'G' as ISC doesn't         
c 6/98 BRL added T phase

      elseif(prm1.eq.'L'.or.prm1.eq.'R'.or.prm1.eq.'T')then
        call delaz(y0(ii),x0(ii),delta,dedeg,azz,xh(2),xh(1))
c changed BRL 6/98        
        cfact=1.0
        if(delta.gt.0.0)cfact=degtorad*dedeg/delta

c    calculate travel time and derivatives along direct path in single 
c    layer having a  velocity vl
        if(iflagd.eq.0)dtw1(ii)=dtwt(ii)*wt
        if(iflagd.eq.1)dtw1(ii)=dtwt(ii)
        if(prm1.eq.'L')then
         vl=test(51)
c jul 2003         trphs(ii)='LG      '
         trphs(ii)='Lg      '
         dtw1(ii)=dtw1(ii)*test(99)
        endif       
        if(prm1.eq.'R')then
         vl=test(44)
c jul 2003         trphs(ii)='RG      '
         trphs(ii)='Rg      '
         dtw1(ii)=dtw1(ii)*test(100)
        endif
        if(prm1.eq.'T')then
         vl=test(49)
         trphs(ii)='T       '
         dtw1(ii)=dtw1(ii)*test(101)
        endif
        dist=delta
        tpc1(ii)=dist/vl
        dx(1)=-sin(azz*degtorad)*cos(abs(xh(2)))/(cfact*vl)
        dx(2)=-cos(azz*degtorad)/(cfact*vl)
        dx(3)=0.0
c        dt(ii)=sngl(tp(ii)-tph)-tpc1(ii)-dl(ii)
c        write(16,*)' L',i,dist,vl,tpc1(ii),dtw1(ii)
        
c    Azimuthal derivatives
      elseif(phase(ii)(1:2).eq.'AZ')then
        if(dedeg.ne.0.0)dx(1)=-cos(azb*degtorad)/abs(sin(dedeg
     &  *degtorad))
        dx(1)=dx(1)*cos(abs(xh(2)))
        if(dedeg.ne.0.0)dx(2)=sin(azb*degtorad)/abs(sin(dedeg
     &  *degtorad))
c        write(iulst,*,iostat=code)'dx1,2,azb',dx(1),dx(2),azb
        call sei code(fort$,code,iulst,b_flag) ! Process error.
        dx(3)=0.0

c   Weight the azimuths with the inverse of the specified error
c   in radians. An azimuthal difference equal to this error then 
c   has the same effect as an unweighted time residual of one second.
        wt1=1.0

c change 10/93: keep zero weight when iflagd=1
c also check weight is not < 0
c also put dtwt(ii) (original weight) calculation in hypocent
        if(iflagd.eq.0.or.distind.eq.'L'.and.dtw1(ii).ge.0.0)wt1=wt

        dtw1(ii)=dtwt(ii)*wt1

c 4/94: changed az1 and dtt to double precision
        az1=tp(ii)

c change 10/93: make azimuths > 0 and correct dtt accordingly
c this section was not working before when azimuths were close to
c +/-180 deg
        if(az1.lt.0.d0)az1=az1+360.d0
        if(azz.lt.0.)azz=azz+360. 
        dtt=sngl(az1)-azz
c       write(iulst,*,iostat=code)sngl(az1),azz,dtt,dtwt(ii),wt1
        call sei code(fort$,code,iulst,b_flag) ! Process error.
c these are the cases when, e.g., az1=350 and azz=10 (dtt=-20)
        if(dtt.gt.180.d0)dtt=dtt-360.d0
c case when, e.g., az1=10 and az1=350 (dtt=+20)
        if(dtt.lt.-180.)dtt=360.+dtt
        dt(ii)=dtt*degtorad
        tpc1(ii)=azz
        tp(ii)=az1
        trphs(ii)='        '

c weird first phase letter or blank: set weight to -1
      else
        if(iulst.gt.0.and.dtw1(ii).ge.0.0.and.test(66).
     *    ne.0..and.(.not.multi_model))then
          if(data(1).ne.dataprev)then
c            write(iulst,*,iostat=code)data(1)(1:78)
           call sei code(fort$,code,iulst,b_flag) ! Process error.
          endif
          write(iulst,'('' No travel time for '',a5,
     &    '' phase '',a4)',iostat=code)st(ii),phase(ii)
          call sei code(fort$,code,iulst,b_flag) ! Process error.
        endif
        if(dtw1(ii).ge.0.0.and.test(66).ne.0.)then
          if(data(1).ne.dataprev)then
c            write(*,*)data(1)(1:78)
            dataprev=data(1)
          endif
          if(phase(ii)(1:4).ne.'    ')write(*,'('' No travel time for ''
     &    ,a5,'' phase '',a4)')st(ii),phase(ii)
        endif
        
c set this to blank for unidentified phases
        trphs(ii)='        '                
        
        dtw1(ii)=-1.0
        aninc(ii)=0.0
        tpc1(ii)=0.0
      endif

c  set P weight to zero for P-S, P-L differences:
c  the difference is stored in the other phase's position
      if(ip(ii).eq.9.and.dtw1(ii).gt.0.0)dtw1(ii)=0.0
      if(dtw1(ii).gt.0)ndata=ndata+1

c   set up the row of the partial derivative matrix, g(ii,j)
      do k=1,3
        g(ii,k)=dx(k)
      end do        
c      write(iulst,*,iostat=code)' dx ',(dx(k),k=1,3)
      call sei code(fort$,code,iulst,b_flag) ! Process error.
c      write(iulst,*,iostat=code)dt(ii),(g(ii,j),j=1,3)
         call sei code(fort$,code,iulst,b_flag) ! Process error.
c      write(iulst,*,iostat=code)st(ii),phase(ii),delta,dtw1(ii),dt(ii),iflagd
      call sei code(fort$,code,iulst,b_flag) ! Process error.
      return
      end

c****************************************************************
c version of Buland's routine r4sort modified to handle
c real*8 data

      subroutine r8sort(n,rkey,iptr)
c
c $$$$$ calls no other routine $$$$$
c
c   R8sort sorts the n elements of array rkey so that rkey(i),
c   i = 1, 2, 3, ..., n are in asending order.  R8sort is a trivial
c   modification of ACM algorithm 347:  "An efficient algorithm for
c   sorting with minimal storage" by R. C. Singleton.  Array rkey is
c   sorted in place in order n*alog2(n) operations.  Coded on
c   8 March 1979 by R. Buland.  Modified to handle real*8 data on
c   14 Oct 1993 by B. Lienert
c
      save
      real*8 rkey(n),tmpkey
      dimension iptr(n),il(10),iu(10)
c   Note:  il and iu implement a stack containing the upper and
c   lower limits of subsequences to be sorted independently.  A
c   depth of k allows for n<=2**(k+1)-1.
      if(n.le.0) return
      do 1 i=1,n
 1    iptr(i)=i
      if(n.le.1) return
      r=.375
      m=1
      i=1
      j=n
c
c   The first section interchanges low element i, middle element ij,
c   and high element j so they are in order.
c
 5    if(i.ge.j) go to 70
 10   k=i
c   Use a floating point modification, r, of Singleton's bisection
c   strategy (suggested by R. Peto in his verification of the
c   algorithm for the ACM).
      if(r.gt..58984375) go to 11
      r=r+.0390625
      go to 12
 11   r=r-.21875
 12   ij=i+(j-i)*r
      if(rkey(iptr(i)).le.rkey(iptr(ij))) go to 20
      it=iptr(ij)
      iptr(ij)=iptr(i)
      iptr(i)=it
 20   l=j
      if(rkey(iptr(j)).ge.rkey(iptr(ij))) go to 39
      it=iptr(ij)
      iptr(ij)=iptr(j)
      iptr(j)=it
      if(rkey(iptr(i)).le.rkey(iptr(ij))) go to 39
      it=iptr(ij)
      iptr(ij)=iptr(i)
      iptr(i)=it
 39   tmpkey=rkey(iptr(ij))
      go to 40
c
c   The second section continues this process.  K counts up from i and
c   l down from j.  Each time the k element is bigger than the ij
c   and the l element is less than the ij, then interchange the
c   k and l elements.  This continues until k and l meet.
c
 30   it=iptr(l)
      iptr(l)=iptr(k)
      iptr(k)=it
 40   l=l-1
      if(rkey(iptr(l)).gt.tmpkey) go to 40
 50   k=k+1
      if(rkey(iptr(k)).lt.tmpkey) go to 50
      if(k.le.l) go to 30
c
c   The third section considers the intervals i to l and k to j.  The
c   larger interval is saved on the stack (il and iu) and the smaller
c   is remapped into i and j for another shot at section one.
c
      if(l-i.le.j-k) go to 60
      il(m)=i
      iu(m)=l
      i=k
      m=m+1
      go to 80
 60   il(m)=k
      iu(m)=j
      j=l
      m=m+1
      go to 80
c
c   The fourth section pops elements off the stack (into i and j).  If
c   necessary control is transfered back to section one for more
c   interchange sorting.  If not we fall through to section five.  Note
c   that the algorighm exits when the stack is empty.
c
 70   m=m-1
      if(m.eq.0) return
      i=il(m)
      j=iu(m)
 80   if(j-i.ge.11) go to 10
      if(i.eq.1) go to 5
      i=i-1
c
c   The fifth section is the end game.  Final sorting is accomplished
c   (within each subsequence popped off the stack) by rippling out
c   of order elements down to their proper positions.
c
 90   i=i+1
      if(i.eq.j) go to 70
      if(rkey(iptr(i)).le.rkey(iptr(i+1))) go to 90
      k=i
      kk=k+1
      ib=iptr(kk)
 100  iptr(kk)=iptr(k)
      kk=k
      k=k-1
      if(rkey(ib).lt.rkey(iptr(k))) go to 100
      iptr(kk)=ib
      go to 90
      end

c**************************************************************
c this subroutine taken from the iasp91 module emiasp91.f
      subroutine emiask(x0,ro,vp,vs)
c
c $$$$$ calls no other routine $$$$$
c
c   Emiask returns model parameters for the IASPEI working model 
c   (September 1990.1).  
c   Given non-dimensionalized radius x0, emiasp returns
c   non-dimensionalized density, ro, compressional velocity, vp, and
c   shear velocity, vs.  Non-dimensionalization is according to the
c   scheme of Gilbert in program EOS:  x0 by a (the radius of the
c   Earth), ro by robar (the mean density of the Earth), and velocity
c   by a*sqrt(pi*G*robar) (where G is the universal gravitational
c   constant.
c
c
      save
      dimension r(14),d(13,4),p(13,4),s(13,4)
      data r/0.      ,1217.1  ,3482.0  ,3631.  ,5611.   ,5711.   ,
     1 5961.   ,6161.   ,6251.   ,6336.   ,6351.    ,6371.    ,
     2 6371.,6371./
      data d/13.01219,12.58416, 6.8143 , 6.8143 , 6.8143 ,11.11978,
     1  7.15855, 7.15855, 7.15855,  2.92  , 2.72   , 2*0.,
     2        0.     ,-1.69929,-1.66273,-1.66273,-1.66273,-7.87054,
     2 -3.85999,-3.85999,-3.85999,4*0.,
     3       -8.45292,-1.94128,-1.18531,-1.18531,-1.18531,8*0.,
     4        0.     ,-7.11215,11*0./
      data p/11.24094,10.03904,14.49470,25.1486 ,25.969838,29.38896,
     1 30.78765,25.41389, 8.785412, 6.5   , 5.8   ,2*0.,
     2        0.   , 3.75665, -1.47089,-41.1538, -16.934118,-21.40656,
     2-23.25415,-17.69722,-0.7495294, 4*0.,
     3       -4.09689,-13.67046, 0.0  ,51.9932,9*0.,
     4        0.     , 0.      , 0.     ,-26.6083,9*0./
      data s/ 3.56454, 0.      , 8.16616,12.9303 ,20.768902,17.70732,
     1 15.24213,5.750203, 6.706232, 3.75   , 3.36   ,2*0.,
     2        0.     , 0.      ,-1.58206,-21.2590,-16.531471,-13.50652,
     2-11.08553,-1.274202,-2.248585, 4*0.,
     3       -3.45241, 0.      , 0.0    ,27.8988 ,9*0.,
     4        0.     , 0.      , 0.     ,-14.1080,9*0./
      data xn,rn,vn/6371.,.18125793,.14598326/,i/1/
c
      x=amax1(x0,0.)
      x1=xn*x
 2    if(x1.ge.r(i)) go to 1
      i=i-1
      go to 2
 1    if(x1.le.r(i+1).or.i.ge.11) go to 3
      i=i+1
      if(i.lt.11) go to 1
 3    ro=rn*(d(i,1)+x*(d(i,2)+x*(d(i,3)+x*d(i,4))))
      vp=vn*(p(i,1)+x*(p(i,2)+x*(p(i,3)+x*p(i,4))))
      vs=vn*(s(i,1)+x*(s(i,2)+x*(s(i,3)+x*s(i,4))))
      return
      end

c**********************************************************************
c   ellipticity correction routine
c
c   polynomial fit of corrections given by Dziewonski & Gilbert (GRAS
c   44, p7-17, 1975)
c
c   Barry Lienert 6/94                                          
c
c   inputs:  xs    geocentric long, lat(rad) and depth (km) of station
c            xh    geocentric long, lat(rad) and depth (km) of event
c            phase      P, PKP, PcP, etc                   
c
c   the current phase list is P, PKPab, PKPbc, PKiKP, PcP, S, ScS, SkS
c   for all other phases (except PKPdf - set to PKPab value), the 
c   correction returned is zero

c   function returns the correction in seconds to be added to travel
c   time calculated on the geocentric sphere (radius = 6371 km for
c   IASP91)
c                                  
c 10/94: changed to include station elevation correction

      function ellipcor(xs,xh,phase)
      save
      parameter (pi = 3.14159265)
      character*8 phase
      dimension coeff(9,3),tau(3),xs(*),xh(*)
      slat=xs(2)
      slon=xs(1)
      eqlat=xh(2)
      eqlon=xh(1)

c 10/93 subtract station elevation (relative to sea level)
      depth=xh(3)-xs(3)                                  
      
      if(phase.eq.'P       ')then
        ndeg=9
c   0 km
        if(depth.le.150.)then
          coeff(1,1)=-.000767752
          coeff(2,1)=-.0320965
          coeff(3,1)=-.00115385
          coeff(4,1)=.000129038
          coeff(5,1)=-4.44838e-6
          coeff(6,1)=8.20844e-8
          coeff(7,1)=-8.55154e-10
          coeff(8,1)=4.70402e-12
          coeff(9,1)=-1.06106e-14
          coeff(1,2)=-.00097755
          coeff(2,2)=-.000891082
          coeff(3,2)=-.000462451
          coeff(4,2)=1.74278e-6
          coeff(5,2)=2.79534e-7
          coeff(6,2)=-6.33865e-9
          coeff(7,2)=7.10643e-11
          coeff(8,2)=-4.25976e-13
          coeff(9,2)=1.04665e-15
          coeff(1,3)=-.000505837
          coeff(2,3)=.00211507
          coeff(3,3)=-.000403287
          coeff(4,3)=1.30399e-5
          coeff(5,3)=-4.07861e-7
          coeff(6,3)=7.18521e-9
          coeff(7,3)=-6.69335e-11
          coeff(8,3)=3.19871e-13
          coeff(9,3)=-6.13161e-16

c   300 km
        elseif(depth.le.475.)then
          coeff(1,1)=-.118157
          coeff(2,1)=-.0021144
          coeff(3,1)=-.00265186
          coeff(4,1)=.000163171
          coeff(5,1)=-4.69022e-6
          coeff(6,1)=7.79931e-8
          coeff(7,1)=-7.59002e-10
          coeff(8,1)=3.97837e-12
          coeff(9,1)=-8.64924e-15
          coeff(1,2)=-.0025971
          coeff(2,2)=-.0296334
          coeff(3,2)=.00271935
          coeff(4,2)=-.000164528
          coeff(5,2)=5.03298e-6
          coeff(6,2)=-8.46223e-8
          coeff(7,2)=8.1276e-10
          coeff(8,2)=-4.18461e-12
          coeff(9,2)=8.94339e-15
          coeff(1,3)=-.00137649
          coeff(2,3)=.00443056
          coeff(3,3)=-.000831244
          coeff(4,3)=4.05234e-5
          coeff(5,3)=-1.35084e-6
          coeff(6,3)=2.58875e-8
          coeff(7,3)=-2.79035e-10
          coeff(8,3)=1.58907e-12
          coeff(9,3)=-3.71079e-15

c   650 km
        else
          coeff(1,1)=-.260749
          coeff(2,1)=.00635749
          coeff(3,1)=-.00196931
          coeff(4,1)=.000102862
          coeff(5,1)=-2.65079e-6
          coeff(6,1)=4.10708e-8
          coeff(7,1)=-3.84205e-10
          coeff(8,1)=1.96951e-12
          coeff(9,1)=-4.22157e-15
          coeff(1,2)=-.00100326
          coeff(2,2)=-.0560922
          coeff(3,2)=.00428337
          coeff(4,2)=-.00019472
          coeff(5,2)=4.88834e-6
          coeff(6,2)=-7.01321e-8
          coeff(7,2)=5.85605e-10
          coeff(8,2)=-2.65545e-12
          coeff(9,2)=5.0413e-15
          coeff(1,3)=-8.08438e-6
          coeff(2,3)=.00181273
          coeff(3,3)=-.000443844
          coeff(4,3)=1.2112e-5
          coeff(5,3)=-3.18625e-7
          coeff(6,3)=5.78808e-9
          coeff(7,3)=-6.46629e-11
          coeff(8,3)=4.08766e-13
          coeff(9,3)=-1.08792e-15
        endif

c 6/94 removed PKPdf - occurs outside of fitted range
      elseif(phase.eq.'PKPab   ')then
        ndeg=6
        if(depth.le.150.)then
          coeff(1,1)=-862.874   
          coeff(2,1)=21.6945  
          coeff(3,1)=-.204365  
          coeff(4,1)=.000853327
          coeff(5,1)=-1.33332e-6
          coeff(6,1)=0
          coeff(1,2)=23711.5   
          coeff(2,2)=-750.896   
          coeff(3,2)=9.50569    
          coeff(4,2)=-.0601236 
          coeff(5,2)=.000190001
          coeff(6,2)=-2.40001e-7
          coeff(1,3)=5559.15   
          coeff(2,3)=-174.183 
          coeff(3,3)=2.18112    
          coeff(4,3)=-.0136466 
          coeff(5,3)=4.26665e-5 
          coeff(6,3)=-5.33331e-8

c   300 km
        elseif(depth.le.475.)then
          coeff(1,1)=-10306.5
          coeff(2,1)=327.611  
          coeff(3,1)=-4.16407  
          coeff(4,1)=.0264531  
          coeff(5,1)=-8.39993e-5
          coeff(6,1)=1.06666e-7
          coeff(1,2)=25.4467  
          coeff(2,2)=-.435782 
          coeff(3,2)=.00270001
          coeff(4,2)=-5.92594e-6
          coeff(5,2)=0
          coeff(6,2)=0
          coeff(1,3)=1963.21   
          coeff(2,3)=-66.3119 
          coeff(3,3)=.892319    
          coeff(4,3)=-.00598345
          coeff(5,3)=2.00004e-5 
          coeff(6,3)=-2.66672e-8

c   650 km
        else
          coeff(1,1)=-435.899
          coeff(2,1)=10.9575  
          coeff(3,1)=-.103083  
          coeff(4,1)=.000428888
          coeff(5,1)=-6.66666e-7
          coeff(6,1)=0
          coeff(1,2)=-193.614  
          coeff(2,2)=5.04239  
          coeff(3,2)=-.0486415
          coeff(4,2)=.000207777
          coeff(5,2)=-3.33332e-7
          coeff(6,2)=0
          coeff(1,3)=-187.962   
          coeff(2,3)=4.85321  
          coeff(3,3)=-.0472418  
          coeff(4,3)=.000204815
          coeff(5,3)=-3.33334e-7
          coeff(6,3)=0
        endif

      elseif(phase.eq.'PKPbc   ')then
        ndeg=3
        if(depth.le.150.)then
          coeff(1,1)=17.2001    
          coeff(2,1)=-.219001 
          coeff(3,1)=.000600004
          coeff(1,2)=-23.61    
          coeff(2,2)=.344   
          coeff(3,2)=-.0012     
          coeff(1,3)=-7.64     
          coeff(2,3)=.079 
          coeff(3,3)=-.0002     

c   300 km
        elseif(depth.le.475.)then
          coeff(1,1)=17.0299 
          coeff(2,1)=-.216999
          coeff(3,1)=.000599997
          coeff(1,2)=-23.61   
          coeff(2,2)=.344 
          coeff(3,2)=-.0012
          coeff(1,3)=-7.34     
          coeff(2,3)=.077 
          coeff(3,3)=-.0002     

c   650 km
        else
          coeff(1,1)=12.5    
          coeff(2,1)=-.156  
          coeff(3,1)=.0004  
          coeff(1,2)=-18.96  
          coeff(2,2)=.283  
          coeff(3,2)=-.001
          coeff(1,3)=-11.98   
          coeff(2,3)=.138  
          coeff(3,3)=-.0004  
        endif
      
      elseif(phase.eq.'PcP     ')then
        ndeg=5
        if(depth.le.150.)then
          coeff(1,1)=-1.51245   
          coeff(2,1)=1.58267e-6
          coeff(3,1)=.000538697
          coeff(4,1)=-5.40473e-6
          coeff(5,1)=9.3899e-9
          coeff(1,2)=.00152695 
          coeff(2,2)=-.0231172  
          coeff(3,2)=3.39633e-5 
          coeff(4,2)=6.44827e-6
          coeff(5,2)=-4.0056e-8
          coeff(1,3)=-.0032619 
          coeff(2,3)=.00104715
          coeff(3,3)=-.000371238
          coeff(4,3)=3.41724e-6
          coeff(5,3)=-5.99615e-9

c   300 km
        elseif(depth.le.475.)then
          coeff(1,1)=-1.34528
          coeff(2,1)=-.00390254
          coeff(3,1)=.000672213
          coeff(4,1)=-7.16257e-6
          coeff(5,1)=1.7189e-8
          coeff(1,2)=6.24639e-6
          coeff(2,2)=-.0242644
          coeff(3,2)=6.41413e-5
          coeff(4,2)=6.05076e-6
          coeff(5,2)=-3.82367e-8
          coeff(1,3)=-.00376741
          coeff(2,3)=.00105237
          coeff(3,3)=-.00037939 
          coeff(4,3)=3.59635e-6
          coeff(5,3)=-7.14236e-9

c   650 km
        else
          coeff(1,1)=-1.25364
          coeff(2,1)=-.000760161
          coeff(3,1)=.000576945
          coeff(4,1)=-5.94543e-6
          coeff(5,1)=1.17353e-8
          coeff(1,2)=-.00452048
          coeff(2,2)=-.0247656
          coeff(3,2)=6.89416e-5
          coeff(4,2)=5.95524e-6
          coeff(5,2)=-3.74576e-8
          coeff(1,3)=-.00332639 
          coeff(2,3)=.000729309
          coeff(3,3)=-.000362487
          coeff(4,3)=3.25262e-6
          coeff(5,3)=-4.94785e-9
        endif

      elseif(phase.eq.'S       ')then
        ndeg=7
        if(depth.le.150.)then
          coeff(1,1)=-.00159755 
          coeff(2,1)=-.065464 
          coeff(3,1)=.000393594
          coeff(4,1)=2.9408e-5
          coeff(5,1)=-5.74291e-7
          coeff(6,1)=3.98649e-9
          coeff(7,1)=-1.02641e-11
          coeff(1,2)=.00310562 
          coeff(2,2)=-.00111105 
          coeff(3,2)=-.00108956 
          coeff(4,2)=2.15437e-5
          coeff(5,2)=-1.17914e-7
          coeff(6,2)=3.62493e-10
          coeff(7,2)=-1.46172e-12
          coeff(1,3)=-8.13873e-5
          coeff(2,3)=.0031144 
          coeff(3,3)=-.000578018
          coeff(4,3)=8.49368e-6
          coeff(5,3)=-1.29615e-7
          coeff(6,3)=1.23587e-9
          coeff(7,3)=-3.8947e-12

c   300 km
        elseif(depth.le.475.)then
          coeff(1,1)=-.20426
          coeff(2,1)=-.0217636
          coeff(3,1)=-.00157197
          coeff(4,1)=7.68349e-5
          coeff(5,1)=-1.1999e-6
          coeff(6,1)=8.21411e-9
          coeff(7,1)=-2.16709e-11
          coeff(1,2)=-.0193939
          coeff(2,2)=-.0309887
          coeff(3,2)=.00105685
          coeff(4,2)=-4.59348e-5
          coeff(5,2)=9.39567e-7
          coeff(6,2)=-7.66655e-9
          coeff(7,2)=2.20597e-11
          coeff(1,3)=-.000953789
          coeff(2,3)=.00472556
          coeff(3,3)=-.000797555
          coeff(4,3)=1.65455e-5
          coeff(5,3)=-2.64495e-7
          coeff(6,3)=2.30252e-9
          coeff(7,3)=-7.09337e-12

c   650 km
        else
          coeff(1,1)=-.466331
          coeff(2,1)=.000529105
          coeff(3,1)=-.00154431
          coeff(4,1)=5.67141e-5
          coeff(5,1)=-7.35948e-7
          coeff(6,1)=4.03289e-9
          coeff(7,1)=-8.14629e-12
          coeff(1,2)=-.0170655 
          coeff(2,2)=-.0793724
          coeff(3,2)=.00420797
          coeff(4,2)=-.000134252
          coeff(5,2)=2.18743e-6
          coeff(6,2)=-1.6348e-8
          coeff(7,2)=4.56869e-11
          coeff(1,3)=.00106618  
          coeff(2,3)=.00249243
          coeff(3,3)=-.000629529
          coeff(4,3)=9.36621e-6
          coeff(5,3)=-1.2012e-7
          coeff(6,3)=9.80553e-10
          coeff(7,3)=-2.60446e-12
        endif

      elseif(phase.eq.'ScS     ')then
        ndeg=7
        if(depth.le.150.)then
          coeff(1,1)=-2.74057   
          coeff(2,1)=.000616927
          coeff(3,1)=.00066294 
          coeff(4,1)=3.43379e-6
          coeff(5,1)=-1.86419e-7
          coeff(6,1)=1.23651e-9
          coeff(7,1)=-2.12018e-12
          coeff(1,2)=.000242482
          coeff(2,2)=-.0393147  
          coeff(3,2)=-.00029074 
          coeff(4,2)=2.6228e-5 
          coeff(5,2)=-3.4253e-7
          coeff(6,2)=2.34549e-9
          coeff(7,2)=-7.76302e-12
          coeff(1,3)=.000891464
          coeff(2,3)=.000161816
          coeff(3,3)=-.000580489
          coeff(4,3)=4.37621e-6
          coeff(5,3)=-1.06131e-8
          coeff(6,3)=3.0902e-10
          coeff(7,3)=-2.14893e-12

c   300 km
        elseif(depth.le.475.)then
          coeff(1,1)=-2.50928
          coeff(2,1)=-.00142982
          coeff(3,1)=.000978636
          coeff(4,1)=-1.03682e-5
          coeff(5,1)=8.66059e-8
          coeff(6,1)=-1.30288e-9
          coeff(7,1)=6.87284e-12
          coeff(1,2)=3.86162e-5
          coeff(2,2)=-.041681 
          coeff(3,2)=-.000125393
          coeff(4,2)=1.88057e-5
          coeff(5,2)=-1.8032e-7
          coeff(6,2)=6.84434e-10
          coeff(7,2)=-1.36169e-12
          coeff(1,3)=.00106879 
          coeff(2,3)=-.000195485
          coeff(3,3)=-.000520055
          coeff(4,3)=1.15282e-6
          coeff(5,3)=5.66433e-8 
          coeff(6,3)=-3.07556e-10
          coeff(7,3)=-5.74159e-14

c   650 km
        else
          coeff(1,1)=-2.27944
          coeff(2,1)=-.00101086
          coeff(3,1)=.000890774
          coeff(4,1)=-4.4587e-6
          coeff(5,1)=-6.93411e-8
          coeff(6,1)=4.45341e-10
          coeff(7,1)=-1.17211e-13
          coeff(1,2)=-.000300892
          coeff(2,2)=-.0442828
          coeff(3,2)=1.42522e-5
          coeff(4,2)=1.28274e-5
          coeff(5,2)=-4.56e-8
          coeff(6,2)=-7.7526e-10
          coeff(7,2)=4.63287e-12
          coeff(1,3)=.000920091 
          coeff(2,3)=-.000135877
          coeff(3,3)=-.000509683
          coeff(4,3)=-4.07251e-7
          coeff(5,3)=1.07329e-7
          coeff(6,3)=-9.48686e-10
          coeff(7,3)=2.75919e-12
        endif

      elseif(phase.eq.'SKS     ')then
        ndeg=7
        if(depth.le.150.)then
          coeff(1,1)=54.3423   
          coeff(2,1)=-3.88174 
          coeff(3,1)=.109657  
          coeff(4,1)=-.00161249
          coeff(5,1)=1.31439e-5
          coeff(6,1)=-5.66686e-8
          coeff(7,1)=1.00996e-10
          coeff(1,2)=-13.3418
          coeff(2,2)=.810794   
          coeff(3,2)=-.0221222  
          coeff(4,2)=-.00031254
          coeff(5,2)=-2.31667e-6
          coeff(6,2)=8.68295e-9
          coeff(7,2)=-1.32088e-11
          coeff(1,3)=2.55499   
          coeff(2,3)=-.236244 
          coeff(3,3)=.00751661  
          coeff(4,3)=-.000132837
          coeff(5,3)=1.23634e-6 
          coeff(6,3)=-5.63696e-9
          coeff(7,3)=9.99772e-12

c   300 km
        elseif(depth.le.475.)then
          coeff(1,1)=38.8272
          coeff(2,1)=-2.55553 
          coeff(3,1)=.0662939  
          coeff(4,1)=-.000892496
          coeff(5,1)=6.66681e-6
          coeff(6,1)=-2.65247e-8
          coeff(7,1)=4.403e-11
          coeff(1,2)=-7.85805 
          coeff(2,2)=.391446 
          coeff(3,2)=-.00944131
          coeff(4,2)=.000115228
          coeff(5,2)=-6.41705e-7
          coeff(6,2)=1.30509e-9
          coeff(7,2)=0
          coeff(1,3)=7.60246   
          coeff(2,3)=-.500365 
          coeff(3,3)=.013152    
          coeff(4,3)=-.000196341
          coeff(5,3)=1.64085e-6 
          coeff(6,3)=-7.04163e-9
          coeff(7,3)=1.21076e-11

c   650 km
        else
          coeff(1,1)=19.2705
          coeff(2,1)=-1.38981 
          coeff(3,1)=.0377979  
          coeff(4,1)=-.000522355
          coeff(5,1)=3.97266e-6
          coeff(6,1)=-1.61102e-8
          coeff(7,1)=2.73351e-11
          coeff(1,2)=-13.4103  
          coeff(2,2)=.798484  
          coeff(3,2)=-.021582
          coeff(4,2)=.000302366
          coeff(5,2)=-2.21747e-6
          coeff(6,2)=8.20113e-9
          coeff(7,2)=-1.22915e-11
          coeff(1,3)=8.46482   
          coeff(2,3)=-.535302 
          coeff(3,3)=.0134536  
          coeff(4,3)=-.000191011
          coeff(5,3)=1.51973e-6
          coeff(6,3)=-6.201e-9
          coeff(7,3)=1.00894e-11
        endif

      
      else
       ellipcor=0.0
       return
      endif   
        
      call delaz(slat, slon, dekm, dedeg, az0, eqlat, eqlon)
      baz=az0*pi/180.
      do i=1,3
        tau(i)=0.0
        do j=1,ndeg
          tau(i)=tau(i)+coeff(j,i)*dedeg**(j-1)  
        end do
      end do                               
c      write(*,*)dedeg,tau(1),tau(2),tau(3)
      colat=.5*pi-eqlat
      ellipcor=.25*(1.+3.*cos(2.*colat))*tau(1)+.8660254*sin(2.*
     &colat)*cos(baz)*tau(2)+.8660254*sin(2.*colat)**2*
     &cos(2.*baz)*tau(3)
c      ellipcor=0.0
c      write(*,*)phase,dedeg,ellipcor 
      return
      end

      real function plgndr(l,m,x)
      integer l,m
      integer i,ll
      real fact,pll,pmm,pmmp1,somx2
      if(m.lt.0.or.m.gt.l.or.abs(x).gt.1.)pause
     *'bad arguments in plgndr'
      pmm=1.
      if(m.gt.0) then
        somx2=sqrt((1.-x)*(1.+x))
        fact=1.
        do 11 i=1,m
          pmm=-pmm*fact*somx2
          fact=fact+2.
11      continue
      endif
      if(l.eq.m) then
        plgndr=pmm
      else
        pmmp1=x*(2*m+1)*pmm
        if(l.eq.m+1) then
          plgndr=pmmp1
        else
          do 12 ll=m+2,l
            pll=(x*(2*ll-1)*pmmp1-(ll+m-1)*pmm)/(ll-m)
            pmm=pmmp1
            pmmp1=pll
12        continue
          plgndr=pll
        endif
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ">29,)KL4.
        

c$debug
c
c    program for reading eqrisk output file and making 
c    a file sutible for epimap for plotting
c
c    jh jun 95
c
c    changes:
c    june 99 jh  : ----------  version 7.0 -------------------
c                 add version call
c
      implicit none
      real lat(5000),lon(5000)            ! latitude and longitude
      real minlat,maxlat,minlon,maxlon    ! extreme -----------
      integer nlat,nlon                   ! number of gridpoints ---
      integer ncon                        ! number of contours
      character*80 infile     ! input file name
      character*80 text(100)  ! help text
      character*80 textt      ! text
      character*63 help(10)   ! more help text
      real levels(6,5000)     ! intensity levels for different return periods
      integer ntypes          ! number of types of output pgv,pga etc
      integer nfiles          ! number of files for output
      integer nvalues         ! total number of values
      real   oldlat,oldlon    ! help variable
      real xnumber(14)        ! contour levels to plot
      real risks(6)           ! risks, max 6
      real del_level          ! level division
      character*10 xlevel (20)! contour levels to plot
      real   maxlevel,minlevel ! extreme levels
      integer i,j,k,n,l,nout,nlevel,kstart
      data xnumber /0.01,0.02,0.05,0.1,0.2,0.5,1.0,2.0,5.0,10.0,
     *              20.0,50.0,100.0,200.0/


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      help(1)=
     *' This file is input for epimap contour plotting. The input of   '
      help(2)=
     *' parameters must appear as listed below with the actual data    '
      help(3)=
     *' starting after the line Fields to use. There can be any        '
      help(4)=
     *' number of header lines. The contour values plotted are         '
      help(5)=
     *' plotted with the number of decimals given below. The last      '
      help(6)=
     *' part of the file is the actual longitudes, latiudes and        '
      help(7)=
     *' levels. Color use is optional and the field can be left        '
      help(8)=
     *' blank, the codes are as follows:                              '
      help(9)=
     *'                                                               '
      help(10)=
     *' 1: blue   2: green   3: red   4: yellow   5: white   6: black '

c
      ncon=10
      write(6,*) ' Input file name'
      read(5,'(a)') infile
      open(1,file=infile,status='old')
c
c   read some text
c
      do i=1,14
        read(1,'(a)') text(i)
      enddo
c
      i=1
c
c   read lon lat points and levels
c
 100  continue
      read(1,'(a)',end=102) textt
      if(textt(2:26).eq.'RESULTS FOR SITE LOCATION') then
         read(textt(28:47),'(2f10.2)') lon(i),lat(i)
c
c   read forward to intensity
c
 101     continue
         read(1,'(a)',end=102) textt
         if(textt(18:22).eq.'RISKS') then
             read(textt(25:80),'(6f9.6)') risks
             read(1,'(a)',end=102) textt
             read(1,'(a)',end=102) textt
             read(textt(25:80),'(6f9.2)')(levels(k,i),k=1,6)
             i=i+1
c             write(6,*) lon(i-1),lat(i-1)
         else
             goto 101
         endif
      endif
      goto 100
c
c   end of input
c
 102  continue
      nvalues=i-1
      write(6,*) ' Number of points', nvalues
c
c   find how many risk levels which is the same as number of output files
c
      do k=1,6
         if(risks(k).eq.0.0) then
            nfiles=k-1
            goto 103
         endif
      enddo
 103  continue
      write(6,*)' Number of risk levels', nfiles
c
c   open output files
c
      textt(1:11)='eqrsei1.out'
      do k=1,nfiles
         write(textt(7:7),'(i1)') k
         open(k+9,file=textt(1:11),status='unknown')
      enddo
c
c   find range
c
      nlat=0
      nlon=0
      maxlon=-500.0
      minlon=500.0
      maxlat=-500.0
      minlat=500.0
      oldlat=-999.0
c
      do i=1,nvalues
         if(lat(i).lt.minlat) minlat=lat(i)
         if(lat(i).gt.maxlat) maxlat=lat(i)
         if(lon(i).gt.maxlon) maxlon=lon(i)
         if(lon(i).lt.minlon) minlon=lon(i)
         if(lat(i).ne.oldlat) nlat=nlat+1
         oldlat=lat(i)
      enddo
      write(6,*)' Min and max lat', minlat,maxlat
      write(6,*)' Min and max lon', minlon,maxlon 
      write(6,*)' Number of latitude points', nlat
c
      oldlon=lon(1)
      do i=1,nvalues
c	    write(6,*)oldlon,lon(i)
        if(lon(i).lt.oldlon) then
          nlon=i-1
          goto 105
        endif
        oldlon=lon(i)
      enddo
 105  continue
c
      write(6,*)' Number of longitude points', nlon
c
c   write out
c
c
c  write help text in files
c
      do k=10,nfiles+9
	    nlevel=k-9
        write(k,'(a)') (text(i),i=1,14)
        write(k,'(a)') (help(i),i=1,10)
        maxlevel=0
        minlevel=5000.0
        do i=1,nvalues
           if(levels(nlevel,i).gt.maxlevel) maxlevel=
     *     levels(nlevel,i)
           if(levels(nlevel,i).lt.minlevel) minlevel=
     *     levels(nlevel,i)
        enddo
        write(6,*) ' Min and max level = ',minlevel,maxlevel
        write(k,*)
        write(k,'(a,2f10.4)') ' Min and max level',minlevel,maxlevel
        write(k,*)
c
c   find levels to use
c
        del_level=(maxlevel-minlevel)/float(ncon)
        do i=1,14
          if(xnumber(i).ge.del_level) then
             del_level=xnumber(i)
             goto 20
          endif
        enddo
 20     continue  
c
c   write levels in xlevel with appropiate accuracy
c
         do i=1,ncon
           if(del_level.lt.0.1)  then
              write(xlevel(i),'(3x,f5.2)') del_level*i+minlevel
              goto 30
           endif
           if(del_level.lt.1.0)  then 
              write(xlevel(i),'(3x,f5.1)') del_level*i+minlevel
              goto 30
           endif
           if(del_level.lt.1000.)  then
              write(xlevel(i),'(3x,i3)') int(del_level*i+minlevel)
           endif
         enddo
 30      continue
c
         write(k,'(a,a)')
     *  ' Fields to use                         ',
     *  ' I.........I.........I.........I   '
        write(k,'(a,2f10.2,i9)')
     *' Latitude range and number of values    ',
     *  minlat,maxlat,nlat
        write(k,'(a,2f10.2,i9)')
     *' Lontitude range and number of values   ',
     *  minlon,maxlon,nlon
        do l=1,ncon
           write(k,'(a,a10)')
     *     ' Contour level to plot and color        ',xlevel(l)
        enddo
c
c   write contours
c
      do l=1,nvalues
        write(k,*)lon(l),lat(l),levels(nlevel,l)
      enddo
      enddo
      write(6,*)' Output files are eqrsei1.out,',
     *' eqrsei2.out, eqrsei3.out, etc'
      stop
      end

        

c$debug
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  smars88
c
c  conversion from SEISAN binary to SMARS88
c  and convert response information to GSE1 format
c
c  by Lars Ottemoeller Mar 1997
c
c        1         2         3         4         5         6         7
c23456789012345678901234567890123456789012345678901234567890123456789012
c
c  input arguments:
c
c      1: input filename   2: mars88 filesystem name   
c      3: response (y/n)
c  last changes:
c
c   ------------- Version 7 --------------
c 01.10.99 lo: take out response option
c 
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      implicit none
      include  'seidim.inc'                 ! Dimensions.
      include  'libsei.inc'                 ! Library defns.
      external sei open,                    ! Open file handler.
     &         sei close,                   ! Close file handler.
     &         sei code,                    ! Error handler.
     &         resp_sei2gse,                ! response conversion to GSE
     &         get_arguments                ! get args
      integer  write01,                     ! Read/write unit.
     &         code                         ! Condition.
      logical   b_flag                      ! File i/o flag

      real    data (max_sample)             ! the data
c     integer idata (max_sample)            ! integer data
      integer            iunit              ! input unit
      integer nchan,nsamp
      character*80      filehead(max_trace)
      character*1040    tracehead
      logical pc,sun,linux                  ! computer type
      character*80 infile,question          ! input filename
      character*12 outfile                  ! 
c counter
      integer c,cout
      character*3 number
      character*9 filesystem,system       ! MARS88 files
c traceheader info
      real srate                             ! sample rate
      integer israte                         ! sample interval in milliseconds
      integer year,month,day,hour,min        !time
      real sec
      real lat,long                          ! station location
      integer height                         ! station height                   
      character*4 station                    ! station name
      character*4 comp                       ! component SEISAN
      integer ind                            ! index
      character*1 resp                       ! response wanted (y/n)
      character*1 overwrite                  ! overwrite responsefile
      integer nars                           ! number of args
      character*80 args(5)                   ! arguments
      character*240 aoutline                 ! header of ASCII out
      character*26 aouttime                  ! time in ASCII out
      integer in                             ! 1 for filenr.lis
      integer filec                          ! counting files of filenr.lis
      integer indf                           ! length of filesystem

c     common /signal/data,rotate,baz,rot_comp,del_rot !for seisinc
      common /signalx/data


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      overwrite='n'

c get arguments
      call get_arguments(nars,args)

  1   format(a,$) 

      filesystem = ' '
      filec=0 
      call computer_type(sun,pc,linux)
      if (nars.ne.0) then
        infile=args(1) 
        filesystem(1:8)=args(2)(1:8)
        resp=args(3)(1:1)
        goto 23
      endif

      write(*,*) 'Conversion SEISAN -> MARS88'
      write(*,*)

      filesystem(9:9)=' '

21    continue
      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)

      if (infile(1:3).eq.'EOF') STOP
      if(infile(1:10).eq.'filenr.lis') then
        open(1,file='filenr.lis',status='old',err=22)
        in=1
      endif
      goto 23

22    continue

      write(*,*) ' filenr.lis not found'
      stop

23    continue

      filesystem(1:4)='mars'
      indf=4
      if (in.eq.1) then 
         read(1,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
         filec=filec+1
         write(filesystem(indf+1:indf+4),'(i4)') filec
         do c=1,indf+3
           if (filesystem(c:c).eq.' ') filesystem(c:c)='0'
         enddo
      endif

c        write(*,*) 'extract response in GSE1 format (y/n) ? '
c        read(*,'(a1)') resp
         resp = 'n'

29    continue
 
      system=filesystem




      write(6,'(1x,a)') infile
c                  
c    Open input file...  
c    ------------------
c              

      chr_f_access$ = 'direct'            ! Type of file.
      f_recl$=2048                        ! Record length
      call sei open( old$,                      !JAB(BGS)Mar95. Open file.
     &               ' ',                       !JAB(BGS)Mar95. No prompt.
     &               infile,                    !JAB(BGS)Mar95. This filename.
     &               iunit,                     !JAB(BGS)Mar95. On unit.
     &               b_flag,                    !JAB(BGS)Mar95. Exists!!
     &               code )                     !JAB(BGS)Mar95. Condition (n/a).

c
c------- Read file headers ----------
       call seisinc
     * (iunit,0,nchan,0,filehead,tracehead,0.0,0.0)

c      do c=1,max_trace
c        write(*,*) filehead(c)
c      enddo

       do cout=1,nchan
         call seisinc
     *       (iunit,cout,nchan,2,filehead,tracehead,0.0,0.0)
c open file
         write(number,'(i3)') cout
         do c=1,3 
           if (number(c:c).eq.' ') number(c:c)='0'
         enddo
         ind=index(filesystem,' ')-1
         if (ind.lt.0) ind=8
         outfile = filesystem(1:ind) // '.' //number
         write01=50
         open(write01,file=outfile,status='unknown')

         write(*,*) tracehead(1:80)
         write(*,*) 'output file :  ',outfile
         if (resp.eq.'Y'.or.resp.eq.'y') then
           write(*,*) 'writing response in GSE1 format ... '
           call resp_sei2gse(tracehead,'2',overwrite)
         endif

 

c
c read and write header info
c

        read(tracehead(45:50),'(i6)') nsamp
        read(tracehead(37:43),'(f7.2)') srate
        read(tracehead(10:35),'(i3,5x,i2,1x,i2,1x,i2,1x,i2,1x,
     &     f6.3)') year,month,day,hour,min,sec
        read(tracehead(52:75),'(f8.4,1x,f9.4,1x,i5)')
     &           lat,long,height
        station(1:4)=tracehead(1:4)
        comp=tracehead(6:9)

        israte=int(1/srate*1000)
        write(aouttime(1:26),'(i4,a1,i2,a1,i2,1x,i2,a1,i2,a1,i2)')
     &    1900+year,'-',month,'-',day,hour,':',min,':',int(sec)
        write(aoutline,'(a,i3,a,a19,a,a)') 
     &    '# dev 0 samp ',israte
     &    ,' chno 0 scale 1 start ',aouttime(1:19),' expo 0 ',
     &    'lag -?- sync ''none'' counts: stop'
        ind=index(aoutline,' stop')
        write(write01,'(a)') aoutline(1:ind)

c#STATION_TYPE
c#STATION_COMMENT
c#STATION_LOCATION_NUMBER
c#INSTRUMENT_NUMBER
c#EVENT_COOR_1
c#EVENT_COOR_2
c#EVENT_COOR_3
c#EVENT_COOR_TYPE
c#EVENT_TIME
c#EVENT_COMMENT
c#EVENT_AZ
c#EVENT_BACK_AZ
c#EVENT_HYPO_DIST
c#EVENT_EPI_DIST
c#EVENT_TYPE
c#EVENT_LOCAL_MAG
c#EVENT_BODY_WAVE_MAG
c#EVENT_SURFACE_WAVE_MAG
c#EVENT_DURATION_MAG
c#EVENT_MOMENT_MAG


c write data
         do c=1,nsamp
c           idata(c)=data(c)

           write(write01,*) data(c)
         enddo
         
         close(write01)
      enddo
      call sei close( close$, iunit, code)

      if (in.eq.1) goto 23
      goto 21

9999  continue

      close(1)
      end

      subroutine bcd(bcd_byte,number)
c
c input one byte bcd coded byte,bcd_byte and return the
c corresponding 2 digit integer number
c
c changes:
c   sep 30, 99 lo: test under linux
c
c
      implicit none
      character*1 bcd_byte
      character*2 bcd2     ! input byte plus null byte
      integer number
      integer*2 bcd_number
      integer i1,i2
      logical sun,pc,linux  ! computer type
      equivalence (bcd2,bcd_number)
c
      call computer_type(sun,pc,linux)
c
c   must put one byte into 2 to be able to get the unsigned integer from
c   then highest 4 bits, swap if on sun
c
      if(pc.or.linux) then
         bcd2(1:1)=bcd_byte
         bcd2(2:2)=char(0)
      elseif (sun) then
         bcd2(2:2)=bcd_byte
         bcd2(1:1)=char(0)
      endif

c
      i2=bcd_number/16       ! get highest digit
      i1=bcd_number - 16*i2  ! get lowest digit
      number=i1+i2*10

c
      return
      end

c
c changes:
c
c sep 26 00 lo : use channel definition file to set components
c oct 23 00 lo : bug fix in write gse out
c feb 24 03 lo : add interactive flag to header_gse_to_seisan
c jan 28 08 lo : changed conversion of component code, seisan to gse
c sep 11 08 jh : new argumant  istart to find_resp


      subroutine write_seisan_to_gse(write1,k,wav_out,
     *     format_out)

c
c Input:
c
c   write1    :   output unit
c   k         :   channel index
c   wav_out   :   true if wav_out* variables set
c   format_out:   gse output format
c
c
c write out gse data from Seisan wave block
c
c Lars Ottemoeller, 12 May 2000
c
c
c changes
c

      implicit none
      include 'codeco_common.f'
      include 'seidim.inc'
      include 'waveform.inc'
      integer seiclen

      integer write1           ! write unit
      integer k                ! channel index
      logical wav_out          ! true if wav_out
      integer l                ! counter
      integer istart
      integer year,month,day,hour,min
      real sec
      double precision msec
      integer nsamp
      real rate
      character*5 stat
      character*4 comp,comp_org
      character*(*) format_out
c
c following variables for GSE output
c
      character*1 cbuf(c_bufsize)        ! gse ascii data
      integer*4 iy(c_sigsize)            ! gse integer data
      integer*4 ichecksum                ! gse checksum
      character*29 mainhead_text
      character*80 text
      character*5 net_code
      character*80 cal_file
      character*120 line


c
c   get def file for station codes, give file name
c
      text='gsesei.def'
      net_code=' '
      hdr_coosys='            '

      call read_def_chan(text,mainhead_text,net_code)

      if (wav_out) then
         year=wav_out_year(k)
         month=wav_out_month(k)
         day=wav_out_day(k)
         hour=wav_out_hour(k)
         min=wav_out_min(k)
         sec=wav_out_sec(k)
         nsamp=wav_out_nsamp(k)
         rate=wav_out_rate(k)
         stat=wav_stat(k)
         comp=wav_comp(k)
      else
         year=wav_year(k)
         month=wav_month(k)
         day=wav_day(k)
         hour=wav_hour(k)
         min=wav_min(k)
         sec=wav_sec(k)
         nsamp=wav_nsamp(k)
         rate=wav_rate(k)
         stat=wav_stat(k)
         comp=wav_comp(k)
      endif
      do l=1,nsamp
         iy(l)=int(signal1(l))
      enddo
c
c write to GSE header
c

      hdr_year=year
      hdr_month=month
      hdr_day=day
      hdr_hour=hour
      hdr_min=min
      hdr_sec=int(sec)
      hdr_msec=int((sec-int(sec))*1000)
      call timsec(year,month,day,hour,min,sec,msec)
c
c station location
c
      hdr_station = ' '
      hdr_station = stat(1:5)
      call stat_loc(stat,' ',
     *    hdr_stalat,hdr_stalon,hdr_staelev)
      hdr_chan = ' '

      comp_org=' '
      comp_org=comp
      call set_def_chan(1,stat(1:5),comp)
c      hdr_chan(1:3)=comp(1:3)
c lot 28/1/2008
      hdr_chan(1:3)=comp(1:2)//comp(4:4)
      
      hdr_stadescr= ' '
      hdr_nsamp=nsamp
      hdr_smprate=rate
      hdr_ifmtnum=0
      hdr_calunit=0
      hdr_calfac=1.
      hdr_calper=1.
      hdr_instr=' '
      hdr_network='         '
      hdr_stadepth=0.
      if (hdr_chan(3:3).eq.'Z'.or.hdr_chan(3:3).eq.'z') then
        hdr_hang=-1.
        hdr_vang=0.
      elseif (hdr_chan(3:3).eq.'N'.or.hdr_chan(3:3).eq.'n') then
        hdr_hang=0.
        hdr_vang=90.
      elseif (hdr_chan(3:3).eq.'E'.or.hdr_chan(3:3).eq.'e') then
        hdr_hang=90.
        hdr_vang=90.
      endif
c
c write input for gse2seed
c
      if (format_out(4:8).eq.'2SEED') then
         write(write1,'(a)') 'DATA_TYPE STATION GSE2.0'
             write(write1,'(a)')
     &'Sta   Type  Latitude  Longitude    Elev   On Date   Off Date'
cWN         51.51300   -1.80050   0.192
         write(write1,'(a5,6x,f9.5,1x,f10.5,1x,f7.3)')
     &     stat,hdr_stalat,hdr_stalon,hdr_staelev/1000.
         write(write1,'(a)')
         write(write1,'(a)') 'DATA_TYPE CHANNEL GSE2.0'
         write(write1,'(a)') 'Sta  Chan Aux   Latitude  Longitude'//
     &'    Elev  Depth   Hang  Vang Sample_Rate Inst     '//
     &'On Date   Off Date'
         write(write1,'(a5,1x,a3,6x,f9.5,1x,
     &          f10.5,1x,f7.3,9x,f5.1,1x,f5.1,1x,f11.6)')
     &     stat,hdr_chan,hdr_stalat,hdr_stalon,hdr_staelev/1000.,
     &     hdr_hang,hdr_vang,hdr_smprate

         write(write1,'(a)')
         write(write1,'(a)') 'DATA_TYPE RESPONSE GSE2.0'
c
c find response file
c
         call find_resp_file(stat,comp_org,msec,cal_file,istart)
         if (seiclen(cal_file).le.9) then
           write(*,*) ' GSE response required for SEED output, '
     &        //' station ',stat
           stop
         endif
         open(33,file=cal_file,status='old')
10       continue
         read(33,'(a)',end=20) line
         write(write1,'(a)') line(1:seiclen(line)) 
         goto 10
20       continue

         write(write1,'(a)') 
         write(write1,'(a)') 'DATA_TYPE WAVEFORM GSE2.0'
      endif

c
c select GSE format, default is CM6
c
      if (format_out(4:4).eq.' '.or.
     * format_out(4:6).eq.'CM6') then
        hdr_ofmtname='CM6'
        hdr_ofmtnum=2
        hdr_odiff=2
      elseif (format_out(4:6).eq.'INT'.or.
     *  format_out(4:8).eq.'2SEED') then
        hdr_ofmtname='INT'
        hdr_ofmtnum=2
        hdr_odiff=0
      endif
      if (format_out(4:10).ne.'2SEEDDL') then
        call gseout(write1,cbuf,iy,ichecksum)
      endif
      return
      end



      subroutine header_gse_to_seisan(ifile,ierr)
c
c read header from gse file and write to wav structure
c
c Lars Ottemoeller, 12 May 2000
c
      implicit none
      include 'codeco_common.f'
      include 'seidim.inc'
      include 'waveform.inc'
      integer k,i              ! channel id total and file, 
      integer ifile            ! wave file number
      character*1 cbuf(c_bufsize)        ! gse ascii data
      integer*4 iy(c_sigsize)            ! gse integer data
      integer*4 ichecksum                ! gse checksum
      integer*4 ierr                     ! gse error
      character*1 ch
      integer seiclen

      i=0
      k=wav_nchan     ! set total channel counter
      open(95,file=wav_filename(ifile),status='unknown')
      open(94,file='gsetemp.out',status='unknown')
 200  continue    ! read until end of file

c
c try to read first channel
c
      call gsein( 95, 94, cbuf, iy, ichecksum, ierr )
      if (ierr.ne.0) goto 250

      k = k + 1
      i = i + 1

      wav_year(k)=hdr_year
c use aux code as option, lo Nov 2001
      if (hdr_stadescr.ne.' '.and.seiclen(ch).lt.1) then
        if (wav_interactive) then
      write(*,*) ' aux station code not empty, use as station code? '
          read(5,'(a1)') ch
          call casefold(ch)
        else 
          ch='N'
        endif
      endif
      if (ch.eq.'Y') then
        wav_stat(k)=hdr_stadescr(1:4)
      else
        wav_stat(k)=hdr_station(1:5)
      endif
c      wav_stat(k)=hdr_station(1:5)
      wav_comp(k)(1:2)=hdr_chan(1:2)
      wav_comp(k)(3:3)=' '
      wav_comp(k)(4:4)=hdr_chan(3:3)
      wav_time_error(k)=' '
      wav_month(k)=hdr_month
      wav_day(k)=hdr_day
      wav_hour(k)=hdr_hour
      wav_min(k)=hdr_min
      wav_sec(k)=float(hdr_sec)+float(hdr_msec)/1000.
      wav_file_nr_chan(k)=ifile
      wav_chan_nr_file(k)=i
      call timsec(wav_year(k),wav_month(k),wav_day(k),
     *       wav_hour(k),wav_min(k),wav_sec(k),wav_abs_time(k))
      wav_nsamp(k)=hdr_nsamp
      wav_rate(k)=hdr_smprate
      wav_cbyte(k)='4'
      wav_duration(k)=(wav_nsamp(k)-1)/wav_rate(k)
      goto 200
 250  continue
      wav_nchan=k    ! save number of channels

      close(95)
      close(94)

      return
      end

c
c
c   special version of ttim for generating synthetic travel times
c   for use in mulplt
c
c
c  update 
c  dec 30 by jh: exclude more phases
c  jan 2       : stop after 150 phases
c  jan 3       : do not use dist in s-file
c  jul 25      : geographic to geocentric latitude, read from other header line
c  oct 26      : bug reading depth
c  dec 94       ************ version 5.0 *****************  no change
c  jan 95   jh : look for any station file, also alternative
c  mar 31, 95,jh: Fix bug if calculated phase is next day relative to o-time
c  may 23 95    : Now min 500 phases, generate more if just return
c  september 96 : write at least one blank line if no phases
c  feb 99    jh : ---------------   verison 7.0 -------------------------
c                 year and station modified, rm computer type
c  jul 24       : make a definitions file for phases
c  sep 09,   lo : dont calculate travel times if station not in station file
c  sep 26    jh : comment change,include all phases since selection now
c                 can be made with iasp.def
c  dec 07       : changed name of routine distaz to iasp_distaz
c  mar 01       : smal change in reading def phases
c
c   reads nordic file name from the environmnetal variable
c   get origin time, epicenter depth,  from nordic file
c   and calculates iasp times. Output is in a nordic file with name 
c   iasp.out. Calculate distance using STATION0.HYP
c   file for station coordinates.
c
      save
      parameter (max=100)
      logical prnt(3),outp
      character*8 phcd(max),phlst(10),oldphase
      character*80 modnam,comp_modnam
      dimension tt(max),dtdd(max),dtdh(max),dddp(max),mn(max),ts(max)
      dimension xcor(max),tcor(max),usrc(2)
      integer year,month,day,hour,min,nhead,nrecord,nphase,id
      integer pday,pmonth,pyear     ! date of seismic phase
      real sec
      character*80 infile           ! nordic file name
      integer hyear,hmonth,hday     ! header date
      character*1 typ,exp
      character*80 data(500)
c-- station and component
      character*5 stat,stat_old
      character*2 outcomp
	  charACTER*1 ANSWER
c-- directory separator
      character*1 dchar
      integer ndef                   ! number of phases in def file
      character*80 deffile           ! def file
      character*8 defphase(200)      ! defined phases for output
      character*80 text
      integer doy
      double precision psec,osec
c--- file exist
      logical exist
      character*60 top_directory
      integer seiclen
c      

      data in/33/,phlst(1)/'query'/,prnt(3)/.true./


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c      
      nphase=0
      oldphase='xxxxxxxx'
      call dir_char(dchar)
c
c   open out put file
c
      open(8,file='iasp.out',status='unknown')
      call topdir(top_directory)
      ITP=index(top_directory,' ')-1
c
c  get def file if it exists
c
      inquire(file='IASP.DEF',exist=exist)
      if(exist) then
         deffile='IASP.DEF'
      else
         deffile=
     *   top_directory(1:itp)//dchar//'DAT'//dchar//'IASP.DEF'
      endif
c
c   if def file, open and read
c
      ndef=0
      inquire(file=deffile,exist=exist)
      if(exist) then
        open(25,file=deffile,status='old')
 221    continue
        read(25,'(a)',end=222) text
        if(text(1:10).eq.'IASP-PHASE'.and. text(13:20).ne.' ') then
          ndef=ndef+1
          read(text(13:20),'(a8)') defphase(ndef)
        endif
        goto 221
 222    continue
        write(6,*) ' Number of defined phases ',ndef
        close(25)
      else
        write(6,*)' No IASP.DEF file, will use all phases'
      endif


c
c   get event file with hypocenter and distances
c
      call get_env_event(infile)
c
c   open and read event from data base
c
      open(21,file=infile,status='old')
c
c   set flag to indicate that only one event
c
      nrecord=-1
      CALL INDATA(21,NSTAT,NPHAS,NHEAD,NRECORD,TYP,EXP,DATA,id)
c
c    check if any hypocenter etc, first use first header line after first
c
      do i=2,nhead
        if(data(i)(80:80).eq.'1') then
           if(data(i)(17:20).eq.'    '.or. 
     *     data(i)(24:30).eq.'       '.
     *     or.data(i)(39:43).eq.'     ') then
              write(6,*)' Insufficient hypocenter info in second ',
     *        'header line'
              goto 3645   ! try main header
            else
              write(6,*)' Use second header line'
              goto 3646   ! read data
            endif
         endif
      enddo
 3645 continue
c
c   now check main header
c
        if(data(1)(17:20).eq.'    '.or. 
     *  data(1)(24:30).eq.'       '.
     *  or.data(1)(39:43).eq.'     ') then
           write(6,*)' Insufficient hypocenter info in main ',
     *     'header line'
          stop 
        endif
        write(6,*)' Use main header line'
        i=1

 3646 continue 
c
c   read header time, might be different from origin time
c
      read(data(1),'(1x,i4,1x,2i2)') hyear,hmonth,hday
c
c   read origin time
c
      read(data(i),'(1x,i4,1x,2i2,1x,2i2,1x,f4.1)') year,month,day,
     *hour,min,sec
c
c   read epicenter
      read(data(i)(24:38),'(f7.3,f8.3)') elat,elon
c
c   read depth
c
      read(data(i)(39:43),'(f5.1)') zs
c
c   gegraphic to geocentric lat
c
      call fold_lat(elat)
c
c   write header in output file, use s-file header
c
      write(8,'(1x,i4,1x,2i2,11x,a1,57x,a1)')hyear,hmonth,hday,'D','1'
c
c   calculate abs time
c
      call timsec(year,month,day,hour,min,sec,osec)

c
c
c   check for iaspei files
c
      call iasp91_filename(comp_modnam)
      inquire(file=comp_modnam
     &   (:seiclen(comp_modnam))//'.TBL',
     &    exist=exist)
      if(exist) then
         modnam=comp_modnam(1:seiclen(comp_modnam))//' '
      else
         modnam=
     *top_directory(1:itp)//dchar//'DAT'//dchar//
     *   comp_modnam(1:seiclen(comp_modnam))//' '
      endif
c
      iucff=25
      il=index(modnam,' ')-1
c     &recl=60)
      call assign(10,2,'ttim1.lis'//char(0))
c     call tabin(in,iucff,modnam)
      call tabin(in,modnam)
      prnt(1)=.false.
      prnt(2)=.false.
      phlst(1)='basic   '
	  phlst(2)='SS      '
      call brnset(2,phlst,prnt)
c
 3    continue 
c     call depset(zs,usrc,iucff)
      call depset(zs,usrc)
c
c
c
c-----------------------------------------------------------------------
c    make a station loop for calculating phases and writing out
c-----------------------------------------------------------------------
c
      stat_old='xxxxx'
      do irec=nhead+1,nrecord-1
         read(data(irec)(2:6),'(a5)') stat
c
c   do not calculate more than once for same station, assume follow each other
c
         if(stat.eq.stat_old) goto 888
         stat_old=stat
c
c  calculate distance
c
            call stat_loc(stat,data(1)(21:21),slat,slon,elev)
c
c   convert from geographic to geocentric coordinates
c
            call fold_lat(slat)
            call iasp_distaz (slat,slon,elat,elon,delta,azi,baz)
c           write(*,*) slat,slon,delta

c
c  check if loaction, otherwise skip station
c  
         if (slat.eq.0.and.slon.eq.0) then
           write(*,'(2a)') 'station not in station file: ',stat
           goto 888
         endif

         if(delta.lt.0.) go to 3
         call trtm(delta,max,n,tt,dtdd,dtdh,dddp,phcd)
         if(n.le.0) then 
            write(*,101)delta
 101        format(/1x,'No arrivals for delta =',f7.2)
            goto 888
         endif
c
         do 4 i=1,n
c
c   calculate time in hr min etc
c
           psec=tt(i)+osec
           call sectim(psec,pyear,doy,pmonth,pday,hour,min,sec)
c
c   check if next day relative to s-file header, then add 24 hours
c
           if(pyear.gt.hyear.or.pmonth.gt.hmonth.or.pday.gt.hday) 
     *     hour=hour+24
c
c   write to nordic file, but filter out more exotic phases in no
c   def file is given
c
           outcomp='  '
           if(ndef.gt.0) then   !case of def file
             outp=.false.
             do k=1,ndef
               if(phcd(i).eq.defphase(k)) outp=.true.
c              write(6,'(a,1x,a)') phcd(i),defphase(k)
c              if(outp) write(6,*) 'selectec'
             enddo
           else                 ! no def file
              outp=.true.
c             if(phcd(i)(1:6).eq.'pPKiKP') outp=.false.
c             if(phcd(i)(1:6).eq.'sPKiKP') outp=.false.
c             if(phcd(i)(1:4).eq.'SnSn') outp=.false.
           endif
           if(phcd(i).eq.oldphase) outp=.false.
           if(outp) then
		       nphase=nphase+1
			   if(nphase.eq.500) then
                  write(6,*)' You have now generated 500 phases'
                  write(6,*)' Continue (y=default/n)?'
                  read(5,'(a1)') answer
                  if(answer.eq.'n'.or.answer.eq.'N')
     *            stop
	           endif
               write(8,200)stat,outcomp,phcd(i)(1:8),
     +          hour,min,sec
                oldphase=phcd(i)
           endif
200        format(1x,a5,a2,1x,'y',a8,i2,i2,1x,f5.2)


           xcor(i)=0.
           tcor(i)=0.
           mn(i)=tt(i)/60.
           ts(i)=.01*int(100.*(tt(i)-mn(i)*60.)+.5)
           if(ts(i).lt.60.) go to 4
           mn(i)=mn(i)+1
           ts(i)=ts(i)-60.
 4       continue
 888     continue
c
c----------------------------------------------------------------------
      enddo
c----------------------------------------------------------------------
c
c
c   write at least one blank line
c
      write(8,*)' '
      write(6,*)nphase, ' phases generated' 
      call retrns(in)
      call retrns(10)
      call vexit(0)
      end

c
c   routine to calculate dist az in nordic file
      subroutine iasp_distaz (alat1,alon1,alat2,alon2, delta,azi,baz)
c
c Calculate angular distance, azimuth and backazimuth between two
c  points on a sphere.
c
c Input
c
c   ALAT1,ALON1  =  latitude and longitude of point 1.
c   ALAT2,ALON2  =  latitude and longitude of point 2.
c
c Output
c
c   DELTA  =  angular distance between points 1 and 2.
c   AZI    =  azimuth from north of point 2 w.r.t. point 1.
c   BAZ    =  azimuth from north of point 1 w.r.t. point 2.
c
c All arguments are in degrees.
c Latitude, longitude and DELTA are geocentric.
c Latitude is zero at equator and positive north.
c Longitude is positive toward the east.
c AZI and BAZ are positive and measured clockwise from local north.
c
c      implicit double precision (a-h,o-z)

c     real alat1,alat2,alon1,alon2,delta,azi,baz
      pi=3.14159265
      rtod=180./pi
      dtor=pi/180.
c
      rlat1 = dtor*alat1
      rlat2 = dtor*alat2
      rdlon = dtor*(alon2-alon1)
c
      clat1 = cos(rlat1)
      clat2 = cos(rlat2)
      slat1 = sin(rlat1)
      slat2 = sin(rlat2)
      cdlon = cos(rdlon)
      sdlon = sin(rdlon)
c
      cdel = slat1 * slat2 + clat1 * clat2 * cdlon
      cdel = min(cdel,1.0)
      cdel = max(cdel,-1.0)
      yazi = sdlon * clat2
      xazi = clat1 * slat2 - slat1 * clat2 * cdlon

      ybaz = -sdlon * clat1
      xbaz = clat2 * slat1 - slat2 * clat1 * cdlon
c
      delta = rtod * acos(cdel)
c     write(16,*)'delta ',delta
c      write(*,*)' xazi yazi ',xazi,yazi
      if(yazi.ne.0.0.or.xazi.ne.0.0)then
        azi = rtod * atan2(yazi,xazi)
        baz = rtod * atan2(ybaz,xbaz)
      else
        azi=0.0
        baz=0.0
      endif
      if (azi.lt.0.) azi=azi+360.
      if (baz.lt.0.) baz=baz+360.
c
      return
      end

      subroutine fold_lat(alat)
c
c-------- given geographic lat compute geocentric lat
c
c input:  la     degree portion of latitude in degrees
c         ins    n for north, s for south
c         ala    minutes portion of latitude
c         lo     degree portion of longitude
c         iew    e for east, w for west
c         alo    minutes portion of longitude
c output: alat   geocentric latitude in radians
c         alon   longitude in radians
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (equrad = 6378.2064)
      parameter (polrad = 6356.5838)
      parameter (flat = (equrad - polrad)/equrad)
      parameter (c1 = (1.0 - flat)**2)
      parameter (c2 = halfpi*(1.0/c1 - 1.0))
c
c
      alat = alat*rad
c  convert from geographic to geocentric latitude
      if (halfpi-abs(alat) .ge. 0.02) goto 201
         alat = alat/c1-sign(c2,alat)
         goto 202
  201    alat = atan(c1*tan(alat))
  202    continue
         alat=alat/rad
      return
      end

      subroutine auto_amp(y,n,rate,fmin,fmax,maxcros,
     *yfirst,ylast,ifirst,ilast)
c
c   determine maximum peak to peak amplitde and corresponding period
c   it is assumed that dc has been removed
c
c     input:  y:     data vector
c             n:     number of points in y
c             rate:  sample rate
c             fmin,fmax: frequency range to seach in
c             maxcros: max number of zero crossings between max and min amp
c
c     output: yfirst,ylast: extreme values found, can be positive or negative
c             ifirst,ilast: sample number of first and last extreme
c                           if ifirst is zero, no valid reading
c
c     j. havskov, december 2000
c
c
      implicit none
      real y(*)
      real yfirst,ylast
      real rate,fmin,fmax,ymin,ymax
      integer n,ifirst,ilast,maxcros
      real min_value,max_value         ! help variables
      integer n1,n2                    ! range of samples corresponding to
c                                        frequency band
      integer max_sign                 ! sign of max_value
      integer i,i1,i2,k                ! counters

      ifirst=0
      if(maxcros.eq.0) maxcros=1       ! at least one crossing
c
c   calculate sample range corresponding to frequency range, remember
c   range is only half the period
c
      
      if(fmax.eq.0.0) then
         n1=1                ! highest possible frequency
      else
         n1=rate/(fmax*2)
         if(n1.eq.0) n1=1
      endif
      if(fmin.eq.0) then
         n2=n
      else
         n2=rate/(fmin*2)
         if(n2.eq.0) n2=n
      endif

c
c  find largest absolute extreme
c
       max_value=0

c
       do i=1,n
          if(abs(y(i)).gt.abs(max_value)) then
             max_value=y(i)
             ifirst=i
          endif
       enddo
       max_sign=abs(max_value)/max_value
c
c   search around the extreme, extreme must have opposite sign of the previous
c   extreme
c

c
c   seach above in time
c

c
c   range acording to frequency band
c
       i1=ifirst+n1
       if(i1.gt.n) i1=n
       i2=ifirst+n2
       if(i2.gt.n) i2=n
c
c   find limits set by zero crossings
c
       k=0
       do i=i1,i2
          if((y(i-1).gt.0.0.and.y(i).le.0.0).or.
     *       (y(i-1).lt.0.0.and.y(i).gt.0.0)) then
                 k=k+1
                 if(k.gt.maxcros) then
                    i2=i
                    goto 10
                 endif
          endif
       enddo
 10    continue

       if(i1.eq.i2) then
          ifirst=0
          return
       endif
c
       min_value=0
       do i=i1,i2
          if((max_sign.gt.0.and.y(i).lt.0).or.
     *    (max_sign.lt.0.and.y(i).gt.0)) then
          if(abs(y(i)).gt.abs(min_value)) then
             min_value=y(i)
             ilast=i
          endif
          endif
       enddo
c
c   search below in time
c

       i1=ifirst-n1
       if(i1.le.0) i1=1
       i2=ifirst-n2
       if(i2.lt.0) i2=1
c
c   find limits set by zero crossings
c
       k=0
       do i=i1,i2,-1
          if((y(i+1).gt.0.0.and.y(i).le.0.0).or.
     *       (y(i+1).lt.0.0.and.y(i).ge.0.0)) then
                 k=k+1
                 if(k.gt.maxcros) then
                    i2=i
                    goto 11
                 endif
          endif
       enddo
 11    continue
       if(i1.eq.i2) then
          ifirst=0
          return
       endif
       
c
       do i=i2,i1
          if((max_sign.gt.0.and.y(i).lt.0).or.
     *    (max_sign.lt.0.and.y(i).gt.0)) then
          if(abs(y(i)).gt.abs(min_value)) then
             min_value=y(i)
             ilast=i
          endif
          endif
       enddo

c
c   find which one is first and last
c
       if(ifirst.gt.ilast) then
          i=ifirst
          ifirst=ilast
          ilast=i
          yfirst=min_value
          ylast=max_value
       else
          yfirst=max_value
          ylast=min_value
       endif
c
c   check if value is reasonable
c
       if(ifirst.eq.1.or.ifirst.eq.n.or.ilast.eq.1.or.ilast.eq.n)
     * ifirst=0

       return
       end

c$DEBUG
c
c   Program makes a input files for hypoinvers using curent
c   seisan station file. The files made are:
c
c   hypinv.sta   : station file
c   hypinv.mod   : model
c   hypinst      : instruction file   
c
c
c   J Havskov October 93
c
c
c   updates:
c
c   nov 5 93 by jh : bug
c   aug 8 94       : new hypocenter, fix minimum number of stations to 3
c   feb 99 jh      : ------------- version 7.0 upgrade -----------------
c                    rem ref to computer, use first 4 chars of 5 char codes
c
      implicit none
      character*80 inst(100)    ! for hypinST FILE
      character*80 line         ! one line
c--- name of station-model file in current directory
      character*80 cur_file
c--- name of stationmodel in DAT directory
      character*80 dat_file	  	  
      character*60 top_directory   ! seisan top dir
      character*1 dchar         ! dir sep. char
      real d1,d2,vel,depth,z,amag,bmag,cmag,vpvs
      integer i,minsta,itp
      logical hexist

	  

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      bmag=0.0
	  
c	  	  	  	  	  	  
      call dir_char(dchar)
      call topdir(top_directory)
      ITP=index(top_directory,' ')-1
c
c   find station file to use
c
c
c  make file name for both file in current and dat directory
c
      cur_file(1:12)='STATION0.HYP'
      dat_file(1:itp)=top_directory(1:itp)	  
      dat_file(itp+1:itp+1)=dchar
      dat_file(itp+2:itp+4)='DAT'	  
      dat_file(itp+5:itp+5)=dchar
      dat_file(itp+6:itp+17)=cur_file(1:12)	  	  
      open(1,file=cur_file,status='old',err=1)
      goto 2
 1    continue	  
      OPEN(1,FILE=dat_file,STATUS='OLD',err=3)
      goto 2
 3    continue
      write(6,*)' No station file'
      stop
 2    continue
c
c   open output files
c
      open(2,file='hypinv.sta',status='unknown')
      open(3,file='hypinv.mod',status='unknown')
      inquire(file='hypinst',exist=hexist)
      if(hexist) then
         write(6,*)' Will use exising hypinst file'
      else
         open(4,file='hypinst',status='unknown')
      endif
c
c   set some defaults
c
      inst(1)(1:6)='CRH1 '
      inst(1)(7:22)='''hypinv.mod'''
      inst(2)(1:16)='STA '//'''hypinv.sta'''
      inst(3)(1:15)='PRT '//'''print.out'''
      inst(4)(1:16)='SUM '//'''hypinv.sum'''
      inst(5)(1:19)='COP 2              '     ! input format to basic
      inst(6)(1:19)='ERF T              '     ! give error messgaes
      inst(7)(1:19)='LST 0              '     ! no print od station location
      inst(8)(1:19)='KPR 1              '     ! print all staitons
      inst(9)(1:19)='CON 99 0.04 0.001  '     ! iteration stop
c
c   read to end of seisan station file and fish out relevant info
c
c
c   reset test parameters
c
      read(1,'(a)') line
c
 10   continue
      if(line(1:14).eq.'RESET TEST(07)')
     *read(line(16:25),'(f10.3)') amag
      if(line(1:14).eq.'RESET TEST(08)')
     *read(line(16:25),'(f10.3)') bmag
      if(line(1:14).eq.'RESET TEST(09)')
     *read(line(16:25),'(f10.3)') cmag
      read(1,'(a)')line
      if(line(1:10).ne.'          ') goto 10
c
c   station coordinates
c
      read(1,'(a)') line
 20   continue      
      if(line(2:2).ne.' ') then
         write(2,'(a4,1x,a2,1x,a6,a3,1x,a6,1x,a5)')   ! a 5 char station code
     *   line(2:5),line(7:8),line(9:14),line(15:17),
     *   line(18:23),line(29:33)
      else
         write(2,'(a4,1x,a2,1x,a6,a3,1x,a6,1x,a5)')
     *   line(3:6),line(7:8),line(9:14),line(15:17),
     *   line(18:23),line(29:33)
      endif
      read(1,'(a)')line
      if(line(1:10).ne.'          ') goto 20
c
c   model
c
      read(1,'(a)') line
      write(3,*)'Seisan model'
 30   continue
      read(line,'(2f8.3)') vel,depth
      write(3,'(2f5.1)') vel,depth
      read(1,'(a)') line
      if(line(1:10).ne.'          ') goto 30
c
c  vp/vs, start depth and distance weight
c
      read(1,'(f4.1,3f6.2)') z,d1,d2,vpvs
c
c  mininum number of stations
c
c     do i=1,3
c        read(1,'(a)') line
c     enddo
c     read(1,'(47x,i3)') minsta
      minsta=3
c
c   finish control file and write out if not exisitng
c
      write(inst(10),'(a,i3)')'MIN ',minsta
      i=z
      write(inst(11),'(a,i3)')'ZTR ',i
      write(inst(12),'(a,f5.2)') 'POS ',vpvs
      write(inst(13),'(a,f6.1,a)') 'DIS 4 ',d1,' 1 5' ! what is the 4 ?
c
c   if no magnitude, use w .lee
c
      if(bmag.eq.0.0) then
        amag=-0.87
        bmag=2.0
        cmag=0.0035
      endif
      i=0
      write(inst(14),'(a,2f7.4,i2,1x,f7.4,a)')'DUR ',
     *amag,bmag,i,cmag,', 4*0, 9999'
      
c
      write(inst(15),'(a)')'PHS '//'''norhin.out'''
      write(inst(16),'(a)')'LOC '
      if(.not.hexist) then
         do i=1,16
            write(4,'(a)') inst(i)
         enddo
      endif
      stop
      end

c--------------------------------------------------------------------------
c  read harward falut plane solutions, output in nordic format
c--------------------------------------------------------------------------c
c
c  input format read is as show on stanadrd screen
c
c  For detail on parameters and variables naames, see rea.inc
c
c  
c
c
      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common bliock

      character*80 data(5000)             ! s-file with data in text array
      character*80 err_text               ! error text
      character*80 infile                 ! input file
      integer strike,dip,slip
      character*80 text

      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer nevent                      ! number of events in file
      integer i                           ! counter
c
c   open output file

       open(2,file='harnor.out',status='unknown')
    
c
c   get input file name, check if exist
c

 9    continue
      write(6,*) 'Give input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old',err=10)
      goto 11
 10    continue
      write(6,*)' No such input file'
      goto 9
 11   continue
c
      all=.true.                  ! read all parameters
      nevent=0                    ! initialize counter

c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c

  50  continue
c
c   read all parameters for one event form file unit 1
c
      read(1,'(a)',end=1000) text      
      if(text(3:6).ne.'Date') goto 50
c
c   start of event found
c
          call rea_hyp_clear(1)
          rea_id_line=' '
          rea_nhyp=1
          rea_nfault=1
          rea_nstat=0
          rea_nhead=2
          rea_nrecord=3
          rea_nphase=0
          hyp_fix_org(1)=' '
          hyp_dist_id(1)='D'
          read(text(9:18),'(i4,1x,i2,1x,i2)') 
     *    hyp_year(1),hyp_month(1),hyp_day(1)    
          read(text(37:46),'(i2,1x,i2,1x,f4.1)') 
     *    hyp_hour(1),hyp_min(1),hyp_sec(1)
c          write(6,*) hyp_year(1)
          read(1,'(a)') text
          read(text,'(6x,f7.2,6x,f7.2)') 
     *    hyp_lat(1),hyp_lon(1)
c          write(6,*) hyp_lat(1)
c          read(5,*) i

          read(1,'(8x,f6.1)') hyp_depth(1)
c          write(6,*) hyp_depth(1)
c          read(5,*) i
          read(1,'(a)') text
          read(1,'(a)') text
          read(1,'(7x,f3.1,9x,f3.1,9x,f3.1))') 
     *    hyp_MAG(1,1),hyp_mag(2,1),hyp_mag(3,1)
c          write(6,*) hyp_mag(1,1)
c          read(5,*) i
          hyp_mag_type(1,1)='W'
          hyp_mag_type(2,1)='B'
          hyp_mag_type(3,1)='S'
          hyp_mag_agency(1,1)='HRW  '
          hyp_mag_agency(2,1)='HRW  '
          hyp_mag_agency(3,1)='HRW  '
          hyp_agency(1)='HRW  '
          read(1,'(23x,i3,8x,i2,8x,i4)') strike,dip,slip
          rea_fault(1)=' '
          write(rea_fault(1),'(3f10.0)') 
     *    float(strike),float(dip),float(slip)
          rea_fault(1)(71:76)='HARWAR'
          rea_fault(1)(80:80)='F'
          nevent=nevent+1               ! count events
c    
c   write on screen a bit info on event
c
          write(6,*)' Strike, dip, rake',strike,dip,slip
 
c
c   write out 
c
          call rea_event_out(2,all,data,code)
c
c   get next event
c
      goto 50
c
c     end of file
c
 1000 continue
c
      write(6,*)            ! blank line
      close(2)              ! close output file
      write(6,*) 'Number of events in input file', nevent
      write(6,*) 'Output file name is harnor.out'

      stop
      end

      subroutine inc_id(idline,filename,nf)
c
c     updates:
c
c jun 11 98 jh  : extracted from split and eev
c                 bug in id fixed
c sep 16 98 jh  : ---------- version 7.0 check --------------------
c                 remove pc part
c oct 16          bug
c
      implicit none
c
c   adds one second to file name and id line
c
      character*80 filename,idline
      integer nf      ! number of characters in filename
      integer isec
c
c 
c   read second and add 1, if 60, start over again
c
      read(filename(nf-10:nf-9),'(i2)') isec
      isec=isec+1
      if(isec.gt.60) isec=1
c
c   write back
c
      write(filename(nf-10:nf-9),'(i2)') isec
      if(filename(nf-10:nf-10).eq.' ') 
     *filename(nf-10:nf-10)='0'
c
c   put into id
c
      idline(73:74)=filename(nf-10:nf-9) ! added 6-98
c
c   note in id that this was a dublicate
c
      idline(75:75)='d'
c
      return
      end      

c                                                                               
c    transform os9 binary or ascii files to seisan  data files               
c                                                                               
c    j. havskov                       
c
c    Note: Search for word COMPUTERTYPE to move progarm between, sun 
c          and pc
c
c    Parameter in defines some type of input
c
c    in=0 : One binary file, work only on sun or pc due to byte swapping on vax
c           only binary files on version 1 and 2
c    in=1 : Several ------, use filenr.lis as input file name
c    in=2 : Ascii file of some type
c    in=3 : Only os9.log file, no questions
c    in=4 : Only os9.log file, ------------,output in RAW directory
c
c    in order ot use options 3 and 4, hardwire in (below) and recompile.
c
c    In addtion logicals old,new and asc define file types:
c    old true : 1024 byte headers before june 92
c    new true : 1024 byte headers after june 92
c    asc true : oldest ascii format, used fixed format blocks and a 512
c               byte header. presently (aug 92) only used by bgs
c                                                                               
c    latest update                                                              
c    jan 3 90 by j.h. : transform directly to seisan  data files                
c    jan 7 90         : bugs                                                    
c    oct 1 91         : binary version                                          
c    oct 17 91        : bug with rlength
c    oct 24 91        : little change in filename
c    nov 4  91        : convert ascii files also, same prog. on vax,sun and pc
c    dec 10 91        : change storage vector to one dimentional
c                       on sun fortran version 1.3.1 it is not possible to
c                       write out more than 16384 i*2 variables from a 2-d
c                       array, a Bug!!!!!!  Another bug is that it must be
c                       compiled with option -Bstatic.
c                       Checking od number sizes added since there were
c                       some problems with tcp/ip transmissiion, which sometimes
c                       gave errors.
c    jun 11 92  jh    : new header size in input file, 4 byte integers
c    aug 11 92        : new input file header
c    aug 13 92        : fix to use oldest ASC format
c    sep 14 92        : user interaction if error
c    feb 26 93        : question and infile to 80 chars
c    jun 02 93        : patch to check for errors, fix better in future, 384
c    jul 2  93        : change parameter in to be able to run without questions
c                       and put output files in RAW directory
c    jul 22           : small bug with old ASC format os9.log files
c    dec 93           : upper lower case
c    jan 30 93        : pc byte swappeing, where did it go !!!
c    sep 28 94        : 64 channels
c    oct 13 94        : new seislog ad unit numbers
c    jan 95 95        :**************** version 5.0 ************** seidim
CJAB(BGS)Mar95        : If the generated file suffix in agency BGS (and
CJAB(BGS)Mar95          associated agencies) is contained in the input file
CJAB(BGS)Mar95          suffix, then use the input file suffix.
c mar 29 by jh        : byte length 2 or 4, general
c aug 4               : delete output file if not complete, allow for
c                       missing header data with cmp6 os9.log type file
c aug 15              : bug by not clearing outfile variable
CJE(BGS)Aug95         : for large samples > 50000, program exiting due to too
CJE(BGS)Aug95           many samples/channel. Value hard-wired into test. 
CJE(BGS)Aug95           Value replaced by max_sample as given in seidim.inc.
CJAB(BGS)Sep95        : Same problem with test for rlength, set to max_sample*2
CJAB(BGS)Sep95        : For os9.log files, the sample size was being re-set
CJAB(BGS)Sep95          incorrectly,  causing routine to fail (but nicely!).
CJAB(BGS)Sep95          Further, blocks with different # records than expected
CJAB(BGS)Sep95          forced an "ignore" prompt...now only a warning is given.
CJAB(BGS)Sep95          The mismatching block samples are zeroed, and the #
CJAB(BGS)Sep95          samples re-set to the mimimum of expected and found.
c  oct 12 95 by jh    : fix a JAB bug to get correct number of samples in buffer
c                       set up general byte swap, bug not clearing file name
c                       when in raw mode
c oct 31              : delete when error
c jan 29 96           : problems with byte order
c jan 98              : fix check for response
c may 98              : fix so seislog 7.0 runs with os9.log
c dec 20 98 jh        :  --------- version 7.0 check -----------------
c                       only partly done, old file name, byte order not fixed
c                       on linux
c jan 7  99           : long file name, no linux swap
c jun 15              : new year 2000 qnx format
c jan 3 2000          : some y2k fixing, patch up to be able ro run old qnx
c may 11 2000         : new waveform structure
c September 25, 2000  : add input of file name from prompt
c February 15 2001    : added option for additional command line args
c                             option for using BGS seisan extensions
c                             fixed bug for 16 bit ILI digitizer 95
c                             determine year explicitly from headers
c june 23 2001 jh     : checked os9 files, seemed ok for 1999 and 2000
c
c dec  6              : remove max_sample_dem form include
c jan 29, 2002 lot    : patch for GUV
c feb 02 03     jh    : remove deocmp6 and intand, now in compdecomp
c dec 07 jh           : remove swap routines, are in library
c
      implicit none
      include 'seidim.inc'
      external    seiclen                  !JAB(BGS)Mar95. Length
      integer     seiclen                  !JAB(BGS)Mar95. Function.
      character*2 byte_length              ! byte length
c                                                                               
c-- seisan  field station file header                
      character*1024	header		
c-- seisan  data file channel header      
      character*1040    chahead         
c-- -------------------main --------      
      character*2000     mainhead        
c-- output file name                                  
      integer           os9sei_c                  ! Working length of outfile.
      character*80	outfile		          !
      character*80	outdir                    ! output directory
      character         chr_suffix *(10),         ! Input file suffix.
     &                  chr_agency *(3)           ! & agency.
c-- save part of header                         
c-- data vector, one buffer or one channel                              
      integer*2		data2(max_sample)	
      character*2   swap (max_sample)
      integer*4     data4(max_sample)
c--output data,  whole file, not to be used on pc
      integer*4         y(1600000)
c-- one line of text
      character*80 text
c-- data array used with compression
      integer*4         datax(max_sample)
c-- compressed ascii data	
      character*1       abuf(max_sample)
c-- ascii data
      character*2 cbuf(2560)
c-- character block size compressed
      integer           sblk	
c-- ad unit, 99 is 4 byte nanometrics
      integer unit
c-- number of equivalent samples in one buffer and in buffer header
      integer nsmp_buf,nhead
c-- in: dim of array, out: # of values returned
      integer           out		
c-- error return
      integer ierr
c-- input file name
      character*80 infile
c-- top directory
      character*60 top_dir
c-- event number in
      integer number
c-- question
      character*80 question
c-- number of channels and samples/chan, total number of samples           
      integer nchan,nsamp,ntotal
c-- total time window                          
      real              total_time	
c-- logical for file types etc
      logical old,new,asc,raw,qnx
c logical for using BGS seisan extensions (bjb 2001/02/15)
c      logical bgs_seisan
      character*10 extension
c-- block record length                   
      integer           rlength         
c-- number of blocks                              
      integer           nblock
c-- displacement first sample in buffer, only old files
      integer displm		
c-- sample rate                                              
      integer           irate
      real		rate
c-- help variables                                     
      integer		i,k,ib,in,j,kk
      character*1       dchar,sw,c
c-- -------------                                    
      integer           ich		
      integer byte_order    ! byte order, machine where written 1: sun, 2:pc
c-- for swapping
      integer inputtype
c determine year explicitly (bjb 2001/02/15)
      integer year
c number of command line arguments (bjb 2001/02/15)
      integer narg
c char string for each argument (bjb 2001/02/15)
      character*80 argument(10)

      equivalence(data2,swap)
      logical pc,sun,linux


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c set initial file or action, if gt 2, no questions asked 
c
      in=0
      outfile = ' '                       !JAB(BGS)Mar95. Empty filename.
c
c call function to determine if using BGS seisan extensions
c
c      call get_bgs_seisan(bgs_seisan)
      call get_env_seisan_extension(extension)
c
c   set computer type
c
      call computer_type(sun,pc,linux)
c
      call dir_char(dchar)
c
c   get top directory
c
      call topdir(top_dir)
c
c   check if output in RAW directory
c
      raw=.false.
      if(in.eq.4) raw=.true.
c
c  get file name, could be from line argument
c

      call get_arguments(narg,argument)
      if(narg.eq.1) then
         infile=argument(1)
         goto 1   ! jump other input
      else if (narg.eq.3) then
         infile=argument(1)
         outdir=argument(2)
         read(argument(3),'(i)') inputtype
c
c set as ascii input if 3rd command line arg is 1
c
         if(inputtype.eq.1) in=2
         goto 1   ! jump other input
      endif

      if(in.lt.3) then
         write(6,*)
     *   ' Input file binary: Give number, name or filenr.lis for all'
         write(6,*)
     *   ' Input file ascii : Filename must be os9.log'
         question=' Filename, ?, or number'
         call filename(question,infile)
c
c  check for no files
c
         if(infile(1:3).eq.'EOF') goto 99
c
c   check which type of input file
c
         if(infile(1:10).eq.'filenr.lis'
     *   .or.infile.eq.'FILENR.LIS') then
            open(8,file='filenr.lis',status='old')
            in=1
         endif
         if(infile(1:7).eq.'os9.log'
     *   .or.infile(1:7).eq.'OS9.LOG') in=2
     
c         if(in.eq.3.or.in.eq.4) then
c            in=2
c            infile(1:7)='os9.log'
c         endif

      endif
c
c-----------------------------------------------------------------------
c  back here if many binary files converted using filenr.lis, or from prompt input
c-----------------------------------------------------------------------
c
 1    continue
      if(in.eq.1) then
         read(8,'(2x,i3,2x,a)') number,infile
         write(6,*)
         write(6,'(1x,i3,3x,a)') number,infile
         if(infile(1:4).eq.'    ') goto 99
      endif
c                                                                               
c  open os9 binary file if that is the option
c     
      if(in.lt.2)
     *open(1,file=infile,status='old',access='direct',recl=1024)            
c
c   open os9 ascii log file if that is the option
c
      if(in.eq.2) open(1,file=infile,status='old')
c                                                                               
c   read header if binary file
c                                                                               
      if(in.lt.2) read(1,rec=1) header
c
c   read header if ascii file, first read forward to 
c   start of event, also enter here after read of one event
c   from asci file
c             
 2    continue
      if(in.eq.2) then
 11      continue
         read(1,'(a80)',end=99) text
         if(text(1:30).eq.'START OF EVENT ***************') then
c
c   check if old asc format indicated by logical asc, that is
c   indicated by ASC at end of START of .... string.
c
            asc=.false.
            if(text(33:35).eq.'ASC') asc=.true.
            if(asc) then
               read(1,'(80a1)',err=15) (header(i:i),i=1,512)
            else
               read(1,'(80a1)',err=15) (header(i:i),i=1,1024)
            endif
            goto 16
 15         continue
 384        continue        ! error from internal read below....
            write(6,202)
 202        format
     *      (/,' Error with os9.log file, will try next event',/)
ctest            write(6,*)' nsamp',nsamp,'nchan',nchan,'unit',unit,'rate',
ctest     *      rate,'displm',displm
            write(6,*)' Return to continue'
            read(5,'(a1)') i
         endif
         goto 11
      endif
 16   continue
c
c   find if old or new header format
c
      new=.true.
      old=.false.
      if(header(10:14).ne.'       ') then
        old=.true.
        new=.false.
      endif
      write(6,*)
      if(asc) write(6,*)' old ASC format'
      if(old) write(6,*)' old header format'
      if(new) write(6,*)' new header format'
c                                                                               
c  make file name 
c             
      outfile=' '      ! jh add oct 95

c
c fix for GUV, lot 29.01.2002
c
         if (header(1:3).eq.'GUV') then
            read(header(17:18),'(i2)') year
            year=year+8-100
            write(header(17:18),'(i2)') year
         endif
c
c-- year
         if(new) outfile(3:4)=header(17:18)
         if(old) outfile(1:2)=header(6:7)
         if(outfile(3:4).eq.'10') outfile(3:4)='00'   ! patch to use old qnx
         read(outfile(3:4),'(i2)') i
         if(i.lt.50) then
            outfile(1:2)='20'
         else
            outfile(1:2)='19'
         endif
c-- month
         outfile(5:5) = '-'
         if(new) outfile(6:7)=header(24:25)
         if(old) outfile(3:4)=header(13:14)
         outfile(8:8)='-'
c-- day     
         if(new) outfile(9:10)=header(27:28)
         if(old) outfile(6:7)=header(16:17)
         outfile(11:11)='-'
c-- hr      
         if(new) outfile(12:13)=header(33:34)
         if(old)outfile(9:10)=header(19:20)
c-- min     
         if(new) outfile(14:15)=header(36:37)
         if(old) outfile(11:12)=header(22:23)
         outfile(16:16)='-'
c-- sec
         if(new) outfile(17:18)=header(39:40)
         if(old) outfile(14:15)=header(25:26)
         outfile(19:20)='S.'
c-- network or station code
         outfile(21:25)=header(1:5)
         do i=21,25
            if(outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo
         outfile(26:27)='_0'
c-- number of channels
         if(new) outfile(28:29)=header(63:64)
         if(old) outfile(22:23)=header(32:33)

c         if (bgs_seisan) then
         if (extension(1:3).eq.'BGS') then
c-- retrieve code from filename in header for manual extracts etc.
            if(header(897:897).eq.'2')then
               qnx=.true.
            else
               qnx=.false.
            endif
            if(new) then
               if(qnx) then
                  outfile(30:31)=header(923:924)
               else
                  outfile(30:31)=header(920:921)
               endif
            endif
         endif
c
c   BGS...if station code/# channels is given in the suffix of the input
c         file, then use the input file suffix...
c
         call get_agency( chr_agency )                         ! Get agency.
         if( chr_agency .eq. 'BGS' .and.                       ! Valid.
     &       in         .lt. 2   ) then                        !
         chr_suffix = infile(index(infile,'.')+1:)             ! Get suffix.
            if( index(chr_suffix,'.')            .eq. 0   .and.! Valid suffix.
     &          index(chr_suffix,outfile(18:23)) .gt. 0 ) then ! Is there!
            outfile(18:) = chr_suffix                          ! & replace.
            end if                                             !
         endif
c----------------------------------------------------------------
c
c-- check for blanks                                        
         do i=1,seiclen(outfile)                    !JAB(BGS)Mar95.
            if(outfile(i:i).eq.' ') outfile(i:i)='0'                            
         enddo                                                                  
         write(*,*)' Output file name is: ',
     &              outfile(1:seiclen(outfile))     !JAB(BGS)Mar95
c
c bjb 4/11/99
c prefix output directory given in subroutine arguments
c to outputfilename
c
         if(narg.gt.1) then
            outfile=outdir(1:seiclen(outdir))//dchar//outfile
            write(*,*)' Output file name is: ',
     &           outfile(1:seiclen(outfile))
         endif
c
c   read header info
c                                                       
         if(new) read(header(17:18),'(i2)') year
         if(old) read(header(6:7),'(i2)') year
         
         if(year.lt.50) then
            year=year+2000
         else
            year=year+1900
         endif
         write(*,*) 'Year is ', year

         if(new) read(header(81:88),'(i8)',err=384) nsamp
         if(old) read(header(40:45),'(i6)',err=384) nsamp
         if(new) read(header(63:64),'(i2)',err=384) nchan
         if(old) read(header(32:33),'(i2)',err=384) nchan
         if(new) read(header(105:112),'(i8)',err=384)rlength
c        if(old) read(header(548:549),'(i2)',err=384) unit
         if(old) unit=0
         if(new) read(header(97:98),'(i2)',err=384) unit
         if(asc) then
            rlength=5120
         else
            if(old) read(header(561:565),'(i5)',err=384)rlength
         endif
         if(new) read(header(65:80),'(f16.7)',err=384) rate
         if(new) read(header(95:96),'(a2)',err=384)byte_length
         if(new) read(header(94:94),'(i1)',err=384) byte_order
         if(old) read(header(35:38),'(i4)',err=384) irate
         if(old.and.asc) read(header(47:49),'(i3)',err=384) displm
         if(old) then
           rate=float(irate)
         else
           rate=1/rate
         endif
c
c   check rlength size
c
         if(rlength.gt.max_sample*2) then                  !JAB(BGS)Sep95.
            write(6,*)' Too long buffers, rlen= ',rlength
            stop
	  endif		
c
c   for the time being assume that earth data is written on pc systems
c
      if(byte_order.eq.0) byte_order=1       ! if no byte order, assume VME
      if(unit.eq.63) byte_order=2            ! earth data
      write(6,'(1x,a,i3)') 'Digitizer ',unit
      write(6,'(1x,a,a)') 'Number of bytes in data word ', byte_length
c
c   calculate number of samples pr buffer inc header and header
c   in samples taking into account if 2 or 4 byte words
c
         nsmp_buf=rlength/2
         nhead=32

c         if((unit.eq.30.or.unit.eq.36).and.in.eq.2) then
c             byte_length=' 2'
c             goto 3747      ! force 2 byte for ascii transmission
c         endif

c problems with 16 bit ili data both binary and ascii 
c fixed bjb 7/9/99 by removing unit 95 (16 bit ILI) 
c from if statement
c         if(unit.eq.99.or.unit.eq.53.or.unit.eq.56.or.unit.eq.63
c     &   .or.unit.eq.95.or.unit.eq.31               !JE(BGS)Aug95.
c     *   .or.byte_length.eq.' 4')  then
         if(unit.eq.99.or.unit.eq.53.or.unit.eq.56.or.unit.eq.63
     &   .or.unit.eq.31.or.byte_length.eq.' 4')  then
            byte_length=' 4'
            nsmp_buf=nsmp_buf/2              !JAB(BGS)Sep95 reset incorrectly.
            nhead=16
         endif
 3747    continue
         if(asc) nhead=displm
c         byte_length=' 4'           ! XXX
c
c   check if not too many samples
c
         if(nsamp.gt.max_sample) then            !JE(BGS)AUG95.
	    write(6,*)' Too many samples/chan, nsamp= ',nsamp
            stop
         endif			 
         nblock=nsamp*nchan/(nsmp_buf-nhead)                                    
         write(6,*)' nsamp=',nsamp,'  nchan=',nchan,' reclen=',rlength          
         write(6,*)' number of blocks=',nblock                                  
c
c   close and reopen input file with record length of data buffers
c   if a binary file
c		                                                                
         if(in.lt.2) then
            close(1) 
            open(1,file=infile,status='old',
     *      access='direct',recl=rlength)   
         endif
c
c  if on pc and ascii file, open a scratch file to help demultiplexing
c
         if(pc.and.in.eq.2) open(7,form='unformatted',status='scratch')
c
c   construct  main header
c
         do i=1,2000                                                            
           mainhead(i:i)=' '                                                    
         enddo                                                                  
         mainhead(2:18)='                  '                              
c-- no of channels                        
         if(new) mainhead(32:33)=header(63:64)
         if(old) mainhead(32:33)=header(32:33)
c-- year, date and time
         if(year.lt.2000)then
            mainhead(34:34)='0'
         else
            mainhead(34:34)='1'
         endif
         if(new) mainhead(35:46)=header(17:28)
         if(new) mainhead(48:59)=header(33:44)
         if(old) mainhead(35:59)=header(6:30)
c
c   patching up year
c
c         if(mainhead(35:36).eq.'10') mainhead(35:36)='00' ! old qnx, no y2k fix
c         if(mainhead(35:35).eq.'0') mainhead(34:34)='1'
c
c  who commented above out ???
         if(mainhead(35:35).eq.' ') mainhead(35:35)='0'  ! lot 29.01.2002

          mainhead(36:36)=outfile(4:4)
c-- total time window
         total_time=nsamp/rate
         write(mainhead(61:69),'(f9.3)') total_time
         j=162
         if(new) k=161
         if(old) k=51
         do i=1,nchan                                                           
c--  station and component              
            mainhead(j:j+7)=header(k:k+7)	
            mainhead(j+8:j+8)=' '                                               
c-- rel. start time of channel           
            mainhead(j+9:j+15)='    0.0'	
            write(mainhead(j+17:j+24),'(f8.2)') total_time                      
            if(i.eq.3.or.i.eq.6.or.i.eq.9.or.i.eq.12.or.i.eq.15.                
     *      or.i.eq.18.or.i.eq.21.or.i.eq.24.or.i.eq.27.or.i.eq.30.
     *      or.i.eq.33.or.i.eq.36.or.i.eq.39.or.i.eq.42.or.i.eq.45.
     *      or.i.eq.48.or.i.eq.51.or.i.eq.54.or.i.eq.57.or.i.eq.60.
     *      or.i.eq.63) then        
              j=j+28                                                            
            else                                                                
              j=j+26                                                            
            endif                                                               
            if(new) k=k+8
            if(old) k=k+11
         enddo                                                                  
c
c   open output binary file, modify name if it goes in RAW directory
c
         if(raw) then
           i=index(top_dir,' ')-1
           text(1:i)=top_dir(1:i)
           text(i+1:i+1)=dchar
           text(i+2:i+4)='RAW'
           text(i+5:i+5)=dchar
           text(i+6:i+7)=mainhead(45:46)
           text(i+8:i+8)=dchar
           if(text(i+6:i+6).eq.' ')text(i+6:i+6)='0'
c
           os9sei_c = seiclen( outfile )                       !JAB(BGS)Mar95.
           text(i+9:i+8+os9sei_c)=outfile(1:os9sei_c)  !JAB(BGS)Mar95.
           outfile(1:i+8+os9sei_c)=text(1:i+8+os9sei_c)!JAB(BGS)Mar95.
         endif
         open(2,file=outfile,status='unknown',form='unformatted')        
         write(6,'(1x,a,a)')'Output file: ',outfile
c
c                                                                               
c   write  main header                                       
c                                                                               
         k=1                                                                    
         do i=1,12                                                              
            write(2) mainhead(k:k+79)                                           
ctest            write(6,'(a80)') mainhead(k:k+79)	
            k=k+80                                                              
         enddo                                                                  
c
c   write remaining main header lines if more than 30
c
         if(nchan.gt.30) then
            kk=(nchan-31)/3+1
            do i=13,kk+12
               write(2)mainhead(k:k+79)
               k=k+80
            enddo
         endif
c                                                                               
c   start channel read loop
c
         j=0                                                                    
         do ib=2,nblock+1                                 
c                                                                               
c   read one buffer, binary or ascii
c   if on pc and ascii, event must be written out in a single
c   file to do demultiplexing later
c   if binary file, make sure first data buffer is read
c   at correct place, which is always beyound the 1024 bytes,
c   see manual for format ( fixed below by 1024/rlength),
c   note: all data is transferred to 4 byte array
c                                                                               
            if(in.lt.2) then
c              if(unit.ne.99) then
               if(byte_length.ne.' 4') then
                  read(1,rec=ib+1024/rlength) (data2(i),i=1,nsmp_buf)
c
c if pc do byte swapping, is now done below
c
c                  if(pc) then
c                     do i=1,nsmp_buf
c                        sw=swap(i)(2:2)
c                        swap(i)(2:2)=swap(i)(1:1)
c                        swap(i)(1:1)=sw
c                     enddo
c                  endif
                               
                  do i=1,nsmp_buf
                     data4(i)=data2(i)
                  enddo
               else
                  read(1,rec=ib+1024/rlength) (data4(i),i=1,nsmp_buf)
               endif
            endif
c
c   ascii file, check for correct position
c
            if(in.eq.2) then
               read(1,'(i4,4x,i6)',err=27) k,sblk
               write(6,*)' block:',ib-1,'     c bytes:', sblk
               if(k.ne.ib-1) then
c
c  could be that one line is missing in header, try previous line
c  before giving up
c
                  write(6,*)' Error, will try previous line'
                  backspace 1
                  backspace 1
                  read(1,'(i4,4x,i6)',err=27) k,sblk
                  if(k.ne.ib-1) then
                     write(6,202)
                     write(6,*)' Return to continue'
                     read(5,'(a1)') i
                     close(2,status='delete')  ! delete since not complete
                     goto 2
                  endif
               endif
               goto 28
 27            continue
               write(6,202)
            write(6,*)' Return to continue'
            read(5,'(a1)') i
            close(2,status='delete')  ! delete since not complete
               goto 2
 28            continue
c
c   read one  buffer, chose buffer format according to compression,
c   for fomatted input, only os9 files of version later then
c   June 92 can be used
c

               if(sblk.eq.0.and.(.not.asc)) then
                  read(1,'(10i8)',err=27,end=38)
     *            (data4(i),i=1,nsmp_buf)
               endif
               if(asc) then
                  read(1,'(40a2)',err=27,end=38)
     *            (cbuf(i),i=33,2560)
c
c   header not transfered, put in something which can be transformed
c
                  do i=1,32
                     cbuf(i)='aa'
                  enddo
c
c   transform from asci to integer
c
                  call asck(2560,data4,cbuf,-1,ierr)
                  out=nsmp_buf
               endif
c
c   compressed data
c
               if(sblk.ne.0.and.(.not.asc)) then
                  read(1,'(80a1)',err=27,end=38)
     *            (abuf(i),i=1,sblk)
               endif
c
               goto 39
 38            continue
               write(6,*) ' End of file'
               goto 99
 39            continue
c
c   transform from compressed asci to integer if compressed
c
               if(asc) goto 42              
               if(sblk.ne.0) then
                  out = nsmp_buf*2                  !JAB(BGS)Sep95 (outragious!)
cJAB(BGS)Sep95                  out=10000
                  call dcomp6(sblk,abuf,out,data4,ierr)
c
c   check if correct number of samples out
c
                  if(out.ne.nsmp_buf) then
                     write(6,*)' Wrong number of samples for buffer'
                     write(6,*)' Should have been:',nsmp_buf
                     write(6,*)' Is:              ',out
c
                     if( out .gt. nsmp_buf ) then    !JAB(BGS)Sep95
                     do i = nsmp_buf+1,out           !JAB(BGS)Sep95
                     data4(i) = 0.0                  !JAB(BGS)Sep95
                     end do                          !JAB(BGS)Sep95.
                     else                            !JAB(BGS)Sep95
                     do i = out+1, nsmp_buf          !JAB(BGS)Sep95.
                     data4(i) = 0.0                  !JAB(BGS)Sep95
                     end do                          !JAB(BGS)Sep95
                     end if                          !JAB(BGS)Sep95
                     write(6,*)' Ignore(i) or return to continue',
     *                           ' with next event'
                     read(5,'(a1)') c
                     if(c.eq.'i'.or.c.eq.'I') then
                        continue
cJAB(BGS)Sep95                        do i=out,nsmp_buf
cJAB(BGS)Sep95                           data4(i)=0.0
cJAB(BGS)Sep95                        enddo
                     else
                        goto 2
                     endif
                  endif
c
c   decompress by removing differences 2 times
c
                  call rmfdif(out,data4,datax,nchan)
                  call rmfdif(out,datax,data4,nchan)
               endif
 42            continue
               if(pc) then
c                 if(unit.eq.99) then
                  if(byte_length.eq.' 4') then
                     write(7) (data4(i),i=1,nsmp_buf)
                  else
                     do i=1,nsmp_buf
                        data2(i)=data4(i)
                     enddo
                     write(7) (data2(i),i=1,nsmp_buf)
                  endif
               endif
c
c   end of ascii read one channel
c
            endif
c                                                                               
c  remove block buffers and save data in one array if sun 
c                                          
            if(sun.or.linux) then                                     
                do k=nhead+1,nsmp_buf
                  j=j+1
                  y(j)=data4(k)
                enddo
            endif
            ntotal=j
c
c   end of channel loop
c                                                               
         enddo
         write(6,*)
     * ' Input file read, now follows headers in output file'
c                                                                               
c  end read for one event
c                                                                               
c                                                                               
c  write each channel with channel headers
c                                                                               
         do ich=1,nchan                                                         
            do i=1,1040                                                         
               chahead(i:i)=' '                                                 
            enddo                                                               
            if(new) j=(ich-1)*8+161
            if(old) j=(ich-1)*11+51
c-- station code                          
            chahead(1:4)=header(j:j+3)		
c-- componnet
            chahead(6:9)=header(j+4:j+7)	
c-- year, date and time                  
            chahead(10:35)=mainhead(34:59)		
            write(chahead(37:43),'(f7.2)') rate                          
            write(chahead(45:50),'(i6)') nsamp                                  
c                                                                               
c   get response            
c                                                                               
            call read_resp_head(chahead) 
c
c   indicate 2 or 4 byte integer in header
c
            if(unit.eq.99) chahead(77:77)='4'
            if(byte_length.eq.' 4') chahead(77:77)='4'
c                                                                               
c   write header                                                                
c                                                                               
            write(2)chahead                                                     
            write(6,'(1x,a70)') chahead(1:70)
c
c   check if response curve
c
c           if(chahead(160:160).eq.'9') write(6,*)
c            if(wav_resp_status(1:1).eq.'9') write(6,*)
c     *        ' No response file for this channel --------'

c                                                                            
c  demultiplex data if on sun 
c
c  remember, no swapping if input is an ascii file************************
c
c            if(sun.or.linux) then
            if(sun) then
               j=0
               do k=ich,ntotal,nchan
                  j=j+1
c                 if(unit.ne.99) then
                  if(byte_length.ne.' 4') then
                     data2(j)=y(k)
                  else
                     data4(j)=y(k)
                  endif
               enddo
c              if(unit.ne.99) then
               if(byte_length.ne.' 4') then
                  if(byte_order.eq.2.and.in.lt.2) 
     *            call swap2(nsamp,data2)
                  write(2)(data2(k),k=1,nsamp)
               else
                  if(byte_order.eq.2.and.in.lt.2) 
     *            call swap4(nsamp,data4)
                  write(2)(data4(k),k=1,nsamp)
               endif
            endif
c
c   if on pc, whole file must be read for each channel
c   to demultiplex
c
c            if(pc) then
            if(pc.or.linux) then
               if(in.lt.2) rewind(1)
               if(in.eq.2) rewind(7)
               j=0                                                              
               do ib=2+(1024/rlength),nblock+1+1024/rlength                    
c                 if(unit.eq.99) then
                  if(byte_length.eq.' 4') then
                     if(in.lt.2)read(1,rec=ib) (data4(i),i=1,nsmp_buf)         
                     if(in.eq.2)read(7) (data4(i),i=1,nsmp_buf)                
                     if(byte_order.eq.1.and.in.lt.2) 
     *               call swap4(nsmp_buf,data4)

                  else
                     if(in.lt.2) then
                         read(1,rec=ib) (data2(i),i=1,nsmp_buf)          
c
c  do byte swapping
c
c                        do i=1,nsmp_buf
c                           sw=swap(i)(2:2)
c                           swap(i)(2:2)=swap(i)(1:1)
c                           swap(i)(1:1)=sw
c                        enddo
                     endif
                     if(in.eq.2)read(7) (data2(i),i=1,nsmp_buf)                 
                     if(byte_order.eq.1.and.in.lt.2) 
     *               call swap2(nsmp_buf,data2)
                  endif
c
c   demultiplex
c
                  do k=nhead+1,nsmp_buf,nchan                                   
                    j=j+1  
c                   if(unit.eq.99) then
                    if(byte_length.eq.' 4') then
                       datax(j)=data4(k+ich-1)
                    else
                       datax(j)=data2(k+ich-1)
                    endif
                  enddo                                                         
               enddo    
ctest          write(6,*)' nsamp,j', nsamp,j                 
               nsamp=j                                              
c               if(unit.eq.99) then
                if(byte_length.eq.' 4') then
                  write(2)(datax(k),k=1,nsamp)                                        
               else
                  do i=1,nsamp
                     data2(i)=datax(i)
                  enddo
                  write(2)(data2(k),k=1,nsamp)
               endif
            endif
         enddo
         close(2,err=765)                       
         if(pc.and.in.eq.2) close(7)                                  
         goto 766
 765     continue
         write(6,*) ' Error close 2'
 766     continue
c
c  if file is binary, close to be able to open next file if more than 1
c                                                                  
         if(in.lt.2) close(1)
c                                                                               
c   back for next event if a list of events are transformed
c   or an ascii input file is used
c              
      if(in.eq.1) goto 1          
      if(in.eq.2) goto 2
c                                                                               
c   end of data                                                                 
c                                                                               
 99   continue                                                                  
      stop                                                                      
      end                                                                       
C*********************************************************************
C                                                                    *
C     SUBROUTINE RMFDIF(NPTS,IXIN,IXOUT,NCHAN                        *
C  THIS ROUTINE WAS ORIGINALLY LIKE:                                 *
C     SUBROUTINE RMFDIF(NPTS,IXIN,IXOUT)                             *
C                                                                    *
C     THE ROUTINE NOW REMOVES 1. DIFFERENCES IN MULTIPLEXED DATA     *
C         THEREFORE NUMBR OF CHANNELS NCHAN TO BE SPECIFIED          *
C                                                                    *
C     ROUTINE TO REMOVE 1ST DIFFERENCES OF INTEGER ARRAY IXIN        *
C     WHICH HAS LENGTH NPTS AND PUT THE OUTPUT INTO THE ARRAY IXOUT. *
C     THE ARRAY IXOUT MAY BE THE SAME AS THE ARRAY IXIN IN WHICH CASE*
C     THE ARRAY IXIN WILL BE OVERWRITTEN.                            *
C     SUBROUTINE ASSUMES THAT WHEN FIRST DIFFERENCES WERE TAKEN      *
C     STARTING VALUE WAS ZERO. (SEE SUBROUTINE FSTDIF)               *
C                                                                    *
C     SECOND DIFFERENCES CAN BE REMOVED BY CALLING THIS SUBROUTINE   *
C     TWICE                                                          *
C                                                                    *
C*********************************************************************
C
      SUBROUTINE RMFDIF(NPTS,IXIN,IXOUT,NCHAN)                              
      INTEGER *4 IXIN(1),IXOUT(1),I,J,NPTS,NCHAN
C
      DO 11 I = 1,NCHAN
         IXOUT(I) = IXIN(I)
   11 CONTINUE
      I = 0
   12 CONTINUE
      I = I + NCHAN
      DO 13 J = 1,NCHAN
         IXOUT(I+J)=IXOUT(I+J-NCHAN) - IXIN(I+J)
   13 CONTINUE
      IF(I .LT. NPTS) GOTO 12
   10 CONTINUE
      RETURN
      END
C***********************************************************************
c

      subroutine asck(n,ix,xchar,con,ierr)
c 
c   convert integer +/-2048  to 2 byte chars or back if con=-1       
c
c  name changed from asc to asck aug 13, 1992, to avoid name conflict,
c  integer arry now 4 byte to ease programming
c
      implicit none
c...number of samples and array with samples
      integer *4 ix(1)
      integer n
c...character array on return
      character*2 xchar(1)
c...character table used
      character*65 chrnum
c...convertion switch, 1: to asci, -1: to integer
      integer con
c...error parameter, ierr=0 : ok, ierr=1 : not ok
      integer ierr
c...byte 1 and 2
      integer i1,i2
c...intrinsic function
      integer index
c...help varaible
      integer i

c
c   assign numbers to chars
c
      chrnum(1:30)= '0:23456789qwertyuiopasdfghjklz'
      chrnum(31:60)='xcvbnmQWERTYUIOPASDFGHJKLZXCVB'
      chrnum(61:65)='NM-?='
      
      ierr=0
c
c  convert from numbers to 2 byte asci
c
      if(con.eq.1) then
         do 1 i=1,n
            ix(i)=ix(i)+2048
            i1=ix(i)/64
            i2=ix(i)-i1*64+1
            i1=i1+1
            xchar(i)(1:1)=chrnum(i1:i1)
            xchar(i)(2:2)=chrnum(i2:i2)
 1       continue
      endif
c
c   convert to numbers
c
      if(con.eq.-1) then
         do 2 i=1,n
            i1=INDEX(chrnum,xchar(i)(1:1))-1
            i2=INDEX(chrnum,xchar(i)(2:2))-1
            if(i1.eq.-1.or.i2.eq.-1) then
               ierr=1
c               write(17,'(i7,1x,a2)')i,xchar(i)
            endif
            ix(i)=i1*64+i2-2048
 2       continue
       endif
       return
       end

      subroutine merge_f(data1,data2,nhead1,nhead2,nrecord1,nrecord2)
c	Subroutine to merge two S files. All headers are kept.
c
c	Written by C. Lindholm, Aug. -90
c
c
c       Updates:
c              Nov. 25 ; C.L.   ; Change from next line to this line indicator
c              nov 25    j.h.   : put a 1 in header2
c              jul 8 93  jh     : version 3.0 *****************************
c              aug 98    jh     : --------verison 7.0 check ----------------
c                                 include seidim.inc for data array
c              may 2000         : check for different days
c
c	Input:
c		data1 : Vector of character strings containing the first s file
c		data2 : Vector of character strings containing the last s file
c               nhead1: Number of headers in first file
c               nhead2: Number of headers in second file
c               nrecord1: Number of records in first file
c               nrecord2: Number of records in second file
c	Output:
c		data1 : Vector of character strings containing the output file
c               nhead1: Number of headers in output file
c               nrecord1: Number of records in output file
c
c
      implicit none
      include 'seidim.inc'

      character*80 data1(*),data2(*)
c-- number of headers
      integer nhead1,nhead2
c-- number of records
      integer nrecord1,nrecord2
c-- time of two headers
      integer year1,month1,day1,hour1,min1
      real sec1
      integer year2,month2,day2,hour2,min2
      real sec2
      double precision time1,time2
      real timedif
      logical add_day         ! true if a day has to be added
c-- Array used in this routine only
      character*80 local(max_data)
c-- Local variables
      integer nrecord,nhead
c-- Explanatory header
      character*80 explanatory
c-- Counters
      integer i,k
c
c------ Initialize -------
c
      k = 0
      explanatory = ' '
      add_day=.false.
c
c   change id line of 2. file to a comment line
c
      do i=1,nhead2
         if(data2(i)(80:80).eq.'I') data2(i)(80:80)='3'
      enddo
c
c   make sure second header has a 1 if not originally there
c
      data2(1)(80:80)='1'	  
c
c   check if files are from same day
c
      read(data1(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)') 
     *year1,month1,day1,hour1,min1,sec1
      read(data2(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)') 
     *year2,month2,day2,hour1,min1,sec1
      call timsec(year1,month1,day1,hour1,min1,sec1,time1)
      call timsec(year2,month2,day2,hour2,min2,sec2,time2)
      timedif=time2-time1
c
c   first check if files more 24 hours apart
c
      if(abs(timedif).ge.24*3600.0) then
          write(6,*)
     *    ' You cannot merge 2 S-files more than 24 hours apart'
          stop
      endif
c
c   if files not on same day, it must start with earliest file
c
      if(day1.ne.day2) then
         if(time1.gt.time2) then
            write(6,*)' S-files on different days, you must',
     *      ' start with earliest file'
            stop
         else 
            add_day=.true.
         endif
      endif
c
c----- first transfer data1 into local variables -----
c

      nrecord = nrecord1
      nhead = nhead1

      do 10 i=1,nrecord
         local(i) = data1(i)
10    continue
c
c------ then transfer the headers  --------
c
      do 20 i = 1,nhead
         k = k + 1
         data1(k) = local(i)
         if(local(i)(80:80) .eq. '7') then
            explanatory = local(i)
            k = k - 1
            go to 100
         endif
20    continue
100   continue

      do 30 i = 1,nhead2
         k = k + 1
         data1(k) = data2(i)
         if(data2(i)(80:80) .eq. '7') then
            explanatory = data2(i)
            k = k - 1
            go to 200
         endif
30    continue
200   continue
      if(explanatory .ne. ' ') then
         k = k + 1
         data1(k) = explanatory
      endif

      nhead1 = k
c
c------ now transfer phase readings
c
      do 40 i = nhead+1,nrecord-1
         k = k + 1
         data1(k) = local(i)
40    continue
      do 50 i = nhead2+1,nrecord2
         k = k + 1
c
c   check if a day change in case 24 hr might have to be added
c
         if(add_day.and.data2(i).ne.' ') then
            read(data2(i)(19:20),'(i2)') hour2
            if(hour2.le.24) then   ! hour could be from next day already
               hour2=hour2+24
            endif
            write(data2(i)(19:20),'(i2)') hour2
         endif   
         data1(k) = data2(i)
50    continue

      nrecord1 = k

      return
      end

c
c Program: corr
c
c correlate signals to either group events based on waveform similarity
c or determine phase readings through cross-correlation with master event
c
c Lars Ottemoller, BGS, Edinburgh, May 2005
c
ccccccccccccccccccccccccccccccccccccccccc 
c
c changes
c
c  11/10/2004 lot added conversion to single bit data
c                 store event data in y2_save for write out
c                 option to write out correlation function as 0/1 dep on min
c  03/11/2004 lot added cumulative energy and changed time format
c  30/05/2005 lot fixed bug with doubled sample rate
c  18/08/2005 lot added synthetic phase times
c                 identification of groups based on several channels
c                 changed xchar to tchar
c  22/08/2005 lot take out scaling from main part
c  31/01/2006 lot change on data selection for esel_crit.eq.0.
c  02/03/2006 lot check for maximum correlation in continuous mode
c     04/2006 lot write out file cc_pairs.out
c  02/05/2006 lot give index file in corr.inp, keyword 'SFILE INDEXFILE' 
c                 changed array structure, removed event grouping, which
c                 is now done in xclust
c  12/08/2008 lot for first signal, filter first, then select time window
c

c      program corr

c      implicit none                       ! force delcaration of all variables
      include 'winplot1.inc'
      include 'seidim.inc'                ! SEISAN definitions
      include 'libsei.inc'                ! ------------------------
      include 'rea.inc'                   ! parameter common bliock
      include 'waveform.inc'              ! waveform data
      include 'seiplot.inc'
      include 'hypparm.inc'
      integer seiclen
      external sei open,
     &         sei close,computer_type

      character*80 data1(5000),data2(5000)! s-file with data in text array
      character*80 err_text               ! error text
      character*80 infile                 ! input file
      character*80 text

      integer maxch,nch                   ! max number of channels and actual number
      parameter (maxch=99)
      integer maxe                        ! max number of events
      parameter (maxe=50000)
      integer maxph
      parameter (maxph=500)     ! also see dimension of temp in read_corr_inp
      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer i,j,c,k,l,m                 ! counter
      integer maxm
      logical b_flag                      ! flag for file exist
      integer out_unit1,out_unit2         ! output units
      integer out_unit3,out_unit4         ! output units
      integer out_unit5
c out_unit6
      integer out_unit,out_unit7          ! output units
      integer in_unit                     ! input unit
      integer tu                          ! trace unit
      integer read1,write1                ! unit names
      character*80 sfile1(maxe),sfile2(maxe)! s-file names
      integer nmaster,nevent,cevent,cmaster ! number of events and counter
      character*5 station(maxch)          ! station name
      character*4 component(maxch)        ! component name
      character*5 stat(maxch)             ! station name
      character*4 comp(maxch)             ! component name
      real filter_low(maxch),filter_high(maxch)
      logical phase_flag(maxch)
      integer nstations
      real y1(max_sample+1),y2(max_sample),y2_save(max_sample) ! data vectors
      real wav_out_rate_save
      real y(max_sample),y3(max_sample),energy(max_sample+1)
      real cumeng(maxch)
      real amplitude(max_sample+1)
      integer iy(max_sample)
      integer nsamp_sel
      integer nfreq
      integer sel_crit(maxch),esel_crit,selc ! 0 for full trace 
                                             ! 1 for P
                                             ! 2 for S
                                             ! 3 for synth P
                                             ! 4 for synth S
      integer nsamp
      real start,t0,tstart
      integer ierr
      integer start_sample,stop_sample
      real pre_time,time_window(maxch),eselcrit,time_shift
      real pretime_ratio
      integer nset,ndouble_rate
      real ccmwin
      real xreal,rdc
      real x_work(max_sample)
      real y_work(max_sample*3)
      integer npoint_set(3)
      real x_size,y_size,xx0,yy0,aaa,
     &    xx,yy,dc,max
      real thl1_save       
c      real maxcm(maxe,maxe,maxch)
      real maxcm(maxch)
c      real difftime(maxe,maxe,maxch)
      real difftime(maxch)
c      real distm(maxe,maxe)
c      character*1 phasem(maxe,maxe,maxch)
      logical chan_flag(maxch)
      integer nc,ndc
      real cx(1),cy(1)
      character*1 c_spec,key
      character*30 x_text,y_text
      character*80 title,wavefile
      real pi/3.1415972/
      integer nsmooth/10/
      real fmax
      character*80 fheader(max_trace)   ! file headers
      character*1040 theader            ! trace header
      character*80 outf(maxch)
      character*29 headtext
c      character*1 cbyte(max_trace)
      double precision abs_phase_time(maxph)
      character*5 phase_stat(maxph)
      character*4 phase_comp(maxph)
      character*8 cphase(maxph)
      integer interactive
      logical sun,pc,linux
      real      cof(8)                  ! filter coefficients
      real      gain                    ! filter gain
      integer npasses                   ! number of passes, 1 forward,
                                        ! 2 both ways
      real mincorr
      real max1,max2
      integer mode                      ! 1 normal, 2 correlation matrix
      character*80 event_text(2)
c      integer event_pointer(maxe)
      integer ind
c      character*200 event_info(maxe)
      double precision msec1,msec2,msec3,msec4(maxch)
      double precision msecot1,msecot2
      double precision msecph1,msecph2
      integer year,month,day,hour,min,doy,isec
      real sec
      logical gflag,flag
      character*80 index_file
      real start_lat,start_lon,fix_depth
      real lat1,lat2,lon1,lon2,degtorad
      real dist,distdeg,az,maxevdist,maxdifftime,maxstdist
      integer mincorrchan
c      integer c_corrchan(maxe,maxe)
      real slat,slon,sheight,stdist,dist1,dist2
      real depth1,depth2
      integer nmoho,nconrad
      real tmin
      parameter (degtorad=0.0174533)
      real wave_name_option,wave_corr_option
      real running_scale,single_bit,continuous_mode
      real continuous_ext
      integer ncphase,ncphase_new,ext_nchan
      character*160 system_call
      integer nrecord1,nrecord2,nhead1,nhead2
      logical filterflag,tuf,plimit_flag
c
c   chan def block
c
      character*5 def_in_stat(200)  ! input station code in def file
      character*4 def_in_comp(200)  ! input component code in def file
      character*5 def_out_stat(200) ! output station code in def file
      character*4 def_out_comp(200) ! output component code in def file
      integer   def_chan_number(200)! channel number of current unit
      integer ndef_chan             ! number of channels defined
      character*29 dummy1
      character*5 dummy2
      character*12 time1,time2
      character*14 timelong
      common /def_chan/def_in_stat,def_in_comp,def_out_stat,
     *                 def_out_comp,def_chan_number,ndef_chan
      include 'version.inc'
      include 'winplot2.inc'
c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)
      call systime(time1,timelong)
c
c remove index.??? files
c
      if (sun.or.linux) then
        system_call='rm corrind.???'
      elseif (pc) then
        system_call='del corrind.???'
      endif
      call systemc(system_call,seiclen(system_call))

      call get_seisan_def
      call get_model(nmoho,nconrad)
      thl1_save=parm(nl+1)
c
c   get def file for station codes, give file name
c
      text='wavfix.def'
      call read_def_chan(text,dummy1,dummy2)

c
c   open parameter file
c
      call sei open( old$,                 ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'corr.inp',       ! Filename.
     &                   in_unit,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
      call read_corr_inp(in_unit,maxch,maxe,
     &    sfile1,sfile2,nmaster,nevent,interactive,station,
     &    sel_crit,component,time_window,filter_low,filter_high,nch,
     &    mincorr,mode,pretime_ratio,esel_crit,ndouble_rate,ccmwin,
     &    start_lat,start_lon,fix_depth,wave_name_option,
     &    wave_corr_option,running_scale,single_bit,
     &    continuous_mode,continuous_ext,maxevdist,
     &    maxstdist,mincorrchan,maxdifftime,
     &    filterflag,tuf,plimit_flag)
      call sei close(close$,in_unit,code)
c
c   open trace file
c
      if (tuf)
     &  call sei open( unknown$,           ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'corr.trace',     ! Filename.
     &                   tu,               ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
c
c open output file
c
      if (mode.eq.1) then
        call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'corr.out',       ! Filename.
     &                   out_unit2,      ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
      endif

c
c read event info
c
      if (mode.eq.1) then
       do j=1,nevent
        call sei open( old$,               ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   sfile2(j),        ! Filename.
     &                   read1,            ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
        call rea_event_in(read1,all,data1,code)
        event_text(1)=data1(1)(2:79)
c        event_info(j)=sfile2(j)(1:seiclen(sfile2(j)))//
c     &   ': '//event_text(1)(1:78)
        call sei close(close$,read1,code)
       enddo
      else
       do j=1,nevent
        call sei open( old$,               ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   sfile1(j),        ! Filename.
     &                   read1,            ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
        call rea_event_in(read1,all,data1,code)
        event_text(1)=data1(1)(2:79)
c        event_info(j)=sfile1(j)(1:seiclen(sfile1(j)))//
c     &   ': '//event_text(1)(1:78)
        call sei close(close$,read1,code)
       enddo
      endif

      npasses=1
      ndc=0
c
c open output file
c
      if (continuous_mode.eq.1.) then
        call sei open( unknown$,           ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                 'corr_cont.out',! Filename.
     &                   out_unit3,        ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
      endif
      if (mode.eq.2) then
         call sei open( unknown$,          ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'dt.cc',          ! Filename.
     &                   out_unit5,        ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
c      call sei open( unknown$,             ! Open file & stop if erro.
c     &                   ' ',              ! Prompt (n/a).
c     &                   'cc_matrix.out',  ! Filename.
c     &                   out_unit6,        ! Unit opened on.
c     &                   b_flag,           ! Flag.
c     &                   code )            ! Returned condition
        call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'cc_pairs.out',  ! Filename.
     &                   out_unit7,        ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
      endif


c
c loop if corrleation matrix
c

      cmaster=1
5     continue
      if (cmaster.gt.nevent) goto 2000
      write(*,*) ' master # ',cmaster,
     &    ' '//sfile1(cmaster)(1:seiclen(sfile1(cmaster)))
      if (tuf) write(tu,*) ' master # ',cmaster,
     &    ' '//sfile1(cmaster)(1:seiclen(sfile1(cmaster)))
 
c
c loop over all events
c
      if (mode.eq.2) then 
c        cevent=cmaster
        cevent=cmaster+1
      else
        cevent=1
      endif
      do j=1,maxch
        msec4(j)=0.
        cumeng(j)=0.
      enddo
10    continue
      all=.true.                  ! read all parameters
      ncphase=0
      c=1
      if (cevent.gt.nevent) goto 1500
 
      write(*,*) ' event # ',cevent,
     &    ' '//sfile2(cevent)(1:seiclen(sfile2(cevent)))
      if (tuf) write(tu,*) ' event # ',cevent,
     &    ' '//sfile2(cevent)(1:seiclen(sfile2(cevent)))
c
c loop over channels defined in corr.inp
c
20    continue

      if (c.gt.nch) goto 1000
c      maxcm(cmaster,cevent,c)=0.
      maxcm(c)=0.
      phase_flag(c)=.false.
      if(tuf)write(tu,*) ' station ',station(c)
      if (c.gt.1.and..not.chan_flag(c)) then
        if (tuf) write(tu,*) ' no data master/event/channel ',
     &      cmaster,cevent,c
        goto 990   ! skip channel if no data
      endif
      max=0.
      write(*,*) c,' station: '//station(c)//' component: '//
     &   component(c)//' selection: ',sel_crit(c)
      if (tuf) write(tu,*) ' station: '//station(c)//' component: '//
     &   component(c)//' selection: ',sel_crit(c)

c
c   read parameters for first event
c
      if (seiclen(sfile1(cmaster)).le.0) stop
      call sei open( old$,                 ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   sfile1(cmaster),  ! Filename.
     &                   read1,            ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
      call rea_event_in(read1,all,data1,code)
      nhead1=rea_nhead
      nrecord1=rea_nrecord
      event_text(1)=data1(1)(2:79)
ccc lot 31/10/2005
ccc        event_info(cevent)=sfile1(cmaster)(1:seiclen(sfile1(cmaster)))//
ccc     &   ': '//event_text(1)(1:78)
      call sei close(close$,read1,code)
      if (hyp_lat(1).gt.-900) lat1=hyp_lat(1)*degtorad
      if (hyp_lon(1).gt.-900) lon1=hyp_lon(1)*degtorad
      if (tuf) write(tu,*) ' event 1 ',hyp_lat(1),hyp_lon(1)
      depth1=hyp_depth(1)
c origin time of master event
      call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     &  hyp_hour(1),hyp_min(1),hyp_sec(1),msecot1)

c
c read second event
c
      if (seiclen(sfile2(cevent)).le.0) stop
      call sei open( old$,                 ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   sfile2(cevent),   ! Filename.
     &                   read1,            ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
      call rea_event_in(read1,all,data2,code)
      nhead2=rea_nhead
      nrecord2=rea_nrecord
      event_text(2)=data2(1)(2:79)
      call sei close(close$,read1,code)
      if (hyp_lat(1).gt.-900) lat2=hyp_lat(1)*degtorad
      if (hyp_lon(1).gt.-900) lon2=hyp_lon(1)*degtorad
      if (tuf) write(tu,*) ' event 2 ',hyp_lat(1),hyp_lon(1)
      depth2=hyp_depth(1)
c calculate origin time in seconds for event
      call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     &  hyp_hour(1),hyp_min(1),hyp_sec(1),msecot2)

c
c check distance, and skip pair if distance too large
c
      call delaz(lat1,lon1,dist,distdeg,az,lat2,lon2)
      if (tuf) write(tu,*) ' inter event distance(km) = ',dist
      if (tuf) write(tu,*) ' lat1,lon1,lat2,lon2 ',
     &    lat1,lon1,lat2,lon2
c      distm(cmaster,cevent)=dist

      if (maxevdist.gt.0..and.dist.gt.maxevdist) then
        if (tuf) write(tu,*) ' skipping event pair, '//
     &     'distance(km) too large: ',dist
        write(*,*) ' skipping event pair, '//
     &     'distance(km) too large: ',dist
        cevent=cevent+1
        goto 10    ! event loop
      endif

c
c check for available channels in first event, if channel loop first channel
c
      if (c.eq.1) then
        do i=1,nch
          chan_flag(i)=.false.
        enddo
        write(*,*) ' checking for station, master ',cmaster
        call wav_init
        call wav_mem_init
c
c   get trace data file names
c
        call auto_tr(data1,nhead1,wav_nfiles,wav_filename)
c
c read waveform headers
c
        do i=1,wav_nfiles
          call get_full_wav_name(wav_filename(i),wavefile)
          wav_filename(i)=wavefile
          if (wavefile.ne.' ') then
            write(*,*) ' read header ',wav_filename(i)
            call read_wav_header(i)
          endif
        enddo
        write(*,*) ' done '
        do i=1,nch
          do j=1,wav_nchan
            if (station(i).eq.wav_stat(j)) then
              chan_flag(i)=.true.
            endif
          enddo
        enddo
c
c check for available channels in event, at first channel
c
        call wav_init
        call wav_mem_init
        write(*,*) ' checking for station, event ',cevent
c
c   get trace data file names
c
        call auto_tr(data2,nhead2,wav_nfiles,wav_filename)
        do i=1,wav_nfiles
          call get_full_wav_name(wav_filename(i),wavefile)
          wav_filename(i)=wavefile
          write(*,*) ' read header ',wav_filename(i)
          if (wavefile.ne.' ') then
            call read_wav_header(i)
          endif
        enddo
        write(*,*) ' done '
        do i=1,nch
          if (chan_flag(i)) then
            chan_flag(i)=.false.
            do j=1,wav_nchan
              if (station(i).eq.wav_stat(j)) then
                chan_flag(i)=.true.
              endif
            enddo
          endif
        enddo
        if (.not.chan_flag(c)) then
          if (tuf) write(tu,*) ' no data master/event/channel',
     &       cmaster,cevent,c
          goto 990   ! next channel
        endif
      endif
c
c restore thickness of first layer, as station elevation will be added
c
      parm(nl+1)=thl1_save   
c
c get station location
c
      stdist=0.
      call stat_loc(station(c),data1(1)(21:21),slat,slon,sheight)
      if (tuf) write(tu,*) ' station lat,lon,elevation ',
     &     slat,slon,sheight
      slat=slat*degtorad
      slon=slon*degtorad
      if (slat.eq.0..and.slon.eq.0..and.sheight.eq.0.) then
         if (tuf) write(tu,*) ' location unknown for station: ' //
     &                station(c)
         dist1=-1.
         dist2=-1.
      else
        call delaz(slat,slon,dist1,distdeg,az,lat1,lon1)
        call delaz(slat,slon,dist2,distdeg,az,lat2,lon2)
      endif
      if (maxstdist.gt.0..and.dist1.gt.maxstdist) then
        if (tuf) write(tu,*) 
     &    ' skipping station, station/master dist(km) = ',
     &    dist1
        goto 990
      endif
      if (maxstdist.gt.0..and.dist2.gt.maxstdist) then
        if (tuf) write(tu,*) 
     &    ' skipping station, station/event dist(km) = ',dist2
        goto 990
      endif
c
c add station elevation to first layer, this requires the elevation
c to be added to event depths as this is relative to 0 depth
c 
      parm(nl+1)=parm(nl+1)+sheight/1000.
      depth1=depth1+sheight/1000.
      depth2=depth2+sheight/1000.

c
c set pre_time, lot 19/09/2005
c
      pre_time=time_window(c)*pretime_ratio
      if (tuf) write(tu,*) ' PRE TIME = ',pre_time

c
c extract signal
c
      if (sel_crit(c).eq.1.or.sel_crit(c).eq.2) then   ! change 14102004
        start=1.
        selc=sel_crit(c)
      elseif (sel_crit(c).eq.3.or.sel_crit(c).eq.4) then
        if (stdist.eq.-1.) goto 990
        if (sel_crit(c).eq.3) then
          call corr_ttmin(nmoho,nconrad,dist1,depth1,v,tmin)
        else
          call corr_ttmin(nmoho,nconrad,dist1,depth1,vs,tmin)
        endif
        selc=4
        start=0.
c       if (tuf) write(tu,'(a,f20.3)') ' ot phase time hyp ',msecot2+tmin
        if(tuf)write(tu,*) ' master-station dist = ',dist1
c        if(tuf)write(tu,*) ' depth 1 = ',depth1
        if(tuf)write(tu,*) ' travel time master = ',tmin
c
c compute start
c
      else
        selc=4
        start=0.   ! absolute time
      endif
c      pre_time=0.
      err_text=' '
      call spec_select(data1,nhead1,nrecord1,.false.,
     *  station(c),component(c),
     *  selc,start,tstart,t0,nsamp,ierr,err_text)
c
c try to convert component code if channel not found
c
      if (seiclen(err_text).gt.0) then
        err_text=' '
        stat(c)=station(c)
        comp(c)=component(c)
        call set_def_chan(c,stat(c),comp(c))
c        if(tuf)write(tu,*) ' trying ',stat(c),comp(c)
        call spec_select(data1,nhead1,nrecord1,.false.,
     *    stat(c),comp(c),
     *    selc,start,tstart,t0,nsamp,ierr,err_text)
      endif

      if (seiclen(err_text).gt.0) then
        write(*,*) ' skipping '//station(c)//' '//
     &    err_text(1:seiclen(err_text))
        if(tuf)write(tu,*) ' skipping '//station(c)//' '//
     &    err_text(1:seiclen(err_text))
        goto 990
      endif

      wav_out_rate(3)=wav_rate(wav_current_chan(1))
c
c set tstart if synthetic phases
c
      if (sel_crit(c).eq.3.or.sel_crit(c).eq.4) then
        tstart=t0+tmin
      endif

c      if (sel_crit(c).eq.1.or.sel_crit(c).eq.2) then
      if (sel_crit(c).eq.0) then
        start_sample=1
        stop_sample=nsamp
      else
c        start_sample=int((tstart-pre_time)*wav_out_rate(3))
        start_sample=int((tstart-pre_time)*wav_out_rate(3)+.5)+1
        stop_sample=int((tstart+time_window(c))*
     &       wav_out_rate(3))
      endif
      if (start_sample.lt.0) then
         start_sample=1
c        write(*,*) ' wrong time interval '
c        stop
      endif
      if (stop_sample.gt.nsamp) then
        stop_sample=nsamp
c        write(*,*) ' wrong time interval '
c        stop
      endif
c
c check if p signal stops before s start, limit to p
c
      if (plimit_flag.and.sel_crit(c).eq.3) then
        if (tmin*pos-tmin.lt.time_window(c)) then 
          stop_sample=int((tstart+tmin*pos-tmin)*
     &       wav_out_rate(3))
          if (tuf) write(tu,*) 
     &   ' WARNING: P window ends after S arrival, signal cut'
        endif
      endif

c      msecph1=msecot1+tmin
c
c phase time for master signal from waveform data
c
      call timsec(wav_year(wav_current_chan(1)),
     &  wav_month(wav_current_chan(1)),wav_day(wav_current_chan(1)),
     &  wav_hour(wav_current_chan(1)),wav_min(wav_current_chan(1)),
     &  wav_sec(wav_current_chan(1)),msec1)
c      msecph1=msec1+(start_sample-1)/wav_rate(1)+pre_time
      msecph1=msec1+(start_sample-1)/wav_rate(wav_current_chan(1))
     &        +pre_time

      wav_out_stat(3)=wav_stat(wav_current_chan(1))
      wav_out_comp(3)=wav_comp(wav_current_chan(1))
      wav_out_year(3)=wav_year(wav_current_chan(1))
      wav_out_month(3)=wav_month(wav_current_chan(1))
      wav_out_day(3)=wav_day(wav_current_chan(1))
      wav_out_hour(3) = wav_hour(wav_current_chan(1))
      wav_out_min(3) = wav_min(wav_current_chan(1))
      wav_out_sec(3)= wav_sec(wav_current_chan(1))

      call remove_dc(y3,ndc,rdc,nsamp)

      if (filter_low(c).ne.0..and.filter_high(c).ne.0.) then
c        write(*,*) ' filter ',station(c),filter_low(c),filter_high(c)
        if(tuf)write(tu,*) 
     &    ' filter ',station(c),filter_low(c),filter_high(c)
c-- calc. filt. cof.
        call bndpas(filter_low(c),filter_high(c),1000.0/
     *        wav_out_rate(3),cof,gain)
c-- and filter
        call filter(signal1,nsamp,cof,gain,npasses)
c        call filter(y3,nsamp_sel,cof,gain,npasses)
      endif
      j=0
      do i=start_sample,stop_sample
        j=j+1
        y3(j)=signal1(i)
      enddo
      nsamp_sel=j
      wav_out_nsamp(3)=nsamp_sel
c
c moved here 07/2/2006, lot
c
c normalize to 1bit
c
      if (single_bit.eq.1.) then
        do i=1,nsamp_sel
          if (y3(i).ge.0.) then
            y3(i)=1.        
          else
            y3(i)=-1.
          endif
        enddo
      endif
        
c
c if second event is full trace, use the full master trace to find max,
c otherwise just master siganl
c
      max1=1.

      if (esel_crit.eq.0) then
        selc=4
        start=0.
      else
        if (sel_crit(c).eq.1.or.sel_crit(c).eq.2) then
          selc=sel_crit(c)
          start=1.
        elseif (sel_crit(c).eq.3.or.sel_crit(c).eq.4) then
          if (sel_crit(c).eq.3) then
            call corr_ttmin(nmoho,nconrad,dist2,depth2,v,tmin)
          else
            call corr_ttmin(nmoho,nconrad,dist2,depth2,vs,tmin)
          endif
          if (tuf) write(tu,*) ' event-station dist = ',dist2
c          if (tuf) write(tu,*) ' depth 2 = ',depth2
          if (tuf) write(tu,*) ' travel time event = ',tmin
          selc=4
          start=0.
        endif
      endif
      call spec_select(data2,nhead2,nrecord2,.false.,
     *  station(c),component(c),
     *  selc,start,tstart,t0,nsamp,ierr,err_text)
c
c try to convert component code if channel not found
c
      if (seiclen(err_text).gt.0) then
        err_text=' '
        stat(c)=station(c)
        comp(c)=component(c)
        call set_def_chan(c,stat(c),comp(c))
        call spec_select(data2,nhead2,nrecord2,.false.,
     *    stat(c),comp(c),
     *    selc,start,tstart,t0,nsamp,ierr,err_text)
      endif

      if (seiclen(err_text).gt.0) then
        write(*,*) ' skipping '//station(c)//' '//
     &    err_text(1:seiclen(err_text))
        if (tuf) write(tu,*) ' skipping '//station(c)//' '//
     &    err_text(1:seiclen(err_text))
        goto 990
      endif
      wav_out_rate(2)=wav_rate(wav_current_chan(1))
c
c set tstart if synthetic phases
c
c 31/1/2006
c      if (sel_crit(c).eq.3.or.sel_crit(c).eq.4) then
      if (esel_crit.eq.1..and.
     &   (sel_crit(c).eq.3.or.sel_crit(c).eq.4)) then
        tstart=t0+tmin
      endif

c      if (selc.eq.1.or.selc.eq.2) then
c      if (sel_crit(c).ne.0) then
c 31/01/2006 lot
      if (esel_crit.eq.1..and.sel_crit(c).ne.0) then
        if (mode.eq.1) then
c          start_sample=int((tstart-2.*pre_time)*wav_out_rate(2))
          start_sample=int((tstart-2.*pre_time)*wav_out_rate(2)+.5)+1
          time_shift=pre_time
          stop_sample=int((tstart+time_window(c))*
     &       wav_out_rate(2))
        elseif (mode.eq.2) then
c changed lot 08/08/05
c          start_sample=int((tstart-2.*pre_time)*wav_out_rate(2))
          start_sample=int((tstart-2.*pre_time)*wav_out_rate(2)+.5)+1
          time_shift=pre_time   
c          if (ccmwin.ne.999..and.ccmwin.gt.0.) then
          if (ccmwin.gt.0.) then
c            start_sample=int((tstart-pre_time-ccmwin)*wav_out_rate(2))
c            time_shift=ccmwin
            stop_sample=int((tstart+ccmwin)*
     &        wav_out_rate(2))
          else
            stop_sample=int((tstart+time_window(c))*
     &        wav_out_rate(2))
c          time_shift=2.*pre_time
          endif
        endif
      else
        time_shift=pre_time ! added 16/10/2004
        start_sample=1
        stop_sample=nsamp
      endif
      if (start_sample.lt.0) then
        start_sample=1
c        write(*,*) ' wrong time interval '
c        stop
      endif
      if (stop_sample.gt.nsamp) then
        stop_sample=nsamp
c        write(*,*) ' wrong time interval '
c        stop
      endif
c
c check if p signal stops before s start, limit to p
c
      if (plimit_flag.and.sel_crit(c).eq.3) then
        if (tmin*pos-tmin.lt.time_window(c)) then 
          stop_sample=int((tstart+tmin*pos-tmin)*
     &       wav_out_rate(3))
c          if (tuf) write(tu,*) 
c     &   ' WARNING: P window ends after S arrival, signal cut'
        endif
      endif

      if (seiclen(err_text).gt.0) then
        write(*,*) ' skipping '//station(c)//' '//
     &    err_text(1:seiclen(err_text))
        if (tuf) write(tu,*) ' skipping '//station(c)//' '//
     &    err_text(1:seiclen(err_text))
      endif
 
      call timsec(wav_year(wav_current_chan(1)),
     &  wav_month(wav_current_chan(1)),wav_day(wav_current_chan(1)),
     &  wav_hour(wav_current_chan(1)),wav_min(wav_current_chan(1)),
     &  wav_sec(wav_current_chan(1)),msec1)
c
c get absolute time of first channel
c
      call timsec(wav_year(wav_first),
     &  wav_month(wav_first),wav_day(wav_first),
     &  wav_hour(wav_first),wav_min(wav_first),
     &  wav_sec(wav_first),wav_abs_time(wav_first))

c
c time of start sample of extracted event signal
c
      msec1=msec1+(start_sample-1)/wav_out_rate(2)
      msec2=msec1+time_shift
      call sectim(msec1,wav_out_year(2),doy,
     &   wav_out_month(2),wav_out_day(2),wav_out_hour(2),
     &   wav_out_min(2),wav_out_sec(2))


      wav_out_stat(2)=wav_stat(wav_current_chan(1))
      wav_out_comp(2)=wav_comp(wav_current_chan(1))
      wav_out_nsamp(2)=wav_nsamp(wav_current_chan(1))
      wav_out_cbyte(2)='4'

      call remove_dc(signal1,ndc,rdc,wav_out_nsamp(2))
      if (filter_low(c).ne.0..and.filter_high(c).ne.0.) then
c-- calc. filt. cof.
        call bndpas(filter_low(c),filter_high(c),1000.0/wav_out_rate(2),
     *              cof,gain)
c-- and filter
        call filter(signal1,wav_out_nsamp(2),cof,gain,npasses)
      endif
      max2=1.
      j=0
c
c copy signal to y2 array
c
      do i=start_sample,stop_sample
        j=j+1
        y2_save(j)=signal1(i)
        y2(j)=signal1(i)
      enddo
c
c normalize to 1bit
c
      if (single_bit.eq.1.) then
        do i=1,j
          if (y2(i).ge.0.) then
            y2(i)=1.        
            y2_save(i)=1.        
          else
            y2(i)=-1.        
            y2_save(i)=-1.
          endif
        enddo
      endif
        
      wav_out_nsamp(2)=j
      wav_out_rate_save=wav_out_rate(2)
c      write(tu,*) ' scale master/event ',max1/max2

c
c resample signals
c
      if (single_bit.eq.0.) then
        do i=1,ndouble_rate
          if (tuf) write(tu,*) ' doubling sample rate ',wav_out_stat(2),
     &      ' ',wav_out_comp(2),' ',wav_out_rate(2),'->',
     &      wav_out_rate(2)*2.
          call resample_linear(y3,wav_out_nsamp(3),max_sample,
     &     wav_out_rate(3))
          call resample_linear(y2,wav_out_nsamp(2),max_sample,
     &     wav_out_rate(2))
          j=wav_out_nsamp(2)
          call resample_linear(y2_save,j,max_sample,
     &     wav_out_rate_save)
        enddo
      endif

c
c compute correlation, y3 is master signal, y2 is event signal,
c y1 is correlation function
c
      call correlation(y3,wav_out_nsamp(3),y2,wav_out_nsamp(2),
     &     y1,energy,amplitude,wav_out_nsamp(1))

      call sectim(msec2,wav_out_year(1),doy,
     &   wav_out_month(1),wav_out_day(1),wav_out_hour(1),
     &   wav_out_min(1),wav_out_sec(1))

      wav_out_stat(1)=wav_out_stat(2)
      wav_out_comp(1)=wav_out_comp(2)
      wav_out_comp(1)(3:3)='C'
      wav_out_rate(1)=wav_out_rate(2)

      wav_out_cbyte(1)='4'

      if (continuous_mode.eq.0.) then
c
c event based data
c

c
c work out time of maximum
c
c changed lot 18/08/2005
          max=0.  ! added 19/08/2005
c j is index of max correlation
          j=0
c          write(*,*) wav_out_rate(1),stop_sample,start_sample
          do i=1,int(wav_out_rate(1)*
     &      (stop_sample-start_sample))
            if (y1(i).gt.max) then
              max=y1(i)
              j=i
            endif
          enddo

        if (sel_crit(c).eq.1.or.sel_crit(c).eq.3) then 
          cphase(c)='P'
        elseif (sel_crit(c).eq.2.or.sel_crit(c).eq.4) then 
          cphase(c)='S'
        endif
c        maxcm(cmaster,cevent,c)=max
        maxcm(c)=max
        phase_stat(c)=wav_out_stat(1)
        phase_comp(c)=wav_out_comp(1)(1:1)//wav_out_comp(1)(4:4)
c        abs_phase_time(c)=wav_abs_time(wav_current_chan(1))+

        abs_phase_time(c)=msec1+
c     &      pre_time+
     &      time_shift+
     &      (j-1)/wav_out_rate(1)

        msecph2=abs_phase_time(c)

       if (tuf) write(tu,'(a,f20.3)') ' ot phase time wave ',
     &    msecph2
        if (max.ge.mincorr) then
          if (tuf) write(tu,*) station(c)//' phase found '//cphase(c)
          if (tuf) write(tu,*) ' max corr = ',max
          phase_flag(c)=.true.
        else
          if (tuf) write(tu,*) ' correlation below threshold, max = ',
     &       max
          phase_flag(c)=.false.
        endif
c
c store differential travel time between events
c
c        difftime(cmaster,cevent,c)=
        difftime(c)=
     &    (msecph1-msecot1)-(msecph2-msecot2)
c         write(tu,*) ' xxx difftime ',difftime(cmaster,cevent,c),
c     &     msecph1-msecot1,msecph2-msecot2
c        phasem(cmaster,cevent,c)=cphase(c)
      else
c
c continuous mode: search for all times where correlation
c                  is above threshold
        ncphase_new=ncphase+1
        do i=1,wav_out_nsamp(1)
          if (y1(i).gt.mincorr) then
            msec3=msec1+time_shift+(i-1)/wav_out_rate(1)
c require that time difference isbs_phase_time(c) at least 1/2. of time window
            if (msec3.gt.msec4(c)+time_window(c)/2.) then
c
c search for maxiumum within 1/2 window of exceeding threshold
c added 26/2/2006, lot
c
              max=y1(i)
c              write(*,*) ' xxx ',msec3
              k=i
              do j=i,i+int(time_window(c)/2.*wav_out_rate(1))
                if (y1(j).gt.max) then
                  max=y1(j)
                  k=j
                endif
              enddo
              msec3=msec1+time_shift+(k-1)/wav_out_rate(1)
              ncphase=ncphase+1
              if (ncphase.ge.maxph) then
                write(*,*) ' too many detections, stop '
                stop
              endif
              if (sel_crit(c).eq.1.or.sel_crit(c).eq.3) then 
                cphase(ncphase)='P'
              elseif (sel_crit(c).eq.2.or.sel_crit(c).eq.4) then 
                cphase(ncphase)='S'
              endif
              phase_stat(ncphase)=wav_out_stat(1)
              phase_comp(ncphase)=wav_out_comp(1)(1:1)//
     &          wav_out_comp(1)(4:4)
              abs_phase_time(ncphase)=msec3
              call sectim(msec3,year,doy,month,day,hour,min,sec)
              cumeng(c)=cumeng(c)+energy(i)
              if (msec4(c).ne.0.) then
                write(out_unit3,'(a5,1x,i4.4,"-",i2.2,"-",i2.2,"T",
     &               i2.2,":",i2.2,":",i2.2,".",i2.2,1x,f15.3,
     &               1x,f12.3,1x,f15.1,1x,f20.1,1x,f10.1,1x,f5.2)') 
     &          phase_stat(ncphase),
     &          year,month,day,hour,min,int(sec),
     &          int((sec-int(sec))*100.),msec3,msec3-msec4(c),
c     &          energy(i),cumeng(c),amplitude(i),y1(i)
     &          energy(k),cumeng(c),amplitude(k),y1(k)
              endif
              msec4(c)=msec3
            endif
          endif
        enddo
c
c write out event data for times where correlation is above threshold
c
        if (continuous_ext.ge.1.) then
          do i=ncphase_new,ncphase
c
c open extract input file
c
            call sei open( unknown$,         ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'extr.inp',       ! Filename.
     &                   out_unit4,        ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
 
            if (continuous_ext.eq.1.) then
              ext_nchan=1
            elseif (continuous_ext.eq.2.) then
              ext_nchan=wav_nchan
            endif
            write(out_unit4,'(i2)') ext_nchan
            do k=1,ext_nchan
              if (continuous_ext.eq.1.) then
                l=wav_current_chan(1)
              else
                l=k
              endif
              write(out_unit4,'(i3,1x,2f10.3)') 
     &          l,
c     &          abs_phase_time(i)-wav_abs_time(wav_first)-
c     &          pre_time,time_window(c)+2.*pre_time
     &          abs_phase_time(i)-wav_abs_time(wav_first)-
     &          5.,time_window(c)+2.*5.
            enddo

            call sei close(close$,out_unit4,code)

            write(*,*) cevent
            system_call='wavetool -sfile '// sfile2(cevent)
     &        (1:seiclen(sfile2(cevent))) //
     &       ' -chansel extr.inp -wav_out_file SEISAN'
            call systemc(system_call,seiclen(system_call))
          enddo
        endif
      endif

c
c make headers
c
      if (wave_corr_option.ne.0.) then
        wav_out_nchan=2
        headtext='correlated signal'
        call sheads(wav_out_year,wav_out_month,
     *      wav_out_day,wav_out_hour,
     *      wav_out_min,wav_out_sec,wav_out_nchan,1,
     *      wav_out_stat(1),headtext,wav_out_stat,wav_out_comp,
     *      wav_out_nsamp,wav_out_rate,wav_out_cbyte,
     *      outf(c),fheader,theader)

        theader(76:76)='G'
        theader(156:159)='100.'
       
        if (sel_crit(c).eq.1.or.sel_crit(c).eq.3) then
          outf(c)=outf(c)(1:seiclen(outf(c)))//'_P'
        elseif (sel_crit(c).eq.2.or.sel_crit(c).eq.4) then
          outf(c)=outf(c)(1:seiclen(outf(c)))//'_S'
        endif
      write(*,*) ' output file '//outf(c)(1:seiclen(outf(c)))
c
c   open output file
c
        chr_f_form$ = 'unformatted'
        call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   outf(c),          ! Filename.
     &                   out_unit1,         ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
c
c write out correlated signal
c
        do i=1,12
          write(out_unit1) fheader(i)
        enddo
        do j=1,2
          call sheads(wav_out_year,wav_out_month,
     *      wav_out_day,wav_out_hour,
     *      wav_out_min,wav_out_sec,wav_out_nchan,j,
     *      wav_out_stat(j),headtext,wav_out_stat,wav_out_comp,
     *      wav_out_nsamp,wav_out_rate,wav_out_cbyte,
     *      text,fheader,theader)
          write(out_unit1) theader
          nsamp=wav_out_nsamp(j) 
          do k=1,wav_out_nsamp(j)
            if (j.eq.1) then
              if (wave_corr_option.eq.1.) then
                iy(k)=int(y1(k)*100.)
              else
                if (y1(k).ge.mincorr) then
                  iy(k)=1
                else
                  iy(k)=0
                endif
              endif
            endif
            if (j.eq.2) iy(k)=int(y2_save(k))
          enddo
          write(out_unit1) (iy(i),i=1,nsamp)
        enddo
        call sei close(close$,out_unit1,code)
      endif

c
c plot 
c
500   continue
c
c start graphics
c
      if (interactive.eq.1) then
        call open_display

        text=event_text(1)
        i=seiclen(text)
        call tchars(text,i,200.,760.)
        text=event_text(2)
        i=seiclen(text)
        call tchars(text,i,200.,750.)

        text='station: '// station(c)//' '//' component: '//component(c)
        i=seiclen(text)
        call tchars(text,i,200.,740.)
        text='Press f to move forward '
        i=seiclen(text)
        call tchars(text,i,770.,200.)
        text='   or q to quit '
        i=seiclen(text)
        call tchars(text,i,770.,190.)
        nset=1
        npoint_set(1)=wav_out_nsamp(3)
          
        x_size=600.
        y_size=150.
        xx0=120.
        yy0=580.
        aaa=-xx0
        x_text='time (s)'
        y_text='amp'
        title=' '

c
c plot signals
c

c
c first signal
c
        do i=1,wav_out_nsamp(3)
          x_work(i)=i/wav_out_rate(3)
          y_work(i)=y3(i)
        enddo

        call xy_plot(nset,npoint_set,x_work,y_work,
     *     title,x_text,y_text,x_size,
     *     y_size,xx0,yy0,2,0,30.0,0,c_spec,nc,cx,cy)

c
c second signal
c
        npoint_set(1)=wav_out_nsamp(2)
        do i=1,wav_out_nsamp(2)
          x_work(i)=i/wav_out_rate(2)
          y_work(i)=y2_save(i)
        enddo

        yy0=330
        call xy_plot(nset,npoint_set,x_work,y_work,
     *     title,x_text,y_text,x_size,
     *     y_size,xx0,yy0,2,0,30.0,0,c_spec,nc,cx,cy)

c
c third signal
c
        npoint_set(1)=wav_out_nsamp(2)
        do i=1,wav_out_nsamp(2)
          x_work(i)=(i-1)/wav_out_rate(2)
          y_work(i)=y1(i)
        enddo

        yy0=80
        call xy_plot(nset,npoint_set,x_work,y_work,
     *     title,x_text,y_text,x_size,
     *     y_size,xx0,yy0,2,0,30.0,interactive,c_spec,nc,cx,cy)

        if (c_spec.eq.'q'.or.c_spec.eq.'Q') goto 2000
        if (c_spec.eq.'r'.or.c_spec.eq.'R') goto 500
        call clear_to_alpha
      endif

 990  continue
      c=c+1
      goto 20

 1000 continue
c
c end of channel loop
c

c
c check if enough channels above minimum correlation
c lot 21/04/2006
c
      xx=0.   ! average correlation
      m=0     ! number of channels above correlation threshold
c      c_corrchan(cmaster,cevent)=0
      do k=1,nch
c        if (maxcm(cmaster,cevent,k).ge.mincorr) then
        if (maxcm(k).ge.mincorr) then
          m=m+1
c          xx=xx+maxcm(cmaster,cevent,k)
          xx=xx+maxcm(k)
        endif
      enddo   
c
c average correlation
c
      if (m.ne.0.and.m.ge.mincorrchan) then
c        c_corrchan(cmaster,cevent)=m
        xx=xx/float(m)

        if (mode.eq.2) then
c
c write out pair
c
          write(out_unit7,'(i4,1x,a,1x,i4,1x,a,1x,i3,1x,f5.3)') 
     &     cmaster,sfile1(cmaster)(1:seiclen(sfile1(cmaster))),
     &     cevent,sfile1(cevent)(1:seiclen(sfile1(cevent))),m,xx
c
c write out differential times for hypodd
c
c
          flag=.false. ! lot 28/2/2007
          do k=1,nch
            if (maxcm(k).ge.mincorr.and.
     &        abs(difftime(k)).le.maxdifftime) then
                flag=.true.
            endif
          enddo
          if (flag) then
c                  if (k.eq.1) then
                    write(out_unit5,'(a1,1x,i4,1x,i4,1x,f3.1)') 
     &                '#',cmaster,cevent,0.
c                  endif
            do k=1,nch
c                    write(out_unit5,'(a1,1x,i4,1x,i4,1x,f3.1)') 
c     &                '#',i,j,0.
c                  endif
c                  if (maxcm(i,j,k).ge.mincorr.and.
c     &              abs(difftime(i,j,k)).le.maxdifftime) then
c                    write(out_unit5,'(a5,1x,f6.3,1x,f5.3,1x,a1)')
c     &              station(k),difftime(i,j,k),maxcm(i,j,k), 
c     &                phasem(i,j,k)

                  if (maxcm(k).ge.mincorr.and.
     &              abs(difftime(k)).le.maxdifftime) then
                    write(out_unit5,'(a5,1x,f6.3,1x,f5.3,1x,a1)')
     &              station(k),
     &              difftime(k),
     &              maxcm(k), 
     &              cphase(k)
c     &              cphase(c)  ! changed lot 27/02/2007
                  endif
            enddo
          endif
        endif
      endif

      if (mode.eq.1) then
c
c write out s-file
c
        call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   sfile2(cevent),   ! Filename.
     &                   in_unit,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition
        all=.true.
        call rea_event_in(in_unit,all,data1,code) 
        call sei close(close$,in_unit,code)

c
c save amplitudes
c
        j=0
        do i=1,rea_nphase
          if (rea_phase(i)(1:2).eq.'AM') then
            j=j+1
            if (i.ne.j) then
              call rea_phase_clear(j)
              rea_phase(j)=rea_phase(i)
              rea_stat(j)=rea_stat(i)
              rea_co(j)=rea_co(i)
              rea_abs_time(j)=rea_abs_time(i)
              rea_year(j)=rea_year(i)
              rea_month(j)=rea_month(i)
              rea_day(j)=rea_day(i)
              rea_hour(j)=rea_hour(i)
              rea_min(j)=rea_min(i)
              rea_sec(j)=rea_sec(i)
              rea_amp(j)=rea_amp(i)
              rea_per(j)=rea_per(i)
            endif
          endif
        enddo
        rea_nphase=j
        if (wave_name_option.eq.1.) rea_nwav=0
        do i=1,nch
c lot 16/08/2005, always include name
          if (phase_flag(i)) then 
c waveform file names
            if (wave_name_option.eq.1.) then
              rea_nwav=rea_nwav+1
       rea_wav(rea_nwav)='                                        ' 
     &        //'                                       6' 
              write(rea_wav(rea_nwav)(2:1+seiclen(outf(i))),'(a)') 
     &               outf(i)(1:seiclen(outf(i))) 
            endif
c phases
            rea_nphase=rea_nphase+1
            call rea_phase_clear(rea_nphase)
            rea_abs_time(rea_nphase)=abs_phase_time(i)
            rea_stat(rea_nphase)=phase_stat(i)
            rea_co(rea_nphase)=phase_comp(i)
            rea_phase(rea_nphase)=cphase(i)  
          endif
        enddo
c continuous phases
        do i=1,ncphase
          if (i.eq.1) then
c waveform file names
            if (wave_name_option.eq.1.) then
              rea_nwav=rea_nwav+1
       rea_wav(rea_nwav)='                                        ' 
     &        //'                                       6' 
              write(rea_wav(rea_nwav)(2:1+seiclen(outf(i))),'(a)') 
     &               outf(i)(1:seiclen(outf(i))) 
            endif
          endif
          rea_nphase=rea_nphase+1
          call rea_phase_clear(rea_nphase)
          rea_abs_time(rea_nphase)=abs_phase_time(i)
          rea_stat(rea_nphase)=phase_stat(i)
          rea_co(rea_nphase)=phase_comp(i)
          rea_phase(rea_nphase)=cphase(i)  
        enddo
        
        all=.true.
        if (start_lat.ne.999.) hyp_lat(1)=start_lat
        if (start_lon.ne.999.) hyp_lon(1)=start_lon
        if (start_lat.ne.999..or.start_lon.ne.999.)
     &      hyp_epi_flag(1)='S'
        if (fix_depth.ne.999.) then
          hyp_depth(1)=fix_depth
          hyp_depth_flag(1)='F'
        endif
        call rea_event_out(out_unit2,all,data1,code)
c      elseif (mode.eq.2) then
c        do i=1,nch
c          write(out_unit2,'(i3,1x,i3,1x,a5,1x,a4,1x,f6.3)') 
c     &       cmaster,cevent,phase_stat(i),phase_comp(i),
c     &       maxcm(cmaster,cevent,i)
c        enddo
      endif
      cevent=cevent+1
      goto 10    ! event loop
1500  continue
      cmaster=cmaster+1
      goto 5     ! master event loop

2000  continue
c
c commented out below, 02/06/2006
c

c      cevent=cevent-1
c      cmaster=cmaster-1

ccc      if (mode.eq.2) then
ccc        if (mode.eq.1) then
ccc          j=cevent 
ccc        else
ccc          j=cmaster
ccc        endif

c        do k=1,j
c          write(out_unit2,'(i4,1x,a)') 
c     &      k,event_info(k)(1:seiclen(event_info(k)))
c        enddo

c        write(out_unit2,*) ' correlation matrix '
c        do i=1,cevent
c          do j=i,cevent
c              do k=1,nch
c                write(out_unit2,'(i3,1x,i3,1x,a5,1x,a4,1x,i1,1x,f7.3)') 
c     &            i,j,station(k),component(k),sel_crit(k),
c     &            maxcm(i,j,k)
c              enddo
c          enddo
c        enddo

c
c find event groups
c

ccc        write(out_unit2,*) ' event groups '
ccc        event_pointer(1)=0
ccc        do j=2,cevent    ! loop over events
cccc
cccc find event with highest number of correlated channels
cccc
ccc          maxm=0
ccc          max=0.
ccc          ind=0
ccc          event_pointer(j)=0
ccc          do i=1,j-1
ccc            xx=0.
ccc            m=0
ccc            c_corrchan(i,j)=0
ccc            do k=1,nch
ccc              if (maxcm(i,j,k).ge.mincorr) then
ccc            if (tuf) write(tu,*) ' above mincorr ',i,j,k,maxcm(i,j,k),m
ccc                m=m+1
ccc                xx=xx+maxcm(i,j,k)
ccc              endif
ccc            enddo   ! channel loop
ccc
cccc
cccc average correlation
cccc
ccc            if (m.gt.0) xx=xx/float(m)
ccc            if (m.ge.mincorrchan.and.m.gt.maxm.and.xx.gt.max) then
ccc              ind=i
ccc              max=xx
ccc              c_corrchan(i,j)=m
ccc            if (tuf) write(tu,*) ' new max ',i,j,m,xx
ccc            endif
ccc
cccc
cccc write out correlation 
cccc
ccc            write(out_unit6,'(i4,1x,a,1x,i4,1x,a,1x,i3,1x,f5.3)') 
ccc     &         i,sfile1(i)(1:seiclen(sfile2(i))),
ccc     &         j,sfile1(j)(1:seiclen(sfile2(j))),m,xx
ccc
ccc          enddo
cccc 
cccc set pointer, to either correlated event, or to that events'
cccc pointer if set,which builds group of correlated events
cccc
ccc          if (ind.eq.0) then
ccc             event_pointer(j)=0 
ccc          elseif (event_pointer(ind).eq.0) then
ccc              event_pointer(j)=ind 
ccc              c_corrchan(ind,j)=1
ccc          else
ccc              event_pointer(j)=event_pointer(ind) 
ccc              c_corrchan(event_pointer(ind),j)=1
ccc          endif
ccc          if (tuf.and.ind.ne.0) then
ccc            write(tu,*) ' event pointer ',j,event_pointer(j),
ccc     &        c_corrchan(ind,j)
ccc          endif
ccc        enddo
ccc        do i=1,cevent
ccc            index_file=' '
ccc            write(index_file(1:9),'(a8,i3.3)') 'corrind.',i
ccc            call sei open( unknown$,             ! Open file & stop if erro.
ccc     &                   ' ',              ! Prompt (n/a).
ccc     &                   index_file,       ! Filename.
ccc     &                   write1,           ! Unit opened on.
ccc     &                   b_flag,           ! Flag.
ccc     &                   code )            ! Returned condition
ccc            gflag=.false.
ccc            do j=1,cevent
ccc              if (event_pointer(j).eq.i.and.
ccc     &          c_corrchan(i,j).ne.0) then
ccc                if (.not.gflag) then
ccc                  write(out_unit2,*) ' group ',i,i,
ccc     &              ' ',
ccc     &              sfile2(i)(1:seiclen(sfile2(i)))
ccc                  write(write1,'(7x,a)') sfile2(i)
ccc                  gflag=.true.
ccc                endif
ccc                write(out_unit2,*) ' group ',i,j,
ccc     &             c_corrchan(i,j),' ',
ccc     &             sfile2(j)(1:seiclen(sfile2(j))),' ',distm(i,j)
ccc                write(write1,'(7x,a)') sfile2(j)
ccc              endif
ccc            enddo
ccc            if (gflag) then
ccc              call sei close(close$,write1,code)
ccc            else
ccc              call sei close(delete$,write1,code)
ccc            endif
ccc        enddo
ccc      endif

      if (mode.eq.1) then
        call sei close(close$,out_unit2,code)
      endif
      if (mode.eq.2) then
        call sei close(close$,out_unit5,code)
c      call sei close(close$,out_unit6,code)
        call sei close(close$,out_unit7,code)
      endif
      if (continuous_mode.eq.1.)
     &    call sei close(close$,out_unit3,code)
      if (tuf) call sei close(close$,tu,code)
      
      write(*,*)
      if (mode.eq.1) then
        write(*,*) ' nordic output file: corr.out '
      endif
      if (tuf) then
        write(*,*) ' trace output file:  corr.trace '
      endif
      if (mode.eq.2) then
        write(*,*) ' correlated event pairs: cc_pairs.out '
        write(*,*) ' input for hypo_DD: dt.cc '
      endif

      read(time1,'(6i2)') year,month,day,hour,min,isec
      year=year+2000
      sec=float(isec)
      call timsec(year,month,day,hour,min,sec,msec1)

      call systime(time2,timelong)
      read(time2,'(6i2)') year,month,day,hour,min,isec
      year=year+2000
      sec=float(isec)
      call timsec(year,month,day,hour,min,sec,msec2)
c      write(*,*) time1,time2,msec2-msec1
      write(*,*)
      write(*,*) ' run time in sec: ',msec2-msec1

      stop
      end


      subroutine read_corr_inp(in_unit,maxch,maxe,
     &    sfile1,sfile2,
     &    nmaster,nevent,interactive,
     &    station,sel_crit,component,time_window,filter_low,
     &    filter_high,nch,mincorr,mode,pretime_ratio,esel_crit,
     &    ndouble_rate,ccmwin,start_lat,start_lon,fix_depth,
     &    wave_name_option,wave_corr_option,running_scale,
     &    single_bit,continuous_mode,continuous_ext,
     &    maxevdist,maxstdist,mincorrchan,maxdifftime,
     &    filterflag,traceout_flag,plimit_flag)
      implicit none
      character*(*) sfile1(*),sfile2(*)
      character*80 temp(50000) ! same as maxe in main program
      character*5 station(*)
      character*4 component(*)
      character*80 indexfile
      real time_window(*),xreal
      integer sel_crit(*),nch,esel_crit,ndouble_rate
      real filter_low(*),filter_high(*),mincorr,pretime_ratio,ccmwin
      character*80 line
      integer seiclen,in_unit,i,interactive,maxch,maxe,
     &    nmaster,nevent,mode,mincorrchan
      logical filterflag,traceout_flag
      real start_lat,start_lon,fix_depth
      real wave_name_option,wave_corr_option
      real running_scale,single_bit,continuous_mode
      real continuous_ext,maxevdist,maxstdist,maxdifftime
      logical plimit_flag
      integer inu,code
      logical b_flag                      ! flag for file exist
      include 'seidim.inc'                ! SEISAN definitions
      include 'libsei.inc'                ! ------------------------

c
c init
c
      sfile1(1)=' '
      xreal=1.
      nch=0
      interactive=0.
      nevent=0
      nmaster=0
      mincorr=.5
      filterflag=.true.
      mode=1
      pretime_ratio=0.1
      plimit_flag=.true.
      esel_crit=0.
      ndouble_rate=0
      ccmwin=999.
      start_lat=999.
      start_lon=999.
      fix_depth=999.
      wave_name_option=0.
      wave_corr_option=0.
      running_scale=0.
      single_bit=0.
      continuous_mode=0.
      continuous_ext=0.
      maxevdist=0.
      maxstdist=0.
      maxdifftime=9.99
      mincorrchan=0
      traceout_flag=.true. 
      indexfile=' '
c
c read input
c
10    continue

      read(in_unit,'(a80)',end=20) line

c fill missing characters
      do i=seiclen(line)+1,80
        line(i:i)=' '
      enddo

      if (line(1:12).eq.'SFILE MASTER') then
        nmaster=nmaster+1
        sfile1(nmaster)=line(41:seiclen(line)) 
        if (seiclen(sfile1(nmaster)).le.0) nmaster=nmaster-1
      elseif (line(1:11).eq.'SFILE EVENT') then
        nevent=nevent+1
        if (nevent.ge.maxe) then
          write(*,*) ' too many stations in corr.inp ' 
          stop
        endif
        sfile2(nevent)=line(41:seiclen(line)) 
        if (seiclen(sfile2(nevent)).le.0) nevent=nevent-1
      elseif (line(1:15).eq.'SFILE INDEXFILE') then
        indexfile=line(41:seiclen(line))
      elseif (line(1:11).eq.'INTERACTIVE') then
        read(line(41:),*) xreal
        interactive=int(xreal)
      elseif (line(1:6).eq.'FILTER') then
        read(line(41:),*) xreal
        if (xreal.ne.1.) filterflag=.false.
      elseif (line(1:12).eq.'TRACE OUTPUT') then
        read(line(41:),*) xreal
        if (xreal.ne.1.) traceout_flag=.false.
      elseif (line(1:14).eq.'START LATITUDE') then
        read(line(41:),*) xreal
        if (xreal.ne.999.) start_lat=xreal
      elseif (line(1:15).eq.'START LONGITUDE') then
        read(line(41:),*) xreal
        if (xreal.ne.999.) start_lon=xreal
      elseif (line(1:9).eq.'FIX DEPTH') then
        read(line(41:),*) xreal
        if (xreal.ne.999.) fix_depth=xreal
      elseif (line(1:16).eq.'CC MATRIX WINDOW') then
        read(line(41:),*) ccmwin
      elseif (line(1:14).eq.'N DOUBLE SRATE') then
        read(line(41:),*) xreal
        ndouble_rate=int(xreal)
      elseif (line(1:10).eq.'MIN CORR  ') then
        read(line(41:),*) mincorr
      elseif (line(1:13).eq.'MIN CORR CHAN') then
        read(line(41:),*) xreal
        mincorrchan=int(xreal)
      elseif (line(1:18).eq.'MAX EVENT DISTANCE') then
        read(line(41:),*) xreal
        maxevdist=xreal
      elseif (line(1:17).eq.'MAX STAT DISTANCE') then
        read(line(41:),*) xreal
        maxstdist=xreal
      elseif (line(1:13).eq.'MAX DIFF TIME') then
        read(line(41:),*) xreal
        maxdifftime=xreal
      elseif (line(1:10).eq.'SINGLE BIT') then
        read(line(41:),*) xreal
        single_bit=int(xreal)
        if (single_bit.ne.0..and.
     &      single_bit.ne.1.) single_bit=0.
      elseif (line(1:15).eq.'CONTINUOUS MODE') then
        read(line(41:),*) xreal
        continuous_mode=int(xreal)
        if (continuous_mode.ne.0..and.
     &      continuous_mode.ne.1.) continuous_mode=0.
      elseif (line(1:18).eq.'CONTINUOUS EXTRACT') then
        read(line(41:),*) xreal
        continuous_ext=int(xreal)
        if (continuous_ext.ne.0..and.
     &      continuous_ext.ne.1..and.
     &      continuous_ext.ne.2.) continuous_ext=0.
      elseif (line(1:12).eq.'WAVENAME OUT') then
        read(line(41:),*) xreal
        wave_name_option=int(xreal)
        if (wave_name_option.ne.0..and.
     &      wave_name_option.ne.1.) wave_name_option=0.
      elseif (line(1:13).eq.'WAVE CORR OUT') then
        read(line(41:),*) xreal
        wave_corr_option=int(xreal)
        if (wave_corr_option.ne.0..and.
     &      wave_corr_option.ne.1..and.
     &      wave_corr_option.ne.2.) wave_corr_option=0.
      elseif (line(1:13).eq.'RUNNING SCALE') then
        read(line(41:),*) xreal
        running_scale=int(xreal)
        if (running_scale.ne.0..and.
     &      running_scale.ne.1.) running_scale=0.
      elseif (line(1:10).eq.'PRE SIGNAL') then
        read(line(41:),*) pretime_ratio
      elseif (line(1:7).eq.'P LIMIT') then
        read(line(41:),*) xreal 
        if (xreal.eq.1.) then
          plimit_flag=.true.
        else
          plimit_flag=.false.
        endif
      elseif (line(1:13).eq.'EVENT SELCRIT') then
        read(line(41:),*) xreal
        esel_crit=int(xreal)
        if (esel_crit.ne.0.and.esel_crit.ne.1) then
          write(*,*) ' wrong phase selection, has to be 0 or 1 '
          stop
        endif
      elseif (line(1:7).eq.'STATION') then
        nch=nch+1
        if (nch.ge.maxch) then
          write(*,*) ' too many stations in corr.inp ' 
          stop
        endif
        filter_low(nch)=0.
        filter_high(nch)=0.
        sel_crit(nch)=1.
        time_window(nch)=0.
        station(nch)=line(11:15) 
        component(nch)=line(21:24) 
        read(line(31:40),*) xreal
        sel_crit(nch)=int(xreal)
        if (sel_crit(nch).ne.1.and.sel_crit(nch).ne.2.and.
     &      sel_crit(nch).ne.0.and.
     &      sel_crit(nch).ne.3.and.sel_crit(nch).ne.4) then
          write(*,*) ' wrong phase selection, has to be 0-4 '
          stop
        endif
        if (seiclen(line).gt.41)
     &    read(line(41:50),*) time_window(nch)
        if (filterflag) then
          if (seiclen(line).gt.51)
     &      read(line(51:60),*) filter_low(nch)
          if (seiclen(line).gt.61)
     &      read(line(61:70),*) filter_high(nch)
        endif
      endif
15    continue
      goto 10

20    continue

c 
c add sfile names from index file
c
      if (seiclen(indexfile).gt.0) then
        call sei open( old$,               ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   indexfile,        ! Filename.
     &                   inu,              ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )
25      continue
        read(inu,'(a80)',end=30) line
        nevent=nevent+1
        if (nevent.ge.maxe) then
          write(*,*) ' too many stations in corr.inp ' 
          stop
        endif
        read(line(8:seiclen(line)),'(a80)') sfile2(nevent)
        goto 25
30      continue
        call sei close(close$,inu,code)
      endif
c
c sort event array, sfile2(nevent)
c
      do i=1,nevent
        temp(i)=sfile2(i)(14:19)//sfile2(i)(1:13)
      enddo
      call sortfi(temp,nevent)
      do i=1,nevent
        sfile2(i)=temp(i)(7:19)//temp(i)(1:6)
      enddo

c
c if no master event, assume correlation between all events
c
      if (seiclen(sfile1(1)).le.0.and.nevent.gt.0) then
        mode=2
c        mincorr=0.
        do i=1,nevent
          sfile1(i)=sfile2(i)
c          write(*,*) ' master ',i,sfile1(i)
        enddo
      endif
      if (mode.eq.1) maxevdist=0.
      if (mode.eq.1) maxstdist=0.
      if (nmaster.gt.1.) then
        write(*,*) ' too many master events, stop '
        stop
      endif

c
c keep original waveforms if no output files
c
      if (wave_corr_option.eq.0.) wave_name_option=0.
 
      return
      end


      subroutine correlation(y1,nsamp1,y2,nsamp2,yout,
     &    energy,amplitude,nsampout)
c
c compute cross-correlation function
c
      implicit none
      include 'seidim.inc'
      real y1(*),y2(*),yout(*),energy(*),amplitude(*)
      real y2work(max_sample)
      real max1,max2,option
      double precision scale,a1,a2
      integer nsamp1,nsamp2,nsampout,i,j,k,l,n,ndc,rdc 

      scale=0.
      max1=1.
      ndc=0
      a1=0.
      do j=1,nsamp1
        a1=a1+y1(j)**2
      enddo
      do i=1,nsamp2
        max2=1.
        energy(i)=0.
        amplitude(i)=0.
          a2=0.
          n=0
          do k=i,i-1+nsamp1
            n=n+1
            if (k.le.nsamp2) then
              y2work(n)=y2(k)
            else
              y2work(n)=0.
            endif
          enddo
c remove dc
          call remove_dc(y2work,ndc,rdc,nsamp1)
          do k=1,nsamp1
              a2=a2+y2work(k)**2
              if (abs(y2work(k)).gt.max2) max2=abs(y2work(k))
c compute signal energy, assuming signal has no dc offset
              energy(i)=energy(i)+y2work(k)**2
          enddo
        amplitude(i)=max2
        yout(i)=0.
        do j=1,nsamp1
          if (i-1+j.le.nsamp2) then
            yout(i)=yout(i)+y2work(j)*y1(j)
          endif
        enddo
c normalise so that maximum of auto-correlation is 1
        yout(i)=yout(i)/sqrt(a1*a2)
      enddo
      nsampout=nsamp2
      return
      end


      subroutine resample_linear(y,nsamp,max,rate)
      implicit none
      real y(*),rate
      integer nsamp,n,i,c,max

      n=2
      rate=rate*2.

      if (n.eq.1) return
      if (nsamp*n.ge.max) then
        write(*,*) ' too many samples for resample '
        stop
      endif
c
c first spread samples over array
c
      c=nsamp
      do i=(nsamp-1)*n+1,n+1,-n
        y(i)=y(c)
        y(c)=0.
        c=c-1
      enddo
      nsamp=(nsamp-1)*n+1
c      do i=1,nsamp
c        write(*,*) y(i)
c      enddo

      do i=n,nsamp-1,n
        y(i)=(y(i-1)+y(i+1))/2.
      enddo

      return
      end

      subroutine get_model(nmoho,nconrad)
c
c read test parameters and model from STATION0.HYP
c
      implicit none
      include 'hypparm.inc'
      character*80 infile
      character*80 indat,testdat
      character*1 reff,ucase
      character*4 stat
      logical exist
      character*80 top_directory
      character*1 dchar
      real testj
      integer seiclen,j,iustat,i
      integer nmoho,nconrad
c
c get directory structure
c
      call topdir(top_directory)
      call dir_char(dchar)         ! dirctory delimiter character

      infile='STATION0.HYP'
      inquire(file=infile, exist=exist)

      if (.not.exist) then
         infile = top_directory(1:seiclen(top_directory)) // dchar // 
     &         'DAT' // dchar //
     &         infile(1:seiclen(infile))
         inquire(file=infile, exist=exist)
         if (.not.exist) then
           write(*,*) 'station file does not exist !'
           stop
         endif
      endif
      open(9,file=infile)
      iustat=9         
c    set test parameter defaults
      call settest(test)

c    read test parameter changes and station data
        stat='xxxx'
        j=-1
        
      do while (stat.ne. '    '.and.j.ne.0)
         read(iustat,'(a80)')testdat
         if(testdat(14:14).eq.')')then
          read(testdat,'(a4,t12,i2,t16,f9.4)')stat,j,testj
         elseif(testdat(13:13).eq.')')then
          read(testdat,'(a4,t12,i1,t15,f9.4)')stat,j,testj
         else
          read(testdat,'(a4)')stat
          j=-1
         endif
         if(j.gt.0)then
          test(j)=testj
         endif
      end do

      indat='XXXXXXXX'
      do while (indat(1:8).ne.'        ')
       read(9,'(a80)')indat
      end do

c read the velocity model
      i=1
      iustat=9
        
c    reff is used to specify the moho layer for PN calculation
5     read(iustat,101,end=99)v(i),d(i),vs(i),reff
101   format(3f7.3,a1)
      if(ucase(reff).eq.'N')nmoho=i

c 4/94: added nconrad variable
      if(ucase(reff).eq.'B')nconrad=i
        
        if(v(i).eq.0.0)go to 6
        i=i+1
        go to 5

c    nl is the number of layers in the velocity model
6       nl=i-1
      
c    read in trial depth and vp/vs ratio
        read(iustat,'(3f5.0,f5.2)',end=99)ztr,xxnear,xxfar,pos

c    if vs(1)=0 then set vs(i)=v(i)/pos
        if(vs(1).eq.0.0)then
          do i=1,nl
            vs(i)=v(i)/pos
          end do
        endif

c  store thicknesses in parm
        do i=1,nl-1
          parm(nl+i)=d(i+1)-d(i)

c    change 10/93: add maximum elevation to upper layer thickness
c    if test(40)=0.0 Need this because dtdx2 origin is always at maxelv
c          if(i.eq.1.and.test(40).eq.0.0)then
c            parm(nl+i)=d(i+1)-d(i)
c          endif
        end do
        do i=1,nl
          parm(i)=v(i)
        end do
        
99    continue
      close(9)
      close(10)
      end
      

      subroutine corr_ttmin(nmoho,nconrad,dist,depth,veloc,tmin)
      include 'hypparm.inc'
      character*80 indat,testdat
      character*1 reff,ucase,prmd,prm2
      character*8 phsid
      real veloc(*)
      real rearth,degtorad,dist,depth,stel
      integer seiclen,nmoho,nconrad

c settings as in hypocent
      degtorad=0.0174533
      rearth=6371.
      minflag=int(test(63))
        
c    xs(1), xs(2) are the station long. and lat.
      x0(1)=0.0
      x0(2)=0.0
      x0(3)=0.0
      
      prmd=' '                        
      prm2=' '

      xh(1)=dist/rearth
      xh(2)=0.
      xh(3)=depth

      do i=1,nl
        parm(i)=veloc(i)
      enddo

      call dtdx2(xh,x0,prmd,nmoho,nconrad,iulst,tmin,
     &  dx,delta,ann,iflag,phsid)
      if(iflag.eq.0)tmin=0.0
      return 
      end

      

c
c   Program to append seisan waveform files jh, sep 99
c
c   The program uses a filenr.lis input file. All files are read,
c   and  then written out as one new file.
c   The maximum number of channels handles is max_chan_out which
c   is set as a parameter. Only the first max_chan_out channels
c   are used or less if fewer channels in file.
c   A blank line followed by a new group of file will make a new 
c   output file.
c
c   It is assued that all channels have the same start and end times
c   in the same file
c   and that the sample rate is the same.
c
c   The sample rate for the appended file, if more than one input file, is 
c   calculated from the header times of the first and last files. 
c
c
c   changes:
c
c   may 2000 lo : new waveform structure
c
      implicit none
      include 'seidim.inc'                     ! dimensions
      include 'waveform.inc'
C
C    Seisan library details...
C    -------------------------
C
      INCLUDE   'libsei.inc'                   ! Definitions and data defns.
      external  sei open,                      ! Open file handler.
     &          sei close,                     ! Close file handler.
     &          sei code,                      ! Error handler.
     &          sei clen                       ! String length
      integer   sei clen                       ! Function.
c
      integer   code,                          ! Local error condition.
     &          read1                          ! Read unit 1.
      logical   b_flag                         ! Flag existance.?
C
C    -------- end ------------
c                                                                               
c                                                                               
c   local variables                                                             
c                                                          
      integer max_chan_out                ! max number of channels out
      parameter (max_chan_out=7)   
      character*80 mainhead(max_trace)    ! main header
      character*80 mainhead_out(max_trace)! output ----
      character*1040 chead                ! channel header                     
      character*1040 chead_out(max_chan_out)         ! output channel header
      integer isamp(max_chan_out)         ! output sample counter                                                                                
      character*5 net_code                ! code for resampled file
      integer ifile                       ! file counter
      integer nfile                       ! number of files in one sequence
      integer ichan                       ! channel counter
      integer numb_samp                   ! number of samples, one trace
      integer numb_samp_total             ! -------------------------, all
      integer unit_wave                   ! unit to read waveform file from
      integer write01                     ! unit for writing
                                          ! between two files
      real rate                           ! sample rate from header
      real rate_out                       ! sample rate calculated
      logical more_files                  ! there could be more files
c-- plotting string                                      
      character*80 files(200)             ! waveform file name
      character*80 out_file,outfile       ! resampled file name
c-- dc value                                                      
c      integer nchan                          ! number of channels in file
c      integer nchan_out                      ! number of channels out
      double precision   file_start_time     ! abs file start time
      double precision   file_end_time       ! abs file end time
      double precision   first_file_time     ! abs file time, first file
                                             ! decimated output
      real total_time
      integer year1,month1,day1,hour1,min1    ! time etc
      real sec1
c-- counters and help variables
      integer	i		
      integer data_out(max_chan_out,max_sample)  !output 
c
c  for seisin common block
c
c      real data(max_sample)
c      real baz(max_trace)
c      real        del_rot       ! delay rotated trace
c      character*1 rot_comp(max_trace)  ! T or R
c      logical rotate

c      common /signal/data,rotate,baz,rot_comp,del_rot !for seisinc
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      write(6,*)
     *' Enter new network code, default is channel one station'
      read(5,'(a5)') net_code
c
c    open file containing list of files numbered                                
c    -------------------------------------------
c                                                                               
      call sei open( old$+warn$,           ! Open & warn of errors.
     &               ' ',                  ! No prompt.
     &               'filenr.lis',         ! Filename.
     &               read1,                ! Open on unit.
     &               b_filenr$,            ! Flag existance & usage?.
     &               code )                ! Condition.
      chr_err_msg$ = 
     &'**** FATAL: problem opening "filenr.lis"'
      call sei code( stop$, code, 0, b_flag ) ! Force an abort on error.
c
c   get  here for another set of files to convert
c
 500  continue
c
c   set some defaults
c
      ifile=1
      do i=1,max_chan_out
         isamp(i)=0                               ! reset output sample counter
      enddo
      numb_samp_total=0
c
c  file read loop
c
 1000 continue
c
c   get next file name
c
      read(read1,'(7x,a)',iostat=code) files(ifile)           ! Read a record.
      call sei code( fort$, code, read1, b_flag )             ! Process outcome.
      if( b_flag.and.ifile.eq.1 ) goto 1999                   ! On end of file.
c-- no more files                        
      if(files(ifile)(1:5).eq.'     '.or.b_flag) then !  new group or eof
         more_files=.true.                ! there could be more files
         nfile=ifile-1                    ! the last was blank
         if(nfile.eq.0) goto 1000         ! could be more blanks
         goto 1200
      endif
      ifile=ifile+1
      goto 1000                           ! read next file
c
c   read filenames of one group, now process
c
 1200 continue
c
c   open and read first file to get specifics
c
      write(6,*)'*********************************************'
      write(6,*) ' Number of files to append:', nfile
      write(6,*)
c      chr_f_access$ = 'direct'            ! Type of file.
c      f_recl$=2048                        ! Record length
c      call sei get file( open$+ignore$,   ! Open waveform file.
c     &                   unit_wave,       ! On unit.
c     &                   code,            ! Returned condition.
c     &                   'WAV',           ! Alternative search directory.
c     &                   files(1))        ! For this filename.
c 
c         if( code .ne. e_ok$ ) then       ! File does not exist
c            write(*,*)
c            write(*,*)
c     &'**** WARN: ',files(ifile)(:seiclen(files(ifile)))
c     &,' does not exist ****'
c            write(*,*)
c            call sei code(stop$,e_misf$,0,b_flag) ! & stop.
c         end if                                   !
c
c   read main header 
c

      wav_filename(1)=files(1)
c
c init wave variables
c
      call wav_init
c
c read header
c
      call read_wav_header(1)
      if(wav_error_message.ne.' ') then
         write(6,'(1x,a)') wav_error_message
         stop   
      endif
c
c generate main header
c
      call wav_sheads(1,net_code,outfile,mainhead,chead)

c      call seisinc                                                           
c     *(unit_wave,0,nchan,0,
c     *mainhead,chead,0.0,0.0)
c      call sei close( close$, unit_wave, code )       ! Close down file

c
c   check for error
c
c      if(nchan.lt.0) then
c         write(6,*)' Something wrong with first file in a sequence'
c         stop
c      endif

   
c
c   save header and file name
c
      do i=1,12
          mainhead_out(i)=mainhead(i)
      enddo
c
c   if more than max_chan_out channels, cut down to max_chan_out 
c
      if(wav_nchan.gt.max_chan_out) then
         write(6,*)' Input file has ',wav_nchan,' channels'
         write(6,*)' The output will only use ',max_chan_out
         wav_out_nchan=max_chan_out
      else
         wav_out_nchan=wav_nchan
      endif
      write(6,*)' Number of channels use:',wav_out_nchan
c
c-------------------------------------------
c   loop for channels
c-------------------------------------------
c                           
      do 1600 ichan=1,wav_out_nchan
c
c   loop for files
c
      do 1500 ifile=1,nfile
         write(6,'(1x,a)') files(ifile)
c        write(27,'(1x,a)') files(ifile)
c         chr_f_access$ = 'direct'            ! Type of file.
c         f_recl$=2048                        ! Record length
c         call sei get file( open$+ignore$,   ! Open waveform file.
c     &                      unit_wave,       ! On unit.
c     &                      code,            ! Returned condition.
c     &                      'WAV',           ! Alternative search directory.
c     &                      files(ifile))    ! For this filename.
c 
c         if( code .ne. e_ok$ ) then       ! File does not exist
c            write(*,*)
c            write(*,*)
c     &      '**** WARN: ',files(ifile)
c     &      (:seiclen(files(ifile))),' does not exist ****'
c            write(*,*)
c            call sei code(stop$,e_misf$,0,b_flag) ! & stop.
c         end if                                   !
c         call seisinc 
c     *   (unit_wave,ichan,nchan,2,
c     *   MAINHEAD,chead,0.0,0.0)

         wav_filename(1)=files(ifile)
c
c init wave variables
c
         call wav_init
c
c read header
c
         call read_wav_header(1)
         if(wav_error_message.ne.' ') then
            write(6,'(1x,a)') wav_error_message
            stop   
         endif
c
c generate headers 
c
         call wav_sheads(1,net_code,outfile,mainhead,chead)
         write(6,'(1x,a)')mainhead(1)(1:79)            
         write(27,'(1x,a)')mainhead(1)(1:79)            
         write(6,'(1x,a)') chead(1:79) 

c
c read channel
c
         call wav_read_channel(ichan)

c
c   check for error
c
c         if(nchan.lt.0) then
c            write(6,*)' Something wrong with input file'
c            stop
c         endif

c
c   if first file, save channel header
c
         if(ifile.eq.1) then
           chead_out(ichan)=chead
         endif           
c                                                    
c   get srate and number of samples                                               
c                                                                               
c        read(chead(37:50),'(f7.2,1x,i6)') rate,numb_samp
         rate=wav_rate(ichan)
         numb_samp=wav_nsamp(ichan) 
         if(ichan.eq.1) numb_samp_total=numb_samp_total+numb_samp
c
c   get times
c
         year1=wav_year(ichan)
         month1=wav_month(ichan)
         day1=wav_day(ichan)
         hour1=wav_hour(ichan)
         min1=wav_min(ichan)
         sec1=wav_sec(ichan)
         call timsec(year1,month1,day1,hour1,min1,sec1,file_start_time)
c
c   save start time and make output file name if first file
c
         if(ifile.eq.1) then
           first_file_time=file_start_time
           
           if (net_code.eq.'     ') then
             net_code = wav_stat(1)
           endif
           call wav_sheads(1,net_code,out_file,mainhead,chead)
           out_file(19:19)='A'
         endif

c
c  put in  output buffer
c
         do i=1,numb_samp
           isamp(ichan)=isamp(ichan)+1
           data_out(ichan,isamp(ichan))=signal1(i)
         enddo
c
c         call sei close( close$, unit_wave, code )       ! Close down file
         file_end_time=file_start_time+(numb_samp)/rate ! start of next file
c
c  end of file loop
c
 1500 continue
c
c   end of channel loop
c
 1600 continue
c
c-----------------------------------------------------------------------
c   enter here when all files read for one sequence
c-----------------------------------------------------------------------
c
c
 1700 continue
c
c   calculate observed sample rate if more than one file read, assume
c   file follow each other
c
c     if(nfile.gt.1) then
c        rate_out=
c    *   (file_start_time-first_file_time)/(numb_samp_total-numb_samp)
c        rate_out=1.0/rate_out
c        write(6,*) 'Sample rate from header times:', rate_out
c        rate=rate_out
c     endif
c
c  calculate new sample rate
c
c     rate=rate/float(skip)
c
c   finish making main header and write it out, assume max 30 channels
c
      total_time=float(isamp(1))/rate       ! assume all channels same isamp
      write(mainhead_out(1)(61:69),'(f9.2)') total_time
      write(mainhead_out(1)(31:33),'(i3)') wav_out_nchan
      do i=3,(wav_out_nchan-1)/3+3
         if(total_time.gt.99999.0) then
            write(mainhead_out(i)(19:26),'(f8.1)') total_time
            write(mainhead_out(i)(45:52),'(f8.1)') total_time
            write(mainhead_out(i)(71:78),'(f8.1)') total_time
         else
            write(mainhead_out(i)(19:26),'(f8.2)') total_time
            write(mainhead_out(i)(45:52),'(f8.2)') total_time
            write(mainhead_out(i)(71:78),'(f8.2)') total_time
         endif
      enddo
      write(6,'(a,1x,a)') ' Output file name is: ',out_file(1:40)
c
c   open file and write main header
c
      chr_f_form$ = 'unformatted'
      call sei open( unknown$,             ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   out_file,         ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
      do i=1,12
         write(write01)mainhead_out(i)
         if(i.lt.4) write(6,'(a79)') mainhead_out(i)(1:79)		 
      enddo
c
c   write channels, 99999945 to round off
c
      do ichan=1,wav_out_nchan
         chead_out(ichan)(1:5)=wav_stat(ichan)
         chead_out(ichan)(6:9)=wav_comp(ichan)
         write(chead_out(ichan)(37:50),'(f7.3,i7)')rate,isamp(ichan)
         if(rate.lt.99.999945)
     *   write(chead_out(ichan)(37:50),'(f7.4,i7)')rate,isamp(ichan)
         if(rate.lt.9.9999945)
     *   write(chead_out(ichan)(37:50),'(f7.5,i7)')rate,isamp(ichan)
         if(rate.lt.0.99999945)
     *   write(chead_out(ichan)(37:50),'(f7.6,i7)')rate,isamp(ichan)
         chead_out(ichan)(77:77)='4'    ! always store as 4 byte
         write(write01) chead_out(ichan)
         write(6,'(1x,a)') chead_out(ichan)(1:79)
         write(write01) (data_out(ichan,i),i=1,isamp(ichan))
      enddo
      call sei close( close$, write01, code )       ! Close down file
c
c  check if more files to convert
c
      goto 500
c
c
 1999 continue
      stop
      end

c
c    
c
c        checks existance of waveform files form nmes in a cat-file
c        chack for existance of calibration files
c        make script file for copying waveform file to current directory
c
c
c   LATEST UPDATE
c
c   march 31 99 by jh : -----------  version 7.0 check --------------
c                       add linux logic
c   jan 2001       jh : more output
c   sep 2008       jh : check for cal files
c   oct 2 2008     jh : change file type to bat for pc

c
      implicit none
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! Dimentions
       include 'waveform.inc'              ! waveform handling routines
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c INPUT FILE                                 
      character file1*80
c EVENT TYPE, L,R OR D                     
      character evtype1*1
c RECORDS IN FILE 1                     
      character data1(max_data)*80
      integer errflag
c EXPLOSION INDICATOR                        
      character exp1*1
c NUMBER OF STATIONS                            
      integer nstat1
c NUMBER OF RECORDS and phasesFOR EVENT                 
      integer nrecord1,nphase
c NUMBER OF HEADERS FOR EVENT                   
      integer nhead
      character*80 wave_file
      character*80 text
      integer seiclen
      integer k
c id line number
      integer id
c indicator for compact file
      logical compact
c EVENT COUNTERS          
      integer  nevent
c calibration file name with path
       character*80 cal_file
c  alll cal files
       character*80 cal_file_all(5000)
c  counter for cal files
       integer ncal,ncal_mis
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1
       integer          read01
       integer year,month,day,hour,min
       real sec
c write unit #1
       logical sun,pc,linux            ! computer types 
       integer n_wav_total
       integer n_wav_present
       integer n_wav_none,istart
       integer i,l,m


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c    SET DEFAULTS AND INITIAL PARAMETERS
c
c
      call computer_type(sun,pc,linux)
      nevent = 0
      n_wav_total = 0
      n_wav_present=0
      n_wav_none=0
      call get_seisan_def
      ncal=0
c
c  OPEN FILE
c
      write(6, fmt=*) ' INPUT FILE  NAME'
      read(5, fmt='(A)') file1
c
             call sei open(old$+warn$,            ! Open a existing file.
     &                     ' ',                   ! Prompt file name (n/a).
     &                     file1,                 ! File name
     &                     read01,                ! Read unit #1
     &                     b_old,                 ! Already exists? (n/a).
     &                     code)                  ! Returned condition.
      if (.not. b_old) go to 999
      errflag = 0
      open(1,file='get_wav.out',status='unknown')
      if(.not.pc) then
         open(2,file='copy_wav.out',status='unknown')
         open(4,file='copy_cal.out',status='unknown')
      else
         open(2,file='copy_wav.bat',status='unknown')
         open(4,file='copy_cal.bat',status='unknown')
      endif

      open(3,file='copy_wav_missing.out',status='unknown')
      open(7,file='copy_cal_missing.out',status='unknown')
c
c   find if full file or compact file
c
      call nortype(read01,compact)
      if(compact) then
        write(6,*)' Input file is compact, no waveform info'
        stop
      endif
c
c   READ  EVENT 
c
    1 continue
      nrecord1 = 1
      call indata(read01, nstat1, nphase,
     *     nhead, nrecord1, evtype1, exp1, data1,id)
c
c   CHECK FOR EOF
c
      if (nrecord1 .eq. 0) goto 2
c
c   check waveform file names
c
      k=0
      do i = 2, nhead
         if(data1(i)(80:80).eq.'6'.and.data1(i)(2:2).ne.' ') then
            n_wav_total=n_wav_total+1
            wave_file=' '
            wave_file(1:78)=data1(i)(2:79)
            call  get_full_wav_name(wave_file,text)
            if(text.eq.' ') then
c commented in
               write(6,'(a,a)') 
     *           ' File does not exist: ',wave_file(:seiclen(wave_file))
                 if(pc) write(3,'(a,a,a)') 'copy ',
     *           wave_file(:seiclen(wave_file)),',xx' 
                 if(sun.or.linux) write(3,'(a,a,a)') 'cp ',
     *           wave_file(:seiclen(wave_file)),' xx'
            else
               n_wav_present=n_wav_present+1
               write(6,'(a,a)') 
     *           ' Full path name    :  ', text(:seiclen(text))
                 if(pc) write(2,'(a,a)') 'copy ',text(:seiclen(text))
                 if(sun.or.linux) write(2,'(a,a,a)') 'cp ',
     *           text(:seiclen(text)),' .'
c
c   check for response files
c
                 wav_filename(1)=text(:seiclen(text))
                 call wav_init
                 call read_wav_header(1)  ! get headers
c                 write(6,*)' Number of channels', wav_nchan
                 do l=1,wav_nchan
                    call find_resp_file(wav_stat(l),
     *              wav_comp(l),wav_abs_time,cal_file,istart)
                    if(cal_file.eq.' ') then
                       call sectim(wav_abs_time(l),year,m,month,
     *                 day,hour,min,sec)
                       write(7,'(a,2x,a5,1x,a4,2x,i4,4i3,f5.1)')
     *                 ' No calibration file for '
     *                 ,wav_stat(l),wav_comp(l),
     *                 year,month,day,hour,min,sec
                       ncal_mis=ncal_mis+1
                    else
                       if(ncal.eq.0) then
                          ncal=1                       ! first file found
                          cal_file_all(ncal)=cal_file  ! save
                       else                            ! check if file saved already
                          do m=1,ncal
                             if(cal_file.eq.cal_file_all(m))
     *                       goto 200                  ! skip, file already there
                          enddo
                          ncal=ncal+1
                          cal_file_all(ncal)=cal_file  ! save
 200                      continue
                       endif 
                    endif                       
c                   write(6,*) cal_file
                 enddo               
               k=k+1
            endif
        endif
      enddo
c
      if(k.eq.0) then
         n_wav_none=n_wav_none+1 
c         write(6,'(a)')' No waveform file names for this event'
      else
          write(1,'(a)') (data1(l),l=1,nrecord1)
      endif
c
c
c   COUNT EVENTS
c
      nevent = nevent + 1
c
c  BACK FOR NEXT EVENT
c
      goto 1

c
c   write summary
c

    2 continue
c
c
c   print out cal files found
c
      do i=1,ncal
        if(pc) write(4,'(a,a)') 'copy ',cal_file_all(i)                
        if(sun.or.linux) write(4,'(a,a,a)') 'cp ',cal_file_all(i),' .'
      enddo  
c
c   info
c
  
      write(6,*)
      write(6,*)' Total number of events',nevent
      write(6,*)' Number of events without waveform files',n_wav_none
      write(6,*)' Number of waveform files',n_wav_total
      write(6,*)' Number of waveform files present', n_wav_present
      write(6,*)' Number of waveform files missing', 
     *n_wav_total-n_wav_present
      write(6,*)' Number of cal files found', ncal
      write(6,*)' Maximum number of cal files missing ', ncal_mis      
      write(6,*)' Output file with events is get_wav.out'
      if(.not.pc) then
         write(6,*)
     *   ' Output file with waveform file names is copy_wav.out'
         write(6,*)
     *   ' Output file with cal files is copy_cal.out'
      else
         write(6,*)
     *   ' Output file with waveform file names is copy_wav.bat'
         write(6,*)' Output file with cal files is copy_cal.bat'
      endif
      write(6,*)' Output file with waveform file names missing',
     *          ' is copy_wav_missing.out'

      write(6,*)' Output file with missing calibration channels is',
     *          ' copy_cal_missing.out' 
      write(6,*)
      call sei close (close$,read01,code)
999   continue
      stop 
      end

      subroutine nortype(unit,compact)
c
c   check if file is compact or not.
c
c   jh july 1993
c
c   updates
c
c   sep 16 98, jh : ---------   version 7.0 check-------------------
c                   no changes
c
c   unit : file unit already opened
c   compact: true if compact
c
      implicit none
      character*80 text
      logical compact
      integer i,unit
c
         compact=.true.
c
c  assume that there are not more than 20 epicenter lines for one event
c
         do i=1,20                                                              
            read(unit,'(a80)',end=10) text                                     
            if(text(22:22).ne.'L'.and.text(22:22).ne.'R'.                 
     *      and.text(22:22).ne.'D'.and.text(22:22).ne.' ')                
     *      compact=.false.                                     
c
c   it could be that there are only epicenter lines and blanl lines
c
            if(text(1:30).eq.'                              ') 
     *      compact=.false.
         enddo                      
c
 10      continue                                            
         rewind unit
         return
         end

c
c program to plot traces using GMT
c
c by Lars Ottemoeller, June 2001
c
c
c   april 2003  jh : change call to remove dc

      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common bliock
      include 'waveform.inc'              ! waveform include
      include 'trace_plot.inc'            ! trace_plot include

      character*80 data(5000)             ! s-file with data in text array
      character*80 err_text               ! error text
      character*80 infile                 ! input file

      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer nevent                      ! number of events in file
      integer i,j,nfiles                  ! counters
      character*80 outfile                ! output filename
      character*80 xfile                  ! waveform filename
      integer seiclen                     ! length of a string
      logical trace_flag(max_trace)       ! true if trace selected
      real trace_dist(max_trace)          ! distances in km
      double precision origin_time        ! origin time in seconds
      real max
      integer last_trace                  ! index to the last selected trace
      character*80 script_file            ! name of script
      character*240 longline
      character*80 line
      real      cof(8)                    ! filter coefficients
      real      gain                      ! filter gain
      integer npasses                     ! number of passes, 1 forward,
                                          ! 2 both ways
      real x(3),y(3)                      ! hypocenter and station location
      real degtorad,distdeg,az0
      real dc
      integer ndc


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver
      call get_seisan_def

      call get_traceplot_def
      npasses=1
      degtorad=0.0174533

c
c   open output file
c
      outfile='trace_plot.data'
      script_file='trace_plot.bat'
      open(2,file=outfile,status='unknown')
    
c
c   get input file name, check if exist
c

 9    continue
      write(6,*) 'Give Nordic input filename '
      read(5,'(a)') infile
      open(1,file=infile,status='old',err=10)
      goto 11
 10    continue
      write(6,*)' No such input file'
      goto 9
 11   continue
c
      all=.true.                  ! read all parameters
      nevent=0                    ! initialize counter

c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c

  50  continue
c
c   read all parameters for one event form file unit 1
c
      call rea_event_in(1,all,data,code)
      x(1)=hyp_lat(1)*degtorad
      x(2)=hyp_lon(1)*degtorad
      x(3)=hyp_depth(1)

      call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     &   hyp_hour(1),hyp_min(1),hyp_sec(1),origin_time)
c
c   check if end of file (code=1), if so jump out of loop
c
      if(code.eq.1) goto 1000
      nevent=nevent+1               ! count events

c
c read all headers
c
      call wav_init
      nfiles=0
      last_trace=0
      wav_nfiles=0
      do i=1,rea_nwav
         xfile=' '
         xfile=rea_wav(i)(2:79)
         xfile=xfile(1:seiclen(xfile))
         call get_full_wav_name(xfile,wav_filename(i))
         write(*,*) ' waveform file: '//wav_filename(i)
     &       (1:seiclen(wav_filename(i)))
         call read_wav_header(i)
         if(wav_error_message.ne.' ') then
            write(6,'(1x,a)') wav_error_message
         endif
      enddo

c
c select channels
c
      do i=1,max_trace
        trace_flag(i)=.true.
      enddo
c
c get distances
c
      do i=1,wav_nchan
        trace_dist(i)=0.
        call stat_loc(wav_stat(i),data(1)(21:21),y(1),y(2),y(3))
        y(1)=y(1)*degtorad
        y(2)=y(2)*degtorad

        if (y(1).ne.0..and.y(2).ne.0.) then
        call delaz(x(1),x(2),
     &        trace_dist(i),distdeg,az0,y(1),y(2))
        else
          write(*,*) ' location unknown for station: '//wav_stat(i)
          trace_flag(i)=.false.
        endif
   
        if (sfileonly_flag) then        
c
c check if station listed in s-file
c
          j=1
          trace_flag(i)=.false.
          do while(j.le.rea_nphase.and..not.trace_flag(i))
            if (wav_stat(i).eq.rea_stat(j)) then
  
              trace_flag(i)=.true.

            endif
            j=j+1
          enddo
        endif
c
c check if channel selected
c
        if (comp_list_cnt.ne.0) then
          j=1
          trace_flag(i)=.false.
          do while(j.le.comp_list_cnt.and..not.trace_flag(i))
            if (wav_comp(i).eq.comp_list(j)) then
              trace_flag(i)=.true.
            endif
            j=j+1
          enddo
          if (.not.trace_flag(i)) write(*,*)
     &         ' channel not selected '// wav_comp(i)
        else
c
c only vertical channels
c
          if (wav_comp(i)(seiclen(wav_comp(i)):seiclen(wav_comp(i)))
     &      .ne.'Z')
     &         trace_flag(i)=.false.
        endif

        if (trace_dist(i).eq.0.) trace_flag(i)=.false.
        if (trace_dist(i).lt.min_dist) trace_flag(i)=.false.
        if (trace_dist(i).gt.max_dist) trace_flag(i)=.false.
c
c set last trace
c
        if (trace_flag(i)) last_trace=i
      enddo
c
c write out trace data
c
      do i=1,wav_nchan
        if (trace_flag(i).eqv..true.) then
          write(*,*) ' reading ... ' ,i,
     &       ' '//wav_stat(i)//' '//wav_comp(i)
c
c read data
c
          call wav_read_channel(i)
c
c remove DC
c
          ndc=0
          call remove_dc(signal1,wav_nsamp(i),dc,wav_nsamp(i))
c
c filter
c
          if (f_low.ne.0..and.f_high.ne.0.) then
            write(*,*) ' filter ', f_low,f_high
c-- calc. filt. cof.
             call bndpas(f_low,f_high,1000.0/wav_rate(i),
     *              cof,gain)
c-- and filter
             call filter(signal1,wav_nsamp(i),cof,gain,npasses)
          endif

c
c get maximum amplitude
c
          max=-1.
          do j=1,wav_nsamp(i)
            if (wav_abs_time(i)+(j-1)/wav_rate(i).ge.
     &        origin_time+min_time.and.
     &        wav_abs_time(i)+(j-1)/wav_rate(i).le.
     &        origin_time+max_time) then

                if (abs(signal1(j)).gt.max) max=abs(signal1(j))

            endif
          enddo
          if (max.eq.0.) max=1.

c
c write data within selected time interval
c
          do j=1,wav_nsamp(i)

            if (wav_abs_time(i)+(j-1)/wav_rate(i).ge.
     &          origin_time+min_time.and.
     &          wav_abs_time(i)+(j-1)/wav_rate(i).le.
     &          origin_time+max_time) then
              write(2,'(2f15.5)') 
     &          wav_abs_time(i)+(j-1)/wav_rate(i)-origin_time,
     &          (signal1(j)/max*amp_scale)+trace_dist(i)
            endif
          enddo
          if (i.le.last_trace) write(2,'(a)') '>'
        endif
      enddo


c
c   get next event
c
      goto 50
c
c     end of file
c
 1000 continue

      write(6,*)            ! blank line
      close(2)              ! close output file

c
c write script file
c
      open(2,file=script_file,status='unknown')
      do i=1,gmt_set_cnt
        write(2,'(a)') set_gmt_def(i)(1:seiclen(set_gmt_def(i)))
      enddo

      longline='psxy trace_plot.data -JX15/25 -X2.5 -Y2.5 -P -W1 -M '

      line=' '
      write(line,'(a,f5.0,a,f5.0,a)') 
     & ' -B:Time:a',(max_time-min_time)/10.,
     & '/:Distance:a',(max_dist-min_dist)/15.,'sWNe '
      do i=2,seiclen(line)
        if(line(i:i).eq.' ') line(i:i)='0'
      enddo
      longline=longline(1:seiclen(longline))//line(1:seiclen(line))

      line=' '
      write(line,'(a4,3(f6.0,a1),f6.0)') ' -RX',min_time,'/',
     &  max_time,'/',min_dist,'/',max_dist
      do i=2,seiclen(line)
        if(line(i:i).eq.' ') line(i:i)='0'
      enddo
      longline=longline(1:seiclen(longline))//line(1:seiclen(line))
     &  //' > trace_plot.ps '
      write(2,'(a)') longline(1:seiclen(longline))
      close(2)
      line='chmod u+x '//script_file(1:seiclen(script_file))
      write(*,'(a)') line(1:seiclen(line))
      call systemc(line,seiclen(line))
      line='./'//script_file(1:seiclen(script_file))
      write(*,'(a)') line(1:seiclen(line))
      call systemc(line,seiclen(line))
      line='gv trace_plot.ps'
      write(*,'(a)') line(1:seiclen(line))
      call systemc(line,seiclen(line))

      write(6,*) 'Number of events in input file', nevent

      stop
      end

      subroutine get_traceplot_def
      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
      include 'trace_plot.inc' 
      real var                      ! parameter values
      character*80 def_file         ! file names
      integer in                    ! file unit
      integer code                  ! return code from opening def file
      integer i                     ! counter
      character*80 line             ! text line


c
c init values
c
      f_low=0.
      f_high=0.
      min_dist=0.
      max_dist=1000.
      min_time=0.
      max_time=1500.
      amp_scale=10.
      comp_list_cnt=0
      sfileonly_flag=.false.
c
c GMT defaults
c
      gmt_set_cnt=4
      set_gmt_def(1)='gmtset PAPER_MEDIA A4+'
      set_gmt_def(2)='gmtset ANOT_FONT_SIZE 10'
      set_gmt_def(3)='gmtset LABEL_FONT_SIZE 12'
      set_gmt_def(4)='gmtset TICK_LENGTH 0.1c'

      def_file = 'trace_plot.par'

      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   in,              ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   def_file )       ! For this filename.

      if(code.ne.e_ok$) then
        write(*,*) ' definition file does not exist: trace_plot.par'
        return
      endif

10    continue

c
c read text line from file, check for code and set variables
c
      read(in,'(a)',end=100,err=100) line

      if (line(1:6).eq.'FILTER') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          f_low=var
        endif
        read(line(51:60),'(f10.1)') var
        if (var.ne.0.) then
          f_high=var
        endif
      elseif (line(1:5).eq.'TIME') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          min_time=var
        endif
        read(line(51:60),'(f10.1)') var
        if (var.ne.0.) then
          max_time=var
        endif
      elseif (line(1:8).eq.'DISTANCE') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          min_dist=var
        endif
        read(line(51:60),'(f10.1)') var
        if (var.ne.0.) then
          max_dist=var
        endif
      elseif (line(1:15).eq.'AMPLITUDE_SCALE') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          amp_scale=var
        endif
      elseif (line(1:18).eq.'STATION_SFILE_ONLY') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          sfileonly_flag=.true.
        endif
      elseif (line(1:9).eq.'COMPONENT') then
        if (line(41:44).ne.' ') then
          comp_list_cnt=comp_list_cnt+1  
          comp_list(comp_list_cnt)=' '
          comp_list(comp_list_cnt)=line(41:44)
        endif
      endif
      goto 10
      
100   continue

      call sei close( close$, in, code )


      return
      end

c
c  program to  read headers in wav files
c
c  j. havskov, march 93
c  Updates:
c  aug 20 93 by jh: clean up                
c  may 95         : more than 30 chan
c  nov 1 95       : use sesinc
c  -----------------------------------------------------------------------
c  oct 17 98 jh   : --------------   version 7.0 check ------------------
c                   year 2000, 5 char station
c
c
c  program is for sun, pc and vax, look for word COMPUTERTYPE, and ajust
c  as shown
c
      implicit none
      include 'seidim.inc'
c-- main header
      character*80 mainhead(max_trace)
      character*1040 chead             ! channel header
c-- input file names
      character*80 infile
c-- number of files, one event
      integer ifile	  
c-- station counter
      integer istat,nstat	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- main header date and time
      integer myear,mmonth,mday,mhour,mmin
      real msec	  
c-- channel start time and interval
      real cstart(max_trace)
      double precision cinter(max_trace)
c-- counters
      integer i,l,k,nout,nchan
c-- station to select
      character*5 station



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c	  	  
      nout=0
c
c  open output file
c
      open(8,file='selsei.out',status='unknown')
c
      write(6,*)' This program assumes that there is a filenr.lis file'
      write(6,*)' of waveform files to search'
      write(6,*)
      write(6,*)'Give station to find'
      read(5,'(a)') station
c
c   open file with file names
c	  	  
      open(7,file='filenr.lis',status='old',err=10)
      goto 11
 10   continue
        write(6,*)' No filenr.lis file, make a dirf first'
        stop
 11   continue
c
c   read headers 
c
      ifile=1
 20   continue 		
      read(7,'(7x,a)', end=999) infile
      write(6,'(a)') infile 
c-- check if end of group of events 	  
      if(infile(1:4).eq.'    ') goto 999  	   	  	  
c
c   now read headers for one event
c	  
      open(1,file=infile,status='old',access='direct',recl=2048)
       call seisinc                                                             
     *(1,0,nchan,0,MAINHEAD,chead,0.0,0.0)                     
c
c-- get number of stations
      read(mainhead(1)(31:33),'(i3)',err=95) istat
c-- date and time of first channel
      read(mainhead(1)(34:59),'(i3,5x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3)'
     *,err=95)
     *k,mmonth,mday,mhour,mmin,msec 	   	  	 
      myear=k+1900
c
c-- get channel codes, start times and durations
c
      nstat=1
      do i=3,(istat-1)/3+3
         read(mainhead(i),'(3(1x,2a4,a1,f7.2,1x,f8.2))',err=95)
     *   stat(nstat)  (1:4),comp(nstat),  stat(nstat)  (5:5),
     *   cstart(nstat),cinter(nstat),
     *   stat(nstat+1)(1:4),comp(nstat+1),stat(nstat+1)(5:5),
     *   cstart(nstat+1),cinter(nstat+1),	 
     *   stat(nstat+2)(1:4),comp(nstat+2),stat(nstat+2)(5:5),
     *   cstart(nstat+2),cinter(nstat+2)	 
         nstat=nstat+3		   		 
      enddo
      goto 96
 95   continue
      write(6,*)' Error with internal read$$$$$$$$$$$$$$$$$$$'
      close(1)
      goto 20
 96   continue
c
c   find if station is present
c
      do i=1,istat
         if(stat(i).eq.station) then
           write(8,'(7x,a)') infile
           write(6,*)'Selected *********************************'
           nout=nout+1
           goto 15
         endif
      enddo
 15   continue
      close(1)	  
c-- go to get next event file
      ifile=ifile+1
      goto 20
 999  continue
      write(6,*)
      write(6,*)nout,' events selected, see file selsei.out'
      stop
      end	  	  	 

c$debug
c                                                                               
c    transform seislog qnx files to seisan data files               
c                                                                               
c    j. havskov                       
c
c    updates:
c    nov 19 97 jh : spike filter
c    nov 30       : set byte order to pc since not given in qnx file
c    jan 22 98    : new sys_resp, no save_head from now
c    sep 15 98    : indicate clock status in output file
c    dec 18 98    :-------------------- version 7.0 check ------------------
c                  filename, computer type
c    mar 23 99 jh : do not check file fo rmissing blocsks, sample rate etc if
c                   less than 30 blocks
c    jun 7        : spike filter removed, not good, cretes problems with large
c                   events
c    aug 16       : patch to fix problem with two different block header 
c                   formats, one for version before 8.0 and one for 8.0
c    sep 29    jh : check 160 instead of 1040 for nonexistance of cal file
c    feb 2, 2000 lo: changed dimension of y
c    may 11  00 lo: use read_resp_head
c    nov 9   00 lo: ignore when invalid buffer header
c    nov 27  01 lo: increased dimension of y array to 2000000
c    apr 8   02 jh: do not check for missing blocks, did not work if
c                   digitizer had a bad drift
c    jul 10  06 lo: increased dimension of y array to 4000000
c    dec 2007   jh  remove swap routines, are in swap.for
c    may 07  08 lo: increased dimension of y array to 6000000
c
c    Parameter in defines some type of input
c
c    in=0 : One binary file
c    in=1 : Several ------, use filenr.lis as input file name
c                                                                               
c
      implicit none
      include 'seidim.inc'
      external    seiclen                  !JAB(BGS)Mar95. Length
      integer     seiclen                  !JAB(BGS)Mar95. Function.
      character*2 byte_length              ! byte length
      character*3 clock_status             ! is SET if ok
      logical y2k                          ! use with verison 8.0 patch
c                                                                               
c-- seisan  field station file header                
      character*1024	header		
c-- seisan  data file channel header      
      character*1040    chahead         
c-- -------------------main --------      
      character*2000     mainhead        
c-- output file name                                  
      character*80	outfile		          !
c-- save part of header                         
      character*64      block_header              ! 1 sec block header
      integer yy,mo,dd,hh,mm,year                 ! time of  ------
      real    ss
      real*8  total_tim,total_tim_old
      real    time_dif                            ! difference between two headers
      real*8  first_time,last_time                ! time of first and last buffer
      real    total_time_block                    ! file length from block times
      integer nmiss,kmiss                         ! missing blocks
c-- data vector, one buffer or one channel                              
      integer*2		data2(max_sample)	
      integer*4     data4(max_sample)
      integer       error_time                    ! 1: error in time
c      integer*4     y(max_sample)
c      integer*4     y(2000000)
      integer maxy
      parameter (maxy=6000000)
      integer*4     y(maxy)
      integer unit
c-- number of equivalent samples in one buffer and in buffer header, inc header
      integer nsmp_buf,nhead
      integer nsmp_buf_chan   ! number of samples pr block pr chan ex header
c-- input file name
      character*80 infile
c-- top directory
      character*60 top_dir
c-- event number in
      integer number
c-- question
      character*80 question
c-- number of channels and samples/chan, total number of samples           
      integer nchan,nsamp,ntotal
c-- total time window                          
      real              total_time	
c-- block record length                   
      integer           rlength         
c-- number of blocks                              
      integer           nblock
c-- sample rate                                              
      real		rate
      real      dc      ! dc level		
c-- help variables                                     
      integer		i,k,ib,in,j,kk,l

      character*1       dchar
c-- -------------                                    
      integer           ich		
      integer byte_order    ! byte order, machine where written 1: sun, 2:pc,linux
      logical pc,sun,linux


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c set initial file or action, if gt 2, no questions asked 
c
      in=0
      outfile = ' '                       !JAB(BGS)Mar95. Empty filename.
c
c   set computer type
c
      call computer_type(sun,pc,linux)
c
      call dir_char(dchar)
c
c   get top directory
c
      call topdir(top_dir)
      open(10,file='qnxsei.out',status='unknown')
c
c  get file name
c
         question=' Filename, ?, number or filenr.lis for all'
         call filename(question,infile)
c
c  check for no files
c
         if(infile(1:3).eq.'EOF') goto 99
c
c   check which type of input file
c
         if(infile(1:10).eq.'filenr.lis'
     *   .or.infile.eq.'FILENR.LIS') then
            open(8,file='filenr.lis',status='old')
            in=1
         endif
c
c-----------------------------------------------------------------------
c  back here if many binary files converted using filenr.lis
c-----------------------------------------------------------------------
c
 1    continue
      if(in.eq.1) then
         read(8,'(2x,i3,2x,a)') number,infile
         write(6,*)
         write(6,'(1x,i3,3x,a)') number,infile
         if(infile(1:4).eq.'    ') goto 99
      endif
      first_time=0.0
      last_time=0.0
c                                                                               
c  open qnx binary file 
c     
      open(1,file=infile,status='old',access='direct',recl=1024)            
c                                                                               
c   read header 
c                                                                               
      read(1,rec=1) header
c                                                                               
c  make file name 
c             
      outfile=' '      
c
c-- year
c
         outfile(3:4)=header(17:18)
         read(outfile(3:4),'(i2)') i
         if(i.lt.50) then
            outfile(1:2)='20'
         else
            outfile(1:2)='19'
         endif
         outfile(3:4)=header(17:18)
         outfile(5:5)='-'
c-- month
         outfile(6:7)=header(24:25)
         outfile(8:8)='-'
c-- day     
         outfile(9:10)=header(27:28)
         outfile(11:11)='-'
c-- hr      
         outfile(12:13)=header(33:34)
c-- min     
         outfile(14:15)=header(36:37)
         outfile(16:16)='-'
c-- sec
         outfile(17:18)=header(39:40)
         outfile(19:20)='S.'
c-- network or station code
         outfile(21:25)=header(1:5)
         do i=21,25 
            if(outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo
         outfile(26:27)='_0'
c-- number of channels
         outfile(28:29)=header(63:64)
c
c-- check for blanks                                        
         do i=1,seiclen(outfile)                    !JAB(BGS)Mar95.
            if(outfile(i:i).eq.' ') outfile(i:i)='0'                            
         enddo                                                                  
c
c-- check for blanks                                        
c
            do i=1,29				
               if(outfile(i:i).eq.' ') outfile(i:i)='0'                         
            enddo                                                               
            write(6,207) outfile(1:29)                                          
 207        format(/,' Output file name is: ',a)                              
c
c   read header info
c                                                       
         read(header(81:88),'(i8)',err=384) nsamp
         read(header(63:64),'(i2)',err=384) nchan
         read(header(105:112),'(i8)',err=384)rlength
         read(header(97:98),'(i2)',err=384) unit
         read(header(65:80),'(f16.7)',err=384) rate
         read(header(95:96),'(a2)',err=384)byte_length
         read(header(94:94),'(i1)',err=384) byte_order
c
c  assume written on PC since missing in file
c
         byte_order=2
         rate=1/rate
         goto 385
 384     continue
           write(6,*) 'error in header'
 385     continue
c
c   check rlength size
c
         if(rlength.gt.max_sample*2) then                  !JAB(BGS)Sep95.
            write(6,*)' Too long buffers, rlen= ',rlength
            stop
         endif
c
      write(6,*) 'digitizer',unit,'  byte order',byte_order,
     *'  byte length', byte_length
c
c   calculate number of samples pr buffer inc header and header
c   in samples assuming 4 byte words
c
            nsmp_buf=rlength/4
            nhead=16
            nsmp_buf_chan=(nsmp_buf-nhead)/nchan
c
c   check if not too many samples
c
         if(nsamp.gt.max_sample) then            !JE(BGS)AUG95.
      	    write(6,*)' Too many samples/chan, nsamp= ',nsamp
            stop
         endif			 
         nblock=nsamp*nchan/(nsmp_buf-nhead)                                    
         write(6,*)' nsamp=',nsamp,'  nchan=',nchan,' reclen=',rlength          
         write(6,*)' number of blocks=',nblock                                  
c
c-- total time window assuming no change in rate and no missing buffers
c   is modified later, should also be equal to number of blocks
c
c        total_time=nsamp/rate
         total_time=nblock
c
c   close and reopen input file with record length of data buffers
c		                                                                
            close(1) 
            open(1,file=infile,status='old',
     *      access='direct',recl=rlength)   
c
c   save time status
c
                   read(1,rec=2+1024/rlength) (data4(i),i=1,nsmp_buf)
                   write(block_header,'(16a4)')(data4(i),i=1,16)
c
c   find if before y2k format or not
c
                   read(block_header(20:21),'(i2)') i
                   y2k=.false.
                   if(i.eq.20.or.i.eq.19) y2k=.true.
                   if(y2k) then
                      clock_status=block_header(29:31)
                   else
                      clock_status=block_header(27:29)
                   endif
         write(6,'(a,a)') ' Clock status ',clock_status
c
c  read first 10 and last 10 buffers to check time if at least 30 buffers
c------------------------------------------------------------------------
c
         if(nblock.gt.30) then
         do ib=2,nblock+1           
             if((ib.gt.1.and.ib.le.11).or.
     *          ib.gt.(nblock-9)) then
                   read(1,rec=ib+1024/rlength) (data4(i),i=1,nsmp_buf)
                   write(block_header,'(16a4)')(data4(i),i=1,16)
c                   write(6,'(1x,a)') block_header(1:45)
                   if(y2k) then
                      read(block_header(1:23),
     *           '(i2,1x,i2,1x,f6.3,1x,i2,1x,i2,3x,i2)',err=9121)
     *                hh,mm,ss,dd,mo,yy
                   else
                      read(block_header(1:21),
     *                '(i2,1x,i2,1x,f6.3,1x,i2,1x,i2,1x,i2)')
     *                hh,mm,ss,dd,mo,yy
                   endif
                   if(yy.lt.50) then 
                      yy=yy+2000
                   else
                      yy=yy+1900
                   endif
                   call timsec(yy,mo,dd,hh,mm,ss,total_tim)
c
c   save average time in 10 first and last blocks
c
                   if(ib.gt.1.and.ib.le.11) then
                      first_time=first_time + total_tim 
                   endif
                   if(ib.gt.(nblock-9)) then
                      last_time=last_time + total_tim
                   endif
                   time_dif=total_tim-total_tim_old
             endif
          enddo
c
c   calculate total time from block times and compare, see how many
c   blocks are missing
c
         total_time_block=last_time/10.0-first_time/10.0+10.0
         write(6,'(a,f8.3)') ' Total time from block times     ',
     *   total_time_block
         write(6,'(a,f8.3)') ' Total time from header          ',
     *   total_time
         nmiss=(total_time_block-total_time+0.2)   ! 0.2 allow for error
c
c   normally blocks are missed so nmiss positive, if negative means
c   that clock has jumped back in time
c
         if(nmiss.lt.0) then
            write(6,*)' Blocks missed: ',nmiss
c           write(6,*)' Serious timing problem, continue (y/n) ?'
c           read(5,'(a)') answer
c           if(answer.eq.'y'.or.answer.eq.'Y') then
c              nmiss=0
c           else
c             stop
c           endif
         endif  
c
         if(nmiss.gt.0) then
            write(6,*) ' Blocks missed in file: ',nmiss
            write(10,*)' Blocks missed in file: ',nmiss
         endif
c
c   ignore crazy errors
c
         error_time=0
         if(nmiss.lt.0.or.nmiss.gt.500) then
            nmiss=0
            error_time=1
         endif

9121     continue   ! if error
c
c   calculate new sample rate and total time if no crazy errors
c
         if(error_time.ne.1) then
c  8-4-02   rate=(nsamp+nmiss*nsmp_buf_chan)/
            rate=(nsamp)/
     *      (last_time/10.0-first_time/10.0+10.0)
            write(6,'(a,f8.3)') ' Sample rate based on block times',rate
c  8-4-02   total_time=((nblock+nmiss)*nsmp_buf_chan)/rate
c  8-4-02   nsamp=nsamp+nsmp_buf_chan*nmiss
            total_time=((nblock)*nsmp_buf_chan)/rate
            nsamp=nsamp
         else
            rate=nsmp_buf_chan
         endif
         endif         !   end if more than 30 blocks
c
c   construct  main header
c
         do i=1,2000                                                            
           mainhead(i:i)=' '                                                    
         enddo                                                                  
         mainhead(2:18)='                  '                              
c-- no of channels                        
         mainhead(32:33)=header(63:64)
c-- year, date and time
         mainhead(35:46)=header(17:28)
c
c   fix century
c
         read(mainhead(35:36),'(i2)') year
         if(year.lt.50) then
            mainhead(34:34)='1'
         endif
         mainhead(48:59)=header(33:44)
         write(mainhead(61:69),'(f9.3)') total_time
         j=162
         k=161
         do i=1,nchan                                                           
c--  station and component              
            mainhead(j:j+7)=header(k:k+7)	
            mainhead(j+8:j+8)=' '                                               
c-- rel. start time of channel           
            mainhead(j+9:j+15)='    0.0'	
            write(mainhead(j+17:j+24),'(f8.2)') total_time                      
            if(i.eq.3.or.i.eq.6.or.i.eq.9.or.i.eq.12.or.i.eq.15.                
     *      or.i.eq.18.or.i.eq.21.or.i.eq.24.or.i.eq.27.or.i.eq.30.
     *      or.i.eq.33.or.i.eq.36.or.i.eq.39.or.i.eq.42.or.i.eq.45.
     *      or.i.eq.48.or.i.eq.51.or.i.eq.54.or.i.eq.57.or.i.eq.60.
     *      or.i.eq.63) then        
              j=j+28                                                            
            else                                                                
              j=j+26                                                            
            endif                                                               
            k=k+8
         enddo                                                                  
c
         open(2,file=outfile,
     *   status='unknown',form='unformatted')        
         write(6,'(1x,a,a)')'Output file: ',outfile
c                                                                               
c   write  main header                                       
c                                                                               
         k=1
         write(6,'(a80)') mainhead(1:80)                                                                    
         do i=1,12                                                              
            write(2) mainhead(k:k+79)                                           
            write(6,'(a80)') mainhead(k:k+79)	
            k=k+80                                                              
         enddo                                                                  
c
c   write remaining main header lines if more than 30
c
         if(nchan.gt.30) then
            kk=(nchan-31)/3+1
            do i=13,kk+12
               write(2)mainhead(k:k+79)
               k=k+80
            enddo
         endif
c                                                                               
c   start channel read loop
c
         j=0                                                                    
         do ib=2,nblock+1                                 
c                                                                               
c   read one buffer
c   make sure first data buffer is read
c   at correct place, which is always beyound the 1024 bytes,
c   see manual for format ( fixed below by 1024/rlength),
c   note: all data is transferred to 4 byte array
c                                                                               
           read(1,rec=ib+1024/rlength) (data4(i),i=1,nsmp_buf)
             write(block_header,'(16a4)')(data4(i),i=1,16)
             read(block_header(1:21),
     *       '(i2,1x,i2,1x,f6.3,1x,i2,1x,i2,1x,i2)',err=1311)
     *       hh,mm,ss,dd,mo,yy
             if(yy.lt.50) then
                yy=yy+2000
             else
                yy=yy+1900
             endif
             call timsec(yy,mo,dd,hh,mm,ss,total_tim)
             time_dif=total_tim-total_tim_old
             if(abs(time_dif-1).gt.0.7.and.ib.gt.2) then
                write(10,'(1x,a)') block_header(1:45)
                write(10,*)' Too large time difference between buffers'
                write(10,'(a,f6.2)')' Difference is ',time_dif
                kmiss=time_dif-1+0.3
c
c   ignore crazy errors
c
                if(abs(kmiss).gt.100) kmiss=0
c
                if(kmiss.lt.0) then
c                  write(6,*)' Bad time error, clock goes back in time'
c                  write(6,*)' Continue (y/n)'
c                  read(5,'(a)') answer
c                  if(answer.eq.'y'.or.answer.eq.'Y') then
c                     kmiss=0
c                  else
c                     stop
c                  endif
                 endif
             endif
             total_tim_old=total_tim
             goto 1312 
c
c jump here if error
c
 1311       continue
            write(*,'(a)') ' error in buffer header (1:21)'
c            write(*,'(a)') block_header(1:21)
 1312       continue
c                                                                               
c  remove block buffers and save data in one array  
c                                          
             do k=nhead+1,nsmp_buf
               j=j+1
               if (j.le.maxy) y(j)=data4(k)
             enddo
             ntotal=j
c
c   if missing data, put in here, only if detected for whole
c   file, so a temporary time jump will not put in extra data
c   put in data from previous block to avoid dc jumps
c
c 09-04-02   if(kmiss.gt.0.and.nmiss.gt.0) then
c 09-04-02      write(10,*)' Extra blocks put in:',kmiss
c 09-04-02      do l=1,kmiss
c 09-04-02         do k=nhead+1,nsmp_buf
c 09-04-02            j=j+1
c 09-04-02            y(j)=data4(k)      
c 09-04-02         enddo
c 09-04-02      enddo
c 09-04-02      ntotal=j
c 09-04-02      kmiss=0
c 09-04-02    endif
c
c   end of channel loop
c                                                               
         enddo
         write(6,*)
     * ' Input file read, now follows headers in output file'
c                                                                               
c  end read for one event
c                                                                               
c                                                                               
c  write each channel with channel headers
c                                                                               
         do ich=1,nchan                                                         
            do i=1,1040                                                         
               chahead(i:i)=' '                                                 
            enddo                                                               
            j=(ich-1)*8+161
c-- station code                          
            chahead(1:4)=header(j:j+3)		
c-- componnet
            chahead(6:9)=header(j+4:j+7)	
c-- year, date and time                  
            chahead(10:35)=mainhead(34:59)		
            if(rate.ge.100.0) write(chahead(37:43),'(f7.2)') rate 
            if(rate.lt.100.0) write(chahead(37:43),'(f7.4)') rate 
            if(rate.lt.10.0)  write(chahead(37:43),'(f7.5)') rate 
            write(chahead(45:50),'(i6)') nsamp                                  
c                                                                               
c   get response, save date etc since removed when calling read_resp            
c                                                                               
             call read_resp_head(chahead)                                            
c
c   indicate 2 or 4 byte integer in header
c
            if(byte_length.eq.' 4') chahead(77:77)='4'
c
c   indicate timing accuracy
c
            if(clock_status.ne.'SET') chahead(29:29)='E'
c                                                                               
c   write header                                                                
c                                                                               
            write(2)chahead                                                     
            write(6,'(1x,a70)') chahead(1:70)
c
c   check if response curve
c
            if(chahead(160:160).eq.'9') write(6,*)
     *        ' No response file for this channel --------'
c                                                                            
c  demultiplex data  
c
               j=0
               do k=ich,ntotal,nchan
                  j=j+1
                  if(byte_length.ne.' 4') then
                     data2(j)=y(k)
                  else
                     data4(j)=y(k)
                  endif
               enddo
               if(byte_length.ne.' 4') then
                  if(byte_order.eq.2.and.sun) 
     *            call swap2(nsamp,data2)
                  write(2)(data2(k),k=1,nsamp)
               else
                  if(byte_order.eq.2.and.sun) 
     *            call swap4(nsamp,data4)
c
c   check for spikes, assume only in 4 byte data
c
                  dc=0
                  do i=1,nsamp
                         dc=dc+data4(i)
                  enddo
                  dc=dc/nsamp
c
c   put in dc at missing points
c
c                 do i=1,nsamp
c                     if(data4(i).eq.0)then
c                        data4(i)=dc
c                     endif
c                 enddo
                  i=1
c                 do while (i .le. nsamp - 100) ! assume only in 100 samples
c                   if(iabs(data4(i+1)-data4(i)).gt.10000) then
c                     write(6,*)' spike'
c                     write(17,*) i,data4(i),data4(i+1)
c                     do l=1,100    
c                        data4(l+i)=dc
c                     enddo
c                     i=i+101
c                   else
c                     i=i+1
c                   endif
c                 enddo

                  write(2)(data4(k),k=1,nsamp)
               endif
         enddo
         close(2,err=765)                       
         goto 766
 765     continue
         write(6,*) ' Error close 2'
 766     continue
c
c  close to be able to open next file if more than 1
c                                                                  
         close(1)
c                                                                               
c   back for next event if a list of events are transformed
c   or an ascii input file is used
c              
      if(in.eq.1) goto 1          
c                                                                               
c   end of data                                                                 
c                                                                               
 99   continue                                                                  
      stop                                                                      
      end

c$debug
c------------------------------------------------
c  Program: VELMENU
c
c  MENU AND CONVERSION PROGRAM TO USE THE INVERSION PROGRAM VELEST
c  IN CONNECTION WITH SEISAN
c
c
c  by Lars Ottemoeller Sept. 96
c
c  last updates:   
c     
c    26 oct 98 lo: conversion from velest to nordic, first station code blank
c --------------- SEISAN 7.0 ----------------------
c    08 jun 99 lo: velest formats do not support 5 char station code, therefore
c                  when reading from STATION0.HYP, only the first chars are
c                  taken, if 5 char station code, this will be a problem, when
c                  after inversion going back to Nordic format
c    24 ju jh      remove reference to external routines
c    19 10 99  lo  check if phase minutes more than 60 and calc hours
c    30 08 00  lo  set vthet to 999 in JHD, also see invertratio in JHD
c    25 10 00  jh  read secs as f6.3, high accuracy
c    05 03 01  jh  distance as real
c
c
c

      implicit none
c menu choice
      character*1 choice
c filename for calling editor
      character*80 fname
c earthquakedata in SEISAN format file name
      character*80 qname
c model file name
      character*80 mname
c index
      integer ind

C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       integer  read01,                    ! Input unit 1.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
C
C    ============= end of list ==========


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver


c
   1  CONTINUE 
   5  Format(a,$)
      write(*,*)
      write(*,*)'File name of earthquake data in Nordic Format : '
      read(*,'(a)') qname 

	  call sei open( old$+warn$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   qname,            ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

       if (code.NE.0) then
	 goto 1
       else

	 call sei close( close$, read01, code ) ! Close file again
       endif

      if (qname(1:8).EQ.'data.nor')THEN
	write(*,'(a)') '!!! Rename file !!!'
	goto 9999 
      ENDIF

c
c model name hardwired
c
      mname='input.mod'
      write(*,*)
      write(*,*) 'VELEST MENU'
      write(*,*) '-----------'
  10  CONTINUE
      write(*,*)
c     ind=index(qname,' ')-1
c     write(*,'(a,a,a)') '0. Change earthquake data file name ('
c    *,qname(1:ind),')'
      write(*,*) '1. Create VELEST command file (velest.cmn)'
      write(*,*) '2. Edit/change VELEST command file (velest.cmn)'
      write(*,*) '3. Create station select file (selstat.lis)' 
      write(*,*) '4. Edit/change station select file (selstat.lis)' 
      write(*,*) '5. Create model file'
      write(*,*) '6. Edit/change model file'
      write(*,*) 'A. RUN VELEST '
      write(*,*) 'B. Edit inversion output file '
      write(*,*) 'C. Convert VELEST output to Nordic format',
     &' and make diff-file'
      write(*,*) 'Q. End '
      write(*,*)
      write(*,*) 'Choice ? '
      read(*,'(a1)') choice

c     IF (choice.eq.'0') THEN
c     write(*,*)'Give file name of earthquake data in Nordic Format : '
c       read(*,'(a)') qname
      IF (choice.eq.'1') THEN
	CALL create_cmn(qname,mname)
      ELSEIF (choice.eq.'2') THEN
	fname='velest.cmn'
	CALL EDITOR(fname,10)
      ELSEIF (choice.eq.'3') THEN
	CALL create_stationlist(qname)
      ELSEIF (choice.eq.'4') THEN
	fname='selstat.lis'
	CALL EDITOR(fname,11)
      ELSEIF (choice.eq.'5') THEN
	CALL create_model(mname)
      ELSEIF (choice.eq.'6') THEN
	ind=INDEX(mname,' ')
	fname=mname
	CALL EDITOR(fname,ind-1)
      ELSEIF (choice.eq.'A'.or.choice.eq.'a') THEN
	CALL conv_stat
	CALL seivel(qname)
	call systemc('velest',6)     
      ELSEIF (choice.eq.'B'.or.choice.eq.'b') THEN
	fname='invers.out'
	call EDITOR(fname,13)
      ELSEIF (choice.eq.'c'.or.choice.eq.'C') THEN
	CALL velsei
      ELSEIF (choice.eq.'q'.or.choice.eq.'Q') THEN
	GOTO 9999
      ENDIF
      GOTO 10
 
9999  continue
      stop
      end

c--------------------------------------------------------
      SUBROUTINE conv_stat
c
c
c THIS SUBROUTINE CONVERTS STATIONS INCLUDED IN SELECTION FILE
c FROM STATION0.HYP FORMAT TO VELEST-STATION FORMAT
c
c
c    INPUT:  STATION0.HYP FILE IN NEAR STANDARD HYPO71 FORMAT
c            STATION SELECTION selstat.lis
c    OUTPUT: STATION FORMAT USED IN THE VELEST INVERSION PROGRAM
c
      implicit none
c text strings, in- and output-files
      character*80 text,textout,out
c characters for North-South and East-West
      character*1  ns,ew
c stationname 
      character*4  stname
c coordinates
      real latmin,longmin
      integer latdeg,longdeg
      integer k,l,height
c flag used to find beginning of station list
      logical flag
c array for selection of stations
      character*4  selstat(999)
c number of stations in station select file
      integer      stat_number
c counter 
      integer c

C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       integer  read01,                    ! Input unit 1.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       character*80 chr_text               ! Text string.
       character*60 top_directory
c---directory separator character
       character*1 dchar
       integer ind                         ! index

C
C    ============= end of list ==========
c
c open files
c

      out='station.sta'
      open(2,file=out,status='unknown')
      open(3,file='selstat.lis',status='old')
      write(*,*) 'CONVERSION: STATION0.HYP -> station.sta'
      write(*,*)  

      call topdir(top_directory)
      ind=index(top_directory,' ')-1

      call dir_char(dchar)         ! dirctory delimiter character
c
      chr_text = top_directory(:ind)//
     &           dchar // 'DAT' //dchar                 //
     &           'STATION0.HYP'

      ind=index(chr_text,' ')-1


c
c read STATION0.HYP file to get velocity model
c


	  call sei open( old$+warn$,       ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   'STATION0.HYP',   ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

	if (code.ne.0) then
	  write(*,*) 'STATION0.HYP from:'
	  write(*,*) chr_text(:ind)
	  call sei open( old$+warn$,       ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   chr_text(:ind),   ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

       endif

       if (code.NE.0) then
	 write(*,*) 'STATION0.HYP not found !!!'
	 stop
       endif



 5    Format(a,$)
c
c read selection of stations
c
      k=0
  2   read(3,'(a)',end=4) text
c     read(text(1:1),'(a1)') c1
      IF (text(1:1).EQ.'#') THEN
	go to 3
      ENDIF     
      k=k+1
      read (text(1:4),'(a4)') selstat(k)
  3   continue
      go to 2
  4   continue
      stat_number=k
c
c  write format line 
c
      write(2,'(a57)') 
     &'(a4,f7.4,a1,1x,f8.4,a1,1x,i4,1x,i1,1x,i3,1x,f5.2,2x,f5.2)' 
      flag=.false.
      k=0
 10   continue
      read(read01,'(a)',end=20) text

c
c  find line with station after blank line
c
      if (text(1:1).ne.'R') THEN
	if (.NOT.flag) then
	      flag=.true.
c
c  read line after blank line, first station line
c
	  read(read01,'(a)') text
c	elseif (index(text,'  ').ne.1) then
        elseif (text.eq.''.or.text.eq.' ') then
	  go to 20
	  endif 
      endif
c
c  convert station data
c  read and write
c
      if (flag) then 

        if (text(2:2).eq.' ') then 
          read(text(3:6),'(a4)') stname 
        else
          read(text(2:5),'(a4)') stname
        endif
c
c compare if stname in selstat
c 
	l=1
 11     if (stname.EQ.selstat(l)) THEN
	  go to 12
	endif
	if (l.EQ.stat_number) THEN
	  go to 10
	endif
	l=l+1
	go to 11 
 12     continue
	do c=1,80
	  textout(c:c)=' '
	enddo
	textout(1:4)=stname
	read(text(7:8),'(i2)') latdeg
	write(textout(5:6),'(i2)') latdeg
c	read(text(9:13),'(f5.2)') latmin
	read(text(9:13),'(f5.3)') latmin
	latmin=latmin/60
	write(textout(7:11),'(f5.4)') latmin
	read(text(14:14),'(a1)') ns
	textout(12:12)=ns
	textout(13:13)= ' '
 
	read(text(15:17),'(i3)') longdeg
	write(textout(14:16),'(i3)') longdeg
c	read(text(18:22),'(f5.2)') longmin
	read(text(18:22),'(f5.3)') longmin
	longmin=longmin/60
	write(textout(17:21),'(f5.4)') longmin
	read(text(23:23),'(a1)') ew
	textout(22:22)= ew

	read(text(24:27),'(i4)') height
	textout(23:23)= ' '
	write(textout(24:27),'(i4)') height
	textout(28:30)= ' 1 '
 
        k=k+1 
        if (k.gt.999) k=0
	write(textout(31:33),'(i3)') k
	textout(34:50)='  0.00   0.00   1'

	write(2,'(a80)') textout
      endif
c     read(text(12:16),'(f2.0,f2.0)') hh,mm
c     if (hh*100+mm.GE.mintime) then
c       if (hh*100+mm.LE.maxtime) then
c         write(2,'(a)') text
c       end if
c     end if
      go to 10
 20   continue
c  write line
      write(2,*)
      call sei close( close$, read01, code ) ! Close file again
      close(2)
      close(3)

      RETURN
      END


c-------------------------------------------------------
       SUBROUTINE SEIVEL(qname) 
c
c      THIS SUBROUTINE CONVERTS THE EARTHQUAKE DATA FILE IN  
c      SEISAN FORMAT TO CNV FORMAT USED IN THE VELEST INVERSION
c      PROGRAM.
c
c
c

      implicit none
c-- event data
      character*80      data(2000)      
c-- for storing the station names from the station file 
      character*80     sdata(1000)
c-- helping variable to store the output lines 
      character*80     line,cnvline
c phasename
      character*4 pha(500)
c-- exp indicator                                         
      character*1       exp     ,wg(500)  !wg is the weight     
      character*80     outfile   ! output file name
c time residual, too high res are not used
      real tres(500)
c max residual
      real maxres
c earthquakedata in SEISAN format file name 
      character*80 qname
      character*80     stafile   !station file name
c-- event type                                      
      character*1      type, ns,ew !ns is north or south,
				   !ew is east or west,
c-- number of records for event                           
      integer           nrecord         
c-- number of header lines                                 
      integer           nhead           
c-- number of stations                                     
      integer           nstat           
c-- number of phases
      integer nphase
c-- counter                                                   
      integer x,p,g,s,i,t !some helping variables for counting          
c -- index
      integer ind
c-- id line number
      integer id ,hour1(500),min1(500) !hour and min at time of reading 
      integer year,month,day,hour,min  ! year, month,day,hour and minute 
      real sec,lat,long,dep,sec1(500),rsec(500)  !seconds,latitude,longtude,depth 
					!sec1 time of reading 
					!rsec relative time 
      integer hh
      character*4 sta(500),stat(1000)      !to store the stations
					   !once from the station file
					   !and once from the input file 
c helping variables for control
      logical flag 
c phase output boolean
      logical phaout(500)
c number of stations in select file
      integer stlistn
c logicals station in list, correct phase type and weight OK,output
c if all are true
      logical phstat(500),phph(500),phwg(500)
c number of phases in cnvline
      integer ncnv
c computer type
      logical sun,pc,linux
c choice
      character*1 choice
c
c    open input file
c
      call computer_type(sun,pc,linux)
      maxres=5.0

   5  format(a,$)
c
      open(1,file=qname,status='old')

c 
c   open output file CNV format 
c 

      outfile='data.cnv' 
      ind=index(qname,' ') 
      write(*,*) 'CONVERSION: ',qname(1:ind),' -> ',
     *'data.cnv'
      write(*,*)
      open(2,file=outfile,status='unknown')

c
c  open output file NORDIC format
c

      open(4,file='data.nor',status='unknown')

c
c  open script control file for hyp
c
      open(8,file='ttt.ttt',status='unknown')
      write(8,'(a8)') 'data.nor'
      write(8,'(a1)') 'n'
      close(8)

c
c    open station file
c
      stafile='selstat.lis'
      open(3,file=stafile,status='old')
c
c read station file, array of stations is stat(...)
c
      p=1
   50 read(3,'(a80)',end=60) sdata(p)
      p=p+1
      GOTO 50
   60 CONTINUE
      g=1 
      DO 70 s=1,p
      IF (sdata(s)(1:1).NE.'#') THEN !to skip the comment lines 
	read(sdata(s),'(a4)') stat(g) 
	g=g+1
      ENDIF
      stlistn=g-1
   70 CONTINUE
c                                                                               
c  read one event
c



   80 continue 
      call indata(1,nstat,nphase,nhead,nrecord,type,exp,data,id)
c
c jump out if end of file
c

c
c overwrite fixed depth and location
c

c      write(data(1)(44:45),'(a2)') '  '

      IF (nrecord.EQ.0) THEN 
	 GOTO 500
      ENDIF

c
c overwrite event ID explosion (P,E)
c

      if (data(1)(23:23).EQ.'P'.OR.data(1)(23:23).EQ.'E')THEN
	data(1)(23:23)=' '
      ENDIF

      do 85 p=1,nhead
	write(4,'(a80)') data(p)

   85 CONTINUE

c
c   read year,month,day,hour,minute,seconds,latitude,longitude
c   and depth from header
c
      read(data(1),'(3x,i2,1x,i2,i2,1x,i2,i2,1x,f4.0,3x,
     +f7.0,f8.0,f5.0)')
     +  year,month,day,hour,min,sec,lat,long,dep
	flag=.FALSE. 
      IF (lat.GE.0) THEN !to make direction north or south
	  ns='N'
      ELSE
	ns='S'
	lat=-lat 
      ENDIF
      IF (long.GE.0) THEN !to make direction east or west 
	ew='E'
      ELSE
	ew='W'
	long=-long
      ENDIF
c
c write the header line in output file
c
      write(2,'(3i2,1x,2i2,1x,f5.2,1x,f7.4,a1,1x,f8.4,a1,
     + f7.2)') year,month,day,hour,min,sec,lat,ns,long,ew,dep

c
c read the phases (station, phase, weight and time)
c
  100 CONTINUE
      do 110 i=nhead+1,nrecord-1,1 
	 x=i-nhead
	 read(data(i),'(1x,a4,5x,a4,a1,3x,i2,i2,f6.3)')
     *   sta(x),pha(x),wg(x),hour1(x),min1(x),sec1(x) 

         if (min1(x).gt.59) then
           hh = int(min1(x)/60)
           if (hh.gt.0) then 
             hour1(x) = hour1(x) + hh
             min1(x) = min1(x) - hh *60
           endif
         endif

	 read(data(i)(64:68),'(f5.1)') tres(x)  ! read residual
c if tres larger than maxres set weight to 4
	 if (abs(tres(x)).ge.maxres) then
	   wg(x)='4'
	 endif
c 
c set weight to 0 if blank
c
	 IF (wg(x).EQ.' ') THEN
	     wg(x)='0'
	 ENDIF
c
c check if weight between 0 and 3, no output for w=4 from
c velest
c
	 phwg(x)=.FALSE.

	 IF (wg(x).EQ.'0'.OR.wg(x).EQ.'1'.OR.wg(x).EQ.'2'
     *   .OR.wg(x).EQ.'3') THEN
	    phwg(x)=.TRUE.
	 ENDIF 
 
c
c calc relative time 
c
	 if (hour1(x).EQ.0) THEN
	   hour1(x)=24
	 ENDIF
	 if (hour.EQ.0) THEN 
	   hour=24
	 ENDIF
 
	 rsec(x)=(3600*hour1(x)+60*min1(x)+sec1(x))
     *          -(3600*hour+60*min+sec)
     
c
c set phaout to false
c
	 phaout(x)=.FALSE.


     
  110 CONTINUE

c
c select phases for output and set logical phaout(x)
c
      ncnv=0
      do i=1,80
	cnvline(i:i)=' '
      enddo
      do 150 i=1,x,1
c
c check if station in list
c
 
       phstat(i)=.FALSE.
       do 115 p=1,stlistn,1
	 if (sta(i).EQ.stat(p)) then
	   phstat(i)=.TRUE.
	   GOTO 115
	 ENDIF

c
c check if weight of 9 at this station
c
	   DO 111 t=1,x,1
	      IF (sta(i).EQ.sta(p)) THEN
		IF (wg(p).EQ.'9') THEN
		  phwg(i)=.FALSE.
		ENDIF
	      ENDIF

  111 CONTINUE

  115 CONTINUE    
      
c
c check if correct phase
c

      phph(i)=.FALSE.
      if ((pha(i)(1:1).EQ.'P').OR.(pha(i)(1:1).EQ.'S')) 
     *THEN
	 phph(i)=.TRUE.
      ENDIF


c
c select first arrival of phases with phph and phstat TRUE
c

      
      if (phph(i).AND.phwg(i) 
     *.AND.phstat(i).AND.rsec(i).LT.100.AND.
     * rsec(i).gT.0) THEN
	phaout(i)=.TRUE.
	do 130 p=1,x
	   if ((sta(i).EQ.sta(p))
     *.AND.(i.NE.p).AND.(pha(i)(1:1).EQ.pha(p)(1:1)))THEN
	     if (rsec(i).LT.rsec(p)) THEN
	       phaout(p)=.FALSE.
	     ELSE
	       phaout(i)=.FALSE.
	     ENDIF
	   ENDIF  

  130 CONTINUE
      ENDIF


c
c output
c
      if (phaout(i)) THEN

c
c write to NORDIC file
c
      line=data(nhead+i)
      write(line(10:14),'(a5)') '     '
      write(line(11:11),'(a1)') pha(i)(1:1)
      write(4,'(a80)') line 

c
c write to CNV file
c

      ncnv=ncnv+1
      if (ncnv.LE.6) then
	write(cnvline((ncnv-1)*12+1:(ncnv-1)*12+12)
     *,'(a4,a1,a1,1x,f5.2)') sta(i),pha(i),
     *wg(i),rsec(i)
      ELSE
	write(2,'(a80)') cnvline
	cnvline=' '
	ncnv=1
	write(cnvline((ncnv-1)*12+1:(ncnv-1)*12+12)
     *    ,'(a4,a1,a1,1x,f5.2)') sta(i),pha(i),
     *    wg(i),rsec(i)
 
      ENDIF

      
      ENDIF


  150 CONTINUE 

      write(4,'(a)')
      write(2,'(a80)') cnvline
      write(2,*)
      GO TO 80

 500  CONTINUE                                                                                
      close(1)
      close(2)
      close(3) 
      close(4)


c
c run hyp on Inversion Input in Nordic format
c

      write(*,'(a)') ' Do you want to relocate velest input with hyp '//
     &          '(y/n)?'
      write(*,'(a)') ' This is needed if you wish to compare the ' //
     &          'computation of velest and hyp. '
      read(*,*) choice
      if (choice.eq.'y'.or.choice.eq.'Y') then
        call systemc('hyp < ttt.ttt',13)


        if (sun.or.linux) then
           call systemc('rm ttt.ttt',11)
        elseif (pc) then
           call systemc('del ttt.ttt',11)
        endif
      endif

      RETURN
      END 
     





c
c---------------------------------------------------
c
      SUBROUTINE velsei
c
c     THIS SUBROUTINE CONVERTS BACK FROM CNV FORMAT GIVEN AS OUTPUT FROM
c     THE VELEST PROGRAM TO SEISAN FORMAT AND WRITES AN OUTPUT FILE
c     SHOWING THE DIFFERENCES BETWEEN INVERSION INPUT AND OUTPUT.
C
c
      implicit none
c-- event data
       character*80     line,data(1000)
c-- exp indicator
       character*1      exp  
c-- event type
       character*1      type
c-- number of recors for event
       integer          nrecord
c-- number of header lines
       integer          nhead
c-- number of stations
       integer          nstat
c-- number of phases
       integer nphase
c-- id line number
       integer id 
c time after inversion
       integer year,month,day,hour,min          
c time before inversion NORDIC
       integer year1,month1,day1,hour1,min1     
c time before inversion CNV
       real sec,lat,long,dep                    !seconds,latitude,longtude,depth
       real sec1,lat1,long1,dep1                !seconds,latitude,longtude,depth
       real dsec,dlat,dlong,ddep                !seconds,latitude,longtude,depth
c characters for NORTH-SOUTH and EAST-WEST
       character*1 nsc,ewc
c counter
       integer i 
c phase reading from cnv file
       character*12 phase
c output line
       character*80 lineout
c phase reading times
       real psec
c time
       real time,timeout
     
c
c      open input file
c
   1   format(a,$)
c
c open inversion input in NORDIC format
c

       open(1,file='hyp.out',status='old')
c
c open INVERSION output-file
c

       open(3,file='fin_hyp.cnv',status='old')
c
c   open file to convert from CNV to Compact format 
c
       open(4,file='velout.nor',status='unknown')
C
c   open difference output file
c
       open(2,file='velout.dif',status='unknown')
       write(2,'(a)') 'differences: inversion output - SEISAN input'
       write(2,*) 'first line input, second line output,',
     &' third line difference'
       write(2,*)

c
c open cnv input file
c
c      open(7,file='data.cnv',status='old')

c
c  read one event
c



   10  continue
       call indata(1,nstat,nphase,nhead,nrecord,type,exp,data,id)

c
c jump out if end of file
c
       IF (nrecord.EQ.0) THEN
	 GOTO 500
       ENDIF

c
c   read time and epicentre location from inversion output
c
	read(3,'(i2,i2,i2,1x,i2,i2,1x,f5.2,1x,
     +f7.4,a1,1x,f8.4,a1,f7.2)')
     +  year,month,day,hour,min,sec,lat,nsc,long,ewc,dep
c
c get time in sec
c
      time=hour*3600+min*60+sec
       read(data(1),'(3x,i2,1x,i2,i2,1x,i2,i2,1x,f4.0,3x,
     +f7.3,f8.3,f5.1)',end=500)
     +  year1,month1,day1,hour1,min1,sec1,lat1,long1,dep1 

c       read(7,'(i2,i2,i2,1x,i2,i2,1x,f5.2,1x,
c    +f7.4,a1,1x,f8.4,a1,f7.2)',end=500)
c    +  yearc,monthc,dayc,hourc,minc,secc,
c    *  latc,nscc,longc,ewcc,depc
       
c     timec=hourc*3600+minc*60+secc

c
c get differences between inversion in- and output
c
c  SOUTH = minus
c  WEST  = minus
c
      if (nsc.EQ.'S') THEN
	 lat=-lat
      endif
      if (ewc.EQ.'W') THEN
	 long=-long
      endif
       dsec = (sec-sec1)
       dlat = (lat-lat1)
       dlong= (long-long1)
       ddep = (dep-dep1)
c
c write output
c             
       write(2,'(a)') (data(1))
c
c write inversion output in headerline
c
       write(data(1)(4:20),'(i2.2,1x,i2.2,i2.2,1x,i2.2,i2.2,1x,f4.1)') 
     + year,month,day,hour,min,sec 
       write(data(1)(24:43),'(f7.3,f8.3,f5.1)')
     + lat,long,dep
c
c clear magnitudes
c
c       write(data(1)(57:79),'(a23)') '                       '
c
c clear rms
c
       data(1)(53:55)= '   '

       write(2,'(a)') (data(1))


c
c write headerlines to file
c
       do 15 i=1,nhead 
	 write(4,'(a)') (data(i))

   15  CONTINUE

       write(2,'(a,f6.1,a,f7.3,a,f8.3,a,f6.1)')
     &  'time: ',dsec,' latitude: '
     & ,dlat,' longitude: ',dlong,' depth: ',ddep

   20 CONTINUE 
      read(3,'(a)',end=500) line 
c     read(7,'(a)',end=500) linec
      IF (line(1:80).EQ.' ') THEN 
	write(2,*)  
	write(4,'(a)')
	GO TO 10
      ELSE
c
c read and write phases
c
      do 30 i=1,6,1
	read(line((i-1)*12+1:((i-1)*12+12)),'(a12)') phase
c take out residuals,since they are 0
c       read(linec((i-1)*12+1:((i-1)*12+12)),'(a12)') phasec
	if (phase(1:4).NE.'    ') THEN
	   lineout=' '
	   write(lineout(1:1),'(a1)') ' '
	   write(lineout(2:5),'(a4)') phase(1:4)
	   write(lineout(11:11),'(a1)') phase(5:5)
	   write(lineout(15:15),'(a1)') phase(6:6)
	   read(phase(8:12),'(f5.2)') psec
c          read(phasec(8:12),'(f5.2)') psecc
c          res=timec+psecc-psec-time
c          write(lineout(64:68),'(f5.2)') res
	   timeout=time+psec
	   write(lineout(19:20),'(i2)') int(timeout/3600)
	   write(lineout(21:22),'(i2)')
     *       int((timeout-int(timeout/3600)*3600)/60)
	   write(lineout(24:28),'(f5.2)')
     *       timeout-int(timeout/3600)*3600
     *       -int((timeout-int(timeout/3600)*3600)/60)*60
	   write(4,'(a)') lineout 
	endif

   30  CONTINUE
   
	 GO TO 20 
       END IF

c
c end of subroutine
c

 500  CONTINUE

      write(*,*) 'Output files:   velout.nor: final hypocentre'
     +  ,' locations in Nordic format'
      write(*,*) '                velout.dif: differences '
     +  ,'(inversion output minus input)'

      close(1)
      close(2)
      close(3)
      close(4)
c     close(7)
      RETURN
      END


c----------------------
      SUBROUTINE EDITOR(fname,enum)
c
c     THIS SUBROUTINE CALLS THE VI-EDITOR.
C
C
      implicit none
      integer enum
      character*80 fname,text,vel_edit
      integer x,ind
c
c call vi + filename 
c
      do x=1,80
	text(x:x)=' '
      enddo
      call get_editor(vel_edit)
      ind=index(vel_edit,' ')
c     write(text,'(a,a)') 'vi ',fname(1:enum)  
      text=vel_edit(1:ind) // fname(1:enum)
      call systemc(text,ind+enum)

      RETURN
      END

c----------------------
      SUBROUTINE CREATE_CMN(qname,mname)
c
c     THIS SUBROUTINE WRITES THE VELEST COMMAND (velest.cmn) FILE.
c     THE EARTHQUAKE DATA FILE IS READ TO GET THE NUMBER OF EVENTS AND
c     TO CALCULATE THE LOCATION CENTRE. PARAMETERS ARE SET FOR INVERSION OR
c     JHD.
c
c

c velest.cmn text
      character*80 text(107)
c earthquakedata in SEISAN format file name
      character*80 qname
c model file name
      character*80 mname
c choice inversion-JHD
      character*1 choice
c inversion or JHD 
      logical jhd
c maximaum distance between epicentre and station
      integer dmax
c velocity model damping
      real vthet
c counter
      integer i
c number of earthquakes
      integer neqs
c centre of earthquake locations
      real olon,olat
c sums of positive lat and lon
      real slon,slat 
c number of lat,lon
      integer nlat,nlon
c lat and lon
      real lat,lon
c-- event type
       character*1      type
c-- number of recors for event
       integer          nrecord
c-- number of header lines
       integer          nhead
c-- number of stations
       integer          nstat
c-- number of phases
       integer nphase
c-- id
       integer id
c-- exp indicator
       character*1      exp
c-- event data
       character*80     data(1000)
c length of mname
       integer mind
c nsinv: invert for station corrections?
       integer nsinv
c
c
  101 format(a,$) 
  102 continue 
      write(*,*)
      write(*,*) 'Inversion or JHD (I / J) ? '
      read(*,'(a1)') choice 
      IF (choice.EQ.'i'.or.choice.EQ.'I') THEN
         jhd=.false.
	 goto 103
      ELSEIF (choice.EQ.'j'.or.choice.EQ.'J') THEN
	 jhd=.TRUE.
	 goto 103
      ENDIF
      write(*,*) 'wrong type! '
      goto 102
  103 CONTINUE

c
c read earthquake data file to get olat,olon,neqs
c
      open(2,file=qname,status='old')
      neqs=0
      slat=0
      slon=0
      nlat=0
      nlon=0
  200 CONTINUE 
      call indata(2,nstat,nphase,nhead,nrecord,type,exp,data,id)
      IF (nrecord.EQ.0) THEN
	GOTO 300
      ELSEIF (nrecord.NE.0) THEN
	neqs=neqs+1 
	read(data(1)(24:30),'(f7.3)') lat
	read(data(1)(31:38),'(f8.3)') lon 
	lat=lat+90
	lon=lon+180
c         write(*,*) lat,',',lon
	slat=slat+lat
	nlat=nlat+1
c         write(*,*) slat,' ',nlat
	slon=slon+lon
	nlon=nlon+1
c         write(*,*) slon,' ',nlon
c         read(*,*)
      ENDIF
      GOTO 200
  300 CONTINUE
      olat=slat/nlat-90
      olon=slon/nlon-180
c
c East is negative
c
      olon=-olon
      write(*,'(a,a15,f7.3,a1,f8.3)') 'Origin of cartesian',
     &' coordinates : ',olat,' ',olon
      write(*,'(a,i5)') 'number of events: ',neqs

c
c write VELEST - command file
c

      data(text(i),i=1,10) /
     &'******* CONTROL-FILE FOR PROGRAM  V E L E S T  *******',
     &'***',
     &'*** ( all lines starting with  *  are ignored! )',
     &'*** ( where no filename is specified,',
     &'***   leave the line BLANK. Do NOT delete!)',
     &'***',
     &'*** next line contains a title (printed on output):',
     &' ',
     &'***      starting model 1 based on',
     &'***  olat       olon   icoordsystem      zshift   itrial ztrial
     &    ised'/

      data(text(i),i=11,20) /
     &'  60.3840     -5.3340      0            0.000      0     0.00
     &     0',
     &'***',
     &'*** neqs   nshot   rotate',
     &'      96      0      0.0',
     &'***',
     &'*** isingle   iresolcalc',
     &'       0          0',
     &'***',
     &'*** dmax    itopo    zmin     veladj    zadj   lowveloclay',
     &'    500.0     0      0.00       0.20    5.00       0'/

c write latitude, longitude, number of quakes
c
      write(text(11)(3:9),'(f7.3)') olat
      write(text(11)(15:22),'(f8.3)') olon
      write(text(14)(4:8),'(i5)') neqs
      
c
c set dmax to 500 for inversion and to 9999 for jhd
c
      if (.not.jhd) THEN
	dmax=500
      ELSEIF (jhd) THEN
	dmax=9999
      ENDIF
      write(text(20)(5:9),'(i5)') dmax

      data(text(i),i=21,30) /
     &'***',
     &'*** nsp    swtfac   vpvs       nmod',
     &'     2      0.50    1.740        1',
     &'***',
     &'***   othet   xythet    zthet    vthet   stathet',
     &'      0.01    0.01      0.01      1.0    0.01',
     &'***',
     &'*** nsinv   nshcor   nshfix     iuseelev    iusestacorr',
     &'       1       0       0           1            0',
     &'***'/

c
c set vthet to 1.0 for inversion and to 999 for jhd
c
      if (.not.jhd) THEN
	vthet=1.0
      ELSEIF (jhd) THEN
	vthet=999.0
      ENDIF
      write(text(26)(34:38),'(f5.1)') vthet 

c
c set nsinv to 1 for inversion and to 0 for jhd (no inversion for station 
c corrections
c
      if (.not.jhd) THEN
	nsinv=1
      ELSEIF (jhd) THEN
	nsinv=1           ! invert for station correction, also for JHD
      ENDIF
      write(text(29)(8:8),'(i1)') nsinv 

      data(text(i),i=31,40) /
     &'*** iturbo    icnvout   istaout   ismpout',
     &'       1         1         1         0',
     &'***',
     &'*** irayout   idrvout   ialeout   idspout   irflout   irfrout   
     &iresout',
     &'       0         0         0         0         0         0    
     &     0',
     &'***',
     &'*** delmin   ittmax   invertratio',
     &'    0.010       5          1',
     &'***',
     &'*** Modelfile:'/
 
c set invertratio to 6 for JHD, no, otherwise no station correction
c      IF (jhd) THEN
c         write(text(38)(28:28),'(a1)') '6' 
c      ENDIF

      mind=INDEX(mname,' ')
      data(text(i),i=41,50) /
     &' ',
     &'***',
     &'*** Stationfile:',
     &'station.sta',
     &'***',
     &'*** Seismofile:',
     &' ',
     &'***',
     &'*** File with region names:',
     &' '/

      write(text(41),'(a)') mname

      data(text(i),i=51,60) /
     &'***',
     &'*** File with region coordinates:',
     &' ',
     &'***',
     &'*** File #1 with topo data:',
     &' ',
     &'***',
     &'*** File #2 with topo data:',
     &' ',
     &'***'/

      data(text(i),i=61,70) /
     &'*** DATA INPUT files:',
     &'***',
     &'*** File with Earthquake data:',
     &'data.cnv',
     &'***',
     &'*** File with Shot data:',
     &' ',
     &'***',
     &'*** OUTPUT files:',
     &'***'/

      data(text(i),i=71,80) /
     &'*** Main print output file:',
     &'invers.out',
     &'***',
     &'*** File with single event locations:',
     &' ',
     &'***',
     &'*** File with final hypocenters in *.cnv format:',
     &'fin_hyp.cnv',
     &'***',
     &'*** File with new station corrections:'/

      data(text(i),i=81,90) /
     &'sta_cor.out',
     &'***',
     &'*** File with summary cards (e.g. for plotting):',
     &' ',
     &'***',
     &'*** File with raypoints:',
     &' ',
     &'***',
     &'*** File with derivatives:',
     &' '/

      data(text(i),i=91,100) /
     &'***',
     &'*** File with ALEs:',
     &' ',
     &'***',
     &'*** File with Dirichlet spreads:',
     &'CALDIRSP.DIS',
     &'***',
     &'*** File with reflection points:',
     &' ',
     &'***'/

      data(text(i),i=101,107) /
     &'*** File with refraction points:',
     &' ',
     &'***',
     &'*** File with residuals:',
     &' ',
     &'***',
     &'******* END OF THE CONTROL-FILE FOR PROGRAM  V E L E S T  
     &*******'/


      open(1,file='velest.cmn',status='unknown')
      do 999 i=1,107 
	 write(1,'(a)') text(i)
 999  CONTINUE
      close(1)
      close(2)
      RETURN
      END


c -------------------------------------------------
      SUBROUTINE CREATE_STATIONLIST(qname)
c
c     THIS SUBROUTINE READS THE VELEST.CMN FILE TO GET THE DMAX PARAMETER
c     AND THEN READS THE EARTHQUAKE DATA FILE TO GET A LIST OF STATIONS 
c     WITH A DISTANCE TO THE EPICENTRE LOCATION SMALLER THAN DMAX.
c
c
      implicit none
c
      character*80 qname
c-- event type
      character*1      type
c-- number of recors for event
      integer          nrecord
c-- number of header lines
      integer          nhead
c-- number of stations
      integer          nstat
c-- number of phases
      integer nphase
c-- id
      integer id
c-- exp indicator
      character*1      exp
c-- event data
      character*80     data(2000)
c lines of velest.cmn 
      character*80 text
c counters
      integer i,k
c max distance between stations and epicentre location
      integer dmax
c stationlist
      character*4 stlist(500)
c station 
      character*4 stat
c distance
      real dist
c current maximum station number
      integer stmax
c
c
c   READ DMAX FROM VELEST.CMN FILE
c
      open(1,file='velest.cmn',status='OLD')
      i=0
 10   CONTINUE
      READ(1,'(a80)') text
      IF (text(1:1).NE.'*') THEN
	  i=i+1
	  IF (i.EQ.5) THEN
	     read(text(5:9),'(i5)') dmax 
	     goto 20
	  ENDIF
      ENDIF
      goto 10
 20   CONTINUE
      close(1)

c
c initalize station list
c
      do i=1,500
	stlist(i)=' '
      enddo

c
c read earthquake data and get stations with a distance of less than dmax 
c
      open(2,file=qname,status='OLD')
      stmax=0
  200 CONTINUE
      call indata(2,nstat,nphase,nhead,nrecord,type,exp,data,id)
      IF (nrecord.EQ.0) THEN
	GOTO 300
      ENDIF
      i=nhead+1
  210 CONTINUE 
	read(data(i)(2:5),'(a4)') stat 
	read(data(i)(71:75),'(f5.0)',err=250) dist
	k=0
	IF (DIST.LE.dmax) THEN
  220   CONTINUE 
	  k=k+1
	  IF (stat.EQ.stlist(k)) THEN
	    GOTO 230
	  ENDIF
	  if (k.GT.stmax) THEN
	    stlist(k)=stat
	    stmax=stmax+1
	    write(*,*) 'station :',k,'. ',stat 
	    goto 230
	  ENDIF
	  goto 220
	ENDIF
  230   CONTINUE
	i=i+1
	if (i.EQ.nrecord) THEN
	  GOTO 250 
	ENDIF
	goto 210
  250 CONTINUE 
      GOTO 200
  300 CONTINUE
      close(2)
c 
c write selstat.lis (station selection file)
c
      open(2,file='selstat.lis',status='unknown')
  400 CONTINUE
      write(*,*)
      write(*,*) 'create station selection file: selstat.lis'
      write(2,'(a)') '#'
      write(2,'(a)') '# STATION SELECT FILE FOR PROGRAM VELEST'
      write(2,'(a)') '#'
      write(2,'(a)') '# STATIONS WILL BE USED IN THE VELEST'
      write(2,'(a)') '#      INVERSION PROGRAM'
      write(2,'(a)') '#'
      write(2,'(a)') '# COMMENT LINES START WITH #'
      write(2,'(a)') '#'
  410 CONTINUE
      DO 500 i=1,stmax
	write(2,'(a4)') stlist(i)
  500 CONTINUE
      close(2)
 
      RETURN
      END


c --------------------------------------------------
      SUBROUTINE create_model(mname)
c
c     THIS SUBROUTINE CONVERTS THE MODEL GIVEN IN THE STATION0.HYP FILE
c     TO THE MODEL USED AS INPUT IN VELEST.
c
c
c model file name
      character*80 mname
c length of model file name
      integer mind
c depth of top of layer
      real depth(100)
c velocity in layer
      real vel(100)
c counter for blank lines
      integer blank
c text line
      character*80 text
c number of layers
      integer layers
c ratio between p and s velocity
      real psratio

C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       integer  read01,                    ! Input unit 1.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       character*80 chr_text               ! Text string.
       character*60 top_directory

C
C    ============= end of list ==========
c---directory separator character
      character*1 dchar
c
      integer ind

      write(*,*)
c
c   get directory structure
c
      call topdir(top_directory)
      ind=index(top_directory,' ')-1

      call dir_char(dchar)         ! dirctory delimiter character
c
      chr_text = top_directory(:ind)//
     &           dchar // 'DAT' //dchar                 //
     &           'STATION0.HYP'

      ind=index(chr_text,' ')-1
 

c
c read STATION0.HYP file to get velocity model
c


	  write(*,*) 'STATION0.HYP from local directory'
	  call sei open( old$+warn$,       ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   'STATION0.HYP',   ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      if (code.ne.0) then
	    write(*,*) 'STATION0.HYP from:'       
	    write(*,*) chr_text(:ind) 
	  call sei open( old$+warn$,       ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   chr_text(:ind),   ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

       endif

       if (code.NE.0) then
	 write(*,*) 'STATION0.HYP not found !!!'
	 stop
       endif

      mind=INDEX(mname,' ')-1
      open(2,file=mname(1:mind),status='unknown') 
      blank=0
      layers=0
c 
c write title
c
      write(2,'(a,a)') ' Model: ',mname(1:mind)
     
 100  CONTINUE
      READ(read01,'(a)',end=500) text 
      if (text.EQ.' ') then
	blank=blank+1  
      endif
      if (blank.EQ.2.AND.(text.NE.' ')) then
	layers=layers+1 
	read(text(3:7),'(f5.2)') vel(layers)
	read(text(9:14),'(f6.1)') depth(layers) 
      endif
      if (blank.EQ.3.AND.(text.NE.' ')) then
	read(text(16:20),'(f5.1)') psratio 
	blank=4
      endif

      goto 100
 500  CONTINUE

c
c write layer model
c
      write(text,'(a,a)') '           vel,depth,vdamp,',
     &'phase(f5.2,5x,f7.2,2x,f7.3,3x,a1) '
      if (layers.LT.10) THEN
	 write(text(1:2),'(1a,i1)') ' ',layers
      ELSEIF (layers.LT.100) THEN
	 write(text(1:3),'(1a,i2)') ' ',layers
      ELSEIF (layers.GE.100) THEN
	 write(text(1:4),'(1a,i3)') ' ',layers
      ENDIF

      write(2,'(a)') text
      text=' '

 600  CONTINUE
      write(*,*)
      write(*,*) 'Create model file: ',mname(1:mind)
      DO 700 i=1,layers
	write(text(1:5),'(f5.2)') vel(i)
	write(text(11:17),'(f7.2)') depth(i)
	write(text(20:26),'(f7.3)') 1.0
	IF (i.EQ.1) THEN
	  write(text(38:53),'(a)') 'P-VELOCITY MODEL'
	  IF (depth(i).LE.0) THEN 
	    write(text(11:17),'(a7)') '  -5.00'
	  ENDIF 
	ENDIF
	write(2,'(a)') text
	text=' '
 700  CONTINUE
      text=' '

      if (layers.LT.10) THEN
	 write(text(1:2),'(1a,i1)') ' ',layers
      ELSEIF (layers.LT.100) THEN
	 write(text(1:3),'(1a,i2)') ' ',layers
      ELSEIF (layers.GE.100) THEN
	 write(text(1:4),'(1a,i3)') ' ',layers
      ENDIF

      write(2,'(a)') text
      text=' ' 
      DO 800 i=1,layers
	write(text(1:5),'(f5.2)') vel(i)/psratio
	write(text(11:17),'(f7.2)') depth(i)
	write(text(20:26),'(f7.3)') 1.0
	IF (i.EQ.1) THEN
	  write(text(38:53),'(a)') 'S-VELOCITY MODEL'
	  IF (depth(i).LE.0) THEN
	    write(text(11:17),'(a7)') '  -5.00'
	  ENDIF
	ENDIF
	write(2,'(a)') text
	text=' '
  800 CONTINUE
      write(2,*)  
      CLOSE(read01)
      CLOSE(2)

      RETURN
      END

      subroutine make_hypoc_brief(data,nstat,nphase,nhead,nrecord)
c
c make summary output format according to BGS preference
c bjb 2001/02/14
c
c   changes:
c
c  mar 2 2001 jh : accept distance in f-format
c
      include '../INC/libsei.inc'          ! Library definitions & data defns.
      include '../INC/seidim.inc'          ! array dimensions

      external sei open,                   ! File open handler.
     &         sei close                   ! & closure.
      integer  code,                       ! Condition.
     &         read1,                      ! Read unit1.
     &         write1                      ! Write unit1.

c---phase readings array
      CHARACTER*80 DATA(2500)                                                  

c---number of header lines, records, stations in nordic file
      integer nstat,nphase,nhead,nrecord

      real sec
      real*8 declat,declon
      real latmin,lonmin
      real*8 grid_east,grid_north
      real depth
      real rms
      real mag1,mag2,mag3
      real oterr
      real erx,ery,erz
      real res
      
      integer year,month,day
      integer hour,min
      integer lat,lon
c      integer nstat
      integer gap
      integer dist,azi
      real xdist
      integer weight

      character*1 mtyp1,mtyp2,mtyp3
      character*1 w_or_e, n_or_s
      character*5 stat
      character*4 phas

      logical error

      error=.false.

C
C   open data base input single event file and read it
c   set flag for single event nrecord= -1
c
c      nrecord = -1
c      call sei open( old$,	! Open old file (stop on error).
c     &                  ' ',             ! No prompt.
c     &                  'hyp.out', read1,! File & unit.
c     &                  b_flag,          ! File exists? (n/a).
c     &                  code )           ! Local condition (n/a).
c      call indata(read1,nstat,nphase,nhead,nrecord,
c     &               typ,exp,data,id)
c      call sei close( close$, read1, code ) ! Close file (stop on error).

c
c open output file
c
      call sei open( unknown$,                ! Open brief file.
     &               ' ',                     ! No prompt.
     &               'hyp.brief', write1,     ! File & unit.
     &               b_flag,                  ! File exists?.
     &               code )                   ! Condition (n/a).

      do i=1,nhead

         if(data(i)(80:80).eq.'1') then

            read(data(i)(2:5), '(i4)') year
            read(data(i)(7:8), '(i2)') month
            read(data(i)(9:10), '(i2)') day

            write(write1,
     *           '(''Date        : '',i2.2,''/'',i2.2,''/'',i4.4)')
     *           day,month,year
            
            read(data(i)(12:13), '(i4)') hour
            read(data(i)(14:15), '(i2)') min
            read(data(i)(17:20), '(f4.1)') sec

            write(write1,
     *           '(''Origin time : '',i2.2,'':'',i2.2,'':'',f4.1)')
     *           hour,min,sec
      
C convert lat and lon to degrees and minutes
       
            read(data(i)(24:30), '(f7.3)') declat
            read(data(i)(31:38), '(f8.3)') declon
            read(data(i)(39:43), '(f5.1)') depth

            lat=int(declat)
            lon=int(declon)
            
            if (lon.lt.0.0) then
               w_or_e = 'W'
               lon = -lon
            else
               w_or_e = 'E'
            end if
            
            if (lat.lt.0.0) then
               n_or_s = 'S'
               lat = -lat
            else
               n_or_s = 'N'
            end if

            latmin=(abs(declat)-real(lat))*60.0
            lonmin=(abs(declon)-real(lon))*60.0


            write(write1,'(''Epicentre   : '',i2.2,''-'',f5.2,'' deg '',
     *           a1,1x,i3,''-'',f5.2,
     *           '' deg '',a1,f9.4,f9.4 )')
     *           lat,latmin,n_or_s,lon,lonmin,w_or_e,declat, declon

            call latlon2ukgrid(error,declat, declon, grid_east, 
     *           grid_north)

            write(write1,
     *       '(''Grid ref    : '',f9.3,'' East /'',f9.3,'' North'')')
     *           grid_east, grid_north
      
            if (data(i)(45:45) .eq. '*') then
               write(write1,
     *              '(''Depth       : '',f5.1,'' kms  (fixed)'')')
     *              depth
            else
               write(write1,'(''Depth       : '',f5.1,'' kms'')') depth
            endif
      

            read(data(i)(49:51), '(i3)') nstat
            read(data(i)(52:55), '(f4.1)') rms



            if (data(i)(56:59) .ne. '    ') then
               read(data(i)(56:59), '(f4.1)') mag1
               read(data(i)(60:60), '(a1)') mtyp1
               write(write1,'(''Magnitude   : '',f4.1,1x,''M'',a1)'),
     *              mag1,mtyp1
            endif


            if (data(i)(64:67) .ne. '    ') then
               read(data(i)(64:67), '(f4.1)') mag2
               read(data(i)(68:68), '(a1)') mtyp2
               write(write1,'(''Magnitude   : '',f4.1,1x,''M'',a1)'),
     *              mag2,mtyp2
            endif
            if (data(i)(72:75) .ne. '    ') then
               read(data(i)(72:75), '(f4.1)') mag3
               read(data(i)(76:76), '(a1)') mtyp3
               write(write1,'(''Magnitude   : '',f4.1,1x,''M'',a1)'),
     *              mag3,mtyp3
            endif

         else if(data(i)(80:80).eq.'E') then

               read(data(i)(6:8), '(i3)') gap
               read(data(i)(15:20), '(f6.2)') oterr
               read(data(i)(25:30), '(f6.1)') ery
               read(data(i)(33:38), '(f6.1)') erx
               read(data(i)(39:43), '(f5.1)') erz
               write(write1,*)
               write(write1,*)
     1    '             NO GAP  RMS   ERX   ERY   ERZ'
               write(write1,'(''Statistics  : ''
     1              ,i2,1x,i3,1x,f4.1,f6.1,f6.1,f6.1)'),
     2              nstat,gap,rms,erx,ery,erz
      
         endif

      enddo

      write(write1,*)
      write(write1,*) 'STAT  PHASE DIST AZI   RES WT'

      do i=nhead+1,nrecord-1
         read(data(i)(2:6), '(a5)') stat
         read(data(i)(11:14), '(a4)') phas
         read(data(i)(64:68), '(f5.1)') res
         read(data(i)(69:70), '(i2)') weight
         read(data(i)(71:75), '(f5.0)') xdist
         dist=xdist+0.5
         read(data(i)(77:79), '(i3)') azi

         write(write1,'(1x,a5,1x,a4,1x,i5,1x,i3,1x,f5.1,1x,i2)'),
     1        stat,phas,dist,azi,res,weight
      enddo
         

c      call sei close( close$, read1, code ) ! Close file (stop on error).
      call sei close( close$, write1, code ) ! Close file (stop on error).


C need to check if the file is empty..
      if(n_or_s.eq.' ') then    ! hyp.brief is empty
         error = .true.
      end if       

      return

      end

      subroutine put_seisan_message(text)
c
c   updates
c
c   sep 98 by jh  : ---------   verison 7.0 check ----------------
c                   no changes
c  mar 30   jh    : add routines put_message and get_message
c
c   put message text in a file seisan.mes
c
      implicit none
      include 'libsei.inc'
      character*200 text
      integer code   ! code from open
      logical b_old  ! from open
      integer unit   ! unit to write to
      integer seiclen
c
c   open message file
c
      call sei open(unknown$+warn$,        ! Open a unknown status file.
     &              ' ',                   ! Prompt file name (n/a).
     &              'seisan.mes',          ! File name
     &              unit,                  ! Write unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.

c
c   write to file
c
      write(unit,'(a)') text(1:seiclen(text)) ! fixed problem on solaris lo

c
c  close
c
      call sei close (close$,unit,code)
c
      return
      end

      subroutine get_seisan_message(text)
c
c   get message text from file seisan.mes
c
      implicit none
      include 'libsei.inc'
      character*200 text
      integer code   ! code from open
      logical b_old  ! from open
      integer unit   ! unit to write to
c
c   open message file
c
      call sei open(old$+ignore$,          ! Open a unknown status file.
     &              ' ',                   ! Prompt file name (n/a).
     &              'seisan.mes',          ! File name
     &              unit,                  ! Write unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.

       if(b_old) then
c
c   read from file
c
         read(unit,'(a)') text
c
c  close
c
         call sei close (delete$,unit,code)
      else
         text=' '
      endif
c
      return
      end


      subroutine put_message(file,text)
c
c   put message text in a file.mes
c   by lo
c
      implicit none
      integer  sei clen      ! character length
      include 'libsei.inc'
      character*200 text
      character* (*)  file
      character*80 filen
      integer code   ! code from open
      logical b_old  ! from open
      integer unit   ! unit to write to

      filen= file(1:seiclen(file)) // '.mes'

c
c   open message file
c
      call sei open(unknown$+warn$,        ! Open a unknown status file.
     &              ' ',                   ! Prompt file name (n/a).
     &              filen,          ! File name
     &              unit,                  ! Write unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.

c
c   write to file
c
      write(unit,'(a)') text
c
c  close
c
      call sei close (close$,unit,code)
c
      return
      end

      subroutine get_message(file,text)
c
c   get message text from file.mes
c   by lo
c
      implicit none
      integer  sei clen      ! character length
      include 'libsei.inc'
      character*(*) text
      character*(*) file
      character*80 filen
      integer code   ! code from open
      logical b_old  ! from open
      integer unit   ! unit to write to

      filen= file(1:seiclen(file)) // '.mes'
c
c   open message file
c
      call sei open(old$+ignore$,          ! Open a unknown status file.
     &              ' ',                   ! Prompt file name (n/a).
     &              filen,                 ! File name
     &              unit,                  ! Write unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.

       if(b_old) then
c
c   read from file
c
         read(unit,'(a)') text
c
c  close
c
         call sei close (delete$,unit,code)
      else
         text=' '
      endif
c
      return
      end

c 
c PROGRAM GMAP
c
c program to convert Nordic format to earth.google kml format.
c
c peter voss at GEUS, 17 apr 2008 version 0.9.6 Beta : added parameters to SEISAN.DEF
c peter voss at GEUS, 26 feb 2008 version 0.9.5 Beta : add -TimeSpan
c peter voss at GEUS, 20 feb 2008 version 0.9.4 Beta : add -color ff0000ff
c                                                    : add -nodata
c peter voss at GEUS, 19 feb 2008 version 0.9.3 Beta : use first available mag in header
c peter voss at GEUS,  8 feb 2008 version 0.9.2 Beta : will handel compact files
c                                                      can handel <,>,&,",' in Title
c peter voss at GEUS, 11 dec 2007 version 0.9.1 Beta
c
c   arguments:
c              -help           print help list
c              -color ff0000ff define color of epicenters
c              -nodata         kml file will only contain header line
c              -out_file       define name of output file (default is gmap.kml)
c              -verbose        be more verbose
c              -version        seisan version
c

       implicit none

C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! dimentions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c-- INPUT FILE                                         
      character*80 file
      character*80 out_file               ! full name of output file
      character*120 defdata
      character*80 data(max_data)
      character*80 title
      character*80 url,urle,urlpe,urlo
      character*8 color,colore,colorpe,coloro
      CHARACTER*1 TYPE,EXP

      integer neq, nexp, npexp, nother, i
      integer nstat,nphase,nhead,nrecord

      real MSIZE,XSIZE,YSIZE

      integer narg                            ! number of arguments
      character*80 arg(40)                    ! arguments
      character*80 gmap_append_kml(100)       ! text that can be appended to gmap.kml
      integer n_gmap_append_kml               ! number of text lines

C-- ID LINE NUMBER
      INTEGER ID

      logical visible       ! show event in kml
      logical sdata
      logical compact       ! compact input file or not
      logical datafolder    ! kml file contain no folders with data
      logical ttag          ! kml file contain timespan for scrolling in time domain

c input file unit #
      integer read01,write01
c logical for existing file or not
      logical          b_old
c returned code
      integer          code
c-- unit for file
      integer def_unit
      logical  b_eof                         ! End of file?.

      logical  verbose
c
c print version
c
      include 'version.inc'
      out_version_date='FEB 26, 2008'
      if (version_new) out_version_date=version_date
      call print_ver

      XSIZE=0.5
      XSIZE=0.2
      YSIZE=0.5

      url="http://maps.google.com/mapfiles/kml/pal2/icon26.png"
      urle="http://maps.google.com/mapfiles/kml/shapes/star.png"
      urlpe=
     +"http://maps.google.com/mapfiles/kml/shapes/open-diamond.png"
      urlo="http://maps.google.com/mapfiles/kml/shapes/square.png"

      out_file='gmap.kml'

      color="ff0000ff"
      colore="ff0000ff"
      colorpe="ff0000ff"
      coloro="ff0000ff"

      neq=0
      nexp=0
      npexp=0
      nother=0

      verbose=.FALSE.
      datafolder=.TRUE.
      ttag=.FALSE.

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   open and read default file
c   ---------------------------
      n_gmap_append_kml=0
c
      call sei get file( open$+ignore$,    ! Find and open without messages.
     &                   def_unit,         ! On file unit.
     &                   code,             ! Condition (n/a).
     &                   'DAT',            ! Alternative directory to search.
     &                   'SEISAN.DEF' )    ! For this file.
c
c   read file if there...
c   ---------------------
c
c     if(code.ne.e_ok$)  return

 333  continue
c
      read(def_unit,'(a)',iostat=code) defdata    ! Read from file.
      call sei code( fort$,                    ! Process fortran i/o condition.
     &               code,                     ! Condition.
     &               def_unit,                 ! On unit.
     &               b_eof )                   ! End of file?.
c
      if( .not.b_eof ) then                    ! Not end of file.
c
c   Look for GMAP parameters
c
       if (defdata(1:15).eq.'GMAP_ICON_QUAKE') then
	    read(defdata(41:80),'(a)') url(1:40)
       elseif (defdata(1:19).eq.'GMAP_ICON_EXPLOSION') then
	    read(defdata(41:80),'(a)') urle(1:40)
       elseif (defdata(1:19).eq.'GMAP_ICON_PROB_EXPL') then
	    read(defdata(41:80),'(a)') urlpe(1:40)
       elseif (defdata(1:22).eq.'GMAP_ICON_OTHER_EVENTS') then
	    read(defdata(41:80),'(a)') urlo(1:40)
       elseif (defdata(1:15).eq.'GMAP_ICON_MSIZE') then
            read(defdata(41:55),'(f15.5)') MSIZE
       elseif (defdata(1:15).eq.'GMAP_ICON_XSIZE') then
            read(defdata(41:55),'(f15.5)') XSIZE
       elseif (defdata(1:15).eq.'GMAP_ICON_YSIZE') then
            read(defdata(41:55),'(f15.5)') YSIZE
       elseif (defdata(1:15).eq.'GMAP_APPEND_KML') then
	    n_gmap_append_kml=n_gmap_append_kml+1
            gmap_append_kml(n_gmap_append_kml)=defdata(41:120)
       endif
c
c   go to next line
c
      goto 333
      endif
      call sei close( close$, def_unit, code ) ! Close (Default stop on error).
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      call get_arguments(narg,arg)
      if(narg.ge.1) then
      do i=1,narg
      if( arg(i)(1:8) .eq. '-verbose' ) verbose=.TRUE.
      if( arg(i)(1:7) .eq. '-nodata' ) datafolder=.FALSE.
      if( arg(i)(1:9) .eq. '-timespan' ) ttag=.TRUE.
      if( arg(i)(1:9) .eq. '-out_file' ) then
	out_file=arg(i+1)
      endif
      if( arg(i)(1:6) .eq. '-color' ) then
	color=arg(i+1)
	colore=arg(i+1)
	colorpe=arg(i+1)
	coloro=arg(i+1)
        if( arg(i+1)(1:4) .eq. 'blue' ) then
          color="ffff0000"
          colore="ffff0000"
          colorpe="ffff0000"
          coloro="ffff0000"
        endif
        if( arg(i+1)(1:5) .eq. 'green' ) then
          color="ff00ff00"
          colore="ff00ff00"
          colorpe="ff00ff00"
          coloro="ff00ff00"
        endif
        if( arg(i+1)(1:6) .eq. 'yellow' ) then
          color="ffffff00"
          colore="ffffff00"
          colorpe="ffffff00"
          coloro="ffffff00"
        endif
        if( arg(i+1)(1:5) .eq. 'black' ) then
          color="ff000000"
          colore="ff000000"
          colorpe="ff000000"
          coloro="ff000000"
        endif
        if( arg(i+1)(1:5) .eq. 'white' ) then
          color="ffffffff"
          colore="ffffffff"
          colorpe="ffffffff"
          coloro="ffffffff"
        endif
      endif
      if( arg(i)(1:5).eq.'-help'.or.arg(i)(1:3).eq.'-h') then
        write(6,*)' '
        write(6,*)
     +' The GMAP program converts Nordic format to the KML format.'
        write(6,*)
     +' The output file gmap.kml can be opened with Google Earth.'
        write(6,*)
     +' The program prompts for a input file in nordic format, the'
        write(6,*)' input file can be compact.'
        write(6,*)' '
        write(6,*)' Usage: gmap [options]'
        write(6,*)'        input file    '
        write(6,*)'        Title used for kml folder'
        write(6,*)' '
        write(6,*)' ## Options ##'
        write(6,'(a17,a15)')'    -help        '
     +,'Print this list'
        write(6,'(a17,a13)')'    -h           '
     +,'Same as -help'
        write(6,'(a17,a46)')'    -color       '
     +,'Define color of epicenters [blue/green/yellow/'
        write(6,'(a17,a47)')'                 '
     +,'black/white] Default color is red              '
        write(6,'(a17,a44)')'                 '
     +,'To uses other colors see describtion below  '
        write(6,'(a17,a44)')'    -timespan    '
     +,'Events gets timetag scroll in time domain   '
        write(6,'(a17,a44)')'    -nodata      '
     +,'kml file will only contain header infomation'
        write(6,'(a17,a48)')'    -out_file    '
     +,'Define name of output file (default is gmap.kml)'
        write(6,'(a17,a15)')'    -verbose     '
     +,'Be more verbose'
        write(6,'(a17,a15)')'    -version     '
     +,'Seisan version '
        write(6,*)' '
        write(6,*)' Scale:'
        write(6,*)' The scale of the icons is set by the SEISAN.DEF '
        write(6,*)' parameters GMAP_ICON_MSIZE, GMAP_ICON_XSIZE and '
        write(6,*)' GMAP_ICON_YSIZE, see the manual for details.'
        write(6,*)' '
        write(6,*)' Color:'
        write(6,*)' Color and opacity (alpha) values are expressed in '
	write(6,*)' hexadecimal notation. The range of values for any '
	write(6,*)' one color is 0 to 255 (00 to ff). For alpha, 00 is'
	write(6,*)' fully transparent and ff is fully opaque. The order'
	write(6,*)' of expression is aabbggrr, where aa=alpha (00 to ff);'
	write(6,*)' bb=blue (00 to ff); gg=green (00 to ff); '
	write(6,*)' rr=red (00 to ff). For example, if you want to apply '
	write(6,*)' a blue color with 50 percent opacity to an overlay, '
	write(6,*)' you would specify the following: '
	write(6,*)' <color>7fff0000</color>, where alpha=0x7f, blue=0xff,'
	write(6,*)' green=0x00, and red=0x00. See also:'
        write(6,*)' http://code.google.com/apis/kml/'
	write(6,*)' documentation/kml_tags_21.html#color '
        write(6,*)' '
        write(6,*)' Examples:'
        write(6,*)'           gmap -color blue -nodata'
        write(6,*)'           gmap -timespan -color 7eee00ee'
        write(6,666)
     +'            echo ','collect.out\\nDK events\\n',
     +' | gmap -out_file dk.kml'
        write(6,*)' '
      goto 999
      endif
      enddo
      endif

  666 FORMAT(a17,'"',a24,'"',a24,1x)

      if(verbose) write(6,*)' GMAP: narg=',narg

 101  continue
      write(6,*)' INPUT FILE NAME'
      read(5,'(a)') file

c
c   open and check if file available
c
            call sei open(old$,                  ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    file,                  ! File name
     &                    read01,                ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
c
      if(.not.b_old) goto 101     ! try again
c
c   check type
c
      call nortype(read01,compact)
      if(verbose.and.compact) write(6,*)' GMAP: Input file is compact'
c if input file is compact copy it to gmap.tmp with extra empty line for subroutine INDATA
      if(compact) then
        call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',               ! Prompt file name (n/a).
     &                    'gmap.tmp',        ! File name
     &                    write01,            ! Read unit #1
     &                    b_old,             ! Already exists? (n/a).
     &                    code)              ! Returned condition.
 501    read(read01,'(a)',end=509) data(1)
        write(write01,'(a)') data(1)
        write(write01,'(a)')' '
	goto 501
 509    continue
	close(read01)
	rewind write01
	read01=write01
      endif
 
      if(verbose) 
     +write(6,*)' GMAP: The title must contain maximum 80 characters!'
      write(6,*)' Title:'
      read(5,'(a)') title

      if(verbose) 
     +write(6,*)' GMAP: open out_file :',out_file
      open(2,file=out_file,status='unknown')

      write(2,'(a38,1x)')'<?xml version="1.0" encoding="UTF-8"?>'
      write(2,'(a45,1x)')'<kml xmlns="http://earth.google.com/kml/2.1">'
      write(2,'(a10,1x)')'<Document>'
      write(2,'(a23,1x)')'<name><![CDATA['
      if(verbose) 
     +write(6,*)' GMAP: Change special characteres in Title to KML'
      do i=1,80
        if(title(i:i).eq.'"')then
          write(2,'(a,$)')"&#34;"
        elseif(title(i:i).eq."&")then
          write(2,'(a,$)')"&#38;"
        elseif(title(i:i).eq."'")then
          write(2,'(a,$)')"&#39;"
        elseif(title(i:i).eq."<")then
          write(2,'(a,$)')"&#60;"
        elseif(title(i:i).eq.">")then
          write(2,'(a,$)')"&#62;"
        else
          write(2,'(a,$)')title(i:i)
        endif
      enddo
      write(2,'(a21,1x)')']]></name>'
      write(2,'(a18,1x)')'<open>1</open>'
c
c Earthquakes :
c
      visible=.TRUE.
      sdata=.FALSE.
      write(2,'(1x)')
      write(2,'(a12,1x)')'<Folder>'
      write(2,'(a30,1x)')'<name>Earthquakes</name>'
      if(verbose)
     +write(6,*)' GMAP: construct folder with earthquakes'
      if(verbose) 
     +write(6,*)
     +' GMAP: check number of : eq, exp, pexp and other events'
  10  continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)

      if(nrecord.eq.0) goto 19
      if(EXP.eq.' ')neq=neq+1
      if(EXP.eq.'E')nexp=nexp+1
      if(EXP.eq.'P')npexp=npexp+1
      if(EXP.ne.' '.AND.EXP.ne.'E'.AND.EXP.ne.'P')nother=nother+1
      if(EXP.eq.' ') then
       CALL wkml(2,data,max_data,NRECORD,url,visible,color,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 10
  19  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')

c
c Earthquakes and data
c
      if(datafolder)then
      if(verbose)
     +write(6,*)' GMAP: construct folder with earthquakes and data'
         rewind read01
      visible=.FALSE.
      sdata=.TRUE.
      write(2,'(a12,1x)')'<Folder>'
      write(2,'(a39,1x)'),
     +'<name>Earthquakes and data</name>'
   21 continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 29
      if(EXP.eq.' ') then
       CALL wkml(2,data,max_data,NRECORD,url,visible,color,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 21
  29  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')
      endif

c
c Explosions
c
      if(nexp.gt.0)then
      if(verbose)
     +write(6,*)' GMAP: construct folder with explosions'
      visible=.FALSE.
      sdata=.FALSE.
      rewind read01
      visible=.FALSE.
      write(2,'(a12,1x)')'<Folder>'
      write(2,'(a29,1x)'),
     +'<name>Explosions</name>'
   31 continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 39
      if(EXP.eq.'E') then
       CALL wkml(2,data,max_data,NRECORD,urle,visible,colore,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 31
  39  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')

c
c Explosions and data
c
      if(datafolder)then
      if(verbose)
     +write(6,*)' GMAP: construct folder with explosions and data'
      rewind read01
      visible=.FALSE.
      sdata=.TRUE.
      write(2,'(a12,1x)')'<Folder>'
      write(2,'(a38,1x)'),
     +'<name>Explosions and data</name>'
   41 continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 49
      if(EXP.eq.'E') then
       CALL wkml(2,data,max_data,NRECORD,urle,visible,colore,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 41
  49  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')
      endif
      endif

c
c Probable Explosions
c
      visible=.FALSE.
      sdata=.FALSE.
      if(npexp.gt.0)then
      if(verbose)
     +write(6,*)' GMAP: construct folder with prob. explosions'
        rewind read01
      write(2,'(a12,1x)')'<Folder>'
      write(2,'(a38,1x)'),
     +'<name>Probable Explosions</name>'
   51 continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 59
      if(EXP.eq.'P') then
        CALL wkml(2,data,max_data,
     +NRECORD,urlpe,visible,colorpe,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 51
  59  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')

c
c Probable Explosions and data
c
      if(datafolder)then
      if(verbose)
     +write(6,*)' GMAP: construct folder with prob. explosions and data'
      rewind read01
      visible=.FALSE.
      sdata=.TRUE.
      write(2,'(a12,1x)')'<Folder>'
      write(2,'(a47,1x)'),
     +'<name>Probable Explosions and data</name>'
   61 continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 69
      if(EXP.eq.'P') then
        CALL wkml(2,data,max_data,
     +NRECORD,urlpe,visible,colorpe,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 61
  69  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')
      endif
      endif

c
c Other events
c
      if(nother.gt.0)then
        rewind read01

      if(verbose)
     +write(6,*)' GMAP: construct folder with other events'
      visible=.FALSE.
      sdata=.FALSE.
      write(2,'(a12,1x)')'<Folder>'
      write(2,'(a31,1x)'),
     +'<name>Other events</name>'
   71 continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 79
      if(EXP.ne.' '.and.EXP.ne.'E'.and.EXP.ne.'P') then
       CALL wkml(2,data,max_data,NRECORD,urlo,visible,coloro,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 71
  79  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')

c
c Other events and data
c
      if(datafolder)then
         rewind read01
      if(verbose)
     +write(6,*)' GMAP: construct folder with other events and data'
      visible=.FALSE.
      sdata=.TRUE.
      write(2,'(a16,1x)')'<Folder>'
      write(2,'(a40,1x)'),
     +'<name>Other events and data</name>'
   81 continue
      CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 89
      if(EXP.ne.' '.and.EXP.ne.'E'.and.EXP.ne.'P') then
       CALL wkml(2,data,max_data,NRECORD,urlo,visible,coloro,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      endif
      goto 81
  89  continue
      write(2,'(a13,1x)')'</Folder>'
      write(2,'(1x)')
      endif
      endif

      close(read01)  

c
c info and links
c

      if(n_gmap_append_kml.ge.1)then
	do i=1,n_gmap_append_kml
          write(2,'(a80,1x)'),gmap_append_kml(i)
	enddo
      endif
c     write(2,'(a29,1x)'),'<ScreenOverlay id="LOGO">'
c     write(2,'(a33,1x)'),
c    +'<name>Info and links</name>'
c     write(2,'(a29,1x)'),'<description> <![CDATA['
c     write(2,'(a68,1x)'),
c    +'Data is in Nordic format. The format is described in the Seisan '
c     write(2,'(a26,1x)'),
c    +'manual at UIB.<br>'
c     write(2,'(a51,1x)'),
c    +'UIB:  http://www.geo.uib.no/seismo/<br> ]]>'
c     write(2,'(a20,1x)'),'</description>'
c     write(2,'(a12,1x)'),'<Icon>'
c     write(2,'(a55,1x)'),
c    +'<href>http://www.gfy.ku.dk/~pv/geus.png</href>'
c     write(2,'(a13,1x)'),'</Icon>'
c     write(2,'(a66,1x)'),
c    +'<overlayXY x="0" y="1" xunits="fraction" yunits="fraction"/>'
c     write(2,'(a53,a19,1x)'),
c    +'<screenXY x="-0.01" y="0.99" xunits="fraction" ',
c    +'yunits="fraction"/>'
c     write(2,'(a67,1x)'),
c    +'<rotationXY x="0" y="0" xunits="fraction" yunits="fraction"/>'
c     write(2,'(a65,1x)'),
c    +'<size x="0.1" y="0.1" xunits="fraction" yunits="fraction"/>'
c     write(2,'(a20,1x)'),'</ScreenOverlay>'
      write(2,'(a13,1x)'),'</Document>'
      write(2,'(a6,1x)'),'</kml>'
      close(2)  

      write(6,*)"Number of Earthquakes         :",neq
      write(6,*)"          Explosions          :",nexp
      write(6,*)"          Probable Explosions :",npexp
      write(6,*)"          Other events        :",nother
      write(6,*)"Output file is ",out_file

 999  continue

      end


      SUBROUTINE wkml(io,text,max_data,nr,url,visible,color,sdata,ttag,
     +MSIZE,XSIZE,YSIZE)
      character*80 text(max_data)
      character*80 dummy,url
      character*8 color
      character*7 magnitude
      integer io,i,j
      real mag
      real MSIZE,XSIZE,YSIZE
      logical visible, sdata
      logical ttag			! timetag / timespan

      magnitude="       "

c remove chars like backspace
      do i=1,nr
        do j=1,80
          if(ichar(text(i)(j:j)).lt.32) text(i)(j:j)=" "
        enddo
      enddo

c get magnitude
      if(text(1)(73:79).ne.'       ')magnitude=text(1)(73:79)
      if(text(1)(65:71).ne.'       ')magnitude=text(1)(65:71)
      if(text(1)(57:63).ne.'       ')magnitude=text(1)(57:63)

      if(text(1)(7:7).eq.' ')text(1)(7:7)='0'
      if(text(1)(9:9).eq.' ')text(1)(9:9)='0'
      if(text(1)(17:17).eq.' ')text(1)(17:17)='0'
      if(text(1)(28:28).eq.' ')text(1)(28:28)='0'
      if(text(1)(29:29).eq.' ')text(1)(29:29)='0'
      if(text(1)(30:30).eq.' ')text(1)(30:30)='0'
      if(text(1)(36:36).eq.' ')text(1)(36:36)='0'
      if(text(1)(37:37).eq.' ')text(1)(37:37)='0'
      if(text(1)(38:38).eq.' ')text(1)(38:38)='0'
c mag is size of circle
      if(magnitude.ne."       ")then
       mag=ichar(magnitude(1:1))-48.0
       mag=mag+0.1*(ichar(magnitude(3:3))-48.0)
      else
       mag=MSIZE
      endif
      if(mag.lt.MSIZE)mag=MSIZE
      mag=XSIZE*mag**YSIZE
      if(text(1)(23:23).ne." ")mag=mag*2.0
      write(io,'(a17,1x)'),'<Placemark>'
      if(visible) then
	write(io,'(a34,1x)'),'<visibility>1</visibility>'
      else
	write(io,'(a34,1x)'),'<visibility>0</visibility>'
      endif
      if(sdata) then
      write(io,'(a14,a4,a1,a2,a1,a2,a1,a2,a1,a2,a1,a6,a1,a7,a7,1x)'),
     +'<name>',text(1)(2:5),'-',text(1)(7:8),'-',text(1)(9:10),'_',
     +text(1)(12:13),':',text(1)(14:15),':',text(1)(17:22),'_',
     +text(1)(57:63),'</name>'
      else
c     write(io,'(a21,a3,a2,a1,a14,1x)'),'<description>',
c    +text(1)(57:59),' M',text(1)(60:60),' ',
      write(io,
     +'(a21,a3,a2,a1,a1,a4,a1,a2,a1,a2,a1,a2,a1,a2,a1,a4,a14,1x)'),
     +'<description>',
     +magnitude(1:3),' M',magnitude(4:4),' ',
     +text(1)(2:5),'-',text(1)(7:8),'-',text(1)(9:10),'_',
     +text(1)(12:13),':',text(1)(14:15),':',text(1)(17:20),
     +'</description>'
      endif
      write(io,'(a15,1x)'),'<Style>'
      write(io,'(a21,1x)'),'<IconStyle>'
      write(io,'(a19,a8,a8,1x)'),'<color>',color,'</color>'
      write(io,'(a41,1x)'),'<colorMode>normal</colorMode>'
      write(io,'(a19,f6.2,a8,1x)'),'<scale>',mag,'</scale>'
      write(io,'(a18,1x)'),'<Icon>'
      write(io,'(a20)'),'<href>'
      write(io,'(a16,a80)'),"                ",url
      write(io,'(a21,1x)'),'</href>'
      write(io,'(a19,1x)'),'</Icon>'
      write(io,'(a22,1x)'),'</IconStyle>'
      write(io,'(a16,1x)'),'</Style>'
      write(io,'(a15,1x)'),'<Point>'
      do i=24,38
        dummy(i:i)=text(1)(i:i)
c       if(text(1)(i:i).eq.' ')dummy(i:i)='0'
      enddo
      write(io,111),dummy(31:38),dummy(24:30)
      write(io,'(a16,1x)'),'</Point>'
      if(ttag) then
        write(io,'(a36,1x)'),'<TimeSpan>'
        write(io,'(a16,a4,a1,a2,a1,a2,a9,1x)'),
     +'<begin>',text(1)(2:5),'-',text(1)(7:8),'-',text(1)(9:10),
     +'</begin>'
        write(io,'(a16,a4,a1,a2,a1,a2,a6,1x)'),
     +'<end>',text(1)(2:5),'-',text(1)(7:8),'-',text(1)(9:10),
     +'</end>'
        write(io,'(a36,1x)'),'</TimeSpan>'
      endif
      if(sdata) then
        write(io,'(a36,1x)'),'<description> <![CDATA[<pre>'
        do i=1,nr
          write(io,'(a80)'),text(i)(1:80)
        enddo
        write(io,'(a31,1x)'),'</pre>]]></description>'
      endif
      write(io,'(a18,1x)'),'</Placemark>'

 111  FORMAT('          <coordinates>',a8,',',a7,',0,</coordinates>')
      end

cProgram norgse
c
c   Mario Villagran, October 1995
c
c   converts nordic format files into GSE2.0 format 
c   as specified in GSETT-3 project to submit information 
c   to the IDC and viceversa.
c
c   Input:   nordic or GSE2.0 format file
c
c            if input is nordic, the corresponding hyp.out
c            and print.out are necesary as well as a correlative
c            number to identify the event in GSE2.0 format.
c
c            if input is GSE2.0 no more info is needed.
c      
c   Oputput: GSE2.0 or nordic format file
c
c   comments: When CONVERTING from nordic to GSE2.0
c
c             vector printout(1000*flines) contains space for 
c             700*flines print.out lines of an event
c             300*flines nordic file lines
c
c   comments: When CONVERTING from GSE2.0 to nordic
c
c             vector printout(1000*flines) contains space for 
c             nordic file lines
c
c             To extend the capacity you have to change
c             the parameter flines (factor to increase 
c             the size of the array 1, 2 ,3....).
c
c   Changes:
c   Feb       1997  m.v. : use time from the system to write GSE2.0
c   March 18             : converts full GSE2.0 <----> nordic, sun or pc
c                        : checks errors and display solutions
c   March 26             : implement 4 magnitudes possibility
c   Aug   19             : allows more than 1 blank line after
c                        : header, region and phases
c   Aug   28             : mb is appropriately included (subr mb_att appended)
c
c   1998
c
c   A major improvement in the program, now allows input and outputs
c   compact files for any format to any format (nordic, GSE2.0)
c
c   Jan   29        m.v. : now also number ID for phases
c   Jan   29        m.v. : creates compact.gse file only with headers.
c   Feb    3        m.v. : all events converted from GSE2.0 to nordic are "R"
c                          fixdepth indicator switched to uppercase "F"
c                          Mb indicator switched to uppercase "B"
c                          line type 1 is now flagged "1" at the 80 column
c                          includes if manual or automatic picking phase "am"
c   Nov   17        m.v. : problem with npha in convertion to gse2.0
c                          also declaring 'T' time valid for T phase or ampl.
c   1999
c   March 03        m.v. : changes after some comments from
c                          Victoria Oancea <oancea@cmr.gov> for the 
c                          compact.gse that is submitted to IDC (gamma info)
c                          see : 
c                             ~seismo/WOR/EXPERIMENTS/REPORTED_to_IDC/idc.mail
c   June 99  jh            : -----------------   SEISAN 7.0 ------------------
c                            no check for year 2000 or 5 char stations, small
c                            format bugs fixed
c                            use seisan systime, cut out conversion to 
c                            gmt in message
c   june 23  lo            : added interactive input
c   sep, 18 2000 lo        : tarray(6)+2000, for system time
c   jul 5   2001 jh        : distance to real
c   march 11 2002 lo       : changed names of output files, and added outfile for ARRIVAL
c
      implicit none
c
c size of working array
      integer flines
      parameter        (flines=10)
c-- arguments, input file, location agency and mag agencies.
      character*132    printout(1000*flines),text   !SEE comments BEFORE
      character*80     args(10),infile,printhyp,region,top_directory
      character*30     ttext
      character        fecha*21,numero*8,sta*4,ph*4
      character*11     msta(150)
      character*3      lage,age1,age2,age3,def
c--crustal model, type of event, id of event,kind of magnitudes.
      character*1      model,type,id,fixd,cd,uno,am
      character*2      mc,mc1,mc2,mc3,mc4,evex,pl,r1,r2,r3,r4,r5
c--time variables, hypocentral parameters and magnitudes.
      integer          year,mo,dy,hr,mn,npha,nsta,number,gap,az
      integer          nsm1,nsm2,nsm3,nsm4,n,dist,reg,kstop,phnumber
      real             xdist
      real             mag,mag1,mag2,mag3,mag4,hdist,smag,sbmag,snr
      real             sec,lat,lon,dep,rms,tres,velo
      real             ermag1,ermag2,ermag3,x1,x2,x3,mw,smw,azph,raz
      real             timerr,x,smajor,sminor,erd,dmin,dmax,amp,per
c--ML,Mb
      real             a,b,c,d,smsta,q,equrad,polrad,pi,rad,radius
                       parameter (equrad = 6378.2064)
                       parameter (polrad = 6356.5838)
                       parameter (pi = 3.14159265)
                       parameter (rad = pi/180.)

      integer*4        stime,tarray(9),time,nmsta
      character*12     t1   ! for seisan system time
      character*14     t2   ! ---------------------
c---ellipse error
      real             ery,erx,erz,cvxy,cvxz,cvyz
c---number of arguments and counters
      integer nars,ncards,i,j,k,ncard,npcard,namp,work,karr,jarr,nmw
      integer nbamp
c--compact or not
      logical compact
c--computer type
      logical pc, sun,linux
c---
c

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

        call computer_type(sun,pc,linux)
c
c   check if input from file given in argument
c   display help if necesary
c
      call get_arguments(nars,args)

      if (nars.eq.0) then

        write(6,*) ' Choose option: '
        write(6,*) '     GSE2.0 -> nordic (1) or '
        write(6,*) '     nordic -> GSE2.0 (2)'
        read(*,'(a)') args(1)
        if (args(1).eq.'1') then
          write(*,*) ' GSE2 input file '
          read(*,'(a)') args(2)
        elseif (args(1).eq.'2') then
          write(*,*) ' Nordic input file '
          read(*,'(a)') args(2)
          write(*,*) ' Hypocenter output file (default=print.out)'
          read(*,'(a)') args(3)
          if (args(3).eq.' '.or.args(3).eq.'') args(3)='print.out'
          write(*,*) ' Number of first event'
          read(*,'(a)') args(4)
          write(*,*) ' Number of first phase'
          read(*,'(a)') args(5)
        endif

      elseif (nars.eq.1.and.args(0).eq.'-help') then
5       write(6,*)'          '
        write(6,*)' You must define the desired convertion type,'
        write(6,*)' input files and id number (this last only case 2)'
        write(6,*)' 1 for GSE2.0------> nordic or'
        write(6,*)' 2 for nordic------> GSE2.0'
        write(6,*)' examples:'
        write(6,*)'          '
        write(6,*)' norgse 1 xx.inp'
        write(6,*)'          '
        write(6,*)' This converts file xx.inp from GSE2.0 to nordic'
        write(6,*)' output is file norgse.nor'
        write(6,*)'          '
        write(6,*)' norgse 2 hyp.out print.out 35 850'
        write(6,*)'          '
        write(6,*)' This creates a GSE2.0 file from the hyp.out and'
        write(6,*)' print.out files and gives to the first event '
        write(6,*)' in list the number 35, and 850 to the first phase'
        write(6,*)' if number is not defined 001 is the default'
        write(6,*)' for both, output files are: '
        write(6,*)'   gse_bulletin.out, gse_origin.out and '//
     &            'gse_arrival.out '
        write(6,*)'          '
        stop
      endif
c
c check arguments
c get input file names and decides what to do
c open files
c
      pl='+-'
      read(args(1),'(i1)',err=5)work
      if((work.eq.1.and.nars.gt.2).or.(nars.gt.5).or.
     *(work.gt.2).or.(work.lt.1))then
        write(6,*)' Wrong arguments !!!!!!!!!!!'
        write(6,*)'    '
        goto 5
      endif
      infile=args(2)
      open(1,file=infile,status='old')
c      stime=time()
      call systime(t1,t2)   ! seisan general routine
      read(t1,'(5i2)') (tarray(i),i=6,2,-1)
c      call gmtime(stime, tarray)      !GMT time
c      write(ttext(1:30),'(a7,i4,3(a1,i2),i2,a8)')
c     *'MSG_ID ',tarray(6)+2000,'/',tarray(5)+1,'/',tarray(4),'_',
c     *tarray(3),tarray(2),' ISR_NDC'
c      do i=13,22   !fill blanks
c        if(ttext(i:i).eq.' ')ttext(i:i)='0'
c      enddo

      if(work.eq.1)goto 50
c
c   HERE STARTS CONVERTING FROM NORDIC TO GSE
c
      printhyp=args(3)
      read(args(4),'(i)',err=6)number
6     if(number.eq.0)number=1
      read(args(5),'(i)',err=7)phnumber
7     if(phnumber.eq.0)phnumber=1
      open(7,file=printhyp,status='old')
c      open(2,file='norgse.gse',status='unknown')
      open(2,file='gse_bulletin.out',status='unknown')
      open(4,file='gse_origin.out',status='unknown')
      open(3,file='gse_arrival.out',status='unknown')
c      open(4,file='compact.gse',status='unknown')
c
c   check if it is a correct s-file
c
      call nortype(1,compact)
      if(compact) then
       write(6,*)' The file must be an F-file'
       stop
      endif
c
c Gets the time at which the file is done if sun GMT time
c note that on pc the time is local unless some extra-arrangement
c   WRITE GSE2.0 EXCHANGE DATA LINES
c
c
c this part should really not be done here LO!
c

c      write(2,'(a12)')'BEGIN GSE2.0'
c      write(2,'(a13)')'MSG_TYPE DATA'
c      write(2,'(a30)')ttext(1:30)
c      write(2,'(a23)')'DATA_TYPE ORIGIN GSE2.0'
c      write(4,'(a12)')'BEGIN GSE2.0'
c      write(4,'(a13)')'MSG_TYPE DATA'
c      write(4,'(a30)')ttext(1:30)
c      write(4,'(a23)')'DATA_TYPE ORIGIN GSE2.0'

c
c   NORDIC ----> GSE2.0    BIG LOOP STARTS HERE
c
      n=0        !  number of processed events
      a=1.00     ! default calculation of ML is
      b=1.11     ! Hutton & Boore, a,b,c,d
      c=0.00189
      d=-1.9680
c magnitude constants for ML (check if other values in STATION0.HYP)
      call topdir(top_directory)
      i=index(top_directory,' ')-1
      text(1:i+17)=top_directory(1:i)//'/DAT/STATION0.HYP'
      open(8,file=text(1:i+17),status='old')
8     read(8,'(a)')text(1:40)
      if(text(1:5).eq.'RESET')then
       if(text(12:13).eq.'75')read(text(16:),*)a
       if(text(12:13).eq.'76')read(text(16:),*)b
       if(text(12:13).eq.'77')read(text(16:),*)c
       if(text(12:13).eq.'78')read(text(16:),*)d
      endif
      close(8)
c
c  initialize variables
c
  10  continue
        mc1(1:2)='  '
        mc2(1:2)='  '
        mc3(1:2)='  '
        mc4(1:2)='  '
        mag1=0.0
        mag2=0.0
        mag3=0.0
        mag4=0.0
        ermag1=0.0
        ermag2=0.0
        ermag3=0.0
        region(1:80)='  '
        nsta=0
        npha=0
        dmax=0.0
        dmin=15000.00
c
c   GET NECESARY INFORMATION FROM print.out AND THE F-file
c
        ncards=1
15      read(7,'(a80)',end=99)printout(1)(1:80)
           if(printout(1)(1:8).eq.' EVENT #')goto 20
        goto 15
20      ncards=ncards+1
         read(7,'(a80)',end=28)printout(ncards)(1:80)
         if(printout(ncards)(1:10).eq.'----------')goto 28
c
c displays possible errors and stop the program
c
         if(ncards.gt.650*flines)then
          write(6,*)printout(1)(1:20),'to many print.out lines!!'
          write(6,*)'to solve this, edit norgse.f, read comments'
          goto 99
22        write(6,*)'print.out and S-file not matching !!!'
24        goto 99
         endif
        goto 20
28      continue
        do i=1,ncards
          if(printout(i)(1:19).eq.' Origin time error:')
     *    read(printout(i)(20:60),*)timerr
          if(printout(i)(1:18).eq.'   date hrmn   sec')
     *        read(printout(i+1)(1:80),'(73x,f5.1)')erd
          if(printout(i)(6:19).eq.'multiple-phase')
     *    read(printout(i)(1:5),'(i5)')npha
          if(printout(i)(1:14).eq.' Azimuthal Gap')
     *    read(printout(i)(36:38),'(i3)')gap
          if(printout(i)(1:17).eq.' stn   dist   azm')then
             do j=i+1,ncards
               if(printout(j)(1:3).eq.'   ')goto 30
                 read(printout(j)(1:11),'(7x,i4)')k
               if(dmax.lt.k)dmax=k
               if(dmin.gt.k)dmin=k
             enddo
          endif
30        continue
        enddo
c
c read info from current event and
c place the file ready to read next event
c
        ncard=700*flines  !reserve 701*flines to 1000*flines for nordic 
        namp=0
        nbamp=0
        nsm4=0
        npcard=0
        k=0
        smag=0.0
        sbmag=0.0
        smw=0.0
        nmw=0
        nmsta=0
        smsta=0
35      read(1,'(a80)',end=22)text(1:80)
        if(text(1:20).eq.'                    '.
     *      and.text(80:80).eq.' ')goto 40
        ncard=ncard+1
        if(k.eq.0)then
         if(text(80:80).eq.'1'.or.text(80:80).eq.' ')then
          if(text(22:22).eq.'L'.or.text(22:22).eq.'R'.or.
     *    text(22:22).eq.'D')then
            read(text(1:80),100)year,mo,dy,hr,
     *      mn,sec,model,type,id,lat,lon,dep,fixd,lage,nsta,
     *      rms,mag1,mc1(2:2),age1,mag2,mc2(2:2),age2,mag3,
     *      mc3(2:2),age3,uno
            if(mc1(2:2).eq.'C')mag1=0.0        !MC = MD
            if(mc1(2:2).eq.'C')mc1(2:2)=' '    !to avoid repetition
            if(mc2(2:2).eq.'C')mag2=0.0
            if(mc2(2:2).eq.'C')mc2(2:2)=' '
            if(mc3(2:2).eq.'C')mag3=0.0
            if(mc3(2:2).eq.'C')mc3(2:2)=' '
            k=1
          endif
         endif
        endif
        if(text(80:80).eq.'E')
     *    read(text(1:80),'(23X,F7.3,1X,F7.3,F5.1,3E12.4)')
     *    ery,erx,erz,cvxy,cvxz,cvyz
        if(text(2:15).eq.'Ellipse_as_IDC')
     *    read(text(1:80),'(16x,2(f6.1,1x),i3)')smajor,sminor,az
c statistics for MW
        if(text(80:80).eq.'3'.and.text(7:11).ne.'AVERA'.and.
     *  text(72:73).eq.'MW')then
          read(text(75:78),'(f4.1)')mw
          if(mc1(2:2).eq.'W')mag=mag1
          if(mc2(2:2).eq.'W')mag=mag2
          if(mc3(2:2).eq.'W')mag=mag3
          nmw=nmw+1
          smw=smw+(mw-mag)**2
        endif
c get stations with MD
        if(text(80:80).eq.'3'.and.text(2:2).eq.'$')then
          nmsta=nmsta+1
          msta(nmsta)=text(3:13)
          read(msta(nmsta)(9:11),'(f3.1)')x1
          smsta=smsta+x1
        endif
c
c NOTE:
c get standard deviation of IPRG magnitude and number of stations
c used to get it, this in case that s-file was obtained/converted
c from iprg format to nordic (using isrnor), IF NOT  ermag3 and nsm4 
c are obtained later when converting the arrivals.(see ARRIVAL LINES)
c
        if(text(1:5).eq.' O.T.')then
         do i=20,60
          if(text(i:i+3).eq.'ML =')
     *     read(text(i+5:i+19),'(f3.1,4x,f3.1,3x,i2)')mag4,ermag3,nsm4
         enddo
        endif
c sign where arrival lines start (appended on March 18,1997) m.v.
        if(text(1:5).eq.' STAT')npcard=ncard+1
c get number of amplitudes and stand dev of MLs
        if(mc1(2:2).eq.'L')mag=mag1
        if(mc2(2:2).eq.'L')mag=mag2
        if(mc3(2:2).eq.'L')mag=mag3
        if(npcard.gt.0.and.text(34:40).ne.'       '.and.
     *  text(34:40).ne.' AMPLIT')then
          read(text(1:80),'(33x,g8.1,f4.1,25x,f5.0)')amp,per,xdist
          dist=xdist
          hdist=sqrt(real(dist)*real(dist)+dep*dep)
          if(amp.gt.0.0.and.per.lt.5.0)then
            if(text(11:11).ne.'P')then
              namp=namp+1
              smag=smag+(a*alog10(amp)+b*alog10(hdist)+c*hdist+d-mag)**2
            else
              nbamp=nbamp+1
              hdist=real(dist)/111.2  ! hdist is distance in deg
              call mb_att(dep,hdist,q)
              sbmag=sbmag+alog10(amp/per)+q
              amp=0.0
            endif
          endif
        endif
c region
        if(text(1:2).eq.' *')then
          do i=3,80
           if(text(i:i).eq.'*')then
              region(1:)=text(4:i-2)
              call sei upc(region)
              goto 39
           endif
          enddo
        endif
c copy the f-file
39      printout(ncard)(1:80)=text(1:80)
        goto 35
c
c arrange magnitudes
c
40      continue
        if(mc1(2:2).ne.' ')mc1(1:1)='M'
        if(mc2(2:2).ne.' ')mc2(1:1)='M'
        if(mc3(2:2).ne.' ')mc3(1:1)='M'
        if(mag4.gt.0.0)mc4(1:2)='MD'
c
c  get ellipse dimensions
c  
c
c NOW commented out to implement the new NDC ellipse calculation IDCwise...
c  M.V. April 18, 1999.
c       call xy_ellipse(ery,erx,erz,cvxy,cvxz,cvyz,smajor,sminor,x)
c       az=x
c       if(az.lt.0)az=az+360
c
c
        npha=npha+nsta
c
c writes date in "fecha" variable and fill blanks with zeros
c
        write(fecha(1:21),'(i4,2(a1,i2),1x,i2,a1,i2,a1,f4.1)')
     *   year,'/',mo,'/',dy,hr,':',mn,':',sec
        do i=1,21
          if(fecha(i:i).eq.' ')fecha(i:i)='0'
        enddo
        fecha(11:11)=' '
c
c   prepares the event id line in GSE2.0 format
c
        numero(1:8)=' '
        write(numero(1:8),'(i8)')number
        do i=1,8
          if(numero(i:i).eq.' ')numero(i:i)='0'
        enddo
c EVENT ID LINE       !!start writing here
        write(2,'(a5,1x,a8)')'EVENT',numero(1:8)
c
c next line goes out after ~seismo/WOR/EXPERIMENTS/REPORTED_to_IDC/idc.mail
c       write(4,'(a5,1x,a8)')'EVENT',numero(1:8)
c HEADER EVENT LINES
        write(2,150)
        write(2,200)
        if(n.eq.0)write(4,150)
        if(n.eq.0)write(4,200)
c BLANK LINE
        write(2,*)' '
        write(4,*)' '
c ORIGIN LINE 1
        if(nmsta.gt.0)then
        mc4='MD'
        nsm4=nmsta
        mag4=smsta/float(nmsta)
        smsta=0.0
           do k=1,nmsta
             read(msta(nmsta)(9:11),'(f3.1)')x1
             smsta=smsta+(x1-mag4)**2
           enddo
        ermag3=sqrt(smsta/nmsta)
        endif
        if(fixd.eq.'F')fixd='f'
        write(text(1:122),250)fecha(1:21),lat,lon,dep,fixd,
     *  npha,nsta,gap,mc4,mag4,nsm4,numero
        if(mc1.ne.' ')write(text(72:77),'(a2,f4.1)')mc1,mag1
        if(mc1(2:2).eq.'L')write(text(79:80),'(i2)')namp
        if(mc1(2:2).eq.'B')write(text(79:80),'(i2)')nbamp
        if(mc2.ne.' ')write(text(83:88),'(a2,f4.1)')mc2,mag2
        if(mc2(2:2).eq.'L')write(text(90:91),'(i2)')namp
        if(mc2(2:2).eq.'B')write(text(90:91),'(i2)')nbamp
        if(mc3(2:2).ne.' '.and.mc2(2:2).eq.' ')then
         write(text(83:88),'(a2,f4.1)')mc3,mag3
         if(mc3(2:2).eq.'L')write(text(90:91),'(i2)')namp
         if(mc3(2:2).eq.'B')write(text(90:91),'(i2)')nbamp
        endif
c shifts MD to 1st or second position depending on its existence
c if MD is 0.0, only cleans the place
        if(text(96:99).eq.' 0.0')then
          text(94:102)='         '
        else
          if(text(72:73).eq.'  ')then
             text(72:80)=text(94:102)
             text(94:102)='         '
          else
             if(text(83:91).eq.'  ')then
               text(83:91)=text(94:102)
               text(94:102)='         '
             endif
          endif
        endif
        write(2,'(a)')text(1:122)
        write(4,'(a)')text(1:122)
c ORIGIN LINE 2
        radius = cos(lat)**2/equrad**2
        radius = (radius +sin(lat)**2/polrad**2)**(-.5)
        dmin = real(dmin)/(radius*rad)
        dmax = real(dmax)/(radius*rad)
        evex='se'
        if(id.eq.' '.and.mag4.gt.2.5)evex='ke'
        if(id.eq.'E')evex='km'
        if(id.eq.'P')evex='sm'
        write(text(1:110),300)rms,pl,timerr,smajor,sminor,az,pl,erd,
     *  dmin,dmax,pl,ermag1,pl,ermag2,pl,ermag3,'m i',evex
        write(text(75:77),'(a3)')'0.0'
        write(text(86:88),'(a3)')'0.0'
        if(mc1(2:2).eq.'L'.and.namp.gt.1)
     *  write(text(75:77),'(f3.1)')sqrt(smag/namp)
        if(mc1(2:2).eq.'B'.and.nbamp.gt.1)
     *  write(text(75:77),'(f3.1)')sqrt(sbmag/nbamp)
        if(mc1(2:2).eq.'W'.and.nmw.gt.1)
     *  write(text(75:77),'(f3.1)')sqrt(smw/nmw)
        if(mc2(2:2).eq.'L'.and.amp.gt.1)
     *  write(text(86:88),'(f3.1)')sqrt(smag/namp)
        if(mc2(2:2).eq.'B'.and.nbamp.gt.1)
     *  write(text(86:88),'(f3.1)')sqrt(sbmag/nbamp)
        if(mc2(2:2).eq.'W'.and.nmw.gt.1)
     *  write(text(86:88),'(f3.1)')sqrt(smw/nmw)
        if(mc3(2:2).eq.'L'.and.amp.gt.1.and.mag3.gt.0.0.and.
     *  mc2(2:2).eq.' ')write(text(86:88),'(f3.1)')sqrt(smag/namp)
        if(mc3(2:2).eq.'B'.and.nbamp.gt.1.and.mag3.gt.0.0.and.
     *  mc2(2:2).eq.' ')write(text(86:88),'(f3.1)')sqrt(sbmag/nbamp)
        if(mc3(2:2).eq.'W'.and.nmw.gt.1.and.mag3.gt.0.0.and.
     *  mc2(2:2).eq.' ')write(text(86:88),'(f3.1)')sqrt(smw/nmw)
        if(mag1.eq.0.0)write(text(73:77),'(a5)')'     '
        if(mag2.eq.0.0)write(text(84:88),'(a5)')'     '
c shifts MD errors to 1st or second position depending on its existence
c if MD is 0.0, only cleans the place
        if(nsm4.eq.0)then
          text(95:99)='     '
        else
          if(text(73:77).eq.'     ')then
             text(73:77)=text(95:99)
             text(95:99)='     '
          else
             if(text(84:88).eq.'     ')then
               text(84:88)=text(95:99)
               text(95:99)='     '
             endif
          endif
        endif
        write(2,'(a)')text(1:110)
        write(4,'(a)')text(1:110)
c BLANK LINE
        write(2,*)'                              '
        write(4,*)'                              '
c REGION LINE (if)
        if(region(1:5).ne.'     ')write(2,'(a)')region
c HEADER ARRIVAL LINE
        if(ncard-npcard.gt.0)then
        write(2,220)
        if (n.eq.0)write(3,220)
c ARRIVAL LINES
         do i=npcard,ncard
           amp=0.0
           mag=0.0
           def='   '
           mc(1:2)='  '
           read(printout(i)(2:80),1201)sta,ph,cd,hr,mn,sec,amp,
     *     per,azph,velo,snr,k,tres,xdist,az
           raz=real(k)
           if(printout(i)(15:15).ne.'4'.and.printout(i)(11:11).ne.' '.
     *     and.printout(i)(11:11).ne.'T')def(1:1)='T'
           am=' '
           if(printout(i)(16:16).eq.'A')am='a'
           if(printout(i)(16:16).eq.' ')am='m'
           if(cd.eq.'C')cd='c'
           if(cd.eq.'D')cd='d'
           hdist=sqrt(real(dist)*real(dist)+dep*dep)
           if(amp.gt.0.0.and.per.lt.5.0)then
            mag=a*alog10(amp)+b*alog10(hdist)+c*hdist+d
            mc='ML'
            if(ph(1:1).eq.'P')then
               hdist=real(dist)/(radius*rad) ! hdist is distance in deg
               call mb_att(dep,hdist,q)
               mag=alog10(amp/per)+q
               mc='Mb'
            endif
           endif
           write(fecha(12:21),'(2(i2,a1),f4.1)')hr,':',mn,':',sec
           do k=12,21
             if(fecha(k:k).eq.' ')fecha(k:k)='0'
           enddo
           mc4='  '
           if(nmsta.gt.0)then
             do k=1,nmsta
               if(sta(1:4).eq.msta(k)(1:4))then
                  read(msta(k)(9:11),'(f3.1)')mag4
                  mc4='MD'
               endif
             enddo
           endif
           write(numero(1:8),'(i8)')phnumber
           do k=1,8
             if(numero(k:k).eq.' ')numero(k:k)='0'
           enddo
c easy convertion from km to deg...not so accurate.
           x3 = real(dist)/(radius*rad)
           write(text(1:132),140)sta,x3,real(az),am,
     *     cd,ph,fecha,tres,azph,raz,velo,def(1:3),snr,amp,per,mc,
     *     mag,mc4,mag4,numero
           if(text(24:24).eq.' ')text(54:58)='     '
           if(text(100:109).eq.' 0.0  0.00')text(100:109)='          '
           if(text(113:116).eq.' 0.0')text(113:116)='    '
           if(text(118:119).eq.'  ')text(120:123)='    '
           if(azph.eq.0.0)text(60:64)='     '
           if(azph.gt.0.0)text(86:86)='A'
           if(velo.eq.0.0)text(73:77)='     '
           if(velo.gt.0.0)text(87:87)='S'
           if(snr.eq.0.0)text(89:93)='     '
           if(raz.eq.0.0)text(66:71)='      '
           write(2,'(a)')text(1:132)
           write(3,'(a)')text(1:132)
           phnumber=phnumber+1
         enddo
        endif
c BLANK LINE
        write(2,*)'                              '
c write in nordic format also file 'norgse.nor'
c       write(8,'(a80)')(printout(i)(1:80),i=701*flines,ncard+1)
        n=n+1
        number=number+1
      goto 10
c   end of BIG LOOP
c
c   HERE STARTS IF CONVERTING FROM GSE2.0 TO NORDIC
50    open(2,file='norgse.nor',status='unknown')
      n=0  !number of events
      ncards=i
      ncard=0
      kstop=0
c
c   GSE2.0 ----> NORDIC    BIG LOOP STARTS HERE
c
c     NEW EVENT
c
c the variables printout(1*flines)-->printout(350*flines)
c are reserved for lines above the nordic line type 7 (also included
c and printout(351*flines)-->printout(999*flines) for arrival lines
c
c
      write(printout(1000*flines)(1:80),'(a,a)')
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU ',
c     *'VELO SNR AR TRES W  DIS CAZ7'
     *'VELO AIN AR TRES W  DIS CAZ7'
60    continue
      karr=350*flines   !the arrival's counter
      j=0               !the header's counter
      jarr=1            !defines if input is short or long input file
      dmax=0.0
      dmin=15000.00
      mag1=0.0
      mag2=0.0
      mag3=0.0
      mc1(1:2)='  '
      mc2(1:2)='  '
      mc3(1:2)='  '
      nsta=0
      if(jarr.eq.0)write(2,'(a80)')printout(1000*flines)(1:80)
      if(jarr.eq.0)write(2,'(a80)')'    '       !case of short input
65    continue
        read(1,'(a)',end=99)text
        if(text(1:4).eq.'STOP')then
          if(n.eq.0)then
            write(6,*)'No events were found in input file !!!'
68          write(6,*)'Error, Check event # ',n
          endif
          goto 99
        endif
c
c Identifies that there is an event, creates location line 
c of nordic format and ID line
c
        if(text(1:5).eq.'EVENT')n=n+1
        if(text(8:21).eq.'rms   OT_Error')then     !LONG IG starts here
c allows more than 1 blank line after header (german gse reports case)
c Aug 19, 1997....m.v.
69       read(1,'(a)',end=99)text     !reads blank lines
         if(text(5:5).ne.'/')goto 69
         backspace(1)
c read first header line
         read(1,255,end=99,err=68)year,mo,dy,hr,mn,sec,
     *   lat,lon,dep,fixd,npha,nsta,gap,mc1,mag1,
     *   nsm1,mc2,mag2,nsm2,mc3,mag3,nsm3,lage,numero
         do i=1,3
         if(lage(i:i).eq.' '.or.lage(i:i).eq.'_')lage(i:i)='X'
         enddo
         if(lage(1:3).eq.'XRE')lage(1:3)='REB'
         if(fixd.eq.'f')fixd='F'
         if(mc1(2:2).eq.'b')mc1(2:2)='B'
         if(mc2(2:2).eq.'b')mc2(2:2)='B'
         if(mc3(2:2).eq.'b')mc3(2:2)='B'
         if(mc1(2:2).eq.'s')mc1(2:2)='S'
         if(mc2(2:2).eq.'s')mc2(2:2)='S'
         if(mc3(2:2).eq.'s')mc3(2:2)='S'
c this line only for Israel
c        if(lage(1:3).ne.'IDC'.and.lage(1:3).ne.'REB')lage(1:3)='ISN'
c read second header line
70       read(1,'(a)',end=99)text     !reads blank lines
         if(text(14:15).ne.'+-')goto 70
         backspace(1)
         read(1,300,end=99,err=68)rms,r1,timerr,smajor,sminor,az,r2,
     *   erd,x1,x2,r3,ermag1,r4,ermag2,r5,ermag3,text(1:3),evex
c line type 1
         write(printout(j+1),100)year,mo,dy,hr,mn,sec,' ','R',' ',lat,
     *   lon,dep,fixd,lage,nsta,rms,mag1,mc1(2:2),'   ',mag2,
     *   mc2(2:2),'   ',mag3,mc3(2:2),'   ','1'
         printout(j+1)(80:80)=' '   !to avoid strange things
         if(evex.eq.'km')printout(j+1)(23:23)='E'
         if(evex.eq.'sm')printout(j+1)(23:23)='P'
         do i=7,18
          if(printout(j+1)(i:i).eq.' ')printout(j+1)(i:i)='0'
         enddo
         printout(j+1)(11:11)=' '
         printout(j+1)(16:16)=' '
         if(mag1.gt.0.0)printout(j+1)(61:63)=lage(1:3)
         if(mag1.eq.0.0)printout(j+1)(57:60)='    '
         if(mag2.gt.0.0)printout(j+1)(69:71)=lage(1:3)
         if(mag2.eq.0.0)printout(j+1)(65:68)='    '
         if(mag3.gt.0.0)printout(j+1)(77:79)=lage(1:3)
         if(mag3.eq.0.0)printout(j+1)(73:76)='    '
c special next 3 lines for Israel. Does not affect other agencies !!
         if(mc1(2:2).eq.'L'.and.lage.eq.'ISN'.and.
     *   mag1.gt.0.0)printout(j+1)(60:60)='C'
         if(mc2(2:2).eq.'L'.and.lage.eq.'ISN'.and.
     *   mag2.gt.0.0)printout(j+1)(68:68)='C'
         if(mc3(2:2).eq.'L'.and.lage.eq.'ISN'.and.
     *   mag3.gt.0.0)printout(j+1)(76:76)='C'
c line type I
c        write(6,*)printout(j+1)
         write(printout(j+2)(1:80),'(a12,a11,1x,a2,a34,i4,5i2,a6)')
     *   ' ACTION:REG ',ttext(10:20),ttext(21:22),
     *   ' OP:ngse STATUS:               ID:',year,mo,dy,hr,mn,
     *   int(sec),'     I'
         printout(j+2)(15:15)='-'
         printout(j+2)(18:18)='-'
         printout(j+2)(21:21)=' '
         printout(j+2)(24:24)=':'
         do i=61,74
           if(printout(j+2)(i:i).eq.' ')printout(j+2)(i:i)='0'
         enddo
c This line to keep some extra information from IDC that nordic
c format does not have specific fields...ellipse and qk ID
         if(mc1(2:2).eq.'B'.and.mag1.gt.0.0)x3=ermag1
         if(mc2(2:2).eq.'B'.and.mag2.gt.0.0)x3=ermag2
         if(mc3(2:2).eq.'B'.and.mag3.gt.0.0)x3=ermag3
         write(printout(j+3),'(1x,a13,2(f6.1,1x),i3,a9,f5.1,12x,
     *   a9,a8,5x,a1)')'IDC: ellipse ',smajor,sminor,az,' MB sd+- ',
     *   x3,'Event ID ',numero,'3'
         if(printout(1)(60:60).ne.'B'.and.printout(1)(68:68).ne.'B'.
     *   and.printout(1)(76:76).ne.'B')printout(j+3)(41:45)='     '
         j=j+3
c in case region is specified adds one line type 3
         reg=0
73       read(1,'(a)',end=99)text     !  reads blank lines
         if(text(1:7).eq.'Sta    ')then
           jarr=0
           goto 80
         else 
           if(text(1:7).eq.'       ')goto 73
           j=j+1
           write(printout(j),'(1x,a2,a50,a3,23x,a1)')
     *     '* ',text(1:50),'***','3'
           reg=1
           goto 73
         endif
c ARRIVALS
80       read(1,'(a)',end=99)text
         if(text.eq.'          ')then
81         read(1,'(a)',end=99)text
           if(text(1:4).ne.'    '.and.text(1:5).ne.'EVENT'.
     *     and.text(1:4).ne.'STOP')goto 85
           if(text(1:4).eq.'    ')goto 81
           backspace(1)
           if(text(1:4).eq.'STOP')kstop=1
c
c          if(mag1.eq.0.and.mag2.eq.0.and.mag3.eq.0.and.dep.le.1.0.
c    *     and.dmin.lt.1.0.and.dmax.lt.1.5)printout(j+1)(23:23)='P'
c          if(dmax.lt.9.0.and.dmax.gt.5.5.and.
c    *     dmin.gt.1.0)printout(j+1)(22:22)='R'
c          if(dmax.gt.9.0.and.dmin.gt.5.0)printout(j+1)(22:22)='D'
c
           printout(1)(80:80)='1'
82         write(2,'(1x,a79)')(printout(i)(2:80),i=1,j)
           write(2,'(a80)')printout(1000*flines)(1:80)
           write(2,'(1x,a79)')(printout(i)(2:80),i=350*flines+1,karr)
           write(2,'(a80)')'    '
           goto 60
         endif
85       karr=karr+1
         read(text,140)sta,x1,x2,am,cd,ph,fecha,tres,azph,raz,velo,
     *   def,snr,amp,per,mc,mag,mc4,mag4,i
         if(x1.lt.dmin)dmin=x1
         if(x1.gt.dmax)dmax=x1
         if(mag4.gt.0.0)then
          j=j+1
          write(printout(j)(1:80),'(1x,a1,a4,1x,a2,1x,f3.1,66x,a1)')
     *    '$',sta,'MD',mag4,'3'
         endif
         if(cd.ne.' ')call sei upc(cd)
c        if(ph.ne.'  ')call sei upc(ph)
c        ph(2:2)=' '    !not sure about n and g phases
         read(fecha(12:21),'(2(i2,1x),f4.1)')hr,mn,sec
         write(ttext(1:6),'(f6.1)')raz  !approximate az residual
         read(ttext(6:6),'(i1)')k
         if(k.ge.5)raz=raz+1.0
         radius = cos(lat)**2/equrad**2
         radius = (radius +sin(lat)**2/polrad**2)**(-.5)
         radius = radius*x1*rad
         if(velo.gt.999.9)velo=999.9
         if(amp.lt.99.)then !  Stupid compiler 
          write(printout(karr)(2:80),120)sta,ph,cd,hr,mn,sec,
     *    amp,per,azph,velo,snr,int(raz),tres,int(radius),int(x2)
         else
          write(printout(karr)(2:80),122)sta,ph,cd,hr,mn,sec,
     *    amp,per,azph,velo,snr,int(raz),tres,int(radius),int(x2)
         endif
         if(amp.eq.0.0)printout(karr)(34:45)='             '
         if(azph.eq.0.0)printout(karr)(46:51)='      '
         if(velo.eq.0.0)printout(karr)(52:56)='     '
         if(snr.gt.99.9)write(printout(karr)(57:60),'(f4.0)')snr
         if(snr.gt.999.9)printout(karr)(57:60)='999.'
         if(snr.eq.0.0)printout(karr)(57:60)='    '
         if(raz.eq.0.0)printout(karr)(61:63)='   '
         if(raz.lt.-99.9)printout(karr)(61:63)='-99'
         if(tres.lt.-99.9.or.tres.gt.999.9)
     *   write(printout(karr)(64:68),'(f5.0)')tres
         if(def(1:1).eq.' ')write(printout(karr)(15:15),'(a1)')'4'
         if(am.eq.'a')write(printout(karr)(16:16),'(a1)')am
c        printout(karr)(7:8)='SZ'
         if(printout(karr)(19:19).eq.' ')printout(karr)(19:19)='0'
         if(printout(karr)(21:21).eq.' ')printout(karr)(21:21)='0'
         if(printout(karr)(24:24).eq.' ')printout(karr)(24:24)='0'
         goto 80
        endif      !LONG IF ends here
      goto 65
c
c   FORMATS   !!!!!
c
 100    format(1x,i4,2(1x,2i2),1x,f4.1,3a1,f7.3,f8.3,f5.1,a1,1x,a3,
     *  i3,f4.1,3(1x,f3.1,a1,a3),a1)
 120    format(a4,5x,a4,2x,a1,1x,2i2,1x,f5.2,5x,g8.2,f4.1,f6.1,f5.1,
     *  f4.1,i3,f5.1,2x,i5,1x,i3,1x)

 1201   format(a4,5x,a4,2x,a1,1x,2i2,1x,f5.2,5x,g8.2,f4.1,f6.1,f5.1,
     *  f4.1,i3,f5.1,2x,f5.0,1x,i3,1x)

 122    format(a4,5x,a4,2x,a1,1x,2i2,1x,f5.2,5x,g8.1,f4.1,f6.1,f5.1,
     *  f4.1,i3,f5.1,2x,i5,1x,i3,1x)
 140    format(a4,2x,f6.2,f6.1,1x,2a1,2x,a4,4x,a21,1x,f5.1,1x,f5.1,
     *  1x,2f6.1,7x,a3,f6.1,1x,f9.1,1x,f5.2,2(1x,a2,f4.1),1x,a8)
 150    format(3x,'Date',7x,'Time',7x,'Latitude',1x,'Longitude',4x,
     *  'Depth',4x,'Ndef',1x,'Nsta',1x,'Gap',4x,'Mag1',2x,'N',4x,
     *  'Mag2',2x,'N',4x,'Mag3',2x,'N',2x,'Author',10x,'ID')
 200    format(7x,'rms',3x,'OT_Error',6x,'Smajor',1x,'Sminor',1x,
     *  'Az',8x,'Err',3x,'mdist',2x,'Mdist',5x,'Err',8x,'Err',8x,
     *  'Err',5x,'Quality')
 220    format('Sta',5x,'Dist  EvAz',5x,'Phase',6x,'Date',7x,
     *  'Time',5x,'TRes  Azim  AzRes  Slow  SRes Def   SNR'
     *  7x,'Amp   Per   Mag1   Mag2   Arr ID')
c write GSE2.0 format, nsta, no fixing flags for origin time and location.
 250    format(a21,4x,f8.4,1x,f9.4,4x,f5.1,1x,a1,2x,i4,1x,i4,
     *  1x,i3,2x,22x,a2,f4.1,1x,i2,2x,'        ',2x,a8)
c read the GSE2.0 format, except agency and number id
 255    format(i4,1x,4(i2,1x),f4.1,4x,f8.4,1x,f9.4,4x,f5.1,1x,a1,2x,
     *  2(i4,1x),i3,2x,3(a2,f4.1,1x,i2,2x),4x,a3,3x,a8)
 300    format(5x,f5.2,3x,a2,f6.2,4x,f6.1,1x,f6.1,2x,i3,4x,a2,
     *  f5.1,2x,f6.2,1x,f6.2,3x,2(a2,f3.1,6x),a2,f3.1,5x,a3,1x,a2)
c
c Finish the program
close files
c
 99   continue
      close(1)
      if(work.eq.2)then
c        write(2,'(a4)')'STOP'
c        backspace(4)
c        write(4,'(a4)')'STOP'
        close(4)
        close(3)
        close(7)
      else
        if(kstop.eq.0.and.n.gt.0)then
          kstop=1
          goto 82
        endif
      endif
      close(2)
      write(6,*)
      write(6,*)' The output file contains ',n,' events processed'
      stop
      end

c***********************************888888888********************************* 
C                                                                               
c	    PROGRAM SPEC  
c                                                                               
c       By  Jens Havskov  apr 1994                                                        
c                                                                               
c       Calculates spectra, relative spectra, tstar and Q
c
c
c
c  Some notes on how Q is selected and averaged, 2 station method

c  Individual Q-calculation: Q values lower than 1 and higher than 5000
c                            are not used, the Q(f) plot might then display
c                            a long straight line. The Q=Q0*f**qalpha
c                            is calcualated from the 'good' values'.

c  Average Q of last plot:   The linear 1/Q values are averaged, 
c                            standard deviation
c                            is calcualted on the 1/Q average and 
c                            1/Q +/- standard
c                            deviation calcualated. From this, Q +/- sd is 
c                            calculated.
c                            Only the Q-values from above are used. In the 
c                            average Q 
c                            Q +/- sd, Q-values below 1 are rejected. 
c                            The Q=Q0*f**qalpha
c                           is calcualated from the 'good' values' 
c
c
c   NB:
c   variable tstar is the same as kappa, however tstar is determined and
c   kappa is input. In print out it is called kappa
c
c       Latest uppdate:                                                         
c       dec 7 94 by jh     : maxdim to max_sample
c       dec 28             : ********** version 5.0 *******************
c       feb 95             : fix
c       april              : component rotation
c       may 95 by    jh    : also make it possible to make average spectras
c                            without making relative spectras
c       may 22             : make file spec_ave.out
c       jun 2              : replace find_chan2 with findchan
C!JAB(BGS)Jun95: Removed SDV since in ../LIB/lsqlin.for
c       oct 95        jh   : new seisinc
c       mar 12 96          : new convert routine, now in picsub
c       mar 25             : check for missing response file and resp in header
c       aug 2 96           : calculate distance only in convert
c       feb 97             : fix if average spectra is zero, then no log
c       feb 24 97          : remove disp_vel from call to spec
c       feb 29             : fix bug when start time was before start of
c       nov 25             : more spectral output, interactive freq. output
c       dec    98          : calculate q
c                            waveform file, then skip trace
c       mar 2 99  jh       : -------------- version 7.0 check-------------
c                            stat to 5 , year
c       mar 10             : bug in q-calculation
C
c       mar 26 bmt         : include winplot.inc
c       may 30 jh          : power density spectrum
c       september 15       : bugs with q-option
c       may 2000 jh        : new waveform structure
c       september 15, 2000 : clear wav_resp_file before call to read_resp
c                            calculate dc for each new trace plot
c       october 24         : high accuracy, sec read wrong
c       december 14        : add peterson noise curves,more prec. spec_ave.out
c       december 20        : calculate t*
c       jan                : small bug, fix routine spec_select so do not
c                            need mulplt.inc
c       jan 30             : new parmeters mincor, maxsn, kappa
c       may 28             : correct power spectrum, small fixes
c       jun 21             : small text changes, t* to kappa
c       sep 30             : possibel to run directly from waveform files
c       jan 20 2002 jh     : gmt standard output
c       feb 11             : fix q calculation
c       feb25              : more gmt fixing
c       mar 6              : remove gmt subroutine from main program
c       apr 17             : multiple windows in same trace, parmeter n_window_total
c       may 8 2002 jh      : sd was calculated wrong in gmt output for q
c       may 27             : small bug in output of number of windows
c       jan 6, 2003        : overlap of wndows possible, add parameter w_overlap to n_window
c       feb 5         jh   : bug in multiple windows, multiple files
c       june 11            : change in file question
c       june 20 2004  jh   : plt to eps
c       november 17 06 jh  : when calculating Q, the correction for geometrical
c                            spreading had the wrong sign adding the correction
c                            instead of subtractin. thsi resulted in too low
c                            Q-values
c
c
c      implicit none         !   comment for pc
      include 'winplot1.inc'!   windows graphics
      include 'mulplt.inc'  ! mulplt variables
      include 'seiplot.inc' ! general plotting variables
      include 'gmt_xy_par.inc' ! for gmt input file
c
c  parameters
c
      real          av               ! average
      integer       nspectra         ! number of specras to store
      integer       nspec_points     ! number of points in each spectrum
      parameter (nspectra=100)
      parameter (nspec_points=30000)
      real out_amp(10), out_f(10)    ! specific output values
      real out_ff(10)                ! spectral frequencies selected
c
      logical       clipped          ! true if signal clipped
      character*4   component(2 )    ! component to use                                                    
      character*4   old_comp(2)      ! component read in
      real          cx(1),cy(1  )    ! return from spectra plot, not used
      character*1   c_spec(1)        ! return from spectral plot, not used
      character*80  question  ! question for one_line
      real          dist_cor  ! distance correction exponent
      character*1   exp       ! explosion indicator
      real          factor    ! correction factor for spectrum
      real          flag(5)   ! flags to be plotted e.g. origin time
      logical       first_run ! indicator of first run with one station
      logical	    power     ! acceleration power density spectrum
      logical       pc,linux,sun
      real          gain_chan1 ! factor multiplied by channel 1
      real          ttime1, ttime2     ! travel time for the 2 traces
      integer       i,ierr,nstart,j
      real          ff
      character*80  infile           ! wav input file
      integer       ievent           ! number of events for one station pairs
      integer       itstar           ! count good tstar events
      integer       k,l,ichan,kk,kkk ! help variables
      integer       make_noise_spec  ! make noise spectra(1=y,0=n)
      integer       make_rel_spec    ! make relative spectra
      integer       mag_spec         ! indicator if magnitude spectrum
c                                    ! 1: moment, 2: moment  magnitude
      real          mincor           ! minumum correlation coef. t*
      real          minsn            ! minimum signal to noise ratio, t*
      character*80  name             ! Sfile name
      integer       nset             ! number of data sets to plot
      integer       n_stat           ! numbr of stations to process, 1 or 2
      integer       npoint_set(nspectra)    ! number of points pr data set    
      integer	    ngmt_all         ! total number for traces for gmt plot
      integer nsmooth                ! number of times smoothed
      integer       nc               ! number of chars return in cx and cy
      integer       nflag            ! number of flags to be plotted
      integer       nspec            ! number of points in plot
      integer       nsamp,nsignal    ! number of samples
      integer nstat,nphase           ! see indata routine
      integer	    n_window         ! count windows used in same trace
      integer       n_window_total   ! total number of windows in one trace
      real          w_overlap	     ! amount of overlap, 1.0: no overlap, 1.3: 30% gap, 0.8: 20 % overlap	
      character*80  out_txt(30)      ! text to graphics screen
      integer       old_poption      ! save plot option
      integer       plot_pics        ! plot pics
      real          rel_spec(nspectra,nspec_points) ! relative spectras
      real          sd               ! standard deviation
      integer       sel_crit  ! seletion criteria for start time of window
      logical       sn_ok            ! indicate if sn is ok
      integer do_rotate              ! rotation or not (1 or 0)
      real          start            ! start of window in time or # of times
      character*5   station(2)       ! station to use
      character*18  main_time ! time in waveform file main header
      real          t0               ! origin time
      real          tstart           ! start of window in secs after orig. time
      character*1   type             ! event type
      character*80  text             ! help text
      real          qq0, qqalpha     ! calculate q and qalpha
      real          corr,rms         ! correlation and rmd for qq0 and qqalpha
      character*80  title            ! part of title
      character*30  xtext,ytext      ! x and y-axis text
      character*80  err_text         ! error text
      logical       wav_list         ! if true, input from waveform file name
      real          wlen             ! window length to analyse      
      real          x0,y0            ! plot lower left hand cornor
      real          x_length         ! lenght of x_axis for spectral plot
      real          x_work(max_sample)
      real          xx_work(nspec_points) ! work array
      real	    yy_work(nspec_points) ! work array
      real          x_size           ! size in tek units of x-axis spec plot
      real          y_size           ! size in tek units of y-axis spec plot
      real          start_org        ! save start time
      real          tstar(nspectra)  ! t* values
      logical       t_star           ! if true, calcualte t*
      logical       xlin             ! if true, linear x-axis
      real          aa,bb            ! help variables
      real          y_work(nspectra*nspec_points)
      integer       key              ! key return
      real          xx,yy            ! -- position
      character*19  wtext            ! part of output file name
      integer       nwtext           ! number of characters in
c
c   peterson noise curves
c
      real low_f(22),high_f(14),low_l(22),high_l(14) ! petersen noise
      data high_f/   1.000000,    6.575773E-01,    4.948500E-01,
     *           9.691001E-02,   -5.797836E-01,   -6.627579E-01,
     *           -7.993407E-01,  -8.976271E-01,   -1.187521,
     *           -1.301030,       -2.549984,       -4.000000,
     *            -4.477121, -5.0/
      data high_l/ -91.5,-97.4,-110.5,-120.0,-97.9,-96.5,-101.0,
     *             -113.5,-120.0,-138.5,-126.0,-80.1,-65.0,-48.5/ 

      data low_f/    1.000000,    7.695511E-01,    3.979400E-01,
     *             9.691001E-02, -9.342168E-02,   -3.802112E-01,
     *            -6.334685E-01,  -6.989700E-01,  -7.781512E-01,
     *             -1.000000,       -1.079181,       -1.193125,
     *              -1.340444, -1.50, -1.65, -1.89, -2.0,
     *              -2.19,-2.51,-2.78,-4.0,-5.0/
      data low_l/   -168.0,-166.7,-166.7,-169.2,-163.7,-148.6,
     *              -141.1,-141.1,-149.0,-163.8,-166.2,-162.1,
     *              -177.5,-185.0,-187.5,-187.5,-185.0,-184.9,
     *              -187.5,-184.4,-151.9,-103.1/ 

      data out_f/0.125,0.25,0.50,1.0,2.0,4.0,6.0,8.0,10.0,16.0/
c
c   scaling values from xy_plot
c
      real xfirst,yfirst,xscale1,yscale1,ymin,ymax,xmin,xmax
      common/xy_plot_common/xfirst,yfirst,xscale1,yscale1,ymin,
     *                       ymax,xmin,xmax
c
      equivalence(x_work,com)
      include 'version.inc'
      include 'winplot2.inc'      
c
      call computer_type(sun,pc,linux)                                               

c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c                                                                                
c                                                                               
c--- set plotter to postscript                                                     
      hctype=1                                                                
c---unit for plot file
      plotunit=65
c---plot resolution
      resolu=3000
c---initial xwindow size in % horizontal full size
      wsize= 60
c---display not yet open
      disp_open=0
      first_run=.true.
      n_window_total=1    ! normally only one window
c
c   get seisan defaults
c
      call get_seisan_def
      itstar=0
      ngmt_all=0
c
c
      t_star=.false.       ! do not calculate t*
      xlin=.false.         ! normally log x-axis

      call gmt_xy_init     ! set default gmt parameters

      xtext=' Frequency (Hz)              '
      ytext=' Log amplitude               '
c
c   interactive input
c                                                                               
      write(6,*)' Only final plot on screen   (0) '                            
      write(6,*)' Plot all on screen          (1) '                            
      write(6,*)' Plot all on screen+laser    (2) '                            
      write(6,*)' Plot all on laser           (3) '                            
      write(6,*)' Only final plot on laser    (4) '                            
      read(5,*) plotoption                                                     
      plotoption=plotoption-1                                                  
c
c   open output file with summary results
c
       open(3,file='spec.out',status='unknown')
c
c   file with all gmt  spectra
c
       open(18,file='spec.scratch',status='unknown')
c
c   get inputs
c
 4847  continue
       write(6,*)'Parameter file, spec.par is default (return)'                
       read (*,'(a)') name                                                    
       if(name(1:2).eq.'  ') name='spec.par'                                  
C                                                                               
c   open parameter filer giving specs for processing                           
C                                                                               
      open(1,file=name,status='old', err=4848)
      goto 4849
 4848 continue
      write(6,*)' No such file'
      goto 4847
 4849 continue
c                                                                               
c   read parameters shared by all data sets                                     
c   each data line is separated by a comment line read by text                
c                                                                               
        read(1,'(a)') text
        read(1,*,err=4850) sel_crit
        write(3,'(1x,a59,i10)') text(1:59),sel_crit
        read(1,'(a)') text
        read(1,*,err=4850) start
        start_org=start
        write(3,'(1x,a59,f10.2)') text(1:59),start
        read(1,'(a)') text
        read(1,*,err=4850) wlen,n_window_total,w_overlap
        write(3,'(1x,a59,f6.1,i6,f6.2)') 
     *  text(1:59),wlen,n_window_total,w_overlap
        read(1,'(a)') text
        read(1,*,err=4850) nsmooth
        write(3,'(1x,a59,i10)') text(1:59),nsmooth
        read(1,'(a)') text
        read(1,*,err=4850) gain_chan1 
        write(3,'(1x,a59,f10.3)') text(1:59),gain_chan1
        read(1,'(a)') text
        read(1,*,err=4850) make_noise_spec
        write(3,'(1x,a59,i10)') text(1:59),make_noise_spec
        read(1,'(a)') text
        read(1,*,err=4850) make_rel_spec
        write(3,'(1x,a59,i10)') text(1:59),make_rel_spec
        read(1,'(a)') text
        read(1,*,err=4850) plot_pics
        write(3,'(1x,a59,i10)') text(1:59),plot_pics
        read(1,'(a)') text
        read(1,*,err=4850) ffmin,ffmax
        write(3,'(1x,a59,2f10.2)') text(1:59),ffmin,ffmax
        read(1,'(a)') text
        read(1,*,err=4850) remove_response
        write(3,'(1x,a59,i10)') text(1:59),remove_response
        read(1,'(a)') text
        read(1,*,err=4850) do_rotate
        write(3,'(1x,a59,i10)') text(1:59),do_rotate
        read(1,'(a)') text
        read(1,*,err=4850) q0,qalpha,kappa
        write(3,'(1x,a59,3f10.2)') text(1:59),q0,qalpha,kappa
        read(1,'(a)') text
        read(1,*,err=4850) dist_cor
        write(3,'(1x,a59,1f10.2)') text(1:59),dist_cor
        read(1,'(a)') text
        read(1,*,err=4850) mincor,minsn
        write(3,'(1x,a59,2f10.2)') text(1:59),mincor,minsn
        minsn=alog10(minsn)
        read(1,'(a)') text
        read(1,*,err=4850) svelocity,density
        write(3,'(1x,a59,2f10.2)') text(1:59),svelocity,density
        read(1,'(a)') text
        read(1,*,err=4850) mag_spec
        write(3,'(1x,a59,i10)') text(1:59),mag_spec
        read(1,'(a)') text
        goto 4851
 4850   continue
        write(6,*)' Error in parameter file for parameter line:'
        write(6,'(1x,a)') text
        write(6,*)' Return to stop'
        read(5,'(a)')i
        stop
 4851   continue
c
c   check parameters for internal consistency
c
        if(sel_crit.eq.4.and.n_window_total.lt.1) then
           write(6,*) ' Number of windows must be selected (>0)'
           write(6,*)' Return to stop'
           read(5,'(a)')i
           stop
        endif
        if(sel_crit.eq.4.and.n_window_total.gt.1.and.w_overlap.le.0.0)
     *  then
           write(6,*) ' Overlap must be more 0, 1.0 is no overlap'
           write(6,*)' Return to stop'
           read(5,'(a)')i
           stop
        endif
        if((svelocity.ne.0.0.and.density.eq.0.0).or.
     *  (svelocity.eq.0.0.and.density.ne.0.0)) then
           write(6,*)
     *     'Give both density and velocity, or none'
           write(6,*)' Return to stop'
           read(5,'(a)')i
            stop
        endif
        if(svelocity.ne.0.0.or.mag_spec.eq.1) then
           if(svelocity.eq.0.0) then
              write(6,*)' Give velocity and density',
     *        ' for moment or magnitude'
              write(6,*)' Return to stop'
              read(5,'(a)')i
              stop
            endif
            if(dist_cor.eq.0.0) then
               write(6,*)' Give distance correction',
     *         'for moment or magnitude'
                write(6,*)' Return to stop'
                read(5,'(a)')i
               stop
            endif
            if(remove_response.ne.1) then
               write(6,*)' Response removal must be 1 ',
     *         'for moment or magnitude'
                write(6,*)' Return to stop'
                read(5,'(a)')i
                stop
            endif
         endif
         if(q0.lt.0) then
             if(dist_cor.le.0.0) then
                write(6,*)
     *    ' You must have a distance correction when determining q'
               write(6,*)' Return to stop'
               read(5,'(a)')i
               stop
              endif
         endif
c
         power=.false.
         if(remove_response.eq.4) then   ! power spectrum
            power=.true.
            remove_response=3            ! acceleration
            ytext='db'
         endif
         if(remove_response.eq.5) then
            t_star=.true.
            xlin=.true.
            remove_response=1             ! must be displacement
         endif
c
c   set rotation flag
c
         rotate=.false.
         if(do_rotate.eq.1) rotate=.true.
c
c   determine title of spectrum
c
        if(remove_response.eq.0) title(1:12)='uncorrected '
        if(remove_response.eq.1) title(1:12)='displacement'
        if(remove_response.eq.2) title(1:12)='velocity    '
        if(remove_response.eq.3) title(1:12)='acceleration'
        if(remove_response.eq.3.and.power) title(1:12)='Acc. pow. db'
        if(mag_spec.eq.1)        title(1:12)='Moment      '
        if(mag_spec.eq.2)        title(1:12)='Magnitude Mw'
c                                                                               
c   open file with list of event's, process until end of file                          
c

      write(6,'(a,a)')                                                              
     *  ' CAT File or filenr.lis type file with events, ',
     *'name spec.inp is default (return)'
c      write(6,*)'filenr.lis means input is waveform files only'         
      read(5,'(a)') name                  
c      if(name(1:10).eq.'FILENR.LIS') name='filenr.lis'

        if(name(1:2).eq.' ') name='spec.inp'                                   
        open(2,file=name,status='old')
c
c   find if a filenr.lis type
c
        wav_list=.true.
        do i=1,10
           read(2,'(2x,i3,a2)',err=2837,end=2839) k,text(1:2)
           if(text(1:2).ne.'  ') wav_list=.false.
           goto 2838
 2837      continue
           wav_list=.false.
 2838      continue
        enddo
 2839   continue
        rewind(2)

c
c   check parameter
c
      if(wav_list.and.sel_crit.ne.4) then
          write(6,*)' When choosing only waveform file input,'
          write(6,*)' parameter sel_crit mut be set to 4'
	  write(6,*)' edit your parameter file and start again'
          stop
      endif

c
        if(wav_list) write(6,*) ' Input file is list of waveform files'
c
c----------------------------------------------------------------------
c   loop for pairs of station starts here label 1
c----------------------------------------------------------------------
c
 1    continue
c
c   reset start time in case multiple windows are used with sel crit 4
c
      start=start_org
c
c   clear screen if not first run
c
     
      question(1:42)='Cont.: any char, q: quit, mouse: f and amp'
      if((plotoption.le.1).and.
     *   (.not.first_run)) then
c        call xset_color(xyellow)
         call tchars(question,42,500.0,20.0)
 111     continue
         call xscursr(key,xx,yy)
         if (char(key).eq.'#') goto 111
         if(char(key).eq.' ') then
            xx=(xx-x0)/xscale1+xfirst
            yy=(yy-y0)/yscale1+yfirst
            if(.not.power) yy=10.0**yy
            write(out_txt(1),'(a3,2f8.2)')'f,a',10.0**xx,yy
            call xmessage(out_txt,1,19,700.0,30.0)
            goto 111
         endif
         if(char(key).eq.'q'.or.char(key).eq.'Q') goto 99 !stop
      endif
c     first_run=.false.
c                                                                               
c   lines with pairs to process now follows, one pair pr line
c               
      write(3,*)
      read(1,'(a5,1x,a4,1x,a5,1x,a4)',end=99) 
     *station(1),component(1),station(2),component(2)                                    
c
c   save component in case changed by rotation
c
      old_comp(1)=component(1)
      old_comp(2)=component(2)
c
c   a blank line should also stop program
c
      if(station(1)(1:5).eq.'     ') goto 99
c
c   reset parameters
c
      rewind 2     ! start again in event file
      ievent=1     ! event counter
      n_window=1   ! windows counter ( only if option 4 for sel_crit)
c
C-----------------------------------------------------------------------
C
C   reading loop for events (can also be windows for one trace)  to process starts here *********************        
C                                                                               
c-----------------------------------------------------------------------
c
 10   continue                                                                     
c
c   reset component in case of rotation
c
      component(1)=old_comp(1)
      component(2)=old_comp(2)
C                                                                               
C   Read next event from file until eof. If option with many windows in same fiwel is used, read next
c   segment of same file instead until end of segments                                      
C                                
      if(sel_crit.eq.4.and.n_window.le.n_window_total.   ! select next segment
     *   and.n_window.ge.2) then
         start=start+wlen*w_overlap   ! move window one down
      else                                               ! select next file or event
         if(wav_list) then   ! waveform files only
            read(2,'(7x,a)',end=60) infile 
c
c   reset overlappin windows
c
            n_window=1
            start=start_org
c
            if(infile.eq.' ') goto 60      ! no more events
            call make_new_sdata(infile,data,nhead,nrecord)
         else
C                                                                               
C   Read next event from file until eof.                                      
C                                   
            call indata
     *      (2,nstat,nphase,nhead,nrecord,type,exp,data,i)
         endif
      endif

      n_window=n_window+1
c
c   for each event, one pair of stations are processed, which gives one page
c   of plot if plot is asked for. Plot must be opened every time here if
c   plots are made for each data pair.
c                                                                               
c   if hardcopy is wanted, open plot file here
c
      if(plotoption.gt.0.and.plotoption.lt.3) then                             
         open(65,file='spec.eps',status='unknown')                            
      endif                                                                    
c
c    screen plot opened
c
      if(plotoption.ge.0)  then 
c        if(plotoption.lt.2) call open_display 
         call open_display 
      endif
c
c   go to average spectral ratios if end of events
c
      if(nrecord.eq.0) goto 60
c
c   check that event number not out of array bounds
c
      if(ievent.gt.nspectra) then
         call clear_to_alpha
         write(6,*)' Too many events, can be maximum ',nspectra
         goto 99
      endif
c
c   output
c
      write(3,'(1x,a)') data(1)(1:79)
      if(plotoption.eq.-1.or.plotoption.gt.1) write(6,'(1x,a)')
     *data(1)(1:79)
c                                                                               
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc              
c                                                                     c              
c   process pairs of stations in a loop if relative spectra, DO 50    c              
c                                                                     c          
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc          
c
      n_stat=2
      if(make_rel_spec.eq.0) n_stat=1
      do 50 ichan=1,n_stat
c                                                                               
c   read data for channel and get travel time etc., check if station is there
c
        if(station(ichan).eq.'     ') goto 55 ! go to clear, then next event                                                                               
c
c   output
c
         write(3,'(1x,a,1x,a)') station(ichan),component(ichan)
         if(plotoption.eq.-1.or.plotoption.gt.1) write(6,'(1x,a,1x,a)')
     *   station(ichan),component(ichan)
c
c   select data in CAT file, read from waveform file
c
        call spec_select(data,nhead,nrecord,rotate,                                                        
     *  station(ichan),component(ichan),
     *  sel_crit,start,tstart,t0,nsamp,ierr,err_text)
c                                                                               
c   check for errors                                                            
C                                                                               
        if(ierr.ne.0) then                                                      
           if(plotoption.eq.0.or.plotoption.eq.1) call clear_to_alpha 
           write(3,'(a)') err_text
           write(6,'(a)') err_text
           write(6,700) station(ichan),component(ichan),' Error CAT'
           write(3,700) station(ichan),component(ichan),' Error CAT'
           if(plotoption.ge.0) then
              write(6,*) ' Return to continue'
              read(5,'(a)') i
           endif
 700       format(1x,a,1x,a,1x,a)                                     
           if(plotoption.eq.0.or.plotoption.eq.1) call open_display 
           close(65) ! close plot file
           goto 10   ! next event                                       
        endif
c
c   put in sample rate
c
         rate=wav_rate(wav_current_chan(1))
         current_chan=wav_current_chan(1)        ! maybe needed for mulplt routines
c
c   set marker for origin time and window
c                                             
         flag(1)=tstart                                                         
         flag(2)=tstart+wlen                                                    
         flag(3)=t0                                     
         nflag=3                        
c
c   set plotting parameters
c
         x0=60.0                
         ptitle=1                ! plot title                                     
c
c  reset fonts
c

         if(plotoption.gt.0.and.plotoption.lt.3) 
     *   call fontsize(0,3.0)
         paxisnumb=0             ! no axis numbers for first trace
         if(ichan.eq.1) then
            if(make_rel_spec.eq.1) y0=665.0
            if(make_rel_spec.eq.0) y0=600.0
            if(make_rel_spec.eq.0) paxisnumb=1                                                       
         endif
         if(ichan.eq.2) then
            if(make_rel_spec.eq.1) y0=595.0
            if(make_rel_spec.ne.1) y0=565.0
            ptitle=0             ! no title for second trace
            paxisnumb=1          ! axis numbers for second trace
         endif
         height=70.0             ! trace height
         if(make_rel_spec.ne.1) height=120.0
c                                                                               
c   transfer data to working array, correct for a possible gain                 
c               
         if(gain_chan1.ne.1.0.and.ichan.eq.1) then
            do i=1,nsamp
               signal1(i)=signal1(i)*gain_chan1
            enddo
         endif
         do i=1,nsamp
           y(i)=signal1(i)
         enddo               
c
c   make plot top header
c
         do i=1,80
            head(i:i)=' '
         enddo
         head(1:12)='Plot start: '
         write(head(13:16),'(i4)') wav_year(wav_first)
         write(head(18:34),'(2i2,1x,2i2,1x,f4.1)') 
     *   wav_month(wav_first),wav_day(wav_first),
     *   wav_hour(wav_first),wav_min(wav_first),wav_sec(wav_first)
         head(36:39)='Lat='
         head(40:46)=data(1)(24:30)
         head(48:52)='Lon='
         head(53:60)=data(1)(31:38)
         head(62:63)='H='
         head(64:68)=data(1)(39:43)
         head(70:73)=data(1)(57:60)
         if(plotoption.ge.0.and.plotoption.lt.3) 
c
c   plot one trace
c
     *   call one_traceplot                                                      
     *   (x0,y0,nsamp,station(ichan),component(ichan),nflag,flag)                                  
         call convert(wav_abs_time(wav_first),station(ichan),
     *   component(ichan),-1)                             
c
c   plot pics if requested
c
         if(plot_pics.eq.1) then
             call tecpic                                                        
          endif
c
c   select window and do spectral analysis
c
         nsignal=wlen*rate                                                 
c
c   check that not too much data for dimentions
c
         if(nsignal.ge.nspec_points) then
            call clear_to_alpha 
            write(6,'(1x,a,f6.1,1x,a)') 
     *      'Too long window, can be max', 
     *       (nspec_points-1)/rate, 'secs'
             goto 99   !stop
         endif
         nstart=tstart*rate                                                    
c
c   check that not too much data has been selected or start is before first
c   sample
c
         if(nstart+nsignal.gt.nsamp.or.nstart.le.0) then
            if(plotoption.eq.0.or.plotoption.eq.1) call clear_to_alpha 
            if(nstart+nsignal.gt.nsamp) then
               write(6,*)' Window too late, skip trace'
               write(3,*)' Window too late, skip trace'
            endif
            if(nstart.le.0) then
               write(6,*)' Window starts before start of trace'
               write(3,*)' Window starts before start of trace'
            endif
	    if(plotoption.ge.0) then
                write(6,*) ' Return to continue'
                read(5,'(a)') i
            endif
            if(plotoption.eq.0.or.plotoption.eq.1)call open_display 
c           if( make_rel_spec.eq.1) then
               goto 10   ! next event                                                             
c           else
c               goto 50   ! next trace
c           endif
         endif
c
c  if response removal, check if response curve available and read, 
c  if not go to next event
c
         if(remove_response.gt.0) then
            wav_resp_file=' '
            call read_resp                 ! read response file
            if(wav_resp_status(1:1).eq.'8') then ! using header resp. values
                call tchars('Response from header ***',24,710.0,230.0)
            endif
               if(wav_resp_status(1:1).eq.'9') then
               if(plotoption.eq.0.or.plotoption.eq.1) 
     *         call clear_to_alpha
               write(6,'(1x,a,1x,a,1x,a)') 
     *         'No response info ***',station(ichan),component(ichan)
               write(3,'(1x,a,1x,a,1x,a)') 
     *         'No response info ***',station(ichan),component(ichan)
              if(plotoption.ge.0) then
                write(6,*) ' Return to continue'
                read(5,'(a)') i
              endif
c               if( make_rel_spec.eq.1) then
                   goto 10   ! next event                                                             
c               else
c                   goto 50   ! next trace
c               endif
            endif
         endif
c
c  check if distance correction wanted
c
         factor=1.0
         if(dist_cor.gt.0.0) then
c
c    check that distance exists
c
c
            if(sdistance.eq.0) then
               call clear_to_alpha 
               write(6,'(1x,a,1x,a,1x,a)') 'No distance in CAT file', 
     *         station(ichan),component(ichan)
               write(6,*)' Will skip trace'
               write(3,'(1x,a,1x,a,1x,a)') 'No distance in CAT file', 
     *         station(ichan),component(ichan)
               write(3,*)' Will skip trace'
               if(plotoption.ge.0) then
                  write(6,*) ' Return to continue'
                  read(5,'(a)') i
               endif
               goto 10   ! next event                                          
             endif
            write(3,*)' Hypocentral distance',sdistance
            factor=factor*sdistance**dist_cor
         endif
c
c   check if calculation of moment
c
         if(mag_spec.gt.0) then
c
c  moment is in Nm, 1.2 is surface and source correction
c
             factor= 4*3.14*(density*1000.0)*
     *               ((svelocity*1000.0)**3)*factor
             factor = factor*(1000.0)/(1.2*1.0e9)
         endif
c
         factor=alog10(factor)
c
c   travel time for q correction
c
         travel_time=tstart-t0
         if(ichan.eq.1) ttime1=travel_time
         if(ichan.eq.2) ttime2=travel_time
c
c   set first and last point to use
c
         first=nstart
         last=nstart+nsignal
c                                                                               
c    put part of the signal into local datavector                           
c                                                                               
         j =  0                                                                
         do i = first,last                                                     
           j = j + 1                                                           
           y(j) = signal1(i)                                                    
         enddo
c
c   check for clipped signals
c
c         call check_clipped(y,j,clipped)
         clipped=.false.
         if(clipped) then
            if(plotoption.eq.0.or.plotoption.eq.1) call clear_to_alpha 
            write(6,*) 'Signal clipped'
            write(3,*) 'Signal clipped'
            if(plotoption.ge.0) then
                write(6,*) ' Return to continue'
                read(5,'(a)') i
            endif
            if(plotoption.eq.0.or.plotoption.eq.1)call open_display
            goto 10
         endif
c
c   spectrum 
c
         call amp_spec_gen(j,nspec,x_work,power)
c
c   write out travel time used for q correction or q calculation 
c
         write(3,*)' Travel time=',travel_time
c
c   correct for distance etc
c
         do i = 1,nspec
             y(i) = y(i)+factor      ! factor is sum of all corrections
         enddo
c
c   smooth
c
         call smooth(y,nspec,nsmooth)                                           
c
c  spectrum title
c
         write(text,'(a5,1x,a4,2x,a12)') 
     *   station(ichan),component(ichan),title(1:12)
c
c   convert to magnitude
c
         if(mag_spec.eq.2) then
            do i=1,nspec
              y(i)=y(i)*0.667-6.06
            enddo
         endif
c
c   select spectral values at nearest fixed 10 output frequencies
c
         do i=1,10
           out_amp(i)=0.0
           out_ff(i)=0.0
           do k=1,nspec
              if(10.0**x_work(k).ge.out_f(i)) then
                 out_ff(i)=10.0**x_work(k)
                 out_amp(i)=y(k)
                 goto 3645
              endif
           enddo
 3645      continue
         enddo        
         write(3,'(a,1x,10f7.1)')' f   ',(out_ff(i),i=1,10)                    
         write(3,'(a,1x,10f7.1)')' amp ',(out_amp(i),i=1,10)
c
c------------------------------------------------------------------------
c   calcualte t* if parameter set
c------------------------------------------------------------------------
c
         if(t_star) then
             do i=1,nspec
                x_work(i)=10.0**x_work(i)    ! get linear frequencies
             enddo
             call lsqlin(nspec,x_work,y,aa,bb,corr,rms)
             bb=bb*0.879     ! 0.879=1/(pi*log10(e))
             if(abs(corr).gt.mincor) then   ! corr is negative or positive
c            if(abs(corr).gt.mincor.and.corr.lt.0.0) then   ! corr is negative
               itstar=itstar+1
               tstar(itstar)=bb
             endif
             write(3,'(a,3f10.4)') 'kappa,corr, rms ',bb,
     *       corr,rms
          endif
c
c-------------------------------------------------------------------
c   save spectrum if first spectrum, else make relative spectrum,
c   this is always done, even when not used
c
         nset=1                     ! at least one data set to plot
         npoint_set(1)=nspec
         if(ichan.eq.1) then        ! first channel
            do i=1,nspec
              rel_spec(ievent,i)=y(i)
            enddo
         else                       ! second channel, only if relative spectrum
            if(make_rel_spec.eq.1) then
               k=0
               do i=1,nspec
                 rel_spec(ievent,i)=rel_spec(ievent,i)-y(i)  ! 1. spectrum divided by 2
c                 write(3,*) 're, t2,t1',rel_spec(ievent,i),ttime2,ttime1
c
c----------------------------------------------------------------------------
c   calculate q if q0 is negative indicating q-calculation, put in rel_spec
c----------------------------------------------------------------------------
c
                 if(q0.lt.0.0) then
                    rel_spec(ievent,i)=
     *              10.0**x_work(i)*3.14*(ttime2-ttime1)/
     *              (2.30*(rel_spec(ievent,i))-   ! sign to - nov 06, jh
     *              dist_cor*2.30*log10(ttime2/ttime1))
c
c   mark crazy values with -1
c
                    if(rel_spec(ievent,i).lt.1.0) rel_spec(ievent,i)=-1.0
                    if(rel_spec(ievent,i).gt.5000.0) 
     *                     rel_spec(ievent,i)=-1.0
c
c   take log
c
                    if(rel_spec(ievent,i).gt.1.0)
     *                 rel_spec(ievent,i)=alog10(rel_spec(ievent,i))
c                    write(3,*) 10.0**x_work(i),rel_spec(ievent,i)

c
c   save for linear relation, but only 'good' values
c
                    if(rel_spec(ievent,i).gt.0.0) then
                       k=k+1
                       y_work(k)=rel_spec(ievent,i)
                    endif
                  endif
               enddo
c
c   calculate q0 and qalpha
c
               if(q0.lt.0.0.and.k.gt.2) then
                 call lsqlin(k,x_work,y_work,qq0,qqalpha,corr,rms)
                 qq0=10.0**qq0
                 write(3,*)'q0 and qalpha',qq0,qqalpha
               endif           
            endif
         endif
c
c   also save for plotting, thsi is only 1. single spectrum
c
         do i=1,nspec
           y_work(i)=y(i)
         enddo
c
c---------------------------------------------------------------------------
c   now do noise spectrum, take noise from same window in start of signal
c---------------------------------------------------------------------------
c
         if(make_noise_spec.eq.1) then
            first=1
            last=nsignal

c                                                                               
c   put part of the signal into local datavector                           
c                                                                               
            j =  0                                                                    
            do i = first,last                                                         
               j = j + 1                                                               
               y(j) = signal1(i)                                                            
            enddo                                                                     
                                                                                

            call amp_spec_gen(j,nspec,x_work,power)                                                 
            do i=1,nspec
                y(i) = y(i)+factor
            enddo
c
c   smooth
c
            call smooth(y,nspec,nsmooth)                                           
c
c   convert to magnitude
c
            if(mag_spec.eq.2) then
               do i=1,nspec
                 y(i)=y(i)*0.667-6.06
               enddo
            endif
c
c   check s/n ratio if tstar
c
            sn_ok=.true.        ! initially ok
            if(t_star) then
               do i=1,nspec
                  if((y_work(i)-y(i)).lt.minsn) sn_ok=.false.
               enddo
               if(.not.sn_ok) then
                 itstar=itstar-1    ! take out last event
                 ievent=ievent-1
                 if(itstar.lt.0) itstar=0   ! cannot be less than 0 events
                 if(ievent.lt.0) ievent=0
               endif
               ievent=itstar                ! make sure the two tally, event
                                            ! could have been taken out under
                                            ! corr check
            endif
c
c   put in plotting vector
c
            do i=1,nspec
               y_work(i+nspec)=y(i)
               if(xlin) x_work(i)=10.0**x_work(i)  ! antilog if linear x-axis      
               x_work(i+nspec)=x_work(i)  
            enddo
            nset=2                        ! 2 data sets to plot
            npoint_set(2)=npoint_set(1)   ! same number of points in both data sets
         endif  !      end noise part

c
c   set plotting parameters
c
         y0=355.0
         x_size=350.0
         x0=(ichan-1)*500.0+120.0
         y_size=170.0
         if(make_rel_spec.ne.1) then
            y0=110.0
            y_size=380.0
            x_size=500.0
         endif
c
c   plot signal and possibly noise spectrum, individual spectra
c
         aa=-x0
         if(xlin) aa=-aa      ! linear scale
         if(plotoption.ge.0.and.plotoption.lt.3)
     *   call xy_plot(nset,npoint_set,x_work,y_work,
     *   text,xtext,ytext,x_size,
     *   y_size,aa,y0,2,0,30.0,0,c_spec,nc,cx,cy)
c                                 
c---------------------------------------------------------------------                                                                               
c End of channel loop  50, max 2 channels
c---------------------------------------------------------------------
c
 50   continue
c
c   set up output screen text for spectra
c
      if(q0.lt.0) then
         write(out_txt(1),'(a,f7.1)') 'Q0=',qq0
         write(out_txt(2),'(a,f5.2)') 'Qalp=',qqalpha
      else
         write(out_txt(1),'(a,f7.1)') 'Q0=',q0
         write(out_txt(2),'(a,f5.2)') 'Qalp=',qalpha
      endif
      write(out_txt(3),'(a,f3.1)') 'DistCo=',dist_cor
      write(out_txt(4),'(a,i4)')   'Hdist=',int(sdistance+0.5)
      write(out_txt(5),'(a,f5.2)') 'Velo=',svelocity
      write(out_txt(6),'(a,f5.2)') 'Dens=',density
      write(out_txt(7),'(a,i2)')   'SelCrit=',sel_crit
      write(out_txt(8),'(a,i4)')   'Start=',int(start)
      write(out_txt(9),'(a,i3)')   'Wind=',int(wlen)
      write(out_txt(10),'(a,f5.1)') 'Gain=',gain_chan1
      write(out_txt(11),'(a,i3)')   'Smooth=',nsmooth
      write(out_txt(12),'(a,f5.3)')  'kk_I=',kappa
      do i=13,30
         write(out_txt(i),'(a)')' '
      enddo
      if(t_star) then
         write(out_txt(13),'(a,f6.4)') 'kk0=',bb
         write(out_txt(14),'(a,f6.3)') 'cor=',corr
         write(out_txt(15),'(a,f6.3)') 'rms=',rms
      endif
c
c   plot text for spectra
c
      if(plotoption.ge.0.and.plotoption.lt.3) then
c        if(make_rel_spec.eq.1) then
           call out_text(out_txt,15,12,2,-20.0,710.0,200.0) ! text at end
c        else
c           call out_text(out_txt,15,12,5,20.0,5.0,10.0)   ! text at bottom
c        endif
      endif
c
c----------------------------------------------------------------------
c   start section on plotting reltive spectrum or q, first
c   check if any plotting at all, count events if relative spetra made
c----------------------------------------------------------------------
c
      if(make_rel_spec.lt.2) ievent=ievent+1 ! number is now for next event
      if(plotoption.eq.-1.or.plotoption.eq.3)   goto 10   ! no plotting, next event
c
c   plot relative spectrum if so specified
c
      if(make_rel_spec.eq.1) then   
c
c   set up plotting parameters
c
         x0=120.0
         y0=55.0
         k=0
         do i=1,nspec
            if(q0.lt.0.and.rel_spec(ievent-1,i).ge.0.0) then
                k=k+1
                y_work(k)=rel_spec(ievent-1,i)
             else
                y_work(i)=rel_spec(ievent-1,i)
             endif
         enddo
         if(q0.ge.0.0) then
            write(text,'(6(a,1x))')'Relative spectrum of ',
     *      station(1),component(1),' and ',station(2),component(2)
            ytext=' Log amplitude               '
         else
c
c   plot Q-values
c
            npoint_set(1)=k
            write(text,'(6(a,1x))')'Q calculated from ',
     *      station(1),component(1),' and ',station(2),component(2)
            ytext=' log Q                     '
         endif

         if(power) ytext='db'
         if(mag_spec.eq.1) ytext='Moment'
         if(mag_spec.eq.2) ytext='Mw'
c
         call xy_plot(1,npoint_set,x_work,y_work,
     *   text,xtext,ytext,550.0,195.0,-x0,y0,2,0,30.0,
     *   0,c_spec,nc,cx,cy)


         ytext=' Log amplitude               '
         if(mag_spec.eq.1) ytext='Moment'
         if(mag_spec.eq.2) ytext='Mw'
c
         if(power) ytext='db'
c
c   calculate average spectrum or average log Q, only 'good' q-values
c
         if(q0.lt.0.0) then
            call sdv(k,y_work,av,sd)
         else
            call sdv(nspec,y_work,av,sd)
         endif
c
         if(q0.ge.0.0) then
            write(3,*)' Average log spectrum and sd: ',av,sd
            do i=1,nspec
               y_work(i)=10**y_work(i)
            enddo
            call sdv(nspec,y_work,av,sd)
            write(3,*)' Average lin spectrum and sd: ',av,sd
         else
            write(3,*)' Average log Q and sd', av,sd
         endif
         write(text,'(a,f6.4,1x,a,f6.4)') 'Av: ',av,'Sd: ',sd
         call xchars(text,23,710.0,60.0)
         if(plotoption.eq.1.or.plotoption.eq.0) call tsend
      endif
c
 55   continue
c
c   close plot if plotting is done, pause before next plot if interactive mode
c
      if(plotoption.ge.0.and.plotoption.lt.3) then 
         if(plotoption.ge.1) then 
            call close_post
            close(65)
            call send_plot('spec.eps',8) ! plot to laser
         endif
         if(plotoption.eq.0.or.plotoption.eq.1) then
c        call xset_color(xyellow)
         call tchars(question,24,700.0,20.0)
 112     continue
         call xscursr(key,xx,yy)
         if (char(key).eq.'#') goto 112
         if(char(key).eq.' ') then
            xx=(xx-x0)/xscale1+xfirst
            yy=(yy-y0)/yscale1+yfirst
            if(.not.power) yy=10.0**yy
            write(out_txt(1),'(a3,2f8.2)')'f,a',10.0**xx, yy
            call xmessage(out_txt,1,19,700.0,230.0)
            goto 112
         endif
     
         if(char(key).eq.'q'.or.char(key).eq.'Q') goto 99 !stop
        endif
      endif
c
c   back for next event
c
      goto 10

c-------------------------------------------------------------------
c------------------------------------------------------------------                                                                               
c   here after Finishing with one station pair, many events,
c   now plot all spectra and calculate average spectra
c------------------------------------------------------------------
c------------------------------------------------------------------
c------------------------------------------------------------------
c                                                                
 60   continue                      
c
c   average spectra are made, if not go to next stations
c
c      if(make_rel_spec.gt.1) goto 1   ! next pair of stations
      ievent=ievent-1
c
c  check if enough spectra are available, else go to next set of stations
c
cfeb 2002 jh
c     if(ievent.le.0) then
c         write(3,*)
c         write(3,*)' No events available for average'
c         first_run=.true.     ! do not ask for clear
c         close(65)            ! a plot file might have been opened above
c         goto 1          ! next pair of stations
c     endif
c
c   plot all relative or individual spectras, if no previous plots, 
c   open plot here
c
      if(plotoption.eq.-1.or.plotoption.eq.3)  then 
         old_poption=plotoption        ! save plot option
         open(65,file='spec.eps',status='unknown')
c
c   temporarely make sure hardcopy is made
c
         if(plotoption.eq.-1) plotoption=1
         if(plotoption.eq.3) plotoption=2  
c        if(old_poption.eq.-1) call xt
c        call xinitt(960)                                    
cx         call open_display
      endif
      call open_display
c
      x0=100.0
      y0=540.0
c
      wtext=station(1)//component(1)//'_'//station(2)//component(2)  ! for file name
      nwtext=19

      if(make_rel_spec.eq.1) then
c
c  non q
c
         if(q0.ge.0) then
            write(text,'(i3,6(a,1x))')ievent,' relative spectra for',
     *      station(1),component(1),'and',station(2),component(2)
            write(3,'(1x,a)') text
            gmt_ytitle='Spectral ratio, '//title(1:12)
         else

c
c  q
c
            write(text,'(i3,6(a,1x))')ievent,'  Q curves for',
     *      station(1),component(1),'and',station(2),component(2)
            write(3,'(1x,a)') text
            gmt_ytitle='Q'
            ytext='Log Q'
         endif
      endif

      if(make_rel_spec.eq.0) then
         nwtext=9         ! only one stat comp for name
         write(text,'(i3,6(a,1x))')ievent,' spectra for',
     *   station(1),component(1)
         if(t_star) 
     *   write(text,'(i3,6(a,1x))')ievent,' displacement spectra for',
     *   station(1),component(1) 
         write(3,'(1x,a)') text
         gmt_ytitle='Amplitude, '//title(1:12)
      endif
      x_length=700.0
c
c   fill out in name so no blanks
c
      do i=1,nwtext
         if(wtext(i:i).eq.' ') wtext(i:i)='_'
      enddo
c
c-----------------------------------------------------------------------
c   set main gmt parameters and open output file
c-----------------------------------------------------------------------
c
      gmt_ofilename='spec_all_'//wtext(1:nwtext)//'.gmt.ps'
      gmt_maintitle=text
      gmt_xtitle='Frequency (Hz)'
      gmt_xsize=12.0
      gmt_xlog=1
      gmt_ysize=10.0
      gmt_ylog=1
      gmt_ntraces=ievent
      if(.not.power.and.xlin) gmt_xlog=0  ! lin frequency
      if(power) then
          gmt_ylog=0                ! linear dD scale
          gmt_ytitle='Power spectral density (dB)'
          gmt_ntraces=gmt_ntraces+2
      endif
      if(mag_spec.eq.1) gmt_ytitle='Moment'
      if(mag_spec.eq.2) then
         gmt_ytitle='Mw'
         gmt_ylog=0
      endif
c
c  open gmt file and write out main parameters
c
       open(16,file='spec_all_'//wtext(1:nwtext)//'.out',
     * status='unknown')
     
      call gmt_xy_par(16,1,1,xx_work,yy_work)
c
c  output in file with all runs
c
      if(first_run) then
         gmt_ofilename='spec_all_gmt.ps'
         gmt_maintitle='All results'
         call gmt_xy_par(18,1,1,xx_work,yy_work)
      endif
c
c--------------------------------------------------------------------------
c   transfer to plotting array and gmt output array
c--------------------------------------------------------------------------
c
      kkk=0                    ! total number of points for q
      if(q0.ge.0.0) then       ! normal case
         do k=1,ievent
            npoint_set(k)=nspec
            do i=1,nspec
               y(i+nspec*(k-1))=rel_spec(k,i)
               x_work(i+nspec*(k-1))=x_work(i)
               j=i+nspec*(k-1)
c
               if(.not.power.and.xlin) then       ! tstar
                   xx_work(i)=x_work(i)          
                   yy_work(i)=10.0**rel_spec(k,i)
               endif 
               
               if(.not.power.and..not.xlin) then  ! log freqyency, normal spectra
                   xx_work(i)=10.0**x_work(i)     ! 
                   yy_work(i)=10.0**rel_spec(k,i)
               endif

               if(power.or.mag_spec.eq.2) then  ! noise power spectra or Mw
                   xx_work(i)=10.0**x_work(i)
                   yy_work(i)=rel_spec(k,i)
               endif
            enddo

            write(gmt_tracetitle,'(i4)') k 
            gmt_tracesymbol=' '
            if(k.lt.gmt_ncolor) then
                gmt_tracecolor=gmt_color(k)
            else
                gmt_tracecolor='black'
            endif
c
c   write out trace parameters and one trace
c
            call gmt_xy_par(16,0,nspec,xx_work,yy_work)
            gmt_tracetitle=station(1)//' '//component(1)
            call gmt_xy_par(18,0,nspec,xx_work,yy_work)
            ngmt_all=ngmt_all+1
c 
         enddo
c
c   q, check  for 'good values'
c
      else
         do k=1,ievent
            kk=0
            do i=1,nspec
               if(rel_spec(k,i).ge.0.0) then
                  kk=kk+1   ! good points in this set
                  kkk=kkk+1 ! good points in all sets
                  y(kkk)=rel_spec(k,i)
                  x_work(kkk)=x_work(i)
                  xx_work(kkk)=10.0**x_work(kkk)
                  yy_work(kkk)=10.0**y(kkk)
               endif
            enddo
            npoint_set(k)=kk
            write(gmt_tracetitle,'(i3)') k
            gmt_tracesymbol=' '
            if(k.lt.gmt_ncolor) then
                gmt_tracecolor=gmt_color(k)
            else
                gmt_tracecolor='black'
            endif
c
c   write out trace parameters and one trace
c
            call gmt_xy_par(16,0,nspec,xx_work,yy_work)
            gmt_tracetitle=station(1)//' '//component(1)
            call gmt_xy_par(18,0,nspec,xx_work,yy_work)
            ngmt_all=ngmt_all+1
c 
         enddo 
c 
      endif
c
c-------------------------------------------------------   
c   add petersen noise spectra if noise spectra
c--------------------------------------------------------
c
      if(power) then
        k=0
        do i=1,22
          ff = 10.0**low_f(i)
          if(ff .ge. ffmin .and. ff .le. ffmax) then
             j=j+1
             k=k+1
             x_work(j)=low_f(i)
             xx_work(k)=10.0**low_f(i)
             y(j)=low_l(i)
             yy_work(k)=low_l(i)
           endif
        enddo
c
        gmt_tracetitle='NHNM'
        gmt_tracesymbol=' '
        gmt_tracecolor='red'
c
c
c   gmt output for peterson
c
        call gmt_xy_par(16,0,k,xx_work,yy_work)
        if(first_run) then
            call gmt_xy_par(18,0,k,xx_work,yy_work)
            ngmt_all=ngmt_all+1
        endif
        npoint_set(ievent+1)=k
        k=0
        do i=1,14
          ff = 10.0**high_f(i)
          if(ff .ge. ffmin .and. ff .le. ffmax) then
             j=j+1
             k=k+1
             x_work(j)=high_f(i)
             xx_work(k)=10.0**high_f(i)
             y(j)=high_l(i)
             yy_work(k)= high_l(i)
          endif
        enddo
        gmt_tracetitle='NLNM'
        gmt_tracesymbol=' '
        gmt_tracecolor='red'
c
c   gmt output
c
        call gmt_xy_par(16,0,k,xx_work,yy_work)
        if(first_run) then
           call gmt_xy_par(18,0,k,xx_work,yy_work)
           ngmt_all=ngmt_all+1
        endif

        npoint_set(ievent+2)=k
       endif
c
       close(16)
c
c---------------------------------------------------------------------------
c   plot individual spectra
c---------------------------------------------------------------------------
c
      k=ievent
      if(power) k=k+2
      aa=-x0            !  log axis
      if(xlin)aa=x0     ! linear axis
      call xy_plot(k,npoint_set,x_work,y,
     *text,xtext,ytext,x_length,200.0,aa,y0,2,0,30.0,
     *0,c_spec,nc,cx,cy)
c
c--------------------------------------------------------------------------------
c-------------------------------------------------------------------------------
c   calculate average spectra with standard deviation if at least 2 spectra,
c   the average is done in linear spectra, for q in 1/q linear,
c   then back to log q
c-------------------------------------------------------------------------------
c-------------------------------------------------------------------------------
c
c   set titles
c
      if(ievent.gt.1) then   ! the endif is far below
         if(make_rel_spec.eq.1) then
            if(q0.ge.0) then
               write(text,'(6a)')
     *         ' Average spectral ratio with sd for ',
     *         station(1),component(1),' and ',station(2),component(2)
               gmt_ytitle='Relative amplitude, '//title(1:12)
            else
               write(text,'(6a)')
     *         ' Average Q with sd for ',
     *         station(1),component(1),' and ',station(2),component(2)
               gmt_ytitle='Q'
            endif
         endif
         if(make_rel_spec.eq.0) then
            if(t_star) then
               write(text,'(3a)')
     *         ' Average spectra with sd for ', 
     *         station(1),component(1)
                gmt_ytitle='Amplitude, '//title(1:12)
            else  
              write(text,'(3a)')
     *         ' Average spectra with sd for ', 
     *          station(1),component(1)
                gmt_ytitle='Amplitude, '//title(1:12)
            endif
         endif
c
c   open output gmt file
c
         open(17,file='spec_ave_'//wtext(1:nwtext)//'.out',
     *   status='unknown')
c
c   set main gmt parameters that have changed realtive to above
c
         gmt_ofilename='spec_ave_'//wtext(1:nwtext)//'.gmt.out'
         gmt_maintitle=text
         gmt_ntraces=3
         if(power) then
             gmt_ylog=0                ! linear dD scale
             gmt_ytitle='Power spectral density (dB)'
             gmt_ntraces=gmt_ntraces+2
         endif
         if(mag_spec.eq.1) gmt_ytitle='Moment'
         if(mag_spec.eq.2) then
             gmt_ytitle='Mw'
             gmt_ylog=0
         endif
c


c
c  write out main gmt parameters
c     
         call gmt_xy_par(17,1,1,xx_work,yy_work)
cx
c


c
c-------------------------------------------------------------------
c  calculate average and transfer to plotting arrays
c-------------------------------------------------------------------
c


c
c   calcucalate and store average value
c
         kkk=0               ! total number to plot in all data sets, Q only
         do k=1,nspec        ! loop over number of frequencies
            kk=0             ! number of values to average, Q only
            do l=1,ievent    ! loop over number of spectra/events
               if(q0.ge.0.and.(.not.power).and.(.not.t_star)) then
                  y_work(l)=10**rel_spec(l,k)
               else
                  if(q0.lt.0.0) then
                     if(rel_spec(l,k).gt.0.0) then   ! only 'good' Q-values at this f
                         kk=kk+1                   
                         y_work(kk)=1.0/10.0**rel_spec(l,k) ! linear 1/q
                     endif
                  else
                     y_work(l)=rel_spec(l,k)         ! linear values, power and t-star
                  endif
               endif
            enddo
c
            if(q0.ge.0.0) then      ! by definition, always at least 2 spectra
               call sdv(ievent,y_work,rel_spec(1,k),sd)
            else
               if(kk.ge.2) then     ! only q average if 2 'good' values
                  kkk=kkk+1
                  call sdv(kk,y_work,rel_spec(1,kkk),sd) 
                  rel_spec(2,kkk)=rel_spec(1,kkk)+sd
                  rel_spec(3,kkk)=rel_spec(1,kkk)-sd
c
c  this must be larger than 0 to take log
c
                  if(rel_spec(3,kkk).le.0.0) rel_spec(3,kkk)=1.0
                  rel_spec(1,kkk)=alog10(1.0/rel_spec(1,kkk))
                  rel_spec(2,kkk)=alog10(1.0/rel_spec(2,kkk))
                  rel_spec(3,kkk)=alog10(1.0/rel_spec(3,kkk))

                  x_work(kkk)=x_work(k)
c
c  save for gmt, linear
c
                  xx_work(kkk)=10.0**x_work(kkk)     
                  yy_work(kkk)=10.0**rel_spec(1,kkk)
               endif
            endif

c
c   calculate sd values, q done above
c

c
c   take log, if not negative or zero, them make log sd zero, NOT Q, done above
c
            if(q0.ge.0.and.(.not.power).and.(.not.t_star)) then
                if((rel_spec(1,k)+sd).gt.0.0.
     *          and.rel_spec(1,k).gt.0.0) then
                   sd=alog10(rel_spec(1,k)+sd)-alog10(rel_spec(1,k))
                else
                   sd=0.0
                endif
                if(rel_spec(1,k).gt.0.0) then
                   rel_spec(1,k)=alog10(rel_spec(1,k))
                else
                   rel_spec(1,k)=0
                endif
            endif
c
c  store sd values, for tstar the original sd can be used since linear, 
c  q done above
c
            if(q0.ge.0.0) then
                rel_spec(2,k)=rel_spec(1,k)+sd
                rel_spec(3,k)=rel_spec(1,k)-sd
            endif
c
c   select for gmt output, not q, done above
c

            if(.not.power.and.xlin) then   ! lin frequency, tstar
                xx_work(k)=x_work(k)
                yy_work(k)=10.0**rel_spec(1,k)
            endif 
               
            if(.not.power.and..not.xlin.and.q0.ge.0.0) then  ! log freqyency, 
c                                                              normal spectra
                xx_work(k)=10.0**x_work(k)     
                yy_work(k)=10.0**rel_spec(1,k)
            endif

            if(power.or.mag_spec.eq.2) then                ! noise power spectra
                xx_work(k)=10.0**x_work(k)
                yy_work(k)=rel_spec(1,k)
            endif            
        enddo

         gmt_tracetitle='average '
         gmt_tracesymbol=' '
         gmt_tracecolor='black'
c
c   write out trace parameters and average trace
c
         if(q0.ge.0) then
            call gmt_xy_par(17,0,nspec,xx_work,yy_work)
         else
            call gmt_xy_par(17,0,kkk,xx_work,yy_work)
         endif
c
c   select for gmt output, average + sd
c
         do k=1,nspec

            if(.not.power.and.xlin) then   ! lin frequency, tstar
                xx_work(k)=x_work(k)
                yy_work(k)=10.0**rel_spec(2,k)
            endif 
               
            if(.not.power.and..not.xlin) then  ! log freqyency, normal spectra
                xx_work(k)=10.0**x_work(k)     ! also log(q)
                yy_work(k)=10.0**rel_spec(2,k)
            endif

            if(power.or.mag_spec.eq.2) then         ! noise power spectra
                xx_work(k)=10.0**x_work(k)
                yy_work(k)=rel_spec(2,k)
            endif            
         enddo
         gmt_tracetitle='av + sd '
         gmt_tracesymbol=' '
         gmt_tracecolor='blue'
c
c   write out trace parameters and average trace + sd
c
         if(q0.ge.0.0) then
            call gmt_xy_par(17,0,nspec,xx_work,yy_work)
         else
            call gmt_xy_par(17,0,kkk,xx_work,yy_work)
         endif
c 
c
c   select for gmt output, average - sd
c
         do k=1,nspec

            if(.not.power.and.xlin) then   ! lin frequency, tstar
                xx_work(k)=x_work(k)
                yy_work(k)=10.0**rel_spec(3,k)
            endif 
               
            if(.not.power.and..not.xlin) then  ! log freqyency, normal spectra
                xx_work(k)=10.0**x_work(k)     ! also log(q)
                yy_work(k)=10.0**rel_spec(3,k)
            endif

            if(power.or.mag_spec.eq.2) then        ! noise power spectra
                xx_work(k)=10.0**x_work(k)
                yy_work(k)=rel_spec(3,k)
            endif            
         enddo
         gmt_tracetitle='av - sd'
         gmt_tracesymbol=' '
         gmt_tracecolor='blue'
c
c   write out trace parameters and average trace - sd
c
         if(q0.ge.0.0) then
            call gmt_xy_par(17,0,nspec,xx_work,yy_work)
         else
            call gmt_xy_par(17,0,kkk,xx_work,yy_work)
         endif  

c
c   transfer to plotting array
c
         if(q0.ge.0.0) then
            do k=1,3
               npoint_set(k)=nspec
               do i=1,nspec
                  y(i+nspec*(k-1))=rel_spec(k,i)
                  x_work(i+nspec*(k-1))=x_work(i)
                  j=i+nspec*(k-1)
               enddo
            enddo
         else        ! for Q
            do k=1,3
               npoint_set(k)=kkk
               do i=1,kkk
                  y(i+kkk*(k-1))=rel_spec(k,i)
                  x_work(i+kkk*(k-1))=x_work(i)
                  j=i+kkk*(k-1)
               enddo
            enddo
         endif
c
c   if t* calculation, do it here on the average spectrum
c
         if(t_star) then
            call lsqlin(nspec,x_work,y,aa,bb,corr,rms)
            aa=bb*0.879     ! 0.879=1/(pi*log10(e))
            write(3,*)
            write(3,'(1x,a,3f10.3)')
     *     'kappa from average spectrum, corr,rms', aa,corr,rms
         endif

c
c   add petersen noise spectra if noise spectra
c
         if(power) then
            k=0
            do i=1,22
               ff = 10.0**low_f(i)
               if(ff .ge. ffmin .and. ff .le. ffmax) then
                  j=j+1
                   k=k+1
                   x_work(j)=low_f(i)
                   xx_work(k)=10.0**low_f(i)
                   y(j)=low_l(i)
                   yy_work(k)=low_l(i)
               endif
            enddo
            gmt_tracetitle='NHNM'
            gmt_tracesymbol=' '
            gmt_tracecolor='red'
c
c
c   gmt output
c
            call gmt_xy_par(17,0,k,xx_work,yy_work)

            npoint_set(4)=k
            k=0
            do i=1,14
               ff = 10.0**high_f(i)
               if(ff .ge. ffmin .and. ff .le. ffmax) then
                  j=j+1
                  k=k+1
                  x_work(j)=high_f(i)
                  xx_work(k)=10.0**high_f(i)
                  y(j)=high_l(i)
                  yy_work(k)= high_l(i)
               endif
            enddo
            gmt_tracetitle='NLNM '
            gmt_tracesymbol=' '
            gmt_tracecolor='red'
c
c   gmt output
c
            call gmt_xy_par(17,0,k,xx_work,yy_work)

            npoint_set(5)=k
         endif
         close(17)
c        
c
c   plot average relative spectra/spectra/Q with standard deviation
c
c
         y0=200
         x_length=700
         k=3
         if(power) k=5
         aa=-x0            !  log axis
         if(xlin)aa=x0     ! linear axis

         call xy_plot(k,npoint_set,x_work,y,
     *   text,xtext,ytext,x_length,200.0,aa,y0,2,0,30.0,
     *   0,c_spec,nc,cx,cy)
c
c   maybe calculate q
c
         if(q0.lt.0.0) then
c
c   calculate q0 and qalpha
c
            call lsqlin(kkk,x_work,y,qq0,qqalpha,corr,rms)
            qq0=10.0**qq0
            write(text,'(a,f7.1,1x,a,f6.2)') 'q0 ',qq0,'qalpha ',
     *      qqalpha
            call xchars(text,23,100.0,20.0)
            write(3,*)
            write(3,*)'q0 and qalpha from average',qq0,qqalpha
            write(3,*)
         endif
c
c   calculate average spectrum/Q/tstar/spectrum
c
         do i=1,nspec
            y_work(i)=rel_spec(1,i)
         enddo

         if(q0.ge.0.0) then
            call sdv(nspec,y_work,av,sd)
            write(3,*)' Average log spectrum and sd: ',av,sd
         else
            call sdv(kkk,y_work,av,sd)
            write(3,*)' Average log Q and sd: ',av,sd
         endif
         write(text,'(a,f13.3)') 'Sd: ',sd
         call xchars(text,29,810.0,200.0)
         write(text,'(a,f13.3)') 'Av: ',av
         call xchars(text,29,810.0,230.0)

         if(.not.power) then
            do i=1,nspec
               y_work(i)=10**y_work(i)
            enddo
         endif

         if(q0.ge.0.0) then
            call sdv(nspec,y_work,av,sd)
            if(.not.power)
     *       write(3,*)' Average lin spectrum and sd: ',av,sd
             if(power)
     *       write(3,*)' Average power density spectrum and sd: ',av,sd
         else
            call sdv(kkk,y_work,av,sd)
            write(3,*)' Average lin Q and sd: ',av,sd
         endif
         write(text,'(a,a)')'Event file: ',name(1:40)
         call xchars(text,51,80.0,110.0)

c        call out_text(out_txt,11,12,5,-20.0,5.0,90.0)   ! text at bottom
         if(plotoption.eq.1.or.plotoption.eq.0) call tsend
c
c   calculate average t* if that option
c
         if(t_star) then
            write(6,*)
            if(itstar.gt.1) then
               call sdv(itstar,tstar,av,sd)
            else
               av=tstar(1)
               sd=0.0
            endif
            write(3,*)' Number of values for kappa',itstar
            if(itstar.gt.0) then
               write(3,'(a,2f10.3)') 'Average kappa and sd',av,sd
               write(text,'(a,f8.3,a,f8.3,a,i5)') 
     *         'kappa=',av,' sd=',sd,'  n=',itstar
               call xchars(text,55,80.0,40.0)
            endif
         endif
c-----------------------------------------------------------------------
c   end of whole average block
c------------------------------------------------------------------------

      else
c
c  not enough spectra are available for average
c
          write(3,*)
          write(3,*)' No events available for average'
c         first_run=.true.     ! do not ask for clear
      endif

c
c   close plot, here there must always be a plot
c
c     call xfinitt(700,200)                               
      if(plotoption.ge.0) then 
         if(plotoption.ge.1) then 
            call close_post
            close(65)
            if(old_poption.ne.-1)
     *      call send_plot('spec.eps',8) ! plot to laser
         endif
      endif
c
c   reset plot option
c
      if(old_poption.eq.-1.or.old_poption.eq.3) plotoption=old_poption 
c
c---------------------------------------------------------------------
c   back for next station pair, goto 1
c---------------------------------------------------------------------
c
      first_run=.false.
      goto 1
c
c   end of program
c

 99   continue                                                                
c
c   fix number of traces in spec_all_gmt.out
c
      rewind 18
      open(19,file='spec_all_gmt.out',status='unknown')
 2929 continue
         read(18,'(a)',end=2930) text
         if(text(3:9).eq.'NTRACES') then
             text(20:80)=' '
             write(text(25:34),'(i10)') ngmt_all 
         endif
         write(19,'(a)') text
         goto 2929
 2930 continue
      close(18,status='delete')
       
      call clear_to_alpha 
      write(6,*)
     *' Output files are: spec.out, spec_all... and spec_ave...'
      if(pc) then
         write(6,*)' Return to end'
         read(5,'(a)') text
      endif

      stop
      end
c
                                                                                
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc             
      subroutine amp_spec_gen(nsamp,nspec,x_work,power)                                                 
c                                   
c
c     routine to make a real spectrum, more general than routine in
c     mul_spec                
c     power: true if power density spectrum
c     The tapering of  the data is fixed to 10%                                 
c                                                                               
c     Jh april 94                                         
c                                                                               
                                                                                
c-- common block     
c
      implicit none
      include 'mulplt.inc'			
      logical power
c
c-- percentage of tapering (fixed)                       
      real taper/10./				
c-- length of input vector                                 
      integer nsamp				
c-- length after padding                                    
      integer ipow				
c-- vector padded with npad zeros                           
      integer npad				
c-- indicator for response removal or not (1 or 0).                        
      integer rem_resp			
c-- indicator for type of spectrum                  
c     integer disp_vel! now in mulplt.inc			
c-- number of points in spectrum
      integer nspec
c-- frequencies
      real x_work(*)
c-- counters and help variables                                               
      integer i,j				
      real ff                    ! help variables
		
c
c   no frequency domain filters
c
      filt=0
c
c   check if response is removed 
c
      if(remove_response.gt.0) then
         rem_resp=1                   ! response is removed
         disp_vel=remove_response     ! type of response
c        opmode=0                     ! get origin time form data array
      else
         rem_resp=0                   ! response is not removed
         disp_vel=0
c        opmode=1
      endif
c                                                                               
c--------put part of the signal into local datavector                           
c                                                                               
c      j =  0                                                                    
c      do i = first,last                                                         
c        j = j + 1                                                               
c        y(j) = signal1(i)                                                            
c      enddo                                                                     
c                                                                                
c      nsamp = j                                                                 
c                                                                               
c------- prepare data.     Pad with zeros and taper 10%.                        
c                                                                               
      call prepare(nsamp,y,taper,ipow,npad,com)                                
c
c   check for max number of points
c
      if(ipow.ge.max_sample/2) then
           call clear_to_alpha
           write(6,*)' Too many points in spectrum'
           write(6,*)' Max number is ', max_sample/2
           stop
      endif                                
c
c-------- Calculate the spectrum, and remove the system response
c         if desired, no frequency domain filters, therfore the zeros                
c

      call spectrum(com,ipow,disp_vel,rem_resp,rate,0.0,0.0,0,0,
     +     q0,qalpha,kappa,travel_time)
c                                                                               
c
c   calculate real spectrum
c
      j=0
      do i = 2,((ipow/2) + 1)
        ff=(i-1)*rate/ipow
        if(ff.ge.ffmin.and.ff.le.ffmax) then
           j=j+1
           if(power) then
             y(j) = 2.0*(com(i)*conjg(com(i)))/(nsamp*rate)    ! power spectral density
           else
             y(j) = ((1/rate)**2)*(com(i)*conjg(com(i)))    ! transient signal
           endif
           if(.not.power)y(j) = sqrt(y(j))                ! j.h. change
           y(j) = log10( y(j))                       ! take the logarithm
           if(power) y(j)=(y(j)-18.0)*10.0  ! db (m/s**2)**2
           x_work(j)=log10(ff)
        endif
      enddo
      nspec=j                                                                 
      return                                                                    
      end                                                                       



      subroutine one_traceplot                                                  
     *(x0,y0,nsamp,stat,comp,nflag,flag)                                  
c                                                                               
c                                                                               
c   plots a trace of data in a fixed frame                                      
c                                                                               
c   input:   x1,x2,y1,y2: frame and size of plot                                
c            n:     number of points  in input vector y                         
c            y:     n samples                                                   
c            xo:    time of first sample (sec)                                  
c            nflag: number of flags to be plotted along trace                   
c            flag:  time of flags to plotted along trace, in same               
c                   time scale as xo.                                           
      implicit none
      include 'seiplot.inc'
      include 'mulplt.inc'
      integer nsamp,nflag,imax                                                
      real x0,y0,flag(1)                                              
      character*80 text
      character*5 stat
      character*4 comp
      real x                    ! help variable
      integer i
c                                                                               
c  define some plot options                                                    
c                                                                               
      pframe=1                                                                  
      paxis=1                                                                   
      pmax=3             ! plot max count at end of trace                                                                    
      ppick=0                                                                   
      over_scale=1.0                                                            
      trace_delay=0.0                                                           
      first=1                                                                   
      last=nsamp   
c
c   set first second and minute of plot axis, use main header values
c
      fsec=wav_sec(wav_first)
      fmin=wav_min(wav_first)
c
c   get page time and trace delay
c
      page_time=wav_total_time
c
c   the trace delay is normally given by wav_delay, however if channels
c   rotated, there might be a further delay due to horizontal 
c   channels not starting at the same time
c
       if(rotate) then
          trace_delay=wav_out_start(1)
       else
          trace_delay=wav_delay(wav_current_chan(1))
       endif
c                                                             
      xpos=x0                                                                  
      ypos=y0
      numb_samp=nsamp
c                                                                               
c   plot header on top trace                                                    
c                                                                               
      if(ptitle.eq.1) then                                                      
         call xchars(head,80,xpos,ypos+height+20)                               
      endif                
c
c   plot station and component
c
      comp=wav_comp(wav_current_chan(1))
      if(wav_rot_comp(wav_current_chan(1)).ne.' ') ! could be rotated
     *comp(4:4)=wav_rot_comp(wav_current_chan(1))

      call xchars(stat,5,5.0,ypos+height/2+15.0)
      call xchars(comp,4,5.0,ypos+height/2-15.0)  
c
c   plot trace
c
      dc_chan=0.0        ! to ensure that dc is calculated for each new plot
      call plotw                                                                
c
c   plot max value
c
      call fontsize(0,1.5)
      imax=max+0.5
      write(text,'(i10)') imax
c-- tektronics
      call tchars(text,10,880.0,ypos+height-22)
c-- postscript
      call pchars(text,8,930.0,ypos+height-5)
      call fontsize(0,3.0)
c
c   plot baz if rotation
c
      if(rotate) then
         write(text,'(a,i4)') 'baz',int(baz(current_chan))
         call tchars(text,7,140.0,ypos+height-22)
         call pchars(text,7,140.0,ypos+height-5)
      endif
c
c                                                                               
c   plot flags                                                                  
c                                                                               
      if (nflag.ne.0) then                                                      
         do  i=1,nflag                                                         
            x=(flag(i)+trace_delay)*xscale+xpos
            call xmovabs(x,ypos)                                            
            call xdrwabs(x,ypos+height)                                        
            call xdrwabs(x-9.0,ypos-9.0+height)                                 
            call xmovabs(x,ypos+height)                                         
            call xdrwabs(x+9.0,ypos-9.0+height)                                
         enddo                                                               
       endif                                                                  
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc    
      subroutine out_text
     *(text,ntext,column_width,ncolumn,line_dist,x0,y0)
c
c  plotting out lines of text. each element in text contains one
c  column of text of width column_width. ncolumn groups are then plotted
c  out pr line starting at position
c  lower left hand cornor x0,y0 (tek units). distance between lines is 
c  line_dist, can be negative to move other way
c
      implicit none
      character*80 text(*)
      character*80 one_line
      integer ntext,ncolumn,k,l,column_width
      real x0,y0,x,y
      real line_dist
c
      x=x0
      y=y0
      k=1
      dowhile(k.le.ntext)
         do l=1,ncolumn
            one_line((l-1)*column_width+1:l*column_width)=
     *      text(k)(1:column_width)
            k=k+1
         enddo
         call xchars(one_line(1:ncolumn*column_width),
     *   ncolumn*column_width,x,y)
         y=y+line_dist
      enddo
c
      return
      end
c

      subroutine make_new_sdata(infile,data,nhead,nrecord)
c
c   makes an internal s-file with just the waveform file name

c       input:  infile : waveform file name
c       output: data   : standard data array
c               nhead, nrecord: standard  variables
c
       implicit none
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'
       include 'waveform.inc'
       character*80 data(*)
       integer nrecord, nhead
       character*80 infile

      wav_filename(1)=infile
c
c   read main header for one file
c	  
      call wav_init
      call read_wav_header(1)
      if(wav_error_message.ne.' ') then
         write(6,'(1x,a)') wav_error_message
         stop
      endif
c
c   output header line 
c
      data(1)=' '
      write(data(1),'(1x,i4,1x,2i2,1x,2i2,1x,f4.1,1x,a1)')     
     *wav_year(wav_first),wav_month(wav_first),
     *wav_day(Wav_first),wav_hour(wav_first),
     *wav_min(wav_first),wav_sec(wav_first),'L'
      data(1)(80:80)='1'
c
c  waveform file name
c
      data(2)=' '
      write(data(2)(2:79),'(a)') infile(1:78)
      data(2)(80:80)='6'
      data(3)=' '
      nhead=2
      nrecord=3
c
      return
      end




ccccccccccccccccccccccccccccccccccccc

      subroutine sfilname
     *(year,month,day,hour,min,sec,base,type,name,length)
c
c
c
c updates
c jh  jul 10 93: agency for REA
c     sep 14   : bug with default agency
c     dec 94   : enable local directory name of base is .
c     jan 11   : new get def base
c     jan 13 98: *********   year 2000 *********************
c     jan 25   : local base can also be ,,,
c     aug      : ----------   version 7.0 check ------------------
c              : only long s-file names, 5 letter base
c     sep 22   : fix bug in file name
c     oct 16   : one more bug
c     sep 30 99: add subroutine check_id
c     mar 07 01: init name before setting it, Linux problem
c     apr 08 01: variable length of name
c
c   makes s file name from year month etc
c
c     base: 5 letter data base
c     type: event type e.g. L
c     name: s file name
c     length: char lenght of name
c
      implicit none
c-- top dir
      character*60 top_directory
c-- date and time
      integer year,month,day,hour,min,sec
c-- base name
      character*5 base
c-- def base 
      character*5 def_base
c-- directory to make
      character*(*) name
      character*80 xname
c-- dircetory character \ or /
      character*1 dchar
c-- event type
      character*1 type
c--
      integer length
c-- help variables
      integer id,i
c
      call dir_char(dchar)
c
c
c  get input
c
c
c   get top dir
c
      call topdir(top_directory)
      id=index(top_directory,' ')-1
c
c   getdef base 
c
      call get_def_base(def_base)
c
c   use agency as default
c
      if(base.eq.'     ') base=def_base
c
c   make start of name
c
      name=' '
      name(1:id)=top_directory(1:id)
      name(id+1:id+1)=dchar
      name(id+2:id+4)='REA'
      name(id+5:id+5)=dchar
      name(id+6:id+10)=base
      name(id+11:id+11)=dchar
      write(name(id+12:id+15),'(i4)') year
      name(id+16:id+16)=dchar
      write(name(id+17:id+18),'(i2)') month
      name(id+19:id+19)=dchar
      write(name(id+20:id+26),'(i2,a,2i2)')day,'-',hour,min
c
      write(name(id+27:id+38),'(a,i2,a,a,i4,i2)')'-',
     *sec,type,'.S',year,month
      do i=1,id+38
         if(name(i:i).eq.' ') name(i:i)='0'
      enddo
      length=id+38
c
c   cut out start of name if base is ,, to indicate local
c   directory
c
      if(base(1:2).eq.',,') then
         xname(1:length-id-19)=name(id+20:length)
         do i=1,80
           name(i:i)=' '
         enddo
         name=xname
         length=length-id -19
      endif
      return
      end
c
c 
c
      subroutine check_id(sfilname,event_id,idline,err)
c
c   compare sfile name with id line,and event type, return err=0 if ok, else,1
c   jh sep 99
c    
      implicit none
      character*80 sfilname,idline
      character*1 event_id
      integer l           ! length of s-file name
      integer err
      integer seiclen
c
      err=0
c
      l=seiclen(sfilname)
      if(sfilname(l-18:l-17).ne.idline(67:68)) err=1   ! day
      if(sfilname(l-15:l-12).ne.idline(69:72)) err=1   ! hour min
      if(sfilname(l-10:l- 9).ne.idline(73:74)) err=1   ! sec
      if(sfilname(l- 5:l- 2).ne.idline(61:64)) err=1   ! year
      if(sfilname(l- 1:l   ).ne.idline(65:66)) err=1   ! month
      if(sfilname(l- 8:l- 8).ne.event_id)      err=1   ! id, L, R or D

c
      return
      end
c

c
c  Program to make a jhd phase input file form a Nordic file
c
c  Brian Baptie, 2004
c
      implicit none
      CHARACTER*80 DATA(2500)                                                  
      CHARACTER*80 infile                                                     
      CHARACTER*5 stations(2500)                                                  
      CHARACTER*1 TYPE,EXP                                                      
      character*80 station_file
      integer nstat,nphase,nhead,nrecord
      integer sta_list_count
c---number of arguments 
      integer nars
c-- arguments
      character*80 args(10)
      integer n,id
c--compact or not
      logical compact
      logical error

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      error=.false.

c 
c   check if input from file given in argument
      call get_arguments(nars,args)
      if(nars.eq.0) then
         write(6,*)' You must give input file as argument'
         stop
      endif
c
c     case with output on standard output
c
      if(nars.gt.2) then        !JAB(BGS)Mar95. Definitely too many
         write(6,*)' Too many arguments'
         stop
      endif
c
c   output file
c
      open(2,file='phase.dat',status='unknown')
c
c   get input file name
c
      infile=args(1)
      open(1,file=infile,status='old')
c
c   check that not a compact file
c
      call nortype(1,compact)
      if(compact) then
         write(6,*)' Input file is compact, cannot be used'
         stop
      endif
c     
c   read and write to end of file
c
      n=0
 10   continue
c
c   read one event in nordic format
c
      CALL INDATA(1,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      if(nrecord.eq.0) goto 99
c
c   convert phase readings to hypodd input format and write out 
c
      call nor2dd(2,n+1,nrecord,nhead,data,stations,sta_list_count)
      n=n+1
      goto 10
c
 99   continue
      write(6,*)
      write(6,*)' The input file had ',n,' events'
        
      close(1)
      close(2)

c
c find the appropriate station file and check its existence
c
c      call get_station_file(station_file,error)
c      if (error) then
c         stop
c      endif
c     
c find the stations corresponding to those in the station list and
c write out jhd format stalist.elev file containing station details
c        
c      call write_station_output(station_file,
c
c changed to use stat_loc to get location, lot 31/5/2005
c
      call write_station_output(
     1     stations,sta_list_count,error)
      if (error) then
         stop
      endif
c
c extract velocity model parameters from the station file and
c write out jhd format syn.vel velocity model file
c       
c      call get_velocity_model(station_file,error)
c      if (error) then
c         stop
c      endif


      stop
      end
                       

c
c
      subroutine nor2dd(unit,nevent,nrecord,nhead,data,stations,
     1     sta_list_count)
	  
c
c   gets one event in nordic format in array data and writes it to unit
c   in hypoinverse format
c
      implicit none
      character*80 data(*)                                                  
      character*5 stations(*)
      integer sta_list_count
      integer nrecord,unit,nhead,nevent
      integer year,month,day,hour,min
      integer p_weight
      real head_sec, p_sec, p_diff
      real lon,lat,depth
      real weight
      real eh,ez,rms,mag
      double precision head_time,p_time ! abs times for header and phase
      integer j,k
      logical station_in_list


c
c   read origin time
c
      read(data(1),'(1x,i4,1x,2i2,1x,2i2,1x,f4.1)') 
     *year,month,day,hour,min,head_sec

      read(data(1)(31:38),'(f8.3)') lon 
      read(data(1)(24:30),'(f7.3)') lat
      read(data(1)(39:43),'(f5.1)') depth 
      read(data(1)(53:55),'(f3.1)') rms 
      read(data(1)(57:59),'(f3.1)') mag 
      eh=0.0
      ez=0.0

c write out origin details
      write(unit,101) year,month,day,hour,min,head_sec,lat,lon,
     *depth,mag,eh,ez,rms,nevent

 101  format('#',1x,i4,1x,i2,1x,i2,1x,i2,1x,i2,1x,f4.1,1x,f7.3,
     1     1x,f8.3,1x,f5.1,1x,f3.1,1x,f3.1,1x,f3.1,1x,f3.1,1x,i4)
c
c   get header abs time
c
      call timsec(year,month,day,hour,min,head_sec,head_time)

c
c   read phases to end of event
c
      do k=nhead+1,nrecord-1

c For each P-phase calculate the phase time relative to the origin time
         if(data(k)(11:11).eq.'P'.or.data(k)(11:11).eq.'S') then
c            read(data(k)(19:28),'(i2,i2,1x,f5.2)') hour,min,p_sec
            read(data(k)(19:22),'(2i2)') hour,min
            read(data(k)(23:28),'(f6.3)') p_sec
            read(data(k)(15:15),'(i1)') p_weight
            if(p_weight.eq.0) then
               weight=1.0
            else if(p_weight.eq.1) then
               weight=0.75
            else if(p_weight.eq.2) then
               weight=0.5
            else if(p_weight.eq.3) then
               weight=0.25
            else if(p_weight.eq.4) then
               weight=0.0
            endif
            call timsec(year,month,day,hour,min,p_sec,p_time)
            p_diff=p_time-head_time ! phase time relative to header time
            p_sec=head_sec+p_diff   ! phase second relative to header second  

c write out the formatted phase output

            station_in_list=.false.
            do j=1,sta_list_count
               if(data(k)(2:5).eq.stations(j)(1:4)) then
                  station_in_list=.true.
               endif
            enddo
            if(.not.station_in_list) then
               sta_list_count=sta_list_count+1
               stations(sta_list_count)(1:5)='     '
               stations(sta_list_count)(1:4)=data(k)(2:5)
            endif

            write(unit,100) data(k)(2:5),p_diff,weight,data(k)(11:11)

         endif
      enddo

      return


 100  format(a4,1x,f6.2,1x,f4.2,1x,a1)

      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C GET_STATION_FILE 
C
C Finds the STATION0.HYP file either in the local directory or in the 
C SEISAN_TOP/DAT directory
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine get_station_file(station_file,error)

      integer itp
      character*80 cur_file        ! station file in current directory
      character*80 dat_file        ! station file in DAT directory
      character*80 station_file
      character*60 top_directory   ! seisan top dir
      character*1 dchar            ! '/' character
      logical error

      error=.false.
c
c   find station file to use
c
      call dir_char(dchar)
      call topdir(top_directory)
      ITP=index(top_directory,' ')-1
c
c  make file name for both file in current and dat directory
c
      cur_file(1:12)='STATION0.HYP'
      dat_file(1:itp)=top_directory(1:itp)	  
      dat_file(itp+1:itp+1)=dchar
      dat_file(itp+2:itp+4)='DAT'	  
      dat_file(itp+5:itp+5)=dchar
      dat_file(itp+6:itp+17)=cur_file(1:12)	  	  
      open(999,file=cur_file,status='old',err=1)
      write(6,2001) cur_file(1:12)
      station_file=cur_file
      goto 2
 1    continue	  
      OPEN(999,FILE=dat_file,STATUS='OLD',err=3)
      write(6,2001) dat_file(1:itp+17)
      station_file=dat_file
      goto 2
 3    continue
      write(6,*)' No station file found'
      error=.true.

 2    continue
      close(999)

 2001 format (' Using station file ', a)


      return

      end



CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C WRITE_STATION_OUTPUT write out JHD stat.evel file
C
C Given a list of station names this program
C finds the corresponding entry in the STATION0.HYP file
C and writes out station data in JHD format
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c      subroutine write_station_output(station_file,
c     1     stations,sta_list_count,error)
      subroutine write_station_output(
     1     stations,sta_list_count,error)
      implicit none

      character*80 station_file
      CHARACTER*5 stat
      CHARACTER*5 stations(*)
      integer sta_list_count
      character*80 line         ! one line

      integer ilat, ilon
      real dec_lat, dec_lon, mlat, mlon, elev,el
      character*1 dlat, dlon, file_ind

      integer i,j

      logical error
      
      error=.false.
c
c open input and output files
c
c      open(10,FILE=station_file,STATUS='OLD',err=98)
      open(3,file='station.dat',status='unknown',err=99)

      file_ind=' '
      do i=1,sta_list_count
         call stat_loc(stations(i),file_ind,dec_lat,dec_lon,el)
         if (dec_lat.ne.0..and.dec_lon.ne.0.) then
           write(3,100) stations(i), dec_lat, dec_lon
         else
           write(6,'(a)') ' station not found '//stations(i)
         endif
      enddo
      return
 100  format(1x,a4,1x,f8.4,1x,f9.4)
           
c         rewind(10)
c         do j=1,1000
c            read(10,'(a27)') line
c            if(stations(i)(1:4).eq.line(3:6)) then
c               read(line(7:27),'(i2,f5.2,a1,i3,f5.2,a1,f4.0)') 
c     &              ilat, mlat, dlat, ilon, mlon, dlon, elev
c               elev=elev/1000.
c               dec_lon=real(ilon)+(mlon/60.0)
c               if(dlon.eq.'W') then
c                  dec_lon=-1.0*dec_lon
c               endif
c               dec_lat=real(ilat)+(mlat/60.0)
c               if(dlon.eq.'S') then
c                  dec_lat=-1.0*dec_lat
c               endif
c               write(3,100) stations(i), dec_lat, dec_lon
c               goto 11
c            endif
c         enddo
c         
c 11      continue
c      enddo
c
c      close(3)
c      close(10)
c
c      return
c
c 100  format(1x,a4,1x,f8.4,1x,f9.4)
c
c 98   write(6,*) 'Error opening station file ', station_file
c      error=.true.
c      return
 99   write(6,*) 'Error opening output file station.dat'
      error=.true.
      return
      end


CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C Subroutine to read the velocity model from a STATION0.HYP file
C
C Requires the name of the file as an input argument
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      subroutine get_velocity_model(station_file,error)


      character*80 station_file    ! station file
      character*80 line            ! one line

      real xnear,xfar,startz,vpvs
      real vel(100), z(100)

      integer nlayers
      integer i

      logical error

      error=.false.
c     
c open input and output files
c
      open(10,FILE=station_file,STATUS='OLD',err=98)
      open(4,file='syn.vel',status='unknown',err=99)

      rewind(10)
c
c Find first blank line
c
 12   read(10,'(a)') line
      if (line(1:10).ne.'          ') then
         goto 12
      endif
c
c Find second blank line
c
 13   read(10,'(a)') line
      if (line(1:10).ne.'          ') then
         goto 13
      endif
c
c read velocity model
c
      i=0
      read(10,'(a)') line
 30   continue
      i=i+1
      read(line,'(2f8.3)') vel(i),z(i)
      read(10,'(a)') line
      if(line(1:10).ne.'          ') goto 30
      nlayers=i

c
c  vp/vs, start depth and distance weight
c
      read(10,'(3f5.0,f5.2)') startz,xnear,xfar,vpvs

c write velocity structure to output file
      do i=1,nlayers
         write(4,*) z(i), vel(i), vpvs
      enddo

      close(10)
      close(4)

      return

 98   write(6,*) 'Error opening station file ', station_file
      error=.true.
      return
 99   write(6,*) 'Error opening output file syn.vel'
      error=.true.
      return

      end

      program congap
c
c program to check completeness of continuous data,
c all input is read from congap.par
c
c
c Lars Ottemoller, BGS, July 2008
c

c
c changes:
c

      implicit none 

c
c read SEISAN include files
c
      include 'seidim.inc'   ! dimensions
      include 'seisan.inc'   ! general seisan parameters
      include 'libsei.inc'
      include 'waveform.inc' ! for waveform handling
      include 'rea.inc'      ! for waveform handling
      integer seiclen

      character*80 outfile   ! name of output seisan  waveform file
      character*80 text  
      character*1040 theader ! seisan channel header
      character*80 fheader(max_trace) ! seisan waveform main header
      character*29 headtext
      character*5 net_code   ! code of network
      real duration_min      ! minute
      integer i,j,l,k        ! counter
      integer maxstat,maxtrig
      parameter (maxstat=100)
      character*5 station(maxstat),cbase(maxstat)
      character*4 component(maxstat)
      integer ind
      double precision msec_start,msec_stop,msec,trigger_msec,msec1
      character*14 stop_time,start_time,time
      integer year1,month1,day1,hour1,min1,isec1,doy1
      integer year2,month2,day2,hour2,min2,isec2,doy2
      real sec1,sec2
      integer write1,write2,write3,read1
      logical b_flag
      integer code
      integer nchan,nbase
      integer narg
      character*80 arg(40)
      real rate
      integer nz,nzt
      logical gap_flag
      real expected_time(max_trace)
      real actual_time(max_trace),atime

c
c   get seisan defaults including names of continuous waveform data bases
c
      call get_seisan_def 
c
c get arguments
c
      call get_arguments(narg,arg)
      do j=1,narg
        if (arg(j).eq.'-start') then   
          start_time=arg(j+1)
        elseif (arg(j).eq.'-stop') then   
          stop_time=arg(j+1)
        elseif (arg(j).eq.'-cbase') then
          cbase(1)=arg(j+1)
          nbase=1
        elseif (arg(j).eq.'-interval') then
           call sei get values(1,arg(j+1), code )
           duration_min=array$(1)
        endif
      enddo
      if (narg.lt.8) 
     &call get_contdet_def(nbase,cbase,start_time,stop_time,
     &   duration_min)

c
c open files
c
      call sei open( unknown$,          ! Open old file.
     &               ' ',               ! No prompt.
     &               'congap.out',    ! This filename.
     &               write1,            ! On this unit.
     &               b_flag,            ! Existance?.
     &               code )             ! Returned consition (n/a)

c
c init variables 
c
      if (cbase(1).eq.' ') then
        write(*,*) ' Name of continuous database '
        read(5,'(a)') cbase(1)
      endif

      if (start_time.eq.' ') then
        write(*,*) ' Start time (yyyymmdd...) '
        read(5,'(a)') start_time
      endif

      if (stop_time.eq.' ') then
        write(*,*) ' Stop time (yyyymmdd...) '
        read(5,'(a)') stop_time
      endif

      if (duration_min.eq.0.) then
        write(*,*) ' Duration in min '
        read(5,*) duration_min
      endif

      if (station(1).eq.' ') then
        write(*,*) ' Station '
        read(5,'(a)') station(1)
      endif

      if (component(1).eq.' ') then
        write(*,*) ' Component '
        read(5,'(a)') component(1)
      endif

      write(*,*) ' start time: ',start_time
      write(*,*) ' stop time:  ',stop_time

      do i=1,max_trace
        expected_time(i)=0.
        actual_time(i)=0.
      enddo
c
c loop over stations
c
      nchan=0
      do k=1,nbase
c
c init
c
        cont_base(1)=cbase(k)
        n_cont_trace=0

        write(*,*) ' Database: ',cbase(k)

c
c  signal that reading is from a continous data base
c
        cwav=.true.
        n_cont_base=1
c
c   calculate end time and extended start time, needed in order to
c   make sure enough files read in
c
        cwav_start_time=start_time

        read(start_time,'(i4,5i2)') year1,month1,day1,hour1,min1,isec1
        sec1=float(isec1)
        call timsec(year1,month1,day1,hour1,min1,sec1,msec_start)

c 
c compute overall endtime
c
        read(stop_time,'(i4,5i2)') year2,month2,day2,hour2,min2,isec2
        sec2=float(isec2)
        call timsec(year2,month2,day2,hour2,min2,sec2,msec_stop)

c
c set initial values
c
        call cwav_time_limits(0)
        cwav_abs_start_time=msec_start
        cont_interval=duration_min*60.

        do while(cwav_abs_start_time.lt.msec_stop)

c
c set end of interval to be read
c
          call cwav_time_limits(1)
c
c  read the header information for all files in bases in time
c  interval, assume info available in common block
c
          cwav_abs_end_time=cwav_abs_start_time+cont_interval
          call cwav_read_bases     

          call sectim(cwav_abs_start_time,year1,doy1,month1,day1,hour1,
     &    min1,sec1)
          call sectim(cwav_abs_end_time,year2,doy2,month2,day2,hour2,
     &    min2,sec2)
          write(*,'(a,i4,"/",i2,"/",i2," ",i2,":",i2,":",f5.2)')
     &    ' start time: ',year1,month1,day1,hour1,min1,sec1
          write(*,'(a,i4,"/",i2,"/",i2," ",i2,":",i2,":",f5.2)')
     &    ' stop time:  ',year2,month2,day2,hour2,min2,sec2
c
c find channel index
c
          do i=1,n_cont_trace
            ind=0
            do j=1,nchan
              if (cwav_stat(i).eq.station(j).and.
     &            cwav_comp(i).eq.component(j)) 
     &        then
                ind=j
              endif
            enddo
c new channel
            if (ind.eq.0) then
              nchan=nchan+1
              ind=nchan
              station(nchan)=cwav_stat(i)
              component(nchan)=cwav_comp(i)
            endif
c
c count expected time
c
            expected_time(ind)=expected_time(ind)+cont_interval 

c
c  read the waveform data, one trace at a time
c
            call wav_read_channel(i)    ! read trace

c            wav_nsamp(i)=wav_nsamp(i)-1  ! removed 12/08/2008
            rate = wav_rate(i)
            if (wav_nsamp(i).lt.0) then
              wav_nsamp(i)=0
            endif
c
c check for gap, which has constant level for more than 1 s
c
            gap_flag=.false.
            nz=0
            nzt=0
            do j=2,wav_nsamp(i)
              if (signal1(j).eq.signal1(j-1)) then
                nz=nz+1
c                if (.not.gap_flag) then
c                  write(*,*) ' gap, start sample ',j
c                  write(*,*) signal1(j),signal1(j-1)
c                endif
                gap_flag=.true.
              else
                if (gap_flag) then
                  if (float(nz)/rate.gt.1.) then
                    nzt=nzt+nz+1
                    write(*,*) ' gap, end sample  ',j,nz
                  endif
                endif
                nz=0
                gap_flag=.false.
              endif
            enddo

c            rate = cwav_rate(i,cwav_nseg(i))

            write(*,*) ' channel number: ',i
            write(*,*) ' total samples: ',wav_nsamp(i)
            write(*,*) ' sampling rate: ',rate
            write(*,*) ' duration: ',float(wav_nsamp(i))/
     &                               rate
            write(*,*) ' gap duration: ',float(nzt)/rate
            atime=float(wav_nsamp(i)-nzt)/rate
            actual_time(ind)=actual_time(ind)+atime
             write(write1,
     &       '(a5,1x,a3,1x,i4,2i2.2,1x,2i2.2,f5.2,1x,f9.2,1x,f9.2)')
     &        station(ind),component(ind)(1:2)//component(ind)(4:4),
     &        year1,month1,day1,hour1,min1,sec1,atime,cont_interval
          enddo ! loop over traces
c
c set start of next interval to read
c
          cwav_abs_start_time=cwav_abs_end_time
        enddo ! loop over time
      enddo ! end of loop over stations

      write(*,'(a)') ' -------------------------------------------- '
      write(*,'(a)') '  # stat comp       actual     expected     % '
      write(*,'(a)') ' -------------------------------------------- '
      do i=1,nchan
        write(*,'(i3,1x,a5,1x,a3,1x,f12.2,1x,f12.2,1x,f5.1)') 
     &      i,station(i),
     &      component(i)(1:2)//component(i)(4:4),
     &      actual_time(i),expected_time(i),
     &      actual_time(i)/expected_time(i)*100.
      enddo
      write(*,'(a)') ' -------------------------------------------- '
c
c close files
c
      call sei close( close$, write1, code )

      stop
      end

      subroutine get_contdet_def(nbase,cbase,startdate,stopdate,
     &   duration)

      implicit none
      include 'libsei.inc'
      include 'seidim.inc'

      character*80 def_file         ! file names
      integer in                    ! file unit
      integer code                  ! return code from opening def file
      integer i                     ! counter
      character*80 line             ! text line
      real var                      ! value of variables
      integer nbase                 ! station counter
      integer seiclen

      character*(*) cbase(*),startdate,stopdate
      real duration
   
c
c check for file end open
c

      def_file = 'congap.par'

      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   in,              ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   def_file )       ! For this filename.

      if(code.ne.e_ok$) then
        write(*,*) ' definition file does not exist: congap.par'
        stop
      endif
c
c init values
c
      cbase(1)=' '
      startdate=' '
      stopdate=' '
      duration=60.
      nbase=0  ! station counter


100   continue

c
c read text line from file, check for code and set variables
c
      read(in,'(a)',end=300,err=200) line

      if (line(1:10).eq.'START DATE') then
        read(line(41:54),'(a)') startdate
      elseif (line(1:9).eq.'STOP DATE') then
        read(line(41:54),'(a)') stopdate
      elseif (line(1:9).eq.'CONT BASE') then
        nbase=nbase+1
        read(line(41:45),'(a)') cbase(nbase)
      elseif (line(1:8).eq.'INTERVAL') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) duration=var
      endif

      goto 100

200   continue
      write(*,*) ' Error in congap.par file'

300   continue
      call sei close( close$, in, code )

      return
      end

c$DEBUG
c
c  changes
c
c  jun 99 jh   : ---------  version 7.0 -------------------
c  sep 27 bmt  : output file format
c                add version number
      PROGRAM ATNOR
      DIMENSION AF(3000),PARS(11),rr(30),TT(30)
      DIMENSION AC(10,50,50)
      DIMENSION SLA(30)
      CHARACTER*30 AD,at
      REAL MMIN,MMAX,MAG
      COMMON/FREC/FFI,FFF,NF,DFF
C


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      WRITE (*,*) 'GIVE INPUT FILE NAME '
      READ (*,5000) AD
      WRITE (*,*) 'GIVE TABLE FILE NAME '
      READ (*,5000) At
5000  FORMAT ( A )
      OPEN (5,FILE=AD,STATUS='OLD')
      OPEN (7,FILE=at,STATUS='UNKNOWN')
C
      READ (5,5200) NTM
      WRITE (*,*) NTM
      READ (5,5100) (PARS(I),I=1,11)
      write (*,6000) (pars(i),i=1,11)
      READ (5,5100) RMIN,RMAX,MMIN,MMAX,TMIN,TMAX
      write (*,6000) rmin,rmax,mmin,mmax,tmin,tmax
      READ (5,5200) MR,NM,MT
      write (*,5200) mr,nm,mt
      NR=ABS(MR)
      IF (MR .LT. 0) READ (5,5100) (RR(I),I=1,NR)
5100  FORMAT (10F8.0)
5200  FORMAT (10I8)
      NT=ABS(MT)
      IF (MT .LT. 0) READ (5,5100) (TT(I),I=1,NT)
      READ (5,5100) (SLA(I),I=1,NT+1)
C
      FFI=0.02
      FFF=50.
      NF=300
      DFF=(FFF-FFI)/(NF-1)
      DR=(RMAX-RMIN)/(NR-1)
      DM=(MMAX-MMIN)/(NM-1)
      IF (NT .GT. 1) DT=(TMAX-TMIN)/(NT-1)
      WRITE (7,7300) MMIN,DM*(NM-1)+MMIN,NM
      WRITE (7,7301) RMIN,DR*(NR-1)+RMIN,NR
7300  FORMAT (4X,F6.4,2X,F7.4,4X,I5)
7301  FORMAT (4X,F6.4,2X,F8.4,4X,I5)
C

      DO 50 J=1,NM
        MAG=MMIN+(J-1)*DM
        PARS(8)=MAG
        DO 100 I=1,NR
          write (*,*) j,i
          IF (MR .GT. 0) THEN      
             R=RMIN+(I-1)*DR
          ELSE
             R=RR(I)
          ENDIF
          PARS(9)=R   
          IF (NTM .EQ.1) THEN
            CALL MODNO1 (PARS,AF,TS,11)      
          ELSE
            CALL MODNO2 (PARS,AF,TS,11)
          ENDIF
          DO 30 K=1,NT
             IF (MT .GT. 0) THEN
                T=TMIN+(K-1)*DT
             ELSE
                T=TT(K)
             ENDIF
             F0=1./T
             CALL MOMEN (NF,F0,FFI,0.05,DFF,AF,NF,AM0,AM2,AM4)
             CALL AMAXA (AM0,AM2,AM4,TS,F0,0.05,T,ACMAX,VAR,0)
             AC(K,J,I)=ACMAX
30        CONTINUE
C
          CALL ESPVEL (AF,FFI,DFF,NF)
          CALL MOMEN (NF,50.,FFI,0.05,DFF,AF,NF,AM0,AM2,AM4)
          CALL AMAXA (AM0,AM2,AM4,TS,50.,0.05,0.02,VMAX,VAR,0)         
          AC(NT+1,J,I)=VMAX
7000      FORMAT (8(1PE10.3))
6000      FORMAT (7(1PE11.3,1X))              
100     CONTINUE
50    CONTINUE
C
      DO 680 J=1,1
        write (7,'(4X,F6.4,2X,F6.4,2X,I3)') 0.005,SLA(J),500
c        WRITE (7,*) SLA(J)
        DO 660 K=1,NM
          WRITE (7,'(20F10.4)') (AC(J,K,L),L=1,NR)
660	 CONTINUE
680   CONTINUE
C	
C
      CLOSE(5)
      CLOSE(7)
      STOP
      END
C********************************************************************
      SUBROUTINE MODNO1 (PARS,A,TS,NPAEF)
      COMMON/FREC/FFI,FFF,NF,DFF
C
      DIMENSION A(NF),PARS(NPAEF)
C
C     PARS(11)=COEFICIENTE DE LA DURACION, =0.05 O 0.07
C      
      DATA PI/3.14159264/
      DS=PARS(1)
      Q0=PARS(2)
      EX=PARS(3)
      VEL=PARS(4)*100000.
      DNS=PARS(5)
      FM=PARS(6)
      S=PARS(7)
      EMC=10.**(1.5*(PARS(8)+10.7))
      R=PARS(9)*100000.
c
      RFP=0.55*PARS(10)*0.71
      CE=RFP/4.0/PI/DNS/VEL/VEL/VEL
c
      FC=49.1*VEL*(DS/EMC)**(1./3.)
      TS=1./FC+PARS(11)*PARS(9)
c
      IF (PARS(9) .LT. 100.) THEN
        GR=1./R
      ELSE
        GR=1./SQRT(100*PARS(9))/100000.
      ENDIF
C
      DO 200 LL=1,NF
         FIF=FFI+(LL-1)*DFF
         QU=Q0*FIF**EX
         XE=EXP(-PI*FIF*R/QU/VEL)
         XE=XE*GR
         SF1=4.0*PI*PI*FIF*FIF
         SF2=1.0+(FIF/FC)**2
         SF=SF1/SF2
         PF=(1.0+(FIF/FM)**(2*S))**(-0.5)
  200    A(LL)=CE*EMC*SF*PF*XE
      RETURN
      END
c
c*********************************************************************
      SUBROUTINE MODNO2 (PARS,A,TS,NPAEF)
      COMMON/FREC/FFI,FFF,NF,DFF
C
      REAL K,K0,K1
      DIMENSION A(NF),PARS(NPAEF)
C
C     PARS(11)=COEFICIENTE DE LA DURACION, =0.05 O 0.07
C     PARS( 6)=Ko
C     PARS( 7)=K1
C
C     PARAMETROS DE ATENUACION DE SITIO:   K = Ko + K1*R (R en km)
C      
      DATA PI/3.14159264/
      DS=PARS(1)
      Q0=PARS(2)
      EX=PARS(3)
      VEL=PARS(4)*100000.
      DNS=PARS(5)
      K0=PARS(6)
      K1=PARS(7)
      K=K0+K1*PARS(9)
      EMC=10.**(1.5*(PARS(8)+10.7))
      R=PARS(9)*100000.
c
      RFP=0.55*PARS(10)*0.71
      CE=RFP/4.0/PI/DNS/VEL/VEL/VEL
c
      FC=49.1*VEL*(DS/EMC)**(1./3.)
      ts=1./Fc+PARS(9)*pars(11)
c
      IF (PARS(9) .LT. 100.) THEN
        GR=1./R
      ELSE
        GR=1./SQRT(100*PARS(9))/100000.
      ENDIF
C
      DO 200 LL=1,NF
         FIF=FFI+(LL-1)*DFF
         QU=Q0*FIF**EX
         XE=EXP(-PI*FIF*R/QU/VEL)
         XE=XE*GR
         SF1=4.0*PI*PI*FIF*FIF
         SF2=1.0+(FIF/FC)**2
         SF=SF1/SF2
         PF=EXP(-PI*K*FIF)
  200    A(LL)=CE*EMC*SF*PF*XE
      RETURN
      END
c
C*************************************************************************
C
      SUBROUTINE ESPVEL (AF,FFI,DFF,NF)
      DIMENSION AF(NF)
C
      DATA PI/3.141592654/
C
      DO 100 I=1,NF
       F=FFI+(I-1)*DFF
       AF(I)=AF(I)/(2.*PI*F)
100   CONTINUE
      RETURN
      END

      SUBROUTINE QTRAP (FUNC,A,B,S)
      DOUBLE PRECISION A,B,S,EPS,OLDS
      DOUBLE PRECISION FUNC
      EXTERNAL FUNC
      PARAMETER (EPS=1.D-4, JMAX=20)
      OLDS=-1.0D30
      DO 11 J=1,JMAX
	   CALL TRAPZD (FUNC,A,B,S,J)
C	   WRITE (*,*) 'J,S ',J,S
C	   PAUSE
	   IF (DABS(S-OLDS) .LT. EPS*DABS(OLDS)) RETURN
	   OLDS=S
11    CONTINUE
      WRITE (*,1000)
      RETURN
1000  FORMAT ('  *****  WARNING: POSSIBLE LACK OF PRECISION IN INTEGRATI
     *                  ON, SUBROUTINE QTRAP  ****')
      END
C  
c$PAGE
      SUBROUTINE TRAPZD (FUNC,A,B,S,N)
      EXTERNAL FUNC
      DOUBLE PRECISION A,B,S,SUM,X,DEL
      DOUBLE PRECISION FUNC
      IF (N .EQ. 1) THEN
	    S=0.5*(B-A)*(FUNC(A)+FUNC(B))
           IT=1
      ELSE
	    TNM=IT
           DEL=(B-A)/TNM
	    X=A+0.5*DEL
	    SUM=0.0
	    DO 11 J=1,IT
		  SUM=SUM+FUNC(X)
		  X=X+DEL
11         CONTINUE
           S=0.5*(S+(B-A)*SUM/TNM)
	    IT=2*IT
      ENDIF
      RETURN
      END			  		
C
C***********************************************************************
C	  SUBROUTINE TO EVALUATE THE GAUSSIAN PROBABILITY DISTRIBUTION	  
C	  TAKEN FROM ABRAMOWITZ AND STEGUN, HANDBOOK OF MATHEMATICAL
C	  FUNCTIONS, PAGE 932. SHOULD HAVE BEEN A FUNCTION, NOT A SUB-
C	  ROUTINE, BUT THINGS WILL GET CLEARER SOME DAY. (NOVEMBER, 1991)
C
	  SUBROUTINE MDNOR (ARG,P)
	  REAL B(5)
	  DATA B/0.319381530,-0.356563782,1.781477937,
     1      -1.821255978, 1.330274429/
	  T=1./(1.+0.2316419*ABS(ARG))
	  TT=T
	  S=0.0
	  DO 100 I=1,5
	  	S=S+TT*B(I)
		TT=TT*T
100	  CONTINUE
	  S=0.3989423*EXP(-0.5*ARG*ARG)*S
	  IF (ARG .GE. 0.0) THEN
	    P=1.0-S
	  ELSE
	  	P=S
	  ENDIF
	  RETURN
	  END					  
C********************************************************************
      SUBROUTINE MOMEN (NFIN,F0,FFI,Z,DFF,A,NE,AMOM0,AMOM2,AMOM4)
      DIMENSION A(NE)
      DATA PI/3.141592654/
      Z1=FFI/F0
      FMAX=FFI+(NFIN-1)*DFF
      ZM=FMAX/F0
      H1=1./((1.-Z1*Z1)**2+4.*Z*Z*Z1*Z1)
      HM=1./((1.-ZM*ZM)**2+4.*Z*Z*ZM*ZM)
      AMOM0=(A(1)**2*H1+A(NFIN)**2*HM)/2.
      AMOM2=(A(1)**2*H1*FFI**2+A(NFIN)**2*HM*FMAX**2)/2.
      AMOM4=(A(1)**2*H1*FFI**4+A(NFIN)**2*HM*FMAX**4)/2.
      DO 1410 I=2,NFIN-1
       F=FFI+(I-1)*DFF
       Z2=F/F0
       H2=1./((1-Z2*Z2)**2+4*Z*Z*Z2*Z2)
       AMOM0=AMOM0+A(I)**2*H2
       AMOM2=AMOM2+A(I)**2*H2*F**2
       AMOM4=AMOM4+A(I)**2*H2*F**4
 1410 CONTINUE
      P=2*PI
      AMOM0=AMOM0*P/PI*DFF
      AMOM2=AMOM2*P*P*P/PI*DFF
      AMOM4=AMOM4*P*P*P*P*P/PI*DFF
      RETURN
      END
c$PAGE
C********************************************************************
      SUBROUTINE AMAXA (AM0,AM2,AM4,TS,F0,Z,T0,ACMAX,VAR,IND)
      DOUBLE PRECISION FPMAX,EPS,EMAX,EMAX2
      REAL K
      EXTERNAL FPMAX
      COMMON/MAX/EPS,M,NC
      DATA PI,C/3.141592654,0.577215665/
C
      GAMA=TS*F0
      TRMS=TS+(1./Z/F0/2./PI*GAMA**3/(GAMA**3+1./3.))
      ARMS=SQRT(AM0/TRMS)
C
      EPS=SQRT(1.-(AM2**2/AM0/AM4))
      R=0.5*(1.-SQRT(1.-EPS*EPS))
      FM=SQRT(AM4/AM2)/2./PI
C
      ANC=2*FM*TRMS
      NC=ANC
C
C     CUANDO NC .LT. 2, EL ACELEROGRAMA CUYO MAXIMO SE DESEA CALCULAR
C     SE VULEVE INCONCEBIBLE. LA SOLUCION TEORICA EXISTE AUN CUANDO
C     NC = 0, PERO ME PARECE QUE NO TIENE SENTIDO. POR ESTA RAZON SE
C     IMPONE LA SIGUIENTE CONDICION:
C
      IF (NC .LT. 2) NC=2
C
C
      K=SQRT(1.-EPS*EPS)*ANC
      Q=2*ALOG(K)
C     WRITE(*,6100) T0,AM0,AM2,AM4
C     WRITE(*,6200) TRMS,NC,FM,EPS,K,Q
6100  FORMAT (5X,'T0=',F6.3,' MOMENTOS 0,2,4:  ',3(1X,1PE11.4))
6200  FORMAT  (5X,'TRMS = ',F8.3,' NC= ',I5,' FM= ',1PE11.4/
     1         5X,'EPS  = ',1PE11.3,' K = ',1PE11.3,' Q= ',1PE11.3)
      
C
      IF (IND .EQ. 0) THEN
        IF (Q .LE. 2) THEN
C         
C         SE CONSIDERA QUE PARA Q<2 LA APROXIMACION ASINTOTICA NO ES
C         VALIDA, ESPECIALMENTE PARA EL SEGUNDO MOMENTO. LOS VALORES
C         DADOS POR LA APROXIMACION SE CALCULAN SOLO COMO REFERENCIA
C         Y PARA PROBAR QUE TAN BUENA ES LA APROXIMACION.
C
          IF (Q .GT. 0.0) THEN
           ACAP =SQRT(Q)+C/SQRT(Q)
           ACAP2=PI/SQRT(6.0)/SQRT(Q)
           ACAP2=ACAP2*ACAP2+ACAP*ACAP
           ACAP =ACAP*ARMS
           ACAP2=ACAP2*ARMS**2
          ENDIF
C                
C
          WRITE(*,6000) T0,Q,EPS,NC
          M=1
          CALL QTRAP (FPMAX,-5D0,5D0,EMAX)
          M=2
          CALL QTRAP (FPMAX,-5D0,5D0,EMAX2)
        ELSE
          EMAX=SQRT(Q)+C/SQRT(Q)
          EMAX2=PI/SQRT(6.0)/SQRT(Q)
          EMAX2=EMAX2*EMAX2+EMAX*EMAX
        ENDIF
      ELSE
        M=1
        CALL QTRAP (FPMAX,-5D0,5D0,EMAX)
        M=2
        CALL QTRAP (FPMAX,-5D0,5D0,EMAX2)
      ENDIF
C
      ACMAX=EMAX*ARMS
      VAR=EMAX2*ARMS**2
C
      RETURN
C
6000  FORMAT('*******************************************************'/
     1       ' ADVERTENCIA DESDE AMAX: NO ES POSIBLE USAR APROX.'/
     2       ' T0,Q,EPS,NC: ',3(1PE11.3,1X),I5/
     3       '*******************************************************')

      END
C
C*************************************************************
      FUNCTION FPMAX(X)
      IMPLICIT DOUBLE PRECISION (A-H,P-Z)
      DOUBLE PRECISION K
      COMMON/MAX/EPS,MOM,NC
      DATA PI/3.141592654D0/
      K=DSQRT(1D0-EPS*EPS)
      O1=X/EPS
      O2=X*K/EPS
      CALL MDNOR (O1,OP1)
      FIA1=OP1
      CALL MDNOR (O2,OP2)
      FIA2=OP2
      FI3=FI(X)
      FI2=FI(X*K/EPS)
      FI1=FI(X/EPS)
      P=NC*(FIA1-DSQRT(2D0*PI)*K*FI3*FIA2)**(NC-1)
      Q=FI1/EPS+DSQRT(2D0*PI)*K*FI3*( X*FIA2-FI2*K/EPS )
      FPMAX=P*Q*X**MOM
C     WRITE(*,6000) N,E,M,X,FPMAX
6000  FORMAT(3X,'DESDE FPMAX ',I5,1PE11.3,I5,1PE11.3,1X,1PE11.3)
      RETURN
      END
C********************************************************
      FUNCTION FI(X)
      DOUBLE PRECISION X,PI,FI
      DATA PI/3.141592654D0/
      IF (X .GT. 14.0D0) THEN
        FI=0.0D0
        RETURN
      ELSE
        FI=1D0/DSQRT(2D0*PI)*DEXP(-X*X/2D0)
      ENDIF
      RETURN
      END
C**********************************************************

      program statstat
c
c program to do station statistics:
c
c     - number of detections in catalog file for each station
c
c Lars Ottemoller, January 2003
c
c changes:
c

      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common bliock
      integer seiclen

      character*80 data(5000)             ! s-file with data in text array
      character*80 err_text               ! error text
      character*80 infile                 ! input file

      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer nevent                      ! number of events in file
      integer i,j                         ! counter

      integer maxstation                  ! maximum number in arrays
      parameter (maxstation=1000)
      character*5 stations(maxstation)    ! names of stations
      logical stationflag(maxstation)     ! true if station already found
      integer stationcount(maxstation)
      integer nstations                   ! number of stations
      integer ind                         ! index
      real slat,slon,height               ! station coordinates
      integer maxdetect                   ! maximum number of events detected

c
c print version
c
      include 'version.inc'
      out_version_date='September 4, 2003'
      if (version_new) out_version_date=version_date
      call print_ver
                                          ! one 1 station
c
c   open output file
c

       open(2,file='statstat.xy',status='unknown')
       open(3,file='statstat.out',status='unknown')
       open(4,file='statstat.gis',status='unknown')
    
c
c   get input file name, check if exist
c

 9    continue
      write(6,*) 'Give input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old',err=10)
      goto 11
 10    continue
      write(6,*)' No such input file'
      goto 9
 11   continue

      all=.true.                  ! read all parameters
      nevent=0                    ! initialize counter
      nstations=0
      do i=1,maxstation
        stationcount(i)=0
      enddo

c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c

  50  continue
c
c   read all parameters for one event form file unit 1
c
      call rea_event_in(1,all,data,code)
c
c   check if end of file (code=1), if so jump out of loop
c
      if(code.eq.1) goto 1000
c
      nevent=nevent+1               ! count events

c
c   write the whole first header line
c
      write(6,'(a)') data(1)(1:79)

      do i=1,maxstation 
        stationflag(i)=.true.
      enddo 
      do i=1,rea_nphase
c
c add station to array if not included yet
c
        ind=0
        do j=1,nstations
          if (rea_stat(i).eq.stations(j)) ind=j
        enddo
        if (ind.eq.0) then
          nstations=nstations+1
          ind=nstations
          if (nstations.eq.maxstation) then
             write(*,*) ' too many stations '
             stop
          endif
          stations(nstations)=rea_stat(i)
        endif
c
c count phases
c
c        if (rea_phase(i)(2:2).eq.'P'.or.
c     &      rea_phase(i)(2:2).eq.'S') then 
          if (stationflag(ind)) then
            stationcount(ind)=stationcount(ind)+1
            stationflag(ind)=.false.
          endif
c        endif
      enddo
c
c   get next event
c
      goto 50
c
c     end of file
c
 1000 continue

      maxdetect=1
      do i=1,nstations
        if (stationcount(i).gt.maxdetect) maxdetect=stationcount(i)
      enddo
c
c write output
c
      write(3,'(a,i7)') ' Number of events in input file', nevent
      write(3,'(a)') ' List of stations with less than 10% '
     &   // ' detections of the maximum number detected on one '
     &   // ' station: '
      write(4,'(a)') 'station,longitude,latitude,detections'
      do i=1,nstations
        slat=0.
        slon=0.
        if (seiclen(stations(i)).gt.0) then
c          write(*,*) i,stations(i)
          call stat_loc(stations(i),' ',slat,slon,height)
        endif
        if (slat.ne.0..and.slon.ne.0.) then
          write(2,'(f8.3,1x,f8.3,1x,i8,1x,a1,1x,a5)') 
     &      slon,slat,stationcount(i),'#',stations(i)
          write(4,'(a5,2x,a1,f9.3,a1,f8.3,a1,i10)') 
     &      stations(i),',',slon,',',slat,',',stationcount(i)

          if (stationcount(i).le.maxdetect*.1) then
            write(3,'(a5,1x,i5)') stations(i),stationcount(i)
          endif
        endif
      enddo
      write(6,*)            ! blank line
      close(2)              ! close output file
      close(3)              ! close output file
      close(4)              ! close output file
      write(6,*) 'Number of events in input file', nevent
      write(6,*) 'Output file name is statstat.out'
      write(6,*) 'Input file for psxy is statstat.xy'
      write(6,*) 'Input file for arcview is statstat.gis'

      stop
      end

c******************************************************************************
c   
c    used on pc, sun and vax, see commented out lines
c
c    latest update:
c
c    oct 17 91 by jh : increase field for ml to f4.1 in routine updatml
c    jan 7  92       : add routine read_stat_mod
c    jun 21 92    jh,cl: bug in ml calc. alog instead of alog10
c                        new global location changes. 
c    jul 30          : bug in hypout
c    oct 9,12  92    : update_ml also calculates mc magnitude, posible
c                      to calculate if no location if distance is there.
c                      calculate ms
c    oct 13          : small changes, updateml is now called update_mag
c    oct 26          : check for missing stations in print.out
c    nov 22          : use hypocentral distance for ml in update_mag
c    mar 93          : test(8) neg, use log coda squared in mc
c    jul 19    93    : iasp to capital letters
c    nov             : new bl program
c    nov 17    93    : magnitudes bug
c    april 5   94    : deleted hypout, added dlt and isort to hypocent window
c    jun 2           : no ml if no dist
c    oct 14          : limit mb to distances of 11000km
CJAB(BGS)Jan95       : Install file & error handling.
c    jun 2 95 jh     : only calculate Ml if balnk, S or L-phase
c     feb 21 96        : magnitudes on a second line
c    mar 6 96        : change condition for calculaiton of mb, mc and ml
c    mar 11          : add  dist type to second mag line
c    mar 14          : small change to clear_old
c    mar 21          : bug in mb
c    apr 16          : ---------
c    sep 19, 96      : bug average corner frequency, more data on 2 mag line
c    mar 4 97        : increase amplitude files for amp out from 8 to 12
c    mar 18          : in connection with above, move coda: right
c    jan 30    98    : magnitude residuals
c    feb 18          : spectral p velocity 
c    mar 1           : set svelocity to 3.5 if not defined in older data
c    sep  18   98 jh : ---------- seisan version 7.0 check --------------
c                      5 character stations
c
c     oct 28 98 bmt : linux changed, save and *
c    jun 10 99 jh    : add AMP as a valid phase for calculating ml and mb
c    jul 26          : remove routine mb_att since a single file already
c    jul 29          : add use_eev to routine read_stat_model
c    sep 24    lo    : put in edepth and spec_phase to upd_spec
c              jh    : fix new spectral distance
c    sep 27          : replace travel time with kappa in spectral output
c    feb 17 2000 jh  : suppres output if output false
c    oct 24          : clear out old H lines in clear routine
c    oct 26          : bug with spectral average and update: if station
c                      with phase line missing, following spectra not used
c    nov  5          : small correction to write out, only write number
c                      of spectra if more than 0
c    mar 5, 2001 jh  : distance as real
c    may 19          : more accuracy in sdrop and radius
c    may 27          : do not use spectra not P or S in average
c    may 31          : Recalculted spectra not written out !!!!!
c    apr 19 2002 bmt : change maxline=1000
c    apr 13 2003 jh  : implement AMPL, AMPb, AMPS
c    may 7  2003 lo  : ISC amp codes changed to AML, AMb and AMS
c    apr 08 2003 lot : add call to iasp91_filename to get comp de
c    oct 12 2005 jh  : only calculate mb if distance larger than test(57)
c    nov 28 2005 jh  : put ml first, then mc (before opposite)
c    jul 22 2008 lo  : added standard deviation to spec aver computation
c    oct 28 2008 jh  : fix output of cornerf
c
C#################################################################



      SUBROUTINE UPDATE_MAG(DATA,NHEAD,NRECORD,AGENCY,TEST,OUTPUT)
C
C   ROUTINE CALCULATES AVERAGE  MAGNITUDES FOR EVENT WRITTEN
C   IN STANDARD FORMAT IN TEXT ARRAY DATA. MAGNITUDES  ARE
c   WRITTEN IN HEADER
C
C     INPUT:  DATA:    EVENT IN STANDARD FORMAT IN TEXT ARRAY
C             NHEAD:   NUMBER OF HEADER RECORDS IN DATA
C             NRECORD: TOTAL NUMBER OF RECORDS IN DATA         
C             AGENCY:  TYPE AND AGENCY E.G. BER
C             TEST   : RESET TEST FROM HYPOCENT
c             OUTPUT : if true, write to screen
C
C     OUTPUT: DATA:    EVENT IN STANDARD FORMAT IN TEXT ARRAY
C                      WITH AVERAGE LOCAL MAGNITUDE IN HEADER
C
C     CHANGES
C     JAN    91    RAN CHANGED TO PC 
c     aug 7  91    jh  : bugs
c     OCT 10 91 BY J.H.: include local  magnitude using the following
c                      ml = A*log(amp) + B*log(dist) + C * dist + D
c                      where amp is max ground motion o-p in nm, 
C                      dist is hypocentral distance in km 
c     oct 18           : add constant d
c     october 92       : mc and ms calculation
c     nov 22           : use hypocentral distance for ml
c     nov 17 93        : do not overwrite 3. magnitude
c     apr 94           : new hypocent
c     apr 94           : use reset test for magnitudes
c     jun 94           : add mb
c     jul 94           : distance bug
c     nov 95           : error when writing out ms magntude
c     feb 21 96        : magnitudes on a second line
c     jan 28 98    jh  : use hypocentral distance also for coda
c     jan 30           : magnitude residuals
c     apr 11 03    jh  : implement amplitude phases AMPL, AMPB and AMPS
c
      implicit none
      save
c

      include 'hypparm.inc'
      integer nhead,nrecord
c BRL 6/98: changed a,b,c,d to am,bm,cm,dm
      real am,bm,cm,dm
      logical output
      character*3 agency
      character*80 text
c-- amplitude,period, distance, hypocentral distance and coda
      real amp,period,dist,hdist,coda
c-- depth
      real depth
c--number of stations with different magnitudes 
      integer nml,nmc,nms,nmb
c-- help varibles
      integer nrec,icoda,nline,maxline
      real xmag,cmag,smag,bmag,q,cmag1
      logical mag_write          ! true if a posiiton found for writing mag.
C--data
c      CHARACTER*80 DATA(*)
c--single local magnitude
      REAL MAGNITUDE
c--reset test variables
c      real test(*)
      character*5 station(nstats)   ! station list
      character*5 stat              ! one station
      real mag_cor(5,nstats)        ! magnitude residuals,1:C, 2:L, 3:B, 4:S 5:W
      integer kstat                 ! station number currently used
c--counters etc
      integer i,k
      common/hyp/station,mag_cor,nline,maxline
c
      nmc=0
      nms=0
      nmb=0
      nms=0.0
      cmag=0.0
      smag=0.0
      bmag=0.0
      NML=0
      XMAG=0.0
      nline=0
c      maxline=20
      maxline=1000
c
c  get ml parameters
c
      am=test(75)
      bm=test(76)
      cm=test(77)
      dm=test(78)
c
c  read depth
c
      read(data(1)(39:43),'(f5.0)') depth
c
      DO 1 NREC=NHEAD+1,NRECORD-1
          READ(DATA(NREC),'(1x,a5,23X,i4,g7.1,1X,F4.1,25X,f5.0)'
     *    ,err=1234)
     *    stat,icoda,AMP,PERIOD,DIST
c
c   if amp or coda is not zero but distance zero, try to find distance at
c   other line with same station if no location flag set but
c   magntudes calculated, test 106
c
          if((amp.gt.0.0.or.icoda.gt.0).and.dist.eq.0.0.and.
     *    test(106).gt.0.0) then
             do i=nhead+1,nrecord-1
                if(stat.eq.data(i)(2:6).and.data(i)(71:75).ne.' ') 
     *          then
                   read(data(i)(71:75),'(f5.0)') dist
                   goto 1235
                endif
             enddo
          endif
          goto 1235
 1234     continue
          write(6,*)' Something wrong with input record:'
          write(6,'(a)') data(nrec)
          amp=0.0
 1235     continue 
c
c   find station number
c
          do i=1,nstats
            if(station(i).eq.stat) then
               kstat=i
               goto 1245
            endif
          enddo
 1245     continue
c         write(6,*)kstat,mag_cor(1,kstat)
c
c
c   use hypocentral distance
c
          hdist=sqrt(dist*dist+depth*depth)
c
c   must be larger than 1 km
c
          if(hdist.le.1.0) hdist=1.0     ! added april 2003 by jh
c
          coda=icoda
c
c   check if coda and distance available, use log coda squared if
c   coefficient is negative, if too far, do not calculate
c
          if(dist.gt.0.and.icoda.gt.0.and.dist.le.test(57)) then
             if(test(8).gt.0.0) then
              cmag1=test(7)+test(8)*alog10(coda)+hdist*test(9)
             else
              cmag1=test(7)-test(8)*alog10(coda)*alog10(coda)
     *        +hdist*test(9)
             endif
             if(mag_cor(1,kstat).ne.99.0) then
                cmag=cmag+cmag1+mag_cor(1,kstat)
                nmc=nmc+1
             endif
c
c   write distance, coda and mag
c
             if(nline.ge.0.and.output) then
                if(mag_cor(1,kstat).ne.99.0) then
                  if(mag_cor(1,kstat).eq.0.0) then
                     write
     *               (6,'(1x,a7,2x,a,2x,f8.1,3x,a,1x,f8.1,3x,a,f5.1)')
     *               data(nrec)(2:8),' hdist:',hdist,
     *               'coda:    ',coda,'mc = ',cmag1
                  else
                     write     ! write correction
     *               (6,'(1x,a7,2x,a,2x,f8.1,3x,a,1x,
     *               f8.1,3x,a,f5.1,a,f5.2)')
     *               data(nrec)(2:8),' hdist:',hdist,
     *               'coda:    ',coda,'mc = ',cmag1,' + ',
     *               mag_cor(1,kstat)
                  endif
                else
                  write(6,'(1x,a7,a,a)')data(nrec)(2:8),
     *            ' Coda available,',
     *    '       magnitude not used (weighted out)' 
                endif
                nline=nline+1
             endif
             if(nline.gt.maxline) then
               nline=0
               write(6,'('' Return to continue, q to end listing '',$)')
               read(5,'(a)') text
               if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') nline=-1
             endif
          endif
c
c   check if amplitude is available, assume local magnitude if
c   phase is blank, AMPL, L or S, AMP, period less than 5 secs 
c      and distance less than test(57)
c
c
          IF(AMP.GT.0.0.and.period.lt.5.0.and.
     *       dist.gt.0.and.dist.lt.test(57).and.
     *           (data(nrec)(11:11).eq.' '
     *           .or.data(nrec)(11:11).eq.'L'
     *           .or.data(nrec)(11:12).eq.'S '
     *           .or.data(nrec)(11:12).eq.'Sg'
     *           .or.data(nrec)(11:12).eq.'SG'
     *           .or.data(nrec)(11:14).eq.'AMPL'
     *           .or.data(nrec)(11:13).eq.'AML'
     *           .or.data(nrec)(11:14).eq.'AMP ')
    
     *        ) then
             magnitude=am*alog10(amp)+bm*alog10(hdist)+cm*hdist+dm
             if(mag_cor(2,kstat).ne.99.0) then
                XMAG=XMAG+MAGNITUDE + mag_cor(2,kstat)
                nml=nml+1
             endif
            
c
c   write distance, amplitude and magnitude
c
             if(nline.ge.0.and.output) then
                if(mag_cor(2,kstat).ne.99.0) then
                   if(mag_cor(2,kstat).eq.0.0) then
                      write
     *                (6,'(1x,a7,2x,a,2x,f8.1,3x,a,2x,f12.1,3x,a,f5.1)')
     *                data(nrec)(2:8),' hdist:',hdist,
     *                'amp:',amp,'ml = ',magnitude
                   else        ! magnitude correction
                      write
     *                (6,'(1x,a7,2x,a,2x,f8.1,3x,a,2x,f12.1,
     *                3x,a,f5.1,a,f5.2)')
     *                data(nrec)(2:8),' hdist:',hdist,
     *                'amp:',amp,'ml = ',magnitude,' + ',
     *                mag_cor(2,kstat)
                   endif
                else
                  write(6,'(1x,a7,a,a)') data(nrec)(2:8),
     *            ' Amp for ml available, magnitude not used',
     *            ' (weighted out)' 
                endif
                nline=nline+1
             endif
            if(nline.gt.maxline) then
               nline=0
               write(6,'('' Return to continue, q to end listing '',$)')
               read(5,'(a)') text
               if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') nline=-1
            endif
          ENDIF
c
c   check if surface wave magnitude, assume period gt 10 secs, 
c   any amplitude
c
          if(amp.gt.0.0.and.period.gt.10.0.and.dist.gt.0.0.
     *       and.(data(nrec)(11:11).eq.' '.or.
     *            data(nrec)(11:14).eq.'AMPS'.or.
     *            data(nrec)(11:13).eq.'AMS'.or.
     *            data(nrec)(11:14).eq.'AMP ')
     *       ) then
                magnitude=alog10(amp/(1000.0*period))+
     *          1.66*alog10(dist/111.2)+3.3
                if(mag_cor(4,kstat).ne.99.0) then
                   smag=smag+magnitude+mag_cor(4,kstat)
                   nms=nms+1
                endif
c
c   write distance, amplitude and magnitude 
c
             if(nline.ge.0.and.output) then
                if(mag_cor(4,kstat).ne.99.0) then
                   if(mag_cor(4,kstat).eq.0.0) then
                      write
     *                (6,'(1x,a7,2x,a,2x,f8.1,3x,a,2x,f12.1,3x,a,f5.1)')
     *                data(nrec)(2:8),'  dist:',dist,
     *                'amp:',amp,'ms = ',magnitude
                   else
                      write
     *                (6,'(1x,a7,2x,a,2x,f8.1,3x,a,2x,f12.1,
     *                3x,a,f5.1,a,f5.2)')
     *                data(nrec)(2:8),'  dist:',dist,
     *                'amp:',amp,'ms = ',magnitude,' + ',
     *                mag_cor(4,kstat)
                   endif
                else
                  write(6,'(1x,a7,a,a)')data(nrec)(2:8),
     *            ' Amp for ms available, magnitude not used',
     *            ' (weighted out)' 
                endif
                nline=nline+1
             endif
            if(nline.gt.maxline) then
               nline=0
               write(6,'('' Return to continue, q to end listing '',$)')
               read(5,'(a)') text
               if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') nline=-1
            endif
          endif
c
c   mb only up to 100 deg
c   check if mb, only if period lt 5 secs and greater than 0.2 and
c   and distance gt test(57), and one of the phases given below
c
          IF(AMP.GT.0.0.and.period.lt.5.0
     *    .and.period.gt.0.2.and.dist.gt.test(57)
     *    .and.
     *          (data(nrec)(11:11).eq.'P'.or.
     *            data(nrec)(11:14).eq.'AMPB'.or.
     *            data(nrec)(11:13).eq.'AMB'.or.
     *            data(nrec)(11:14).eq.'AMPb'.or.
     *            data(nrec)(11:13).eq.'AMb'.or.
     *            data(nrec)(11:14).eq.'AMP '.or.
     *            data(nrec)(11:11).eq.' '
     *          )) then
               if(dist.gt.11000) then
                 write(6,'(1x,a,1x,a)')
     *           data(nrec)(2:8), ' Station too far for mb'
               else
c
c   get attenuation term
c           
                 call mb_att(depth,dist/111.2,q)
                 magnitude=alog10(amp/period)+q
                 if(mag_cor(3,kstat).ne.99.0) then
                    bmag=bmag+magnitude+mag_cor(3,kstat)
                    nmb=nmb+1
                 endif
c
c   write distance and depth
c
                 if(nline.ge.0.and.output) then
                    if(mag_cor(3,kstat).ne.99.0) then
                       if(mag_cor(3,kstat).eq.0.0) then
                          write(6,'(1x,a7,2x,a,2x,
     *                    f8.1,3x,a,2x,f12.1,3x,a,f5.1)')
     *                    data(nrec)(2:8),'  dist:',dist,
     *                    'amp:',amp,'mb = ',magnitude
                       else
                          write(6,'(1x,a7,2x,a,2x,
     *                    f8.1,3x,a,2x,f12.1,3x,a,f5.1,a,f5.2)')
     *                    data(nrec)(2:8),'  dist:',dist,
     *                    'amp:',amp,'mb = ',magnitude,' + ',
     *                    mag_cor(3,kstat)
                       endif
                    else
                       write(6,'(1x,a7,a,a)')data(nrec)(2:8),
     *                 ' Amp for mb available, magnitude not used',
     *                 ' (weighted out)' 
                    endif           
                    nline=nline+1
                 endif
                 if(nline.gt.maxline) then
                   nline=0
                   write
     *             (6,'('' Return to continue, q to end listing '',$)')
                   read(5,'(a)') text
                   if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') nline=-1
                 endif
             endif
          endif
 1     CONTINUE
c
c   write ml in first mag position if mag available
c
       if(nml.ne.0) then
          xmag=xmag/nml
          if(xmag.lt.-10.0.or.xmag.gt.10.0) xmag=-9.9
          write(data(1)(56:63),'(f4.1,a1,a3)')xmag,'L',agency
       endif
c
c
c   check if mc magnitude is available, if  mag  in first pos. write
c   in second postion, else first.
c 
       IF(NMC.NE.0) THEN
          CMAG=CMAG/NMC
          if(cmag.lt.-10.0.or.cmag.gt.10.0) cmag=-9.9
          if(data(1)(60:60).ne.' ') then
             write(data(1)(64:71),202) cmag,agency
          else
             write(data(1)(56:63),202) cmag,agency
 202         format(f4.1,'C',a3)
          endif
       endif
c
c   check if ms is available, write in first available position
c
       if(nms.gt.0) then
          smag=smag/nms
          if(smag.lt.-10.0.or.smag.gt.10.0) smag=-9.9
          if(data(1)(60:60).eq.' ')then 
             write(data(1)(56:63),203) smag,agency
          elseif(data(1)(68:68).eq.' ')then 
             write(data(1)(64:71),203) smag,agency
          elseif(data(1)(76:76).eq.' ')then 
             write(data(1)(72:79),203) smag,agency
          else   ! all positions used on first line
c
c   put in a new line with magnitudes
c
                do k=nrecord,2,-1      ! move records one down 
                   data(k+1)=data(k)
                enddo
                data(2)=' '            ! new line with more magnitudes
                data(2)(46:48)=data(1)(46:48)    ! use same agency
                data(2)(1:23)=data(1)(1:23)      ! use same  start
                write(data(2)(56:63),203) smag,agency ! put in magnitude
                data(2)(80:80)='1'
                nhead=nhead+1
                nrecord=nrecord+1
 203         format(f4.1,'S',a3)
          endif
       endif
c
c   check if mb is available, write in first available position
c
       if(nmb.gt.0) then
          bmag=bmag/nmb
          if(bmag.lt.-10.0.or.bmag.gt.10.0) bmag=-9.9
          if(data(1)(60:60).eq.' ')then 
             write(data(1)(56:63),205) bmag,agency
          elseif(data(1)(68:68).eq.' ')then 
             write(data(1)(64:71),205) bmag,agency
          elseif(data(1)(76:76).eq.' ')then 
             write(data(1)(72:79),205) bmag,agency
 205         format(f4.1,'B',a3)
          else
             do i=2,nhead             ! check if other headers can be used
                if(data(i)(80:80).eq.'1'. ! must have same loc. agency
     *          and.data(1)(46:48).eq.data(i)(46:48)) then
                   write(data(i)(64:71),205) bmag,agency  ! must be 2. position
                   mag_write=.true.
                endif
             enddo
c
c   put in a new line with magnitudes
c
             if(.not. mag_write) then
                do k=nrecord,2,-1      ! move records one down 
                   data(k+1)=data(k)
                enddo
                data(2)=' '            ! new line with more magnitudes
                data(2)(46:48)=data(1)(46:48)    ! use same agency
                data(2)(22:22)=data(1)(22:22)    ! use same type
                data(2)(1:10)=data(1)(1:10)      ! use same y, m, d
                data(2)(80:80)='1'
                write(data(2)(56:63),205) bmag,agency ! put in magnitude 
                nhead=nhead+1
                nrecord=nrecord+1
             endif
          endif
       endif
       RETURN
       END
c---------------------------------------------------------------------------

      subroutine read_stat_mod
     &(agency,model_code,model,minstat,minphase,
     &modnam,loc_indicator,iustat,iuphs,iulst,iusum,iutab,isort,
     &test,dlt,yter,maxline,use_eev)
c
c   read model and stations etc, assumed from unit 1, the file name
c   is STATIONX.HYP where X can be any character given by model. If
c   model is blank, the standard model 0 is assumed. The routine will
c   first look for the station model in the curent directory, then
c   in the DAT directory. If the model file is not found, modlel=@ is
c   returned
c
c   iustat: 0: no station list, iulst: unit for print.out file
c
c   j havskov jan 92
c 
c   jul 92 by jh : add new par line for event type
c   jul 93       : iasp to capital letters
c   april 94 brl : added I/O numbers - was using #'s different from main program!!
c   apr 94 jh    : do not read addtional parameters except agency
CJAB(BGS)Jan95   : Install file & error handling...
CJAB(BGS)Jan95   : & remove VAX..
c
       implicit none
       save
      include 'libsei.inc'                 ! Library definitons.
      include 'hypparm.inc'                 !added 6/98 BRL
      external sei get file,               ! Find file & open handler.
     &         sei close,                  ! & closure.
     &         sei clen,                   ! String length.
     &         sei code                    ! Error condition handler.
      integer  sei clen                    ! & function.
      integer  code                        ! Condition.
      logical  b_flag                      ! A problem flagged?.
      logical use_eev                      ! true if call from eev
c
c      character*80 data(*)
      character*3 agency                                           
      character*20 model_code
      character*1 yter
      integer minstat,minphase,init,maxline
      character*1 model
c--- location indicator
      character*1 loc_indicator(3)
c--- name of station-model file in current directory
      character*80 cur_file
c--- name of stationmodel in DAT directory
      character*80 modnam
c--- event #
      integer eventno      
c--- isort &  test added
c      integer isort(*)                        
      logical locate
c--  covarrience matrix and origin time error
      real covar(3,3),oterr
c--- logical I/O
      integer iustat,iuphs,iulst,iusum,iutab
      integer idummy,nhead,nrecord
      
c      real test(200),dlt(narriv)
  
      model_code='                    ' ! currently do no tuse
c
c  Open the stations file...
c  =========================
c
      cur_file = 'STATION0.HYP'                ! Set up filename.
      if(model.ne.' ') cur_file(8:8)=model     ! & adjust
      call sei get file( open$+ignore$,        ! Find file & open it.
     &                   iustat,               ! On unit.
     &                   code,                 ! Returned condition.
     &                   'DAT',                ! Alternative directory to search
     &                   cur_file )            ! For stations file.
c
         if( code .ne. e_ok$ ) then         ! Does not exist.
         chr_err_msg$ = cur_file(:seiclen(cur_file)) //
     &                  ' does not exist'
         call sei code( stop$,              ! Halt the program with user-.
     &                  e_misf$,            ! Message; dummy use of code.
     &                  0,                  ! Unit (n/a).
     &                  b_flag )            ! Flag (n/a).
         end if                             !
c
c   check for iaspei files
c   ----------------------
c

      call iasp91_filename(modnam)
      modnam = modnam(:index(modnam,' ')-1) // '.TBL'  ! File name
      call sei get file( check$,               ! Find file.
     &                   0,                    ! On unit (n/a).
     &                   code,                 ! Returned condition.
     &                   'DAT',                ! Alternative directory to search
     &                   modnam )              ! For iaspei file.
c      modnam = 'IASP91.TBL'                    ! File name.
c
c    File exists somewhere...
c
         if( code .eq. e_ok$ ) then               ! Exists in pathname.
         modnam = modnam(:index(modnam,'.TBL')-1) ! Extract root.
c
c    File nowhere to be found...
c
         else                               ! Does not exist.
         chr_err_msg$ = '**** WARN: '     //
     &           modnam(:seiclen(modnam)) //
     &                  ' does not exist'
         write(*,*)
         call sei code( warn$,              ! Warn the user it doesn't exist.
     &                  e_misf$,            ! Message; dummy use of code.
     &                  0,                  ! Unit (n/a).
     &                  b_flag )            ! Flag (n/a).
         write(*,*)
         modnam= ' '
         end if                             !
C
C   READ STATION LIST AND MODEL
C
      call hypocent(1,iustat,iuphs,iulst,iusum,iutab,init,'N',
     &data,modnam,eventno,dlt,isort,test,yter,maxline,idummy,
     &locate,covar,oterr,nhead,nrecord,use_eev)
c
c   read agency 
c
      read(iustat,'(a3)',iostat=code) agency  ! Get agency.
      call sei code(fort$,code,iustat,b_flag) ! Process outcome.
      call sei close(close$,iustat,code)      ! Close the file (stop on error).
c
c   get minstat etc
c
      minstat=test(79)
      minphase=test(80)
      loc_indicator(1)='L'
      loc_indicator(2)='R'
      loc_indicator(3)='D'
      if(test(81).ne.1.0) loc_indicator(1)=' '
      if(test(82).ne.1.0) loc_indicator(2)=' '
      if(test(83).ne.1.0) loc_indicator(3)=' '
c
c  make sure minphase has been set to at least 3
c changed to 2 6/98 BRL
      if(minphase.lt.2) minphase=2
      return
c
c error
c
 3    continue
      model='@'   
      return
      end  


c
c------------------------------------------------------------------
c
      subroutine clear_old(data,nhead,nrecord,agency)
c
c   clear old secondary magnitude lines, old error lines
c   and old id lines
c
      implicit none
      save
      integer nrecord,nhead
      character*80 data(*)
      integer i,j,k
      character*3 agency
c
c   delete secondary header lines with magnitude, only delete line
c   if location agency is the same as default agency
c
      k=1
      if(nhead.gt.1) then
         do i=2,nhead             
             if(.not.(data(i)(80:80).eq.'1'. 
     *       and.agency.eq.data(i)(46:48)).and.
     *       data(i)(80:80).ne.'E'.and.
     *       data(i)(79:80).ne.'83'.and.
     *       data(i)(79:80).ne.'93'.and.
     *       data(i)(79:80).ne.'A3'.and.
     *       data(i)(80:80).ne.'H'
     *       .and.(.not.
     *       (data(i)(80:80).eq.'3'.and.data(i)(2:7).eq.'ACTION'))
     *       .and.(.not.
     *       (data(i)(80:80).eq.'3'.and.data(i)(2:13)
     *       .eq.'SPEC SD     '))
     *       .and.(.not.
     *       (data(i)(80:80).eq.'3'.and.data(i)(2:13)
     *       .eq.'SPEC AVERAGE'))) then
                k=k+1
                if(k.ne.i) data(k)=data(i)
             endif
         enddo
         j=k          ! save  new number of headers
         if(k.lt.nhead) then           ! some header lines removed, shift rest
             do i=nhead+1,nrecord
                k=k+1
                data(k)=data(i)
             enddo
             nhead=j
             do i=k,nrecord    ! blank double lines
                data(i)=' '
             enddo
             nrecord=k
         endif
      endif
c
c   
      return
      end

c--------------------------------------------------------------------
      subroutine update_spec(data1,nrecord,nhead,agency,output)
c
c   recalcualte spectral values so if distance has been changed,
c   the values are updated. Then calculate average values and write out 
c   in nordic data array data and return new number of headers and records.
c   the main header is updated with average mw if there is room and agency 
c   is written in the usual way.
c
      implicit none
      save
      include 'hypparm.inc'
      include 'seidim.inc'
c
c the following 2 otherwise defined in mulplt.inc
c
      character*(*) data1(*)
      real edepth        ! depth
      character*1 spec_phase ! nearest phase to spectrum
      character*3 agency     ! magnitude agency
      character*5 station
      character*4 compon ! component
      integer nrecord,nhead  ! number of record and headers
      real depth             ! hypocentral depth
c--- spectral values, see mulplt.inc
      real mw(max_data),moment(max_data),sdrop(max_data),
     *     sslope,svelocity,
     *     radius(max_data),swindow,
     *     omega0(max_data),cornerf(max_data),
     *     spec_velocity,density,
     *     q0,qalpha
      integer secc,travel_time,hour,min
      real geo_distance
      real kappa       ! near term attenuation
      real edistance,xdist   ! epicentral distance
      real avmw,avmoment,avsdrop,avsslope,avradius,avswindow,avomega0
      real avcornerf
      real sdmw,sdmoment,sdsdrop,sdradius,sdomega0,sdcornerf
      logical mag_write     ! true if room for magnitude on an existing line
      logical output        ! true if screen output
      integer nline         ! line count for magnitude output
      integer maxline       ! maximum magnitude lines out
c
      integer nspec,nspec1   ! number of spectra
      integer nmw            ! number of mw, can be less than nspec if w. out
      real pi
      real surface,radpat  !  surface effect and radiation pattern effect 
      real factor
      character*80 text

      integer i,k
      character*5 stat(nstats)      ! station list
      real mag_cor(5,nstats)        ! magnitude residuals
      integer kstat                 ! station number currently used
      common/hyp/stat,mag_cor,nline,maxline
c
      pi=3.14159265
c     output=.true.
      surface=2.0
      radpat=0.6
c
c   read depth
c
      read(data1(1)(39:43),'(f5.1)') edepth
c
      nspec=0
      nspec1=0
      nmw=0
      avmw=0.0
      avmoment=0.0
      avsdrop=0.0
      avsslope=0.0
      avradius=0.0
      avswindow=0.0
      avcornerf=0.0
c
c   look for spectral values
c
      k=1
 10   continue
        k=k+1
        if(k.gt.nhead) goto 20   ! calculate average values when all h. read
        if(data1(k)(80:80).eq.'3'.and.data1(k)(2:5).eq.'SPEC') then
           if(data1(k)(7:14).eq.data1(k+1)(7:14).and.data1(k)(16:30).
     *     ne.data1(k+1)(16:30)) then      ! check if pair of lines ok
           nspec1=nspec1+1
c
c   find current distance from station
c
           do i=nhead+1,nrecord-1
              if(data1(k)(7:10).eq.data1(i)(2:5)) then
                 if(data1(i)(71:75).eq.'     ') goto 2   ! no distance
                 read(data1(i)(71:75),'(f5.0)') edistance
                 goto 1
              endif
 2            continue
           enddo
c
c   if here, no distance found, jump to next spectral values
c
           k=k+1
           goto 10
 1         continue
c
c  read old spectral values
c
           read(data1(k),300)
     *     station(1:4),compon,moment(nspec1),sdrop(nspec1),
     *     omega0(nspec1),cornerf(nspec1),
     *     radius(nspec1),sslope,swindow,mw(nspec1)
300        format(6x,a4,a4,3x,f5.1,3x,f5.1,3x,f5.1,
     *     3x,f5.2,2x,f6.2,3x,f5.2,3x,f5.1,3x,f5.1)
           station(5:5)=' '   ! only possible to use 4 char station in spec
           read(data1(k+1),301)
     *     station(1:4),compon,hour,min,secc,kappa,xdist,
     *     spec_velocity,density,q0,qalpha,svelocity
           spec_phase=data1(k+1)(41:41)    ! type of spectrum
           if(data1(k+1)(24:25).eq.'TR') kappa=0.0    ! from old seisan
301        format(6x,a4,a4,2x,3i2,3x,f5.3,3x,
     *     f5.0,3x,f5.2,
     *     3x,f5.2,3x,f5.1,3x,f5.2,3x,f5.2)
           station(5:5)=' '
c
c   since svelocity and spec_velocity was introduced feb 98, some older data
c   will not have svelocity defined, so it must be done here. this will also 
c   fix the problem of earlier using p-velocity for radius when making
c   a p-wave spectrum
c
           if(svelocity.eq.0.0) svelocity=3.5    
c
c   find station number
c
          do i=1,nstats
            if(stat(i).eq.station) then
               kstat=i
               goto 1245
            endif
          enddo
 1245     continue
c
c   recalculate
c
c
c   calculate geo_distance
c
           call  spec_dist
     *     (spec_phase,edistance,edepth,factor)

c
           geo_distance=1.0/factor
           factor= 4*pi*(density*1000.0)*
     *          ((spec_velocity*1000.0)**3)
           moment(nspec1) = factor*(geo_distance*1000.0)*
     *     (10.0**omega0(nspec1))/(radpat*surface*1.0e9)
           radius(nspec1)=0.35*svelocity/cornerf(nspec1)
           sdrop(nspec1) = (0.44*moment(nspec1))/
     *                     (1.0e14*radius(nspec1)**3)
           moment(nspec1) = alog10(moment(nspec1))
           if(moment(nspec1).gt.0.0)  then
              if(mag_cor(5,kstat).ne.99.0) then
                 mw(nspec1)=moment(nspec1)*0.667-6.06
              else
                 if(output)
     *           write(6,'(1x,a,a)') station, ' mw weighted out'
              endif
           endif
c
c   write geo_distance, amplitude and magnitude
c
             if(nline.ge.0.and.output) then
                if(mag_cor(5,kstat).ne.99.0) then
                   if(mag_cor(5,kstat).eq.0.0) then
                      write
     *                (6,'(1x,a4,1x,2a1,2x,a,2x,f8.1,
     *                3x,a,2x,f12.1,3x,a,f5.1)')
     *                data1(k)(7:10),data1(k)(11:11),
     *                data1(k)(14:14),' gdist:',geo_distance,
     *                'mom:',moment(nspec1),'mw = ',mw(nspec1)
                   else        ! magnitude correction
                      write
     *                (6,'(1x,a7,2x,a,2x,f8.1,3x,a,2x,f12.1,
     *                3x,a,f5.1,a,f5.2)')
     *                data1(k)(7:13),' gdist:',geo_distance,
     *                'mom:',moment(nspec1),'mw = ',mw(nspec1),' + ',
     *                mag_cor(5,kstat)
                      mw(nspec1)=mw(nspec1)+mag_cor(5,kstat)
                   endif
                else
                  if(output)write(6,'(1x,a7,a,a)') data1(k)(5:13),
     *            ' Mom for mw available, magnitude not used',
     *            ' (weighted out)' 
                endif
                nline=nline+1
             endif
            if(nline.gt.maxline.and.output) then
               nline=0
               write(6,'('' Return to continue, q to end listing '',$)')
               read(5,'(a)') text
               if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') nline=-1
            endif
c
c   check for overflow
c
           if(moment(nspec1).gt.999.0) moment(nspec1)=999.9
           if(sdrop(nspec1).gt.999.0) sdrop(nspec1)=999.9
           if(geo_distance.gt.99999) geo_distance=99999
c
c   rewrite values
c
c jh 5-2001, strange seems recalculated spec not output
c          if(output) write(data1(k),400)
           write(data1(k),400)
     *     station(1:4),compon,moment(nspec1),sdrop(nspec1),
     *     omega0(nspec1),
     *     radius(nspec1),sslope,swindow,mw(nspec1)
400        format(' SPEC ',a4,a4,' MO',f5.1,' ST',f5.1,' OM',f5.1,
     *     ' f0',5x,' R',f6.2,' AL',f5.2,' WI',f5.1,' MW',f5.1)
c
c  check size of cornerf
c
         if(cornerf(nspec1).lt.1.0) write(data1(k)(42:46),'(f5.3)') 
     *   cornerf(nspec1)
         if(cornerf(nspec1).lt.10.0.and.cornerf(nspec1).ge.1.0)
     *   write(data1(k)(42:46),'(f5.2)') cornerf(nspec1)
         if(cornerf(nspec1).ge.10.0.and.cornerf(nspec1).lt.100.0)
     *   write(data1(k)(42:46),'(f5.1)') cornerf(nspec1)
         if(cornerf(nspec1).ge.100.0) write(data1(k)(42:46),'(f5.0)') 
     *   cornerf(nspec1)

           if(sdrop(nspec1).lt.1.0)
     *     write(data1(k)(26:30),'(f5.3)') sdrop(nspec1)
           if(radius(nspec1).lt.10.0)
     *     write(data1(k)(49:54),'(f6.4)') radius(nspec1)
           data1(k)(80:80)='3'
           write(data1(k+1),401)
     *     station(1:4),compon,hour,min,secc,
     *     kappa,int(geo_distance),
     *     spec_velocity,density,q0,qalpha,svelocity
401        format(' SPEC ',a4,a4,' T',3i2,' K ',f5.3,' GD',
     *     I5,' V ',f5.2,
     *     ' DE',f5.2,' Q0',f5.1,' QA',f5.2,' VS',f5.2)
           data1(k+1)(80:80)='3'
           data1(k+1)(41:41)=spec_phase
           if(geo_distance.lt.100.0) write(data1(k+1)(34:38),'(f5.1)') 
     *     geo_distance
c
c   sum for average, do not use magnitude weighted out value
c   do not use unidentified spectra, must be p or s (new may 2001, jh)
c
           if(spec_phase.eq.'P'.or.spec_phase.eq.'S') then
              avmoment=avmoment+moment(nspec1)
              avsdrop=avsdrop+sdrop(nspec1)
              avomega0=avomega0+omega0(nspec1)
              avcornerf=avcornerf+cornerf(nspec1)
              avradius=avradius+radius(nspec1)
              avsslope=avsslope+sslope
              avswindow=avswindow+swindow
              if(mag_cor(5,kstat).ne.99.0) then
                avmw=avmw+mw(nspec1)
                nmw=nmw+1
              else
                write(6,'(4a)')' Moment magnitude not used in average ',
     *                    'since weighted out ',station(1:4),compon
              endif
              nspec=nspec+1
           else
              write(6,'(3a)')
     *        ' Unidentified spectrum, not used in average ',
     *                   station(1:4),compon
           endif
        endif
c
        k=k+1         ! do not use next spectral line 
        endif
      goto 10           ! get next spectral line
c
c   enter here when all headers checked
c
 20   continue
c
c   return if no spectral values
c
      if(nspec.gt.0) write(6,'(a,2i6)')
     *' Number of spectra available and number used in average',
     *nspec1,nspec
      if(nspec.eq.0) return

c
c   calculate average values
c
      avmoment=avmoment/nspec
      avsdrop=avsdrop/nspec
      avomega0=avomega0/nspec
      avcornerf=avcornerf/nspec
      avradius=avradius/nspec
      avsslope=avsslope/nspec
      avswindow=avswindow/nspec
      if(nmw.gt.0) then
c        avmw=avmw/nspec ! lot 22/07/2008
        avmw=avmw/nmw
      else
        avmw=9.9         ! indicate no mw
      endif
c
c   check for overflow
c
c
c compute standard deviation
c
      sdmoment=0.
      sdsdrop=0.
      sdomega0=0.
      sdradius=0.
      sdcornerf=0.
      sdmw=0.
      if(avmoment.gt.999.0) then
        avmoment=999.9
      else
        call calcsd(moment,avmoment,sdmoment,nspec)
      endif
      if(avmw.gt.9.9.or.avmw.lt.-9) then
        avmw=9.9
      else
        call calcsd(mw,avmw,sdmw,nmw)
      endif
      if(avsdrop.gt.999.0) then
        avsdrop=999.9
      else
        call calcsd(sdrop,avsdrop,sdsdrop,nspec)
      endif
      if(avomega0.gt.999.0) then
        avomega0=999.9
      else
        call calcsd(omega0,avomega0,sdomega0,nspec)
      endif
      if(avradius.gt.999.9) then
        avradius=999.99
      else
        call calcsd(radius,avradius,sdradius,nspec)
      endif
      if(avcornerf.gt.999.9) then
        avcornerf=999.99
      else
        call calcsd(cornerf,avcornerf,sdcornerf,nspec)
      endif


      if(abs(avsslope).gt.999.0) avsslope=999.9
      if(avswindow.gt.999.9) avswindow=999.9
      
c
c   move all lines down one to make room for new sd spectral line
c   if not there from before
c
      k=0
      do i=2,nhead
        if(data1(i)(1:13).eq.' SPEC SD     ') k=i
      enddo
      if(k.eq.0) then
         do i=nrecord,2,-1
            data1(i+1)=data1(i)
         enddo
         k=2
         nrecord=nrecord+1
         nhead=nhead+1
      endif
c
c   check size
c
         if(sdcornerf.gt.999.0) sdcornerf=999.0
         if(sdsdrop.gt.999.0) sdsdrop=999.0
         if(sdradius.gt.999.0) sdradius=999.0
c
c   write values
c
      write(data1(k),500)
     *sdmoment,sdsdrop,sdomega0,sdradius,sdmw
c
         if(sdcornerf.lt.1.0) write(data1(k)(42:46),'(f5.3)') 
     *   sdcornerf
         if(sdcornerf.lt.10.0.and.sdcornerf.ge.1.0)
     *   write(data1(k)(42:46),'(f5.2)') sdcornerf
         if(sdcornerf.ge.10.0.and.sdcornerf.lt.100.0)
     *   write(data1(k)(42:46),'(f5.1)') sdcornerf
         if(sdcornerf.ge.100.0) write(data1(k)(42:46),'(f5.0)') 
     *   sdcornerf

      if(sdsdrop.lt.1.0)
     *write(data1(k)(26:30),'(f5.3)') sdsdrop
      if(sdradius.lt.10.0)
     *write(data1(k)(49:54),'(f6.4)') sdradius

500   format(' SPEC ','SD      ',' MO',f5.1,' ST',f5.1,' OM',f5.1,
     *' f0',5x,' R',f6.2,' AL     ',' WI     ',' MW',f5.1)
      data1(k)(80:80)='3'


c
c   move all lines down one to make room for new average spectral line
c   if not there from before
c
      k=0
      do i=2,nhead
        if(data1(i)(1:13).eq.' SPEC AVERAGE') k=i
      enddo
      if(k.eq.0) then
         do i=nrecord,2,-1
            data1(i+1)=data1(i)
         enddo
         k=2
c
         nrecord=nrecord+1
         nhead=nhead+1
      endif
c
c   write values
c
      write(data1(k),501)
     *avmoment,avsdrop,avomega0,
     *avradius,avsslope,avswindow,avmw
c 
c   check size
c
         if(avcornerf.lt.1.0) write(data1(k)(42:46),'(f5.3)') avcornerf
         if(avcornerf.lt.10.0.and.avcornerf.ge.1.0)
     *   write(data1(k)(42:46),'(f5.2)') avcornerf
         if(avcornerf.ge.10.0.and.avcornerf.lt.100.0)
     *   write(data1(k)(42:46),'(f5.1)') avcornerf
         if(avcornerf.ge.100.0) write(data1(k)(42:46),'(f5.0)') 
     *   avcornerf

      if(avsdrop.lt.1.0)
     *write(data1(k)(26:30),'(f5.3)') avsdrop
      if(avradius.lt.10.0)
     *write(data1(k)(49:54),'(f6.4)') avradius

501   format(' SPEC ','AVERAGE ',' MO',f5.1,' ST',f5.1,' OM',f5.1,
     *' f0',5x,' R',f6.2,' AL',f5.2,' WI',f5.1,' MW',f5.1)
      data1(k)(80:80)='3'
      if(avmw.eq.9.9) data1(k)(75:78)=' '   ! no mw
c
c   update header, if a mw,, find which header and where there is a free spot
c
      if(avmw.ne.9.9) then
          if(data1(1)(60:60).eq.' ')then 
             write(data1(1)(56:63),205) avmw,agency
          elseif(data1(1)(68:68).eq.' ')then 
             write(data1(1)(64:71),205) avmw,agency
          elseif(data1(1)(76:76).eq.' ')then 
             write(data1(1)(72:79),205) avmw,agency
 205         format(f4.1,'W',a3)
          else
             mag_write=.false.
             do i=2,nhead             ! check if other headers can be used
                if(data1(i)(80:80).eq.'1'. ! must have same loc. agency
     *          and.data1(1)(46:48).eq.data1(i)(46:48)) then
                  mag_write=.true.
                  if(data1(i)(60:60).eq.' ')then 
                     write(data1(i)(56:63),205) avmw,agency
                  elseif(data1(i)(68:68).eq.' ')then 
                     write(data1(i)(64:71),205) avmw,agency
                  elseif(data1(i)(76:76).eq.' ')then 
                     write(data1(i)(72:79),205) avmw,agency
                  endif
                endif
             enddo
c
c   put in a new line with magnitudes
c
             if(.not. mag_write) then
                do k=nrecord,2,-1      ! move records one down 
                   data1(k+1)=data1(k)
                enddo
                data1(2)=' '            ! new line with more magnitudes
                data1(2)(46:48)=data1(1)(46:48)    ! use same agency
                data1(2)(1:23)=data1(1)(1:23)      ! use same start 
                data1(2)(80:80)='1'
                write(data1(2)(56:63),205) avmw,agency ! put in magnitude
                nhead=nhead+1
                nrecord=nrecord+1
             endif
          endif
      endif
c
      return
      end

      subroutine calcsd(data,avdata,sddata,n)
      implicit none
      real data(*)
      real avdata,sddata
      integer i,n
      do i=1,n
        sddata=sddata+(data(i)-avdata)**2
      enddo
      sddata=sqrt(sddata/n)
      return
      end

c
c
c  converts geophysical institute of Israel imported  DAQ files to 
c  SEISAN format. The initial station codes are as defined in file, can
c  be converted with normal .def file. If 4 character of station name
c  indicate componenet (N or E), that is blanked out and transferred to 
c  4. character of componenet name BEFORE using the def file conversions.
c
c
c  This program works with a max of 30 channels, if you need more, test files
c  are needed to fix it
c
c  sep 2001 tested with 32 channels
c
c  j. havskov, sep 98
c
c
c
c
c
c  updates:
c
c  may 1999 jh   : ---------------- version 7 upgrade -----------------------
c  sep 2001      : 32 channels
c

      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
c
c   block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c
c--------  end of block
c

c-- output data vector	  
      integer*4  data4(max_sample)
      integer*2  data2(max_sample)
      character*3000 block  ! input file header
      integer*2 i_rate
      character*2 c_rate
      integer kbyte,k
      integer first            ! first record of samples-1
c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
      integer i,irec
c-- computer type
      logical pc,sun,linux	  
       integer i_samp    ! number of samples
       character*4 c_samp! ----------------

c
c
      character*1 cc
      character*2 c_short
      integer*2   i_short
c time
      character*16 time
      integer*2 i_time(8)
      integer i_magic               ! magig number
      character*4 magic 
c
      equivalence(i_rate,c_rate)
      equivalence (c_samp,i_samp)
      equivalence (c_short,i_short)
      equivalence (time,i_time)
      equivalence (magic,i_magic)
      

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      call computer_type(sun,pc,linux)

c
c   get def file for station codes
c
       call read_def_chan('giisei.def',mainhead_text,net_code)

c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old',access='direct',recl=3000)
c
c   read header block to get start time etc
c
c
 1     continue
       read(1,rec=1,err=99) block
       close(1)

c
c   magic number
c
       magic=block(1:4)
       if(sun) call swap4_one(i_magic)
c
c   number of samples
c
       c_samp=block(13:16)
       if(sun) call swap4_one(i_samp)
c
c   sample rate
c
       c_rate=block(11:12)
       if(sun) call swap2_one(i_rate)
c
c   number of channels
c
       c_short=block(9:10)
       if(sun) call swap2_one(i_short)
c
c   time
c
       time=block(2285:2300)
       if(sun) call swap2(8,i_time)
c
       write(6,*)' Magic number', i_magic
c
c   number of channels
c
       nchan=i_short
       write(6,*) ' Number of channels, samples and sample rate',
     * nchan,i_samp,i_rate
c
c   get times
c
       year(1) =i_time(6)
       month(1)=i_time(7)
       day(1)  =i_time(8)
       hour(1) =i_time(2)
       min(1)  =i_time(3)
       sec(1)  =i_time(4)+i_time(5)/1000.0
       
       write(6,*) year(1),month(1),day(1),hour(1),min(1),sec(1)
c
       write(6,*) 'Number of samples',i_samp
c
c   2 or 4 bytes
c
       cbyte(1)=' '   ! default 2 bytes, i_magic=131161
       if(i_magic.eq.190266) cbyte(1)='4'
c
c  get stations, assume max 64 channels in input file
c  but only read 32
c
       read(block(1402:1402+32*5-1),'(32(a4,1x))') (stat(i)(1:4),i=1,32)
       do i=1,32          ! only 4 char station names
         stat(i)(5:5)=' '
       enddo
c
c   assume same start time etc. for all channels
c
       do i=1,nchan
          year(i)=year(1)
          month(i)=month(1)
          day(i)=day(1)
          hour(i)=hour(1)
          min(i)=min(1)
          sec(i)=sec(1)
          rate(i)=i_rate
          nsamp(i)=i_samp
          cbyte(i)=cbyte(1)
          comp(i)='S  Z'
       enddo
c
c   if the component is given in the 4 char of station name, use that
c
        do i=1,nchan
          if(stat(i)(4:4).eq.'N'.or.stat(i)(4:4).eq.'E')then
             comp(i)(4:4)=stat(i)(4:4)
             stat(i)(4:4)=' '
          endif
        enddo
c
c  enter loop to define channels if a def file
c
       do ichan=1,nchan
c
c   put in definition from def file
c
           call set_def_chan(ichan,stat(ichan),comp(ichan))
       enddo
c   remove null chars
       do k=1,5
          if(ichar(stat(i)(k:k)).eq.0) stat(i)(k:k)=' '
       enddo
c
c   make seisan header
c
      ichan=1
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo
c
c  if mor ethan 30 channels
c
      if(nchan.gt.30) then
         k=(nchan-31)/3+1
         do i=13,k+12
            write(2)mainhead(i)
            write(6,'(a80)') mainhead(i)
         enddo
      endif
c
c   calculate address of first sample 
c
      kbyte=2
      if(cbyte(1).eq.'4') kbyte=4   ! 2 or 4 byte integers
      first=2300+nchan*2*kbyte
      first=first/kbyte
c
c   open again with record length kbyte to read samples later
c
       
      open(1,file=infile,status='old',access='direct',recl=kbyte)
c
c
C-----------------------------------------
C   enter channel  loop
c-----------------------------------------
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,stat,comp,
     *                    nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
c
c   get response
c                                                                               
         call read_resp_head(chahead)                                            
c
c   read samples
c
          do i=1,i_samp
            irec=first+i+i_samp*(ichan-1)
c            write(88,*) i,irec
            if(kbyte.eq.2) read(1,rec=irec) data2(i)
            if(kbyte.eq.4) read(1,rec=irec) data4(i)
          enddo
c
c   write data
c
         write(2)chahead
         if(kbyte.eq.2) then
c
c   BUGGGGGG
c
c   the call swap2 does not work here on solris for some files, ok on pc
c   a temporary fix is to do swap directly as done below, problem seem to
c   be that nothing happens in the swap routine in this special case, must be 
c   a memory problem somewhere
c   the swap4 has not been tested 
c
         if(sun)then 
             do i=1,i_samp
               i_short=data2(i)
               cc=c_short(1:1)
               c_short(1:1)=c_short(2:2)
               c_short(2:2)=cc
               data2(i)=i_short
             enddo
c              
c            call swap2(i_samp,data2)
          endif
            write(2) (data2(i),i=1,i_samp)
         endif
         if(kbyte.eq.4) then
            if(sun) call swap4(i_samp,data4)
            write(2) (data4(i),i=1,i_samp)
         endif
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  

c$debug 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c subroutine resp_sei2gse
c
c convert SEISAN response (character*1040) to GSE1 or GSE2
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c last changes
c
c    14 mar 97 LO corrected PAZ SEISAN reading routine
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c ----------------------- SEISAN VERSION 7.0 ---------------------------
c mar, 08 99 lo: year 2000 and 5 chars station code
c
c


       subroutine resp_sei2gse(respsei,respout,overwrite)

      implicit none
c output file
      character*80 outfile
c seisan response information
      character*1040 respsei
c seisan station name
      character*5 sstation
c seisan component
      character*4 scomp
c seisan date and time
      integer syear, smonth, sday, shour, smin
c seisan sec
      real ssec
c seisan sample rate
      real ssrate
c response format (FAP, PAZ)
      character*1 srespformat
c seisan gain
      real sgain
c seisan normalization constant
      real snorm
c seisan response information FAP
      real sfrequ(30), samp(30), sphase(30)
c seisan numbers of zeros and poles
      integer snumpoles,snumzeros
c seisan poles and zeros
      real spr(50),spi(50),szr(50),szi(50)
c array of text
      character*8 text(90)
c counter
      integer c,x,a
c response output format
      character*1 respout
c number of fap
      integer numberfap
c overwrite protection
      character*1 overwrite
c array of PAZ lines
      character*80 pazline(10)
c paz value
      real paz(74)

c gse2 component
      character*3 g2comp
c gse2 calibration id line (CAL2)
      character*90 g2idline
c gse2 system sensitivity (nm/counts)
      real g2calib
c gse2 header line
      character*80 g2header
c gse2 data triplets
      character*32 g2triplet

c gse1 line
      character*80 g1line
c gse1 component
      character*2 g1comp
c gse1 scaling factor
      real g1scf
c file name
      character*80 file_name
c network code
      character*5 net_code
c main header in waveform file (not used here)
      character*29 mainhead_text




C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external computer_type,             ! Get platform type.
     &          systemc                   ! System call.
       external sei open,                  ! Open file routine.
     &          sei close                  ! Close file routine.
       integer  write01                    ! Input unit 1.
       integer  code                       ! Local condition.
       logical  exist,b_flag               ! exist flag
   
C
C    ============= end of list ==========


      net_code = ' '
      mainhead_text = ' '
c
c   get def file for station codes, give file name
c
      file_name='gsesei.def'
      call read_def_chan(file_name,mainhead_text,net_code)

c
c check if response exists
c
      if (respsei(321:330).eq.'          '.and.
     &    respsei(161:170).eq.'          ') then
         write(*,*) 'no response information in channel header !!! ' 
         return
      endif
   1  Format(a,$)


c read header information
       sstation = respsei(1:5)
       scomp = respsei(6:9)
       read(respsei(11:12),'(i2)') syear
     
       read(respsei(18:19),'(i2)') smonth
       read(respsei(21:22),'(i2)') sday
       read(respsei(24:25),'(i2)') shour
       read(respsei(27:28),'(i2)') smin
       read(respsei(30:35),'(f6.3)') ssec 
       read(respsei(37:43),'(f7.2)') ssrate
       read(respsei(78:78),'(a1)') srespformat 
     

c read resp information, FAP or PAZ 

       if (srespformat.eq.' ') THEN

c read gain at 1Hz
         read(respsei(201:208),'(g8.3)') sgain

         c=1 
         do x=321,1033,8
           write(text(c)(1:8),'(a8)') respsei(x:x+7)
           c=c+1  
         enddo

c get FAP

         do c=1,10
           read(text(c)(1:8),'(g8.3)') sfrequ(c) 
         enddo
         do c=31,40 
           read(text(c)(1:8),'(g8.3)') sfrequ(c-20)
         enddo
         do c=61,70 
           read(text(c)(1:8),'(g8.3)') sfrequ(c-40)
         enddo

         do c=11,20
           read(text(c)(1:8),'(g8.3)') samp(c-10)
         enddo
         do c=41,50
           read(text(c)(1:8),'(g8.3)') samp(c-30)
         enddo
         do c=71,80
           read(text(c)(1:8),'(g8.3)') samp(c-50)
         enddo

         do c=21,30
           read(text(c)(1:8),'(g8.3)') sphase(c-20)
         enddo
         do c=51,60
           read(text(c)(1:8),'(g8.3)') sphase(c-40)
         enddo
         do c=81,90
           read(text(c)(1:8),'(g8.3)') sphase(c-60)
         enddo

c find number of FAP triplets
         numberfap=0
         do c=1,30
           if (sfrequ(c).gt.0) then
              numberfap=numberfap+1
           endif
         enddo
       
       elseif (srespformat.eq.'P') then

         read(respsei(161:182),'(1x,2i5,g11.4)' )
     &      snumpoles,snumzeros,snorm 

c read the first two,5 poles in pairs of re and im
         read(respsei(183:237),'(5g11.4)')
     &     paz(1),paz(2),paz(3),paz(4),paz(5)


c read the remaining poles and zeros 
         x=1
         do c=241,961,80
           read(respsei(c:c+80),'(a80)') pazline(x)
           x=x+1
         enddo  
 
         a=5

         do x=1,10
           do c=1,67,11
             a=a+1  
             read(pazline(x)(c:c+11),'(g11.4)') paz(a)
           enddo
         enddo

c read real part of poles
         do x=1,snumpoles
           spr(x)=paz(x*2-1)
         enddo

c read imaginary part of poles
         do x=1,snumpoles 
           spi(x)=paz(x*2)
         enddo

c read real part of zeros
         do x=1,snumzeros
           szr(x)=paz(snumpoles*2+x*2-1)
         enddo
         
c read imaginary part of zeros
         do x=1,snumzeros
           szi(x)=paz(snumpoles*2+x*2)
         enddo

       endif  

c end of input part



c make GSE filename same on PC and SUN
       if (respout.eq.'3') then
c         call channel2gse2(scomp,g2comp)  ! convert comp to GSE2
         call set_def_chan(1,sstation,scomp)
         g2comp = scomp(1:3)
         outfile = sstation // g2comp // '2.CAL'
       elseif (respout.eq.'2') then
c        call channel2gse1(scomp,g1comp)  ! convert comp to GSE1
         call set_def_chan(1,sstation,scomp)
         g1comp = scomp(1:2)
         outfile = sstation // g1comp // '_1.CAL'
       endif

c remove blanks
       do c=1,12
          if (outfile(c:c).eq.' ') outfile(c:c)='_'
       enddo

c open file
 100  CONTINUE

      call sei open( check$,               ! check if file exists 
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   exist,            ! Flag.
     &                   code )            ! Returned condition.

      if (exist) then
        if (overwrite.ne.'a'.and.overwrite.ne.'A') then
          write(*,*) outfile,' exists !!!'
          write(*,*) 'overwrite (y/n/a=always) ?  '
          read(*,'(a1)') overwrite
        endif
        if (overwrite.eq.'n'.or.overwrite.eq.'N') then
          write(*,*) ' new file name :  ' 
          read(*,'(a80)') outfile
          goto 100
        else
          call sei open( old$,           ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,            ! Flag.
     &                   code )            ! Returned condition.
          
        endif
      else
        call sei open( new$,           ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,            ! Flag.
     &                   code )            ! Returned condition.

        
      endif

      write(*,*) ' response output file :  ',outfile

c output part GSE2

       if (respout.eq.'3') THEN

c fill character strings with blanks

         do c=1,90
            g2idline(c:c)=' '
         enddo

         do c=1,80
           g2header(c:c)=' '
         enddo



c write ID line
         g2idline(1:4)='CAL2'      
         g2idline(6:10)=sstation(1:5)
         g2idline(12:14)=g2comp
         if (srespformat.eq.' ') then 
           if (sgain.ne.0) then
             g2calib=1/(sgain*1E-9)
           else
             g2calib=1
           endif
           write(g2idline(28:37),'(e10.2)') g2calib
         elseif (srespformat.eq.'P') then
           g2calib=1/(snorm*1E-9)
           write(g2idline(28:37),'(e10.2)') g2calib
         endif
         
       
         g2idline(39:45)='   1.0' 
         if (ssrate.ne.0) write(g2idline(47:56),'(f10.5)') ssrate

c if response from waveform header, dont use starttime
         if (ssec.ne.0) then
           write(g2idline(58:67),'(i4,a1,i2,a1,i2)') 
     &       1950,'/',01,'/',01   ! time fixed
           write(g2idline(69:73),'(i2,a1,i2)') 00,':',00 ! shour, smin
         else
           write(g2idline(58:67),'(i4,a1,i2,a1,i2)')
     &          syear+1900,'/',smonth,'/',sday
           write(g2idline(69:73),'(i2,a1,i2)') shour,':',smin
         endif

  
         write(write01,'(a90)') g2idline(1:90)
         write(*,*) g2idline

         
c write header line and response data

         if (srespformat.eq.' ') THEN
           g2header(1:4)='FAP2'
           g2header(9:9)='C'
           write(g2header(25:27),'(i3)') numberfap

           write(write01,'(a)') g2header
           write(*,'(a53)') g2header(1:53)

c write data triplets
           do c=1,numberfap
             do x=1,32
               g2triplet(x:x)=' '
             enddo
             write(g2triplet(2:11),'(f10.5)') sfrequ(c)
             write(g2triplet(13:27),'(e15.8)') samp(c)
             write(g2triplet(29:32),'(i4)') int(sphase(c))
           
             write(write01,'(a32)') g2triplet
c            write(*,*) g2triplet

           enddo

         elseif (srespformat.eq.'P') THEN
c write header
           g2header(1:4)='PAZ2'
           g2header(9:9)='C'
           write(g2header(41:43),'(i3)') snumpoles
           write(g2header(45:47),'(i3)') snumzeros

           write(write01,'(a)') g2header
           write(*,*) g2header

c write data triplets
c first the poles
           do c=1,snumpoles
             do x=1,32
               g2triplet(x:x)=' '
             enddo
             write(g2triplet(2:16),'(e15.8)') spr(c) 
             write(g2triplet(18:32),'(e15.8)') spi(c)
          
             write(write01,'(a)') g2triplet
c            write(*,*) g2triplet

           enddo

c now the zeros
           do c=1,snumzeros
             do x=1,32
               g2triplet(x:x)=' '
             enddo
             write(g2triplet(2:16),'(e15.8)') szr(c) 
             write(g2triplet(18:32),'(e15.8)') szi(c)
          
             write(write01,'(a)') g2triplet
c            write(*,*) g2triplet

           enddo



         endif 


c write GSE1 output

       elseif (respout.eq.'2') then


c fill character strings with blanks

         do c=1,80
            g1line(c:c)=' '
         enddo


c write ID line
         g1line(1:4)='CAL1'
         g1line(6:10)=sstation(1:5)
         g1line(22:23)=g1comp
         if (srespformat.eq.' ') then
           g1line(32:34)='FAP'
         elseif (srespformat.eq.'P') then
           g1line(32:34)='PAZ'
         endif
         if (ssec.ne.0) then   ! if response from waveform file
           write(g1line(36:41),'(3i2)')
     &       50,01,01    ! time fixed
           write(g1line(43:46),'(2i2)') 0,0   !shour,smin
         else
           write(g1line(36:41),'(3i2)')
     &       syear,smonth,sday
           write(g1line(43:46),'(2i2)') shour,smin
         endif
 
         write(write01,'(a80)') g1line(1:80)
         write(*,*) g1line

c write header line and response data


         if (srespformat.eq.' ') THEN   ! response as FAP
 
           do c=1,80
             g1line(c:c)=' '
           enddo

           write(g1line(1:8),'(i8)') numberfap

           write(write01,'(a)') g1line
c          write(*,'(a)') g1line


c write data triplets
           do c=1,numberfap
             do x=1,80
               g1line(x:x)=' '
             enddo

             write(g1line,'(e10.5,1x,e10.5,1x,f10.4)') sfrequ(c),
     &         samp(c)*1E9/sgain, sphase(c)


             write(write01,'(a)') g1line
c            write(*,*) g1line

           enddo

         elseif (srespformat.eq.'P') THEN   ! PAZ

c write poles
 
           do x=1,80
             g1line(x:x)=' '
           enddo

           write(g1line(1:8),'(i8)') snumpoles

           write(write01,'(a)') g1line
c          write(*,*) g1line

c write real and imaginary part
           do c=1,snumpoles
             do x=1,80
               g1line(x:x)=' '
             enddo
             write(g1line(1:8),'(e8.2)') spr(c)
             write(g1line(9:16),'(e8.2)') spi(c)
             write(write01,'(a)') g1line
c            write(*,*) g1line

           enddo


c write number of zeros
           do x=1,80
             g1line(x:x)=' '
           enddo

           write(g1line(1:8),'(i8)') snumzeros

           write(write01,'(a)') g1line
c          write(*,*) g1line


c write real part
           do c=1,snumzeros
             do x=1,80
               g1line(x:x)=' '
             enddo
             write(g1line(1:8),'(e8.2)') szr(c)
             write(g1line(9:16),'(e8.2)') szi(c)

             write(write01,'(a)') g1line
c            write(*,*) g1line

           enddo


C write scale factor to normalize to grounddisplacement
             do x=1,80
               g1line(x:x)=' '
             enddo
 
             g1scf=1/(snorm*1E-9)
             write(g1line(1:20),'(e16.10)') g1scf
             write(write01,'(a)') g1line


         endif
  

       endif


       call sei close( close$, write01,code ) ! Close file 

       return 
 
       end



ccccccc end of main program          ccccccccccccccccc



cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c convert component from SEISAN to FDSN format used
c in GSE2
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccc

       subroutine old_channel2gse2(inch,outch)

       implicit none
 
       character*4 inch
       character*3 outch

       outch='   '

c convert channel codes
       if (inch.eq.'S  Z') outch='SHZ'
       if (inch.eq.'S  N') outch='SHN'
       if (inch.eq.'S  E') outch='SHE'
       if (inch.eq.'L  Z') outch='LHZ'
       if (inch.eq.'L  N') outch='LHN'
       if (inch.eq.'L  E') outch='LHE'
       if (inch.eq.'B  Z') outch='BHZ'
       if (inch.eq.'B  N') outch='BHN'
       if (inch.eq.'B  E') outch='BHE'
       if (inch.eq.'BV Z') outch='BHZ'
       if (inch.eq.'BV N') outch='BHN'
       if (inch.eq.'BV E') outch='BHE'
       if (inch.eq.'V  Z') outch='VHZ'
       if (inch.eq.'V  N') outch='VHN'
       if (inch.eq.'V  E') outch='VHE'
       if (inch.eq.'A  Z') outch='SAZ'
       if (inch.eq.'A  N') outch='SAN'
       if (inch.eq.'A  E') outch='SAE'


       return
       end      ! end of subroutine channel2gse



cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c convert component from SEISAN to GSE1 format 
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccc


       subroutine old_channel2gse1(inch,outch)

       implicit none

       character*4 inch
       character*2 outch

       outch='  '

c convert channel codes
       if (inch.eq.'S  Z') outch='SZ'
       if (inch.eq.'S  N') outch='SN'
       if (inch.eq.'S  E') outch='SE'
       if (inch.eq.'L  Z') outch='LZ'
       if (inch.eq.'L  N') outch='LN'
       if (inch.eq.'L  E') outch='LE'
       if (inch.eq.'B  Z') outch='BZ'
       if (inch.eq.'B  N') outch='BN'
       if (inch.eq.'B  E') outch='BE'
       if (inch.eq.'BV Z') outch='BZ'
       if (inch.eq.'BV N') outch='BN'
       if (inch.eq.'BV E') outch='BE'
       if (inch.eq.'V  Z') outch='VZ'
       if (inch.eq.'V  N') outch='VN'
       if (inch.eq.'V  E') outch='VE'
       if (inch.eq.'A  Z') outch='AZ'
       if (inch.eq.'A  N') outch='AN'
       if (inch.eq.'A  E') outch='AE'


       return
       end      ! end of subroutine channel2gse


cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c convert component from GSE1 to SEISAN format
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccc


       subroutine old_channel_gse12sei(inch,outch)

       implicit none

       character*2 inch
       character*4 outch

       outch='    '

c convert channel codes
       if (inch.eq.'SZ') outch='S  Z'
       if (inch.eq.'SN') outch='S  N'
       if (inch.eq.'SE') outch='S  E'
       if (inch.eq.'LZ') outch='L  Z'
       if (inch.eq.'LN') outch='L  N'
       if (inch.eq.'LE') outch='L  E'
       if (inch.eq.'BZ') outch='B  Z'
       if (inch.eq.'BN') outch='B  N'
       if (inch.eq.'BE') outch='B  E'
       if (inch.eq.'VZ') outch='V  Z'
       if (inch.eq.'VN') outch='V  N'
       if (inch.eq.'VE') outch='V  E'
       if (inch.eq.'AZ') outch='A  Z'
       if (inch.eq.'AN') outch='A  N'
       if (inch.eq.'AE') outch='A  E'


       return
       end      ! end of subroutine 


cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c convert component from FDSN to SEISAN format 
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccc

       subroutine old_channel_gse22sei(inch,outch)

       implicit none

       character*3 inch
       character*4 outch

       outch(2:4)=inch

c convert channel codes
       if (inch.eq.'SHZ') outch='S  Z'
       if (inch.eq.'SHN') outch='S  N'
       if (inch.eq.'SHE') outch='S  E'
       if (inch.eq.'LHZ') outch='L  Z'
       if (inch.eq.'LHN') outch='L  N'
       if (inch.eq.'LHE') outch='L  E'
       if (inch.eq.'BHZ') outch='B  Z'
       if (inch.eq.'BHN') outch='B  N'
       if (inch.eq.'BHE') outch='B  E'
       if (inch.eq.'VHZ') outch='V  Z'
       if (inch.eq.'VHN') outch='V  N'
       if (inch.eq.'VHE') outch='V  E'
       if (inch.eq.'SAZ') outch='A  Z'
       if (inch.eq.'SAN') outch='A  N'
       if (inch.eq.'SAE') outch='A  E'

       return
       end      ! end of subroutine 

c
c  simple program to extract out a section of a seisan file (any seisan
c  primary format). a similar job can be done with wavetool, 
c  however seicut can do the sam ecut on many files
c  
c  jh, april 2004
c
c  changes
c
c  2005 oct 21  jh: Fix so it also works with files with more than 30 channels
c  2007 apr 20  jh: Make it work with filenr.lis, and use relative time from
c                   start of file 
c
c  mode 1 with one file
c
c  syntax is: seicut filename yyyymmdd..  inteval (sec)
c  
c  If no input on prompt, user can enter values manually.
c  the first sample to use is the first sample found before the start time
c  the time interval out will be time from first to last sample, so if e.g.
c  one second of data is asked for at a sample rate of 100 Hz, the time interval
c  in header will be 0.99 sec and the number of samples output will be 100.
c
c  if interval not available in any of the channels, the program will stop.
c
c
c  mode 2
c
c  syntax is : seicut
c
c  When entereing a file name, filenr.lis can be used. The program will
c  then use a list of files. Start time is now relative to start of file, 
c  interval is same as before. So all files are cut the same amount. if
c  file is too short, there is an option to use end of file as end time.
c
c
c  
c  the output file name will use a network code reflecting station code of
c  first channel in input file and '_CUT' is added to the end of the file name

      implicit none
      include 'seidim.inc'                    ! for giving dimensions
      include 'libsei.inc'                    ! for all seisan subroutines
      include 'waveform.inc'                  ! waveform data
      include 'seisan.inc'                    ! seisan general parameters
      character*80 arg(5)    	   	      ! arguments to cfile
      integer nargs                           ! number of arguments
      integer doy                             ! day of year
      character*5 net_code                    ! network code
      character*80 outfile                    ! output file name
      Character*80 start_time                 ! start time
      character*80 mainhead(max_trace)        ! waveform header
      character*1040 chead                    ! waveform header
      integer syear,smonth,sday,shour,smin    ! start time
      real*8 abs_start                        ! abs time of start time
      integer last_samp(max_trace)            ! sample number for last sample
      real ssec                               ! start sec
      real interval                           ! interval to extract (sec)
      real start_t                            ! start time relative to file start, many files
      integer seiclen                         ! function
      integer accept                          ! if 1, accept many files too short
      real del_time                           ! time difference between first sample and
                                              ! sample to use
      integer first_samp(max_trace)           ! first sample to use, first sample in trace
                                              ! is number 1
      integer i,l,k,kk,in                        ! counters

      accept=0
c
c   get arguments, first is start time in yyyymmdd... and second is interval in seconds
c   this argument function is SEISAN general, has the same form on all computer platforms
c
      call get_arguments(nargs,arg)
C
c   check arguments
c
      
      if (nargs.lt.3) then
         write(6,*)' Not enough arguments'
         write(*,*)
     *  'filename start time (yymmdd...) and time',
     *  ' interval (sec) can be given'
         write(6,*)
         write(6,*) 'Will use interactive input'
c
c   just enter one wav name
c
         write(6,*)
     *   'Waveform file name, can be filenr.lis for many files'
         read(5,'(a)') wav_filename(1)
         in=0
         if(wav_filename(1)(1:10).eq.'filenr.lis') then
            open(8,file='filenr.lis',status='old',err=20)
            goto 21
 20         continue
            write(6,*)' No filenr.lis'
             stop
 21          continue
             in=1
          endif          
c
c   one file
c 
         if(in.eq.0) then      
            write(6,*)
     *      'start time (yyyymmddhhmmss.sss)'
            read(5,'(a)') start_t
            read(start_t,'(i4,4i2,f6.0)')
     *      syear,smonth,sday,shour,smin,ssec
         endif
c
c   many files
c
         if(in.eq.1) then
            write(6,*) 'Start time (sec) relative to file start time'
            read(5,*) start_t
         endif

         write(6,*)'Interval in seconds'
         read(5,*) interval
      else
         wav_filename(1)=arg(1)
         read(arg(2),'(i4,4i2,f6.0)')
     *   syear,smonth,sday,shour,smin,ssec
         read(arg(3),'(f9.0)') interval
      endif

      wav_nfiles=1                   ! there is only one file in this case
      wav_nchan=0

c
c  file loop if many files
c

 1000 continue

      if(in.eq.1) then
         read(8,'(7x,a)') wav_filename(1)
         if(wav_filename(1)(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') wav_filename(1)
      call wav_init
c
c   read all headers of waveform file 
c
      call read_wav_header(1)
c
c   output possible errors
c
      if(wav_error_message.ne.' ') write(6,'(1x,a)') 
     *wav_error_message
c
c   write out the format
c
      write(6,'(1x,a,a)') 'Format ',wav_file_format(i)
c
      write(6,*)' Total number of channels available:',wav_nchan
c
c   write some input info for each channnel on screen
c
      write(6,'(a,a)')
     *' CHA STAT  COMP  YEAR MO DA HR MI    SEC  NSAMP ',
     *                '    RATE    DELAY DURATION'
      do i=1,wav_nchan
         write(6,'(1x,i3,1x,a,1x,a,1x,i5,4i3,f7.3,1x,i6,3f9.3)')
     *   i, wav_stat(i),wav_comp(i),
     *   wav_year(i),wav_month(i),wav_day(i),wav_hour(i),wav_min(i),
     *   wav_sec(i),wav_nsamp(i),wav_rate(i),wav_delay(i),
     *   wav_duration(i)
      enddo
      write(6,*)
c
c   find first sample to use for each channel
c
      do i=1,wav_nchan
         if(in.eq.0) then
            call timsec(syear,smonth,sday,shour,smin,ssec,abs_start)
            del_time=abs_start-wav_abs_time(i)
         else
            del_time=start_t
         endif
c
c  check if start time ok
c
         if(del_time.lt.0) then
            write(6,*)'channel ',i
c           write(6,*)'start time is before channel start time'
            stop
         endif
         first_samp(i)=del_time*wav_rate(i)+1
c        write(6,*) 'del time, first samp', del_time,first_samp(i)
c
c   check if end time ok
c
         last_samp(i)=first_samp(i)+wav_rate(i)*interval-1 
         if(last_samp(i).gt.wav_nsamp(i)) then
             write(6,*) 'Channel ',i
             write(6,*) 'End time after channel end'
c
c   case of many files
c
             if(accept.eq.1.and.in.eq.1) then
                last_samp(i)=wav_nsamp(i)
             endif
             if(in.eq.1.and.accept.eq.0) then
               write(6,*) 
     *        'Write available samples for this file only (1)'
               write(6,*)
     *        'Write available samples for all files      (2)'
               write(6,*)
     *        'Stop                                       (3)'
               read(5,*) k
               if(k.eq.1.or.k.eq.2) then
                  last_samp(i)=wav_nsamp(i)
               endif
               if(k.eq.2) accept=1                  
               if(k.eq.3) stop
             endif

c
c  always stop if one file only
c
             if(in.eq.0) then
                stop
             endif
          endif
c
c  find exact time of first sample and put in ouput common block
c
          abs_start=wav_abs_time(i)+(first_samp(i)-1)/wav_rate(i)          
          call sectim(abs_start,wav_year(i),doy,wav_month(i),wav_day(i),
     *    wav_hour(i),wav_min(i),wav_sec(i))
c          wav_nsamp(i)=wav_rate(i)*interval
          wav_nsamp(i)=last_samp(i) - first_samp(i) +1
       enddo
c
c   adjust common block variables for trimmed output
c
c     do i=1,wav_nchan
c        wav_year(i)=syear
c        wav_month(i)=smonth
c        wav_day(i)=sday
c        wav_min(i)=smin
c        wav_sec(i)=ssec
c     enddo
c
c   make and write seisan output header
c
      net_code='     '
      call wav_sheads(1,net_code,outfile,mainhead,chead)   ! make headers
c      write(6,*) outfile(1:seiclen(outfile))//'_CUT'
      write(6,*) ' Output filename: '
     &   //outfile(1:seiclen(outfile))//'_CUT'
      open(2,file=outfile(1:seiclen(outfile))//'_CUT',
     *status='unknown',form='unformatted')
c
c   write headers, assume maximum of 30 channels, since only 12 headers are written out
c
      do i=1,12
          write(2) mainhead(i)
      enddo
c
c   write remaining main header lines if more than 30
c
         if(wav_nchan.gt.30) then
            kk=(wav_nchan-31)/3+1
            do i=13,kk+12
               write(2)mainhead(i)
            enddo
         endif

      write(6,*) mainhead(1)(1:79)
c
c  read the waveform data, one trace at a time
c
      do i=1,wav_nchan
          call wav_read_channel(i)                            ! read one trace, read as integer, converted to real
          call wav_sheads(i,net_code,outfile,mainhead,chead)  ! make channel header
          write(2) chead                                      ! write channel header
          write(6,*) chead(1:79)
          write(2)(int(signal1(l)),
     *    l=first_samp(i),last_samp(i)) ! write trace, converted to integer
      enddo
      close(2)
c
c   if many files go back for next
c
      if(in.eq.1) goto 1000
      stop
      end

c   program to collect event files to one file from
c   standard data base or individual base                              
c   wicount eventn  events and records                                   
c                                                                      
c   jens havskov, dec 88                                             
c                                                                  
c   uppdates                                                      
c   26.May 89 by Leif Kvamme. Testing file existence. (CLK)                
c   may 29  by j.h.   : status messages about errors                            
c   sep 19, 89 by j.h : increase filename to 60 chars                     
c   Aug 23, 90 by K.Atakan : add compact file                            
c   nov 5   90 by j.h.     : fix output file name,                      
c   nov 12  90 by Erik Hjortenberg : adjust to UNIX
c   oct 17  91 jh : 12 char time string
c   nov 26        : new nordic format, new indata
c   May 13  92 cl : Command line input facilitated
c   jul 8   93 jh : VERSION 3.0 ***************
c   aug 23        : filenames to 80
c   aug 25        : ajust to pc
c   jul 26 94     : small comment change
c   nov    94     :  *******************   verson 5.0 ********************
c   nov 24, 1994  : opening files changed
c   jan 11     95  : new find ev in
c   jan 31        : change quesiton
c   jun 95        : put in global dimensions !!!!!
c  
c   jan 98  jh    : Year 2000 fix ***************************************
c   sep  17 98    : ---------------- verison 7.0 check ------------------
c                   local data base to ,,, longer file name print out
c   nov 02        : recompiled to include new findevin and indata
c   sep 16 05 jh  : no longer clean out norsar amplitudes
C
      implicit none
      include 'seidim.inc'
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c-- event data
       character*80	data(max_data)	
c-- exp indicator                                         
       character*1	exp		
c-- event type                                      
       character*1      type		
c-- output indicator for comp. or norm.	  
       character*1      outf            
c-- number of recors for event                           
       integer		nrecord		
c-- number of header lines                                 
       integer		nhead		
c-- number of stations                                     
       integer		nstat		
c-- number of phases
       integer nphase
c-- start and end time of select      
       character*14    start_time,end_time 
c-- data base name if not agency (blank)               
       character*40	base_name	
c-- event file name                                   
       character*80	evfile		
c-- select key                                       
       character*10     key		
c-- see subroutine find...       
       integer		status,new_month,fstart,event_no 
c-- counters for events, records etc.      
       integer nr,nd,nl,records,nevent	
c-- counter                                                   
       integer 		i		
c-- true if file exists (CLK)             
       logical          exist           
c-- Arguments passed
       character*80     arg(10)
c-- id line number
       integer id
c---number of arguments and function
      integer nars
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1
       integer          read01
c write unit  #1
       integer          write01



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver


c
c
C
       start_time = ' '
       nars = 0
       call get_arguments(nars,arg)    ! get arguments 
        if(nars .ne. 0) then
         end_time = ' '
         base_name = ' '
         outf = ' '
         do i = 1,nars
            if(arg(i)(1:11) .eq. '-start_time')then
                read(arg(i+1),'(a14)') start_time
            endif
            if(arg(i)(1:9) .eq. '-end_time')then
              read(arg(i+1),'(a14)') end_time
            endif
            if(arg(i)(1:10).eq. '-base_name')then
              read(arg(i+1),'(a40)') base_name
            endif
            if(arg(i)(1:10) .eq. '-compact')then
              outf='y'
            endif
            if(arg(i)(1:2).eq.'-h')then
              write(*,*)'    Command line input:'
              write(*,*)'-start_time yymmdd...'
              write(*,*)'-end_time yyyymmdd...(blank=end of month)'
              write(*,*)'-base_name XXX (blank=default)'
              write(*,*)'-compact y/n'
              stop
            endif
         enddo
       endif
       if(start_time .ne. ' ') go to 50 
c                                             
c   input base name and time interval                                      
c                                                                               
       write(6,*)' Base name, ,, for local directory, ',
     *'name of index file'
       write(6,*)' or return for default base'                               
c
       read(5,'(a40)') base_name                                                
       write(6,'(1x,a,$)')' Start time                       : '                      
       read(5,'(a14)') start_time                                               
       write(6,'(1x,a,$)')' End time, return for end of month: '                           
       read(5,'(a14)') end_time                                                 
 1     continue                                                                 
       write(6,*)' Compact output file (Y/N=default) '                          
	   read(5,'(a)') outf 	                    
	                                                                    
c                                                                               
c  reset counters                                                               
c
                                                                               
 50    nl=0                                                                     
       nr=0                                                                     
       nd=0                                                                     
       nevent=0                                                                 
       records=0                                                                
c                                                                               
c   open output file                                                            
c                                                                               
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    'collect.out',         ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.

c                                                                               
c  start read and write loop                                                    
c                                                                               
 5     continue                                                                 
c-- always use next event                                
       key='          '		
       CALL findevin                                                       
     * (base_name,start_time,end_time,key,0,
     * event_no,evfile,fstart,new_month,status)                                 
       if(status.eq.0) then                                                     
c--   (CLK)     
         inquire(file=evfile,exist=exist)                         
c--   (CLK)     
         if (exist) then                                          
            call sei open(old$+warn$,            ! Open an old file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    evfile,                ! File name
     &                    read01,                ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
         call indata(read01,nstat,nphase,nhead,nrecord,type,exp,data,id)
c
c                                                                               
c   count events etc                                                            
c                                                                               
           if(type.eq.'L') nl=nl+1                                              
           if(type.eq.'R') nr=nr+1                                              
           if(type.eq.'D') nd=nd+1                                              
           records=records+nrecord                                              
           nevent=nevent+1                                                      
c                                                                               
c  write event, only first line if compact desired                              
c                                                                               
	   if(outf.eq.'y'.or.outf.eq.'Y') nrecord=1		                                  
          write(write01,'(a80)',iostat=code)
     *          (data(i),i=1,nrecord)
          call sei code(fort$,code,write01,b_eof)
c                                                                               
c  print event name                                                             
c                                                                               
           write(6,'(1x,a79)') evfile(1:79)
           call sei close (close$,read01,code)
c-- (CLK)
         else                                                      
c-- (CLK)      
           write(6,'(1x,a60,a)') evfile(1:60),' doesn''t exist.'         
c-- (CLK)      
         endif                                                     
c-- back for next event                                         
         goto 5			
       else                                                                     
c-- 3 is end of time period                       
          if(status.eq.2) write(6,*)' End of index file'
          if(status.gt.3)       
     *    write(6,*)' ****** Something wrong, status= ', status                 
       endif                                                                    
c                                                                               
c  print out statistics                                                         
c                                                                               
      write(6,*)                                                                
      write(6,200)                                                       
 200  format(' Output file is collect.out  ')                                         
      write(6,*)                                                                
      write(6,201) nevent,nl,nr,nd,records                                      
 201  format(' Total number of events          ',i7,
     *     /,' Total number local events       ',i7                             
     *     /,' Total number of regional events ',i7                             
     *     /,' Total number of distant events  ',i7                             
     *     /,' Total number of records         ',i7)
      call sei close (close$,write01,code)
      stop                                                                      
      end                                                                       
                                                                                
                                                                                

CSTART***************************************************************************
C                                                                              *
C             List of modifications in this particular release                 *
C             ================================================                 *
C                                                                              *
C             Please remove the following lines when installed...              *C                                                                              *
CJAB(BGS)Jul27/1995 ...add wavefile handler routines...(in file LIBLOAD.FOR)   *
CJAB(BGS)Jul27/1995 ...remove th need for libsei1, by incorporating message    *
C                      handling on PC and UNIX in both graphics states in this *
C                      same routine                                            *
CJAB(BGS)Jul27/1995 ...Place all diagnostics flagged by "B_F_DEBUG$" to        *
C                      DBGUNIT$ rather than standard output                    *
CJAB(BGS)Sep 5/1995 ...Allocate debug unit to DBG_OUT$ in libsei.inc, this = 4 *
c
C oct  20 95 jh        Save record length when opening direct access files
c                      remove form= when opening direct acces files
c jul 22 98  mv jh     added routine seilcs to conver to lower case
c aug  16 by jh    :   -------- version 7.0 check------------------------------ 
c                       century, changed wav
c                      directory so it must have century, however file names
c                      can still be with only year until 2019. Not checked !!
c                      apparently no change needed for 5 letter wav data base
c                      names
C  sep 98    linux :   ok                                                      *
c  nov 25   jh     :   change search in wav data bases
c  feb 24   lo     :   bug in get_full_wav
c  mar 30 99 bmt   :   add pc_to_text 
c  mar 31 99 lo    :   add print_ver
c  jun 16 99 jh    :   change .cmd to .inp
c  sep 5 99  jh    :   change get_full_wav_name: was using wrong month when
c                      files had format 1999-11 ... Thanks griselda
c  sep 23          :   initialize geo_depths and herkij_distance
c  sep 24    lo    :   read epimap projection as real
c  feb 23    lo    :   read keep_auto_reg
c  feb 28    jh    :   add read of copy_wav_dir
c  mar 10    jh    :   add read of text_print
c  may 10          :   initialize merge_wav
c  oct 23    jh    :   add routine remove_letters, add read of high_accuracy
c  nov 7     lo    :   add cont parameters
c  mar 7     lo    :   bug fix in r_index, return 0 if char not found
c  april 4   lo    :   change in get_full_wav if file does not start with number
c  oct 9     jh    :   put cont variables to get_seisan_def
c  nov 1     lo    :   add cursortype to get_seisan_def
c  apr 10    lo    :   add myxfont to get_seisan_def, increased data to 120
c  may       jh    :   add AUTO_PROCESS
c  july      lo    :   also read continuous bases into wav_base
c  jun 1 04  jh    :   read merge_wav correctly with 5 chars instead of 3
c  jul 26 05 lo    :   change to get_full_wav_name calling seisarch, BGS
c  mat    06 lo    :   reading of cont bases in get_seisan_def
c  may    07 jh    :   do not return if file do not start with a number
c  oct 07 07 jh    :   gmap paramters
c  apr 21 08 pv    :   changed the read of the gmap_dir to 41:120
c
CEND****************************************************************************
C
CSTART**************************************************************************
C                                                                              *
C                             BGS/GSRG Computer Unit                           *
C                             ======================                           *
C                                                                              *
C      System  : SEISAN                                                        *
C      Library : LIBSEI.FOR                                                    *
C                                                                              *
C      Note 1) : In this library, all variables are explicitly defined,        *
C                including those found in the "INCLUDE" files (see note 2).    *
C                Thus their type is not limited to initial letter, except for  *
C                the following:                                                *
C                                                                              *
C              - character strings are prefixed with "CHR" and are defined in  *
C                the form CHARACTER  CHR_STRING *("value") where "value" is an *
C                integer. This is consistant where "value" is a parameter.     *
C                                                                              *
C              - logicals (booleans) are prefixed by "B".                      *
C                                                                              *
C                All external routines and function type are defined at the    *
C                start of the sub-program unit.                                *
C                                                                              *
C                Most sub-programs have one entry and one return point (the    *
C                exception is where an abort is made via "STOP"), usually      *
C                labelled "9999", and possibly an error section placed just    *
C                before the return point, with labels "9000" and greater.      *
C                                                                              *
C                BLOCK data sub-programs are to be found at the end of the     *
C                library, prefixed by "BD_".                                   *
C                                                                              *
C           2) : All variables with suffix "$" are those which are found in    *
C                their respective "INCLUDE" files and, due to this naming      *
C                convention, can be used throughout the user's program         *
C                without fear of conflict, as long as the user does not adopt  *
C                this same convention for his/her usual variable names.        *
C                However, the relevant "INCLUDE" file must appear in the       *
C                calling program or sub-program. All definitions and COMMON    *
C                variables are linked in this way.                             *
C                                                                              *
C           3) : When in PC graphics mode, text-writing to standard output     *
C                hangs the screen. If this occurs then the only course of      *
C                action is to re-boot the PC.                                  *
C                                                                              *
C                Messages should only be written when the common boolean       *
C                variable B_F_MESSAGE$ is set TRUE.                            *
C                                                                              *
C                By default, this is always initialised TRUE by block data.    *
C                However, it should only be modified by graphics initialisation*
C                and state changing which are found in the plotting library    *
C                "seiplot.for". Thus when graphics are not encountered, this is*
C                not affected. Otherwise, the boolean is set by these routines *
C                either explicitly, or by:                                     *
C                                                                              *
C                          B_F_MESSAGE$ = .not.( B_F_PC$ .and. B_F_GRAPH$ )    *
C                                                                              *
C                See the block data and the include file "libsei.inc" for      *
C                definitions and meanings.                                     *
C                                                                              *
C                With PC fatal errors, the graphics state is changed to alpha  *
C                before writing the error message, using routine "PC_TO_TEXT", *
C                which when active also sets this boolean TRUE. All other      *
C                messages are suppressed if the boolean is set FALSE.          *
C                                                                              *
C                On the UNIX platform, this is a dummy routine linked via      *
C                "comp_sun.o".                                                 *
C                On the PC, when no graphics are encountered, this is a dummy  *
C                routine linked via "pcdumt.obj".                              *
C                On the PC, when graphics are encountered, this is an active   *
C                routine which calls "CLEAR_TO_ALPHA", linked via "pctext.obj".*
C                                                                              *
C           4) : When the common variable "B_F_DEBUG$" is set TRUE, all        *
C                diagnostic messages are written to the debug file which is    *
C                given by "CHR_DBG_FILE$", defaulted to "libsei_debug$", and   *
C                is opened on unit "DBGUNIT$ ".                                *
C                                                                              *
C      WARN:     If this boolean (logical) variable is used in the user source *
C                code as a flag to write diagnostic messages to standard output*
C                and the program is in the PC graphics state then see note 3.  *
C                                                                              *
C      Author  : J. A. Bolton                                                  *
C      Date    : July 1995                                                     *
C      Version : V01                                                           *
C                                                                              *
CEND****************************************************************************
C
C      EXTERNAL   SEI OPEN        ! Open file handler.
C     &          ,SEI CLEN        ! Find length of a character string.
C     &          ,SEI CLOSE       ! Close files opened by SEI OPEN.
C     &          ,SEI CODE        ! Error condition handler.
C     &          ,SEI GETU        ! Get next available fortran unit (SEI OPEN).
C     &          ,SEI UPC         ! Convert a character string to uppercase.
C     &          ,SEI GET FILE    ! To open file in current/ standard directory.
C     &          ,SEI LEFT        ! To left justify a character string.
C     &          ,SEI CMD PRO     ! To process standard I/O or command stream.
C     &          ,SEI CMD SET     ! Open up command stream I/O files.
C     &          ,SEI GET VALUES  ! Parse a text string for number items.
C     &          ,SEI REAL NUM    ! Return a real number from a text item.
C     &          ,SEI INTEGER     ! Return an integer from a text item.
C     &          ,BD_ERROR        ! Block data common for error handling.
C     &          ,BD_FILEIO       ! Block data common for file handling.
C      INTEGER    SEI CLEN        ! Function.
C     &          ,SEI INTEGER     ! Ditto.
C      REAL       SEI REAL NUM    ! Et ditto.
C
C     Note the following routines in the extension library, LIBLOAD.FOR:
C
C      EXTERNAL   SEI LOAD        ! Load waveform file data
C     &          ,SEI BASELINE    ! Remove DC component from wave on baseline.
C     &          ,SEI MEAN AMP    ! Mean amplitude algorithm.
C      REAL       SEI BASELINE    ! Remove DC component from wave on baseline.
C     &          ,SEI MEAN AMP    ! Mean amplitude algorithm.
C
C************************* End of list ***********************************
C
C
      INTEGER FUNCTION SEI CLEN(CHR_STRING)
CSTART*************************************************************************
C                                                                             *
C    System           : SEI  Application Library                              *
C    Supplier         : BGS/SEI  Systems Programming Unit                     *
C    Module Name      : SEI CLEN                                              *
C    Purpose          : Return the actual length of a character string        *
C                       ignoring trailing spaces and non-printables.          *
C    Arguments -Input : CHR_STRING (C*) Character string                      *
C    Author           : J. A. Bolton                                          *
C    Date             : 23 November 1994                                      *
C    Version          : V01                                                   *
C                                                                             *
CEND***************************************************************************
C
      INTRINSIC    ICHAR, LEN
C
C    Argument
C    ========
C
      CHARACTER CHR_STRING*(*)               ! String to find length of.
C
C    Local variables...
C    ==================
C
      INTEGER        IX, IY,                 ! Very local.
     &               BLANK,                  ! Values of characters.
     &               A,                      ! Lowercase "a".
     &               Z,                      ! Ditto "z".
     &               LENGTH                  ! Dimension of string.
C
C    Initialise...
C    =============
C    The following are the delimiter characters to non-printing characters...
C    ------------------------------------------------------------------------
C
      BLANK = ICHAR(' ')                     ! Space.
      Z     = ICHAR('z')                     ! Small z.
      A     = ICHAR('a')                     ! Small a.
C
C    Empty string...
C    ===============
C
      IF( CHR_STRING .EQ. ' ' ) THEN           ! Blank string.
      SEI CLEN = 0                             ! Zero length.
C
C    Work backwards from end of string....
C    =====================================
C    Initialise....
C    --------------
C
      ELSE                                       ! Otherwise.
      LENGTH = LEN( CHR_STRING )                 ! Maximum length of string. 
      DO 1 IX = LENGTH, 0, -1                    ! Loop backwards.
      IF(IX .GT. 0) IY = ICHAR(CHR_STRING(IX:IX))! Get character representation.
C
C    Empty...
C
         IF( IX .EQ. 0 ) THEN                   ! Empty string.
         SEI CLEN = 0                           ! & set value.
C
C    Not empty..
C
         ELSE IF( IY .GT. BLANK   .AND.         ! Skip loop.
     &            IY .LE. Z       .AND.         ! Found.
     &            IY .NE. A-1   ) THEN          ! 
         SEI CLEN = IX                          ! Set value.
         GOTO 9999                              ! & return.
         END IF                                 !
1     CONTINUE                                  !
      END IF                                    !
C
C    Return to Caller...
C    ===================
C
9999  RETURN
      END
C
      SUBROUTINE SEI CLOSE( FUNC, UNIT, CODE )
C
CSTART**************************************************************************
C                                                                              *
C   System            : SEI  Validation & Application Library                  *
C   Supplier          : BGS/GSRG  Applications Programming Unit                *
C   Procedure Name    : SEI CLOSE                                              *
C   Purpose           : To close the file on unit and delete depending on:     *
C                       FUNC     = CLOSE$  Close file on unit.                 *
C                       FUNC     = DELETE$ Close file on unit & delete         *
C                       Add        ALL$    to process each file open           *
C                                                                              *
C                       The routine will always HALT with a message on any     *
C                       error condition, unless the following                  *
C                                                                              *
C                       add        WARN$   to exit to caller on non-fatal error*
C                                          with a message.                     *
C                                                                              *
C   Arguments  -Input : FUNC       (I*4) The operations vector.                *
C                     : UNIT       (I*4) Fortran unit number                   *
C              -Output: CODE       (I*4) Returned condition                    *
C                     : UNIT       (I*4) Fortran unit number= 0 for single file*
C                                                                              *
C   Author            : J. A. Bolton                                           *
C   Date              : 23 November 1994                                       *
C   Version           : V01                                                    *
C                                                                              *
CEND***************************************************************************
C
      EXTERNAL     SEI CLEN       ! String length function
     &            ,PC_TO_TEXT     ! Close down graphics.
      INTEGER      SEI CLEN       ! & function.
C
C    System definitions....
C    ======================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
C
C    Argument declarations....
C    =========================
C
      INTEGER*4         FUNC,               ! Operational functionality.
     &                  CODE,               ! Returned condition.
     &                  UNIT                ! File unit.
C
C    Local variables...
C    ==================
C
      INTEGER*4         F_UNIT,             ! Local file unit.
     &                  FUNCT,              ! Working function.
     &                  FUNCTION,           ! Local function.
     &                  IX,     IZ          ! Very local.
      LOGICAL*4         B_OPEN,             ! File open?
     &                  B_WARN,             ! Warn, not halt, on error?.
     &                  B_ALL               ! Operate on all files open.
C
C     1. Initialise....
C     =================
C
      CODE = E_OK$                                ! Set returned condition.
      FUNCT    = FUNC                             ! Set working function.
      FUNCTION = MOD(FUNCT,WARN$)                 ! Local function.
      FUNCT    = FUNCT - FUNCTION                 ! Major function.
      B_WARN   = FUNCT .EQ. WARN$                 ! Warn caller?.
C
      IF( FUNCT .EQ. IGNORE$ ) GOTO 9300          ! Invalid function.
      FUNCT    = FUNCTION                         ! Working function
      FUNCTION = MOD(FUNCT,OLD$)                  ! Local function.
      FUNCT    = FUNCT - FUNCTION                 ! Major function.
      B_ALL    = FUNCT .EQ. ALL$                  ! All files?.
C
C     2.  Loop all open files...
C     ==========================
C
      IF( B_ALL ) THEN                      !  Operate on all open units.
C
C    2.1. Check the file unit is actually open...
C    --------------------------------------------
C
2000  IZ = INDEX( CHR_MAP$, 'O' )                         ! Location in map.
      IX = F_MAXU$ - IZ                                   ! Next open unit.
C
         IF( IX .LT. F_MAXU$ ) THEN                       ! Unit flagged open.
         INQUIRE( UNIT= IX, OPENED=B_OPEN, IOSTAT= CODE ) ! Unit open?.
         IF( CODE .NE. E_OK$ ) GOTO 9000                  ! On error.
C
C    2.2. Close & delete if required....
C    -----------------------------------
C
            IF( B_OPEN ) THEN                            !
               if( b_f_debug$ ) then                     ! Debug information.
               write(dbgunit$,*)'...closing: ',          ! Message.
     &         chr_file_open$(ix)(:seiclen(chr_file_open$(ix)))
               write(dbgunit$,*)'   on unit: ', ix       !
               end if                                    !
C
               IF( FUNCTION .EQ. CLOSE$ ) THEN           ! Close only.
               CLOSE( IX, STATUS='KEEP', IOSTAT=CODE )   !
               IF( CODE .NE. E_OK$ ) GOTO 9100           ! On error.
C
               ELSE IF( FUNCTION .EQ. DELETE$ ) THEN     ! Close & delete.
               CLOSE( IX, STATUS='DELETE', IOSTAT=CODE ) !
               IF( CODE .NE. E_OK$ ) GOTO 9200           ! On error.
C
               ELSE                                      ! Invalid option.
               GOTO 9300                                 ! Error.
               END IF                                    !
C
C    2.2.1 Remove details from map...
C
            CHR_MAP$(IZ:IZ) = ' '                 ! & remove from map.
            CHR_FILE_OPEN$(IX) = ' '              ! & list of open files.
            GOTO 2000                             ! Next unit.
C
C    2.3. Unit should be open... it is flagged so....
C    ------------------------------------------------
C
            ELSE                                       !
            GOTO 9400                                  ! Error.
            END IF                                     !
         END IF                                        !
C
C     3. Close and/or delete a single file unit supplied.....
C     =======================================================
C     3.1 Unit supplied is zero and invalid...
C     ----------------------------------------
C
      ELSE IF( UNIT .LE. 0 ) THEN                           ! Invalid.
      F_UNIT = UNIT                                         ! Copy input.
      GOTO 9600                                             ! & message.
C
C     3.2 Check that the file is open...
C     ----------------------------------
C
      ELSE                                                  ! Single file.
      F_UNIT = UNIT                                         ! Copy unit.
      IX     = F_UNIT                                       ! & save
      IZ     = F_MAXU$ - F_UNIT                             ! Map position.
      INQUIRE( UNIT= F_UNIT, OPENED= B_OPEN, IOSTAT= CODE ) ! Unit open?.
      IF( CODE .NE. E_OK$ ) GOTO 9000                       ! On error.
C
C     3.3.   Close & delete if required....
C     =====================================
C
         IF( B_OPEN .AND. CHR_MAP$(IZ:IZ) .EQ. 'O' ) THEN ! 
            if( b_f_debug$ ) then                         ! Debug information.
            write(dbgunit$,*)'...closing: ',              ! Message.
     &      chr_file_open$(ix)(:seiclen(chr_file_open$(ix)))
            write(dbgunit$,*)'   on unit: ', f_unit       !
            end if                                        !

            IF( FUNCTION .EQ. CLOSE$ ) THEN               ! Close only.
            CLOSE( F_UNIT, STATUS='KEEP', IOSTAT=CODE )   !
            IF( CODE .NE. E_OK$ ) GOTO 9100               ! On error.
C
            ELSE IF( FUNCTION .EQ. DELETE$ ) THEN         ! Close &delete.
            CLOSE( F_UNIT, STATUS='DELETE', IOSTAT=CODE ) !
            IF( CODE .NE. E_OK$ ) GOTO 9200               ! On error.
C
            ELSE                                          ! Invalid.
            GOTO 9300                                     ! Error.
            END IF                                        !
C
         UNIT = -1                                        ! Re-initialise.
         CHR_MAP$(IZ:IZ) = ' '                            ! & remove from map.
         CHR_FILE_OPEN$(IX) = ' '                         ! & open files list.
C
C    3.3.1. Open but not flagged.....
C    --------------------------------
C
         ELSE IF( B_OPEN ) THEN                           !
         GOTO 9500                                        ! Force error.
C
C    3.3.2. Flagged but unit not open...
C    -----------------------------------
C
         ELSE IF( CHR_MAP$(IZ:IZ) .EQ. '0' ) THEN         !
         GOTO 9400                                        ! Force error.
C
C    3.3.3  Not open and not flagged....
C    -----------------------------------
C
         ELSE                                             ! Otherwise.
         GOTO 9600                                        ! Invalid.
         END IF                                           ! 
      END IF                                              !
      GOTO 9999                                           ! Successful.
C
C     9. Errors.....
C     ==============
C
9000  IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &    CALL PC_TO_TEXT                           ! Then text mode.
C
      IF( B_F_MESSAGE$ ) THEN                       ! & message.
      WRITE(*,*) 
      WRITE(*,*)
     &'**** ERROR: problem checking file open             ****'
      WRITE(*,*)'            ',
     &CHR_FILE_OPEN$(IX)(:SEICLEN(CHR_FILE_OPEN$(IX)))
      WRITE(*,*)'     FORTRAN condition ', CODE           !
      WRITE(*,*)
     &'****                                               ****'
      END IF
      GOTO 9998                                           ! 
C
9100  IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &    CALL PC_TO_TEXT                           ! Then text mode.
C
      IF( B_F_MESSAGE$ ) THEN                       ! & message.
      WRITE(*,*)
      WRITE(*,*)
     &'**** ERROR: problem closing file                   ****'
      WRITE(*,*)'            ',
     &CHR_FILE_OPEN$(IX)(:SEICLEN(CHR_FILE_OPEN$(IX)))
      WRITE(*,*)'     FORTRAN condition ', CODE           !
      WRITE(*,*)
     &'****                                               ****'
      END IF
      GOTO 9998                                           !
C
9200  IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &    CALL PC_TO_TEXT                           ! Then text mode.
C
      IF( B_F_MESSAGE$ ) THEN                       ! & message.
      WRITE(*,*)
      WRITE(*,*)
     &'**** ERROR: problem deleting file                  ****'
      WRITE(*,*)'            ',
     &CHR_FILE_OPEN$(IX)(:SEICLEN(CHR_FILE_OPEN$(IX)))
      WRITE(*,*)'     FORTRAN condition ', CODE           !
      WRITE(*,*)
     &'****                                               ****'
      END IF
      GOTO 9998                                           !
C
9300  IF( (.NOT.B_F_MESSAGE$) )                     ! Fatal; graphics on pc.
     &    CALL PC_TO_TEXT                           ! Then text mode.
      WRITE(*,*)
      WRITE(*,*)
     &'**** ERROR: invalid argument FUNCTION              ****'
      WRITE(*,*)'            ',
     &CHR_FILE_OPEN$(IX)(:SEICLEN(CHR_FILE_OPEN$(IX)))
      WRITE(*,*)
     &'****                                               ****'
      B_WARN = .FALSE.
      GOTO 9998                                           !
C
9400  IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &    CALL PC_TO_TEXT                           ! Then text mode.
C
      IF( B_F_MESSAGE$ ) THEN                       ! & message.
      WRITE(*,*)
      WRITE(*,*)
     &'**** ERROR: file opened by SEI OPEN is not open    ****'
      WRITE(*,*)'            ',
     &CHR_FILE_OPEN$(IX)(:SEICLEN(CHR_FILE_OPEN$(IX)))
      WRITE(*,*)
     &'****                                               ****'
      END IF
      GOTO 9998                                           !
C
9500  IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &    CALL PC_TO_TEXT                           ! Then text mode.
C
      IF( B_F_MESSAGE$ ) THEN                       ! & message.
      WRITE(*,*)
      WRITE(*,*)
     &'**** ERROR: open file not opened by SEI OPEN       ****'
      WRITE(*,*)'             unit ', F_UNIT
      WRITE(*,*)
     &'****                                               ****'
      END IF
      GOTO 9998                                           !
C
9600  IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &    CALL PC_TO_TEXT                           ! Then text mode.
C
      IF( B_F_MESSAGE$ ) THEN                       ! & message.
      WRITE(*,*)
      WRITE(*,*)
     &'**** ERROR: ambiguous unit supplied to SEI CLOSE   ****'
      WRITE(*,*)'             unit ', F_UNIT
      WRITE(*,*)
     &'****                                               ****'
      END IF
      GOTO 9998                                           !
C
C    10. ABORT point.....
C    ====================
C
9998  IF( B_WARN ) THEN                                   ! Warn, no action.
      CONTINUE                                            !
C
      ELSE                                                ! Otherwise.
      WRITE(*,*)
     &'****                                               ****'
      WRITE(*,*)
      WRITE(*,*)
     &'**** WARN: halting program in SEI CLOSE            ****'
      STOP                                       !
      END IF                                     !
C
C     Return to caller....
C     ====================
C
9999  RETURN
      END                                    
C
      SUBROUTINE SEI CMD PRO( CHR_PROMPT, CHR_TEXT )
C
CSTART*************************************************************************
C                                                                             *
C   System          : SEISAN                                                  *
C   Supplier        : BGS/GSRG Applications Programming Unit                  *
C   Procedure Name  : SEI CMD PRO                                             *
C   Purpose         : To process text retrieved either from standard input or *
C                     from a command file and write this to an output file    *
C                     if required.                                            *
C                     In particular, if both arguments are blank, then write  *
C                     the premature end of file message and stop.             *
C   Note            : No PC graphics treatment of messages to standard output *
C                     is required here!.                                      *
C                                                                             *
C   Arguments-Input : CHR_TEXT   (C*)  Input text string.                     *
C                   : CHR_PROMPT (C*)  Input prompt string. If blank, do not  *
C                                      prompt and retrieve data. Instead      *
C                                      process to the output file when necess-*
C                                      ary.                                   *
C           -Output : CHR_TEXT   (C*)  Retrieved text in reply to a prompt    *
C                                      when given.                            *
C                                                                             *
C   Author          : J. A. Bolton                                            *
C   Date            : 2 December 1994                                         *
C   Version         : V01                                                     *
C                                                                             *
CEND***************************************************************************
C
      EXTERNAL   SEI CLEN, SEI LEFT
      INTEGER*4  SEI CLEN
C
C    System inserts....
C    ==================
C
      INCLUDE  'libsei.inc'                ! Library definitions & data defns.
C
C    Arguments.....
C    ==============
C
      CHARACTER   CHR_PROMPT *(*),         ! Prompt string.
     &            CHR_TEXT   *(*)          ! Text to process.
C
C    Local variables...
C    ==================
C
      INTEGER*4   CODE                     ! Local condition.
      LOGICAL*4   B_FLAG,                  ! End of file?.
     &            B_PEOF                   ! Premature eof only.
C
C    Initialise...
C    =============
C
      CODE = E_OK$                         ! Everything's fine!!!.
      B_PEOF = CHR_PROMPT .EQ. ' '  .AND.  ! Force premature end of file!.
     &         CHR_TEXT   .EQ. ' '         !
C
C    =============================================
C    Prompt when required and process the reply...
C    =============================================
C
      IF( CHR_PROMPT .NE. ' ' ) THEN                        ! A prompt to make.
      WRITE(*,'(A,A,A,$)') ' ',CHR_PROMPT(:SEICLEN(CHR_PROMPT))
     &,' ' ! Prompt it.
      READ(CMDUNIT$,'(A)',IOSTAT=CODE) CHR_TEXT             ! Get a reply.
      CALL SEI LEFT( CHR_TEXT )                             ! Left justify
      CALL SEI CODE( FORT$,                                 ! Fortran condition.
     &               CODE,                                  ! From reply.
     &               CMDUNIT$,                              ! From command file.
     &               B_PEOF )                               ! End of file?.
C
C    =================================================
C    No prompt, read from input command file stream...
C    =================================================
C
      ELSE IF( CMDUNIT$ .NE. STD_IN$ ) THEN     ! Command file input.
      READ(CMDUNIT$,'(A)',IOSTAT=CODE) CHR_TEXT ! Get a record.
      CALL SEI LEFT( CHR_TEXT )                 ! Left justify
      CALL SEI CODE( FORT$,                     ! Fortran condition.
     &               CODE,                      ! From reply.
     &               CMDUNIT$,                  ! From command file.
     &               B_PEOF )                   ! End of file?.
C
C    ==========================================
C    Otherwise left justify the input string...
C    ==========================================
C
      ELSE                                              ! Otherwise.
      CALL SEI LEFT( CHR_TEXT )                         ! Left justify
      END IF                                            !
C
C    =============================================
C    Force premature end of file message & stop...
C    =============================================
C
1000  IF( B_PEOF ) THEN                                 ! Force stop.
      WRITE(*,*)
     &'****                                                ****'
      WRITE(*,*)                                        ! 1st line of
     &'**** ERROR: contents of command file, specified on  ****'
      WRITE(*,*)                                        ! Special message.
     &'****        the command line, are incomplete        ****'
      CHR_ERR_MSG$ =
     &'****                                                ****'
      CALL SEI CODE( STOP$,                             ! Force halt.
     &               E_PEOF$,                           ! On premature eof.
     &               0,                                 ! Unit (n/a).
     &               B_FLAG )                           ! Flag (n/a).
C
C    ========================================================
C    Write text to the output command stream file, or else if
C    unavailable, read from the input stream & echo to the user...
C    ========================================================
C
      ELSE IF( PARUNIT$ .NE. STD_OUT$ ) THEN ! Not standard output.
      WRITE(PARUNIT$,'(A)',IOSTAT=CODE)      ! Write to output file.
     &      CHR_TEXT(:SEICLEN(CHR_TEXT))     ! The input or retrieved text.
      CALL SEI CODE( FORT$,                  ! Fortran condition.m
     &               CODE,                   ! Returned from.
     &               PARUNIT$,               ! Output command file.
     &               B_FLAG )                ! Flag (n/a).
C
C    Echo after reading from command stream...
C    -----------------------------------------
C
      ELSE IF( CMDUNIT$ .NE. STD_IN$ ) THEN  ! Command file input.
      WRITE(*,*)CHR_TEXT(:SEICLEN(CHR_TEXT)) ! & echo to user.
      END IF                                 !
C
C    Return to Caller...
C    ===================
C
9999  RETURN
      END
C
      SUBROUTINE SEI CMD SET( CHR_PROG )
C
CSTART*************************************************************************
C                                                                             *
C   System          : SEISAN                                                  *
C   Supplier        : BGS/GSRG Applications Programming Unit                  *
C   Procedure Name  : SEI CMD SET                                             *
C   Purpose         : To determine and retrieve any argument from the command *
C                     line and dependent on this, open up either the command  *
C                     stream file for input or for output.                    *
C                                                                             *
C   Arguments-Input : CHR_PROG   (C*)  Name of the routine which is the basis *
C                                      of the command file name.              *
C           -Output : None                                                    *
C   Note            : CMDUNIT$ = STD_IN$ for standard input (*)               *
C                     PARUNIT$ = "unit"  for output             OR            *
C                     CMDUNIT$ = "unit"  for input                            *
C                     and strings echoed to STD_OUT$        (*)               *
C                                                                             *
C   Author          : J. A. Bolton                                            *
C   Date            : 2 December 1994                                         *
C   Version         : V01                                                     *
C                                                                             *
CEND***************************************************************************
C
      EXTERNAL    GET_ARGUMENTS        ! From command line.
      EXTERNAL    SEI CLEN             ! String length.
      INTEGER     SEI CLEN             ! Function.
C
C    System inserts....
C    ==================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
C
C    Arguments.....
C    ==============
C
      CHARACTER   CHR_PROG *(*)  ! program name.
C
C    Local variables...
C    ==================
C
      INTEGER     CODE,              ! Local condition.
     &            ARGS_N,            ! # arguments on command line.
     &            TEXT_C             ! Text string length.
      PARAMETER  (TEXT_C = 80)       ! & value.
      CHARACTER   CHR_TEXT *(TEXT_C) ! & text.
      LOGICAL     B_FLAG             ! Flag it?.
C
C    Initialise...
C    =============
C
      CALL GET_ARGUMENTS( ARGS_N, CHR_TEXT ) ! Get text of arguent.
C
C    Command file input...
C    =====================
C
      IF( ARGS_N .GT. 0 ) THEN       ! Argument given.
      CALL SEI OPEN( OLD$,           ! Open (default stop on error).
     &         ' ',                  ! No prompt.
     &         CHR_TEXT,             ! Filename.
     &         CMDUNIT$,             ! Opened command stream.
     &         B_FLAG,               ! Flag exists.
     &         CODE )                ! Condition (n/a).
C
C    Open the command file to output the commands from standard input...
C    ===================================================================
C
      ELSE                                       ! Otherwise standard input.
      CHR_TEXT = CHR_PROG(:SEICLEN(CHR_PROG)) // ! Output file name.
     &           '.inp'                          ! 
      CALL SEI OPEN( UNKNOWN$,                   ! Open (default stop on error).
     &               ' ',                        ! No prompt.
     &               CHR_TEXT,                   ! File.
     &               PARUNIT$,                   ! Output unit.
     &               B_FLAG,                     ! Flag exists.
     &               CODE )                      ! Condition (n/a).
      END IF                                     !
C
C    Return to Caller...
C    ===================
C
9999  RETURN
      END
C
      SUBROUTINE SEI CODE( FUNC, CODE, UNIT, B_FLAG )
C
CSTART*************************************************************************
C                                                                             *
C   System          : SEISAN  Application Library                             *
C   Supplier        : BGS/SEI  Applications Programming Unit                  *
C   Procedure Name  : SEI CODE                                                *
C   Purpose         : To encode and store error codes depending on whether the*
C                     input code is a SEISAN (local) or FORTRAN condition,    *
C                     dependant on the condition.                             *
C
C                     The routine will normally HALT the program on error, or *
C                     if WARN$ is included, will exit to the caller.          *
C                                                                             *
C                     The allocated message can be replaced by a customised   *
C                     message set up by the caller, in the string CHR_ERR_MSG$*
C                     but this will be re-initialised to blank on exit        *
C                                                                             *
C   Arguments - NOTE: All arguments are assumed to be 4 bytes.                *
C                     Whereas all SEISAN (local) conditions can be supplied by*
C                     a constant, FORTRAN conditions (when UNIT not zero) must*
C                     be supplied as a variable, since it is converted into a *
C                     local condition...we must not try to change a machine   *
C                     constant!!!                                             *
C                                                                             *
C            -Input : FUNC       (I*4) Functionality of routine:              *
C                                      = STOP$ (=0) HALT program on error     *
C                                      = WARN$      Return condition to caller*
C                                      + FORT$      To trap any fortran       *
C                                                   conditions where unit is  *
C                                                   not open                  *
C                   : CODE       (I*4) Input code (local or fortran)          *
C                   : UNIT       (I*4) Fortran unit or zero for local         *
C            -Output: CODE       (I*4) Output (local) code                    *
C                     B_FLAG     (L*4) Flag end of file condition or change in*
C                                      error condition.                       *
C                                                                             *
C   Author          : J. A. Bolton                                            *
C   Date            : 23 November 1994                                        *
C   Version         : V01                                                     *
C                                                                             *
CEND***************************************************************************
C
      EXTERNAL     SEI CLEN       ! String length function
     &            ,SEI CLOSE      ! File closure.
     &            ,PC_TO_TEXT     ! Close down graphics.
      INTEGER      SEI CLEN       ! & function.
C
C    System inserts....
C    ==================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
C
C    Arguments.....
C    ==============
C
      INTEGER*4    FUNC,                    ! Functionality of routine.
     &             UNIT,                    ! Fortran unit or zero.
     &             CODE                     ! Input/output condition.
      LOGICAL*4    B_FLAG                   ! Flag end of file condition.
C
C    Local variables....
C    ===================
C
      INTEGER*4    IX,                      ! Very local.
     &             KODE,                    ! Alternative condition.
     &             FUNCTION                 ! Working functionality.
      LOGICAL*4    B_OK,                    ! Everything ok?.
     &             B_FORTRAN,               ! Fortran condition?.
     &             B_WARN                   ! Warn caller, not halt?.
C
C    Preliminaries...
C    ================
C
      IX        = MOD( FUNC, WARN$ )        ! Fortran forcing function.
      FUNCTION  = FUNC - IX                 ! Working function.
C
      B_FLAG    = .FALSE.                   ! Re-initialise.
      B_OK      = CODE     .EQ. E_OK$       ! Re-initalise error vector?.
      B_WARN    = FUNCTION .EQ. WARN$       ! Warn user.?
      B_FORTRAN = UNIT     .GT. 0      .OR. ! Fortran file error.
     &            IX       .EQ. FORT$       ! Or forced fortran functionality.
C
C    Re-initialise error vector...
C    =============================
C
      IF( B_OK ) THEN                       ! No error.                  (L11).
      ERROR$(1) = E_OK$                     ! Local error.
      ERROR$(2) = E_OK$                     ! System error.
      GOTO 9999                             ! Return to caller.
C
C    Process FORTRAN I/O condition...
C    ================================
C
      ELSE IF( B_FORTRAN ) THEN             ! Fortran i/o
C
C    Unit not open...
C    ----------------
C
         IF( UNIT .EQ. -1 ) THEN            ! Unit is not open.
         ERROR$(1) = E_RDWR$                ! Read-write-file error.
         ERROR$(2) = CODE                   ! & system code.
         CODE      = ERROR$(1)              ! Set local condition.
C
         IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &       CALL PC_TO_TEXT                           ! Then text mode.
C
            IF( B_F_MESSAGE$ ) THEN                    ! & message.
            WRITE(*,*)
     &'****                                                ****'
            WRITE(*,*)
     &'           FORTRAN condition : ', ERROR$(2)
            END IF   
C
         CHR_ERR_MSG$ =                     ! Set message, no over-ride.
     &'           ...file unit not open'
         GOTO 9000                              ! & message.
C
C    End of file....
C    ---------------
C
         ELSE IF( CODE .LT. E_OK$ ) THEN    ! End of file.
         ERROR$(1) = E_OK$                  ! Re-set error.
         ERROR$(2) = E_OK$                  ! Ditto.
         CODE      = ERROR$(1)              ! Set local condition.
         B_FLAG    = .TRUE.                 ! Flag end of file.
         GOTO 9999                          ! Return to caller.
C
C    System errors....
C    -----------------
C
         ELSE                                   ! File function error.
         ERROR$(1) = E_RDWR$                    ! Read-write-file error.
         ERROR$(2) = CODE                       ! & system code.
         CODE      = ERROR$(1)                  ! Set local condition.
C
         IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) ) ! Fatal; graphics on pc.
     &       CALL PC_TO_TEXT                           ! Then text mode.
C
            IF( B_F_MESSAGE$ ) THEN                    ! & message.
            WRITE(*,*)
     &'****                                                ****'
            WRITE(*,*)
     &'           FORTRAN condition : ', ERROR$(2)
            WRITE(*,*)
     &'           FORTRAN I/O unit  : ', UNIT
            END IF
C
            IF( CHR_ERR_MSG$ .EQ. ' ' ) THEN    ! Can allocate message.
            CHR_ERR_MSG$ = CHR_ERR_TXT$(E_RDWR$)! Set the error message.
            END IF                              !
         GOTO 9000                              ! & message.
         END IF                                 ! 
C
C    Process local condition...
C    ==========================
C
      ELSE                                  ! Local code.
      B_FLAG    = ERROR$(1) .NE. CODE .AND. ! Changed the error?.
     &            ERROR$(1) .NE. E_OK$      !
      ERROR$(1) = CODE                      ! & store.
      ERROR$(2) = E_OK$                     ! Not a fortran condition.
C
         IF( CHR_ERR_MSG$ .EQ. ' ' ) THEN   ! Can allocate a message.
         CHR_ERR_MSG$ = CHR_ERR_TXT$(CODE)  ! Set the error message.
         END IF                             !
C
C    Unrecoverable errors...
C
      DO 1000 IX = 1, E_FAIL_MX$                     ! Loop unrecoverables.
         IF( CODE .EQ. E_FAIL$(IX) )THEN             ! Unrecoverable.   
         B_WARN = .FALSE.                            ! Must halt.
         IF( .NOT.B_F_MESSAGE$ ) CALL PC_TO_TEXT     ! Fatal; graphics on pc.
         GOTO 9000                                   ! & message.
         END IF                                      !       
1000  CONTINUE                                       !
      END IF                                         !   
C
C    Errors....
C    ==========
C
9000  IF( B_F_MESSAGE$ ) THEN
      WRITE(*,*)
     &'****                                                ****'
      WRITE(*,*)
     &    CHR_ERR_MSG$(:SEICLEN(CHR_ERR_MSG$))
      END IF
C
C    Abort the program?...
C    =====================
C
      IF( B_WARN ) THEN                          ! Warning only.
      CONTINUE                                   ! No further action.
C
      ELSE                                       ! Otherwise abort.
      IF( .NOT.B_F_MESSAGE$ ) CALL PC_TO_TEXT    ! Not necessary!!
      WRITE(*,*)
     &'****                                                ****'
      WRITE(*,*)
     &'**** WARN: halting program in SEI CODE              ****'
C
      WRITE(*,*)
     &'****       ...closing down files                    ****'
C
      CALL SEI CLOSE(CLOSE$+ALL$,                ! Close all files.
     &               0,                          ! File unit (n/a).
     &               KODE )                      ! Returned condition (n/a).
C
      STOP                                       !
      END IF                                     !
C
C    Return to caller...
C    ===================
C
9999  CHR_ERR_MSG$ = ' '                         ! Empty the message.
      RETURN                                    
      END                                    
C
      SUBROUTINE SEI GET FILE( FUNCTION,
     &                         UNIT, CODE,
     &                         CHR_UFD_PATH, CHR_FILE)
CSTART**************************************************************************
C                                                                              *
C   System            : SEI  Validation & Application Library                  *
C   Supplier          : BGS/GSRG  Applications Programming Unit                *
C   Procedure Name    : SEI GET FILE                                           *
C   Purpose           : To find &/or open a particular file in the current     *
C                       directory or if not found, in the directory            *
C                           $SEISAN_TOP/"CHR_UFD_PATH"                         *
C                       depending on function                                  *
C                       If the path is the Wave directory "WAV", then finally  *
C                       search the year/month sub-directory specified in the   *
C                       filename pre-fix text.                                 *
C                                                                              *
C   Arguments  -Input : FUNCTION     (I*) Function to perform. Values are:     *
C                                         OPEN$ - find and open file           *
C                                         CHECK$- find file & return pathname  *
C                                         To cancel messages, add IGNORE$      *
C                     : CHR_FILE     (C*)  filename                            *
C                     : CHR_UFD_NAME (C*) Particular standard directory path   *
C                                         eg. DAT, WAV, REA/BER/91/10          *
C              -Output: UNIT         (I)   Fortran unit number                 *
C                     : CODE         (I)   Returned condition                  *
C                                                                              *
C   Note              : If just checking for existance, or ignoring messages   *
C                       and file not found, then return condition and re-set   *
C                       the "file-open-set-up-detail" to nullify the default   *
C                       re-set action taken by "sei open".                     *
C                                                                              *
C   Author            : J. A. Bolton                                           *
C   Date              : 23 November 1994                                       *
C   Version           : V01                                                    *
C                                                                              *
CEND***************************************************************************
C
      EXTERNAL     SEI CLEN      ! String length function
      INTEGER      SEI CLEN      ! & function.
      EXTERNAL     SEI OPEN,     ! Open file handler.
     &             SEI CODE      ! & error handler.
C
      EXTERNAL     TOP DIR       ! Root pathname from environment.
     &            ,DIR_CHAR      ! Directory path delimiter.
     &            ,GET_ENV_BASE  ! Get environment database.
     &            ,GET_DEF_BASE  ! Get default database.
C
C    System definitions....
C    ======================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
      include  'seisan.inc'      ! general seisan
C
C    Argument declarations....
C    =========================
C
      INTEGER    CODE,               ! Returned condition.
     &           FUNCTION,           ! Function to perform.
     &           UNIT                ! File unit.
      CHARACTER  CHR_FILE     *(*),  ! Filename.
     &           CHR_UFD_PATH *(*)   ! User file directory path under seisan_top
C
C    Local variables...
C    ==================
C
      INTEGER    TEXT_C,                  ! Text string length.
     &           FUNC                     ! Loacl function.
      PARAMETER (TEXT_C = 80)             ! & value.
      CHARACTER  CHR_PATH_ROOT *(F_LEN$), ! Pathname root.
     &           CHR_TEXT      *(TEXT_C), ! Text string.
     &           CHR_DELIM     *(1)       ! Path delimiter. 
      LOGICAL    B_OLD,                   ! File exists?.
     &           B_MESSAGE,               ! Issue messages?.
     &           B_CHECK,                 ! Check where file exists?.
     &           B_WAVE,                  ! Wave directory?.
     &           B_FLAG                   ! General flagged situation?.
C
      CHARACTER  CHR_F_STAT    *(F_STATC$), ! Copies of file-open details.
     &           CHR_F_ACCESS  *(F_ACCSC$), ! Ditto.
     &           CHR_F_FORM    *(F_FORMC$), ! Ditto.
     &           CHR_F_ACTION  *(F_ACTNC$)  ! Et ditto.
                 integer         f_recl
      character*2 century
C
      CHARACTER  CHR_BASE      *(3)         ! Databasename.
C
C    Initialise...
C    =============
C
      CODE = E_OK$                          ! Local condition.
C
      FUNC = MOD(FUNCTION,CHECK$)           ! Subfunction.
      B_MESSAGE = FUNC .NE. IGNORE$         ! Issue messages?.
      FUNC = FUNCTION - FUNC                ! Major function.
      B_CHECK = FUNC .EQ. CHECK$            ! Check where it is?.
      B_WAVE  = CHR_UFD_PATH(:3) .EQ. 'WAV' ! Wave directory?.
C
      CALL TOP DIR(  CHR_PATH_ROOT )        ! Get root directory.
      CALL DIR_CHAR( CHR_DELIM )            ! Get delimiter.
C 
C     Copy the file-open-set-up-detail...
C     -----------------------------------
C     These are used by the OPEN statement...
C
      CHR_F_STAT   = CHR_F_STAT$      ! Copies of file-open details.
      CHR_F_ACCESS = CHR_F_ACCESS$    ! Ditto.
      CHR_F_FORM   = CHR_F_FORM$      ! Ditto.
      CHR_F_ACTION = CHR_F_ACTION$    ! Et ditto.
      f_recl=f_recl$
C
C    Search the current directory for the file...
C    ============================================
C
      CHR_TEXT = CHR_FILE                   ! Copy filename.
      CALL SEI OPEN( CHECK$,                ! Check pathname exists.
     &               ' ', CHR_TEXT,         ! For this pathname.
     &               0,                     ! Unit (n/a)
     &               B_OLD,                 ! File exists?.
     &               CODE )                 ! Returned condition (n/a).
C
C    Found file...
C    =============
C    Re-set file-open details unset by call to "sei open"...
C    -------------------------------------------------------
C

 1    B_FLAG = B_OLD                          ! File exists to open!.
      IF( B_FLAG .AND. B_CHECK ) THEN         ! Checks out ok!.
         CHR_FILE      = CHR_TEXT                ! Install for output.
         CHR_F_STAT$   = CHR_F_STAT              ! Copy back file-open details.
         CHR_F_ACCESS$ = CHR_F_ACCESS            ! Ditto.
         CHR_F_FORM$   = CHR_F_FORM              ! Ditto.
         CHR_F_ACTION$ = CHR_F_ACTION            ! Et ditto.
         f_recl$       = f_recl

C
C    Open the file...
C    ================
C
      ELSE IF( B_FLAG ) THEN                     ! Open file.
         IF( B_MESSAGE .AND. B_F_MESSAGE$ ) THEN ! Notify user.
            WRITE(*,*)                              !
            WRITE(*,*) CHR_TEXT(:SEICLEN(CHR_TEXT)) !
         END IF                                  !
C
         CHR_F_STAT$   = CHR_F_STAT              ! Copy back file-open details.
         CHR_F_ACCESS$ = CHR_F_ACCESS            ! Ditto.
         CHR_F_FORM$   = CHR_F_FORM              ! Ditto.
         CHR_F_ACTION$ = CHR_F_ACTION            ! Et ditto.
         f_recl$       = f_recl
C
         CALL SEI OPEN( OLD$,                 ! Open, stop on error.
     &               ' ',                     ! Prompt (n/a).
     &               CHR_TEXT,                ! Existing waveform file.
     &               UNIT,                    ! File unit.
     &               B_OLD,                   ! Exists!!?
     &               CODE )                   ! Condition (n/a).
C
C    Search the directory name supplied...
C    =====================================
C
      ELSE                                                 ! Otherwise.
         CHR_TEXT = CHR_PATH_ROOT(:SEICLEN(CHR_PATH_ROOT)) // ! Construct path.
     &              CHR_DELIM                              // !
     &              CHR_UFD_PATH(:SEICLEN(CHR_UFD_PATH))   // !
     &              CHR_DELIM                              // !
     &              CHR_FILE(:SEICLEN(CHR_FILE))              ! Filename.
C
 2       CALL SEI OPEN( CHECK$,               ! Check pathname exists.
     &               ' ', CHR_TEXT,           ! For this pathname.
     &               0,                       ! Unit (n/a)
     &               B_OLD,                   ! File exists?.
     &               CODE )                   ! Returned condition (n/a).
c
c   get here if file not found in loop, to terminate error messages
c
 3    continue

C
C    File exists in this directory...
C    --------------------------------
C
         IF( B_OLD ) THEN                     ! Exists.
            GOTO 1                               ! Then open it.
C
C    Check the wave directory...
C    ---------------------------
C
         ELSE IF( B_WAVE ) THEN                   ! Check sub-directory

            call get_full_wav_name(chr_file,chr_text)
            IF( chr_text(1:4).ne.'    ') then
               full_path_wav_name=chr_text
               b_wave=.false.
               b_old=.true.
              goto 1                                ! Exists, go open it
            endif

c
c   if here, no wav file found, go terminate error messages
c
          b_wave=.false.
          goto 3
C
C    Checking if the file does not exist...
C    --------------------------------------
C
         ELSE IF( B_CHECK           .OR.      ! Checking or no messages.
     &           (.NOT.B_MESSAGE) ) THEN      ! 
            CODE          = E_MISF$              ! Missing file.
            CHR_F_STAT$   = CHR_F_STAT           ! Copy back file-open details.
            CHR_F_ACCESS$ = CHR_F_ACCESS         ! Ditto.
            CHR_F_FORM$   = CHR_F_FORM           ! Ditto.
            CHR_F_ACTION$ = CHR_F_ACTION         ! Et ditto.
            f_recl$       = f_recl
C
C    File doesn't exist...
C    ---------------------
C
         ELSE                                 ! Otherwise.
            CHR_ERR_MSG$ = CHR_FILE(:SEICLEN(CHR_FILE)) //
     &                     ' does not exist'
            CALL SEI CODE( STOP$,                ! Halt the program with user-.
     &                     E_MISF$,              ! Message; dummy use of code.
     &                     0,                    ! Unit (n/a).
     &                     B_FLAG )              ! Flag (n/a).
         END IF                               !
      END IF                                  !
C
C    Return to Caller...
C    ===================
C
9999  RETURN
      END
C
      SUBROUTINE  SEI GETU( UNIT, CODE )
CSTART**************************************************************************
C                                                                              *
C   System            : SEI  Validation & Application Library                  *
C   Supplier          : BGS/SEI  Applications Programming Unit                 *
C   Procedure Name    : SEI GETU                                               *
C   Purpose           : To find the next available unit for opening a file on. *
C   Arguments  -Input : None                                                   *
C              -Output: UNIT       (I*4) Fortran unit opened on                *
C                     : CODE       (I*4) Returned condition                    *
C   Author            : J. A. Bolton                                           *
C   Date              : 22 November 1994                                       *
C   Version           : V01                                                    *
C                                                                              *
CEND****************************************************************************
C
      EXTERNAL     PC_TO_TEXT    ! Clear graphics.
C
C    System definitions....
C    ======================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
C
C    Argument declarations....
C    =========================
C
      INTEGER*4         UNIT,               !  File unit.
     &                  CODE                !  Returned condition.
C
C    Local variables......
C    =====================
C
      INTEGER*4         IX                  !  Very local.
      LOGICAL*4         B_OPEN              !  Unit open?.
C
C    Initialise....
C    ==============
C
      CODE = E_OK$                          !  Set returned condition.
      UNIT = 0                              !  & returned device #.
C
C    Find next available unit....
C    ============================
C
      IX = F_MAXU$ - INDEX( CHR_MAP$, ' ' ) !  Next non-protected, non-opened.
C
C    Check that unit found is not already opened...
C    ==============================================
C
      IF( IX .LT. F_MAXU$ ) THEN                        ! Found.
      INQUIRE( UNIT= IX, OPENED= B_OPEN, IOSTAT= CODE ) ! Unit open?.
         IF( CODE .NE. E_OK$ ) THEN                     ! Already open!.
         IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT          ! Fatal; pc graphics.
         WRITE(*,*)
         WRITE(*,*)
     &   '**** FATAL: problem finding next available unit    ****'
         WRITE(*,*)'     FORTRAN condition ', CODE      !
         WRITE(*,*)
     &   '****                                               ****'
         CODE = E_INIT$                                 ! Initialisation problem
C
C    Already open....
C    ----------------
C
         ELSE IF( B_OPEN ) THEN                           ! Open.
         CODE = E_INIT$                                   ! Already open!.
         IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT            ! Fatal; pc graphics.
         WRITE(*,*)
         WRITE(*,*)
     &   '**** FATAL: attempting to get a unit already open  ****'
         WRITE(*,*)
     &   '****                                               ****'
C
C    Unit available....
C    ------------------
C
         ELSE                                ! Otherwise.
         UNIT = IX                           ! Set up returned unit.
         END IF                              !
C
C    No more units available...
C    ==========================
C
      ELSE                                      ! Otherwise none found.
      CODE = E_INIT$                            ! Set condition.
      IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT     ! Fatal pc; graphics.
      WRITE(*,*)
      WRITE(*,*)
     &'**** FATAL: too many files currently open          ****'
      WRITE(*,*)
     &'****                                               ****'
      END IF                                !
C
C    Return to caller....
C    ====================
C
9999  RETURN                                !
      END                                   !
C
      SUBROUTINE SEI GET VALUES( NVAL, CHR_STRING, CODE )
CSTART*************************************************************************
C                                                                             *
C    System           : SEISAN Utilities                                      *
C    Supplier         : BGS/GSRG Programming Unit                             *
C    Routine          : SEI GET VALUES                                        *
C    Purpose          : To parse the input text string for numbers and return *
C                       these in the common decode real array ARRAY$. In      *
C                       addition, if any number element cannot be decoded,    *
C                       return a non-zero condition. Likewise for the count   *
C                       of decoded number elements not being NVAL. In all     *
C                       cases, issue an appropriate message                   *
C    Arguments -Input : CHR_STRING     (C**) character string to parse        *
C                     : NVAL           (I)   # items to be returned           *
C              -Output: CODE           (I)   Returned condition code          *
C                     : ARRAY$ contains the output number items in the order  *
C                              they are found.                                *
C    Author           : J A Bolton                                            *
C    Date             : 6 December 1994                                       *
C    Version          : V01                                                   *
C                                                                             *
CEND***************************************************************************
C
      EXTERNAL   SEI REAL NUM            ! Get real number.
     &          ,SEI CODE                ! Condition handler.
     &          ,SEI CLEN                ! Get string length.
     &          ,PC_TO_TEXT              ! Clear graphics mode.
      INTEGER    SEI CLEN                ! Function.
      REAL       SEI REAL NUM            ! Ditto.
C
C    System inserts...
C    =================
C
      include    'libsei.inc'            ! Library definitions & data defns.
C
C    Arguments...
C    ============
C
      INTEGER     NVAL,                  ! # items in list.
     &            CODE                   ! Returned condition.
      CHARACTER   CHR_STRING *(*)        ! Text to parse.
C
C    Local variables...
C    ==================
C
      INTEGER     IX, IY, IZ,            ! Very local.
     &            COUNT,                 ! List items count.
     &            TEXT_C                 ! Text string length.
      PARAMETER  (TEXT_C = 80)           ! Length of text.
      CHARACTER   CHR_TEXT *(TEXT_C),    ! & message text string.
     &            CHR_A    *(1)          ! Single character.
      LOGICAL     B_FLAG,                ! Flag variable?.
     &            B_LAST                 ! Last character flagged?.
C
C    Initialise...
C    =============
C
      CODE   = E_OK$                     ! Local condition.
      COUNT  = 0                         ! Item count.
      B_FLAG = .FALSE.                   ! Item not found yet.
C
C    Check output array is large enough...
C    -------------------------------------
C
      IF( NVAL .GT. ARRAY_N$ ) THEN        ! Fatal initialisation.
      IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT! In pc graphics.
      WRITE(*,*)
     &'**** In call to SEI GET VALUES:                     ****'
      CHR_ERR_MSG$ =                     ! Set up message.
     &'**** FATAL: no. of requested items exceeds ARRAY$   ****'
      CALL SEI CODE( STOP$,              ! Stop processing.
     &               E_INIT$,            ! Bad initialisation.
     &               0,                  ! Fortran unit (n/a).
     &               B_FLAG )            ! Flag (n/a).
C
C    =========================================================
C    Loop the characters & look for numbers...
C    Each number will start with any one of "+-0123456789"...
C    Once found, they may include exponent flags "E" or "D"...
C    Each field will be delimited by blank or non-alphanumeric
C    characters...
C    =========================================================
C
      ELSE                               ! Otherwise.
      IX = SEI CLEN( CHR_STRING )        ! Length of string.
      if(b_f_debug$)write(dbgunit$,*)'length..', ix
      DO 1000 IY = 1, IX                 ! Loop characters.
      CHR_A = CHR_STRING(IY:IY)          ! This character!.
      B_LAST = B_FLAG                    ! Last character flagged?.
      if(b_f_debug$)write(dbgunit$,*)'chra:', chr_a
C  
C    Check character is a possible item...
C    -------------------------------------
C
         IF( B_LAST ) THEN                   ! Already an item?.
         B_FLAG = INDEX('+-0123456789.EDed', ! Still flagged?.
     &                  CHR_A) .GT. 0        !
         ELSE                                ! Otherwise.
         B_FLAG = INDEX('+-0123456789.',     ! Is this an item?.
     &                  CHR_A) .GT. 0        !
         END IF                              !
         if(b_f_debug$)write(dbgunit$,*)'last?flag?:',b_last,b_flag
C
C    Item found...
C    -------------
C
         IF( B_FLAG .AND. (.NOT.B_LAST) ) THEN ! Yes.
         if(b_f_debug$)write(dbgunit$,*)'incrementing..',count+1
         COUNT = COUNT + 1                     ! Increment item count.
         IF( COUNT .GT. NVAL ) GOTO 2000       ! Skip & message.
         IZ    = IY                            ! Store start location.
C
C    Item closed...                           
C    --------------
C
         ELSE IF( B_LAST .AND. (.NOT.B_FLAG) ) THEN      ! Closure.
         if(b_f_debug$)write(dbgunit$,*)'columns..', iz, iy-1
         ARRAY$(COUNT) = SEIREALNUM(CHR_STRING(IZ:IY-1), !
     &                              CODE)                !
         IF( CODE .NE. E_OK$ ) GOTO 9000                 ! Return on error.
         END IF                                          !
1000  CONTINUE                                           !
C
C    Fall through loop...decode any remaining valid item...
C    ------------------------------------------------------
C
         if(b_f_debug$)write(dbgunit$,*)'fall through columns..',iz,ix
         IF( B_FLAG ) THEN                               ! Item flagged.
         ARRAY$(COUNT) = SEIREALNUM(CHR_STRING(IZ:IX),   !
     &                              CODE)                !
         IF( CODE .NE. E_OK$ ) GOTO 9000                 ! Return on error.
         END IF                                          !
C
C    Check number of items is the same as required...
C    ================================================
C
2000     IF( COUNT .LT. NVAL ) THEN                   ! Too few items.
         CODE = E_CONV$                               ! Flag condition.
         CHR_TEXT =                                   !
     &'**** WARN: $$$ item(s) are missing from the list.   ****'
         IX = INDEX( CHR_TEXT,'$$$' )                 ! Position indicator.
         WRITE(CHR_TEXT(IX:IX+2),'(I3)') (NVAL-COUNT) ! Indicate items missing.
            IF( B_F_MESSAGE$ ) THEN                   ! Write message.
            WRITE(*,*) CHR_TEXT(:SEICLEN(CHR_TEXT))   !
            END IF                                    !
C
         ELSE IF( COUNT .GT. NVAL ) THEN ! Too many items.
         CODE = E_CONV$                               ! Flag condition.
         CHR_TEXT =                                   !
     &'**** WARN: $$$ item(s) too many are in the list.    ****'
         IX = INDEX( CHR_TEXT,'$$$' )                 ! Position indicator.
         WRITE(CHR_TEXT(IX:IX+2),'(I3)') (COUNT-NVAL) ! Indicate items missing.
            IF( B_F_MESSAGE$ ) THEN                   ! Write message.
            WRITE(*,*) CHR_TEXT(:SEICLEN(CHR_TEXT))   !
            END IF                                    !
         END IF                                       !
      END IF                                          !
C
C    Errors...
C    =========
C
      GOTO 9999                                       ! Bypass if required.
9000  IF( B_F_MESSAGE$ ) THEN                         ! Write message.
      CHR_TEXT =                                      ! Otherwise setup message.
     &'**** WARN: item is in position $$$ in the string    ****'
      IX = INDEX( CHR_TEXT,'$$$' )                    ! Position indicator.
      WRITE(CHR_TEXT(IX:IX+2),'(I3)') COUNT           ! Indicate item.
      WRITE(*,*) CHR_TEXT(:SEICLEN(CHR_TEXT))         !
      END IF                                          !
C
C    Return to caller...
C    ===================
C
9999  if( b_f_debug$ ) then                                  ! Write out values.
      write(dbgunit$,*)'sei get values (',nval,' required):' !
      write(dbgunit$,*) array$                               !
      end if                                                 !
C
      RETURN
      END
C
      INTEGER FUNCTION SEI INTEGER( CHR_STRING, CODE )
CSTART*************************************************************************
C                                                                             *
C    System           : SEISAN Utilities                                      *
C    Supplier         : BGS/GSRG Programming Unit                             *
C    Routine          : SEI INTEGER                                           *
C    Purpose          : To decode an integer from a character string          *
C    Arguments -Input : CHR_STRING     (C**) Number character string          *
C              -Output: CODE           (I)   Returned condition code          *
C    Note             : Based on PGG INTEGER in libugeo.for (BGS/GSRG)        *
C    Author           : J A Bolton                                            *
C    Date             : 6 December 1994                                       *
C    Version          : V01                                                   *
C                                                                             *
CEND***************************************************************************
C
      EXTERNAL  SEI CLEN                    ! String length.
      INTEGER   SEI CLEN                    ! Function.
C
C    System definitions....
C    ======================
C
      INCLUDE  'libsei.inc'                 ! Library definitions & data defns.
C
C    Arguments.....
C    ==============
C
      INTEGER      CODE                     ! Returned condition.
      CHARACTER    CHR_STRING *(*)          ! Number string.
C
C    Local variables...
C    ==================
C
      INTEGER      IX,                      ! Very local.
     &             NUMBER,                  ! Decoded number.
     &             FORM_C                   ! Length of format string.
      PARAMETER   (FORM_C = 8)              ! & value.
      CHARACTER    CHR_FORMAT *(FORM_C)     ! Format string.
C
C    Initialise....
C    ==============
C
      CODE   = E_OK$                        ! Initialise return code.
      NUMBER = 0                            ! Value.
      IX     = SEICLEN( CHR_STRING )        ! Length.
C
C    Decode integer...
C    =================
C
      IF( IX .GT. 9 )     THEN                       ! Long.
      WRITE(CHR_FORMAT,'(''(I'',I2,'')'')')  IX      ! Encode format
      READ(CHR_STRING, CHR_FORMAT, ERR=9000 ) NUMBER ! Decode number.
C
      ELSE                                           ! Short.
      WRITE(CHR_FORMAT,'(''(I'',I1,'')'')')  IX      ! Encode format.
      READ(CHR_STRING, CHR_FORMAT, ERR=9000 ) NUMBER ! Decode number.
      END IF                                         !
C
C    Finished....
C    ------------
C
      GOTO 9999                          ! 
C
C    Errors.....
C    ===========
C
9000  CODE = E_CONV$                     ! Bad conversion.
      IF( B_F_MESSAGE$ ) THEN
      WRITE(*,*)                              !
      WRITE(*,*)                              !
     &'**** WARN: unable to decode integer in the string   ****'
      END IF
C
C    Return to caller...
C    ===================
C
9999  SEI INTEGER = NUMBER                     ! Assign.
      if( b_f_debug$ ) then                    ! Debug detail.
      write(dbgunit$,*)'sei integer: ',        !
     &      chr_string(:seiclen(chr_string)),  !
     &      ' ... ', number                    !
      end if
C
      RETURN         
      END
C
      SUBROUTINE SEI LEFT( CHR_TEXT )
C
CSTART*************************************************************************
C                                                                             *
C   System          : SEISAN                                                  *
C   Supplier        : BGS/GSRG Applications Programming Unit                  *
C   Procedure Name  : SEI LEFT                                                *
C   Purpose         : To left justify the text string (must be a variable)    *
C                                                                             *
C   Arguments-Input : CHR_TEXT   (C*)  Input text string.                     *
C           -Output : CHR_TEXT   (C*)  Left justified output string.          *
C                                                                             *
C   Author          : J. A. Bolton                                            *
C   Date            : 2 December 1994                                         *
C   Version         : V01                                                     *
C                                                                             *
CEND***************************************************************************
C
      EXTERNAL   SEI CLEN
      INTEGER*4  SEI CLEN
C
C    Arguments.....
C    ==============
C
      CHARACTER    CHR_TEXT *(*)            ! Input text string.
C
C    Local variables....
C    ===================
C
C    None
C
C    Process...
C    ==========
C
1000  IF( CHR_TEXT      .NE. ' '   .AND.    ! Non-empty string and.
     &    CHR_TEXT(1:1) .EQ. ' ' ) THEN     ! Leading blank found.
      CHR_TEXT = CHR_TEXT(2:)               ! Left justify.
      GOTO 1000                             ! Test again.
      END IF                                !
C
C    Return to Caller...
C    ===================
C
9999  RETURN
      END
C
      SUBROUTINE SEI OPEN( FUNC,     CHR_PROMPT,
     &                     CHR_FILE, UNIT, B_OLD,
     &                     CODE )
C
CSTART**************************************************************************
C                                                                              *
C   System            : SEI  Validation & Application Library                  *
C   Supplier          : BGS/GSRG Applications Programming Unit                 *
C   Procedure Name    : SEI OPEN                                               *
C   Purpose           : To open a file on the next available unit and STOP the *
C                       current program on error unless directed by function.  *
C                       If the program is stopped, all files will be closed.   *
C                       Alternatively, the routine may be used to check the    *
C                       existance of a file.                                   *
C                                                                              *
C                       In addition, if prompt text is given, then prompt user *
C                       for the file name which is returned. Otherwise use the *
C                       given filename. Not availble in PC graphics state.     *
C                                                                              *
C                       The routine will open the file on the next available   *
C                       unit and save its name for error processing.           *
C                                                                              *
C                       For other options, required for the open command, use  *
C                       COMMON block variables as seen in libsei.inc". eg.     *
C                                                                              *
C                         CHR_F_ACCESS$ = 'DIRECT', CHR_F_ACCESS$ = 'APPEND'   *
C                                                                              *
C   Arguments  -Input : FUNC       (I*4) The operations vector depending on    *
C                                        file option. Values are:              *
C                                                                              *
C                                        NEW$         - open new file (default)*
C                                        OLD$         - open existing file     *
C                                        UNKNOWN$     - open empty file        *
C                                        SCRATCH$     - open a scratch file    *
C                                        CHECK$       - check existance        *
C                                                                              *
C                                        add one of the following to disable   *
C                                        STOP on non-fatal errors:             *
C                                                                              *
C                                        WARN$        - exit routine with      *
C                                                       condition CODE set     *
C                                                       but issue message.     *
C                                        IGNORE$      - exit routine with      *
C                                                       with no message.       *
C                                                                              *
C                                        To check the existance of a directory *
C                                        specify:                              *
C                                                                              *
C                                        CHECK$+DIRECTORY$                     *
C                                                                              *
C                                        in this case, B_OLD will be returned  *
C                                        true or false and non-fatal errors    *
C                                        will be ignored. It is found by trying*
C                                        to open a file in the target directory*
C                                                                              *
C                                                                              *
C                                        In addition, if B_F_DEBUG$ is TRUE,   *
C                                        open up the debug file given in       *
C                                        CHR_DBG_FILE$, otherwise if blank     *
C                                        then open up "libsei_debug$"          *
C                                                                              *
C                     : CHR_PROMPT (C*)  Prompt text to standard output        *
C                     : CHR_FILE   (C*)  Pathname of file to open or directory.*
C              -Output: UNIT       (I*4) Fortran unit opened on                *
C                     : CHR_FILE   (C*)  Pathname of file opened or directory. *
C                     : B_OLD      (L*4) File already exists?.                 *
C                     : CODE       (I*4) Returned condition                    *
C                                                                              *
C   Author            : J. A. Bolton                                           *
C   Date              : 23 November 1994                                       *
C   Version           : V01                                                    *
C                                                                              *
CEND****************************************************************************
C
C    System definitions....
C    ======================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
C
C    Application references...
C    =========================
C
      EXTERNAL   DIR_CHAR        ! Get directory path delimiter.
      EXTERNAL   SEI UPC         ! String uppercase function.
     &          ,SEI CLOSE       ! File closure.
     &          ,SEI CLEN        ! & length function.
     &          ,PC_TO_TEXT      ! Cancel graphics.
      INTEGER    SEI CLEN        ! & define the function.
C
C    Argument declarations....
C    =========================
C
      INTEGER*4         FUNC,               ! Operational functionality.
     &                  UNIT,               ! File unit.
     &                  CODE                ! Returned condition.
      CHARACTER         CHR_PROMPT*(*),     ! User PROMPT.
     &                  CHR_FILE  *(*)      ! File to open.
      LOGICAL*4         B_OLD               ! File already exists?.
C
C     Local variables...
C     ==================
C
      INTEGER*4         TEXT_C,             ! Text string length.
     &                  FUNCT,              ! Working function.
     &                  FUNCTION,           ! Working function. 
     &                  COPY_UNIT,          ! Copy of current unit.
     &                  STATE,              ! State of open operation.
     &                  IX,   IY,   IZ      ! Very local.
      PARAMETER        (TEXT_C = 80)        ! & value.
      CHARACTER         CHR_TEXT *(TEXT_C), ! & string.
     &                  CHR_DELIM*(1)       ! & path delimiter.
C
      LOGICAL*4         B_PROMPT,           ! Prompt user for file name?.
     &                  B_OPEN,             ! File opened?.
     &                  B_WARN,             ! Warn the caller of an error?.
     &                  B_IGNORE,           ! Ignore non-fatal errors?.
     &                  B_CHECK,            ! Check file exists?.
     &                  B_DIRECTORY,        ! Check directory exists?.
     &                  B_EXIST,            ! File must exist?.
     &                  B_UNKNOWN,          ! File status is unknown.?
     &                  B_SCRATCH,          ! Scratch file?.
     &                  B_APPEND,           ! Append sam file?.
     &                  B_DAMF              ! Dam file?.
C
C     ===============
C     1.Initialise...
C     ===============
C     1.1. Preliminaries...
C     =====================
C
      CODE      = E_OK$                               ! Set return condition.
      FUNCT     = FUNC                                ! Working function
      FUNCTION  = MOD(FUNC,WARN$)                     ! Local function.
      FUNCT     = FUNC - FUNCTION                     ! Major function.
      COPY_UNIT = F_UNIT$                             ! Copy current unit.
      CALL SEI UPC( CHR_F_ACCESS$ )                   ! Ensure uppercase.
      CALL SEI UPC( CHR_F_FORM$ )                     ! Ditto.
C
      B_WARN   = FUNCT .EQ. WARN$                     ! Warn user?.
      B_CHECK  = FUNCT .EQ. CHECK$                    ! Check file exists?.
      B_IGNORE = FUNCT .EQ. IGNORE$                   ! Ignore errors?.
C
      FUNCT    = FUNCTION                             ! Working function.
      FUNCTION = MOD(FUNCT,OLD$)                      ! Local function.
      FUNCT    = FUNCT - FUNCTION                     ! Major function.
C
      B_EXIST     = FUNCT .EQ. OLD$                   ! File must exist?.
      B_UNKNOWN   = FUNCT .EQ. UNKNOWN$               ! File status unknown?.
      B_SCRATCH   = FUNCT .EQ. SCRATCH$               ! File to be scratch?.
      B_DIRECTORY = FUNCT .EQ. DIRECTORY$             ! Check directory exists?
C
      B_PROMPT = CHR_PROMPT .NE. ' '                  ! Prompt for filename?
      B_APPEND = INDEX(CHR_F_ACCESS$,'APPEND') .GT. 0 ! Append sam access?.
      B_DAMF   = INDEX(CHR_F_ACCESS$,'DIRECT') .GT. 0 ! Direct access?.
C
C     1.1.1 Initialise units...
C     -------------------------
C
      IF( CHR_MAP$ .EQ. ' ' ) THEN          ! Set-up.
      DO 1    IX = 1, F_MAX$                ! Loop protected units.
      IY = F_MAXU$ - F_PROTECT$(IX)         ! Get protected unit.
      CHR_MAP$(IY:IY) = 'P'                 ! & flag it.
1     CONTINUE                              !
      END IF                                !
C
C     1.1.2 Open up the debug file if required...
C     -------------------------------------------
C
      IF( B_F_DEBUG$          .AND.           ! Debugging required.
     &    DBGUNIT$   .EQ. 0 ) THEN            ! & unit not open.
C
         IF( CHR_DBG_FILE$ .EQ. ' ' ) THEN    ! Setup debug filename.
         CHR_DBG_FILE$ = 'libsei_debug$'      !
         END IF                               !
C
      IX = DBG_OUT$                           ! Set to debug unit.
         if( b_f_message$ ) then              ! Message allowed.
         write(*,*)'...opening debug file...'
         write(*,*)'   file   : ', 
     & chr_dbg_file$(:seiclen(chr_dbg_file$))
         write(*,*)'   on unit: ', ix
         end if                               !
C
      OPEN( UNIT=IX,                                     ! Open the file.
     &      FILE=chr_dbg_file$(:seiclen(chr_dbg_file$)), !
     &      STATUS='UNKNOWN', IOSTAT=CODE )              !
C
         IF( CODE .EQ. E_OK$ ) THEN                      ! Successful
         DBGUNIT$ = IX                                   ! Setup unit.
         IZ = F_MAXU$ - IX                               ! Map position.
         CHR_MAP$(IZ:IZ) = 'O'                           ! Mapped unit open.
         CHR_FILE_OPEN$(IX) = CHR_DBG_FILE$              ! & copy filename.
C
         ELSE                                            ! Otherwise fatal error
         IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT           ! Fatal; pc graphics.
         WRITE(*,*)
         WRITE(*,*)
     &'**** FATAL: problem opening debug file             ****'
         WRITE(*,*)'          ',
     &'on pre-allocated unit ', IX
         WRITE(*,*)'          ',
     &   CHR_DBG_FILE$(:SEICLEN(CHR_DBG_FILE$))
         WRITE(*,*)'     FORTRAN condition ', CODE       !
         WRITE(*,*)
     &'****                                               ****'
         GOTO 9998                                       ! & exit.
         END IF                                          !
      END IF                                             !
C
C     1.2. Prompt the user for a filename?....
C     ========================================
C
1000  CODE = E_OK$                           !
      IF( B_PROMPT ) THEN                    ! & prompt
C
C     1.2.0 In message mode...
C     ------------------------
C
         IF( B_F_MESSAGE$ ) THEN                ! Prompting allowed.
         WRITE(*,*)
         WRITE(*,*) CHR_PROMPT                  ! Write prompt.
         WRITE(*,*)'(press <return> for exit prompt)'
C
C     1.2.1 Fatal if PC graphics at this point...
C     -------------------------------------------
C
         ELSE                                   ! Otherwise.
         CALL PC_TO_TEXT                        ! Get out of graphics.
         WRITE(*,*)
         WRITE(*,*)
     &'**** FATAL: unable to PROMPT for information in    ****'
         WRITE(*,*)
     &'****        PC graphics mode                       ****'
         WRITE(*,*)
     &'****                                               ****'
         GOTO 9998                              ! & abort.
         END IF                                 !
C
C     -------------------------------------
C     1.2.2 Ok to proceed with prompting...
C     -------------------------------------
C
      READ(*,'(A)') CHR_TEXT                 ! Get the response.
C
C     No response..does the user want to abort?...
C     --------------------------------------------
C
         IF( CHR_TEXT .EQ. ' ' ) THEN        ! & again.
         WRITE(*,*)
            IF( B_DIRECTORY ) THEN           ! Directory pathname.
            WRITE(*,*)
     &   '**** WARN: no directory pathname supplied          ****'
            ELSE                             ! File pathname.
            WRITE(*,*)
     &   '**** WARN: no filename/file pathname supplied      ****'
            END IF                           !
C
         WRITE(*,*)
         WRITE(*,*)'           enter "(Y)es" to exit'
C
         READ(*,'(A)') CHR_TEXT               ! Get reply.
C
C        abort the program...
C        --------------------
C
            IF( CHR_TEXT(1:1) .EQ. 'Y'   .OR. ! Abort.
     &          CHR_TEXT(1:1) .EQ. 'y' ) THEN !
            GOTO 9998                         ! & stop.     
C
C        try again...
C        ------------
C
            ELSE                              ! Otherwise.
            GOTO 1000                         !
            END IF                            !
C
C     Setup the filename...
C     ---------------------
C
         ELSE                                 ! Otherwise.
         CHR_FILE = CHR_TEXT                  ! & copy.
         END IF                               !
      END IF                                  !
C
C     ==============================
C     2.   See if the file exists...
C     ==============================
C     2.0.1. Check directory exists...
C     --------------------------------
C
      IF( B_DIRECTORY ) THEN                  ! Check directory exists.
      CHR_TEXT = CHR_FILE                     ! Copy directory pathname.
      IY = SEI CLEN( CHR_TEXT )               ! Length of filename.
      CALL DIR_CHAR( CHR_DELIM )              ! Get path delimiter.
C
C     Set up pathname of a special file to create in this directory...
C
         IF( CHR_TEXT(IY:IY) .EQ. CHR_DELIM ) THEN ! Ends with delimiter.
         CHR_TEXT(IY+1:) = 'LIBSEI$DIR$'           ! File pathname.
         ELSE                                      ! Otherwise.
         CHR_TEXT(IY+1:) = CHR_DELIM     //        ! File pathname.
     &                     'LIBSEI$DIR$'           ! Ditto.
         END IF                                    !
C
C     Get next available unit...
C
      CALL SEI GETU( IX, CODE )               ! Next unit.
      IF( CODE .NE. E_OK$ ) GOTO 9998         ! Fatal error.
C
C     Open unknown file, then delete it...    
C
         if( b_f_debug$ ) then
         write(dbgunit$,*)'...opening test file...'
         write(dbgunit$,*)'   file   : ',chr_text(:seiclen(chr_text))
         write(dbgunit$,*)'   on unit: ',ix
         end if
C
      OPEN( UNIT=IX, FILE=CHR_TEXT(:SEICLEN(CHR_TEXT)), ! Open file.
     &      STATUS='UNKNOWN', IOSTAT=CODE )             !
      B_OLD = CODE .EQ. E_OK$                           ! Exists.
C
C     Directory exists, reserve unit just in case we can't delete
C     without an error...
C
         IF( B_OLD ) THEN                      ! Found ok, reserve.
         IZ = F_MAXU$ - IX                     ! Map position.
         CHR_MAP$(IZ:IZ) = 'O'                 ! Mapped unit open.
         CHR_FILE_OPEN$(IX) = CHR_TEXT         ! & copy filename.
         CALL SEI CLOSE(DELETE$+WARN$,IX,CODE) ! Delete file & warn of error.
C
C     Problem...
C   
         ELSE IF( B_F_MESSAGE$ ) THEN          ! Otherwise.
         WRITE(*,*)
         WRITE(*,*)
     &   '**** WARN: unable to open files in this directory  ****'
         WRITE(*,*)
     &   '****       or directory does not exist.            ****'
         WRITE(*,*)
         WRITE(*,*)'           ', CHR_FILE(:SEICLEN(CHR_FILE))
         END IF                               !
C
      CODE = E_OK$                            ! No error condition.
      GOTO 9999                               ! Return to caller.
      END IF                                  !
C
C     2.0.2. Check file exists...
C     ---------------------------
C
      INQUIRE(FILE=CHR_FILE(:SEICLEN(CHR_FILE))           ! Find out.
     &                     ,EXIST=B_F_EXIST$,IOSTAT=CODE) ! File exists?.
      B_OLD = B_F_EXIST$                                  ! Existance?.
C
C     2.1  Errors from enquiry...
C     ===========================
C
      IF( CODE .NE. E_OK$ ) THEN                          ! Fatal error.
      IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT               ! Cancel pc graphics.
      WRITE(*,*)
      WRITE(*,*)
     &'**** FATAL: problem checking file exists           ****'
      WRITE(*,*)'          ',CHR_FILE(:SEICLEN(CHR_FILE))
      WRITE(*,*)'     FORTRAN condition ', CODE           !
      WRITE(*,*)
     &'****                                               ****'
c         
         if( b_f_debug$ ) then
         WRITE(dbgunit$,*)
     &'**** FATAL: problem checking file exists           ****'
         WRITE(dbgunit$,*)'          ',
     &   CHR_FILE(:SEICLEN(CHR_FILE))
         WRITE(dbgunit$,*)'     FORTRAN condition ', CODE           !
         end if
c      
      GOTO 9998                                           ! & exit.
C
C     2.2  Caller only wished to check existance of file...
C     =====================================================
C
      ELSE IF( B_CHECK ) THEN                            ! Just checking.
      GOTO 9999                                          ! & return to caller.
C
C     2.3  File status is considered UNKNOWN or SCRATCH...
C     ====================================================
C
      ELSE IF( B_UNKNOWN .OR. B_SCRATCH ) THEN           ! No action.
      CONTINUE                                           !
C
C     2.4  File must exist if caller indicates this...
C     ================================================
C
      ELSE IF( B_EXIST .AND. (.NOT.B_F_EXIST$) ) THEN    ! Error.
      CODE = E_INIT$                                     ! Bad initialisation.
      IF( B_IGNORE ) GOTO 9999                           ! Ignore.
C
      IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) )      ! Fatal; PC graphics.
     &    CALL PC_TO_TEXT                                ! Change to text mode.
         IF( B_F_MESSAGE$ ) THEN                         ! Write message.
         WRITE(*,*)
         WRITE(*,*)
     &'**** WARN: specified file does not exist           ****'
         WRITE(*,*)'          ',CHR_FILE(:SEICLEN(CHR_FILE))
         WRITE(*,*)
     &'****                                               ****'
         END IF
c
         if( b_f_debug$ ) then
         WRITE(dbgunit$,*)
     &'**** WARN: specified file does not exist           ****'
         WRITE(dbgunit$,*)'          ',
     &   CHR_FILE(:SEICLEN(CHR_FILE))
         end if
C
         IF( B_PROMPT ) THEN                          ! Prompted filename.
         GOTO 1000                                    ! & prompt again.
C
         ELSE IF( B_WARN ) THEN                       ! Back to caller.
         CODE = E_INIT$                               ! Bad initialisation.
         GOTO 9999                                    ! & return to caller.
C
         ELSE                                         ! Otherwise.
         GOTO 9998                                    ! Exit program
         END IF                                       ! 
C
C     2.5  Caller expects a new file but file already exists...
C     =========================================================
C
      ELSE IF( B_F_EXIST$ .AND. (.NOT.B_EXIST) ) THEN ! New file exists!!
      CODE = E_INIT$                                  ! Bad initialisation.
      IF( B_IGNORE ) GOTO 9999                        ! Ignore.
C
      IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) )   ! Fatal; PC graphics.
     &    CALL PC_TO_TEXT                             ! Change to text mode.
         IF( B_F_MESSAGE$ ) THEN                      ! Messages allowed.
         WRITE(*,*)
         WRITE(*,*)
     &'**** WARN: specified file already exists           ****'
         WRITE(*,*)'          ',CHR_FILE(:SEICLEN(CHR_FILE))
         WRITE(*,*)
     &'****                                               ****'
         END IF
c
         if( b_f_debug$ ) then
         WRITE(dbgunit$,*)
     &'**** WARN: specified file already exists           ****'
         WRITE(dbgunit$,*)'          ',
     &   CHR_FILE(:SEICLEN(CHR_FILE))
         end if
C
         IF( B_PROMPT ) THEN                          ! Prompted filename.
         GOTO 1000                                    ! & prompt again.
C
         ELSE IF( B_WARN ) THEN                       ! Back to caller.
         CODE = E_INIT$                               ! Bad initialisation.
         GOTO 9999                                    ! & return to caller.
C
         ELSE                                         ! Otherwise.
         GOTO 9998                                    ! Exit program
         END IF                                       !
      END IF                                           !
C
C    ========================
C    3.    Open the file.....
C    ========================
C    3.1   Set up for opening...
C    ===========================
C
3000  IF( B_UNKNOWN ) THEN                  ! Assume unknown status.
      CHR_F_STAT$ = 'UNKNOWN'               !
C
      ELSE IF( B_SCRATCH ) THEN             ! Scratch file.
      CHR_F_STAT$ = 'SCRATCH'               !
C
      ELSE IF( B_F_EXIST$ ) THEN            ! File exists.
      CHR_F_STAT$ = 'OLD'                   !
C
      ELSE                                  ! Otherwise new.
      CHR_F_STAT$ = 'NEW'                   !
      END IF                                !
C
C    3.1.1 Get the next available unit....
C    -------------------------------------
C
      CALL SEI GETU( UNIT, CODE )           ! That's it.
      IF( CODE .NE. E_OK$ ) THEN            ! Problem getting unit.
      GOTO 9998                             ! & abort.
      END IF                                !
C
C    3.1.2 Final check to see if the unit is physically open...
C    ----------------------------------------------------------
C
      IY = UNIT                                         ! Copy unit.
      INQUIRE( UNIT= IY, OPENED= B_OPEN, IOSTAT= CODE ) ! Unit open?.
C
C    3.1.2.1 Errors from enquiry...
C
      IF( CODE .NE. E_OK$ ) THEN                          ! Fatal error.
      IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT               ! Cancel  pc graphics.
      WRITE(*,*)
      WRITE(*,*)
     &'**** FATAL: problem checking file open             ****'
      WRITE(*,*)'          ',CHR_FILE(:SEICLEN(CHR_FILE))
      WRITE(*,*)'     FORTRAN condition ', CODE           !
      WRITE(*,*)
     &'****                                               ****'
c      
         if( b_f_debug$ ) then
         WRITE(dbgunit$,*)
     &'**** FATAL: problem checking file open             ****'
         WRITE(dbgunit$,*)'          ',
     &   CHR_FILE(:SEICLEN(CHR_FILE))
         WRITE(dbgunit$,*)'     FORTRAN condition ', CODE           !
         end if
c
      GOTO 9998                                           ! & exit.
C
C    3.1.2.2 Already open...fatal since outside scope of file handler...
C
      ELSE IF( B_OPEN ) THEN                              ! Already open.
      IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT               ! Cancel  pc graphics.
      WRITE(*,*)
      WRITE(*,*)
     &'**** FATAL: specified file already open            ****'
      WRITE(*,*)'          ',CHR_FILE(:SEICLEN(CHR_FILE))
      WRITE(*,*)'     File open outside scope of SEISAN'
      WRITE(*,*)'     file handler.'
      WRITE(*,*)
     &'****                                               ****'
c      
         if( b_f_debug$ ) then
         WRITE(dbgunit$,*)
     &'**** FATAL: specified file already open            ****'
         WRITE(dbgunit$,*)'          ',
     &   CHR_FILE(:SEICLEN(CHR_FILE))
         WRITE(dbgunit$,*)
     &   '     File open outside scope of SEISAN'
         WRITE(dbgunit$,*)'     file handler.'
         end if
c
      GOTO 9998                                      ! Abort.
C
C    3.1.2.3 Store current unit...
C    -----------------------------
C
      ELSE                                           ! Otherwise ok.
      F_UNIT$ = UNIT                                 ! Set the unit to open.
      END IF                                         !
C
C    3.2.   Open the file as required...
C    ===================================
C    3.2.1. DAM file....
C    -------------------
C
      IF( B_DAMF ) THEN                                 ! Dam file operation.
      CHR_F_ACCESS$  = 'DIRECT'                         !
C
         IF( B_SCRATCH ) THEN                           ! Scratch file.
            if( b_f_debug$ ) then                       ! Debug information.
            write(dbgunit$,*)
            write(dbgunit$,*)'opening direct access scratch file...'
            write(dbgunit$,*)'on unit:', f_unit$
            write(dbgunit$,*)'recl   :', f_recl$
            write(dbgunit$,*)'details:' ,chr_f_stat$
     &                             ,' ' ,chr_f_access$
     &                             ,' ' ,chr_f_form$     
            end if                                      !
C
         OPEN( UNIT  = F_UNIT$,                         !
     &         STATUS= CHR_F_STAT$, ACCESS= CHR_F_ACCESS$, 
     &         FORM  = CHR_F_FORM$, RECL  = F_RECL$,    ! Caller supplies these.
     &         IOSTAT= STATE )                          !
C
         ELSE                                           ! Otherwise named file.
            if( b_f_debug$ ) then                       ! Debug information.
            write(dbgunit$,*)
            write(dbgunit$,*)'opening direct access file...'
            write(dbgunit$,*)'file   :',chr_file(:seiclen(chr_file))
            write(dbgunit$,*)'on unit:', f_unit$
            write(dbgunit$,*)'recl   :', f_recl$
            write(dbgunit$,*)'details:' ,chr_f_stat$
     &                             ,' ' ,chr_f_access$
     &                             ,' ' , chr_f_form$ 
            end if                                      !
C
         OPEN( UNIT  = F_UNIT$,                         !
     &         FILE  = CHR_FILE(:SEICLEN(CHR_FILE)),    !
     &         STATUS= CHR_F_STAT$, ACCESS= CHR_F_ACCESS$,  
     &         RECL  = F_RECL$,                         ! Caller supplies these.
     &         IOSTAT= STATE )                          ! jh: remove form=
         END IF                                         !
C
C    3.2.2. SAM file....
C    -------------------
C    Consider access types...
C
      ELSE                                              ! SAM file operation.
         IF( B_APPEND ) THEN                            ! Open for append.
         CHR_F_ACCESS$ = 'APPEND'                       !
         ELSE                                           ! Otherwise.
         CHR_F_ACCESS$ = 'SEQUENTIAL'                   !
         END IF                                         !
C
C    Unformatted files...
C
         IF( CHR_F_FORM$ .EQ. 'UNFORMATTED' ) THEN      ! Unformatted.
            IF( B_SCRATCH ) THEN                        ! Scratch filename.
            if( b_f_debug$ ) then                       ! Debug information.
            write(dbgunit$,*)
            write(dbgunit$,*)'opening sam scratch file...'
            write(dbgunit$,*)'on unit:', f_unit$
            write(dbgunit$,*)'details:' ,chr_f_stat$
     &                             ,' ' ,chr_f_access$
     &                             ,' ' ,chr_f_form$ 
            end if                          
C
            OPEN( UNIT  = F_UNIT$,                         !
     &            FORM  = CHR_F_FORM$,                     ! 
     &            STATUS= CHR_F_STAT$, ACCESS= CHR_F_ACCESS$, 
     &            IOSTAT= STATE )                          !
C
            ELSE                                           ! Otherwise named.
            if( b_f_debug$ ) then                          ! Debug information.
            write(dbgunit$,*)
            write(dbgunit$,*)'opening sam file...'
            write(dbgunit$,*)'file   :', chr_file(:seiclen(chr_file))
            write(dbgunit$,*)'on unit:', f_unit$
            write(dbgunit$,*)'details:' ,chr_f_stat$
     &                             ,' ' ,chr_f_access$
     &                             ,' ' ,chr_f_form$ 
            end if                       
C
            OPEN( UNIT  = F_UNIT$,                         !
     &            FILE  = CHR_FILE(:SEICLEN(CHR_FILE)),    !
     &            FORM  = CHR_F_FORM$,                     !
     &            STATUS= CHR_F_STAT$, ACCESS= CHR_F_ACCESS$, 
     &            IOSTAT= STATE )                          !
            END IF                                         !
C
C    Formatted files....
C
         ELSE                                              ! Otherwise format.
            IF( B_SCRATCH ) THEN                           ! Scratch file. 
            if( b_f_debug$ ) then                          ! Debug information.
            write(dbgunit$,*)
            write(dbgunit$,*)'opening sam formatted scratch file...'
            write(dbgunit$,*)'on unit:', f_unit$
            write(dbgunit$,*)'details:' ,chr_f_stat$
     &                             ,' ' ,chr_f_access$ 
            end if                                 
C
            OPEN( UNIT  = F_UNIT$,                         !
     &            STATUS= CHR_F_STAT$, ACCESS= CHR_F_ACCESS$, 
     &            IOSTAT= STATE )                          !
C
            ELSE                                           ! Otherwise named.
            if( b_f_debug$ ) then                          ! Debug information.
            write(dbgunit$,*)
            write(dbgunit$,*)'opening sam formatted file...'
            write(dbgunit$,*)'file   :', chr_file(:seiclen(chr_file))
            write(dbgunit$,*)'on unit:', f_unit$
            write(dbgunit$,*)'details:' ,chr_f_stat$
     &                             ,' ' ,chr_f_access$ 
            end if                                    
C
            OPEN( UNIT  = F_UNIT$,                         !
     &            FILE  = CHR_FILE(:SEICLEN(CHR_FILE)),    !
     &            STATUS= CHR_F_STAT$, ACCESS= CHR_F_ACCESS$, 
     &            IOSTAT= STATE )                          !
            END IF                                         !
         END IF                                            !
      END IF                                               !
C
C    3.3. Process the outcome...
C    ===========================
C    Successful...
C    -------------
C
      IF( STATE .EQ. E_OK$ ) THEN                        !
      UNIT = F_UNIT$                                     ! & copy.
      IZ = F_MAXU$ - F_UNIT$                             ! Map position.
      CHR_MAP$(IZ:IZ) = 'O'                              ! Mapped unit open.
      CHR_FILE_OPEN$(UNIT) = CHR_FILE                    ! & copy filename.
      GOTO 9999                                          ! Return.
C
C     Not successful...
C     -----------------
C
      ELSE                                               ! Otherwise.
      F_UNIT$ = COPY_UNIT                                ! Put back current
      CODE = E_INIT$                                     ! Bad initialisation.
      IF( B_IGNORE ) GOTO 9999                           ! Ignore.
C
      IF( (.NOT.B_WARN) .AND. (.NOT.B_F_MESSAGE$) )      ! Fatal; PC graphics.
     &    CALL PC_TO_TEXT                                ! Change to text mode.
      WRITE(*,*)
      WRITE(*,*)
     &'**** WARN: problem opening file                    ****'
      WRITE(*,*)'          ',CHR_FILE(:SEICLEN(CHR_FILE))
      WRITE(*,*)
     &'****                                               ****'
c
         if( b_f_debug$ ) then
         WRITE(dbgunit$,*)
     &'**** WARN: problem opening file                    ****'
         WRITE(dbgunit$,*)'          ',
     &   CHR_FILE(:SEICLEN(CHR_FILE))
         end if
C
         IF( B_PROMPT ) THEN                          ! Prompted filename.
         GOTO 1000                                    ! & prompt again.
C
         ELSE IF( B_WARN ) THEN                       ! Back to caller.
         CODE = E_INIT$                               ! Bad initialisation.
         GOTO 9999                                    ! & return to caller.
C
         ELSE                                         ! Otherwise.
         GOTO 9998                                    ! Exit program
         END IF                                       !
      END IF                                          !
C
C    4. ABORT point.....
C    ===================
C
9998  IF(.NOT.B_F_MESSAGE$) CALL PC_TO_TEXT           ! Not required!!.
      WRITE(*,*)
      WRITE(*,*)
     &'**** WARN: halting program in SEIOPEN              ****'
      WRITE(*,*)
     &'****       ...closing down files                   ****'
c
      if( b_f_debug$ ) then
      WRITE(dbgunit$,*)
     &'**** WARN: halting program in SEIOPEN              ****'
      WRITE(dbgunit$,*)
     &'****       ...closing down files                   ****'
      end if
C
      CALL SEI CLOSE(CLOSE$+ALL$,             ! Close all files.
     &               0,                       ! File unit (n/a).
     &               CODE )                   ! Returned condition (n/a).
      STOP                                    !
C
C    ===================
C    Return to caller...
C    ===================
C    Re-set "file-open" attributes...
C    ================================
C
9999  F_RECL$       = 0
      CHR_F_STAT$   = ' '
      CHR_F_ACCESS$ = ' '
      CHR_F_FORM$   = ' '
      CHR_F_ACTION$ = CHR_SET_ACTION$
C
C    & return...
C    ===========
C
      RETURN    
      END
C
      REAL FUNCTION SEI REAL NUM( CHR_STR, CODE )
CSTART*************************************************************************
C                                                                             *
C    System           : SEISAN Utilities                                      *
C    Supplier         : BGS/GSRG Programming Unit                             *
C    Routine          : SEI REAL NUM                                          *
C    Purpose          : To decode a number from a character string containing *
C                       either an integer or real number.                     *
C    Arguments -Input : CHR_STR     (C*) Number character string              *
C              -Output: CODE        (I)  Returned condition code              *
C                     : SEI REAL NUM returns the real value of the decode     *
C    Note             : Based on PGG REAL NUM from libugeo.for (BGS/GSRG)     *
C                       by same author.                                       *
C    Author           : J A Bolton                                            *
C    Date             : 6 December 1994                                       *
C    Version          : V01                                                   *
C                                                                             *
CEND***************************************************************************
C
      EXTERNAL  SEI INTEGER                 ! Get integer.
     &         ,SEI UPC                     ! Uppercase.
     &         ,SEI CLEN                    ! String length.
      INTEGER   SEI CLEN                    ! Function.
     &         ,SEI INTEGER                 ! Ditto. 
C
C    System definitions....
C    ======================
C
      INCLUDE  'libsei.inc'                 ! Library definitions & data defns.
C
C    Arguments.....
C    ==============
C
      INTEGER      CODE                     ! Returned condition.
      CHARACTER    CHR_STR *(*)             ! Number string.
C
C    Local variables...
C    ==================
C
      INTEGER      IW, IX, IY, IZ,          ! Very local.
     &             FORM_C                   ! Length of format string.
      REAL*8       NUMBER                   ! Decoded number.
      PARAMETER   (FORM_C = 8)              ! & value.
      CHARACTER    CHR_FORMAT *(FORM_C)     ! Format string.
     &            ,CHR_STRING *(80)         ! & working text string.
      LOGICAL      B_EXP,                   ! Simple exponent.
     &             B_DEXP,                  ! Double exponent.
     &             B_REAL,                  ! Real format.
     &             B_INTEGER                ! Integer format.
C
C    Initialise....
C    ==============
C
      CODE       = E_OK$                          ! Initialise return code.
      CHR_STRING = CHR_STR                        ! Working string.
C
      NUMBER = 0.0D0                              ! Working decoded number.
      IX     = SEICLEN( CHR_STRING )              ! Length of string.
      CALL SEI UPC( CHR_STRING(:IX) )             ! In uppercase.
C
      IW     = INDEX( CHR_STRING(:IX), 'E' )      ! Exponential format.
      IZ     = INDEX( CHR_STRING(:IX), 'D' )      ! Exponential format.
      IY     = IX - INDEX( CHR_STRING(:IX), '.' ) ! Decimal point.
C
      B_EXP     = IW .GT. 0                 ! Exponent input?.
      B_DEXP    = IZ .GT. 0                 ! Double precisison exponent?.
      B_REAL    = IX .NE. IY      .AND.     ! Real number?.
     &            (.NOT.B_EXP )   .AND.     !
     &            (.NOT.B_DEXP)             !
      B_INTEGER = IX .EQ. IY      .AND.     ! An integer?.
     &            (.NOT.B_EXP )   .AND.     !
     &            (.NOT.B_DEXP)             !
C
      IW        = MAX0( IW, IZ )            ! Use for both single & double exp.
      IF( IW .GT. 0 ) IY = IY + IW - IX - 1 ! Update.
C
C    Decode integer...
C    -----------------
C
      IF( B_INTEGER ) THEN                          ! Integer.
      NUMBER = DBLE( SEI INTEGER(CHR_STRING,CODE) ) ! & convert.
      IF( CODE .NE. E_OK$ ) GOTO 9999               ! On error.
C
C    Decode real...
C    --------------
C
      ELSE IF( B_REAL      .AND.                              ! Real.
     &         IX .GT. 9 ) THEN                               ! & long length.
        IF( IY .GT. 9 ) THEN                                  ! Lots of decimal
        WRITE(CHR_FORMAT,'(''(F'',I2,''.'',I2,'')'')') IX, IY ! Format.
        ELSE                                                  ! Few decimals.
        WRITE(CHR_FORMAT,'(''(F'',I2,''.'',I1,'')'')') IX, IY ! Format.
        END IF                                                !
      READ(CHR_STRING,CHR_FORMAT,ERR=9000) NUMBER             ! & convert.
C
      ELSE IF( B_REAL ) THEN                                  ! Small real.
      WRITE(CHR_FORMAT,'(''(F'',I1,''.'',I1,'')'')')   IX, IY ! Format.
      READ(CHR_STRING,CHR_FORMAT,ERR=9000) NUMBER             ! & convert.
C
C    Decode real with exponent...
C    ----------------------------
C
      ELSE IF( B_EXP       .AND.                              ! Real.
     &         IX .GT. 9 ) THEN                               !
        IF( IY .GT. 9 ) THEN                                  ! Lots of decimal
        WRITE(CHR_FORMAT,'(''(E'',I2,''.'',I2,'')'')') IX, IY ! Format.
        ELSE                                                  ! Few decimals.
        WRITE(CHR_FORMAT,'(''(E'',I2,''.'',I1,'')'')') IX, IY ! Format.
        END IF                                                !
      READ(CHR_STRING,CHR_FORMAT,ERR=9000) NUMBER             ! & convert.
C
      ELSE IF( B_EXP ) THEN                                   ! Small real.
      WRITE(CHR_FORMAT,'(''(E'',I1,''.'',I1,'')'')')   IX, IY ! Format.
      READ(CHR_STRING,CHR_FORMAT,ERR=9000) NUMBER             ! & convert.
C
C    Decode real with Double precision exponent...
C    ---------------------------------------------
C
      ELSE IF( IX .GT. 9 ) THEN                               ! Real.
        IF( IY .GT. 9 ) THEN                                  ! Lots of decimal
        WRITE(CHR_FORMAT,'(''(D'',I2,''.'',I2,'')'')') IX, IY ! Format.
        ELSE                                                  ! Few decimals.
        WRITE(CHR_FORMAT,'(''(D'',I2,''.'',I1,'')'')') IX, IY ! Format.
        END IF                                                !
      READ(CHR_STRING,CHR_FORMAT,ERR=9000) NUMBER             ! & convert.
C
      ELSE                                                    ! Small real.
      WRITE(CHR_FORMAT,'(''(D'',I1,''.'',I1,'')'')')   IX, IY ! Format.
      READ(CHR_STRING,CHR_FORMAT,ERR=9000) NUMBER             ! & convert.
      END IF                                                  !
C
C    Errors...
C    =========
C
      GOTO 9999                               ! Bypass if ok.
9000  CODE = E_CONV$                          ! Unable to convert.
      IF( B_F_MESSAGE$ ) THEN                 !
      WRITE(*,*)                              !
      WRITE(*,*)                              !
     &'**** WARN: unable to decode a number in the string  ****'
      END IF                                  !
C
C    Return to caller...
C    ===================
C
9999  SEI REAL NUM = NUMBER                    ! Assign.
      if( b_f_debug$ ) then                    ! Debug detail.
      write(dbgunit$,*)'sei real num: '
     &                 ,chr_string(:seiclen(chr_string))
     &                 ,' ... ' ,number
      end if
C
      RETURN
      END
C
      SUBROUTINE SEI UPC( CHR_STRING )
C
CSTART*************************************************************************
C                                                                             *
C   System          : SEI  Validation & Application Library                   *
C   Supplier        : BGS/GSRG  Applications Programming Unit                 *
C   Procedure Name  : SEI UPC                                                 *
C   Purpose         : Converts any lowercase letters in CHR_STRING to         *
C                     uppercase                                               *
C   Arguments -Input: CHR_STRING  (C*) String to convert                      *
C            -Output: CHR_STRING  (C*) Converted string                       *
C   Author          : J. A. Bolton                                            *
C   Date            : 23 November 1994                                        *
C   Version         : V01                                                     *
C                                                                             *
CEND***************************************************************************
C
C    Arguments...
C    ============
C
      CHARACTER     CHR_STRING *(*)        ! String to convert.
C
C    Local variables....
C    ===================
C
      INTEGER*4     I,                                !  Loop counter
     &              OFFSET                            !  Case offset.
      CHARACTER     CHR1*(1)                          !  Temporary character
C
C    Set-up local case offset...
C    ===========================
C
      OFFSET = ICHAR('A') - ICHAR('a')                !  Displacement.
C
C    Loop round whole string...
C    ==========================
C
      DO 100 I = 1, LEN(CHR_STRING)                   !  Loop input string.
      CHR1 = CHR_STRING(I:I)                          !  & get character.
         IF( CHR1 .GE. 'a'   .AND.                    !  If lower case... (L11).
     &       CHR1 .LE. 'z' ) THEN                     !
         CHR_STRING(I:I) = CHAR(ICHAR(CHR1)+OFFSET)   !  ...convert to upper
         ENDIF                                        !                   (L11).
100   CONTINUE                                        !
C
C    Return to caller...
C    ===================
C
9999  RETURN
      END
C
CSTART*************************************************************************
C                                                                             *
C                    BGS/GSRG Applications Programming Unit                   *
C                                                                             *
C      Name    : ERROR_BD Error messages for the SEISAN system                *
C      Author  : J. A. Bolton                                                 *
C      Date    : 23 November 1994                                             *
C      Version : V01                                                          *
C                                                                             *
CEND***************************************************************************
C
      BLOCK DATA BD_ERROR
C
C     Insert files....
C     ================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
C
C     Initialise Local & system error vector...
C     =========================================
C
      DATA     ERROR$ / 2*0 /
C
C     Initialise Unrecoverable Local Errors....
C     =========================================
C
      DATA     E_FAIL$ / E_INIT$,
     &                   19*0     /
C
C     Initialise the text string buffer & pointer...
C     ==============================================
C
      DATA     CHR_ERR_MSG$
     &/'                                                            '/,
     &         ERR_LEN$ / 0 /
C
C     Messages texts...
C     =================
C
      DATA CHR_ERR_TXT$(1)
     &/'Unable to convert                                           '/
C
      DATA CHR_ERR_TXT$(2)
     &/'Initialisation error                                        '/
C
      DATA CHR_ERR_TXT$(3)
     &/'Command error, command line not executed                    '/
C
      DATA CHR_ERR_TXT$(4)
     &/'Invalid option supplied                                     '/
C
      DATA CHR_ERR_TXT$(5)
     &/'FORTRAN read-write function error                           '/
C
      DATA CHR_ERR_TXT$(6)
     &/'Unable to open the index file                               '/
C
      DATA CHR_ERR_TXT$(7)
     &/'Empty file or premature end of file                         '/
C
      DATA CHR_ERR_TXT$(8)
     &/'Missing file                                                '/
C
      DATA CHR_ERR_TXT$(9)
     &/'Denominator is too small                                    '/
C
      END
C
CSTART*************************************************************************
C                                                                             *
C                    BGS/GSRG Applications Programming Unit                   *
C                                                                             *
C      Name    : FORTIO_BD File information for current file to open or opened*
C      Author  : J. A. Bolton                                                 *
C      Date    : 23 November 1994                                             *
C      Version : V01                                                          *
C                                                                             *
CEND***************************************************************************
C

      BLOCK DATA BD_FILEIO
C
C     Insert files....
C     ================
C
      INCLUDE  'libsei.inc'      ! Seisan library definitions & data definitions
C
C     Initialise...
C     =============
C
      DATA
C
     &             F_UNIT$       / F_MAXU$ /,
     &             F_RECL$       / 512 /,
     &             CHR_F_STAT$   / ' ' /,
     &             CHR_F_ACCESS$ / ' ' /,
     &             CHR_F_FORM$   / ' ' /,
     &             CHR_F_ACTION$ / CHR_SET_ACTION$ /,
     &             B_F_EXIST$    / .FALSE. /,
     &             B_F_DEBUG$    / .FALSE. /
C
C    The following are protected FORTRAN device numbers....
C    ======================================================
C    The error unit 0 is always protected....
C    ========================================
C
     &             F_PROTECT$/ 
     &                          STD_IN$,    ! Sunos input.
     &                          STD_OUT$ /  ! Sunos ouput.
C
C    Command & output parameter file units...
C    ========================================
C
      DATA         CMDUNIT$ /STD_IN$   /,
     &             PARUNIT$ /STD_OUT$  /,
     &             DBGUNIT$ / 0        /,
     &             CHR_DBG_FILE$ / ' ' /,
C
C    For PC graphics (message suppression)...
C    ========================================
C
     &             B_F_GRAPH$  /.FALSE./ 
     &            ,B_F_PC$     /.FALSE./
     &            ,B_F_MESSAGE$/.TRUE./
C
C    Open file mapping...
C    ====================
C
      DATA
     &             CHR_MAP$       / ' ' /,
     &             CHR_FILE_OPEN$ / MAP_C$*' ' /
C
      END

C
      SUBROUTINE SEI LCS( CHR_STRING )
C
CSTART*************************************************************************
C   Author          : M.Villagran
C   Date            : July 1998 
CEND***************************************************************************
C
C    Arguments...
C    ============
C
      CHARACTER     CHR_STRING *(*)        ! String to convert.
C
C    Local variables....
C    ===================
C
      INTEGER*4     I,                                !  Loop counter
     &              OFFSET                            !  Case offset.
      CHARACTER     CHR1*(1)                          !  Temporary character
C
C    Set-up local case offset...
C    ===========================
C
      OFFSET = ICHAR('a') - ICHAR('A')                !  Displacement.
C
C    Loop round whole string...
C    ==========================
C
      DO 100 I = 1, LEN(CHR_STRING)                   !  Loop input string.
      CHR1 = CHR_STRING(I:I)                          !  & get character.
         IF( CHR1 .GE. 'A'   .AND.                    !  If lower case... (L11).
     &       CHR1 .LE. 'Z' ) THEN                     !
         CHR_STRING(I:I) = CHAR(ICHAR(CHR1)+OFFSET)   !  ...convert to upper
         ENDIF                                        !                   (L11).
100   CONTINUE                                        !
C
C    Return to caller...
C    ===================
C
9999  RETURN
      END
C

c   Subroutines handling waveform file names and a few other things
c
c   changes
c
c sep 16 98 by jh : ----------  version 7.0 check ----------------
c                   waveform data bases to 5 chars
c ??? BM           linux changed line 118 , include comment
c nov 26 98 jh    : add posibility for many waveform directorires
c jan 5 99  jh    : change ,,,,, to ,,
c feb 16 99 jh    : include in libsei
c apr 27 00 lo    : get_full_wav_name search for compressed files
c feb 21 01 lo    : changed file_in,file_out to variable length


      subroutine get_full_wav_name(file_in,file_out)
c
c   Input is a waveform file without full pateh. The routine will search
c   all waveform directories given in wav_base and return the complete
c   file name with path. If the file is not found, the file name will be 
c   returned blank.

      implicit none
      include 'seisan.inc'    ! general seisan variables
      include 'libsei.inc'    ! for libsei
      character*(*) file_in    ! input file
      character*(120) file_in_save    ! input file saved
      character*(*) file_out   ! output file
c lot nov 07, changed next 2
      character*80 top_directory       
      character*240 file_temp
      integer seiclen         ! function to get string length
      character*1 dchar       ! dir char
      character*2 century     ! century
      logical ex              ! file existance
      integer i,j,k,l
      integer nsearch         ! number of serach loops
      parameter (nsearch=5)
      character*4 suffix(nsearch) ! suffix array 
c      character*256 seisarch_cmd  ! command to seisarch
c      character*200 seisarch_path ! output path for seisarch
      character*10 extension
      integer search_loops     ! 1, 2 if BGS

c
c define optional suffixes
c
      suffix(1)=''
      suffix(2)='.gz'
      suffix(3)='.zip'
      suffix(4)='.Z'
      suffix(5)='.bz2'

      call get_env_seisan_extension(extension)
      if(extension(1:3).eq.'BGS') then
        search_loops=2
      else
        search_loops=1
      endif

c
c keep file_in variable
c
      file_in_save = file_in

c
c bgs loop to search in archive if file not found
c
      do l=1,search_loops

c
c loop for suffixes
c
      do k=1,nsearch
        file_out=' '            ! default is file not found
        file_in=file_in(1:seiclen(file_in_save)) // 
     *            suffix(k)(1:seiclen(suffix(k)))

        file_temp=file_in
c
c   search current directory
c
       if (l.eq.1) then
        inquire(file=file_temp,exist=ex)
        if(ex) then
           file_out=file_temp
           return
        endif

c
c   search TMP directory
c

        call topdir(top_directory)
        call dir_char(dchar)        ! get directory separater
        file_temp=top_directory(1:seiclen(top_directory))//dchar//'TMP'
     *  //dchar//file_in(1:seiclen(file_in))
c
c  check if exist
c
        inquire(file=file_temp,exist=ex)
        if(ex) then
           file_out=file_temp
           return
        endif

c
c   search wav directory
c

        call topdir(top_directory)
        call dir_char(dchar)        ! get directory separater
        file_temp=top_directory(1:seiclen(top_directory))//dchar//'WAV'
     *  //dchar//file_in(1:seiclen(file_in))
c
c  check if exist
c
        inquire(file=file_temp,exist=ex)
        if(ex) then
           file_out=file_temp
           return
        endif
c
c   check if an old name without century or a new with century
c
        read(file_in(1:2),'(i2)',err=800) j
        goto 801
c 800    continue   ! jump directly below, jh may 2007
c jh may 07        write(6,*)' Waveform file name does not start with a number'
c       return  ! do not return, changed may 2007 jh
c        stop   ! dont stop, changed 04-04-2001 lo

 801  continue
c
c  now check in all wav data bases
c
         do i=1,n_wav_bases
            if(j.ne.19.and.j.ne.20) then    ! check which century if not given
               if(j.gt.50) then
                  century='19'
               else
                  century='20'
               endif
               file_temp=top_directory(1:seiclen(top_directory))
     *         //dchar//
     *         'WAV'//dchar//wav_base(i)//dchar//
     *         century//                     ! century
     *         file_in(1:2)//dchar//         ! year
     *         file_in(3:4)//dchar//         ! month
     *         file_in(1:seiclen(file_in))
            else
               file_temp=top_directory(1:seiclen(top_directory))
     *         //dchar//
     *         'WAV'//dchar//wav_base(i)//dchar//
     *         file_in(1:4)//dchar//         ! year with century
     *         file_in(6:7)//dchar//         ! month
     *         file_in(1:seiclen(file_in))
            endif
c
c           write(6,'(1x,a)') file_temp
            inquire(file=file_temp,exist=ex)
            if(ex) then
               file_out=file_temp
               return
            endif
         enddo

 800     continue
c
c  now check in all full path directories
c
         do i=1,n_wav_dirs
           file_temp=wav_dirs(i)(1:seiclen(wav_dirs(i)))//
     *     dchar//file_in(1:seiclen(file_in))
 
           inquire(file=file_temp,exist=ex)
           if(ex) then
              file_out=file_temp
              return
           endif
         enddo
c
c extract from archive, as implemented at BGS, Jan 2005
c
c       elseif (l.eq.2) then
c        if(extension(1:3).eq.'BGS'
c     &     .and.(suffix(k).eq.'.gz'.or.
c     &     seiclen(suffix(k)).le.0)) then
c
c          seisarch_path = 
c     &      top_directory(1:seiclen(top_directory))//dchar//'TMP'
c          seisarch_cmd = 'seisarch retrieve_plain ' //
c     &      file_in(1:seiclen(file_in)) // ' ' //
c     &      seisarch_path(1:seiclen(seisarch_path))
c          write(*,*) seisarch_cmd(1:seiclen(seisarch_cmd))
c          call systemc(seisarch_cmd,seiclen(seisarch_cmd))
c
c          file_temp = seisarch_path(1:seiclen(seisarch_path))//dchar//
c     &       file_in(1:seiclen(file_in))
c          inquire(file=file_temp,exist=ex)
c          if(ex) then
c            file_out=file_temp
c            return
c          endif
c        endif
       endif  ! loop eq 2
      enddo   ! loop over suffix
      enddo   ! search loop
      file_in = file_in_save
      return
      end

c ----------------------------------------------------------------------------------------

      subroutine get_seisan_def
c
c   read in seisan parameters
c
      implicit none
      external sei get file,                 ! Search directories & open file.
     &         sei close,                    ! Close file open.
     &         sei code                      ! Error processor.
      include 'libsei.inc'                   ! Library definitions & data defns
      include 'seisan.inc'
      integer  code                          ! Condition.
      logical  b_eof                         ! End of file?.
      real rmap_proj
      real parameter                         ! help variable 
      integer i
c
c-- unit for file
      integer def_unit
c-- directory separator char
      character*1 dchar
      character*5  waveform_base             ! one wav base name
      character*120 data                      ! one line of data
      integer n_cont_trace                   ! # of continiuous traces
      integer seiclen

      call dir_char(dchar)
c
c   set default parameters in case there is no seisan.def
c
      n_wav_dirs=0
      geo_depth1=50.0
      geo_depth2=100.0
      herkij_distance=100.0
      hypo71_offset=0.0
      copy_wav_dir=' '
      text_print=' '
      merge_wav=' '
      high_accuracy=.false.

      cont_before=60.
      if (n_cont_base_sel.le.0) n_cont_base=0
      n_cont_comp=0
      n_cont_trace=0
      cont_before=60.
      cont_after=1000.
      cont_int_s=300.
      cursortype=0.
      focmec_maxsol=100
      myxfont=' '
      myxfont=
     &  '-adobe-courier-bold-r-normal--12-120-75-75-m-70-iso8859-1'
      confirmation_level=1.
      gmap_type='HYBRID    '
      gmap_size_lat=2.0
      gmap_size_lon=2.0
      gmap_dir='/usr/local/apache/htdocs/seismo/SisteJordskjelv'
      
c
c   waveform data base
c
      call get_env_base(waveform_base)    ! check if a given base
      if(waveform_base(1:2).eq.',,'.      ! local base
     *or.waveform_base.eq.'     '.        ! index file
     *or.ichar(waveform_base(1:1)).eq.0) then                  
        call get_def_base(wav_base(1))    ! put the default into #1
        n_wav_bases=1
      else
        wav_base(1)=waveform_base         ! put choses base in #1
        call get_def_base(wav_base(2))    ! put default in #2
        n_wav_bases=2
      endif
c                                                     
                          
c                                                                               
c   open and read default file               
c   ---------------------------
c
      call sei get file( open$+ignore$,    ! Find and open without messages.
     &                   def_unit,         ! On file unit.
     &                   code,             ! Condition (n/a).
     &                   'DAT',            ! Alternative directory to search.
     &                   'SEISAN.DEF' )    ! For this file.
c                                                                               
c   read file if there...
c   ---------------------
c                                                                               
      if(code.ne.e_ok$)  return

 10   continue
c
      read(def_unit,'(a)',iostat=code) data    ! Read from file.
      call sei code( fort$,                    ! Process fortran i/o condition.
     &               code,                     ! Condition.
     &               def_unit,                 ! On unit.
     &               b_eof )                   ! End of file?.
c
      if( .not.b_eof ) then                    ! Not end of file.
c
c   find default wav bases
c
         if(data(1:13).eq.'WAVEFORM_BASE'.and.
     *      data(41:50).ne.'          ') then
            n_wav_bases=n_wav_bases+1
            wav_base(n_wav_bases)=data(41:45)
c
c   check for blanks
c
            do i=2,5
              if(wav_base(n_wav_bases)(i:i).eq.' ') 
     *        wav_base(n_wav_bases)(i:i)='_'
            enddo
         elseif(data(1:13).eq.'WAVEFORM_DIRS'.and.
     *      data(41:80).ne.' ') then
            n_wav_dirs=n_wav_dirs+1
            wav_dirs(n_wav_dirs)=' '
c            wav_dirs(n_wav_dirs)(1:40)=data(41:80), lot nov 07
            wav_dirs(n_wav_dirs)=data(41:seiclen(data))
         elseif (data(1:14).eq.'MERGE_WAVEFORM') then
            merge_wav=data(41:45)
         elseif (data(1:17).eq.'MAP_LAT_BORDER') then
            read(data(41:50),'(f10.1)') map_lat
         elseif (data(1:17).eq.'MAP_LON_BORDER') then
            read(data(41:50),'(f10.1)') map_lon
         elseif (data(1:17).eq.'EPIMAP_LAT_BORDER') then
            read(data(41:50),'(f10.1)') map_lat
         elseif (data(1:17).eq.'EPIMAP_LON_BORDER') then
            read(data(41:50),'(f10.1)') map_lon
         elseif (data(1:15).eq.'EPIMAP_STATIONS') then
            map_stations=data(41:41)
         elseif (data(1:15).eq.'EPIMAP_MAP_FILE') then
            map_file(1:10)=data(41:50)
         elseif (data(1:17).eq.'EPIMAP_PROJECTION') then
            read(data(41:50),'(f10.1)') rmap_proj
            map_proj = int (rmap_proj)
         elseif(data(1:19).eq.'SPECTRAL GEO_DEPTHS'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:60),'(2f10.1)') geo_depth1,geo_depth2
         elseif(data(1:15).eq.'HERKIJ_DISTANCE'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:50),'(f10.1)')herkij_distance 
         elseif(data(1:13).eq.'HYPO71_OFFSET'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:50),'(f10.1)')hypo71_offset 
         elseif(data(1:13).eq.'CONFIRMATION'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:50),'(f10.1)')confirmation_level
         elseif(data(1:13).eq.'REG_KEEP_AUTO'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:50),'(f10.1)') keep_auto
         elseif(data(1:12).eq.'COPY_WAV_DIR'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:45),'(a)') copy_wav_dir 
            do i=2,5
              if(copy_wav_dir(i:i).eq.' ') copy_wav_dir(i:i)='_'
            enddo
         elseif(data(1:10).eq.'TEXT_PRINT'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:80),'(a)') text_print(1:40) 
         elseif(data(1:13).eq.'HIGH_ACCURACY'.and.
     *      data(41:50).ne.'          ') then
            read(data(41:50),'(f10.1)') parameter
            if(parameter.gt.0.0) high_accuracy=.true.
         elseif(data(1:9).eq.'CONT_BASE'.and.
     *      data(41:45).ne.' ') then
            if (n_cont_base_sel.le.0) then
              n_cont_base=n_cont_base+1
              cont_base(n_cont_base)=' '
              cont_base(n_cont_base)(1:5)=data(41:45)
c
c default if Par 2 is 1
c
              cont_base_def(n_cont_base)=0
              read(data(51:60),'(f10.1)') parameter
              if (parameter.eq.1.) cont_base_def(n_cont_base)=1
            endif
c
c also store as wav_base, lot 07/07/2003
c
            n_wav_bases=n_wav_bases+1
            wav_base(n_wav_bases)=data(41:45)
c
c   check for blanks
c
            do i=2,5
              if(wav_base(n_wav_bases)(i:i).eq.' ') 
     *        wav_base(n_wav_bases)(i:i)='_'
            enddo
         elseif(data(1:9).eq.'CONT_COMP'.and.
     *      data(41:44).ne.' ') then
            n_cont_comp=n_cont_comp+1
            cont_comp(n_cont_comp)=' '
            cont_comp(n_cont_comp)(1:4)=data(41:44)
         elseif(data(1:13).eq.'CONT_NET_CODE'.and.
     *      data(41:45).ne.' ') then
            cont_net_code=' '
            cont_net_code(1:5)=data(41:45)
         elseif(data(1:13).eq.'CONT_OPERATOR'.and.
     *      data(41:44).ne.'    ') then
            cont_operator=' '
            cont_operator(1:4)=data(41:44)
         elseif(data(1:11).eq.'CONT_BEFORE') then
            read(data(41:50),'(f10.1)') parameter
            if(parameter.gt.0.0) cont_before=parameter
         elseif(data(1:11).eq.'CONT_AFTER') then
            read(data(41:50),'(f10.1)') parameter
            if(parameter.gt.0.0) cont_after=parameter
         elseif(data(1:13).eq.'CONT_INT_S') then
            read(data(41:50),'(f10.1)') parameter
            if(parameter.gt.0.0) cont_int_s=parameter
         elseif(data(1:6).eq.'CURSOR') then
            read(data(41:50),'(f10.0)') parameter
            cursortype=int(parameter)
         elseif(data(1:13).eq.'FOCMEC MAXSOL') then
            read(data(41:50),'(f10.0)') parameter
            focmec_maxsol=int(parameter)
         elseif(data(1:4).eq.'FONT') then
            myxfont=data(41:seiclen(data))
         elseif(data(1:9).eq.'GMAP_TYPE') then
            read(data(41:50),'(a10)')gmap_type 
         elseif(data(1:9).eq.'GMAP_SIZE') then
            read(data(41:50),'(2f10.0)')gmap_size_lon,gmap_size_lat 
         elseif(data(1:8).eq.'GMAP_DIR') then
            read(data(41:120),'(a80)')gmap_dir 
         elseif(data(1:12).eq.'AUTO_PROCESS'.and.
     *      data(41:50).ne.'          '
     *     .and.data(51:60).ne.'          ') then
            read(data(41:50),'(f10.1)') reg_autoprocess_flag
            reg_autoprocess_name(1:10)=data(51:60)
         endif

c
c   go to next line
c
         goto 10

      endif
c
      call sei close( close$, def_unit, code ) ! Close (Default stop on error).

      return
      end

c ----------------------------------------------------------------------------------------

      subroutine get_cplot_def

c routine to get default values for cplot (defined in CPLOT.DEF)
c    modified after get_seisan_def by Susanne Lund Jensen, May 01
c
c   read in cplot parameters
c
      implicit none
      external sei get file,                 ! Search directories & open file.
     &         sei close,                    ! Close file open.
     &         sei code                      ! Error processor.
      include 'libsei.inc'                   ! Library definitions & data defns
      include 'seisan.inc'
      integer  code                          ! Condition.
      logical  b_eof                         ! End of file?.
      real rmap_proj
      real parameter                         ! help variable 
      integer i
c
c-- unit for file
      integer def_unit
c-- directory separator char
      character*1 dchar
      character*5  waveform_base             ! one wav base name
      character *80 data                     ! one line of data
      integer n_cont_trace                   ! # of continiuous traces
                                        
c
      call dir_char(dchar)
c
c   set default parameters in case there is no seisan.def
c
      n_cont_base=0
      n_cont_comp=0
      n_cont_trace=0
      herkij_distance=100.0
      cont_before=60.
      cont_after=1000.
      cont_int_s=300.
c                                                                               
c   open and read default file               
c   ---------------------------
c
      call sei get file( open$+ignore$,    ! Find and open without messages.
     &                   def_unit,         ! On file unit.
     &                   code,             ! Condition (n/a).
     &                   'DAT',            ! Alternative directory to search.
     &                   'CPLOT.DEF' )     ! For this file.
c                                                                               
c   read file if there...
c   ---------------------
c                                                                               
      if(code.ne.e_ok$)  return

 10   continue
c
      read(def_unit,'(a)',iostat=code) data    ! Read from file.
      call sei code( fort$,                    ! Process fortran i/o condition.
     &               code,                     ! Condition.
     &               def_unit,                 ! On unit.
     &               b_eof )                   ! End of file?.
c
      if( .not.b_eof ) then                    ! Not end of file.

         if(data(1:13).eq.'WAVEFORM_DIRS'.and.
     *      data(41:80).ne.' ') then
            n_wav_dirs=n_wav_dirs+1
            wav_dirs(n_wav_dirs)=' '
            wav_dirs(n_wav_dirs)(1:40)=data(41:80)
         elseif (data(1:14).eq.'MERGE_WAVEFORM') then
            merge_wav=data(41:45)
         elseif(data(1:9).eq.'CONT_BASE'.and.
     *      data(41:45).ne.' ') then
            n_cont_base=n_cont_base+1
            cont_base(n_cont_base)=' '
            cont_base(n_cont_base)(1:5)=data(41:45)
         elseif(data(1:9).eq.'CONT_COMP'.and.
     *      data(41:44).ne.' ') then
            n_cont_comp=n_cont_comp+1
            cont_comp(n_cont_comp)=' '
            cont_comp(n_cont_comp)(1:4)=data(41:44)
         elseif(data(1:13).eq.'CONT_NET_CODE'.and.
     *      data(41:45).ne.' ') then
            cont_net_code=' '
            cont_net_code(1:5)=data(41:45)
         elseif(data(1:13).eq.'CONT_OPERATOR'.and.
     *      data(41:44).ne.'    ') then
            cont_operator=' '
            cont_operator(1:4)=data(41:44)
         elseif(data(1:11).eq.'CONT_BEFORE') then
            read(data(41:50),'(f10.1)') parameter
            if(parameter.gt.0.0) cont_before=parameter
         elseif(data(1:11).eq.'CONT_AFTER') then
            read(data(41:50),'(f10.1)') parameter
            if(parameter.gt.0.0) cont_after=parameter
         elseif(data(1:13).eq.'CONT_INT_S') then
            read(data(41:50),'(f10.1)') parameter
            if(parameter.gt.0.0) cont_int_s=parameter
         endif

c
c   go to next line
c
         goto 10

      endif
c
      call sei close( close$, def_unit, code ) ! Close (Default stop on error).

      return
      end

c ---------------------------------------------------------------------------------------

      subroutine get_bgs_seisan_old(bgs_seisan)
c
c   read in seisan parameters
c
      implicit none
      external sei get file,                 ! Search directories & open file.
     &         sei close,                    ! Close file open.
     &         sei code                      ! Error processor.
      include 'libsei.inc'                   ! Library definitions & data defns
      include 'seisan.inc'
      integer  code                          ! Condition.
      logical  b_eof                         ! End of file?.
c whether to use BGS seisan modifications to output
      logical bgs_seisan
c test variable
      real var
c-- unit for file
      integer def_unit
c-- directory separator char
      character*1 dchar
      character *80 data                     ! one line of data
                                        
c
      call dir_char(dchar)

      bgs_seisan=.false.

c
c   set default parameters in case there is no seisan.def
c
c   open and read default file               
c   ---------------------------
c
      call sei get file( open$+ignore$,    ! Find and open without messages.
     &                   def_unit,         ! On file unit.
     &                   code,             ! Condition (n/a).
     &                   'DAT',            ! Alternative directory to search.
     &                   'SEISAN.DEF' )    ! For this file.
c                                                                               
c   read file if there...
c   ---------------------
c                                                                               
      if(code.ne.e_ok$)  return

 10   continue
c
      read(def_unit,'(a)',iostat=code) data    ! Read from file.
      call sei code( fort$,                    ! Process fortran i/o condition.
     &               code,                     ! Condition.
     &               def_unit,                 ! On unit.
     &               b_eof )                   ! End of file?.
c
      if( .not.b_eof ) then                    ! Not end of file.
c
c   find default wav bases
c
         if(data(1:10).eq.'BGS_SEISAN') then
            read(data(41:50),'(f10.1)') var
            if (var.eq.1.0) then
               bgs_seisan=.true.
            endif
         endif

c
c   go to next line
c
         goto 10

      endif
c
      call sei close( close$, def_unit, code ) ! Close (Default stop on error).

      return
      end



      subroutine PC_TO_TEXT
      return
      end




c
c print version text if argument is '-version'
c
      subroutine print_ver
      implicit none
      include 'version.inc'
      integer nars
      character*80 arg(10)
      integer seiclen
c      character*(*) version

      if (seiclen(out_version_date).le.0) out_version_date=version_date
      call get_arguments(nars,arg) 
      if (nars.eq.1.and.arg(1).eq.'-version') then
        write(*,'(a)') ' '//version_text//
     &      ', '//out_version_date(1:seiclen(out_version_date))
        stop
      endif

      end


      subroutine file_ready(name)
c
c check if file is opened already and wait until it is closed
c
      implicit none
      character*(*)  name
      integer seiclen
      logical opened,exists
      inquire(file=name(1:seiclen(name)),exist=exists)
      if (.not.exists) goto 20
 10   continue
      inquire(file=name,opened=opened)
      if (opened) goto 10
 20   continue
      return
      end


       subroutine remove_letters(text)
c
c  cleans out all non numerical characters to leave numbers,
c  for use with sei get number. leave decimal point
c
c  jh oct 2000
c

       implicit none
       character*80 text
       integer i
       character*1 c

       do i=1,80
          c=text(i:i)
          if(c.ne.'1'.and.c.ne.'2'.and.c.ne.'3'.and.c.ne.'4'.and.
     *       c.ne.'5'.and.c.ne.'6'.and.c.ne.'7'.and.c.ne.'8'.and.
     *       c.ne.'9'.and.c.ne.'0'.and.c.ne.'.') text(i:i)=' '
       enddo
       return
       end


      subroutine exit_with_status(status)
c
c bjb 2001/02/14 set exit codes on unix systems
c in development
c

      implicit none
      integer status
      logical sun,pc,linux

      call computer_type(sun,pc,linux)

      if(pc) then

         stop

      else 

         call exit(status)

      endif


      return
      end

c
c function to find character c in text, starting search from last
c character, lo 21-02-2001
c
      integer function  r_index(text,c)
      implicit none
      character text*(*)
      character*1 c
      integer i,ind
      integer seiclen
      ind = 0
      do i=seiclen(text),1,-1
        if (ind.eq.0.and.text(i:i).eq.c) ind = i
      enddo
      r_index = ind
      end

c$DEBUG
c
c  convert neis files to seisan  format
c
c  j. havskov, december 1994
c
c  updates:
c  feb 14 96 jh: only writing out half the zeroes
c  nov 99      : recompile under version 7.0
c  converts only one input ascii file
c
c  
      implicit none
c-- input data vector	  
      real signal(150000)
c-- input file name	  
      character*80 infile
c-- output file name
      character*80 outfile	  
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
      real lat,lon,height   ! latitude,longitude and height
c--Seisan headers
      character*80 main_head(12)
      character*1040 cha_head
      character*80   chead(13)
      real poles(100),zero(100)      ! poles and zeroes in resp.
      integer npole,nzero            ! # of ------------------
      real norm                      ! normalization factor, resp
c-- sample rate
      real rate	  
c-- total duration of signal
      real total_time
c-- date and time
      character*2 month,day,hour,min
      character*4 year
      integer iyear,imonth,iday,idoy,ihour,imin
c-- day of year
      character*3 doy
c-- start sec
      real sec
      integer isec
c-- station and component
      character*4 comp
      character*5 stat
c-- one line of text
      character*120 text
c--Counters etc
	  integer nsamp,i,k,isamp,line
      equivalence(chead,cha_head)


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c
      open(17,file='scratch')
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c
c  open file and read header
c
      open(1,file=infile,status='old')
c
c   find date etc from header
c	   
c-- station 
       read(1,'(a)') text
       stat=text(1:4)
       stat(5:5)=' '
       comp(1:1)=text(6:6)
       comp(4:4)=text(8:8)
       comp(2:3)='  '
       write(17,'(a)') text(9:120)
       rewind 17
       read(17,*) lat,lon,height,iyear,idoy,ihour,imin,sec,rate,norm
c       write(6,*) lat,lon,height,iyear,idoy,ihour,imin,sec,rate,norm
c
c   the normalization constant, should be counts/m
c
       norm=norm*1.0e12 

      rewind 17
c
c   poles and zeroes
c
       read(1,*) npole
       read(1,*)(poles(i),i=1,2*npole)
       read(1,*) nzero
       if(nzero.gt.0) then
          read(1,*)(zero(i),i=1,2*nzero)
       endif
       if(npole+nzero.gt.37) then
           write(6,*)' Too many poles and zeros, edit input file'
           stop
        endif
c
c   read data
c
       nsamp=0
 50    continue
       read(1,*,end=60) isamp
c       write(6,*) isamp
       read(1,*)(signal(i),i=nsamp+1,nsamp+isamp)
       nsamp=nsamp+isamp
       goto 50
c
c   all data read
c
 60    continue
c
c   write seisan file, first make headers
c
c
c   calculate month and day
c
c      if(iyear.gt.1900) iyear=iyear-1900
      call dte(idoy,iday,imonth,iyear)
      write(year,'(i4)') iyear
      write(day,'(i2)') iday
      write(doy,'(i3)') idoy
      write(month,'(i2)') imonth
      write(hour,'(i2)') ihour
      write(min,'(i2)') imin
      write(6,*) ' Number of samples and rate',nsamp,rate 
      write(6,'(i4,1x,4i3,1x,f6.2)') 
     *iyear,imonth,iday,ihour,imin,sec
c
c   blank headers
c
       do i=1,1040
	     cha_head(i:i)=' '
       enddo
       do i=1,12
         do k=1,80
            main_head(i)(k:k)=' '
         enddo
       enddo
       total_time=nsamp/rate	   
c-- number of channels
       main_head(1)(33:33)='1'	   
c-- year
       main_head(1)(35:36)=year(3:4)
c-- month
       main_head(1)(42:43)=month
c-- day of year
       main_head(1)(38:40)=doy
c-- day
       main_head(1)(45:46)=day	   
c-- hr
       main_head(1)(48:49)=hour
c-- min
       main_head(1)(51:52)=min
c-- sec
       write(main_head(1)(54:59),'(f6.3)')sec
c-- total time
       write(main_head(1)(61:69),'(f9.3)') total_time
c-- station code
       main_head(3)(2:5)=stat(1:4)
c-- channel
       main_head(3)(6:9)=comp
c-- start time relative to main header	   	          	   
       main_head(3)(11:17)='    0.0'
c-- total time
       write(main_head(3)(19:26),'(f8.2)') total_time
c                                                                               
c  make file name on
c             
c-- year                          
         outfile(1:4)=year
         outfile(5:5)='-'               
c-- month                                    
         outfile(6:7)=month		
         outfile(8:8)='-'
c-- day                                      
         outfile(9:10)=day		
         outfile(11:11)='-'
c-- hr                                       
         outfile(12:13)=hour		
c-- min                                    
         outfile(14:15)=min	
         outfile(16:16)='-'
c-- sec               
         isec=sec
         write(outfile(17:18),'(i2)') isec		                    
         outfile(19:20)='S.'
c-- network or station code                  
         outfile(21:24)=stat(1:4)		
         outfile(25:25)='-'
c-- normally number of channels, here use component number for easy sorting
c-- when later merging
         if(comp(4:4).eq.'Z') outfile(26:30)='1'//comp(1:4)
         if(comp(4:4).eq.'N') outfile(26:30)='2'//comp(1:4)
         if(comp(4:4).eq.'E') outfile(26:30)='3'//comp(1:4)
c-- check for blanks                                        
         do i=1,27				
            if(outfile(i:i).eq.' ') outfile(i:i)='0'                            
         enddo                                     
         do i=27,30
		    if(outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo                             
         write(6,200) outfile(1:30)                                             
 200     format(/,' Output file name is: ',a30)                                
c
c   open output file
c
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write data
c
      do i=1,12
         write(2)main_head(i)
      enddo
      close(1)
c
c   channel
c
c   make channel header	
c
c-- station
         cha_head(1:4)=stat(1:4)
c-- component
         cha_head(6:9)=comp
c-- data and time
         cha_head(11:35)=main_head(1)(35:59)	  	     	   	   	   	   	   	   	   		 					 	      	   		  
c-- sample rate
         write(cha_head(37:43),'(f7.3)') rate
c-- number of samples
         write(cha_head(45:50),'(i6)') nsamp	  	  
c-- indicate 4 byte integer
         cha_head(77:77)='4'
c-- indicate that poles and zeros are written
         cha_head(78:78)='P'
c
         write(cha_head(161:182),'(1x,2i5,g11.4)') npole,nzero,norm
         k=23
         line=3
         do i=1,npole*2
            write(chead(line)(k:k+10),'(g11.4)') poles(i)
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
         enddo
         do i=1,nzero*2
            write(chead(line)(k:k+10),'(g11.4)') zero(i)
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
         enddo
c
c   open channnel file, first make name
c
         write(2) cha_head
         write(2)(int(signal(i)),i=1,nsamp)
      close(2)
      write(6,*)
c
c  back for next file if many
c
      if(in.gt.0) goto 1000	  	  	  	  		 	     	  
 99   continue
      stop
      end	   	  	  	         	  	  

c******************************************************************
c Modified version of Ray Buland's SETBRN program which
c runs on both PC's and SUN's
c
c Note: On PC's, SETBRN is too big to run under MSDOS
c to run it under windows using MS Fortran 5.1, compile and
c link it as follows (I assume that you installed your compiler
c in the \FORTRAN subdirectory)
c
c  fl -c -Gt -AH -MW setbrn.for
c  fl -c -Gt -AH -MW tau.for
c  link setbrn+tau,,,/NOD:llibfor7 llibfew,\fortran\binb\fl.def;
c
c Don't try using the programmer's workbench (PWB): its NMAKE facility 
c is all screwed up when it comes to making Window's executables
c
c 3/94 Recompiled using MS Fortran Powerstation: (32 bit compiler which
c generates executables that run under MSDOS on a 386 or better).
c
c Should also work with other 32 bit compilers (Watcom, Microway, etc)
c
c    jh mar 1 99 -------------   Version 7.0 check ----------------
c    no changes
c
c
      program setbrn
c
c Herewith the new version of setbrn.f with separated table and header
c and correct index assignments for direct access (hopefully)
c
      include 'limits.inc'
      save
      character*8 code,phcd
      character*20 modnam
      character*80 fnam
      double precision zm,pm,pb,pu,taup,xp,taul,px,xt,xl,pux,pt,taut,
     1 coef,xa
      double precision tmp(nsl1,2),xm(nsl1,2),deg,dtol,zmax,zoc,zic,
     1 z0
      dimension ndx2(nsr0,2)
      common/umodc/zm(nsr0,2),pm(nsr0,2),ndex(nsr0,2),mt(2)
      common/brkptb/lcb(2),lbb(2),lbrk(nbr2,2)
      common/brkptc/code(nbr1,2)
      common/intc/pb(nsl1),pu(nsl1,2),taup(nsl1,3,2),xp(nsl1,3,2),
     1 taul(nlvz0,2),xl(nlvz0,2),xmin,kb(2),ku(2),lt(2),lvz(nlvz0,2),
     2 kuse(nsl1,2)
      common/segc/fcs(jseg,3),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),
     1 nseg
      common/brnb/px(jbrn,2),xt(jbrn,2),jndx(jbrn,2),mndx(jbrn,2),nbrn
      common/brnc/phcd(jbrn)
      common/msqc/pux(jbrn,2),km(2),midx(jbrn,2)
      common/outc/pt(jout),taut(jout),coef(5,jout),xa(jout),nl
      data nin,nout,xmin,dtol/1,2,200.,1d-6/



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      deg=180d0/3.1415927d0
c
c     write(6,*) "rec length for dasign:"
c     read(5,*) ndasr
c
      fnam='remodl.hed'//char(0)
      call assign(nin,-1,fnam)
      read(nin)ndasr,modnam,zmax,zoc,zic,kb,(pb(i),i=1,kb(2)),
     1 mt,lt,lbb,lcb,xn,pn,tn
      read(nin)((lbrk(i,nph),i=1,lbb(nph)),(code(i,nph),
     1 i=1,lcb(nph)),(zm(i,nph),pm(i,nph),ndex(i,nph),i=1,mt(nph)),
     2 (lvz(i,nph),taul(i,nph),xl(i,nph),i=1,lt(nph)),nph=1,2)
      call iasp91_filename(modnam)
      call retrns(nin)
      print *,'ndasr =',ndasr,'  modnam = ',modnam
c
      call dasign(nin,-1,'remodl.tbl'//char(0),ndasr)
      nrec=0
      do 1 nph=1,2
      n1=kb(nph)
      ind=0
      do 2 k=1,n1
 2    xm(k,nph)=0d0
 3    nrec=nrec+1
      read(nin,rec=nrec)z0,n,(tmp(k,1),k=1,n),(tmp(k,2),k=1,n)
      if(ind.gt.0) go to 4
      if(dabs(z0-zoc).le.dtol) go to 4
      j=1
      do 5 k=2,n
      xm(k,nph)=dmax1(xm(k,nph),dabs(tmp(j,2)-tmp(k,2)))
 5    j=k
      if(n+1.eq.n1) xm(n1,nph)=tmp(n,2)
      go to 3
 4    ind=ind+1
      do 6 k=1,n
      taup(k,ind,nph)=tmp(k,1)
 6    xp(k,ind,nph)=tmp(k,2)
      if(ind.lt.3) go to 3
 1    continue
c
      xmin=xn*xmin
c
      fnam='setbrn1.lis'//char(0)
      call assign(10,2,fnam)
      write(10,*)'kb mt lt lbb lcb',kb,mt,lt,lbb,lcb
      write(10,*)'xn pn tn xmin',xn,pn,tn,xmin
      cn=1./xn
      write(10,209)(i,(lbrk(i,j),code(i,j),j=1,2),i=1,lbb(1))
 209  format(/(1x,2i5,2x,a,i5,2x,a))
      write(10,210)(i,lbrk(i,2),code(i,2),i=lbb(1)+1,lbb(2))
 210  format(1x,i5,15x,i5,2x,a)
      write(10,200,iostat=ios)(i,(zm(i,j),pm(i,j),ndex(i,j),j=1,2),
     1 i=1,mt(1))
 200  format(/(1x,i5,2f12.6,i5,2x,2f12.6,i5))
      write(10,201,iostat=ios)(i,zm(i,2),pm(i,2),ndex(i,2),
     1 i=mt(1)+1,mt(2))
 201  format(1x,i5,31x,2f12.6,i5)
      write(10,217)((nph,i,lvz(i,nph),taul(i,nph),deg*xl(i,nph),
     1 i=1,lt(nph)),nph=1,2)
 217  format(/(1x,3i5,f12.6,f12.2))
      write(10,202)(i,pb(i),cn*xm(i,1),cn*xm(i,2),i=1,kb(1))
 202  format(/(5x,i5,f12.6,2f12.2))
      write(10,203)(i,pb(i),cn*xm(i,2),i=kb(1)+1,kb(2))
 203  format(5x,i5,f12.6,12x,f12.2)
      call retrns(10)
      fnam='setbrn2.lis'//char(0)
      call assign(10,2,fnam)
c
      do 8 nph=1,2
      n1=kb(nph)
      do 9 i=2,n1
      xm(i,nph)=xm(i-1,nph)+xm(i,nph)
      pu(i,nph)=pb(i)
 9    kuse(i,nph)=-1
      do 8 ind=3,2,-1
      jnd=ind-1
      do 8 i=1,n1
      taup(i,ind,nph)=taup(i,ind,nph)-taup(i,jnd,nph)
 8    xp(i,ind,nph)=xp(i,ind,nph)-xp(i,jnd,nph)
      do 10 nph=1,2
 10   call pdecx(kb(nph),nph,xm,2.)
c
      write(10,*)'ku',ku
      write(10,204)(i,(pu(i,nph),cn*xm(i,nph),cn*(xm(i+1,nph)-
     1 xm(i,nph)),nph=1,2),i=1,ku(1))
 204  format(/(5x,i5,2(f12.6,2f12.2)))
      write(10,205)(i,pu(i,2),cn*xm(i,2),cn*(xm(i+1,2)-xm(i,2)),
     1 i=ku(1)+1,ku(2))
 205  format(5x,i5,36x,f12.6,2f12.2)
      do 207 nph=1,2
 207  write(10,206)(i,pb(i),(taup(i,j,nph),j=1,3),(deg*xp(i,j,nph),
     1 j=1,3),i=1,kb(nph))
 206  format(/(1x,i5,4f10.6,3f10.2))
c
      call layout
c     write(10,214)(i,pb(i),(kuse(i,j),j=1,2),i=1,kb(2))
c214  format(/(5x,i5,f12.6,2i5))
      do 11 nph=1,2
      n1=kb(nph)
      k=0
      do 12 i=1,n1
      if(kuse(i,nph).lt.0) go to 12
      k=k+1
      pu(k,nph)=pb(i)
 12   continue
 11   ku(nph)=k
      call kseq
      call mseq
      write(10,215)(i,(pu(i,j),j=1,2),i=1,ku(1))
 215  format(/(5x,i5,2f12.6))
      write(10,216)(i,pu(i,2),i=ku(1)+1,ku(2))
 216  format(5x,i5,12x,f12.6)
      write(10,208)(i,(nafl(i,j),j=1,3),(indx(i,j),j=1,2),(kndx(i,j),
     1 j=1,2),(fcs(i,j),j=1,3),i=1,nseg)
 208  format(/(1x,8i6,3f6.1))
      write(10,211)(i,(jndx(i,j),j=1,2),(mndx(i,j),j=1,2),(px(i,j),
     1 j=1,2),(deg*xt(i,j),j=1,2),phcd(i),i=1,nbrn)
 211  format(/(1x,i3,4i5,2f12.6,2f10.2,2x,a))
      write(10,218)(i,(midx(i,j),j=1,2),(pux(i,j),j=1,2),
     1 i=1,max0(km(1),km(2)))
 218  format(/(1x,i3,2i5,2f12.6))
      write(10,212,iostat=ios)(i,pt(i),taut(i),deg*xa(i),
     1 cn*(xa(i)-xa(i+1)),(coef(j,i),j=1,5),i=1,nl)
 212  format(/(1x,i4,0p2f12.6,2f10.2,1p5d10.2))
      call retrns(10)
c
      fnam='setbrn3.lis'//char(0)
      call assign(10,2,fnam)
      do 20 nph=1,2
      mt(nph)=mt(nph)-3
      ku(nph)=ku(nph)-1
 20   km(nph)=km(nph)-1
c     icor=33  -  originally 32 records used as header in setbrn
c                 and 2 records used as header in remodl.
      icor=3
      do 14 nph=1,2
      m1=mt(nph)
      icor=icor-3
      do 14 i=2,m1
 14   ndx2(i,nph)=ndex(i,nph)+icor
      len1=ku(2)+km(2)
      len0=8*len1
      len2=5*nl
      write(10,*)'nseg nbrn mt ku km len len1',nseg,nbrn,mt,ku,km,len0,
     1 len1
      write(10,*)
      nasgr = len0
      write(6,*) 'reclength for direct access', nasgr
c++ 
c     write(6,*) 'enter model name'
c     read(5,*) cmodel
      nb=index(modnam,' ')-1
      if(nb.le.0) nb=len(modnam)
c     cnam1 = cmodel(1:nb)//'.tbl'
c     cnam2 = cmodel(1:nb)//'.hed'
      write(6,*) 'header file  :',modnam(1:nb)//'.HED'
      write(6,*) 'table file   :',modnam(1:nb)//'.TBL'
      fnam=modnam(1:nb)//'.HED'//char(0)
      call assign(nout,-2,fnam)
c++ 
      write(nout) nasgr,nl,len2,xn,pn,tn,mt,nseg,nbrn,ku,km,fcs
      do i=1,jseg
        write(nout)(nafl(i,j),j=1,3)
        write(nout)(indx(i,j),j=1,2)
        write(nout)(kndx(i,j),j=1,2)
      enddo
      do i=1,nsr0
        write(nout)(pm(i,j),j=1,2)
        write(nout)(zm(i,j),j=1,2)
      end do
      do i=1,nsr0
        write(nout)(ndx2(i,j),j=1,2)
      enddo
      do i=1,nsl1
        write(nout)(pu(i,j),j=1,2)
      end do
      do i=1,jbrn
        write(nout)(pux(i,j),j=1,2)
      end do
      write(nout) phcd
      do i=1,jbrn
        write(nout)(px(i,j),j=1,2)
        write(nout)(xt(i,j),j=1,2)
        write(nout)(jndx(i,j),j=1,2)
      end do
      write(nout) pt,taut
      do i=1,jout
       write(nout)(coef(j,i),j=1,5)
c       write(*,'(5f12.4)')(coef(j,i),j=1,5)
      end do
      call retrns(nout)
c
      call dasign(nout,-2,modnam(1:nb)//'.TBL'//char(0),nasgr)
      nrec = 0
      do 16 nph=1,2
      m1=mt(nph)
      n1=ku(nph)
      k1=km(nph)
      write(10,*)'nph m1 n1 k1',nph,m1,n1,k1
      do 16 m=2,m1
      if(ndex(m,nph).eq.ndex(m-1,nph)) go to 16
      read(nin,rec=ndex(m,nph))z0,n,(tmp(k,1),k=1,n),(tmp(k,2),k=1,n)
      write(10,*)'m nph ndex n',m,nph,ndex(m,nph),n
      k=0
      l=1
      do 17 i=1,n
      if(kuse(i,nph).lt.0) go to 17
      if(dabs(pux(l,nph)-pb(i)).gt.dtol) go to 18
      tmp(l,2)=tmp(i,2)
      l=l+1
 18   k=k+1
      tmp(k,1)=tmp(i,1)
 17   continue
      write(10,*)'k l nrec',k,l-1,nrec+1,ndx2(m,nph),sngl(tmp(1,1))
      if(k.ge.n1) go to 19
      k=k+1
      do 21 i=k,n1
 21   tmp(i,1)=0d0
 19   if(l.gt.k1) go to 23
      do 22 i=l,k1
 22   tmp(i,2)=0d0
 23   nrec=nrec+1
      write(nout,rec=nrec)(tmp(i,1),i=1,n1),(tmp(i,2),i=1,k1)
 16   continue
c
      call retrns(10)
      call retrns(nin)
      call retrns(nout)
      call vexit(0)
      end
c
      subroutine pdecx(n1,nph,xm,fac)
      save 
      include 'limits.inc'
      double precision pb,pu,taup,xp,taul,xl
      double precision xm(nsl1,2),ptol,pa,pax,plim
      common/intc/pb(nsl1),pu(nsl1,2),taup(nsl1,3,2),xp(nsl1,3,2),
     1 taul(nlvz0,2),xl(nlvz0,2),xmin,kb(2),ku(2),lt(2),lvz(nlvz0,2),
     2 kuse(nsl1,2)
      data ptol/.03/
c
      call collct(1,n1,xm(1,nph),fac*xmin)
      k=0
      plim=.7d0*pu(n1,nph)
      do 1 i=1,n1
      if(xm(i,nph).lt.0d0) go to 1
      if(pu(i,nph).lt.plim) go to 2
      if(pu(i,nph)-pu(k,nph).le.ptol) go to 2
      pa=pu(k,nph)+.75d0*(pu(i,nph)-pu(k,nph))
      pax=1d10
      m=0
      do 3 j=i1,i
      if(dabs(pu(j,nph)-pa).ge.pax) go to 3
      m=j
      pax=dabs(pu(j,nph)-pa)
 3    continue
      if(m.eq.i1.or.m.eq.i) go to 2
      k=k+1
      pu(k,nph)=pu(m,nph)
      xm(k,nph)=0d0
      kuse(m,nph)=1
 2    k=k+1
      i1=i
      pu(k,nph)=pu(i,nph)
      xm(k,nph)=xm(i,nph)
      kuse(i,nph)=1
 1    continue
      ku(nph)=k
      return
      end
c
      subroutine collct(i1,i2,x,xmn)
c
c $$$$$ calls varn $$$$$
c
      save
      double precision x(i2)
c
      is=i1+1
      ie=i2-1
      if(ie.lt.is) return
      k1=i1
      var=0.
      m=0
      do 1 i=is,ie
      dx1=dabs(x(k1)-x(i))-xmn
      dx2=dabs(x(k1)-x(i+1))-xmn
      if(abs(dx2).ge.abs(dx1)) go to 2
      x(i)=-x(i)
      go to 1
 2    if(k1.le.i1) kb=i
      k1=i
      var=var+dx1*dx1
      m=m+1
 1    continue
      dx1=dabs(x(k1)-x(i2))-xmn
      var=var+dx1*dx1
      m=m+1
 7    if(m.le.1) return
      k1=i1
      k2=kb
      ks=kb+1
      nch=0
      write(10,*)'ks,i2',ks,i2
      do 8 i=ks,i2
      if(x(i).lt.0d0) go to 8
      k0=k1
      k1=k2
      k2=i
      var1=varn(x,k0,k1,k2,k1-1,xmn,var,m,m1)
      var2=varn(x,k0,k1,k2,k1+1,xmn,var,m,m2)
      if(amin1(var1/m1,var2/m2).ge.var/m) go to 6
      nch=nch+1
      x(k1)=-x(k1)
      if(var1/m1-var2/m2)3,4,5
 4    if(m1-m2)3,3,5
 3    k1=k1-1
      x(k1)=dabs(x(k1))
      var=var1
      m=m1
      go to 6
 5    k1=k1+1
      x(k1)=dabs(x(k1))
      var=var2
      m=m2
 6    if(k0.eq.i1) kb=k1
 8    continue
      if(nch.gt.0) go to 7
      return
      end
c
      function varn(x,k0,k1,k2,kt,xmn,var,m,mn)
c
c $$$$$ calls only library routines $$$$$
c
      save
      double precision x(k2)
c
      dx1=dabs(x(k0)-x(k1))-xmn
      dx2=dabs(x(k1)-x(k2))-xmn
      varn=var-dx1*dx1-dx2*dx2
      if(kt.le.k0.or.kt.ge.k2) go to 1
      dx1=dabs(x(k0)-dabs(x(kt)))-xmn
      dx2=dabs(dabs(x(kt))-x(k2))-xmn
      varn=varn+dx1*dx1+dx2*dx2
      mn=m
      return
 1    dx1=dabs(x(k0)-dabs(x(k2)))-xmn
      varn=varn+dx1*dx1
      mn=m-1
      return
      end
c
      subroutine layout
c
c   Layout contains the program for the desired travel-time segments 
c   implemented as calls to the mk_br entry points.  Each call does one 
c   segment (which may have many branches).
c
      save 
      include 'limits.inc'
      double precision pb,pu,taup,xp,taul,xl,px,xt,pt,taut,coef,xa
      double precision dir(3),cref(3),sref(3)
      common/brkptb/lcb(2),lbb(2),lbrk(nbr2,2)
      common/intc/pb(nsl1),pu(nsl1,2),taup(nsl1,3,2),xp(nsl1,3,2),
     1 taul(nlvz0,2),xl(nlvz0,2),xmin,kb(2),ku(2),lt(2),lvz(nlvz0,2),
     2 kuse(nsl1,2)
      common/segc/fcs(jseg,3),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),
     1 nseg
      common/brnb/px(jbrn,2),xt(jbrn,2),jndx(jbrn,2),mndx(jbrn,2),nbrn
      common/outc/pt(jout),taut(jout),coef(5,jout),xa(jout),nl
      data dir,cref,sref/1d0,1d0,1d0,1d0,2d0,2d0,2d0,2d0,2d0/
c
c   Initialize variables.
      nseg=0
      nbrn=0
      nl=0
      do 1 j=1,3
      do 1 i=1,jseg
 1    fcs(i,j)=0.
      do 2 i=1,jout
 2    taut(i)=0d0
      do 3 j=1,2
      do 3 i=1,jbrn
 3    xt(i,j)=0d0
c
c   Do all of the segments.
c
c   P (up-going branch).
      print *,'Layout:  do Pup'
      call mkubr(ku(1),   +1)
c   P, Pdiff, and PKP.
      print *,'Layout:  do P and PKP'
      call mkdbr(1,lbb(1),-1,3,1,1,dir)
c   PKiKP.
      print *,'Layout:  do PKiKP'
      call mkrbr(2,       -1,2,1,1,dir)
c   pP.
      print *,'Layout:  do pP'
      call mkdbr(1,lbb(1),+1,3,1,1,dir)
c   sP.
      print *,'Layout:  do sP'
      call mkdbr(1,lbb(1),+2,3,1,1,dir)
c   pPKiKP.
      print *,'Layout:  do pPKiKP'
      call mkrbr(2,       +1,2,1,1,dir)
c   sPKiKP.
      print *,'Layout:  do sPKiKP'
      call mkrbr(2,       +2,2,1,1,dir)
c   PcP.
      print *,'Layout:  do PcP'
      call mkrbr(3,       -1,1,1,1,dir)
c   ScP.
      print *,'Layout:  do ScP'
      call mkrbr(3,       -2,1,2,1,dir)
c   SKP.
      print *,'Layout:  do SKP'
      call mkdbr(1,3,     -2,3,2,1,dir)
c   SKiKP.
      print *,'Layout:  do SKiKP'
      call mkrbr(2,       -2,2,2,1,dir)
c   PKKP.
      print *,'Layout:  do PKKP'
      call mkdbr(1,3,     -1,3,1,1,cref)
c   SKKP.
      print *,'Layout:  do SKKP'
      call mkdbr(1,3,     -2,3,2,1,cref)
c   PP and P'P'.
      print *,'Layout:  do PP, P''P'''
      call mkdbr(1,lbb(1),-1,3,1,1,sref)
c   S (up-going branch).
      print *,'Layout:  do Sup'
      call mkubr(ku(2),   +2)
c   S, Sdiff, and SKS.
      print *,'Layout:  do S and SKS'
      call mkdbr(1,lbb(2),-2,3,2,2,dir)
c   pS
      print *,'Layout:  do pS'
      call mkdbr(1,lbb(1),+1,3,2,2,dir)
c   sS
      print *,'Layout:  do sS'
      call mkdbr(1,lbb(2),+2,3,2,2,dir)
c   ScS
      print *,'Layout:  do ScS'
      call mkrbr(4,       -2,1,2,2,dir)
c   PcS
      print *,'Layout:  do PcS'
      call mkrbr(3,       -1,1,1,2,dir)
c   PKS
      print *,'Layout:  do PKS'
      call mkdbr(1,3,     -1,3,1,2,dir)
c   PKKS
      print *,'Layout:  do PKKS'
      call mkdbr(1,3,     -1,3,1,2,cref)
c   SKKS
      print *,'Layout:  do SKKS'
      call mkdbr(1,3,     -2,3,2,2,cref)
c   SS and S'S'.
      print *,'Layout:  do SS and S''S'''
      call mkdbr(1,lbb(2),-2,3,2,2,sref)
c   SP
      print *,'Layout:  do SP'
      call mkcbr(4,lbb(1),-2,1,2,1,sref)
c   PS
      print *,'Layout:  do PS'
      call mkcbr(4,lbb(1),-1,1,1,2,sref)
      return
      end
c
      subroutine mkdbr(l1,l2,isgn,lyr,nph,kph,fac)
c
c   Mkdbr sets up a simple refracted wave segment.  L1 and l2 point to the 
c   lbrk array of slowness break point pointers.  Note that the P and S 
c   break point arrays don't necessarily line up layer by layer.  This is 
c   not generally a problem as most phases need only worry about the 
c   pointer to the surface slowness for one wave type and a pointer 
c   somewhere in the core (which is constrained to be the same for both 
c   P and S).  Isgn is positive if the wave starts out going up and 
c   negative if the wave starts out going down.  Iabs(isng) is 1 if the 
c   wave starts out as a P wave and 2 if the wave starts out as an S wave.  
c   Lyr gives the number of major layers (mantle, outer core, and inner 
c   core) that the wave penetrates.  Nph and kph give the wave type (1 for 
c   P and 2 for S) on the down-going and up-going legs of the ray path 
c   respectively.  Fac is a three element array giving the number of 
c   repeats of the ray path in each major layer.  This scheme incorporates 
c   turning rays (e.g., P and S), turning rays reflected, but not 
c   converted at the surface (e.g., PP and SS), up-going rays reflected 
c   and/or converted at the surface into turning rays (e.g., pP and sP), 
c   turning rays converted during transmission through an interface (e.g., 
c   SKP and PKS), and rays which turn multiple times while reflecting from 
c   the bottom side of a layer (e.g., PKKP or SKKP).  Mkdbr does not 
c   include up-going rays (to the receiver), rays reflected from the top 
c   side of a discontinuity, or rays which are reflected and converted at 
c   the free surface.  See mkubr, mkrbr, and mkcbr respectively for 
c   routines which handle these types of rays.
c
      save
      include 'limits.inc'
      character*8 code,phcd,ks,phcd1,phcd2
      double precision pb,pu,taup,xp,taul,xl,px,xt,pt,taut,coef,xa
      double precision fac(3)
      common/brkptb/lcb(2),lbb(2),lbrk(nbr2,2)
      common/brkptc/code(nbr1,2)
      common/intc/pb(nsl1),pu(nsl1,2),taup(nsl1,3,2),xp(nsl1,3,2),
     1 taul(nlvz0,2),xl(nlvz0,2),xmin,kb(2),ku(2),lt(2),lvz(nlvz0,2),
     2 kuse(nsl1,2)
      common/segc/fcs(jseg,3),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),
     1 nseg
      common/brnb/px(jbrn,2),xt(jbrn,2),jndx(jbrn,2),mndx(jbrn,2),nbrn
      common/brnc/phcd(jbrn)
      common/outc/pt(jout),taut(jout),coef(5,jout),xa(jout),nl
      data ks/'KKKKKKKK'/
c
c   Remember the programming as part of the final phase construction is 
c   done in depcor.
      nseg=nseg+1
      nafl(nseg,1)=isgn
      nafl(nseg,2)=nph
      nafl(nseg,3)=kph
      indx(nseg,1)=nl+1
      kndx(nseg,1)=1
c   Using l1 and l2 to get the breakpoints has some shortcommings, 
c   particularly for converted phases.  It would be more general to 
c   have separate indicies for the breakpoints and the layers covered.
      if(l1.gt.1) kndx(nseg,1)=lbrk(l1-1,nph)
      kndx(nseg,2)=min0(min0(lbrk(l2,nph),lbrk(l2,kph)),
     1 lbrk(l2,iabs(isgn)))
      print *,'Mkdbr:  l1 l2 isgn lyr nph kph =',l1,l2,isgn,lyr,nph,kph
      print *,'Mkdbr:  nseg kndx indx =',nseg,kndx(nseg,1),kndx(nseg,2),
     1 indx(nseg,1)
      xfc=0.
      do 14 m=1,lyr
      fcs(nseg,m)=fac(m)
 14   xfc=amax1(xfc,fcs(nseg,m))
c
c   Set up the required slownesses, taus and distances.
c
      j=kndx(nseg,1)
      lz1=1
      lz2=1
c   Loop over the layers of interest.
      do 1 i=l1,l2
c   Be sure that the phase cuts off at the right place.
      l=min0(lbrk(i,nph),kndx(nseg,2))
c   Skip all total internal reflections.
      if(code(i,nph)(1:1).eq.'r'.or.j.ge.l) go to 1
c   Set the starting branch pointer.
      nbrn=nbrn+1
      nt=nl+1
      jndx(nbrn,1)=nt
c   Copy in the desired slownesses.
      do 2 k=j,l
      nl=nl+1
      pt(nl)=pb(k)
c   Add up the tau contributions.
      do 2 m=1,lyr
 2    taut(nl)=taut(nl)+fac(m)*(taup(k,m,nph)+taup(k,m,kph))
c   Take care of branch end pointers and slownesses.
      mndx(nbrn,1)=j
      mndx(nbrn,2)=l
      px(nbrn,1)=pb(j)
      px(nbrn,2)=pb(l)
c   Add up distance contributions for the branch end points only.
      do 3 m=1,lyr
      xt(nbrn,1)=xt(nbrn,1)+fac(m)*(xp(j,m,nph)+xp(j,m,kph))
 3    xt(nbrn,2)=xt(nbrn,2)+fac(m)*(xp(l,m,nph)+xp(l,m,kph))
c   Take care of the contribution due to low velocity zones for the 
c   down-going leg(s).
      if(j.ne.lvz(lz1,nph)) go to 9
      do 11 m=1,lyr
      taut(nt)=taut(nt)-fac(m)*taup(j,m,nph)
 11   xt(nbrn,1)=xt(nbrn,1)-fac(m)*xp(j,m,nph)
      taut(nt)=taut(nt)+fac(1)*taul(lz1,nph)
      xt(nbrn,1)=xt(nbrn,1)+fac(1)*xl(lz1,nph)
      lz1=lz1+1
c   Take care of the contributions due to low velocity zones for the 
c   up-going leg(s).
 9    if(j.ne.lvz(lz2,kph)) go to 10
      do 12 m=1,lyr
      taut(nt)=taut(nt)-fac(m)*taup(j,m,kph)
 12   xt(nbrn,1)=xt(nbrn,1)-fac(m)*xp(j,m,kph)
      taut(nt)=taut(nt)+fac(1)*taul(lz2,kph)
      xt(nbrn,1)=xt(nbrn,1)+fac(1)*xl(lz2,kph)
      lz2=lz2+1
c   Decimate the slownesses if the branch is oversampled in distance.
 10   call pdect(jndx(nbrn,1),nl,j,iabs(isgn),xfc)
c   Set up the interpolation.
      call tauspl(jndx(nbrn,1),nl,pt,coef)
c   Remember the final branch end slowness value.
      jndx(nbrn,2)=nl
c
c   Take care of the branch name.  First, set up a default.
      phcd1=code(i,kph)(3:)
      phcd(nbrn)=code(i,nph)(2:2)//phcd1(1:7)
      if(idint(fac(1)+.5d0).gt.1) go to 5
      if(idint(fac(2)+.5d0).le.1) go to 4
c   Re-do the name if the ray is reflected from the underside of the 
c   core-mantle boundary.
      ind=idint(fac(2)-.5d0)
      phcd1=code(i,kph)(3:)
      phcd(nbrn)=code(i,nph)(2:2)//ks(1:ind)//phcd1(1:7-ind)
      go to 4
c   Re-do the name if the ray is reflected from the surface.
 5     phcd1=code(i,kph)(2:)
       if(code(i,nph)(3:3).eq.' ') phcd(nbrn)=code(i,nph)(2:2)//
     1 phcd1(1:7)
      phcd1=code(i,kph)(2:)
      if(code(i,nph)(3:3).ne.' '.and.code(i,nph)(3:3).ne.'K')
     1  phcd(nbrn)=code(i,nph)(2:3)//phcd1(1:6)
      phcd1=code(i,kph)(2:2)
      phcd2=code(i,kph)(5:)
      if(code(i,nph)(3:3).eq.'K') phcd(nbrn)=code(i,nph)(2:2)//''''//
     1 phcd1(1:1)//''''//phcd2(1:4)
c   Take care .
 4    ind=max0(index(phcd(nbrn),'KSab'),index(phcd(nbrn),'S''ab'))
      if(phcd(nbrn)(1:1).eq.'S'.and.ind.gt.0) phcd(nbrn)(ind+2:ind+3)=
     1 'ac'
      phcd1=phcd(nbrn)
      if(isgn.eq.1) phcd(nbrn)='p'//phcd1(1:7)
      if(isgn.eq.2) phcd(nbrn)='s'//phcd1(1:7)
 1    j=l
      indx(nseg,2)=nl
      return
c
c   Mkubr handles up-going P and S.  L1 and isgn are as for mkdbr (except 
c   that l1 actually plays the role of l2 with the beginning break point 
c   assumed to be zero).  The other arguments are not needed.
c
      entry mkubr(l1,isgn)
      nseg=nseg+1
      nafl(nseg,1)=isgn
      nafl(nseg,2)=0
      nafl(nseg,3)=0
      indx(nseg,1)=nl+1
      kndx(nseg,1)=1
      l=kb(iabs(isgn))
      kndx(nseg,2)=l
      print *,'Mkubr:  l1 isgn =',l1,isgn
      print *,'Mkubr:  nseg kndx indx =',nseg,kndx(nseg,1),kndx(nseg,2),
     1 indx(nseg,1)
      nbrn=nbrn+1
      jndx(nbrn,1)=nl+1
      do 6 k=1,l1
      nl=nl+1
      pt(nl)=pu(k,isgn)
 6    xa(nl)=0d0
      mndx(nbrn,1)=1
      mndx(nbrn,2)=l
      px(nbrn,1)=pb(1)
      px(nbrn,2)=pb(l)
      call tauspl(jndx(nbrn,1),nl,pt,coef)
      jndx(nbrn,2)=nl
      phcd(nbrn)=code(1,iabs(isgn))(2:2)
      indx(nseg,2)=nl
      return
c
c   Mkrbr handles reflected phases possibly with a conversion such as 
c   PcP, PcS, and PkiKP.  Arguments are as for mkdbr (except that l1 
c   actually plays the role of l2 with the beginning break point assumed 
c   to be zero).
c
      entry mkrbr(l1,isgn,lyr,nph,kph,fac)
      nseg=nseg+1
      nafl(nseg,1)=isgn
      nafl(nseg,2)=nph
      nafl(nseg,3)=kph
      indx(nseg,1)=nl+1
      kndx(nseg,1)=1
      l=min0(lbrk(l1,nph),lbrk(l1,kph))
      kndx(nseg,2)=l
      print *,'Mkrbr:  l1 isgn lyr nph kph =',l1,isgn,lyr,nph,kph
      print *,'Mkrbr:  nseg kndx indx =',nseg,kndx(nseg,1),kndx(nseg,2),
     1 indx(nseg,1)
      xfc=0.
      do 15 m=1,lyr
      fcs(nseg,m)=fac(m)
 15   xfc=amax1(xfc,fcs(nseg,m))
      if(lyr.ge.2) xfc=2.
c
      nbrn=nbrn+1
      jndx(nbrn,1)=nl+1
      do 7 k=1,l
      nl=nl+1
      pt(nl)=pb(k)
      do 7 m=1,lyr
 7    taut(nl)=taut(nl)+fac(m)*(taup(k,m,nph)+taup(k,m,kph))
      mndx(nbrn,1)=1
      mndx(nbrn,2)=l
      px(nbrn,1)=pb(1)
      px(nbrn,2)=pb(l)
      do 8 m=1,lyr
 8    xt(nbrn,2)=xt(nbrn,2)+fac(m)*(xp(l,m,nph)+xp(l,m,kph))
c      write(10,*)'jndx1',jndx(nbrn,1)
      call pdect(jndx(nbrn,1),nl,1,iabs(isgn),xfc)
      call tauspl(jndx(nbrn,1),nl,pt,coef)
c      write(10,*)'jndx2',jndx(nbrn,1)
      jndx(nbrn,2)=nl

c changed BRL
      phcd1=code(l1,kph)(2:2)
      if(lyr.eq.1) phcd(nbrn)=code(l1,nph)(2:2)//'c'//phcd1(1:6)
      phcd1=code(l1,kph)(3:)
      if(lyr.eq.2) phcd(nbrn)=code(l1,nph)(2:2)//phcd1(1:7)
      phcd1=phcd(nbrn)(1:7)
      if(isgn.eq.1) phcd(nbrn)='p'//phcd1(1:7)
      if(isgn.eq.2) phcd(nbrn)='s'//phcd1(1:7)

      indx(nseg,2)=nl
      return
c
c   Mkcbr handles phases reflected and converted at the surface such as 
c   PS and SP.  Arguments are as for mkdbr.
c
      entry mkcbr(l1,l2,isgn,lyr,nph,kph,fac)
      if(nph.gt.0.and.kph.gt.0.and.nph.ne.kph) go to 29
      print *,'Mkcbr:  bad call - nph kph =',nph,kph
      call vexit(1)
 29   nseg=nseg+1
      nafl(nseg,1)=isgn
      nafl(nseg,2)=nph
      nafl(nseg,3)=kph
      indx(nseg,1)=nl+1
      kndx(nseg,1)=1
      if(l1.gt.1) kndx(nseg,1)=min0(lbrk(l1,nph),lbrk(l1,kph))
      kndx(nseg,2)=min0(min0(lbrk(l2,nph),lbrk(l2,kph)),
     1 lbrk(l2,iabs(isgn)))
      print *,'Mkcbr:  l1 l2 isgn lyr nph kph =',l1,l2,isgn,lyr,nph,kph
      print *,'Mkcbr:  nseg kndx indx =',nseg,kndx(nseg,1),kndx(nseg,2),
     1 indx(nseg,1)
      xfc=0.
      do 16 m=1,lyr
      fcs(nseg,m)=fac(m)
 16   xfc=amax1(xfc,fcs(nseg,m))
c
      j=kndx(nseg,1)
      lz1=1
      lz2=1
      ik=l1
c
      print *,'Mkcbr:  start loop'
      do 17 in=l1,l2
 31   l=min0(lbrk(in,nph),kndx(nseg,2))
      if(code(in,nph)(1:1).eq.'r'.or.j.ge.l) go to 17
      l=min0(lbrk(ik,kph),kndx(nseg,2))
      if(code(ik,kph)(1:1).ne.'r'.and.j.lt.l.or.ik.ge.l2) go to 28
      j=max0(j,l)
      ik=ik+1
      go to 31
c
 28   if(lbrk(in,nph).le.lbrk(ik,kph)) go to 26
      l=min0(lbrk(ik,kph),kndx(nseg,2))
      print *,'kph:  kph ik j l code =',kph,ik,j,l,' ',code(ik,kph)
      isw=2
      go to 27
 26   l=min0(lbrk(in,nph),kndx(nseg,2))
      print *,'nph:  nph in j l code =',nph,in,j,l,' ',code(in,nph)
      isw=1
c
 27   nbrn=nbrn+1
      nt=nl+1
      jndx(nbrn,1)=nt
      do 18 k=j,l
      nl=nl+1
      pt(nl)=pb(k)
      do 18 m=1,lyr
 18   taut(nl)=taut(nl)+fac(m)*(taup(k,m,nph)+taup(k,m,kph))
      mndx(nbrn,1)=j
      mndx(nbrn,2)=l
      px(nbrn,1)=pb(j)
      px(nbrn,2)=pb(l)
      do 19 m=1,lyr
      xt(nbrn,1)=xt(nbrn,1)+fac(m)*(xp(j,m,nph)+xp(j,m,kph))
 19   xt(nbrn,2)=xt(nbrn,2)+fac(m)*(xp(l,m,nph)+xp(l,m,kph))
      if(j.ne.lvz(lz1,nph)) go to 20
      do 21 m=1,lyr
      taut(nt)=taut(nt)-fac(m)*taup(j,m,nph)
 21   xt(nbrn,1)=xt(nbrn,1)-fac(m)*xp(j,m,nph)
      taut(nt)=taut(nt)+fac(1)*taul(lz1,nph)
      xt(nbrn,1)=xt(nbrn,1)+fac(1)*xl(lz1,nph)
      lz1=lz1+1
 20   if(j.ne.lvz(lz2,kph)) go to 22
      do 23 m=1,lyr
      taut(nt)=taut(nt)-fac(m)*taup(j,m,kph)
 23   xt(nbrn,1)=xt(nbrn,1)-fac(m)*xp(j,m,kph)
      taut(nt)=taut(nt)+fac(1)*taul(lz2,kph)
      xt(nbrn,1)=xt(nbrn,1)+fac(1)*xl(lz2,kph)
      lz2=lz2+1
 22   call pdect(jndx(nbrn,1),nl,j,iabs(isgn),xfc)
      call tauspl(jndx(nbrn,1),nl,pt,coef)
      jndx(nbrn,2)=nl
c

c changed BRL
      phcd1=code(ik,kph)(2:)
      if(code(in,nph)(3:3).eq.' ') phcd(nbrn)=code(in,nph)(2:2)//
     1 phcd1(1:7)
      if(code(in,nph)(3:3).ne.' '.and.code(in,nph)(3:3).ne.'K')
     1  phcd(nbrn)=code(in,nph)(2:3)//phcd1(1:6)
      phcd1=code(ik,kph)(5:)
      if(code(in,nph)(3:3).eq.'K') phcd(nbrn)=code(in,nph)(2:2)//''''//
     1 code(ik,kph)(2:2)//''''//phcd1(1:4)
      phcd1=phcd(nbrn)
      if(isgn.eq.1) phcd(nbrn)='p'//phcd1(1:7)
      if(isgn.eq.2) phcd(nbrn)='s'//phcd1(1:7)

      print *,'phcd:  in ik phcd =',in,ik,' ',phcd(nbrn)
      if(isw.le.1) go to 17
      ik=ik+1
      j=max0(j,l)
      go to 31
 17   j=max0(j,l)
      indx(nseg,2)=nl
      return
      end
c
      subroutine pdect(i1,i2,j1,nph,fac)
      save 
      include 'limits.inc'
      double precision pb,pu,taup,xp,taul,xl,px,xt,pt,taut,coef,xa
      double precision h1,h2,hh
      dimension ib(2,2)
      common/intc/pb(nsl1),pu(nsl1,2),taup(nsl1,3,2),xp(nsl1,3,2),
     1 taul(nlvz0,2),xl(nlvz0,2),xmin,kb(2),ku(2),lt(2),lvz(nlvz0,2),
     2 kuse(nsl1,2)
      common/brnb/px(jbrn,2),xt(jbrn,2),jndx(jbrn,2),mndx(jbrn,2),nbrn
      common/outc/pt(jout),taut(jout),coef(5,jout),xa(jout),nl
c
      xmn=fac*xmin
      isg=1
      do 1 i=1,2
      ib(i,1)=i1
 1    ib(i,2)=i2
      ii=i1+1
      ie=i2-1
      xa(i1)=xt(nbrn,1)
      do 2 i=ii,ie
      h1=pt(i-1)-pt(i)
      h2=pt(i+1)-pt(i)
      hh=h1*h2*(h1-h2)
      h1=h1*h1
      h2=-h2*h2
 2    xa(i)=-(h2*taut(i-1)-(h2+h1)*taut(i)+h1*taut(i+1))/hh
      xa(i2)=xt(nbrn,2)
      do 3 i=ii,ie
      if((xa(i+1)-xa(i))*(xa(i)-xa(i-1)).gt.0d0) go to 3
      isg=2
      ib(1,2)=i-2
      ib(2,1)=i+2
 3    continue
      do 4 it=1,isg
      write(10,*)'collct1',it,isg,ib(it,1),ib(it,2)
 4    call collct(ib(it,1),ib(it,2),xa,xmn)
      k=i1-1
      j=j1
      do 5 i=i1,i2
      if(xa(i).lt.0d0) go to 5
      k=k+1
      pt(k)=pt(i)
      taut(k)=taut(i)
      xa(k)=xa(i)
      kuse(j,nph)=1
 5    j=j+1
      if(k.eq.nl) return
      ii=k+1
      do 6 i=ii,nl
 6    taut(i)=0d0
      nl=k
      return
      end
c
      subroutine kseq
c
c   Kseq makes a correspondence between model slownesses in array pb and 
c   the subset of the same slownesses used for sampling tau which are 
c   stored in pu (separate sets for P and S).  The net result is to 
c   translate the kndx pointers to critical slowness values (bounding 
c   branches actually implemented) from pointing into pb to pointing 
c   into pu.
c   
c
      save 
      include 'limits.inc'
      double precision pb,pu,taup,xp,taul,xl
      dimension kl(2),kk(jseg,2,2)
      common/intc/pb(nsl1),pu(nsl1,2),taup(nsl1,3,2),xp(nsl1,3,2),
     1 taul(nlvz0,2),xl(nlvz0,2),xmin,kb(2),ku(2),lt(2),lvz(nlvz0,2),
     2 kuse(nsl1,2)
      common/segc/fcs(jseg,3),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),
     1 nseg
      data kl/0,0/
c
c   Compile a sorted list of unique kndx values in the first column of 
c   kk.
c
      do 1 i=1,nseg
      nph=iabs(nafl(i,1))
      k=kl(nph)
      do 2 j=1,2
      if(k.le.0) go to 3
      do 4 m=1,k
      if(kk(m,nph,1)-kndx(i,j))4,2,5
 4    continue
 3    k=k+1
      kk(k,nph,1)=kndx(i,j)
      go to 2
 5    do 6 l=k,m,-1
 6    kk(l+1,nph,1)=kk(l,nph,1)
      k=k+1
      kk(m,nph,1)=kndx(i,j)
 2    continue
 1    kl(nph)=k
c
c   Make the correspondence between pb and pu for each kndx and save it 
c   in the second column of kk.
c
      do 7 nph=1,2
      n1=ku(nph)
      k=1
      ki=kk(k,nph,1)
      do 8 i=1,n1
      if(pu(i,nph)-pb(ki))8,9,10
 9    kk(k,nph,2)=i
      if(k.ge.kl(nph)) go to 7
      k=k+1
      ki=kk(k,nph,1)
 8    continue
 10   write(*,100)ki,pb(ki),nph
 100  format(1x,'Kseq:  pb(',i3,') =',f7.4,' not found in pu(*,',i1,
     1 ').')
      call vexit(1)
 7    continue
c
c   Replace each kndx pb pointer with the corresponding pu pointer.
c
      do 11 i=1,nseg
      nph=iabs(nafl(i,1))
      k=kl(nph)
      do 11 j=1,2
      do 12 m=1,k
      if(kk(m,nph,1)-kndx(i,j))12,11,13
 12   continue
 13   write(*,101)kndx(i,j)
 101  format(1x,'Kseq:  kndx value',i4,' not translated.')
      call vexit(1)
 11   kndx(i,j)=kk(m,nph,2)
      return
      end
c
      subroutine mseq
c         partial reordering of tables
      save 
      include 'limits.inc'
      double precision pb,pu,taup,xp,taul,xl,px,xt,pux
      common/intc/pb(nsl1),pu(nsl1,2),taup(nsl1,3,2),xp(nsl1,3,2),
     1 taul(nlvz0,2),xl(nlvz0,2),xmin,kb(2),ku(2),lt(2),lvz(nlvz0,2),
     2 kuse(nsl1,2)
      common/segc/fcs(jseg,3),nafl(jseg,3),indx(jseg,2),kndx(jseg,2),
     1 nseg
      common/brnb/px(jbrn,2),xt(jbrn,2),jndx(jbrn,2),mndx(jbrn,2),nbrn
      common/msqc/pux(jbrn,2),km(2),midx(jbrn,2)
      data km/0,0/
c
      is=1
      do 1 i=1,nbrn
 8    if(jndx(i,2).le.indx(is,2)) go to 7
      is=is+1
      go to 8
 7    nph=iabs(nafl(is,1))
      k=km(nph)
      do 2 j=1,2
      if(k.le.0) go to 3
      do 4 m=1,k
      if(midx(m,nph)-mndx(i,j))4,2,5
 4    continue
 3    k=k+1
      midx(k,nph)=mndx(i,j)
      pux(k,nph)=px(i,j)
      go to 2
 5    do 6 l=k,m,-1
      midx(l+1,nph)=midx(l,nph)
 6    pux(l+1,nph)=pux(l,nph)
      k=k+1
      midx(m,nph)=mndx(i,j)
      pux(m,nph)=px(i,j)
 2    continue
 1    km(nph)=k
      return
      end

CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX       
C                                                                               
      SUBROUTINE REMOVE_DC(DATABUFF,NDC,DC,NSAMP)                               
C                                                                               
C     ROUTINE TO REMOVE DC                                                      
c
c  sep 98 by jh :      --------------   version 7.0 check ---------------
c                      no change
C                                                                               
C                                                                               
c--DATA FROM WHICH TO REMOVE DC              
      REAL        DATABUFF(*)        
c--NUMBER OF SAMPLES TO USE FOR              
      INTEGER     NDC                
c--DC CALCULATION,                           
                                     
c--NDC=0: NDC=NSAMP                          
                                     
c--DC LEVEL FOUND                            
      REAL        DC                 
c--TOTAL NUMBER OF SAMPLES IN DATABUFF       
      INTEGER     NSAMP              
C                                                                               
      IF(NDC.EQ.0)THEN                                                          
          NDC=NSAMP                                                             
      ENDIF                                                                     
      DC=0.0                                                                    
      DO 10 I=1,NDC                                                             
         DC=DC+DATABUFF(I)/NDC                                                  
 10   CONTINUE                                                                  
      DO 100 I=1,NSAMP                                                          
          DATABUFF(I)=DATABUFF(I)-DC                                            
 100  CONTINUE                                                                  
      RETURN                                                                    
      END                                                                       

c
c
c   read one or many segments from a seed file, mainly
c   intended to chop up a seed file in many smaller files
c   of equal size. smallest interval is one minute
c   there is no selection of channels or format, assumed 
c   that seed file contain what you want
c
c   the program calls rdseed
c
c   jh jan 2004
c

      implicit none
      integer year,month,day,hour,doy,min ! times
      integer del_min               ! length of extract
      integer number_intervals       ! number of intervals
      integer i,k
      character*80  seed_file        ! seed volume name
      character*80 text              ! general text


      write(6,*) 'Seed file name'
      read(5,'(a)') seed_file
      write(6,*) 'start time YYYY,MM,DD,HH,MM'
      read(5,*) year,month,day,hour,min
      write(6,*) 'Interval in minutes'
      read(5,*) del_min
      write(6,*) 'Number of intervals to extract'
      read(5,*) number_intervals
      call DATE_DOY (DOY,DAY,MONTH,YEAR)
c
c   start extract loop
c
      do i=1,number_intervals
c
c   write input file for rdseed
c
          open(1,file='rdseed.inp',status='unknown')
          write(1,'(a)') seed_file

          do k=1,2
              write(1,*)
          enddo
          write(1,'(a)')'d'       ! extract data command
          write(1,'(a)')
          do k=1,7
              write(1,*)
          enddo
c
c  time interval
c
          write(text,'(i4,a,i3,a,i2,a,i2)') year,',',doy,',',
     *    hour,':',min
          do k=1,14
            if(text(k:k).eq.' ') text(k:k)='0'
          enddo
          write(1,'(a)') text(1:14)
c         write(7,'(a)') text(1:14)
c
c  end of interval
c
c
c   add for next interval, is also end of interval
c
          min=min+del_min
          if(min.ge.60)then
 1           continue
             min=min-60     
             hour=hour+1
             if(min.ge.60) goto 1
             if(hour.ge.24) then
                 hour=hour-24
                 doy=doy+1
             endif
           endif
          write(text,'(i4,a,i3,a,i2,a,i2)') year,',',doy,',',
     *    hour,':',min
          do k=1,14
            if(text(k:k).eq.' ') text(k:k)='0'
          enddo
          write(1,'(a)') text(1:14)
c         write(7,'(a)') text(1:14)
 
          do k=1,2
             write(1,*)
          enddo
          write(1,*)'quit'
c
          close(1)
c
c   extract data
c
          call systemc('rdseed<rdseed.inp',17)
          
      enddo
c
      stop
      end
          
c
      

c$DEBUG
c                                                                               
c    transform iris ascii files to seisan  data files 
c                                                                               
c    j. havskov                    
c   jan 29        ************ version 5.0 *************************
c
c    latest update                                                              
c    jul 27, 95 by jh : better error trap
c    aug 21  96       : use v instead of l for file name
c    jan 2   98       : change SS to S for short period
c    jan 23           : implement respense file check
c    dec 16  98    lo : ask for filename, instead of usinf iris.log
c    dec 20  98    jh : ----------  version 7.0 check ---------------
c    feb 12  99    lo : new header format with 6 chars for channel
c    apr 19  00    lo : fix from before for India stations
c    may 11  00    lo : use read_resp_head
c
      implicit none
      include 'seidim.inc'
c                                                                               
c-- seisan  data file channel header      
      character*1040    chahead         
c-- -------------------main --------      
      character*80     mainhead(max_trace)        
c-- date and time
      integer year,month,day,hour,min,isec
      real sec
c-- filter delay
      double precision delay
c-- output file name                                  
      character*80	outfile		
c-- stations and components
      character*4 comp(max_trace),statt
      character*5 stat(max_trace)
      integer*4     data4(90000)
c-- one line of text
      character*80 text
c-- data interval each channel, start time
      real cinter(max_trace),cstart(max_trace)
c-- number of channels and samples/chan, total number of samples           
      integer nchan,nsamp
c-- sample rate                                              
      real		rate		
c-- help variables                                     
      integer		i,k,nline,in
c - - input file name
      character*80 infile
c true for new header
      logical new_header
c index
      integer dot_ind,start_ind
c-- -------------                                    
c
c   open iris ascii log file 
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver


       write(*,*) 'filename'
       read(*,'(a)') infile

       open(1,file=infile,status='old',err=88)
       goto 89
 88    continue
       write(6,*)' No file ',infile
       stop
 89    continue
c
c   read header of ascii file, first read forward to 
c   start of event, also enter here after read of one event
c   from asci file
c             
 2    continue
         read(1,'(a80)',end=99) text
c
c   look for line with station header, has a "/" and "SPS"
c
c old header
cKBS 1999/02/09 06:40:03 +0.428001   SEC    E   LP 1.00 SPS   UNFILTERED 6000
c new header
cONO.10-BHZ 1999/02/09 14:02:00 -0.003374   SEC 40.00 SPS   UNFILTERED 6000
c
         new_header = .false.
         dot_ind=-1
         start_ind=-1
         do i=1,80
            if (text(i:i).eq.'.'.and.dot_ind.eq.-1) then
               dot_ind=i
            endif
            if (text(i:i).ne.' '.and.start_ind.eq.-1) then
               start_ind=i
            endif
            if(text(i:i).eq.'/')  then
               do k=1,78
                  if(text(k:k+2).eq.'SPS') then
c
c check if old or new header
c
c                   if (text(5:5).eq.'.'.or.text(4:4).eq.'.')
                    if (dot_ind.le.11) then
                        new_header = .true.
                        write(*,*) ' new header '
                    endif

                    goto 50
                  endif
               enddo
            endif
         enddo
         goto 2   ! not a header line
 50      continue
c
c   fish out station, can be left or right justified, or be shifted
c          
         statt=text(start_ind:dot_ind-1)

         if (new_header) then
cONO.10-BHZ 1999/02/09 14:02:00 -0.003374   SEC 40.00 SPS   UNFILTERED 6000
c  BHPL.BHZ 2000/04/18 00:03:07 +0.010645   SEC 20.00 SPS   UNFILTERED 6000
cKBS 1999/02/09 06:40:03 +0.428001   SEC    E   LP 1.00 SPS   UNFILTERED 6000

            read(text,'(12x,i4,5(1x,i2),f7.4)')
     *      year,month,day,hour,min,isec,delay

            read(text(49:53),'(f5.2)') rate     
            if(rate.lt.10.0) then
               read(text(70:74),'(i5)') nsamp
            else
               read(text(71:75),'(i5)') nsamp
            endif
c
c component code could be 3 or 6 characters, otherwise add fix
c
            if (11-dot_ind.eq.6) then
              comp(1)(1:1)=text(9:9)
              comp(1)(2:3)=text(6:7)
              comp(1)(4:4)=text(11:11)
c            elseif (11-dot_ind.eq.3) then
c
c assume component is the last three chars
c
            else
              comp(1)(1:2)=text(9:10)
              comp(1)(3:3)=' '
              comp(1)(4:4)=text(11:11)
            endif


         else
c
c   get header info
c
            read(text,'(5x,i4,5(1x,i2),f7.4)')    ! changed delay from 7.3
     *      year,month,day,hour,min,isec,delay
c            write(6,*) 'sec,delay',isec,delay
            read(text(51:55),'(f6.2)') rate
            if(rate.lt.10.0) then
               read(text(73:77),'(i5)') nsamp
            else
               read(text(74:78),'(i5)') nsamp
            endif
            comp(1)(1:1)=text(49:49)
            comp(1)(2:2)=text(48:48)
            if(comp(1)(1:2).eq.'SS') comp(1)(1:2)='S ' ! use only S for SP
            comp(1)(3:3)=' '
            if(text(44:44).eq.' ') then
                comp(1)(4:4)=text(45:45)
            else
                comp(1)(4:4)=text(44:44)
            endif

          endif    
          write(6,*) 'Number of samples',nsamp
c
c   correct for filter delay
c
            sec=isec
            call timadd(year,month,day,hour,min,sec,delay,
     *                  year,month,day,hour,min,sec)
c            write(6,*) 'sec after delay added',sec

            stat(1)(1:4)=statt
            stat(1)(5:5)=' '
            cstart(1)=0.0
            cinter(1)=(nsamp-1)/rate
c
c  blank data array
c
            do i=1,nsamp
               data4(i)=0
            enddo
c
c   read one blank line
c
            read(1,'(a)')text
c
c   calculate number of lines to read, 8 samples pr line, the 9th
c   value is a checksum
c
            i=1
            nline=nsamp/8
            do in=1,nline
              read(1,'(a)',end=2222,err=2222) text
c             write(6,'(a)') text
              if(text(1:10).eq.'          ')goto 2222 
			  backspace 1
              read(1,*,end=2222,err=2222) (data4(k),k=i,i+8)
c             write(6,*)data4(i)
              i=i+8
            enddo
         goto 2223
 2222    continue
            write(6,*)' Data missing, return to continue'
            read(5,'(a)') text
 2223    continue
c                                                                               
c  make file name and main header
c             
         nchan=1
         call mfhead(year,month,day,hour,min,sec,cinter(1),nchan,
     *   stat(1),stat,comp,cstart,cinter,outfile,mainhead)
c
c   different components could be at the same time, add
c   component id to file name
c
         outfile(30:30)='_'
         outfile(31:34)=comp(1)
         do i=31,34
            if(outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo
         write(6,'(a,a)') ' Outfile name: ',outfile(1:34)
c
c  open file
c
         open(2,file=outfile,status='unknown',form='unformatted')
c                                                                               
c   write  main header                                       
c                                                                               
         write(6,'(a)') mainhead(1)(1:75)
         do i=1,12
            write(2) mainhead(i)                                         
         enddo
c                                                                               
c  write channel with channel header
c                                                                               
            do i=1,1040                                                         
               chahead(i:i)=' '                                                 
            enddo                                                               
c-- station code                          
            chahead(1:4)=statt		
c-- componnet
            chahead(6:9)=comp(1)	
c-- year, date and time                  
            chahead(10:35)=mainhead(1)(34:59)		
            write(chahead(37:43),'(f7.2)') rate                          
            write(chahead(45:50),'(i6)') nsamp                                  
c                                                                               
c   get response            
c                                                                               
             call read_resp_head(chahead)                                            

c
c   indicate 2 or 4 byte integer in header
c
             chahead(77:77)='4'
c                                                                               
c   write header                                                                
c                                                                               
            write(2)chahead                                                     
            write(6,'(1x,a70)') chahead(1:70)                                   
c  
c   write data
c
            write(2)(data4(i),i=1,nsamp)
            close(2)
c
c   back for next channel
c
            goto 2                                                                    
 99   continue                                                                  
      stop                                                                      
      end                                                                       

c     Program to read a NOrdic file and write out
c     the parameters in a Herrmann file ready for hspec8 modelling
c
c
c  may 99 by jh : --------------  version 7.0 check --------------------
c
c
      parameter (nnstat=32)
c--- stations to model
      character*5 stat(nnstat)
      real distance (nnstat)
c
      character*80 sfile,data(200),string
      character*1 TYPE,EXP
      character*4 comp
      real thick(20),vp(20),vs(20),dens(20),qp(20),qs(20)
c
c
      

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c      open(1,file='transfer.idx',status='old')
c      read(1,'(a)')sfile
c      close(1)
      k = 0

      open(1,file='hyp.out',status='old')
      call indata(1,NSTAT,NPHAS,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      do i = 1, nhead
        if(data(i)(80:80).eq.'3'.and.data(i)(2:6).eq.'SYNT:') then
          if(data(i)(8:15) .eq. 'MODEL--:' )then 
            if(data(i)(16:25) .ne. '     THICK')then
              k = k + 1
              read(data(i)(16:79),'(6f10.0)')thick(k),vp(k),vs(k),
     +                          dens(k),qp(k),qs(k)
              if(qp(k) .eq. 0. )qp(k) = 500.
              if(qs(k) .eq. 0. )qs(k) = 500.
              qp(k) = 1./qp(k)
              qs(k) = 1./qs(k)
            endif
          endif
          if(data(i)(8:15) .eq. 'DEPTH--:')then
            read(data(i)(16:79),'(f10.0)')depth
          endif
          if(data(i)(8:15) .eq. 'NPOINTS:')then
            read(data(i)(16:79),'(i10)')npoints
          endif
          if(data(i)(8:15) .eq. 'TIMES--:')then
            read(data(i)(16:79),'(3(10x,f10.1))')window,t0,time
          endif
          if(data(i)(8:15) .eq. 'REDVELO:')then
            read(data(i)(16:79),'(f10.3)')vred 
          endif
        endif
      enddo
c
c   find number of stations and stations to model
c
      nstat=0
      do i=1,nhead
         if(data(i)(80:80).eq.'3'.and.data(i)(2:15).eq.'SYNT: STATION:')
     *   then
            do istat=1,nstat
              if(stat(istat).eq.data(i)(17:21)) goto 80
            enddo
c
c   station was not counted before
c
            nstat=nstat+1
            stat(nstat)=data(i)(17:21)
 80         continue
         endif
      enddo
c
c   get station data
c
       do istat=1,nstat
         do i=1,nhead
            if(stat(istat)(1:5).eq.data(i)(17:21).and.
     *      data(i)(28:35).eq.'DISTANC:'.and.data(i)(80:80).eq.'3')
     *      then
               read(data(i)(36:45),'(f10.1)') distance(istat)
            endif
         enddo
      enddo
      close(1)
c
c VM  look for largest epicentral distance (used to calculate the spectrum)
c              smallest                    (for origin times)
      distmax=0.
      do istat=1,nstat
        distmax=amax1(distmax,distance(istat))
      enddo
      distmin=distmax
      do istat=1,nstat
        distmin=amin1(distmin,distance(istat))
      enddo

      dt = time/npoints
      write (*,*) time,dt,npoints
c
      dummy = 0.
      lmax = 0
      vpmin = 100.
      vsmin = 100.
      vpmax = 0.
      vsmax = 0.
      thick(k) = 0.
      do i = 1,k
        dummy = dummy + thick(i)
        if(depth .lt. dummy .and. lmax .eq. 0)then
          lmax = i
          dph = dummy - depth
        endif
        if(depth .eq. dummy)then
          write(*,*)' Focal depth on layer interface'
          write(*,*)' Change parameter file'
          stop
        endif
        if(vp(i) .gt. vpmax)vpmax = vp(i)
        if(vs(i) .gt. vsmax)vsmax = vs(i)
        if(vp(i) .lt. vpmin)vpmin = vp(i)
        if(vs(i) .lt. vsmin)vsmin = vs(i)
      enddo 
      hvert = dummy
      if(lmax .eq. 0)stop' Focal depth not possible with this model'
      alpha = 3./(npoints*dt)
      n1 = 1
      n2 = int((npoints/2) + 1.001)
      df = 1./(npoints*dt)
      nyq2 = npoints + 1
      xleng = 3*distmax 
      dummy = vpmax*time
      if(xleng .lt. dummy)xleng = dummy
      xfac = 1.5
      fl = 0.
      fu = 1./(dt*2.)
      mmax = k
c
c---- Now write hspec8 parameter file
c
      write(*,*)' Writing parameter file for hspec8'
      open(11,file='hspec8.inp',status='unknown')
      call system('\\rm response.ssp')
      write(11,'(a)')'response.ssp'
      write(11,'(a)')'new'
      write(11,'(a)')'   -1    0'
      write(11,'(5e15.7)')alpha,depth,fl,fu,dt
      write(11,'(3i10,e15.7,2i10)')npoints,n1,n2,df,nyq2,mmax
      j = 1
      jbdry = 0
      write(11,'(11i5)')j,j,j,j,j,j,j,j,j,j,jbdry
      do i = 1,k
        write(11,'(6e11.4)')thick(i),vp(i),vs(i),dens(i),qp(i),qs(i)
      enddo
      write(11,'(i10,6e11.4)')lmax,dph,vpmin,vpmax,vsmin,vsmax,hvert
      write(11,'(2e15.7)')xleng,xfac

      close(11)

      write(*,*)' The computation of earth respons will now start,'
      write(*,*)' The input parameter file is:  hspec8.inp'
      write(*,*)' A respons file  response.ssp  will be made'
      write(*,*)' You may wish to stop now and manually edit the'
      write(*,*)' input parameter file, or directly continue the'
      write(*,*)' calculation of the earth response.'
      write(*,*)' 1  ==> Stop now'
      write(*,*)' 2  ==> Continue with calculations'
      read(*,*) icont
      if(icont .eq. 1)stop
c
c---- Continue generating the response spectrum F(f,k)
c
      write(*,*)'*********************************'
      write(*,*)' hspec8 is now running....'
      write(*,*)' Input  file: hspec8.inp '
      write(*,*)' Output file: response.ssp'
      write(*,*)'*********************************'
      string='hspec8 < hspec8.inp'
      call system(string)
c
c--- Now start the integration along wavenumber to obtain F(f,r)
c
      do istat=1,nstat 
c
      if (vred.ne.0.)  then
        tshift = t0-distmin/vred
      else
        tshift = t0
      endif
      open(11,file='rhwvinta.inp',status='unknown')
      write(11,'(a)')'response.ssp'
      write(string(1:1),'(i1)') istat
      write(string(1:13),'(a)') 'rhwvinta.out'//string(1:1)
      write(11,'(a)')string(1:13)
      write(11,'(a)')'-1.0       -1.0       100.0      100.0'
      write(11,'(4f10.5)')distance(istat),tshift,vred
      write(11,'(a)')'    -1.0   0.0       0.0'
      close(11)
      write(*,*)'*********************************'
      write(*,*)' rhwvinta is now running....'
      write(*,*)' Input  file: rhwvinta.inp '
      write(*,*)' Output file: ',string(1:13)
      write(*,*)'*********************************'
      string(1:18)='\\rm '//string(1:13)
      call system(string(1:18))
      string = 'rhwvinta < rhwvinta.inp'
      call system(string)
c
      enddo
c
c
      write(*,*)'*********************************'
      write(*,*)' Finished'
      write(*,*)' Command to continue:      hersei'
      write(*,*)'*********************************'

      end


C########################################################################### 
   

c--------------------------------------------------------------------------
c  p_align.for
c  This program timeshift data from P-phase arrival time to the psudo time 
c  2070-11-27 12:00
c  Input is a nordic file (e.g. select.out) and a station name. 
c  Output is timeshifted waveform files and a file tsd.out with timeshifted 
c  phase readings and names of the new waveform files.
c
c  TODO: timeshift tsd.out back in time with new phase readings
c        read+write miniseed 
c
c  2008-06-19 pv : good luck
c  2008 06 25 jh : code to code1
c--------------------------------------------------------------------------c
 
      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common block input files
      include 'rea2.inc'                  ! parameter common block output file

      character*80 data(5000)             ! s-file with data in text array
      character*80 data2(5000)             ! s-file with data in text array
      character*80 infile                 ! input file
      character*80 wavfile                 ! input file
      character*80 wavfile_old_stat
      character*80 outfile
      character*80 text      ! general text string
      character*5 old_stat, new_stat      ! station code for input and output station
      character*5 stat(max_trace)  ! staions in header
      character*4 comp(max_trace)  ! components in header
      character*80 mainhead(max_trace)
      character*1040 chahead
      character*12 time1                      ! time strings
      character*14 time2

      real cinter(max_trace),cstart(max_trace) ! start and interval each trace

      logical shift_pphase
      logical all                         ! true: read all data, false: headers
      logical verbose
      logical wav_found
      logical data_found
      logical phase_found
      integer code1                       ! error return code
      integer nevent                      ! number of events in file
      integer i,j,k                       ! counter
      integer khead           ! number of main headers
      integer pindex                      ! the rea_phase number where P-phase is found
      integer nchan
      integer nstat
      integer nsamp
      integer nnewchan
      integer*4 data4i(max_sample) ! samples
      integer*2 data2i(2*max_sample)   ! samples

c--- time and dates
      integer year,month,day,hour,min,year1,month1,day1,hour1,min1
      integer doy,doy1
      real sec, sec1
      double precision msec

      double precision shift_time
      double precision dummy

c
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code,                  ! Error encoder.
     &          sei real num               ! Get real number
       integer  seiclen
C
       integer
     &          read02,                    ! Ditto 2.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       real sei real num                   ! Real number
C
C    ============= end of list ==========
      real x(max_sample)
      common /signalx/x

       verbose=.TRUE.
c
c   open output file

       open(3,file='tsd.out',status='unknown')
    
c
c   get input file name, check if exist
c

 9    continue
      write(6,*) 'Give input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old',err=10)
      goto 11
 10    continue
      write(6,*)' No such input file'
      goto 9
 11   continue
c
      all=.true.                  ! read all parameters
      shift_pphase=.true.   
      nevent=0                    ! initialize counter
      rea2_ncomment=0
      rea2_nwav=0
      rea2_nphase=0
      rea2_nfault=0
      rea2_nmacro=0
      rea2_nspec=0
      rea2_av_moment=0.0
      rea2_av_omega0=0.0

      old_stat="     "
      new_stat="     "
      write(6,*) 'Enter station code to be time shifted:'
      read(5,'(a)') old_stat
c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c

  50  continue
c
c   read all parameters for one event form file unit 1
c
      call rea_event_in(1,all,data,code1)
c
c   check if end of file (code=1), if so jump out of loop
c
      if(code1.eq.1) goto 1000
c
      nevent=nevent+1               ! count events
c     
c----------------------------------------------------
      new_stat(1:3)=old_stat(1:3)
      if(nevent.le.9) then
        new_stat(4:4)="0"
        new_stat(5:5)=char(nevent+48)
c       new_stat(5:5)=char(nevent+65)
      elseif(nevent.ge.10) then
        i=int(nevent/10.)
        new_stat(4:4)=char(i+48)
        new_stat(5:5)=char(nevent-i*10+48)
c       new_stat(4:4)=char(i+65)
c       new_stat(5:5)=char(nevent-i+65)
c     elseif(nevent.ge.100)stop
      endif
      if(verbose) write(6,*) "Event #",nevent,
     &" time shifting station : ",old_stat

c----------------------------------------------------
c  look for P-phase in s-file
      pindex=-1
      phase_found=.FALSE.
      do i=1,rea_nphase
        if(rea_stat(i).eq.old_stat)then
          if(rea_phase(i)(1:1).eq.'P') then
c           If more than one P (Pn,Pg) select the first:
            if(.not.phase_found) pindex=i
            phase_found=.TRUE.
          endif
        endif
      enddo
c
c----------------------------------------------------
c
c time shift with respect to p-phase time
c
      if(shift_pphase)then
        if(pindex.eq.-1)then
          write(6,*)" NO P-PHASE FROM STATION ",old_stat,
     &" IN S-FILE - STOP !!"
          write(6,*)" Add p-phase with weight 4 and try again."
          stop
        else
        call timsec(2070,11,27,12,00,0.0,dummy)
        call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     *rea_hour(pindex),rea_min(pindex),rea_sec(pindex),msec)
c       write(6,*),hyp_year(1)
c       write(6,*),hyp_month(1)
c       write(6,*),hyp_day(1)
c       write(6,*),rea_hour(pindex)
c       write(6,*),rea_min(pindex)
c       write(6,*),rea_sec(pindex)
        shift_time=dummy-msec
        endif
      endif
c
c----------------------------------------------------
c
c  Add phases from old_stat to new s-file
c
      do i=1,rea_nphase
        if(rea_stat(i).eq.old_stat)then
          call timadd(hyp_year(1),hyp_month(1),hyp_day(1),
     *     rea_hour(i),rea_min(i),rea_sec(i),shift_time,
     *     year1,month1,day1,hour1,min1,sec1)  ! add correction
          rea2_nphase=rea2_nphase+1
c         rea2_stat(rea2_nphase)=rea_stat(i)(1:5)
          rea2_stat(rea2_nphase)=new_stat(1:5)
          rea2_comp(rea2_nphase)=rea_comp(i)(1:4)
          rea2_co(rea2_nphase)=rea_co(i)(1:2)
          rea2_phase(rea2_nphase)=rea_phase(i)(1:8)
          rea2_onset(rea2_nphase)=rea_onset(i)(1:1)
          rea2_weight_in(rea2_nphase)=rea_weight_in(i)(1:1)
          rea2_weight_out(rea2_nphase)=rea_weight_out(i)(1:2)
          rea2_polarity(rea2_nphase)=rea_polarity(i)(1:1)
          rea2_year(rea2_nphase)=rea_year(i)
          rea2_month(rea2_nphase)=rea_month(i)
          rea2_day(rea2_nphase)=rea_day(i)
c         rea2_hour(rea2_nphase)=rea_hour(i)
          rea2_hour(rea2_nphase)=hour1
c         rea2_min(rea2_nphase)=rea_min(i)
          rea2_min(rea2_nphase)=min1
c         rea2_sec(rea2_nphase)=rea_sec(i)
          rea2_sec(rea2_nphase)=sec1
          rea2_abs_time(rea2_nphase)=rea_abs_time(i)
          rea2_coda(rea2_nphase)=rea_coda(i)
          rea2_amp(rea2_nphase)=rea_amp(i)
          rea2_per(rea2_nphase)=rea_per(i)
          rea2_baz_obs(rea2_nphase)=rea_baz_obs(i)
          rea2_baz_cal(rea2_nphase)=rea_baz_cal(i)
          rea2_vel(rea2_nphase)=rea_vel(i)
          rea2_sn(rea2_nphase)=rea_sn(i)
          rea2_baz_res(rea2_nphase)=rea_baz_res(i)
          rea2_res(rea2_nphase)=rea_res(i)
          rea2_dist(rea2_nphase)=rea_dist(i)
          rea2_az(rea2_nphase)=rea_az(i)
          rea2_auto(rea2_nphase)=rea_auto(i)(1:20)
        else
            rea_phase(i)(1:6)='DELETE'
        endif
      enddo

c----------------------------------------------------
c
      rea2_ncomment=rea2_ncomment+1
      rea2_comment(rea2_ncomment)(1:40)=
     *' TSD:                                   '
      rea2_comment(rea2_ncomment)(41:80)=
     *'                                       3'
c     rea2_comment(rea2_ncomment)(1:79)=data(1)(1:79)
      rea2_comment(rea2_ncomment)(6:70)=data(1)(1:65)
      rea2_comment(rea2_ncomment)(64:64)=' '
      rea2_comment(rea2_ncomment)(65:69)=old_stat(1:5)
      rea2_comment(rea2_ncomment)(70:79)='          '

      rea2_ncomment=rea2_ncomment+1
      rea2_comment(rea2_ncomment)(1:40)=
     *' TSD:                                   '
      rea2_comment(rea2_ncomment)(41:80)=
     *'                                       3'
      rea2_comment(rea2_ncomment)(7:11)=old_stat(1:5)
      rea2_comment(rea2_ncomment)(13:17)=new_stat(1:5)
      write(rea2_comment(rea2_ncomment)(20:34),'(f15.4)')shift_time


c----------------------------------------------------
      rea2_nhyp=1
c     rea2_nhead=1
      hyp2_year(1)=2070
      hyp2_month(1)=11
      hyp2_day(1)=27
      hyp2_hour(1)=12
      hyp2_min(1)=0
      hyp2_sec(1)=0.0
      hyp2_model(1)=" "
      hyp2_dist_id(1)=hyp_dist_id(1)
      hyp2_type(1)=hyp_type(1)
      hyp2_fix_org(1)=hyp_fix_org(1)
      hyp2_lat(1)=hyp_lat(1)
      hyp2_lat(1)=-999.0
      hyp2_lon(1)=hyp_lon(1)
      hyp2_lon(1)=-999.0
      hyp2_depth(1)=hyp_depth(1)
      hyp2_depth(1)=-1.0
      hyp2_depth_flag(1)=hyp_depth_flag(1)
      hyp2_epi_flag(1)=hyp_epi_flag(1)
      hyp2_agency(1)=old_stat(1:3)
      hyp2_nstat(1)=0
      hyp2_rms(1)=-1.0
      hyp2_high_accuracy(1)=.FALSE.
      hyp2_error(1)=.FALSE.
c
      do i=1,6
        hyp2_mag_type(i,1)=hyp_mag_type(i,1)
        hyp2_mag_agency(i,1)=hyp_mag_agency(i,1)
      enddo
      hyp2_mag(1,1)=-1000.
      hyp2_mag(2,1)=-1000.
      hyp2_mag(3,1)=-1000.
      hyp2_mag(4,1)=-1000.
      hyp2_mag(5,1)=-1000.
      hyp2_mag(6,1)=-1000.
c     (1)=(1)
c     (1)=(1)
c     data2(1)(1:80)=data(1)(1:80)
c     rea2_id_line(1:80)=rea_id_line(1:80)
      call systime(time1,time2)
      rea2_id_line=' ACTION:TSD '//time2//' OP:     '//
     &       'STATUS:               ID:20701127120000     I'
c----------------------------------------------------

c   write on screen a bit info on event, number of headers and
c   total number of records
c
c     write(6,*)' Number of headers and number of records',
c    *rea_nhead,rea_nrecord

c
c   write the whole first header line
c
      write(6,'(a)') data(1)(1:79)
c----------------------------------------------------
c check wav files:
      wavfile_old_stat=' '
      do j=1,rea_nwav
              wavfile(1:78)=rea_wav(j)(2:79)
c
c  check if file exists
c
              call  get_full_wav_name(wavfile,text)
              if(text.eq.' ') then
                 write(6,'(a,a)')
     *           ' File does not exist : ',wavfile(:seiclen(wavfile))
                 wav_found=.FALSE.
              else
c                write(6,'(a,a)')
c    *           ' Full path name      : ', text(:seiclen(text))
                 wavfile=text(:seiclen(text))
                 wav_found=.TRUE.
              endif

c
c check if wavfile has been procesed before
c
      if(wav_found)then
        if(wavfile(:seiclen(wavfile)).eq.
     *wavfile_old_stat(:seiclen(wavfile))) wav_found=.FALSE.
      endif

c if wav file is found check file for old_stat data 
c
      if(wav_found)then
        wavfile_old_stat(:seiclen(wavfile))=wavfile(:seiclen(wavfile))
      
          chr_f_access$='direct'
          f_recl$=2048
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   wavfile,          ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
      if(verbose)write(6,'(a,a)') ' Reading file name   : ',
     *wavfile(1:45)
       call seisinc                                                             
     *(read02,0,nchan,0,mainhead,chahead,0.0,0.0)

c
c   read header channel names, might be needed
c
      nstat=1
      do i=3,(nchan-1)/3+3
            read(mainhead(i),'(3(1x,2a4,a1,f7.2,1x,f8.2))')
     *      stat(nstat)(1:4),  comp(nstat),  stat(nstat)(5:5),  
     *      cstart(nstat),cinter(nstat),
     *      stat(nstat+1)(1:4),comp(nstat+1),stat(nstat+1)(5:5),
     *      cstart(nstat+1),cinter(nstat+1),     
     *      stat(nstat+2)(1:4),comp(nstat+2),stat(nstat+2)(5:5),
     *      cstart(nstat+2),cinter(nstat+2)      
            nstat=nstat+3                                
      enddo
c
c Check if Station is in wavform file otherwise goto next file
c
c     skip_wav_file=.TRUE.
      data_found=.FALSE.
      nnewchan=0
      do i=1,nchan
        if(stat(i)(1:5).eq.old_stat(1:5))then
          data_found=.TRUE.
          nnewchan=nnewchan+1
        endif
      enddo

      if(data_found)
     *    write(6,*)"Found wavefrom data - ",
     *old_stat," is renamed to : ",new_stat
c
c     write(6,'(a)') 'mainhead : ',mainhead(1:12)(1:80)
c     write(6,'(a11,1x,5i)') 'nstat    : ',nstat
c     write(6,'(a11,1x,5i)') 'nchan    : ',nchan

      if(data_found) then
        call newheader(mainhead,nnewchan,shift_time,old_stat,new_stat)
        call newfilename(text,mainhead(1)(1:80),new_stat,nnewchan)

        outfile=text(:seiclen(text))
      rea2_nwav=rea2_nwav+1
      rea2_wav(rea2_nwav)='                                        '
     &//'                                       6'
      write(rea2_wav(rea2_nwav)(2:1+seiclen(outfile)),'(a)')
     &outfile(1:seiclen(outfile))
        open(2,file=outfile,status='unknown',form='unformatted')
          if(verbose)
     *    write(6,'(a,a)')" Output file name    : ",
     *    outfile(1:seiclen(outfile))
c
c   write main header
c
         khead=(nchan-1)/3+3
         if(khead.lt.12) khead=12    ! never less than 12 main headers
         do i=1,khead
            write(2) mainhead(i)
c           write(6,*) mainhead(i)
         enddo
c
c   read each channel, fix time, channel names and rewrite
c
         do i=1,nchan            ! fix headers in all channels
c           write(6,*) i
            call seisinc
     *      (read02,i,nchan,2,mainhead,chahead,0.0,0.0)
         if(chahead(1:5).eq.old_stat) then
            read (chahead(10:35),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *      k,doy,month,day,hour,min,sec
            year=k+1900
            call timadd(year,month,day,hour,min,sec,shift_time,
     *             year1,month1,day1,hour1,min1,sec1)  ! add correction
            call date_doy(doy1,day1,month1,year1)
            k=year1-1900
            write (chahead(1:5),'(a5)')new_stat(1:5)
            write (chahead(10:35),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *      k,doy1,month1,day1,hour1,min1,sec1
c
            read(chahead(44:50),'(i8)') nsamp
c
            write(2) chahead   ! write header
            if(chahead(77:77).eq.'4') then
               do k=1,nsamp
                  data4i(k)=x(k)
               enddo
               write(2)(data4i(k),k=1,nsamp)
            else
               do k=1,nsamp
                  data2i(k)=x(k)
               enddo
               write(2)(data2i(k),k=1,nsamp)
            endif
         endif
      enddo                 ! do i=1,nchan
         close(2)



      endif

      call sei close(close$,read02,code1)
      endif                 ! if(wav_found)then
      enddo                 ! do j=1,rea_nwav
      goto 50
c
 1000 continue
c
c
c     do i=1,rea2_nphase
c       write(6,'(i2,1x,a5,1x,a2,1x,2i2,f6.1,1x,a8,1x,
c    *1x,i4,1x,i2,1x,i2,1x,f15.3,1x)')
c    *      i,rea2_stat(i),rea2_co(i),rea2_hour(i),
c    *        rea2_min(i),rea2_sec(i),rea2_phase(i),
c    *        rea2_year(i),
c    *        rea2_month(i),
c    *        rea2_day(i),
c    *        rea2_abs_time(i)
c     enddo
c999  FORMAT(i2,1x,a5,1x,a2,1x,2i2,f6.1,1x,a8,1x,
c    *1x,i4,1x,i2,1x,i2,1x,f15.3,1x)
      write(6,*)            ! blank line
      write(6,*) 'Number of new phasereadings ', rea2_nphase
      write(6,*) 'Number of events in input file', nevent
      write(6,*) 'Output file name is tsd.out'
      write(6,*)            ! blank line

      call rea2_event_out(3,all,data2,code1)
      close(3)              ! close output s-file
c
      stop
      end


c       call newheader(mainhead(1)(1:80),nnewchan,shift_time)
      subroutine newheader(mainhead,nc,st,oldstat,newstat)
      include 'seidim.inc'                ! dimensions for rea block
      character*80 mainhead(max_trace)
      character*5 newstat, oldstat
      integer nchan
      integer nstat
      integer nc
      integer year,month,day,hour,min,year1,month1,day1,hour1,min1
      integer doy,doy1,k,i,j,l
      character*5 stat(max_trace)  ! staions in header
      character*4 comp(max_trace)  ! components in header      
      real cinter(max_trace),cstart(max_trace) ! start and interval each trace
      real sec, sec1
      double precision st

      write (mainhead(1)(2:19),'(a5,a13)')oldstat," time shifted"
      read (mainhead(1)(31:33),'(i3)')nchan
      write (mainhead(1)(31:33),'(i3)')nc
      read (mainhead(1)(34:59),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *year,doy,month,day,hour,min,sec
      year=year+1900       
      call timadd(year,month,day,hour,min,sec,st,
     *year1,month1,day1,hour1,min1,sec1)  ! add correction
      call date_doy(doy1,day1,month1,year1)
      k=year1-1900
      write (mainhead(1)(34:59),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *k,doy1,month1,day1,hour1,min1,sec1
c
c   read header channel names, might be needed
c
      nstat=1
      do i=3,(nchan-1)/3+3
            read(mainhead(i),'(3(1x,2a4,a1,f7.2,1x,f8.2))')
     *      stat(nstat)(1:4),  comp(nstat),  stat(nstat)(5:5),  
     *      cstart(nstat),cinter(nstat),
     *      stat(nstat+1)(1:4),comp(nstat+1),stat(nstat+1)(5:5),
     *      cstart(nstat+1),cinter(nstat+1),     
     *      stat(nstat+2)(1:4),comp(nstat+2),stat(nstat+2)(5:5),
     *      cstart(nstat+2),cinter(nstat+2)      
            nstat=nstat+3                                
      enddo
      j=1
      do i=1,nstat
        if(stat(i)(1:5).eq.oldstat)then
          stat(j)(1:5)=newstat(1:5)
          comp(j)(1:4)=comp(i)(1:4)
          cstart(j)=cstart(i)
          cinter(j)=cinter(i)
          j=j+1
        endif
      enddo
c
c   make new channel header, clear first
c
      khead=(nchan-1)/3+3
      if(khead.lt.12) khead=12    ! never less than 12 main headers
      do i=3,khead
         do j=1,80
            mainhead(i)(j:j)=' '
         enddo
      enddo
      j=1
      do i=3,(nchan-1)/3+3
        l=2
        do k=1,3
           if(j.le.nc)then
              write(mainhead(i)(l:l+24),'(2a4,a1,f7.2,1x,f8.2)')
     *        stat(j)(1:4),comp(j),stat(j)(5:5),cstart(j),cinter(j)
           endif
           j=j+1
           l=l+26
        enddo
      enddo

      return
      end
 

c       call newfilename(text,mainhead(1)(1:80),new_stat,nnewchan)
      subroutine newfilename(outfile,mainhead,new_stat,nc)
      character*80 mainhead,outfile
      character*5 new_stat
      integer nc
c  make output file name 
c             
      outfile=' '
         
c-- year                          
         outfile(3:4)=mainhead(35:36)
         outfile(1:2)='19'
         if(mainhead(34:34).eq.'1') outfile(1:2)='20'
         outfile(5:5)='-'               
c-- month                                    
         outfile(6:7)=mainhead(42:43)
         outfile(8:8)='-'
c-- day                                      
         outfile(9:10)=mainhead(45:46)
         outfile(11:11)='-'
c-- hr                                       
         outfile(12:13)=mainhead(48:49)
c-- min                                    
         outfile(14:15)=mainhead(51:52)
         outfile(16:16)='-'
c-- sec                                    
         outfile(17:18)=mainhead(54:55)
         outfile(19:20)='S.'
c
         outfile(21:25)=new_stat(1:5)

      write(6,*)"Number fo channels  : ",nc
      if(nc.le.9) then
        outfile(28:28)="0"
        outfile(29:29)=char(nc+48)
      elseif(nc.ge.10) then
        i=int(nc/10.)
        outfile(28:28)=char(i+48)
        outfile(29:29)=char(nc-i*10+48)
c     elseif(nevent.ge.100)stop
      endif

         do i=1,18
            if(outfile(i:i).eq.' ') outfile(i:i)='0'                            
         enddo                                                                  
         do i=19,26
            if(outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo
         do i=27,29
            if(outfile(i:i).eq.' ') outfile(i:i)='0'
         enddo

      return
      end

c$debug
cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
c                 HYPOLOC version 4.0 6/98
c
c         Locates an earthquake from a set of phase data 
c         using adaptively damped least-squares.
c
c         Uses calls to function 'rmsv' which evaluates
c         the rms, travel times and derivatives at any point. 
c         rmsv is also used by subroutine 'startloc', to find the
c         best starting location.
c
c
c         Author:           Barry R. Lienert
c                           Hawaii Institute of Geophysics,
c                           University of Hawaii at Manoa,
c                           2525 Correa Rd., Honolulu HI 96822
c
c Changes:
c
c  May 27, 92  BRL  :
c         Now use Bratt's routine, distaz, instead of delaz.
c         delaz was calculating delta using local radius
c         whereas I want it on the geocentric sphere (R=6378km)
c         Fixed test (56) logic to disable starting location
c         test(57) no longer used for this
c
c  Jun 9, 1992, BRL:
c         Added fixepi to parameter list in window
c         Startloc was still being called when fixepi='S'
c
c  Nov, 1992, BRL
c         If no convergence, try with alternate epicenter
c
c  Oct, 1993, BRL
c         Put travel time calculation in subroutine trtime
c         Used this subroutine to initially test arrivals for
c         bad times (e.g., 1 hour off) by comparing arrival
c         time differences between station pairs with travel
c         times between them.
c         Added PARAMETER statement for dimensions
c         Added check for Moho specification
c         added fixdep  to input window
c         changed depth origin to sea level if test(40)=0.0
c
c 10/93   added fixdep, data, parm & isort to window  
c
c 4/94    put common/comm1 in 'comm1.inc' 
c         added nconrad, added origin time fix if fixor='F'
c may 19 1994 by jh: put in icd=6 and return in all non locatable cases
c sep 94  BRL moved consistency test into subroutine ttcheck
c oct 94  BRL added oterr (origin time error) and nzcount to window
CJAB(BGS)Jan95 : Installed error encoding...
c feb 95  BRL added ires & fixor to rmsv window
C sep 97  mario azimuth changees
c nov 27 97 by jh : count correctly # of stations if not in order
c Jan 98  mv:   now calculates correctly the azimuth from event
c            to station and a new additional variable baz0(narriv)
c            is used to calculate the backazimuth.--->call hypoloc(...
c Jun 98  brl: incorporated changes from my version (spher. harm. sta. corrs, etc)
c              Added section to locate using single stat. azimuth & appar. vel.
C              Added appar_veloc(narriv) to window
c sep 98 jh  : ---------- seisan verison 7.0 changes ----------------------
c              year 2000, 5 char station names
c
c oct 28 1998 bmt: linux changed, save option and (* vs 1) include
c nov 179  99 jh : remove v,vs,d,nl and parm form windows, in common block
c dec 10      jh : fix year 2000 printout
c jan-feb 2000   : fix for multiple models etc
c may 2008    bl : fix problem with error calculation

cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
      subroutine hypoloc(nphase,st,maxelv,phase,tp,dtwt,ip,x0,y0,
     &iselv,dl,ires,xnear,xfar,xh0,tph0,nmoho,nconrad,test,
     &iulst,xh1,tph,std1,dtwt1,tpc,im,dt,dlt,az0,aninc,ips,rms1,
     &xk1,ndata,icd,fixepi,fixdep,fixor,dtw1,distind,trphs,vapp,azapp,
     &alatm,alonm,data,isort,di,oterr,nzcount,baz0,scorr,
     &appar_veloc)
c
cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
c                          INPUTS
c  Variable  Type
c
c  nphase    integer        Number of phases counted separately 
c                            (e.g., p, s & azimuth are each 1 phase)
c  st(i)     character*5    Station IDs
c  maxelv    integer        maximum elevation of ALL stations (not just
c                            the ones in the phase array). Needed
c                            because the velocity model is referenced to this.
c  phase(i)  character*8    Phase identifiers (e.g., PN, SG, etc)
c  tp(i)     SP real        Arrival times measured in seconds from 1/1/1900
c  dtwt(i)   SP real        Input phase weights
c  ip(i)     integer        Integer HYPO71 style weights: set P phase ip(i) 
c                            to 9 to force  S-P, L-S differences for 
c                            subsequent phases at this station.
c  x0(i)     SP real        Station longitudes in geocentric radians
c  y0(i)     SP real          "     latitudes       "
c  iselv(i)   integer          "     elevations in meters for each phase
c  dl(i)     SP real        Station corrections in seconds  "        "
c   i=1..nphase              NOTE: station data must be matched to each phase, 
c                            i.e., each phase  needs its own station info.
c
c  ires      integer     Hypocenter fixing index:
c                             1    -    Fix depth to xh0(3)
c                             2    -    Fix origin time to tph0
c                             7    -    Fix hypocenter at xh0
c                             8    -    Fix epicenter at xh0(1),xh0(2)
c                             9    -    Fix hypocenter and origin time
c
c  xnear     SP real      Distance in km from epicenter where distance
c                         weighting is 1
c  xfar      SP real      Distance in km from epicenter beyond which
c                         distance weighting is 0
c  xh0(j)    SP real      Starting hypocenter (long., lat., depth)
c  j=1,2,3
c  tph0      DP real      Starting origin time in seconds from 1/1/1900
c  nl        integer      Number of layers in velocity model
c  v(k)      SP real      P velocities in km/sec
c  vs(k)     SP real      S velocities     "
c  d(k)      SP real      depths to layer boundaries in km
c  k=1..nl 
c                          (e.g., d(1) is depth to bottom of 1st layer)
c  nmoho     integer      Layer number having moho velocity
c  nconrad   integer       "             "    Pb     "
c
c  test(l)   SP real      parameters controlling weighting, damping,
c  l=1..ntest
c                          convergence, etc. See subroutine "settest"
c                          for definitions of these.
c  iulst                  Listing unit# - if < 0, no listing
c  fixepi    character*1  fix epicenter at xh0(1),xh0(2) if ='F',
c                         use as start location if ='S' 
c  fixdep    character*1  fix depth "             "                   
c  fixor     character*1  fix origin time
c
c****************************************************************************
c
c                          OUTPUTS
c
c  xh1(j)    SP real      Final hypocenter solution in geocentric radians
c                         (j=1,2,3:long., lat., depth)
c  tph       DP real      Origin time in seconds from 1/1/1900
c  std1(j)   SP real      Final solution standard deviations in km
c  dtwt1(i)  SP real      Final residual weights 
c  dtw1(i)   SP real      Residual weights determined by trtime 
c                         (include distance weighting, residual 
c                         weighting, etc). Set to -1 if no valid travel time.
c  tpc(i)    SP real      Calculated travel times in seconds for solution
c  im        integer      Index of first arrival
c  dt(i)     SP real      arrival time residuals in seconds (i=1,nphase)
c                         for final solution (unweighted)
c  dlt(i)    SP real      Distances of final epicenter from station in km
c  az0(i)    SP real      Azimuths from earthquake to station (measured
c                          clockwise from North in degrees)
c  aninc(i)  SP real      Angles of incidence of rays leaving earthqake
c                          measured up from the (downward) vertical,
c                         i.e., a refraction is < 90, a direct is > 90 deg  
c  ips(i)    integer      1 for S-P or L-P  difference, 0 otherwise
c  trphs(i)  character*8  phase used for travel time calculation
c  rms1      SP real      Weighted root mean square residual in seconds
c  xk1       SP real      Last value of damping used for solution
c  ndata     integer      Number of phases used in final solution
c  icd       integer      Convergence of solution:    
c                          2    # increases in damping > test(37)
c                          3    hypocentral change < test(32)
c                          5    test(11) iterations reached
c                          6    less than 3 valid phases (no solution)
c                          7    more than 20 attempts to make depth<0
c                               or to exceed the parameter change limit
c******************************************************************************
       save
       include 'hypparm.inc'
c      include 'comm1.inc'
c      include 'param.inc'
c
      include 'libsei.inc'                    ! Library definitons.
      external sei code                       ! Error encoder.
      integer  code,                          ! Condition.
     &         iulst                          ! Output diagnostics.
      logical  b_flag                         ! Flag it?.
      logical tst                             ! for station test
c


      double precision tsmin,tphh,tph1,tph2,tph3
      character*5 statchk
      character*4 dr1,dr2,thrmin
      character*1 prm2,ins1,iew1,ucase,fd,fo,fixepi,
     &fixdep
c
c    Initialise...
c    =============
c   
      code = e_ok$                               ! Initialise condition.
c
      pi=3.141593
      degtorad=pi/180.
      rearth=6371.                         

c save starting depth, lon and lat
      startdep=xh0(3)

c removed 4/92: starting depth is always relative to assumed origin, 
c i.e., sea level if test(40)=0 or maxelv if test(40)>0
c      if(test(40).eq.0.0)startdep=xh0(3)+float(maxelv)*.001
      startlon=xh0(1)
      startlat=xh0(2)
c      write(iulst,*,iostat=code)startlon/degtorad,startlat/degtorad
      call sei code( fort$, code, iulst, b_flag ) ! Process outcome.

c 10/93: added minflag as test parameter
      minflag=int(test(63))      
      
c 4/94: added new parameter depthlim which is limited to moho and conrad
c       depths for layered model (returned by rmsv & trtime)

      depthlim=test(70)

c-----------------------------------------------------------------
c change 10/93: check for non-locatable cases
c 4/94: disable for fixed hypocenter
      if(ires.lt.7)then
       naz=0
       nvp=0
       nappv=0  !added 6/98            

c find # diff stats: added 6/98
       ndiffstat=0
       statchk='     '
       do i=1,nphase
        if(st(i).ne.statchk.and.dtwt(i).gt.0.0)then
         statchk=st(i)
         ndiffstat=ndiffstat+1
        endif
       enddo  

       statchk='     '
c
c   count no of azimuths naz and other phases nvp
c
       do i=1,nphase
c         call distaz(y0(i)/degtorad,x0(i)/degtorad,
c     &   xh0(2)/degtorad,xh0(1)/degtorad,dedeg,azz,azb)
c         dlt(i)=dedeg*degtorad*rearth
c         write(iulst,*,iostat=code)st(i),dlt(i)
         call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
c change 10/94: added statchk test to make sure azimuths are from different stations
         if(phase(i)(1:2).eq.'AZ'.and.dtwt(i).gt.0.0.and.st(i).ne.
     &    statchk)then
           statchk=st(i)
           naz=naz+1       
           if(appar_veloc(i).gt.0.0)nappv=nappv+1
         elseif(dtwt(i).gt.0.0)then
           nvp=nvp+1
         endif
       end do
c       write(6,*)'nz,nv',naz,nvp
c   
c   case of 2 phases-no azimuthts, or , one phase and one azimuth
c
       if((nvp.eq.2.and.naz.eq.0).or.((nappv.eq.0.or.distind.ne.'D')
     &  .and.nvp.eq.1.and.naz.le.1))then
         if(iulst.gt.0.and.(.not.multi_model))then
           if(dataprev.ne.data(1))then
c             write(iulst,*,iostat=code)data(1)(1:78)
              call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
           endif
           write(iulst,*,iostat=code)
     &     ' less than 2 phases and no azimuths:',
     &     ' not locatable'
           call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
           write(*,*)' less than 2 phases and no azimuths:',
     &     ' not locatable'
           icd=6
           return
         endif
         if(dataprev.ne.data(1))then
c           write(*,*)data(1)(1:78)
           dataprev=data(1)
         endif
         write(*,*)'less than 2 phases and no azimuths:',
     &   ' not locatable'
         icd=6
         return
       endif
c
c   case of one azimuth and one phase and no apparent velocities
c
       if(nvp.lt.2.and.naz.eq.1.and.(nappv.eq.0.or.distind.ne.'D'))then
         if(iulst.gt.0)then
           if(dataprev.ne.data(1))then
c             write(iulst,*,iostat=code)data(1)(1:78)
              call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
           endif
           write(iulst,*,iostat=code)
     &     ' less than 2 phases and 1 azimuth:',
     &     ' not locatable'
           call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
           write(*,*)' less than 2 phases and 1 azimuth:',
     &     ' not locatable'
         icd=6
         return
         endif
         if(dataprev.ne.data(1))then
c           write(*,*)data(1)(1:78)
           dataprev=data(1)
         endif
         write(*,*)'less than 2 phases and 1 azimuth:',
     &   ' not locatable'
         icd=6
         return
       endif
c
c   case of no azimuths
c
       if(naz.eq.0)then
         statchk=st(1)
         k=1
c
c   jh change nov 97, count correctly # stations, also if not in order
c
         do i=2,nphase
           tst=.false.  ! initially not same station
           do l=1,i-1
             if(st(i).eq.st(l).and.dtwt(l).ne.0.0) tst=.true.   ! already counted
           enddo
           if(dtwt(i).gt.0.0.and..not.tst) k=k+1
c           write(6,*) k,st(i),dtwt(i)
           if(k.eq.3)go to 7000  !  3 stations now
         end do
c        
         if(iulst.gt.0.and.(.not.multi_model))then
           if(dataprev.ne.data(1))then
c             write(iulst,*,iostat=code)data(1)(1:78)
              call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
           endif
           write(iulst,*,iostat=code)' not locatable: data needed at'
     &     ,' three different stations if no azimuths'
           call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
           write(*,*)' not locatable: data needed at'
     &     ,' three different stations if no azimuths'
         icd=6
         return
         endif
         if(dataprev.ne.data(1))then
c           write(*,*)data(1)(1:78)
           dataprev=data(1)
         endif
         write(*,*)' not locatable: data needed at'
     &   ,' three different stations if no azimuths'
         icd=6
         return
       endif
      endif
      
7000  continue
c-----------------------------------------------------------------------------

c    set L velocity to test(51)
      vl=test(51)

c layer thicknesses
      do i=1,nl-1
        parm(nl+i)=d(i+1)-d(i)

c need to add maxelv to 1st layer thickness if test(40)=0
        if(i.eq.1.and.test(40).eq.0.0)parm(nl+i)=d(i+1)-d(i)+
     &  float(maxelv)*.001

      end do

      nn=2*nl-1
c--------------------------------------------------------------
c change 10/93, BRL
c find travel time order and store in new variable, isort(i) 
c      call r4sort(nphase,dlt,isort)
      call r8sort(nphase,tp,isort)

c change 10/93:  set ips(i) before checking for bad times

      do i=1,nphase

c 5/94: use dt2<0 to mark weighted out arrivals
        dt2(i)=0.0
        ips(i)=0
      end do

c 19/94: removed loop setting ips(i)=1 for differences

c      write(iulst,*,iostat=code)test(60)
      call sei code( fort$, code, iulst, b_flag ) ! Process outcome.

c this is a call to initialize rmsv & set ips(i)
       dtav=0.0 
       tph=0.0     !added 6/98
       rms=rmsv(nphase,st,phase,tp,x0,y0,xhh0,ndata,nmoho,
     & nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc1,
     & dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc1,
     & trphs,dtav,0,data,1,depthlim,iflagd,ires,fixor,scorr)

      if(test(60).ne.0.0.and.(.not.multi_model))then
       write(iulst,'(/,'' Consistency check performed'')',
     &iostat=code)          
       call sei code( fort$, code, iulst, b_flag ) ! Process outcome.

c change 9/94: moved consistency check into subroutine ttcheck
       call ttcheck(nphase,isort,dtwt,ips,phase,st,iulst,dataprev,
     & data,xh,x0,y0,iselv,maxelv,dt2,test,tp,nmoho,nconrad,tpc1,
     & xnear,xfar,ip,dt,tph,aninc,trphs,distind,depthlim,iflagd,
     & minflag1,imatch,statchk,ndata,dtw1,dl,tt,xh1,
     & dtdl,dtdh,dddp,phcd,scorr)
      endif

c--------------------------------------------------------------------
c    find the first non-zero weight arrival and if there are any 'N' phases 
      tsmin=1.0d30
      mohoflag=0                                  
      conradflag=0
      nzcount=0

      do i=1,nphase
c------------------------------------------------------------------
c change 10/93, BRL
c use variable nzcount to count the number of valid absolute times
c 10/94; changed dtwt(i) to dtw1(i)
c          write(iulst,*,iostat=code)st(i),phase(i),ips(i),dtw1(i)
          call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
        if(phase(i)(1:2).ne.'AZ'.and.ips(i).eq.0.and.ip(i).ne.9
     &  .and.dtw1(i).ge.0.0.and.dtwt(i).gt.0)then
          nzcount=nzcount+1
        endif
c------------------------------------------------------------------
        prm2=ucase(phase(i)(2:2))
c-------------------------------------------------------------
c change 10/93 BRL added dtwt(i).gt.0.0 to next two statements
c to prevent zero-weight and PS phases being used
        if(prm2.eq.'N'.and.dtwt(i).gt.0.0)mohoflag=1
        if(prm2.eq.'B'.and.dtwt(i).gt.0.0)conradflag=1
        if(dtwt(i).gt.0.0.and.tp(i).lt.tsmin.and.
     &    phase(i)(1:2).ne.'AZ'.and.ip(i).ne.9.and.ips(i).ne.1)then
c-------------------------------------------------------------
          im=i
          tsmin=tp(i)
        endif
      end do

c    print the first arrival 
      if(nzcount.gt.0)then
        call sectim(tsmin,iyear,jday,imonth,iday,ihr,imin,sec)
        if(iulst.gt.0.and.(.not.multi_model))write(iulst,1000
     &                      ,iostat=code)st(im),iyear,imonth,
     &  iday,ihr,imin,sec
        call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
c 2000 1000    format(/,3x,'First arrival: ',a4,1x,3i2,2x,2i3,f6.2,/)
1000    format(/,3x,'First arrival: ',a4,1x,i4,1x,2i2,2x,2i3,f6.2,/)

      else
        iyear=0
        if(iulst.gt.0)then
          write(iulst,'(/''********** No absolute times: Origin time'',
     &    '' not calculated **********''/)'
     &                ,iostat=code)
        call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
        endif
      endif

c    start with origin time at either the fixed value or the 1st arrival time
c  changed 6/98,BRL      
      if(ires.eq.2.or.ucase(fixor).eq.'F'.or.test(31).eq.0.0)then
        tph=tph0
      elseif(im.gt.0)then
        tph=tp(im)
      else
        tph=0.0
      endif 

c change 10/93: set origin time to 0 when no absolute times (all PS)
c      if(nzcount.eq.0.and.ucase(fixor).ne.'F')tph=0.0

c 4/94: limit starting depth to test(70)
      if(startdep.gt.test(70))startdep=test(70)
      
c change 10/93: pass starting depth to startloc in xhh0(3)
      xhh0(3)=startdep
      
c 6/98: section to locate with slowness & azimuth
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if(nphase.eq.2)then                         
       dlt1=find_delta(phase(1),110.7/appar_veloc(1),tt1,imat)
       if(imat.ne.0)then
        trphs(1)=phase(1)
       else
        trphs(1)='????' 
       endif 
       dtwt1(1)=1.0
       dtwt1(2)=1.0 
       azm1=sngl(tp(2))
       call latlon(y0(1)/degtorad,x0(1)/degtorad,dlt1,azm1,alata,alona)
       xh1(1)=alona*degtorad
       std(1)=0.0
       xh1(2)=alata*degtorad
       xh1(3)=startdep
       std(1)=0.0
       std(2)=0.0
       std(3)=0.0
       tph=tp(1)-tt1
       dt(1)=0.0
       dlt(1)=dlt1*degtorad*rearth 
       dlt(2)=dlt1*degtorad*rearth 
       xx1=xh1(1)
       xx2=xh1(2)
       if(xx1.gt.pi)xx1=-(2.*pi-xx1)
       if(xx1.lt.-pi)xx1=2.*pi+xx1
       call unfold(xx2,xx1,la1,ins1,ala1,lo1,iew1,alo1)
       lo2=lo1
       la2=la1
       if(iew1.eq.'W')lo2=-lo1
       if(ins1.eq.'S')la2=-la1
       fo=' ' 
       fd='*'
       dp2=startdep
       m=2
       ndata=3
       call distaz(y0(1)/degtorad,x0(1)/degtorad,xh1(2)/degtorad,
     &  xh1(1)/degtorad,dedeg,azb,azz)
c       call delaz(xh1(2),xh1(1),dekm,dedeg,azz,y0(1),x0(1))
       baz0(1)=azb
       baz0(2)=azb
       az0(1)=azz
       az0(2)=azz

c find angle of incidence using IASPEI91 model
       dddd=110.7/appar_veloc(1)/rearth/degtorad      
       delz=xh1(3)
       rr=(rearth-delz)/rearth
       call emiask(rr,ro,vpp,vss)
       vpp=vpp*6.8501006
       vss=vss*6.8501006
       if(phase(1)(1:1).eq.'P'.or.phase(1)(2:2).eq.'P')vvv=vpp
       if(phase(1)(1:1).eq.'S'.or.phase(1)(2:2).eq.'S')vvv=vss

       arg=vvv*dddd
       if(arg.gt.1.)arg=1.
       aninc(1)=asin(arg)/degtorad

       call sectim(tph,iyr,jday,imnth,idy,ihn,imm,xhm)
       if(iulst.gt.0.and.(.not.multi_model))
     * write(iulst,950,iostat=code)
       call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c2000       if(iulst.gt.0)write(iulst,951,iostat=code)iyr,imnth,idy,
      if(iyr.lt.2000) i=iyr-1900
      if(iyr.ge.2000) i=iyr-2000

       if(iulst.gt.0.and.(.not.multi_model))
     * write(iulst,951,iostat=code)i,imnth,idy,
     & ihn,imm,xhm,fo,la1,
     & ala1,ins1,lo1,alo1,iew1,dp2,fd,ndata,m,rmssv,xk2,
     & (std1(i),i=1,3),icd
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
       tpc(1)=tt1
       tpc(2)=azm1
       return
      endif
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
       
c    Find starting epicenter (if not fixed)  Added 'F' 4/92
c 7/94: add fixepi='N' option to force closest station start location
      if(ires.lt.7.and.ucase(fixepi).ne.'S'.and.ucase(fixepi)
     &.ne.'F'.and.ucase(fixepi).ne.'N'.and.nphase.gt.2)then
        
        test36=test(36)  
        test88=test(88)
        test(36)=0.0      !temporarily disable residual weighting
        test(88)=0.0
c        test(36)=10000.
c        test(88)=10000.

c 6/98 BRL: set xfar to 10000 temporarily for start location. 
c           This was causing problems due to most or all phases 
c           being weighted out by the distance weighting giving 
c           an artificially low rms when distance of the start
c           location became large
        xfar_temp=xfar
        xfar=50000.0
        call startloc(nphase,st,phase,tp,x0,y0,xhh0,xh2,nn,
     &  nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &  tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,rmsmin,distind,
     &  nsol,aninc,trphs,vapp,azapp,alatm,alonm,isort,data,fixdep,
     &  depthlim,iflagd,ires,fixor,scorr,appar_veloc)
        xfar=xfar_temp
        test(36)=test36
        test(88)=test88
c        write(iulst,*,iostat=code)xhh0(1)/degtorad,xhh0(2)/degtorad
        call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
        do i=1,2
          xh0(i)=xhh0(i)
        end do
        
        startlon=xhh0(1)   !added 6/98
        startlat=xhh0(2)
        
c added depth phase determination 1/94
        startdep=xhh0(3)

c 4/94: limit starting depth to depthlim        
        if(startdep.gt.depthlim)then
         startdep=depthlim
         xhh0(3)=depthlim
        endif 
        
c  fixed starting depth
      else

c this is a call to initialize rmsv   -removed BRL 6/98
c        dtav=0.0                                         
c        rms=rmsv(nphase,st,phase,tp,x0,y0,xhh0,ndata,nmoho,
c     &  nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc1,
c     &  dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc1,
c     &  trphs,dtav,0,data,1,depthlim,iflagd,ires,fixor,scorr)

c  leave depth as it was
         xh0(1)=startlon
         xh0(2)=startlat
         xh0(3)=startdep
      endif

      xh0(3)=startdep
c       write(*,*)'startdep',startdep
c   set initial hypocenter, xh, to starting location
      do i=1,3
        xh(i)=xh0(i)
      end do                                           
c      write(iulst,*,iostat=code)xh(1)/degtorad,xh(2)/degtorad
      call sei code( fort$, code, iulst, b_flag ) ! Process outcome.
      fact=0.5
      irs=0
      dtav=0.0

c    fix depth initially (unless ires=8)
      if(ires.eq.8)then
        m=3
      else
        m=2
      endif

      izneg=0

c    initial value of damping
      xks=test(30)
      xk=xks

      m1=0
      nitr=test(11)                       
      
c 10/94: limit test(31) to 3      
      if(test(31).gt.3.)test(31)=3.0

c 6/94: only 1 iteration if everything fixed
      if(test(31).eq.0.0)nitr=1             
      if(ires.eq.8.or.ires.eq.9)nitr=1
      idec=0
      iend=0
      i1=0
      i2=0
      m1=m
      eps=test(32)

c   parameter change limit increased by 10 initially to free depth 
c   more quickly
      if(test(31).eq.3)eps=test(32)*10.

c    xke is the damping used for error calculations
      xke=xks

      kntt=0

c    irmsmx is the maximum increases allowed in xk
      irsmx=test(37)

      pcm=0.0

c    istart is used to count the number of convergences 
      istart=0
      std(3)=0.0
      tph1=tph                          
      tph3=tph
      tph2=tph                     
      
c ifirst is used to set minimum values on 1st iteration
      ifirst=1      

c 1/95: counts # of depth variation trials at end (only 1 allowed)
      idpcount=0

c  !!!!!!!!!!!!!!!!!!!!!!!!   iteration loop   !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      if(test(31).eq.0.0)icflag=1 !added 6/98 BRL

      do 98 it=1,nitr

5000    continue

c   find ne1, the present hypocenter layer 
        do i=1,nl-1
          if(xh(3).lt.d(i+1))go to 28
        end do

        ne1=nl
        go to 29
28      ne1=i
29      continue

        vph=v(ne1)
        vsh=vs(ne1)

        do k=1,3
          ss(k)=0.0
        end do

c  <<<<<<<<<<<<<<<<<<<<<<<<<<<  phase loop  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c        write(iulst,*,iostat=code)'xh ',(xh(i)/degtorad,i=1,2) 
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
      imatch=1
      if((it.ge.int(test(73)).or.nitr.lt.int(test(73)))
     & .and.test(72).ne.0.0)imatch=0
c      if(minflag.eq.5)imatch=1
      
c      write(iulst,*,iostat=code)imatch,test(72),test(73)
      call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c update origin time using previous mean residual, dtav
c 6/94 don't change for fixed origin time
      if(fixor.eq.'F'.or.ires.eq.2)then   !changed 6/98, BRL
       tph=tph0
      endif  

      rms=rmsv(nphase,st,phase,tp,x0,y0,xh,ndata,nmoho,nconrad,
     &iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc1,dl,iselv,
     &maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc1,trphs,dtav,
     &minflag,data,imatch,depthlim,iflagd,ires,fixor,scorr)   
      iupdate=1
c      write(iulst,'(''st'',i3,6f9.3)',iostat=code)ndata,rms,tph1-tph3,
c     & (xh(i)/degtorad,i=1,2),xh(3)
      call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c      write(iulst,'(10f8.3)',iostat=code)(dtw1(i),i=1,nphase)
      call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c      write(iulst,'(10f8.3)',iostat=code)(dt(i),i=1,nphase)
      call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c 6/98,BRL: added icflag to reset minimum rms when minutes corrected
      if(imflag.eq.1.or.it.eq.1.or.icflag.eq.1)then
c         write(iulst,*)' imflag=1'
          rms1=rms
          rms2=rms
          res2=res
          tph2=tph
          tph1=tph
          np=m
          np1=np
          do i=1,nphase
            dt1(i)=dt(i)
          end do

          do i=1,3
           xh1(i)=xh(i)
           xh2(i)=xh(i)
          end do 
          icflag=0
      endif 
c      write(iulst,'(10f8.3)')(dtw1(i),i=1,nphase)
c      write(iulst,'(10f8.3)')(dt(i),i=1,nphase)

        if(ndata.lt.3)then
          if(iulst.gt.0)then
            if(dataprev.ne.data(1))then
c              write(iulst,*,iostat=code)data(1)(1:78)
              call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
              dataprev=data(1)
            endif
            call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
            write(iulst,303,iostat=code)
            write(*,303)     !added 6/98 BRL
          endif
303       format(1x,'Less than three valid phases for this ',
     &    'event at its present location: no result')
          icd=6
          return
        endif

        if(ifirst.eq.1.and.iulst.gt.0.and.(.not.multi_model))then
          write(iulst,940,iostat=code)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
940       format(/,' iter   origin      lat      long depth  no  m',
     &    '    rms   damp.  erlg  erlt  erdp')
          write(iulst,972,iostat=code)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
972       format('         (sec)  (dg mn)   (dg mn)  (km)         ',
     &    '(sec)          (km)  (km)  (km)')
        endif

c    set rms1 = rms on first iteration
c    changed 7/94 to use ifirst instead of it=1
        if(ifirst.eq.1)then
          rms1=rms
          rms2=rms
          res2=res
          tph2=tph
          tph1=tph
          np=m
          np1=np
          do i=1,nphase
            dt1(i)=dt(i)
          end do

c 5/94: set xh1 & xh2 to xh
          do i=1,3
           xh1(i)=xh(i)
           xh2(i)=xh(i)
          end do 
          ifirst=0          
        endif

c  ----------------------  rms decrease  ---------------------------------

 741     continue
c        write(iulst,*,iostat=code)rms,rms1,m,np,np1,xh(3)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c change 5/94: for autopick, store minimum values at test(73) iterations
c even when rms is not minimum
        if(rms.le.rms1.or.ires.eq.9.or.it.eq.1.or.(test(72).ne.0.0.and.
     &  it.eq.int(test(73))))then

c save the relevant old values for minimum rms
          xk1=xk
          res1=res
          rms1=rms
          tph1=tph                        


c 10/93: disabled this - set tph=tph+dtav1 at very end
c Centering: any change in the mean residual, dtav, is added to the origin time
c          if(ires.ne.9.and.ires.ne.2)then
c            tph=tph+dble(dtav)
c          endif

c----------------------------------------------------------
c change 10/93: set origin time and dtav1 to 0 when no absolute times
c         if(nzcount.eq.0)then
c          tph=0.0
c          dtav1=0.0
c         endif
c----------------------------------------------------------
          
          do j=1,3
            std1(j)=std(j)
            xh1(j)=xh(j) 
            eig1(j)=eig(j)
            alpha1(j)=alpha(j)
          end do
          
c          write(iulst,'(''rms decr-eigs:'',3f8.3)'
c     &                 ,iostat=code)(eig1(i),i=1,3)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

           do i=1,nphase
             tpc(i)=tpc1(i)
             aninc(i)=aninc1(i)
             dtwt1(i)=dtw1(i)
             dt1(i)=dt(i)                            

c save minimum rms data importances
             di1(i)=di(i)

           end do

          do i=1,3
            ss(i)=0.0
          end do

c 10/93: set rms2=rms1 as well if rms1 is lower
         if(rms1.lt.rms2)then                  
             irs=0
c             write(iulst,*,iostat=code)'rms2 set to ',rms1,xh1(3)
             call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
             rms2=rms1
             tph2=tph1                            
             res2=res1
             do i=1,3
              xh2(i)=xh1(i)
             end do
          endif                                            
c    .................  centering and scaling  ........................

c 10/93 residual centering removed - now in rmsv

c    calculate the means, ss(j), of the weighted columns 
c    of the partial derivative matrix, g(i,j). 
c    wsum1 = sum of the valid weights (no azimuths or differences)

          wsum1=0.0

          do i=1,nphase
            ww=dtw1(i)*dtw1(i)  !change 6/98, BRL

c 10/93 don't include azimuth and difference phases in wsum1
            if(dtw1(i).lt.0.0.or.ips(i).eq.1.or.phase(i)(1:2).eq.
     &      'AZ')ww=0.0

            wsum1=wsum1+ww
            do j=1,3
              ss(j)=ss(j)+g(i,j)*ww
            end do
          end do

400       format(10f7.2)

          do j=1,3
            if(wsum1.ne.0.0)ss(j)=ss(j)/wsum1
          end do

c    center and weight the columns of g
          do i=1,nphase
            ww=dtw1(i)
            if(dtw1(i).lt.0.0)ww=0.0

c            write(iulst,*,iostat=code)g(i,3)
            call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
            do j=1,3

c 10/93 don't center azimuths & differences (modified to exlude ires=2, 4/94)
              if(dtw1(i).gt.0.0.and.ips(i).eq.0.and.phase(i).ne.
     &        'AZ  '.and.ires.ne.2)then
                g(i,j)=(g(i,j)-ss(j))*ww
              else
                g(i,j)=g(i,j)*ww
              endif
            end do
c            write(iulst,*,iostat=code)(g(i,j),j=1,3),ww
            call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
          end do

c   now scale the centered columns of g so they have an rms of 1
c   11/94: use ss1 for scaling factors instead of overwriting ss
          do j=1,3
            ss1(j)=0.0
            do i=1,nphase
              ss1(j)=ss1(j)+g(i,j)*g(i,j)
            end do
          end do

          do k=1,3
            ss1(k)=sqrt(ss1(k))
c            ss1(k)=ss(k)
          end do

          do i=1,nphase
            do k=1,3
              if(ss1(k).eq.0.0)then
                g(i,k)=0.0
              else
                g(i,k)=g(i,k)/ss1(k)
              endif
c      set g1=g
              g1(i,k)=g(i,k)
            end do                   
c           write(iulst,'(1x,5f12.6)',iostat=code)(g(i,k),k=1,3)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
          end do

c .....................................................................

c    output the current solution (changed 4/94 to allow fixing origin time)
          if(ucase(fixor).eq.'F'.or.ires.eq.2)then ! BRL 6/98 remove ires.eq9
           tphh=tph0
          else
c         origin time now updated in rmsv
           tphh=tph !+dble(dtav)                  ! BL Feb95, 6/98
cJAB(BGS)Feb95           tphh=tph1+dble(dtav)   ! BL Feb95
          endif  
          
          call sectim(tphh,iyear,jday,imnth,iday,ihr,imin,secs)
c          write(16,*)xh(1)/degtorad,xh(2)/degtorad
          call unfold(xh(2),xh(1),la1,ins1,ala1,lo1,iew1,alo1)

c change 10/93, 4/94 : correct depth to maxelv origin if test(40)>0
          dp2=xh(3)
c          if(test(40).gt.0.)dp2=xh(3)+float(maxelv)*.001
          rmssv=rms1
          if(rmssv.gt.999.999)rmssv=999.999
          if(dp2.gt.999.9)dp2=999.9
          xk2=xk
          if(xk2.gt.9999.9)xk2=9999.9
          do i=1,3
            if(std(i).gt.9999.9)std(i)=9999.9
          end do
          if(iulst.gt.0.and.(.not.multi_model)) write(iulst,941
     &                      ,iostat=code)it,secs,la1,ala1,ins1,lo1,
     &    alo1,iew1,dp2,ndata,m,rmssv,xk2,(std(i),i=1,3)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
  
c 10/93: minor format change
941       format(i5,f9.2,i3,f5.2,a1,i4,f5.2,a1,f6.1,i4,i3,f7.2,f8.3,
     &    4f6.1)

          kntt=0

c        check convergence criteria
          if(rms.lt.0.01.and.it.gt.1)then !change 6/98, BRL
            rms1=rms
            tph1=tph
            icd=1
            go to 97
          endif

          if(it.eq.nitr)then
            icd=5
            if(rms.lt.rms1)rms1=rms
            go to 97
          endif

          if(it.ne.1)then

c    decrease xk 
            if(irs.eq.0.and.it.gt.1)xk=xk/4.
  
c    more cautiously if rms has increased
            if(irs.ne.0)xk=xk/1.5

c    but don't go less than xks
            if(xk.lt.xks)xk=xks

          endif

          kk=2

        else
       
c  --------------------  rms increase  -------------------------------------
c      rms has increased - return to minimum rms values 
c      irs counts the attempts to increase rms 
          irs=irs+1

c          write(iulst,'(''rms incr'',i3,6f8.2)'
c      &                ,iostat=code)irs,rms,rms1,
c     &     (xh(i)/degtorad,i=1,2),xh(3),xk
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c          write(iulst,'(''eigs:'',3f8.3)',iostat=code)(eig1(i),i=1,3)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c change 10/93: allows rms to increase test(65) times to rms1*test(64)
c setting test(64)=0.0 disables this feature
          irskip=int(test(65))

          if(irs.le.irskip.and.rms.lt.rms1*test(64).and.m.eq.3)then

c change 4/94: save the (real) minimum rms in rms2 and hypocenter in xh2
            if(rms1.lt.rms2.and.irs.eq.1)then
c             write(iulst,*,iostat=code)'rms2 set to ',rms1,xh1(3)
             call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
             rms2=rms1
             tph2=tph1                            
             res2=res1
             do i=1,3
              xh2(i)=xh1(i)
             end do
            endif                                            
            
c set minimum rms temporarily to this (increased) value
            rms1=rms    
            tph1=tph

c might as well increase the damping a bit 
            xk=xk*2.
            
c now act as if rms had decreased
            go to 741
          endif
                      
c   return to minimum rms values
          if(it.ne.1)then
           res=res1
c          tph=tph1  
c          np=np1
           if(np.eq.np1)then
            do i=1,16
              ve(i)=ve1(i)
            end do
           endif
          endif
          do i=1,3
           xh(i)=xh1(i)
           if(it.ne.1.and.np.eq.np1)then
            eig(i)=eig1(i)
            alpha(i)=alpha1(i)

c 6/98, BRL restore scaling factors
            ss(i)=ss01(i)
            ss(i)=ss11(i)     

           endif
          end do

          do i=1,nphase
           dt(i)=dt1(i)
          end do

          if(irs.gt.irsmx)then
            icd=2

c    rms has still increased after test(37) increases of xk: fix depth
            if(m.eq.2)go to 97
            iend=1
            xk=xks
            irs=0
            m=2
c            if(iulst.gt.0)write(iulst,2002,iostat=code)icd
            call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
2002        format(1x,'depth fixed: icd=',i3) 

c change 4/94: reset to xh2 if rms2<rms1
            if(rms2.lt.rms1)then  
             rms1=rms2
             tph1=tph2             
             res1=res2
             rms2=999.
             do i=1,3
              xh(i)=xh2(i)
             end do
             go to 5000
            endif  
            
            dth(3)=0.0
            std(3)=0.0

          else   

c    increase xk
            xk=xk*test(39)
c            write(iulst,*,iostat=code)' k increased to ',xk,
c     &                                ' rms = ',rms
            call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
            if(xk.eq.0.0)xk=xks
 8           np=m
            go to 189

          endif

        endif

c **************************************************************************
41      continue

c    SVD of partial derivative matrix
        res2=0.0
        ndata2=0
        do i=1,nphase
c          write(iulst,'(3f10.3)',iostat=code)(g1(i,j),j=1,m)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
          ww=dtw1(i)
          if(ww.gt.0.0)ndata2=ndata2+1
          if(dtw1(i).lt.0.0)ww=0.0

c centered differences, dt2(i) are used to calculate parameter corrections
c modified 4/94 to allow for fixed origin time
           dt2(i)=dt1(i)*ww
           res2=res2+dt2(i)*dt2(i)
c          write(iulst,'(2f10.1)',iostat=code)dt1(i),dtw1(i)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
        end do
c        write(iulst,*,iostat=code)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c 9/94: added di & dtw1 to window
        call minv(m,nphase,np,dt2,di,dtw1)
        
c        write(iulst,*,iostat=code)(eig(i),i=1,3),np
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c 10/93: now need to calculate res, the sum of the squared residuals,
c from rms. Although nphase is not always the number of phases used, res 
c is divided by nphase in subroutine corr and this keeps the mean square 
c residual correct for the error calculation

c 2008        res=res2*float(nphase)/float(ndata2)
        res=res2     ! bl may 2008
         
c    save minimum rms SVD values
        if(it.eq.1.or.rms.le.rms1)then
          np1=np
c        write(iulst,*,iostat=code)' np1 ',np1
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
          res1=res

c 6/94 save minimum values at this point - moved from earlier point
c where they were still zero
          do i=1,3
           alpha1(i)=alpha(i)
           eig1(i)=eig(i)
           ss01(i)=ss(i)   !j changed to i, BRL 6/98
           ss11(i)=ss1(i)
          end do                        
          do i=1,16
            ve1(i)=ve(i)
          end do
        endif  
           
c        write(iulst,*,iostat=code)' res1 ',res1,np1,nphase,m
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c     calculate parameter corrections (dth) and standard deviations (std)
189     continue
c        write(iulst,*,iostat=code)' res1 ',res1,m,nphase,xk
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c        write(iulst,'(3f10.3)',iostat=code)(alpha(j),j=1,3)         
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c        write(iulst,'(9f9.3)',iostat=code)(ve(j),j=1,9)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c 9/94 changed nphase to ndata2 (now no of non-zero phases - only used
c      for errors)        
c 10/94 added distind, iflagd to corr window
        call corr(m,ndata2,np,xk,res1,test,oterr,distind,iflagd)

c 6/94: set dth(1), dth(2)=0 if fixepi=0
         if(fixepi.eq.'F')then
           dth(1)=0.0
           dth(2)=0.0
         endif
           
c        write(iulst,*,iostat=code)(ss1(j),j=1,m),res1,xk
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c         write(iulst,'(''corrs'',3f8.2)'
c      &            ,iostat=code)(dth(j)/(ss1(j)*degtorad)
c     &    ,j=1,m)
         call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c         write(iulst,*,iostat=code)' np,res, xk ',np,res,xk,ndata2
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

900     format(5f12.4)
c       write(iulst,*,iostat=code)(eig(i),i=1,3)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c    calculate std devs and unscaled parameter corrs in km
        sum=0.0
        
        do ib=1,m
          if(ires.ne.8.and.ss1(ib).ne.0.0)then
c            std(ib)=rearth*sqrt(var(ib)/ss1(ib))
            std(ib)=rearth*sqrt(var(ib,ib))
            sum=sum+(rearth*dth(ib)/ss1(ib))**2
          endif
        end do                             
c        write(iulst,'(3f10.3)',iostat=code)(std(i),i=1,m)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c    pcm = magnitude of parameter change in km
        pcm=sqrt(sum)
c        write(iulst,'(''pcm '',2f8.2)',iostat=code)pcm,xk
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
        dfact=1.0

c     apply parameter corrections to xh to solution, xh
        do j=1,m
          if(ires.ne.8.or.j.eq.3)then
            if(ss1(j).ne.0.0)then
              ddd=dth(j)/ss1(j)

c 11/94: correct dtav for hypocentral adjustment
c              dtav=dtav+ddd*ss(j)

c  convert depth correction to km
              if(j.eq.3)ddd=ddd*rearth
              
              xh(j)=xh(j)+ddd                                       
              
            endif
          endif
        end do

c change 6/98, BRL: update origin time
c         if(fixor.ne.'F'.and.ires.ne.2.and.test(31).gt.0.0)then
         if(fixor.ne.'F'.and.ires.ne.2.and.abs(test(31)).gt.0.0)then
          if(iupdate.eq.1)then
           iupdate=0
c           write(iulst,*)' dtav added: ',dtav
c           tph=tph+dtav       
          endif 
         else
          tph=tph0
         endif  

c 2/95: prevent latitude > 90 or <-90
        if(xh(2).gt.0.5*pi)then
         xh(1)=xh(1)+pi
         xh(2)=pi-xh(2)
        endif
        if(xh(2).lt.-0.5*pi)then
         xh(1)=xh(1)+pi
         xh(2)=-pi-xh(2)
        endif

c 6/94 prevent longitude>180 deg        
        if(xh(1).gt.pi)xh(1)=-(2.*pi-xh(1))
        if(xh(1).lt.-pi)xh(1)=2.*pi+xh(1)
c       write(iulst,'(''dth '',3f8.2)'
c      &         ,iostat=code)(dth(j)/(ss1(j)*degtorad),
c     &  j=1,2),rearth*dth(3)/ss1(3)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c       write(iulst,'(''new sol'',3f10.2,f10.3)'
c      &          ,iostat=code)(xh(j)/degtorad,j=1,2)
c     &  ,xh(3),rms
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c    if depth < 0 or pcm > test(2) increase xk and try again

c change 10/93: correct depth origin if test(40)>0
        dptest=xh(3)
c        if(test(40).gt.0.0)dptest=xh(3)+float(maxelv)*.001

c 6/94: don't use test(2) limit for distant events        
        if(dptest.lt.0.0.or.(pcm.gt.test(2).and.distind.ne.'D'))then

c          write(16,*)rms,xh(1)/degtorad,xh(2)/degtorad,xh(3)
          xk=xk*test(39)
c          write(iulst,*,iostat=code)'d<0 or pcm>test(2), 
c     &      xk increased to ',xk
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c    kntt counts the attempts to cause depth < 0 and/or make pcm > test(2)
          kntt=kntt+1

c    return to minimum rms solution
          do j=1,3
            xh(j)=xh1(j)
          end do

c    redo the corrections if kntt<10
          np=m
          if(kntt.le.10)go to 189

c    fix depth if kntt > 10
          m=2
          xk=xks
          irs=0
          std(3)=0.0

c change 10/93: no error2 message, just terminate with icd=7
          icd=7
          do j=1,3
            xh(j)=xh1(j)
          end do
          go to 97 
        endif

c change 1/94 BRL: limit depth to depthlim
        if(xh(3).gt.depthlim)then
         if(depthlim.eq.test(70))then
          if(iulst.gt.0.and.(.not.multi_model))
     *    write(iulst,'('' depth fixed at '',
     &    f6.1,'' km'')',iostat=code)depthlim
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
          write(*,'('' depth fixed at '',
     &    f6.1,'' km'')')depthlim
         endif
         xh(3)=depthlim
         iend=1
         xk=xks
         irs=0
         m=2
        endif

c     write(iulst,*,iostat=code)(dth(kk),kk=1,3)
      call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c    don't go more than test(41) km from nearest station
c         call distaz(y0(im)/degtorad,x0(im)/degtorad,xh(2)/degtorad,
c     &   xh(1)/degtorad,dedeg,azz0,azb)
c        delta=rearth*dedeg*degtorad
        call delaz(y0(im),x0(im),delta,dedeg,azz0,xh(2),xh(1))
c        write(iulst,*,iostat=code)delta
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
        if(delta.gt.test(41).and.distind.ne.'D')then
          icd=4
          if(iulst.gt.0)write(iulst,2127,iostat=code)test(41)
          call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
          write(*,2127)test(41)
2127      format(1x,/,' event is >',f7.1,' km from closest ',
     &    'station: no output ',/)
          if(rms.lt.rms1)rms1=rms
          go to 97
        endif

c   convergence: pcm < eps or last iteration
c        write(iulst,*,iostat=code)pcm,eps,istart
        call sei code(fort$,code,iulst,b_flag)
        if(pcm.le.eps.or.it.eq.nitr)then
c          istart=istart+1  !removed 6/98, BRL
c          icd=3

          if(it.eq.nitr)then
            write(iulst,
     &      '(/'' ******* Maximum Iterations Exceeded''/)',
     &      iostat=code)
            call sei code(fort$,code,iulst,b_flag)
            icd=5
            if(rms.lt.rms1)rms1=rms
            go to 97
          endif

c this section changed 6/98, BRL<<<<<<<<<<<<<<<<<<<<<<<<<<<<
           istart=istart+1
           icflag=0
           
c check for minute errors
          if(istart.eq.1.and.m.eq.2)then
           icflag=1

c recalculate rms with minute check
           go to 5000
          endif 
          
          icd=3

          if(istart.eq.4)then
            if(rms.lt.rms1)rms1=rms
            go to 97
          endif
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c   free depth on first time thru (istart=1)
          if(istart.eq.2)then

c   change 10/93: don't free depth if ndata<4
            if(ndata.ge.4)m=abs(test(31))
c            write(iulst,*,iostat=code)
c     &             'ires,fixdep,ndata',ires,fixdep,ndata
            call sei code(fort$,code,iulst,b_flag)
            if(ires.eq.1.or.fixdep.eq.'F')m=2
            if(m.eq.3.and.iulst.gt.0.and.(.not.multi_model))then
             write(iulst,'(1x,''depth freed: icd= '',i3)'
     &                  ,iostat=code)icd
             call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
            endif 

c 6/94 changed to only do this if m=3 - otherwise exit
            if(m.eq.3)then   
             irs=0
             eps=test(32)
c             xk=xks
             
c          redo the SVD
             go to 41
            endif 

            icd=3
            if(rms.lt.rms1)rms1=rms
            go to 97

          elseif(istart.eq.3)then

c     fix depth on 2nd time thru
            if(m.eq.2)then

c     depth already fixed - exit
              icd=3
              if(rms.lt.rms1)rms1=rms
              go to 97
            endif
    
c      fix depth
            m=2
c            if(iulst.gt.0)write(iulst,2002,iostat=code)icd
            call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
            dth(3)=0.0
            std(3)=0.0

c     set xk to starting value
            xk=xks
            iend=1
            irs=0
            izneg=0                

c change 4/94: reset to rms2 and xh2 if rms2<rms1
            if(rms2.lt.rms1)then
c             write(iulst,*,iostat=code)' rms reset to ',rms2
             call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
             rms1=rms2      
             res1=res2
             tph1=tph2
             do i=1,3
              xh1(i)=xh2(i)
             end do
            endif                                

c 1/95: section to find minimum rms depth testing at 10 km intervals
            if (test(96).gt.0.0)then !added condition 6/98, BRL
             dincr=10.
             dpmin=xh1(3)
             rmsdt=rms1
             rmsmin=rms1
             dpmin=xh1(3)
             xh1(3)=xh1(3)-dincr
             if(xh1(3).lt.0.0)xh1(3)=0.0
c             do while (xh1(3).lt.dpmin.and.rmsdt.le.rmsmin.and.xh1(3).
c     &       gt.0.0)
             do while (xh1(3).lt.dpmin.and.xh1(3).
     &       gt.0.0)
              rmsdt=rmsv(nphase,st,phase,tp,x0,y0,xh1,ndata,
     &        nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,
     &        dtwt,dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,
     &        tph,distind,aninc1,trphs,dtav,minflag,data,imatch,
     &        depthlim,iflagd,ires,fixor,scorr)
c              write(iulst,*)rmsmin,dpmin,rmsdt,xh1(3)
              if(rmsdt.le.rmsmin)then
               rmsmin=rmsdt
               dpmin=xh1(3)
              endif
              xh1(3)=xh1(3)-dincr
              if(xh1(3).lt.0.0)xh1(3)=0.0
             enddo
             rms1=rmsmin
             xh1(3)=dpmin
            
c recalculate everything
            go to 41
           endif
c            go to 5000

          endif

        endif

c.....................................................................

c    don't count rms increase as an iteration
        if(rms.gt.rms1.and.ires.lt.7)then
c          write(*,*)rms,rms1,xk,pcm
          go to 5000
        endif

c    set new minimum rms value to rms
        rms1=rms
        tph1=tph 

c added 4/94 to also set rms2 & xh2
        if(rms1.lt.rms2)then
c         write(iulst,*,iostat=code)' rms2 set to ',rms1
         call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c         rms2=rms1
         do i=1,3
c          xh2(i)=xh1(i)
         end do
        endif  

98    continue

c  !!!!!!!!!!!!!!!!!!!!!  end of iteration loop  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

97    continue

c change 4/94: reset to rms2 and xh2 if rms2<rms1
      if(rms2.lt.rms1)then
c       write(iulst,*,iostat=code)' rms reset to ',rms2
       call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
       rms1=rms2      
       res1=res2
       tph1=tph2
       do i=1,3
        xh1(i)=xh2(i)
       end do
      endif                                

c 6/94 recalculate rms at minimum rms solution - residuals in dt1
      rms1=rmsv(nphase,st,phase,tp,x0,y0,xh1,ndata,nmoho,
     & nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &tpc1,dl,iselv,maxelv,ips,ip,dt1,xfar,xnear,tph1,distind,
     &aninc1,trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,
     &scorr)

c  calculate errors for final solution with m=3
      m=3
      
      
c 6/98: fix depth if ndiffstat=1
      if(ndiffstat.eq.1)m=2                          

c 10/94: fix depth if ndata2<4
      if(ndata2.lt.4)m=2

c xke is the damping used to calculate the errors
      xke=xks                                    
      
c 6/94 set m=2 if depth fixed
      if(ndata.eq.3.or.ires.eq.1.or.fixdep.eq.'F')m=2
      
c if test(38)=0, set it to 0 (least squares errors)      
      if(test(38).eq.0.0)xke=0.0                   

c 6/94 need to recalculate weighted residuals for error calculation
      res2=0.0
      ndata2=0
      do i=1,nphase
c        write(iulst,'(3f10.3)',iostat=code)(g1(i,j),j=1,m)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
        ww=dtw1(i)

c 10/94: set dtwt1(i)=dtw1(i)
        dtwt1(i)=dtw1(i)
        
        if(ww.gt.0.0)ndata2=ndata2+1
        if(dtw1(i).lt.0.0)ww=0.0
        dt2(i)=dt1(i)*ww
        res2=res2+dt2(i)*dt2(i)
c        write(iulst,'(2f10.1)',iostat=code)dt1(i),dtw1(i)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
      end do
c 2008      res1=res2*float(nphase)/float(ndata2)
        res1=res2             ! added bl may 2008
c      write(iulst,*,iostat=code)' res1 ',res1,np1,nphase,m
      call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c 9/94: added di & dtw1 to window
      call minv(m,nphase,np1,dt2,di,dtw1)

c 9/94 changed nphase to ndata2
      call corr(m,ndata2,np1,xke,res1,test,oterr,distind,iflagd)
      
c      write(iulst,*,iostat=code)(ss1(j),j=1,m),res1,xke
      call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
      
      do i=1,3
       std1(i)=rearth*sqrt(var(i,i))
       if(std1(i).gt.999.9)std1(i)=999.9

c 7/94: set error to 999.9 if zero - unconstrained case
       if(std1(i).eq.0.0)std1(i)=999.9                 
       
      end do
      if(m.eq.2)std1(3)=0.0
       
c   calculate resolution matrix, resl
      do i=1,m
       do j=1,m
        sum=0.0
        do k=1,np1
         ii=(k-1)*m+i
         jj=(k-1)*m+j

c change 10/93: prevent divide by zero
         if(eig1(k).gt.0.0)then
          fact=1./(1.+xk1/eig1(k)**2)
          sum=sum+ve(ii)*ve(jj)*fact
         endif

        end do
        resl(i,j)=sum
       end do
      end do

c 7/94 calculate error ellipsoid
      ic=1
      do  j=1,m
        do  k=1,j
          a(ic)=var(j,k)
          ic=ic+1
        end do
      end do
      call eigen(a,ve,m,0)    
      dip1=atan2(ve(3),sqrt(ve(1)*ve(1)+ve(2)*ve(2)))
      iazyx1=int(0.49999+atan2(ve(1),ve(2))/degtorad)
c      write(iulst,*,iostat=code)'var ',rearth*sqrt(a(1)),
c     &rearth*sqrt(a(3)),
c     & rearth*sqrt(a(6))  
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c      write(iulst,*,iostat=code)ve(1),ve(2),ve(3)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c      write(iulst,*,iostat=code)ve(4),ve(5),ve(6)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c      write(iulst,*,iostat=code)ve(7),ve(8),ve(9)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
      
c    convert epicenter to geographic lat/long
      xx1=xh1(1)
      xx2=xh1(2)

c change 3/94 to correct longitude > 180 deg  or < -180   
      if(xx1.gt.pi)xx1=-(2.*pi-xx1)
      if(xx1.lt.-pi)xx1=2.*pi+xx1

      call unfold(xx2,xx1,la1,ins1,ala1,lo1,iew1,alo1)
      lo2=lo1
      la2=la1
      if(iew1.eq.'W')lo2=-lo1
      if(ins1.eq.'S')la2=-la1

c   center the origin time and convert it to standard format (4/94 if not fixed)
c      write(iulst,*,iostat=code)'dtav1=',dtav1
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
      if(ires.ne.9.and.ires.ne.2.and.ucase(fixor).ne.'F')then
       tphh=tph1 !+dble(dtav)  changed 6/98, BRL
      else
       tphh=tph0
      endif
        
      call sectim(tphh,iyr,jday,imnth,idy,ihn,imm,xhm)

c    output final solution
      if(test(50).eq.0.0.and.iulst.gt.0)then
        write(iulst,953,iostat=code)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
953     format(/'    *************   Azimuth',
     &  '  data ignored *************')
      endif
      if(iulst.gt.0.and.(.not.multi_model))
     *write(iulst,950,iostat=code)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
950   format(/,'   date hrmn   sec      lat      long depth   no m',
     &'    rms  damp erln erlt erdp ic')
      fd=' '
      if(ires.eq.1.or.ires.eq.9.or.abs(test(31)).eq.2.)fd='*'
      fo=' '
      if(ires.eq.2.or.ucase(fixor).eq.'F')fo='*'

c change 10/93: correct for depth origin
      dp2=xh1(3)

c 4/94: removed this - depth is always relative to defined origin
c      if(test(40).gt.0)dp2=xh1(3)+float(maxelv)*.001

      if(dp2.gt.999.9)dp2=999.9
      rmssv=rms1
      if(rmssv.gt.999.99)rmssv=999.99
      
c 6/94 set damping to value used for errors      
      xk2=xke
      if(xk2.gt.99.999)xk2=99.999

      do i=1,3
        if(std1(i).gt.999.9)std1(i)=999.9
      end do

c change BRL 11/95: add zeros to hr,min format
      if(nzcount.gt.0)then
       write(thrmin,'(2i2)')ihn,imm          
      else
       thrmin='    '
       xhm=0.0
      endif  
      do i=1,4
       if(thrmin(i:i).eq.' ')thrmin(i:i)='0'
      enddo
      if(iyr.lt.2000) i=iyr-1900
      if(iyr.ge.2000) i=iyr-2000
      if(iulst.gt.0.and.(.not.multi_model))
     *write(iulst,951,iostat=code)i,imnth,idy,
     &ihn,imm,xhm,fo,la1,
     &ala1,ins1,lo1,alo1,iew1,dp2,fd,ndata,m,rmssv,xk2,
     &(std1(i),i=1,3),icd
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

951   format(1x,3i2,1x,2i2,f6.2,a1,i2,f5.2,a1,i4,f5.1,a1,f6.1,a1,i4,i2,
     &f7.2,f6.3,3f5.1,i3)
     
c 10/94: add origin time  error printout
      if(iulst.gt.0.and.nzcount.gt.0.and.(.not.multi_model))
     & write(iulst,'(/'' Origin time error: '',f10.2)'
     &            ,iostat=code)oterr      
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c 3/94: remove screen printout of solution
c      write(*,951)iyr,imnth,idy,ihn,imm,xhm,fo,la1,
c     &ala1,ins1,lo1,alo1,iew1,dp2,fd,ndata,m,rmssv,xk2,
c     &(std1(i),i=1,3),icd

c  calculate changes in rms for changes of test(13) km in lat long and depth
c  the final value of ir (7) is for the solution, ensuring that the correct
c  values of the phases and times are returned to hypocent

c added if statement 1/94 to disable when test(13)=0.0
      if(test(13).gt.0.0)then
       if(iulst.gt.0.and.(.not.multi_model))
     *write(iulst,'(/,'' DRMS Values: d='',f8.2,
     &  '' km'',/)',iostat=code)test(13)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
       dtav=0.0
       do  ir=1,7
         do  j=1,3
           xhd(j)=xh1(j)
         end do
         f=test(13)
         if((ir/2)*2.eq.ir)f=-f
         f1=f
         ind=(ir+1)/2
         if(ir.eq.6.and.xhd(ind).lt..05)f1=0.0
         if(ind.ne.3)f1=atan(f/rearth)
         if(ind.eq.1)f1=f1/abs(cos(xh1(2)))
         if(ind.le.3)xhd(ind)=xhd(ind)+f1
         if(ind.eq.3.and.xhd(ind).lt.0.0)xhd(ind)=0.0

c   if depth < 0 set it to 0
 
c 6/94 changed to allow for fixed origin time
         if(ires.ne.9.and.ires.ne.2.and.ucase(fixor).ne.'F')then
          tph=tph1
         else
          tph=tph0
         endif

c 6/94 changed tpc1 to tpc so minimum residuals don't get overwritten         
         rmss(ir)=rmsv(nphase,st,phase,tp,x0,y0,xhd,ndata,nmoho,
     &   nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc,
     &   dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc1,trphs,
     &   dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,scorr)
c      write(iulst,'(''st'',i3,6f9.3)',iostat=code)ndata,rmss(ir),
c     &  tph1-tph3,
c     & (xhd(i)/degtorad,i=1,2),xhd(3)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c         write(iulst,*,iostat=code)'rmss ',rmss(ir)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
       end do
       dr1='DRMS'
       dr2='pos'

       do i=1,6
        rmss(i)=rmss(i)-rmss(7)
        if(rmss(i).lt.0.0)dr2='neg'
        if(rmss(i).gt.99.99)rmss(i)=99.99
        if(rmss(i).lt.-99.99)rmss(i)=-99.99
       end do
      endif

      do i=1,nphase
        call distaz(y0(i)/degtorad,x0(i)/degtorad,xh1(2)/degtorad,
     &  xh1(1)/degtorad,dedeg,azb,azz)
        delta=rearth*dedeg*degtorad
c
c This part changed by M. Villagran Aug 1997 (temporary solution)
c---------------------------------------------------------------
c

c       calculate azimuths and distances from stations to earthquake
c       azimuth here is relative to the source
c       write(6,*)xh1(2)*180/3.1415926,xh1(1)*180/3.1415926,dekm,
c    *  dedeg,azz,y0(i)*180/3.1415926,x0(i)*180/3.1415926
c       call delaz(xh1(2),xh1(1),dekm,dedeg,azz,y0(i),x0(i))
        call delaz(y0(i),x0(i),dekm,dedeg,azz,xh1(2),xh1(1))

c       write(6,*)xh1(2)*180/3.1415926,xh1(1)*180/3.1415926,dekm,
c    *  dedeg,azz,y0(i)*180/3.1415926,x0(i)*180/3.1415926
c       write(6,*)'--------------------------------------------'
        dlt(i)=dekm

c       az0(i) is calculated relative to the source
c       az0(i)=azz-180.
        az0(i)=azz
        if(az0(i).lt.0.0)az0(i)=360.+az0(i)
c here gets the backazimuth to use it after in hyposub1.for for
c the calculation of the residuals.....
        call delaz(xh1(2),xh1(1),dekm,dedeg,azz,y0(i),x0(i))
        baz0(i)=azz

c---------------------------------------------------------------
c       center residuals if ips(i)<>0. Changed 4/94 for fixed origin case
        if(ips(i).eq.0.and.phase(i)(1:2).ne.'AZ'.and.ires.ne.9
     &  .and.ucase(fixor).ne.'F')then
         dt(i)=dt1(i)!-dtav
        else
         dt(i)=dt1(i)
        endif  
        
c 10/94: put minimum rms data importances back in di
        di(i)=di1(i)        

c        write(iulst,*,iostat=code)az0(i)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c        write(iulst,*,iostat=code)' dt ',dt(i)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
      end do

      tph=tphh
      
c      write(iulst,*,iostat=code)' hy dtav1 ',dtav1
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

      if(test(13).gt.0.0)then
       if(iulst.gt.0.and.(.not.multi_model))
     * write(iulst,1502,iostat=code)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
1502   format(1x,'DRMS:',7x,'lon+d     lon-d     lat+d     lat-d',
     @ 3x,'depth+d   depth-d')
       if(iulst.gt.0.and.(.not.multi_model))
     * write(iulst,1501,iostat=code)dr1,dr2,
     &  (rmss(k),k=1,6)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
1501   format(1x,2a5,1x,6(f6.2,4x))
      endif

      if(iulst.gt.0.and.(.not.multi_model))
     *write(iulst,998,iostat=code)xk1
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
998   format(1x,/,1x,'Resolution matrix: k = ',f10.3//,
     &29x,'Long',5x,'Lat',3x,'Depth')
971   format(21x,'Long',3f8.3,/,22x,'Lat',3f8.3,/,20x,'Depth',3f8.3)
      if(iulst.gt.0.and.(.not.multi_model))
     *write(iulst,971,iostat=code)(resl(1,j),j=1,3),
     &(resl(2,j),j=1,3),(resl(3,j),j=1,3)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
      return
      end

c  ************  travel time consistency check subroutine *****************

      subroutine ttcheck(nphase,isort,dtwt,ips,phase,st,iulst,dataprev,
     &data,xh,x0,y0,iselv,maxelv,dt2,test,tp,nmoho,nconrad,tpc1,
     &xnear,xfar,ip,dt,tph,aninc,trphs,distind,depthlim,iflagd,
     &minflag1,imatch,statchk,ndata,dtw1,dl,tt,xh1,
     &dtdl,dtdh,dddp,phcd,scorr)
     
      implicit none
      save
      include 'hypparm.inc'
      include 'libsei.inc'                    ! Library definitons.
c      include 'param.inc'
      external sei code                       ! Error encoder.
      integer  code                           ! Condition.
      logical  b_flag                         ! Flag it?.
      real dltmin1
      real pi,degtorad,rearth,ph
      real azz,azb,dedeg,delta,depthlim
      real xnear,xfar,dltmin2
      real dltmin3
      integer iulst,ii,i,jj,j,nphase
      integer maxelv,j1,iflagd,minflag1,imatch,nconrad,nmoho
      integer j2,j3,ndata
      character*5 statchk 
      pi=3.141593
      degtorad=pi/180.
      rearth=6378.                         
      
c 10/93: added check that secondary phases do not precede 'P   '
        do ii=1,nphase

           i=isort(ii)
c          write(*,*)st(i),phase(i),ips(i),dtwt(i)

c change 3/94: changed to only check 'L???', 'S   ' and 'P   ' - otherwise tests
c core phases, PP's, etc
c 10/94: changed to exclude azimuths
          if(dtwt(i).gt.0.0.and.ips(i).eq.0.and.(phase(i)(1:4).eq.
     &     'S   '.or.phase(i)(1:1).eq.'L'.and.phase(i)(1:4).ne.'AZ  '
     &     ))then
c            write(iulst,*,iostat=code)st(i),phase(i)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
            statchk=st(i)
            do jj=ii+1,nphase
              j=isort(jj)
              if((dtwt(j).gt.0.0.and.ips(j).eq.0).and.phase(j)(1:4)
     &         .eq.'P   '.and.st(i).eq.st(j))then
c               write(iulst,*,iostat=code)phase(j),tp(j)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
                if(iulst.gt.0.and.(.not.multi_model))then
                  if(dataprev.ne.data(1))then
c                    write(iulst,*,iostat=code)data(1)(1:78)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
                  endif
                  write(iulst,*,iostat=code)' time for ',st(i),
     &            ' phase ',phase(i),
     &            ' cannot precede P phase: weighted out'
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
                endif
                if(dataprev.ne.data(1))then
c                  write(*,*)data(1)(1:78)
                  dataprev=data(1)
                endif
                write(iulst,'('' time for '',a4,'' phase '',a8,
     &           '' cannot precede P phase: weighted out'')')
     &           st(i),phase(i)
                dtwt(i)=0.0
              endif
            end do
          endif
        end do

c---------------------------------------------------------------------
c change 10/93 BRL: added next section to test for bad times
c 5/94 changed this test completely
c  I now calculate arrival time differences between each station and
c  the station closest to it having the same phase. 
c  If the two stations have an arrival time difference > 
c  the travel time between them + test(60), the test fails. To find which 
c  of the two arrivals is bad, I repeat the test with each of the two stations
c  using the stations closest to each of them, but excluding each other.  
c  The results of these two tests are then used to weight either (or both)
c  of the arrivals to zero

        do i=1,nphase

c         set the 'earthquake' to the i-station position,
c         provided it is not a PS or PL difference or azimuth,
c         has zero weight or is blank. The depth origin is left at maxelv
c         for this test
          if(ips(i).eq.0.and.ip(i).ne.9.and.dtwt(i).gt.0.0
     &    .and.phase(i)(1:4).ne.'    '.and.phase(i)(2:2).ne.'c'
     &    .and.phase(i)(2:2).ne.'K'.and.phase(i)(1:1).ne.'p'
     &    .and.phase(1)(1:1).ne.'s'.and.phase(i)(1:4).ne.'AZ  ')then
c            write(iulst,'('' 1'',i8,1x,a4,1x,a8)',iostat=code)i,
c     &      st(i),phase(i)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
            xh(1)=x0(i)
            xh(2)=y0(i)
            xh(3)=float(maxelv-iselv(i))*.001                     
              
c 5/94: changed to find closest station having the same arrival              

c dltmin1 is the distance to the closest station
            dltmin1=1.e32

c          find the closest station with same non-zero weight absolute phase
            j1=0
            iflagd=0
            do j=i+1,nphase

c 4/94: changed this so that all 4 phase letters match
              if(st(i).ne.st(j).and.phase(j).eq.phase(i).and.dt2(j).eq.
     &         0.0.and.ips(j).ne.1.and.ip(j).ne.9)then

c             get distance to this station
                call distaz(y0(j)/degtorad,x0(j)/degtorad,
     &          xh(2)/degtorad,xh(1)/degtorad,dedeg,azz,azb)
                delta=dedeg*degtorad*rearth

c 10/94: don't allow iflagd=1 for local events 
                if(delta.gt.test(57).and.distind.ne.'L')iflagd=1
                
                if(delta.lt.dltmin1)then
                  dltmin1=delta

c             save closest phase index in j1
                  j1=j                                        
                
                endif 
              endif
            end do     

            if(j1.gt.0)then 
c  set dt2(i) to 1 to indicate its been tested
              dt2(i)=1.0                   

c calculate the travel time to the closest station

c calculate minimum travel time for 1st phase letter
              minflag1=1
              imatch=0
c              write(iulst,*,iostat=code)st(i),phase(i),st(j1),
c     &                                  phase(j1),dltmin1
              call trtime(j1,1,st,phase,tp,x0,y0,xh,ndata,
     &        nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,
     &        dtwt,dtw1,tpc1,dl,iselv,maxelv,ip,dt,xfar,xnear,tph,
     &        aninc,trphs,iflagd,minflag1,data,'L',imatch,
     &        depthlim,scorr,ph,dx)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c              write(iulst,'(1x,''1'',a4,1x,a4,1x,a4,3f10.1)'
c     &                   ,iostat=code)
c     &        st(i),st(j1),phase(i),tp(i)-tp(j1),tpc1(j1),dltmin1
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c 6/94: changed to exclude cases where only one phase is PKP or PKiKP
c 9/94: exclude cases where tpc1(j1)=0.0 (no calculated time)
              if(dabs(tp(i)-tp(j1)).gt.tpc1(j1)+test(60)
     &        .and.dtwt(j1).gt.0.0.and.((trphs(j1)(2:2).ne.'K'
     &        .and.trphs(i)(2:2).ne.'K').or.trphs(j1)(2:2).eq.
     &        trphs(i)(2:2)).and.tpc1(j1).ne.0.0)then
              
C           test has failed: find st(j2), the closest station to st(i) 
c          (excluding st(j1)) and st(j3), the closest station to st(j1) 
c          (excluding st(i))
                xh1(1)=x0(j1)
                xh1(2)=y0(j1)
                xh1(3)=float(maxelv-iselv(j1))*.001                     
                dltmin2=1.e32                   
                j2=0                                    
                dltmin3=1.e32
                j3=0
                
                do j=1,nphase
                  if(st(j1).ne.st(j).and.phase(j).eq.phase(j1).and.
     &            dtwt(j).gt.0.0.and.ips(j).ne.1.and.ip(j).ne.9.
     &            and.st(j).ne.st(i).and.dt2(j).ge.0.0)then

c                get distance of st(i) to st(j)
                    call distaz(y0(j)/degtorad,x0(j)/degtorad,
     &              xh(2)/degtorad,xh(1)/degtorad,dedeg,azz,azb)
                    delta=dedeg*degtorad*rearth
                    if(delta.lt.dltmin2)then
                      dltmin2=delta
                      j2=j
                    endif 

c                get distance to st(j1) to st(j)
                    call distaz(y0(j)/degtorad,x0(j)/degtorad,
     &              xh1(2)/degtorad,xh1(1)/degtorad,dedeg,azz,azb)
                    delta=dedeg*degtorad*rearth
                    if(delta.lt.dltmin3)then
                      dltmin3=delta
                      j3=j
                    endif 
                  endif
                end do
                if(j2.gt.0)then

c                 calculate the travel time of st(i) to st(j2)
                  iflagd=0
                  if(delta.gt.test(57).or.distind.eq.'D')iflagd=1
                  minflag1=1
                  imatch=0
c                 write(iulst,*,iostat=code)st(i),phase(i),st(j),
c     &              phase(j),dltmin
                  call trtime(j2,1,st,phase,tp,x0,y0,xh,ndata,
     &            nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,
     &            test,dtwt,dtw1,tpc1,dl,iselv,maxelv,ip,dt,xfar,
     &            xnear,tph,aninc,trphs,iflagd,minflag1,data,'L',
     &            imatch,depthlim,scorr,ph,dx)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c                  write(iulst,'(1x,''2'',a4,1x,a4,1x,a4,3f10.1)'
c     &                       ,iostat=code)
c     &            st(i),st(j2),phase(j2),tp(i)-tp(j2),tpc1(j2),dltmin2
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

c 9/94: exclude case where tpc1(j2)=0.0 and delta>1000 km
                  if(dabs(tp(i)-tp(j2)).gt.tpc1(j2)+test(60)
     &            .and.dtwt(j2).gt.0.0.and.tpc1(j2).ne.0.0
     &            .and.dltmin2.lt.1000.)then
              
C               this test has failed too: the ith arrival is bad              
c               set its weight to 0 
                    write(iulst,*,iostat=code)' ',st(i),' ',phase(i),
     &              ' weighted out:',' inconsistent time:'
                    write(iulst,'(1x,''Arrival time difference from'',
     &              '' station '',a4,/,'' observed:'', f10.2,
     &              '' calculated: '',f10.2,'' delta: '',f10.1)'
     &              ,iostat=code)
     &              st(j2),dabs(tp(j2)-tp(i)),tpc1(j2),dltmin2
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c                   write(*,*)data(1)(1:78)
                    dataprev=data(1)
                    write(iulst,'(a4,1x,a8,'' weighted out:''
     &               ,'' inconsistent time'')')st(i),phase(i)
                    dtwt(i)=0.0
                    dt2(i)=-1.0
                  endif
                endif
                if(j3.gt.0)then

c                 calculate the travel time from st(j1) to st(j3)
                  iflagd=0
                  if(delta.gt.test(57).or.distind.eq.'D')iflagd=1
                  minflag1=1
                  imatch=0
c                 write(iulst,*,iostat=code)st(i),phase(i),st(j),
c     &            phase(j),dltmin
                  call trtime(j3,1,st,phase,tp,x0,y0,xh1,ndata,
     &            nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,
     &            test,dtwt,dtw1,tpc1,dl,iselv,maxelv,ip,dt,xfar,
     &            xnear,tph,aninc,trphs,iflagd,minflag1,data,'L',
     &            imatch,depthlim,scorr,ph,dx)
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c                  write(iulst,'(1x,''3'',a4,1x,a4,1x,a4,3f10.1)'
c     &                       ,iostat=code)
c     &            st(j1),st(j3),phase(j1),tp(j1)-tp(j3),tpc1(j3),dltmin3
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.

                  if(dabs(tp(j1)-tp(j3)).gt.tpc1(j3)+test(60)
     &             .and.dtwt(j3).gt.0.0.and.dltmin3.lt.1000.)then
              
C                  this test has failed too: the j1th arrival is bad              
c                  set its weight to 0 
                    write(iulst,*,iostat=code)' ',st(j1),' ',phase(j1),
     &              ' weighted out:',' inconsistent time:'
                    write(iulst,'(1x,''Arrival time difference from'',
     &              '' station '',a4,/,'' observed:'', f10.2,
     &              '' calculated: '',f10.2,'' delta: '',f10.1)'
     &               ,iostat=code)
     &              st(j3),dabs(tp(j3)-tp(j1)),tpc1(j3),dltmin3
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c                   write(*,*)data(1)(1:78)
                    dataprev=data(1)
                    write(iulst,'(a4,1x,a8,'' weighted out:''
     &               ,'' inconsistent time'')')st(j1),phase(j1)
                    dtwt(j1)=0.0
                    dt2(j1)=-1.0
                  endif
                endif
                if(dt2(i).ge.0.0.and.dt2(j1).ge.0.0.and.dltmin1
     &          .lt.1000.)then

c cannot distinguish bad arrival: weight both to zero
                  write(iulst,*,iostat=code)' ',st(i),' ',phase(i),
     &            ' weighted out:',' inconsistent time:'
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
                  write(iulst,*,iostat=code)' ',st(j1),' ',phase(j1),
     &            ' weighted out:',' inconsistent time:'
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
                  write(iulst,'(1x,''Arrival time difference from'',
     &            '' station '',a4,/,'' observed:'', f10.2,
     &            '' calculated: '',f10.2,'' delta: '',f10.1)'
     &            ,iostat=code)
     &            st(j1),dabs(tp(j1)-tp(i)),tpc1(j1),dltmin1
        call sei code( fort$, code, iulst, b_flag ) ! process the outcome.
c                 write(*,*)data(1)(1:78)
                  dataprev=data(1)
                    write(iulst,'(a4,1x,a8,'' weighted out:''
     &               ,'' inconsistent time'')')st(i),phase(i)
                    write(iulst,'(a4,1x,a8,'' weighted out:''
     &               ,'' inconsistent time'')')st(j1),phase(j1)
                  dtwt(i)=0.0
                  dt2(i)=-1.0
                  dtwt(j1)=0.0
                  dt2(j1)=-1.0
                endif  
              endif
            endif
          endif    
        end do
c       end phase loop ******************************************
      return
      end

c
c  hyp_isc
c
c  Copy of hyp.for that calls iscloc_wrap instead of hypocent
c  A lot of functionality stripped out if it seemed unapplicable.
c
c  iscloc only locates using Jeffreys-Bullen so no model choice.
c
c   updates: 27-10-04 jh : add old location
c
      implicit none
      include 'hypparm.inc'
      include 'seisan.inc'
      include 'seidim.inc'                 ! array dimentions

      include 'libsei.inc'                 ! Library definitions & data defns.
      external sei open,                   ! File open handler.
     &         sei close,                  ! & closure.
     &         sei clen,                   ! String length.
     &         sei code                    ! Error condition handler.
      integer  sei clen                    ! & function.
      integer  code                        ! Condition.
      integer  text_c                      ! Text length.

      integer  iuin                        ! event file
      integer  iustat                      ! STATION0.HYP
      integer  iulst                       ! print.out
      integer  iuphs                       ! hyp.out

      parameter (text_c = 80)              ! & value.
      logical  b_flag                      ! Flag!!
      character chr_text   *(text_c)       ! Text string.

c---name of top directory
      character*60 top_directory
c---original header buffer
      character*80 datsave,data_old ! could they be the same ??
c---flag first says whether to locate and then whether successfuly located
      logical locate
c--- event type, indcator of explosion, indicator of fixing depth  
      character*1 typ,exp
c---indicator if output on screen  
      character*1 yter,yter1
      logical output
c---agency for magnitude  
      character*3 agency
c---directory separator character
      character*1 dchar
c---number of header lines, records, stations in nordic file, help variables
      integer nhead,nrecord,nstat,nfind,k,nphase,i
c---id line indicator
      integer id
C-- hypocenter help variable
      integer init
c-- help varibale
      character*80 text
c-- line counter and max number of line pr page
      integer nline,maxline
c-- save year, month ,day for old location
      integer year,month,day
c-- hour and difference in hours between solutions shifted one day
      integer hour,delhour
c-- abs times for above
      double precision abstim1,abstim2
c-- # phases      
      integer nphs
c-- indicator if program is used in connection with EEV in seisan
      logical use_eev
c-- indicator if seisan data base present
      logical seisan
c--  next for data base operation
      character*10 keys                      ! next choice key
      character*14 starttime,endtime         ! time interval for location
      character*80 basename                  ! data base or file name
      character*80 infile                    ! input file or base name
      character*80 eventfile                 ! single event file name
      integer status,eventno,newmonth,fstart ! 
      integer base                           ! 0: data base, 1: single file

c---minimum number of stations to locate
      integer minstat
c---minimum number of phases to locate  
      integer minphase
c---magnitude Ml coefficients
c      real a,b,c,d  
c---number of arguments and function
       integer nars
       character*80 args(10)
c---used in setting max number of lines per page for screen
      integer lunit
      logical terminal,isatty
      character*10 extension

      integer isindex

      call get_arguments(nars,args)

      call get_env_seisan_extension(extension)

C
C    initialise...
C    =============

      code   = e_ok$                            ! Local condition.
      b_f_debug$ = .false.                      ! Debug to screen/file?
      iuin   = 0                                ! file units.
      iustat = 0                                ! station/model file.
      iulst  = 0                                ! print.out.
      iuphs  = 0                                ! hyp.out.

c                                                           
c   get computer specifics
c
      call dir_char(dchar)         ! dirctory delimiter character

c
c   get seisan defaults
c
      call get_seisan_def

c set max number of lines pr page for screen print out
c modified to allow output to a pipe without expecting
c a reply from the terminal (bjb 2001/02/14)
c Function ISATTY may only be available on Solaris???
      lunit=6
      terminal=isatty(lunit)
      if(terminal) then
         maxline=20
      else
         maxline=1000
      endif

c 
c   get directory structure
c
      call topdir(top_directory)
c
c   check if SEISAN data base is present indicated by the presense of
c   the file station0.hyp in DAT directory
c
      chr_text = top_directory(:seiclen(top_directory)) //
     &           dchar // 'DAT' //dchar                 //
     &           'STATION0.HYP'
c
      call sei open( check$,            ! Check existance.
     &               ' ',               ! No prompt.
     &               chr_text, iuin,   ! File & unnit.
     &               seisan,            ! File exists?.
     &               code )             ! Local condition (n/a).
c
      if( seisan ) then                 ! Multiple files.
      base = 0                          ! General database.
      else                              ! Otherwise only a single file.
      base = 1                          ! Only a single file.
      end if                            !
c
c   check if input of a file as argument
c
      call get_env_event(eventfile)
      if(nars.gt.0) then
         eventfile=args(1)(1:80)
         maxline=1000
      endif
c
c  check if non interactive, then no output
c
      call get_seisan_message(text)

c   find if program will run from within EEV indicated by the presenses of file
c   name in an enviromental variable

      use_eev =  eventfile(1:1)        .ne. ' '    .and.
     &           ichar(eventfile(1:1)) .ne. 0  

C   open data base input single event file and read it
c   set flag for single event nrecord= -1

      if (use_eev) then
         nrecord = -1
         call sei open( old$,            ! Open old file (stop on error).
     &                  ' ',             ! No prompt.
     &                  eventfile, iuin,! File & unit.
     &                  b_flag,          ! File exists? (n/a).
     &                  code )           ! Local condition (n/a).
         call indata(iuin,nstat,nphase,nhead,nrecord,
     &               typ,exp,data,id)
         datsave=data(1)
         call sei close( close$, iuin, code ) ! Close file (stop on error).

         yter = 'Y'                            ! output on screen
         output=.true.

         if (text.eq.'hyp non interactive') then
            yter='N' 
            output = .false.
         endif
         goto 20                               ! jump remaining questions
      endif

c
c   input data base name and time interval
c
      if(seisan) then
         write(*,*) ' Arrival time data input - select one:'
         write(*,*)
         WRITE(*,*) 
     *  '    SEISAN data base or                             :',
     &  'RETURN '
         write(*,*) 
     *  '    Alternative data base, give 1-5 letter code or  :'  
         WRITE(*,*) 
     *  '    Local index file, name must start with index or :'
         WRITE(*,*) 
     *  '    Local data base, write ,, or                    :'
         WRITE(*,*) 
     *  '    Filename for one file, min. 6 chars or with a . : '
      else
         WRITE(*,*) 'Filename for file in NORDIC format     : '
      endif
      write(*,*)

      read(*,'(a)') infile
      basename=infile(1:80)
                       
      write(*,*)
C
c   check if this is a single multiple event file (base=1),
c   general data base (base=0) or local data base, only check if seisan
c   data base is present
C
      if (seisan) then
         starttime=' '
         endtime=' '
         if(basename(1:5).eq.'INDEX'.or.basename(1:5).eq.'index'.
     *   or.basename(1:2).eq.',,') then
            base=0
            goto 2929
         endif
         if(seiclen(basename).lt.6.and.index(basename,'.').eq.0) 
     *   then
            base=0
            goto 2929
         endif
         base = 1                                  ! Single event file
 2929    continue
      endif
C
      if( base.eq.0.and.
     *basename(1:2).ne.',,'.and.basename(1:5).
     *ne.'INDEX'.and.basename(1:5).ne.'index') then 
                 ! only ask time interval for true base
         write(*,'('' Start Time           (YYYYMMDDHHMMSS): '',$)')
         read(*,'(a14)') starttime
         write(*,'('' End Time, RETURN is to end of month:   '',$)')
         read(*,'(a14)') endtime
         write(*,*)
      endif
C
C   check if interactive operation, 
c
      if (yter.ne.'N') then
         write(*,'('' Interactive operation (N/Y=default)'',$)')
         read(*,'(a1)')  yter
      endif
      yter1=' '       
      write(*,*)
      call sei upc( yter )
      if(yter.eq.' ') yter='Y'
      if(yter.eq.'Y') output=.true.
  
c
c   enter here if used with eev
c
  20  continue

C
C   open  output files
C
      call sei open( unknown$,            ! Open print file.
     &               ' ',                 ! No prompt.
     &               'print.out', iulst, ! File & unit.
     &               b_flag,              ! File exists?.
     &               code )               ! Condition (n/a).
c
c   on  sun, old events seem to remain in print.out file, so delete and reopen
c
      call sei close( delete$, iulst, code ) ! Delete it (stop on error).
      call sei open( unknown$,                ! Open print file.
     &               ' ',                     ! No prompt.
     &               'print.out', iulst,     ! File & unit.
     &               b_flag,                  ! File exists?.
     &               code )                   ! Condition (n/a).

      call sei open( unknown$,                ! Open hyp file.
     &               ' ',                     ! No prompt.
     &               'hyp.out', iuphs,       ! File & unit.
     &               b_flag,                  ! File exists?.
     &               code )                   ! Condition (n/a).

c
c 4/94: write input filename to print output....
c
      write( iulst,                               ! Details to print file.
     &       '('' Input File: '',a40,/)',          ! On format.
     &       iostat=code ) basename                ! On condition, the basename.
      call sei code( fort$, code, iulst, b_flag ) ! Process the outcoe.

c
c   if used with eev, jump straight at location
c
      if(use_eev) goto 1000
C
C   open input event file if multiple event single file option has
C   has been selected 

      if(base.eq.1) then
C
         call sei open( old$,            ! Open old file (stop on error).
     &               ' ',             ! No prompt.
     &               infile, iuin,   ! File & unit.
     &               b_flag,          ! File exists? (n/a).
     &               code )           ! Local condition (n/a).
         eventno = 0
      endif

      keys(1:4)='NEXT'    ! start with next event

 50   continue
c
C----------------------------------------------------------------------
C   Point to same, next or another event 
C----------------------------------------------------------------------
C
      if (base.eq.0) then              ! data base event
         call findevin
     *   (basename,starttime,endtime,keys,0,eventno,
     *   eventfile,fstart,newmonth,status)

c
c   check if end of time interval or errors, then
c   close hyp.out and stop
C     
         if(status.gt.0) then
            write(6,*)' STOP WITH STATUS=',status
            GOTO 900   ! stop
         endif
C
C   open data base input single event file and read it
c   set flag for single event nrecord= -1
c
         nrecord=-1
         call sei open( old$,            ! Open old file (stop on error).
     &                  ' ',             ! No prompt.
     &                  eventfile, iuin,! File & unit.
     &                  b_flag,          ! File exists? (n/a).
     &                  code )           ! Local condition (n/a).
         call indata(iuin,nstat,nphase,nhead,nrecord,
     &               typ,exp,data,id)
         datsave=data(1)
         call sei close( close$, iuin, code ) ! Close file (stop on error).
c
      else                             ! single file  multiple event mode
c
         if(keys(1:4).eq.'NEXT') then
            call indata(iuin,nstat,nphase,nhead,nrecord,
     &               typ,exp,data,id)
            datsave=data(1)
            if(nrecord.eq.0) goto 900   ! check for end of file
            eventno=eventno+1
         endif
c
c  selection by number 
c
         if(keys(1:1).eq.'#') keys(1:4)=keys(2:5)
         if(keys(1:1).eq.'1'
     *   .or.keys(1:1).eq.'2'.or.keys(1:1).eq.'3'
     *   .or.keys(1:1).eq.'4'.or.keys(1:1).eq.'5'
     *   .or.keys(1:1).eq.'6'.or.keys(1:1).eq.'7'
     *   .or.keys(1:1).eq.'8'.or.keys(1:1).eq.'9') then
            read(keys(1:4),'(i4)') nfind
            if(keys(4:4).eq.' ') read(keys(1:3),'(i3)') nfind
            if(keys(3:3).eq.' ') read(keys(1:2),'(i2)') nfind
            if(keys(2:2).eq.' ') read(keys(1:1),'(i1)') nfind
            if(nfind.eq.0) goto 75    ! make choice
            if(nfind.eq.eventno) goto 75

            if (nfind.lt.eventno) then
               rewind( iuin, iostat=code )                ! Rewind unit.
               call sei code( fort$, code, iuin, b_flag ) ! Process outcome.
               eventno = 0
               k = nfind
            else
               k = nfind - eventno
            endif

            do i=1,k
               call indata(iuin,nstat,nphase,nhead,nrecord,
     *                     typ,exp,data,id)
               datsave=data(1)
               eventno=eventno+1
               if (nrecord.eq.0) then
                  write(6,*)' no such number ',nfind
                  rewind( iuin, iostat=code )                ! Rewind unit.
                  call sei code( fort$, code, iuin, b_flag ) ! Process outcome.
                  eventno=0
                  keys(1:4)='NEXT'
                  goto 50
               endif
            enddo
        endif
      endif
c
c--------------------------------------------------------------
c  decide what to do next if in interactive mode
c--------------------------------------------------------------
c
 75   continue
      if(yter.eq.'Y') then

         isindex=2
         do while (data(isindex)(80:80) .ne. '4' .and. 
     &             data(isindex)(80:80) .ne. ' ')
            isindex=isindex+1
         enddo
         isindex=isindex-1  
         nphs=nrecord-1-isindex                   
        
         write(6,289) eventno,data(1)(1:22),nphs
 289     format(1x,'#',i5,1x,a22,' NPHS=',i4,3x,'T Q L #XXX ', $)
         read(5,'(a)') keys
         if (keys(1:4) .eq. '    ') keys(1:4)='NEXT'
         if (keys(1:1) .eq. 'Q'.or. keys(1:1) .eq. 'q' ) goto 900
c
c   type event
c
         if (keys(1:1).eq.'t' .or. keys(1:1).eq.'T') then
            write(6,*)
            nline=0
            do i=1,nrecord
               write(6,'(a)')data(i)
               nline=nline+1
               if (nline.gt.maxline) then
                  nline=0
                  write(6,'('' Return to continue'',$)')
                  read(5,'(a)') text
               endif
            enddo
            keys(1:4)='SAME'      ! use same event
            goto 50               ! back for new choice
         endif
c
c   back one event
c
         if (keys(1:1).eq.'b' .or. keys(1:1).eq.'B') then
            keys(1:4)='BACK'
            goto 50
         endif
c
c  scroll in print.out file
c
         if (keys(1:1).eq.',' .or. keys(1:1).eq.'.') then
            call hyp_print(iulst,keys(1:1),maxline)
            keys(1:4)='SAME'
            goto 50 
         endif
C 
C   if location has been chosen go on, else restart in 50
C
         if (keys(1:1).ne.'l' .and. keys(1:1).ne.'L') goto 50
      endif
C
C------------------------------------------------------------------------
c   location start here
C--------------------------------------------------------------------------
C
 1000 continue

c
c   check if disable location has been set on for this event, in which case
c   event is passed on with no modification to hyp.out
c
      if(data(1)(45:45).eq.'*') then
         write(6,*)'Event flagged not to be located'
         keys(1:4)='NEXT'
         goto 31               ! go to outputs
      endif

c
c  check if event has enough phases and stations and if it
c  should be located, if not still try to calculate magnitudes
c      
      if (nphase .lt. minphase .or. nstat .lt. minstat) then  
         write(6,*) 'NPHASE=',nphase,'  NOT LOCATABLE' 
         if (nphase.lt.minphase) write(6,*)' Too few phases'
         if (nstat.lt.minstat) write(6,*) ' Too few stations'

         locate=.false.       ! was not located
         go to 30
      endif

c
c  if type is E or P, fix depth to 0.0 km
c
      if(exp.eq.'P'.or.exp.eq.'E') then
         data(1)(39:44)='  0.0F'
      endif

C
c    locate one event
C
      init=2
      if(yter.eq.'Y') write(6,*)

c
c   if interactive output, position print file at end
c
      if(yter.eq.'Y') call hyp_print(iulst,'e',maxline) 
c
c   clear old parameters
c
      call clear_old(data,nhead,nrecord,agency)

      do i=nhead+1,nrecord
         data(i)(61:70)='          '
c
c   keep distance if coda is there, so that magnitude can be calculated
c   in case not enough data for a location
c
         if (data(i)(30:33).eq.'    ') data(i)(71:75)='     '
         data(i)(76:79)='    '
      enddo
c
c   save year month and day before updating and calculate abs time
c
      read (data(1),'(1x,i4,1x,2i2)') year,month,day
      call  TIMSEC (year,month,day,0,0,0.0,abstim1)
c
c   save old header line
c
      data_old=data(1)
c
c   normal soulution
c
      call iscloc_wrap(iustat,iulst,data,nhead,nrecord,
     &                  agency,test,locate,use_eev)
 
c
c   check if located
c
      if (.not.locate) goto 30

c
c   check if day has changed, if so correct all arrival times by + or -24 hours
c
      read(data(1),'(1x,i4,1x,2i2)') year,month,day
      call  TIMSEC (year,month,day,0,0,0.0,abstim2)

      ! add 10 for posible round off error
      if (dabs(abstim2-abstim1) .gt. 10.0) then  
         delhour=(dabs(abstim1-abstim2)+10.0)/3600
         if (abstim2.gt.abstim1) delhour=-delhour
         write(6,*)' Day has changed, hours added:', delhour
         write(iulst,*,iostat=code)
     &         ' Day has changed, hours added:', delhour
         call sei code( fort$, code, iulst, b_flag ) ! Process the outcoe.

         do i=nhead+1,nrecord-1
            read(data(i)(19:20),'(i2)') hour
            hour=hour+delhour
            write(data(i)(19:20),'(i2)') hour
         enddo
      endif

c
c   print out event on screen 
c
         if (yter .eq. 'Y') then
            call hyp_print(iulst,'p',maxline)
            write(6,*)
         end if

c-----------------------------------------------------------------------
c   enter here if event could not be located to only calculate magnitude
c   or no locate is desired by test 106 set
c-----------------------------------------------------------------------

 30   continue

c
c   clear old magnitudes, except 3.
c
      data(1)(57:72)='                '
      if (data(1)(77:79) .eq. agency) data(1)(72:79)=' '
c
c   in case event not located, clear out old locations etc, however
c   keep 3. magnitude, unless same agency
c   if location is fixed, do not clean out header info
c   if test 106 set, do not clean location or location agency
c
      if (.not.locate) then
         if (data(1)(44:44).ne.'F')data(1)(39:43)   = '     '
         if (data(1)(45:45).ne.'F')data(1)(24:38)   = '               '
         if (data(1)(44:45).ne.'FF') data(1)(46:48) = '   '
         data(1)(49:72)='                        '
      endif

c
c   enter here if no location is set by using flag *
c
 31   continue

c
c  put in agency unless no location done
c
      if (data(1)(45:45) .ne. '*') data(1)(46:48)=agency

c
c   calculate  magnitudes, unless no location flag is set
c
      if(data(1)(45:45).ne.'*') then
         call update_mag(data,nhead,nrecord,agency,test,output)

         !  also update and average spectral information
         call update_spec(data,nrecord,nhead,agency,output)
      endif

c
c   output header line on screen, if not interactive, event number must be there
c
      if (yter .eq. 'Y') then
         write(6,'(a)') data(1)(1:79)
c
         ! write any second header line with additional mags
         do i=2,nhead
            if (data(1)(1:23) .eq. data(i)(1:23) .and. 
     &          data(1)(46:48).eq. data(i)(46:48))
     &          write(6,'(a)') data(i)(1:79)
         enddo
         write(6,'(a,a)') ' OLD:',data_old(6:79)
         write(6,*)
      else
         write(6,2838) eventno,data(1)(1:71)
2838     format(1x,'#',i5,1x,a71)
      endif

c
c   write out to hyp.out
c
      write(iuphs,'(a80)',iostat=code) (data(i),i=1,nrecord)
      call sei code(fort$,code,iuphs,b_flag)

c
c   stop here if using eev
c
      if(use_eev) goto 999 

      if (yter .ne. 'Y') keys='NEXT'
      if (yter .eq. 'Y') keys='SAME'

      data(1)=datsave
      go to 50  
                                      
  900 continue
      
      write(6,*)' print output in file print.out'
      write(6,*)' CAT-file in file hyp.out'

  999 continue

      call sei close( close$+all$, 0, code ) ! Close all files.

      stop
      end                

cccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine hyp_print(unit,action,maxline)
      implicit none
      include 'libsei.inc'
      external sei code
      integer   code          ! Local condition.
      logical   b_flag        ! Flag a situation?.

c
c   scroll forth and back in print.out file
c
      integer unit           ! unit for print.out file
      character*80 text      ! one line of text
      integer maxline        ! number of lines to print
      character*1 action     ! what to do
      integer i,nline

c
c   print solution from station line
c
      if (action .eq. 'p') then
         nline=0
1        continue
         backspace( unit,iostat=code)
         call sei code(fort$,code,unit,b_flag)

         read(unit,'(a)',iostat=code) text 
         call sei code(fort$,code,unit,b_flag)
         if (b_flag) goto 99

         if (text(4:7) .eq. 'date') goto 2
         backspace(unit,iostat=code)
         call sei code(fort$,code,unit,b_flag)
         goto 1
2        continue

c
c  epi line found, write out
c
         write(6,'(a)') text
         nline=nline+1
         read(unit,'(a)',iostat=code) text
         call sei code(fort$,code,unit,b_flag)
         if (b_flag) goto 99
         write(6,'(a)') text
         nline=nline+1

c
c   now go to station lines
c

3        continue
         read(unit,'(a)',iostat=code) text 
         call sei code(fort$,code,unit,b_flag)
         if (b_flag) goto 99
         if(text(2:4).eq.'stn') goto 4
         goto 3

4        continue
         write(6,'(a)') text
         nline=nline+1

5        continue
         read(unit,'(a)',iostat=code)text 
         call sei code(fort$,code,unit,b_flag)
         if (b_flag) goto 99

c
c   check for end of phases
c
         if(text(1:13).eq.'          ') go to 6
c
c   write station lines 
c
         write(6,'(a80)') text 
         nline=nline+1
         if(nline.gt.maxline) then
            nline=0
            write(6,'('' Return to continue, q to end listing '',$)')
            read(5,'(a)') text
            if (text(1:1) .eq. 'q' .or. text(1:1) .eq. 'Q') goto 6
         endif
         goto 5
 6       continue
         return
      endif

c
c   go back one screen
c

      if (action .eq. '.') then
         do i=1,maxline*2
            backspace (unit,iostat=code)
            call sei code(fort$,code,unit,b_flag)
         enddo
         do i=1,maxline
           read(unit,'(a)',iostat=code) text
           call sei code(fort$,code,unit,b_flag)
           if (b_flag) goto 99
           write(6,'(a)') text
         enddo
         return
      endif
c
c  go foreward one screen
c
      if (action .eq. ',') then
         do i=1,maxline
            read(unit,'(a)',iostat=code) text
            call sei code(fort$,code,unit,b_flag)
            if( b_flag ) goto 99
            write(6,'(a)') text
         enddo
         return
       endif
c
c   goto end of file
c
       if (action .eq. 'e') then
12        continue
          read(unit,'(a)',iostat=code) text
          call sei code(fort$,code,unit,b_flag)
          if( b_flag ) goto 99
          goto 12
       endif

 99    continue
       backspace( unit, iostat=code)
       call sei code(fort$,code,unit,b_flag)
 999   continue
       return
       end

cccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine find_file_type(unit,type)
      save
      include 'libsei.inc'
      external sei code
c
      integer   code          ! Local condition.
      logical   b_flag        ! Flag a situation?.

c
c  find if an input file is Nordic (type=1) or index file (type 2) or
c  something else (type = 3)
c
      character*80 text
      integer i,unit,type 

      rewind( unit,iostat=code)
      call sei code(fort$,code,unit,b_flag)
      type=3
c
c   check if nordic file
c
      
c
c  one of the first 2 lines should be a header
c
      do i=1,2
         read(unit,'(a80)',iostat=code) text
         call sei code(fort$,code,unit,b_flag)
         if( b_flag ) goto 10                      ! End of file.
         if((text(22:22).ne.'L'.and.text(22:22).ne.'R'.
     *   and.text(22:22).ne.'D'.and.text(22:22).ne.' ').
     *   or.(text(11:11).ne.' '.or.text(16:16).eq.' '))
     *   type=3
      enddo

c
c   check for index file
c
      rewind( unit,iostat=code)
      call sei code(fort$,code,unit,b_flag)

      read(unit,'(a)',iostat=code) text
      call sei code(fort$,code,unit,b_flag)
      if( b_flag ) goto 10

      do i=1,80
         if((text(i:i+2).eq.'L.S'.or.text(i:i+3).eq.'D.S'.or.
     *      text(i:i+2).eq.'R.S').and.text(6:7).eq.'  ') then
            type=2
            return
         endif
      enddo 

10    continue
      return
      end

C---------------------------------------------------------------------- 
C                                                                       
C RECFIL -- SUBROUTINE:   IIR FILTER DESIGN AND IMPLEMENTATION          
C                                                                       
C  AUTHOR:  DAVE HARRIS                                                 
C                                                                       
C  LAST MODIFIED:  FEBRUARY 13, 1981                                    
c                  dec 5 , 1995 by jh: enable continous filtering by not
c                                      not clearing buffer between calls
c                  sep 98 by jh      : --------- verison 7.0 check ----------
c                                      no change
C 
c    oct 7  98  bmt        :linux changed (*) // (1)                            c                                       
C  ARGUMENTS:                                                           
C  ----------                                                           
C                                                                       
C    DATA           REAL ARRAY CONTAINING SEQUENCE TO BE FILTERED       
C                                                                       
C    NDATA          NUMBER OF SAMPLES IN DATA AND FDATA                 
C                                                                       
C    FDATA          REAL ARRAY CONTAINING FILTERED SEQUENCE             
C                   MAY BE THE SAME ARRAY AS DATA IN CALLING SEQUENCE   
C                                                                       
C    PROTO          CHARACTER*8 VARIABLE, CONTAINS TYPE OF ANALOG       
C                     PROTOTYPE FILTER                                  
C                     '(BU)TTER  ' -- BUTTERWORTH FILTER                
C                     '(BE)SSEL  ' -- BESSEL FILTER                     
C                     'C1        ' -- CHEBYSHEV TYPE I                  
C                     'C2        ' -- CHEBYSHEV TYPE II                 
C                                                                       
C    TRBNDW         TRANSITION BANDWIDTH AS FRACTION OF LOWPASS         
C                   PROTOTYPE FILTER CUTOFF FREQUENCY.  USED            
C                   ONLY BY CHEBYSHEV FILTERS.                          
C                                                                       
C    ATTEN          ATTENUATION FACTOR.  EQUALS RECIPROCAL AMPLITUDE    
C                   REACHED AT STOPBAND EDGE.  USED ONLY BY             
C                   CHEBYSHEV FILTERS.                                  
C                                                                       
C    IORD           ORDER (#POLES) OF ANALOG PROTOTYPE                  
C                   NOT TO EXCEED 10 IN THIS CONFIGURATION.  4 - 5      
C                   SHOULD BE AMPLE.                                    
C                                                                       
C    TYPE           CHARACTER*8 VARIABLE CONTAINING FILTER TYPE         
C                     'LP' -- LOW PASS                                  
C                     'HP' -- HIGH PASS                                 
C                     'BP' -- BAND PASS                                 
C                     'BR' -- BAND REJECT                               
C                                                                       
C    FLO            LOW FREQUENCY CUTOFF OF FILTER (HERTZ)              
C                   IGNORED IF TYPE = 'LP'                              
C                                                                       
C    FHI            HIGH FREQUENCY CUTOFF OF FILTER (HERTZ)             
C                   IGNORED IF TYPE = 'HP'                              
C                                                                       
C    TS             SAMPLING INTERVAL (SECONDS)                         
C                                                                       
C    PASSES           INTEGER VARIABLE CONTAINING THE NUMBER OF PASSES  
C                   1 -- FORWARD FILTERING ONLY                         
C                   2 -- FORWARD AND REVERSE (I.E. ZERO PHASE) FILTERING
c                   If negative 1 or 2, do not clear buffers use with cont. data
C                                                                       
C                                                                       
C  SUBPROGRAMS REFERENCED:  BILIN, BUTTER, WARP, CUTOFF, LPTHP, LPTBP,  
C    BESSEL,CTPOLY,MPOLYS,CHEBI,CHEBII                                  
C                                                                       
      SUBROUTINE RECFIL(DATA, NDATA, FDATA, PROTO, TRBNDW, ATTEN, IORD, 
     +TYPE, FLO, FHI, TS, PASSES)                                       
C                                                                       
        DIMENSION DATA(*), FDATA(*)                                     
        DOUBLE PRECISION A(21), B(21), P(21), Q(21)                     
        DOUBLE PRECISION OUT, DBUF(21), FBUF(21)                        
        CHARACTER*8 TYPE                                                
        CHARACTER*8 PROTO                                               
        INTEGER POINT, ORDER, NDATA, PASSES                             
        REAL*4 WARP                                                     
        logical clear_buf     ! if clear buffer, for cont. data

        if(passes.lt.0) then
          clear_buf=.false.
          passes=-passes
        else
          clear_buf=.true.
        endif
C                                                                       
C  SCALE SAMPLING RATE AND CUTOFF FREQUENCIES                           
C                                                                       
        SCALE=2./TS                                                     
        T=2.                                                            
        FL=FLO/SCALE                                                    
        FH=FHI/SCALE                                                    
C                                                                       
C  GENERATE PROTOTYPE ANALOG FILTER                                     
C                                                                       
        IF (  PROTO(1:2) .EQ. 'BU' ) THEN                               
          CALL BUTTER(P,Q,M,N,IORD)                                     
        ELSE IF ( PROTO(1:2) .EQ. 'BE' ) THEN                           
          CALL BESSEL(P,Q,M,N,IORD)                                     
        ELSE IF ( PROTO(1:2) .EQ. 'C1' ) THEN                           
          OMEGAR=1.+TRBNDW                                              
          TEMP=OMEGAR+SQRT(OMEGAR*OMEGAR-1.)                            
          ALPHA=1.                                                      
          DO    4 I=1, IORD                                             
            ALPHA=ALPHA*TEMP                                            
    4     CONTINUE                                                      
          G=(ALPHA*ALPHA+1.)/(2.*ALPHA)                                 
          EPS=SQRT(ATTEN*ATTEN-1.)/G                                    
          CALL CHEBI(P,Q,M,N,IORD,EPS)                                  
        ELSE IF ( PROTO(1:2) .EQ. 'C2' ) THEN                           
          OMEGAR=1.+TRBNDW                                              
          CALL CHEBII(P,Q,M,N,IORD,ATTEN,OMEGAR)                        
        ELSE                                                            
          WRITE(6,*) '**** RECFIL - PROTO FILTER UNKNOWN ****'          
          RETURN                                                        
        END IF                                                          
C                                                                       
C  TRANSFORM ANALOG PROTOTYPE TO DESIRED ANALOG TYPE                    
C                                                                       
        IF (  TYPE(1:2) .EQ. 'LP' ) THEN                                
          F=WARP(FH,T)                                                  
          CALL CUTOFF(P,Q,M,N,F)                                        
        ELSE IF ( TYPE(1:2) .EQ. 'HP' ) THEN                            
          F=WARP(FL,T)                                                  
          CALL LPTHP(P,Q,M,N)                                           
          CALL CUTOFF(P,Q,M,N,F)                                        
        ELSE IF ( TYPE(1:2) .EQ. 'BP' ) THEN                            
          F1=WARP(FL,T)                                                 
          F2=WARP(FH,T)                                                 
          CALL LPTBP(P,Q,M,N,F1,F2)                                     
        ELSE IF ( TYPE(1:2) .EQ. 'BR' ) THEN                            
          F1=WARP(FL,T)                                                 
          F2=WARP(FH,T)                                                 
          CALL LPTHP(P,Q,M,N)                                           
          CALL LPTBP(P,Q,M,N,F1,F2)                                     
        ELSE                                                            
          WRITE(6,*) '**** RECFIL - FILTER TYPE UNDEFINED ****'         
          RETURN                                                        
        END IF                                                          
C                                                                       
C  BILINEAR TRANSFORMATION TO CONVERT ANALOG FILTER TO DIGITAL FILTER   
C                                                                       
        CALL BILIN(P,Q,M,N,A,B,T)                                       
C                                                                       
C  FILTER DATA - FORWARD DIRECTION                                      
C                                                                       
        ORDER=MAX0(M,N)+1                                               
C                                                                       
C    INITIALIZE BUFFER ARRAYS if not a continous filtering
C            
        if(clear_buf) then                                                           
           DO    5 I=1, 21                                                 
             DBUF(I)=0.                                                    
             FBUF(I)=0.                                                    
    5      CONTINUE          
        endif                                              
C                                                                       
C    INITIALIZE POINTER                                                 
C                                                                       
        POINT=1                                                         
C                                                                       
C    LOOP                                                               
C                                                                       
    6   CONTINUE                                                        
        IF ( POINT .GT. NDATA ) GO TO    7                              
C                                                                       
C      FETCH NEW INPUT DATUM                                            
C                                                                       
          DBUF(1)=DATA(POINT)                                           
C                                                                       
C      CALCULATE NEW OUTPUT POINT                                       
C                                                                       
          OUT=A(1)*DBUF(1)                                              
          DO    8 I=2, ORDER                                            
            OUT=OUT+A(I)*DBUF(I)-B(I)*FBUF(I)                           
    8     CONTINUE                                                      
          FBUF(1)=OUT/B(1)                                              
          FDATA(POINT)=FBUF(1)                                          
C                                                                       
C      SHIFT BUFFERS                                                    
C                                                                       
          DO    9 I=2, ORDER                                            
            K=ORDER+2-I                                                 
            FBUF(K)=FBUF(K-1)                                           
            DBUF(K)=DBUF(K-1)                                           
    9     CONTINUE                                                      
C                                                                       
C      UPDATE POINTER                                                   
C                                                                       
          POINT=POINT+1                                                 
        GO TO    6                                                      
    7   CONTINUE                                                        
C                                                                       
C  FILTER DATA - REVERSE DIRECTION                                      
C                                                                       
        IF (  PASSES .GT. 1 ) THEN                                      
C                                                                       
C      INITIALIZE BUFFER ARRAYS                                         
C                                                                       
          DO   10 I=1, 21                                               
            DBUF(I)=0.                                                  
            FBUF(I)=0.                                                  
   10     CONTINUE                                                      
C                                                                       
C      INITIALIZE POINTER                                               
C                                                                       
          POINT=NDATA                                                   
C                                                                       
C      LOOP                                                             
C                                                                       
   11     CONTINUE                                                      
          IF ( POINT .LT. 1 ) GO TO   12                                
C                                                                       
C        FETCH NEW INPUT DATUM                                          
C                                                                       
            DBUF(1)=FDATA(POINT)                                        
C                                                                       
C        CALCULATE NEW OUTPUT POINT                                     
C                                                                       
            OUT=A(1)*DBUF(1)                                            
            DO   13 I=2, ORDER                                          
              OUT=OUT+A(I)*DBUF(I)-B(I)*FBUF(I)                         
   13       CONTINUE                                                    
            FBUF(1)=OUT/B(1)                                            
            FDATA(POINT)=FBUF(1)                                        
C                                                                       
C        SHIFT BUFFERS                                                  
C                                                                       
            DO   14 I=2, ORDER                                          
              K=ORDER+2-I                                               
              FBUF(K)=FBUF(K-1)                                         
              DBUF(K)=DBUF(K-1)                                         
   14       CONTINUE                                                    
C                                                                       
C        UPDATE POINTER                                                 
C                                                                       
            POINT=POINT-1                                               
          GO TO   11                                                    
   12     CONTINUE                                                      
        END IF                                                          
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C WARP -- FUNCTION, APPLIES TANGENT FREQUENCY WARPING TO COMPENSATE     
C         FOR BILINEAR ANALOG -> DIGITAL TRANSFORMATION                 
C                                                                       
C ARGUMENTS:                                                            
C ----------                                                            
C                                                                       
C      F      ORIGINAL DESIGN FREQUENCY SPECIFICATION (HERTZ)           
C      T      SAMPLING INTERVAL                                         
C                                                                       
C  LAST MODIFIED:  JULY 7, 1980                                         
C                                                                       
      REAL FUNCTION WARP(F,T)                                           
C                                                                       
        TWOPI = 6.2831853                                               
        ANGLE = TWOPI*F*T/2.                                            
        WARP = 2.*TAN(ANGLE)/T                                          
        WARP = WARP/TWOPI                                               
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C  CHEBII -- SUBROUTINE TO COMPUTE CHEBYSHEV TYPE II FILTER             
C            POLYNOMIALS                                                
C                                                                       
C                                                                       
C  AUTHOR:  DAVID HARRIS                                                
C                                                                       
C  LAST MODIFIED:  DECEMBER 22, 1980                                    
C                                                                       
C                                                                       
C  ARGUMENTS:                                                           
C  ----------                                                           
C                                                                       
C      P              ARRAY OF NUMERATOR POLYNOMIAL COEFFICIENTS        
C                                                                       
C      Q              ARRAY OF DENOMINATOR POLYNOMIAL COEFFICIENTS      
C                                                                       
C      M              ORDER OF NUMERATOR POLYNOMIAL                     
C                                                                       
C      N              ORDER OF DENOMINATOR POLYNOMIAL                   
C                                                                       
C      IORD           ORDER OF FILTER (NUMBER OF POLES)                 
C                                                                       
C      A              STOPBAND ATTENUATION FACTOR                       
C                                                                       
C      OMEGAR         CUTOFF FREQUENCY OF STOPBAND                      
C                     PASSBAND CUTOFF IS AT 1.0 HERTZ                   
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND M=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE CHEBII(P,Q,M,N,IORD,A,OMEGAR)                          
C                                                                       
        INTEGER PTYPE(10),HALF                                          
        DOUBLE PRECISION P(*),Q(*)                                      
        COMPLEX ROOTS(10)                                               
        PI=3.14159265                                                   
        HALF=IORD/2                                                     
C                                                                       
C  INTERMEDIATE DESIGN PARAMETERS                                       
C                                                                       
        GAMMA=(A+SQRT(A*A-1.))                                          
        GAMMA=ALOG(GAMMA)/FLOAT(IORD)                                   
        GAMMA=EXP(GAMMA)                                                
        S=.5*(GAMMA-1./GAMMA)                                           
        C=.5*(GAMMA+1./GAMMA)                                           
C                                                                       
C  CALCULATE POLES                                                      
C                                                                       
        NROOTS=0                                                        
        DO   15 I=1, HALF                                               
          PTYPE(I)=0                                                    
          ANGLE=FLOAT(2*I-1)*PI/FLOAT(2*IORD)                           
          ALPHA=-S*SIN(ANGLE)                                           
          BETA=C*COS(ANGLE)                                             
          DENOM=ALPHA*ALPHA+BETA*BETA                                   
          SIGMA=OMEGAR*ALPHA/DENOM                                      
          OMEGA=-OMEGAR*BETA/DENOM                                      
          ROOTS(I)=CMPLX(SIGMA,OMEGA)                                   
          NROOTS=NROOTS+1                                               
   15   CONTINUE                                                        
        IF (  2*HALF .LT. IORD ) THEN                                   
          PTYPE(HALF+1)=1                                               
          ROOTS(HALF+1)=CMPLX(-OMEGAR/S,0.0)                            
          NROOTS=NROOTS+1                                               
        END IF                                                          
C                                                                       
C  DENOMINATOR POLYNOMIAL CONVERSION                                    
C                                                                       
        CALL CTPOLY(NROOTS,ROOTS,PTYPE,Q,N)                             
C                                                                       
C  CALCULATE ZEROS                                                      
C                                                                       
        NROOTS=0                                                        
        DO   16 I=1, HALF                                               
          PTYPE(I)=0                                                    
          ANGLE=FLOAT(2*I-1)*PI/FLOAT(2*IORD)                           
          OMEGA=OMEGAR/COS(ANGLE)                                       
          ROOTS(I)=CMPLX(0.0,OMEGA)                                     
          NROOTS=NROOTS+1                                               
   16   CONTINUE                                                        
C                                                                       
C  NUMERATOR POLYNOMIAL CONVERSION                                      
C                                                                       
        CALL CTPOLY(NROOTS,ROOTS,PTYPE,P,M)                             
C                                                                       
C  NORMALIZE NUMERATOR POLYNOMIAL SO THAT P(0)/Q(0) = 1.                
C                                                                       
        SCALE=Q(1)/P(1)                                                 
        DO   17 I=1, M+1                                                
          P(I)=P(I)*SCALE                                               
   17   CONTINUE                                                        
C                                                                       
C  DONE                                                                 
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C  CHEBI -- SUBROUTINE TO COMPUTE CHEBYSHEV TYPE I FILTER               
C            POLYNOMIALS                                                
C                                                                       
C                                                                       
C  AUTHOR:  DAVID HARRIS                                                
C                                                                       
C  LAST MODIFIED:  DECEMBER 22, 1980                                    
C                                                                       
C                                                                       
C  ARGUMENTS:                                                           
C  ----------                                                           
C                                                                       
C      P              ARRAY OF NUMERATOR POLYNOMIAL COEFFICIENTS        
C                                                                       
C      Q              ARRAY OF DENOMINATOR POLYNOMIAL COEFFICIENTS      
C                                                                       
C      M              ORDER OF NUMERATOR POLYNOMIAL                     
C                                                                       
C      N              ORDER OF DENOMINATOR POLYNOMIAL                   
C                                                                       
C      IORD           ORDER OF FILTER (NUMBER OF POLES)                 
C                                                                       
C      EPS            CHEBYSHEV PARAMETER RELATED TO PASSBAND RIPPLE    
C                                                                       
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND M=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE CHEBI(P,Q,M,N,IORD,EPS)                                
C                                                                       
        INTEGER PTYPE(10),HALF                                          
        DOUBLE PRECISION P(1), Q(1)                                     
        COMPLEX POLE(10)                                                
        PI=3.14159265                                                   
        HALF=IORD/2                                                     
C                                                                       
C  NUMERATOR POLYNOMIAL                                                 
C                                                                       
        P(1)=1.D0                                                       
        DO   18 I=2, IORD+1                                             
          P(I)=0.D0                                                     
   18   CONTINUE                                                        
        M=0                                                             
C                                                                       
C  INTERMEDIATE DESIGN PARAMETERS                                       
C                                                                       
        GAMMA=(1.+SQRT(1.+EPS*EPS))/EPS                                 
        GAMMA=ALOG(GAMMA)/FLOAT(IORD)                                   
        GAMMA=EXP(GAMMA)                                                
        S=.5*(GAMMA-1./GAMMA)                                           
        C=.5*(GAMMA+1./GAMMA)                                           
C                                                                       
C  CALCULATE POLES                                                      
C                                                                       
        NPOLES=0                                                        
        DO   19 I=1, HALF                                               
          PTYPE(I)=0                                                    
          ANGLE=FLOAT(2*I-1)*PI/FLOAT(2*IORD)                           
          SIGMA=-S*SIN(ANGLE)                                           
          OMEGA=C*COS(ANGLE)                                            
          POLE(I)=CMPLX(SIGMA,OMEGA)                                    
          NPOLES=NPOLES+1                                               
   19   CONTINUE                                                        
        IF (  2*HALF .LT. IORD ) THEN                                   
          PTYPE(HALF+1)=1                                               
          POLE(HALF+1)=CMPLX(-S,0.0)                                    
          NPOLES=NPOLES+1                                               
        END IF                                                          
C                                                                       
C  DENOMINATOR POLYNOMIAL CONVERSION                                    
C                                                                       
        CALL CTPOLY(NPOLES,POLE,PTYPE,Q,N)                              
C                                                                       
C  NORMALIZE NUMERATOR POLYNOMIAL SO THAT P(0)/Q(0) = 1.                
C                                                                       
        P(1)=Q(1)                                                       
C                                                                       
C  DONE                                                                 
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C  MPOLYS -- SUBROUTINE TO MULTIPLY TWO POLYNOMIALS                     
C                                                                       
C                                                                       
C  AUTHOR:  DAVE HARRIS                                                 
C                                                                       
C  LAST MODIFIED:  DECEMBER 11, 1980                                    
C                                                                       
C                                                                       
C  ARGUMENTS:                                                           
C  ----------                                                           
C                                                                       
C      P1                ARRAY CONTAINING FIRST POLYNOMIAL              
C                                                                       
C      N1                ORDER OF FIRST POLYNOMIAL                      
C                                                                       
C      P2                ARRAY CONTAINING SECOND POLYNOMIAL             
C                                                                       
C      N2                ORDER OF SECOND POLYNOMIAL                     
C                                                                       
C      Q                 ARRAY CONTAINING PRODUCT POLYNOMIAL            
C                                                                       
C      M                 ORDER OF PRODUCT POLYNOMIAL                    
C                                                                       
C                                                                       
C  NOTE:  POLYNOMIAL COEFFICIENT ARRAYS HAVE LOW ORDER POLYNOMIAL       
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND N=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE MPOLYS(P1,N1,P2,N2,Q,M)                                
        DOUBLE PRECISION P1(*),P2(*),Q(*)                               
C                                                                       
C  COMPUTE ORDER OF NEW POLYNOMIAL                                      
C                                                                       
        M=N1+N2                                                         
C                                                                       
C  NEW POLYNOMIAL FOUND BY CONVOLUTION OF P1 AND P2                     
C                                                                       
        DO   20 I=0, M                                                  
          IP1=I+1                                                       
          Q(IP1)=0.                                                     
          LIM1=MAX0(0,I-N2)                                             
          LIM2=MIN0(I,N1)                                               
          DO   21 J=LIM1, LIM2                                          
            Q(IP1)=Q(IP1)+P1(J+1)*P2(I-J+1)                             
   21     CONTINUE                                                      
   20   CONTINUE                                                        
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C  CTPOLY -- SUBROUTINE TO CONVERT ROOT DESCRIPTION TO POLYNOMIAL       
C            DESCRIPTION                                                
C                                                                       
C                                                                       
C  AUTHOR:  DAVID HARRIS                                                
C                                                                       
C  LAST MODIFIED:  DECEMBER 12, 1980                                    
C                                                                       
C                                                                       
C  ARGUMENTS:                                                           
C  ----------                                                           
C                                                                       
C   NROOTS                 NUMBER OF ROOTS IN DESCRIPTION               
C                                                                       
C   ROOTS                   COMPLEX ARRAY CONTAINING ROOTS OF POLYNOMIAL
C                                                                       
C   RTYPE                  INTEGER ARRAY CONTAINING CODE FOR TYPE OF ROO
C                          0    -- COMPLEX CONJUGATE PAIR               
C                          ]] 0  -- REAL ROOTS REPEATED RTYPE TIMES     
C                                                                       
C   P                      POLYNOMIAL COEFFICIENT ARRAY                 
C                                                                       
C   N                      ORDER OF POLYNOMIAL IN P                     
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND N=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE CTPOLY(NROOTS,ROOTS,RTYPE,P,N)                         
        COMPLEX ROOTS(1)                                                
        INTEGER RTYPE(1)                                                
        DOUBLE PRECISION P(*),C(3),TEMP(21)                             
C                                                                       
C  INITIALIZE POLYNOMIAL                                                
C                                                                       
        N=0                                                             
        DO   22 I=1, NROOTS                                             
          IF (  RTYPE(I) .EQ. 0 ) THEN                                  
            N=N+2                                                       
          ELSE                                                          
            N=N+RTYPE(I)                                                
          END IF                                                        
   22   CONTINUE                                                        
        DO   23 I=1, N+1                                                
          P(I)=0.D0                                                     
   23   CONTINUE                                                        
        P(1)=1.D0                                                       
        N=0                                                             
C                                                                       
C  MULTIPLY OUT SECOND ORDER SECTIONS                                   
C                                                                       
        DO   24 I=1, NROOTS                                             
C                              CONJUGATE PAIR OF ROOTS                  
          IF (  RTYPE(I) .EQ. 0 ) THEN                                  
            C(3)=1.D0                                                   
            C(2)=-2.D0*REAL(ROOTS(I))                                   
            C(1)=REAL(ROOTS(I)*CONJG(ROOTS(I)))                         
            CALL MPOLYS(P,N,C,2,TEMP,NT)                                
            N=NT                                                        
            DO   25 J=1, N+1                                            
              P(J)=TEMP(J)                                              
   25       CONTINUE                                                    
C                              REAL ROOTS                               
          ELSE                                                          
            DO   26 J=1, RTYPE(I)                                       
              C(2)=1.D0                                                 
              C(1)=-REAL(ROOTS(I))                                      
              CALL MPOLYS(P,N,C,1,TEMP,NT)                              
              N=NT                                                      
              DO   27 K=1, N+1                                          
                P(K)=TEMP(K)                                            
   27         CONTINUE                                                  
   26       CONTINUE                                                    
          END IF                                                        
   24   CONTINUE                                                        
C                                                                       
C  BYE                                                                  
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C  BESSEL - SUBROUTINE TO GENERATE BESSEL SYSTEM FUNCTION               
C                                                                       
C  AUTHOR: DAVE HARRIS                                                  
C                                                                       
C  LAST MODIFIED:  DECEMBER 11, 1980                                    
C                                                                       
C  ARGUMENTS:                                                           
C  ----------                                                           
C                                                                       
C      P          NUMERATOR POLYNOMIAL COEFFICIENT ARRAY                
C                                                                       
C      Q          DENOMINATOR ARRAY                                     
C                                                                       
C      M          ORDER OF NUMERATOR POLYNOMIAL                         
C                                                                       
C      N          ORDER OF DENOMINATOR                                  
C                                                                       
C      IORD       DESIRED NUMBER OF POLES                               
C                                                                       
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND M=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE BESSEL(P,Q,M,N,IORD)                                   
        DOUBLE PRECISION P(*),Q(*),TABLE(2,4,8),C1,C2,TEMP(11),C(11)    
C                                                                       
C  FILL TABLE OF BESSEL POLES                                           
C                                                                       
        DO   28 I=1, 8                                                  
          DO   29 J=1, 4                                                
            DO   30 K=1, 2                                              
              TABLE(K,J,I)=0.D0                                         
   30       CONTINUE                                                    
   29     CONTINUE                                                      
   28   CONTINUE                                                        
C                                                                       
C                                                                       
C                                                                       
C                                     FIRST ORDER POLES                 
        TABLE(1,1,1)=-1.D0                                              
C                                                                       
C                                     SECOND ORDER POLES                
        TABLE(1,1,2)=-1.1016013                                         
        TABLE(2,1,2)= 0.6360098                                         
C                                                                       
C                                     THIRD ORDER POLES                 
        TABLE(1,1,3)=-1.0474091                                         
        TABLE(2,1,3)= 0.9992645                                         
C                                                                       
        TABLE(1,2,3)=-1.3226758                                         
C                                                                       
C                                                                       
C                                     FOURTH ORDER POLES                
        TABLE(1,1,4)=-0.9952088                                         
        TABLE(2,1,4)= 1.2571058                                         
C                                                                       
        TABLE(1,2,4)=-1.3700679                                         
        TABLE(2,2,4)= 0.4102497                                         
C                                                                       
C                                                                       
C                                     FIFTH ORDER POLES                 
        TABLE(1,1,5)=-0.9576766                                         
        TABLE(2,1,5)= 1.4711244                                         
C                                                                       
        TABLE(1,2,5)=-1.3808774                                         
        TABLE(2,2,5)= 0.7179096                                         
C                                                                       
        TABLE(1,3,5)=-1.5023160                                         
C                                                                       
C                                                                       
C                                     SIXTH ORDER POLES                 
        TABLE(1,1,6)=-0.9306565                                         
        TABLE(2,1,6)= 1.6618633                                         
C                                                                       
        TABLE(1,2,6)=-1.3818581                                         
        TABLE(2,2,6)= 0.9714719                                         
C                                                                       
        TABLE(1,3,6)=-1.5714904                                         
        TABLE(2,3,6)= 0.3208964                                         
C                                                                       
C                                                                       
C                                     SEVENTH ORDER POLES               
        TABLE(1,1,7)=-0.9098678                                         
        TABLE(2,1,7)= 1.8364514                                         
C                                                                       
        TABLE(1,2,7)=-1.3789032                                         
        TABLE(2,2,7)= 1.1915667                                         
C                                                                       
        TABLE(1,3,7)=-1.6120388                                         
        TABLE(2,3,7)= 0.5892445                                         
C                                                                       
        TABLE(1,4,7)=-1.6843682                                         
C                                                                       
C                                                                       
C                                     EIGHTH ORDER POLES                
        TABLE(1,1,8)=-0.8928710                                         
        TABLE(2,1,8)= 1.9983286                                         
C                                                                       
        TABLE(1,2,8)=-1.3738431                                         
        TABLE(2,2,8)= 1.3883585                                         
C                                                                       
        TABLE(1,3,8)=-1.6369417                                         
        TABLE(2,3,8)= 0.8227968                                         
C                                                                       
        TABLE(1,4,8)=-1.7574108                                         
        TABLE(2,4,8)= 0.2728679                                         
C                                                                       
C  INITIALIZE POLYNOMIALS                                               
C                                                                       
        IHALF=IORD/2                                                    
        IOP=IORD+1                                                      
        DO   31 I=1, IOP                                                
          P(I)=0.D0                                                     
          Q(I)=0.D0                                                     
   31   CONTINUE                                                        
        P(1)=1.D0                                                       
        Q(1)=1.D0                                                       
        M=0                                                             
        N=0                                                             
C                                                                       
C  GENERATE DENOMINATOR POLYNOMIAL BY MULTIPLYING SECOND ORDER SECTIONS 
C                                                                       
        DO   32 I=1, IHALF                                              
          C1=TABLE(1,I,IORD)                                            
          C2=TABLE(2,I,IORD)                                            
          C(3)=1.D0                                                     
          C(2)=-2.D0*C1                                                 
          C(1)=C1*C1+C2*C2                                              
          CALL MPOLYS(Q,N,C,2,TEMP,NT)                                  
          DO   33 J=1, NT+1                                             
            Q(J)=TEMP(J)                                                
   33     CONTINUE                                                      
          N=NT                                                          
   32   CONTINUE                                                        
C                                                                       
C  TEST FOR ODD ORDER FILTER                                            
C                                                                       
        IF (  IHALF*2 .LT. IORD ) THEN                                  
          C1=TABLE(1,IHALF+1,IORD)                                      
          C(2)=1.D0                                                     
          C(1)=-C1                                                      
          CALL MPOLYS(Q,N,C,1,TEMP,NT)                                  
          DO   34 J=1, NT+1                                             
            Q(J)=TEMP(J)                                                
   34     CONTINUE                                                      
          N=NT                                                          
        END IF                                                          
C                                                                       
C  NORMALIZE NUMERATOR POLYNOMIAL SO THAT P(0)/Q(0) = 1.                
C                                                                       
        P(1)=Q(1)                                                       
C                                                                       
C  DONE                                                                 
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C LPTBP -- SUBROUTINE TO TRANSFORM ANALOG LOWPASS FILTER TO             
C          ANALOG BANDPASS FILTER                                       
C                                                                       
C  AUTHOR:  DAVE HARRIS                                                 
C                                                                       
C  LAST MODIFIED:  DECEMBER 11, 1980                                    
C                                                                       
C                                                                       
C ARGUMENTS:                                                            
C ----------                                                            
C                                                                       
C     P       ARRAY CONTAINING NUMERATOR POLYNOMIAL COEFFICIENTS        
C     Q       ARRAY CONTAINING DENOMINATOR POLYNOMIAL COEFFICIENTS      
C     M       ORDER OF NUMERATOR POLYNOMIAL                             
C     N       ORDER OF DENOMINATOR POLYNOMIAL                           
C     F1      LOW FREQUENCY CUTOFF (HERTZ)                              
C     F2      HIGH FREQUENCY CUTOFF (HERTZ)                             
C                                                                       
C  NOTE:  PROTOTYPE ANALOG FILTER SUPPLIED AS INPUT IN P AND Q          
C         POLYNOMIAL ARRAYS IS ASSUMED TO BE DESIGNED TO BE A LOWPASS   
C         FILTER WITH CUTOFF AT ONE HERTZ.  P AND Q CONTAIN THE         
C         MODIFIED FILTER AS OUTPUT.                                    
C                                                                       
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND M=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE LPTBP(P,Q,M,N,F1,F2)                                   
        DOUBLE PRECISION P(*),Q(*),A(21),B(21)                          
        DOUBLE PRECISION TEMPA(21),TEMPB(21),ALPHA,BETA,SCALE           
        PI=3.14159265                                                   
        TWOPI=2.*PI                                                     
        DO   35 I=1, 21                                                 
          A(I)=0.                                                       
          B(I)=0.                                                       
   35   CONTINUE                                                        
        NMAX=MAX0(M,N)                                                  
        ALPHA=TWOPI*TWOPI*F1*F2                                         
        BETA=TWOPI*(F2-F1)                                              
C                                                                       
C INITIALIZE RECURSION                                                  
C                                                                       
        A(1)=P(NMAX+1)                                                  
        B(1)=Q(NMAX+1)                                                  
        SCALE=1.                                                        
C                                                                       
C RECURSION                                                             
C                                                                       
        DO   36 I=1, NMAX                                               
          SCALE=SCALE*BETA                                              
          IP1=I+1                                                       
          DO   37 I1=1, 21                                              
            TEMPA(I1)=0.                                                
            TEMPB(I1)=0.                                                
   37     CONTINUE                                                      
          DO   38 J=1, 2*I-1                                            
            TEMPA(J)=ALPHA*A(J)+TEMPA(J)                                
            TEMPA(J+2)=TEMPA(J+2)+A(J)                                  
            TEMPB(J)=TEMPB(J)+ALPHA*B(J)                                
            TEMPB(J+2)=TEMPB(J+2)+B(J)                                  
   38     CONTINUE                                                      
          TEMPA(IP1)=TEMPA(IP1)+SCALE*P(NMAX+1-I)                       
          TEMPB(IP1)=TEMPB(IP1)+SCALE*Q(NMAX+1-I)                       
          DO   39 J=1, 2*I+1                                            
            A(J)=TEMPA(J)                                               
            B(J)=TEMPB(J)                                               
   39     CONTINUE                                                      
   36   CONTINUE                                                        
C                                                                       
        DO   40 I=1, 21                                                 
          P(I)=A(I)                                                     
          Q(I)=B(I)                                                     
   40   CONTINUE                                                        
        M=NMAX+M                                                        
        N=NMAX+N                                                        
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C LPTHP -- SUBROUTINE TO PERFORM LOWPASS TO HIGHPASS                    
C          TRANSFORMATION ON ANALOG FILTERS                             
C                                                                       
C  AUTHOR:  DAVE HARRIS                                                 
C                                                                       
C  LAST MODIFIED:  DECEMBER 11, 1980                                    
C                                                                       
C                                                                       
C ARGUMENTS:                                                            
C ----------                                                            
C                                                                       
C     P         ARRAY CONTAINING NUMERATOR POLYNOMIAL COEFFICIENTS      
C     Q         ARRAY CONTAINING DENOMINATOR POLYNOMIAL COEFFICIENTS    
C     M         ORDER OF NUMERATOR POLYNOMIAL                           
C     N         ORDER OF DENOMINATOR POLYNOMIAL                         
C                                                                       
C  NOTE:  PROTOTYPE ANALOG FILTER SUPPLIED AS INPUT IN P AND Q          
C         POLYNOMIAL ARRAYS IS ASSUMED TO BE DESIGNED TO BE A LOWPASS   
C         FILTER WITH CUTOFF AT ONE HERTZ.  P AND Q CONTAIN THE         
C         MODIFIED FILTER AS OUTPUT.                                    
C                                                                       
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND M=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
C LAST MODIFIED:  JULY 7, 1980                                          
C                                                                       
C AUTHOR:  DAVID HARRIS                                                 
C                                                                       
      SUBROUTINE LPTHP(P,Q,M,N)                                         
        DOUBLE PRECISION P(*),Q(*),TEMP(21)                             
        NMAX=MAX0(M,N)                                                  
C                                                                       
        DO   41 I=1, NMAX+1                                             
          K=NMAX+2-I                                                    
          TEMP(I)=P(K)                                                  
   41   CONTINUE                                                        
        DO   42 I=1, NMAX+1                                             
          K=NMAX+2-I                                                    
          P(I)=TEMP(I)                                                  
          TEMP(I)=Q(K)                                                  
   42   CONTINUE                                                        
        DO   43 I=1, NMAX+1                                             
          Q(I)=TEMP(I)                                                  
   43   CONTINUE                                                        
        M=NMAX                                                          
        N=NMAX                                                          
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C CUTOFF -- SUBROUTINE TO CHANGE CUTOFF OF ANALOG FILTER                
C                                                                       
C ARGUMENTS:                                                            
C ----------                                                            
C                                                                       
C     P         ARRAY CONTAINING NUMERATOR POLYNOMIAL COEFFICIENTS      
C     Q         ARRAY CONTAINING DENOMINATOR POLYNOMIAL COEFFICIENTS    
C     M         ORDER OF NUMERATOR POLYNOMIAL                           
C     N         ORDER OF DENOMINATOR POLYNOMIAL                         
C     F         NEW CUTOFF FREQUENCY IN HERTZ                           
C                                                                       
C  NOTE:  PROTOTYPE ANALOG FILTER SUPPLIED AS INPUT IN P AND Q          
C         POLYNOMIAL ARRAYS IS ASSUMED TO BE DESIGNED TO BE A LOWPASS   
C         FILTER WITH CUTOFF AT ONE HERTZ.  P AND Q CONTAIN THE         
C         MODIFIED FILTER AS OUTPUT.                                    
C                                                                       
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND M=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE CUTOFF(P,Q,M,N,F)                                      
        DOUBLE PRECISION P(*),Q(*)                                      
        PI=3.14159265                                                   
        TWOPI=2.*PI                                                     
        ANGF=TWOPI*F                                                    
        SCALE=1.                                                        
        NMAX=MAX0(M,N)                                                  
        DO   44 I=2, NMAX+1                                             
          SCALE=SCALE/(ANGF)                                            
          P(I)=P(I)*SCALE                                               
          Q(I)=Q(I)*SCALE                                               
   44   CONTINUE                                                        
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C BUTTER -- SUBROUTINE TO COMPUTE BUTTERWORTH POLYNOMIAL                
C                                                                       
C LAST MODIFIED:  JULY 7, 1980                                          
C                                                                       
C  ARGUMENTS:                                                           
C  ----------                                                           
C      P              NUMERATOR POLYNOMIAL                              
C                                                                       
C      Q              DENOMINATOR POLYNOMIAL                            
C                                                                       
C      M              ORDER OF NUMERATOR POLYNOMIAL                     
C                                                                       
C      N              ORDER OF DENOMINATOR POLYNOMIAL                   
C                                                                       
C      IORD           DESIRED NUMBER OF POLES                           
C                                                                       
C                                                                       
C  NOTE:  NUMERATOR AND DENOMINATOR ARRAYS HAVE LOW ORDER POLYNOMIAL    
C         COEFFICIENTS STORED IN FIRST ELEMENT.  THE NUMBER OF          
C         COEFFICIENTS IS ONE GREATER THAN THE ORDER.  THUS, THE        
C         POLYNOMIAL:                                                   
C                        A(S) = S**2 + 2.*S + 3.                        
C         WILL BE STORED AS:                                            
C                        P(1) = 3.                                      
C                        P(2) = 2.                                      
C                        P(3) = 1.                                      
C         AND M=2.  POLYNOMIAL COEFFICIENT ARRAYS ARE DOUBLE PRECISION. 
C                                                                       
      SUBROUTINE BUTTER(P, Q, M, N, IORD)                               
C                                                                       
        DOUBLE PRECISION P(*), Q(*), TEMP(21), PI, ANGLE                
        INTEGER HALF                                                    
C                                                                       
        PI=3.14159265359                                                
        DO   45 I=1, 21                                                 
          P(I)=0.                                                       
          Q(I)=0.                                                       
   45   CONTINUE                                                        
        P(1)=1.                                                         
        Q(1)=1.                                                         
        M=0                                                             
        N=0                                                             
        HALF=IORD/2                                                     
C                                                                       
C TEST FOR ODD ORDER, AND ADD POLE AT -1                                
C                                                                       
        IF (  2*HALF .LT. IORD ) THEN                                   
          Q(2)=1.                                                       
          N=1                                                           
        END IF                                                          
C                                                                       
        DENOM=2.*FLOAT(IORD)                                            
        DO   46 K=1, HALF                                               
          ANGLE=PI*(.5+FLOAT(2*K-1)/DENOM)                              
          SCALE=-2.*DCOS(ANGLE)                                         
          DO   47 K1=1, 21                                              
            TEMP(K1)=0.                                                 
   47     CONTINUE                                                      
          DO   48 J=1, N+1                                              
            TEMP(J)=TEMP(J)+Q(J)                                        
            TEMP(J+1)=TEMP(J+1)+SCALE*Q(J)                              
            TEMP(J+2)=TEMP(J+2)+Q(J)                                    
   48     CONTINUE                                                      
          N=N+2                                                         
          DO   49 J=1, N+1                                              
            Q(J)=TEMP(J)                                                
   49     CONTINUE                                                      
   46   CONTINUE                                                        
C                                                                       
C  NORMALIZE NUMERATOR POLYNOMIAL SO THAT P(0)/Q(0) = 1.                
C                                                                       
        P(1)=Q(1)                                                       
C                                                                       
      RETURN                                                            
      END                                                               
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C SUBROUTINE BILIN -- BILINEAR TRANSFORMATION FOR GENERATING DIGITAL    
C                     FILTERS FROM ANALOG FILTERS                       
C                                                                       
C ARGUMENTS:                                                            
C ----------                                                            
C                                                                       
C P        ARRAY CONTAINING COEFFICIENTS OF ANALOG FILTER NUMERATOR     
C          POLYNOMIAL                                                   
C Q        ARRAY CONTAINING COEFFICIENTS OF ANALOG FILTER DENOMINATOR   
C          POLYNOMIAL                                                   
C M        ORDER OF ANALOG FILTER NUMERATOR POLYNOMIAL                  
C N        ORDER OF ANALOG FILTER DENOMINATOR POLYNOMIAL                
C A        NUMERATOR POLYNOMIAL OF DIGITAL FILTER                       
C B        DENOMINATOR POLYNOMIAL OF DIGITAL FILTER                     
C T        SAMPLING INTERVAL IN SECONDS                                 
C                                                                       
C COMMENT:  IN ALL ARRAYS, THE CONSTANT COEFFICIENTS OF THE POLYNOMIALS 
C           ARE IN THE FIRST ARRAY ELEMENTS, AND THE REST OCCUR IN      
C           ORDER OF INCREASING POWER.  RECALL THAT A POLYNOMIAL OF     
C           DEGREE N HAS N+1 COEFFICIENTS                               
C                THE RESULTING DIGITAL FILTER POLYNOMIALS               
C           SHOULD BE ASSUMED TO HAVE DEGREE MAX(M,N), ALTHOUGH         
C           SOME COEFFICIENTS MAY BE ZERO.  THIS PROGRAM IS             
C           LIMITED TO FILTERS OF ORDER 20, THOUGH THIS LIMIT           
C           MAY BE RELAXED BY REDIMENSIONING ARRAYS BIN AND             
C           TEMP.                                                       
C                A MODIFIED HORNER SCHEME IS USED TO                    
C           EXPAND THE DIGITAL FILTER POLYNOMIALS.                      
C                                                                       
C AUTHOR:  DAVID HARRIS                                                 
C                                                                       
C LAST MODIFIED:  JULY 2, 1980                                          
C                                                                       
      SUBROUTINE BILIN(P,Q,M,N,A,B,T)                                   
        DOUBLE PRECISION P(*),Q(*),A(*),B(*)                            
        DOUBLE PRECISION BIN(21),TEMP(21),TOP,BOT                       
C                                                                       
        NMAX=MAX0(M,N)                                                  
        DO   50 I=1, NMAX+1                                             
          A(I)=0.                                                       
          B(I)=0.                                                       
   50   CONTINUE                                                        
        DO   51 I=1, 21                                                 
          BIN(I)=0.                                                     
   51   CONTINUE                                                        
C                                                                       
C  INITIALIZE RECURSION FOR BILINEAR TRANSFORM                          
C                                                                       
        A(1)=P(NMAX+1)                                                  
        B(1)=Q(NMAX+1)                                                  
        SCALE=2./T                                                      
        BIN(1)=1.                                                       
C                                                                       
C MAIN RECURSION                                                        
C                                                                       
        DO   52 I=1, NMAX                                               
          IP1=I+1                                                       
C                                                                       
C   COMPUTE BINOMIAL COEFFICIENTS AS PART OF RECURSION                  
C                                                                       
          DO   53 I1=1, 21                                              
            TEMP(I1)=0.                                                 
   53     CONTINUE                                                      
          DO   54 J=2, IP1                                              
            TEMP(J)=BIN(J)+BIN(J-1)                                     
   54     CONTINUE                                                      
          DO   55 J=2, IP1                                              
            BIN(J)=TEMP(J)                                              
   55     CONTINUE                                                      
C                                                                       
C   ADD NEW INCREMENTS TO DIGITAL FILTER POLYNOMIALS                    
C                                                                       
          TOP=P(NMAX+1-I)                                               
          BOT=Q(NMAX+1-I)                                               
          DO   56 J=1, I                                                
            A(J)=SCALE*A(J)                                             
            B(J)=SCALE*B(J)                                             
   56     CONTINUE                                                      
          TEMP(1)=A(1)                                                  
          DO   57 J= 2, IP1                                             
            TEMP(J)=A(J)-A(J-1)                                         
   57     CONTINUE                                                      
          DO   58 J=1, IP1                                              
            A(J)=TEMP(J)+TOP*BIN(J)                                     
   58     CONTINUE                                                      
          TEMP(1)=B(1)                                                  
          DO   59 J=2, IP1                                              
            TEMP(J)=B(J)-B(J-1)                                         
   59     CONTINUE                                                      
          DO   60 J=1, IP1                                              
            B(J)=TEMP(J)+BOT*BIN(J)                                     
   60     CONTINUE                                                      
   52   CONTINUE                                                        
        M=NMAX                                                          
        N=NMAX                                                          
      RETURN                                                            
      END                                                               

c$debug
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  seipitsa
c
c  conversion from SEISAN binary to PITSA ASCII (input and output)
c  and conversion of response information to GSE1 format
c
c  comment june 10,99: This program from Seisan 7 is not anymore invoked
c                      from eev, since GSE is used instead, however this
c                      program might still be useful to generate one 
c                      column ASCII files
c
c  by Lars Ottemoeller Feb 1997
c changes
c   sep 21, 99 lo: modified ascii output and added ascii input,
c                  program now works in both directions
c
c
c  input arguments:
c
c      1: input filename   2: pitsa filesystem name   
c      3: output format (1=pitsa input, 2=pitsa output)  4: response (y/n)
c
c  last changes:
c
c ---------------- SEISAN 7 ----------------
c june 10, 99 lo: modify to use 5 char station code
c                 removed response output
c may 29  02  jh: ascii to seisan did not work on pc due to interal free formatted read
c                 does not work on pc, replaced by reading directly from file, assumes
c                 all data comes at end
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      implicit none
      include  'seidim.inc'                 ! Dimensions.
      include  'libsei.inc'                 ! Library defns.
      integer  write01,                     ! Read/write unit.
     &         code                         ! Condition.
      logical   b_flag                      ! File i/o flag

      real    data (max_sample)             ! the data
      integer idata (max_sample)            ! integer data
      integer            iunit              ! input unit
      integer nchan,nsamp,tsamp,i
      character*80      filehead(max_trace)
      character*1040    tracehead
      character*80 infile                   ! input filename
      character*80 outfile                  ! 
c counter
      integer c,cout
      character*3 number
      character*9 filesystem,system       ! PITSA files
c traceheader info
      real srate                             ! sample rate
      integer year,month,day,hour,min        !time
      real sec
      real lat,long                          ! station location
      integer height                         ! station height
      character*5 station                    ! station name
      character*4 comp                       ! component SEISAN
      integer ind                            ! index
      character*1 resp                       ! response wanted (y/n)
      character*1 overwrite                  ! overwrite responsefile
      integer in                             ! 1 for filenr.lis
      integer filec                          ! counting files of filenr.lis
      integer indf                           ! length of filesystem
c question
      character*80 question,line
c mode 
      character*1 mode
      character*29 mainhead_text 
c-- network code
      character*5 net_code
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)

c 
      logical date_set,rate_set,tsamp_set,station_set,comp_set
c time interval
      double precision cinter(max_trace),cstart(max_trace)


c     common /signal/data,rotate,baz,rot_comp,del_rot !for seisinc
      common /signalx/data

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      overwrite='n'

c get arguments
c      call get_arguments(nars,args)

  1   format(a,$) 


 
      filesystem(9:9)=' '

c      if (nars.eq.0) then
        question=' (1) Seisan binary -> Pitsa ASCII or ' // 
     &      ' (2) Pitsa ASCII -> Seisan binary'
        write(*,'(a)') question
        read(*,'(a)') mode
        if (mode.ne.'1'.and.mode.ne.'2') then
          if (mode.eq.' ') stop
          write(*,*) ' wrong choice!'
          stop
        endif
        filec=0 
 20     continue
        question=' Filename or number, filenr.lis for all'
        call filename(question,infile)

        if (infile(1:3).eq.'EOF') stop
c        if (infile(1:10).eq.'filenr.lis') then
c          write(*,*)
c     &    'PITSA filesystem name (not more than 5 characters) :  '
c        else 
c          write(*,*) 
c     &    'PITSA filesystem name (not more than 8 characters) :  '
c        endif
c        read(*,'(a8)') filesystem(1:8)
c        if (filesystem(1:1).eq.' ') filesystem(1:5)='pitsa'
        filesystem(1:6)='pitsa '
c        indf=index(filesystem,' ')-1
        indf=5
        resp = 'n'
 
      system=filesystem

      in=0
c filenr.lis
      if (infile(1:10).eq.'filenr.lis') then
        in=1
        open(60,file=infile,status='old',err=500)
      endif

 10   continue

      if (in.eq.1) then 
         read(60,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      filec=filec+1
      filesystem=system
      write(filesystem(indf+1:indf+4),'(i3)') filec

      do c=1,indf+3
         if (filesystem(c:c).eq.' ') filesystem(c:c)='0'
      enddo

      write(6,'(1x,a13,a)') ' input file: ',infile
      write(*,*) 

      if (mode.eq.'2') goto 1000

c
c seisan -> ascii
c 

c                  
c    Open input file...  
c    ------------------
c              

      chr_f_access$ = 'direct'            ! Type of file.
      f_recl$=2048                        ! Record length
      call sei open( old$,                      !JAB(BGS)Mar95. Open file.
     &               ' ',                       !JAB(BGS)Mar95. No prompt.
     &               infile,                    !JAB(BGS)Mar95. This filename.
     &               iunit,                     !JAB(BGS)Mar95. On unit.
     &               b_flag,                    !JAB(BGS)Mar95. Exists!!
     &               code )                     !JAB(BGS)Mar95. Condition (n/a).



c
c------- Read file headers ----------
       call seisinc
     * (iunit,0,nchan,0,filehead,tracehead,0.0,0.0)

c      do c=1,max_trace
c        write(*,*) filehead(c)
c      enddo

       do cout=1,nchan
         call seisinc
     *       (iunit,cout,nchan,2,filehead,tracehead,0.0,0.0)
c open file
         write(number,'(i3)') cout
         do c=1,3 
           if (number(c:c).eq.' ') number(c:c)='0'
         enddo
         ind=index(filesystem,' ')-1
         if (ind.lt.0) ind=8
         outfile = filesystem(1:ind) // '.' //number
         write01=50
         open(write01,file=outfile,status='unknown')

         write(*,*) tracehead(1:80)
         write(*,*) 'output file :  ',outfile
         if (resp.eq.'Y'.or.resp.eq.'y') then
           write(*,*) 'writing response in GSE1 format ... '
           call resp_sei2gse(tracehead,'2',overwrite)
         endif

 

c
c read and write header info
c

        read(tracehead(45:50),'(i6)') nsamp
        read(tracehead(37:43),'(f7.2)') srate
        read(tracehead(10:35),'(i3,5x,i2,1x,i2,1x,i2,1x,i2,1x,
     &     f6.3)') year,month,day,hour,min,sec
         year = year + 1900
        read(tracehead(52:75),'(f8.4,1x,f9.4,1x,i5)')
     &           lat,long,height
        station(1:5)=tracehead(1:5)
        comp=tracehead(6:9)

c
c see pitsa manual for format descr. page 5-6
c
          write(write01,'
     &       (a12,i4,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3)')
     &         '#START_TIME ',year,month,day,hour,min,sec
          write(write01,'(a11,f7.2)') '#SAMP_FREQ ',srate
          write(write01,'(a6,i6)') '#NDAT ',nsamp
          write(write01,'(a14,a5)') '#STATION_CODE ',station
          write(write01,'(a17,a4)') '#STATION_CHANNEL ',comp

c write data
         do c=1,nsamp
           idata(c)=data(c)
           write(write01,*) idata(c)
         enddo
         
         close(write01)
      enddo
      call sei close( close$, iunit, code)

      if (in.eq.1) goto 10
      goto 20

500   continue
      goto 9999

1000  continue

c
c ascii -> Seisan
c

c
c read headers     
c

       date_set = .false.
       tsamp_set = .false.
       station_set = .false.
       comp_set = .false.
       rate_set = .false.
       nsamp=1
       open(1,file=infile,status='old')
 222   continue
       read(1,'(a)',end=333,err=333) line
       if (line(1:1).eq.'#') then

         write(*,*) line

         if (line(2:11).eq.'START_TIME') then
           call SEI GET VALUES(6, line, CODE )
            year=ARRAY$(1)
            month=ARRAY$(2)
            day=ARRAY$(3)
            hour=ARRAY$(4)
            min=ARRAY$(5)
            sec=ARRAY$(6)
            date_set = .TRUE.
        elseif (line(2:5).eq.'NDAT') then
           call SEI GET VALUES(1, line, CODE )
           tsamp=ARRAY$(1)
           tsamp_set = .true.
 
        elseif (line(2:13).eq.'STATION_CODE') then
            station=line(15:19)
            station_set = .true.
        

        elseif (line(2:16).eq.'STATION_CHANNEL') then
            comp=line(18:21)
            comp_set = .true.
         elseif (line(2:11).eq.'SAMP_FREQ') then
             call SEI GET VALUES(1, line, CODE )
             srate = ARRAY$(1)
             rate_set = .true.
         endif
         goto 222
       endif
       backspace 1
c
c   read data
c
 223   continue
       read (1,*,end=333) data(nsamp)
       idata(nsamp)=data(nsamp)
       nsamp=nsamp+1
       
       goto 223
 333   continue
       close(1)
       nsamp=nsamp-1

       write(*,*) nsamp,tsamp
       if (nsamp.ne.tsamp) then
         write(*,*) ' number of samples in header does not agree'//
     &        ' with number of samples in file !!!'
       endif

       if (.not.date_set) then
         write(6,*) 'year,month,day,hour,min,sec'
         read(5,*) year,month,day,hour,min,sec
       endif
       if (.not.rate_set) then
         write(6,*)'sample rate'
         read(5,*) srate
       endif
       if (.not.station_set) then
         write(6,*)'station and component, a5'
         read(5,'(a5)') station
       endif
       if (.not.comp_set) then
         write(6,*)'component, a4'
         read(5,'(a4)') comp
       endif
c
c calc start time and window length
c

       call timsec(year,month,day,hour,min,sec,cstart(1))

       cinter(1)=(nsamp-1)/srate
c
c  make file name and main header
c             
         nchan=1

         net_code = station(1:3)
         cbyte(1) = '4'

      call sheads(year,month,day,hour,min,sec,nchan,1,
     *                 net_code,mainhead_text,station,comp,
     *                 nsamp,srate,cbyte,
     *                 outfile,filehead,tracehead)

c         call mfhead(year,month,day,hour,min,sec,cinter,nchan,
c     *   station(1:3),station,comp,cstart,cinter,outfile,filehead)

         outfile = outfile(1:29) // '_' // comp
         do i=30,33
           if (outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo

         write(6,'(a,a)') ' Outfile name: ',outfile(1:60)
c
c  open file
c
         open(2,file=outfile,status='unknown',form='unformatted')
c                                                                               
         do i=1,12
            write(2) filehead(i)
         enddo
            write(2)tracehead                                                     
            write(6,'(1x,a70)') tracehead(1:70)                                   
c
c   check if response curve
c
c            if(tracehead(160:160).eq.'9') write(6,*)
c     *        ' No response file for this channel --------'
c  
c   write data
c
            write(2)(idata(i),i=1,nsamp)
            close(2)
c
c   back for next file
c

            if(in.eq.1) goto 10                                                           
            goto 20 

9999  continue
      close(60)

      stop
      end

c  This program calculates various magnitude relations, is a bit primitive !
c  J Havskov, 1994-95
c-----------------------------------------------------------------------
c
c   updatees
c   aug 23, 95 by jh: also write out all data if converting
c   nov 6           : quick fix to use magnitude in any line for mc regression
c   jan 10  96      : bug in quick fix, now also use agency to select 
c                     magnitude for coda scale
c   feb 28          : bug when searching many header lines
c   oct 30  96      : also do moment, stress drop etc regression
c   mar 25, 97      : fix output -input of agency etc
c ---------------------------------------------------------------------------
c   sep 98 by jh    : ------------   version 7.0 check -----------------
c                     change bad station to 5 chars
c   mar 8     jh    : put maxlik for magnetude correlation
c   sep 23    lo    : put in maxlik a 2nd time
c   dec 5     lo    : add inversion for Ml scale for complete data set
c   mar 2     lo    : add site term for Ml inversion
c   mar 5     jh    : distances to real
c   mar 19          : increase mag field to be able to use negative mags
c   may27           : more spectral parameter selection
c   jun  12         . small text changes
c   june 20 2005 jh : plt to eps
c   dec 2005     jh : disable inversion for ml using all data
c                     max likelihood for coda realtion
c
c   1: Calculation of an mc scale using some selectable m 
c      for calibration events
c   
c   3d regression
c   m = a * log (coda) + b * dist + c
c
c   2d regression
c   m = a * (log (coda) + dist_coff * dist) + c
c   note b = a * dist_coff  where dist_coff is entered
c
c   input is a nordic file where m, coda and dist are given
c   dist is hypocentral distance
c
c------------------------------------------------------------------------
c   2: Calculation of an amplitude attenuation scale using amplitudes 
c      and distances in Nordic file, does not work too well. For each
c      event a,b,c are calcualted using least squares regressian as follows:
c
c      3d regression
c
c      log(amp) = a * log(dist) + b * dist + c
c
c      2d regression
c
c      log(amp)+dist_coff*dist = a * log(dist) + c

c      At the end the average constants a and b are calculated. Hypocentral
c      distance is used.
c------------------------------------------------------------------------
c   3: Calculation of relations between different magnitude scales
c      using already calculated magnitudes in header lines
c      Here one or both can be spectral parameters
c
c-------------------------------------------------------------------------
c   4: Calculation of a converted magntude from one of several input 
c      magnitudes using one of several relations
c
c   mar 22 99 bmt : include winplot.inc
c
c      implicit none
       include 'winplot1.inc'
      include 'seiplot.inc'   ! seisan graphics
      include 'seidim.inc'
      include 'rea.inc'
      real x(20000),y(20000),z(20000)              ! observations each event
      real xx(20000),yy(20000),zz(20000),yy1(20000) ! observations each event
      real mag1(50000),mag2(50000)        ! magnitudes to compare
      character*1 cha(10)                 ! dummy for xy_plot
      character*80 text                   ! general text
      character*80 title                  ! title for plot      
      character*30 xtext,ytext            ! axis title
      character*200 outstring             ! for spectral output
      integer nspec                       ! number of events with spectra
      character*1  make_plot              ! indicator for making plot
      character*80 data(2000)
      integer nrecord,nstat,nhead,id,nphas
      integer icoda
      real dist,amp,av,sd,xm1,xm2
      real max_dist          ! maximum distance
      real min_dist          ! minimum distance
      integer iml            ! number of events for amp atteneuation, 3d
      integer iml1           ! number of events for amp atteneuation, 2d
      integer iamp           ! number of  stations for amp inversion
      character*5 bad_stat(100)  ! bad stations, do not use
      integer nbad,ibad      ! number of bad stations
      real depth             ! hypocentral depth
      integer synt           ! 0: real data, 1: syntetic data
      real noise             ! noise for synthetic amplitude data
      character*1 exp,type
      character*1 mag_type   ! correlation magnitude type for mc correlation
      character*3 mag_type_aga ! tyep of agency to use for mc correlation
      real xm                ! correlation magnitude
      character*4 mag_aga1,mag_aga2 ! magnitude and agency 
      character*4 mag_aga_out       ! ---------------- for output conversion
      character*4 mag_aga_rel(250)   ! ---------------- magnitudes to use in --
      real arel(250),brel(250)        ! magnitude relation coefficients
      integer nrel                    ! number of --------------------- sets
      integer nmag_out                ! number of converted magnitudes out
      real xm_in, xm_out              ! in and output magnitude 
      character*8 inmag               ! magntude and agency used for conversion
      character*80 filename 
      real dist_coff         ! distance coeffcient in 2d regressing, see above
      real dist_ratio        ! distance ratio
      real sigmaa,sigmab,r,sigmay(10000) ! statistical parameters
      real a,b,c             ! see above
      real aa(10000),bb(10000),cc(10000)
      real b_2d_amp(10000)    ! b-values for 2d amplitude relation
      integer istat          ! total number of station observavions
      logical ifin           ! switch for event selection
      integer nmagrel        ! number of events for magnitude comparison
      integer i,k,m          ! counters etc
      integer nline          ! nmber of lines in parameter file
      logical compact        ! true if compact file
      character*1 screenout  ! y for printout
      character*5 spec_stat1,spec_stat2 ! stations to use with spectra
      character*4 spec_comp1,spec_comp2 ! components to use with spectra
      character*1 spec_type1,spec_type2 ! P or S spectrum
      logical  sun,pc,linux
c
c for inversion of Ml
c
      integer max_x,max_y             ! array dimensions for inversion
      parameter (max_y=2000)          ! number of observations
      parameter (max_x=1000)          ! size of model vector
      real data_vector(max_y)         ! amplitude vector
      real kernel_matrix(max_y,max_x) ! kernel matrix
      real model_vector(max_x)        ! model vector
      real mag_vector(max_x)          ! original magnitude
      real cvm(max_x,max_x)           ! covariance matrix
      integer maxs                    ! maximum number of stations
      parameter(maxs=200)
      character*5 stat_name(maxs)     ! list of station names
      integer stat_max                ! maximum number of stations
      integer stat_index(1000)        ! station index
      integer evcnt,datacnt           ! counter for events used in inversion
      real v(max_x,max_x),w(max_y)    ! matrices used with SVD
      real thresh,wmax,tol            ! used when editing the w vector
      integer mp,np                   ! number of cols and rows in matrices

      include 'version.inc'
      include 'winplot2.inc'



c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      synt=0
      istat=0
      nbad=0
      ibad=0
      nrel=0
      iml=0
      nspec=0
      iml1=0
      dist_coff=99.9
      nmagrel=0
      compact=.false.
      nrel=0
      evcnt=0
      datacnt=0
      stat_max=0
     
c
c init arrays
c
      do i=1,max_y
        data_vector(i)=0.
        do j=1,max_x
          if (i.eq.1) model_vector(j)=0.
          kernel_matrix(i,j)=0.
        enddo
      enddo
      do i=1,maxs
        stat_name(i)=' '
        mag_vector(i)=0.
      enddo
      do k=1,1000
        stat_index(k)=0
      enddo

      call computer_type(sun,pc,linux)
c
      write(6,'(a,a)')
     *' Magnitudes and agencies to compare, return for no',
     *          ' comparison,'
      write(6,*) ' can also be spectral parameters'
      write(6,'(a,a)')
     *' The first magnitude ( spectral parameter) will',
     *' be the independent variable'
      write(6,'(a,a)')
     *' If both agencies are blank, agency information is',
     *          ' not used'
      write(6,'(a)')' Abbreviations are:'
      write(6,'(a)')' MOME                log moment'
      write(6,'(a)')' OMEG                log omega0 level'
      write(6,'(a)')' STRE                log stress drop'
      write(6,'(a)')' CORF                log corner frequnecy'
      write(6,'(a)')' RADU                log source radius'
      write(6,'(a)')' ALPA                log spectral decay'
      write(6,*)
      write(6,'(a)')' Example of input format, all UPPER CASE'
      write(6,'(a)')'  x    y'
      write(6,'(a)')' LPDE BBER           2 magnitudes'
      write(6,'(a)')' LPDE MOME           magnitude and log moment'
      write(6,'(a)')
     *' CBER CORF           magnitude and log corner frequency'
      if(pc)read(5,'(a4,1x,a4)') mag_aga1,mag_aga2
      if(sun.or.linux)read(5,'(1x,a4,1x,a4)') mag_aga1,mag_aga2


      spec_comp1=' '
      spec_comp2=' '
      spec_stat1=' '
      spec_stat2=' '
      spec_type1=' '
      spec_type2=' '
c
c   check if station specific paremters whciis possible for
c   spectral parameters
c
      if(mag_aga1(1:4).eq.'STRE'.or.mag_aga1(1:4).eq.'RADU'.or.
     *   mag_aga1(1:4).eq.'ALPA'.or.mag_aga1(1:4).eq.'MOME'.or.
     *   mag_aga1(1:4).eq.'OMEG'.or.mag_aga1(1:4).eq.'W   '.or.
     *   mag_aga1(1:4).eq.'CORF') then
         write(6,*)
     *' For spectral values, also possible to chose channel and P or S'
         write(6,*)'Return to use average spectral values'
         write(6,*)'Write below, P is P, S or blank for no type'
         write(6,'(a)')' STAT COMP P for mag_aga1'
         if(pc)read(5,'(a5,a4,1x,a1)')
     *   spec_stat1,spec_comp1,spec_type1
         if(sun.or.linux)read(5,'(1x,a5,a4,1x,a1)')
     *   spec_stat1,spec_comp1,spec_type1
      endif
c
c   check if station specific paremters which possible for
c   spectral parameters
c
      if(mag_aga2(1:4).eq.'STRE'.or.mag_aga2(1:4).eq.'RADU'.or.
     *   mag_aga2(1:4).eq.'ALPA'.or.mag_aga2(1:4).eq.'MOME'.or.
     *   mag_aga2(1:4).eq.'OMEG'.or.mag_aga2(1:4).eq.'W   '.or. 
     *   mag_aga2(1:4).eq.'CORF') then
         write(6,*)
     *' For spectral values, also possible to chose channel and P or S'
         write(6,*)'Return to use average spectral values'
         write(6,*)'Write below, P is P, S or blank for no type'
         write(6,'(a)')' STAT COMP P for mag_aga2'
         if(pc)read(5,'(a5,a4,1x,a1)')
     *   spec_stat2,spec_comp2,spec_type2
         if(sun.or.linux)read(5,'(1x,a5,a4,1x,a1)')
     *   spec_stat2,spec_comp2,spec_type2
      endif

c
c   get parameter file if there 
c
         i=1
         open(1,file='mag.par',status='old',err=56)
 49      continue
         read(1,'(a)',end=56) data(i)
         i=i+1
         goto 49
 56      continue
         nline=i-1
c
c   search for keywords for parameters if file has one or more lines
c
         if(nline.gt.0) then
c
c   bad stations
c
            do i=1,nline
               if(data(i)(1:12).eq.'BAD STATION'
     *         .and.data(i)(51:55).ne.'     ') then
                  nbad=nbad+1
                  bad_stat(nbad)=data(i)(51:55)
               endif                   
c
c   magnitude and agency of converted magnitude
c
               if(data(i)(1:6).eq.'MAGAGA'
     *         .and.data(i)(51:54).ne.'    ') then
                  mag_aga_out=data(i)(51:54)
               endif                   
c
c   conversion relations
c
               if(data(i)(1:6).eq.'MAGREL'
     *         .and.data(i)(51:54).ne.'    ') then
                  nrel=nrel+1
                  mag_aga_rel(nrel)=data(i)(51:54)
                  read(data(i)(61:80),'(2f10.3)') arel(nrel),brel(nrel)
               endif                   
c
c   print output
c
               if(data(i)(1:9).eq.'SCREENOUT'
     *         .and.data(i)(51:54).ne.'    ') then
                  screenout=data(i)(51:51)
               endif                   
c
c   magnitude relation generation by regression on coda or amplitude
c			   
               if(data(i)(1:11).eq.'MAG_TYP_COF'
     *         .and.data(i)(51:54).ne.'    ') then
                  mag_type=data(i)(51:51)
                  mag_type_aga=data(i)(52:54)
                  read(data(i)(61:70),'(f10.3)' ) dist_coff
               endif                   
            enddo
            write(6,*)' Number of bad stations', nbad
            write(6,*)' Number of magnitude relations to use',nrel
         else
            write(6,*)' No parameter file mag.par given'
            write(6,*)' No new magntudes generated, must be set up in'
     *                  ,' mag.par'
            write(6,*)' No coda or amplitude realtions made'
         endif
         if(dist_coff.ne.99.9) then
            write(6,*)' Will do a magnitude regression',
     *    ' on coda and/or amplitudes if possible'
	     else
            write(6,*)' No magntude regression done on coda',
     *      ' and/or amplitude, see mag.par for setup'
	     endif
         close(1)
c
c   open output files
c
      open(2,file='mag_coda.out',status='unknown')
      open(12,file='mag_coda_ava.out',status='unknown')
      open(3,file='mag_mag.out',status='unknown')
      open(4,file='mag_amp.out',status='unknown')
      open(7,file='mag_new.out',status='unknown')
      open(8,file='mag_newa.out',status='unknown')
      open(9,file='mag_spec.out',status='unknown')
      open(10,file='mag_ml_inv.out',status='unknown')
c
c   loop for reading files --------------------------------------------------
c
 500  continue
      write(6,*)' File name, if no more, return'
      read(5,'(a)') filename
      if(filename(1:5).eq.'     ') then
         if(compact.or.dist_coff.eq.99.9) then
             goto 250  ! magnitude comparison only
         else
             goto 2  ! magnitude relation processing
         endif
      endif
      open(1,file=filename,status='old',err=5005)
      goto 5006
 5005 continue
      write(6,*)' No such file'
      goto 500
 5006 continue
c
c  find which type of input file
c
      call nortype(1,compact)
      if(compact) write(6,*)' Input file is compact'
c
c   loop for reading events
c
  1   continue
c
c   read one event or one header line
c
      if(compact) then
         read(1,'(a)',end=501) data(1)
         nhead=1
         nrecord=1
         goto 502
 501     continue
            close(1)
            goto 500  ! next file
 502     continue
      else
         call indata(1,nstat,nphas,nhead,nrecord,type,exp,data,id)
         data(1)(80:80)='1'
c
c        write(6,*) nhead,nrecord,nphas
         write(6,'(a)') data(1)
         if(nrecord.le.0) then
            close(1)
            goto 500   ! check for end of file
         endif
      endif
c
c   read into rea block
c
      rea_nrecord=nrecord
      rea_nhead=nhead
      call rea_event_in(0,.true.,data,i)

      if(screenout.eq.'Y') write(6,'(a)')data(1)
c
c   print out spectral parameters
c
      outstring=' '
      do i=2,nhead
        if(data(i)(2:13).eq.'SPEC AVERAGE') then
           nspec=nspec+1
           outstring(1:79)=data(1)(1:79)
           outstring(80:80)=' '
           outstring(105:105)=' '
           outstring(106:145)=data(i)(16:55)
        endif
        if(data(i)(46:48).eq.data(1)(46:48)) then   ! second magnitude line
           outstring(81:104)=data(i)(56:79)
        endif
      enddo
      if(outstring(1:10).ne.'          ')
     * write(9,'(a)')  outstring
c
c   look for magnitudes and spectral paramaters to compare
c   will always use last occurence of data. if agency is blank,
c   use any occurence of magnitude type
c
c   spectral parameter is used as magnitude and agency
c
      xm1=-99.0
      xm2=-99.0

c-------------------------------------
c   check if comparison of parameters
c-------------------------------------

      if(mag_aga1.ne.' ') then

c
c-----------------------------------------------------------
c   select two parameters 
c-----------------------------------------------------------
c-------------------
c   parameter 1
c-------------------
c
          if(spec_stat1.ne.' ') then
c
c   spectral parameters, component and type dependent
c
             do i=1,rea_nphase
                if(spec_stat1(1:4).eq.rea_stat(i)(1:4).
     *          and.spec_comp1.eq.
     *          rea_comp(i).and.spec_type1.eq.rea_phase(i)(5:5)) then
                   if(mag_aga1(1:4).eq.'MOME'.and.rea_moment(i).gt.0.0)
     *             xm1=rea_moment(i)
                   if(mag_aga1(1:4).eq.'STRE'.and.rea_sdrop(i).gt.
     *             0.0)  xm1=alog10(rea_sdrop(i))
                   if(mag_aga1(1:4).eq.'OMEG'.and.rea_omega0(i).gt.-10.)
     *             xm1=rea_omega0(i)
                   if(mag_aga1(1:4).eq.'CORF'.and.rea_cornerf(i).gt.0.0)
     *             xm1=alog10(rea_cornerf(i))
                   if(mag_aga1(1:4).eq.'RADU'.and.rea_radius(i).gt.0.0)
     *             xm1=alog10(rea_radius(i))
                   if(mag_aga1(1:4).eq.'ALPA'.and.rea_slope(i).gt.-99.)
     *             xm1=rea_slope(i)
                   if(mag_aga1(1:4).eq.'W   '.and.rea_mw(i).gt.-10.0)
     *             xm1=rea_mw(i)
                endif
             enddo
          else
c
c   average spectral values, not component or type dependent
c
             if(mag_aga1(1:4).eq.'MOME'.and.rea_av_moment.gt.0.0)
     *       xm1=rea_av_moment
             if(mag_aga1(1:4).eq.'STRE'.and.rea_av_sdrop.gt.
     *       0.0)  xm1=alog10(rea_av_sdrop)
             if(mag_aga1(1:4).eq.'OMEG'.and.rea_av_omega0.gt.-10.)
     *       xm1=rea_av_omega0
             if(mag_aga1(1:4).eq.'CORF'.and.rea_av_cornerf.gt.0.0)
     *       xm1=alog10(rea_av_cornerf)
             if(mag_aga1(1:4).eq.'RADU'.and.rea_av_radius.gt.0.0)
     *       xm1=alog10(rea_av_radius)
             if(mag_aga1(1:4).eq.'ALPA'.and.rea_av_slope.gt.-99.)
     *       xm1=rea_av_slope
          endif
             
c
c   magnitudes with type and agency
c
          do i=1,rea_nmag
              if(mag_aga1(1:1).eq.hyp_mag_type_all(i).and.
     *           mag_aga1(2:4).eq.hyp_mag_agency_all(i)(1:3)) then
                 xm1=hyp_mag_all(i)
              endif
          enddo

c-----------------------------------
c   look for 2. parmeter if first ok
c-----------------------------------

       if(xm1.gt.-99.0) then
          if(spec_stat2.ne.' ') then
c
c   spectral parameters, component and type dependent
c
             do i=1,rea_nphase
                if(spec_stat2(1:4).eq.rea_stat(i)(1:4).
     *          and.spec_comp2.eq.
     *          rea_comp(i).and.spec_type2.eq.rea_phase(i)(5:5)) then
                   if(mag_aga2(1:4).eq.'MOME'.and.rea_moment(i).gt.0.0)
     *             xm2=rea_moment(i)
                   if(mag_aga2(1:4).eq.'STRE'.and.rea_sdrop(i).gt.
     *             0.0)  xm2=alog10(rea_sdrop(i))
                   if(mag_aga2(1:4).eq.'OMEG'.and.rea_omega0(i).gt.-10.)
     *             xm2=rea_omega0(i)
                   if(mag_aga2(1:4).eq.'CORF'.and.rea_cornerf(i).gt.0.0)
     *             xm2=alog10(rea_cornerf(i))
                   if(mag_aga2(1:4).eq.'RADU'.and.rea_radius(i).gt.0.0)
     *             xm2=alog10(rea_radius(i))
                   if(mag_aga2(1:4).eq.'ALPA'.and.rea_slope(i).gt.-99.)
     *             xm2=rea_slope(i)
                   if(mag_aga2(1:4).eq.'W   '.and.rea_mw(i).gt.-10.0)
     *             xm2=rea_mw(i)
                endif
             enddo
          else
c
c   average spectral values, not component or type dependent
c
             if(mag_aga2(1:4).eq.'MOME'.and.rea_av_moment.gt.0.0)
     *       xm2=rea_av_moment
             if(mag_aga2(1:4).eq.'STRE'.and.rea_av_sdrop.gt.
     *       0.0)  xm2=alog10(rea_av_sdrop)
             if(mag_aga2(1:4).eq.'OMEG'.and.rea_av_omega0.gt.-10.)
     *       xm2=rea_av_omega0
             if(mag_aga2(1:4).eq.'CORF'.and.rea_av_cornerf.gt.0.0)
     *       xm2=alog10(rea_av_cornerf)
             if(mag_aga2(1:4).eq.'RADU'.and.rea_av_radius.gt.0.0)
     *       xm2=alog10(rea_av_radius)
             if(mag_aga2(1:4).eq.'ALPA'.and.rea_av_slope.gt.-99.)
     *       xm2=rea_av_slope
          endif    
c
c   magnitudes with type and agency
c
          do i=1,rea_nmag
              if(mag_aga2(1:1).eq.hyp_mag_type_all(i).and.
     *           mag_aga2(2:4).eq.hyp_mag_agency_all(i)(1:3)) then
                 xm2=hyp_mag_all(i)
              endif
          enddo
      endif

c-------------------------------------------------------------------
c   case where no agencies are chosen and no specific chnnels either
c-------------------------------------------------------------------

      if(mag_aga1(2:4).eq.'   '.and.mag_aga2(2:4).eq.'   '.
     *and.spec_stat1.eq.' ') then
          do i=1,nhead
           if(data(i)(80:80).eq.'1') then
           if(mag_aga1(1:1).eq.data(i)(60:60))
     *        read(data(i)(56:59),'(f4.1)') xm1
           if(mag_aga1(1:1).eq.data(i)(68:68))
     *        read(data(i)(64:67),'(f4.1)') xm1
           if(mag_aga1(1:1).eq.data(i)(76:76))
     *        read(data(i)(72:75),'(f4.1)') xm1 
           endif
           if(xm1.gt.-99.0) then
               do k=1,nhead
                if(data(k)(80:80).eq.'1') then
                  if(mag_aga2(1:1).eq.data(k)(60:60))
     *               read(data(k)(56:59),'(f4.1)') xm2
                  if(mag_aga2(1:1).eq.data(k)(68:68))
     *               read(data(k)(64:67),'(f4.1)') xm2
                  if(mag_aga2(1:1).eq.data(k)(76:76))
     *               read(data(k)(72:75),'(f4.1)') xm2 
                endif
               enddo
           endif
          enddo
         endif
c
c   if data found, put into array
c
        if(xm1.gt.-99.0.and.xm2.gt.-99.0) then
            nmagrel=nmagrel+1
            mag1(nmagrel)=xm1
            mag2(nmagrel)=xm2
        endif
      endif
C
      read(data(1)(39:43),'(f5.1)') depth
c
c   find if magnitude type is available for magnitude relation, also
c   check for agency. if no agency required, only the magntude type
c   is checked for, else both magnitude type and agency mmust fit
c
      xm=-100.0
     
      do i=1,nhead
        if(i.eq.1.or.data(i)(80:80).eq.'1') then
         if((mag_type_aga.eq.'   '.or.mag_type_aga.eq.data(i)(61:63)).
     *   and.data(i)(60:60).eq.mag_type) read(data(i)(56:59),'(f4.1)')xm
         if((mag_type_aga.eq.'   '.or.mag_type_aga.eq.data(i)(69:71)).
     *   and.data(i)(68:68).eq.mag_type) read(data(i)(64:67),'(f4.1)')xm
         if((mag_type_aga.eq.'   '.or.mag_type_aga.eq.data(i)(77:79)).
     *   and.data(i)(76:76).eq.mag_type) read(data(i)(72:75),'(f4.1)')xm
        endif
      enddo
c
c---------------------------------------------------------------------------
c   do magnitude conversion, look for magnitude with given type and agency,
c   if no agency then use magnitude with same type. The first magntude 
c   found is used
c---------------------------------------------------------------------------
c
      if(nrel.gt.0) then
        do k=1,nrel
          do i=1,nhead
           if(data(i)(80:80).eq.'1') then
           if((mag_aga_rel(k).eq.data(i)(60:63)).or.
     *        (mag_aga_rel(k)(2:4).eq.'   '.and.mag_aga_rel(k)(1:1).eq.
     *        data(i)(60:60))) then
              read(data(i)(56:59),'(f4.1)') xm_in
              xm_out=xm_in*arel(k)+brel(k)
              inmag=data(i)(56:63)
              goto 70
           endif
           if((mag_aga_rel(k).eq.data(i)(68:71)).or.
     *        (mag_aga_rel(k)(2:4).eq.'   '.and.mag_aga_rel(k)(1:1).eq.
     *        data(i)(68:68))) then
              read(data(i)(64:67),'(f4.1)') xm_in
              xm_out=xm_in*arel(k)+brel(k)
              inmag=data(i)(64:71)
              goto 70
           endif
           if((mag_aga_rel(k).eq.data(i)(76:79)).or.
     *        (mag_aga_rel(k)(2:4).eq.'   '.and.mag_aga_rel(k)(1:1).eq.
     *        data(i)(76:76))) then
              read(data(i)(72:75),'(f4.1)') xm_in 
              xm_out=xm_in*arel(k)+brel(k)
              inmag=data(i)(72:79)
              goto 70
           endif
          endif
          enddo
        enddo
        goto 71    ! no magnitude found
 70     continue
        nmag_out=nmag_out+1
c
c  update header, clean out old magntude values and put in just the new,
c  also put magnitude used for conversion in 2. position
c
        data(1)(56:79)='                       '
        data(1)(60:63)=mag_aga_out     ! output type and agency
        write(data(1)(56:59),'(f4.1)') xm_out
        data(1)(64:71)=inmag
        write(7,'(a)') data(1)
        write(8,'(a)') data(1)
        goto 72
 71     continue
        write(8,'(a)') data(1) ! write all data if not written above
 72     continue
      endif
c
c   read amplitudes and coda lengths
c
      iamp=0
      max_dist=0.0
      min_dist=999999.0
c
c   read rest of event if nordic file if not a compact file.
c   if a compact file or no magnitude relation is to be calculated
c   jump this section and go to next event
c
      if(compact.or.dist_coff.eq.99.9) goto 1  
c      if(xm.eq.-100.0) goto 1         ! no magnitude, next event
      m=0                              ! for synthetic data
      do i=nhead+1,nrecord-1
         ifin=.true.
c
c check that station is used 
c
         do k=1,nbad
           if(bad_stat(k).eq.data(i)(2:6)) then
              ifin=.false.
              ibad=ibad+1
              write(6,*)' Station rejected ',bad_stat(k)
           endif
         enddo
         if(ifin) then        ! station is used
            read(data(i)(30:33),'(i4)') icoda
            read(data(i)(71:75),'(f5.0)') dist
            read(data(i)(34:40),'(f8.1)') amp
            dist=sqrt(dist*dist+depth*depth)
c
c  save values
c
           if(icoda.gt.0.and.dist.gt.0.and.xm.ne.-100.0) then
               istat=istat+1
               x(istat)=alog10(float(icoda))
               z(istat)=dist
               y(istat)=xm
c               write(6,*) xm,icoda,dist
            endif
c
c   only use local or regional events for Ml amplitude attenuation
c
            if(amp.gt.0.and.(data(1)(22:22).eq.'L'
     *      .or.data(1)(22:22).eq.'R').and.dist.gt.0.0) then
               iamp=iamp+1
               xx(iamp)=alog10(dist)
               yy(iamp)=alog10(amp)
               zz(iamp)=dist
c
c sort station into list and set index
c
               do k=1,stat_max
                 if (stat_name(k).eq.data(i)(2:6).or.
     &               stat_name(k).eq.data(i)(3:6)) then
                   if (stat_index(iamp).eq.0) stat_index(iamp)=k
                 endif
               enddo
               if (stat_index(iamp).eq.0) then
                 stat_max = stat_max + 1
                 stat_index(iamp) = stat_max
                 if (data(i)(2:2).eq.' ') then
                   stat_name(stat_max) = data(i)(3:6)
                 else
                   stat_name(stat_max) = data(i)(2:6)
                 endif
               endif
c
c  next section is for testing with syntetic data
c
               if(synt.eq.1) then
                  yy(iamp)=-1.0*alog10(dist)-dist_coff*dist+3.0  
                  m=m+1
                  if(m.eq.2) m=0
                  if(m.eq.0) noise=0.04    ! 10 % amplitude changee
                  if(m.eq.1) noise=-0.04
                  yy(iamp)=yy(iamp)+noise
               endif
               yy1(iamp)=yy(iamp)+dist_coff*dist
c               write(6,*) iamp,amp
              if(dist.gt.max_dist) max_dist=dist
              if(dist.lt.min_dist) min_dist=dist
            endif
         endif
      enddo
c
c   invert for amplitude attenuation, use linear distance corrected amp
c   do not use if less than 3 stations and ditance ratio less than 3
c
      if(max_dist.eq.min_dist) then
         dist_ratio=999.9
      else
         dist_ratio=max_dist/(max_dist-min_dist)
      endif
c
c fill data vector and kernel matrix
c
c  disable by putting a large value
c
      if(iamp.gt.20000.and.dist_ratio.lt.3.0.and.evcnt.lt.max_y) then
        evcnt=evcnt+1
        mag_vector(evcnt)=xm1
c       write(*,*) ' event: ',evcnt
        if (evcnt.gt.max_x-4) then
          write(*,*) ' Max number of events exceeded '
          write(6,*) ' No more data used'
          goto 7777
c         stop
        endif
        do i=1,iamp
          datacnt=datacnt+1
          if (datacnt.gt.max_y) then
            write(*,*) ' Max number of readings exceeded '
            write(6,*) ' No more data used'
            goto 7777
c           stop
          endif
          data_vector(datacnt)=yy(i)       ! amplitude
          kernel_matrix(datacnt,1)=xx(i)   ! log10(dist)
          kernel_matrix(datacnt,2)=zz(i)   ! dist
          kernel_matrix(datacnt,3)=1.      ! constant
          kernel_matrix(datacnt,3+stat_index(i))=1. ! station term
          kernel_matrix(datacnt,maxs+3+evcnt)=1. ! event size term
        enddo
 7777   continue
      endif

      if(iamp.gt.2.and.dist_ratio.lt.3.0) then
c
c   first make a 2 D inversion to remove bad values
c
         CALL LINFIT (xx,yy1, SIGMAY, iamp, 0, A, SIGMAA, B, SIGMAB ,R)
         write(4,'(a,2i6,a,i5,a,f6.2,a,f8.2)')
     *  ' Distance range',int(min_dist),int(max_dist),
     *  '  namp=',iamp, '  corr=',r,'  r=',dist_ratio
c
c   save 2d value if reasonable
c
            if(b.gt.-3.and.b.lt.1.0) then
c            if(r.lt.-0.5.and.iamp.gt.2) then
               iml1=iml1+1
               b_2d_amp(iml1)=b
               write(4,'(1x,a,3x,f10.4,20x,a)')
     *         data(1)(1:15),b,' selected for 2 d'
            else
               write(4,'(1x,a,3x,f10.4,20x,a)')
     *         data(1)(1:15),b,' not selected for 2 d'
            endif
c
c   now make 3 D inversion
c
         if(b.lt.2.0.and.b.gt.-10.0) then   ! do not use very bad values
c
            iml=iml+1
            call invxy(iamp,yy,xx,zz,aa(iml),bb(iml),cc(iml))
c
c   again remove very bad values
c
            if(aa(iml).gt.0.or.aa(iml).lt.-3.0) then
               write(4,'(1x,a,3x,3f10.4,a)')
     *         data(1)(1:15),aa(iml),bb(iml),cc(iml),
     *         ' not selected for 3d'
               iml=iml-1
            else
               write(4,'(1x,a,3x,3f10.4,a)')
     *         data(1)(1:15),aa(iml),bb(iml),cc(iml),' selected for 3d'
            endif

         endif
      endif
      goto 1    ! next event
c
c--------------------------------------------------------------
c  all events read, now calculate 
c--------------------------------------------------------------
c
  2   continue
c
c   fix axis notation
c
      if(mag_aga1(1:4).eq.'STRE'.or.mag_aga1(1:4).eq.'RADU'.or.
     *   mag_aga1(1:4).eq.'ALPA'.or.mag_aga1(1:4).eq.'MOME'.or.
     *   mag_aga1(1:4).eq.'OMEG'.or.mag_aga1(1:4).eq.'W   '.or.
     *   mag_aga1(1:4).eq.'CORF'.and.spec_stat1.eq.' ')
     *   spec_stat1='AVARA'
      if(mag_aga2(1:4).eq.'STRE'.or.mag_aga2(1:4).eq.'RADU'.or.
     *   mag_aga2(1:4).eq.'ALPA'.or.mag_aga2(1:4).eq.'MOME'.or.
     *   mag_aga2(1:4).eq.'OMEG'.or.mag_aga2(1:4).eq.'W   '.or. 
     *   mag_aga2(1:4).eq.'CORF'.and.spec_stat2.eq.' ')
     *   spec_stat2='AVARA'
c


c
c do inversion for Ml scale
c
c  disbale by putting evcnt  =0
      evcnt=0
      if (evcnt.gt.1) then
        mp=datacnt+2
        np=evcnt+3+stat_max
c
c add constraint for constant added to source term
c
        data_vector(mp-1)=2.
        kernel_matrix(mp-1,3)=1.
        data_vector(mp)=0.
c
c remove empty columns from kernel matrix
c
        do j=1,evcnt
          do i=1,mp
            kernel_matrix(i,j+3+stat_max)=
     &           kernel_matrix(i,j+3+maxs)
          enddo
        enddo
c
c add constraint for all source terms to sum up to 0
c
        do i=4,3+stat_max
          kernel_matrix(mp,i)=1
        enddo

c
c write out lin equations
c
        do i=1,mp
          write(23,*) data_vector(i),' = ',(kernel_matrix(i,j),j=1,np)
        enddo
        call svdcmpx(kernel_matrix,mp,np,max_y,max_x,w,v)
c
c edit w, remove small values
c
         wmax=0.
         do j=1,tol
           if(w(j).gt.wmax)wmax=w(j)
         enddo
         thresh=tol*wmax
         do j=1,xdim
           if (w(j).lt.thresh)w(j)=0.
         enddo

c
c call svbksb
c
         call svbksbx(kernel_matrix,w,v,mp,np,max_y,max_x,
     *      data_vector,model_vector)

c
c call svdvar to get variance
c
         call svdvar(v,np,max_x,w,cvm,max_x)

c          c=-3.-alog10(454.)-model_vector(1)*alog10(100.)-
c     &           model_vector(2)*100.
c     endif

      write(10,'(a,f12.8,a,f12.8)') ' a = ',model_vector(1),
     &      ' +/- ',sqrt(cvm(1,1))
      write(10,'(a,f12.8,a,f12.8)') ' b = ',model_vector(2),
     &      ' +/- ',sqrt(cvm(2,2))
      write(10,'(a,f12.8,a,f12.8)') ' c = ',model_vector(3),
     &      ' +/- ',sqrt(cvm(3,3))
      do i=1,stat_max
        write(10,'(a,i3,a,f5.2,a,f6.3)')
     &     ' Station # ',i,' '//stat_name(i)//' ',
     &     model_vector(i+3), 
     &     ' +/- ',sqrt(cvm(i+3,i+3))
      enddo
      do i=1,evcnt
        write(10,'(a,i3,a,f5.2,a,f6.3,a,f4.1)') 
     &     ' Event # ',i,' Ml= ',model_vector(i+3+stat_max),
     &     ' +/- ',sqrt(cvm(i+3+stat_max,i+3+stat_max)),
     &     ' M orig = ',mag_vector(i)
      enddo
      endif
      close(10)

      write(6,*)'Number of points for 3d amplitude relation',iml
      if(iml.gt.1) then
c         write(6,*)'Number of events for ml ',iml
         write(6,*)'Average a for ml'
         call SDV(iml,aa,AV,SD)
         write(6,*) av,sd
         call SDV(iml,bb,AV,SD)
         write(6,*)'Average b for ml'
         write(6,*) av,sd
      else
         write(6,*) 'Too few points for 3d amplitude relation'
      endif
      write(6,*)'Number of points for 2d amplitude relation',iml1
      if(iml1.gt.1) then
c         write(6,*)'Number of events for ml ',iml1
         call SDV(iml1,b_2d_amp,AV,SD)
         write(6,*)'Average a for ml'
         write(6,*) av,sd
      else
         write(6,*) 'Too few points for 2d amplitude relation'
      endif
c
      if(mag_type.eq.' ') goto 250    ! no Mc calculation
      write(6,*)
      write(6,*)' Number of data points to use for mc',istat
      write(6,*)' Number of data points rejected', ibad
      write(6,*)
      if(istat.lt.3) then
         write(6,*)' Too few points for coda relation'
         goto 250
      endif
c
      write(6,*)' Inversion for 3 parameters'
c     
      call invxy(istat,y,x,z,a,b,c)
      write(6,*)' Coda term',a
      write(6,*)' Distance term',b
      write(6,*)' Constant', c 
c
c   do 2d inverison
c
      write(6,*)
      write(6,*)' Inversion with fixed distance term',dist_coff
      do i=1,istat
        x(i)=x(i)+dist_coff*z(i)
        write(2,*) x(i),y(i)      ! write out for plotting
      enddo
      CALL LINFIT (X, Y, SIGMAY, istat, 0, A, SIGMAA, B, SIGMAB ,R)
      write(6,*)' Coda term, least squares',b,sigmab
      write(6,*)' Constant, least squares', a,sigmaa 
      write(6,*)' Correlation coefficient, least squares ', r
      call maxlik(x,y,istat,a,b,sigmaa,sigmab)
      write(6,*)
      write(6,*)' Coda term, max likelihood',b,sigmab
      write(6,*)' Constant, max likelihood', a,sigmaa
c
c   use average magnitudes
c
      do i=1,istat
            xx(i)=0
            yy(i)=0
            zz(i)=0
      enddo
      n=0
      do i=1,istat
         if(y(i).gt.0.0) then
            k=y(i)*10
            yy(k)=k/10.0
            xx(k)=xx(k)+x(i)
            zz(k)=zz(k)+1
c           write(17,*) i,k,x(i),xx(k),y(i),yy(k),zz(k)
         endif
      enddo
      do i=1,100
         if(zz(i).gt.0) then
           n=n+1
c          write(17,*) n,xx(i),yy(i),zz(i)
           xx(n)=xx(i)/zz(i)
           yy(n)=yy(i)
         endif
      enddo
      write(6,*)
      write(6,*)' Number of avaraged magnitudes',n
      write(6,*)' Now using averaged magnitudes'

      do i=1,n
        x(i)=xx(i)
        y(i)=yy(i)
        write(12,*) x(i),y(i)      ! write out for plotting
      enddo
      CALL LINFIT (X, Y, SIGMAY, n, 0, A, SIGMAA, B, SIGMAB ,R)
      write(6,*)' Coda term, least squares',b,sigmab
      write(6,*)' Constant, least squares', a,sigmaa
      write(6,*)' Correlation coefficient, least squares ', r
      call maxlik(x,y,n,a,b,sigmaa,sigmab)
      write(6,*)
      write(6,*)' Coda term, max likelihood',b,sigmab
      write(6,*)' Constant, max likelihood', a,sigmaa
c


c
c   enter here if a compact file is used
c
 250  continue

c------------------------------------------
c  magnitude/spectral parameter comparison
c------------------------------------------

      if(nmagrel.gt.1) then
         write(6,*)' Number of points for magnitude and or ',
     *   'spectral parameter comparison'
     *               ,nmagrel

c
c   call to linfit only to get correlation 
c

         CALL LINFIT (mag1, mag2, SIGMAY, nmagrel, 0, 
     *   A,SIGMAA, B, SIGMAB ,R)
         write(6,'(2x,a,a,a,f6.3,a,a,a,f7.3)')
     *   'Least squares:      ',mag_aga2,' = ',b,' * ',mag_aga1,' + ',a

c
c   maximum likelihood
c
         call maxlik(mag1,mag2,nmagrel,a,b,sigmaa,sigmab)

         write(6,'(2x,a,a,a,f6.3,a,a,a,f7.3)')
     *   'Maximum likelihood: ',mag_aga2,' = ',b,' * ',mag_aga1,' + ',a
         write(6,*) 
         write(6,*)' Slope', b,sigmab
         write(6,*)' Constant', a,sigmaa
         write(6,*)' Correlation ',r
         call SDV(nmagrel,mag1,AV,SD)
         write(6,'(1x,a,1x,a,1x,2f8.2)')' Average par1(x): ',mag_aga1,av,sd
         call SDV(nmagrel,mag2,AV,SD)
         write(6,'(1x,a,1x,a,1x,2f8.2)')' Average par2(y): ',mag_aga2,av,sd
         do i=1,nmagrel
           write(3,*) mag1(i),mag2(i)
         enddo
c
         write(6,*) ' Plot relation (y/n)'
         read(5,'(a)') make_plot
         if(make_plot.eq.'y'.or.make_plot.eq.'Y') then
    
c
c  set defaults for output on tek screen and one hardcopy file
c
           open(65,file='mag.eps',status='unknown')
           plotunit=65
           plotoption=1
           hctype=1
           wsize=60
c
c   open plotter
c
           call open_display 
c
c set some postscipt scalings
c
           write(65,*) ' 1.0 0.55 scale'

           write(title,'(a,f7.3,a,f7.3)')
     *     'Maximum likelihood relation: y = ',b,' * x + ',a

c           write(title,'(a,f7.3,a,f7.3)')
c     *     'Least squares relation: y = ',b,' * x + ',a
           xtext='             '
     *     //mag_aga1//' '//spec_stat1//' '//spec_comp1//' '//spec_type1
           ytext='             '
     *     //mag_aga2//' '//spec_stat2//' '//spec_comp2//' '//spec_type2
c
c   plot points
c
           call xy_plot
     *     (1,nmagrel,mag1,mag2,title,xtext,ytext,
     *     600.0,600.0,100.0,100.0,1,1,20.0,
     *     0,cha,i,x,y)
c
c  plot line
c
           call xy_plot_line(b,a,100.0,100.0)
           text='Push any key to stop'
           call  tchars(text,20,750.0,700.0)
c
c  call up cursxor so plots remains
c
495        continue
           call xscursr(i,x(1),y(1))
           if (char(i).eq.'#') goto 495  ! lot 01/07/2003

c
c   close postscript
c
           call close_post
c
c   close output plot file
c 
c         call sei close(close$,write02,code)
           close(65)
c
c   close display and back to alpha screen
c
          call clear_to_alpha
          write(6,*)' Plot file is mag.eps'
        endif

         write(6,*)
         write(6,*) 

     * 'File with mag and or spectral comparison values is mag_mag.out'
      else
         write(6,*) 'No values for comparison *************'
      endif
      write(6,*)
      if(dist_coff.ne.99.9.and.(.not.compact)) then
	     write(6,*)
     *           'File with coda scale values is mag_coda.out'
             write(6,*)
     *           'File with avaraged coda values is mag_coda_ava,out'
	     write(6,*)'File with individual Ml a and b is mag_amp.out'
      endif
      write(6,*)'Number of converted magnitudes',nmag_out
      if(nmag_out.gt.0) then
      write(6,*)
     *'File with only converted magnitudes is mag_new.out'
      write(6,*)
     *'File with all magnitudes is mag_newa.out'
      endif
      if(nspec.gt.0) then
         write(6,*)' Number of events with spectra', nspec
         write(6,*)' Spectral parameters in file mag_spec.out'
      endif
      if(pc) then
         write(6,*) ' Return to stop'
         read(5,'(a)') i
      endif
      stop
      end

C
C  SUBROUTINE LINFIT
C
C  PURPOSE
C   MAKE A LEAST-SQUARES FIT TO DATA WITH A STRAIGHT LINE
C       Y = A + B*X
C
C  USAGE
C    CALL LINFIT (X, Y, SIGMAY, NPTS, MODE, A, SIGMAA, B, SIGMAB ,R)
C
C  DESCRIPTION OF PARAMETERS
C       X       - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE
C       Y       - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C       SIGMAY  - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
C       NPTS    - NUMBER OF PAIRS OF DATA POINTS
C       MODE    - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C                 +1 (INSTRUMENTAL) WEIGHT(I)=1./SIGMAY(I)**2
C                  0 (NO WEIGHTING) WEIGHT(I)=1.
C                 -1 (STATISTICAL)  WEIGHT(I)=1./Y(I)
C       A       - Y INTERCEPT OF FITTED STRAIGHT LINE
C       SIGMAA  - STANDARD DEVIATION OF A
C       B       - SLOPE OF FITTED STRAIGHT LINE
C       SIBMAB  - STANDARD DEVIATION OF B
C       R       - LINEAR CORRELATION COEFFICIENT
C
C  SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C    NONE
C
C  MODIFICATIONS FOR FORTRAN II
C    OMIT DOUBLE PRECISION SPECIFICATIONS
C    CHANGE DSQRT TO SQRTF IN STATEMENTS 67,68, AND 71

      subroutine linfit(x,y,sigmay,npts,mode,a,sigmaa,b,sigmab,r)
      dimension x(1),y(1),sigmay(1)
c
c   accumulate weighed sums
c
 11   sum=0.0
      sumx=0.0
      sumy=0.0
      sumx2=0.0
      sumxy=0.0
      sumy2=0.0
 21   continue
      do 50 i=1,npts
        x1=x(i)
        y1=y(i)
        if(mode) 31,36,38
 31     if(y1) 34,36,32
 32     weight=1.0/y1
        go to 41
 34     weight=1.0/(-y1)
        go to 41
 36     weight=1.0
        go to 41
 38     weight=1.0/sigmay(i)**2
 41     sum=sum+weight
        sumx=sumx+weight*x1
        sumy=sumy+weight*y1
        sumx2=sumx2+weight*x1*x1
        sumxy=sumxy+weight*x1*y1
        sumy2=sumy2+weight*y1*y1
 50   continue
c
c   calculate coefficients and standard deviations
c
 51   delta=sum*sumx2-sumx*sumx
      a=(sumx2*sumy-sumx*sumxy)/delta
 53   b=(sumxy*sum-sumx*sumy)/delta
cc
c  patched up to use same varnce at all times jh jun 94
c
c61   if(mode) 62,64,62
c62   varnce=1.0
c     go to 67
 64   c=npts-2
c
c   modified to not crash with only 2 points
c
      if(c.gt.0) then
         varnce=(sumy2+a*a*sum+b*b*sumx2
     *   -2.0*(a*sumy+b*sumxy-a*b*sumx))/c
      else
         varnce=0.0
      endif
c  put abs values to not chash with negative sqrt (jh,jan 96)
 67   sigmaa=sqrt(abs(varnce*sumx2/delta))
 68   sigmab=sqrt(abs(varnce*sum/delta))
 71   r=(sum*sumxy-sumx*sumy)/
     *sqrt(abs(delta*(sum*sumy2-sumy*sumy)))
      return
      end


	

      subroutine invxy(n,y,x,z,a,b,cc)
c
c   invert n equations y=ax + bz + cc
c
      implicit none
      real x(*),y(*),z(*)
      double precision c(3,3),h(3)     ! for normal equations
      double precision t
      real a,b,cc
      integer i,j,k,n
c
c   zero
c
      do i=1,3
        h(i)=0.0
        do k=1,3
          c(i,k)=0.0
        enddo
      enddo
c
c   make normal equations
c
      do i=1,n
        c(1,1)=c(1,1)+x(i)*x(i)
        c(1,2)=c(1,2)+x(i)*z(i)
        c(1,3)=c(1,3)+x(i)
        c(2,2)=c(2,2)+z(i)*z(i)
        c(2,3)=c(2,3)+z(i)
        h(1)=h(1)+x(i)*y(i)
        h(2)=h(2)+z(i)*y(i)
        h(3)=h(3)+y(i)
      enddo
c
c   fill out rest
c
      c(3,3)=n
      c(2,1)=c(1,2)
      c(3,2)=c(2,3)
      c(3,1)=c(1,3)
      c(3,2)=c(2,3)
c
c   do inversion
c
      do k=1,2
         do i=k+1,3
           t=c(k,i)/c(k,k)
              do j=i,3
                 c(i,j)=c(i,j)-t*c(k,j)
              enddo
         enddo
       enddo
       do i=2,3
          do k=1,i-1
             h(i)=h(i)-c(k,i)*h(k)/c(k,k)
          enddo
       enddo
       h(3)=h(3)/c(3,3)
       do i=2,1,-1
          do k=i+1,3
             h(i)=h(i)-c(i,k)*h(k)
          enddo
          h(i)=h(i)/c(i,i)
       enddo
c
       a=h(1)
       b=h(2)
       cc=h(3)
       return
       end

      SUBROUTINE SDV(N,X,AV,SD)
C
C   CALCULATES STANDARD DEVIATION SD AND AVERAGE OF
C   N DATA SAMPLES X. IF N LT 10, WEIGHT IS (N-1)
C
      DIMENSION X(1)
C
      IF(N.EQ.0) RETURN
      SD=0.0
      AV=0.0
      DO 1 I=1,N
      AV=AV+X(I)
 1    CONTINUE
      AV=AV/N
      IF(N.EQ.1) RETURN
      DO 2 I=1,N
      SD=SD+(AV-X(I))*(AV-X(I))
 2    CONTINUE
      IF(N.GE.10) SD=SQRT(SD/N)
      IF(N.LT.10) SD=SQRT(SD/(N-1))
      RETURN
      END
C
C

c-----------------------------------------------------------------------------
c  plotting routines in pc, dummy file on sun
c
c      include 'pcplot.inc'

c  Program name: nrwsei
c
c  convert files from geological survey of northrhine-westphalia 
c  to seisan format, PC, Sun and Linux
c
c  format description at end
c
c  this is a fist version, only tested with a few files
c
c  format and test data from klaus lehmann klaus.lehmann@nrw.de
c
c  j. havskov, sep   2006
c
c  updates : 
c  mar 20, 2007 jh : add station KRF
c  april 4 2007 jh : limit filename to 12 chars, fix problem of filenr.lis and code k 
c                    on windows
c
c
c
c  updates:

      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
c     integer*4  data(max_sample)     ! output samples
      character*80 text,text1         ! general text
      integer code                    ! error code
      integer*4 data(8,500000)        ! samples
      integer*4 x(500000)             ! for swapping
      character*1 stat_letter(20)     ! letter for station
      character*5 sta(20)             ! station code
      integer rec_length              ! record length for one read
c
c   block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	
ccccccccccccccccccccccccccccccccccccc  end

c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
	  integer i,k,l
c-- computer type
      logical pc,sun,linux	  
      integer org_stat            ! original number of stations
c
c print version
c
      include 'version.inc'
      out_version_date='Aug  2006    '
      if (version_new) out_version_date=version_date
      call print_ver
c
      org_stat=13
c
      stat_letter(1)='B'
      stat_letter(2)='E'
      stat_letter(3)='G'
      stat_letter(4)='J'
      stat_letter(5)='K'
      stat_letter(6)='L'
      stat_letter(7)='O'
      stat_letter(8)='P'
      stat_letter(9)='R'
      stat_letter(10)='S'
      stat_letter(11)='T'
      stat_letter(12)='W'
      stat_letter(13)='k'
    
      sta(1)='BHE  '
      sta(2)='ENT  '
      sta(3)='GSH  '
      sta(4)='JCK  '
      sta(5)='KRF  '
      sta(6)='LOH  '
      sta(7)='OLF  '
      sta(8)='PLH  '
      sta(9)='RWB  '
      sta(10)='SOR  '
      sta(11)='TDN  '
      sta(12)='WBS  '
      sta(13)='KRF  '

      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       call read_def_chan('nrwsei.def',mainhead_text,net_code)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files, here use text header files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old')
c
c
c   read all header lines
c
       stat(1)='TEST '
       nchan=0
 1     continue
c
c   read  a line
c
       read(1,'(a)',end=50,err=99) text
c
c   date
c
       if(text(1:3).eq.'104') then
          k=1
          do i=5,40
             if(text(i:i).eq.'.') then
                text1(k:k)=' '
             else
                text1(k:k)=text(i:i)
             endif
             k=k+1
          enddo
          call seigetvalues(3,text1,code)
          day(1)=array$(1)
          month(1)=array$(2)
          year(1)=array$(3)
       endif
c
c   station code
c
c
       if(text(1:3).eq.'211') then
         do i=1,org_stat
           stat(1)=' '
           stat(1)(1:1)=text(5:5)
           if(text(5:5).eq.stat_letter(i)) 
     *     stat(1)=sta(i)
         enddo
       endif
c  time
c
       if(text(1:3).eq.'105') then
          k=1
          do i=5,30
             if(text(i:i).eq.':') then
                text1(k:k)=' '
             else
                text1(k:k)=text(i:i)
             endif
             k=k+1
          enddo
          call seigetvalues(3,text1,code)
          hour(1)=array$(1)
          min(1)=array$(2)
          sec(1)=array$(3)
          goto 2
       endif
       goto 1
c
c   now main header information is read, go on with channels
c
 2     continue   
       read(1,'(a)',end=50,err=99) text
       if(text(1:19).eq.'#BEGINCHANNELHEADER') then
          nchan=nchan+1
       endif
       
c
c   channel id
c
       if(text(1:3).eq.'200') then
          if(text(5:5).eq.'T') then
             nchan=nchan-1
             goto 2    ! do not use time channel , no dat
          endif         
          comp(nchan)(1:4)=text(5:8)
          if(text(5:6).eq.'UD') comp(nchan)='S  Z'
          if(text(5:6).eq.'NS') comp(nchan)='S  N'
          if(text(5:6).eq.'EW') comp(nchan)='S  E'
          if(text(5:7).eq.'DCF') comp(nchan)=' DCF'
        endif

c   station code
c
c
       if(text(1:3).eq.'211') then
         stat(nchan)=' '
         stat(nchan)(1:1)=text(5:5)
         do i=1,org_stat
           if(text(5:5).eq.stat_letter(i))
     *     stat(nchan)=sta(i)
         enddo
       endif

c
c   number of samples
c
        if(text(1:3).eq.'220') then
           read(text(5:10),'(i)') nsamp(nchan)
        endif
c
c   sample rate      
c
        if(text(1:3).eq.'241') then
           read(text(5:12),'(g7.3)') rate(nchan)
c          write(6,*) rate(nchan)
           rate(nchan)=1.0/rate(nchan)
        endif
        goto 2

c
c  end of reading header file
c
 50     continue
        
        close(1)
c
c   copy info to other channels
c
        rate(1)=200.0
        do i=2,nchan
          year(i)=year(1)
          month(i)=month(1)
          day(i)=day(1)
          hour(i)=hour(1)
          min(i)=min(1)
          sec(i)=sec(1)
          rate(i)=rate(1)
        enddo

       write(6,*) ' Number of channels',nchan
       write(6,*) ' Date and time',year(1),month(1),
     *              day(1),hour(1),sec(1)
       write(6,*) ' Rate and nsamp', rate(1),nsamp(1)
c
c   open data file
c
       infile(10:12)='I32'
       rec_length=nchan*4
       write(6,*)'Now opening binary file:',infile
c
       open(1,file=infile(1:12),status='old',access='direct',
     * recl=rec_length)      

c--------------------------------------------------------------
c  loop to read whole file
c--------------------------------------------------------------
c
c
       do i=1,nsamp(1) 
          read(1,rec=i)(data(k,i),k=1,nchan) 
c         write(6,*) i
       enddo 
c
       do ichan=1,nchan
         call set_def_chan(ichan,stat(ichan),comp(ichan))
         cbyte(ichan)='4'
       enddo
c
c   make seisan headers
c
      ichan=1
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
      mainhead(1)(2:29)=mainhead_text    ! put in header text
c
      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo

C
C   enter channel  loop
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,
     *                    stat,comp,nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
c                                                                               
c   get response            
c                                                                               
         call read_resp_head(chahead)                                            
c
c   swap if sun
c
            if(sun) then
               do k=1,nsamp(ichan)
                  x(k)=data(ichan,k)
               enddo
               call swap4(nsamp,x)
            endif
c
c
c   write data
c
         write(2)chahead
         write(2) (x(i),i=1,nsamp(ichan))
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  

c Geological Survey of Northrhine-Westphalia (GD NRW)
c Section Geophysics, Earthquake Hazard Analysis
c Krefeld, Germany

c CONVERSION OF RAW DATA OUTPUT INTO SEISAN FORMAT

c Description of input format for conversion program by J. Havskov
c --------------------------------------------------------------------------------------------
c The output format, which is produced by our data acquisition system, is adapted to the 
c input of the data analysis software which we use at this time, 
c i. e. LabVIEW 7.1 by National Instruments Corporation (Austin, Texas, USA),
c former versions as DIA/DAGO by GfS mbH (Aachen, Germany). 

c For the event (in trigger mode) or time interval data (in continuous registration mode),
c two files are saved, respectively, the header file (1) and the waveform data file (2). The 
c file formats are organised as described below.

c The original data of the outlined example of an event header and related waveform data are 
c contained in the files
c S0912002.DAT	(header)
c S0912002.I32	(waveform data).
c The filename structure (3) is explained below.
c 
c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c (1) Header file
c ASCII
c The function of each line is defined by a specific identification number in the beginning of 
c that line. Only lines which are necessary for using with Nordic or SeisAn format are listed 
c in the example below. In our application, we use data file with 
c    1 time channel 			(1 implicite channel), 
c    3 seismometer channels, and
c    1 time code channel 		(4 explicite channels).
c    (4 other channels, optionally	4 explicite channels, unused)	
c The example is depicted line by line, begins after the next two lines          
c                 *** description in these columns ***	------------------------------------------------------------------------------------------
c DIAEXTENDED

c #BEGINGLOBALHEADER				
c 101,				name of data set (max. A72 - 72 chars.)
c 102, 				comments (max. 20 lines a A72)
c 103,				analyst's ID or comments (max. A72)
c 104,13.09.2006			date (dd.mm.yyyy)
c 105,9:14:27			time (hh:mm:ss)	
c 112,High -> Low			byte structure definition for INT32 or REAL64 format, 
c                               respectively, ("Low -> High" using the REAL64 format)
c #ENDGLOBALHEADER

c #BEGINCHANNELHEADER
c 200,T				channel name (max. A16)
c 201,Zeit			comments to channel (e. g. "Zeit" -> Time, max. A72)
c 202,[s]				unit of data (e. g. "[s]" -> (s), max. A12)
c 210,IMPLIZIT			type of channel (IMPLIZIT -> implicite / 
c                               EXPLIZIT-> explicite)
c 220,14801	 		length of data set (number of lines)
c 240,85059010			start value (here: t0)
c 241,5E-03			increment value (s; here: time increment T = 0,005 s), 
c                               i.e. a sampling rate of 200 Hz
c #ENDCHANNELHEADER
c 
c #BEGINCHANNELHEADER
c 200,UD				channel name (max. A16)
c 201,Seismometer vertikal	comments to channel (here: "Seismometer vertikal" ->

c 202,[µV]			unit of data (e. g. "[µV]" -> (µV), max. A12)
c 210,EXPLIZIT			type of channel (IMPLIZIT -> implicite / 
c                               EXPLIZIT-> explicite)
c 211,S0912002.I32		name of waveform data file, s. below (*.I32 using the INT32 / 
c                               *. R64 using the REAL 64 format), file names with 12 chars.
c 213,BLOCK			description of data matrix as data block
c 214,INT32			data type (INT32 / REAL64), s. below
c 220,14801	 		length of data set (number of lines)
c 240,1				offset value
c 241,4				calibration factor (not used in conversion)
c #ENDCHANNELHEADER

c #BEGINCHANNELHEADER
c 200,NS				channel name (max. A16)
c 201,Seismometer nord-sued	comments to channel (here: "Seismometer nord-sued" -> 
c                               Seismometer north-south, max. A72)
c 202,[µV]			unit of data (e. g. "[µV]" -> (µV), max. A12)
c 210,EXPLIZIT			type of channel (IMPLIZIT -> implicite / 
c                               EXPLIZIT-> explicite)
c 211,S0912002.I32		name of waveform data file, s. below 
c 213,BLOCK			description of data matrix as data block
c 214,INT32			data type (INT32 / REAL64), s. below
c 220,14801			length of data set (number of lines)
c 240,0				offset value
c 241,2				calibration  factor (not used in conversion)
c #ENDCHANNELHEADER

c #BEGINCHANNELHEADER
c 200,EW				channel name (max. A16)
c 201,Seismometer ost-west	comments to channel (here: "Seismometer ost-west" -> 
c                               Seismometer east-west, max. A72)
c 202,[µV]			unit of data (e. g. "[µV]" -> (µV), max. A12)
c 210,EXPLIZIT			type of channel (IMPLIZIT -> implicite / 
c                               EXPLIZIT-> explicite)
c 211,S0912002.I32		name of waveform data file, s. below 
c 213,BLOCK			description of data matrix as data block
c 214,INT32			data type (INT32 / REAL64), s. below
c 220,14801			length of data set (number of lines)
c 240,0				offset value
c 241,2				calibration factor (not used in conversion)
c #ENDCHANNELHEADER
	
c #BEGINCHANNELHEADER
c 200,DCF				channel name (max. A16)
c 201,DCF77			comments to channel (here: "DCF77" -> regional radio time 
c                               code, max. A72)
c 202,[µV]			unit of data (e. g. "[µV]" -> (µV), max. A12)
c 210,EXPLIZIT			type of channel (IMPLIZIT -> implicite /
c                               EXPLIZIT-> explicite)
c 211,S0912002.I32		name of waveform data file, s. below (
c 213,BLOCK			description of data matrix as data block
c 214,INT32			data type (INT32 / REAL64), s. below
c 220,14801			length of data set (number of lines)
c 240,0				offset value
c 241,2				calibration factor (not used in conversion)
c #ENDCHANNELHEADER
c 
c ---------------------------------------------------------------------------------------------
c end before former line.
c Empty lines are allowed, comment lines begin with ",".
c 
c (*)	IMPLIZIT means that values are described via start and increment values
c       EXPLIZIT means that values are saved one by one
c (**)	Explicite channels are stored BLOCKwise in waveform data file

c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c (2) Waveform data file 
c INT32 	(4-byte Integer format - PC, file extension I32) or 
c REAL64 	(8-byte Real format - UNIX, file extension R64), respectively, 
c both options should be supported.

c Data blocks in binary format (s. above)
c line 1: 	value1(channel UD) 	value1(channel NS) 	value1(channel EW) 	value1(channel DCF)
c line 2: 	value2(channel UD) 	value2(channel NS) 	value2(channel EW) 	value2(channel DCF)
c line 3: 	value3(channel UD) 	value3(channel NS) 	value3(channel EW) 	value3(channel DCF)
c ...		...			...			...			...
c line 14801: ... 			...			...			value14801(channel DCF)

c +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
c (3) Filename structure
c 
c 1)  The station code is contained in the filenames of both, header and waveform data files. 
c The used filename structure can be read from the following rules:
c 
c  s mm dd nnn .ext
c  |  |  |  |    |
c  |  |  |  |    file extension (dat / i32 / r64)
c  |  |  |  event number in the same day (e. g. no. of triggered event) 
c  |  |  day
c  |  month
c  STATION CODE (in abbreviation according to station list)
c 
c List of station abbreviation (12 stations)
c 
c b	BHE
c e	ENT
c g	GSH
c j	JCK
c k	KRF
c l	LOH
c o	OLF
c p	PLH
c r	RWB
c s	SOR
c t	TDN
c w	WBS
c 
c In the mentioned example, i. e.: S0912002.I32 in channel header (line identification no. 211) 
c is the 2nd event file of 12 September at station SOR.
c Remark: Station code and extension will remain unchanged. Chars for date and event number
c may be used otherwise in future.
c 
c 2) All channels have the same start time (does not represent full seconds).
c 
c 3) Time channel must be converted, too, for test and proof purposes. 
c 
c --------------------------------------------------------------------------------------------
c 20/11/2006 	Klaus Lehmann

C*******************************************************************************
c      PROGRAM UPDATE
c
C   LATEST UPDATE :  4/94 BRL: added include file, eventno to hypocent window
c                    removed unused variables, minor changes to 
c                    interactive section
c   may 11 94 by jh : do double sorting
c   jul 25 94          : fix updates
c   sep 28 94        : do not update agency if hypocenter is fixed
c   nov 9            : do not clear magnides before location
c   dec 94           **********  version 5.0 **********  new hypo
c   jan 10, 94       : new find ev in
CJAB(BGS)May95       : Opening CAT file...peculiar problem on PC...crashing out
CJAB(BGS)May95         with memory problem. If the "sun" statement commented
CJAB(BGS)May95         out then works ok. Thus changed code to use if-then-else
CJAB(BGS)May95         construct.
c   jun 9   jh       : do not write loc. agency when no locate
c aug 16  jh        : do not modify event if no locate flag * is set
c mar 7 96          : subroutine update_spec to hyposub3
c mar 14            : put in clear old, cnages to read_...
c aug 27  96, jh    : enable use of local data base
c sep 19            : clear 3 magnitude if default agency
c oct 11            : fix sorting to use time so p comes before s
c dec 96            : change id's and file names according to origin time
C jan 97            : always hyp.out. cat.out for local base
c feb 19            : change how ordering is done
c mar  18, 97       : reverse arguments in sort_fi (sun)
c mar 20            : do not remove hyp agency if hypocenter fixed
c mar 24            : seems that above was wrong
c may 16            : sort also when no location
c nov 19            : put in option for locking id
c dec 8             : error in above for local data base
c jan 14  98        : ******** year 2000 ******************************
c feb 12 98         : clear residuals etc before location, not after
c jun 11 ,98        : remove routine increment_id and fix it
c aug 31 98         : do not change id line if event marked not to be located
C
c sep 98 jh         :  ------------    version 7.0 check -------------------
c                     year 2000, 5 char base, 5 char station, no pc-sun
c mar 19 lo         : name of sort_fi changed to sortfi
c apr 9 99 jh       : error with eisnenght of data base
c                     add print_ver
c august 20         : add variable use_eev to hypocenter and read_stat_model call
c sep 01 lo         : when changing date of file allow 24 hours
c sep 6  jh         : read_stat_model not changed in change of august 20
c sep 24 jh         : include seisan.inc and read values
c oct 18 jh         : agency_dir to 5 char, caused wrong base for def base
c oct 19            : probelm with weight 4 
c nov 2 99          : recompiled to include new findevin and indata
c feb 17 2000 ,jh   : new update_spec, no mw output
c march 10 2000     : move call clear_old up before location 
c march 29          : update id even if not located by '*' flag, ID might be
c                     wrong
c oct 25 2000       : read secs as f6.3 instead of f5.2 when sorting, compile
c                     for high accuracy 
c dec 6 2000 lo     : only change action to UPD if event had been registered
c may 2 2001 jh     : read in new model before header clear to avoid deleting
c                     type 1 lines not corresponding to active station file
c
c
      implicit none
      include 'hypparm.inc'
      include 'seidim.inc'
      include 'libsei.inc'
      include 'seisan.inc'
c
c---name of top directory
      character*60 top_directory
c---one event in nordic format, one line of data  
c---iaspei file name
      character*80 modnam
      character*1 answer
c---location indicator, can be L, R or D
      character*1 loc_indicator(3)
      logical locate
c--- event type, indcator of explosion, indicator of fixing depth  
      character*1 typ,exp,fixdepth
c---agency for magnitude  
      character*3 agency
c---directory separator character
      character*1 dchar
c---number of header lines, records, stations in nordic file, help variables
      integer nhead,nrecord,nstat,k,nphase,i,itp
c---id line indicator
      integer id
      character*1 id_lock          ! indicator for locked id
      character*1 id_to_lock       ! choise if to lock
c---model type or number
      character*1 model  
C-- hypocenter help variable
      integer init
      character*80 sfiles(max_index$)       ! save s-files names			
c-- save year, month ,day for old location
      integer year,month,day
c-- hour and difference in hours between solutions shifted one day
      integer hour,delhour
c-- abs times for above
      double precision abstim1,abstim2
c-- logical I/O units
      integer iusum,iuphs,iulst,iuin,iutab,iustat
c---logfile name when updating
      character*80 logfile
c---flag for indicatin if first month  when updating
      integer first_month
c---line in log file
      character*80 logrecord
c---number of event in one month in data base
      integer nout
c---time of making update
      character*12 p_time
      character*14 proc_time
c---operator id
      character*4 operator
c---data base code
      CHARACTER*5 TBASE
c---first and last event used when updating
      character*12 first_event,last_event
c-- covarriance matrix, origin time error
      real covar(3,3),oterr
c-- min and sec of phase
      integer min
      real sec
c-- for sorting
      character*5 old_stat
      logical use_eev     ! indicate if call from eev
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1 
       integer          read02
      integer j,m,l
C
C  next for data base operation
C
      character*10 keys                      !next choice key
      character*14 starttime,endtime         ! time interval for location
      character*40 basename                  ! data base or file name
      character*80 eventfile                 ! single event file name
      character*80 old_eventfile             ! the one before
      character*5  agency_dir                ! agency used for def. base
      integer status,eventno,newmonth,fstart ! 
c---name of epi file in data base
      CHARACTER*80 EPIFILE

c
c---minimum number of stations to locate
      integer minstat
c---minimum number of phases to locate  
      integer minphase
c---code for current model  
      character*20 model_code  
c---magnitude Ml coefficients
c      real a,b,c,d  
c---number of arguments and function
c      integer nargs

c---added 4/94: sort arrays for sorting output by distanace
      integer ksort(narriv)     
      integer lsort(narriv)     
      character*5 old_dist
      
c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c 4/94: added logical unit# definitions      
      iuphs=12                                         
      iustat=11
      iusum=7
      iulst=9     
      iuin=21
      iutab=22                         
      use_eev=.false.    ! not from eev, print out station list etc
      
      first_month=0      
c                                                           
c   get computer specifics
c
      call dir_char(dchar)         ! dirctory delimiter character
      call get_def_base(agency_dir)
      call get_seisan_def

c 
c   get directory structure
c
      call topdir(top_directory)
      itp=index(top_directory,' ')-1
c
c   input data base name and time interval
c
 333  continue   ! wrong entry of base name
      write(6,*)
     *'Give 1-5 letter data base name, ,, for local base, ',
     *'return for default'
      read(*,'(a40)') basename
      if(index(basename,' ').eq.2.and.basename(1:5).ne.'   ') goto 333
         tbase=basename(1:5)
         IF(TBASE.EQ.'     ') TBASE(1:5)= agency_dir
         WRITE(6,'(A,A)')
     * ' YOU ARE NOW GOING TO UPDATE THE SEISMIC DATA BASE ',TBASE
         WRITE(6,*)
     * 'ARE YOU SURE YOU KNOW WHAT YOU ARE DOING, IF SO, ENTER '
c
 6666    continue 
         WRITE(6,*)'OPERATOR ID (max 4 char):'
         READ(5,'(A4)') OPERATOR
c
         IF(OPERATOR.EQ.'    ') then
           write(6,*) ' You must give operator'
           goto 6666
         endif
c
         write(6,*)'LOCK ID, (N/Y=Return)'
         read(5,'(a)') answer
         id_to_lock='L'
         if(answer.eq.'N'.or.answer.eq.'n') id_to_lock=' '
         if(tbase(1:2).ne.',,') then   ! a local data base does not need time int.
            WRITE(6,'(a,$)')
     *      ' START TIME year-month, e.g. 199809  :'
            READ(5,'(A14)') STARTTIME
            IF(STARTTIME(7:7).NE.' ') THEN
               WRITE(*,*) ' YOU MUST START WITH BEGINNING OF MONTH'
               WRITE(*,*) ' THIS HAS NOW BEEN CORRECTED'
               STARTTIME(7:14)='        '
            ENDIF
            WRITE(6,'(a,$)')
     *      ' END TIME, RETURN IS TO END OF MONTH :'
            READ(5,'(A14)') ENDTIME
            IF(ENDTIME(7:7).NE.' ') THEN
               WRITE(*,*)' YOU MUST END WITH END OF MONTH'
               WRITE(*,*)' THIS HAS NOW BEEN CORRECTED'
               WRITE(*,*)' THIS HAS NOW BEEN CORRECTED'
               ENDTIME(7:14)='        '
            ENDIF
         else
            starttime='              '  ! start time very early
            endtime  ='              '  ! end of file
         endif
c
c   make shure base is 5 chars
c
         if(tbase(1:1).ne.',') then
            do i=2,5
              if(tbase(i:i).eq.' ') tbase(i:i)='_'
            enddo
         endif
c
c   start with standard model
c
      model=' '     
C
C   do not fix depth  
C
      fixdepth=' '
C
C   open  output files
C
      open(iulst,FILE='print.out',STATUS='unknown')      ! print file
c
c   on  sun, old events seem to remain in print.out file, so delete and reopen
c
      close(iulst,status='delete')
      open(iulst,FILE='print.out',STATUS='unknown')      ! print file

      open(iuphs,file='hyp.out',status='unknown')        ! nordic out
      open(iusum,file='hypsum.out',status='unknown')     ! hypo71 style summary 
C
C   open hypocenter file with model and station and read
c   file is first searched for in your local directory, then in SEISAN
c   DAT directory
c
      call read_stat_mod
     *(agency,model_code,model,minstat,minphase,
     *modnam,loc_indicator,iustat,iuphs,iulst,iusum,iutab,isort,
     &test,dlt,'N',1,use_eev)
c
      keys(1:4)='NEXT'    ! start with next event

c 3/94: added init call to zero residual summary
      call hypocent(4,iustat,iuphs,iulst,iusum,iutab,init,
     &'N',data,modnam,eventno,dlt,isort,test,'N',1,nstat,
     &locate,covar,oterr,nhead,nrecord,use_eev)
C
c
c---------------------------------------------------------------------
c  event loop starts here, always come back here after locating one event
c---------------------------------------------------------------------
c
 50   continue
c
C----------------------------------------------------------------------
C    next event 
C----------------------------------------------------------------------
C
c
c   get system time so time of update can be time stamped
c
      call systime(p_time,proc_time)
C
C  GET FILENAME OF NEXT EVENT, save previous if any, also save last current
c  event, will be the last for the month when a new month is entered
C
      if(tbase(1:2).ne.',,'.and.first_month.ne.0) then
         last_event=eventfile(fstart:fstart+11) ! for log file
      endif
c
c  save name of first event in a month for log if a data base
c
      if(eventno.eq.1.and.tbase(1:2).ne.',,'.and.first_month.ne.0) then
         first_event=eventfile(FSTART:fstart+11)
      endif
c
	  old_eventfile=eventfile       ! save if next event is from next month
c
      call findevin
     *(basename,starttime,endtime,keys,0,eventno,
     *eventfile,fstart,newmonth,status)
c
c   if only one month and no data, stop here
c
      if(starttime(1:6).eq.endtime(1:6).
     *and.status.gt.0.and.eventno.eq.0) STOP
C
C  CHECK FOR OUTPUT IN CAT DATA BASE IF A NEW MONTH
c  or end of time period=end of month. Since the first month also
c  get the newmonth flag set, this is checked by first_month.
c  If a local data base, check for end of data.
C
      IF((NEWMONTH.EQ.1.or.status.eq.3).and.first_month.ne.0.or.
     *(tbase(1:2).eq.',,'.and.status.eq.2)) THEN
c
c
c   sort file names, might be different from before
c
      call sortfi(sfiles,nout)
c
c   read all s-files and make cat file in chrono order 
c
      write(6,*)
      write(6,*)' Put CAT file in chrono order'
      write(6,*)
c
      rewind 31
      do k=1,nout
c          write(6,'(1x,a)') sfiles(k)
          call sei open(old$+warn$,            ! Open 
     &                  ' ',                   ! Prompt file name (n/a).
     &                  sfiles(k),             ! File name
     &                  read02,                ! unit #
     &                  b_old,                 ! Already exists? (n/a).
     &                  code)                  ! Returned condition.

         call indata(read02,nstat,nphase,nhead,nrecord,typ,exp,data,id)
         write(31,'(a80)')(data(i),i=1,nrecord)
         call sei code(fort$,code,read02,b_eof)
         call sei close (close$,read02,code) ! close
      enddo
C
C  CLOSE EPI BASE FILE if not a local data base
C
         if(tbase(1:2).ne.',,') then
            CLOSE(31)

c   write in log file, latest information is on top
c   write when one month of locations is finished
c   not done if a local data base
c
c   first make log file name, assume that epifile (now cat file) name now known
c
            logfile(1:itp)=top_directory(1:itp)
            logfile(itp+1:itp+5)=dchar//'REA'//dchar
            logfile(itp+6:itp+10)=tbase
            logfile(itp+11:itp+15)=dchar//'LOG'//dchar
            logfile(itp+16:itp+28)='01-0000-00L.S'
            logfile(itp+29:itp+34)=epifile(itp+16:itp+21)
            write(6,*)
            write(6,'(1x,a)') logfile
            open(13,file=logfile,status='unknown')
            call indata(13,nstat,nphase,nhead,nrecord,typ,exp,data,id)
            rewind 13
            do i=1,80
              logrecord(i:i)=' '
            enddo
            logrecord(2:5)=epifile(itp+16:itp+19)
            logrecord(7:8)=epifile(itp+20:itp+21)
            logrecord(10:13)=operator
            logrecord(15:28)=proc_time
            logrecord(30:41)=first_event
            logrecord(43:54)=last_event
            write(logrecord(56:60),'(i5)') nout
            write(13,'(a80)') logrecord
            if(nrecord.eq.0) write(13,*)'        '
            write(13,'(a80)')(data(i),i=1,nrecord)
            close(13)
            nout=0
         endif
      endif
c
c   if not at end of time period, open next epi file, could be the first
c
	  if(tbase(1:2).eq.',,'.and.eventno.eq.1) 
     *open(31,file='hyp.cat',status='unknown')
c
      if(status.ne.3.and.newmonth.eq.1.and.tbase(1:2).ne.',,') then
c
C
C   open data base input single event file and read first line
c   needed for generating file name
c
         open(21,file=eventfile,status='old')
         read(21,'(a)') data(1)
         close(21)
C
C  YEAR-MONTH
C
         IF(DATA(1)(2:3).EQ.'  ') DATA(1)(2:3)='19'
         epifile(1:ITP)=TOP_DIRECTORY(1:ITP)
         epifile(itp+1:itp+1)=dchar
         epifile(ITP+2:ITP+4)='REA'
         epifile(itp+5:itp+5)=dchar
         epifile(ITP+6:ITP+10)=TBASE
         epifile(itp+11:itp+11)=dchar
         epifile(ITP+12:ITP+14)='CAT'
         epifile(itp+15:itp+15)=dchar
         EPIFILE(itp+16:itp+19)=data(1)(2:5)  ! year
         EPIFILE(itp+20:itp+21)=data(1)(7:8)  ! month
         if(epifile(itp+20:itp+20).eq.' ') epifile(itp+20:itp+20)='0'
         EPIFILE(itp+22:itp+25)= '.CAT'
C
C  OPEN NEW  cat file
C
C
         WRITE(6,'(1x,A)') epifile
         OPEN(UNIT=31,FILE=epifile,STATUS='unknown')
      endif
c
c   now that first event has been read, set first_month flag
c
      first_month=1
c
c   check if  errors or end of time interval, then stop
C     
      if(status.gt.0) then
         write(6,*)' STOP WITH STATUS=',status
         GOTO 900   ! stop
      endif
C
C   open data base input single event file and read it
c   set flag for single event nrecord= -1
c
         nrecord=-1
         open(21,file=eventfile,status='old')
         call indata(21,nstat,nphase,nhead,nrecord,typ,exp,data,id)
         id_lock=data(id)(76:76)          ! save id locking parameter
C
C------------------------------------------------------------------------
c   location start here
C--------------------------------------------------------------------------
C
 1000 continue
c
c   assume this is after year 1900 and put in header
C
      if(data(1)(2:3).eq.'  ') data(1)(2:3)='19'
c
c   check if disable location has been set on for this event, in which case
c   event is passed on with no modification to hyp.out
c
      if(data(1)(45:45).eq.'*') then
        write(6,*)'Event flagged not to be located'
        keys(1:4)='NEXT'
        goto 31               ! go to outputs 
      endif
c
c   check if a new model has to be read in
c
      if(model.ne.data(1)(21:21)) then
         model=data(1)(21:21)
         call read_stat_mod
     *   (agency,model_code,model,minstat,minphase,
     *   modnam,loc_indicator,iustat,iuphs,
     &   iulst,iusum,iutab,isort,test,dlt,
     *   'N',1,use_eev)
         write(*,*)' Model changed'
      endif

c
c   clear old parameters
c
      call clear_old(data,nhead,nrecord,agency)
C
C check if type of event should be located 
C
      locate=.false.
      do i=1,3 
         if(typ.eq.loc_indicator(i)) locate=.true.
      enddo                                     
c
c  check if event has enough phases and stations and if it
c  should be located
c      
      if(nphase.ge.minphase.and.locate.
     *and.nstat.ge.minstat) then  
c
c   set fixdepth indicator
c
         if(fixdepth .ne. ' ')then
            data(1)(44:44)=fixdepth
         endif
c
c  if type is E or P, fix depth to 0.0 km
c
         if(exp.eq.'P'.or.exp.eq.'E') then
            data(1)(39:44)='  0.0F'
         endif
      else
         write(6,291)typ,nphase
 291     format
     *   (1x,'type',1x,a1,2x,'NPHASE=',
     *   i2,'  NOT LOCATABLE') 
         if(nphase.lt.minphase) write(6,*)' Too few phases'
         if(nstat.lt.minstat) write(6,*) ' Too few stations'
c
c  check if location indicator is set or correctly set
c
         if(typ.ne.'L'.and.typ.ne.'R'.and.typ.ne.'D')
     *   write(6,*)' Missing or wrong event type, must be L,R or D'
         if(.not.locate.and.(typ.eq.'L'.or.typ.eq.'R'.or.typ.eq.'D'))
     *   write(6,*)' Check your STATION0.HYP file under Locating ',
     *   'indicator'
         keys='NEXT'
         locate=.false.       ! was not located
C
C  No location, still try to calculate magnitudes  
C
         go to 30
      endif
C
c    locate one event
C
      init=2
      do i=nhead+1,nrecord
         data(i)(61:70)='          '
c
c   keep distance if coda is there, so that magnitude can be calculated
c   in case not enough data for a location
c
         if(data(i)(30:33).eq.'    ') data(i)(71:75)='     '
         data(i)(76:79)='    '
      enddo

c
c   save year month and day before updating and calculate abs time
c
      read(data(1),'(1x,i4,1x,2i2)') year,month,day
      call  TIMSEC (year,month,day,0,0,0.0,abstim1)
      call hypocent(2,iustat,iuphs,iulst,iusum,iutab,
     &init,'N',data,modnam,eventno,
     &dlt,isort,test,'N',1,nstat,locate,covar,oterr,nhead,nrecord,
     *use_eev)
c
c   check if located
c
      if(.not.locate) goto 30
c
c   check if day has changed, if so correct all arrival times by + or -24 hours
c
      read(data(1),'(1x,i4,1x,2i2)') year,month,day
      call  TIMSEC (year,month,day,0,0,0.0,abstim2)
      if(dabs(abstim2-abstim1).gt.10.0) then  ! add 10 for posible round off err
         delhour=(dabs(abstim1-abstim2)+10.0)/3600
         if(abstim2.gt.abstim1) delhour=-delhour
         write(6,*)' Day has changed, hours added:', delhour
c change lo
c        if(abs(delhour).gt.23) then
         if(abs(delhour).gt.24) then
             write(6,*)' Unrealistic change, will stop'
             stop
         endif
c         write(iulst,*)' Day has changed, hours added:', delhour
         do i=nhead+1,nrecord-1
            read(data(i)(19:20),'(i2)') hour
            hour=hour+delhour
            write(data(i)(19:20),'(i2)') hour
         enddo
      endif
c
c-----------------------------------------------------------------------
c   enter here if event could not be located to only calculate magnitude
c-----------------------------------------------------------------------
c
 30   continue


c
c
c   clear old magnitudes, except 3. unless the agency is the default
c
      data(1)(57:72)='                '
      if(data(1)(77:79).eq.agency) data(1)(72:79)=' '
c
c   in case event not located, clear out old locations etc, however 
c   keep 3. magnitude, unless the agency is the default
c   if location is fixed, do not clean out header info
c
      if(.not.locate) then
         if(data(1)(44:44).ne.'F')data(1)(39:43)='     '
         if(data(1)(45:45).ne.'F')data(1)(24:38)='               '
         if(data(1)(44:45).ne.'FF') data(1)(46:48)='   ' ! keep old aga if fixe
         data(1)(49:72)='                        '
         if(data(1)(77:79).eq.agency) data(1)(72:79)=' '
       endif
c
c   enter here if no location is made by using flag *
c
 31   continue
c
c  put in agency unless both epicenter and depth has been fixed
c  in which case it must be the existing agency resposible for hypocenter
c  or if no location done
c
      if(data(1)(44:45).ne.'FF'.and.data(1)(45:45).ne.'*') 
     *data(1)(46:48)=agency
C
c   calculate  magnitudes, if no location flag is not set
C
         if(data(1)(45:45).ne.'*') then
            call update_mag(data,nhead,nrecord,agency,test,.false.)
c
c  update and average spectral information
c
            call update_spec(data,nrecord,nhead,agency,.false.)
         endif

C
c   output header line on screen
C
            write(6,2838) eventno,data(1)(1:71)
 2838       format(1x,'#',i5,1x,a71)



C
C
C   UPDATE ID LINE
C
         IF(ID.NE.0) THEN
c
c   check that id line has not changed since first read
c   could happen when adding a new error line
c
            do i=1,nhead+1   
              if(data(i)(80:80).eq.'I') id=i
            enddo
            WRITE(DATA(ID)(31:34),'(A)')OPERATOR
            WRITE(data(id)(13:26),'(A)')PROC_TIME
c
c only if event registered or split, change action to update
c
           if(data(id)(9:10).eq.'RE'.or.data(id)(9:11).eq.'SPL')
     &        WRITE(data(id)(9:11),'(A)')'UPD'
           
         ENDIF
c
c   write number of stations in header
c
         write(data(1)(49:51),'(i3)') nstat
C
c  write output files
C

c 4/94: added sort by distance option

c     if(test(71).ne.0.0.and.locate)then
      if(test(71).ne.0.0)then
        do i=nhead+1,nrecord-1
         read(data(i)(71:75),'(f5.0)')dlt(i-nhead)
        end do

        call r4sort(nrecord-1-nhead,dlt,isort)
c
c   now sort so the distance sorted phase lines, for each group of
c   as in the original file
c
        old_dist=data(isort(1)+nhead)(71:75)
        old_stat=data(isort(1)+nhead)(2:6)
        k=0
        l=0
        do i=nhead+1,nrecord-1
           l=l+1
           read(data(isort(l)+nhead),'(18x,2i2,f6.2)') hour,min,sec
           if(data(isort(l)+nhead)(71:75).eq.old_dist.and.
     *     data(isort(l)+nhead)(2:6).eq.old_stat) then
              k=k+1
              lsort(k)=isort(l)
              dlt(k)=sec+min*60+hour*3600
              if(i.ne.nrecord-1) goto 73   ! at the end, always sort what is lef
              l=l+1                        ! since this is last value
           endif
c
c   if here, new distance or station or last group
c
           if(k.gt.1) then
               call r4sort(k,dlt,ksort)
               m=1
               do j=l-k,l-1
                  isort(j)=lsort(ksort(m))
                  m=m+1
               enddo
           endif
           if(i.eq.nrecord-1) goto 73
           old_dist=data(isort(l)+nhead)(71:75)
           old_stat=data(isort(l)+nhead)(2:6)
           k=1    ! this is the first of the next group
           dlt(k)=sec+min*60+hour*3600
           lsort(k)=isort(l)
 73        continue
         enddo
c
c   write out
c
        rewind 21
        do i=1,nhead
           write(21,'(a80)') data(i)
           write(31,'(a80)') data(i)
           write(iuphs,'(a80)') data(i)    ! hyp.out 
        enddo 
        do i=nhead+1,nrecord-1
            write(21,'(a80)') data(isort(i-nhead)+nhead)
            write(31,'(a80)')data(isort(i-nhead)+nhead)
            write(iuphs,'(a80)')data(isort(i-nhead)+nhead)
        end do          
        write(21,'(a80)') data(nrecord)
        write(31,'(a80)') data(nrecord)
        write(iuphs,'(a80)') data(nrecord)
      else                    
c
c   write unsorted
c
        rewind 21
        write(21,'(a80)') (data(i),i=1,nrecord)
C
C  WRITE IN MONTHLY FILE and hyp.out
C
            WRITE(31,'(A80)') (DATA(i),i=1,nrecord)
            WRITE(iuphs,'(A80)') (DATA(i),i=1,nrecord)
      endif    
      NOUT=NOUT+1
c      close(21)
c
c   Rewrite s-file with name according to origin time, at same time
c   check header line and correct id line
c
c   If ID is locked, just continue, since id and file name should remain
c   unless flag is set to unlock
c
      if(id_lock.ne.'L'.or.id_to_lock.eq.' ') then 
         call rewrite_sfile
     *   (21,sfiles(nout),tbase,proc_time,operator,data,id_to_lock)
      else
         sfiles(nout)=eventfile    ! it was not changed
         close(21)
      endif
c
      keys='NEXT'
c
c   get next event
c
      go to 50                                        

C
c   this was the end
C
  900 continue
      call hypocent(3,iustat,iuphs,iulst,iusum,iutab,
     &init,'N',data,modnam,eventno,
     &dlt,isort,test,'N',1,nstat,locate,covar,oterr,nhead,nrecord,
     *use_eev)
 
c  close files (BRL 4/94)
      close(7)
      close(11)
      close(12)
      
      write(6,*)' Print output in file print.out'
      if(tbase(1:2).eq.',,') write(6,*)' CAT file hyp.cat'  
      write(6,*)' Summary file in hypsum.out'
      write(6,*)' Nordic in hyp.out'
      stop
      end                                                               


      subroutine rewrite_sfile
     *(read01,sfil,base,proc_time,operator,data,id_to_lock)
c
c  routine runs the split function on file on read01 in seisan data base base.
c  only one event is written out. The output file name is sfil.
c  proc_time and operator as in program update.
c  special for this version is that the file name and id is always taken
c  from the origin time since it is used in connection with update.
c  modified from split dec 96, see also program split. Routine assumes that
c  the input file is there and that the id line is present.
c
c  variable data just put in window to share memory space with main program
c
c  id_to_lock: lock on id put in at end
c
       implicit none

C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'seidim.inc'
       include 'libsei.inc'                ! Open file definitions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c-- OUTPUT FILE NAME                                   
      CHARACTER*80 OUTFL
      integer nf            ! length of file name
c-- EVENT TYPE, L,R OR D                              
      CHARACTER*1  EVTYPE			
c-- idline
      character*80 idline
      character*1 id_to_lock
c-- TOP DIR FOR REA               
      CHARACTER*40 TOP_DIRECTORY                
c-- dir separator
      character*1 dchar
C-- SYSTEM TIME FOR USED FOR TIME OF OPERATION
      character*14 proc_time 
C-- OPERATOR ID
      CHARACTER*4 OPERATOR
c-- HELP FORMAT LINE 0: NO, 1: YES               
      INTEGER FORMAT_INDICATOR			
c-- RECORDS IN FILE                                
      CHARACTER*80 DATA(*)			
c-- DATES AND TIMES                             
      INTEGER century,YEAR,MONTH		        
     *,DAY,HR,MIN,ISEC                                                          
c-- SECONDS                                                    
      REAL SEC					
c-- EXPLOSION INDICATOR                                
      CHARACTER*1 EXP	  			
c-- INDICATOR FOR USE OF DATA BASE                      
      CHARACTER*5 BASE				
c-- NUMBER OF STATIONS                                     
      INTEGER NSTAT				
c-- NUMBER OF RECORDS FOR EVENT                          
      INTEGER NRECORD				
c-- NUMBER OF HEADERS FOR EVENT                            
      INTEGER NHEAD				
c-- NUMBER OF PHASES FOR EVENT	  
      INTEGER NPHASE
C-- ID LINE NUMBER
      INTEGER ID
c-- TIME IN SEC SINCE 1900 EVENT                    
      DOUBLE PRECISION TIME			
c-- MINIMUM TIME --------------   
      DOUBLE PRECISION MIN_TIME                 
c-- DAY OF YEAR, NOT USED                                    
      INTEGER DOY				
c-- COUNTER                                                  
      INTEGER I,K	
c   length of top_directory
      integer topdirlen
c  agency
      character*3 agency
      character*80 sfil    ! name of sfile returned
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1 
       integer          read01
c write unit #1
       integer          write01
c file name
       character*80     chr_file
C                                                                               
C    SET DEFAULTS AND INITIAL PARAMETERS                                        
C
      call topdir(top_directory)
      call get_def_base(agency)
      topdirlen=index(top_directory,' ') -1
      call dir_char(dchar)
      b_f_debug$=.false.                  ! file debugging
c      nevent=0
c
C  rewind FILE                                                                   
C                         
      rewind read01              
C
C   START OF LOOP-------------------------------------------------
C                                       
                                                                                
 1    CONTINUE                                                                  
C                                                                               
C   READ  EVENT                                                                 
C          
         CALL INDATA(read01,NSTAT,NPHASE,NHEAD,NRECORD,
     *   EVTYPE,EXP,DATA,ID)
C                                                                               
C   CHECK FOR EOF                                                               
C                                                                               
      IF(NRECORD.EQ.0) GO TO 2
C
C                                                                               
C   CHECK IF FORMAT EXPLANATORY LINE IN FILE                        
C                                                                               
      FORMAT_INDICATOR=0                                                        
      DO K=1,NHEAD                                                              
         IF(DATA(K)(80:80).EQ.'7') FORMAT_INDICATOR=1                           
      ENDDO                                                                     
C                                                                               
C   GET ABS TIME FOR  EVENT, READ YEAR,MONTH AND DAY FROM HEADER,               
C   HR, MIN AND SEC FROM EARLIEST STATION IF NOT GIVEN IN HEADER
C                                                                               
      READ(DATA(1),'(1X,2I2,1X,2I2,1X,2I2,1X,F4.1)')                             
     *CENTURY,YEAR,MONTH,DAY,HR,MIN,SEC
C
C   ASSUME 1900 IF NO CENTURY GIVEN
C
      IF(CENTURY.EQ.0) CENTURY=19
      year=century*100+year                                                               
C                                                                               
C   CHECK IF HR AND MIN IN HEADER                                               
C                                                                               
c-- FIND EARLIEST TIME if phase records available                  
      IF(DATA(1)(12:15).EQ.'    '.and.(nrecord-1).gt.nhead) THEN		
         MIN_TIME=10E20                                                         
         DO I=NHEAD+1,NRECORD-1                                                 
            READ(DATA(I),'(18X,2I2,1X,F5.1)') HR,MIN,SEC                        
c-- ABS TIME              
            CALL TIMSEC(YEAR,MONTH,DAY,HR,MIN,SEC,TIME)	
            IF(TIME.LT.MIN_TIME) MIN_TIME=TIME                                  
         ENDDO                                                                  
         CALL SECTIM(MIN_TIME,YEAR,DOY,MONTH,DAY,HR,MIN,SEC)                    
c--  EARLIEST TIME  
         WRITE(DATA(1)(1:20),'(1X,I4,1X,2I2,1X,2I2,1X,F4.1)') 
     *   YEAR,MONTH,DAY,HR,MIN,SEC                   
         DATA(1)(80:80)='1'
      ENDIF                                                                     
c
C                                                                               
C  GENERATE OUTPUT FILE NAME                                                    
C     
      ISEC=SEC      
C
      IF(BASE.NE.'     '.and.base(1:2).ne.',,') THEN
         WRITE                                                                  
     *   (OUTFL,307)BASE,YEAR,MONTH,DAY,HR,MIN,ISEC,EVTYPE,YEAR,MONTH           
 307     FORMAT(
     *   '/',A5,'/',I4,'/',I2,'/',I2,'-',2i2,'-',i2,a1,'.S',i4,I2)               
C
         DO I=1,34                                                              
            IF(OUTFL(I:I).EQ.' ') OUTFL(I:I)='0'                                
         ENDDO   
         nf=34                                                               
      ELSE                                                                      
         WRITE(OUTFL,303)DAY,HR,MIN,ISEC,EVTYPE,'S',YEAR,MONTH                      
 303     FORMAT(I2,'-',2i2,'-',i2,a1,'.',a1,i4,I2)                                  
         DO I=1,19                                                                 
            IF(OUTFL(I:I).EQ.' ') OUTFL(I:I)='0'                                   
         ENDDO
         nf=19          
      ENDIF
c
c   make id line if not there, else update current id line
c
      if(id.ne.0) idline=data(id)
      if(id.eq.0) THEN
         idline(1:40)= ' ACTION:                   OP:     STATU'
         idline(41:80)='S:               ID:                   I'
         WRITE(IDLINE(31:34),'(A)')OPERATOR
         WRITE(IDLINE(13:26),'(A)')PROC_TIME
         WRITE(IDLINE(9:11),'(A)')'UPD' 
      endif
c
c  update id line
c
      WRITE(IDLINE(61:75),'(i4,5I2)')
     *YEAR,MONTH,DAY,HR,MIN,ISEC
      DO I=61,74
         IF(IDLINE(I:I).EQ.' ') IDLINE(I:I)='0'
      ENDDO
c
c   close and delete input file
c
      close (read01,status='delete') ! close
C                                                                               
C  OPEN AND WRITE OUTPUT FILE                                                   
C
 3    continue                 ! get here from below when file did exist
      IF(BASE(1:2).NE.',,') THEN                                                    
         chr_file = top_directory(1:topdirlen)//dchar//'REA'//outfl
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    chr_file,              ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
            sfil=chr_file
      ELSE
            call sei open(unknown$+warn$,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    outfl,                 ! File name
     &                    write01,               ! Write unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
            sfil=outfl
      ENDIF
c
c   make new index
c
      if(b_old) then
          write(6,*)' Creating a new id for event'
          call inc_id(idline,outfl,nf)
          call sei close (close$,write01,code) ! close
          goto 3                            ! go and try to open again
      endif
c
  10  continue 
C
C   WRITE FILE
C                                  

C                                                                     
c-- ORIGINAL HEADER LINES FIRST
C   IF NO ID LINE, PUT IN AS NUMBER 2
C
          write(write01,'(a80)',iostat=code) data(1)
          call sei code(fort$,code,write01,b_eof)
c
c   put in id update lock
c
      idline(76:76)=id_to_lock
c
c  if new id line, write as #2, else where it was before
c
      if(id.eq.0) then
          write(write01,'(a80)',iostat=code) idline
          call sei code(fort$,code,write01,b_eof)
      else
         data(id)=idline
      endif
c
c   write rest of header lines, skip format help lines
c
      if(nhead.ge.2) then
	     do i=2,nhead 
            if(data(i)(80:80).ne.'7') then
               write(write01,'(a80)',iostat=code) data(i)
            endif
	     enddo
      endif
      call sei code(fort$,code,write01,b_eof)
C
c-- write help line 
C
      write(write01,243,iostat=code)
      call sei code(fort$,code,write01,b_eof)
 243  FORMAT(
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO ',
c     *'SNR AR TRES W  DIS CAZ7')              
     *'AIN AR TRES W  DIS CAZ7')              
c-- WRITE REST OF EVENT         
       write(write01,'(a80)',iostat=code)
     * (data(i),i=nhead+1,nrecord)
      call sei code(fort$,code,write01,b_eof)
      call sei close (close$,write01,code)
c
 2    continue
      return                                                                      
      END                                                                       
                                                                                

c
c   simple program to make a least squres calculation between two data sets 
c   in a two column file and plot the relation
c
c   nov 98 by jh: ----------verison 7.09 check, no change -----------------
c   
c   mar 22 99 bmt: include winplot.inc 
c   jun 24 02 jh : include gmtxy
c   jun 20 05 jh : plt to eps
c   dec 13 05 jh : put in max likelihood

c      implicit none                      ! cannot be used on PC
      include 'winplot1.inc'              ! for windows graphics
      include 'gmt_xy_par.inc'            ! include block for gmt_xy routines

      include 'seiplot.inc'               ! seisan graphics
      include 'version.inc'               ! version

      real x(90000),y(90000)              ! xy values
      real xm,ym                          ! help variables
      real x1,x2,y1,y2                    ! help varibales
      character*1 cha(10)                 ! dummy for xy_plot
      character*80 text                   ! general text
      character*80 title                  ! title for plot      
      character*30 xtext,ytext            ! axis title
      character*80 fname                  ! input file name 
      character*1 make_plot               ! choise if making plot
      integer n,i 
      real a,b,corr,rms                   ! for lsq relation
      real sigmaa,sigmab                  ! errors
      integer reg                         ! which regression
      include 'winplot2.inc'              ! for windows graphics  

c
c   print version
c
      out_version_date='June 24, 2003'
      if (version_new) out_version_date=version_date
      call print_ver
c
c   get input file name


      write(6,*)'File name'
      read(5,'(a)') fname
      open(1,file=fname,err = 5,status='old') 
      goto 6
 5    continue
      write(6,*) ' Errror with file or file not there'
      write(6,*) ' Return to stop'
      read(5,'(a)') i
      stop
 6    continue

      n=1
 10   continue
c
c   read file
c
      read(1,*,end=20,err=20) x(n),y(n)
      n=n+1
      goto 10
 20   continue
      n=n-1
      write(6,*)' Number of points: ',n
      if(n.lt.2) then
         write(6,*) ' Not enough points, return to stop'
         read(5,'(a)') n
         stop
      endif

      close(1)
      write(6,*) 'Least squares (1) or maximum likelihood (2) ?'
      read(5,*) reg
      if(reg.eq.1) then
c
c   find least squares relation
c
         call lsqlin(n,x,y,a,b,corr,rms)
      else
c
c   find max likelihood
c
         call maxlik(x,y,n,a,b,sigmaa,sigmab)
      endif

	 
c
c   check if plot of reltion on screen	
c

      write(6,*) ' Plot relation (y/n)'
      read(5,'(a)') make_plot
      if((make_plot.eq.'y') .or. (make_plot.eq.'Y')) then
    
		
c
c  set defaults for output on screen and one hardcopy file
c
          open(65,file='lsq.eps',status='unknown')  ! open postscript output file
          plotunit=65                               ! use unit 65 for output
          plotoption=1                              ! plot ps
          hctype=1                                  ! is ps unit
          wsize=60                                  ! use 60 % of screen

c
c set some postscipt scalings
c
          write(65,*) ' 1.0 0.55 scale'
c
c   make titles
c
          if(reg.eq.1) then
             write(title,'(a,f7.3,a,f7.3)')
     *      'Least squares relation: y = ',b,' * x + ',a
          else
             write(title,'(a,f7.3,a,f7.3)')
     *      'Maximum liklihood     : y = ',b,' * x + ',a
          endif
          xtext='                   '                ! no title on x-axis
          ytext='                   '                ! no title on y-axis
c
c   open plotter
c
          call open_display 
c
c   plot coordinate system and points with seisan routine
c
          call xy_plot
     *    (1,n,x,y,title,xtext,ytext,
     *    600.0,600.0,100.0,100.0,1,1,20.0,
     *    0,cha,i,x,y)
c
c   plot line with seisan routine given equation for line and size of coordinate system
c
          call xy_plot_line(b,a,100.0,100.0)
          text='Push any key to stop'
          call  tchars(text,20,750.0,700.0)   ! put command on plot
c
c   call up cursxor so plots remains and wait for input from keyboard
c	 
495       continue
          call xscursr(i,xm,ym)
          if (char(i).eq.'#') goto 495
c
c   close postscript output
c
          call close_post
c
c   close output plot file
c 
          close(65)
c
c   close display and back to alpha screen
c
           call clear_to_alpha
      endif
c
c----------------------------------------------------------
c   make gmt_xy file
c----------------------------------------------------------
c
      call gmt_xy_init                 ! set default gmt parameters
c
c   gmt main header settings
c
      gmt_xtitle='X-axis'
      gmt_ytitle='Y-axis'
      gmt_maintitle='Main title'       ! title
      gmt_xsize=12.0                   ! y-size in cm
      gmt_xlog=0                       ! linear
      gmt_ysize=10.0                   ! x-size in cm
      gmt_ylog=0                       ! linear
      gmt_ntraces=2                    ! two data sets, points and line

c
c  open gmt file and write out main parameters
c
      open(16,file='lsq_gmt.out',
     *status='unknown')

      call gmt_xy_par(16,1,1,x,y)
c
c    set some parameters for first data set, the points
c
      gmt_linestyle=' '                ! do not join points
      gmt_tracesymbol='d'              ! diamond as a symbol
      gmt_scaling=1.1                  ! increase size of plot by 10 %
c
c   write out xy data for first data set
c
      call gmt_xy_par(16,0,n,x,y)
c
c   calculate two endpoints of line so within plot
c

      x1=gmt_minx
      y1=b*x1+a
      if(y1.gt.gmt_maxy) then
          y1=gmt_maxy
          x1=(y1-a)/b
      endif
      if(y1.lt.gmt_miny) then
          y1=gmt_miny
          x1=(y1-a)/b
      endif
c
      x2=gmt_maxx
      y2=b*x2+a
      if(y2.gt.gmt_maxy) then
          y2=gmt_maxy
          x2=(y2-a)/b
      endif
      if(y2.lt.gmt_miny) then
          y2=gmt_miny
          x2=(y2-a)/b
      endif
      x(1)=x1
      x(2)=x2
      y(1)=y1
      y(2)=y2
c
c    set some parameters for second data set1
c
      gmt_linestyle='solid'            ! join points
      gmt_tracesymbol=' '              ! no symbol for end points of line
      gmt_scaling=1.0                  ! normal size now              
      gmt_tracetitle='lsq line'        ! title for 2. trace
c
c   write out xy data, in this case just the line end points
c
      n=2
      call gmt_xy_par(16,0,n,x,y)
c
c   close gmtxy file
c
      close(16)


      write(6,*)' Plot file is lsq.eps'
      write(6,*)' gmt_xy plot file is lsq_gmt.out'
        
      stop
      end
C***********************************************************************
C                                                                    
      SUBROUTINE LSQLIN(N,X,Y,A,B,CORR,RMS)                               
C                                                                       
C  REGRESSION LINE WITH PARAMETERS A AND B
C  Y=A+BX                              
C                                                                       
      DIMENSION X(1),Y(1)
      INTRINSIC SQRT                                         
      REAL NEV
      SX=0.0                                                            
      SY=0.0                                                            
      SXY=0.0                                                           
      SXS=0.0                                                       
      DO 1 I=1,N                                                       
      SX=SX+X(I)                                                        
      SY=SY+Y(I)                                                        
      SXY=SXY+X(I)*Y(I)                                                 
      SXS=SXS+X(I)*X(I)                                                 
 1    CONTINUE                                                          
      D1=REAL(N*SXS-SX*SX)                                                   
      IF (ABS(D1).LT.10E-6) GOTO 3     
      A=REAL(SY*SXS-SX*SXY)/(D1)                                            
      B=REAL(SXY*N-SX*SY)/(D1)
      RMS=0.0               
      TEL=0.0
      WVX=0.0
      WVY=0.0
      RX=SX/REAL(N)
      RY=SY/REAL(N)                              
      DO 2 I=3,N
      TEL=TEL+(X(I)-RX)*(Y(I)-RY)
      WVX=WVX+(X(I)-RX)**2
      WVY=WVY+(Y(I)-RY)**2
      RMS=RMS+(Y(I)-A-B*X(I))**2
 2    CONTINUE
      ARG=WVX*WVY
      IF (ARG.LT.10E-6) GOTO 4
      NEV=SQRT(ARG)
      CORR=TEL/NEV
      RMS=SQRT(RMS/N)
      RETURN                       
 3    A=0.0                                      
      B=0.0  
 4    RMS=0.0                                                           
      CORR=0.0
      RETURN                                                            
      END                                                               
C
c-----------------------------------------------------------------------------

C+
C	SUBROUTINE AN2DSR(A,N,ANGS,PI)
C
C	Calculates dip, strike and rake (ANGS) - A&R convention,
C		from A and N.
C	12 January 2000:  Fixed a divide by zero when angs(1) .eq. 0
C	1 October 2001: When porting to the PC, there were roundoff
C		errors when acos was near its limits.
C-
	SUBROUTINE AN2DSR(A,N,ANGS,PI)
	REAL N(3),A(3),ANGS(3)
	if (N(3) .eq. -1.0) then
	  angs(2) = atan2(a(2),a(1))
	  angs(1) = 0.0
	else
	  ANGS(2) = ATAN2(-N(1),N(2))
	  if (N(3) .eq. 0.0) then
	    angs(1) = 0.5*PI
	  else IF (ABS(SIN(ANGS(2))) .ge. 0.1) then
	    ANGS(1) = ATAN2(-N(1)/SIN(ANGS(2)),-N(3))
	  else
	    ANGS(1) = ATAN2(N(2)/COS(ANGS(2)),-N(3))
	  end if
	end if
	A1 = A(1)*COS(ANGS(2)) + A(2)*SIN(ANGS(2))
	if (abs(a1) .lt. 0.0001) a1 = 0.0
	if (a(3) .ne. 0.0) then
	  if (angs(1) .ne. 0.0) then
	    ANGS(3) = ATAN2(-A(3)/SIN(ANGS(1)),A1)
	  else
	    ANGS(3) = atan2(-1000000.0*A(3),A1)
	  end if
	else
	  a2 = a(1)*sin(angs(2)) - a(2)*cos(angs(2))
	  if (abs(a2) .lt. 0.0001) a2 = 0.0
	  if (abs(sin(2*angs(2))) .ge. 0.0001) then
	    angs(3) = atan2(a2/sin(2*angs(2)),a1)
	  else if (abs(sin(angs(2))) .ge. 0.0001) then
	    acosarg = amin1(1.0,amax1(-1.0,a(2)/sin(angs(2))))
	    angs(3) = acos(acosarg)
	  else
	    acosarg = amin1(1.0,amax1(-1.0,a1))
	    angs(3) = acos(a1)
	  end if
	end if
	IF (ANGS(1) .lt. 0.0) then
	  ANGS(1) = ANGS(1) + PI
	  ANGS(3) = PI - ANGS(3)
	  IF (ANGS(3) .GT. PI) ANGS(3) = ANGS(3) - 2*PI
	end if
	IF(ANGS(1) .gt. 0.5*PI) then
	  ANGS(1)=PI-ANGS(1)
	  ANGS(2)=ANGS(2)+PI
	  ANGS(3)=-ANGS(3)
	  IF (ANGS(2) .GE. 2*PI) ANGS(2) = ANGS(2) - 2*PI
	end if
	IF (ANGS(2) .LT. 0.0) ANGS(2) = ANGS(2) + 2.0*PI
	RETURN
	END
C+
	SUBROUTINE AN2MOM(A,N,MOMTEN)
C
C	Starting with the A and N axis, calculates the elements
C	  of the moment tensor with unit scalar moment.
C	  Coordinate system:  X = North, Y = East, Z = Down
C	  Convention used is that of Dziewonski & Woodhouse
C	  (JGR 88, 3247-3271, 1983) and Aki & Richards (p 118)
C	24 September 1985: If an element is < 0.000001 (ABS), set to zero
C-
	REAL*4 A(3), N(3), MOMTEN(6)
C	      Moment tensor components:  M(I,j) = A(I)*N(J)+A(J)*N(I)
	MOMTEN(1) = 2.0*A(3)*N(3)	!  MRR = M(3,3)
	MOMTEN(2) = 2.0*A(1)*N(1)	!  MTT = M(1,1)
	MOMTEN(3) = 2.0*A(2)*N(2)	!  MPP = M(2,2)
	MOMTEN(4) = A(1)*N(3)+A(3)*N(1)	!  MRT = M(1,3)
	MOMTEN(5) = -A(2)*N(3)-A(3)*N(2)!  MRP = -M(2,3)
	MOMTEN(6) = -A(2)*N(1)-A(1)*N(2)!  MTP = -M(2,1)
	DO 100 J=1,6
	  IF (ABS(MOMTEN(J)) .LT. 0.000001) MOMTEN(J) = 0.0
100	CONTINUE
	RETURN
	END
C+
	SUBROUTINE ANTPIN (ANBTP,ANGS,ANGS2,PTTP,MOMTEN,PI)
C
C	Calculates other representations of fault planes with
C		trend and plunge of A and N as input.  All
C		angles are in radians.
C	22 July 1985:  Added moment tensor output.
C-
	REAL N(3), MOMTEN(6)
	DIMENSION PTTP(4),ANGS(3),ANGS2(3),ANBTP(6),P(3),T(3),A(3),B(3)
	DATA SR2/0.707107/
	CALL TRPL2V(ANBTP(1),A)
	CALL TRPL2V(ANBTP(3),N)
	DO 100 J=1,3
	  T(J) = SR2*(A(J) + N(J))
	  P(J) = SR2*(A(J) - N(J))
100	CONTINUE
	B(1) = P(2)*T(3) - P(3)*T(2)
	B(2) = P(3)*T(1) - P(1)*T(3)
	B(3) = P(1)*T(2) - P(2)*T(1)
	CALL V2TRPL(P,PTTP(1),PI)
	CALL V2TRPL(T,PTTP(3),PI)
	CALL V2TRPL(B,ANBTP(5),PI)
	CALL AN2DSR(A,N,ANGS,PI)
	CALL AN2DSR(N,A,ANGS2,PI)
	CALL AN2MOM(A,N,MOMTEN)
	RETURN
	END
C+
	subroutine cstring(string,nstring)
C
C	Input a character string with a read(*,'(A)') string
C	If first two characters are /* it will read the next entry
C	Tab is a delimiter.
C	Returns string and nstring, number of characters to tab.
C	string stars with first non-blank character.
C       25 May 2001.  Took out parameter statement for tab.
C-
	logical more
	CHARACTER*1 TAB
	CHARACTER*(*) string
C
	tab = char(9)
	more = .true.
	do while (more)
	  read(*,'(A)') string
	  nstring = lenc(string)
	  more = (nstring.ge.2 .and. string(1:2).eq.'/*')
	end do
	IF (nstring .GT. 0) THEN
	  NTAB = INDEX(string(1:nstring),TAB)
	  IF (NTAB .GT. 0) nstring = NTAB - 1
	end if
	return
	end
C+
	character*(*) function cvalue(msg,default,nout)
C
C	MSG gets printed on screen prompting for a character string.
C	DEFAULT is the default string.  NOUT is the number of characters
C	  returned in cvalue.
C	A tab in the input acts as a terminator.
C       27 July 1993: Did input read through cstring so can have 
C         comment lines
C	25 May 2001.  Took out parameter statement for tab.
C-
	character*1 tab
	character*(*) msg,default
	character*80 input
C
        tab = char(9)
	call printx(msg)
	call cstring(input,nout)
c  Kill leading blanks
        do while (nout.gt.0 .and. input(1:1).eq.' ')
          nout = nout - 1
          input(1:nout) = input(2:nout+1)
          input(nout+1:nout+1) = ' '
        end do
	if (nout .eq. 0) then
	  nout = lenc(default)
	  cvalue = default(1:nout)
	else
	  cvalue = input(1:nout)
	end if
	return
	end
C+
	SUBROUTINE DSRIN (ANGS,ANBTP,ANGS2,PTTP,MOMTEN,PI)
C
C	Calculates other representations of fault planes with
C		dip, strike and rake (A&R convinention) input.  All
C		angles are in radians.
C	22 July 1985:  Added moment tensor output (D&W convention)
C	               normalized to unit scalar moment
C	1 October 2001: When ported to the PC, on one compiler there
C		was a roundoff problem for limiting cases.  Included
C		a fix.
C-
	REAL N(3), MOMTEN(6)
	DIMENSION PTTP(4),ANGS(3),ANGS2(3),ANBTP(6),P(3),T(3),A(3),B(3)
	DATA SR2/0.707107/
	RAKE=ANGS(3)
	STR = ANGS(2)
	DIP = ANGS(1)
	A(1) = COS(RAKE)*COS(STR) + SIN(RAKE)*COS(DIP)*SIN(STR)
	A(2) = COS(RAKE)*SIN(STR) - SIN(RAKE)*COS(DIP)*COS(STR)
	A(3) = -SIN(RAKE)*SIN(DIP)
	N(1) = -SIN(STR)*SIN(DIP)
	N(2) = COS(STR)*SIN(DIP)
	N(3) = -COS(DIP)
	do j=1,3
          if (abs(A(j)) .le. 0.0001) A(j) = 0.0
          IF ((ABS(A(j))-1.0) .gt. 0.0) A(j)=A(j)/abs(A(j))
          if (abs(N(j)) .le. 0.0001) N(j) = 0.0
          IF ((ABS(N(j))-1.0) .gt. 0.0) N(j)=N(j)/abs(N(j))
        end do
	CALL V2TRPL(A,ANBTP(1),PI)
	CALL V2TRPL(N,ANBTP(3),PI)
	DO 100 J=1,3
	T(J) = SR2*(A(J) + N(J))
100	P(J) = SR2*(A(J) - N(J))
	B(1) = P(2)*T(3) - P(3)*T(2)
	B(2) = P(3)*T(1) - P(1)*T(3)
	B(3) = P(1)*T(2) - P(2)*T(1)
	CALL V2TRPL(P,PTTP(1),PI)
	CALL V2TRPL(T,PTTP(3),PI)
	CALL V2TRPL(B,ANBTP(5),PI)
	CALL AN2DSR(N,A,ANGS2,PI)
	CALL AN2MOM(A,N,MOMTEN)
	RETURN
	END
C+
C	SUBROUTINE FLTSOL(A,N,BMATRX,PLUNGE,TREND,ANGLE,JA)
C
C	Called by SRCHFM, a subroutine of FOCMEC
C	Calculates the A and N vectors (Herrmann's X and Y)
C		for a given trend and plunge for the B axis
C		and  an ANGLE relative to a reference.
C
C	Arthur Snoke  Virginia Tech  May 1984
C-
	SUBROUTINE FLTSOL(A,N,BMATRX,PLUNGE,TREND,ANGLE,JA)
	INCLUDE 'FOCMEC.INC'
	REAL*4 A(3), N(3), BMATRX(3,3),ZROT(3,3),YROT(3,3),ANZ(3,3)
	IF (JA .EQ. 1) THEN
		DO 100 J=1,3
		DO 100 K=1,3
		ZROT(J,K) = 0.0
100		YROT(J,K) = 0.0
C
C	Construct a rotation matrix to map X=North, Y=East,
C		Z=Down into A, N, B
C
C	First rotate about Z (= Down) through an angle TREND.
C		This rotates X into the trend of B
	ZROT(1,1) = COS(TREND)
	ZROT(2,2) = ZROT(1,1)
	ZROT(1,2) = SIN(TREND)
	ZROT(2,1) = -ZROT(1,2)
	ZROT(3,3) = 1.0
C
C	Now rotate about Y through an angle 90-PLUNGE.
C		This rotates the Z axis into B.
C
	YROT(1,1) = SIN(PLUNGE)
	YROT(3,3) = YROT(1,1)
	YROT(3,1) = COS(PLUNGE)
	YROT(1,3) = -YROT(3,1)
	YROT(2,2) = 1.0
C
C	BMATRX is the product of YROT and ZROT
C
	CALL GMPRD(YROT,ZROT,BMATRX,3,3,3)
C
C	BMATRX does not change as ANGLE changes
C
	ENDIF
C
C	Rotate about Z (= B) through an angle ANGLE.
C		This rotates X into A and N into Y.
C	Inverse of matrix rotating by ANGLE about B
C
C
	ZROT(1,1) = COS(ANGLE)
	ZROT(2,2) = ZROT(1,1)
	ZROT(1,2) = SIN(ANGLE)
	ZROT(2,1) = -ZROT(1,2)
	ZROT(3,3) = 1.0
C
C	ANZ is the product of ZROT and BMATRX
C
	CALL GMPRD(ZROT,BMATRX,ANZ,3,3,3)
	DO 200 J=1,3
	A(J) = ANZ(1,J)		!  A is 1st row of ANZ
200	N(J) = ANZ(2,J)		!  N is 2nd row of ANZ
	RETURN
	END
C+
	SUBROUTINE FMREPS(ANBTP,ANGS,PTTP,ANGS2,AN,PT,DSR,mt,MOMTEN,
     .	  LUNIT1,LUNIT2)
C
C	Input: A and N (trned and plunge), or P and T or dip, strike
C	  and rake (A&R convention) or moment tensor (A&R)
C	Output: the other representations plus the auxiliary plane.
C	PTTP:  4 parameters, trend and plunge for P and T
C	  P trend and plunge, T trend and plunge
C	ANBTP  6 parameters, t and p for A, N and B respectively.
C	ANGS   3 parameters,  dip, strike and rake for first plane
C	ANGS2  3 parameters, dip strike and rake for auxiliary plane
C	AN, PT, DSR are LOGICAL variables which are true if
C	  A and N, P and T or dip-strike-rake are input
C	MOMTEN  6 parameters:  the moment tensor (unit scalar
C	  magnitude) D & W convention
C	Angles come in and go out in degrees.
C	If LUNIT1 and/or LUNIT2 are positive, the representations
C	  are written on those logical unit numbers.
C	22 July 1985:  Added moment tensor output
C	30 October 1992:  Fixed up problem if lunit2=5.
C	15 March 2002:  Added moment-tensor input, changed MFF to MPP, etc.
C-
	LOGICAL AN,PT,DSR,MT
	REAL*4 MOMTEN(6)
	INTEGER LUNIT1, LUNIT2
	DIMENSION PTTP(4),ANGS(3),ANGS2(3),ANBTP(6)
	RDEG = 45.0/ATAN(1.0)
	PI = 4.0*ATAN(1.0)
	IF (MT) then
	  call mt_in(PTTP,PI)
	  CALL PTTPIN(PTTP,ANGS,ANGS2,ANBTP,MOMTEN,PI)
	else IF (PT) THEN
	  DO 100 J=1,4
100	  PTTP(J) = PTTP(J)/RDEG
	  CALL PTTPIN(PTTP,ANGS,ANGS2,ANBTP,MOMTEN,PI)
	ELSE IF (AN) THEN
	  DO 200 J=1,4
200	  ANBTP(J) = ANBTP(J)/RDEG
	  CALL ANTPIN(ANBTP,ANGS,ANGS2,PTTP,MOMTEN,PI)
	ELSE if (DSR) then
	  DO 300 J=1,3
300	  ANGS(J) = ANGS(J)/RDEG
	  CALL DSRIN(ANGS,ANBTP,ANGS2,PTTP,MOMTEN,PI) 
	END IF
	DO 400 I=1,3
	  ANGS(I) = ANGS(I)*RDEG
	  ANGS2(I) = ANGS2(I)*RDEG
	  PTTP(I) = PTTP(I)*RDEG
  	  ANBTP(I) = ANBTP(I)*RDEG
400	CONTINUE
	ANBTP(4) = ANBTP(4)*RDEG
	ANBTP(5) = ANBTP(5)*RDEG
	ANBTP(6) = ANBTP(6)*RDEG
	PTTP(4) = PTTP(4)*RDEG
	IF (LUNIT1 .GT. 0) THEN
	  WRITE (LUNIT1,1) (ANGS(I),I=1,3)
	  WRITE(LUNIT1,2)(ANGS2(I),I=1,3),'   Auxiliary Plane'
	  WRITE (LUNIT1,3) (ANBTP(J),J=1,4)
	  WRITE(LUNIT1,4) (ANBTP(J),J=5,6)
	  WRITE(LUNIT1,5) PTTP
	  WRITE(LUNIT1,6) MOMTEN
	END IF
	IF (LUNIT2 .GT. 0) THEN
	  if (lunit2 .eq. 5) then
	    WRITE (*,1) (ANGS(I),I=1,3)
	    WRITE(*,2)(ANGS2(I),I=1,3),'   Auxiliary Plane'
	    WRITE (*,3) (ANBTP(J),J=1,4)
	    WRITE(*,4) (ANBTP(J),J=5,6)
	    WRITE(*,5) PTTP
	    WRITE(*,6) MOMTEN
	  else
	    WRITE (LUNIT2,1) (ANGS(I),I=1,3)
	    WRITE(LUNIT2,2)(ANGS2(I),I=1,3),'   Auxiliary Plane'  
	    WRITE (LUNIT2,3) (ANBTP(J),J=1,4)
	    WRITE(LUNIT2,4) (ANBTP(J),J=5,6)
	    WRITE(LUNIT2,5) PTTP
	    WRITE(LUNIT2,6) MOMTEN
	  end if
	END IF
	RETURN
C
1	FORMAT(5X,'Dip,Strike,Rake ',3F9.2)
2	FORMAT(5X,'Dip,Strike,Rake ',3F9.2,A)
3	FORMAT(5X,'Lower Hem. Trend, Plunge of A,N ',4F9.2)
4	FORMAT(5X,'Lower Hem. Trend & Plunge of B ',2F9.2)
5	FORMAT(5X,'Lower Hem. Trend, Plunge of P,T ',4F9.2)
6	FORMAT(5X,'MRR =',F5.2,'  MTT =',F5.2,'  MPP =',F5.2,
     .	  '  MRT =',F5.2,'  MRP =',F5.2,'  MTP =',F5.2)
	END
C+
	SUBROUTINE FOCINP
C
C	Input routine for FOCMEC
C
C	Arthur Snoke  Virginia Tech  May 1984
C	Last perturbed 12 October 1990
C	20 August 1991:  sun version.  call assign replaced by open
C	31 August:  expanded to include SV polarities and SV/SH ratios
C	15 May 1992:  Changed name of listing file from lp.lst to 
C		focmec.lst
C	19 June 1993: Separate P and S errors should now work
C	20 Jun 1993:  Belts and braces:  If someone uses a ratio with
C	  no input S take-off angle, now sets it equal to P angle
C	2 August 1993:  Changed rules for ratios near nodal surfaces
C	6 January 1997:  format change
C	7 April 2000: sense='R' no longer allowed for ratios.  First TOANG
C	  is not necessarily for P (if an SH or SV polarity is to be used)
C	1 October 2001: When porting to a PC, found some compilers could
C		not handle reading in an integer for a floating-pint
C		variable (number of polarity errors), so "fixed" it.
C	26 March 2002: If emergent polarity data are included, now it
C		will ask if you want to include it.  Previously it 
C		ignored such data.
C	5 July 2002: Some compilers do not like the way I had used
C	  CVALUE -- CVALUE(1:NFILE) with NFILE defined on the right-hand side.
C-
	INCLUDE 'FOCMEC.INC'
	CHARACTER*1 SENSE,SNUMPOL
	CHARACTER*80 COMMNT,FILENA,CVALUE,DUMMY
	LOGICAL TRUTH, relweight, pguess
	CHARACTER*40 INFO
	RD = 45.0/ATAN(1.0)		
	open(2,file='focmec.lst',status='unknown')
	FILENA = 
     1    CVALUE('Output file name (for plotting) [focmec.out]',
     2    'focmec.out',NFILE)
	open(3,file=filena(1:nfile),status='unknown')
	CALL TIMDAT(2,'FOCMEC')
	CALL TIMDAT(3,'FOCMEC')
	COMMNT =
     1    CVALUE('Comment - up to 80 characters',DUMMY,NCOM)
	WRITE(2,'(1X,A)') COMMNT(1:NCOM)
	WRITE(3,'(1X,A)') COMMNT(1:NCOM)
100	FILENA = CVALUE('Input filespec',DUMMY,NFILE)
	OPEN(UNIT=1,NAME=FILENA(1:NFILE),STATUS='OLD',ERR=100)
	READ(1,'(A)') COMMNT
	ncom = lenc(commnt)
	WRITE(*,'(1X,A)') COMMNT(1:NCOM)
	IF (.NOT.TRUTH('Correct file?...[Y]')) GO TO 100
C
	WRITE(2,3) FILENA(1:NFILE)
	WRITE(3,3) FILENA(1:NFILE)
	WRITE(2,'(1X,A)') COMMNT(1:NCOM)
	WRITE(3,'(1X,A)') COMMNT(1:NCOM)
	WRITE(2,4)
	NRAT = 0
	NPOL = 0
	NPPOL = 0
	NSVPOL = 0
	NSHPOL = 0
	J = 0
	NGUESS = 0
200	read(1,'(a)',end=300) commnt
	ncom = lenc(commnt)
	if (ncom .lt. 40) then
	  read(commnt(1:21),'(A4,2F8.2,A1)') STA,AZIN,TOANG1,SENSE
	else
	  READ(commnt,5,END=300) STA,AZIN,TOANG1,SENSE,
     .	    RATLOG,SNUMPOL,TOANG2,INFO
	end if
	  IF (SENSE.EQ.'V' .OR. SENSE.EQ.'S' .OR. SENSE.EQ.'H') THEN
	    J = J + 1
	    IF (J .GT. MAX2) GO TO 300
	    stoang = toang1
	    ptoang = toang2
	    NRAT = NRAT + 1
	    LOGRAT(NRAT) = RATLOG
	    SVSH(2,NRAT) = SNUMPOL
	    RSTATN(NRAT) = STA
	    NADD = 0
	    SVSH(1,NRAT) = SENSE
	    IF (SENSE .EQ. 'H') NADD = 1000
	    IF (SENSE .EQ. 'S') NADD = 2000
	    WRITE(2,6) RSTATN(NRAT),AZIN,TOANG1,SENSE,LOGRAT(NRAT),
     .	      SVSH(1,NRAT),SVSH(2,NRAT),TOANG2,INFO(1:lenc(info))
	    KEYRAT(NRAT) = J + NADD
	  ELSE
	    WRITE(2,6) STA,AZIN,TOANG1,SENSE
	    IF (SENSE .EQ. 'U') SENSE = 'C'
            if (sense .eq. 'R') sense = '>'
            if (sense .eq. 'L') sense = '<'
	    if (sense.eq.'+' .or. sense.eq.'-' .or. sense.eq.'l'
     1	        .or. sense.eq.'r') then
	      if (nguess .eq. 0) then
	        nguess = 1
		pguess = truth('Include emergent polarity picks?..[Y]')
	      end if
	      if (pguess) then
	        IF (SENSE .EQ. '+') SENSE = 'C'
		IF (SENSE .EQ. '-') SENSE = 'D'
		IF (SENSE .EQ. 'l') SENSE = '<'
		IF (SENSE .EQ. 'r') SENSE = '>'
	      end if
	    end if
	    IF(.NOT.(SENSE.EQ.'C' .OR. SENSE.EQ.'D'
     .        .OR. SENSE .EQ. 'F' .OR. SENSE .EQ. 'B'
     .	      .OR. SENSE .EQ. '<' .OR. SENSE .EQ. '>')) GO TO 200
	      J = J + 1
	      IF (J .GT. MAX2) GO TO 300
	      stoang = toang1
	      ptoang = toang1
	      IF (SENSE .EQ. '<' .OR. SENSE .EQ. '>') THEN
	        NSHPOL = NSHPOL + 1
		if (sense .eq.'R') sense = '>'
	        if (sense .eq. 'L') sense = '<'
	        NADD = 2000
	      ELSE IF (SENSE .EQ. 'F' .OR. SENSE .EQ. 'B') THEN
	        NSVPOL = NSVPOL + 1
	        NADD = 1000
	      ELSE
	        NPPOL = NPPOL + 1
	        NADD = 0
	      END IF
	      NPOL = NPOL + 1
	      KEYPOL(NPOL) = J + NADD
	      PSTATN(NPOL) = STA
	      IF (SENSE .EQ. 'C' .OR. SENSE .EQ. '<'
     .          .OR. SENSE .EQ. 'F') THEN
	             POLRTY(NPOL) = 1
	      ELSE
	             POLRTY(NPOL) = -1
	      END IF
	  ENDIF
	  TREND = AZIN/RD
	  PLUNGE = (90.0 - PTOANG)/RD 
	  COST = COS(TREND)
	  SINT = SIN(TREND)
	  COSP = COS(PLUNGE)
	  SINP = SIN(PLUNGE)
	  XYZ(1,J) = COST*COSP
	  XYZ(2,J) = SINT*COSP
	  XYZ(3,J) = SINP
	  SPLUNG = (90.0 - STOANG)/RD
	  SINP = SIN(SPLUNG)
	  COSP = COS(SPLUNG)
C
C	Next two vectors reversed in sign from normal convention because
C	  of my convention for SV and SH (down and left, facing the station)
C
	  XYZ(4,J) = -COST*SINP
	  XYZ(5,J) = -SINT*SINP
	  XYZ(6,J) = +COSP
	  XYZ(7,J) = SINT
	  XYZ(8,J) = -COST
	  XYZ(9,J) = 0.0
	  GO TO 200
300	CLOSE(UNIT=1)
	WRITE(*,7) NPPOL,NSVPOL,NSHPOL,NRAT
	IF (NPOL .LE. 0) THEN
	  WRITE(2,8)
	  WRITE(3,8)
	  GO TO 400
	ELSE
	  write(*,*) ' Can have relative weighting for polarity errors'
	  write(*,*) '  In this case, weight = theor. rad. factor'
	  write(*,*) '  above a chosen threshold'
	  IF (TRUTH('Want relative weighting?..[N]')) THEN
	    THRESH = RVALUE('Lower threshold for weighting [0.1]',0.1)
	    relweight = .true.
	  ELSE
	    THRESH = 1.0
	    relweight = .false.
	  END IF
	END IF
	IF (NPPOL .GT. 0 .AND. (NSHPOL .GT. 0
     .      .OR. NSVPOL .GT. 0)) THEN
	  WRITE(*,*) 'Options:    Total polarity errors'
	  WRITE(*,*) '         or Separate P and S error limits'
	  IF (TRUTH('Total polarity error option?..[Y]')) THEN
	    if (relweight) then
	      ERR = VALUE('Total number of errors (floating point)')
	      WRITE(3,17) NPPOL,NSVPOL,NSHPOL,ERR,THRESH
	      WRITE(2,17) NPPOL,NSVPOL,NSHPOL,ERR,THRESH
	    else
	      NERR = VALUE('Total number of errors (integer)')
	      err = nerr
	      WRITE(3,18) NPPOL,NSVPOL,NSHPOL,NERR
	      WRITE(2,18) NPPOL,NSVPOL,NSHPOL,NERR 
	    end if
	    ERRP = ERR
            ERRSV = ERR
	    ERRSH = ERR
	    GO TO 400
	  END IF
	END IF
	IF (NPPOL .GT. 0) THEN
	  if (relweight) then
	    ERRP = RVALUE('Allowed P polarity errors..[0.0]',0.0)
	  else
	    NERRP = IVALUE('Allowed P polarity errors..[0]',0)
	    errp = nerrp
	  end if
	  IF (ERRP .GT. float(NPPOL)) ERRP = NPPOL
	else
	  errp = 0.0
	END IF
	IF (NSVPOL .GT. 0) THEN
	  if (relweight) then
	    ERRSV = RVALUE('Allowed SV polarity errors..[0.0]',0.0)
	  else
	    NERRSV = IVALUE('Allowed SV polarity errors..[0]',0)
	    errSV = nerrsv
	  end if
	  IF (ERRSV .GT. float(NSVPOL)) ERRSV = NSVPOL
	else
	  errsv = 0.0
	END IF
	IF (NSHPOL .GT. 0) THEN
	  if (relweight) then
	    ERRSH = RVALUE('Allowed SH polarity errors..[0.0]',0.0)
	  else
	    NERRSH = IVALUE('Allowed SH polarity errors..[0]',0)
	    errsh = nerrsh
	  end if
	  IF (ERRSH .GT. float(NSHPOL)) ERRSH = NSHPOL
	else
	  errsh = 0.0
	END IF
	err = errp + errsv + errsh
	If (nguess .eq. 1) then
		if (pguess) then
		  write(2,*) 'Including emergent polarity picks'
		  write(3,*) 'Including emergent polarity picks'
		else
		  write(2,*) 'Not including emergent polarity picks'
		  write(3,*) 'Not including emergent polarity picks'
		end if
	end if
	if (thresh .lt. 1.0) then
	  write(2,19) nppol,errp,nsvpol,errsv,nshpol,errsh,thresh
	  write(3,19) nppol,errp,nsvpol,errsv,nshpol,errsh,thresh
	else
	  nerrp = errp
	  nerrsv = errsv
	  nerrsh = errsh
	  write(2,9) NPPOL,NERRP,NSVPOL,NERRSV,NSHPOL,NERRSH
	  write(3,9) NPPOL,NERRP,NSVPOL,NERRSV,NSHPOL,NERRSH
	end if
400	IF (NRAT .LE. 0) THEN
	  WRITE(2,12)
	  WRITE(3,12)
	ELSE
	  VPVS = RVALUE('VP/VS ratio at source ...[1.732]',1.732)
	  ERRRAT = RVALUE('Maximum allowed log10 of ratio..[0.6]',0.6)
	  NERRR = IVALUE('Number of allowed amp. ratio errors..[0]',0)
	  write(*,*) 'Next two entries are for near nodal amplitudes'
	  write(*,*) 'CUTP is the lower bound for P radiation factor'
	  write(*,*) 'CUTS is the lower bound for S radiation factor'
	  write(*,*) 'Ratio is indeterminate if both calculated'
	  write(*,*) '    values less than the chosen CUT values'
	  CUTP = RVALUE('CUTP: lower-limit P cutoff...[0.05]',0.05)
	  CUTS = RVALUE('CUTS: lower-limit S cutoff...[0.15]',0.15)
	  IF (NERRR .GT. NRAT) NERRR = NRAT
	  WRITE(2,13) NRAT,NERRR,ERRRAT,VPVS
	  WRITE(2,*) CUTP,' = P radiation cutoff',CUTS,
     .	              ' = S radiation cutoff for ratios'
	  WRITE(3,13) NRAT,NERRR,ERRRAT,VPVS
	  WRITE(3,*) CUTP,' = P radiation cutoff',CUTS,
     .	              ' = S radiation cutoff for ratios'
	  VPVS3 = VPVS**3
	ENDIF
	MAXSOL = IVALUE('Exit after this many acceptable sols...[100]',
     .	  100)
	BTMIN = RVALUE('Minimum search value B trend..[0]',0.0)
	BTDEL = ABS(RVALUE('Increment for B trend..[5 degrees]',5.0))
	BTMAX = RVALUE('Maximum B trend..[355 degrees]',355.0)
	  BTMAX = AMAX1(BTMIN,AMIN1(BTMAX,359.0))
	BPMIN = RVALUE('Minimum search value B plunge..[0]',0.0)
	BPDEL = ABS(RVALUE('Increment for B plunge..[5 degrees]',5.0))
	BPMAX = RVALUE('Maximum B plunge..[90 degrees]',90.0)
	  BPMAX = AMAX1(BPMIN,AMIN1(BPMAX,90.0))
	WRITE(*,*) '"A" angle = zero in vertical plane of B trend'
	AAMIN = RVALUE('Minimum search value A angle..[0]',0.0)
	AADEL = ABS(RVALUE('Increment for A angle..[5 degrees]',5.0))
	AAMAX = RVALUE('Maximum A angle..[85 degrees]',85.0)
	  AAMAX = AMAX1(AAMIN,AMIN1(AAMAX,90.0-AADEL))
	WRITE(2,14) BTMIN,BTDEL,BTMAX,BPMIN,BPDEL,BPMAX,AAMIN,AADEL,
     1	  AAMAX
	WRITE(3,14) BTMIN,BTDEL,BTMAX,BPMIN,BPDEL,BPMAX,AAMIN,AADEL,
     1	  AAMAX
	WRITE(3,15)
	write(*,'('' '')')
	WRITE(*,15)
	write(2,16)
	RETURN
C
C
3	FORMAT(1X,'Input from a file ',A)
4	FORMAT(/' Statn',T9,'Azimuth',T18,'TOAng',T26,
     1	  'Key',T31,'Log10 (S/P)',T44,
     2	  'NumPol',T52,'DenTOAng',T62,'Comment')
5	FORMAT(A4,2F8.2,A1,F8.4,1X,A1,1X,F6.2,1X,A)
6	FORMAT(2X,A4,T10,F5.1,T19,F5.1,T27,A1,T32,F8.4,T41,'S',A1,T47,
     .	  A1,T53,F6.2,T60,A)
7	FORMAT(' Input:',I4,' P ',I4,' SV and ',I4,' SH polarities and,',
     .	  I4,' ratios')
8	FORMAT(' There are no polarity data')
9	FORMAT(' Polarities/Errors:  P ',I3.3,'/',I2.2,'  SV ',
     .    I3.3,'/',I2.2,'  SH ',I3.3,'/',I2.2)
12	  FORMAT(' There are no amplitude ratio data')
13	  FORMAT(' Input',I3,' ratios',I3,
     1	    ' allowed errors, maximum error of',
     2	    F5.2,'    VP/VS =',F6.3)
14	FORMAT(' The minimum, increment and maximum B axis trend are ',
     1	  3F8.2/' The limits for the B axis',
     2	  ' plunge are ',3F8.2/' The limits',
     3	  ' for the angle of the A axis are ',3F8.2)
15	FORMAT(T5,'Dip',T11,'Strike',T20,'Rake',T28,'Pol:',
     .    T33,'P',T39,'SV',T45,'SH',
     .	  T50,'Rat Err',T59,'RMS RErr',T70,'RErr (All)')
16       FORMAT(' ',79('+')/)
17	FORMAT(I4,' P Pol.',I3,' SV Pol.',I3,' SH Pol.',F5.1,' allowed',
     .	  ' (weighted) errors  Threshold =',F5.2)
18	FORMAT(I4,' P Pol.',I3,' SV Pol.',I3,' SH Pol.',I4,' allowed',
     .	  '  errors')
19	FORMAT(' Polarities/Errors:  P ',I3.3,'/',F4.1,'  SV ',
     .    I3.3,'/',F4.1,'  SH ',I3.3,'/',F4.1,'  Threshh. =',F5.2)
	END
C+
      SUBROUTINE GDMOT(RD,IPS,VSVP,AIN,AR,PHR,AV)
C
C  GDMOT GIVES GROUND DISPLACEMENT FOR INCIDENT P (IPS=1) OR S (IPS=2)
C  BULLEN (1963) P. 129 FOR INCIDENT P (BUT AIN=90-E)
C  AIN IS EMERGENCE ANGLE IN DEGREES RELATIVE TO VERTICAL
C  VSVP=VS/VP AT THE SURFACE
C  AV AND AR ARE THE VERTICAL AND RADIAL GROUND DISPLACEMENTS
C  FOR SV INC. BEYOND CRITICAL, PHV=PHR+90.
C     (AR MAY BE NEGATIVE IN THIS CASE - NOT REALLY AN AMPLITUDE)
C-
      COTAN(B) = 1.0/TAN(B)
      COTCOT(B)=1.-COTAN(B)**2
      PHR=0.0
      IF (AIN .EQ. 0.0) THEN
        AR=2.*(IPS-1)
	AV = 2*(2 - IPS)
      ELSE
        IF (IPS .EQ. 1) THEN
          A = AIN/RD
          B=ASIN(SIN(A)*VSVP)
          DEN=2.*COS(A)/(SIN(B)**2*(4.*COTAN(A)*COTAN(B)
     *      +COTCOT(B)**2))
          AR=2.*COTAN(B)*DEN
          AV=-COTCOT(B)*DEN
        ELSE IF (IPS .EQ. 2) then
          B=AIN/RD
          SA=SIN(B)/VSVP
          IF(SA .LE. 1.0) THEN
            A = ASIN(SA)
            DEN=2.*COTAN(B)/(SIN(B)*(4.*COTAN(A)*COTAN(B)
     *        +COTCOT(B)**2))
            AV = -2*COTAN(A)*DEN
            AR=-COTCOT(B)*DEN
          ELSE
            CTA=SQRT(1.-1./(SA*SA))
            DEN=2.*COTAN(B)/(SIN(B)*SQRT((4.*CTA*COTAN(B))**2
     *        +COTCOT(B)**4))
            AV=-2.*CTA*DEN
            AR=0.
            PHR = 90.0
            IF(COTCOT(B).EQ.0.0) RETURN
            AR=-COTCOT(B)*DEN
            PHR=ATAN2(4.*COTAN(B)*CTA,-COTCOT(B)**2)*RD
          END IF
        END IF
      END IF
      RETURN
      END
c+
	character*(*) function GETSTRING(prompt)
c
c  outputs 'prompt' using PRINTX
c  and accepts input character string
c				Alan Linde ... Aug 1986
C       27 July 1993: Did input read through cstring so can have 
C         comment lines
C	12 February 95:  Kill leading blanks
c-
	character*(*) prompt
	character*80 temp
	  getstring = ' '
c output 'prompt'
	call printx(prompt)
	kk=lenc(prompt)
	if (prompt(kk:kk).eq.']') then
	  ll=0
	  do i=kk-1,1,-1
	    if (prompt(i:i).eq.'['.and.ll.eq.0) ll=i+1
	  end do
	  if (ll.ne.0) getstring=prompt(ll:kk-1)
	end if
c  get the response
	call cstring(temp,nout)
c  Kill leading blanks
        do while (nout.gt.1 .and. temp(1:1).eq.' ')
          nout = nout - 1
          temp(1:nout) = temp(2:nout+1)
          temp(nout+1:nout+1) = ' '
        end do
	if (nout .gt. 0) getstring=temp(1:nout)
	return
	end
C+
C     SUBROUTINE GMPRD(A,B,R,N,M,L)
C
C     MULTIPLIES A N BY M MATRIX A TIMES A M BY L MATRIX B GIVING A N
C         BY L MATRIX R
C-
      SUBROUTINE GMPRD(A,B,R,N,M,L)
      DIMENSION A(1),B(1),R(1)
      IR=0
      IK=-M
      DO 10 K=1,L
      IK=IK+M
      DO 10 J=1,N
      IR=IR+1
      JI=J-N
      IB=IK
      R(IR)=0
      DO 10 I=1,M
      JI=JI+N
      IB=IB+1
   10 R(IR)=R(IR)+A(JI)*B(IB)
      RETURN
      END
C+
	Subroutine grndmtn(RDDEG,IPS,VRAT,aemrg,AR,AV,PhR,PhV)
C
C  Version of gdmot using equations from Hudson (or Aki & Richards)
C  aemrg IS EMERGENCE ANGLE IN DEGREES RELATIVE TO UPWARD VERTICAL
C  VRAT=VS/VP AT THE SURFACE
C  AV AND AR ARE THE VERTICAL AND RADIAL GROUND DISPLACEMENT AMPLITUDES
C  PhR and PhV are the phases (in degrees).
C  A and B are the amplitudes for the P and S parts of the reflected
C	waves.  Beyond the critical angle, the phases Ap and Bp are nonzero
C	as A and B become complex.  Below the critical angle A and B
C	can be negative.  In this routine, A and B are not returned.
C	Opposite sign convention for incident SV from Hudson.  My convention
C	is positive incident SV is towards the surface (up and back),
C	his is away from the interface (down and forward).  We have the
C	same convention for reflected SV (up and forward).  Note that in
C	my convention, SV has the same direction relative to the ray
C	propagation for incident and reflected.  Not so for theirs.
C     
C	jas/vt July 2002
C-
	real mb,mbsts
	mb(x) = 1 - 2.0*x*x
	Ap = 0.0
	Bp = 0.0
	PhR = 0.0
	PhV = 0.0
      IF (aemrg .EQ. 0.0) THEN
        AR=2.*(IPS-1)
	PhR = (IPS-1)*180.0
	AV = 2*(2 - IPS)
	A = ips - 2
	B = ips - 1
      else if (aemrg .eq. 90.0) then
	ar = 0.0
	av = 0.0
	A = ips - 2
	B = ips - 1
	Bp = (ips-1)*180.0/RDDEG
      else if (aemrg.eq.45.0 .and. ips.eq.2) then
        A = 0.0
	B = 1.0
	PhR = -90.0
	Ap = 90.0
	av = sqrt(2.0)
	ar = 0.0
      ELSE
        IF (IPS .EQ. 1) THEN
          tp = aemrg/RDDEG
          ts=ASIN(SIN(tp)*VRAT)
	  sts = sin(ts)
	  mbsts = mb(sts)
	  ctp = cos(tp)
	  stp = sin(tp)
	  cts = cos(ts)
	  Anum1 = 4.0*sts*sts*ctp*cts*vrat
	  den = Anum1 + mbsts**2
	  A = (Anum1 - mbsts**2)/den
	  B = 4*sts*ctp*mbsts/den
	  AR = stp*(1.0 + A) + cts*B
	  if (AR .lt. 0.00001) AR = 0.0
	  AV = ctp*(1.0 - A) +sts*B
	  if (AV .lt. 0.00002) AV = 0.0
	else if (ips .eq. 2) then
          ts=aemrg/RDDEG
	  sts = sin(ts)
	  mbsts = mb(sts)
	  d2 = mbsts**2
	  cts = cos(ts)
	  Anum1 = 4.0*sts*cts*vrat
	  Anum = -Anum1*mbsts
          stp = sts/VRAT
          IF(stp .LE. 1.0) THEN
            tp = ASIN(stp)
	    ctp = cos(tp)
	    d1 = sts*ctp*Anum1
	    den = d1 + d2
	    A = Anum/den
	    B = (d1-d2)/den
	    AR = (2.*cts*d2 - stp*Anum)/den
	    PhR = 180.0
	    AV = (2.0*d1*sts - ctp*Anum)/den
	    if (abs(AV) .lt. 0.0001) AV = 0.0
	  else
	    ctp = sqrt(stp*stp-1.0)   ! this is pure imaginary
	    d1 = sts*ctp*Anum1
	    den = sqrt(d1*d1 + d2*d2)
	    B = 1.0
	    A = Anum/den
	    if (abs(A) .lt. 0.0001) A = 0.0
	    if (A .lt. 0.0) then
	      A = -A
	      Ap = rddeg*atan2(-d1,d2)
	    else
	      Ap = rddeg*atan2(d1,-d2)
	    end if
	    Bp = rddeg*atan2(2.0*d1*d2,-d2*d2+d1*d1)
	    AR = (-2.0*d2*cts + Anum*stp)/den 
	    if (abs(AR) .lt. 0.0001) AR = 0.0
	    if (AR .lt. 0.0) then
	      AR = -AR
	      PhR = rddeg*atan2(d1,-d2)
	    else
	      PhR = rddeg*atan2(-d1,d2)
	    end if
	    AV = (2.0*d1*sts - Anum*ctp)/den
	    if (AV .lt. 0.0) then
	      AV = -AV
	      PhV = rddeg*atan2(d1,-d2) + 90.
	    else
	      PhV = rddeg*atan2(-d1,d2) + 90.
	    end if
          END IF
        END IF
      END IF
      RETURN
      END
C+
	INTEGER FUNCTION IVALUE(MSG,IDEF)
C
C PURPOSE:
C		THIS FUNCTION ACCEPTS A MESSAGE (ASKING FOR A VALUE)
C		AND RETURNS THE VALUE ENTERED AT THE TERMINAL
C ROUTINES CALLED:
C		PRINTX
C
C USE:
C		IANS=IVALUE('ENTER AN INTEGER',IDEF)
C	If enter a carriage return, IVALUE is set to IDEF.
C
C AUTHOR:
C			ALAN LINDE ... AUGUST 1980 (for VALUE)
C
C EXTENSIONS:
C	30 JULY 1989:  CAN HANDLE ENTRY FOLLOWED BY A BLANK OR TAB
C       27 July 1993: Did input read through cstring so can have 
C         comment lines
C	19 July 2002: PCs had a problem with single-digit integer, so ...
C-
	CHARACTER*1 E/'E'/,BLANK/' '/
	CHARACTER*30 STUFF
	CHARACTER*(*) MSG
C
100	CALL PRINTX(MSG)
	call cstring(stuff,nin)
	IF (NIN .GT. 0) THEN
	  NBLANK = INDEX(STUFF(1:NIN),BLANK)
	  IF (NBLANK .GT. 0) NIN = NBLANK - 1
	END IF
	IF (NIN .EQ. 0) THEN
	  IVALUE = IDEF
	ELSE
	  if (nin .eq. 1) then
	    stuff(2:2) = stuff(1:1)
	    stuff(1:1) = '0'
	    nin = 2
	  end if
	  READ(STUFF(1:NIN),*,ERR=100) IVALUE
	END IF
	RETURN
	END
C+
	SUBROUTINE IYESNO(MSG,IANS)
C
C
C     PURPOSE:
C	     THIS LITTLE SUBROUTINE ASKS A QUESTION AND RETURNS A
C	     RESPONSE TO THAT QUESTION. THE ANSWER TO THE QUESTION
C	     MUST BE EITHER 'Y' FOR YES, 'N' FOR NO, OR NOTHING
C	     (i.e. simply hitting carrage return) FOR THE DEFAULT
C	     REPONSE TO THE QUESTION.
C
C     ON INPUT:
C	    MSG = BYTE STRING CONTAINING THE QUESTION
C
C     ON OUTPUT:
C	    IANS = THE LOGICAL REPONSE TO THE QUESTION (1 or 0)
C     EXTRA FEATURES:
C	    DEFAULT SITUATION IS:
C	    IF LAST 3 CHARACTERS IN 'MSG' ARE
C	  	     [Y]  OR  [N]
C	    THEN 'IANS' = 1   OR   0
C
C	    IF LAST 3 CHARACTERS ARE NOT ONE OF ABOVE PAIRS
C	    THEN 'IANS' = 0
C	    (i.e. default for no supplied default is N)
C	30 JULY 1989:  IF ENTERED CHARACTER IS A BLANK OR A TAB, 
C	    TREATS AS A NULL ENTRY.
C       27 July 1993: Did input read through cstring so can have 
C         comment lines
C-
	CHARACTER*1 DELIM/'$'/,CHARIN,BLANK/' '/
	CHARACTER*3 TEST,UCY,LCY
	character*80 string_in
	CHARACTER*(*) MSG
	DATA UCY/'[Y]'/,LCY/'[y]'/
	KK = LEN(MSG)
	IF (MSG(KK:KK) .EQ. DELIM) KK = KK - 1
	TEST = MSG(KK-2:KK)
	CALL PRINTX(MSG)
	call cstring(string_in,nchar)
	IF ((NCHAR.GT.0) .AND. (string_in(1:1).EQ.BLANK))
     1    NCHAR = 0
	IF (NCHAR .EQ. 0) THEN
	  IF ((TEST .EQ. UCY) .OR. (TEST .EQ. LCY)) THEN
	    IANS = 1
	  ELSE 
	    IANS = 0
	  END IF
	ELSE
	  charin = string_in(1:1)
	  IF (CHARIN .EQ. UCY(2:2) .OR. CHARIN .EQ. LCY(2:2)) THEN
	    IANS = 1
	  ELSE
	    IANS = 0
	  END IF
	END IF
	RETURN
	END
	function lenc(string)
C+
C	function lenc(string)
C
C	Returns length of character variable STRING excluding right-hand
C	  most blanks or nulls
C-
	character*(*) string
	length = len(string)	! total length
	if (length .eq. 0) then
	  lenc = 0
	  return
	end if
	if(ichar(string(length:length)).eq.0)string(length:length) = ' '
	do j=length,1,-1
	  lenc = j
	  if (string(j:j).ne.' ' .and. ichar(string(j:j)).ne.0) return
	end do
	lenc = 0
	return
	end
C+
	SUBROUTINE LRATIO(JR,DIP,STRIKE,RAKE,XYZ,VPVS3,LOGRAT,TOP,
     1             CUTP,CUTS,FLAG)
c
c  calculates theoretical value of log10 amplitude ratio for a given
c  fault dip, strike, and slip
C	SV/P for JR = 1, SH/P for JR = 2, SV/SH for JR = 3
C	Uses A&R convention for RAKE - negative of Kisslinger's
C
C	TOP contains the sign of the S polarity: + for SV if towards
C	  the station (down on vertical), + for SH if to
C	  left facing station (opposite from others, sorry).  For SV/SH
C	  it will be for SV.
C	Written by Arthur Snoke Virginia Tech June 1984
C	10 June 1986:  Fixed case for 0/0 by taking derivatives of
C	  both numerator and denominator with respect to strike
C	  (derivatives with respect to dip did not work).
C	7 July 1990:  Decided that case for 0/0 was irrelevant.  If one
C	  is near a nodal surface for either the numerator or denominator,
C	  that should suffice in practise.  For FOCMEC therefore simply
C	  want it flagged if near a nodal surface.
C	8 July 1990:  Intorduced CUT as a calling argument to limit the
C	  range of ratios considered to stay away from nodal surfaces.
C	  If both the numerator and denominator are less than CUT,
C	  LOGRAT returned as -3, if only num., as -2, den. +2.
C	29 August 1991:  adapted from LSPRAT to include SV/SH
C	3 August 1993:  Changed procedure for dealing with near-nodal
C	  cases:  Now separate CTP and CUTS for P and S terms.  No more
C	  FACTOR.  Returns a FLAG for near-nodal -- 'NUM' if numerator,
C	  'DEN if denominator, 'N&D' if both, '   ' if non-nodal.
C	6 January 1997: Corrected an error in solutions near a
C	  nodal surface for either the numerator or the denominator
C	  but not both.  Previously the ratio returned was not updated
C	  for such cases, so was what had been found in the previous call.
C	27 February 1997: If numerator is near nodal surface, now returns
C	  correct sign in TOP
C-
	character*3 flag
	REAL*4 LOGRAT,XYZ(9),A(3),N(3)
	A(1) = COS(RAKE)*COS(STRIKE) + SIN(RAKE)*COS(DIP)*SIN(STRIKE)
	A(2) = COS(RAKE)*SIN(STRIKE) - SIN(RAKE)*COS(DIP)*COS(STRIKE)
	A(3) = -SIN(RAKE)*SIN(DIP)
	N(1) = -SIN(STRIKE)*SIN(DIP)
	N(2) = COS(STRIKE)*SIN(DIP)
	N(3) = -COS(DIP)
	RA = 0.0
	RN = 0.0
	TA = 0.0
	TN = 0.0
	PA = 0.0
	PN = 0.0
	DO J=1,3
	  RA = RA + XYZ(J)*A(J)
	  RN = RN + XYZ(J)*N(J)
	  TA = TA + XYZ(J+3)*A(J)
	  TN = TN + XYZ(J+3)*N(J)
	  PA = PA + XYZ(J+6)*A(J)
	  PN = PN + XYZ(J+6)*N(J)
	END DO
	if (JR .lt. 3) then
	  BOT = 2*RA*RN
	else
	  BOT = RA*PN + RN*PA
	end if
	if (JR .eq. 2) then
	  TOP = RA*PN + RN*PA
	else
	  TOP = RA*TN + RN*TA
	end if
	flag = '   '
	IF (JR.ne.3.and.ABS(BOT).LE.CUTP .or. JR.eq.3.and.ABS(BOT)
     1      .le.CUTS) THEN
	  IF (ABS(TOP) .LE. CUTS) THEN
	    flag = 'N&D'
	    lograt = 0.0
	    RETURN
	  ELSE
	    flag = 'DEN'
	    if (jr .ne. 3) then
	      bot = CUTP
	    else
	      bot = CUTS
	    end if
	  END IF
	ELSE IF (ABS(TOP) .LE. CUTS) THEN
	  flag = 'NUM'
	  top = CUTS*sign(1.0,top)
	end if
	IF (JR .NE. 3) THEN
	  LOGRAT = ALOG10(VPVS3*ABS(TOP/BOT))
	ELSE
	  LOGRAT = ALOG10(ABS(TOP/BOT))
	end if
	RETURN
	END
C+
	SUBROUTINE MAXMIN(DATA,NPTS,RMIN,RMAX,ITYPE,NU1,NU2)
C 
C     Returns (real) minimum and maximum values for an array DATA
C	Number of points to be included is NPTS
C	DATA can be INTEGER*2, INTEGER*4, REAL or DOUBLE PRECISION
C		If ITYPE = 'SP' or 'R4', single precision
C		           'DP' or 'R8', double precision
C		           'I2', integer*2
C		           'I4', integer*4
C	If NU1 > 0, prints RMAX and RMIN on unit NU1.  Same for NU2.
C		Arthur Snoke:  February 1983
C	6 October 1988:  If NU1 or NU2 are 5, writes to *  (VAX)
C	7 July 1991:  sun version:  calls minmax
C-
	INTEGER*2 DATA(*)
	character*2 itype
	NSTART = 1
	call minmax(data,nstart,npts,rmin,rmax,itype,nu1,nu2)
	RETURN
	END 
C+
	SUBROUTINE MINMAX(DATA,NSTART,NPTS,RMIN,RMAX,ITYPE,NU1,NU2)
C 
C     Returns (real) minimum and maximum values for an array DATA
C	Number of points to be included is NPTS
C	DATA can be INTEGER*2, INTEGER*4, REAL or DOUBLE PRECISION
C		If ITYPE = 'SP' or 'R4', single precision
C		           'DP' or 'R8', double precision
C		           'I2', integer*2
C		           'I4', integer*4
C	If NU1 > 0, prints RMAX and RMIN on unit NU1.  Same for NU2.
C		Arthur Snoke:  February 1983
C	6 October 1988:  If NU1 or NU2 are 5, writes to *  (VAX)
C	7 July 1991:  unix/sun version
C-
	CHARACTER*2 ICHECK,ITYPE,SP,R4,DP,R8,I2,I4 
	INTEGER*2 DATA(*),IDAT2(4)
	INTEGER*4 IDAT4,MIN,MAX
	real*8 rdat8
	EQUIVALENCE (RDAT4,IDAT4,IDAT2(1),rdat8)
	DATA SP,R4,DP,R8,I2,I4/'SP','R4','DP','R8','I2','I4'/
	RMAX = -1.0E30 
	RMIN = 1.0E30
	ICHECK = ITYPE
	IF (ICHECK .EQ. SP) ICHECK = R4
	IF (ICHECK .EQ. DP) ICHECK = R8
	IF (ICHECK .EQ. I2) NST = NSTART
        IF (ICHECK .EQ. I4 .OR. ICHECK .EQ. R4) NST = 2*NSTART - 1
        IF (ICHECK .EQ. R8) NST = 4*NSTART - 3
        IF (ICHECK .EQ. I2) NTOT = NST - 1 + NPTS
        IF (ICHECK .EQ. R4 .OR. ICHECK .EQ. I4) NTOT = NST - 1 + 2*NPTS
        IF (ICHECK .EQ. R8) NTOT = NST - 1 + 4*NPTS
        IF (ICHECK .EQ. I2) INTRVL = 1
        IF (ICHECK .EQ. R4 .OR. ICHECK .EQ. I4) INTRVL = 2
        IF (ICHECK .EQ. R8) INTRVL = 4
        DO 100 J=NST,NTOT,INTRVL
	IDAT2(1) = DATA(J)
	IDAT2(2) = DATA(J+1)
	IF (ICHECK .EQ. I2) RDAT = IDAT2(1)
	IF (ICHECK .EQ. I4) RDAT = IDAT4
	IF (ICHECK .EQ. R4) RDAT = RDAT4
	if (ICHECK .EQ. R8) then
	  IDAT2(3) = DATA(J+2)
	  IDAT2(4) = DATA(J+3)
	  RDAT = RDAT8
	END IF
	IF (RDAT .LT. RMIN) RMIN = RDAT
100	IF (RDAT .GT. RMAX) RMAX = RDAT
	IF (NU1 .LE. 0) RETURN
	IF (ICHECK .EQ. I4 .OR. ICHECK .EQ. I2) GO TO 200
	HALF = 0.5*ABS(RMIN-RMAX)
	IF (NU1 .NE. 5) THEN
	  WRITE (NU1,1) RMIN,RMAX,HALF
	ELSE
	  WRITE (*,1) RMIN,RMAX,HALF
	END IF
1	FORMAT(' Minimum is ',1PG10.3,'   Maximum is ',G10.3,
     .		'  Half Range is ',G10.3)
	IF (NU2 .GT. 0) THEN
	  IF (NU2 .NE. 5) THEN
	    WRITE (NU2,1) RMIN,RMAX,HALF
	  ELSE
	    WRITE (*,1) RMIN,RMAX,HALF
	  END IF
	END IF	
	RETURN
200	MIN = RMIN
	MAX = RMAX
	IF (NU1 .NE. 5) THEN
	  WRITE (NU1,2) MIN,MAX
	ELSE
	  WRITE (*,2) MIN,MAX
	END IF
2	FORMAT(' Minumum is ',I10,'   Maximum is ',I10)
	IF (NU2 .GT. 0) THEN
	  IF (NU2 .NE. 5) THEN
	    WRITE (NU2,2) MIN,MAX
	  ELSE
	    WRITE (*,2) MIN,MAX
	  END IF
	END IF
	RETURN
	END 
C+
	subroutine mt_in(pttp,PI)
C
C	eigenvalues/vectors using EISPACK routines from www.netlib.no
C	Much of code adapted from Jost/Herrmann mteig.f and mtdec.f
C	Uses original EISPACK routines for TRED2 and IMTQL2, not NR
C	Also includes subroutine eig, which calls TRED2 and IMTQL2.
C	15 March 2002
C-
	dimension A(3,3), U(3,3), W(3), PTTP(4), XYZ(3)
	real*4 MRR, MTT, MPP, MRT, MRP, MTP, isotrop
      write(*,*) 'Input MRR MTT MPP MRT MRP MTP (free format)'
      read(*,*) MRR, MTT, MPP, MRT, MRP, MTP
      write(2,*) '  Input is moment tensor (Dziewonski convention)'
      write(2,*) 'MRR MTT MPP MRT MRP MTP'
      write(2,'(1p6g11.4)') MRR, MTT, MPP, MRT, MRP, MTP
C
C	Convention is X north, Y east, Z down
C
      A(3,3) = MRR
      A(1,1) = MTT
      A(2,2) = MPP
      A(1,3) = MRT
      A(3,1) = A(1,3)
      A(2,3) = -MRP
      A(3,2) = A(2,3)
      A(1,2) = -MTP
      A(2,1) = A(1,2)
      call eig(a,u,w)
C
C	Ordering returned is from smallest to highest (P, B, T for DC)
C
C      write(*,*) ' '
C     write(*,*) 'EIGENVALUES                EIGENVECTORS'
C     do j=1,3
C       write(*,'(1pg11.4,2x,0p5f11.4)') W(j),(U(i,j),i=1,3)
C     end do
      isotrop = 0.0
      do j=1,3
        isotrop = isotrop + w(j)
      end do
      devmom = 0.0
      do j=1,3
        w(j) = w(j) - isotrop/3.0
	devmom = devmom + w(j)*w(j)
      end do
      devmom = sqrt(0.5*devmom)
      if (devmom .lt. 0.001*isotrop) devmom = 0.0
      write(*,*) ' '
      write(*,'(a,1pg11.4,a,g11.4)') 
     1	'  Trace of moment tensor = ',isotrop,
     2  '  Deviatoric tensor moment = ', devmom
      write(2,*) ' '
      write(2,'(a,1pg11.4,a,g11.4)') 
     1	'  Trace of moment tensor = ',isotrop,
     2  '  Deviatoric tensor moment = ', devmom
      if (devmom .eq. 0.0) then
        write(2,*) 'Exiting because purely isotropic source'
	write(*,*) 'Exiting because purely isotropic source'
	stop
      end if
      write(2,'(a,1p3g11.4)') '  Deviatoric moment tensor eigenvalues:',
     1   (w(j),j=1,3)
      write(*,'(a,1p3g11.4)') '  Deviatoric moment tensor eigenvalues:',
     1   (w(j),j=1,3)
c---- Dziewonski, Chou, Woodhouse,  JGR 1981 2825-2852
c---- eps=0 pure double couple
c---- eps=0.5 pure CLVD
      eps = abs(w(2)/amax1(-w(1),w(3)))
      eps1 = eps*200.0
      eps2 = 100.0 - eps1
      write(*,'(a)') '  EPSILON    % OF CLVD     % OF DC'
      write(*,'(f9.4,2f12.4)') eps, eps1, eps2
      write(2,'(a)') '  EPSILON    % OF CLVD     % OF DC'
      write(2,'(f9.4,2f12.4)') eps, eps1, eps2
      write(2,*) ' '
      if (eps .ge. 0.25) then
        write(2,*) ' Exiting because less than 50% double couple'
	write(*,*) ' Exiting because less than 50% double couple'
	stop
      end if
C
C	Get trend and plunge for P
C
      do j=1,3
        xyz(j) = u(j,1)
      end do
      call V2TRPL(XYZ,PTTP(1),PI)
C
C	Get trend and plunge for T
C
      do j=1,3
        xyz(j) = u(j,3)
      end do
      call V2TRPL(XYZ,PTTP(3),PI)
C     do j=1,4
C        pttp(j) = rdeg*pttp(j)
C      end do
C      write(*,*) '  '
C      write(*,*) '  Trend and Plunge of P and T'
C     write(*,'(4f11.4)') pttp
      return
      end
      subroutine eig (a,u,w)
      dimension A(3,3), U(3,3), W(3), work(3)
      np = 3
      do i=1,np
        do j=1,3
	  u(i,j) = a(i,j)
	end do
      end do
      n = 3
      call tred2(np,n,a,w,work,u)
      call imtql2(np,n,w,work,u,ierr)
C
C	This system has P, B, T as a right-hand coordinate system.
C	I prefer P, T, B
C
      do j=1,3
        u(j,1) = -u(j,1)
      end do
      return
      end
c---------------
      subroutine tred2(nm,n,a,d,e,z)
c
      integer i,j,k,l,n,nm
      real a(nm,n),d(n),e(n),z(nm,n)
      real f,g,h,hh,scale
c
c     this subroutine is a translation of the algol procedure tred2,
c     num. math. 11, 181-195(1968) by martin, reinsch, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 212-226(1971).
c
c     this subroutine reduces a real symmetric matrix to a
c     symmetric tridiagonal matrix using and accumulating
c     orthogonal similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the real symmetric input matrix.  only the
c          lower triangle of the matrix need be supplied.
c
c     on output
c
c        d contains the diagonal elements of the tridiagonal matrix.
c
c        e contains the subdiagonal elements of the tridiagonal
c          matrix in its last n-1 positions.  e(1) is set to zero.
c
c        z contains the orthogonal transformation matrix
c          produced in the reduction.
c
c        a and z may coincide.  if distinct, a is unaltered.
c
c     Questions and comments should be directed to Alan K. Cline,
c     Pleasant Valley Software, 8603 Altus Cove, Austin, TX 78759.
c     Electronic mail to cline@cs.utexas.edu.
c
c     this version dated january 1989. (for the IBM 3090vf)
c
c     ------------------------------------------------------------------
c
c?      call xuflow(0)
      do 100 i = 1, n
         do 100 j = i, n
  100       z(j,i) = a(j,i)
c
      do 110 i = 1, n
  110    d(i) = a(n,i)
c
      do 300 i = n, 2, -1
         l = i - 1
         h = 0.0e0
         scale = 0.0e0
         if (l .lt. 2) go to 130
c     .......... scale row (algol tol then not needed) ..........
         do 120 k = 1, l
  120    scale = scale + abs(d(k))
c
         if (scale .ne. 0.0e0) go to 140
  130    e(i) = d(l)
c
c"    ( ignore recrdeps
         do 135 j = 1, l
            d(j) = z(l,j)
            z(i,j) = 0.0e0
            z(j,i) = 0.0e0
  135    continue
c
         go to 290
c
  140    do 150 k = 1, l
            d(k) = d(k) / scale
            h = h + d(k) * d(k)
  150    continue
c
         f = d(l)
         g = -sign(sqrt(h),f)
         e(i) = scale * g
         h = h - f * g
         d(l) = f - g
c     .......... form a*u ..........
         do 170 j = 1, l
  170       e(j) = 0.0e0
c
         do 240 j = 1, l
            f = d(j)
            z(j,i) = f
            g = e(j) + z(j,j) * f
c
            do 200 k = j+1, l
               g = g + z(k,j) * d(k)
               e(k) = e(k) + z(k,j) * f
  200       continue
c
            e(j) = g
  240    continue
c     .......... form p ..........
         f = 0.0e0
c
         do 245 j = 1, l
            e(j) = e(j) / h
            f = f + e(j) * d(j)
  245    continue
c
         hh = -f / (h + h)
c     .......... form q ..........
         do 250 j = 1, l
  250       e(j) = e(j) + hh * d(j)
c     .......... form reduced a ..........
         do 280 j = 1, l
            f = -d(j)
            g = -e(j)
c
            do 260 k = j, l
  260          z(k,j) = z(k,j) + f * e(k) + g * d(k)
c
            d(j) = z(l,j)
            z(i,j) = 0.0e0
  280    continue
c
  290    d(i) = h
  300 continue
c     .......... accumulation of transformation matrices ..........
      do 500 i = 2, n
         l = i - 1
         z(n,l) = z(l,l)
         z(l,l) = 1.0e0
         h = d(i)
         if (h .eq. 0.0e0) go to 380
c
         do 330 k = 1, l
  330       d(k) = z(k,i) / h
c"    ( ignore recrdeps
c"    ( prefer vector
         do 360 j = 1, l
            g = 0.0e0
c
            do 340 k = 1, l
  340          g = g + z(k,i) * z(k,j)
c
            g = -g
c
            do 350 k = 1, l
  350          z(k,j) = z(k,j) + g * d(k)
  360    continue
c
  380    do 400 k = 1, l
  400       z(k,i) = 0.0e0
c
  500 continue
c
c"    ( prefer vector
      do 520 i = 1, n
         d(i) = z(n,i)
         z(n,i) = 0.0e0
  520 continue
c
      z(n,n) = 1.0e0
      e(1) = 0.0e0
      return
      end
      subroutine imtql2(nm,n,d,e,z,ierr)
c
      integer i,j,k,l,m,n,nm,ierr
      real d(n),e(n),z(nm,n)
      real b,c,f,g,p,r,s,tst1,tst2
c
c     this subroutine is a translation of the algol procedure imtql2,
c     num. math. 12, 377-383(1968) by martin and wilkinson,
c     as modified in num. math. 15, 450(1970) by dubrulle.
c     handbook for auto. comp., vol.ii-linear algebra, 241-248(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a symmetric tridiagonal matrix by the implicit ql method.
c     the eigenvectors of a full symmetric matrix can also
c     be found if  tred2  has been used to reduce this
c     full matrix to tridiagonal form.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        d contains the diagonal elements of the input matrix.
c
c        e contains the subdiagonal elements of the input matrix
c          in its last n-1 positions.  e(1) is arbitrary.
c
c        z contains the transformation matrix produced in the
c          reduction by  tred2, if performed.  if the eigenvectors
c          of the tridiagonal matrix are desired, z must contain
c          the identity matrix.
c
c      on output
c
c        d contains the eigenvalues in ascending order.  if an
c          error exit is made, the eigenvalues are correct but
c          unordered for indices 1,2,...,ierr-1.
c
c        e has been destroyed.
c
c        z contains orthonormal eigenvectors of the symmetric
c          tridiagonal (or full) matrix.  if an error exit is made,
c          z contains the eigenvectors associated with the stored
c          eigenvalues.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the j-th eigenvalue has not been
c                     determined after 30 iterations.
c
c     Questions and comments should be directed to Alan K. Cline,
c     Pleasant Valley Software, 8603 Altus Cove, Austin, TX 78759.
c     Electronic mail to cline@cs.utexas.edu.
c
c     this version dated january 1989. (for the IBM 3090vf)
c
c     ------------------------------------------------------------------
c
c?      call xuflow(0)
      ierr = 0
      if (n .eq. 1) go to 1001
c
      do 100 i = 2, n
  100 e(i-1) = e(i)
c
      e(n) = 0.0e0
c
      do 240 l = 1, n
         j = 0
c     .......... look for small sub-diagonal element ..........
  105    do 110 m = l, n-1
            tst1 = abs(d(m)) + abs(d(m+1))
            tst2 = tst1 + abs(e(m))
            if (tst2 .eq. tst1) go to 120
  110    continue
c
  120    p = d(l)
         if (m .eq. l) go to 240
         if (j .eq. 30) go to 1000
         j = j + 1
c     .......... form shift ..........
         g = (d(l+1) - p) / (2.0e0 * e(l))
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c *      r = pythag(g,1.0d0)
cccccccccccccccccccccccccccccccccccccccccccccccccccc
         if (abs(g).le.1.0e0) then
            r = sqrt(1.0e0 + g*g)
         else
            r = g * sqrt(1.0e0 + (1.0e0/g)**2)
         endif
cccccccccccccccccccccccccccccccccccccccccccccccccccc
         g = d(m) - p + e(l) / (g + sign(r,g))
         s = 1.0e0
         c = 1.0e0
         p = 0.0e0
c     .......... for i=m-1 step -1 until l do -- ..........
         do 200 i = m-1, l, -1
            f = s * e(i)
            b = c * e(i)
cccccccccccccccccccccccccccccccccccccccccccccccccccc
c *         r = pythag(f,g)
cccccccccccccccccccccccccccccccccccccccccccccccccccc
            if (abs(f).ge.abs(g)) then
               r = abs(f) * sqrt(1.0e0 + (g/f)**2)
            else if (g .ne. 0.0e0) then
               r = abs(g) * sqrt((f/g)**2 + 1.0e0)
            else
               r = abs(f)
            endif
cccccccccccccccccccccccccccccccccccccccccccccccccccc
            e(i+1) = r
            if (r .eq. 0.0e0) then
c     .......... recover from underflow ..........
               d(i+1) = d(i+1) - p
               e(m) = 0.0e0
               go to 105
            endif
            s = f / r
            c = g / r
            g = d(i+1) - p
            r = (d(i) - g) * s + 2.0e0 * c * b
            p = s * r
            d(i+1) = g + p
            g = c * r - b
c     .......... form vector ..........
            do 180 k = 1, n
               f = z(k,i+1)
               z(k,i+1) = s * z(k,i) + c * f
               z(k,i) = c * z(k,i) - s * f
  180       continue
c
  200    continue
c
         d(l) = d(l) - p
         e(l) = g
         e(m) = 0.0e0
         go to 105
  240 continue
c     .......... order eigenvalues and eigenvectors ..........
      do 300 i = 1, n-1
         k = i
         p = d(i)
c
         do 260 j = i+1, n
            if (d(j) .ge. p) go to 260
            k = j
            p = d(j)
  260    continue
c
         d(k) = d(i)
         d(i) = p
c
         do 280 j = 1, n
            p = z(j,i)
            z(j,i) = z(j,k)
            z(j,k) = p
  280    continue
c
  300 continue
c
      go to 1001
c     .......... set error -- no convergence to an
c                eigenvalue after 30 iterations ..........
 1000 ierr = l
 1001 return
      end
C+
	LOGICAL FUNCTION OKPOL(A,N,NBADP,NBADSV,NBADSH)
C
C	Called by SRCHFM, which is called by FOCMEC
C	Compares observed polarities with trial mechanism
C		designated by A and N
C	NBADP and NBADS return the number of bad P and S polarities
C	  If any of the (weighted) numbers of errors is bigger than the
C	  appropriate maximum allowed, the function is .FALSE. on return
C	23 July 1985:  Added SH polarity check 
C	10 August 1985:  Added SH + P polarity option
C	27 September 1985:  included variable weighting option for
C	  polarities
C	last perturbed 12 October 1990
C	29 August 1991:  sun version.  Now can have SV polarities
C-
	INCLUDE 'FOCMEC.INC'
	REAL*4 A(3),N(3)
	INTEGER NBADP, NBADSH, NBADSV
	OKPOL = .FALSE.
	NBADP = 0
	NBADSV = 0
	NBADSH = 0
	BADP = 0.0
	BADSV = 0.0
	BADSH = 0
	BAD = 0.0
	DO K=1,NPOL
          KKK = KEYPOL(K)
          IF (KKK-1000 .LT. 0) THEN
            KK = KKK
            JR = 1
          ELSE IF (KKK-2000 .LT. 0) THEN
            KK = KKK - 1000
            JR = 2
	    TA = 0.0
	    TN = 0.0
	    do j=1,3
              TA = TA + XYZ(J+3,KK)*A(J)
              TN = TN + XYZ(J+3,KK)*N(J)
	    end do
          ELSE
            KK = KKK - 2000
            JR = 3
	    PA = 0.0
	    PN = 0.0
	    do j=1,3
              PA = PA + XYZ(J+6,KK)*A(J)
              PN = PN + XYZ(J+6,KK)*N(J)
	    end do
          END IF
	  RA = 0.0
	  RN = 0.0
          DO J=1,3
            RA = RA + XYZ(J,KK)*A(J)
            RN = RN + XYZ(J,KK)*N(J)
          END DO
	  IF (JR .eq. 1) THEN    !  This is a P polarity
	    TEST = POLRTY(K)*2*RA*RN
	    IF (TEST .LE. 0.0) THEN
	      BADNOW = AMAX1(-TEST,THRESH)
	      BADP = BADP + BADNOW
	      BAD = BAD + BADNOW
	      IF (BAD .GT. ERR) RETURN
	      IF (BADP .GT. ERRP) RETURN
	      NBADP = NBADP + 1
	      NBAD = NBAD + 1
	      BADPP(NBADP) = PSTATN(K)
	      WBADP(NBADP) = BADNOW
	    ENDIF
	  ELSE IF (JR .eq. 2) then   ! This one is an SV polarity
	    TEST = POLRTY(K)*(RA*TN + RN*TA)
	    IF (TEST .LE. 0.0) THEN
	      BADNOW = AMAX1(-TEST,THRESH)
	      BADSV = BADSV + BADNOW
	      BAD = BAD + BADNOW
	      IF (BAD .GT. ERR) RETURN
	      IF (BADSV .GT. ERRSV) RETURN
	      NBADSV = NBADSV + 1
	      BADSVP(NBADSV) = PSTATN(K)
	      WBADSV(NBADSV) = BADNOW
	    END IF
	  ELSE IF (JR .eq. 3) then   ! This one is an SH polarity
	    TEST = POLRTY(K)*(RA*PN + RN*PA)
	    IF (TEST .LE. 0.0) THEN
	      BADNOW = AMAX1(-TEST,THRESH)
	      BADSH = BADSH + BADNOW
	      BAD = BAD + BADNOW
	      IF (BAD .GT. ERR) RETURN
	      IF (BADSH .GT. ERRSH) RETURN
	      NBADSH = NBADSH + 1
	      BADSHP(NBADSH) = PSTATN(K)
	      WBADSH(NBADSH) = BADNOW
	    END IF
	  END IF
	END DO
	OKPOL = .TRUE.
	RETURN
	END
C+
	LOGICAL FUNCTION OKRAT(DSR,NBADR,ESUM,ESUMAL,DIFF,SPOL,FLAG)
C
C	Called by OKSOL, which is called by FOCMEC
C	Compares observed log10 amplitude ratios with trial mechanism
C	  designated by A and N
C	8 July 1990:  Put in limits on ratios to allow for nodal surfaces.
C	  The limit for the numerator and denominator as used in LSPRAT is
C	  CUT.  Allowing for the other part of the ratio being non-unity is
C	  taken care of through FACTOR.  My choices are CUT=0.05, FACTOR=2.0.
C	  These have been added to the .INC file and are prompted for in FOCINP
C	29 August 1991:  sun version.  Now allows SV/SH ratios
C	3 August 1993:  Changed rules for nodal surfaces.  No more FACTOR,
C	  Now have CUTP and CUTS.  FLAG labels nodel surface cases
C-
	INCLUDE 'FOCMEC.INC'
	character*3 FLAG(MAX)
	INTEGER NBADR
	REAL*4 SPOL(MAX),DSR(3),DIFF(MAX)
	OKRAT = .FALSE.
	NBADR = 0
	IF (NRAT .LE. 0) RETURN
	ESUM = 0.0
	ESUMAL = 0.0
	DO K=1,NRAT
	  KKK = KEYRAT(K)
	  IF (KKK-1000 .LT. 0) THEN
	    KK = KKK
	    JR = 1
	  ELSE IF (KKK-2000 .LT. 0) THEN
	    KK = KKK - 1000
	    JR = 2
	  ELSE
	    KK = KKK - 2000
	    JR = 3
	  END IF
	  CALL LRATIO(JR,DSR(1),DSR(2),DSR(3),XYZ(1,KK),VPVS3,RAT,
     .	       SP,CUTP,CUTS,FLAG(K))
	  SPOL(K) = SP
	  CALRAT(K) = RAT
	  IF (FLAG(K) .eq. 'N&D') THEN
c	Both the numberator and the denominator are < cutoff values.
	    DIFF(K) = 0.0
	  ELSE
	    DIFF(K) = LOGRAT(K) - CALRAT(K)
	  END IF
	  ESUMAL = ESUMAL + DIFF(K)**2
	  IF (ABS(DIFF(K)) .GT. ERRRAT) THEN
	    WTRAT(K) = 0
	    NBADR = NBADR + 1
	    IF (NBADR .GT. NERRR) RETURN
	  ELSE
	    WTRAT(K) = 1
	    ESUM = ESUM + DIFF(K)**2
	  ENDIF
	END DO
	OKRAT = .TRUE.
	RETURN
	END
C+
	LOGICAL FUNCTION OKSOL(A,N,ANGLE)
C
C	Called by SRCHFM, which is called by FOCMEC
C	Checks for valid focal mechanisms based on ratios and polarities
C		designated by A and N
C	ANGLE is passed in and written out for a valid solution:
C		It is an internally caluclated quantity - the
C		angle the A axis makes with the plane defined by
C		the B axis and vertical
C
C	Arthur Snoke  Virginia Tech  July 1984
C	24 July 1985:  Added SH polarity check
C	7 July 1990:  Commented out (C90) call to perturb solution
C	  if there are ratio dats based on Kisslinger's least-squares
C	  approach.  Decided it is too misleading, as polarities are
C	  not taken into account.  (Room for improvement!)
C	Latest perturbation (VAX):  12 October 1990
C	31 August 1991:  sun   Allows for SV polarities and SV/SH ratios
C	15 May 1992:  Corrected an error in printing if near a double
C		nodal plane in ratio printout
C	5 August 1993:  Changed rules for ratios when numerator and/or
C	  denominator near nodal surfaces.  Also, if both numerator and
C	  denominator near a nodal surface for all solutions, writes out
C	  rmsall as 99.99 instead of 0.0.  FLAG has been added to output
C	  for ratio data: NUM and DEN for numerator or denominator near
C	  nodal surface respectively; N&D for both.  Summary printout for
C	  total ratio error now same as in short output file -- RMS errors.
C	  Now radiation factors (normalized to unity) are printed out even
C	  if weighted option is not chosen.
C	22 March 2002: Small changes to include fact that fmreps can allow
C	  moment tensor input -- not used in this program.
C-
	INCLUDE 'FOCMEC.INC'
	CHARACTER*1 POL,MARK(2)
	character*3 flag(MAX)
	LOGICAL OKRAT,OKPOL,PT,AN,ANGS,mt
	REAL*4 DSR(3), DSRD(3),PTTP(4),ANBTP(6),DSR2(3),DIFF(MAX)
	REAL*4 SPOL(MAX),A(3),N(3),MOMTEN(6)
	DATA PT,AN,mt,ANGS/3*.FALSE.,.TRUE./
	DATA MARK/'*',' '/
	OKSOL = .FALSE.
	IF (NPOL .GT. 0) THEN
	  IF (.NOT.OKPOL(A,N,NBADP,NBADSV,NBADSH)) RETURN
C
	ELSE
	  NBADP = 0
	  NBADSV = 0
	  NBADSH = 0
	  BADP = 0.0
	  BADSV = 0.0
	  BADSH = 0.0
	END IF
	do j=1,3
	  if (abs(A(j)) .lt. 0.0001) A(j) = 0.0
	  if (abs(abs(a(j))-1.0) .lt. 0.0001) a(j) = a(j)/abs(a(j))
	  if (abs(N(j)) .lt. 0.0001) N(j) = 0.0
	  if (abs(abs(N(j))-1.0) .lt. 0.0001) N(j) = N(j)/abs(N(j))
	end do
	pi = 4.0*atan(1.0)
	CALL AN2DSR(A,N,DSR,PI)
	IF (NRAT .GT. 0) THEN
	  IF (.NOT.OKRAT(DSR,NBADR,ESUM,ESUMAL,DIFF,SPOL,FLAG)) 
     1        RETURN
C
	ENDIF
	OKSOL = .TRUE.
	DO K=1,3
	  DSRD(K) = DSR(K)*RD
	END DO
	CALL FMREPS(ANBTP,DSRD,PTTP,DSR2,AN,PT,ANGS,MT,MOMTEN,2,0)
	ANGDEG = ANGLE*57.29578
	WRITE(2,1) ANGDEG
	IF (NRAT .GT. 0) THEN
C
C	DON'T WANT TO COUNT SOLUTIONS NEAR DOUBLE NODAL SURFACE
C
	  NRATOK = NRAT
	  DO K=1,NRAT
	    IF (FLAG(K) .eq. 'N&D') NRATOK = NRATOK - 1
	  END DO
C
	  if (nratok .gt. 0) then
	    RMSALL = SQRT(ESUMAL/NRATOK)
	  else
	    rmsall = 99.99
	  end if
	  IF (NRATOK .GT. NBADR) THEN
	    RMS = SQRT(ESUM/(NRATOK-NBADR))
	    WRITE(*,3) DSRD,BADP,BADSV,BADSH,NBADR,RMS,RMSALL
	    WRITE(3,3) DSRD,BADP,BADSV,BADSH,NBADR,RMS,RMSALL
	  ELSE
	    RMS = 99.99
	    WRITE(*,4) DSRD,BADP,BADSV,BADSH,NBADR,RMSALL
	    WRITE(3,4) DSRD,BADP,BADSV,BADSH,NBADR,RMSALL
	  END IF
	ELSE
	  WRITE(*,3) DSRD,BADP,BADSV,BADSH
	  WRITE(3,3) DSRD,BADP,BADSV,BADSH
	END IF
	IF (NBADP .GT. 0) THEN
	  IF (NBADP .LE. 11) THEN
	    WRITE(2,5) (BADPP(KK),KK=1,NBADP)
	    WRITE(2,11) (WBADP(KK),KK=1,NBADP)
	  ELSE
	    WRITE(2,5) (BADPP(KK),KK=1,11)
	    WRITE(2,11) (WBADP(KK),KK=1,11)
	    WRITE(2,'(20(T23,11(A4,1X)/))') (BADPP(KK),KK=12,NBADP)
	    WRITE(2,'(20(T23,11(F4.2,1X)/))') (WBADP(KK),KK=12,NBADP)
	  END IF
	  WRITE(2,12) BADP
	END IF
	IF (NBADSV .GT. 0) THEN
	  IF (NBADSV .LE. 11) THEN
	    WRITE(2,10) (BADSVP(KK),KK=1,NBADSV)
	    WRITE(2,13) (WBADSV(KK),KK=1,NBADSV)
	  ELSE
	    WRITE(2,10) (BADSVP(KK),KK=1,11)
	    WRITE(2,13) (WBADSV(KK),KK=1,11)
	    WRITE(2,'(20(T23,11(A4,1X)/))') (BADSVP(KK),KK=12,NBADSV)
	    WRITE(2,'(20(T23,11(F4.2,1X)/))') (WBADSV(KK),KK=12,NBADSV)
	  END IF
	  WRITE(2,14) BADSV
	END IF
	IF (NBADSH .GT. 0) THEN
	  IF (NBADSH .LE. 11) THEN
	    WRITE(2,15) (BADSHP(KK),KK=1,NBADSH)
	    WRITE(2,16) (WBADSH(KK),KK=1,NBADSH)
	  ELSE
	    WRITE(2,15) (BADSHP(KK),KK=1,11)
	    WRITE(2,16) (WBADSH(KK),KK=1,11)
	    WRITE(2,'(20(T23,11(A4,1X)/))') (BADSHP(KK),KK=12,NBADSH)
	    WRITE(2,'(20(T23,11(F4.2,1X)/))') (WBADSH(KK),KK=12,NBADSH)
	  END IF
	  WRITE(2,17) BADSH
	END IF
	IF (NRAT .LE. 0) THEN
	  WRITE(2,6)
	  RETURN
	END IF
	WRITE(2,7)
	DO K=1,NRAT
	  IF (SVSH(1,K) .EQ. 'V' .AND. SPOL(K) .GT. 0.0) POL = 'F'
	  IF (SVSH(1,K) .EQ. 'V' .AND. SPOL(K) .LT. 0.0) POL = 'B'
	  IF (SVSH(1,K) .EQ. 'S' .AND. SPOL(K) .GT. 0.0) POL = 'F'
	  IF (SVSH(1,K) .EQ. 'S' .AND. SPOL(K) .LT. 0.0) POL = 'B'
	  IF (SVSH(1,K) .EQ. 'H' .AND. SPOL(K) .GT. 0.0) POL = 'L'
	  IF (SVSH(1,K) .EQ. 'H' .AND. SPOL(K) .LT. 0.0) POL = 'R'
	  WRITE(2,8) LOGRAT(K),CALRAT(K),DIFF(K),MARK(WTRAT(K)+1),
     .	    RSTATN(K),SVSH(1,K),SVSH(2,K),POL,FLAG(K)
	END DO
	WRITE(2,9) RMSALL, RMS
	WRITE(2,6)
	RETURN
C
1	FORMAT(' Angle of "A" with vertical B trend plane is ',F5.1)
3	FORMAT(3F8.2,T30,3F6.1,I9,F10.2,F10.2)
4	FORMAT(3F8.2,T30,3F6.1,I9,10X,F10.2)
5	FORMAT(/' P Polarity error at',T23,11(A4,1X))
6	FORMAT(' ',79('+')/)
7	FORMAT(/T11,'Log10(Ratio)',T53,'Ratio',
     .    T63,'S Polarity'/T6,'Observed',
     1	  T16,'Calculated',T30,
     2	  'Difference',T42,'Station',T53,' Type',T63,'Obs.',
     3	  T69,'Calc.',T75,'Flag')
8	FORMAT(4X,F8.4,T17,F8.4,T30,F8.4,T43,A1,A4,T55,'S',A1,T64,A1,
     .	  T71,A1,T76,A3)
9	FORMAT(/' The RMS log amplitude ratio error for all solutions is',
     1	  F7.3/' The error for acceptable solutions is',F6.3/)
10	FORMAT(/' SV Polarity error at',T24,11(A4,1X))
11	FORMAT(' P Polarity weights:',T23,11(F4.2,1X))
12	FORMAT('  Total P polarity weight is',F7.3)
13	FORMAT(' SV Polarity weights:',T24,11(F4.2,1X))
14	FORMAT('  Total SV polarity weight is',F7.3)
15	FORMAT(/' SH Polarity error at',T24,11(A4,1X))
16	FORMAT(' SH Polarity weights:',T24,11(F4.2,1X))
17	FORMAT('  Total SH polarity weight is',F7.3)
	END
	SUBROUTINE PRINTX(LINE)
C+
c	SUBROUTINE PRINTX(LINE)
C  OUTPUTS A MESSAGE TO THE TERMINAL
C  PRINTX STARTS WITH A LINE FEED BUT DOES NOT END WITH A CARRIAGE RETURN
C  THE PRINT HEAD REMAINS AT THE END OF THE MESSAGE
C
C  IF THE MESSAGE LENGTH IS LESS THAN 40,
C	DOTS ARE INSERTED UP TO COL. 39
C	AND A COLON IS PUT IN COL. 40.
C
C  USE FOR CONVERSATIONAL INTERACTION
C			Alan Linde ... April 1980.
C	10 Sugust 1985:  Corrected a minor error for  strings > 40 bytes
C	20 June 1986:  Made it compatible with Fortran 77
C	24 September 2001: On some platforms there are problems when one
C		writes into column 1.  So the write sstatement now has a 
C		1x to start out.
C-
	character*(*) line
	CHARACTER*60 BUF
	CHARACTER*2 COLON
	CHARACTER*1 DOT,DELIM
	DATA DELIM/'$'/,DOT/'.'/,COLON/': '/
	KK = lenc(LINE)	!  length minus right-hand blanks
	  IF (LINE(KK:KK) .EQ. DELIM) KK = KK - 1
	  IF (KK .GT. 58) KK = 59
	BUF(1:KK) = LINE(1:KK)
	IF (KK .LT. 49) THEN
	  DO J=KK+1,49
	    BUF(J:J) = DOT
	  END DO
	  KK = 49
	END IF
	BUF(KK:KK+1) = COLON
	KK = KK + 2
	WRITE(*,'(1x,A,$)') BUF(1:KK)
	RETURN
	END
C+
	SUBROUTINE PTTPIN (PTTP,ANGS,ANGS2,ANBTP,MOMTEN,PI)
C
C	Calculates other representations of fault planes with
C		trend and plunge of P and T as input.  All
C		angles are in radians.
C	22 July 1985:  Added moment tensor output
C-
	REAL N(3),MOMTEN(6)
	DIMENSION PTTP(4),ANGS(3),ANGS2(3),ANBTP(6),P(3),T(3),A(3),B(3)
	DATA SR2/0.707107/
	CALL TRPL2V(PTTP(1),P)
	CALL TRPL2V(PTTP(3),T)
	DO 100 J=1,3
	  A(J) = SR2*(P(J) + T(J))
	  N(J) = SR2*(T(J) - P(J))
100	CONTINUE
	B(1) = P(2)*T(3) - P(3)*T(2)
	B(2) = P(3)*T(1) - P(1)*T(3)
	B(3) = P(1)*T(2) - P(2)*T(1)
	CALL V2TRPL(A,ANBTP(1),PI)
	CALL V2TRPL(N,ANBTP(3),PI)
	CALL V2TRPL(B,ANBTP(5),PI)
	CALL AN2DSR(A,N,ANGS,PI)
	CALL AN2DSR(N,A,ANGS2,PI)
	CALL AN2MOM(A,N,MOMTEN)
	RETURN
	END
C+
	REAL FUNCTION RVALUE(MSG,RDEF)
C
C PURPOSE:
C		THIS FUNCTION ACCEPTS A MESSAGE (ASKING FOR A VALUE)
C		AND RETURNS THE VALUE ENTERED AT THE TERMINAL
C ROUTINES CALLED:
C		PRINTX
C
C USE:
C		ANS=RVALUE('ENTER AN REAL NUMBER',RDEF)
C	If enter a cariage return, rvalue is set to RDEF
C
C AUTHOR:
C			ALAN LINDE ... AUGUST 1980 (for VALUE)
C
C EXTENSIONS:
C	30 JULY 1989:  CAN HANDLE ENTRY FOLLOWED BY A BLANK OR TAB
C       27 July 1993: Did input read through cstring so can have 
C         comment lines
C	19 July 2002: PCs had a problem with single-digit integers, so ...
C-
	CHARACTER*1 E/'E'/,BLANK/' '/
	CHARACTER*30 STUFF
	CHARACTER*(*) MSG
C
100	CALL PRINTX(MSG)
	call cstring(stuff,nin)
	IF (NIN .GT. 0) THEN
	  NBLANK = INDEX(STUFF(1:NIN),BLANK)
	  IF (NBLANK .GT. 0) NIN = NBLANK - 1
	END IF
	IF (NIN .EQ. 0) THEN
	  RVALUE = RDEF
	ELSE
	  if (nin .eq. 1) then
	    stuff(2:2) = stuff(1:1)
	    stuff(1:1) = '0'
	    nin = 2
	  end if
	  READ(STUFF(1:NIN),*,ERR=100) RVALUE
	END IF
	RETURN
	END
C+
	SUBROUTINE SRCHFM
C
C	Subroutine called by FOCMEC
C
C	Using parameters established in FOCINP it searches the
C	focal sphere for acceptable solutions based on polarity
C	and/or amplitude ratios.  The logic of the search
C	is as follows:  One chooses an orientation for the null
C	or B axis (the trend and plunge).  To cover the focal
C	sphere, the trend would vary from 0 to 360 degrees and
C	the plunge from 0 to 90.  All possible focal mechanisms
C	will then be included if the A axis (Herrmann's X axis)
C	varies from 0 to 180 degrees.  However, solutions in the
C	second quadrant are the same as ones in the first except
C	for the sign of the slip direction.  So only the range
C	from 0 to 90 degrees need be calculated with two 
C	possibilities for slip direction considered for each
C	orientation.  (For the ratios the two solutions would
C	be identical.)  The procedure to calculate the actual
C	solution is described in FLTSOL and the comparison for
C	polarities in OKPOL.
C
C	Arthur Snoke  Virginia Tech  July 1984
C
C	2 September 1986:  made sampling truly equal area on focal sphere
C	8 January 2000:  Added do ... 200 instead of a second do ... 300
C-
	INCLUDE 'FOCMEC.INC'
	REAL*4 A(3), N(3), BMATRX(3,3)
	LOGICAL OKSOL
	NPLUNG = 1 + NINT((BPMAX-BPMIN)/BPDEL)
	if (nplung .eq. 1) bpmax = bpmin
	NAANG = 1 + NINT((AAMAX-AAMIN)/AADEL)
	if (naang .eq. 1) aamax = aamin
	NSOL = 0
	DO 500 JP = 1,NPLUNG
	  IF (JP .LT. NPLUNG) THEN
	    PLUNGE = (BPMIN + (JP-1)*BPDEL)/RD
	  ELSE
	    PLUNGE = BPMAX/RD
	  ENDIF
	  IF (JP .EQ. NPLUNG .AND. BPMAX .GE. 90.0) THEN
	    BTDELN = 0.0
	    NTREND = 1
	  ELSE
	    BTDELN = BTDEL/COS(PLUNGE)
	    NTREND = NINT((BTMAX+BTDEL-BTMIN)/BTDELN)
	    BTDELN = (BTMAX+BTDEL-BTMIN)/NTREND
	  ENDIF
	  DO 400 JT = 1,NTREND
	    TREND = AMIN1(BTMIN + (JT-1)*BTDELN,BTMAX)/RD
	    IF (PLUNGE .EQ. 0.0 .AND. TREND .GE. 180.0/RD) GO TO 400
	    DO 300 JA = 1,NAANG
	      IF (JA .LT. NAANG) THEN
	        ANGLE = (AAMIN + (JA-1)*AADEL)/RD
	      ELSE
	        ANGLE = AAMAX/RD
	      ENDIF
	      CALL FLTSOL(A,N,BMATRX,PLUNGE,TREND,ANGLE,JA)
	      DO 200 JSLIP = 1,2
	        IF (JSLIP .EQ. 2) THEN
	          DO 100 JS=1,3
	            AN = A(JS)
	            A(JS) = N(JS)
	            N(JS) = -AN
100	          CONTINUE
	        ENDIF
	        IF (.NOT.OKSOL(A,N,ANGLE)) GO TO 200
	        NSOL = NSOL + 1
	        IF (NSOL .EQ. MAXSOL) THEN
	          WRITE(2,3) MAXSOL
	          WRITE(*,3) MAXSOL
3	  FORMAT(' Reached chosen maximum of',I5,' solutions')
	          GO TO 600
	        END IF
200	      continue
300	    continue
400	  continue
500	CONTINUE
600	IF (NSOL .GT. 0) THEN
	  WRITE(*,1) NSOL
	  WRITE(2,1) NSOL
1	FORMAT(/' There are',I4,' acceptable solutions')
	ELSE
	  WRITE(2,2)
	  WRITE(*,2)
2	FORMAT(/' There are no acceptable solutions')
	ENDIF
	RETURN
	END
C+
      SUBROUTINE TIMDAT(NOUT,PROGNM)
C
C      INPUT IS PROGRAM NAME
C         A LINE TO NOUT WITH DATE AND TIME AND PROGNM
C	unix version:  25 June 1991  jas/vtso
C-
      character*24 fdate
      CHARACTER*(*) PROGNM
      if (nout .le. 0) return
      write(nout,*) ' ',fdate(),' for program ',prognm(1:lenc(prognm))
      RETURN
      END
C+
C	SUBROUTINE TRPL2V(TRPL,XYZ)
C
C	Transforms to XYZ components of a unit vector from
C		the trend and plunge for the vector.
C	Trend is the azimuth (clockwise from north looking down)
C	Plunge is the downward dip measured from the horizontal.
C	All angles in radians
C	X is north, Y is east, Z is down
C-
	SUBROUTINE TRPL2V(TRPL,XYZ)
	DIMENSION XYZ(3),TRPL(2)
	XYZ(1) = COS(TRPL(1))*COS(TRPL(2))
	XYZ(2) = SIN(TRPL(1))*COS(TRPL(2))
	XYZ(3) = SIN(TRPL(2))
	do j=1,3
	  if (abs(xyz(j)) .lt. 0.0001) xyz(j) = 0.0
	  if (abs(abs(xyz(j))-1.0).lt.0.0001) xyz(j)=xyz(j)/abs(xyz(j))
	end do
	RETURN
	END
C+
	LOGICAL FUNCTION TRUTH(MSG)
C
C
C PURPOSE:
C		ROUTINE ACCEPTS A MESSAGE (QUESTION) REQUIRING A Y/N RESPONSE
C		AND THE RETURN "TRUTH" IS SET:
C			TRUTH = .TRUE.	  IF RESPONSE IS Y(y)
C			TRUTH = .FALSE.                 N(n)
C
C ROUTINES CALLED:
C			IYESNO
C				WHICH CALLS
C						NSTRNG
C						PRINTX
C
C
C USE:
C	I=TRUTH('ANSWER Y OR N')
C	IF (I) ......
C
C OR
C	IF (TRUTH('REPLY Y OR N')) ....
C
C
C AUTHOR:			ALAN LINDE ... AUGUST 1980
C
C  ENTRY
C			ILOGIC (Alan's original name)
C-
	CHARACTER*(*) MSG
	LOGICAL ILOGIC
	ENTRY ILOGIC(MSG)
	TRUTH=.FALSE.
	CALL IYESNO(MSG,IANS)
	IF (IANS.EQ.1) TRUTH=.TRUE.
	ILOGIC = TRUTH
	RETURN
	END
C+
	SUBROUTINE V2TRPL(XYZ,TRPL,PI)
C
C	Transforms from XYZ components of a unit vector to
C	  the trend and plunge for the vector.
C	Trend is the azimuth (clockwise from north looking down)
C	Plunge is the downward dip measured from the horizontal.
C	All angles in radians
C	X is north, Y is east, Z is down
C	If the component of Z is negative (up), the plunge,TRPL(2),
C	  is replaced by its negative and the trend, TRPL(1),
C	  Is changed by PI.
C	The trend is returned between 0 and 2*PI, the plunge
C	  between 0 and PI/2.
C	12 January 2000: If xyz(3) = -1.0, make the trend PI.  Made
C	  consistency in the roundoff -- all are now 0.0001
C-
	DIMENSION XYZ(3),TRPL(2)
	do j=1,3
	  if (abs(xyz(j)) .le. 0.0001) xyz(j) = 0.0
	  IF (ABS(ABS(XYZ(j))-1.0).LT.0.0001) xyz(j)=xyz(j)/abs(xyz(j))
	end do
	IF (ABS(XYZ(3)) .eq. 1.0) THEN 
C
C	plunge is 90 degrees
C
	  if (xyz(3) .lt. 0.0) then
	    trpl(1) = PI
	  else
	    TRPL(1) = 0.0
	  end if
	  TRPL(2) = 0.5*PI
	  RETURN
	END IF
	IF (ABS(XYZ(1)) .LT. 0.0001) THEN
	  IF (XYZ(2) .GT. 0.0) THEN
	    TRPL(1) = PI/2.
	  ELSE IF (XYZ(2) .LT. 0.0) THEN
	    TRPL(1) = 3.0*PI/2.0
	  ELSE
	    TRPL(1) = 0.0
	  END IF
	ELSE
	  TRPL(1) = ATAN2(XYZ(2),XYZ(1))
	END IF
	C = COS(TRPL(1))
	S = SIN(TRPL(1))
	IF (ABS(C) .GE. 0.1) TRPL(2) = ATAN2(XYZ(3),XYZ(1)/C)
	IF (ABS(C) .LT. 0.1) TRPL(2) = ATAN2(XYZ(3),XYZ(2)/S)
	IF (TRPL(2) .LT. 0.0) THEN
	  TRPL(2) = -TRPL(2)
	  TRPL(1) = TRPL(1) - PI
	  END IF
	IF (TRPL(1) .LT. 0.0) TRPL(1) = TRPL(1) + 2.0*PI
	RETURN
	END
C+
	FUNCTION VALUE(MSG)
C
C PURPOSE:
C		THIS FUNCTION ACCEPTS A MESSAGE (ASKING FOR A VALUE)
C		AND RETURNS THE VALUE ENTERED AT THE TERMINAL
C ROUTINES CALLED:
C		PRINTX, CSTRING
C
C USE:
C		ANS=VALUE('ENTER A REAL VALUE')
C	AND
C		IANS=VALUE('ENTER AN INTEGER')
C
C AUTHOR:
C			ALAN LINDE ... AUGUST 1980
C
C EXTENSIONS:
C
C	  One can now enter exponential format in VALUE or RVALUE
C	30 JULY 1989:  CAN HANDLE ENTRY FOLLOWED BY A BLANK OR TAB
C	27 July 1993: Did input read through cstring so can have
C	  comment lines
C
C	2001.05.24	Khalil Hayek, GSC
C	Changed READ(,F20,) to READ(,*,) to be able to handle
C	integers.
C	Not needed on my compilers, but ok.  Commented out E20 option  (jas)
C	19 July 2002: PCs had a problem with single-digit integer, so ...
C-
	CHARACTER*1 E/'E'/,BLANK/' '/
	CHARACTER*30 STUFF
	CHARACTER*(*) MSG
C
100	CALL PRINTX(MSG)
	call cstring(stuff,nin)
	IF (NIN .GT. 0) THEN
	  NBLANK = INDEX(STUFF(1:NIN),BLANK)
	  IF (NBLANK .GT. 0) NIN = NBLANK - 1
	END IF
	IF (NIN .EQ. 0) THEN
	  VALUE = 0.0
	ELSE
	  if (nin .eq. 1) then
	    stuff(2:2) = stuff(1:1)
	    stuff(1:1) = '0'
	    nin = 2
	  end if
	  READ(STUFF(1:NIN),*,ERR=100) VALUE
	END IF
	RETURN
	END

CJAB(BGS)Mar28/1995 : changes to assist in data entry
CSTART**************************************************************************
c              PROGRAM TO CREATE SEISMIC DATA FILE
C              ===================================
C
C    WRITTEN BY EZRA AND REUBEN, MAY 1990
c
c
C    CHANGES AND UPDATES:
C    1991-04-04; CL : INITILIZATION OF TEXT STRINGS ADDED
C    1992  2  7  JH : NEW NORDIC, EXTRA HEADER LINE, do not ask for hr min
c    sep 10 92 ny jh: fix problems
c    sep 8  93      : check if output file there, fix bug
c    sep 18         : stop any where
CJAB(BGS)Mar95      : Make header easier to enter.
c---------------------------------------------------------------------
c    oct 98          --------------   version 7.0 check ---------------
c                    5 station chars, remove explanation line for header
c
c                     and sec in header
C
C                VARIABLE IDENTIFICATION
C                ------------------------
C           STAT: station name
C           SP: S=instrument type: S=short period
c                                  L=long period, I=intermediate
c               P=component(Z,N,E)
C           I=Quality indicator(I,E,( ) )
C           PHAS=phase identification(P,S,Pg e.t.c)
c           W= weighting indicator
c           D=first motion(U: up; D:down; or C: compression; D:dilatation)
c           CODA=duration(to noise) in seconds
c           AMPLIT=amplitude(zero-peak) in nanometers
c           PERI=period in seconds
c           HR= hours,MM=minutes,SECON=seconds
c      
                  integer      start              !JAB(BGS)Mar95. Text position.
                  CHARACTER*80 TEXT/' '/,OLDTEX/' '/
                  character    chr_text *(80)     !JAB(BGS)Mar95.
                  character answer
		  INTEGER ERROR


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c          
	  WRITE(6,*) '  *************************************************'
	  WRITE(6,*) ' This program creates a file with new events'
	  WRITE(6,*) ' Output file: neweve.out'
	  WRITE(6,*) ' neweve.out is used as input to program: SPLIT'
      WRITE(6,*) '  *************************************************'
	  WRITE(6,*) '   '
	  WRITE(6,*) '        Note the following.....!!!!!'
	  WRITE(6,*) '   '
	  WRITE(6,*) ' 1. Text will be converted to UPPERCASE'   !JAB(BGS)Mar95.
	  WRITE(6,*) ' 2. Enter data only below MARKED fields'
	  WRITE(6,*) ' 3. RETURN (blank line) is new event.'
	  WRITE(6,*) ' 4. STOP  stops the program'
          write(6,*) ' 5. To correct a line, use _ for blank'
          write(6,*) ' 6. Auto repeat of STAT SP HHMM'
	  WRITE(6,*)
C
C   OPEN FILE
C
      OPEN(2,FILE='neweve.out',STATUS='new',err=888)
      goto 889
 888  continue
      write(6,*)' The NEWEVE.OUT file exists, do you want to',
     *          '  overwrite(y/n)'
      read(5,'(a)') answer
      if(answer.eq.'y'.or.answer.eq.'Y') then
          open(2,file='neweve.out',status='unknown')
      else
          stop
      endif
 889  continue           
C
C  ENTER HERE FOR NEW EVENT
C
   10 CONTINUE
C
      WRITE(6,*) 'New event: First enter header information....'
      WRITE(6,*)'YEAR MMDD LE' 
      READ(5,'(A)') chr_text                     !JAB(BGS)Mar95.
      call sei upc ( chr_text )                  !JAB(BGS)Mar95. Uppercase.
      if( chr_text(:4) .eq. 'STOP' ) stop        !JAB(BGS)Mar95.
c                                                !JAB(BGS)Mar95.
c    Find start position for text, so that       !JAB(BGS)Mar95.
c    different hardware situations can be        !JAB(BGS)Mar95.
c    accounted for                               !JAB(BGS)Mar95.
c                                                !JAB(BGS)Mar95.
      start = 0                                  !JAB(BGS)Mar95. Initialise.
1111  start = start + 1                          !JAB(BGS)Mar95. Increment.
      if( chr_text .eq. ' ' )then                !JAB(BGS)Mar95. Invalid.
      write(*,*)'Blank entry...try again...'     !JAB(BGS)Mar95.
      goto 10                                    !JAB(BGS)Mar95. Try again.
c                                                !JAB(BGS)Mar95.
      else if(chr_text(start:start) .eq. ' ')then!JAB(BGS)Mar95. Not there yet!.
      goto 1111                                  !JAB(BGS)Mar95. & try again.
c                                                !JAB(BGS)Mar95.
      else                                       !JAB(BGS)Mar95. Found.
      text(2:) = chr_text(start:)                !JAB(BGS)Mar95. & setup.
      end if                                     !JAB(BGS)Mar95.  
c
      TEXT(22:23)=TEXT(12:13)
      TEXT(12:13)='  '
      TEXT(1:1)=' '
C
C   CHECK HEADER
C
      IF(TEXT(22:22).NE.'L'.AND.TEXT(22:22).NE.'R'.AND.TEXT(22:22).
     *NE.'D') THEN
         WRITE(6,*)' YOU  MUST GIVE EVENT TYPE L, R OR D'
         GOTO 10
      ENDIF
      READ(TEXT(2:10),'(I4,1X,2I2)',ERR=27) IYEAR,IMONTH,IDAY
      goto 28
 27   CONTINUE
         WRITE(6,*)' SOMETHING WRONG WITH YEAR AND DATE INFO'
         goto 10
 28   continue
      IF(IYEAR.GT.2100.OR.IYEAR.LT.0.OR.IMONTH.GT.12.OR.IMONTH.
     *LT.1.OR.IDAY.GT.31.OR.IDAY.LT.1) THEN
         WRITE(6,*)' SOMETHING WRONG WITH YEAR AND DATE INFO'
         GOTO 10
      ENDIF
      WRITE(2,'(A)') TEXT
C
C Print headers in file and screen
C
c      WRITE(2,201)
c 201  FORMAT(' YYYY MMDD HHMM  SEC LE LT.XXX LON.XXX DP.XFF     N RMS',
c     *'                        3')	  
      WRITE(2,200)
  200 FORMAT(' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI',
     *' AZIMU VELO AIN AR TRES  W DIS CAZ7'  )
c     *' AZIMU VELO SNR AR TRES  W DIS CAZ7'  )
C
C   ***** NOTE: SOME DIFFERENCE BETWEEN COMPILERS MIGHT OCCUR HERE......
C
      WRITE(6,*)'STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI'
C
C Start of input data
      DO 20 I=1,2000
      read(5,'(A)') chr_text                    !JAB(BGS)Mar95. Get text.
      call sei upc( chr_text )                  !JAB(BGS)Mar95. Make uppercase.
      text(1:75) = ' ' // chr_text(start:)      !JAB(BGS)Mar95. positioned data.
C
C Check for end of data entry
C
	    IF(TEXT(2:5).EQ.'STOP') GOTO 99
C
C  Check for end of event
C
        IF(TEXT(1:30).EQ.'                             ') GOTO 30
C
C  Check if information from previous line should be used
C
C  STATION
C
        IF(TEXT(2:6).EQ.'     ')TEXT(2:6)=OLDTEX(2:6)  
        OLDTEX(2:6)=TEXT(2:6)
C Type of instrument
        IF(TEXT(7:7).EQ.' ') TEXT(7:7)=OLDTEX(7:7)
        OLDTEX(7:7)=TEXT(7:7)
c Component type
	   IF(TEXT(8:8).EQ.' ') TEXT(8:8)=OLDTEX(8:8)
	   OLDTEX(8:8)=TEXT(8:8)
c Quality indicator
C	  IF(TEXT(10:10).EQ.' ') TEXT(10:10)=OLDTEX(10:10)
C	  OLDTEX(10:10)=TEXT(10:10)
c Phase type
C	 IF(TEXT(11:11).EQ.' ') TEXT(11:11)=OLDTEX(11:11)
C	 OLDTEX(11:11)=TEXT(11:11)
c Hours 
        IF(TEXT(19:20).EQ.'  ')TEXT(19:20)=OLDTEX(19:20)
        OLDTEX(19:20)=TEXT(19:20)
c Minutes 
	  IF(TEXT(21:22).EQ.'  ') TEXT(21:22)=OLDTEX(21:22)
	  OLDTEX(21:22)=TEXT(21:22)
C Check input data
        CALL CHECK(start,TEXT,ERROR)      !JAB(BGS)Mar95.
        WRITE(2,'(A)')TEXT(1:75)
        oldtex=text
   20 CONTINUE   
C
   30 CONTINUE
c Leave blank between events
      WRITE(2,330)
  330 FORMAT(' ')
      GOTO 10
 99   CONTINUE
      WRITE(2,340)
 340  FORMAT(' ')
      STOP
      END

C            SUBROUTINE FOR VALIDATING INPUT DATA
C            ------------------------------------   
             SUBROUTINE CHECK(start,TEXT,ERROR)    !JAB(BGS)Mar95.
C
             CHARACTER*80 TEXT,NEWTEX
             INTEGER ERROR
             integer start                         !JAB(BGS)Mar95.
             character    chr_text *(80)           !JAB(BGS)Mar95.
C
C  Input:   text: input line to chech,if something is wrong
c                 a new line is asked
c  Output:  text:the corrected line
c                 ERRORS: NO ERROR=0
C                         ERRORS=1
C
          ERROR=0
C
C  Start of checking loop
   25 CONTINUE
c   
c Check onset phase
C
       IF(TEXT(10:10).NE.'I'.AND.TEXT(10:10).NE.'E'.AND.TEXT(10:10).
     *   NE.' ') THEN
         WRITE(6,120) 
  120    FORMAT(' ***ONSET NOT VALID ***')
         ERROR=1
       ENDIF
C Check phase
c change lot 03/2006
       IF((TEXT(11:11).NE.'P'.AND.TEXT(11:11).NE.'S'.AND.TEXT(11:11)
     *  .NE.' '.and.text(11:11).ne.'L'.and.text(11:11).ne.'R'.and.
     *  text(11:11).ne.'A')
     *  .OR.TEXT(10:11).EQ.'  ') THEN
        WRITE(6,150) TEXT(11:11)
  150   FORMAT(' ***PHASE INPUT  ' ,A1,' NOT LEGAL,CORRECT LINE')
        ERROR=1
      ENDIF
C
C Check whether time is   within the range
c
      READ(TEXT(19:20),'(I2)',ERR=123) IHOUR
      goto 1124
 123  CONTINUE
	  WRITE(6,260) TEXT(19:20)
      errror=1
 1124 continue

      IF(IHOUR.GT.24.OR.IHOUR.LT.0) THEN
	    WRITE(6,260) TEXT(19:20)
  260   FORMAT(' ***hours  ',A2,' out of range,correct time **')
        ERROR=1
      ENDIF
C
c Check for minutes
C
      READ(TEXT(21:22),'(I2)',ERR=124) MIN
      goto 1224
 124  continue
      write(6,270)
      error=1
 1224 continue
      IF(MIN.LT.0.OR.MIN.GT.60) THEN
	    WRITE(6,270)
  270   FORMAT(' ***time in minutes is out of range ***')
        ERROR=1
	  ENDIF	 			  		
C Check if any errors
      IF(ERROR.EQ.0) GOTO 40
C If errors are present
      WRITE(6,*)'Correct data---------'
      WRITE(6,*)'STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI'
      write(*,*)text(2:)                                  !JAB(BGS)Mar95.
C
C  Read corrected text line, compare with old text and replace
c  chars in old text with chars in new text if different,or blank
c  if underscore
c
      read(5,'(A)') chr_text                        !JAB(BGS)Mar95.
      call sei upc( chr_text )                      !JAB(BGS)Mar95.
      if( chr_text(:4) .eq. 'STOP' ) stop           !JAB(BGS)Mar95.
      newtex = ' ' // chr_text(start:)              !JAB(BGS)Mar95.
C                                                   !JAB(BGS)Mar95.
      DO 30 I=2,80
        IF(NEWTEX(I:I).EQ.' ') GOTO 30
        if(newtex(i:i).eq.'_') then
           text(i:i)=' '
           goto 30
        endif
        IF(NEWTEX(I:I).NE.TEXT(I:I)) TEXT(I:I)=NEWTEX(I:I)
   30 CONTINUE
      ERROR=0
      GOTO 25
C End of loop
  40  CONTINUE
      RETURN
      END                       

      subroutine auto_tr(data,nhead,nfile,filename)
c
c   routine to get trace file names for nordic file
c
c   updates
c
c   feb 99 by jh :---------------  verison 7.0 check ------------------
c                 no changes
c
c   input:
c   data: nordic S-file
c   nhead: number of headers in file
c   output:
c   nfile: number of waveform files
c   filename: waveform files
c
      implicit none
      character*80 data(*)
ccc      character*80 filename(*)
      character*(*) filename(*)
      integer nhead,nfile
c
c-- help variables
c
      integer i
      nfile=0
      do i=2,nhead
         if(data(i)(80:80).eq.'6') then
            nfile=nfile+1
            filename(nfile)(1:78)=data(i)(2:79)
            filename(nfile)(79:80)=' '
          endif
      enddo
      return
      end

c$large
c$debug
C  c-----------------------------------------------------------------------
c
c  original Bouchon program has been modified in output, will now use
c  SEISAN files to make a SEISAN binary output file with both the original
c  and synthetic data, lined up using the residuals in the hyp.out file
c  Nothing in the working of the Bouchon program has been changed,
c  only graphics cut out
c
c  J Havskov, February 1993
c
c  updates:
c  apr 13 93 by jh: bug in syntsel
c  jul 16 93      : interactive channel delay
c  aug 30         : seisinc instead fo seisin to save memory for pc
c  dec 93         : more arguments to seisinc,
c                   read from hyp.out instead of synt.inp, bug in pc
c  jan 94         ; fix moment, new valerie version
c  apr 95         : only use one triangular source
c  nov 95         : use seidim
c  may 99 jh      : -----------------   version 7.0 check -----------------
c                   stat to 5 char
c
c
        include 'seidim.inc'
        parameter (nfq=513,nst=32)
        DIMENSION  utdat(3,2*nfq)
C                  utdat(j,i)  collects the output data, to be written out later
C                              is real, with three components,
c
      character*80 data(max_data)
      integer nstat,ndata
      character*5 stat(nst)
      dimension u(nfq,nst,3),yy(2*nfq),source(nfq),y(4*nfq)
      dimension r(nst)
c   dimension li‚e … la source complexe
      dimension dtt(20),tau(20),ah(20)
      complex *16 q1,u,source,omega,ai,q2,q3,ait0
      real t0synt(max_trace)
      real*4 maxgen
c-- code for component orientation
      logical radial


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c  pgm de calcul du sismogramme synthetique produit par la m‚thode de Bouchon
c  des sources triangulaires peuvent etre introduites
c  le moment sismique pris en compte est de 10**15 Newton-metres
c  les entrees sont en km et km/s et la masse volumique en tonne/m**3
c  sorties en metres
c
      ai=(0.,1.)
      pi=asin(1.)*2.
      pi2=pi+pi
      maxgen=0.
c
c   open files
c
c   output from Bouchon synthetic program, bouch.for
c		
      open(10,form='formatted',file='bouch.out',status='unknown')
c
c   a scratch file where the synthetic time signal are written out
c   temporarely before being merged with seisan binary file
c
      open(20,status='scratch')
c      open(20,file='bousei.txt',status='unknown')
c
c  standard hyp.out file from Seisan
c
      open(1 ,file='hyp.out',status='unknown')
c
c   read data from pick file
c
      ndata=1
 49   continue
      read(1,'(a)',end=50) data(ndata)
      ndata=ndata+1
      goto 49
 50   continue
      ndata=ndata-1
c
c   find stations modelled
c
      nstat=0
      do i=1,ndata
         if(data(i)(80:80).eq.'3'.and.data(i)(2:15).eq.'SYNT: STATION:')
     *   then
            do k=1,nstat
              if(stat(k).eq.data(i)(17:21)) goto 81
            enddo
c
c   station was not counted before
c
            nstat=nstat+1
            stat(nstat)=data(i)(17:21)
 81         continue
         endif
      enddo
      write(6,*)'Number of stations', nstat
c
c   read if Radial-Transverse or North-East components
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: COMPON-:') then
            radial=.false.
            if  (data(i)(20:25).eq.'RADIAL') radial=.true.
         endif
      enddo

c   half-duration of the source
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: DT-Tsou:') then
            read(data(i),'(25x,f10.3)') t00dat
         endif
      enddo

c   total time window, initial time
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: TIMES--:') then
            read(data(i),'(15x,3(10x,f10.1))') window,t0
         endif
      enddo

c   reduction velocity
c
      redvel=0.
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: REDVELO:') then
            read(data(i),'(15x,3f10.1)') redvel
         endif
      enddo
c
c   read from bouch.out file
c
      read(10,*) nt,tl,q,nr
      write(*,*)' nt,tl,nr',nt,tl,nr
      nfreq=nt/2
      nfreq1=nfreq+1
      if(nfreq1.gt.nfq.or.nr.gt.nst) then
          write(*,*)' error dimentions nfq ns - max: ',nfq,nst
          stop
      endif
      read(10,*)(r(ir),ir=1,nr)
c
c   calculate origin times at different epicentral distances
c
c     t0=0.
      if (redvel.eq.0.)  then
        do ir=1,nr
          t0synt(ir)=t0
        enddo
      else  
        epimin=r(1)
        do ir =2,nr   
          epimin=amin1(epimin,r(ir))
        enddo
        do ir =1,nr   
          t0synt(ir)=t0 +(r(ir)-epimin)/redvel
        enddo
      endif
c
      dt=tl/nt
      aw=-pi/q
      write(*,*) 'displacement=1, velocity=2, acceleration=3'
      read(*,*) ind
c ====lecture fichier donnees======================
      bidm=0
      do 55 if=1,nfreq1
        read(10,2500)((u(if,ir,j),j=1,3),ir=1,nr)
        read(10,*) bidon
2500    format(10e12.5)
        if(bidon.gt.bidm) bidm=bidon
 55   continue
cejns      write(*,*)' m max et bidon der:',bidm,bidon
c ============================ ====================
      dfreq=1./tl
c===================================================
c     description de la source
c       write(*,*)' Bouchon source model (1)'
c       read(*,*) ibou
        am0=10000.0
        ibou=2
        if(ibou.eq.1) then
c            write(*,*) 'Enter rise time '
c            read(*,*) t00
             t00=2.*t00dat
c             write(*,*) 'Enter moment '
c             read(*,*) am0
      else
c  sources triangulaires
c            write(*,*)' Number of sources,if one use default'
c            read(*,*) nbs
             nbs=1
             surf=0.
             if(nbs.eq.1) then
               dtt(1)=0.0
               tau(1)=t00dat
               ah(1)=1.0
               surf=surf+tau(1)*ah(1)
             else
                do 800 i=1,nbs
c  decalage milieu base triangle par rapport tps origine
                    write(*,*)' Delay, half-length and hight'
                    read(*,*) dtt(i),tau(i),ah(i)
                    surf=surf+tau(i)*ah(i)
cvalerie apr 95                if(dtt(i).le.0.) dtt(i)=tau(i)
800             continue
             endif
c    calcul du moment sismique total
             surf=1./surf
        endif
        write(6,*)' Source half duration ',tau(1) 
c
c-------------------------------------------------------------------------
c--------------loop over stations
c-------------------------------------------------------------------------
c
      do 56 ir=1,nr
c
c   skip the initialisation of source and other functions if 
c             origin time identical at the different stations
c
      if(redvel.eq.0..and.ir.ne.1) goto 59
c
c   calcul de la source
c
         ait0=ai*t0synt(ir)
         freq=0.
         do 1 if=1,nfreq1
              rw=pi2*freq
              omega=cmplx(rw,aw)
              if(ibou.eq.1) then
                    if(t00.lt.1.e-5) then
                        q3=ai/omega
                    else
                        q1=omega*pi/4.
                        q2=q1*t00
                        q2=cdexp(q2)
                        q3=ai*t00*pi/2.
                        q3=q3/(q2-1./q2)
                    endif
                    q2=omega*ait0
                    source(if)=q3*cdexp(q2)
              else
                    source(if)=0.
c    bouch1= calcul fonction de Green pour deplacement
                    do 850 iy=1,nbs
                         q2=omega*ai*(t0synt(ir)-dtt(iy))
                         q1=omega*tau(iy)/2.
c   integration du signal triangulaire derivee du moment sismique
                         source(if)=source(if)-ah(iy)*tau(iy)*
     *                   (cdsin(q1)/q1)**2*cdexp(q2)/omega/ai
850                  continue
                     source(if)=source(if)*surf
              endif
              if(ind.eq.2) source(if)=source(if)*(ai*omega)
              if(ind.eq.3) source(if)=-source(if)*omega**2
1        freq=freq+dfreq
         n3=2*nt+3
         tex1=exp(-aw*dt)
         ex7=exp(-aw*t0synt(ir))
c        ex7=1.
         do 140 i=1,nt
            yy(i)=ex7
140      ex7=ex7*tex1
 59   continue
c---------------------------------------------------
c   loop over 3 channels
c--------------------------------------------------
c
c   set counter for interchanging channels, factor for polarity on z
c   since that is reversed
c
      ichan=1
      pol=1.
c
      do 516 j=1,3
      ichan=ichan+1
      if(ichan.eq.4) then
        ichan=1
        pol=-1.
      endif
c
c  spectre source et propagation
c
      do 518 i=1,nfreq+1
         q1=u(i,ir,j)*source(i)
         i2=i+i
         i1=i2-1
         y(i1)=real(q1)
c first for pc, seocnd for sun
c        y(i2)=aimag(q1)
         y(i2)=dimag(q1)
         if(i1.eq.nt+1) go to 518
         y(n3-i1)=-y(i2)
         y(n3-i2)=y(i1)
518   continue
      call four1(y,nt,1)
      do 521 i=1,nt
         y(i)=y(i+i-1)*yy(i)
521   continue
c
c   save data
c
         do 522 i=1,nt
           utdat(ichan,i) = y(i)*pol*100000.*am0
522      continue
c------------------------------------------------------------end comp loop
516   continue
c------------------------------------------------------------end comp loop
c
c   write data in output file, identify stations and channels
c
        write(20,'(a5,a4)')stat(ir),'   Z'
        write(20,*)(utdat(1,i),i=1,nt)
        if (radial) write(20,'(a5,a4)')stat(ir),'   R'
        if (.not.radial) write(20,'(a5,a4)')stat(ir),'   N'
        write(20,*)(utdat(2,i),i=1,nt)
        if (radial) write(20,'(a5,a4)')stat(ir),'   T'
        if (.not.radial) write(20,'(a5,a4)')stat(ir),'   E'
        write(20,*)(utdat(3,i),i=1,nt)
56      continue
c------------------------------------------------------------end station loop
c
c   integrate synthetic and real data in a seisan file
c
c       tsamp=tl/(nt-1)
c       write (*,*) 'syntsel',(t0synt(ir),ir=1,nr)
c        write(*,*)'syn',ndata,t0,window,t0synt,dt,nt
        call syntsel(data,ndata,t0,window,t0synt,dt   ,nt,'SB ')

80    stop
      end
c***************************************************************************
      subroutine four1(data,nn,isign)
      real*8 wr,wi,wpr,wpi,wtemp,theta
      dimension data(1)
      n=2*nn
      j=1
      do 11 i=1,n,2
      if(j.gt.i) then
      tempr=data(j)
      tempi=data(j+1)
      data(j)=data(i)
      data(j+1)=data(i+1)
      data(i)=tempr
      data(i+1)=tempi
      endif
      m=n/2
1     if((m.ge.2).and.(j.gt.m)) then
      j=j-m
      m=m/2
      go to 1
      endif
      j=j+m
11    continue
      mmax=2
2     if(n.gt.mmax) then
      istep=2*mmax
      theta=6.28318530717959d0
      theta=theta/(isign*mmax)
      wpi=dsin(theta)
      wpr=-2.0d0*dsin(0.5d0*theta)**2
      wr=1.d0
      wi=0.d0
      do 13 m=1,mmax,2
      do 12 i=m,n,istep
      j=i+mmax
      tempr=sngl(wr)*data(j)-sngl(wi)*data(j+1)
      tempi=sngl(wr)*data(j+1)+sngl(wi)*data(j)
      data(j)=data(i)-tempr
      data(j+1)=data(i+1)-tempi
      data(i)=data(i)+tempr
      data(i+1)=data(i+1)+tempi
12    continue
      wtemp=wr
      wr=wr*wpr-wi*wpi+wr
      wi=wi*wpr+wtemp*wpi+wi
13    continue
      mmax=istep
      go to 2
      endif
      return
      end

c
c  Output-Lines in GSE-Format have always a length of 80 characters, also the
c  last line of the DAT2 section. Urs Kradolfer, 6.6.99
c
c  Version 98.002 - 27.11.98
c==============================================================================
c     Karl Koch, 08.05.98
c
c     This file contains two subroutines: GSEIN and GSEOUT
c
c          *) GSEIN ....  reads GSE-waveform data
c
c          *) GSEOUT ...  write GSE-waveform data
c
c==============================================================================
c
c-----
      subroutine gsein(iin,iout,cbuf,iy,ichecksum,ierr)
c------------------------------------------------------------------------------
c     Input/Output parameters:
c        iin ......... logical unit with input data
c        iout ........ logical unit for output data
c        cbuf ........ character array to store compressed data (see c_bufsize)
c        iy .......... integer array to hold raw waveform data (see c_sigsize)
c        ichecksum ... checksum value for data stored in iy according to format
c        ierr ........ error code
c
c        in common block
c        hdr_ifmtnum . GSE format identifier of input data
c        hdr_nsamp ... number of samples in array iy
c
c        disabled
c        iformat_in .. GSE format identifier (ie. =2 for GSE2.0) (output)
c        nmax ........ number of samples in array iy (output)
c        lin ......... character array to hold header lines
c        ilin ........ number of header lines (output)
c------------------------------------------------------------------------------
c
      implicit none

c     -- include header variables (hdr_...) and constants (c_...)
      include 'codeco_common.f'

c     -- parameters
      integer*4 iin, iout
      character*1 cbuf(1)
      integer*4 iy(1)
      integer*4 ichecksum, ierr

c     -- local variables
      integer*4 icomp, i, j, ierror, nchecksum
      integer*4 numout, nchar, ii
      integer*4 trimlen
      integer*4 icheck_sum_gse1,icheck_sum_gse2
      real      fsec                 ! seconds and milliseconds
      character line*132, fmt*6
      character firstline*132        ! store first line for error message
c     -- for month conversions:
      integer   mnths(12)
      data mnths/31,28,31,30,31,30,31,31,30,31,30,31/

c     -- executable code

		hdr_coosys = ' '
      if  (hdr_debug .gt. 2)  write (*,*)  '-- entering gsein'
      ierr = 0

c     -- loop all lines in GSE file until WID is found
1     read(iin,'(a)',end=999) line
      if  (line(1:4) .ne. 'WID1' .and. line(1:4) .ne. 'WID2')  then
c        -- copy all lines before WID-line
         if  (hdr_ofmtnum .gt. 0)
     &      write(iout,'(a)') line(1:trimlen(line))
         goto 1
      else
         if  (line(1:4).eq.'WID1')  hdr_ifmtnum = 1
         if  (line(1:4).eq.'WID2')  hdr_ifmtnum = 2
      endif
      firstline = line
      if  (hdr_debug .gt. 3)  then
         write (*,*)  '-- found hdr line: '
         write (*,'(a)')  firstline
      endif
c
      if  (hdr_ifmtnum .eq. 2)  goto 20
c
c     -- input data are in GSE1.0 format
c
      if  (hdr_debug .gt. 0)  write(*,*)
     &   '-- reading GSE1.0 format data'

c     -- parse first header line of GSE1.0
100   format(i4,i3,3(1x,i2),1x,i3,1x,i8,1x,a6,1x,a8,1x,
     &   a2,1x,f11.7,1x,a6,1x,a4,1x,i1)
      read( line(7:), 100 ) hdr_year, hdr_jday, hdr_hour, hdr_min,
     &   hdr_sec, hdr_msec, hdr_nsamp, hdr_station, hdr_stadescr,
     &   hdr_chan, hdr_smprate, hdr_instr, hdr_ifmtname, hdr_idiff

c     -- read and parse second header line
      read( iin, '(a)' ) line
101   format(f9.6,i1,f7.4,1x,4(f9.4,1x),2(f7.2,1x),f6.1,1x,f6.1)
      read( line, 101 ) hdr_calfac, hdr_calunit, hdr_calper,
     &   hdr_stalat, hdr_stalon, hdr_staelev, hdr_stadepth,
     &   hdr_beamaz, hdr_beamslo, hdr_hang
      if  (hdr_nsamp .gt. c_sigsize)  goto 998

c     -- compute day and month from julian day
cks      if(ifix(float(hdr_year)/4.0)*4 .eq. hdr_year) mnths(2)=29
cks      hdr_month = 0
cks      do i=1,12
cks         hdr_month = hdr_month + mnths(i)
cks         if  (hdr_month .ge. hdr_jday)  goto 60
cks      enddo
cks60    hdr_month = hdr_month - mnths(i)
cks      hdr_day = hdr_jday - hdr_month
cks      hdr_month = i
      call julien( hdr_day, hdr_month, hdr_year, hdr_jday, 0 )

c     -- adjust channel name (insert a 'H' in the middle)
      hdr_chan(3:3) = hdr_chan(2:2)
      hdr_chan(2:2) = 'H'
      call casefold( hdr_chan )

c     -- read away all lines until DAT1
      if  (hdr_debug .gt. 3)  write (*,*) '-- find DAT1'
2     read( iin, '(a)' )  line
      if  (line(1:4) .ne. 'DAT1')  goto 2

c     -- Now read in data according to the format:
      if  (hdr_debug .gt. 2)  write (*,*) '-- read in samples'
      if  (hdr_ifmtname .eq. 'INTV')  then
         if  (hdr_debug .gt. 3)  write (*,*) '-- read INTV data'
         read(iin,*) (iy(i),i=1,hdr_nsamp)
         read(iin,'(4x,6x,i15)') ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
      if(hdr_ifmtname(1:3).eq.'INT'.and.hdr_ifmtname.ne.'INTV')then
         if  (hdr_debug .gt. 3)  write (*,*) '-- read INTx data'
         read(hdr_ifmtname(4:4),*) ii
         read(iin,'(a)') line
         i=(trimlen(line)+ii-1)/ii
         write(fmt,'(''('',i2.2,''i'',i1.1,'')'')') i,ii
         backspace(3)
         read(iin,fmt) (iy(i),i=1,hdr_nsamp)
         read(iin,'(4x,6x,i15)') ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
c
      if(hdr_ifmtname(1:3).eq.'CMP')then
         if  (hdr_debug .gt. 3)  write (*,*) '-- read CMPx data'
         read(hdr_ifmtname(4:4),*) icomp 
         j=0
c        -- loop all data lines
10       continue
            read(iin,'(a)') line
            if(line(1:4).eq.'CHK1') goto 11
            nchar=trimlen(line)
            do i=1,nchar
               j=j+1
               cbuf(j)=line(i:i)
            enddo
         goto 10
11       continue
         read(line(5:),*) ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
         nchar=j
         numout=c_sigsize   ! on input, give max. size of array iout (=iy)
         if  (hdr_debug .gt. 3)  write (*,*) '-- decompress', icomp
         if(icomp.eq.6) call DCOMP6(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.7) call DCOMP7(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.8) call DCOMP8(nchar,cbuf,numout,iy,ierror)
         if(ierror.eq.-1) write(6,*)'Integer*4 array not large enough !'
         if(numout.ne.hdr_nsamp)then
            write(6,*)'Error in retrieving correct number of samples !'
            write(6,*)'Expected ',hdr_nsamp,', received ',numout
         endif
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif

c     -- remove first or second differences if necessary
      if  (hdr_debug .gt. 3)  write (*,*) '-- remove differences diff:',
     &   hdr_idiff, 'no. samples: ', hdr_nsamp
      do i=1,hdr_idiff
         call REMDIF1(iy,hdr_nsamp)
      enddo
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'
c
      if (hdr_ifmtnum.eq.1) goto 50
      write(6,*) 'There is good news and bad news at this point:'
      write(6,*) 'First the good news: no more CPU time will be used!!!'
      write(6,*) 'and now the bad news: You have screwed up !!!'
      stop
c
c     -- The input data are GSE2.0
c
20    if  (hdr_debug .gt. 0)  write(*,*) '-- reading GSE2.0 format data'

c     -- parse WID2 line
200   format(i4,1x,i2,1x,i2,1x,i2,1x,i2,1x,f6.3,1x,a5,1x,a3,1x,
     &  a4,1x,a3,1x,i8,1x,f11.6,1x,e10.2,1x,f7.3,1x,a6,1x,f5.1,1x,f4.1)
      read( line(6:), 200 )  hdr_year, hdr_month, hdr_day, hdr_hour,
     &   hdr_min, fsec, hdr_station, hdr_chan, hdr_stadescr,
     &   hdr_ifmtname, hdr_nsamp, hdr_smprate, hdr_calfac, hdr_calper,
     &   hdr_instr, hdr_hang, hdr_vang
      hdr_sec = ifix( fsec )
      hdr_msec = nint( (fsec-float(hdr_sec)) * 1000.0 )
      if  (hdr_debug .gt. 3)  write (*,*) '-- got start time: ',
     &   hdr_year, hdr_month, hdr_day, hdr_hour, hdr_min, hdr_sec,
     &   hdr_msec
      if (hdr_nsamp .gt. c_sigsize) goto 998

c     -- compute julian day
cks      if  (ifix(float(hdr_year)/4.0)*4 .eq. hdr_year)  mnths(2)=29
cks      hdr_jday = 0
cks      do i=1,hdr_month-1
cks          hdr_jday = hdr_jday + mnths(i)
cks      enddo
cks      hdr_jday = hdr_jday + hdr_day
      call julien( hdr_day, hdr_month, hdr_year, hdr_jday, 1 )

c     -- read away all lines until DAT2, read possibly existing STA2-line
      if  (hdr_debug .gt. 3)  write (*,*) '-- find DAT2'
22    read( iin, '(a)' )  line
         if  (line(1:4) .eq. 'STA2')  then
            read( line,
     &         '(5x,a9,1x,f9.5,1x,f10.5,1x,a12,1x,f5.3,1x,f5.3)' )
     &         hdr_network, hdr_stalat, hdr_stalon, hdr_coosys,
     &         hdr_staelev, hdr_stadepth
            hdr_staelev = hdr_staelev * 1000.0
            hdr_stadepth = hdr_stadepth * 1000.0
            if  (hdr_debug .gt. 3)  write (*,*) '-- found STA2 ',
     &         hdr_network, hdr_stalat, hdr_stalon, hdr_coosys,
     &         hdr_staelev, hdr_stadepth
         endif
      if  (line(1:4) .ne. 'DAT2')  goto 22
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'

c     -- Now read in data according to the format:
      if  (hdr_debug .gt. 2)   write (*,*) '-- reading samples'
      if  (hdr_ifmtname .eq. 'INT')  then
         if  (hdr_debug .gt. 3)  write (*,*) '-- reading INT data'
         read(iin,*) (iy(i),i=1,hdr_nsamp)
30       read(iin,'(a)') line
         if(line(1:4).eq.'CHK2') goto 31
         goto 30
31       read(line(5:),*) ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
c
      if  (hdr_ifmtname(1:2) .eq. 'CM')  then
         read(hdr_ifmtname(3:3),*) icomp 
         if  (hdr_debug .gt. 3)  write (*,*) '-- reading CM', icomp
         j=0
c        -- reading all compressed lines
32       continue
            read(iin,'(a)') line
            if(line(1:4).eq.'CHK2') goto 34
            nchar=trimlen(line)
            do i=1,nchar
               j=j+1
               cbuf(j)=line(i:i)
            enddo
         goto 32
  34     continue
         read(line(5:),*) ichecksum
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
         nchar=j
         numout=c_sigsize   ! on input, give max. size of array iout (=iy)
         if  (hdr_debug .gt. 3)  write (*,*) '-- decompress data'
         if(icomp.eq.6) call DCOMP6(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.7) call DCOMP7(nchar,cbuf,numout,iy,ierror)
         if(icomp.eq.8) call DCOMP8(nchar,cbuf,numout,iy,ierror)
         if(ierror.eq.-1) write(6,*)'Integer*4 array not large enough !'
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
         if(numout.ne.hdr_nsamp)then
            write(6,*)'Error in retrieving correct number of samples !'
            write(6,*)'Expected ',hdr_nsamp,', received ',numout
         endif

c        -- remove first and second differences
         if  (hdr_debug .gt. 3)  write (*,*) '-- remove 2 differences'
         call REMDIF1(iy,hdr_nsamp)
         call REMDIF1(iy,hdr_nsamp)
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif
c
50    continue
      if  (hdr_debug .gt. 3)  write (*,*) '-- check checksums'
      if (hdr_ifmtnum .eq. 1) then
c        -- calculate checksum for GSE1.0 format
         nchecksum=icheck_sum_gse1(iy,hdr_nsamp)
      elseif (hdr_ifmtnum .eq. 2) then
c        -- calculate checksum for GSE2.0 format
         nchecksum=icheck_sum_gse2(iy,hdr_nsamp)
      else
         print *, 'Unknown GSE-Format ',hdr_ifmtnum,'.x'
         stop
      endif
      if(nchecksum.ne.ichecksum)then
         write(6,*)'Error in checksum in the following waveform'
         write(6,'(a)') firstline(1:trimlen(firstline))
         write(6,*)'Read checksum       =',ichecksum
         write(6,*)'Calculated checksum =',nchecksum
         write(6,*)
         ichecksum=nchecksum  ! ... use the correct checksum  !!!
      endif
      if  (hdr_debug .gt. 2)  write (*,*) '-- leaving gsein'
      return
c
 998  print *,' >>>> WARNING: Program dimensions too small for ',
     &    ' the following waveform :'
          print *, line
      goto 1
 999  ierr = 999
      return
      end


c------------------------------------------------------------------------------


      subroutine gseout(iout,cbuf,iy,nchecksum)
c------------------------------------------------------------------------------
c     Input/Output parameters:
c        iout ........ logical unit for output data
c        cbuf ........ character array to store compressed data (see c_bufsize)
c        iy .......... integer array to hold raw waveform data (see c_sigsize)
c        nchecksum ... checksum value for data iy according to hdr_ifmtname
c
c        in common block
c        hdr_ifmtnum . GSE format identifier of input data
c        hdr_nsamp ... number of samples in array iy
c
c        disabled
c        iformat_in
c        nmax
c        format_out .. GSE format identifier for output data (e.g. "CM6")
c        iformat_out . GSE format identifier (ie. =2 for GSE2.0)
c        lin ......... character array to hold header lines
c        ilin ........ number of header lines
c        idiffout .... difference identifier
c------------------------------------------------------------------------------
c
      implicit none

      include 'codeco_common.f'

c     parameters
      integer*4 iout
      character*1 cbuf(1)
      integer*4 iy(1)
      integer*4 nchecksum

c     local variables
c
      integer*4 icomp, i,j, ierror
      integer*4 nchar, ii, ichecksum
      integer*4 trimlen
      integer*4 icheck_sum_gse1,icheck_sum_gse2
      integer*4 n
      real      fsec                ! seconds and milliseconds
      character line*132, fmt*132

c     -- executable code

      if  (hdr_debug .gt. 1)  write (*,*) '-- entering gseout'

      if (hdr_ifmtnum.eq.hdr_ofmtnum) then
          ichecksum=nchecksum
      else
         if (hdr_ofmtnum.eq.2)  then
            if  (hdr_debug .gt. 0)  write (*,*)
     &         '-- writing GSE2.0 output'
c           -- adjust calibration factor to displacement
            if  (hdr_calunit .gt. 0)  then
c              -- divide cal.factor 'hdr_calunit' times by 2*pi/hdr_calper
               hdr_calfac = hdr_calfac / 
     &            (atan(1.0)*8.0/hdr_calper)**hdr_calunit
               hdr_calunit = 0
            endif
c           -- calculate checksum for GSE2.0 format
            ichecksum=icheck_sum_gse2(iy,hdr_nsamp)
         else if  (hdr_ofmtnum .eq. 1)  then
            if  (hdr_debug .gt. 0)  write (*,*)
     &         '-- writing GSE1.0 output'
            ichecksum=icheck_sum_gse1(iy,hdr_nsamp)
            ichecksum=icheck_sum_gse1(iy,hdr_nsamp)   !!! why this ?
         else
            write (*,*) '** gseout: this should not happen'
            write (*,*) '** output format number is ', hdr_ofmtnum
            stop
         endif
      endif

c     -- compute differences if requested
      if  (hdr_debug .gt. 3)  write (*,*) '-- apply differences',
     &   hdr_odiff
      do i=1,hdr_odiff
         call DIF1(iy,hdr_nsamp)
      enddo
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'

c     -- here write out header lines
      if  (hdr_debug .gt. 3)  write (*,*)  '-- write header line(s)'
      if  (hdr_ofmtnum .eq. 1)  then
c        -- first line is straightforward
100      format(a6,i4,i3.3,3(1x,i2.2),1x,i3.3,1x,i8,1x,a6,1x,a8,1x,
     &      a1,a1,1x,f11.7,1x,a6,1x,a4,1x,i1)
         write(iout,100) 'WID1  ', hdr_year, hdr_jday, hdr_hour,
     &      hdr_min, hdr_sec, hdr_msec, hdr_nsamp, hdr_station,
     &      hdr_stadescr, hdr_chan(1:1), hdr_chan(3:3),
     &      hdr_smprate, hdr_instr, hdr_ofmtname, hdr_odiff
c        -- second line's format depends on hdr_calfac
         fmt = '(f9.6,i1,f7.4,1x,4(f9.4,1x),2(f7.2,1x),f6.1,1x,f6.1)'
         n = 6
         if (hdr_calfac .ge. 100.0) n = 9-(log10(hdr_calfac)+3)
         write(fmt(5:5),'(i1)') n
         write(iout,fmt) hdr_calfac, hdr_calunit, hdr_calper,
     &      hdr_stalat, hdr_stalon, hdr_staelev, hdr_stadepth,
     &      hdr_beamaz, hdr_beamslo, hdr_hang
         write( iout, '(a)' )  'DAT1'
      else
         fsec = float(hdr_sec) + float(hdr_msec)/1000.0
200      format(a5,i4,2(1h/,i2.2),1x,2(i2.2,1h:),f6.3,1x,a5,1x,a3,
     &      1x,a4,1x,a3,1x,i8,1x,f11.6,1x,e10.2,1x,f7.3,1x,a6,1x,
     &      f5.1,1x,f4.1)
         write( iout, 200 )  'WID2 ', hdr_year, hdr_month, hdr_day,
     &      hdr_hour, hdr_min, fsec, hdr_station, hdr_chan,
     &      hdr_stadescr, hdr_ofmtname, hdr_nsamp, hdr_smprate,
     &      hdr_calfac, hdr_calper, hdr_instr, hdr_hang, hdr_vang
         fmt = '(a5,a9,1x,f9.5,1x,f10.5,1x,a12,1x,f5.3,1x,f5.3)'
c        -- need to change from f9.5 to f9.4 if hdr_stalat is empty (= -999.0)
         if  (hdr_stalat .le. -100.0)  fmt(14:14) = '4'
         write( iout, fmt )  'STA2 ', hdr_network, hdr_stalat,
     &      hdr_stalon, hdr_coosys, hdr_staelev/1000.0,
     &      hdr_stadepth/1000.0
         write( iout, '(a)' )  'DAT2'
      endif
      if  (hdr_debug .gt. 3)  write (*,*) '-- done'

      if(hdr_ofmtname(1:2).eq.'CM')then
         if (hdr_ofmtnum.eq.1) read(hdr_ofmtname(4:4),*) icomp
         if (hdr_ofmtnum.eq.2) read(hdr_ofmtname(3:3),*) icomp
         if  (hdr_debug .gt. 3)  write (*,*) '-- compress data', icomp
         nchar=c_bufsize ! on input, give max. size of array cbuf
         if(icomp.eq.6) call CMPRS6(hdr_nsamp,iy,nchar,cbuf,ierror)
         if(icomp.eq.7) call CMPRS7(hdr_nsamp,iy,nchar,cbuf,ierror)
         if(icomp.eq.8) call CMPRS8(hdr_nsamp,iy,nchar,cbuf,ierror)
         if  (ierror .eq. -1)  write(*,*)
     &      '** character array not large enough !'
         if  (hdr_debug .gt. 3)  write (*,*) '-- done, found nchar',
     &      nchar
C        TEST FOR MULTIPLE OF 80 CHARACTERS
         if(nchar-((nchar/80)*80).ne.0)then
            write(6,*)  '** not a multiple of 80 characters !'
         endif
         do i=1,nchar/80
            line = ' '
            do j=1,80
               line(j:j)=cbuf(80*(i-1)+j)
            enddo
            if  (hdr_debug .gt. 4) write(*,'(a)') line(1:trimlen(line))
cccc            write(iout,'(a)') line                      ! kradi, 28.11.90
c99 6.6.99/uk  if  (line .ne. ' ') write(iout,'(a)') line(1:trimlen(line))
            if  (line .ne. ' ') write(iout,'(a)') line(1:80)
         enddo
      endif
      if  (hdr_ofmtname(1:3) .eq. 'INT')  then
         if  (hdr_ofmtname(4:4) .eq. 'V' .or. 
     &      hdr_ofmtname(4:4) .eq. ' ')  then
            if  (hdr_debug .gt. 3)  write (*,*)
     &         '-- write uncompressed samples (INT,INTV)', hdr_nsamp
cks            write(iout,*) (iy(i),i=1,hdr_nsamp)
            do  i=1,hdr_nsamp
               write (iout,*) iy(i)
            enddo
         else
             if  (hdr_debug .gt. 3)  write (*,*) '-- write fixed INTx'
             read(hdr_ofmtname(4:4),*) ii
cc             i=(trimlen(line)+ii-1)/ii
             i=(80+ii-1)/ii
             write(fmt,'(''('',i2.2,''i'',i1.1,'')'')') i,ii
             write(iout,fmt) (iy(i),i=1,hdr_nsamp)
         endif
         if  (hdr_debug .gt. 3)  write (*,*) '-- done'
      endif

      if  (hdr_debug .gt. 3)  write (*,*) '-- write checksum'
      if (hdr_ofmtnum.eq.1) then
          line='CHK1'
          write(line(10:24),'(i15)') ichecksum
      endif
      if (hdr_ofmtnum.eq.2) then
          line='CHK2'
          write(line(6:13),'(i8)') ichecksum
      endif
      write(iout,'(a)') line(1:trimlen(line))

      if  (hdr_debug .gt. 1)  write (*,*) '-- leaving gseout'
      return
      end


c -----------------------------------------------------------------------------


      subroutine init_hdrvars

c     Initializes header variables in common block

      include 'codeco_common.f'

c     -- leave hdr_debug untouched
      hdr_year = 0
      hdr_month = 0
      hdr_day = 0
      hdr_jday = 0
      hdr_hour = 0
      hdr_min = 0
      hdr_sec = 0
      hdr_msec = 0
      hdr_nsamp = 0
      hdr_ifmtnum = 0
      hdr_ofmtnum = 0
      hdr_idiff = 0
      hdr_odiff = 0
      hdr_calunit = 0
      hdr_smprate = 0.0
      hdr_calfac = 1.0
      hdr_calper = 1.0
      hdr_stalat = -999.0
      hdr_stalon = -999.0
      hdr_staelev = -999.0
      hdr_stadepth = -999.0
      hdr_beamaz = -1.0
      hdr_beamslo = -1.0
      hdr_hang = -1.0
      hdr_vang = -1.0
      hdr_station = ' '
      hdr_stadescr = ' '
      hdr_chan = ' '
      hdr_instr = ' '
      hdr_network = ' '
      hdr_ifmtname = ' '
      hdr_ofmtname = ' '

      return
      end


c -----------------------------------------------------------------------------
 

c
c    program to convert station coordinates from usgs to seisan format
c    jh august 2006
c
c  upgrade
c
c    nove 16, 06  jh : e and w was reversed
c
      implicit none
      character*180 text,text2
      real lat,lon,depth         ! latitude longitude depth
      integer ilat,ilon
      real dlat,dlon             ! minutes of latitude and longitude
      character*5 stat           ! station code
      character*2 ns,ew          ! N, S E, or W
      character*80 infile        ! input file name 
      integer nstat              ! station counter
      character*4 type           ! input file type
      integer i,j,k,l
c
c
c
      write(6,*)
      write(6,*) 
     *' This program converts the station file from USGS to SEISAN'
      write(6,*)
     *' The file must have the comma format'
      write(6,*)
      write(6,*) 'Input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old')
      open(2,file='stasei.out',status='unknown')
      nstat=0
c
c    determine type
c
      read(1,'(a)') text
      if(text(1:4).eq.'CODE') type='usgs' 
c    
      if(type.eq.'usgs') then
 1       continue
         read(1,'(a)',end=100) text
c
c   reformat string to columns without comma
c
         k=1
         j=1     
         do i=1,60
           if(text(i:i).ne.',') then
              text2(k:k)=text(i:i)
              k=k+1
              j=j+1
           else
              if(j.ne.10) then
                 do l=j,10
                    text2(k:k)=' '
                    k=k+1
                 enddo
              endif
              j=1       ! start of a new field
           endif
         enddo
         write(17,*) text2
c
c   read data
c
         read(text2,'(a5,4x,2f10.4,f8.2)') stat,lat,lon,depth
c         write(6,*) stat
         if(lat.eq.0.0.and.lon.eq.0.0) goto 1
         ns='N'
         if(lat.lt.0.0) ns='S'
         ilat=abs(lat)
         dlat=(abs(lat)-ilat)*60.0
         ew='E'
         if(lon.lt.0.0) ew='W'
         ilon=abs(lon)
         dlon=(abs(lon)-ilon)*60.0
         i=depth
         if(stat(5:5).ne.' ') then
            write(2,'(1x,a5,i2,f5.2,a1,i3,f5.2,a1,i4)')
     *      stat,ilat,dlat,ns,ilon,dlon,ew,i
         else
            write(2,'(2x,a4,i2,f5.2,a1,i3,f5.2,a1,i4)')
     *      stat(1:4),ilat,dlat,ns,ilon,dlon,ew,i
         endif
         nstat=nstat+1
         goto 1
      endif

 100  continue
      write(6,*)' Number of stations', nstat
      write(6,*)' Output file name is stasei.out'
      stop
      end

      program autosig  

c
c input files
c
c   1 - one waveform file
c   2 - s-file and 1 waveform file
c   3 - s-file, multiple waveform files
c

c 
c input data 
c
c   1 - no location, no phase readings  -> find phase arrival
c   2 - location, no phase readings     -> compute phase arrivals, or force 1
c   3 - phase readings                  -> use phase arrivals, or force 1/2 
c

c
c input_mode
c
c   1 - input file is Nordic file, name given through environmental variable
c   2 - S-file given through environmental variable, used by seisnet
c   3 - input is Nordic file
c   4 - continuous data

c
c
c functions
c
c   1 - pick phase based on sta/lta
c   2 - check if spectral level of signal is above noise at its maximum
c   3 - determine type (L,R,D,N) based on spectral levels at different 
c       frequencies
c   4 - determine spectral flat level and corner frequency based on 
c       spectrum of P or S, if distance known to correct for geom spr and Q,
c       using genetic algorithm
c ( 5 - read amplitude for Ml and Mb )
c ( 6 - location )
c

c
c by Lars Ottemoeller, Dec 1999
c
c changes:
c   08.02.2000 lo: use file_ready
c   09.02.2000 lo: if no detrigger use last sample for coda
c   10.02.2000 lo: put event id 'R'
c   23.05.2000 lo: use new wav reading routines
c   23.05.2000 lo: compute spectrum, new routine auto_moment
c   14.02.2001 lo: change in sta_lta_nrec, at BGS
c   15.02.2001 lo: add call to get_seisan_def, at BGS
c   21.02.2001 lo: fix call to spectrum 
c                  taken out mulplt.inc
c   05.03.2001 lo: add routine to determine type of event from spectrum
c   08.03.2001 lo: fixes in sta_lta_nrec and find_coda
c   14.03.2001 lo: add genetic algortihm to determine om and f0 from spectrum
c -----------------------------------------
c   20.03.2001 lo: name of program changed to autosig
c   21.03.2001 lo: changed variable odata to raw_signal
c   23.03.2001 lo: add correction for near surface attenuation using kappa
c   30.03.2001 lo: add get_amp_per, auto amplitude routine
c   20.06.2001 lo: added function to use const Q for long periods
c   03.07.2001 lo: removed call to dtime
c   23.09.2002 lo: add all phase output
c   11.11.2002 lo: fix bug with no output for waveform file input
c   11.11.2002 lo: add arguments
c   13.11.2002 lo: bug fix on input_mode
c   16.06.2003 lo: add reading of continuous data, not yet finished
c   24.05.2005 lo: put in recent changes 
c      07.2008 lo: some changes, compute spec average
c
c

c on Linux routines auto_moment and invert_spectrum cause problems
c

      implicit none

C    Seisan library inserts and routines...
C    ======================================
C
      include 'libsei.inc'                ! Seisan definitions
      include 'seidim.inc'                ! ------------------
      include 'seisan.inc'                ! ------------------
      include 'waveform.inc'              ! ------------------
      include 'autosig.inc'               ! autosig include file
      include 'rea.inc'                   ! rea include file

      external computer_type              ! Get platform type.
      external sei open,                  ! Open file routine.
     &         sei close,                 ! Close file routine.
     &         sei get file               ! Find files in diff dirs
      integer sei clen                    ! Length of string
      integer r_index
      character*1 dchar
      integer  write01,write02,err_unit,! File units,    
     &         read01,read02,code       ! Local condition.
      logical  b_flag                   ! Flag end of file
c --------------------------------------------------------------

      character*80 infile,outfile,autosig_out, ! file names
     &                outf,xfile,autosig_err
      integer*4 idata(max_sample)       ! integer data
      real raw_signal(max_sample),fil_signal(max_sample) 
                                        ! original and filtered data
      integer it                        ! trace counter
      character*80 fheader(max_trace)   ! file headers
      character*1040 theader            ! trace header
      integer c,i,x,z,j,y,ind           ! counters 
      integer coda(max_trace)           ! coda duration
      double precision drate            ! rate as double prec.
      character*80 line,text1,text2     ! some text line
      character*80 sfile                ! name of sfile
      character*80 question             ! text
      character*1 cbyte(max_trace)      ! 2 or 4 byte
      character*5 net_code              ! network code
      character*29 mainhead_text        ! mainheader text
      double precision phase_time(max_phase) ! phase times
      double precision msec,msec2
      character*80 aphases(max_phase)   ! phase array
      real sta,lta,ratio,mincoda,dtrle,fill,filh ! variables from parameter file
                                        ! for individual stations
      integer in                        ! 1 if filenr.lis
      integer filec                     ! file counter
      real      cof(8)                  ! filter coefficients
      real      gain                    ! filter gain
      integer npasses                   ! number of passes, 1 forward, 
                                        ! 2 both ways
      character*80      data(max_data)  ! event arrays
      integer           nstat           ! no of stations for event
c      integer nphase                    ! no of phases for one event
c      integer           nrecord         ! no of records for event
c      integer           nhead           ! no of headers for event
      character*1       exp,evid        ! event ids--------------
      integer id                        ! event id line number
      character*2       fr_type         ! event type based on spectrum
      integer dist_cnt,local_cnt,reg_cnt! counter for type of event
      real om,f0,omi,f0i                ! flat level and corner frequency
      integer nspec                     ! number of spectra
c      real spfmin,spfmax                ! frequnecy range in which signal above noise
      logical clipped                   ! true if signal clipped
      logical lfreeze                   ! true if to freeze lta at trigger
      integer nfiles                    ! number of files
      real duration                     ! signal duration
      integer phase_index               ! index to phase in rea structure
      integer spec_index                ! index to spec phase
      integer jday                      ! julian day
      logical hyp_flag                  ! true if hypocenter known
      real slat,slon,sheight,sdist      ! station coords and distance
      real degtorad                     ! constant to convert degree to radians
      real distdeg,az0,xx(4),yy
      double precision abs_time
      character*1 phase
      character*1 which_phase
      real geo_corr
      integer trace_unit,event_unit,    ! file units
     &   mom_unit,f0_unit,mag_unit,res_unit
      real res_sum
      double precision msdif
      real proc_count,time
      double precision proc_time
      real amp,per
      real mag_sum,mom_sum,mag_save(100)
      character*80 data_save(max_data)
      integer nrecord_save
      logical event_done  
      integer mag_n
      real res_m_a(2)
      double precision time_amp
      real pi
      real max_dist,min_dist
      integer mag_ml_index
      parameter (pi=3.141592654)
      character*12 time1                      ! time strings
      character*14 time2
      integer narg                            ! number of arguments
      character*80 arg(10)                    ! arguments
      logical onlyonce                        ! true if input file given on prompt or
                                              ! from env variable
      real cmin,rsec
      integer year,month,day,doy,hour,min,sec
      character*14 end_time
      logical flag
      character*80 file_name
      character*3 agency
     
c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   get arguments
c
      call get_arguments(narg,arg)


      call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'autosig.trace',  ! Filename.
     &                   trace_unit,       ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      write(trace_unit,*) ' AUTOSIG TRACE FILE '

      call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'autosig.event',  ! Filename.
     &                   event_unit,       ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'moment.comp',    ! Filename.
     &                   mom_unit,         ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'f0.comp',        ! Filename.
     &                   f0_unit,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'mag.comp',       ! Filename.
     &                   mag_unit,         ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      call sei open( unknown$,             ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'res.comp',       ! Filename.
     &                   res_unit,         ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.


c
c get parameters from parameter file
c
      call get_autosig_par(trace_unit)
      call get_seisan_def
      call dir_char(dchar)
      call get_agency(agency)

c
c init variables
c
      infile = ' '
      outfile='autosig.wav.001'
      autosig_out ='autosig.out'
      autosig_err ='autosig.err'
      filec = 0
      npasses = 1
      clipped=.FALSE.
      input_mode = 1             ! default waveform data

      degtorad=0.0174533
      proc_time=0.
      proc_count=0.
      res_sum=0.
      max_dist=-1.
      min_dist=99999.
      in=0
      onlyonce=.false.
      cwav=.false.

c
c overwrite settings if set as arguments
c
      do i=1,narg
        if (arg(i)(1:5).eq.'-spec') then
          if (arg(i+1)(1:2).eq.'on') then
            lautospec=.true. 
          else 
            lautospec=.false.
          endif
        elseif (arg(i)(1:6).eq.'-clear') then
          if (arg(i+1)(1:2).eq.'on') then
            lclear=.true.
          else 
            lclear=.false.
          endif
        elseif (arg(i)(1:6).eq.'-phase') then
          if (arg(i+1)(1:2).eq.'on') then
            lautophase=.true.
          else 
            lautophase=.false.
          endif
        elseif (arg(i)(1:7).eq.'-infile') then
          infile=arg(i+1)(1:seiclen(arg(i+1)))
        elseif (arg(i)(1:5).eq.'-help') then
          write(*,*) 'autosig [-infile <filename> -spec on/off '//
     &               '-phase on/off -clear on/off' 
        endif
      enddo

c
c open error output file
c
        call sei open( unknown$,           ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   autosig_err,      ! Filename.
     &                   err_unit,         ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.


      line=' '   
c
c check if started from other program
c
      call get_message('autosig',line)

40    continue 

c
c in case autosig is started from other program
c
      if (line(1:7).eq.'autosig'.and.line(9:9).ne.' ') then

          call get_env_event(sfile)
c
c read sfile
c
c          call file_ready(sfile)
          call sei open( old$,           ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   sfile,            ! Filename.
     &                   write02,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
          call rea_event_in(write02,.true.,data,code)
          if (code.ne.0) then
            write(*,*) ' error reading file '
            call sei close( close$, write02, code)
            stop
          endif
          call sei close( close$, write02, code)
          read(line(9:79),'(a73)') infile
          input_mode = 2
          onlyonce=.true.
          lwavout= .FALSE.
      elseif (infile.ne.' '.and.in.ne.1) then
        onlyonce=.true.
      else
c
c if autosig not started from other program read input file name
c
        question=' Filename or number, filenr.lis for all, or cont'
        call filename(question,infile)
      endif

      if (infile(1:3).eq.'EOF') STOP
      if(infile(1:10).eq.'filenr.lis') then
c        call file_ready('filenr.lis')
        call sei open( old$,               ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'filenr.lis',     ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
        in=1
      elseif (infile(1:4).eq.'cont') then
        if (n_cont_base.eq.0) then
           write(*,*) ' no continuous database defined in SEISAN.DEF '
           stop
        endif
c
c write out the database names
c
        write(*,*)'Databases are:'
        do i=1,n_cont_base
           write(*,*)'    ',cont_base(i)
        enddo
        write(*,*) ' Start time (yyyymmddhhmmss) '
        read(5,'(a)')  cwav_start_time
        write(*,*) ' End time (yyyymmddhhmmss) '
        read(5,'(a)')  end_time
        write(*,*) ' Time interval in minutes '
        read(5,*) cmin
c
c set interval length
c
        cont_interval=cmin*60.
c
c set end time for continuous data
c
        read(cwav_start_time,'(i4,4i2,f2.0)') year,month,day,
     &    hour,min,rsec
        call timsec(year,month,day,hour,min,rsec,msec)
        msec=msec+cont_interval
        call sectim(msec,year,doy,month,day,hour,min,rsec)
        write(cwav_end_time,'(i4.0,5i2.0)') 
     &    year,month,day,hour,min,int(rsec)
        lwavout=.false.
        lautoamp=.false.
        lautospec=.false.
        lall_phases=.true.
        onlyonce=.true.
        input_mode=4
        cwav=.true.
        call cwav_time_limits(0)
      endif

c
c open ascii output
c
      if (input_mode.ne.2) then
        call sei open( unknown$,           ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   autosig_out,      ! Filename.
     &                   write02,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
       elseif (input_mode.eq.2) then
         call sei open( old$,           ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   sfile,            ! Filename.
     &                   write02,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
      endif

50    continue

c
c if filenr.lis
c
      if(in.eq.1) then
        read(read02,'(7x,a)',end=40) infile
        if(infile(1:4).eq.'    ') stop
        filec=filec+1
        write(outfile(13:15),'(i3)') filec
        do i=13,15
          if (outfile(i:i).eq.' ') outfile(i:i)='0'
        enddo 
      endif
c
c open input file
c
      if (input_mode.ne.4) then
        call wav_init
        wav_filename(1)=' '
        wav_filename(1)=infile
c
c   now read first header for one event
c
        call get_full_wav_name(infile, wav_filename(1))
        write(*,*) ' INPUT FILE : '//
     &      wav_filename(1)(1:seiclen(wav_filename(1)))
        if (lwavout) then
          write(*,*) ' OUTPUT FILE: '//outfile(1:seiclen(outfile))
        endif
        call read_wav_header(1)
      else 
        wav_error_message=' '
      endif
60    continue

      if (cwav) then
        rea_nwav=0
        n_cont_trace=0
      endif

      if (input_mode.eq.3) wav_error_message='MODE 3'
      write(*,*) ' wav_error_message= '//wav_error_message

      if(wav_error_message.ne.' ') then
c
c file could be nordic
c 
        if (input_mode.ne.3) then
c
c open when checking 1st time
c
          call sei open( old$,           ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   infile,           ! Filename.
     &                   read01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
        endif

        nspec=0
        mag_n=0
        mag_sum=0.
        mom_sum=0.
        mag_ml_index=0

        call rea_event_in(read01,.true.,data,code)
        write(*,*) data(1)
c
c save data vector
c
        do i=1,rea_nrecord
          data_save(i)=data(i)
        enddo
        nrecord_save=rea_nrecord

        if ((rea_nrecord.eq.0.or.code.ne.0).and.input_mode.eq.3) then
          call sei close( close$, read01, code)
          goto 9999
        endif
        onlyonce=.true.
        if (rea_nrecord.eq.0.and.in.ne.1) then
          write(6,'(1x,a)') wav_error_message
          goto 9999
        else
          input_mode=3
          write(*,*) ' Nordic input file ... '
c
c read hyp parameters
c

          hyp_flag=.false.
          if (hyp_lat(1).ne.0..or.
     &        hyp_lon(1).ne.0..or.
     &        hyp_depth(1).ne.0.) hyp_flag=.true.

          call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     &       hyp_hour(1),hyp_min(1),hyp_sec(1),abs_time)
c     write(*,*) ' lat/lon/dep ',hyp_lat(1),hyp_lon(1),hyp_depth(1)
          j=0

c
c find index to ml value
c
          do i=1,6
            if (hyp_mag_type(i,1).eq.'L') then
              mag_ml_index=i
            endif
          enddo

c
c get waveform filenames
c
          call wav_init
          nfiles=0
          wav_nfiles=0
          do i=1,rea_nwav 
            xfile=' '
            xfile=rea_wav(i)(2:79)
            xfile=xfile(1:seiclen(xfile))
            call get_full_wav_name(xfile,wav_filename(i))
          enddo
c
c read headers
c
          do i=1,rea_nwav
            call read_wav_header(i)
            if(wav_error_message.ne.' ') then
               write(6,'(1x,a)') wav_error_message
            endif
          enddo
        endif

        if (input_mode.eq.1) then
          if (in.eq.1) goto 50
          goto 9999
        endif

c
c file is waveform file, set content for output file
c
      elseif (input_mode.eq.1) then
        input_mode=1
        hyp_flag=.false.
c        hyp_fix_org(1)=' '
c        hyp_depth_flag(1)=' '
        call rea_hyp_clear(1)
        hyp_lat(1)=0.
        hyp_lon(1)=0.
        hyp_depth(1)=0.
        hyp_year(1)=wav_year(1)
        hyp_month(1)=wav_month(1)
        hyp_day(1)=wav_day(1)
        hyp_hour(1)=wav_hour(1)
        hyp_min(1)=wav_min(1)
        hyp_sec(1)=wav_sec(1)
        rea_nphase=0
        rea_nhyp=1

        rea_nwav=1
        rea_wav(1)='                                        '//
     &       '                                        '
        write(rea_wav(1)(2:),'(a)') infile(1:seiclen(infile))
        rea_wav(1)(80:80)='6'
        call systime(time1,time2) 
        rea_id_line=' ACTION:ASI '//time2//' OP:     '//
     &       'STATUS:               ID:20021001025954     I'
cACTION:REE 02-10-01 10:02 OP:gdf  STATUS:               ID:20021001025954
        write(rea_id_line(61:74),'(i4.4,5i2.2)')
     &     wav_year(1),wav_month(1),wav_day(1),wav_hour(1),wav_min(1),
     &     int(wav_sec(1)) 

      elseif (input_mode.eq.4) then
        call cwav_time_limits(0)
        call cwav_read_bases
        wav_nchan=n_cont_trace

        hyp_flag=.false.
        call rea_hyp_clear(1)
        hyp_lat(1)=0.
        hyp_lon(1)=0.
        hyp_depth(1)=0.
        read(cwav_start_time,'(i4,4i2,f2.0)') hyp_year(1),hyp_month(1),
     &    hyp_day(1),hyp_hour(1),hyp_min(1),hyp_sec(1)
        rea_nphase=0
        rea_nhyp=1

c        rea_nwav=1
c        rea_wav(1)='                                        '//
c     &       '                                        '
c        write(rea_wav(1)(2:),'(a)') infile(1:seiclen(infile))
c        rea_wav(1)(80:80)='6'
        call systime(time1,time2)
        rea_id_line=' ACTION:ASI '//time2//' OP:     '//
     &       'STATUS:               ID:20021001025954     I'
        write(rea_id_line(61:74),'(i4.4,5i2.2)')
     &     wav_year(1),wav_month(1),wav_day(1),wav_hour(1),wav_min(1),
     &     int(wav_sec(1))
      endif

c
c clear out phases if set
c
      if (lclear) then
        rea_nphase=0
      endif

c
c open output files
c 
      if (wav_nchan.ge.100) then
        lwavout= .FALSE.
        write(*,*) ' too many traces to create output file '
      endif

c waveform output
      if (lwavout) then
            chr_f_form$ = 'unformatted'
c            call file_ready(outfile)
            call sei open( unknown$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
      endif


c
c number of output traces is twice the input traces, since trigger trace is added
c
      wav_out_nchan = wav_nchan * 2
      write(*,*) ' number of traces: ',wav_nchan

c
c read trace header(s) to make new file header
c
      dist_cnt=0
      local_cnt=0
      reg_cnt=0
      if (input_mode.eq.1) nspec = 0

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c start loop over all traces
c
      do i=1,wav_nchan

c
c original trace is c
c
c
c sta/lta ratio signal is index x
c
        if (lwavout) then      ! double traces if cretae output file
          c=i*2 -1
          x=c+1
        else
          c=i
          x=i
        endif
        it=c
c
c set output variables
c
        wav_out_stat(c)=wav_stat(i)
        wav_out_stat(x)=wav_stat(i)
        wav_out_comp(c)=wav_comp(i)
        wav_out_comp(x)=wav_comp(i)

        wav_out_year(c)=wav_year(i)
        wav_out_year(x)=wav_year(i)
        wav_out_month(c)=wav_month(i)
        wav_out_month(x)=wav_month(i)
        wav_out_day(c)=wav_day(i)
        wav_out_day(x)=wav_day(i)
        wav_out_hour(c) = wav_hour(i)
        wav_out_hour(x) = wav_hour(i)
        wav_out_min(c) = wav_min(i)
        wav_out_min(x) = wav_min(i)
        wav_out_sec(c)= wav_sec(i)
        wav_out_sec(x)= wav_sec(i)
        wav_out_nsamp(c)= wav_nsamp(i)
        wav_out_nsamp(x)= wav_nsamp(i)
        wav_out_rate(c)=wav_rate(i)
        wav_out_rate(x)=wav_rate(i)

        cbyte(x)='4'
        cbyte(c)='4'

c
c set waveform names if continuous data
c
        if (cwav) then
          do j=1,cwav_nseg(i)
            ind=0
            do z=seiclen(cwav_filename(i,j)),1,-1
              if (cwav_filename(i,j)(z:z).eq.dchar.and.
     &            ind.eq.0) ind=z
            enddo
            file_name=cwav_filename(i,j)
     &          (ind+1:seiclen(cwav_filename(i,j)))
            flag=.true.
            do c=1,rea_nwav
              if (rea_wav(c)(2:seiclen(file_name)+1).eq.file_name) 
     &            flag=.false.
            enddo  
            if (flag) then
              rea_nwav=rea_nwav+1
              rea_wav(rea_nwav)=
     &          '                                        '//
     &          '                                       6'
              write(rea_wav(rea_nwav)(2:seiclen(file_name)+1),'(a)') 
     &           file_name(1:seiclen(file_name))
            endif
          enddo
        endif
      enddo
  
c
c   make seisan headers
c
      if (lwavout) then
        call sheads(wav_out_year,wav_out_month,wav_out_day,
     *    wav_out_hour,wav_out_min,wav_out_sec,wav_out_nchan,c,
     *    net_code,mainhead_text,wav_out_stat,wav_out_comp,
     *    wav_out_nsamp,wav_out_rate,cbyte,
     *    outf,fheader,theader)
      endif
c
c write header
c
      if (lwavout) then
        x=int(((2*wav_nchan)-28)/3)
        if (x.lt.0) x=0
        do z=1,12+x
             write(write01) fheader(z)
        enddo
      endif

c
c delete files
c
      call systemc('rm -f *.obs',11)
      event_done=.false.

      do i=1,wav_nchan
c
c read response into common block
c
        wav_current_chan(1)=i

        if (lwavout) then      ! double traces if cretae output file
          c=i*2 -1
          x=c+1
        else
          c=i
          x=i
        endif

        write(*,*) 'trace: ',i,' ' // wav_stat(i) // wav_comp(i)
        it=c
c
c get parameters for station c
c
        call get_station(wav_out_stat(c),wav_out_comp(c),sta,lta,ratio,
     &      mincoda,dtrle,fill,filh,code)
 
        if (code.eq.1) then
c
c set flag that some station in parameter file
c
          event_done=.true.
          
c
c check if P or S
c
          phase=which_phase(phase_mode)
c
c use P for Q waves if set and P waves used
c
          if (phase.eq.'P') then
             par_q0=par_p_q0
             par_qalpha=par_p_qalpha
          else
             par_q0=par_s_q0
             par_qalpha=par_s_qalpha
          endif
c
c check for phase time
c
          phase_index=0
          if (phase_mode.eq.3..or.phase_mode.eq.4..or.
     &      phase_mode.eq.5.) then
            do j=1,rea_nphase
              if (rea_stat(j).eq.wav_stat(i).and.
     &            rea_phase(j)(1:4).ne.'SPEC') then
                if (rea_phase(j)(1:1).eq.phase(1:1).or.
c     &            rea_phase(j)(1:1).eq.phase(1:1).or.
     &            phase_mode.eq.5.) then
                  phase_index=j
                  phase=rea_phase(j)(1:1)
                  call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     &             rea_hour(j),rea_min(j),rea_sec(j),rea_abs_time(j))
                endif
              endif
            enddo
c
c check that phase there if required
c
          elseif ((phase_mode.eq.1..or.phase_mode.eq.2.).and.
     &      phase_infile.eq.1.) then
            do j=1,rea_nphase
              if (rea_stat(j).eq.wav_stat(i).and.
     &            rea_phase(j)(1:4).ne.'SPEC') then
                  phase_index=j
              endif
            enddo
            if (phase_index.eq.0.) code=0
          endif

c
c check if spec already done and keep index
c
          spec_index=0
          do j=1,rea_nphase
            if (rea_stat(j).eq.wav_stat(i).and.
     &          rea_phase(j)(1:4).eq.'SPEC') then
              if (spec_index.eq.0) spec_index=j
            endif
          enddo

c
c read trace, signal stored in signal1
c
          call wav_read_channel(i)
          call read_resp
          if (wav_nsamp(i).gt.max_sample) code=0
        endif

        if (code.eq.1) then
          do z=1,wav_nsamp(i)
            idata(z)=int(signal1(z))
c
c save raw signal
c
            raw_signal(z)=signal1(z)
          enddo
        endif
c
c   make trace header
c
        if (lwavout) then
          call sheads(wav_out_year,wav_out_month,
     *      wav_out_day,wav_out_hour,
     *      wav_out_min,wav_out_sec,wav_out_nchan,c,
     *      net_code,mainhead_text,wav_out_stat,wav_out_comp,
     *      wav_out_nsamp,wav_out_rate,cbyte,
     *      outf,fheader,theader)

          write(write01) theader
          write(write01) (idata(z),z=1,wav_out_nsamp(c))
          call sheads(wav_out_year,wav_out_month,
     *      wav_out_day,wav_out_hour,
     *      wav_out_min,wav_out_sec,wav_out_nchan,x,
     *      net_code,mainhead_text,wav_out_stat,wav_out_comp,
     *      wav_out_nsamp,wav_out_rate,cbyte,
     *      outf,fheader,theader)

           write(write01) theader
        endif


        if (code.eq.1) then     ! station defined in parameter file

c
c compute distance if hypocenter given
c
          if (hyp_flag) then
            call stat_loc(wav_stat(i),data(1)(21:21),slat,slon,sheight)
            if (slat.eq.0..and.slon.eq.0..and.sheight.eq.0.) then
              write(*,*) ' location unknown for station: ' //
     &           wav_stat(i)
              sdist=0.
            else
              if (hyp_lat(1).ne.-999.) then
                xx(1)=slat*degtorad
                xx(2)=slon*degtorad
                xx(3)=hyp_lat(1)*degtorad
                xx(4)=hyp_lon(1)*degtorad
                call delaz(xx(1),xx(2),
     &             sdist,distdeg,az0,xx(3),xx(4)) 
                write(*,*) ' dist for station ' // wav_stat(i)
     &             // ' in km: ',  sdist
              else
                sdist=0.1
              endif
            endif
          endif

c
c calculations depending on which processes are activated in parameter file
c
          drate=wav_out_rate(c)        ! store rate as double precision

c
c remove linear trend or mean
c
          if (lrtr) then
            write(*,*) ' removing linear trend'
            call rtr(signal1,wav_out_nsamp(c),drate)
          else
            if (lrmean) then
              call rmean(signal1,wav_out_nsamp(c))
            endif  
          endif

c
c check if signal is clipped
c
          call check_clipped(signal1,wav_out_nsamp(c),clipped)
          if (clipped) write(*,*) ' *** signal clipped *** '

c
c  filter if not lower filter is -1.
c
          if (par_fill(c).ne.-1.) then

            write(*,*) 'filtering: ',fill,filh

c-- calc. filt. cof.
            call bndpas(fill,filh,1000.0/wav_out_rate(c),
     *              cof,gain)
c-- and filter
            call filter(signal1,wav_out_nsamp(c),cof,gain,npasses)
          endif

          do z=1,wav_out_nsamp(c)
            fil_signal(z)=signal1(z)
          enddo
c
c normalize signal to max of 1000
c
          call normalize_signal(signal1,wav_out_nsamp(c),1000.)

c
c compute characteristic function, y**2 + k * y'**2
          if (lchfu) then
             call char_fu(signal1,wav_out_nsamp(c),kchfu)
          endif
c
c compute sta/lta, ratio signal in signal1
c
 
          if (.not.lrec) then
            lfreeze=.true.
            call sta_lta_nrec(signal1,wav_out_nsamp(c),
     *        drate,sta,lta,lstasq,ratio,lfreeze)
          else
            call sta_lta_rec(signal1,wav_out_nsamp(c),
     *        drate,sta,lta,lstasq)
          endif
c
c find phases, ratio given in signal1, spectral analysis to check if signal done
c on raw_signal
c
          duration=0.
          if (lautophase.or.
     &        phase_mode.eq.0..or.      
     &     (phase_mode.ge.3..and.phase_index.eq.0.and.lautophase)) then 

           lautoamp=.false.

            call find_phases(i,signal1,raw_signal,wav_out_nsamp(c),
     &           drate,sta,ratio,dtrle,wav_abs_time(i),
     &           aphases,phase_time,dist_f_sel,fr_type,
     &           spike_test)

c
c loop over all phases
c
            y=1
            if (lall_phases) y=max_phase
            do z=1,y
c
c find coda on filtered signal
c
              call find_coda(fil_signal,wav_out_nsamp(c),drate,
     &           wav_abs_time(i),sta,
     &           dtrle,phase_time(z),coda(z),lautocodasq)
c
c write phases to array, signal has to either above noise spectrum or longer
c than minimum coda duration
c
c            if (coda(1).gt.mincoda.or.fr_type(1:1).ne.'N') then
       
              if (coda(z).ge.mincoda.and.phase_time(z).ne.0.) then
                if (aphases(z)(22:22).ne.' ') then
c
c new phase
c
                  lautoamp=.true.
                  rea_nphase=rea_nphase+1
                  phase_index=rea_nphase

                  call rea_phase_clear(phase_index)
                  rea_auto(phase_index)='autosig'
                  rea_stat(phase_index)=wav_out_stat(c)
                  rea_comp(phase_index)=wav_out_comp(c)
                  rea_co(phase_index)(1:2)=wav_out_comp(c)(1:1)//
     &               wav_out_comp(c)(4:4) 
                  rea_phase(phase_index)='P'
                  phase(1:1)='P'
                  rea_onset(phase_index)='E'
                  rea_weight_out(phase_index)='  '
                  rea_weight_in(phase_index)=' '
                  rea_polarity(phase_index)=' '
                  call sectim(phase_time(z),rea_year(phase_index),
     &     jday,rea_month(phase_index),rea_day(phase_index),
     &     rea_hour(phase_index),rea_min(phase_index),
     &     rea_sec(phase_index))
                  if (coda(z).gt.0..and.coda(z).lt.10000) then
                    rea_coda(phase_index)=coda(z)
                  endif
                endif
              endif
            enddo
c
c set duration either for P or S, as given in parameter file
c
            if (sdist.ne.0..and.spec_dur_choice.eq.1.) then
              call gvel_to_time(sdist,phase_time(1),
     &          msec,duration)
            else
              duration=spectrum_length_p
            endif
          elseif (phase_mode.ge.3..and.
     &      phase_index.ne.0) then
c
c if phase to be taken from file
c
            phase_time(1) = rea_abs_time(phase_index)
            if (spec_dur_choice.eq.1.) then
              call gvel_to_time(sdist,rea_abs_time(phase_index),
     &          msec,duration)
            else
              if (which_phase(phase_mode).eq.'P') then 
                phase='P'
                duration=spectrum_length_p
              elseif (which_phase(phase_mode).eq.'S') then 
                phase='S'
                duration=spectrum_length_s
              endif
            endif
          elseif ((phase_mode.eq.1..or.phase_mode.eq.2.)
c     &       .and.phase_time(1).ne.0.) then   ! changed lot 20/03/2003
     &       ) then
c 
c set group velocity window
c
            rea_nphase=rea_nphase+1
            phase_index=rea_nphase
            phase=which_phase(phase_mode)
            call rea_phase_clear(phase_index)
            call gvel_to_time(sdist,abs_time,
     &          phase_time(1),duration)
                  rea_auto(phase_index)='autosig'
                  rea_stat(phase_index)=wav_out_stat(c)
                  rea_comp(phase_index)=wav_out_comp(c)
                  rea_co(phase_index)(1:2)=wav_out_comp(c)(1:1)//
     &               wav_out_comp(c)(4:4)
                  rea_phase(phase_index)='        '
                  rea_phase(phase_index)(1:1)=which_phase(phase_mode)
                  rea_onset(phase_index)='E'
                  rea_weight_out(phase_index)='  '
                  rea_weight_in(phase_index)=' '
c xxx
                  rea_coda(phase_index)=int(duration)
                  rea_dist(phase_index)=sdist
                  rea_polarity(phase_index)=' '
                  call sectim(phase_time(1),rea_year(phase_index),
     &     jday,rea_month(phase_index),rea_day(phase_index),
     &     rea_hour(phase_index),rea_min(phase_index),
     &     rea_sec(phase_index))
          endif
c       write(*,*) ' phase_mode, phase_time ',phase_mode,phase_time(1)

c
c check event type from frequency content
c          
c          write(*,*) ' xxx duration: ',duration 
          if (.not.clipped.and.duration.ne.0.) then
            call freq_event_type(raw_signal,i,dist_f_sel,
     &        phase_time(1),
     &        spectrum_pre_length,duration,fr_type)
            if (fr_type(1:1).eq.'D') then
              dist_cnt= dist_cnt+1
            elseif (fr_type(1:1).eq.'R'.or.fr_type(1:1).eq.'N') then
              reg_cnt = reg_cnt + 1
            else
              local_cnt= local_cnt+1
            endif
          endif

          if (.not.clipped.and.duration.ne.0.) then
c
c determine auto amplitude
c
            if (lautoamp.and.phase(1:1).eq.'S') then

              call get_amp_per(i,'WA',raw_signal,phase_time(1),
     &          duration,amp,per,time_amp)
c              write(*,*) ' xxx ',amp,per,time_amp
            endif
c
c add amp and per to common block, add to old phase or make new phase
c
            if (amp.ne.0..and.per.ne.0.) then
              if ((phase_index.eq.0.or.
     &          phase_mode.eq.1..or.phase_mode.eq.2.).and.
     &          time_amp.ne.0.) then  ! if new phase
                rea_nphase=rea_nphase+1
                phase_index=rea_nphase
                call rea_phase_clear(phase_index)
                rea_stat(phase_index)=wav_stat(i)
                rea_comp(phase_index)=wav_comp(i)
                rea_onset(phase_index)='E'
                call sectim(time_amp,rea_year(phase_index),
     &     jday,rea_month(phase_index),rea_day(phase_index),
     &     rea_hour(phase_index),rea_min(phase_index),
     &     rea_sec(phase_index))
              endif
              rea_auto(phase_index)='autosig'
              rea_amp(phase_index)=amp
              rea_per(phase_index)=per
            endif

c          write(*,*) ' xxx autospec ',lautospec
c
c determine spectral parameters, flat level and corner frequency
c
            if (lautospec) then
c
c set values from s-file to initial values, used to compare residual
c
              if (spec_index.gt.0) then
                omi=rea_omega0(spec_index)
                f0i=rea_cornerf(spec_index)
              else
                omi=0. 
                f0i=0.
              endif
              write(*,*) ' trying to match spectrum ... '
              call get_om_f0(raw_signal,i,spfmin,wav_rate(i)/2.5,
     &          phase_time(1),spectrum_pre_length,
     &          duration,om,f0,omi,f0i,sdist,hyp_depth(1),
     &          abs_time,phase,par_q0,par_qalpha,qcorner,par_kappa,
     &          par_vp,par_vs,par_density,ga_pop_size,ga_n_generations,
     &          ngrid_f,ngrid_om,grid_nloop,
     &          res_m_a,search_method,norm_fit,msdif,ffixl,ffixh)
            endif

            res_sum=res_sum+res_m_a(2)
            proc_time= proc_time+msdif 
            proc_count=proc_count+1.
         write(res_unit,*) proc_count,proc_time,res_m_a(2)

c
c write results to common block
c
            if (om.ne.0..and.f0.ne.0.) then
              rea_nphase=rea_nphase+1
              phase_index=rea_nphase
              rea_stat(phase_index)=wav_stat(i)
              rea_comp(phase_index)=wav_comp(i)
              rea_auto(phase_index)='autosig'
              rea_phase(phase_index)= '     '
              rea_phase(phase_index)(1:4)='SPEC'
              rea_phase(phase_index)(5:5)=phase
c              rea_phase(phase_index)(5:5)=rea_phase(phase_index)(1:1)
c              rea_coda(phase_index)=int(duration)
              rea_omega0(phase_index)=om
              rea_cornerf(phase_index)=f0
              rea_vp(phase_index) = par_vp
              rea_vs(phase_index) = par_vs
              rea_q0(phase_index)=par_q0
              rea_qalpha(phase_index)=par_qalpha
              rea_kappa(phase_index)=par_kappa
              rea_density(phase_index)=par_density
              rea_swin(phase_index)=duration
c
c source dimension
c
              rea_radius(phase_index)=.35*par_vs/f0
              call spec_dist(phase,sdist,hyp_depth(1),geo_corr)
              rea_geo_dist(phase_index)=1./geo_corr
              if (sdist.gt.max_dist) max_dist=sdist
              if (sdist.lt.min_dist) min_dist=sdist
c
c log moment
c
              rea_moment(phase_index)=4.*pi*
     &          rea_density(phase_index)*10.**rea_omega0(phase_index)
     &          * .833   ! kk
     &          * rea_geo_dist(phase_index)
     &          * (1000.**5)   ! to convert units of density and distance
     &          / (1.e9)       ! to convert to Nm
              if (rea_phase(phase_index)(5:5).eq.'P') then
                rea_moment(phase_index)=rea_moment(phase_index)*
     &            rea_vp(phase_index)**3
              else
                rea_moment(phase_index)=rea_moment(phase_index)*
     &            rea_vs(phase_index)**3
              endif
              rea_moment(phase_index)=log10(rea_moment(phase_index))
              rea_mw(phase_index)=2./3.*rea_moment(phase_index)
     &          -6.06
c
c xxx remove if loop later
c
       if (rea_moment(spec_index).ne.0.) then
              mag_n=mag_n+1
              mag_sum=mag_sum+rea_mw(phase_index)
              mag_save(mag_n)=rea_mw(phase_index)
              mom_sum=mom_sum+rea_moment(phase_index)
c        write(*,*) mag_n,mag_sum,rea_mw(phase_index)
       endif
c
c stress drop
c
              rea_sdrop(phase_index)=(.44*10.**rea_moment(phase_index))
     &           / (1.e14*rea_radius(phase_index)**3)

c
c write out comparison
c
       if (rea_moment(spec_index).ne.0.) then
         write(mom_unit,*) rea_moment(spec_index),
     &      rea_moment(phase_index)
         write(f0_unit,*) rea_cornerf(spec_index),
     &      rea_cornerf(phase_index)
c         write(res_unit,*) res_m_a(1),res_m_a(2)

c         write(333,*) 
c     &       10.**rea_moment(phase_index),
c     &     1.23*10.**15*(3.14*rea_radius(phase_index)**2)**1.5
c         write(334,*) 
c     &       10.**rea_moment(spec_index),
c     &     1.23*10.**15*(3.14*rea_radius(spec_index)**2)**1.5
       endif



c              call rea_spec_out(phase_index,text1,text2)
c              text1(6:6)='A'
c              text2(6:6)='A'
c              if (input_mode.ne.2) then
c                call add_spec_to_sfile(text1,text2,
c     &            data,nhead,nrecord,spec_overwrite)
c              endif
            endif
          endif

        else
          write(err_unit,*) ' station/comp ',wav_out_stat(c),' ',
     &        wav_out_comp(c), 
     &          ' not defined in autosig.par'
        endif


c
c write out data
c
        if (lwavout) then
          do z=1,wav_out_nsamp(c)
            idata(z)=int(signal1(z))
          enddo
          write(write01) (idata(z),z=1,wav_out_nsamp(c))
        endif

      enddo    ! end of loop over all traces
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c      if (rea_av_mw.gt.0..and.mag_n.gt.0) then
      if (mag_n.gt.0) then
c
c get variance
c
        do i=1,mag_n
          yy=yy+(mag_save(i)-mag_sum/float(mag_n))**2
        enddo
        yy=(1./float(mag_n-1)*yy)**.5

        write(mag_unit,*) rea_av_mw,mag_sum/float(mag_n),yy
        write(65,*) mom_sum/float(mag_n)
c        write(523,*) mag_n
        if (mag_ml_index.ne.0) then
           write(66,*) hyp_mag(mag_ml_index,1),mag_sum/float(mag_n)
        endif
c      else
c           write(66,*) '0.'
      endif

      if (dist_cnt.gt.local_cnt.and.dist_cnt.gt.reg_cnt) then
         fr_type='D ' 
         write(*,*) ' *************** Distant *********** '
      elseif (local_cnt.gt.dist_cnt.and.local_cnt.gt.reg_cnt) then
         fr_type='L ' 
         write(*,*) ' *************** Local ************* '
      else
         fr_type='R '
         write(*,*) ' *************** Regional ********** '
      endif
      if (input_mode.ne.2) then
c        data(1)(22:22)=fr_type(1:1)
         hyp_dist_id(1)=fr_type(1:1)
      endif

c
c compute averages and standard deviation and store in data
c
      call rea_event_out(0,.true.,data,code)  ! update array
      call update_spec(data,rea_nrecord,rea_nhead,agency,.false.)

c
c write out nordic file
c
c      call rea_event_out(write02,.true.,data,code)
       do i=1,rea_nrecord
         write(write02,'(a)') data(i)
       enddo
c
c write out event if at least 1 channel processed
c
      if (event_done) then
        do i=1,nrecord_save
          write(event_unit,'(a80)') data_save(i)
        enddo
      endif
c
c call gmt script
c
      if (input_mode.ne.2.and.input_mode.ne.4) then
        call systemc('spec.exp',8)
      endif

      if (lwavout) then
        call sei close( close$, write01, code)
      endif
      write(*,*) ' min distance = ',min_dist
      write(*,*) ' max distance = ',max_dist
      if (input_mode.eq.3) then
        goto 60
      endif
      if (input_mode.eq.4) then
c
c calculate new start time
c
        read(cwav_start_time,'(i4,4i2,f2.0)') year,month,day,hour,
     &       min,rsec
        call timsec(year,month,day,hour,min,rsec,msec) 
        msec=msec+(cont_interval*.9)
        call sectim(msec,year,jday,month,day,hour,min,rsec)
        write(cwav_start_time,'(i4.4,4i2.2,i2.2)') 
     &     year,month,day,hour,min,int(sec)
        write(*,*) ' new start time: ',cwav_start_time

        read(end_time,'(i4,4i2,f2.0)') year,month,day,hour,
     &       min,sec
        call timsec(year,month,day,hour,min,rsec,msec2) 
        if (msec.ge.msec2) goto 9999
        goto 60
      endif
      if (in.eq.1) then
        goto 50
      endif

9999  continue
      write(*,*) ' average processing time, residual ',
     &    proc_time/proc_count,
     &    res_sum/proc_count
      if (.not.onlyonce) then
        input_mode=1
        goto 40
      endif

c
c close files
c
      if (in.eq.1) call sei close( close$, read02, code)
      call sei close( close$, err_unit, code)
      call sei close( close$, trace_unit, code)
      call sei close( close$, event_unit, code)
      call sei close( close$, mag_unit, code)
      call sei close( close$, f0_unit, code)
      call sei close( close$, mom_unit, code)
      call sei close( close$, res_unit, code)
      call sei close( close$, write02, code)


      stop
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c SUBROUTINES
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      subroutine rmean(idata,nlen)
c
c simple routine to remove the mean
c
c input/output: idata - real array with nlen samples
c

      implicit none
C    Seisan library inserts and routines...
C    ======================================
C
      include 'libsei.inc'                ! Open file definitions
      include 'seidim.inc'

      real idata(*)                       ! data
      integer i                           ! counters
      integer nlen                        ! number of samples
      real dc                             ! average or DC level

c
c get dc
c
      dc=0.
      do i=1,nlen
        dc=dc+idata(i)
      enddo
      dc=dc/nlen

c
c remove dc
c
      do i=1,nlen
        idata(i)=idata(i)-int(dc)
      enddo

      return
      end
        



      subroutine integrate(idata,nlen,rate)
c
c integration based on trapezoid rule
c
c by Lars Ottemoeller, Dec 1999
c
c input/output: idata - real data array with nlen samples
c               rate  - sample rate in Hz

      implicit none

C    Seisan library inserts and routines...
C    ======================================
C
      include 'libsei.inc'                ! Open file definitions
      include 'seidim.inc'

      real idata(max_sample),raw_signal(max_sample)
      integer   nlen
      real sum,ri
      double precision rate
      integer i

      sum = 0
      do i=1,nlen

        ri=i
        if(i-2.gt.0) then
          sum = sum + idata(i-1)
        endif
        raw_signal(i) = (ri-1)/2/rate * (idata(1)+idata(i)+2*sum)
      enddo

      do i=1,max_sample
        idata(i)=raw_signal(i)
      enddo

      return
      end
      

      subroutine rtr(data,nlen,rate)
c
c remove linear lsq trend
c
c by Lars Ottemoeller, Dec 1999
c
c input/output: data - real data array with nlen samples
c               rate - sample rate in Hz
c
      implicit none
      include 'seidim.inc'
      real data(*),x(max_sample) ! x and y data
      integer nlen,i                      ! number of samples and counters
      real a,b,corr,rms                   ! lsqlin output
      double precision rate               ! rate

c
c get x coords
c
      do i=1,max_sample
        x(i)=i/rate
      enddo

      call lsqlin(nlen,x,data,a,b,corr,rms)

      write(*,*) 'correction applied: y=',b,'*x+',a
c
c remove trend
c
      do i=1,max_sample
        data(i)=data(i)-b*x(i)-a
      enddo
  
      return
      end


      subroutine differentiate(idata,nlen,rate)
c
c differentiate
c
c by Lars Ottemoeller, Dec 19999
c
      implicit none

      include 'seidim.inc'
      real idata(max_sample),raw_signal(max_sample)
      double precision rate
      integer i,nlen

      do i=2,nlen-1
        raw_signal(i)=(idata(i+1)-idata(i-1))/2*rate
      enddo
      idata(1)=0
      idata(nlen)=0
      do i=2,nlen-1
        idata(i)=raw_signal(i)
      enddo
      
      return
      end


      subroutine char_fu(data,nlen,k)
c
c calculate characteristic function as suggested by Rex Allen,
c output data are y^2 + k*(y')^2, k is given in the parameter file
c
c input/output: data - real data array with nlen samples
c               k    - real number in formula above
c
      implicit none
      include 'seidim.inc'
      real data(*),raw_signal(max_sample)   ! data
      integer nlen,i                            ! number of samples and counter
      real k                                    ! real number in formula above

c
c calculate characteristic function
c
      do i=2,nlen-1
        raw_signal(i)=data(i)*data(i)+k*(data(i+1)-data(i-1))*
     &         (data(i+1)-data(i-1))
      enddo
c
c copy output into data
c
      do i=2,nlen-1
        data(i)=raw_signal(i)
      enddo
      data(1)=0
      data(nlen)=0

      return
      end


      subroutine sta_lta_nrec(data,nlen,rate,lsta,llta,lsq,ratio,
     &     lfreeze)
c
c computation of squared sta/lta nonrecursive, first the start sta and lta 
c levels are determined from the beginning of the trace, the sta and lta 
c windows are not overlapping, reference ...
c
c input: data - real input data with nlen samples
c        nlen - number of samples in trace
c        rate - sample rate in Hz
c        lsta - length of sta window in seconds
c        llta - length of lta window in seconds
c        lsq  - true if squares, false if abs
c        ratio - trigger ratio
c        lfreeze - true if to freeze lta when sta/lta over ratio
c
      implicit none
      include 'seidim.inc'
      real data(*)
      double precision raw_signal(max_sample)   ! data
      integer nlen,i                            ! number of samples and counter
      double precision rate                     ! sample rate
      real lsta,llta                            ! length of sta and lta in secs
      integer nsta,nlta                         ! number of samples for sta and
                                                ! lta
      double precision sta,lta                  ! sta and lta level
      logical lsq                               ! square or abs sta/lta
      integer nstart                            ! number of samples for initial lta
      integer ind
      logical lfreeze                           ! freeze lta if true and trigger
      real ratio                                ! sta/lta required for trigger
       

c
c determine number of samples in lta and sta
c
      nsta=int(lsta*rate)
      nlta=int(llta*rate)
      nstart=nsta * 2

      sta=0
      do i=1,nstart
        if (lsq) then
          sta=sta+data(i)*data(i)
        else
          sta=sta+abs(data(i))
        endif
      enddo
      sta=sta/float(nstart)
      
      lta=0
      do i=1,nstart-nsta
        if (lsq) then
           lta=lta+data(i)*data(i)
        else 
           lta=lta+abs(data(i))
        endif
      enddo
      lta=lta/float(nstart-nsta)

c      do i=nsta+nlta+1,nlen
      do i=nstart+1,nlen

c
c get sta and lta
c
        ind = i-nsta-1-nlta
c        if (ind.le.0) ind = i-nsta-1-nstart
c        if (ind.le.0) ind = 1
        if (lsq) then
          sta=sta+(data(i)*data(i)-data(i-nsta)*data(i-nsta))/nsta
          if ((sta/lta.le.ratio.or..not.lfreeze).and.
     &      ind.gt.0) then
            lta=lta+(data(i-nsta-1)*(data(i-nsta-1))-
     &      data(ind)*data(ind))/nlta
          else
            ! keep it on pre trigger level
          endif
        else
          sta=sta+(abs(data(i))-abs(data(i-nsta)))/nsta
          if ((sta/lta.le.ratio.or..not.lfreeze).and.
     &        ind.gt.0) then
            lta=lta+(abs(data(i-nsta-1))-
c     &       abs(data(i-nsta-nlta-1)))/nlta
     &       abs(data(ind)))/nlta
          else
            ! keep it on pre trigger level
          endif
        endif

c
c sta/lta ratio
c
        if (lta.eq.0.) then
          raw_signal(i) = 0
        else
          raw_signal(i) = sta/lta
c          write(115,*) i,data(i),sta/lta,sta,lta,nsta,nlta
        endif
      enddo

c
c first values are set to 0
c
      do i=1,1+nstart
        data(i)=0
      enddo
c
c write output into data
c
c      do i=nsta+nlta+1,nlen
      do i=1+nstart,nlen
        data(i)=raw_signal(i)
      enddo

      return
      end


      subroutine sta_lta_rec(data,nlen,rate,lsta,llta,lsq)
c
c sta/lta recursive, does not seem to work well, ok now jh
c
c substantially modified, do not require short lta, put in missing
c abs on data and add squared values, initialize over 10 times sta
c time window
c jh dec 2000
c
      implicit none
      include 'seidim.inc'
      real data(*),raw_signal(max_sample)
      logical lsq
      integer nlen,i
      double precision rate
      real lsta,llta
      integer nsta,nlta
      real sta,lta,x,y

      nsta=int(lsta*rate)
      nlta=int(llta*rate)

      sta=0
      do i=1,10*nsta
         if(lsq) then
            sta=sta+data(i)*data(i)
         else
            sta=sta+abs(data(i))
         endif
      enddo
      sta=sta/float(10*nsta)
      lta=sta

      x=nsta
      y=nlta
      do i=nsta*10+1,nlen
         if(lsq) then
            sta=sta+(data(i)*data(i)-sta)/x   ! add lsq, jh dec 2000
         else
            sta=sta+(abs(data(i))-sta)/x   ! add abs, jh dec 2000
         endif
         lta=lta+(sta-lta)/y

         if (lta.eq.0) then
           raw_signal(i) = 0
         else
           raw_signal(i) = sta/lta
         endif

      enddo

      do i=1,nsta*10
        data(i)=0
      enddo
      do i=nsta*10+1,nlen
        data(i)=raw_signal(i)
      enddo

      return
      end


      subroutine sta_lta_rec_old(data,nlen,rate,lsta,llta)
c
c sta/lta nonrecursive, does not seem to work well
c
      implicit none
      include 'seidim.inc'
      real data(*),raw_signal(max_sample)
      integer nlen,i
      double precision rate
      real lsta,llta
      integer nsta,nlta
      real sta,lta,x,y

      nsta=int(lsta*rate)
      nlta=int(llta*rate)

      sta=0
      do i=nlta+1,nlta+nsta
        sta=sta+data(i)
      enddo
      sta=sta/nsta

      lta=0
      do i=1,nlta
        lta=lta+data(i)
      enddo
      lta=lta/nlta

      x=nsta
      y=nlta
      do i=nsta+nlta+1,nlen

        sta=(1-1/x)*sta+1/x*data(i)
        lta=(1-1/y)*lta+1/y*data(i-nsta-1)

        if (lta.eq.0) then
           raw_signal(i) = 0
        else
          raw_signal(i) = sta/lta
        endif

      enddo

      do i=1,nsta+nlta
        data(i)=0
      enddo
      do i=nsta+nlta+1,nlen
        data(i)=raw_signal(i)
      enddo

      return
      end

      
      subroutine find_phases(current,data,raw_signal,nlen,rate,lsta,
     &  ratio,dtrle,start,phases,phase_time,f_sel,fr_type,spike_test)
c
c routine to find phases, which are given by trace value (sta/lta) above 
c the ratio, phases are written to array phases, start form sample after 
c lsta from the trace start, check that signal spectral amplitude is at least 2
c the noise 
c
c input: 
c        current - current index to waveform block
c        data - array of nlen samples, char function
c        raw_signal - original data
c        rate - sample rate in Hz
c        lsta - length of sta window
c        ratio - trigger level
c        dtrle - detrigger level
c        start - array of trace start in seconds
c output:
c        phases - array of phases in Nordic format
c        phase_time - time of phases in seconds
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'    ! Seisan includes
      include 'waveform.inc'  ! ---------------
      real data(*),ratio,lsta,raw_signal(*),dtrle
      integer nlen,i,c,j,nsta,current,ind
      character*80 phases(max_phase)
      double precision phase_time(max_phase)
      double precision rate,drate,start,time
      integer year,month,jday,day,hour,min
      real sec,x,yy
      real fmin
      real f_sel(2)
      character*2 fr_type,fr_type_save
      logical flag,spike_test,spike_flag,spiketest,lresp

      fr_type_save = '0'
      lresp=.true.

      if (wav_resp_status.eq.'9') then
        write(*,*) ' no response for: ' //wav_stat(current)//' '//
     &       wav_comp(current)
        lresp=.false.
c        return
      endif
      drate=rate

      do i=1,max_phase
        phases(i)(1:40) ='                                        '
        phases(i)(41:80)='                                        '
      enddo
  
      nsta=int(lsta*drate)
      c=0
      flag=.false.         ! true if signal above trigger
      phase_time(1)=-1
      do i=1,nlen 
        x=float(i)
        if (data(i).ge.ratio.and.c.lt.max_phase.and..not.flag)then
          c=c+1
          time=x/drate+start
cccc          time=x/drate+start - lsta   ! use start of sta window, lot 04/03/03
          call sectim(time,year,jday,month,day,hour,min,sec)
c
c check if spike
c
          spike_flag=.false.
          if (spike_test) then
            ind=i
            spike_flag=spiketest(raw_signal,ind,nlen,rate)
          endif
c
c check if signal spectrum above noise (by factor 1.6)
c
          fr_type= ' '
c          write(*,'(2i2,1x,f5.2)') hour,min,sec
          yy=lsta*2.
          if (lresp) then
            call freq_event_type(raw_signal,current,f_sel,
     &        time,2.,yy,fr_type)
          else
            fr_type(1:1)='R' ! in case no response, assume detection is not noise or spike
          endif
          if (fr_type(1:1).ne.'N'.and..not.spike_flag) then
            flag=.true.
            phase_time(c)=time
            write(phases(c)(19:28),'(2i2,1x,f5.2)') hour,min,sec
c
c save fr_type for first phase only
c
            if (fr_type_save.eq.'0') fr_type_save=fr_type
          endif
c
c make sure no new trigger within nsta
c
          do j=i+1,nsta
            data(j)=0
          enddo
        elseif (flag.and.data(i).le.dtrle) then
          flag=.false.
        endif
      enddo
      fr_type=fr_type_save

      return
      end
        
      
      subroutine get_autosig_par(t)
c
c read definition file and store variables in common clock
c
      implicit none
      include 'libsei.inc' 
      include 'seidim.inc'
      include 'autosig.inc'
      include 'rea.inc'

      character*80 def_file         ! file names
      integer in                    ! file unit
      integer code                  ! return code from opening def file
      integer i                     ! counter
      character*80 line             ! text line
      real var                      ! value of variables
      integer t                     ! unit of trace file

c
c check for file end open
c

      def_file = 'autosig.par'

      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   in,              ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   def_file )       ! For this filename.

      if(code.ne.e_ok$) then
        write(*,*) ' definition file does not exist: autosig.par'
        stop   
      endif

      write(t,*) ' '
      write(t,*) ' settings from file: ' // def_file
      write(t,*) ' '
c
c init values
c
      lrmean=.FALSE.
      lrtr  =.FALSE.
      lchfu =.FALSE.
      kchfu =3.
      lrec  =.FALSE.
      lwavout = .FALSE.
      lstasq=.FALSE.
      lautocodasq=.FALSE.
      lautospec=.FALSE.
      lautophase=.FALSE.
      lautoamp=.FALSE.
      lclear=.FALSE.
      phase_mode=0.
      phase_infile=1.
      input_mode=0.
      spectrum_length_p=5.
      spectrum_length_s=10.
      spectrum_pre_length=1.
      spfmin=.01
      spfmax=20.
      par_vs=3.6
      par_vp=6.2
      par_q0=0.
      par_p_q0=0.
      par_s_q0=0.
      par_qalpha=0.
      par_p_qalpha=0.
      par_s_qalpha=0.
      par_kappa=0.
      qcorner=0.
      par_density=2.8
      spec_overwrite=.false.
      phase_overwrite=.false.
      ga_pop_size=50
      ga_n_generations=150
      gvel_p(1)=6.5
      gvel_p(2)=8.0
      gvel_s(1)=3.0
      gvel_s(2)=3.7
      spec_dur_choice=0.
      dist_f_sel(1)=1.
      dist_f_sel(2)=10.
      spike_test=.false.
      search_method=2.
      grid_nloop=3
      ngrid_f=100
      ngrid_om=100
      lall_phases=.false.
      ffixl=0.
      ffixh=0.
      i=0

1010  continue

c
c read text line from file, check for code and set variables
c
      read(in,'(a)',end=1090,err=1080) line

      if (line(1:11).eq.'REMOVE MEAN') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lrmean=.TRUE.
          write(t,*) ' REMOVE MEAN = TRUE'
        endif
      elseif (line(1:12).eq.'REMOVE TREND') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lrtr= .TRUE.
          write(t,*) ' REMOVE TREND = TRUE'
        endif
      elseif (line(1:10).eq.'SPIKE TEST') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          spike_test= .TRUE.
          write(t,*) ' SPIKE TEST = TRUE'
        endif
      elseif (line(1:4).eq.'NORM') then
        read(line(41:50),'(f10.1)') norm_fit
      elseif (line(1:16).eq.'SEARCH ALGORITHM') then
        read(line(41:50),'(f10.1)') search_method
        if (search_method.eq.1.) then
          write(t,*) ' SEARCH ALGORITHM = GENETIC '
        elseif (search_method.eq.2.) then
          write(t,*) ' SEARCH ALGORITHM = GRID '
        endif
      elseif (line(1:10).eq.'CHAR FUNCT') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lchfu=.TRUE.
          write(t,*) ' CHAR FUNCT = TRUE'
        endif
      elseif (line(1:15).eq.'WRITE ALL PHASE') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lall_phases=.TRUE.
          write(t,*) ' WRITE ALL PHASE = TRUE'
        endif
      elseif (line(1:15).eq.'K IN CHAR FUNCT') then
        read(line(41:50),'(f10.1)') kchfu
        write(t,*) ' K IN CHAR FUNCT = ',kchfu
      elseif (line(1:15).eq.'STALTA NREC/REC') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lrec=.FALSE.
          write(t,*) ' STALTA NREC = TRUE'
        else
          lrec=.TRUE.
          write(t,*) ' STALTA REC = TRUE'
        endif
      elseif (line(1:17).eq.'STALTA SQUARE/ABS') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lstasq=.TRUE.
          write(t,*) ' STALTA SQUARE/ABS = TRUE'
        else
          lstasq=.FALSE.
          write(t,*) ' STALTA SQUARE/ABS = FALSE'
        endif
      elseif (line(1:19).eq.'AUTOCODA SQUARE/ABS') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lautocodasq=.TRUE.
          write(t,*) ' AUTOCODA SQUARE/ABS = TRUE'
        else
          lautocodasq=.FALSE.
          write(t,*) ' AUTOCODA SQUARE/ABS = FALSE'
        endif
      elseif (line(1:14).eq.'CREATE WAVEOUT') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lwavout=.TRUE.
          write(t,*) ' CREATE WAVEFORM OUT = TRUE'
        endif
      elseif (line(1:10).eq.'GRID NLOOP') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          grid_nloop=int(var)
          write(t,*) ' GRID NLOOP = ',grid_nloop   
        endif
      elseif (line(1:15).eq.'NGRID FREQUENCY') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          ngrid_f=int(var)
          write(t,*) ' NGRID FREQUENCY = ',ngrid_f   
        endif
      elseif (line(1:18).eq.'NGRID SPECTRAL AMP') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          ngrid_om=int(var)
          write(t,*) ' NGRID SPECTRAL AMP = ',ngrid_om  
        endif
      elseif (line(1:18).eq.'GA POPULATION SIZE') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          ga_pop_size=int(var)
          write(t,*) ' GA POPULATION SIZE = ',ga_pop_size
        endif
      elseif (line(1:14).eq.'GA GENERATIONS') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          ga_n_generations=int(var)
          write(t,*) ' GA GENERATIONS = ',ga_n_generations
        endif
      elseif (line(1:18).eq.'GROUP VEL WINDOW P') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          gvel_p(1)=var
        endif
        read(line(51:60),'(f10.1)') var
        if (var.ne.0.) then
          gvel_p(2)=var
        endif
        write(t,*) ' GROUP VEL WINDOW P ',gvel_p 
      elseif (line(1:18).eq.'GROUP VEL WINDOW S') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          gvel_s(1)=var
        endif
        read(line(51:60),'(f10.1)') var
        if (var.ne.0.) then
          gvel_s(2)=var
        endif
        write(t,*) ' GROUP VEL WINDOW S ',gvel_s 
      elseif (line(1:16).eq.'DIST FREQ SELECT') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          dist_f_sel(1)=var
        endif
        read(line(51:60),'(f10.1)') var
        if (var.ne.0.) then
          dist_f_sel(2)=var
        endif
        write(t,*) ' DIST FREQ SELECT = ',dist_f_sel
      elseif (line(1:17).eq.'FIXED FREQUENCIES') then
        read(line(41:50),'(f10.1)') var
        if (var.ne.0.) then
          ffixl=var
        endif
        read(line(51:60),'(f10.1)') var
        if (var.ne.0.) then
          ffixh=var
        endif
        write(t,*) ' FIXED FREQUENCIES = ',ffixl,ffixh
      elseif (line(1:13).eq.'AUTO SPECTRUM') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lautospec=.TRUE.
          write(t,*) ' AUTO SPECTRUM = TRUE'
        endif
      elseif (line(1:14).eq.'AUTO AMPLITUDE') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lautoamp=.TRUE.
          write(t,*) ' AUTO AMPLITUDE = TRUE'
        endif
      elseif (line(1:10).eq.'AUTO PHASE') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          lautophase=.TRUE.
          write(t,*) ' AUTO PHASE = TRUE'
        endif
      elseif (line(1:14).eq.'SPEC OVERWRITE') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          spec_overwrite=.TRUE.
          write(t,*) ' SPEC OVERWRITE = TRUE'
        endif
      elseif (line(1:15).eq.'PHASE OVERWRITE') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) then
          phase_overwrite=.TRUE.
          write(t,*) ' PHASE OVERWRITE = TRUE'
        endif
      elseif (line(1:12).eq.'SELECT PHASE') then
        read(line(41:50),'(f10.1)') phase_mode
        write(t,*) ' SELECT PHASE 1 = ',phase_mode
        if (phase_mode.eq.1.or.phase_mode.eq.2) then
          read(line(51:60),'(f10.1)') phase_infile
        endif
        write(t,*) ' SELECT PHASE 2 = ',phase_infile
      elseif (line(1:17).eq.'SPECTRUM P LENGTH') then
        read(line(41:50),'(f10.1)') spectrum_length_p
        write(t,*) ' SPECTRUM P LENGTH = ',spectrum_length_p
      elseif (line(1:17).eq.'SPECTRUM S LENGTH') then
        read(line(41:50),'(f10.1)') spectrum_length_s
        write(t,*) ' SPECTRUM S LENGTH = ',spectrum_length_s
      elseif (line(1:19).eq.'SPECTRUM PRE LENGTH') then
        read(line(41:50),'(f10.1)') spectrum_pre_length
        write(t,*) ' SPECTRUM PRE LENGTH = ',spectrum_pre_length
      elseif (line(1:14).eq.'SEPCTRUM F LOW') then
        read(line(41:50),'(f10.1)') spfmin
        write(t,*) ' SEPCTRUM F LOW = ',spfmin
      elseif (line(1:15).eq.'SEPCTRUM F HIGH') then
        read(line(41:50),'(f10.1)') spfmax
        write(t,*) ' SEPCTRUM F HIGH = ',spfmax
      elseif (line(1:19).eq.'SPECDURATION CHOICE') then
        read(line(41:50),'(f10.1)') spec_dur_choice
        write(t,*) ' SPECDURATION CHOICE = ',spec_dur_choice
      elseif (line(1:13).eq.'SPECTRAL S-Q0') then
        read(line(41:50),'(f10.1)') par_s_q0
        write(t,*) ' SPECTRAL S-Q0 = ',par_s_q0
      elseif (line(1:13).eq.'SPECTRAL P-Q0') then
        read(line(41:50),'(f10.1)') par_p_q0
        write(t,*) ' SPECTRAL P-Q0 = ',par_p_q0
      elseif (line(1:14).eq.'SPECTRAL KAPPA') then
        read(line(41:50),'(f10.1)') par_kappa
        write(t,*) ' KAPPA = ',par_kappa
      elseif (line(1:16).eq.'SPECTRAL QCORNER') then
        read(line(41:50),'(f10.1)') qcorner   
        write(t,*) ' Q CORNER = ',qcorner
      elseif (line(1:17).eq.'SPECTRAL P-QALPHA') then
        read(line(41:50),'(f10.1)') par_p_qalpha
        write(t,*) ' SPECTRAL P-QALPHA = ',par_p_qalpha
      elseif (line(1:17).eq.'SPECTRAL S-QALPHA') then
        read(line(41:50),'(f10.1)') par_s_qalpha
        write(t,*) ' SPECTRAL S-QALPHA = ',par_s_qalpha
      elseif (line(1:19).eq.'SPECTRAL P-VELOCITY') then
        read(line(41:50),'(f10.1)') par_vp
        write(t,*) ' SPECTRAL P-VELOCITY = ',par_vp
      elseif (line(1:19).eq.'SPECTRAL S-VELOCITY') then
        read(line(41:50),'(f10.1)') par_vs
        write(t,*) ' SPECTRAL S-VELOCITY = ',par_vs
      elseif (line(1:16).eq.'SPECTRAL DENSITY') then
        if (line(41:50).ne.'          ') then
          read(line(41:50),'(f10.1)') par_density
        endif
        write(t,*) ' SPECTRAL DENSITY = ',par_density

c
c if station
c
      elseif (line(1:7).eq.'STATION') then
        i=i+1
cTATION MOL   S  Z    3.0   20.0   50.0   10.0    5.0  5.0 10.0
        read(line(9:63),'(a5,1x,a4,5(1x,f6.1),2(1x,f4.1))',
     &    err=1070)
     &    par_stat(i),par_comp(i),par_sta(i),par_lta(i),
     &    par_ratio(i),par_mincoda(i),par_dtrle(i),par_fill(i),
     &    par_filh(i)
        write(t,*) ' STATION ' // par_stat(i),' ',par_comp(i)

      endif
     
      goto 1010
1070  continue
      write(*,*) 'error in line : ',line(1:62)
      goto 1010

1080  continue
      write(*,*) ' Error in autosig.par file'

1090  continue

      par_nstat=i
      write(t,*) ' number of stations in autosig.par: ',par_nstat
      call sei close( close$, in, code )

      return
      end 


      subroutine get_station(sname,cname,sta,lta,ratio,
     &      mincoda,dtrle,fill,filh,code)
c
c get individual station/component parameters from array
c
c input:  sname  - station name
c         cname  - component name
c
c output: sta    - length of sta window
c         lta    - length of lta window
c         ratio  - trigger ratio
c         mincoda - minimum coda
c         dtrle   - detrigger level for reading autocoda
c         fill    - lower filter limit for autocoda
c         filh    - upper filter limit for autocoda
c         code    - 1 if parameters for station found in array
c

      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      include 'autosig.inc'
      include 'rea.inc'
      character*(*) sname
      character*(*) cname
      real sta,lta,ratio,mincoda,dtrle,fill,filh
      integer code,i
      logical flag

      code = 0
      flag = .FALSE.

      do i=1,par_nstat
        if (.NOT.flag.and.sname.eq.par_stat(i).and.
     &                    cname.eq.par_comp(i)) then
          flag = .TRUE.
          code = 1
          sta=par_sta(i)
          lta=par_lta(i)
          ratio=par_ratio(i)
          mincoda=par_mincoda(i)
          dtrle=par_dtrle(i)
          fill=par_fill(i)
          filh=par_filh(i)
        endif
      enddo

      return
      end
        
      subroutine find_coda(data,nlen,rate,start,lsta,dtrle,ptime,coda,
     &       lsq)
c
c routine to find signal duration (coda) in seismic trace, data are 
c assumed to be filtered, start from p time, lta level is calculated from
c signal (noise) before the p time, the ratio is computed from the squared
c sta divided by the lta, coda is set when detrigger level found if value 
c below dtrle
c

      implicit none

      include 'seidim.inc'

      real data(max_sample),raw_signal(max_sample)

      integer nlen
      double precision rate
      integer coda
      double precision start,ptime
      integer c                                   ! counter
      integer p_sample
      real dtrle
      logical flag
      integer last
      real lta,sta,lsta
      integer nsta
      real rnsta
      logical lsq
 
      coda = -1
      last = 0
      flag=.FALSE.

      rnsta=lsta*rate
      nsta=int(rnsta)

      if (ptime.eq.-1) return

c
c calculate sample of P-phase
c
      p_sample= int((ptime-start) * rate)
      if (p_sample.le.150) return

c
c get noise level
c
      lta=0
      do c=1,p_sample-nsta
        if (lsq) then
          lta = lta + data(c) * data(c)
        else
          lta = lta + abs(data(c))
        endif
      enddo

      lta= lta / (p_sample-nsta)

c
c get start sta
c
      sta=0
      do c=p_sample+1,p_sample+nsta
        if (lsq) then
          sta=sta+data(c)*data(c)
        else
          sta=sta+ abs(data(c))
        endif
      enddo
      sta = sta / nsta

      do c=p_sample+nsta+1,nlen
        if (lsq) then
          sta=sta+(data(c)*data(c)-data(c-nsta)*data(c-nsta))
     *          /rnsta
        else
          sta=sta+(abs(data(c))-abs(data(c-nsta)))/rnsta
        endif
        raw_signal(c)=sta/lta

        if (.not.flag.and.sta/lta.lt.dtrle) then
           flag = .TRUE.
           last = c
        endif
      enddo   

      if (.not.flag.and.sta/lta.gt.dtrle) then
        flag = .TRUE.
        last = nlen
      endif

      c=last-p_sample+1
      if (flag) coda=int(c/rate)

c      do c=1,p_sample+nsta
c        data(c)=lta
c      enddo
c      do c=p_sample+nsta+1,nlen
c        data(c)=raw_signal(c)
c      enddo

      return
      end

      subroutine extract_signal(yy,nsamp,start_time,rate,
     &    time,pre,post,sig,cnt)
c
c extract part of signal in time window time-pre -> time+post 
c
      implicit none
      real yy(*)         ! input signal
      real sig(*)        ! output signal
      integer nsamp
      double precision time,start_time
      real rate
      real pre,post
      integer i,cnt

      cnt=0
      do i=1,nsamp
        if (start_time+i/rate.le.time+post
     &    .and.start_time+i/rate.gt.time-pre)
     &       then
          cnt=cnt+1
          sig(cnt)=yy(i)
        endif
      enddo
      call rmean(sig,cnt)
      return
      end

      character*(*) function which_phase(phase_mode)
      implicit none
      character*1 xx
      real phase_mode
      xx='P'
      if (phase_mode.eq.2..or.phase_mode.eq.4.) then
        xx='S'
      endif
      which_phase=xx
      end

      subroutine get_amp_per(current,type,yy,start,duration,
     &    amp,per,time_amp)
c
c determine auto amplitude
c
      implicit none
      include 'libsei.inc'    ! Seisan includes
      include 'seidim.inc'    ! ---------------
      include 'seisan.inc'    ! ---------------
      include 'waveform.inc'  ! ---------------
      real yy(*),sig(max_sample)
      character*(*) type
      complex y_com(max_sample)
      real y1,y2
      integer i1,i2
      double precision start,time_amp
      real duration,amp,per
      real f(4)
      integer cnt
      integer current

      amp=0.
      per=0.
      if (wav_resp_status.eq.'9') then
        write(*,*) ' no response for: ' //wav_stat(current)//' '//
     &       wav_comp(current)
        return
      endif
c
c  calculate corrected trace
c
      if (type(1:2).eq.'WA') then   ! Wood Anderson
c        f(1)=.8
        f(1)=.5
        f(2)=20.
        f(3)=8.
        f(4)=8.
  
      else
        return
      endif
c
c extract signal
c
      call extract_signal(yy,wav_nsamp(current),wav_abs_time(current),
     &    wav_rate(current),start,1.,duration,sig,cnt)

c
c convert signal to displacement
c
      call remove_resp(sig,y_com,cnt,wav_rate(current),1,
     *  f(1),f(2),int(f(3)),int(f(4))) 
c
c   calculate maximum amplitude
c
      call auto_amp(sig,cnt,wav_rate(current),
     &     1.0,10.0,3,y1,y2,i1,i2)

      if(i1.eq.0) return    ! no amplitude read

c
c   reading ok, calculate amp and period and absolute start time
c
      amp=abs(y2-y1)/2.0
      per=2.0*abs(i2-i1)/wav_rate(current)
      time_amp=start+i1/wav_rate(current)

      return
      end

      subroutine get_om_f0(yy,current,a,b,time,
     &  pre,post,om,f0,omi,f0i,dist,depth,orig_time,
     &  phase,q0,qalpha,qcorner,kappa,vp,vs,density,
     &  pop_size,generations,
     &  ngrid_f,ngrid_om,grid_nloop,
     &  res_m_a,search_method,norm,
     &  msdif,ffixl,ffixh)
c
c automatically find spectral parameters om and f0 by using genetic algorithm,
c the process is done in xx steps: 
c
c   1) extract signal and noise time series of given start time and
c      duration, and get spectra using spec_values
c   2) find lowest frequency at which noise is half the max between signal
c      and noise
c   3) find initial om and f0, not used at the moment
c   4) call ga_om_f0 which is the genetic algorithm
c
c Lars Ottemoeller, March 2001
c
c input: yy - data vector
c        current - index of carrent waveform channel
c        a and b - lower and higher frequency limits
c        time - phase arrival, absolute time in seconds
c        pre - pre time in seconds
c        post - post time in seconds
c        dist - epicentral distance
c        depth - epicenter distance
c        orig_time - origin time in seconds
c        phase - P or S
c        q0,qalpha,kappa,vp,vs,density - parameters needed to correct for Q
c        pop_size - size of population in genetic algorithm
c        generations - number of generations to be done
c        search_method - 1=GA, 2=GRID
c        norm
c        ffixl,ffixh - fixed frequency range
c
c outout: fmin,fmax
c         om - log spectral displacement flat level
c         f0 - corner frequency
c         omi,f0i - inital values of om and f0, as input assumed to be manual
c
      implicit none
      include 'libsei.inc'    ! Seisan includes
      include 'seidim.inc'    ! ---------------
      include 'seisan.inc'    ! ---------------
      include 'waveform.inc'  ! ---------------
c      include 'autosig.inc'   ! ---------------
c      include 'rea.inc'       ! ---------------
      integer current         ! current index to wav structure
      real yy(*)              ! data vector
      real a,b                ! min and max frequencies
      real om,f0,omi,f0i
      real omi_save,f0i_save
      real f_low,f_high       ! low and high limit for spectrum
      integer maxl            ! dimension of spectral levels to be determined
      parameter (maxl=100)
      real level_signal(maxl),level_noise(maxl)  ! spectral levels for signal and noise
      real farray(maxl)       ! frequency array
      real max                ! max spec level
      real norm
      real ffixl,ffixh
      complex y_com(max_sample) ! complex spectrum
      real log_spec(max_sample)  ! log10 of amplitude spectrum of signal
      real y_full(max_sample) ! log10 of amplitude spectrum of signal
      real ff(max_sample)     ! frequncy array
      integer nff             ! number of elements in ff
      real sig(max_sample)    ! temp signal vector
      real search_method      ! 1=ga, 2=grid
      integer i,j,cnt,c       ! counters
      integer nsmooth         ! number of times for smooth
      double precision time   ! travel time
      double precision orig_time ! origin time
      real pre,post           ! pre and posrt time interval in seconds
      real xx                ! some value
      integer ind,min_ind,max_ind
      integer ipow
      real dist,depth
      real trtime   
      character*1 phase
      real q0,qalpha,kappa,vp,vs,density,qcorner
      real geom_corr
      integer pop_size,generations
      integer ngrid_f,ngrid_om,grid_nloop
      integer seiclen
      character*80 outfile
      real res,res_m_a(*)
      integer year,month,day,doy,hour,min
      real sec
      real pi
      parameter (pi=3.141592654)
      real eval_q
      double precision msdif
c      real             SC1, SC2
      integer          YR1,MN1,DA1,HR1,MI1,ISC1
      integer          YR2,MN2,DA2,HR2,MI2,ISC2
      character*12 time1
      character*14 time2
c
c set initial values
c
      nsmooth = 0         ! no smoothing
      f0 = 0.
      om = 0.
c
c manual readings can be passed through f0i and omi
c
      f0i_save=f0i
      omi_save=omi
      f0i=0.
      omi=0.
      trtime=time-orig_time
      call sectim(orig_time,year,doy,month,day,hour,min,sec)

      if (wav_resp_status.eq.'9') then
        write(*,*) ' no response for: ' //wav_stat(current)//' '//
     &       wav_comp(current)
        return
      endif

      if (time.eq.-1) return
      if (dist.eq.0.) return
c
c init values
c
      f_low=0.001                  ! these are the lower and upper limit
      f_high=wav_rate(current)/2.  !    used in the computation of the spectra
c
c set up frequency array, use log equidistant spacing
c
      farray(1)=a
      farray(maxl)=b
      do i=2,maxl-1
        farray(i)=log10(farray(1))+
     &    (log10(farray(maxl))-log10(farray(1)))/(maxl-1)*(i-1)
        farray(i)=10**farray(i)
c         farray(i)=farray(1)+float(i)*(b-a)/(maxl-1)
      enddo
 
c
c signal
c
      call extract_signal(yy,wav_nsamp(current),wav_abs_time(current),
     &    wav_rate(current),time,pre,post,sig,cnt)
c
c write out signal
c
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.wave'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      do i=1,cnt
        write(27,*) dist/(trtime+i/wav_rate(current)),sig(i)
      enddo
      close(27)

      call spec_value(current,sig,cnt,nsmooth,
     &    f_low,f_high,1,farray,maxl,0,level_signal,y_com,ipow)
c
c save full signal spectrum
c
      c = 0
      do i = 2,((ipow/2) + 1)
        c = c + 1
        ff(c) = (i-1)*wav_rate(current)/ipow
        y_full(c) = (1/wav_rate(current)**2)*
     &     y_com(i)*conjg(y_com(i))
        y_full(c) = sqrt (y_full(c)) 

        xx=1.
        if (q0.gt.0.) then
          xx=xx*
     &      exp(-pi*ff(c)*trtime /
     &      eval_q(q0,ff(c),qalpha,qcorner))
c         write(*,*) ff(c),eval_q(q0,ff(c),qalpha,qcorner),qcorner
c (q0*ff(c)**qalpha))
        endif
        if (kappa.ne.0.) then
          xx=xx*exp(-pi*kappa*ff(c))
        endif
        y_full(c) = log10(y_full(c)/xx)

      enddo
      nff=c

c
c noise
c

c
c set noise window, after wav_abs_time
c
      xx=post+pre
      if (wav_abs_time(current)+xx.ge.time) then
        xx=time-pre-wav_abs_time(current) 
      endif
      call extract_signal(yy,wav_nsamp(current),wav_abs_time(current),
     &    wav_rate(current),wav_abs_time(current),0.,xx,sig,cnt)
      call spec_value(current,sig,cnt,nsmooth,
     &    f_low,f_high,1,farray,maxl,0,level_noise,y_com,ipow)

c
c get geometrical spreading distance
c
c      call spec_dist(phase,dist,depth,geom_corr)     ! not used 1 June, 2001 lo

      do i=1,maxl
        xx=1.
        if (q0.gt.0.) then
c correct for Q

c xxx change ???
c          if (farray(i).lt.1.) then
c            xx=xx*exp(-pi*farray(i)*trtime/q0)
c          else
            xx=xx*exp(-pi*farray(i)*trtime/
     &         eval_q(q0,farray(i),qalpha,qcorner))
c q0*farray(i)**qalpha))
c          endif          
        endif
        if (kappa.ne.0.) then
c correct for kappa, near surface attenuation
          xx=xx*exp(-pi*kappa*farray(i))
        endif

        level_signal(i)=level_signal(i)/xx
c        level_noise(i)=level_noise(i)   ???? /xx

c
c take log10 and put into log_spec
c
        log_spec(i)=log10(level_signal(i))
      enddo

c
c write out amp spectrum
c
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.full'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      do i=1,nff
        write(27,*) ff(i),y_full(i)
c        write(27,*) ff(i),y_full(i)+10.
      enddo
      close(27)

c write out date
c
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.date'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      write(27,'(i4,2(i2),1x,3(i2))') year,month,day,hour,min,int(sec)
      write(27,'(i5)') int(dist)
      close(27)

c
c write out noise spectrum
c
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.noise'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      do i=1,maxl
        write(27,*) farray(i),log10(level_noise(i))
      enddo
      close(27)

c
c find max difference between signal and noise, and return if signal is not
c more than twice the noise at the maximum
c
      max = 0.
      do i=1,maxl
        xx=log10(level_signal(i))-log10(level_noise(i))
        if (xx.gt.max) max = xx
      enddo
      if (max.le..4) then
        write(*,*) ' *************** Noise ************* max ',max
        return
      endif
c
c find frequency with minimum spec level
c
      xx=99.
      ind=0
      do i=1,maxl
c      do i=min_ind,maxl
        if (log10(level_signal(i)).lt.xx) then
          ind=i
          xx=log10(level_signal(i))
        endif
      enddo
      if (ind.eq.0) then
        write(*,*) ' not finding spectral minimum '
        return
      endif
      max_ind=ind
c
c find lowest frequency at which signal is half the max dif of signal and noise,
c after at least once the diff between the noise and signal has been less than
c half the max
c
      ind = 0
c      ind = -1
      cnt = 0
      do i=1,maxl
        xx=log10(level_signal(i))-log10(level_noise(i))-max/2.
c        if (xx.lt.0..and.ind.eq.-1) ind = 0
        if (xx.gt.0..and.ind.eq.0) then
          ind = i
          cnt=cnt+1
        elseif (xx.gt.0..and.ind.ne.0) then
          cnt=cnt+1
        endif
      enddo
c
c reset if signal close to noise
c
c change lot 05/2006
        if (log10(level_signal(ind))-log10(level_noise(ind)).lt..3.and.
     &    ind.lt.max_ind) then
          ind=0
        endif
      if (ind.le.0.or.cnt.lt.5) then
        write(*,*) ' difference between signal and noise does ' //
     &      'not allow to find frequency window'
        return
      endif
c
c check at what smaller frequency, the level is lower than at ind
c added lo, June 2, 2001, due to not using low f with DECP data set
c
      min_ind=ind
      ind=0
      do i=1,min_ind-1
        if (log10(level_signal(i)).lt.log10(level_signal(min_ind)).and.
     &    ind.eq.0) then
          ind=i
        endif
      enddo
      if (ind.ne.0) min_ind=ind

c
c case of fixed frequency interval
c
      if (ffixl.ne.0..and.ffixh.ne.0.) then
        max_ind=0
        min_ind=0
        do i=1,maxl
          if (farray(i).ge.ffixl.and.min_ind.eq.0) min_ind=i 
        enddo
        do i=maxl,1,-1
          if (farray(i).le.ffixh.and.max_ind.eq.0) max_ind=i 
        enddo
          write(*,*) farray(min_ind),farray(max_ind)
      endif

      om = log_spec(min_ind)

c
c if max_ind smaller than min_ind
c
      if (min_ind.gt.max_ind) max_ind=maxl
c
c check that f window large enough
c
c changed .1 to .3, lot 070702
c      if (log10(farray(max_ind))-log10(farray(min_ind)).lt..1) then
      if (log10(farray(max_ind))-log10(farray(min_ind)).lt..3) then
        write(*,*) ' frequency window too small ',farray(min_ind),
     &    farray(max_ind),log10(farray(max_ind))-log10(farray(min_ind))
        return
      endif
c
c reduce frequency window to 3 log units, added 07/07/2002
c
      ind=0
      if (log10(farray(max_ind))-log10(farray(min_ind)).gt.3.) then
        do i=min_ind+1,max_ind
          if (log10(farray(i))-log10(farray(min_ind)).gt.3) then
            if (ind.eq.0) then
              ind=i
              write(*,*) ' new fmax: ',farray(ind)
            endif
          endif
        enddo
        if (ind.ne.0) max_ind=ind
      endif


c
c check that average residual between signal and noise is large in f range
c
      res = 0.
      do i=min_ind,max_ind
        res=res+1/(float(max_ind-min_ind+1)) * 
     &    (log10(level_signal(i))-log10(level_noise(i)))
c      write(*,*) farray(i),log10(level_signal(i)),log10(level_noise(i)),
c     & res
      enddo
      if (res.le..2) then
c         write(*,*) ' min_ind,max_ind,res ',min_ind,max_ind,res
        write(*,*) ' *************** Noise ************* (get_om_fo) '
        return
      endif

      write(*,*) ' ****** signal between: ',farray(min_ind),
     &      ' and ',farray(max_ind),' Hz '

c
c find frequency after which average does not go up again
c
      j=0
      xx=0.
      ind=0
      do i=min_ind,min_ind+5
        xx=xx+log10(level_signal(i))
      enddo
      xx=xx/5.
      ind=min_ind
      do i=min_ind,maxl
        if (log10(level_signal(i)).gt.xx) then
          ind=i
        endif
      enddo
        
c        j=j+1
c        xx=xx+log10(level_signal(i))
c        if (log10(level_signal(i)).lt.log10(level_signal(min_ind))-.2
c     &      .and.ind.eq.0) then
c          ind = i
c        endif
c        if (log10(level_signal(i)).gt.log10(level_signal(min_ind))-.2
c     &      .and.ind.ne.0) then
c          ind = 0
c        endif
c      enddo
      f0 = farray(ind)
      f0i = f0
        
c
c find flat level as average between min_ind and f0
c
      om=0.
      cnt=0
      do i=min_ind,ind
        cnt=cnt+1
        om = om + log10(level_signal(i)) 
c        write(*,*) ' xxx ',i,farray(i),log10(level_signal(i)),om
      enddo
      om = om / float(cnt)
      omi=om
      write(*,*) ' *** initial om = ',om,' f0 = ',f0

c
c call genetic algorithm to serach for om and f0
c
c      write(*,*) ' xxx ',farray(min_ind),farray(max_ind)
c      call systime(time1,time2)
cc xxx     CALL CPU_Time(SC1)
c      read(time1,'(6i2)') YR1,MN1,DA1,HR1,MI1,ISC1
c      SC1=float(ISC1)
      if (search_method.eq.1.) then
        call ga_om_fo(current,log_spec,farray,maxl,farray(min_ind),
     &         farray(max_ind),om,f0,pop_size,
     &         generations,norm)
      elseif (search_method.eq.2.) then
        call grid_om_fo(current,log_spec,farray,maxl,farray(min_ind),
     &         farray(max_ind),om,f0,
     &         ngrid_f,ngrid_om,grid_nloop,norm)
      endif
cc xxx      CALL CPU_Time(SC2)
c      msdif=SC2-SC1
c      call systime(time1,time2)
c      read(time1,'(6i2)') YR2,MN2,DA2,HR2,MI2,ISC2
c      SC2=float(ISC2)
c      call timdif(YR2,MN2,DA2,HR2,MI2,SC2,
c     .                    YR1,MN1,DA1,HR1,MI1,SC1,msdif)

c
c get comparison of residuals
c
      if (omi_save.gt.0.) then
        call spec_residual(omi_save,f0i_save,log_spec,farray,maxl,
     &      farray(min_ind),farray(max_ind),res_m_a(1),norm)
      endif
c
c get residual for obtained values f0 and om
c
        call spec_residual(om,f0,log_spec,farray,maxl,
     &      farray(min_ind),farray(max_ind),res_m_a(2),norm)

c      call eval_spec_fit1(log_spec,farray,maxl,farray(min_ind),
c     &       farray(max_ind),f0,om,norm)

      return
      end


      subroutine spec_residual(om,f0,log_spec,farray,nfreq,fmin,
     &      fmax,res,norm)
      implicit none
      character*24 dec_to_bin
      real eval_spec_fit,eval_spec_fit1
      real om,f0,res
      real bin_to_dec
      real log_spec(*),farray(*)
      integer nfreq
      real fmin,fmax
      real norm

      integer lj1,lj2
      parameter (lj1=8)
      parameter (lj2=9)
      integer j1(lj1),j2(lj2)
      character*17 a

      a=' '
      a(1:lj1)=dec_to_bin(om/20.*(2.**float(lj1)-1.),lj1)
      a(lj1+1:lj1+lj2)=dec_to_bin(f0/40.*(2.**float(lj2)-1.),lj2)

      call text_to_array(a(1:lj1),j1,lj1)
      call text_to_array(a(lj1+1:lj1+lj2),j2,lj2)
c      res = -eval_spec_fit(log_spec,farray,nfreq,fmin,fmax,j1,
c     &        j2,lj1,lj2,norm) + 30.

      res=-eval_spec_fit1(log_spec,farray,nfreq,fmin,
     &       fmax,f0,om,norm)+30.
c      res = -eval_spec_fit(log_spec,farray,nfreq,fmin,fmax,j1,
c     &        j2,lj1,lj2,norm)-30. 

      return
      end

      subroutine ga_om_fo(current,log_spec,farray,nfreq,fmin,fmax,om,f0,
     &   pop_size,nloop,norm)
c
c subroutine to fit spectrum by Brune model, parameters are flat 
c level and corner frequency, the genetic algorithm follows the most
c simple case presented in Genetic Algor. + Data Structures = Evol. Programs,
c Zbigniew Michalewicz, 1992, ISBN 0-387-55387-8
c
c Lars Ottemoeller, March 2001
c
c input: 
c        current - current waveform channel, index to waveform common block
c        log_spec - signal
c        farray - array with frequency values
c        nfreq - number of frequencies in farray
c        fmin - min f to use
c        fmax - max --------
c        norm - norm fit
c
c output:
c        om - spectral flat level in log10 units
c        fo - corner frequency
c

      implicit none
      include 'libsei.inc'    ! Seisan includes
      include 'seidim.inc'    ! ---------------
      include 'waveform.inc'  ! ---------------
      integer seiclen

      integer current         ! current index to wav structure
      real bin_to_dec
      real log_spec(*),farray(*),y_brune(2048)
      integer nfreq
      real fmin,fmax
      real f0,om
      real norm

      integer nloop
      integer pop_size,max_pop_size
      integer lj1,lj2
      parameter (lj1=8)
      parameter (lj2=9)
      parameter (max_pop_size=300)
      integer i,j,j1(lj1),j2(lj2),loop,nc,y(max_pop_size),gen
      character*17 v(max_pop_size),v_new(max_pop_size),a
      real result(max_pop_size),pi(max_pop_size),qi(max_pop_size)
      real x
      real pc,pm
      parameter (pc=0.25)
      parameter (pm=0.01)
      real eval_spec_fit
      real omax(5)
      real fitness
      real rand
      character*24 dec_to_bin
      character*80 outfile

      x=rand(1)
      gen=0
      open(26,file='ga.out',status='unknown')
c
c init population, set half the population to initial values
c
      a=' '
      a(1:lj1)=dec_to_bin(om/20.*(2.**float(lj1)-1.),lj1)
      a(lj1+1:lj1+lj2)=dec_to_bin(f0/40.*(2.**float(lj2)-1.),lj2)
      do i=1,pop_size
        v(i)=' '
      enddo

      do i=2,pop_size-1
        do j=1,lj1+lj2
          write(v(i)(j:j),'(i1)') int(rand(0)+.5)
        enddo
c        v(i+1)=a
c        write(*,*) i,' ',v(i)
c        write(*,*) i+1,' ',v(i+1)
      enddo
      v(1)=a
      v(pop_size)=a

      do i=1,5
        omax(i)=-999.
      enddo
      do loop=1,nloop
        gen=gen+1
c        write(*,*) ' Generation ',gen
c
c evaluate population
c
        omax(5)=-999.
        do i=1,pop_size
          call text_to_array(v(i)(1:lj1),j1,lj1)
          call text_to_array(v(i)(lj1+1:lj1+lj2),j2,lj2)
          result(i) = eval_spec_fit(log_spec,farray,nfreq,fmin,fmax,j1,
     &        j2,lj1,lj2,norm)
c          write(222,*)i,-5.+bin_to_dec(j1,lj1)*20./(2.**float(lj1)-1.),
c     &      bin_to_dec(j2,lj2) *40./(2.**float(lj2)-1.),
c     &      result(i)

c commented out lo 22/7/2008
c          if (bin_to_dec(j2,lj2) *40./(2.**float(lj2)-1.).gt.0.and.
c     &      result(i).lt.30.)
c     &    write(87,*) 
c     &      bin_to_dec(j2,lj2) *40./(2.**float(lj2)-1.),
c     &      -5.+bin_to_dec(j1,lj1) *20./(2.**float(lj1)-1.),
c     &      30.-result(i)

c
c find overall maximum
c
          if (result(i).gt.omax(5)) then
            omax(5)=result(i)
          endif
          if (result(i).gt.omax(1)) then
            omax(1)=result(i)
            omax(2)=-5.+bin_to_dec(j1,lj1) *20./(2.**float(lj1)-1.)
            omax(3)=bin_to_dec(j2,lj2) *40./(2.**float(lj2)-1.)
            omax(4)=float(loop)
          endif
        enddo

c
c compute fitness
c
        fitness=0.
        do i=1,pop_size
          fitness=result(i)+fitness
        enddo
        write(26,*) ' Generation ',loop,' Fitness ',fitness,
     &       fitness/pop_size,omax(5)

c
c compute individual probablities
c
        do i=1,pop_size
          pi(i)=result(i)/fitness
        enddo

c
c compute cumulative probablities
c
        do i=1,pop_size
          qi(i)=0.
          do j=1,i
            qi(i)=qi(i)+pi(j)
          enddo
        enddo

c
c spin selection wheel
c
        do i=1,pop_size
          x=rand(0)
          v_new(i)=' '
          if (x.le.qi(1)) then
            v_new(i)=v(1)
          else
            do j=2,pop_size
              if (qi(j-1).lt.x.and.x.le.qi(j).and.v_new(i).eq.' ') then
                v_new(i)=v(j)
              endif
            enddo
          endif
        enddo
c        do i=1,pop_size
c          write(*,*) i,' ',v_new(i)
c        enddo

c
c crossover
c
        nc=0
        do i=1,pop_size
          x=rand(0) 
          if (x.le.pc) then
            nc=nc+1
            y(nc)=i
          endif
        enddo
        if (int(nc/2.).ne.(nc/2.)) nc=nc-1
        do i=1,nc,2
          j=int(rand(0)*float(lj1+lj2)+1.)
c          write(*,*) ' crossover ',y(i),y(i+1),j
          a=v_new(y(i))
          v_new(y(i))(j:lj1+lj2) = v_new(y(i+1))(j:lj1+lj2)
          v_new(y(i+1))(j:lj1+lj2) = a(j:lj1+lj2)
        enddo

c
c mutation
c
        do i=1,pop_size
          do j=1,lj1+lj2
            x=rand(0) 
            if (x.le.pm) then
c              write(*,*) ' changing ',i,j
              if (v_new(i)(j:j).eq.'1') then
                v_new(i)(j:j)='0'
              else
                v_new(i)(j:j)='1'
              endif
            endif
          enddo
        enddo

c
c copy v_new into v array
c
        do i=1,pop_size
          v(i)=v_new(i)
        enddo
      enddo
c
c write out result
c
      x=0.
      do i=1,pop_size
        call text_to_array(v(i)(1:lj1),j1,lj1)
        call text_to_array(v(i)(lj1+1:lj1+lj2),j2,lj2)
        result(i) = eval_spec_fit(log_spec,farray,nfreq,fmin,fmax,j1,j2,
     &        lj1,lj2,norm)

c        write(*,*) i,result(i),
c     &    -5.+bin_to_dec(j1,lj1)*20./(2.**float(lj1)-1.),
c     &    bin_to_dec(j2,lj2)*40./(2.**float(lj2)-1.)

c
c take average of last population
c
c         x=x+1.
c         om=om-5.+bin_to_dec(j1,lj1)*20./(2.**float(lj1)-1.) 
c         f0=f0+bin_to_dec(j2,lj2)*40./(2.**float(lj2)-1.)

        if (result(i).gt.x) then
          x=result(i)
          om=-5.+bin_to_dec(j1,lj1)*20./(2.**float(lj1)-1.)
          f0=bin_to_dec(j2,lj2)*40./(2.**float(lj2)-1.)
        endif
      enddo
      write(*,*) ' last generattion best om,f0 ',om,f0
c
c use best ever solution
c
      om=omax(2)
      f0=omax(3)

c      write(300,*) ' station '//wav_stat(current),wav_comp(current)
c      write(300,*) ' last generattion best om,f0 ',om,f0
      write(*,*) ' best ever solution ',om,f0
      write(*,*) ' result/generation ',omax(1),omax(4)
      close(26)
c
c write out log spectral amplitude
c
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.obs'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      do i=1,nfreq
        write(27,*) farray(i),log_spec(i)
      enddo
      close(27)

c      call compute_brune(omax(2),omax(3),farray,nfreq,y_brune)
      call compute_brune(om,f0,farray,nfreq,y_brune)
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.synth'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      do i=1,nfreq
        if (farray(i).ge.fmin.and.farray(i).le.fmax) 
     &    write(27,*) farray(i),y_brune(i)
      enddo
      close(27)

      return
      end

      subroutine grid_om_fo(current,log_spec,farray,nfreq,fmin,fmax,
     &   om,f0,ngrid_f,ngrid_om,nloop,norm)
c
c subroutine to fit spectrum by Brune model applying simple grid search
c
c Lars Ottemoeller, July 2002
c
c input: 
c        current - current waveform channel, index to waveform common block
c        log_spec - signal
c        farray - array with frequency values
c        nfreq - number of frequencies in farray
c        fmin - min f to use
c        fmax - max --------
c        norm - fitting norm
c        ngrid_f - number of grid points for f
c        ngrid_om - number of grid points for mo 
c        grid_nloop - number of loops in which grid size is made smaller
c
c output:
c        om - spectral flat level in log10 units
c        fo - corner frequency
c

      implicit none
      include 'libsei.inc'    ! Seisan includes
      include 'seidim.inc'    ! ---------------
      include 'waveform.inc'  ! ---------------
      integer seiclen

      integer xmax,ymax,xdim,ydim 
      parameter(xdim=500)
      parameter(ydim=500)
      integer nloop,loop
      integer current         ! current index to wav structure
      real bin_to_dec
      real log_spec(*),farray(*),y_brune(2048)
      integer nfreq
      real fmin,fmax
      real f0,om
      real norm

      integer i,jloop,nc,j
      real result(xdim,ydim),max
      real x,y,xstart,ystart
      real xstep,ystep
      real eval_spec_fit1
      real fitness
      real rand
      character*24 dec_to_bin
      character*80 outfile
      integer ngrid_f,ngrid_om

      xmax=ngrid_f
      ymax=ngrid_om

      open(26,file='grid.out',status='unknown')

c      nloop=3
      max=0.

      do loop=1,nloop

c step size
        xstep=(fmax-fmin)/float(xmax)/(loop**2.)
        ystep=15./float(ymax)/(loop**2.)
        write(*,*) ' loop,xstep,ystep ',loop,xstep,ystep
        if (loop.eq.1) then
          xstart=fmin
          ystart=-3.
        else
c set grid around previous best solution
          xstart=f0-(xmax*xstep/2.)
          ystart=om-(ymax*ystep/2.)
        endif

        do i=1,xmax
          x=xstart+(i-1)*xstep

          do j=1,ymax
            y=ystart+(j-1)*ystep
            result(i,j) = eval_spec_fit1(log_spec,farray,
     &          nfreq,fmin,fmax,x,y,norm)
c commented out lo 22/7/2008
c            write(99,*) i,j,x,y,result(i,j)
c            if (loop.eq.3.and.x.gt.0.) write(87,*) x,y,30.-result(i,j)
            if (result(i,j).gt.max) then
              max=result(i,j)
              f0=x
              om=y
            endif       
          enddo
        enddo

      enddo
      write(*,*) ' best ever solution ',om,f0,max
      close(26)
c
c write out log spectral amplitude
c
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.obs'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      do i=1,nfreq
        write(27,*) farray(i),log_spec(i)
      enddo
      close(27)

      call compute_brune(om,f0,farray,nfreq,y_brune)
      outfile=wav_stat(current)(1:seiclen(wav_stat(current)))
     &    // '.' // wav_comp(current)(1:seiclen(wav_comp(current)))
     &    // '.synth'
      do i=1,seiclen(outfile)
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      open(27,file=outfile,status='unknown')
      do i=1,nfreq
        if (farray(i).ge.fmin.and.farray(i).le.fmax) 
     &    write(27,*) farray(i),y_brune(i)
      enddo
      close(27)

      return
      end

      subroutine compute_brune(om,f0,farray,nfreq,brune)
c 
c compute Brune displacement spectrum for given om and f0
c
      implicit none
      real f0,om
      real farray(*)
      integer nfreq
      real brune(*)
      integer i
      do i=1,nfreq 
        brune(i)=log10(10**om/((1.+(farray(i)/f0)**2)))
      enddo
      return
      end

      real function eval_spec_fit(log_spec,farray,nfreq,fmin,fmax,
     &       j1,j2,lj1,lj2,norm)
c
c the evaluation function, computes residual between Brune spectrum and 
c observed spectrum
c
      implicit none
      real log_spec(*)
      real farray(*)
      real x,res
      integer nfreq
      integer j1(*),j2(*)
      real bin_to_dec
      real om,f0
      real fmin,fmax
      integer i,cnt,lj1,lj2
      real norm
c
c convert om and f0 to real numbers
c
      om=-5.+bin_to_dec(j1,lj1) *20./(2.**float(lj1)-1.)
      f0=bin_to_dec(j2,lj2) *40./(2.**float(lj2)-1.)
      res = 0.
      cnt = 0
c
c add squared residuals over all frequencies
c
      do i=1,nfreq
        if (farray(i).ge.fmin.and.farray(i).le.fmax.and.
     &       f0.gt.0.and.f0.lt.fmax) then
          x = om - log10(1.+(farray(i)/f0)**2)         ! source
          cnt = cnt +1
          res= res+abs(x-log_spec(i))**norm
        endif
      enddo
c
c make result negative, so that res can be maximized and add 
c constant to make values positive
c
      if (cnt.gt.0) then 
        x=-(res/float(cnt))**(1./norm) + 30.
      else
        x=0.
      endif
      eval_spec_fit = x   ! return negative residual
      end


      real function eval_spec_fit1(log_spec,farray,nfreq,fmin,fmax,
     &       f0,om,norm)
c
c the evaluation function, computes residual between Brune spectrum and
c observed spectrum
c
      implicit none
      real log_spec(*)
      real farray(*)
      real x,res
      real norm
      integer nfreq
      real bin_to_dec
      real om,f0
      real fmin,fmax
      integer i,cnt,lj1,lj2

      res = 0.
      cnt = 0
c
c add squared residuals over all frequencies
c
      do i=1,nfreq
        if (farray(i).ge.fmin.and.farray(i).le.fmax.and.
     &       f0.gt.0.and.f0.lt.fmax) then
          x = om - log10(1.+(farray(i)/f0)**2)         ! source
          cnt = cnt +1
          res= res+abs(x-log_spec(i))**norm
        endif
      enddo

      if (cnt.gt.0) then 
        x=-(res/float(cnt))**(1./norm) + 30.
      else
        x=0.
      endif
      eval_spec_fit1 = x   ! return negative residual
      end


      subroutine freq_event_type(yy,current,f_sel,time,pre,post,
     &   fr_type)
c
c determin type of event (Local, Distant or Noise), by comparing 
c spectral levels at low and high frequency, if level 
c difference from noise higher at lower frequency,
c event is assumed to be distant, otherwise local; 
c if signal and noise spectra have 
c no difference, signal is assumed to be noise
c
c Lars Ottemoeller, March 2001
c
c input: yy - data vector
c        current - index of carrent waveform channel
c        a and b - lower and higher frequency limits
c        time - phase arrival
c        pre - pre time in seconds
c        post - post time in seconds
c        f_sel - frequencies used to compare if dist or local
c
c output: fr_type - type of event, L: Local
c                                  D: Distant
c                                N: Noise (signal spectral levels same as noise)
c
c
      implicit none
      include 'libsei.inc'    ! Seisan includes
      include 'seidim.inc'    ! ---------------
      include 'waveform.inc'  ! ---------------
      integer current         ! current index to wav structure
      real yy(*)              ! data vector
      character*2 fr_type     ! type of event: L, D or N
      real a,b                ! min and max frequencies
      real f_low,f_high       ! low and high limit for spectrum
      real f_sel(2)
      integer maxl            ! dimension of spectral levels to be determined
      parameter (maxl=50)
      real level_signal(maxl),level_noise(maxl)  ! spectral levels for signal and noise
      real farray(maxl)       ! frequency array
      real max                ! max spec level
      complex y_com(max_sample) ! complex spectrum
      real sig(max_sample)    ! temp signal vector
      integer i,cnt           ! counters
      integer nsmooth         ! number of times for smooth
      double precision time   ! travel time
      real pre,post           ! pre and posrt time interval in seconds
      real xx                 ! some value
      integer ipow
c
c set initial values
c
      nsmooth = 0         ! no smoothing
      fr_type = 'R '
      
      if (wav_resp_status.eq.'9') then
        write(*,*) ' no response for: ' //wav_stat(current)//' '//
     &       wav_comp(current)
        return
      endif

      if (time.eq.-1) return
c
c init values
c
      f_low=0.01
      f_high=wav_rate(current)/2.
      farray(1)=f_sel(1)
      farray(maxl)=f_sel(2)
      do i=2,maxl-1
        farray(i)=log10(farray(1))+
     &    (log10(farray(maxl))-log10(farray(1)))/(maxl-1)*(i-1)
        farray(i)=10**farray(i)
      enddo

c
c signal
c
      call extract_signal(yy,wav_nsamp(current),wav_abs_time(current),
     &    wav_rate(current),time,pre,post,sig,cnt)
      call spec_value(current,sig,cnt,nsmooth,
     &    f_low,f_high,1,farray,maxl,0,level_signal,y_com,ipow)
c
c noise, set noise window, after wav_abs_time
c
      xx=post+pre
      if (wav_abs_time(current)+xx.ge.time) then
        xx=time-pre-wav_abs_time(current) 
      endif
      call extract_signal(yy,wav_nsamp(current),wav_abs_time(current),
     &    wav_rate(current),wav_abs_time(current)+pre,0.,xx,sig,cnt)
 
      call spec_value(current,sig,cnt,nsmooth,
     &    f_low,f_high,1,farray,maxl,0,level_noise,y_com,ipow)

c
c find max difference between signal and noise
c
      max = 0.
      xx  = 0.
      do i=2,maxl-1
          xx=abs(log10(level_signal(i))-log10(level_noise(i)))
c          write(*,*) ' xxx ',farray(i),log10(level_signal(i)),
c     *    log10(level_noise(i))
          if (xx.gt.max) then
             max = xx
c             write(*,*) ' max ',max
          endif
      enddo

      if (max.le..3) then
c        write(*,*) ' xxx Noise ',max,log10(level_signal(i)),
c     &         log10(level_noise(i))
        fr_type(1:2) = 'N '
        write(*,*) ' *************** Noise ************* '
      elseif (log10(level_signal(1))-log10(level_noise(1)).gt.
     &   log10(level_signal(maxl))-log10(level_noise(maxl))+max/2.)
     &   then
        fr_type(1:2) = 'D '
c        write(*,*) ' *************** Distant *********** '
      elseif (log10(level_signal(maxl))-log10(level_noise(maxl)).gt.
     &   max/2.) then
        fr_type(1:2) = 'L '
c        write(*,*) ' *************** Local ************* '
      else
c
c unknown type
c
        fr_type(1:2) = 'R '
      endif

c      write(111,*) wav_stat(current)//' '//wav_comp(current)//' ',
c     &         log10(level_signal(1)),log10(level_noise(1)),
c     &         log10(level_signal(2)),log10(level_noise(2)),
c     &         log10(level_signal(1))-log10(level_noise(1)),
c     &         log10(level_signal(2))-log10(level_noise(2)),
c     & fr_type

      return
      end


c      subroutine auto_moment(current,xdata,nsamp,code,ffmin,ffmax)
c      implicit none
c      include 'libsei.inc'
c      include 'seidim.inc'
c      include 'waveform.inc'
c
c      integer current         ! current channel ID
c      real xdata(max_sample)  ! data
c      real y(max_sample)  ! data
c      integer nsamp           ! number of samples
c      real srate              ! sample rate
c      integer code            ! error code
c      integer i,j             ! counter
c      real taper/10./         ! percentage of tapering (fixed)
c      integer ipow            ! length after padding
c      real ff                 ! frequency
c      real x_work(max_sample) ! log x scale
c      real f_scale(max_sample)! frequ scale
c      integer rem_resp        ! 1 if remove
c      integer seiclen
c      complex y_com(max_sample)
c      real q0,qalpha          ! q
c      integer disp_vel        ! kind of spectrum
c      real kappa              ! kappa
c      real f_low,f_high       ! filter band
c      integer pole_low,pole_high ! filter poles
c      real ffmin,ffmax
c      real travel_time
c
c
cc
cc set variables
cc
c      srate=wav_rate(current)
c      do i=1,nsamp
c        y(i)=xdata(i)
c      enddo
c      wav_current_chan(1)=current
c      disp_vel=1
c      rem_resp=1
c      travel_time=1.
c      f_low=0.0001
c      f_high=1000.
c      pole_low=4
c      pole_high=4
cc
cc hardwire
cc
c      kappa=0.0
c      q0=0.   
c      qalpha=.0
c
c      if (nsamp.le.20) then
c        code = -1
c        return
c      endif
c
cc
cc read response
cc
c      wav_resp_file = ' '
cc      call read_resp
c
c      if(wav_resp_status(1:1).eq.'9') then
c         write(*,'(a)')' No response info ***'
c         return
c      endif
c      if(wav_resp_status(1:1).eq.'8') then
c         write(*,'(a)')' Response from waveform header ***'
c      endif
c
cc
cc------- prepare data.     Pad with zeros and taper 10%.
cc
cc      call prepare(nsamp,taper,ipow,npad)
c
c
cc
cc calculate displacement spectrum, remove response, correct for kappa, not
cc for Q
cc
c      call spectrum(y_com,ipow,disp_vel,rem_resp,srate,
c     +     f_low,f_high,pole_low,pole_high,q0,qalpha,
c     *     kappa,travel_time)
cc      call spectrum(ipow,rem_resp,srate,
cc     +     spstart,spstop)
c
cc
cc   calculate real spectrum, limit to frequencies ffmin and ffmax
cc
c      open(15,file=wav_stat(current)(1:seiclen(wav_stat(current)))
c     &     //'.out',status='unknown')
c      j = 0
c      do i = 2,((ipow/2) + 1)
c       ff = (i-1)*srate/ipow
c       if(ff .ge.ffmin.and. ff .le. ffmax)then
c         j = j + 1
c         y(j) = ((1/srate)**2)*(y_com(i)*conjg(y_com(i)))    ! transient signal
c         y(j) = sqrt(y(j))              ! j.h. change
c         y(j) = log10( y(j) )           ! take the logarithm
c         x_work(j) = log10(ff)          ! this after use of com, equivalent !!!
c         f_scale(j) = ff
c         write(15,*) x_work(j),y(j)         
c       endif
c      enddo
c      close(15)
c
cc
cc call the inversion routine
cc
cc      call invert_spectrum(current,f_scale,ipow/2-1)
c
c      return
c      end
c
c
c      subroutine invert_spectrum(current,f_scale,maxs)
cc
cc on Linux routines auto_moment and invert_spectrum cause problems
c      implicit none
c
c      include 'libsei.inc'
cc      include 'mulplt.inc'
c      include 'seidim.inc'
c      include 'waveform.inc'
c      
c      integer current
c      integer maxs
c      integer maxx
c      parameter (maxx=1000)
c      real tol
c      parameter (tol=1.E-5)
c      real y(max_sample)
c      real thresh,wmax
c      real gn(maxx,maxx)          ! 
c      real m(maxx),m1(maxx)
c      real d(maxx),ds(maxx)
c      integer i,j,x
c      real f_scale(maxx)
c      real s,ff,f0
c      real v(maxx,maxx),w(maxx)
c      real density
c      real spec_velocity
c      integer seiclen
c
c      density=2.5
c      spec_velocity=6.2
c      m(1)=4.      ! start value for f0
c      m(2)=10**14.     ! start value for Moment
c      do i=3,maxs
c        m(i)=0.
c      enddo
c
cc
cc iteration loop
cc
c      do i=1,5
c
cc
cc compute data vector = y(i) - S(fi)
cc
c      open(15,file=wav_stat(current)(1:seiclen(wav_stat(current)))
c     &     //'.tsp',status='unknown')
c         do j=1,maxs
c           ff=f_scale(j)
c           f0=m(1)
c           s = m(2)/(1+ff*ff/(f0*f0))  ! source
c           s = log10( s )      ! take the logarithm
c           s = s+log10(1.2)   ! rad. pat, free surface
c           s = s+log10(1.0/   ! the rest, 1000 to convert metr.
c     *               (4*3.14*(density*1000)*((1000*spec_velocity)**3)))
c           ds(j)=s
c           d(j)=y(j)-s
c           write(15,'(4(g15.5))') log10(ff),s
c         enddo
c         close(15)
cc
cc compute kernel G
cc
c         do x=1,maxs
c           do j=1,maxs
c             gn(x,j) = 0.
c           enddo
c         enddo
c         do j=1,maxs
cc
cc compute ds/df0
cc
c           ff=f_scale(j)
c           s=log(10.)*2*ff**2/(m(1)**3)*(1+ff**2/m(1)**2)
c           s=4*ff**2/((m(1)**2)*log(10.)*(1+ff**2/m(1)**2))
cc           s = s+log10(1.2)   ! rad. pat, free surface
cc           s = s+log10(1.0/   ! the rest, 1000 to convert metr.
cc     *               (4*3.14*(density*1000)*((1000*spec_velocity)**3)))
c           gn(1,j) = s
cc
cc compute ds/dM
cc 
c           s = 1/(log(10.)*m(2))
cc           s = s+log10(1.2)   ! rad. pat, free surface
cc           s = s+log10(1.0/   ! the rest, 1000 to convert metr.
cc     *               (4*3.14*(density*1000)*((1000*spec_velocity)**3)))
c           gn(2,j) = s
c
cc           write(*,*) 'xxx ',gn(1,j),gn(2,j)
c         enddo
cc
cc call SVD
cc
c         call svdcmpx(gn,maxs,maxs,maxs,maxs,w,v)
cc         write(*,*) w ,v
c 
cc
cc edit w, remove small values
cc
c         wmax=0.
c         do j=1,maxs
c           if(w(j).gt.wmax)wmax=w(j)
c         enddo
c         thresh=tol*wmax
c         do j=1,maxs
c           if (w(j).lt.thresh)w(j)=0.
c         enddo
c
cc
cc call svbksb
cc
c         call svbksbx(gn,w,v,maxs,maxs,maxs,maxs,d,m1)
c 
cc
cc add differences
cc
c         m(1) = m(1) + m1(1)
c         m(2) = m(2) + m1(2)
c         write(*,*) ' iteration ',i,m(1),m(2)
c
c      enddo
c
c      return
c      end


      subroutine normalize_signal(yy,n,xx)
c
c normalize data (yy) with n samples to maximum of xx
c
      implicit none
      real yy(*)
      integer n,i
      real max,xx

      max=0.
      do i=1,n
        if (abs(yy(i)).gt.max) max = abs(yy(i))
      enddo
      do i=1,n
        yy(i)=yy(i)/max*xx
      enddo
      return
      end


      subroutine gvel_to_time(dist,abs_time,
     &          time_out,duration)
c
c routine to convert group velocities in start time and duration
c

      implicit none
      include 'autosig.inc'

      real dist                          ! distance in km
      double precision abs_time,time_out ! origin time and phase start time
      real duration                      ! duration
      real start,stop                    ! help variables
      character*1 which_phase            ! function to give P or S
      real vg(2)                         ! group velocities

      if (which_phase(phase_mode).eq.'P') then
        vg(1)=gvel_p(1)
        vg(2)=gvel_p(2)
      elseif (which_phase(phase_mode).eq.'S') then
        vg(1)=gvel_s(1)
        vg(2)=gvel_s(2)
      else
        time_out=abs_time
        duration=0.
        return
      endif
 
      start=dist/vg(2)
      stop =dist/vg(1)
      time_out=abs_time+start
      duration=stop-start

      return
      end

      real function eval_q(q0,f,qalpha,fc)
      real q0,f,qalpha
c
c compute q=q0*f**qalpha for f>1 Hz, use fixed Q0 for f<1 
c 
      if (fc.eq.0.) then
        eval_q=q0*f**qalpha
      else
        eval_q=q0*(1+(f/fc)**qalpha)
      endif

c      if (f.ge.1.) then
c
c        eval_q=q0*f**qalpha
c
c      else
c        eval_q=q0
c      endif
      return
      end 

      logical function spiketest(data,c,nsamp,srate)
c
c check if signal is spike
c
      implicit none
      include 'seidim.inc'
      logical flag
      real data(*),data1(max_sample)
      integer c,nsamp,ind,i,j,i1,i2
      real average,min,max
      double precision srate

      flag=.false.

      min=999999999999999999.
      do i=1,nsamp
        if (abs(data(i)).lt.min) min=abs(data(i))
      enddo
      
      do i=1,nsamp
        data1(i)=abs(data(i))
      enddo

      max=-999999999999999999.
c
c find previous maximum within 3 seconds
c
      ind=c
      do i=c,1,-1
        if ((c-i)/srate.le.3.) then
          if (data1(i).gt.max) then
             max=data1(i)
             ind=i
          endif
        endif
      enddo 
      c=ind

      if (c.le.srate*.2) return

      average=0.
      j=0
      i1=c-int(srate*.2)
      i2=c+int(srate*.2)
      do i=i1,i2
        if (abs(c-i)/srate.gt..1) then
           average=average+data1(i)
           j=j+1
        endif
      enddo
      average=average/float(j)
      if (data1(c).gt.(10.*average)) then
        flag=.true.
      endif

      spiketest=flag
      return
      end

c     iscloc_wrap()
c
c     Subroutine to go between fortran update or hyp and C iscloc.
c
c     Calls:
c           subroutines from rea.for
c           read_stat() from this file.
c           write_hyp() from this file.
c           iscloc() from iscloc.c
c           functions from libsei.inc
c
c     Only read the station file on first visit (nstat=0), store
c     station data with this routine between calls using save.
c     Exception to this is if model in current s-file is different to 
c     that in the previous one - in which case station file is different.
c
c     This is only place that model/station file gets read so read
c     agency and test array here and pass back to calling routine.
c     read_stat() writes mag_cor to /hyp/ common block.

      subroutine iscloc_wrap(iustat,iulst,data,nhead,nrecord,agency,
     &                       test,locate,use_eev)

	  implicit none
      save

      external iscloc                     ! C function

      include 'hypparm.inc'               ! nstats, data, test
      include 'seidim.inc'                ! needed for rea.inc
      include 'rea.inc'                   ! for reading s-files

c Library file open routine needs these
      include 'libsei.inc'                 ! Library definitons.
      external sei open                    ! File open handler.
      external sei close                   ! & closure.
      integer  code                        ! Condition.
      logical  b_flag                      ! A problem flagged?.

c Arguments
      integer iustat                      ! lu to use for station file
      integer iulst                       ! print.out logical unit
      integer nhead                       ! number of headers in data
      integer nrecord                     ! number of lines in data
      character*3 agency                  ! agency read from station list
      logical locate                      ! return true on success 
      logical use_eev                     ! flag controlling output

c Arrays to store staion info - nstats set in hypparm.inc
      character*5 statid(nstats)
      real sta_lat(nstats),sta_lon(nstats)
      integer sta_elev(nstats)
      integer nstat                   ! number of stations in station list

c Arrays for phase data extra to the ones in rea.inc
      real        pha_lat(max_data/2)
      real        pha_lon(max_data/2)
      real        pha_elev(max_data/2)
      real        pha_weight(max_data/2)
      character*8 pha_isc_phase(max_data/2)
      character   char_stat(5,max_data/2)
      character   char_phase(8,max_data/2)
      character   char_isc_phase(8,max_data/2)

      character*1 prev_model          ! to check if new STATION file needed

      integer weight                  ! for writing to s-file
      integer i,j,k

c Program starts cccccccccccccccccccccccccccccc

c Read in prime hypocenter from s-file stored in data()
      call rea_hyp_clear(1)
      call rea_hyp1_in(data(1),1)

c If this is the first visit to this routine then load in station data.
c Also read file if current s-file has a different model in it.
      if (nstat .eq. 0 .or. hyp_model(1) .ne. prev_model) then
         call read_stat(iustat,iulst,hyp_model(1),statid,sta_lat,
     &                  sta_lon,sta_elev,nstat,agency,test,use_eev)
      end if
      prev_model = hyp_model(1)

c Read in phases from s-file stored as data()
      rea_nphase = 0
      do i=nhead+1,nrecord
         if (data(i) .ne. ' ') then
            rea_nphase=rea_nphase+1
            call rea_phase_clear(rea_nphase)          ! clear variables
            call rea_phase_in(rea_nphase,data(i))     ! read

            ! Put station info into arrays parallel to phase data
            j=0
            do while (j .lt. nstat)                   
               j = j+1
               if (rea_stat(rea_nphase) .eq. statid(j)) then
                  pha_lat(rea_nphase)  = sta_lat(j)
                  pha_lon(rea_nphase)  = sta_lon(j)
                  pha_elev(rea_nphase) = sta_elev(j)
                  j=nstat
               end if
            end do

           ! Put strings into 2D arrays of char for easy passing to C
           do j=1,5
              char_stat(j,rea_nphase) = rea_stat(rea_nphase)(j:j)
           end do
           do j=1,8
              char_phase(j,rea_nphase) = rea_phase(rea_nphase)(j:j)
           end do

         else
            if(i.ne.nrecord) then                     ! last can be blank
               write(6,*)' Blank line in phase data'
               write(6,'(a)')data(1)(1:79)
               stop
            end if
         end if
      end do

c Close print.out so that iscloc can append to it
      call sei close(close$,iulst,code)

c Call seisan version of iscloc - rea_nphase=0 if failure
      call iscloc( hyp_year, hyp_month, hyp_day, hyp_hour,
     &             hyp_min, hyp_sec, hyp_fix_org, 
     &             hyp_lat, hyp_lon, hyp_epi_flag,
     &             hyp_depth, hyp_depth_flag,
     &             hyp_rms, hyp_gap, hyp_sec_err,
     &             hyp_lat_err, hyp_lon_err, hyp_depth_err,
     &             char_stat, char_phase,
     &             char_isc_phase, rea_hour, rea_min, rea_sec,
     &             rea_res, rea_dist, rea_az, pha_weight,
     &             pha_lat, pha_lon, pha_elev, rea_nphase )

      locate = .true.
      if (rea_nphase .eq. 0) locate = .false.

c Re-open print.out
      chr_f_access$ = 'APPEND'
      call sei open( old$,                ! Open print file.
     &               ' ',                 ! No prompt.
     &               'print.out', iulst,  ! File & unit.
     &               b_flag,              ! File exists?.
     &               code )               ! Condition (n/a).


c If solution was found then change data array
      if (locate) then

         ! new top line
         call rea_hyp1_out(data(1),1)

         ! check for existing error line
         k=2                                          
         do while (data(k)(80:80) .ne. 'E' .and. k .le. nhead)
            k=k+1
         end do         

         ! if no error record move data array below header down one
         if (data(k)(80:80) .ne. 'E') then
            do i=2,nrecord
               data(nrecord+3-i)=data(nrecord+2-i)
            end do
            nrecord=nrecord+1
            nhead=nhead+1
            k=2                    
         endif              

         ! new error line
         call rea_hype_out(data(k),1)

         ! insert new residuals etc into phase lines in data()
         k=nhead
         do i=1,rea_nphase
            k=k+1

            ! untangle 2D character array holding new phase names 
            j=1
            do while (char_isc_phase(j,i) .ne. '\0')
               pha_isc_phase(i)(j:j) = char_isc_phase(j,i)
               j=j+1
            end do
            pha_isc_phase(i)(j:) = ' '

            ! create string showing weight - multiply real weight by 10
            weight = 10.*pha_weight(i)+0.49
            if (weight .eq. 10) then
               rea_weight_out(i)(1:1) = '1'
               rea_weight_out(i)(2:2) = '0'
            else if (weight .eq. 0) then
               rea_weight_out(i) = ' '
            else
               rea_weight_out(i)(1:1) = ' '
               rea_weight_out(i)(2:2) = char(ichar('0') + weight)
            endif

            call rea_phase_out(i,data(k))
         end do

         ! write lines to print.out in format read back in by hyp
         call write_hyp(iulst,pha_isc_phase,pha_weight)

      end if   ! location succeeded

      return                           
      end        

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c     read_stat()
c
c     Subroutine to read hypo71 style station file.
c     Extracts and returns station codes and locations.
c     Extracts station magnitude corrections and puts them in a common block.
c     Reads RESET TEST variables and returns test array.
c     Reads agency from last line of file and returns it.
c
c     Calls:
c           stations() from hyposub1.for
c           functions from libsei.inc
c
c     If use_eev is false stations() will write a stalist to print.out

      subroutine read_stat(iustat,iulst,model,statid,lat,lon,elev,
     &                     nstat,agency,test,use_eev)

      implicit none

      include 'hypparm.inc'                ! nstats and test

c Arguments
      integer iustat                      ! lu to use for station file
      integer iulst                       ! print.out logical unit
      character*1 model                   ! charcter for choice of STATION file
      character*5 statid(*)               ! station codes
      real lat(*),lon(*)
      integer elev(*)
      integer nstat                       ! actual number of stations
      character*3 agency                  ! agency read from station file
      logical use_eev                     ! toggle list output to print.out

c Library file open routine needs these
      include 'libsei.inc'                 ! Library definitons.
      external sei get file,               ! Find file & open handler.
     &         sei close,                  ! & closure.
     &         sei clen,                   ! String length.
     &         sei code                    ! Error condition handler.
      integer  sei clen                    ! & function.
      integer  code                        ! Condition.
      logical  b_flag                      ! A problem flagged?.

c Variables to use in call to stations(), nstats set in hypparm.inc
      integer la(nstats),lo(nstats)
      real alat(nstats),alon(nstats)
      real fmg(nstats),scrst(nstats)
      real dly(nstats)
      integer init
      character*1 ins(nstats),iew(nstats)

c Common block for magnitude corrections
      common/hyp/stacode,mag_cor
      character*5 stacode(nstats)         ! same as statid() but in common
      real mag_cor(5,nstats)              ! station magnitude corrections

      character*80 cur_file
      character*80 testdat
      integer i

c Open the stations file. All this stuff is in libsei
      cur_file = 'STATION0.HYP'                ! Set up filename
      if (model.ne.' ') cur_file(8:8)=model    ! and adjust if needs be.
      call sei get file( open$+ignore$,        ! Find file & open it.
     &                   iustat,               ! On unit.
     &                   code,                 ! Returned condition.
     &                   'DAT',                ! Alternative directory to search
     &                   cur_file )            ! For stations file.
      if( code .ne. e_ok$ ) then
         chr_err_msg$ = cur_file(:seiclen(cur_file)) //
     &                  ' does not exist'
         call sei code( stop$,              ! Halt the program with user-.
     &                  e_misf$,            ! Message; dummy use of code.
     &                  0,                  ! Unit (n/a).
     &                  b_flag )            ! Flag (n/a).
      end if

c Report which file is being read
      if (.not. use_eev) then
         inquire(iustat,name=cur_file)
         write (iulst,*) 'Reading station data from ',
     &                  cur_file(:seiclen(cur_file))
         write (iulst,*)
      end if

c Initialise test() with default values
      call settest(test)

c Read RESET lines at start of station file
      testdat='xxxxx'        
      do while (testdat.ne. '     ')
         read(iustat,'(a80)')testdat
         if (testdat(13:13).eq.')')then
            read(testdat,'(t12,i1,t15,f9.4)') i,test(i)
         else if (testdat(14:14).eq.')')then
            read(testdat,'(t12,i2,t16,f9.4)') i,test(i)
         else if(testdat(15:15).eq.')')then
            read(testdat,'(t12,i3,t17,f9.4)') i,test(i)
         end if
         if (.not. use_eev) then
            write(iulst,'(1x,''Reset test('',i3,'')='',f10.4)')i,test(i)
         end if
      end do
      if (.not. use_eev) write (iulst,*)

c Fill arrays with station info
c     statid:       station identifier (5 letters max.)
C     la:           degree portion of station's geographic latitude
c     alat:         minute  "                      "
c     ins:          'S' for south, 'N' for north
C     lo:           degree portion of station's geographic longitude
c     alon:         minute  "                      "
c     iew:          'E' for east, 'W' for west
c     elev:         station elevation in meters
c     dly:          station delay in seconds - not used at present
c     fmg:          not used here
c     scrst:        not used here
c     nstat:        returns number of stations
c     init:         not used here
c     nstats:       maximum number of stations from hypparm.inc
c     mag_cor:      not used here
c     use_eev       flag to control output to print.out

      call stations(statid,la,alat,ins,lo,alon,iew,elev,dly,fmg,
     & scrst,nstat,iustat,iulst,init,nstats,mag_cor,use_eev)

      do i=1,nstat
        stacode(i) = statid(i)
        lat(i) = la(i) + alat(i)/60
        if (ins(i) .eq. 'S') lat(i) = lat(i) * -1

        lon(i) = lo(i) + alon(i)/60
        if (iew(i) .eq. 'W') lon(i) = lon(i) * -1
      end do

c Skip local model at end of station file
      testdat='xxxxx'        
      do while (testdat.ne. '     ')
         read(iustat,'(a80)')testdat
      end do
      read(iustat,'(a80)')testdat

c Read in agency
      read(iustat,'(a3)') agency 

c Close the file (stop on error).
      call sei close(close$,iustat,code)

      return
      end   

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c     write_hyp()
c
c     Subroutine to write hypocentre and phase data to print.out
c     Information already there from iscloc but need this exact format
c     to keep hyp happy as it reads print.out and writes it to screen.

      subroutine write_hyp(iulst,pha_isc_phase,pha_weight)
      implicit none

      include 'seidim.inc'                 ! needed for rea.inc
      include 'rea.inc'                    ! contains common block with data

c Arguments
      integer     iulst                    ! print.out logical unit
      character*8 pha_isc_phase(*)         ! ISC phase code
      real        pha_weight(*)            ! weights direct from iscloc

c Tempory variables for hypocentre write
      integer yy                           ! 2 digit year
      integer lat1,lon1                    ! degree part
      real lat2,lon2                       ! minute part
      character*1 ns,ew                    ! N/S E/W part
      character*1 m                        ! not sure exactly what m is
      integer cd                           ! convergence flag - always 3 here
      real damp                            ! not used
      character*1 fo                       ! time fixed flag * if fixed
      character*1 fe                       ! epicentre fixed flag * if fixed
      character*1 fd                       ! depth fixed flag * if fixed

c Temporary variables for phase write
      real*8 hyp_abs_time                  ! hypocentre time relative to epoch
      real t_obs                           ! observed travel time 
      real t_calc                          ! calculated travel time

      integer k

c
c Hypocentre header and line
c

c Want 2 digit year
      yy = hyp_year(1) - 100*(hyp_year(1)/100)

c Want lat and lon in bits
      lat1 = abs(hyp_lat(1))
      lat2 = (abs(hyp_lat(1))-lat1)*60
      ns = 'N'
      if (hyp_lat(1) .lt. 0) ns = 'S'
      lon1 = abs(hyp_lon(1))
      lon2 = (abs(hyp_lon(1))-lon1)*60
      ew = 'E'
      if (hyp_lat(1) .lt. 0) ew = 'W'

c m is 3 or 2 if depth fix but not sure what it should be when lat/lon fix
      m=' '

c fo is time fixed flag but * not F
      fo=' '
      if (hyp_fix_org(1) .eq. 'F') fo='*'

c fe is epicentre fixed flag but * not F
      fe=' '
      if (hyp_epi_flag(1) .eq. 'F') fe='*'

c fd is depth fixed flag but * not F
      fd=' '
      if (hyp_depth_flag(1) .eq. 'F') fd='*'

c Some damping parameter thats not aplicable - set to 0
      damp=0

c Only here if converged set cd to 3
      cd=3

      write(iulst,'(/,''   date hrmn   sec      lat      long'',
     &    '' depth   no m    rms  damp erln erlt erdp ic'')')

      ! all errors
      if (hyp_depth_err(1) .gt. 0) then
         write(iulst,1) yy,hyp_month(1),hyp_day(1),hyp_hour(1),
     &               hyp_min(1),hyp_sec(1),fo,
     &               lat1,lat2,ns,lon1,lon2,ew,fe,hyp_depth(1),
     &               fd,rea_nphase,m,hyp_rms(1),damp,
     &               hyp_lon_err(1),hyp_lat_err(1),
     &               hyp_depth_err(1),cd

      ! only errors in lat/lon if depth fixed
      else if (hyp_lat_err(1) .gt. 0) then
         write(iulst,2) yy,hyp_month(1),hyp_day(1),hyp_hour(1),
     &               hyp_min(1),hyp_sec(1),fo,
     &               lat1,lat2,ns,lon1,lon2,ew,fe,hyp_depth(1),
     &               fd,rea_nphase,m,hyp_rms(1),damp,
     &               hyp_lon_err(1),hyp_lat_err(1),cd

      ! no errors at all if epicentre fixed - leave rms/cd off too
      else
         write(iulst,3) yy,hyp_month(1),hyp_day(1),hyp_hour(1),
     &               hyp_min(1),hyp_sec(1),fo,
     &               lat1,lat2,ns,lon1,lon2,ew,fe,hyp_depth(1),
     &               fd,rea_nphase,m,damp
      end if

1     format(1x,3i2,1x,2i2,f6.2,a1,i2,f5.2,a1,i4,f5.1,a1,a1,f5.1,
     &       a1,i4,a1,1x,f7.2,f6.3,3f5.1,i3)
2     format(1x,3i2,1x,2i2,f6.2,a1,i2,f5.2,a1,i4,f5.1,a1,a1,f5.1,
     &       a1,i4,a1,1x,f7.2,f6.3,2f5.1,5x,i3)
3     format(1x,3i2,1x,2i2,f6.2,a1,i2,f5.2,a1,i4,f5.1,a1,a1,f5.1,
     &       a1,i4,a1,1x,7x,f6.3,18x)

c
c Phase header and lines
c
      write(iulst,'(/,'' stn   dist   azm  ain w phas'',
     &   ''    calcphs hrmn tsec  t-obs  t-cal    res   wt di'')')

      ! observed travel times are relative to hypocentre time
      call timsec(hyp_year(1),hyp_month(1),hyp_day(1),hyp_hour(1),
     &            hyp_min(1),hyp_sec(1),hyp_abs_time)

c Loop over phases writing line for each
      do k=1,rea_nphase

         ! Put first motion in char 7 of phase code
         ! Only do this if phase code less than 6 chars long
         if (rea_phase(k)(6:6) .eq. ' ') then
            rea_phase(k)(7:7) = rea_polarity(k)
         end if

         ! calculate t_obs and t_calc on the fly
         call timsec(hyp_year(1),hyp_month(1),hyp_day(1),rea_hour(k),
     &               rea_min(k),rea_sec(k),rea_abs_time(k))
         t_obs = rea_abs_time(k) - hyp_abs_time
         if (t_obs .lt. -3600.) t_obs = t_obs + 86400  ! day change
         t_calc = t_obs - rea_res(k)

         ! only print t_calc, residual and weight when phase has a residual
         if (rea_res(k) .ne. -999) then
            write(iulst,11) rea_stat(k),int(rea_dist(k)+.49999),
     &                  rea_az(k),rea_phase(k),pha_isc_phase(k),
     &                  rea_hour(k),rea_min(k),rea_sec(k),t_obs,
     &                  t_calc,rea_res(k),pha_weight(k)
         else
            write(iulst,12) rea_stat(k),int(rea_dist(k)+.49999),
     &                  rea_az(k),rea_phase(k),pha_isc_phase(k),
     &                  rea_hour(k),rea_min(k),rea_sec(k),t_obs
         end if

      end do
      write(iulst,*)

11    format(1x,a5,i5,f6.1,8x,a8,a8,2i2,f5.1,2f7.1,f7.2,f5.2)
12    format(1x,a5,i5,f6.1,8x,a8,a8,2i2,f5.1,f7.1)

      return
      end

c     file codeco_common.f
c          ===============
c
c     version 3, 21-Aug-98
c
c     variables of header lines of GSE files
c     K. Stammler, 19-Aug-98

c     -- constants
      integer   c_sigsize          ! dimension of sample array
      integer   c_bufsize          ! dimension of char buffer for compressed data
      parameter(
     &   c_sigsize = 3000000,
     &   c_bufsize = 6*c_sigsize
     &)

c     -- header variables of common block
      integer   hdr_debug          ! debug level
      integer   hdr_year           ! data start time; year
      integer   hdr_month          ! data start time; month
      integer   hdr_day            ! data start time; day of month
      integer   hdr_jday           ! data start time; day of year
      integer   hdr_hour           ! data start time; hour
      integer   hdr_min            ! data start time; minute
      integer   hdr_sec            ! data start time; second
      integer   hdr_msec           ! data start time; millisecond
      integer   hdr_nsamp          ! number of samples
      integer   hdr_ifmtnum        ! input format number
      integer   hdr_ofmtnum        ! output format number
      integer   hdr_idiff          ! number of input differences
      integer   hdr_odiff          ! number of output differences
      integer   hdr_calunit        ! unit of calibration (0=displ, 1=vel, 2=acc)
      real      hdr_smprate        ! sample rate in Hz
      real      hdr_calfac         ! calibration factor
      real      hdr_calper         ! calibration period
      real      hdr_stalat         ! station latitude
      real      hdr_stalon         ! station longitude
      real      hdr_staelev        ! station elevation
      real      hdr_stadepth       ! emplacement depth
      real      hdr_beamaz         ! beam azimuth
      real      hdr_beamslo        ! beam slowness
      real      hdr_hang           ! horizontal orientation
      real      hdr_vang           ! vertical orientation
      character hdr_station*10     ! station name
      character hdr_stadescr*10    ! station/chan description
      character hdr_chan*3         ! channel name
      character hdr_instr*6        ! instrument type
      character hdr_network*9      ! network name
      character hdr_coosys*12      ! name of coordinate system
      character hdr_ifmtname*10    ! name of input format
      character hdr_ofmtname*10    ! name of output format

      common /gsehdr/
     &   hdr_debug, hdr_year, hdr_month, hdr_day, hdr_jday,
     &   hdr_hour, hdr_min, hdr_sec, hdr_msec, hdr_nsamp,
     &   hdr_ifmtnum, hdr_ofmtnum, hdr_idiff, hdr_odiff,
     &   hdr_calunit, hdr_smprate, hdr_calfac, hdr_calper,
     &   hdr_stalat, hdr_stalon, hdr_staelev, hdr_stadepth,
     &   hdr_beamaz, hdr_beamslo, hdr_hang, hdr_vang,
     &   hdr_station, hdr_stadescr, hdr_chan, hdr_instr,
     &   hdr_network, hdr_coosys, hdr_ifmtname, hdr_ofmtname

c                                                                               
c     routine to plot response function       
c     jh February 1997
c
c  changes
c
c     
c     26 mar 99 bmt : include winplot.inc
c     june 99 jh    :  ------------  version 7.0 -----------------------
c     11 may 00 lo  : include waveform.inc and use read_resp routine
c      16 may 01 jh : fix common block
c     16 june 05 jh : plt to eps
c
c
c                                

      include 'winplot1.inc'   
c      implicit none
      include 'seiplot.inc'
      include 'seidim.inc'
      include 'waveform.inc'
      real ff ! frequency
c-- number of points in spectrum
      integer nspec
c-- if several data sets, number of points in each
      integer nnspec(2)
c-- counters and help variables                                               
      integer i,j				
c-- response value
      complex respons
      character*80 text
      character*30 xtext,ytext      ! axis text
c--returns from spectral plot
      character*1 c_spec(20)
      real x0                       ! left corner of spectrum
c-- Arguments passed
      character*80     arg(10)
      real cx(20),cy(20)
      integer nc,nars
      real x(1000),y(1000)

      logical gse_resp          ! true if gse format
      logical sei_resp          ! true if seisan format
      integer nfa               ! number of frequencies and amplitude

c   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      real xpole(10)
      REAL FFILT(10)
      complex pol(max_resp_value),zero(max_resp_value)  ! complex PAZ
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
c   sensor type 2: seismometer, 3: accelerometer
      integer sentyp
      real g1hz  ! gain at 1 hz
c   individual response values
      real freq_val(max_resp_value),gain_val(max_resp_value),
     *phas_val(max_resp_value)
      logical ftab                      ! if true, force tabulated values

c
c response common block
c
      common /response/nfilt,pole,ffilt,gain,gencon,dampin,period,ftab,
     *                 regain,g1hz,freq_val,gain_val,phas_val,sentyp,
     *                 npol,nzero,pol,zero,norm,gse_resp,sei_resp,nfa
      equivalence (xpole,pole)

      include 'version.inc'
      include 'winplot2.inc'
 
c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      nars = 0
c 
c   get argument
c
      call get_arguments(nars,arg)    ! get arguments 
      if(nars .eq. 1) then
           wav_resp_file=arg(1)
      elseif(nars.eq.0) then
 10       continue
          text=' File name, number, ? to get list'
          call filename(text,wav_resp_file)      
          if(wav_resp_file.eq.'EOF') goto 999
      else
          write(6,*)' Enter one argument with file name'
          stop
      endif
 
c
c  check display type, can be x (sun) or Microsoft (pc)
c
      call get_display(display_type)
c
c-- x-window size in % screen
c
      wsize=65
c
c  graphic display not yet open
c
      disp_open=0

c
c read response file
c
         call read_resp
         plotoption=1
         hctype=1
c
c  open plot file
c
         open(2,file='presp.eps',status='unknown')
         plotunit=2
c
c   open plotter
c
         call open_display 
c
c set some postscipt scalings
c
         write(plotunit,*) ' 1.4 0.85 scale'
c
c  the amplitude response
c
      j=0
      do i = -260,190,1    ! log frequencies
         j=j+1
         ff=10**(i/100.0)
         call calc_resp(ff,respons)
         y(j)=log10(cabs(respons))
         x(j) = log10(ff)          
 1243    continue
      enddo
      nspec=j
c
c   plot spectrum
c
      xtext='      Log frequency (Hz)     '
      ytext='Log amplitude                '
      write(text,'(a)')'Amplitude Response, count/nm '
      nnspec(1)=nspec
      x0=100.0                
      call xy_plot
     *(1,nnspec,x,y,text,xtext,ytext,590.0,250.0,
     *x0,420.0,2,1,30.0
     *,0,c_spec,nc,cx,cy)
c
c  the phase response
c
      j=0
      do i = -260,190,1    ! log frequencies
         j=j+1
         ff=10**(i/100.0)
         call calc_resp(ff,respons)
         y(j)=180.0*atan2(imag(respons),real(respons))/3.141592654
         x(j) = log10(ff)          
      enddo
      nspec=j
c
c   plot spectrum
c
      ytext='Phase                '
      write(text,'(a)')'Phase response '
      nnspec(1)=nspec
      call tchars('q to quit',9,750.0,700.0)
      call tchars(wav_resp_file(1:seiclen(wav_resp_file)),80,10.0,750.0)
      call pchars(wav_resp_file(1:seiclen(wav_resp_file)),80,10.0,750.0)
      call xy_plot
     *(1,nnspec,x,y,text,xtext,ytext,590.0,250.0,
     *x0,70.0,2,1,30.0
     *,1,c_spec,nc,cx,cy)
c
c   close postscript
c
      call close_post
c
c   close output plot file
c 
      close(2)
c
c   back to alpha
c
      call clear_to_alpha
c
c   if filenr.lis list is used, try another
c   
      if(nars.eq.0) goto 10
c
 999  continue
      write(6,*)' Plot file in presp.eps'
      stop
      end                                                                       
c
c      include 'pcplot.inc'   ! pc plotting routines

c  computer dependent subroutines including dummy routines to be
c  able to use same programs on pc and sun
c
c    ***** this file is for linux ******
c
c
c  Updates:
c
c--------------------------------------------------------------------
c  nov5 by jh       version 7.0 check
c

      subroutine computer_type(sun,pc,linux)
c   which computer
      implicit none
      logical pc,sun,linux
      pc=.false.
      sun=.false.
      linux=.true.
      return
      end

      integer function JIAND(i1,i2)
      implicit none
      integer i1,i2
      jiand=iand(i1,i2)
      return
      end 

      subroutine iasp91_filename(name)
c set name of iasp91 files
      character*(*) name
      name='IASP91_linux'
      return
      end

C   RESPONSE PROGRAM
C
C   J. HAVSKOV    FEB 90
C
C   CALCULATES RESPONSE OF A SEISMIC SYSTEM INCLUDING
C   SENSORS, AMPLIFIER, FILTERS ETC. CAN BE COMBINED WITH
C   POLES AND ZEROS SPECIFICATIONS 
c
C
C   ALL UNITS ARE IN METERS AND SECONDS EXCEPT ACCELERATION
C   WHICH IS SUPPOSED TO BE IN G.
C
C   LAST UPDATE:
C   mar 13, 90 by j.h. : last changes 
C   dec 90             : seisan  response file
C   jan  4 91          : minor cleanup
C   JAN 29             :----
C   feb 4              : error in output format
c   nov 12 91 by jh    : adapt seisan  response filename to pc
C   NOV 22 92          : decrease lower frequency to 0.01 hz, make
c   dec 17             : array bound bug
c                        calculation with accelerometer correct if
c                        a displacemrnt or velocity response is wanted,
c                        from now on units also m and s for accellerometer
c                        in output, g in input as before.
C   DEC 1 92           : BUG WHEN CALCULATING LOWER FREQUENCY STEPS
C   dec 93             : fix pc file names, seisan  to seisan
c   mar 30 94          : do not allow seisan response file if not displacement
c   aug 26 94          : RESPONSE.OUT to resp.out
c   dec 94             : ********* version 5.0 ****************************
c   aug 2  96  jh      : changed phase response , seem that there was
c                        an error, term with 2 * i * damp changed sign
c   feb 97             : poles and zeros
C   feb 97 lo          : moved subrourine inter_p to ../LIB/sys_resp.for
c   mar 14 jh          : bugs with new implemention of T and C indicators
c                        chaekc if A is used for accelerometer
c   mar 21             : error message if missing tabulated file
c   oct 7, 1998        : ------------   verison 7.0 check------------------
c                        5 letter station, year 2000
c   nov 5 98 jh        : remove computer dependence, system-c to systemc
c   sep 7,99 lo        : fix output of filename on Linux
c   oct 1, 99 lo       : add a write statement
c   mar 19, 00 lo      : add paz output for seismometer and filters
c   may 00  jh         : get right order of lat an dlon, thanks mario
c   sep 18 lo          : fix linux bug, init variables
c   oct 04 lo          : set gsesei.def comp code fore GSE
c   nov  1 lo          : change format of GSE output from 2.1 to 2.0
c   nov  2 lo          : some smaller changes in GSE out part
c   nov  3 lo          : changed GSE response
c   jan 3  2001 jh     : check component name, redo option, check equation
c                        again, some comments.
c   jan 24             : fix so seisan output works if combined response of
c                        paz an dparameters, fix seisan output of paz combined
c                        with input file of paz, only input file paz was written
c                        out, sligh change in parameter output format to 
c                        accomodate negative gain constants
c   july 13            : add gse description, and changed calib in CAL2 line
c   jun 8 2004 jh      : small cahnge in format for recalculation
c   may 24 2005 lo     : some changes, added gse fir
c   jan 11 2005 jh     : in seisan format, was writing out double number 
c                        of poles and zeros !!!

C
      IMPLICIT NONE
      include 'libsei.inc'
C
C   VARIABLES
C
C   COMPLEX RESPONSE OF SYSTEM FOR NF VALUES
      COMPLEX RESPON(61)
      INTEGER NF
C   FIRST AND LAST FREQUENCY TO USE
      REAL F1,F2
C   REAL AMPLITUDE AND PHASE VALUES, GAIN AT 1HZ, LOG OF AMP
      REAL AMP(61),PHASE(61), AMP1HZ, LAMP(61)
C   MANUAL ENTERED FREQUENCIES, AMPLITUDE AND PHASE VALUES 
C   FOR MNF VALUES
      REAL MF(61),MAMP(61),MPHASE(61)
      INTEGER MNF
C   FILE NAME OF MANUAL ENTERED VALUES
      CHARACTER*20 MANFIL 
C   Seisan FILE NAME
      CHARACTER*40 FILE
      CHARACTER*80 TEXT  ! GENERAL TEXT
      CHARACTER*96 GSETEXT
      INTEGER CODE       ! ERROR RETURN
C   DATE AND TIME
      INTEGER IYR,IDOY,IMON,IDY,IHR,IMIN,ISEC
      REAL SEC
C   LATITUDE,LONGITUDE AND ELEVATION
      REAL ALAT,ALON
      INTEGER IELEV
C   STATION AND COMPONENT
      CHARACTER STA*5,COMP*4
C   COMMENT FOR SEISAN RESPONSE FILE
      CHARACTER*80 COMMENT
C   FREQUENCIES FOR CALCULATIONS, LOG OF F
      REAL F(61),LF(61)
C   NUMBER OF FILTERS,  POLES,AND FREQUENCIES
      INTEGER NFILT,POLE(10)
      REAL FFILT(10),FC
C   AMPLIFIER GAIN (DB), SEISMOMETER GENERATOR CONSTANT (LOADED V/M/S)
      REAL GAIN,GENCON
C   SEISMOMETER OR ACCELEROMETER DAMPING RATIO AND SEISMOMETER PERIOD
      REAL DAMPIN,PERIOD
C   SEISMOMETER NATURAL ANG FREQUENCY
      real omega0
C   RECORDING MEDIA GAIN (COUNTS/V OR M/VOLT)
      REAL REGAIN
C   FLAG FOR TYPE OF SENSOR 0: NONE 1: SEISMOMETER 2: ACCELEROMETER
      INTEGER SENTYP
C   SEISAN HEADER
      CHARACTER*1040 HEADER
c   equivalent to header
      character*80 chead(13)
C   FLAG FOR TYPE OF RESPONSE 1: DISPLACEMENT, 2: VELOCITY, 3: ACCELER.
      INTEGER RESTYP
C OUTPUT TYPE
      INTEGER OUTTYP
C   TEXT FOR RESPONSE AND SENSOR TYPE
      CHARACTER*15 RESTXT(3),SENTXT(3)
C   RESPONSE CURVE CORRECTION EXPONENT
      INTEGER RESCOR
C   PLOT TEXT
      CHARACTER*8 YTEXT
      CHARACTER*6 XTEXT
C   CONSTANT
      REAL PI
C   HELP VARIABLES
      COMPLEX CX,FACTOR
      REAL X,Y
      DOUBLE PRECISION XL
      CHARACTER*1 ANSWER
      INTEGER I,J,K,I1,I2,I3,I4,I5,I6,J1,J2,LINE
c   FLAG IF PAZ CHOSEN
      logical paz
c   flag true if gse
      logical gse
      logical recal                     ! true if recalculation
      character*80 deffile              ! text
      character*29 mainhead_text
      character*5 net_code              ! network code
      logical no_net                    ! flag if net_code set
c
c gse response
c
      real gse_dig2_samprat     ! digitizer sample rate
      real gse_rate             ! combined sample rate
      real gse_dig2_sensitivity ! digitizer sensitivity (counts/input)
      real gse_paz2_sfactor     ! paz scale factor
      real gse_cal2_calib       ! total calibration of all stages
      character*25 gse_dig2_description  ! digitizer model
      character*6 gse_cal2_instype       ! seismometer type
      integer gse_stage
c
c  for tabulated input
c
      integer nresp        ! number of tabulated input values
      real freq_val(300),gain_val(300),phas_val(300) ! freq, amp and phase
      real normtab         ! normalization constant for tabulated input
c
c   for poles and zeros
c
      real ppr(1000),ppi(1000)   ! poles,  real and im.
      real pzr(1000),pzi(1000)   ! zeros, real and im.
      complex pol(500),zero(500) ! complex poles and zeros
      integer npol,nzero        ! number of poles and zeros
      integer nfir(20)          ! number of fir
      integer fir_deci(20)      ! decimation in fir stage
      character*1 fir_sym(20)   ! symmetry  flag
      real fir_rate(20)         ! decimation in fir stage
      real normalize_fir        ! return normalisation constant
      real delay_fir
      character*1 sym_fir       ! return symmetry flag
      integer nfirstage         ! number of fir filter stages
      double precision fir(20,10000) ! fir filter coeffs 
      double precision rfir(10000)
      double precision fir_sum
      real w                    ! weight for filter poles
      complex cw                ! ---------- complex
      real norm                 ! normalization constant for poles and zeros
      complex presp             ! complex response from poles and zeros
      character*80 filepole     ! file with poles and zeros 
      character*80 filetab      ! file with poles and zeros 
      character*80 filefir      ! file with fir coeff 
      integer seiclen           ! routine to get length of string
c
      equivalence (header,chead)
      common /resp/npol,nzero,ppr,ppi,pzr,pzi,pol,zero,norm
      DATA PI/3.141592654/


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   initialize
c
      sta=' '
      iyr=0


C
C   TEXT FOR OPTIONS
C
      SENTXT(1)='NO SENSOR      '
      SENTXT(2)='SEISMOMETER    '
      SENTXT(3)='ACCELEROMETER  '
      RESTXT(1)='DISPLACEMENT   '
      RESTXT(2)='VELOCITY       '
      RESTXT(3)='ACCELERATION   '      
      npol=0
      nzero=0
      norm=1.
      period=0.
      dampin=0.
      gencon=0.
      gain=0.
      regain=0.
      gse_dig2_samprat=0.
      gse_dig2_sensitivity=1.
      amp1hz=0.
      do i=1,7
        ffilt(i)=0.
        pole(i)=0.
      enddo
C
C   FREQUENCIES FOR CALCULATION, ROUND OFF VALUES
C
      NF=60
      F1=0.005
      F2=100.0
      DO 5 I=1,NF
         X=ALOG10(F1)+(I-1)*(ALOG10(F2)-ALOG10(F1))/(NF-1)
         F(I)=10**X
         if(f(i).le.0.01.and.f(i).gt.0.001) k=10000
         IF(F(I).LE.0.1.AND.F(I).GT.0.01) K=1000
         IF(F(I).LE.1.0.AND.F(I).GT.0.1) K=100
         IF(F(I).LE.10.0.AND.F(I).GT.1.0) K=10
         IF(F(I).GE.10.0) K=1
         J=F(I)*K+0.5
         F(I)=J/FLOAT(K)          
 5    CONTINUE
C
C   PUT 1 HZ RESPONSE IN NUMBER 61
C
      F(61)=1.0
      NF=61
C
C   ENTER OUTPUT FORMAT
C
      paz=.false.
      gse=.false.
      write(6,*) ' RESP - PROGRAM TO CREATE RESPONSE FILES IN SEISAN'
      write(6,*) '        OR GSE FORMAT. THE RESPONSE CAN BE CREATED'
      write(6,*) '        AS POLES AND ZEROS (PAZ) OR FREQUENCY'
      write(6,*) '        AMPLITUDE AND PHASE (FAP). THE SAME' 
      write(6,*) '        TRANSFER FUNCTION AND FILTERS ARE USED'
      write(6,*) '        IN BOTH CASES.'
      write(6,*)
      write(6,*) ' CHOSE OUTPUT FORMAT: 0: NO OUTPUT FILE '
      write(6,*) '                      1: SEISAN FAP '
      write(6,*) '                      2: SEISAN PAZ '
      write(6,*) '                      3: GSE2 FAP '
      write(6,*) '                      4: GSE2 PAZ '
      read(5,*) outtyp
      if (outtyp.eq.3.or.outtyp.eq.4) gse=.true.
      if (outtyp.eq.2.or.outtyp.eq.4) paz=.true.

C
C   ENTER INPUT PARAMETERS FROM KEYBOARD
C
      WRITE(6,*)' TYPE OF SENSOR:       1: NONE '
      WRITE(6,*)'                       2: SEISMOMETER '
      WRITE(6,*)'                       3: ACCELEROMETER '
      READ(5,*) SENTYP
C
C   SENSOR PARAMETERS
C
      GENCON=1.
      IF(SENTYP.EQ.2) THEN
         WRITE(6,*)' SEISMOMETER NATURAL PERIOD ? '
         READ(5,*) PERIOD
         WRITE(6,*)' SEISMOMETER DAMPING RATIO ? '
         READ(5,*) DAMPIN
      ENDIF
      IF(SENTYP.EQ.2.OR.SENTYP.EQ.3) THEN
         WRITE(6,*) 
     *   ' SENSOR LOADED GENERATOR CONSTANT (V/M/S OR V/G) ? '
         READ(5,*) GENCON
      ENDIF
C
C INSTRUMENT TYPE IF GSE ONLY
C
      gse_cal2_instype=' '
      if (gse.and.SENTYP.ne.1) then
        write(*,*) '  INSTRUMENT TYPE FROM LIST BELOW'
        write(*,*)
        write(*,*) 
     &  '  Akashi, 23900, BB-13V, CMG-3, CMG-3N, CMG-3T, CMG-3E, '
        write(*,*) 
     &  '  FBA-23, GS-13, GS-21, KS3600, KS360i, KS5400, MK II, '
        write(*,*) 
     &  '  Oki, Parus2, S-13, S-500, STS-1, STS-2, TSJ-1e '
        write(*,*) ' CHOICE '
        read(5,'(a)') gse_cal2_instype
      endif

C
C   RECORDING MEDIA GAIN
C
      WRITE(6,*)' RECORDING MEDIA GAIN (COUNT/V OR M/V) ? '
      READ(5,*) REGAIN
      if (gse) then
        write(*,*) ' DIGITIZER SAMPLE RATE '
     &           //'(BEFORE POSSIBLE FIR FILTER)'
        read(5,*) gse_dig2_samprat
        gse_rate=gse_dig2_samprat
        write(*,*) ' DIGITIZER MODEL '
        read(5,'(a)') gse_dig2_description
      endif
C
C   AMPLIFIER PARAMETERS
C
      WRITE(6,*)' AMPLIFIER GAIN (DB) ? '
      READ(5,*) GAIN
      WRITE(6,*) ' NUMBER OF FILTERS (0-10), RETURN FOR NONE ? '
      READ(5,'(a)') TEXT
      IF(TEXT(1:2).EQ.'  ') THEN
         NFILT=0
      ELSE
         CALL SEI GET VALUES(1,TEXT,CODE)
         NFILT=ARRAY$(1)
      ENDIF
      IF(NFILT.GT.0) THEN
         WRITE(6,*)' FREQUENCY AND NUMBER OF POLES FOR EACH FILTER,'
         WRITE(6,*)' POLES NEGATIVE FOR HIGH PASS '
         DO 10, I=1,NFILT
            READ(5,*) FFILT(I),POLE(I)
 10      CONTINUE
      ENDIF
C
C   TYPE OF RESPONSE IF SENSOR IS USED
C
      RESTYP=1
      RESCOR=0
      IF(SENTYP.GT.1) THEN
         if (.not.paz) then
           WRITE(6,*)' TYPE OF RESPONSE: 1: DISPLACEMENT'
           WRITE(6,*)'                   2: VELOCITY'
           WRITE(6,*)'                   3: ACCELERATION '
           WRITE(6,*)' NOTE: CHOOSE DISPLACEMENT IF YOU ARE '//
     &               'CREATING SEISAN RESPONSE FILE'
           READ(5,*) RESTYP
C
C   CALCULATE EXPONENT FOR RESPONSE TYPE CORRECTION
C        
           IF(SENTYP.EQ.2) RESCOR=RESTYP-1
           IF(SENTYP.EQ.3) RESCOR=RESTYP-3
         endif
      ENDIF
c
c   file name of file with poles and zeros or tabulated values,
c   can multiply with
c   existing curve or use alone
c
         nresp=0
         goto 544
 444     CONTINUE
         write(6,*)' No such file'
 544     continue
         WRITE(6,*) ' FILE NAME FOR FILE WITH POLES AND ZEROS,',
     *   ' RETURN FOR NO FILE'
         READ(5,'(A)') FILEPOLE
         IF(FILEPOLE(1:2).NE.'    ') THEN
            OPEN(20,FILE=FILEPOLE,STATUS='OLD',ERR=444)
            CALL READ_POLES                 ! read poles and zeros
            write(6,*)' ',npol+nzero,' poles and zeros'
            close(20)
         endif
c
c   tabulated values
c
         goto 545
 445     CONTINUE
         write(6,*) 'No such file'
 545     continue
         FILETAB = '  '
         if (.not.paz) then
           WRITE(6,*) ' FILE NAME FOR TABULATED VALUES,',
     *       ' RETURN FOR NO FILE'
           READ(5,'(A)') FILETAB
         endif
         IF(FILETAB(1:2).NE.'    ') THEN
            OPEN(20,FILE=FILETAB,STATUS='OLD',ERR=445)
            read(20,*) nresp,normtab
            write(6,*) ' ',nresp,' tabulated values'
            do i=1,nresp                    ! read tabulated values
               read(20,*) freq_val(i),gain_val(i),phas_val(i)
            enddo
            close(20)
         endif
c
c FIR FILTERS IF FORMAT IS GSE
c
      nfirstage=0
      if (gse) then
        write(*,*) ' NUMBER OF FIR FILTER STAGES '
        read(5,*) nfirstage
        do i=1,nfirstage
          goto 546
 446      CONTINUE
          write(6,*) 'No such file'
 546      continue
          FILEFIR = '  '
          WRITE(6,*) ' FILE NAME FOR FIR COEFFICIENTS,',
     *        ' RETURN FOR NO FILE'
          READ(5,'(A)') FILEFIR
          write(*,*) ' DECIMATION, FIR STAGE ',i
          read(5,*) fir_deci(i)
          write(*,*) ' FIR FILTER SYMMETRY (A=asymetric, ' //
     &               'B=symetric (odd) '//
     &               'C=symetric (even) '
          read(5,*) fir_sym(i)
          IF(FILEFIR(1:2).NE.'    ') THEN
             OPEN(20,FILE=FILEFIR,STATUS='OLD',ERR=446)
               nfir(i)=0
               fir_sum=0.
 547           CONTINUE
               read(20,*,end=548) xl
               nfir(i)=nfir(i)+1
               fir(i,nfir(i))=xl
               fir_sum=fir_sum+xl
c               write(55,*) nfir(i),xl
               GOTO 547
 548           CONTINUE
             close(20)
             if (fir_sym(i).eq.'B') then
               do k=1,nfir(i)-1
                 fir_sum=fir_sum+fir(i,k)
               enddo
             elseif (fir_sym(i).eq.'C') then
               do k=1,nfir(i)
                 fir_sum=fir_sum+fir(i,k)
               enddo
             endif
c
c normalise
c
             do k=1,nfir(i)
               fir(i,k)=fir(i,k)/fir_sum
             enddo
             write(*,*) ' stage ',i,
     &           ' number of fir coefficients ',nfir(i)
          endif
c          write(*,*) ' SAMPLE RATE AT INPUT TO FIR FILTER, '
c     &     //'FIR STAGE ',i
c          read(5,*) fir_rate(i)
          if (i.eq.1) then
            fir_rate(i)=gse_dig2_samprat
          else
            fir_rate(i)=fir_rate(i-1)/fir_deci(i-1)
          endif
          write(*,*) ' input sample rate ',fir_rate(i)
          write(*,*) ' output sample rate ',fir_rate(i)/fir_deci(i)
          if (i.eq.nfirstage) gse_rate=fir_rate(i)/fir_deci(i)
        enddo
      endif
c
c-------------------------------------------------------
c   enter here for recalculation from end of program
c--------------------------------------------------------
c
 2000 continue

      nf=61  ! to get 1 hz again if recal
C
C   NOW READY FOR CALCULATIONS, FIRST CALCULATE CONSTANT FACTORS  
C
      FACTOR=1.0
C
C  AMP GAIN AND RECORDING MEDIA GAIN
C
      FACTOR=FACTOR*10**(GAIN/20.0)*REGAIN
C
C  SEISMOMETER IF ANY
C
      if (.NOT.PAZ) then
        IF(SENTYP.EQ.2) THEN
           FACTOR=FACTOR*GENCON
c          FACTOR=FACTOR*PI*(0.0,2.0)*GENCON*(-1.0)*PERIOD**2 ! before mar 2000
        ENDIF
C
C  ACCELEROMETER IF ANY, DO CONVERSION OF G TO M/SS
C
        IF(SENTYP.EQ.3) FACTOR=FACTOR*GENCON/9.81
      endif
C
C response in PAZ
C
      if (paz) then
        omega0=2.*PI/period
c
c norm in Counts/m
c
        norm=norm*10**(GAIN/20.0)*REGAIN
        gse_dig2_sensitivity = 1.*10**(GAIN/20.0)*REGAIN
        if (sentyp.eq.2) then
c          norm=norm*GENCON*2.*PI*period**2
          norm=norm*GENCON
          gse_paz2_sfactor= GENCON / 1E9     ! c/m -> c/nm
          ppr(npol+1)=-dampin*omega0
          ppi(npol+1)=sqrt(1.-dampin**2)*omega0
          pol(npol+1)=cmplx(ppr(npol+1),ppi(npol+1))
          ppr(npol+2)=-dampin*omega0
          ppi(npol+2)=-sqrt(1.-dampin**2)*omega0
          pol(npol+2)=cmplx(ppr(npol+2),ppi(npol+2))
          npol=npol+2
          zero(nzero+1)=cmplx(0.,0.)
          zero(nzero+2)=cmplx(0.,0.)
          zero(nzero+3)=cmplx(0.,0.)
          nzero=nzero+3
        elseif (sentyp.eq.3) then
          norm=norm*GENCON/9.81
          gse_paz2_sfactor=GENCON/9.81 / 1E9     ! c/m -> c/nm
          zero(nzero+1)=cmplx(0.,0.)
          zero(nzero+2)=cmplx(0.,0.)
          nzero=nzero+2
        elseif (sentyp.eq.1) then
          gse_paz2_sfactor=1.
        endif
c
c get poles and zeros for Butterworth filters, same as routine 
c bworth, but gives paz instead of the transfer function
c
c    the formulas used -- 
c
c    lowpass:      h(s)=1/(s-s1)(s-s2)...(s-sk)
c    where poles   sk=omega0*exp(i*pi*(1/2+((2*k-1)/(2*np))))
c                                   k=1,2, ... number of poles
c                  s = i omega
c                  norm = norm * omega0
c    highpass:     h(s)=z**k/(s-s1)(s-s2) ....
c    where poles   sk=omega0/exp ...
c

        if (nfilt.gt.0) then
          do i=1,nfilt
            fc=ffilt(i)*2*PI 
            k=iabs(pole(i))
            do j=1,abs(pole(i))
              w=PI*(0.5+((2.*float(j)-1.)/(2.*float(k))))
              cw=cmplx(0.,w)
c
c lowpass
c
              if (pole(i).gt.0) then
                norm=norm*fc
                gse_paz2_sfactor = gse_paz2_sfactor*fc
                pol(npol+1)=fc*cexp(cw)
                npol=npol+1 
c
c highpass
c
              else
                 pol(npol+1)=fc/cexp(cw)
                 npol=npol+1 
                 zero(nzero+1)=cmplx(0.,0.)
                 nzero=nzero+1
               endif
            enddo         
          enddo
        endif
      endif
C
C  ENTER LOOP OF NF PREDEFINED FREQUENCES TO CALCULTE REPONSE
C  INITIALLY DISPLACEMENT FOR SEISMOMETER AND ACCELERATION FOR
C  ACCELEROMETER
C   
      DO 100 I=1,NF
C
         if (.not.paz) then
C
C   SEISMOMETER
c
c                                  REGAIN[V/m/s] * GENCON * s^3
c T(s)= preamplification *  ----------------------------------------------
c                                 s^2 + 2*h*omega0*s + omega0^2
c
c   T(j omega) = T(s) for s -> j omega
c


C           RESPON(I)=FACTOR         ! before mar 00
 
           IF(SENTYP.EQ.1) THEN
             RESPON(I)=FACTOR
           ELSEIF(SENTYP.EQ.2) THEN
C
C CLEANED UP IN MARCH 2000 lo
C
              X=PERIOD*F(I)
              RESPON(I)=FACTOR*(0.,2.)*PI*PERIOD**2*(-1.)*F(I)**3
     &                      /(1.+(0.,2.)*DAMPIN*X-X*X)
c
c  this is the same as:
c
c                          - i * (om)**3
c         RESPON(om) = ---------------------------
c                       om0**2 - om**2 +2*h*om*om0
c
c  where om=2*pi*f, om0 = 2*pi*f0,  f=/T, f0=1/T0
c
c  the minus sign in the nominator comes from the generator constant
c  or, if polarity has put so, is there to make sure a positive pilse gives
c  a positive first motion
c

C RESPON(I)=RESPON(I)*F(I)**3/(1.+(0.,2.)*DAMPIN*X-X*X) ! before aug96
c RESPON(I)=RESPON(I)*F(I)**3/(1.-(0.,2.)*DAMPIN*X-X*X) ! until mar 00

           ELSEIF (SENTYP.EQ.3) THEN
             RESPON(I)=FACTOR
           ENDIF
C
C   FILTERS
C
           IF(NFILT.GT.0) THEN
              DO 20, J=1,NFILT
                 CALL BWORTH(F(I),FFILT(J),POLE(J),CX)
                 RESPON(I)=RESPON(I)*CX
 20           CONTINUE
           ENDIF
         endif
C
C   MULTIPLY WITH ANOTHER RESPONSE CURVE WHICH CAN BE POLES AND ZERO'S
C   if available, if only paz used, that is all which is done, if paz
c   are additional to fap, multiply with earlier fap values
C

        if(npol.ne.0.or.nzero.ne.0) then
           call pazresp (f(i), norm, nzero, zero,
     $     npol, pol,presp)
           if (.not.paz) then     ! fap
              respon(i)=respon(i)*presp
           else
              respon(i)=presp     ! paz
           endif
        else
           if (paz) then
             respon(i)=norm
           endif
        endif
c
c   interpolate in tabulated values
c
        if(nresp.gt.2) then
           call inter_p(nresp,normtab,
     *     freq_val,gain_val,phas_val,f(i),presp)                                       
           respon(i)=respon(i)*presp
        endif

C
C   COMPLEX RESPONSE FINISHED, CALCULATE REAL RESPONSE
C   TAKING INTO CONSIDERATION THE TYPE OF RESPONSE WANTED
C        
         AMP(I)=CABS(RESPON(I))/((2*PI*F(I))**RESCOR)
         X=AIMAG(RESPON(I))
         Y=REAL(RESPON(I))
         IF(Y.EQ.0.0) THEN
            PHASE(I)=0.0
         ELSE
            PHASE(I)=(ATAN2(X,Y)-(PI/2.0)*RESCOR)*(180./PI)
         ENDIF
 100  CONTINUE
C
C  FINISHED RESPONSE CALCULATION. NORMALIZE TO 1.0 AT 1 HZ
C  AND SAVE 1HZ VALUE
C
      AMP1HZ=AMP(61)
C
C   FINISHED WITH 1 HZ, NF BACK TO 60
C
      NF=60
      DO 110 I=1,NF
         AMP(I)=AMP(I)/AMP1HZ
 110  CONTINUE
C
C   CHECK IF MANUAL POINTS SHOULD BE USED FOR COMPARISON
C
      if(.not.recal) then
         WRITE(6,*)
     *   ' FILE NAME FOR MEASURED VALUES, RETURN FOR NO FILE '
         READ(5,'(A20)') MANFIL
         MNF=0
         IF(MANFIL.NE.'                    ') THEN
            OPEN(3,FILE=MANFIL,STATUS='OLD')
            I=1
 30         CONTINUE
            READ(3,*,END=40)MF(I),MAMP(I),MPHASE(I)
            I=I+1
            GOTO 30
 40         CONTINUE
            MNF=I-1
            WRITE(6,*) MNF,' VALUES READ IN'
         ENDIF
      endif
C
C   OUTPUT IN FILE
C
      OPEN(2,FILE='resp.out',STATUS='UNKNOWN')
      WRITE(2,220)SENTXT(SENTYP),RESTXT(RESTYP)
 220  FORMAT('  SENSOR TYPE: ',A15,3X,'RESPONSE: ',A15) 
      WRITE(2,*)' SEISMOMETER PERIOD=', PERIOD
      WRITE(2,*)' GENERATOR CONSTANT=', GENCON
      WRITE(2,*)' DAMPING RATIO     =', DAMPIN
      WRITE(2,*)' AMPLIFIER GAIN(DB)=', GAIN
      WRITE(2,*)' RECORDING GAIN=    ', REGAIN
      IF(FILEPOLE(1:3).NE.'   ') 
     *write(2,'(a,a)') 
     *'  FILE WITH POLES AND ZEROS: ',FILEPOLE
      IF(FILETAB(1:3).NE.'   ') 
     *write(2,'(a,a)') 
     *'  FILE WITH TABULATED VALUES: ',FILETAB
      IF(NFILT.GE.1) THEN
         WRITE(2,*)' FILTER CONSTANTS' 
         WRITE(2,200) (FFILT(I),POLE(I),I=1,NFILT)
 200     FORMAT(1X,' F=',F6.2,3X,'POLES=',I3)
      ENDIF
      WRITE(2,*)' GAIN AT 1 HZ=      ', AMP1HZ
      WRITE(2,*) 
      WRITE(2,201)(F(I),1.0/F(I),AMP(I),
     *20*ALOG10(AMP(I)),PHASE(I),I=1,NF)
 201  FORMAT
     *(1X,'F=',F8.4,3X,'T=',F8.2,3X,' AMP=',F14.6,3X,
     *' AMPDB=',F6.1,3X,' PHAS=',F8.1)
C
C   FINISHED, TAKE LOG BEFORE PLOTTING
C
       DO 130 I=1,NF
         LAMP(I)=ALOG10(AMP(I))
         LF(I)=ALOG10(F(I))
 130  CONTINUE
      DO 135 I=1,MNF
         MAMP(I)=ALOG10(MAMP(I))
         MF(I)=ALOG10(MF(I))
 135  CONTINUE
C
C   PLOT AMPLITUDE RESPONSE
C
      WRITE(6,*)     
      XTEXT='FREQ  '
      YTEXT='AMPL    '  
      WRITE(6,221) SENTXT(SENTYP),RESTXT(RESTYP)
 221  FORMAT(12X,' AMPLITUDE RESPONSE',3X,A15,3X,A15) 
      CALL PLOTW(MNF,NF,MF,MAMP,LF,LAMP,XTEXT,YTEXT,1,1)
      WRITE(6,'(a,G10.3,2x,a,$)')' GAIN FACTOR AT 1 HZ:',AMP1HZ,
     *'   RETURN FOR PHASE RESPONSE'
      READ(5,'(A)') X 
C
C   PLOT PHASE RESPONSE                   
C
      YTEXT='PHAS DEG'
      WRITE(6,222) SENTXT(SENTYP),RESTXT(RESTYP)
 222  FORMAT(12X,' PHASE RESPONSE',3X,A15,3X,A15) 

      CALL PLOTW(MNF,NF,MF,MPHASE,LF,PHASE,XTEXT,YTEXT,1,0)
c
C----------------------------------------------------------------
C  OPTION FOR SEISAN RESPONSE  FILE
C-----------------------------------------------------------------
c
      if (outtyp.eq.0) then
        WRITE(6,*) ' RESPONSE CURVE IS IN FILE resp.out'
        write(6,*) ' NO CALIBRATION FILE CREATED '
        stop
      endif
      if (outtyp.eq.1.or.outtyp.eq.2) then
        WRITE(6,'(a,$)')' SEISAN RESPONSE FILE (Y/N=default)?'
      else
        WRITE(6,'(a,$)')' GSE RESPONSE FILE (Y/N=default)?'
      endif
        
      READ(5,'(a1)') ANSWER
      IF(ANSWER.NE.'Y'.and.ANSWER.NE.'y') GOTO 999
C
C   MUST BE DISPLACEMENT, CHECK
C
      IF(RESTYP.NE.1) THEN
         WRITE(6,*)' RESPONSE TYPE MUST BE DISPLACMENT'
         GOTO 999
      ENDIF

c
c  questions, skip if recal unless parameter not given previously
c
      if(recal.and.sta.ne.' '.and.iyr.ne.0) goto 3000
c
      print*,'Enter station code. e.g. BERGE, max 5 chars '
      read(5,'(a)')sta
 666  continue
      print*,'Enter component (4 chars) e.g. SL Z'
      print*,'  First character is type, must be one of the following: '
      print*,'  S: Short period, L: Long period'
      print*,'  B: Broad band,   A: Accelerometer'
      print*,'Last character must be Z,N or E'
      print*,'Character 2 and 3 can be anything'
      read(5,'(a4)')comp
      if( comp(1:1).ne.'S'.and.comp(1:1).ne.'L'.and.comp(1:1).ne.'B'.
     *and.comp(1:1).ne.'A'.and.comp(4:4).ne.'N'.and.comp(4:4).ne.'E'.
     *and.comp(4:4).ne.'Z') then
        write(6,*)' Wrong component, redo'
        goto 666
      endif
c
      if(sentyp.eq.3.and.comp(1:1).ne.'A') then
         comp(1:1)='A'
         write(6,*)
     *' Sensor is an accelerometer, first letter of component must be A'
         write(6,'(a,a)') ' Component changed to ',comp
      endif
      write(6,'(1x,a,a,$)')
     *'Enter date as YYYYMMDDHHMMSS, at least up to the day ',
     *' (e.g. 19880123):'
      read(5,'(i4,5i2)')iyr,imon,idy,ihr,imin,isec
      sec=float(isec)
c
c   get doy
c
      call date_doy(idoy,idy,imon,iyr)
      ielev=-999
      alat=999
      alon=999
c
c get some input, SEISAN
c
      if (outtyp.eq.1.or.outtyp.eq.2) then
        write(6,'(1x,a,a,$)')'Latitude (Up to 4 ',
     *'decimal places and - for south), return for none:'
        read(5,'(a)') text
        if(text(1:2).ne.'  ') then
           call sei get values(1,text,code)
           alat=array$(1)
        endif
        write(6,'(1x,a,a,$)')'Longitude (Up to 4 ',
     *'decimal places and - for west), return for none:'
        read(5,'(a)') text
        if(text(1:2).ne.'  ') then
           call sei get values(1,text,code)
           alon=array$(1)
        endif
        write(6,'(1x,a,a,$)')'Enter elevation in meters (integer), ',
     *'return for none:'
        read(5,'(a)') text
        if(text(1:2).ne.'  ') then
           call sei get values(1,text,code)
           ielev=array$(1)
        endif
        write(6,*)'Enter comments, one line. e.g. amp type, sensor type',
     *' return for none'
        read(5,'(a80)') comment
      endif
c
c   enter here if question skipped for recal, just above
c
 3000 continue
c
c
c   make file name
c
      file=' '
      file(1:5)=sta(1:5)
      file(6:9)=comp(1:4)
      do i=1,9
        if(file(i:i).eq.' '.or.file(i:i).eq.char(0)) file(i:i)='_'
      enddo
      file(10:10)='.'
      write(file(11:25),150)iyr,imon,idy,ihr,imin
 150  format(i4,'-',i2,'-',i2,'-',2i2)

      if (outtyp.eq.1.or.outtyp.eq.2) then
        file(26:29)='_SEI'
      elseif (gse) then
        file(26:29)='_GSE'
      endif
      do i=11,25
        if(file(i:i).eq.' ') file(i:i)='0'
      enddo
c
      open(4,file=file(1:seiclen(file)),status='unknown')


      if (outtyp.eq.1.or.outtyp.eq.2) then
c
C--------------------------------------------------------------
C   SEISAN RESPONSE FILE
C--------------------------------------------------------------
c
      do 64 i=1,1040
         header(i:i)=' '
 64   continue

C  
C   CONSTANTS
C
c   indicator TC for force use of tabulated values if:
c   1. combined response of poles and zeros and parameters, fab wanted
c   2. combined rersponse with tabulated values
c   3. number of poles and zero larger than 37 since not enough room in format
c

      if(((npol+nzero).gt.0.and.(gencon.gt.0.0.or.nfilt.ne.0.
     *or.regain.ne.1.0.or.gain.ne.0).and..not.paz).
     *or.nresp.gt.0.or.(npol+nzero).gt.37) header(78:79)='TC'

c
      WRITE(HEADER(161:240),'(f8.3,f8.4,f8.1,f8.1,
     *2G8.3,2(g8.3,f8.3))')
     *PERIOD,DAMPIN,GENCON,GAIN,REGAIN,AMP1HZ,
     *FFILT(1),FLOAT(POLE(1)),FFILT(2),FLOAT(POLE(2))
      WRITE(HEADER(241:320),'(5(G8.3,f8.2))')(FFILT(I),
     *FLOAT(POLE(I)),I=3,7)   
C
C  RESPONSE VALUES
C
        do 60 i=1,3
          j1=(i-1)*20 + 1
          j2=j1+19
          i1=320+(i-1)*240+1
          i2=i1+79
          i3=400+(i-1)*240+1
          i4=i3+79
          i5=480+(i-1)*240+1
          i6=i5+79
          write(header(i1:i2),'(10g8.3)')(f(j),j=j1,j2,2)
          write(header(i3:i4),'(10g8.3)')(amp(j),j=j1,j2,2)
          write(header(i5:i6),'(10f8.3)')(phase(j),j=j1,j2,2)
 60     continue
c
c   if only poles and zeros are given and less than 38 together, 
c   use that instead of table values, indicate with P. If combined
c   response has been calculated, do not use poles and zeros.
c
        if(header(79:79).eq.' '.and.paz.and.(npol+nzero).lt.38) then
         header(78:78)='P'   ! indicate poles and zeros
         do i=161,1040
            header(i:i)=' '
         enddo
         write(header(161:182),'(1x,2i5,g11.4)') npol,nzero,norm
         k=23
         line=3
c        do i=1,npol*2
         do i=1,npol          !jh jan 06
c           write(chead(line)(k:k+10),'(g11.4)') ppr(i)
            write(chead(line)(k:k+10),'(g11.4)') real(pol(i))
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
c           write(chead(line)(k:k+10),'(g11.4)') ppi(i)
            write(chead(line)(k:k+10),'(g11.4)') aimag(pol(i))
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
         enddo
c        do i=1,nzero*2
         do i=1,nzero     ! jh jan 06
c           write(chead(line)(k:k+10),'(g11.4)') pzr(i)
            write(chead(line)(k:k+10),'(g11.4)') real(zero(i)) 
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
c           write(chead(line)(k:k+10),'(g11.4)') pzi(i)
            write(chead(line)(k:k+10),'(g11.4)') aimag(zero(i))
            k=k+11
            if(k.eq.78) then
              k=1
              line=line+1
            endif
         enddo
      endif

c
c  put in header, first blank
c
      header(1:5)=sta(1:5)
      header(6:9)=comp(1:4)
      if(alat.ne.999.) write(header(52:59),'(f8.4)')alat
      if(alon.ne.999.) write(header(61:69),'(f9.4,i5)')alon
      if(ielev.ne.-999)write(header(71:75),'(i5)')ielev
      k=iyr-1900 ! century info in 3 digits
      write(header(10:35),'(i3,1x,i3,4(1x,i2),1x,f6.3)')k,idoy,
     *imon,idy,ihr,imin,sec
      write(header(81:160),'(a80)')comment(1:80)
c
c   write out
c     
      do 70, i=1,13
        j=(i-1)*80+1
        write(4,'(a80)')header(j:j+79)   
 70   continue      

c
c write GSE2 output
c

c
c PAZ
c    
      elseif (gse) then

c
c   get def file for station codes, give file name
c
        deffile='gsesei.def'
        no_net = .FALSE.
        net_code=' '
        call read_def_chan(deffile,mainhead_text,net_code)
        gse_stage=1

c
c header line, CAL2 
c 
        gsetext(1:96)='                                        '
     &// '                                                        '
        gsetext(1:4)='CAL2'
        gsetext(6:10)=sta(1:5)

c
c convert component to GSE
c
        call set_def_chan(1,sta,comp)
        if (seiclen(comp).gt.3) then
          gsetext(12:13)=comp(1:2)
          gsetext(14:14)=comp(4:4)
        else
          gsetext(12:14)=comp(1:3)
        endif
        gsetext(21:26)=gse_cal2_instype

        if (outtyp.eq.3) then
c         write(gsetext(28:42),'(e10.2)') 1e9/amp1hz        ! GSE2.1
          write(gsetext(28:37),'(e10.2)') 1e9/amp1hz        
        else
c         write(gsetext(28:42),'(e10.2)') 1.                ! GSE2.1
c
c product of all stage scaling factors, in nm/count
c
          write(gsetext(28:37),'(e10.2)') 1e9/amp1hz        
c changed lo, july 13, 2001
c          write(gsetext(28:37),'(e10.2)') 
c     &           1/(gse_paz2_sfactor*gse_dig2_sensitivity)
        endif
        write(gsetext(44:45),'(a2)') '1.'
c sample rate, added lo July 13, 2001
        write(gsetext(47:56),'(f10.5)') gse_rate

        write(gsetext(58:67),'(i4.4,a1,i2.2,a1,i2.2)') 
     &       iyr,'/',imon,'/',idy
        write(gsetext(69:73),'(i2.2,a1,i2.2)') ihr,':',imin

        write(4,'(a96)') gsetext
c
c paz line, stage 1
c

        gsetext(1:96)='                                        '
     &// '                                                        '
        if (outtyp.eq.3) then
          gsetext(1:6)='FAP2  '
          gsetext(26:27)='60'
        else
          gsetext(1:6)='PAZ2  '
          write(gsetext(11:25),'(e15.8)') gse_paz2_sfactor
          write(gsetext(41:43),'(i3)') npol
          write(gsetext(45:47),'(i3)') nzero
          write(gsetext(49:65),'(a17)') 'Laplace transform'
        endif
        write(gsetext(7:7),'(i1)') gse_stage
        gsetext(9:9)='V'             ! Volts
        write(4,'(a96)') gsetext
        if (outtyp.eq.3) then
          do i=1,60
            write(4,'(1x,f10.5,1x,e15.8,1x,i4)') f(i),amp(i),
     &            int(phase(i))
          enddo 
        else
          do i=1,npol
            write(4,'(1x,e15.8,1x,e15.8)') real(pol(i)),
     &      aimag(pol(i))
          enddo
          do i=1,nzero
            write(4,'(1x,e15.8,1x,e15.8)') real(zero(i)),
     &      aimag(zero(i))
          enddo
        endif
c
c digitizer DIG2, stage 2
c
        gse_stage=gse_stage+1
        if (outtyp.eq.4) then
          gsetext(1:96)='                                        '
     &// '                                                        '
          gsetext(1:6)='DIG2  '
          write(gsetext(7:7),'(i1)') gse_stage
          write(gsetext(9:23),'(e15.8)') gse_dig2_sensitivity
          write(gsetext(25:35),'(f11.5)') gse_dig2_samprat
          gsetext(37:61)=gse_dig2_description

          write(4,'(a96)') gsetext
        endif
      endif
c
c fir filters
c
      if (nfirstage.gt.0) then
        do i=1,nfirstage
          gse_stage=gse_stage+1
          do k=1,nfir(i)
            rfir(k)=fir(i,k)
          enddo
          if(abs(1.-normalize_fir(nfir(i),rfir,fir_rate(i))).gt..01)then
            write(*,*) ' Warning: fir filters not normalized '
          endif
          if (nfir(i).gt.0) then
            gsetext(1:80) = 
     &          '                                        ' //
     &          '                                        '
            gsetext(1:4)='FIR2'
            write(gsetext(6:7),'(i2)') gse_stage
            write(gsetext(9:18),'(e10.2)') 1. ! changed lot12/2/2008
c     &   normalize_fir(nfir(i),rfir,fir_rate(i))
            write(gsetext(20:23),'(i4)') fir_deci(i)
            write(gsetext(25:32),'(f8.3)')delay_fir(nfir(i),fir_rate(i))
c            gsetext(34:34) = sym_fir(nfir(i),rfir)
            gsetext(34:34) = fir_sym(i)
            write(gsetext(36:39),'(i4)') nfir(i)
            write(4,'(a80)') gsetext(1:80)
            do j=1,nfir(i),5
              gsetext(1:80) = 
     &          '                                        ' //
     &          '                                        '
              write(gsetext(1:80),'(5(1x,e15.8))')
     &           fir(i,j),fir(i,j+1),fir(i,j+2),fir(i,j+3),fir(i,j+4)
c
c remove 0s from last line
c
              if (j.eq.nfir(i).and.mod(nfir(i),5).ne.0) then
                do k=mod(nfir(i),5),4
                  write(gsetext(16*k+1:16*k+16),'(a16)')
     &              '                '
                enddo
              endif
              write(4,'(a80)') gsetext(1:80)
            enddo
          endif
        enddo
      endif
       
      close(4)
c
c   plot
c
      call systemc('presp '//file(1:seiclen(file)),seiclen(file)+6)
c
C------------------------------------------------------------------------
C parameters for recalculation   
C-------------------------------------------------------------------------
c
 999  CONTINUE
      recal=.false.
 990  continue
      write(6,*)' Constants used:'
      write(6,*)
      WRITE(6,'(a,f13.2)')' 1: SEISMOMETER PERIOD=', PERIOD
      WRITE(6,'(a,f13.2)')' 2: GENERATOR CONSTANT=', GENCON
      WRITE(6,'(a,f13.2)')' 3: DAMPING RATIO     =', DAMPIN
      WRITE(6,'(a,f13.2)')' 4: AMPLIFIER GAIN(DB)=', GAIN
      WRITE(6,'(a,f13.0)')' 5: RECORDING GAIN=    ', REGAIN
      write(6,'(a,a,a)')  ' 6: STATION AND COMP=  ', sta,comp
      write(6,'(a,i4,5i2)')  ' 7: DATE AND TIME=     ',
     *                         iyr,imon,idy,ihr,imin,isec
      IF(NFILT.GE.1) THEN
         WRITE(6,'(a)')   ' 8: FILTER CONSTANTS' 
         WRITE(6,200) (FFILT(I),POLE(I),I=1,NFILT)
      ENDIF
      write(6,*)
      write(6,*)
     *' Run again: Enter number to change value, enter to end'
      write(6,*)' End: Enter' 
c
      read(5,'(a)') text
      if(text(1:1).ne.' ') then
         read(text(1:1),'(i1)') k
         if(k.gt.8) then
            write(6,*)' Not a valid number'
            goto 990
         endif
         recal=.true.
         if(k.eq.1) then
            write(6,*)' SEISMOMETER NATURAL PERIOD'
            read(5,*) PERIOD
            goto 990
         endif
         if(k.eq.2) then
            write(6,*)' SENSOR LOADED GENERATOR CONSTANT'
            read(5,*) GENCON
            goto 990
         endif
         if(k.eq.3) then
            write(6,*)' SEISMOMETER DAMPING RATIO'
            read(5,*) DAMPIN
            goto 990
         endif
         if(k.eq.4) then
            write(6,*)' AMPLIFIER GAIN(DB)'
            read(5,*) GAIN
            goto 990
         endif
         if(k.eq.5) then
            write(6,*)' RECORDING MEDIA GAIN'
            read(5,*) REGAIN
            goto 990
         endif
         if(k.eq.6) then
            print*,'Enter station code. e.g. BERGE, max 5 chars '
            read(5,'(a)')sta
 667        continue
            print*,'Enter component (4 chars) e.g. SL Z'
            print*,
     *      '  First character is type, must be one of the following: '
            print*,'  S: Short period, L: Long period'
            print*,'  B: Broad band,   A: Accelerometer'
            print*,'Last character must be Z,N or E'
            print*,'Character 2 and 3 can be anything'
            read(5,'(a4)')comp
            if( comp(1:1).ne.'S'.and.comp(1:1).ne.'L'.
     *      and.comp(1:1).ne.'B'.
     *      and.comp(1:1).ne.'A'.and.comp(4:4).ne.'N'.
     *      and.comp(4:4).ne.'E'.
     *      and.comp(4:4).ne.'Z') then
               write(6,*)' Wrong component, redo'
               goto 667
            endif
            if(sentyp.eq.3.and.comp(1:1).ne.'A') then
              comp(1:1)='A'
              write(6,*)
     *        ' Sensor is an accelerometer, first letter',
     *        ' of component must be A'
               write(6,'(a,a)') ' Component changed to ',comp
             endif
             goto 990
         endif
         if(k.eq.8) then
            WRITE(6,*) ' NUMBER OF FILTERS (0-10), RETURN FOR NONE ? '
            READ(5,'(a)') TEXT
            IF(TEXT(1:2).EQ.'  ') THEN
              NFILT=0
            ELSE
              CALL SEI GET VALUES(1,TEXT,CODE)
              NFILT=ARRAY$(1)
            ENDIF
            IF(NFILT.GT.0) THEN
               WRITE(6,*)
     *         ' FREQUENCY AND NUMBER OF POLES FOR EACH FILTER,'
               WRITE(6,*)' POLES NEGATIVE FOR HIGH PASS '
               DO  I=1,NFILT
                  READ(5,*) FFILT(I),POLE(I)
               enddo
            ENDIF
            goto 990
         endif
         if(k.eq.7) then
            write(6,'(1x,a,a,$)')
     *      'Enter date as YYYYMMDDHHMMSS, at least up to the day ',
     *      ' (e.g. 19880123):'
             read(5,'(i4,5i2)')iyr,imon,idy,ihr,imin,isec
             sec=float(isec)
c
c   get doy
c
             call date_doy(idoy,idy,imon,iyr)
             goto 990
         endif
      else
         if(recal) then
            goto 2000   ! recalculate
         endif
      endif


      write(6,*)' '
      write(6,'(a,a)')' Response file name is: ',file(1:seiclen(file))
      WRITE(6,*)' RESPONSE CURVE IS IN FILE resp.out'
      STOP
      END


c
      SUBROUTINE PLOTW(N1,N2,X1,Y1,X2,Y2,XTEXT,YTEXT,XLOG,YLOG)           
C
C   J. HAVSKOV SOMETIMES IN 1978 IN MEXICO WHEN WE HAD NO PLOTTER
C   HAS BEEN CHANGED A BIT FOR CURRENT VERSION (1990) 
C
C                                                                       
C   ROUTINE TO PLOT ON A LINE PRINTER 2 SETS OF DATA                    
C   Y AS A FUNCTION X ON ONE PAGE, DIMENSION NXDIM*NYDIM                     
C   THERE ARE N1 AND N2 POINTS IN THE TWO DATA SETS X1,Y1 AND           
C   X2,Y2 RESPECTIVELY. THE OUTLINE OF THE PLOT IS                      
C   DETERMINED BY THE MAX AND MIN VALUES IN THE DATA SET 2              
C   AND VALUES X1,Y1 OUTSIDE THE GRID WILL NOT BE USED.                 
C   IF N1 = 0 ,DATA SET X1-Y1 IS NOT USED                               
C   THE X AND Y VALUES CAN COME IN ANY ORDER, THEY                      
C   WILL AUTOMATICALLY BE SCALED.                                       
C   IF XLOG OR YLOG=1, LOG SCALE FOR AXIS NUMBERS, ELSE LINEAR
C                                                                       
C   number of digits to be printed must
c   be fixed in the the format statement. Likewise if numbers
c   printed out should be log or antilog
C                                                                       
      DIMENSION X1(*),Y1(*),X2(*),Y2(*)             
      DIMENSION YSC(41),XSC(11)
      CHARACTER*1 A(101,41)
      CHARACTER*8 YTEXT
      CHARACTER*6 XTEXT                                         
      INTEGER XLOG,YLOG
      XMAX=-1*10E10                                                     
      XMIN=-XMAX                                                        
      YMIN=XMIN
      YMAX=XMAX
C
C   DIMENSION OF PRINTING SURFACE FOR PLOT, ALSO CHANGE SOME
C   FORMAT STATEMENTS
C                                                         
      NXDIM=61
      NYDIM=19
C                                                                       
C   FIND EXTREMAS                                                       
C                                                                       
      DO 1 I=1,N2                                                       
      IF(X2(I).GT.XMAX) XMAX=X2(I)                                      
      IF(Y2(I).GT.YMAX) YMAX=Y2(I)                                      
      IF(X2(I).LT.XMIN) XMIN=X2(I)                                      
      IF(Y2(I).LT.YMIN) YMIN=Y2(I)                                      
c
c   blank array
c
 1    CONTINUE                                                          
      DO 29 I=1,NXDIM
      DO 29 K=1,NYDIM
      A(I,K)=' '
 29   CONTINUE                                                          
C                                                                       
C   PUT IN GRID                                                         
C                                                                       
       DO 50 I=nydim-4,1,-5                                                   
       DO 50 K=1,nxdim,2                                                   
       A(K,I)='.'                                                        
  50   CONTINUE                                                          
       DO 51 K=1,nxdim,10                                                  
       DO 51 I=1,nydim,2                                                    
       A(K,I)='.'                                                        
  51   CONTINUE                                                          
C                                                                       
C   SCALING                                                             
C                                                                       
C                                                                       
C   ENSURE THAT VERTICAL AND HORIZONTAL LINES CAN BE PLOTTED            
C                                                                       
      XMM=XMAX-XMIN                                                     
      YMM=YMAX-YMIN                                                     
      IF(XMM.EQ.0.0) XMIN=XMIN-1.0                                      
      IF(YMM.EQ.0.0)YMIN=YMIN-1.0                                       
      XR=(NXDIM-1)/(XMAX-XMIN)                                              
      YR=(NYDIM-1)/(YMAX-YMIN)                                               
      IF(XMM.EQ.0.0) XR=XR/2.0                                          
      IF(YMM.EQ.0.0) YR=YR/2.0                                          
C                                                                       
C   A-VALUES FOR X2-Y2 VARIABLES                                        
C                                                                       
      DO 12 I=1,N2                                                      
      IX=(X2(I)-XMIN)*XR+1.5                                            
      IY=(Y2(I)-YMIN)*YR+1.5                                            
      IY=NYDIM+1-IY                                                                                                     
      A(IX,IY)='+'
 12   CONTINUE                                                          
C                                                                       
C   X1 VARIABLES, REMOVE THE ONES OUTSIDE THE GRID                      
C                                                                       
      IF(N1.EQ.0) GO TO 5                                               
      DO 2 I=1,N1                                                       
         NX=(X1(I)-XMIN)*XR+1.5                                            
         IF(NX.GT.NXDIM.OR.NX.LT.1) GO TO 11                                 
         NY=(Y1(I)-YMIN)*YR+1.5                                            
         NY=NYDIM+1-NY                                                          
         IF(NY.GT.NYDIM.OR.NY.LT.1) GO TO 11                                  
         A(NX,NY)='O'
 11      CONTINUE                                                          
 2    CONTINUE 
C                                                         
 5    CONTINUE                                                          

C                                                                       
C   VALUES AT AXIS DIVISIONS                                            
C                                                                       
      DO 10 I=1,NYDIM
      YSC(NYDIM+1-I)=YMIN+(I-1)/YR                                           
 10   CONTINUE                                                          
      DO 15 I=1,NXDIM/10+1                                                      
      XSC(I)=XMIN+(I-1)*10.0/XR                                         
 15   CONTINUE                                                          
C                                                                       
C   PRINTING                                                            
C                                                                       
      WRITE(6,100) YTEXT                                                      
 100  FORMAT(2X,A8,2X,63('-'),5X)                               
 101  FORMAT(12X,63('-'),5X)                               
      DO 20 IL=1,NYDIM                                                 
      IF(YLOG.EQ.1) THEN
         WRITE(6,201)10**YSC(IL),(A(I,IL),I=1,NXDIM)                     
      ELSE
         WRITE(6,201)YSC(IL),(A(I,IL),I=1,NXDIM)                     
      ENDIF
 201  FORMAT(1X,G10.3,1X,'I',61A1,'I')                            
 20   CONTINUE                                                          
      WRITE(6,101)
      IF(XLOG.EQ.1) THEN                                                      
         WRITE(6,202) XTEXT,(10**XSC(I),I=1,NXDIM/10+1)
      ELSE
         WRITE(6,202) XTEXT,(XSC(I),I=1,NXDIM/10+1)    
      ENDIF
 202  FORMAT(2X,A6,11(F8.2,2X))                                           
      RETURN                                                            
      END
c
c
      subroutine read_poles
c
c   read poles and zeros
c
      implicit none
c
      real ppr(1000),ppi(1000)   ! poles,  real and im.
      real pzr(1000),pzi(1000)   ! zeros, real and im.
      complex pol(500),zero(500)  ! complex poles and zeros
      integer npol,nzero        ! number of poles and zeros
      real norm                 ! normalization constant for poles and zeros
      INTEGER I
c
      common /resp/npol,nzero,ppr,ppi,pzr,pzi,pol,zero,norm
c
c   read response values
c         
         read(20,*) npol,nzero,norm
         if(npol.gt.0) then
             do i=1,npol
               read(20,*) ppr(i),ppi(i)
             enddo
         endif
         if(nzero.gt.0) then
             do i=1,nzero
                read(20,*) pzr(i),pzi(i)
             enddo
         endif
c         write(6,*)npol,nzero,norm
c
c   convert to complex
c
         do i=1,npol
           pol(i)=cmplx(ppr(i),ppi(i))
         enddo
         do i=1,nzero
           zero(i)=cmplx(pzr(i),pzi(i))
         enddo
         return
         end

      character*1 function sym_fir(nfir,fir)
      implicit none
      double precision fir(*)
      integer nfir,i
      logical even
      logical sym

      if (mod(nfir,2).eq.0) then
        even=.true.
      else
        even=.false.
      endif
      sym=.true.
      do i=1,int(nfir/2)
        if (abs(fir(i)-fir(nfir-i+1)).gt.abs(0.01*fir(i))) then
          sym=.false.
        endif
      enddo
      if (.not.sym) then
        sym_fir='A'
      elseif (even) then
        sym_fir='C'
      else
        sym_fir='B'
      endif

c
c for the case of symmetric filters, only half the coeffs are stored
c
      if (sym_fir.eq.'B') nfir=(nfir+1)/2
      if (sym_fir.eq.'C') nfir=nfir/2

      return
      end

      real function delay_fir(nfir,rate)
c
c compute fir filter delay
c
      implicit none
      integer nfir
      real rate,delay
      
      if (mod(nfir,2).eq.0) then
        delay=float(nfir)/2.*1./rate
      else
        delay=float(nfir-1)/2.*1./rate
      endif
      delay_fir=delay
      return
      end

      real function normalize_fir(nfir,fir,rate)
      implicit none
      double precision fir(*)
      real rate,pi,f0,x,y,dt
      integer nfir
      integer a
      parameter (pi=3.141592654)
      complex hc(10000),resp,i

      f0=1.
      dt=1./rate   
cc      write(*,*) ' sample interval ',dt,nfir
      i=(0,1)
c
c normalize FIR filter
c
      resp=(0,0)
      do a=1,nfir
        resp=resp+fir(a)*exp(2.*pi*i*f0*dt) 
      enddo
      normalize_fir=1./cabs(resp)
c      write(*,*) cabs(resp)
c      do a=1,nfir
c        x=fir(a)*cos(2.*pi*f0*dt*float(a))
c        y=-1.*fir(a)*sin(2.*pi*f0*dt*float(a))
cc        x=fir(a)*cos(2.*pi*f0*dt)
cc        y=-1.*fir(a)*sin(2.*pi*f0*dt)
c        hc(a)=x+y*i
c      enddo
c      resp=(0,0)
c      do a=1,nfir
c        resp=resp+hc(a)
c      enddo
c      write(*,*) cabs(resp)
      return
      end

C
C   PROGRAM TO NUMBER FILES IN A DIRECTORY using *
c               or selected files using other search string for ls
C
c
c   j. havskov    many years ago, who knows
c   e. hjortenberg 910116 unix adaptation
c   c. Lindholm, Some unix improvement
c   oct 10 94 filename to 70
c   jan 95 :     ***********  version 5.0 **********************
c   sep 17 98 by jh : ----------------- version 7.0 check -----------------
c                     no changes
c   nov 5           : linux logic
c   oct 25 2000 jh  : write more than 1000 files
c   nov 14 2006 jh  : stop if too many files
c
c
      IMPLICIT none 
      include 'seidim.inc'
c-- HEADER TEXT
      character*80 files(max_dirf)
      character*80 args ! argument
c-- COUNTERS
      INTEGER NR, nargs,i,nf,i1
      logical sun,pc,linux



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      NR=0
c
      call computer_type(sun,pc,linux)
c
c  get argument from command line
c
      call get_arguments(nargs,files)
      if (nargs.gt.0) then
        go to 10
      else
        stop
      endif
c
      
 10   CONTINUE
C
      nf=nargs-1
      if(sun.or.linux) nf=nargs
      i1=1
      nr=0
      OPEN(2,FILE='filenr.lis',STATUS='unknown')
      if(pc) then
          args=files(1)
          call dirf_pc(args,files,nf)
          i1=1
      endif
c
c   error
c
      if(nf.ge.max_dirf) then
        write(6,*) ' Number of input files: ',nf
        write(6,*) ' Maximum is: ', max_dirf
        write(6,*) ' Program terminated'
        stop
      endif
c
      do i = i1,nf
         nr=nr+1
         WRITE(2,200) nr,FILEs(i)(1:70)
         WRITE(6,200) nr,FILEs(i)(1:70)
      enddo
 200  FORMAT(1X,I4,2X,A70)
      
c-- END OF FILE
 20   CONTINUE
c-- BLANK LAST LINE
      WRITE(2,*) '                             '
      close(2)
  255 continue
      END

      subroutine xy_plot
     *(np,n,x,y,title,xtext,ytext,xlength,ylength,x0,y0,draw,
     *symbol,symbol_size,
     *xy_cursor,cha,nc,cx,cy)
c
c   makes an x-y plot, optionally calls up cursor and returns x and
c   y coordinaes and key pushed. A q terminates cursor operation. 
c   Coordinates returned are in same units as input.
c
c   
c
c   j havskov, jun 93 
c   feb 95: put axis text
c   jan 95: small adjsutment x-axis numbering space
c   jan 23, 96: bugs when  using option same scale for next plot
c   jan 31    : add exit on s
c   feb  7    : small change
c   feb 13    : increase number field from 5 to 7
c   jul 24    : bug with number of digits
c   feb 24 97 : more patching with xlin=0 for linear numbers
c   mar 14 97 : plotting of horizontal and vertical lines
c   jun 10 98 : bug in format write(text(1:5),'(i7)') int(xnumber), mario v.
c   sep 98 jh : ----------------   version 7.0 chaeck -----------------
c               no changes
c   mar 1 99  : move all numbers on x-axis 20 to the right
c   may 3 00jh: fix so extra data sets only plots points inside if scaled
c               by main data set
c   apr 03 lo : dont quit when replot given
c
c     input:      np: number of data sets
c                 n: number of points in each data set
c                 x,y: x and y points in all data sets in one vector
c                 title: plot title
c                 xtext,ytext : axis text, 30 chars
c                 xlength,ylength: axis lengths in tek units
c                                  if xlength zero, only plot data, old scale
c                                  however, data outside plot are cut down to
c                                  fit plot, WILL BE MODIFIED ON RETURN
c                 x0,y0: positon of lower left hand corner, tek units, if
c                        x0 is negative, antilog is taken of x-values
c                 draw: 1: symbols only
c                       2: lines only
c                       3: symbols and connecting lines
c                 symbol: symbol code, 1,2 etc, see routine for symbols
c                 symbol_size: size in tek units of symbol
c                 xy_cursor: 0: do not call up cursor
c                         1: call cursor
c                         2: ----------- and mark positions with symbol
c                         3: --------------- connect with lines
c                         4: ------------------symbol and connecting lines
c     output:      cha:   characters input
c                  nc :   number of positions
c                  cx,cy; x-y positions
c
c
       implicit none
       real x(*),y(*)
       character*1 cha(*)
       real cx(*),cy(*),symbol_size
       integer symbol,xy_cursor
       integer n(*),np,draw,nc
       character*80 title
       character*30 xtext,ytext
c--length of axis in tek units
       real xlength,ylength
c--scaling factors
       real xscale,yscale
c--max and min values
       real xmax,ymax,xmin,ymin
       real xmax1,ymax1,xmin1,ymin1
       real xin,yin
c--position of 0,0 of frame
       real x0,y0
c--x and y axix divisions
       real xdiv,ydiv
       integer xlin
c--exponent of xdiv and ydiv
       integer ixdiv,iydiv
c--permitted numbers on axix
       real anumber(10)
c--values at first axis tics
       real xfirst,yfirst
c--help variables
       character*80 text
       logical last_point_in,move_to      ! for plotting inside and outside
       real xd,yd,xnumber,ynumber,x1,y1,xold,yold
       integer i,j,ichar,nread,nn,k
c
c   put some scaling values in a common block so other routines can use
c   them
c
       common/xy_plot_common/xfirst,yfirst,xscale,yscale,ymin,
     *                       ymax,xmin,xmax
       data anumber/0.01,0.02,0.05,0.1,0.2,0.5,1.0,2.0,5.0,10.0/
c
c   log lin
c
       xlin=1   ! as is
       if(x0.lt.0) then
         x0=-x0
         xlin=0
       endif
c
c   check if only plotting data with old scale and position
c
       if(xlength.eq.0.0) goto 10
c
       xmax=-10e20
       ymax=-10e20
       xmin=10e20
       ymin=10e20
       nc=0
c
c   find max and min values, use all data sets, nn is total number of points
c
       nn=0
       do i=1,np
         nn=nn+n(i)
       enddo
c
       do i=1,nn
         if(x(i).gt.xmax) xmax=x(i)
         if(y(i).gt.ymax) ymax=y(i)
         if(x(i).lt.xmin) xmin=x(i)
         if(y(i).lt.ymin) ymin=y(i)
       enddo
c
c if draw <0 use same max scaling for both x and y, lot 14/02/2008
c
       if (draw.le.0) then
         draw=-draw
         if (xmax-xmin.gt.ymax-ymin) then
           ymax=xmax
           ymin=xmin
         else
           xmax=ymax
           xmin=ymin
         endif
       endif
       
c
c   ensure plotting of horizontal and vertical lines
c
       if((xmax-xmin).eq.0) then
         xmax=xmax*1.1
         if(xmax.eq.0.0) xmax=0.1
       endif
       if((ymax-ymin).eq.0) then
         ymax=ymax*1.1
         if(ymax.eq.0.0) ymax=0.1
       endif
       
c
c   add 5% to make plot look nicer
c
       xmax1=xmax+(xmax-xmin)*.05
       xmin1=xmin-(xmax-xmin)*.05
       ymax1=ymax+(ymax-ymin)*.05
       ymin1=ymin-(ymax-ymin)*.05
       xmax=xmax1
       xmin=xmin1
       ymax=ymax1
       ymin=ymin1
c
c   slighly larger limits for prescaled data sets
c
       xmax1=xmax+(xmax-xmin)*.02
       xmin1=xmin-(xmax-xmin)*.02
       ymax1=ymax+(ymax-ymin)*.02
       ymin1=ymin-(ymax-ymin)*.02

c
c   find axis divisions, assume max 10 tics with number
c
       xdiv=(xmax-xmin)/10.0
       ydiv=(ymax-ymin)/10.0
c
c  could be that xdiv is too small
c
       if(xdiv*xscale.lt.80.0)
     * xdiv=(xmax-xmin)/(xlength/60.0)
c
c   find exponent of div for scaling
c
       ixdiv=alog10(xdiv)
       if(ixdiv.ge.0) ixdiv=ixdiv+1
       if(ixdiv.lt.0) ixdiv=ixdiv-1
       iydiv=alog10(ydiv)
       if(iydiv.ge.0) iydiv=iydiv+1
       if(iydiv.lt.0) iydiv=iydiv-1
       do i=1,9
          if(xdiv/10.0**ixdiv.gt.anumber(i)) 
     *       xd=anumber(i+1)*10.0**ixdiv
          if(ydiv/10.0**iydiv.gt.anumber(i)) 
     *       yd=anumber(i+1)*10.0**iydiv
       enddo
       xdiv=xd
       ydiv=yd
c
c   find axis number at lower left hand corner
c
       xfirst=(int(xmin/xdiv))*xdiv
       if(xmin.lt.0) xfirst=xfirst-xdiv
       yfirst=(int(ymin/ydiv))*ydiv
       if(ymin.lt.0) yfirst=yfirst-ydiv
c
c   scaling factors
c
       xscale=xlength/(xmax-xfirst)
       yscale=ylength/(ymax-yfirst)
c
c   plot frame
c
       call xmovabs(x0,y0)
       call xdrwabs(x0,y0+ylength)
       call xdrwabs(x0+xlength,y0+ylength)
       call xdrwabs(x0+xlength,y0)
       call xdrwabs(x0,y0)
c
c   plot x-axis text
c
       call tchars(xtext,30,x0+50.0,y0-60.0)
       call pchars(xtext,30,x0+50.0,y0-40.0)
c
c   plot axis tics with number, first x axis
c
       do i=1,(xmax-xfirst)/xdiv
         xd=x0+i*xdiv*xscale-50.0
         yd=y0-40.0
         xnumber=xdiv*i+xfirst
c
c   if number too large, print only number without exponent
c
         if(abs(ixdiv).gt.6) then 
            xnumber=xnumber/10.0**ixdiv
            write(text(1:7),'(i7)') int(xnumber)
         else
            if(xlin.eq.0) xnumber=10**xnumber    ! patch to write log numbers
            if(xdiv.ge.1.0) write(text(1:7),'(i7)') int(xnumber)
            if(xdiv.lt.1.0) write(text(1:7),'(f7.1)') xnumber
            if(xdiv.lt.0.1) write(text(1:7),'(f7.2)') xnumber
            if(xdiv.lt.1.0.and.xlin.eq.0) 
     *      write(text(1:7),'(f7.1)') xnumber
            if(xnumber.lt.1.0.and.xnumber.ge.0.001.and.xlin.eq.0) 
     *      write(text(1:7),'(f7.3)') xnumber
            if(xnumber.lt.0.1.and.xnumber.ge.0.0001.and.xlin.eq.0) 
     *      write(text(1:7),'(f7.4)') xnumber
	        
         endif
         call tchars(text,7,xd,yd)
         call pchars(text,7,xd+25,yd+20)
         call xmovabs(x0+i*xdiv*xscale,y0)
         call xdrwabs(x0+i*xdiv*xscale,y0+10)
       enddo
       if(abs(ixdiv).gt.6) then
          write(text(1:4),'(a,i3)')'E',ixdiv
          call xchars(text,4,x0+xlength,y0-40.0)
       endif
c
c   plot y-axis text
c
       yd=y0+ylength+13.0
       do i=1,30
         yd=yd-13.0
         call xchars(ytext(i:i),1,x0-90.0,yd)
       enddo
c
c   plot y axis
c
       do i=1,(ymax-yfirst)/ydiv
         xd=x0-95.0
         yd=y0+i*ydiv*yscale-5.0
         ynumber=ydiv*i+yfirst

         if(abs(iydiv).gt.6) then 
            ynumber=ynumber/10.0**iydiv
            write(text(1:7),'(i7)') int(ynumber)
         else
            if(ydiv.ge.1.0) write(text(1:7),'(i7)') int(ynumber)
            if(ydiv.lt.1.0) write(text(1:7),'(f7.1)') ynumber
            if(ydiv.lt.0.1) write(text(1:7),'(f7.2)') ynumber
         endif
         call xchars(text,7,xd,yd)
         call xmovabs(x0,y0+i*ydiv*yscale)
         call xdrwabs(x0+10.0,y0+i*ydiv*yscale)
       enddo
       if(abs(iydiv).gt.6) then
          write(text(1:4),'(a,i3)')'E',iydiv
          call xchars(text,4,x0-80.0,y0+ylength+10)
       endif
c
c   plot title
c
       call xchars(title,60,x0,y0+ylength+23)
c
c   plot data points, enter here if only draw a new data set with
c   previous scaling factors
c
 10    continue
       i=0      ! counter for total number of points plotted
       do k=1,np   ! loop over data sets
          last_point_in=.false.                ! to force move to first point
c
c  if another data set with no scaling check, only plot numbers inside
c

          do j=1,n(k)  ! loop over each set
            i=i+1
            if(xlength.eq.0.0) then           ! case of no scaling
               if(x(i).ge.xmin1.and.x(i).le.xmax1.and.  ! check if inside
     *         y(i).ge.ymin1.and.y(i).le.ymax1) then 
                  if(last_point_in) then
                     move_to=.false.  ! point inside, prev. point inside, draw
                  else
                     move_to=.true.   ! point inside, prev. outside, move to
cx                     last_point_in=.true.
                  endif
                  last_point_in=.true.
               else
                  last_point_in=.false.
                  move_to=.true.
               endif
            else                               ! case of point inside always 
               move_to=.false.                 ! always draw, except first point
               if(j.eq.1) move_to=.true.       ! always move to first point
            endif

            xin=x(i)
            yin=y(i)

            xd=(x(i)-xfirst)*xscale+x0
            yd=(y(i)-yfirst)*yscale+y0
            if(xd.gt.1023.0) xd=1023.0
            if(xd.lt.0.0) xd=1.0
            if(yd.gt.780.0) yd=780.0
            if(yd.lt.0.0) yd=1.0
            if(move_to) then             ! only move to point
               call xmovabs(xd,yd)
               if( xlength.ne.0.0) then  ! make symbol if regular data set
                  if(draw.eq.1.or.draw.eq.3) 
     *            call xsymbol(symbol,symbol_size,xd,yd)
               endif
            else                         ! draw to point
               if(draw.eq.2.or.draw.eq.3) call xdrwabs(xd,yd)                  
               if(draw.eq.1.or.draw.eq.3) 
     *         call xsymbol(symbol,symbol_size,xd,yd)
            endif
         enddo
      enddo
c
c   empty plot buffer
c
c     call tsend
c
c   calls up cursor
c
      if(xy_cursor.gt.0) then
         nread=0
 50      continue
            call xscursr(ichar,x1,y1)
            nread=nread+1
            cha(nread)=char(ichar)
            cx(nread)=(x1-x0)/xscale+xfirst
            cy(nread)=(y1-y0)/yscale+yfirst
            if(nread.eq.1) then
               xold=x1
               yold=y1
            endif
c
c   do not draw if terminating character
c
            if(cha(nread).eq.'q'.or.cha(nread).eq.'Q'.or.
     *      cha(nread).eq.'f'.or.cha(nread).eq.'F'.or.
     *      cha(nread).eq.'r'.or.cha(nread).eq.'R'.or.
     *      cha(nread).eq.'S'.or.cha(nread).eq.'s') goto 60
c
c   possible drawing
c           
            if(xy_cursor.eq.3.or.xy_cursor.eq.4) 
     *        call xmovabs(xold,yold)
            if(xy_cursor.eq.3.or.xy_cursor.eq.4) 
     *        call xdrwabs(x1,y1)
			xold=x1
            yold=y1
            if(xy_cursor.eq.2.or.xy_cursor.eq.4) 
     *         call xsymbol(symbol,symbol_size,x1,y1)
            call tsend
            goto 50   ! next cursor input
      endif
 60   continue
      nc=nread
      return
      end                                         
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine xy_plot_line(a,b,x0,y0)
c
c  plots the line with constants y = ax + b
c  all scaling values from routine xy_plot via common
c  x0,y0 are lower left hand corner of plot
c
       implicit none
       real x1,x2,y1,y2   ! line endpoints
       real a,b
       real xfirst,yfirst,x0,y0,xscale,yscale,ymin,ymax,xmin,xmax   ! see xy_plot
       common/xy_plot_common/xfirst,yfirst,xscale,yscale,ymin,
     *                       ymax,xmin,xmax

c      open(27,file='xy.tst',status='unknown')
c	  write(27,*) a,b
c
c   calculate two endpoints
c
      x1=xfirst
      y1=a*x1+b
      if(y1.gt.ymax) then
          y1=ymax
          x1=(y1-b)/a
      endif
      if(y1.lt.ymin) then
          y1=ymin
          x1=(y1-b)/a
      endif
c
      x2=xmax
      y2=a*x2+b
      if(y2.gt.ymax) then
          y2=ymax
          x2=(y2-b)/a
      endif
      if(y2.lt.ymin) then
          y2=ymin
          x2=(y2-b)/a
      endif
c	  write(27,*)'x,y',x1,y1,x2,y2
c
c   plot line
c
      call xmovabs((x1-xfirst)*xscale+x0,(y1-yfirst)*yscale+y0)
      call xdrwabs((x2-xfirst)*xscale+x0,(y2-yfirst)*yscale+y0)
c
      return
      end

c program to convert SIL bc files to mseed, jh august 2006
c
c based on SILSEI program to convert SIL ASCII data to Seisan, lo June 01, 2001
c
c comments: component hardwired to B
c           network code hardvired to SI
c           not tested much


      implicit none
      include  'seidim.inc'                 ! Dimensions.
      include  'libsei.inc'                 ! Library defns.
      include 'waveform.inc'                ! for waveform handling
      include 'seisan.inc'                  ! seisan parameters
      include 'write_mseed.inc.f'           ! writing miniseed


      integer idata (max_sample)            ! integer data
      integer nchan,nsamp,i
      character*80      filehead(max_trace)
      character*1040    tracehead
      character*80 infile                   ! input filename
      character*80 outfile                 
      real srate                             ! sample rate
      integer year,month,day,hour,min        !time
      real sec
      character*5 station                    ! station name
      character*4 comp                       ! component SEISAN
      integer in                             ! 1 for filenr.lis
      integer ichan                          ! channel counter
      logical op_file,open_file              ! open seed file
      character*2 seed_location_code         ! seed location code
      integer seiclen
      character*80 question,line
      character*40 text
      integer mseed_block                    ! mseed block counter
      integer l



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

 10   continue
c
c input file names
c
      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)
      if (infile(1:3).eq.'EOF') stop

      in=0
      if (infile(1:10).eq.'filenr.lis') then
        in=1
        open(60,file=infile,status='old',err=9999)
      endif

 20   continue

      if (in.eq.1) then 
         read(60,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif

      write(6,'(1x,a13,a)') ' input file: ',infile
      write(*,*) 
c
c   convert binary file to SIL ascii
c
      i=seiclen(infile)   ! length of file name
c
c   convert file to ascii using sil program bctool 
c
      call systemc
     *('bctool -b '//infile(1:i)//' -S',13+i)
c
c   start with first block
c
      mseed_block=1
c
c
c  always assume 3 channels now in 3 different files, same
c  file name except ending

      do ichan=1,3
         if(ichan.eq.1) open(1,file=infile(1:8)//'Z00'
     *   ,status='scratch')
         if(ichan.eq.2) open(1,file=infile(1:8)//'N00'
     *   ,status='scratch')
         if(ichan.eq.3) open(1,file=infile(1:8)//'E00'
     *   ,status='scratch')
c
c read header
c
         read(1,'(a)',end=333,err=333) line
c
c arn  2001
c
         station=line(1:4)
         call CASEFOLD(station)
         read(line(6:9),'(i4)') year
c
c              12345678901234567890
c /usr/sil/net/may/07/09:44:00.00E00     format example
c
         read(1,'(a)',end=333,err=333) line
         text=' '
         text= line(seiclen(line)-20:seiclen(line))
         if (text(1:3).eq.'jan') then 
           month=1
         elseif (text(1:3).eq.'feb') then
           month=2
         elseif (text(1:3).eq.'mar') then
           month=3
         elseif (text(1:3).eq.'apr') then
           month=4
         elseif (text(1:3).eq.'may') then
           month=5
         elseif (text(1:3).eq.'jun') then
           month=6
         elseif (text(1:3).eq.'jul') then
           month=7
         elseif (text(1:3).eq.'aug') then
           month=8
         elseif (text(1:3).eq.'sep') then
           month=9
         elseif (text(1:3).eq.'oct') then
           month=10
         elseif (text(1:3).eq.'nov') then
           month=11
         elseif (text(1:3).eq.'dec') then
           month=12
         endif
         read (text(5:6),'(i2)') day
         read (text(8:9),'(i2)') hour
         read (text(11:12),'(i2)') min
         read (text(14:18),'(f5.2)') sec
         comp='B   '
         comp(4:4)=text(19:19)
c 100
         read(1,'(a)',end=333,err=333) line
         read(line,'(f5.0)') srate

c T3795 D0395
c aut
c o/s=   600 drift=     0 pwm=  3484   4 Auto 9

         read(1,'(a)',end=333,err=333) line
         read(1,'(a)',end=333,err=333) line
         read(1,'(a)',end=333,err=333) line
c
c +data+
c
         read(1,'(a)',end=333,err=333) line
         if (line(1:6).ne.'+data+') then
            goto 333 
         endif
c
c  36000        exmaple of nsamp
c
         read(1,'(a)',end=333,err=333) line
         read(line,'(i10)') nsamp
c
c -117874       exmaple fo first sample
c
         do i=1,nsamp
            read(1,'(a)',end=333,err=333) line
            read(line,'(i14)') idata(i)
         enddo
c
c input done
c

         goto 334
    
 333     continue
         close(1)
         write(*,*) ' error reading SIL file '
         stop
 334     continue
         close(1)
c
c  open output file if first channel
c
         if(ichan.eq.1) then
            outfile=infile(1:8)//'_MSEED'
            op_file=open_file(96,outfile,12)   ! use block size 4096=2**12
            write(6,'(a,a)') ' Outfile name: ',outfile(1:60)
         endif
c
c MSEED  headers
c
         seed_location_code='  '   ! hardwird to blank
         mseed_year=year
         mseed_month=month
         mseed_day=day
         mseed_hour=hour
         mseed_minute=min
         mseed_second=sec
         mseed_station=station
         mseed_channel(1:2)=comp(1:2)
         mseed_channel(3:3)=comp(4:4)
         mseed_total_samples=nsamp
         mseed_sample_rate=srate
         mseed_location=seed_location_code
         mseed_network='SI'

         mseed_encoding=steim1               ! steim1
c        do l=1,nsamp
c           signal4b(l)=idata(l)
c        enddo
         call seed_write_chn(96,idata,mseed_block)
      enddo          ! end of channel loop
c
c   back for next file
c

      if(in.eq.1) goto 20                                                           
      goto 10 

9999  continue
      close(60)

      stop
      end

c  april 27 99 jh : also possible to have def file in dat
c  may23          :bug
c  march 05 01 lo : close def file before return
c  march 23 01 jh : but only if it had been opened, else crash
c  may    7 03 lo : add reading routine for time definition file
c
      subroutine read_def_chan(def_file,mainhead_text,net_code)
c
c   read the channel definition file for conversion programs
c   the output is given in the common block
c
c   j havskov, march 99
c
      implicit none
      include 'libsei.inc'
      external  sei open,                      ! Open file handler.
     &          sei close,                     ! Close file handler.
     &          sei code                       ! Error handler.
      character*5 def_in_stat(200)  ! input station code in def file
      character*4 def_in_comp(200)  ! input component code in def file
      character*5 def_out_stat(200) ! output station code in def file
      character*4 def_out_comp(200) ! output component code in def file
      integer   def_chan_number(200)! channel number of current unit
      character*29 mainhead_text    ! waveform header info
      character*5  net_code         ! network code for file name
      integer ndef_chan             ! number of channels defined
      character*80 def_file         ! name of def file
      integer in                    ! file unit
      logical exist                 ! true if def file exists
      integer code                  ! return code from opening def file
      integer i
      common /def_chan/def_in_stat,def_in_comp,def_out_stat,
     *                 def_out_comp,def_chan_number,ndef_chan
c
      mainhead_text=' '
      net_code=' '
c
c   get def file for station codes
c
      ndef_chan=1	   	   	  	  	  
c                                                                               
      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   in,              ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   def_file )       ! For this filename.

c
      if(code.ne.e_ok$) goto 50
      goto 49                  
 50   continue
      i=index(def_file,' ')-1
      write(6,'(a,a,a)')
     *' No ',def_file(1:i),
     *' file, will use internal information for channel codes'
      return
c      goto 51    ! mar 2001  jh
c
c  read def file
c	  
 49   continue
c-- read help line
      read(in,'(a)',end=51,err=60) i  
c-- header info line	  
      read(in,'(a29,1x,a5)',end=51,err=60) mainhead_text,net_code
c-- comment help line
      read(in,'(a)',end=51,err=60) i
c-- codes	  
 53   continue
      read(in,'(i5,1x,a5,2x,a4,1x,a5,2x,a4)',end=51,err=60)
     *def_chan_number(ndef_chan),
     *def_in_stat (ndef_chan),def_in_comp (ndef_chan),
     *def_out_stat(ndef_chan),def_out_comp(ndef_chan)
     
	  ndef_chan=ndef_chan+1
      goto 53
c
c   end of def file
c
 51   continue
      ndef_chan=ndef_chan-1 
      if(ndef_chan.gt.0) then
cc        write(6,*)' Number of channel codes in def file',
cc     *   ndef_chan
cc         write(6,*)
      endif		 		 
c
      goto 99
c
 60   continue
      write(6,*)' Error in def file'
      ndef_chan=0
c
 99   continue
c added close 05 March, 2001
      call sei close(close$, in, code)
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccc

      subroutine read_def_time(def_file,ntime)
c
c   read the time definition file for conversion programs
c   the output is given in a common block
c
c   L Ottemoller, January 2002
c
      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
      external  sei open,                      ! Open file handler.
     &          sei close,                     ! Close file handler.
     &          sei code                       ! Error handler.
      character*5 def_time_stat(max_phase)  ! input station code in def file
      character*4 def_time_comp(max_phase)  ! input component code in def file
      double precision def_time_start(max_phase),def_time_end(max_phase)
                                               ! time interval for which to 
                                               ! apply correction
      double precision def_time_correction(max_phase) ! time correction
      integer ndef_time_chan             ! number of channels defined
      character*80 def_file         ! name of def file
      character*80 text             ! text
      integer in                    ! file unit
      logical exist                 ! true if def file exists
      integer code                  ! return code from opening def file
      character*14 starttime,endtime! time as text
      integer year,month,day,hour,min
      real sec
      double precision msec
      integer i,ntime
      common /def_time/def_time_stat,def_time_comp,
     *                 def_time_start,def_time_end,
     *                 def_time_correction,ndef_time_chan
c
c   get time correction for individual channels
c
      ndef_time_chan=1	   	   	  	  	  
      ntime=0

      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   in,              ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   def_file )       ! For this filename.

      if(code.ne.e_ok$) goto 50
      goto 49                  
 50   continue
      i=index(def_file,' ')-1
      write(6,'(a,a,a)')
     *' No ',def_file(1:i),
     *' file for individual channel time correction'
      return
c
c  read def file
c	  
 49   continue
c-- read the 4 header lines
      do i=1,4
        read(in,'(a)',end=51,err=60) text
      enddo

 53   continue

      read(in,'(a5,1x,a4,1x,a14,1x,a14,f20.3)',end=51,err=60)
     &  def_time_stat(ndef_time_chan),def_time_comp(ndef_time_chan), 
     &  starttime,endtime,def_time_correction(ndef_time_chan)

      if (def_time_stat(ndef_time_chan)(1:1).eq.'#') goto 53
   
c
c convert time into seconds
c
      if (starttime.ne.'              ') then
        read(starttime,'(i4,4i2,i2.0)') year,month,day,hour,min,sec
        call timsec(year,month,day,hour,min,sec,msec)
        def_time_start(ndef_time_chan)=msec
      else
        def_time_start(ndef_time_chan)=0.
      endif
      if (endtime.ne.'              ') then
        read(endtime,'(i4,4i2,i2.0)') year,month,day,hour,min,sec
        call timsec(year,month,day,hour,min,sec,msec)
        def_time_end(ndef_time_chan)=msec
      else
        def_time_end(ndef_time_chan)=0.
      endif

      if (ndef_time_chan.le.max_phase.and.
     &    def_time_stat(ndef_time_chan).ne.'     '.and.
     &    def_time_stat(ndef_time_chan).ne.'    '.and.
     &    def_time_correction(ndef_time_chan).ne.0.) then
        ndef_time_chan=ndef_time_chan+1
      endif
      goto 53
c
c   end of def file
c
 51   continue
      ndef_time_chan=ndef_time_chan-1 

      goto 99
 60   continue
      write(6,*)' Error in def file'
      ndef_time_chan=0

 99   continue

      call sei close(close$, in, code)
      ntime=ndef_time_chan
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccc


      subroutine set_def_chan(ichan,stat,comp)
c
c  set channel codes according to def file, if no valid definition is 
c  found, stat and chan are returned unchanged
c
c  principle of conversion in order of precedence:
c
c  both station and component given on input: Converted to what is given
c               for output station and componenet. If both are not present
c               an erro message is given an dno conversion is done
c
c  Only station given in input: The station code is converted to what
c               is given for output station. The component is not changed
c               even if an output component is given. If no output station
c               is given, no conversion is made and an error message is given.
c
c  Only component given in input: The component code is converted to what
c               is given for output componenet. The station is not changed
c               even if an output station is given. If no output componenet
c               is given, no conversion is made and an error message is given.
c
c  No input station or componenet given, only channel number given. The output
c               will get the output station and componenet given for output.
c               If the output station and component is not defined, an error
c               message will be given and no conversion made.
c
c  No definition in def file: No conversion made and a message given.
c  
      implicit none
      character*5 stat              ! station code
      character*4  comp             ! component code
      character*5 def_in_stat(200)  ! input station code in def file
      character*4 def_in_comp(200)  ! input component code in def file
      character*5 def_out_stat(200) ! output station code in def file
      character*4 def_out_comp(200) ! output component code in def file
      integer   def_chan_number(200)! channel number of current unit
      integer ndef_chan             ! number of channels defined
      integer ichan                 ! input channel number
      integer i,kdef
      common /def_chan/def_in_stat,def_in_comp,def_out_stat,
     *                 def_out_comp,def_chan_number,ndef_chan
c
c if no defaults, return
c
c
      if(ndef_chan.eq.0) return
c   
c
c   first check if given station and component are defined in input definition,
c   if so use that for the output, overide all other definitions
c

      do i=1,ndef_chan
        if(stat.eq.def_in_stat(i).and.comp.eq.def_in_comp(i)) then
           if(def_out_stat(i).eq.' '.or.def_out_comp(i).eq.' ') then
              write(6,'(a,a,1x,a)') 
     *        ' Missing output definition for input ',
     *        def_in_stat(i),def_in_comp(i)
              write(6,*)' No conversion made of codes for this channel'
           else
              comp=def_out_comp(i)
              stat=def_out_stat(i)
           endif
           return
        endif
      enddo
c
c    next case is if input station is given but component is blank,
c    then the station is changed but the componenet remain
c

      do i=1,ndef_chan
        if(stat.eq.def_in_stat(i).and.def_in_comp(i).eq.' ') then
           if(def_out_stat(i).eq.' ') then
              write(6,'(a,a)') 
     *        ' Missing output definition for station, input is ',
     *        def_in_stat(i)
              write(6,*)' No conversion made of codes for this channel'
           else
              stat=def_out_stat(i)
           endif
           return
        endif
      enddo
c
c    next case is if input component is given but station is blank,
c    then the component is changed but the station remains
c

      do i=1,ndef_chan
        if(comp.eq.def_in_comp(i).and.def_in_stat(i).eq.' ') then
           if(def_out_comp(i).eq.' ') then
              write(6,'(a,a)') 
     *        ' Missing componenet output definition for input ',
     *        def_in_comp(i)
              write(6,*)' No conversion made of codes for this channel'
           else
              comp=def_out_comp(i)
           endif
           return
        endif
      enddo

c
c   if definition input is blank for both station and component,
c   and the output definition exist for that channel, use that
c   irrespective of what was defined from before
c
c   first find if channel number is given
c
      kdef=0
      do i=1,ndef_chan
        if(ichan.eq.def_chan_number(i)) kdef=i
      enddo
c
      if(kdef.gt.0) then
         if( def_in_stat (kdef).eq.' '.and.def_in_comp (kdef).eq.' '.
     *   and.def_out_stat(kdef).ne.' '.and.def_out_comp(kdef).ne.' ') 
     *   then
            stat=def_out_stat(kdef)
            comp=def_out_comp(kdef)
            return
         endif
      endif
c
c   if here, channel was not defined in def file
c
      write(6,'(a,i3,1x,a5,1x,a4)') 
     *' Channel # and name not defined in def file: ',
     *              ichan,stat,comp
c
      return
      end


      subroutine set_time_chan(stat,comp,time,correction)
      implicit none
      include 'seidim.inc'
c
c find individual time correction for given channel
c
      character*(*) stat,comp
      double precision time,correction
      integer i
      character*5 def_time_stat(max_phase)  ! input station code in def file
      character*4 def_time_comp(max_phase)  ! input component code in def file
      double precision def_time_start(max_phase),def_time_end(max_phase)
                                               ! time interval for which to 
                                               ! apply correction
      double precision def_time_correction(max_phase) ! time correction
      integer ndef_time_chan             ! number of channels defined
      common /def_time/def_time_stat,def_time_comp,
     *                 def_time_start,def_time_end,
     *                 def_time_correction,ndef_time_chan

      correction=0.

      do i=1,ndef_time_chan
        if (stat.eq.def_time_stat(i).and.
     &      comp.eq.def_time_comp(i)) then
          if ((time.ge.def_time_start(i).and.
     &         time.lt.def_time_end(i)).or. 
     &        (time.ge.def_time_start(i).and.
     &         def_time_end(i).eq.0.).or. 
     &        (time.lt.def_time_end(i).and.
     &         def_time_start(i).eq.0.).or. 
     &        (def_time_start(i).eq.0..and.
     &         def_time_end(i).eq.0.)) then 

            if (correction.eq.0.) then
              correction=def_time_correction(i)
            else
              write(*,*) ' Time correction defined more than once! '
            endif
          endif
        endif
      enddo

      return 
      end

c
c xclust: program to detect event clusters based on cross-correlation
c         as computed by corr, default input file is cc_pair.out
c
c program does the following:
c         - read data
c         - sort event pairs with descending correlation
c         - find groups, loop over pairs
c            + start with highest correlation
c            + in a loop over all pairs until no more events 
c              added to group, add events that are linked
c              into group 
c            + continue to find next group
c
c Lars Ottemoller, April 2006
c
c changes:
c
c  23/05/06 lot - Changed reading of input data
c
 
      program xclust
      implicit none
      integer maxpair,maxe
      parameter (maxpair=100000)
      parameter (maxe=5000)
      
      character*19 sfile(maxe),text1,text2
      integer sfileind(maxpair)
      integer nevent
      integer ind1(maxpair),ind2(maxpair)
      integer nchan(maxpair)
      integer group(maxe,maxe,2)
      logical grouped(maxpair),flag,added
      integer ngroup
      real cor(maxpair)
      integer c,i,j,k,l,ind,npair,tu
      character*80 line,infile,outfile,outgroup
      real max
      logical tout
      real mincor
      real minlink
      real minpg
      logical sun,pc,linux
      character*80 system_call
      integer seiclen
c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      outfile='xclust.out'
      call computer_type(sun,pc,linux)
c
c read parameter file
c
      inquire(file='xclust.par',exist=flag)
      if (.not.flag) then
        write(*,*) ' no such file: xclust.par '
        stop
      endif
      open(1,file='xclust.par',status='old')
      call read_xclust_def(1,mincor,minlink,minpg,tout)
      close(1)

c
c trace file
c
      if (tout) then
        tu=4
        open(tu,file='xclust.trace',status='unknown')
      endif
c
c remove index.??? files
c
      if (sun.or.linux) then
        system_call='rm index.???'
      elseif (pc) then
        system_call='del index.???'
      endif
      call systemc(system_call,seiclen(system_call))

c
c read input file
c
      write(*,*) ' Filename of corr output file (e.g. cc_pairs.out) '
      read(5,'(a)') infile
      if (seiclen(infile).le.0) infile='cc_pairs.out'
      inquire(file=infile,exist=flag)
      if (.not.flag) then
        write(*,*) ' no such file: '//infile(1:seiclen(infile))
        stop
      endif
      if(tout)write(tu,'(a)') 
     &   'input file: '//infile(1:seiclen(infile))

      do i=1,maxpair
        grouped(i)=.false.
        sfileind(ind1(c))=0
      enddo

      open(1,file=infile,status='old')
      c=0
      nevent=0
      write(*,*) ' reading data ... '
 10   continue
      read(1,'(a)',end=999) line
      c=c+1
      read(line,'(i4,1x,a19,1x,i4,1x,a19,1x,i3,1x,f5.3)') 
     &    ind1(c),text1,ind2(c),text2,nchan(c),cor(c)
c       write(*,*) ind1(c),' ',text1,' ',ind2(c),' ',
c     &    text2,' ',nchan(c),' ',cor(c)
c
c store s-file names if correlation is above minimum
c
      if (cor(c).gt.mincor) then
        j=0
        do i=1,nevent
          if (sfile(i).eq.text1) then
            j=i
          endif
        enddo
        if (j.eq.0) then
          nevent=nevent+1
          sfile(nevent)=text1
          j=nevent
          if(tout)write(tu,*) ' new sfile ',nevent,' ',text1
        endif
        if (sfileind(ind1(c)).eq.0) sfileind(ind1(c))=j
        j=0
        do i=1,nevent
          if (sfile(i).eq.text2) then
            j=i
          endif
        enddo
        if (j.eq.0) then
          nevent=nevent+1
          sfile(nevent)=text2
          j=nevent
          if(tout)write(tu,*) ' new sfile ',nevent,text2
        endif
        if (sfileind(ind2(c)).eq.0) sfileind(ind2(c))=j
      else
c        write(tu,*) ' correlation low: ',text1,' ',text2,cor(c)
c
c don't use pair if correlation low
c
        c=c-1
      endif

      goto 10
 999  continue
      npair=c
      write(*,*) ' sorting data ... '
c
c sort arrays descending correlation
c
      do i=1,npair-1
c
c find pair with maximum correlation
c
        max=0.
        ind=0
        do j=i+1,npair
          if (cor(j).gt.max) then
            ind=j
            max=cor(j)
          endif
        enddo
c
c swap
c
        if (ind.gt.0) then
c          write(*,*) ' swap ',ind,i,max
          ind1(npair+1)=ind1(i)
          ind2(npair+1)=ind2(i)
          nchan(npair+1)=nchan(i)
          cor(npair+1)=cor(i)

          ind1(i)=ind1(ind)
          ind2(i)=ind2(ind)
          nchan(i)=nchan(ind)
          cor(i)=cor(ind)
          
          ind1(ind)=ind1(npair+1)
          ind2(ind)=ind2(npair+1)
          nchan(ind)=nchan(npair+1)
          cor(ind)=cor(npair+1)
        endif
      enddo
      if(tout)write(tu,*) 
     &   ' pairs: # event1 event2 nchan correlation '
      do i=1,npair
        if(tout)write(tu,*) i,ind1(i),ind2(i),nchan(i),cor(i)
      enddo

c
c build groups
c
      write(*,*) ' building groups ... '
      ngroup=0
      do i=1,npair
        if (.not.grouped(i)) then
c
c remove weak links
c
        if (ngroup.ge.2.and.minlink.gt.0.) then
          if(tout)write(tu,*) 
     &       ' checking for weak links, group ',ngroup
          do l=2,group(ngroup,1,1)+1
c            if(tout)write(tu,*) group(ngroup,l,2),minlink
            if (group(ngroup,l,2).lt.minlink) then
              if(tout)write(tu,*) 
     &        ' weak link ',ngroup,l,group(ngroup,l,2)
              group(ngroup,l,2)=0
              do k=1,npair
                if (group(ngroup,l,1).eq.ind1(k).or.
     &              group(ngroup,l,1).eq.ind2(k)) then
                  grouped(k)=.false. 
                endif
              enddo
            endif
          enddo
        endif
c
c new group
c
          ngroup=ngroup+1
          if(tout)write(tu,*) ' new group ',ngroup
          if(tout)write(tu,*) ' adding pair ',ind1(i),ind2(i)  
c
c first element gives count in group
c
          group(ngroup,1,1)=2
          group(ngroup,2,1)=ind1(i)
          group(ngroup,2,2)=1
          group(ngroup,3,1)=ind2(i)
          group(ngroup,3,2)=1
          grouped(i)=.true.
c
c search remaining pairs and merge into group
c
         added=.true.
         do while(added)
          added=.false.
c          write(*,*) ' still added'
          do j=1,npair
            if (.not.grouped(j)) then
ccc              do k=1,ngroup
                k=ngroup
                flag=.false.
                do l=2,group(k,1,1)+1
                  if (group(k,l,1).eq.ind1(j).or.
     &                group(k,l,1).eq.ind2(j)) then 
                    flag=.true.
                    if(tout)write(tu,*) ' adding pair ',ind1(j),ind2(j)
                  endif
                enddo
c
c add both ind1 and ind2, if pair belongs to group
c
                if (flag) then
                  added=.true.
                  grouped(j)=.true.
                  ind=0
                  do l=2,group(k,1,1)+1
                    if (group(k,l,1).eq.ind1(j)) then
                      group(k,l,2)=group(k,l,2)+1
                      ind=ind1(j) 
                    endif
                  enddo
                  if (ind.eq.0) then
                      group(k,1,1)=group(k,1,1)+1
                      group(k,group(k,1,1)+1,1)=ind1(j) 
                      group(k,group(k,1,1)+1,2)=1 
c             write(*,*) ind,ind1(j),group(k,1,1)
                  endif
                  ind=0
                  do l=2,group(k,1,1)+1
                    if (group(k,l,1).eq.ind2(j)) then
                      group(k,l,2)=group(k,l,2)+1
                      ind=ind2(j)
                    endif
                  enddo
                  if (ind.eq.0) then
                      group(k,1,1)=group(k,1,1)+1
                      group(k,group(k,1,1)+1,1)=ind2(j)
                      group(k,group(k,1,1)+1,2)=1
c             write(*,*) ind,ind2(j),group(k,1,1)
                  endif
                endif
ccc              enddo          
            endif     
          enddo 
         enddo
        endif
      enddo

c
c output
c
      open(2,file=outfile,status='unknown')
      k=0
      do i=1,ngroup
c
c only groups with more than minpg events
c
        if (group(i,1,1).ge.minpg) then
          k=k+1
c
c group index file
c
          outgroup='index.out'
          write(outgroup(7:9),'(i3.3)') k
          open(3,file=outgroup,status='unknown')

          write(2,'(a)') '============= '
          write(2,'(a,i5,a,i6)') ' group: ',k,
     &      ' number of events: ',group(i,1,1)
          write(2,'(a)') '------------- '
          write(2,'(a)') '  event links '
          write(2,'(a)') '------------- '
          do j=2,group(i,1,1)+1
            write(2,'(2x,i5,1x,i5)') group(i,j,1),group(i,j,2)
            if (group(i,j,2).gt.0.) 
     &      write(3,'(i5,2x,a)') j-1,sfile(sfileind(group(i,j,1))) 
          enddo
          close(3)
        endif
      enddo

      close(1)
      close(2)
      if (tout) close(tu)
      write(*,*) ' total events: ',nevent
      write(*,*) ' total pairs:  ',npair
      write(*,*) ' total groups: ',k
      write(*,*) ' output file:   xclust.out '
      if(tout)write(*,*) ' trace file:    xclust.trace '
      write(*,*) ' index files:   index.??? '

      stop
      end



      subroutine read_xclust_def(unit,mincor,minlink,minpergroup,tout)
c
c read parameter file xclust.par
c
      implicit none
      character*80 line
      real x
      real mincor,minlink,minpergroup
      logical tout
      integer i,unit,seiclen
  
c
c init values
c
      mincor=0.
      minlink=0.
      minpergroup=0.
      tout=.false.
c
c read input
c
10    continue

      read(unit,'(a80)',end=20) line

c fill missing characters
      do i=seiclen(line)+1,80
        line(i:i)=' '
      enddo

      if (line(1:19).eq.'MINIMUM CORRELATION') then
        read(line(41:),*) x
        if (x.gt.0..and.x.le.1.) mincor=x
      elseif (line(1:12).eq.'MINIMUM LINK') then
        read(line(41:),*) x
c        if (x.ge.1.) minlink=x
      elseif (line(1:16).eq.'MINIMUM PERGROUP') then
        read(line(41:),*) x
        if (x.ge.1.) minpergroup=x
      elseif (line(1:12).eq.'TRACE OUTPUT') then
        read(line(41:),*) x
        if (x.ge.1.) tout=.true.
      endif
      goto 10
20    continue
      return
      end

      program mech
c
c  may 99 by jh --------------- version 7.0 --------- 
c               add old files mchdep70, numarg
c
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME V                                                       c
c                                                                     c
c      PROGRAM: MECH                                                  c
c                                                                     c
c      COPYRIGHT 1985 R. B. Herrmann                                  c
c                                                                     c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      parameter (LER=0, LIN=5, LOT=6)
c usage mech -d D -s S -l L -m M -x -a A -b B -v
c
c
c
	character*4 icom(3)
      dimension fz(3),fr(3),ft(3)
      dimension x(2048)
      dimension xr(2048),xt(2048),z(2048)
	data icom/' Z  ',' N  ',' E  '/


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c-----
c     call machine dependent initialization
c-----
      call mchdep()
      call gcmdln(dip,slip,strike,iexpl,iverby,xmom,az,baz,irot)
	if(irot.eq.1)then
		icom(2) = ' R  '
		icom(3) = ' T  '
		baz = 180.0
	endif
      if(iverby.eq.1)then
      write(LER,*)'dip =',dip,' slip= ',slip,' str= ',strike
      write(LER,*)'xmom= ',xmom,' az=',az,' baz=',baz,'exp=',iexpl
      endif
      str=strike
      slp=slip
      call trans(dip,str,slp,f1,f2,f3,v1,v2,v3)
      degrad = 0.01745329
      sint = sin(baz*degrad)
      cost = cos(baz*degrad)
      sina = sin(az*degrad)
      cosa = cos(az*degrad)
      sin2a = sin(2.*az*degrad)
      cos2a = cos(2.*az*degrad)
      fz(1) = f3 * v3
      fr(1) = fz(1)
      fz(2) = (f1*v3+f3*v1)*cosa + (f2*v3+f3*v2)*sina
      fr(2) = fz(2)
      fz(3) = (f1*v1-f2*v2)*cos2a + (f1*v2+f2*v1)*sin2a
      fr(3) = fz(3)
      ft(1) = 0.0
      ft(2) = (f1*v3+f3*v1)*sina - (f2*v3+f3*v2)*cosa
      ft(3) = (f1*v1-f2*v2)*sin2a - (f1*v2+f2*v1)*cos2a
c following the notation of Wang and Herrmann (1980)
      if(iverby.eq.1)then
            write(LER,*)' fz=',fz
            write(LER,*)' fr=',fr
            write(LER,*)' ft=',ft
      endif
 9995 continue
      read(LIN,10,end=9999)r,yr,hs,nt,ti,dt,tau
   10 format(3e16.9,i10/3e16.9)
      write(LOT,13)r,yr,hs,nt,ti,dt,tau,dip,strike,slip,xmom,az,baz,
     1            iexpl,icom
   13 format(3e16.9,i10,e16.9/5e16.9/3e16.9,i10,3a4)
      do 1005 i=1,nt
      z(i)=0.0
      xr(i)=0.0
      xt(i)=0.0
 1005 continue
c read in the ten basic solutions
      do 1001 j=1,10
c initialize input array
      do 300 i=1,nt
  300 x(i)=0.0
      read(LIN,11)(x(i),i=1,nt)
   11 format(5e16.9)
      do 1002 i=1,nt
      x(i)=x(i)*xmom
 1002 continue
      do 9200 i=1,nt
      if(iexpl.le.0)then
            if(j.eq.1)then
                  z(i)=z(i) + fz(1)*x(i)
            elseif(j.eq.2)then
                  xr(i)=xr(i) + fr(1)*x(i)
            elseif(j.eq.3)then
                  z(i)=z(i) + fz(2)*x(i)
            elseif(j.eq.4)then
                  xr(i)=xr(i) + fr(2)*x(i)
            elseif(j.eq.5)then
                  xt(i)=xt(i) + ft(2)*x(i)
            elseif(j.eq.6)then
                  z(i)=z(i) + fz(3)*x(i)
            elseif(j.eq.7)then
                  xr(i)=xr(i) + fr(3)*x(i)
            elseif(j.eq.8)then
                  xt(i)=xt(i) + ft(3)*x(i)
            endif
      elseif(iexpl.eq.1)then
            if(j.eq.9)then
                  z(i)= x(i)
            elseif(j.eq.10)then
                  xr(i)=x(i)
            endif
      endif
 9200  continue
 1001 continue
c rotate horizontal components into receiver coordinates N and E
	if(irot.eq.0)then
      do 9210 i = 1,nt
      yr = xr(i)
      yt = xt(i)
      xr(i) = - cost*yr + sint*yt
      xt(i) = -sint*yr - cost*yt
 9210 continue
	endif
      write(LOT,11)(z(i),i=1,nt)
      write(LOT,11)(xr(i),i=1,nt)
      write(LOT,11)(xt(i),i=1,nt)
      go to 9995
 9999 continue
      stop
      end
      subroutine trans(dip,stk,slip,f1,f2,f3,v1,v2,v3)
      degrad=0.01745329
      sins=sin(stk*degrad)
      coss=cos(stk*degrad)
      sind=sin(dip*degrad)
      cosd=cos(dip*degrad)
      sinf=sin(slip*degrad)
      cosf=cos(slip*degrad)
      a11=cosf*coss + sinf*cosd*sins
      a12=cosf*sins - sinf*cosd*coss
      a13= - sinf*sind
      a21= -sins*sind
      a22= coss*sind
      a23= - cosd
      f1=a11
      f2=a12
      f3=a13
      v1=a21
      v2=a22
      v3=a23
      return
      end
      subroutine gcmdln(dip,slip,strike,iexpl,iverby,xmom,
     1            az,baz,irot)
      parameter (LER=0, LIN=5, LOT=6)
c-----
c     parse command line arguments
c
c     requires subroutine getarg() and function numarg()
c
c-----
      character*25 name
      integer*4 numarg
      dip = 0.0
      slip = 0.0
      strike = 0.0
      iexpl=0
      iverby=0
      xmom=1.0
      az=0.0
      baz=0.0
	irot = 0.0
      nmarg=numarg()
      if(nmarg.le.0)then
            write(LER,*)'mech -d D -s S -l L -m M -x -a A -b B -v -r'
            stop
      endif
      i = 0
   11 i = i + 1
      if(i.gt.nmarg)go to 13
            call getarg(i,name)
            if(name(1:2).eq.'-d')then
                  i=i+1
                  call getarg(i,name)
                  read(name,'(f10.0)')dip
            else if(name(1:2).eq.'-s')then
                  i=i+1
                  call getarg(i,name)
                  read(name,'(f10.0)')strike
            else if(name(1:2).eq.'-l')then
                  i=i+1
                  call getarg(i,name)
                  read(name,'(f10.0)')slip
            else if(name(1:2).eq.'-m')then
                  i=i+1
                  call getarg(i,name)
                  read(name,'(f10.0)')xmom
            elseif(name(1:2).eq.'-a')then
                  i=i+1
                  call getarg(i,name)
                  read(name,'(f10.0)')az
            elseif(name(1:2).eq.'-b')then
                  i=i+1
                  call getarg(i,name)
                  read(name,'(f10.0)')baz
            else if(name(1:2).eq.'-x')then
                  iexpl = 1
            else if(name(1:2).eq.'-v')then
                  iverby = 1
		else if(name(1:2).eq.'-r')then
			irot = 1
            endif
      goto 11
   13 continue
      return
      end

      subroutine mchdep()
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME VI                                                      c
c                                                                     c
c      PROGRAM: MCHDEP                                                c
c                                                                     c
c      COPYRIGHT 1985                                                 c
c      R. B. Herrmann                                                 c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      return
      end

	function numarg()
	integer numarg
	numarg = iargc()
	return
	end

c
c
c
c  changes
c
c  feb 03 2003  by jh : put in computer indpendent intand instead of unix
c                       only version
c
c
c
c
C******************************************************************************
c#    The following data compression and decompression routines have
c#    been developped by Dr. Shane Ingate and Dr. Ken Muirhead, at the
c#    Australian Seismological Centre, Bureau of Mineral Resources,
c#    Canberra, Australia.
c#    They provided me with these routines in March 1989 during the
c#    session of the Group of Scientific Experts (GSE) in Geneva.
c#    These compression/decompression algorithms are used by all members
c#    of the GSE during the large-scale data exchange experiment GSETT-2,
c#    carried out from 1989 to 1991.
c#    It is recommended to use second differences and the six-bit compression.
c#    The second differences can be computed by two subsequent calls of
c#    subroutine DIF1 (see above).
c#    These routines are already running on many different machines.
c#    Because the AND function is not standard FORTRAN 77, this operation
c#    has been moved to a separate subroutine INTAND. All users of these
c#    routines will have to modify INTAND so that it performs correctly on
c#    their computers.
c#                                 Urs Kradolfer, Swiss Seismological Service
c#
C******************************************************************************
C                                                                       *
C     SUBROUTINE CMPRS6(LX,IX,LC,CBUFF,IERROR)                          *
C                                                                       *
C     ROUTINE TO COMPRESS INTEGER DATA INTO PRINTABLE ASCII CHARACTERS. *
C     INPUTS ARE INTEGER*4 ARRAY IX OF LENGTH LX.                       *
C     LC SHOULD CONTAIN THE DIMENSION OF THE ARRAY CBUFF.               *
C     OUTPUTS ARE CHARACTER*1 ARRAY CBUFF CONTAINING LC CHARACTERS.     * 
C     IF THE ARRAY CBUFF IS NOT LARGE ENOUGH TO CONTAIN ALL OF THE DATA *
C     IERROR IS SET TO -1, OTHERWISE IT IS SET TO ZERO.                 *
C     OUTPUT IS PADDED TO A MULTIPLE OF 80 CHARACTERS USING SPACES.     *
C                                                                       *
C     METHOD OF COMPRESSION IS TO USE THE 6 LEAST SIGNIFICANT SIX BITS  *
C     OF AN EIGHT BIT BYTE SO THAT ALL DATA CAN BE TRANSMITTED AS ASCII *
C     CHARACTERS.                                                       *
C     OF THESE SIX BITS, THE MOST SIGNIFICANT IS USED AS A CONTINUATION *
C     BIT. IF IT IS SET TO ONE THE FOLLOWING BYTE ALSO FORMS PART OF    *
C     THE PRESENT SAMPLE. IF ZERO, THIS IS THE LAST BYTE IN THE SAMPLE. *
C     THE SECOND LEAST SIGNIFICANT BIT IS USED AS A SIGN BIT IN THE     *
C     FIRST BYTE AND FOR DATA IN SUBSEQUENT BYTES (ORIGINAL DATA IS     *
C     FIRST CONVERTED TO SIGN AND MAGNITUDE). ALL OTHER BITS OF FIRST   *
C     AND SUBSEQUENT BYTES FORM THE MAGNITUDE OF THE NUMBER.            *
C                                                                       *
C     TO ENABLE TRANSMISSION OVER AS MANY LINKS AS POSSIBLE DATA IS     *
C     FURTHER TRANSFORMED TO THE CHARACTERS +,-,0 - 9,A - Z, a - z      *
C     USING A LOOKUP TABLE.                                             *
C                                                                       *
C     SUBROUTINES CALLED INTAND (THIS SUBROUTINE IS MACHINE SPECIFIC)   *
C                                                                       *
C     DATA MAY BE DECOMPRESSED USING SUBROUTINE DCOMP6.                 *
C                                                                       *
C************************************************************************ 
C
      SUBROUTINE CMPRS6(LX,IX,LC,CBUFF,IERROR)
      IMPLICIT INTEGER*4 (I-N)
cuk      CHARACTER *1 CBUFF(4),TEMP(4),TEST(4),ACHAR(64),BLANK
cuu91      CHARACTER *1 CBUFF(1),TEMP(4),TEST(4),ACHAR(64),BLANK
      CHARACTER *1 CBUFF(lc),TEMP(4),TEST(4),ACHAR(64),BLANK
cuu91      INTEGER *4 IX(1)
      INTEGER *4 IX(lx)
      EQUIVALENCE (J,TEMP(1)),(TEST,ITEST)
      DATA TEST/'1','2','3','4'/
      DATA ACHAR / '+','-','0','1','2','3','4','5','6','7','8','9','A',
     1 'B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q',
     2 'R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g',
     3 'h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w',
     4 'x','y','z'/
      DATA BLANK /' '/
      DATA N4/16/, N5/32/, N5M1/31/, N6/64/, N9/512/, N10/1024/, 
     1 N10M1/1023/, N14/16384/, N15/32768/, N15M1/32767/, N19/524288/, 
     2 N20/1048576/, N20M1/1048575/, N24/16777216/, N25/33554432/, 
     3 N25M1/33554431/, N28/134217728/, N28M1/134217727/
      IERROR = 0
      IMAX = LC
      MFLAG = N5
      IOFF = 0
      DO 60 I = 1,LX
        JN = IX(I)
C       SET NFLAG TO 1 TO POINT TO FIRST ELEMENT IN LOOKUP TABLE
        NFLAG = 1
C
C       SEE IF NUMBER IS -VE IF SO CONVERT TO SIGN AND MAGNITUDE.
C
        IF(JN .LT. 0) THEN
           NFLAG = NFLAG + N4
           JN = -JN
        END IF
        IF(JN .LT. N4) GO TO 50
C        IF HERE, DATA REQUIRES MORE THAN 1 BYTE
         IF(JN .LT. N9) GO TO 40
C         IF HERE, DATA REQUIRES MORE THAN 2 BYTES
          IF(JN .LT. N14) GO TO 30
C          IF HERE, DATA REQUIRES MORE THAN 3 BYTES.
           IF(JN. LT. N19) GO TO 20
C           IF HERE, DATA REQUIRES MORE THAN 4 BYTES.
            IF(JN. LT. N24) GO TO 10
C            IF HERE, DATA REQUIRES MORE THAN 5 BYTES.
             IF(JN .GT. N28M1) JN=N28M1
C            FILL A BYTE IF HERE NUMBER WILL REQUIRE SIX BYTES
             J = JN/N25 + NFLAG + MFLAG
             IOFF = IOFF + 1
             CBUFF(IOFF) = ACHAR(J)
             CALL INTAND(JN,N25M1,JN)
             NFLAG = 1
   10       CONTINUE
C           FIVE CHARACTERS TO GO
            J = JN/N20 + NFLAG + MFLAG
            IOFF = IOFF + 1
            IF (IOFF .GT. IMAX) GO TO 80
            CBUFF(IOFF) = ACHAR(J)
            CALL INTAND(JN,N20M1,JN)
            NFLAG = 1
   20      CONTINUE
C          FOUR CHARACTERS TO GO
           J = JN/N15 + NFLAG + MFLAG
           IOFF = IOFF + 1
           IF (IOFF .GT. IMAX) GO TO 80
           CBUFF(IOFF) = ACHAR(J)
           CALL INTAND(JN,N15M1,JN)
           NFLAG = 1
   30     CONTINUE
C         THREE CHARACTERS TO GO
          J = JN/N10 + NFLAG + MFLAG
          IOFF = IOFF + 1
          IF (IOFF .GT. IMAX) GO TO 80
          CBUFF(IOFF) = ACHAR(J)
          CALL INTAND(JN,N10M1,JN)
          NFLAG = 1
   40    CONTINUE
C        TWO CHARACTERS TO GO
         J = JN/N5 + NFLAG + MFLAG
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 80
         CBUFF(IOFF) = ACHAR(J)
         CALL INTAND(JN,N5M1,JN)
         NFLAG = 1
   50   CONTINUE
C       ONE CHARACTER TO GO
        J = JN + NFLAG
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 80
        CBUFF(IOFF) = ACHAR(J)
   60 CONTINUE
C     NOW MAKE OUTPUT BUFFER UP TO A MULTIPLE OF 80 CHARACTERS
C     WITH BLANKS
      K = 80 - (IOFF - ((IOFF/80) * 80))
      IF (K .LT. 2) K = K + 80
C     PUT IN AT LEAST TWO ADJACENT SPACE CHARACTERS TO ASSIST IN
C     DECODING
      DO 70 I = 1, K
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 80
         CBUFF(IOFF) = BLANK
   70 CONTINUE
   80 CONTINUE
      LC = IOFF
      IF (IOFF .GT. IMAX) THEN
         LC = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C******************************************************************
C                                                                 *
C     SUBROUTINE CMPRS7(LX,IX,LC,CBUFF,IERROR)                    *
C                                                                 *
C     ROUTINE TO WORD-COMPRESS DATA INTO 7 BIT BYTES.             *
C     INPUTS ARE INTEGER*4 ARRAY IX CONTAINING LX VALUES TO BE    *
C     COMPRESSED INTO 7 BIT BYTES. THE MOST SIGNIFICANT BIT OF    *
C     EACH BYTE IS NOT USED.                                      *
C     ON ENTRY LC SHOULD CONTAIN DIMENSIONED LENGTH OF CBUFF.     *
C     OUTPUTS ARE CHARACTER*1 ARRAY CBUFF WITH LC MODIFIED TO     * 
C     REFLECT THE NUMBER OF BYTES WHICH HAVE BEEN PUT INTO CBUFF. *
C     LC IS MADE A MULTIPLE OF 80 USING UNIQUE FILL CHARACTERS.   *
C     IF CBUFF IS TOO SMALL TO CONTAIN ALL COMPRESSED DATA        *
C     IERROR WILL CONTAIN -1 OTHERWISE IT WILL BE SET TO ZERO.    *
C     METHODOLOGY IS THAT THE MOST SIGNIFICANT BIT OF EACH BYTE   *
C     IS SET TO ONE IF NEXT BYTE CONTAINS INFORMATION PERTAINING  *
C     TO THE SAME SAMPLE. IN THE FIRST BYTE PERTAINING TO EACH    *
C     SAMPLE, THE SECOND MOST SIGNIFICANT BIT IS USED AS A SIGN   *
C     BIT. THE LEAST SIGNIFICANT 5 BITS OF THE FIRST BYTE AND     *
C     THE LEAST SIGNIFICANT SIX BITS OF ANY SUBSEQUENT BYTE       *
C     PERTAINING TO THE SAME SAMPLE ARE COMPRESSED TOGETHER ON    *
C     DECODING TO GIVE THE MAGNITUDE OF THE SAMPLE.               * 
C     USING THIS COMPRESSION SCHEME THE CODES                     *
C     1000000  1000000  AND 1000000  0000001 WOULD NOT NORMALLY BE*
C     TRANSMITTED (AKIN TO NOT TRANSMITTING LEADING ZEROS).       *
C     THESE TWO PATTERNS ARE USED AS CONTROL PATTERNS.            *
C     THE PATTERN 1000000 1000000 SIGNIFIES THE END OF THE DATA   *
C     AND IS USED TO FILL UP TO A MULTIPLE OF EIGHTY CHARACTERS.  *
C     THE PATTERN 1000000  0000001 INDICATES THAT 32 SHOULD BE    *
C     SUBTRACTED FROM THE PREVIOUS SAMPLE. USING THIS METHODOLOGY,*
C     ANY CONTROL CHARACTER WITH INTEGER VALUE LESS THAN 32       *
C     WHICH A COMMUNICATION LINK WONT ACCEPT CAN BE MODIFIED BY   *
C     ADDING 32 TO IT. THE 32 WILL BE SUBTRACTED ON DECOMPRESSION.*
C     DATA MAY BE DECOMPRESSED USING SUBROUTINE DCOMP7.           *
C                                                                 *
C     SUBROUTINES CALLED   ---   INTAND   ---   CHEKBT   ---      * 
C                                                                 *
C******************************************************************
C
      SUBROUTINE CMPRS7(LX,IX,LC,CBUFF,IERROR)
      IMPLICIT INTEGER*4 (I-N)
cuk      CHARACTER*1 CBUFF(4),TEMP(4),TEST(4),NCNTRL
cuu91      CHARACTER*1 CBUFF(1),TEMP(4),TEST(4),NCNTRL
      CHARACTER*1 CBUFF(lc),TEMP(4),TEST(4),NCNTRL
cuu91      INTEGER *4 IX(*)
      INTEGER *4 IX(lx)
      EQUIVALENCE (J,TEMP),(TEST,ITEST)
      DATA TEST/'1','2','3','4'/
      DATA N5/32/,
     *     N6/64/,        N6M1/63/,
     *     N11/2048/,
     *     N12/4096/,     N12M1/4095/,
     *     N17/131072/,
     *     N18/262144/,   N18M1/262143/,
     *     N23/8388608/,
     *     N24/16777216/, N24M1/16777215/,
     *     N27/134217728/,N27M1/134217727/
C
C     WORK OUT WHICH WAY BYTES ARE STORED IN A COMPUTER WORD
      IBYTE = 4
      IF(ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
C
      NCNTRL = CHAR(64)
C     NCNTRL IS A 7 BIT BYTE WITH BIT PATTERN 1000000
      MFLAG = N6
      IMAX = LC
      IERROR = 0
      IOFF = 0
      DO 100 II = 1,LX
        IONLY = 0
        JN = IX(II)
C
C       GET SIGN AND MAGNITUDE OF SAMPLE
C
        NFLAG = 0
        IF(JN .LT. 0) THEN
           NFLAG = N5
           JN = -JN
        END IF
        IF(JN .LT. N5) GO TO 40
         IONLY = 1
C        IF HERE, DATA REQUIRES MORE THAN 1 BYTE
         IF(JN .LT. N11) GO TO 30
C         IF HERE, DATA REQUIRES MORE THAN 2 BYTES
          IF(JN. LT. N17) GO TO 20
C          IF HERE, DATA REQUIRES MORE THAN 3 BYTES.
           IF(JN. LT. N23) GO TO 15
C           IF HERE, DATA REQUIRES MORE THAN 4 BYTES.
            IF(JN. GT. N27M1) JN=N27M1
C           FILL A BYTE
            J = JN/N24 + NFLAG + MFLAG
            IOFF = IOFF + 1
            IF (IOFF .GT. IMAX) GO TO 120
            CBUFF(IOFF) = TEMP(IBYTE)
            CALL INTAND(JN,N24M1,JN)
            NFLAG = 0
   15      CONTINUE
C          FOUR MORE BYTES TO GO
           J = JN/N18 + NFLAG + MFLAG
           IOFF = IOFF + 1
           IF (IOFF .GT. IMAX) GO TO 120
           CBUFF(IOFF) = TEMP(IBYTE)
           CALL INTAND(JN,N18M1,JN)
           NFLAG = 0
   20     CONTINUE
C         THREE MORE BYTES TO GO
          J = JN/N12 + NFLAG + MFLAG
          IOFF = IOFF + 1
          IF (IOFF .GT. IMAX) GO TO 120
          CBUFF(IOFF) = TEMP(IBYTE)
          CALL INTAND(JN,N12M1,JN)
          NFLAG = 0
   30    CONTINUE
C        TWO MORE BYTES TO GO
         J = JN/N6 + NFLAG + MFLAG
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = TEMP(IBYTE)
         CALL INTAND(JN,N6M1,JN)
         NFLAG = 0
   40   CONTINUE
C       ONE MORE BYTE TO GO
        J = JN + NFLAG
C       CHECK AND MODIFY BYTE IF IT CANNOT BE TRANSMITTED
        CALL CHEKBT(TEMP(IBYTE),NSTAT,IBYTE)
C       IF CHARACTER HAS BEEN MODIFIED AND ONLY ONE CHARACTER IN WORD
C       NEED A CHARACTER WITH A CONTINUE BIT - CHECK AND PUT IN IF
C       REQUIRED
        IF (NSTAT .NE. 0) THEN
          IF(IONLY .EQ. 0) THEN
             IOFF = IOFF + 1
             IF (IOFF .GT. IMAX) GO TO 120
             CBUFF(IOFF) = CHAR(64)
          ENDIF
        ENDIF
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
        IF (NSTAT .EQ. 0) GO TO 100
C       CHARACTER WAS MODIFIED PUT OUT THE CODE 1000000 0000001 TO
C       INDICATE THAT IT WAS
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = NCNTRL
        J = 1
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
  100 CONTINUE
C     FINISHED COMPRESSING NOW MAKE UP TO A MULTIPLE OF 80 CHARACTERS
C     FIND OUT HOW MANY CHARACTERS TO PUT IN
      K = 80 - (IOFF - ((IOFF/80) * 80))
      IF (K .LT. 2) K = K + 80
C     FILL TO A MULTIPLE OF 80 CHARACTERS WITH REPEATS OF 
C     THE BIT PATTERN 1000000
      DO 110 I = 1,K
         IOFF = IOFF + 1
         IF(IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = NCNTRL
  110 CONTINUE
  120 CONTINUE
      LC = IOFF
      IF (IOFF .GT. IMAX) THEN
         LC = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C******************************************************************
C                                                                 *
C     SUBROUTINE CMPRS8(LX,IX,LC,CBUFF,IERROR)                    *
C                                                                 *
C     ROUTINE TO WORD-COMPRESS DATA INTO 8 BIT BYTES.             *
C     INPUTS ARE INTEGER*4 ARRAY IX CONTAINING LX VALUES TO BE    *
C     COMPRESSED INTO 8 BIT BYTES.                                *
C     ON ENTRY LC SHOULD CONTAIN DIMENSIONED LENGTH OF CBUFF.     *
C     OUTPUTS ARE CHARACTER*1 ARRAY CBUFF WITH LC MODIFIED TO     * 
C     REFLECT THE NUMBER OF BYTES WHICH HAVE BEEN PUT INTO CBUFF. *
C     LC IS MADE A MULTIPLE OF 80 USING UNIQUE FILL CHARACTERS.   *
C     IF CBUFF IS TOO SMALL TO CONTAIN ALL COMPRESSED DATA        *
C     IERROR WILL CONTAIN -1 OTHERWISE IT WILL BE SET TO ZERO.    *
C     METHODOLOGY IS THAT THE MOST SIGNIFICANT BIT OF EACH BYTE   *
C     IS SET TO ONE IF NEXT BYTE CONTAINS INFORMATION PERTAINING  *
C     TO THE SAME SAMPLE. IN THE FIRST BYTE PERTAINING TO EACH    *
C     SAMPLE, THE SECOND MOST SIGNIFICANT BIT IS USED AS A SIGN   *
C     BIT. THE LEAST SIGNIFICANT 6 BITS OF THE FIRST BYTE AND     *
C     THE LEAST SIGNIFICANT SEVEN BITS OF ANY SUBSEQUENT BYTE     *
C     PERTAINING TO THE SAME SAMPLE ARE COMPRESSED TOGETHER ON    *
C     DECODING TO GIVE THE MAGNITUDE OF THE SAMPLE.               * 
C     USING THIS COMPRESSION SCHEME THE CODES                     *
C     10000000 10000000 AND 10000000 00000001 WOULD NOT NORMALLY  *
C     BE TRANSMITTED (AKIN TO NOT TRANSMITTING LEADING ZEROS)     *
C     THESE TWO PATTERNS ARE USED AS CONTROL PATTERNS.            *
C     THE PATTERN 10000000 10000000 SIGNIFIES THE END OF THE DATA *
C     AND IS USED TO FILL UP TO A MULTIPLE OF EIGHTY CHARACTERS.  *
C     THE PATTERN 10000000 0000001 INDICATES THAT 32 SHOULD BE    *
C     SUBTRACTED FROM THE PREVIOUS SAMPLE. USING THIS METHODOLOGY *
C     ANY CONTROL CHARACTER WHICH A COMMUNICATION LINK WONT ACCEPT*
C     CAN BE MODIFIED BY ADDING 32 TO IT. THE 32 WILL BE SUB-     *
C     TRACTED ON DECOMPRESSION                                    *
C     DATA MAY BE DECOMPRESSED USING SUBROUTINE DCOMP8            *
C                                                                 *
C     SUBROUTINES CALLED   ---   INTAND   ---   CHEKBT   ---      * 
C                                                                 *
C******************************************************************
C
      SUBROUTINE CMPRS8(LX,IX,LC,CBUFF,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      CHARACTER *1 CBUFF(4),TEMP(4),TEST(4),NCNTRL
cuu91      CHARACTER *1 CBUFF(1),TEMP(4),TEST(4),NCNTRL
      CHARACTER *1 CBUFF(lc),TEMP(4),TEST(4),NCNTRL
cuu91      INTEGER *4 IX(*)
      INTEGER *4 IX(lx)
      EQUIVALENCE (J,TEMP),(TEST,ITEST)
      DATA TEST/'1','2','3','4'/
      DATA N5/32/,
     *     N6/64/,
     *     N7/128/,       N7M1/127/,
     *     N12/4096/,
     *     N13/8192/,
     *     N14/16384/,    N14M1/16383/,
     *     N19/524288/,
     *     N20/1048576/,
     *     N21/2097152/,  N21M1/2097151/,
     *     N26/67108864/, N28M1/268435455/
      IBYTE = 4
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IF(ITEST .EQ. (((52*256+51)*256+50)*256+49)) IBYTE = 1
      J = N7 
      NCNTRL = TEMP(IBYTE)
C     NCNTRL IS AN EIGHT BIT BYTE WITH BIT PATTERN 10000000
C
      MFLAG = N7
      IOFF = 0
      IMAX = LC
      IERROR = 0 
      DO 100 II = 1,LX
        IFIX = 0
        JN = IX(II)
C
C       SEE IF NUMBER IS -VE.
C
        NFLAG = 0
        IF(JN .LT. 0) THEN
           NFLAG = N6
           JN = -JN
        END IF
        IF(JN .LT. N6) GO TO 40
C        IF HERE, DATA REQUIRES MORE THAN 1 BYTE
         IF(JN. LT. N13) GO TO 30
C         IF HERE, DATA REQUIRES MORE THAN 2 BYTES
          IF(JN. LT. N20) GO TO 20
C          IF HERE, DATA REQUIRES MORE THAN THREE BYTES
           IF(JN. GT. N28M1) JN = N28M1
C          FILL A BYTE
           J = JN/N21 + NFLAG + MFLAG
           IOFF = IOFF + 1
           IF (IOFF .GT. IMAX) GO TO 120
           CBUFF(IOFF) = TEMP(IBYTE)
           CALL INTAND(JN,N21M1,JN)
           NFLAG = 0
   20     CONTINUE
C         IF HERE, DATA REQUIRES THREE MORE BYTES
          J = JN/N14 + NFLAG + MFLAG
          IOFF = IOFF + 1
          IF (IOFF .GT. IMAX) GO TO 120
          CBUFF(IOFF) = TEMP(IBYTE)
          CALL INTAND(JN,N14M1,JN)
          NFLAG = 0
   30    CONTINUE
C        IF HERE, DATA REQUIRES TWO MORE BYTES
         J = JN/N7 + NFLAG + MFLAG
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = TEMP(IBYTE)
         CALL INTAND(JN,N7M1,JN)
         NFLAG = 0
   40   CONTINUE
C       FILL IN LAST REMAINING BYTE
        J = JN + NFLAG
C       CHECK AND MODIFY BYTE IF IT CANNOT BE TRANSMITTED
        CALL CHEKBT(TEMP(IBYTE),NSTAT,IBYTE)
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
        IF(NSTAT .EQ. 0) GO TO 100
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = NCNTRL
        J = 1
        IOFF = IOFF + 1
        IF (IOFF .GT. IMAX) GO TO 120
        CBUFF(IOFF) = TEMP(IBYTE)
  100 CONTINUE
C     FINISHED COMPRESSING NOW MAKE UP TO A MULTIPLE OF 80 CHARACTERS
C     FIND HOW MANY CHARACTERS TO PUT IN
      K = 80 - (IOFF - ((IOFF/80) * 80))
      IF (K .LE. 2) K = K + 80
C     NEED AT LEAST TWO NCNTRL CHARACTERS TOGETHER FOR UNIQUENESS
      DO 110 I = 1,K
         IOFF = IOFF + 1
         IF (IOFF .GT. IMAX) GO TO 120
         CBUFF(IOFF) = NCNTRL
  110 CONTINUE
  120 CONTINUE
      LC = IOFF 
      IF ( IOFF .GT. IMAX) THEN
        LC = IMAX
        IERROR = -1
      ENDIF
      RETURN
      END
C***********************************************************************
C                                                                      *
C     SUBROUTINE DCOMP6(LB,IBUF,LOUT,IOUT,IERROR)                      *
C                                                                      *
C     SUBROUTINE DECOMPRESS INTEGER DATA THAT HAS BEEN COMPRESSED      *
C     INTO ASCII CHARACTERS AND RETURNS VALUES IN INTEGER *4 FORMAT    *
C     SEE SUBROUTINE CMPRS6 FOR COMPRESSION FORMAT                     *
C     INPUT - IBUF AN ARRAY OF CONTAINING  LB CHARACTERS.              *
C     LOUT SHOULD CONTAIN THE DIMENSION OF THE INTEGER *4 ARRAY IOUT.  * 
C     ON RETURN ARRAY LOUT WILL BE SET TO CONTAIN THE NUMBER OF INTEGER*
C     VALUES WHICH HAVE BEEN PUT IN THE ARRAY IOUT.                    *
C     IF THE ARRAY IOUT IS NOT LARGE ENOUGH TO CONTAIN ALL OF THE      *
C     DECOMPRESSED VALUES IERROR WILL BE SET TO -1 OTHERWISE IT WILL   *
C     SET TO ZERO                                                      *
C***********************************************************************
C
      SUBROUTINE DCOMP6(LB,IBUF,LOUT,IOUT,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      INTEGER *4 IOUT(*),ICHAR(128)
cuu91      INTEGER *4 IOUT(1),ICHAR(128)
      INTEGER *4 IOUT(lout),ICHAR(128)
cuu91      CHARACTER *1 IBUF(1), ACHAR(4), TEST(4)
      CHARACTER *1 IBUF(lb), ACHAR(4), TEST(4)
      CHARACTER *1 ASPACE,LFEED,CRETN
      EQUIVALENCE (INN,ACHAR),(ITEST,TEST)
      DATA TEST/'1','2','3','4'/
      data ichar/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     1 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     2 0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,2,
     3 3,4,5,6,7,8,9,10,11,0,0,0,0,0,0,0,
     4 12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,
     5 28,29,30,31,32,33,34,35,36,37,0,0,0,0,0,0,
     6 38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,
     7 54,55,56,57,58,59,60,61,62,63,0,0,0,0,0,0/
      IERROR = 0
      CRETN = CHAR(13)
      LFEED = CHAR(10)
      ASPACE = CHAR(32)
      IMAX = LOUT
      ISIGN = 16
      IOFLOW = 32
      MASK1 = 15
      MASK2 = 31
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IBYTE = 4
      IF (ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
      ICOUNT = 0
      I = 0
      J = 0
C     START OF DECODING
   1  CONTINUE
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       IF A CARRIAGE OR LINE FEED IGNORE, IF A SPACE THEN END OF DATA
        IF (ACHAR(IBYTE) .EQ. CRETN) GO TO 1 
        IF (ACHAR(IBYTE) .EQ. LFEED) GO TO 1 
        IF (ACHAR(IBYTE) .EQ. ASPACE) GO TO 5
        ICOUNT = ICOUNT + 1
C       STRIP OFF ANY HIGHER ORDER BITS
        CALL INTAND(INN,127,K)
C       GET NUMBER REPRESENTION OF INPUT CHARACTER
        INN = ICHAR(K)
C       GET SIGN BIT
        CALL INTAND(INN,ISIGN,JSIGN)
C       GET CONTINUATION BIT (IF ANY)
        CALL INTAND(INN,IOFLOW,JOFLOW)
C       REMOVE BITS WE DONT WANT
        CALL INTAND(INN,MASK1,ITEMP)
   2    CONTINUE
          IF(JOFLOW.EQ.0) GO TO 4
C         THERE IS ANOTHER BYTE IN THIS SAMPLE
          ITEMP = ITEMP * 32
   3        CONTINUE
            I = I + 1
            ACHAR(IBYTE) = IBUF(I)
          IF (ACHAR(IBYTE) .EQ. CRETN) GO TO 3 
          IF (ACHAR(IBYTE) .EQ. LFEED) GO TO 3 
          ICOUNT = ICOUNT + 1
C         STRIP OFF ANY HIGHER ORDER BITS
          CALL INTAND(INN,127,K)
          INN = ICHAR(K)
C         GET CONTINUATION BIT (IF ANY)
          CALL INTAND(INN,IOFLOW,JOFLOW)
          CALL INTAND(INN,MASK2,K)
          ITEMP = ITEMP + K
        GO TO 2
   4    CONTINUE
        IF (JSIGN.NE.0) ITEMP = -ITEMP
        J = J +1
        IF (J .GT. IMAX) GO TO 5
        IOUT(J) = ITEMP
      IF(ICOUNT.LT.LB) GO TO 1
   5  CONTINUE
      LOUT = J
      IF (J .GT. IMAX) THEN
         LOUT = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C************************************************************************
C                                                                       *
C     SUBROUTINE DCOMP7(LB,IBUF,LOUT,IOUT,IERROR)                       *
C                                                                       *
C     SUBROUTINE DECOMPRESS INTEGER DATA THAT HAS BEEN COMPRESSED       *
C     INTO 7 BIT CHARACTERS AND RETURNS VALUES IN INTEGER *4 FORMAT.    *
C     SEE SUBROUTINE CMPRS7 FOR COMPRESSION FORMAT.                     *
C     INPUT - IBUF AN ARRAY OF CHARACTERS OF LENGTH LB.                 *
C     LOUT SHOULD CONTAIN THE LENGTH OF THE INTEGER *4 OUTPUT ARRAY IOUT*
C     ON RETURN ARRAY IOUT WILL CONTAIN LOUT INTEGER VALUES.            *
C     IF THE ARRAY IOUT WAS LARGE ENOUGH TO CONTAIN ALL CONVERTED       *
C     VALUES, IERROR WILL CONTAIN ZERO. IF NOT IT WILL BE SET TO -1     *
C                                                                       *
C************************************************************************
C
      SUBROUTINE DCOMP7(LB,IBUF,LOUT,IOUT,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      INTEGER *4 IOUT(*)
cuu91      INTEGER *4 IOUT(1)
      INTEGER *4 IOUT(lout)
cuu91      CHARACTER *1 IBUF(1),ACHAR(4),TEST(4)
      CHARACTER *1 IBUF(lb),ACHAR(4),TEST(4)
      EQUIVALENCE (INN,ACHAR),(ITEST,TEST)
      DATA TEST/'1','2','3','4'/
      DATA ISIGN/32/, IOFLOW/64/, MASK1/31/, MASK2/63/
      DATA ICORR/32/, MASK3/127/, NCNTRL/64/
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IBYTE = 4
      IF (ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
      I = 0
      J = 0
      IMAX = LOUT
C     START OF DECODING
   1  CONTINUE
        IEND = 0
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       REMOVE MOST SIGNIFICANT BIT - NOT USED
        CALL INTAND(INN,MASK3,INN)
C       TEST IF CHARACTER IS EQUAL TO NCNTRL
        IF (INN .EQ. NCNTRL) IEND =  1
C       GET SIGN BIT
        CALL INTAND(INN,ISIGN,JSIGN)
C       GET CONTINUATION BIT
        CALL INTAND(INN,IOFLOW,JOFLOW)
C       REMOVE SIGN AND CONTINUATION BITS
        CALL INTAND(INN,MASK1,ITEMP)
   2    CONTINUE
        IF(JOFLOW .EQ. 0) GO TO 3
C       THERE IS ANOTHER BYTE IN THIS SAMPLE
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       REMOVE MOST SIGNIFICANT BIT - NOT USED
        CALL INTAND(INN,MASK3,INN)
C       TEST IF CHARACTER IS EQUAL TO NCNTRL 
        IF (IEND .EQ. 1) THEN
           IF (INN .EQ. NCNTRL) GO TO 4
C          BIT PATTERN 1000000 FOLLOWED BY 1000000 MEANS END OF DATA
C          SEE IF PREVIOUS SAMPLE HAS TO BE MODIFIED
            IF (INN .LT. 16) THEN
               ITEMP = ICORR
C              SUBTRACT CORRECTION FROM PREVIOUS SAMPLE
               IF (IOUT(J) .LT. 0) ITEMP = -ITEMP
               IOUT(J) = IOUT(J) - ITEMP
               GO TO 1
           ENDIF
      ENDIF
      IEND = 0
C     GET CONTINUATION BIT
      CALL INTAND(INN,IOFLOW,JOFLOW)
      CALL INTAND(INN,MASK2,K)
C     SHIFT WHAT WE HAVE 6 BITS LEFT AND ADD IN NEW BITS
      ITEMP = ITEMP * 64 + K
      GO TO 2
   3  CONTINUE
      IF(JSIGN .NE. 0) ITEMP = -ITEMP
      J = J + 1
      IF (J .GT. IMAX) GO TO 4
      IOUT(J) = ITEMP
      IF(I. LT. LB) GO TO 1
   4  CONTINUE
      LOUT = J
      IF (J .GT. IMAX) THEN
         LOUT = IMAX
         IERROR = -1
      ENDIF
      RETURN
      END
C************************************************************************
C     SUBROUTINE DCOMP8(LB,IBUF,LOUT,IOUT,IERROR)                       *
C     SUBROUTINE DECOMPRESS INTEGER DATA THAT HAS BEEN COMPRESSED       * 
C     INTO 8 BIT CHARACTERS AND RETURNS VALUES IN INTEGER *4 FORMAT.    *
C     SEE SUBROUTINE CMPRS8 FOR COMPRESSION FORMAT.                     *
C     INPUT - IBUF AN ARRAY OF CHARACTERS OF LENGTH LB.                 *
C     LOUT SHOULD CONTAIN THE LENGTH OF THE INTEGER *4 OUTPUT ARRAY IOUT*
C     ON RETURN ARRAY IOUT WILL CONTAIN LOUT INTEGER VALUES.            *
C     IF THE ARRAY IOUT WAS LARGE ENOUGH TO CONTAIN ALL CONVERTED       *
C     VALUES IERROR WILL CONTAIN ZERO. IF NOT IT WILL BE SET TO -1      *
C************************************************************************
      SUBROUTINE DCOMP8(LB,IBUF,LOUT,IOUT,IERROR)
      IMPLICIT INTEGER *4 (I-N)
cuk      INTEGER *4 IOUT(*)
cuu91      INTEGER *4 IOUT(1)
      INTEGER *4 IOUT(lout)
cuu91      CHARACTER *1 IBUF(1),ACHAR(4),TEST(4)
      CHARACTER *1 IBUF(lb),ACHAR(4),TEST(4)
      EQUIVALENCE (INN,ACHAR),(ITEST,TEST)
      DATA TEST/'1','2','3','4'/
      DATA N5/32/,N12/4096/,N19/524288/,N26/67108864/
      DATA ISIGN/64/,IOFLOW/128/,MASK1/63/,MASK2/127/
      DATA NCNTRL/128/,ICORR/32/
C     WORK OUT WHICH WAY BYTES ARE STORED IN COMPUTER
      IBYTE = 4
      IF (ITEST.EQ.(((52*256+51)*256+50)*256+49)) IBYTE = 1
      I = 0
      J = 0
      IERROR = 0
      IMAX = LOUT
C     START OF DECODING
   1  CONTINUE
        IEND = 0
        ISUB = 0
        I = I + 1
        ACHAR(IBYTE) = IBUF(I)
C       TEST IF CHARACTER IS EQUAL TO NCNTRL (100000000)
        IF(INN.EQ.NCNTRL) IEND = 1
C       GET SIGN BIT
        CALL INTAND(INN,ISIGN,JSIGN)
C       GET CONTINUATION BIT
        CALL INTAND(INN,IOFLOW,JOFLOW)
C       REMOVE SIGN AND CONTINUATION BITS
        CALL INTAND(INN,MASK1,ITEMP)
   2    CONTINUE
          IF(JOFLOW.EQ.0) GO TO 3
C         THERE IS ANOTHER BYTE IN THIS SAMPLE
          I = I + 1
          ACHAR(IBYTE) = IBUF(I)
C         TEST IF CHARACTER IS EQUAL TO NCNTRL 
          IF (IEND.EQ.1) THEN
             IF (INN .EQ. NCNTRL) GO TO 100
C            IF TWO CONTROL CHARACTERS IN A ROW THEN END OF DATA
C            SEE IF PREVIOUS SAMPLE HAS TO BE MODIFIED
             IF (INN.LT.16) THEN
                ITEMP = ICORR
C               NOW SUBTRACT CORRECTION FROM PREVIOUS SAMPLE
                IF (IOUT(J).LT.0) ITEMP = - ITEMP 
                IOUT(J) = IOUT(J) - ITEMP
              GO TO 1
             ENDIF 
          ENDIF 
          IEND = 0
          ISUB = 0
C         GET CONTINUATION BIT
          CALL INTAND(INN,IOFLOW,JOFLOW)
C         MASK OFF CONTINUATION BIT
          CALL INTAND(INN,MASK2,K)
C         SHIFT WHAT WE HAVE SO FAR 7 BITS LEFT AND ADD IN NEXT BITS
          ITEMP = ITEMP * 128 + K
        GO TO 2
   3    CONTINUE
        IF(JSIGN.NE.0) ITEMP = -ITEMP
        J = J + 1
        IF (J .GT. IMAX) GO TO 100
        IOUT(J) = ITEMP
      IF(I. LT. LB) GO TO 1
  100 CONTINUE
      LOUT = J
      IF (J .GT. IMAX) THEN
        LOUT = IMAX
        IERROR = -1
      ENDIF
      RETURN
      END
C**********************************************************************
C                                                                     *
C      SUBROUTINE INTAND(I1,I2,I3)                                    *
C                                                                     *
C      SUBROUTINE BITWISE "ANDS" THE INTEGERS IN I1 AND I2            *
C      AND RETURNS THE RESULT IN INTEGER I3                           *
C      FOR EXAMPLE                                                    *
C      IF THE 32 BITS IN I1 ARE 11001100 1110001110 11110000 11111111 *
C      AND IN I2 ARE            10101010 1100110011 00110011 00110011 *
C      I3 WILL BECOME           10001000 1100000010 00110000 00110011 *
C                                                                     *
C      NOTE "AND" IS NOT STANDARD FORTRAN 77 FUNCTION SO THIS IS A    *
C      MACHINE DEPENDANT SUBROUTINE                                   *
C**********************************************************************
C
cks       SUBROUTINE INTAND(I1,I2,I3) 
cks       INTEGER *4 I1,I2,I3
cksC##SUN## REMOVE COMMENT FROM NEXT LINE FOR SUN COMPUTERS
cks       I3 = AND(I1,I2)
cksC##DEC## REMOVE COMMENT FROM NEXT LINE FOR PDP AND VAX COMPUTERS and HP's
ckscuk       I3 = JIAND(I1,I2)
cksC##IBM## REMOVE COMMENT FROM NEXT LINE FOR IBM PC'S (I THINK)
cksC      I3 = IAND(I1,I2)
cks       RETURN
cks       END


c =============================================================================

c      -- this routine is machine and compiler dependend.  The appropriate
c      -- command should be selected by the 'conf.csh' script.
c      -- K.S. 21-Aug-98

c       SUBROUTINE INTAND(I1,I2,I3) 
c       INTEGER *4 I1,I2,I3
c       I3 = AND(I1,I2)   ! Sun
c       I3 = AND(I1,I2)   ! Linux (here same as sun)
c       I3 = JIAND(I1,I2)    ! HP, VAX
c      I3 = IAND(I1,I2)     ! PC ?
c       RETURN
c       END
 
c
c   put in by jh feb 3 2003
c
C**********************************************************************
C                                                                     *
C      SUBROUTINE INTAND(I1,I2,I3)                                    *
C                                                                     *
C      SUBROUTINE BITWISE "ANDS" THE INTEGERS IN I1 AND I2            *
C      AND RETURNS THE RESULT IN INTEGER I3                           *
C      FOR EXAMPLE                                                    *
C      IF THE 32 BITS IN I1 ARE 11001100 1110001110 11110000 11111111 *
C      AND IN I2 ARE            10101010 1100110011 00110011 00110011 *
C      I3 WILL BECOME           10001000 1100000010 00110000 00110011 *
C                                                                     *
C      NOTE "AND" IS NOT STANDARD FORTRAN 77 FUNCTION SO THIS IS A    *
C      MACHINE DEPENDANT SUBROUTINE                                   *
C**********************************************************************
C
       SUBROUTINE INTAND(I1,I2,I3) 
       INTEGER *4 I1,I2,I3
       logical sun,pc,linux
       call computer_type(sun,pc,linux)
COMPUTERTYPE
C##SUN## REMOVE COMMENT FROM NEXT LINE FOR SUN COMPUTERS
          if(sun.or.linux) I3 = AND(I1,I2)
C##DEC## REMOVE COMMENT FROM NEXT LINE FOR PDP AND VAX COMPUTERS,+sun
c          if(sun.or.linux)I3 = JIAND(I1,I2)
C##IBM## REMOVE COMMENT FROM NEXT LINE FOR IBM PC'S (I THINK), now also sun !
        if(pc)I3 = IAND(I1,I2)
       RETURN
       END
c

      
       
C************************************************************************
C                                                                       *
C     SUBROUTINE CHEKBT(ACHAR,NSTAT,IBYTE)                              *
C                                                                       *
C     SUBROUTINE CHECKS WHETHER THE CHARACTER ACHAR IS ONE WHICH CANNOT *
C     BE TRANSMITTED OVER A COMMUNICATIONS LINK. IF THE CHARACTER       *
C     CAN BE TRANSMITTED NSTAT IS SET TO 0 OTHERWISE IT IS SET TO 1.    *
C     IF NSTART IS SET TO ONE A ONE BIT IS ADDED INTO THE SIXTH MOST    *
C     SIGNIFICANT BIT OF ACHAR. THIS IS REMOVED IN THE DECODING PROGRAM *
C     THE SUBROUTINE HAS BEEN INITIALLY SET UP TO STOP CONTROL Z,       *
C     CONTROL C, CONTROL P AND CONTROL D CHARACTERS FROM BEING          *   
C     TRANSMITTED. THESE MAY HAVE TO BE CHANGED, DELETED OR ADDED TO    *
C     DEPENDING ON THE PARTICULAR CIRCUIT AND COMPUTERS.                *
C     FOR A FULL BINARY LINK, NO CONTROL CHARACTERS NEED BE STOPPED     *
C     AND THIS SUBROUTINE WILL BECOME REDUNDANT.                        * 
C     TO ADD ANOTHER CONTROL CHARACTER DEFINE IT, SPECIFY IT AND TEST   *
C     FOR IT.                                                           *
C     IBYTE = 1 FOR COMPUTERS WHICH STORE A CHARACTER IN THE MOST       *
C     SIGNIFICANT BITS OF AN INTEGER  *4 WORD. IBYTE = 4 FOR            *
C     COMPUTERS WHICH STORE A CHARACTER IN THE LEAST SIGNIFICANT        *
C     BYTE OF A COMPUTER WORD.                                          *
C     NOTE THIS SUBROUTINE WILL NOT WORK FOR CHARACTERS WHOSE 8 BIT     *
C     INTEGER REPRESENTATION IS GREATER THAN 31                         *
C     MODIFIED 28TH NOVEMBER 1988 BECAUSE OF ERRORS ON VAX COMPUTERS    *
C************************************************************************
C
      SUBROUTINE CHEKBT(ACHAR,NSTAT,IBYTE)
      IMPLICIT INTEGER *4 (I-N)
      CHARACTER *1 ACHAR,CNTRLZ,CNTRLC,CNTRLP,CNTRLD
      CHARACTER *1 OVRLAY,CHAR32
      INTEGER *4 ITEMP,ITEMP1
      EQUIVALENCE (ITEMP,OVRLAY),(ITEMP1,CHAR32)
      ITEMP = 0
      ITEMP1 = 0
      CHAR32 = CHAR(32)
C     DEFINE CONTROL CHARACTERS WHICH SHOULD NOT BE TRANSMITTED
C     THESE WILL VARY FOR DIFFERENT CIRCUITS AND COMPUTERS AND MAY HAVE
C     TO BE FOUND BY TRIAL AND ERROR.
      CNTRLZ = CHAR(26)
      CNTRLC = CHAR(3)
      CNTRLP = CHAR(16)
      CNTRLD = CHAR(4)
      NSTAT = 0
      IF(ACHAR.EQ.CNTRLZ) NSTAT = 1
      IF(ACHAR.EQ.CNTRLC) NSTAT = 1
      IF(ACHAR.EQ.CNTRLP) NSTAT = 1
      IF(ACHAR.EQ.CNTRLD) NSTAT = 1
      IF(NSTAT.EQ.1) THEN
         OVRLAY = ACHAR
         ITEMP = ITEMP + ITEMP1
         ACHAR = OVRLAY
      ENDIF
      RETURN
      END

c
c  Convert kinemetrics dataseis files to seisan format. 
c
c  This is program KINSEI,  Aug 96
c
c  r. Arvidsson, march, 1992, original program for PDAS now changed for
c                             kinetrics input data
c                92-03-22     Currently working for PC however only with
c                             16 bits - 2 byte word. 12 bits not fixed yet.
c                92-04-27     bugs , r.a.
c                92 11 15     cut cuttim from end ofdata, jh
c                97 11  7     use a def file, some clean up
c                april 7 99 jh------------  version 7.0 --------------
c                             new general standard, clean up
c                feb 2000, jh major clenaup, junk code removed, bit
c                             manipulation greatly simplified, unix version 
c          may 11  00    lo : use read_resp_head
c          nov 20  01    jh : write out more than 30 channels
c
c
c ,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
c
c   block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile
      character*80 text
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c
c--------  end of block
c
c-- input data vector	
      integer*2 data(max_sample)
c-- input file name	
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in
c-- question
      character*80 question	
c-- interval to cut off end
      real cuttim
c-- number of codes
      integer istat
c-- sample rate hz*10
      integer*2 ismpl
c--kin    headers
      character*1 kinhead(2048)
c-- date and time
      integer iday, yr, mth, ndoy
      real        xsec
c--Counters
      integer isamp,ib,i,k,kk,flag, j, jj, ii, filecount,ik
c--Logical check
      logical lhead
c -- logcal used to show if filenr.lis present
      logical flis
c-- block size
      integer blksize
      logical pc,sun,linux	  

c -----------------------------------------------------------------
c
c  Kinemetrics header, first block 2048 bytes
c
c -----------------------------------------------------------------
c --
c--  no chan,  samples/sm,
c --
      integer*2  nnchan, nochan 
      equivalence (kinhead(3),nnchan)
      equivalence (kinhead(7),ismpl)

c --
c -- user comments and channel names
c --
      character*32 userc
      character*4  chname(64)
      equivalence (kinhead(225),userc),(kinhead(257),chname)


c--------------------------------------------------------------------
c
c Kinemetrics datablocks 2048 bytes/record
c
c--------------------------------------------------------------------

      integer*2 bcode, byear, bday, bmsc,
     *          muldata(1016)
c     integer*1 bhr, bmin, bqual
      logical*1 bhr, bmin, bqual
      character*1 cdata(2048)
      equivalence (cdata(1),bcode)
      equivalence (cdata(3),byear),(cdata(5),bday)
      equivalence (cdata(7),bhr),(cdata(8),bmin)
      equivalence (cdata(9),bmsc),(cdata(11),bqual)
      equivalence (cdata(17),muldata)


c
c print version
c
      include 'version.inc'
      out_version_date='Nove 20, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)


      mainhead_text=' '
      cuttim=5.0    ! cut last 5 seconds of data

c
c   get def file for station codes
c
       text='kinsei.def'
       call read_def_chan(text,mainhead_text,net_code)
c
      blksize=2048
c
      istat=1	   	   	  	  	
c ---------------------------------------------------------------
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
11    call filename(question,infile)	
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(*,'(a)')' No filenr.lis'
         stop
 21      continue
         in=1
         flis = .true.
      endif
c
c -------------------------------------------------------
c
c   file loop if many files
c --------------------------------------------------------
  999 continue
      filecount= filecount + 1
      if(flis) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
      open(1,file=infile,access='direct',recl=blksize,status='old')
c
c  read loop
c
      isamp=0	
      ib=1
      flag=0	
c-- read header
          k = 1
           do 800 ik=1, (2048/blksize)
              read(1,rec=k,err=10) kinhead
              k=k+1
800        continue
c
c   swap if sun
c
           if(sun) call swap2_one(nnchan)
           if(sun) call swap2_one(ismpl)
           nchan=nnchan
c--- channel
        nochan=nchan
c--- rate
       rate(1)=float(ismpl)/10.0
c
c   read data
c
c---------------------------------------------------------------
       do 1000 jj = 1, nchan     ! channel loop
c --------------------------------------------------------------
c
           isamp=0
           k=2
55         continue
           if(isamp.gt.max_sample) then
              write(6,*)' Too many samples in input file'
              stop
           endif
           do 900 ik=1, (2048/blksize)
              read(1,rec=k,err=10) cdata
              k = k + 1
900        continue
c--
c-- Check if main header should be created
c--
           if (k.eq.3 .and. jj.eq.1) then
              lhead=.true.
           else
             lhead=.false.
           endif
c--
c --- find times, first swap if on sun
c--
c
          if (lhead) then
             if(sun) then
                call swap2_one(byear)
                call swap2_one(bday)
                call swap2_one(bmsc)
             endif
c-- day of year
             yr=byear
             ndoy=bday
             call dte(ndoy,iday,mth,yr)
c
c   convert from signed integer to unsigned integer
c
             if(bmsc.ge.0) then
                xsec=float(bmsc)/1000.0   ! same as signed
             else
                xsec=(2**16+bmsc)/1000.0
             endif
             sec(1)=xsec
c ----------------------------------------------------------------
             year(1)=byear
             month(1)=mth
             hour(1)=bhr
             min(1)=bmin
             sec(1)=xsec
             day(1)=iday
          endif
c
c---------------------------------------------------------------
c  loop to read data
c
       if(sun) call swap2(1016,muldata)
c
       kk=1016/nochan
       kk=kk*nochan               ! location of last real sample
       do 56 ii=jj,kk,nochan
          isamp = isamp + 1
          data(isamp)=muldata(ii)
c
c   convert to unsigned integer
c
          if(data(isamp).lt.0) data(isamp)=2**16+data(isamp)
c
c   convert to signed integer
c
          data(isamp)=data(isamp)-2**15

56     continue

       go to 55
c -------------------------------------------------------------

10     continue
       isamp=isamp-cuttim*rate(1)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   make main header if first channel
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
       if (jj .eq. 1 ) then

c
c -- fix network comments if not given in def file
c
       if(mainhead_text.eq.' ') then 
          mainhead_text= userc(1:29)
       endif

c
       cbyte(1)=' '
       nsamp(1)=isamp
       do i=2,nchan
         year(i)=year(1)
         month(i)=month(1)
         day(i)=day(1)
         hour(i)=hour(1)
         min(i)=min(1)
         sec(i)=sec(1)
         rate(i)=rate(1)
         cbyte(i)=' '
         nsamp(i)=nsamp(1)
       enddo
c
       do i=1,nchan
           comp(i)='S  Z'
           stat(i)(1:4)=chname(i)
           do j=1,4
             if(ichar(stat(i)(j:j)).eq.0) stat(i)(j:j)=' '
           enddo
           stat(i)(5:5)=' '
           if(stat(i).eq.' ') then 
              write(stat(i),'(i2)') i
              if(stat(i)(1:1).eq.' ') stat(i)(1:1)='0'
              stat(i)(3:4)=' '
           endif
c
c   put in definition from def file
c
           call set_def_chan(i,stat(i),comp(i))
       enddo
       write(6,*) year(1),month(1),day(1),hour(1),min(1),sec(1)
       write(6,*)' Sample rate',rate(1)
       write(6,*)' Number of channels', nchan


         ichan=1   ! just make main header
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
         write(6,'(a,a)')' Output file name is: ',outfile
         open(2,file=outfile,status='unknown',form='unformatted')	  
       endif
c ----------------------------------------------------
c
c   write data
c
      if (jj .eq. 1) then
         do i=1,12
            write(2) mainhead(i)
         enddo
         if(nchan.gt.30) then
            k=(nchan-31)/3+1
            do i=13,k+12
               write(2) mainhead(i)
            enddo
         endif
      endif

c
c   make channel header	
c

         call sheads(year,month,day,hour,min,sec,nchan,jj,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)


      write(6,'(1x,a)')chahead(1:70)
c --
c -- write channel number
c --
c      write(6,'(a,i5)') ' channel ', jj

c
c   read response curve into header
c

           call read_resp_head(chahead)             

      write(2) chahead
      write(2)(data(i),i=1,isamp)

1000  continue
c ----------------------------------------------------------------
      write(6,*)
c --
c -- close output and input file
c--
      close(1)
      close(2)
c
c  back for next file if many
c
      if(in.eq.1) goto 999
      if(in.eq.0) goto 11
99    continue
      stop
      end

C+
C	PROGRAM FOCMEC
C
C	Calculates acceptable focal mechanisms based on polarities
C	  and (S/P) amplitude ratios.
C	Inspired by the Georgia Tech program with statistics
C	  from Kisslinger's.  Conventions are those in
C	  Herrmann as well as Aki & Richards
C	Updates are documented in a separate file.
C
C	Arthur Snoke   Virginia Tech  1984, 2001
C-
	CALL FOCINP
	CALL SRCHFM
	STOP
	END

C
c    program will plot macroseismic observations using GMT
c    can read web files and  seisan storage files,
c    web files are converted to seisan files
c   
c    input is a web file or a seisan macroseismic file
c
c    output is a gmt file macromacp.gmt with commands to plot the
c    macroseismic observations together with an input file iso.inp.
c    within the program, the gmt script is executed and the map ps
c    file macromap.eps displayed.
c
c    if input is from a web file made with macroquest, the plot is also 
c    made and an output file macromap.out is also generated in seisan 
c    macroformat. the program then needs an input file with postal codes.
c
c    The program can also take input from the prompt line:
c
c      -macroinput        file with macroseismic observations,
c                         abs path or in ISO
c      -placename         additional file with place names,
c                         abs path or in DAT, epimap format
c      -postfile          file with postal code, abs path
c
c      -lat               epicenter latitude
c
c      -lon               epicenter longitude
c    
c
c    If used with eev, the place name file must have name place_names.macro
c    
c
c    j. havskov, january 2005
c
c  changes
c
c  feb 15 2006 jh : add epicenter 
c  apr 5  2006 jh : add correct seisan output file name if web input
c  jun 20 2006 jh : change ps to eps
c  jan 26 2007 bm : change colors
c  mar 6  2007 jh : end criteria not err but '---' for macro fil
c  mar 23 2007 jh : make sure size of map ok if only one point
c  may 28 2008 jh : make map 0.1 deg larger in all directions
c  oct 31 2008 jh : change user/bin to bin
c
c
c
      implicit none
      include 'libsei.inc'

      character*120 text(100)		! general text
      character*80  txt                 ! general text
      character*80 txt_all(5000)        ! whole web file
      character*80 macroinput 		! input file with lat,lon and intensity
      character*80 post_file            ! file with postal codes
      real lat(5000),lon(5000) 		! latitutde and longitude
      real intensity(5000)		! intensity
      real max_lat,min_lat		! latitude limits
      real max_lon,min_lon		! longitude limits
      real epi_lat,epi_lon              ! epicenter
      integer n_observations		! number of intnesity points
      character*80 title		! plot title
      character*80 place_name_file	! place name file, seisan format
      character*80 p_name		! place name
      integer seiclen                   ! function to get length of string
      logical plot_gmt                  ! if true, plot 
      real x,y                          ! help variable
      character*3 format                ! format of input file
      integer narg                      ! number of arguments
      character*80 arg(40)              ! arguments
      integer npost                     ! number of postal codes
      character*10 post_code(10000)     ! postal codes
      character*10 ppost                ! one postal code
      character*30 psite(10000)         ! postal sites
      character*30 one_site             ! one postal site
      character*30 reported_site        ! reported site
      character*80 file_name            ! seisan type output file name
      real plat(10000),plon(10000)      ! lat-lon of postal sites
      integer year,month,day,hour,min,sec
      integer local_hour                ! local hour
      integer nweb                      ! number of lines in web file
      integer n_bad                      ! number of missign postal codes
      real ratio                        ! ratio between yand x on plot
      real xsize                        ! x size in cm
      

      integer i,k,kk,code,l,m,ll

      plot_gmt=.true.
      place_name_file=' '
      post_file=' '
      epi_lat=999.0
      epi_lon=999.0
      n_bad=0

c
c   get arguments
c
      call get_arguments(narg,arg)

      if(narg.lt.2) then
c
c   get file names
c
         write(6,*)' Input file name with macroseismic data'
         read(5,'(a)') macroinput
         write(6,*)' Place name file, return for none'
         read(5,'(a)') place_name_file
         write(6,*)' File with postal codes, return for none',
     *   ' or default if web file input'
         read(5,'(a)') post_file
      else
         do i=1,narg
            if(arg(i)(1:11).eq.'-macroinput') then
               macroinput=arg(i+1)
            endif
            if(arg(i)(1:10).eq.'-placename') then
               place_name_file=arg(i+1)
            endif
            if(arg(i)(1:10).eq.'-postfile') then
               post_file=arg(i+1)
            endif
            if(arg(i)(1:4).eq.'-lat') then
               read(arg(i+1),'(f8.3)') epi_lat
            endif
            if(arg(i)(1:4).eq.'-lon') then
               read(arg(i+1),'(f8.3)') epi_lon
            endif
          enddo
      endif
      if(epi_lat.lt.900) write(6,*)' Epicenter',epi_lat,epi_lon
c
c   make file with color tables
c
      open(1,file='macro.cpt',status='unknown')
      write(1,'(a)')
     *'0       255     255     0       3     255       255     0'
      write(1,'(a)')
     *'3       255     200     100     4     255       200     100'
      write(1,'(a)')
     *'4       160     96      224     5     160        96     224'
      write(1,'(a)')
     *'5       0       255     0       6       0       255       0'
      write(1,'(a)')
     *'6       0       0       255     7       0         0     255'
      write(1,'(a)')
     *'7       255       0     0       8       255       0       0'
      write(1,'(a)')
     *'8       255     255     255     9       255     255     255'
      write(1,'(a)')
     *'B         0     224     255'
      write(1,'(a)')
     *'F       0       0       0'
      write(1,'(a)')
     *'N       128     128     128'
      close(1)
c
c
c   open file with macroseismic info

c
c   open file in ISO if fom eev (inputy from prompt)
c
      if(narg.ge.2) then
         call sei get file( open$,            ! Get file.
     &                          k,            ! Opened on this unit.
     &                      code,             ! Returned condition.
     &                      'ISO',            ! Alternative directory to search.
     &                      macroinput)       ! For this station file.
         if(code.ne.e_ok$) then
            write(6,*)' Macroseismic file missing'
            stop
         endif
      else
         k=10
         open(k,file=macroinput,status='old')
      endif


c
c   find format, new or web
c
      format=' '
c
c  try  if web format
c
      read(k,'(a)') txt
      if(txt(1:20).eq.'--------------------') then
          format='web'
          goto 6
      endif
c
c   try new format
c
      rewind k
      read(k,'(a)') txt
      if(txt(49:51).eq.'GMT') then
         format='new'
         goto 6
      endif

 6    continue
      rewind k
c
      if(format.eq.' ') then
         write(6,*)' Unknown format'
         stop
      else
         write(6,'(a,a)')' Format: ',format
      endif
c
c   if web format, input date etc
c
      if(format.eq.'web') then
      write(6,*)' enter GMT year,month,day,hour,min,sec'
      read(5,*) year,month,day,hour,min,sec
      write(6,*) 'enter local hour'
      read(5,*) local_hour
      write(6,*)' enter location, max 30 chars'
      read(5,'(a)') txt(1:40)
      write(6,*) txt(1:40)
      write(file_name,'(i4,a,i2,a,i2,a,2i2,a,i2,a)')
     *year,'-',month,'-',day,'-',
     *hour,min,'-',sec,'.MACRO'
      do i=1,21
        if(file_name(i:i).eq.' ') file_name(i:i)='0'
      enddo
      write(6,*) ' File name for SEISAN ', file_name
      open(9,file=file_name,status='unknown')
      write(9,
     *'(a,i4,1x,2i2,1x,2i2,1x,i2,a,i4,1x,2i2,1x,2i2,1x,i2,a)')
     * txt(1:30), year,month,day,hour,min,sec,' GMT ',
     * year,month,day,local_hour,min,sec,' Local time'
       write(9,*)'Comment'
      endif


c   open and read postal codes, if a web file, also try to use
c   default file if no name is given
c
      npost=0
      kk=0
c
c   first check if a default post file is to be used
c
      if(format.eq.'web'.and.post_file.eq.' ') then
        call sei get file( open$,            ! Get file.
     &                          kk,           ! Opened on this unit.
     &                      code,             ! Returned condition.
     &                      'DAT',            ! Alternative directory to search.
     &                      'postal_code.dat')! For this file.
         if(code.ne.e_ok$) then
            write(6,*)' File postal_code.dat is missing'
            stop
         endif
      endif
c
c   specific name is given
c
c
      if(post_file.ne.' ') then
         kk=1
         open(kk,file=post_file,status='old')
      endif
c
c   now read if a file there
c
      if(kk.gt.0) then
         i=1
 1       continue
         read(kk,'(a10,2f10.3,2x,a30)',end=2)
     *   post_code(i),plat(i),plon(i),psite(i)
         i=i+1
         goto 1
 2       continue
         npost=i-1
         write(6,*) ' Number of postal codes', npost
         close(kk)
      endif
c
c   read observations file
c
      if(format.eq.'old') then
         read(k,'(a)') text(1)
         do i=1,10000
            n_observations=i-1
            read(k,'(28x,2f7.2,8x,f3.1)',end=10) 
     *      lat(i),lon(i),intensity(i)
         enddo
 10      continue
      endif
     
c
      if(format.eq.'new') then
         read(k,'(a)')title(1:48) 
         read(k,'(a)') txt
         do i=1, 10000
           n_observations=i-1
           read(k,'(a)',end=5) txt
           if(txt(1:5).eq.'-----') goto 5     ! new section with original data
           read(txt,'(2f10.3,f6.1)') 
     *     lat(i),lon(i),intensity(i)
           if(lat(i).eq.0.0.or.lon(i).eq.0.0) then
              n_observations=n_observations-1
              goto 5
           endif
         enddo
 5       continue
      endif
c
      if(format.eq.'web') then
         i=1
         ll=1
c        open(2,file='macromap.out',status='unknown')
         open(7,file='macromap_bad.out',status='unknown')
         read(k,'(a)') txt
         txt_all(ll)=txt
         ll=ll+1
         read(k,'(a)') txt
         txt_all(ll)=txt
         ll=ll+1
         read(k,'(a)') txt
         txt_all(ll)=txt
         ll=ll+1
 7       continue
         read(k,'(a)',end=8) txt  
         txt_all(ll)=txt
         ll=ll+1
         if(txt(1:10).eq.'----------') then ! new observation
           i=i+1
         endif
         if(txt(1:10).eq.'intensitet') then
            if(txt(19:20).eq.'II') intensity(i)=2
            if(txt(19:21).eq.'III') intensity(i)=3
            if(txt(19:20).eq.'IV') intensity(i)=4
            if(txt(19:20).eq.'V ') intensity(i)=5
            if(txt(19:20).eq.'VI') intensity(i)=6
            if(txt(19:21).eq.'VII') intensity(i)=7
            if(txt(19:22).eq.'VIII') intensity(i)=8
            if(txt(19:20).eq.'IX') intensity(i)=9
            if(txt(19:20).eq.'X ') intensity(i)=10
            goto 7
         endif
c
c   read site
c
         if(txt(1:11).eq.'postal site') then
            reported_site=txt(19:48)
            goto 7
         endif
c
c        if(txt(1:11).eq.'postal code') then
         if(txt(1:6).eq.'postnr') then
           ppost=txt(19:28)
c          write(6,*) ppost
c
c   find lat long corresponding to postal code
c
           if(npost.eq.0) then
             write(6,*)' No post code file'
             stop
           else
             one_site='code unknown'
             lat(i)=999
             lon(i)=999
             do l=1,npost
c              write(17,*) l, ppost(1:4),' ',post_code(l)(1:4)
c              if(ppost).eq.post_code(l)) then
               if(ppost(1:4).eq.post_code(l)(1:4)) then
                  lat(i)=plat(l)
                  lon(i)=plon(l)
                  one_site=psite(l)
               endif
             enddo
c            write(17,*)
             if(lat(i).lt.900) then
                write(9,'(2f10.3,2x,f3.1,1x,a3,1x,a10,2x,2a)')
     *          lat(i),lon(i),intensity(i),'EMS',
     *          ppost,one_site(1:20),
     *          reported_site(1:17)
             else
                write(7,'(2f10.3,2x,f3.1,1x,a3,1x,a10,2x,2a)')
     *          lat(i),lon(i),intensity(i),'EMS',
     *          ppost,one_site(1:20),
     *          reported_site(1:17)
                i=i-1
                n_bad=n_bad+1
             endif
           endif
         endif
         goto 7
 8       continue
         nweb=ll-1
         n_observations=i
c
c   write original web observation
c
         do i=1,nweb
           write(9,'(a)') txt_all(i)
         enddo
         close(9)
      endif
      if(narg.ge.2) call sei close (close$,k,code)


  
c
c  open file with place names, read and write
c
      if(place_name_file.ne.' ') then
c
c
c   open file in DAT
c
         call sei get file( open$,            ! Get file.
     &                          m,            ! Opened on this unit.
     &                      code,             ! Returned condition.
     &                      'DAT',            ! Alternative directory to search.
     &                      place_name_file)  ! For this station file.
         if(code.ne.e_ok$) then
            write(6,*)' Place name file missing'
         endif

        open(4,file='place_name.gmt',status='unknown')
        k=0
 11     continue
        read(m,'(a)',end=12) txt
        k=k+1
        i=index(txt,'  ')
        p_name=txt(1:i)       ! save name
        txt(1:80-i+1)=txt(i:80) ! strip off name
        call sei get values( 2, txt, code )        ! Parse text.
        y=array$(1)                         
        x=array$(2)
        write(4,'(2f8.3,a,a)') 
     *  x,y,' 12 0 1 CM ',p_name(1:seiclen(p_name))
        goto 11
 12     continue
        write(6,*)' Number of place names', k
        call sei close (close$,m,code)
        close(4)
      endif
c
c   write out for gmt script
c
      open(3,file='iso.inp',status='unknown')
      k=1
      do i=1,n_observations
         if(lat(i).ne.999.0.or.lon(i).ne.999.0) then
            lat(k)=lat(i)
            lon(k)=lon(i)
            k=k+1
            write(3,*) lon(i),lat(i),intensity(i)
         endif
      enddo
      close(3)

c
c   find limits
c
      max_lat=-100.0
      min_lat=100.0
      max_lon=-400.0
      min_lon=400.0
      do i=1,n_observations
        if(lat(i).gt.max_lat) max_lat=lat(i)
        if(lat(i).lt.min_lat) min_lat=lat(i)
        if(lon(i).gt.max_lon) max_lon=lon(i)
        if(lon(i).lt.min_lon) min_lon=lon(i)
      enddo
c
c   if epicenter is given, make sure it is on map
c
      if(epi_lat.lt.900.0) then
        if(epi_lat.gt.max_lat) max_lat=epi_lat
        if(epi_lat.lt.min_lat) min_lat=epi_lat
        if(epi_lon.gt.max_lon) max_lon=epi_lon
        if(epi_lon.lt.min_lon) min_lon=epi_lon
      endif
c
c  make sure min and max is not the same
c
      if(max_lat-min_lat.lt.0.1) max_lat=max_lat+0.1
      if(max_lon-min_lon.lt.0.1) max_lon=max_lon+0.1


c
c    check that it fits and make it a bit bigger than observations
c
c     i=2*max_lat
c     max_lat=i
c     if(i.gt.0) max_lat=max_lat+1.0
c     max_lat=max_lat/2.0
      max_lat=max_lat+(max_lat-min_lat)*0.2
      max_lat=max_lat+0.1
      

c     i=2*min_lat
c     if(i.lt.0) i=i-1.0
c     min_lat=i
c     min_lat=min_lat/2.0
      min_lat=min_lat-(max_lat-min_lat)*0.2
      min_lat=min_lat-0.1

c
c   ratio on map
c
      ratio=(max_lat-min_lat)/((max_lon-min_lon)*cos(max_lat/57.0))
c
c   horizontal size. if both y and x size the same, map will be 12 cm wide
c
      xsize=34.0/ratio
      if(xsize.gt.12.0) xsize=12.0

c     i=2*max_lon
c     max_lon=i
c     if(i.gt.0) max_lon=max_lon+1.0
c     max_lon=max_lon/2.0
      max_lon=max_lon+(max_lon-min_lon)*0.2
      max_lon=max_lon+0.1


c     i=2*min_lon
c     if(i.lt.0) i=i-1.0
c     min_lon=i/2.0
      min_lon=min_lon-(max_lon-min_lon)*0.2
      min_lon=min_lon-0.1
c
      write(6,*)' Number of observations with postal code', 
     *           n_observations
      write(6,*)' Number of observations without postal code', 
     *           n_bad
      write(6,*)' Lat-lon range ',
     *            min_lat,max_lat,min_lon,max_lon

c
c   open file with gmt output script
c
      open(2,file='macromap.gmt',status='unknown')

      k=1
      text(k)='#!/bin/csh'  	    		! start of file
      k=k+1
      text(k)='gmtset UNIX_TIME FALSE'
      k=k+1
      text(k)='gmtset WANT_EURO_FONT TRUE'
      k=k+1
      text(k)='gmtset HEADER_FONT_SIZE 14'
      k=k+1
      write(text(k),'(a,4(f6.1,a))')'set REGION=',	! region limits
     *          min_lon,'/',max_lon,'/',min_lat,'/',max_lat,' '
      do i=12,36
        if(text(k)(i:i).eq.' ') text(k)(i:i)='0'        ! no blanks allowed
      enddo
      k=k+1
c
c   calculate horizontal scale in cm/deg
c
      x=xsize/(max_lon-min_lon)
      write(text(k),'(a,f5.2)')'set PROJ=m',x		! scale     
      if(text(k)(11:11).eq.' ') text(k)(11:11)='0'
      if(text(k)(12:12).eq.' ') text(k)(12:12)='0'
      k=k+1
      write(text(k),'(a,a,a)')'set TITLE="',title(1:48),'"' ! title
      k=k+1
      text(k)='set OUTFILE=macromap.eps'	! ps output file
      k=k+1
      text(k)='set INFILE=iso.inp'
      k=k+1
      write(text(k),'(a,f6.1)') 'set LEGLON=',max_lon+0.1  ! legion corner
      do i=12,15
        if(text(k)(i:i).eq.' ') text(k)(i:i)='0'           ! no blanks allowed
      enddo

      k=k+1
      write(text(k),'(a,f6.1)')'set LEGLAT=',max_lat       ! legion corner
      do i=12,15
        if(text(k)(i:i).eq.' ') text(k)(i:i)='0'           ! no blanks allowed
      enddo
      k=k+1
c
c   epicenter
c
      if(epi_lat.lt.900) then
         write(text(k),'(a,f9.3)')'set EVLON=',epi_lon
         do i=11,19
           if(text(k)(i:i).eq.' ') text(k)(i:i)='0'        ! no blanks allowed
         enddo
         k=k+1
         write(text(k),'(a,f9.3)')'set EVLAT=',epi_lat
         do i=11,19
           if(text(k)(i:i).eq.' ') text(k)(i:i)='0'        ! no blanks allowed
         enddo
         k=k+1
       endif
c
c  place names
c
      if(place_name_file.ne.' ') then
         text(k)='set PLACEFILE=place_name.gmt'
         k=k+1
      endif
c     text(k)='makecpt -Crainbow -I -T0/8/1  >! macro.cpt'
c
c   fixed commands
c

c     k=k+1
      text(k)='psbasemap -R$REGION -J$PROJ -B1.0f10m:'//
     *         '."$TITLE":WSne -K >! $OUTFILE'
      k=k+1
      text(k)='pscoast -R$REGION -J$PROJ -B1.0f10m:.'//
     *         '"$TITLE":WSne -Di -G255/224/192 -S128/192/224 -W2 '//
     *          '-O -K >> $OUTFILE'
      k=k+1
      if(place_name_file.ne.' ') then
         text(k)='psxy $PLACEFILE -R$REGION -J$PROJ -O'//
     *   ' -Ss0.3 -G0 -K >> $OUTFILE'
         k=k+1
         text(k)='pstext $PLACEFILE -R$REGION -J$PROJ'//
     *   ' -D0/0.4 -O -K >> $OUTFILE'
         k=k+1
      endif
c
c   epicenter
c
      if(epi_lat.lt.900) then
         text(k)='psxy -R$REGION -J$PROJ -B1.0f10m:."$TITLE":WSne'//
     *   ' -O -K -Sa0.8c -G255/255/0 -W1 << EOF >> $OUTFILE'
         k=k+1
         text(k)='$EVLON $EVLAT'
         k=k+1
         text(k)='EOF'
         k=k+1
      endif
c
      text(k)='psxy $INFILE -R$REGION -J$PROJ -B1.0f10m:.'//
     *         '"$TITLE":WSne'//
     *         ' -Cmacro.cpt -O -Sc0.3c -W -G0/0/0 -K >> $OUTFILE'
      k=k+1
      if(epi_lat.lt.900) then
         text(k)='pslegend -R$REGION -J$PROJ -D$LEGLON/$LEGLAT/'//
     *           '2.8/5.2/TL -O -F -G255/255/255 << EOF >> $OUTFILE'
         k=k+1
      else
         text(k)='pslegend -R$REGION -J$PROJ'//
     *           ' -D$LEGLON/$LEGLAT/2.3/4.7/TL'//
     *           ' -O -F -G255/255/255 << EOF >> $OUTFILE'
         k=k+1
      endif
      text(k)='C 0/0/0'
      k=k+1
      text(k)='H 10 1 Intensity'
      k=k+1
      text(k)='D 0.1 1'
      k=k+1
      text(k)='N 1'
      k=k+1
      text(k)='S 0.2 c 0.3c 255/255/0 1p 0.6c I = 0-II '
      k=k+1
      text(k)='S 0.2 c 0.3c 255/200/100 1p 0.6c I = III'
      k=k+1
      text(k)='S 0.2 c 0.3c 160/96/225 1p 0.6c I = IV'
      k=k+1
      text(k)='S 0.2 c 0.3c 0/255/0 1p 0.6c I = V'
      k=k+1
      text(k)='S 0.2 c 0.3c 0/0/255 1p 0.6c I = VI'
      k=k+1
      text(k)='S 0.2 c 0.3c 255/0/0 1p 0.6c I = VII'
      k=k+1
      text(k)='S 0.2 c 0.3c 255/255/255 1p 0.6c I = VIII'
      k=k+1
      if(epi_lat.lt.900.0)then 
         text(k)='S 0.2 a 0.5c 255/255/0 1p 0.6c epicenter'
         k=k+1
      endif
      text(k)='EOF'
c
c   write gmt script
c

      do i=1,k 
         write(2,'(a)') text(i)(1:seiclen(text(i)))
      enddo
      close(2)
c
c   plot gmt script if that option
c
      if(plot_gmt) then
        call systemc('chmod +x macromap.gmt',21)   ! make it executable
        call systemc
     *  ('macromap.gmt',12)    ! run gmt
        call systemc('gv macromap.eps',15)         ! plot
        call systemc(
     *   'gs -sDEVICE=jpeg -sOutputFile=macromap.jpeg macromap.eps',
     *    56)

      endif

      if(format.eq.'web') then
         write(6,*)
     *   ' Output file with identified sites is macromap.out'
         write(6,*)
     *   ' Output file with un-identified sites is macromap_bad.out'
      endif
      stop
      end

c
c   subroutines for parameter input - output
c
c   all parameters are going through common block in rea.inc
c
c
c   rea_event_in                : read one whole event
c
c   rea_event_out               : write one whole event
c
c   rea_hyp1_in                 : read  type 1 line
c
c   rea_hyph_in                 : read high accuracy hypocenter line
c
c   rea_hype_in                 : read error line
c
c   rea_hyp1_out                : write  type 1 line
c
c   rea_hyph_out                : write high accuracy hypocenter line
c
c   rea_hype_out                : write error line
c
c   rea_hypm_out                : write extra magnitudes
c
c   rea_hyp_clear               : clear hypocenter parameters
c
c   rea_phase_out               : write phase parameters to phase line
c
c   rea_phase_in                : read phase parameters from phase line
c
c   rea_phase_clear             : clear phase parameters
c
c   add_phase_to_sfile          : add phase to data array
c
c   rea_spec_out                : write spectral parameters to spec lines
c
c   rea_av_spec_out             : write average spectral parameter to text line
c
c   rea_spec_in                 : read  spectral parameters to memory
c
c   rea_av_spec_out             : read average spectral parameters
c
c   add_spec_to_sfile           : add spectral lines to data array
c
c   get_par                     : read general parameter def file, set defs
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   General info:
c
c   The phase name DELETE is reserved. Giving a phase the name DELETE, will
c                         remove it at the next write out
c
c
c------------------------------------------------------------------------------
c changes:
c   01 May 2001 lo : change in rea_av_spec_in, AVARAGA -> AVERAGE
c   26 may 2001 jh : add phase DELETE which delete phase on write out
c                    add arrays for all magnitudes,agencies and types
c   06 May 2001 lo : added reading of auto phase to rea_phase_in
c   14 mar 2008 jh : calculate readings abs times in rea_in
c   23 apr 2008 jh : do not stop if more than one error oe high accuracy 
c                    line
c    9 may 2008 pv : subroutine rea_phase_in did not like line type 4    
c   28 oct 2008 jh : fix output of cornerf without overflow

      subroutine rea_event_in(unit,all,data,code)
c
c   Read all data from one event in data array and puts it into common block
c   data that canot go into variables in common block are stored in rea_data
c
c     input :   unit:  File unit to read from, if 0, read directly
c                      from data array, MAKE SURE TO PASS NRECORD AND
C                      NHEAD TO COMMON BLOCK BEFORE CALLL
c               all:   If true, read whole event, if false only headers
c               data:  S-file data array
c
c     output:   code:  0: Ok, 1: End of file, 2: Read error (not implemented)
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      integer unit
      logical all
      integer code
      integer nh,ne                   ! count high accurarcy and errror lines
      integer nphase                  ! as counted by indata
      integer nstat                   ! as counted by indata
      character*80 data(1000)
      character*80 text
      character*1 type,exp            ! for indata
      integer i,k

      ne=0
      nh=0
      code=0
      rea_nphase=0
c
c  check if reading from a file
c
      if(unit.gt.0) then
         call indata
     *   (unit,nstat,nphase,rea_nhead,rea_nrecord,
     *   type,exp,data,k)
         if(rea_nrecord.eq.0) then
             code=1
             return
         endif
      endif
c
c  now read all data, first headers, the main hypocenter (index 1) also
c  contains error info, high accuracy and extra magnitudes 
c
      rea_nphase=0      ! count number of phase lines
      rea_nhyp=0        ! count number of hypocenters
      rea_nwav=0        ! --------------- waveform files
      rea_ncomment=0    ! --------------- comment lines
      rea_nmacro=0      ! --------------- macroseismic data
      rea_nfault=0      ! --------------- fault plane solutions
      rea_nspec=0       ! --------------- spectral solutions
      rea_nmag=0        ! --------------- magnitudes
c
      i=1
      dowhile(i.le.rea_nhead)
         if(data(i)(80:80).eq.'1'.or.i.eq.1) then  ! allow first line without 1
             rea_nhyp=rea_nhyp+1
             k=rea_nhyp
             call rea_hyp_clear(k)
             call rea_hyp1_in(data(i),k)
             goto 10
         endif
         if(data(i)(80:80).eq.'H') then
            call rea_hyph_in(data(i),1)     ! put high precision info in 1
            nh=nh+1
            goto 10
         endif
         if(data(i)(80:80).eq.'E') then
            call rea_hype_in(data(i),1)        ! put error info in 1
            ne=ne+1
            goto 10
         endif
c
c   check for additional magnitudes, are in type 1 line with same first
c   23 chars and same hypocenter agency as the prime solution
c
         if(data(i)(1:23).eq.data(1)(1:23).and.data(i)(46:48).eq.
     *      data(1)(46:48).and.data(i)(80:80).eq.'1'.and.i.gt.1) then
            call rea_hyp_clear(100)
            call rea_hyp1_in(data(i),100)  ! temporarely use index 100
            do k=1,3                       ! put into last 3 positions
c               hyp_mag(i+3,1)=hyp_mag(100,i)  ! changed lo, may 2001
               hyp_mag(i+3,1)=hyp_mag(6,i)
c               hyp_mag_type(i+3,1)=hyp_mag_type(100,i)
               hyp_mag_type(i+3,1)=hyp_mag_type(6,i)
c               hyp_mag_agency(i+3,1)=hyp_mag_type(100,1)
               hyp_mag_agency(i+3,1)=hyp_mag_agency(6,1)
            enddo
            call rea_hyp_clear(100)            ! clear again
            goto 10
         endif
        
c
c   spectral average line
c
         if(data(i)(80:80).eq.'3'.and.data(i)(2:13).eq.
     *   'SPEC AVERAGE') then        ! changed from AVARAGE lo, May 2001
            call rea_av_spec_in(data(i))
            goto 10
         endif
c
c   spectral station lines
c
         if(data(i)(80:80).eq.'3'.and.data(i)(2:5).eq.'SPEC'.and.
     *      data(i)(7:13).ne.'AVERAGE') then
            if(data(i+1)(80:80).eq.'3'.
     *      and.data(i+1)(2:5).eq.'SPEC') then
               rea_nphase=rea_nphase+1
               k=rea_nphase
               call rea_spec_in(k,data(i),data(i+1))
               rea_nspec=rea_nspec+1
               i=i+1                      ! there are 2 lines
               goto 10
            endif
         endif
c
c   id line
c
         if(data(i)(80:80).eq.'I') then
            rea_id_line=data(i)
            goto 10
          endif
c
c   fault plane solutions
c
         if(data(i)(80:80).eq.'F') then
            rea_nfault=rea_nfault+1
            rea_fault(rea_nfault)=data(i)
            goto 10
         endif
c
c    waveform file names
c
         if(data(i)(80:80).eq.'6') then
             rea_nwav=rea_nwav+1
             rea_wav(rea_nwav)=data(i)
             goto 10
         endif
c
c    macroseismic info
c
         if(data(i)(80:80).eq.'2') then
             rea_nmacro=rea_nmacro+1
             rea_macro(rea_nmacro)=data(i)
             goto 10
         endif

c
c    comment lines
c
         if(data(i)(80:80).eq.'3') then
            rea_ncomment=rea_ncomment+1
            rea_comment(rea_ncomment)=data(i)
         endif


 10      continue
         i=i+1
c
      enddo
c
c   check that there was not too many high accuracy lines or error lines
c
      if(ne.gt.1.or.nh.gt.1) then
          write(6,*) ' Too many error or high accuracy lines'
          write(6,'(a)') data(i)(1:79)
          write(6,*)' Enter to continue'
          read(5,'(a)') text
cjh apr 08          stop
      endif
c
c   count total number of magnitudes and put into one array
c
      rea_nmag=0
      do i=1,rea_nhyp
        do k=1,6
           if(hyp_mag(k,i).gt.-20.0) then
              rea_nmag=rea_nmag+1
              hyp_mag_all(rea_nmag)=hyp_mag(k,i)
              hyp_mag_type_all(rea_nmag)=hyp_mag_type(k,i)
              hyp_mag_agency_all(rea_nmag)=hyp_mag_agency(k,i)
           endif
        enddo
      enddo
         

c
c   read phases if specified
c
      if(all) then
         do i=rea_nhead+1,rea_nrecord
            if(data(i).ne.' ') then
               rea_nphase=rea_nphase+1
               call rea_phase_clear(rea_nphase)          ! clear variables
               call rea_phase_in(rea_nphase,data(i))     ! read
            else
               if(i.ne.rea_nrecord) then                 ! last can be blank
                  write(6,*)' Blank line in phase data'
                  write(6,'(a)')data(1)(1:79)
                  stop
               endif
            endif
c
c   check if last record is blank as it should be, if not, add one
c
            if(data(rea_nrecord).ne.' ') then
               rea_nrecord=rea_nrecord+1
               data(rea_nrecord)=' '
            endif
         enddo
      endif
c
c   calcualte abs times if phases read and header read
c
      if(rea_nphase.gt.1.and.all) then
         do i=1,rea_nphase
             call timsec(hyp_year(1),hyp_month(1),hyp_day(1),
     *       rea_hour(i),rea_min(i),rea_sec(i),rea_abs_time(i))
          enddo
      endif

c
c
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_event_out(unit,all,data,code)
c
c   Write all data to data array and optinally to file also. Variables
c   all come from common block.
c
c
c     input :   unit:  File unit to write from, if 0, only write
c                      to data array
c               all:   If true, read whole event, if false only headers
c               
c
c     output:   data:  S-file data array
c               code:  0: Ok, 1: Write error (not implemented)
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      integer unit,code
      logical all
      character*80 data(1000)
      integer i,k

     

c
c  now write all data, first main header, the main hypocenter (index 1) also
c  contains error info, high accuracy and extra magnitudes 
c
      rea_nrecord=0
c
c   there must be at least one hypo line
c
      if(rea_nhyp.le.0) then
           write(6,*)' No hypocenter lines for output'
           stop
      endif
      do i=1,rea_nhyp
         rea_nrecord=rea_nrecord+1
         call rea_hyp1_out(data(rea_nrecord),i)
c
c   for first prime hypocenter, there could be additional info
c
         if(i.eq.1) then
c
c   there could be an addiitonal high accuracy line
c
             if(hyp_high_accuracy(i)) then
                 rea_nrecord=rea_nrecord+1
                 call rea_hyph_out(data(rea_nrecord),i)
             endif
c
c   there could be an error line
c
             if(hyp_error(i))  then
                 rea_nrecord=rea_nrecord+1
                 call rea_hype_out(data(rea_nrecord),i)
             endif
c
c   check for additonal magnitudes, are in type 1 line with same first
c   23 chars and same hypocenter agency as the prime solution
c
             if(hyp_mag(4,1).gt.-100.0.or.hyp_mag(5,1).gt.-100.0.or.
     *       hyp_mag(6,1).gt.-100.0) then
                rea_nrecord=rea_nrecord+1
                call rea_hypm_out(data(rea_nrecord),i)
             endif
          endif
      enddo
c
c   spectral average line
c
      if(rea_av_moment.gt.0.0.or.rea_av_omega0.gt.0.0) then
         rea_nrecord=rea_nrecord+1
         call rea_av_spec_out(data(rea_nrecord))
      endif
      
c
c   spectral lines  
c
      do i=1,rea_nphase
         if(rea_phase(i)(1:4).eq.'SPEC') then
             rea_nrecord=rea_nrecord+1
             call rea_spec_out(i,data(rea_nrecord),data(rea_nrecord+1))
             rea_nrecord=rea_nrecord+1       ! there are 2 spectral lines
          endif
      enddo
c
c   fault plane solutions
c
      if(rea_nfault.gt.0) then
          do i=1,rea_nfault
             rea_nrecord=rea_nrecord+1
             data(rea_nrecord)=rea_fault(i)
          enddo
      endif
c
c    waveform file names
c
      if(rea_nwav.gt.0) then
          do i=1,rea_nwav
             rea_nrecord=rea_nrecord+1
             data(rea_nrecord)=rea_wav(i)
          enddo
      endif

c
c    macroseismic info
c
      if(rea_nmacro.gt.0) then
          do i=1,rea_nmacro
             rea_nrecord=rea_nrecord+1
             data(rea_nrecord)=rea_macro(i)
          enddo
      endif
c
c    comment lines
c
      if(rea_ncomment.gt.0) then
          do i=1,rea_ncomment
             rea_nrecord=rea_nrecord+1
             data(rea_nrecord)=rea_comment(i)
          enddo
      endif
c
c   id line
c
      if(rea_id_line.ne.' ') then
         rea_nrecord=rea_nrecord+1
         data(rea_nrecord)=rea_id_line
      endif
c
c    phase explanation line
c
      rea_nrecord=rea_nrecord+1
      data(rea_nrecord)=
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO '//
     *'AIN AR TRES W  DIS CAZ7'
c     *'SNR AR TRES W  DIS CAZ7'
c
c   number of header lines
c
       rea_nhead=rea_nrecord
c
c   write phases if specified, spectral related phases not written
c

      if(all) then
         do i=1,rea_nphase

            if(rea_phase(i)(1:4).ne.'SPEC'.and.rea_phase(i)(1:6).ne.
     *         'DELETE') then
               rea_nrecord=rea_nrecord+1
               call rea_phase_out(i,data(rea_nrecord))     ! write
            endif
         enddo
      endif
c
c   make last record blank
c
      rea_nrecord=rea_nrecord+1
      data(rea_nrecord)=' '
c
c   write out if flag set
c
       if(unit.gt.0) then
           write(unit,'(a)',err=100) (data(i),i=1,rea_nrecord)
           goto 101
 100       continue
           write(6,*)' Error writing S-file data array, data'
           stop
 101       continue
      endif
c
      return
      end

                  
      subroutine rea_hyp1_in(text,ihyp)
c
c   read all hypocenter info from type 1 line in text into
c   common block hypocenter array number ihyp
c   some checking is done
c
c   note: agencies are 5 chars of which only 3 is used
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80   text
      character*20   err_text       ! error text
      integer        ihyp,seiclen
c
      if (seiclen(text(2:79)).le.0) goto 60
      if(text(80:80).ne.' '.and.text(80:80).ne.'1') then
         write(6,*) ' Not a type 1 line'
         stop
      endif
c      write(3,*)' in read1',ihyp,text(1:40)
c
c   read times
c
      err_text='hypocenter time'
      if(text(2:5).ne.' ')   read(text(2:5),   '(i4)',  err=50)
     *hyp_year(ihyp)
      if(text(7:8).ne.' ' )  read(text(7:8),   '(i2)',  err=50)
     *hyp_month(ihyp)
      if(text(9:10).ne.' ' ) read(text(9:10),  '(i2)',  err=50)
     *hyp_day(ihyp)
      if(text(12:13).ne.' ') read(text(12:13), '(i2)',  err=50)
     *hyp_hour(ihyp)
      if(text(14:15).ne.' ') read(text(14:15), '(i2)',  err=50)
     *hyp_min(ihyp)
      if(text(17:20).ne.' ') read(text(17:20), '(f4.1)',err=50)
     *hyp_sec(ihyp)
c      write(3,*)ihyp,hyp_year(ihyp)

c
c   flags, check a bit
c
      hyp_model(ihyp)=text(21:21)
      hyp_dist_id(ihyp)=text(22:22)
      if(hyp_dist_id(ihyp).ne.'L'.and.hyp_dist_id(ihyp).ne.'R'.and.
     *hyp_dist_id(ihyp).ne.'D') then
         err_text='distance id'
         goto 50
      endif
      hyp_type(ihyp)=text(23:23)
      hyp_fix_org(ihyp)=text(11:11)
      if(hyp_fix_org(ihyp).ne.' '.and.hyp_fix_org(ihyp).ne.'F') then
         err_text='origin time flag'
         goto 50
      endif
c
c  hypocenter
c
      err_text='hypocenter'
      if(text(24:30).ne.' ') read(text(24:30),
     *'(f7.3)',err=50) hyp_lat(ihyp)
      if(text(31:38).ne.' ') read(text(31:38),
     *'(f8.3)',err=50) hyp_lon(ihyp)
      if(text(39:43).ne.' ') read(text(39:43),
     *'(f5.1)',err=50) hyp_depth(ihyp)
c
c   hypocenter flags
c
      hyp_depth_flag(ihyp)=text(44:44)
      hyp_epi_flag(ihyp)=text(45:45)
      if( hyp_depth_flag(ihyp).ne.' '.and.hyp_depth_flag(ihyp).ne.'F'.
     *and.hyp_depth_flag(ihyp).ne.'S'.and.hyp_epi_flag(ihyp)  .ne.' '.
     *and.  hyp_epi_flag(ihyp).ne.'F'.and.hyp_epi_flag(ihyp).  ne.'*')
     *then
          err_text='hypocenter flags'
          goto 50
      endif
c
c   agency
c
      hyp_agency(ihyp)(1:3)=text(46:48)
c
c   number of stations
c
      err_text='number of stations'
      if(text(49:51).ne.' ')
     *read(text(49:51),'(i3)',err=50) hyp_nstat(ihyp)
c
c   rms
c
      err_text='rms'
      if(text(52:55).ne.' ')
     *read(text(52:55),'(f4.1)',err=50) hyp_rms(ihyp)
c
c   magnitudes
c
      err_text='magnitudes'
      if(text(56:63).ne.' ')
     *read(text(56:63),'(f4.1,a1,a3)',err=50)
     *hyp_mag(1,ihyp),hyp_mag_type(1,ihyp),hyp_mag_agency(1,ihyp)(1:3)

      if(text(64:71).ne.' ')
     *read(text(64:71),'(f4.1,a1,a3)',err=50)
     *hyp_mag(2,ihyp),hyp_mag_type(2,ihyp),hyp_mag_agency(2,ihyp)(1:3)

      if(text(72:79).ne.' ')
     *read(text(72:79),'(f4.1,a1,a3)',err=50)
     *hyp_mag(3,ihyp),hyp_mag_type(3,ihyp),hyp_mag_agency(3,ihyp)(1:3)

c
c   finish reading without errors
c
      goto 60
c
c   error
c

 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,' reading hyp line'
      write(6,'(a)') text
      write(6,*)' Will stop'
      stop

 60   continue
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_hyph_in(text,ihyp)
c
c   read all hypocenter info from type H line (high accuracy hypoenter
c   line) in text into common block hypocenter array number ihyp
c
c   some checking is done
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80   text
      character*20   err_text       ! error text
      integer        ihyp
c
      if(text(80:80).ne.'H') then
         write(6,*)' Not a high accuracy hypocenter line'
         stop
      endif
c
c   read times
c
      hyp_high_accuracy(ihyp)=.true.
      err_text='hypocenter time'
      if(text(2:5).ne.' ')   read(text(2:5),   '(i4)',  err=50)
     *hyp_year(ihyp)
      if(text(7:8).ne.' ' )  read(text(7:8),   '(i2)',  err=50)
     *hyp_month(ihyp)
      if(text(9:10).ne.' ' ) read(text(9:10),  '(i2)',  err=50)
     *hyp_day(ihyp)
      if(text(12:13).ne.' ') read(text(12:13), '(i2)',  err=50)
     *hyp_hour(ihyp)
      if(text(14:15).ne.' ') read(text(14:15), '(i2)',  err=50)
     *hyp_min(ihyp)
      if(text(17:23).ne.' ') read(text(17:23), '(f6.3)',err=50)
     *hyp_sec(ihyp)

c
c  hypocenter
c
      err_text='hypocenter'
      if(text(24:32).ne.' ') read(text(24:32),
     *'(f9.5)',err=50) hyp_lat(ihyp)
      if(text(34:43).ne.' ') read(text(34:43),
     *'(f10.5)',err=50) hyp_lon(ihyp)
      if(text(45:52).ne.' ') read(text(45:52),
     *'(f8.3)',err=50) hyp_depth(ihyp)
c
c   rms
c
      err_text='rms'
      if(text(54:59).ne.' ')
     *read(text(54:59),'(f6.3)',err=50) hyp_rms(ihyp)
c
c   finish reading without errors
c
      goto 60
c
c   error
c

 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,
     *' reading hyp high acc. line'
      write(6,'(a)') text
      stop

 60   continue
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_hype_in(text,ihyp)
c
c   read all error hypocenter info from type E line (error info
c   line) in text into common block hypocenter array number ihyp
c
c   some checking is done
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80   text
      character*20   err_text       ! error text
      integer        ihyp
c
      if(text(80:80).ne.'E') then
         write(6,*)' Not a hypocenter error line'
         stop
      endif
c
      hyp_error(ihyp)=.true.
c
c   gap
c
      err_text='gap'
      if(text(6:8).ne.' ') then
          read(text(6:8),'(f3.0)',err=50) hyp_gap(ihyp)
      endif
c
c   read origin time error
c
      err_text='origin time error'
      if(text(15:20).ne.' ') read(text(15:20),'(f6.2)',err=50)
     *hyp_sec_err(ihyp)
c
c  hypocenter errors
c
      err_text='hypocenter error'
      if(text(25:30).ne.' ') read(text(25:33),
     *'(f6.1)',err=50) hyp_lat_err(ihyp)
      if(text(33:38).ne.' ') read(text(33:38),
     *'(f6.1)',err=50) hyp_lon_err(ihyp)
      if(text(39:43).ne.' ') read(text(39:43),
     *'(f5.1)',err=50) hyp_depth_err(ihyp)
c
c   covariance terms
c
      err_text='hypocent covariance'
      if(text(44:55).ne.' ')
     *read(text(44:55),'(e12.4)',err=50) hyp_cov(1,ihyp)
      if(text(56:67).ne.' ')
     *read(text(56:67),'(e12.4)',err=50) hyp_cov(2,ihyp)
      if(text(68:79).ne.' ')
     *read(text(68:79),'(e12.4)',err=50) hyp_cov(3,ihyp)

c
c   finish reading without errors
c
      goto 60
c
c   error
c

 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,
     *' reading hyp error line'
      write(6,'(a)') text
      stop

 60   continue
      return
      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_hyp1_out(text,ihyp)
c
c   write all hypocenter info to type 1 line text from
c   common block array number ihyp
c
c   note: agencies are 5 chars of which only 3 is used
c
c   some checking is done
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80   text
      character*20   err_text       ! error text
      integer        ihyp
c
c   clear
c
      text=' '
      text(80:80)='1'
c
c   write times
c
      err_text='hypocenter time'
      if(hyp_year(ihyp). gt.0  ) write(text(2:5),   '(i4)',  err=50)
     *hyp_year(ihyp)
      if(hyp_month(ihyp).gt.0  ) write(text(7:8),   '(i2)',  err=50)
     *hyp_month(ihyp)
      if(hyp_day(ihyp).  gt.0  ) write(text(9:10),  '(i2)',  err=50)
     *hyp_day(ihyp)
      if(hyp_hour(ihyp). ge.0  ) write(text(12:13), '(i2)',  err=50)
     *hyp_hour(ihyp)
      if(hyp_min(ihyp).  ge.0  ) write(text(14:15), '(i2)',  err=50)
     *hyp_min(ihyp)
      if(hyp_sec(ihyp).  ge.0.0) write(text(17:20), '(f4.1)',err=50)
     *hyp_sec(ihyp)
c
c   flags, check a bit
c
      text(21:21) = hyp_model(ihyp)
      text(22:22)=hyp_dist_id(ihyp)
      if(hyp_dist_id(ihyp).ne.'L'.and.hyp_dist_id(ihyp).ne.'R'.and.
     *hyp_dist_id(ihyp).ne.'D') then
         err_text='distance id'
         goto 50
      endif
      text(23:23)=hyp_type(ihyp)
      text(11:11)=hyp_fix_org(ihyp)
      if(hyp_fix_org(ihyp).ne.' '.and.hyp_fix_org(ihyp).ne.'F') then
         err_text='origin time flag'
         goto 50
      endif
c
c  hypocenter
c
      err_text='hypocenter'
      if(hyp_lat(ihyp).ne.-999.0) write(text(24:30),
     *'(f7.3)',err=50) hyp_lat(ihyp)
      if(hyp_lon(ihyp).ne.-999.0) write(text(31:38),
     *'(f8.3)',err=50) hyp_lon(ihyp)
      if(hyp_depth(ihyp).ge.0) then
         if(hyp_depth(ihyp).lt.10.0) then
            write(text(39:43),'(f5.2)',err=50) hyp_depth(ihyp)
         else
            write(text(39:43),'(f5.1)',err=50) hyp_depth(ihyp)
         endif
      endif
c
c   hypocenter flags
c
      text(44:44)=hyp_depth_flag(ihyp)
      text(45:45)=hyp_epi_flag(ihyp)
      if( hyp_depth_flag(ihyp).ne.' '.and.hyp_depth_flag(ihyp).ne.'F'.
     *and.hyp_depth_flag(ihyp).ne.'S'.and.hyp_epi_flag(ihyp)  .ne.' '.
     *and.  hyp_epi_flag(ihyp).ne.'F'.and.hyp_epi_flag(ihyp).  ne.'*')
     *then
          err_text='hypocenter flags'
          goto 50
      endif
c
c   agency
c
      text(46:48)=hyp_agency(ihyp)(1:3)
c
c   number of stations, if more than 1000, reduce to 999
c
      err_text='number of stations'
      if(hyp_nstat(ihyp).gt.1000) hyp_nstat(ihyp)=999
      if(hyp_nstat(ihyp).gt.0)
     *write(text(49:51),'(i3)',err=50) hyp_nstat(ihyp)
c
c   rms
c
      if(hyp_rms(ihyp).ge.0.0) then
         err_text='rms'
         if(hyp_rms(ihyp).ge.100.0) hyp_rms(ihyp)=99.0
         if(hyp_rms(ihyp).lt.1.0) then
             write(text(53:55),'(f3.2)',err=50) hyp_rms(ihyp)
         else

             write(text(52:55),'(f4.1)',err=50) hyp_rms(ihyp)
         endif
       endif
c
c   magnitudes
c
      err_text='magnitudes'
      if(hyp_mag(1,ihyp).gt.-100.0)
     *write(text(56:63),'(f4.1,a1,a3)',err=50)
     *hyp_mag(1,ihyp),hyp_mag_type(1,ihyp),hyp_mag_agency(1,ihyp)(1:3)

      if(hyp_mag(2,ihyp).gt.-100.0)
     *write(text(64:71),'(f4.1,a1,a3)',err=50)
     *hyp_mag(2,ihyp),hyp_mag_type(2,ihyp),hyp_mag_agency(2,ihyp)(1:3)

      if(hyp_mag(3,ihyp).gt.-100.0)
     *write(text(72:79),'(f4.1,a1,a3)',err=50)
     *hyp_mag(3,ihyp),hyp_mag_type(3,ihyp),hyp_mag_agency(3,ihyp)(1:3)


c
c   finish writing without errors
c
      goto 60
c
c   error
c

 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,' writing hyp line'
      write(6,'(a)') text
      stop

 60   continue
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_hypm_out(text,ihyp)
c
c   write  extra magnitude info (mag 3 to 6) type 1 to line text from
c   common block array number ihyp. The first 23 chars and the agency
c   is the same as for the first hypocenter line for this hypocenter
c   with index ihyp
c
c   note: agencies are 5 chars of which only 3 is used
c
c   some checking is done
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80   text
      character*20   err_text       ! error text
      integer        ihyp
c
c   clear
c
      text=' '
      text(80:80)='1'
c
c   write times
c
      err_text='hypocenter time'
      if(hyp_year(ihyp). gt.0  ) write(text(2:5),   '(i4)',  err=50)
     *hyp_year(ihyp)
      if(hyp_month(ihyp).gt.0  ) write(text(7:8),   '(i2)',  err=50)
     *hyp_month(ihyp)
      if(hyp_day(ihyp).  gt.0  ) write(text(9:10),  '(i2)',  err=50)
     *hyp_day(ihyp)
      if(hyp_hour(ihyp). ge.0  ) write(text(12:13), '(i2)',  err=50)
     *hyp_hour(ihyp)
      if(hyp_min(ihyp).  ge.0  ) write(text(14:15), '(i2)',  err=50)
     *hyp_min(ihyp)
      if(hyp_sec(ihyp).  ge.0.0) write(text(17:20), '(f4.1)',err=50)
     *hyp_sec(ihyp)
c
c   flags, check a bit
c
      text(21:21) = hyp_model(ihyp)
      text(22:22)=hyp_dist_id(ihyp)
      if(hyp_dist_id(ihyp).ne.'L'.and.hyp_dist_id(ihyp).ne.'R'.and.
     *hyp_dist_id(ihyp).ne.'D') then
         err_text='distance id'
         goto 50
      endif
      text(23:23)=hyp_type(ihyp)
      text(11:11)=hyp_fix_org(ihyp)
      if(hyp_fix_org(ihyp).ne.' '.and.hyp_fix_org(ihyp).ne.'F') then
         err_text='origin time flag'
         goto 50
      endif
c
c   agency
c
      text(46:48)=hyp_agency(ihyp)(1:3)
c
c   magnitudes
c
      err_text='magnitudes'
      if(hyp_mag(4,ihyp).gt.-100.0)
     *write(text(56:63),'(f4.1,a1,a3)',err=50)
     *hyp_mag(1,ihyp),hyp_mag_type(1,ihyp),hyp_mag_agency(1,ihyp)(1:3)

      if(hyp_mag(5,ihyp).gt.-100.0)
     *write(text(64:71),'(f4.1,a1,a3)',err=50)
     *hyp_mag(2,ihyp),hyp_mag_type(2,ihyp),hyp_mag_agency(2,ihyp)(1:3)

      if(hyp_mag(6,ihyp).gt.-100.0)
     *write(text(72:79),'(f4.1,a1,a3)',err=50)
     *hyp_mag(3,ihyp),hyp_mag_type(3,ihyp),hyp_mag_agency(3,ihyp)(1:3)
c
c   finish writing without errors
c
      goto 60
c
c   error
c

 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,' writing hyp line'
      write(6,'(a)') text
      stop

 60   continue
      return
      end






cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_hyph_out(text,ihyp)
c
c   write all hypocenter info to type H line text from
c   common block array number ihyp
c
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80   text
      character*20   err_text       ! error text
      integer        ihyp
c
c   clear
c
      text=' '
      text(80:80)='H'
c
c   write times
c
      err_text='hypocenter time'
      if(hyp_year(ihyp). gt.0  ) write(text(2:5),   '(i4)',  err=50)
     *hyp_year(ihyp)
      if(hyp_month(ihyp).gt.0  ) write(text(7:8),   '(i2)',  err=50)
     *hyp_month(ihyp)
      if(hyp_day(ihyp).  gt.0  ) write(text(9:10),  '(i2)',  err=50)
     *hyp_day(ihyp)
      if(hyp_hour(ihyp). ge.0  ) write(text(12:13), '(i2)',  err=50)
     *hyp_hour(ihyp)
      if(hyp_min(ihyp).  ge.0  ) write(text(14:15), '(i2)',  err=50)
     *hyp_min(ihyp)
      if(hyp_sec(ihyp).  ge.0.0) write(text(17:22), '(f6.3)',err=50)
     *hyp_sec(ihyp)
c
c  hypocenter
c
      err_text='hypocenter'
      if(hyp_lat(ihyp).ne.-999.0) write(text(24:32),
     *'(f9.5)',err=50) hyp_lat(ihyp)
      if(hyp_lon(ihyp).ne.-999.0) write(text(34:43),
     *'(f10.5)',err=50) hyp_lon(ihyp)
      if(hyp_depth(ihyp).ge.0) 
     *write(text(45:52),'(f8.3)',err=50) hyp_depth(ihyp)
c
c   rms
c
      if(hyp_rms(ihyp).ge.0.0) then
         err_text='rms'
         if(hyp_rms(ihyp).gt.100.0) hyp_rms(ihyp)=99.0
         write(text(54:59),'(f6.3)',err=50) hyp_rms(ihyp)
       endif
c
c   finish writing without errors
c
      goto 60
c
c   error
c

 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,
     *' writing hyp high accuracy line'
      write(6,'(a)') text
      stop

 60   continue
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_hype_out(text,ihyp)
c
c   read all error hypocenter info from type E line (error info
c   line) in text into common block hypocenter array number ihyp
c
c   some checking is done
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80   text
      character*20   err_text       ! error text
      integer        ihyp
c

      text=' '
      text(80:80)='E'

c
c   gap
c
      err_text='gap'
      if(hyp_gap(ihyp).ge.0.0) then
          text(2:5)='GAP='
          write(text(6:8),'(i3)',err=50) int(hyp_gap(ihyp)+0.5)
      endif
c
c   write origin time error
c
      err_text='origin time error'
      if(hyp_sec_err(ihyp).ge.0.0) then
         if(hyp_sec_err(ihyp).gt.1000.0) hyp_sec_err(ihyp)=999.0
         if(hyp_sec_err(ihyp).gt.1.0) 
     *   write(text(15:20),'(f6.2)',err=50) hyp_sec_err(ihyp)
         if(hyp_sec_err(ihyp).le.1.0) 
     *   write(text(15:20),'(f6.3)',err=50) hyp_sec_err(ihyp)
       endif
c
c  hypocenter errors
c
      err_text='hypocenter error'
      if(hyp_lat_err(ihyp).ge.0.0) then
         if(hyp_lat_err(ihyp).gt.1000.0) hyp_lat_err(ihyp)=999.0
         if(hyp_lat_err(ihyp).le.1.0) write(text(25:33),
     *   '(f6.3)',err=50) hyp_lat_err(ihyp)
         if(hyp_lat_err(ihyp).gt.1.0) write(text(25:33),
     *   '(f6.1)',err=50) hyp_lat_err(ihyp)
      endif

      if(hyp_lon_err(ihyp).ge.0.0) then
         if(hyp_lon_err(ihyp).gt.1000.0) hyp_lon_err(ihyp)=999.0
         if(hyp_lon_err(ihyp).le.1.0) write(text(33:38),
     *   '(f6.3)',err=50) hyp_lon_err(ihyp)
         if(hyp_lat_err(ihyp).gt.1.0) write(text(33:38),
     *   '(f6.1)',err=50) hyp_lon_err(ihyp)
      endif

      if(hyp_depth_err(ihyp).ge.0.0) then
         if(hyp_depth_err(ihyp).gt.1000.0) hyp_depth_err(ihyp)=999.0
         if(hyp_depth_err(ihyp).le.1.0) write(text(39:43),
     *   '(f5.3)',err=50) hyp_depth_err(ihyp)
         if(hyp_depth_err(ihyp).gt.1.0) write(text(39:43),
     *   '(f5.1)',err=50) hyp_depth_err(ihyp)
      endif
 
c
c   covariance terms
c
      err_text='hypocent covariance'
      if(hyp_cov(1,ihyp).ge.-1.0e9)
     *write(text(44:55),'(e12.4)',err=50) hyp_cov(1,ihyp)
      if(hyp_cov(2,ihyp).ge.-1.0e9)
     *write(text(56:67),'(e12.4)',err=50) hyp_cov(2,ihyp)
      if(hyp_cov(3,ihyp).ge.-1.0e9)
     *write(text(68:79),'(e12.4)',err=50) hyp_cov(3,ihyp)

c
c   finish reading without errors
c
      goto 60
c
c   error
c

 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,
     *' writing hyp error line'
      write(6,'(a)') text
      stop

 60   continue
      return
      end




cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine rea_hyp_clear(ihyp)
c
c   initialize hyp1 line parameters for one entry at index ihyp,
c   character items are set to blanks and numbers to -999 excepth
c   covariace element which is set to -9.9e10
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      integer ihyp,i

      hyp_year(ihyp)=-999              ! hypocenter year
      hyp_month(ihyp)=-999
      hyp_day(ihyp)=-999
      hyp_hour(ihyp)=-999
      hyp_min(ihyp)=-999
      hyp_sec(ihyp)=-999.0
      hyp_model(ihyp)=' '             ! model indicator
      hyp_dist_id(ihyp)=' '           ! distance indicator
      hyp_type(ihyp)=' '              ! event type like E
      hyp_fix_org(ihyp)=' '           ! fix origin time flag
      hyp_lat(ihyp)=-999.0            ! latitude
      hyp_lon(ihyp)=-999.0            ! longitude
      hyp_depth(ihyp)=-999.0          ! depth
      hyp_depth_flag(ihyp)=' '        ! depth flag
      hyp_epi_flag(ihyp)=' '          ! epicenter flag
      hyp_agency(ihyp)=' '            ! hypocenter agency, use 3 only
      hyp_nstat(ihyp)=-999            ! number of station
      hyp_rms(ihyp)=-999.0            ! rms of hypocenter solution
      do i=1,6
         hyp_mag(i,ihyp)=-999.0       ! magnitudes
         hyp_mag_type(i,ihyp)=' '     ! magnitude types
         hyp_mag_agency(i,ihyp)=' '   ! magnitude agencies
      enddo
      hyp_high_accuracy(ihyp)=.false. ! high accurcy flag
      hyp_error(ihyp)=.false.         ! error flag
      do i=1,3
         hyp_cov(i,ihyp)= -9.9e10     ! covarieance elements
      enddo
      hyp_gap(ihyp)=-999.0            ! gap
      hyp_sec_err(ihyp)=-999.0        ! origin time error
      hyp_lat_err(ihyp)=-999.0        ! hypocenter errors
      hyp_lon_err(ihyp)=-999.0
      hyp_depth_err(ihyp)=-999.0
      hyp_auto(ihyp)=' '              ! not an automatic parameter

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c      subroutine rea_hyp_inp(data,nhead)
c
c   read all hypocenter info from data array nhead header lines into
c   common block hypocenter arrays
c
c      implicit none
c      include 'seidim.inc'
c      include 'rea.inc'
c      return
c     end



      subroutine rea_phase_out(iphas,text)
c
c   write one phase line from rea common, the phase number is iphas
c   and it is written to text, some checking of the values is
c   done, if errors the program stops
c
c   the time to write out is taken from the hr, min, sec. if not
c   available (still have initial values) use abs time. Be aware that
c   if a phase time is just after midnight, oriign time before midninght,
c   the hour must be 24 or more. So the abs time migh give an undesirded
c   effect
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      include 'seisan.inc'
      character*80 text
      integer iphas,i

      text=' '
c
c   if phase is a spectrum or deleted, do not write out
c
      if(rea_phase(iphas)(1:4).eq.'SPEC'   .or.
     *   rea_phase(iphas)(1:6).eq.'DELETE') return

c
c   check which time to use
c
      if((rea_hour(iphas).eq.-999.0.or.rea_min(iphas).eq.-999.0).
     * and.rea_abs_time(iphas).gt.0.0)
     * call sectim(rea_abs_time(iphas),rea_year(iphas),i,
     * rea_month(iphas),rea_day(iphas),rea_hour(iphas),
     * rea_min(iphas),rea_sec(iphas))
c
c   station
c
      text(2:6)=rea_stat(iphas)
c
c   component, if short notion is not there, try to make it
c

      if(rea_co(iphas).eq.' ' ) then
         call component(rea_comp(iphas),rea_co(iphas))
      endif
      text(7:8)=rea_co(iphas)
c
c   onset
c
      text(10:10)=rea_onset(iphas)

c
c   phase name can be long in which case no input polarity can be given
c   and weight is put in column 9
c
      if(rea_phase(iphas)(5:8).ne.' ') then
         text(11:18)=rea_phase(iphas)
         text(9:9)=rea_weight_in(iphas)
      else
         text(11:14)=rea_phase(iphas)(1:4)
         text(15:15)=rea_weight_in(iphas)
         text(17:17)=rea_polarity(iphas)
      endif
c
c   automatic process
c
      if(rea_auto(iphas).ne.' ') text(16:16)='A'
c
c   hour
c
      if(rea_hour(iphas).ge.0) then
          write(text(19:20),'(i2)',err=5) rea_hour(iphas)
          goto 6
 5        continue
             write(6,*)' Error writing time, hr:',rea_hour(iphas)
             write(6,'(a)') text
             stop
 6        continue
       endif
c
c   min
c
      if(rea_min(iphas).ge.0) then
          write(text(21:22),'(i2)',err=7) rea_min(iphas)
          goto 8
 7        continue
             write(6,*)' Error writing time, min:',rea_min(iphas)
             write(6,'(a)') text
             stop
 8        continue
       endif
       
c
c  seconds, can be high accuracy
c
      if(rea_sec(iphas).ge.0.0) then
         if(high_accuracy) then
            write(text(23:28),'(f6.3)',err=10) rea_sec(iphas)
         else
            write(text(24:28),'(f5.2)',err=10) rea_sec(iphas)
         endif
         goto 11
 10      continue
            write(6,*)' Error writing time, sec:',rea_sec(iphas)
            write(6,'(a)') text
         stop
 11      continue
      endif
c
c   coda
c
      if(rea_coda(iphas).gt.0.0) then
         write(text(30:33),'(i4)',err=15) int(rea_coda(iphas))
         goto 16
 15      continue
           write(6,*)' Error writing coda:', rea_coda(iphas)
           write(6,'(a)') text
           stop
 16      continue
      endif
c
c  amplitude, amplitude must be formated to a range of values
c

      if(rea_amp(iphas).gt.0.0) then
c
c   check size of amplitude                                                 
c        
         if(rea_amp(iphas).ne.0..and.rea_amp(iphas).lt.100000.)
     +   write(text(34:40),'(f7.1)')
     +   rea_amp(iphas)
         if(rea_amp(iphas).ne.0..and.rea_amp(iphas).ge.1.0e5
     +      .and.rea_amp(iphas).lt.1.0e7)then
            rea_amp(iphas)=rea_amp(iphas)/1.0e4                 
            write(text(34:40),'(f5.1,a)')
     +      rea_amp(iphas),'e4'
         endif
         if(rea_amp(iphas).ne.0..and.rea_amp(iphas).ge.1.0e7
     +      .and.rea_amp(iphas).lt.1.0e9)then
            rea_amp(iphas)=rea_amp(iphas)/1.0e6                 
            write(text(34:40),'(f5.1,a)')
     +      rea_amp(iphas),'e6'
         endif
         if(rea_amp(iphas).ne.0..and.rea_amp(iphas).ge.1.0e9
     +      .and.rea_amp(iphas).lt.1.0e11)then
            rea_amp(iphas)=rea_amp(iphas)/1.0e8                 
            write(text(34:40),'(f5.1,a)')
     +      rea_amp(iphas),'e8'
         endif
         if(rea_amp(iphas).ge.1.0e11) then
             write(6,*)' Amplitude larger than 100 meters, unrealistic'
             stop
         endif
      endif
c
c   period
c
      if(rea_per(iphas).gt.0.0) then
         if(rea_per(iphas).lt.10.0) then
             write(text(42:45),'(f4.2)',err=20) rea_per(iphas)
         else
             write(text(42:45),'(f4.1)',err=20) rea_per(iphas)
         endif
         goto 21
 20      continue
            write(6,*)' Error writing period:', rea_per(iphas)
            write(6,'(a)') text
            stop
 21      continue
      endif
c
c   back azimuth
c
      if(rea_baz_obs(iphas).ne.-999.0) then
         write(text(47:51),'(f5.1)',err=25) rea_baz_obs(iphas)
         goto 26
 25      write(6,*)' Error writing observed back azimuth:',
     *   rea_baz_obs(iphas)
         write(6,'(a)') text
         stop
 26   continue
      endif
c
c  apparent velocity
c
      if(rea_vel(iphas).ne.-999.0) then
         write(text(53:56),'(f4.1)',err=30) rea_vel(iphas)
         goto 31
 30      write(6,*)' Error writing apparent velocity:',
     *   rea_vel(iphas)
         write(6,'(a)') text
         stop
 31   continue
      endif
c
c  signal to noise ratio, reduce to 999 if larger than 1000
c
      if(rea_sn(iphas).ge.0.0) then
         if(rea_sn(iphas).gt.1000.0) rea_sn(iphas)=999.0 ! max 1000
         if(rea_sn(iphas).lt.100.0) then
             write(text(57:60),'(f4.1)',err=35) rea_sn(iphas)
         else
             write(text(57:60),'(f4.0)',err=35) rea_sn(iphas)
         endif
         goto 36
 35      write(6,*)' Error writing signal to noise ratio:',
     *   rea_sn(iphas)
         write(6,'(a)') text
         stop
 36   continue
      endif
c
c  azimuth residual, if negative convert to positive if smaller than -99
c
      if(rea_baz_res(iphas).ne.-999.0) then
         if(rea_baz_res(iphas).lt.-99.0)
     *   rea_baz_res(iphas)=rea_baz_res(iphas)+360.0
         if(rea_baz_res(iphas).gt.0.0) then
            write(text(61:63),'(i3)',err=40) int(rea_baz_res(iphas)+0.5)
         else
            write(text(61:63),'(i3)',err=40) int(rea_baz_res(iphas)-0.5)
         endif
         goto 41
 40      write(6,*)' Error writing back azimuth residual:',
     *   rea_baz_res(iphas)
         write(6,'(a)') text
         stop
 41   continue
      endif
c
c   travel time residual, values larger than 100 are truncated to 99.0
c
      if(rea_res(iphas).ne.-999.0) then
         if(rea_res(iphas).gt.100.0)  rea_res(iphas)=99.0
         if(rea_res(iphas).lt.-100.0) rea_res(iphas)=-99.0
         if(abs(rea_res(iphas)).lt.1.0)
     *      write(text(64:68),'(f5.3)',err=45) rea_res(iphas)
         if(abs(rea_res(iphas)).lt.10.0.and.abs(rea_res(iphas)).ge.1.0)
     *      write(text(64:68),'(f5.2)',err=45) rea_res(iphas)
         if(abs(rea_res(iphas)).lt.100.0.and.abs(rea_res(iphas)).
     *      ge.10.0)
     *      write(text(64:68),'(f5.1)',err=45) rea_res(iphas)
         goto 46
 45         write(6,*)' Error writing travel time residual:',
     *      rea_res(iphas)
            write(6,'(a)') text
            stop
 46      continue
      endif
      
c
c   output weight
c
      if(rea_weight_out(iphas).ne.' ') then
         read(rea_weight_out(iphas),'(i2)',err=50) i
         text(69:70)=rea_weight_out(iphas)
         goto 51
 50      continue
            write(6,'(a25,1x,a2)')' Error with output weight:',
     *         rea_weight_out(iphas)
               write(6,'(a)') text
               stop
 51         continue
      endif
c
c  azimuth at source, if negative convert to positive
c
      if(rea_az(iphas).ne.-999.0) then
         if(rea_az(iphas).lt.0.0)
     *   rea_az(iphas)=rea_az(iphas)+360.0
         write(text(77:79),'(i3)',err=55) int(rea_az(iphas)+0.5)
         goto 56
 55         write(6,*)' Error writing azimuth:',
     *      rea_az(iphas)
            write(6,'(a)') text
            stop
 56      continue
      endif
c
c   epicentral distance
c
      if(rea_dist(iphas).ge.0.0) then
         if(rea_dist(iphas).lt.10.0)
     *      write(text(71:75),'(f5.3)',err=60) rea_dist(iphas)
         if(rea_dist(iphas).lt.100.0.and.rea_dist(iphas).ge.10.0)
     *      write(text(71:75),'(f5.2)',err=60) rea_dist(iphas)
         if(rea_dist(iphas).lt.1000.0.and.rea_dist(iphas).
     *      ge.100.0)
     *      write(text(71:75),'(f5.1)',err=60) rea_dist(iphas)
         if(rea_dist(iphas).ge.1000.0)
     *      write(text(71:75),'(i5)',err=60) int(rea_dist(iphas))
         goto 61
 60         write(6,*)' Error writing epicentral distance',
     *      rea_dist(iphas)
            write(6,'(a)') text
            stop
 61      continue
      endif

      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      subroutine rea_phase_in(iphas,text)
c
c   reads one phase line from text line text,
c   the phase number to put info in is iphas,
c   data are read to rea-common block variables,
c   if errors the program stops
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80 text
      integer iphas,i
c
c pv: if(text(80:80).ne.' ') then
      if(text(80:80).ne.' '.AND.text(80:80).ne.'4') then
          write(6,*) ' Not a phase line'
          write(6,*) text
c          stop    ! commented out, lo
      endif
c
c   clear variables with phase parameters
c
      call rea_phase_clear(iphas)
c
c   station
c
      rea_stat(iphas)=text(2:6)
c
c   component, if short notion is not there, try to make it
c
      rea_co(iphas)=text(7:8)
c
c   onset
c
      rea_onset(iphas)=text(10:10)
c
c   phase name can be long in which case no input polarity can be given
c   and weight is in column 9
c
      if(text(9:9).ne.' '.or.(text(14:14).ne.' '.and.
     * text(15:18).ne.' '.and.text(17:17).ne.'C'.and.text(17:17).
     * ne.'D'.and.text(15:15).ne.' '.and.text(15:15).ne.'0'.and.
     * text(15:15).ne.'1'.and.text(15:15).ne.'2'.and.text(15:15).
     * ne.'3'.and.text(15:15).ne.'4'.and.text(15:15).ne.'9')) then
         rea_phase(iphas)=text(11:18)
         rea_weight_in(iphas)=text(9:9)
      else
         rea_phase(iphas)(1:4)=text(11:14)
         rea_weight_in(iphas)=text(15:15)
         rea_polarity(iphas)=text(17:17)
      endif
c
c auto phase
c
      if(text(16:16).eq.'A') rea_auto(iphas)='auto'

c
c   hour
c
      if(text(19:20).ne.' ') then
          read(text(19:20),'(i2)',err=5) rea_hour(iphas)
          goto 6
 5        continue
             write(6,*)' Error reading hour'
             write(6,'(a)') text
             stop
 6        continue
       endif
c
c   min
c
      if(text(21:22).ne.' ') then
          read(text(21:22),'(i2)',err=7) rea_min(iphas)
          goto 8
 7        continue
             write(6,*)' Error reading min:'
             write(6,'(a)') text
             stop
 8        continue
       endif
       
c
c  seconds
c
      if(text(23:28).ne.' ') then
         read(text(23:28),'(f6.3)',err=10) rea_sec(iphas)
         goto 11
 10      continue
            write(6,*)' Error reading secc:'
            write(6,'(a)') text
         stop
 11      continue
      endif
c
c   coda
c
      if(text(30:33).ne.' ') then
         read(text(30:33),'(f4.0)',err=15) rea_coda(iphas)
         goto 16
 15      continue
           write(6,*)' Error reading coda:'
           write(6,'(a)') text
           stop
 16      continue
      endif
c
c  amplitude
c

      if(text(34:40).ne.' ') then
          read(text(34:40),'(g7.1)',err=17) rea_amp(iphas)
          goto 18
 17       continue
             write(6,*)' Error reading amplitude'
             write(6,'(a)') text
 18       continue
      endif
c
c   period
c
      if(text(42:45).ne.' ') then
         read(text(42:45),'(f4.2)',err=20) rea_per(iphas)
         goto 21
 20      continue
            write(6,*)' Error reading period'
            write(6,'(a)') text
            stop
 21      continue
      endif
c
c   back azimuth
c
      if(text(47:51).ne.' ') then
         read(text(47:51),'(f5.1)',err=25) rea_baz_obs(iphas)
         goto 26
 25      write(6,*)' Error reading observed back azimuth:'
         write(6,'(a)') text
         stop
 26   continue
      endif
c
c  apparent velocity
c
      if(text(53:56).ne.' ') then
         read(text(53:56),'(f4.1)',err=30) rea_vel(iphas)
         goto 31
 30      write(6,*)' Error reading apparent velocity:'
         write(6,'(a)') text
         stop
 31   continue
      endif
c
c  signal to noise ratio
c
      if(text(57:60).ne.' ') then
         read(text(57:60),'(f4.1)',err=35) rea_sn(iphas)
         goto 36
 35         write(6,*)' Error reading signal to noise ratio:'
            write(6,'(a)') text
            stop
 36      continue
      endif
c
c  azimuth residual
c
      if(text(61:63).ne.' ') then
         read(text(61:63),'(f3.0)',err=40) rea_baz_res(iphas)
         goto 41
 40         write(6,*)' Error readin back azimuth residual:'
            write(6,'(a)') text
            stop
 41      continue
      endif
c
c   travel time residual
c
      if(text(64:69).ne.' ') then
         read(text(64:68),'(f5.3)',err=45) rea_res(iphas)
         goto 46
 45         write(6,*)' Error reading travel time residual:'
            write(6,'(a)') text
            stop
 46      continue
      endif
      

c
c   output weight
c
      read(text(69:70),'(i2)',err=50) i
      rea_weight_out(iphas)=text(69:70)
      goto 51
 50   continue
         write(6,*)' Error reading output weight:'
         write(6,'(a)') text
         stop
 51   continue
c
c  azimuth at source
c
      if(text(77:79).ne.' ') then
         read(text(77:79),'(f3.0)',err=55) rea_az(iphas)
         goto 56
 55         write(6,*)' Error reading azimuth:'
            write(6,'(a)') text
            stop
 56      continue
      endif
c
c   epicentral distance
c
      if(text(71:75).ne.' ') then
         read(text(71:75),'(f5.0)',err=60) rea_dist(iphas)
         goto 61
 60         write(6,*)' Error reading epicentral distance'
            write(6,'(a)') text
            stop
 61      continue
      endif

      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      subroutine rea_phase_clear(iphas)
c
c   initialize phase line parameters for one entry at index iphas,
c   character items are set to blanks and numbers to -999
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      integer iphas
c
      rea_stat(iphas)=' '        ! station codes
      rea_comp(iphas)=' '        ! componenets
      rea_co(iphas)= ' '         ! 2 letter componenets
      rea_phase(iphas)= ' '      ! phase name
      rea_onset(iphas)=  ' '     ! onset I or E or blank
      rea_weight_in(iphas)= ' '  ! input weight
      rea_weight_out(iphas)=' '  ! weight out
      rea_polarity(iphas)=' '    ! polarity, D or C
      rea_year(iphas)=-999
      rea_month(iphas)=-999
      rea_day(iphas)=-999
      rea_hour(iphas)= -999
      rea_min(iphas)= -999
      rea_sec(iphas)= -999
      rea_abs_time(iphas)=-999   ! abs phase time
      rea_coda(iphas)= -999      ! coda length in s
      rea_amp(iphas)=  -999      ! amplitude in nm
      rea_per(iphas)=  -999      ! period of amplitude
      rea_baz_obs(iphas)= -999   ! observed back azimuth
      rea_baz_cal(iphas)= -999   ! calculated back azimuth
      rea_vel(iphas)= -999       ! observed apparent velocity
      rea_sn(iphas)=  -999       ! observed signal to noise ratio
      rea_baz_res(iphas)= -999   ! back azimuth residual
      rea_res(iphas)=-999        ! travel time residual
      rea_dist(iphas)= -999      ! epicentral distance
      rea_az(iphas)=   -999      ! azimuth
c

      rea_moment(iphas)=-999     ! log moment, Nm
      rea_sdrop(iphas)=-999      ! stress drop, bar
      rea_omega0(iphas)=-999     ! log spectral flat level, ns
      rea_cornerf(iphas)=-999    ! corner f
      rea_radius(iphas)=-999     ! source radius
      rea_swin(iphas)=-999       ! window lenght used
      rea_geo_dist(iphas)=-999   ! geo distance, km
      rea_vs(iphas)=-999         ! s-velocity at source, km/s
      rea_vp(iphas)=-999         ! p-velocity at source, km/s
      rea_q0(iphas)=-999         ! q0
      rea_qalpha(iphas)=-999     ! q alpha
      rea_kappa(iphas)=-999      ! kappa
      rea_density(iphas)=-999    ! density g/cm**3
      rea_slope(iphas)=-999      ! - measured slope of spectrum
      rea_mc(iphas)=-999         ! coda
      rea_ml(iphas)=-999         ! local
      rea_mb(iphas)=-999         ! mb
      rea_ms(iphas)=-999         ! ms
      rea_mw(iphas)=-999         ! mw
      rea_auto(iphas)=' '        ! not an automatic parameter
      

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_spec_in(iphas,text1,text2)
c
c   read spectral info to rea common, the phase number is iphas
c   and it is read from text1 and 2, some checking of the values is
c   done, if errors the program stops
c
c
c   there are two spectral phases defined: SPECP: P-spectrum
c                                          SPECS: S-spectrum
c
c   the time read in is put in normal phase variables
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80 text1,text2
      integer iphas,i
      real x                  ! help variable
      character*20 err_text   ! error text

c
c   clear variables
c
      call rea_phase_clear(iphas)

c
c   check if text strings are spectral strings and belong together
c
      if(text1(2:5).ne.'SPEC'.or.text2(2:5).ne.'SPEC'.or.
     *   text1(80:80).ne.'3'.or.text2(80:80).ne.'3'.or.
     *   text1(7:14).ne.text2(7:14)) then
         write(6,*)
     *   ' Two spec lines of wrong type or do not belong together'
         write(6,'(a)') text1
         write(6,'(a)') text2
c         stop
       endif
        
c
c   station
c
      rea_stat(iphas)(1:4)=text1(7:10)  ! not room for 5. letter
c
c   component
c
      rea_comp(iphas)=text1(11:14)

c
c   moment
c

      err_text='moment'
      if(text1(16:17).ne.'MO') goto 50
      if(text1(18:22).ne.' ') 
     *read(text1(18:22),'(f5.1)',err=50) rea_moment(iphas)
      
c
c   stress drop
c
      err_text='stress drop'
      if(text1(24:25).ne.'ST') goto 50
      if(text1(26:30).ne.' ') 
     *read(text1(26:30),'(f5.1)',err=50) rea_sdrop(iphas)
c
c   omega0
c
      err_text='omega0'
      if(text1(32:33).ne.'OM') goto 50
      if(text1(34:38).ne.' ')
     *read(text1(34:38),'(f5.1)',err=50) rea_omega0(iphas)
c
c   corner frequency
c
      err_text='corner frequency'
      if(text1(40:41).ne.'f0') goto 50
      if(text1(42:46).ne.' ') 
     *read(text1(42:46),'(f5.2)',err=50) rea_cornerf(iphas)
c
c   radius
c
      err_text='source radius'
      if(text1(48:48).ne.'R') goto 50
      if(text1(50:54).ne.' ') 
     *read(text1(50:54),'(f5.1)',err=50) rea_radius(iphas)

c
c   specteral slope, abs value
c
      err_text='spectral slope'
      if(text1(56:57).ne.'AL') goto 50
      if(text1(58:62).ne.' ') then 
         read(text1(58:62),'(f5.2)',err=50) rea_slope(iphas)
         rea_slope(iphas)=-rea_slope(iphas)
      endif
c
c   window length
c
      err_text='spectral window'
      if(text1(64:65).ne.'WI') goto 50
      if(text1(66:70).ne.' ') 
     *read(text1(66:70),'(f5.2)',err=50) rea_swin(iphas)
c
c   moment magnitude
c
      err_text='moment magnitude'
      if(text1(72:73).ne.'MW') goto 50
      if(text1(74:78).ne.' ')
     *read(text1(74:78),'(f5.1)',err=50) rea_mw(iphas)
c
c-----------------------------
c   second spec line
c-----------------------------
c

c
c   start of window
c
      err_text='window start time'
      if(text2(16:16).ne.'T') goto 51
      if(text2(17:22).ne.' ') then
         read(text2(17:22),'(3i2)',err=51) rea_hour(iphas),
     *    rea_min(iphas),i
          rea_sec(iphas)=i
      endif
c
c   kappa
c
      err_text='kappa'
      if(text2(24:25).ne.'K ') goto 51
      if(text2(26:30).ne.' ')
     *read(text2(26:30),'(f5.3)',err=51) rea_kappa(iphas)
c
c   geodistance
c
      err_text='geo distance'
      if(text2(32:33).ne.'GD') goto 51
      if(text2(34:38).ne.' ') 
     *read(text2(34:38),'(f5.1)',err=51) rea_geo_dist(iphas)
c
c   velocity for spectrum and spectral phases
c
      err_text='source velocity'
      if(text2(40:40).ne.'V ') goto 51
      rea_phase(iphas)='SPEC '
      rea_phase(iphas)(5:5)=text2(41:41)   ! type of spectrum
      if(text2(42:46).ne.' ') then
         read(text2(42:46),'(f5.2)',err=51) x
c
c   assign velocity to right velocity
c
         if(rea_phase(iphas)(5:5).eq.'S') rea_vs(iphas)=x  
         if(rea_phase(iphas)(5:5).eq.'P') rea_vp(iphas)=x
      endif
c
c   density
c
      err_text='density'
      if(text2(48:49).ne.'DE') goto 51
      if(text2(50:54).ne.' ') 
     *read(text2(50:54),'(f5.2)',err=51) rea_density(iphas)
c
c    q0
c
      err_text='q0'
      if(text2(56:57).ne.'Q0') goto 51
      if(text2(58:62).ne.' ') 
     *read(text2(58:62),'(f5.1)',err=51) rea_q0(iphas)
c
c   q-alpha
c
      err_text='q-alpha'
      if(text2(64:65).ne.'QA') goto 51
      if(text2(66:70).ne.' ') 
     *read(text2(66:70),'(f5.2)',err=51) rea_qalpha(iphas)
c
c   s-velocity
c
      err_text='S-velocty'
      if(text2(72:73).ne.'VS') goto 51
      if(text2(74:78).ne.' ') 
     *read(text2(74:78),'(f5.2)',err=51) rea_vs(iphas)
c
      goto 52


 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,' reading spec line'
      write(6,'(a)') text1
c      stop
 51   continue
      write(6,'(a,a,a)') 'Error with ',err_text,' reading spec line'
      write(6,'(a)') text2
c      stop

 52   continue
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_av_spec_in(text)
c
c   read spectral average info to rea common, the phase number is iphas
c   and it is read from text1,  some checking of the values is
c   done, if errors the program stops
c
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80 text
      character*20 err_text   ! error text


c
c  check if correct string
c
      if(text(2:13).ne.'SPEC AVERAGE') then
          write(6,*)' Not a spectral average input string'
          write(6,'(a)') text
          stop
      endif
c
c   clear variables
c
      rea_av_moment=-999.0
      rea_av_sdrop=-999.0
      rea_av_omega0=-999.0
      rea_av_cornerf=-999.0
      rea_av_radius=-999.0
      rea_av_slope=-999.0
      rea_av_swin=-999.0
      rea_av_mw=-999.0
c
c   moment
c

      err_text='moment'
      if(text(16:17).ne.'MO') goto 50
      if(text(18:22).ne.' ') 
     *read(text(18:22),'(f5.1)',err=50) rea_av_moment
      
c
c   stress drop
c
      err_text='stress drop'
      if(text(24:25).ne.'ST') goto 50
      if(text(26:30).ne.' ') 
     *read(text(26:30),'(f5.1)',err=50) rea_av_sdrop
c
c   omega0
c
      err_text='omega0'
      if(text(32:33).ne.'OM') goto 50
      if(text(34:38).ne.' ')
     *read(text(34:38),'(f5.1)',err=50) rea_av_omega0
c
c   corner frequency
c
      err_text='corner frequency'
      if(text(40:41).ne.'f0') goto 50
      if(text(42:46).ne.' ') 
     *read(text(42:46),'(f5.2)',err=50) rea_av_cornerf
c
c   radius
c
      err_text='source radius'
      if(text(48:48).ne.'R') goto 50
      if(text(50:54).ne.' ') 
     *read(text(50:54),'(f5.1)',err=50) rea_av_radius

c
c   specteral slope, abs value
c
      err_text='spectral slope'
      if(text(56:57).ne.'AL') goto 50
      if(text(58:62).ne.' ') then 
         read(text(58:62),'(f5.2)',err=50) rea_av_slope
         rea_av_slope=-rea_av_slope
      endif
c
c   window length
c
      err_text='spectral window'
      if(text(64:65).ne.'WI') goto 50
      if(text(66:70).ne.' ') 
     *read(text(66:70),'(f5.2)',err=50) rea_av_swin
c
c   moment magnitude
c
      err_text='moment magnitude'
      if(text(72:73).ne.'MW') goto 50
      if(text(74:78).ne.' ') 
     *read(text(74:78),'(f5.1)',err=50) rea_av_mw

      goto 51

 50   continue
      write(6,'(a,a,a)')
     *'Error with ',err_text,' reading average spec line'
      write(6,'(a)') text
      stop

 51   continue
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_spec_out(iphas,text1,text2)
c
c   write spectral info from rea common, the phase number is iphas
c   and it is written to text, some checking of the values is
c   done, if errors the program stops
c
c
c   there are two spectral phases defined: SPECP: P-spectrum
c                                          SPECS: S-spectrum

c   the time to write out is taken from the hr, min, sec. if not
c   available (still have initial values) use abs time
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80 text1,text2
      integer iphas,i
      real x                  ! help variable
      character*20 err_text   ! error text

      text1=' '
      text2=' '

c
c   check which time to use
c
      if((rea_hour(iphas).eq.-999.0.or.rea_min(iphas).eq.-999.0).
     * and.rea_abs_time(iphas).gt.0.0)
     * call sectim(rea_abs_time(iphas),rea_year(iphas),i,
     * rea_month(iphas),rea_day(iphas),rea_hour(iphas),
     * rea_min(iphas),rea_sec(iphas))
c
c   fixed values
c
      text1(2:5)='SPEC'
      text1(80:80)='3'
c
c   check if an auto process
c
      if(rea_auto(iphas).ne.' ') text1(6:6)='A'
c
c   station
c
      text1(7:10)=rea_stat(iphas)(1:4)  ! not room for 5. letter
c
c   component
c
      text1(11:14)=rea_comp(iphas)
c
c   same content
c
      text2=text1
c
c   check for overflow
c
      if(rea_sdrop(iphas).gt.999.0)  rea_sdrop(iphas)=999.0
      if(rea_cornerf(iphas).gt.999.0) rea_cornerf(iphas)=999.0
      if(rea_omega0(iphas).gt.999.0) rea_omega0(iphas)=999.0
      if(abs(rea_slope(iphas)).gt.999.0)   rea_slope(iphas)=999.0
      if(rea_geo_dist(iphas).gt.99999.) rea_geo_dist(iphas)=99999.0
      if(rea_radius(iphas).gt.999.0) rea_radius(iphas)=999.0
      if(rea_swin(iphas).gt.999.0) rea_swin(iphas)=999.0

c
c   moment
c
      text1(16:17)='MO'
      if(rea_moment(iphas).gt.0.0) then
         err_text='moment'
         write(text1(18:22),'(f5.1)',err=50) rea_moment(iphas)
      endif
c
c   stress drop
c
      text1(24:25)='ST'
      if(rea_sdrop(iphas).gt.0.0) then
         err_text='stress drop'
         write(text1(26:30),'(f5.1)',err=50) rea_sdrop(iphas)
      endif
c
c   omega0
c
      text1(32:33)='OM'
      if(rea_omega0(iphas).gt.0.0) then
         err_text='omega0'
         write(text1(34:38),'(f5.1)',err=50) rea_omega0(iphas)
      endif
c
c   corner frequency
c
      text1(40:41)='f0'
      if(rea_cornerf(iphas).gt.0.0) then
         err_text='corner frequency'
         if(rea_cornerf(iphas).lt.1.0) 
     *     write(text1(42:46),'(f5.3)',err=50) rea_cornerf(iphas)
         if(rea_cornerf(iphas).lt.10.0.and.rea_cornerf(iphas).ge.1.0)
     *     write(text1(42:46),'(f5.2)',err=50) rea_cornerf
         if(rea_cornerf(iphas).ge.10.0.and.rea_cornerf(iphas).lt.100.0)
     *      write(text1(42:46),'(f5.1)',err=50) rea_cornerf(iphas)
         if(rea_cornerf(iphas).ge.100.0) 
     *      write(text1(42:46),'(f5.0)',err=50) rea_cornerf(iphas)

c        write(text1(42:46),'(f5.2)',err=50) rea_cornerf(iphas)
      endif
c
c   radius
c
      text1(48:48)='R'
      if(rea_radius(iphas).gt.0.0) then
         err_text='source radius'
         if(rea_radius(iphas).lt.1.0)
     *   write(text1(50:54),'(f5.3)',err=50) rea_radius(iphas)
         if(rea_radius(iphas).lt.10.0.and.rea_radius(iphas).ge.1.0)
     *   write(text1(50:54),'(f5.2)',err=50) rea_radius(iphas)
         if(rea_radius(iphas).ge.10.0)
     *   write(text1(50:54),'(f5.1)',err=50) rea_radius(iphas)
      endif

c
c   specteral slope, abs value
c
      text1(56:57)='AL'
      if(rea_slope(iphas).gt.-20.0) then
         err_text='spectral slope'
         write(text1(58:62),'(f5.2)',err=50) -rea_slope(iphas)
      endif
c
c   window length
c
      text1(64:65)='WI'
      if(rea_swin(iphas).gt.0.0) then
         err_text='spectral window'
         if(rea_swin(iphas).lt.10.0)
     *   write(text1(66:70),'(f5.2)',err=50) rea_swin(iphas)
         if(rea_swin(iphas).ge.10.0)
     *   write(text1(66:70),'(f5.1)',err=50) rea_swin(iphas)
      endif
c
c   moment magnitude
c
      text1(72:73)='MW'
      if(rea_mw(iphas).gt.-10.0) then
         err_text='moment magnitude'
         write(text1(74:78),'(f5.1)',err=50) rea_mw(iphas)
      endif
c
c-----------------------------
c   second spec line
c-----------------------------
c

c
c   start of window
c
      text2(16:16)='T'
      if(rea_hour(iphas).gt.-1.and.rea_min(iphas).
     *gt.-1.and.rea_sec(iphas).gt.-1.0) then
         err_text='window start time'
         write(text2(17:22),'(3i2)',err=51) rea_hour(iphas),
     *   rea_min(iphas),int(rea_sec(iphas)+0.5)
      endif
c
c   kappa
c
      text2(24:25)='K '
      if(rea_kappa(iphas).gt.0.0) then
         err_text='kappa'
         write(text2(26:30),'(f5.3)',err=51) rea_kappa(iphas)
      endif
c
c   geodistance
c
      text2(32:33)='GD'
      if(rea_geo_dist(iphas).gt.0.0) then
         err_text='geo distance'
         if(rea_geo_dist(iphas).lt.10.0)
     *   write(text2(34:38),'(f5.3)',err=51) rea_geo_dist(iphas)
         if(rea_geo_dist(iphas).ge.10.0.and.rea_geo_dist(iphas).
     *   lt.100.0)
     *    write(text2(34:38),'(f5.2)',err=51) rea_geo_dist(iphas)
         if(rea_geo_dist(iphas).ge.100.0)
     *   write(text2(34:38),'(f5.1)',err=51) rea_geo_dist(iphas)
      endif
c
c   velocity for spectrum
c
      text2(40:41)='V '
      text2(41:41)=rea_phase(iphas)(5:5)  ! indicate if p or s-spectrum
      x=0.0
      if(rea_phase(iphas)(5:5).eq.'S') x=rea_vs(iphas)  ! find which velocity if any
      if(rea_phase(iphas)(5:5).eq.'P') x=rea_vp(iphas)
      if(x.gt.0.0) then
         err_text='source velocity'
         write(text2(42:46),'(f5.2)',err=51) x
      endif
c
c   density
c
      text2(48:49)='DE'
      if(rea_density(iphas).gt.0.0) then
         err_text='density'
         write(text2(50:54),'(f5.2)',err=51) rea_density(iphas)
      endif
c
c    q0
c
      text2(56:57)='Q0'
      if(rea_q0(iphas).gt.0.0) then
         if(rea_q0(iphas).gt.1000.0) rea_q0(iphas)=999.0
         err_text='q0'
         write(text2(58:62),'(f5.1)',err=51) rea_q0(iphas)
      endif
c
c   q-alpha
c
      text2(64:65)='QA'
      if(rea_qalpha(iphas).ge.0.0) then
         err_text='q-alpha'
         write(text2(66:70),'(f5.2)',err=51) rea_qalpha(iphas)
      endif
c
c   s-velocity
c
      text2(72:73)='VS'
      if(rea_vs(iphas).gt.0.0) then
         err_text='S-velocty'
         write(text2(74:78),'(f5.2)',err=51) rea_vs(iphas)
      endif
c
      goto 52


 50   continue
      write(6,'(a,a,a)') 'Error with ',err_text,' writing spec line'
      write(6,'(a)') text1
      stop
 51   continue
      write(6,'(a,a,a)') 'Error with ',err_text,' writing spec line'
      write(6,'(a)') text2
      stop

 52   continue
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine rea_av_spec_out(text)
c
c   write average spectral info from rea common to text
c
c   jh march 2001
c
      implicit none
      include 'seidim.inc'
      include 'rea.inc'
      character*80 text
      character*20 err_text   ! error text

      text=' '
c
c   fixed values
c
      text(2:13)='SPEC AVERAGE'
      text(80:80)='3'
c
c   check for overflow
c
      if(rea_av_sdrop.gt.999.0)  rea_av_sdrop=999.0
      if(rea_av_cornerf.gt.999.0) rea_av_cornerf=999.0
      if(rea_av_omega0.gt.999.0) rea_av_omega0=999.0
      if(abs(rea_av_slope).gt.999.0)   rea_av_slope=999.0
      if(rea_av_radius.gt.999.0) rea_av_radius=999.0
      if(rea_av_swin.gt.999.0) rea_av_swin=999.0

c
c   moment
c
      text(16:17)='MO'
      if(rea_av_moment.gt.0.0) then
         err_text='moment'
         write(text(18:22),'(f5.1)',err=50) rea_av_moment
      endif
c
c   stress drop
c
      text(24:25)='ST'
      if(rea_av_sdrop.gt.0.0) then
         err_text='stress drop'
         write(text(26:30),'(f5.1)',err=50) rea_av_sdrop
      endif
c
c   omega0
c
      text(32:33)='OM'
      if(rea_av_omega0.gt.0.0) then
         err_text='omega0'
         write(text(34:38),'(f5.1)',err=50) rea_av_omega0
      endif
c
c   corner frequency
c
      text(40:41)='f0'
      if(rea_av_cornerf.gt.0.0) then
         err_text='corner frequency'
         if(rea_av_cornerf.lt.1.0)
     *     write(text(42:46),'(f5.3)',err=50) rea_av_cornerf
         if(rea_av_cornerf.lt.10.0.and.rea_av_cornerf.ge.1.0)
     *     write(text(42:46),'(f5.2)',err=50) rea_av_cornerf
         if(rea_av_cornerf.ge.10.0.and.rea_av_cornerf.lt.100.0)
     *      write(text(42:46),'(f5.1)',err=50) rea_av_cornerf
         if(rea_av_cornerf.ge.100.0)
     *      write(text(42:46),'(f5.0)',err=50) rea_av_cornerf

c         write(text(42:46),'(f5.2)',err=50) rea_av_cornerf
      endif
c
c   radius
c
      text(48:48)='R'
      if(rea_av_radius.gt.0.0) then
         err_text='source radius'
         if(rea_av_radius.lt.1.0)
     *   write(text(50:54),'(f5.3)',err=50) rea_av_radius
         if(rea_av_radius.lt.10.0.and.rea_av_radius.ge.1.0)
     *   write(text(50:54),'(f5.2)',err=50) rea_av_radius
         if(rea_av_radius.ge.10.0)
     *   write(text(50:54),'(f5.1)',err=50) rea_av_radius
      endif

c
c   specteral slope, abs value
c
      text(56:57)='AL'
      if(rea_av_slope.gt.-20.0) then
         err_text='spectral slope'
         write(text(58:62),'(f5.2)',err=50) -rea_av_slope
      endif
c
c   window length
c
      text(64:65)='WI'
      if(rea_av_swin.gt.0.0) then
         err_text='spectral window'
         if(rea_av_swin.lt.10.0)
     *   write(text(66:70),'(f5.2)',err=50) rea_av_swin
         if(rea_av_swin.ge.10.0)
     *   write(text(66:70),'(f5.1)',err=50) rea_av_swin
      endif
c
c   moment magnitude
c
      text(72:73)='MW'
      if(rea_av_mw.gt.-10.0) then
         err_text='moment magnitude'
         write(text(74:78),'(f5.1)',err=50) rea_av_mw
      endif

      goto 51

 50   continue
      write(6,'(a,a,a)')
     *'Error with ',err_text,' writing avarage spec line'
      write(6,'(a)') text
      stop

 51   continue
      return
      end

c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       
      subroutine get_par(def_file)
c
c read definition file and store variables in common clock
c
      implicit none
      include 'libsei.inc' 
      include 'seidim.inc'
      include 'rea.inc'

      character*80 def_file
      integer in                    ! file unit
      logical exist                 ! true if def file exists
      integer code                  ! return code from opening def file
      integer i                     ! counter
      character*80 line             ! text line
      real var                      ! value of variables

c
c check for file, can be in local dir or DAT
c

      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   in,              ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   def_file )       ! For this filename.

      if(code.ne.e_ok$) then
        write(*,'(a,a)') ' Definition file does not exist:',
     *                    def_file
        stop   
      endif
c
c init values
c
      par_q0=0.0
      par_qalpha=0.0
      par_density=3.0
      par_kappa=0.0
      par_vp=6.0
      par_vs=3.5
c
c  p
c
      par_pick_p=0.0
      par_mb_amp=0.0
      par_mb_flow=1.0
      par_mb_flow_pole=4
      par_mb_fhigh=5.0
      par_mb_fhigh_pole=4
      par_pspec=0.0
      par_pspec_sn=4.0
      par_p_q0=0.0
      par_p_qalpha=0.0
      par_p_kappa=0.0
      par_p_flow=0.01
      par_p_flow_pole=8
      par_p_fhigh=50.0
      par_p_fhigh_pole=8

c
c  s
c
      par_pick_s=0.0
      par_ml_amp=0.0
      par_ml_flow=1.0
      par_ml_flow_pole=4
      par_ml_fhigh=5.0
      par_ml_fhigh_pole=4
      par_sspec=0.0
      par_sspec_sn=4.0
      par_s_q0=0.0
      par_s_qalpha=0.0
      par_s_kappa=0.0
      par_s_flow=0.01
      par_s_flow_pole=8
      par_s_fhigh=50.0
      par_s_fhigh_pole=8


      i=0

 1000 continue

c
c read text line from file, check for code and set variables
c
      read(in,'(a)',end=4000,err=3000) line
c
c  q0 and qalpha
c
      if (line(1:11).eq.'SPECTRAL Q0') then 
         read(line(41:50),'(f10.1)',err=3000) par_q0
      elseif(line(1:15).eq.'SPECTRAL QALPHA') then
         read(line(41:50),'(f10.1)',err=3000) par_qalpha
      elseif (line(1:16).eq.'SPECTRAL DENSITY') then
        read(line(41:50),'(f10.1)',err=3000) par_density
      elseif (line(1:14).eq.'SPECTRAL KAPPA') then
        read(line(41:50),'(f10.1)',err=3000) par_kappa
      elseif (line(1:19).eq.'SPECTRAL P-VELOCITY') then
        read(line(41:50),'(f10.1)',err=3000) par_vp
      elseif (line(1:19).eq.'SPECTRAL S-VELOCITY') then
        read(line(41:50),'(f10.1)',err=3000) par_vs
c
c   special P
c
      elseif (line(1:12).eq.'PICK P-PHASE') then
        read(line(41:50),'(f10.1)',err=3000) par_pick_p
      elseif (line(1:11).eq.'PICK AMP-MB') then
        read(line(41:50),'(f10.1)',err=3000) par_mb_amp
      elseif (line(1:20).eq.'MB LOW CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_mb_flow,
     *  par_mb_flow_pole
      elseif (line(1:21).eq.'MB HIGH CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_mb_fhigh,
     *  par_mb_fhigh_pole
      elseif (line(1:10).eq.'MB MIN S/N') then
        read(line(41:50),'(f10.1)',err=3000) par_mb_amp_sn
      elseif (line(1:10).eq.'P-SPECTRUM') then
        read(line(41:50),'(f10.1)',err=3000) par_pspec
      elseif (line(1:18).eq.'P-SPECTRUM MIN S/N') then
        read(line(41:50),'(f10.1)',err=3000) par_pspec_sn
      elseif (line(1:13).eq.'P-SPECTRUM Q0') then
        read(line(41:50),'(f10.1)',err=3000) par_p_q0
      elseif (line(1:17).eq.'P-SPECTRUM QALPHA') then
        read(line(41:50),'(f10.1)',err=3000) par_p_qalpha
      elseif (line(1:16).eq.'P_SPECTURM KAPPA') then
        read(line(41:50),'(f10.1)',err=3000) par_p_kappa
      elseif (line(1:28).eq.'P-SPECTRUM LOW CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_p_flow,
     *  par_p_flow_pole
      elseif (line(1:29).eq.'P-SPECTRUM HIGH CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_p_fhigh,
     *par_p_fhigh_pole
c
c  S
c

      elseif (line(1:12).eq.'PICK S-PHASE') then
        read(line(41:50),'(f10.1)',err=3000) par_pick_s
      elseif (line(1:11).eq.'PICK AMP-ML') then
        read(line(41:50),'(f10.1)',err=3000) par_ml_amp
      elseif (line(1:20).eq.'ML LOW CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_ml_flow,
     *  par_ml_flow_pole
      elseif (line(1:21).eq.'ML HIGH CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_ml_fhigh,
     *  par_ml_fhigh_pole
      elseif (line(1:10).eq.'ML MIN S/N') then
        read(line(41:50),'(f10.1)',err=3000) par_ml_amp_sn
      elseif (line(1:10).eq.'S-SPECTRUM') then
        read(line(41:50),'(f10.1)',err=3000) par_sspec
      elseif (line(1:18).eq.'S-SPECTRUM MIN S/N') then
        read(line(41:50),'(f10.1)',err=3000) par_sspec_sn
      elseif (line(1:13).eq.'S-SPECTRUM Q0') then
        read(line(41:50),'(f10.1)',err=3000) par_s_q0
      elseif (line(1:17).eq.'S-SPECTRUM QALPHA') then
        read(line(41:50),'(f10.1)',err=3000) par_s_qalpha
      elseif (line(1:16).eq.'S_SPECTURM KAPPA') then
        read(line(41:50),'(f10.1)',err=3000) par_s_kappa
      elseif (line(1:28).eq.'S-SPECTRUM LOW CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_s_flow,
     *  par_s_flow_pole
      elseif (line(1:29).eq.'S-SPECTRUM HIGH CUT AND POLES') then
        read(line(41:50),'(2f10.1)',err=3000) par_s_fhigh,
     *par_s_fhigh_pole

c
c   stations to use
c
      elseif (line(1:7).eq.'STATION') then
         i=i+1
cTATION MOL   S  Z    3.0   20.0   50.0   10.0    5.0  5.0 10.0

         par_stat(i)=' '
         par_comp(i)=' '
         par_sta(i)=0.0
         par_lta(i)=0.0
         par_ratio(i)=0.0
         par_mincoda(i)=0.0
         par_dtrle(i)=0.0
         par_fill(i)=0.0
         par_filh(i)=0.0

         read(line(9:63),'(a5,1x,a4,5(1x,f6.1),2(1x,f4.1))',
     &   err=3000)
     &   par_stat(i),par_comp(i),par_sta(i),par_lta(i),
     &   par_ratio(i),par_mincoda(i),par_dtrle(i),par_fill(i),
     &   par_filh(i)

      endif
     
      goto 1000

 3000 continue
      write(6,'(a,a)') ' Error in def file: ',def_file
      write(6,'(a)') line
      stop

4000  continue

      par_nstat=i

      write(6,'(a,a,2x,i3)') ' Number of stations in ',
     *def_file(1:20),par_nstat
      call sei close( close$, in, code )

      return
      end 

      subroutine add_phase_to_sfile(text,data,nhead,nrecord,overwrite)
c
c  and one new line to phase list in s-file, line added. If the same
c  component and phase exists and associated info (column 2:18),
c  overwrite if flag set
c
c  jh march 2001
c

c      input:   text: new line
c               data: data
c               nhead: number of headers
c               nrecord: number of records
c               overwrite: if true, overwrite
c
c      output:  data,nrecord updated

      implicit none
      character*80 data(*),text
      integer nhead,nrecord
      logical overwrite
      integer i
c
c   overwrite
c
      if(overwrite) then
         do i=nhead+1,nrecord
             if(text(2:18).eq.data(i)(2:18)) then
                data(i)=text
                goto 999
             endif
         enddo
      endif
c
c  add at end since no overwrite or overwrite flag not set
c
      if(data(nrecord).eq.' ') then   ! last line blank as it should be
         data(nrecord)=text
         data(nrecord+1)=' '
         nrecord=nrecord+1
      else
         data(nrecord+1)=text
         data(nrecord+2)=' '          ! last lin enot blank, add one extra line
         nrecord=nrecord+2
      endif
c
 999  continue
      return
      end

      subroutine add_spec_to_sfile
     *(text1,text2,data,nhead,nrecord,overwrite)
c
c  add 2 new lines to spec list in s-file. If the same
c  component and phase exists and spectrum is the same type (P or S)
c  overwrite if flag owerwrite set
c
c  jh march 2001
c

c      input:   text1,tet2: new 2 lines
c               data: data
c               nhead: number of headers
c               nrecord: number of records
c               overwrite: if true, overwrite
c
c      output:  data,nrecord,nhead updated

      implicit none
      character*80 data(*),text1,text2
      integer nhead,nrecord
      logical overwrite
      integer i,n,k
c
c   overwrite
c
      if(overwrite) then
         n=0             ! count number of spec lines replaced
         do i=2,nhead
             if(data(i)(2:5).eq.'SPEC'.and.data(i)(80:80).eq.'3'.and.
     *          text1(2:17).eq.data(i)(2:17)) then  ! check if first type
                n=n+1
                data(i)=text1
             endif
             if(data(i)(2:5).eq.'SPEC'.and.data(i)(80:80).eq.'3'.and.
     *          text2(2:16).eq.data(i)(2:16).and.text2(41:41).eq.   ! S or P
     *          data(i)(41:41)) then
                data(i)=text2
                n=n+1
             endif
         enddo
c
c   check for a missing line
c
         if(n.eq.1) then
            write(6,*)' One spectral line missing in input file'
            write(6,'(a)') text1(1:79)
            stop
         endif
c
c   check for too many lines
c
          if(n.gt.2) then
             write(6,*)' Too many spectral line in input file',
     *       ' for same channel'
             write(6,'(a)') text1(1:79)
             stop
          endif
c
c   if both replaced, return
c   
          if(n.eq.2) goto 999
      endif
c
c  add since no overwrite or overwrite flag not set
c
c
c   find where to add
c
      n=0
      k=0
      do i=2,nhead
         if(data(i)(2:5).eq.'SPEC') n=i   ! find last previous spectral line
         if(data(i)(80:80).eq.'E') k=i    ! find error line
      enddo
      n=n+1
      k=k+1
c
c   if no spectal lines, add after error line if there, if no error line
c   start in number 2
c
      if(n.eq.1) n=k
      if(k.eq.1) n=2
c
c    shift down data to make room for spectral parameters
c
      do i=nrecord,n,-1
         data(i+2)=data(i)
      enddo
c
c   put in new spectral data
c
      data(n)=text1
      data(n+1)=text2
      nhead=nhead+2
      nrecord=nrecord+2
c
 999  continue
      return
      end







      subroutine moment_f0(nfreq,amp,freq,level,f0,rms)
c
c  fit the brune model to an observed spectrum by grid search
c
c  jh feb 2000
c
c      input:  nfreq:          number of spectral values
c              amp             amplitudes (linear)
c              freq:           corresponding frequencies, start with
c                              lowest frequencies
c              f0:             starting corner frequency
c
c      output: level           omega zero level or flat level
c              f0:             corner frequency
c              rms:            rms error
c

      
      implicit none
      integer nfreq
      real amp(*),freq(*),level,f0,rms
      real ftest(54)         ! test f0
      integer ntest          ! number of test frequencies
      integer fmin           ! frequecy number for best fit
      real rmsmin            ! minimum rms
      real x,y               ! help variable
      real brune             ! brune function
      integer i,j,k,l        ! counters

      data  ftest/0.01, 0.02, 0.03, 0.04, 0.05, 0.06, 0.07, 0.08, 0.09,
     *             0.1,  0.2,  0.3,  0.4,  0.5,  0.6,  0.7,  0.8,  0.9,
     *        1.0, 1.1,  1.2,  1.3,  1.4,  1.5,  1.6,  1.7,  1.8,  1.9,
     *                   2.0,  3.0,  4.0,  5.0,  6.0,  7.0,  8.0,  9.0,
     *        10.0,     12.0,       14.0,       16.0,      18.0,
     *        20.0,     22.0,       24.0,       26.0,      28.0,
     *        30.0,                       35.0,
     *        40.0,                       45.0,
     *        50.0,                             60.0, 70.0, 80.0/ 


      ntest=54
c
c-------------------------------------------------------------------
c   run routine a few times in a loop to improve esitimate
c
       do l=1,3
c
c
c   first get a first estimate of level using data up to f0/2
c
       i=1
       level=0.0
       do while(freq(i).lt.f0/2.0.and.i.lt.nfreq-1)
          level=level+amp(i)
          i=i+1
       enddo
       i=i-1
       if(i.gt.0) then
          level=level/i
       else
           level=1.0                                  
       endif
       level=level/0.92       ! correct for level going down  a bit , fix !!

c
c  enter loop of trials
c
       rmsmin=10.0e30
       do k=1,100
       y=level*(50.0+k)/100.0
       do i=1,ntest      ! loop over trial f0
          rms=0.0
          do j=1,nfreq   ! loop over observations
c             x=alog10(amp(j))-alog10(y*brune(freq(j),ftest(i)))
             x=(amp(j))-y*brune(freq(j),ftest(i))
             rms=rms+x*x
          enddo
          if(rms.lt.rmsmin) then
             rmsmin=rms
             fmin=i
          endif
c          write(1,*) ftest(i),rms
       enddo
       enddo
       rms=rmsmin/nfreq
       f0=ftest(fmin)
c
c  end of iterative loop
c
       enddo         ! enddo of l

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c
c  recalculate level using all frequencies
c
       x=0.0
       do i=1,nfreq
           x=x+amp(i)/brune(freq(i),f0)
       enddo
       x=x/nfreq
       level=x

       return
       end

      real function brune(f,f0)
c
c   calculates the level of the Brune displacement spectrum at 
c   at frequency f . The spectrum has corner frequency f0. Spectral
c   level is 1.0

      implicit none
      real f,f0

      brune=1.0/(1.0+(f/f0)**2)
      return
      end

c
c program to convert waveform data to time trace input for GMT4.x
c one file is written out per channel
c
c Lars Ottemoller, April 2006
c
      implicit none
      include 'seidim.inc'                    ! for giving dimensions
      include 'libsei.inc'                    ! for all seisan subroutines
      include 'waveform.inc'                  ! waveform data
      include 'seisan.inc'                    ! seisan general parameters
      integer nstat,nphase,nhead,nrecord,id   ! for reading s-file
      character*1 type,exp                    ! -----------------
      character*80 sfilname                   ! s-file name
      character*80 data(max_data)             ! one s-file
      integer npresent                        ! number of wav files present
      character*80 text                       ! general text string
      integer k,i,nz,j,seiclen
      character*5 station
      character*4 component
      real x
      logical gap_flag,b_flag
      integer read01,in,code,number,nerr,last_gap
      character*80 question
      character*80 filein,fileout
      character*24 time
      double precision msec
      integer year,doy,month,day,hour,min
      real sec
      integer narg                            ! number of arguments
      character*80 arg(40)                    ! arguments

c
c print version
c
      include 'version.inc'
      out_version_date='May 02, 2006'
      if (version_new) out_version_date=version_date
      call print_ver
      call get_arguments(narg,arg)
      fileout=' '
      if (narg.eq.4) then
        do i=1,4
          if (arg(i).eq.'-infile') filein=arg(i+1)
          if (arg(i).eq.'-outfile') fileout=arg(i+1)
        enddo
        in=0
        goto 11
      endif

 10   continue
      question=' Filename or number, filenr.lis for all'
      call filename(question,filein)
      if(filein(1:3).eq.'EOF') goto 99
c
c   check for one or many files
c
      in=0
      if(filein(1:10).eq.'filenr.lis') then
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'filenr.lis',     ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
         in=1
      endif

c
c  back here if many files to convert using filenr.lis
c
 11   continue
      if(in.eq.1) then
         read(read01,'(2x,i3,2x,a)') number,filein
         write(6,*)
         if(filein(1:4).eq.'    ') goto 99
      endif
      if(in.eq.0) write(6,'(1x,a)') filein

      wav_nfiles=1                   ! there is only one file in this case
      call get_full_wav_name(filein,wav_filename(1))

      wav_nchan=0
c
c   loop to read all headers of all files
c
         write(6,'(1x,a)') wav_filename(1)
c
c   read header
c
         wav_error_message=' '
         call read_wav_header(1)
c
c   output possible errors
c
         if(wav_error_message.ne.' ') write(6,'(1x,a)') 
     *   wav_error_message

      write(6,*)' channels:',wav_nchan
      if(wav_nchan.eq.0) then
        write(*,*) ' no channels '
        stop
      endif

      do k=1,wav_nchan
c
c   read whole channel
c
        call wav_read_channel(k)
        call timsec(wav_year(k),wav_month(k),wav_day(k),
     &      wav_hour(k),wav_min(k),wav_sec(k),msec)
 
c
c write out data
c
        if (fileout.eq.' '.or.wav_nchan.ne.1) 
     &  fileout=filein(1:seiclen(filein))//'_'//wav_stat(k)//'_'//
     &      wav_comp(k)
        do i=1,seiclen(fileout)
          if (fileout(i:i).eq.' ') fileout(i:i)='_'
        enddo
        open(1,file=fileout,status='unknown')
c
c output sample time code 2004/07/12T18:08:44.00
c
        do i=1,wav_nsamp(k)
          time=' '
          call sectim(msec,year,doy,month,day,
     &      hour,min,sec)
          write(time(1:22),'(i4.4,"/",i2.2,"/",i2.2,"T",
     &   i2.2,":",i2.2,":",f5.2)')
     &      year,month,day,hour,min,sec
          do j=1,22
            if (time(j:j).eq.' ') time(j:j)='0'
          enddo
          write(1,*) time,signal1(i)
          msec=msec+1/wav_rate(k)
        enddo
        close(1)
      enddo
 
      if (in.eq.1) goto 11

99    continue

      stop
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c write_mseed_internal.for
c Internal variables for writing Mini-SEED.
c
c DO NOT INCLUDE THIS FILE IN YOUR MAIN PROGRAM!!!
c
c Author: Rodrigo Canabrava
c Email:  rlpcfr@yahoo.com.br
c Universitetet i Bergen - Department of Earth Sciences
c
c  changes
c
c  dec 21 2005 jh    add seed_pc
c  mar 22 2006 jh    add force_len
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc 

c MAX_BLK_SIZE must be at most the size of the variable seed_record

      INTEGER*4 BLK_SIZE        ! block size
      INTEGER*4 MAX_BLK_SIZE    ! maximum block size
      PARAMETER (MAX_BLK_SIZE = 4096)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Data Record
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      character*4096 seed_record

      common / miniseed_data_record / seed_record, BLK_SIZE, length_

      character*6    seq_number ! block sequence number
      character      header_type ! header type
      character      continuation ! continuation code
      character*5    station_   ! station name
      character*2    location_  ! location id
      character*3    channel_   ! channel name
      character*2    network_   ! network id
      integer*2      year_      ! year
      integer*2      day_of_year_ ! day of year
      character*1    hour_      ! hour
      character*1    minute_    ! minute
      character*1    second_    ! second
      integer*2      fracsec_   ! fraction of seconds
      integer*2      n_samples  ! number of samples
      integer*2      sample_rate_factor ! sample rate factor
      integer*2      sample_rate_multiplier ! sample rate multiplier
      character*1    activity_flags ! activity flags
      character*1    io_flags   ! io flags
      character*1    quality_flags ! quality flags
      character*1    n_blockettes ! number of blockettes
      integer*4      time_correction ! time correction
      integer*2      data_p     ! pointer to data
      integer*2      first_blk  ! pointer to first blockette
      integer*2      blk_type_1000 ! field of blockette type
      integer*2      next_1000  ! pointer to next blockette
      character*1    encoding_  ! encoding format
      character*1    rec_length ! record length
      character*1    byte_order ! byte order
      logical        seed_pc    ! true if on pc platform
      logical        force_len  ! true if write litte endian

      integer*2 length_          ! block length as power of 2

      equivalence(seed_record(1:6), seq_number)
      equivalence(seed_record(7:7), header_type)
      equivalence(seed_record(8:8), continuation)
      equivalence(seed_record(9:13), station_)
      equivalence(seed_record(14:15), location_)
      equivalence(seed_record(16:18), channel_)
      equivalence(seed_record(19:20), network_)
      equivalence(seed_record(21:22), year_)
      equivalence(seed_record(23:24), day_of_year_)
      equivalence(seed_record(25:25), hour_)
      equivalence(seed_record(26:26), minute_)
      equivalence(seed_record(27:27), second_)
c     reserved byte skipped: seed_record(28)
      equivalence(seed_record(29:30), fracsec_)
      equivalence(seed_record(31:32), n_samples)
      equivalence(seed_record(33:34), sample_rate_factor)
      equivalence(seed_record(35:36), sample_rate_multiplier)
      equivalence(seed_record(37:37), activity_flags)
      equivalence(seed_record(38:38), io_flags)
      equivalence(seed_record(39:39), quality_flags)
      equivalence(seed_record(40:40), n_blockettes)
      equivalence(seed_record(41:44), time_correction)
      equivalence(seed_record(45:46), data_p)
      equivalence(seed_record(47:48), first_blk)
      equivalence(seed_record(49:50), blk_type_1000)
      equivalence(seed_record(51:52), next_1000)
      equivalence(seed_record(53:53), encoding_)
      equivalence(seed_record(54:54), byte_order)
      equivalence(seed_record(55:55), rec_length)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Control variables of DFA
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*4 FRAMESIZE       ! number of words in frame
      PARAMETER (FRAMESIZE = 16)

      integer*4 w0              ! encoding info of frame
      integer*4 f_count         ! number of current frame
      integer*4 f_pos           ! position of word in frame
      integer*4 n               ! number of compressed samples
      integer*4 diff(4)         ! buffer with differences on the limbo
      integer*2 state           ! current state of DFA

      common / DFA / diff, w0, f_count, f_pos, n, state, seed_pc,
     *               force_len

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Time variables really used inside the writing routines.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*2      year ! year
      integer*2      doy ! day of year
      integer*2      hour ! hour
      integer*2      minute ! minute
      integer*2      second ! second
      integer*2      fracsec ! fraction of second

      integer*2 encoding ! encoding format

      COMMON / mseed_param_intern / year, doy, hour, minute, second, 
     &     fracsec, encoding

      program gseresp2seed
c
c program to convert gse response files to dataless seed volumes using
c program gse2seed (written by Reinoud Sleeman)
c
c Lars Ottemoller, 24/01/2008
c
      implicit none
      include 'libsei.inc'
      character*80 infile,outfile,seedfile
      character*80 question
      character*120 gseline,line(1000)
      integer read01,read02,code,in,seiclen,ind,write01,i,max
      logical b_flag
      character*5 stat
      character*4 comp
      character*10 start_date,stop_date
      character*240 system_call
      real srate
      real lat,lon,elev,hang,vang
      character*80 sitename
      
 10   continue
      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)
      if(infile(1:3).eq.'EOF') goto 99
c
c   check for one or many files
c
      in=0
      if(infile(1:10).eq.'filenr.lis') then
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'filenr.lis',     ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
         in=1
      endif

 20   continue
      if(in.eq.1) then
         read(read01,'(7x,a)') infile
         write(6,*)
         if(seiclen(infile).le.0) goto 90
      endif
c
c set outfile
c
      ind=seiclen(infile)
      if (infile(ind-3:ind).eq.'_GSE') then
        outfile=infile(1:ind-3)//'tmp'
        seedfile=infile(1:ind-3)//'SEED'
      else
        outfile=infile(1:ind)//'tmp'
        seedfile=infile(1:ind)//'SEED'
      endif
 
c
c read file to get station and component code, and start and end time
c
      call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   infile,           ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      max=0
      start_date='          '
      stop_date='          '
      stat='     '
      comp='    '
      sitename = ' '
 30   continue
      read(read02,'(a)',end=40) gseline
      max=max+1
      line(max)=gseline

      if (gseline(1:4).eq.'CAL2') then
        write(*,*) gseline(1:seiclen(gseline))
        read(gseline(6:10),'(a5)') stat
        read(gseline(12:14),'(a3)') comp
        read(gseline(47:56),*) srate
        read(gseline(58:67),'(a10)') start_date
        read(gseline(75:84),'(a10)') stop_date
        call stat_loc(stat,' ',lat,lon,elev)

        if (comp(3:3).eq.'Z'.or.comp(3:3).eq.'z') then
          hang=-1.
          vang=0.
        elseif (comp(3:3).eq.'N'.or.comp(3:3).eq.'n') then
          hang=0.
          vang=90.
        elseif (comp(3:3).eq.'E'.or.comp(3:3).eq.'e') then
          hang=90.
          vang=90.
        endif
      endif
c
c check for sitename
c(GSE2SEED_SITENAME Lerwick, Shetland, UK)
c     
      if (gseline(3:19).eq.'GSE2SEED_SITENAME') then
        sitename = gseline(21:seiclen(gseline)-1)
      endif

      goto 30
 40   continue
      call sei close( close$, read02, code )
c
c write out gse2seed input file
c
      call sei open( unknown$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
 
      write(write01,'(a)') 'DATA_TYPE STATION GSE2.0'
      write(write01,'(a)')
     &'Sta   Type  Latitude  Longitude    Elev   On Date   Off Date'
      write(write01,'(a5,6x,f9.5,1x,f10.5,1x,f7.3,1x,a10,1x,a10,1x,a)')
     &     stat,lat,lon,elev/1000.,start_date,stop_date,
     &     sitename(1:seiclen(sitename))
      write(write01,*) 

      write(write01,'(a)') 'DATA_TYPE CHANNEL GSE2.0'
      write(write01,'(a)') 'Sta  Chan Aux   Latitude  Longitude'//
     &'    Elev  Depth   Hang  Vang Sample_Rate Inst     '//
     &'On Date   Off Date'
      write(write01,'(a5,1x,a3,6x,f9.5,1x,
     &     f10.5,1x,f7.3,9x,f5.1,1x,f5.1,1x,f11.6,9x,a10,1x,a10)')
     &     stat,comp,lat,lon,elev/1000.,
     &     hang,vang,srate,start_date,stop_date
      write(write01,*)

      write(write01,'(a)') 'DATA_TYPE RESPONSE GSE2.0'
      do i=1,max
        write(write01,'(a)') line(i)(1:seiclen(line(i)))
      enddo
      write(write01,*)
      write(write01,'(a)') 'DATA_TYPE WAVEFORM GSE2.0'
      call sei close( close$, write01, code )
      system_call = 'gse2seed -i '//outfile(1:seiclen(outfile))
     &    //' -o '//seedfile(1:seiclen(seedfile))
        write(*,*) system_call(1:seiclen(system_call))
        call systemc(system_call,seiclen(system_call))

      if (in.eq.1) goto 20

 90   continue
      if (in.eq.1) call sei close( close$, read01, code )
      goto 10

 99   continue

      stop
      end

c$NOFLOATCALLS
C--HYP IS THE VAX & DEC PC VERSION OF THE LOCATION PROGRAM HYPOINVERSE.
C--THE PROGRAM IS DESIGNED TO BE COMPACT, FAST, FILE ORIENTED AND
C--COMMAND DRIVEN.

C--WRITTEN BY FRED KLEIN, 1/85 VERSION
c
c   updates
c   nov 93 by jh : chance include file names to .inc, put in lower case
c                  remove refernece to file 20 and 25
c   feb 99       : ---------------    verison 7.0 check ---------------
c                  put hypinv1, hypinv2 and hypinv3 in main program
c                  PROGRAM ONLY USES FIRST 4 CHARS OF 5 CHAR STATION CODES
c    oct 2000    : read station minutes as f5.3 instead of f5.2

C--CHECK IN G COL REQUIRES GENERAL PARAM COMMON /D/ & /C/ (HYPCOM.inc)        *
C--CHECK IN C COL REQUIRES CRUST MODEL COMMON BLOCKS /M/ & /MC/ (HYPCOMC.inc
C--CHECK IN T COL REQUIRES THE TRAVEL TIME TABLE INCLUDE FILE HYPCOMT.INC  *
C--CHECK IN A COL REQUIRES THE INVERSION ARRAY INCLUDE FILE HYPCOMA.INC    *
C--CHECK IN P COL REQUIRES PLOT PARAMETER COMMON BLOCK /P/ (HYPCOMP.INC    *
C--CHECK IN V COL REQUIRES THE STATION NAME INCLUDE FILE HYPCOMV.INC
C--BLOCK /P/ IS FOR PLOT PARAMETERS & IS FUNCTIONAL ON THE PC350 ONLY.
C--COL O SPECIFIES THE OVERLAY BRANCH (R IS THE ROOT) IN THE PC350 ONLY.

C--FILES MARKED WITH * DIFFER SLIGHTLY BETWEEN VAX & PC350 VERSIONS.
C--PLACES WHERE CHANGES OCCUR ARE CLEARLY MARKED WITH "PC350" OR "VAX".

C++++++++++++++++ LIST OF REQUIRED SUBROUTINES +++++++++++++++++
C          G C T A P V O
C  HYP	   X X X X X X R * MAIN PROGRAM.
C  HYBDA   X X     X   R * BLOCK DATA INITIALIZATION OF COMMON.
C  HYBEG               1 * EXECUTABLE CODE TO INITIALIZE HYPOINVERSE.
C  HYCMD   X           1 * GETS AND IDENTIFIES COMMANDS.
C  HYCM1   X X         1 * PROCESSES PARAMETER & FILE COMMANDS.
C  HYSTA   X         X 1 * READS IN STATIONS.
C  HYCRH     X         1   READS IN HOMOGENOUS LAYER CRUSTAL MODELS.
C  HYCRT     X X       1   READS IN TRAVEL-TIME-TABLE CRUSTAL MODELS.
C  HYSTL   X X       X 4 * OUTPUTS STATIONS, CRUST & PARAMETERS TO PRINT FILE.
C			    ALSO OPENS FILES, ETC.
C  HYPHS   X         X 3   READS IN PHASE DATA FOR ONE EVENT.
C  HYPHS2  X         X 3   READS RAW PICKER DATA FROM A FILE.
C  HYTRL   X           3   SETS TRIAL HYPOCENTER.
C  HYLOC   X   X X     2 * LOCATES ONE EVENT.
C  HYSOL   X     X     2   PERFORMS INVERSION FOR ONE ITERATION.
C  HYSVD         X     2 * CANNED SINGLE-VALUE-DECOMPOSITION ROUTINE.
C  HYTRH   X X         2 * CALC TRAVEL TIMES AND DERIVS FOR HOMO LAYER MODEL.
C  HYTRT   X X X       2 * CALC TRAVEL TIMES AND DERIVS FROM TRAV-TIME TABLE.
C  HYMAG   X           3   COMPUTES ALL MAGNITUDES.
C  HYREP   X           3   REPORTS A LOCATION ON THE TERMINAL.
C  HYLST   X     X   X 3   OUTPUTS DATA BY STATION TO PRINT & ARCHIVE FILES.
C  HYSUM   X           3   OUTPUTS SUMMARY RECORD (FINAL LOCATION).
C  HYNEW   X           3   SETS UP NEW OUTPUT FILES FOR EACH DAY.
C  HYINP               4   FOR INTERACTIVE ENTRY OF PHASE DATA.

C  HYCM2           X   1   PROCESSES PLOT PARAMETER COMMANDS.
C  JDAT                R   STORES & RETRIEVES INTEGER STATION DATA.
C  HYPLT   X       X   5   PLOTS EVENTS FROM SUMMARY FILE ON MAP & AS LOCATED.
C  HYFRM           X   5   PLOTS MAP FRAME.
C  HYKEY           X   5   PLOTS SYMBOL KEY.
C  HYSHF           X   5   SHIFTS TIME INTERVALS AND REFRESHES THE SCREEN.
C  HYLIN           X   5   PLOTS LINES & STATIONS.
C  HYSYM           X   5   PLOTS ONE EARTHQUAKE.
C  SYMBOL              5   PLOTS AN EARTHQUAKE SYMBOL.
C  CURSOR              1   DIGITIZES A SCREEN COORDINATE TO RESET MAP CENTER.
C  HYPHS3  X         X 3   READS RAW PICKER DATA FROM THE COMM PORT.
C  NEWCHR              3   BUFFERS CHARACTERS FROM COMM PORT.
C			    (ABOVE 12 ROUTINES FOR PC350 VERSION ONLY)

C  CLASS               3   ASSIGNS A 3-LETTER NAME TO AN EVENT BASED ON LOCATION
C  KLASS               3   ASSIGNS A REGION NUMBER TO AN EVENT.
C  UPSTR               1   CONVERTS A STRING TO UPPER CASE.
C  JASK	             4,1   INTERACTIVE PROMPT & ENTRY OF AN INTEGER.
C  DAYJL             1,5   CALCULATES JULIAN DAY GIVEN DATE.
C  JDATE             1,5   CALCULATES DATE GIVEN JULIAN DAY.
C  ASKC                1   INTERACTIVE PROMPT AND ENTRY OF A STRING.
C  ASKR                1   INTERACTIVE PROMPT AND ENTRY OF A REAL VALUE.
C  LASK                1   INTERACTIVE PROMPT AND ENTRY OF A LOGICAL VALUE.
C  LENG              1,5   DETERMINES THE NON-BLANK LENGTH OF A STRING.

C++++++++++++++++ I/O DEVICE NUMBERS USED ++++++++++++++++++++++
C  3  KEYBOARD SIGNAL TO INTERRUPT REAL-TIME LOCATIONS (PC350 ONLY)
C  5  TERMINAL INPUT & OUTPUT.
C  6  ERROR MESSAGE OUTPUT TO TERMINAL.
C  7  ARCHIVE OUTPUT FILE.
C  8  COMMAND LINE SCRATCH FILE, & LINE PLOTTING INPUT FILE.
C  9  GRAPHICS OUTPUT (PC350 ONLY)
C 10  BINARY (CONTROL SEQUENCE) OUTPUT TO TERMINAL (PC350 ONLY)
C 11  SCRATCH FILES FOR PLOTTING INTERVALS.
C 12  SUMMARY OUTPUT FILE (& INPUT SUMMARY FILE FOR PLOTTING)
C 13  INPUT COMMAND FILE.
C 14  CRUST, STATION & PHASE INPUT FILES.
C 15  PRINT OUTPUT FILE.
C 16  COMMUNICATIONS PORT FOR PICKER INPUT (PC350 ONLY)

C	INCLUDE 'HYPCOM./LIST'
c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'

C	INCLUDE 'HYPCOMC./NOLIST'
c$INCLUDE:'HYPCOMC.'
      include 'hypcomc.inc'

C	INCLUDE 'HYPCOMP./NOLIST'	!PC350 VERSION ONLY
c$INCLUDE:'HYPCOMP.'
      include 'hypcomp.inc'

C	INCLUDE 'HYPCOMT./LIST'
c$INCLUDE:'HYPCOMT.'
       include 'hypcomt.inc'

C	INCLUDE 'HYPCOMV./LIST'
c$INCLUDE:'HYPCOMV.'
      include 'hypcomv.inc'
C	INCLUDE 'HYPCOMA./LIST'
c$INCLUDE:'HYPCOMA.'
      include 'hypcoma.inc'
C--THESE ARE FOR THE KEYPRESS BUFFER FOR INTERRUPTING LOCATIONS (PC350 ONLY)
	INTEGER STATQ(2),PRL(6)

	LOGICAL LPLT
	DATA LASDAY /0/

	DATA KEYBUF,PRL /0,0,1,4*0/
C  PRL(1) WILL HAVE THE ADDRESS OF KEYBUF (NEEDED BY QIO) ASSIGNED BY GETADR
C  PRL(2) TELLS QIO HOW MANY BYTES TO GET
C  KEYBUF WILL CONTAIN THE ASCII CODE OF THE KEY PRESSED

C--GO DO SOME EXECUTABLE INITIALIZATION
c	OPEN(25,FILE='OVSI.MEC',STATUS='unknown')
c	OPEN(20,FILE='OVSI.BOL',STATUS='unknown')
	CALL HYBEG (INP)
C	WRITE(*,767) INP
C767	FORMAT(I3)
C--GO GET A COMMAND AND EXECUTE IT. RETURN HERE IF CALLING A
C--SUBROUTINE WHICH CAN BE OVERLAYED WITH HYCMD.
5	CALL HYCMD (MOD)
	LPLT=.TRUE.
	LDRW=.FALSE.	
C!PC350 VERSION ONLY

C--ISTAT DIRECTS WHICH SUBROUTINE OR LOCATION SECTION TO INVOKE.
	GOTO (10,12,14,74,78,80,82,18,22,26), ISTAT
	GOTO 5

C--<CRH> READ A HOMOGENEOUS LAYER CRUSTAL MODEL
10	CALL HYCRH (MOD)
	CLOSE (14)
	GOTO 5

C--<CRT> READ A LINEAR GRADIENT CRUSTAL MODEL
12	CALL HYCRT (MOD,KDHR,KT)
	CLOSE (14)
	GOTO 5

C--<STA> READ STATION FILE
14	CALL HYSTA (STANAM)
	CLOSE (14)
	GOTO 5

C--<PLR> PLOT EVENTS FROM A SUMMARY FILE WITHOUT ERASING SCREEN (PC350 ONLY)
18	KODE=3
	GOTO 79

C--<LOR> CONTINUE LOCATING & PLOTTING EVENTS WITHOUT PLOTTING FROM A
C        SUMMARY FILE OR REDRAWING SCREEN. (PC350 ONLY)
22	KODE=6
	GOTO 81

C--<LOX> RESUME EQ. LOCATIONS AFTER REPLOTTING SCREEN FROM YMD.SUM FILES
C	(PC350 ONLY)
26	KODE=4
	GOTO 81

C--<INP> ENTER PHASE DATA MANUALLY INTO A CONDENSED FORMAT FILE
C	ALSO SET THE CONDENSED PHASE FORMAT FLAG TO TRUE
74	CALL HYINP
	GOTO 5

C--<PLT> PLOT EVENTS FROM SUMMARY FILE - PC350 VERSION ONLY
78	KODE=1

79	CONTINUE
C	CALL HYPLT
	GOTO 5

C--<LOP> PLOT EARTHQUAKES FROM SUMMARY FILE, THEN LOCATE A PHASE FILE,
C	PLOTTING EVENTS ALONG THE WAY. 
C	EVENT PLOTTING IS FUNCTIONAL IN PC350 VERSION ONLY.
80	KODE=2

81	CONTINUE
C	CALL HYPLT
	GOTO 84

C++++++++++++++++++++ EARTHQUAKE LOCATION SECTION ++++++++++++++++++

C--LOCATE ALL EARTHQUAKES IN THE SPECIFIED FILE, USING PRESENT PARAMETERS
C--<LOC>

82	LPLT=.FALSE.

C--GO OPEN FILES AND INITIALIZE SOME VALUES, ALSO
C--OPTIONALLY LIST AVAILABLE STATIONS & MODELS IN PRINT FILE
84	CALL HYSTL (STANAM)
	DO 85 I=1,MMAX
85	IMPORT(I)=0

C--STOP NOW IF THERE IS NO PHASE FILE
	IF (ISTAT.EQ.0) GOTO 5

C--SET PLOT CODE FOR LOCATE & PLOT MODE
	KODE=5

C--IF WE ARE LOCATING EQS IN REAL-TIME, QUEUE UP AN INTERRUPTING KEYPRESS
C  TO GO INTO KEYBUF. CALL QIO ONCE, THEN TEST TO SEE IF KEYBUF IS NON ZERO
C  WHENEVER IT IS CONVENIENT TO STOP THE LOCATIONS. THE 528 MEANS "READ
C  WITH NO ECHO".
	IF (JCP.EQ.5) THEN
C	  CALL GETADR (PRL(1),KEYBUF)
C	  CALL QIO (528,3,1,,STATQ,PRL)
	END IF

C--LOCATE ONE EARTHQUAKE FOR EACH PASS THRU THE FOLLOWING LOOP.
C--READ IN PHASE DATA FOR ONE EVENT
50	IF (JCP.LT.4) THEN

C--READ PHASE DATA IN 3 STANDARD FORMATS
	  CALL HYPHS (STANAM)
	ELSE
	  IF (JCP.EQ.4) THEN

C--READ RAW PICKER DATA FROM A FILE
C	    CALL HYPHS2 (STANAM)
	  ELSE

C--READ RAW PICKER DATA FROM THE COMM PORT
C	    CALL HYPHS3 (STANAM,LPLT,KEYBUF,PRL)
	  END IF
	END IF

C--KEND IS SET BY HYPHS DEPENDING ON END-OF-FILE STATUS
C  =-1  END OF FILE, STOP RIGHT AWAY
C  = 0  LOCATE THIS EVENT, THEN READ ANOTHER
C  = 1  END OF FILE, LOCATE THIS EVENT THEN STOP
C--CLOSE FILES & QUIT IF END OF FILE OCCURRED IN PHASE FILE
	IF (KEND.LT.0) GOTO 70

C--OPTIONALLY CLOSE & REOPEN SUMMARY & ARCHIVE FILES AT END OF A DAY
C  (PC350 VERSION ONLY)
C	IF (LRTP .AND. LASDAY.NE.KDAY) CALL HYNEW

C--OPTIONALLY PLACE A PAGE EJECT BETWEEN EVENTS
	IF (LPRT.AND.LEJCT) WRITE (15,1012)
1012	FORMAT ('1')
	IF (LPRT.AND..NOT.LEJCT) WRITE (15,1008)
1008	FORMAT (1X,40('##'))

C--SET THE TRIAL HYPOCENTER
	CALL HYTRL

C--LOCATE THE EVENT
	CALL HYLOC (KDHR,KT,STANAM,A,W,R,IMPORT,MTCAL)

C--ASSIGN A 3-LETTER CODE BASED ON LOCATION
C	IF (NET.GT.0) CALL CLASS (REMK,NET,CLAT,-CLON,Z1)

C--CALCULATE THE EARTHQUAKE'S MAGNITUDE
	CALL HYMAG
C
C	IF(FMAG.EQ.0.) FMAG=XMAG
	IF(FMAG.GE.3.5) THEN
c	WRITE(20,681)
C	WRITE(25,681)
681	FORMAT('     ')
	END IF
C	IF(FMAG.GE.3.0) THEN
C	WRITE(25,681)
C	END IF
C--GENERATE PRINTED AND ARCHIVE OUTPUT
	CALL HYLST (STANAM,A,W,R,IMPORT,MTCAL)
C
C--OUTPUT SUMMARY DATA
	IF (NWR.GT.3) CALL HYSUM
C
C--OPTIONALLY PLOT THE EVENT ON THE SCREEN (PC350 VERSION ONLY)
C	LDRW = LNEWL .AND. LASDAY.NE.0 .AND. LASDAY.NE.KDAY
C	IF (LPLT .AND. NWR.GT.3) CALL HYPLT 

C--OUTPUT A MESSAGE ON THE CONSOLE FOR EACH EVENT
	IF (LREP) CALL HYREP (LPLT)

C--ABORT THE LOOP IF THERE ARE NOT ENOUGH READINGS
	IF (NWR.LT.4) GOTO 50

C--OUTPUT AN EVENT TERMINATOR TO ARCHIVE FILE
	IF (LARC) WRITE (7,1010)
1010	FORMAT (1X)

C--SAVE DAY TO SEE IF IT CHANGES
	LASDAY=KDAY

C--END OF LOCATION LOOP
	IF (KEND.EQ.0) GOTO 50

C--CLOSE FILES THEN GET ANOTHER COMMAND
70	IF (LSUM) CLOSE (12)
	IF (LARC) CLOSE (7)
	IF (LPRT) CLOSE (15)
c	IF (LPRT) CLOSE (20)
	CLOSE (14)
c	CLOSE (25)

C--IN THE PC350 VERSION, CLOSE THE CURRENT PLOT SCRATCH FILE
	IF (LINT.AND.LPLT) CLOSE (11)
 
C--IN THE PC350 VERSION, REASSIGN THE PRINTFILE UNIT # TO THE DISK
C--IN CASE OUTPUT WAS SENT DIRECTLY TO THE PRINTER.
C	CALL ASNLUN (15,'DW',1)
c	GOTO 5
	END
cccccccccccccccccccccccccccccc

c
c   changes
c
c   nov 93 by jh: include files to lower case and extension .inc
c                 hypinst to lower case
c
	SUBROUTINE HYBEG (INP)
C--EXECUTABLE INITIALIZATION OF HYPOINVERSE

C--AVOID PRINTING ERROR MESSAGES FOR THESE FORTRAN ERROR NUMBERS
C--(END OF FILE, NO SUCH FILE, LIST DIRECTED I/O SYNTAX)
C--PC350 VERSION ONLY
C	DIMENSION IERS(4)
C	DATA IERS/24,29,59,64/

C--DONT GIVE ERROR MESSAGES WHEN DATA OVERFLOW OUTPUT FIELDS
C--VAX VERSION ONLY
C	CALL ERRSET (63,.TRUE.,.FALSE.,.FALSE.,.FALSE.)

C--AVOID PRINTING CERTAIN ERROR MESSAGES - PC350 VERSION ONLY
C--DONT REPORT OUTPUT OVERFLOWS
C	CALL ERRSET (63,.TRUE.,.FALSE.,.FALSE.,.FALSE.,.TRUE.,.TRUE.)
C	DO 1 I=1,4
C	CALL ERRSET (IERS(I),.TRUE.,.FALSE.,.TRUE.,.FALSE.)
C1	CONTINUE

C--OPEN THE SCRATCH FILE FOR FREE-FORMAT DECODING OF PARAMETERS
	OPEN (8,FILE='HYTEMP.XXX',STATUS='unknown',FORM='FORMATTED')

C--SEND A MESSAGE TO THE TERMINAL. THIS ALSO ASSIGNS UNIT 5 TO THE
C  TERMINAL BEFORE UNIT 3 IS ASSIGNED THERE BY THE QIO CALL
	WRITE (*,1000)
1000	FORMAT (' HYPOINVERSE STARTING')

C--OPEN AND BEGIN READING THE OPTIONAL STARTUP COMMAND FILE HYPINST
 	INP=5
c       INP=0
	OPEN (13,FILE='hypinst',STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF(IOC.GT.0) GO TO 5
	INP=13
5	RETURN
	END
	SUBROUTINE HYCMD (MOD)
C--CALLED BY HYPOINVERSE TO GET A COMMAND, THEN ACT ON IT.
C--SOME SIMPLE COMMANDS, SUCH AS TO PLOT OR LOCATE, ARE INTERPRETED HERE,
C--AND CONTROL IS IMMEDIATELY RETURNED TO HYP TO CALL APPROPRIATE ROUTINES.
C--PLOT COMMANDS ARE HANDLED IN HYCM2.
C--SETTING OF PARAMETERS & READING SOME INPUT FILES ARE HANDLED IN HYCM1.

C	INCLUDE 'HYPCOM./NOLIST'
c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'
	PARAMETER (NCMD=61)
	CHARACTER CMD(NCMD)*3
	LOGICAL LINST

C--CMD HOLDS THE NAMES OF ALL COMMANDS RECOGNIZED BY THIS ROUTINE.
C--THE STRUCTURE OF THIS STATEMENT MATCHES THAT OF THE COMPUTED GOTO
C--STATEMENTS IN THIS & THE HYCM1 & HYCM2 ROUTINES.
	DATA CMD /
     2 'SUM','ARC','PRT','ERF','LST','KPR','TOP','REP',
     3 'COP','DLY','CON','DAM','DUR','DIS','RMS','SWT',
     4 'POS','ZTR','ERR','ERC','NET','SHO','CAR','APP',
     5 'H71','CTR','SCA','SHF','LIN','STP','MAG','INT',
     6 'SYM','CLR','DEP','TIM','RES','SET','CUR','HUE',
     7 'STO','CRH','CRT','STA','INP','PLT','LOP','LOC',
     8 'PHS','RTP','FRM','TIT','DSK','DEV','PLR','LOR',
     9 'LOX','MIN','PIP','BAD','CLK'/

C++++++++++++++++++ COMMAND INTERPRETER ++++++++++++++++++++
C	WRITE(*,888) INP
C888	FORMAT(I3)
C--SUPPLY A PROMPT IF READING FROM THE TERMINAL
5	IF (INP.EQ.0) WRITE (*,1011)
1011    FORMAT (' COMMAND? ',$)

C--READ A COMMAND LINE
	READ (INP,1012,END=9) CM,INST
1012	FORMAT (A3,A80)

C--A STRING PRECEDED BY @ IS INTERPRETED AS A FILENAME TO HOP TO
	IF (CM(1:1).EQ.'@') THEN
	  IF (INP.EQ.13) CLOSE (13)
	  INP=13
	  INFILE(1:2)=CM(2:3)
	  INFILE(3:30)=INST
	  OPEN (13,FILE=INFILE,STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF(IOC.GT.0) GO TO 32
	  GOTO 5
	END IF

C--IF THE FIRST CHARACTER IS #, EXECUTE THE SYSTEM COMMAND WHICH FOLLOWS
C--VAX VERSION ONLY:
C	IF (CM(1:1).EQ.'#') THEN
C	  INST(3:80)=INST
C	  INST(1:2)=CM(2:3)
C	  CALL LIB$SPAWN (INST)
C	  GOTO 5
C	END IF

C--DETERMINE WHETHER THE PARAMETER FIELD IS BLANK & IF SO SUPPLY PROMPTS
	LINST=INST(1:10).EQ.'          '
	IF (.NOT. LINST) THEN
C--WRITE THE PARAMETER FIELD TO A SCRATCH FILE FOR LATER DECODING
	  REWIND 8
	  WRITE (8,1013) INST
1013	  FORMAT (A80)
	  REWIND 8
	END IF

C--BE SURE THE COMMAND IS UPPERCASE
	CALL UPSTR (CM,3)

C--SEARCH THE COMMAND LIST
C--COMMANDS REFERENCING 500 ARE PROCESSED IN HYCM1,
C--COMMANDS REFERENCING 600 ARE PROCESSED IN HYCM2, THE REST ARE HANDLED HERE
	DO 8 I=1,NCMD
	ICMDX=I
	IF (CM.EQ.CMD(ICMDX)) GOTO (
     2 500,500,500,500,500,500,500,500,
     3 500,500,500,500,500,500,500,500,
     4 500,500,500,500,500,500,500,500,
     5 500,600,600,600,600,600,600,600,
     6 600,600,600,600,600,600,600,600,
     7 140,500,500,500,156,160,164,166,
     8 500,600,600,600,600,500,168,170,
     9 172,500,600,600,600), ICMDX
8	CONTINUE

C--OUTPUT AN ERROR MESSAGE
	WRITE (*,1001) CM
1001	FORMAT (' *** COMMAND NOT FOUND: 'A3'  ***')
	GOTO 5

C--RETURN TO INTERACTIVE MODE AT END OF COMMAND FILE
9	IF (INP.EQ.0) RETURN
	CLOSE (13)
C	INP=5
	INP=0
	GOTO 5

C******************** COMMAND PROCESSORS *************************

C--<STO> STOP THE PROGRAM
140	CLOSE (8,STATUS='DELETE')
	STOP

C--HERE IS THE ERROR MESSAGE FOR NON-EXISTENT FILES
C32	INP=5
32	INP=0
	WRITE (*,1015)
1015	FORMAT (' *** ERROR - INPUT FILE DOES NOT EXIST ***')
	GOTO 5

C--<INP> ENTER PHASE DATA MANUALLY
156	ISTAT=4
	RETURN

C--<PLT> PLOT EVENTS FROM SUMMARY FILE
160	ISTAT=5
	RETURN		
C !PC350 VERSION
C	GOTO 600	!VAX VERSION

C--<LOP> LOCATE & PLOT EVENTS
164	ISTAT=6
	RETURN		
C !PC350 VERSION
C	GOTO 600	!VAX VERSION

C--<LOC> LOCATE EVENTS
166	ISTAT=7
	RETURN

C--<PLR> RESUME PLOTTING SUMMARY EVENTS - DO NOT ERASE SCREEN
168	ISTAT=8
	RETURN		
C !PC350 VERSION
C	GOTO 600	!VAX VERSION

C--<LOR> RESUME LOCATING & PLOTTING - DO NOT ERASE SCREEN
170	ISTAT=9
	RETURN		
C !PC350 VERSION
C	GOTO 600	!VAX VERSION

C--<LOX> RESUME LOCATING & PLOTTING EVENTS AFTER REPLOTTING SCREEN
C        FROM YMD.SUM FILES
172	ISTAT=10
	RETURN		
C !PC350 VERSION
C	GOTO 600	!VAX VERSION

C--GO PROCESS THE PARAMETER & FILENAME COMMANDS IN HYCM1
500	CALL HYCM1 (ICMDX,LINST,MOD)

C--IF THE COMMAND REQUESTED READING A CRUST OR STATION FILE, DO IT IN
C--THE MAIN PROGRAM.
	IF (ISTAT.GT.0) RETURN
	GOTO 5

C--GO PROCESS A PLOT PARAMETER COMMAND IN HYCM2 (PC350 VERSION ONLY).
600	CONTINUE
C	CALL HYCM2 (ICMDX,LINST,CM,INST)

C--PRINT AN ERROR MESSAGE IN THE VAX VERSION
C	TYPE *,' COMMAND NOT AVAILABLE IN VAX VERSION'
	GOTO 5
	END
	SUBROUTINE UPSTR (STR,LEN)
C--UPSTR CONVERTS THE CHARACTER STRING STR TO UPPER CASE.
C--LEN IS THE NUMBER OF CHARACTERS TO CONVERT, NOT TO EXCEED THE
C--ACTUAL LENGTH OF STR.
	CHARACTER STR,CHAR*26
	DATA CHAR/'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
	DO 2 I=1,LEN
	J=ICHAR(STR(I:I))-96
	IF (J.GT.0 .AND. J.LT.27) STR(I:I)= CHAR(J:J)
2	CONTINUE
	RETURN
	END
	SUBROUTINE HYCM1 (ICMDX,LINST,MOD)
C--CALLED BY HYCMD TO DECODE & STORE TEST PARAMETERS FROM COMMANDS

c$INCLUDE:'HYPCOMC.'
      include 'hypcomc.inc'
c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'
	LOGICAL LINST

C--BRANCH TO THE APPROPRIATE COMMAND PROCESSOR
C--THIS GOTO CORRESPONDS IN STRUCTURE TO THE COMMAND LIST IN HYCMD
C--CERTAIN VALUES OF ICMDX (CORRESPONDING TO GOTO 5) SHOULD NEVER OCCUR
	GOTO (
     2  10, 12, 14, 16, 20, 22, 24, 26,
     3  28, 34, 38, 42, 46, 50, 52, 54,
     4  56, 58, 60, 62, 64, 70, 30, 74,
     5  66,  5,  5,  5,  5,  5,  5,  5,
     6   5,  5,  5,  5,  5,  5,  5,  5,
     7   5,144,148,152,  5,  5,  5,  5,
     8 168,  5,  5,  5,  5,172,  5,  5,
     9   5,176,  5,  5,  5), ICMDX
	GOTO 5

C******************** COMMAND PROCESSORS *************************

C--<SUM> SET SUMMARY OUTPUT FILENAME
10	IF (LINST) THEN
	  CALL ASKC('EARTHQUAKE SUMMARY FILE (NONE FOR NONE)',SUMFIL,
     2 30,39)
	ELSE
	  READ (8,*,ERR=3) SUMFIL
	END IF
	LSUM=.NOT. (SUMFIL(1:4).EQ.'NONE')
	GOTO 5

C--<ARC> SET ARCHIVE OUTPUT FILENAME
12	IF (LINST) THEN
	  CALL ASKC('ARCHIVE FILE (NONE FOR NONE)',ARCFIL,30,28)
	ELSE
	  READ (8,*,ERR=3) ARCFIL
	END IF
	LARC=.NOT. (ARCFIL(1:4).EQ.'NONE')
	GOTO 5

C--<PRT> SET PRINTER OUTPUT FILENAME
14	IF (LINST) THEN
	  CALL ASKC('PRINTOUT FILE (NONE FOR NONE)',PRTFIL,30,29)
	ELSE
	  READ (8,*,ERR=3) PRTFIL
	END IF
	LPRT=.NOT. (PRTFIL(1:4).EQ.'NONE')
	GOTO 5

C--<ERF> SEND ERROR MESSAGES TO TERMINAL AS WELL AS PRINT FILE
16	IF (LINST) THEN
C	  LERR=LASK('SEND ERROR MESSAGES TO TERMINAL',LERR,31)
	ELSE
	  READ (8,*,ERR=3) LERR
	END IF
	GOTO 5

C--<LST> FLAG TO LIST AVAILABLE STATIONS & CRUST ON THE PRINTER
20	IF (LINST) THEN
	  WRITE (*,1001)
1001	  FORMAT (' PRINT CODE: 0=EQS ONLY, 1=ADD PARAMS & FILES,')
	  JST=JASK('2=ADD STATIONS & CRUST',JST,22)
	ELSE
	  READ (8,*,ERR=3) JST
	END IF
	GOTO 5

C--<KPR> PARAMETER TO CONTROL AMOUNT OF PRINTOUT
22	IF (LINST) THEN
	  KPRINT=JASK('PRINT QUANTITY CONTROL (0-6)',KPRINT,28)
	ELSE
	  READ (8,*,ERR=3) KPRINT
	END IF
	GOTO 5

C--<TOP> FLAG TO PAGE EJECT BEFORE EACH EVENT
24	IF (LINST) THEN
C	  LEJCT=LASK('PRINT PAGE EJECT FOR EACH EVENT',LEJCT,31)
	ELSE
	  READ (8,*,ERR=3) LEJCT
	END IF
	GOTO 5

C--<REP> FLAG TO REPORT EACH EVENT ON TERMINAL AS LOCATED
26	IF (LINST) THEN
C	  LREP=LASK('REPORT EACH EVENT AS LOCATED',LREP,28)
	ELSE
	  READ (8,*,ERR=3) LREP
	END IF
	GOTO 5

C--<COP> READ PHASE DATA IN CONDENSED FORMAT
28	IF (LINST) THEN
	  JCP=JASK('PHASE FORMAT (1=FULL 2=CONDENSED 4=PIKR',JCP,39)
	ELSE
	  READ (8,*,ERR=3) JCP
	END IF
	GOTO 5

C--<CAR> WRITE ARCHIVE DATA IN CONDENSED FORMAT
30	IF (LINST) THEN
	  JCA=JASK('ARCHIVE FORMAT (1=FULL 2=CONDENSED',JCA,34)
	ELSE
	  READ (8,*,ERR=3) JCA
	END IF
	GOTO 5

C--<DLY> STATION DELAY PARAMETERS
34	READ (8,*,ERR=3) KDLY
	IF (KDLY.LT.3) GOTO 5
	REWIND 8
	READ (8,*,ERR=3) KDLY,DLYAZ,DLYWD,DLYLON,DLYLAT
	GOTO 5

C--<CON> TERMINATING LOCATION UPON CONVERGENCE
38	IF (LINST) THEN
	  ITRLIM=JASK('MAX ITERATIONS',ITRLIM,14)
	  DQUIT=ASKR('MIN HYPOCENTER ADJUSTMENT',DQUIT,25)
	  DRQT=ASKR('MIN RMS CHANGE',DRQT,14)
	ELSE
	  READ (8,*,ERR=3) ITRLIM,DQUIT,DRQT
	END IF
	GOTO 5

C--<DAM> ITERATION AND DAMPING CONTROLS
42	READ (8,*,ERR=3) DXFIX,DZMAX,DZAIR,DAMP,EIGTOL,RBACK,BACFAC
	GOTO 5

C--<DUR> DURATION MAG CONSTANTS
46	READ (8,*,ERR=3) FMA1,FMB1,FMZ1,FMD1,
     2 FMA2,FMB2,FMZ2,FMD2,FMBRK
	GOTO 5

C--<DIS> DISTANCE WEIGHT PARAMETERS
50	IF (LINST) THEN
	  ITRDIS=JASK('ITERATION TO BEGIN DISTANCE WEIGHTING',IRTDIS,37)
	  DISCUT=ASKR('DISCUT (KM)',DISCUT,11)
	  DISW1=ASKR('DISW1 FACTOR',DISW1,12)
	  DISW2=ASKR('DISW2 FACTOR',DISW2,12)
	ELSE
	  READ (8,*,ERR=3) ITRDIS,DISCUT,DISW1,DISW2
	END IF
	GOTO 5

C--<RMS> RMS WEIGHTING PARAMETERS
52	IF (LINST) THEN
	  ITRRES=JASK('ITERATION TO BEGIN RESIDUAL WEIGHTING',IRTRES,37)
	  RMSCUT=ASKR('RMSCUT (KM)',RMSCUT,11)
	  RMSW1=ASKR('RMSW1 FACTOR',RMSW1,12)
	  RMSW2=ASKR('RMSW2 FACTOR',RMSW2,12)
	ELSE
	  READ (8,*,ERR=3) ITRRES,RMSCUT,RMSW1,RMSW2
	END IF
	GOTO 5

C--<SWT> S ARRIVAL WEIGHTING FACTOR
54	IF (LINST) THEN
	  SWT=ASKR('S WEIGHT FACTOR',SWT,15)
	ELSE
	  READ (8,*,ERR=3) SWT
	END IF
	GOTO 5

C--<POS> VP/VS VELOCITY RATIO
56	IF (LINST) THEN
	  POS=ASKR('P/S VELOCITY RATIO',POS,18)
	ELSE
	  READ (8,*,ERR=3) POS
	END IF
	GOTO 5

C--<ZTR> TRIAL DEPTH
58	IF (LINST) THEN
	  ZTR=ASKR('TRIAL DEPTH, NEG TO FIX DEPTH',ZTR,29)
	ELSE
	  READ (8,*,ERR=3) ZTR
	END IF
	GOTO 5

C--<ERR> ESTIMATED READING & TIMING ERROR
60	READ (8,*,ERR=3) RDERR
	GOTO 5

C--<ERC> WEIGHTING FACTOR OF RMS IN ERROR CALCS
62	READ (8,*,ERR=3) ERCOF
	GOTO 5

C--<NET> NET FOR ASSIGNING 3-LET. NAMES BASED ON LOCATION
64	IF (LINST) THEN
	  NET=JASK('NET: 1=HAWAII 2=LONG-VAL',NET,24)
	ELSE
	  READ (8,*,ERR=3) NET
	END IF
	GOTO 5

C--<H71> SET SUMMARY FORMAT TYPE
66	IF (LINST) THEN
C	  LH71=LASK('SUMMARY FORMAT: F=HYPOINV T=HYPO71',LH71,34)
	ELSE
	  READ (8,*,ERR=3) LH71
	END IF
	GOTO 5

C--<SHO> WRITE INPUT FILENAMES
70	WRITE (*,1020)
1020	FORMAT (/' INPUT FILES:',$)
	WRITE (*,1021) INFILE,STAFIL,PHSFIL
1021	FORMAT (' COMMANDS: 'A/' STATIONS: 'A/' PHASES: 'A)

	DO 25 I=1,3
	IF (MODTYP(I).EQ.0) WRITE (*,1022) I,CRUFIL(I)
1022	FORMAT (' LINEAR  GRADIENT  CRUST'I2':  'A,$)
	IF (MODTYP(I).EQ.1) WRITE (*,1023) I,CRUFIL(I)
1023	FORMAT (' HOMOGENEOUS LAYER CRUST'I2':  'A,$)
25	CONTINUE

C--WRITE OUTPUT FILENAMES
	WRITE (*,1029)
1029	FORMAT (/' OUTPUT FILES:',$)
	IF (LPRT) WRITE (*,1030) PRTFIL
1030	FORMAT (' PRINTOUT: 'A,$)
	IF (LSUM) WRITE (*,1031) SUMFIL
1031	FORMAT (' SUMMARY:  'A,$)
	IF (LARC) WRITE (*,1032) ARCFIL
1032	FORMAT (' ARCHIVE:  'A,$)
	GOTO 5

C--<APP> INDICATE WHETHER OUTPUT FILES SHOULD BE APPENDED TO
C  ORDER IS 1=PRINT 2=SUMMARY 3=ARCHIVE
74	IF (LINST) THEN
C	  LAPP(1)=LASK('APPEND TO PRINT FILE',LAPP(1),20)
C	  LAPP(2)=LASK('APPEND TO SUMMARY FILE',LAPP(2),22)
C	  LAPP(3)=LASK('APPEND TO ARCHIVE FILE',LAPP(3),22)
	ELSE
	  READ (8,*,ERR=3) LAPP
	END IF
	GOTO 5

C--<CRH> READ ONE OF THE 3 HOMO LAYER CRUSTAL MODELS
144	IF (LINST) THEN
	  MOD=JASK('CRUST MODEL NO. (1-3)',1,21)
	  IF (MOD.LT.1 .OR. MOD.GT.3) THEN
	    WRITE (*,1014)
1014	    FORMAT (' INVALID CRUST MODEL NO.')
	    GOTO 5
	  END IF
	  CALL ASKC('CRUST MODEL FILENAME',CRUFIL(MOD),30,20)
	ELSE
	  READ (8,*,ERR=3) MOD,CRUFIL(MOD)
	END IF

C--OPEN FILE & READ MODEL
	OPEN (14,FILE=CRUFIL(MOD),STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF(IOC.GT.0) GO TO 33
	LTRH=.TRUE.
	ISTAT=1
	RETURN

C--<CRT> READ ONE OF THE LINEAR GRADIENT CRUSTAL MODELS
148	IF (LINST) THEN

C--THIS LINE FOR THE VAX VERSION ONLY:
C	  MOD=JASK('CRUST MODEL NO. (1-3)',1,21)
C--THIS LINE FOR THE PC350 VERSION ONLY:
	  MOD=1
  	  CALL ASKC('CRUST MODEL FILENAME',CRUFIL(MOD),30,20)
	ELSE
	  READ (8,*,ERR=3) MOD,CRUFIL(MOD)
	  IF (MOD.LT.1 .OR. MOD.GT.LN) THEN
	    WRITE (*,1014)
	    GOTO 5
	  END IF
	END IF

C--OPEN FILE & READ MODEL
	OPEN (14,FILE=CRUFIL(MOD),STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF (IOC.GT.0) GO TO 33
	LTRT=.TRUE.
	ISTAT=2
	RETURN

C--<STA> READ IN A LIST OF SEISMIC STATIONS
152	IF (LINST) THEN
	  CALL ASKC('STATION FILENAME',STAFIL,30,16)
	ELSE
	  READ (8,*,ERR=3) STAFIL
	END IF
	OPEN (14,FILE=STAFIL,STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF (IOC.GT.0) GO TO 33
	ISTAT=3
	RETURN

C--HERE IS THE ERROR MESSAGE FOR NON-EXISTENT FILES
33	WRITE (*,1015)
1015	FORMAT (' *** ERROR - INPUT FILE DOES NOT EXIST ***')
	GOTO 5

C--<PHS> SPECIFY PHASE INPUT FILE
168	IF (LINST) THEN
	  CALL ASKC('PHASE FILENAME',PHSFIL,30,14)
	ELSE
	  READ (8,*,ERR=3) PHSFIL
	END IF
	GOTO 5

C--<DEV> SET DEV & DIR SPECIFIER FOR YMD.SUM & YMD.ARC FILES
172	IF (LINST) THEN
	  CALL ASKC('DEVICE & DIRECTORY FOR YMD.SUM & YMD.ARC FILES',
     2 DEV,20,46)
	ELSE
	  READ (8,*,ERR=3) DEV
	END IF
	NDEV=LENG(DEV,20)
	GOTO 5

C--<MIN> SET MIN NO. OF PHASE CARDS TO ATTEMPT A LOCATION
176	IF (LINST) THEN
	  MINSTA=JASK('MIN NO. OF PHASES TO ATTEMPT A LOCATION',
     2 MINSTA,39)
	ELSE
	  READ (8,*,ERR=3) MINSTA
	END IF
	GOTO 5

C--OUTPUT A MESSAGE ON A FREE-FORMAT DECODING ERROR
3	WRITE (*,1000) CM
1000	FORMAT (' *** ERROR IN 'A3' PARAMETERS - TRY AGAIN ***')

C--RETURN TO HYCMD
5	ISTAT=0
	RETURN
	END
	SUBROUTINE ASKC (PROMPT,STRING,MAXLEN,LENP)

C--ASKC PROMPTS THEN READS A CHARACTER STRING FROM THE TERMINAL.
C--THE ORIGINAL VALUE IS UNCHANGED BY A CR RESPONSE.
C	PROMPT = PROMPT STRING
C	STRING = CHARACTER RESPONSE, OR ORIGINAL STRING ON CR.
C	MAXLEN = MAX LENGTH OF THE ARGUMENT "STRING"
C	LENP   = BYTE LENGTH OF PROMPT STRING.

	CHARACTER PROMPT, STRING, TEMP*40
	I=LENG(STRING,MAXLEN)
3	WRITE (*,1000) PROMPT(1:LENP),STRING(1:I)
1000	FORMAT (1X,A/' [CR=',A,']?',$)
	READ (*,1001,ERR=3) TEMP
1001	FORMAT (A)
	IF(TEMP(1:2).EQ.'  ') THEN
	NCH=0
	ELSE
	NCH=1
	END IF
	IF (NCH.EQ.0) GOTO 9
	I=40
	IF (MAXLEN.LT.40) I=MAXLEN
	STRING(1:I)=TEMP(1:I)
9	RETURN
	END
	SUBROUTINE HYCRH (MOD)
C--READS A HOMOGENEOUS LAYER CRUSTAL MODEL FOR HYPOINVERSE
C	INCLUDE 'HYPCOMC./LIST'
c$INCLUDE: 'HYPCOMC.'
      include 'hypcomc.inc'
	MODTYP(MOD)=1
	LAY(MOD)=0
	READ (14,1002,END=20,ERR=20) MODNAM(MOD)
1002	FORMAT (A20)
C
C--READ VELOCITY & DEPTH OF EACH LAYER
	DO 10 L=1,NLYR
	READ (14,1000,END=20) VEL(L,MOD),D(L,MOD)
1000	FORMAT (2F5.2)
C--COMPUTE THICKNESS & V**2 FOR LAYER
	LAY(MOD)=L
	IF (L.GT.1) THEN
	  DD=D(L,MOD)-D(L-1,MOD)
	  THK(L-1,MOD)=DD
	  DV=VEL(L,MOD)-VEL(L-1,MOD)
	  IF (DV.LT.0. .OR. DD.LE.0.) GOTO 22
	END IF
10	VSQ(L,MOD)=VEL(L,MOD)**2
C
C--DEFINE THK FOR HALFSPACE
20	THK(LAY(MOD),MOD)=999.
	RETURN
C
C--BAD DATA
22	WRITE (*,1001) MOD
1001	FORMAT (' BAD DATA FOR CRUST MODEL'I2)
	RETURN
	END
	SUBROUTINE HYCRT (MOD,KDHR,KT)
C--READS A TRAVEL TIME TABLE FOR A LINEAR GRADIENT CRUST MODEL
C--CALLED BY HYPOINV
C	INCLUDE 'HYPCOMC./LIST'
C	INCLUDE 'HYPCOMT./LIST'
c$INCLUDE: 'HYPCOMC.'
c$INCLUDE: 'HYPCOMT.'
      include 'hypcomc.inc'
      include 'hypcomt.inc'
C--IDENTIFY THE MODEL MOD AS A LINEAR GRADIENT TABLE
	MODTYP(MOD)=0
C
C--READ HEADER INFO
	READ (14,1000) MODNAM(MOD),LAY(MOD),REDV(MOD)
1000	FORMAT (A20,I2,F8.4)
C
C--READ DEPTHS & VELOCITIES OF MODEL
	READ (14,1001) (D(I,MOD),I=1,LAY(MOD))
	READ (14,1001) (VEL(I,MOD),I=1,LAY(MOD))
1001	FORMAT (15F5.2)
C
C--READ DISTANCE & DEPTH GRID INFO
      READ (14,1003) DD1(MOD),ND1(MOD),DD2(MOD),ND2(MOD),
     2DZ1(MOD),NZ1(MOD),DZ2(MOD),NZ2(MOD)
1003	FORMAT (2(F7.4,I3))
	ND(MOD)=ND1(MOD)+ND2(MOD)+1
	NZ(MOD)=NZ1(MOD)+NZ2(MOD)+1
C
C--READ REDUCED TRAVEL TIMES, GROUPED BY DEPTH
	DO 20 J=1,NZ(MOD)
	READ (14,1004) KDHR(MOD,J)
1004	FORMAT (20X,I10)
20	READ (14,1005) (KT(MOD,J,I),I=1,ND(MOD))
1005	FORMAT (15I6)
	GD1(MOD)=ND1(MOD).NE.0 .AND. DD1(MOD).NE.0
	GD2(MOD)=ND2(MOD).NE.0 .AND. DD2(MOD).NE.0
	GZ1(MOD)=NZ1(MOD).NE.0 .AND. DZ1(MOD).NE.0
	GZ2(MOD)=NZ2(MOD).NE.0 .AND. DZ2(MOD).NE.0
	RETURN
	END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c$DEBUG
	SUBROUTINE HYSTA (STANAM)
C--READ IN STATION LIST & COORDINATES FOR HYPOINV
C	INCLUDE 'HYPCOM./NOLIST'
C	INCLUDE 'HYPCOMV./LIST'
c$INCLUDE: 'HYPCOM.'
c$INCLUDE: 'HYPCOMV.'
      include 'hypcom.inc'
      include 'hypcomv.inc'
C--THE INTEGER STATION DATA IN THE VAX VERSION IS STORED IN COMMON.
C--THE DATA IN THE PC350 VERSION IS STORED IN VIRTUAL MEMORY, WHICH IS
C--WRITTEN BY 1 CALL TO JDAT, AND READ BY FUNCTION ENTRIES TO JDAT.

C--LOOP TO READ STATIONS INTO LOOK-UP TABLE
	DO 20 J=1,MAXSTA
	JSTA=J-1
C--VAX VERSION
	READ (14,1000,END=30,ERR=40) STANAM(J),CTEMP,JLATD(J),ALAT,IS,
     2 JLOND(J),ALON,IE,PER,MODS,MODP,PD1,PD2,XMC,FMC,ITYPE,CAL
C--PC350 VERSION
C      READ (14,1000,END=30,ERR=40) STANAM(J),CTEMP,ILATD,ALAT,IS,
C     2ILOND,ALON,IE,PER,MODS,MODP,PD1,PD2,XMC,FMC,ITYPE,CAL
1000	FORMAT (A4,A1,I2,1X,F5.3,A1,I3,1X,F5.3,A1,4X,F3.1,1X,2I1,
     24(1X,F5.2),1X,I1,F6.2)

C--CORRECT VALUES WHICH ARE OUT OF RANGE
	IF (PER.GT.1.9) PER=1.9
	IF (PER.LT..1) PER=.2
	IF (CAL.LT.0.) CAL=0.
	IF (CAL.GT.49.9) CAL=49.9
	IF (MODP.LT.1 .OR. MODP.GT.3) MODP=1
	IF (MODS.LT.1 .OR. MODS.GT.3) MODS=MODP
	IF (ITYPE.GT.2) ITYPE=1

C--STORED LAT & LON ARE POSITIVE N & W
C--USE NEG LAT FOR SOUTH, NEG LON FOR EAST
	IF (IS.EQ.'S') THEN
	  JLATD(J)=-JLATD(J)	
C!VAX VERSION
C	  ILATD=-ILATD		
C!PC350 VERSION
	  ALAT=-ALAT
	END IF
	IF (IE.EQ.'E') THEN
	  JLOND(J)=-JLOND(J)	
C !VAX VERSION
C	  ILOND=-ILOND		
C!PC350 VERSION
	  ALON=-ALON
	END IF

C--STORE STATION INFO IN CONDENSED INTEGER FORMAT
C--LAT & LON IN .01 MINUTE, KEPT AS NEAREST INTEGER
	JLATM(J)=JNINT(100.*ALAT)
C !VAX VERSION
	JLONM(J)=JNINT(100.*ALON)
C !VAX VERSION
C	ILATM=NINT(100.*ALAT)		
C!PC350 VERSION
C	ILONM=NINT(100.*ALON)		
C!PC350 VERSION

C--STORE STATION WEIGHT IN UNITS OF 0.1 FROM 0.0 TO 1.0
	IF (CTEMP.EQ.'*') THEN
	  JWT=0
	ELSE
	  READ (CTEMP,1001) JWT
1001	  FORMAT (I1)
	  IF (CTEMP.EQ.' ') JWT=10
	END IF

C--STORE MAGNITUDE CORRECTIONS
	KTEMP=JNINT(XMC*10.)
	KTEMP2=JNINT(FMC*10.)
	JMCOR(J)=KTEMP2+KTEMP*100+2525	
C!VAX VERSION
C	IMCOR=KTEMP2+KTEMP*100+2525	
C!PC350 VERSION

C--STORE P DELAYS
	JPD1(J)=JNINT(PD1*100.)
C!VAX VERSION
	JPD2(J)=JNINT(PD2*100.)
C!VAX VERSION
C	IPD1=NINT(PD1*100.)	
C!PC350 VERSION
C	IPD2=NINT(PD2*100.)	
C!PC350 VERSION

C--STORE STATION WEIGHT & CRUST MODELS
	JMOD(J)=100*JWT+10*MODP+MODS	
C !VAX VERSION
C	IMOD=100*JWT+10*MODP+MODS	
C!PC350 VERSION

C--STORE STATION TYPE, CAL FACTOR & PERIOD
	KTEMP=JNINT(CAL*10.)
	KTEMP2=JNINT(PER*10.)
	JCAL(J)=ITYPE*10000+KTEMP2*500+KTEMP	
C !VAX VERSION
C	ICAL=ITYPE*10000+KTEMP2*500+KTEMP	
C!PC350 VERSION

C--NOW STORE DATA FOR ONE STATION IN VIRTUAL MEMORY (PC350 ONLY)
C	I=JDAT(J,ILATD,ILATM,ILOND,ILONM,ICAL,IMCOR,IMOD,IPD1,IPD2)

20	CONTINUE

C--COME HERE IF TOO MANY STATIONS ARE IN FILE
	JSTA=MAXSTA
	WRITE (*,1003) JSTA
1003	FORMAT (' TOO MANY STATIONS. THE FIRST'I4' ARE USED.')
30	RETURN

C--COME HERE FOR READ ERROR
40	WRITE (*,1002)
1002	FORMAT (' ERROR READING STATION FILE')
	STOP
	END
	SUBROUTINE HYINP
C--CALLED BY HYPOINVERSE TO PROMPT FOR PHASE DATA & OUTPUT IT TO A FILE
C--IN CONDENSED FORMAT.
	LOGICAL LALL
	CHARACTER STA*4,STAS(100)*4,IFL*40,CHR*1,PRMK*4,SRMK*4,RMK*4
	CHARACTER SCHR(100)*1,ACHR(100)*1,CCHR(100)*1
C--TELL HYPOINVERSE TO READ THE NEXT PHASE FILE IN CONDENSED FORMAT
C	JCP=2
C--INITIALIZE DATA
	PRMK=' P  '
	SRMK=' S  '
	IY=0
	IM=0
	ID=0
	IH=0
	IN=0

C--PROMPT FOR & OPEN OUTPUT FILE
	WRITE (*,1000)
1000	FORMAT (' CONDENSED PHASE DATA OUTPUT FILENAME?',$)
	READ (*,1001) IFL
1001	FORMAT (A)
	OPEN (14,FILE=IFL,STATUS='unknown',FORM='FORMATTED')
C--LOOK FOR LIST OF STATIONS TO PROMPT FOR ON FILE 'STALIST.'
C--IF STALIST IS NOT THERE, REQUEST ANOTHER FILENAME.
	OPEN (12,FILE='STALIST.',STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF(IOC.GT.0) GO TO 10
	GOTO 15
10	WRITE (*,1002)
1002	FORMAT (' FILE OF STATION NAMES TO PROMPT FOR NOT FOUND.'/
     2 ' (THE DEFAULT FILE IS STALIST.)'/' ENTER FILENAME: ',$)
	READ (*,1001) IFL
	OPEN (12,FILE=IFL,STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF (IOC.GT.0) GO TO 10

C--READ IN LIST OF STATIONS TO PROMPT FOR
15	DO 18 I=1,100
18	READ (12,1003,END=20) STAS(I),SCHR(I),ACHR(I),CCHR(I)
1003	FORMAT (A4,3A1)
20	NSTA=I-1
	CLOSE (12)

C--SET THE FLAG THAT PROMPTS FOR A P REMARK, FIRST MOTION & WEIGHT
	WRITE (*,1007)
1007	FORMAT (' DO YOU WANT TO ENTER REMARKS, FIRST MOTIONS & WEIGHTS'/
     2 ' FOR ALL STATIONS (Y OR N)? ',$)
	READ (*,1008) CHR
1008	FORMAT (A1)
	LALL=CHR.EQ.'Y' .OR. CHR.EQ.'y'
	WRITE (*,1012)
1012	FORMAT (' REMARKS ARE 4 CHARACTERS LONG, AND CONSIST OF'/
     2 ' QUALITY, P OR S, FIRST MOTION, & WEIGHT,'/
     3 ' FOR EXAMPLE "IPU0" OR "ES 2". RETURN USES SIMPLY "P" OR "S".')

C******************* EVENT LOOP ******************************

C--PROMPT FOR DATE & TIME
25	WRITE (*,1004)
1004	FORMAT (' FOR THE NEXT EVENT:')
	IY=JASK(' YEAR',IY,5)
	IM=JASK('MONTH',IM,5)
	ID=JASK('  DAY',ID,5)
	IH=JASK(' HOUR',IH,5)
	IN=JASK('  MIN',IN,5)

C--WRITE EVENT HEADER TO PHASE FILE
	WRITE (14,1009) IY,IM,ID,IH,IN
1009	FORMAT (5I2)
	WRITE (*,1006)
1006	FORMAT (' ENTER P TIMES:',$)

C--LOOP OVER STATIONS IN THE PROMPTING LIST
	DO 50 I=1,NSTA

C--OPTIONALLY INPUT P REMARK, FIRST MOTION & WEIGHT
	IF (LALL) THEN
	  WRITE (*,1005) STAS(I)
1005	  FORMAT (' P REMK, FM & WEIGHT (A4) FOR 'A4': ',$)
	  READ (*,1003) PRMK
	  IF (PRMK.EQ.'    ') PRMK=' P  '
	END IF

C--INPUT P TIME IN FREE FORMAT, CR SKIPS THE STATION
30	WRITE (*,1010) STAS(I)
1010	FORMAT (1X,A4'(0.0 NO P): ',$)
	READ (*,1011,ERR=30) P
1011	FORMAT (F20.0)
	IF(P.EQ.0.0) THEN 
	NCHP=0
	ELSE
	NCHP=1
	END IF
C--OUTPUT TIME IN 1/100 SECONDS AS AN INTEGER
	IP=P*100.+.5
	IF (NCHP.EQ.0) PRMK=' P 4'

C--INPUT A DURATION IF THIS STATION WAS FLAGGED
	IF (CCHR(I).NE.' ') THEN
46	  WRITE (*,1027) STAS(I)
1027	  FORMAT (' CODA DURATION FOR 'A4'(0.0 NO CODA): ',$)
	  C=0.
	  READ (*,1011,ERR=46) C
	IF(C.EQ.0.0) THEN 
	NCHC=0
	ELSE
	NCHC=1
	END IF
	  IC=C+.5

C--OUTPUT P AND/OR CODA TIMES
	  IF (NCHC.NE.0 .OR. NCHP.NE.0)
     2	 WRITE (14,1013) STAS(I),PRMK,IP,IC
	ELSE
	  IF (NCHP.NE.0) WRITE (14,1013) STAS(I),PRMK,IP
	END IF
1013	FORMAT (2A4,I5,I4)

C--NOW INPUT AN S TIME IF THIS STATION WAS FLAGGED
	IF (SCHR(I).NE.' ') THEN

C--OPTIONALLY INPUT S REMARK & WEIGHT
	  IF (LALL) THEN
	    WRITE (*,1014) STAS(I)
1014	    FORMAT (' S REMK & WEIGHT (A4) FOR 'A4': ',$)
	    READ (*,1003) SRMK
	    IF (SRMK.EQ.'    ') SRMK=' S  '
	  END IF

C--INPUT S TIME IN FREE FORMAT, CR SKIPS THE STATION
40	  WRITE (*,1024) STAS(I)
1024	  FORMAT (' S TIME FOR 'A4'(0.0 NO S): ',$)
	  READ (*,1011,ERR=40) S
	IF(S.EQ.0.0) THEN 
	NCH=0
	ELSE
	NCH=1
	END IF
C--OUTPUT TIME IN 1/100 SECONDS AS AN INTEGER
	  IS=S*100.+.5
	  IF (NCH.NE.0) WRITE (14,1013) STAS(I),SRMK,IS
	END IF

C--INPUT AN AMPLITUDE IF THIS STATION WAS FLAGGED
	IF (ACHR(I).NE.' ') THEN
44	  WRITE (*,1025) STAS(I)
1025	  FORMAT (' AMPLITUDE FOR 'A4': ',$)
	  READ (*,1011,ERR=44) P
	  IF(P.EQ.0.0) THEN
	  NCH=0
	  ELSE
	  NCH=1
	  END IF
	  IF (NCH.NE.0) WRITE (14,1026) STAS(I),P
1026	  FORMAT (A4' A  'F5.0)
	END IF

C--END OF STATION LOOP
50	CONTINUE

C--OPTIONALLY ENTER A TIME FOR A STATION NOT ON PROMPT LIST
60	WRITE (*,1015)
1015	FORMAT (' ENTER ANOTHER P, S OR CODA FOR THIS EVENT (Y OR N)? ',$)
	READ (*,1008) CHR
	IF (CHR.NE.'Y' .AND. CHR.NE.'y') GOTO 70
C--GET STATION NAME & REMARK
	WRITE (*,1016)
1016	FORMAT (' STATION (A4)? ',$)
	READ (*,1003) STA
	WRITE (*,1017) 
1017	FORMAT (' P OR S REMARK & WEIGHT (A4)? ',$)
	READ (*,1003) RMK

C--GET STATION TIME
65	WRITE (*,1018)
1018	FORMAT (' P OR S TIME: ',$)
	READ (*,1011,ERR=65) P
	IF(P.EQ.0.0) THEN
	NCHP=0
	ELSE
	NCHP=1
	END IF
	IF (NCHP.EQ.0) RMK=' P 4'
	IP=P*100.+.5

C--GET CODA
67	WRITE (*,1029)
1029	FORMAT (' CODA: ',$)
	C=0.
	READ (*,1011,ERR=67) C
	IF(C.EQ.0.0) THEN
	NCHC=0
	ELSE
	NCHC=1
	END IF
	IC=C+.5

C--OUTPUT ARRIVAL TIME AND/OR CODA
	IF (NCHP.NE.0 .OR. NCHC.NE.0) THEN
	  IF (NCHC.EQ.0) THEN
	    WRITE (14,1013) STA,RMK,IP
	  ELSE
	    WRITE (14,1013) STA,RMK,IP,IC
	  END IF
	END IF
	GOTO 60

C--OPTIONALLY ENTER AN AMPLITUDE FOR ANY STATION
70	WRITE (*,1019)
1019	FORMAT (' ENTER AN AMPLITUDE FOR THIS EVENT (Y OR N)? ',$)
	READ (*,1008) CHR
	IF (CHR.NE.'Y' .AND. CHR.NE.'y') GOTO 80
C--GET STATION NAME
	WRITE (*,1016)
	READ (*,1003) STA

C--GET STATION AMPLITUDE
75	WRITE (*,1021)
1021	FORMAT (' AMPLITUDE: ',$)
	READ (*,1011,ERR=75) P
	IF(P.EQ.0.0) THEN
	NCH=0
	ELSE
	NCH=1
	END IF
	IF (NCH.EQ.0) GOTO 70
	IP=P+.5
	WRITE (14,1022) STA,CHR,IP
1022	FORMAT (A4' A  'I4'.')
	GOTO 70

C--WRITE TERMINATOR LINE
80	WRITE (14,1010)

C--DECIDE WHETHER TO ENTER ANOTHER EVENT
	WRITE (*,1023)
1023	FORMAT (' STOP ENTERING DATA & RETURN TO COMMAND LEVEL',
     2 ' (Y OR N)? ',$)
	READ (*,1008) CHR
	IF (CHR.NE.'Y' .AND. CHR.NE.'y') GOTO 25
	CLOSE (14)
	RETURN
	END
	SUBROUTINE HYSTL (STANAM)
C--CALLED BY HYPOINV TO LIST STATIONS & CRUST MODEL ON PRINT FILE & OPEN FILES
	CHARACTER DAT*9,TIM*8
C--THESE ARE NEEDED IN PC350 VERSION ONLY:
	INTEGER STATUS(2),IOSB(2)

C--OPTIONAL LINE DESCRIPTOR BLOCK WITH PORT SETTINGS
C	BYTE LDB(16)
C	DATA LDB/16,16,8,1,0,0,0,9*0/

c$INCLUDE:'HYPCOM.'
c$INCLUDE:'HYPCOMC.'
c$INCLUDE:'HYPCOMV.'

      include 'hypcom.inc'
      include 'hypcomc.inc'
      include 'hypcomv.inc'
C--OPEN PHASE DATA FILE
C	IF (JCP.EQ.5) THEN

C--ATTACH (OPEN) THE COMM PORT (USE IN PC350 VERSION ONLY)
C	  CALL CCATT (STATUS,16)
C--OPTIONALLY SET LINE CHARACTERISTICS TO 4800 BAUD SEND & RECEIVE,
C  8 DATA BITS, 1 STOP BIT, NO PARITY CHECKING, XON/XOFF ENABLED.
C	  CALL CCSMC (STATUS,16,LDB)
C--INITIATE THE CONNECTION IN ORIGINATE MODE (RAISE DTR & RTS)
C	  CALL CCORG (STATUS,16,IEFN,IOSB)
C--RESET THE PHASE FILE NAME, WHICH IS UNUSED
C	  PHSFIL='*COMM PORT*'
C	ELSE

C--OPEN PHASE FILE
      OPEN (14,FILE=PHSFIL,STATUS='OLD',FORM='FORMATTED',
     2IOSTAT=IOC)
	IF(IOC.GT.0) GO TO 33
C	END IF
	ISTAT=1

C--OPEN OUTPUT FILES
 	IF (LSUM .AND. LAPP(2)) OPEN (12,FILE=SUMFIL,FORM='FORMATTED')
	IF (LARC .AND. LAPP(3)) OPEN (7,FILE=ARCFIL,FORM='FORMATTED')
	IF (LPRT .AND. LAPP(1)) OPEN (15,FILE=PRTFIL,FORM='FORMATTED')

	IF (LSUM .AND. .NOT.LAPP(2)) OPEN(12,FILE=SUMFIL,STATUS='unknown')
	IF (LARC .AND. .NOT.LAPP(3)) OPEN (7,FILE=ARCFIL,STATUS='unknown')
	IF (LPRT .AND. .NOT.LAPP(1)) OPEN(15,FILE=PRTFIL,STATUS='unknown')
	GOTO 38

C--HERE IS THE ERROR MESSAGE FOR NON-EXISTENT PHASE FILES
33	WRITE (*,1010)
1010	FORMAT (' *** ERROR - PHASE FILE DOES NOT EXIST ***')
	ISTAT=0
	RETURN

C--INITIALIZE SOME VALUES
38	REMK=' '
	LOCNUM=0

C--SET FLAG USED TO INDICATE END OF PHASE CARD FILE
	KEND=0

C--CONTINUE ONLY IF STATIONS & OTHER DATA ARE TO BE PRINTED
	IF (.NOT.LPRT .OR. JST.EQ.0) RETURN

C--PRINT CURRENT DATE & TIME FIRST
C	CALL DATE (DAT)
C	CALL TIME (TIM)
	WRITE (15,1000)
1000	FORMAT ('1HYPOINVERSE (1/85 VERSION)'/)
	IF (JST.EQ.1) GOTO 18
	WRITE (15,1009)
1009	FORMAT (' STATIONS:'/3X'I NAME ---LAT---- ----LON---- PDLY1',
     3 ' PDLY2 FMC XMC WT PMOD SMOD CAL PER TYP'/)

C--LOOP TO DECODE PARAMETERS AND WRITE STATIONS
	DO 5 I=1,JSTA
	XLTM=ABS(JLATM(I)*.01)
	XLNM=ABS(JLONM(I)*.01)
	KTEMP2=JMCOR(I)-2525
	KTEMP=KTEMP2/100.
	KTEMP2=KTEMP2-KTEMP*100
	XMC=KTEMP*.1
	FMC=KTEMP2*.1
	PD1=.01*JPD1(I)
	PD2=.01*JPD2(I)
	JWT=JMOD(I)/100
	KTEMP=JMOD(I)-100*JWT
	MODP=KTEMP/10
	MODS=KTEMP-10*MODP
	WT=.1*JWT
	ITYPE=JCAL(I)/10000
	KTEMP=JCAL(I)-10000*ITYPE
	KTEMP2=KTEMP/500
	KTEMP=KTEMP-500*KTEMP2
	CAL=KTEMP*.1
	PER=KTEMP2*.1
	KTEMP=IABS(JLATD(I))
	KTEMP2=IABS(JLOND(I))
	IE=' '
	IS=' '
	IF (KTEMP.LT.0 .OR. XLTM.LT.0.) IS='S'
	IF (KTEMP2.LT.0 .OR. XLNM.LT.0.) IE='E'

C--OUTPUT ONE LINE FOR THIS STATION
5	WRITE (15,1001) I,STANAM(I),KTEMP,IS,XLTM,KTEMP2,IE,XLNM,PD1,
     2 PD2,FMC,XMC,WT,MODP,MODS,CAL,PER,ITYPE
1001	FORMAT (1X,I3,1X,A4,I4,A1,F5.2,I6,A1,F5.2,1X,2F6.2,3F4.1,I3,I5,
     2 F5.1,F4.1,I3)

C--PRINT THE CRUSTAL MODELS, ONE AT A TIME
	DO 15 I=1,3
	IF (MODTYP(I).EQ.-1) GOTO 15
	WRITE (15,1002) I,MODNAM(I)
1002	FORMAT (//' CRUST MODEL'I2': 'A20/)

C--PRINT THE LAYER PARAMETERS FOR THE MODEL
C--HANDLE HOMOGENEOUS LAYER & LINEAR GRADIENT MODELS SEPERATELY
	IF (MODTYP(I).EQ.0) THEN
	  WRITE (15,1003)
1003	  FORMAT (' LINEAR GRADIENT MODEL WITH VELOCITIES SPECIFIED AT',
     2 ' THE FOLLOWING DEPTHS:')
	ELSE
	  WRITE (15,1004)
1004	  FORMAT (' HOMOGENEOUS LAYER MODEL WITH THE FOLLOWING',
     2 ' VELOCITIES AND LAYER TOPS:')
	END IF
	WRITE (15,1005)
1005	FORMAT (4X'VELOCITY  DEPTH') 
	DO 10 J=1,LAY(I)
10	WRITE (15,1006) J,VEL(J,I),D(J,I)
1006	FORMAT (I3,2F8.3)
15	CONTINUE

C--PRINT THE COMPUTATIONAL PARAMETERS FOR THIS RUN
18	WRITE (15,1007)
1007	FORMAT (//' TEST PARAMETERS:'/3X'-ITERATION AND CONVERGENCE-',
     2 5X'-WEIGHTING AND ERRORS-')

	WRITE (15,1008) ITRLIM,DAMP,DISCUT,RMSCUT,
     2 DQUIT,DRQT,DISW1,RMSW1,
     3 DXFIX,EIGTOL,DISW2,RMSW2,
     4 DZMAX,RBACK,SWT,RDERR,
     5 DZAIR,BACFAC,ZTR,ERCOF,
     6 NET,LFIX
1008	FORMAT (
     1   I9'=ITRLIM'F8.3'=DAMP  'F8.3'=DISCUT'F8.3'=RMSCUT'/
     2 F9.3'=DQUIT 'F8.3'=DRQT  'F8.3'=DISW1 'F8.3'=RMSW1'/
     3 F9.3'=DXFIX 'F8.3'=EIGTOL'F8.3'=DISW2 'F8.3'=RMSW2'/
     4 F9.3'=DZMAX 'F8.3'=RBACK 'F8.3'=SWT   'F8.3'=RDERR'/
     5 F9.3'=DZAIR 'F8.3'=BACFAC'F8.3'=ZTR   'F8.3'=ERCOF'/
     6   I9'=NET   '  A8'=LFIX')

	WRITE (15,1014)
1014	FORMAT (/4X'-DURATION MAG CONSTANTS-'7X'-DELAYS-')

	WRITE (15,1015) FMA1,FMA2,DLYAZ,
     2 FMB1,FMB2,DLYWD,
     3 FMZ1,FMZ2,DLYLON,
     4 FMD1,FMD2,DLYLAT,
     5 FMBRK,POS,KDLY
1015	FORMAT (
     1 F9.3'=FMA1  'F8.3'=FMA2  'F8.3'=DLYAZ'/
     2 F9.3'=FMB1  'F8.3'=FMB2  'F8.3'=DLYWD'/
     3 F9.3'=FMZ1  'F8.3'=FMZ2  'F8.3'=DLYLON'/
     4 F9.3'=FMD1  'F8.3'=FMD2  'F8.3'=DLYLAT'/
     5 F9.3'=FMBRK 'F8.3'=POS   '  I8'=KDLY')

C--WRITE INPUT FILENAMES
	WRITE (15,1020)
1020	FORMAT (//' INPUT FILES:')
	WRITE (15,1021) INFILE,STAFIL,PHSFIL
1021	FORMAT (' COMMANDS: 'A/' STATIONS: 'A/' PHASES:   'A)

	DO 25 I=1,3
	IF (MODTYP(I).EQ.0) WRITE (15,1022) I,CRUFIL(I)
1022	FORMAT (' LINEAR  GRADIENT  CRUST'I2':  'A)
	IF (MODTYP(I).EQ.1) WRITE (15,1023) I,CRUFIL(I)
1023	FORMAT (' HOMOGENEOUS LAYER CRUST'I2':  'A)
25	CONTINUE

C--WRITE OUTPUT FILENAMES
	WRITE (15,1030) LAPP(1),PRTFIL
1030	FORMAT (//' OUTPUT FILES: (T IF APPENDED TO)'/
     2 ' ('L1') PRINTOUT: 'A)
	IF (LSUM) WRITE (15,1031) LAPP(2),SUMFIL
1031	FORMAT (' ('L1') SUMMARY:  'A)
	IF (LARC) WRITE (15,1032) LAPP(3),ARCFIL
1032	FORMAT (' ('L1') ARCHIVE:  'A)

	WRITE (15,1034)
1034	FORMAT (//)
	RETURN
	END
	SUBROUTINE HYPHS (STANAM)
C--READS IN PHASE DATA FOR 1 HYPOINVERSE EARTHQUAKE
C--ALSO CHECK FOR TRIAL HYPOCENTER & MANY ERRORS IN DATA
c$INCLUDE:'HYPCOM.'
c$INCLUDE:'HYPCOMV.'
      include 'hypcom.inc'
      include 'hypcomv.inc'
	CHARACTER CSTA*4,TRMK*3,RMKS(7)*3
	REAL LASTA

C--RMKS IS THE ARRAY OF EVENT REMARKS WHICH ARE RECOGNIZED, ABBREVIATED
C  TO 1 LETTER & OUTPUT AS A SUPPLEMENTARY REMARK.
	DATA RMKS/'FLT','F  ','TRM','T  ','LPC','LPD','BLS'/

C--INITIALIZATION BEFORE EACH EQ.
8	LOCIN=0
	CCOR=0.
	RMK1=' '
	RMK2=' '
	LASTA=' '
	K=0

C--READ THE EVENT REFERENCE TIME IF PHASE FILE IS CONDENSED
C--ALSO DEFINE THE AUXILIARY REMARKS FROM THE HEADER LINE IF THIS IS
C--A CONDENSED FORMAT ARCHIVE FILE.
	IF (JCP.GT.1) THEN
	  READ (14,1008,ERR=9,END=80) KYEAR,KMONTH,
     2 KDAY,KHOUR,KMIN,SEC,RMK1,RMK2
1008	  FORMAT (5I2,F4.2,62X,2A1)
	  IF (RMK2.EQ.'*') RMK2=' '
	END IF
	GOTO 10

C--READ ERROR
9	WRITE (*,1009)
	IF (LPRT) WRITE (15,1009)
1009	FORMAT (' BAD REFERENCE TIME - ASSUME ZEROS')
	KYEAR=0
	KMONTH=0
	KDAY=0
	KHOUR=0
	KMIN=0
	SEC=0.

C--LOOP TO READ PHASE CARDS
10	DO 50 K=1,MAXPHS
	GOTO 15

C--PRINT AN ERROR MESSAGE & SKIP A BAD PHASE CARD
12	IF (LPRT) WRITE (15,1000) INST
	IF (LERR) WRITE (6,1000) INST
1000	FORMAT (' SKIP BAD PHASE CARD:'/1X,A)

C--READ A PHASE CARD
15	READ (14,1001,END=80,ERR=12) INST
1001	FORMAT (A)

C--INTERPRET A CARD WITH A BLANK STATION NAME OR NUMERAL IN THE FIRST
C  COLUMN AS A TERMINATOR CARD
	CSTA=INST(1:4)
	I=ICHAR(INST(1:1))
	IF (CSTA.EQ.'    ' .OR. (I.LT.58 .AND. I.GT.47)) GOTO 60

	IF (JCP.GT.1) THEN
C--ASSUME THE CONDENSED PHASE CARD FORMAT.
C--INITIALIZE DATA IN CASE IT IS NOT GIVEN A VALUE READING CONDENSED FORMAT
	  KP(K)=0
	  KPRK(K)='  '
	  KWT(K)=0
	  KS(K)=0
	  KFMP(K)=0
	  KAMP(K)=0
	  KSRK(K)='  '
	  KRMK(K)=' '

C--IF THIS LINE INCLUDES DATA FROM THE STATION ON PREVIOUS LINE,
C  DONT INCREMENT THE STATION INDEX
	  READ (INST,1010,ERR=12) STA,CM,I,TEMP,FMP
1010	  FORMAT (A4,A3,I1,F5.2,F4.0)
	  IK=K
	  IF (STA.EQ.LASTA) IK=K-1
	  CTEMP=CM(2:2)
	  IF (FMP.NE.0.) KFMP(IK)=FMP+.5

C--THIS IS A P TIME 
	  IF (CTEMP.EQ.'P') THEN
	    KPRK(IK)=CM
	    KWT(IK)=KWT(IK)+I
	    KP(IK)=JNINT(100.*(TEMP+SEC))
	  END IF

C--THIS IS AN S TIME
	  IF (CTEMP.EQ.'S') THEN
	    KSRK(IK)=CM
	    KWT(IK)=KWT(IK)+10*I
	    KS(IK)=JNINT(100.*(TEMP+SEC))
	  END IF

C--THIS IS AN AMPLITUDE
	  IF (CTEMP.EQ.'A') KAMP(IK)=TEMP+.5
	  IF (IK.EQ.K) GOTO 18
	  GOTO 15
	END IF

C--ASSUME A FULL PHASE CARD
	READ (INST,1002,ERR=12) STA,KPRK(K),LPWT,LYEAR,LMONTH,LDAY,
     2 LHOUR,LMIN,P,S,KSRK(K),LSWT,AMP,IL,IT,TRMK,CCOR,KRMK(K),FMP
1002	FORMAT (A4,A3,I1,1X,5I2,F5.2,6X,F6.2,A2,1X,I1,4X,F3.0,7X,
     2 2I4,A3,F5.2,A1,F4.0)
	KAMP(K)=AMP+.5
	KFMP(K)=FMP+.5

C--KEEP THE LOCATION NO. LOCIN (IF PRESENT) AS THE CURRENT EVENT NO.
	IF (LOCIN.EQ.0 .AND. IT.EQ.0) LOCIN=IL

C--TEST ALL PHASE CARDS BUT THE FIRST FOR CLOSE TIME AGREEMENT
	IF (K.EQ.1) THEN
	  KYEAR=LYEAR
	  KMONTH=LMONTH
	  KDAY=LDAY
	  KHOUR=LHOUR
	  KMIN=LMIN
	ELSE
	  IF (LYEAR-KYEAR+LMONTH-KMONTH+LDAY-KDAY.NE.0 .OR.
     2 IABS((LHOUR-KHOUR)*60+LMIN-KMIN).GT.4) THEN
	    IF (LPRT) WRITE (15,1003) INST
	    IF (LERR) WRITE (6,1003) INST
1003	    FORMAT (' SKIP OVER PHASE CARD WITH WRONG TIME:'/1X,A)
	    GOTO 15
	  END IF
	END IF

C--DERIVE THE AUXILIARY REMARKS FROM CERTAIN EVENT REMARKS
18	DO 20 I=1,7
	IF (TRMK.EQ.RMKS(I)) THEN
	  IF (RMK1.EQ.' ') THEN
	    RMK1=TRMK(1:1)
	  ELSE
	    IF (RMK2.EQ.' ') RMK2=TRMK(1:1)
	  END IF
	  GOTO 24
	END IF
20	CONTINUE

C--KEEP TRACK OF THE CURRENT STA FOR NEXT PASS THRU LOOP
24	LASTA=STA

C--TEST TO SEE IF THE STATION IS ON THE LOOK-UP LIST
	DO 30 J=1,JSTA
	IF (STA.EQ.STANAM(J)) GOTO 35
30	CONTINUE
C--PRINT AN ERROR MESSAGE & READ ANOTHER PHASE CARD
	IF (LPRT) WRITE (15,1004) INST
	IF (LERR) WRITE (6,1004) INST
1004	FORMAT (' SKIP PHASE CARD WITH UNKNOWN STATION:'/1X,A)
	GOTO 15

C--SET REFERENCE INDEX FOR THIS STATION & ENCODE DATA
35	KINDX(K)=J
	IF (JCP.GT.1) GOTO 50

C--CORRECT ARRIVAL TIMES TO SAME MINUTE
	LSHIF=((LHOUR-KHOUR)*60+LMIN-KMIN)*60
C--STORE TIMES IN .01 SEC, ROUNDED TO NEAREST INTEGER
	KP(K)=JNINT(100.*(P+LSHIF+CCOR))
	KS(K)=JNINT(100.*(S+LSHIF+CCOR))
	KWT(K)=10*LSWT+LPWT
50	CONTINUE

C--TREAT REMAINING PHASE CARDS AS ANOTHER EVENT
	KSTA=MAXPHS
	IF (LPRT) WRITE (15,1005) INST
	IF (LERR) WRITE (6,1005) INST
1005	FORMAT (' TOO MANY STATIONS. TREAT REST AS ANOTHER EVENT.'/
     2 ' LAST STATION FOR THIS EVENT IS:'/1X,A)
C--ZERO THE TRIAL COORDINATES AS IF A BLANK CARD WAS READ
	T1=0.
	Z1=0.
	CLON=0.
	CLAT=0.
	RETURN

C--COME HERE FOR NORMAL EVENT TERMINATION WITH AN INSTRUCTION CARD
60	KSTA=K-1
C--SKIP AN EVENT WITH FEWER THAN MINSTA PHASE CARDS
	IF (KSTA.LT.MINSTA) THEN
	  IF (LPRT) WRITE (15,1006) MINSTA,KYEAR,KMONTH,KDAY,KHOUR,KMIN
	  IF (LERR) WRITE (6,1006) MINSTA,KYEAR,KMONTH,KDAY,KHOUR,KMIN
1006	  FORMAT (' SKIP EVENT WITH LESS THAN'I2' PHASE CARDS:'5I3)
	  GOTO 8
	END IF

C--GET TRIAL DATA (IF ANY) FROM TERMINATOR CARD
	READ (INST,1007,ERR=74) MHOUR,MINIT,T,LAT,IS,XLTM,LON,IE,XLNM,Z1
1007	FORMAT (6X,2I2,F4.2,I2,A1,F4.2,I3,A1,F4.2,F5.2)
C--LOAD LAT & LON
	CLAT=LAT+XLTM/60.
	CLON=LON+XLNM/60.
	IF (IS.EQ.'S') CLAT=-CLAT
	IF (IE.EQ.'E') CLON=-CLON
C--DONT INTERPRET AN OLD STYLE INSTRUCTION PARAMETER IN COLS 18-19
C  AS A TRIAL LATITUDE.
	IF (ABS(CLAT).LT..4 .AND. CLON.EQ.0.) CLAT=0.
	IF (MHOUR+MINIT.EQ.0 .AND. T.EQ.0.) THEN
	  T1=0.
	ELSE
	  T1=T+((MHOUR-KHOUR)*60+MINIT-KMIN)*60
	END IF
74	RETURN

C--COME HERE IF AN END OF FILE WAS JUST READ
80	KSTA=K-1
	KEND=1
	IF (KSTA.LT.2) KEND=-1
	RETURN
	END
	SUBROUTINE HYTRL
C--SETS THE TRIAL HYPOCENTER FOR HYPOINVERSE & PRINTS THE PRINT HEADING
c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'
	CHARACTER XMON(12)*3
	DATA XMON/'JAN','FEB','MAR','APR','MAY','JUN','JUL','AUG','SEP',
     2 'OCT','NOV','DEC'/
	KTEMP=30000
	KTMP2=2

C--INCREMENT THE LOCATION & SEQUENCE NUMBERS
	LOCNUM=LOCNUM+1
	INUM=INUM+1
	IF (LOCIN.NE.0) LOCNUM=LOCIN

C--DETERMINE EARLIEST ARRIVING STATION AND USE ITS COORDS AS TRIAL LOC
	DO 20 K=1,KSTA
	LSWT=KWT(K)/10
	LPWT=KWT(K)-LSWT*10
	IF (LPWT.GT.3 .OR. KP(K).GT.KTEMP .OR. KPRK(K).EQ.' ')
     2  GO TO 20
C--K2 IS THE SECOND CLOSEST STATION
	K2=KTMP2
	KTMP2=K
	J=KINDX(K)
	KTEMP=KP(K)
20	CONTINUE

C--SET A TRIAL COORDINATE ONLY IF IT WASN'T GIVEN ON INST CARD
	IF (CLAT.EQ.0.) CLAT=JLATD(J)+JLATM(J)/6000.+.005
	IF (CLON.EQ.0.) CLON=JLOND(J)+JLONM(J)/6000.+.005
	IF (T1.EQ.0.) T1=KTEMP/100.-2.

C--PRINT THE EVENT DATE AND TIME AS HEADING
	IF (LPRT .AND. KPRINT.GT.0) WRITE (15,1005) KDAY,XMON(KMONTH),
     2 KYEAR,KHOUR,KMIN,LOCNUM,INUM
1005	FORMAT (1X,I3,1X,A3,I3','I3':'I2,2X'SEQUENCE NO. 'I4
     2 ' LOCATION NO. 'I4)
	RETURN
	END
	SUBROUTINE HYLOC (KDHR,KT,STANAM,A,W,R,IMPORT,MTCAL)
C--LOCATES ONE EARTHQUAKE FOR THE PROGRAM HYPOINV
	LOGICAL CONERR,LZFIX,ZFIX,LPKTMP,LMESS,LDISWT,LRESWT

c$INCLUDE:'HYPCOM.'
c$INCLUDE:'HYPCOMT.'
c$INCLUDE:'HYPCOMV.'
c$INCLUDE:'HYPCOMA.'

      include 'hypcom.inc'
      include 'hypcomt.inc'
      include 'hypcomv.inc'
      include 'hypcoma.inc'

C--THIS IS THE HYPOCENTER ADJUSTMENT VECTOR
	DIMENSION Y(4)

C--NRES IS THE NUMBER OF TIMES THAT RESIDUAL WEIGHTING IS APPLIED EACH ITER.
	DATA NRES /2/

C--INITIALIZE VARIABLES
	N=3
	NLAST=N
	ITR=0
	DONE=.FALSE.
	RMSMIN=10000.
	OLDRMS=10000.
	RR=10000.
	D1=10000.
	D2=10000.
	LMESS=KPRINT.GT.1 .AND. LPRT

C--ZFIX INDICATES WHETHER DEPTH IS FIXED PERMANENTLY, & LZFIX INDICATES
C  WHETHER IT IS FIXED ON THIS ITERATION.
	IF (Z1.EQ.0.) Z1=ZTR
	ZFIX=Z1.LT.0.
	LZFIX=.TRUE.
	Z1=ABS(Z1)

C******************* BEGIN ITERATION LOOP ********************************

30	M=0
	NWR=0
	ITR=ITR+1
	COSLAT=COS(CLAT/RDEG)

C--THESE FLAGS SIGNAL WHETHER WEIGHTING IS APPLIED IN THE CURRENT ITERATION
	LDISWT=ITR.GE.ITRDIS
	LRESWT=ITR.GE.ITRRES
	IF (ITR.EQ.ITRDIS .AND. LMESS) WRITE (15,1001)
1001	FORMAT (' BEGIN DISTANCE WEIGHTING')
	IF (ITR.EQ.ITRRES .AND. LMESS) WRITE (15,1002)
1002	FORMAT (' BEGIN RESIDUAL WEIGHTING')

C--DECIDE WHICH DELAY MODEL TO USE FOR THIS LOCATION.
C--DLYBAL MAY DEPEND ON EPI POSITION AND GIVES THE ACTUAL DELAY AS A
C--WEIGHTED AVERAGE OF THE 2 DELAY MODELS.

C--DELAY MODEL 1 OR DEFAULT IF KDLY IS OUT OF RANGE
	DLYBAL=0.
C--DELAY MODEL 2
	IF (KDLY.EQ.2) DLYBAL=1.
	IF (KDLY.GT.2) THEN
C--TWO DELAY MODELS SEPARATED BY A LINE
	  IF (KDLY.EQ.3) DF=-111.19*((CLAT-DLYLAT)*SIN(DLYAZ/RDEG)
     2 +COSLAT*(CLON-DLYLON)*COS(DLYAZ/RDEG))
C--TWO DELAY MODELS SEPARATED BY A CIRCLE
	  IF (KDLY.EQ.4) DF=111.19*SQRT((CLAT-DLYLAT)**2
     2 +((CLON-DLYLON)*COSLAT)**2)-DLYAZ
C--SET BALENCE FACTOR BETWEEN 2 DELAY MODELS
	  IF (DF.GT.DLYWD) DF=DLYWD
	  IF (DF.LT.-DLYWD) DF=-DLYWD
	  DLYBAL=.5+.5*SIN(1.5708*DF/DLYWD)
	END IF

C++++++++++++++++++++++ CALC STATION DISTANCES AND AZIMUTHS +++++++++++++

	DO 40 K=1,KSTA
	J=KINDX(K)

C--DIST AND AZIMUTH FORMULAS ARE APPROXIMATE.
C--DISTANCE ERROR IS LESS THAN 3.E-10*D**3 FOR D IN KM AND LATS BETWEEN +/- 70
C--THIS GIVES A 1 KM ERROR AT 700 KM.
C--TEMP=LAT DIFFERENCE, TEMP2=LON DIFFERENCE TIMES COS OF LAT
	TEMP=JLATD(J)+JLATM(J)/6000.-CLAT
	TEMP2=(JLOND(J)+JLONM(J)/6000.-CLON)*COSLAT
C--CALCULATE AZIMUTH TO STATION IN DEG BETWEEN +/- 180
	KTEMP=0
	IF (TEMP*TEMP2 .NE. 0.)	KTEMP=RDEG*ATAN2(-TEMP2,TEMP)
	KAZEM(K)=180*KTEMP

C--DISTANCE IN .05 KM
	DELTKM=111.195*SQRT(TEMP**2+TEMP2**2)
	KDIS(K)=20.*DELTKM+.5

C--DETERMINE THE INDEX OF THE 2ND CLOSEST STATION
	IF (DELTKM.LT.D1) THEN
	  D2=D1
	  K2=K1
	  D1=DELTKM
	  K1=K
	  GOTO 40
	END IF
	IF (DELTKM.LT.D2) THEN
	  D2=DELTKM
	  K2=K
	END IF
40	CONTINUE

C--TEMP3 IS THE DISTANCE WEIGHTING SCALE FACTOR
	TEMP3=KDIS(K2)*.05
	IF (TEMP3.LT.DISCUT) TEMP3=DISCUT
	TEMP=TEMP3*DISW1
	TEMP2=TEMP3*DISW2

C++++++ LOOP OVER REPORTING STATIONS TO CALC DIST WTS & LOG IN TIMES ++++++

	DO 50 K=1,KSTA
	J=KINDX(K)
	DELTKM=KDIS(K)*.05

C-- APPLY DISTANCE AND STATION WEIGHTS
	KTEMP=JMOD(J)/100
	WFAC=.1*KTEMP
	IF (DELTKM.GE.TEMP .AND. LDISWT) THEN
	  IF (DELTKM.GT.TEMP2) THEN
	    WFAC=0.
	  ELSE
	    WFAC=(.5*COS(PI*(DELTKM-TEMP)/(TEMP2-TEMP))+.5)*WFAC
	  END IF
	END IF

C--DECODE P & S WEIGHTS
	LSWT=KWT(K)/10
	LPWT=KWT(K)-10*LSWT
C--IF ONLY A MAGNITUDE IS TO BE COMPUTED (BUT THERE IS NO P OR S),
C  RESERVE A PLACE FOR STATION BY PRETENDING TO LOG IN A P.
	LPKTMP=KPRK(K).NE.'  '
	IF (LPKTMP .OR. (KAMP(K)+KFMP(K).NE.0 .AND.
     2 KSRK(K).EQ.'  ')) THEN

C--LOG IN P ARRIVAL TIMES AND WEIGHTS
	  M=M+1
	  IF (M.GT.MMAX) GOTO 52
	  W(M)=0.
	  IF (LPWT.LT.4 .AND. LPKTMP) W(M)=.25*WFAC*(4-LPWT)
	  IF (W(M).GT.0.) NWR=NWR+1
	  IND(M)=K
	END IF

	IF (KSRK(K).NE.' ') THEN
C--LOG IN S ARRIVAL TIMES AND WEIGHTS
	  M=M+1
	  IF (M.GT.MMAX) GOTO 52
	  W(M)=0.
	  IF (LSWT.LT.4) W(M)=.25*WFAC*(4-LSWT)*SWT
	  IF (W(M).GT.0.) NWR=NWR+1
C--USE IND BOTH TO INDEX ARRIVALS TO PHASE CARDS AND FLAG S ARRIVALS
	  IND(M)=K+10000
	END IF

C--END OF STATION LOOP
50	CONTINUE
	GOTO 54

C--COME HERE IN CASE OF TOO MANY PHASES
52	M=MMAX
	K=IND(M)
	J=KINDX(K)
	IF (LPRT) WRITE (15,1004)STANAM(J)
1004	FORMAT (' TOO MANY PHASES. LAST STATION INCLUDED IS 'A4)

54	IF (M.LT.4) GO TO 500

C++++++++++++++ CALC ALL TRAVEL TIMES AND DERIVS ++++++++++++++++++++

C--PASS TRAVEL TIMES & DERIVATIVES IN COLS OF ARRAY A:
C  A(I,1)  AIN   ANGLE OF INCIDENCE
C  A(I,2)  T     TRAVEL TIME
C  A(I,3)  DTDR  TT DERIV WRT DISTANCE
C  A(I,4)  DTDZ  TT DERIV WRT DEPTH

	IF (LTRT) CALL HYTRT (A,KDHR,KT)
	IF (LTRH) CALL HYTRH (A)

C--LOOP OVER ALL ARRIVAL TIMES TO CALC EMERGENCE ANGLES, RESIDUALS, ETC.
	DO 60 IM=1,M

C--FIND STATION INDEX AND REMOVE KPS AS AN S FLAG
	K=IND(IM)
	KPS=K/10000
	K=K-10000*KPS
	J=KINDX(K)

C--RECORD EMERGENCE ANGLE AND AZIMUTH
C--MAKE THEM THE SAME SIGN TO FIT BOTH IN A 16-BIT WORD
	KTEMP=KAZEM(K)/180
	AZM=KTEMP/RDEG
	TEMP=A(IM,1)
	IF (KTEMP.LT.0) TEMP=-TEMP
	KAZEM(K)=KTEMP*180+TEMP
C--CALCULATED TRAVEL TIME
	MTCAL(IM)=100.*A(IM,2)

C+++++++++++++++++ CALC DELAYS AND RESIDUALS ++++++++++++++++++

C--CALC DELAYS, OBS ARRIVAL TIME, AND VEL INDEPENDENTLY FOR P AND S
	IF (KPS.NE.1) THEN
C--THIS IS A P WAVE
	  PSFAC=1.
	  TEMP2=KP(K)
	ELSE
C--THIS IS AN S WAVE
	  PSFAC=POS
	  TEMP2=KS(K)
	END IF
	DLY=PSFAC*(DLYBAL*JPD2(J)+(1.-DLYBAL)*JPD1(J))

C--CALC TRAVEL TIME RESIDUAL
	R(IM)=.01*(TEMP2-MTCAL(IM)*PSFAC-DLY)-T1

C--SET PARTIAL DERIVATIVES
C--(1)=DTDT,(2)=DTDY,(3)=DTDX,(4)=DTDZ
	A(IM,1)=1.
	TEMP=PSFAC*A(IM,3)
C--SET LAT & LON PARTIAL DERIVATIVES
	A(IM,2)=-TEMP*COS(AZM)
	A(IM,3)= TEMP*SIN(AZM)
C--SET DT/DZ, WHICH MAY BE UNUSED IF DEPTH IS FIXED
	A(IM,4)=PSFAC*A(IM,4)

C--END OF PHASE LOOP
60	CONTINUE

C++++++++++++++++ RESIDUAL WEIGHTING ++++++++++++++++++++

C--LOOP TO APPLY RESIDUAL WEIGHTING NRES TIMES
C--NRES WILL APPROXIMATE THE NUMBER OF VERY LARGE RESIDUALS
C  TO BE DISCARDED BEFORE INVERTING FOR THE HYPOCENTER
C--IF NRES=1, ONLY 1 VERY LARGE RESIDUAL WILL BE DISCARDED,
C  LEAVING ERRORS IN THE REMAINING DATA TO CONTAMINATE THE SOLUTION

	DO 80 I=1,NRES
	RMSWT=0.
	WNORM=0.
	NWR=0

C--ACCUMULATE RMSWT AND WEIGHTS
	DO 65 IM=1,M
	WNORM=WNORM+W(IM)**2
65	RMSWT=RMSWT+(W(IM)*R(IM))**2
	IF (WNORM.EQ.0.) GO TO 500
	RMSWT=SQRT(RMSWT/WNORM)
C--DON'T SHRINK RESIDUAL WEIGHTING LIMITS IF RMSWT BECOMES TOO SMALL
	TEMP2=RMSWT
	IF (TEMP2.LT.RMSCUT) TEMP2=RMSCUT
	TEMP=(RMSW2-RMSW1)*TEMP2
	WNORM=0.

C--LOOP TO CALC AND APPLY RESIDUAL WEIGHTING FOR ALL ARRIVALS
	DO 70 IM=1,M
	IF (LRESWT) THEN
	  IF (W(IM).EQ.0.) GO TO 70
	  RES=(ABS(R(IM))-RMSW1*TEMP2)/TEMP
	  IF (RES.GT.1.) THEN
	    W(IM)=0.
	    GOTO 70
	  END IF
	  IF (RES.GT.0.) W(IM)=W(IM)*(.5+.5*COS(PI*RES))
	END IF
	WNORM=WNORM+W(IM)
	NWR=NWR+1
70	CONTINUE
80	CONTINUE

	WFAC=NWR/WNORM
	WNORM=0.
	RMS=0.
	NWS=0
	NWR=0

C--NOW NORMALIZE WEIGHTS AND APPLY THEM TO PARTIAL DERIVATIVES
	DO 95 IM=1,M

C--NORMALIZE WEIGHTS
	W(IM)=W(IM)*WFAC
	WNORM=WNORM+W(IM)**2
	RMS=RMS+(R(IM)*W(IM))**2
C--COUNT WEIGHTED ARRIVALS
	IF (W(IM).GT..1) THEN
	  NWR=NWR+1
	  K=IND(IM)
	  KPS=K/10000
	  IF (KPS.NE.0) NWS=NWS+1
	END IF

C--APPLY WEIGHTS TO PARTIAL DERIVS
	DO 90 I=1,N
90	A(IM,I)=A(IM,I)*W(IM)

C--LOAD THE DATA VECTOR R INTO THE N+1ST COL OF A FOR INVERSION IN SOLVE
95	A(IM,N+1)=R(IM)*W(IM)

	RMS=SQRT(RMS/WNORM)
	IF (NWR.LT.4) GO TO 500

C--MAKE THIS THE LAST ITER IF 1) CHANGE IN RMS OR ADJ VECTOR IS SMALL
C  (ONLY IF THE DEPTH HAS BEEN FREED) OR 2) THE MAX NO. OF ITERATIONS 
C  IS REACHED (AND THE RMS DID NOT INCREASE LAST TIME)
C--BUT CONTINUE ITERATING IF DIS & RES WEIGHTS HAVENT BEEN APPLIED.
	IF (LRESWT .AND. LDISWT) DONE=(((ABS(OLDRMS-RMS).LT.DRQT) .OR.
     2 RR.LT.DQUIT) .AND. (.NOT.LZFIX .OR. ZFIX))
     3 .OR. (ITR.GT.ITRLIM .AND. RMS.LT.RMSMIN+RBACK)

C--GO BACK TOWARD OLD SOLUTION IF RMS INCREASED LAST TIME
	IF (RMS.GT.RMSMIN+RBACK .AND. .NOT.DONE) THEN
	  JBAC=JBAC+1
	  OLDRMS=RMS
	  IF (RMS.LT.RMSMIN) RMSMIN=RMS
	  IF (JBAC.EQ.1) THEN
C--BACKUP TOWARD OLD SOLUTION FOR FIRST TIME
	    DO 105 I=1,4
105	    Y(I)=-BACFAC*Y(I)
	    RR=RR*BACFAC
	  ELSE
C--BACKUP TOWARD OLD SOLUTION FOR SECOND OR LATER TIME
	    DO 100 I=1,4
100	    Y(I)=(1.-BACFAC)*Y(I)
	    RR=RR*(1.-BACFAC)
	  END IF
	  IF (LMESS) WRITE (15,1006) BACFAC
1006	  FORMAT (' RMS INCREASE - MOVE HYPO ',F4.2,' BACK')
	  CONERR=.TRUE.
	  GOTO 130
	END IF

C+++++++++++++++ INVERT FOR HYPO ADJUSTMENT ++++++++++++++++++++++++++

C--DO INVERSION FOR 1 ITER, FINDING OTHER USEFUL MATRICES IF REQUESTED
	CALL HYSOL (A,N,NLAST,Y,NFREE,LZFIX,W,R,IMPORT,MTCAL)

C--SET CONVERGENCE ERROR FLAG (USED TO POST A '*' REMARK)
	CONERR=.FALSE.

C--PREVENT HYPO FROM ITERATING INTO THE AIR
	IF (Z1+Y(4).LT.0.) THEN
	  IF (LMESS) WRITE (15,1210)
1210	  FORMAT (' AIRQUAKE PREVENTED')
	  CONERR=.TRUE.
	  TEMP=-DZAIR*Z1/Y(4)
	  Y(4)=-DZAIR*Z1
	  DO 110 I=1,3
110	  Y(I)=Y(I)*TEMP
	END IF

C--DAMP DEPTH ADJUSTMENT IF TOO LARGE
	IF (ABS(Y(4)).GT.DZMAX) THEN
	  IF (LMESS) WRITE (15,1220)
1220	  FORMAT (' DEPTH ADJ. DAMPED')
	  CONERR=.TRUE.
	  Y(4)=Y(4)*DZMAX/(ABS(Y(4))+DZMAX)
	END IF

C--SAVE RMS AND COMPUTE ADJUSTMENT VECTOR LENGTH
	OLDRMS=RMS
	IF (RMS.LT.RMSMIN) RMSMIN=RMS
	JBAC=0
	RR=0.
	DO 120 I=2,4
120	RR=RR+Y(I)**2
	RR=SQRT(RR)

C+++++++++++++++ PRINT INVERSION INFO +++++++++++++++++++++

C--GET COORDS IN DEG AND MIN, AND WRITE LOC FOR THIS ITERATION
C--LOCATION IS THAT PRIOR TO ADJUSTMENTS GIVEN
130	IS=' '
	IE=' '
C--LATITUDE
	IF (CLAT.LT.0.) IS='S'
	TEMP=ABS(CLAT)
	LAT=TEMP
	XLTM=60.*(TEMP-LAT)
C--LONGITUDE
	IF (CLON.LT.0.) IE='E'
	TEMP=ABS(CLON)	
	LON=TEMP
	XLNM=60.*(TEMP-LON)

C--OUTPUT ADJUSTMENTS TO PRINT FILE
	IF (LMESS) THEN
C--PRINT HEADING
	  IF (KPRINT.GT.4 .OR. ITR.EQ.1) WRITE (15,1010)
1010	  FORMAT (56X,'ADJUSTMENTS (KM)'/'  I ORIGIN   LAT N',5X,'LON W',
     2 5X,'Z   NWR  RMS    DT    DLAT   DLON    DZ    RR NF')
C--PRINT ADJUSTMENT
	  WRITE (15,1020) ITR,T1,LAT,IS,XLTM,LON,IE,XLNM,Z1,NWR,RMS,Y,RR,NFREE
1020	  FORMAT (1X,I2,F6.2,I4,A1,F5.2,I5,A1,F5.2,F6.2,I4,F5.2,F7.3,3F7.3
     2 ,F6.3,I2)
	END IF

C--IF HYPOCENTER IS FIXED (ITRLIM=0) ADJUST ORIGIN TIME TO REMOVE AV. RESIDUAL
	IF (ITRLIM.EQ.0) THEN
	  WNORM=0.
	  TEMP=0.
	  DO 124 IM=1,M
	  WNORM=WNORM+W(IM)
124	  TEMP=TEMP+R(IM)*W(IM)
	  IF (LMESS) WRITE (15,1221)
1221	  FORMAT (' AV RES REMOVED; O.T. ADJUSTED')
	  T1=T1+TEMP/WNORM
	END IF

	IF (DONE) GOTO 510

C--OPTIONALLY LIST ALL STATIONS NOW
C--VAX VERSION ONLY
C	IF (KPRINT.GT.5 .AND. LPRT) 
C	2 CALL HYLST (STANAM,A,W,R,IMPORT,MTCAL)

C+++++++++++++++++++++ ADJUST HYPOCENTER +++++++++++++++++++++

	T1=T1+Y(1)
	CLAT=CLAT+Y(2)/111.19
	CLON=CLON+Y(3)/(111.19*COS(CLAT/RDEG))
	Z1=Z1+Y(4)

C--FREE THE FOCAL DEPTH ON NEXT ITER IF ADJUSTMENT IS SMALL ENOUGH
C  AND THE DEPTH IS NOT PERMANENTLY FIXED
	NLAST=N
	N=3
	IF (RR.LT.DXFIX .AND. .NOT.ZFIX) THEN
	  IF (LMESS .AND. LZFIX) WRITE (15,1230)
1230	  FORMAT (' FREE DEPTH')
	  LZFIX=.FALSE.
	END IF
C--SOLVE FOR DEPTH IF IT IS NOT FIXED
	IF (.NOT.LZFIX) N=N+1

	GOTO 30

C*************** END ITERATION LOOP ***************************

C--ABANDON SOLUTION WITH INSUFFICIENT DATA
C--OUTPUT STATIONS HERE, SINCE IT WILL NOT BE DONE FROM MAIN PROG
500	IF (LPRT) WRITE (15,1052) NWR,LOCNUM
	IF (LERR) WRITE (6,1052) NWR,LOCNUM
1052	FORMAT (1X,I1' PHASES CANT SOLVE NO.'I5)

C--FLAG THIS EVENT IF IT HAD CONVERGENCE PROBLEMS
510	IF (ITR.GT.ITRLIM .OR. NFREE.LT.4 .OR. CONERR) RMK2='*'
	RETURN
	END
	SUBROUTINE HYTRT (A,KDHR,KT)
C--GIVEN DEPTH AND DISTANCE, THIS ROUTINE CALCULATES TRAVEL TIME AND ITS
C--DERIVATIVES, AND EMERGENCE ANGLE AT THE SOURCE FOR ALL ARRIVALS.
C--HYTRT USES A CONDENSED AND REDUCED TRAVEL TIME TABLE GENERATED 
C--BY THE PROGRAM TTGEN.
C--IND AND KINDX ARE INDEXING ARRAYS NECESSARY TO REFERENCE THE CORRECT
C--ELEMENTS OF THE STATION ARRAYS.

c$INCLUDE:'HYPCOMC.'
      include 'hypcomc.inc'
      INCLUDE 'hypcomt.inc'
      include 'hypcom.inc'
c$INCLUDE:'HYPCOM.'
C	VIRTUAL A(MMAX,5)	!PC350 VERSION
	DIMENSION A(MMAX,5)

C--THESE VALUES ARE PASSED BY THE ARRAY A.
C DTDR	!TT DERIVATIVE WRT DISTANCE
C DTDZ	!TT DERIVATIVE WRT DEPTH
C T	!TRAVEL TIME
C AIN	!ANGLE OF EMERGENCE AT THE SOURCE, MEASURED IN DEGREES FROM NADIR.

	DIMENSION VH(LN)	
C !VELOCITY AT HYPOCENTER
	DIMENSION DHRZ(LN)	
C !DIST AT WHICH HORIZ RAY EMERGES
	DIMENSION TZ(LN,42)	
C !TT AT EACH DISTANCE POINT
	DIMENSION DTZ(LN,42)	
C !TT DEPTH DERIV AT EACH DISTANCE POINT
	DATA SCFAC/2000./

C--LOOP OVER THE LN POSSIBLE MODELS, SKIPPING LOOP IF MODEL NOT USED.
	DO 35 MD=1,LN
	IF (MODTYP(MD).NE.0) GOTO 35

C--PERFORM SOME PRELIMINARY CALCS AND INTERPOLATIONS WHICH DEPEND ONLY ON
C  DEPTH. DO THIS FOR EACH LINEAR GRAD MODEL ONCE.
	NZM=NZ(MD)
	NZ1M=NZ1(MD)
	NZ2M=NZ2(MD)
	DZ1M=DZ1(MD)
	DZ2M=DZ2(MD)
	LAYM=LAY(MD)
	ND1M=ND1(MD)

C--PERFORM DEPTH INTERPOLATION FIRST
C--FIND DEPTH INDEX = INDEX OF TABLE ENTRY NEAREST HYPOCENTER
C--ALSO DEPTH SPACING H AND FRACTION OF INTERVAL X
	TEMP=NZ1M*DZ1M
	IF ((.NOT.GZ1(MD) .OR. Z1.GT.TEMP) .AND. GD2(MD)) THEN
C--HYPO IN LOWER PART OF TABLE
	  I=NZ1M+(Z1-TEMP)/DZ2M+1.5001
	  IF (I.GE.NZM) I=NZM-1
	  IF (I.LT.NZ1M+2) I=NZ1M+2
	  H=DZ2M
	  X=(Z1-TEMP)/DZ2M-(I-NZ1M-1)
	ELSE
C--HYPO IN UPPER PART OF TABLE
	  I=Z1/DZ1M+1.5
	  IF (I.GT.NZ1M) I=NZ1M
	  IF (I.LT.2) I=2
	  H=DZ1M
	  X=Z1/DZ1M-(I-1)
	END IF

C--FIND EXACT VELOCITY AT HYPOCENTER
	DO 20 K=1,LAYM
	IF (D(K,MD).LT.Z1) L=K
20	CONTINUE
	VH(MD)=VEL(LAYM,MD)
	IF (L.LT.LAYM) VH(MD)=VEL(L,MD)+(VEL(L+1,MD)-VEL(L,MD))
     2 *(Z1-D(L,MD))/(D(L+1,MD)-D(L,MD))

C--INTERPOLATE DIST AT WHICH A HORIZONTAL RAY EMERGES
	DHRZ(MD)=(KDHR(MD,I)+X*(KDHR(MD,I+1)-KDHR(MD,I)))*.1

C--DEPTH INTERPOLATION
	IF (Z1.LE.TEMP+DZ2M*NZ2M) THEN
C--USE 3 POINT INTERPOLATION
	  CA=X*.5*(X-1.)
	  CB=1.-X**2
	  CC=X*.5*(X+1.)
	  DA=(X-.5)/H
	  DB=-2.*X/H
	  DC=(X+.5)/H
	ELSE
C--USE LINEAR EXTRAPOLATION
	  CA=0.
	  CB=1.-X
	  CC=X
	  DA=0.
	  DC=1./H
	  DB=-DC
	  DHRZ(MD)=1000.
	END IF

C--INTERPOLATE TT AND ITS DEPTH DERIVATIVE FOR ALL DISTANCE GRID POINTS
	TEMP=ND1M*DD1(MD)
	DO 30 J=1,ND(MD)
	DX=(J-1)*DD1(MD)
	IF (J.GT.ND1M+1) DX=TEMP+(J-ND1M-1)*DD2(MD)
	TZ(MD,J)=(CA*KT(MD,I-1,J)+CB*KT(MD,I,J)
     2 +CC*KT(MD,I+1,J)+32000.)/SCFAC+DX*REDV(MD)
30	DTZ(MD,J)=(DA*KT(MD,I-1,J)+DB*KT(MD,I,J)+DC*KT(MD,I+1,J))/SCFAC
35	CONTINUE

C--NOW FIND TRAVEL TIME, DTDR, DTDZ, AND ANGLE OF EMERGENCE FOR EACH ARRIVAL
C--LOOP OVER ALL ARRIVALS
	DO 60 I=1,M

C--FIND STATION INDEX 
	KI=IND(I)
	KPS=KI/10000
	KI=KI-10000*KPS
	J=KINDX(KI)

C--DETERMINE MODEL FOR THIS STATION
	MD=JMOD(J)
C--REMOVE WEIGHT FLAG
	J=MD/100
	MD=MD-100*J
C--DETERMINE P & S MODEL NUMBERS
	MODP=MD/10
	MODS=MD-10*MODP
	MD=MODP
	IF (KPS.EQ.1) MD=MODS

C--CALC TRAVELTIME ONLY IF A LINEAR GRADIENT MODEL IS USED FOR THIS STA.
	IF (MODTYP(MD).NE.0) GOTO 60

C--START DISTANCE INTERPOLATION
	NDM=ND(MD)
	ND1M=ND1(MD)
	ND2M=ND2(MD)
	DD1M=DD1(MD)
	DD2M=DD2(MD)
	TEMP=ND1M*DD1M

C--FIND STATION DISTANCE
	DX=KDIS(KI)*.05

C--FIND DISTANCE INDEX = INDEX OF TABLE ENTRY NEAREST THE STATION DIST
C--ALSO DISTANCE SPACING H AND FRACTION OF INTERVAL X
	IF ((.NOT.GD1(MD) .OR. DX.GT.TEMP) .AND. GD2(MD)) THEN
C--HYPO IN FAR PART OF TABLE
	  J=ND1M+(DX-TEMP)/DD2M+1.5001
	  IF (J.GE.NDM) J=NDM-1
	  IF (J.LT.ND1M+2) J=ND1M+2
	  H=DD2M
	  X=(DX-TEMP)/DD2M-(J-ND1M-1)
	ELSE
C--HYPO IN NEAR PART OF TABLE
	  J=DX/DD1M+1.5
	  IF (J.GT.ND1M) J=ND1M
	  IF (J.LT.2) J=2
	  H=DD1M
	  X=DX/DD1M-(J-1)
	END IF

C--DISTANCE INTERPOLATION
	IF (DX.LE.TEMP+DD2M*ND2M) THEN
C--USE 3 POINT INTERPOLATION
	  CA=X*.5*(X-1.)
	  CB=1.-X**2
	  CC=X*.5*(X+1.)
	  DA=X-.5
	  DB=-2.*X
	  DC=X+.5
	ELSE
C--USE LINEAR EXTRAPOLATION
	  CA=0.
	  CB=1.-X
	  CC=X
	  DA=0.
	  DC=1.
	  DB=-1.
	END IF

C--INTERPOLATE TT AND ITS 2 DERIVATIVES
	A(I,2)=CA*TZ(MD,J-1)+CB*TZ(MD,J)+CC*TZ(MD,J+1)
	A(I,4)=CA*DTZ(MD,J-1)+CB*DTZ(MD,J)+CC*DTZ(MD,J+1)
	DTDR=(DA*TZ(MD,J-1)+DB*TZ(MD,J)+DC*TZ(MD,J+1))/H
	IF (DTDR.LT.0.) DTDR=0.
	A(I,3)=DTDR

C--CALC EMERGENCE ANGLE
	CA=VH(MD)*DTDR
	IF (CA.GT..99999) CA=.99999
	AIN=RDEG*ASIN(CA)
	IF (DX.LT.DHRZ(MD)) AIN=180.-AIN
	A(I,1)=AIN

C--END OF LOOP OVER ARRIVALS
60	CONTINUE
	RETURN
	END
	SUBROUTINE HYTRH (A)
C--GIVEN DEPTH & DISTANCE, THIS ROUTINE CALCULATES TRAVEL TIME, ITS
C--DERIVATIVES AND EMERGENCE ANGLES AT THE SOURCE FOR ALL ARRIVALS.
C  USES HOMOGENEOUS LAYER VELOCITY MODELS & ALGORITHMS OF HYPOLAYR/HYPO71

c$INCLUDE:'HYPCOMC.'
c$INCLUDE:'HYPCOM.'
      include 'hypcomc.inc'
      include 'hypcom.inc'

C	VIRTUAL A(MMAX,5)	!PC350 VERSION
	DIMENSION A(MMAX,5)	
	DIMENSION TINJ(13),DIDJ(13),TR(12)

C--THE FOLLOWING ARE PASSED THRU THE ARRAY A:
C DTDR	!TT DERIV WRT DISTANCE
C DTDZ	!TT DERIV WRT DEPTH
C T	!TRAVEL TIME
C AIN	!ANGLE OF EMERGENCE AT SOURCE

	ZSQ=Z1*Z1

C--LOOP OVER ALL ARRIVALS
	DO 280 I=1,M
C--FIND STATION INDEX AND REMOVE KPS AS AN S FLAG
	KI=IND(I)
	KPS=KI/10000
	KI=KI-10000*KPS
	J=KINDX(KI)

C--FIND STATION MODEL 
	MD=JMOD(J)
	J=MD/100
	MD=MD-100*J
C--DETERMINE P & S MODEL NUMBERS
	MODP=MD/10
	MODS=MD-10*MODP
	MD=MODP
	IF (KPS.EQ.1) MD=MODS

C--CALC TRAVEL TIME ONLY IF A LAYER MODEL IS USED FOR THIS STATION
	IF (MODTYP(MD).NE.1) GOTO 270

C--FIND STATION DISTANCE
	DX=KDIS(KI)*.05

C--JL IS THE LAYER IN WHICH THE HYPOCENTER LIES
	NL=LAY(MD)
	DO 10 L=1,NL
	IF (D(L,MD).GT.Z1) THEN
	  JJ=L
	  JL=L-1
	  GOTO 30
	END IF
10	CONTINUE
	JL=NL

C--CALC SOME BASIC PARAMETERS FOR THIS MODEL
30	TKJ=Z1-D(JL,MD)
	TKJSQ=TKJ**2+0.000001
C--IF HYPO IS IN HALFSPACE (BOT LAYER), THEN ALL RAYS GO UP
	IF (JL.EQ.NL) GOTO 100
	TMIN=999.99

C--DETERMINE DIST OF CLOSEST CRITICALLY REFRACTED RAY XOVMAX
	DO 40 L=JJ,NL
	SQT=SQRT(VSQ(L,MD)-VSQ(JL,MD))
	TINJ(L)=HYTID(JL,L,MD)-TKJ*SQT/(VEL(L,MD)*VEL(JL,MD))
40	DIDJ(L)=HYDID(JL,L,MD)-TKJ*VEL(JL,MD)/SQT
	XOVMAX=VEL(JJ,MD)*VEL(JL,MD)*(TINJ(JJ)-HYTID(JL,JL,MD))/
     2 (VEL(JJ,MD)-VEL(JL,MD))

	DO 70 L=JJ,NL
	TR(L)=TINJ(L)+DX/VEL(L,MD)
	IF (TR(L).GT.TMIN .OR. DIDJ(L).GT.DX) GOTO 70
	K=L
	TMIN=TR(L)
70	CONTINUE
	IF (DX .LT. XOVMAX) GO TO 90

C--TRAVEL TIME & DERIVATIVES FOR REFRACTED WAVE
80	T=TR(K)
	DTDR=1.0/VEL(K,MD)
	DTDZ=-SQRT(VSQ(K,MD)-VSQ(JL,MD))/(VEL(K,MD)*VEL(JL,MD))
	ANIN=-VEL(JL,MD)/VEL(K,MD)
	GO TO 260

C--DIRECT WAVE WITH EARTHQ IN TOP LAYER
90	IF (JL.NE.1) GOTO 100
	SQT=SQRT(ZSQ+DX**2)
	TDJ1=SQT/VEL(1,MD)
	IF (TDJ1 .GE. TMIN) GO TO 80

C--TRAVEL TIME & DERIVATIVES FOR DIRECT WAVE IN FIRST LAYER
	T=TDJ1
	DTDR=DX/(VEL(1,MD)*SQT)
	DTDZ=Z1/(VEL(1,MD)*SQT)
	ANIN=DX/SQT
	GO TO 260

C--FIND A DIRECT WAVE THAT WILL EMERGE AT THE STATION
100	XBIG=DX
	XLIT=DX*TKJ/Z1
	UB=XBIG/SQRT(XBIG**2+TKJSQ)
	UL=XLIT/SQRT(XLIT**2+TKJSQ)
	UBSQ=UB**2
	ULSQ=UL**2
	DELBIG=TKJ*UB/SQRT(1.000001-UBSQ)
	DELLIT=TKJ*UL/SQRT(1.000001-ULSQ)
	J1=JL-1
	DO 110 L=1,J1
	DELBIG=DELBIG+(THK(L,MD)*UB)/SQRT(VSQ(JL,MD)/VSQ(L,MD)-UBSQ)
110	DELLIT=DELLIT+(THK(L,MD)*UL)/SQRT(VSQ(JL,MD)/VSQ(L,MD)-ULSQ)

C--SHOOT UP TO 25 RAYS TO ITERATIVELY FIND THE STATION BY TRAPPING
C--IT BETWEEN TWO RAYS
	DO 170 LL=1,25
	XTEST=DELBIG-DELLIT
	IF (XTEST.LT..02) GOTO 180
	XTR=XLIT+(DX-DELLIT)*(XBIG-XLIT)/XTEST
	U=XTR/SQRT(XTR**2+TKJSQ)
	USQ=U**2
	DELXTR=TKJ*U/SQRT(1.000001-USQ)
	DO 120 L=1,J1
120	DELXTR=DELXTR+(THK(L,MD)*U)/SQRT(VSQ(JL,MD)/VSQ(L,MD)-USQ)
	XTEST=DX-DELXTR
C--STATION IS FOUND WHEN RAY IS WITHIN .02 KM
	IF (ABS(XTEST) .LE. 0.02) GOTO 190
	IF (XTEST.LT.0.) THEN
	  XBIG=XTR
	  DELBIG=DELXTR
	ELSE
	  XLIT=XTR
	  DELLIT=DELXTR
	END IF
	IF (LL.GT.10 .AND. U.GT..9999) GOTO 190
170	CONTINUE

180	XTR=0.5*(XBIG+XLIT)
	U=XTR/SQRT(XTR**2+TKJSQ)
	USQ=U**2

C--IF U IS TOO NEAR 1, COMPUTE TDIR AS WAVE ALONG THE TOP OF LAYER JL
190	IF (U.GT..9999) THEN
	  TDC=HYTID(JL,JL,MD)+DX/VEL(JL,MD)
	  IF (JL.NE.NL .AND. TDC.GE.TMIN) GO TO 80
	  T=TDC
	  DTDR=1./VEL(JL,MD)
	  DTDZ=0.
	  ANIN=0.99999
	  GOTO 260
	END IF

C--TRAVEL TIME & DERIVATIVES FOR DIRECT WAVE BELOW FIRST LAYER
	TDIR=TKJ/(VEL(JL,MD)*SQRT(1.-USQ))
	DO 240 L=1,J1
240	TDIR=TDIR+(THK(L,MD)*VEL(JL,MD))/(VSQ(L,MD)*SQRT(VSQ(JL,MD)/
     2 VSQ(L,MD)-USQ))
	IF(JL.NE.NL .AND. TDIR.GE.TMIN) GOTO 80
	T=TDIR
	SRR=SQRT(1.-USQ)
	SRT=SRR**3
	ALFA=TKJ/SRT
	BETA=TKJ*U/(VEL(JL,MD)*SRT)
	DO 250 L=1,J1
	STK=(SQRT(VSQ(JL,MD)/VSQ(L,MD)-USQ))**3
	VTK=THK(L,MD)/(VSQ(L,MD)*STK)
	ALFA=ALFA+VTK*VSQ(JL,MD)
250	BETA=BETA+VTK*VEL(JL,MD)*U
	DTDR=BETA/ALFA
	DTDZ=(1.-VEL(JL,MD)*U*DTDR)/(VEL(JL,MD)*SRR)
	ANIN=U
260	AIN=RDEG*ASIN(ANIN)
	IF (AIN.LT.0.) AIN=AIN+180.
	AIN=180.-AIN

C--END OF STATION LOOP
270	A(I,1)=AIN
	A(I,2)=T
	A(I,3)=DTDR
280	A(I,4)=DTDZ

	RETURN
	END
	SUBROUTINE HYSOL (A,N,NLAST,Y,NFREE,LZFIX,W,R,IMPORT,MTCAL)
C--USES SVD TO INVERT THE PARTIAL DERIV MATRIX A FOR THE HYPO ADJUSTMENT
C--VECTOR Y. ALSO CALCULATES EIGENVALUES, EIGENVECTORS, COVARIANCE,
C--IMPORTANCE, AND ERROR ELLIPSE.
	LOGICAL WITHU,LZFIX
c$INCLUDE:'HYPCOM.'
c$INCLUDE:'HYPCOMA.'
      include 'hypcom.inc'
      include 'hypcoma.inc'

	DIMENSION Y(4),V3(3,3),TSVD(MMAX)
	WITHU=DONE .AND. (LPRT.OR.LARC)
	DO 2 I=1,4
2	EIGVAL(I)=0.

C--OBTAIN THE SVD OF MATRIX A.
C--THE DATA VECTOR OF TT RESIDUALS R IS INPUT IN THE N+1ST COL OF A.
C--A IS REPLACED BY U AND R IS REPLACED BY UT*R IN SVD.
	CALL HYSVD (A,EIGVAL,V,MMAX,4,M,N,1,WITHU,.TRUE.,TSVD)

C--NFREE IS THE ACTUAL DEGREES OF FREEDOM USED
C--(THE NO. OF EIGENVALUES > EIGTOL)
	NFREE=0
	DO 5 I=1,N
	IF (EIGVAL(I).GT.EIGTOL) NFREE=NFREE+1
5	CONTINUE

C--CALCULATE ADJUSTMENT VECTOR Y AS V*S**-1*(UT*R)
	DO 10 I=1,4
	Y(I)=0.
	IF (I.GT.N) GO TO 10
	DO 8 J=1,NFREE
8	Y(I)=Y(I)+V(I,J)*A(J,N+1)/EIGVAL(J)
10	CONTINUE

C--DAMP THE ADJUSTMENT VECTOR
C--USE EXTRA DAMPING IF THE SOLUTION IS NOT CONVERGING QUICKLY
	I=ITRLIM*.6
	TEMP=DAMP
	IF (ITR.GT.I) TEMP=.5*DAMP
	DO 11 I=1,4
11	Y(I)=Y(I)*TEMP

C--CALCULATE IMPORTANCE VECTOR AS TRACE OF INFORMATION MATRIX U*UT
	IF (WITHU) THEN
	  DO 15 I=1,M
	  TEMP=0.
	  DO 12 J=1,N
12	  TEMP=TEMP+A(I,J)**2
15	  IMPORT(I)=TEMP*1000.
	END IF

C--FIND LENGTH OF HYPO ADJ VECTOR IN KM
	RR=0.
	DO 25 I=2,N
25	RR=RR+Y(I)**2
	RR=SQRT(RR)

C--SKIP THE REMAINING CALCS IF THEY ARE NOT NEEDED FOR FINAL OUTPUT
	IF (.NOT.DONE .AND. KPRINT.LT.5) GO TO 110
C--CALCULATE COVARIANCE MATRIX AS SIGMA**2 * V * EIGVAL**-2 * VT
C--ESTIMATED ARRIVAL TIME ERROR
	SIGSQ=RDERR**2+ERCOF*RMS**2
	TEMP=EIGTOL**2
	DO 52 I=1,4
	DO 50 J=1,I
	COVAR(I,J)=0.
	IF (I.GT.N .OR. J.GT.N) THEN
	  IF (I.EQ.J) COVAR(I,J)=999.
	  GO TO 50
	END IF
	DO 45 L=1,N
45	COVAR(I,J)=COVAR(I,J)+V(I,L)*V(J,L)/(EIGVAL(L)**2+TEMP)
	COVAR(I,J)=SIGSQ*COVAR(I,J)
50	COVAR(J,I)=COVAR(I,J)
52	CONTINUE

C--EVALUATE THE HYPOCENTER ERROR ELLIPSE BY DIAGONALIZING
C--THE SPATIAL PART OF THE COVARIANCE MATRIX
C--USE A AS TEMPORARY STORAGE
	DO 57 I=1,3
	DO 55 J=1,3
55	A(I,J)=COVAR(I+1,J+1)
57	CONTINUE
	CALL HYSVD (A,SERR,V3,MMAX,3,3,3,0,.FALSE.,.TRUE.,TSVD)
	DO 60 I=1,3
	SERR(I)=SQRT(SERR(I))
	IF (SERR(I).GT.99.) SERR(I)=99.
60	CONTINUE

C--COMPUTE ERH AND ERZ AS THE LARGEST OF THE HORIZ AND VERTICAL
C--PROJECTIONS OF THE PRINCIPAL STANDARD ERRORS
	ERH=0.
	ERZ=0.
	DO 65 I=1,3
	TEMP=SERR(I)*SQRT(V3(1,I)**2+V3(2,I)**2)
	IF (TEMP.GT.ERH) ERH=TEMP
	TEMP=SERR(I)*ABS(V3(3,I))
	IF (TEMP.GT.ERZ) ERZ=TEMP
65	CONTINUE
	IF (ERZ.GT.99.) ERZ=99.
	IF (ERH.GT.99.) ERH=99.

C--NOW CALC THE ORIENTATIONS OF THE PRINCIPAL STD ERRORS
	DO 90 J=1,3
	IAZ(J)=0
	IDIP(J)=90
	TEMP=SQRT(V3(1,J)**2+V3(2,J)**2)
	IF (TEMP.EQ.0.) GO TO 90
	IAZ(J)=RDEG*ATAN2(-V3(2,J),V3(1,J))
	IDIP(J)=RDEG*ATAN2(V3(3,J),TEMP)
	IF (IDIP(J).LT.0) THEN
	  IDIP(J)=-IDIP(J)
	  IAZ(J)=IAZ(J)+180
	END IF
	IF (IAZ(J).LT.0) IAZ(J)=IAZ(J)+360
90	CONTINUE
110	RETURN
	END


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c
c   changes
c
c   nov 93 by jh : include files tolower case and name to .inc
c                  disable ovsi output
c
C     *********************  START OF SVD  *****************************

      SUBROUTINE  HYSVD  (A, S, V, MMAX, NMAX, M, N, P, WITHU, WITHV,T)

C--NOTE THAT FOR USE IN HYPOINVERSE:
C-(1) THE TEMPORARY T IS DIMENSIONED T(MMAX) IN THE CALLING ROUTINE.
C-(2) THE NUMBER OF COLUMNS OF A IS NPMAX = NMAX + PMAX. SINCE PMAX
C-IS 1 AND NMAX IS 4, NPMAX = 5.
	PARAMETER (NPMAX=5)

      INTEGER    MMAX, NMAX, M, N, P
      REAL       R, W, CS, SN, TOL, F, X, EPS, G, T, Y
      REAL       ETA, H, Q, Z
      INTEGER    I, J, K, L, L1, N1, NP
      LOGICAL    WITHU, WITHV
      DIMENSION       S(NMAX), V(NMAX,NMAX), T(MMAX)

	DIMENSION A(MMAX,NPMAX)	
C !VAX VERSION
C	VIRTUAL A(MMAX,NPMAX)	

C     ------------------------------------------------------------------

C     THIS IS A TRANSLATION OF A CDC 6600 FORTRAN PROGRAM TO IBM 360
C     FORTRAN IV.  THIS SUBROUTINE USES SHORT PRECISION ARITHMETIC.
C     A LONG PRECISION VERSION IS AVAILABLE UNDER THE NAME 'DSVD'.

C     THIS SUBROUTINE REPLACES EARLIER SUBROUTINES WITH THE SAME NAME,
C    689   6       &   &0&  S OF A COMPLEX AR&THMETIC PROGRAM, PUBLISHED
C     AS ALGORITHM 358.  THIS CURRENT PROGRAM IS FASTER, MORE ACCURATE
C     AND LESS OBSCURE IN DESCRIBING ITS CAPABILITIES.

C     ORIGINAL PROGRAMMER=  R. C. SINGLETON
C     360 VERSION BY=       J. G. LEWIS
C     LAST REVISION OF THIS SUBROUTINE=  4 DECEMBER 1973

C     ------------------------------------------------------------------

C     ADDITIONAL SUBROUTINE NEEDED=  ROTATE
C--THE HYROT SUBROUTINE WAS ELIMINATED TO PERMIT USE OF VIRTUAL ARRAYS

C     ------------------------------------------------------------------


C     THIS SUBROUTINE COMPUTES THE SINGULAR VALUE DECOMPOSITION
C     OF A REAL M*N MATRIX A, I.E. IT COMPUTES MATRICES U, S, AND V
C     SUCH THAT
C
C                  A = U * S * VT ,
C     WHERE
C              U IS AN M*N MATRIX AND UT*U = I, (UT=TRANSPOSE
C                                                    OF U),
C              V IS AN N*N MATRIX AND VT*V = I, (VT=TRANSPOSE
C                                                    OF V),
C        AND   S IS AN N*N DIAGONAL MATRIX.
C
C     DESCRIPTION OF PARAMETERS=
C
C     A = REAL ARRAY. A CONTAINS THE MATRIX TO BE DECOMPOSED.
C         THE ORIGINAL DATA ARE LOST.  IF WITHV=.TRUE., THEN
C         THE MATRIX U IS COMPUTED AND STORED IN THE ARRAY A.
C
C     MMAX = INTEGER VARIABLE.  THE NUMBER OF ROWS IN THE
C            ARRAY A.
C
C     NMAX = INTEGER VARIABLE.  THE NUMBER OF ROWS IN THE
C            ARRAY V.
C
C     M,N = INTEGER VARIABLES.  THE NUMBER OF ROWS AND COLUMNS
C           IN THE MATRIX STORED IN A.  (N<=M<=100.  IF IT IS
C           NECESSARY TO SOLVE A LARGER PROBLEM, THEN THE
C           AMOUNT OF STORAGE ALLOCATED TO THE ARRAY T MUST
C           BE INCREASED ACCORDINGLY.)  IF M<N , THEN EITHER
C           TRANSPOSE THE MATRIX A OR ADD ROWS OF ZEROS TO
C           INCREASE M TO N.
C
C     P = INTEGER VARIABLE.  IF P>0, THEN COLUMNS N+1, . . . ,
C         N+P OF A ARE ASSUMED TO CONTAIN THE COLUMNS OF AN M*P
C         MATRIX B.  THIS MATRIX IS MULTIPLIED BY UT, AND UPON
C         EXIT, A CONTAINS IN THESE SAME COLUMNS THE N*P MATRIX
C         UT*B. (P>=0)
C
C     WITHU, WITHV = LOGICAL VARIABLES.  IF WITHU=.TRUE., THEN
C         THE MATRIX U IS COMPUTED AND STORED IN THE ARRAY A.
C         IF WITHV=.TRUE., THEN THE MATRIX V IS COMPUTED AND
C         STORED IN THE ARRAY V.
C
C     S = REAL ARRAY.  S(1), . . . , S(N) CONTAIN THE DIAGONAL
C         ELEMENTS OF THE MATRIX S ORDERED SO THAN S(I)>=S(I+1),
C         I=1, . . . , N-1.
C
C     V = REAL ARRAY.  V CONTAINS THE MATRIX V.  IF WITHU
C         AND WITHV ARE NOT BOTH =.TRUE., THEN THE ACTUAL
C         PARAMETER CORRESPONDING TO A AND V MAY BE THE SAME.
C
C     THIS SUBROUTINE IS A REAL VERSION OF A FORTRAN SUBROUTINE
C     BY BUSINGER AND GOLUB, ALGORITHM 358=  SINGULAR VALUE
C     DECOMPOSITION OF A COMPLEX MATRIX, COMM. ACM, V. 12,
C     NO. 10, PP. 564-565 (OCT. 1969).
C     WITH REVISIONS BY RC SINGLETON, MAY 1972.
C     ------------------------------------------------------------------


C    ECLIPSE CONSTANTS
      DATA ETA,TOL/1.9E-7,1.1E-30/

C     DATA ETA,TOL /1.5E-15,1.E-250/


C     ETA (16**-6) AND TOL (16**-59) ARE MACHINE DEPENDENT CONSTANTS
C     FOR IBM 360/370 COMPUTERS (SHORT FORM ARITHMETIC).
C     ETA IS THE MACHINE EPSILON (RELATIVE ACCURACY)!
C     TOL IS THE SMALLEST REPRESENTABLE REAL DIVIDED BY ETA.

      NP = N + P
      N1 = N + 1

C     HOUSEHOLDER REDUCTION TO BIDIAGONAL FORM
      G = 0.0
      EPS = 0.0
      L = 1
   10 T(L) = G
      K = L
      L = L + 1

C     ELIMINATION OF A(I,K), I=K+1, . . . , M
      S(K) = 0.0
      Z = 0.0
      DO 20 I = K,M
   20    Z = Z + A(I,K)**2
      IF (Z.LT.TOL) GOTO 50
      G = SQRT(Z)
      F = A(K,K)
      IF (F.GE.0.0) G = - G
      S(K) = G
      H = G * (F - G)
      A(K,K) = F - G
      IF (K.EQ.NP) GOTO 50
      DO 40 J = L,NP
         F = 0
         DO 30 I = K,M
   30       F = F + A(I,K)*A(I,J)
         F = F/H
         DO 40 I = K,M
   40       A(I,J) = A(I,J) + F*A(I,K)

C     ELIMINATION OF A(K,J), J=K+2, . . . , N
   50 EPS = AMAX1(EPS,ABS(S(K)) + ABS(T(K)))
      IF (K.EQ.N) GOTO 100
      G = 0.0
      Z = 0.0
      DO 60 J = L,N
   60    Z = Z + A(K,J)**2
      IF (Z.LT.TOL) GOTO 10
      G = SQRT(Z)
      F = A(K,L)
      IF (F.GE.0.0) G = - G
      H = G * (F - G)
      A(K,L) = F - G
      DO 70 J = L,N
   70    T(J) = A(K,J)/H
      DO 90 I = L,M
         F = 0
         DO 80 J = L,N
   80       F = F + A(K,J)*A(I,J)
         DO 90 J = L,N
   90       A(I,J) = A(I,J) + F*T(J)

      GOTO 10

C     TOLERANCE FOR NEGLIGIBLE ELEMENTS
  100 EPS = EPS*ETA

C     ACCUMULATION OF TRANSFORMATIONS
      IF (.NOT.WITHV) GOTO 160
      K = N
      GOTO 140
  110    IF (T(L).EQ.0.0) GOTO 140
         H = A(K,L)*T(L)
         DO 130 J = L,N
            Q = 0
            DO 120 I = L,N
  120          Q = Q + A(K,I)*V(I,J)
            Q = Q/H
            DO 130 I = L,N
  130          V(I,J) = V(I,J) + Q*A(K,I)
  140    DO 150 J = 1,N
  150       V(K,J) = 0
         V(K,K) = 1.0
         L = K
         K = K - 1
         IF (K.NE.0) GOTO 110

  160 K = N
      IF (.NOT.WITHU) GOTO 230
      G = S(N)
      IF (G.NE.0.0) G = 1.0/G
      GO TO 210
  170    DO 180 J = L,N
  180       A(K,J) = 0
         G = S(K)
         IF (G.EQ.0.0) GOTO 210
         H = A(K,K)*G
         DO 200 J = L,N
            Q = 0
            DO 190 I = L,M
  190          Q = Q + A(I,K)*A(I,J)
            Q = Q/H
            DO 200 I = K,M
  200          A(I,J) = A(I,J) + Q*A(I,K)
         G = 1.0/G
  210    DO 220 J = K,M
  220       A(J,K) = A(J,K)*G
         A(K,K) = A(K,K) + 1.0
         L = K
         K = K - 1
         IF (K.NE.0) GOTO 170

C     QR DIAGONALIZATION
      K = N

C     TEST FOR SPLIT
  230    L = K
  240       IF (ABS(T(L)).LE.EPS) GOTO 290
            L = L - 1
            IF (ABS(S(L)).GT.EPS) GOTO 240

C     CANCELLATION
         CS = 0.0
         SN = 1.0
         L1 = L
         L = L + 1
         DO 280 I = L,K
            F = SN*T(I)
            T(I) = CS*T(I)
            IF (ABS(F).LE.EPS) GOTO 290
            H = S(I)
            W = SQRT(F*F + H*H)
            S(I) = W
            CS = H/W
            SN = - F/W
C           IF (WITHU) CALL HYROT(A(1,L1), A(1,I), CS, SN, M)
	    IF (WITHU) THEN
		DO 260 JJ=1,M
		XX=A(JJ,L1)
		YY=A(JJ,I)
		A(JJ,L1)=XX*CS + YY*SN
260		A(JJ,I)= YY*CS - XX*SN
	    END IF
            IF (NP.EQ.N) GOTO 280
            DO 270 J = N1,NP
               Q = A(L1,J)
               R = A(I,J)
               A(L1,J) = Q*CS + R*SN
 270         A(I,J) = R*CS - Q*SN
  280       CONTINUE

C     TEST FOR CONVERGENCE
  290    W = S(K)
         IF (L.EQ.K) GOTO 360

C     ORIGIN SHIFT
         X = S(L)
         Y = S(K-1)
         G = T(K-1)
         H = T(K)
         F = ((Y - W)*(Y + W) + (G - H)*(G + H))/(2.0*H*Y)
         G = SQRT(F*F + 1.0)
         IF (F.LT.0.0) G = - G
         F = ((X - W)*(X + W) + (Y/(F + G) - H)*H)/X

C     QR STEP
         CS = 1.0
         SN = 1.0
         L1 = L + 1
         DO 350 I = L1,K
            G = T(I)
            Y = S(I)
            H = SN*G
            G = CS*G
            W = SQRT(H*H + F*F)
            T(I-1) = W
            CS = F/W
            SN = H/W
            F = X*CS + G*SN
            G = G*CS - X*SN
            H = Y*SN
            Y = Y*CS
C           IF (WITHV) CALL HYROT(V(1,I-1), V(1,I), CS, SN, N)
	    IF (WITHV) THEN
		DO 320 JJ=1,N
		XX=V(JJ,I-1)
		YY=V(JJ,I)
		V(JJ,I-1)=XX*CS + YY*SN
320		V(JJ,I)=  YY*CS - XX*SN
	    END IF
            W = SQRT(H*H + F*F)
            S(I-1) = W
            CS = F/W
            SN = H/W
            F = CS*G + SN*Y
            X = CS*Y - SN*G
C           IF (WITHU) CALL HYROT(A(1,I-1), A(1,I), CS, SN, M)
	    IF (WITHU) THEN
		DO 330 JJ=1,M
		XX=A(JJ,I-1)
		YY=A(JJ,I)
		A(JJ,I-1)=XX*CS + YY*SN
330		A(JJ,I)=  YY*CS - XX*SN
	    END IF
            IF (N.EQ.NP) GOTO 350
            DO 340 J = N1,NP
               Q = A(I-1,J)
               R = A(I,J)
               A(I-1,J) = Q*CS + R*SN
 340  A(I,J) = R*CS - Q*SN
  350       CONTINUE

         T(L) = 0.0
         T(K) = F
         S(K) = X
         GOTO 230

C     CONVERGENCE
  360    IF (W.GE.0.0) GOTO 380
         S(K) = - W
         IF (.NOT.WITHV) GOTO 380
         DO 370 J = 1,N
  370       V(J,K) = - V(J,K)
  380    K = K - 1
         IF (K.NE.0) GO TO 230

C     SORT SINGULAR VALUES
      DO 450 K = 1,N
         G = -1.0
         DO 390 I = K,N
            IF (S(I).LT.G) GOTO 390
            G = S(I)
            J = I
  390       CONTINUE
      IF (J .EQ. K) GO TO 450
      S(J) = S(K)
         S(K) = G
         IF (.NOT.WITHV) GOTO 410
         DO 400 I = 1,N
            Q = V(I,J)
            V(I,J) = V(I,K)
  400       V(I,K) = Q
  410    IF (.NOT.WITHU) GOTO 430
         DO 420 I = 1,M
            Q = A(I,J)
            A(I,J) = A(I,K)
  420       A(I,K) = Q
  430    IF (N.EQ.NP) GOTO 450
         DO 440 I = N1,NP
            Q = A(J,I)
            A(J,I) = A(K,I)
  440       A(K,I) = Q
  450    CONTINUE

      RETURN
C      END
C      SUBROUTINE   HYROT  (X, Y, CS, SN, N)
C      INTEGER N
C      REAL    X(N), Y(N), CS, SN
C      REAL    XX
C      INTEGER J
C      DO 10 J = 1, N
C         XX = X(J)
C         X(J) = XX*CS + Y(J)*SN
C   10    Y(J) = Y(J)*CS - XX*SN
C      RETURN
      END
	SUBROUTINE HYMAG
C--CALCULATE MAGNITUDES FOR ALL STATIONS FOR HYPOINVERSE

c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'
C--INITIALIZE SUMS FOR AVERAGING
	NFMAG=0
	NXMAG=0
	XMAG=0.
	FMAG=0.

C--LOOP OVER STATIONS TO CALC AND AVERAGE FMAGS AND XMAGS
	DO 100 K=1,KSTA
	KFMAG=0
	KXMAG=0
C--GO NO FURTHER IF THERE IS NO AMP OR DUR MAG FOR THIS STATION
	IF (KFMP(K).EQ.0 .AND. KAMP(K).EQ.0) GOTO 100
	J=KINDX(K)
	KXCOR=JMCOR(J)/100
	KFCOR=JMCOR(J)-100*KXCOR-25
	KXCOR=KXCOR-25

C--COMPUTE FMAG IF DURATION IS POSITIVE
	IF (KFMP(K).LE.0) GOTO 50
	TEMP=KFMP(K)
C--USE A BI-LINEAR SCALE WITH DIST & DEPTH CORRECTIONS
	IF (TEMP.LT.FMBRK) THEN
	  KFMAG=10*(FMA1+FMB1*ALOG10(TEMP)+FMD1*KDIS(K)*.05+FMZ1*Z1)
	ELSE
	  KFMAG=10*(FMA2+FMB2*ALOG10(TEMP)+FMD2*KDIS(K)*.05+FMZ2*Z1)
	END IF

C--APPLY MAG CORRECTION
	KFMAG=KFMAG+KFCOR
	IF (KFCOR.GT.25) KFMAG=KFMAG-50
	IF (KFMAG.LT.0) KFMAG=0
C--DON'T INCLUDE MAG IN AVERAGE IF MAG CORRECTION GT 2.5
	IF (KFCOR.GT.25 .OR. KFMAG.EQ.0) GOTO 50
	FMAG=FMAG+KFMAG*.1
	NFMAG=NFMAG+1

C--CALCULATE AMPLITUDE MAG IF AMP IS POSITIVE
50	IF (KAMP(K).LE.0) GOTO 100

C--COMPUTE XMAG AS A SUM OF 3 TERMS:
C--1: LOG(MAX PEAK-TO-PEAK AMP / 2*CAL FACTOR)
C--2: -LOG RESPONSE OF INST REL TO WOOD-ANDERSON AT 5 HZ.
C--3: -LOG(A(0)), THE LOCAL MAGNITUDE DISTANCE CORRECTION
C--ALFRQ = LOG(FREQUENCY OF SIGNAL AT MAX AMPLITUDE / 5HZ.)
C--ALDSQ = LOG((HYPOCENTRAL DISTANCE)**2)

C--DECODE SEISMOMETER TYPE & CALIBRATION FACTOR
	ITYPE=JCAL(J)/10000
	KCAL=JCAL(J)-ITYPE*10000
	KPER=KCAL/500
	KCAL=KCAL-KPER*500
	IF (KCAL.EQ.0) GO TO 100

C--COMPUTE MAGNITUDE
	ALDSQ=ALOG10(Z1**2+(KDIS(K)*.05)**2)
	ALFRQ=ALOG10(2./KPER)
	TEMP=ALOG10(KAMP(K)*5./KCAL)
	IF (ITYPE.EQ.1) TEMP=TEMP-1.3-.95*ALFRQ
	IF (ITYPE.EQ.2) TEMP=TEMP+.41+.56*ALFRQ
	TEMP=TEMP-.15+.8*ALDSQ
	IF (ALDSQ.GT.4.6) TEMP=TEMP-3.23+.7*ALDSQ
	KXMAG=10*TEMP+.5

C--APPLY MAG CORRECTION
	KXMAG=KXMAG+KXCOR
	IF (KXCOR.GT.25) KXMAG=KXMAG-50
	IF (KXMAG.LT.0) KXMAG=0

C--DON'T INCLUDE MAG IN AVERAGE IF MAG CORRECTION GT 2.5
	IF (KXCOR.GT.25 .OR. KXMAG.EQ.0) GOTO 100
	XMAG=XMAG+KXMAG*.1
	NXMAG=NXMAG+1

C--STORE BOTH MAGS FOR THIS STATION
100	KMAG(K)=KXMAG*100+KFMAG

C--AVERAGE THE STATIONS TOGETHER
	IF (NXMAG.GT.0) XMAG=XMAG/NXMAG
	IF (NFMAG.GT.0) FMAG=FMAG/NFMAG
	IF (FMAG.EQ.0.) FMAG=XMAG
	RETURN
	END
	SUBROUTINE HYLST (STANAM,A,W,R,IMPORT,MTCAL)
C--DOES FINAL OUTPUT OF EVENT DATA BY STATION FOR HYPOINV

c$INCLUDE:'HYPCOM.'
c$INCLUDE:'HYPCOMA.'
c$INCLUDE:'HYPCOMV.'
      include 'hypcom.inc'
      include 'hypcoma.inc'
      include 'hypcomv.inc'
	CHARACTER XTEMP*4,FTEMP*4,TAMP*4,TFMP*4,CWT*1,C1*1,C3*3
	CHARACTER CRES*6,STAR*1,XLABL(4)*3
	DATA XLABL /'OT ','LAT','LON','Z  '/

C--OUTPUT EIGENDATA AND ERROR ELLIPSE
	IF (KPRINT.GT.2 .AND. LPRT) THEN
C--OUTPUT HEADING & EIGENVALUES
	  WRITE (15,1100) EIGVAL
1100	  FORMAT (/12X'EIGENVALUES'/4X'('4F6.3')'37X
     2 '#ERROR ELLIPSE'/4X'EIGENVECTORS OF ADJUSTMENT'
     3 11X'COVARIANCE'10X'ERRORS#  SERR AZ DIP')
C--COMPUTE STANDARD DEVIATIONS
	  DO 150 I=1,3
	  TEMP=SQRT(COVAR(I,I))

C--OUTPUT EIGENVECTORS, COVARIANCE, STD. DEV. & ERROR ELLIPSE
150	  WRITE (15,1101) XLABL(I),(V(I,J),J=1,4),(COVAR(I,J),J=1,4),
     2 TEMP,SERR(I),IAZ(I),IDIP(I)
1101	  FORMAT (1X,A3'('4F6.3')('4F7.3')'F7.3'#'F6.2,I4,I3)
	  TEMP=SQRT(COVAR(4,4))
	  WRITE (15,1101) XLABL(4),(V(4,J),J=1,4),(COVAR(4,J),J=1,4),TEMP
	END IF

C--SET VALUES IN CASE OT MUST BE ADJUSTED
	T2=T1
	KMIN2=KMIN
	KHOUR2=KHOUR

1001	FORMAT (F6.2)
1003	FORMAT (F4.1)
1004	FORMAT (I4)
1010	FORMAT (I1)

C--ADJUST ORIGIN IF EVENT HAS ITERATED INTO ANOTHER MINUTE
C  AT FIRST, NT IS THE TIME SHIFT IN MINUTES, THEN IN HOURS
C  DO NOT ADJUST TIME IF EVENT IS STILL BEING LOCATED
	IF (DONE) THEN
	  NT=(T1+600.)/60.
	  NT=NT-10
	  T1=T1-NT*60.
	  KMIN=KMIN+NT
	  NT=(KMIN+60.)/60.
	  NT=NT-1
	  KMIN=KMIN-NT*60
	  KHOUR=KHOUR+NT

C--ADJUST ORIGIN IF EVENT HAS ITERATED INTO ANOTHER DAY
	  IF (KHOUR.LT.0) THEN
	    KDAY=KDAY-1
	    KHOUR=KHOUR+24
	  END IF
	END IF

C--COMPUTE LARGEST GAP AS MAXGAP
	MAXGAP=0
C--CALC DISTANCE TO NEAREST STA & NUMBER OF FIRST MOTIONS
	KTEMP=10000
	NFRM=0

C--EXAMINE ALL POSSIBLE GAPS FOR THE LARGEST BETWEEN ADJACENT STATIONS
	DO 30 IM=1,M
	IF (W(IM).LT..1) GO TO 30
	K=IND(IM)

C--REMOVE S FLAG FROM STATION INDEX
	IF (K.GT.10000) K=K-10000
C--TALLY FIRST MOTIONS WHEN THEY ARE NON-BLANK
	IF (KPRK(K)(3:3).NE.' ') NFRM=NFRM+1
C--FIND LEAST STATION DISTANCE
	IF (KDIS(K).LT.KTEMP) KTEMP=KDIS(K)
	MINGAP=360
	LAZ1=KAZEM(K)/180

C--INNER STATION LOOP
	DO 20 I=1,M
	IF (I.EQ.IM .OR. W(I).LT..1) GOTO 20
	K2=IND(I)
	IF (K2.GT.10000) K2=K2-10000
	LAZ2=KAZEM(K2)/180
	JGAP=LAZ1-LAZ2
	IF (JGAP.LE.0) JGAP=JGAP+360
	IF (JGAP.LT.MINGAP) MINGAP=JGAP
20	CONTINUE

	IF (MINGAP.GT.MAXGAP) MAXGAP=MINGAP
30	CONTINUE

C--SET DISTANCE TO CLOSEST STATION
	DMIN=KTEMP*.05

C++++++++++++++ OUTPUT THE LOCATION +++++++++++++++++
	IF (LPRT) THEN

C--STORE & OUTPUT MAGNITUDES AS A STRING WHICH IS BLANK IF NONE PRESENT
	  FTEMP=' '
	  XTEMP=' '
	  IF (FMAG.GT.0.) WRITE (FTEMP,1003) FMAG
	  IF (XMAG.GT.0.) WRITE (XTEMP,1003) XMAG

C--OUTPUT LOCATION TO PRINT FILE
	  WRITE (15,1027)
1027	  FORMAT(/1X,40('--')/' YR MO DA    ORIGIN'6X
     2 'LAT N     LON W    DEPTH   RMS   ERH   ERZ  XMAG  FMAG')
	  WRITE (15,1028) KYEAR,KMONTH,KDAY,KHOUR,KMIN,T1,LAT,IS,XLTM,
     2 LON,IE,XLNM,Z1,RMS,ERH,ERZ,XTEMP,FTEMP
1028	  FORMAT (1X,I2,2('-',I2),I4,I2,F6.2,I4,A1,F5.2,I5,A1,F5.2,F7.2,
     2 3F6.2,2(2X,A4))
C******ESCRIBA ENCABEZADO SUMARIO EN OVSI.BOL*****
c      IF(FMAG.GE.3.5) THEN
c	  WRITE (20,1328) KYEAR,KMONTH,KDAY,KHOUR,KMIN,T1,LAT,IS,XLTM,
c     2 LON,IE,XLNM,Z1,FMAG
c1328	  FORMAT (1X,3I2,I4,I2,F6.2,I4,A1,F5.2,I5,A1,F5.2,F7.2,
c     2 F3.1)
c      END IF
C**************************************************
C
	  WRITE (15,1029)
1029	  FORMAT(/' RMSWT  DMIN  DLYBAL  GAP  ITR  NFM  NWR  ',
     2 'NWS   REMARKS')

	  WRITE (15,1030) RMSWT,DMIN,DLYBAL,MAXGAP,ITR,NFRM,NWR,NWS,
     2 REMK,RMK1,RMK2
1030	  FORMAT (1X,F5.2,F6.1,F8.3,5I5,3X,A3,1X,2A1)
	END IF

C+++++++++++++++ PRINT OUT THE STATION LIST +++++++++++++++++++++++

	MOUT=0
	IF (KPRINT.GT.0 .AND. LPRT) WRITE (15,1031)
1031	FORMAT (/2X'STA DIST AZM  AN P/S W   SEC (TOBS -TCAL',
     2 ' -DLY  =RES) WT  R INFO AMP DUR XMG FMG')

C--LIST STATIONS IN DISTANCE ORDER
C--LSTDIS IS THE LEAST REMAINING DISTANCE AND WILL BE PRINTED ON THIS PASS
C--NXTDIS IS THE NEXT TO LEAST REMAINING DISTANCE,
C--AND WILL BE PRINTED ON THE NEXT PASS
C--OUTPUT PHASE DATA A OVSI.MEC *********
c	IF(FMAG.GE.3.0) THEN
c	ULAT=LAT+XLTM/60.
c	ULON=LON+XLNM/60.
c      WRITE(25,878) KYEAR,KMONTH,KDAY,KHOUR,KMIN,T1,ULAT,ULON,Z1,
c     2    FMAG,MAXGAP,RMS,ERH,ERZ
c878   FORMAT (1X,3I2,1X,2I2,1X,F6.3,1X,F6.3,1X,F6.3,1X,F6.2,
c     2    F5.2,1X,I4,1X,F6.2,1X,F6.2,1X,F6.2)
c	END IF
C
	NXTDIS=-1
C
C--START OUTER STATION LOOP
40	LSTDIS=NXTDIS
	NXTDIS=30000
	KLSTA=-1

C--START INNER STATION LOOP
	DO 90 IM=1,M

C--DETERMINE STATION INDEX & WHETHER IT IS P OR S
	K=IND(IM)
	KPS=K/10000
	K=K-10000*KPS
	K1=KDIS(K)

	IF (K1.NE.LSTDIS) THEN
	  IF (K1.GT.LSTDIS .AND. K1.LT.NXTDIS) NXTDIS=K1
	  GOTO 90
	END IF
	MOUT=MOUT+1

C--WRITE A LINE OF PHASE ARRIVAL DATA FOR THIS STATION
C--PREPARE STATION INFO
	IF (K.EQ.KLSTA) GOTO 60
	J=KINDX(K)

C--DECODE DISTANCE, AZIMUTH AND EMERGENCE ANGLE
	DIST=K1*.05
	KAZ=KAZEM(K)/180
	KEM=IABS(KAZEM(K)-180*KAZ)
	IF (KAZ.LT.0) KAZ=KAZ+360
C--DECODE CALCULATED TRAVEL TIME
	TCAL=.01*MTCAL(IM)

C--NOW STORE XMAG AND FMAG AS ALPHAMERIC CODE
	XTEMP=' '
	FTEMP=' '
	TAMP=' '
	TFMP=' '
	KXMAG=KMAG(K)/100
	KFMAG=KMAG(K)-KXMAG*100
	TEMP=.1*KFMAG
	TMP2=.1*KXMAG
	AFMAG=.1*KFMAG
	AXMAG=.1*KXMAG
	IF (TEMP.GT.0.) WRITE (FTEMP,1003) TEMP
	IF (KFMP(K).NE.0) WRITE (TFMP,1004) KFMP(K)
	IF (TMP2.GT.0.) THEN
	  WRITE (XTEMP,1003) TMP2
	  WRITE (TAMP,1004) KAMP(K)
	END IF

C--DECODE ASSIGNED WEIGHTS
	LSWT=KWT(K)/10
	LPWT=KWT(K)-LSWT*10
C--GIVE THESE A VALUE FOR ARCHIVE OUTPUT IN CASE AN ARRIVAL IS NOT PRESENT
	IMPORP=0
	IMPORS=0
	KPWT=0
	KSWT=0
	KPRES=0
	KSRES=0
	KPDLY=0
	KSDLY=0

C--PREPARE ARRIVAL TIME INFO, BUT FIRST DECIDE IF THIS IS P OR S
60	TEMP=.01*(DLYBAL*JPD2(J)+(1.-DLYBAL)*JPD1(J))
	IF (KPS.EQ.0) THEN

C--ASSUME A P ARRIVAL
	  DLY=TEMP
	  KPDLY=JNINT(100.*DLY)
	  C3=KPRK(K)
	  C1=' '
	  LWT=LPWT
	  SEC=KP(K)*.01
	  IMPORP=IMPORT(IM)
	  KPWT=100.*W(IM)
	ELSE

C--ASSUME AN S ARRIVAL
	  DLY=POS*TEMP
	  KSDLY=JNINT(100.*DLY)
	  C3=KSRK(K)
	  C1='S'
	  LWT=LSWT
	  SEC=KS(K)*.01
	  TCAL=TCAL*POS
	  IMPORS=IMPORT(IM)
	  KSWT=100.*W(IM)
	END IF

C--SET PARAMETERS COMMON TO BOTH P & S
	TOBS=SEC-T2
	XIMPOR=IMPORT(IM)*.001
C--OUTPUT WEIGHT AS A STRING
	CWT=' '
	IF (LWT.GT.0) WRITE (CWT,1010) LWT

C--OUTPUT RESIDUAL AS A STRING AND FLAG IT IF LARGE
	STAR=' '
	RES=TOBS-TCAL-DLY
	CRES=' '
	IF (C3.NE.'   ') THEN
	  WRITE (CRES,1001) RES
C--FLAG READING WITH A * IF LARGE OR AN X IF READING NOT USED
	  IF (ABS(RES).GT..5) STAR='*'
	  IF (LWT.GT.3) STAR='X'
	END IF

C--SET THEN LIMIT P & S RESIDUALS AS INTEGERS FOR OUTPUT TO ARCHIVE FILE
	IF (KPS.EQ.0) THEN
C--P WAVE
	  KPRES=JNINT(100.*RES)
	  IF (KPRES.GT.9999) KPRES=9999
	  IF (KPRES.LT.-999) KPRES=-999
	ELSE
C--S WAVE
	  KSRES=JNINT(100.*RES)
	  IF (KSRES.GT.9999) KSRES=9999
	  IF (KSRES.LT.-999) KSRES=-999
	END IF
	STA=STANAM(J)

C--PRINT ARRIVAL TIME INFORMATION FOR ONE STATION
	IF (KPRINT.GT.0 .AND. LPRT) THEN
	  IF (K.NE.KLSTA) THEN

C--WRITE ALL DATA FOR FIRST PHASE (WHICH IS A P UNLESS ONLY S WAS GIVEN)
	    WRITE (15,1532) STA,DIST,KAZ,KEM,C3,CWT,SEC,TOBS,
     2   TCAL,DLY,CRES,STAR,W(IM),C1,KRMK(K),XIMPOR,
     3   TAMP,TFMP,AXMAG,AFMAG
1532	    FORMAT (1X,A4,F5.1,2I4,1X,A3,1X,A1,3F6.2,F5.2,A6,A1,F4.2,2A1,
     2   F5.3,2A4,1X,F3.1,1X,F3.1)
C*******ESCRIBE FASES EN ARCHIVO OVSI.BOL******
c        IF(FMAG.GE.3.5) THENc
c	    WRITE (20,1032) STA,DIST,KAZ,KEM,C3,CWT,SEC,TOBS,
c     2   TCAL,DLY,CRES,STAR,W(IM),C1,KRMK(K),XIMPOR,TAMP,TFMP,XTEMP,FTEMP
c1032	    FORMAT (1X,A4,F5.1,2I4,1X,A3,1X,A1,3F6.2,F5.2,A6,A1,F4.2,2A1,
c     2   F5.3,4A4)
c        END IF
C*****************************
c        IF(FMAG.GE.3.0) THEN
C--PRINT PHASE DATA HERE  OVSI.MEC ********
c      WRITE (25,1134) STA,C3,CWT,KHOUR,KMIN,SEC,
c     2     RES,DIST,KEM,KAZ
c1134  FORMAT (A4,1X,A3,1X,A1,1X,2I2,1X,F5.2,1X,F6.2,1X,F5.1,1X,
c     2     I4,1X,I4)
C*****************************
c	END IF
	  ELSE
C
C--WRITE ONLY ARRIVAL TIME INFO FOR AN S FOLLOWING A P
	    WRITE (15,1033) C3,CWT,SEC,TOBS,TCAL,DLY,CRES,STAR,W(IM),
     2   C1,KRMK(K),XIMPOR
C*******ESCRIBE FASES EN ARCHIVO OVSI.BOL******
c        IF(FMAG.GE.3.5) THENc
c	    WRITE (20,1033) C3,CWT,SEC,TOBS,TCAL,DLY,CRES,STAR,W(IM),
c     2   C1,KRMK(K),XIMPOR
1033        FORMAT (19X,A3,1X,A1,3F6.2,F5.2,A6,A1,F4.2,2A1,F5.3)
c        END IF
C
	  END IF
	END IF
C--WRITE A RECORD CONTAINING ALL STATION INFO TO AN ARCHIVE FILE
C--DON'T WRITE A LINE YET IF S ARRIVAL IS TO COME
	IF (IM.LT.M) THEN
	  I=IND(IM+1)
	  K1=I/10000
	  K1=I-K1*10000
	  IF (K.EQ.K1) GO TO 80
	END IF
	KTEMP=KDIS(K)/2

	IF (LARC .AND. DONE .AND. NWR.GT.3) THEN
	  IF (JCA.NE.1) THEN

C--CONDENSED FORMAT
	    I=KP(K)-100.*T1+.5
	    K1=KFMP(K)

	    IF (K1.EQ.0) THEN
	      IF(KPRK(K).NE.'  ')WRITE(7,1006)STA,KPRK(K),LPWT,I
1006	      FORMAT (A4,A3,I1,I5,I4)
	    ELSE
C--COMBINE P TIME & CODA ON SAME LINE IF PICKER-STYLE FORMAT IS SELECTED
	      WRITE (7,1006) STA,KPRK(K),LPWT,I,K1
	    END IF

 	    I=KS(K)-100.*T1+.5
	    IF (KSRK(K).NE.'  ') WRITE(7,1005) STA,KSRK(K),LSWT,I
1005	    FORMAT (A4,A2,1X,I1,I5)

	    K1=KAMP(K)
	    IF (K1.NE.0) WRITE (7,1007) STA,K1
1007	    FORMAT (A4' A  'I4'.')
	  ELSE

C--FULL FORMAT
	    WRITE (7,1034) STA,KPRK(K),LPWT,KYEAR,
     2   KMONTH,KDAY,KHOUR2,KMIN2,KP(K),KPRES,KPWT,KS(K),KSRK(K),LSWT,
     3   KSRES,KAMP(K),KSWT,KPDLY,KSDLY,KTEMP,KEM,KRMK(K),
     4   KFMP(K),KAZ,KFMAG,KXMAG,IMPORP,IMPORS
1034	    FORMAT (A4,A3,I1,1X,5I2,I5,I4,I3,I5,A2,1X,I1,I4,I3,I3,
     2   3I4,I3,5X,A1,I4,I3,2I2,2I4)
	  END IF
	END IF
C
C--UPDATE THE LAST STATION INDEX
80	KLSTA=K
90	CONTINUE
	IF (MOUT.LT.M) GOTO 40
	RETURN
	END
	SUBROUTINE HYSUM
C--CALLED BY HYPOINV TO OUTPUT SUMMARY DATA

c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'

	DIMENSION KSIG(3)
	CHARACTER CARD*90,KSFL*1

C--ADJUST ORIGIN IF EVENT HAS ITERATED INTO ANOTHER MINUTE.
C--DO NOT MAKE THE ADJUSTMENT PERMANENT, BUT USE ONLY IN HYSUM.
C--ADJUSTMENT WILL BE MADE AGAIN IN HYLST.
	T2=T1
	KMIN2=KMIN
	KHOUR2=KHOUR
	KDAY2=KDAY
	NT=(T2+600.)/60.
	NT=NT-10
	T2=T2-NT*60.
	KMIN2=KMIN2+NT
	NT=(KMIN2+60.)/60.
	NT=NT-1
	KMIN2=KMIN2-NT*60
	KHOUR2=KHOUR2+NT

C--ADJUST ORIGIN IF EVENT HAS ITERATED INTO ANOTHER DAY
	IF (KHOUR2.LT.0) THEN
	  KDAY2=KDAY2-1
	  KHOUR2=KHOUR2+24
	END IF

C--CONVERT SOME DATA TO INTEGER FOR OUTPUT
	KLTM=XLTM*100.+.5
	KLNM=XLNM*100.+.5
	KT=T2*100.+.5
	KZ=Z1*100.+.5
	KFMAG=FMAG*10.+.5
	KXMAG=XMAG*10.+.5
	KDMIN=DMIN+.5
	KRMS=RMS*100.+.5
	KERH=ERH*100.+.5
	KERZ=ERZ*100.+.5
	DO 10 I=1,3
10	KSIG(I)=SERR(I)*100.

C--ENCODE THE SUMMARY DATA AS A STRING
	WRITE (CARD,1001) KYEAR,KMONTH,KDAY2,KHOUR2,KMIN2,KT,LAT,IS,
     2 KLTM,LON,IE,KLNM,KZ,KXMAG,NWR,MAXGAP,KDMIN,KRMS,
     3 (IAZ(I),IDIP(I),KSIG(I),I=1,2),KFMAG,REMK,KSIG(3),
     4 RMK1,RMK2,NWS,KERH,KERZ,NFRM
1001	FORMAT (5I2,I4,I2,A1,I4,I3,A1,I4,I5,I2,3I3,I4,2(I3,I2,I4),
     2 I2,A3,I4,2A1,I2,2I4,I2)
C
C--WRITE A RECORD TO ARCHIVE FILE
	IF (LARC) WRITE (7,1000) CARD
1000	FORMAT (A)
C
	IF (LSUM) THEN
C--WRITE A SUMMARY RECORD
C
C--HYPO71 FORMAT
	  IF (LH71) THEN
	    KSFL=' '
	    IF (NWS.GT.0) KSFL='S'
	    WRITE (12,1002) KYEAR,KMONTH,KDAY2,KHOUR2,KMIN2,T2,LAT,IS,
     2   XLTM,LON,IE,XLNM,Z1,FMAG,NWR,MAXGAP,DMIN,RMS,ERH,ERZ,KSFL
1002	    FORMAT (3I2,I3,I2,F6.2,I3,A1,F5.2,I4,A1,F5.2,2F7.2,
     2   I3,I4,F5.1,F5.2,2F5.1,1X,A1)
C	  ENDIF
	ELSE
C
C--HYPOINVERSE FORMAT
	    WRITE (12,1000) CARD
	  END IF
	END IF
	RETURN
	END
	SUBROUTINE HYREP (LPLT)
C--CALL BY HYPOINVERSE TO REPORT THE CURRENT EVENT ON THE CONSOLE
	LOGICAL LPLT
c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'

	IT=JNINT(XLTM)
	IN=JNINT(XLNM)
	IF (INUM.EQ.1 .OR. LPLT) WRITE (*,1000)
1000	FORMAT (' EVENT LOCATED: REMARK -LAT-  --LON-  DEPTH XMAG',
     2 ' FMAG NUM  ERH  ERZ')
	WRITE (*,1011) KYEAR,KMONTH,KDAY,KHOUR,KMIN,REMK,
     2 RMK1,RMK2,LAT,IT,LON,IN,Z1,XMAG,FMAG,NWR,ERH,ERZ
1011	FORMAT (I3'/'I2'/'I2,I3':'I2,1X,A3,1X,2A1,2I3,I5,I3,
     2 F7.2,2F5.1,I4,2F5.1)
	RETURN
	END
	BLOCK DATA
C--DATA INITIALIZATION FOR HYPOINV

C	INCLUDE 'HYPCOM./LIST'
C	INCLUDE 'HYPCOMC./LIST'
C	INCLUDE 'HYPCOMP./LIST'	!PC350 VERSION ONLY
c$INCLUDE:'HYPCOM.'
c$INCLUDE:'HYPCOMC.'
c$INCLUDE:'HYPCOMP.'	
      include 'hypcom.inc'
      include 'hypcomc.inc'
      include 'hypcomp.inc'
C!PC350 VERSION ONLY
	LOGICAL LNEWL,LCOPY
C--GENERAL PARAMETERS
	DATA PI,RDEG,LTRT,LTRH /3.14159,57.2958,2*.FALSE./
C--FILES AND OUTPUT CONTROLS
	DATA LSUM,LARC,LPRT,LERR,LH71,LAPP /6*.FALSE.,2*.TRUE./
	DATA JCP,JCA,LEJCT,LREP,KPRINT,JST /2*1,2*.TRUE.,3,2/
	DATA INFILE,DEV,NDEV /'HYPINST.',' ',0/
C--MISCELLANEOUS DATA FOR THIS EVENT
	DATA LOCNUM /0/
C--STATION DELAY PARAMETERS
	DATA KDLY,DLYAZ,DLYWD,DLYLON,DLYLAT /1,4*0./
C--TERMINATING LOCATION UPON CONVERGENCE
	DATA ITRLIM,DQUIT,DRQT /20,.04,.001/
C--ITERATION & DAMPING CONTROLS
	DATA DXFIX,DZMAX,DZAIR,DAMP,EIGTOL,RBACK,BACFAC
     2/7.,30.,.5,.9,.012,.02,.6/
C--DURATION MAG CONSTANTS
	DATA FMA1,FMB1,FMZ1,FMD1,FMA2,FMB2,FMZ2,FMD2,FMBRK
     2/-5.2,3.89,.013,.0037,-.905,2.026,.013,.0037,210./
C--MISCELLANEOUS PARAMETERS
	DATA DISCUT,DISW1,DISW2 /50.,1.,3./
	DATA RMSCUT,RMSW1,RMSW2 /.16,1.5,3./
	DATA SWT,POS,ZTR,RDERR,ERCOF,NET,MINSTA,ITRDIS,ITRRES
     2/1.,1.75,7.,.15,1.,0,3,2*0/
C--CRUST MODEL PARAMETERS
	DATA MODTYP /3*-1/

C--THE FOLLOWING ARE FOR THE PC350 VERSION ONLY
C--MAP PLOT PARAMETERS
	DATA BLAT,BLON,SCAL,LSTA,NLIN /19.33,-155.25,4.E5,.FALSE.,0/
	DATA JSSYM,SSIZ,JSCLR,TITL,ERHMAX,ERZMAX /2,.08,1,' ',2*99./
C--EARTHQUAKE SYMBOLS
	DATA NMAG,ASIZ,ACUT /5,.02,.04,.08,.14,.2,0.,1.,2.,3.,4.,10./
	DATA LCLR,JSYM,JCLR /.FALSE.,7*7,2,6,3,4*4/
	DATA NDEP,ZCUT /4,0.,5.,13.,20.,100.,3*0./
	DATA NTIM,JY,JM,JD,JH,JN,TJ /1,7*60,14*1,14*0,7*0.D0/
	DATA ID,IH,DT,JCFR,JCTX /1,0,1.D0,7,4/
C	DATA LINT,LRTP,LNEWL,LCOPY /4*.FALSE./
	DATA LINT,LRTP,LNEWL,LCOPY /.FALSE.,.FALSE.,.FALSE.,.FALSE./
C--RGB VALUES OF THE 8 DISPLAYABLE COLORS:
C              BLK   BLUE   RED   GREEN YELLOW MAGENT  CYAN   WHITE
C	DATA INTEN/3*0, 0,0,6, 7,0,0, 0,7,0, 7,7,0, 7,0,6, 0,7,6, 7,7,6/
C--COUNT ARRAYS
	DATA MMAG,MMAGT,MDEP,MDEPT,MTIM,MXPLT,MXPL /111*0/
	END
	FUNCTION JASK (PROMPT,IDFLT,LENP)

C--JASK PROMPTS THEN READS AN INTEGER VALUE FROM THE TERMINAL.
C--THE DEFAULT VALUE IS RETURNED ON A CR RESPONSE.
C	JASK   = INTEGER RESPONSE
C	PROMPT = PROMPT STRING
C	IDFLT  = DEFAULT SUPPLIED ON CARRIAGE RETURN, AND
C		 DISPLAYED IN PROMPT.
C	LENP   = BYTE LENGTH OF PROMPT STRING.

	CHARACTER PROMPT, TEMP*20
	WRITE (TEMP,1002) IDFLT
1002	FORMAT (I20)
	DO 3 I=1,20
	IF (TEMP(I:I).NE.' ') GOTO 5
3	CONTINUE
5	WRITE (*,1001) PROMPT(1:LENP),TEMP(I:20)
1001	FORMAT (1X,A,' [CR=',A,']? ',$)
	READ (*,1000,ERR=5) I
1000	FORMAT (I20)
	IF(I.EQ.0) THEN
	NCH=0
	ELSE
	NCH=1
	END IF
	IF (NCH.EQ.0) I=IDFLT
	JASK=I
	RETURN
	END
C	LOGICAL FUNCTION LASK (PROMPT,LDFLT,LENP)

C--LASK PROMPTS USING THE STRING "PROMPT", THEN READS A LOGICAL VALUE
C--FROM THE TERMINAL. THE DEFAULT VALUE LDFLT IS RETURNED ON A CR RESPONSE.
C	LASK= LOGICAL RESPONSE.
C	PROMPT= PROMPT STRING.
C	LDFLT= DEFAULT DISPLAYED IN PROMPT & RETURNED ON CR.
C	LENP= BYTE LENGTH OF PROMPT STRING

C	CHARACTER PROMPT
C	CHARACTER*1 L
C	LOGICAL LDFLT
C5	WRITE (*,1001) PROMPT(1:LENP),LDFLT
C1001	FORMAT (1X,A' [T OR F, CR='L1']? '$)
C	READ (*,1000,ERR=5) L
C1000	FORMAT (A1)
C	IF(L.NE.' ') THEN
C	IF(L.EQ.'T'.OR.L.EQ.'t') THEN
C	LASK=.TRUE.
C	NCH=1
C	ELSE
C	LASK=.FALSE.
C	NCH=1
C	END IF
C	ELSE
C	NCH=0
C	END IF
C	IF (NCH.GT.0) GOTO 9
C	LASK=LDFLT
C9	RETURN
C	END
	FUNCTION LENG (STRING,MAXLEN)
C--RETURNS THE NON-BLANK LENGTH OF STRING WHOSE PHYSICAL LENGTH IS MAXLEN
C--(RETURNS THE POSITION OF THE LAST NON-BLANK CHARACTER)
	CHARACTER STRING
	DO 5 I=MAXLEN,1,-1
	IF (STRING(I:I) .NE. ' ') GOTO 10
5	CONTINUE
	I=0
10	LENG=I
	RETURN
	END
	FUNCTION ASKR (PROMPT,DFLT,LENP)

C--ASKR PROMPTS THEN READS A REAL VALUE FROM THE TERMINAL.
C--THE DEFAULT VALUE IS RETURNED ON A CR RESPONSE.
C	ASKR   = REAL RESPONSE
C	PROMPT = PROMPT STRING
C	DFLT   = DEFAULT SUPPLIED ON CARRIAGE RETURN AND
C		 DISPLAYED IN PROMPT.
C	LENP   = BYTE LENGTH OF PROMPT (PC350 ONLY)

	CHARACTER PROMPT, TEMP*20
	WRITE (TEMP,1000) DFLT
1000	FORMAT (G20.5)
	DO 2 I=1,20
	IF (TEMP(I:I).NE.' ') GOTO 3
2	CONTINUE
3	DO 4 J=20,1,-1
	IF (TEMP(J:J).NE.' ')GOTO 5
4	CONTINUE
5	WRITE (*,1001) PROMPT(1:LENP), TEMP(I:J)
1001	FORMAT (1X,A,' [CR=',A,']? ',$)
	READ (*,1002,ERR=5,END=9) ASKR
1002	FORMAT (F20.0)
	IF(ASKR.EQ.0.0) THEN
	NCH=0
	ELSE
	NCH=1
	END IF
	IF (NCH.GT.0) GOTO 9
	ASKR=DFLT
9	RETURN
	END
C**************************************************
	FUNCTION HYDID (J,M,MD)
C--CALLED BY HYTRH IN PROGRAM HYPOINVERSE
C	INCLUDE 'HYPCOMC./NOLIST'
c$INCLUDE:'HYPCOMC.'
      include 'hypcomc.inc'
	HYDID=0.
	IF (M.EQ.1) GOTO 110
	DO 20 L=1,M-1
	SQT=SQRT(VSQ(M,MD)-VSQ(L,MD))
	DM=THK(L,MD)*VEL(L,MD)/SQT
	FLJ=1.
	IF (L.GE.J) FLJ=2.
	HYDID=HYDID+FLJ*DM
20	CONTINUE
110	RETURN
	END
C*********************************************************
	FUNCTION HYTID (J,M,MD)
C--CALLED BY HYTRH IN PROGRAM HYPOINVERSE
C	INCLUDE 'HYPCOMC./NOLIST'
c$INCLUDE:'HYPCOMC.'
      include 'hypcomc.inc'
	HYTID=0.
	IF (M.EQ.1) GOTO 110
	DO 20 L=1,M-1
	SQT=SQRT(VSQ(M,MD)-VSQ(L,MD))
	TIM=THK(L,MD)*SQT/(VEL(L,MD)*VEL(M,MD))
	FLJ=1.
	IF (L.GE.J) FLJ=2.
	HYTID=HYTID+FLJ*TIM
20	CONTINUE
110	RETURN
	END


	FUNCTION JDAT (J,KLATD,KLATM,KLOND,KLONM,KCAL,KMCOR,KMOD,
     2KPD1,KPD2)

C--USED IN THE PC350 VERSION OF HYPOINVERSE.
C--JDAT IS THE INPUT/OUTPUT ROUTINE FOR INTEGER STATION DATA IN VIRTUAL
C--MEMORY. THE HYPOINVERSE ROUTINE HYSTA READS STATION FILES & STORES
C--DATA ONE STATION AT A TIME. REFERENCES TO DATA IN OTHER ROUTINES ARE
C--RESOLVED AS FUNCTION ENTRY POINTS, WHICH LOOK IN THE CALLING ROUTINES
C--JUST LIKE A REFERENCE TO AN ARRAY IN COMMON IN THE VAX VERSION.

C--STATION NAMES ARE ALSO IN VIRTUAL STORAGE, BUT ACCESSED DIRECTLY,
C--NOT THRU FUNCTION CALLS TO JDAT.
c$INCLUDE:'HYPCOM.'
      include 'hypcom.inc'

	DIMENSION ID(9,MAXSTA)
C!THE NO. OF STATIONS AVAILABLE.
C	VIRTUAL ID (9,MAXSTA)	!THE VIRTUAL ARRAY HOLDING STATION DATA.
C--THE IDENTITY OF THE 9 DATA TYPES ARE:
C  1  LAT, DEG.
C  2  LAT, MIN.
C  3  LON, DEG.
C  4  LON, MIN.
C  5  STA TYPE, CAL FACTOR & PERIOD.
C  6  AMP & DUR MAG CORRECTIONS.
C  7  P & S CRUSTAL MODELS & STA WEIGHT.
C  8  P DELAY 1 IN .01 SEC.
C  9  P DELAY 2 IN .01 SEC.

C--THE MAIN ENTRY POINT STORES DATA FOR ONE STATION
	ID(1,J)=KLATD
	ID(2,J)=KLATM
	ID(3,J)=KLOND
	ID(4,J)=KLONM
	ID(5,J)= KCAL
	ID(6,J)=KMCOR
	ID(7,J)= KMOD
	ID(8,J)= KPD1
	ID(9,J)= KPD2
	JDAT=0
	RETURN

C--RETURN THE VALUE OF LAT IN DEG FOR STATION J
C	ENTRY JLATD(J)
	JLATD(J)=ID(1,J)
	RETURN

C--LAT MINUTES
C	ENTRY JLATM(J)
	JLATM(J)=ID(2,J)
	RETURN

C--LON DEG
C	ENTRY JLOND(J)
	JLOND(J)=ID(3,J)
	RETURN

C--LON MIN
C	ENTRY JLONM(J)
	JLONM(J)=ID(4,J)
	RETURN

C--CAL FACTOR ETC.
C	ENTRY JCAL(J)
	JCAL(J)=ID(5,J)
	RETURN

C--MAG CORRECTIONS
C	ENTRY JMCOR(J)
	JMCOR(J)=ID(6,J)
	RETURN

C--CRUST MODELS ETC.
C	ENTRY JMOD(J)
	JMOD(J)=ID(7,J)
	RETURN

C--P DELAY 1
C	ENTRY JPD1(J)
	JPD1(J)=ID(8,J)
	RETURN

C--P DELAY 2
C	ENTRY JPD2(J)
	JPD2(J)=ID(9,J)
	RETURN
	END
	FUNCTION JNINT (XNUM)
C--RETURNS THE NEAREST INTEGER ACCORDING TO [A+0.5*SIGN(A)]
	IXX=IFIX(XNUM)
	IF(IXX.GT.0) ISIGNO=1
	IF(IXX.LT.0) ISIGNO=-1
	JNINT= IFIX(XNUM+0.5*ISIGNO)
	RETURN
	END

c
c   changes
c
c   nov 93 by jh: include files to lower case and extension .inc
c                 hypinst to lower case
c

C	LOGICAL FUNCTION LASK (PROMPT,LDFLT,LENP)

C--LASK PROMPTS USING THE STRING "PROMPT", THEN READS A LOGICAL VALUE
C--FROM THE TERMINAL. THE DEFAULT VALUE LDFLT IS RETURNED ON A CR RESPONSE.
C	LASK= LOGICAL RESPONSE.
C	PROMPT= PROMPT STRING.
C	LDFLT= DEFAULT DISPLAYED IN PROMPT & RETURNED ON CR.
C	LENP= BYTE LENGTH OF PROMPT STRING

C	CHARACTER PROMPT
C	CHARACTER*1 L
C	LOGICAL LDFLT
C5	WRITE (*,1001) PROMPT(1:LENP),LDFLT
C1001	FORMAT (1X,A' [T OR F, CR='L1']? '$)
C	READ (*,1000,ERR=5) L
C1000	FORMAT (A1)
C	IF(L.NE.' ') THEN
C	IF(L.EQ.'T'.OR.L.EQ.'t') THEN
C	LASK=.TRUE.
C	NCH=1
C	ELSE
C	LASK=.FALSE.
C	NCH=1
C	END IF
C	ELSE
C	NCH=0
C	END IF
C	IF (NCH.GT.0) GOTO 9
C	LASK=LDFLT
C9	RETURN
C	END

c$debug
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  KINNOR.FOR
c
c  Converts .PCK file output of EDPPICK to to file in SEISAN format. 
c  Many events are converted from one file.
c  The program is based on program from Kinemetrics by:
c
c  Christopher S. Lim, Kinemetrics Systems
c  Date: June 15, 1987
c
c  Revision A
c  by M. Ciudad-Real
c  Date: March 27, 1996
c
c  SEISAN version by J. Havskov, November 1997
c  
c
c  Assumptions: First 3 chars of station name is station, last character
c               is component. All component are assumed to be SP. So 
c               e.g. LPGZ is converted to LPG  S  Z
c               The coda given with S is not used.
c               If a P or S field is blank, no travel time is given.
c               A new event start with c* St
c               There is no check if minute > 60, however it is now 
c               checked for both P and S that second is not more than 60.
c               Polarity U is changed to C.
c               waveform file names can be generated assuming file name
c               corresponds to time in input file header.
c
c   updates:
c  april 13, 1999 jh : ----------- version 7.0 check ---------------
c                      year 2000, long wave form file name
c  jun 99            : small format bug
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      implicit none
      character*256 line  
      character*80 infil,text
      character*80 wavname
      character*1 ppol,spol 
      character*5 code             ! waveform agency code
      integer ichan                ! number of channels in waveform file
c     character*6 cdate
      real lat,lon,depth           ! hypocenter
      integer ndata,iyear,imonth,iday,i,day
      character*4 sta
      real ptime,stime,psec,second,ssec
      integer pwt,swt,iminute,ihour,iocheck,pmin,smin
      real ftime,fsec


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c      
c
c---- Get input file name
c
      iocheck = 0
50    write(6,*) ' '
      write(6,'(1x,a)') 'Enter input filename: '
      read(5,'(a)') infil
      write(6,*) 'Enter 1-5 letter code for automatic waveform name',
     *' generation, return for none'
      read(5,'(a)') code
      if(code.ne.' ') then
         write(6,*)' Number of channels in waveform file'
         read(5,*) ichan
      endif
      open(unit=10,file=infil,status='OLD',iostat=iocheck,err=50)
      open(unit=11,file='kinnor.out',status='UNKNOWN')
c
      write(6,*) ' '  
      write(6,'(1x,2a)') 'Reading phase list from file: ',infil(1:50)
c
c------------------------------------------------------------------
c  here starts reading of a new event, loop
c------------------------------------------------------------------
c
      ndata = 0
 1000 continue
c
c
c---- Read in time information line
c
90    read(10,400,end=9000) line
  400 format(a)
      if (line(1:1) .ne. ' ') goto 90
c
c   header
c
      read(line,100) iyear,iday,ihour,iminute,second,lat,lon,depth
100   format(2x,i4,1x,i3,1x,i2,1x,i2,1x,f6.3,13x,f8.4,f10.4,f6.1)
c
c.....Calculate year,month,day     
c
c     call date(iyear,imonth,iday)
      call DTE (iday,DAY,imonth,iyear)
      iday=day

c
c....Calculate date
c
c     kdate = (iyear - 1900)*10000+imonth*100+iday
c     write(cdate,'(i6)') kdate
c     if (iyear-1900 .lt. 10) cdate(1:1) = '0'
c     if (iyear-1900 .eq. 0) cdate(2:2) = '0'
c     if (imonth .lt. 10) cdate(3:3) = '0'
c     read(cdate(5:6),'(i2)') kdate
      
c
c   write nordic header
c
      text=' '
      write(text,'(1x,i4,1x,2i2,1x,2i2,1x,f4.1,1x,a
     *)')iyear,
     *imonth,iday,ihour,iminute,second,'L'
      if(.not.(lat.eq.0.0.and.lon.eq.0.0.and.depth.eq.0.0))
     *write(text(24:43),'(f7.3,f8.3,f5.1)') lat,lon,depth
      text(80:80)='1'
      write(11,'(a)') text
c
c   make waveform file name id desired
c
      if(code.ne.' ') then
c        if(iyear.lt.100) then
c          i=iyear
c        else
c          i=iyear-1900
c        endif
         write(wavname,'(i4,a1,i2,a1,i2,a1,2i2,a1,i2,a2,a5,a1,i3)')
     *   iyear,'-',imonth,'-',iday,'-',ihour,iminute,'-',
     *   int(second),'S.',code,'_',ichan
         do i=1,19
           if(wavname(i:i).eq.' ') wavname(i:i)='0'
         enddo
         do i=27,29
           if(wavname(i:i).eq.' ') wavname(i:i)='0'
         enddo
         do i=20,26
           if(wavname(i:i).eq.' ') wavname(i:i)='_'
         enddo
         text=' '
         text(2:30)=wavname
         text(80:80)='6'
         write(11,'(a)') text
      endif
      ndata = ndata + 1
c              
c.....Read in phase list
c
110   read(10,400,end = 9000) line
      if (line(1:5) .eq. 'c* St') then
         write(11,'(a)') '   '            ! event separater
         goto 1000    ! end of one event
      endif
      if (line(1:1) .ne. ' ') goto 110
      read(line,120) sta,ptime,pwt,ppol,stime,swt,spol,ftime
120   format(7x,a4,1x,f8.3,1x,i1,1x,a1,1x,f8.3,1x,i1,1x,a1,2x,f8.3)      
c
c
      text=' '
c
c   for station assume first 3 chars is station and last char component
c
      text(2:4)=sta(1:3)
      text(7:7)='S'
      text(8:8)=sta(4:4)
c
c.....Calculate and write P-arrival time if field not blank
c
      if(line(15:22).ne.'        ') then
         psec = second + ptime
         pmin = iminute
125      if (psec .ge. 60.) then 
           psec = psec - 60.
           pmin = pmin + 1
           goto 125
         endif
c
c   phase
c
         text(10:11)='IP'
         write(text(19:28),'(2i2,1x,f5.2)') ihour,pmin,psec
c
c   calculate coda if there, p must be there
c
         if(ftime.gt.ptime) then
            fsec = ftime - ptime         ! coda length
            i=fsec+0.5
            write(text(30:33),'(i4)') i
         endif
c
c   polarity and weight
c
         if(ppol.eq.'U') ppol='C'        
         text(17:17)=ppol
         write(text(15:15),'(i1)') pwt
c
c   write P-line
c
         write(11,'(a)') text

      endif

c
c.....Calculate and  write S-arrival time if field not blank, assune no 
c     polarity with S and no coda
c        
      if (line(28:33).ne.'      ') then
         text(9:80)=' '   ! assume same station and component
         smin = iminute
         ssec = stime + second
126      if (ssec .ge. 60.) then 
           ssec = ssec - 60.
           smin = smin + 1
           goto 126
         endif
c
c   phase
c
         text(10:11)='IS'
         write(text(19:28),'(2i2,1x,f5.2)') ihour,smin,ssec
c
c   weight
c
         write(text(15:15),'(i1)') swt
c
c   write S-line
c
         write(11,'(a)') text

      endif
      goto 110
c
c---- End of file encountered
9000  continue
c      
      close(10)
      close(11)
      write(6,'(1x,/,a,1x,i5)') ' Number of events converted:',ndata
      write(6,*)'Output file name is kinnor.out'
      stop
      end
c
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  DATE(iyear,imonth,iday)
c
c     Given day of year, calculates month and day
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine date(iyear,imonth,iday)
      integer iyear,imonth,iday
      integer imon(12)
      data imon/31,28,31,30,31,30,31,31,30,31,30,31/
c
c... Hypo71 assumes 20th century
c
      iyear = mod(iyear,100) + 1900
c
c....Leap years: Century years divisible by 400
c                Other years divisible by 4
      if ((mod(iyear,100) .eq. 0 .and. mod(iyear,400) .eq. 0) .or.
     & (mod(iyear,100) .ne. 0 .and. mod(iyear,4) .eq. 0) ) then
        imon(2) = 29
      else
        imon(2) = 28
      endif  
c
      imonth = 1
100   if (iday .le. imon(imonth)) return
      iday = iday - imon(imonth)
      imonth = imonth + 1
      goto 100
      end               

c   program to make a seisan ascii file
c
c   J. Havskov, January 1991
c
c   latest update:
c   mar xx 91 by j.h. : program goes both ways
c   oct 21 91         : output file name change, comment for vax
c   dec 13            : use 4 byte integers also
c   apr 8  92         : convert many files with filenr.lis
c   may 12            : remove ; from filename
c   nov 13 92         : fix filename length to 100 chars to routine filename
c   nov 15 93         : question to 80 chars
c   jun 7  94         : channels to 999
c   sep 22 94     mv  : bug with format for more than 30 chan
c   dec 7             : include seidim
C   dec 94            : Installed file & error handling (libsei)
c   dec 13       jh   : ************ version 5.0 *********************
CJAB(BGS)Feb95        : Crashing out...too many files open, close files
CJAB(BGS)Feb95          when finished with them, rather than all at the end
c   apr 3 95 jh       : fix start of file nale BA to also remove Ba, bA and ba
CJAB(BGS)Apr95        : Make doubly converted files uppercase.
CJAB(BGS)May95        : Overwrite PC files when converting to binary and the
CJAB(BGS)May95          the Ascii prefix 'A' is missing.eg. 95041804.C44
c oct 95 jh           : use seisinc to read
c--------------------------------------------------------------------
c sep 98 jh           : -------------- version 7.0 check ------------
c                       remove pc file name differences
c nov 5 98 jh         : remove system_c and computer_type from external dec.
c aug 11 04 jh        : do not clse files initially, seems to give
c                       problems on some linux versions
c
      implicit none
      include 'seidim.inc'
      character*80 question
c
c! SINGLE TRACE HEADER
      CHARACTER*1040    TRACEHEAD
c! MAIN HEADERS
      CHARACTER*80      MAINHEAD(max_trace)
      character*80     filein,fileout
      INTEGER           NCHAN
      INTEGER*2         DATA(max_sample*2)
      integer*4         data4(max_sample)	  
      INTEGER           NSAMP
      integer           mode,in,number
      INTEGER           I,ICHAN,k
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei clen,                  ! String length function.
     &          sei upc,                   ! Uppercase conversion.
     &          sei code                   ! Error encoder.
       integer  sei clen                   ! & function.
C
       integer  write01,                   ! Output unit 1.
     &          read01,                    ! Input unit1.
     &          read02,                    ! Ditto 2.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       character*80 chr_file               ! File name
C
C    ============= end of list ==========
c-- 2 or 4 byte word
      character*1       word  	  
c--------- for seisinc ------------------------------
      REAL		X(max_sample)			
      real baz(max_trace)
      character*1 rot_comp(max_trace)  ! T or R
      real        del_rot       ! delay rotated trace
      logical rotate
      equivalence       (data,data4)	  
      common /signalx/x,rotate,baz,rot_comp,del_rot



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c    Initialise...
c    =============
c
c   which conversion
c
       write(6,*)' Seisan binary to ascii  (1)'
       write(6,*)' Seisan ascii  to binary (2)'
       read(5,*) mode
c
c   file
c
 10    continue
       question=' Filename or number, filenr.lis for all'
       call filename(question,filein)
       if(filein(1:3).eq.'EOF') goto 99       
c
c   check for one or many files
c
      in=0
         if(filein(1:10).eq.'filenr.lis') then
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'filenr.lis',     ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
         in=1
      endif
c
c  back here if many files to convert using filenr.lis
c
 11   continue
      if(in.eq.1) then
         read(read01,'(2x,i3,2x,a)') number,filein
         write(6,*)
         if(filein(1:4).eq.'    ') goto 99
      endif
      if(in.eq.0) write(6,'(1x,a)') filein
      if(mode.eq.1.and.in.eq.0) fileout='seiasc.out'
      if(mode.eq.2.and.in.eq.0) fileout='seibin.out'
      if(in.eq.1) then
         fileout=filein
         if(mode.eq.1) fileout='A'//filein
         if(mode.eq.2) then
           fileout='B'//filein
cc
           if(fileout(1:2).eq.'BA'.or.fileout(1:2).eq.'Ba'.
     *     or.fileout(1:2).eq.'ba'.or.fileout(1:2).eq.'ba') then
              i=len(fileout)
              fileout(1:i-2)=fileout(3:i)
              fileout(i-1:i)='  '
              call sei upc( fileout )             !JAB(BGS)Apr95. Uppercase.
           endif
c
c   check that there are no ;'s
c
           i=index(fileout,';')
           if(i.gt.1) then
              fileout(i:i+3)='    '
           endif
         endif
      endif
          
c  
c  open files
c
       i=index(fileout,' ')-1
c
cjh 8-04          if( read02 .gt. 0 ) then               ! Close down if open.
cjh 8-04          call sei close( close$, read02, code ) ! Stop on error.
cjh 8-04          end if                                 !
cjh 8-04          if( write01 .gt. 0 ) then              ! Close down if open.
cjh 8-04          call sei close( close$, write01,code ) ! Ditto.
cjh 8-04          end if                                 !
c
       if(mode.eq.1) then
       chr_f_form$ = 'unformatted'         ! Type of file.
       chr_f_access$='direct'
       f_recl$=2048

c          chr_f_form$ = 'unformatted'
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   filein,           ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
c           open(read02,file=filein,access='direct',recl=2060)
       else
          chr_f_form$ = 'unformatted'
          chr_file = fileout(1:i)
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   chr_file,         ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
       endif
c
       if(mode.eq.1) then
          chr_file = fileout(1:i)
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   chr_file,         ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
       else
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   filein,           ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
       endif
C
C   READ MAIN HEADER 
C
      if(mode.eq.1) then
         call seisinc
     *   (read02,1,NCHAN,0,MAINHEAD,TRACEHEAD,0.0,0.0)

         do 1 i=1,12
c            READ(read02) MAINHEAD(i)
            write(write01,'(a80)')mainhead(i)
 1       continue
c         read(mainhead(1),'(30x,i3)') nchan
c
c   read remaining main header lines if more than 30
c
         if(nchan.gt.30) then
            k=(nchan-31)/3+1
            do i=13,k+12
c               read(read02)mainhead(2)
               write(write01,'(a80)')mainhead(i)
            enddo       
         endif                       
      else
         do 2 i=1,12
            read(write01,'(a80)') mainhead(i)
            write(read02) mainhead(i)
 2       continue
         read(mainhead(1),'(30x,i3)') nchan
c
c   read remaining main header lines if more than 30
c
         if(nchan.gt.30) then
            k=(nchan-31)/3+1
            do i=13,k+12
               read(write01,'(a80)')mainhead(2)
               write(read02) mainhead(2)
            enddo       
         endif                       
      endif
C
C   READ DATA  UNTIL END OF FILE
C
      DO 3 ICHAN=1,NCHAN
         write(6,*)' Channel',ichan
         if(mode.eq.1) then
           call seisinc
     *     (read02,ichan,NCHAN,1,MAINHEAD,TRACEHEAD,0.0,0.0)
c            READ(read02) TRACEHEAD
            DO 4 I=1,13	 		
               WRITE(write01,'(A80)') TRACEHEAD((i-1)*80+1:i*80)
c              write(6,*)TRACEHEAD((i-1)*80+1:i*80)
 4          continue
         else
            DO 5 I=1,13	 		
               READ(write01,'(A80)') TRACEHEAD((i-1)*80+1:i*80)
 5          continue
            write(read02) tracehead
         endif            
C
C   READ NUMBER OF SAMPLES
C
         READ(TRACEHEAD,'(43X,I7)') NSAMP
c         write(6,*)' Number of samples',nsamp
c
c   get if 2 or 4 byte integers
c
         word=tracehead(77:77)
         if(mode.eq.1) then
            if(word.eq.'4') then
c               read(read02)(data4(i),i=1,nsamp)
c               write(write01,'(7i11)')(data4(i),i=1,nsamp)
               write(write01,'(7i11)')(int(x(i)),i=1,nsamp)
            else	    					 
c               READ(read02)(DATA(I),I=1,NSAMP)
c               WRITE(write01,'(13I6)')(DATA(I),I=1,NSAMP)
                WRITE(write01,'(13I6)')(int(x(I)),I=1,NSAMP)
            endif			   
         else
            if(word.eq.'4') then
               read(write01,'(7i11)')(data4(i),i=1,nsamp)
               write(read02)(data4(i),i=1,nsamp)
            else			   			   					 
               READ(write01,'(13I6)')(DATA(I),I=1,NSAMP)
               WRITE(read02)(DATA(I),I=1,NSAMP)
            endif			     
         endif            
 3    continue
C
      write(6,'(a,1x,a)')' Output file name is:',fileout
c
c    Close down files...
c    ===================
c
       call sei close( close$, read02, code ) ! Stop on error.
       call sei close( close$, write01,code ) ! Ditto.
c
c    Next file...
c    ============
c
      if(in.eq.0) goto 10
      if(in.eq.1) goto 11
c
 99   continue
         call sei close(close$+all$,read01, code)       ! Close all open files.
      STOP
      END      

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c  program: gseresp
c           response conversion: SEISAN <-> GSE2 (FAP or PAZ)
c           
c  author:  Lars Ottemoeller, Feb 97
c
c        1         2         3         4         5         6         7
c23456789012345678901234567890123456789012345678901234567890123456789012
c
c  last changes:
c  feb 25 by jh: comment out external
c  mar 14    lo  corrected SEISAN PAZ output
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c ------------------------- SEISAN VERSION 7.0 -------------------------
c  mar 08, 99 lo: changes for year 2000 and 5 chars station code
c  jun 10, 99 lo: use seigse.def file for component conversion
c                 for GSE2 PAZ make use of sfactor variable
c  jun 11     jh  g8 to g8.3 etc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



      program gseresp

      implicit none
c input file
      character*80 infile
c seisan response information
      character*80 respline(13)
      character*1040 respsei
c response output format
      character*1 respout
c counters 
      integer x,c
c overwrite protection
      character*1 overwrite
c input format
      character*1 formatin
c 
      character*80 question

      external resp_sei2gse,inter_p,pazresp
                

c if filenr.lis in=1 else in=0
       integer in

c      external resp_sei2gse   ! commented out by jh, pc problem

C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external computer_type,             ! Get platform type.
     &          systemc                   ! System call.
       external sei open,                  ! Open file routine.
     &          sei close                  ! Close file routine.
       integer  read01,                    ! Input unit 1.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
C
C    ============= end of list ==========


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

   1  Format(a,$)

      overwrite='n'

  10  continue


c start filenr.lis
      in=0
      write(*,*) ' Conversion of response files GSE <-> SEISAN'
      write(*,*)
      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)

      if (infile(1:3).eq.'EOF') STOP
      if(infile(1:10).eq.'filenr.lis') then
         open(1,file='filenr.lis',status='old',err=9999)
         in=1
      endif

11    continue

      write(*,1) ' input format (SEISAN=1, GSE=2) ? '
      read(*,'(a1)') formatin
      write(*,1) ' output format (SEISAN=1, GSE1=2, GSE2=3) ? '
      read(*,'(a1)') respout

      if (respout.eq.formatin) then
        write(*,*) 'input format = output format'
        goto 11
      elseif (formatin.ne.'1'.and.formatin.ne.'2') then
        write(*,*) 'wrong choice !!!'
        goto 11
      elseif (respout.ne.'1'.and.respout.ne.'2'.and.respout.ne.'3')
     &    then
        write(*,*) 'wrong choice !!!'
        goto 11
      elseif (formatin.eq.'2'.and.respout.ne.'1') then
        write(*,*) 'wrong choice !!!'
        goto 11

      endif


  15  continue

      if(in.eq.1) then
         read(1,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(*,'(1x,a)') infile

c get inputfile name

  
      call sei open( old$+warn$,           ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   infile,             ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.

      if (code.NE.0) then
        stop    
c     else
c       call sei close( close$, read01, code ) ! Close file again
      endif


      if (formatin.eq.'1') then
c
c read SEISAN response file
c
         do c=1,13
           read(read01,'(a80)') respline(c)
         enddo

c write respline into one variable
         x=1
         do c=1,961,80
           respsei(c:c+80)= respline(x)
c          write(*,*) respline(x)
           x=x+1
         enddo
         write(*,*) respsei(1:80) 

c close input file

         call resp_sei2gse(respsei,respout,overwrite)

       elseif (formatin.eq.'2') then
       
         call resp_gse2sei(read01,overwrite)

       endif

      call sei close( close$, read01, code ) ! 

      if (in.eq.1) goto 15
      goto 10

9999  continue
      close(1)
      end



      subroutine resp_gse2sei(read01,overwrite)

      implicit none

      integer read01                             ! read unit
      character*90 gseline                       ! gse line
      integer ingse                              ! gse format
      character*5 station,scomp                  ! station name, component
      character*3 g2comp                         ! component in GSE2
      real g2calib,g1calib                       ! calibration in GSE2 / GSE1
      real srate                                 ! samplerate
      integer year,month,day,hour,min,doy        ! time
      real sec 
      character*2 g1comp                         ! component GSE1
      character*3 g1format                       ! PAZ or FAP
      character*4 g2format                       ! FAP2 or PAZ2
c      real scalib                               ! gain or normalization
      double precision scalib,sfactor            ! gain or normalization
      real poler(100),polei(100),
     &     zeror(100),zeroi(100)                 ! poles and zeros
      complex cpole(100),czero(100)
      integer npoles,nzeros                      ! numbers of PAZ
      integer x,c,n                              ! counter
      real frequ(200),amp(200),phase(200)        ! FAP
      integer nfap                               ! number of FAP triplets
      integer iphase                             ! phase as integer
      real frequencies(30)                       ! frequ values if too many PAZ
      complex clxrsp,response                    ! complex amplitude
      character*1 srespout                       ! P or ' '
      real pi
      real sgain                                 ! gain at 1Hz FAP
      real samp(30),sfrequ(30),sphase(30)        ! SEISAN FAP 
      real fr                                    ! frequency
      character*80 outfile                       ! output in SEISAN
      character*80 text(13)                      ! response in SEISAN
      real number(70)                            ! mix of poles and zeros
      character*1 overwrite                      ! overwrite protection
      character*29 mainhead_text
      character*80 file_name
      character*5 net_code


C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external computer_type              ! Get platform type.
       external sei open,                  ! Open file routine.
     &          sei close                  ! Close file routine.
       integer  write01                    ! Input unit 1.
       integer  code                       ! Local condition.
       logical  exist,b_flag               ! exist flag
C
C    ============= end of list ==========



      complex i    

      DATA PI/3.141592654/
      i=(0.0,1.0)
      nfap=0
      nzeros=0
      npoles=0
      sec=0.

      file_name='gsesei.def'
      net_code=' '

      call read_def_chan(file_name,mainhead_text,net_code)


c reading part: GSE1 or GSE2 and FAP or PAZ


100   continue

       read(read01,'(a)',end=9999) gseline
       if (gseline(1:4).ne.'CAL2'.and.gseline(1:4).ne.'CAL1')
     &       goto 100  
       write(*,*) gseline
       if (gseline(1:4).eq.'CAL2') ingse=2
       if (gseline(1:4).eq.'CAL1') ingse=1

c file in GSE2 
       if (ingse.eq.2) then
         read(gseline(6:10),'(a5)') station
         read(gseline(12:14),'(a3)') g2comp
         scomp = g2comp
         call set_def_chan(1,station,scomp)

c         call channel_gse22sei(g2comp,scomp)
         read(gseline(28:37),'(e10.2)') g2calib
c         scalib=1/g2calib*1E9                     ! scalib in counts/m
         scalib=1.0/g2calib          ! bug fix Mario  , lo
         scalib=scalib*1E9
         read(gseline(47:56),'(f10.5)') srate
         read(gseline(58:67),'(i4,1x,i2,1x,i2)')
     &        year,month,day
c         year=year-1900
         read(gseline(69:73),'(i2,1x,i2)') hour,min

c file in GSE1
       elseif (ingse.eq.1) then
         read(gseline(6:10),'(a5)') station
         read(gseline(22:23),'(a2)') g1comp
         scomp = g1comp
         call set_def_chan(1,station,scomp)

c         call channel_gse12sei(g1comp,scomp)
         read(gseline(32:34),'(a3)') g1format
         read(gseline(36:41),'(3i2)')
     &       year,month,day
         if (year.lt.50) then
            year=year+2000
         else
            year=year+1900
         endif
         read(gseline(43:46),'(2i2)') hour,min

       endif


c response in GSE1
       if (ingse.eq.1) then

         if (g1format.eq.'PAZ') then

           srespout='P'    ! PAZ

           read(read01,'(a)',end=9999) gseline
c read poles
           read(gseline(1:8),'(i8)') npoles  ! get number of poles
           do x=1,npoles
             read(read01,'(a)') gseline
             read(gseline(1:8),'(g8.3)') poler(x)
             read(gseline(9:16),'(g8.3)') polei(x)
             cpole(x)=poler(x) + I * polei(x)
c            write(*,*) poler(x),polei(x)
           enddo

           read(read01,'(a)',end=9999) gseline
c read zeros 
           read(gseline(1:8),'(i8)') nzeros  ! get number of poles
           do x=1,nzeros
             read(read01,'(a)') gseline
             read(gseline(1:8),'(g8.3)') zeror(x)
             read(gseline(9:16),'(g8.3)') zeroi(x)
             czero(x)=zeror(x) + I * zeroi(x)
c            write(*,*) zeror(x),zeroi(x)
           enddo 

c read normalization constant 
           read(read01,'(a)',end=9999) gseline
           read(gseline(1:16),'(g16.3)')  g1calib
           scalib=1/g1calib*1E9

         elseif (g1format.eq.'FAP') then 

           srespout=' '
c read FAP  
           read(read01,'(a)',end=9999) gseline
           read(gseline(1:8),'(i8)') nfap  ! get number of fap 
           do x=1,nfap
             read(read01,'(a)') gseline
             read(gseline,'(e10.5,1x,e10.5,1x,e10.4)') frequ(x),
     &         amp(x),phase(x)
             amp(x)=amp(x)*1E9
c            write(*,*) frequ(x),amp(x),phase(x)
           enddo

         endif


       elseif (ingse.eq.2) then

c read PAZ or FAP and numbers
         read(read01,'(a)',end=9999) gseline
         read(gseline(1:4),'(a4)') g2format
         if (g2format.eq.'PAZ2') then
           read(gseline(11:25),'(e15.8)') sfactor
           scalib = scalib / sfactor
           read(gseline(41:43),'(i3)') npoles
           read(gseline(45:47),'(i3)') nzeros
         elseif (g2format.eq.'FAP2') then
           read(gseline(25:27),'(i3)') nfap
         endif

c PAZ
         if (g2format.eq.'PAZ2') then
           srespout='P'   ! PAZ
           do c=1,npoles     ! read the poles
             read(read01,'(a)',end=9999) gseline
             read(gseline(2:16),'(g15.8)') poler(c) 
             read(gseline(18:32),'(g15.8)') polei(c)
             cpole(c) = poler(c) + i  * polei(c)
c            write(*,*) c,cpole(c)
           enddo
 
          do c=1,nzeros    ! read the zeros
             read(read01,'(a)',end=9999) gseline
             read(gseline(2:16),'(g15.8)') zeror(c) 
             read(gseline(18:32),'(g15.8)') zeroi(c)
             czero(c) = zeror(c) + i  * zeroi(c)
c            write(*,*) c,czero(c)
           enddo

c FAP
         elseif (g2format.eq.'FAP2') then
           srespout=' '
           do c=1,nfap
             read(read01,'(a)',end=9999) gseline
             read(gseline(2:11),'(f10.5)') frequ(c)
             read(gseline(13:27),'(e15.8)') amp(c)
             amp(c)=amp(c)/scalib
             read(gseline(29:32),'(i4)') iphase
             phase(c)=iphase
c           write(*,*) frequ(c),amp(c),phase(c)
            enddo
         endif 
       endif
      

c output part in SEISAN
c       maximum of FAP pairs is 30, if more than interpolate
c       maximum of PAZ is 37, if more than convert to FAP
c        

c set desired frequency value
      data(frequencies(x),x=1,30) / 
     &.01,.014,.019,.026,.035,.048,.065,.089,.12,.17,.23, 
     &.31,.42,.58,.79,1.1,1.5,2.,2.8,3.8,5.2,7.,9.6,13.,18.,
     &25.,34.,46.,63.,86./

      if (srespout.eq.' ') then
        if (nfap.ne.30) then
          fr=1.0
          call inter_p(nfap,fr,frequ,amp,phase,
     &       fr,response)
          sgain=cabs(response)
          do x=1,30
            call inter_p(nfap,fr,frequ,amp,phase,
     &        frequencies(x),response)
c           write(*,*) frequencies(x),response
            sfrequ(x)=frequencies(x)
            samp(x)=cabs(response)/sgain
            sphase(x)=ATAN2(aimag(response),real(response
     &        ))*(180./PI)
            write(*,*) sfrequ(x),samp(x),sphase(x)
          enddo  
        else          ! get gain at 1 Hz and write response
                    ! into sfrequ, samp, sphase
          fr=1.0
            call inter_p(nfap,fr,frequ,amp,phase,
     &        fr,response)
          sgain=cabs(response)
          do x=1,30
            samp(x)=amp(x)/sgain
            sfrequ(x)=frequ(x)
            sphase(x)=phase(x)
          enddo
        endif

      elseif (srespout.eq.'P') then

        if (npoles+nzeros.gt.37) then  ! 37
          srespout=' '  ! FAP
c get amplitude at 1 Hz
          fr=1.0
          call pazresp(fr,scalib,nzeros,czero,
     &       npoles,cpole,clxrsp)
          sgain=CABS(clxrsp)

c get FAP values using the routine pazresp
          do x=1,30
            call pazresp(frequencies(x),scalib,nzeros,czero,
     &        npoles,cpole,clxrsp)
            sfrequ(x)=frequencies(x)
            samp(x)=CABS(clxrsp) / sgain
            sphase(x)=ATAN2(aimag(clxrsp),real(clxrsp))*(180./PI)
c           write(*,*) clxrsp
            write(*,*) sfrequ(x),samp(x),sphase(x)
          enddo
        endif
      endif



c
c SEISAN OUTPUT
c

        do x=1,80
           outfile(x:x)= ' '
        enddo


c make filename and open file
c123456789012345678901234567890
cLOF__A__Z.1989-11-22-1200
c        call date_doy(doy,day,month,year)     ! get day of year
        write(outfile(1:5),'(a5)') station(1:5)
        write(outfile(6:9),'(a4)') scomp
        write(outfile(10:10),'(a1)') '.'
        write(outfile(11:14),'(i4)') year
        outfile(15:15) = '-'
        write(outfile(16:17),'(i2)') month
        outfile(18:18) = '-'
        write(outfile(19:20),'(i2)') month
        outfile(21:21) = '-'
        write(outfile(22:23),'(i2)') hour
        write(outfile(24:25),'(i2)') min

        do x=1,9
          if (outfile(x:x).eq.' ') outfile(x:x)='_'
        enddo

        do x=11,25
          if (outfile(x:x).eq.' ') outfile(x:x)='0'
        enddo
            

        write(*,*) outfile(1:25)

c clear text
      do x=1,13
        do c=1,80
          text(x)(c:c)=' '
        enddo
      enddo        

c write first line
      write(text(1)(1:5),'(a5)') station
      write(text(1)(6:9),'(a4)') scomp
      write(text(1)(10:12),'(i3)') year-1900
      write(text(1)(14:16),'(i3)') doy
      write(text(1)(18:19),'(i2)') month
      write(text(1)(21:22),'(i2)') day
      write(text(1)(24:25),'(i2)') hour
      write(text(1)(27:28),'(i2)') min 
      write(text(1)(30:35),'(f6.3)') 0.
      write(text(1)(78:78),'(a1)') srespout

     

c write FAP

      if (srespout.eq.' ') then

c no comments in second line
c third line, gain at 1Hz only
        write(text(3)(41:48),'(g8.3)') sgain
 
c write frequencies
        c=0
        do x=1,73,8
          c=c+1
          write(text(5)(x:x+7),'(g8.3)') sfrequ(c)
        enddo
        c=10
        do x=1,73,8
          c=c+1
          write(text(8)(x:x+7),'(g8.3)') sfrequ(c)
        enddo
        c=20
        do x=1,73,8
          c=c+1
          write(text(11)(x:x+7),'(g8.3)') sfrequ(c)
        enddo

c write amplitudes
        c=0
        do x=1,73,8
          c=c+1
          write(text(6)(x:x+7),'(g8.3)') samp(c)
        enddo
        c=10
        do x=1,73,8
          c=c+1
          write(text(9)(x:x+7),'(g8.3)') samp(c)
        enddo
        c=20
        do x=1,73,8
          c=c+1
          write(text(12)(x:x+7),'(g8.3)') samp(c)
        enddo

c write phase
        c=0
        do x=1,73,8
          c=c+1
          write(text(7)(x:x+7),'(f8.3)') sphase(c)
        enddo
        c=10
        do x=1,73,8
          c=c+1
          write(text(10)(x:x+7),'(f8.3)') sphase(c)
        enddo
        c=20
        do x=1,73,8
          c=c+1
          write(text(13)(x:x+7),'(f8.3)') sphase(c)
        enddo




c write PAZ

      elseif (srespout.eq.'P') then

c write 3rd line
        write(text(3)(1:22),'(1x,2i5,g11.4)') npoles,nzeros,
     &      scalib 
        write(text(3)(23:77),'(5G11.4)') 
     &    poler(1),polei(1),poler(2),polei(2),poler(3)

c write remaining poles and zeros
        do x=1,npoles-2
          number(x*2-1)=polei(x+2)
          number(x*2)=poler(x+3)
        enddo

        do x=1,nzeros
          number(x*2-1+npoles*2-2)=zeror(x) 
          number(x*2+npoles*2-2)=zeroi(x)
        enddo

        n=0
        do c=4,13
          do x=1,67,11
            n=n+1
            if (n.le.(npoles-2)*2-1+nzeros*2) then
              write(text(c)(x:x+10),'(g11.4)') number(n)
            endif
          enddo
        enddo

      endif


c open file

 150  CONTINUE

      call sei open( check$,               ! check if file exists
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   exist,            ! Flag.
     &                   code )            ! Returned condition.

      if (exist) then
        if (overwrite.ne.'a'.and.overwrite.ne.'A') then
          write(*,*) outfile,' exists !!!'
          write(*,*) 'overwrite (y/n/a=always) ?  '
          read(*,'(a1)') overwrite
        endif
        if (overwrite.eq.'n'.or.overwrite.eq.'N') then
          write(*,*) 'new file name :  '
          read(*,'(a80)') outfile
          goto 150
        else
          call sei open( old$,           ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,            ! Flag.
     &                   code )            ! Returned condition.

        endif
      else
        call sei open( new$,           ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,            ! Flag.
     &                   code )            ! Returned condition.


      endif

      write(*,'(a,a)') ' output file :  ',outfile


c write to file
 
      write(*,*) text(1)
      do c=1,13
        write(write01,'(a80)') text(c)
      enddo

 200  continue



9999   continue

       call sei close( close$, write01,code ) ! Close file

       return
       end

c                                                                               
c    transform an ascii file to seisan data file. the input file only contains
c    one column of samples 
c                                                                               
c    j. havskov jan 96                    
c    may 11  00    lo : use read_resp_head
c    feb 02  03    jh : small clean up
c    sep 13           : add input of psn ascii
c    dec 17 2003   jh : fix channel header year, no century
c    aug 30, 2005  jh : fix filename and network code
c    oct 18  2005     : put in scale factor
c
c    latest update                                                              
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
c                                                                               
c-- seisnor data file channel header      
      character*1040    chahead         
c-- -------------------main --------      
      character*80     mainhead(max_trace)
      character*80     text        
c-- date and time
      integer year,month,day,hour,min
      real sec
c-- output file name                                  
      character*80	outfile		
      character*80  question
      character*80  infile
c      character*50      save_head	
c-- stations and components
      character*4 comp(max_trace)
      character*5 stat(max_trace)
c-- data vector, one buffer or one channel                              
      integer*4     data4(max_sample)
      real          x(max_sample)
      real          factor		! scale factor



c-- data interval each channel, start time
      real cinter(max_trace),cstart(max_trace)
c-- number of channels and samples/chan, total number of samples           
      integer nchan,nsamp
c-- sample rate                                              
      real		rate		
c-- help variables                                     
      integer		i,in
 
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver


c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.infile(1:10).eq.
     *'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old')

c
c   check if a psn ascii file
c
       read(1,'(a)' )text
       if(text(1:5).eq.'! PSN') then
          read(1,'(12x,i4,4(1x,i2),1x,f6.3)') 
     *    year,month,day,hour,min,sec
          read(1,'(a)') text
          read(1,'(4x,i4)') i
          rate=i
          do i=1,7
            read(1,'(a)') text
          enddo
          read(1,'(16x,a5)') stat(1)
          if(stat(1).eq.' ') stat(1)='STAT '
          do i=1,4
             read(1,'(a)') text
          enddo
          write(6,'(a)') text
          comp(1)='S   '
          read(1,'(20x,a1)') comp(1)(4:4)
          do i=1,12
            read(1,'(a)') text
          enddo
       else
c
c   get parameters
c
          write(6,*) 'year,month,day,hour,min,sec'
          read(5,*) year,month,day,hour,min,sec
          write(6,*)'sample rate'
          read(5,*) rate
          write(6,*)'station, max 5 chars' 
          read(5,'(a5)') stat(1)
          write(6,*)'component, max 4 chars' 
          read(5,'(a4)') comp(1)
       endif
       factor=1.0
       write(6,*)' Enter scale factor, return for no scaling'
       read(5,'(a)') text
       if(text.ne.' ') then
         call sei get values (1,text,i) 
         factor=array$(1)
       endif
       
c
c   read data
c
       nsamp=1
 222   continue
       read(1,*,end=333,err=333) x(nsamp)
c      write(6,*) x(nsamp),factor
       data4(nsamp)=x(nsamp)*factor
       nsamp=nsamp+1
       goto 222
 333   continue
       nsamp=nsamp-1

       cinter(1)=(nsamp-1)/rate

c                                                                               
c  make file name and main header
c             
         nchan=1
         call mfhead(year,month,day,hour,min,sec,cinter(1),nchan,
     *   stat(1),stat,comp,cstart,cinter,outfile,mainhead)
c
c   different components could be at the same time, add
c   component id to file name
c
         outfile(30:30)='_'
         outfile(32:32)=comp(1)(4:4)
         outfile(31:31)=comp(1)(1:1)
         do i=30,32
            if(outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo
         write(6,'(a,a)') ' Outfile name: ',outfile(1:32)
c
c  open file
c
         open(2,file=outfile,status='unknown',form='unformatted')
c                                                                               
c   write  main header                                       
c                                                                               
         write(6,'(a)') mainhead(1)(1:75)
         do i=1,12
            write(2) mainhead(i)                                         
         enddo
c                                                                               
c  write channel with channel header
c                                                                               
            do i=1,1040                                                         
               chahead(i:i)=' '                                                 
            enddo                                                               
c-- station code                          
            chahead(1:5)=stat(1)
c-- componnet
            chahead(6:9)=comp(1)	
c-- year, date and time                  
            chahead(10:35)=mainhead(1)(34:59)		
            write(chahead(37:43),'(f7.2)') rate                          
            write(chahead(45:50),'(i6)') nsamp                                  
c                                                                               
c   get response
c
             call read_resp_head(chahead)       
c
c   indicate 2 or 4 byte integer in header
c
             chahead(77:77)='4'
c                                                                               
c   write header                                                                
c                                                                               
            write(2)chahead                                                     
            write(6,'(1x,a70)') chahead(1:70)                                   
c  
c   write data
c
            write(2)(data4(i),i=1,nsamp)
            close(2)
c
c   back for next file
c
            if(in.eq.1) goto 1000                                                                    
 99   continue                                                                  
      stop                                                                      
      end                                                                       

c$DEBUG
c
c  Convert pdas files to seisan format
c  
c  At the end of the program is a pdas format description
c
c  j. havskov, december 1991
c
c
c  Carl Mulchay from Geotech Instruments has been very helpful in 
c  supplying format descriptions and test data.
c
c  updates:
c  jan 31 91 by jh: change to read 4 bytes integer a la federico
c  feb 2        cl: read 177 bytes dir access on sun
c  feb 3        cl: due to F77 problems a program pdabin is called and made to create
c  aug 23 93 jh   : filenames to 80
c                   the binary file from an ascii file: pdaasc.out
c  feb 1 94       : header length erroor on sun was 178, now 177
c  aug 95         : header length on pc now seem sto be 184 ????
c                   also fix so program works on pc without pdabin
c  sep 15, 95     : read only the sun way, so header lenght can be variable
c                   however a few samples are then lost at the end, change
c                   pc file names, divide numbers by 1000.
c  spring 96      : use the correct pdas format, the earlier divide by
c                   1000 was caused by having 2 byte or gainranged data
c                   when 4 byte data was assumed !!!!!!!!!!!!!!
c april 99 by jh   : ----------   verision 7.0 upggrade------------------
c august 31       : bugs that was never fixed
c jan 21          : add component to file name
c may 11  00   lo : use read_resp_head
c feb 03  03   jh : remove intand, now in compdecomp
c
c  The program can work with 2 byte, 4 byte and gain ranged data. 
c  It is assumed that channel 1,2 and 3 are SP Z, N and E respectively.
c  If not, change the program. There is no predefined codes for
c  channels 4-6, can be put in. Station codes can be given in an
c  input file pdasei.def, if no def file, the seiral number are used.
c
c  First the header is read with record
c  length 1 to find the length (mostly it seems 177), then the file is closed
c  and reopened with record length = header length. This means that the
c  part of the last record is lost corressponding to max e.g. 177/4 samples.
c  this can be avoided quite easily by reading reading one byte at a time, but
c  it is slowwwwww.
c
c
       implicit none
      include 'libsei.inc'
      include 'seidim.inc'
c-- one byte of data	  
      character*1 onebyte
c-- type of data bytes
      character*4 byte
c-- input data vector	  
      integer*4 data(max_sample),data_temp(max_sample)
      integer*2 data2(max_sample*2)
c-- input data text string, equivalent to data and data2
      character*1 text(max_sample*4)
      character*80 txt   ! general text string
c-- dummy text string used in read statement; Max. length of record=1000
      character*1000 dummy
c-- one sample	  
	  integer*4 x
c-- one sample in 4 bytes	  
	  character*4 swap
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  

c
c   block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  

c-- Pdas header	  
	  character*500 pdas_head
c-- date and time
      character*2 cyear,cmonth,cday,chour,cmin
c-- start sec
      character*6 csec
      character*1 acomp	  	  	  
c-- sampling interval
      real interval	  	  	  	  	  
c--Counters etc
	  integer isamp,i,k,ib,flag,ijk,nbytes,j,nrec
      integer gain   ! gain exponent when gain ranging
c-- computer type
      logical pc,sun,linux	  
	  equivalence (x,swap)
	  equivalence (data,text)
      equivalence (data2,text)


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)
c
      chour= '  '
      cmonth='  '
c
      write(6,*)' This program converts 2 byte, 4 byte and'
     *,' gain ranged data'
      write(6,*)
c
c   get pdas def file for station codes
c
      txt='pdasei.def'
      call read_def_chan(txt,mainhead_text,net_code)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file and read header
c
       open(1,file=infile,access='direct',recl=1,status='old')
       k=1		 
       ib=1
       flag=0	  
  1    continue
       read(1,rec=k) onebyte
       pdas_head(k:k)=onebyte
      if(onebyte.eq.':') flag=1
      if(k.gt.3.and.pdas_head(k-3:k).eq.'DATA'.and.flag.eq.1) then
         k=k+1
	     read(1,rec=k) onebyte
         k=k+1
	     read(1,rec=k) onebyte
         goto 2
      endif
	  k=k+1		 
	  goto 1 
 2    continue
c
c--  Close and open again, but now with record length equal the full header
c--  Also read header again, but this is later overwritten
      close(1)
      open(1,file=infile,access='direct',recl=k,status='old')
	  read(1,rec=1)dummy(1:k)
      write(6,*)' header length is ',k
c
c   write header
c	   	   	 
      write(6,'(1x,a)')	pdas_head(1:k-1) 
c
c   find date etc from header. Since values are found by finding
c   relevant chars, it should work also if header changes
c	   
       cyear=' '
       cmonth=' '
       cday=' '	   
       chour=' '
       cmin=' '
       csec=' '
       comp(1)='S   Z'
c-- station number used as name
       stat(1)(1:3)=pdas_head(11:13)
       stat(1)(4:5)='  '

       do i=4,k-1
c
c   format of samples
c
          if(pdas_head(i:i+8).eq.'FILE_TYPE') then
             if(pdas_head(i+10:i+12).eq.'INT') byte='two '  ! two byte data
             if(pdas_head(i+10:i+12).eq.'LON') byte='four'  ! four byte data
          endif
          if(pdas_head(i:i+6).eq.'COMMENT') then
              if(pdas_head(i+8:i+11).eq.'GAIN') byte='gain' ! gain ranged
          endif
c
c-- date and time
c
          if(pdas_head(i:i).eq.'-'.and.cmonth.eq.'  ') then
             cmonth=pdas_head(i-2:i-1)
             if(pdas_head(i+3:i+3).eq.'-') then
                cday=pdas_head(i+1:i+2)
                cyear=pdas_head(i+4:i+5)				
             else
                cday(2:2)=pdas_head(i+1:i+1)
                cday(1:1)=' '		
                cyear=pdas_head(i+3:i+4)
             endif
            read(cyear,'(i2)') year(1)
            if(year(1).lt.50) then
               year(1)=year(1)+2000
            else
               year(1)=year(1)+1900
            endif
            read(cmonth,'(i2)') month(1)
            read(cday,'(i2)') day(1)
         endif
          if(pdas_head(i:i).eq.':'.and.chour.eq.'  ') then
             chour=pdas_head(i-2:i-1)
             read(chour,'(i2)') hour(1)
             cmin=pdas_head(i+1:i+2)
             read(cmin,'(i2)') min(1)
             csec(2:6)=pdas_head(i+4:i+8)
             csec(1:1)=' '
             read(csec,'(f6.3)') sec(1)			 
          endif
c--- channel
          if(pdas_head(i-3:i).eq.'nnel') then
             acomp=pdas_head(i+1:i+1)		  
             if(pdas_head(i+1:i+1).eq.'1') comp(1)='S  Z'
             if(pdas_head(i+1:i+1).eq.'2') comp(1)='S  N'
             if(pdas_head(i+1:i+1).eq.'3') comp(1)='S  E'
          endif			   
c--- rate
          if(i.gt.10.and.pdas_head(i-3:i).eq.'RVAL') then
             read(pdas_head(i+1:i+7),'(f6.2)') interval
             if(interval.ne.0.0) rate(1)=1.0/interval
          endif
       enddo
c
c   put in definition from def file
c
         call set_def_chan(1,stat(1),comp(1))

c
c   read data, one header lenght of bytes
c   On sun swap is done by first storing byte 4 in 1 etc.
c	   		  	
       isamp=1
       ijk = 1
	   nrec = 2
 30    read(1,rec=nrec,err=40)dummy(1:k)
       nrec = nrec + 1
       do j = 1,k
         text(ijk) = dummy(j:j)
	     ijk = ijk + 1
	   enddo
	   go to 30
c		  
 40    continue
       write(*,*)' Reading finished with',nrec-2,' records of data'
	   write(*,*)' Number of bytes:',ijk-1
       write(*,*)' Type of data storage ', byte
       nbytes = ijk-1
       if(byte.eq.'four') isamp = nbytes/4
       if(byte.eq.'two ') isamp = nbytes/2
       if(byte.eq.'gain') isamp = nbytes/2
c
c   sometimes last block seems to be corrupted by the above reading routine
c   so throw away
c
       isamp=isamp-80
       cbyte(1)='4'
       if(byte.eq.'two ') cbyte(1)=' '
c
c  do swapping
c		  
       if(sun) then
          if(byte.eq.'four') then
		  do ijk = 1,nbytes,4
		     write(swap,'(4a1)')text(ijk),text(ijk+1),
     +       text(ijk+2),text(ijk+3)
             text(ijk)=swap(4:4)
             text(ijk+1)=swap(3:3)
             text(ijk+2)=swap(2:2)
             text(ijk+3)=swap(1:1)
		  enddo
          endif
          if(byte.eq.'two '.or.byte.eq.'gain') then
		  do ijk = 1,nbytes,2
		     write(swap,'(2a1)')text(ijk),text(ijk+1)
             text(ijk)=swap(2:2)
             text(ijk+1)=swap(1:1)
		  enddo
          endif
       endif
c
c   write seisan file, first make headers
c

 10   continue
c      write(6,*)year(1),month(1),day(1),hour(1),min(1),sec(1)
c      write(6,*)nsamp(1),rate(1),cbyte(1),net_code
      write(6,*) ' Number of samples',isamp 
c      read(5,*) i
c
c   make seisan headers
c
      nchan=1
      ichan=1
      nsamp(1)=isamp
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   add componenets to make filenames different for different channels
c   and a number to put channels in right order when sorting
c
         if(comp(1)(4:4).eq.'Z') outfile(30:30)='1'
         if(comp(1)(4:4).eq.'N') outfile(30:30)='2'
         if(comp(1)(4:4).eq.'E') outfile(30:30)='3'
         outfile(31:34)=comp(1)
         do i=31,34
            if(outfile(i:i).eq.' '.or.outfile(i:i).eq.char(0)) 
     *      outfile(i:i)='_'
         enddo
         write(6,'(1x,a)') outfile(1:34)                                             
         write(6,*)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write data
c
      write(6,'(1x,a)')mainhead(1)(1:78)
      do i=1,12
        write(2)mainhead(i)
      enddo
c
c   decode gain ranging
c
      if(byte.eq.'gain') then
         do i=1,isamp
            data_temp(i)=data2(i)
            call intand(data_temp(i),3,gain)   ! find gain exponent
            data_temp(i)=data_temp(i)/4       ! strip off two low bytes
            data_temp(i)=data_temp(i)*8**(5-gain)  ! correct for exponent
c            write(16,*) gain,data2(i),data_temp(i)
         enddo
         do i=1,isamp
            data(i)=data_temp(i)
         enddo
      endif
c
c   read response curve into header
c

           call read_resp_head(chahead)                          

      write(2) chahead
      write(6,'(1x,a)') chahead(1:78)
      if(byte.eq.'four'.or.byte.eq.'gain') 
     *  write(2)(data(i), i=1,isamp)
      if(byte.eq.'two ') 
     *  write(2)(data2(i),i=1,isamp)
      write(6,*)
      close(1)
      close(2)

c
c  back for next file if many
c
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  
								  
C
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c                  PDAS-100 MANUAL EXCERPT                                      
c                                                                               
c                     DATA FILE FORMAT                                          
c                                                                               
c                                                                               
c 4.1.7 Data File                                                               
c                                                                               
c The data file has two parts, a record header and the collected                
c data for a channel.  These files are written to sub-directories               
c  on the PDAS-100 static RAM disk during acquisition.  Each channel            
c  being recorded has its own sub-directory, \CH0, \CH1....                     
c There are four types of files which can be recorded for a channel,            
c  each with its own letter designating type:                                   
c                                                                               
c      \CHj\Pjnnnsss.doy       Primary Window Record                            
c      \CHj\Sjnnnsss.doy       Secondary Window Record                          
c      \CHj\Cjnnnsss.doy       Calibration Window Record                        
c      \CHj\Ejnnnsss.doy       Event Record                                     
c                                                                               
c             j - channel number                                                
c           nnn - last three digits of PDAS-100 serial number                   
c           sss - sequence number                                               
c           doy - day of year of start of file                                  
c                                                                               
c                                                                               
c                                   NOTE                                        
c                                                                               
c The sequence number for Primary windows and for Calibra-tion                  
c windows use the same counting sequence.  That is to say if the                
c first recording of the day was a primary window, it would have                
c sequence number 001.  If the second and third recordings for                  
c that day were calibrations they would be sequence numbers 002                 
c and 003.  If the next recording was a primary window it would                 
c have sequence number 004.                                                     
c                                                                               
c                                                                               
c 4.1.7.1  Data File Header                                                     
c                                                                               
c The first part of the data file is a text listing defining the contents of the
c file.  In particular, this text is in DADiSP import format.  An example data  
c file header follows.                                                          
c                                                                               
c      DATASET  P1001001134                                                     
c      FILE_TYPE  LONG                                                          
c      VERSION next                                                             
c      SIGNAL  channel 1                                                        
c      DATE  5-13-88                                                            
c      TIME   17:59:00.00  (000)                                                
c      INTERVAL  0.010                                                          
c      VERT_UNITS    Counts                                                     
c      HORZ_UNITS   sec                                                         
c      COMMENT   None                                                           
c      DATA                                                                     
c                                                                               
c Definitions for each of the lines in the data file header follow:             
c                                                                               
c                                                                               
c DATASET                                                                       
c                                                                               
c The data set is the DOS file name assigned to the data file during            
c acquisi-tion.  Note that the file extension has been moved to the             
c left of the decimal point.                                                    
c                                                                               
c                                                                               
c FILE TYPE                                                                     
c                                                                               
c The file type defines the method by which the data was recorded and           
c  is stored in the DOS file.                                                   
c                                                                               
c      INTEGER      16-bit (2 byte) FG data samples                             
c         LONG      32-bit (4 byte) data samples                                
c         LONG      14/2 (2 byte) GR data samples                               
c               (see COMMENT also)                                              
c                                                                               
c                                                                               
c VERSION                                                                       
c                                                                               
c The 'next' parameter in this field causes DADiSP to find the highest          
c existing version of the Dataset Name and sets the new version to the          
c next higher value.                                                            
c                                                                               
c                                                                               
c SIGNAL                                                                        
c                                                                               
c This field contains the name given to the channel when the ASP screen         
c was defined during the experiment configuration file creation.                
c                                                                               
c                                                                               
c DATE                                                                          
c                                                                               
c This field contains the date that the data file was recorded.                 
c                                                                               
c                                                                               
c TIME                                                                          
c                                                                               
c This field contains the time for the first sample in the                      
c data                                                                          
c file.  It is recorded in 24 hour format with millisecond                      
c resolution.  The PDAS starts each recording block at the                      
c 10 millisecond mark.  For event files, 1 to 9 milliseconds                    
c are added to the pre-event length to place the start of the                   
c data set on a 10 millisecond mark.                                            
c                                                                               
c                                                                               
c INTERVAL                                                                      
c                                                                               
c This field will reflect the chosen sample rate for the data                   
c channel.  It is provided as sample interval with the units                    
c of seconds.                                                                   
c                                                                               
c                                                                               
c VERT UNITS                                                                    
c                                                                               
c The vertical units for the data will always be counts.                        
c                                                                               
c                                                                               
c HORZ UNITS                                                                    
c                                                                               
c The horizontal units for the data will always be sec. (The                    
c abbreviation for seconds).                                                    
c                                                                               
c                                                                               
c COMMENT                                                                       
c                                                                               
c The information in this field will vary depending on how the data             
c was recorded within the PDAS.  The following information describes            
c what will be in the COMMENT field based on what recording mode was            
c selected.                                                                     
c                                                                               
c                                                                               
c      COMMENT                    DATA FILE TYPE                                
c                                                                               
c      NONE          16 bit (2 byte) FG data samples (INTEGER)                  
c                    32 bit (4 byte) FG data samples (LONG)                     
c       GAINRANGED   14/2 (2 byte) GR. data samples 14/2                        
c (LONG)                                                                        
c     DEGAINRANGED    32 BIT (4 byte) FG data samples (LONG)                    
c                     which were acquired an 14/2 GR samples                    
c and                                                                           
c                     degain-ranged using the DRANGE program.                   
c                                                                               
c                                                                               
c                                 NOTE                                          
c                                                                               
c The data file header is variable in length.  The actual channel data          
c is preceded bythe following string:                                           
c                                                                               
c                          DATA<CR><LF>                                         
c                                                                               
c A suggested method for searching for the channel data is to                   
c perform a string search for the word DATA, then skip two                      
c bytes.  The balance of the channel data file is data in one                   
c of the formats described In the following section.                            
c                                                                               
c                                                                               
c 4.1.7.2  Data File Data                                                       
c                                                                               
c The second part of the data file is the digitized data                        
c collected for the channel.  This is stored in binary                          
c according to three formats.                                                   
c                                                                               
c       Two byte integer                                                        
c       Four byte Integer                                                       
c       Two byte gain range                                                     
c                                                                               
c In all-cases the bytes are organized in 'INTEL" format.                       
c INTEL format for 16 bit data words (as well as 32 bit LONGS)                  
c assumes that the most significant byte is at the highest                      
c memory location.  Bits within the byte follow the convention                  
c of most significant bit being the lift most bit and least                     
c significant bit being the right most.                                         
c                                                                               
c Use of the two byte recording formats increases the length of                 
c data which may be recorded on the PDAS-100, while use of the                  
c four byte integer format provides the most resolution.                        
c                                                                               
c                                                                               
c 16-BIT DATA FORMAT                                                            
c                                                                               
c The two byte integer is stored in two's complement format.                    
c To convert this count to voltage, use the following formula:                  
c                                                                               
c       Let m be the digitized value in counts.                                 
c       Let p be the preamp gain.                                               
c       Let v be volts.                                                         
c                                                                               
c    Then:  v = m / (32768 * p)      high gain inputs                           
c           v = 20 * m / (32768 * p)       low gain inputs                      
c                                                                               
c (Preamp gain (p) = 1, 10 or 100 as specified in ASP set-up.)                  
c                                                                               
c                                                                               
c 32-BIT DATA FORMAT                                                            
c                                                                               
c The four byte integer is also stored in two's complement format.              
c To convert this count to voltage, use the following formula:                  
c                                                                               
c      Let a be the digitized value in counts.                                  
c      Let v be volts.                                                          
c                                                                               
c    Then: v = m / 2147483648        high gain inputs                           
c          v = 20 * m / 2147483648 low gain inputs                              
c                                                                               
c                                                                               
c 14/2 GAIN RANGED FORMAT                                                       
c                                                                               
c The two byte gain ranged format uses a 14/2 gain range.  The gain             
c code is stored in the two least significant bits of the 16 bits,              
c and the digitized value is in the upper 14 bits of the 16 bits.               
c                                                                               
c      Let g be the gain code from the lower two bits.                          
c      Let p be the preamp gain.                                                
c      Let m be the value (two's complement) in upper 14.                       
c      Let v be volts.                                                          
c                                                                               
c    Then:  v = m * (8**(5-g)) / (268435456 * p)        high gain inputs        
c           v = 20 * (m * (8**(5-g))) / (268435456 * P) low gain inputs         
c                                                                               
c The digitized samples are stored packed in the rest of the data file          
c until the end of file is reached.                                             
c 

c
c    program to check total content of seisan distribution
c
c    the input file with all info is in seisan.all and is located in the
c    seisan DAT directory
c
c    the program can be operated from any directory
c
c changes:
c   August 9, 2001  : add SUP directory
c   May 8, 2003     : small change in questions, used known top dir
c

      implicit none
      character*80 text(1000)   ! whole file
      character*1  dchar        ! dir char
      character*80 top_dir      ! seisan top directory
      integer      nt           ! length of top_dir
      character*80 file         ! input file
      integer      nline        ! number fo lines in input file
      logical      exist        ! true if a file exists
      character*5  dirc         ! verison directory
      integer      nfile_ex_err ! files not found
      integer      nfile_co_err ! compiled files not found
      integer      nfound       ! number of files found
      character*3  dir          ! seisan directory
      character*1  basic_check,comp
      logical      unix,pc      ! system checked
      integer      seiclen
      integer      i,k,l   


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      nfile_ex_err=0
      nfile_co_err=0
      nfound=0
      unix=.false.
      pc=.false.
c
      call dir_char(dchar)
c
c    
      call topdir(text(1))
      write(6,*) ' Top directory is defined as: ',text(1)
      write(6,*) ' If not correct,'
      write(6,*) ' Give SEISAN top directory, e.g. /net/seismo/'
      write(6,*) ' If ok, return'
      read(5,'(a)') text(2)
      if(text(2).eq.' ') then
         top_dir=text(1)(1:seiclen(text(1)))//dchar
      else
         top_dir=text(2)
      endif 
      write(6,*)' Basic single platform (b) or '
      write(6,*)
     *' check full original distribution of all platforms (d) ?'
      read(5,'(a)') basic_check
      if(basic_check.eq.'b') then
 88     continue
        write(6,*) 'Unix or PC (u/p)'
        read(5,'(a1)') comp
        if(comp.ne.'u'.and.comp.ne.'p') goto 88
        if(comp.eq.'u') unix=.true.
        if(comp.eq.'p') pc=.true.
      endif
c
c   open and read file
c
      nt=index(top_dir,' ')
      nt=nt-1
      file=top_dir(1:nt)//'INF/seisan.all'
      open(1,file=file,status='old',err=10)
      goto 11
 10   continue
         write(6,'(a,a,a)')' File ',file(1:nt+10),' does not exist'
         stop
 11   continue
c
      nline=1
 12   continue 
      read(1,'(a)',end=13) text(nline)
      nline=nline+1
      goto 12
c
c   end of file
c
 13   continue
      close(1)
      nline=nline-1
      write(6,*)' Number of lines in seisan.all file ', nline
c
c   open output error file
c
      open(2,file='check.out',status='unknown')
      open(3,file='check_ok.out',status='unknown')
c
c   first check existance of all files
c
      dir=' '
      do i=1,nline
         if(text(i)(1:3).eq.'PRO'.or.text(i)(1:3).eq.'LIB'.or.
     *      text(i)(1:3).eq.'INC'.or.text(i)(1:3).eq.'DAT'.or.
     *      text(i)(1:3).eq.'COM'.or.text(i)(1:3).eq.'INF'.or.
     *      text(i)(1:3).eq.'PIC'.or.text(i)(1:3).eq.'SUP') then
            dir=text(i)(1:3)
         endif
c
c   extract file name
c
         if(text(i)(3:3).eq.' '.and.text(i)(1:14).ne.' '.
     *      and.dir.ne.'   ') 
     *      then
               k=index(text(i)(4:80),' ')
               dirc=' '
               if(text(i)(1:1).eq.'p') dirc='PCWIN'
               if(text(i)(1:1).eq.'o') dirc='SUNOS'
               if(text(i)(1:1).eq.'s') dirc='SOLAR'
               if(text(i)(1:1).eq.'l') dirc='LINUX'
               if(basic_check.eq.'b') then
                  if( dirc.eq.'PCWIN'.and..not.pc) goto 200 ! file not there
                  if((dirc.eq.'SOLAR'.or.dirc.eq.'SUNOS'.or.dirc.
     *                   eq.'LINUX'.or.text(i)(1:1).eq.'u').
     *                   and..not.unix) 
     *                   goto 200 ! file should not be there
                  dirc=' '  ! basic check of only main dirs
               endif
                  
               if(dirc.eq.' ') then
                  if(dir.eq.'DAT'.and.basic_check.ne.'b') then   ! if DAT, one more DAT level
                     file=top_dir(1:nt)//dir//'/'//dir//'/'//
     *               text(i)(4:k+2)
                     l=nt+3+1+k-1+4
                  else
                     file=top_dir(1:nt)//dir//'/'//text(i)(4:k+2)
                     l=nt+3+1+k-1
                  endif
               else
                  if(dir.eq.'DAT') then
                     file=top_dir(1:nt)//dir//'/'
     *               //dir//'/'//dirc//'/'//text(i)(4:k+2)
                     l=nt+3+1+5+1+k-1+4
                  else
                     file=top_dir(1:nt)
     *               //dir//'/'//dirc//'/'//text(i)(4:k+2)
                     l=nt+3+1+5+1+k-1
                  endif
               endif

c            write(6,'(a)') file
            inquire(file=file,exist=exist)
             

            if(.not.exist) then
               write(6,'(a,a)') ' File not found: ',file
               write(2,'(a,a)') '          File not found: ',file
               nfile_ex_err=nfile_ex_err+1
            else
               write(3,'(a,a)') ' File found: ',file
               nfound=nfound+1
            endif
            if(dir.eq.'PRO') then
               if(file(l-2:l).eq.'for') then
               if(unix) then
                  file(l-3:l)=' '
                  inquire(file=file,exist=exist)
               endif
               if(pc) then
                  file(l-3:l)='.exe'
                  inquire(file=file,exist=exist)
               endif
               if(.not.exist) then
                  write(*,'(a,a)') ' Compiled file not found: ',file
                  write(2,'(a,a)') ' Compiled file not found: ',file
                  nfile_co_err=nfile_co_err+1
               endif
               endif
            endif
         endif
 200     continue
      enddo
c
c   end of alll
c

 99   continue


      write(6,*) ' Number of files found     ', nfound
      write(6,*) ' Number of files not found          ', 
     *nfile_ex_err
      write(6,*) ' Number of compiled files not found ', 
     *nfile_co_err
      write(6,*) ' File names not found given in check.out'
      write(6,*) ' File names found given in  check_ok.out'
c
      stop
      end

c
      subroutine xy_ellipse(erx,ery,erz,cvxy,cvxz,cvyz,emaj,emin,ang)
c
c  By Mario Villagran, intended to get information for the
c  norgse program to provide information to IDC from NDC-SOREQ
c
c   changes
c
c  may 12 2000 by jh : remove routine eigen, hyposub2
c
c  Israel
c  inputs are:
c                erx,ery,erz,cvxy,cvxz,cvyz (outputs of hyp program)
c  outputs are:
c                emaj,emin,ang (dimensions of semi-major axis and azimuth)
c        
c Calculate many things, here this routine only extracts
c the size of the ellipsoide error and the orientation
c from the north (degrees).
c calculate maximum horizontal dimensions of error ellipse
c using ellipsoide dimensions & orientations
c  in ae & ve (output of subroutine ellipse)
c
c changes:
c  june 13, 99 lo: replaced atan2d by atan2, *360/2pi
        implicit none
        real ae(9),ve(9)
        real a,b,c,emaj,emin,ang,pi
        real erx,ery,erz,cvxy,cvxz,cvyz,var(3,3)
c
c   covarriance matrix
c
        var(1,1)=erx*erx
        var(2,2)=ery*ery
        var(3,3)=erz*erz
        var(1,2)=cvxy
        var(1,3)=cvxz
        var(2,3)=cvyz
        var(2,1)=var(1,2)
        var(3,1)=var(1,3)
        var(3,2)=var(2,3)
      pi=3.1415926
c
c
        call ellipse_x(var,ae,ve)
c
c find the projection of components of the major ellipse axes (the 3
c eigenvalues of the covariance matrix) on the xy plane
        a=sqrt(abs(ae(1)))*cos(atan2(ve(3),sqrt(ve(1)*ve(1)+ve(2)
     &  *ve(2))))
        b=sqrt(abs(ae(3)))*cos(atan2(ve(6),sqrt(ve(4)*ve(4)+ve(5)
     &  *ve(5))))
        c=sqrt(abs(ae(6)))*cos(atan2(ve(9),sqrt(ve(7)*ve(7)+ve(8)
     &  *ve(8))))
 
c major & minor axes are the largest two of these
        if(a.ge.b.and.a.ge.c)then
         emaj=a
 
c angle between major axis, a, and x-axis
c         ang=atan2d(ve(2),ve(1))
         ang=atan2(ve(2),ve(1))*360/(2*pi)     ! lo
 
         if(b.ge.c)then
          emin=b
         else
          emin=c
         endif
        elseif(b.ge.a.and.b.ge.c)then
         emaj=b
c         ang=atan2d(ve(5),ve(4))
         ang=atan2(ve(5),ve(4))*360/(2*pi)     ! lo
         if(c.ge.a)then
          emin=c
         else
          emin=a
         endif
        elseif(c.ge.a.and.c.ge.b)then
         emaj=c
c         ang=atan2d(ve(8),ve(7))
         ang=atan2(ve(8),ve(7))*360/(2*pi)     ! lo
         if(b.ge.a)then
          emin=b
         else
          emin=a
         endif
        endif
        if(ang.ge.0.and.ang.le.90.0)ang=90.0-ang
        if(ang.gt.90.0)ang=450.0-ang
        if(ang.lt.0.0)ang=-ang+90.0
c          write(88,*)emaj,emin,ang,emaj*emin*3.1416
        return
        end
c
      subroutine ellipse_x(var,ae,ve)
 
c calculates major axis lengths and their orientations
c from covariance matrix using subroutine eigen
c the input covariance matrix is
c by Barry Lienert, 94
c  varxx=var(1,1), varyy=var(2,2), varzz=var(3,3),... etc
c on output, major axis lengths in descending order
c of size are in ae(1), ae(3) & ae(6)
c x,y,z direction cosines of their (x,y,z) orientations are
c   ve(1),ve(2),ve(3)
c   ve(4),ve(5),ve(6)
c   ve(7),ve(8),ve(9)
 
      implicit none
      real ae(1),var(3,3),ve(1)
      integer ic,j,k
 
c put var in ae in input format used by eigen
        ic=1
        do  j=1,3
         do  k=1,j
          ae(ic)=var(j,k)
          ic=ic+1
         end do
        end do
 
        call eigen(ae,ve,3,0)
c       write(*,*)ae(1),ae(2),ae(3),ae(4),ae(5),ae(6)
        return
        end
c***************************************************************************

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   subroutines for handling waveform data
c
c   some principles:
c   - all channels from all files are indexed sequentially
c   - the index is used in all operations in all variables, also
c     for selected variables (wav_out ...)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   look for word problem for petentially unsolved problems
c
c   changes:
c   
c   may 24 2000 lo: bug fix in wav_read_channel
c   oct  3 2000 jh: allow a time window of 300 000 secs, from 90 000
c   oct  9 2000 lo: check for channel in file for GSE , wav_read_channel
c   oct  5 2001 jh: add routine wav_out_sheads, change wav_read_channel
c                   to wav_read_channel_one, put in new wav_read_cahnnel
c                   to be used with both one and many files (cont data)
c   nov  11     jh: bugs in cont part when many waveform files in cont base
c                   initilize wav_header_text
c   nov 21 2001 lo: in gse read, also check for aux station code
c   dec 7  2001 bjb add if statement to allow progs to read BGS VAX wave files
c                   that do not support the century 
c   jun 30 2003 lo: read 3 comp seisan comp codes as 4 chars
c   sep 29 2003 ct: add "form='unformatted'" to 3 open calls for SeisAn data
c   oct-nov2004 jh: seed reading
c   april 8, check for timegap in seed reading, fill with zero
c            remove temporary xx array in seed reading
c   june 7   a few check if too many samples
c   july 5 2005 lo: check if sac binary before seed, example of sac file that
c                   was thought to be miniseed
c   oct 19, 2005 jh:fix so many seed files can be read form one s-file, has to
c                   read contents of each file again before reading channel
c   nov 09 2005 jh :fix time gap problems
c   nov 23 2005 jh :message about cont_before
c   jan 06 2005 jh : bug in time gap and seed
c   oct 3  2005 jh : check of which seed file to index, was not set up
c                     correctly
c   jan 8  2006 lo : implemented sacsubf rading routines
c                    check if seed file before sac
c   jan 17 2007 jh : fix bug with time gaps in seed file. output information
c                    was not updated if a gap was found. now channel infor is
c                    ok, but initial reading of headers without reading
c                    traaces is still wrong
c   june   2007 jh : add wav_select_sav, add wav_seed_location and 
c                    wav_seed_network
c   sep 6  2007 lo : check wrecord is not what it would be if mseed data
c                    before check if data is sac binary
c   oct    2007 Jh : memeory handling
c   oct  19        : start fixin location codes etc
c   nov 5          : fixed bug in memory handling when time gaps in mseed
c   nov 10         : more bugs with cont
c   dec 19 2007 jh : comment out update of wav_out_nsamp and duration,
c                    seems to be a msitake
c       20         : do not use memory handling with large seed files
c   april 15 07 jh : add 0.4 sample time to output duration when calculating
c                    number of samples out to to avoid round off error, 
c                    variabel wav_nsmap_out
c   may 5 07    jh: probelm with reading cont data when mixing types of
c                   files (seisan+seed), cause by a wrong memery store when
c                   reading seed, and missing update of wav_nsamp
c   august 6    jh: seems an old call to wav_copy_sav had been uncommented
c                   in seed reading section
c                   wav_duration set to nsamp/rate, was (nsamp-1)/rate
c                   output from cont set start at or after start time and
c                        number of samples = interval * rate, 
c                        was interval * rate + 1 
c   august 12   jh: Ensure correct format when reading cont data
c   aug 27      JH: more fixing of duration problem, more comments
c   sep 17 08   jh: more output if a gap
c   sep 25 08   JH: comments
c   oct 7  08   jh: avoid crash if file empty
c   oct 23 08   jh: do not write out 'seed file indexed'

c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   definition of interval or duration
c
c   there has been some confusion in SEISAN about this definition which
c   has lead one too few or one too many samples. From August, 2008, we try to
c   follow the following principle in all operations:
c
c   duration  = number of samples * sample rate
c
c   this means that the duration is defined as the time from the first sample to
c   the last sample plus one sample interval. this might seem wrong for single files
c   where the time difference between the first and last sample is (number of samples-1) 
c   times the sample rate. however if two following segments are put together, there
c   is the extra samle interval of time between them so the data in one segment
c   really reprent the time inval as now defined in SEISAN.so using this definition  is
c   particular impoertant when dealing with continuouis data.





c
c   Continuous data
c
c   Continuous data is a data set of many traces and several segments
c   of traces. This means that an event (collection of files) from
c   the continuous data base is like a normal event with one dimension
c   added for the file structure. Reading of continuous data will, for
c   the user, appear almost as reading a 'normal event'. The only
c   added input information needed is the list of data bases used
c   and the time window. From there on, the same calls, as for one
c   dimensionsl events' is used and the data ends up in the same
c   variables.
c
c   assumptions: It is assumed that there is only one waveform file
c   in S-file. The system could be programmed to use several waveform
c   files even of different format, but there has so far been no need.
c
c   If 2 files in a continuous stream are less than 2 s apart (last sample in
c   first and first sample in next), it is assumed that the data is continuous
c   and no samples will be put in for the time gap. larger time gaps are replaced
c   by the DC value.
c
c   Continuous event consisting of 4 traces with repectively 5, 8, 5
c   and 9 files (segments) each:
c
c   _______ ________ _______ _______ _______
c     ____ ____ ____ ____ ____ ____ ____ ____
c    ________ ________ ________ ________ ________
c       ___ ___ ___ ___ ___ ___ ___ ___ ___ ___
c   
c   
c   
c   One dimensional file (normal) with 4 traces:
c   
c   _______________
c    ________________
c       _________________
c     ____________
c   

c   Sequence to read continuous data:
c
c   - Get data bases to use, if not specified by users, read from
c     SEISAN.DEF
c   - Get time interval, must be shorter than corresponding to
c     usual dimension of SEISAN
c   - Read all header info for whole data set to cwav and place
c     info, for combined data set in normal wav-common block
c   - Read any one channel of data with normal reading routines
c
c   EXAMPLE
c
c   tell all routnes that this is reading from cont data base
c
c      cwav=.true.
c
c   set interval in secs
c
c      cont_interval=1800.0  ! common block variable
c
c   set start time
c
c      cwav_start_time = '200101101000'  ! common block variable
c
c   calculate end time
c
c      call cwav_time_limits(0)
c
c  read the header information for all files in all bases in time
c  interval, assume info available in common block
c
c      call cwav_read_bases
c
c  the normal SEISAN main head in not available since all data is now in
c  the standard waveform common block. if needed (e.g. for output) it
c  can be generated by following command
c
c      call wav_sheads(1,net_code,outfile,mainhead,chead)
c
c
c  read the waveform data, one trace at a time, note normal call is used
c
c      do i=1,n_cont_trace         ! n_cont_traces are available traces
c          call wav_read_channel(i)  - variable from common block
c          call user routine
c      enddo
c
c--------------------------------------------------------------------------
c   large seed file
c   variable cseed must bet set to true, however in these routines it is only
c   used to avoid memeoryt buffereing for large seed files. in calling program,
c   the start and stop block to read must be called before reading seed dara here.
c
c--------------------------------------------------------------------------
c
c   memory buffering
c   
c   when a channel is read, the waveform data is stored in a buffer, a
c   one dimensional array, wav_mem_signal. the first channel read is
c   stored in the beginning, the next one followin etc. when the buffer is 
c   full, it starts from the beginning. signal are not broken up at end
c   of buffer so first sampel in a trace  is also a first sample
c   in memory buffer. for each trace stored, the correspondign filename,
c   wav,mem_filename, number of samples, wav_mem_nsamp and channel number
c   in original file, wav_mem_chan_number are stored in arrays. The index
c   in these arrays increase until memory buffer is full. after that there
c   is a check if an index is no longer used (number of samples negative)
c   and if not used it is resused. the data traces are 'remembered' for as 
c   long as program is active so e.g. in mulplt cont mode, the data read in
c   in previous windows will be rmebered, if there is space in the 
c   buffer.
c   when the waveform reading routine starts, it will first chek if data
c   already is in memory by cheking if the desired filename and channel 
c   number, corresponds to a stored filename and channel number.
c   all the header informaton is not stored so if mem routines are used for
c   cont mode, it all has to be read in again, something to fix. For a single
c   event it is rembered (also seed, check ??)
c
c   memory buffereing is not used in large seed files, since not a whole file
c   is used
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   location and network codes and seisan format
c
c   the network code is now and put into channel header position 17 
c   and 20. location code is stored in 8 and 13. position 8 is 3. position
c   of seisan component code and thsi meas that old seisan data files
c   will not looose the 3. position indformation if given. in the future
c   it is assume that 3. posion component code is reserved for 1. location
c   code. when plotting, seed standard is followed.
c   the variabel wav_comp is keep unchange since may program use it
c   but changes will habe to be made so the 3. character is not used
c
c   List of routines in this file
c
c
c   wav_read_channel(ichan)           ! reads one channel, ichan, one or cont
c
c   read_wav_header(ifile)            ! reads all headers in file nr ifile
c
c   wav_read_channel_one(ichan)       ! reads one channel,ichan, of one file
c
c   wav_read_3channel(ichan)          ! reads 3 channels of data
c
c   wav_index_total                   ! find total time window of all traces
c                                       and delay of each traces  relative
c                                       to earliest data point
c
c   wav_out_index_total               ! find total time window of all output
c                                       traces and delay of each trace relative
c                                       to earliest data point
c
c   wav_get_interval                  ! check availibility of data for
c                                       different channels
c
c   wav_read_2channel(ichan)          ! reads 2 horizontal channels of data
c
c
c   wav_get_max_interval              ! finds largest common time window where
c                                       data from all selected channels
c                                       available
c
c   put_chead(chanhead)               ! reads one seisan channel header and put
c                                       it into index 1 which also becomes
c                                       current channel, used for seisan
c
c   wav_init                          ! initialize variables from waveform.inc
c
c   wav_find_chan(station,component,channel) ! finds channel number correspond.
c                                       to a given station and component
c
c   wav_sav_sheads(ichan,net_code,outfile,mainhead,chead) ! calls sheads with
c                                       sav_out_block as input
c   wav_copy_sav(i)                   ! copy some of content of wav array to
c                                       sav array for index i, only for cont.
c   wav_select_sav(i,j)               ! copy from one place in waw to another in
c                                       sav

c
c   wav_copy_wav(i)                   ! copy some of content of sav array to
c                                       wav array for index i, only for cont.
c   cwav_read_bases                   ! read all headers for all files in
c                                       cont data set
c
c   cwav_time_limits(start)           ! calculate abs start and end times and 
c                                       extended start time,
c                                       cwav_data_start_time
c
c   cwav_read_header(cbase)           ! read header information from cont
c                                       data bases and append to continuous
c                                       common block
c   cwav_read_channel_one(ichan)      ! read signal from one channel ichan of
c                                       continuous database
c   wav_mem_free_index                  find location of next channel to store 
c                                       in memory
c   wav_mem_in_memeory                  check if channel ichan already is in 
c                                       memory 
c   wav_mem_init                        initilizes counters for memory buffer, 
c                                       done only when program starts
c   update_mem                          after writing samples in memory, some 
c                                       channels might have been overwritten.
c                                       check and update


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
      subroutine wav_read_channel(ichan)

c
c   read one channel of data, either from one file or a sereis of files
c   following each other in time. gaps are filled with dc levels if
c   cont. data
c   jh oct 2001
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer ichan   ! overall channel number
c
c  check if continous data or one file only
c
      if(cwav) then
         call cwav_read_channel_one(ichan)
      else
         call wav_read_channel_one(ichan)
      endif
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine read_wav_header(ifile)
c
c  read all headers from waveform file ifile in list of waveform files
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      include 'codeco_common.f'
      include 'seed.inc.f'
      integer seiclen
      integer nchan                      ! number of channels, one file
      logical sun,linux,pc
      character*80 mainhead(max_trace)   ! seisan main header
      character*1040 chanhead            ! seisan channel header
      character*20   wrecord             ! first 20 bytes of waveform file
      integer i,j,k,ifile
      character*1 cbuf(c_bufsize)        ! gse ascii data
      integer*4 iy(c_sigsize)            ! gse integer data
      integer*4 ichecksum                ! gse checksum
      integer*4 ierr                     ! gse error
c      character*80 sacaux

      call computer_type(sun,pc,linux)
c      call get_env_sacaux(sacaux)

c
c first check if file compressed and uncompress if so
c
      call uncompress_file(wav_filename(ifile))

c
c   then find type of file
c
       wav_file_format(ifile)=' '
       wav_error_message=' '
c
c check if Seisan,  miniseed or seed file
c
       open(95,file=wav_filename(ifile),access='direct',
     * recl=20,status='old',err=100,form='unformatted')
       goto 101
 100   continue
       wav_error_message(1:14)='File missing: '
       wav_error_message(15:80)=
     * wav_filename(ifile)(1:66)
       return
 101   continue

       read(95,rec=1,err=1010) wrecord
       close(95)
       if(wrecord(1:2).eq.'KP'.or.wrecord(1:1).eq.'P'.or.
     * wrecord(4:4).eq.'P') then
           wav_file_format(ifile)(1:6)='SEISAN'
       endif
c
       goto 1011

 1010  continue
       write(6,*)' Error with file, probably file is empty '
     * ,wav_filename(ifile)
       wav_error_message(1:17)='Error with read  '
       wav_error_message(18:80)=wav_filename(ifile)(1:63)
       return
 1011  continue

c
c check if seed file
c
       if (wav_file_format(ifile).eq.' ') then
         if(wrecord(7:7).eq.'R'.or.wrecord(7:7).eq.'Q'.or.
     *     wrecord(7:7).eq.'D') then
           wav_file_format(ifile)(1:8)='MINISEED'
         elseif(wrecord(7:7).eq.'V') then
           wav_file_format(ifile)(1:4)='SEED'
         endif
       endif
c
c check if SACBIN file
c
       if (wav_file_format(ifile).eq.' ') then
         call read_sacbin_to_seisan(wav_filename(ifile),1,ierr)
         if (ierr.eq.0) wav_file_format(ifile)(1:6)='SACBIN'
       endif

c       if (wav_file_format(ifile).eq.' ') then
cc added lot 6 Sep 2007
c         if(wrecord(7:7).ne.'R'.and.wrecord(7:7).ne.'Q'.and.
c     *     wrecord(7:7).ne.'D') then
c         call read_sacbin_to_seisan(wav_filename(ifile),1,ierr)
c         if (ierr.eq.0) wav_file_format(ifile)(1:6)='SACBIN'
c        endif
c       endif


c
c check if GSE file
c
       if (wav_file_format(ifile).eq.' ') then
         open(95,file=wav_filename(ifile),status='unknown')
         open(94,file='gsetemp.out',status='unknown')

c
c try to read first channel
c
         call gsein( 95, 94, cbuf, iy, ichecksum, ierr )
         if (ierr.eq.0) wav_file_format(ifile)(1:3)='GSE'

         close(95)
         close(94)
       endif

c
c check if SACASC file
c
       if (wav_file_format(ifile).eq.' ') then
         call read_sacasc_to_seisan(wav_filename(ifile),1,ierr)
         if (ierr.eq.0) wav_file_format(ifile)(1:6)='SACASC'
       endif
c
c changed and moved lot nov 07
c
c check if SACBIN file
c
c       if (.not.(pc).and.wav_file_format(ifile).eq.' '.and.
c     &   sacaux.ne.' ') then
c       if (wav_file_format(ifile).eq.' ') then
c         call read_sacbin_to_seisan(wav_filename(ifile),1,ierr)
c         if (ierr.eq.0) wav_file_format(ifile)(1:6)='SACBIN'
c       endif
       
c       write(*,'(2a)') ' input file is ',wav_file_format(ifile)

c
c  return if no valid format and set a message
c
c      write(6,*)'ifile',ifile,wav_file_format(ifile)
       if(wav_file_format(ifile).eq.' ') then
          wav_error_message='Unknown waveform file format'
          return		! added oct 04
       endif
c      write(6,*)'ifile',ifile,wav_file_format(ifile)
c
c----------------------------------------------------------------------
c   section for reading all headers
c----------------------------------------------------------------------
c
c
c   SEISAN format
c
      if(wav_file_format(ifile)(1:6).eq.'SEISAN') then
         open(95,file=wav_filename(ifile),access='direct',
     *   recl=2048,status='old',form='unformatted')
c
c   read main header to get number of channels, nchan
c
         call seisinc 
     *   (95,1,nchan,0,mainhead,chanhead,0.0,0.0)
         wav_header_text(ifile)(1:28)=mainhead(1)(2:29)
c
c   loop trough all channel headers to get channel info
c
          k=wav_nchan     ! set total channel counter
          do i=1,nchan
             k=k+1
             call seisinc 
     *       (95,i,nchan,3,mainhead,chanhead,0.0,0.0)
             read(chanhead(10:12),'(i3)') j      ! year - 1900
             wav_year(k)=j+1900
             wav_stat(k)=chanhead(1:5)
c lot 28/02/2008
c             wav_comp(k)=chanhead(6:9)
             wav_comp(k)='    '
             wav_comp(k)(1:2)=chanhead(6:7)
             if (chanhead(9:9).ne.' ') then
               wav_comp(k)(4:4)=chanhead(9:9)
             elseif (chanhead(8:8).ne.' ') then
c files written by earthworm use first 3 chars
               wav_comp(k)(4:4)=chanhead(8:8)
             endif
c lot 30/06/2003
c             if (seiclen(wav_comp(k)).eq.3) then
c               wav_comp(k)(4:4)=wav_comp(k)(3:3)
c               wav_comp(k)(3:3)=' '
c             endif
             wav_time_error(k)=' '
             wav_time_error(k)(1:1)=chanhead(29:29)
             read(chanhead(17:28),'(4(1x,i2))') wav_month(k),wav_day(k),
     *       wav_hour(k),wav_min(k)
             read(chanhead(30:35),'(f6.3)') wav_sec(k)
             wav_file_nr_chan(k)=ifile
             wav_chan_nr_file(k)=i
c
c   location and network
c
             wav_location(k)(1:1)=chanhead(8:8)  ! part of component
             wav_location(k)(2:2)=chanhead(13:13)
             wav_network(k)(1:1)=chanhead(17:17)
             wav_network(k)(2:2)=chanhead(20:20)
c
             call timsec(wav_year(k),wav_month(k),wav_day(k),
     *       wav_hour(k),wav_min(k),wav_sec(k),wav_abs_time(k))

             read(chanhead,'(43x,i7)') wav_nsamp(k)
             if(wav_nsamp(k).ge.max_sample) then
                 write(6,*) ' Too many samples in trace, will stop'
                 write(6,*) ' Enter to stop'
                 read(5,'(a)') k
                 stop
             endif
             read(chanhead(37:43),'(f7.3)') wav_rate(k)
             wav_cbyte(k)=chanhead(77:77)
c             wav_duration(k)=(wav_nsamp(k)-1)/wav_rate(k)
             wav_duration(k)=(wav_nsamp(k))/wav_rate(k)  ! jh aug 2008
          enddo
          close(95)
          wav_nchan=k    ! save number of channels
      elseif (wav_file_format(ifile)(1:3).eq.'GSE') then
c
c  GSE format, read header
c
         call header_gse_to_seisan(ifile,ierr)

c
c SAC BINARY
c
      elseif (wav_file_format(ifile)(1:6).eq.'SACBIN') then
         wav_nchan=wav_nchan+1
         k=wav_nchan
         call read_sacbin_to_seisan(wav_filename(ifile),k,ierr)
         wav_file_nr_chan(k)=ifile
         wav_chan_nr_file(k)=1

c
c SAC ASCII 
c
      elseif (wav_file_format(ifile)(1:6).eq.'SACASC') then
         wav_nchan=wav_nchan+1
         k=wav_nchan
         call read_sacasc_to_seisan(wav_filename(ifile),k,ierr)
         wav_file_nr_chan(k)=ifile
         wav_chan_nr_file(k)=1
      endif

c
c
c   MINISEED or SEED format
c
      if(wav_file_format(ifile)(1:8).eq.'MINISEED'.or.
     *   wav_file_format(ifile)(1:4).eq.'SEED') then
c
c uses unit 95
c
         call seed_contents(wav_filename(ifile))
c
c   same filename to later check when reading traces whether content
c   is the same since the seed specific content is not stored for
c   all files
c
         wav_seed_last_file=wav_filename(ifile)
c
c   loop trough all channel headers to get channel info
c
          k=wav_nchan     ! set total channel counter
          do i=1,nb_channels
             k=k+1
             wav_year(k)=seed_year(i)
             wav_month(k)=seed_month(i)
             wav_day(k)=seed_day(i) 
             wav_stat(k)=seed_station(i)
             wav_comp(k)(1:2)=seed_comp(i)(1:2)
             wav_comp(k)(3:3)=' '  ! normally it should be blank
             wav_comp(k)(4:4)=seed_comp(i)(3:3)  
c commented out lot nov 07, as this makes no sense
c             wav_comp(k)(3:3)=seed_location(i)  ! temporary fix !!!
             wav_location(k)=seed_location(i)
             wav_network(k)=seed_network(i)
c            write(6,*) 'net',wav_network(k)
             wav_time_error(i)=' '
             if (seed_bad_time_tag(i)) 
     *           wav_time_error(k)(1:1)='E'
             wav_hour(k)=seed_hour(i)
             wav_min(k)=seed_minute(i)
             wav_sec(k)=seed_second(i)
             wav_file_nr_chan(k)=ifile
             wav_chan_nr_file(k)=i
             wav_nsamp(k)=seed_nsamp(i)
             wav_rate(k)=seed_rate(i)
             wav_cbyte(k)='4'
c             wav_duration(k)=(wav_nsamp(k)-1)/wav_rate(k)
             wav_duration(k)=(wav_nsamp(k))/wav_rate(k)  ! jh aug 2008
             call timsec(wav_year(k),wav_month(k),wav_day(k),
     *       wav_hour(k),wav_min(k),wav_sec(k),wav_abs_time(k))
          enddo
          wav_nchan=k    ! save number of channels
c          write(6,*)'seed nchan',wav_nchan
       endif
c
c   find earliest and latest channels
c
      call wav_index_total
c
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c

      subroutine wav_seed_read_header_interval
c
c  read and update header info for current seed file  when
c  position is not at start of file. intended for use with large
c  seed/miniseed files
c  works only with one file, assumes that seed file has been indexed first
c  the time interval returned corresponds to block start end end times
c  should be fixed to be on exact time limit
c  
c  input is cwav_abs_start_time and cwav_abs_end_time
c  output is wav_seed_start_block(i) and wav_seed_stop_block(i) 
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      include 'seed.inc.f'
      real*8   old_start_time              ! previous start time
      real*8   abs_time                    ! absolute time
      integer  old_start_block(max_trace)  ! corresponding block
      integer*2 chop_chn,chop_status
      integer  i,k
     
c
c   loop trough all channel headers to get position in correct
c   block and get channel info for interval
c
          do i=1,wav_nchan  
             k=1            ! by default start at beginning of file (channel)
ct           write(6,*)'old,new b',old_start_block(i),
ct   *       wav_seed_start_block(i)
ct           write(6,*)'ot nt',old_start_time,
ct   *       cwav_abs_start_time
             if(wav_seed_start_block(i).gt.0) then       ! not the first time
                 if(cwav_abs_start_time.gt.old_start_time)
     *           then
                   k=old_start_block(i)
                 endif
             endif
ct           write(6,*)'start used',k
             chop_status=chop_chn(wav_filename(1),i,
     *       cwav_abs_start_time,k,wav_seed_start_block(i))
c
c   update for next time window, therefore only done for last channel
c

             if(i.eq.wav_nchan) old_start_time=cwav_abs_start_time
             old_start_block(i)=wav_seed_start_block(i)
c            write(6,*)'p,b',position, wav_seed_start_block(i)
c
             if(chop_status.eq.1) write(6,*)
     *          ' Start time before start of channel, use first block'
             if(chop_status.eq.2) write(6,*)
     *          ' Start time after end of channel, use last block'
             if(chop_status.eq.3) write(6,*)
     *          ' Start block after end of channel, use last block'
             if(chop_status.eq.4) write(6,*)
     *          ' Start time before start block, use start block'
             if(chop_status.eq.5) write(6,*)
     *          ' Start time in time gap, use first block after gap' 
c
c   a start block is always returned, optionally it could be limited to 
c   only return a start if block and time correspond, same with end
c   block
c
                wav_year(i)=seed_year(i)
                wav_month(i)=seed_month(i)
                wav_day(i)=seed_day(i)
                wav_hour(i)=seed_hour(i)
                wav_min(i)=seed_minute(i)
                wav_sec(i)=seed_second(i)
                wav_rate(i)=seed_rate(i)
                if (seed_bad_time_tag(i))
     *          wav_time_error(k)(1:1)='E'
 
                call timsec(wav_year(i),wav_month(i),wav_day(i),
     *          wav_hour(i),wav_min(i),wav_sec(i),wav_abs_time(i))
ct              write(6,*) wav_year(i),wav_month(i),wav_day(i),
ct   *          wav_hour(i),wav_min(i),wav_sec(i)
c
c
c   find block corresponding to end block
c
             k=wav_seed_start_block(i)
             chop_status=chop_chn(wav_filename(1),i,
     *       cwav_abs_end_time,k,wav_seed_stop_block(i))
ct           write(6,*)'times',cwav_abs_start_time,
ct   *       cwav_abs_end_time
c
c

            if(chop_status.eq.1) write(6,*)
     *          ' End time before start of channel, use first block'
             if(chop_status.eq.2) write(6,*)
     *          ' End time after end of channel, use last block'
             if(chop_status.eq.3) write(6,*)
     *          ' End block after end of channel, use last block'
             if(chop_status.eq.4) write(6,*)
     *          ' End time before start block, use start block'
             if(chop_status.eq.5) write(6,*)
     *          ' End time in time gap, use first block after gap' 
c

ct            write(6,*) 'chop status end', chop_status
c             if(chop_status.lt.3) then  ! block found
c
c   calculate time of last sample
c
                call timsec(seed_year(i),seed_month(i),
     *          seed_day(i),
     *          seed_hour(i),seed_minute(i),seed_second(i),
     *          abs_time)
c 
c   calculate number of samples in interval               
c
                wav_nsamp(i)=wav_rate(i)*
     *          (abs_time-wav_abs_time(i))+
     *          seed_nsamp(i) 
c             wav_duration(i)=(wav_nsamp(i)+1)/wav_rate(i)
             wav_duration(i)=(wav_nsamp(i))/wav_rate(i)   ! jh aug 2008
ct            write(6,*)'nsmap,dur', wav_nsamp(i),wav_duration(i)
ct           write(6,*) 'min after',seed_minute(i)
c             else
c                write(6,*) 'Seed end point not found'
c                stop
c             endif   
ct           write(6,*) 'start,stop b',
ct   *       wav_seed_start_block(i),wav_seed_stop_block(i)
ct           write(6,*)
        enddo

c
c   find earliest and latest channels
c
      call wav_index_total
c
      return
      end



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine wav_read_channel_one(ichan)
c
c   read one channel of data from one file, number as indexed from
c   all wav files
c
c     ichan: channel number to read
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      include 'seed.inc.f'
      include 'seed_internal.inc.f'
      include 'codeco_common.f'
      integer ichan                      ! current channel in total data set
      character*80 mainhead(max_trace)   ! seisan main header
      character*1040 chanhead            ! seisan channel header
      integer nchan
      character*1 cbuf(c_bufsize)        ! gse ascii data
      integer*4 iy(c_sigsize)            ! gse integer data
      integer*4 ichecksum                ! gse checksum
      integer*4 ierr                     ! gse error
      integer*4 seed_read_chn            ! seed reader function
      real*8    time_err                 ! time jump form one to next seed block
      integer b_start,b_end              ! block to check for time gaps
      integer j,i,n,k,m,l
      logical present                    ! true if channel in memory
      integer gse_counter                ! gse channel counter
      integer nsamp                      ! number of samples in this read, no the same 
                                         ! as wav_nsamp if in cwav mode or if
                                         ! time gap

c
c   initially no errors
c
      wav_error_message=' '
      wav_current_chan(1)=0
c
      wav_resp_action=' '        ! no resp action initially
      wav_resp_seisan_chead=' '  ! no seisan resp info
c
c

c      do i=1,10
c        write(6,'(i2,1x,a30,5x,i)') 
c     *   i,wav_mem_filename(i)(1:30),wav_mem_nsamp(i)
c      enddo
c
c   check if data already in memeory, present will then be true
c   not used for large seed file
c
      if(.not.cseed) then
         call wav_mem_in_memeory(ichan,present,k)

c        write(27,*)' channel there',present
c
c   read from memory if data, k is index in header memory
c
         if(present) then
            l=wav_mem_position(k)		! start of sample data in memory
            do i=1,wav_mem_nsamp(k)
               signal1(i)=wav_mem_signal(l+i-1)
            enddo
            wav_current_chan(1)=ichan    ! save last channel read
            wav_rot_comp(ichan)=' '      ! channel is not rotated
            return
         endif
       endif

c------------------------------------------------

c
c
c   SEISAN format
c
      if(wav_file_format(wav_file_nr_chan(ichan))(1:6).eq.'SEISAN') 
     *   then
         open(95,file=wav_filename(wav_file_nr_chan(ichan)),
     *   access='direct',recl=2048,status='old',err=100,
     *   form='unformatted')
         wav_resp_seisan_chead=' '
         call seisinc
     *   (95,wav_chan_nr_file(ichan),nchan,1,mainhead,chanhead,
     *    0.0,0.0)
         wav_resp_seisan_chead=chanhead   ! save for use in response
         wav_resp_action=chanhead(79:79)  ! forced header response flag
         close(95)
c
c  get number of samples for this trace. this information is not available if  
c  in cont mode since wav_nsamp then contains the  total number of samples in
c  all segmnets
c
         READ(chanhead,'(43X,I7)') nsamp
c
         goto 101
 100     continue
         wav_error_message(1:14)='File missing: '
         wav_error_message(15:80)=
     *   wav_filename(wav_file_nr_chan(ichan))(1:66)
         return
 101     continue

      elseif (wav_file_format(wav_file_nr_chan(ichan))(1:3).eq.'GSE')
     * then

c---------------------------------------------------------------------------
c   GSE format, read data
c---------------------------------------------------------------------------

         open(95,file=wav_filename(wav_file_nr_chan(ichan)),
     *       status='unknown')
         open(94,file='gsetemp.out',status='unknown')
         gse_counter = 0

 200     continue
c
c  might not work for cont data since wav_nsamp has bewen used in cont section
c  must be tested
c
         do j=1,wav_nsamp(ichan) ! added may 24, 2000
           signal1(j)=0.
         enddo
         call gsein( 95, 94, cbuf, iy, ichecksum, ierr )
         if (ierr.ne.0) then
           wav_error_message(1:14)='Error in GSE file'
           goto 250
         endif
         gse_counter = gse_counter + 1
c        if (hdr_station(1:5).eq.
c     *     wav_stat(wav_chan_nr_file(ichan)).and.
c     *     hdr_chan(1:2).eq.wav_comp(wav_chan_nr_file(ichan))(1:2)
c     *     .and.hdr_chan(3:3).eq.wav_comp(wav_chan_nr_file(ichan))(4:4)) 
c     *     then

c         if (hdr_station(1:5).eq.
c     *     wav_stat(ichan).and.

c also check for aux code, lo nov 2001
         if ((hdr_station(1:5).eq.wav_stat(ichan).or.
     *        hdr_stadescr(1:4).eq.wav_stat(ichan)).and.
     *     hdr_chan(1:2).eq.wav_comp(ichan)(1:2)
     *     .and.hdr_chan(3:3).eq.wav_comp(ichan)(4:4).and.
     *     gse_counter.eq.wav_chan_nr_file(ichan)) 
     *     then

            do j=1,hdr_nsamp
              signal1(j)=float(iy(j))
            enddo
c
c   get number of samples for this trace. this information is not available if 
c   in cont mode since wav_nsamp then contains the  total number of samples in
c   all segmnets
c
             nsamp=hdr_nsamp

            goto 250
         endif
         goto 200

 250     continue
         close(95)
         close(94)

c-----------------------------------------------------------------------------
c SAC BINARY
c------------------------------------------------------------------------------

      elseif (wav_file_format(
     *      wav_file_nr_chan(ichan))(1:6).eq.'SACBIN') then
       call read_sacbin_to_seisan(
     *    wav_filename(wav_file_nr_chan(ichan)),ichan,ierr)
c
c SAC ASCII
c
      elseif (wav_file_format(
     *     wav_file_nr_chan(ichan))(1:6).eq.'SACASC') then
           call read_sacasc_to_seisan(
     *     wav_filename(wav_file_nr_chan(ichan)),ichan,ierr)

c------------------------------------------------------------------------------
c   MINI SEED  or SEED format
c------------------------------------------------------------------------------
c
      elseif (wav_file_format(wav_file_nr_chan(ichan))(1:8).
     *eq.'MINISEED'.
     *     or.wav_file_format(wav_file_nr_chan(ichan))(1:4).
     *eq.'SEED') then 
c
c   use unit 95 for reading
c
c        write(6,*)wav_file_nr_chan(ichan),
c    *   wav_chan_nr_file(ichan),wav_nsamp(ichan)
c
c   first the content of the file must be read again if file has
c   changed. 
c   this has already been done 
c   when all files were indexed, maybe that info could be saved so not to 
c   read again ?
c
c        write(6,'(a)') wav_seed_last_file
c        write(6,'(a)') 
c    *   wav_filename(wav_file_nr_chan(ichan)) 
c
         if(wav_seed_last_file.ne.
     *      wav_filename(wav_file_nr_chan(ichan))) then
c           write(6,*) ' Seed file indexed'
            call seed_contents
     *      (wav_filename(wav_file_nr_chan(ichan)))
c
c   save last file indexed
c
            wav_seed_last_file=wav_filename(wav_file_nr_chan(ichan))
c
c   save last file indexed
c
            wav_seed_last_file=wav_filename(wav_file_nr_chan(ichan))
         endif
c
c   read channel, all data read into signal_int, at this time
c   no check for time gaps, done later
c   the first block to read in file is wav_seed_start_block and the 
c   last block to read is wav_seed_stop_block, if both are zero,
c   read whole channel in file, usually only different from
c   0,0 if reading from a large seed volume. start and stop 
c   is calculated elswhere.
c   thus reding here is the same if reading whole seed file or 
c   just a part (cseed=.true.)
c

         n=seed_read_chn(
     *   wav_filename(wav_file_nr_chan(ichan)),
     *   wav_chan_nr_file(ichan),signal_int,
     *   wav_seed_start_block(ichan),
     *   wav_seed_stop_block(ichan))
         wav_nsamp(ichan)=n    !  this is probably not needed ???????????????????
                               !  or maybe a problem for cont reading since wav_nsamp
                               !  then contains all samples from all segements
C
c   update sample rate variable, might have been used when reading
c   segments of continuous data
c
         wav_rate(ichan)=seed_rate(wav_chan_nr_file(ichan))     !jh may 5
c
c   get number of samples for this trace. this information is not available if  
c   in cont mode since wav_nsamp then contains the total number of samples in
c   all segmnets. however if time gap it will be changed.
c
         nsamp=n
c
c        write(6,*)' samples read before gap check', n
c        write(6,*)'bb',wav_seed_start_block(ichan),
c    *   wav_seed_stop_block(ichan)
 
         k=1   ! count blocks
         n=1   ! count samples
         if(wav_seed_start_block(ichan).eq.0.and.
     *      wav_seed_stop_block(ichan).eq.0) then
            b_start=seed_begin(ichan)
         else
            b_start=wav_seed_start_block(ichan)
         endif
c        write(6,*)' Number of blocks read', seed_blk_read
c        write(6,*)' Start block', b_start
c
c        write(6,*)' first, last blk for chn ',
c    *   chn_begin(ichan),chn_end(ichan),seed_begin(ichan),
c    *   seed_end(ichan)

         b_end=b_start+seed_blk_read-1

c        write(6,*)' End block ', b_end

         do i=b_start,b_end -1
c           write(6,*) k,seed_blk_time(k),
c    *                seed_blk_index(k)
c          write(6,*)'n2,n1 ',seed_blk_index(k+1),seed_blk_index(k)
c
c   transfer data block by bloc from data read to array out
c   do not transfer last block here due to time gap check, seed_blk_index
c   is the sample number of the start of the bloc as stored in signal_int
c
           do j=seed_blk_index(k),seed_blk_index(k+1)-1
              signal1(n)=signal_int(j)
              n=n+1
           enddo
           if(n.gt.max_sample-20000) then   ! 20000 to allow for samples in
               write(6,*)' Too many samples, stop reading'    ! - current block
               wav_nsamp(ichan)=n-1         ! counted one too many
               goto 301
           endif
c
c   check for time gaps 
c
c
c   calculate  time gap
c
            time_err=seed_blk_time(k+1)-
     *      seed_blk_time(k)-
     *      (seed_blk_index(k+1)-seed_blk_index(k))/
     *      wav_rate(ichan)
c           write(6,*)'ichan,rate',ichan, wav_rate(ichan)
c           write(6,*)seed_blk_index(k+1),seed_blk_index(k)
c           write(6,*)'t1,t2',k,seed_blk_time(k+1),seed_blk_time(k)

c
c   if a positive time gap, fill in with zero
c
            if(time_err.gt.0.5/wav_rate(ichan)) then
               write(6,'(1x,a5,1x,a4,1x,a,f12.3)')wav_stat(ichan),
     *         wav_comp(ichan)(1:2)//wav_comp(ichan)(4:4),
     *         ' Positive time gap in seconds:',
     *         time_err
               write(6,*) ' Will fill with zeros'
               m=time_err*wav_rate(ichan)
               write(6,*)' Samples in time gap',m
               if(m.gt.100000) then
                  write(6,*)
     *            ' Gap larger than 100 000 samples, will stop reading'
                  wav_nsamp(ichan)=n-1
                  goto 301
               endif
c
               do j=1,m
                   signal1(n)=0.0  ! problem, fix, shuld be DC
                   n=n+1
               enddo
               if(n.gt.max_sample-20000) then
                  write(6,*)' Too many samples, stop reading'
                  wav_nsamp(ichan)=n-1
                  goto 301
               endif
c
c   check for negative time gap
c
            if(time_err.lt.-0.5/wav_rate(ichan)) then
               write(6,*)' Negative time gap, stop reading', 
     *         time_err
               wav_nsamp(ichan)=n-1
c              write(6,*)' Sample output after gap check', n-1
               goto 301
            endif
           endif         ! end of time gap check
           k=k+1    
         enddo
c
c   copy last block if no negative time gaps
c   and if not too many samples above
c
         do j=seed_blk_index(k),wav_nsamp(ichan)
              signal1(n)=signal_int(j)
              n=n+1
         enddo
         if(n.gt.max_sample-20000) then
            write(6,*)' Too many samples, stop reading'
            wav_nsamp(ichan)=n-1
            goto 301
         endif
c

         wav_nsamp(ichan)=n-1         ! probelm, does this work for cont ????
c
c   this seems to work since when reading cont data one, trace is jsut appended to
c   to the next 
c
c        write(6,*)'Duration from header: ',wav_duration(ichan)
c         wav_duration(ichan)=wav_nsamp(ichan)/float(wav_rate(ichan))
c lot 19/03/2007
         wav_duration(ichan)=wav_nsamp(ichan)/wav_rate(ichan)
c        write(6,*)'Duration from actual samples: ',wav_duration(ichan)
c        write(6,*)' Number of samples after time check ',n-1
c
c   update headers , only needed if a time gap problem: seems to be done anyway
c
c  seesm no update is needed
c
c   changed next 2 dec 2007 jh. seems next 2 should not be there since 
c   the wav_out is the interval, not the total duration of the read
c   signal, same with duration
c
c        wav_out_nsamp(ichan)=wav_nsamp(ichan)
c        wav_out_duration(ichan)=wav_duration(ichan)
c  below comment out again august 6, jh
c        call wav_copy_sav(ichan)       ! may 2, 08 jh, gave prob. cont
cnov         call wav_index_total       ! doing this gives probelms with
c
c   number of samples for memory handling
c
         nsamp=wav_nsamp(ichan)
c
         goto 301
 300     continue
         wav_error_message(1:14)='File missing: '
         wav_error_message(15:80)=
     *   wav_filename(wav_file_nr_chan(ichan))(1:66)
         return
 301     continue
      endif
c
ccccccccccccc end
c
      wav_current_chan(1)=ichan    ! save last channel read
      wav_rot_comp(ichan)=' '      ! channel is not rotated
c
c-------------------------------------------------------------------
c   memory handling
c-------------------------------------------------------------------
c
c   since channel was read, it cannot be in memory so it must be stored
c   not used with large seed files
c
       if(cseed) return
c
c   first find where to store the data: array location for headers and
c   and position in memory ring buffer      
c
      call wav_mem_free_index
c
c   store number of samples in this read
c
      wav_mem_nsamp(wav_mem_free_header)=nsamp
c
c   store file name and channel number
c
      wav_mem_filename(wav_mem_free_header)=
     *wav_filename(wav_file_nr_chan(ichan))
      wav_mem_chan_number(wav_mem_free_header)=
     *wav_chan_nr_file(ichan)   ! save channel number in current file     
c
c   store the waveform data, first check if space at end, if not
c   write from beginning
c
      if((nsamp+wav_mem_next_position-1).gt.max_mem_sample)
     *then
         wav_mem_next_position=1
      endif
c
c   copy data samples
c
      do i=1,nsamp
         wav_mem_signal(wav_mem_next_position+i-1)=signal1(i)    
      enddo
c
c   store start position of new channel
c
      wav_mem_position(wav_mem_free_header)=wav_mem_next_position
c
c   check which information has been overwritten and null out
c   corresponding channel headers
c
       call update_mem

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_read_3channel(ichan)
c
c   reads 3 component channels of data, number as indexed from all wav files
c   ichan can be any of the 3 channels, data for z, ns and ew are returned
c   in signal 1, signal2 and signal3 in common block. the corresponding 
c   channels numbers are in wav_current_chan(1-3). If wav_current_chan(i)
c   is zero, then the data channel i was not present
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer ichan                      ! current channel in total data set
      integer comp_index(3)              ! channel numbers of components
      character*5 stat                   ! station code for 3 comp station
      character*4 comp                   ! component
      integer i
c
c   Initially no errors
c
      wav_error_message=' '
      do i=1,3
        wav_current_chan(i)=0
        comp_index(i)=0
      enddo
c
c   find if all 3 channels available
c
      stat=wav_stat(ichan)
      comp=wav_comp(ichan)
      do i=1,wav_nchan
         if(stat.eq.wav_stat(i).and.comp(1:3).eq.wav_comp(i)(1:3))
     *      then      ! component same except for last char
            if(wav_comp(i)(4:4).eq.'Z') comp_index(1)=i
            if(wav_comp(i)(4:4).eq.'N') comp_index(2)=i
            if(wav_comp(i)(4:4).eq.'E') comp_index(3)=i
         endif
      enddo
c
c  check if all 3 components available
c
      do i=1,3
         if(comp_index(i).eq.0) then
            wav_error_message=
     *      'All 3 components not available for '//stat
            return
         endif
      enddo
c
c   read 3 components
c
      call wav_read_channel(comp_index(3))
      wav_current_chan(3)=comp_index(3)
      do i=1, wav_nsamp(comp_index(3))
         signal3(i)=signal1(i)
      enddo
      call wav_read_channel(comp_index(2))
      wav_current_chan(2)=comp_index(2)
      do i=1, wav_nsamp(comp_index(2))
         signal2(i)=signal1(i)
      enddo
      call wav_read_channel(comp_index(1))
c
c      write(17,*)(signal1(i),signal2(i),signal3(i),i=1,10)

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_index_total
c
c  find total time window of all traces and delay of each trace
c  relative to earliest data point
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      double precision first_time   ! ealiest abs start time
      double precision last_time    ! latest abs end time
      integer i
c
      first_time=1.0e20
      last_time=0.0
      do i= 1,wav_nchan
c        write(6,*) 'wabs',wav_abs_time(i),wav_duration(i)  
         if(wav_abs_time(i).lt.first_time) then
            first_time=wav_abs_time(i)
            wav_first=i
         endif
         if(wav_abs_time(i)+wav_duration(i).gt.last_time) then 
            last_time=wav_abs_time(i)+wav_duration(i)
            wav_last=i
         endif
      enddo
c
c   find new start times relative to new main header
c
      do i=1,wav_nchan
         wav_delay(i)=wav_abs_time(i)-first_time
      enddo		 	  
c
c   check if total time window is reasonable
c
      wav_total_time=last_time-first_time
      if(wav_total_time.gt.3000000.0) then
c        write(6,*) ' Abs times ',first_time,last_time
         do i=1,wav_nchan
            write(6,'(1x,a,a,1x,i4,4i2,f6.1,f13.1)')
     *      wav_stat(i),wav_comp(i),wav_year(i),
     *      wav_month(i),wav_day(i),wav_hour(i),wav_min(i),wav_sec(i),
     *      wav_abs_time(i)
         enddo
         write(6,*)' Total time window is:',wav_total_time,' secs'
         write(6,*)' This is unrealistic, program will stop'
         write(6,*)' Return to stop		 '
         write(6,*)
         read(5,'(a1)') i		 		 
         stop
       endif

c
       return
       end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_out_index_total
c
c  find total time window of all output traces and delay of each trace
c  relative to earliest data point
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      double precision first_time   ! ealiest abs start time
      double precision last_time    ! latest abs end time
      integer i,k
c
      first_time=wav_out_start(1)
      last_time=wav_out_start(1)
      do i= 1,wav_out_nchan
         k=wav_out_chan(i)
         if(wav_out_start(k).lt.first_time) then
            first_time=wav_out_start(k)
         endif
         if(wav_out_start(k)+wav_out_duration(k).gt.last_time) then
            last_time=wav_out_start(k)+wav_out_duration(k)
         endif
      enddo
c
c   check if total time window is reasonable
c
      wav_out_total_time=last_time-first_time

      return
      end
	   
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine wav_get_interval
c
c   Routine to check availibility of data for different channels and adjust
c   prameters accordingly
c
c   Currently (aug 2008) used in wavetool and mul_spec
c
c   Input:
c
c         wav_out_nchan         : number of selected channels
c         wav_out_chan          : the channel numbers (original index) 
c         wav_out_start         : start from earlist overall channel
c         wav_out_duration      : desired duration
c
c   The return values are 
c         wav_out_year etc..... : time of exact sample to start with
c         wav_out_start_sample  : corresponding sample number
c         wav_out_duration      : interval available of each channel. 
c         wav_out_status        : indicates status of selection: 
c                                 0: no data, 1: some data, 
c   start time ok but data missing at end, 2: some data, end time ok, but
c   some data missing in the beginning, 3: some data, but mising at both
c   ends, 4: data ok
      
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      double precision dtime1,dtime2       ! abs start and end time for selection
      integer i,k,doy

      do i=1,wav_out_nchan
         k=wav_out_chan(i)
         wav_out_status(k)=4                   ! assume ok
c
c   check if start time time1 is within data window for channel
c
         dtime1=wav_abs_time(wav_first)+wav_out_start(k)
         if(dtime1.ge.wav_abs_time(k)+wav_duration(k)) then
            wav_out_status(k)=0                ! after end, deselect channel
            goto 100
c           return
         else
            if(dtime1.lt.wav_abs_time(k)) then  ! start time cannot be before
               dtime1=wav_abs_time(k)           ! first sample, use first
               wav_out_status(k)=1
            endif
         endif
c
c   find nearest first sample. first sample at or after given time is used. roundoff
c   is now set to 1/1000 of a sample
c
c         wav_out_first_sample(k)=(0.5/wav_rate(k)+   jh aug 27 08
         wav_out_first_sample(k)=(0.001/wav_rate(k)+
     *                   dtime1-wav_abs_time(k))*wav_rate(k)
         wav_out_first_sample(k)=wav_out_first_sample(k)+1
c         write(6,*) 'first sample',wav_out_first_sample(k)
c
c   calculate exact time of first sample
c
         dtime1=wav_abs_time(k)+(wav_out_first_sample(k)-1)/wav_rate(k)
   
c
c   date and time of first sample
c
         call sectim(dtime1,wav_out_year(k),doy,wav_out_month(k),
     *   wav_out_day(k),wav_out_hour(k),wav_out_min(k),wav_out_sec(k))
c        write(6,*)'time of first sample', wav_out_sec(k) 
c
c   check if end time time2 is outside data window for channel
c
         dtime2=wav_abs_time(wav_first)+wav_out_duration(k)+
     *   wav_out_start(k)
         if(dtime2.le.wav_abs_time(k)) then
            wav_out_status(k)=0                      ! before start, deselect
            goto 100
c            return
         endif
         if(dtime2.gt.wav_abs_time(k)+wav_duration(k)) then
            dtime2=wav_abs_time(k)+wav_duration(k)     ! after end
            if(wav_out_status(k).eq.1) then
                wav_out_status(k)=3                  ! data missing at both ends
            else
                wav_out_status(k)=2                   ! data mising end only
            endif
         endif
         wav_out_duration(k)=dtime2-dtime1   ! corrected value 
         wav_out_rate(k)=wav_rate(k)
c
c   round off set to 1/10 of a sample. Using a smaller number can potentially give 
c   a problem since duration is single precision. E.g. 1 hour of data at 100 hz has a
c   duration of 3600.00. Adding 1/1000 of sample in time gives 3600.00001 which is outside
c   the accuarcy of single precision so no roundoff would be made and potentially
c   one sample would be missing
c
c         write(6,*) 'out duration',wav_out_duration(k)
c         wav_out_nsamp(k)=(wav_out_duration(k)+0.4/wav_out_rate(k))
c     &*wav_out_rate(k)+1
         wav_out_nsamp(k)=(wav_out_duration(k)+0.1/wav_out_rate(k))
     &*wav_out_rate(k)     ! jh aug 27 08
c       write(6,*) 
c     *(wav_out_duration(1)+0.01/wav_out_rate(1))*wav_out_rate(1)
c       write(6,*) wav_out_nsamp(k)
100    continue
      enddo
c
      return
      end
	  
	  
	  
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_read_2channel(ichan)
c
c   reads 2 horizontal channels of data, number as indexed from all wav files
c   ichan can be any of the 3 channels, data for ns and ew are returned
c   signal2 and signal3 in common block. the corresponding 
c   channels numbers are in wav_current_chan(2-3). If wav_current_chan(i)
c   is zero, then the data channel i was not present. An error message
c   is also returned.
c   the routine also calculates the common interval between the 2 signals
c   and return results in wav_out ....
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer ichan                      ! current channel in total data set
      integer comp_index(3)              ! channel numbers of components
      character*5 stat                   ! station code for 3 comp station
      character*4 comp                   ! component
      integer i
c
c   initially no errors
c
      wav_error_message=' '
      do i=1,3
        wav_current_chan(i)=0
        comp_index(i)=0
      enddo
c
c   find if 2 horizontal channels available
c
      stat=wav_stat(ichan)
      comp=wav_comp(ichan)
      do i=1,wav_nchan
         if(stat.eq.wav_stat(i).and.comp(1:3).eq.wav_comp(i)(1:3))
     *      then      ! component same except for last char
            if(wav_comp(i)(4:4).eq.'Z') comp_index(1)=i
            if(wav_comp(i)(4:4).eq.'N') comp_index(2)=i
            if(wav_comp(i)(4:4).eq.'E') comp_index(3)=i
         endif
      enddo
c
c  check if  2 components available
c
      do i=1,2
         if(comp_index(i).eq.0) then
            wav_error_message=
     *      'Both horizontal components not available for '//stat
            return
         endif
      enddo
c
c   read 2 components
c
      call wav_read_channel(comp_index(3))
      wav_current_chan(3)=comp_index(3)
      do i=1, wav_nsamp(comp_index(3))
         signal3(i)=signal1(i)
      enddo
      call wav_read_channel(comp_index(2))
      wav_current_chan(2)=comp_index(2)
      do i=1, wav_nsamp(comp_index(2))
         signal2(i)=signal1(i)
      enddo

        wav_out_nchan=2     ! there are 2 channels to check
        wav_out_chan(1)=comp_index(2)  ! put in 2 horizontal channels
        wav_out_chan(2)=comp_index(3)
c
c   check intervals
c
      call wav_get_max_interval          
c
c   return if a problem
c
      if(wav_out_status(1).ne.4)  then
         wav_error_message=
     *   'Data interval not available both horizontal channels '//stat
          return
      endif
c
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_get_max_interval
c
c   Finds largest common time window where data from all 
c   selected channels available
c
c   Input:
c
c         wav_out_nchan         : number of selected channels
c         wav_out_chan          : the channel numbers (original index) 
c
c   The return values are 
c         wav_out_year(1) etc.. : time of start of window
c         wav_out_start(1)      : delay relative main window of total data
c                                 set
c         wav_out_start_sample  : corresponding sample number each channel
c         wav_out_duration      : available duration
c         wav_out_status(1)     : indicates status of selection: 
c                                 0: no data, 4: ok 
      
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      double precision dtime1,dtime2   !    start and end time for selection
      integer i,k,k1

      dtime1=0.0
      dtime2=1.0e20
c
      wav_out_status(1)=4
      do i=1,wav_out_nchan
         k=wav_out_chan(i)
c
c   find latest start time among selected channels
c
         if(wav_abs_time(k).gt.dtime1) then
            dtime1=wav_abs_time(k)
            k1=k
         endif
c
c  find earliest end
c
         if(wav_abs_time(k)+wav_duration(k).lt.dtime2) then
            dtime2=wav_abs_time(k)+wav_duration(k)
         endif
         if(dtime2.le.dtime1) then
            wav_out_status(1)=0
            return
         endif
      enddo
c
c   set start date and time
c
      wav_out_year(1)=wav_year(k1)
      wav_out_month(1)=wav_month(k1)
      wav_out_day(1)=wav_day(k1)
      wav_out_hour(1)=wav_hour(k1)
      wav_out_min(1)=wav_min(k1)
      wav_out_sec(1)=wav_sec(k1)
      wav_out_duration(1)=dtime2-dtime1    
      wav_out_start(1)=dtime1-wav_abs_time(wav_first)
c
c   find nearest first sample
c
       do i=1,wav_out_nchan
         k=wav_out_chan(i)
         wav_out_first_sample(k)=(0.5/wav_rate(k)+
     *                   dtime1-wav_abs_time(k))*wav_rate(k)
         wav_out_first_sample(k)=wav_out_first_sample(k)+1
      enddo
c
      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine put_chead(chanhead)
c
c   read one seisan channel header and put it into index 1 which also becomes 
c   current channel, used for seisan response
c
c  but what is it used for ??????
c

      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
c      character*80 mainhead(max_trace)   ! seisan main header
      character*1040 chanhead            ! seisan channel header
      integer i,j,ifile,k
c
      wav_error_message=' '

      read(chanhead(10:12),'(i3)',err=999) j      ! year - 1900
c bjb
c add following if statement to allow progs to read BGS VAX wave files
c that do not support the century 
      if (j.lt.50)then
         j=j+100
      endif
      wav_year(1)=j+1900
      wav_stat(1)=chanhead(1:5)
      wav_comp(1)=chanhead(6:9)
      wav_time_error(1)=' '
      wav_time_error(1)(1:1)=chanhead(29:29)
      read(chanhead(17:28),'(4i3)',err=999) wav_month(1),wav_day(1),
     *wav_hour(1),wav_min(1)
      read(chanhead(30:35),'(f6.3)',err=999) wav_sec(1)
cfix      wav_file_nr_chan(1)=ifile
cfix      wav_chan_nr_file(1)=i
      call timsec(wav_year(1),wav_month(1),wav_day(1),
     *wav_hour(1),wav_min(1),wav_sec(1),wav_abs_time(1))
      read(chanhead,'(43x,i7)',err=999) wav_nsamp(1)
      read(chanhead(37:43),'(f7.3)',err=999) wav_rate(1)
      wav_cbyte(1)=chanhead(77:77)
c      wav_duration(1)=(wav_nsamp(1)-1)/wav_rate(1)   jh aug 2008
      wav_duration(1)=(wav_nsamp(1))/wav_rate(1)
c
c
c  only one channel
c
      wav_current_chan(1)=1
      wav_current_chan(2)=0
      wav_current_chan(3)=0
c
c  abs time
c
      call timsec(wav_year(1),wav_month(1),wav_day(1),
     *wav_hour(1),wav_min(1),wav_sec(1),wav_abs_time(1))
 
      wav_resp_type='SEISAN'

      goto 1000
 999  continue
      wav_error_message='Read error seisan chead'
 1000 continue

c
      return
      end


      subroutine wav_init
c
c initialize variables from waveform.inc
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i

      wav_nchan = 0
      wav_nfiles = 0
      wav_resp_file = ' '
      do i=1,max_trace
         wav_rot_comp(i)=' '
         wav_seed_start_block(i)=0
         wav_seed_stop_block(i)=0
      enddo
      do i=1,200
         wav_header_text(i)=' '
      enddo
      
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_find_chan(station,component,channel)
c
c   finds channel number corresponding to a given station
c   and component. error message if not found.
c

      implicit none
      include 'seidim.inc'
      include 'waveform.inc'

      character*5 station
      character*4 component
      integer channel
      integer i

      wav_error_message=' '
      channel=0

      do i=1,wav_nchan
         if(component.eq.wav_comp(i).and.
     *   station.eq.wav_stat(i)) then
            channel=i
            return
         endif
      enddo
c
      wav_error_message='No data for '//station//' '//component
      return
      end


      subroutine wav_sheads(ichan,net_code,outfile,mainhead,chead)
c
c call sheads with wav_block as input
c this is to write seisan format
c
c   add location and network code after write
c

      implicit none
      include 'seidim.inc'
      include 'waveform.inc'

      integer ichan
      character*5 net_code
      character*80 outfile
      character*80 mainhead(max_trace)
      character*1040 chead
      
c 
c call sheads
c
      call sheads(wav_year,wav_month,wav_day,wav_hour,wav_min,wav_sec,
     *  wav_nchan,ichan,net_code,wav_header_text,wav_stat,wav_comp,
     *  wav_nsamp,wav_rate,wav_cbyte,outfile,mainhead,chead)
c
c   add location nad network code
c
       chead(8:8)=wav_location(ichan)(1:1)
       chead(13:13)=wav_location(ichan)(2:2)
       chead(17:17)=wav_network(ichan)(1:1)
       chead(20:20)=wav_network(ichan)(2:2)
       

      return
      end

c-----------------------------------------------------------------------

      subroutine wav_sav_sheads(ichan,net_code,outfile,mainhead,chead)
c
c call sheads with wav_sav block as input
c

      implicit none
      include 'seidim.inc'
      include 'waveform.inc'

      integer ichan
      character*5 net_code
      character*80 outfile
      character*80 mainhead(max_trace)
      character*1040 chead
      
c 
c call sheads
c
      call sheads(wav_sav_year,wav_sav_month,wav_sav_day,
     *  wav_sav_hour,wav_sav_min,wav_sav_sec,
     *  wav_sav_nchan,ichan,net_code,wav_sav_header_text,
     *  wav_sav_stat,wav_sav_comp,
     *  wav_sav_nsamp,wav_sav_rate,wav_sav_cbyte,
     *  outfile,mainhead,chead)
c
c   add location nad network code
c
       chead(8:8)=wav_sav_location(ichan)(1:1)
       chead(13:13)=wav_sav_location(ichan)(2:2)
       chead(17:17)=wav_sav_network(ichan)(1:1)
       chead(20:20)=wav_sav_network(ichan)(2:2)
       

      return
      end
c ----------------------------------------------------------------------
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_select_sav(i,j)
c
c   copy some of content of wav array (i) to out array(j) in sav
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i,j
c
cx      wav_sav_nchan=wav_nchan
      wav_sav_stat(i)=wav_stat(j)
      wav_sav_comp(i)=wav_comp(j)
      wav_sav_year(i)=wav_year(j)
      wav_sav_month(i)=wav_month(j)
      wav_sav_day(i)=wav_day(j)
      wav_sav_hour(i)=wav_hour(j)
      wav_sav_min(i)=wav_min(j)
      wav_sav_sec(i)=wav_sec(j)
      wav_sav_abs_time(i)=wav_abs_time(j)
      wav_sav_rate(i)=wav_rate(j)
      wav_sav_cbyte(i)=wav_cbyte(j)
      wav_sav_nsamp(i)=wav_nsamp(j)
      wav_sav_duration(i)=wav_duration(j)
      wav_sav_delay(i)=wav_delay(j)
      wav_sav_first=wav_first
      wav_sav_last=wav_last
      wav_sav_total_time=wav_total_time
      wav_sav_location(i)=wav_location(j)
      wav_sav_network(i)=wav_network(j)
      return
      end
c ----------------------------------------------------------------------


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wav_copy_sav(i)
c
c   copy some of content of wav array to sav array for index i
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i
c
cx      wav_sav_nchan=wav_nchan
      wav_sav_stat(i)=wav_stat(i)
      wav_sav_comp(i)=wav_comp(i)
      wav_sav_year(i)=wav_year(i)
      wav_sav_month(i)=wav_month(i)
      wav_sav_day(i)=wav_day(i)
      wav_sav_hour(i)=wav_hour(i)
      wav_sav_min(i)=wav_min(i)
      wav_sav_sec(i)=wav_sec(i)
      wav_sav_abs_time(i)=wav_abs_time(i)
      wav_sav_rate(i)=wav_rate(i)
      wav_sav_cbyte(i)=wav_cbyte(i)
      wav_sav_nsamp(i)=wav_nsamp(i)
      wav_sav_duration(i)=wav_duration(i)
      wav_sav_delay(i)=wav_delay(i)
      wav_sav_first=wav_first
      wav_sav_last=wav_last
      wav_sav_total_time=wav_total_time
      wav_sav_location(i)=wav_location(i)
      wav_sav_network(i)=wav_network(i)
      return

      return
      end
c ----------------------------------------------------------------------



      subroutine wav_copy_wav(i)
c
c   copy some of content of sav array to wav array for index i
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i

cx      wav_nchan=wav_sav_nchan
      wav_stat(i)=wav_sav_stat(i)
      wav_comp(i)=wav_sav_comp(i)
      wav_year(i)=wav_sav_year(i)
      wav_month(i)=wav_sav_month(i)
      wav_day(i)=wav_sav_day(i)
      wav_hour(i)=wav_sav_hour(i)
      wav_min(i)=wav_sav_min(i)
      wav_sec(i)=wav_sav_sec(i)
      wav_abs_time(i)=wav_sav_abs_time(i)
      wav_rate(i)=wav_sav_rate(i)
      wav_cbyte(i)=wav_sav_cbyte(i)
      wav_nsamp(i)=wav_sav_nsamp(i)
      wav_duration(i)=wav_sav_duration(i)
      wav_delay(i)=wav_sav_delay(i)
      wav_first=wav_sav_first
      wav_last=wav_sav_last
      wav_total_time=wav_sav_total_time
      wav_location(i)=wav_sav_location(i)
      wav_network(i)=wav_sav_network(i)
 

      return
      end



c ======================================================================

      subroutine cwav_read_bases
c
c  read all headers for all files in cont data set,
c
c  IMPORTANT   This routine calcualtes all output time intervals and start
c              times including time gaps between files and put this in wav_sav array
c              ready for output so that array should not be used before output
c              However time gaps within a seed file is not checked here, but should 
c              be ok since current routine only deals with start time and total
c              number of samples


      implicit none
      include 'seidim.inc'
      include 'seisan.inc'
      include 'waveform.inc'

      integer base_cnt                       ! data base counter
      integer n_out_sample                   ! 
      real diff                              ! difference between two times
      double precision tfirst                ! abs first time
      integer i,l,j,n1,n2,doy

      n_cont_trace=0

c
c loop over databases, to read header information
c
      do base_cnt=1,n_cont_base
cx
cc        write(*,'(i2,1x,a)') base_cnt,cont_base(base_cnt)
c
c read header info from databases and append to continuous common block
c
        call cwav_read_header(cont_base(base_cnt))
      enddo
c
c   put headers back to normal headers for possible output
c
      do i=1,n_cont_trace
         wav_stat(i)=cwav_stat(i)
         wav_comp(i)=cwav_comp(i)
         wav_location(i)=cwav_location(i)
         wav_network(i)=cwav_network(i)
         wav_year(i)=cwav_year(i,1)
         wav_month(i)=cwav_month(i,1)
         wav_day(i)=cwav_day(i,1)
         wav_hour(i)=cwav_hour(i,1)
         wav_min(i)=cwav_min(i,1)
         wav_sec(i)=cwav_sec(i,1)
         wav_abs_time(i)=cwav_abs_time(i,1)
         wav_rate(i)=cwav_rate(i,1)
         wav_cbyte(i)=cwav_cbyte(i)
c
c   find number of samples including gaps for sum of original whole blocks,
c   check for timing errors or missing blocks, start with 2. file
c   only check for missing data or gaps. sample can be inaccurate
c   so gap must be more then 2 s to be considered real
c
         n_out_sample=0
         do j=1,cwav_nseg(i)
            if(j.gt.1) then
               diff=cwav_abs_time(i,j)-cwav_abs_time(i,j-1)-
     *         cwav_duration(i,j-1)
               if(diff.gt.2.0) then
                  diff=diff+0.5/cwav_rate(i,j-1)   ! round off
                  do l=1,int(diff)*cwav_rate(i,j-1)
                     n_out_sample=n_out_sample+1
                  enddo
               endif
            endif
            n_out_sample=n_out_sample+cwav_nsamp(i,j)
            if(n_out_sample.ge.max_sample) then
                write(6,*)' Too many samples, will stop'
                write(6,*)' Enter to stop'
                read(5,'(a)') l
                stop
            endif
         enddo
         wav_nsamp(i)=n_out_sample
c
c   adjust all headers for start and end times
c
c
c   find real start time, if no data, use first sample of data available
c
         n1=1   
         if(cwav_abs_start_time.gt.wav_abs_time(i)) then  ! start after first sample
             diff=cwav_abs_start_time-wav_abs_time(i)
c
c   adjust for round off, jh august 2008
c
             diff=diff+0.004
c
             n1=diff*wav_rate(i) + 1    ! +1 added august 5, 2008, jh
c
c   adjust time of first sample
c
             tfirst=wav_abs_time(i)+
     *       (n1+0)/wav_rate(i) ! exact time on first sample, -1 to 0 jh aug 08
             call sectim(tfirst,wav_year(i),doy,wav_month(i),wav_day(i),
     *       wav_hour(i),wav_min(i),wav_sec(i))
             wav_abs_time(i)=tfirst
         endif
c
c   find last sample
c
c   case of end time contained in last block
c
         if(cwav_abs_time(i,cwav_nseg(i))+cwav_duration(i,cwav_nseg(i)).
     *   gt.cwav_abs_end_time) then
            n2=n1+(cwav_abs_end_time-wav_abs_time(i)+0.0004)*wav_rate(i)-1
c
c   round off 0.004 added jh aug 2008
c
c   case of end time after end of last available sample
c
         else
             n2=wav_nsamp(i)
c            n2=n1+(cwav_abs_time(i,cwav_nseg(i))+
c     *      cwav_duration(i,cwav_nseg(i)))*wav_rate(i)-1
         endif
c
c   check if enough samples
c
c         if(n2.gt.wav_nsamp(i)) n2=wav_nsamp(i)

         wav_nsamp(i)=n2-n1+1
c
c   find new duration
c
         wav_duration(i)=wav_nsamp(i)/wav_rate(i) 
c
c   save in sav array since other routnes also use these 
c   variables for reading individual events. doen again below, needed here ???
c
         call wav_copy_sav(i)   

      enddo

      wav_nchan=n_cont_trace
      wav_sav_nchan=wav_nchan
c
c   find earliest and latest channels
c
      call wav_index_total

cx copy this result, simpler way ?
c
c  this must be saved for cont use since same variabels are used
c  when reading individual files in cont data base
c

      do i=1,wav_nchan
         call wav_copy_sav(i)
      enddo
c
c   check if data
c
      if(wav_nchan.eq.0) then
          write(6,*)' No data found'
          write(6,*)
     *' Check if parameter CONT_BEFORE in SEISAN.DEF is large enough'
c commented out lot 6/8/08
c          write(6,*)' Return to stop'
c          read(5,'(a)') i
c          stop
      endif

      return
      end



c ======================================================================
      subroutine cwav_time_limits(start)
c
c   calculate abs start and end times and extended start time,
c   cwav_data_start_time
c
c   if start = 0, start with year month...
c      else
c   start with abs time
c
c
      implicit none
      include 'seidim.inc'
      include 'seisan.inc'
      include 'waveform.inc'

      integer year,month,day,doy,hour,min,isec  ! date and time
      real sec                                  ! --------
      double precision msec,start_msec          ! time in seconds
      integer i,start

c
c   compute start and end time in seconds
c   (cwav_abs_start_time and cwav_abs_end_time)
c
      if(start.eq.0) then
         read(cwav_start_time,'(i4,5(i2))') year,month,day,hour,min,isec
         sec=isec
         call timsec(year,month,day,hour,min,sec,cwav_abs_start_time)
      endif

      cwav_abs_end_time=cwav_abs_start_time+cont_interval
c
c   start time to start searching
c
      start_msec=cwav_abs_start_time-cont_before*60.0
      call sectim(start_msec,year,doy,month,day,hour,min,sec)     
      isec=sec
      write(cwav_data_start_time(1:14), '(i4,5(i2))')
     *year,month,day,hour,min,isec
c
c   saving the end time
c
      call sectim(cwav_abs_end_time,year,doy,month,day,hour,min,sec)     ! end time
      isec=sec
      write(cwav_end_time(1:14), '(i4,5(i2))') year,month,day,hour,min,
     *isec
c
      do i=1,14                ! fill up blancs with 0
        if(cwav_end_time(i:i).eq.' ') cwav_end_time(i:i)='0'
        if(cwav_start_time(i:i).eq.' ') cwav_start_time(i:i)='0'
        if(cwav_data_start_time(i:i).eq.' ')
     *  cwav_data_start_time(i:i)='0'
      enddo
cx
cc      write(6,*) cwav_start_time,cwav_end_time 
      return
      end



c --------------------------------------------------
c                                                                               
c
      subroutine cwav_read_header(cbase)

c   Subroutine to read header information from cont data bases and
c   append to continuous common block 

      implicit none                                                 
c    
c    input: cbase                  - name of continuous data base
c           cwav_data_start_time   - start time, in common block  
c           cwav_end_time          - end time, in common block
c
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'
       include 'seisan.inc'
       include 'waveform.inc'
C
C
      character*80  file_out       !complete wav name
      integer       nstat,nphase   !See routine: 'indata'
      character*1   type,exp       !See routine: 'indata
      integer       id             !id line number
      integer       n_wav_file     !number wavform files in s-file
      integer       read1          !read unit 1
      logical       flag,b_flag    !flag
      character*40  base_name      !data base name
      character*5   cbase          !data base name
      integer       from_eev       !indicate to routine findevin that call is from eev
      character*80  evfile         !event file name       
      integer       event_no       !event number
      integer       nhead,nrecord  ! for indata
c      character*80  data(100)      ! s-file content
      character*80  data(max_phase)! s-file content
      integer       status         !status of event search               
      integer       code           !returned code 
      integer       new_month      !new month indicator              
      integer       fstart         !see base               
      integer       k,i,j,l        !counter
      integer       ns(max_ctrace) !sample counter
      character*10  key            !key in findevin
      integer       ichan          !channel number
 

      base_name(1:5)=cbase
      key= ' '
      from_eev=0
c
c   start of reading loop
c
 10   continue

c
c find s-file name, go through database
c
      call findevin
     &   (base_name,cwav_data_start_time,cwav_end_time,key,
     *    from_eev,event_no,evfile,fstart,new_month,status)
cc      write(6,*) base_name,cwav_start_time,cwav_end_time
cc      write(*,*)'sfile ', evfile,status
c
c return at end of time period
c
      if (status.eq.3) goto 20

  25  continue
c
c open and read s-file
c
       nhead=0
       call sei open( old$,                   ! Open old file.
     &                  ' ',                  ! No prompt.
     &                  evfile,               ! This file.
     &                  read1,                ! On this unit.
     &                  b_flag,               ! Existance?.
     &                  code )                ! Condition (n/a).
       call indata(read1,nstat,nphase,nhead,nrecord,type,exp,data,id)
       call sei close(close$,read1,code)    ! Close (stop on error).
c
c   get waveform headers
c
c    -- Find waveform file (wav_filename) in sfile (data)
c
          call auto_tr(data,nhead,n_wav_file,wav_filename)
cx
cc        write(6,*) 'nf ',n_wav_file, wav_filename(1)
	  do k=1,n_wav_file !there can be more than one wavform file in a s-file 
	     call get_full_wav_name(wav_filename(k),file_out)
	     wav_filename(k)=file_out
c
c init wave structure
c
             call wav_init

             call read_wav_header(k)
cx             write(6,*) wav_filename(k)
c
c   copy waveform header information to continuous common block of all traces
c
             do j=1,wav_nchan
c
c   check which trace, new if not found
c
               flag=.false.
               do i=1,n_cont_trace
                 if (cwav_stat(i).eq.wav_stat(j).and.
     &              cwav_comp(i).eq.wav_comp(j)) then
                    flag=.true.
                    ichan=i
                 endif
               enddo
c
c   move component from 3 to 4, needed ?
c
c               if(wav_comp(j)(3:3).ne.' ') then
c                  wav_comp(j)(4:4)=wav_comp(j)(3:3)
c                  wav_comp(j)(3:3)=' '
c               endif
c
c   check if new channel
c
               if(.not.flag.and.n_cont_trace.lt.max_ctrace) then !max_ctrace def in continuous.inc
                 n_cont_trace=n_cont_trace+1
                 cwav_stat(n_cont_trace)=wav_stat(j)
                 cwav_comp(n_cont_trace)=wav_comp(j)
                 cwav_location(n_cont_trace)=wav_location(j)
                 cwav_network(n_cont_trace)=wav_network(j)
                 ichan=n_cont_trace
cx
                 cwav_nseg(ichan)=0        ! start counter
                 ns(ichan)=0
cc                 write(6,*) (cwav_stat(l),l=1,n_cont_trace)
cc                 write(*,*) n_cont_trace,'  ',cwav_stat(i),cwav_comp(i)
               endif
c
c check if number of maximum traces exceeded 
c
               if (n_cont_trace.gt.max_ctrace) then  
                  write(*,*)' Number of maximum traces exceeded'
                  write(6,*)' Return to continue'
                  read(5,'(a)') i
               endif
c
c check if memory full
c
               if (cwav_nseg(ichan).gt.max_cseg) then
                   write(*,*)'*** ', wav_stat(j),wav_comp(j),
     &             ': Number of maximum waveform files exceeded ***'
                   write(6,*)' Return to continue'
                   read(5,'(a)') i
               endif

               if (ns(ichan)+wav_nsamp(j).ge.max_sample) then
                   write(*,*)'*** ', wav_stat(j),wav_comp(j),
     &             ': Number of maximum samples exceeded ***'
                   write(6,*)' Return to continue'
                   read(5,'(a)') i
               endif

               ns(ichan)=ns(ichan)+wav_nsamp(j)
cx               write(6,*)'ns,chan,j',ns(ichan),ichan,j
c
c   store header information in continuous block
c
               cwav_nseg(ichan)=cwav_nseg(ichan)+1
               cwav_filename(ichan,cwav_nseg(ichan))=wav_filename(k)
cx cx
cc               write(6,*) 'seg:', cwav_nseg(ichan),
cc     *         cwav_filename(ichan,cwav_nseg(ichan))
               cwav_file_format(ichan,cwav_nseg(ichan))=
     *         wav_file_format(k)
cc               write(6,*)'format in ',wav_file_format(k)
               cwav_abs_time(ichan,cwav_nseg(ichan))=wav_abs_time(j)
               cwav_nsamp(ichan,cwav_nseg(ichan))=wav_nsamp(j)
               cwav_rate(ichan,cwav_nseg(ichan))=wav_rate(j)
               cwav_duration(ichan,cwav_nseg(ichan))=wav_duration(j)
               cwav_chan_nr_file(ichan,cwav_nseg(ichan))=
     *         wav_chan_nr_file(j)
               cwav_time_error(ichan,cwav_nseg(ichan))=
     *         wav_time_error(j)
               cwav_year(ichan,cwav_nseg(ichan))=wav_year(j)
               cwav_month(ichan,cwav_nseg(ichan))=wav_month(j)
               cwav_day(ichan,cwav_nseg(ichan))=wav_day(j)
               cwav_hour(ichan,cwav_nseg(ichan))=wav_hour(j)
               cwav_min(ichan,cwav_nseg(ichan))=wav_min(j)
               cwav_sec(ichan,cwav_nseg(ichan))=wav_sec(j)
               cwav_cbyte(ichan)=wav_cbyte(j)
             enddo
          enddo
c
c next event file
c
      key='next'
      goto 10

20    continue

      return
      end



c ---------------------------------------------------------------

      subroutine cwav_read_channel_one(ichan)
c
c    routine to read signal from one channel ichan of continuous database
c    ichan is the total number indexed over all cont data bases
c    data is output in usual signal 1 and headers are also the usual
c    gaps are filled with dc-level
c


      implicit none
c
C
C    Seisan library inserts and routines...
C    ======================================
C
      include 'seidim.inc'
      include 'seisan.inc'
      include 'waveform.inc'
      include 'libsei.inc'                ! Open file definitions
C
C    ============= end of list ==========
C
      integer ichan                       ! cont channel number
      integer i,j,l,k                     ! counter
      real diff                           ! time difference
      real dc                             ! dc level
      integer n_out_sample                ! sample counter

c
c   extract samples for all files for channel ichan
c
      n_out_sample=1    ! sample counter

      do j=1,cwav_nseg(ichan)
        wav_filename(1)=cwav_filename(ichan,j)  ! put current file to read in first index
        wav_file_nr_chan(cwav_chan_nr_file(ichan,j))=1  ! always first file
cx
cx        write(6,*)'file to read ',wav_filename(1)(1:40)
c
c   read one file, it is assumed there is only one file so index
c   if fixed to 1. No storage of file numbers is used for cont reading
c
        wav_file_format(1)=     ! jh  index to a fixed 1, aug 2008
     *  cwav_file_format(ichan,j)
cx        write(6,*)'chan ',cwav_chan_nr_file(ichan,j),
cx     *  'format',wav_file_format(cwav_chan_nr_file(ichan,j))
cx        write(6,*) 'wav_file_nr_chan',wav_file_nr_chan(1)

        call wav_init
        call wav_read_channel_one(cwav_chan_nr_file(ichan,j)) !signal1 put in commom block
c
c   check for timing errors or missing blocks, start with 2. file
c   only check for missing data or gaps. sample can be inaccurate
c   so gap must be more then 2 s to be considered real
c
        if(j.gt.1) then
            diff=cwav_abs_time(ichan,j)-cwav_abs_time(ichan,j-1)-
     *      cwav_duration(ichan,j-1)
            if(diff.gt.2.0) then
               diff=diff+0.5/cwav_rate(ichan,j-1)   ! round off
c   find dc
               dc=0.0
               do l=1,cwav_nsamp(ichan,j-1)
                   dc=dc+signal1(l)
               enddo
               dc=dc/cwav_nsamp(ichan,j-1)

               do i=1,int(diff*cwav_rate(ichan,j-1))
                  signal2(n_out_sample)=dc
                  n_out_sample=n_out_sample+1
               enddo
            endif
        endif
               
        do i=1, cwav_nsamp(ichan,j)   ! number of samples in this segment
            signal2(n_out_sample)=signal1(i)
            n_out_sample=n_out_sample+1
        enddo 
      enddo
c
c   restore header info for cont. opertion since the variabels have
c   been used for reading individual files
c
      wav_nchan=wav_sav_nchan
cx 
cx      write(17,*)'restroe for ',wav_nchan
      do i=1,wav_nchan
        call wav_copy_wav(i)
      enddo
      wav_current_chan(1)=ichan
c
c   cut out desired time interval
c
c
c  start time is within first block
c
      if(cwav_abs_start_time.gt.cwav_abs_time(ichan,1)) then
         k=(cwav_abs_start_time-
     *   cwav_abs_time(ichan,1)+0.0001)*wav_rate(ichan)+1
cc       write(6,*) 'n1,n2', k,wav_nsamp(ichan)
c
c   start time is before first block
c
      else
         k=1
      endif
      do i=k,k+wav_nsamp(ichan)-1
         signal1(i-k+1)=signal2(i)
      enddo

      return
      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

ccccccccccccccccccccc    memory handeling


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


c ----------------------------------------------------------------------

      subroutine wav_mem_free_index
c
c   find location of next channel to store in memory, the index returned
c   through a common is wav_free_header
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i
c
c  if no data yet in memeory, just initilize to 1
c
       if(wav_mem_counter.eq.0) then
          wav_mem_counter=1
          wav_mem_free_header=1
          goto 10
       endif
c
c   see if any previous used header index are free

      do i=1,wav_mem_counter
        if(wav_mem_nsamp(i).eq.-1) then   ! number of sampels is -1 if no data
           wav_mem_free_header=i
           goto 10
        endif
      enddo
c
c  none are free, add one
c
      wav_mem_counter=wav_mem_counter+1
      wav_mem_free_header=wav_mem_counter

c
c   enter here if one was found
c
 10   continue
c     write(6,*)'free header',wav_mem_free_header
c     write(6,*)'mem_counter',wav_mem_counter
c     write(6,*)'next pos',wav_mem_next_position
c     write(27,*)'free header',wav_mem_free_header
c     write(27,*)'mem_counter',wav_mem_counter
c     write(27,*)'next pos',wav_mem_next_position
c
c  check if not too many, to be done !
c
      return
      end

c--------------------------------------------------------------------------

      subroutine wav_mem_in_memeory(ichan,present,wav_mem_chan)
c
c   check if channel ichan already is in memory and therefore can be read from
c   memory. if in memory, return present as true and 
c   position in header ring buffer wav_mem_chan
c

      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i,ichan
      integer wav_mem_chan       ! channel number in memory ring buffer
      integer j                  ! channel number in orignal waveform file
      logical present
c
      present=.false.
c
c  return if not in memory
c
      if(wav_mem_counter.eq.0) return
c
      j=wav_file_nr_chan(ichan)
c
c   check all segments, file name, channel number in file must be equal and
c   number of samples positive
c
      do i=1,wav_mem_counter
c           write(6,'(i3,1x,a30,1x,a30,1x,2i3)')
c    *      i,wav_mem_filename(i)(1:30),
c    *             wav_filename(wav_file_nr_chan(ichan))(1:30),
c    *             wav_mem_chan_number(i),wav_chan_nr_file(ichan)
c           write(27,'(i3,1x,a30,1x,a30,1x,2i3)')
c    *      i,wav_mem_filename(i)(1:30),
c    *             wav_filename(wav_file_nr_chan(ichan))(1:30),
c    *             wav_mem_chan_number(i),wav_chan_nr_file(ichan)
  
         if(wav_mem_filename(i).
     *      eq.wav_filename(wav_file_nr_chan(ichan))  .and.
     *      wav_mem_chan_number(i).eq.wav_chan_nr_file(ichan).and.
     *      wav_mem_nsamp(i).gt.0) goto 1

      enddo
      goto 2
 1    continue
      present=.true.
      wav_mem_chan=i
 2    continue
c     write(27,*) 'present ',present
      return
      end

c---------------------------------------------------------------------------

      subroutine wav_mem_init
c
c   initilizes counters for memory buffer, done only when program starts
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i

c
       wav_mem_next_position=1       ! position of first sample to write
       wav_mem_counter=0             ! number of segments stored, start with 0
       do i=1,max_trace
         wav_mem_nsamp(i)=-1         ! no samples
       enddo

       return
       end
c
c----------------------------------------------------------------------------
c
       subroutine update_mem
c
c  after writing samples in memory, some channels migh have been overwritten.
c  find out which, and mark the channels no longer in memory
c  this means that that index is free for another write in header
c
c  also update next position to write
c
      implicit none
      include 'seidim.inc'
      include 'waveform.inc'
      integer i,first,last,n1,n2

      first=wav_mem_position(wav_mem_free_header)     ! postion of first sample just written
      last=first+wav_mem_nsamp(wav_mem_free_header)-1 ! -----------last------------------
c     write(27,*)'first,last',first,last
c
c   if only one segment written, just update sample counter and return
c
      if(wav_mem_counter.eq.1) goto 10
      
c
c   check all previous headers corresponding to segments stored
c
      do i=1,wav_mem_counter
          n1=wav_mem_position(i)      ! start of old segment
          n2=n1+wav_mem_nsamp(i)-1    ! end of old segment
c          write(6,*) 'n1,n2',n1,n2
c
c   skip the one just written
c
          if(i.ne.wav_mem_free_header) then     
c
c  check if start of last write is in segnment
c
            if(first.ge.n1.and.first.le.n2) wav_mem_nsamp(i)=-1
c
c  check if end of write is in segnment
c
            if(last.ge.n1.and.last.le.n2) wav_mem_nsamp(i)=-1
c
c  check if segment is enclosed by the new write 
c
             if(n1.gt.first.and.n2.lt.last) wav_mem_nsamp(i)=-1
          endif
       enddo
 10    continue
c
c   update next postion to write in memeory ring buffer
c
       wav_mem_next_position=last+1
c
       return
       end

        

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c seed_internal.inc.f
c Parameters & internal variables of SEED readers
c
c DO NOT INCLUDE THIS FILE IN YOUR MAIN PROGRAM!!!
c
c Author: Rodrigo Canabrava
c E-mail: rlpcfr@yahoo.com.br
c Universitetet i Bergen - Department of Earth Sciences
c
c  changes
c
c dec 21 2005 jh  add seed_pc
c sep 25 2008 jh change dim to 1900000
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Parameters
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c     BLK_SIZE is not a parameter, it can be changed during program
c     execution.
c     MAX_BLK_SIZE must be at most the size of the variable seed_record

      INTEGER*4 BLK_SIZE
      INTEGER*4 MAX_BLK_SIZE    ! Maximum block size supported
      INTEGER*4 MAX_SAMP        ! Maximum number of samples
      PARAMETER (MAX_BLK_SIZE = 32768)
      PARAMETER (MAX_SAMP = 1900000)


      INTEGER FRAME_SIZE        ! Frame size
      INTEGER STEIM_1, STEIM_2, INT_32BIT ! codes of encoding formats
      CHARACTER*5 S_STEIM
      PARAMETER (FRAME_SIZE = 64)
      PARAMETER (INT_32BIT = 3)
      PARAMETER (STEIM_1 = 10)
      PARAMETER (STEIM_2 = 11)
      PARAMETER (S_STEIM = 'STEIM')


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc      
c Variables:
c "seed_record" holds one block of BLK_SIZE.
c The following fields make EQUIVALENCE to part of "seed_record",
c according to the file layout.
c
c The variables
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      character*32768 seed_record ! a block from the file

      common / seed_data_record / seed_record, BLK_SIZE, sample_rate, 
     &     hour, minute, second, questionable_time_tag

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Variables related to fixed header of Data Record
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      character*6    seq_number ! sequence number
      character      header_type ! header type
      character      continuation ! continuation code
      character*5    station    ! station name
      character*2    location   ! location id
      character*3    channel    ! channel id
      character*2    network    ! network id
      integer*2      year       ! year
      integer*2      day_of_year ! day of year
      character*1    hour_      ! hour as a char
      character*1    minute_    ! minute as a char
      character*1    second_    ! second as a char
      integer*2      fracsec    ! fraction of second
      integer*2      n_samples  ! number of samples
      integer*2      sample_rate_factor ! sample rate factor
      integer*2      sample_rate_multiplier ! sample rate multiplier
      character*1    activity_flags ! activity flags
      character*1    io_flags   ! input/output flags
      character*1    quality_flags ! quality flags
      character*1    n_blockettes ! number of blockettes
      integer*4      time_correction ! time correction
      integer*2      data_p     ! position of start of data
      integer*2      first_blk  ! position of first blockette

      logical*1      questionable_time_tag ! "questionable time tag" flag
      logical*1      seed_pc    ! true if on as pc platform

      equivalence(seed_record(1:6), seq_number)
      equivalence(seed_record(7:7), header_type)
      equivalence(seed_record(8:8), continuation)
c     reserved byte skipped: seed_record(8)
      equivalence(seed_record(9:13), station)
      equivalence(seed_record(14:15), location)
      equivalence(seed_record(16:18), channel)
      equivalence(seed_record(19:20), network)
      equivalence(seed_record(21:22), year)
      equivalence(seed_record(23:24), day_of_year)
      equivalence(seed_record(25:25), hour_)
      equivalence(seed_record(26:26), minute_)
      equivalence(seed_record(27:27), second_)
c     reserved byte skipped: seed_record(28)
      equivalence(seed_record(29:30), fracsec)
      equivalence(seed_record(31:32), n_samples)
      equivalence(seed_record(33:34), sample_rate_factor)
      equivalence(seed_record(35:36), sample_rate_multiplier)
      equivalence(seed_record(37:37), activity_flags)
      equivalence(seed_record(38:38), io_flags)
      equivalence(seed_record(39:39), quality_flags)
      equivalence(seed_record(40:40), n_blockettes)
      equivalence(seed_record(41:44), time_correction)
      equivalence(seed_record(45:46), data_p)
      equivalence(seed_record(47:48), first_blk)


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c The following fields have 1 byte in the header layout.
c This is a problem because not all compilers accept integer*1
c declarations. So, they are "equivalenced" to the seed_record as character 
c fields, and converted to integer.
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*2   hour          ! hour
      integer*2   minute        ! minute
      integer*2   second        ! second


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Sample rate must be calculated from two factors in the header,
c so it needs an extra variable that will hold the result
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real*4 sample_rate        ! sample rate in real*4

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Blockette 1000
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*2   encoding      ! encoding format
      integer*2   rec_length    ! record length as a power of 2
      logical     is_swapped    ! .TRUE. if file is in inversed byte order
      common / blk_1000 / encoding, rec_length, is_swapped, seed_pc


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Blockette 1001
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      integer*2 timing_quality  ! timing quality
      integer*2 usec            ! micro seconds error
      integer*2 n_frames        ! number of frames in data section

      common / blk_1001 / timing_quality, usec, n_frames

c$debug
      subroutine get_baz(nchan,stat,data,nhead,nrecord,baz)

c
c   find or calculate station back azimuth for stations in waveform
c   header. The azimuth will be obtained in the following way:
c
c   1: If hypocenter, calculate
c   2: No hypocenter, check S-file for observed azimuths, correct for residuals
c  
c   input  : nchan: number of channels
c            stat:  staiton codes, can be repeated for 3 comp
c            data,nhead,nrecord:  s-file etc
c   output:  baz:  back azimuth
c
c   J Havskov, mar 95
c
c   updates:
c
c   sep 98  by jh :  ----------------   version 7.0 check --------------------
c                    stations changed to 5 chars
c
c   april 11, adopt to new waveform structure
c
      implicit none
      real lat,lon,slat,slon    ! station and hypocenter coordinates
      real height               ! station elevation
      integer nchan             ! number of channels
      integer i,j,ich           ! counters etc
      character*5 stat(*)       ! stations
	  character*80 data(*)      ! s-file
      character*5 old_stat      ! previous station
      real delta, azim          ! epicentral distance and azimuth
      real baz(*)               ! backazimuth each trace
      real  ba                  ! back azimuth and residual from s-file
      integer ba_res
      integer nhead,nrecord     ! header and records in s-file

c
c   put in a default values
c
      do i=1,nchan
         baz(i)=999.0
      enddo
c
c   check if hypocenter is available
c
      if(data(1)(24:30).ne.'       '.and.data(1)(31:38).ne.'        ')
     *then
c
c   read hypocenter
c
         read(data(1)(24:38),'(f7.3,f8.3)') lat,lon
c
c   calculate baz
c
         old_stat='xxxxx'
         do i=1,nchan
c
c  get station coordinates
c
            call stat_loc(stat(i),data(1)(21:21),slat,slon,height)
c
c   use values from previous station if the same
c           
            if(old_stat.eq.stat(i)) then
               baz(i)=baz(i-1)
               goto 10
            endif
c
c   reset station
c
            old_stat=stat(i)
c
c  calculate baz if station was found
c
            if(slat.eq.0.0.and.slon.eq.0.0.and.height.eq.0.0) goto 10
            call azibazi(lat,lon,slat,slon,delta,azim,baz(i))
 10         continue
         enddo
      endif
c
c   check if any missing values can be found in phase file
c
      do ich=1,nchan
         if(baz(ich).eq.999.0) then
            do i=nhead+1,nrecord
               if(stat(ich).eq.data(i)(2:6)) then  ! check if azimuth there
                  if(data(i)(47:51).ne.'     '.or.
     *               data(i)(61:63).ne.'   ') then
                     read(data(i)(47:51),'(f5.1)') ba    ! observed azimuth
                     read(data(i)(61:63),'(i3)') ba_res  ! residual
                     baz(ich)=ba+ba_res                  ! calculated baz
                     goto 20                             ! do not look more 
                  endif
               endif
 20            continue
            enddo
         endif
      enddo
c
      return
      end

c$debug
cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
c       HYPOSUB2   version 4.0    6/98
c
cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
c changes:
c
c 6/92 (BRL) several fairly minor changes to getphasn
c 4/94: put common/comm1/ block in 'comm1.inc'
CJAB(BGS)Mar95 : Remove some causes of ieee_flags in routine "betai" 
cBRL Jun98  : few changes to limit conditions   
cBRL &/98: removed dx from window
c   sep 98   jh : ------------- seisan version 7.0 check --------------
c                 year 2000, 5 char station 
c  oct 28 98 bmt: linux changed, save and *
c  nov 19 99 jh: remove parm and nn form call window, add in common block
c  jan         : multi_model
c  jul 21 03 jh: small text change realted to Pg
c
      subroutine dtdx2(xh,x0,ptype,nmoho,nconrad,iulst,tmin,
     &dx,delta,ann,iflag,phsid)

C***********************************************************************
C
c   subroutine to calculate travel time and derivatives for a one-
c   dimensional nl-layered model
c
c       Barry R. Lienert    March, 1991
c
c   Updates:
c   Feb 17, 92 by jh: Fix negative sqrt, look for jh fix
C
c   May 27, 92 BRL: removed this whole section (increases
c                   calculation time a bit)               
c
c   April, 1994 BRL: added b phases
c
c   Adapted for variable station elevations Jan, 1987
c   can now use x0(3) with any positive value i.e. station
c   can be positioned in any layer. However the top of the velocity
c   model must then correspond to the highest elevation station IN THE
c   WHOLE ARRAY.
c
c   changed to work with geocentric lat/long instead of km 3/14/91
c   Lat./Long. are now in geocentric radians on a sphere having the
c   earth's MEAN radius (6371 km)
c
c   inputs:    nn:     number of parameters (=2*nl-1), from common via nl
c              parm(i),i=1,nl:     layer velocities in km/sec, from common
c              parm(i),i=nl+1,nn:  layer thicknesses in km,from common
c              xh(3):      event coordinates in geocentric radians
c                      (depth still in km)
c                      Depth origin is always the maximum elevation station
c              x0(3):     station coordinates in geocentric radians
c                      (depth in km). x0(3) origin is the maximum elevation station, i.e.,
c                      x0(3) is the 'depth' of the station below the maximum elevation one
c              ptype:  G        : direct arrival
c                      N        : moho refracted arrival                                  
c                      B        : Conrad refracted arrival
c                      blank    : minimum arrival 
c              nmoho:  layer# having moho velocity 
c              nconrad   "      "    conrad  "
c              iulst:  output listing unit# for error messages
c                      (if <= 0, no output)
c
c   outputs    tmin:   minimum travel time
c              dx(1):  spatial derivative of tmin wrt long. in secs/radian
c              dx(2):  spatial derivative of tmin wrt lat. in secs/radian
c              dx(3)   spatial derivative of tmin wrt depth in secs/radian
c                      (the depth derivative in secs/km is multiplied by 6367,
c                       the earth's mean radius, to keep it similar in size 
c                       to dx(1) and dx(2))
c              delta:  epicentral distance in km
c              ann:    angle (measured upward from vertical) at which
c                      ray leaves the source (< 90 <=> refracted)
c              iflag:  1 for valid phase, 0 otherwise
c              phsid:  8 char ID for phase calculated: 
c                      PG  or Pg for direct 
c                      PB  or Pb for Conrad diffraction
c                      PN2 for refraction # is layer#, if not moho
c                      left blank otherwise
c
c   subroutines called:
c
c              del :calculates horizontal offset for direct path
c                   - modified version for variable station depth
c
c 
c
C***********************************************************************
      save
      include 'hypparm.inc'  
c      real dx(3)
      character*1 ptype
      character*8 phsid
      dimension dcrit(nlayer)
      double precision t1,t2,uu,u1,u2,dtan,datan,dsqrt,del,dl1,dl2,dll,
     +p,p1,p2,dabs,dble,pi,degtorad

c added this to prevent overflows in atan2
      if(abs(xh(3)-x0(3)).lt.0.001)xh(3)=x0(3)

      pi=3.14159265d0
      degtorad=pi/180.d0
      rearth=6371.
      eps=0.01d0
      sthi=0.0
      cthi=1.0
      dx(1)=0.0
      dx(2)=0.0

c    nl=no of layers

c nov 99      nl=(nn+1)/2
      nn=2*nl-1     ! new nov 99 jh
      ne2=1
      ne1=1
      eta2=x0(3)
      if(eta2.eq.0.0)eta2=0.01 !added 6/98 brl
      tmin=1.e22
      if(nl.eq.1)then
        ne1=1
        go to 59
      endif

c    find find layer, ne2, that station is in

      sum=0.0

      do 3 i=1,nl-1
        sss=parm(nl+i)
        sum=sum+sss
        if(x0(3).le.sum)go to 4
3     continue
      sss=0.0
      i=nl
4     ne2=i

c    eta2 is the depth to the station from the top of this layer

      eta2=x0(3)-sum+sss

C    IF JUST AT OR BELOW BOUNDARY, PLACE 1 METER ABOVE (added 6/98, brl)
      if(eta2.lt.0.001.and.ne2.ne.1)then
       eta2=eta2-parm(nl+ne2)-0.001
       ne2=ne2-1
      endif    

c   now find layer, ne1, that event is in

      sum=0.0

      do 1 i=1,nl-1
        sss=parm(nl+i)
        sum=sum+sss
        if(xh(3).le.sum)go to 2
1     continue

      sss=0.0
      i=nl
2     ne1=i

c    eta1 is the depth to the event from the top of this layer

      eta1=xh(3)-sum+sss

c    if eta1 < 0.001, set ne1 to previous layer 

      if(abs(eta1).lt.0.1.and.ne1.ne.1)then !changed eta1 to abs(eta1) 6/98, brl
         eta1=eta1+parm(nl+ne1)
         ne1=ne1-1
c        eta1=parm(nl+ne1)+eta1*parm(ne1+1)/parm(ne1)
      endif
      na=ne2
      ea=parm(nl+ne2)-eta2
      eb=eta1
      nb=ne1

c    station is below hypocenter

      if(ne2.gt.ne1)then
        nb=ne2
        ea=parm(nl+ne1)-eta1
        na=ne1
        eb=eta2
      endif

59    continue

c     use J. Lahr's routine to get delta from geocentric distances
c     azz0 is the azimuth of the station from the epicenter

      call delaz(x0(2),x0(1),delta,dedeg,azz0,xh(2),xh(1))
      delta=abs(delta)
c      write(iulst,*)' Delta = ',delta
      dedeg=abs(dedeg)

c    cfact is local conversion factor between km and radians in rad/km

      cfact=1./rearth
c      cfact=sngl(degtorad)*dedeg/delta
      dellat=delta*cos(azz0*sngl(degtorad))
      dellon=cos(abs(xh(2)))*delta*sin(azz0*sngl(degtorad))
      dist=sqrt(delta**2+(xh(3)-x0(3))**2)

c*************************************************************************
c                       trivial cases

c  1.  ptype='N' and no refractions

      if(ptype.eq.'N'.and.ne1.ge.nmoho)then
        if(iulst.gt.0.and.(.not.multi_model))
     *  write(iulst,*)' dtdx2 error: event below moho - ',
     &  'N phase not possible'
        iflag=0
        ann=0.0            
        phsid='        '
        return
      endif

      if(ptype.eq.'B'.and.ne1.ge.nconrad)then
        if(iulst.gt.0.and.(.not.multi_model))
     *  write(iulst,*)' dtdx2 error: event below Conrad',
     &  ' - B phase not possible'
        phsid='        '
        iflag=0
        ann=0.0
        return
      endif

      if(nl.eq.1.and.ptype.eq.'N')then
        if(iulst.gt.0)write(iulst,*)'dtdx2 error: N phase not possible',
     &  ' in a single layer'
        phsid='        '
        iflag=0
        ann=0.0
        return
      endif

      if(nl.eq.1.and.ptype.eq.'B')then
        if(iulst.gt.0)write(iulst,*)'dtdx2 error: B phase not possible',
     &  ' in a single layer'
        phsid='        '
        iflag=0
        ann=0.0
        return
      endif

      if(dist.lt.0.001)then

c  2. event coincident with station

        do 17 i=1,2
17      dx(i)=-1.0/(cfact*parm(ne1))

        dx(1)=dx(1)*cos(abs(xh(2)))
        dx(3)=rearth/parm(ne1)

c  incidence angle set to zero (???) for this case

        phsid='        '
        ann=0
        iflag=1
        if(ptype.eq.'N'.or.ptype.eq.'B')then
            iflag=0
          if(iulst.gt.0)write(iulst,*)' dtdx2 error: event coincident',
     &    ' with station - no refracted phase'
          phsid='        '
          iflag=0
          return
        endif
        phsid='        '
        iflag=1
        tmin=0.0
        ann=0.0
        return
      endif

      if(delta.lt.0.001)go to 24


c  3.  single layer case: only direct wave possible

      if(nl.eq.1)then
        tmin=dist/parm(1)
        dx(1)=-dellon/(cfact*dist*parm(1))
        dx(2)=-dellat/(cfact*dist*parm(1))
        dx(3)=(xh(3)-x0(3))*rearth/(dist*parm(1))
        if(xh(3).ne.x0(3))then
          dd=atan(delta/(xh(3)-x0(3)))/sngl(degtorad)
          if(dd.ge.0.0)then
            ann=180.0-dd
          else
            ann=abs(dd)
          endif
        else
          ann=90.0
        endif
        phsid(2:8)='G      '
        iflag=1
        return
      endif

      if(ptype.eq.'G')go to 66

c  4.  station or event in bottom layer - no refractions

      if(ne1.eq.nl.or.ne2.eq.nl)then
        if(ptype.eq.'N'.or.ptype.eq.'B')then
          if(iulst.gt.0)write(iulst,*)' dtdx2 error: refracted phase',
     &    ' not possible for event in bottom layer'
          phsid='        '
          iflag=0
          ann=0.0
          return
        else
          go to 66
        endif
      endif
c*******************************************************************

c   nep1 is the shallowest layer in which refraction can occur

      nep1=ne1+1
      if(ne2+1.gt.nep1)nep1=ne2+1
c      write(iulst,*)'nep1,nl,ne1,ne2,nmoho',nep1,nl,ne1,ne2,nmoho
      
      if(ptype.eq.'N'.and.nep1.ge.nl)then
        if(iulst.gt.0)write(iulst,*)' dtdx2: no N phase',
     &  ' for event below Moho'
        phsid='        '
        iflag=0
        ann=0.0
        return
c   changed 4/94 to include 'B'
      elseif(ptype.eq.'B'.and.nep1.gt.nconrad)then
        if(iulst.gt.0)write(iulst,*)' dtdx2: no B phase',
     &  ' for event below Conrad'
        phsid='        '
        iflag=0
        ann=0.0
        return
      endif
      
      if(delta.eq.0.0)go to 24
      if(ptype.eq.'N'.and.(ne1.eq.nl.or.ne2.eq.nl))then
        if(iulst.gt.0)write(iulst,*)' dtdx2: no N phase',
     &  ' when event or station is in bottom layer'
        phsid='        '
        iflag=0
        ann=0.0
        return
      elseif(ptype.eq.'B'.and.(ne1.gt.nconrad.or.ne2.gt.nconrad))then
        if(iulst.gt.0)write(iulst,*)' dtdx2: no B phase',
     &  ' when event or station is in or below Conrad'
        phsid='        '
        iflag=0
        ann=0.0
        return
      endif

c  find the refracted wave travel times

c  kmin is the fastest refraction layer, tmin is its travel time

      kmin=0

c   find critical distances, dcrit(k), for all refracted waves. if no
c   refracted wave is possible, set dcrit(k)=-1.0

      n1=ne2

c  need this section for when station is below hypocenter

      if(ne2.gt.ne1)n1=ne1
      n2=ne1-1
      if(ne2.gt.ne1)n2=ne2-1

c 4/94: added for 'B' case
      if(ptype.eq.'B')n1=nconrad

      do 50 k=nep1,nl
        sum=0.0
        do 40 i=nep1-1,k-1
          if(parm(k).le.parm(i))go to 49
40      sum=sum+parm(nl+i)*2./sqrt((parm(k)/parm(i))**2-1.)

        if(parm(k).le.parm(ne1).or.parm(k).le.parm(ne2))go to 49
        dcrit(k)=sum-eta1/sqrt((parm(k)/parm(ne1))**2-1.)
     &  -eta2/sqrt((parm(k)/parm(ne2))**2-1.)

        if(ne1.ne.ne2)then
          do 42 i=n1,n2
            if(parm(k).le.parm(i))go to 49
42        dcrit(k)=dcrit(k)+parm(nl+i)/sqrt((parm(k)/parm(i))**2-1.)
        endif
c        write(iulst,*)'k,dcrit,delta',k,dcrit(k),delta
        if(dcrit(k).le.delta)go to 50
49      dcrit(k)=-1.0
50    continue


c   find the travel times, t, for all possible refracted waves

      do 60 k=nep1,nl
        if(dcrit(k).lt.0.0)go to 60
        sum=0.0

        do 52 i=nep1-1,k-1
          eee=parm(nl+i)*2.
52      sum=sum+eee*sqrt(1./(parm(i)*parm(i))-1./(parm(k)*parm(k)))

        if(parm(ne1).gt.parm(k))go to 60
        t=delta/parm(k)-eta1*sqrt(1./(parm(ne1)*parm(ne1))
     &  -1./(parm(k)*parm(k)))+sum-eta2*sqrt(1./(parm(ne2)*parm(ne2))
     &  -1./(parm(k)*parm(k)))

        if(ne1.ne.ne2)then
          do 53 i=n1,n2
53        t=t+parm(nl+i)*sqrt(1./(parm(i)*parm(i))-1./1/(parm(k)*
     &    parm(k)))
        endif

c   if t < tmin, set tmin = t

        if(t.lt.tmin)then
          kmin=k

c added output id 4/94
          if(k.eq.nconrad)phsid(2:8)='B      '
          if(k.eq.nmoho)phsid(2:8)='N      '

          tmin=t
        endif

c    N phase: if k = nmoho  then exit

        if(ptype.eq.'N'.and.nmoho.eq.k)then
          phsid='N'
          kmin=k
          tmin=t
          go to 62
        endif

c    B phase: if k = nconrad  then exit

        if(ptype.eq.'B'.and.nconrad.eq.k)then
          phsid='B'
          kmin=k
          tmin=t
          go to 62
        endif

60    continue

c     exit if ptype='N' or 'B' and  no refracted wave is possible

      if(ptype.eq.'N'.or.ptype.eq.'B'.and.kmin.eq.0)then
          if(iulst.gt.0)write(iulst,*)' dtdx2: refracted phase',
     &    ' not possible, delta < critical distance' 
        phsid='        '
        iflag=0
        ann=0.0
        return
      endif

66    continue

c    Direct travel times


c    Trivial cases: (i) same depth

      if(abs(xh(3)-x0(3)).lt.0.001)go to 36

c                   (ii) station and event in same layer

      if(ne1.eq.ne2)then
        td=dist/parm(ne1)
        if(td.lt.tmin.or.ptype.eq.'G')then
          tmin=td
          dx(1)=-dellon/(cfact*dist*parm(ne1))
          dx(2)=-dellat/(cfact*dist*parm(ne1))
          dx(3)=(xh(3)-x0(3))*rearth/(dist*parm(ne1))
          if(xh(3).ne.x0(3))then
            dd=atan(delta/(xh(3)-x0(3)))/sngl(degtorad)
            if(dd.ge.0.0)then
              ann=180.-dd
            else
              ann=abs(dd)
            endif
          else
            ann=90.0
          endif
          phsid(2:8)='G      '
          iflag=1
          return
        endif
      endif


c   calculate the direct path travel time, td

c    find tangents of maximum and minimum takeoff angles,t1 and t2

      et=eta1
      ne=ne1
      if(ne2.gt.ne1)et=eta2
      if(ne2.gt.ne1)ne=ne2
      if(ne1.ne.ne2)go to 39
      if(xh(3).eq.x0(3))go to 36
      td=dist/parm(ne1)
      thi=atan(delta/abs(xh(3)-x0(3)))
      cthi=cos(thi)
      sthi=sin(thi)
      go to 37
39    continue
      t1=dble(delta)/dble(abs(xh(3)-x0(3)))
      if(et.eq.0.0)et=1.e-30               !added 6/98, brl
      t2=dble(delta)/dble(et)
      u1=dble(et)*t1
      u2=dble(delta)

c   find raypath parameters, p1 and p2 for direct waves

      p1=1.d0/(dsqrt(1.d0+1.d0/(t1*t1))*dble(parm(ne)))
      p2=1.d0/(dsqrt(1.d0+1.d0/(t2*t2))*dble(parm(ne)))
      p=p1
      sthi=sngl(p1)*parm(ne)
      cthi=sqrt(1.-sthi*sthi)

c   find corresponding distances, dl1 and dl2 for the 2 rays

      dl1=del(p1,eta1,ne1,eta2,ne2,nn,parm)
      if(dabs(dl1-dble(delta)).le.eps)go to 30
41    if(dl1.le.dble(delta))go to 43
      t1=dtan(2.d0*datan(t1)-datan(dl1/dble(abs(xh(3)-x0(3)))))
      p1=1.d0/(dsqrt(1.d0+1.d0/(t1*t1))*dble(parm(ne)))
      dl1=del(p1,eta1,ne1,eta2,ne2,nn,parm)
      go to 41
43    continue
      dl2=del(p2,eta1,ne1,eta2,ne2,nn,parm)
      if(dl1.eq.dl2)go to 30
      u1=dble(et)*t1
      u2=dble(delta)

c   now find takeoff angle thi and distance delta1 of a ray p which
c   lies between p1 and p2

      ii=0
10    uu=u1+(u2-u1)*(dble(delta)-dl1)/(dl2-dl1)
      ii=ii+1
      if(dabs(uu).gt.1.d100)uu=1.d100*uu/dabs(uu)    !added 6/98, brl
      p=uu/(dble(parm(ne))*dsqrt(uu*uu+dble(et)*dble(et)))
      sthi=sngl(p)*parm(ne)
      cthi=sqrt(1.0-sthi*sthi)
      dll=del(p,eta1,ne1,eta2,ne2,nn,parm)

c   iterate until abs(delta-dll)<eps

      if(dabs(dll-dble(delta)).le.eps)go to 30
      if(dabs(dl1-dble(delta)).gt.eps)go to 770
      dll=dl1
      uu=u1
      go to 30
770   if(dabs(dl2-dble(delta)).gt.eps)go to 771
      dll=dl2
      uu=u2
      go to 30
771   if(ii.gt.50)go to 26
      if(dll.gt.dble(delta))go to 20
      dl1=dll
      if(dl1.eq.dl2)dl1=dl1-.001     !added 6/98, brl
      u1=uu
      go to 10
20    dl2=dll
      u2=uu
      go to 10
26    continue
      if(iulst.gt.0)then
        write(iulst,100)
        write(iulst,101)delta,dll
100     format(' no direct path convergence after 50 iterations')
101     format(' delta = ',f12.4,' dll = ',f12.4)
      endif
      phsid='        '
      iflag=0
      ann=0.0
      return

24    p=0.0d0
30    continue

c   calculate the travel time,td,for the direct path

      td=0.0

      do 35 i=na,nb
        pm=parm(nl+i)
        if(i.eq.na)pm=ea
        if(i.eq.nb)pm=eb
        if(dble(parm(i))*p.ge.1.0d0)go to 38
35    td=td+pm/(parm(i)*sqrt(1.-p*p*parm(i)*parm(i)))
      go to 37
38    continue
      if(iulst.gt.0)then
        write(iulst,'(''dtdx2 error: p > 1/velocity in layer '',
     &  i3,'' p = '',f6.4)')i,p
      endif
      phsid='        '
      iflag=0
      ann=0.0
      return

36    td=delta/parm(ne1)
      cthi=0.0
      sthi=1.0

37    if(td.gt.tmin.and.ptype.ne.'G')go to 62

c    set minimum travel time to td

      tmin=td

c   direct path derivatives

      dx(1)=0.0
      dx(2)=0.0
      if(delta.lt.0.001)go to 69
      dx(1)=-dellon*sthi/(cfact*delta*parm(ne1))
      dx(2)=-dellat*sthi/(cfact*delta*parm(ne1))
69    dx(3)=cthi*rearth/parm(ne1)
      if(x0(3).gt.xh(3))dx(3)=-dx(3)
      if(cthi.ne.0.0)then
        ann=180.-abs(atan(sthi/cthi))/sngl(degtorad)
      else
        ann=90.0
      endif
      phsid(2:8)='G      '
      iflag=1
      return

c   refracted path is minimum - find spatial derivatives of tmin and exit

62    k=kmin
      dx(1)=-dellon/(cfact*delta*parm(k))
      dx(2)=-dellat/(cfact*delta*parm(k))
c 4/94: added section to write # of refraction layer
c        if(k.eq.nmoho)then
c         phsid(2:8)='N      '
c        elseif(k.eq.nconrad)then
c         phsid(2:8)='B      '
c        else
         phsid(2:8)='N      '
         if(k.lt.10)then
          write(phsid(3:3),'(i1)')k 
         elseif(k.lt.100)then 
          write(phsid(3:4),'(i2)')k 
         elseif(k.lt.1000)then 
          write(phsid(3:5),'(i3)')k 
         elseif(k.lt.10000)then 
          write(phsid(3:6),'(i4)')k 
         endif
c        endif                                       
      if(parm(k).lt.parm(ne1))then
        if(iulst.gt.0)then
          write(iulst,'(''dtdx2 error:'',
     &     '' Illegal velocity inversion '')')
          write(iulst,500)ne1,kmin,xh(3),parm(ne1),parm(k)
        endif
500     format(2i8,3f12.4)
        phsid='        '
        ann=0.0
        iflag=0
        return
      endif
      dx(3)=-rearth*sqrt(1./(parm(ne1)*parm(ne1))-1./(parm(k)
     &*parm(k)))
      dd=sqrt(parm(k)*parm(k)-parm(ne1)*parm(ne1))
      if(dd.ne.0.0)then
        ann=atan(parm(ne1)/dd)/sngl(degtorad)
      else
        ann=90.0
      endif
      iflag=1
      return

      end

      subroutine azdist(alat1,alon1,az,alat2,alon2,dist,alata,alona,
     &alatb,alonb,nsol)
c************************************************************************
c   Intersection of one distance and one azimuth at different stations
c
c  finds the latitudes/longitudes of the intersections of a distance, dist,
c  from a point at (alat2,alon2) and a line having azimuth az (deg)
c  through a point at (alat1,alon1). Solved for plane case, but works
c  roughly (100 km error at delta=20 deg) on a sphere
c
c  nsol = no of intersections
c  (alata,alona) is the first intersection, (alatb,alonb) the second
c     - the latter only valid when nsol=2
c
c                   Barry R. Lienert  1991
c***********************************************************************
          save
          degtorad=0.0174533
          nsol=0
          x1=alon1*degtorad
          y1=alat1*degtorad
          y2=alat2*degtorad
          x2=alon2*degtorad
          call delaz(y2,x2,dekm,dedeg,azz,y1,x1)
c          write(*,*)' dekm azz ',dekm,azz
          theta=azz-az
          d=abs(dist*sin(theta*degtorad))
          if(d.gt.dist)return
          del=sqrt(dist*dist-d*d)
          delt1=dekm*cos(theta*degtorad)
c          write(*,*)' del delt ',del,delt1
          if(delt1.ge.0.0)then
            if(delt1+del.ge.0.0)then
              nsol=1
              delt=(delt1+del)/(6371.*degtorad)
              call latlon(alat1,alon1,delt,az,alata,alona)
            endif
            if(delt1-del.ge.0.0)then
              nsol=nsol+1
              delt=(delt1-del)/(6371.*degtorad)
              call latlon(alat1,alon1,delt,az,alatb,alonb)
            endif
          else
            del=dekm/dist
            arg=1.0+del*del-2.0*del*cos(theta*degtorad)
            if(arg.lt.0)return
            nsol=1
            r=dist*sqrt(arg)
            delt=r/(6371.*degtorad)
            call latlon(alat1,alon1,delt,az,alata,alona)
          endif
          return
          end

      subroutine minv(m,n,np,dt1,di,dtw1)

C****************************************************************************
C
c  inversion subroutine: finds svd of partial derivative matrix, g1
C
c                   Barry R. Lienert  1991
C
c this routine is independent of damping and only needs to be performed
c when a new step is taken. For the adaptive dampi8ng technique, used in
c HYPOCENTER, this is only when the rms decreases. Consequently, it uses
c the minimum rms partial derivative matrix, g1(i,j)

C***************************************************************************
C
c   inputs:     g1 = partial derivative matrix
c               n  = no of rows in g1 (i.e., no of data)
c               m  = no of columns in g1 (i.e., no of parameters)
c               dt1 = data residuals          
c               dtw1 = data weights
C
c   outputs:    ve    = (mxm) eigenvector matrix of gt*g
c               u     = (nxn)    "     "     "      g*gt
c               di    = (nx1) data importances
C
C***************************************************************************

c modified 9/94 to calculate information matrix, si=uTu, also
c changed to structured format
C
      save
      include 'hypparm.inc'
c      include 'comm1.inc'
c      dimension dt1(*),dtw1(*),di(*)

c  first find g1t*g1 and put it in a in correct format for eigen
      ic=1

      do j=1,m
        do k=1,j
          sum=0.0
          do kc=1,n
            g3=g1(kc,j)
            g2=g1(kc,k)
            sum=sum+g3*g2
          enddo  
          a(ic)=sum
          ic=ic+1
        enddo
      enddo    

c      do i=1,n
c       write(6,'(4e10.3)')(g1(i,j),j=1,m)
c      enddo

c get eigenvalues (diag(a)) and eigenvectors (ve)
      call eigen(a,ve,m,0)

      sum=0.0
      ii=1
      np=0

      do i=1,m
c     sum=sum+dabs(a(ii))
        sum=sum+abs(a(ii))

c 6/94 changed 1e-7 to 1e-20
        if(a(ii).gt.1.0e-20)then

          np=np+1
        endif

C       eig(i)=dabs(a(ii))
        eig(i)=abs(a(ii))
        if(eig(i).ne.0.0)then
         sgn(i)=a(ii)/eig(i)
        endif
        ii=ii+i+1
      enddo  

      if(np.lt.m)m=np

c   now find eigenvectors of g1*g1t, u
      do i=1,np
        do j=1,n
          sum=0.0
          do k=1,m
            ii=(i-1)*m+k
            f=1.0
            gg=g1(j,k)
            sum=sum+sgn(i)*ve(ii)*gg
          enddo  
          u(j,i)=sum/sqrt(abs(eig(i)))
        enddo
      enddo                        
      
c 9/94: data importance calculation added      
      do i=1,n       
       di(i)=0.0
       if(dtw1(i).gt.0.0)then
        do j=1,np
         di(i)=di(i)+u(i,j)*u(i,j)
        enddo
        
c normalize by # data and make it %        
        di(i)=di(i)*100./float(np) 
        
       endif 
      enddo
        
c  eigenvalues of g = sqrt(eigenvalues of g1t*g1
      do i=1,m
       eig(i)=sqrt(eig(i))
      enddo 

c  determine  alpha=vt*dt (Jackson, 1972)
      do j=1,np
       alpha(j)=0.0
       ax(j)=0.0
      enddo 

      do k=1,n
        do j=1,np
          aa=dt1(k)
          alpha(j)=alpha(j)+u(k,j)*aa/eig(j)
          ax(j)=ax(j)+u(k,j)*aa
        enddo
      enddo    

      return
      end

c************************************************************************
      subroutine corr(m,n,np,xk,res,test,oterr,distind,iflagd)
c
c   subroutine to calculated damped least squares parameter corrections
c   and variances using SVD eigenvalues and eigenvectors
c
c             Barry R. Lienert  1991
c
c  reference: 'interpretation of inaccurate, insufficient and inconsistent
c              data'.  D.D. Jackson, Geophys. J. Roy. Astr. Soc., 28, 97-109,
C              1972
C
c        m is the number of columns in the SVD matrix
c        n is the number of rows
c        xk is the damping factor
c        res is their squared weighted sum
c
c        np (output) is the number of eigenvectors used
c
c************************************************************************
c
      save
      include 'hypparm.inc'
c      include 'comm1.inc'
      double precision dble             
c      dimension test(200)
c      character*1 distind

c change 10/93: prevents divide by zero in some situations
      ndeg=0
      do i=1,3

c 6/94 changed 1e-7 to 1e-20
        if(eig(i).gt.1.e-20)ndeg=ndeg+1
        dth(i)=0.0
      end do
        
      if(np.gt.ndeg)np=ndeg

c changed 9/94 to use Bayesian statistics and F-distribution      
c local event degs freedom & error
      degfb=test(86)    !changed test(87) to test(86) 6/98 BRL
      errb=test(85) 

c distant case
      if(distind.eq.'D'.or.iflagd.eq.1)then  !changed 6/98, brl
       degfb=test(92)
       errb=test(91)
      endif                 
      
      ndeg=int(degfb+0.499999)
c  changed brl, 6/98
      cres=(degfb*errb**2+res)/(degfb+float(n)-float(np+1))
c      cres=(degfb*errb**2+res)/(test(86)+float(n)-float(np+1))

c use F-distribution to get confidence interval for residuals  
c corrected an error to include the total degrees of freedom, np+1 6/98 BRL
      rs=float(np+1)*cres*fdist(np+1,ndeg+n-np-1,test(87))
c      rs=cres*fdist(np+1,ndeg+n-np-1,test(87))
      
c 10/24/94: added origin time error. Same as confidence interval
c           for residuals
      oterr=sqrt(rs)      

      do i=1,m
        dth(i)=0.0
        do j=1,np
          ii=(j-1)*m+i
          f1=0.0
          f2=0.0
          sx=ss1(i)
c         write(6,*)ve(ii),eig(j),alpha(j)
          f2=sngl(dble(ve(ii)*alpha(j))/(1.0d0+dble(xk)/dble
     &    (eig(j))**2))
          dth(i)=dth(i)+f2
        end do

c changed 8/94 to calculate complete unscaled covariance matrix var(i,j)
c common block comm1.inc changed to accomodate this
        do j=1,m
          var(i,j)=0.0
          do k=1,np
            ii=(k-1)*m+i
            jj=(k-1)*m+j
            if(ss1(i).gt.0.0.and.ss1(j).gt.0.0.and.eig(k).gt.0.0)then
             f1=rs*ve(ii)*ve(jj)/((eig(k)+xk/eig(k))**2*ss1(i)*ss1(j))
             var(i,j)=var(i,j)+f1
            endif 
          end do
        end do    
      end do  

      return
      end

c BRL 6/98: added ips check
      subroutine median(a,wt,phase,n,am,ips)
      save
      dimension a(*),wt(*),ips(*)
      character*8 phase(*)
      no=n/2+1
      am=a(1)
      do 10 i=1,n
      if(wt(i).le.0.0.or.phase(i)(1:2).eq.'AZ'.or.ips(i).eq.1)go to 10
      if(a(i).gt.am)am=a(i)
10    continue
      do 50 i=1,n
      if(wt(i).le.0.0)go to 50
      knt=0
      do 40 j=1,n
      if(wt(i).le.0.0)go to 40
      if(a(j).le.a(i))knt=knt+1
40    continue
      if(knt.ge.no.and.a(i).lt.am)am=a(i)
      if(knt.eq.no)go to 60
50    continue
60    return
      end

c**************************************************************************
c Get a set of phases in Nordic format<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
c change 10/93: removed iunit1 and init from window
c change 3/94 added narriv and check that its not exceeded
      
      subroutine getphasn(nphase,iazflag,st,phase,prm1,prm2,prm3,ip,
     &tp,coda,fixdep,depth,fixepi,xlat,xlon,orgsec,fixor,iulst,data,
     &test,distind,narriv1,imap,xmag,magtype,oldrms,appar_veloc)
c
c   after change nov 23, iunit1 is not used, replaced by array data	 
c
c  BRL 6/92   Added test parameters to window
c             Now only use phase data if apparent veloc.< test(58)
c             distind added to window
c
c 11/92 BRL added orgsec to window
c 4/94: added fixor to window              
c 9/94: added xmag & magid to window              
c 10/94: added oldrms                                          
c 6/98: added appar_veloc
c
C***************************************************************************
c
c  Updates:
c  May 21 -91  C.L. : Possibility to select start location facilitated
c                     by use of test(57). Nordic format changed
C  NOV 23 91   J.H. : change to new nordic format, line indicator on same line
c                     use data array data instead of read
c  May 92      BRL  : added comments to make termination conditions clearer
c  April 94    BRL   : changed to read 8 char phase ID's if col 6 is not blank
c                      (col 6 is then the WEIGHT)
c******************************************************************************
c
c      get a set of phases - Nordic format

      save
      include 'hypparm.inc'
c      include 'param.inc'                     ! added 6/98
      double precision secs,orgsec
      character*8 phased
      character*4 type   
      character*5 depth,azimuth
      character*1 prm1(narriv),prm2(narriv),prm3(narriv),
     & fixepi,expl,fixdep,
     &cont,pp,magtype
      dimension coda(*)
      type='    '
      fmp1=0.0
      nphase=0

c     i is the phase counter

 10   i=1

c
c   counter for record to read in data array
c
      krecord=1

c     read header record

c change BRL 1/94: 43x changed to 34x 
c 4/94: added fixor in col 11
c added imap to record position in data array
c 9/94: added magnitude, changed f5.2 to f4.1
c 10/94: added oldrms
c2000      read(data(1),'(3x,i2,1x,2i2,a1,2i2,1x,f4.1,1x,2a1,f7.3,f8.3,a5,a1,
      read(data(1),'(1x,i4,1x,2i2,a1,2i2,1x,f4.1,1x,2a1,f7.3,f8.3,a5,a1,
     &a1,6x,f4.1,f3.0,a1,19x,a1)',end=99,err=15)iyr,imnth,idy,fixor,
     &iohr,iomin,orsec,distind,expl,xlat,xlon,depth,fixdep,fixepi,
     &oldrms,xmag,magtype,cont
c      write(iulst,*)data(1)
      if(iulst.gt.0.and.(.not.multi_model))then
        write(iulst,'(a80)')data(1)
c        write(iulst,'(3x,i2,1x,2i2,a1,2i2,f5.2,1x,2a1,f7.3,f8.3,a5,
c     &  a1,a1)')iyr,imnth,idy,fixor,iohr,iomin,orsec,distind,expl,
c     &  xlat,xlon,depth,fixdep,fixepi
      endif

c calculate header origin time, orgsec

      call timsec(iyr,imnth,idy,iohr,iomin,orsec,orgsec)
      go to 815

c change BRL 12/29/93: print header if error
 15   continue
      write(iulst,*)' getphasn: Error in header record:'
      write(iulst,*)data(1)
815   continue
c      write(iulst,*)data(krecord)(1:20),krecord,i,imap(i)
      krecord=krecord+1                                   
      

c  skip over headings

      read(data(krecord),200,end=99)cont
200   format(79x,a1)
c      write(iulst,*)data(krecord)(1:20),krecord,i,imap(i)

c  skip over non-phase records

c change BRL 1/94: changed 15 to 815
      if(cont.ne.' '.and.cont.ne.'4')go to 815

c    read the phase 

c change BRL 1/94: print message if error in phase record
 20   read(data(krecord),100,end=99,err=166) 
     &st(i),pp,prm1(i),phased,
     &ihrr,imn,tsec,icoda,azimuth,veloc,cont
 100  format(1x,a5,2x,2a1,a8,2i2,f6.1,1x,i4,13x,a5,f5.1,
     &23x,a1)
      
c change 4/94 to read 8 char phase ID if col 6 not blank
      if(pp.eq.' ')then
       pp=phased(5:5)
       prm3(i)=phased(7:7)

c set remaining 4 chars to blank in normal case
c       phased(5:8)='    '
      else

c set first motion to ' ' for 8 char phase ID
       prm3(i)=' '                           
       
      endif
       
      imap(i)=krecord
      go to 816
166   continue
      write(iulst,*)' getphasn: Error in phase record:'
      write(iulst,*)data(krecord)

c 7/94: added this section here, since error record gets processed - set weight to 4 
      pp='4'
      imap(i)=krecord
816   continue

c modifification (BRL 6/13/92) to trap error due to additional
c phase letters in weight column - previously this caused the
c phase to be rejected

      read(pp,'(i1)',err=88)ip(i)
      
c change:10/94: reset weights>4 to 4
      if(ip(i).gt.4.and.ip(i).ne.9)ip(i)=4
            
      go to 89
88    ip(i)=0
89    krecord=krecord+1 

c this prints the input phases in the output print file: enabled by test(74)=1 4/94
      if(iulst.gt.0.and.test(74).ne.0.0.
     *and.(.not.multi_model))then

c 10/94: changed position of pp & removed prm3(i)
        if(st(i).ne.'     ')write(iulst,100) st(i),pp,prm1(i),phased,
     &  ihrr,imn,tsec,icoda,azimuth,veloc,cont

      endif

c blank record signifies end of this phase set

      if(st(i).eq.'     ')then
        nphase=i-1
c        init=2
c        if(nphase.eq.0)init=-1
        return
      endif

c     do 30 k=1,4
c30   phased(k:k)=ucase(phased(k:k))

      call timsec(iyr,imnth,idy,ihrr,imn,tsec,secs)
      tp(i)=secs
      phase(i)=phased
      prm2(i)=phased(1:1)
      coda(i)=float(icoda)                         
      appar_veloc(i)=veloc     !added 6/98

c    treat azimuth as a separate phase - return it in sec(i)
c
c   why veloc not eq 0.0, commented out by jh
c   changed to test for both azimuth and velocity non-zero (BRL 92)

c     if(azimuth.ne.'    '.and.iazflag.eq.1.and.veloc.lt.test(58))then
c      write(*,*)azimuth,iazflag
        read(azimuth,'(f5.1)')azz

c -1 test added 6/92 BRL

      if(azimuth.ne.'     '.and.iazflag.eq.1.and.azz.ne.-1..and.veloc.
     &lt.test(58).and.(veloc.ne.0..or.azz.ne.0.)) then
        i=i+1
        phase(i)='AZ      '
        st(i)=st(i-1)
        read(azimuth,'(f5.1)')tp(i)
        prm1(i)=prm1(i-1)
        prm2(i)=prm2(i-1)
        prm3(i)=prm3(i-1)
        imap(i)=imap(i-1)
        appar_veloc(i)=appar_veloc(i-1)
        
c give azimuth the same weight as its parent phase
c 10/94: set=0 if difference phase
        if(ip(i-1).ne.9)then
         ip(i)=ip(i-1)
        else
         ip(i)=0
        endif  
      endif

c  bump the phase count and get another record

      i=i+1

c added 3/94 to test for exceeding maximum arrivals      
      if(i.gt.narriv1)then
       write(*,*)'Maximum arrivals exceeded - edit hypparm.inc and reco'
     & ,'mpile sources'
       stop
      endif  

      go to 20
c      nphase=i-1
c      init=2
c      if(nphase.eq.0)init=-1
c      return

c       end of file

99    nphase=i-1
c      init=-1
      return

98    write(iulst,'('' Phase record out of sequence'')')
      write(*,'('' Phase record out of sequence'')')
      go to 10

97    write(iulst,'('' Header record out of sequence'')')
      write(*,'('' Header record out of sequence'')')
      go to 20

      end

c**************************************************************************
c   subroutine to calculate the direct path horizontal displacement for an
c   n-layered one-dimensional model
c
c      Barry R. Lienert    October, 1982
c      modified for variable elevation stations 2/17/87
c
c   inputs:   p       raypath parameter = sin(theta)/velocity
c             eta     depth to event from the top of the layer
c                     it is in
c             n       layer event is in
c             eta1    depth to station from top of the layer
c                     it is in
c             n1      layer station is in
c             nn      no of parameters
c             parm(i) i=1,nn   layer velocities, then thicknesses
c
c*******************************************************************
      double precision function del(p,eta,n,eta1,n1,nn,parm)
      save
      dimension parm(*)
      double precision e,p
      nl=(nn+1)/2
      del=0.0d0
      na=n1
      ea=parm(nl+n1)-eta1
      nb=n
      eb=eta
      if(nb.ge.na)go to 5
      na=n
      ea=parm(nl+n)-eta
      nb=n1
      eb=eta1
5     continue
      do 10 i=na,nb
         e=dble(parm(nl+i))
         if(i.eq.na)e=dble(ea)
         if(i.eq.nb)e=dble(eb)
         if(dble(parm(i))*p.ge.1.0d0)go to 11
10    del=del+e/dsqrt(1.0d0/(dble(parm(i))*p)**2-1.0d0)
      return
11    del=1000.
      write(*,100)i
100   format(1x,/,' dtdx2 error: p >= 1/v(',i2,') ')
      return
      end
c***************************************************************************
c        subroutine eigen
c
c        purpose
c           compute eigenvalues and eigenvectors of a real symmetric
c           matrix
c
c        usage
c           call eigen(a,r,n,mv)
c
c        description of parameters
c           a - original matrix (symmetric), destroyed in computation.
c               resultant eigenvalues are developed in diagonal of
c               matrix a in descending order.
c           r - resultant matrix of eigenvectors (stored columnwise,
c               in same sequence as eigenvalues)
c           n - order of matrices a and r
c           mv- input code
c                   0   compute eigenvalues and eigenvectors
c                   1   compute eigenvalues only (r need not be
c                       dimensioned but must still appear in calling
c                       sequence)
c
c        remarks
c           original matrix a must be real symmetric (storage mode=1)
c           matrix a cannot be in the same location as matrix r
c
c        subroutines and function subprograms required
c           none
c
c        method
c           diagonalization method originated by Jacobi and adapted
c           by Von Neumann for large computers as found in 'Mathematical
c           Methods for Digital Computers', edited by A. Ralston and
c           H.S. Wilf, John Wiley and sons, New York, 1962, chapter 7
c
c     ..................................................................
c
      subroutine eigen(a,r,n,mv)
      save
      dimension a(*),r(*)
c
c        ...............................................................
c
c        if a double precision version of this routine is desired, the
c        c in column 1 should be removed from the double precision
c        statement which follows.
c
c      double precision a,r,anorm,anrmx,thr,x,y,sinx,sinx2,cosx,
c     1                 cosx2,sincs,range
c
c        the c must also be removed from double precision statements
c        appearing in other routines used in conjunction with this
c        routine.
c
c        the double precision version of this subroutine must also
c        contain double precision fortran functions.  sqrt in statements
c        40, 68, 75, and 78 must be changed to dsqrt.  abs in statement
c        62 must be changed to dabs. the constant in statement 5 should
c        be changed to 1.0d-12.
c
c        ..............................................................
c
c        generate identity matrix
c
    5 range=1.0e-7 
      if(mv-1) 10,25,10
   10 iq=-n
      do 20 j=1,n
      iq=iq+n
      do 20 i=1,n
      ij=iq+i
      r(ij)=0.0
      if(i-j) 20,15,20
   15 r(ij)=1.0
   20 continue
c
c        compute initial and final norms (anorm and anormx)
c
   25 anorm=0.0
      do 35 i=1,n
      do 35 j=i,n
      if(i-j) 30,35,30
   30 ia=i+(j*j-j)/2
      anorm=anorm+a(ia)*a(ia)
   35 continue
      if(anorm) 165,165,40
40    anorm=sqrt(2.0*anorm)
      anrmx=anorm*range/dfloat(n)
c
c        initialize indicators and compute threshold, thr
c
      ind=0
      thr=anorm
   45 thr=thr/dfloat(n)
   50 l=1
   55 m=l+1
c
c        compute sin and cos
c
   60 mq=(m*m-m)/2
      lq=(l*l-l)/2
      lm=l+mq
   62 if(abs(a(lm))-thr) 130,65,65
   65 ind=1
      ll=l+lq
      mm=m+mq
      x=0.5*(a(ll)-a(mm))
   68 y=-a(lm)/sqrt(a(lm)*a(lm)+x*x)
      if(x) 70,75,75
   70 y=-y
75    sinx=y/sqrt(2.0*(1.0+(sqrt(abs(1.0-y*y)))))
      sinx2=sinx*sinx
   78 cosx= sqrt(1.0-sinx2)
      cosx2=cosx*cosx
      sincs =sinx*cosx
c
c        rotate l and m columns
c
      ilq=n*(l-1)
      imq=n*(m-1)
      do 125 i=1,n
      iq=(i*i-i)/2
      if(i-l) 80,115,80
   80 if(i-m) 85,115,90
   85 im=i+mq
      go to 95
   90 im=m+iq
   95 if(i-l) 100,105,105
  100 il=i+lq
      go to 110
  105 il=l+iq
  110 x=a(il)*cosx-a(im)*sinx
      a(im)=a(il)*sinx+a(im)*cosx
      a(il)=x
  115 if(mv-1) 120,125,120
  120 ilr=ilq+i
      imr=imq+i
      x=r(ilr)*cosx-r(imr)*sinx
      r(imr)=r(ilr)*sinx+r(imr)*cosx
      r(ilr)=x
  125 continue
      x=2.0*a(lm)*sincs
      y=a(ll)*cosx2+a(mm)*sinx2-x
      x=a(ll)*sinx2+a(mm)*cosx2+x
      a(lm)=(a(ll)-a(mm))*sincs+a(lm)*(cosx2-sinx2)
      a(ll)=y
      a(mm)=x
c
c        tests for completion
c
c        test for m = last column
c
  130 if(m-n) 135,140,135
  135 m=m+1
      go to 60
c
c        test for l = second from last column
c
  140 if(l-(n-1)) 145,150,145
  145 l=l+1
      go to 55
  150 if(ind-1) 160,155,160
  155 ind=0
      go to 50
c
c        compare threshold with final norm
c
  160 if(thr-anrmx) 165,165,45
c
c        sort eigenvalues and eigenvectors
c
  165 iq=-n
      do 185 i=1,n
      iq=iq+n
      ll=i+(i*i-i)/2
      jq=n*(i-2)
      do 185 j=i,n
      jq=jq+n
      mm=j+(j*j-j)/2
      if(a(ll)-a(mm)) 170,185,185
  170 x=a(ll)
      a(ll)=a(mm)
      a(mm)=x
      if(mv-1) 175,185,175
  175 do 180 k=1,n
      ilr=iq+k
      imr=jq+k
      x=r(ilr)
      r(ilr)=r(imr)
  180 r(imr)=x
  185 continue
      return
      end


c**********************************************************************
c function to calculate the F-distribution function for nu1 parameters,
c having nu2 degrees of freedom at confidence level alpha

c Barry Lienert 1994

c determined using 'Numerical recipes' functions betai, betacf, gammln
c and (modified) bisection function, rtbis, to find the root of qf

      FUNCTION fdist(nu1,nu2,alpha)
      external qf

c lower and upper limit of F
      f1=0
      f2=1.e6

c accuracy desired
      facc=1.e-6

c find the root of qf(f,nu1,nu2,alpha)
      fdist=rtbis(qf,f1,f2,facc,nu1,nu2,alpha)

      return
      end

c****************************************************************
c equation of F-distribution probability minus confidence
c level alpha: the root of this is the F-distribution value
c at nu1,nu,alpha

c Barry Lienert 1994

      FUNCTION qf(f,nu1,nu2,alpha)
      a=float(nu2)*.5
      b=float(nu1)*.5
      x=float(nu2)/(float(nu2)+float(nu1)*f)

c equation to find the root of
      qf=betai(a,b,x)-alpha

      return
      end

c>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
c numerical recipes functions

      FUNCTION betai(a,b,xx)                        !JAB(BGS)Mar95.
      REAL betai,a,b,x
      real       xx,                                !JAB(BGS)Mar95.Argument.
     &           xlogmax,                           !JAB(BGS)Mar95.Max log.
     &           xexpmin                            !JAB(BGS)Mar95.Min exp.
      parameter (xexpmin = 1.0e-30)                 !JAB(BGS)Mar95.& value.
      parameter (xlogmax = 69.0)                    !JAB(BGS)Mar95.
c
CU    USES betacf,gammln
      REAL bt,betacf,gammln
c
      x = xx                                        !JAB(BGS)Mar95.Working copy.
      if(x.lt.0..or.x.gt.1.)pause 'bad argument x in betai'
c
c    Prevent "log" underflow/overflow/divide by zero/inexact etc...
c
      if( x .lt. xexpmin ) then                     !JAB(BGS)Mar95.
      bt = gammln(a+b)                              !JAB(BGS)Mar95.
     &   - gammln(a)                                !JAB(BGS)Mar95.
     &   - gammln(b)                                !JAB(BGS)Mar95.
     &   - a*xlogmax                                !JAB(BGS)Mar95.
     &   + b*log(1.-x)                              !JAB(BGS)Mar95.
c
      else if( 1.0-x .lt. xexpmin ) then            !JAB(BGS)Mar95.
      bt = gammln(a+b)                              !JAB(BGS)Mar95.
     &   - gammln(a)                                !JAB(BGS)Mar95.
     &   - gammln(b)                                !JAB(BGS)Mar95.
     &   + a*log(x)                                 !JAB(BGS)Mar95.
     &   - b*xlogmax                                !JAB(BGS)Mar95.
c
      else
      bt = gammln(a+b)                              !JAB(BGS)Mar95.
     &   - gammln(a)                                !JAB(BGS)Mar95.
     &   - gammln(b)                                !JAB(BGS)Mar95.
     &   + a*log(x)                                 !JAB(BGS)Mar95.
     &   + b*log(1.-x)                              !JAB(BGS)Mar95.
      endif
c
      if( abs(bt) .gt. xlogmax ) then               !JAB(BGS)Mar95.
      bt = exp(sign(xlogmax,bt))                    !JAB(BGS)Mar95.
      else                                          !JAB(BGS)Mar95.
      bt = exp( bt )                                !JAB(BGS)Mar95.
      end if                                        !JAB(BGS)Mar95.
c
CJAB(BGS)Mar95.     bt=exp(gammln(a+b)-gammln(a)-gammln(b)+a*log(x)+b*log(1.-x))
c
      if(x.lt.(a+1.)/(a+b+2.))then
        betai=bt*betacf(a,b,x)/a
        return
      else
        betai=1.-bt*betacf(b,a,1.-x)/b
        return
      endif
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ">29,)KL4.
      FUNCTION betacf(a,b,x)
      INTEGER MAXIT
      REAL betacf,a,b,x,EPS,FPMIN
      PARAMETER (MAXIT=100,EPS=3.e-7,FPMIN=1.e-30)
      INTEGER m,m2
      REAL aa,c,d,del,h,qab,qam,qap
      qab=a+b
      qap=a+1.
      qam=a-1.
      c=1.
      d=1.-qab*x/qap
      if(abs(d).lt.FPMIN)d=FPMIN
      d=1./d
      h=d
      do 11 m=1,MAXIT
        m2=2*m
        aa=m*(b-m)*x/((qam+m2)*(a+m2))
        d=1.+aa*d
        if(abs(d).lt.FPMIN)d=FPMIN
        c=1.+aa/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        h=h*d*c
        aa=-(a+m)*(qab+m)*x/((a+m2)*(qap+m2))
        d=1.+aa*d
        if(abs(d).lt.FPMIN)d=FPMIN
        c=1.+aa/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      pause 'a or b too big, or MAXIT too small in betacf'
1     betacf=h
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ">29,)KL4.
      FUNCTION gammln(xx)
      REAL gammln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      gammln=tmp+log(stp*ser/x)
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ">29,)KL4.

c********************************************************************
c this function modified (BRL, 94) to include the
c extra variables nu1, nu2 & alpha needed for the F-distribution
      FUNCTION rtbis(func,x1,x2,xacc,nu1,nu2,alpha)
      INTEGER JMAX
      REAL rtbis,x1,x2,xacc,func
      EXTERNAL func
      PARAMETER (JMAX=40)
      INTEGER j,nu1,nu2
      REAL dx,f,fmid,xmid,alpha
      fmid=func(x2,nu1,nu2,alpha)
      f=func(x1,nu1,nu2,alpha)
      if(f*fmid.ge.0.) pause 'root must be bracketed in rtbis'
      if(f.lt.0.)then
        rtbis=x1
        dx=x2-x1
      else
        rtbis=x2
        dx=x1-x2
      endif
      do 11 j=1,JMAX
        dx=dx*.5
        xmid=rtbis+dx
        fmid=func(xmid,nu1,nu2,alpha)
        if(fmid.le.0.)rtbis=xmid
        if(abs(dx).lt.xacc .or. fmid.eq.0.) return
11    continue
      pause 'too many bisections in rtbis'
      END
C  (C) Copr. 1986-92 Numerical Recipes Software ">29,)KL4.
      

c$DEBUG
c
c   Subroutine makes a input files for hypo71 using curent
c   seisan station file and the pahse readings. The file made
c   is called hypo71.input
c   It also returns the test parameters used in the magnitude
c   calculation in array test.
c
c   updates:
c
c     20-02-2001 lo  : added extension flag for UK grid in make_hypo71_brief
c
c
      subroutine make_hypo71_input(test,agency,error)

      implicit none

      character*80 line            ! one line
      character*80 cur_file        ! station file in current directory
      character*80 dat_file        ! station file in DAT directory
      character*60 top_directory   ! seisan top dir
      character*1 dchar            ! '/' character

      character*5 oldsta,newsta
      CHARACTER*5 station(100)
      CHARACTER*80 data(2500)
      CHARACTER*1 typ,exp
c---agency for magnitude  
      character*3 agency
      character*80 testdat
      character*10 stat


      integer nstat,nphase,nhead,nrecord
      integer id
      integer i,j,k
      integer itp
      integer nlayers
      integer testnum
      integer lat1,lon1
      integer min

      real xnear,xfar,startz,vpvs
      real vel(100), z(100)
      real startlat,startlon,lat2,lon2,sec
c-- test variables
      real testj
      real test(200)

      character*6 stat_name
      character*1 dlat,dlon
      integer lat,lon,elev
      real mlat,mlon,del,mcor,dec_lon
      real hypo71_offset
      logical offset
      
      logical error,found
      logical trial_dep,fix_dep,trial_epi,fix_epi

      common/readings/NSTAT,NPHASE,NHEAD,NRECORD,TYP,EXP,DATA,ID
      common/model/vel,z,nlayers,startz,xnear,xfar,vpvs
      common/hypo71/ hypo71_offset


      trial_dep=.false.
      trial_epi=.false.
      fix_dep=.false.
      fix_epi=.false.


      if (error) return

      call dir_char(dchar)
      call topdir(top_directory)
      ITP=index(top_directory,' ')-1

c check for x offset to be applied to
c station coords of events near Greenwich Meridian
c      call get_hypo71_offset(coffset)
c      read(coffset,'(f3.0)')xoffset
      if(hypo71_offset.gt.0.0) then
         offset=.true.
         write(*,*) 'Applying offset ',hypo71_offset,
     1        'to station coordinates'
      else
         offset=.false.
      endif

c
c   find station file to use
c
c
c  make file name for both file in current and dat directory
c
      cur_file(1:12)='STATION0.HYP'
      dat_file(1:itp)=top_directory(1:itp)	  
      dat_file(itp+1:itp+1)=dchar
      dat_file(itp+2:itp+4)='DAT'	  
      dat_file(itp+5:itp+5)=dchar
      dat_file(itp+6:itp+17)=cur_file(1:12)	  	  
      open(1,file=cur_file,status='old',err=1)
c      write(6,2001) cur_file(1:12)
      goto 2
 1    continue	  
      OPEN(1,FILE=dat_file,STATUS='OLD',err=3)
c      write(6,2001) dat_file(1:itp+17)
      goto 2
 3    continue
      write(6,*)' No station file found'
      error=.true.
      return
 2    continue
 2001 format (' Using station file ', a)

c
c create array of stations, making sure that station don't 
c occur more than once. This seems a bit torturous but it works
c
      k=0
      do i=nhead+1,nrecord-1
         oldsta=data(i)(2:6)
         found=.false.
         do j=i+1,nrecord-1
            newsta=data(j)(2:6)
            if(oldsta.eq.newsta) then
               found=.true.
            endif
         enddo
         if(.not.found) then
            k=k+1
            station(k)=data(i)(2:6)
         endif
      enddo

c   open output files
c
      open(2,file='hypo71.input',status='unknown')

      write(2,'(a4)') 'HEAD'

c
c   read to end of seisan station file and fish out relevant info
c
c
c   reset test parameters if neccesary
c
        stat='xxxxx'
        j=-1
        do while (stat.ne. '     '.and.j.ne.0)
           read(1,'(a80)')testdat
           if(testdat(14:14).eq.')')then
              read(testdat,'(a5,t12,i2,t16,f9.4)')stat,j,testj
           elseif(testdat(13:13).eq.')')then
              read(testdat,'(a5,t12,i1,t15,f9.4)')stat,j,testj
           else
              read(testdat,'(a5)')stat
              j=-1
           endif
           if(j.gt.0)then
              test(j)=testj
           endif
        enddo
        
c
c set step length damping control to less than 100 in case hypocenter default value is being used
c
      if(test(2).gt.100.0) test(2)=100.0
c
c set critical F value to 0.5
c
        test(3)=0.5

      if(test(3).lt.2.0) test(6)=1.0
c
c set Mc parameters a,b,c to defaults if not already set.
c
      if(test(7).eq.0.0) test(7)=-0.87
      if(test(8).eq.0.0) test(8)=2.0
      if(test(9).eq.0.0) test(9)=0.0035
c
c set test(57) parameter to default value if required
c
      if(test(57).eq.0.0) test(57)=1500.

c
c set test(71) parameter to default value if required
c this enable distance sorting of output
c
      if(test(71).eq.0.0) test(71)=1.0

c
c set Ml parameters a,b,c,d to defaults (Hutton and Boore, 1987)
c if not already set.
c
      if(test(75).eq.0.0) test(75)=1.0
      if(test(76).eq.0.0) test(76)=1.11
      if(test(77).eq.0.0) test(77)=0.00189
      if(test(78).eq.0.0) test(78)=-2.09

      do j=1,13
         if(test(j).ne.0.0) then
            write(2,'(a11,i2.2,a2,f10.4)') 'RESET TEST(',j,')=', test(j)
         endif
      enddo

      write(2,*)
c
c   station coordinates
c
      read(1,'(a)') line
 20   continue     


c correction for offset if required bjb 
      if(line(2:2).ne.' ') then
         read(line,'(1x,a5,i2,f5.2,a1,i3,f5.2,a1,i4,f6.2,f5.2)')
     1        stat_name,lat,mlat,dlat,lon,mlon,dlon,elev,del,mcor
         if(offset) then
            dec_lon=real(lon)+(mlon/60.0)
            if(dlon.eq.'W') then
               dec_lon=-1.0*dec_lon+hypo71_offset
               dlon='E'
            else
               dec_lon=dec_lon+hypo71_offset
            endif
            lon = int(dec_lon)
            mlon = (dec_lon - real(lon)) * 60.0
         endif
         do i=1,nphase
         if(line(2:6).eq.station(i)(1:5)) then
            write(2,'(1x,a5,i2,f5.2,a1,i3,f5.2,a1,i4,f6.2,f5.2)')
     *           stat_name,lat,mlat,dlat,lon,mlon,dlon,elev,del,mcor
         endif
         enddo
      else
         read(line,'(2x,a4,i2,f5.2,a1,i3,f5.2,a1,i4,f6.2,f5.2)')
     1        stat_name,lat,mlat,dlat,lon,mlon,dlon,elev,del,mcor
         if(offset) then
            dec_lon=real(lon)+(mlon/60.0)
            if(dlon.eq.'W') then
               dec_lon=-1.0*dec_lon+hypo71_offset
               dlon='E'
            else
               dec_lon=dec_lon+hypo71_offset
            endif
            lon = int(dec_lon)
            mlon = (dec_lon - real(lon)) * 60.0
         endif
         do i=1,nphase
         if(line(3:6).eq.station(i)(1:4)) then
            write(2,'(2x,a4,i2,f5.2,a1,i3,f5.2,a1,i4,f6.2,f5.2)')
     *           stat_name,lat,mlat,dlat,lon,mlon,dlon,elev,del,mcor
         endif
         enddo
      endif

      read(1,'(a)')line
      if(line(1:10).ne.'          ') goto 20
c
c   model
c
      i=0
      write(2,*)
      read(1,'(a)') line
 30   continue
      i=i+1
      read(line,'(2f8.3)') vel(i),z(i)
      write(2,'(2f7.3)') vel(i),z(i)
      read(1,'(a)') line
      if(line(1:10).ne.'          ') goto 30
      nlayers=i
      write(2,*)

c
c  vp/vs, start depth and distance weight
c
      read(1,'(3f5.0,f5.2)') startz,xnear,xfar,vpvs
c
c Check for flags for starting location and fixing location
c
      if(data(1)(44:44).eq.'S') then
         read(data(1)(39:43),'(f5.1)') startz
         trial_dep=.true.
      else if(data(1)(44:44).eq.'F') then
         read(data(1)(39:43),'(f5.1)') startz
         fix_dep=.true.
      endif
      if(data(1)(45:45).eq.'S') then
         read(data(1)(24:30),'(f7.3)') startlat
         read(data(1)(31:38),'(f8.3)') startlon
         startlon=abs(startlon)
         trial_epi=.true.
      else if(data(1)(45:45).eq.'F') then
         read(data(1)(24:30),'(f7.3)') startlat
         read(data(1)(31:38),'(f8.3)') startlon
         startlon=abs(startlon)
         fix_epi=.true.
      endif

      if(trial_epi) then
         lat1=int(startlat)
         lat2=(startlat-real(lat1))*60.0
         lon1=int(startlon)
         lon2=(startlon-real(lon1))*60.0
         write(2,'(f5.0,f5.0,f5.0,f5.2,4x,a1,4x,a1,
     *        24x,a1,1x,a4,2x,i2,1x,f5.2,1x,i3,1x,f5.2)') 
     *        startz,xnear,xfar,vpvs,'4','1','1','1111',
     *        lat1,lat2,lon1,lon2
      else
         write(2,'(f5.0,f5.0,f5.0,f5.2,4x,a1,4x,a1,24x,a1,1x,a4)') 
     *        startz,xnear,xfar,vpvs,'4','1','1','1111'
      endif
c
c read agency
c
      read(1,'(a3)') agency

c
c   convert to hypo71 and write out 
c
      call nor2hypo71(2,nrecord,nhead,data)
        

c
c   write instruction card
c
      if(fix_dep.and.fix_epi) then
         read(data(1)(14:15),'(i2)') min
         read(data(1)(17:20),'(f4.1)') sec
         lat1=int(startlat)
         lat2=(startlat-real(lat1))*60.0
         lon1=int(startlon)
         lon2=(startlon-real(lon1))*60.0
         write(2,'(17x,a2)')'19'
         write(2,'(f5.0,f5.2,i5,f5.2,i5,f5.2,f5.2)')
     *        real(min),sec,lat1,lat2,lon1,lon2,startz
      else if(fix_dep) then
         write(2,'(17x,a2,f5.2)')'11',startz
      else
         write(2,'(17x,a2)')'10'
      endif


      close(1)
      close(2)

      return
      end



      subroutine nor2hypo71(unit,nrecord,nhead,data)
	  
c
c   gets one event in nordic format in array data and writes it to unit
c   in hypo71 format
c
      implicit none
      character*80 data(*)
      character*80 pline(100),sline(100)
      integer nrecord,unit,nhead
      integer year,month,day,hour,min
      real sec
      integer i,j,k
      integer np,ns
      integer phour,pmin,shour,smin,psdiff
      real ssec

      logical pfound
c
c   read reference time, put sec to zero so all following times 
c   are referred to a whole minute
c
      sec=0.0
      read(data(1),'(1x,i4,1x,2i2,1x,2i2)') 
     *year,month,day,hour,min
      if(year.lt.2000) year=year-1900
      if(year.ge.2000) year=year-2000
      
c
c   read both p and s phases to end of event
c
      np=0
      ns=0
      do k=nhead+1,nrecord-1
         read(data(k)(19:28),'(i2,i2,1x,f5.1)') hour,min,sec

         if(data(k)(11:11).eq.'P'.or.data(k)(10:10).eq.'p') then
            np=np+1
            write(pline(np),
     *           '(a4,a2,2a1,1x,i2.2,i2.2,i2.2,i2.2,i2.2,f5.2)') 
     *           data(k)(2:5),data(k)(10:11),data(k)(17:17),
     *           data(k)(15:15),year,month,day,hour,min,sec
         endif

         if(data(k)(11:11).eq.'S'.or.data(k)(10:10).eq.'s') then
            ns=ns+1
            write(sline(ns),'(a4,5x,i2.2,i2.2,i2.2,i2.2,i2.2,f5.2,
     *           7x,f5.2,a2,a1,a1)') 
     *           data(k)(2:5),year,month,day,hour,min,sec,sec,
     *           data(k)(10:11),data(k)(17:17),data(k)(15:15)
         endif

      enddo

c
c for each p phase, check to see if an s phase exists
c if so then write p and s on same line to output
c if no matching s then just output the p phase
c
      do 100 i=1,np
         do 200 j=1,ns
            if(pline(i)(1:4).eq.sline(j)(1:4)) then
c check that the minute for both p and s match
c otherwise add 60 seconds to s second
               if(pline(i)(18:19).ne.sline(j)(18:19)) then
                  read(pline(i)(16:17),'(i2)') phour 
                  read(pline(i)(18:19),'(i2)') pmin 
                  read(sline(j)(16:17),'(i2)') shour
                  read(sline(j)(18:19),'(i2)') smin 
                  read(sline(j)(32:36),'(f5.2)') ssec 
                  psdiff=(shour*60.0+smin)-(phour*60.0+pmin)
                  ssec=ssec+(60.0*psdiff)
                  write(sline(j)(31:36),'(f6.2)') ssec 
               endif
               write(unit,'(a24,6x,a10)') 
     *              pline(i)(1:24),sline(j)(31:40)
               goto 100
            else
               goto 200
            endif            
 200     continue
         write(unit,'(a24)')pline(i)(1:24)
 100  continue


c
c check for s picks without a p pick at a given station
c
      do i=1,ns
         pfound=.false.
         do j=1,np
            if(pline(j)(1:4).eq.sline(i)(1:4)) then
               pfound=.true.
            endif
         enddo
         if (.not.pfound) then
            write(unit,'(a4,a5,a10,11x,a10)')
     *           sline(i)(1:4),'   4 ',sline(i)(10:19),sline(i)(31:40)
         endif
      enddo
         


      return
      end




C-----------------------------------------------------------------------
C Takes file HYPO71.output and updates the phase readings
C
      subroutine update_location(agency,error)

      implicit none

      logical error
c      logical bgs_seisan


      character n_or_s, w_or_e
      character*132 line
      character*80 data(2500)
      character q*1, sqd*3
      character*1 typ,exp
      character*4 station(100)
      character*2 phase(100)
      character*3 agency

      real sec
      real lat2, lon2, depth
      real* 8 dec_lat, dec_lon
      double precision grid_east,grid_north
      real rms,erh,erz
      real xnear,xfar,startz,vpvs
      real vel(100), z(100)
      real distance(100)
      real residual(100)
      real weight(100)
      real sdlat,sdlon,sdz
      
      integer azimuth(100)
      integer nrecord,nhead,nphase,nstat,id
      integer year,month,day,hour,min
      integer lat1, lon1
      integer no,dm,gap,m
      integer nlayers
      integer nused
      integer iter
      integer i,j,k
      character*10 extension

      real hypo71_offset
      logical offset
      
      common/readings/NSTAT,NPHASE,NHEAD,NRECORD,TYP,EXP,DATA,ID
      common/model/vel,z,nlayers,startz,xnear,xfar,vpvs
      common/hypo71/ hypo71_offset

      if (error) return

c
c call function to determine ig BGS seisan outputs are to be used
c bjb 2001/02/14
c
c      call get_bgs_seisan(bgs_seisan)
      call get_env_seisan_extension(extension)

c read environment variable continaing x offset to be applied to
c station coords of events near Greenwich Meridian
c      call get_hypo71_offset(coffset)
c      read(coffset,'(f3.0)')xoffset
      if(hypo71_offset.gt.0.0) then
         offset=.true.
         write(*,*) 'Correcting offset ',hypo71_offset
      else
         offset=.false.
      endif


      open (unit = 1, file = 'hypo71.output', status = 'old',
     1     err=91)
	
 1    read (1,'(a132)',end=92) line
      if ( line (1:9) .eq. '  I  ORIG') then
         do i=1,200
            read (1,'(a132)') line
            read (line(1:3),'(i3)') iter
           if (iter.eq.0) then
               goto 10
            endif
         enddo
c backspace twice to get back to last iteration line
 10      backspace(1)
         backspace(1)
         read (1,'(a132)') line
         read(line(96:113),'(3f6.2)') sdlat,sdlon,sdz
         goto 2
      else
         goto 1
      endif

 2    do i = 1 , 1000
         read (1,'(a132)',end=92) line
         if ( line (1:6) .eq. '  DATE') goto 3
      end do

 3    n_or_s = line (25:25)
      w_or_e = line (35:35)
      read (1, '(a132)') line
c
c read time string
c
      read(line(2:3), '(i2)') year
      if (year.gt.50) year=year+1900
      if (year.lt.50) year=year+2000
      read(line(4:5), '(i2)') month
      read(line(6:7), '(i2)') day
      read(line(9:10), '(i2)') hour
      read(line(11:12), '(i2)') min
      read(line(14:18), '(f5.2)') sec

c
c     convert to decimal lat and lon
c
      read (line (20:37),'(i2,1x,f5.2,1x,i3,1x,f5.2)',err=93)
     *     lat1, lat2, lon1, lon2

      dec_lat = lat1 + lat2/60.0
      dec_lon	= lon1 + lon2/60.0

      if(offset) then
         dec_lon=dec_lon-hypo71_offset
         if(dec_lon.lt.0.0) then
            w_or_e='W'
            dec_lon=abs(dec_lon)
         endif
      endif


      if (n_or_s .eq. 'S') dec_lat = -dec_lat
      if (w_or_e .eq. 'W') dec_lon = -dec_lon

      if(extension(1:3).eq.'BGS') then    ! lot 14-02-2002
        call latlon2ukgrid(error,dec_lat,dec_lon,grid_east,grid_north)
      endif

      read(line(38:44),'(f7.2)') depth


c
c read error params
c
      read(line(53:84),1001) no,dm,gap,m,rms,erh,erz,q,sqd
 1001 format(2(i2,1x),i3,1x,i1,f5.2,2f5.1,1x,a1,1x,a3)

      do i = 1 , 1000
         read (1,'(a132)',end=92) line
         if ( line (1:5) .eq. '  STN') goto 4
      end do

      nused=0
 4    do i = 1,1000
         read (1, '(a132)') line

         if(line(1:5).ne.'     ') then
            nused=nused+1
            read(line(2:15),'(a4,f6.1,1x,i3)') 
     1           station(nused),distance(nused),azimuth(nused)
            read(line(21:22),'(a2)') 
     1           phase(nused)
            read(line(55:65),'(f5.2,2x,f4.2)') 
     1              residual(nused),weight(nused)

            if(line(101:101).eq.'S') then
               nused=nused+1
               read(line(2:15),'(a4,f6.1,1x,i3)') 
     1              station(nused),distance(nused),azimuth(nused)
               read(line(100:101),'(a2)') 
     1              phase(nused)
               read(line(117:121),'(f5.2)') 
     1              residual(nused)
               read(line(124:127),'(f4.2)',err=11) 
     1              weight(nused)
               goto 12
 11            weight(nused)=0.0
 12            continue
            endif

         else
            goto 5
         endif
      enddo

 5    continue

c      do i=1,nused
c      write(*,*) i,station(i),distance(i), azimuth(i), 
c     1     residual(i), weight(i)
c      enddo
c
c write parameters to data line 1
c
      write(data(1)(2:10),'(i4,1x,i2.2,i2.2)') year,month,day
      write(data(1)(12:20),'(i2.2,i2.2,1x,f4.1)') hour,min,sec
      write(data(1)(24:43),'(f7.3,f8.3,f5.1)') dec_lat,dec_lon,depth
      write(data(1)(46:48),'(a3)') agency
      write(data(1)(49:51),'(i3)') no
      write(data(1)(52:55),'(f4.1)') rms

c
c add error line
c
c Error record should have been removed by this point
c but check anyway
      k=2                                          
      do while (data(k)(79:80).ne.'83'.and.k.le.nhead)
         k=k+1
      enddo         

c no error record: move data array below header down 1
      if(data(k)(79:80).ne.'83')then
         do i=2,nrecord
            data(nrecord+3-i)=data(nrecord+2-i)
         enddo
         nrecord=nrecord+1
         nhead=nhead+1                                

c write errors in new record 83
         k=2                               
         do i=1,78
            data(k)(i:i)=' '
         enddo 
         data(k)(79:80)='83'
      endif              
        
c write out errors into data(k)        
      if(extension(1:3).eq.'BGS') then
        write(data(k)(1:17),'(f8.3,1x,f8.3)') grid_east,grid_north   ! lot 14-02-2002
      else
        write(data(k)(2:14),'(a13)') 'HYPO71 Errors'   
      endif
      write(data(k)(19:19),'(a1)')q
      write(data(k)(21:23),'(a3)')sqd
      write(data(k)(25:27),'(i3)')no
      write(data(k)(28:30),'(i3)')dm
      write(data(k)(32:34),'(i3)')gap
      write(data(k)(36:36),'(i1)')m
      write(data(k)(38:41),'(f4.2)')rms
      write(data(k)(43:46),'(f4.1)')erh
      write(data(k)(48:51),'(f4.1)')erz


      if(extension(1:3).eq.'BGS') then

c
c add velocity model line
c
c Velocity model record should have been removed by this point
c but check anyway
         k=3
         do while (data(k)(79:80).ne.'93'.and.k.le.nhead)
            k=k+1
         enddo         
         
c no velocity model record: move data array below header down 1
         if(data(k)(79:80).ne.'93')then
            do i=3,nrecord
               data(nrecord+4-i)=data(nrecord+3-i)
            enddo
            nrecord=nrecord+1
            nhead=nhead+1                                

c write errors in new record 3         
            k=3
            do i=1,78
               data(k)(i:i)=' '
            enddo 
            data(k)(79:80)='93'
         endif              
        
         do i=1,nlayers
            j=1+(i-1)*12
            write(data(k)(j:j+11),'(f5.2,1x,f5.2,a1)')vel(i),z(i),'/'
         enddo

c
c add location parameter line
c
c Location parameter record should have been removed by this point
c but check anyway
         k=4
         do while (data(k)(79:80).ne.'A3'.and.k.le.nhead)
            k=k+1
         enddo         

c no location parameter record: move data array below header down 1
         if(data(k)(79:80).ne.'A3')then
            do i=4,nrecord
               data(nrecord+5-i)=data(nrecord+4-i)
            enddo
            nrecord=nrecord+1
            nhead=nhead+1                                

c write errors in new record A3
            k=4
            do i=1,78
               data(k)(i:i)=' '
            enddo 
            data(k)(79:80)='A3'
         endif              
         
         write(data(k)(3:5),'(f3.0)') startz
         write(data(k)(7:10),'(f4.0)') xnear
         write(data(k)(12:15),'(f4.0)') xfar
         write(data(k)(17:20),'(f4.2)') vpvs
         
      endif


c output azimuths and distances
      do 100 i=nhead+1,nrecord-1
         do 200 j=1,nused
            if(data(i)(2:5).eq.station(j).and.
     1           data(i)(10:11).eq.phase(j)) then
               write(data(i)(64:68),'(f5.1)') residual(j)
c               write(data(i)(69:70),'(i2)') 10*nint(weight(j))
               write(data(i)(71:75),'(i5)') nint(distance(j))
               write(data(i)(77:79),'(i3)') azimuth(j)
               goto 100
            else if(data(i)(2:5).eq.station(j).and.
c     1           data(i)(10:11).eq.'E ') then
     1         (data(i)(10:11).eq.'E '.or.data(i)(11:12).eq.'AM'))then
               write(data(i)(71:75),'(i5)') nint(distance(j))
               write(data(i)(77:79),'(i3)') azimuth(j)
               goto 100
            endif
 200     continue
 100  continue

      close (unit=1)
      return


C Error making output
      

 91   write(*,*) 'Hypo71.output does not exist'
      error= .true.
      return

 92   write (2,'(a)') ' No location obtained with this data'
      close (unit = 1)
      error= .true.
      return

 93   write (2,'(a)') ' Error reading location'
      close (unit = 1)
      error= .true.
      return

      end
C--------------------------------------------------------------------------
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
C Takes file HYPO71.output and produces a summary called HYPO71.BRIEF
C ie condenses the useful information of HYPO71.output into a smaller
C file, also with grid-references and magnitude

      subroutine make_hypo71_brief(data,nhead,nrecord,error)

      logical error

      character n_or_s, w_or_e
c      character ans
      character * 132 line1, line2
      character*5 stat
c      character * 4 stations(30) ! store station names from which
c                                 ! magnitudes were obtained
c      character * 4 mags( 30)    ! stores individual magnitudes
      CHARACTER*80 DATA(2500)                                                  

c      integer yea,yr,mon,mt,day,dy,hou,hr,min,mn ! time parameters
c      integer istat             ! number of channels
      integer count, nml, nmc
      integer lat1, lon1
c      integer counter           ! do loop counter
      integer year              ! JE for year 2K
      integer icoda
      integer idist
      integer nrec,nhead,nrecord

      real lat2, lon2
      real xmag, cmag
      real amp,period
      real * 8 dec_lat, dec_lon
      double precision grid_east, grid_north  ! lo 11/04/2003
      character*10 extension

      real hypo71_offset
      logical offset
      

      common/hypo71/ hypo71_offset

 
      if (error) return

      call get_env_seisan_extension(extension)

c read environment variable continaing x offset to be applied to
c station coords of events near Greenwich Meridian
c      call get_hypo71_offset(coffset)
c      read(coffset,'(f3.0)')xoffset
      if(hypo71_offset.gt.0.0) then
         offset=.true.
         write(*,*) 'Correcting offset ',hypo71_offset
      else
         offset=.false.
      endif


      nml=0
      nmc=0


c	call obtain_magnitude (error, cmag, ccoda_mag, num_readings,
c     * num_coda_readings, stations, mags,  readings_file)

      DO 100 NREC=NHEAD+1,NRECORD-1
         READ(DATA(NREC),'(1x,a5,23X,i4,g7.1,1X,F4.1,25X,I5)'
     *        ,err=1234)
     *        stat,icoda,AMP,PERIOD,IDIST
         goto 1235
 1234    continue
         write(6,*)' Something wrong with input record:'
         write(6,'(a)') data(nrec)
         amp=0.0
 1235    continue 

c
c   check if coda and distance available
c
         if(idist.gt.0.and.icoda.gt.0) then
            nmc=nmc+1
         endif
         
c     
c     check if amplitude is available, assume local magnitude if
c     1: phase is blank, AMP, L or S, period less than 5 secs 
c     and distance less than test(57)
c     
         if(amp.gt.0.0.and.period.lt.5.0.and.
     *        idist.gt.0.and.
     *        (data(nrec)(11:11).eq.' '.or.data(nrec)(11:11).
     *        eq.'L'.or.data(nrec)(11:12).eq.'S '
     *        .or.data(nrec)(11:12).eq.'Sg'
c     *        .or.data(nrec)(11:12).eq.'AM'
     *        .or.data(nrec)(11:13).eq.'AML'
     *        .or.data(nrec)(11:14).eq.'AMPL'
     *        .or.data(nrec)(11:12).eq.'SG')) then
            nml=nml+1
         endif

 100  continue

c
c   check if coda mag is available
c
      if(nmc.ne.0) then
         if(data(1)(60:60).eq.'C') then
            read(data(1)(56:63),'(f4.1,1x,a3)')cmag,agency
         endif
      endif
c
c     check if Ml magnitude is available, if  mag  in first pos. write
c     in second postion, else first.
c     
      if(nml.ne.0) then
         if(data(1)(60:60).eq.'L') then
            read(data(1)(56:63),202) xmag,agency
         else
            read(data(1)(64:71),202) xmag,agency
         endif
 202     format(f4.1,'L',a3)
      endif



      open (unit = 1, file = 'hypo71.output', status = 'old')
      open (unit = 2, file = 'hypo71.brief')
      
      do count = 1 , 1000
         read (1,'(a132)',end=99) line1
         if ( line1 (1:6) .eq. '  DATE') goto 1
      end do
      write (2,'(a)') ' No location obtained with this data'
      close (unit = 1)
      close (unit = 2)


 1    n_or_s = line1 (25:25)
      w_or_e = line1 (35:35)
      read (1, '(a132)') line2

      read(line2(2:3), '(i2)') year
      write (2,'(''Date        : '',a2,''/'',a2,''/'',i2.2)')
     *     line2 (6:7), line2 (4:5), year
      write (2,'(''Origin time : '',a2,'':'',a2,'':'',a5)')
     *     line2(9:10), line2(11:12),line2(14:18)
      
C     convert to decimal lat and lon
       
      read (line2 (20:37),'(i2,1x,f5.2,1x,i3,1x,f5.2)',err=44)
     *     lat1, lat2, lon1, lon2

      if (offset) then
         dec_lat = lat1 + lat2/60.0
         dec_lon	= (lon1 + lon2/60.0) - hypo71_offset


         if (dec_lon .lt. 0.0)then
            w_or_e = 'W'
            dec_lon = -dec_lon
            lon1 = dec_lon
            lon2 = (dec_lon - lon1) * 60.0
            dec_lon = -dec_lon
         else
            w_or_e = 'E'
            lon1 = dec_lon
            lon2 = (dec_lon - lon1) * 60.0
         end if
      else

         dec_lat = lat1 + lat2/60.0
         dec_lon	= lon1 + lon2/60.0
         if (n_or_s .eq. 'S') dec_lat = -dec_lat
         if (w_or_e .eq. 'W') dec_lon = -dec_lon
         
      end if

      write(2,'(''Epicentre   : '',a8,'' deg '',a1,1x,i3,''-'',f5.2,
     *     '' deg '',a1,''   ('',f9.4,'' / '',f9.4,'' )'')')
     *     line2(20:27),n_or_s,lon1,lon2,w_or_e,dec_lat, dec_lon
      
      if (extension(1:3).eq.'BGS') then
        call latlon2ukgrid(error,dec_lat,dec_lon,grid_east,grid_north)
        write(2,'(''Grid ref    : '',f9.3,'' East /'',f9.3,'' North'')')
     *     grid_east, grid_north
      endif

      if (line2(45:45) .eq. '*') then
         write(2,'(''Depth       : '',a$,'' kms  (fixed)'')')
     *        line2(38:44)
         
      else
         write(2,'(''Depth       : '',a$,'' kms'')') line2(38:44)
      endif
      

      write(2,'(''Quality     : '',a)') line2 (80:84)
      
      write(2, *)' '
      write(2,'(''              '',a)') line1(53:79)
      write(2,'(''Statistics  : '',a)') line2(53:79)
      
      
      if (nml.gt. 0) then
         write(2, '(''Magnitude   : '',f4.1, '' ML     (from '',i2,
     *        '' readings)'')' ) xmag, nml

      else
         write(2, '(a)')'Magnitude   : No valid amplitude readings'
      end if

      if (num_coda_readings .gt. 0) then
         write(2, '(''            : '',f4.1, ''  Coda  (from '',i2,
     *        '' readings)'')' ) cmag, nmc
      else
         write(2, '(a)')'Magnitude   : No valid coda readings'
      end if


      read (1, '(a132)') line1
      write (2, *)' '
	
      read (1, '(a132)') line1
      write (2,'(a19,2x,a11,2x,a12)') 
     *     line1(1:19), line1(55:65), line1(116:127)
      
      do count = 1, 1000	
         read (1, '(a132)') line1
         if ((line1.eq. ' ') .or. (line1(3:7).eq.'*****')) goto 2
         write (2,'(a19,2x,a11,2x,a12)') 
     *        line1(1:19), line1(55:65), line1(116:127)
      end do
      
 2    write (2, *) ' '

 99   close (unit=1)
      close (unit=2)
C need to check if the file is empty..
      if(n_or_s.eq.' ') then    ! hypo71.brief is empty
         error = .true.
         return
      end if       
 
C now write in the individual readings in hypo71.mags
c      open (unit = 1, file = 'hypo71.mags')
c      do counter = 1, num_readings
c         write(1, '(27x, a4,2x,a1,1x,a4,1x,a2)')
c     *        stations(counter), ':' , mags(counter), 'ML'
c      end do    
    
      goto 199


C Error making output
44      error= .true.
        close(unit=2)

199     close (unit = 1)           
	return
	end
C--------------------------------------------------------------------------

C--------------------------------------------------------------------
        subroutine latlon2ukgrid(error, slat,slon,lgmee,lgmne)
        implicit  double precision(a-h,o-z)
        logical error
        real*8 slat,slon
        double precision lgmee,lgmne
c icnv is 1 for latlong to ng, 2 for viceversa
        icnv=1
        error = .false.

        f0=0.99960127d0
        b=6356256.9d0*f0
        conv=0.0000048481368d0
        phi1=0.85521133d0
        s=dsin(conv)
        a=6377563.4d0*f0
        esq=0.00667054d0
        if (icnv-1) 1,1,2
    1   continue
        slat=slat*3600.00
        slon=slon*3600.00
        phi2=slat*conv
        pa=phi2-phi1
        pb=phi2+phi1
        xm=b*(1.0016767d0*pa-0.005028071d0*dsin(pa)*dcos(pb)+0.000005250d
     1		0*dsin(2*pa)*dcos(2*pb))
        gnu=a/dsqrt(1-esq*(dsin(phi2)**2))
        two=gnu*0.5*(s**2)*dsin(phi2)*dcos(phi2)*(10.**8)
        rho=gnu*(1-esq)/(1-esq*(dsin(phi2)**2))
        t=dsin(phi2)/dcos(phi2)
        etasq=gnu/rho-1
        three=(gnu/24.)*(s**4)*dsin(phi2)*(dcos(phi2)**3)*(5.-
     1		(dsin(phi2)/dcos(phi2))**2+9*etasq)*(10.**16)
        threa=(gnu/720.)*(s**6)*dsin(phi2)*(dcos(phi2)**5)*(61.-
     1		58.*t*t+t**4)*(10.**24)
        p=(slon+7200.)/10000.
        gmn=xm-100000.+two*p*p+three*p**4+threa*p**6
        four=gnu*s*dcos(phi2)*(10.**4)
        five=-(gnu/6.)*(s**3)*(dcos(phi2)**3)*(gnu/rho-t*t)
     1		*(10.**12)
        six=-(gnu/120.)*(s**5)*(dcos(phi2)**5)*(5.-18*t*t+t**4
     1		+14.*etasq-58.*t*t*etasq+2*(t**4)*etasq)*(10.**20)
        gme=400000.+p*four-five*p**3-six*p**5
        goto12
    2   continue
   12   continue
        gme=gme/1000.00
        slat=slat/3600.00
        slon=slon/3600.00
        gmn=gmn/1000.00
        lgmee=sngl(gme)
        lgmne=sngl(gmn)


        return
        end

c   Program imsnor
c   To exchange info with IMS1.0:SHORT.
c
c   Mario Villagran, March 2001
c   IDC-Vienna                  
c   International Data Centre
c
c   converts nordic format files into IMS1.0:SHORT format 
c   as specified in the IDC Formats and Protocols to submit information 
c   to the IDC and viceversa.
c
c   Input:   nordic or IMS1.0:SHORT format file
c
c            if input is nordic, the corresponding hyp.out
c            and print.out are necesary as well as a correlative
c            number to identify the event in IMS1.0:SHORT format.
c
c            if input is IMS1.0:SHORT no more info is needed.
c      
c   Oputput: IMS1.0:SHORT or nordic format file
c
c   comments: When CONVERTING from nordic to IMS1.0:SHORT
c
c             vector printout(1000*flines) contains space for 
c             700*flines print.out lines of an event
c             300*flines nordic file lines
c
c   comments: When CONVERTING from IMS1.0:SHORT to nordic
c
c             vector printout(1000*flines) contains space for 
c             nordic file lines
c
c             To extend the capacity you have to change
c             the parameter flines (factor to increase 
c             the size of the array 1, 2 ,3....).
c
c   Changes:
c   2001  july 5 jh : make distance real, help from mario
c   2007 04 26      : optionally put out a * for no location flag, 
c                     look for varibale 
c   2008 09 16   jh: make sure all lock flags are F, not f. also Mb changed to
c                    MB, limit number of stations to 999
c   2008 09 26   jh. soem d flag was appearing in fixf, removed
c   2008 10 07   jh  transfer first 6 chars of phase instead og 6 from ims, fix pdif
c
      implicit none
c
c size of working array
      integer flines
      parameter        (flines=10)
c-- arguments, input file, location agency and mag agencies.
      character*136    printout(1000*flines),text   !SEE comments BEFORE
      character*80     args(10),infile,printhyp,region,top_directory
      character*80     cjunk,nordorg(50)
      character*30     ttext
      character        fecha*12,fechax*22,numero*8,sta*5,ph*4,junk*8
      character        lage*7,ph_out*6
      character*11     msta(150)
      character*3      prefage,age1,age2,age3,def,mage(9)
c--crustal model, type of event, id of event,kind of magnitudes.
      character*1      model,type,id,fixd,cd,uno,am,undsc,timf,locf
      character*2      mc,mc1,mc2,mc3,mc4,evex,pl
      character*2      cmg(9)
      real             mg(9)
c--time variables, hypocentral parameters and magnitudes.
      integer          year,mo,dy,hr,mn,npha,nsta,number,gap,az,wg
      integer          nsm1,nsm2,nsm3,nsm4,n,dist,reg,kstop,phnumber
      real             xdist
      real             mag,mag1,mag2,mag3,mag4,hdist,smag,sbmag,snr
      real             sec,lat,lon,dep,rms,tres,velo
      real             ermag1,ermag2,ermag3,x1,x2,x3,mw,smw,azph,raz
      real             ermg(9)
      integer          nm(9),nmags
      real             timerr,x,smajor,sminor,erd,dmin,dmax,amp,per
c--ML,Mb
      real             a,b,c,d,smsta,q,equrad,polrad,pi,rad,radius
                       parameter (equrad = 6378.2064)
                       parameter (polrad = 6356.5838)
                       parameter (pi = 3.14159265)
                       parameter (rad = pi/180.)

      integer*4        stime,tarray(9),time,nmsta,inumid
      character*12     t1   ! for seisan system time
      character*14     t2   ! ---------------------
      character*1      lock ! to lock location
c---ellipse error
      real             ery,erx,erz,cvxy,cvxz,cvyz
c---number of arguments and counters
      integer nars,ncards,i,j,k,ncard,npcard,namp,work,karr,jarr,nmw
      integer nbamp,kk,kkk
c--compact or not
      logical compact
c--computer type
      logical pc, sun,linux
c---
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

        call computer_type(sun,pc,linux)
c
c   check if input from file given in argument
c   display help if necesary
c
      call get_arguments(nars,args)

      if (nars.eq.0) then
        write(6,*) ' Choose option: '
        write(6,*) '     IMS1.0:SHORT -> nordic (1) or '
        write(6,*) '     nordic -> IMS1.0:SHORT (2)'
        read(*,'(a)') args(1)
        if (args(1).eq.'1') then
          write(*,*) ' IMS1.0:SHORT input file '
          read(*,'(a)') args(2)
        elseif (args(1).eq.'2') then
          write(*,*) ' Nordic input file '
          read(*,'(a)') args(2)
          write(*,*) ' Hypocenter output file (default=print.out)'
          read(*,'(a)') args(3)
          if (args(3).eq.' '.or.args(3).eq.'') args(3)='print.out'
          write(*,*) ' Number of first event'
          read(*,'(a)') args(4)
          write(*,*) ' Number of first phase'
          read(*,'(a)') args(5)
        endif
      elseif (nars.eq.1.and.args(0).eq.'-help') then
5       write(6,*)'          '
        write(6,*)' You must define the desired convertion type,'
        write(6,*)' input files and id number (this last only case 2)'
        write(6,*)' 1 for IMS1.0:SHORT------> nordic or'
        write(6,*)' 2 for nordic------> IMS1.0:SHORT'
        write(6,*)' examples:'
        write(6,*)'          '
        write(6,*)' norims 1 xx.inp'
        write(6,*)'          '
        write(6,*)' This converts file xx.inp from IMS1.0:SHORT to'
        write(6,*)' nordic output is file norims.nor'
        write(6,*)'          '
        write(6,*)' norims 2 hyp.out print.out 35 850'
        write(6,*)'          '
        write(6,*)' This creates a IMS1.0:SHORT file from the hyp.out'
        write(6,*)' and print.out files and gives to the first event '
        write(6,*)' in list the number 35, and 850 to the first phase'
        write(6,*)' if number is not defined 001 is the default'
        write(6,*)' for both, output is file norims.ims and compact.ims'
        write(6,*)'          '
        stop
      endif
c
c check arguments
c get input file names and decides what to do
c open files
c
      pl='+-'
      read(args(1),'(i)',err=5)work
      if((work.eq.1.and.nars.gt.2).or.(nars.gt.5).or.
     *(work.gt.2).or.(work.lt.1))then
        write(6,*)' Wrong arguments !!!!!!!!!!!'
        write(6,*)'    '
        goto 5
      endif
      infile=args(2)
      open(1,file=infile,status='old')
c      stime=time()
      call systime(t1,t2)   ! seisan general routine
      read(t1,'(5i2)') (tarray(i),i=6,2,-1)
c      call gmtime(stime, tarray)      !GMT time
      write(ttext(1:30),'(a7,i4,3(a1,i2),i2,a8)')
     *'MSG_ID ',tarray(6)+2000,'/',tarray(5)+1,'/',tarray(4),'_',
     *tarray(3),tarray(2),' IDC_NDC'
      do i=13,22   !fill blanks
        if(ttext(i:i).eq.' ')ttext(i:i)='0'
      enddo
      if(work.eq.1)goto 50
c
c   HERE STARTS CONVERTING FROM NORDIC TO IMS1.0:SHORT
c
      printhyp=args(3)
      read(args(4),'(i)',err=6)number
6     if(number.eq.0)number=1
      read(args(5),'(i)',err=7)phnumber
7     if(phnumber.eq.0)phnumber=1
      open(7,file=printhyp,status='old')
      open(2,file='norims.ims',status='unknown')
      open(4,file='compact.ims',status='unknown')
c
c   check if it is a correct s-file
c
      call nortype(1,compact)
      if(compact) then
       write(6,*)' The file must be an F-file'
       stop
      endif
c
c Gets the time at which the file is done if sun GMT time
c note that on pc the time is local unless some extra-arrangement
c   WRITE IMS1.0:SHORT EXCHANGE DATA LINES
c
      write(2,'(a12)')'BEGIN IMS1.0'
      write(2,'(a13)')'MSG_TYPE DATA'
      write(2,'(a30)')ttext(1:30)
      write(2,'(a23)')'DATA_TYPE BULLETIN IMS1.0:SHORT'
      write(4,'(a12)')'BEGIN IMS1.0'
      write(4,'(a13)')'MSG_TYPE DATA'
      write(4,'(a30)')ttext(1:30)
      write(4,'(a23)')'DATA_TYPE BULLETIN IMS1.0:SHORT'
c
c   NORDIC ----> IMS1.0:SHORT    BIG LOOP STARTS HERE
c
      n=0        !  number of processed events
      a=1.00     ! default calculation of ML is
      b=1.11     ! Hutton & Boore, a,b,c,d
      c=0.00189
      d=-1.9680
c magnitude constants for ML (check if other values in STATION0.HYP)
      call topdir(top_directory)
      i=index(top_directory,' ')-1
      text(1:i+17)=top_directory(1:i)//'/DAT/STATION0.HYP'
      open(8,file=text(1:i+17),status='old')
8     read(8,'(a)')text(1:40)
      if(text(1:5).eq.'RESET')then
       if(text(12:13).eq.'75')read(text(16:),*)a
       if(text(12:13).eq.'76')read(text(16:),*)b
       if(text(12:13).eq.'77')read(text(16:),*)c
       if(text(12:13).eq.'78')read(text(16:),*)d
      endif
      close(8)
c
c  initialize variables
c
  10  continue
        mc1(1:2)='  '
        mc2(1:2)='  '
        mc3(1:2)='  '
        mc4(1:2)='  '
        mag1=0.0
        mag2=0.0
        mag3=0.0
        mag4=0.0
        ermag1=0.0
        ermag2=0.0
        ermag3=0.0
        region(1:80)='  '
        nsta=0
        npha=0
        dmax=0.0
        dmin=15000.00
        undsc='_'
        lage='       '
c
c   GET NECESARY INFORMATION FROM print.out AND THE F-file
c
        ncards=1
15      read(7,'(a80)',end=99)printout(1)(1:80)
           if(printout(1)(1:8).eq.' EVENT #')goto 20
        goto 15
20      ncards=ncards+1
         read(7,'(a80)')printout(ncards)(1:80)
         if(printout(ncards)(1:10).eq.'----------')goto 28
c
c displays possible errors and stop the program
c
         if(ncards.gt.650*flines)then
          write(6,*)printout(1)(1:20),'to many print.out lines!!'
          write(6,*)'to solve this, edit norims.f, read comments'
          goto 99
22        write(6,*)'print.out and S-file not matching !!!'
24        goto 99
         endif
        goto 20
28      continue
        do i=1,ncards
          if(printout(i)(1:19).eq.' Origin time error:')
     *    read(printout(i)(20:60),*)timerr
          if(printout(i)(1:18).eq.'   date hrmn   sec')
     *        read(printout(i+1)(1:80),'(73x,f5.1)')erd
          if(printout(i)(6:19).eq.'multiple-phase')
     *    read(printout(i)(1:5),'(i5)')npha
          if(printout(i)(1:14).eq.' Azimuthal Gap')
     *    read(printout(i)(36:38),'(i3)')gap
          if(printout(i)(1:17).eq.' stn   dist   azm')then
             do j=i+1,ncards
               if(printout(j)(1:3).eq.'   ')goto 30
                 read(printout(j)(1:11),'(7x,i4)')k
               if(dmax.lt.k)dmax=k
               if(dmin.gt.k)dmin=k
             enddo
          endif
30        continue
        enddo
c
c read info from current event and
c place the file ready to read next event
c
        ncard=700*flines  !reserve 701*flines to 1000*flines for nordic 
        namp=0
        nbamp=0
        nsm4=0
        npcard=0
        k=0
        smag=0.0
        sbmag=0.0
        smw=0.0
        nmw=0
        nmsta=0
        smsta=0
35      read(1,'(a80)',end=22)text(1:80)
        if(text(1:20).eq.'                    '.
     *      and.text(80:80).eq.' ')goto 40
        ncard=ncard+1
        if(k.eq.0)then
         if(text(80:80).eq.'1'.or.text(80:80).eq.' ')then
          if(text(22:22).eq.'L'.or.text(22:22).eq.'R'.or.
     *    text(22:22).eq.'D')then
            read(text(1:80),100)year,mo,dy,hr,
     *      mn,sec,model,type,id,lat,lon,dep,fixd,lage(5:7),nsta,
     *      rms,mag1,mc1(2:2),age1,mag2,mc2(2:2),age2,mag3,
     *      mc3(2:2),age3,uno
            if(mc1(2:2).eq.'C')mag1=0.0        !MC = MD
            if(mc1(2:2).eq.'C')mc1(2:2)=' '    !to avoid repetition
            if(mc2(2:2).eq.'C')mag2=0.0
            if(mc2(2:2).eq.'C')mc2(2:2)=' '
            if(mc3(2:2).eq.'C')mag3=0.0
            if(mc3(2:2).eq.'C')mc3(2:2)=' '
            k=1
          endif
         endif
        endif
        if(text(80:80).eq.'E')
     *    read(text(1:80),'(23X,F7.3,1X,F7.3,F5.1,3E12.4)')
     *    ery,erx,erz,cvxy,cvxz,cvyz
        if(text(2:15).eq.'Ellipse_as_IDC')
     *    read(text(1:80),'(16x,2(f6.1,1x),i3)')smajor,sminor,az
c statistics for MW
        if(text(80:80).eq.'3'.and.text(7:11).ne.'AVERA'.and.
     *  text(72:73).eq.'MW')then
          read(text(75:78),'(f4.1)')mw
          if(mc1(2:2).eq.'W')mag=mag1
          if(mc2(2:2).eq.'W')mag=mag2
          if(mc3(2:2).eq.'W')mag=mag3
          nmw=nmw+1
          smw=smw+(mw-mag)**2
        endif
c get stations with MD
        if(text(80:80).eq.'3'.and.text(2:2).eq.'$')then
          nmsta=nmsta+1
          msta(nmsta)=text(3:13)
          read(msta(nmsta)(9:11),'(f3.1)')x1
          smsta=smsta+x1
        endif
c
c NOTE:
c get standard deviation of IPRG magnitude and number of stations
c used to get it, this in case that s-file was obtained/converted
c from iprg format to nordic (using isrnor), IF NOT  ermag3 and nsm4 
c are obtained later when converting the arrivals.(see ARRIVAL LINES)
c
        if(text(1:5).eq.' O.T.')then
         do i=20,60
          if(text(i:i+3).eq.'ML =')
     *     read(text(i+5:i+19),'(f3.1,4x,f3.1,3x,i2)')mag4,ermag3,nsm4
         enddo
        endif
c sign where arrival lines start (appended on March 18,1997) m.v.
        if(text(1:5).eq.' STAT')npcard=ncard+1
c get number of amplitudes and stand dev of MLs
        if(mc1(2:2).eq.'L')mag=mag1
        if(mc2(2:2).eq.'L')mag=mag2
        if(mc3(2:2).eq.'L')mag=mag3
        if(npcard.gt.0.and.text(34:40).ne.'       '.and.
     *  text(34:40).ne.' AMPLIT')then
          read(text(1:80),'(33x,g8.1,f4.1,25x,f5.0)')amp,per,xdist
          xdist=dist
          hdist=sqrt(real(dist)*real(dist)+dep*dep)
          if(amp.gt.0.0.and.per.lt.5.0)then
            if(text(11:11).ne.'P')then
              namp=namp+1
              smag=smag+(a*alog10(amp)+b*alog10(hdist)+c*hdist+d-mag)**2
            else
              nbamp=nbamp+1
              hdist=real(dist)/111.2  ! hdist is distance in deg
              call mb_att(dep,hdist,q)
              sbmag=sbmag+alog10(amp/per)+q
              amp=0.0
            endif
          endif
        endif
c region
        if(text(1:2).eq.' *')then
          do i=3,80
           if(text(i:i).eq.'*')then
              region(1:)=text(4:i-2)
              call sei upc(region)
              goto 39
           endif
          enddo
        endif
c copy the f-file
39      printout(ncard)(1:80)=text(1:80)
        goto 35
c
c arrange magnitudes
c
40      continue
        if(mc1(2:2).ne.' ')mc1(1:1)='M'
        if(mc2(2:2).ne.' ')mc2(1:1)='M'
        if(mc3(2:2).ne.' ')mc3(1:1)='M'
        if(mag4.gt.0.0)mc4(1:2)='MD'
c
c  get ellipse dimensions
c  
        npha=npha+nsta
c
c writes date in "fecha" variable and fill blanks with zeros
c
        write(fechax(1:22),'(i4,2(a1,i2),1x,2(i2,a1),f5.2)')
     *   year,'/',mo,'/',dy,hr,':',mn,':',sec
        do i=1,22
          if(fechax(i:i).eq.' ')fechax(i:i)='0'
        enddo
        fechax(11:11)=' '
c
c   prepares the event id line in IMS1.0:SHORT format
c
        numero(1:8)=' '
        write(numero(1:8),'(i8)')number
        do i=1,8
          if(numero(i:i).eq.' ')numero(i:i)='0'
        enddo
c EVENT and REGION ID LINE (if)      !!start writing here
        write(2,'(a5,1x,a8,1x,a50)')'EVENT',numero(1:8),region(1:50)
        write(4,'(a5,1x,a8,1x,a50)')'EVENT',numero(1:8),region(1:50)
c HEADER EVENT LINES
        write(2,150)
        write(4,150)
c ORIGIN LINE
        if(nmsta.gt.0)then
        mc4='MD'
        nsm4=nmsta
        mag4=smsta/float(nmsta)
        smsta=0.0
           do k=1,nmsta
             read(msta(nmsta)(9:11),'(f3.1)')x1
             smsta=smsta+(x1-mag4)**2
           enddo
        ermag3=sqrt(smsta/nmsta)
        endif
        if(fixd.eq.'f')fixd='F'
        write(text(1:136),250)fechax(1:22),timerr,rms,lat,lon,smajor,
     *  sminor,az,dep,fixd,erd,npha,nsta,gap,lage(5:7),numero
        radius = cos(lat)**2/equrad**2
        radius = (radius +sin(lat)**2/polrad**2)**(-.5)
        dmin = real(dmin)/(radius*rad)
        dmax = real(dmax)/(radius*rad)
        write(text(97:110),'(2f7.2)')dmin,dmax
        evex='se'
        if(id.eq.' '.and.mag4.gt.2.5)evex='ke'
        if(id.eq.'E')evex='km'
        if(id.eq.'P')evex='sm'
        write(text(111:117),'(a4,1x,a2)')' m i',evex
        write(2,'(a)')text(1:136)
        write(4,'(a)')text(1:136)
c BLANK LINE
        write(2,*)'                              '
        write(4,*)'                              '
c MAGNITUDE HEADER LINE
        write(2,'(a)')'Magnitude  Err Nsta Author      OrigID'
        write(4,'(a)')'Magnitude  Err Nsta Author      OrigID'
c MAGNITUDE LINES (if)
        text(1:38)='                                      '
        if(mc1.ne.' ')then
          write(text(1:38),310)mc1,mag1,numero
          if(mc1(2:2).eq.'B')write(text(1:2),'(a2)')'mb'
          if(mc1(2:2).eq.'S')write(text(1:2),'(a2)')'Ms'
          if(mc1(2:2).eq.'W')write(text(1:2),'(a2)')'Mw'
          if(mc1(2:2).eq.'L')write(text(16:19),'(i4)')namp
          if(mc1(2:2).eq.'B')write(text(16:19),'(i4)')nbamp
          if(mc1(2:2).eq.'L'.and.namp.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(smag/namp)
          if(mc1(2:2).eq.'B'.and.nbamp.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(sbmag/nbamp)
          if(mc1(2:2).eq.'W'.and.nmw.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(smw/nmw)
          if(text(18:19).eq.' 0')text(18:19)='  '
          write(2,'(a38)')text(1:38)
          write(4,'(a38)')text(1:38)
        endif
        if(mc2.ne.' ')then
          write(text(1:38),310)mc2,mag2,numero
          if(mc2(2:2).eq.'B')write(text(1:2),'(a2)')'mb'
          if(mc2(2:2).eq.'S')write(text(1:2),'(a2)')'Ms'
          if(mc2(2:2).eq.'W')write(text(1:2),'(a2)')'Mw'
          if(mc2(2:2).eq.'L')write(text(16:19),'(i4)')namp
          if(mc2(2:2).eq.'B')write(text(16:19),'(i4)')nbamp
          if(mc2(2:2).eq.'L'.and.namp.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(smag/namp)
          if(mc2(2:2).eq.'B'.and.nbamp.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(sbmag/nbamp)
          if(mc2(2:2).eq.'W'.and.nmw.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(smw/nmw)
          if(text(18:19).eq.' 0')text(18:19)='  '
          write(2,'(a38)')text(1:38)
          write(4,'(a38)')text(1:38)
        endif
        if(mc3.ne.' ')then
          write(text(1:38),310)mc3,mag3,numero
          if(mc3(2:2).eq.'B')write(text(1:2),'(a2)')'mb'
          if(mc3(2:2).eq.'S')write(text(1:2),'(a2)')'Ms'
          if(mc3(2:2).eq.'W')write(text(1:2),'(a2)')'Mw'
          if(mc3(2:2).eq.'L')write(text(16:19),'(i4)')namp
          if(mc3(2:2).eq.'B')write(text(16:19),'(i4)')nbamp
          if(mc3(2:2).eq.'L'.and.namp.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(smag/namp)
          if(mc3(2:2).eq.'B'.and.nbamp.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(sbmag/nbamp)
          if(mc3(2:2).eq.'W'.and.nmw.gt.1)
     *    write(text(12:14),'(f3.1)')sqrt(smw/nmw)
          if(text(18:19).eq.' 0')text(18:19)='  '
          write(2,'(a38)')text(1:38)
          write(4,'(a38)')text(1:38)
        endif
        if(mag4.gt.0.0)then
          write(text(1:38),310)mc4,mag4,numero
          write(text(16:19),'(i4)')nsm4
          write(text(12:14),'(f3.1)')ermag3
          if(text(18:19).eq.' 0')text(18:19)='  '
          write(2,'(a38)')text(1:38)
          write(4,'(a38)')text(1:38)
        endif
c BLANK LINE
        write(2,*)'                              '
        write(4,*)'                              '
c HEADER ARRIVAL LINE
        if(ncard-npcard.gt.0)then
        write(2,220)
c ARRIVAL LINES
         do i=npcard,ncard
           amp=0.0
           mag=0.0
           def='___'
           mc(1:2)='  '
           read(printout(i)(2:80),1201)sta,ph,wg,cd,hr,mn,sec,amp,
     *     per,azph,velo,snr,k,tres,xdist,az
           raz=real(k)
           dist=xdist
           if(printout(i)(15:15).ne.'4'.and.printout(i)(11:11).ne.' '.
     *     and.printout(i)(11:11).ne.'T')def(1:1)='T'
           am='m'
           if(printout(i)(16:16).eq.'A')am='a'
           cd='_'
           if(cd.eq.'C')cd='c'
           if(cd.eq.'D')cd='d'
           hdist=sqrt(real(dist)*real(dist)+dep*dep)
           if(amp.gt.0.0.and.per.lt.5.0)then
            mag=a*alog10(amp)+b*alog10(hdist)+c*hdist+d
            mc='ML'
            if(ph(1:1).eq.'P')then
               hdist=real(dist)/(radius*rad) ! hdist is distance in deg
               call mb_att(dep,hdist,q)
               mag=alog10(amp/per)+q
               mc='Mb'
            endif
           endif
           write(fechax(11:22),'(2(i2,a1),f6.3)')hr,':',mn,':',sec
           do k=11,22
             if(fecha(k:k).eq.' ')fecha(k:k)='0'
           enddo
           mc4='  '
           if(nmsta.gt.0)then
             do k=1,nmsta
               if(sta(1:4).eq.msta(k)(1:4))then
                  read(msta(k)(9:11),'(f3.1)')mag4
                  mc4='MD'
               endif
             enddo
           endif
           write(numero(1:8),'(i8)')phnumber
           do k=1,8
             if(numero(k:k).eq.' ')numero(k:k)='0'
           enddo
c easy convertion from km to deg...not so accurate.
           x3 = real(dist)/(radius*rad)
           write(text(1:122),140)sta,x3,real(az),ph,fechax(11:22),tres,
     *     azph,raz,velo,def,snr,amp,per,am,cd,undsc,mc,mag,numero
 140    format(a5,1x,f6.2,f6.1,1x,a4,5x,a12,3f6.1,1x,f6.1,
     *  8x,a3,f6.1,f10.1,f6.2,1x,2a1,a1,1x,a2,4x,f4.1,1x,a8)
           if(text(104:105).eq.'  ')write(text(104:113),'(a2,4x,f4.1)')
     *     mc4,mag4
           if(text(20:20).eq.' ')text(42:46)='     '
           if(text(89:98).eq.' 0.0  0.00')text(89:98)='          '
           if(text(110:113).eq.' 0.0')text(110:113)='    '
           if(azph.eq.0.0)text(47:58)='     '
           if(azph.gt.0.0)text(75:75)='A'
           if(velo.eq.0.0)text(61:65)='     '
           if(velo.gt.0.0)text(76:76)='S'
           if(wg.eq.4)text(75:76)='__'
           if(snr.eq.0.0)text(78:82)='     '
           if(raz.eq.0.0)text(53:58)='      '
           write(2,'(a)')text(1:122)
           phnumber=phnumber+1
         enddo
        endif
c BLANK LINE
        write(2,*)'                              '
        n=n+1
        number=number+1
      goto 10
c   end of BIG LOOP
c
c   HERE STARTS IF CONVERTING FROM IMS1.0:SHORT TO NORDIC
50    open(2,file='norims.nor',status='unknown')
      write(*,*)' Which agency you prefer for nordic first header?'
      write(*,*)' 3 chars....(ex. ISC) or enter for any'
      read(*,'(a)') prefage
      write(6,*) ' Set no location flag (y/n=default)'
      read(5,'(a1)') lock
      if(lock.ne.'y'.and.lock.ne.' ') lock=' '
      if(lock.eq.'y') lock='*'
      n=0  !number of events
      ncards=i
      ncard=0
      kstop=0
c
c   IMS1.0:SHORT ----> NORDIC    BIG LOOP STARTS HERE
c
c     NEW EVENT
c
c the variables printout(1*flines)-->printout(350*flines)
c are reserved for lines above the nordic line type 7 (also included
c and printout(351*flines)-->printout(999*flines) for arrival lines
c
c
      write(printout(1000*flines)(1:80),'(a,a)')
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU ',
c     *'VELO SNR AR TRES W  DIS CAZ7'
     *'VELO AIN AR TRES W  DIS CAZ7'
60    continue
      karr=350*flines   !the arrival's counter
      j=0               !the header's counter
      jarr=1            !defines if input is short or long input file
      dmax=0.0
      dmin=15000.00
      cmg(1)='MB'
      cmg(2)='MS'
      cmg(3)='ML'
      cmg(4)='MD'
      cmg(5)='Ml'
      cmg(6)='MN'
      cmg(7)='MG'
      cmg(8)='MS'
      cmg(9)='MB'
      timf=' '
      locf=' '
      do i=1,9
        mg(i)=0.0       
        ermg(i)=0.0
        nm(i)=0
      enddo
      mc1(1:2)='  '
      mc2(1:2)='  '
      mc3(1:2)='  '
      mag1=0.0
      mag2=0.0
      mag3=0.0
      nmags=0
      nsta=0
65    continue
        read(1,'(a)',end=99)text
        if(text(1:4).eq.'STOP')then
          if(n.eq.0)then
            write(6,*)'No events were found in input file !!!'
68          write(6,*)'Error, Check event # ',n
          endif
          goto 99
        endif
c
c Identifies that there is an event, creates location line 
c of nordic format and ID line
c
        if(text(1:5).eq.'EVENT'.or.text(1:5).eq.'Event')then
           n=n+1
           read(text(7:),*)inumid,cjunk(1:50)
           read(text(7:),'(a50)')region(1:50)
           reg=0
        endif
        if(text(4:18).eq.'Date       Time')then     !LONG IG starts here
c allows more than 1 blank line after header (german ims reports case)
c Aug 19, 1997....m.v.
69       read(1,'(a)',end=99)text     !reads blank lines
         if(text(5:5).eq.'/')then
           backspace(1)
c read first header line
           read(1,255,end=99,err=68)year,mo,dy,hr,mn,sec,timf,timerr,
     *     rms,lat,lon,locf,smajor,sminor,az,dep,fixd,erd,npha,nsta,
     *     gap,x1,x2,text(1:3),evex,lage,numero
           do i=1,3
             if(lage(i:i).eq.' '.or.lage(i:i).eq.'_')lage(i:i)='X'
           enddo
           if(fixd.eq.'f')fixd='F'
c line type 1
           j=j+1
c
c   check if not oo many stations
c
           if(nsta.gt.999) nsta=999
c
           write(printout(j),101)year,mo,dy,hr,mn,sec,' ','R',' ',lat,
     *     lon,dep,fixd,lage(1:3),nsta,rms,'1'
           if(evex.eq.'km')printout(j)(23:23)='E'
           if(evex.eq.'sm')printout(j)(23:23)='P'
           do i=7,18
            if(printout(j)(i:i).eq.' ')printout(j)(i:i)='0'
           enddo
c jh
           if(printout(j)(44:44).ne.' '.and.printout(j)(44:44).ne.'F') 
     *     printout(j)(44:44)=' '
           if(printout(j)(45:45).ne.' '.and.printout(j)(45:45).ne.'F') 
     *     printout(j)(45:45)=' '

           if(timf.eq.'f') timf='F'
           printout(j)(11:11)=timf(1:1)
           printout(j)(16:16)=' '
           if(locf(1:1).eq.'f') locf(1:1)='F'
           printout(j)(45:45)=locf(1:1)
         elseif(text(2:2).eq.'(')then
700        j=j+1   !This case for info between brackets in the middle
           write(printout(j),'(1x,a2,a70,a3,3x,a1)')  !of origin lines
     *     '* ',text(1:70),'***','3'
           do i=2,136
             if(text(i:i).eq.')')goto 69
           enddo
           read(1,'(a)',end=70)text
           goto 700
         elseif(text(1:5).eq.'     ')then 
           if(prefage.ne.'   ')then
             kk=0     !sorts origin lines if a prefered agency exists
             do i=1,j
               if(printout(i)(46:48).eq.prefage)then
                  kk=kk+1
                  nordorg(kk)(1:80)=printout(i)(1:80)
                  printout(i)(1:5)='IMOUT'
               endif
             enddo
             do i=1,j
               if(printout(i)(1:5).ne.'IMOUT')then
                  kk=kk+1
                  nordorg(kk)(1:80)=printout(i)(1:80)
               endif
             enddo
             do i=1,j
                  printout(i)(1:80)=nordorg(i)(1:80)   !done
             enddo
           endif
           goto 70
         endif
         goto 69
c read second header line
70       continue
         read(1,'(a)',end=73)text     !reads blank lines
         if(text(1:5).eq.'Event'.or.text(1:5).eq.'EVENT')then
           backspace(1) !This in case that there are no magnitudes
           goto 73
         endif
         if(text(1:14).ne.'Magnitude  Err')goto 70
c gets magnitude line by line, only done for Ms, mb and ML.....
71       read(1,'(a)',end=99)text
         if(text(1:4).eq.'    ')goto 72
        if(text(1:1).eq.'m'.or.text(1:1).eq.'M')then
         if(text(2:4).eq.'b  ')
     *   read(text(1:23),300,err=68)mg(1),ermg(1),nm(1),mage(1)
         if(text(2:4).eq.'s  ')
     *   read(text(1:23),300,err=68)mg(2),ermg(2),nm(2),mage(2)
         if(text(2:4).eq.'L  ')
     *   read(text(1:23),300,err=68)mg(3),ermg(3),nm(3),mage(3)
         if(text(2:4).eq.'D  ')
     *   read(text(1:23),300,err=68)mg(4),ermg(4),nm(4),mage(4)
         if(text(2:4).eq.'l  ')
     *   read(text(1:23),300,err=68)mg(5),ermg(5),nm(5),mage(5)
         if(text(2:4).eq.'N  ')
     *   read(text(1:23),300,err=68)mg(6),ermg(6),nm(6),mage(6)
         if(text(2:4).eq.'bLg')
     *   read(text(1:23),300,err=68)mg(7),ermg(7),nm(7),mage(7)
         if(text(2:4).eq.'S  ')
     *   read(text(1:23),300,err=68)mg(8),ermg(8),nm(8),mage(8)
         if(text(2:4).eq.'B  ')
     *   read(text(1:23),300,err=68)mg(9),ermg(9),nm(9),mage(9)
         goto 71
        endif
72       continue
c  magnitudes insertion work
         kk=56
         kkk=1
         do k=1,9    ! At the moment only 9 kinds of magnitude are parsed
           if(mg(k).gt.0.0.and.kk.le.72)then
              write(printout(kkk)(kk:kk+7),'(f4.1,a1,a3)')
     *        mg(k),cmg(k)(2:2),mage(k)
              kk=kk+8
           endif
           if(kk.gt.72)then
             kk=56
             kkk=kkk+1
             if(kkk.gt.j)goto 73
           endif
         enddo
c line type I
73       continue
         write(printout(j+1)(1:80),'(a12,a11,1x,a2,a34,i4,5i2,a6)')
     *   ' ACTION:REG ',ttext(10:20),ttext(21:22),
     *   ' OP:nims STATUS:               ID:',year,mo,dy,hr,mn,
     *   int(sec),'     I'
         printout(j+1)(15:15)='-'
         printout(j+1)(18:18)='-'
         printout(j+1)(21:21)=' '
         printout(j+1)(24:24)=':'
         do i=61,74
           if(printout(j+1)(i:i).eq.' ')printout(j+1)(i:i)='0'
         enddo
c This line to keep some extra information from IDC that nordic
c format does not have specific fields...ellipse and qk ID
         write(printout(j+2),'(1x,a13,2(f6.1,1x),i3,a9,f5.1,12x,
     *   a9,i8,5x,a1)')'IDC: ellipse ',smajor,sminor,az,' MB sd+- ',
     *   ermg(1),'Event ID ',inumid,'3'
         j=j+2
c in case region is specified adds one line type 3
         if(region(1:10).ne.'          '.and.reg.eq.0)then
           j=j+1
           reg=1
           write(printout(j),'(1x,a2,a50,a3,23x,a1)')
     *     '* ',region(1:50),'***','3'
         endif
74       read(1,'(a)',end=82)text     !  reads blank lines
         if(text(1:7).eq.'Sta    ')then
           jarr=0
           goto 80   !go for arrivals
         elseif(text(1:1).eq.'(')then
75         j=j+1   !This case for info between brackets after
           write(printout(j),'(1x,a2,a70,a3,3x,a1)')  !origin lines
     *     '* ',text(1:70),'***','3'
           do i=2,136
             if(text(i:i).eq.')')goto 74
           enddo
           read(1,'(a)',end=99)text
           goto 75
         elseif(text(1:5).eq.'Event'.or.text(1:5).eq.'EVENT')then
           backspace(1)      !This case for no arrivals in ims file
           goto 82
         endif
         goto 74
c ARRIVALS
80       read(1,'(a)',end=99)text
         if(text.eq.'          ')then
81         read(1,'(a)',end=99)text
           if(text(1:4).ne.'    '.and.text(1:5).ne.'EVENT'.
     *     and.text(1:4).ne.'STOP'.and.text(1:5).ne.'Event')goto 85
           if(text(1:4).eq.'    ')goto 81
           backspace(1)
           if(text(1:4).eq.'STOP')kstop=1
82         continue
           if(locf(1:1).eq.' ') printout(1)(45:45)=lock
           write(2,'(1x,a79)')(printout(i)(2:80),i=1,j)
           write(2,'(a80)')printout(1000*flines)(1:80)
           if(jarr.eq.0)
     *     write(2,'(1x,a79)')(printout(i)(2:80),i=350*flines+1,karr)
           write(2,'(a80)')'    '
           read(1,'(a)',end=102)text
           backspace(1)
           goto 60
         endif
85       karr=karr+1
         read(text,1140)sta,x1,x2,ph_out,fecha,tres,azph,raz,velo,
     *   def,snr,amp,per,am,cd,undsc,mc,mag,junk
c
c  now read 6 chars of phase
c
 1140   format(a5,1x,f6.2,f6.1,1x,a6,3x,a12,3f6.1,1x,f6.1,      ! jh oct 08
     *  8x,a3,f6.1,f10.1,f6.2,1x,2a1,a1,1x,a2,4x,f4.1,1x,a8)
         if(x1.lt.dmin)dmin=x1
         if(x1.gt.dmax)dmax=x1
         if(mag.gt.0.0)then
          j=j+1
          write(printout(j)(1:80),'(1x,a1,1x,a5,1x,a2,1x,f4.2,63x,a1)')
     *    '$',sta,mc,mag,'3'
         endif
         if(cd.eq.'_')cd=' '
         if(cd.ne.' ')call sei upc(cd)
         read(fecha(1:12),'(2(i2,1x),f6.3)')hr,mn,sec
         write(ttext(1:6),'(f6.1)')raz  !approximate az residual
         read(ttext(6:6),'(i1)')k
         if(k.ge.5.and.raz.lt.0)raz=raz-1.0
         if(k.ge.5.and.raz.gt.0)raz=raz+1.0
         radius = cos(lat)**2/equrad**2
         radius = (radius +sin(lat)**2/polrad**2)**(-.5)
         radius = radius*x1*rad
         wg=0
         if(velo.gt.999.9)velo=999.9
c
c   check for pdif, jh oct 08
c
         if(ph_out.eq.'P DIFF') ph_out='Pdif  '

         if(amp.lt.1000.)then
          write(printout(karr)(2:80),1120)sta,ph_out,cd,hr,mn,sec,
     *    amp,per,azph,velo,snr,int(raz),tres,int(radius),int(x2)
         else
          write(printout(karr)(2:80),1122)sta,ph_out,cd,hr,mn,sec,
     *    amp,per,azph,velo,snr,int(raz),tres,int(radius),int(x2)
         endif
c
c   now put weight   oct 08 jh 
c
         if(def(1:1).eq.'_') wg=4
         if(ph_out(5:5).eq.' ') then
            write(printout(karr)(15:15),'(i1)') wg
            if(wg.eq.0) printout(karr)(15:15)=' '
         else
            write(printout(karr)(9:9),'(i1)') wg  ! phase longer than 4 chars
            if(wg.eq.0) printout(karr)(9:9)=' '
         endif

 1120   format(a5,4x,a6,a1,1x,2i2,1x,f5.2,5x,g7.2,1x,f4.1,f6.1,
     *  f5.1,f4.1,i3,f5.1,2x,i5,1x,i3,1x)
 1122   format(a5,4x,a6,a1,1x,2i2,1x,f5.2,5x,g7.1,1x,f4.1,f6.1,
     *  f5.1,f4.1,i3,f5.1,2x,i5,1x,i3,1x)
         if(text(14:18).eq.'     ')printout(karr)(77:79)='   '
         if(amp.eq.0.0)printout(karr)(34:45)='             '
         if(azph.eq.0.0)printout(karr)(46:51)='      '
         if(velo.eq.0.0)printout(karr)(52:56)='     '
         if(snr.gt.99.9)write(printout(karr)(57:60),'(f4.0)')snr
         if(snr.gt.999.9)printout(karr)(57:60)='999.'
         if(snr.eq.0.0)printout(karr)(57:60)='    '
         if(raz.eq.0.0)printout(karr)(61:63)='   '
         if(raz.lt.-99.9)printout(karr)(61:63)='-99'
         if(tres.lt.-99.9.or.tres.gt.999.9)
     *   write(printout(karr)(64:68),'(f5.0)')tres

cc         if(def(1:1).eq.'_')write(printout(karr)(15:15),'(a1)')'4'

         if(tres.eq.0.0.and.printout(karr)(15:15).eq.'4')
     *   printout(karr)(64:68)='     '

cc         if(printout(karr)(15:15).eq.'0')printout(karr)(15:15)=' '

         if(am.eq.'a')write(printout(karr)(16:16),'(a1)')'A'
c        printout(karr)(7:8)='SZ'
         if(printout(karr)(19:19).eq.' ')printout(karr)(19:19)='0'
         if(printout(karr)(21:21).eq.' ')printout(karr)(21:21)='0'
         if(printout(karr)(24:24).eq.' ')printout(karr)(24:24)='0'
         goto 80
        endif      !LONG IF ends here
      goto 65
c
c   FORMATS   !!!!!
c
 100    format(1x,i4,2(1x,2i2),1x,f4.1,3a1,f7.3,f8.3,f5.1,a1,1x,a3,
     *  i3,f4.1,3(1x,f3.1,a1,a3),a1)
 101    format(1x,i4,2(1x,2i2),1x,f4.1,3a1,f7.3,f8.3,f5.1,a1,1x,a3,
     *  i3,f4.1,24x,a1)
 
 1201   format(a5,4x,a4,i1,1x,a1,1x,2i2,1x,f5.2,5x,g7.2,1x,f4.1,f6.1,
     *  f5.1,f4.1,i3,f5.1,2x,f5.0,1x,i3,1x)
 
 150    format(3x,'Date',7x,'Time',8x,'Err',3x,'RMS',1x,'Latitude',1x,
     *  'Longitude',2x,'Smaj',2x,'Smin',2x,'Az',1x,'Depth',3x,'Err',
     *  1x,'Ndef',1x,'Nsta',1x,'Gap',
     *  2x,'mdist  Mdist Qual   Author      OrigID')
 220    format('Sta',5x,'Dist  EvAz',1x,
     *  'Phase        Time      TRes  Azim AzRes   Slow   SRes',
     *  ' Def   SNR       Amp   Per Qual Magnitude    ArrID')
c write IMS1.0:SHORT format, nsta, no fixing flags for origin time and location.
 250    format(a22,1x,2f6.2,1x,f8.4,1x,f9.4,2f6.1,1x,
     *  i3,1x,f5.1,a1,f5.1,2i5,1x,i3,22x,a3,'_NDC',3x,a8)
 255    format(i4,1x,4(i2,1x),f5.2,a1,2f6.2,1x,f8.4,1x,f9.4,a1,f5.1,
     *  f6.1,1x,i3,1x,f5.1,a1,f5.1,2i5,1x,i3,2f7.2,1x,a3,1x,a2,1x,
     *  a7,3x,a8)
 300    format(6x,f4.1,1x,f3.1,1x,i4,1x,a3)
 310    format(a2,4x,f4.1,10x,'XXX_NDC',3x,a8)
c read the IMS1.0:SHORT format, except agency and number id
c
c Finish the program
close files
c
 99   continue
      if(work.eq.2)then
        write(2,'(a4)')'STOP'
        backspace(4)
        write(4,'(a4)')'STOP'
        close(4)
        close(7)
      else
        if(kstop.eq.0.and.n.gt.0)then
          kstop=1
          goto 82
        endif
      endif
102   close(1)
      close(2)
      write(6,*)
      write(6,*)' The output file contains ',n,' events processed'
      stop
      end

c$DEBUG
C
C PROGRAM TO CONVERT HYPO71 FORMAT OR HYPOINVERSE
C TO NORDIC STANDARD FORMAT.
C  
C BY M. VILLAGRAN, NOVEMBER-91
C
C
c Updates
c dec 14 91 by jh: change to new nordic format, add more to header line
c mar 93         : fix bugs
c jun 2 93       : --------, more still
c jun 3          L: ---
c feb7 94        : used format f6.2 doe reading s, comment out CERO for weight 9
c dec 94         : ************* version 5.0 ****************  no change
c mar 1 99 by jh :---------------version 7.0 check --------------------
c                 ask for century, no 5 char stations
c
c
C character variables definition
C 
      implicit none
	  character*80 text
      CHARACTER*80 HEADERINFO
	  CHARACTER*30 INFILE
      CHARACTER*5 CERO,SECP
      character*6 secs 
      CHARACTER*4 ST,CODA 
      CHARACTER*3 AMP1,AMP
   	  CHARACTER*2 PHP,PHS,SP
      CHARACTER*1 TYPE,UDP,WTP,UDS,WTS,point     
      logical new_event,write_header
      character*2 century
C
C integer variables definition 
C
        INTEGER YR,MTH,DY,JJ,HRMN,error,icoda,new_hour,old_hour
        real xsec,xcoda



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

C
C Formats
C 100 is to read Hypo71pc phases format
C 200 is to write the headline of identification of the quake in NF
c NF means Nordic Format.
C 300 is to write P or S Phases format in NF
C
 200    FORMAT(1X,a2,I2,1X,2I2,1X,I4,1X,f4.1,1x,A1,58X)
	            
C
        error=0
        HEADERINFO(1:40)=' STAT SP IPHASW D HRMN SECON CODA AMPLIT'
c        headerinfo(41:80)=' PERI AZIMU VELO SNR AR TRES W  DIS CAZ7'
        headerinfo(41:80)=' PERI AZIMU VELO AIN AR TRES W  DIS CAZ7'

        WRITE(*,*)'  '
        WRITE(*,*)'  '
C
C open file to convert
C
        WRITE(*,*)' NAME OF HYPO71 FILE ?'
        READ(*,'(A)')INFILE
 666    continue
        write(6,*)' Give century, 19 or 20'
        read(5,'(a2)') century
        if(century.ne.'19'.and.century.ne.'20') goto 666
        OPEN(1,FILE=INFILE,ERR=80,STATUS='OLD')
C
C all quakes will be cataloged like local 
C it has to be updated
C
        TYPE='L'
C
C all phases will be considerated like Z component 
C because H71pc and Hinvpc formats don't have
C notation of that.
C
        SP='SZ'
C
C to be used in P phase if Weigth option in pc format is 9.
C
        CERO='     '
C
C JJ is the quakes counter
C
	JJ=0
C
C OPEN THE NORDIC FORMAT FILE TO CREATE
C WRITE THE HEAD INFORMATION IN OUTPUT FILE
C
        OPEN(2,FILE='hypnor.out',STATUS='unknown')
        open(3,file='hypnor.err',status='unknown')
        WRITE(*,*)'  '
        WRITE(*,*)'  '
C
C START THE PROCESS TO CONVERT FORMAT
C at first the program writes P phase
C that is because the NF uses one line for each phase
C after the program change the variable values
C to write the S phase
C
C
c
c   enter here for new event
c
 20	   continue 
            write_header=.true.
            new_event=.false.
C
C earthquakes counter
C
	    JJ=JJ+1
c
c   here for next line of one event
c
 21     continue
        read(1,'(a)',end=90) text
c
c  check if line is a new event, might by junk with blanks in front
c
        if(text(1:4).eq.'   '.and.(.not.new_event)) goto 21
c
c   set new event flag
c
c
c check that no separator missing, if so make a new event
c
        read(text(16:17),'(i2)')new_hour
        if((new_hour-old_hour).ge.1.and.(.not.write_header)) then
           backspace 1
           old_hour=new_hour
           write_header=.true.
           new_event=.true.
           write(2,*)'   '
           write(3,'(a,a)')' separator: ',text(1:40)
           error=error+1
           goto 21
        endif
        old_hour=new_hour
c
c   check if end of event, if so write blank separation line
c
    	IF(text(1:4).eq.'    ')THEN
           write(2,*)'      '
	   GOTO 20
     	ENDIF
        new_event=.true.
        READ(text,100,ERR=60)ST,PHP,UDP,WTP,YR,MTH,DY,HRMN,
     *  SECP,SECS,
     +  phs,UDS,WTS,AMP,POINT,CODA
 100    FORMAT(A4,A2,2A1,1X,3I2,I4,A5,6X,A6,A2,2A1,3X,A3,A1, 
     +  23X,A4)        
        goto 65
 60     continue
           write(3,'(a)') text
           error=error+1
           goto 21
 65     continue
c
c   check if writing a header
c
	    IF(write_header)then
           read(secp,'(f5.1)') xsec
           WRITE(2,200)century,YR,MTH,DY,HRMN,xsec,TYPE
           WRITE(6,200)century,YR,MTH,DY,HRMN,xsec,TYPE
           WRITE(2,'(a80)')HEADERINFO 
	      write_header=.false. 
        endif
C
C also check the 9 weigth option of the hp71 and hinvs programs
C
 27     continue
c       IF(WTP.EQ.'9') HRMN=CERO
C
C if the programs H71pc and Hinvpc reads coda values of "0"
C accept that like not a coda value, for that case
C in NF coda has to be blank
C
		IF(CODA.EQ.'   0') CODA='    '
C
C For an H71pc format the program will change the way of notacion
C of the arrival, up will be C and Down D
C
        IF(UDP.EQ.' ')  GOTO 30
        IF(UDP.EQ.'U')THEN
	 	  UDP='C' 
		ELSE
	      UDP='D'
		ENDIF
30      IF(UDS.EQ.' ')THEN 
	  	   GOTO 40
		ENDIF
        IF(UDS.EQ.'U')THEN
          UDS='C'
        ELSE
          UDS='D'
        ENDIF
40      AMP1='   '
C
C    Writes P in the NF file and make variable values to
C    can write S phase
C
c
c   convert coda to integer and write back if not zero
c
        read(coda,'(f4.1)') xcoda
        icoda=xcoda
        if(icoda.ne.0) write(coda,'(i4)') icoda
c
c   check if P-phase has been supplied 
c
        if(secp.ne.'     ') then
           if(php.eq.'  ') php='EP'
           WRITE(2,300)ST,SP,PHP,WTP,UDP,HRMN,SECP,CODA,AMP1
 300       FORMAT(1X,A4,1X,A2,1X,A2,3X,A1,1X,A1,1x,i4,1X,
     *     A5,1X,a4,1X,A3)
        endif
c
c   check if S-phase is there
c
        if(secs.ne.'      ') then
c
c   if no S phase is written, substitute
c
          if(phs.eq.'  ') phs='ES'
c
c   get s time, write in f5.1 to assure that values larger than
c   will be readable in nordic format
c
          read(secs,'(f6.2)') xsec
          write(secs,'(f6.1)') xsec
          WRITE(2,301)ST,SP,PHS,WTS,UDS,HRMN,SECS(2:6)
 301      FORMAT(1X,A4,1X,A2,1X,A2,3X,A1,1X,A1,1x,I4,1X,A5)
        endif
		goto 21
C
C ERRORS DISPLAY
C
80      WRITE(*,*)'  '
        WRITE(*,*)'  '
        WRITE(*,*)'  '
        WRITE(*,*)'             THAT INPUTFILE DO NOT EXISTS !'
        WRITE(*,*)'  '
        WRITE(*,*)'  '
        WRITE(*,*)'  '
        GOTO 99
C
C FINISH
C
90      IF(error.ne.0) THEN
           write(6,*) error, 'errors were found, see hypnor.err'
        endif
		WRITE(*,'(10X,I5,1X,A22)')JJ,'QUAKES WERE CHANGED !!'
        write(6,*)' Output file name is hypnor.out'
98      CLOSE(1)
99      STOP
        END

c                                                                               
c   initial version april 21 1989                                               
c   latest updates:                                                             
c   jan 31 96     : operation over several months
c   feb 6         : -----------------------------, also in initial call
c   feb 14        : bug with del, put quit with type in again
c   jun 6, 96     : editor as a variable
c   aug 12        : possible to ignore no id line
C   nov-dec 96    : split program up in subroutine eev_act and main program
c                   eev in preparation for w95 version. Display more info
c                   at prompt line
c   feb 13  97    : small changes in output, UPD to UP, bug in FC
c   feb 26        : make output file indexeev.out, type file name
c   mar 25        : change format of inputone
c   sep 5  LAA    : length of string in edit
c   sep 7  jh     : add from_eev to eev_action routine
c   sep 18        : add options new and dub
c   oct           : option PP
c   nov 12        : option reg or put
c   nov 19        : option ppo (plot many,def),po(plot def) ,ss(search new)
c   dec  17       : bug with option 'NEW'
c   dec  30       : no chrash if empty file
c   feb           : option 'w'
c   feb 22        : fix probelme with PP, remove null char
c   feb 23        : moment tensor
c   feb 25        : redo PP option
c   following changes implement after first version 7.0 check, might not work
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   mar 1         : several faultplane solutions
c   april 1       : add processing status in output
c   april 7       : more clean up when register, check wav file status
c   may 20        : do not find NAO with SS, delte old id lines using reg
c   jun 5 98      : in option REG, also enter event id
c   jun 11        : remove routine increment_id and fix bug, also include
c                   status UPD as events considered registered
c   july  10 lo   : bug when starting editor after mulplt on Solaris
c   july  20 lo   : start epimap from eev
cccccccccccccccccccccccccccccccccccccccccccccc
c   sep 98 jh     : -----------version 7.0 check----------------------
c                   year 2000, 5 char base name, long file names
c   sep 17        : local base from ,,,,, to ,,
c   oct 16        : bug
c   oct 28        : bug with REG and option LP, inc_id
c   nov 4 bmt     : linux ok, add comma in FORMAT sentences        
c   nov 5 jh      : linux logiac, replace system_c with systemc
c   jan 5 99 jh   : bug with event type in option REG
c   jan 8         : bug with NEXT option
c   feb 15   lo   : change call for pitsa 
c   feb 23   lo   : interface to sac
c   mar 2    jh   : define event as new if autoreg ARG
c                   indicate by who and when file deleted
c   mar 30   lo   : start pitsa with command pitsa not i
c   april 13 jh   : do not use capital i in above
c   april 14 bmt  : add PMAC command (PROMAC)
c   june 16  jh   : do not append to same event
c   aug 13        : fix synt
c   aug 24  lo    : fix Eyyyymm option
c                   in option 'MAP' take location from S-file, if there
c   sep 5    jh   : change message if s-file deleted from mulplt
c                   bug in time association with chosen window due to option ss
c   sep 9         : put in CR whne from_mulplt true
c   sep 15        : fix problem with infinite loop if all events in index
c                   file non existent
c   sep 21        : eev over severalmonths was never implemented !!!
c                   add shwow_menu
c   sep 22        : bugs with updating of fault plane solution
c                   change mom to invrad
c   sep 29        : make shure event not updated if marked for no location
c   sep 30        : put in check for same id an ds-file name under edit
c   oct 1   lo    : change dub to dup
c   oct           : put subroutines to LIB
c   nov 2         : recompile to include new base structure
c   nov 28        : recompile to include fix of MAP option on PC, new
c                   options u and comment
c   oct 20  99 jh : number of stations is always shown, also if no update
c   jun 8  2001   : fix display of negative magnitude
c   may 8  2003   : check that not quarry before quit
c   may 24 2006   : put in save for operator
c   oct 23 2008   : make sure base name does not have garbage, created
c                   a problem on linux when using eev index.out

      implicit none                                                 
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'                ! dimentions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C

c-- base
      character*5 ba
c-- time interval chosen          
      CHARACTER*14      START_TIME,END_TIME     
c-- data base name                
      CHARACTER*40      BASE_NAME               
c-- input fron transfer file      
c      character*40      base_or_time            
c-- one line                                            
      character*80	text			
      integer from_eev     ! indicate to routine findevin that call is from eev
c-- unix command
      character*80 command
c-- event file name               
      character*80      evfile          
c-- ev. selection key             
      character*10      keys                    
c-- event number                  
      integer           event_no,oldno          
c-- status of event search        
      integer           status                  
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c-- new month indicator           
      integer           new_month               
c-- see base                      
      integer           fstart                  
c-- no of phases for one event
c      integer		mstatus			
c-- counter                                                    
      integer		i
c   arguments to eev
      character*80 arg(5)
c   number of arguments
      integer nargs
c-- operator code
      character*4 operator
c-- dirctory separation character
      character*1 dchar
      real sec      ! seconds
      character*80 from_mulplt   ! message from mulplt
      character *3 ids           ! id status
      character *1 proc_status   ! processing status
	  integer isec
c read unit #1 .. #6
       integer          read01
c-- event array                  
      character*80      data(max_data)   
c-- no of stations for event                        
      integer           nstat    
c-- no of phases for one event
      integer nphase
c-- no of records for event                  
      integer           nrecord 
c-- no of headers for event                         
      integer           nhead    
c-- event ids--------------               
      character*1       exp,evid
      integer           id           ! line number of id line
      save operator

c indicator of the use of an index file
       logical index_file
       character*3 month(12)
       data month /'Jan','Feb','Mar','Apr','May',
     * 'Jun','Jul','Aug','Sep','Oct','Nov','Dec'/ 

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   event number must be zero before anything has been defined
c
      event_no=0
      from_mulplt=' '
      oldno=0
      index_file=.false.
      operator='    '      ! no operator given initially
      from_eev=1
c
c   no debugging on file io
c
      b_f_debug$=.false.
      call dir_char(dchar)
      call get_def_base( ba )                 !JAB(BGS)Feb95. Get database.
      write(*,*)                              !JAB(BGS)Feb95.
c
c   get arguments
c
      call get_arguments(nargs,arg)
c
c  case of local directory
c
c      write(6,'(1x,a)') arg(1)
c      write(6,'(1x,a)') arg(2)
      if (nargs.eq.0) then
        write(6,*)' Local directory'
        base_name=',,   '     ! signal a local directory
c                                                                               
c-- start is very early
c              
        start_time='            '
      endif
c
c   data base or index file
c
      if (nargs.eq.1) then
        read(arg(1)(1:4),'(i4)',err=6353) i   ! if a number, must be data base
c
c  assume default data base
c
          base_name(1:5)=ba                    !JAB(BGS)Feb95..default dbase.
          start_time=arg(1)
          goto 6354
c
c  assume index file since one argument and not a number
c
 6353   continue
          i=index(arg(1),' ') -1
          base_name=' '
          base_name(1:i)=arg(1)(1:i)
          start_time='              '
          index_file=.true.
      endif
 6354 continue
c
c   end time is always to end of month if end time not given or index file
c
      end_time='            '
c
c   must be a base different from standard or interval
c
      if (nargs.eq.2) then
        start_time=arg(1)
c
c   check if arg2 is a number
c
        read(arg(2)(1:4),'(i4)',err=2736) i
        end_time=arg(2)                     ! assume it was a number        
        base_name(1:5)=ba                   !..default dbase.
        from_eev=2
        goto 2737
 2736   continue
        base_name=arg(2)                    ! assume 2 argument a data base
 2737   continue
      endif
c
c   must be a base different from standard with an interval
c
      if (nargs.eq.3) then
        start_time=arg(1)
        end_time=arg(2)
        base_name=arg(3)                    ! assume 3 argument a data base
        from_eev=2
      endif
c
c   delete eev.out and indexeev.out if there
c
            call sei open(unknown$      ,        ! Open a unknown status file.
     &                    ' ',                   ! Prompt file name (n/a).
     &                    'eev.out',             ! File name
     &                    read01,                ! Read unit #1
     &                    b_old,                 ! Already exists? (n/a).
     &                    code)                  ! Returned condition.
            call sei close (delete$,read01,code)
c            call sei open(unknown$      ,        ! Open a unknown status file.
c     &                    ' ',                   ! Prompt file name (n/a).
c     &                    'indexeev.out',        ! File name
c     &                    read01,                ! Read unit #1
c     &                    b_old,                 ! Already exists? (n/a).
c     &                    code)                  ! Returned condition.
c            call sei close (delete$,read01,code)
c
c   get seisan defaults
c
      call get_seisan_def
c                                                                               

C                                                                               
C  initial position                                                   
C                                                                               
      call findevin
     *(base_name,start_time,end_time,keys,from_eev,event_no,                             
     *evfile,fstart,new_month,status)
      call put_env_event(evfile)
c                                                                               
C   CHECK IF END OF TIME INTERVAL OR OTHER ERRORS                               
C                                                                               
      IF(STATUS.GT.0) THEN                                                      
         if(status.eq.1) write(6,*)' ***** event not found'                     
         if(status.eq.5) then
            write(6,*)' ***** wrong time interval'                 
            stop
         endif
c
c   if an empty index file, stop
c
         if(event_no.eq.0.and.status.eq.3) stop
         if(status.eq.9) stop   ! something wrong
      ENDIF                                                                     
c
c
c-------------------------------------------------------                  
c   start of interactive loop                                                   
c-------------------------------------------------------
c
 10   continue
c
c   open file to get main info
c
      open(1,file=evfile,status='old',err=1818)
      call indata
     *(1,nstat,nphase,nhead,nrecord,evid,exp,data,id)
      if(nrecord.eq.0) goto 1919          ! end of file
      text=data(1)
      goto 1819                           ! process data
c
c   errror
c
 
 1818 continue
      write(6,'(a,i5)')'   ****   Event No ',event_no
      write(6,*)' Event not present in S-file data base, file name is: '
      write(6,'(1x,a)') evfile
      write(6,*) 'Return to continue, q to quit'
      read(5,'(a)') text
      if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') stop
 1820 continue
      keys(1:10)='          '   ! go to next event
      close(1)
      goto 1000
c
 1919 continue
      write(6,'(a,i5)')'   ****   Event No ',event_no
      write(6,'(1x,a)') evfile
      write(6,*)' EMPTY event file'
      text=' '
c
 1819 continue
c
c   find id status
c
      ids=' '
      if(id.ne.0) ids=data(id)(9:11)
c
c   set flag for processing status
c
      proc_status=' '
      if(ids.eq.'NEW'.or.ids.eq.'SPL'.or.ids.eq.'HYP') proc_status='N'
      if(ids.eq.'   ') proc_status='?'   ! unknown status
c
      close(1)
c
C   display info and ask what to do next                                                          
C                                                                               
      read(text(17:20),'(f4.1)',err=1100) sec   ! second
      goto 1101
 1100 continue
      write(6,*)' Something wrong with second in header, set to 00'
      sec=0.0
c
 1101 continue
      isec=sec
      read(text(7:8),'(i2)',err=1300) i   ! month
      if(i.gt.12.or.i.lt.1) then
         write(6,*)' Month wrong in file, fix it !!!'
         write(6,*)' For this event set to month in start time'
         read(start_time(5:6),'(i2)') i
      endif
      goto 1301
 1300 continue
      write(6,*)' Something wrong with month in header, set to 01'
      i=1
 1301 continue

c
c   check for magnitudes, if first not there, see if others
c
      if(text(56:63).eq.'        ') then
         if(text(64:71).ne.'        ') then
            text(56:63)=text(64:71)
         elseif(text(72:79).ne.'        ') then
            text(56:63)=text(72:79)
         endif
      endif
c
c   check what should be in magnitude field
c
      if(text(57:63).eq.'       ') then
         if(text(65:71).ne.'       ') then
           text(57:63)=text(65:71)     ! try 2. magnitude
         else
           text(57:63)=text(73:79)     ! try 3. magnitude
         endif
      endif
c
c   if nothing in magnitude field, put in location agency
c
      if(text(57:63).eq.'       ') then
        text(61:63)=text(46:48)
      endif
c
c   number of statiosn is taken from actual stations in file
c   not info on header line
      text(49:51)=' '
      if(nstat.gt.0) write(text(49:51),'(i3)') nstat

      write(6,289) event_no,
     *text(9:10),             ! day
     *month(i),               ! month
     *text(2:5),              ! year
     *text(12:13),            ! hour
     *text(14:15),            ! min
     *isec,                   ! sec
     *text(21:23),            ! indicators
     *text(24:30),text(31:38),text(39:45), ! hypocenter
     *proc_status,
     *text(52:55),            ! rms
     *text(56:63),                         ! first magnitude
     *text(49:51)                          ! number of stations

 289  format('#',i5,1x,a2,1x,a3,1x,a4,1x,a2,':',a2,1x,i2,1x,
     *a3,a7,a8,a7,a1,a4,1x,a8,1x,a3,'  ? ',$)

c

c
c   get next action unless given from mulplt
c
c      if(from_mulplt(1:4).ne.'    '.and.
c     &    (event_no.ne.1.or.oldno.ne.0)) then      ! added lot 07-05-2002
      if(from_mulplt(1:4).ne.'    ') then
         keys(1:10)=from_mulplt(1:10)
         write(6,*)                        ! nothing was read so no CR, putit in
      else
         READ(5,'(A10,a)') KEYS,command                          
      endif

c
c   get here from above if file not there
c   
 1000 continue
c       
c  check if quit                                                                
c       
      if((keys(1:1).eq.'Q'.or.keys(1:1).eq.'q'.or.keys(1:4).
     *eq.'quit'.or.keys(1:4).eq.'QUIT').and.
     *(keys(1:6).ne.'quarry'.and.keys(1:6).ne.'QUARRY')) 
     *stop                                             
c
c  find what action to do
c
      call eev_action(base_name,start_time,end_time,keys,
     *command,event_no,evfile,fstart,
     *index_file,from_eev,from_mulplt,operator)
      oldno=event_no
c
c   back to ask for next action
c
      goto 10
c
c    end
c
      stop
      end



 

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c seed.inc.f
c Summary of seed file.
c
c Author: Rodrigo Canabrava
c E-mail: rlpcfr@yahoo.com.br
c Universitetet i Bergen - Department of Earth Sciences
c
c   changes
c
c  nov 9, 2005 jh : add variabel seed_blk_read
c  oct 6  2006 jh : add seed_network
c  oct 21 2007 jh : add chn_network
c  nov 9  2007 jh : add seed_chan_time
c  sep 25 2007 jh : increase max_n_block from 2000 to 9000
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      INTEGER*4 MAX_N_CHN       ! Maximum number of channels
      INTEGER*4 MAX_N_BLK       ! Maximum number of blocks read at a time
      PARAMETER (MAX_N_CHN = 1000)
      PARAMETER (MAX_N_BLK = 9000)

      INTEGER*4 STDIN           ! Standard input number
      INTEGER*4 STDOUT          ! Standard output number

      PARAMETER (STDIN = 95)
      PARAMETER (STDOUT = 6)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c File Summary
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*4   nb_channels   ! number of channels in file
      character*3 chn_name(MAX_N_CHN) ! names of channels
      character*5 stn_name(MAX_N_CHN) ! names of stations of each channel
      character*2 chn_location(MAX_N_CHN) ! location id
      character*2 chn_network(MAX_N_CHN) ! network
      integer*4   chn_begin(MAX_N_CHN) ! first block of each channel
      integer*4   chn_end(MAX_N_CHN) ! last block of each channel
      integer*4   chn_samples(MAX_N_CHN) ! number of samples of each channel
      real*4      chn_sample_rate(MAX_N_CHN) ! sample rate of each channel
      integer*2   chn_year(MAX_N_CHN) ! start year of each channel
      integer*2   chn_day(MAX_N_CHN) ! start day
      integer*2   chn_hour(MAX_N_CHN) ! start hour
      integer*2   chn_minute(MAX_N_CHN) ! start minute
      integer*2   chn_second(MAX_N_CHN) ! start second
      integer*2   chn_fracsec(MAX_N_CHN) ! start fraction of seconds
      logical*1   chn_questionable_time_tag(MAX_N_CHN) !flag if time tag is bad

      common / file_summary / stn_name, chn_name, chn_begin, chn_end, 
     & chn_samples, chn_year, chn_day, chn_hour, chn_minute, 
     & chn_second, chn_fracsec, chn_sample_rate,
     & chn_questionable_time_tag, chn_location,
     & nb_channels, chn_network


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Section summary.
c This common block is updated by seed_read_chn, so the user can
c have the information of start time of the section read by the mentioned 
c function.
c Each is an array, which holds the specified information for all the
c channels.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      integer*4   seed_year(MAX_N_CHN) ! year
      integer*4   seed_month(MAX_N_CHN) ! month
      integer*4   seed_day(MAX_N_CHN) ! day
      integer*4   seed_hour(MAX_N_CHN) ! hour
      integer*4   seed_minute(MAX_N_CHN) ! minute
      real*4      seed_second(MAX_N_CHN) ! second
      real*4      seed_rate(MAX_N_CHN) ! sample rate
      logical*4   seed_bad_time_tag(MAX_N_CHN) ! flag saying if time tag is bad
      integer*4   seed_nsamp(MAX_N_CHN) ! number of samples
      integer*4   seed_begin(MAX_N_CHN) ! beginning block
      integer*4   seed_end(MAX_N_CHN) ! end block
      character*3 seed_comp(MAX_N_CHN) ! component (channel)
      character*5 seed_station(MAX_N_CHN) ! station name
      character*2 seed_location(MAX_N_CHN) ! location id
      character*2 seed_network(MAX_N_CHN)  ! network code

      real*8      seed_blk_time(MAX_N_BLK) ! start time of the block
      real*8      seed_chan_time(max_n_blk) ! abs time current block+1
      integer*4   seed_blk_index(MAX_N_BLK) ! number of the sample
      integer*4   seed_blk_read             ! number of blocks read

      common / section_summary / seed_blk_time, seed_blk_index, 
     & seed_year,
     & seed_month, seed_day, seed_hour, seed_minute, seed_second,
     & seed_rate, seed_nsamp, seed_begin, seed_end, seed_bad_time_tag,
     & seed_station, seed_comp, seed_location, seed_blk_read,
     & seed_network,seed_chan_time


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Error message
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      character*80 error_msg  ! error message

      common / error_handle / error_msg

c$debug
C                                                                               
C                       
C  Program to make wadati diagram and apparent velocity 
c  from a Nordic file with one or many events                                  
C
c  The apparent velocity is calculated from the arrtival times and
c  calculated distances as given in the s-file
c                                                                               

c The purpose of the program is to calculate Vp/Vs values for individual
c events and calculate the average for a group of events. In additon, the
c program can calculate the apparent velocity for each event based on 
c P or S-times. 

c The information can be used to obtain a first impresison of crustal 
c parameters.

c The apparent velocity is calculated based on reported
c arrival times and calculated distances. For each calculation, events 
c can be selected based on: Minimum number of stations, maximum rms of 
c the fit (S-P vs P, or arrival times), minimum correlation 
c coefficient of the fit. For thr eapparent velocity calculation, data 
c can also be selected in distance and azimuth ranges.


c The output gives:

c T0  : Wadati calculated origin time
c N   : Number of stations used for Vp/Vs
c VPS : Vp/Vs ratio
c NP  : Number of stations for P- velocity
c NS  : Number of stations for S-velocity
c AVSP: Aversge S-P times with sd
c AVDI: Averge distance with sd 

c The average Vp/VS is calculated for the whole data set. Individual Vp/Vs
c values outside the range 1.53 to 1.93 are excluded.
c
c
C  J. Havskov  98
c
c
c  updates
c  may 99 by jh -------------------  verison 7.0 check --------------------
c               5 char station codes
c  mar 5, 01, jh : distnace to real
c  apr 19 03  jh : as pointed out bt fernando carrilho, weiting was not used properly
c                  for s in wadati mode
c                                                                               
c
      implicit none
      include 'seidim.inc'        ! dimensions
      CHARACTER*80 DATA(max_data)                                                    
      CHARACTER*1 TYPE,EXP                                                      
      integer nstat,nphase,nhead,nrecord
      integer min_wad    ! minimum number of stations, wadati
      real min_corr      ! -------- correlation coefficient, wadati
      real max_rms       ! maximum rms, wadati
      integer choise     ! wadati or app vel
      real min_vps, max_vps ! acceptable vp vs range
      real min_dist,max_dist,min_az,max_az ! acceptable distance and azimuth 
      character*80 file
      integer hour,min
      integer nwad   ! number of points in wadati diagram
      real sec
      real vps    ! vp/vs ratio
      integer n_min_vel  ! minimum number of stations for ap vel.
      real av_vps(50000)  ! store vps values
      integer nvps       ! number stored
      real corr,rms  ! correlation coefficient and rms, wadati
      real sd        ! standard deviation
      real max_rms_p_vel ! maximum rms for app vel of p
      real corr_p_vel,rms_p_vel,app_p_vel   ! corr and rms for apparent velcity, p vs dist
      real corr_s_vel,rms_s_vel,app_s_vel   ! corr and rms for apparent velcity, p vs dist
      real av_dist_p,sd_dist_p,av_dist_s,sd_dist_s ! average distances
      real avsp,sdsp
      integer np,ns    ! number of p'sand s's used for apparent velocity
      integer n,id
c--compact or not
      logical compact

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c
      write(6,*) 'Input file name'
      read(5,'(a)') file
c
      open(1,file=file,status='old')
c
      open(2,file='wadati.out',status='unknown')
c
c   get selection parameters
c
        write(6,*) ' Wadati (1), apparent velocity (2) or both (3) ?'
        read(5,*) choise
        if(choise.eq.1.or.choise.eq.3) then
           write(6,*)' Wadati parameters:'
           write(6,*) ' Minimum number of stations'
           read(5,*) min_wad
           write(6,*) ' Maximum rms'
           read(5,*) max_rms
           write(6,*) ' Minimum correlation coefficient'
           read(5,*) min_corr 
        endif
c
        if(choise.eq.2.or.choise.eq.3) then
           write(6,*)' Apparent velocity parameters:'
           write(6,*)' Distance range'
           read(5,*) min_dist,max_dist
           write(6,*)' Azimuth range'
           read(5,*) min_az,max_az
           write(6,*) ' Minimum number of stations'
           read(5,*) n_min_vel
           write(6,*) ' Maximum rms'
           read(5,*) max_rms_p_vel
        endif
c
c   set some defaults
c
        min_vps=1.53
        max_vps=1.93
c
c   check that not a compact file
c
        call nortype(1,compact)
        if(compact) then
           write(6,*)' Input file compact, cannot use'
           stop
        endif
c
c   read and write to end of file
c
        nvps=0
        n=0
  10    continue
        CALL INDATA(1,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
        if(nrecord.eq.0) goto 99
c
c
        if(choise.eq.1.or.choise.eq.3) then
c
c   calculate wadati diagram
c
        call wadati
     *  (data,nhead,nrecord,3,nwad,vps,hour,min,sec,rms,corr)
c
c   write result for wadati
c
        if(nwad.ge.2) then
           n=n+1
           write(2,'(1x,a,a,2i2,f6.1,a,i4,a,f5.2,a,f6.2,a,f6.3)')
     *     data(1)(1:20),' T0: ',hour,min,sec,' N: ',nwad,' VPS: ',
     *     vps,' RMS: ',rms,' CORR: ',corr
           write(6,'(1x,a,a,2i2,f6.1,a,i4,a,f5.2,a,f6.2,a,f6.3)')
     *     data(1)(1:20),' T0: ',hour,min,sec,' N: ',nwad,' VPS: ',
     *     vps,' RMS: ',rms,' CORR: ',corr
        else
           write(6,'(1x,a,a)') data(1)(1:20),' No data for Wadati'
        endif
c
c   store good data for wadati average
c
        if(vps.gt.min_vps.and.vps.le.max_vps.and.corr.ge.min_corr.and.
     *  rms.le.max_rms.and.nwad.ge.min_wad) then
          nvps=nvps+1
          av_vps(nvps)=vps
        endif
        endif
c

      if(choise.gt.1) then
c
c   do apparent velocity
c
      call app_velocity
     *(data,nhead,nrecord,4,min_dist,max_dist,min_az,max_az,avsp,sdsp,
     *np,app_p_vel,rms_p_vel,corr_p_vel,av_dist_p,sd_dist_p,
     *ns,app_s_vel,rms_s_vel,corr_s_vel,av_dist_s,sd_dist_s)

c
           
      if(np.ge.n_min_vel.and.rms_p_vel.le.max_rms_p_vel) then
           write(2,'(1x,a,f6.1,f4.1,2x,a,2f6.1,1x,a,i4,a,
     *     f5.2,a,f6.2,a,f6.3)')
     *     'AVSP:',avsp,sdsp,
     *     'AVDI:',av_dist_p,sd_dist_p,
     *     'NP: ',np,' VP : ',app_p_vel,' RMS: '
     *     ,rms_p_vel,' CORR: ',corr_p_vel

           write(6,'(1x,a,f6.1,f4.1,2x,a,2f6.1,1x,a,i4,a,
     *     f5.2,a,f6.2,a,f6.3)')
     *     'AVSP:',avsp,sdsp,
     *     'AVDI',av_dist_p,sd_dist_p,
     *     'NP: ',np,' VP : ',app_p_vel,' RMS: '
     *     ,rms_p_vel,' CORR: ',corr_p_vel
      endif
c
c   put ns high so not to use apperent S-velocity
c
      if(ns.gt.n_min_vel) then
           write(2,'(18x,a,2f6.1,1x,a,i4,a,
     *     f5.2,a,f6.2,a,f6.3)')
     *     'AVDI:',av_dist_s,sd_dist_s,
     *     'NS: ',ns,' VS : ',app_s_vel,' RMS: '
     *     ,rms_s_vel,' CORR: ',corr_s_vel

           write(6,'(18x,a,2f6.1,1x,a,i4,a,
     *     f5.2,a,f6.2,a,f6.3)')
     *     'AVDI:',av_dist_s,sd_dist_s,
     *     'NS: ',ns,' VS : ',app_s_vel,' RMS: '
     *     ,rms_s_vel,' CORR: ',corr_s_vel

      endif
      endif
        goto 10
c
 99     continue
        write(6,*)

        if(choise.eq.1.or.choise.eq.3) then
           write(6,*)
     *     ' Number of events for which vp/vs were calcualted ',n
           write(6,*)
     *     ' Number of events selected for average            ', nvps
           write(6,*)
           write(2,*)
     *     ' Number of events for which vp/vs were calculated ',n
           write(2,*)
     *     ' Number of events selected for average            ', nvps
           write(2,*)
c
c   calculate average vps
c
           if(nvps.ge.2) then
              write(6,*)
              call sdv(nvps,av_vps,vps,sd)
              write(6,'(1x,a,f6.2,a,f6.2,a,i5)')' Average VP/VS =', vps, 
     *        '  SD=',sd,' N=',nvps
              write(2,*)
              call sdv(nvps,av_vps,vps,sd)
              write(2,'(1x,a,f6.2,a,f6.2,a,i5)')' Average VP/VS =', vps, 
     *        '  SD=',sd,' N=',nvps
           endif
        endif
        stop
        end
                       
      subroutine wadati
     *(data,nhead,nrecord,min_weight,nwad,vps,hour,min,sec,rms,corr)
c
c   routine makes wadati analysis of one event
c   jh, february 1998
c
c   input
c
c   data,nhead,nrecord: data, number of headers, number of records 
c   min_weight        : smallest weight to use (0,1,2,3)
c   
c   output
c
c   nwad              : number of points used
c   vps               : vp to vs ratio
c   hour,min,sec      : origin time
c   rms               : rms of fit
c   corr              : correlation coefficient of fit
c
c
      implicit none
      character*80 data(*)
      integer nhead,nrecord,min_weight,nwad
      real vps,t_origin,rms,corr
      real tp(500)   ! p-times
      real tsp(500)  ! s-p times
      real sec
      integer timep  ! hours and minutes in secs
      integer hour,min
      character*5 stat   ! one station code
      character*2 phase  ! phase
      integer i,k,iw
      
c
c
c
      nwad=0
c
c   find pairs of readings, assume same phase, weight can be in column 9 if
c   phase is long
c
      do i=nhead+1,nrecord
        read(data(i)(15:15),'(i1)',err=50) iw     ! read assigned weight
        goto 51
 50     continue
        read(data(i)(9:9),'(i1)') iw              ! read assigned weight
 51     continue
c
c   find p and s-p for wadati
c
          
        if(data(i)(11:11).eq.'P'.and.iw.le.min_weight) then  ! if valid P
           stat=data(i)(2:6)
           phase=data(i)(11:12)  ! p-phase
           phase(1:1)='S'        ! corresponding s-phase
           do k=nhead+1,nrecord
             read(data(k)(15:15),'(i1)',err=60) iw     ! read assigned weight, i to k, apr 03
             goto 61
  60         continue
             read(data(k)(9:9),'(i1)') iw              ! read assigned weight, i to k, apr 03
  61         continue
             if(data(k)(11:12).eq.phase.and.data(k)(2:6).eq.stat.
     *       and.iw.le.min_weight) then  ! same S
                nwad=nwad+1
                read(data(i)(19:28),'(2i2,f6.1)') hour,min,sec
                tp(nwad)=hour*3600.0+min*60.0+sec
                read(data(k)(19:28),'(2i2,f6.1)') hour,min,sec
                tsp(nwad)=hour*3600.0+min*60.0+sec-tp(nwad)
             endif
           enddo
        endif
      enddo
      timep=hour*3600+min*60  
      do i=1,nwad
        tp(i)=tp(i)-timep    ! make values smaller so better fit in lsq
      enddo

c
c  all readings done, now do wadati analysis
c
      if(nwad.ge.2) then
         call lsqlin(nwad,tp,tsp,t_origin,vps,corr,rms)
         t_origin=-t_origin/vps+timep
         vps=vps+1
         hour=t_origin/3600
         min=(t_origin-hour*3600)/60
         sec=t_origin-hour*3600-min*60
      endif

      return
      end


      subroutine app_velocity
     *(data,nhead,nrecord,min_weight,
     *min_dist,max_dist,min_az,max_az,
     *avsp,sdsp,
     *np,app_p_vel,rms_p_vel,corr_p_vel,av_dist_p,sd_dist_p,
     *ns,app_s_vel,rms_s_vel,corr_s_vel,av_dist_s,sd_dist_s)
     
c
c   routine makes apparent velocity analysis of one event
c   jh, march 1998
c
c   input
c
c   data,nhead,nrecord: data, number of headers, number of records 
c   min_weight        : smallest weight to use (0,1,2,3)
c   min_dist,max_ist,min_az,max_az : distance and azimuth range to use
c   
c   output
c
c   avsp,sdsp         : averasge and sd of s-p times
c   av_dist_p         : average distance for P
c   av_dist_s         : average distance for S
c   np                : number of points used for p
c   app_p_vel         : apparent p-velocity
c   rms_p_vel         : rms of fit
c   corr_p_vel        : correlation coefficient of fit
c
c
      implicit none
      character*80 data(*)
      integer nhead,nrecord,min_weight,nsp
      real min_dist,max_dist,min_az,max_az
      integer iaz    ! azimuth for one station, event to statiojn
      real rms_p_vel, corr_p_vel,app_p_vel ! for app velocity
      real rms_s_vel, corr_s_vel,app_s_vel ! for app velocity
      real tp(500)   ! p-times
      real tpp(500)  ! p-times for s-p
      real ts(500)   ! first s
      real av_dist_p,sd_dist_p,av_dist_s,sd_dist_s
      character*5 stat_p(500),stat_s(500)  ! stations having a p or s-reading
      integer np     ! number of p times
      integer ns     ! number of s times
      real tsp(500)  ! s-p times
      real dist_p(500) ! epicentral distances, p
      real dist_s(500) ! epicentral distances, s
      real dist      ! -------------------
      real avsp,sdsp ! average s-p with standard deviation
      real sec
      real a         ! dummy
      integer timep  ! hours and minutes in secs
      integer hour,min
      character*5 stat   ! one station code
      character*2 phase  ! phase
      integer i,k,iw
      
c
c
c
      nsp=0
      np=0
      ns=0
c
c   find pairs of readings, assume same phase, weight can be in column 9 if
c   phase is long
c
      do i=nhead+1,nrecord
        read(data(i)(15:15),'(i1)',err=50) iw     ! read assigned weight
        goto 51
 50     continue
        read(data(i)(9:9),'(i1)') iw              ! read assigned weight
 51     continue
c
c   find p and distance
c 
c        write(6,*) iw,data(i)(11:11),data(i)(71:75)
        if(data(i)(11:11).eq.'P'.and.iw.lt.4.and.
     *  data(i)(71:75).ne.'     ') then            ! if valid P
c            write(6,*) np
            read(data(i)(19:28),'(2i2,f6.1)') hour,min,sec
            read(data(i)(71:79),'(f5.0,1x,i3)') dist,iaz
c
c   check if within range
c
            if(dist.gt.max_dist.or.dist.lt.min_dist.
     *      or.iaz.gt.max_az.or.iaz.lt.min_az) then
               goto 198   ! end of loop, do not use station for P
            endif
            np=np+1
            tp(np)=hour*3600.0+min*60.0+sec
            dist_p(np)=dist
            stat_p(np)=data(i)(2:6)
        endif
 198    continue
c
c  find s and distance
c

        if(data(i)(11:11).eq.'S'.and.iw.lt.4.and.
     *  data(i)(71:75).ne.'     ') then            ! if valid P
c            write(6,*) ns
            read(data(i)(19:28),'(2i2,f6.1)') hour,min,sec
            read(data(i)(71:79),'(f5.0,1x,i3)') dist,iaz
c
c   check if within range
c
            if(dist.gt.max_dist.or.dist.lt.min_dist.
     *      or.iaz.gt.max_az.or.iaz.lt.min_az) then
               goto 199   ! end of loop, do not use station for S
            endif
            ns=ns+1
            ts(ns)=hour*3600.0+min*60.0+sec
            dist_s(ns)=dist
            stat_s(ns)=data(i)(2:6)
        endif
 199    continue
c
c   find p and s-p for average s-p
c
        if(data(i)(11:11).eq.'P'.and.iw.le.min_weight) then  ! if valid P
           stat=data(i)(2:6)
           phase=data(i)(11:12)  ! p-phase
           phase(1:1)='S'        ! corresponding s-phase
           do k=nhead+1,nrecord
             read(data(i)(15:15),'(i1)',err=60) iw     ! read assigned weight
             goto 61
  60         continue
             read(data(i)(9:9),'(i1)') iw              ! read assigned weight
  61         continue
             if(data(k)(11:12).eq.phase.and.data(k)(2:6).eq.stat.
     *       and.iw.le.min_weight) then  ! same S
                nsp=nsp+1
                read(data(i)(19:28),'(2i2,f6.1)') hour,min,sec
                tpp(nsp)=hour*3600.0+min*60.0+sec
                read(data(k)(19:28),'(2i2,f6.1)') hour,min,sec
                tsp(nsp)=hour*3600.0+min*60.0+sec-tpp(nsp)
             endif
           enddo
        endif
      enddo
      timep=hour*3600+min*60  
c
c  all readings done, now find average s-p
c
      if(nsp.ge.2) then
         call sdv(nsp,tsp,avsp,sdsp)
      endif

c
c   apparent velocity from distances and p-times
c
      if(np.ge.2) then
c
c  first get rid of multiple p's for same station
c
         do i=1,np
           do k=1,np
             if((stat_p(k).eq.stat_p(i)).and.(k.ne.i)) then
                if((tp(k).gt.tp(i)).and.tp(i).gt.0.0) tp(k)=0   ! indicate not use
             endif
           enddo
         enddo
         k=0
         do i=1,np
           if(tp(i).ne.0) then
              k=k+1
              tp(k)=tp(i)
              dist_p(k)=dist_p(i)
           endif
         enddo
         np=k

         if(np.ge.2) then
            do i=2,np
              tp(i)=tp(i)-tp(1)  ! make values smaller
            enddo  
            tp(1)=0.0                        
            call lsqlin
     *      (np,tp,dist_p,a,app_p_vel,corr_p_vel,rms_p_vel)
         endif
      endif
c
c   average distance 
c
      call sdv(np,dist_p,av_dist_p,sd_dist_p)
c
c   apparent velocity from distances and s-times
c
      if(ns.ge.2) then
c
c  first get rid of multiple s's for same station
c
         do i=1,ns
           do k=1,ns
             if((stat_s(k).eq.stat_s(i)).and.(k.ne.i)) then
                if((ts(k).gt.ts(i)).and.ts(i).gt.0.0) ts(k)=0   ! indicate not use
             endif
           enddo
         enddo
         k=0
         do i=1,ns
           if(ts(i).ne.0) then
              k=k+1
              ts(k)=ts(i)
              dist_s(k)=dist_s(i)
           endif
         enddo
         ns=k

         if(ns.ge.2) then
            do i=2,ns
              ts(i)=ts(i)-ts(1)  ! make values smaller
            enddo  
            ts(1)=0.0                        
            call lsqlin
     *      (ns,ts,dist_s,a,app_s_vel,corr_s_vel,rms_s_vel)
         endif
      endif
c
c   average distance
c
      call sdv(ns,dist_s,av_dist_s,sd_dist_s)
c
      return
      end

c****************************************************************
c Modified version of Ray Buland's global travel time generation
c program which runs on both PC's and SUN's
c must be linked with subroutines in tau.for

c reads the two random access files iasp91.hed & iasp91.tbl
c
c   updates
c   dec 29 94  : adopt to seisan
c   april 99   : -----------  verisopn 7.0 check --------------------
c                remove call to computer type
c   11/03 lot  : add call to iasp91_filename

      program ttim
      save
      parameter (max=100)
      logical log,prnt(3)
      character*8 phcd(max),phlst(10)
      character*80 fnam
      character*80 modnam,comp_modnam
      logical exist
      dimension tt(max),dtdd(max),dtdh(max),dddp(max),mn(max),ts(max)
      dimension xcor(max),tcor(max),usrc(2)
      integer seiclen
c
c
      character*1 dchar
      character*60 top_directory
      data inrec/30/,phlst(1)/'query'/,prnt(3)/.true./

 

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call dir_char(dchar)
      call topdir(top_directory)
      itp= index(top_directory,' ') -1

c
c   check for iaspei files
c
c      modnam='IASP91 '
      call iasp91_filename(comp_modnam)
      inquire(file=comp_modnam
     &   (:seiclen(comp_modnam))//'.TBL',
     &    exist=exist)
      if(exist) then
         modnam=comp_modnam(1:seiclen(comp_modnam))//' '
      else
         modnam=
     *top_directory(1:itp)//dchar//'DAT'//dchar//
     *   comp_modnam(1:seiclen(comp_modnam))//' '
      endif

c      inquire(file='IASP91.TBL',exist=exist)
c      if(exist) then
c         modnam='IASP91 '
c      else
c         modnam=
c     *top_directory(1:itp)//dchar//'DAT'//dchar//'IASP91 '
c      endif


c
      fnam='ttim1.lis'//char(0)
      call assign(10,2,fnam)
c     write(6,*) 'name of model'
c     read (5,fmt='(a)') ctnam
      call tabin(inrec,modnam)
      fnam='Do you want tau interpolation printed?'//char(0)
      call query(fnam,prnt(1))
      fnam='Do you want range summary printed?'//char(0)
      call query(fnam,prnt(2))
      call brnset(1,phlst,prnt)
c
 3    fnam='Source depth (km):'//char(0)
      call query(fnam,log)
      read(*,*)zs
      if(zs.lt.0.) go to 13
      call depset(zs,usrc)
 1    write(*,*)
      fnam='Enter delta:'//char(0)
      call query(fnam,log)
      read(*,*)delta
      if(delta.lt.0.) go to 3
      call trtm(delta,max,n,tt,dtdd,dtdh,dddp,phcd)
      if(n.le.0) go to 2
      do 4 i=1,n
c     if(iupcor(phcd(i)(1:1),dtdd(i),xcor(i),tcor(i)).le.0)
c    1 print *,'iupcor failed on phase ',phcd(i)
      xcor(i)=0.
      tcor(i)=0.
c     if(phcd(i)(1.eq.'Pg'.or.phcd(i).eq.'Pb'.or.phcd(i).eq.'Pn'.or.
c    1 phcd(i).eq.'P') ierr=iupcor('P',dtdd(i),xcor(i),tcor(i))
c     if(phcd(i).eq.'Sg'.or.phcd(i).eq.'Sb'.or.phcd(i).eq.'Sn'.or.
c    1 phcd(i).eq.'S') ierr=iupcor('S',dtdd(i),xcor(i),tcor(i))
      mn(i)=tt(i)/60.
      ts(i)=.01*int(100.*(tt(i)-mn(i)*60.)+.5)
      if(ts(i).lt.60.) go to 4
      mn(i)=mn(i)+1
      ts(i)=ts(i)-60.
 4    continue
c
      do 5 i=1,n
      if(i.gt.1) go to 6
      write(*,100)delta,i,phcd(i),tt(i),mn(i),ts(i),dtdd(i),dtdh(i),
     1 dddp(i)
 100  format(/1x,f6.2,i5,2x,a,f9.2,i4,f7.2,1p3e11.2)
      go to 7
 6    write(*,102)i,phcd(i),tt(i),mn(i),ts(i),dtdd(i),dtdh(i),dddp(i)
 102  format(7x,i5,2x,a,f9.2,i4,f7.2,1p3e11.2)
 7    if(xcor(i).ne.0..or.tcor(i).ne.0.) write(*,103)tcor(i),xcor(i)
 103  format(22x,f9.2,f11.2)
 5    continue
      go to 1
 2    write(*,101)delta
 101  format(/1x,'No arrivals for delta =',f7.2)
      go to 1
 13   call retrns(inrec)
      call retrns(10)
      call vexit(0)
      end

c--------------------------------------------------------------------------
c  read edr format of USGS, output in nordic format
c--------------------------------------------------------------------------c
c
c  input format read is as show on stanadrd screen
c
c  For detail on parameters and variables naames, see rea.inc
c
c  
c
c changes
c  17/05/2007 lot - changed == to .eq.
c
      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common bliock

      character*80 data(5000)             ! s-file with data in text array
      character*80 err_text               ! error text
      character*80 infile                 ! input file
      integer strike,dip,slip
      character*80 text

      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer nevent                      ! number of events in file
      integer i                           ! counter

!_________________________________________________________________________
      integer          flin_region,nms,nstat,mm,jj,nphas,nstat2
      integer          LNBLNK,fp,lp,lc,nhead
      integer          scol(3)

      character*2      line_id
      character*1      ev_lat_dir
      character*1      ev_lon_dir
      character*1      depth_flag
      character*1      ver_flag
      character*1      loc_quality
      character*5      src_code, station
      character*8      phase

      real             ev_lat,dist
      real             ev_lon
      real             standrd_dev, azimu

      logical          finish_job

!_________________________________________________________________________

c
c   open output file

       open(2,file='edrnor.out',status='unknown')
    
c
c   get input file name, check if exist
c

 9    continue
      write(6,*) 'Give input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old',err=10)
      goto 11
 10    continue
      write(6,*)' No such input file'
      goto 9
 11   continue
c
      all=.true.                  ! read all parameters
      nevent=0                    ! initialize counter

c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c

  50  continue
c
c   read all parameters for one event form file unit 1
c

      read(1,'(a)',end=1000) text      
      if(text(1:2).eq.'HY' .and. nevent .gt. 0 ) goto 77
!_________________________________________________________________

66    if(text(1:2).eq.'HY') then
!          print*,'HY   >>>'
          nstat=0
          nphas=0
          nevent=nevent+1               ! count events

          call rea_hyp_clear(1)

        read(text,101)line_id,hyp_year(1),hyp_month(1),hyp_day(1),
     +       hyp_hour(1),hyp_min(1),hyp_sec(1),loc_quality,ev_lat,
     +       ev_lat_dir,ev_lon,ev_lon_dir,hyp_depth(1),depth_flag,
     +       standrd_dev,rea_nstat, ver_flag,flin_region,src_code

        if(ev_lat_dir .eq. 'N')then
             hyp_lat(1)= ev_lat 
        else if(ev_lat_dir .eq. 'S')then
             hyp_lat(1)= -ev_lat 
        endif

        if(ev_lon_dir .eq. 'E')then
             hyp_lon(1)= ev_lon 
        else if(ev_lon_dir .eq. 'W')then
             hyp_lon(1)= -ev_lon 
        endif

          hyp_dist_id(1)='D'
          hyp_fix_org(1)=' '
          rea_nhyp=1
          nhead = 1
          rea_nhead = nhead
          rea_id_line=' '
          hyp_epi_flag(1)=' '
        goto 50
!-------------------------------------
      else if(text(1:2).eq.'E ') then
!          print*,'E    >>>'

        read(text,102)line_id,hyp_sec_err(1),hyp_lat_err(1),
     +       hyp_lon_err(1),hyp_depth_err(1),hyp_mag(1,1),
     +       hyp_nstat(1),hyp_mag(2,1),nms


        hyp_mag_type(1,1)= 'B'
        hyp_mag_type(2,1)= 'S'
        goto 50
!-------------------------------------
      else if(text(1:2).eq.'L ') then
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'A ') then
!         read(text,104)line_id,rea_nphase,rea_nstat,hyp_gap(1)
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'C ') then
         read(text,105)line_id,rea_comment(1)
         rea_ncomment = 1
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'AH') then
!!        read(text,101)line_id,hyp_year(2),hyp_month(2),hyp_day(2),
!!     +       hyp_hour(2),hyp_min(2),hyp_sec(2),loc_quality,ev_lat,
!!     +       ev_lat_dir,ev_lon,ev_lon_dir,hyp_depth(2),depth_flag,
!!     +       standrd_dev,nstat2, ver_flag,flin_region,src_code
!!        if(ev_lat_dir .eq. 'N')then
!!             hyp_lat(2)= ev_lat 
!!        else if(ev_lat_dir .eq. 'S')then
!!             hyp_lat(2)= -ev_lat 
!!        endif
!!        if(ev_lon_dir .eq. 'E')then
!!             hyp_lon(2)= ev_lon 
!!        else if(ev_lon_dir .eq. 'W')then
!!             hyp_lon(2)= -ev_lon 
!!        endif
!!          nhead = nhead + 1
!!          hyp_dist_id(nhead)='D'
!!          rea_nhyp=rea_nhyp+1
!!          hyp_fix_org(nhead)=' '
!!          hyp_epi_flag(nhead)=' '
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'AE') then
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'Dp') then
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'Dt') then
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'Da') then
!        read(text,110)line_id,strike1,dip1,slip1,strike2,dip2,slip2
!               rea_nfault = 2
!               rea_fault(1)=' '
!               write(rea_fault(1),'(3f10.0)') 
!              rea_fault(1)(71:76)='HARWAR'
!              rea_fault(1)(80:80)='F'
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'Dc') then
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'S ') then
          scol(1) = 8
          scol(2) = 26
          scol(3) = 44

       do jj = 1,3
        if(text(scol(jj):scol(jj)+1).ne.'D=' .and.
     +     text(scol(jj):scol(jj)+7).ne.'        ' )then
     
           nphas=nphas + 1

        if(jj.eq.1)then
        read(text,114)line_id,phase,
     +      rea_hour(nphas),rea_min(nphas),
     +       rea_sec(nphas)
        else if(jj.eq.2)then
        read(text,115)line_id,phase,
     +       rea_hour(nphas),rea_min(nphas),
     +       rea_sec(nphas)
        else if(jj.eq.2)then
        read(text,116)line_id,phase,
     +       rea_hour(nphas),rea_min(nphas),
     +       rea_sec(nphas)
       endif

             rea_auto(nphas) = ' '
             rea_onset(nphas) = ' '
             rea_polarity(nphas)= ' '
             lc =  lnblnk(phase)
          if(phase(lc:lc).eq.'c'.or.phase(lc:lc).eq.'d')then
             if(phase(lc:lc).eq.'c')rea_polarity(nphas)='C'
             if(phase(lc:lc).eq.'d')rea_polarity(nphas)='D'
             lp = lnblnk(phase)-1 
          else
             lp = lnblnk(phase) 
          endif
          if(phase(1:1).eq.'e'.or.phase(1:1).eq.'i')then
             if(phase(1:1).eq.'e')rea_onset(nphas) = 'E'
             if(phase(1:1).eq.'i')rea_onset(nphas) = 'I'
             fp = 2
          else
             fp = 1
          endif
             rea_phase(nphas) = phase(fp:lp)

           rea_az(nphas) = azimu
           rea_weight_in(nphas) = ' '   
           rea_weight_out(nphas) = ' '   
           rea_stat(nphas) = station
           rea_dist(nphas) = dist*111.4
           rea_co(nphas) = 'BZ'
       endif

       end do
         goto 50
!-------------------------------------
      else if(text(1:2).eq.'M ') then

         goto 50
!-------------------------------------
      else if(text(1:2).eq.'P ') then
         nstat=nstat + 1
         nphas=nphas + 1

        read(text,112)line_id,station,
     +      phase,rea_hour(nphas),
     +      rea_min(nphas),rea_sec(nphas),rea_res(nphas),dist,
     +      azimu,rea_per(nphas),rea_amp(nphas)

             rea_az(nphas) = azimu
             rea_weight_in(nphas) = ' '   
             rea_weight_out(nphas) = ' '   
             rea_dist(nphas) = dist*111.4
             rea_stat(nphas) = station
             rea_co(nphas) = 'BZ'
             rea_auto(nphas) = ' '
             rea_onset(nphas) = ' '
             rea_polarity(nphas)= ' '
             lc =  lnblnk(phase)
          if(phase(lc:lc).eq.'c'.or.phase(lc:lc).eq.'d')then
             if(phase(lc:lc).eq.'c')rea_polarity(nphas)='C'
             if(phase(lc:lc).eq.'d')rea_polarity(nphas)='D'
             lp = lnblnk(phase)-1 
          else
             lp = lnblnk(phase) 
          endif
          if(phase(1:1).eq.'e'.or.phase(1:1).eq.'i')then
             if(phase(1:1).eq.'e')rea_onset(nphas) = 'E'
             if(phase(1:1).eq.'i')rea_onset(nphas) = 'I'
             fp = 2
          else
             fp = 1
          endif
             rea_phase(nphas) = phase(fp:lp)

         goto 50
!-------------------------------------
      else
         goto 50
      endif
!_________________________________________________________________
c
c   write out 
c
 1000 continue
      finish_job = .true.

77      continue


          rea_nphase = nphas
!          rea_nstat  = nphas
!          rea_nrecord = nphas
        call rea_event_out(2,all,data,code)
c

!       endif  


c   get next event
c
      if( .not.finish_job) goto 66
c
c     end of file
c
c
      write(6,*)            ! blank line
      close(2)              ! close output file
      write(6,*) 'Number of events in input file', nevent
      write(6,*) 'Output file name is edrnor.out'

101     format (a2,i4,i2,i2,1x,i2,i2,f5.2,a1,f6.3,a1,1x,f7.3,a1,1x,f5.1,
     +         a1,f4.2,i3,a1,i3,a5)


!102     format (a2,f5.2,1x,f6.2,1x,f6.2,1x,f5.1,1x,f3.1,1x,i3,
!     +        1x,f3.1,i3,f3.1,a2,a4,f3.1,a2,a4)
102     format (a2,f5.2,1x,f6.2,1x,f6.2,1x,f5.1,1x,f3.1,1x,i3,
     +        1x,f3.1,i3)
103     format (a2,f6.2,f5.2,e8.2,f6.2,f5.2,e8.2,f6.2,f5.2,e8.2,1x)
!104     format (a2,i4,1x,i3,f5.1,1x,f3.1,a2,a5,1x,a1,i7,
!     +          a1,i7,a1,i7,a1,a8)
104     format (a2,i4,1x,i3,f5.1)
105     format (a2, a58)
106     format (a2, i8, 1x,d9.2,a1,f6.3,a1,1x,f7.3,a1,a1,f5.1,
     +        a1,f4.2,i3,i4,a5)
107     format (a2,f5.2,1x,f6.2,1x,f6.2,1x,f5.1,1x,f5.1,f3.1,
     +        a2,5x,f3.1,a2,12x)
108     format (a2,a4,a1,i1,f7.1,f2.1,f4.2,a1,f3.2,f5.2,a1,
     +        f3.2,f4.1,f2.1,i3,i3,i2,i3,f3.1,f2.1,f2.1,i2 )
109     format (a2,1x,i2,1x,a2,f4.2,f3.2,a2,f4.2,f3.2,a2,
     +        f4.2,f3.2,a2,f4.2,f3.2,a2,f4.2,f3.2,a2,f4.2,f3.2)
!110    format (a2,1x,i2,f4.2,f3.2,i2,i3,f4.2,f3.2,i2,i2,f4.2, 
!     +        f3.2,i2,i3,1x,i3,i2,i4,i3,i2,i4)
110    format (a2,39x,i3,i2,i4,i3,i2,i4)
111    format (a2, a58 )
!112    format (a2,a5,a8,f9.2,1x,f5.1,a1,1x,f6.2,1x,
!     + f5.1,f4.1,f7.2,1x,f3.1,a1)
112    format (a2,a5,a8,i2,i2,f5.2,1x,f5.1,   2x,f6.2,1x,
     + f5.1,f4.1,f7.2)
113    format (a2,5x,a1,1x,f4.1,f7.2,1x,a1,1x,f4.1,f7.2,
     + 1x,a1,1x,f4.1,f7.2,1x,a3,1x,f3.1,a1,3x)
!114    format (a2,5x,a8,f9.2,1x,a8,f9.2,1x,a8,f9.2)
!115   format (a2,5x,a2,f5.1,a1,f9.2,1x,a2,f5.1,a1,
!     + f9.2,1x,a2,f5.1,a1,f9.2)
114    format (a2, 5x,a8,i2,i2,f5.2)
115    format (a2,23x,a8,i2,i2,f5.2)
116    format (a2,41x,a8,i2,i2,f5.2)

      stop
      end
!_________________________________________________________________
!_________________________________________________________________

*
* $Id: lnblnk.F,v 1.2 2002/10/14 14:57:23 hristov dead $
*
* $Log: lnblnk.F,v $
* Revision 1.2  2002/10/14 14:57:23  hristov
* Merging the VirtualMC branch to the main development branch (HEAD)
*
* Revision 1.1  1999/05/18 15:55:30  fca
* Initial revision
*
* Revision 1.1.1.1  1996/02/15 17:50:38  mclareni
* Kernlib
*
*
!#include "kerngen/pilot.h"
      FUNCTION LNBLNK (CHV)
C
C CERN PROGLIB# M432    LNBLNK          .VERSION KERNFOR  4.21  890323
C ORIG. 04/10/88, JZ
C
C-    Find last non-blank character in CHV

      CHARACTER    CHV*(*)

      N = LEN(CHV)

      DO 17  JJ= N,1,-1
      IF (CHV(JJ:JJ).NE.' ') GO TO 99
   17 CONTINUE
      JJ = 0

   99 LNBLNK = JJ
      RETURN
      END
!_________________________________________________________________
!_________________________________________________________________

      subroutine spec_dist
     *(spec_phase,edistance,edepth,factor)
c
c   calculate equivalent geometrical spreading distance
c
c
c     input : spec_phase,Phase type (P or S),                             
c             edistance, epicentral distance
c             edepth,hypocentral depth,
c             geo_depth1, geo_depth2 :depth range for type of 
c                                     geometrical spreading,from common 
c             herkij_distance: distance where spreading goes from
c                              body to surface wave
c     output: the geometrical spreading factor to mulitply with
c
c     If no phase type, S is assumed
c     The geometrical spreading changes from Herrmann-Kijko or body
c     wave spreading in the depth range geo_depth1 to geo_depth2, see
c     comment below.
c
c   updates:
c
c   mar 5 01 jh : allow distance to be less than 1.0
c   oct 12 07 jh: add teleseismic spreading
c
c     
      implicit none
      include 'seisan.inc'
      character*1 s_phase,spec_phase ! phase ids
      real factor
      real edepth,edistance,sdistance
c
c   check if distance larger than 30 deg, then use teleseismic approximation to spreading
c
      if(edistance.ge.30.0*111.2) then
         factor=0.0048/(30.0+(edistance/111.2))
         return
      endif
         

      sdistance=sqrt(edepth*edepth+edistance*edistance)
      factor=1.0
c
c   check phase type
c
      s_phase=spec_phase
      if(spec_phase.ne.'S'.and.spec_phase.ne.'P') s_phase ='S'

c
c   check that hypocentral distance is not zero
c
      if(sdistance.lt.0.00001) sdistance=0.00001
c
c   check depth limits
c
      if(geo_depth2.le.geo_depth1) then
         write(6,*)' Wrong limits for geo_depth:', 
     *   geo_depth1,geo_depth2
         write(6,*)' Return to stop'
         read(5,'(a)') s_phase
         stop
      endif
c
c   if a P wave, geometrical spreading is always 1/hypocentral distance
c
      if(s_phase.eq.'P') then
        factor=1.0/sdistance
        return
      endif
c
c   if a S-phase, geometrical spreading is 1/hypocentral distance if
c   epicentral distance is less than herkij_distance km or depth larger than 
c   geo_depth2
c
      if((edistance.lt.herkij_distance.and.s_phase.eq.'S').or.
     *   edepth.ge.geo_depth2) then
        factor=1.0/sdistance
        return
      endif
c
c   if a S-phase, epicentral distance larger than 100 km and depth
c   is less than geo_depth1, then Herrmann-Kijko attenuation is used
c
      if(edistance.ge.herkij_distance.and.s_phase.eq.'S'.
     *and.edepth.lt.geo_depth1)
     *then
         factor=1.0/sqrt(herkij_distance*edistance)
         return
      endif      
c
c   if a S-phase, epicentral distance larger than herkij_distance km and depth
c   between geo_depth1 and geo_depth2), an interpolation between
c   Herrmann-Kijko and body wave spreading is used.
c
       if(edistance.ge.herkij_distance.and.s_phase.eq.'S'.and.
     *    edepth.ge.geo_depth1.and.edepth.lt.geo_depth2) then
         factor=(1.0-((edepth-geo_depth1)/(geo_depth2-geo_depth1)))
     *          *sqrt(edistance*herkij_distance)+
     *          ((edepth-geo_depth1)/(geo_depth2-geo_depth1))*
     *          sdistance
         factor=1.0/factor
       endif
c
       return

       end

c     Program to read a NOrdic file and write out
c     the parameters in a Herrmann file ready for hspec8 modelling
c
c apr 95 by jh : use only triangular pulse
c may 99 jh    : ------------------   veriosn 7.0 check ----------------
c                5 char stat code
c
      include 'seidim.inc'
      parameter (nnstat=32)
      character*80 sfile,data(max_data)
      character*110 string
      character*1 TYPE,EXP
c--- fault plane solution
      real strike,dip,rake,azimuth(nnstat),backazi(nnstat)
c--- component orientation
      logical radial
c--- station information 
      real distance(nnstat)
c--- stations to model
      character*5 stat(nnstat)
      character*14 filename
c
      character*4 comp
      real thick(20),vp(20),vs(20),dens(20),qp(20),qs(20)
      real t0synt(nnstat)
      


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c      open(1,file='transfer.idx',status='old')
c      read(1,'(a)')sfile
c      close(1)
      k = 0

      open(1,file='hyp.out',status='old')
      call indata(1,NSTAT,NPHAS,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
      do i = 1, nhead
        if(data(i)(80:80).eq.'3'.and.data(i)(2:6).eq.'SYNT:') then
          if(data(i)(8:15) .eq. 'MODEL--:' )then 
            if(data(i)(16:25) .ne. '     THICK')then
              k = k + 1
              read(data(i)(16:79),'(6f10.3)')thick(k),vp(k),vs(k),
     +                          dens(k),qp(k),qs(k)
              if(qp(k) .eq. 0. )qp(k) = 500.
              if(qs(k) .eq. 0. )qs(k) = 500.
              qp(k) = 1./qp(k)
              qs(k) = 1./qs(k)
            endif
          endif
          if(data(i)(8:15) .eq. 'DT-Tsou:')then
            read(data(i)(26:79),'(f10.1)')t_source
          endif
          if(data(i)(8:15) .eq. 'NPOINTS:')then
            read(data(i)(16:79),'(I10)')npoints
          endif
          if(data(i)(8:15) .eq. 'ST-D-RK:')then
            read(data(i)(16:79),'(3f10.1)')strike,dip,rake
          endif
          if(data(i)(8:15) .eq. 'TIMES--:')then
            read(data(i)(16:79),'(3(10x,f10.1))')time,t0,tsynt
          endif
          if(data(i)(8:15) .eq. 'REDVELO:')then
            read(data(i)(16:79),'(f10.4)')vred
          endif
        endif
      enddo
c
c   find number of stations and stations to model
c
      nstat=0
      do i=1,nhead
         if(data(i)(80:80).eq.'3'.and.data(i)(2:15).eq.'SYNT: STATION:')
     *   then
            do istat=1,nstat
              if(stat(istat).eq.data(i)(17:21)) goto 80
            enddo
c
c   station was not counted before
c
            nstat=nstat+1
            stat(nstat)=data(i)(17:21)
 80         continue
         endif
      enddo
c
c   get station data
c
       do istat=1,nstat
         do i=1,nhead
            if(stat(istat)(1:5).eq.data(i)(17:21).and.
     *      data(i)(28:35).eq.'DISTANC:'.and.data(i)(80:80).eq.'3')
     *      then
               read(data(i)(36:45),'(f10.1)') distance(istat)
            endif
            if(stat(istat)(1:5).eq.data(i)(17:21).and.
     *      data(i)(28:35).eq.'AZIMUTH:'.and.data(i)(80:80).eq.'3')
     *      then
               read(data(i)(36:45),'(f10.1)') azimuth(istat)
               read(data(i)(56:65),'(f10.1)') backazi(istat) 
            endif
         enddo
      enddo
c
c   read if Radial-Transverse or North-East components
c
      do i=1,nhead
         if(data(i)(2:15).eq.'SYNT: COMPON-:') then
            radial=.false.
            if  (data(i)(20:25).eq.'RADIAL')  radial=.true.
         endif
      enddo
c

      write(*,*) 'displacement=1, velocity=2, acceleration=3'
      read(*,*) ind

c     write(*,*) ' Possible Source time functions :'
c     write(*,*) ' 1 ==> Parabolic pulse (default)'
c     write(*,*) ' 2 ==> Triangular pulse'
c     write(*,*) ' 3 ==> Ohnaka pulse   '
c     write(*,*) ' 4 ==> Spike pulse'
c     read(*,*)ipulse
      ipulse=2
c     write(*,*)' Pulse duration multiplier (L*dt)(1=default)'
c     read(*,*)lpulse
      lpulse=t_source/(tsynt/float(npoints))
      if(lpulse.lt.1) lpulse=1
      write(6,*)' Pulse half time ', lpulse*(tsynt/float(npoints))
      if(ipulse .eq. 3)then
        write(*,*)' Enter corner frequency of Ohnaka pulse'
        read(*,*)freqc
      endif
c
c  loop on stations 
      open(20,status='scratch')
c
      do istat=1,nstat
        write(string(1:1),'(i1)') istat
        write(string(1:13),'(a)') 'rhwvinta.out'//string(1:1)
        write(filename,'(a)') string(1:13)
        string = ' '
c
c
c---- Now run rhfoc10
c
        write(*,*)'*********************************'
        write(*,*)' rhfoc10 is now running....'
        write(*,*)' Input  file: ',filename
        write(*,*)' Output file: file10'
        write(*,*)'*********************************'
        string(1:11) = 'rhfoc10 -f '
        string(12:25) = filename
        if(ind .eq. 1)string(26:29)=' -D '
        if(ind .eq. 2)string(26:29)=' -V '
        if(ind .eq. 3)string(26:29)=' -A '
        if(ipulse .eq. 1)string(30:32)='-p '
        if(ipulse .eq. 2)string(30:32)='-t '
        if(ipulse .eq. 3)string(30:32)='-o '
        if(ipulse .eq. 4)string(30:32)='-i '
        string(33:41) = ' > file10'
        if(ipulse .eq. 3 .and. freqc .ne. 0.)then
           write(string(33:40),'(a3,f5.1)')'-a ',freqc
           string(41:49)=' > file10'
        endif

        write(*,*)string

        call system('\\rm file10')
        write (*,*) 'file10 removed' 
        call system(string)

        string = ' '

c
c---- Now calculate 3C seismogram given the mechanism
c
        write(*,*)'*********************************'
        write(*,*)' mech is now running....'
        write(*,*)' Input  file: file10 '
        write(*,*)' Output file: file3 '
        write(*,*)'*********************************'
        string(1:5)='mech '
        if (radial)   then
          write(string(6:54),200)strike,dip,rake,
     *                azimuth(istat),backazi(istat)
200       format('-s ',f5.1,' -d ',f5.1,' -l ',f5.1,' -a ',f5.1,
     *        ' -b ',f5.1,' -r ')
        else
          write(string(6:54),201)strike,dip,rake,
     *                azimuth(istat),backazi(istat)
201       format('-s ',f5.1,' -d ',f5.1,' -l ',f5.1,' -a ',f5.1,
     *        ' -b ',f5.1)
        endif
        write(string(55:72),'(a)')' < file10 > file3'

c        write(*,*)string

        call system('\\rm file3')
        call system(string)
        string = ' '

        call readherr(stat(istat),nsamp,window)

        write(*,*)stat(istat),nsamp,window

        write(*,*)data(1),nrecord,window,nsamp
c
      enddo
c
      distmin=distance(1)
      do istat=2,nstat
        distmin=amin1(distmin,distance(istat))
      enddo
      do istat=1,nstat
        if (vred.ne.0.)  then
          t0synt(istat) = t0+(distance(istat)-distmin)/vred
        else
          t0synt(istat) = t0
        endif
      enddo
      dtt=window/(nsamp-1)
      write (*,*) (t0synt(istat),istat=1,nstat)
c
      call syntsel(data,nrecord,t0,time  ,t0synt,dtt,nsamp,'SH ')

      close(20)
      close(1)
      end


C########################################################################### 
   

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Routine to  read output data from Herrmann's program to

      subroutine readherr(stat,nsamp,window)

      character*80 infile,outfile1,outfile2,outfile3
      character*80 card
      character*4 icom(3)
      character*5 stat
      character*4 comp
      integer nnt(2)
      integer year,month,day,hour,min,sec,msec
      real yr,hs
      integer gmt(5),doy
      real tti(2), ddt(2), xmom(2)
      real srate
      dimension y(4096)
      dimension a(4096),b(4096),c(4096)
      real rfreq(2),amp(2),phase(2)
      integer ntrip,nsamp
      real xlat,xlon,xelev

      logical append,incresp

c      write(*,*)' Which file to convert?'
c      read(*,'(a)')infile

      infile='file3'

      open(12,file=infile,status='old')

c
c---- First read header information
c
120   continue

      write (*,*) 'lecture'
	read(12,13)r,yr,hs,nnt(1),tti(1),ddt(1),
     1		tau,dip,strike,slip,xmom(1),
     2            az,baz,iexpl,icom
   13 format(3e16.9,i10,e16.9/5e16.9/3e16.9,i10,3a4)
      write (*,*) 'fin lecture'
    
      idist = int(r)
      srate = 1./ddt(1)
      nsamp = nnt(1)
      window = ddt(1)*nsamp

      write(*,*)' srate and nsamp:',srate,nsamp
c
c---- Top of read and write 
c
      do 1000 i=1,nnt(1)
      y(i)=0.0
 1000 continue

      comp = 'S  '//icom(1)(2:2)

      read(12,11)(y(i),i=1,nnt(1))
   11 format(5e16.9) 
c     ymin = 10000.
c     do i = 1,nnt(1)
c       if(y(i).lt.ymin.and.y(i).ne.0.)factor = abs(2./y(i))
c     enddo
      factor=1.e10 
      do i = 1,nnt(1)
        a(i) = y(i) * factor
      enddo

      comp = 'S  '//icom(2)(2:2)
      do 2000 i=1,nnt(1)
       y(i)=0.0
 2000 continue
      read(12,11)(y(i),i=1,nnt(1))
      do i = 1,nnt(1)
        b(i) = y(i) * factor
      enddo

      comp = 'S  '//icom(3)(2:2)
      do 3000 i=1,nnt(1)
      y(i)=0.0
 3000 continue
      read(12,11)(y(i),i=1,nnt(1))
      do i = 1,nnt(1)
        c(i) = y(i) * factor
      enddo

      close (12)

      write(20,'(a5,a4)')stat,'   '//icom(1)(2:2)
      write(20,*)(a(i),i=1,nnt(1))
      write(20,'(a5,a4)')stat,'   '//icom(2)(2:2)
      write(20,*)(b(i),i=1,nnt(1))
      write(20,'(a5,a4)')stat,'   '//icom(3)(2:2)
      write(20,*)(c(i),i=1,nnt(1))

      end

c   computer dependent subroutines including dummy routines to be
c  able to use same programs on pc, linux  and sun
c-----------------------------------------------------------------
c  5 11 98    version 7.0 check
c----------------------------------------------------------------
c
c    ***** this file is for sun ******
c
c
c  Updates:
c

      subroutine computer_type(sun,pc,linux)
c   which computer
      implicit none
      logical pc,sun,linux
      pc=.false.
      sun=.true.
      linux=.false.
      return
      end

      subroutine iasp91_filename(name)
c set name of iasp91 files
      character*(*) name
      name='IASP91_sun'
      return
      end

c  Program name: sissei
c
c  convert Sismalp files to seisan format, PC, Sun and Linux
c
c  it is assumed that the sis ndx files have the same file names except
c  for the extension and that the file name is 12 characters long
c
c  this is a fist version, only tested with a few files
c
c  complete format description given at end of program
c
c  j. havskov, feb   2000
c
c
c  Help was provided by Philipe Lesage, Universite de Savoie
c
c  updates:
c    may 11  00    lo : use read_resp_head
c    feb 03 03     jh : remove intand, now in compdecomp

      implicit none
      include 'libsei.inc'
      include 'seidim.inc'
      integer*4  data(max_sample)     ! output samples
      integer*4  data4                ! input sample
      character*80 text               ! general text
c
c   block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	
ccccccccccccccccccccccccccccccccccccc  end

      integer nbits(max_trace)     ! number of bits in input sample
      integer ngainbits(max_trace) ! number of gain bits in input sample  
      integer nblock(max_trace)    ! number fo block each channel
c-- one file block
      integer*2 block_data(512)
c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
	  integer i,k,l
c-- computer type
      logical pc,sun,linux	  
       integer gain       ! gain
       integer data_mask  ! mask to extract data value exponent
       integer gain_mask  ! mask to extract one sample
       integer data1      ! one sample without gain
      integer irec                ! record number
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       call read_def_chan('sissei.def',mainhead_text,net_code)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files, here use text header files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old')
	   
c
c   read all header lines
c
       nchan=0
 1     continue
c
c   read first line
c
       read(1,'(a)',end=50,err=99) text
       nchan=nchan+1
       stat(nchan)=text(5:8)//' '
       read(text(9:14),'(i6)') nsamp(nchan)
       read(text(21:26),'(i6)') nblock(nchan)
       read(text(27:34),'(f8.2)') rate(nchan)
       read(text(37:47),'(i2,1x,i2,1x,i4)') 
     *                  day(nchan),month(nchan),year(nchan)
       read(text(48:59),'(i2,1x,i2,1x,f6.3)') 
     *                  hour(nchan),min(nchan),sec(nchan)

c
c    read 2. line
c
       read(1,'(a)',end=50) text
       comp(nchan)=' '
       comp(nchan)(1:1)=text(9:9)
       comp(nchan)(4:4)=text(11:11)
       read(text(13:14),'(i2)') nbits(nchan)
       read(text(16:16),'(i1)') ngainbits(nchan)
c
       goto 1
c
c  end of reading header file
c
  50   continue
       close(1)
       write(6,*)' Number of channels',nchan
c
c   open data file
c
       infile(10:12)='SIS'
       open(1,file=infile,status='old',access='direct',recl=1024)      

c--------------------------------------------------------------
c  loop to read whole file
c--------------------------------------------------------------
c
c
c  enter loop to define channels if a def file, set cbyte to always 4
c
       do ichan=1,nchan
         call set_def_chan(ichan,stat(ichan),comp(ichan))
         cbyte(ichan)='4'
       enddo
c
c   make seisan headers
c
      ichan=1
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
      mainhead(1)(2:29)=mainhead_text    ! put in header text
c
      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo

      irec=0
C
C   enter channel  loop
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,
     *                    stat,comp,nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
c                                                                               
c   get response            
c                                                                               
         call read_resp_head(chahead)                                            
c
c   read data samples for one channel, first set parameters for extracting
c   gain
c
         gain_mask=2**16-2**(16-ngainbits(ichan))   ! mask to get gain
         data_mask=2**nbits(ichan)-1                ! mask to extract data value        
         l=0
         do i=1,nblock(ichan)
            irec=irec+1
            read(1,rec=irec,err=99) block_data
c
c   swap if sun
c
            if(sun) call swap2(512,block_data)
c
            do k=1,512
               l=l+1
c
c   convert each sample
c
               data4=block_data(k)
               if(ngainbits(ichan).eq.0) then           ! signed 16 bit integer
                  data(l)=data4
               else                                     ! gain ranged
                  call intand(data4,gain_mask,gain)     ! extract gain
                  gain=gain/2**nbits(ichan)             ! shift bits right
                  call intand(data4,data_mask,data1)    ! extract one sample
                  data1=data1-2**(nbits(ichan)-1)       ! convert to signed int
                  data1=data1*2**gain                   ! correct for gain
                  data(l)=data1
               endif
            enddo
         enddo
c
c   write data
c
         write(2)chahead
         write(2) (data(i),i=1,nsamp(ichan))
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  
c

c                         APPENDIX 1: *.NDX AND *.SIS FILES



c           The seismic  traces processed by the PickEv 97 software comply
c          with a  specific format,  the SISMALP  format. Its advantage is
c          its simplicity  and compactness,  particularly useful  on a PC.
c          Writing filters  to transform these data into other formats and
c          conversely is very simple.

c           The seismic  samples are stored in the form of consecutive 16-
c          bit integers  grouped in blocks of 512 integers (1024 bytes) in
c          the binary name.SIS file, where name is either the station name
c          or the  event name.  Several traces can be stored one after the
c          other. If  the sample  number of  a trace  is not a multiple of
c          512, samples of any value have to be added to complete the last
c          block of this trace.

c           The name.NDX  text file has 2 lines per trace according to the
c          following format:

c          First line:


c               BALI  4096    52     8    100.  31.05.1997 12:34:56.789
c           ^^^^    ^^    ^^^^  ^^^^^ ^^^^    ^^          ^
c                (1)   (2)   (3)   (4)     (5)           (6)


c           (1) Col. 5-8: Station code
c           (2) Col. 9-14:    Number of samples in signal
c           (3) Col. 15-20:   Number of  first signal block in the direct
c                         access name.SIS  file (the  very first  block of
c                         the file has the number 1)
c           (4) Col. 21-26:   Number of blocks making up the signal
c           (5) Col. 27-34:   Sampling  frequency   (real  value  with  a
c                         decimal point)  expressed in  Hz (in the SISMALP
c                         format versions  previous to version 11.20, this
c                         sampling frequency was an integer)
c           (6) Col. 37-59:   Date and time of first sample, separated by
c                         a space  ( ), a  tilde (~),  a circumflex accent
c                         (^), an underscore (_), a plus (+), a minus (-),
c                         or  an  ampersand  (&)  (see  Sections  1.5  and
c                         2.3.7.13)

c          Second line:


c           SISMALP 3 Z 10 0 * 15.02   -512   -43    38     2   1024 1
c           3
c                  ^ ^ ^  ^ ^ ^     ^^^    ^^^   ^^^^  ^^^^^ ^^^    ^ ^^^
c             (1)   2 3 4 5 6  (7)     (8)   (9)   (10)  (11)   (12)13
c           (14)

c      116   Appendix 1


c       (1) Col. 1-7: Name of acquisition system.
c       (2)  Col. 9:  Component number.
c       (3) Col. 11:  Component identification  (for example  V, Z, N,
c                     E, R, L, T, 1..9, etc.).
c       (4) Col. 13-14:   Number of significant bits (variable NrBits
c                     in PICK.INI, see Section 2.1.6).
c       (5) Col. 16:  Number of  gain  bits  (variable  NrGainBits  in
c                     PICK.INI, see Section 2.1.6).
c                     If  this   number  is   0  samples  are  signed,
c                     otherwise they  are not signed. The gain is 2n,
c
c Comment by J. Havskov: Gain factor must 2**n, also gain is applied
c                        after converting to a signed integer

c                     where n  is the non-signed integer stored in the
c                     NrGainBits gain  bits; the  sample value  is the
c                     integer value  stored in  the  least-significant
c                     NrBits, multiplied by the gain value.
c       (6) Col. 18:  Indicator of reversed polarity under PICKEV (see
c                     Section 2.3.7.9).  A space  ( ) means  a  normal
c                     polarity, a star (*) means a reversed polarity.
c       (7) Col. 20-24:   SISMALP version number.
c       (8) Col. 26-31:   Maximum   possible    amplitude   of    the
c                     acquisition system  (AdcMax). A  negative  value
c                     indicates two's  complement  coding  (e.g.  -512
c                     corresponds to  interval [-512,+511], while +512
c                     corresponds to interval [-512,+512]).
c       (9) Col. 32-37:   Maximum    trace     amplitude    downwards
c                     (TraceMin).
c       (10) Col. 38-43:  Maximum trace amplitude upwards (TraceMax).
c       (11) Col. 44-49:  Mean trace offset (TraceMoy).
c       (12) Col. 51-56:  Number of  samples of  the pre-event window
c                     (PreEvent).
c       (13) Col. 57-58 : Channel of  the acquisition  system (unused
c                     in PickEv 97).
c       (14) Col. 59-62 : Gain of channel (unused in PickEv 97).

c       Columns 20-62  did not  exist in SISMALP format before version
c      14.36. Informations  in columns  26-62 are  thus ignored if the
c      version number  given in  columns 20-24  is blank  or is  below
c      14.36. The  channel and  the gain,  in columns  57-62, did  not
c      exist before version 15.02.

c       AdcMax, TraceMin,  TraceMax, and  TraceMoy  values  are  coded
c      using NrBits  and NrGainBits  values, i.e.  coded with the same
c      algorithm as the samples.

c       AdcMax (columns 26-31) and PreEvent (columns 51-56) fields can
c      be left  blank and are then ignored. The three fields TraceMin,
c      TraceMax, and  TraceMoy (columns  32-49) can be left blank as a
c      whole; they will then be ignored.
c
c   Format provided by
c
c*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-
c Philippe Lesage                           *
c Laboratoire de Geophysique Interne et     |
c Tectonophysique - Savoie (UMR 5559)       *
c Universite de Savoie                      |
c 73376 Le Bourget-du-Lac Cedex             *
c Telephone : (33) 4 79 75 84 86            |
c Telefax   : (33) 4 79 75 87 42            *
c E-mail    : lesage@univ-savoie.fr         |
c*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-

c$DEBUG
c
c   make a WKBJ input file from hyp.out
c
c   (based on subroutine makebou)
c
c  updates:
c  dev 94   by jh: use system_c instead of system
c  jan 94        : check for zereo number of stations and zereo depth
c                  not free, 6 phases per line
c  may 95        : bug
c  april 99 by jh: ------------------- verison 7.0 check-----------------
c                  year to 4 digits, system_c to systemc, 5 char stat
c  may,13 99   lo: changed two format statements
c
      include 'seidim.inc'
      parameter (nnrays=30,nnptst=40000,nnstat=32,nnint=20)
c--- the hyp file
      character*80 data(max_data)
c--- number of lines in hyp file
      integer ndata
c--- code for Moho definition 
      character*1 comoho(nnint)
c--- model parameters in input
      real thick(nnint),alp1(nnint),bet1(nnint),rho1(nnint)
c--- fault plane solution
      real strike,dip,rake,azimuth(nnstat)
c--- component orientation
      logical radial
c--- focal depth
      real sdepth
c--- stations to model
      character*5 stat(nnstat)
      real distance(nnstat),backazi(nnstat)
c--- codes for phases which can be synthesized with WKBJ
      character*4 catfas(24)
c--- codes for phases to be synthesized with WKBJ
      character*4 codfsi(nnrays)
      character*4 codfas(nnrays)
      character*3 codhed
      character*5 coiasp
c--- true if the receiver is at the free surface
      logical freesf
c--- index of the reflective interface for each phase
      integer imoho0(nnrays)
c--- indexes to make the phases
      integer idx(5,13),idx2(13)
      character*13 chain,chain2
c--- arrays for the Green functions and the seismograms
      real temp(nnptst),green(13,nnptst),sismo(3,nnptst)
c--- array for the origin time of the seismograms
      real t0synt(nnstat),dtt
c--- array for the source time function
      real ss(nnptst)
c--- origin times
      integer oyear,omonth,odoy,oday,ohour,omin
      real osec
      double precision otime,ptime
c--- counters and pointers and help variables
c      character*1 liquid
      character*2 cbid
      logical logic
c
      data pi /3.14159/
      data catfas/
     &'  Pg','  Sg','    ','    ',' PmP',' SmS',' SmP',' PmS',
     &'    ','    ','    ','    ','pPmP','pSmS','pSmP','pPmS',
     &'    ','    ','    ','    ','sPmP','sSmS','sSmP','sPmS'/


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   open output file for phase times
c
       open(16,file='iasp.out',status='unknown')
       close(16,status='delete')
       open(16,file='iasp.out',status='unknown')
c
c----------------------------  READING IN PARAMETRS  --------------
c
c   open and read hyp.out file, store in array 'data'
c
      ndata=1
      open(1,file='hyp.out',status='old')
 10   continue
        read(1,'(a)',end=20)data(ndata)
        ndata=ndata+1
        goto 10
  20  continue
      ndata=ndata-1
c
c  get model, first count number of layers, assume first line header
c
         kl=-1
         do i=1,ndata
            if(data(i)(2:15).eq.'SYNT: MODEL--:') then
               kl=kl+1
               if(kl.eq.0) khead=i
            endif
         enddo
         do i=1,kl
            iline=khead+i
            read(data(iline)(16:25),'(f10.1)') thick(i)
            read(data(iline)(26:35),'(f10.1)') alp1 (i)
            read(data(iline)(36:45),'(f10.1)') bet1 (i)
            read(data(iline)(46:55),'(f10.1)') rho1 (i)
            read(data(iline)(77:77),'(a1   )') comoho(i)  
         enddo
c
c   find number of stations and stations to model
c
      nstat=0
      do i=1,ndata
         if(data(i)(80:80).eq.'3'.and.data(i)(2:15).eq.'SYNT: STATION:') 
     *   then
            do k=1,nstat
              if(stat(k).eq.data(i)(17:21)) goto 80
            enddo
c
c   station was not counted before
c
            nstat=nstat+1
            stat(nstat)=data(i)(17:21)
 80         continue
         endif
      enddo
c
c   if number of stations are zero stop
c
      if(nstat.eq.0) then
         write(6,*)' No stations given for modelling'
         stop
      endif
c
c   get station data
c
       do istat=1,nstat
c
c   find distance for stations, either given by SYNT, or by hyp
c
         do i=1,ndata
            if(stat(istat).eq.data(i)(17:21).and.
     *      data(i)(28:35).eq.'DISTANC:'.and.data(i)(80:80).eq.'3') 
     *      then
               read(data(i)(36:45),'(f10.1)') distance(istat)
            endif
            if(stat(istat).eq.data(i)(17:21).and.
     *      data(i)(28:35).eq.'AZIMUTH:'.and.data(i)(80:80).eq.'3') 
     *      then
               read(data(i)(36:45),'(f10.1)') azimuth(istat)
               read(data(i)(56:65),'(f10.1)') backazi(istat)
            endif
         enddo
      enddo
c
c   read if Radial-Transverse or North-East components 
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: COMPON-:') then
            radial=.false.
            if  (data(i)(20:25).eq.'RADIAL')  radial=.true.
         endif
      enddo
c
c   find source depth 
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: DEPTH--:') then
            read(data(i)(16:25),'(f10.1)') sdepth
c
c   if depth zero, stop
c
         if(sdepth.eq.0) then
            write(6,*)' Depth zero not allowed'
            stop
         endif
         endif
      enddo
c
c   get strike slip and dip         
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: ST-D-RK:') then
            read(data(i),'(15x,3(f10.1))') strike,dip,rake
         endif
      enddo
c
c   total duration of the plot window (the plot starts at the smallest
c         initial time of the synthetics)
c   origin time for the seismogram at the smallest epicentral distance 
c   duration of the time window at each station              
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: TIMES--:') then
            read(data(i),'(15x,3(10x,f10.1))') time,t0,twind
         endif
       enddo
c
c   find out if the station is at the free surface 
c     (by specifying that the station is NOT at the free surface, you will
c      modify the amplitudes of the respective phases, but you will also
c      take away some of the "free surface head waves". This option has
c      therefore mainly be put here so that you may check on a "free surface
c      seismogram" which phases are "free surface head waves".
c
      freesf=.true.
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: STAT-AT:') then
            if (data(i)(16:25).eq.'NOT FREE  ') freesf=.false.
            if (data(i)(16:25).eq.' NOT FREE ') freesf=.false.
            if (data(i)(16:25).eq.'  NOT FREE') freesf=.false.
            if (data(i)(16:25).eq.'not free  ') freesf=.false.
            if (data(i)(16:25).eq.' not free ') freesf=.false.
            if (data(i)(16:25).eq.'  not free') freesf=.false.
         endif
      enddo
	  if(.not.freesf)write(6,*)' No free surface used ************'
c
c   phases to be synthesized with WKBJ
c
      nphas=0
      npline=6
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: PHASES-:') then
            read(data(i),'(15x,6(6x,a4))')
     &               (codfsi(j),j=nphas+1,nphas+npline)
            do j=nphas+1,nphas+npline
              if(codfsi(j).eq.'    ')  then
                nphas=j-1
                goto 190
              endif
            enddo
            nphas=nphas+npline
 190        continue
         endif
      enddo
      write(6,*)' Number of phases to model: ',nphas
c
c      sampling interval, half-duration of the source 
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: DT-Tsou:') then
            read(data(i),'(15x,2f10.3)') dtt,halfdur
         endif
      enddo
c
c   reduction velocity 
c
      do i=1,ndata
         if(data(i)(2:15).eq.'SYNT: REDVELO:') then
            read(data(i),'(15x,f10.3)') redvel
         endif
      enddo
c
c----------------------------  WRITING OUT PARAMETERS  --------------
c
c
c   open WKBJ input file
c
      open(2,file='wkbj.inp',status='unknown')
c
c   looking for the Moho
c
      nmoho=0
      do i=1,kl
        if(comoho(i).eq.'N')  nmoho=i
      enddo
      if(nmoho.eq.0) stop 'Moho not defined'
C
c   find where the source is in the model 
c   find in which layer or on which real interface 
c   label the possibly dummy interface corresponding to the source
c
         y=0.0
         do i=1,kl-1
           y=y+thick(i)
c    if the source is inside a  layer
           if((y-sdepth).gt.0.001) then
              isrc=i
              iints=i+1
              goto 180
           endif
c    if the source is on a real interface
           if(abs(y-sdepth).le.0.001) then
              isrc=0
              iints=i+1
              goto 180
           endif
         enddo
c    if the source is under the last interface
         if(sdepth.gt.y) then
            isrc=kl
            iints=kl+1
            goto 180
         endif
         stop 'problem with source depth '
 180     continue
c
c   writing information on the model :
c
c   first write:
c   2 reading units in wkbj.f for model and phase data
c   code for interpolation law in layers (2=linear)
c   number of depth points in model
c   F for flat model, F for depth axis positive downwards, dummy radius
c
      inunit=2
      logic=.false.
      nl=2*(kl-1)+1
      if (isrc.ne.0) nl=nl+2
      write (2,1001) inunit,inunit,2,nl,logic,logic,6371.
c
c   writing the model with depth:
c
      dep=0.
      index=0
      do i=1,kl-1
        write (2,1002) dep, alp1(i),bet1(i),rho1(i)
        if (isrc.eq.i)  then
          write (2,1002) sdepth, alp1(i),bet1(i),rho1(i)
          write (2,1002) sdepth, alp1(i),bet1(i),rho1(i)
        endif
        dep= dep+thick(i)
        write (2,1002) dep, alp1(i),bet1(i),rho1(i)
      enddo
      write(2,1002) dep, alp1(kl),bet1(kl),rho1(kl)
      if (iints.gt.kl)  then
        write (2,1002) sdepth,alp1(kl),bet1(kl),rho1(kl)
        write (2,1002) sdepth,alp1(kl),bet1(kl),rho1(kl)
      endif
c
c  -------------- make the two input lines for each phase
c
      do ip=1,nphas
c
c   look if the phase is in the catalogue of phases, and associate indexes
c
        do j=1,24
          if (codfsi(ip).eq.catfas(j))  then
            codfas(ip)=codfsi(ip)
            jp=j
            imoho0(ip)=nmoho
            goto 210
          endif
        enddo
        do j=1,24
          if (codfsi(ip)(1:2).eq.catfas(j)(1:2).and.
     &        codfsi(ip)(4:4).eq.catfas(j)(4:4))  then
            codfas(ip)=catfas(j) 
            jp=j
            read  (codfsi(ip)(3:3),'(i1)') imoho0(ip)
            if (imoho0(ip).gt.(kl-1)) then
              write (*,'(a,i1,a,a)') ' no interface ',imoho0(ip),
     &         ' in this model; will skip ',codfsi(ip)
              codfsi(ip)='    '
              goto 299
            endif
c            add one because free surface = interface 1 in the routines
            imoho0(ip) = imoho0(ip)+1
            goto 210
          endif
        enddo
        write (*,'(1x,a,a)') codfsi(ip),
     *' does not exist in the catalogue'
        codfsi(ip)='    '
        go to 299
 210    continue
        jp2= mod((jp-1),2)+1
        jp8= mod((jp-1),8)+1
        jdep=int((jp-1)/8)
c
c   prepare code for the wave type at the source
c
        if (jp8.eq.1) ksou=5
        if (jp8.eq.2) ksou=6
        if (jp8.eq.5.or.jp8.eq.8) ksou=1
        if (jp8.eq.6.or.jp8.eq.7) ksou=2
        if (jdep.eq.1) ksou=5
        if (jdep.eq.2) ksou=6
c
c   prepare indexes for the reflective interface
c   index shifts if there is a dummy interface at the source 
c   indexes at the source and around the Moho for calculating the slownesses
c
        imoho=imoho0(ip)
        if (isrc.ne.0.and.isrc.lt.imoho) imoho=imoho+1
c
c         if the source is under the interface, PmP etc... impossible
        if (jp8.gt.4.and.iints.ge.imoho)  then
          write (*,'(1x,a,a)') codfsi(ip),' impossible for that source'
          codfsi(ip)='    '
          goto 299
        endif
c
        jsourc=2*(iints-1)
        if (ksou.le.2) jsourc=jsourc+1
        jmoho0=2*(imoho-1)
        jmoho1=jmoho0+1
c
c   prepare code for the 2 first interfaces if P or S wave at the receiver
c            and wavetype at the receiver
c
        k=1
        idx(k,1)=1
        if (jp2.eq.1)  then 
          krec=9
          if (.not.freesf) krec=1
          chain='10 0000000000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if (jp2.eq.2)  then 
          krec=10
          if (.not.freesf) krec=2
          chain='01 0000000000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
c
        if (iints.gt.2)  then
          k=k+1
          idx(k,1)=2
          if (jp2.eq.1)  then 
            chain='10 0100000000'
            read (chain,1020) (idx(k,j),j=2,13)
          endif
          if (jp2.eq.2)  then 
            chain='01 0000100000'
            read (chain,1020) (idx(k,j),j=2,13)
          endif
        endif
c
c   prepare code for the interface at the source
c
        k=k+1
        idx(k,1)=iints
        if (jp8.eq.1.or.jp8.eq.2)  then
          chain='00 0000000000'
          read (chain,1020) (idx(k,j),j=2,13)
          goto 239
        endif
        if (jp8.eq.5)  then
          chain='20 0100000000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if (jp8.eq.6)  then
          chain='02 0000100000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if (jp8.eq.7)              then
          chain='11 0100000000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if (jp8.eq.8)              then
          chain='11 0000100000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
c
c   prepare code for the interface below the source
c
        if (jp8.eq.5.and.(iints+1).ne.imoho)  then
          k=k+1
          idx(k,1)=iints+1
          chain='20 0200000000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if (jp8.eq.6.and.(iints+1).ne.imoho)  then
          k=k+1
          idx(k,1)=iints+1
          chain='02 0000200000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if ((jp8.eq.7.or.jp8.eq.8).and.(iints+1).ne.imoho)  then
          k=k+1
          idx(k,1)=iints+1
          chain='11 0100100000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
c
c   prepare code for the last interface
c
        k=k+1
        idx(k,1)=imoho
        if (jp8.eq.5)  then
          chain='00 1000000000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if (jp8.eq.6)  then
          chain='00 0001000000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
        if (jp8.eq.7.or.jp8.eq.8)  then
          chain='00 0000001000'
          read (chain,1020) (idx(k,j),j=2,13)
        endif
c
 239    continue
c
c    add elements on the first two lines in case of depth phases
c
        if (jdep.eq.0) goto 249
c
c  pS or sP type
        chain='11 0000000001'
        chain2='11 0100100000'
c  pP type - interface 1
        if (jdep.eq.1.and.(jp8.eq.3.or.jp8.eq.5.or.jp8.eq.8)) then
          chain='20 0010000000'
          chain2='20 0200000000'
        endif
c  sS type - interface 1
        if (jdep.eq.2.and.(jp8.eq.4.or.jp8.eq.6.or.jp8.eq.7)) then
          chain='02 0000010000'
          chain2='02 0000200000'
        endif
        read (chain,1020) (idx2(j),j=2,13)
        do j=2,13
          idx(1,j)=idx(1,j)+idx2(j)
        enddo
        read (chain2,1020) (idx2(j),j=2,13)
        if (iints.gt.2)  then 
          do j=2,13
            idx(2,j)=idx(2,j)+idx2(j)
          enddo
        endif
c
c   add a transmission on line iints in case of depth phases
c
        do j=2,k-1
          if(idx(j,1).eq.iints)  ij=j
        enddo
        if (jp8.eq.3.or.jp8.eq.5.or.jp8.eq.8) chain='00 0100000000'
        if (jp8.eq.4.or.jp8.eq.6.or.jp8.eq.7) chain='00 0000100000'
        read (chain,1020) (idx2(j),j=2,13)
        do j=2,13
          idx(ij,j)=idx(ij,j)+idx2(j)
        enddo
c
c   if it exists, supress line iints+1, and shifts in k the last interface
c            in case of depth phases
c
        if ((ij+1).ne.k) then
          do j=1,13
            idx(k-1,j) = idx(k,j)
          enddo
          k=k-1
        endif
c
 249    continue
c
c   write out the final code for the phase
c
        logic=.true.
        write(2,1005) logic,idx(k,1),1,ksou,krec,
     &                       ((idx(l,j),j=1,13),l=1,k)
c
c   calculate the slowness range for the phase
c
        npp=200
c.................. P
        if (jp8.eq.1)
     &   write(2,1004) npp,1,jsourc,0,0,1,jsourc,1,jsourc,0.,0.,0.
c.................. S
        if (jp8.eq.2) then
          if(alp1(1).le.bet1(iints-1)) then 
         write(2,1004) npp,1,jsourc,0,0,2,jsourc,2,jsourc,0.,0.,0.
         else
         write(2,1004) npp,1,jsourc,0,0,1,     1,2,jsourc,0.,0.,0.
        endif
       endif
c.................. PmP
        if (jp8.eq.5) 
     &   write(2,1004) npp,1,jsourc,0,0,1,jmoho1,1,jmoho0,0.,0.,0.
c.................. SmS
        if (jp8.eq.6)  then
          write(2,1004) npp,1,jsourc,0,0,1,jmoho1,1,jmoho0,0.,0.,0.
          write(2,1005) logic,idx(k,1),1,ksou,krec,
     &                       ((idx(l,j),j=1,13),l=1,k)
          ii1=2
          jj1=jmoho1
          ii2=2
          jj2=jmoho0
          if (jdep.eq.1)  then
            if (alp1(iints-1).gt.bet1(imoho0(ip)-1))  then
              ii2=1
              jj2=jsourc
              if (alp1(iints-1).gt.bet1(imoho0(ip)))  then
                ii1=1
                jj1=jsourc
              endif
            endif
          endif
          write(2,1004) npp,1,jsourc,1,jmoho0,ii1,jj1,ii2,jj2,0.,0.,0.
        endif
c.................. SmP
        if (jp8.eq.7)  then 
          write(2,1004) npp,1,jsourc,0,0,1,jmoho1,1,jmoho0,0.,0.,0.
        endif
c.................. PmS
        if (jp8.eq.8)   then
          write(2,1004) npp,1,jsourc,0,0,1,jmoho1,1,jmoho0,0.,0.,0.
        endif
c       
 299    continue
      enddo
      write(2,1005) logic,0
c
c   -------------- distances, origin time, sampling intervals etc.
c
c  Calculate the number of points per seismogram (max=nnptst)
c
      npts=int(twind/dtt) + 1
      if (npts.gt.nnptst) stop ' Not enough dimension in time'
C
C  Look for the smallest epicentral distance and calculate the starting times
C
      epi0=distance(1)
      do  i=2,nstat
        epi0=amin1(epi0,distance(i))
      enddo
      if (redvel.eq.0.)  then
      do  i=1,nstat
        t0synt(i) = t0
      enddo
      else
      do  i=1,nstat
        t0synt(i) = t0+(distance(i)-epi0)/redvel
      enddo
      endif
c
      write (2,1006) nstat,(distance(istat),istat=1,nstat)
      write (2,1007) (t0synt(istat),istat=1,nstat)
      write (2,1008) dtt,npts

      close (2)
 1001 format (3I2,I4,2L2,F10.2)
 1002 format (4F10.5)
 1006 format (i2,10f7.1)
 1007 format (10f7.2)
 1008 format (F8.2,I4)
 1004 format (3I4,3(I2,I4),3F10.5)
 1005 format (L1,I3,3I2,5(I2,12I1))
c removed $ after last a, lo
 1010 format (a,f5.1,a,i2,a)   
 1020 format (2i1,1x,10i1)
c
c----------------------------  EXECUTION OF THE WKBJ PROGRAM  -----

c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
      call systemc ('wkbj_or',7)
      write (*,*) ' wkbj executed '
c
c   open input file with synthetics
c
      open(4,file='wkbj.out',status='old')
c
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
c----------------------------  CALCULATING THE ARRIVAL TIMES  -----
c
      open (3,file='wkbj.tab',status='old')
c
c   read seism origin time
c
      read(data(1),'(1x,i4,1x,2i2,1x,2i2,f5.1)')

     *oyear,omonth,oday,ohour,omin,osec
c
c   get seism origin time in secs
c
      call timsec(oyear,omonth,oday,ohour,omin,osec,otime)
c
c
c   write header in output file
c
      write(16,'(1x,i4,1x,2i2,11x,a1,57x,a1)')
     *oyear,omonth,oday,'L','1'

      do istat=1,nstat
        epi=distance(istat)
        write (*,1031) stat(istat),epi
        rewind(3)
        do iphas=1,nphas
          if (codfsi(iphas).eq.'    ') goto 398
c
c    prepare elements for head waves Pn, Sn, etc..
c
          pcrit=0.
          if (codfas(iphas)(2:4).eq.'PmP') then
            pcrit=1./alp1(imoho0(iphas))
            codhed='Pn '
            if (codfas(iphas).ne.codfsi(iphas)) 
     &                         codhed(3:3)=codfsi(iphas)(3:3)
          endif
          if (codfas(iphas)(2:4).eq.'SmS') then
            pcrit=1./bet1(imoho0(iphas))
            codhed='Sn '
            if (codfas(iphas).ne.codfsi(iphas)) 
     &                         codhed(3:3)=codfsi(iphas)(3:3)
          endif
c
          iray=0
 301      continue
          iray=iray+1
 302      continue
          read (3,'(a2)',end=399) cbid
          if (cbid.ne.'0P')  goto 302
          read(3,1030) pp2,time2,epi2
          do ip=2,npp
            pp1=pp2
            time1=time2
            epi1=epi2
            read(3,1030) pp2,time2,epi2
c
c    head wave
c
            if (pcrit.ne.0.)  then
              if(pp1.le.pcrit.and.pp2.ge.pcrit)  then
                tcrit=time1+(time2-time1)*(pcrit-pp1)/(pp2-pp1)
                xcrit= epi1+( epi2- epi1)*(pcrit-pp1)/(pp2-pp1)
                if (epi.ge.xcrit)   then
                  tt = tcrit + (epi-xcrit)*pcrit
                  write( *,1032) codfas(iphas)(1:1)//codhed,tt
                  ptime = otime + tt   ! phase arrival time
                  call sectim          ! phase arrival time in day m hr etc
     *            (ptime,oyear,odoy,omonth,oday,ohour,omin,osec)
                  coiasp='y'//codfas(iphas)(1:1)//codhed
                  if (codfas(iphas)(1:1).eq.' ') coiasp='y'//codhed//' '
                  write(16,222)stat(istat),'  ',coiasp,
     +            ohour,omin,osec
222               format(1x,a5,a2,1x,a5,4x,i2,i2,1x,f5.2)
                endif
              endif
            endif
c
c    "normal" wave
c
            if ((epi1.le.epi.and.epi2.ge.epi).or.
     &          (epi2.le.epi.and.epi1.ge.epi))   then
              call interpo(epi1,pp1,time1,epi2,pp2,time2,epi,pp,tt)
              write ( *,1032) codfsi(iphas),tt
                  ptime = otime + tt   ! phase arrival time
                  call sectim          ! phase arrival time in day m hr etc
     *            (ptime,oyear,odoy,omonth,oday,ohour,omin,osec)
                  coiasp='y'//codfsi(iphas)
                  if (codfsi(iphas)(1:1).eq.' ') 
     &                      coiasp='y'//codfsi(iphas)(2:4)//' '
                  if (codfsi(iphas)(1:2).eq.'  ') 
     &                      coiasp='y'//codfsi(iphas)(3:4)//'  '
                  write(16,223)stat(istat),'  ',coiasp,
     +            ohour,omin,osec
223               format(1x,a5,a2,1x,a5,4x,i2,i2,1x,f5.2)
            endif
          enddo
          if(codfas(iphas)(2:4).eq.'SmS'.and.iray.eq.1)   goto 301
 398      continue
        enddo
 399    continue
      enddo
      close(3)
 1030 format(G13.5,2F15.4)
 1031 format(1x,a4,' (',f6.1,'km) arrival times: ')
 1032 format(30x,a4,'  ',f8.2)
c
c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c
c----------------  COMBINING GREEN FUNCTIONS WITH SOURCE ELEMENTS  ------- 
c
c   making the time series for the source rate function
c    (a triangle with half-duration halfdur, sampled from its onset time)
c
      read (4,*) i,dd,k,tst,dt,nt
      rewind(4)
      if (halfdur.le.dt)   goto 410 
      ns0= int(halfdur/dt)
      do i=1,ns0+1
        ss(i)=(i-1)*dt/halfdur
      enddo
      do i=ns0+2,2*ns0+2
        ss0 = 2.-float(i-1)*dt/halfdur
        if (ss0.lt.0.)  goto 410
        nss=i
        ss(i)=ss0
      enddo
 410  continue
c
c  open scratch file for writing the seismograms 
c
      open(20,status='scratch')
c
      do istat=1,nstat
c
c   reading the Green functions for the current epicentral distance
c
        do igr=1,13
          read (4,*) i,dd,k,tst,dt,nt,smaxx
          if (dd.ne.distance(istat)) 
     &            stop 'problem in the ordering of the Green functions'
          if (k.ne.igr)  stop 'problem in reading the Green functions'
          read (4,*) (green(igr,it),it=1,nt)
        enddo
c
c   calculating the moment tensor in case of an explosion 
c        (coded with all angles =0. in strike-dip-rake)
c
        if (strike.eq.0..and.dip.eq.0..and.rake.eq.0.) then
           em11=1.
           em22=1.
           em33=1.
           em12=0.
           em23=0.
           em13=0.
        else
c
c   calculating the moment tensor for the current azimuth
c         see box 4.4 in Aki and Richards for formulae 
c         + sign change on m13 and m23 due to z-upwards here
c
          stra=(strike-azimuth(istat))*pi/180.
          dipa=dip*pi/180.
          raka=rake*pi/180.
          sind=sin(dipa)
          cosd=cos(dipa)
          sin2d=2.*sind*cosd
          cos2d=cosd**2-sind**2
          sinr=sin(raka)
          cosr=cos(raka)
          sins=sin(stra)
          coss=cos(stra)
          sin2s=2.*sins*coss
          cos2s=coss**2-sins**2
c
          em11=-sind*cosr*sin2s-sin2d*sinr*sins**2
          em12=sind*cosr*cos2s+.5*sin2d*sinr*sin2s
          em13=-(-cosd*cosr*coss-cos2d*sinr*sins)
          em22=sind*cosr*sin2s-sin2d*sinr*coss**2
          em23=-(-cosd*cosr*sins+cos2d*sinr*coss)
          em33=sin2d*sinr
c
        endif
c
c   combine moment tensor with Green functions
c
        do ic=1,3
c         write (8,1050) ic,dd,tst,dt,nt
          if (ic.eq.1) then
           do it=1,nt
            temp(it)=
     &         em33*green(4,it)+em11*green(5,it)+2.*em13*green(6,it)
           enddo
          endif
          if (ic.eq.2) then
           do it=1,nt
            temp(it)=
     &         em33*green(1,it)+em11*green(2,it)+2.*em13*green(3,it)
           enddo
          endif
          if (ic.eq.3) then
           do it=1,nt
            temp(it)= em12*green(11,it)+em23*green(12,it)
           enddo
          endif
c
c   convolve with the source time function
c
          amoment=1.0e12
          if (halfdur.le.dt)    then
            do it=1,nt
              sismo(ic,it)=temp(it)*amoment
            enddo
          else
            do it=1,nt
              sismo(ic,it)=0.
              do j=1,min0(it,nss)
                sismo(ic,it)=sismo(ic,it)+ss(j)*temp(it+1-j)*amoment
              enddo
            enddo
          endif

c         write (8,1051) (sismo(ic,it),it=1,nt)
        enddo
c
c   write data in output file, identify stations and channels
c
        write(20,'(a5,a4)')stat(istat),'   Z'
        write(20,*)(sismo(1,i),i=1,nt)
c
        if (radial)   then
c   write the radial and transverse components
          write(20,'(a5,a4)')stat(istat),'   R'
          write(20,*)(sismo(2,i),i=1,nt)
          write(20,'(a5,a4)')stat(istat),'   T'
          write(20,*)(sismo(3,i),i=1,nt)
        else
c   rotate to North-East components, and write down
c   (note component 1 used as a buffer for component 2)
          cosb=cos(backazi(istat)*3.14159/180.)
          sinb=sin(backazi(istat)*3.14159/180.)
          do i=1,nt
            sismo(1,i)=-cosb*sismo(2,i)+sinb*sismo(3,i)
            sismo(3,i)=-sinb*sismo(2,i)-cosb*sismo(3,i)
          enddo
          write(20,'(a5,a4)')stat(istat),'   N'
          write(20,*)(sismo(1,i),i=1,nt)
          write(20,'(a5,a4)')stat(istat),'   E'
          write(20,*)(sismo(3,i),i=1,nt)
        endif
c
      enddo
c
      window=time
      call syntsel(data,ndata,t0,window,t0synt,dtt,npts,'SW ')
c
 1050 format (i3,f8.2,f15.4,g13.5,i5)
 1051 format (5g13.5)
      close (1)
      stop
c     return
      end
c********************************************************************
      subroutine interpo(x1,p1,t1,x2,p2,t2,x,p,t)
c
c     interpolate in x the function t(x),
c     given the function and its derivative p(x)
c     at two points x1 and x2
c
      dx=x2-x1
      y1=p1*dx
      y2=p2*dx
c
      a =-2.*(t2-t1) +y1 +y2
      b = 3.*(t2-t1) -2.*y1 -y2
      c = y1
      d = t1
c
      xn=(x-x1)/(x2-x1)
      t = xn*(xn*(xn*a + b) +c) +d
      p = xn*(xn*3.*a/dx + 2.*b/dx) + c/dx
c
      return
      end

c
c  convert mars88 files to seisan format
c
c  j. havskov, sep, 93
c
c
c  Testdata and help was provided by Dieter Stoll at Lennartz
c
c  updates:
c  oct 93   by jh: sun version
c  nov 97        : take gain ranging into account and a few other things
c  jan 23 98     : correct error,response file check from header 1040 to 160
c  april 7 98    : --------------   version 7 changes ----------------------
c                  new general structure
c  jun 11 99     : serial number was not put in for station name
c  jun 13     lo : changed routine intand
c  may 11  00 lo : use read_resp_head
c  mar 23  01 jh : if straight 16 bit data, divide by 2**16 and write as
c                  2 byte integers
c  feb 03  03 jh : commen tout intand, now in compdecomp
c
c  This program can handle a maximum of 3 channels and max_sample samples.
c  Output is always 2 or 4 byte integers so remember scaling factor.
c  Gain and time correction is not accounted for.
c
c  Mars88 channel 0 is one, 1 is 2 and 2 is 3 in the output. Channel
c  1, 2 and 3 is also used in channel definition file, NOT 0....
c
c  Gain ranging:
c  
c  In each block, the variable data format (byte 4) has value 0, 1, 2 or 3
c  Correspondingly 0, 2, 3, or 4 of the lowest bytes in data word is used
c  for gain and the correspondign mantissa is 16, 14, 13 or 12 bytes long.
c  The gain exponent is extracted by using an and between an integer 
c  representing 0 to 4 bytes. If e.g. 3 bytes are used, the masking
c  number is 7=(111) in binary. The mantissa is extracted by dividing
c  the sample with 2**exp. In above example with 3 bytes used, the division is
c  by 8. The final sample is constructed by mantissa * 2 **(16-gain exponent).
c
c  If straigt 16 bit data is used, numbers are divived by 65536 so scaling
c  factor is different for straight 16 bit and gain ranged data (changed
c  march 23, 2001)
c

      implicit none
c-- output data vector
      include 'libsei.inc'
      include 'seidim.inc'
      integer*4  data(3,max_sample)
      integer*2  data2(max_sample)
c
c   block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
ccccccccccccccccccccccccccccccccccccc  end

      integer*4  data4
c-- one file block
      integer*2 block_data(512)
      character*1024 block
       integer doy   ! day of year
c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
	  integer i,nblock,k,l,nrec
c-- computer type
      logical pc,sun,linux	  
c--------------------------- specific lennartz 
c-- data format
       integer data_format
       character*1 c_data_format
c-- current channel in block
       integer block_channel
       character*1 c_block_channel
c-- log2 sample rate
       integer log2rate
       character*1 c_log2rate
c-- channel order in block
       integer bchan(3)
c-- scale
       integer scale
       character*1 c_scale
       integer first_rec       ! first useful block to use
       integer m(3)            ! number of samples, 3 channels
c-- time since 1970 for start of block
       integer itime
       double precision sec70
c-- help for swap
       character*4 xs
       character*1 xx
       integer ixs
       integer exp       ! exponent from format
       integer exp_mask  ! mask to extract data value exponent
       integer mantissa  ! mantissa of one sample
       integer exp_sample! exponent one sample
       logical s16bit    ! true if straight 16 bit
c
c-- serial numbers
c
      integer*2 is_number
      integer*2 delay             ! time delay in milliseconds 
      character*5 s_number        ! seriel number of current station
c
       equivalence (block,block_data)
       equivalence (block(4:4),c_data_format)
       equivalence (block(9:12),itime)
       equivalence (block(13:14),delay)
       equivalence (block(17:17),c_block_channel)
       equivalence (block(18:18),c_log2rate) 
       equivalence (block(21:21),c_scale) 
       equivalence (block(5:6),is_number)
       equivalence (ixs,xs)


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       call read_def_chan('m88sei.def',mainhead_text,net_code)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old',access='direct',recl=1024)
c
c   read first 3 blocks to get start time etc
c
       nrec=1
       s16bit=.true.   ! initially assume straight 16 bit
c
 1     continue
       read(1,rec=nrec,err=99) block
c
c   check if a setup block, channel number is then 15, skip block
c
       if(sun) then
          xs(4:4)=c_block_channel
       else
          xs(1:1)=c_block_channel
       endif
       block_channel=ixs
       if(block_channel.eq.15) then
          nrec=nrec+1
          goto 1
       endif
c
       bchan(1)=block_channel

c
c   find time in year month etc from 1900 to 1970
c
       call TIMSEC (1969,12,31,23,60,0.0,sec70)
c
c   byte swap itime, delay and seriel number
c
       if(sun) then
          xs(1:1)=block(12:12)
          xs(2:2)=block(11:11)
          xs(3:3)=block(10:10)
          xs(4:4)=block(9:9)
          block(9:12)=xs
c-- serial number
          xs(1:1)=block(5:5)
          block(5:5)=block(6:6)
          block(6:6)=xs(1:1)
c-- delay
          xs(1:1)=block(13:13)
          block(13:13)=block(14:14)
          block(14:14)=xs(1:1)
       endif
c
       sec70=sec70+itime   ! add time since 1970
       call sectim (sec70,year(1),doy,
     * month(1),day(1),hour(1),min(1),sec(1))
       write(6,*) year(1),month(1),day(1),hour(1),min(1),sec(1)
c
c   assume same start time for 3 possible channels
c
       year(2)=year(1)
       year(3)=year(1)
       month(2)=month(1)
       month(3)=month(1)
       day(2)=day(1)
       day(3)=day(1)
       hour(2)=hour(1)
       hour(3)=hour(1)
       min(2)=min(1)
       min(3)=min(1)
       sec(2)=sec(1)
       sec(3)=sec(1)
c
c  get one byte integers, do byte swapping
c
       do i=1,4
         xs(i:i)=char(0)
       enddo
c
       if(sun) then
          xs(4:4)=c_log2rate
       else
          xs(1:1)=c_log2rate
       endif
       log2rate=ixs
c
c   scale
c
       do i=1,4
         xs(i:i)=char(0)
       enddo
       if(sun) then
          xs(4:4)=c_scale
       else
          xs(1:1)=c_scale
       endif
       scale=ixs
 
       write(6,*)'Log2rate',log2rate
       write(6,*)'Data format ',data_format
       write(6,*)'Time delay in ms',delay
       write(6,*)'Log2scale ', scale
c
c-- get seriel number, find corresponding code if defined
c   else use seriel number padded with 0, assume max 4 digits
c
       s_number=' '
       write(6,*)'Seriel number',is_number
       write(s_number(1:5),'(i5)')is_number
       stat(1)=s_number
       do i=1,5
          if(stat(1)(i:i).eq.' ') stat(1)(i:i)='0'
       enddo			 	   	   	    
c
c   read next two blocks to see how many channels are available, assume a
c   maximum of 3
c
      nrec=nrec+1
      read(1,rec=nrec,err=99) block
      if(sun) then
	     xs(4:4)=c_block_channel   ! byte swapping
      else
         xs(1:1)=c_block_channel
      endif
      block_channel=ixs
      bchan(2)=block_channel
      nrec=nrec+1
      read(1,rec=nrec,err=99) block
      if(sun) then
         xs(4:4)=c_block_channel
      else
         xs(1:1)=c_block_channel
      endif
      block_channel=ixs
      bchan(3)=block_channel
      if(bchan(1).eq.bchan(2).and.bchan(2).eq.bchan(3)) nchan=1
      if(bchan(1).ne.bchan(2).and.bchan(3).eq.bchan(1)) nchan=2
      if(bchan(1).ne.bchan(2).and.bchan(2).ne.bchan(3)) nchan=3
      write(6,*)'Channel order',bchan
      write(6,*)'Number of channels =',nchan
      rate(1)=1000.0/(2**log2rate)
c
c   assume same sample rate for 3 possible channels
c
      rate(2)=rate(1)
      rate(3)=rate(1)
c
c  save start record number
c
      first_rec=nrec-2
c
c   read whole file 
c
       do i=1,3
         m(i)=1
       enddo
       nrec=first_rec
c
c--------------------------------------------------------------
c  loop to read whole file
c--------------------------------------------------------------
c
 555   continue

       read(1,rec=nrec,err=600) block
       nrec=nrec+1
c
c  find channel number since channels can be in any order !!!!
c
       if(sun) then
          xs(4:4)=c_block_channel
       else
          xs(1:1)=c_block_channel
       endif
       block_channel=ixs
c
c  if channel is 15, skip since setup block
c
       if(block_channel.eq.15) goto 555
c      write(6,*) block_channel
c
c   find format
c
       if(sun) then 
          xs(4:4)=c_data_format
       else
          xs(1:1)=c_data_format
       endif
c
       data_format=ixs
       if(data_format.eq.0) exp=0
       if(data_format.gt.0) exp=data_format+1
       exp_mask=2**exp-1    ! value to mask with to get exponenet
c
c   do byte swapping if on sun
c
       if(sun) then
          do k=25,1024,2
            xx=block(k:k)
            block(k:k)=block(k+1:k+1)
            block(k+1:k+1)=xx
          enddo
       endif
c
       do l=1,500
c
c   correct each sample for exponent 
c
c
c   new from march 27, 2001: find if exponenet always is 0 indicating
c                            straight 16 bit data, if so divide by
c                            65536
c
          data4=block_data(l+12)
          call intand(data4,exp_mask,exp_sample)  ! exponent one sample
          if(exp_sample.gt.0) s16bit=.false.
          mantissa=data4/(exp_mask+1)             ! get mantissa
          data(block_channel+1,m(block_channel+1))=
     *    mantissa*2**(16-exp_sample)     ! calculate sample                      
          m(block_channel+1)=m(block_channel+1)+1
          if(m(block_channel+1).gt.max_sample)  goto 600
       enddo
c
c   get next block
c
       goto 555
c
c   whole file read
c
 600   continue
       if(s16bit) then
          write(6,*)' Straight 16 bit data'
       else
         write(6,*)' Gain ranged data'
       endif

       nblock=nrec-1
c
       nsamp(1)=(nblock/nchan)*500
       write(6,*)'Number of samples',nsamp(1)
       if(nsamp(1).gt.max_sample) then
            nsamp(1)=max_sample
            write(6,*)' Number of samples has been cut to',max_sample
            nblock=nsamp(1)/(500*nchan)
       endif
c
c   assume same number of samples for 3 possible channels
c
       nsamp(2)=nsamp(1)
       nsamp(3)=nsamp(1)
c
c   assume components in case no def file
c
       comp(1)='S  Z'
       comp(2)='S  N'
       comp(3)='S  E'
c
c   2 or 4 byte integers for data, all 3 possible channels
c
       if(.not.s16bit) then
          cbyte(1)='4'
          cbyte(2)='4'
          cbyte(3)='4'
       else
          cbyte(1)='2'
          cbyte(2)='2'
          cbyte(3)='2'
       endif

c
c   assume same stations initially
c  
        stat(2)=stat(1)
        stat(3)=stat(1)

c
c  enter loop to define channels if a def file
c
       do ichan=1,nchan
         call set_def_chan(ichan,stat(ichan),comp(ichan))
       enddo
c
c   make seisan headers
c
      ichan=1
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
c
c   ******** next write and rewind is to fix a problem ******
c   if not done, garbage will be insert between the first and 
c   second record, at least on some implementations
c
      mainhead(1)(2:29)=mainhead_text    ! put in header text
c     write(2)mainhead(i)
      write(2)mainhead(1)
      rewind(2)
      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo
C
C   enter channel  loop
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,
     *                    stat,comp,nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
c                                                                               
c   get response            
c                                                                               
         call read_resp_head(chahead)                      
c
c   write data
c
         write(2)chahead
c
c   truncate if only 16 bit
c
         if(s16bit) then
            do i=1,nsamp(ichan)
                data2(i)=data(ichan,i)/65535
            enddo
            write(2) (data2(i),i=1,nsamp(ichan))
         else
            write(2) (data(ichan,i),i=1,nsamp(ichan))
         endif
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  
C**********************************************************************
C                                                                     *
C      SUBROUTINE INTAND(I1,I2,I3)                                    *
C                                                                     *
C      SUBROUTINE BITWISE "ANDS" THE INTEGERS IN I1 AND I2            *
C      AND RETURNS THE RESULT IN INTEGER I3                           *
C      FOR EXAMPLE                                                    *
C      IF THE 32 BITS IN I1 ARE 11001100 1110001110 11110000 11111111 *
C      AND IN I2 ARE            10101010 1100110011 00110011 00110011 *
C      I3 WILL BECOME           10001000 1100000010 00110000 00110011 *
C                                                                     *
C      NOTE "AND" IS NOT STANDARD FORTRAN 77 FUNCTION SO THIS IS A    *
C      MACHINE DEPENDANT SUBROUTINE                                   *
C**********************************************************************
C
c       SUBROUTINE INTAND(I1,I2,I3) 
c       INTEGER *4 I1,I2,I3
c       logical sun,pc,linux
c       call computer_type(sun,pc,linux)
COMPUTERTYPE
C##SUN## REMOVE COMMENT FROM NEXT LINE FOR SUN COMPUTERS
c          if(sun.or.linux) I3 = AND(I1,I2)
C##DEC## REMOVE COMMENT FROM NEXT LINE FOR PDP AND VAX COMPUTERS,+sun
c          if(sun.or.linux)I3 = JIAND(I1,I2)
C##IBM## REMOVE COMMENT FROM NEXT LINE FOR IBM PC'S (I THINK), now also sun !
c        if(pc)I3 = IAND(I1,I2)
c       RETURN
c       END
c

C--------------------------------------------------------------------
C Define the input and output files for HYPO71 and set the program in
C motion

c
c   changes:
c   
c  feb 3, 2003 jh  : had to comment out program statement on pc

c      program hypo71
	
      implicit none

      include '../INC/libsei.inc'          ! Library definitions & data defns.
      include '../INC/seidim.inc'          ! array dimensions
      include '../INC/seisan.inc'          ! 

      external sei open,                   ! File open handler.
     &         sei close                   ! & closure.
      integer  code,                       ! Condition.
     &         read1,                      ! Read unit1.
     &         write1                      ! Write unit1.

c---single event file name
      character*80 eventfile
c---phase readings array
      CHARACTER*80 DATA(2500)                                                  
c--- event type, indcator of explosion, indicator of fixing depth  
      character*1 typ,exp
c---agency for magnitude  
      character*3 agency
c---character strings for sorting option
      character*5 old_dist
      character*5 old_stat

c---number of header lines, records, stations in nordic file
      integer nstat,nphase,nhead,nrecord
c---id line indicator
      integer id
c--- 0: data base, 1: single file
      integer base
c---minimum number of stations to locate
      integer minstat
c---minimum number of phases to locate  
      integer minphase
c---number of layers in model
      integer nlayers
c---max number of arrivals in readings file
      integer narriv
      parameter (narriv=2000)
c---arrays for distance sorting option
      integer isort(narriv)
      integer ksort(narriv)
      integer lsort(narriv)

      integer hour,min
c-- program exit status
      integer status
c---counters
      integer i,j,k,l,m

c-- indicator if program is used in connection with EEV in seisan
      logical use_eev
c-- indicator if seisan data base present
      logical seisan
c---location indicator
      logical locate
      logical b_flag
      logical error
      logical output

c---model and location algorithm parameters
      real xnear,xfar,startz,vpvs
      real vel(100), z(100)
c---test parameters for location and magnitude calculation
      real test(200)
c---array containing epicentral distance to each station (used in sorting)
      real dlt(narriv)
      real sec

      common/readings/NSTAT,NPHASE,NHEAD,NRECORD,TYP,EXP,DATA,ID
      common/model/vel,z,nlayers,startz,xnear,xfar,vpvs


C
C    initialise...
C    =============
C
      code   = e_ok$                             ! Local condition.
      read1  = 0                                 ! & file units.
      write1 = 0                                 ! Ditto.
      status=0
      error=.false.
      
c
c   get seisan defaults
c
      call get_seisan_def

c
c   find if program will run from within EEV indicated by the presence of file
c   name in an enviromental variable
c
      call get_env_event(eventfile)

C
C   open data base input single event file and read it
c   set flag for single event nrecord= -1
c
      nrecord = -1
      call sei open( old$,	! Open old file (stop on error).
     &                  ' ',             ! No prompt.
     &                  eventfile, read1,! File & unit.
     &                  b_flag,          ! File exists? (n/a).
     &                  code )           ! Local condition (n/a).
      call indata(read1,nstat,nphase,nhead,nrecord,
     &               typ,exp,data,id)
      call sei close( close$, read1, code ) ! Close file (stop on error).


c
c  if type is E or P, fix depth to 0.0 km
c
      if(data(1)(23:23).eq.'P'.or.data(1)(23:23).eq.'E') then
         data(1)(39:44)='  0.0F'
      endif

      call make_hypo71_input(test,agency,error)
      if (error) then
         write(*,*) 'Error creating input file for HYPO71'
         status=1
         call exit_with_status(status)
      endif

c
c   check if disable location has been set on for this event, in which case
c   event is passed on with no modification to hyp71.out
c
      if(data(1)(45:45).eq.'*') then
         write(6,*)'Event flagged not to be located'
         goto 31                ! go to outputs
      endif

c
c  check if event has enough phases and stations and if it
c  should be located
c     
      minstat=test(79)
      if(minstat.lt.2) minstat=2
      minphase=test(80)
      if(minphase.lt.3) minphase=3

      if(nphase.lt.minphase.or.nstat.lt.minstat) then  
         write(6,291)typ,nstat,nphase
 291     format(1x,'TYPE',1x,a1,2x,'NSTAT=',i2,1x,'NPHASE=',i2,
     1'  NOT LOCATABLE') 
         if(nphase.lt.minphase) write(6,*)' Too few phases'
         if(nstat.lt.minstat) write(6,*) ' Too few stations'
         status=2
         call exit_with_status(status)
      endif
c
c   clear old parameters
c
      call clear_old(data,nhead,nrecord,agency)

      do i=nhead+1,nrecord
         data(i)(61:70)='          '
c
c   keep distance if coda is there, so that magnitude can be calculated
c   in case not enough data for a location
c
         if(data(i)(30:33).eq.'    ') data(i)(71:75)='     '
         data(i)(76:79)='    '

      enddo

c
c call the location routine. This is done using a system call
c since the hypo71 code uses units 5 and 6 for input and output
c The hypo71 code should be in its original form as
c previously used on the vax except it is now a program rather 
c than a subroutine
c

      call systemc("hypo71exe < hypo71.input > hypo71.output",40)

      call update_location(agency,error)
      if (error) then
         write(*,*) 'Error updating location'
         status=3
         call exit_with_status(3)
      endif
      
c
c   clear old magnitudes, except 3.
c
      data(1)(57:72)='                '
      if(data(1)(77:79).eq.agency) data(1)(72:79)=' '
C
c   calculate  magnitudes
C
      output=.false.
      call update_mag(data,nhead,nrecord,agency,test,output)


C
C
c  write normal output file, sort first if event has been located
C

c
c open output file which will contain the updated phase readings
c
      call sei open( unknown$,                ! Open hyp file.
     &               ' ',                     ! No prompt.
     &               'hypo71.out', write1,    ! File & unit.
     &               b_flag,                  ! File exists?.
     &               code )                   ! Condition (n/a).
c
c sort by distance if required
c
      if(test(71).ne.0.0)then
         do i=nhead+1,nrecord-1
            read(data(i)(71:75),'(f5.0)')dlt(i-nhead)
         end do

         call r4sort(nrecord-1-nhead,dlt,isort)
c
c   now sort so the distance sorted phase lines, for each group of
c   as in the original file
c
         old_dist=data(isort(1)+nhead)(71:75)
         old_stat=data(isort(1)+nhead)(2:6)
         k=0
         l=0
         do i=nhead+1,nrecord-1
            l=l+1
            read(data(isort(l)+nhead),'(18x,2i2,1x,f5.2)') hour,min,sec
            if(data(isort(l)+nhead)(71:75).eq.old_dist.and.
     *           data(isort(l)+nhead)(2:6).eq.old_stat) then 
               k=k+1
               lsort(k)=isort(l)
               dlt(k)=sec+min*60+hour*3600
               if(i.ne.nrecord-1) goto 73 ! at the end, always sort what is left
               l=l+1                      ! since this is last value
            endif
c
c   if here, new distance or station or last group
c
            if(k.gt.1) then
               call r4sort(k,dlt,ksort)
               m=1
               do j=l-k,l-1
                  isort(j)=lsort(ksort(m))
                  m=m+1
               enddo 
            endif
            if(i.eq.nrecord-1) goto 73
            old_dist=data(isort(l)+nhead)(71:75)
            old_stat=data(isort(l)+nhead)(2:6)
            k=1                 ! this is the first of the next group
            dlt(k)=sec+min*60+hour*3600
            lsort(k)=isort(l)
 73         continue
         enddo

c
c   write out
c
         do i=1,nhead
            write(write1,'(a80)',iostat=code) data(i)
            call sei code(fort$,code,write1,b_flag) ! process outcome.
         enddo 

         do i=nhead+1,nrecord-1
            write(write1,'(a80)',iostat=code)
     &           data(isort(i-nhead)+nhead)
            call sei code(fort$,code,write1,b_flag) ! process outcome.
         end do          

         write(write1,'(a80)',iostat=code) data(nrecord)
         call sei code(fort$,code,write1,b_flag) ! process outcome.
      else
         write(write1,'(a80)',iostat=code)
     &        (data(i),i=1,nrecord)
         call sei code(fort$,code,write1,b_flag) ! process outcome.
      endif    

c
c close output file
c
      call sei close( close$, write1, code ) ! Close file (stop on error).

c
c create the summary file, hypo71.brief, from hypo71.output file
c this subroutine was copied from the vax with some minor changes.
c
      call make_hypo71_brief(data,nhead,nrecord,error)
      if (error) then
         write(*,*) 'Error creating hypo71.brief'
         status=4
         call exit_with_status(status)
      endif

 31   continue

      if(.not.error) then
         write(*,*) 'HYPO71 completed successfully'
         status=0
         call exit_with_status(status)
      else
         write(*,*) 'Error running HYPO71'
         status=5
         call exit_with_status(status)
      endif

      stop
      end

c$DEBUG
c
c  program to auto register waveform files
c
c  j. havskov, mar 93
c  Updates:
c  jul 93 by jh: version 3.0 
c  apr 94      : also possible to register in local data base
c  nov 24, 1994  : opening files changed
c  dec  15     : **********   version 5.0 ********************
c  jan 96    96: new seisinc
c  nov 97      : put line type 1 in header line
c  dec 8, 97   : change local to ,,,
c  dec 23      : error when asking for overwrite
c---------------------------------------------------------------------
c  oct 98      : ------------   version 7.0 check --------------------
c                make new id, 5 letter base, year 2000
c  jan 99, 5 lo: bug fix with reading base
c  mar 2 99  jh: REG to ARG
c  may2  00  jh: new wave structure
c  apr 29 01 lo: add check for blank line, if blank lines, add all names
c                up to next blank line to one event, this makes it possible
c                to register events with several waveform file names
c
c
      implicit none
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Open file definitions
       include 'seidim.inc'
       include 'waveform.inc'
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
       integer seiclen
C
C    ============= end of list ==========
C
c-- input file name
      character*80 infile,wave_file(990),xx
c-- output file name 
      character*80 event_name	
      integer nf    ! length of name  
c-- operator
      character*4 operator
c-- id line
      character*80 idline
c-- event type
      character*1 type,type_in
c-- base name
      character*5 base
c-- main header date and time
      integer year,month,day,hour,min,isec
c-- processing time
      character*12 p_time
      character*14 proc_time
c-- file existence
      logical exist
      real sec	  
C-- s file data
      character*80 data(999)
c-- counters
      integer i,j,k,cnt
c logical for end of file
       logical          b_eof
c logical for existing file or not
       logical          b_old
c returned code
       integer          code
c read unit #1 .. #6
       integer          read01, read02
c write unit #1 .. #5
       integer          write01
c file name
       character*80     chr_file
       logical          nwrite_all,owrite_all ! for writing files
       logical          ignore_all            ! ignore all dublicates
       character*1      choise                ! choise form questions
       logical with_blanks  ! true if filenr.lis has blank lines to sep events
c

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      nwrite_all=.false.
      owrite_all=.false.
      ignore_all=.false.
      b_f_debug$=.false.                  ! file debugging
      b_eof=.false.
c
c   set event type to local
c
 1000 continue
      write(6,*)' Event type for all events: Local:    L (default)'
      write(6,*)'                            Regional: R'
      write(6,*)'                            Distant:  D'
      read(5,'(a)') type_in
      if(type_in.eq.' ') then
         type='L'
      else
         type=type_in
      endif
      if(type.eq.'l') type='L'
      if(type.eq.'r') type='R'
      if(type.eq.'d') type='D'
      if(type.ne.'L'.and.type.ne.'R'.and.type.ne.'D') then
         write(6,*)' Wrong type, enter again'
         goto 1000
      endif
c
c  get base name
c
      write(6,*)
     *' 1-5 letter base name, return for standard base, '
     *,',, for local base'
      read(5,'(a)') base

      if (base(1:1).ne.' ') then
        do i=2,5
          if (base(i:i).eq.' ') base(i:i)='_'
        enddo
      endif

c
c   get operator
c
 60   continue
      write(6,*) ' Operator, max 4 chars'
      read(5,'(a)') operator
      if(operator.eq.'    ') then
         write(6,*)' You must give operator id'
         goto 60
      endif
c
c   open file with file names
c	  	  
      call sei open(old$+warn$,            ! Open a existing file.
     &                     ' ',                   ! Prompt file name (n/a).
     &                     'filenr.lis',          ! File name
     &                     read01,                ! Read unit #1
     &                     b_old,                 ! Already exists? (n/a).
     &                     code)                  ! Returned condition
      if (code .ne. e_ok$) go to 10
      goto 11
 10   continue
        write(6,*)' No filenr.lis file, make a dirf first'
        stop
 11   continue

      i=0
      with_blanks=.false.

 12   continue

      read(read01,'(7x,a)',iostat=code) infile
      call sei code(stop$,code,read01,b_eof)
      if (b_eof) go to 14  

      if (seiclen(infile).le.3) then
        i=1
      else
        if (i.eq.1) then
          with_blanks=.true.
          goto 14
        endif
      endif

      goto 12
 14   continue
      call sei close (close$,read01,code)
      b_eof=.false.
      call sei open(old$+warn$,            ! Open a existing file.
     &                     ' ',                   ! Prompt file name (n/a).
     &                     'filenr.lis',          ! File name
     &                     read01,                ! Read unit #1
     &                     b_old,                 ! Already exists? (n/a).
     &                     code)                  ! Returned condition.

      do i=1,990
        wave_file(i)=' '
      enddo
c 
c----------------------------------------------
c   enter here for new  event to register
c----------------------------------------------
c
 1    continue 
      read(read01,'(7x,a)',iostat=code) infile
      call sei code(stop$,code,read01,b_eof)
      if (b_eof) go to 999
      if (infile(1:1).eq.' ') goto 1
c
c read lines until next blank
c
      j=0
      xx='x'
      if (with_blanks) then
        do while (.not.b_eof.and.
     &            xx(1:1).ne.' ')
          read(read01,'(7x,a)',iostat=code) xx
          call sei code(stop$,code,read01,b_eof)
          if (b_eof) go to 111
          if (xx(1:1).ne.' ') then
            j=j+1
            wave_file(j)=xx
          else
            goto 111
          endif
        enddo
      endif
111   continue

      write(6,'(1x,a)') infile(1:60)
c-- check if end of group of filenr.lis	  
      if(infile(1:4).eq.'    ') goto 999	  	  	   	  	  
      wav_filename(1)=infile
c
c   now read first header for one event
c	  
      call wav_init
      call read_wav_header(1)
      if(wav_error_message.ne.' ') then
         write(6,'(1x,a)') wav_error_message
         goto 1
      endif
c
c   make output file name
c
      year=wav_year(wav_first)
      month=wav_month(wav_first)
      day=wav_day(wav_first)
      hour=wav_hour(wav_first)
      min=wav_min(wav_first)
      sec=wav_sec(wav_first)
      isec=sec
      call sfilname
     *(year,month,day,hour,min,isec,base,type,event_name,nf)

c
c   write header line in file
c
      data(1)=' '
      write(data(1),'(1x,i4,1x,2i2,1x,2i2,1x,f4.1,1x,a1)')     
     *year,month,day,hour,min,sec,type
      data(2)(1:1)=' '
      data(1)(80:80)='1'
c
c
c   next line is id line
c
      idline(1:40)= ' ACTION:                   OP:     STATU'
      idline(41:80)='S:               ID:                   I'
      WRITE(IDLINE(61:75),'(i4,5I2)')
     *YEAR,MONTH,DAY,HouR,MIN,ISEC
      DO I=61,74
         IF(IDLINE(I:I).EQ.' ') IDLINE(I:I)='0'
      ENDDO
      call systime(p_time,proc_time)
      WRITE(IDLINE(31:34),'(A)')OPERATOR
      WRITE(IDLINE(13:26),'(A)')PROC_TIME
      WRITE(IDLINE(9:11),'(A)')'ARG'
c
c  trace file name
c
      i=index(infile,'.')
      if(i.lt.0) 
     *write(6,*)' *** No . in trace file name ****'
c
c  write trace file name
c
      do i=1,80
         data(3)(i:i)=' '
      enddo
      i=index(infile,' ') -1
      if(i.lt.1) then
         data(3)(2:13)=infile(1:12)
      else
         data(3)(2:i+1)=infile(1:i)
      endif
      data(3)(80:80)='6'	  

c
c add more waveform files
c
      cnt=0
      do k=1,j
        if (seiclen(wave_file(k)).gt.1) then 
          i=0
          data(k+3)='                                        '//
     &              '                                       6' 
          cnt=cnt+1
          i=index(wave_file(k),' ') -1 
          data(k+3)(2:i+1)=wave_file(k)(1:i)
        endif
      enddo
c
c   make help line
c
      data(4+cnt)(1:57)=
     *' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO '
c      data(4+cnt)(58:80)='SNR AR TRES W  DIS CAZ7'
      data(4+cnt)(58:80)='AIN AR TRES W  DIS CAZ7'
c
c   blank last line
c
      do i=1,80
         data(5+cnt)(i:i)=' '		
      enddo
c
c   check if file exists
c
 3    continue       ! get here from below to again check file existance
c
      inquire(file=event_name,exist=exist)
c
c  If file exists, check what to do
c
c   ignore
c
      if(exist.and.ignore_all) then ! was there but do not overwrite
         write(6,*)' New event ignored'
         goto 1       ! never overwrite
      endif
c
c   over write
c
      if(exist.and.owrite_all) then
         write(6,*)' New event overwriting old'
         go to 100    ! overwrite all
      endif
c
c   make new index
c
      if((exist.and.nwrite_all).or.(exist.and.(choise.eq.'N'.or.
     *    choise.eq.'n'))) then
          write(6,*)' Creating a new id for event'
          call inc_id(idline,event_name,nf)
          goto 3                            ! go and try to open again
      endif

 5    continue      ! here to make a new choise
c
c   make choises here
c
      if(exist) then
          write(6,*)
          write(6,'(a)')' File already registered, options are:'
          write(6,'(a)')' Ignore (leave old event):             Return'
          write(6,'(a)')' Ignore all                            I'
          write(6,'(a)')' Overwrite duplicate:                  O'
          write(6,'(a)')' Overwite all duplicates:              A'
          write(6,'(a)')' Create a new event, different ID:     N'
          write(6,'(a,$)')' Create new events for ALL duplicates: *'
          read(5,'(a)') choise
c
          write(6,*)
        
          if(choise.eq.' ') then
             goto 1     ! get next event
          endif
          if(choise.eq.'i'.or.choise.eq.'I') then
             ignore_all=.true.
             goto 1
          endif
          if(choise.eq.'a'.or.choise.eq.'A') then
             write(6,*)' Sure you want to overwrite ALL (y/n)'
             read(5,'(a)') choise
             if(choise.eq.'y'.or.choise.eq.'Y') then
                 owrite_all=.true.
                 goto 100
             endif
             goto 5 ! another choise  
          endif
          if(choise.eq.'o'.or.choise.eq.'O') then
             write(6,*)' Sure you want to overwrite(y/n)'
             read(5,'(a)') choise
             if(choise.eq.'y'.or.choise.eq.'Y') then
                goto 100
             else
                goto 5   
             endif
          endif
          if(choise.eq.'n'.or.choise.eq.'N'.or.choise.eq.'*') then
             call inc_id(idline,event_name,nf)
             if(choise.eq.'*') nwrite_all=.true.
             goto 3     ! test again
          endif
          goto 5   ! no valid choise
      endif
c
  100 continue 
      choise=' '    ! reset choise
c
      data(2)=idline
      write(6,'(1x,a)') event_name(1:seiclen(event_name))
      write(6,*)

c
c   open and write s-file 
c
      chr_file = event_name(1:80)
              call sei open(unknown$+warn$,       ! Open an unknown status file.
     &                      ' ',                  ! Prompt file name (n/a).
     &                      chr_file,             ! File name
     &                      write01,              ! Write unit #1
     &                      b_old,                ! Already exists? (n/a).
     &                      code)                 ! Returned condition
      if (code .ne. e_ok$) go to 50
      goto 51
 50   continue
        write(6,*)' Data base sub directory not made'
        stop
 51   continue
          write(write01,'(a80)',iostat=code) (data(i),i=1,5+cnt)
          call sei code(stop$,code,write01,b_eof)
      call sei close (close$,write01,code)
c
c   back for next event
c	  
      goto 1	  	  	   
c
 999  continue	  
      call sei close (close$,read01,code) 
      stop
      end	  	  	 

      program seedresp2gse
c
c convert seed paz response to gse format
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      include 'resp.inc'

      character*5 sta
      character*4 comp
      character*14 time
      character*80 filename
      double precision event_time
      integer read01,code
      logical b_flag
      integer year,month,day,hour,min
      real sec
      double precision seed_start

c
c get input
c
      write(*,*) ' name of seed response file '
      read(5,'(a)') filename
      write(*,*) ' station name '
      read(5,'(a)') sta
      write(*,*) ' component name '
      read(5,'(a)') comp
      write(*,*) ' date and time (yyyymmddhhmm) '
      read(5,'(a)') time

      call sei open( old$,                          ! Open file (stop on error).
     &                     ' ',                ! No prompt.
     &                     filename,           ! This filename.
     &                     read01,             ! On unit.
     &                     b_flag,             ! Exists!!
     &                     code )              !
      if( code .ne. e_ok$ ) stop

      read(time,'(i4,4i2)') year,month,day,hour,min
      sec=0.
      call timsec(year,month,day,hour,min,sec,event_time)

c
c read seed response into common block
c
      call read_seed_resp(read01,event_time,seed_start)

c
c write gse response
c
      call write_gse_resp(sta,comp,time)
      call sei close ( close$, read01, code )

      write(*,*)
      write(*,*) ' gse response file: gseresp.out '

      stop
      end

      subroutine sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 file,mainhead,chahead)
c
c
c   make a seisan main header, one channel header  and file name
c
c   updates
c
c   sep 98 by jh : ----------  version 7.0 check ----------------------
c                  correction for year 2000
c                  5 char station names
c                  5 char network name
c   nov 5 98  jh : remover computer type, not needed
c   march 17, 99 jh: bug with file name, change to more than 32 channesl
c                    put in mainhead_text, change how net name is used
c   may 24         : small change to net_CODE
c   sep 99         : do not alter net code on return
c   apr 2000 jh    : change realistic time window to 999000 secs
c   may 15 2000 jh : make sure channel numbe rin file name always is 3 digitis
c                    like 003
c   jun 30 2003 lo : increased precision on sample rate if less than 1 Hz
c   nov 19 2003 jh : number fo samples to i6
c   aug 6 2008  jh : adjust duration by one sample, now nsamp/rate
c
c
c
c   input: year, month...  : date etc of each channel
c          nchan:          : number of channels
c          ichan:          : channle to calculate channel head for
c          net_code        : network code for file name
c          mainhead_text   : text for main header, if no text, net_code used
c          stat,comp       : station and channels for each channel
c          nsamp           ; number of samples each channel
c          rate            ; sample rate -----------------
c          cbyte           : 2 or 4 byte
c  output: file            : file name
c          mainhead        : main header
c          chahead         : channel header for ichan
c 
c
c  If a network name is given in net_code, that is used in file name. If no
c  network name is given, station code if first station is used
c           
c          
c          
      implicit none
      include 'seidim.inc'
c-- main header
      character*80 mainhead(max_trace)
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 file	  
c-- number of stations
      integer nchan	  
      character*29 mainhead_text        ! text for main header
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*4 comp(max_trace)	  
      character*5 stat(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *doy,hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c-- main header date and time
      integer myear,mmonth,mday,mdoy,mhour,mmin
      real msec
c-- channel start time 
      double precision cstart(max_trace)
c-- channel absolute start time relative earliest channel, from  1900, in sec 
      double precision cabstim(max_trace)     	  	  
c-- channel end time absolute
      double precision cendtim(max_trace)
      real ctim         ! time interval of one channel
c-- maximum and minumum of above and their difference
      double precision first_time,last_time, total_window
      character*5 net_code_local  ! net code used locally
      integer i,j,k,l
c
      net_code_local=net_code

c
c   find abs times for each channel and extreme values
c
      first_time=1.0e20
      last_time=0.0	  
      do i=1,nchan
         call timsec
     *   (year(i),month(i),day(i),hour(i),min(i),sec(i),cabstim(i))
cold         cendtim(i)=cabstim(i)+(nsamp(i)-1)/rate(i)
         cendtim(i)=cabstim(i)+(nsamp(i))/rate(i)  ! jh august 2008
         if(cabstim(i).lt.first_time) first_time=cabstim(i)
         if(cendtim(i).gt.last_time)  last_time=cendtim(i)
      enddo

c
c   find new start times relative to new main header
c
      do i=1,nchan
         cstart(i)=cabstim(i)-first_time
      enddo		 	  
c
c   check if total time window is reasonable
c
      total_window=last_time-first_time
      if(total_window.gt.999000.0) then
         write(6,*)' Total time window is:',total_window,' secs'
         write(6,*)' This is unrealistic, event is skipped'
         stop
      endif		 		 		 	  	   		 		 	  


c
c   make main header, clear first
c
      do i=1,max_trace
         do j=1,80
            mainhead(i)(j:j)=' '
         enddo
      enddo		 					 	  
c-- name or code
      if(mainhead_text.ne.' ') mainhead(1)(2:30)=mainhead_text 
      if(mainhead_text.eq.' '.and.net_code.ne.' ') 
     *mainhead(1)(2:6)=net_code
      if(mainhead_text.eq.' '.and.net_code.eq.' ') 
     *mainhead(1)(2:6)=stat(1)
      if(net_code.eq.' ') net_code_local=stat(1)
c-- number of channels
      write(mainhead(1)(31:33),'(i3)') nchan
c-- start time	  
      call sectim(first_time,myear,mdoy,mmonth,mday,mhour,mmin,msec)
      if(total_window.gt. 99999.0) then 
         write(mainhead(1)(34:69),'(i3,1x,i3,1x,i2,1x,i2,1x,i2,1x,
     *   i2,1x,f6.3,1x,f9.2)') myear-1900,mdoy,mmonth,mday,mhour,mmin,
     *   msec,total_window
      else
         write(mainhead(1)(34:69),'(i3,1x,i3,1x,i2,1x,i2,1x,i2,1x,
     *   i2,1x,f6.3,1x,f9.3)') myear-1900,mdoy,mmonth,mday,mhour,mmin,
     *   msec,total_window
      endif
c
c   write channel info
c	  
      l=2
      k=3	  
      do j=1,nchan
cold        ctim=float(nsamp(j)-1)/rate(j)
        ctim=float(nsamp(j))/rate(j) ! jh aug 2008
        if(ctim.gt.99999.0) then
           write(mainhead(k)(l:l+24),'(2a4,a1,f7.2,1x,f8.1)')
     *     stat(j)(1:4),comp(j),stat(j)(5:5),cstart(j),
     *     ctim   
        else
           write(mainhead(k)(l:l+24),'(2a4,a1,f7.2,1x,f8.2)')
     *     stat(j)(1:4),comp(j),stat(j)(5:5),cstart(j),
     *     ctim   
        endif
        l=l+26
        if(l.gt.60) then
           l=2
           k=k+1
        endif
      enddo			
c                                                                               
c  make file name 
c             
         file=' '
c             
c-- year                          
         write(file(1:4),'(i4)') myear
         file(5:5)='-'               
c-- month                                    
         file(6:7)=mainhead(1)(42:43)		
         file(8:8)='-'
c-- day                                      
         file(9:10)=mainhead(1)(45:46)		
         file(11:11)='-'
c-- hr                                       
         file(12:13)=mainhead(1)(48:49)		
c-- min                                    
         file(14:15)=mainhead(1)(51:52)		
         file(16:16)='-'
c-- sec                                    
         file(17:18)=mainhead(1)(54:55)		
         file(19:20)='S.'
c-- network                   
         file(21:25)=net_code_local
         file(26:26)='_'
c-- number of channels
         file(27:29)=mainhead(1)(31:33)
c-- check for blanks                                        
         do i=1,20				
            if(file(i:i).eq.' ') file(i:i)='0'                            
         enddo    
         do i=27,28
            if(file(i:i).eq.' ') file(i:i)='0'
         enddo
         do i=21,26
            if(file(i:i).eq.' '.or.ichar(file(i:i)).eq.0) file(i:i)='_'
         enddo
c
c   check whole main header for null chars
c
         do i=1,max_trace
            do j=1,80
               if(ichar(mainhead(i)(j:j)).eq.0) mainhead(i)(j:j)=' '
            enddo
         enddo		 					 	  

c
c   make one channel header
c
c
c   clear
c
        do i=1,1040
           chahead(i:i)=' '
        enddo
c
c   station and component
c
        chahead(1:5)=stat(ichan)
        chahead(6:9)=comp(ichan)
c--  year
        write(chahead(10:12),'(i3)') year(ichan)-1900
c
c  calculate doy
c
      call date_doy(doy,day(ichan),month(ichan),year(ichan))
c-- doy
        write(chahead(14:16),'(i3)') doy
c-- month
        write(chahead(18:19),'(i2)') month(ichan)
c-- day
        write(chahead(21:22),'(i2)') day(ichan)
c-- hour
        write(chahead(24:25),'(i2)') hour(ichan)
c-- min
        write(chahead(27:28),'(i2)') min(ichan)
c-- sec
        write(chahead(30:35),'(f6.3)') sec(ichan)
c-- sample rate
c        write(chahead(37:43),'(f7.2)') rate(ichan)
c changed lot 30/06/2003
        if (rate(ichan).gt.1.) then
          write(chahead(37:43),'(f7.2)') rate(ichan)
        else
          write(chahead(37:43),'(f7.5)') rate(ichan)
        endif
c-- number of samples
        write(chahead(44:50),'(i7)') nsamp(ichan)
c-- 2 or 4 byte
        chahead(77:77)=cbyte(ichan)
c
c   check that no null chars in header
c
        do i=1,1040
          if(ichar(chahead(i:i)).eq.0) chahead(i:i)=' '
        enddo
      return
      end

c$DEBUG
c
c  convert Nanometrics files to seisan format
c
c
c  j. havskov, march 99
c
c  updates:
c
c  sep 29  bmt : update name of agency with station
c  oct 21  bmt : update for sun and pc
c  dec 09  lo  : read component from last 3 chars in string
c  may 11  lo  : use read_resp_head
c  oct 12  jh  : fix pc verison with pc y5dump, requires 2 dll files
c                add component to output file name
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
c-- input data vector	  
      integer*4 data(max_sample)
c-- input file name	  
      character*80 infile
      integer seiclen      ! function
      character*80 text
c
c-----------------------------------------------------------------------
c   start block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c index
      integer ind
c
c--end block of definitions most conversion programs
c---------------------------------------------------------------------
c

c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
	  integer i
      integer code   ! error code
c-- computer type
      logical pc,sun,linux	  
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       text='nansei.def'
      call read_def_chan(text,mainhead_text,net_code)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.infile(1:10).eq.
     *'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c  file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
	  i=seiclen(infile)   ! length of file name
c
c   convert file to ascii using nanometrics program y5dump
c      
      call systemc
     *('y5dump -h -d '//infile(1:i)//'> nan.out',22+i)
c
c  open file and read header info
c
       open(1,file='nan.out',status='old')
c
c  read in a loop to get needed info
c
       comp(1)='S  Z'
  60   continue
       read(1,'(a)') text
c
c assume that 3 char component in the end of string
c
       if(text(9:17).eq.'StnLocChn') then
          stat(1)=text(20:24)
          ind=seiclen(text)
          comp(1)=' '
          comp(1)(1:1)=text(ind-2:ind-2)
          comp(1)(2:2)=text(ind-1:ind-1)
          comp(1)(4:4)=text(ind:ind)
c          comp(1)(1:1)=text(25:25)
c          comp(1)(4:4)=text(27:27)
       endif
c
c   number of samples 
c
       if(text(1:17).eq.'Number of Samples') then
          call sei get values(1,text(20:30),code)
          nsamp(1)=array$(1)
       endif

c
       if(text(7:17).eq.'Sample Rate') then
          read(text(19:30),'(f8.2)') rate(1)
       endif
c
       if(text(8:17).eq.'Start Time') then
          read(text(20:43),'(i4,1x,i2,1x,i2,1x,i2,1x,i2,1x,f7.2)') 
     *    year(1),month(1),day(1),
     *    hour(1),min(1),sec(1)
       endif
c
c   continue if not at the data section
c
       if(text(4:17).ne.'Format Version') goto 60
c
c   header read
c
       write(6,'(1x,a,1x,a4)') stat(1),comp(1)
       write(6,*)' rate,nsamp',rate(1),nsamp(1)
       write(6,*) year(1),month(1),day(1),hour(1),min(1),sec(1)
 
c
c   put in definition from def file
c
       call set_def_chan(1,stat(1),comp(1))
c
c   make seisan headers
c
      ichan=1
      nchan=1
      cbyte(1)='4'   ! 4 byte data
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)

c
c   add component name to avoind overwriting
c
      outfile(30:30)='_'
      outfile(31:34)=comp(1)
      do i=31,34
          if(outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo
      write(6,200) outfile(1:34)                                             
 200  format(/,' Output file name is: ',a)                                
c
c   read response curve into header
c

      call read_resp_head(chahead)                                            
c
c   open output file
c
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   read data
c
c
      do i=1,nsamp(1)
          data(i)=0
      enddo
      read(1,*,END=222) (data(i),i=1,nsamp(1))
      goto 223
c
 222  data(i)=0
 223   continue
   
c   end of file on solaris is incoplete causing an end of file, so the
c   end=222 is added above and all samples are set to 0 before reading.
c   in this wasy any missing samples will be zero
c
c
c   write data
c
      write(6,'(1x,a)')mainhead(1)(1:79)
      write(6,'(1x,a)')chahead(1:79)
      do i=1,12
         write(2)mainhead(i)
      enddo
      write(2) chahead
c
      write(2)(data(i),i=1,nsamp(1))
      write(6,*)
      close(1)
      close(2)
c
c  back for next file if many
c
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  

c--------------------------------------------------------------------------
c  calcualtes the best fit of a plane wave to a set of stations so the
c  stations are assuemd to act as a seismic array. the program uses one
c  s-file
c--------------------------------------------------------------------------c
c
c   updates
c
c aug 20 2008 jh: add q to quit to plot
c
c      implicit none                       ! force delcaration of all variables
      include 'winplot1.inc' 
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common block
      include 'version.inc'
      include 'libsei.inc'

      include 'seiplot.inc'               ! seisan graphics
      character*1 cha(10)                 ! dummy for xy_plot

      character*1 make_plot

      character*80 text(1000)             ! general text
      character*80 txt(100)
      character*80 title                  ! title for plot
      character*30 xtext,ytext            ! axis title
      character*80 data(5000)             ! s-file with data in text array
      character*80 infile                 ! input file
      character*5  stat_p(100)            ! stations with p
      real*8       time_p(100)            ! abs arrival time
      real*8       time1_p                ! temporary of above
      real stat_x(100),stat_y(100)        ! cartesian station coordinates
      real x(100),y(100)                  ! work array
      real stat_dist(100)                 ! distance from reference station
      character*5 ref_stat                ! reference station
      integer k_ref                       ! index of reference station
      real max_dist                       ! maximum distance from ref stat.
      real px,py                          ! slownes components
      real vapp, baz                      ! apparent velocity and back azimuth
      real corr, rms                      ! correlation coefficient and rms
      character*1  modelc                 ! model flag
      real stlat(100),stlong(100)         ! lat lon of selected stations
      real stlat1,stlong1                 ! temporary of above
      real stelev(100)                    ! elevation ------------------
      real xm,ym                          ! cursor input
      real xc,yc                          ! scaling factors

      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer il                          ! line counter
      integer i,k,n                       ! counter


      include 'winplot2.inc'
c
c   start writing from line 1
c
c   check if input via argumants
c
      call get_arguments(n,infile)
c
      if(n.lt.1) then
c
c   get input file name, check if exist
c
 9       continue
         write(6,*) 'Give input file'
         read(5,'(a)') infile
      endif

      open(1,file=infile,status='old',err=10)
      goto 11
 10   continue
      write(6,*)' No such input file'
      goto 9
 11   continue
c
      write(6,*) 
     *' Give reference station, enter for using first station in list'
      read(5,'(a)') ref_stat
      write(6,*) 'Maximum distance from reference station',
     *', default is 1000 km'
      read(5,'(a)') txt(1)
      if(txt(1).eq.' ') then
         max_dist=1000.0
      else
         call sei get values(1 , txt(1), code )
         max_dist=array$(1)
      endif
c
      all=.true.                  ! read all parameters
c
c   open output file
c
      open(2,file='array.out',status='unknown')  
c
c
c   read all parameters for one event from file unit 1
c
      call rea_event_in(1,all,data,code)
c
c   check if end of file (code=1), if so terminate program
c
      if(code.eq.1) goto 1000
c
c   write the whole first header line
c
      il=2
      write(6,'(a)') data(1)(1:79)
      write(text(il),'(a)') data(1)(1:79)
      il=il+1
c
c count P-phases and find coordinates, only first arrival are used
c

      k=1
      modelc=' '
      do i=1,rea_nphase
        if(rea_phase(i)(1:2).eq.'P '.or.
     *     rea_phase(i)(1:2).eq.'Pg'.or. 
     *     rea_phase(i)(1:2).eq.'PG'.or. 
     *     rea_phase(i)(1:2).eq.'Pn'.or. 
     *     rea_phase(i)(1:2).eq.'PN'.or. 
     *     rea_phase(i)(1:3).eq.'PKP'.or. 
     *     rea_phase(i)(1:2).eq.'Pb'.or. 
     *     rea_phase(i)(1:2).eq.'PB') 
     *   then
           time_p(k)=rea_abs_time(i)
           stat_p(k)=rea_stat(i)
           call stat_loc(stat_p(k),modelc,stlat(k),stlong(k),
     *     stelev(k))
           if(stlat(k).eq.0.0.and.stlong(k).eq.0.0) then
              write(6,'(1x,a,a)') 
     *        ' Station not found in STATION0.HYP file ',stat_p(k)
           else
              k=k+1
           endif   
        endif
      enddo
      k=k-1
c
c   find reference station
c
      k_ref=0
      do i=1,k
        if(ref_stat.eq.stat_p(i)) then
          k_ref=i
        endif
      enddo
      if(k_ref.eq.0) then
        write(6,*) 
     *  'Reference station not found, will use first station in list'
        k_ref=1
        ref_stat=stat_p(1)
      endif
c
c   put reference station in index 1
c
      time1_p=time_p(1)
      stlat1=stlat(1)
      stlong1=stlong(1) 
      time_p(1)=time_p(k_ref)
      stlat(1)=stlat(k_ref)
      stlong(1)=stlong(k_ref)
      time_p(k_ref)=time1_p
      stlat(k_ref)=stlat1
      stlong(k_ref)=stlong1
      stat_p(k_ref)=stat_p(1)
      stat_p(1)=ref_stat
c
c   reference to first station with respect to time
c
      do i=2,k
        time_p(i)=time_p(i)-time_p(1)
      enddo 
      time_p(1)=0.0
c
c  calculte xy coordinates with respect to first station
c
      do i=2,k
        stat_x(i)=111.195*cos(stlat(1)/57.296)*
     *  (stlong(i)-stlong(1))
        stat_y(i)=111.195*(stlat(i)-stlat(1))
        stat_dist(i)=sqrt(stat_x(i)*stat_x(i)+stat_y(i)*stat_y(i))
      enddo
      stat_x(1)=0.0
      stat_y(1)=0.0
c
c   select stations within max-dist radius
c
      n=2
      do i=2,k
        if(stat_dist(i).le.max_dist) then
          stat_x(n)=stat_x(i)
          stat_y(n)=stat_y(i)
          time_p(n)=time_p(i)
          stat_p(n)=stat_p(i)
          stlong(n)=stlong(i)
          stlat(n)=stlat(i)
          n=n+1
        endif
      enddo
      n=n-1
      write(6,*)
      write(6,'(a,i3,a,i3)')
     *' Stations available:',k,'  Stations used:',n
      write(text(il),'(a,i3,a,i3)')
     *' Stations available:',k,'  Stations used:',n
 
      il=il+1

      k=n

      write(6,'(2a)') ' Stat      Delta t  Latitude',
     *' Longitude         x         y'
      write(text(il),'(2a)') ' Stat      Delta t  Latitude',
     *' Longitude         x         y'
      il=il+1
      do i=1,k
         write(6,'(1x,a5,2x,5f10.3)') 
     *   stat_p(i),time_p(i),stlat(i),stlong(i),
     *              stat_x(i),stat_y(i)
         write(text(il),'(1x,a5,2x,5f10.3)') 
     *   stat_p(i),time_p(i),stlat(i),stlong(i),
     *              stat_x(i),stat_y(i)
         il=il+1
      enddo
   
      if(k.lt.3) then
        write(6,*)
        write(6,*) ' Too few stations available, will stop'
        write(6,*) ' Enter to continue'
        read(5,'(a)')  txt(1)
        write(2,*)' No data'
        close(2)
        stop
      endif
c
c   put into x and y variables for least squares
c
      do i=2,k
        x(i-1)=stat_y(i)/stat_x(i)
        y(i-1)=time_p(i)/stat_x(i)
      enddo

      k=k-1

      call lsqlin(k,x,y,py,px,corr,rms)
c
c   calcualte azimuth and apparent velocity
c
      vapp=1.0/sqrt(px*px+py*py)
      baz=atan2(py,px)
      baz=baz*57.2 -180.0
      if(baz.lt.0.0) baz=baz+360.0
c
      write(6,*)
      write(6,'(a,a)') ' Reference station is: ',ref_stat
      write(text(il),'(a,a)') ' Reference station is: ',ref_stat
      il=il+1
      write(6,*)
      write(6,'(a,f5.1,a,f5.2,a,f5.2,a,f6.2)')
     *' Back azimuth =',baz,'  Apparent velocity =',vapp,
     *'  corr =',corr,'  rms = ',rms
      write(text(il),'(a,f5.1,a,f5.2,a,f5.2,a,f6.2)')
     *' Back azimuth =',baz,'  Apparent velocity =',vapp,
     *'  corr =',corr,'  rms = ',rms
      il=il+1
c
c   put baz and app in top of file
c
      write(text(1),'(a,a5,1x,2f10.2)')
     *' Back azi. and apparent velocity  '
     *,ref_stat,baz,vapp
c
c   wrtiew in file
c
      do i=1,il-1
        write(2,'(a)') text(i)
      enddo
      write(6,*) ' Plot relation (y=default/n)'
      read(5,'(a)') make_plot
      if((make_plot.eq.'y') .or. (make_plot.eq.' ')) then
c
c  set defaults for output on screen and one hardcopy file
c
          open(65,file='array.eps',status='unknown')
          plotunit=65
          plotoption=1
          hctype=1
          wsize=60
c
c   open plotter
c
c
c   set some postscipt scalings
c
          write(65,*) ' 1.0 0.55 scale'

          write(title,'(a,f5.1,a,f6.1,a,f6.3)')
     *   'App. vel=',vapp,'   Back Azimuth= ',baz,
     *    '   corr=',corr
          xtext=' (x-coordinate)/(y-coordinate)'
          ytext='(P-time) / (Stat x-coordinate )     '

c
c   open display
c
        call open_display
c
c   plot points
c
          call xy_plot
     *    (1,k,x,y,title,xtext,ytext,
     *    600.0,600.0,100.0,100.0,1,1,20.0,
     *    0,cha,i,x,y)
c
c  plot line
c
          call xy_plot_line(px,py,100.0,100.0)
          txt(1)='Select station by'
          txt(2)='clicking near symbol'
          txt(3)='q to quit'
          call xmessage(txt,3,25,720.0,650.0)
c
c   plot all stations
c
c         i=1
c         l=2
c         txt(1)='STAT PS  S-P  STAT PS  S-P'
c554      continue
c         txt(l)=' '
c         do k=1,2
c            if(k.eq.1) then
c               write(txt(l)(1:13),'(a5,a1,a1,f5.2)')
c    *          stat(i),phase_p(i)(11:11),phase_s(i)(11:11),tsp(i)
c               i=i+1
c               if(i.gt.nwad) goto 555
c            endif
c            if(k.eq.2) then
c               write(txt(l)(16:28),'(a5,a1,a1,f5.2)')
c    *          stat(i),phase_p(i)(11:11),phase_s(i)(11:11),tsp(i)
c               i=i+1
c               l=l+1
c               if(i.gt.nwad) goto 555
c               goto 554
c            endif
c         enddo
c555      continue
c         if(k.eq.2) l=l-1
c         call xmessage(txt,l,28,710.0,10.0)
c

c
c  call up cursxor so plots remains
c
 55       continue
          call xy_plot_input(100.0,100.0,cha(1),xm,ym,xc,yc)
 
c   find corresponding station
 
          txt(1)=' '
          txt(1)='Too far from symbol,'
          txt(2)='try again'
          txt(3)=' '
c          write(27,*) x,y
          do i=1,k
              if(abs(xm-x(i))*xc.lt.10.0.and.   ! distance in pixels
     *           abs(ym-y(i))*yc.lt.8.0) then
                 txt(1)(1:25)='STAT      Relative P '
                 write(txt(2)(1:25),
     *           '(a,5x,f10.3)')stat_p(i+1),time_p(i+1)
                 txt(3)=' '
c                 write(27,*) x,y,stat(i),phase_p(i),phase_s(i)
c                 write(27,*) txt(1),txt(2),txt(3)
              endif
          enddo

         call xmessage(txt,3,25,720.0,655.0)
          if(cha(1).ne.'q') goto 55   ! next input

c          call xscursr(i,xm,ym)

 
c   close postscript
c
          call close_post
c
c   close output plot file
c
          close(65)
c
c   close display and back to alpha screen
c
         write(6,*)
         write(6,*)' Plot file is array.eps'
      endif
 30   call clear_to_alpha

c
c     end of file
c
 1000 continue
c
      write(6,*)            ! blank line
      write(6,*) ' Output file is array.out'


      stop
      end


      subroutine xy_plot_input(x0,y0,c,x,y,xc,yc)
c
c  reads positions from the screen much like the main routine
c  all scaling values from routine xy_plot via common
c  x0,y0 are lower left hand corner of plot
c
c  x0,yo : same input as main routine
c  x,y   : output in scaled units
c  c     : character pressed
c  xc    : xscale
c
       implicit none
       character*1 c
       integer ichar
       reaL xc,yc   ! same as x and yscale
       real x1,x,y1,y   ! help variables
       real xfirst,yfirst,x0,y0,xscale,yscale,ymin,ymax,xmin,xmax ! see xy_plot
       common/xy_plot_common/xfirst,yfirst,xscale,yscale,ymin,
     *                       ymax,xmin,xmax
c
c   call up cursor
c

   1        continue
            call xscursr(ichar,x1,y1)
            if (char(ichar).eq.'#') goto 1
            c=char(ichar)
            x=(x1-x0)/xscale+xfirst
            y=(y1-y0)/yscale+yfirst
            xc=xscale
            yc=yscale
c
      return
      end

c$debug
C***************************************************************
C PROGRAM TO CONVERT HYPOINVERSE
C TO NORDIC STANDARD FORMAT.
    
c Originally by M. Villagran for converting H71 to Nordic
C By R. Arvidsson, 1992-01-28. Format on output scs in header
c  header line.

c  modified by Barry Lienert 11/94

c   dec 94    by jh   **************** version 5.0 ************** no change
c   feb 99    by jh   -----------------version 7.0 check ------------------
c                     add question about century, no 5 char stations
c   18 mar 99    lo   define cero
c
C character variables definition
c
        CHARACTER*80 HEADERINFO
	CHARACTER*30 INFILE,outfile
        character*5   sec
        CHARACTER*4 CODA 
        CHARACTER*3 AMP1,TODO
        character*4 sta
	CHARACTER*2 PHP
        character*2 cen ! century
        character*1 type,siete,udp,wtp,decision,sp,qi
        character*5 cero

C integer variables definition 
        integer yr,mth,dy,escribs,jj,hrmn,error



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

C Formats
C 100 is to read HYPOINV phases format
C 200 is to write the headline of identification of the quake in NF
c NF means Nordic Format.
C 300 is to write P or S Phases format in NF

 102    format(a)
	            
C Program presentation and
C asks for input and output file
C F1FILE is the input file
        HEADERINFO(1:40)= ' STAT SP IPHASW D HRMN SECON CODA AMPLIT ' 
c        HEADERINFO(41:80)=' PERI AZIMU VELO SNR AR TRES  W DIS CAZ7'
        HEADERINFO(41:80)=' PERI AZIMU VELO AIN AR TRES  W DIS CAZ7'
        WRITE(*,*)'  '
        WRITE(*,*)' This program converts HYPOINVERSE',
     &   ' phase format to'
        WRITE(*,*)' NORDIC phase format for use with HYPOCENTER'

C open file to convert
1098    WRITE(*,'(/'' HYPOINVERSE Phase file ? '',$)')
        read(*,'(a)')infile
 11     continue
        write(6,*)' Give century, 19 or 20'
        read(5,'(a2)') cen
        if(cen.ne.'19'.and.cen.ne.'20') goto 11
        open(1,file=infile,err=1099,status='old')

        write(*,'(/'' Output Filename ? '',$)')
        read(*,'(a)')outfile   

C all quakes will be cataloged like local 
C it has to be updated
        TYPE='L'
 
C 7 is a number that will be puted in the 80 column
C of the Nordic Format just in the earthquake identification line
        SIETE='7'

C all phases will be considerated like Z component 
C because H71pc and Hinvpc formats don't have
C notation of that.
        SP='SZ'

C to be used in P phase if Weigth option in pc format is 9.
        CERO='     '

C TODO is a variable to write blank lines.
	TODO='   '

C JJ is the quakes counter
	JJ=0

C open the nordic format file to create
C write the head information in output file
10      OPEN(2,FILE=outfile,status='new',err=70)

C start the process to convert format
C at first the program writes P phase
C that is because the NF uses one line for each phase
C after the program change the variable values
C to write the S phase

C YES is an variable that the program loks to know
C if has to write P or S Wave.
20	YES=0

C earthquakes counter
	JJ=JJ+1
c       WRITE(2,*)TODO

      read(1,101,end=90) yr, mth, dy, hrmn 
101    FORMAT(3i2,i4)

21    read(1,100,end=90)sta,qi,php,wtp,udp,sec,coda
100    format(a4,4a1,a5,a4,a4) 

c      write(sec,'(a2,a1,a2)') ss,'.',hhscs
 
c Fix weight as blank when zero
      if ( WTP .eq. '0' ) then
         WTP= ' '
      endif
c ---
25      continue

c        if(jj.ne.1) write(2,*)'                  '

c -------- Fix format of seconds, r.n.a
c        write(*,*)sec
c        read(ss,'(f5.2)') scs     

       if(yes.eq.0)then
        write(2,200)cen,yr,mth,dy,hrmn,'L'	
 200    format(1x,a2,i2,1x,2i2,1x,i4,6x,a1,57(' '),'1')
        write(2,'(A79,A1)')HEADERINFO(1:79), '7' 
	yes=1
       endif

C if the programs H71pc and Hinvpc reads coda values of "0"
C accept that like not a coda value, for that case
C in NF coda has to be blank
      if(coda.eq.'   0')then
       coda='    '
      endif

C For an H71pc format the program will change the way of notacion
C of the arrival up will be C and Down D
      if(udp.eq.'U')then
       udp='C' 
      endif
      amp1='   '
       escribs=0
       if(sta.eq.'    ')then
        write(2,*)
        goto 20
       endif

C Writes P in the NF file and make variable values to
C can write S phase
50    write(2,300)sta,sp,qi,php,udp,wtp,hrmn,sec,coda,amp1
300    format(1x,a4,1x,a2,1x,2a1,3x,a1,1x,a1,1x,i4,1x,a5,1x,a4,1x,a3)
      goto 21

C error display
60    write(*,*)'  '
      error=1
      write(*,*)'  Error found after ...'
      write(2,300)sta,sp,qi,php,udp,wtp,hrmn,sec,coda,amp1
      goto 21
70    WRITE(*,*)'  '
      WRITE(*,*)' This file already exists:'
      WRITE(*,'(/'' Do you want to overwrite it (Y/N) ? '',$)')
      read(*,'(a1)')decision

      if((decision.eq.'y').or.(decision.eq.'Y'))then
        open(2,file=outfile,status='old')
        close(2,status='delete')
        goto 10
      else
        goto 99
      endif

1099  write(*,'(/'' File not found '')') 
      go to 1098

c finish
90      IF(error.EQ.1)THEN
	WRITE(*,*)' Output file was not created'
	WRITE(*,*)' Correct the file and try again'
	GOTO 98
	ENDIF
        write(2,*)'    '
        CLOSE(2)
        write(6,*)
	WRITE(*,'(10X,I5,1X,A22)')JJ-1,'Quakes were converted '
98      CLOSE(1)
99      continue
        END

      program wavfullname
c
c program to write out full path, input is given on command line
c    e.g. wavfullpath 2002-11-26-0059-27S.LNQ___013
c will print full path + filename to stamdard output
c
c May 2003, Lars Ottemoller
c
      implicit none

      character*80 arg(1)
      character*240 fullname
      integer narg,seiclen

      call get_seisan_def
      call get_arguments(narg,arg)
      call get_full_wav_name(arg(1),fullname)
      if (seiclen(fullname).le.0) then
        write(*,'(a)') 'not found'
      else
        write(*,'(a)') fullname(1:seiclen(fullname))
      endif
      stop
      end

c     Program to list the yearly, monthly and daily
c     number of events. Input file is Nordic compact.
c
c     by Mario Villagran, March 1995
c     Updates
c     June 95 by jh   : Put on PC
c     jul 20 by jh, time of day statistics
c     feb 96          : fixing and graphics
c     jul 24 96       : fix error in time of day distribution
c     aug 10 98 jh    : fix so years without century in s-file are sorted ok
c     feb    99 jh    : ---------   version 7.0 check ---------------------
c
c     mar 26 bmt      :include winplot.inc
c     sep 30    jh    : edit text
c     april 25  2002  : gmt output
c     feb 25 2003 jh  : increase dimensions
c     jun 20 2005 jh  : plt to eps
c     oct 24 2006 jh  : but in time of day
c
c
c      implicit none  !comment for pc
      include 'winplot1.inc'
      include 'seiplot.inc'   ! seisan graphics
      include 'seidim.inc'
      include 'gmt_xy_par.inc'
      integer nrecord,nstat,nhead,id,nphas
      character*1 exp,type
      character*80 data(max_data)
      integer sei integer     ! function to get integer from a text string
      logical compact        ! true if compact file
      INTEGER YEA,MO,DA,hour
      character*8 start_time,end_time ! time interval for statistics
      integer dayabs,dayabs1,dayabs2  ! days from year 0
      integer year1,month1,day1,year2,month2,day2  ! time inerval
      integer nday            ! number of days in a month
      CHARACTER event(150000)*13,infile*30
      integer time_of_day(24)    ! to time of day disitribution
      integer i,j,k,m,kk,l,nev
      real xx                    ! help variable
      integer syr(20000),smo(20000,12),sda(20000,12,31)
      real x(150000),y(150000)              ! for plotting
      real x_gmt(150000), y_gmt(150000)     ! for gmt plotting
      integer n_gmt                       ! number of points for gmt plotting
      character*80 filename_gmt           ! file with gmt input
      character*1 cha(10)                 ! dummy for xy_plot
      character*80 text                   ! general text
      character*80 title                  ! title for plot      
      character*30 xtext,ytext            ! axis title
      character*5  make_plot              ! indicator for making plot
      character*1  daily                  ! is y, print out daily statisitcs
      integer      iplot                  ! type of plot
      real size     	                      ! half the column size
      include 'version.inc'
      include 'winplot2.inc'
C-------------------------------


c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      call gmt_xy_init     ! set default gmt parameters

      size=0.2
      do i=1,24
        time_of_day(i)=0
      enddo
c
      write(6,*)' Input file name ?'
      read(5,'(a)')infile
      open(unit=17,file=infile,status='old')
c
c  find which type of input file
c
      call nortype(17,compact)
      if(compact) write(6,*)' Input file is compact'

      open(unit=19,file='catyear.out',status='unknown')
      open(unit=20,file='catmonth.out',status='unknown')
      open(unit=21,file='catday.out',status='unknown')
      open(unit=22,file='cathour.out',status='unknown')
c
      write(6,'(a,$)')' Start time (ccyymmdd.eg.19550101) '
      read(5,'(a)') start_time
      write(6,'(a,$)')' End time                          '
      read(5,'(a)') end_time
      read(start_time,'(i4,2i2)') year1,month1,day1
      if(month1.eq.0) month1=1
      if(day1.eq.0) day1=1
      read(end_time,  '(i4,2i2)') year2,month2,day2
      if(month2.eq.0) month2=12
      if(day2.eq.0) day2=31
      write(6,'(a,$)')' Write out dayly statistics (y/n)'
      read(5,'(a)') daily
      
c
c    calculate days since year 0
c
      dayabs1=year1*365+(month1-1)*31+day1
      dayabs2=year2*365+(month2-1)*31+day2
      
      nev=0
c
c   lop for reading events
c

 5    nev=nev+1

c
c   read one event or one header line
c
      if(compact) then
         read(17,'(a)',end=10) data(1)
      else
         call indata(17,nstat,nphas,nhead,nrecord,type,exp,data,id)
         if(nrecord.le.0) then
            goto 10   ! process data
         endif
      endif
      event(nev)=data(1)(1:13)
c
c   next event
c
      goto 5
c
c------------------------------------
c   read all events, start processing
c------------------------------------
c
 10   continue
      close(17)
      nev=nev-1
        do i=year1,year2
           write(6,*)'year',i
             do j=1,nev
               read(event(j),400)yea,mo,da,hour
 400           format (1X,I4,1X,2I2,1x,i2)
               if(yea.lt.100) yea=yea+1900    ! mssing century, 8-98
               dayabs=yea*365+(mo-1)*31+da
               if(dayabs.ge.dayabs1.and.dayabs.le.dayabs2) then
c
c   get time of day distribution, but only for thje first time in loop
c
                  if(i.eq.year1) then
                     if(hour.gt.23.or.hour.lt.0) then
                          write(6,*)' wrong hour'
                     else
                        hour=hour+1
                        time_of_day(hour)=time_of_day(hour)+1
                     endif
                  endif
               endif
               if(yea.eq.i)then
               syr(i)=syr(i)+1    ! yearly statistics
               do k=1,12
                  if(dayabs.ge.dayabs1.and.dayabs.le.dayabs2.
     *            and.mo.eq.k)then
                     smo(i,k)=smo(i,k)+1  ! monthly statistics
                     do kk=1,31
                       if(dayabs.ge.dayabs1.and.dayabs.
     *                 le.dayabs2.and.da.eq.kk)
     *                 sda(i,k,kk)=sda(i,k,kk)+1 ! daily statistics
                     enddo
                  endif
               enddo
            endif
          enddo
        write(19,*)i,syr(i)  ! write yearly statistics
      enddo
c
c  write monthly distribution
c
      do i=year1,year2
        do k=1,12
          dayabs=i*365+(k-1)*31+31   ! add 31 to get even to end of month
          if(dayabs.ge.dayabs1.and.dayabs.le.dayabs2) 
     *    write(20,'(i4,1x,i2,i6)')i,k,smo(i,k)
        enddo
        do k=1,12
c
c   find number of days in month
c
           call month_day(i,k,nday)
c
c   write events/day distribution
c
           if(daily.eq.'y'.or.daily.eq.'Y') then
           do kk=1,nday
              dayabs=i*365+(k-1)*31+kk
              if(dayabs.ge.dayabs1.and.dayabs.le.dayabs2)
     *        write(21,'(i4,2(1x,i2),i6)')i,k,kk,sda(i,k,kk)
c            write(6,*)i,k,kk
           enddo
           endif
        enddo
      enddo
c
c   write time of day distribution
c
      do i=1,24
         write(22,*) i,time_of_day(i)
      enddo
c
c
 1000    continue
         write(6,*) ' Plot yearly distribution      (1)'
         write(6,*) ' Plot monthly distribution     (2)'
         write(6,*) ' Plot daily distribution       (3)'
         write(6,*) ' Plot time of day distribution (4)'
         write(6,*) ' No plot, return'
         read(5,'(a)') make_plot
         if(make_plot.ne.'     ') then
           iplot=sei integer(make_plot,kk)    ! get number, kk is error code
           if(iplot.gt.4) then
              write(6,*)' Not a valid number'
              goto 1000     ! not a valid number    
           endif
        
           n_gmt=0
c
c   make yearly histogram 
c
           k=1
           size=0.3
           if(iplot.eq.1) then
              do i=year1,year2
c
c   gmt
c
                 n_gmt=n_gmt+1
                 x_gmt(n_gmt)=i
                 y_gmt(n_gmt)=syr(i)
c
                 x(k)=i-size
                 y(k)=0
                 k=k+1
                 x(k)=i-size
                 y(k)=syr(i)
                 k=k+1
                 x(k)=i+size
                 y(k)=syr(i)
                 k=k+1
                 x(k)=i+size
                 y(k)=0
                 k=k+1
              enddo
              x(k)=year1-size
              y(k)=0
           endif
c
c   monthly distribution
c
           if(iplot.eq.2) then
              size=size/12.0
              do i=year1,year2
                 do l=1,12
                    dayabs=i*365+(l-1)*31+31
                    if(dayabs.ge.dayabs1.and.dayabs.le.dayabs2) then
                    xx=i+l/12.0    ! convert to fraction of year
                    x(k)=xx-size
                    y(k)=0
                    k=k+1
                    x(k)=xx-size
c
c   gmt
c
                    n_gmt=n_gmt+1
                    x_gmt(n_gmt)=xx
                    y_gmt(n_gmt)=smo(i,l)

                    y(k)=smo(i,l)
                    k=k+1
                    x(k)=xx+size
                    y(k)=smo(i,l)
                    k=k+1
                    x(k)=xx+size
                    y(k)=0
                    k=k+1
                    endif
                 enddo
              enddo
              x(k)=x(1)
              y(k)=0
              size=size*12.0
           endif
c
c   daily distribution
c
           kk=1                  ! count days
           if(iplot.eq.3) then
              do i=year1,year2
                 do l=1,12
                    call month_day(i,l,nday)
                    do m=1,nday
                       dayabs=i*365+(l-1)*31+m
                       if(dayabs.ge.dayabs1.and.dayabs.le.dayabs2)then
                       x(k)=kk-size
                       y(k)=0
                       k=k+1
                       x(k)=kk-size
                       y(k)=sda(i,l,m)
                       k=k+1
                       x(k)=kk+size
                       y(k)=sda(i,l,m)
c
c   gmt
c
                       n_gmt=n_gmt+1
                       x_gmt(n_gmt)=n_gmt
                       y_gmt(n_gmt)=sda(i,l,m)

                       k=k+1
                       x(k)=kk+size
                       y(k)=0
                       k=k+1
                       kk=kk+1    ! one more day
                       endif
                    enddo
                 enddo
              enddo
              x(k)=x(1)
              y(k)=0
           endif
c
c   time of day
c
           if(iplot.eq.4) then
              do i=1,24
                 x(k)=i-size
                 y(k)=0
                 k=k+1
                 x(k)=i-size
                 y(k)=time_of_day(i)
c
c   gmt
c
                 n_gmt=n_gmt+1
                 x_gmt(n_gmt)=i
                 y_gmt(n_gmt)=time_of_day(i)
                 k=k+1    ! jh oct 06

                 x(k)=i+size
                 y(k)=time_of_day(i)
                 k=k+1
                 x(k)=i+size
                 y(k)=0
                 k=k+1
              enddo
              x(k)=1-size
              y(k)=0
           endif
c
c  set defaults for output on tek screen and one hardcopy file
c
           open(65,file='catstat.eps',status='unknown')
           plotunit=65
           plotoption=1
           hctype=1
           wsize=60
c
c   open plotter
c
           call open_display 
c
c set some postscipt scalings
c
           write(65,*) ' 1.0 0.55 scale'
           if(iplot.eq.1) then
              title=  'Yearly number of events'
              xtext='                 Year               '
              ytext='     Number             '
              filename_gmt='catstat.gmt.year.out'   ! output file name for gmt
              gmt_ofilename='catstat.gmt.year.ps'   ! gmt output file name
           endif
           if(iplot.eq.2) then
              title=  'Monthly number of events'
              xtext='                 Year               '
              ytext='     Number             '
              filename_gmt='catstat.gmt.month.out'   ! output file name for gmt
              gmt_ofilename='catstat.gmt.month.ps'   ! gmt output file name
           endif
           if(iplot.eq.3) then
              write(title,'(a,i4,1x,2i2)')
     *        'Daily number of events starting from ',year1,month1,day1
              xtext='                 Days               '
              ytext='     Number             '
              filename_gmt='catstat.gmt.day.out'   ! output file name for gmt
              gmt_ofilename='catstat.gmt.day.ps'   ! gmt output file name
           endif
           if(iplot.eq.4) then
              title=  'Time of day distribution'
              xtext='                 Hour               '
              ytext='     Number             '
              filename_gmt='catstat.gmt.hour.out'   ! output file name for gmt
              gmt_ofilename='catstat.gmt.hour.ps'   ! gmt output file name
           endif
c
c   gmt stuff
c
           gmt_xtitle=xtext
           gmt_ytitle=ytext
           gmt_maintitle=title              ! title
           gmt_xsize=12.0                   ! y-size in cm
           gmt_xlog=0                       ! linear
           gmt_ysize=10.0                   ! x-size in cm
           gmt_ylog=0                       ! linear
           gmt_ntraces=1                    ! one data set

c
c  open gmt file and write out main parameters
c
           open(16,file=filename_gmt,
     *     status='unknown')

           call gmt_xy_par(16,1,1,x_gmt,y_gmt)
c
c   write out data
c
           call gmt_xy_par(16,0,n_gmt,x_gmt,y_gmt)
c
c   close gmt file
c
           close(16)


c
c   plot points
c
           call xy_plot
     *     (1,k,x,y,title,xtext,ytext,
     *     600.0,600.0,100.0,100.0,2,1,20.0,
     *     0,cha,i,x,y)
           text='Push any key to stop'
           call  tchars(text,20,750.0,700.0)
c
c  call up cursxor so plots remains
c
495        continue
           call xscursr(i,x(1),y(1))
           if (char(i).eq.'#') goto 495

c
c   close postscript
c
           call close_post
c
c   close output plot file
c 
           close(65)
c
c   close display and back to alpha screen
c
          call clear_to_alpha
          goto 1000            ! plot again
        endif
        
      if(iplot.gt.0) write(6,*)' Plot file is catstat.eps'
      write(6,*) ' Output files are: catyear.out : yearly data'
      print*, '                   catmonth.out: monthly data'
      print*, '                   catday.out  : daily data'
      print*, '                   cathour.out : hourly distribution' 
      print*, '    In addition, GMT prepared files                 ' 
      stop
      end
c-----------------------------------------------------------------------------

c                                                                               
c    transform rsa binary files to seisan data files
c    program works with 2 types from the network and the bb files
c
c    network: old format: parameter file must be *.dts, waveform file *.sad
c             new format: parameter file must be *.ds1, waveform file *.sa1
c                                                *.ds3                *.sa3
c    bb data: file nam emaust be *.hdr
c
c    j. havskov, 1992, 2000
c
c    updates:
c    sep 20 jh  : add type ds3
c    oct 17 jh  : fix for antactic dts format
c    dec 20     . add array char to file name
c    feb        : faster reading on sun, do as on pc
c                 fix bb reading for upper and lower case file name
c    mar          increase dimension
c                        
c
c    Parameter in defines type of file
c
c    in=0 : One binary file, work only on sun or pc due to byte swapping on vax
c    in=1 : Several ------, use filenr.lis as input file name
c                                                                               
c    latest update                                                              
c                                                                               
      implicit 	none
      include 'seidim.inc'
c
c-----------------------------------------------------------------------
c   start block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c
c--end block of definitions most conversion programs
c---------------------------------------------------------------------

c-- data vector, input and output                              
      integer*2  y(3000000),data(200000)
      integer*4  data4(200000)
c-- input file name
      character*80 infile
c-- event number in
      integer number
c-- total number of samples in all channels
      integer ntotal	  
c-- question
      character*80 question
c-- total time window                          
      real              total_time	
c-- help variables                                     
      integer           i,k,ib,in,j,dtemp,irec
c-- -------------                                    
      logical pc,sun,linux
c- RSA parameters-----------------------------------------------------	  
      integer*4 day1,month1,year1,hour1,min1,isec
      integer*4 max(32),ofset(32)
      real sec1,fsamp
      integer*2 mue(16)	  
      character*1 c	  
      integer*4 nmues
      character*5 stcod(32)
      character*80 fsad,fdts,fnor   !nombres de ficheros incluida via
      character extdts*4,extsad*4,extnor*4,via*60,filein*8
      logical bb     ! indicate bb station
      character*80 text
      common /dts/nchan,day1,month1,year1,
     *hour1,min1,sec1,max,ofset,fsamp,
     +nmues,stcod,fsad,fdts,fnor
c---------------------------------------------------------------------	 



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   get def file for station codes, give file name
c
       text='rsasei.def'
       net_code=' '
       call read_def_chan(text,mainhead_text,net_code)
	  
c
c  initially assumes one binary file
c
      in=0
c
c   set computer type
c
      call computer_type(sun,pc,linux)
c
c  get file name
c
      question='  Filename, ?, # or filenr.lis for all'
      call filename(question,infile)
c
c  check for no files
c
      if(infile(1:3).eq.'EOF') goto 99
c
c   check which type of input file
c
      if(infile(1:10).eq.'filenr.lis') then
         open(8,file='filenr.lis',status='old')
         in=1
      endif
c
c  back here if many binary files to convert using filenr.lis
c
 1    continue
      if(in.eq.1) then
         read(8,'(2x,i3,2x,a)') number,infile
         write(6,*)
         write(6,'(1x,i3,3x,a)') number,infile
         if(infile(1:4).eq.'    ') goto 99
      endif
c
c   open and read header file
c
      write(6,'(1x,a)') infile	  
      open(1,file=infile,status='old')
c
c   old format
c

      if(infile(10:12).eq.'DTS'.or.infile(10:12).eq.'dts') then
         call leedts
         infile(10:12)='SAD'
      endif
c
c new format
c
      if(infile(10:12).eq.'DS1'.or.infile(10:12).eq.'ds1'.
     *or.infile(10:12).eq.'DS3'.or.infile(10:12).eq.'ds3') then
         call leedt1
         infile(10:11)='SA'
      endif
c
c   bb format
c
      bb=.false.
      if(infile(10:12).eq.'HDR'.or.infile(10:12).eq.'hdr')then
         bb=.true.
         call leedt2
      endif
c                                                                               
c  fill in variables in common block 
c
      if(.not.bb) then
         if(year1.gt.50) year1=year1+1900
         if(year1.le.50) year1=year1+2000
      endif
      do i=1,nchan
         year(i)=year1
         month(i)=month1
         day(i)=day1
         hour(i)=hour1
         min(i)=min1
         sec(i)=sec1
         nsamp(i)=nmues
         rate(i)=fsamp
         cbyte(i)=' '
         if(bb) cbyte(i)='4'
         stat(i)=stcod(i)
         comp(i)='S  Z'
         if(bb.and.i.eq.1) comp(i)='B  Z'
         if(bb.and.i.eq.2) comp(i)='B  N'
         if(bb.and.i.eq.3) comp(i)='B  E'
      enddo
c
c  enter loop to define channels if a def file
c
       do i=1,nchan
          call set_def_chan(i,stat(i),comp(i))
       enddo

c
c   make seisan headers
c
      ichan=1      ! only main head
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   specially mark array data
c
      if(infile(8:8).eq.'G'.or.infile(8:8).eq.'N'.or.infile(8:8)
     *.eq.'M'.or.infile(8:8).eq.'F') outfile(30:30)=infile(8:8)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',outfile
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
      mainhead(1)(2:29)=mainhead_text    ! put in header text
      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo
c                                                       
c   check if not too many samples
c
         if(nmues.gt.200000) then
            write(6,*)' Too many samples/chan, nsamp= ',nmues
            stop
         endif			 
c
c   open input binary file if not bb
c
         if(.not.bb) then
c           if(.not.pc) then
c             open(1,file=infile,status='old',access='direct',recl=2)
c             open(1,file=infile,status='old',access='direct',
c    *        recl=nmues*2)
c           else
              open(1,file=infile,status='old',form='binary')
c           endif
         endif
c
c   network file
c
         if(.not.bb) then
c
c   read whole file into one array
c
            irec=0
            k=0    ! new
            do j=1,nmues
c              if(pc) then
                  read(1)(mue(i),i=1,nchan)
c              else
c                 do i=1,nchan
c                    irec=irec+1
c                    read(1,rec=irec)mue(i)
c                 enddo
c              endif
               do i=1,nchan
                  k=k+1                                       
                  y(k)=mue(i)                                         
               enddo
            enddo
            close(1)
            ntotal=k
         endif
c
c   channel write loop
c
       do ichan=1,nchan
c
c   make channel header	
c
         chahead=' '
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,stat,comp,
     *                    nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
c
c   get response info
c
        call read_resp_head(chahead)                                            
c
c   write header
c
         write(2)chahead
c                                                                            
c
         if(bb) then
            do i=11,12
              infile(i:i)=char(0)  ! sun did not like blanks in file name
            enddo
            if(ichan.eq.1) infile(10:10)='z'
            if(ichan.eq.2) infile(10:11)='ns'
            if(ichan.eq.3) infile(10:11)='ew'
            open(1,file=infile,status='old',access='direct',
     *      recl=4,err=888)
            goto 889
 888        continue
            if(ichan.eq.1) infile(10:10)='Z'
            if(ichan.eq.2) infile(10:11)='NS'
            if(ichan.eq.3) infile(10:11)='EW'
            open(1,file=infile,status='old',access='direct',recl=4)
 889        continue
            write(6,'(a,a)')' Opened file: ',infile
            do i=1,nsamp(1)
               read(1,rec=i) data4(i)
            enddo
            close(1)
            if(sun) call swap4(nsamp(1),data4)   ! swapping
            write(2)(data4(i),i=1,nsamp(1))
         else
            j=0
            do k=ichan,ntotal,nchan
               j=j+1
               data(j)=y(k)
            enddo
            if(sun) call swap2(nsamp(1),data)
            write(2)(data(k),k=1,nsamp(ichan))
         endif
      enddo
      close(2)                       
c
c  end read for one event
c                                                                               
c                                                                               
c   back for next event if a list of events are transformed
c                                                        
      if(in.eq.1) goto 1          
c                                                                               
c   end of data                                                                 
c                                                                               
 99   continue                                                                  
      stop                                                                      
      end                                                                       
c
cccccccccccccccccccc--------------ccccccccccccccccccccccccccc

 
      SUBROUTINE leedts()
c
c   read header for dts file
c
c   not clear who wrote the original routine
c
      include 'libsei.inc'
      integer*4 nchan,day,month,year,hour,min,max(32),ofset(32)
      integer*4 nmues
      character*5 stcod(32)
      character*80 fsad,fdts,fnor   !nombres de ficheros incluida via
 
      common /dts/nchan,day,month,year,hour,min,sec,max,ofset,fsamp,
     +            nmues,stcod,fsad,fdts,fnor 
      character*5 cod
      integer*4 maxi,code
      character*80 linea
      read (1,'(a80)') linea
      call remove_letters(linea)
      call sei get values(1,linea,code)
      nchan=array$(1)
      
      write (6,*) 'nchan= ',nchan
      read (1,'(a80)') linea
      call remove_letters(linea)
      call sei get values(1,linea,code)
      nmues=array$(1)

      write (6,*) 'nmues= ',nmues
      read (1,'(a80)') linea
      read (1,'(a80)') linea
      read (linea,'(I2,1X,I2,1X,I2)') year,month,day
      write (6,*) 'Date ',day,month,year
      read (1,'(a80)') linea
      call remove_letters(linea)
      write(6,*) linea
      read (1,'(a80)') linea
      call remove_letters(linea)
      write(6,*) linea
      read (linea,'(I2,1X,I2,1X,F5.2)') hour,min,sec
      write (6,*) 'hour ',hour,'h',min,'m',sec,'s'
      read (1,'(a80)') linea
      call remove_letters(linea)
      call sei get values(1,linea,code)
      fsamp=array$(1)

c      read (linea, '(F3.0)') fsamp
      write (6,*) fsamp,' sps'
      read (1,'(a80)') linea
      read (1,'(a80)') linea
         do 66 i=1,nchan
            read (1,'(a80)') linea
            read (linea,'(A4,18X,I4)') cod, maxi
c            stcod(i)=linea(:4)
            stcod(i)=cod
            max(i)=maxi
            write (6,*) stcod(i),'max ',max(i)
66       continue
c      close (1)
      end            


      SUBROUTINE leedt1()
      include 'libsei.inc'
      integer*4 nchan,day,month,year,hour,min,max(32),ofset(32)
      integer*4 nmues
      character*5 stcod(32)
      character*80 text
      character*80 fsad,fdts,fnor   !nombres de ficheros incluida via
 
      common /dts/nchan,day,month,year,hour,min,sec,max,ofset,fsamp,
     +            nmues,stcod,fsad,fdts,fnor 
      character*5 cod
      character*80 linea
      integer*4 maxi,code
c
c  number of channels
c
      read (1,'(a)') text
      call sei get values(1,text,code)
      nchan=array$(1)
c
c   number of samples
c
      read (1,'(15x,a)') text
      call sei get values(1,text,code)
      nmues=array$(1)
c
c   sample rate
c
      read (1,'(15x,a)') text
      call sei get values(1,text,code)
      fsamp=array$(1)

c
c   time and date
c
      read (1,'(a)') text
      do i=1,80
         if (text(i:i).eq.'/'.or.text(i:i).eq.':') text(i:i)=' '
      enddo
      write(6,*) text
      call sei get values(6,text,code)
      year=array$(1)
      month=array$(2)
      day=array$(3)
      hour=array$(4)
      min=array$(5)
      sec=array$(6)

      write (6,*) 'fecha ',day,'-',month,'-',year
      write (6,*) 'hora ',hour,'h',min,'m',sec,'s'
      read(1,'(a)') text
         do 66 i=1,nchan
            read (1,'(a)') stcod(i)
c            write (6,*) stcod(i)
66       continue
      end            
      
      SUBROUTINE leedt2()
c
c  for bb files
c
      include 'libsei.inc'
      integer*4 nchan,day,month,year,hour,min,max(32),ofset(32)
      integer*4 nmues
      character*5 stcod(32)
      character*80 text
      character*80 fsad,fdts,fnor   !nombres de ficheros incluida via
 
      common /dts/nchan,day,month,year,hour,min,sec,max,ofset,fsamp,
     +            nmues,stcod,fsad,fdts,fnor 
      character*5 cod
      character*80 linea
      integer*4 maxi,code
      integer test
c
c  number of channels
c
      nchan=3

      do i=1,8
         read(1,'(a)') text
      enddo
c
c   sample rate
c
      read (1,'(24x,a)') text
      do i=1,40
         if(text(i:i).eq.'m'.or.text(i:i).eq.'p'.or.text(i:i).eq.'s')
     *   text(i:i)=' '
      enddo
      call sei get values(1,text,code)
      fsamp=array$(1)
      
      read(1,'(a)') text
      read(1,'(a)') text
      read(1,'(a)') text
c
c   time and date
c
      do i=1,80
         if (text(i:i).eq.'d'.or.text(i:i).eq.':'.or.
     *    text(i:i).eq.'e'.or.text(i:i).eq.'l') text(i:i)=' '
      enddo
      write(6,*) text
      call sei get values(6,text,code)
      year=array$(6)
      month=array$(5)
      day=array$(4)
      hour=array$(1)
      min=array$(2)
      sec=array$(3)

      write (6,*) 'fecha ',day,'-',month,'-',year
      write (6,*) 'hora ',hour,'h',min,'m',sec,'s'
c
c   number of samples
c
      read(1,'(a)') text
      read (1,'(33x,a)') text
      do i=1,40
         if(text(i:i).eq.'s'.or.text(i:i).eq.'.') text(i:i)=' '
      enddo
      call sei get values(1,text,code)
      nmues=array$(1)*fsamp
c
c   station codes
c
       if(test.ne.999999) then
     
       write(6,*)' Give station code'
       read(5,'(a)') stcod(1)
       stcod(2)=stcod(1)
       stcod(3)=stcod(1)
       endif
       test=999999    ! only do above one time

       return
       end
      
      

c
c  program to merge and split seisan waveform files. All valid seisan formats can be used
c  as input, but output will be seisan or mseed only
c
c  j. havskov, december 1991
c  Updates:
c  4.2 -92  c.l.: Fix small bug at OVSICORI
c  28-4-92  j.h.: Automatic event merging within certain time window
c  16-10-92     : Increase array dim to 100000
c  21-10-92     : check if more than 30 chan, if split, also use component
c                 in file name
c  18 8 93  jh  : max duration to 9000 secs, variable max-ev-dif
c  23 8 93      : filename and question to 80
c  jun 94       : 999 channels,bug with last channel, bug
c  aug 2        : in split, use 4 chars stat for file name instead of 3
c  sep 5        : only duplicates of also header time the same
c  sep 23       : bug in split when more than 30 channels
c  oct 5        : bug in merge when 30, 33, 36 etc channels
c  dec 7        : new seidim
C  dec 8        : Installed file & error handling (libsei)
c  dec 13       : ********* version 5.0 *****************
c  dec 28       : bug with backspace
c  jan 4 95     : close files, too many opened
c  jan 30       : bug
c  mar 31, 95,jh: not closing file in split mode, too many open
c  oct 95       : using seisinc routine to read
c  mar 26  96   : if interval > 9999, write with f7.1
c  mar 26  97   : fix probelm of wrong merge, caused by seisinc
c                 not reading header
c  sep 28  97 jh: fix splitting problem of wrong file names
c                 add input from s-file for info on merge
c  mar 9   98   : send message if no merge
c  jun  5 98    : not require blank line at end of filenr.lis
c  jun 18 98  lo: net_code is read from SEISAN.DEF
c-------------------------------------------------------------------------
c  oct 98 jh    : ----------------   version 7.0 check -----------------
c                 year 2000, station names to 5 char, base or agency to 5 chars
c  nov 5 98     : remove computer type
c  nov 26  jh   : enable merge from eev for event in wav base
c  jan 05 99 lo : bug with date and hour in filename
c  jAN 8   JH   : fix compare file names
c  nov 2 99     : some check for null chars
c  dec 6        : close read02 when splitting
c  march 23 00  : add number to file name when splitting for easy sorting
c  june 17 01   : taken out return confirmation, for use with Seisan
c  nov 24 03 jh : changed totoal time window from 99000 to 130000
c  oct 2006  jh : new waveform reading routines, remove option of getting
c                 input from eev, does not seem to be used, can now usee mseed
c  oct 21 2007 : remeove variabels wav_mseed_location and replace 
c                by wav_location, same for network
c                bug fixing
c  aug 1 08 lo : fixed bug, channel number was wrong
c
      implicit none
c
      include 'seidim.inc'                ! dimensions
      include 'seisan.inc'                ! seisan defintions
      include 'waveform.inc'              ! for common waveform structure
      include 'seed.inc.f'                ! seed reading
      include 'write_mseed.inc.f'	  ! seed writing

c-- main header
      character*80 mainhead(max_trace)
c-- help variable
      character*80 text
c-- channel header
      character*1040 chahead	  
c-- input file names
      character*80 infile(999) ! increased from 64, lo June 27, 2001
c-- output file name 
      character*80 outfile	  
c-- number of files, one event
      integer ifile	  
c-- input indicator
      integer in 
c-- input question
      character*80 question	  	  
c-- station counter
      integer istat,nstat	  
c-- number of stations and samples
      integer nsamp,nchan	  
c-- merged file network code
      character*5 net_code	  	  
c-- function
      integer sei clen
c-- event start time
      double precision ev_time(max_trace)
c-- max time between event in order to merge the events
      real max_ev_dif
c-- channel duplication indicator
      integer dup(max_trace)
c-- number of duplicate channels
      integer ndup	  	  
c-- maximum and minumum of above and their difference
      double precision first_time,last_time, total_window	  	  
c-- counters
      integer i,j,k,l,ich,khead
c-- selcector for two parts of program
      integer select
c--- output format
      character*6 out_format
      integer mseed_block                 ! count mseed blocks whrn writing out
      logical op_file,open_file           ! for opening mseed output  file


C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code,                  ! Error encoder.
     &          sei real num               ! Get real number
C
       integer  write01,                   ! Output unit 1.
     &          read01,                    ! Input unit1.
     &          read02,                    ! Ditto 2.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       character*80 chr_file               ! File name
       real sei real num                   ! Real number
C
C    ============= end of list ==========
c


c
c print version
c
      include 'version.inc'
      out_version_date='October 2006'
      if (version_new) out_version_date=version_date
      call print_ver

c	  	  
      merge_wav='MERGE'
      call get_seisan_def
      net_code=merge_wav
      
      max_ev_dif = 180.0	  	  
c
c   question if merge or split
c
      write(6,*)' Merge (1) or split (2) files:'
      read(5,*) select
      if(select.ne.1.and.select.ne.2) then
          write(6,*)' Wrong choice, stop'
          stop
       endif	
c
c   output format
c
 4646 continue   ! from just below
      write(6,*)' Output format, seisan or mseed ?'
      read(5,'(a)') out_format
      if(out_format(1:6).ne.'seisan'.
     *and.out_format(1:5).ne.'mseed') then
         write(6,*)' Wrong format, try again'
         goto 4646
      endif
c
c   go to split if selected
c
      if(select.eq.2) goto 500
c	 		 	  	  	  	  	  	  
      write(6,*)
     *   ' Give 1-5 letter network code for merged file(s),'
     *,' ',merge_wav,' is default'
      read(5,'(a5)') net_code
      if(net_code.eq.'     ') net_code=merge_wav 
  678 continue
      write(6,*) ' Maximum difference (sec) of events to merge,',
     *' return for default (180 secs)'
      read(5,'(a)') text
      if(text(1:4).eq.'    ') then
         max_ev_dif=180.0
      else
         max_ev_dif = sei real num(text,code)
         if(code .ne. e_ok$) then
            write (6,*) ' wrong value'
            go to 678
         end if
      endif

c
c   open file with file names
c	  	  
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'filenr.lis',     ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
         if (code .ne. e_ok$) go to 10
         goto 11
 10      continue
         write(6,*)' No filenr.lis file, make a dirf first'
         stop
 11      continue
 
c 
c----------------------------------------------
c   enter here for new group of events to merge
c----------------------------------------------
c
 1    continue 
c
c   read headers of group of files to merge, first initialize wav arrays
c
      call wav_init
      wav_out_nchan=0
c
      ifile=1
 20   continue 		
      read(read01,'(7x,a)', end=50) infile(ifile)
c
c-- check if end of group of events to merge	  
c
      if(infile(ifile)(1:4).eq.'    ') goto 50 	  	   	  	  
c
c   now read headers for one event
c	  
 30   continue

      wav_filename(ifile)=infile(ifile)
c
c   read headers
c
      call read_wav_header(ifile)

c
c  get event abs time and check if within current event merge window
c  the input from filenr.lis must be backspaced to begin next time
c  with correct event
c

      if(ifile.eq.1) then
         k=1
      else
         k=ifile-1
      endif
      if(abs(wav_abs_time(ifile)-wav_abs_time(k)).gt.max_ev_dif)
     *  then
        backspace read01
        goto 50
      endif
      wav_out_nchan=wav_nchan ! avoid late channels to be added
c
c-- go to get next event file
c
      ifile=ifile+1
      if (ifile.gt.999) then
        write(*,*)  ' Too many files '
        stop
      endif
      goto 20
c
c------------------------------------------------------------
c   all files headers of files to merge read for one event
c------------------------------------------------------------
c	  	  	 
 50   continue 	 
      write(6,*)
      write(6,*)
      ifile=ifile-1  
      wav_nchan=wav_out_nchan
      if(ifile.eq.0) goto 999
      write(6,*)' Number of files to merge', ifile
c
c   find earliest trace, total time window and delay relative to earliest time
c
      call wav_index_total 	  
c
c   check if total time window is reasonable
c

      if(wav_total_time.gt.130000.0) then
         write(6,*)' Total time window is:',total_window,' secs'
         write(6,*)' This is unrealsistic, event is skipped'
c         write(6,*)' Return to continue		 '
c         write(6,*)
c         read(5,'(a1)') i		 		 
         goto 1
      endif		 		 		 	  	   		 		 	  
c
c   mark identical channels to be removed on merging 
c
      do i=1,wav_nchan
         dup(i)=0
      enddo		 	   
      ndup=0
      do i=1,wav_nchan
         do j=i,wav_nchan
c
c  send a message if station and components are the same while header times
c  are different, the two channels might belong to different events
c
          if(wav_stat(i).eq.wav_stat(j).and.wav_comp(i).eq.wav_comp(j).
     *    and.wav_location(i).eq.wav_location(j).
     *    and.i.ne.j.and.wav_abs_time(i).ne.wav_abs_time(j)) then   ! check if duplicate
              write(6,'(1x,a,1x,a4,1x,a4)')
     *        ' Same station and component, different time',
     *        wav_stat(i),wav_comp(i)
c              write(6,*)' Return to continue'
c              read(5,'(a)') text
           endif
          if(wav_stat(i).eq.wav_stat(j).and.wav_comp(i).eq.wav_comp(j).
     *    and.wav_location(i).eq.wav_location(j).
     *    and.i.ne.j.and.wav_abs_time(i).eq.wav_abs_time(j)) then   ! check if duplicate
c
c   check that channel has not already been counted as duplicated
c
              if(dup(j).ne.1) then
                 dup(j)=1
                 ndup=ndup+1			  
              endif
           endif
        enddo
      enddo
      write(6,*)wav_nchan, ' Number of input channels'
      if(ndup.gt.0) 
     *write(6,*) ndup,' duplicate channels will not be merged'
  
c   check if not too many channels, max 999
c
      if(wav_nchan-ndup.gt.999) then
         write(6,*)' Number of output channels is:',wav_nchan-ndup
         write(6,*)' Max allowed is 999, will stop'
         stop
      endif
c
c   remove duplicate channels if any
c
      if(ndup.gt.0) then
         k=0
         do i=1,wav_nchan
           if(dup(i).ne.1) then
              k=k+1
              call wav_select_sav(k,i)             
           endif
         enddo
c
c  put headers back
c
         wav_nchan=wav_nchan-ndup
         do i=1,wav_nchan
             call wav_copy_wav(i)
         enddo         
c
c  update header info
c
        
         call wav_index_total

      endif
c
c   section for writing out, seisan or mseed format
c
 
c
c   make new main seisan header, clear first, done for both formats to
c   get file name
C
      khead=(wav_nchan-1)/3+3
      if(khead.lt.12) khead=12    ! never less than 12 main headers
      do i=1,khead
         do j=1,80
            mainhead(i)(j:j)=' '
         enddo
      enddo
      call wav_sheads(1,net_code,outfile,mainhead,chahead) 
      if(out_format(1:5).eq.'mseed') outfile(19:19)='M'                                                              
      write(6,200) outfile(1:29)                                             
 200  format(' Output file name is: ',a29)                                
        
c
c   check that outfile name is not the same as one of the input
c   file names in which case the event should not be written out
c
         do i=1,ifile
            if(infile(i)(1:35).eq.outfile(1:35)) then
               write(6,*)'**************************************'
               write(6,*)'Output file already exists, skip merge'
               write(6,*)'**************************************'
               write(6,*)' Enter to continue'
               read(5,'(a)') k
               goto 1      ! try next group
            endif
         enddo
c
c---------------------------
c   seisan format
c---------------------------
c
      if(out_format(1:6).eq.'seisan') then
c      
c   open output file and write main header
c
          chr_f_form$ = 'unformatted'
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
         do i=1,khead
            write(write01)mainhead(i)
            write(6,'(a80)') mainhead(i)		 
         enddo
c
c   channel loop
              
c
c   write output file                       
c
         do j=1,wav_nchan
            call wav_read_channel(j)                            ! read one trace, read as integer, converted to real
            call wav_sheads(j,net_code,outfile,mainhead,chahead)  ! make channel header
            write(write01) chahead                                     ! write channel header
            write(write01)(int(signal1(l)),l=1,wav_nsamp(j))         ! write trace, converted to integer
         enddo
cx   2 byte integers not taken care of	 		 

c
c close
c
         call sei close(close$,write01, code)
      else
c
c-----------------------------------------------------------
c  mseed format
c-----------------------------------------------------------
c
          mseed_block=1     ! start writing in first block
c
c   open mseed file
c
          op_file=open_file(96,outfile,12)   ! use block size 4096=2**12
          if(.not.op_file) then
             write(6,*) 'Error opening miniseed output file'
             stop
          endif
          do i=1,wav_nchan
c
c   read one channel
c
            call wav_read_channel(i)
c
c   transfer data to writing array
c
            mseed_year=wav_year(i)
            mseed_month=wav_month(i)
            mseed_day=wav_day(i)
            mseed_hour=wav_hour(i)
            mseed_minute=wav_min(i)
            mseed_second=wav_sec(i)
            mseed_station=wav_stat(i)
            mseed_channel(1:2)=wav_comp(i)(1:2)
            mseed_channel(3:3)=wav_comp(i)(4:4)
            mseed_total_samples=wav_nsamp(i)
            mseed_sample_rate=wav_rate(i)
c
c  if input channel is from a seed file, location and network is 
c  from there, else it is blank
c
c  oct 2007   should not be needed neo seince seisan also can have
c             location and network, no tsure about other input formats
c
c           write(6,*) i,wav_file_format(wav_file_nr_chan(i)),
c    *      seed_location(i)
c           if(wav_file_format(wav_file_nr_chan(i))(1:8).eq.
c    *      'MINISEED'.or.wav_file_format
c    *      (wav_file_nr_chan(i))(1:4).eq.'SEED') then
               mseed_location=wav_location(i)
               mseed_network=wav_network(i)
c           else
c              mseed_location='  '
c              mseed_network='  '
c           endif
            mseed_encoding=steim1               ! steim1
            do l=1,wav_nsamp(i)
               signal_int(l)=signal1(l)
            enddo          
            call seed_write_chn(96,signal_int,mseed_block)
        enddo         
        close(96)
      endif
 
       
c
c   back to check if more groups of files to merge 
c	  
      goto 1  		 						   			   
   

c---------------------------------------------------------------------------
c---------------------------------------------------------------------------
c
c Section for splitting a file	  
c
c---------------------------------------------------------------------------
c----------------------------------------------------------------------------
c
 500  continue
c
c   open file 
c
      in=0
      question=' Filename, # or filenr.lis for all'
      call filename(question,infile(1))
      if(infile(1)(1:3).eq.'EOF') stop
      if(infile(1)(1:10).eq.'filenr.lis') then	  	  	  	  
c        write(6,*) 'open'
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'filenr.lis',     ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
      if (code .ne. e_ok$) go to 110
         in=1		 
         goto 111
 110     continue
         write(6,*)' No filenr.lis file, make a dirf first'
         stop
 111     continue
      endif 
c
c   here starts a new event to split if many using filenr.lis
c
c      write(6,*) 'start'
 100  continue 
      if(in.eq.1) then  
         read(read01,'(7x,a)', end=999) infile(1)
         if(infile(1)(1:3).eq.'   ') goto 999
      endif		 
      write(6,'(1x,a)') infile(1)
c
c   now read headers for one event
c
       call wav_init	  
       wav_filename(1)=infile(1)
       call read_wav_header(1)

c
c   loop for writing out single channels
c
      do j=1,wav_nchan

c
c   make new main seisan header, clear first, done for both formats to
c   get file name
c
         do i=1,12
           do k=1,80
              mainhead(i)(k:k)=' '
           enddo
         enddo	
c
c  select channel to output array, index 1
c
         call wav_select_sav(1,j)
c
c   only one channel
c
         wav_sav_nchan=1
c
c   make header
c
         call wav_sav_sheads(1,wav_stat(j),outfile,
     *   mainhead,chahead) 
         if(out_format(1:5).eq.'mseed') outfile(19:19)='M' 	  
c
c
c   add componenets to make filenames different for different channels
c
         outfile(30:30)='_'
c
c   add number to make component sorting easier
c
         outfile(31:33)=wav_comp(j)(1:3)
         outfile(34:34)='0'
         if(wav_comp(j)(4:4).eq.'Z') outfile(34:34)='1'
         if(wav_comp(j)(4:4).eq.'N') outfile(34:34)='2'
         if(wav_comp(j)(4:4).eq.'E') outfile(34:34)='3'
         outfile(35:35)=wav_comp(j)(4:4)
         do i=31,35
            if(outfile(i:i).eq.' '.or.outfile(i:i).eq.char(0)) 
     *      outfile(i:i)='_'
         enddo
c-- check for blanks                                        
         do i=1,29				
            if(outfile(i:i).eq.' '.or.outfile.eq.char(0)) 
     *      outfile(i:i)='0'                            
         enddo                                                                  
         write(6,'(1x,a)') outfile(1:35)
         write(6,'(a80)') mainhead(1)	                                             
         write(6,*)


c---------------------------
c   seisan format
c---------------------------
c
         if(out_format(1:6).eq.'seisan') then
c      
c   open output file and write main header
c
            chr_f_form$ = 'unformatted'
            call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   outfile,          ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
            do i=1,12
               write(write01)mainhead(i) 
            enddo

c
c   write output file                       
c
            call wav_read_channel(j)                         ! read one trace, read as integer, converted to real
            write(write01) chahead                           ! write channel header
            write(write01)(int(signal1(l)),l=1,wav_nsamp(j)) ! write trace, converted to integer
         
cx   2 byte integers not taken care of	 		 

c
c close
c
            call sei close(close$,write01, code)
         else
c
c-----------------------------------------------------------
c  mseed format
c-----------------------------------------------------------
c
            mseed_block=1     ! start writing in first block
c
c   open mseed file
c
            op_file=open_file(96,outfile,12)   ! use block size 4096=2**12
            if(.not.op_file) then
               write(6,*) 'Error opening miniseed output file'
               stop
            endif
c
c   read one channel
c
            call wav_read_channel(j)
c
c   transfer data to writing array
c
            mseed_year=wav_year(j)
            mseed_month=wav_month(j)
            mseed_day=wav_day(j)
            mseed_hour=wav_hour(j)
            mseed_minute=wav_min(j)
            mseed_second=wav_sec(j)
            mseed_station=wav_stat(j)
            mseed_channel(1:2)=wav_comp(j)(1:2)
            mseed_channel(3:3)=wav_comp(j)(4:4)
            mseed_total_samples=wav_nsamp(j)
            mseed_sample_rate=wav_rate(j)
c
c  if input channel is from a seed file, location and network is 
c  from there, else it is blank
c
c            write(6,*) j,wav_file_format(wav_file_nr_chan(j)),
c     *      seed_location(i)
            if(wav_file_format(wav_file_nr_chan(j))(1:8).eq.
     *      'MINISEED'.or.wav_file_format
     *      (wav_file_nr_chan(j))(1:4).eq.'SEED') then
               mseed_location=wav_location(j)
               mseed_network=wav_network(j)
            else
               mseed_location='  '
               mseed_network='  '
            endif
            mseed_encoding=steim1               ! steim1
            do l=1,wav_nsamp(j)
               signal_int(l)=signal1(l)
            enddo          
            call seed_write_chn(96,signal_int,mseed_block)     
            close(96)
          endif
c
c   end of channel loop
c	  
      enddo		
c
c   mulitievent mode
c
      if(in.eq.1) goto 100
c
c   single event mode
c	  
      goto 500	  	  	   
c
 999  continue	  
      call sei close(close$+all$,read01, code)       ! Close all open files.
      stop
      end	  	  	 

c***************************************************************************
      subroutine CASEFOLD(cn) ! Urs Kradolfer, 20. Feb. 1990
c
c Input : character-string of any length
c Output: same character-string, but all letters are CAPITAL now
c         (other characters are not changed)
c
c   --> this subroutine needs the function TRIMLEN !
c
c Call  : call CASEFOLD(charstring)
c
      implicit none
      character cn*(*)
      integer i, trimlen,ilen, ival
      ilen=trimlen(cn)
      do i=1,ilen
         ival=ICHAR(cn(i:i))
         if(ival.ge.97.and.ival.le.122)then
            cn(i:i)=CHAR(ival-32)
         endif
      enddo
      RETURN
      end ! of subroutine casefold
c
c***************************************************************************
      integer function TRIMLEN(t)   ! Urs Kradolfer, June 1986
c
c     Call:    nc=TRIMLEN(char)
c
c          --> nc says, how many characters the input-string has
c              (ignoring trailing blanks!).
c
      implicit none
      character t*(*)
      do 1 trimlen=LEN(t),1,-1
    1    if(t(trimlen:trimlen).ne.' ')RETURN
      trimlen=1
      end ! of integer function trimlen
c
c***************************************************************************

      integer function TRIMBEG(t)   ! Urs Kradolfer, 17.1.90
c
c     Call:    nc=TRIMBEG(char)
c
c          --> nc returns the position of the first characters of
c              the input-string (ignoring leading blanks!).
c
      implicit none
      character t*(*)
      do 1 trimbeg=1,LEN(t)
    1    if(t(trimbeg:trimbeg).ne.' ')RETURN
      trimbeg=1

      end ! of integer function trimbeg


C=======================================================================

      SUBROUTINE JULIEN(IJ,IM,IY,IJD,ISI)

C=======================================================================
C     CONVERTS IJ,IM,IY -> IY,IJD      FOR ISI >= 1
C     CONVERTS IY,IJD   -> IJ,IM,IY    FOR ISI <= 0
C     EX:  IJ,IM,IY = 21 02 80    IY,IJD = 1980 52

      INTEGER IMO(12)
      DATA IMO/31,28,31,30,31,30,31,31,30,31,30,31/

      IF(MOD(IY,4).EQ.0) IMO(2)=29
      IF(IY.LT.1900) IY=IY+1900
      if  (iy .lt. 1970)  iy = iy + 100   ! K.S. 20-Aug-98

      IF(ISI.GE.1) THEN
        IJD=0
        DO 10 I=1,IM-1
   10   IJD=IJD+IMO(I)
        IJD=IJD+IJ
      ELSE
        IDL=IJD
        DO 30 I=1,12
        IF(IDL.LE.IMO(I)) GOTO 40
   30   IDL=IDL-IMO(I)
   40   IJ=IDL
        IM=I
      ENDIF

      RETURN
      END

c***************************************************************************
c
      subroutine DIF1(iy,nmax)
c
c     Do Data-compression (first differences)
c
c     Urs Kradolfer, January 1990
c
      implicit none
      integer nmax, iy(nmax), k, xim1, xtemp
c
      xim1=iy(1)
      do k=2,nmax
         xtemp=iy(k)
         iy(k)=xtemp-xim1
         xim1=xtemp
      enddo
c
      RETURN
      end ! of subroutine dif1
c
c***************************************************************************
c
      subroutine REMDIF1(iy,nmax)
c
c     Remove Data-compression (first differences)
c
c     Urs Kradolfer, January 1990
c
      implicit none
      integer nmax, iy(nmax), k
c
      do k=2,nmax
         iy(k)=iy(k)+iy(k-1)
      enddo
c
      RETURN
      end ! of subroutine remdif1
c
c***************************************************************************
      integer*4 function icheck_sum_gse1(ix,n)
c     Karl Koch, May 1995
      integer*4 ix(n),n
      integer*4 i,nchk

      nchk=0
      do i=1,n
         nchk=nchk+ix(i)
      enddo
      icheck_sum_gse1=nchk
      return
      end

c
c***************************************************************************
      integer*4 function icheck_sum_gse2(ix,n)
c     Karl Koch, May 1995
      integer*4 ix(n),n
      integer*4 i,nchk,ixx
      integer*4 MODULO_VALUE
      parameter (MODULO_VALUE = 100 000 000)
      integer*4 modulo
c
      modulo=MODULO_VALUE
      nchk=0
      do i=1,n
        ixx=ix(i)
        if (abs(ixx).ge.modulo) ixx=ixx-(ixx/modulo)*modulo
           nchk=nchk+ixx
        if (abs(nchk).ge.modulo) nchk=nchk-(nchk/modulo)*modulo
      enddo
      icheck_sum_gse2=abs(nchk)
      return
      end



c ==============================================================================



      subroutine get_flags( ifmt, flags )

c     Parses format string 'ifmt' and extracts flags appended after '-'.
c     'ifmt' is truncated at '-'.
c     K. Stammler, 20-Aug-98

c     -- parameters
      character*(*)   ifmt     ! user input (modified)
      character*(*)   flags    ! flag string found (output)

c     -- local variables
      integer         strlth   ! length of input string
      integer         i, j     ! counter
      logical         f_found  ! flags found

c     -- functions
      integer         trimlen

c     -- executable code

      flags = ' '
      strlth = trimlen( ifmt )
      f_found = .false.
      j = 1
      do  i=1,strlth
         if  (f_found)  then
            flags(j:j) = ifmt(i:i)
            ifmt(i:i) = ' '
         endif
         if  (ifmt(i:i) .eq. '-')  then
            f_found = .true.
            ifmt(i:i) = ' '
         endif
      enddo

      end ! of subroutine get_flags



c ==============================================================================

      subroutine shead(year,month,day,hour,min,sec,
     *                 stat,comp,nsamp,rate,cbyte,
     *                 chahead)
c
c   make a seisan channel header, dec 97 
c
c   updates
c   sep 98 jh : --------------    version 7.0 check ---------------
c               year 2000, 5 char station name
c
c   input: year, month...  : date etc of each channel
c          stat,comp       : station and channels for channel
c          nsamp           ; number of samples for channel
c          rate            ; sample rate -----------------
c          cbyte           : 2 or 4 byte
c          chahead         : channel header for ichan
c          
c          
c          
      implicit none
c-- channel header
      character*1040 chahead
c-- stations and components
      character*5 stat
      character*4 comp	  
c--channel header date and times	  
      integer year,month,day,doy,hour,min
      real sec
c-- channel samples and sample rate
      integer nsamp
      real rate	  
c-- channel 2 or 4 byte
      character*1 cbyte
      integer i
c
c   make one channel header
c
c
c   clear
c
        do i=1,1040
           chahead(i:i)=' '
        enddo
c
c   station and component
c
        chahead(1:5)=stat
        chahead(6:9)=comp
c--  year
        write(chahead(10:12),'(i3)') year-1900
c
c  calculate doy
c
      call date_doy(doy,day,month,year)
c-- doy
        write(chahead(14:16),'(i3)') doy
c-- month
        write(chahead(18:19),'(i2)') month
c-- day
        write(chahead(21:22),'(i2)') day
c-- hour
        write(chahead(24:25),'(i2)') hour
c-- min
        write(chahead(27:28),'(i2)') min
c-- sec
        write(chahead(30:35),'(f6.3)') sec
c-- sample rate
        write(chahead(37:43),'(f7.2)') rate
c-- number of samples
        write(chahead(45:50),'(i6)') nsamp
c-- 2 or 4 byte
        chahead(77:77)=cbyte
      return
      end

********************************************************************
c
c-this subroutine checks the type line for all lines and
c-calls the specific subroutine to check the line.
c-after the line checked, it prints the error if some was found
c
c     Input:
c       data: records
c       nrec: number of records
c       evfile: file name
c       unit_number: unit number
c
c     Output:
c       nerr: number of errors found
c       gate: output destination
c         0 - screen
c         1 - file
c         2 - both
c
c     written by Carlos Eduardo Vieira, Nov. 1994.
c     Updates:
c
c     dec 14, 94 by j.h. : error using i15 format on pc
c     dec 15             : check if type 1 line first in file
c     dec 29             : accept tline type E, but do not check
c     jun 7              : accept R and T components
c     jun9               : accepct locating indicator *
c     jan 8 96           : accept component V
c     feb 28, 97         : accept id line UP, phase secs in field 23-27
c                          accept magnitude without type
c                          seconds =60 on main header, seconds up to 500 for
c                          phase time
c     nov 12             : accept DUB, NEW, REE
c     aug 98 by jh       : ----------   version 7.0 check ------------------
c                          station name to 5 char
c     oct 01 99 jh       : accept DUP
c     oct 4              : accept ARG
c     jan 7 00           : accept year ge 2000 in id line
c     may 2000 jh        : add  IRIS channel band codes
c     oct 24             : add H-line
c     mar 2 2001 jh      : accept distnace in f-format
c
      subroutine check_s(data,nrec,evfile,nerr,gate,unit_number)
      implicit none
      character*80 data(*)           ! records
      integer nrec                   ! number of records
      character*80 evfile            ! file name
      integer nerr                 ! number of errors found
      integer gate                   ! output destination
      character*80 ermsg(80)           ! array for error message
      character*1 tline               ! type line
      character*80 cline              ! current line
      integer uni                     ! output unit
      integer i                       ! counter
      integer ind                     ! index
      integer nerror                  ! aux for number of errors
      logical line1                   ! flag for line type 1
      logical lineID                  ! flag for line type ID
      logical errorfound              ! flag for error found 
      integer unit_number             ! unit number

      uni = 6
      nerr = 0
      nerror = 0
      lineID = .false.
      line1 = .false.
      errorfound = .false.
c
c   check that the first line is of type 1, if not add type 1
c
         if(data(1)(80:80).ne.'1') then
               data(1)(80:80)='1'
               if(gate.eq.0.or.gate.eq.2) 
     *         write(6,*)' No line type of first line,',
     *         ' assume type 1'
               if(gate.gt.0) write(unit_number,*)
     *         ' No line type of first line,',
     *                       ' assume type 1'
         endif
c
c-reads until end of file
      do i=1,nrec 
c-sets variable 'cline' with the current line
         cline = data(i) (1:80)
c-sets variable 'tline' with the type line
         tline = cline (80:80)
c-clears the error message variable
         do ind=1,80
            ermsg(ind) = ' '
         end do
         ind = 1
c-checking the type line
         if (tline .eq. '1') then
            line1 = .true. 
            call check_line_type_1(cline,ermsg,nerr)
         else if (tline .eq. '2') then
            call check_line_type_2(cline,ermsg,nerr)
         else if (tline .eq. '4' .or. tline .eq. ' ') then
            call check_line_type_4(cline,ermsg,nerr)
         else if (tline .eq. '6') then
            call check_line_type_6(cline,ermsg,nerr)
         else if (tline .eq. 'F') then
            call check_line_type_F(cline,ermsg,nerr)
         else if (tline .eq. 'I') then
            lineID = .true.
            call check_line_type_I(cline,ermsg,nerr)
         else if (tline .ne. '1' .and. tline .ne. '2' .and.
     1            tline .ne. '3' .and. tline .ne. '4' .and.
     2            tline .ne. '5' .and. tline .ne. '6' .and.
     3            tline .ne. '7' .and. tline .ne. 'F' .and.
     4            tline .ne. 'I' .and. tline .ne. 'E' .and.
     5            tline .ne. 'H') then
                  if (gate .eq. 0) then
                     uni = 6
                     write( uni,*) ' Unexpected type line'
                     write( uni,*) cline
                  else if (gate .eq. 1) then
                     uni = unit_number
                     if (.not. errorfound) then
                         write( uni,*) '  '
                         write( uni,*) '  '
                         write( uni,*) '  '
                         write(uni,*)'Error found in file: ',evfile
                         errorfound = .true.
                     end if
                     write( uni,*) 'Unexpected type line'
                     write( uni,*) cline
                  else if (gate .eq. 2) then
                     uni = 6
                     write( uni,*) ' Unexpected type line'
                     write( uni,*) cline
                     uni = unit_number
                     if (.not. errorfound) then
                         write( uni,*) '  '
                         write( uni,*) '  '
                         write( uni,*) '  '
                         write(uni,*)'Error found in file: ',evfile
                         errorfound = .true.
                     end if
                     write( uni,*) 'Unexpected type line'
                     write( uni,*) cline
                  end if
         end if
c-checking if some error was found - if found, print it
         if (nerror .ne. nerr) then
            if (gate .eq. 0) then
                uni = 6
                write( uni,*)
                write( uni,'(a)') cline
                write( uni,'(a)') ermsg(ind) (1:80)
            else if (gate .eq. 1) then
                uni = unit_number
                if (.not. errorfound) then
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) 'Error found in file: ',evfile
                    errorfound = .true.
                end if
                write( uni,'(a)') cline
                write( uni,'(a)') ermsg(ind) (1:80)
            else if (gate .eq. 2) then
                uni = 6
                write( uni,'(a)') cline
                write( uni,'(a)') ermsg(ind) (1:80)
                uni = unit_number
                if (.not. errorfound) then
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write(uni,*) 'Error found in file: ',evfile
                    errorfound = .true.
                end if
                write( uni,'(a)') cline
                write( uni,'(a)') ermsg(ind) (1:80)
            end if
            nerror = nerr
         end if
      end do
         if (.not. line1) then
            if (gate .eq. 0) then
                uni = 6
                write( uni,*) ' Line type 1 is missing'
            else if (gate .eq. 1) then
                uni = unit_number
                if (.not. errorfound) then
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) 'Error found in file: ',evfile
                    errorfound = .true.
                end if
                write( uni,*) 'Line type 1 is missing'
            else if (gate .eq. 2) then
                uni = 6
                write( uni,*) ' Line type 1 is missing'
                uni = unit_number
                if (.not. errorfound) then
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) 'Error found in file: ',evfile
                    errorfound = .true.
                end if
                write( uni,*) 'Line type 1 is missing'
            end if
         end if
         if (.not. lineID) then
            if (gate .eq. 0) then
                uni = 6
                write( uni,*) ' Line type I is missing'
            else if (gate .eq. 1) then
                uni = unit_number
                if (.not. errorfound) then
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) 'Error found in file: ',evfile
                    errorfound = .true.
                end if
                write( uni,*) 'Line type I is missing'
            else if (gate .eq. 2) then
                uni = 6
                write( uni,*) ' Line type I is missing'
                uni = unit_number
                if (.not. errorfound) then
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) '  '
                    write( uni,*) 'Error found in file: ',evfile
                    errorfound = .true.
                end if
                write( uni,*) 'Line type I is missing'
            end if
         end if
      end 

c-this subroutine checks all the importants variables
c-for the line type 1
      subroutine check_line_type_1(cline,ermsg,nerr)
      implicit none
      character*80 cline           ! dummy current line
      character*1 ermsg(80)        ! dummy array for error message
      integer nerr               ! dummy for number of error
      real left                     ! value left after division 
      integer status                ! iostatus 
      integer year                  ! year
      integer month                 ! month
      integer day                   ! day
      integer hour                  ! hour
      integer minute                ! minutes
      real secnds                   ! seconds
      character*1 dind              ! distance indicator
      real latit                    ! latitude
      real long                     ! longitude
      real depth                    ! depth
      character*1 depind            ! depth indicator
      character*1 loind             ! locating indicator
      integer nstat                 ! number of stations used
      real rms                      ! RMS of time residuals
      real magn1                    ! magnitude no. 1
      character*1 tmagn1            ! type of magnitude no. 1
      real magn2                    ! magnitude no. 2
      character*1 tmagn2            ! type of magnitude no. 2
      real magn3                    ! magnitude no. 3
      character*1 tmagn3            ! type of magnitude no. 3
      
c-reading and checking status variable year
      read(cline (2:5),'(i4)',err=4,iostat=status) year
 4    continue    
      call check_status(nerr,status,ermsg,2,5)

c-reading and checking status variable month
      read(cline (7:8),'(i2)',err=5,iostat=status) month 
 5    continue 
      call check_status(nerr,status,ermsg,7,8)

c-reading and checking status variable day
      read(cline (9:10),'(i2)',err=6,iostat=status) day 
 6    continue 
      call check_status(nerr,status,ermsg,9,10)

c-reading and checking status variable hour
      read(cline (12:13),'(i2)',err=7,iostat=status) hour 
 7    continue
      call check_status(nerr,status,ermsg,12,13)

c-reading and checking status variable minute
      read(cline (14:15),'(i2)',err=8,iostat=status) minute 
 8    continue
      call check_status(nerr,status,ermsg,14,15)

c-reading and checking status variable secnds
      read(cline (17:20),'(f4.0)',err=9,iostat=status) secnds 
 9    continue
      call check_status(nerr,status,ermsg,17,20)

c-reading and checking status variable dind 
      read(cline (22:22),'(a1)',err=11,iostat=status) dind 
 11   continue
      call check_status(nerr,status,ermsg,22,22)

c-reading and checking status variable latit 
      read(cline (24:30),'(f7.0)',err=13,iostat=status) latit 
 13   continue
      call check_status(nerr,status,ermsg,24,30)

c-reading and checking status variable long 
      read(cline (31:38),'(f8.0)',err=14,iostat=status) long 
 14   continue
      call check_status(nerr,status,ermsg,31,38)

c-reading and checking status variable depth 
      read(cline (39:43),'(f5.0)',err=15,iostat=status) depth 
 15   continue
      call check_status(nerr,status,ermsg,39,43)

c-reading and checking status variable depind 
      read(cline (44:44),'(a1)',err=16,iostat=status) depind 
 16   continue
      call check_status(nerr,status,ermsg,44,44)

c-reading and checking status variable loind 
      read(cline (45:45),'(a1)',err=17,iostat=status) loind
 17   continue
      call check_status(nerr,status,ermsg,45,45)

c-reading and checking status variable nstat 
      read(cline (49:51),'(i3)',err=19,iostat=status) nstat 
 19   continue
      call check_status(nerr,status,ermsg,49,51)

c-reading and checking status variable rms 
      read(cline (52:55),'(f4.0)',err=20,iostat=status) rms 
 20   continue
      call check_status(nerr,status,ermsg,52,55)

c-reading and checking status variable magn1 
      read(cline (57:59),'(f3.0)',err=21,iostat=status) magn1 
 21   continue
      call check_status(nerr,status,ermsg,57,59)

c-reading and checking status variable tmagn1 
      read(cline (60:60),'(a1)',err=22,iostat=status) tmagn1 
 22   continue
      call check_status(nerr,status,ermsg,60,60)

c-reading and checking status variable magn2 
      read(cline (65:67),'(f3.0)',err=24,iostat=status) magn2 
 24   continue
      call check_status(nerr,status,ermsg,65,67)

c-reading and checking status variable tmagn2 
      read(cline (68:68),'(a1)',err=25,iostat=status) tmagn2 
 25   continue
      call check_status(nerr,status,ermsg,68,68)

c-reading and checking status variable magn3
      read(cline (73:75),'(f3.0)',err=27,iostat=status) magn3 
 27   continue
      call check_status(nerr,status,ermsg,73,75)

c-reading and checking status variable tmagn3 
      read(cline (76:76),'(a1)',err=28,iostat=status) tmagn3 
 28   continue
      call check_status(nerr,status,ermsg,76,76)

c-checking year
      if (year .le. 0 .or. year .gt. 2100) then
         call mark_error(nerr,ermsg,2,5)
      end if

c-checking month
      if (month .lt. 1 .or. month .gt. 12) then
         call mark_error(nerr,ermsg,7,8)
      end if

c-checking day finding out if month has 28, 29, 30 or 31 days
      if (month .eq. 01 .or. month .eq. 03 .or. month .eq. 05 .or.     
     1    month .eq. 07 .or. month .eq. 08 .or. month .eq. 10 .or.     
     2    month .eq. 12 .or. month .lt. 01 .or. month .gt. 12) then
         if (day .lt. 1 .or. day .gt. 31) then
            call mark_error(nerr,ermsg,9,10)
         end if
      else if (month .eq. 04 .or. month .eq. 06 .or.
     1         month .eq. 09 .or. month .eq. 11) then
         if (day .lt. 1 .or. day .gt. 30) then
            call mark_error(nerr,ermsg,9,10)
         end if
      else if (month .eq. 02) then
         left = year-int(year/4)*4
         if (left .eq. 0) then
            if (day .lt. 1 .or. day .gt. 29) then
               call mark_error(nerr,ermsg,9,10)
            end if
         else
            if (day .lt. 1 .or. day .gt. 28) then
               call mark_error(nerr,ermsg,9,10)
            end if
         end if
      end if

c-checking hour
      if (hour .lt. 00 .or. hour .gt. 23) then
         call mark_error(nerr,ermsg,12,13)
      end if

c-checking minutes
      if (minute .lt. 00 .or. minute .gt. 59) then
         call mark_error(nerr,ermsg,14,15)
      end if

c-checking seconds
      if (secnds .lt. 00 .or. secnds .gt. 60.0) then
         call mark_error(nerr,ermsg,17,20)
      end if

c-checking distance indicator
      if (dind .ne. 'L' .and. dind .ne. 'R' .and. dind .ne. 'D') then
         call mark_error(nerr,ermsg,22,22)
      end if

c-checking latitude
      if (latit .lt. -90 .or. latit .gt. 90) then
         call mark_error(nerr,ermsg,24,30)
      end if

c-checking longitude
      if (long .lt. -180 .or. long .gt. 180) then
         call mark_error(nerr,ermsg,31,38)
      end if

c-checking depth
      if (depth .lt. 0 .or. depth .gt. 900) then
         call mark_error(nerr,ermsg,39,43)
      end if

c_checking depth indicator
      if (depind .ne. 'F' .and. depind .ne. 'S' .and.
     1    depind .ne. ' ') then
         call mark_error(nerr,ermsg,44,44)
      end if

c_checking locating indicator
      if (loind .ne. 'F' .and. loind .ne. 'S' .and.
     1    loind .ne. ' '.and.loind.ne.'*') then
         call mark_error(nerr,ermsg,45,45)
      end if

c-checking number of stations used
      if (nstat .lt. 0) then
         call mark_error(nerr,ermsg,49,51)
      end if

c-checking rms
      if (rms .lt. 0) then
         call mark_error(nerr,ermsg,52,55)
      end if

c-checking magnitude number 1
      if (magn1 .lt. -2 .or. magn1 .gt. 10) then
         call mark_error(nerr,ermsg,57,59)
      end if

c-checking type of magnitude number 1
      if (magn1 .ne. 0) then
         if (tmagn1 .ne. 'L' .and. tmagn1 .ne. 'B' .and.
     1       tmagn1 .ne. 'S' .and. tmagn1 .ne. 'C' .and.
     2       tmagn1 .ne. 'W'.and.tmagn1.ne.' ') then
            call mark_error(nerr,ermsg,60,60)
         end if
      end if

c-checking magnitude number 2
      if (magn2 .lt. -2 .or. magn2 .gt. 10) then
         call mark_error(nerr,ermsg,65,67)
      end if

c-checking type of magnitude number 2 
      if (magn2 .ne. 0) then
         if (tmagn2 .ne. 'L' .and. tmagn2 .ne. 'B' .and.
     1       tmagn2 .ne. 'S' .and. tmagn2 .ne. 'C' .and.
     2       tmagn2 .ne. 'W'.and.tmagn2.ne.' ') then
            call mark_error(nerr,ermsg,68,68)
         end if
      end if

c-checking magnitude number 3
      if (magn3 .lt. -2 .or. magn3 .gt. 10) then
         call mark_error(nerr,ermsg,73,75)
      end if

c-checking type of magnitude number 3 
      if (magn3 .ne. 0) then
         if (tmagn3 .ne. 'L' .and. tmagn3 .ne. 'B' .and.
     1       tmagn3 .ne. 'S' .and. tmagn3 .ne. 'C' .and.
     2       tmagn3 .ne. 'W'.and.tmagn3.ne.' ') then
            call mark_error(nerr,ermsg,76,76)
         end if
      end if
      end


c-this subroutine checks all the importants variables
c-for the line type 2
      subroutine check_line_type_2(cline,ermsg,nerr)
      character*80 cline           ! dummy current line
      character*1 ermsg(80)        ! dummy array for error message
      integer nerr               ! dummy for number of error
      integer status                ! iostatus
      character*1 dicode            ! diastrophism code
      character*1 tscode            ! tsunami code
      character*1 secode            ! seiche code
      character*1 cultef            ! cultural effects
      character*1 unev              ! unusual events
      integer maxint                ! max intensity
      character*1 maxiq             ! max intensity qualifier
      character*2 intscl            ! intensity scale
      real maclat                   ! macroseismic latitude
      real maclon                   ! macroseismic longitude
      real macmag                   ! macroseismic magnitude
      character*1 tmagn             ! type of magnitude 
      real logrfa                   ! logarithm of radius of felt area
      real logar1                   ! logarithm of area 1 where eq was felt
      integer intba1                ! intensity boardering the area 1
      real logar2                   ! logarithm of area 2 where eq was felt
      integer intba2                ! intensity boardering the area 2 
      character*1 qrrep             ! quality rank of the report

c-reading and checking status variable dicode 
      read(cline (22:22),'(a1)',err=30,iostat=status) dicode 
 30   continue
      call check_status(nerr,status,ermsg,22,22)

c-reading and checking status variable tscode
      read(cline (23:23),'(a1)',err=31,iostat=status) tscode
 31   continue
      call check_status(nerr,status,ermsg,23,23)

c-reading and checking status variable secode
      read(cline (24:24),'(a1)',err=32,iostat=status) secode
 32   continue
      call check_status(nerr,status,ermsg,24,24)

c-reading and checking status variable cultef 
      read(cline (25:25),'(a1)',err=33,iostat=status) cultef 
 33   continue
      call check_status(nerr,status,ermsg,25,25)

c-reading and checking status variable unev
      read(cline (26:26),'(a1)',err=34,iostat=status) unev
 34   continue
      call check_status(nerr,status,ermsg,26,26)

c-reading and checking status variable maxint 
      read(cline (28:29),'(i2)',err=35,iostat=status) maxint 
 35   continue
      call check_status(nerr,status,ermsg,28,29)

c-reading and checking status variable maxiq
      read(cline (30:30),'(a1)',err=36,iostat=status) maxiq
 36   continue
      call check_status(nerr,status,ermsg,30,30)

c-reading and checking status variable intscl
      read(cline (31:32),'(a2)',err=37,iostat=status) intscl
 37   continue
      call check_status(nerr,status,ermsg,31,32)

c-reading and checking status variable maclat 
      read(cline (34:39),'(f6.2)',err=38,iostat=status) maclat
 38   continue
      call check_status(nerr,status,ermsg,34,39)

c-reading and checking status variable maclon 
      read(cline (41:47),'(f7.2)',err=39,iostat=status) maclon
 39   continue
      call check_status(nerr,status,ermsg,41,47)

c-reading and checking status variable macmag
      read(cline (49:51),'(f3.1)',err=40,iostat=status) macmag
 40   continue
      call check_status(nerr,status,ermsg,49,51)

c-reading and checking status variable tmagn
      read(cline (52:52),'(a1)',err=41,iostat=status) tmagn
 41   continue
      call check_status(nerr,status,ermsg,52,52)

c-reading and checking status variable logrfa
      read(cline (53:56),'(f4.2)',err=42,iostat=status) logrfa
 42   continue
      call check_status(nerr,status,ermsg,53,56)

c-reading and checking status variable logar1
      read(cline (57:61),'(f5.2)',err=43,iostat=status) logar1
 43   continue
      call check_status(nerr,status,ermsg,57,61)

c-reading and checking status variable intba1
      read(cline (62:63),'(i2)',err=44,iostat=status) intba1
 44   continue
      call check_status(nerr,status,ermsg,62,63)

c-reading and checking status variable logar2
      read(cline (64:68),'(f5.2)',err=45,iostat=status) logar2
 45   continue
      call check_status(nerr,status,ermsg,64,68)

c-reading and checking status variable intba2
      read(cline (69:70),'(i2)',err=46,iostat=status) intba2
 46   continue
      call check_status(nerr,status,ermsg,69,70)

c-reading and checking status variable qrrep
      read(cline (72:72),'(a1)',err=47,iostat=status) qrrep 
 47   continue
      call check_status(nerr,status,ermsg,72,72)


c-checking dicode
      if (dicode .ne. 'F' .and. dicode .ne. 'U' .and.
     1    dicode .ne. 'D' .and. dicode .ne. ' ') then
         call mark_error(nerr,ermsg,22,22)
      end if

c-checking tscode
      if (tscode .ne. 'T' .and. tscode .ne. 'Q' .and.
     1    tscode .ne. ' ') then
         call mark_error(nerr,ermsg,23,23)
      end if

c-checking secode
      if (secode .ne. 'S' .and. secode .ne. 'Q' .and.
     1    secode .ne. ' ') then
         call mark_error(nerr,ermsg,24,24)
      end if

c-checking cultef
      if (cultef .ne. 'C' .and. cultef .ne. 'D' .and.
     1    cultef .ne. 'F' .and. cultef .ne. 'H' .and.
     2    cultef .ne. ' ') then
         call mark_error(nerr,ermsg,25,25)
      end if

c-checking unev
      if (unev .ne. 'L' .and. unev .ne. 'G' .and.
     2    unev .ne. 'S' .and. unev .ne. 'B' .and.
     3    unev .ne. 'C' .and. unev .ne. 'V' .and.
     4    unev .ne. 'O' .and. unev .ne. 'M' .and.
     5    unev .ne. ' ') then
         call mark_error(nerr,ermsg,26,26)
      end if

c-checking maxint
      if (maxint .lt. 0 .and. maxint .gt. 12) then
         call mark_error(nerr,ermsg,28,29)
      end if

c-checking maxiq
      if (maxiq .ne. '+' .and. maxiq .ne. '-' .and.
     1    maxiq .ne. ' ') then
         call mark_error(nerr,ermsg,30,30)
      end if

c-checking intscl
      if (intscl .ne. 'MM' .and. intscl .ne. 'RF' .and.
     1    intscl .ne. 'CS' .and. intscl .ne. 'SK' .and.
     2    intscl .ne. '  ') then
         call mark_error(nerr,ermsg,31,32)
      end if

c-checking maclat
      if (maclat .lt. -90 .and. maclat .gt. 90) then
         call mark_error(nerr,ermsg,34,39)
      end if

c-checking maclon
      if (maclon .lt. -180 .and. maclon .gt. 180) then
         call mark_error(nerr,ermsg,41,47)
      end if

c-checking macmag
      if (macmag .lt. -2 .and. macmag .gt. 10) then
         call mark_error(nerr,ermsg,49,51)
      end if

c-checking tmagn
      if (tmagn .ne. 'I' .and. tmagn .ne. 'A' .and.
     1    tmagn .ne. 'R' .and. tmagn .ne. '*' .and.
     2    tmagn .ne. ' ') then
         call mark_error(nerr,ermsg,52,52)
      end if

c-checking qrrep
      if (qrrep .ne. 'A' .and. qrrep .ne. 'B' .and.
     1    qrrep .ne. 'C' .and. qrrep .ne. 'D' .and.
     2    qrrep .ne. ' ') then
         call mark_error(nerr,ermsg,72,72)
      end if

      end


c-this subroutine checks all the importants variables
c-for the line type 4
      subroutine check_line_type_4(cline,ermsg,nerr)
      character*80 cline           ! dummy current line
      character*1 ermsg(80)        ! dummy array for error message
      integer nerr               ! dummy for number of error
      integer status                ! iostatus
      character*1 aux5              ! auxiliary for check empty record
      logical nempty                ! controls empty record
      character*5 stname            ! station name
      character*1 itype             ! instrument type
      character*1 compo             ! component
      integer hour                  ! hour
      integer minute                ! minutes
      real secnds                   ! seconds
      integer durat                 ! duration
      real amplit                   ! amplitude
      real period                   ! period
      real diappr                   ! direction of approach
      real phvel                    ! phase velocity
      real snrat                    ! signal to noise ratio
      integer azres                 ! azimuth residual
      real ttres                    ! travel time residual
      integer weight                ! weight
      real epdist                   ! epicentral distance
      integer azsour                ! azimuth at source 

c-reading and checking status variable stname
      read(cline (2:6),'(a5)',err=49,iostat=status) stname
 49   continue
      call check_status(nerr,status,ermsg,2,5)
      if (stname .eq. '    ') then
         nempty = .false.
         do ind=1,80
            read(cline (ind:ind),'(a1)') aux5
            if (aux5 .ne. ' ') then
                nempty = .true.
            end if
         end do
         if (.not. nempty) then 
            go to 71
         end if
      end if

c-reading and checking status variable itype 
      read(cline (7:7),'(a1)',err=50,iostat=status) itype   
 50   continue
      call check_status(nerr,status,ermsg,7,7)

c-reading and checking status variable compo
      read(cline (8:8),'(a1)',err=51,iostat=status) compo
 51   continue
      call check_status(nerr,status,ermsg,8,8)

c-reading and checking status variable hour
      read(cline (19:20),'(i2)',err=57,iostat=status) hour
 57   continue
      call check_status(nerr,status,ermsg,19,20)

c-reading and checking status variable minute
      read(cline (21:22),'(i2)',err=58,iostat=status) minute
 58   continue
      call check_status(nerr,status,ermsg,21,22)

c-reading and checking status variable secnds
      read(cline (23:28),'(f6.0)',err=59,iostat=status) secnds 
 59   continue
      call check_status(nerr,status,ermsg,23,28)

c-reading and checking status variable durat
      read(cline (30:33),'(i4)',err=60,iostat=status) durat
 60   continue
      call check_status(nerr,status,ermsg,30,33)

c-reading and checking status variable amplit
      read(cline (34:40),'(g8.1)',err=61,iostat=status) amplit
 61   continue
      call check_status(nerr,status,ermsg,34,40)

c-reading and checking status variable period 
      read(cline (42:45),'(f4.0)',err=62,iostat=status)  period
 62   continue
      call check_status(nerr,status,ermsg,42,45)

c-reading and checking status variable diappr
      read(cline (47:51),'(f5.0)',err=63,iostat=status) diappr
 63   continue
      call check_status(nerr,status,ermsg,47,51)

c-reading and checking status variable phvel
      read(cline (53:56),'(f4.0)',err=64,iostat=status) phvel
 64   continue
      call check_status(nerr,status,ermsg,53,56)

c-reading and checking status variable snrat
      read(cline (57:60),'(f4.0)',err=65,iostat=status) snrat
 65   continue
      call check_status(nerr,status,ermsg,57,60)

c-reading and checking status variable azres
      read(cline (61:63),'(i3)',err=66,iostat=status) azres
 66   continue
      call check_status(nerr,status,ermsg,61,63)

c-reading and checking status variable ttres
      read(cline (64:68),'(f5.1)',err=67,iostat=status) ttres
 67   continue
      call check_status(nerr,status,ermsg,64,68)

c-reading and checking status variable weight
      read(cline (69:70),'(i2)',err=68,iostat=status) weight
 68   continue
      call check_status(nerr,status,ermsg,69,70)

c-reading and checking status variable epdist
      read(cline (71:75),'(f5.0)',err=69,iostat=status) epdist 
 69   continue
      call check_status(nerr,status,ermsg,71,75)

c-reading and checking status variable azsour 
      read(cline (77:79),'(i3)',err=70,iostat=status) azsour
 70   continue
      call check_status(nerr,status,ermsg,77,79)


c-checking station name
      if (stname .eq. '    ') then
         call mark_error(nerr,ermsg,2,5)
      end if
c-checking itype
      if (itype .ne. 'S' .and. itype .ne. 'I' .and.
     1    itype .ne. 'L' .and. itype .ne. 'A' .and.
     2    itype .ne. 'B' .and. itype .ne. 'U' .and.
     3    itype .ne. 'H' .and. itype .ne. 'M' .and.
     4    itype .ne. 'R' .and. itype .ne. 'E' .and.
     5    itype .ne. ' ' .and. itype .ne. 'V') then
          call mark_error(nerr,ermsg,7,7)
      end if

c-checking compo
      if (compo .ne. 'Z' .and. compo .ne. 'N' .and.
     1    compo .ne. 'E' .and. compo .ne. ' ' .and.
     2    compo .ne. 'P' .and. compo .ne. 'R' .and.
     3    compo .ne. 'T') then
         call mark_error(nerr,ermsg,8,8)
      end if

c-checking hour
      if (hour .lt. 00 .or. hour .gt. 48) then
         call mark_error(nerr,ermsg,19,20)
      end if

c-checking minutes
      if (minute .lt. 00 .or. minute .gt. 59) then
         call mark_error(nerr,ermsg,21,22)
      end if

c-checking seconds
      if (secnds .lt. 00 .or. secnds .gt.500.0 ) then
         call mark_error(nerr,ermsg,24,28)
      end if

c-checking duration
      if (durat .lt. 00) then
         call mark_error(nerr,ermsg,30,33)
      end if

c-checking period
      if (period .lt. 00) then
         call mark_error(nerr,ermsg,42,45)
      end if

c-checking phvel
      if (phvel .lt. 00) then
         call mark_error(nerr,ermsg,53,56)
      end if

 71   continue
      end


c-this subroutine checks all the importants variables
c-for the line type I
      subroutine check_line_type_I(cline,ermsg,nerr)
      character*80 cline           ! dummy current line
      character*1 ermsg(80)        ! dummy array for error message
      integer nerr               ! dummy for number of error
      integer status                ! iostatus
      character*3 lact              ! last action done
      integer year                  ! year
      character*1 aux1              ! auxiliary for date
      integer month                 ! month
      character*1 aux2              ! auxiliary for date
      integer day                   ! day
      character*1 aux3              ! auxiliary for date
      integer hour                  ! hour
      character*1 aux4              ! auxiliary for time
      integer minute                ! minutes
      character*1 id                ! identification (read 1 ch per time)
      integer idint                 ! integer variable for id
      integer ind                   ! index 


c-reading and checking status variable lact
      read(cline (9:11),'(a3)',err=72,iostat=status) lact
 72   continue
      call check_status(nerr,status,ermsg,9,11)

c-reading and checking status variable year
      read(cline (13:14),'(i2)',err=73,iostat=status) year
 73   continue
      call check_status(nerr,status,ermsg,13,14)

c-reading and checking status variable aux1
      read(cline (15:15),'(a1)',err=74,iostat=status) aux1 
 74   continue
      call check_status(nerr,status,ermsg,15,15)

c-reading and checking status variable month
      read(cline (16:17),'(i2)',err=75,iostat=status) month
 75   continue
      call check_status(nerr,status,ermsg,16,17)

c-reading and checking status variable aux2
      read(cline (18:18),'(a1)',err=76,iostat=status) aux2 
 76   continue
      call check_status(nerr,status,ermsg,18,18)

c-reading and checking status variable day
      read(cline (19:20),'(i2)',err=77,iostat=status) day
 77   continue
      call check_status(nerr,status,ermsg,19,20)

c-reading and checking status variable aux3
      read(cline (21:21),'(a1)',err=78,iostat=status) aux3 
 78   continue
      call check_status(nerr,status,ermsg,21,21)

c-reading and checking status variable hour
      read(cline (22:23),'(i2)',err=79,iostat=status) hour
 79   continue
      call check_status(nerr,status,ermsg,22,23)

c-reading and checking status variable aux4
      read(cline (24:24),'(a1)',err=80,iostat=status) aux4 
 80   continue
      call check_status(nerr,status,ermsg,24,24)

c-reading and checking status variable minute
      read(cline (25:26),'(i2)',err=81,iostat=status) minute
 81   continue
      call check_status(nerr,status,ermsg,25,26)

c-reading and checking status variable idint
      read(cline (61:69),'(i9)',err=84,iostat=status) idint 
      read(cline (70:74),'(i5)',err=84,iostat=status) idint 
 84   continue
      call check_status(nerr,status,ermsg,61,74)

c-checking lact
      if (lact .ne. 'SPL' .and. lact .ne. 'REG' .and.
     1    lact .ne. 'UPD' .and. lact .ne .'UP ' .and.
     1    lact .ne. 'NEW' .and. lact. ne. 'DUB' .and.
     !    lact .ne. 'REE' .and. lact. ne. 'HYP' .and.
     1    lact .ne. 'DUP' .and. lact. ne. 'ARG') then
         call mark_error(nerr,ermsg,9,11)
      end if

c-checking year
      if (year .lt. 0 .or. year .gt. 2100) then
         call mark_error(nerr,ermsg,13,14)
      end if

c-checking aux1
      if (aux1 .ne. '-') then
         call mark_error(nerr,ermsg,15,15)
      end if

c-checking month
      if (month .lt. 1 .or. month .gt. 12) then
         call mark_error(nerr,ermsg,16,17)
      end if

c-checking aux2
      if (aux2 .ne. '-') then
         call mark_error(nerr,ermsg,18,18)
      end if

c-checking day finding out if month has 28, 29, 30 or 31 days
      if (month .eq. 01 .or. month .eq. 03 .or. month .eq. 05 .or.
     1    month .eq. 07 .or. month .eq. 08 .or. month .eq. 10 .or.
     2    month .eq. 12 .or. month .lt. 01 .or. month .gt. 12) then
         if (day .lt. 1 .or. day .gt. 31) then
            call mark_error(nerr,ermsg,19,20)
         end if
      else if (month .eq. 04 .or. month .eq. 06 .or.
     1         month .eq. 09 .or. month .eq. 11) then
         if (day .lt. 1 .or. day .gt. 30) then
            call mark_error(nerr,ermsg,19,20)
         end if
      else if (month .eq. 02) then
         left = year-int(year/4)*4
         if (left .eq. 0) then
            if (day .lt. 1 .or. day .gt. 29) then
               call mark_error(nerr,ermsg,19,20)
            end if
         else
            if (day .lt. 1 .or. day .gt. 28) then
               call mark_error(nerr,ermsg,19,20)
            end if
         end if
      end if

c-checking aux3
      if (aux3 .ne. ' ') then
         call mark_error(nerr,ermsg,21,21)
      end if

c-checking hour
      if (hour .lt. 00 .or. hour .gt. 23) then
         call mark_error(nerr,ermsg,22,23)
      end if

c-checking aux4
      if (aux4 .ne. ':') then
         call mark_error(nerr,ermsg,24,24)
      end if

c-checking minutes
      if (minute .lt. 00 .or. minute .gt. 59) then
         call mark_error(nerr,ermsg,25,26)
      end if

c-checking ID
      do ind=61,74  
         read(cline (ind:ind),'(a1)',err=81) id 
         if (id .eq. ' ') then
            call mark_error(nerr,ermsg,61,74)
         end if
      end do

      end



c-this subroutine checks all the importants variables
c-for the line type 6
      subroutine check_line_type_6(cline,ermsg,nerr)
      character*80 cline           ! dummy current line
      character*1 ermsg(80)        ! dummy array for error message
      integer nerr               ! dummy for number of error
      integer status                ! iostatus
      character*1 free              ! free position of line 6
      character*1 first             ! first position of valid data

c-reading and checking status variable free 
      read(cline (1:1),'(a1)',err=82,iostat=status) free
 82   continue
      call check_status(nerr,status,ermsg,1,1)

c-reading and checking status variable first
      read(cline (2:2),'(a1)',err=83,iostat=status) first
 83   continue
      call check_status(nerr,status,ermsg,2,2)
      
c-checking freee
      if (free .ne. ' ') then
         call mark_error(nerr,ermsg,1,1)
      end if

c-checking first
      if (first .eq. ' ') then
         call mark_error(nerr,ermsg,2,2)
      end if
 
      end



c-this subroutine checks all the importants variables
c-for the line type F
      subroutine check_line_type_F(cline,ermsg,nerr)
      character*80 cline           ! dummy current line
      character*1 ermsg(80)        ! dummy array for error message
      integer nerr               ! dummy for number of error
      integer status                ! iostatus
      real var1, var2, var3         ! real variables
      integer var4                  ! integer variable 

c-reading and checking status variable var1
      read(cline (1:10),'(f10.1)',err=85,iostat=status) var1
 85   continue
      call check_status(nerr,status,ermsg,1,10)

c-reading and checking status variable var2
      read(cline (11:20),'(f10.1)',err=86,iostat=status) var2
 86   continue
      call check_status(nerr,status,ermsg,11,20)

c-reading and checking status variable var3
      read(cline (21:30),'(f10.1)',err=87,iostat=status) var3
 87   continue
      call check_status(nerr,status,ermsg,21,30)

c-reading and checking status variable var4
      read(cline (31:35),'(i5)',err=88,iostat=status) var4
 88   continue
      call check_status(nerr,status,ermsg,31,40)

      end




c-this subroutine marks with stars the errors found and sets the
c-variable error to become able to print the error message
      subroutine mark_error(nerr,ermsg,begin,end) 
      character*1 ermsg(80)        ! dummy array for error message
      integer nerr               ! dummy for number of errors
      integer begin                 ! first position of error
      integer end                   ! last position of error
      
      nerr = nerr + 1
      do ind=begin,end
         ermsg(ind) = '*'
      end do

      end



c-this subroutine checks the I/O status and 
c-marks with stars the errors found and sets the
c-variable error to become able to print the error message
      subroutine check_status(nerr,status,ermsg,begin,end)
      integer status                ! dummy for iostatus
      character*1 ermsg(80)         ! dummy array for error message
      integer nerr                  ! dummy for number of errors
      integer begin                 ! first position of error
      integer end                   ! last position of error

      if (status .ne. 0) then
         nerr = nerr + 1
         do ind=begin,end
            ermsg(ind) = '*'
         end do
      end if
      end

	program seigmt    

c
c program to convert seisan nordic files into gmt psxy input
c
c
c ---------------- new in SEISAN version 7.0 ---------------------
c lo 15 mar 1999: include output for psvelomeca
c lo 16 mar 1999: magnitude order as input
c jh 24 jun 1999: comment out first format statement below
c lo 16 sep 1999: small fixes
c lo 16 may 2005: added output for station coordinates and travel paths 
c jh 21 oct 2005: write out -dep as f6.1 instead of f5.1
c jh 24 may 2007: increaze dimesion of data array
c

      implicit none

      character*40 file
      real scale
      real lat,lon,magout,mag(5),dep,stlat,stlon,stel
      character*1 cmag(5)
      integer nevent,nfp
      logical compact
      real strike,dip,rake
      character*8 datetext

c-- event arrays
      character*80      data(7000)    ! jh may 2007, increased
c-- no of stations for event
      integer           nstat
c-- no of phases for one event
      integer nphase
c-- no of records for event
      integer           nrecord
c-- no of headers for event
      integer           nhead
c-- event ids--------------
      character*1       exp,evid
      integer id,l,c,x
c magnitude order
      character*5 magorder
c magnitude found, new station
      logical flag,new
c number of stations
      integer nstatpath,nstations
c station names
      character*5 pathstations(999),stations(999)
c model indicator in station filename
      character*1 file_ind


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver


      NEVENT=0
      nstations=0
      nfp = 0

      WRITE(6,*) ' Nordic input file'
      READ(5,'(A40)') FILE

      magorder = ' '
      write(*,*) ' Return to use largest magnitude, or enter magnitude o
     &rder (e.g. CLBSW) '
      read(*,'(a)') magorder

      write(*,*) ' scale: size = mag * scale (for example 0.01)'
      read(*,*) scale

      if (scale.eq.0) then
        write(*,*) 'scale fixed to 0.01'
        scale = 0.01
      endif

      OPEN(1,FILE=FILE,STATUS='OLD')
      OPEN(2,FILE='gmtxy.out',STATUS='unknown')
      OPEN(12,FILE='gmtstxy.out',STATUS='unknown')
      open(3,file='psmeca.out',status='unknown')
      OPEN(4,FILE='gmtxyz.out',STATUS='unknown')
      OPEN(11,FILE='gmtpath.out',STATUS='unknown')

      call nortype(1,compact)

      if (compact) then
          write(*,*) 'Input file is compact.'
      else
          write(*,*) 'Input file is Nordic.'  
      endif
c      write(*,*)

1     CONTINUE

      if (compact) then
          read(1,'(A80)',END=666) data(1)
          nhead = 1
      else

          call indata
     *      (1,nstat,nphase,nhead,nrecord,evid,exp,data,id)
            if(nrecord.eq.0) goto 666   ! end of file
      endif

      do c=1,5
         mag(c)=0
        cmag(c)= ' '
      enddo

      read(data(1)(21:21),'(a1)') file_ind
      read(data(1)(24:30),'(f7.3)') lat
      read(data(1)(31:38),'(f8.3)') lon
      read(data(1)(39:43),'(f5.1)') dep
      read(data(1)(57:59),'(f3.1)') mag(1)
      datetext= ' '
      datetext(1:4)=data(1)(2:5)
      datetext(5:6)=data(1)(7:8)
      datetext(7:8)=data(1)(9:10)
      do c=1,8
        if (datetext(c:c).eq.' ') datetext(c:c) = '0'
      enddo
      cmag(1) = data(1)(60:60)
      read(data(1)(65:67),'(f3.1)') mag(2)
      cmag(2) = data(1)(68:68)
      read(data(1)(73:75),'(f3.1)') mag(3)
      cmag(3) = data(1)(76:76)
c
c  read from 2nd header
c
      if (.not.compact) then
        if (data(1)(1:23).eq.data(2)(1:23)) then
          read(data(2)(57:59),'(f3.1)') mag(4)
          cmag(4) = data(2)(60:60)
          read(data(2)(65:67),'(f3.1)') mag(5) 
          cmag(5) = data(2)(68:68)
        endif
      endif

      magout=0.
      flag = .true.
c
c  find largest mag
c
      if (magorder.ne.''.and.magorder.ne.' ') then
        flag=.false.

        do c=1,5
          do x=1,5
            if (magorder(c:c).eq.cmag(x).and.
     &           magorder(c:c).ne.' ') then
              magout = mag(x)
              flag = .true.
              goto 10
            endif
          enddo
        enddo

      else
c
c find largest magnitude
c
        do c=1,5
          if (mag(c).gt.magout) magout=mag(c)
        enddo
      endif

  10  continue

      if (data(1)(24:38).eq.'               ') goto 1

      do l=2,nhead
          if(data(l)(80:80).eq.'F') then
             read(data(l),'(3f10.1)')strike,dip,rake
 
c output to file
c             write(*,'(8(1x,f7.2))')lon,lat,strike,dip,
c     &                 rake,magout,lon,lat
             write(3,'(9(1x,f7.2),1x,a8)')lon,lat,dep,strike,dip,
     &                 rake,magout,lon,lat,datetext
             nfp = nfp + 1
          endif
      enddo

      if (flag) then
        magout = magout *scale
c        write(*,'(F8.3,1X,F7.3,1X,F10.5)') lon,lat,magout
        write(2,'(F8.3,1X,F7.3,1X,F10.5)') lon,lat,magout
        write(4,'(F8.3,1X,F7.3,1X,F6.1,F10.5)') lon,lat,-dep,magout
        nevent=nevent+1
      else
        write(*,*) ' selected magnitude type(s) not found: ',
     &            data(1)(1:23)
      endif
c
c get stations
c
      do c=nhead+1,nrecord
        new=.true.
        do l=1,nstations
          if (data(c)(3:6).eq.stations(l).or.
     &        data(c)(2:6).eq.stations(l)) then
            new=.false.
          endif
        enddo
        if (new) then
          nstations=nstations+1
          if (data(c)(2:2).eq.' ') then
            stations(nstations)=data(c)(3:6)
          else
            stations(nstations)=data(c)(2:6)
          endif
          call stat_loc(stations(nstations),file_ind,stlat,stlon,stel)
          if (stlat.ne.0..and.stlon.ne.0.) then 
c
c bjb 3/2/2006 output station name to output file also.
c
            write(12,'(f8.3,1x,f8.3,1x,a5)') stlon,stlat,
     &	    stations(nstations)
          endif
        endif
      enddo

c
c get path information
c
      nstatpath=0
      do c=nhead+1,nrecord
        new=.true.
        do l=1,nstatpath
          if (data(c)(3:6).eq.pathstations(l).or.
     &        data(c)(2:6).eq.pathstations(l)) then
            new=.false.
          endif 
        enddo
        if (new) then
          nstatpath=nstatpath+1
          if (data(c)(2:2).eq.' ') then
            pathstations(nstatpath)=data(c)(3:6)
          else
            pathstations(nstatpath)=data(c)(2:6)
          endif
        endif
      enddo
      if (nstatpath.ne.0.and.lat.ne.0..and.lon.ne.0.) then
        do c=1,nstatpath
          call stat_loc(pathstations(c),file_ind,stlat,stlon,stel)
          if (stlat.ne.0..and.stlon.ne.0.) then 
            write(11,'(f8.3,1x,f8.3)') lon,lat
            write(11,'(f8.3,1x,f8.3)') stlon,stlat
            write(11,'(a1)') '>'
          endif
        enddo
      endif
      goto 1

666   close(1)
      close(2)
      close(3)
      close(4)
      close(11)
      close(12)

      write(*,'(a,i5)') ' Number of events:                          '
     &         ,nevent
      write(*,'(a,i5)') ' Number of events with fault plane solution: '
     &            ,nfp
      WRITE(*,*) ' epicenter location input file for GMT psxy/psxyz: '
     &               //'gmtxy.out/gmtxyz.out'
      WRITE(*,*) ' station location input file for GMT psxy: '
     &               //'gmtstxy.out'
      WRITE(*,*) ' travel path input file for GMT psxy (option -M): '
     &               //'gmtpath.out'
      write(*,*) ' Coordinates are given as longitude - latitude'
      write(*,*) ' input file for psmeca (Aki and Richards convention):'
     &               // ' psmeca.out'

      STOP
      END

      subroutine polos(fy,fx,ypol,iant,insidepol)
c
c    updates
c
c    sep 98 by jh : ---------  version 7.0 check ------------------
c                   no changes
c
c     to find out if a given point (fy,fx) is inside any of the
c            polygons defined by ypol.  the number of the
c                   polygon is returned in 'insidepol'
c input :
c  fy,fx           : point to find polygone for
c  ypol(iant,2): array defining the polygone
c  iant       : number of points defining polygone
c output :
c  inside             : true - polygon contains event 
c
      include 'seidim.inc'        ! dimensions
      integer iant
      dimension ypol(max_polyn$,2),x(2),xx(2)
      logical insidepol
      real fy, fx
C
C    ============= Changes =================
C!JAB(BGS)Nov94       : YPOL is multi-dimensional and will not allow
C!JAB(BGS)Nov94         successful compilation with some compiler options.
C!JAB(BGS)Nov94       : Trap zero denominators.   
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei code                    ! Error encoder.
C
       logical  b_flag                      ! Dummy boolean.
C
      integer   npol, npol1, iflag, i, m, n ! Previously undefined (JAB).
      real      x, eps, xx, diff, yy,       ! Ditto.
     &          dx1, dx2, dy1, dy2, xcross  ! Ditto.
C
C    ============= end of changes ==========
C
C    Initialise...
C    -------------
C
      x(1) = fx
      x(2) = fy
      eps= 0.0001
      insidepol = .false.
c
      npol = iant
c
      xx(1)=x(1)
      xx(2)=x(2)
c
    6 iflag = 0
      do 5 i=1,npol
          diff= abs(xx(2)-ypol(i,2))
          if(diff.gt.0.00001) go to 5
            xx(2)= xx(2) + eps
            iflag = 1
    5 continue
      if (iflag.eq.1) go to 6
c
c now, dy1 or dy2 will never be zero  (hopefully..)
c
      npol1= npol+1
      ypol(npol1,1) = ypol(1,1)
      ypol(npol1,2) = ypol(1,2)
c
      dx1 = ypol(1,1) - xx(1)
      dy1 = ypol(1,2) - xx(2)
c
      n= 0
      do 50 i=2,npol1

           dx2 = ypol(i,1) - xx(1)
           dy2 = ypol(i,2) - xx(2)
c
           yy= dy1*dy2
           if (yy.ge.0) go to 10
             if (dx1.lt.0. .and. dx2.lt.0.) go to 10
               if (dx1.gt.0. .and. dx2.gt.0.) go to 20
C
C    Trap potential zero denominator...
C    ----------------------------------
C
                 if( abs(dy1-dy2) .gt. 0.0 ) then
                 xcross= (dy1*dx2 - dy2*dx1)/(dy1-dy2)
C
                 else
                 chr_err_msg$ =              ! Overwrite with this message.
     &'Invalid point in/or polygon, zero denominator (polos)'
                 call sei code( stop$,       ! Stop on error error.
     &                          e_dnom$,     ! Forced by denominator.
     &                          0,           ! Not by fortran unit.
     &                          b_flag )     ! Flag (n/a).
                 end if
C
C    ------------ end -----------------
C
                 if (xcross.lt.0.) go to 10
c
   20          n=n+1
c
   10      dx1=dx2
           dy1=dy2
   50 continue

c
      m=(n/2)*2
      if(m.eq.n) go to 30
c
c n odd, x is inside polygon.
c
      insidepol = .true.
      goto 9999                            ! Return to caller.
c
c n even, x is outside polygon
c

   30 insidepol = .false.
c
C    Return to caller...
C    ===================
C
9999  return
      end

c                                                                               
c     Program to summarize logs                    
c     1997 by jh
c
c   to change number of stations, change variable text and all format
c   statments where the number is used, one station takes 5 columns
c
c   Updates:
c   june 98 by jh   : include gps statistics
c   sep 98          : fix text
c   sep  25 by jh   : average over all days instead of active days
c                     also write out total detection in interval
c   oct 2           : divide by one day too little
c   feb 3 99   jh   : -------------   verison 7.0  -----------------
c   jun 24          : enscript instead of nenscript
c   jan 15, 02 jh   : more def stations
c   feb 6, 2002 jh  : count wav files
c   feb 7           : one day operation from prompt
c   may 6 2002      : add domb
c   sep 23 2002     : add OSL
c   nov 6 2006      : add hopen,berb,ckono,ckbs
c   nov 9 2007      : more changws, now 38 stat
c                                                                               
      implicit none                                                             
      include 'libsei.inc'                ! Open file definitions
      include 'seidim.inc'                ! Dimentions
      include 'seisan.inc'
C
c-- event records                                  
      character*80 data(500)			
      real up_time,up_t     ! up times in %
      real up_time_gps,up_g     ! up times gps in %
c-- filenames                        
      character*80 evfile	
      character*80 wave_file
      character*207 text
      character*80 txt
c-- times for event selection             
      character*14 start_time,end_time		
c-- database name               
      character*40 base_name/' '/		
c-- selection key                                   
      character*10 key/' '/			
c-- Event type indicators                         
      character*1 type1			
      character*12 t12      ! system time
      character*14 t14      ! system time
c-- explosion indicator                                  
      character*1 exp				
      integer det(50,31)    ! number of detections all stations, one month
      real up(50,31)        ! up times             -----------------------
      real up_gps(50,31)    ! --------------- gps
      integer wav_total(50,31)    !  total number of waveforms in s-file
      integer wav_present(50,31) ! number of waveforms present
      character*5 stat(50)  ! station data bases
      character*250 stat_c  ! --- in one string
      real average_up(50)   ! average up time
      real average_up_gps(50) ! --- gps -----
      real average_det(50)  ! average no of detections
      integer ava_wav_total(50) ! total number of wav files
      integer ava_wav_present(50) ! total number for wav files present
      integer n_up(50)      ! number of days with up times
      integer n_up_gps(50)  ! ------------------ gps -----
      integer day1,day2     ! range of days for log
c-- See routine: find_ev_index     
      integer status,new_month,fstart,event_no	
c-- timing of first event           
      integer year1,month1,hr1,min1,sec1
      real sec
      double precision total_time
c   arguments 
      character*80 arg(5)
c   number of arguments
      integer nargs
      integer day_back      ! days back to do a one day check
c-- same as sec1                  
      real ssec1                                
      integer seiclen
c-- not used                                               
      integer nphas				
c-- See routine: Indata                        
      integer nhead,nrecord,nstat,nsta		
c-- counters                                     
      integer i,k,l,nin,nout,istat,nout_gps
      logical exist                                                            
      equivalence (stat_c,stat)
c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver
c
c   get arguments
c
      call get_arguments(nargs,arg)
c
c   find how many minutes back if given as an argument
c
      if(nargs.gt.0) then
         read(arg(1),'(i2)') day_back
      endif

c
c   get system time
c
       call systime(t12,t14)
c
c   calculate abs time
c
       read(t12,'(4i2)') year1,month1,day1,hr1
       year1=year1+2000
       call timsec(year1,month1,day1,hr1,0,0.0,total_time)
c
c   subtract days day_back
c
       total_time=total_time-day_back*24*3600

       call sectim(total_time,year1,i,month1,day1,hr1,min1,sec)
c
      stat_c=' '
      stat_c(1:50)= 
     *'FOO  HYA  KMY  LOF  MOL  NSS  ODD  SUE  TRO  STEI '
      stat_c(51:100)=
     *'WNN  BLS  BJO  KBS  KONO KTK  MOR  RUND STAV JMI  ' 
      stat_c(101:150)=
     *'DOMB OSL  SNARTSTOK HOPENBERB FLOS KONS MELS CBJO '
      stat_c(151:200)=
     *'CJMICCKONOCKBS CBER CNSS CMOL CTRO CKTK           '
c                                                                               
c------First inizialize -------                                                 
c                                                                               
      nout=0               
      nout_gps=0                                                     
      nin=0                                                                     
      up_time=0.0
      up_time_gps=0.0
c
c   set number of stations, also set all format stations at end
c
      nstat=38
      do i=1,50
        do k=1,31
           up(i,k)=-1.5
           up_gps(i,k)=-1.5
           det(i,k)=0
           wav_total(i,k)=0
           wav_present(i,k)=0
        enddo
      enddo
      text=' '
      call get_seisan_def
c
c   ask for time interval if not jst one day day_back
c
      if(day_back.lt.1) then
         write(6,*)'Start time(yyyymmdd)'
         read(5,'(a)') start_time
         write(6,*)'End time, return for end of month'
         read(5,'(a)') end_time
      else
         start_time=' '
         write(start_time(1:8),'(i4,2i2)') year1,month1,day1
         do i=1,8
           if(start_time(i:i).eq.' ') start_time(i:i)='0'
         enddo
         end_time=start_time
      endif
c                                                                               
c-------Open infile' ------                                               
c                                                                               
c      write(6,*)'Enter input file name'
c      read(5,'(a)') infile
c      open(2,file=infile,status='old')                                    
c
   
      open(3,file='stalog.out',status='unknown')                      
      open(9,file='stalog_wav.out',status='unknown')
c          
c---------------------------------------------------------------------
c  loop of all data bases
c--------------------------------------------------------------------
c
      do istat=1,nstat
        base_name=' '
        base_name(1:5)=stat(istat)
        write(9,*)
        write(9,'(a,a)') ' Station:  ', stat(istat)
c                                                                               
c  back here for next event, same base                                                    
c
 30    continue                                                                
c-- always use next event                                
       key='          '		
       CALL findevin                                                       
     * (base_name,start_time,end_time,key,0,
     * event_no,evfile,fstart,new_month,status)                                 
       if(status.eq.0) then                                                     
         inquire(file=evfile,exist=exist)                         
         if (exist) then
            open(2,file=evfile,status='old')                                          
            call indata(2,nsta,nphas,nhead,nrecord,type1,exp,data,i)
c            if(nrecord.eq.0) goto 999                                                 
c                                                                               
c   count number of input files                                                 
c                                                                               
            nin=nin+1                                                                 
c
c  get date etc
c
            read(data(1),'(1x,i4,1x,2i2,1x,2i2,1x,f4.1,1x,a1)')                       
     *      year1,month1,day1,hr1,min1,ssec1,type1                                    
            sec1=ssec1                                                                
c
c   check if a log file                                                   
c
            if(data(1)(22:23).eq.'LL') then
               do k = 1,nhead                                             
                  if(data(k)(10:16).eq.'up time') then
                     read(data(k)(31:36),'(f7.2)') up_t
                     up(istat,day1)=up_t       ! save up time for this day
                     up_time=up_time+up_t
c                     write(3,'(a,5x,f7.2)')data(1)(1:10),up_t
                     nout=nout+1
                  endif
                  if(data(k)(2:7).eq.'GPS UP') then
                     read(data(k)(31:36),'(f7.2)') up_g
c                    write(6,*) up_g
                     up_gps(istat,day1)=up_g       ! save up gps for this day
                     up_time_gps=up_time_gps+up_g
c                     write(3,'(a,5x,f7.2)')data(1)(1:10),up_t
                     nout_gps=nout_gps+1
                  endif
               enddo                                                                 
            else         
c
c   count detections for this day
c
               det(istat,day1)=det(istat,day1)+1
            endif
c
c   check for waveform files
c
             do i = 2, nhead
                if(data(i)(80:80).eq.'6'.and.
     *             data(i)(2:2).ne.' ') then
                      wav_total(istat,day1)=
     *                wav_total(istat,day1)+1
                      wave_file=' '
                      wave_file(1:78)=data(i)(2:79)
                      call  get_full_wav_name(wave_file,txt)
                      if(txt.eq.' ') then
                         write(9,'(a,a)')
     *                   ' File does not exist: ',
     *                   wave_file(:seiclen(wave_file))
                         write(9,*) txt
                      else
                         wav_present(istat,day1)=
     *                   wav_present(istat,day1)+1
                      endif
                endif
            enddo
c
            goto 30   ! next event
         endif
      else       ! must be end of month, jump to end of loop
         goto 40
      endif
c
 40   continue
c
c----------------------------------------------------------------------
c   end of station loop
c----------------------------------------------------------------------
c
      enddo
c                                                                              
c
c   write out total statistics for that month or interval
c
 999  continue                                                                  
c
      write(3,'(a,a,2x,a)')
     *'  Statistics for year and month interval : ',
     * start_time(1:8),end_time(1:8)
      write(3,*)
      read(start_time(7:8),'(i2)')day1
      if(day1.eq.0) day1=1
      read(end_time(7:8),'(i2)') day2
      if(day2.eq.0) then
        call month_day(year1,month1,day2)  ! find number of days in month
      endif
      write(3,'(a3,6x,38(a5))') 'Day',(stat(i),i=1,nstat)
      do i=day1,day2
c
c   system 
c
         write(text,'(i3,a4,38i5)')i,' SEI',(int(up(k,i)+0.5),k=1,nstat)
         do l=1,207
           if(text(l:l).eq.'-') text(l:l+1)=' .'
         enddo 
         write(3,'(a)') text(1:207)
c
c   gps
c
         write(text,'(3x,a4,38i5)')' GPS',
     *   (int(up_gps(k,i)+0.5),k=1,nstat)
         do l=1,157
           if(text(l:l).eq.'-') text(l:l+1)=' .'
         enddo 
         write(3,'(a)') text(1:207)
c
         write(3,'(3x,a4,38i5)')' DET',(det(k,i),k=1,nstat)
c
c  wav files
c
         write(text,'(3x,a4,38i5)')' WAV',
     *   (wav_total(k,i),k=1,nstat)
         do l=1,207
           if(text(l:l).eq.'-') text(l:l+1)=' .'
         enddo 
         write(3,'(a)') text(1:207)

         write(text,'(3x,a4,38i5)')' WAP',
     *   (wav_present(k,i),k=1,nstat)
         do l=1,207
           if(text(l:l).eq.'-') text(l:l+1)=' .'
         enddo 
         write(3,'(a)') text(1:207)

         write(3,*)
      enddo
c----------------------------------
c   average values if more than one day
c----------------------------------
c
      if(day2.gt.day1) then
      do k=1,nstat
         do i=day1,day2
            if(up(k,i).gt.-1.0) then
              average_up(k)=up(k,i)+average_up(k)
              n_up(k)=n_up(k)+1
            endif
c
            average_det(k)=average_det(k)+det(k,i)
c
c   gps
            if(up_gps(k,i).gt.-1.0) then
              average_up_gps(k)=up_gps(k,i)+average_up_gps(k)
              n_up_gps(k)=n_up_gps(k)+1
            endif
c
c   wav
c
            ava_wav_total(k)=wav_total(k,i)+ava_wav_total(k)
            ava_wav_present(k)=wav_present(k,i)+ava_wav_present(k)
         enddo
      enddo
c
      do k=1,nstat
         if(n_up(k).ne.0) then
c            average_up(k)=average_up(k)/n_up(k)     ! average over active days
            average_up(k)=average_up(k)/(day2-day1+1)  ! average over all days
         else
            average_up(k)=-1.5
         endif
c
         average_det(k)=average_det(k)/(day2-day1+1)
c
c   gps
c
         if(n_up_gps(k).ne.0) then
c           average_up_gps(k)=average_up_gps(k)/n_up_gps(k)  ! average active days
            average_up_gps(k)=average_up_gps(k)/(day2-day1+1)  ! average all days
         else
            average_up_gps(k)=-1.5
         endif
         
      enddo
      write(3,*)
      write(text,'(a7,38i5)')'AVA SEI',
     *(int(average_up(k)+0.5),k=1,nstat)
      do l=1,207
        if(text(l:l).eq.'-') text(l:l+1)=' .'
      enddo 
      write(3,'(a)') text
c
c gps

      write(text,'(a7,76i5)')'AVA GPS',(int(average_up_gps(k)+0.5),
     *k=1,nstat)
      do l=1,207
        if(text(l:l).eq.'-') text(l:l+1)=' .'
      enddo 
      write(3,'(a)') text
c
      write(3,'(a7,38i5)')'AVA DET',
     *(int(average_det(k)+0.5),k=1,nstat)
      write(3,'(a7,38i5)')'TOT DET',
     *(int(average_det(k)*(day2-day1+1)),k=1,nstat)
      write(3,'(a7,38i5)')'TOT WAV',
     *(ava_wav_total(k),k=1,nstat)
      write(3,'(a7,38i5)')'TOT WAP',
     *(ava_wav_present(k),k=1,nstat)
      write(3,'(a3,6x,38(a5))') '   ',(stat(i),i=1,nstat)

      endif

      close(3)
      call systemc('enscript -r -fCourier6 -Phpbw11 stalog.out',
     *42)
            
c
      write(6,*)                                                                
      write(6,*)'Output file is stalog.out and stalog_wav.out' 
      stop                                                                      
      end

c$debug
c
c	This program identifies possible "Cluster"
c       activity, around a time-space window centered
c       in a "Big" event.
c	The program receives a files, which contains
c	a catalog of earthquakes (inf1). This catalog must
c	be in nordic format
c	Some of the more relevant aspects of the pro-
c	cedure followed are:
c		- The Magnitude above which value, an
c		  event is considered a main one (xmag).
c		- The Time window considered for sear-
c		  ching the cluster (lday & hday)
c		- The distance from the source
c      The program output will be (cluster.cat) a catalog
c      equal to inf1 but now containing '?' marks at the
c      end of the line of each apparent cluster event.
c 
c      May , 1994         Juan Pablo Ligorria
c      Modified March,95     -  "  -
c      Feb 1999 by jh   : ----------   version 7.0 check ----------------
c                         no changes
c
c
      character*80 inf1
      character*81 card1(14000)
      real lat2,lon2,lat1,lon1,dist,distance,mdis
      real mag1,mag2,mag3,max
      integer yr2,mn2,day2,yr1,mn1,day1
      integer lday,hday,day,cday,bef,aft



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      write(*,*)' File with catalog of earthquakes....'
      read(*,'(a)')inf1
      open(1,file=inf1,status='old')
      open(4,file='cluster.out',status='unknown')
      do i=1,14000
       read(1,'(a)',end=99)card1(i)
      enddo

99    n1 = i - 1
      write(*,*)n1,' events in catalog'

      write(*,*)' Magnitude of Big event ? '
      read(*,*)max 
      write(*,*)' Number of days before event ? (integer)'
      read(*,*)bef
      write(*,*)' Number of days after Big event ? (integer)'
      read(*,*)aft
      write(*,*)' Minimum distance for analysis ? '
      read(*,*)mdis

      do i=1,n1

c     if(card1(i)(80:80) .ne. '1') go to 98
c     if(card1(i)(1:1) .ne. '*') go to 98

      read(card1(i),100)yr2,mn2,day2,lat2,lon2,mag1,mag2,mag3
100   format(1x,i4,1x,2i2,13x,f7.0,f8.0,18x,3(f3.0,5x))

      xmag = amax1(mag1,mag2,mag3)

      if(xmag .ge. max)then
         write(*,*)'Big event in',i,' card'
         write(4,*)'    '
         card1(i)(81:81)= ' '
         write(4,'(a)')card1(i)
	 day = yr2*365 + mn2*30 + day2
	 lday = day - bef
	 hday = day + aft
	 do k = i-50,i+50
	   kk = k
	   if(kk .lt. 1)kk = 1
	   if(kk .gt. n1)kk = n1
	   if(card1(kk) .eq. card1(i)) go to 97
c	   if(card1(kk)(80:80) .ne. '1') go to 97
	   read(card1(kk),100)yr1,mn1,day1,lat1,lon1,mag1,
     +         mag2,mag3
	   cday = yr1*365 + mn1*30 + day1

	   if(cday .gt. lday .and. cday .lt. hday)then
	      dist = distance(lat1,lat2,lon1,lon2)
	      if(dist .le. mdis)then
	        card1(kk)(81:81) = '?'
                write(4,'(a)')card1(kk)
c               write(*,'(a)')card1(kk)
              endif
           endif
97         continue
	 enddo
       endif
98    continue
      enddo

c     do i =1,n1
c	write(4,'(a)')card1(i)
c     enddo

      write(*,*)' Output file is "cluster.out"'
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      function distance(lat1,lat2,lon1,lon2)
      real lat1,lat2,lon1,lon2
      rad = (lat1*3.1415)/180.
      y = abs(lat1-lat2)*111.
      x = abs(lon1-lon2)*111.*cos(rad)
      distance = sqrt(x**2 + y**2)
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c   - program to get waveform data from all waveform files in one s-file,
c     or a list ow waveform file in a file of filenr.lis format
c     the data  can be selected in verious ways like channels, times etc
c   - the information is written out to a file in the local directory 
c   - in seisweb mode, data is  written to a file specified
c     and at end a seisweb message written to screen
c   - output format is SEISAN, GSE and SAC
c   - program can also only give file info
c   - optinally points can be skipped so resampled files can also be made,
c     it is up to the user to use correct antialias filters
c   - filter option is a 4 poles butterworth running one way, ther si currently
c     no check if the output after filtering is larger than one so funny
c     results might occur in the write out
c
c   arguments:
c              -seisweb: use with seisweb, seisweb screen message
C
c              -chan_out_file: file name  of file with channel description
c                              if this option is given, program terminates
c                              after writing out the file
c              -wav_out_file: complete filename including path to wav output,
c                        if not set, output to extract.out 
c                        If set to SEISAN, a seisan standard output file name
c                        will be used, net code from SEISAN.DEF
c              -sfile  : s-filename with complete path
c              -wav_files: list of waveform files, filenr.lis format
c                          overrides input from -sfile
c              -format : output format, SEISAN, GSECM6, GSEINT, MSEED, SEED 
c                        default is SEISAN
c              -maxpoints : skip points to get approximately maxpoints
c              -filter : bandpass filter limits 
c              -ground : compute displacement, velocity or acceleration (1,2,3)
c              -chansel: file with selection parameters, if -chansel not used,
c                        all channels selected with whole window.
c                        Format: First line gives number of channels, free form
c                                Each following line give channel #, start and
c                                duration of selected channels. if start is
c                                zero use first sample, if interval is zero,
c                                use whole interval, free format
c              -start  : (1) Start time relative earliest channnel,
c                        (2) Abs start time string yy...s.sss for all channels
c                            IF ABS time used, string MUST contain a '.'
c                        (3) Abs start time string yyyymmddhhmmss (integer),
c                            used to define cont start time
c              -duration:    length of all channels to select
c                             start and duration not used if chansel file given 
c                             -duration will not have an effect if -start
c                             is not used.
c
c              -ichan : selection of one channel
c              -npole n: number of poles used for filter
c              -stat_out: write out station location file
c              -resp_out: write out list of response files
c              -cwav    : read from cont data base
c              -cseed   : interval from large seed volume
c              -seed_location: seed location code NOT USED 
c              -wav_in_file: input waveform file
c              -interactive : enable interactive mode
c              -rsam: comput 1 min rsam data
c              -cbase: name of file with selected continuous databases, 
c                     all is default
c
c   examples:
c  
c   wavetool -sfile sfile     
c           all channels selected from all files
c   wavetool -sfile sfile -start 100
c           start 100 secs after earliest channel, take all channels and all
c           remaining data
c   wavetool -sfile sfile -start 19950101202211.1 
c           same as above except now start time is in absolute time
c   wavetool -wav_in_file lsa.iris.big.seed -start 19990509000000 -duration 500 -cseed
c           extract from a seed volume
c
c
c changes:
c
c april 19, 00 lo fix gse output
c april 20, 00 lo add some arg options and fix gse output
c april 25     jh many changes
c may    3     lo routine signal_to_visual
c may    8  00 lo some fixes with the chansel input file
c may   10     jh set network code to MERGE if no code defined
c may   15     lo some smaller changes, bug net code(jh)
c may   25     bmt add ichan option (select 1 channel)
c oct   20     jh  merge_wav changed to 5 chars
c feb   01 01  lo ground motion output
c mar   05 01  lo use i3 in channel list
c mar   06 01  lo keep time of max and min in signal_to_visual
c may   01 01  lo started to extract from waveform files directly
c july  13 01  lo extract now also wave conversion, any input, any output
c nov   11 01  jh extract from cont base
c dec   03 01  bm clean chan_out_file when nothing is found
c              bm added new option "-command_file" for reading prompt arguments 
c                 from a file, one line per argument
c mar 14   02  jh comment out write(17
c april 30 02  lo seisan output always 4 byte
c may   8  02  bm multiply by 10 when output is GSE format (only seisweb)
c aug  22  02  lo added option -wav_in_file to give waveform file nam
c apr 9    03  jh put in gain in seisan output if filter or ground correction to
c                  make sure values are more than 1 count, make it possibele to filter
c                  also when no response removal, check if filtering is possible
c may 14   03  jh  add text to header when corrected output written
c jun 30   03  lo add rsam output
c sep 10   03  jh check value of sample in GSE format, if response, was sometimes too big
c apr      04  lo: some format fixing
c dec 2        jh: large seed volume
c mar 10   05  jh: add component to output file name if only one channel
c jun 20   05  jh: seed location code input
c feb 17   06  jh: change references to extract. NOTE: seisweb uses old 
c                  extract !!!!!!!
c mar 28   06  jh: bug with overwrite seisan file
c                  bugs in defining waveform file name etc pointed out
c                  by wayne crawford
c mar 30   06  lo: option to select continuous database, used from mulplt
c jan 17   07  jh: fix bug when reading seed files with time gap, if converting
c                  to seisan file, main header will be wrong, but channel
c                  header ok, to be fixed
c mar 14   07  lo: added seed output using gse2seed
c mar 21   07  lo: added option for dataless seed
c may 30   07  lo: use file to read cbase
c oct 24   07  jh: put in writing of location and networ in seisan and mseed
c                  remove old INPUT OF LOCATION CODE, should now come from
c                  input file
c dec 19   07  jh  fix probelm of wrong interval using selection out of a 
c                  seed file, cseed in common block
c aug 01   08  lo  set wav_interactive to true if filenr.lis
c aug 27   08  jh  put in more comments
c oct 23   08  jh  fix output for seisweb from chan_out_text

      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      include 'waveform.inc'
      include 'seisan.inc'
      include 'write_mseed.inc.f'
      integer seiclen
      integer nstat,nphase,nhead,nrecord,id   ! for reading s-file
      character*1 type,exp                    ! -----------------
      character*80 sfilname                   ! s-file name
      character*80 chan_out_file              ! file name for channel info
      character*80 data(max_data)             ! one s-file
      character*80 chansel                    ! file with selection
      integer npresent                        ! number of wav files present
      character*80 text                       ! general text string
      character*80 wav_out_file               ! full name of output file
      character*80 wav_files                  ! input files with wav f. names
      character*80 file_out                   ! output file name
      character*80 seed_file_out              ! output file name
      character*5  net_code                   ! network code, for output file name
      integer narg                            ! number of arguments
      character*80 arg(40)                    ! arguments
      logical seisweb                         ! true if call from seisweb
      logical exist                           ! file existance
      logical station_out_flag                ! true if write out station file
      logical resp_out_flag                   ! true if write out list of 
c     logical cseed now in common block       ! large seed file
                                              ! resp files 
c     character*2 seed_location_code          ! seed location code
      character*80 stat_list(max_trace)       ! station list
      integer stat_cnt                        ! station counter
      character*80 format_out                 ! output format
      integer max_points                      ! maximum number of points out
      integer nskip(max_trace)                ! number of points to skip
      integer syear,smonth,sday,shour,smin    ! common start
      real ssec                               ! common start
      integer code                            ! return error code
      real flow,fhigh                         ! filter band pass f
      integer npole                           ! number of poles
      real      cof(8)                        ! filter coefficients
      real      gain                          ! filter gain
      logical ground                          ! true if ground motion
      integer ground_type                     ! dis=1, vel=2 or acc=3
      complex y_com(max_sample)               ! complex spectrum
      integer file_cnt                        ! file counter
      real slat,slon,sheight                  ! station location
      character*1 resp_flag                   ! Y if response there
      character*1 statfile_char               ! character in station file
      character*120 chan_out_text(1000)       ! output text array
      real dc,ndc                             ! used for remove_dc
      character*80 question                   ! question for filenames
      logical sfile_flag                      ! true if sfile
      logical rsam_flag                       ! true for rsam output
      character*5 cbase_select(max_cont)      ! selected databases
      integer n_cbase_select                  ! number of the above
      character*80 cbase_list                 ! file with cont databases

c
c  following for seisan format output files
c
      integer year(max_trace),month(max_trace),day(max_trace),
     *        hour(max_trace),min(max_trace),nsamp(max_trace)
      real rate(max_trace),sec(max_trace)
      character*80 mainhead(max_trace)   ! seisan main header
      character*1040 chahead             ! seisan channel header
      character*29 h_text                ! seisan header
      integer signal4b(max_sample)       ! 4 byte seisan data
      integer*2 signal2b(max_sample)     ! 2 byte seisan data
      character*1 cbyte(max_trace)       ! indicator of 2 or 4 bytes
      real ymax                          ! maximum output value
      real factor                        ! gain factor if used
c
c  following parameters for selected output
c
      double precision start,duration    ! start and duration one channel
      character*18 pstart                ! absolute start from prompt,ymdhms
      double precision abs_start_time    ! pstart in seconds
      real pduration                     ! duratiopn from prompt
      character*5 stat(max_trace)
      character*4 comp(max_trace)
      character*2 location(max_trace)    ! seed location
      character*2 network(max_trace)     ! seed network
      integer i,k,j,l,ichan,in
      character*80 file
      real evla,evlo,evel                ! event loctaion
      integer nerr                       ! error code
      logical open_file,op_file          ! for opening mseed file
      integer mseed_block                ! block counter for wring miniseed files
      character*160 system_call
      logical sun,linux,pc
c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver
      call computer_type(sun,pc,linux)

      chan_out_file=' '
      sfilname=' '
      wav_files=' '
      wav_out_file=' '
      seisweb=.false.
c     seed_location_code='  '
      pstart='0'
      flow=0.0
      fhigh=0.0
      npole=4
      pduration=0.0
      n_cbase_select=0
      chansel='_'
      format_out='SEISAN'     ! default format to write is seisan
      evla=0.
      evlo=0.
      evel=0.
      ichan=-1
      ground=.false.
      ground_type=0
      in=0
      statfile_char=' '
      stat_cnt=0
      sfile_flag=.false.
      station_out_flag=.false.
      resp_out_flag=.false.
      max_points=0
      wav_interactive=.false.
      rsam_flag=.false.
      cseed=.false.
      mseed_block=1             ! start with first block
      cbase_list=' '
      
c
c   get seisan defaults for network code merge_wav
c
      call get_seisan_def
c
c   get arguments
c
      call get_arguments(narg,arg)

 10   continue
      if(narg.lt.2) then
c
c   get s-file name or waveform file name
c
         question=' Filename of s-file or waveform file, ' //
     &          'number or filenr.lis '
         call filename(question,sfilname)
         if (seiclen(sfilname).le.0.or.sfilname.eq.'EOF') stop


c
c filenr.lis, interactive input
c
         if (sfilname(1:10).eq.'filenr.lis') then 
           open(2,file='filenr.lis',status='old', err=999)
           in=1
           wav_interactive=.true.  ! lot 1/8/08
           file_cnt=0
  11       continue
           read(2,'(7x,a)',end=12) sfilname
           if(sfilname(1:1).eq.' ') go to 12
           goto 13
  12       continue
           close(1)
           goto 10
         endif
  13     continue
         file_cnt=file_cnt+1  
c
c   check if wav file exist
c
         if(sfilname.ne.' ') then
            inquire(file=sfilname,exist=exist)
            if(.not.exist) then
               write(6,*) ' No such file'
               goto 10
            endif
         endif
  
c
c   interactive input of parameters
c
         text=' '
         if (in.eq.0) then
           write(6,*) 
     *     'Maximum number of points in output trace, return for all'
            read(5,'(a)') text
         endif
         if(text.eq.' ') then 
            max_points=0
         else
            read(text,'(i8)') max_points
         endif
         text=' '

         if (file_cnt.eq.1) then
           write(6,*) ' Ground motion output (dis = 1, '
     &         // 'vel = 2, acc = 3, none = return)'
           read(5,'(a)') text
           if(text.eq.' ') then 
              ground_type=0
           else
              read(text,'(i1)') ground_type
              if (ground_type.eq.1.or.
     &                ground_type.eq.2.or.
     &                ground_type.eq.3) then
                 ground = .true.
              endif
c
c read filter
c
c             write(*,*) ' filter low and high '
c             read(5,*) flow,fhigh
           endif
c
c read filter
c
           write(*,*) ' Filter low and high, return for no filter '
           read(5,'(a)') text
           if(text.eq.' ') then
             flow=0.0
             fhigh=0.0
           else
             call sei get values(2,text, code ) 
             flow=array$(1) 
             fhigh=array$(2)
           endif              
         endif
      else
c
c  read argument from a file
c
	   if( arg(1)(1:13) .eq. '-command_file' ) then
	     call get_argument_from_file(arg,narg)
         endif

c
c   read arguments to fill in choices
c
         do i=1,narg
            if(arg(i)(1:13).eq.'-wav_out_file') then
               wav_out_file=arg(i+1)
            endif
            if(arg(i)(1:6).eq.'-sfile') then
               sfilname=arg(i+1)
               sfile_flag=.true.
            endif
            if(arg(i)(1:6).eq.'-cbase') then
c               n_cbase_select=n_cbase_select+1
c               cbase_select(n_cbase_select)=arg(i+1)
                cbase_list=arg(i+1)
            endif
            if(arg(i)(1:7).eq.'-filter') then
                call sei get values(1,arg(i+1), code )  
                flow=array$(1) 
                call sei get values(1,arg(i+2), code )
                fhigh=array$(1) 
            endif
            if(arg(i)(1:5).eq.'-rsam') then
               rsam_flag=.true.
            endif
            if(arg(i)(1:6).eq.'-npole') then
                call sei get values(1,arg(i+1), code )
                npole=int(array$(1))
            endif
            if(arg(i)(1:7).eq.'-ground') then
                call sei get values(1,arg(i+1), code ) 
                ground_type = int(array$(1))
                if (ground_type.eq.1.or.
     &              ground_type.eq.2.or.
     &              ground_type.eq.3) then
                  ground = .true.
                endif
            endif
            if(arg(i)(1:8).eq.'-seisweb') then
                seisweb=.true.
            endif
            if(arg(i)(1:9).eq.'-stat_out') then
                station_out_flag=.true.
            endif
            if(arg(i)(1:9).eq.'-resp_out') then
                resp_out_flag=.true.
            endif
            if(arg(i)(1:10).eq.'-wav_files') then
                wav_files=arg(i+1)
            endif
            if(arg(i)(1:7).eq.'-format') then
                format_out=arg(i+1)
            endif
            if(arg(i)(1:8).eq.'-chansel') then
                chansel=arg(i+1)
            endif
            if(arg(i)(1:14).eq.'-chan_out_file') then
                chan_out_file=arg(i+1)
	          open(1,file=chan_out_file,status='unknown')
	          endfile 1
                rewind 1
	          close(1)
            endif
            if(arg(i)(1:6).eq.'-start') then
                pstart=arg(i+1)
            endif
            if(arg(i)(1:9).eq.'-duration') then
                call sei get values(1,arg(i+1), code )   ! Extract 1 value
                pduration=array$(1) 
            endif
            if(arg(i)(1:10).eq.'-maxpoints') then
                call sei get values(1,arg(i+1), code )   ! Extract 1 value
                max_points=array$(1) 
            endif
            if(arg(i)(1:6).eq.'-ichan') then
                call sei get values(1,arg(i+1), code )   ! Extract 1 value
                ichan=array$(1)
            endif
            if(arg(i)(1:5).eq.'-cwav') then
                cwav=.true.                              ! cont base
            endif
            if(arg(i)(1:6).eq.'-cseed') then
                cseed=.true.                             !  large seed
            endif
c           if(arg(i)(1:6).eq.'-seed_location') then
c               seed_location_code=arg(i+1)(1:2)         !  seed location code
c           endif
            if(arg(i)(1:12).eq.'-interactive') then
                wav_interactive=.true.
            endif
            if(arg(i)(1:12).eq.'-wav_in_file') then
                sfilname=arg(i+1)
            endif
         enddo
      endif
c
c--------------------------------------------------------
c---------------------------------------------------------
c   get all info if cont data base or a large seed file
c---------------------------------------------------------
c---------------------------------------------------------
c
      if(cwav.or.cseed) then
c
c check if cont databases
c
        if(cwav) then
         if (n_cont_base.eq.0) then
           write(6,*) ' No continuous database defined in SEISAN.DEF '
           stop
         endif
c
c read file with cont databases
c
         if (cbase_list.ne.' ') then
           open(1,file=cbase_list,status='old')
18         continue
           n_cbase_select=n_cbase_select+1
c           write(*,*) n_cbase_select
           read(1,'(a)',end=19) cbase_select(n_cbase_select)
c           write(*,*) ' database selected: '//
c     &          cbase_select(n_cbase_select)
           goto 18
19         continue
           close(1)
           n_cbase_select=n_cbase_select-1
         endif
c
c check if databases selected
c
         if (n_cbase_select.gt.0) then
           do i=1,n_cbase_select
              cont_base(i)=cbase_select(i)
           enddo
           n_cont_base=n_cbase_select
         endif
c
c write out the databases
c
         write(*,*)'Databases are:'
         do i=1,n_cont_base
            write(*,*)'    ',cont_base(i)
         enddo
        endif
c
c   get start time and time interval
c
         if(pduration.eq.0.0.or.pstart.eq.' ') then
            write(6,*)
     *     'Abs start time and interval must be given for'//
     *      ' cwav or cseed option'
            stop
         endif

         cwav_start_time=pstart     ! also used for seed
         pstart='0'     ! indicate that whole window used, no further
                        ! selection in time
         cont_interval=pduration

c
c   calculate end time and extended start time
c
         call cwav_time_limits(0)
c
c  read the header information for all files in all bases in time
c  interval, assume info available in common block, not large seed file
c
         if(cwav) call cwav_read_bases
c
c  read data for section of seed file
c
         if(cseed) then
            if(sfilname.ne.' ') then
              open(1,file=sfilname,status='old', err=999)
c
c  read s-file
c
              call indata
     *        (1,nstat,nphase,nhead,nrecord,type,exp,data,id)
              close(1)
c
c   get waveform file names
c
              call auto_tr(data,nhead,wav_nfiles,wav_filename)
            else 
              wav_filename(1)=' '
              wav_filename(1)=sfilname
            endif
            wav_nfiles=1         ! only one file can be used
c           call get_full_wav_name
c    *      (wav_filename(1), wav_filename(1))
            write(*,*) ' reading waveform headers ... '
            write(6,*) wav_filename(1)
            call wav_init
            call read_wav_header(1)
            write(6,*) 'headers read'
            call wav_seed_read_header_interval ! find position in file of window
            write(6,*) ' seed read'
         endif
 
c
c for continuous/seed data, if number of samples not set, do it here
c
         do k=1,wav_nchan
           if (wav_nsamp(k).le.0) then
             write(6,*)'set nsamp'
             wav_nsamp(k)=int(pduration*wav_rate(k))
             wav_duration(k)=pduration
           endif
         enddo

c
c   terminate if no waveform files
c
         if(wav_nchan.eq.0) goto 999   
         goto 700      ! jump all normal reading, straight to output
      endif
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
ccccccccccccccc  end of section for large seed or cont data cccccccccccc
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c


c-----------------------------------------------------------------------
c check if waveform file by reading the header
c this is done because sfilname can be a waveform file name
c and a sfile name, should be changed !
c at this point, the waveform file name is transferred from 
c sfilname to wav_file_name
c-----------------------------------------------------------------------

      if (.not.sfile_flag.and.sfilname.ne.' ') then
        wav_error_message=' '
        call wav_init
        wav_nfiles=1
        wav_filename(1)=' '
        wav_filename(1)=sfilname
        call get_full_wav_name(sfilname, wav_filename(1))
c       write(*,*) ' reading waveform headers ... '
        call read_wav_header(1)
      endif
c
c---------------------------------------------------------
c  case of waveform files from sfile
c---------------------------------------------------------
c
c check if sfile, if not waveform
c
      if(wav_error_message.ne.' ') then
       if(sfilname.ne.' ') then    ! assume s-file
         open(1,file=sfilname,status='old', err=999)
c
c  read s-file
c
         call indata
     *   (1,nstat,nphase,nhead,nrecord,type,exp,data,id)
         close(1)

c
c read location and depth from first line
c
         read(data(1)(24:43),'(f7.3,f8.3,f5.2)') evla,evlo,evel
         read(data(1)(16:16),'(a1)') statfile_char

c
c   get waveform file names
c
         call auto_tr(data,nhead,wav_nfiles,wav_filename)
       endif
      endif
c
c----------------------------------------------------------------
c   case of input from a list of waveform files
c---------------------------------------------------------------
c
c   check for waveform files in a filenr.lis format input file
c   wav_files is from argument list
c
      if(wav_files.ne.' ') then
         write(6,*) wav_files
         open(1,file=wav_files,status='old', err=999)
         j=0
 20      continue
         j=j+1
         read(1,'(7x,a)',end=21) wav_filename(j)
         if(wav_filename(j).ne.' ') go to 20
 21      continue
         wav_nfiles=j-1
      endif
c
c----------------------------
c
      if(.not.seisweb) then              
        write(6,*)' Number of wav-files',wav_nfiles
      endif
c
c   find how many waveform files are present, replace the origial
c   names with the present files full path
c
      npresent=0                ! no files initially
      do i=1,wav_nfiles
          call get_full_wav_name(wav_filename(i),text)
      if(.not.seisweb) then              
c        write(*,*) i,wav_filename(i),text
      endif
          if(text.ne.' ') then
             npresent=npresent+1
             wav_filename(npresent)=text
          endif
      enddo
      wav_nfiles=npresent
      if(.not.seisweb) then              
        write(6,*)' Number of wav-files present', wav_nfiles
      endif

c
c   terminate if no waveform files
c
      if(wav_nfiles.eq.0) goto 999   
c
      wav_nchan=0
c
c   loop to read all headers of all files
c
      do i=1,wav_nfiles
c        write(6,'(1x,a)') wav_filename(i)
         call read_wav_header(i)
         if(wav_error_message.ne.' ') write(6,'(1x,a)') 
     *   wav_error_message
         write(6,'(1x,a40,2x,a)') wav_filename(i)(1:40),
     *   wav_file_format(i)
      enddo
c
      if(.not.seisweb) then              
        write(6,*)' Total number of channels available:',wav_nchan
      endif
c
c   terminate if no channels
c
      if(wav_nchan.eq.0) goto 999

c---------------------------------------------------------------
c   section for output, if cont data base enter here directly
c   since all headers read above
c---------------------------------------------------------------
c
 700  continue      ! from cont reading above
c
c   write input out, optionally also in a file
c
      if(.not.seisweb) then              
        write(6,*)' Total duration:',wav_total_time
        open(3,file='respfile_list.out',status='unknown')
        do i=1,wav_nchan
c
c check if response available for channel and get station location
c
c   j was not set in 2. "if(station_out..)", pointed out by  
c   wayne crawford, mar 06, so in following line j=1 so j is set 
c   when station_out is false
c
          j=1
c
          if (station_out_flag) then
            call stat_loc(wav_stat(i),statfile_char,slat,slon,sheight)
c 
c sort into station location array
c
            j=1
            do while(j.le.stat_cnt.and.
     &           wav_stat(i).ne.stat_list(j)(1:5))
               j=j+1
            enddo
          endif
          if (station_out_flag.and.
     &       wav_stat(i).ne.stat_list(j)(1:5)) then
             stat_cnt=stat_cnt+1
             stat_list(stat_cnt)=' '
             write(stat_list(stat_cnt),'(a5,1x,f8.3,1x,f8.3)')
     &             wav_stat(i),slat,slon
          endif

          resp_flag='N'
          if (ground.or.resp_out_flag) then
            wav_current_chan(1) = i
            wav_resp_file = ' '
c xxx
            call read_resp
            if (wav_resp_filename.ne.' ') then
              resp_flag='Y'
              write(3,'(a)')
     &    wav_resp_filename(1:seiclen(wav_resp_filename))
c              write(3,'(a)') 'cp /net/seismo/seismo/CAL/'//
c     &         wav_resp_filename(1:seiclen(wav_resp_filename)) //' .'
            else
c            write(555,'(a)') 'cp /net/seismo/seismo/CAL/'//
c     &         wav_resp_file(1:seiclen(wav_resp_file)) //' .'
            endif
            wav_resp_file = ' '
          endif

c         write(6,'(1x,i2,1x,a,1x,a,1x,i5,4i3,f7.3,i6,3f9.3)')
c 05 march 2001, lo
c 08 June 2001 lo, added location and resp
c
          chan_out_text(i)=' '
         write(chan_out_text(i),
     *        '(i3,1x,a,1x,a,1x,i5,4i3,f7.3,i6,3f9.3,
     *        2(1x,f8.3),1x,f5.0,1x,a1)')
     *   i, wav_stat(i),wav_comp(i),
     *   wav_year(i),wav_month(i),wav_day(i),wav_hour(i),wav_min(i),
     *   wav_sec(i),wav_nsamp(i),wav_rate(i),wav_delay(i),
     *   wav_duration(i),
     *   slat,slon,sheight,resp_flag

         write(*,'(a)') chan_out_text(i)(1:seiclen(chan_out_text(i)))

        enddo
        close(3) ! close response list file
        if (station_out_flag) then
          open(3,file='station_list.out',status='unknown')
          open(4,file='station_list.err',status='unknown')
          do j=1,stat_cnt
            read(stat_list(j),'(6x,f8.3,1x,f8.3)') slat,slon
            if (slat.ne.0..and.slon.ne.0.) then
              write(3,'(a)') stat_list(j)(1:seiclen(stat_list(j)))
            else
              write(4,'(a)') stat_list(j)(1:seiclen(stat_list(j)))
            endif
          enddo
          close(3)
          close(4)
        endif
      endif

      if(seisweb) then
         do i=1,wav_nchan
         chan_out_text(i)=' '
         write(chan_out_text(i),
     *        '(i3,1x,a,1x,a,1x,i5,4i3,f7.3,i6,3f9.3,
     *        2(1x,f8.3),1x,f5.0,1x,a1)')
     *   i, wav_stat(i),wav_comp(i),
     *   wav_year(i),wav_month(i),wav_day(i),wav_hour(i),wav_min(i),
     *   wav_sec(i),wav_nsamp(i),wav_rate(i),wav_delay(i),
     *   wav_duration(i),
     *   slat,slon,sheight,resp_flag
         enddo
      endif

c
c   read channel selection file
c
      if(chan_out_file.ne.' ') then
         open(1,file=chan_out_file,status='unknown')
         do i=1,wav_nchan
c            write(1,'(1x,i2,1x,a,1x,a,1x,i5,4i3,f7.3,i6,3f9.3)')
c 05 march 2001, lo
           write(1,'(a)') chan_out_text(i)(1:seiclen(chan_out_text(i)))

c            write(1,'(i3,1x,a,1x,a,1x,i5,4i3,f7.3,i6,3f9.3)')
c         write(1,'(i3,1x,a,1x,a,1x,i5,4i3,f7.3,i6,3f9.3,
c     *        2(1x,f8.3),1x,f5.1,1x,a1)')
c     *      i, wav_stat(i),wav_comp(i),
c     *      wav_year(i),wav_month(i),wav_day(i),wav_hour(i),wav_min(i),
c     *      wav_sec(i),wav_nsamp(i),wav_rate(i),wav_delay(i),
c     *      wav_duration(i),
c     *      slat,slon,sheight,resp_flag
         enddo
         close(1)
         if (wav_out_file.eq.' ' ) then
           if(seisweb) then
             write(6,*)'extract channel info terminated: ok ', wav_nchan
           endif
           stop
         endif
      endif

c
c-------------------------------------------------------------------------
c  select and possibly process data for output file, can be done
c  from keyboard if no input on  prompt line
c  following is what is selected using keyboard input
c-------------------------------------------------------------------------
c
c   select channels to read, by default all data are selected
c
      call wav_index_total
      do i=1,wav_nchan
        wav_out_chan(i)=i
        wav_out_start(i)=wav_abs_time(i)-wav_abs_time(wav_first)
        wav_out_duration(i)=wav_duration(i)
c        write(6,*) 'org wav duration', wav_duration(i)
      enddo
      wav_out_nchan=wav_nchan
c
c-----------------------------------------------------------------------
c  keyboard input
c-----------------------------------------------------------------------
c     
      if(narg.lt.2) then
       if(in.ne.1) then
         write(6,*)' Select all data, y=return,n'
         read(5,'(a)') text
         if(text.ne.' '.and.text.ne.'y'.and.text.ne.'Y') then 
            write(6,*)' Number of channels to read'
            read(5,*) wav_out_nchan
            write(6,*)' Channel number, start time and window'
            do i=1,wav_out_nchan
               read(5,*,err=555) wav_out_chan(i),start,duration
c
c   find out if a small or a large number, which indicate if abs start
c
               if(start.gt.1.0e10) then
                  write(pstart,'(f18.3)',err=555) start
                  read(pstart,'(i4,4i2,f6.3))',err=555)
     *            syear,smonth,sday,shour,smin,ssec
                  goto 556
 555              continue
                  write(6,*)' Error in input'
                  stop
 556              continue
                  call timsec(syear,smonth,sday,shour,smin,ssec,
     *            abs_start_time)
                  start=abs_start_time-wav_abs_time(wav_first) ! cal. rel start
               endif
               wav_out_start(wav_out_chan(i))=start  ! put in correct channel
               if(duration.ne.0.0) then
                  wav_out_duration(wav_out_chan(i))=duration
               endif
            enddo
         endif
        endif
        if ((in.eq.1.and.file_cnt.eq.1).or.(in.eq.0)) then
          if (sun) then
            write(*,*) 
     *' Output formats '//
     *'(SEISAN, GSE (def=CM6), GSEINT, SAC, MSEED, SEED, SEEDDL) '
          else
            write(*,*) 
     *' Output formats '//
     *'(SEISAN, GSE (def=CM6), GSEINT, SAC, MSEED) '
          endif
          write(*,*) ' Default is SEISAN=return'
          read(*,'(a)') format_out
          call casefold(format_out)
          if(format_out.eq.' ') format_out='SEISAN'
          if(format_out.eq.'SEED'.and..not.sun) then
            write(*,*) ' SEED output format only works on sun '
            stop
          endif
c         if(format_out.eq.'MSEED'.and.seed_location_code.eq.'  ') then
c             write(6,*)'SEED location code, 2 characters'
c             read(5,'(a2)') seed_location_code
c         endif
        endif
       else
c
c------------------------------------------------------------------------------
c   selection is from prompt, if no selection file, all data selected initially
c   there could also be a start and duration, see below
c------------------------------------------------------------------------------
c

c-------------------------
c   option selection file
c-------------------------
c
         if(chansel.ne.'_') then         ! from a file
            open(1,file=chansel,status='old',err=901)
            goto 902
 901        write(6,*)' Channel selection input file missing'
            goto 999
 902        continue
c
c   first get number of channels
c
            read(1,*,err=903,end=903) wav_out_nchan
c
c   read info if abs time used
c
            do i=1,wav_out_nchan
               read(1,*,err=903) wav_out_chan(i),start,duration 
c
c   find out if a small or a large number, which indicate if abs start
c   start is used to select the start of the window in abs time
c
               if(start.gt.1.0e10) then    ! start is abs start
                  write(pstart,'(f18.3)') start
                  read(pstart,'(i4,4i2,f6.3))',err=903)
     *            syear,smonth,sday,shour,smin,ssec
                  call timsec(syear,smonth,sday,shour,smin,ssec,
     *            abs_start_time)
                  start=abs_start_time-wav_abs_time(wav_first) ! cal. rel start
                  wav_out_start(wav_out_chan(i))=start
               else
                 if (start.eq.0.) then    ! use first sample
                   wav_out_start(wav_out_chan(i))=
     *  -wav_abs_time(wav_first)+wav_abs_time(wav_out_chan(i)) ! relative first channel
                 else
                   wav_out_start(wav_out_chan(i))=start
                 endif
               endif
               if(duration.ne.0.0) then
                  wav_out_duration(wav_out_chan(i))=duration
               endif
            enddo
            close(1)
            goto 904
 903        continue
            write(6,'(a,a)')' Error in channel select file'
            goto 999
 904        continue
        else

c
c----------------------------------------------------------------
c   option same start and window all channels as given on prompt
c-----------------------------------------------------------------
c
            if(pstart.ne.'0') then    
              read(pstart,'(f20.3)')start 
              if(start.gt.1.0e10) then   ! abs start times
                 write(pstart,'(f18.3)') start
                 read(pstart,'(i4,4i2,f6.3))',err=950) 
     *           syear,smonth,sday,shour,smin,ssec  
                 call timsec(syear,smonth,sday,shour,smin,ssec,
     *           abs_start_time)
                 if(abs_start_time.lt.wav_abs_time(wav_first)) then
                    write(6,*)' Start is before first data point, ',
     *              ' will use first point'
                    abs_start_time=wav_abs_time(wav_first)
                 endif
                 start=abs_start_time-wav_abs_time(wav_first) ! cal. rel start
              else
                call sei get values(1,pstart, code )   ! Extract 1 value
                start=array$(1) 
              endif
              goto 951
 950          continue
              write(6,*)' Error in time string'
              goto 999
 951          continue
              do i=1,wav_out_nchan
                 wav_out_start(i)=start
                 if(pduration.ne.0.0) wav_out_duration(i)=pduration
              enddo
            endif
c
c----------------------------------------------------------------
c   option for select 1 channel
c-----------------------------------------------------------------
c
       if(ichan.ne.-1) then
            wav_out_nchan=1
            wav_out_chan(1)=ichan
       endif
      endif
      if(pstart.ne.' '.and.pduration.ne.0.0) then
      endif 
      endif

c
c-------------------------------------------------------------------------
c   calculate new start times and intervals, check if data is available
c   the call to wav_get_interval also calculates new number of samples
c   in variable wav_out_nsamp. wav_out_start is input and gives start time relative
c   to first sample in file, wav_out duration gives the lenght of the window.
c   both set above
c-------------------------------------------------------------------------
c
c      write(6,*) 'wav-out-start,duration',wav_out_start(1),
c     *wav_out_duration(1)      

      call wav_get_interval

c
c   get rid of empty channels
c
      k=0
      do i=1,wav_out_nchan
        if(wav_out_status(wav_out_chan(i)).gt.0) then
           k=k+1
           wav_out_chan(k)=wav_out_chan(i)
        endif
      enddo
      wav_out_nchan=k
c
c   check if any data left
c
cc     write(6,*)' Number of channels after time window selection',
cc    *wav_out_nchaN
      if(wav_out_nchan.eq.0) then
         write(6,*)' No data left after window selection'
         goto 999
      endif          
c      if(.not.seisweb) then              
c      do i=1,wav_out_nchan
c         k=wav_out_chan(i)
c         nskip(k)=1           ! not less than every point
c         write(6,'(i5,1x,a5,a4,i4)')k,wav_stat(k),wav_comp(k),
c     *   wav_out_status(k)
c      enddo  
c      endif
c
c   find if skipping, if so correct number of points and sample rate
c xxx
c      if(max_points.gt.0) then
c        do i=1,wav_out_nchan
c          k=wav_out_chan(i)
c          nskip(k)=int(wav_out_nsamp(k)/max_points)
c          if(nskip(k).lt.1) nskip(k)=1
c        enddo
c      endif          

      if(max_points.gt.0) then
        do i=1,wav_out_nchan
          call signal_to_visual(wav_out_chan(i),max_points,1)
        enddo
      endif
c
c set headers for rsam data
c
      if (rsam_flag) then
        do i=1,wav_out_nchan
          call signal_to_rsam(wav_out_chan(i),1)
        enddo
      endif
       

c
c-------------------------------------------------------------------------
c   section to write out, different formats possible
c-------------------------------------------------------------------------
c
c   Make main header if needed  and open output file, decide name of
c   output file
c
c
      if(wav_out_file.ne.' '.and.wav_out_file.ne.'SEISAN') then !lo 2004
          file_out=wav_out_file
c     elseif (format_out.eq.'SEISAN') then  ! lo 11-18-2002
c         file_out=format_out
      elseif (wav_out_file.eq.'SEISAN') then
          file_out='SEISAN'
      elseif (format_out.ne.' '.and.narg.lt.2) then
          file_out=format_out
      else
          file_out='wavetool.out'
      endif

c
c fix sample rate and number of samples according to skipping
c xxx
c      do i=1,wav_out_nchan
c        k=wav_out_chan(i)
c        wav_out_rate(k)=wav_out_rate(k)/nskip(k)
c        wav_out_nsamp(k)=wav_out_nsamp(k)/nskip(k)
c      enddo

      net_code='MERGE'
c
c  take net code from SEISAN.DEF
c
      if(merge_wav.ne.' ') then
         net_code=merge_wav
      endif
c
c   if all channels have the same station name, use that for net code
c
      text(1:5)=wav_stat(wav_out_chan(1))
      do i=1,wav_out_nchan
        k=wav_out_chan(i)
        if(text(1:5).ne.wav_stat(k)) goto 888
      enddo
      net_code=text(1:5)   ! use station code for net code
 888  continue
c 
c
c
c   make main header, the out variabels are used since the file might have been
c   cut so no longer the read start time
c
c
         do i=1,wav_out_nchan
            k=wav_out_chan(i)
            year(i)=wav_out_year(k)
            month(i)=wav_out_month(k)
            day(i)=wav_out_day(k)
            hour(i)=wav_out_hour(k)
            min(i)=wav_out_min(k)
            sec(i)=wav_out_sec(k)
            stat(i)=wav_stat(k)
            comp(i)=wav_comp(k)
            location(i)=wav_location(k)
            network(i)=wav_network(k)
c xxx        rate(i)=wav_out_rate(k)/nskip(k)
c            nsamp(i)=wav_out_nsamp(k)/nskip(k)
            rate(i)=wav_out_rate(k)
            nsamp(i)=wav_out_nsamp(k)
c            cbyte(i)=wav_cbyte(k)
            cbyte(i)='4'  ! lot 30 April 2002
         enddo

c
c   make seisan main header, also used to make file name
c
         call sheads(year,month,day,hour,min,sec,wav_out_nchan,1,
     *                 net_code,h_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 file,mainhead,chahead)
 
c
c   if only one chan, add component so no overwrite
c
         if(wav_out_nchan.eq.1) then
           text=file
           file=text(1:seiclen(text))//comp(1)
           do i=1,seiclen(file)
             if(file(i:i).eq.' ') file(i:i)='_'
           enddo
         endif

c----------------------
c   SEISAN format
c----------------------

      if(format_out.eq.'SEISAN') then
         h_text='Extracted waveform file '   ! title
       
c        write(6,'(1x,a)') file
         if(file_out.eq.'SEISAN') file_out=file
c
c   next 3 lines seems a repeat of above ??? comm out mar 28 ,06 jh
c        if (wav_nchan.eq.1) then
c           file_out=file_out(1:seiclen(file_out)) //'_'//
c1     &          wav_comp(1)
c        endif
c
c   check if file exist, if so add SEI to name, jh mar 06
c
         inquire(file=file,exist=exist)
         if(exist) then
            file_out=file_out(1:seiclen(file_out))//'_SEI'
         endif
         do i=seiclen(file_out)-3,seiclen(file_out)
           if (file_out(i:i).eq.' ') file_out(i:i)='_'
         enddo
c
c   if a correction is made, write in main header
c
           
         if(ground.or.flow.ne.0.0.or.fhigh.ne.0.0) then
                                  mainhead(1)(2:13)='Filtered raw'
             if(ground_type.eq.1) mainhead(1)(2:13)='Displacement'
             if(ground_type.eq.2) mainhead(1)(2:13)='Velocity    '
             if(ground_type.eq.3) mainhead(1)(2:13)='Acceleration'
             if(flow.lt.10.0) write(mainhead(1)(15:19),'(f5.3)') flow
             if(flow.ge.10.0) write(mainhead(1)(15:19),'(f5.1)') flow
             if(fhigh.lt.10.0.and.fhigh.ge.0.0) 
     *                       write(mainhead(1)(21:25),'(f5.3)') fhigh
             if(fhigh.ge.10.0) write(mainhead(1)(21:25),'(f5.1)') fhigh
             if(flow.ne.0.0.or.fhigh.ne.0.0) then
                 mainhead(1)(27:28)='hz'
                 mainhead(1)(20:20)='-'
             endif
             

         endif
  
         do i=1,8
            write(6,'(1x,a)') mainhead(i)(1:78)
         enddo
         open(96,file=file_out,status='unknown',form='unformatted')
         do k=1,12
            write(96)mainhead(k)
         enddo
         if(wav_out_nchan.gt.30) then
            k=(wav_out_nchan-31)/3+1
            do i=13,k+12
               write(96)mainhead(i)
            enddo       
         endif                       
      endif
c
c----------------------------------------------------------
c  GSE format has no main header
c----------------------------------------------------------
c         
      if(format_out(1:3).eq.'GSE'.or.
     &   format_out(1:4).eq.'SEED') then
c delete output file
        if (file_out(1:4).eq.'SEED') then
          seed_file_out=' '
          seed_file_out=file(1:seiclen(file))//'_SEED'
        endif
        if (file_out(1:3).eq.'GSE'.or.
     &      file_out(1:4).eq.'SEED') then
          file_out=file(1:seiclen(file))//'_GSE'
        endif
        open(96,file=file_out,status='unknown')
        close(96)
        open(96,file=file_out,status='unknown')
      endif

c
c----------------------------------------------------------
c  SAC nothing done about header
c----------------------------------------------------------
c

c
c-----------------------------------------------------------
c   MSEED, just open file
c-----------------------------------------------------------
c
      if(format_out(1:5).eq.'MSEED') then
        if (file_out(1:5).eq.'MSEED') then
          file_out=file(1:seiclen(file))//'_MSEED'
        endif
         op_file=open_file(96,file_out,12)   ! use block size 4096=2**12
         if(.not.op_file) then
            write(6,*) 'Error opening miniseed output file'
            stop
         endif
      endif          
c
c----------------------------------------------------------
c  Channel processing and write out loop
c-----------------------------------------------------------
c
      mseed_block=1
      do i=1,wav_out_nchan
         k=wav_out_chan(i)

c   read whole channel
c
         call wav_read_channel(k)
c
c   correct number of samples, reading process might have found a gap
c   commnet out dec 19 2007 jh: this was wrong since the the number 
c   of samples in whole interval was  was used, not the number in
c   selected interval, seemed to only affect seed since this number was 
c   reset after reading
c
c        nsamp(k)=wav_out_nsamp(k)
cjh
c         write(6,*) 
c     *  'nsamp,out,wav',nsamp(k),wav_out_nsamp(k),wav_nsamp(k)
c        write(6,*)' Samples after correction',nsamp(k)

c
c   filter but only if ground motion not done in which case
c   filtering is done in spectral domain
c
        if((flow.ne.0.0.or.fhigh.ne.0.0).and..not.ground) then
c
c   check sample rate before filtering
c
        if(fhigh.ge.wav_rate(k)/2.0) then
            write(6,'(a,f8.2)')' Sample rate is: ',wav_rate(k)
            write(6,'(a,f8.2)') ' Filter is:      ',fhigh
            write(6,'(a)')' Cannot filter **********'
         else
c
c remove DC
c
            ndc=0           
            call remove_dc(signal1,ndc,dc,wav_nsamp(k))
c           write(6,*) ' filter ',flow,'-',fhigh
            call bndpas(flow,fhigh,1000.0/wav_rate(k),
     *              cof,gain)
            call filter(signal1,wav_nsamp(k),cof,gain,1)   ! 4 pole one way
         endif
        endif
c
c compute ground motion
c
        if (ground) then
          wav_current_chan(1) = k
          wav_resp_file = ' '
          call read_resp
          if (wav_resp_status.ne.'9') then 
            call remove_resp(signal1,y_com,wav_nsamp(k),
     &         wav_rate(k),ground_type,
     &         flow,fhigh,8,8)   
          endif
        endif


c
c compute rsam data
c
       if (rsam_flag) then
         call remove_dc(signal1,ndc,dc,wav_nsamp(k))
         call signal_to_rsam(k,2)
       endif

c 
c reduce signal to what is seen
c
      if(max_points.gt.0) then
        call signal_to_visual(k,max_points,2)
      endif
c
c   cut out data and put data in beginning of array
c
         j=0
         do l=wav_out_first_sample(k),wav_out_nsamp(k)+
     *        wav_out_first_sample(k)-1
            j=j+1
            signal1(j)=signal1(l) 
          enddo
c
c   skip points
c xxx
c          j=0
c          if(nskip(k).gt.1) then
c             do l=1,wav_out_nsamp(k),nskip(k)
c                j=j+1
c                signal1(j)=signal1(l)
c             enddo
c
c fix sample rate and number of samples according to skipping
c
c             wav_out_rate(k)=wav_out_rate(k)/nskip(k)
c             wav_out_nsamp(k)=wav_out_nsamp(k)/nskip(k)
c          endif

c
c   write out, ddifferent formats
c
c
c-----------------
c  SEISAN format
c-----------------
c
         if(format_out.eq.'SEISAN') then
            call sheads(year,month,day,hour,min,sec,wav_out_nchan,i,
     *                 'NEWAV',h_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 file,mainhead,chahead)
c
c   put in location and network
c
               chahead(8:8)=location(i)(1:1)
               chahead(13:13)=location(i)(2:2)
               chahead(17:17)=network(i)(1:1)
               chahead(20:20)=network(i)(2:2)
	    write(6,'(1x,a)') chahead(1:79)
c
c   if filtered or correction for ground response, values might be very small so
c   numbers are multiplied by a gain factor and the gain factor is put in header
c
           
            if(ground.or.flow.ne.0.0.or.fhigh.ne.0.0) then
c
c   find largest value to be sure data can be scaled up or down
c
               ymax=0.0
               do l=1,nsamp(i)
                   if(abs(signal1(l)).gt.ymax) ymax=abs(signal1(l))
               enddo
c
c  find factor
c
               factor=ymax/1.0e9

               do l=1,nsamp(i)
                   signal1(l)=signal1(l)/factor
               enddo
               chahead(76:76)='G'
               write(chahead(148:159),'(g12.7)') factor
               write(chahead(148:159),'(g12.7)') factor  ! save factor in header

            endif

            write(96) chahead
c
cjh apr 2003            if(cbyte(i).eq.' '.or.cbyte(k).eq.'2') then
cjh              do l=1,nsamp(i)
cjh                 signal2b(l)=signal1(l) 
cjh              enddo
cjh              write(96)(signal2b(l),l=1,nsamp(i))
cjh            else
              do l=1,nsamp(i)
                 signal4b(l)=signal1(l)
              enddo
              write(96)(signal4b(l),l=1,nsamp(i))
cjh            endif
         endif
c
c---------------------------------------
c   GSE format
c---------------------------------------
c
        if(format_out(1:3).eq.'GSE'.or.
     &     format_out(1:4).eq.'SEED') then
c
c   make sure number is not too big
c
           do l=1,nsamp(i)
              if(signal1(l).gt.  100000000.0) signal1(l)= 100000000.0
              if(signal1(l).lt. -100000000.0) signal1(l)=-100000000.0
           enddo
           if (seisweb) then
              do l=1,nsamp(i)
                 signal1(l)=signal1(l)*10. 
              enddo
           endif
 
           if(format_out(1:5).eq.'SEED ') then
             call write_seisan_to_gse(96,k,.true.,'GSE2SEED')
           elseif(format_out(1:6).eq.'SEEDDL') then
             call write_seisan_to_gse(96,k,.true.,'GSE2SEEDDL')
           else
             call write_seisan_to_gse(96,k,.true.,format_out)
           endif

c
c---------------------------------------
c   SAC format
c---------------------------------------
c
        elseif(format_out(1:3).eq.'SAC') then
          call write_seisan_to_sacbin(k,.false.,
     *     .true.,evla,evlo,evel,nerr)
c
c-----------------------------------------
c   MINISEED format
c------------------------------------------
c
         elseif(format_out(1:5).eq.'MSEED') then

            mseed_year=year(i)
            mseed_month=month(i)
            mseed_day=day(i)
            mseed_hour=hour(i)
            mseed_minute=min(i)
            mseed_second=sec(i)
            mseed_station=stat(i)
            mseed_channel(1:2)=comp(i)(1:2)
            mseed_channel(3:3)=comp(i)(4:4)
            mseed_total_samples=nsamp(i)
            mseed_sample_rate=rate(i)
c            mseed_location=seed_location_code
            mseed_location=location(i)
            mseed_network=network(i)
            mseed_encoding=steim1               ! steim1
            do l=1,nsamp(i)
               signal4b(l)=signal1(l)
            enddo          
            call seed_write_chn(96,signal4b,mseed_block)         
        endif
      enddo
c
c   close output waveform file
c
      if (format_out(1:6).eq.'SEISAN'.or.format_out(1:3).eq.'GSE'.
     * or.format_out(1:5).eq.'MSEED'.or.format_out(1:4).eq.'SEED')
     *close(96)

      if (format_out(1:4).eq.'SEED') then
        system_call = ' '
        system_call = 'gse2seed -i '//file_out(1:seiclen(file_out))
     &    //' -o '//seed_file_out(1:seiclen(seed_file_out))
        write(*,*) system_call(1:seiclen(system_call))
        call systemc(system_call,seiclen(system_call))
      endif

c-----------------------------------------------------
      goto 500
c
 999  continue
      write(6,*)' Wavetool terminated: error'
      if(seisweb) then
        write(6,*)'Wavetool terminated: error' 
      endif
      goto 600
c
 500  continue
      if(seisweb) then
         write(6,*)' Waveform extraction terminated: ok'
      endif
      text=' '
      text(1:2)='OK'
      text(3:62)=file_out(1:60)
      open(1,file='extract.mes',status='unknown')
      write(1,'(a)') text
      close(1)
c      call put_seisan_message(text)
      if (format_out(1:4).eq.'SEED') then
        write(6,'(1x,a,a)')' Output waveform file name is ',
     &       seed_file_out
      else
        write(6,'(1x,a,a)')' Output waveform file name is ',file_out
      endif

      if(in.eq.1) goto 11
 600  continue

      stop
      end


      subroutine signal_to_visual(ichan,max_points,option)
c
c reduce number of samples in single trace, so that total windows of all
c traces will have max_points 
c 
c  input: ichan      - channel index for wav_out
c'         max_points - number of points for total window
c         option     - 1: header only, 2: header and data
c
      implicit none
      save  
      include 'seidim.inc'
      include 'waveform.inc'

      integer ichan                   ! channel index
      integer max_points              ! number of points in total time window
      integer option                  ! option
      real data(max_sample)           ! data array
      real min,max                    ! min and max in interval delta
      double precision delta          ! size of time window to take data
      double precision stop,now
      integer nsamp_save(max_trace)
      real rate_save(max_trace)
      integer i,k
      integer ind(2)                  ! index to sample of min and max

c
c option 1, only set wav_out_nsamp and wav_out_rate
c
      if (option.eq.1) then
c
c get length of total output window
c
        call wav_out_index_total
        delta = wav_out_total_time / max_points
c       write(*,*) ichan,wav_out_rate(ichan),
c    *         wav_out_nsamp(ichan),wav_out_total_time
        nsamp_save(ichan)=wav_out_nsamp(ichan)
        rate_save(ichan)=wav_out_rate(ichan)
        wav_out_rate(ichan)=1./delta
        wav_out_nsamp(ichan)=wav_out_duration(ichan)/delta
c       write(*,*) ichan,wav_out_rate(ichan),
c    *         wav_out_nsamp(ichan)
        return 
 
      elseif (option.eq.2) then
c
c reset samples and rate
c
        wav_out_rate(ichan)=rate_save(ichan)
        wav_out_nsamp(ichan)=nsamp_save(ichan)
c
c get length of total output window
c
        delta = wav_out_total_time / max_points
c
c go out if max_points larger than number of samples
c
        if (max_points.ge.wav_out_nsamp(ichan)) return

c
c get time interval for new sampling
c
        stop  = wav_abs_time(wav_first)+wav_out_start(ichan)+delta

        k=1
        min=signal1(wav_out_first_sample(ichan))
        ind(1)=wav_out_first_sample(ichan)
        max=signal1(wav_out_first_sample(ichan))
        ind(2)=wav_out_first_sample(ichan)
 
c        write(17,*) 'max,min ',max,min

c
c loop through all samples
c
        do i=wav_out_first_sample(ichan),wav_out_first_sample(ichan)+
     *       wav_out_nsamp(ichan)-1
c
c time of sample
c
          now=wav_abs_time(wav_first)+wav_out_start(ichan)+
     *     (i-wav_out_first_sample(ichan))/wav_out_rate(ichan) 

c         write(17,*) now,stop,ichan,wav_out_first_sample(ichan),
c    *           signal1(i)
          if (now.le.stop) then                  ! check if sample in interval
            if (signal1(i).ge.max) then
              max=signal1(i)
              ind(2)=i
            endif
            if (signal1(i).le.min) then
              min=signal1(i)
              ind(1)=i
            endif
c
c sort with time
c
            if (ind(2).le.ind(1)) then
              data(k)=max
              data(k+1)=min
            else
              data(k+1)=max
              data(k)=min
            endif
          else                                   ! new interval
c            write(17,*) k,data(k),data(k+1)
            k=k+2
            stop=stop+2*delta
            max=signal1(i)
            min=signal1(i)
            data(k)=max
            data(k+1)=min
          endif
        enddo

c
c set number of samples and first sample in wav_out
c
        wav_out_rate(ichan)=1./delta
        wav_out_nsamp(ichan)=wav_out_duration(ichan)/delta
        wav_out_first_sample(ichan)=1
c
c write data to signal1
c
        do i=1,wav_out_nsamp(ichan)
          signal1(i)=data(i)
        enddo

c
c change number of samples and sample rate
c
      endif

      return
      end


      subroutine get_argument_from_file(arguments,nargs)
	implicit none
	include 'libsei.inc'
	  character*80 arguments(*)
	  integer nargs
	  integer read1 
	  integer seiclen
	  character*80 strline
	  integer code
	  logical b_flag
	  integer i

        call sei open( old$+warn$,       ! Open file & warn of erro.
     &                   ' ',              ! Prompt (n/a).
     &                   arguments(2),     ! Filename.
     &                   read1,            ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
          if( code .ne. e_ok$ ) then       ! An error or does not exist.
                write(6,'(a,a)') ' File does not exist: ',arguments(2)
                stop                          ! stop if input from choise file                           !
           endif
         do i=1,9999
          read(read1,'(a)',end=9711) strline
	    arguments(i) = strline(1:seiclen(strline)) 
         enddo
 9711	   nargs = i - 1
	   close(read1)
        return
	 end

      subroutine signal_to_rsam(ichan,option)
c
c compute 1 s p minute rsam data
c
c  input: ichan      - channel index for wav_out

      implicit none
      save
      include 'seidim.inc'
      include 'waveform.inc'

      integer ichan                   ! channel index
      real data(max_sample)           ! data array
      double precision delta          ! size of time window to take data
      double precision msec1,msec2,start
      integer i,k
      integer year,month,day,hour,min,doy
      real sec,secprev
      real  rsam
      integer nrsam
      integer option

      if (option.eq.1) then

        msec1=wav_abs_time(ichan)
        msec2=wav_abs_time(ichan)+wav_nsamp(ichan)/wav_rate(ichan)

        k=int((msec2-msec1)/60.)
        call sectim(msec1,year,doy,month,day,hour,min,sec)
        if (sec.ne.0.) k=k+1
        call sectim(msec2,year,doy,month,day,hour,min,sec)
        if (sec.ne.0.) k=k+1

        wav_out_rate(ichan)=1./60.
        wav_out_nsamp(ichan)=k
        wav_out_first_sample(ichan)=1
      else
c
c compute rsam data
c
        secprev=-1
        rsam=0.
        k=0
        do i=1,wav_nsamp(ichan)
c
c get time of sample
c
          msec1=wav_abs_time(ichan)+(i-1)/wav_rate(ichan)
          call sectim(msec1,year,doy,month,day,hour,min,sec)
          if (i.eq.1) then
            wav_out_sec(ichan)=0.
          endif
          if (sec.lt.secprev) then
            k=k+1
            if (nrsam.ne.0) then
              data(k)=rsam/float(nrsam)
            else
              data(k)=0
            endif
            nrsam=1
            rsam=abs(signal1(i))
            secprev=-1
          else
            secprev=sec
            nrsam=nrsam+1
            rsam=rsam+abs(signal1(i))
          endif
        enddo
        k=k+1
        data(k)=rsam/float(nrsam)
c
c write data to signal1
c
        do i=1,wav_out_nsamp(ichan)
          signal1(i)=data(i)
        enddo

      endif
      return
      end

c$DEBUG
c     Program to make Seismological Bulletins
c
c     January 1993, Conrad Lindholm
c     Updates:
c     jul 8 93 by jh: VERSION 3.0 *****
c     jul 16        : bul.inp to BUL.INP
c     aug   93      : conrad fixes ?????
c     aug26    by jh: pc adoption, many changes and bugs !!!!
c     sep 10        ; bug, scratch file 8, pc
c     sep 16        : check month range, bug with -onlyhypo
c     sep 21,22     : check for non existing phases, residual 
c     apr 27 94     : print one line pr event
c     jul           : bug with several months
c     nov 16        : august
c     jan 95        : ************ version 5.0 ****************
c     jan 20        : amplitude to 8 digits
c     feb 7         : check for ctl z, pc problem
c     mar 27  95  jh: add page selection
c     april 25      : always give explosion info
c     aug 4         : write amplitudes lt 1
c     aug 16        : bug page selection
c     may 31 96     : enable 8 character phase names
c     sept 96     lo: dont print probable explosions without readings 
c     jan 97      ha: bug in weight in phase
c     May 97      mv: Now possible to change default fontsize for
c                   : event data (see %fontsize=)
c     Nov 5 97    jh: do not print an explosion if only one phase
c     Jan 13 98     : do not print explosions if no epicenter
c-----------------------------------------------------------------------------
c     oct 17 98   jh: -------------   verson 7.0 check -------------      
c                     5 char station check, no change
c     sep 19 2001 jh: dist to integer
c     jan 30 2003 jh: allow negative magnitudes
c     feb 19          diabled temporarely
c     jan 6, 04 jh  : also do not print explosions without location
c                     and/or readings
c     jan 27 04 jh  : do not print event with no phases
c     jan 5  07 jh  : now really fix so neg magnitudes can be printed
c
c     To make a defintion in PostScript:  /t {postscript_command} def
c         t is after this synonymous with postscript_command
c
C  Font index
C         1 = Times-Roman
C         2 = Times-Italic
C         3 = Times-Bold
C         4 = Helvetica
C         5 = Helvetica-Oblique
C         6 = Helvectica-Bold
C         7 = Courier               Must be used on tabular data !!!!
C         8 = Courier-Oblique
C         9 = Courier-Bold
c
c  Input files:
c         A Nordic formatted F-file
c         A file called "BUL.INP" which is expected to be found in ~/DAT
c  Output file:
c         A PostScript bulletin file: "bul.ps"
c
      
      implicit none
      include 'seidim.inc'
      character*80 data(max_data),infile/' '/
      character*60 top_directory,timecard,hypcard,agcard,depcard
      character*150 card,dummy,dummy2,arg,outcard
      character*1 type, exp,t1,t2,t3,cult,answer
      character*1 ucase,fixed,ns,ew
      character*2 intscale
      character*3 agency,ag1,ag2,ag3
      character*10 disttype
      character*80 args(20)
      character tmonth(12)*9
      integer nstat,nhead,nrecord,nphas
      integer year,month,day,hour,min
      integer oport,font
      integer nargs, nars,iargc
      integer maxint,id
      real sec
      real xdummy
      real lat,lon,depth,rms
      real size,x,y,dx,dy,xleft,ytop,ybottom,fontsize
      real m1,m2,m3,xminmag
      real rmspos,hyppos,agpos,indent,deppos
      integer firstmonth,lastmonth,npage
      integer i,j,k,nbend
      logical pc,unix,vax,frontpage,center,exist
      logical onlyhypo,nofrontpage,minmag
      integer*2 i2,istatus

c
c ------ Initialize
c
c      data tmonth / 'Enero       ', 'Febrero     ', 
c     &'Marzo       ', 'Abril       ',
c     &'Mayo        ', 'Junio       ', 'Julio     ', 
c     &'Agosto      ', 'Septiembre  ',
c     &'Octubre     ', 'Noviembre   ', 'Diciembre  ' /
      data tmonth / 'January  ', 'February ', 
     &'March    ', 'April     ',
     &'May      ', 'June      ', 'July     ', 
     &'August   ', 'September ',
     &'October  ', 'November  ', 'December ' /


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      frontpage = .false.
      nofrontpage = .false.
      onlyhypo = .false.
      center = .false.
      minmag = .false.
c
c------- Define standard top bottom of the page and line spacing in incheottoms
c------- Default font is Times-Roman  (1)
c
c------- rmspos =x position of rms information in inches
c------- hyppos =x position of hypoinformation in inches
c------- agpos  =x position of agencyinformation in inches
      deppos = 5.5
      rmspos = 5.5
      hyppos = 3.55
      agpos = 6.25

      indent = 1.1
      xleft = 1.0
      ytop = 10.5
      ybottom = 1.00
      dy = 0.15
      font = 1
      fontsize = 0.15
      npage = 1
c
c------ Find arguments passed
c
       call get_arguments(nars,args)
       if(nars .ne. 0)then
	do i = 1,nars
      i2=i
	 if(args(i)(1:2).eq.'-h'.or.args(i)(1:2).eq.'-H')then
	   write(*,*)'  Options:'
	   write(*,*)' -frontpage: Only frontpages are printed.'
	   write(*,*)' -nofrontpage: No frontpages are printed.'
	   write(*,*)' -onlyhypo: Only hypocenter solutions are printed.'
	  write(*,*)' -minmag x.x : Only hypocenter solutions are printed',
     +'          if magnitude is lower than the requested.'
	   stop
	 endif
	 if(args(i)(1:10) .eq. '-frontpage')then
	   frontpage = .true.
	 endif
	 if(args(i)(1:9) .eq. '-onlyhypo')then
	   onlyhypo = .true.
	 endif
	 if(args(i)(1:12) .eq. '-nofrontpage')then
	   nofrontpage = .true.
	 endif
	 if(args(i)(1:7) .eq. '-minmag')then
           i2 = i2 + 1
            read(args(i2),'(f5.1)') xminmag
	   minmag = .true.
	 endif
	enddo
      endif
c
c------- Get first and last month in the data
c
      write(*,'(a,$)')' Enter name of your file (Nordic format): '
      read(*,'(a)')infile

      open(1,file=infile,status='old')
c
c   scratch file for interactive input
c
      open(8,status='scratch')
      i = 0
1     call indata(1,nstat,nphas,NHEAD,NRECORD,TYPE,EXP,DATA,id)
      if(nrecord .eq. 0) go to 2
      read(data(1)(2:8),'(i4,1x,i2)')year,month
      i = i + 1
      if(i .eq. 1)firstmonth = month
      go to 1
2     lastmonth = month
      close(1)
      if(firstmonth.le.0) then
         write(6,*)' Something wrong with data of first event'
         stop
      endif
      if(lastmonth.gt.12) then
         write(6,*)' Something wrong with date of last event'
         stop
      endif
      write(6,'(5a)') ' You are going to make a bulletin for the ','
     *months ',tmonth(firstmonth), ' to ',tmonth(lastmonth)
      write(6,'(a,$)')' Is that ok (y/n)'
      read(5,'(a1)') answer
      if(answer.ne.'Y'.and.answer.ne.'y') stop
      

c
c-------- Make the first page
c
      oport = 2
      call PSOPEN('bul.ps',6,oport,font)

      if(nofrontpage)then
	  call psfont(oport,font,fontsize)
          go to 10
      endif

      call topdir(top_directory)
      i=index(top_directory,' ') - 1
      inquire(file='BUL.INP',exist=exist)
      if(exist)then
        open(1,file='BUL.INP',status='old')
      else
        open(1,file=top_directory(1:i)//'/DAT/BUL.INP',status='old')
      endif
c
c----- Top left corner of page is x = 1 inch and y = 11 inches
c
      x = xleft
      y = ytop

3     card= ' '
      read(1,'(a)',end=10)card
c
c   check for ctlz, a problem on pc files moved forth and back on the net
c
      do i=1,80
        if(ichar(card(i:i)).eq.26) goto 3
      enddo
      if( card(1:1) .eq. '#') go to 3
      if( card(1:10) .eq. '%Next Page') go to 5
c
c----- Read position, size etc. of the next line
c
      if( card(1:6) .eq. '%xpos=')then
         rewind 8
         write(8,'(a)') card(7:80)
         rewind 8
         read(8,*)x
conrad	 read(card(7:80),*)x
	 go to 3
      endif
      if( card(1:6) .eq. '%ypos=')then
conrad	 read(card(7:80),*)y
         rewind 8
         write(8,'(a)') card(7:80)
         rewind 8
         read(8,*)y
         go to 3
      endif
      if( card(1:6) .eq. '%font=')then
conrad	  read(card(7:80),*)font
         rewind 8
         write(8,'(a)') card(7:80)
         rewind 8
         read(8,*)font
	  call psfont(oport,font,size)
          go to 3
      endif
      if( card(1:6) .eq. '%size=')then
conrad	  read(card(7:80),*)size
         rewind 8
         write(8,'(a)') card(7:80)
         rewind 8
         read(8,*)size
	  call psfont(oport,font,size)
          go to 3
      endif
c changes default fontsize value
      if( card(1:10) .eq. '%fontsize=')then
         rewind 8
         write(8,'(a)') card(11:80)
         rewind 8
         read(8,*)fontsize
         goto 3
      endif
      if( card(1:7) .eq. '%Months') then
conrad	write(card,*)(tmonth(i),i=firstmonth,lastmonth)
        
c       write(card,'(a)')(tmonth(i),i=firstmonth,lastmonth)
        card(1:9)=tmonth(firstmonth)
        if(lastmonth.ne.firstmonth) then
           card(10:13)=' to '
           card(14:22)=tmonth(lastmonth)
        endif
        if(center)then
  	  call pscenter(oport,x,y,card,NBEND(card))
          center = .false.
        else
          call pswrite(oport,x,y,card,NBEND(card))
        endif
	go to 3
      endif
      if( card(1:5) .eq. '%Year') then
	write(card,'(i4)')year
        if(center)then
  	  call pscenter(oport,x,y,card,NBEND(card))
          center = .false.
        else
          call pswrite(oport,x,y,card,NBEND(card))
        endif
	go to 3
      endif
      if( card(1:7) .eq. '%center') then
	center = .true.
	go to 3
      endif

      if(center)then
	call pscenter(oport,x,y,card,NBEND(card))
      else
        call pswrite(oport,x,y,card,NBEND(card))
      endif
      call position(x,y,dx,dy)
      center = .false.

      go to 3

5     call psclear(oport)
      x = xleft
      y = ytop
      go to 3

10    continue
      if(frontpage) then
         write(6,*)' You have selected to only print front pages'
         go to 999
      endif
c
c---------------------------------------------
c---------- Now start to work with the data
c---------------------------------------------
c
      call psclear(oport)
      x = xleft
      y = ytop


      open(1,file=infile,status='old')
7     call indata(1,nstat,nphas,NHEAD,NRECORD,TYPE,EXP,DATA,id)
      if(nrecord .eq. 0) go to 999
c
c dont print events that are probable explosions or explosion
c without phase readings
c
      if (EXP.EQ.'P'.or.exp.eq.'p'.or.exp.eq.'E') THEN
        if (NRECORD-1-NHEAD.EQ.0) THEN
          GOTO 7
        ENDIF

      if(nphas.lt.2) goto 7   
c
c   also do not print if no hypocenter
c
        if(data(1)(24:38).eq.'               ') goto 7
      ENDIF
c
c   if no phases at all, skip
c
      if(nphas.lt.1) goto 7   !jh jan 27 03
        
      write(6,'(a)')data(1)
      if(type .eq. 'L')disttype='  Local   '
      if(type .eq. 'R')disttype='  Regional'
      if(type .eq. 'D')disttype='  Distant '

      read(data(1),100)year,month,day,hour,min,sec,
     + lat,lon,depth,fixed,agency,rms,m1,t1,ag1,m2,
     + t2,ag2,m3,t3,ag3
100   format(1x,i4,1x,2i2,1x,2i2,1x,f4.0,3x,f7.3,f8.3,
     + f5.0,a1,1x,a3,3x,f4.0,3(f4.1,a1,a3))
c
c------- Write event header card
c
      write(timecard,300)tmonth(month),day,year,hour,min,sec
300   format(a,' ',i2,'  ',i4,'   Hour:  ',i2,':',i2,' ',f4.1)

      ns = 'N'
      ew = 'E'
      if(lat .lt. 0.001)then
         ns = 'S'
         lat = -lat
      endif
      if(lon .lt. 0.001)then
         ew = 'W'
         lon = -lon
      endif
      write(hypcard,400)lat,ns,lon,ew
400   format('Lat:  ',f6.2,a1,'    Lon:  ',f7.2,a1)

      write(depcard,500)int(depth),fixed
500   format('Depth:',i3,a1)

      write(agcard,600)'Agency: ',agency,disttype
600   format(a,a3,'  ',a10)

      if(lat .eq. 0.0 .and. lon .eq. 0.0)then
        hypcard = ' '
        depcard = ' '
      endif

c
c----- New page if the header comes too low
c
      if(onlyhypo)then
        xdummy = ybottom + 0.75
      else
        xdummy = ybottom + 1.0
      endif
      if(y .lt. xdummy)then
	write(dummy,'(i3)')npage
	x = 4.0
	y = 0.5
	call psfont(oport,font,fontsize)
	CALL PSWRITE(oport,x,y,dummy,3)
	npage = npage + 1
	CALL PSCLEAR(oport)
	call psfont(oport,3,fontsize)
	x = xleft
	y = ytop
      else
	call psfont(oport,3,fontsize)
      endif
c
c------- write main header; Time and position
c
      call position(x,y,dx,dy)
      call pswrite(oport,x,y,timecard,NBEND(timecard))
      call pswrite(oport,hyppos,y,hypcard,NBEND(hypcard))
      call pswrite(oport,deppos,y,depcard,NBEND(depcard))
      call pswrite(oport,agpos,y,agcard,NBEND(agcard))
c
c------- Write Magnitudes and RMS INFO
c
      card = ' '
      write(card,301)m1,'M',t1,ag1,m2,'M',t2,
     + ag2,m3,'M',t3,ag3
301   format('Magnitudes:  ',3(f4.1,2a1,1x,a3,4x))
cjh to be fixd to report neg mag
c     if(m1 .le. 0.0)card(14:26) = '       '
c     if(m2 .le. 0.0)card(27:39) = '       '
c     if(m3 .le. 0.0)card(40:52) = '       '
c
c   report magnitude if agency is not blank
c   assuming then the magnitude is not valid
c
      if(ag1 .eq.'   ')card(14:26) = '       '
      if(ag2 .eq.'   ')card(27:39) = '       '
      if(ag3 .eq.'   ')card(40:52) = '       '

      if(m1.ne.0.0 .or. m2.ne.0.0 .or. m3.ne.0.0 )then
        call position(x,y,dx,dy)
        call pswrite(oport,indent,y,card,NBEND(card))
      endif
c
c---- RMS iNfo written on fixed 5.0 inches x-coordinate
c
      if(lat .ne. 0.0 .and. lon .ne. 0.0)then
        write(card,302)rms
302     format('Rms:',f4.1,' secs')
        if(exp .eq. 'E')card(20:29)='Explosion'
        if(exp .eq. 'P')card(20:36)='Likely Explosion'
        if(m1.eq.0.0 .and. m2.eq.0.0 .and. m3.eq.0.0 )then
          call position(x,y,dx,dy)
        endif
        call pswrite(oport,rmspos,y,card,NBEND(card))
      else
        if(exp.eq.'E'.or.exp.eq.'P') then
            if(exp .eq. 'E')card(20:29)='Explosion'
            if(exp .eq. 'P')card(20:36)='Likely Explosion'
            card(1:11)='           '   ! take magnitude away
            if(m1.eq.0.0 .and. m2.eq.0.0 .and. m3.eq.0.0 )then
               call position(x,y,dx,dy)
            endif
            call pswrite(oport,rmspos,y,card,NBEND(card))
        endif
      endif
c
c------- Write extra "Bul-headers" and macro information
c
      do i = 2,nhead
	if(data(i)(80:80).eq.'3'.and.data(i)(1:5).eq.' Bul:')then
	  write(card,'(a)')data(i)(6:79)
	  call position(x,y,dx,dy)
	  call pswrite(oport,indent,y,card,NBEND(card))
	endif
        if(data(i)(80:80) .eq. '2')then
          read(data(i),200)cult,maxint
200       format(24x,a1,2x,i2)
	  dummy = ' '
	  if(cult .eq. 'C')dummy = '  Casualties reported'
	  if(cult .eq. 'D')dummy = '  Damage reported'
	  if(maxint .gt. 0.)then
            write(card,401)maxint,dummy(1:21)
401         format('Earthquake was felt;   Maximum intensity: ',
     +       i2,'  ',a)
          else
            write(card,'(a)')'Earthquake was felt'
          endif
        call position(x,y,dx,dy)
        call pswrite(oport,indent,y,card,NBEND(card))
        endif
	   
      enddo
c
c-------- If only hypocenter wanted, then skip the rest
c
      xdummy = max(m1,m2,m3)
      if(onlyhypo .or. (minmag .and. xdummy .lt. xminmag))then
        card = ' '
        call position(x,y,dx,dy)
        call pagecheck(x,y,ybottom,xleft,ytop,npage,oport,
     +                                        font,fontsize)
        call psfont(oport,font,fontsize)
        call pswrite(oport,x,y,card,NBEND(card))
        go to 7
      endif

c
c-------- Now read and write phase information; Font Courirer
c
      call psfont(oport,7,fontsize)
      outcard=' STAT CO DIST AZI PHASE '
      dummy  =' P HRMN SECON TRES CODA'
      dummy2 =' AMPL PERI BAZ ARES VELO  WT'
      card = outcard(1:24)//dummy(1:23)//dummy2(1:28)
      call position(x,y,dx,dy)
      call pagecheck(x,y,ybottom,xleft,ytop,npage,oport,
     +                                        font,fontsize)
      call pswrite(oport,x,y,card,NBEND(card))
      do i = nhead+1,nrecord
	card = data(i)
	call position(x,y,dx,dy)
        call pagecheck(x,y,ybottom,xleft,ytop,npage,oport,
     +                                        font,fontsize)
        call reformat(card,outcard)
	call pswrite(oport,x,y,outcard,NBEND(outcard))
      enddo
c
c--------- Back for a new event; Font is reset   
c

      go to 7

999   continue
      write(dummy,'(i3)')npage
      x = 4.0
      y = 0.5
      call psfont(oport,font,fontsize)
      CALL PSWRITE(oport,x,y,dummy,3)

      write(*,*)' Bulletin is now written in the file: bul.ps'
      call select_pages(oport)  ! page selection
      call psclose(oport)

      end
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine position(x,y,dx,dy)
      real x,y,dx,dy
c     Position is given in units of inches where
c     origo is in the lower left corner of an A4 page

      y = y - dy

      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      SUBROUTINE PSOPEN(CNAME,ILEN,IUNIT,font)
      CHARACTER*(*) CNAME
      integer font
C Input: CNAME, ILEN
C Output: IUNIT
      open(unit=iunit,file=cname(1:ilen),status='unknown')

      WRITE(IUNIT,'(A23)') '%!PS-Adobe-2.0 EPSF-2.0'
      WRITE(IUNIT,'(A26)') '%%BoundingBox: 0 0 539 539'
      WRITE(IUNIT,'(A13)') '%%EndComments'
C defintions necessary for pscenter routine
      WRITE(IUNIT,'(A12)') '/WIDTH 8 def'
      WRITE(IUNIT,'(A37)') '% Usage: ypos pagewidth string center'
      WRITE(IUNIT,'(A35)') '/center { stringwidth pop sub 2 div'
      WRITE(IUNIT,'(A17)') 'exch moveto } def'
C transform from 1 unit = 1/72 inch to 1 unit = 1 inch
      WRITE(IUNIT,'(A11)') '72 72 scale'
      CALL PSFONT(IUNIT,font,0.15)
C save these definitions
      WRITE(IUNIT,'(A5)') 'gsave'
      RETURN
      END
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE PSCLOSE(IUNIT)
      WRITE(IUNIT,'(A8)') 'showpage'
      WRITE(IUNIT,'(A8)') 'grestore'
      close(unit=IUNIT)
      RETURN
      END
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE PSCLEAR(IUNIT)
      WRITE(IUNIT,'(A8)') 'showpage'
C restore old definitions      
      WRITE(IUNIT,'(A8)') 'grestore'
C save these definitions
      WRITE(IUNIT,'(A5)') 'gsave'
      RETURN
      END
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE PSCENTER(IUNIT,X,Y,STR,ILEN)
      REAL X,Y
C Units in inches, (0,0) at lower-left corner of page
      CHARACTER*(*) STR
      INTEGER ILEN
      WRITE(IUNIT,*) X, Y, ' moveto'
conrad      WRITE(IUNIT,*) Y,' WIDTH '//'('//STR(1:ILEN)//')',' center'
conad      WRITE(IUNIT,*) '('//STR(1:ILEN)//') show'
      WRITE(IUNIT,200) Y,STR(1:ILEN)
 200  format(f10.2,' WIDTH (',a,') center')
      WRITE(IUNIT,201) STR(1:ILEN)
 201  format('(',a,') show')
      RETURN
      END
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      SUBROUTINE PSWRITE(IUNIT,X,Y,STR,ILEN)
      REAL X,Y
C Units in inches, (0,0) at lower-left corner of page
      CHARACTER*(*) STR
      INTEGER ILEN
      WRITE(IUNIT,*) X, Y, ' moveto'
conrad      WRITE(IUNIT,*) '('//STR(1:ILEN)//') show'
      write(iunit,201) str(1:ilen)
 201  format('(',a,') show')
      RETURN
      END
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      SUBROUTINE PSFONT(IUNIT,IFONT,SIZE)
      INTEGER IUNIT,IFONT
      REAL SIZE
C IUNIT - File unit number
C IFONT - Font index
C         1 = Times-Roman
C         2 = Times-Italic
C         3 = Times-Bold
C         4 = Helvetica
C         5 = Helvetica-Oblique
C         6 = Helvectica-Bold
C         7 = Courier
C         8 = Courier-Oblique
C         9 = Courier-Bold
C SIZE  - Size of fonts in inches
C
C Note that the Courier font family (font 7-9) is a monospaced,
C or fixed-pitch (fixed width) font suitable for use in
C tabular material, program listings, or word processing.
C
      CHARACTER*17 CFONTS(9)
      INTEGER      LFONTS(9)
      DATA CFONTS / 'Times-Roman',
     +              'Times-Italic',
     +              'Times-Bold',
     +              'Helvetica',
     +              'Helvetica-Oblique',
     +              'Helvectica-Bold',
     +              'Courier',
     +              'Courier-Oblique',
     +              'Courier-Bold' /
      DATA LFONTS / 11, 12, 10, 9, 17, 15, 7, 15, 12 /
 
      IF2 = MIN0(9,MAX0(1,IFONT))
 
      WRITE(IUNIT,'(A)') '/'//CFONTS(IF2)(1:LFONTS(IF2))//' findfont'
      WRITE(IUNIT,*) SIZE,' scalefont'
      WRITE(IUNIT,'(A7)') 'setfont'
      RETURN
      END

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C NBEND    UT-F-U   Created: 8/11/89 Copied : 08/28/89 Made at NORSAR
      INTEGER FUNCTION NBEND(STRING)
      CHARACTER*(*) STRING
C.======================================================================
C.    PURPOSE
C     find_Non_Blank_END_of_string                                  UT<<
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C..   STRING - Character string
C
C.    OUTPUT
C..   NBEND  - Position of last non blank character in string
C.----------------------------------------------------------------------
C.    PROGRAMMER    Stein Holger Pettersen
C.    CREATION_DATE 19 Jun 1989
C.    MADE_AT  NTNF/NORSAR
C     Pb. 51
C     N-2007 Kjeller
C
C.    MODIFICATION
C.    CORRECTION
C.======================================================================
 
      LS = LEN(STRING)
      DO 10 I = LS,1,-1
         IF (STRING(I:I).NE.' ') GO TO 20
   10 CONTINUE
      I = 1
 
   20 NBEND = I
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      character*1 function ucase(a)
c     convert lower case single char to upper case - machine independent
      
      character*1 chr(26),ucchr(26),a
      data chr/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     &'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      data ucchr/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     &'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      do 10 i=1,26
        if(a.eq.chr(i))then
          ucase=ucchr(i)
          return
        endif
10    continue
      ucase=a
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pagecheck(x,y,ybottom,xleft,ytop,npage,oport,
     +                                        font,size)
      real x,y,ybottom,xleft,ytop,size
      integer font
      character*100 dummy
	  integer oport

      if(y .lt. ybottom )then
	write(dummy,'(i3)')npage
	x = 4.0
	y = 0.5
	call psfont(oport,font,size)
	CALL PSWRITE(oport,x,y,dummy,3)
	npage = npage + 1
	CALL PSCLEAR(oport)
c----- Font must be 7 (Courier)
	call psfont(oport,7,size)
	x = xleft
	y = ytop
      endif
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine reformat(incard,outcard)
      character*80 incard,outcard
      character*1 uncertain
      real ampl,peri,bazi,wt
      real xdist 		! distance
      integer idist		! distance

c      outcard = 
c  +' STAT CO DIST AZI PHAS P HRMN SECON TRES CODA AMPL PERI BAZ ARES VELO  WT'
c
      outcard = ' '

c
c  put in if time not accurate
c
      uncertain=' '
      if(incard(15:15) .eq. '9')then
        uncertain = '*'
      endif
c
c   remove input weight from incard if not a phase
c
      if(incard(15:15).eq.'0'.or.incard(15:15).eq.'1'.or.incard(15:15)
     *.eq.'3'.or.incard(15:15).eq.'4'.or.incard(15:15).eq.'9'.or.
     *incard(15:15).eq.'2') then
      if(incard(16:16).ne.' ') then
        continue             ! character 15 must be part of phase name
      else 
        incard(15:15)=' '    ! character 15 is probably an input weight
      endif
      endif
      outcard(1:8) = incard(1:8)
c
c   distance to integer, jh sep 2001
c
      read(incard(71:75),'(f5.0)') xdist
      xdist=xdist+0.5
      idist=xdist
      if(xdist.gt.0.51) write(outcard(9:13),'(i5)') idist
cjh sep 2001      outcard(9:13) = incard(71:75)
      outcard(15:17) = incard(77:79)
      outcard(19:27) = incard(10:18)
      outcard(28:31) = incard(19:22)
      outcard(33:37) = incard(24:28)
      outcard(38:42) = incard(64:68)
      outcard(44:47) = incard(30:33)
      if(outcard(27:27).eq.' ') outcard(27:27)=uncertain ! assume long phase 
                                                         ! name has ok time
      read(incard(34:40),'(g8.0)')ampl
      if(ampl.ne.0.0) then
         if(ampl.gt.1.0) then
            write(outcard(45:52),'(i8)')nint(ampl)
         else
            write(outcard(45:52),'(f8.2)') ampl
         endif
      endif
      read(incard(42:45),'(f4.0)')peri
      if(peri.ne.0.0)write(outcard(54:57),'(f4.1)')peri
      read(incard(47:51),'(f5.0)')bazi
      if(bazi.ne.0.0)write(outcard(58:61),'(i4)')nint(bazi)
      outcard(64:66) = incard(61:63)
      outcard(68:71) = incard(53:56)
      read(incard(69:70),'(i2)')iwt
       wt = real(iwt)/10.
      write(outcard(73:75),'(f3.1)')wt
c
c   check for nonexisting phase
c
      if(incard(69:70).eq.'-9') then
         outcard(73:75)='  '
         outcard(15:17)='   '
         outcard(39:42)='    '
       endif
      if(incard(69:70) .eq. ' ')outcard(73:75)=' '

      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine select_pages(oport)
c
c  edit output file to select certain pages
c
      implicit none
      include 'libsei.inc'
      character*80 text
      integer first_page, last_page   ! first and last page to use
      integer code   ! error code
      integer npage  ! page counter
      integer oport  ! file unit for original file
c
      write(6,*)' Select pages, give first and last, return for all'
      read(5,'(a)') text
      if(text(1:2).eq.'  ') return           ! stop if default
      call sei get values( 2, text, code )   ! Extract 2 values.
      code = e_ok$                           ! re-store.
      first_page = array$(1)+1                    ! Retrieve.
      last_page =  array$(2)+1                    ! Ditto.
c
c   open selected page output file
c
      open(22,file='bul1.ps',status='unknown')
      rewind oport
c
c   read foreward to pages wanted, always leave first
c
      npage=-2
 1    continue
      read(oport,'(a)',end=99) text
      if((npage.ge.first_page.and.npage.le.last_page).or.npage.eq.-2) 
     *write(22,'(a)') text               ! write out page if set
      if(text(1:8).eq.'showpage') then
         npage=npage+1
         write(6,*)' Page ',npage
      endif
      goto 1
c
c  end of file
c
  99  continue
      backspace oport
	  backspace 22
      call psclose(22)

      close(22)
      write(6,*)' Selected pages in file bul1.ps'
      return
      end

C**************************************************************************
C                                                                               
      SUBROUTINE filename(question,file_name)                                   
c                                                                               
c    question is printed out first, then                                        
c    routine reads a file name, checks it for one of the following              
c    possibilities                                                              
c                                                                               
c    1: file name longer than 4 chars, routine returns                          
c    2: file name is a question mark: read file listing of files and print      
c       then return for new file name.                                          
c    3: file name is between 1 and 4 chars and not a question mark:            
c       file name is assumed to be a number which indicates nr in list          
c       of files. Finds file name in list and returns it.
c       If not all 4 characters are digits, assume a file name and returns                       
c    5: file name is blank, return EOF                                          
c    6: question is #Next_file#, which will be next file relative to
c       previous number used, question is then not printed out
c                                                                               
c    updates
c    jul 24 92 by jh  : next file option, add eof check 
c    oct 28           : add write out of filenr if next option is used
C!JAB(BGS)Nov94       : install error & file handling...
c    dec 94           : **************version 5.0 *******************
C!JAB(BGS)Mar95       : Diagnostic to inform of filename request rather than
C!JAB(BGS)Mar95         item from filenr.lis
C!JAB(BGS)Mar95       : Add "q" to quit
C!JAB(BGS)Aug95       : If filenr.lis does not exist, message before killing.
C!JAB(BGS)Aug95         In future, this might just give message & return the
C!JAB(BGS)Aug95         condition code to be processed by the calling program
c   jan 17 96 jh      : 4 digit number, less than 4 letter file if none of
c                       the letters are digits
c   mar 31    jh      : reset access variable before opening filenr.lis
c---------------------------------------------------------------------
c   sep 98 jh         : ----------- version 7.0 check -------------
c                       no change
c   sep 25 jh         : stop every 20 lines when using '?'
c   oct 18 2002 jh    : add back option
C
C    Seisan library details...
C    -------------------------
C
      implicit none                                                             
      INCLUDE   'libsei.inc'                   ! Definitions and data defns.
      external  sei open,                      ! Open file handler.
     &          sei close,                     ! Close file handler.
     &          sei code,                      ! Error handler.
     &          sei clen                       ! String length
      integer   sei clen                       ! Function.
c
      integer   code,                          ! Local error condition.
     &          read1                          ! Read unit 1.
      logical   b_flag                         ! Flag existance.?
C
C    -------- end ------------
C
c-- question to be printed out                    
      character*(*) question		   
c-- input output file name             
      character*(*) file_name               
c-- file name on disk file             
      character*80 file_list               
c-- length of file_name                
      integer length                       
c-- number of file in list             
      integer file_nr,old_file_nr                      
      character*80 text
      integer nout                  ! counter for output lines
      character*1 number(10)        ! ascii values of numbers
      logical file                  ! true if a file name
      logical digit                 ! true if a digit
c-- counters                           
      integer i,k                            
      data number/'1','2','3','4','5','6','7','8','9','0'/
      common/filenumberlis/file_nr    !new
C
C    Initialise...
C    =============
C
1     code  = e_ok$                           ! Local condition.
      nout=1
      file_name = ' '
c                                                                               
c    input file name if not next file                                         
c    --------------------------------
c                                                                               
      if(question(1:11).ne.'#Next_file#'. and.
     *   question(1:11).ne.'#Back_file#') then
         write(6,'(a80)')question                                               
         call flush (6)
         read(5,'(a80)') file_name 
      else
         if(question(1:11).eq.'#Next_file#') file_nr=old_file_nr+1
         if(question(1:11).eq.'#Back_file#') then
             file_nr=old_file_nr-1
             if(file_nr.eq.0) file_nr=1
         endif                                                
         goto 1000
      endif
c                                                                               
c    check if blank indicating EOF                                             
c    -----------------------------
c                                                                               
      if(file_name(1:1).eq.' '   .or.       !JAB(BGS)Mar95.
     &   file_name(1:1).eq.'q'   .or.       !JAB(BGS)Mar95.
     &   file_name(1:1).eq.'Q' ) then       !JAB(BGS)Mar95.
         file_name='EOF'                                                        
         goto 9999                        ! Return to caller.
      endif                                                                     
c
c   if firs charcter is  ?, go down to list file list
c
      if(file_name(1:1).eq.'?') goto 1000
     
c
c-- check if a normal file name, pad name with nulls...         
c   --------------------------------------------------
c
      length = sei clen( file_name )      ! Length of file name.
c
c  if length is less than 5, could still be a file name if not
c  all characters are numbers
c
      if(length.lt.5) then
         file=.false.
         do i=1,length
           digit=.false.
           do k=1,10
             if(file_name(i:i).eq.number(k)) digit=.true.
           enddo
           if(.not.digit) file=.true.
         enddo
      endif
      if(length.gt.4.or.file) then
         do i=length+1,80
            file_name(i:i)=char(0)
         enddo
         goto 9999                         ! Return to caller.
      endif                                                                    
c
 1000 continue
c
c    open file containing list of files numbered                                
c    -------------------------------------------
c                                                                               
      chr_f_access$ = ' '
      call sei open( old$+warn$,         ! Open & warn of errors.
     &               ' ',                  ! No prompt.
     &               'filenr.lis',         ! Filename.
     &               read1,                ! Open on unit.
     &               b_filenr$,            ! Flag existance & usage?.
     &               code )                ! Condition.
      chr_err_msg$ = 
     &'**** FATAL: problem opening "filenr.lis"'
      call sei code( stop$, code, 0, b_flag ) ! Force an abort on error.
C
c-- list files                         
c   ----------
c
      if(file_name(1:1).eq.'?') then            !
3     read(read1,'(a80)',iostat=code) file_list ! read item.                 
      call sei code(fort$,code,read1,b_flag)    ! Process outcome.
c
c    End of file...
c    --------------
c
         if( b_flag ) then                      ! End of file.
         call sei close(close$,read1,code)      ! Close file.
         go to 1                                ! & start again.
c
c    Write item to standard output...
c    --------------------------------
c
         else                                   ! Otherwise.
         write(6,'(1x,a79)') file_list(1:79)    ! Write to statndard output.
         nout=nout+1
         if(nout.gt.20) then
            write(6,*)' Return to continue, q to quit listing'
            call flush (6)
            read(5,'(a1)') text(1:1)
            if(text(1:1).eq.'q'.or.text(1:1).eq.'Q') then
               call sei close(close$,read1,code)      ! Close file.
               go to 1                                ! & start again.
            endif
            nout=1
         endif
         go to 3                                ! Read next record.
         end if                                 !
      endif                                                                     
c                                                                               
c   file name is a number, find nr and name in list on disk, if not
c   ---------------------------------------------------------------
c   next file to use                
c   ----------------
c                                                                               
      if(question(1:11).ne.'#Next_file#'.and.
     *   question(1:11).ne.'#Back_file#') then
         if(length.eq.1) read(file_name,'(i1)') file_nr                         
         if(length.eq.2) read(file_name,'(i2)') file_nr                         
         if(length.eq.3) read(file_name,'(i3)') file_nr                         
         if(length.eq.4) read(file_name,'(i4)') file_nr                         
      endif
c
c   write out filen number if next or back file option
c
      if(question(1:11).eq.'#Next_file#'.or.
     *   question(1:11).eq.'#Back_file#') then
          write(6,*)' Filenumber',file_nr
      endif
c                                                                               
c-- read until file nr is hit in file  
c   ---------------------------------
c
      do i=1,file_nr                       
      read(read1,'(7X,a70)',iostat=code) file_name ! Read filename.
      call sei code(fort$,code,read1,b_flag)       ! Process outcome.
      if( b_flag ) goto 50                         ! End of file.
      enddo                                                                     
C
      if(file_name(1:1).eq.' ') goto 50
      i=index(file_name,' ')
c
c   make sure end of file name do not contain blanks
c
      do k=i,80
         file_name(k:k)=char(0)
      enddo
      goto 51
c
 50   continue
         write(6,*)' File number too large'
         file_name(1:3)='EOF'
         call sei close(close$,read1,code)     ! Close file.
         goto 9999                             ! Return to caller.
c
51    call sei close(close$,read1,code)        ! Close file.
c
c   save file number
c
      old_file_nr=file_nr
c
c   Return to caller...
c   ===================
c
9999  return
      end                                                                       

c
c   new routine for fft for SEISAN, put in by jh, jan 2002
c   the old routines has problem with numerical overflow
c   on solaris
c   
c   the old routine is listed below
c
c   this new routine was origianlly for double precision, has been
c   modified to single precision since it is so in all SEISAN calls
c   modifications are indicated by cx. modification also include
c   changing normalization
c
c
cx      Subroutine FFT(A,m,INV)
      Subroutine FFT(m,INV,A)
*------------------------------------------------------------------*
*                                                                  *
* A First Course in Computational Physics                          *
*                                                                  *
* Paul L. DeVries, Department of Physics, Miami University         *
*                                                                  *
* This subroutine performs the Fast Fourier Transform by           *
* the method of Cooley and Tukey --- the FORTRAN code was          *
* adapted from                                                     *
*                                                                  *
*   Cooley, Lewis, and Welch, IEEE Transactions E-12               *
*       (March 1965).                                              *
*                                                                  *
* The array A contains the complex data to be transformed,         *
* `m' is log2(N), and INV is an index = 1 if the inverse           *
* transform is to be computed. (The forward transform is           *
* evaluated if INV is not = 1.)                                    *
*                                                                  *
*                            start: 1965                           *
*                    last modified: 1993                           *
*                                                                  *
*------------------------------------------------------------------*
*
cx       Complex*16 A(1), u, w, t 
       Complex A(1), u, w, t
       Double precision ang, pi
       real inv  !cx
       Integer N, Nd2, i, j, k, l, le, le1, ip
       Parameter (pi = 3.141592653589793d0)
*
*  This routine computes the Fast Fourier Transform of the 
*  input data and returns it in the same array. Note that 
*  the k's and x's are related in the following way:
*
*    IF    K = range of k's      and     X = range of x's
*
*    THEN  delta-k = 2 pi / X    and   delta-x = 2 pi / K
*        
*  When the transform is evaluated, it is assumed that the 
*  input data is periodic. The output is therefore periodic 
*  (you have no choice in this). Thus, the transform is 
*  periodic in k-space, with the first N/2 points being 
*  'most significant'. The second N/2 points are the same 
*  as the Fourier transform at negative k!!! That is,
*
*              FFT(N+1-i) = FFT(-i)  ,i = 1,2,....,N/2
*
       N   = 2**m
       Nd2 = N/2
       j   = 1
       DO i = 1, N-1
          IF( i .lt. j ) THEN
             t    = A(j)
             A(j) = A(i)
             A(i) = t
          ENDIF
          k = Nd2
100       IF( k .lt. j ) THEN
             j = j-k
             k = k/2
             goto 100
          ENDIF
          j  = j+k
       END DO
       le = 1       
       DO l = 1, m
          le1 = le
          le  = le + le

          u = ( 1.D0, 0.D0 )
          ang = pi / dble(le1)
          W = Dcmplx( cos(ang), -sin(ang) )
cx          IF(inv .eq. 1) W = Dconjg(W)
          IF(inv .gt. 0.0) W = conjg(W)

          DO j = 1, le1
             DO i = j, N, le
                ip   = i+le1
                t    = A(ip)*u
                A(ip)= A(i)-t
                A(i) = A(i)+t
             END DO
             u=u*w
          END DO

       END DO

cx       IF(inv .ne. 1) THEN
cx          DO i = 1, N
cx             A(i) = A(i) / dble(N)
cx          END DO
cx       ENDIF
       return
       end



c    old routine
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX   
C                                                                               
c     SUBROUTINE FFT(NR,SIGN,DAT)                                               
C                                                                               
C   FAST FOURIER TRANSFORM OF 2**NR COMPLEX POINTS DAT.                         
C   SIGN=-1 : FROM TIME TO FREQUENCY                                            
C   SIGN=+1 : FROM FREQUENCY TO TIME                                            
C                                                                               
c     COMPLEX COMP,DAT,EIFI                                                     
c     DIMENSION DAT(1)                                                          
c     DIMENSION IPW2(14)                                                        
c     NTOTAL=2**NR                                                              
c     ANG=SIGN*6.283185307E+00/FLOAT(NTOTAL)                                    
c     JF=NTOTAL                                                                 
c     DO 10 II=1,NR                                                             
c     JF=JF/2                                                                   
c  10 IPW2(II)=JF                                                               
c     I2P1=1                                                                    
c     I2RP=NTOTAL                                                               
c     DO 40 IP=1,NR                                                             
c     I2RP1=I2RP                                                                
c     I2RP=I2RP/2                                                               
c     MINV=0                                                                    
c     DO 41 MDIR=1,I2P1                                                         
c     QR=ANG*FLOAT(MINV)                                                        
c     EIFI=CMPLX(COS(QR),SIN(QR))                                               
c     ICONST=I2RP1*(MDIR-1)                                                     
c     DO 20 II=1,I2RP                                                           
c     JF=ICONST+II                                                              
c     JL=JF+I2RP                                                                
c     COMP=DAT(JL)*EIFI                                                         
c     DAT(JL)=DAT(JF)-COMP                                                      
c  20 DAT(JF)=DAT(JF)+COMP                                                      
c     DO 30 II=2,NR                                                             
c     JF=IPW2(II)                                                               
c     JL=MINV/JF                                                                
c     ICONST=JL/2                                                               
c     IF(JL-ICONST-ICONST) 41,41,30                                             
c  30 MINV=MINV-JF                                                              
c  41 MINV=MINV+JF                                                              
c  40 I2P1=I2P1+I2P1                                                            
c     I2N=NTOTAL-1                                                              
c     MINV=IPW2(1)                                                              
c     DO 60 IJ=2,I2N                                                            
c     IF(MINV-IJ)48,47,47                                                       
c  47 COMP=DAT(IJ)                                                              
c     JF=MINV+1                                                                 
c     DAT(IJ)=DAT(JF)                                                           
c     DAT(JF)=COMP                                                              
c  48 DO 49 II=1,NR                                                             
c     JF=IPW2(II)                                                               
c     JL=MINV/JF                                                                
c     ICONST=JL/2                                                               
c     IF(JL-ICONST-ICONST)60,60,49                                              
c  49 MINV=MINV-JF                                                              
c  60 MINV = MINV + JF                                                          
c                                                                               
C      IF(SIGN.EQ. -1.0) DAT=(0.0,0.0)  ! this line was always commented out                                        
C                                                                               
c     RETURN                                                                    
c     END                                                                       

c
c   automatic coda determination by lo, 1998
c
c
c  updates
c
c  sep 98 by jh  : ---------- version 7.0 check ---------------------
c                  remove test output to 99
c
      subroutine auto_coda 
      implicit none
      include 'mulplt.inc'

      integer c                                   ! counter
      real p_time
      integer p_sample
      real lta,slta
 
      integer l_sta
      real sta,ssta,old_sta

c      open(99,file='junk',status='unknown')

c      write(99,*) 'coda filter low ',coda_l
c      write(99,*) 'coda filter high ',coda_h
c      write(99,*) 'coda ratio ',coda_ratio
c      write(99,*) 'coda sta ',coda_sta

c      auto_coda_time = numb_samp / rate /2
      auto_coda_time = -1

      p_time = 9999999
c
c  check for p phase and get start time relative to trace start
c
      
      do c=1,nphas
        if (phase(c)(2:2).eq.'P') then
 
          if (pictim(c).lt.p_time) p_time = pictim(c)
 
        endif
      enddo

      if (p_time.eq.9999999) goto 999

c
c calculate sample of P-phase
c
      p_sample= p_time * rate

c
c  take complete trace and filter
c
      filt = 8
      flow(8) = coda_l
      fhigh(8) = coda_h

      call trans_filt(1)

c
c get LTA
c
      slta=0
      do c=1,p_sample-1

        slta = slta + y(c) * y(c)
      enddo

      lta= slta / (p_sample-1)

c      write(99,*) 'lta ',lta

c
c  length of coda_sta in samples
c
      l_sta=abs(coda_sta*rate)

      ssta=0

      do c=p_sample,p_sample+l_sta
        ssta=ssta + y(c) * y(c)
      enddo

c
c  get start sta
c
      old_sta = ssta / l_sta

      c=p_sample+l_sta+1     ! start from coda_sta
 100  continue

      c=c+1

      sta= (y(c) * y(c) - y(c-l_sta) * y(c-l_sta))
     &     / l_sta    + old_sta

      old_sta = sta

c      write(99,*) 'c ',c,' sta ',sta
c
c  get ratio of STA/LTA
c

      if (sta/lta.lt.coda_ratio) then

        auto_coda_time = c / rate
        goto 999
      endif


      if (c.eq.numb_samp) goto 999

      goto 100

 999  continue

c      write(99,*) 'auto_coda_time ',auto_coda_time

c      close(99)


      return
      end

c$debug
c
c   select isc stations from isc station file corresponding
c   to isc events in user specified input file
c    
c   station list can be both isc or seisan format
c
c   j. havskov nov 93
c
c   changes:
c   jan 96 by jh: fixed to always convert to seisian format
c   apr 18      : bug in output format
c   jun 1999 jh   ------------   version 7.0 -----------------
C   jan 6 99    : change so that station is not selected more than once,
c                 idea thanks to Mohammad Raesi
c
      implicit none
      character*4 outsta(30000)    ! stations selected
      integer selected(30000)      ! indicator for stations found
      character*80 iscfile,norfile
      character*80 text
      integer nout,i,k,nwrite
      real latsec,lonsec          ! seconds part of latitude and longitude
      integer latmin,lonmin       ! lat and lon minutes
      integer nstat,nphase,nhead,nrecord,id
      character*1 type,exp
      character*80 data(5000)
c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      write(6,*)' This program will read an S-file, find how many'
      write(6,*)' different stations there are and select those'
      write(6,*)' stations out of a station file, which can either'
      write(6,*)' be in SEISAN (=HYPO71) format or ISC format. The'
      write(6,*)' output is in SEISAN format. If no S-file is given'
      write(6,*)' the input station file is assumed to be in ISC'
      write(6,*)' format and the whole file will be converted to'
      write(6,*)' SEISAN format'
      write(6,*)' ONLY 4 letter station codes supported '
      write(6,*)
c

      write(6,*)' Give file with all stations( ISC or SEISAN format)'
      read(5,'(a)') iscfile
      write(6,*)
     *' Give file with readings, Nordic format, if none, return'
      read(5,'(a)') norfile
      open(2,file=iscfile,status='old')
      open(3,file='iscsta.out',status='unknown')
c
c   go through events if available
c
      nout=0
      nwrite=0
      do i=1,6000
         selected(i)=0
      enddo
      if(norfile(1:3).ne.'   ') then 
         open(1,file=norfile,status='old')
         open(4,file='isc_miss.out',status='unknown')

 1       continue
         call indata(1,nstat,nphase,nhead,nrecord,type,exp,data,id)              
         if(nrecord.eq.0) goto 10
c
         do i=nhead+1,nrecord-1
            do k=1,nout
               if(data(i)(2:5).eq.outsta(k)) goto 2
            enddo
            nout=nout+1
            outsta(nout)=data(i)(2:5)
c
c   enter here if station found
c
 2          continue
         enddo
         goto 1
      endif
c
c   end of event list
c
 10   continue
c
c   find station in isc list, check both isc and seisan formats
c   convert to seisan format, if no input readings file, just
c   convert 
c
      read(2,'(a80)',end=99) text
      if(norfile(1:3).ne.'   ') then    
        do k=1,nout     
          if(selected(k).ne.1) then             ! only select new stations
           if(text(1:4).eq.outsta(k)) then      ! isc format
              selected(k)=1                     ! indicate that station found
              read(text(47:48),'(i2)') latmin
              read(text(56:57),'(i2)') lonmin
              read(text(49:51),'(f3.1)')latsec
              read(text(58:60),'(f3.1)')lonsec
              write(3,'(2x,a,a,f5.2,a,a,f5.2,a)')
     *        text(1:4),text(45:46),latmin+latsec/60.0,
     *        text(52:52),text(53:55),lonmin+lonsec/60.0,text(61:65)
              nwrite=nwrite+1
           endif
c
c   seisan format input
c
           if(text(3:6).eq.outsta(k)) then
              selected(k)=1                     ! indicate that station found
              write(3,'(a)') text
              nwrite=nwrite+1
           endif
         endif
        enddo
      else
        read(text(47:48),'(i2)') latmin
        read(text(56:57),'(i2)') lonmin
        read(text(49:51),'(f3.1)')latsec
        read(text(58:60),'(f3.1)')lonsec
        write(3,'(2x,a,a,f5.2,a,a,f5.2,a)')
     *  text(1:4),text(45:46),latmin+latsec/60.0,
     *  text(52:52),text(53:55),lonmin+lonsec/60.0,text(61:65)
        nwrite=nwrite+1
      endif
      goto 10
c
 99   continue

      if(norfile(1:3).ne.'   ') then
         write(6,*)' Number of stations found in readings file',nout
         k=0
         do i=1,nout
            if(selected(i).ne.1) then
               write(4,'(2x,a)') outsta(i)
               k=k+1
            endif
         enddo
         write(6,*)' Number of stations not found in station file',k
      endif
      write(6,*)' Number of stations selected in station file',nwrite
      write(6,*)' Output file is iscsta.out'
      if(norfile(1:3).ne.'   ') 
     *write(6,*)' Output file with missing stations is isc_miss.out'
      stop
      end

c$DEBUG
c
c  converts Sprengnether DR3024 and DR3016 to SEISAN format
c  formats slight different, automatically corrected for
c  only essential info read, no instrument correction, no channel info read
c  channels can only be defined using the drsei.def definition file, NOTE,
c  only 4 lowest digits of seriel number is used. if a station code is given,
c  it will be used, else the serial number is used for station code.
c  default componenents are s  z, s  n, s  e
c  Output is always 4 byte integers 
c
c  j. havskov, april 98
c
c    may 11  00    lo : use read_resp_head
c
c  Testdata and help was provided by Sprengnether
c
c  updates:
c  --------------------- Version 7 ---------------------
c sep 22 99 lo: changes for Version 7
c               changed to run on Sun
c sep 30    lo: tested under Linux
c dec 99    jh: define mainhead to max_trace, was 12, read fraction of second,
c               use station codes when available, hardwire default components
c

      implicit none
      include 'seidim.inc'
c-- output data vector	  
      integer*4  data(max_sample)
      character*256 block  ! input file header
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile,deffile
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     &     hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      integer*2 i_rate
      character*2 c_rate
      real srate(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c-------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
	  integer i,irec
c-- computer type
      logical pc,sun,linux
c--------------------------- specific lennartz 
       integer ishift          ! one header relative to other in two models
c-- help for swap
       character*4 xs
       integer ixs
       integer i_samp    ! number of samples
       character*4 c_samp! ----------------
       integer*2 i2
       character*2 c2
      character*2 cs_number       ! seriel number
      integer*2 is2_number        ! -------------
      integer*4 is_number
      character*8 s_number        ! seriel number of current station
c-- corresponding station codes
      character*29 mainhead_text
      logical no_net                    ! flag if net_code set
      integer seiclen

c
      equivalence(is2_number,cs_number)
      equivalence(i_rate,c_rate)
      equivalence (c_samp,i_samp)
      equivalence (ixs,xs)
      equivalence (i2,c2)



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c init
c
      mainhead_text = ' '
c
      call computer_type(sun,pc,linux)

c
c   get def file for station codes, give file name
c
      deffile='drsei.def'
      no_net = .FALSE.
      net_code=' '

      call read_def_chan(deffile,mainhead_text,net_code)

      if (net_code.eq.' ') no_net = .true.

c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile(1:seiclen(infile))
c
c  open file 
c
       open(1,file=infile,status='old',access='direct',recl=256)
c
c   read header block to get start time etc
c
c
 1     continue
c       read(1,rec=1,end=99) block
       read(1,rec=1) block
       close(1)
c
c   open again with record length 4 to read samples later
c
       
      open(1,file=infile,status='old',access='direct',recl=4)

c
c   get name of recorder and find which kind, bytes are shifted
c   3 bytes in one relative to other
c
       if(block(53:54).eq.'DR') then
          ishift=3   ! dr3024
       else
          ishift=0
       endif
       write(6,'(a,a)')' Recorder ',block(50+ishift:55+ishift)
c
c   number of samples
c
       c_samp=block(7:10)
c
c   seriel number
c
       cs_number=block(57+ishift:58+ishift)
c
c   sample rate
c
       c_rate=block(11:12)
c
c   swap a few numbers if on sun
c
       if(sun) then
c  seriel number
          xs(1:1)=cs_number(1:1)
          cs_number(1:1)=cs_number(2:2)
          cs_number(2:2)=xs(1:1)
c  sample rate
          xs(1:1)=c_rate(1:1)
          c_rate(1:1)=c_rate(2:2)
          c_rate(2:2)=xs(1:1)

c  number of samples, change lo
          xs(1:1)=c_samp(1:1)
          c_samp(1:1)=c_samp(4:4)
          c_samp(4:4)=xs(1:1)
          xs(1:1)=c_samp(2:2)
          c_samp(2:2)=c_samp(3:3)
          c_samp(3:3)=xs(1:1)
       endif
c
c   number of channels
c
       nchan=ichar(block(13:13))
       write(6,*)'Number of channels',nchan
c
c   get times
c
c   fractions of seconds
       c2=block(32+ishift:33+ishift)
       if(sun) call swap2_one(i2)
       write(6,*)'Samples offset',i2
c   seconds
       call bcd(block(34+ishift:34+ishift),i)
       sec(1)=i+float(i2)/float(i_rate)
c   minutes
       call bcd(block(35+ishift:35+ishift),min(1))
c   hour
       call bcd(block(36+ishift:36+ishift),hour(1))
c   day
       call bcd(block(37+ishift:37+ishift),day(1))
c   month
       call bcd(block(38+ishift:38+ishift),month(1))
c   year
       call bcd(block(39+ishift:39+ishift),year(1))

       if (year(1).gt.50) then
         year(1) = year(1) + 1900
       else
         year(1) = year(1) + 2000
       endif

c
c   initially use seriel numbers padded with 0 for station codes, 
c   assume max 5 digits, if more, only use last 5 digits of number
c   seriel number is unsigned integer, correct by putting into
c   4 byte word and null 2 top bytes
c
       ixs=is2_number
       if(sun) then
          xs(1:1)=char(0)
          xs(2:2)=char(0)
       else
          xs(3:3)=char(0)
          xs(4:4)=char(0)
       endif
       is_number=ixs
       write(s_number,'(i8)') is_number
       write(6,'(a14,5x,a5)') ' Serial number ',s_number(4:8)
       write(6,*) 'Number of samples',i_samp
c
c   use code if there, else use serial number
c
       if(block(59+ishift:63+ishift).ne.' ') then
          stat(1)=block(59+ishift:63+ishift)
          do i=1,5
             if(stat(1)(i:i).eq.char(0)) stat(1)(i:i)=' '
          enddo
       else
          stat(1)=s_number(4:8)
          do i=1,5
             if(stat(1)(i:i).eq.' ') stat(1)(i:i)='0'
          enddo			 	   	   	    
       endif
c
c   assume same start time etc. for all channels
c
       do i=1,nchan
          year(i)=year(1)
          month(i)=month(1)
          day(i)=day(1)
          hour(i)=hour(1)
          min(i)=min(1)
          sec(i)=sec(1)
          srate(i)=i_rate
          nsamp(i)=i_samp
          cbyte(i)='4'
          comp(i)(1:4) = '    '
c          write(comp(i)(4:4),'(i1)') i
          stat(i)=stat(1)
       enddo
        write(*,*) year(1),month(1),day(1),hour(1),min(1),
     &   sec(1),srate(1),nsamp(1),' ',cbyte(1),' ',comp(1),' ',
     &   stat(1)
c
c   assume components in case no def file for first 3 components
c       
        comp(1)='S  Z'
        comp(2)='S  N'
        comp(3)='S  E'
c
c  enter loop to define channels if a def file
c

c
c   look for values in def file
c
       do i=1,nchan
         call set_def_chan(i,stat(i),comp(i)) 
       enddo

c
c   make seisan headers
c
      ichan=1
      if (no_net) then
        net_code = stat(1)
      endif

      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 srate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   open output file
c
      write(6,'(a,a)')' Output file name is: ',
     &           outfile(1:seiclen(outfile))
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c
      mainhead(1)(2:29)=mainhead_text    ! put in header text
      write(6,'(a80)') mainhead(1)
      do i=1,12
         write(2)mainhead(i)
c         write(6,'(a80)') mainhead(i)
      enddo
c
C-----------------------------------------
C   enter channel  loop
c-----------------------------------------
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,
     *                    stat,comp,nsamp,srate,cbyte,
     *                    outfile,mainhead,chahead)
         write(6,'(1x,a)') chahead(1:78)
c                                                                               
c   get response, save date etc since removed when calling read_resp            
c                                                                               
         call read_resp_head(chahead)                                            
c
c   read samples
c
          do i=1,i_samp
            irec=65+(i-1)*nchan+(ichan-1)
            read(1,rec=irec) data(i)
          enddo
 
          if (sun) then
             call swap4(i_samp,data)
          endif
 
c
c   write data
c
         write(2)chahead
         write(2) (data(i),i=1,i_samp)
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  

      program condet
c
c program to run sta/lta detection through continuous data stream,
c all input is read from condet.par
c
c two detection algorithms are supported:
c       - squared sta/lta
c       - Carl Johnson's 
c

c
c Lars Ottemoller, BGS, July 2005
c

c
c changes:
c
c 20/03/2008 lot - use several stations, network detection (option -net)
c    08/2008 lot - change write for extract.batch not to break up lines
c 14/08/2008 lot - added cosine taper to master signal when using COR
c                  this may give problem at file boundaries
c  2/10/2008 lot - fixed bug with wrong net detection at end and high ndet num

      implicit none 

c
c read SEISAN include files
c
      include 'seidim.inc'   ! dimensions
      include 'seisan.inc'   ! general seisan parameters
      include 'libsei.inc'
      include 'waveform.inc' ! for waveform handling
      include 'rea.inc'      ! for waveform handling
      integer seiclen

      character*80 outfile   ! name of output seisan  waveform file
      character*80 text  
      character*1040 theader ! seisan channel header
      character*80 fheader(max_trace) ! seisan waveform main header
      character*29 headtext
      character*5 net_code   ! code of network
      real duration_min      ! minute
      integer i,j,l,k,sc     ! counter
      integer tl             ! number of samples to taper
      real taper,pi          ! taper value
      integer maxstat,maxtrig
      parameter (maxstat=100)
      character*5 station(maxstat),cbase(maxstat)
      character*4 component(maxstat)
      integer ind,ind_save
      double precision msec_start,msec_stop,msec,trigger_msec,msec1
      double precision ptrigger_msec
      character*14 stop_time,start_time,time
      integer year1,month1,day1,hour1,min1,isec1,doy1
      integer year2,month2,day2,hour2,min2,isec2,doy2
      real sec1,sec2
      real*8 sta,lta,star,ltar
      integer nsta,nlta
      real sta_duration,lta_duration
      logical startup
      integer write1,write2,write3,read1,write4
      logical b_flag
      integer code
      real trigger_ratio,detrigger_ratio,trigcor
      real trigger_min_int,trigger_min_dur
      logical trigger
      logical freeze
      character*8 filter_proto,filter_type  
      integer npoles,passes
      real flow,fhigh,samp_int
      integer ndc
      real rdc
      logical waveout
      character*80      data(max_data)  ! event array
      real data_save(max_sample),first_sta,first_lta
      real first_stacarl,first_ltacarl
      real ltacarl_save(max_sample),ltacarl(max_sample)
      real master(max_sample),cordata(max_sample)
      integer ntriggers(maxstat)
      character*10 detalg
      real carlratio,carlquiet
      integer nstat
      real pre_event,extduration
      logical netflag
      real netwindow
      integer netmindet
      integer narg
      character*80 arg(40)
      character*80 master_filename
      integer nmaster ! number of samples in master signal
      real max
      integer cor_nsamp

c
c   get seisan defaults including names of continuous waveform data bases
c
      call get_seisan_def 
c
c   get arguments
c
      call get_arguments(narg,arg)
      i=1
      netflag=.false.
      do while(i.le.narg)
        if (arg(i).eq.'-net') then
          netflag=.true.
        elseif (arg(i).eq.'-help') then
          write(*,*) ' usage: condet [-net] '
          write(*,*) '     -net: network detection using '//
     &      'condet.out as input '
          stop
        endif
        i=i+1
      enddo

      call get_contdet_def(nstat,cbase,start_time,stop_time,
     &   duration_min,station,component,waveout,flow,fhigh,
     &   sta_duration,lta_duration,trigger_ratio,
     &   detrigger_ratio,trigger_min_dur,trigger_min_int,
     &   freeze,detalg,
     &   carlratio,carlquiet,pre_event,extduration,
     &   netwindow,netmindet,master_filename)

c
c open files
c
      if (.not.netflag) then
        call sei open( unknown$,          ! Open old file.
     &               ' ',               ! No prompt.
     &               'condet.out',    ! This filename.
     &               write1,            ! On this unit.
     &               b_flag,            ! Existance?.
     &               code )             ! Returned consition (n/a)
        call sei open( unknown$,          ! Open old file.
     &               ' ',               ! No prompt.
     &               'nordic.out',        ! This filename.
     &               write2,            ! On this unit.
     &               b_flag,            ! Existance?.
     &               code )             ! Returned consition (n/a)
        call sei open( unknown$,          ! Open old file.
     &               ' ',               ! No prompt.
     &               'condet.trace',    ! This filename.
     &               write4,            ! On this unit.
     &               b_flag,            ! Existance?.
     &               code )             ! Returned consition (n/a)
      else
        call sei open( old$,          ! Open old file.
     &               ' ',               ! No prompt.
     &               'condet.out',    ! This filename.
     &               read1,            ! On this unit.
     &               b_flag,            ! Existance?.
     &               code )             ! Returned consition (n/a)
        call sei open( unknown$,          ! Open old file.
     &               ' ',               ! No prompt.
     &               'net.out',    ! This filename.
     &               write1,            ! On this unit.
     &               b_flag,            ! Existance?.
     &               code )             ! Returned consition (n/a)
      endif
      call sei open( unknown$,          ! Open old file.
     &               ' ',               ! No prompt.
     &               'extract.batch',   ! This filename.
     &               write3,            ! On this unit.
     &               b_flag,            ! Existance?.
     &               code )             ! Returned consition (n/a)

c
c call routine in case of network detection
c
      if (netflag) then
        call netdet(read1,write1,write3,pre_event,extduration,
     &     netwindow,netmindet)
        call sei close( close$, write1, code )
        call sei close( close$, write3, code )
        call sei close( close$, read1, code )
        stop
      endif

c
c init variables 
c
      npoles=4

      if (cbase(1).eq.' ') then
        write(*,*) ' Name of continuous database '
        read(5,'(a)') cbase(1)
      endif

      if (start_time.eq.' ') then
        write(*,*) ' Start time (yyyymmdd...) '
        read(5,'(a)') start_time
      endif

      if (stop_time.eq.' ') then
        write(*,*) ' Stop time (yyyymmdd...) '
        read(5,'(a)') stop_time
      endif

      if (duration_min.eq.0.) then
        write(*,*) ' Duration in min '
        read(5,*) duration_min
      endif

      if (station(1).eq.' ') then
        write(*,*) ' Station '
        read(5,'(a)') station(1)
      endif

      if (component(1).eq.' ') then
        write(*,*) ' Component '
        read(5,'(a)') component(1)
      endif

      write(*,*) ' start time: ',start_time
      write(*,*) ' stop time:  ',stop_time
c
c loop over stations
c
      do sc=1,nstat
c init
        ind_save=0
        nsta=0
        nlta=0
        sta=0.
        lta=0.
        star=0.
        ltar=0.
        trigger=.false.
        startup=.true.
        passes=-1
        filter_proto='BU'
        do k=1,max_sample
          data_save(k)=0.
          ltacarl_save(k)=0.
        enddo
        cont_base(1)=cbase(sc)
        ntriggers(sc)=0
        ptrigger_msec=0.
        trigger_msec=0.
c
c read master signal if detalg is correlation
c
        if (detalg(1:3).eq.'COR') then
          if (seiclen(master_filename).le.0) then
            write(*,*) ' MASTER WAVEFORM must be given in condet.par '
            stop
          endif
          call wav_init
          call get_full_wav_name(master_filename,wav_filename(1))
          call read_wav_header(1)
          ind=0
          do j=1,wav_nchan
            if (station(sc).eq.wav_stat(j).and.
     &          component(sc).eq.wav_comp(j).and.ind.eq.0) then
              ind=j
            endif
          enddo
          if (ind.eq.0) then
            write(*,*) ' channel not found ',station(sc),component(sc)
            stop
          else
            write(*,*) ' master file, channel selected index ',ind
          endif
          call wav_read_channel(ind)
          ndc=0
c put remove_dc back, lot 14/08/08
          call remove_dc(signal1,ndc,rdc,wav_nsamp(ind))
c this can be changed to compute dc and use it for taper, but not remove it
c as that is a problem when moving from one file to another
          do j=1,wav_nsamp(ind)
            write(15,*) j,signal1(j)
          enddo
c
c apply cosine taper 
c
          tl=int(wav_nsamp(ind)*.05)
          pi=acos(-1.)
          do j=1,tl
c            taper=.5*(1.-cos((j-1)*pi/float(tl-1)))
            taper=(-cos(pi/2.+(j-1)*(pi/2.)/float(tl-1)))
            signal1(j)=signal1(j)*taper
            signal1(wav_nsamp(ind)-j+1)=signal1(wav_nsamp(ind)-j+1)*
     &           taper
            write(18,*) j,taper
          enddo
          do j=1,wav_nsamp(ind)
            write(16,*) signal1(j)
          enddo
           
c
c filter data
c
          samp_int=1./wav_rate(ind)
          if (flow.ne.0..or.fhigh.ne.0.) then
            filter_type='BP'
            call recfil(signal1,wav_nsamp(ind),signal1,
     &      filter_proto,0.,0.,npoles,filter_type,flow,fhigh,
     &      samp_int,passes)
          else
c
c apply highpass to remove dc
c
            filter_type='HP'
            flow=0.01
c            fhigh=wav_rate(ind)/2.*.9
            fhigh=0.
            call recfil(signal1,wav_nsamp(ind),signal1,
     &      filter_proto,0.,0.,npoles,filter_type,flow,fhigh,
     &      samp_int,passes)
          endif
c
c copy to master signal
c
          nmaster=wav_nsamp(ind)
          do j=1,wav_nsamp(ind)
            master(j)=signal1(j)
            write(17,*) master(j)
          enddo
        endif

c
c  signal that reading is from a continous data base
c
        cwav=.true.
        n_cont_base=1
c
c   calculate end time and extended start time, needed in order to
c   make sure enough files read in
c
      cwav_start_time=start_time

      read(start_time,'(i4,5i2)') year1,month1,day1,hour1,min1,isec1
      sec1=float(isec1)
      call timsec(year1,month1,day1,hour1,min1,sec1,msec_start)

c 
c compute overall endtime
c
      read(stop_time,'(i4,5i2)') year2,month2,day2,hour2,min2,isec2
      sec2=float(isec2)
      call timsec(year2,month2,day2,hour2,min2,sec2,msec_stop)

c
c set initial values
c
      call cwav_time_limits(0)
      cwav_abs_start_time=msec_start
      cont_interval=duration_min*60.

      do while(cwav_abs_start_time.lt.msec_stop)

c
c set end of interval to be read
c
c        cwav_abs_end_time=cwav_abs_start_time+cont_interval
        call cwav_time_limits(1)
c
c  read the header information for all files in bases in time
c  interval, assume info available in common block
c
        call cwav_read_bases     
c
c find channel index
c
        ind=0
        do i=1,n_cont_trace
          if (cwav_stat(i).eq.station(sc).and.
     &        cwav_comp(i).eq.component(sc)) 
     &    then
            ind=i
          endif
        enddo
        if (ind_save.eq.0.and.ind.ne.0) ind_save=ind

        if (ind_save.ne.ind) then
          write(*,*) ' channel index changed, stop '
          startup=.true.
          goto 9999
        endif

c        cont_interval=duration_min*60.-
c     &       1./cwav_rate(ind,cwav_nseg(ind))
        cwav_abs_end_time=cwav_abs_start_time+cont_interval
 
        call sectim(cwav_abs_start_time,year1,doy1,month1,day1,hour1,
     &    min1,sec1)
        call sectim(cwav_abs_end_time,year2,doy2,month2,day2,hour2,
     &    min2,sec2)

        write(*,'(a,i4,"/",i2,"/",i2," ",i2,":",i2,":",f5.2)')
     &    ' start time: ',year1,month1,day1,hour1,min1,sec1
        write(write4,'(a,i4,"/",i2,"/",i2," ",i2,":",i2,":",f5.2)')
     &    ' start time: ',year1,month1,day1,hour1,min1,sec1
        write(*,'(a,i4,"/",i2,"/",i2," ",i2,":",i2,":",f5.2)')
     &    ' stop time:  ',year2,month2,day2,hour2,min2,sec2
        write(write4,'(a,i4,"/",i2,"/",i2," ",i2,":",i2,":",f5.2)')
     &    ' stop time:  ',year2,month2,day2,hour2,min2,sec2

        if (ind.ne.0) then
c          do j=1,cwav_nseg(ind)
c            write(*,*) ' segment:  ',cwav_nseg(j)
c            write(*,*) ' duration: ',cwav_duration(ind,j)
c            write(*,*) ' rate:     ',cwav_rate(ind,j)
c            write(*,*) ' samples:  ',cwav_nsamp(ind,j)
c          enddo

c
c  read the waveform data, one trace at a time
c
          call wav_read_channel(ind)    ! read trace

          if (wav_nchan.eq.0) then
            startup=.true.
            goto 9999
          endif

c          write(*,*) ' total samples: ',wav_nsamp(ind)-1
          write(*,*) ' total samples: ',wav_nsamp(ind)
          write(write4,*) ' total samples: ',wav_nsamp(ind)
          write(*,*) ' channel index: ',ind
          write(write4,*) ' channel index: ',ind
c
c filter data
c
c          call remove_dc(signal1,ndc,rdc,wav_nsamp(ind))
          samp_int=1./cwav_rate(ind,cwav_nseg(ind))
          if (flow.ne.0..or.fhigh.ne.0.) then
            filter_type='BP'
            call recfil(signal1,wav_nsamp(ind),signal1,
     &      filter_proto,0.,0.,npoles,filter_type,flow,fhigh,
     &      samp_int,passes)
          else
c
c apply highpass to remove dc
c
            filter_type='HP'
            flow=0.01
c            fhigh=wav_rate(ind)/2.*.9
            call recfil(signal1,wav_nsamp(ind),signal1,
     &      filter_proto,0.,0.,npoles,filter_type,flow,fhigh,
     &      samp_int,passes)
          endif

c
c set waveform output variables
c
          if (waveout) then
            wav_out_nchan=2
            do j=1,wav_out_nchan
              wav_out_year(j)=wav_year(ind)
              wav_out_month(j)=wav_month(ind)
              wav_out_day(j)=wav_day(ind)
              wav_out_hour(j)=wav_hour(ind)
              wav_out_min(j)=wav_min(ind)
              wav_out_sec(j)=wav_sec(ind)
              wav_out_stat(j)=wav_stat(ind)
              if (j.eq.1) then
                wav_out_nsamp(j)=wav_nsamp(ind)
                wav_out_comp(j)=wav_comp(ind)
              else
                 wav_out_nsamp(j)=wav_nsamp(ind)
c                wav_out_nsamp(j)=wav_nsamp(ind)-1
                wav_out_comp(j)=detalg(1:4)
              endif
              wav_out_rate(j)=wav_rate(ind) 
              wav_out_cbyte(j)=wav_cbyte(ind)
            enddo
c
c   make and write seisan output header
c
            headtext=' '
c            net_code=detalg(1:3)
            net_code=wav_stat(ind)
            call sheads(wav_out_year,wav_out_month,
     *        wav_out_day,wav_out_hour,
     *        wav_out_min,wav_out_sec,wav_out_nchan,1,
     *        net_code,headtext,wav_out_stat,wav_out_comp,
     *        wav_out_nsamp,wav_out_rate,wav_out_cbyte,
     *        outfile,fheader,theader)
            outfile=outfile(1:seiclen(outfile))//'_'//detalg(1:3)
            write(6,*) ' Output file : '//outfile
            open(66,file=outfile,status='unknown',form='unformatted')

c
c   write headers, assume maximum of 30 channels, since only 12 headers are written out
c
            do i=1,12
              write(66) fheader(i)
            enddo
c
c write out filtered data
c
            call sheads(wav_out_year,wav_out_month,
     *        wav_out_day,wav_out_hour,
     *        wav_out_min,wav_out_sec,wav_out_nchan,1,
     *        wav_out_stat(1),headtext,wav_out_stat,wav_out_comp,
     *        wav_out_nsamp,wav_out_rate,wav_out_cbyte,
     *        text,fheader,theader)
            write(66) theader              
c find scale
            max=0.
            do i=1,wav_out_nsamp(1)
              if (abs(signal1(i)).gt.max) max=abs(signal1(i))
            enddo
            max=1000000./max
            write(66)(int(signal1(l)*max),l=1,wav_out_nsamp(1))      
c            write(66)(int(signal1(l))*100,l=1,wav_out_nsamp(1))      
          endif
c
c init rea
c
          call rea_hyp_clear(1)
          rea_id_line=' '
          if (waveout) then
            rea_nwav=1
            rea_wav(1)='                                        '//
     &               '                                       6'
            write(rea_wav(1)(2:79),'(a)') outfile(1:seiclen(outfile)) 
          endif

          hyp_year(1)=wav_year(1)
          hyp_month(1)=wav_month(1)
          hyp_day(1)=wav_day(1)
          hyp_hour(1)=wav_hour(1)
          hyp_min(1)=wav_min(1)
          hyp_sec(1)=wav_sec(1)
          hyp_dist_id(1)='L'
          rea_nphase=0
          rea_nhyp=1

          if (detalg(1:3).ne.'COR') then
            if (nsta.eq.0) then
              nsta=int(sta_duration*cwav_rate(ind,cwav_nseg(ind)))
              write(*,*) ' nsta: ',nsta
            endif
            if (nlta.eq.0) then
              nlta=int(lta_duration*cwav_rate(ind,cwav_nseg(ind)))
              write(*,*) ' nlta: ',nlta
            endif
            write(*,*) ' nsta/nlta: ',nsta,nlta
          endif
c
c compute cross correlation
c
          if (detalg(1:3).eq.'COR') then
            write(*,*) ' master nsamp ',nmaster,
     &        ' cont segment nsamp ',wav_nsamp(ind)
            call cor_time(master,nmaster,signal1,
     &         cwav_nsamp(ind,cwav_nseg(ind)),
     &         cordata,cor_nsamp)
c           do j=1,cwav_nsamp(ind,cwav_nseg(ind))
c              write(15,'(f5.2)') abs(cordata(j)*100.)
c           enddo
          endif

c
c compute sta and lta
c
c          do j=1,wav_nsamp(ind)-1   ! last sample is start of next interval

          do j=1,wav_nsamp(ind)   
c
c set previous data values for sta and lta
c
            if (detalg(1:3).ne.'COR') then
              if (j.ge.nsta) then
                first_sta=signal1(j-nsta+1)
              else
                first_sta=data_save(nlta-nsta+j+1)
              endif
              if (j.ge.nlta) then
                first_lta=signal1(j-nlta+1)
              else
                first_lta=data_save(j+1)
              endif
            endif
c
c previous values for carltrig
c
            if (detalg.eq.'CAR') then
              if (j.ge.nsta) then
                first_stacarl=ltacarl(j-nsta+1)
              else
                first_stacarl=ltacarl_save(nlta-nsta+j+1)
              endif
              if (j.ge.nlta) then
                first_ltacarl=ltacarl(j-nlta+1)
              else
                first_ltacarl=ltacarl_save(j+1)
              endif
            endif
c
c get sample time
c
            msec=cwav_abs_start_time+
     &         float(j-1)/cwav_rate(ind,cwav_nseg(ind))
c
c add new sample and delete first sample in sta and lta
c
            if (detalg(1:3).eq.'STA') then
              sta=sta+(signal1(j)**2)/float(nsta)-
     &          (first_sta**2)/float(nsta)
              if (.not.trigger.or..not.freeze) then
                lta=lta+signal1(j)**2/float(nlta)-
     &            first_lta**2/float(nlta)
              endif

              signal2(j)=sta/lta

            elseif (detalg(1:3).eq.'CAR') then
              sta=sta+signal1(j)/float(nsta)-
     &          first_sta/float(nsta)
              ltacarl(j)=ltacarl(j)+signal1(j)/float(nlta)-
     &            first_lta/float(nlta)
              star=star+abs(signal1(j)-ltacarl(j))/float(nsta)-
     &            abs(first_sta-first_stacarl)/float(nsta)
     
              ltar=ltar+abs(signal1(j)-ltacarl(j))/float(nlta)-
     &            abs(first_lta-first_ltacarl)/float(nlta)

              signal2(j)=
     &          star-carlratio*ltar
     &          -abs(sta-lta)
     &          -carlquiet

            elseif (detalg(1:3).eq.'COR') then
              signal2(j)=cordata(j)*100.
            endif

            if (startup.and.j.ge.nlta) then
              startup=.false.
            endif
c
c save signal 
c
            if (detalg(1:3).ne.'COR') then
c              if (j.eq.wav_nsamp(ind)-1) then
              if (j.eq.wav_nsamp(ind)) then
                do k=1,nlta
                  data_save(k)=signal1(wav_nsamp(ind)-1-nlta+k)
                  ltacarl_save(k)=ltacarl(wav_nsamp(ind)-1-nlta+k)
                enddo
              endif
            endif
c
c check for trigger based on sta/lta ratio
c
            if (.not.startup) then 
              if (signal2(j).gt.trigger_ratio.and.
     &        .not.trigger) then
                trigger_msec=msec
                trigger=.true.
                if (detalg.eq.'COR') trigcor=signal2(j)
              endif
              if (trigger) then
c                  write(*,*) ' xxx trigger ',j,signal2(j)
c
c check for detrigger, detection if trigger duration long enough
c
c               write(*,*) ' xxx1 ',trigger
                if (signal2(j).le.detrigger_ratio) then
c                  write(*,*) ' detrigger ',signal2(j)

                  if (msec-trigger_msec.lt.trigger_min_dur) then
c                    write(*,*) ' trigger interval too short '
                    trigger=.false.
                  endif
                  if (trigger_msec-ptrigger_msec.lt.
     &              trigger_min_int) then
                      trigger=.false.
                  endif
c               write(*,*) ' xxx2 ',trigger

                  if (detalg.eq.'COR'.and.trigcor.lt.signal2(j)) then
                    trigcor=signal2(j)
                    trigger_msec=msec
                  endif
                  if (trigger) then
c
c write out trigger
c
                    ntriggers(sc)=ntriggers(sc)+1
c                    write(*,*) ' xxx ',station(sc),ntriggers(sc)

c
c add phase to nordic.out
c
                    rea_nphase=rea_nphase+1
                    if (rea_nphase.ge.max_phase) then
                      write(*,*) ' too many phases -> stop '
                      stop
                    endif
                    call rea_phase_clear(rea_nphase)
                    rea_stat(rea_nphase)=wav_stat(ind)
                    rea_comp(rea_nphase)=wav_comp(ind)
c                  rea_co(rea_nphase)(1:2)=wav_comp(ind)(1:1)//
c     &                 wav_comp(ind)(4:4)
                    rea_co(rea_nphase)(1:2)=wav_out_comp(2)(1:1)//
     &                 wav_out_comp(2)(4:4)
                    rea_phase(rea_nphase)=detalg(1:1)
                    rea_onset(rea_nphase)=' '
                    rea_weight_out(rea_nphase)='  '
                    rea_weight_in(rea_nphase)=' '
                    rea_polarity(rea_nphase)=' '
                    call sectim(trigger_msec,rea_year(rea_nphase),
     &     doy1,rea_month(rea_nphase),rea_day(rea_nphase),
     &     rea_hour(rea_nphase),rea_min(rea_nphase),
     &     rea_sec(rea_nphase))
  
                    call sectim(trigger_msec,year1,
     &                doy1,month1,day1,hour1,min1,sec1)
                    isec1=int(sec1)
                    write(time,'(i4.4,5i2.2)') 
     &                year1,month1,day1,hour1,min1,isec1
c                    write(write1,'(a14," ",f5.1)') time,
c     &                msec-trigger_msec
                    if (detalg(1:3).ne.'COR') then
                      write(write1,'(a5,1x,a4,1x,a14,1x,f5.1)') 
     &                station(sc),component(sc),time,
     &                msec-trigger_msec
                    else
                      write(write1,'(a5,1x,a4,1x,a14,1x,f5.1)') 
     &                station(sc),component(sc),time,
     &                trigcor
                    endif

c
c write out extract command
c
c                    msec1=trigger_msec-60.
                    msec1=trigger_msec-pre_event
                    call sectim(msec1,year1,
     &                doy1,month1,day1,hour1,min1,sec1)
                    isec1=int(sec1)
                    write(time,'(i4.4,5i2.2)') 
     &                year1,month1,day1,hour1,min1,isec1
c                    write(write3,*) 'wavetool -cwav -start '
                    write(write3,'(a,f6.1,a)')
     &                'wavetool -cwav -start '
     &                // time(1:seiclen(time)) 
     &     // ' -duration ',extduration,' -wav_out_file SEISAN'
c
c save time as previous trigger
c
                    ptrigger_msec=trigger_msec
                    trigger=.false.
                  endif
                endif
              endif
            endif
          enddo
   
          if (waveout) then
c
c write out sta/lta
c
            call sheads(wav_out_year,wav_out_month,
     *        wav_out_day,wav_out_hour,
     *        wav_out_min,wav_out_sec,wav_out_nchan,2,
     *        wav_out_stat(2),headtext,wav_out_stat,wav_out_comp,
     *        wav_out_nsamp,wav_out_rate,wav_out_cbyte,
     *        text,fheader,theader)
            write(66) theader              
            write(66)(int(signal2(l)),l=1,wav_out_nsamp(2))      
          endif
c
c write out phases to Nordic file
c
          call rea_event_out(write2,.true.,data,code)
        endif
9999    continue
c
c set start of next interval to read
c
        cwav_abs_start_time=cwav_abs_end_time
      enddo
      enddo ! end of loop over stations
c
c close files
c
      call sei close( close$, write1, code )
      call sei close( close$, write2, code )
      call sei close( close$, write3, code )
      call sei close( close$, write4, code )
      do sc=1,nstat
        write(*,*) ' number of triggers ',station(sc),ntriggers(sc)
      enddo

      stop
      end


      subroutine get_contdet_def(nstat,cbase,startdate,stopdate,
     &   duration,station,component,waveout,flow,fhigh,
     &   sta_duration,lta_duration,trigger_ratio,
     &   detrigger_ratio,trigger_min_dur,trigger_min_int,
     &   freeze,detalg,
     &   carlratio,carlquiet,pre_event,extduration,
     &   netwindow,netmindet,master_filename)

      implicit none
      include 'libsei.inc'
      include 'seidim.inc'

      character*80 def_file         ! file names
      integer in                    ! file unit
      integer code                  ! return code from opening def file
      integer i                     ! counter
      character*80 line             ! text line
      real var                      ! value of variables
      integer nstat                 ! station counter
      integer seiclen

      character*(*) cbase(*),startdate,stopdate,
     &  station(*),component(*),
     &  detalg
      logical waveout,freeze
      real duration,flow,fhigh,sta_duration,lta_duration
      real trigger_ratio,detrigger_ratio
      real trigger_min_int,trigger_min_dur
      real carlratio,carlquiet
      real pre_event,extduration
      real netwindow
      integer netmindet
      character*80 master_filename
      real cormin
   
c
c check for file end open
c

      def_file = 'condet.par'

      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   in,              ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   def_file )       ! For this filename.

      if(code.ne.e_ok$) then
        write(*,*) ' definition file does not exist: condet.par'
        stop
      endif
c
c init values
c
      cbase(1)=' '
      startdate=' '
      stopdate=' '
      station(1)=' '
      component(1)=' '
      waveout=.false.
      duration=0.
      sta_duration=0.
      lta_duration=0.
      trigger_ratio=10.
      detrigger_ratio=10.
      trigger_min_int=0.
      trigger_min_dur=10.
      freeze=.false.
      detalg='STA'
      carlratio=4.
      carlquiet=2.
      nstat=0  ! station counter
      pre_event=60.
      extduration=180.
      netwindow=0.
      netmindet=1
      cormin=1.
      master_filename=' '


100   continue

c
c read text line from file, check for code and set variables
c
      read(in,'(a)',end=300,err=200) line

c      if (line(1:9).eq.'CONT BASE') then
c        read(line(41:45),'(a)') cbase
      if (line(1:10).eq.'START DATE') then
        read(line(41:54),'(a)') startdate
      elseif (line(1:9).eq.'STOP DATE') then
        read(line(41:54),'(a)') stopdate
      elseif (line(1:7).eq.'STATION') then
        nstat=nstat+1
        read(line(41:45),'(a)') cbase(nstat)
        read(line(51:55),'(a)') station(nstat)
        read(line(57:60),'(a)') component(nstat)
c      elseif (line(1:9).eq.'COMPONENT') then
c        read(line(41:45),'(a)') component
      elseif (line(1:13).eq.'DET ALGORITHM') then
        read(line(41:50),'(a)') detalg
      elseif (line(1:15).eq.'MASTER WAVEFORM') then
        read(line(41:seiclen(line)),'(a)') master_filename
      elseif (line(1:7).eq.'WAVEOUT') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) waveout=.true.
      elseif (line(1:8).eq.'INTERVAL') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) duration=var
      elseif (line(1:15).eq.'CORRELATION MIN') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) cormin=var
      elseif (line(1:10).eq.'FILTER LOW') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) flow=var
      elseif (line(1:11).eq.'FILTER HIGH') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) fhigh=var
      elseif (line(1:10).eq.'STA LENGTH') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) sta_duration=var
      elseif (line(1:10).eq.'LTA LENGTH') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) lta_duration=var
      elseif (line(1:13).eq.'TRIGGER RATIO') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) trigger_ratio=var
      elseif (line(1:15).eq.'DETRIGGER RATIO') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) detrigger_ratio=var
      elseif (line(1:10).eq.'FREEZE LTA') then
        read(line(41:50),'(f10.1)') var
        if (var.eq.1.) freeze=.true.
      elseif (line(1:17).eq.'MIN TRIG DURATION') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) trigger_min_dur=var
      elseif (line(1:17).eq.'MIN TRIG INTERVAL') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) trigger_min_int=var
      elseif (line(1:10).eq.'CARL RATIO') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) carlratio=var
      elseif (line(1:10).eq.'CARL QUIET') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) carlquiet=var
      elseif (line(1:14).eq.'PRE EVENT TIME') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) pre_event=var
      elseif (line(1:14).eq.'NET WINDOW SEC') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) netwindow=var
      elseif (line(1:11).eq.'NET MIN DET') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) netmindet=int(var)
      elseif (line(1:16).eq.'EXTRACT DURATION') then
        read(line(41:50),'(f10.1)') var
        if (var.gt.0.) extduration=var
      endif

      goto 100

200   continue
      write(*,*) ' Error in condet.par file'

300   continue
      call sei close( close$, in, code )

      if (detalg(1:3).eq.'CAR') then
        trigger_ratio=0.
        detrigger_ratio=0.
        sta_duration=1.0
        lta_duration=8.0
      elseif (detalg.eq.'COR') then
        trigger_min_dur=0.
        trigger_ratio=cormin*100.
        detrigger_ratio=0.
        sta_duration=0.
        lta_duration=0.
      endif

      return
      end

      subroutine netdet(read1,write1,write3,pre_event,extduration,
     &     netwindow,netmindet)

      implicit none
      integer read1,write1,write3
      real pre_event,extduration
      real netwindow
      integer netmindet
      integer i,j,n,ind
      integer max
      parameter (max=100000)
      double precision msec(max),hmsec
      logical used(max)
      character*5 stat(max),hstat
      integer year,month,day,hour,min,sec,doy
      real rsec
      integer ndet
      character*14 time

c
c read data    
c
      n=1
10    continue
      read(read1,'(a5,1x,4x,1x,i4,5i2)',end=50) 
     &   stat(n),year,month,day,hour,min,sec
      rsec=float(sec)
      call timsec(year,month,day,hour,min,rsec,msec(n))
      used(n)=.false.
      n=n+1
      goto 10

50    continue
      n=n-1
      write(*,*) ' number of detections: ',n
c
c sort data
c
      do i=1,n-1
        ind=i
        do j=i+1,n
          if (msec(j).lt.msec(ind)) then
            ind=j
          endif
        enddo
c
c swap
c
        if (ind.gt.0) then
          hstat=stat(i)
          hmsec=msec(i)
          stat(i)=stat(ind)
          msec(i)=msec(ind)
          stat(ind)=hstat
          msec(ind)=hmsec
        endif
      enddo

c
c now check if enough different stations in time window
c
      ndet=0
      do i=1,n
c       write(25,*) ' i ',i,netwindow
        j=i+1
        ndet=0
        if (.not.used(i)) then
         ndet=1
         if (i.lt.n) then
          do while(msec(j).le.msec(i)+netwindow.and.
     &             j.le.n) ! lot 02/10/2008
c         write(25,*) ' j ',j,msec(j),msec(i)+netwindow,
c     &     msec(i)+netwindow-msec(j),ndet
            if (stat(j).ne.stat(i).and..not.used(j)) then
              ndet=ndet+1
c         write(25,*) ' j ',j,msec(j),msec(i)+netwindow,
c     &     msec(i)+netwindow-msec(j),ndet
              used(j)=.true.
              used(i)=.true.
            endif
            j=j+1
          enddo
         endif
        endif
        if (ndet.ge.netmindet) then
          hmsec=msec(i)-pre_event
          call sectim(hmsec,year,
     &           doy,month,day,hour,min,rsec)
          sec=int(rsec)
          write(time,'(i4,5i2.2)') year,month,day,hour,min,sec
          write(*,*) time,' ndet = ',ndet
c          write(write3,*) 'wavetool -cwav -start '
                    write(write3,'(a,f6.1,a)')
     &                'wavetool -cwav -start '
     &                // time 
     &     // ' -duration ',extduration,' -wav_out_file SEISAN'
        endif
      enddo
      
      return
      end

      program isfnor
c
c convert between ISF and Nordic format
c the program uses ISC library routines to read and write ISF,
c and the routines from rea.for to read and write Nordic files
c
c Lars Ottemoller, BGS, Edinburgh, UK
c 21.05.2003
c
c   changes
c
c  jun 23 2003 jh : add all1
c  jul  3 2003 lo : tested with BER 2002 data and sorted bugs
c

      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common bliock
      include 'isf_bul.h'                 ! isf header file
c
c isf write routines
c
      integer write_event_type,write_origin,write_origin_prime,
     &   write_origin_head,write_data_type,write_event_id,
     &   write_fault_plane,write_fault_plane_head,
     &   write_netmag,write_netmag_head,write_phase,
     &   write_phase_head,write_effects_head,write_effects,
     &   write_phase_info,write_phase_info_head,write_comment,
     &   write_phase_measure,write_origin_nohyp
c
c isf read routines
c
      integer read_origin_head,read_origin,read_fault_plane_head,
     &   read_axes_head,read_axes_err_head,read_netmag_head,
     &   read_effects_head,read_phase_head,read_phase_info_head,
     &   read_effects,read_netmag,read_fault_plane,read_phase,
     &   read_phase_info,read_event_id,read_phase_measure,
     &   read_origin_prime,read_origin_nohyp
 

      real dist2deg

      integer seiclen
      character*80 data(5000)             ! s-file with data in text array
      character*80 err_text               ! error text
      character*80 infile                 ! input file

      logical all,all1                    ! true: read all data, false: headers
      integer code                        ! error return code
      integer recognized                  ! return code
      integer nevent                      ! number of events in file
      integer norigin                     ! counter for origin
      integer narr                        ! counter for arrivals
      integer i,j,ind                     ! counter
      integer stdout                      ! 3 to file, 6 to screen
      logical flag,origin_flag(100),maghead_flag,hyp_flag,
     &    out_flag
      character line*(ISF_LINE_LEN*2),region*(ISF_REGION_LEN)
c
c ISF variables
c
      real sdobs,smaj,smin,sdepth,maxdist,mindist,stime,rstrike
      integer strike,ndef
      character author*(ISF_AUTHOR_LEN),error*(80),
     &    param*(80)
      character*1 loctype,antype,epifix,depfix,timfix,
     &    anytype
      integer yyyy,mm,dd,hh,mi,ss,msec,gap,nsta,numparam,doy
      real lat,lon,depth
      double precision dpsec
      character origid*(ISF_ORIGID_LEN),evid*(ISF_EVID_LEN)
      character*(ISF_ORIGID_LEN) hyp_origid(100)
      real fpstrike,fpdip,fprake
      character*(ISF_ARRID_LEN) rea_arrid(max_data)
      character sta*(ISF_STA_LEN),arrid*(ISF_ARRID_LEN),
     &    phase*(ISF_PHASE_LEN),magtype*(ISF_MAGTYPE_LEN),
     &    etype*(ISF_ETYPE_LEN),
     &    chan*(ISF_CHAN_LEN),comment*(ISF_COMM_LEN),value*(10),
     &    f_plane,f_type
      integer np,ns
      character*(1) timedef,azimdef,slowdef,
     &    sp_fm,detchar,magind,picktype
      real dist,esaz,timeres,azim,azimres,slow,slowres,amp,per,mag,snr,
     &     magerr
      character scale*(ISF_I_SCALE_LEN),mloctype*(6)
      character felt,casualties,damage,uplift,subsidence,fault,tsunami,
     &  heard
      character seiche,liquification,geyser,filter
      character landslide,sandblow,cracks,lights,modifier
      real mlat,mlon,intensity1,intensity2
      character country*(ISF_COUNTRY_LEN),postcode*(ISF_POSTCODE_LEN),
     &     net*(ISF_NET_LEN)
      character volcano,acoustic,gravity,t_wave,odours
      real filter_min,filter_max,time_unc,time_weight,
     &   azim_unc,azim_weight
      real slow_unc,slow_weight,amp_unc,per_unc,mag_unc
      character*2 mag_type

      integer choice                      ! 1: nor-isf, 2: isf-nor
      character*80 outfile

      stdout=6   ! this can be changed to 3, for output to file isfnor.log

 1    continue
      write(*,*) ' Convert (1) Nordic -> ISF or (2) ISF -> Nordic ' 
      read(5,'(i1)') choice
      if (choice.ne.1.and.choice.ne.2) goto 1

      if (choice.eq.1) outfile = 'norisf.out'
      if (choice.eq.2) outfile = 'isfnor.out'

c
c   open output file
c
      open(2,file=outfile,status='unknown')
      open(3,file='isfnor.log',status='unknown')
    
c
c   get input file name, check if exist
c

 9    continue
      write(6,*) 'Give input file'
      read(5,'(a)') infile
      if (seiclen(infile).le.0) stop
      open(1,file=infile,status='old',err=10)
      goto 11
 10   continue
      write(6,*)' No such input file'
      goto 9
 11   continue
c
      all=.true.                  ! read all parameters
      nevent=0                    ! initialize counter

      if (choice.eq.2) goto 500
c
c Nordic to ISF
c
  40  continue
      write(*,*) ' converting Noridc to ISF '
c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c
      code=write_data_type(2,'BULLETIN','','IMS1.0','')

  50  continue
c
c   read all parameters for one event form file unit 1
c
      call rea_event_in(1,all,data,code)
      write(stdout,'(a78)') data(1)(2:79)
c
c   check if end of file (code=1), if so jump out of loop
c
      if(code.eq.1) goto 1000
c
      hyp_flag=.false.
      if (hyp_lat(1).gt.-900.) hyp_flag=.true.
c      if (hyp_flag) then
        nevent=nevent+1               ! count events
        write(evid,'(i8)') nevent
c      write(stdout,*)' Number of headers and number of records',
c     *rea_nhead,rea_nrecord

        code=write_event_id(2,evid,'')
        if (code.ne.0) then
          write(stdout,'(a)') 'write_event_id: '//isf_bulletin_error
     &          (1:seiclen(isf_bulletin_error))
        endif
c      endif
      norigin=0
c
c write origin
c
      do i=1,rea_nhyp
        flag=.true.
        origin_flag(i)=.false.
        call nullify_origin(
     &       yyyy,mm,dd,hh,mi,ss,msec,
     &       timfix,stime,sdobs,
     &       lat,lon,epifix,
     &       smaj,smin,strike,
     &       depth,depfix,
     &       sdepth,ndef,nsta,gap,
     &       mindist,maxdist,antype,loctype,
     &       etype,author,origid)
        
        yyyy=hyp_year(i)
        mm=hyp_month(i)
        dd=hyp_day(i)
        hh=hyp_hour(i)
        mi=hyp_min(i)
        ss=int(hyp_sec(i))
        if (hh.eq.-999.or.mi.eq.-999) then
          if (i.eq.2) then
            hh=hyp_hour(1)
            mi=hyp_min(1)
            ss=int(hyp_sec(1))
            hyp_sec(i)=hyp_sec(1)
          else
            flag=.false.
          endif 
        endif
        if (hh.ge.24.or.mi.eq.60.or.ss.eq.60) then
          call timsec(yyyy,mm,dd,hh,mm,ss,dpsec)
          call sectim(dpsec,yyyy,doy,mm,dd,hh,mm,ss)
        endif
        msec=int(1000.*(hyp_sec(i)-int(hyp_sec(i))))
        if (hyp_rms(i).ge.0.) then
          sdobs=hyp_rms(i)
        else
          sdobs=ISF_NULL
        endif
        if (hyp_epi_flag(i).eq.'F') then
          epifix='f'  
        else
          epifix=' '  
        endif
        if (hyp_depth_flag(i).eq.'F') then
          depfix='f'  
        else
          depfix=' ' 
        endif
        if (hyp_fix_org(i).eq.'F') then
          timfix='f'  
        else
          timfix=' ' 
        endif
        if (hyp_type(i).eq.'P') then
          etype='sh'
        elseif (hyp_type(i).eq.'E') then
          etype='kh'
        endif
        author=hyp_agency(i)
        if (seiclen(author).le.0) author='unknown'
        if (i.eq.1) then
          mindist=99999.
          maxdist=0.
          if (hyp_flag) then
            do j=1,rea_nphase
              dist=dist2deg(rea_dist(j),hyp_lat(1),hyp_lon(1))
              if (dist.gt.maxdist) maxdist=dist
              if (dist.lt.mindist) mindist=dist
            enddo
          endif
          if (mindist.ge.99999..or.mindist.le.0.) mindist=ISF_NULL
          if (maxdist.le.0.) maxdist=ISF_NULL
          stime=hyp_sec_err(i)
          sdepth=hyp_depth_err(i)
          if (hyp_lon_err(i).gt.0.) then
            call xy_ellipse(hyp_lon_err(i),hyp_lat_err(i),
     &       hyp_depth_err(i),hyp_cov(1,i),hyp_cov(2,i),
     &       hyp_cov(3,i),smaj,smin,rstrike)
            strike=int(rstrike)
            if (smaj.gt.999..or.smin.gt.999) then
              smaj=ISF_NULL
              smin=ISF_NULL
              rstrike=ISF_NULL
            endif
          endif
        else
          maxdist=ISF_NULL
          mindist=ISF_NULL
          stime=ISF_NULL
          sdepth=ISF_NULL
        endif
        if (sdepth.gt.99..or.sdepth.lt.0.) sdepth=ISF_NULL
        if (stime.gt.999.) stime=ISF_NULL
        if (hyp_lat(i).eq.-999.) then
          flag=.false.
        else
          lat=hyp_lat(i)
          lon=hyp_lon(i)
          depth=hyp_depth(i)
        endif
        nsta=hyp_nstat(i)
        gap=int(hyp_gap(i))
        norigin=norigin+1
        write(origid,'(i8)') norigin
        origin_flag(i)=.true.
        if (i.eq.1) then
             code=write_origin_head(2)
             if (code.ne.0) 
     &         write(stdout,'(a)') 'write_origin_head: '//
     &           isf_bulletin_error
     &          (1:seiclen(isf_bulletin_error))
        endif
        if (flag) then
          code=write_origin(2,
     &       yyyy,mm,dd,hh,mi,ss,msec,
     &       timfix,stime,sdobs,
     &       lat,lon,epifix,
     &       smaj,smin,strike,
     &       depth,depfix,
     &       sdepth,ndef,nsta,gap,
     &       mindist,maxdist,antype,loctype,
     &       etype,author,origid)
             if (code.ne.0) 
     &       write(stdout,'(a)') 'write_origin: '//isf_bulletin_error
     &          (1:seiclen(isf_bulletin_error))
             if (norigin.eq.1) then
               code=write_origin_prime(2)
               if (code.ne.0) 
     &           write(stdout,'(a)') 'write_origin_prime: '//
     &             isf_bulletin_error(1:seiclen(isf_bulletin_error))
             endif
        else
c
c write origin line without hypocenter
c 
          code=write_origin_nohyp(2,
     &       yyyy,mm,dd,hh,mi,ss,msec,
     &       timfix,stime,sdobs,
     &       lat,lon,epifix,
     &       smaj,smin,strike,
     &       depth,depfix,
     &       sdepth,ndef,nsta,gap,
     &       mindist,maxdist,antype,loctype,
     &       etype,author,origid)
             if (code.ne.0)
     &       write(stdout,'(a)') 'write_origin_nohyp: '//
     &         isf_bulletin_error
     &          (1:seiclen(isf_bulletin_error))
             if (norigin.eq.1) then
               code=write_origin_prime(2)
               if (code.ne.0)
     &           write(stdout,'(a)') 'write_origin_prime: '//
     &             isf_bulletin_error(1:seiclen(isf_bulletin_error))
             endif
        endif
      enddo
c
c write fault plane solutions
c      
      do i=1,rea_nfault
        if (i.eq.1) code=write_fault_plane_head(2)
        read(rea_fault(i),'(1x,3f10.1)') fpstrike,fpdip,fprake
        code=write_fault_plane(2,' ',fpstrike,fpdip,
     &    fprake,ISF_NULL,ISF_NULL,' ',author)
        if (code.ne.0)
     &    write(stdout,'(a)') 'write_fault_plane: '//
     &      isf_bulletin_error(1:seiclen(isf_bulletin_error))

      enddo

c
c write magnitudes
c
      norigin=0
      maghead_flag=.false.
      do i=1,rea_nhyp
        if (origin_flag(i)) then
          norigin=norigin+1
          do j=1,6
            write(origid,'(i8)') norigin
            if (hyp_mag(j,i).ge.-900..and.
     &        seiclen(hyp_mag_type(j,i)).gt.0) then
              if (.not.maghead_flag) then
                maghead_flag=.true.
                code=write_netmag_head(2)
                if (code.ne.0) 
     &             write(stdout,'(a)') 'write_netmag_head: '//
     &             isf_bulletin_error(1:seiclen(isf_bulletin_error))
              endif
              mag_type=' '
              mag_type='M'//hyp_mag_type(j,i)
              code=write_netmag(2,mag_type,' ',
     &          hyp_mag(j,i),float(ISF_NULL),ISF_NULL,
     &          hyp_mag_agency(j,i),origid)
            endif
          enddo
        endif
      enddo

c
c write macroseismic data
c
      do i=1,rea_nmacro
        if (i.eq.1) then
          code = write_effects_head(2)
          if (code.ne.0)
     &      write(stdout,'(a)') 'write_effects_head: '//
     &        isf_bulletin_error(1:seiclen(isf_bulletin_error))
        endif
        felt='F' 
        casualties='_'
        damage='_'
        heard='_'
        if (rea_macro(i)(25:25).eq.'C') then
          casualties='C'
        elseif (rea_macro(i)(25:25).eq.'D') then
          damage='D'
        elseif (rea_macro(i)(25:25).eq.'H') then
          heard='H'
        endif
        uplift='_'
        subsidence='_'
        fault='_'
        if (rea_macro(i)(22:22).eq.'F') then
          fault='F'
        elseif (rea_macro(i)(22:22).eq.'U') then
          uplift='U'
          subsidence='S'
        elseif (rea_macro(i)(22:22).eq.'F') then
          fault='F'
          uplift='U'
          subsidence='S'
        endif
        tsunami='_'
        if (rea_macro(i)(23:23).ne.' ') then
          tsunami=rea_macro(i)(23:23)
        endif
        seiche='_'
        if (rea_macro(i)(24:24).ne.' ') then
          seiche=rea_macro(i)(24:24)
        endif
        liquification='_'
        geyser='_'
        landslide='_'
        sandblow='_'
        cracks='_'
        lights='_'
        if (rea_macro(i)(26:26).eq.'L') then
          liquification='L'
        elseif (rea_macro(i)(26:26).eq.'G') then
          geyser='G'
        elseif (rea_macro(i)(26:26).eq.'S') then
          landslide='S'
        elseif (rea_macro(i)(26:26).eq.'B') then
          sandblow='B'
        elseif (rea_macro(i)(26:26).eq.'C') then
          cracks='C'
        elseif (rea_macro(i)(26:26).eq.'V') then
          lights='V'
        endif
c        mlat=float(ISF_NULL)
c        mlon=float(ISF_NULL)
        mlat=0.
        mlon=0.
        mloctype='LatLon'
        if (rea_macro(i)(34:39).ne.'      ') then
          read(rea_macro(i)(34:47),'(f6.2,1x,f7.2)')
     &       mlat,mlon
        endif
        intensity1=float(ISF_NULL)
        if (rea_macro(i)(28:29).ne.'  ') then
          read(rea_macro(i)(28:29),'(f2.0)') intensity1
          modifier=rea_macro(i)(30:30)
          scale=rea_macro(i)(31:32)
        endif  
        if (rea_macro(i)(73:75).ne.'   ') then
          author=rea_macro(i)(73:75)
        else
          author=hyp_agency(1)
        endif
        if (seiclen(author).le.0) author='unknown'

        code = write_effects(2,heard,felt,damage,casualties,uplift,
     &     subsidence,fault,tsunami,
     &     seiche,'_','_','_',
     &     '_',liquification,geyser,landslide,sandblow,cracks,lights, 
     &     '_',mloctype,mlat,mlon,
     &     float(ISF_NULL),float(ISF_NULL),'na','na','_','_',
     &     intensity1,modifier,float(ISF_NULL),scale,author) 
          if (code.ne.0)
     &      write(stdout,'(a)') 'write_effects: '//
     &        isf_bulletin_error(1:seiclen(isf_bulletin_error))
      enddo

c
c write phases
c
c      if (hyp_flag) then  ! only if hypocenter given in 1st line
        narr=0
        author=hyp_agency(1)
        if (author.eq.' ') author='na'
        do i=1,rea_nphase
          call nullify_phase(
     &      sta,dist,esaz,phase,hh,mi,ss,msec,
     &      timeres,azim,azimres,slow,
     &      slowres,timedef,azimdef,slowdef,
     &      snr,amp,per,picktype,
     &      sp_fm,detchar,magtype,magind,mag,arrid) 
          narr=narr+1
          write(arrid,'(i8)') narr
          sta=rea_stat(i)
          if (rea_dist(i).gt.0.) then
            dist=dist2deg(rea_dist(i),hyp_lat(1),hyp_lon(1))
            if (dist.eq.0.) dist=float(ISF_NULL)
          endif
          if (rea_az(i).ge.0.) azim=rea_az(i) ! check this
c        if (rea_baz_obs(i).gt.-999.) azim=rea_baz_obs(i) ! check this
c        if (rea_baz_res(i).gt.-999.) azimres=rea_baz_res(i)
          phase=rea_phase(i)
          hh=rea_hour(i)
          mi=rea_min(i)
          ss=rea_sec(i)
          if (hh.ge.24.or.mi.eq.60.or.ss.eq.60) then
            call timsec(yyyy,mm,dd,hh,mm,ss,dpsec)
            call sectim(dpsec,yyyy,doy,mm,dd,hh,mm,ss)
          endif
          msec=int(1000.*(rea_sec(i)-int(rea_sec(i))))
          timeres=rea_res(i)
          azim=float(ISF_NULL)    ! in Nordic format back azimuth is used
          if (rea_vel(i).gt.0.) 
     &    slow=1./rea_vel(i)      ! in Nordic format app velocity
          amp=rea_amp(i)
          per=rea_per(i)
 
          if (i.eq.1) then
            code=write_phase_head(2)
            if (code.ne.0)
     &        write(stdout,'(a)') 'write_phase_head: '//
     &        isf_bulletin_error(1:seiclen(isf_bulletin_error))
          endif  
  
          code=write_phase(2,
     &      sta,dist,esaz,phase,hh,mi,ss,msec,
     &      timeres,azim,azimres,slow,
     &      slowres,timedef,azimdef,slowdef,
     &      snr,amp,per,picktype,
     &      sp_fm,detchar,magtype,magind,mag,arrid) 
            if (code.ne.0)
     &        write(stdout,'(a)') 'write_phase: '//
     &        isf_bulletin_error(1:seiclen(isf_bulletin_error))
          value=' '
          if (rea_coda(i).gt.0.) then
            write(value,'(f6.1)') rea_coda(i)
            do j=1,6
              if (value(j:j).eq.' ') value(j:j)='0'
            enddo
            code=write_phase_measure(2,'DURATION',value,' ',1)
            if (code.ne.0)
     &        write(stdout,'(a)') 'write_phase_measure: '//
     &        isf_bulletin_error(1:seiclen(isf_bulletin_error))
          endif
        enddo
c      endif ! flag
c
c write additional phase info in sub block
c
c      if (.not.hyp_flag) then
c        code=write_data_type(2,'ARRIVAL','','IMS1.0','')
c      endif
      narr=0
      do i=1,rea_nphase
        narr=narr+1
        write(arrid,'(i8)') narr
        chan='   '
        write(chan,'(a1,a1,a1)') rea_co(i)(1:1),'H',rea_co(i)(2:2)
        yyyy=hyp_year(1)
        mm=hyp_month(1)
        dd=hyp_day(1)
        if (rea_year(i).gt.0.) then
          yyyy=rea_year(i)
          mm=rea_month(i)
          dd=rea_day(i)
        endif
c        if (rea_onset(i).ne.' ') then
c          phase=rea_onset(i)//rea_phase(i)
c        else 
          phase=rea_phase(i)
c        endif
        hh=rea_hour(i)
        mi=rea_min(i)
        ss=rea_sec(i)
c
c change date if hh gt 24
c
        if (hh.ge.24) then
          call timsec(yyyy,mm,dd,hh,mm,ss,dpsec)
          call sectim(dpsec,yyyy,doy,mm,dd,hh,mm,ss)
        endif
        msec=int(1000.*(rea_sec(i)-int(rea_sec(i))))

        if (i.eq.1) then
            code=write_phase_info_head(2)
            if (code.ne.0)
     &        write(stdout,'(a)') 'write_phase_info_head: '//
     &        isf_bulletin_error(1:seiclen(isf_bulletin_error))
        endif  
        code=write_phase_info(2,' ',chan,' ',float(ISF_NULL),
     &      float(ISF_NULL),' ',yyyy,mm,dd,float(ISF_NULL),
     &      float(ISF_NULL),float(ISF_NULL),float(ISF_NULL),
     &      float(ISF_NULL),float(ISF_NULL),float(ISF_NULL),
     &      float(ISF_NULL),float(ISF_NULL),author,arrid)
      enddo

c
c   get next event
c
      goto 50
c
c     end of file
c


c
c ISF to Nordic
c
  500 continue
      write(*,*) ' converting ISF to Noridc '

      recognized=1
      out_flag=.false.
      do while (recognized.eq.1)
        read(1,'(a)',end=990) line
c       write(*,*) line
        recognized=0
c
c check for valid headers
c
        if (read_origin_head(line).eq.0) then
          write(stdout,*) ' reading origin head '
          recognized=1
          if (out_flag.eqv..true.) then
            all1=.true.
            call rea_event_out(2,all1,data,code)
            write(*,*) ' writing event ' 
          endif
          out_flag=.true.
          rea_nhyp=0
          rea_nfault=0
          rea_nmacro=0
          rea_nphase=0
          rea_ncomment=0
          do i=1,100
            do j=1,6
              hyp_mag(j,i)=-999.
            enddo
          enddo
c
c write out event, then goto next
c
        elseif (read_fault_plane_head(line).eq.0) then
          recognized=1
          write(stdout,*) ' reading fault plane head '
        elseif (read_axes_head(line).eq.0) then
          recognized=1
          write(stdout,*) ' reading axes head '
        elseif (read_axes_err_head(line).eq.0) then
          recognized=1
          write(stdout,*) ' reading axes err head '
        elseif (read_netmag_head(line).eq.0) then
          recognized=1
          write(stdout,*) ' reading netmag head '
        elseif (read_effects_head(line).eq.0) then
          recognized=1
          write(stdout,*) ' reading effects head '
        elseif (read_phase_head(line).eq.0) then
          recognized=1
          write(stdout,*) ' reading phase head '
        elseif (read_phase_info_head(line).eq.0) then
          recognized=1
          write(stdout,*) ' reading phase info head '
c
c check for valid parameter lines
c
        elseif (read_origin(line,yyyy,mm,dd,hh,mi,ss,
     &    msec,timfix,stime,sdobs,lat,lon,epifix,smaj,smin,
     &    strike,depth,depfix,sdepth,ndef,nsta,gap,
     &    mindist,maxdist,anytype,loctype,etype,
c     &    author,origid).eq.0 .or. 
     &    author,origid).eq.0) then
c     &      read_origin_nohyp(line,yyyy,mm,dd,hh,mi,ss,
c     &    msec,timfix,stime,sdobs,lat,lon,epifix,smaj,smin,
c     &    strike,depth,depfix,sdepth,ndef,nsta,gap,
c     &    mindist,maxdist,anytype,loctype,etype,
c     &    author,origid).eq.0) then

c
c extract Nordic parameters
c
          rea_nhyp=rea_nhyp+1
          call rea_hyp_clear(rea_nhyp)
          recognized=1
          write(stdout,*) ' reading origin '
          write(*,*) yyyy,mm,dd,hh,mi,ss,msec
          hyp_origid(rea_nhyp)=origid
          if (yyyy.ne.ISF_NULL) hyp_year(rea_nhyp)=yyyy
          if (mm.ne.ISF_NULL) hyp_month(rea_nhyp)=mm
          if (dd.ne.ISF_NULL) hyp_day(rea_nhyp)=dd
          if (hh.ne.ISF_NULL) hyp_hour(rea_nhyp)=hh
          if (mi.ne.ISF_NULL) hyp_min(rea_nhyp)=mi
          if (ss.ne.ISF_NULL.and.msec.ne.ISF_NULL) 
     &      hyp_sec(rea_nhyp)=float(ss)+float(msec)/1000.
          if (timfix.eq.'f') hyp_fix_org(rea_nhyp)='F'
          if (stime.ne.ISF_NULL) hyp_sec_err(rea_nhyp)=stime
          if (sdobs.ne.ISF_NULL) hyp_rms(rea_nhyp)=sdobs
          if (lat.ne.ISF_NULL) hyp_lat(rea_nhyp)=lat
          if (lon.ne.ISF_NULL) hyp_lon(rea_nhyp)=lon
          if (epifix.eq.'f') hyp_epi_flag(rea_nhyp)='F'
          if (depth.ne.ISF_NULL) hyp_depth(rea_nhyp)=depth
          if (sdepth.ne.ISF_NULL) hyp_depth_err(rea_nhyp)=sdepth
          if (depfix.eq.'f') hyp_depth_flag(rea_nhyp)='F'
          if (nsta.ne.ISF_NULL) hyp_nstat(rea_nhyp)=nsta
          if (gap.ne.ISF_NULL) hyp_gap(rea_nhyp)=float(gap)
          if (maxdist.gt.0.and.maxdist.le.3000.) then
            hyp_dist_id(rea_nhyp)='L'
          else
            hyp_dist_id(rea_nhyp)='L'
          endif
          hyp_agency(rea_nhyp)=author(1:3)
c
c create ID line
c
          if (rea_nhyp.eq.1) then
            rea_id_line=
     &' ACTION:                   OP:     STATUS:'//
     &'               ID:                   I'
            write(rea_id_line(61:74),'(i4.4,5i2.2)') yyyy,mm,dd,hh,mi,ss
          endif
c
c event id
c 
        elseif (read_event_id(line, evid, region).eq.0) then
          recognized=1
          nevent=nevent+1
c          rea_nhyp=0 ! lot 27/5/2007
          if (seiclen(region).gt.0) then
            rea_ncomment=rea_ncomment+1
            rea_comment(rea_ncomment)=
     &     '                                        '//
     &     '                                       3'
            write(rea_comment(rea_ncomment)(2:79),'(a)') region
          endif
        elseif (read_origin_prime(line).eq.0) then
          recognized=1
c
c read macroseismic effects
c
        elseif (read_effects(line,heard,felt,damage,casualties,uplift,
     &     subsidence,fault,tsunami,seiche,volcano,acoustic,gravity,
     &     t_wave,liquification,geyser,landslide,sandblow,cracks,lights,
     &     odours,loctype,lat,lon,dist,azim,country,postcode,net,
     &     sta,intensity1,modifier,intensity2,scale,author).eq.0) then

          recognized=1
          rea_nmacro=rea_nmacro+1
          rea_macro(rea_nmacro)=
     &     '                                        '//
     &     '                                       2'
          rea_macro(rea_nmacro)(23:23)=tsunami
          rea_macro(rea_nmacro)(24:24)=seiche
          if (mloctype.eq.'LatLon') then
            write(rea_macro(rea_nmacro)(34:47),'(f6.2,1x,f7.2)')
     &         mlat,mlon
          endif
          if (intensity1.ne.ISF_NULL) then
            write(rea_macro(rea_nmacro)(30:32),'(i2,a1)')
     &        int(intensity1),modifier
          endif
          write(rea_macro(rea_nmacro)(73:75),'(a3)')
     &        author

c
c read phases
c
        elseif (read_phase(line,sta,dist,esaz,phase,hh,mi,ss,msec,
     &    timeres,azim,azimres,slow,slowres,timedef,azimdef,
     &    slowdef,snr,amp,per,picktype,sp_fm,detchar,
     &    magtype,magind,mag,arrid).eq.0) then

          write(stdout,*) ' reading phase '
          recognized=1
          rea_nphase=rea_nphase+1
          rea_auto(rea_nphase)=' '
          rea_onset(rea_nphase)=' '
          rea_polarity(rea_nphase)=' '
          rea_weight_in(rea_nphase)=' '
          rea_weight_out(rea_nphase)=' '
          rea_az(rea_nphase)=-999.
          rea_baz_obs(rea_nphase)=-999.
          rea_baz_res(rea_nphase)=-999.
          rea_vel(rea_nphase)=-999.
          rea_sn(rea_nphase)=-999.
          rea_dist(rea_nphase)=-999.
          rea_arrid(rea_nphase)=arrid
          rea_stat(rea_nphase)=sta
          rea_co(rea_nphase)='  '
          if (azim.ne.ISF_NULL) rea_az(rea_nphase)=azim
          if (phase(1:1).eq.'E'.or.phase(1:1).eq.'I') then
            rea_onset(rea_nphase)=phase(1:1)
            rea_phase(rea_nphase)=phase(2:)
          else
            rea_phase(rea_nphase)=phase
          endif
          rea_hour(rea_nphase)=hh
          rea_min(rea_nphase)=mi
          rea_sec(rea_nphase)=float(ss)+float(msec)/1000.
          rea_res(rea_nphase)=timeres
          if (slow.gt.0.) rea_vel(rea_nphase)=1./slow
          rea_amp(rea_nphase)=amp
          rea_per(rea_nphase)=per
c
c read phase measure
c
       elseif (read_phase_measure(line,param,value,error,numparam)
     &    .eq.0) then
          recognized=1
          if (param.eq.'DURATION') then
            read(value,'(f6.1)') rea_coda(rea_nphase)
          endif
c
c read phase info
c
       elseif (read_phase_info(line,net,chan,filter,filter_min,
     &    filter_max,phase,yyyy,mm,dd,time_unc,time_weight,
     &    azim_unc,azim_weight,slow_unc,slow_weight,amp_unc,
     &    per_unc,mag_unc,author,arrid).eq.0) then
           
          write(stdout,*) ' reading phase info '
          recognized=1
          ind=0
          do i=1,rea_nphase
            if (arrid.eq.rea_arrid(i)) then
              ind=i
            endif
          enddo
          if (ind.gt.0) then
            rea_co(ind)(1:1)=chan(1:1)
            rea_co(ind)(2:2)=chan(3:3)
            if (yyyy.gt.0) rea_year(ind)=yyyy
            if (mm.gt.0) rea_month(ind)=mm
            if (dd.gt.0) rea_day(ind)=dd
          endif
c
c read magnitudes
c
        elseif (read_netmag(line,magtype,magind,mag,
     &            magerr,nsta,author,origid).eq.0) then
            
          write(55,*) magtype
          recognized=1
          ind=0
          do j=1,rea_nhyp
            if (origid.eq.hyp_origid(j)) ind=j
          enddo
          do j=1,6
            if (hyp_mag(j,ind).eq.-999..and.ind.gt.0) then
                hyp_mag(j,ind)=mag      
                if (magtype(1:1).eq.'M'.or.
     &            magtype(1:1).eq.'m') then
                  hyp_mag_type(j,ind)=magtype(2:)
                else
                  hyp_mag_type(j,ind)=magtype
                endif
                hyp_mag_agency(j,ind)=author
                ind=0
            endif
          enddo
c
c read fault plane solution
c
        elseif (read_fault_plane(line,f_type,fpstrike,fpdip,
     &        fprake,np,ns,f_plane,author).eq.0) then

          recognized=1
            rea_nfault=rea_nfault+1
            rea_fault(rea_nfault)=
     &       '                                        ' //
     &       '                                       F' 
            write(rea_fault(rea_nfault)(2:31),'(3f10.1)')
     &        fpstrike,fpdip,fprake
        elseif (seiclen(line).eq.0) then
c empty line
          recognized=1
        endif
        if (recognized.eq.0) then
          write(stdout,'(a)') ' following line not recognized: '
          write(stdout,'(a)') line(1:seiclen(line))
          recognized=1
        endif
      enddo
 990  continue
c
c write out last event if in memory
c
       all1=.true.
      call rea_event_out(2,all1,data,code)

 1000 continue
c
      write(6,*)            ! blank line
      close(1)
      close(2)              ! close output file
      close(3)
      write(6,*) 'Number of events in input file', nevent
      write(6,*) 'Output file name is '//outfile(1:seiclen(outfile))

      stop
      end

      real function dist2deg(distkm,lat,lon)
c
c convert distance in km to degrees      
c
      implicit none
      real distkm,lat,lon
      real pi,rad,deg,equrad,polrad,radius
      parameter (pi = 3.14159265)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (equrad = 6378.2064)
      parameter (polrad = 6356.5838)
 
      if (lat.le.-99..or.lon.le.-181) then
        dist2deg=0.
        return
      endif
      radius = (cos(lat)**2/equrad**2 +
     *sin(lat)**2/polrad**2)**(-.5)
      dist2deg=distkm/radius*deg
      return
      end
      
c
c copy of write_origin which works without hypocenter parameters
c
      integer function write_origin_nohyp(file,yyyy,mm,dd,hh,mi,ss,msec,
     + timfix,stime,sdobs,lat,lon,epifix,smaj,smin,strike,depth,
     + depfix,sdepth,ndef,nsta,gap,mindist,maxdist,antype,loctype,
     + etype,author,origid)

      integer file
      character author*(*), origid*(*), etype*(*)
      character*1 timfix, epifix, depfix, antype, loctype
      integer yyyy, mm, dd, hh, mi, ss, msec
      integer strike, ndef, nsta, gap
      real stime, sdobs, lat, lon, smaj, smin, depth, sdepth
      real mindist, maxdist

      include 'isf_bul.h'
      integer partline, check_prev_line_type, is_null, check_whole
      integer numchar
      character substr*(ISF_LINE_LEN)

c     Chars 1-10: date. Char 11: space.
      if (is_null(real(yyyy)) .eq. 1) then
          isf_bulletin_error = 'missing year'
          write_origin = 20
          return
      end if

      if (yyyy .lt. 1000 .or. yyyy .gt. 9999) then
          write (isf_bulletin_error,"('bad year ',i4)") yyyy
          write_origin = 20
          return
      end if

      if (is_null(real(mm)) .eq. 1) then
          isf_bulletin_error = 'missing month'
          write_origin = 20
          return
      end if

      if (mm .lt. 1 .or. mm .gt. 12) then
          write (isf_bulletin_error,"('bad month ',i2)") mm
          write_origin = 20
          return
      end if

      if (is_null(real(dd)) .eq. 1) then
          isf_bulletin_error = 'missing day'
          write_origin = 20
          return
      end if

      if (dd .lt. 1 .or. dd .gt. 31) then
          write (isf_bulletin_error,"('bad day ',i2)") dd
          write_origin = 20
          return
      end if
      write (file,"(i4.4,'/',i2.2,'/',i2.2,' ',$)") yyyy,mm,dd

c     Chars 12-19: time.
      if (is_null(real(hh)) .eq. 1) then
          isf_bulletin_error = 'missing year'
          write_origin = 20
          return
      end if

      if (hh .lt. 0 .or. hh .gt. 23) then
          write (isf_bulletin_error,"('bad hour ',i2)") hh
          write_origin = 20
          return
      end if

      if (is_null(real(mi)) .eq. 1) then
          isf_bulletin_error = 'missing minute'
          write_origin = 20
          return
      end if

      if (mi .lt. 0 .or. mi .gt. 59) then
          write (isf_bulletin_error,"('bad minute  ',i2)") mi
          write_origin = 20
          return
      end if

      if (is_null(real(ss)) .eq. 1) then
          isf_bulletin_error = 'missing second'
          write_origin = 20
          return
      end if

      if (ss .lt. 0 .or. ss .gt. 59) then
          write (isf_bulletin_error,"('bad second ',i2)") ss
          write_origin = 20
          return
      end if
      write (file,"(i2.2,':',i2.2,':',i2.2,$)") hh,mi,ss

c     Chars 20-22 msec - put blanks here if no msec provided.
      if (is_null(real(msec)) .eq. 1) then
          write(file,"('   ',$)")
      else
          if (msec .lt. 0 .or. msec .gt. 999) then
              write (isf_bulletin_error,"('bad msec ',i3)") msec
              write_origin = 20
              return
          end if
          write(file,"('.',i2.2,$)") msec/10
      end if

c     Char 23: fixed time flag. Char 24: space.
      if (timfix .ne. ' ' .and. timfix .ne. 'f') then
          write (isf_bulletin_error,"('bad timfix: ',a1)") timfix
          write_origin = 20
          return
      end if
      write(file,"(a1,' ',$)") timfix

c     Chars 25-29: optional origin time error. Char 30: space.
c     Give at least 2 decimal places but less if number > 99.
      write(file,"('      ',$)")

c     31-35: optional rms (sdobs). Char 36: space.
c     Give 2 decimal places but less if number > 99.
      write(file,"('      ',$)")

c     37-44: lattitude. Char 45: space.
      write (file,"('         ',$)") 

c     Chars 46-54: longitude.
      write (file,"('         ',$)") 

c     Char 55: fixed epicentre flag.
      if (epifix .ne. ' ' .and. epifix .ne. 'f') then
          write (isf_bulletin_error,"('bad epifix: ',a1)") epifix
          write_origin = 20
          return
      end if
      write(file,"(a1,$)") epifix

c     Char 56 should be a space but then can't have 5 digit smaj.
c     Chars 56-60: optional semi-major axis. Char 61: space.
c     Give 1 decimal place but less if number > 999.
      write (file,"('      ',$)")

c     Chars 62-66: optional semi-minor axis. Char 67: space.
c     Give 1 decimal place but less if number > 999.
      write (file,"('      ',$)")

c     Chars 68-70: optional strike. Char 71: space.
c     Strike can be -1, when it's a flag to signify that smaj,smin
c     are really slat,slon.
      write (file,"('    ',$)")

c     Chars 72-76: optional depth.
      write (file,"('     ',$)")

c     Char 77: fixed depth flag. Char 78: space.
      if (depfix .ne. ' ' .and. depfix .ne. 'f' .and. depfix .ne. 'd')
     +then
          write (isf_bulletin_error,"('bad depfix: ',a1)") depfix
          write_origin = 20
          return
      end if
      write(file,"(a1,' ',$)") depfix

c     Chars 79-82: optional depth error. Char 83: space.
c     Give 1 decimal place or 0 if number > 99.
      write (file,"('     ',$)")

c     Chars 84-87: optional ndef. Char 88: space.
      if (is_null(real(ndef)) .eq. 1) then
          write (file,"('     ',$)")
      else
          if (ndef .lt. 0 .or. ndef .gt. 9999) then
              write (isf_bulletin_error,"('bad ndef: ',f)") ndef
              write_origin = 20
              return
          end if
          write (file,"(i4,' ',$)") ndef
      end if

c     Chars 89-92: optional nsta. Char 93: space.
      if (is_null(real(nsta)) .eq. 1) then
          write (file,"('     ',$)")
      else
          if (nsta .lt. 0 .or. nsta .gt. 9999) then
              write (isf_bulletin_error,"('bad nsta: ',f)") nsta
              write_origin = 20
              return
          end if
          write (file,"(i4,' ',$)") nsta
      end if

c     Chars 94-96: optional gap. Char 97: space.
      write (file,"('    ',$)")

c     Chars 98-103: optional minimum distance. Char 104: space.
c     Gives 2 decimal places or less if number > 999.
      write (file,"('       ',$)")

c     Chars 105-110: optional maximum distance. Char 111: space.
c     Gives 2 decimal places or less if number > 999.
      write (file,"('       ',$)")

c     Char 112: analysis type. Char 113 space.
      if (antype .ne. ' ' .and. antype .ne. 'a' .and.
     +    antype .ne. 'm' .and. antype .ne. 'g') then

          write (isf_bulletin_error,"('bad antype: ',a1)") antype
          write_origin = 20
          return
      end if
      write(file,"(a1,' ',$)") antype

c     Char 114: location method. Char 115 space.
      if (loctype .ne. ' ' .and. loctype .ne. 'i' .and. loctype .ne.
     +    'p' .and. loctype .ne. 'g' .and. loctype .ne. 'o') then

          write (isf_bulletin_error,"('bad loctype: ',a1)") loctype
          write_origin = 20
          return
      end if
      write(file,"(a1,' ',$)") loctype

c     Chars 116-117: event type. Char 118 space.
      numchar = partline(substr,etype,0,0)
      if (numchar .eq. 0 ) then
          write(file,"('   ',$)")
      else
          if (numchar .ne. ISF_ETYPE_LEN) then
              write (isf_bulletin_error,"('bad etype: ',a)") etype
              write_origin = 20
              return
          end if
          write(file,"(a2,' ',$)") etype
      end if

c     Chars 119-127: author. Char 128: space.
      numchar = partline(substr,author,0,0)
      if (numchar .gt. ISF_AUTHOR_LEN) then
          write (isf_bulletin_error,"('author too long: ',a)") author
          write_origin = 20
          return
      end if
      if (numchar .eq. 0) then
          write (isf_bulletin_error,"('missing author')")
          write_origin = 20
          return
      end if
      if ( check_whole(author) .eq. 1 ) then
          isf_bulletin_error = 'bad author: '//author
          write_origin = 20
          return
      end if
      write(file,"(a9,' ',$)") author

c     Chars 129-136: origid.
      numchar = partline(substr,origid,0,0)
      if (numchar .gt. ISF_ORIGID_LEN) then
          write (isf_bulletin_error,"('origid too long: ',a)") origid
          write_origin = 20
          return
      end if
      if (numchar .eq. 0) then
          write (isf_bulletin_error,"('missing origid')")
          write_origin = 20
          return
      end if
      if ( check_whole(origid) .eq. 1 ) then
          isf_bulletin_error = 'bad origid: '//origid
          write_origin = 20
          return
      end if
      write(file,"(a8)") origid

c     Check that this line's type should follow the previous line's type.
      if (check_prev_line_type('origin') .ne. 0) then
          write_origin = 10
          return
      end if

      write_origin_nohyp = 0
      return
      end

c
c read origin line without hypocenter
c
      integer function read_origin_nohyp(line,yyyy,mm,dd,hh,mi,ss,msec,
     + timfix,stime,sdobs,lat,lon,epifix,smaj,smin,strike,depth,
     + depfix,sdepth,ndef,nsta,gap,mindist,maxdist,antype,loctype,
     + etype,author,origid)

      character line*(*), author*(*), origid*(*), etype*(*)
      character*1 timfix, epifix, depfix, antype, loctype
      integer yyyy, mm, dd, hh, mi, ss, msec
      integer strike, ndef, nsta, gap
      real stime, sdobs, lat, lon, smaj, smin, depth, sdepth
      real mindist, maxdist

      include 'isf_bul.h'
      integer partline, check_int, atoi, isdigit
      integer check_real,check_whole
      real ator

      character substr*(ISF_LINE_LEN)

c     Chars 1-4: year.
      if (partline(substr,line,1,4) .eq. 0) then
          isf_bulletin_error = 'missing year: '//line
          read_origin = 20
          return
      end if

      if (check_int(substr) .eq. 1) then
          isf_bulletin_error = 'bad year: '//line
          read_origin = 20
          return
      end if
      yyyy = atoi(substr)

c     Char 5: '/' character.
      if (line(5:5) .ne. '/') then
          isf_bulletin_error = 'bad date: '//line
          read_origin = 20
          return
      end if

c     Chars  6-7: month.
      if (partline(substr,line,6,2) .eq. 0) then
          isf_bulletin_error = 'missing month: '//line
          read_origin = 20
          return
      end if
      if (check_int(substr) .eq. 1) then
        isf_bulletin_error = 'bad month: '//line
          read_origin = 20
          return
      end if
      mm = atoi(substr)

c     Char 8: '/' character.
      if (line(8:8) .ne. '/') then
          isf_bulletin_error = 'bad date: '//line
         read_origin = 20
          return
      end if

c     Chars  9-10: day.
      if (partline(substr,line,9,2) .eq. 0) then
          isf_bulletin_error = 'missing day: '//line
          read_origin = 20
          return
      end if

      if (check_int(substr) .eq. 1) then
          isf_bulletin_error = 'bad day: '//line
          read_origin = 20
          return
      end if
      dd = atoi(substr)

c     Char 11: space.
      if (line(11:11) .ne. ' ') then
          isf_bulletin_error = 'bad date: '//line
          read_origin = 20
          return
      end if

c     Chars  12,13: hour.
      if (partline(substr,line,12,2) .eq. 0) then
          isf_bulletin_error = 'missing hour: '//line
          read_origin = 20
          return
      end if

      if (check_int(substr) .eq. 1) then
        isf_bulletin_error = 'bad hour: '//line
          read_origin = 20
          return
      end if
      hh = atoi(substr)

c     Char 14:  ':' character.
      if (line(14:14) .ne. ':') then
          isf_bulletin_error = 'bad date: '//line
          read_origin = 20
          return
      end if

c     Chars 15,16: minute.
      if (partline(substr,line,15,2) .eq. 0) then
          isf_bulletin_error = 'missing minute: '//line
          read_origin = 20
          return
      end if

      if (check_int(substr) .eq. 1) then
        isf_bulletin_error = 'bad minute: '//line
          read_origin = 20
          return
      end if
      mi = atoi(substr)

c     Char 17:  ':' character.
      if (line(17:17) .ne. ':') then
          isf_bulletin_error = 'bad date: '//line
          read_origin = 20
          return
      end if

c     Chars 18,19: integral second.
      if (partline(substr,line,18,2) .eq. 0) then
          isf_bulletin_error = 'missing second: '//line
          read_origin = 20
          return
      end if

      if (check_int(substr) .eq. 1) then
        isf_bulletin_error = 'bad second: '//line
          read_origin = 20
          return
      end if
      ss = atoi(substr)
c     Char 20-22: msec or spaces.
c     Allow decimal point without any numbers after it.
      if (partline(substr,line,20,3) .ne. 0) then
c       Char 20: '.' character.
          if (line(20:20) .ne. '.') then
              isf_bulletin_error = 'bad date: '//line
              read_origin = 20
              return
          end if

c       Chars 21,22: 10s of msec.
          if (isdigit(line(21:21)) .eq. 0) then
              isf_bulletin_error = 'bad date: '//line
              read_origin = 20
              return
          end if
          msec = (ichar(line(21:21)) - ichar('0'))*100

          if (isdigit(line(22:22)) .ne. 0) then
              msec = msec + (ichar(line(22:22)) - ichar('0'))*10
          else if (line(22:22) .ne. ' ' ) then
              isf_bulletin_error = 'bad msec: '//line
              read_origin = 20
              return
          end if
      else
c       Char 20: '.' character or space.
          if (line(20:20) .ne. '.' .and. line(20:20) .ne. ' ') then
              isf_bulletin_error = 'bad date: '//line
              read_origin = 20
              return
          end if
          msec = ISF_NULL
      end if

c     Char 23: timfix - either f or space.
      if (line(23:23) .eq. 'f' .or. line(23:23) .eq. ' ') then
          timfix = line(23:23)
      else
          isf_bulletin_error = 'bad timfix: '//line
          read_origin = 20
          return
      end if
c     Char 24: space.
      if (line(24:24) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 24: '//line
          read_origin = 20
          return
      end if

c     Chars 25-29: origin time error - real if anything.
      if (partline(substr,line,25,5) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad stime: '//line
              read_origin = 20
              return
          end if
          stime = ator(substr)
      else
          stime =ISF_NULL
      end if

c     Char 30: space.
      if (line(30:30) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 30: '//line
          read_origin = 20
          return
      end if

c     Chars 31-35: rms (sdobs) - real if anything.
      if (partline(substr,line,31,5) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad sdobs: '//line
              read_origin = 20
              return
          end if
          sdobs = ator(substr)
      else
          sdobs =ISF_NULL
      end if

c     Char 36: space.
      if (line(36:36) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 36: '//line
          read_origin = 20
          return
      end if
c      Chars 37-44: lattitude 
      if (partline(substr,line,37,8) .ne. 0) then
          isf_bulletin_error = 'latitude: '//line
          read_origin = 20
          return
      else
        lat = -999.
      end if


c     Char 45: space.
      if (line(45:45) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 45: '//line
          read_origin = 20
          return
      end if

c      Chars 46-54: longitude - must be there.
      if (partline(substr,line,46,9) .ne. 0) then
          isf_bulletin_error = 'longitude: '//line
          read_origin = 20
          return
      else
          lon = -999.
      end if

c     Char 55: epifix - either f or space.
      if (line(55:55) .eq. 'f' .or. line(55:55) .eq. ' ') then
          epifix = line(55:55)
      else
          isf_bulletin_error = 'bad epifix: '//line
          read_origin = 20
          return
      end if
c     Chars 56-60: semi-major axis of error ellipse - real if there.
c     This is departure from format but smaj < smin is daft.
      if (partline(substr,line,56,5) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad smaj: '//line
              read_origin = 20
              return
          end if
          smaj = ator(substr)
      else
          smaj =ISF_NULL
      end if

c     Char 61: space.
      if (line(61:61) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 61: '//line
          read_origin = 20
          return
      end if

c     Chars 62-66: semi-minor axis of error ellipse - real if there.
      if (partline(substr,line,62,5) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad smin: '//line
              read_origin = 20
              return
          end if
          smin = ator(substr)
      else
          smin =ISF_NULL
      end if

c     Char 67: space.
      if (line(67:67) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 67: '//line
          read_origin = 20
          return
      end if
c     Chars 68-70: strike - integer if there.
c     Strike can be -1, when its a flag to signify that smaj,smin
c     are really slat,slon.
      if (partline(substr,line,68,3) .ne. 0) then
          if (check_int(substr) .eq. 1) then
            isf_bulletin_error = 'bad strike: '//line
              read_origin = 20
              return
          end if
          strike = atoi(substr)
      else
          strike =ISF_NULL
      end if

c     Char 71: space.
      if (line(71:71) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 71: '//line
          read_origin = 20
          return
      end if

c     Chars 72-76: depth - real if there.
      if (partline(substr,line,72,5) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad depth: '//line
              read_origin = 20
              return
          end if
          depth = ator(substr)
      else
          depth =ISF_NULL
      end if

c     Char 77: depfix - either d,f, or space.
      if (line(77:77) .eq. 'f' .or. line(77:77) .eq. ' ' .or.
     +    line(77:77) .eq. 'd') then
          depfix = line(77:77)
      else
          isf_bulletin_error = 'bad depfix: '//line
          read_origin = 20
          return
      end if
c     Char 78: space.
      if (line(78:78) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 78: '//line
          read_origin = 20
          return
      end if

c     Chars 79-82: depth error - real if there.
      if (partline(substr,line,79,4) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad sdepth: '//line
              read_origin = 20
              return
          end if
          sdepth = ator(substr)
      else
          sdepth =ISF_NULL
      end if

c     Char 83: space.
      if (line(83:83) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 83: '//line
          read_origin = 20
          return
      end if

c     Chars 84-87: ndef - integer if there.
      if (partline(substr,line,84,4) .ne. 0) then
          if (check_int(substr) .eq. 1) then
            isf_bulletin_error = 'bad ndef: '//line
              read_origin = 20
              return
          end if
          ndef = atoi(substr)
      else
          ndef =ISF_NULL
      end if

c     Char 88: space.
      if (line(88:88) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 88: '//line
          read_origin = 20
          return
      end if
c     Chars 89-92: nsta - integer if there.
      if (partline(substr,line,89,4) .ne. 0) then
          if (check_int(substr) .eq. 1) then
            isf_bulletin_error = 'bad nsta: '//line
              read_origin = 20
              return
          end if
          nsta = atoi(substr)
      else
          nsta =ISF_NULL
      end if

c     Char 93: space.
      if (line(93:93) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 93: '//line
          read_origin = 20
          return
      end if

c     Chars 94-96: gap - integer if there.
      if (partline(substr,line,94,4) .ne. 0) then
          if (check_int(substr) .eq. 1) then
            isf_bulletin_error = 'bad gap: '//line
              read_origin = 20
              return
          end if
          gap = atoi(substr)
      else
          gap =ISF_NULL
      end if

c     Char 97: space.
      if (line(97:97) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 97: '//line
          read_origin = 20
          return
      end if
c     Chars 98-103: minimum distance - real if there.
      if (partline(substr,line,98,6) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad mindist: '//line
              read_origin = 20
              return
          end if
          mindist = ator(substr)
      else
          mindist =ISF_NULL
      end if

c     Char 104: space.
      if (line(104:104) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 104: '//line
          read_origin = 20
          return
      end if

c     Chars 105-110: maximum distance - real if there.
      if (partline(substr,line,105,6) .ne. 0) then
          if (check_real(substr) .eq. 1) then
            isf_bulletin_error = 'bad maxdist: '//line
              read_origin = 20
              return
          end if
          maxdist = ator(substr)
      else
          maxdist =ISF_NULL
      end if

c     Char 111: space.
      if (line(111:111) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 111: '//line
          read_origin = 20
          return
      end if
c     Char 112: analysis type - either space, a, m, or g.
      if (line(112:112) .eq. 'a' .or. line(112:112) .eq. 'm' .or.
     +    line(112:112) .eq. 'g' .or. line(112:112) .eq. ' ') then

          antype = line(112:112)
      else
          isf_bulletin_error = 'bad antype: '//line
          read_origin = 20
          return
      end if

c     Char 113: space.
      if (line(113:113) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 113: '//line
          read_origin = 20
          return
      end if

c     Char 114: location method - either space, i, p, g, or o.
      if (line(114:114) .eq. 'i' .or. line(114:114) .eq. 'p' .or.
     +    line(114:114) .eq. 'g' .or. line(114:114) .eq. 'o' .or.
     +    line(114:114) .eq. ' ') then

          loctype = line(114:114)
      else
          isf_bulletin_error = 'bad loctype: '//line
          read_origin = 20
          return
      end if

c     Char 115: space.
      if (line(115:115) .ne. ' ') then
          isf_bulletin_error = 'bad format, char 115: '//line
          read_origin = 20
          return
      end if

c     Chars 116-117: event type, any characters allowed but must be there
      if (partline(etype,line,116,2) .eq. 0) then
          etype = " "
      else if( len(etype) .ne. 2) then
          isf_bulletin_error = 'bad etype: '//line
          read_origin = 20
          return
      end if
c     Char 118: space.
      if (line(118:118) .ne. ' ' ) then
          isf_bulletin_error = 'bad format, char 118: '//line
          read_origin = 20
          return
      end if

c     Chars 119-127: author, any characters allowed but must be there.
      if (partline(author,line,119,9) .eq. 0) then
          isf_bulletin_error = 'missing author: '//line
          read_origin = 20
          return
      end if

      if ( check_whole(author) .eq. 1 ) then
          isf_bulletin_error = 'bad author: '//line
          read_origin = 20
          return
      end if

c     Char 128: space.
      if (line(128:128) .ne. ' ' ) then
          isf_bulletin_error = 'bad format, char 128: '//line
          read_origin = 20
          return
      end if

c     Chars 129-136: origin ID, any characters allowed but must be there.
      if (partline(origid,line,129,8) .eq. 0) then
          isf_bulletin_error = 'missing origid: '//line
          read_origin = 20
          return
      end if

      if ( check_whole(origid) .eq. 1 ) then
          isf_bulletin_error = 'bad origid: '//line
          read_origin = 20
          return
      end if

c     Check for extra characters after char 136.
      if (partline(substr,line,137,0) .ne. 0) then
          isf_bulletin_error = 'extra characters at end: '//line
          read_origin = 20
          return
      end if

      read_origin_nohyp = 0
      return
      end

c-----
c	CHANGES
c
c	10 APR 2003 - argument to etoh corrected
c	01 APR 2004 - forced wsac1 to set depmax, depmin depmin
c	07 JAN 2005 - forces bwsac and bwsac2 to delete the file before writing. This is
c			required if the file already exists and is larger than necessary
c			Check the close(UNIT,status='delete') across compilers
c       09 May 2007 lot - added error check to open statements in brsac
c        5 Oct 2007 lot - added byte sawp to brsac
c-----
	subroutine brsac (IRU,LN,name,data,swap,nerr)
c-----
c	IRU	I*4	logical unit for IO
c	LN	I*4	length of data array
c	name	C*	Name of file to be opened
c	rhdr	R*4	Real header
c	ihdr	I*4	Integer Header
c	chdr	C*	Character Header
c	data	R*4	Array of trace values
c       swap    I*4     1 for byte swapping, 0 for not
c	nerr	I*4	-1 file does not exist
c			-2 data points in file exceed dimension
c
c	NOTE IF THE BINARY FILE HAS MORE THAN LN POINTS, THEN ONLY
c	LN POINTS ARE USED
c-----
c
c  This routine reads waveform data written in SAC binary format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
c-----
	real*4 data(LN)

	logical ext

	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70),trhdr(70)
	integer*4 ihdr(40),tihdr(40)
	character*8 chdr(24)
	character*(*) name
        integer*4 swap
c-----
c  Read real and integer header blocks to find actual number
c  of waveform data points which is stored in ihdr(10).
c
c-----
	inquire(file=name,exist=ext)
	if(.not. ext)then
		ihdr(10) = 0
		nerr = -1
		return
	endif
		nerr = 0
		open (IRU,file=name,form='unformatted',
     &			access='direct',recl=440,status='old',err=999)
			read (IRU,rec=1) (rhdr(i), i=1,70),
     &					 (ihdr(i), i=1,40)
		close (IRU)
c
c swap bytes
c
                if (swap.eq.1) then
c                  write(*,*) ' swapping '
                  call swap4(40,ihdr)
                  call swap4r(70,rhdr)
                endif
c-----
c
c  Read header and waveform data blocks using recored length of 158*4=632.
c
c-----
		if(ihdr(10).gt.LN)then
			maxpts = LN
			ihdr(10) = LN
			nerr = -2
                  goto 999 ! assume not sac file
		else 
			maxpts = ihdr(10)
			nerr = 0
		endif
                if (maxpts.le.0) goto 999
		nrec=632+4*maxpts
		nread = 0
c-----
C-----
C	The true simple code is commented out. The code to work
C	with an early buggy SUNOS 4.1 FORTRAN follows
C-----
C		nrec=632+4*ihdr(10)
C		open (IRU,file=name,form='unformatted',
C     &			access='direct',recl=nrec,err=999)
C			read (IRU,rec=1) (rhdr(i), i=1,70),
C     &					 (ihdr(i), i=1,40),
C     &					 (chdr(i), i=1,24),
C     &					 (data(i), i=1,ihdr(10))
C		close (IRU)
C-----
		nrec=632+4*maxpts
		nread = 0
c-----
c	because of SUNOS Fortran problems with IO transfers 
c	more than 2048 bytes, read these  chunks in 
c----- 
		ndat = maxpts
		if(nrec.gt.2048)then
			open (IRU,file=name,form='unformatted',
     &				access='direct',recl=2048,err=999)
			ndat1 = (2048 - 632) / 4
			irec = 1
			read (IRU,rec=irec,err=998) (trhdr(i), i=1,70),
     &					 (tihdr(i), i=1,40),
     &					 (chdr(i), i=1,24),
     &					 (data(i), i=1,ndat1)
			nread = nread + ndat1
 1000			continue
			nl = nread + 1
			nh = nl + 512 - 1
			if(nh.gt.ndat)then
				nh = ndat
			endif
			if(nl.gt.ndat)go to 1001
			irec = irec + 1
			read (IRU,rec=irec,err=998) (data(i), i=nl,nh)
			nread = nread + (nh-nl+1)

			go to 1000
 1001			continue
		close (IRU)
		else
			open (IRU,file=name,form='unformatted',
     &				access='direct',recl=nrec,err=999)
			read (IRU,rec=1,err=998) (trhdr(i), i=1,70),
     &					 (tihdr(i), i=1,40),
     &					 (chdr(i), i=1,24),
     &					 (data(i), i=1,ndat)
		close (IRU)
		endif
		if(ihdr(10).gt.LN)then
			maxpts = LN
			ihdr(10) = LN
		else 
			maxpts = ihdr(10)
		endif
      if (swap.eq.1) then
        call swap4r(ndat,data)
      endif
           write(*,*) ' xxx '
      return
998   continue
		close (IRU)
999   continue 
		close (IRU)
                nerr=-1
c                write(*,*) ' not a sac binary file '
	return
	end

	subroutine brsach(IRU,name,nerr)
c-----
c	IRU	I*4	logical unit for IO
c	name	C*	Name of file to be opened
c	rhdr	R*4	Real header
c	ihdr	I*4	Integer Header
c	chdr	C*	Character Header
c	nerr	I*4	-1 file does not exist
c			-2 data points in file exceed dimension
c
c	NOTE IF THE BINARY FILE HAS MORE THAN LN POINTS, THEN ONLY
c	LN POINTS ARE USED
c-----
c
c  This routine reads waveform data written in SAC binary format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
c-----

	logical ext

	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*(*) name
c-----
c  Read real and integer header blocks to find actual number
c  of waveform data points which is stored in ihdr(10).
c
c-----
	inquire(file=name,exist=ext)
	if(.not. ext)then
		ihdr(10) = 0
		nerr = -1
		return
	endif
		nerr = 0
		open (IRU,file=name,form='unformatted',
     &			access='direct',recl=440,status='old')
			read (IRU,rec=1) (rhdr(i), i=1,70),
     &					 (ihdr(i), i=1,40)
		close (IRU)
c-----
C-----
C	The true simple code is commented out. The code to work
C	with an early buggy SUNOS 4.1 FORTRAN follows
C-----
C		nrec=632+4*ihdr(10)
C		open (IRU,file=name,form='unformatted',
C     &			access='direct',recl=nrec)
C			read (IRU,rec=1) (rhdr(i), i=1,70),
C     &					 (ihdr(i), i=1,40),
C     &					 (chdr(i), i=1,24)
C		close (IRU)
C-----
c-----
c	because of SUNOS Fortran problems with IO transfers 
c	more than 2048 bytes, read these  chunks in 
c----- 
		open (IRU,file=name,form='unformatted',
     &			access='direct',recl=nrec)
		read (IRU,rec=1) (rhdr(i), i=1,70),
     &				 (ihdr(i), i=1,40),
     &				 (chdr(i), i=1,24)
		close (IRU)
	return
	end

	subroutine arsac (IRU,LN,name,data,nerr)
c-----
c	IRU	I*4	logical unit for IO
c	LN	I*4	length of data array
c	name	C*	Name of file to be opened
c	rhdr	R*4	Real header
c	ihdr	I*4	Integer Header
c	chdr	C*	Character Header
c	data	R*4	Array of trace values
c	nerr	I*4	-1 file does not exist
c			-2 data points in file exceed dimension
c
c	NOTE IF THE BINARY FILE HAS MORE THAN LN POINTS, THEN ONLY
c	LN POINTS ARE USED
c-----
c
c  This routine reads waveform data written in SAC binary format.
c
c  This routine reads files written in SAC alpha (ASCII) format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
c-----
	logical ext
	real*4 data(LN)
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*(*) name
c-----
	inquire(file=name,exist=ext)
	if(.not. ext)then
		ihdr(10) = 0
		nerr = -1
		return
	endif
	nerr = 0
		open (IRU,file=name,status='old',access='sequential')
c----		rewind IRU
c  Read real header block.
c-----
		j1=1
		j2=5
		do 1110  i=1,14
			read (IRU,'(5g15.0)') (rhdr(j), j=j1,j2)
			j1=j1+5
			j2=j2+5
 1110		continue
c-----
c  Read integer header block.
c-----
		j1=1
		j2=5
		do 1120 i=1,8
			read (IRU,'(5i10)') (ihdr(j), j=j1,j2)
			j1=j1+5
			j2=j2+5
 1120		continue
c-----
c  Read character header block.
c-----
		j1=1
		j2=3
		do 1130 i=1,8
			read (IRU,'(3a8)') (chdr(j), j=j1,j2)
			j1=j1+3
			j2=j2+3
 1130		continue
		if(ihdr(10).gt.LN)then
			maxpts = LN
			ihdr(10) = LN
			nerr = -2
		else 
			maxpts = ihdr(10)
			nerr = 0
		endif
c-----
c  Read waveform data organized in a five columns block.
c-----
		nrow=(maxpts/5)+1
		do 1140 i=1,nrow
			l=i*5
			k=l-4
			read (IRU,'(5g15.0)') (data(j), j=k,l)
 1140		continue
		close (IRU)
		if(ihdr(10).gt.LN)then
			maxpts = LN
			ihdr(10) = LN
		else 
			maxpts = ihdr(10)
		endif
	return
	end

	subroutine arsach(IRU,name,nerr)
c-----
c	IRU	I*4	logical unit for IO
c	name	C*	Name of file to be opened
c	rhdr	R*4	Real header
c	ihdr	I*4	Integer Header
c	chdr	C*	Character Header
c	nerr	I*4	-1 file does not exist
c			-2 data points in file exceed dimension
c
c	NOTE IF THE BINARY FILE HAS MORE THAN LN POINTS, THEN ONLY
c	LN POINTS ARE USED
c-----
c
c  This routine reads waveform data written in SAC binary format.
c
c  This routine reads files written in SAC alpha (ASCII) format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
c-----
	logical ext
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*(*) name
c-----
	inquire(file=name,exist=ext)
	if(.not. ext)then
		ihdr(10) = 0
		nerr = -1
		return
	endif
	nerr = 0
		open (IRU,file=name,status='old',access='sequential')
c----		rewind IRU
c  Read real header block.
c-----
		j1=1
		j2=5
		do 1110  i=1,14
			read (IRU,'(5g15.0)') (rhdr(j), j=j1,j2)
			j1=j1+5
			j2=j2+5
 1110		continue
c-----
c  Read integer header block.
c-----
		j1=1
		j2=5
		do 1120 i=1,8
			read (IRU,'(5i10)') (ihdr(j), j=j1,j2)
			j1=j1+5
			j2=j2+5
 1120		continue
c-----
c  Read character header block.
c-----
		j1=1
		j2=3
		do 1130 i=1,8
			read (IRU,'(3a8)') (chdr(j), j=j1,j2)
			j1=j1+3
			j2=j2+3
 1130		continue
		if(ihdr(10).gt.LN)then
			maxpts = LN
			ihdr(10) = LN
			nerr = -2
		else 
			maxpts = ihdr(10)
			nerr = 0
		endif
		close (IRU)
	return
	end

	subroutine getfhv(strcmd,fval,nerr)
c-----
c	Get float header value
c
c	strcmd	C*8	String to key on
c	val	R*4	Real value returned
c	nerr	I*4	Error condition
c				0 no error
c				1336 Value not defined
c				1337 Header variable does not exist
c-----
	character strcmd*(*)
	logical streql
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	output real header
c-----
	fval = -12345.
	nerr = -1
	do 1000 i=1,70
		if(streql(strcmd,rstr(i))) then
			nerr = 0
			fval = rhdr(i)
		endif
 1000	continue
	return
	end

	subroutine getnhv(strcmd,ival,nerr)
c-----
c	Get integer header value
c
c	str	C*8	String to key on
c	ival	R*4	integer value returned
c	nerr	I*4	Error condition
c				0 no error
c				1336 Value not defined
c				1337 Header variable does not exist
c-----
	character strcmd*(*)
	logical streql
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	output integer header
c-----
	ival = -12345
	nerr = -1
	do 2000 i=1,40
		if(streql(strcmd,istr(i))) then
			nerr = 0
			ival = ihdr(i)
		endif
 2000	continue
	return
	end

	subroutine getkhv(strcmd,cval,nerr)
c-----
c	Get character header value
c
c	strcmd	C*8	String to key on
c	cval	C*8	character value returned
c	nerr	I*4	Error condition
c				0  no error
c				1336 Value not defined
c				1337 Header variable does not exist
c-----
	character strcmd*(*)
	logical streql

	character cval*8
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	output character header
c-----
	nerr = -1
	do 3000 i=1,24
		if(streql(strcmd,cstr(i))) then
			nerr = 0
			cval = chdr(i)
		endif
 3000	continue
	return
	end

	subroutine getlhv(strcmd,lval,nerr)
	character strcmd*(*)
	logical lval
	
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	input logical header
c-----
	call getnhv(strcmd,ival,nerr)
	if(ival.eq.0)then
		lval = .false.
	else
		lval = .true.
	endif
	return
	end

c---------------------------------------------------------
	subroutine bwsac (IWU,LN,name,data)
c---------------------------------------------------------

c
c  This routine writes out a waveform data in SAC binary format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character name*(*)
	real*4 data(LN)
c-----
c	remove the original file so that the output length is
c	never greater than desired. Else the dregs of the first will remain
c-----
		open (IWU,file=name,form='unformatted',
     &			access='sequential',status='unknown')
		rewind IWU
		close (IWU,status='delete')
c
c  The actual number of waveform data points is stored in integer
c  header 10. The file recored length is 158*4=632.
c
		nrec=632+4*ihdr(10)
		open (IWU,file=name,form='unformatted',
     &			access='direct',recl=nrec,status='unknown')
		rewind IWU
		write (IWU,rec=1) (rhdr(i),i=1,70),
     &				  (ihdr(k),k=1,40),
     &				  (chdr(j),j=1,24),
     &				  (data(l), l=1,ihdr(10))
		close (IWU)
	return
	end
c---------------------------------------------------------
	subroutine awsac (IWU,LN,name,data)
c---------------------------------------------------------
c
c  This routine writes out files in SAC alpha (ASCII) format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
	real*4 data(LN)
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character name*(*)
c
		open (IWU,file=name,status='unknown',
     &				 access='sequential')
		rewind IWU
c
c  Write real header block.
c
		j1=1
		j2=5
		do 1100 i=1,14
			write (IWU,'(5g15.7)') (rhdr(j), j=j1,j2)
			j1=j1+5
			j2=j2+5
 1100		continue
c
c  Write integer header block.
c
		j1=1
		j2=5
		do 1110 i=1,8
			write (IWU,'(5i10)') (ihdr(j), j=j1,j2)
			j1=j1+5
			j2=j2+5
 1110		continue
c
c  Write character header block.
c
		j1=1
		j2=3
		do 1120 i=1,8
			write (IWU,'(3a8)') (chdr(j), j=j1,j2)
			j1=j1+3
			j2=j2+3
 1120		continue
c
c  Ensure the last row is padded with zeros, if actual number of
c  waveform points is less than the product of number of rows
c  and number of columns which constitutes the data block.
c
		nrow=(ihdr(10)/5)+1
		nrc5=nrow*5
		if (nrc5 .gt. ihdr(10)) then
			nrcx=ihdr(10)+1
			do 1140 i=nrcx,nrc5
				data(i)=0.0
 1140			continue
		end if
c
c  Write waveform data in five columns format.
c
		do 1150 i=1,nrow
			k=i*5
			j=k-4
			write (IWU,'(5g15.7)') (data(l), l=j,k)
 1150		continue
		close (IWU)
	return
	end

	subroutine setfhv(strcmd,fval,nerr)
c-----
c	Set float header value
c
c	strcmd	C*8	String to key on
c	fval	C*8	real value set
c	nerr	I*4	Error condition
c				0  no error
c				1337 Header variable does not exist
c-----
	character strcmd*(*)
	logical streql
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	output real header
c-----
	do 1000 i=1,70
		if(streql(strcmd,rstr(i))) rhdr(i) = fval
 1000	continue
	return
	end

	subroutine setnhv(strcmd,ival,nerr)
c-----
c	Set integer header value
c
c	strcmd	C*8	String to key on
c	ival	C*8	integer value set
c	nerr	I*4	Error condition
c				0  no error
c				1337 Header variable does not exist
c-----
	character strcmd*(*)
	integer ival, nerr

	logical streql
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	output integer header
c-----
	do 2000 i=1,40
		if(streql(strcmd,istr(i))) ihdr(i) = ival
 2000	continue
	return
	end

	subroutine setkhv(strcmd,cval,nerr)
c-----
c	Set character header value
c
c	strcmd	C*8	String to key on
c	cval	C*8	character value set
c	nerr	I*4	Error condition
c				0  no error
c				1337 Header variable does not exist
c-----
	character strcmd*(*)
	character cval*8
	logical streql
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	output character header
c-----
	do 3000 i=1,24
		if(streql(strcmd,cstr(i))) chdr(i) = cval
 3000	continue
	return
	end


	subroutine setlhv(strcmd,lval,nerr)
	character strcmd*(*)
	logical lval
	
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	character*8 rstr(70), istr(40), cstr(24)
	data (rstr(i),i=1,45)/
     1	'DELTA   ', 'DEPMIN  ', 'DEPMAX  ', 'SCALE   ', 'ODELTA  ', 
     1	'B       ', 'E       ', 'O       ', 'A       ', 'FMT     ', 
     1	'T0      ', 'T1      ', 'T2      ', 'T3      ', 'T4      ', 
     1	'T5      ', 'T6      ', 'T7      ', 'T8      ', 'T9      ', 
     1	'F       ', 'RESP0   ', 'RESP1   ', 'RESP2   ', 'RESP3   ', 
     1	'RESP4   ', 'RESP5   ', 'RESP6   ', 'RESP7   ', 'RESP8   ', 
     1	'RESP9   ', 'STLA    ', 'STLO    ', 'STEL    ', 'STDP    ', 
     1	'EVLA    ', 'EVLO    ', 'EVEL    ', 'EVDP    ', 'FHDR40  ', 
     1	'USER0   ', 'USER1   ', 'USER2   ', 'USER3   ', 'USER4   ' /
	data (rstr(i),i=46,70)/
     1	'USER5   ', 'USER6   ', 'USER7   ', 'USER8   ', 'USER9   ', 
     1	'DIST    ', 'AZ      ', 'BAZ     ', 'GCARC   ', 'SB      ', 
     1	'SDELTA  ', 'DEPMEN  ', 'CMPAZ   ', 'CMPINC  ', 'XMINIMUM', 
     1	'XMAXIMUM', 'YMINIMUM', 'YMAXIMUM', 'ADJTM   ', 'FHDR65  ', 
     1	'FHDR66  ', 'FHDR67  ', 'FHDR68  ', 'FHDR69  ', 'FHDR70  ' /
	data istr/
     1	'NZYEAR  ', 'NZJDAY  ', 'NZHOUR  ', 'NZMIN   ', 'NZSEC   ', 
     1	'NZMSEC  ', 'NVHDR   ', 'NINF    ', 'NHST    ', 'NPTS    ', 
     1	'NSNPTS  ', 'NSN     ', 'NXSIZE  ', 'NYSIZE  ', 'NHDR15  ', 
     1	'IFTYPE  ', 'IDEP    ', 'IZTYPE  ', 'IHDR4   ', 'IINST   ', 
     1	'ISTREG  ', 'IEVREG  ', 'IEVTYP  ', 'IQUAL   ', 'ISYNTH  ', 
     1	'IDHR11  ', 'IDHR12  ', 'IDHR13  ', 'IDHR14  ', 'IDHR15  ', 
     1	'IDHR16  ', 'IDHR17  ', 'IDHR18  ', 'IDHR19  ', 'IDHR20  ', 
     1	'LEVEN   ', 'LPSPOL  ', 'LOVROK  ', 'LCALDA  ', 'LHDR5   ' /
     	data cstr/
     1	'KSTNM   ', 'KEVNM   ', 'KEVNMC  ', 'KHOLE   ', 
     1	'KO      ', 'KA      ', 'KT0     ', 'KT1     ', 
     1	'KT2     ', 'KT3     ', 'KT4     ', 'KT5     ', 
     1	'KT6     ', 'KT7     ', 'KT8     ', 'KT9     ', 
     1	'KF      ', 'KUSER0  ', 'KUSER1  ', 'KUSER2  ', 
     1	'KCMPNM  ', 'KNETWK  ', 'KDATRD  ', 'KINST   '
     1	/
c-----
c	output logical header
c-----
	if(lval)then
		call setnhv(strcmd,1,nerr)
	else
		call setnhv(strcmd,0,nerr)
	endif
	return
	end


	subroutine newhdr()
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	call inihdr()
	return
	end

	subroutine inihdr()
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)
	do 1100 i=1,70
		rhdr(i)= -12345.0
 1100	continue
	do 1110 i=1,35
		ihdr(i)= -12345
 1110	continue
	ihdr(7)=6
	ihdr(8)=0
	ihdr(9)=0
	do 1120 i=36,40
		ihdr(i)=0
 1120	continue
	do 1130 i=1,24
		chdr(i)='-12345  '
 1130	continue
	return
	end


	logical function streql(str1,str2)
	character str1*(*), str2*(*)
	character nstr1*8, nstr2*8
c-----
c	determine if two strings are equal
c-----
	nstr1 = ' '
	l1 = lgstr(str1)
	nstr1(1:l1) = str1(1:l1)
	nstr2 = ' '
	l2 = lgstr(str2)
	nstr2(1:l2) = str2(1:l2)
c-----
	if(nstr1 .eq. nstr2)then
		streql = .true.
	else
		streql = .false.
	endif
	return 
	end

	subroutine getihv(strcmd,strval,nerr)
c-----
c	Get enumerated header value
c
c	strcmd	C*8	String to key on
c	strval	C*8	real value set
c	nerr	I*4	Error condition
c			0  no error
c			1336 Header variable undefined
c			1337 Header variable does not exist
c-----
	character strcmd*(*), strval*8
	parameter (NEVAL=50)
	character*8 eval(NEVAL)
c-----
c	header integer equivalents of enumerated values
c	e.g., IDISP == 2
c-----
      data eval/'ITIME   ','IRLIM   ','IAMPH   ','IXY     ','IUNKN   ', 
     1	'IDISP   ', 'IVEL    ', 'IACC    ', 'IB      ', 'IDAY    ', 
     2	'IO      ', 'IA      ', 'IT0     ', 'IT1     ', 'IT2     ', 
     3	'IT3     ', 'IT4     ', 'IT5     ', 'IT6     ', 'IT7     ', 
     4	'IT8     ', 'IT9     ', 'IRADNV  ', 'ITANNV  ', 'IRADEV  ', 
     5	'ITANEV  ', 'INORTH  ', 'IEAST   ', 'IHORZA  ', 'IDOWN   ', 
     6	'IUP     ', 'ILLLBB  ', 'IWWSN1  ', 'IWWSN2  ', 'IHGLP   ', 
     7	'ISRO    ', 'INUCL   ', 'IPREN   ', 'IPOSTN  ', 'IQUAKE  ', 
     8	'IPREQ   ', 'IPOSTQ  ', 'ICHEM   ', 'IOTHER  ', 'IGOOD   ', 
     9	'IGLCH   ', 'IDROP   ', 'ILOWSN  ', 'IRLDTA  ', 'IVOLTS  '/
c-----
		call getnhv(strcmd,nval,nerr)
		strval = '        '
		if(nerr.eq.0)then
			if(nval.ge.1 .and. nval.le.NEVAL)then
				strval = eval(nval)
			endif
		endif
	return
	end

	subroutine setihv(strcmd,strval,nerr)
c-----
c	Set enumerated header value
c
c	strcmd	C*8	String to key on
c	strval	C*8	real value set
c	nerr	I*4	Error condition
c			0  no error
c			1336 Header variable undefined
c			1337 Header variable does not exist
c-----
	character strcmd*(*), strval*8
	parameter (NEVAL=50)
	character*8 eval(NEVAL)
	character*8 ival(NEVAL)
	logical streql
c-----
c	header integer equivalents of enumerated values
c	e.g., IDISP == 2
c-----
      data eval/'ITIME   ','IRLIM   ','IAMPH   ','IXY     ','IUNKN   ', 
     1	'IDISP   ', 'IVEL    ', 'IACC    ', 'IB      ', 'IDAY    ', 
     2	'IO      ', 'IA      ', 'IT0     ', 'IT1     ', 'IT2     ', 
     3	'IT3     ', 'IT4     ', 'IT5     ', 'IT6     ', 'IT7     ', 
     4	'IT8     ', 'IT9     ', 'IRADNV  ', 'ITANNV  ', 'IRADEV  ', 
     5	'ITANEV  ', 'INORTH  ', 'IEAST   ', 'IHORZA  ', 'IDOWN   ', 
     6	'IUP     ', 'ILLLBB  ', 'IWWSN1  ', 'IWWSN2  ', 'IHGLP   ', 
     7	'ISRO    ', 'INUCL   ', 'IPREN   ', 'IPOSTN  ', 'IQUAKE  ', 
     8	'IPREQ   ', 'IPOSTQ  ', 'ICHEM   ', 'IOTHER  ', 'IGOOD   ', 
     9	'IGLCH   ', 'IDROP   ', 'ILOWSN  ', 'IRLDTA  ', 'IVOLTS  '/
c-----
c	equivalence of header field position and enumerated value
c	e.g., IDEP can be IUNKN, IDISP, IVEL, IVOLTS or IACC
c-----
      data ival/'IFTYPE  ','IFTYPE  ','IFTYPE  ','IFTYPE  ','IDEP    ', 
     1	'IDEP    ', 'IDEP    ', 'IDEP    ', 'IZTYPE  ', 'IZTYPE  ', 
     2	'IZTYPE  ', 'IZTYPE  ', 'IZTYPE  ', 'IZTYPE  ', 'IZTYPE  ', 
     3	'IZTYPE  ', 'IZTYPE  ', 'IZTYPE  ', 'IZTYPE  ', 'IZTYPE  ', 
     4	'IZTYPE  ', 'IZTYPE  ', 'IRADNV  ', 'ITANNV  ', 'IRADEV  ', 
     5	'ITANEV  ', 'INORTH  ', 'IEAST   ', 'IHORZA  ', 'IDOWN   ', 
     6	'IUP     ', 'ILLLBB  ', 'IWWSN1  ', 'IWWSN2  ', 'IHGLP   ', 
     7	'ISRO    ', 'IEVTYP  ', 'IEVTYP  ', 'IEVTYP  ', 'IEVTYP  ', 
     8	'IEVTYP  ', 'IEVTYP  ', 'IEVTYP  ', 'IQUAL   ', 'IQUAL   ', 
     9	'IQUAL   ', 'IQUAL   ', 'IQUAL   ', 'ISYNTH  ', 'IDEP    '/

c-----
c	now do the work, parse the table for the match
c		strcmd = ival and strval = eval, then 
c		using the table index, I, 
c			do a call setnhv(strcmd,I,nerr)
c
c	However, the IUNKN is used in both IDEP and IZTYPE 
c	and IOTHER is used in both IEVTYP and IQUAL
c	
c-----
	nerr = 0
	if(streql(strcmd,'IDEP    ')
     1			.and. streql(strval,'IUNKN   '))then
		call setnhv('IDEP    ',5,nerr)
	else if(streql(strcmd,'IZTYPE  ')
     1			.and. streql(strval,'IUNKN   '))then
		call setnhv('IZTYPE  ',5,nerr)
	else if(streql(strcmd,'IEVTYP  ')
     1			.and. streql(strval,'IOTHER  '))then
		call setnhv('IEVTYP  ',44,nerr)
	else if(streql(strcmd,'IQUAL   ')
     1			.and. streql(strval,'IOTHER  '))then
		call setnhv('IQUAL   ',44,nerr)
	else
		nerr = 1336
c-----
c	IFTYPE
c-----
		do 100 i=1,NEVAL
			if(
     1				streql(strval,eval(i)))then
				call setnhv(strcmd,i,nerr)
			endif
  100	continue
	endif
	return
	end
		
	subroutine rsac1(infile,y,npts,btime,dt,maxpts,swap,nerr)
	character infile*(*)
	real y(maxpts)
	integer npts
	real btime
	real dt
	integer maxpts
        integer swap
	integer nerr
c-----
c	PURPOSE READ AN EVENLY SPACED SAC FILE
c
c	read a binary sac file with evenly sampled data
c	infile	Char	name of file
c	y	R	array of values
c	npts	I	number of points in data
c	btime	R	start time
c	dt	R	sample interval
c	maxpts	I	maximum number of points to read
c	nerr	I	error return
c-----
        common/sachdr/rhdr,ihdr,chdr
        real*4 rhdr(70)
        integer*4 ihdr(40)
        character*8 chdr(24)


	npts = maxpts
c-----
c	rad up to maxpts, indicate the number actually read
c-----
	call brsac(1,maxpts,infile,y,swap,nerr)
	call getnhv('NPTS    ',npts,ierr)
	call getfhv('DELTA   ',dt  ,ierr)
	call getfhv('B       ',btime  ,ierr)
	return
	end

	subroutine wsac0(ofile,x,y,nerr)
	character ofile*(*)
	real x(*)
	real y(*)
	integer nerr

	logical leven
c-----
c	WRITE  SAC FILE USING CURRENT HEADER VALUES
c	however we should look at the header value LEVEN
c	to decide if we should write out at x,y pairs or as
c	y values only
c
c	RBH 2000 08 31 look at the header value,
c	then do a wsac1 or a wsac2
c
c	write a binary sac file with evenly sampled data
c
c	ofile	Char	name of file
c	ydummy	R	array of values
c	y	R	array of values
c	nerr	I	error return
c-----
        common/sachdr/rhdr,ihdr,chdr
        real*4 rhdr(70)
        integer*4 ihdr(40)
        character*8 chdr(24)

	npts = ihdr(10)
c-----
c	this is wrong
c	'To write a SAC file to disk using current header values'
C	well I am forcing even spaced data
c		had to do this to kludge owens SAC
c-----
	call getlhv('LEVEN   ',leven,nerr)
	call getnhv('NPTS    ',npts,nerr)
	call getfhv('DELTA   ',dt,nerr)
	call getfhv('B       ',b ,nerr)
	if(leven)then
		call wsac1(ofile,y,npts,b,dt,nerr)
	else
		call wsac2(ofile,x,npts,y,nerr)
	endif
C	call bwsac(1,npts,ofile,y)
	nerr = 0
	return
	end

	subroutine wsac1(ofile,y,npts,btime,dt,nerr)
	character ofile*(*)
	real y(npts)
	integer npts
	real btime
	real dt
	integer nerr 
c----- 
c	PURPOSE: WRITE AN EVENLY SPACED SAC FILE
c
c	write a binary sac file with evenly sampled data
c	ofile	Char	name of file
c	y	R	array of values
c	npts	I	number of points in data
c	btime	R	start time
c	dt	R	sample interval
c	maxpts	I	maximum number of points to read
c	nerr	I	error return
c-----
        common/sachdr/rhdr,ihdr,chdr
        real*4 rhdr(70)
        integer*4 ihdr(40)
        character*8 chdr(24)
c-----
c	create a new header
c-----
C	call newhdr()
c-----
c	place essential values into the new header
c-----
	call scmxmn(y,npts,depmax,depmin,depmen)
	call setfhv('DEPMAX', depmax, ierr)
	call setfhv('DEPMIN', depmin, ierr)
	call setfhv('DEPMEN', depmen, ierr)
	call setnhv('NPTS    ',npts,nerr)
	call setfhv('DELTA   ',dt  ,nerr)
	call setfhv('B       ',btime  ,nerr)
	call setihv('IFTYPE  ','ITIME   ',nerr)
	e = btime + (npts -1 )*dt
	call setfhv('E       ',e     ,nerr)
	call setlhv('LEVEN   ',.true.,nerr)
	call setlhv('LOVROK  ',.true.,nerr)
	call setlhv('LCALDA  ',.true.,nerr)
	call bwsac(1,npts,ofile,y)
	nerr = 0
	return
	end

	subroutine wsac2(ofile,x,npts,y,nerr)
	character ofile*(*)
	real y(npts), x(npts)
	integer npts
	integer nerr 
c----- 
c	PURPOSE: WRITE AN UNEVENLY SPACED SAC FILE
c
c	write a binary sac file with evenly sampled data
c	ofile	Char	name of file
c	y	R	array of values
c	npts	I	number of points in data
c	x	R	array of independent variable
c	nerr	I	error return
c-----
        common/sachdr/rhdr,ihdr,chdr
        real*4 rhdr(70)
        integer*4 ihdr(40)
        character*8 chdr(24)
c-----
c	create a new header
c-----
	call newhdr()
c-----
c	place essential values into the new header
c-----
	call setnhv('NPTS    ',npts,nerr)
	call setihv('IFTYPE  ','ITIME   ',nerr)
	call setfhv('B       ',y(1)  ,nerr)
	call setfhv('E       ',y(npts)  ,nerr)
	call bwsac2(1,npts,ofile,x,y,npts)
	nerr = 0
	return
	end

	subroutine rsac2(ofile,x,npts,y,maxpts,nerr)
	character ofile*(*)
	real y(npts), x(npts)
	integer npts
	integer nerr 
	integer maxpts
c----- 
c	PURPOSE: WRITE AN UNEVENLY SPACED SAC FILE
c
c	write a binary sac file with evenly sampled data
c	ofile	Char	name of file
c	y	R	array of values
c	npts	I	number of points in data
c	x	R	array of independent variable
c	nerr	I	error return
c-----
        common/sachdr/rhdr,ihdr,chdr
        real*4 rhdr(70)
        integer*4 ihdr(40)
        character*8 chdr(24)
c-----
c	create a new header
c-----
	
c-----
c	place essential values into the new header
c-----
	call brsac2(1,maxpts,ofile,x,y,npts)
	nerr = 0
	return
	end

c---------------------------------------------------------
	subroutine bwsac2 (IWU,LN,name,x,y,npts)
c---------------------------------------------------------

c
c  This routine writes out a waveform data in SAC binary format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)

	character name*(*)
	real*4 x(LN)
	real*4 y(LN)
c-----
c	remove the original file so that the output length is
c	never greater than desired. Else the dregs of the first will remain
c-----
		open (IWU,file=name,form='unformatted',
     &			access='sequential',status='unknown')
		rewind IWU
		close (IWU,status='delete')
c
c  The actual number of waveform data points is stored in integer
c  header 10. The file recored length is 158*4=632.
c
		nrec=632+8*npts
		open (IWU,file=name,form='unformatted',
     &			access='direct',recl=nrec,status='unknown')
		rewind IWU
		write (IWU,rec=1) (rhdr(i),i=1,70),
     &				  (ihdr(k),k=1,40),
     &				  (chdr(j),j=1,24),
     &				  (x(l), l=1,npts),
     &				  (y(l), l=1,npts)
		close (IWU)
	return
	end
c---------------------------------------------------------
	subroutine brsac2 (IRU,LN,name,x,y,npts)
c---------------------------------------------------------
c-----
c	IRU	I*4	logical unit for IO
c	LN	I*4	length of data array
c	name	C*	Name of file to be opened
c	rhdr	R*4	Real header
c	ihdr	I*4	Integer Header
c	chdr	C*	Character Header
c	x	R*4	Array of x values
c	y	R*4	Array of y values
c	nerr	I*4	-1 file does not exist
c			-2 data points in file exceed dimension
c
c	NOTE IF THE BINARY FILE HAS MORE THAN LN POINTS, THEN ONLY
c	LN POINTS ARE USED
c-----
c
c  This routine reads waveform data written in SAC binary format.
c
c  Written by Hafidh A. A. Ghalib, 1988.
c
c-----

	logical ext

	common/sachdr/rhdr,ihdr,chdr
	real*4 rhdr(70)
	integer*4 ihdr(40)
	character*8 chdr(24)

	character*(*) name
	integer LN
	real*4 x(LN), y(LN)
	integer npts

	
c-----
c  Read real and integer header blocks to find actual number
c  of waveform data points which is stored in ihdr(10).
c
c-----
	inquire(file=name,exist=ext)
	if(.not. ext)then
		ihdr(10) = 0
		nerr = -1
		return
	endif
		nerr = 0
		open (IRU,file=name,form='unformatted',
     &			access='direct',recl=440,status='old')
			read (IRU,rec=1) (rhdr(i), i=1,70),
     &					 (ihdr(i), i=1,40)
		close (IRU)
        do i=1,70
          write(*,*) i,rhdr(i)
        enddo
        do i=1,40
          write(*,*) i,ihdr(i)
        enddo
c-----
c
c  Read header and waveform data blocks using recored length of 158*4=632.
c
c-----
		if(ihdr(10).gt.LN)then
			maxpts = LN
			ihdr(10) = LN
			nerr = -2
		else 
			maxpts = ihdr(10)
			nerr = 0
		endif
		npts = maxpts
		nrec=632+8*npts
		open (IRU,file=name,form='unformatted',
     &			access='direct',recl=nrec,status='unknown')
		rewind IRU
		read (IRU,rec=1) (rhdr(i),i=1,70),
     &				  (ihdr(k),k=1,40),
     &				  (chdr(j),j=1,24),
     &				  (x(l), l=1,npts),
     &				  (y(l), l=1,npts)
	return
	end

C	character kkdate*20
C	character kktime*20
C	ncdate = 20
C	call kadate(1998,133,ncdate,kkdate,nerr)
C	write(6,*)kkdate
C	call kadate(1998, 23,ncdate,kkdate,nerr)
C	write(6,*)kkdate
C	call kadate(1998,  3,ncdate,kkdate,nerr)
C	write(6,*)kkdate
C      call katime(23,33,43,890,12,kktime,nerr)
C	write(6,*)kktime
C      call katime( 3, 3, 3, 90,12,kktime,nerr)
C	write(6,*)kktime
C      call katime( 3, 3, 3,  0,12,kktime,nerr)
C	write(6,*)kktime
C      end

      subroutine katime(ihour,imin,isec,imsec,nctime,kktime,nerr)
*=====================================================================
* PURPOSE: To convert four integer fields representing hour, minute,
*          second, and millisecond to an alphanumeric equivalent
*          of the form:  HH:MM:SS.SSS
*=====================================================================
* INPUT ARGUMENTS:
*    IHOUR:   Integer hour field.
*    IMIN:    Integer minute field.
*    ISEC:    Integer second field.
*    IMSEC:   Integer millisecond field.
*    NCTIME:  Maximum length of output alphanumeric field.
*             NCTIME must be at least 12.
*=====================================================================
* OUTPUT ARGUMENTS:
*    KKTIME:  Equivalent alphanumeric field.
*             Set to all asterisks if an error occurs.
*    NERR:    Error flag. Set to 0 if no error occurred.
*             Potential error numbers: 0905, 0907.
*===================================================================
	integer ihour, imin, isec, imsec,nctime,nerr
	character kktime*(*)
	kktime(1:nctime) = ' '
	nerr = 0
	sec = isec + 0.001*imsec
	write(kktime,'(i2,1x,i2,1x,f6.3)')ihour, imin, sec
	kktime(3:3) = ':'
	kktime(6:6) = ':'
	do 1000 i=1,12
		if(kktime(i:i).eq.' ')kktime(i:i) = '0'
 1000	continue
	return
	end

      subroutine kadate(iyear,ijday,ncdate,kkdate,nerr)
*=====================================================================
* PURPOSE: To convert two integer fields representing year and
*          julian day to an alphanumeric equivalent
*          of the form:  MMM DD (JJJ), YYYY
*=====================================================================
* INPUT ARGUMENTS:
*    IYEAR:   Integer year field.
*    IJDAY:   Integer day field.
*    NCDATE:  Maximum length of output alphanumeric field.
*             NCDATE must be at least 18.
*=====================================================================
* OUTPUT ARGUMENTS:
*    KKDATE:  Equivalent alphanumeric date field.
*             Set to all asterisks if an error occurred.
*    NERR:    Error flag. Set to 0 if no error occurred.
*             Potential error numbers:
*=====================================================================
	integer iyear, ijday, nerr
	character kkdate*(*)
	character kmonth*4
      dimension kmonth(12)
      data kmonth/'JAN ','FEB ','MAR ','APR ','MAY ','JUN ',
     1            'JUL ','AUG ','SEP ','OCT ','NOV ','DEC '/


	nerr = 0
	call mnthdy(iyear,ijday,imonth,iday)
	kkdate(1:ncdate) = ' '
	kkdate(1:4)=kmonth(imonth)
	if(iday.gt.10)then
		write(kkdate(5:6),'(i2)')iday
	else
		kkdate(5:5) = '0'
		write(kkdate(6:6),'(i1)')iday
	endif
	kkdate(7:14)=' (   ), '
	if(ijday.gt.99)then
		write(kkdate(9:11),'(i3)')ijday
	else if(ijday.le.99 .and .ijday.ge.10)then
		kkdate(9:9) = '0'
		write(kkdate(10:11),'(i2)')ijday
	else
		kkdate(9:10)='00'
		write(kkdate(11:11),'(i1)')ijday
	endif
	
	write(kkdate(15:18),'(i4)')iyear

	return
	end

	subroutine etoh(epoch,date,str,doy,
     1		year,month,day,hour,minute,second)
	implicit none
c-----
c	convert from epoch time to human time
c
c	epoch	- R*8 time in seconds relative to 0000 1 Jan 1970
c	date	- I*4 Julian date
c	str	- C*  printable string C*32
c-----
	real*8 epoch
	integer*4 date
	character str*(*)
	integer*4 diy, doy, hour, minute, year, month
	integer*4 day
	real*4 second
	real*8 seclft
	integer i
	integer leapdy
	

	str=' '
	doy = (epoch/86400.0d+00)
	seclft = dmod(epoch, 86400.0d+00)
	hour = 0
	minute = 0
	second = 0.00
c-----
c	compute hours minutes seconds
c-----
	if(seclft .ne. 0.00d+00)then
c-----
c				before 1970 subtract and add a day
c-----
		if(seclft .lt. 0.0d+00)then
			doy = doy - 1
			seclft = seclft + 86400.00d+00
		endif
		hour = (seclft/3600.00d+00)
		seclft = dmod(seclft,3600.0d+00)
		minute = seclft/60.0d+00
		second = dmod(seclft,60.0d+00)
	endif

	if(doy .ge. 0)then
		year = 1970
 1000		continue
			diy =  leapdy(year)
			if(doy .lt. diy)go to 2000
			doy = doy - diy
			year = year + 1
		go to 1000
	else
		year = 1969
 1100		continue
			diy =  leapdy(year)
			doy = doy + diy
			if( doy .gt. 0 ) go to 2000
			year = year - 1
		go to 1100
	endif
 2000	continue
	doy = doy + 1
	date = year*1000 + doy
	call mnthdy(year,doy,month,day)
c-----
c	the minimum length of the string is 32
c-----
	write(str,110) year,doy,year,month,day,hour,minute,second
  110	format(i4,'/',i3,' ',i4,'/',i2,'/',i2,' ',i2,':',i2,':',f6.3)
c-----
c	guarantee that there are no blanks in the string str
c-----
	do 2100 i=1,32
		if(str(i:i).eq.' ')str(i:i)='0'
 2100	continue
c-----
c	except between date and time
c-----
	str( 9: 9) = ' '
	str(20:20) = ' '
	return
	end

	function leapdy(yr)
	integer*4 yr
	logical t1, t2, t3
	t1 = mod(yr,4).ne.0
	t2 = mod(yr,100).ne.0
	t3 = mod(yr,400).ne.0
	if( .not.t1 .and. t2)then
		isleap = 1
		leapdy = 366
	elseif( .not.t3)then
		isleap = 1
		leapdy = 366
	else
		isleap = 0
		leapdy = 365
	endif
	return
	end

	subroutine mnthdy(year,doy,month,day)
c-----
c	given YEAR and DOY, return MONTH and DAY
c-----
	integer*4 year, doy, month, day
	integer*4 i, dim, leap
	integer*4 dmnth(12)
	data dmnth/31,28,31,30,31,30,31,31,30,31,30,31/
	if(leapdy(year).eq.366)then
		leap = 1
	else
		leap = 0
	endif
	day = doy
	do 100 i=1,12
		month = i
		dim = dmnth(i)
		if(leap.eq.1 .and. i.eq.2)dim = dim + 1
		if(day .le.dim)goto 1000
		day = day - dim 
  100	continue
 1000	continue
	return
	end


	subroutine htoe(year,month,day,hour,minute,second,epoch)
c-----
c	convert calendar date to epoch time since January 1, 1970
c-----
c	year	- I*4	year
c	month	- I*4	month
c	day	- I*4	day
c	hour	- I*4	hour
c	minute	- I*4	minute c	second	- I*4	second
c	second	- R*4	seconds
c	epoch	- R*8	time in seconds relative to 00:00 01 Jan 1970
c-----
	integer*4 year, month, day, hour, minute, date, diy
	real*4 second
	real*8 epoch, dtoepo
	integer*4 daymon(12)
	data daymon/0, 31, 59, 90, 120, 151, 181, 212, 243, 273,
     1		304, 334/
	diy = daymon(month) + day
	if(leapdy(year).eq.366 .and. month.gt.2)diy=diy+1
	date = 1000*year + diy
c	write(6,*)'date=',date
	epoch = dtoepo(date) + hour * 3600.0d+00 + 
     1		minute * 60.0d+00 +dble(second)
	return
	end

c-----
c	convert julian date to epoch time
c-----
	function dtoepo(date)
	real*8 dtoepo
	integer*4 date, diy, cnt, days

	cnt = date / 1000
	days = 0
	if (cnt .gt. 1970)then
 1000		continue
		cnt = cnt -1
		if(cnt.lt.1970)go to 2000
			days = days + leapdy(cnt)
		go to 1000
	else if (cnt .lt. 1970)then
 1100		continue
		if(cnt.ge.1970)goto 2000
			days = days - leapdy(cnt)
			cnt = cnt + 1
		go to 1100
	endif
 2000	continue
	diy = (date -1) / 1000
	diy = (date -1 ) -  1000*diy
c	write(6,*)'days=',days,' diy=',diy
	dtoepo = (days + diy) * 86400.0d+00
	return
	end
		
	subroutine scmxmn(x,npts,depmax,depmin,depmen)
c-----
c	get extremal values of the time series
c-----
	real*4 x(*)
	real*4 depmax,depmin,depmen
	integer*4 npts
	depmax = -1.0e+38
	depmin =  1.0e+38
	sum = 0.0
	do 1000 i=1, npts
		if( x(i) .gt. depmax) depmax = x(i)
		if( x(i) .lt. depmin) depmin = x(i)
		sum = sum + x(i)
 1000	continue
	if(npts.gt.0)then
		depmen = sum / npts
	else
		depmen = -12345.
	endif
	return
	end
	

c$debug
cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
c                HYPOSUB4  version 4.0  6/98
c
cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
c changes:
c
c 6/92 (BRL) startloc has been extensively modified from version 2.0
c it now performs a regression on similar phase times at 3 or more
c different stations and converts the resulting slowness and azimuth
c into a starting location.
c All candidate starting locations now have their rms calculated
c (using the new function rmsv) and the one having the smallest
c rms is used.         

c 2/95: added ires & fixor
c june 95 by jh and bl: problem with start location, nearest station
c
c sep 98 ny jh : ------------- version 7.0 check -------------------
c                5 character station codes
c
c oct 28 1999 bmt : linux changed, save and *
c nov 19  99  jh  : v,vs,nl,parm removed from call windows, in common block
c jan             : multi model
c sep 10 2001 jh+bl: fix so a blnak phase with azimuth can be the
c                    first line
c
c aug 2002    jh+bl: fix problem of error when locating in a sequence
c
c may 2008    bl   : search for closest staion location i 4 quadrants to
c                    improve start location

c Subroutines from 'Numerical Recipes' have been added to perform
c the regressions in startloc
 
      subroutine startloc(nphase,st,phase,tp,x0,y0,xh0,xh2,nn,
     &nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,rmsmin,distind,nsol,
     &aninc,trphs,vapp,azapp,alatm,alonm,isort,data,fixdep,depthlim,
     &iflagd,ires,fixor,scorr,appar_veloc)

c**********************************************************************
c
c    find a starting location for a set of earthquake phases 
c             using azimuths and travel times
c
c              Barry R. Lienert  version 3.1 10/93
c
c    The travel times must already be matched to their station IDs
c    and coordinates (geocentric) and must each have a 4 character 
c    phase identifier PN, PG, P , SN, SG, S, L or AZ,
c    where a blank second letter means an unidentified 
c    first arrival. The arrival times/azimuths are stored in the
c    double precision array tp(i). Times must be seconds referenced
c    to a fixed datum (e.g., seconds from 1/1/1900), while azimuths
c    are in degrees, clockwise from North, measured relative to the 
c    receiver. Station latitude and longitude are in geocentric radians. 
c
c    The strategy proceeds as follows:
c
c    1. Determine the index of the phase recorded at the maximum 
c       number of stations (maxno) and its associated velocity, vv 
c       If maxno>2 perform a linear regression on the arrival times
c       with respect to their latitudes and longitudes to determine
c       the azimuth. 
c
c    2. Find the number of azimuthal phases, naz
c       Exit if maxno=0 and naz=0 (not locatable)
c       Use the azimuth data to define a starting location
c       based on intersections with other azimuths, including
c       those defined in (1).
c
c    3. Find nmp, the number of multi-phase (S-P, etc.) stations.
c       If one of these multi-phase stations has an azimuth, 
c       calculate the distance and use it to define the starting
c       location. Else, use the first two multi-phase distances to define
c       intercepts with the lines defined by any azimuth phases, or
c       by azimuths determined in (1). Then use any additional distances
c       to select one of the intercepts as a starting location.
c
c    4. Search for any refracted (N) phases, and make sure
c       that their critical distances are satisfied.
c
c   external subroutines: 
c
c   delaz (J. Lahr)         - calculates azimuth and delta between two 
c                             sets of geocentric coordinates
c   latlon (S. Bratt)       - calculates new latitude/longitude corresponding
c                              to a shift of delta along a given azimuth
c   azcros (Bratt/Williams) - calculates the intersection point of two 
c                             great circles
c
c   Changes:
c
c   May 21      J.H.: Duality in start location and test(55) = 1 accounted for
c
c   May 21, 1992  BRL: added same-phase regression to estimate azimuth,
c                      slowness and starting location
c
c                      Fixed bug in locations using multiple distances
c                      Changed logic so that dual solutions do not occur
c                      as frequently
c                      Fixed test(56) logic so <=0.0 disables starting location
c
c   Jun 19, 1992  BRL: added parameters to window which enable calls to
c                      new function rmsv, which evaluates rms at any location
c
c                      rms is now the major criterion for selecting a start
c                      location. It is evaluated for each solution, and if
c                      less than the present minimum value, rmsmin, this
c                      solution is the one saved in xh0
c

c 11/92 (BRL) changed the step size in the minimum rms search
c added a test for outliers in the "plane wave" regression
c which removes extreme outliers. Also added the alternate
c starting location xh2 for use when no convergence is
c obtained using xh0

c 10/93, BRL: removed statement numbers where possible
c             as well as making many (commented) modifications

c             used sort array 'isort' to sort arrivals in order
c             preventing input order from changing start location
c             set depth to initial xh0(3) value for all starting
c             location determinations
c     added minflag=1 to rmsv window to force minimum travel time rms
c
c 4/94: added fixdep to window: fix depth for apparent velocity starting location
c 5/94: only use depth phases when depth not fixed

c****************************************************************************

c change 10/93: added parameter statement and dimensioned
c arrays using it.
      save
      include 'hypparm.inc'
      character*5 stat,stataz,stemp
      character*5 statdp
      character*8 st1(narriv),stmax
      character*1 prm1,prm2,prm3,prm4,ucase,fixdep,fixdepn
      character*1 distinds
      double precision firstarriv,lastarriv,ttpred
      double precision sumt,sumx,sumy,sumx2,sumy2,sumxy,asl(3,3),
     &ya(3,3),c(3),cinv(3),dd,sumt2,xno,tmean,r2,xx,yy,sumxt,sumyt
      double precision sum   !added 6/98
      dimension ind1(narriv),ind2(narriv),nmp(narriv),delmp(narriv),
     &ind3(narriv,20),nmp1(narriv),indx(3),xhtr(3),
     &tdev(narriv),dpps(500)

      real usrc(2)             ! added aug 2002 by jh+bl

      pi=3.141593
      degtorad=0.0174533
      dist=0.1
      vl=test(51)
      dcrit=test(53)
      relaz=0.0
      rmsmin=9999.
      iulst1=0                  
      imatch=1       
      fixdepn=' '

c 5/94 BRL: only use depth phases if depth not fixed
c 6/95 BRL: also only if test(89)>0

      if(fixdep.ne.'F'.and.test(89).gt.0.0)then
      
c added depth phases 1/94 BRL

       sumdepth=0.0
       kdd=0
       statdp='     '

       do i=1,nphase
        if(st(i).ne.statdp.and.phase(i)(1:1).eq.'p'
     &   .and.dtwt(i).gt.0.0)then
         statdp=st(i)
         i1=i
         i2=i1-1
         ifound=0
          if(i2.gt.0)then
           stemp=st(i2)
          else
           stemp='     ' 
          endif 
          do while (statdp.eq.stemp.and.i2.ge.1)
           if(phase(i1)(2:4).eq.phase(i2)(1:3))then
             dppp=sngl(tp(i1)-tp(i2))*test(68)
             write(iulst,'(1x,a4,1x,a4,''-'',a4,f7.1,'' km'')')
     &        st(i),phase(i1),phase(i2),dppp
             if(dppp.gt.0.0)then
               sumdepth=sumdepth+dppp
               kdd=kdd+1
               dpps(kdd)=dppp          
             endif
           endif
           i2=i2-1
           if(i2.gt.0)then
            stemp=st(i2)
           else
            stemp='     '
           endif  
           ifound=1
          enddo
         if(ifound.eq.0)then
           i2=i1+1
           do while (statdp.eq.st(i2).and.i2.le.nphase)
             if(phase(i1)(2:4).eq.phase(i2)(1:3))then
               dppp=sngl(tp(i1)-tp(i2))*test(68)
               if(dppp.gt.0.0)then
                 sumdepth=sumdepth+dppp
                 kdd=kdd+1           
                 dpps(kdd)=dppp
               endif
             endif
             i2=i2+1
           enddo
         endif
        endif
       enddo

c change 11/94: minimum of 3 depth phases needed
c 6/98: changed to >test(103) depth phases
       if(kdd.gt.test(103)-1.)then                         
       
         startdp=sumdepth/float(kdd) 

c change 3/94 to exclude severe outliers         
         ddrms=0.0
         if(kdd.gt.test(103)-1.)then
          do k=1,kdd
           ddrms=ddrms+(dpps(k)-startdp)**2
          enddo
          ddrms=sqrt(ddrms/float(kdd))
c         write(iulst,*)' ddrms=',ddrms,startdp 
          sumdepth=0.0
          kd1=0
          do k=1,kdd         
c          write(iulst,*)dpps(k)
           if(abs(dpps(k)-startdp).lt.2.*ddrms)then
            kd1=kd1+1
            sumdepth=sumdepth+dpps(k)
           endif
          enddo
          if(kd1.gt.1)then
           startdp=sumdepth/float(kd1)  
          else
           kd1=kdd
          endif  
         else
          kd1=kdd
         endif
          
c 4/94: limit start depth to test(70)
         if(startdp.gt.test(70))startdp=test(70)
         
         if(iulst.gt.0.and.(.not.multi_model))
     *   write(iulst,'(/i3,'' Depth phases used: '',
     &    ''depth = '',f6.1,'' km''/)')kd1,startdp
         xh0(3)=startdp
       endif
      endif
      
c 10/93: use minimum travel time for rms calculations
      minflag=0
      stdp=xh0(3)
c      if(test(40).eq.0.0)stdp=xh0(3)-float(maxelv)*.001
      if(.not.multi_model)
     *write(iulst,'('' Starting location depth = '',f7.1,'' km'')')
     &stdp
      xhtr(3)=xh0(3)
      xh2(3)=xh0(3)
        
c  nsol is the number of solutions found - ranges from 0 to 2
      nsol=0

c      read(33,3278)latt,xlatt,lont,xlont
c3278  format(18x,i2,1x,f5.2,2x,i2,1x,f5.2)
c      write(iulst,*)latt,xlatt,lont,xlont
c      call fold(ytheor,xtheor,latt,'N',xlatt,lont,'W',xlont)

c change 10/93: find the number of PS phases, npsphase
      npsphase=0
      do i=1,nphase
       if(ips(i).eq.1.and.dtwt(i).ne.0.0)npsphase=npsphase+1
      end do

c **********  1. find the number of  multi-station phases, nphs ******

c  zero  counters
      do i=1,nphase               
c         write(iulst,'(a8,2i3,f6.3)')phase(i),ip(i),ips(i),dtwt(i)
         ind1(i)=0
         ind2(i)=0
      end do
      k=0
      nphs=0

c   bump the phase index
30    k=k+1

c   check for azimuths and last phase
      if(k.le.nphase)then

c 1/95: exclude depth phases
c  don't count azimuths, zero weight phases, PS phases or depth phases
        if(phase(k)(1:1).eq.'p')go to 30
        if(phase(k)(1:1).eq.'s')go to 30
        if(phase(k)(1:2).eq.'AZ')go to 30
        if(phase(k)(1:4).eq.'    ')go to 30 !added 6/98
        if(ucase(phase(k)(2:2)).eq.'X')go to 30
        if(dtwt(k).le.0.0)go to 30    !change 6/98
c 10/94: exclude  difference phases
        if(ip(k).eq.9.or.ips(k).eq.1)go to 30

c   do we already have this phase ?
        do i=1,nphs
c         write(iulst,'(2i3,2a8)')k,i,phase(k),st1(i)
c allow 4th letter of phase (PKPa, PKPb, etc) to be matched with a blank
          if(phase(k)(1:3).eq.st1(i)(1:3).and.(phase(k)(4:4).eq.' '.or.
     &    st1(i)(4:4).eq.' '.or.phase(k)(4:4).eq.st1(i)(4:4))
     &    )then
c   Yes:  bump its multi-station counter and get another
            ind1(i)=ind1(i)+1
            go to 30         
c           endif                   
           
          endif
        end do

c   No: bump the  phase count, store phase ID 
c       in st1 and get another phase
        nphs=nphs+1
        st1(nphs)=phase(k)
        go to 30

      endif

c   now find their associated apparent velocity, vv
      maxno=0
      maxind=0
      n1=nmoho
      if(n1.le.0.or.n1.gt.nl)n1=1

      do i=1,nphs
c        write(iulst,*)'phase,ind1,maxno: ',st1(i),ind1(i),maxno
        if(ind1(i).gt.maxno)then
          vv=0.0
          if(ucase(st1(i)(1:1)).eq.'P')vv=v(n1)
          if(ucase(st1(i)(1:1)).eq.'S')vv=vs(n1)

c 1/95: added Pg & Sg
          if(st1(i)(1:2).eq.'PG'.or.st1(i)(1:2).eq.'Pg')vv=v(1)
          if(st1(i)(1:2).eq.'SG'.or.st1(i)(1:2).eq.'Sg')vv=vs(1)
          
          if(st1(i)(1:1).eq.'L')vv=vl
          if(vv.gt.0)then
            maxind=i

c 10/94: removed +1
            maxno=ind1(i)+1

            vv=vv*1.5
          endif
        endif
c        write(iulst,*)st1(i)
      end do

      stmax='xxxx'
      if(maxind.gt.0)stmax=st1(maxind)

      i1=0
      i2=0                        
      firstarriv=1.d99
      lastarriv=-1.d99
      
      do i=1,nphase
c------------------------------------------------------------
c change 10/93: exclude PS differences
        if(dtwt(i).ne.0.0.and.ip(i).ne.9.and.ips(i).ne.1)then
c------------------------------------------------------------
          if(phase(i)(1:4).eq.stmax(1:4).and.maxind.gt.0)then
            if(tp(i).gt.lastarriv)then
              i2=i
              lastarriv=tp(i)
            endif
c 6/95 BRL: exclude invalid phases            
            if(tp(i).lt.firstarriv.and.dtwt(i).gt.0.)then
              i1=i
              firstarriv=tp(i)
            endif
          endif
        endif
      end do

c  coordinates of nearest station
c      write(16,*)'i1,i2',i1,i2
      if(i1.eq.0)i1=1
      if(i2.eq.0)i2=1
c
c
c 5/8/2008 changed to test closest station +/- 0.15 km in lat and long and
c take minimum rms solution. Occasionally a minimum rms was found in the first quadrant
c that subsequent iterations could not get away from
      do kkk=1,4
       if(kkk.eq.1)then
        xhtr(1)=x0(i1)+0.00135
        xhtr(2)=y0(i1)+0.00135
       endif
       if(kkk.eq.2)then
        xhtr(1)=x0(i1)+0.00135
        xhtr(2)=y0(i1)-0.00135
       endif
       if(kkk.eq.3)then
        xhtr(1)=x0(i1)-0.00135
        xhtr(2)=y0(i1)+0.00135
       endif
       if(kkk.eq.4)then
        xhtr(1)=x0(i1)-0.00135
        xhtr(2)=y0(i1)-0.00135
       endif
c need to reset ips(i)=0 for 1st call to rmsv
c      do i=1,nphase
c        ips(i)=0
c      end do

      rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,nmoho,
     &nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
     &trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,scorr)

c      rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,nl,ndata,v,vs,nmoho,
c    &  nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,parm,test,dtwt,dtw1,
c    &  tpc1,dl,ielv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
c    &  trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,scorr)

c changed 4/94 to not set rmsmin=rms if 'N' phase
       if(ucase(phase(i1)(2:2)).ne.'N')rmsmin=rms

       xh0(1)=xhtr(1)
       xh0(2)=xhtr(2)
       nsol=1

       if(iulst.gt.0)then
        write(iulst,'('' Starting location .15 km from '',
     &  ''closest station: '',5x,3f8.2)')xhtr(2)/degtorad,
     &   xhtr(1)/degtorad
         write(iulst,'('' rms = '',f8.2)')rms
       endif
      end do

c  use closest station solution if test(56) <= 0 (changed so 0 disables 6/94)
      if(test(56).le.0.0)then
c        xh0(1)=x0(i1)+0.00135
c        xh0(2)=y0(i1)+0.00135
        xh0(1)=xhtr(1)
        xh0(2)=xhtr(2)
        nsol=1
        return
      endif              
      

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc barry cccc
c first try .15 km from closest station 
c     i1=isort(i1) ! thsi line was causing problems to use nearest station
c                  ! comment from barry june 95
c     xhtr(1)=x0(i1)+0.00135
c     xhtr(2)=y0(i1)+0.00135
c     
c need to reset ips(i)=0 for 1st call to rmsv
c      do i=1,nphase
c        ips(i)=0
c      end do

c     call depset(xhtr(3),usrc)   ! added aug 2002 by jh+bl

c     rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,nmoho,
c    &nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
c    &tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
c    &trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,scorr)




c changed 4/94 to not set rmsmin=rms if 'N' phase
c     if(ucase(phase(i1)(2:2)).ne.'N'.and.distind.ne.'D'
c    & .and.ndata.gt.2)rmsmin=rms

c     xh0(1)=xhtr(1)
c     xh0(2)=xhtr(2)
c     nsol=1    
c     

c     if(iulst.gt.0.and.(.not.multi_model))then
c       write(iulst,'('' Starting location .15 km from '',
c    &  ''closest station: '',5x,3f8.2)')xhtr(2)/degtorad,
c    &   xhtr(1)/degtorad
c        write(iulst,'('' rms = '',f8.2)')rms
c     endif

c  use it if test(56) <= 0 (changed so 0 disables 6/94)
c     if(test(56).le.0.0)then
c       xh0(1)=x0(i1)+0.00135
c       xh0(2)=y0(i1)+0.00135
c       nsol=1
c       return
c     endif              
c     
ccccccccccccccccccccccccccccccccccccccccc barry cccccccccccccccccccccccccccc
c*************** 1.  common phase station section ********************

      if(maxno.gt.1)then

c   find the mean position (slonm,slatm) of the maximum common-phase stations
        sumlat=0.0
        sumlon=0.0
        icnt=0             

c 1/95: find first common phase arrival
        firstarriv=1.d99
        icpfirst=0
        
        do  i=1,nphase
c          write(iulst,*)st(i),x0(i)/degtorad,y0(i)/degtorad

c changed 10/93 to exclude PS phases
          if(dtwt(i).ne.0.0.and.ips(i).ne.1.and.ip(i).ne.9)then
            if(phase(i)(1:4).eq.stmax(1:4).and.maxind.gt.0)then
              if(tp(i).lt.firstarriv)then
               firstarriv=tp(i)
               icpfirst=i
              endif 
              icnt=icnt+1
              sumlat=sumlat+y0(i)
              xsave=x0(i)
              if(xsave.gt.pi)xsave=xsave-2*pi
              sumlon=sumlon+xsave
            endif
          endif  
        end do     

c        write(iulst,*)' maxno,icnt ',maxno,icnt
        slatm=sumlat/float(maxno)
        slonm=sumlon/float(maxno)
c        write(iulst,*)maxno,slonm/degtorad,slatm/degtorad
        if(iulst.gt.0.and.(.not.multi_model))then
          write(iulst,'(/'' maximum multi-station phase: '',a4,i8/)')
     &    st1(maxind),maxno
        endif

c 1/95: Find common phase having maximum delta/abs(tp(i)-tp(icpfirst))
        dllmax=0.0
        do  i=1,nphase 
          if(dtwt(i).ne.0.0.and.ips(i).ne.1.and.ip(i).ne.9)then
c 6/98 BRL: exclude PKP if test(90)=0.0        
            if((phase(i)(1:4).eq.stmax(1:4).or.(stmax(1:1).eq.'P'
     &      .and.phase(i)(1:3).eq.'PKP'.and.test(90).gt.0.0))
     &      .and.maxind.gt.0.and.st(i).ne.st(icpfirst))then
              call delaz(y0(icpfirst),x0(icpfirst),delstat,dedeg,
     &        azstat,y0(i),x0(i))
              deltt=abs(sngl(tp(i)-tp(icpfirst)))
              if(deltt.eq.0.0)deltt=1.0
              dll=dedeg/sqrt(deltt)
c              write(iulst,*)x0(i)/degtorad,y0(i)/degtorad,dll,dedeg
              if(dll.gt.dllmax)then
               dllmax=dll     
               azmax=azstat
               dedegmx=dedeg*.5
               imaxx=i
              endif 
            endif
          endif  
        end do               
c        write(*,*)st(imaxx),x0(imaxx)/degtorad,y0(imaxx)/degtorad

c now find the midpoint between the icpfirst and dlmax station
        if (imaxx.gt.0)then       !condition added 6/98 BRL      
         call latlon(y0(imaxx)/degtorad,x0(imaxx)/degtorad,
     &   dedegmx,azmax,alata,alona)
c        write(*,*)alona,alata
        
c and try it as a start location
         xhtr(1)=alona*degtorad
         xhtr(2)=alata*degtorad
      
         rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,nmoho,
     &   nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &   tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
     &   trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,
     &   scorr)

         if(rms.lt.0.0.and.ndata.gt.2)then
          rmsmin=rms
          xh0(1)=xhtr(1)
          xh0(2)=xhtr(2)
          nsol=1

          if(iulst.gt.0.and.(.not.multi_model))then
           write(iulst,'('' Starting location from midpoint of'',
     &     '' two most distant stations: '',5x,3f8.2)')xhtr(2)/degtorad,
     &      xhtr(1)/degtorad
           write(iulst,'('' rms = '',f8.2)')rms
          endif
         endif 
        endif
      endif

c 10/94: moved ntime=0 to above 1799 - was causing infinite loop
      ntime=0
1799  continue

      if(maxno.gt.2)then

c  perform linear regressions on the x and y coordinates to
c  obtain apparent azimuth and apparent velocity, vappar
        sumt=0
        sumt2=0.0
        sumx=0.0
        sumy=0.0
        sumxt=0.0
        sumyt=0.0
        sumx2=0.0
        sumy2=0.0
        sumxy=0.0

        do i=1,nphase
          if(dtwt(i).ne.0.0.and.ip(i).ne.9.and.ips(i).ne.1)then
            if(phase(i)(1:3).eq.stmax(1:3).and.maxind.gt.0)then
              call delaz(y0(i),x0(i),delstat,dedeg,azstat,slatm,
     @        slonm)
              xx=delstat*sin(azstat*degtorad)
              yy=delstat*cos(azstat*degtorad)
              ttt=tp(i)-tp(i1)
c              write(iulst,*)st(i),phase(i),azstat,xx,yy,ttt
              sumt=sumt+ttt
              sumt2=sumt2+ttt*ttt
              sumx=sumx+xx
              sumy=sumy+yy
              sumx2=sumx2+xx*xx
              sumy2=sumy2+yy*yy
              sumxt=sumxt+xx*ttt
              sumyt=sumyt+yy*ttt
              sumxy=sumxy+xx*yy
            endif
          endif
        end do

        asl(1,1)=float(maxno)
        asl(1,2)=sumx
        asl(2,1)=asl(1,2)
        asl(1,3)=sumy
        asl(3,1)=asl(1,3)
        asl(2,2)=sumx2
        asl(2,3)=sumxy
        asl(3,2)=asl(2,3)
        asl(3,3)=sumy2
        c(1)=sumt
        c(2)=sumxt
        c(3)=sumyt

        do i=1,3
          do j=1,3
            ya(i,j)=0.
          end do
          ya(i,i)=1.
        end do

        call ludcmp(asl,3,3,indx,dd)

        do j=1,3
          call lubksb(asl,3,3,indx,ya(1,j))
        end do

        do i=1,3
          cinv(i)=0.0
          do j=1,3
            cinv(i)=cinv(i)+ya(i,j)*c(j)
          end do
        end do

        xno=dfloat(maxno)
        tmean=sumt/xno
        r2=xno*cinv(1)**2+(cinv(2)**2)*sumx2+(cinv(3)**2)*sumy2
     &  +2.*cinv(1)*cinv(2)*sumx+2.*cinv(1)*cinv(3)
     &  *sumy+2.*cinv(2)*cinv(3)*sumxy-2.*tmean*xno*cinv(1)-2.*tmean*
     &  cinv(2)*sumx-2.*tmean*cinv(3)*sumy+xno*tmean**2

        if(sumt2.ne.xno*tmean**2)then
          r2=r2/(sumt2-xno*tmean**2)
        endif

c section added 11/19/92 (BRL) to find and remove outliers in this
c regression
c 7/94: exclude local events                            
        if(ntime.eq.0.and.distind.ne.'L')then
          sum=0.0
          nsum=0
          do i=1,nphase
            if(dtwt(i).ne.0.0.and.ip(i).ne.9.and.ips(i).ne.1)then
              if(phase(i)(1:3).eq.stmax(1:3).and.maxind.gt.0)then
                call delaz(y0(i),x0(i),delstat,dedeg,azstat,slatm,
     @          slonm)
                xx=delstat*sin(azstat*degtorad)
                yy=delstat*cos(azstat*degtorad)
                ttt=tp(i)-tp(i1)
                ttpred=cinv(1)+cinv(2)*xx+cinv(3)*yy
                tdev(i)=sngl(ttt-ttpred)
                nsum=nsum+1
                sum=sum+tdev(i)*tdev(i)
c               write(iulst,*)st(i),ttt,ttpred
              endif
            endif
          end do

          trms=sngl(dsqrt(sum/float(nsum)))  !changed 6/98
c         write(iulst,*)'trms = ',trms
          noutl=0
  
          do i=1,nphase
            if(dtwt(i).ne.0.0.and.ip(i).ne.9.and.ips(i).ne.1)then
c             write(iulst,*)tdev(i)
              if(phase(i)(1:3).eq.stmax(1:3).and.maxind.gt.0)then

c change 10/93: made test(61)*trms the criterion instead of 2.0*trms
c setting test(61)=0.0 disables any outlier rejection here
                if(abs(tdev(i)).gt.trms*test(61).and.test(61)
     &          .gt.0.0)then

                  write(*,*)st(i),phase(i),' removed: Apparent',
     &            ' velocity deviation = ',tdev(i)
                  write(iulst,*)st(i),phase(i),' removed: Apparent',
     &            ' velocity deviation = ',tdev(i)
                  write(iulst,*)
                  dtwt(i)=0.0
                  noutl=noutl+1
                  maxno=maxno-1
                endif
              endif
            endif
          end do

        endif

        ntime=ntime+1

c repeat the regression once with the outlier removed
        if(noutl.gt.0.and.ntime.eq.1.and.maxno.ge.2)go to 1799
c        write(iulst,*)' regression R2 = ',r2
c        write(iulst,*)'slopex,slopey,R2: ',cinv(1),cinv(2),cinv(3),r2
        denom=sqrt(cinv(2)**2+cinv(3)**2)
        vappar=0.0
        azm1=0.0
        if(denom.ne.0.0)then
          vappar=1./denom
          vapp=vappar
          azm1=atan2(-cinv(2),-cinv(3))/degtorad
          azapp=azm1

c 4/94: added printout of azimuth & appar. vel.
          if(iulst.gt.0.and.(.not.multi_model))then
            write(iulst,'(/,'' Regression azimuth='',f6.1,
     &       '' Apparent velocity='',f7.2,'' km/s'',/)')azm1,vappar
          endif

          nsolm=1
          azz=azm1
        endif

c alatm, alonm are the mean latitude and longitude (deg) of the array to
c which the azimuths determined here are referred
        alatm=slatm/degtorad
        alonm=slonm/degtorad

        
        if (vappar.gt.0.0)then  !condition added 6/98
c the values in the following formula were determined empirically, using
c a set of distant event arrivals collected by the Norwegian array
c They may need changing in different geological regions
         slowness=110.7/vappar
c         delta=(10.46-slowness)/0.067
c added 6/98 BRL Now use this routine to find delta using IASP91
         delta=find_delta('        ',slowness,tt1,imat)

         if(delta.lt.0.0)delta=1.0
         if(delta.gt.180.)delta=179.
         if(.not.multi_model)
     *   write(iulst,'('' delta = '',f6.1,'' R2 = '',f6.2)')delta,r2
         dlt1=delta 
         if(dlt1.lt.test(104))dlt1=test(104)
         dltmin=delta
         sign1=1.0
         rms1=9999.
         kk=0
c         call latlon(alatm,alonm,dlt1,azm1,alata,alona)
         
c  search at increments azinc and dinc in 
c azimuth and distance, respectively, for the minimum rms location, rms1

c change BRL 11/92: azinc made approximately the same distance 
c as dinc, dinc reduced to 1.0
         dinc=1.0
         azinc=dinc/(degtorad*delta)
         ifirst=1
         
5400     continue
         call latlon(alatm,alonm,dlt1,azm1,alata,alona)
c         call latlon(y0(icpfirst)/degtorad,x0(icpfirst)/degtorad,
c     &    dlt1,azm1,alata,alona)
c         write(iulst,*)'alatatr,alonatr',alata,alona
         xhtr(1)=alona*degtorad
         xhtr(2)=alata*degtorad

c 6/94 save distind in distinds and use 'D' for this section
         distinds=distind                                   
c         distind='D'
         
         rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,nmoho,
     &   nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc1,
     &   dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
     &   trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,
     &   scorr)
c         write(iulst,*)rms1,rms,alata,alona,dlt1,k
         if(ifirst.eq.1)rms1=rms
         
c change 10/93, BRL
c if initial rms value is > rms .15 km from nearest station (rmsmin)
c skip the minimum rms search. This was previously finding
c local minima at large distances in some cases
         ifirst=0
         if(rms1.le.rmsmin.or.distinds.eq.'D')then
         
          if(rms.le.rms1)then  !changed from .lt. 6/98
            kk=kk+1
            rms1=rms
            dltmin=dlt1
            dlt1=dlt1+dinc*sign1
            if(kk.lt.30)go to 5400
          elseif(kk.eq.1)then
            sign1=-1.0
            dlt1=delta-dinc
            kk=kk+1
            if(kk.lt.30)go to 5400
          endif
c          dlt1=dltmin
          kk=0
          sign1=1.0
          azmin=azm1                   
          
          azmm=azm1+azinc
5500      call latlon(alatm,alonm,dltmin,azmm,alata,alona)
          xhtr(1)=alona*degtorad
          xhtr(2)=alata*degtorad
          ndataprev=ndata
          rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,nmoho,
     &    nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc1,
     &    dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
     &    trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,
     &    scorr)

          nsol=1
c          write(iulst,*)rms,alata,alona,azmm,kk
c          write(iulst,*)xhtr(1)/degtorad,xhtr(2)/degtorad

          if(kk.eq.0)then
            sign1=-1.0
            azmm=azm1-azinc
            kk=kk+1
            go to 5500
          endif
          if(rms.lt.rms1.and.kk.lt.30)then  ! changed 6/98  to prevent 
            kk=kk+1                         ! infinite loop
            rms1=rms
            azmin=azmm
            azmm=azmm+sign1*azinc
            go to 5500
          endif
         endif
c         write(iulst,*)dltmin,azmin
         call latlon(alatm,alonm,dltmin,azmin,alata,alona)
         xhtr(1)=alona*degtorad
         xhtr(2)=alata*degtorad
 
         if(r2.gt..8)then
          if(dltmin.gt.10..and.rms1.lt.rmsmin)fixdepn='F'
          if(rms1.lt.rmsmin)then
            rmsmin=rms1
            xh2(1)=xh0(1)
            xh2(2)=xh0(2)
            xh0(1)=xhtr(1)
            xh0(2)=xhtr(2)
c            nsol=2
          endif
          if(rms.lt.rms1)rms1=rms
           if(iulst.gt.0.and.(.not.multi_model))then
            write(iulst,'('' Starting location from regression '',
     &      ''azimuth and slowness: '',5x,3f8.2)')alata,alona
            write(iulst,'('' rms = '',f8.2)')rms1
           endif
           apprms=rms1
         else
          xh2(1)=xhtr(1)
          xh2(2)=xhtr(2)
          nsol=2
         endif

c 6/94 restore original value
         distind=distinds
        endif
      endif

c *************** 2.  azimuthal phases  ********************

      naz=0
      nazsol=0
      rmsaz=999.

      do  i=1,nphase
c        write(iulst,*)st(i),phase(i),ip(i),dtwt(i)
        if(phase(i)(1:2).eq.'AZ'.and.dtwt(i).gt.0.0)naz=naz+1
      end do
c      write(iulst,*)'naz',naz
      if(naz.eq.0.and.maxno.eq.0.and.npsphase.eq.0)then
    
c  no azimuths and only one station: not locatable 
        if(iulst.gt.0)write(*,*)' Only one common phase station',
     &  ' and no azimuths: not locatable'
        xh0(1)=-999.
        xh0(2)=-999.
        nsol=0
        return
      endif
    
c change 10/93: removed condition maxno > 0
c      if(maxno.gt.0)then

c  k is used to check the number of azimuths found
        kk=0

        do ii=1,nphase

c change 10/93, BRL: i is now arrival time order
          i=isort(ii)
          if(phase(i)(1:2).eq.'AZ'.and.dtwt(i).gt.0.0)then
            if(kk.eq.0)then
              nsolz=0

c  first azimuth:
c  save the station ID to test for a different station
              stat=st(i)
c              write(iulst,*)' 1 ',stat,phase(i),i,tp(i)
              t1=sngl(tp(i))
              x1=x0(i)/degtorad
              y1=y0(i)/degtorad
              kk=kk+1
              if(maxno.gt.2)then

c  find this azimuth's intersections with the apparent velocity azimuth, azm1 
                alat2=y0(i)/degtorad
                alon2=x0(i)/degtorad
                az2=sngl(tp(i))
                call azcros(alatm,alonm,azm1,alat2,alon2,az2,dist1,
     &          dist2,alat1,alon1,ierr)
                ierr1=ierr
                if(ierr1.eq.0)then
                  nsolz=1
                  alata=alat1
                  alona=alon1
                endif

c     set the new epicenter values
                if(nsolz.eq.1)then
                  xhtr(1)=alona*degtorad
                  xhtr(2)=alata*degtorad
                  rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,
     &            nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,
     &            test,dtwt,dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,
     &            xnear,tph,distind,aninc,trphs,dtav,minflag,data,
     &            imatch,depthlim,iflagd,ires,fixor,scorr)
                  nsol=1
                  if(rms.lt.rmsmin)then
                    fixdepn=' '
                    rmsmin=rms
                    xh2(1)=xh0(1)
                    xh2(2)=xh0(2)
                    xh0(1)=xhtr(1)
                    xh0(2)=xhtr(2)
                    nsol=2
                  endif
                  if(iulst.gt.0.and.(.not.multi_model))then
                    write(iulst,'('' Starting location from one '',
     &              ''azimuth and apparent velocity azimuth:''
     &              ,2f8.2)')alata,alona
                    write(iulst,'('' rms = '',f8.2)')rms
                  endif
                endif
              endif 
c added apparent_vel-distance location 6/98
              if(appar_veloc(i).gt.0.0.and.distind.eq.'D')then
                dlt1=find_delta('        ',110.7/appar_veloc(i),
     &           tt1,imat)
                az2=sngl(tp(i))
                call latlon(y0(1)/degtorad,x0(1)/degtorad,dlt1,
     &           az2,alata,alona)
                xhtr(1)=alona*degtorad
                xhtr(2)=alata*degtorad
                rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,
     &          nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,
     &          test,dtwt,dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,
     &          xnear,tph,distind,aninc,trphs,dtav,minflag,data,
     &          imatch,depthlim,iflagd,ires,fixor,scorr)
                nsol=1
                if(rms.lt.rmsmin)then
                  fixdepn=' '
                  rmsmin=rms
                  xh2(1)=xh0(1)
                  xh2(2)=xh0(2)
                  xh0(1)=xhtr(1)
                  xh0(2)=xhtr(2)
                  nsol=2
                endif
                if(iulst.gt.0.and.(.not.multi_model))then
                  write(iulst,'('' Starting location from one '',
     &            ''azimuth and apparent velocity distance:''
     &            ,2f8.2)')alata,alona
                  write(iulst,'('' rms = '',f8.2)')rms
                endif
              endif
            endif

c 10/94: added azimuth check
           if(kk.eq.1.and.st(i).ne.stat)then
c            write(iulst,*)' 2 ',st(i),phase(i),i,tp(i)
c    two azimuths: find the intersection of their great circles
            t2=sngl(tp(i))
            x2=x0(i)/degtorad
            y2=y0(i)/degtorad
c            write(iulst,*)x1,y1,x2,y2
            call azcros(y1,x1,t1,y2,x2,t2,dist1,dist2,
     &      alat1,alon1,ierr)

            if(ierr.ne.0.and.iulst.gt.0.and.(.not.multi_model))
     *      then

c             write(*,8000)t1,t2
c8000          format(' Azimuths ',f6.1,' and ',f6.1,
c     &        ' do not intersect')
            else
              nazsol=nazsol+1
              xhtr(1)=alon1*degtorad
              xhtr(2)=alat1*degtorad
              rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,
     &        nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,
     &        dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,
     &        distind,aninc,trphs,dtav,minflag,data,imatch,depthlim,
     &        iflagd,ires,fixor,scorr)
              if(rms.lt.rmsaz)then
                rmsaz=rms
                t1min=t1
                t2min=t2
                alataz=alat1
                alonaz=alon1
c                write(iulst,*)'*',alat1,alon1,rms
              endif

c try the antipode as well (if non-local)
              if(distind.ne.'L')then
                xhtr(1)=(alon1+180.)*degtorad
                xhtr(2)=-alat1*degtorad
                rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,
     &          nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,
     &          dtwt,dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,
     &          tph,distind,aninc,trphs,dtav,minflag,data,imatch,
     &          depthlim,iflagd,ires,fixor,scorr)
                nsol=1
                if(rms.lt.rmsaz)then
                  rmsaz=rms
                  t1min=-t1
                  t2min=-t2
                  alataz=-alat1
                  alonaz=alon1+180.
                  if(alonaz.gt.180.)alonaz=alonaz-360.
                endif
              endif
            endif
c            write(iulst,*)'X ',alon1,alat1
           endif
          endif 
        end do

        if(nazsol.gt.0.and.k.eq.1)then
          if(rmsaz.lt.rmsmin)then
            fixdepn=' '
            rmsmin=rmsaz
            xh2(1)=xh0(1)
            xh2(2)=xh0(2)
            xh0(1)=alonaz*degtorad
            xh0(2)=alataz*degtorad
            alata=alataz
            alona=alonaz
            nsol=2
          endif
            if(iulst.gt.0.and.(.not.multi_model))then
              write(iulst,'('' Starting location from two'',
     &        '' azimuths:'',14x,2f8.2)')alataz,alonaz
c              write(iulst,*)'az1,az2 ',t1min,t2min
              write(iulst,'('' rms = '',f8.2)')rmsaz
            endif
        endif
c      endif

c  ***************** 3. Find the multi-phase stations *******************

c  zero  counters
      do i=1,nphase
        ind1(i)=0
        ind2(i)=0
      end do

      kk=0

c  nstat is the number of different stations
      nstat=0
      ndist=0

c   bump the phase index
c change 10/93, BRL: now use arrival time order for k
130   kk=kk+1
      k=isort(kk)
c      write(iulst,*)st(k)

c   check for azimuths, blank phases and last phase
      if(kk.le.nphase)then
c before sep 10, 2001        if(phase(k)(1:2).eq.'AZ')go to 130
        if(phase(k)(1:2).eq.'AZ'.or.phase(k)(1:1).eq.' ')go to 130

c 10/94: keep these in
c change 10/93 BRL: include PS P-phases
c        if(dtwt(k).eq.0.0.and.ip(k).ne.9)go to 130

c   do we already have this station ?
        do i=1,nstat
c          write(iulst,*)i,st(k),st1(i)
          if(st(k).eq.st1(i))then

c   Yes:  bump the counter and get another phase

c change 10/93, BRL: changed nstat to i in following lines
c 4/94: changed phase limit to 20
            if(ind1(i).eq.20)then
              write(iulst,*)' Limit of 20 phases/station exceeded'
              go to 135
            endif  
            ind1(i)=ind1(i)+1
c            write(iulst,*)i,k,st1(i),ind1(i)

c  store the index of the second phase in ind3
            ind3(i,ind1(i))=k

            go to 130
          endif
135       continue
        end do

c   New station: bump the  station count, store the first phases 
c  index in ind2, the station ID in st1, then get another phase
        nstat=nstat+1
        ind2(nstat)=k
        st1(nstat)=st(k)
c        write(iulst,*)' new st ',nstat,k,st1(nstat)
        go to 130
      endif

c find the number of multiple phase stations, nmult
      nmult=0

      do i=1,nstat
        if(ind1(i).gt.0)nmult=nmult+1
      end do

c   stataz is used to store the ID of the azimuth 
c   station having a multiple phase (i.e. a distance)
      stataz='     '

      if(nmult.gt.0)then

        if(iulst.gt.0.and.(.not.multi_model))then
          write(iulst,'(/,i4,'' multiple-phase stations'')')nmult
        endif


        jaz=0

        if(naz.gt.0)then

c   find the first azimuth station having a multiple phase

c change 10/93, BRL: j now arrival time order
          do jj=1,nphase
            j=isort(jj)

            if(phase(j)(1:2).eq.'AZ'.and.dtwt(j).ne.0.0)then
              do i=1,nstat
                if(st(j).eq.st1(i).and.ind1(i).gt.0)then
                  jaz=j
                  stataz=st(j)
                  go to 591
                endif
              end do
            endif
          end do

591       continue

        endif

c   store the indices (nmp(k),nmp1(k)) and distances 
c  (delmp(k))  of all the multiple phases
        ii=nl
        if(nmoho.ne.0)ii=nmoho
        k=0

c iaz and kaz are used to store the indices of the first multiple-phase
c station which also has an azimuth
        iaz=0
        kaz=0

        if(iulst.gt.0.and.(.not.multi_model))write(iulst,*)

        do i=1,nstat
          do j=1,ind1(i)
            j1=ind2(i)
            j2=ind3(i,j)
            if(ind1(i).gt.0)then
              prm1=ucase(phase(j1)(1:1))
              prm2=ucase(phase(j1)(2:2))
              prm3=ucase(phase(j2)(1:1))
              prm4=ucase(phase(j2)(2:2))
            
c    Use the  multiple phase  to estimate an
c    approximate distance using surface or moho velocities (or vl)
              vvv=0.0
              vvv1=0.0

c Set the velocities of the two phases using the phase ID's
              if(prm3.eq.'S'.and.prm4.eq.'G')vvv=vs(1)
              if(prm3.eq.'S'.and.prm4.eq.'N')vvv=vs(ii)
              if(prm3.eq.'S'.and.prm4.eq.' ')vvv=vs(ii)
              if(prm3.eq.'P'.and.prm4.eq.'G')vvv1=v(1)
              if(prm3.eq.'P'.and.prm4.eq.'N')vvv1=v(ii)
              if(prm3.eq.'P'.and.prm4.eq.' ')vvv1=v(ii)
              if(prm3.eq.'L')vvv=vl
              if(prm1.eq.'P'.and.prm2.eq.'N')vvv1=v(ii)
              if(prm1.eq.'P'.and.prm2.eq.' ')vvv1=v(ii)
              if(prm1.eq.'P'.and.prm2.eq.'G')vvv1=v(1)
              if(prm1.eq.'S'.and.prm2.eq.'G')vvv=vs(1)
              if(prm1.eq.'S'.and.prm2.eq.'N')vvv=vs(ii)
              if(prm1.eq.'S'.and.prm2.eq.' ')vvv=vs(ii)
              if(prm1.eq.'L')vvv=vl
               
              if(vvv.gt.0.0.and.vvv1.gt.0.0)then

c bump multiple phase count and calculate distance
                k=k+1

c                write(iulst,*)' ',ip(j2),ip(j1),tp(j2),tp(j1)

c change 10/93, BRL
c  time difference for PS phase is already in tp(j2)
                if(ip(j1).ne.9)then
                  delmp(k)=abs(sngl(tp(j2)-tp(j1))
     &             /((1./vvv)-(1./vvv1)))
                else
                  delmp(k)=abs(sngl(tp(j2))/((1./vvv)-(1./vvv1)))
                endif

                nmp(k)=j1
                nmp1(k)=j2
                if(iulst.gt.0.and.(.not.multi_model))then
                  write(iulst,'(8x,a4,2x,2a1,''-'',2a1,4x,f8.1,'' km''
     &            )')st1(i),prm1,prm2,prm3,prm4,delmp(k)
                endif

                if(st1(i).eq.stataz)then
                  if(iaz.eq.0)iaz=i
                  if(kaz.eq.0)kaz=k
                endif
              endif
            endif
          end do
        end do

        if(iulst.gt.0.and.(.not.multi_model))write(iulst,*)
        ndist=k

c change 10/93 BRL
c I now calculate rms for all the following cases, rather
c than for only one of them. The minimum rms criterion
c is used to select the starting location

c   case A:  distance + 1 azimuth from  the same station
        if(iaz.ne.0.and.kaz.ne.0)then
          nsol=1
          ii=jaz
          azloc=sngl(tp(ii))

c          write(iulst,*)ii,st(ii),tp(ii),delmp(kaz)
          delt=delmp(kaz)/(6371.*degtorad)
          call latlon(y0(ii)/degtorad,x0(ii)/degtorad,delt,azloc,
     &    alata,alona)
          xhtr(1)=alona*degtorad
          xhtr(2)=alata*degtorad                                    
          rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,nmoho,
     &    nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,tpc1,
     &    dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
     &    trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,
     &    scorr)
          nsol=1
          if(rms.lt.rmsmin)then
            fixdepn=' '
            rmsmin=rms
            xh2(1)=xh0(1)
            xh2(2)=xh0(2)
            xh0(1)=xhtr(1)
            xh0(2)=xhtr(2)
            nsol=2
          endif
            if(iulst.gt.0.and.(.not.multi_model))then
              write(iulst,'('' Starting location from distance +'',
     &        '' 1 azimuth: '',5x,2f8.2)')alata,alona
               write(iulst,'('' rms = '',f8.2)')rms
            endif
        endif

c 6/94 removed distance+apparent velocity azimuth - caused global location problems

        if(ndist.gt.1)then

c  case C:  more than one distance: 
c     find the length and direction of the line joining
c     the first two distance stations (indices nmp(k) and nmp(k1))
          k1=2
          k=1
600       continue
          j1=nmp(k)
          j2=nmp(k1)
c          write(iulst,*)' j1,j2 ',j1,j2
          ctheta=0.0
          if(st(j1).ne.st(j2))then
            call delaz(y0(j2),x0(j2),dekm,dedeg,az1,
     &      y0(j1),x0(j1))

c now find the orientation of the intersection point(s)
c******************************************************
c change brl 12/22/93: check that dekm and delmp(k) > 0
            if(delmp(k).gt.0.0.and.dekm.gt.0.0)then
              ctheta=(delmp(k)**2-delmp(k1)**2+dekm*dekm)/
     &        (2.*delmp(k)*dekm)

c 2/95: limit ctheta to +/- 1
              if(ctheta.gt.1.0)ctheta=1.0
              if(ctheta.lt.-1.0)ctheta=-1.0
              
            endif
c*********************************************************
          endif
          
c          write(iulst,*)ctheta,delmp(k),delmp(k1),dekm
          if(abs(ctheta).gt.1.0.or.st(j1).eq.st(j2))then 
            if(k1+1.le.ndist)then
              k1=k1+1
              go to 600
            elseif(k+1.le.ndist.and.k+1.ne.k1)then
              k=k+1
              go to 600
            else
              ndist=1
            endif
          else
c************************************************************
c change brl 12/22/93: when ctheta=0, azz=90
            if(ctheta.ne.0.0)then
              azz=atan(sqrt(1./(ctheta*ctheta)-1.))/degtorad
            else
              azz=90.
            endif
c*************************************************************
            if(ctheta.lt.0.0)azz=180.-azz
c           write(iulst,*)' dekm az1 azz ',dekm,az1,azz
            alat1=y0(j1)/degtorad
            alon1=x0(j1)/degtorad
            delt=delmp(k)/(6371.*degtorad)
            call latlon(alat1,alon1,delt,az1+azz,alata,alona)
            call latlon(alat1,alon1,delt,az1-azz,alatb,alonb) 

c 2/95: if ctheta=1 or -1 try other distance
            if(ctheta.eq.1.0.or.ctheta.eq.-1.0)then
             alat1=y0(j2)/degtorad
             alon1=x0(j2)/degtorad
             delt=delmp(k1)/(6371.*degtorad)
             call latlon(alat1,alon1,delt,az1+azz,alatb,alonb)
            endif 
c           write(iulst,*)alata,alona,alatb,alonb

c change 10/93: test rms of both solutions
            do ns=1,2
              if(ns.eq.1)then
                xhtr(1)=alona*degtorad
                xhtr(2)=alata*degtorad
              elseif(ns.eq.2)then
                xhtr(1)=alonb*degtorad
                xhtr(2)=alatb*degtorad
                alata=alatb
                alona=alonb
              endif
              rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,
     &        nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,
     &        dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,
     &        distind,aninc,trphs,dtav,minflag,data,imatch,depthlim,
     &        iflagd,ires,fixor,scorr)
              nsol=2
              if(rms.lt.rmsmin)then
                fixdepn=' '
                rmsmin=rms
                xh2(1)=xh0(1)
                xh2(2)=xh0(2)
                xh0(1)=xhtr(1)
                xh0(2)=xhtr(2)
                nsol=2
              endif
              if(iulst.gt.0.and.(.not.multi_model))then
                write(iulst,'('' Starting location from 2 distances:''
     &          ,2f8.2)')alata,alona
                write(iulst,'('' rms = '',f8.2)')rms
              endif
            end do

c change 10/93:removed 3 distance test - no longer necessary
          endif
        endif



        if(ndist.eq.1.and.iaz.eq.0.and.naz.gt.0)then

c Case D: one distance and one azimuth at different stations
          ii=nmp(1)

c  find the azimuth of the line joining the distance station 
c  to the reference point (azimuth station if naz > 0)
c  the coordinates of the first azimuth t1, and its station 
c  coordinates (x1,y1) have already been saved
          alat2=y0(ii)/degtorad
          alon2=x0(ii)/degtorad
          dist=delmp(1)
          call azdist(y1,x1,t1,alat2,alon2,dist,alata,alona,alatb,
     &    alonb,nsol)
          do ic=1,nsol
            xhtr(1)=alona*degtorad
            xhtr(2)=alata*degtorad
            rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,ndata,nmoho,
     &      nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,dtw1,
     &      tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,distind,aninc,
     &      trphs,dtav,minflag,data,imatch,depthlim,iflagd,ires,fixor,
     &      scorr)

            if(rms.lt.rmsmin)then
              fixdepn=' '
              rmsmin=rms
              xh2(1)=xh0(1)
              xh2(2)=xh0(2)
              xh0(1)=xhtr(1)
              xh0(2)=xhtr(2)
              nsol=2
            endif
              if(iulst.gt.0.and.(.not.multi_model))then
                write(iulst,'('' Starting location from distance +'',
     &          '' another stat. azimuth: '',5x,2f8.2)')alata,alona
                 write(iulst,'('' rms = '',f8.2)')rms
              endif
            xhtr(1)=alonb*degtorad
            xhtr(2)=alatb*degtorad
          end do
        endif
      endif

c now make sure the selected starting location satisfies the critical
c distance for all stations with azimuths

      do i=1,nphase

        if((ucase(phase(i)(2:2)).eq.'N'.or.phase(i)(2:2).eq.'K'))then
c     &  .and.dtwt(i).ne.0.0)then

          dcrit1=dcrit

c set critical distance to test(59) km for core phases
c          if(phase(i)(2:2).eq.'K')dcrit1=test(59) !removed 6/98 BRL

          if(naz.gt.0)then
            do j=1,nphase

c change 10/93, BRL: exclude zero weight azimuths
c------------------------------------------------------------------
              if(phase(j).eq.'AZ  '.and.st(j).eq.st(i).and.dtwt(j)
     &        .gt.0.0)then
c-----------------------------------------------------------------
c  find the distance, dekm1, to the present starting location from this
c  station
       
                call delaz(alata*degtorad,alona*degtorad,dekm1,
     &          dedeg,azz,y0(i),x0(i))

                if(dekm1.lt.dcrit1)then

c move the start location out to the critical distance

                  delt=dcrit1/(6371.*degtorad)
                  az4=sngl(tp(j))
                  call latlon(y0(i)/degtorad,x0(i)/degtorad,delt,az4,
     &            alata,alona)
c                 write(iulst,*)'alata,alona ',alata,alona
                  xhtr(1)=alona*degtorad
                  xhtr(2)=alona*degtorad
                  rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,nn,
     &            nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,
     &            dtwt,dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,
     &            tph,distind,aninc,trphs,dtav,minflag,data,imatch,
     &            depthlim,iflagd,ires,fixor,scorr)
                  nsol=2
                  if(rms.lt.rmsmin)then
                    fixdepn=' '
                    rmsmin=rms
                    xh2(1)=xh0(1)
                    xh2(2)=xh0(2)
                    xh0(1)=xhtr(1)
                    xh0(2)=xhtr(2)
                    nsol=2
                    if(iulst.gt.0.and.(.not.multi_model))then
                      write(iulst,'('' Critical distance from station ''
     &                ,a5,'' phase '',a4,'' used along azimuth '',f6.1
     &                )')st(i),phase(i),az4
                      write(iulst,'('' rms = '',f8.2)')rms
                      go to 599
                    endif
                  endif
                endif
              endif
            end do
    
          elseif(maxno.gt.2)then

c  no azimuth data: use regression azimuth

            call delaz(alata*degtorad,alona*degtorad,dekm1,
     &      dedeg,azz,slatm,slonm)
            if(dekm1.lt.dcrit1)then

c move the start location out to the critical distance

              delt=dcrit1/(6371.*degtorad)
              call latlon(y0(i)/degtorad,x0(i)/degtorad,delt,azm1,
     &        alata,alona)                                        
     
c             write(iulst,*)'alata,alona ',alata,alona
              xhtr(1)=alona*degtorad
              xhtr(2)=alona*degtorad
              rms=rmsv(nphase,st,phase,tp,x0,y0,xhtr,nn,
     &        nmoho,nconrad,iulst,dtdl,dtdh,dddp,tt,phcd,test,dtwt,
     &        dtw1,tpc1,dl,iselv,maxelv,ips,ip,dt,xfar,xnear,tph,
     &        distind,aninc,trphs,dtav,minflag,data,imatch,depthlim,
     &        iflagd,ires,fixor,scorr)
              nsol=1
              if(rms.lt.rmsmin)then
                fixdepn=' '
                rmsmin=rms
                xh2(1)=xh0(1)
                xh2(2)=xh0(2)
                xh0(1)=xhtr(1)
                xh0(2)=xhtr(2)
                if(iulst.gt.0.and.(.not.multi_model))then
                  write(iulst,'('' Critical distance for phase '',a8,
     &            '' used along regression azimuth '',f6.1
     &             )')phase(i),az1
                  go to 599
                endif
                nsol=2
              endif
            endif
          endif
        endif
      end do

599   continue
c      xh0(1)=alona*degtorad
c      xh0(2)=alata*degtorad

c 4/94: if apparent velocity start location, fix depth
      if(fixdepn.eq.'F')then
c       write(iulst,'(/'' Depth fixed for regression'',
c     & '' starting location''/)')
c       fixdep='F'      
      endif                
      
      return
      end


      subroutine ludcmp(a,n,np,indx,d)
      implicit double precision (a-h,o-z)
      save
      parameter (nmax=100,tiny=1.0d-20)
      dimension a(np,np),indx(n),vv(nmax)
      d=1.
      do 12 i=1,n
        aamax=0.
        do 11 j=1,n
          if (dabs(a(i,j)).gt.aamax) aamax=dabs(a(i,j))
11      continue
C        if (aamax.eq.0.) pause 'singular matrix.'
        if(aamax.ne.0.0)vv(i)=1./aamax
12    continue
      do 19 j=1,n
        do 14 i=1,j-1
          sum=a(i,j)
          do 13 k=1,i-1
            sum=sum-a(i,k)*a(k,j)
13        continue
          a(i,j)=sum
14      continue
        aamax=0.
        do 16 i=j,n
          sum=a(i,j)
          do 15 k=1,j-1
            sum=sum-a(i,k)*a(k,j)
15        continue
          a(i,j)=sum
          dum=vv(i)*dabs(sum)
          if (dum.ge.aamax) then
            imax=i
            aamax=dum
          endif
16      continue
        if (j.ne.imax)then
          do 17 k=1,n
            dum=a(imax,k)
            a(imax,k)=a(j,k)
            a(j,k)=dum
17        continue
          d=-d
          vv(imax)=vv(j)
        endif
        indx(j)=imax
        if(a(j,j).eq.0.)a(j,j)=tiny
        if(j.ne.n)then
          dum=1./a(j,j)
          do 18 i=j+1,n
            a(i,j)=a(i,j)*dum
18        continue
        endif
19    continue
      return
      end

      subroutine lubksb(a,n,np,indx,b)
      implicit double precision (a-h,o-z)
      dimension a(np,np),indx(n),b(n)
      ii=0
      do 12 i=1,n
        ll=indx(i)
        sum=b(ll)
        b(ll)=b(i)
        if (ii.ne.0)then
          do 11 j=ii,i-1
            sum=sum-a(i,j)*b(j)
11        continue
        else if (sum.ne.0.) then
          ii=i
        endif
        b(i)=sum
12    continue
      do 14 i=n,1,-1
        sum=b(i)
        do 13 j=i+1,n
          sum=sum-a(i,j)*b(j)
13      continue
        b(i)=sum/a(i,i)
14    continue
      return
      end
      character*1 function lcase(a)

c    convert upper case single char to lower case - machine independent

      character*1 chr(26),ucchr(26),a
      data chr/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     &'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      data ucchr/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     &'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      do 10 i=1,26
        if(a.eq.ucchr(i))then
          lcase=chr(i)
          return
        endif
10    continue
      lcase=a
      return
      end
      
      real function find_delta(m_phs,p,tt1,imat)
c  uses iasp91 trtm routine to find offset, delta in degrees, at which
c  horiz. deriv of travel time for phase phs matches slowness p
c  Barry Lienert Jun 98
      implicit none
      save
      include 'hypparm.inc'
      character*8 phs,m_phs
      real p,p1,change,dpdd,delta,del_delta,tt1
      integer i,imat,n,niter,ilen
c find approximate first delta from empirical formula
      delta=(10.46-p)/0.067
      p1=-999.
      if(m_phs.eq.'        ')then
       call trtm(delta,niasp,n,tt,dtdl,dtdh,dddp,phcd)
       imat=0
       i=1
       do while (imat.eq.0.and.i.le.n)
        if(abs(dtdl(i))/abs(p).lt.2..and.abs(p)/abs(dtdl(i)).gt..5)then
         imat=i
        endif
        i=i+1 
       end do                   
       if(imat.ne.0)then
        phs=phcd(imat)
       else
        imat=1
        phs=phcd(imat)
       endif  
      else
       phs=m_phs
      endif 

      ilen=len(m_phs)

      niter=0
      do while (abs(p-p1).gt..01.and.niter.le.50)
c get iasp91 values at this delta      
       call trtm(delta,niasp,n,tt,dtdl,dtdh,dddp,phcd)
      
c look for the phase in the iasp91 phase list
       imat=0            
       i=1
       do while (imat.eq.0.and.i.le.n)
        if(phs(1:ilen).eq.phcd(i)(1:ilen))imat=i
        i=i+1
       end do                              
c no matching phase: return 
       if(imat.eq.0)then
        find_delta=(10.46-p)/0.067
        return
       endif          
c find approx. derivative, dpdd, of p w.r.t. delta       
       change=.05
       p1=dtdl(imat)
       if(dtdl(imat).lt.p)then
        call trtm((1.+change)*delta,niasp,n,tt,dtdl,dtdh,dddp,phcd)
        imat=0            
        i=1
        do while (imat.eq.0.and.i.le.n)
         if(phs.eq.phcd(i))imat=i
         i=i+1
        end do                              
c no matching phase: return 
        if(imat.eq.0)then
         find_delta=(10.46-p)/0.067
         return
        endif          
        dpdd=(dtdl(imat)-p1)/(change*delta)
       else
        call trtm((1.-change)*delta,niasp,n,tt,dtdl,dtdh,dddp,phcd)
        imat=0            
        i=1
        do while (imat.eq.0.and.i.le.n)
         if(phs.eq.phcd(i))imat=i
         i=i+1
        end do                              
c no matching phase: return 
        if(imat.eq.0)then
         find_delta=(10.46-p)/0.067
         return
        endif          
        dpdd=(p1-dtdl(imat))/(change*delta)
       endif
c find new delta by extrapolating this derivative
       if(dpdd.ne.0.0)then
        del_delta=(p-p1)/dpdd
       else
        find_delta=(10.46-p)/0.067
        return
       endif 
c limit change in delta to 5 degrees
       if(del_delta.gt.5.)del_delta=5.
       if(del_delta.lt.-5.)del_delta=-5.
       delta=delta+del_delta 
       niter=niter+1
      end do
      if (niter.eq.20)then
       find_delta=(10.46-p)/0.067
       return
      endif 
      find_delta=delta
      tt1=tt(imat)
      return 
      end

cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c
c             HYPOSUB1 version 4.0     BRL 6/98
c
c           uses IASP91 software to locate globally as well as locally
c
cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH

      subroutine hypocent(ifunct,iustat,iuphs,iulst,iusum,iutab,init,
     &inform,data,modnam,eventno,dlt,isort,test,yter,maxline,nstation,
     &locate,covar,oterr,nhead,nrecord,use_eev)
c
c******** NOTE****** This routine will only locate one event unless
c                    statements around 9   continue are commented out
c                    this for use with seisan
c
c
c  Updates:
c   nov 24, 91 by j.h. : array data added for input in nordic format
c                        changes in getphasn and hypocent
c   dec 1              : make sure routine returns if # of phases lt 3 or
c                        return to 9 for other reason, comment out
c                        if multi event location
c   jan 3   92 by. jh  : bl's new version  (nov 91) updated with new nordic 
c                        format changes from dec 91
c                        use S for starting depth  (same loc as F for fixed)
c   jan 7              : magnitude correction is given to individul station
c                        instead of to average
c   feb 7 92  by j.h   : do not require that veloc .ne. 0.0 to use azimuth
c   May 92 BRL         : added travel time table interpolation for distant
c                        events
c   June 10/92 BRL     : added test parameters to getphasn window
c
c   June 11/92 BRL     : added Buland's IASP91 travel time software
c                        for distant events 
c   oct 27, 92, JH     : always write on screen if station is missing
c   nov 27, 92, JH     : change format to  summary file
c   Oct 11, 93 BRL     : added PARAMETER statement for dimensions
c                        This is now in the include file 'hypparm.inc'
c                        If the dimensions in this file are changed,
c                        hyposub2, hyposub4, hypoloc and hypoloc1 must ALL BE
c                        RECOMPILED as well as hyposub1
c                        added ifunct=3 to print residual summary
c                              ifunct=4 to zero residual sums
c   Dec 30, 93 BRL       ifunct=1 no longer zero's residual count:
c                        needs a separate call with ifunct=4
c   April 2, 1994 BRL    Added eventno to input window & printout
c   4/94                 Added fixor (fix origin time option)
c                        added yter, residual print to screen option
c   apr  28   94  jh     new test
c   may 5, 94     jh     write out geographic, not geocentric coordinates in
c                        data(1), include nstat for header
c   may 11               more on sorting, add locate in window
c   may 27 94     jh     shift residual output in nordic file format to f5.1
c   may 27 94     brl    set fixdep='F' when test(31)<=2
c   Sep 94        brl    added xmag & magtype to getphasn
c   Oct 94        brl    added error output in data array, nhead and nerecord
c                        to input window            
c   Oct 94        brl    added test(31)=-2 option to fix depth at STATION0.HYP
c                        value
CJAB(BGS)Jan95        : Only try to use IASP91 files if they exist.
c   feb 95  jh           if lat or lon outside range, fix to 90 or 360
c   jan 96  jh        : fix problem with lat between -1 and 0 and long between
c                       -1 and 0, bothe were between 0 and 1
c   mar 7 96 jh       : limit oterr to 999.99
c   nov 15, 96 jh     : origin times was fixed when hypocenter fixed, now ok
c   Jan 18, 98 mv     : due to a bug with the az residuals, a new variable 
c                       baz0(narriv) was created to calculate the backazimuths 
c                       at the same time than the azimuths in GEOCENTRIC !!!
c   jan 30     jh     : 5 magnitude residuals
c   jun 98     brl    : added spherical harmonic station corrections
c   sep 98     jh     . ----------------- seisan version 7.0 check -----------
c                       year 2000
c   oct 98              5 char station, if use hypo 71 data input, only 4 
c                       write gap on error line
c
c  oct 28 1998 bmt : linux changed, save and *
c   jul 26 99 jh      :add variable use_eev
c   oct 19 99 jh      : add test(94) to dela with w=4 reintroduction
c  nov 19          : remove v,vp,vs,d,nl,parm from window, to common block
c   dec 10         : year 2000 printout in hypsum.out
c   dec 10         : range of start depths
c   mar 23, 2000 lo: keep fixed origin time
c   aug 19       jh: add one_rms
c   oct 19, 2000   : read minutes of station lat and lon with f5.3 instead
c                    of f5.2, high accuracy output
c   jan 18, 2001   : get negative height from column 1 if depth > 1000 m
c   feb 19, 2001   : special code for BGS, see comments by bjb below
c   mar 4   2001 jh: add test 106 to enable only magnitude calcualtion
c                    write distance as real, fix reading of test above 99
c   may 5          : fix problem with multipel start depth and s-p phases,
c                    requred rereading of all phases for each new depth
c   jan 29  2002 jh: fix overflow in rms ouput to header line
c                    change ditnc eaccuracy in station line to make it
c                    more readbale (and less accurate)
c   feb 6  2002 jh : write angle of incidence in s-file
c   aug 3  2004 fernado carrilho: fix so oring time do not sometimes
c                    become zereo when locating in a sequence
c   may 24 2005 lot: take xnear and xfar from common block if set
c   may 30 2005 lot: added test(107) as flag to read xnear/xfar from sfile
c   feb 15 2006 lot: one more digit for travel time output in print.out
c   jan 24 2007 jh : max elevation was only possible to -999, now to -9999

cHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH
c--- array data for one event in nordic format
c      character*80 data(1)
      save
      logical locate   ! false if event was not located

c--indicator if event has been read, for seisan
      integer one_pass,eventno
c
c    dimensions now in hypparm.inc
      include 'hypparm.inc'
      include 'seisan.inc'
c      include 'param.inc'
      dimension fmg(nstats),fmgc(narriv),fmp(narriv)
      dimension fma(nstats),pres(nstats),sres(nstats),
     +pknt(nstats),scrst(nstats,9),dly(nstats),
     +sknt(nstats),sres2(nstats),pres2(nstats)
     +,kntp(nstats),knts(nstats),sknt2(nstats),pknt2(nstats),
     +sw2res(nstats),pw2res(nstats),ielv(nstats)

      dimension la(nstats),alat(nstats),lo(nstats),alon(nstats)
      dimension xhdiff(4),xhd2(4),covar(3,3)
      logical prnt(3)         
      logical use_eev     ! call is from eev
c      logical bgs_seisan
      character*8 phlst(10)
      character*80 modnam,datsave,testdat,prevstat
      character*1 pr(narriv),ins(nstats),iew(nstats),inform,
     +pr1(narriv),pr3(narriv),ins1,iew1,ucase,reff,fixepi,
     &fixdep,wtflag,phsflag,fd,fo,magtype
      real mag_cor(5,nstats)     !cmag
      character*5 s(nstats),stat
      character*4 thrmin
      character*5 depth
      integer*4 idd                                         
      character*1 yter,yquery,sgnla2,sgnlo2
      double precision orgsec,tph1,tph2,firstarr
      real min_rms   ! minimum rms when locating with several start depths
      real min_i     ! min i ...........................................
      integer n_start_depths   ! number of start depths to use
      logical diff_phase       ! difference phases like S-P present
      real    start_depth      ! first start depth
      real    start_depth_increment ! increment in start depths

c change BRL 12/29/93: fmg(narriv) changed to fmg(nstats)              
c 4/94: added sres2, pres2
c 9/94: added di
      character*5 old_stat
      real old_dist
      integer ksort(narriv) !changed 6/98
      real xlt(narriv)
      character*10 extension
      
c 4/94: common/comm1/ now in include file
c      include 'comm1.inc'
      common/hyp/s,mag_cor !cmag
c      dimension tt(niasp),dtdl(niasp),dtdh(niasp),dddp(niasp)

      pi=3.1415927
      degtorad=0.0174533
      rearth=6371.

c
c call function to determine ig BGS seisan outputs are to be used
c bjb 2001/02/14
c
c      call get_bgs_seisan(bgs_seisan)
      call get_env_seisan_extension(extension)

c    ifunct=1 : initialization (only needed once)   <<<<<<<<<<<<<<<<<<<<<<<<<<<

      if(ifunct.eq.1)then

c    set test parameter defaults

        call settest(test)

c set up iasp91 variables and files
        if(test(62).ne.0.0)then
          phlst(1)='all     '
        else
          phlst(1)='basic   '
        endif

c print flags for iasp91 software - disables printout
        prnt(3)=.false.
        prnt(1)=.false.
        prnt(2)=.false.

c readin the iasp91 filenames, open the files and initialize
        if( modnam .ne. ' ' ) then  !JAB(BGS)Jan95
        call tabin(iutab,modnam)
        i1=index(modnam,' ')-1
        call brnset(1,phlst,prnt)
        end if                      !JAB(BGS)Jan95.
c
c    read test parameter changes and station data
c    changed 4/94 to read character string and check for ")" so reset test(1) is OK
        stat='xxxxx'
        j=-1
        
        do while (stat.ne. '     '.and.j.ne.0)
         read(iustat,'(a80)')testdat
         if(testdat(14:14).eq.')')then
          read(testdat,'(a5,t12,i2,t16,f9.4)')stat,j,testj
         elseif(testdat(13:13).eq.')')then
          read(testdat,'(a5,t12,i1,t15,f9.4)')stat,j,testj
         elseif(testdat(15:15).eq.')')then
          read(testdat,'(a5,t12,i3,t17,f9.4)')stat,j,testj
         else
          read(testdat,'(a5)')stat
          j=-1
         endif
         if(j.gt.0)then
          test(j)=testj
          if(iulst.gt.0.and.(.not.use_eev))
     *    write(iulst,'(1x,''Reset test('',i3,'')='',
     &    f10.4)')j,testj
         endif
        end do
        
        if(iulst.gt.0)write(iulst,'(''    '')')
        
        call stations(s,la,alat,ins,lo,alon,iew,ielv,dly,fmg,scrst,nstat
cmag     &  iustat,iulst,init,nstats)
     &  ,iustat,iulst,init,nstats,mag_cor,use_eev)

        ichk=0
        iazflag=int(test(50))
        
        if(ichk.eq.0)write(iulst,'(''     ---------'',
     &  '' HYPOCENTER Version 4.0  1998 -----------''//)')
        ichk=1

c change 10/93: find max elev. station here rather than for each phase
        maxelv=-9999.
        do i=1,nstat
          if(ielv(i).gt.maxelv)then
            maxelv=ielv(i)
            iemx=i
          endif
        end do
        if(iulst.gt.0)write(iulst,1729)s(iemx),la(iemx),alat(iemx),
     &  ins(iemx),lo(iemx),alon(iemx),iew(iemx),maxelv
1729    format(1x,/,' Maximum elev. station: ',a5,1x,2(I4,f5.2,a1),
     &  '   elevation = ',i5,' m')

        if(test(40).ne.0.0.and.iulst.gt.0)then
          write(iulst,*)' ********* used as depth origin *************'
        endif
        if(iulst.gt.0)write(iulst,*)

c     read in velocity model
c   if vs(i) is not 0.0, the vs(i) are used to find separate
c   travel times and derivatives - otherwise vp/vs ratio is used

        i=1

c    reff is used to specify the moho layer for PN calculation
5       read(iustat,101,end=1999)v(i),d(i),vs(i),reff
101     format(3f7.3,a1)
        if(ucase(reff).eq.'N')nmoho=i

c 4/94: added nconrad variable
        if(ucase(reff).eq.'B')nconrad=i
        
        if(v(i).eq.0.0)go to 6
        i=i+1
        go to 5

c    nl is the number of layers in the velocity model
6       nl=i-1

c    read in trial depth and vp/vs ratio
        read(iustat,'(3f5.0,f5.2,i5,2f5.1)',end=1999)
     *  ztr,xnear,xfar,pos,
     *  n_start_depths,start_depth,start_depth_increment
        if(n_start_depths.eq.0) n_start_depths=1
        if(xnear.eq.9999.)xnear=20000.
        if(xfar.eq.9999.)xfar=20000.
        if(iulst.gt.0)write(iulst,'(/,'' Trial depth = '',f5.2,
     &  ''  Vp/Vs = '',f5.2,/)')ztr,pos

c    if vs(1)=0 then set vs(i)=v(i)/pos
        if(vs(1).eq.0.0)then
          do i=1,nl
            vs(i)=v(i)/pos
          end do
        endif

        if(iulst.gt.0)write(iulst,'('' Velocity Model'',/)')
        if(iulst.gt.0)write(iulst,'('' Depth, km   Vp, km/s   Vs, km/s''
     &  )')

        do  i=1,nl
         reff=' '

c 4/94: added printout of moho and conrad
         if(i.eq.nconrad)reff='B'
         if(i.eq.nmoho)reff='N'          
         if(iulst.gt.0)write(iulst,'(1x,f9.2,2f11.2,3x,a1)')
     &    d(i),v(i),vs(i),reff
        end do

c    convert depths to thicknesses and store parameters in parm(i)
        do i=1,nl-1
          parm(nl+i)=d(i+1)-d(i)

c    change 10/93: add maximum elevation to upper layer thickness
c    if test(40)=0.0 Need this because dtdx2 origin is always at maxelv
          if(i.eq.1.and.test(40).eq.0.0)then
            parm(nl+i)=d(i+1)-d(i)+float(maxelv)*.001
          endif
        end do
        do i=1,nl
          parm(i)=v(i)
        end do

c 6/98: added convergence flag
        icflag=0 
        imflag=0

        if(iulst.gt.0.and.(.not.multi_model))write(iusum,849)
849     format(' Date    Origin    Lat ',1x,'    Long ',1x,
     &  '    Depth    Mag No Gap Dmin  Rms  Erh  Erz  Erx      Cvxy',
     &  '      Cvxz      Cvyz     Oterr')
c        if(iulst.gt.0.and.(.not.multi_model))
c    *   write(iulst,'(/,'' Input phases:'',/)')
        return
1999    init=-1
        return
      endif

c   end of initialization  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

c   location <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      if(ifunct.eq.2)then
c
c set xnear and xfar if set in event file
c lot 24/5/2005
c
        if (xxnear.ne.-1..and.xxfar.ne.-1.) then
          xnear=xxnear
          xfar=xxfar
        endif

c BRL 6/98: save old header before it gets overwritten
        datsave=data(1)

c +++++++++++++++++++  read phases  ++++++++++++++++++++++++
        if(inform.eq.'N')one_pass=0
c
c   with seisan, only pass here once, set flag
c
9       continue
c
c   check for more passes, comment out if not using seisan
c   indicated with N, locate is false if no location was made
c
        if(one_pass.eq.1.and.inform.eq.'N') then
          locate=.false.
          return
        endif

c added 4/94: write event no
        if(iulst.gt.0.and.(.not.multi_model))
     *  write(iulst,'(/,'' EVENT # '',i6,/)')eventno

c intialize the phase count
        nphase=0

c remove comment in this line for seisan
        one_pass=1

c     read in the phase data (HYPO71 format)
        if(inform.eq.'H')then
          if(init.ne.-1)call getphase(nphase,st,phase,pr1,pr,pr3,ip,tp,
     &    fmp,imin,init,iuphs,iulst,narriv)

          if(nphase.eq.0)return
        endif

c     read in the phase data (Nordic format)
        if(inform.eq.'N')then
          ires=0
          ks=0

c  added test parameters to window BRL 6/92
c  added distance indicator, distind

c 11/92 BRL added orgsec to window
c 10/93 removed init.ne.-1 condition
c 4/94: added fixor                                              
c 10/94: added oldrms
          call getphasn(ks,iazflag,st,phase,pr1,pr,pr3,ip,
     &    tp,fmp,fixdep,depth,fixepi,yres,xres,orgsec,fixor,
     &    iulst,data,test,distind,narriv,imap,xmag,magtype,
     &    oldrms,appar_veloc)


c 10/93: make sure distind is u.c.
          distind=ucase(distind) 
          
          nphase=ks                          
          nphase1=ks
          if(nphase.eq.0)return
          if(ucase(fixdep).eq.'F')ires=1
c          if(ucase(fixepi).eq.'F')ires=9  ! how it was before nov 96         
          if(ucase(fixepi).eq.'F')ires=8   ! add jh nov 96
          if(ucase(fixepi).eq.'F'.and.ucase(fixdep).eq.'F'.and.
     *       ucase(fixor) .eq.'F') ires=9            ! add jh nov 96        
          if(ucase(fixepi).eq.'F'.and.ucase(fixdep).eq.'F')ires=7   ! jh nov 96
          if(ucase(fixepi).eq.'F'.or.ucase(fixepi).eq.'S')tph0=orgsec
          if(ucase(fixor).eq.'F'.and.ires.ne.9)ires=2
          
c 4/94: fix origin time
          if(ucase(fixor).eq.'F'.or.test(31).eq.0.)then
           tph0=orgsec
          endif 

c  transform decimal lat./long. to geocentric radians
          lar=int(yres)
          xlatr=abs(yres-float(lar))*60.
          lor=int(xres)
          xlonr=abs(xres-float(lor))*60.

c    lat/long are -ve for S/W  - change back for fold subr.
          ins1='N'
c         if(lar.lt.0)then      ! was so before jan 19, jh
          if(yres.lt.0.0) then  ! new version after jan 19,86
            lar=iabs(lar)
            ins1='S'
          endif
          iew1='E'
c         if(lor.lt.0)then      ! was so before jan 19, 96 jh
          if(xres.lt.0.0) then  ! new verison after jan 19,96, jh
            lor=iabs(lor)
            iew1='W'
          endif      
          call fold(yresn,xresn,lar,ins1,xlatr,lor,iew1,xlonr)

c 12/29/93: added error trap to this statement
c   zresn is measured relative to the origin (sea level or maxelv if test(40)<>0)          
          read(depth,'(f5.1)',err=883)zresn
          go to 884
883       if(iulst.gt.0)then
           write(iulst,'('' character in starting depth'',
     &     '' field on input phase header: '', a5)')depth
           write(iulst,'('' starting depth set to '',f10.1)')ztr
          endif 
          write(*,'('' character in starting depth'',
     &    '' field on input phase header: '', a5)')depth
          zresn=ztr
          
884       continue
        endif
c +++++++++++++++++++++ end of phase read +++++++++++++++++++++++++++++

        kss=1
        iphs=0       

c    find the station coordinates and corrections
        do 133 i=1,nphase
          do 15 j=1,nstat
15        if(s(j).eq.st(i))go to 16

          if(iulst.gt.0)write(iulst,105)st(i)
          write(*,105)st(i)
105       format(1x,'Station ',a5,' is not on station list: ignored')

c added 4/94 to clear old distance from no station phase          
          write(data(imap(i))(61:79),'(''                   '')')

          go to 133
16        continue  
          iphs=iphs+1        
          do k=1,9
           scorr(iphs,k)=scrst(j,k)
          end do 
          imap(iphs)=imap(i)                                                              
c          write(iulst,*)i,j,st(i),s(j)


c change BRL 12/27/93: if test(67)<>0 set blank phases to 'P    '
          if(phase(iphs)(1:4).eq.'    '.and.test(67).ne.0.0)
     &    phase(iphs)='P   '
        
c    convert to geocentric lat., y0(iphs), and long., x0(iphs)
          call fold(y0(iphs),x0(iphs),la(j),ins(j),alat(j),
     &    lo(j),iew(j),alon(j))                          

c    store phases elevation in iselv
          iselv(iphs)=ielv(j)

c change 10/93: max elev removed from here: in init section

          phase(iphs)=phase(i)
          ip(iphs)=ip(i)
          fmgc(iphs)=fmg(j)
          st(iphs)=st(i)
          pr1(iphs)=pr1(i)
          pr(iphs)=pr(i)
          pr3(iphs)=pr3(i)
          tp(iphs)=tp(i)
          fmp(iphs)=fmp(i)
          if(phase(iphs)(1:1).eq.'P')dl(iphs)=dly(j)
          if(phase(iphs)(1:1).eq.'S')dl(iphs)=dly(j)*pos

c    calculate the station weights, dtwt(i)  (never changed)
          if(ip(iphs).ge.0.and.ip(iphs).le.4.and.phase(iphs)(1:2).ne.
     &    'AZ')then

            dtwt(iphs)=(4.-float(ip(iphs)))/4.   
c            write(iulst,'(a8,f6.1)')phase(iphs),dtwt(iphs)
          elseif(phase(iphs)(1:2).eq.'AZ'.and.ip(iphs).ge.0)then

c change 10/93: calculate azimuth weights here
            dtwt(iphs)=(4.-float(ip(iphs)))/4./(degtorad*test(52))
          elseif(ip(iphs).ne.9)then
            write(iulst,'(a5,1x,a8,i3, '' invalid weight: set to zero''
     &       )')st(iphs),phase(iphs),ip(iphs)       
            dtwt(iphs)=0.0
          endif

c change 10/93: initialize dtw1
          dtw1(iphs)=0.0

133     continue

        nphase=iphs 
        
c 5/94 find first arrival station
        if(fixepi.eq.' '.or.ucase(fixepi).eq.'N')then
         firstarr=1.d100
         ifirst=0
        
         do i=1,nphase        
          if(tp(i).lt.firstarr)then
           firstarr=tp(i)
           ifirst=i
          endif
         enddo  
         xres=x0(ifirst)
         yres=y0(ifirst)
c         write(iulst,*)xres/degtorad,yres/degtorad
        endif 


c                   HYPO71 Feature

c   if phase data set is terminated by a 9 in col 19, output is calculated
c   at the latitude, longitude and depth specified on the next card
c   if col 19 is 2, fix origin time to value on next card (mod. 8/18/86)
c   NOTE: this origin time is referenced to the year, month, day and hour 
c   of the first arrival station.
c   if col 19 is 1, fixed depth solution at zres (no extra card needed)

c    ires values of 2 and 9 are hypo71 features - see hypo71 manual

        if(inform.eq.'H')then
          kmin=imin
          ires=kmin-(kmin/10)*10
          if(ires.eq.9.or.ires.eq.8.or.ires.eq.2)then
            read(iustat,771)iorg1,org2,lar,xlatr,lor,xlonr,zres
            if(iulst.gt.0)write(iulst,771)iorg1,org2,lar,xlatr,lor,
     &      xlonr,zres
            call timsec(iyear,imonth,iday,ihr,iorg1,org2,tph0)
771         format(i5,f5.2,2(i5,f5.2),f5.2)

c    lat/long are -ve for S/W  - change back for fold subr.
            ins1='N'
            if(lar.lt.0)then
              lar=iabs(lar)
              ins1='S'
            endif
            iew1='E'
            if(lor.lt.0)then
              lor=iabs(lor)
              iew1='W'
            endif      

            call fold(yres,xres,lar,ins1,xlatr,lor,iew1,xlonr)
          endif
          if(ires.eq.8.or.ires.eq.9)fixepi='F'
          if(ires.eq.9)fixdep='F'
        endif

        if(ires.eq.9.or.ires.eq.7.and.iulst.gt.0)write(iulst,772)
772     format(' ***** hypocenter fixed by operator ... ires = 9 *****'
     &  /)
        if(ires.eq.2.or.ires.eq.7.and.iulst.gt.0.or.ucase(fixor)
     &  .eq.'F'.or.test(31).eq.0.0)write(iulst,773)
773     format(' ***** origin time fixed by operator .. ires = 2 *****'
     &  /)
        if((ires.eq.1.or.abs(test(31)).le.2.).and.iulst.gt.0)
     &  write(iulst,774)
774     format(' ***** depth fixed by operator .. ires = 1 or test(31)'
     &  ,'<= 2 *****'/) 
        if(iulst.gt.0.and.(ires.eq.8.or.abs(test(31)).le.1.0))then
         write(iulst,775)                                        
        endif 
775     format(' ***** epicenter fixed by operator .. ires = 8',
     &  ' *****'/) 

c    setup starting hypocenter, xh
        ix=1
        iy=2
        iz=3
        io=4
        nn=2*nl-1
        xh(1)=xres
        xh(2)=yres
        xh(3)=ztr

        if(inform.eq.'N')then
        
c 10/94: fix to header value if test(31)=+2, leave at ztr if test(31)=-2
c---fixed depth  Added test(31)=1 to fix at depth on phase header
          if(ucase(fixdep).eq.'F'.or.test(31).eq.2.0.or.
     &     abs(test(31)).le.1.and.depth.ne.'     ')xh(3)=zresn
c---starting depth. 
          if(ucase(fixdep).eq.'S')xh(3)=zresn
c---fixed epicenter
          if(ucase(fixepi).eq.'F'.or.ucase(fixepi).eq.'S'.or.
     &     abs(test(31)).le.1.)then
            xh(1)=xresn
            xh(2)=yresn
            ix=1
            iy=2
            iz=3
            io=4
            nn=2*nl-1

          endif
        endif

c 4/94: fix epicenter if test(31)=1          
          if(abs(test(31)).le.1.0)fixepi='F'

c 5/94: fix depth if abs(test(31))<=2          
          if(abs(test(31)).le.2.0)fixdep='F'
          
c 5/94: fix origin time if test(31)=0          
          if(test(31).eq.0.0)fixor='F'

          
c change 10/93: added fixdep and data to window & changed ielv to iselv  
c 4/94: added parm,fixor & isort to window
c 10/94: added oterr to window
c--------------------------------------------------------------------------
c   enter a loop to try all start depths and select solution with smallest
c   rms unless depth is fixed or a starting depth is provided in S-file
c--------------------------------------------------------------------------
c
      if(fixdep.ne.'F'.and.fixdep.ne.'S') then
         min_rms= 999999.0
c
c   find if any difference phases that requres initializaiton
c   of input variables since some variables times rare replaced
c   bt e.g. S-P times in hypoloc1, hard to figure out exactly which
c   easier to read all again
c
         if(n_start_depths.gt.1) then
            diff_phase=.false.
            do i=1,nphase          
              if(ip(i).eq.9) diff_phase=.true.
            enddo
         endif
c
         do i=1,n_start_depths
            if(n_start_depths.gt.1) then
                if(diff_phase) then   ! rered all from 2. time
                   call getphasn(ks,iazflag,st,phase,pr1,pr,pr3,ip,
     &             tp,fmp,fixdep,depth,fixepi,yres,xres,orgsec,fixor,
     &             iulst,data,test,distind,narriv,imap,xmag,magtype,
     &             oldrms,appar_veloc)
                endif
                xh(3)=start_depth+(i-1)*start_depth_increment
             endif
c
             call hypoloc(nphase,st,maxelv,phase,tp,dtwt,
     *       ip,x0,y0,iselv,dl,
     &       ires,xnear,xfar,xh,tph0,nmoho,nconrad,test,
     *       iulst,xh1,
     &       tph,std1,dtwt1,tpc,im,dt,dlt,az0,aninc,
     *       ips,rms,xk,ndata,icd,
     &       fixepi,fixdep,fixor,dtw1,distind,trphs,
     *       vapp,azapp,alatm,alonm,
     &       data,isort,di,oterr,nzcount,baz0,scorr,appar_veloc)
c
c   find minimum rms
c
             if(rms.lt.min_rms) then
                min_i=i
                min_rms=rms
             endif
c            write(6,*) i,rms, xh1
         enddo
c        write(6,*) min_i
c
c   if only one start depth, continue, else repeat with that
c   start depth unless the last
c
         if(n_start_depths.gt.1.and.min_i.ne.n_start_depths) then
             if(diff_phase) then
                 call getphasn(ks,iazflag,st,phase,pr1,pr,pr3,ip,
     &           tp,fmp,fixdep,depth,fixepi,yres,xres,orgsec,fixor,
     &           iulst,data,test,distind,narriv,imap,xmag,magtype,
     &           oldrms,appar_veloc)
             endif
c
             xh(3)=start_depth+(min_i-1)*start_depth_increment
             call hypoloc(nphase,st,maxelv,phase,tp,dtwt,ip,
     *       x0,y0,iselv,dl,
     &       ires,xnear,xfar,xh,tph0,nmoho,nconrad,
     *       test,iulst,xh1,
     &       tph,std1,dtwt1,tpc,im,dt,dlt,az0,aninc,
     *       ips,rms,xk,ndata,icd,
     &       fixepi,fixdep,fixor,dtw1,distind,trphs,
     *       vapp,azapp,alatm,alonm,
     &       data,isort,di,oterr,nzcount,baz0,scorr,appar_veloc)
         endif
c
      else   ! location when depth fixed or one start depth

        call hypoloc(nphase,st,maxelv,phase,tp,dtwt,ip,x0,y0,iselv,dl,
     &  ires,xnear,xfar,xh,tph0,nmoho,nconrad,test,iulst,xh1,
     &  tph,std1,dtwt1,tpc,im,dt,dlt,az0,aninc,ips,rms,xk,ndata,icd,
     &  fixepi,fixdep,fixor,dtw1,distind,trphs,vapp,azapp,alatm,alonm,
     &  data,isort,di,oterr,nzcount,baz0,scorr,appar_veloc)
      endif
      one_rms=rms   ! save rms this event, now used in grid search
c

c 10/94: put variance in covar
        do i=1,3
         do j=1,3
          covar(i,j)=var(i,j)
         enddo
        enddo                 
        
        if(nphase.lt.2)then
c          write(iulst,'(/''   Less than three phases for this event:'',
c     &    '' Not processed''/)')
          go to 9
        endif

        if(icd.eq.4.or.icd.eq.6)go to 9

c  minimum rms errors
        erh=sqrt(std1(ix)**2+std1(iy)**2)   
        
c change 9/94: output sqrt(var(i,i)) and 3 off-diagonal terms
c of complete covariance matrix
        erx=std1(ix)                    
        ery=std1(iy)
        erz=std1(iz)
        cvxy=rearth*rearth*var(ix,iy)
        cvxz=rearth*rearth*var(ix,iz)
        cvyz=rearth*rearth*var(iy,iz)

c        write(iulst,'(8f8.2)')xh1(2)/degtorad,xh1(1)/degtorad,
c     &  alatm,alonm

c  write start and end solutions on unit 30
c        write(30,'(8f8.2)')xh1(2)/degtorad,xh1(1)/degtorad,xh1(3),
c     &yres,xres,zresn

c calculate distance and azimuth of epicenter from mean station
c position
        call delaz(xh1(2),xh1(1),dekmm,dedegm,azzm,
     &  alatm*degtorad,alonm*degtorad)
CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
c this line inserted by M. villagran to compute backazimut
c at once and use it after for the residuals
c        call delaz(alatm*degtorad,alonm*degtorad,dekmm,
c     *  dedegm,azb,xh1(2),xh1(1))
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXxxx
        if(azapp.lt.0.)azapp=azapp+360.
c        write(27,'(8f8.2)')dedegm,azzm,azapp,vapp

c  calculate azimuthal spread of stations
c 10/94: changed gap calculation to sort using azimuth
        call r4sort(nphase,az0,isort)
        j1=0                          
        j2=0
        azmax=0.0
        do i=1,nphase
         j=isort(i)
         if(dtw1(j).gt.0.0.and.j1.eq.0)then
          j1=j             
          az1=az0(j1)
         elseif(dtw1(j).gt.0.0.and.j2.eq.0)then
          j2=j       
          az2=az0(j2)
          azgap=az0(j2)-az0(j1)
          if(azgap.gt.azmax)azmax=azgap
          j1=j2
          j2=0
         endif
        end do
        azmax1=360-az2+az1
        if(azmax1.gt.azmax)azmax=azmax1
        igap=int(azmax+0.49999)
        if(iulst.gt.0.and.(.not.multi_model))
     *  write(iulst,'(/'' Azimuthal Gap in Station '',
     &  ''Coverage'',i4,'' degrees''/)')igap

c  calculate coda magnitudes
        fmag=0.0
        kt=0

        do i=1,nphase
          fma(i)=0.0
          if(fmp(i).gt.0.0)then
            kt=kt+1
            fma(i)=test(7)+test(8)*alog10(fmp(i))+test(9)*dlt(i)+fmgc(i)
            fmag=fmag+fma(i)
          endif
        end do

        if(kt.ne.0)fmag=fmag/float(kt)

c 9/94: if magmitude=0 set it to value on header
        if(fmag.eq.0.0)fmag=xmag

c    convert epicenter to geographic lat/long

        call unfold(xh1(iy),xh1(ix),la1,ins1,ala1,lo1,iew1,alo1)
        lo2=lo1
        la2=la1
        alo2=alo1
        ala2=ala1

c changed 6/98 to separately assign signs - were wrong for -0.5 deg
        sgnlo2=' '
        if(iew1.eq.'W')then
         if(test(93).gt.0.0)then
          lo2=360-lo1
          if(alo1.gt.0.)then
           lo2=lo2-1
           alo2=60.-alo1
          endif 
         else
          sgnlo2='-'
         endif  
        endif 
        sgnla2=' '
        if(ins1.eq.'S')then
         sgnla2='-'
        endif 

c 10/94: changed test(31).eq.2 to abs(test(31)).le.2
        fd=' '
        if(ires.eq.1.or.ires.eq.9.or.abs(test(31)).le.2.)fd='*'
        
        fo=' '
        if(ires.eq.2)fo='*'

c    convert origin time to standard format
      call sectim(tph,iyr,jday,imnth,idy,ihn,imm,xhm)
        
c 3/94: save for data output
        xhmsave=xhm
        
c 4/94 read original month, day & year to which arrival times are referenced        
c2000        read(data(1)(2:10),'(i2,1x,2i2)')iyr1,imnth1,idy1                  
        read(data(1)(2:10),'(i4,1x,2i2)')iyr1,imnth1,idy1                  

c calculate difference in hours to be added to the arrival times        
c            call timsec(iyear,imonth,iday,ihr,iorg1,org2,tph0)
        call timsec(iyr1,imnth1,idy1,0,0,0.,tph1)
        call timsec(iyr,imnth,idy,0,0,0.,tph2)
        timdiff=sngl((tph2-tph1)/3600.d0)
c        write(iulst,*)' time diff ',timdiff
        
c  output hypo71 compatible summary
c2000        idd=iyr*10000+imnth*100+idy
        if(iyr.lt.2000) i=iyr-1900
        if(iyr.ge.2000) i=iyr-2000
        idd=i*10000+imnth*100+idy
 
        if(nzcount.eq.0)iddd=0
        
c    dmin = dist of event from closest station
        dmin=dlt(im)
        if(dmin.gt.999.9)dmin=999.9
        if(rms.gt.99.99)rms=99.99
        if(erh.gt.999.9)erh=999.9
        if(erz.gt.999.9)erz=999.9
        if(erx.gt.999.9)erx=999.9
        if(ery.gt.999.9)ery=999.9
        if(oterr.gt.999.99) oterr=999.99   ! change jh march 6, 96

c change JH 3/93: add zeros to hr,min format
c----------------------------------------------------------------------
        idmin=dmin+0.5
c       if(nzcount.gt.0)then
c  following fix by fernando carrilho to avoid orign time to be zero
c  when locang in sequence
        if(nzcount.gt.0.or.data(1)(11:11).eq.'F')then
         write(thrmin,'(2i2)')ihn,imm          
        else
         thrmin='    '
         xhm=0.0
        endif  
        do i=1,4
          if(thrmin(i:i).eq.' ')thrmin(i:i)='0'
        enddo
c changed 4/92: depth is always measured relative to the origin (sea level for test(40)=0)
c       if(test(40).eq.0.0)xh1(iz)=xh1(iz)-float(maxelv)*.001 

c 3/94: xsave, ysave used for location difference
c (geocentric, cannot be used for output j.j. 5/94)
        xsave=xh1(ix)
        if(test(93).gt.0.0)then
         if(xsave.ge.pi)xsave=xsave-2.*pi
         if(xsave.le.-pi)xsave=xsave+2.*pi
        endif 
        ysave=xh1(iy)
        zsave=xh1(iz)       
        
       if(xh1(iz).gt.999.99)xh1(iz)=999.99

c 9/94: output erx, cvxy, cvxz, cvyz so error ellipses can be calculated
c 10/94: added origin time error
        if(iulst.gt.0.and.(.not.multi_model))
     *  write(iusum,952)idd,thrmin,xhm,la2,ala2,lo2,
     &  alo2,xh1(iz),fd,fmag,ndata,igap,dmin,rms,erh,erz,erx,cvxy,
     &  cvxz,cvyz,oterr
952     format(i6,1x,a4,f6.2,i3,1x,f5.2,i4,1x,f5.2,1x,f6.1,
     +  a1,f6.1,i3,i4,f5.1,f5.2,3f5.1,4e10.3)

c accumulate mean square rms value
        if(nphase.gt.3.and.rms.le.test(43))then
          ievent=ievent+1
          rmssum=rmssum+rms*rms
        endif

c  output residual summary
        linecount=0

c changed format 4/94 BRL, again 9/94
        if(iulst.gt.0.and.(.not.multi_model))
     *  write(iulst,'(/,'' stn   dist   azm  ain w phas'',
     &   ''    calcphs hrmn tsec  t-obs  t-cal    res   wt di'')')

        kst=1
        res=0.0

c   unweighted rms calculation
c wtmax1 is the maximum weight originally specified as 1
c it is used to renormalize all the final weights
        wtmax1=0.0
        ndd=0

        do kst=1,nphase
         if(dtwt1(kst).gt.wtmax1.and.ip(kst).eq.0.and.phase(kst).ne.
     &   'AZ  ')wtmax1=dtwt1(kst)

c change 4/94: dtw1(kst) now .ge.0 - was previously .gt.0 allowing
c bisquare weighting to remove phases
         if(dtw1(kst).ge.0.0.and.phase(kst)(1:2).ne.'AZ')then
          res=res+dt(kst)**2
          ndd=ndd+1
         endif
        end do

        if(wtmax1.eq.0.0)wtmax1=1.0
        if(ndd.ne.0)res=sqrt(res/float(ndd))

c    process residuals------------------------------------------------------------------

c 4/94: sort stations by distance, dlt(i) in isort(j)
        call r4sort(nphase,dlt,isort)
c
c   now sort so the distance sorted phase lines remain in the same order
c   as in the original file
c
        old_stat=st(isort(1))
        old_dist=dlt(isort(1))
        k=0
        l=0
        nvalid=0

        do i=1,nphase

c          5/94: count valid phases
          if(dtwt(i).gt.0.0.and.dtw1(i).gt.0.0)nvalid=nvalid+1

           l=l+1
           if(st(isort(l)).eq.old_stat ! both station and distance
     *     .and.dlt(isort(l)).eq.old_dist) then
              k=k+1
              xlt(k)=isort(l)
           else
              if(k.gt.1) then
                  call r4sort(k,xlt,ksort)
                  m=1
                  do j=l-k,l-1
                     isort(j)=xlt(ksort(m))
                     m=m+1
                  enddo
              endif
              old_stat=st(isort(l))
              old_dist=dlt(isort(l))
              k=1
              xlt(k)=isort(l)
           endif
         enddo
c<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<        
                                                                                       
c 3/94: look for first phase record index (isindex) in data array
        isindex=2
        
        do while (data(isindex)(80:80).ne.'4'.and.data(isindex)(80:80)
     &  .ne.' ')
          isindex=isindex+1
        enddo
        
        yquery=ucase(yter)
        nazimuth=0
        prevstat='    '
        
c 4/94: changed loop index to k1 and distance sort index to k
        do k1=1,nphase

c 4/94: added pause for screen print
          if(yquery.eq.'Y'.and.linecount.gt.maxline)then
           write(*,'('' RETURN to continue, Q to quit printout '',$)')
           read(*,'(a1)')yquery
           if(ucase(yquery).ne.'Q')yquery='Y'
           linecount=0
          endif 

c k is the index of the sorted phase data which includes azimuths
          
          if(test(71).eq.0.0)then
           k=k1
          else
           k=isort(k1)  
          endif 
          
c imap is an array of index addresses in the original data array
          is=imap(k)   
         
c count the azimuths        
          if(phase(k)(1:2).eq.'AZ')nazimuth=nazimuth+1                                   
           
c          write(*,*)st(k),phase(k),data(is)(1:28)                     
c          read(*,*)

c 10/93: added '*' to showed changed weights and phases
          phsflag=' '
          wtflag=' '
          if(dtw1(k).ne.dtwt(k).and.ip(k).ne.9)wtflag='*'
          if(trphs(k)(1:4).ne.phase(k).and.phase(k)(1:2).ne.'AZ'.and.
     &    ips(k).ne.1.and.phase(k)(1:4).ne.'    ')phsflag='*'

c accumulate residual sums
c 4/94: added pres2 & sres2 to calculate rms deviation
          if(phase(k)(1:2).ne.'AZ'.and.ips(k).ne.1.and.ip(k).le.4)then
            wtt=(4.-float(ip(k)))/4.

c 10/93: exclude invalid phases
            if(dtw1(k).le.0.0)wtt=0.0
            if(rms.le.test(43))then
              do i=1,nstat
                if(s(i).eq.st(k))then
                  if(pr(k).eq.'S'.and.ip(k).ne.4.and.ips(k).ne.1)then
                    sres(i)=sres(i)+dt(k)*wtt 
                    sres2(i)=sres2(i)+(wtt*dt(k))**2
                    sw2res(i)=sw2res(i)+wtt*wtt*dt(k)
                    sknt(i)=sknt(i)+wtt
                    sknt2(i)=sknt2(i)+wtt*wtt
                    knts(i)=knts(i)+1
                  endif
                  if(pr(k).eq.'P'.and.ip(k).ne.4.and.ip(k).ne.9)then
                    pres(i)=pres(i)+dt(k)*wtt       
                    pres2(i)=pres2(i)+(wtt*dt(k))**2
                    pw2res(i)=pw2res(i)+wtt*wtt*dt(k)
                    pknt(i)=pknt(i)+wtt
                    pknt2(i)=pknt2(i)+wtt*wtt
                    kntp(i)=kntp(i)+1 
                  endif
                endif
              end do
            endif
          endif
          azz=az0(k)
          if(azz.lt.0)azz=azz+360
          if(dabs(tp(k)).gt.7200.)then
            tpp=sngl(tp(k)-tph)
            call sectim(tp(k),iyear,jday,imonth,iday,ihn,imm,xhm)
          else
            tpp=sngl(tp(k))
          endif

c   azimuth residual format
          if(phase(k)(1:2).eq.'AZ')then

c  subtract 180 from difference as input azimuth is relative to station
c  whereas calculated azimuth is relative to source (BRL 5/28/92)
c
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
c next 3 lines comented by m. villagran 
c the reason is that backazimuth must be calculated with geocentric
coordinates procedure (delaz) and not just az-180
c azb is calculated before at the same place where delaz is called
c           azb=azz-180.
c           if(azb.lt.0.0)azb=360.+azb
c           ttt2=sngl(tp(k))-azb
            ttt2=sngl(tp(k))-baz0(k)
c      write(6,*)'az0 = ',az0(k),'azb= ',baz0(k),'tp(k)= ',tp(k)
            if(ttt2.gt.180.)ttt2=360.-ttt2
            if(ttt2.lt.-180.)ttt2=360.+ttt2
            if(ttt2.gt.999.9)ttt2=999.9
            ttt=sngl(tp(k))
            if(ttt2.gt.999.9)ittt=999.9
            if(ttt2.lt.-99.9)ttt2=-99.9
            if(iulst.gt.0.and.(.not.multi_model))then

c  residual format change 10/93, 3/94, 9/94
              write(iulst,'(1x,a5,i5,f6.1,8x,a8,17x,2f7.1,
     &        f7.2,f5.2,a1,i2)')st(k),int(dlt(k)+.49999),azz,
c    &        phase(k),tp(k),azb,ttt2,degtorad*dtwt1(k),wtflag
     &        phase(k),tp(k),baz0(k),ttt2,degtorad*dtwt1(k),wtflag
     &        ,int(di(k)+.4999)
            endif
            
c 3/94:write azimuth residual into original data array
c 4/94: put <0 roundoff case in
            ittt=int(ttt2+.49999)
            if(ittt.gt.999)ittt=999
            if(ittt.lt.-99)ittt=-99
            write(data(is)(61:63),'(i3)')ittt            
             
c non-azimuth residuals
          else
            if(dlt(k).gt.99999.9)dlt(k)=99999.9
            if(tpp.gt.9999.9)tpp=9999.9
            if(tpp.lt.-999.9)tpp=-999.9
            if(tpc(k).gt.9999.9)tpc(k)=9999.9
            if(tpc(k).lt.-999.9)tpc(k)=-999.9
            if(dt(k).gt.999.99)dt(k)=999.99
            if(dt(k).lt.-99.99)dt(k)=-99.99
            if(dl(k).gt.999.99)dl(k)=999.99
            if(dtwt1(k).gt.999.99)dtwt1(k)=999.99
            if(fma(k).gt.999.99)fma(k)=999.99
            if(di(k).gt.99.)di(k)=99.

c residual output format for valid absolute arrivals
c 10/94: exclude difference parent phases if nzcount=0
            if(ips(k).eq.0.and.dtw1(k).ge.0.0.and.(ip(k).ne.9.
     &      or.nzcount.gt.0))then
              if(iulst.gt.0.and.(.not.multi_model)) then
c 2/2006 lot, 2 decimals for travel times
                if (tpp.lt.10000.0) then 
                  write(iulst,'(1x,a5,i5,f6.1,f5.1,1x,i1,1x,
     &          2a8,2i2,f5.1,2f7.2,f7.2,f5.2,a1,i2)')st(k),
     &          int(dlt(k)+.49999),azz,aninc(k),ip(k),phase(k),
     &          trphs(k),ihn,imm,xhm,tpp,tpc(k),dt(k),
     &            dtwt1(k)/wtmax1,wtflag,int(di(k)+.4999)
                else
                  write(iulst,'(1x,a5,i5,f6.1,f5.1,1x,i1,1x,
     &           2a8,2i2,f5.1,2f7.1,f7.2,f5.2,a1,i2)')st(k),
     &          int(dlt(k)+.49999),azz,aninc(k),ip(k),phase(k),
     &          trphs(k),ihn,imm,xhm,tpp,tpc(k),dt(k),
     &            dtwt1(k)/wtmax1,wtflag,int(di(k)+.4999)
                endif
              endif
c
c  2-02 jh  write ainc to data array
c
              write(data(is)(57:60),'(i4)') int(aninc(k)+0.5)

c modification 6/13/92 (BRL) to not print calculated times and residuals
c when weight less than zero
            elseif(dtw1(k).lt.0.0.or.ip(k).eq.9.and.nzcount.eq.0)then
              if(iulst.gt.0.and.(.not.multi_model))
     *        write(iulst,'(1x,a5,i5,f6.1,6x,i1,1x,
     &         a8,8x,2i2,f5.1,f7.1,20x,a1)')st(k),
     &        int(dlt(k)+.49999),azz,ip(k),phase(k),ihn,imm,
     &        xhm,tpp

c format for difference phases
            elseif(ips(k).eq.1.and.dtw1(k).ge.0)then
              tpp=sngl(tp(k))
              if(tpp.gt.999.99)tpp=999.99
              if(tpp.lt.-999.99)tpp=-999.99
              if(iulst.gt.0.and.(.not.multi_model))
     *        write(iulst,'(1x,a5,i5,f6.1,f5.1,1x,i1,1x,
     &        2a8,9x,2f7.1,f7.2,f5.2,a1,i2)')st(k),int(dlt(k)+.49999),
     &        azz,aninc(k),ip(k),phase(k),trphs(k),tpp,tpc(k),dt(k),
     &        dtwt1(k)/wtmax1,wtflag,int(di(k)+.4999)
            endif

c 3/94:write residual into original data array
            if(dtw1(k).ge.0.0.and.(ip(k).ne.9.or.nzcount.gt.0))then
c 5/94 write residual with f5.1, truncate if too large
             if(dt(k).lt.-99.9)dt(k)=-99.9
             if(dt(k).gt.999.9)dt(k)=999.9 
c             write(data(is)(64:68),'(f5.1)')dt(k)
             if (dt(k).lt.100..and.dt(k).ge.-10.) then
               write(data(is)(64:68),'(f5.2)')dt(k) ! lot 21/09/2005
             else
               write(data(is)(64:68),'(f5.1)')dt(k) ! lot 21/09/2005
             endif

c 3/94: and final normalized weight*10
             write(data(is)(69:70),'(i2)')int(.4999+
     &       10.*dtwt1(k)/wtmax1)     
            endif 

c 3/94: and delta & azimuth
            
      data(is)(71:79)=' '
      if(dlt(k).lt.10.0) write(data(is)(71:75),'(f5.2)')dlt(k) 
      if(dlt(k).lt.100.0.and.dlt(k).ge.10.0)
     *write(data(is)(71:75),'(f5.1)')(dlt(k) -0.01) 
cjh jan 02      if(dlt(k).lt.1000.0.and.dlt(k).ge.100.0)
cjh jan 02     *write(data(is)(71:75),'(f5.1)') dlt(k)
      if(dlt(k).ge.100)write(data(is)(71:75),'(i5)')int(dlt(k)+0.5) 

c mar 20001            write(data(is)(71:75),'(i5)')int(dlt(k)+.49999)            
            iazz=int(azz+.49999)
            if(iazz.lt.0)iazz=iazz+360
            write(data(is)(77:79),'(i3)')iazz            
          endif 
c          write(iulst,*)k1,k,imap(k)
        end do 

c 4/94: added blank printout at end
        if(.not.multi_model) write(iulst,'(''      '')')
        
c 3/94: output difference between this and previous solution
        if(data(1)(24:38).ne.'               ')then

         dor=sngl(tph-orgsec)
         ddx=(xsave-xresn)
         if(ddx.ge.pi)ddx=ddx-2.*pi
         if(ddx.le.-pi)ddx=ddx+2.*pi
         ddx=ddx*rearth*cos(ysave)
         ddy=(ysave-yresn)*rearth
         ddz=zsave-zresn                    
         if(iulst.gt.0.and.(.not.multi_model))then
          write(iulst,'(/'' Difference from previous solution:''/)') 
          write(iulst,'('' dorigin= '',f7.1,'' sec dx='',f8.1,
     &    '' km dy='',f8.1,'' km dz= '',f7.1,'' km drms= '',f5.2)')dor,
     &    ddx,ddy,ddz,rms-oldrms 
         endif

c 5/94: use rms<test(45) to accumulate differences   
         if(rms.le.test(45).and.float(nvalid).ge.test(46))then
           xhdiff(1)=xhdiff(1)+ddx
           xhdiff(2)=xhdiff(2)+ddy
           xhdiff(3)=xhdiff(3)+ddz
           xhdiff(4)=xhdiff(4)+dor

           xhd2(1)=xhd2(1)+ddx*ddx
           xhd2(2)=xhd2(2)+ddy*ddy
           xhd2(3)=xhd2(3)+ddz*ddz
           xhd2(4)=xhd2(4)+dor*dor
           idiff=idiff+1
         endif  
        endif     

c  xxlat & xxlon are used to write the solution into the Nordic
c  output file header      
c 10/94: changed conditions to ins1 and iew1 - xxlat and xxlon were always>0!   
        xxlat=float(la1)
        if(ins1.eq.'N')then
         xxlat=xxlat+ala1/60.
        else
         xxlat=-xxlat-ala1/60.
        endif 
        xxlon=float(lo1)
        if(iew1.eq.'E')then
         xxlon=xxlon+alo1/60.
        else
         if(test(93).gt.0.)then
          xxlon=360.-xxlon-alo1/60
         else
          xxlon=-xxlon-alo1/60.
         endif  
        endif   

c write new solution into data header, data(1)      
c save old header in datsave
c j.h. something wrong with lat,lon check
        if(xxlat.gt.90.0.or.xxlat.lt.-90.0) xxlat=90.0
        if(xxlon.gt.360.0.or.xxlon.lt.-360.0) xxlon=360.0

c brl 6/98: remove this - datsave stored in hyp.for
c        datsave=data(1)
c2000        write(data(1)(1:20),'(1x,i4,1x,2i2,1x,a4,f5.1)')iyr+1900,
        write(data(1)(1:20),'(1x,i4,1x,2i2,1x,a4,f5.1)')iyr,

     &   imnth,idy,thrmin,xhmsave
        write(data(1)(24:43),'(f7.3,f8.3,f5.1)')xxlat,
     &  xxlon,zsave   
c j.h.        write(data(1)(24:43),'(f7.3,f8.3,f5.1)')ysave/degtorad,
c j.h.     &  xsave/degtorad,zsave   

c old data gets overwritten: need to replace it
        write(data(1)(44:48),'(a5)')datsave(44:48)
        ndata1=ndata
        if(ndata1.gt.999)ndata1=999
        write(data(1)(49:51),'(i3)')nstation
        rmss1=rms
        if(rmss1.gt.99.9)rmss1=99.9
        write(data(1)(52:55),'(f4.1)')rmss1
        write(data(1)(56:80),'(a25)')datsave(56:80)
        write(data(1)(11:11),'(a1)') datsave(11:11)
        
c 10/94 look for error record
        k=2                                          
        do while (data(k)(80:80).ne.'E'.and.k.le.nhead)
         k=k+1
        enddo         
        if(data(k)(80:80).ne.'E')then

c no error record: move data array below header down 1
         do i=2,nrecord
          data(nrecord+3-i)=data(nrecord+2-i)
         enddo
         nrecord=nrecord+1
         nhead=nhead+1                                

c write errors in new record 2         
         k=2                               
         do i=1,79
          data(k)(i:i)=' '
         enddo 
         data(k)(80:80)='E'
        endif              
        
c write gap on error line   jh oct 98
        write(data(k)(2:8),'(a,i3)')'GAP=',igap
c write out errors into data(k)        
        write(data(k)(15:20),'(f6.2)')oterr
        write(data(k)(25:30),'(f6.1)')ery
        write(data(k)(33:38),'(f6.1)')erx
        write(data(k)(39:43),'(f5.1)')erz
        write(data(k)(44:79),'(3e12.4)')cvxy,cvxz,cvyz
c
c   check if high accuracy output
c
        l=0
        if(high_accuracy) then
           do i=2,nhead           ! find if a line already there
              if(data(i)(80:80).eq.'H') l=i
           enddo
c
c   if no H line, make a new one
c
           if(l.eq.0) then
             do i=nrecord,k+1,-1
                data(i+1)=data(i)
             enddo
             nrecord=nrecord+1
             nhead=nhead+1                                
             l=k+1    ! new record to write in
           endif
c
c  blank H record
c
           do i=1,79
              data(l)(i:i)=' '
           enddo 
           data(l)(80:80)='H'
c
c   write data
c
           data(l)(1:15)=data(1)(1:15)
           write(data(l)(17:22),'(f6.3)') xhmsave
           write(data(l)(24:59),'(f9.5,1x,f10.5,1x,f8.3,1x,f6.3)')
     *     xxlat,xxlon,zsave,rmss1
        endif

c taken out 31/1/2006, lot
        if(extension(1:3).eq.'BGx') then

c Following code added by bjb 14/2/2001 to insert BGS lines 93 and A3
c containing velocity model and starting parameters respectively to
c the readings format output. Lines are all shifted down by one
c before inserting the new line. If line type already exists then 
c it will be overwritten.

c Check if velocity model line already exists
         k=3
         do while (data(k)(79:80).ne.'93'.and.k.le.nhead)
            k=k+1
         enddo         
         
c     if no velocity model record: move data array below header down 1
         if(data(k)(79:80).ne.'93')then
            do i=3,nrecord
               data(nrecord+4-i)=data(nrecord+3-i)
            enddo
            nrecord=nrecord+1
            nhead=nhead+1                                

c write velocity model in new record 93         
            k=3
            do i=1,78
               data(k)(i:i)=' '
            enddo 
            data(k)(79:80)='93'
            do i=1,nl
               j=1+(i-1)*12
               write(data(k)(j:j+11),'(f5.2,1x,f5.2,a1)')v(i),d(i),'/'
            enddo
         else                   ! overwrite existing velocity model
            do i=1,78
               data(k)(i:i)=' '
            enddo 
            do i=1,nl
               j=1+(i-1)*12
               write(data(k)(j:j+11),'(f5.2,1x,f5.2,a1)')v(i),d(i),'/'
            enddo
         endif              
c 
c Next add location parameter line containing start depth,
c xnear, xfar and vpvs
c
c Check for existing line type A3
c
         k=4
         do while (data(k)(79:80).ne.'A3'.and.k.le.nhead)
            k=k+1
         enddo         

c no location parameter record: move data array below header down 1
         if(data(k)(79:80).ne.'A3')then
            do i=4,nrecord
               data(nrecord+5-i)=data(nrecord+4-i)
            enddo
            nrecord=nrecord+1
            nhead=nhead+1                                

c write start depth, xnear, xfar and vpvs to new line type A3
            k=4
            do i=1,78
               data(k)(i:i)=' '
            enddo 
            data(k)(79:80)='A3'
c            write(data(k)(3:5),'(f3.0)') ztr
c            write(data(k)(7:12),'(f6.1)') xnear
c            write(data(k)(14:19),'(f6.1)') xfar
c            write(data(k)(21:24),'(f4.2)') pos
c changed lot 24/5/2005
            write(data(k)(3:5),'(f3.0)') ztr
            write(data(k)(7:10),'(f4.0)') xnear
            write(data(k)(12:15),'(f4.0)') xfar
            write(data(k)(17:20),'(f4.2)') pos
c            return
         else                   ! overwrite existing A3 line
            do i=1,78
               data(k)(i:i)=' '
            enddo 
c            write(data(k)(3:5),'(f3.0)') ztr
c            write(data(k)(7:12),'(f6.1)') xnear
c            write(data(k)(14:19),'(f6.1)') xfar
c            write(data(k)(21:24),'(f4.2)') pos
            write(data(k)(3:5),'(f3.0)') ztr
            write(data(k)(7:10),'(f4.0)') xnear
            write(data(k)(12:15),'(f4.0)') xfar
            write(data(k)(17:20),'(f4.2)') pos
c            return
         endif              
        endif
c 
c add xnear and xfar 
c
c Check for existing 'XNEAR' line type
c
        if (test(107).eq.1..and.distind.eq.'L') then
          k=3
          do while (data(k)(2:6).ne.'XNEAR'.and.k.le.nhead)
             k=k+1
          enddo         
c no location parameter record: move data array below header down 1
          if(data(k)(80:80).ne.'3'.and.data(k)(2:6).ne.'XNEAR')then
            do i=3,nrecord
               data(nrecord+4-i)=data(nrecord+3-i)
            enddo
            nrecord=nrecord+1
            nhead=nhead+1                                

c write xnear, xfar to new line 
            k=3
            data(k)(1:80)=
     &  ' XNEAR        XFAR        SDEP          '//
     &  '                                       3'
            write(data(k)(8:13),'(f6.1)') xnear
            write(data(k)(20:25),'(f6.1)') xfar
            write(data(k)(32:36),'(f5.1)') ztr
          else                   ! overwrite existing line
            write(data(k)(8:13),'(f6.1)') xnear
            write(data(k)(20:25),'(f6.1)') xfar
            write(data(k)(32:36),'(f5.1)') ztr
          endif              
        endif

        
        if(iulst.gt.0.and.(.not.multi_model))write(iulst,959)res
959     format(/,1x,'unweighted rms = ',f8.2)
        if(.not.multi_model)
     *  write(iulst,'(/,''------------------------------------------'',
     &  ''-----------------------------------'',/)')

        return
      endif


c change 10/93: made this section a separate function
      if(ifunct.eq.3)then
          if(ievent.gt.0)rmssum=sqrt(rmssum/float(ievent))
      
        if(iulst.gt.0.and.(.not.multi_model))then
          
c changed 4/94 to calculate & print rms deviations

         if(idiff.gt.0)then
          xnn=float(idiff)
          write(iulst,'(/,'' average differences from previous'',
     &     '' solutions: '',i8,'' events''/)')idiff          
          write(iulst,'(t28,'' mean'',t40,''  rms''/)')
          xmm=xhdiff(4)/xnn
          xme=sqrt(abs(xhd2(4)*xnn-xhdiff(4)**2))/xnn
          write(iulst,'('' origin time: '',t22,f10.1,'' sec'',
     &     t36,f10.1)')xmm,xme
          xmm=xhdiff(1)/xnn
          xme=sqrt(abs(xhd2(1)*xnn-xhdiff(1)**2))/xnn
          write(iulst,'('' longitude: '',t22,f10.1,'' km'',
     &     t36,f10.1)')xmm,xme
          xmm=xhdiff(2)/xnn
          xme=sqrt(abs(xhd2(2)*xnn-xhdiff(2)**2))/xnn
          write(iulst,'('' latitude: '',t22,f10.1,'' km'',
     &     t36,f10.1)')xmm,xme
          xmm=xhdiff(3)/xnn
          xme=sqrt(abs(xhd2(3)*xnn-xhdiff(3)**2))/xnn
          write(iulst,'('' depth: '',t22,f10.1,'' km'',
     &     t36,f10.1)')xmm,xme                       
          write(iulst,*)
         endif 
         
          write(iulst,980)
980       format(/,' average station residuals (weighted):'//,
     &    ' station',5x,'p residual rms dev  no p',5x,'s residual rms',
     &    ' dev  no s')
981       format(1x,a5,9x,2f8.2,i6,7x,2f8.2,i6)

          do i=1,nstat 
            ipf=0
            isf=0
            if(pknt(i).ne.0)then
              pmean=pres(i)/pknt(i)
              parg=pres2(i)-2.*pw2res(i)*pmean+pknt2(i)*pmean**2
              pres2(i)=sqrt(abs(parg)/pknt(i))
              pres(i)=pres(i)/pknt(i)
              ipf=1
            endif
            if(sknt(i).ne.0)then
              smean=sres(i)/sknt(i)
              sarg=sres2(i)-2.*sw2res(i)*smean+sknt2(i)*smean**2
              sres2(i)=sqrt(abs(sarg)/sknt(i))
              sres(i)=sres(i)/sknt(i)
              isf=1
            endif
            if(iulst.gt.0)then
              if(isf.eq.1.and.ipf.eq.1)write(iulst,981)s(i),pres(i),
     &        pres2(i),kntp(i),sres(i),sres2(i),knts(i)
              if(isf.eq.0.and.ipf.eq.1)write(iulst,981)s(i),pres(i),
     &        pres2(i),kntp(i)
982           format(1x,a5,38x,2f8.2,i6)
              if(isf.eq.1.and.ipf.eq.0)write(iulst,982)s(i),sres(i),
     &        sres2(i),knts(i)
            endif
          end do
c         if(ievent.gt.0)rmssum=sqrt(rmssum/float(ievent))
          write(iulst,'(/,'' Mean rms value ('',i4,'' events) = '',
     &    f12.3)')ievent,rmssum
        endif
      endif

      if(ifunct.eq.4)then

c    initialize p and s residual counts and sums
        do i=1,nstat
          kntp(i)=0
          knts(i)=0
          sknt(i)=0.
          pknt(i)=0.
          sres(i)=0.0
          pres(i)=0.0                        
          pres2(i)=0.0
          sres2(i)=0.0 
          pw2res(i)=0.0
          sw2res(i)=0.0
          sknt2(i)=0.0
          pknt2(i)=0.0
        end do

c  rmssum is used to get a mean rms value for all the events,
c  ievent is the total events located
        rmssum=0.0
        ievent=0

c added these to calculate differences from previous solution and rms
        idiff=0
        do i=1,4
         xhdiff(i)=0.0
         xhd2(i)=0.0
        enddo

      endif

      return
      end

      subroutine fold(alat,alon,la,ins,ala,lo,iew,alo)
c
c-------- given geographic coordinates compute geocentric lat and lon
c
c input:  la     degree portion of latitude in degrees
c         ins    n for north, s for south
c         ala    minutes portion of latitude
c         lo     degree portion of longitude
c         iew    e for east, w for west
c         alo    minutes portion of longitude
c output: alat   geocentric latitude in radians
c         alon   longitude in radians
      save
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (equrad = 6378.2064)
      parameter (polrad = 6356.5838)
      parameter (flat = (equrad - polrad)/equrad)
      parameter (c1 = (1.0 - flat)**2)
      parameter (c2 = halfpi*(1.0/c1 - 1.0))
c
      character*1 ins, iew
c
c changed 6/98 brl: fix roundoff problem
      alat = (float(la) + ala*1.6666667e-2)*rad
c ggtogc - convert from geographic to geocentric latitude
      if (halfpi-abs(alat) .ge. 0.02) goto 201
         alat = alat/c1-sign(c2,alat)
         goto 202
  201    alat = atan(c1*tan(alat))
  202    continue
      if (ins .eq. 'S')alat = -alat
      alon = (lo + alo*1.6666667e-2)*rad
      if (iew .eq. 'W') alon = -alon
      return
      end
 
      subroutine back (delat, delon, newlat, newlon, slat, slon)
c
c-------- back - calculate geocentric coordinates of secondary point from
c            step in latitude (km) and longitude(km)
c
c input:  delat     change in earthquake latitude in km (northward positive)
c         delon     change in earthquake longitude in km (westward positive)
c output: newlat    new earthquake geocentric latitude in radians
c         newlon    new earthquake longitude in radians
c
      save
      real newlat,newlon
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (equrad = 6378.2064)
      parameter (polrad = 6356.5838)
      parameter (flat = (equrad - polrad)/equrad)
c
      st0 = cos(slat)
      ct0 = sin(slat)
      call cvrtop(delat,delon,delta,az1)
      if (az1 .lt. 0.0) az1 = az1 + twopi
c use approximation of local radius for derivative of surface
c     distance with geocentric latitude.
c  more accurate formulation would be:
c      drdth = -r**3 * cos(alat)*sin(alat)*( (1.-flat)**(-2) - 1. )/a**2
c      dsd = sqrt(drdth**2 + r**2)
      radius = (cos(slat)**2/equrad**2 + sin(slat)**2/polrad**2)**(-.5)
      sdelt = sin(delta/radius)
      cdelt = cos(delta/radius)
      cz0 = cos(az1)
      ct1 = st0*sdelt*cz0+ct0*cdelt
      call cvrtop(st0*cdelt-ct0*sdelt*cz0, sdelt*sin(az1), st1, dlon)
      newlat = atan2(ct1, st1)
      newlon = slon + dlon
      if (abs(newlon) .gt. pi) newlon = newlon - sign(twopi, newlon)
      return
      end
 
      subroutine cvrtop(x, y, r, theta)
c
c-------- bruce julian
c
c-------- cvrtop - convert from rectangular to polar coordinates
c
c (output - may overlay x, y)
c
c-------- standard fortran funct. required:  atan2
c-------- funct. required:  hypot
c
      r = hypot(x, y)
      theta = 0.
      if ((y .ne. 0.) .or. (x .ne. 0.)) theta = atan2(y, x)
      return
      end
 
      real function hypot(a, b)
c
c-------- bruce julian
c
c
c-------- hypot - calculates euclidian distance, accurately and
c            avoids overflow
c
      real a, b
      real abs, l, s, t, sqrt
      l = abs(a)
      s = abs(b)
      if (s .le. l) goto 1
         t = s
         s = l
         l = t
   1  if (l .ne. 0.0) goto 2
         hypot = 0.0
         return
   2  s = s/l
      hypot = l*sqrt(s*s+1.0)
      return
      end
 
      subroutine delaz(slat, slon, dekm, dedeg, az0, eqlat, eqlon)
c
c-------- delaz - calculate the distance in km (approx equal to geocentric
c      distance times local radius), and azimuths in radians
c
c input:  slat     station geocentric latitude in radians
c         slon     station longitude in radians
c         eqlat    earthquake geocentric latitude in radians
c         eqlon    earthquake longitude in radians
c output: dekm     distance from earthquake to station in kilometers
c         dedeg    distance from earthqauke to station in degrees
c         az0      azimuth from earthquake to station measured clockwise
c                     from north in degrees
c
      save
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (equrad = 6378.2064)
      parameter (polrad = 6356.5838)
      parameter (flat = (equrad - polrad)/equrad)
c
      st0 = cos(eqlat)
      ct0 = sin(eqlat)
c use approximation of local radius for derivative of surface
c     distance with geocentric latitude.
c  more accurate formulation would be:
c      drdth = -r**3 * cos(slat)*sin(slat)*( (1.-flat)**(-2) - 1. )/a**2
c      dsd = sqrt(drdth**2 + r**2)
      radius = (cos(eqlat)**2/equrad**2 +
     *sin(eqlat)**2/polrad**2)**(-.5)
      ct1 = sin(slat)
      st1 = cos(slat)
      sdlon = sin(eqlon-slon)
      cdlon = cos(eqlon-slon)
      cdelt = st0*st1*cdlon+ct0*ct1
      call cvrtop(st0*ct1-st1*ct0*cdlon, st1*sdlon, sdelt, az0)
      dedeg = atan2(sdelt, cdelt)*deg
      dekm = radius*atan2(sdelt, cdelt)
      if (az0 .lt. 0.0) az0 = az0 + twopi
      if (az0 .ge. twopi) az0 = az0 - twopi
      az0 = 360.-az0*deg
c calculation of back azimuth if needed
c      call cvrtop(st1*ct0 - st0*ct1*cdlon, (-sdlon)*st0, sdelt, az1)
c      if (az1 .lt. 0.0) az1 = az1 + twopi
      return
      end
 
      subroutine unfold(alat,alon,la,ins,ala,lo,iew,alo)
c     unfold2
c
c-------- given geocentric lat and lon compute geographic coordinates
c            suitable  for printing
c
c input and output definition just reverse of entry fold
c
      save
      parameter (pi = 3.14159265)
      parameter (twopi = 2.0*pi)
      parameter (halfpi = 0.5*pi)
      parameter (rad = pi/180.)
      parameter (deg = 1.0/rad)
      parameter (equrad = 6378.2064)
      parameter (polrad = 6356.5838)
      parameter (flat = (equrad - polrad)/equrad)
      parameter (c1 = (1.0 - flat)**2)
      parameter (c2 = halfpi*(1.0/c1 - 1.0))
c
      character*1 ins, iew
c
c
c convert from geocentric lat and lon to geographic
c
c     alat     geocentric lat (radians)
c     alon                lon (radians)
c     la,ins,ala          lat in deg and min
c     lo,iew,alo          lon in deg and min
c
c gctogg - convert from geocentric to geographic latitude
      if (halfpi-abs(alat) .ge. 0.02) goto 403
         blat = c1*(alat + sign(c2,alat))
         goto 404
  403    blat = atan(tan(alat)/c1)
  404 continue
      ins = 'N'
      iew = 'E'
      ala1 = blat*deg
      la = ala1
      ala = abs(ala1 - la)*60.
      la = iabs(la)
      ins='N'
      if (ala1 .lt. 0.0) ins = 'S'
      alo1 = alon*deg
      lo = alo1
      alo = abs(alo1 - lo)*60.
      lo = iabs(lo)
      if (alo1 .lt. 0.0) iew = 'W'
      return
      end

      subroutine settest(test)
      dimension test(200)

c set default test parameters - see hypo71 documentation


c  any test values not set below are not used by hypocenter

c  test(2) = step length damping control. to enable this, make it smaller.
c  the damping factor,xk, is increased if the parameter change is > test(2) km.

      test(2)=500.0

c  test(7)-test(9) = duration magnitude coefficients (fmag) - see hypo71 manual
 
      test(7)=-0.87
      test(8)=2.00
      test(9)=0.0035

c  test(11) = maximum no of iterations

      test(11)=99.0

c  test(13) = increment in km at which auxiliary rms values are calculated

      test(13)=10.0

c  additional test values used by hypocenter

c     test(30) = initial value of damping factor, xk

      test(30)=0.005

c     test(31) = max degs freedom: set to 2 for fixed depth solution at header
c                value, -2 at STATION0.HYP value, 1 to fix epicenter at header
c                value, 0 to fix origin time, epicenter & depth at header values
c                 (alternatively set ires=1 as described below)

      test(31)=3.0

c     test(32) = magnitude of parameter changes (km) below which convergence is
c                assumed - increased by a factor of 10 initially

      test(32)=0.05

c     test(34) = minimum residual (sec) for normalizing residuals in
c                bisquare weighting 

      test(34)=0.1

c     test(35) = c value for bisquare weighting

      test(35)=4.685

c     test(36) = rms value below which bisquare residual weighting is applied
c                to residuals for local events - set to 1 to enable this weighting

      test(36)=0.0

c     test(37) = max no of increases in xk before fixing depth

      test(37)=10.

c change 9/94: changed default to 0.0 (least squares)
c     test(38) = 0.0 for least squares errors, =anything else, damped least
c                squares errors with xke error value (see below)  

      test(38)=0.0

c     test(39) = factor by which damping, xk, is increased for rms increases

      test(39)=4.

c change 10/93: changed old test(40) (no longer used) to option for
c setting the depth origin

c     test(40)=0.0 specifies that the depth origin is sea-level, with
c              layer 1 of the velocity model extended up to the maximum
c              elevation station. The depths of all located events are
c              then limited to sea-level.
c              Setting test(40)=1.0 specifies the maximum elevation
c              station in the station list (NOT the phase list) is
c              used as zero depth for both the event depth and the
c              velocity model (this was the old default)

      test(40)=0.0

c     test(41) = maximum distance from nearest station at which hypocentral
c                solutions will be generated

      test(41)=20000.

c     test(43) = maximum rms for residuals to be used in average 
c                station residual calculation.
c                 - doesn't affect hypocenter calculation

c                default vaue changed to 15.0 4/94
      test(43)=15.0

c     test(44)=3.0 Rayleigh wave (R phase) velocity in km/sec

      test(44)=3.0
 
c     test(45) (added 5/94) location differences only accumulated if rms<test(45)
      test(45)=50.0

c     test(46) (added 5/94) location differences only accumulated
c              if nmber of non-zero weight phases is > test(46)
      test(46)=3.0

c     test(47) (added 11/95) set to 1 to enable checking to prevent
c      depth going below moho or conrad when b or n phases present
      test(47)=0.0  
      
C     test(49) T phase velocity in km/sec (added 6/98)
      test(49)=1.484      

c     test(50) = flag for using azimuth phases. 0 disables

      test(50)=1.0

c     test(51) = L phase velocity in km/sec

      test(51)=3.5

c     test(52) = azimuthal error used in azimuth inversion  (degrees) 

      test(52)=5.0

c     test(53) = critical distance (km)  which the starting location
c                is moved out to if N phases are specified

      test(53)=130.

c     6/94: changed this to use 0 to disable, 1 to enable
c     test(56) = 1.0 enables starting location estimates from apparent
c                velocity, distance, azimuths, etc.
c                If test(56)<=0.0 epicenter is taken 0.15 km from
c                the first arrival station

      test(56)=1.0

c     test(57) = distance (geocentric km) beyond which iasp91 is used to
c                calculate travel times

      test(57)=1500.

c     test(58) = maximum apparent velocity (km/sec) for phase data to
c                be used

      test(58)=100.0

c     test(59) = critical distance (km) for PKP core phases

      test(59)=13000.

c     test(60) = seconds by which the arrival time difference between
c     two adjacent stations can exceed the travel time between them
c     Setting this to 0 disables the initial consistency check for
c     bad times in 'hypoloc'

      test(60)=5.0

c     test(61) = multiple of apparent velocity regression residual rms at
c     which arrival times are weighted to zero during start location
c     determination.  Reducing this value will cause arrivals to be
c     rejected when they do not conform to the plane wave set of arrivals
c     which is characteristic of distant events. Unless you are getting
c     a lot of messages ' xxx removed: Apparent velocity deviation =..',
c     in the output, I recommend against changing this default value
c     However, you can disable this feature by setting test(61)=0.0

      test(61)=3.0

c     test(62) = 0.0 limits the IASP91 phase list to 'basic', whereas
c     1.0 specfies all phases to be calculated each time. This can
c     speed up the program, particularly on a slow PC

      test(62)=1.0

c     test(63) is a value that specifies the types of phases used
c     by the subroutine trtime to be specified when calculating
c     travel times and their derivatives and resulting residuals
c     and rms.  The default value of 0 means that all 8 letters
c     of the phase ID are matched. However, first arrivals are used
c     before and after the critical distance for N and G phases,
c     respectively. See the trtime listing (hypoloc1) for details.

      test(63)=0.0

c     test(64) and test(65) are parameters added (10/93) to allow 
c     temporary increases in rms during the iterations. If 
c     rms < test(64)*rms1, where rms1 is the minimum value, 
c     the parameter step will be allowed for test(65) iterations. 
c     I strongly recommend against changing these parameters 
c     from their present defaults. To disable any increases in 
c     rms at all, set test(64)=0.0. This was how HYPOCENTER 
c     originally worked, but expererience with deep events has 
c     indicated that secondary minima can exist at shallow depth
c     in some situations. A factor of 2 increase in rms for a single
c     step was found to be sufficient to allow movement to the
c     lower rms at a greater depth.

      test(64)=2.0
      test(65)=3.0

c     setting test(66) to a non-zero value enables a printout
c     of the dtdx2 layered model travel time calculation errors
c     (critical distances exceeded, etc)

      test(66)=0.0

c     setting test(67) to a value other than zero forces
c     blank phases to be set to P. The default is to ignore
c     blank phases

      test(67)=0.0

c     test(68) is the P-velocity used in depth-phase depth determination

      test(68)=5.0      
      
c     test(69) is the distance (deg) at which PKiKP or PKP are used as the first
c     arrival instead of Pdiff

      test(69)=110.
      
c     test(70) is the maximum depth (km) that the hypocenter is allowed to move to

      test(70)=700. 
      
c     test(71) determines if the nordic output file is sorted by distance. Set to 0.0
c     to disable this sorting

      test(71)=1.0      
      
c     test(72) determines if an IASP91 phases is matched to the input phase ID 
c     (test(72)=0.0) or if the closest IASP91 phase to the observed travel time
c     is used (test(72)>0.0)

      test(72)=0.0
      
c     test(73) is the number of iterations for which hypoloc will attempt 
c     to match phase ID's when test(72)>0      

      test(73)=3.0
      
c     test(74)=1.0 enables the printout of the input phase data in PRINT.OUT

      test(74)=0.0
c  
c     test(75-78) Ml parameters, california standards, hutton and boore
      test(75)=1.0
      test(76)=1.11
      test(77)=0.00189
      test(78)=-2.09
c
c     test(79) is number of stations required to make a solution
      test(79)=1.0
c
c     test(80) is number of phases required to make a solution
      test(80)=2.0
c
c     test(81)=1.0 enables use of local events, 0.0 : do not use local events
      test(81)=1.0
c
c     test(82)=1.0 enables use of regional events, 0.0 : do not use regional events
      test(82)=1.0
c
c     test(83)=1.0 enables use of distant events, 0.0 : do not use distant events
      test(83)=1.0  
      
c     test(84)=1.0 enables ellipticity corrections for IASP91 travel times
      test(84)=1.0    
      
c     error ellipse parameters for local events test(85)-(86) added 9/94
c     test(85)=0.1 assumed error in arrival times for a weight of 1
c                  for local events
      test(85)=0.1
      
c     test(86)=8.0 degrees of freedom in test(85) for local events
      test(86)=8.0
      
c     test(87)=0.1 confidence level that solution will lie outside
c                   the confidence ellipsoid defined by the covariance
c                   matrix (default is 90%  confidence)
      test(87)=0.1                         
      
c     test(88)=10000. rms value (sec) at which residual weighting for
c                     distant events - set to zero to disable weighting
      test(88)=10.      

c     test(89)=1.0    enable use of depth phases in solution - 0 disables
      test(89)=1.0

c     test(90)=1.0    enable use of core phases (PKP, SKP, etc)
      test(90)=1.0  
      
c     test(91)=1.0    a priori error in distant event times
      test(91)=1.0

c     test(92)=8.0    degrees of freedom in test(91)for distant events
      test(92)=8.0                            
      
c     test(93)=0.0    setting test(93)=1 outputs longitudes between 0 and 360
c                     the default is -180<longitude<+180
      test(93)=0.0      
c
c     test(94)=0.0    value of residual below which phases with weight 4 is used
c                     again
      test(94)=0.0

c     test(95)=1.0    setting this to 1.0 disables core phases between 135 & 150 deg          
      test(95)=0.0
      
c     test(96)=0.0    set to 1 to enable variation of depth to find minimum rms
      test(96)=0.0       

c     test(97)=0.0     set to 1 to enable minute error correction
      test(97)=0.0
      
c     test(98)=0.0     set to 1 to enable spherical harmonic station corrections
      test(98)=0.0    
      
c     test(99) L phase weight: multiplied by phase weight. (added 6/98)
      test(99)=1.0
              
c     test(100) R phase weight: multiplied by phase weight. 
      test(100)=1.0
              
c     test(101) T phase weight: multiplied by phase weight. 
      test(101)=0.0

c     test(103) Min number of depth phases for starting depth (added 6/98)
      test(103)=1.0
      
c     test(104) min distance of epicenter from array for distant events            
      test(104)=30.0                   

c     test(105) Set this to 1.0 to enable the use of the 1D gradient model
      test(105)=0.0

c     test(106) Set this to 1.0 to only calculate magnitudes
      test(106)=0.0

c     test(107) Set this to 1.0 to take xnear/xfar from sfile
      test(107)=0.0
           
            
      return
      end

      subroutine getphase(nphase,st,phase,pr1,pr,pr3,ip,tp,fmp,kmin,
     &init,iuphs,iulst,narriv)
   
c      get a set of phases - hypo71 version (S and P on same record)
c      init=-1 means EOF

      save
      character*8 phase(*)
      character*5 st(*),statid
      character*1 prmk(3),srmk(3),pr1(*),pr(*),pr3(*),ucase
      double precision tp(*),tsec
      dimension ip(*),fmp(*)
      ks=0

10      read(iuphs,104,end=99)statid(1:4),(prmk(i),i=1,3),ipp,iyear,
     &  imonth,
     &  iday,khr,kmin,tpp,ts,(srmk(i),i=1,3),is,fmpp
        statid(5:5)=' '
        if(iulst.gt.0.and.statid.ne.'     ')then
          write(iulst,104)statid(1:4),(prmk(i),i=1,3),ipp,iyear,
     *    imonth,iday,
     &    khr,kmin,tpp,ts,(srmk(i),i=1,3),is,fmpp
104       format(a4,3a1,i1,1x,5i2,f5.2,7x,f5.2,3a1,i1,31x,f5.0)
        endif

c   blank record  - end of phase set, exit

        if(statid.eq.'     ')then
          if(ks.eq.0)go to 10
          nphase=ks
          init=2
          return
        endif

        if(ucase(prmk(2)).eq.'P')then
          ks=ks+1
          phase(ks)='P   '
          st(ks)=statid
          ip(ks)=ipp

c change 11/93: day 0 is day 1 in hypo71 format
          if(iday.eq.0)iday=1

          call timsec(iyear,imonth,iday,khr,kmin,tpp,tsec)
          tp(ks)=tsec
          fmp(ks)=fmpp
          pr1(ks)=prmk(1)
          pr(ks)=ucase(prmk(2))
          pr3(ks)=prmk(3)
        endif

        if(ucase(srmk(2)).eq.'S')then

          ks=ks+1
          if(ks.gt.narriv)then
           write(*,*)'Maximum arrivals exceeded - change hypparm.inc an'
     &     ,'d recompile sources'
           stop
          endif  
          phase(ks)='S   '
          st(ks)=statid
          ip(ks)=is
          call timsec(iyear,imonth,iday,khr,kmin,ts,tsec)
          tp(ks)=tsec
          fmp(ks)=0.0
          pr1(ks)=srmk(1)
          pr(ks)=ucase(srmk(2))
          pr3(ks)=srmk(3)

       endif

      go to 10

99    init=-1
      nphase=ks
      return
      end

      subroutine stations(statid,la,alat,ins,lo,alon,iew,ielv,dly,fmg,
     &scrst,nstat,iunit1,iunit2,init,nstats,mag_cor,use_eev)   !mag_corr,scrst added
      
      save
      character*1 ins,iew,ucase
      character*5 statid
      character*80 text
      logical use_eev
      dimension statid(*),la(*),alat(*),lo(*),alon(*),ielv(*),
     &dly(*),fmg(*),ins(*),iew(*)
      real mag_cor(5,nstats),scrst(nstats,9) ! mag_corr, spher. harm. stat. corr.

c   read station coordinates, elevations, delays, etc.

c   hypo71 version

c   statid:       station identifier (5 letters max.)
C   la:           degree portion of station's geographic latitude
c   alat:         minute  "                      "
c   ins:          'S' for south, 'N' for north
C   lo:           degree portion of station's geographic longitude
c   alon:         minute  "                      "
c   iew:          'E' for east, 'W' for west
c   ielv:         station elevation in meters (see note below)
c   dly:          station delay in seconds

c   as mentioned in the b.s.s.a. paper, we found it useful to include
c   station elevations in the calculation, as even small station elevation
c   differences dramatically stabilize solutions at close to zero depth.
C
c   ielv(i) are the station elevations in meters above a suitable datum
c   (e.g. sea level) - they must be positive up. all hypocentral depths
c   in this program are referenced to the highest stations elevation, which
c   is also the top of the velocity model. this referencing is essential
c   as HYPOCENTER will not allow negative hypocentral depths to occur.
C
      i=1
2     continue
      read(iunit1,'(a)',end=99) text
      if(text(2:2).eq.' ') then   ! 4 char station
         read(text,103)statid(i)(1:4),la(i),alat(i),ins(i),lo(i),
     &   alon(i),iew(i),ielv(i),dly(i),(mag_cor(k,i),k=1,5) !mag_corr added
     &,   (scrst(i,j),j=1,9)                                !scrst added
         statid(i)(5:5)=' '
      else    ! 5 char station
         read(text,1103)statid(i),la(i),alat(i),ins(i),lo(i),
     &   alon(i),iew(i),ielv(i),dly(i),(mag_cor(k,i),k=1,5) !mag_corr added
     &,   (scrst(i,j),j=1,9)                                !scrst added
      endif
103   format(2x,a4,i2,f5.3,a1,i3,f5.3,a1,i4,f6.2,5f5.2,9f6.2)  ! 4 char station
1103  format(1x,a5,i2,f5.3,a1,i3,f5.3,a1,i4,f6.2,5f5.2,9f6.2)  ! 5 char station
c
c   check if elevation is negtive at more than 1000 m
c
      if(text(1:1).eq.'-') ielv(i)=-ielv(i)
c
      fmg(i)=mag_cor(1,i)    !cmag
      if(statid(i).eq.'     ')go to 4
c change 10/93: ins changed to ins(i) in this line-was incorrectly
c printing 'N' & 'S' station ID's even though they had been read in
c correctly

c change 12/27: removed station printout
      if(iunit2.gt.0.and.(.not.use_eev))
     *write(iunit2,1203)statid(i),la(i),alat(i),ins(i),
     &lo(i),alon(i),iew(i),ielv(i),dly(i),fmg(i)
1203  format(1x,a5,i2,f6.3,a1,i3,f6.3,a1,i5,f6.2,5f5.2,9f6.2)  ! 5 char station

      ins(i)=ucase(ins(i))
      iew(i)=ucase(iew(i))
      i=i+1
      if(i.le.nstats)go to 2
      write(*,'('' Limit of '',i6,'' stations exceeded - edit'',
     &'' hypparm.inc and recompile sources'')')nstats 
      stop
4     nstat=i-1
      if(iunit2.gt.0.and.(.not.use_eev))write(iunit2,103)                                  
      init=0
      return
99    init=-1
      nstat=i-1
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      character*1 function ucase(a)

c    convert lower case single char to upper case - machine independent

      character*1 chr(26),ucchr(26),a
      data chr/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     &'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      data ucchr/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     &'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      do i=1,26
        if(a.eq.chr(i))then
          ucase=ucchr(i)
          return
        endif
      end do  
      ucase=a
      return
      end

      subroutine azcros(alat1,alon1,aza,alat2,alon2,azb, 
     *  dista,distb,alat,alon,ierr)                     

c Given the locations of two reference points and two azimuths of
c  great circles passing through those points, the
c  program computes the location of the crossing of two great circles
c   and the distances from two reference points. 
c   -- by Steve Bratt and Donna Williams, June 1986. 
                                                                               
c     modified 6/11/92 by B. Lienert
c   to calculate intersections on far side of globe
                                                                               
c  INPUT: 
c  alat1,alon1,alat2,alon2:  locations of reference points 
c  aza,azb: azimuths of great circles passing through points points
c           1 and 2, respectively                                  
c  OUTPUT:                                                         
c  dista,distb:  distance from points 1 and 2 to point             
c                great circles cross                               
c  alat,alon:  location of crossing point.                         
                                                                               
c  All distances, azimuths, and locations are input and output     
c    in degrees.                                                   
                                                                               
c  ierr : = 0 all O.K., = 1 lines do not cross within reasonable   
c         distance.                                                
                                                                               
c  SUBROUTINES CALLED:                                             
c    distaz                                                        
c    latlon, which calls cart
c                        rotate
c                        geog 
      save 
                                                                               
      degtrad=2.0*asin(1.0)/180.0   !changed 6/98 brl

c
c Find azimuth, back azimuth and radial distance between
c  stations.
c
      call distaz(alat1,alon1,alat2,alon2,delta,azi,baz)
c
c Find sign (clockwise = +) and value of angle measured from line
c   between two stations to aza and azb.
c
      ra = aza - azi
      if(abs(ra).gt.180.) ra = -sign((360.-abs(ra)),ra)
      rb = azb - baz
      if(abs(rb).gt.180.) rb = -sign((360.-abs(rb)),rb)
c
c If the signs of ra and rb are the same, the great circles along
c  those azimuths will not cross within a "reasonable" distance. 
c
      if(sign(1.,ra).eq.sign(1.,rb)) then
       ierr = 1 
       return   
      endif  
c            
      ra = abs(ra)
      rb = abs(rb)

      npode=0
      if((ra+rb).gt.180.) then
        npode=1
       
c added 6/11792 BRL
c this is the far sided case: (npode=1)
c reverse the sense of the two azimuths (i.e., take the triangle
c on the opposite side of the line joining the two stations)

        ra=180.-ra
        rb=180.-rb
      endif 
c                       
      ra = ra*degtrad   
      rb = rb*degtrad   
      rc = delta*degtrad
c                      
      c1=tan(0.5*rc) 
      c2=(ra-rb)*0.5 
      c3=(ra+rb)*0.5 
c                      
c          equations for solving for the distances
c                                                 
      f=(c1)*sin(c2)                            
      g=sin(c3)                                 
      h=cos(c2)*(c1)                            
      e=cos(c3)                                 
c                                                 
      c4=atan(f/g) 
      c5=atan(h/e) 
c                    
c       Compute distances (lengths of the triangle)
c                                                  
      distb=(c4+c5)/degtrad                      
      dista=(c5-c4)/degtrad                      
c                                                  
      if(dista.lt.0.0.or.distb.lt.0.0) then          
        ierr = 1                                     
        return                                       
      endif                                      
c                                                  
      if(dista.lt.distb) then                        
       dist = abs(dista)
       az = aza                                     
       alatin = alat1                               
       alonin = alon1                               
      else
       dist = abs(distb)
       az = azb                                     
       alatin = alat2                               
       alonin = alon2
      endif

c addition 6/11/92 BRL
c  antipodal case: 180 - (angular distance)

      if(npode.eq.1)then
       dist=180.-dist
       dista=180.-dista
       distb=180.-distb
      endif

      call latlon(alatin,alonin,dist,az,alat,alon)
      ierr = 0                                        
      return                                          
      end                                             

      subroutine distaz (alat1,alon1,alat2,alon2, delta,azi,baz)
c                                                               
c Calculate angular distance, azimuth and backazimuth between two
c  points on a sphere.                                           
c                                                                
c Input                                                          
c                                                                
c   ALAT1,ALON1  =  latitude and longitude of point 1.           
c   ALAT2,ALON2  =  latitude and longitude of point 2.           
c                                                                
c Output                                                         
c                                                                
c   DELTA  =  angular distance between points 1 and 2.           
c   AZI    =  azimuth from north of point 2 w.r.t. point 1.      
c   BAZ    =  azimuth from north of point 1 w.r.t. point 2.      
c                                                                
c All arguments are in degrees.                                  
c Latitude, longitude and DELTA are geocentric.                  
c Latitude is zero at equator and positive north.                
c Longitude is positive toward the east.                         
c AZI and BAZ are positive and measured clockwise from local north. 
c
c      implicit double precision (a-h,o-z)
c     real alat1,alat2,alon1,alon2,delta,azi,baz 
      save
      pi=3.14159265
      rtod=180./pi
      dtor=pi/180.
c                                                
      rlat1 = dtor*alat1                         
      rlat2 = dtor*alat2                         
      rdlon = dtor*(alon2-alon1)                 
c                                                
      clat1 = cos(rlat1)                                                       
      clat2 = cos(rlat2)                                                       
      slat1 = sin(rlat1)                                                       
      slat2 = sin(rlat2)                                                       
      cdlon = cos(rdlon)                                                       
      sdlon = sin(rdlon)                                                       
c                                                
      cdel = slat1 * slat2 + clat1 * clat2 * cdlon
      cdel = min(cdel,1.0)                                                     
      cdel = max(cdel,-1.0)                                                    
      yazi = sdlon * clat2                        
      xazi = clat1 * slat2 - slat1 * clat2 * cdlon
      ybaz = -sdlon * clat1                       
      xbaz = clat2 * slat1 - slat2 * clat1 * cdlon
c                                                 
      delta = rtod * acos(cdel)                                                
c     write(16,*)'delta ',delta
c      write(*,*)' xazi yazi ',xazi,yazi
      if(yazi.ne.0.0.or.xazi.ne.0.0)then
        azi = rtod * atan2(yazi,xazi)             
        baz = rtod * atan2(ybaz,xbaz) 
      else
        azi=0.0
        baz=0.0
      endif                                           
      if (azi.lt.0.) azi=azi+360.                 
      if (baz.lt.0.) baz=baz+360.                 
c                                                 
      return                                      
      end                                         
      subroutine cart (alat,alon,z,radius, x)     
c                                                 
c Convert a geographical location to geocentric cartesian coordinates,
c  assuming a spherical earth.                                        
c                                                                     
c The cartesian axis are such that                                    
c     - Axis 1 intersects equator at 90 deg longitude (east)          
c     - Axis 2 intersects north pole                                  
c     - Axis 3 intersects equator at  0 deg longitude                 
c                                                                     
c Input                                                               
c                                                                     
c   ALAT  =  latitude (degrees)                                       
c   ALON  =  longitude (degrees)                                      
c   Z     =  depth                                                    
c   RADIUS  =  radius of the earth                                    
c                                                                     
c Output                                                              
c                                                                     
c   X(1:3)  =  vector of geocentric cartesian coordinates             
c              axis 1 intersects equator at  0 deg longitude          
c              axis 2 intersects equator at 90 deg longitude          
c              axis 3 intersects north pole 
c                                           
      parameter (dtor = 1./57.2957795)      
      dimension x(3)                        
c                                           
      r123 = radius - z                     
      r13 = r123*cos(dtor*alat)             
      x(1) = r13*sin(dtor*alon)            
      x(2) = r123*sin(dtor*alat)           
      x(3) = r13*cos(dtor*alon)            
c                                          
      return                               
      end                                  

      subroutine geog (x,radius, alat,alon,z)
c                                            
c Convert geocentric cartesian coordinates to a geographical location,
c  assuming a spherical earth.                                        
c                                                                     
c The cartesian axis are such that     
c     - Axis 1 intersects equator at 90 deg longitude (east)
c     - Axis 2 intersects north pole                        
c     - Axis 3 intersects equator at  0 deg longitude       
c                                                           
c Input                                                     
c                                                           
c   X(1:3)  =  vector of geocentric cartesian coordinates   
c   RADIUS  =  radius of the earth                          
c                                                           
c Output                                                    
c                                                           
c   ALAT  =  latitude (degrees)                             
c   ALON  =  longitude (degrees)                            
c   Z     =  depth                                          
c                                                           
      parameter (rtod = 57.2957795)                         
      dimension x(3)                                        
c                                                           
      r13sq = x(3)*x(3) + x(1)*x(1)                             
      r13 = sqrt(r13sq)                                     
      r123 = sqrt(r13sq + x(2)*x(2))                          
      alon = rtod * atan2 (x(1),x(3))                       
      alat = rtod * atan2 (x(2),r13)                        
      z = radius - r123                                     
c                                                           
      return                                                
      end                                                   
      subroutine latlon (alat1,alon1,delta,azi, alat2,alon2)
c                                                           
c Find a point on a sphere which is a given distance and azimuth
c  away from another point.                                
c                                                          
c Input                                                    
c                                                          
c   ALAT1,ALON1  =  latitude and longitude of point 1.     
c   DELTA  =  angular distance between points 1 and 2.     
c   AZI    =  azimuth from north of point 2 w.r.t. point 1.
c                                                          
c Output                                                   
c                                                          
c   ALAT2,ALON2  =  latitude and longitude of point 2.     
c                                                          
c Subroutines called                                       
c                                                          
c   cart                                                   
c   rotate                                                 
c   geog                                                   
c                                                          
c All arguments are in degrees.                            
c Latitude, longitude and DELTA are geocentric.            
c Latitude is zero at equator and positive north.          
c Longitude is positive toward the east.                   
c AZI is measured clockwise from local north.              
c                                                          
      dimension x(3)                                       
c                                                          
      call cart (90.0-delta,180.0-azi,0.0,1.0, x)          
      call rotate (90.0-alat1,0.0,x)                       
      call geog (x,1.0, alat2,dlon,z)                      
      alon2 = mod(alon1+dlon+180.0,360.0) - 180.0          
c                                                          
      return                                               
      end                                                  
      subroutine rotate (alat,alon,x)                      
c                                                          
c Rotate a 3-vector represented in cartesian coordinates.  
c                                                          
c The cartesian coordinate system is most easily described 
c  in geographic terms.  The origin is at the earth's center. 
c  The axes are such that                                     
c     - Axis 1 intersects equator at 90 deg longitude (east)  
c     - Axis 2 intersects north pole                          
c     - Axis 3 intersects equator at  0 deg longitude         
c                                                             
c On input, the vector to be rotated has components X(i),i=1,2,3
c  in this system.  This procedure rotates the vector           
c  in the following two steps:                                  
c    1. Rotation by ALON degrees westward, about the 2-axis.    
c    2. Rotation by ALAT degrees southward,about the 1-axis.    
c                                                               
c On output, X contains the coordinates of the rotated vector.  
c                                                               
c Another way to interpret X on output:  as the components      
c  of the original vector in a rotated coordinate system.       
c  Put yourself on the earth's surface at the point having
c  latitude ALAT and longitude ALON.  Call this point P.  
c  This rotated system is also geocentric, in which       
c     - Axis 1 points east                                
c     - Axis 2 points north                               
c     - Axis 3 points up                                  
c  where east, north and up are the directions local to P.
c                                                         
      parameter (rtod = 57.2957795)                       
      dimension x(3)                                      
c                                                         
c Do it                                                   
c                                                         
      alatr = alat/rtod   
      alonr = alon/rtod   
      sinlat = sin(alatr) 
      coslat = cos(alatr) 
      sinlon = sin(alonr) 
      coslon = cos(alonr) 
c                         
      a = x(1) * coslon - x(3) * sinlon
      b = x(2)                         
      c = x(1) * sinlon + x(3) * coslon
      x(1) = a                         
      x(2) = b * coslat - c * sinlat   
      x(3) = b * sinlat + c * coslat   
c                                      
      return                           
      end                              

c
c  program to make proper waveform file names from header info
c  program can make a time change to all headers
c  program to make polarity changes to individual channels, only 
c          channels where station and component is gien in input
c          definition in wavfix.def, will be used
c
c  j. havskov, december 1995
c  Updates:
c  aug 2 96 by jh : 2 byte data were decleared as 4 bytes !!!
c--------------------------------------------------------------------
c  oct 98 by jh   : --------------    version 7.0 check ------------
c                   remove pc names, year 2000, 5 char agency
c  nov 5          : linux logic, system_c to systemc
c  feb 5          : include channel name change
c  june 11   lo   : use also Nordic file as input and wavfix.def
c  sep 9     jh   : make shure net code is not blank in output name
c  jan 10,2003 lo : apply individual channel time correction given in wavfix.tim
c  oct 20      jh : make it possible ot hardwire sample rate changes, look 
c                   for new_rate
c  feb 10 2004 lo : fix bug with net_code
c  may 12 2004 jh : possibel to change polarity by changing gain constat
c  mar 30 2006 lo : use converted station/component codes in output filenames
c  mar  5 2007 lo : add option to mark uncertain time, and command line options
c
      implicit none
c
c   general dimensions
c
      include 'seidim.inc'

c-- main header
      character*80 mainhead(max_trace)
c-- channel header
      character*1040 chahead	  
c-- input file name
      character*80 infile
c-- output file name 
      character*80 outfile
c -- for channel redefination
      character*5 stat_in
      character*4 comp_in
      logical change
      character*5 stat(max_trace)  ! staions in header
      character*4 comp(max_trace)  ! components in header
      logical chg_pol(max_trace)   ! true if channel pol changed
      real new_rate(max_trace)     ! new sample rate
      real cinter(max_trace),cstart(max_trace) ! start and interval each trace
      double precision ind_time_cor(max_trace) ! individual time correction
      character*80 text      ! general text string
      character*1 answer
      character*1 polarity_change    ! if yes, change polarity
      character*1 uncertain_time_change ! if yes mark time as uncertain
      logical exist          ! for file open
      logical same_file      ! if same name of in and output file
c-- merged file network code
      character*5 net_code,net_code_out
c-- counters, etc
      integer i,k,l,j
      integer nchan,nstat,nsamp     ! number of channels and samples
      integer*4 data4(max_sample) ! samples
      integer*2 data2(2*max_sample)   ! samples
c--- time and dates
      integer year,month,day,hour,min,year1,month1,day1,hour1,min1
      integer doy,doy1
      real sec, sec1
      double precision time_cor           ! time correction in seconds
      double precision msec               ! time correction in seconds
      integer khead           ! number of main headers
      character*1 replace_filename
c-- computer type
      logical sun,pc,linux
c
c   chan def block
c
      character*5 def_in_stat(200)  ! input station code in def file
      character*4 def_in_comp(200)  ! input component code in def file
      character*5 def_out_stat(200) ! output station code in def file
      character*4 def_out_comp(200) ! output component code in def file
      integer   def_chan_number(200)! channel number of current unit
      integer ndef_chan             ! number of channels defined
      common /def_chan/def_in_stat,def_in_comp,def_out_stat,
     *                 def_out_comp,def_chan_number,ndef_chan
c
c	  
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code,                  ! Error encoder.
     &          sei real num               ! Get real number
       integer  seiclen
C
       integer  
     &          read01,                    ! Input unit1.
     &          read02,                    ! Ditto 2.
     &          read03,
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       character*80 chr_file               ! File name
       real sei real num                   ! Real number
C
C    ============= end of list ==========
      real x(max_sample)
c-- for component rotation, not used in this routine
      real baz(max_trace)
      real        del_rot       ! delay rotated trace
      character*1 rot_comp(max_trace)  ! T or R
      logical rotate
      character*29 mainhead_text
c-- name of sfile
      character*40 nordic_file
c output file unit 
      integer write01
      character*1 choice
      character*80 line
      equivalence(data2,data4)
c question
      character*80 question
c 1 if filenr.lis
      integer in
c number of components defined in wavfix.tim
      integer ntime
      integer narg                            ! number of arguments
      character*80 arg(40)                    ! arguments


      common /signalx/x,rotate,baz,rot_comp,del_rot

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver
    
      replace_filename='N'
      net_code=' '
      polarity_change='n'
      uncertain_time_change='n'
      ntime=0
      time_cor=0.
      in=0
      call computer_type(sun,pc,linux)

c
c read command line options
c

c
c   get arguments
c
      call get_arguments(narg,arg)
      if (narg.ge.1) then
        do i=1,narg
          if (arg(i)(1:15).eq.'-uncertain_time') then
            uncertain_time_change='y'
          elseif (arg(i)(1:9).eq.'-polarity') then
            polarity_change='y'
          elseif (arg(i)(1:7).eq.'-infile') then
            infile=arg(i+1)
          elseif (arg(i)(1:10).eq.'-overwrite') then
            replace_filename='A'
          elseif (arg(i)(1:16).eq.'-time_correction') then
            call sei get values(1,arg(i+1), code )
            time_cor=array$(1)
          elseif (arg(i)(1:5).eq.'-help') then
            write(6,'(a)') 'wavfix' 
            write(6,'(a)') 'usage: wavfix -infile <infile> ' 
     &        //'[-uncertain_time -polarity] '
     &        //'[-time_correction <x in seconds> ]'
            write(6,'(a)') '-uncertain_time   add uncertain time flag '
     &                   //'to all channel headers'
            write(6,'(a)') '-polarity         change polarity'    
            write(6,'(a)') '-time_correction  apply time correction '
     &        //'of x seconds'
            stop
          endif
        enddo
        if (seiclen(infile).le.0) then
          write(*,*) 'give input file' 
          stop
        endif
        goto 30
      endif
        

c
c   hardwire possible sample rate changes
c
      do i=1,max_trace
         new_rate(i)=-1.0
      enddo


c
c   get def file for station codes, give file name
c
      text='wavfix.def'

      call read_def_chan(text,mainhead_text,net_code)
      call read_def_time('wavfix.tim',ntime)

      write(6,*)' This program will change header times in all headers'
      write(6,*)' with the same amount. The waveform file name will be'
      write(6,*)' changed at the same time and adjusted to the standard'
      write(6,*)' name.'
      write(6,*)' If no time correction is given, only the waveform'
      write(6,*)' names are adjusted.'
      write(6,*)' Optionally polarty can be changed for channels',
     *          ' listed in wavfix.def'
      write(6,*)' In addition, channels names can be changed if a'
      write(6,*)' wavfix.def file is available'

      if (ntime.eq.0) then
        write(6,*)
     &    ' Time correction in seconds, u for uncertain time, '
     &    //' return for no correction'
        read(5,'(a)') text
        if (text(1:1).eq.'u'.or.text(1:1).eq.'U') then
          uncertain_time_change='y'
          time_cor=0.
        else
          time_cor=sei real num(text,code)
        endif
      else
        write(6,*) 
     &    ' Time correction applied from file wavfix.tim '
      endif
      write(6,*)' Polarity change(y/n=default)'
      polarity_change='n'
      read(5,'(a)') polarity_change
      if(polarity_change.eq.'y') then
          write(6,*)' Sure you want to change polarity (y/n) ?'
          read(5,'(a)') answer
          if(answer.ne.'y') polarity_change='n'
      endif
      write(6,*)

220   continue

      write(*,*) ' Input options: (1) filenr.lis or wavfeform file name'
      write(*,*) '                (2) Nordic file'
      read(5,'(a1)') choice
      if (choice.ne.'1'.and.choice.ne.'2')goto 220

      if (choice.eq.'2') then
        write(6,*) ' Name of Nordic file'
        read(5,'(a40)') nordic_file
        if (nordic_file.eq.'nordic.fix') then
           write(*,*) ' Please rename your input file.'
           stop
        endif
      endif

225   continue

      if (choice.eq.'1') then
        question=' Filename or number, filenr.lis for all'
        call filename(question,infile)

        if (infile(1:3).eq.'EOF') stop
      endif

c
c   open file with file names
c	  	  
      if (choice.eq.'1') then
        if(infile(1:10).eq.'filenr.lis') then
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'filenr.lis',     ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
        in=1
        endif
        if (code .ne. e_ok$) then      
          write(6,*)' No filenr.lis file, make a dirf first'
          stop
        endif

      elseif (choice.eq.'2') then
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   nordic_file,      ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
        if (code .ne. e_ok$) then         
            write(6,*) 'file does not exist'
            stop
        endif
c
c open output file
c
        call sei open( unknown$+warn$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   'nordic.fix',     ! Filename.
     &                   write01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )



      endif


11     continue
c 
c----------------------------------------------
c   enter here for new event to name or fix
c----------------------------------------------
c
 1    continue 

      if (in.eq.1) then
        read(read01,'(7x,a)', end=999) infile
c-- check if end of group of events to name	  
        if(infile(1:4).eq.'    ') goto 999

c
c  read from Nordic file
c
      elseif (choice.eq.'2') then
        read(read01,'(a80)',end=999) line

        if(line(80:80).eq.'6') then
          infile=' '
          read(line(2:79),'(a78)') infile

c
c  check if file exists
c
          inquire(file=infile,exist=exist)
          if (.not.exist) then
               write(write01,'(a80)') line
               write(*,*) 'file does not exist: ',infile
               if (in.eq.1.or.choice.eq.'2') goto 1
               if (choice.eq.'1') goto 225
          endif
        else
          write(write01,'(a80)') line
          if (in.eq.1.or.choice.eq.'2') goto 1
          if (choice.eq.'1') goto 225
        endif
      endif

c
c   now read header for one event
c	  
 30   continue
      mainhead_text = ' '
c      net_code=' '
      net_code_out=net_code
      do i=1,5
        if (net_code_out(i:i).eq.' ') net_code_out(i:i)='_'
      enddo
c      time_cor=0.
      do i=1,max_trace
        ind_time_cor(i)=0.
      enddo
          chr_f_access$='direct'
          f_recl$=2048
          chr_file = infile
          call sei open( old$+stop$,       ! Open file & stop if erro.
     &                   ' ',              ! Prompt (n/a).
     &                   chr_file,          ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
      write(6,'(1x,a,a)') 'Input file name: ',infile(1:45)
       call seisinc                                                             
     *(read02,0,nchan,0,mainhead,chahead,0.0,0.0)
c
c   read header channel names, might be needed
c
      nstat=1
      do i=3,(nchan-1)/3+3
            read(mainhead(i),'(3(1x,2a4,a1,f7.2,1x,f8.2))')
     *      stat(nstat)(1:4),  comp(nstat),  stat(nstat)(5:5),  
     *      cstart(nstat),cinter(nstat),
     *      stat(nstat+1)(1:4),comp(nstat+1),stat(nstat+1)(5:5),
     *      cstart(nstat+1),cinter(nstat+1),	 
     *      stat(nstat+2)(1:4),comp(nstat+2),stat(nstat+2)(5:5),
     *      cstart(nstat+2),cinter(nstat+2)	 
            nstat=nstat+3		   		 
      enddo
 
c
c individual channel time correction
c
      if (ntime.ne.0) then
           read (mainhead(1)(34:59),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *     year,doy,month,day,hour,min,sec
           year=year+1900       
           call timsec(year,month,day,hour,min,sec,msec)
           do i=1,nchan
             if (seiclen(stat(i)).gt.0) then
               call set_time_chan(
     &           stat(i),comp(i),msec+cstart(i),ind_time_cor(i))
               write(*,*) ' time correction for '//stat(i)//comp(i)//
     &          ': ',ind_time_cor(i)
             endif
           enddo
      endif

c
c if individual correction for 1st channel, set time_cor to this value
c
      if (ind_time_cor(1).ne.0.) then
         time_cor=ind_time_cor(1)
      endif
c
c   if a time correction, change header
c
      if(time_cor.ne.0.) then
         read (mainhead(1)(34:59),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *   year,doy,month,day,hour,min,sec
         year=year+1900       
         call timadd(year,month,day,hour,min,sec,time_cor,
     *             year1,month1,day1,hour1,min1,sec1)  ! add correction
         call date_doy(doy1,day1,month1,year1)
         k=year1-1900
         write (mainhead(1)(34:59),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *   k,doy1,month1,day1,hour1,min1,sec1
      endif       
c
c if no individual time correction set values for channel correction to time_cor
c
      if (ntime.eq.0) then
        do i=1,nchan
          ind_time_cor(i)=time_cor
        enddo
      endif

c                                                                               
c  make output file name 
c             
      if ((ntime.ne.0.or.time_cor.ne.0.).and.
c     &    (replace_filename.ne.'A'.and.replace_filename.ne.'E')) then
c lot 24/5/2005
     &    (replace_filename.ne.'A'.and.replace_filename.ne.'E')
     &    .and.outfile(21:25).ne.net_code_out) then
        write(*,*) ' keep input file name as output file name '//
     &     ', (y)es,(n)o, (a)lways or n(e)ver ? '
        replace_filename=' '
        read(5,'(a)') replace_filename
        if (replace_filename.eq.'y') replace_filename='Y'
        if (replace_filename.eq.'n') replace_filename='N'
        if (replace_filename.eq.'e') replace_filename='E'
        if (replace_filename.eq.'a') replace_filename='A'
      endif

      outfile=' '
      if (replace_filename.ne.'N'.and.replace_filename.ne.'E') then
        outfile=infile
      else
         
c-- year                          
         outfile(3:4)=mainhead(1)(35:36)
         outfile(1:2)='19'
         if(mainhead(1)(34:34).eq.'1') outfile(1:2)='20'
         outfile(5:5)='-'               
c-- month                                    
         outfile(6:7)=mainhead(1)(42:43)		
         outfile(8:8)='-'
c-- day                                      
         outfile(9:10)=mainhead(1)(45:46)		
         outfile(11:11)='-'
c-- hr                                       
         outfile(12:13)=mainhead(1)(48:49)		
c-- min                                    
         outfile(14:15)=mainhead(1)(51:52)		
         outfile(16:16)='-'
c-- sec                                    
         outfile(17:18)=mainhead(1)(54:55)		
         outfile(19:20)='S.'
c
c convert station and channel for first channel and use for filename
c lot 07/03/2006
c
         stat_in = stat(1)
         comp_in = comp(1)
         call set_def_chan(1,stat(1),comp(1))
c
c-- network or station code, if not defined used from input fike name, else 
c   first station                  
c         if(seiclen(net_code).le.0) then
          if(seiclen(net_code_out).le.0.or.net_code_out.eq.'_____') then
c            if(infile(19:20).eq.'S.') then
            if(infile(19:20).eq.'S.'.and.nchan.gt.1) then
c              net_code=infile(21:25)
              net_code_out=infile(21:25)
            else
c              net_code=stat(1)
              net_code_out=stat(1)
            endif
         endif
c         outfile(21:25)=net_code		
         outfile(21:25)=net_code_out
         outfile(26:26)='_'
c-- number of channels
         outfile(27:29)=mainhead(1)(31:33)
c-- check for blanks                                        
         do i=1,18				
            if(outfile(i:i).eq.' ') outfile(i:i)='0'                            
         enddo                                                                  
         do i=19,26
            if(outfile(i:i).eq.' ') outfile(i:i)='_'
         enddo
         do i=27,29
            if(outfile(i:i).eq.' ') outfile(i:i)='0'
         enddo
c-- add component code if only one channel
         if (nchan.eq.1) then
           outfile(31:34)=comp(1)
           do i=30,seiclen(outfile)
              if(outfile(i:i).eq.' ') outfile(i:i)='_'
           enddo
         endif
       endif
c
c restore station and component codes
c
       stat(1)= stat_in
       comp(1)= comp_in

         write(6,200) outfile(1:seiclen(outfile))                                             
 200     format(' Output file name ',a)                                
         write(6,*)

c 
c check if input name same as output name
c
      same_file=.false.
      write(*,*) infile
      write(*,*) outfile

c      if (outfile(1:29).eq.infile(1:29)) same_file=.true.
      if (outfile(1:seiclen(outfile)).eq.
     &     infile(1:seiclen(outfile))) same_file=.true.
c
c   check that outfile name is not the same as an input
c   file names in which case the event should not be renamed if
c   there is no internal changes
c
      call sei open( check$,                  ! Try to open & warn.
     &               ' ',                     ! No prompt.
     &             outfile,                   ! This file.
     &               read03,                  ! On unit.
     &               exist,                   ! File exists?.
     &               code )                   ! Condition.

c      if (exist) then                      
c         same_file=.true.
      if (exist.and..not.same_file) then
c         if(time_cor.ne.0.) then
            write(6,*)' Name already exists, overwrite (y/n)'
            read(5,'(a)') answer
            if(answer.ne.'y'.and.answer.ne.'Y') then
               call sei close(close$,read02,code)
               call write_out(write01,choice,line,outfile)
               if (in.eq.1.or.choice.eq.'2') goto 1
               if (choice.eq.'1') goto 225
            endif

c         else
c           write(6,*)' Name already exists, no rename,',
c     *      ' return to continue'
cc            read(5,'(a)') answer
c            call sei close(close$,read02,code)
c            call write_out(write01,choice,line,outfile)
c               if (in.eq.1.or.choice.eq.'2') goto 1
c               if (choice.eq.'1') goto 225
c         endif
            
c
c  if a time correction, or channel name change
c  the output file must have a different name
c  temporarely, to be able to read the old file with the same name
c
c         if(time_cor.ne.0.0) then
c           same_file=.true.
c         endif
      endif

c
c change station and component code
c
      change = .false.
      do k=1,nchan
        chg_pol(k)=.false.
        stat_in = stat(k)
        comp_in = comp(k)
c
c   polarity should be changed if input and def stat and comp is the same
c
        do i=1,ndef_chan
           if(stat_in.eq.def_in_stat(i).
     *     and.comp_in.eq.def_in_comp(i)) 
     *     chg_pol(k)=.true.
        enddo
c
        call set_def_chan(k,stat(k),comp(k))
        if (.not.change) then
          if (comp(k).ne.comp_in) change=.true.
          if (stat(k).ne.stat_in) change=.true.
        endif
c
c   check for time change
c
        if (ind_time_cor(k).ne.0.) change=.true.

      enddo
      if (uncertain_time_change.eq.'y') change=.true.
c
c   rename only
c
      if(time_cor.eq.0..and.(.not.change).and.
     *   polarity_change.ne.'y'.and.
     *   uncertain_time_change.ne.'y') then
         call sei close(close$,read02,code)
         k=seiclen(infile)+seiclen(outfile)   
         if(sun.or.linux) 
     *   call systemc('mv '//infile(1:seiclen(infile))//
     *   ' '//outfile(1:seiclen(outfile)),k+4)
         if(pc) call systemc('rename '//infile(1:seiclen(infile))//
     *   ' '//outfile(1:seiclen(outfile)),k+8)

      else
c
c   correct all headers and rewrite file
c
         if(same_file) then   ! make a temporary file
c            write(*,*) ' new file same as old, creating wavfix.tmp '
            open(2,file='wavfix.tmp', 
     *      status='unknown',form='unformatted')
         else
c if file exists and overwrite confirmed
            if (exist) then
              open(2,file=outfile,status='unknown',form='unformatted')
            else
              open(2,file=outfile,status='new',form='unformatted')
            endif
         endif

c
c   write in header
c
             l=2
             k=3	  
             do j=1,nchan
                write(mainhead(k)(l:l+24),'(2a4,a1,f7.2,1x,f8.2)')
     *          stat(j)(1:4),comp(j),stat(j)(5:5),
     *          cstart(j)+ind_time_cor(j)-time_cor,cinter(j)		   
                l=l+26
                if(l.gt.60) then
                   l=2
                   k=k+1
                endif
             enddo			
c
c   write main header
c
         khead=(nchan-1)/3+3
         if(khead.lt.12) khead=12    ! never less than 12 main headers
c
         do i=1,khead
            write(2) mainhead(i)
         enddo         
c
c   read each channel, fix time, channel names or polarity and rewrite
c
         do i=1,nchan            ! fix headers in all channels
c           write(6,*) i
            call seisinc                                                             
     *      (read02,i,nchan,2,mainhead,chahead,0.0,0.0)
            read (chahead(10:35),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *      k,doy,month,day,hour,min,sec       
            year=k+1900
            call timadd(year,month,day,hour,min,sec,ind_time_cor(i),
     *             year1,month1,day1,hour1,min1,sec1)  ! add correction
            call date_doy(doy1,day1,month1,year1)
            k=year1-1900
            write (chahead(10:35),'(i3,1x,i3,1x,4(i2,1x),f6.3)')
     *      k,doy1,month1,day1,hour1,min1,sec1
c
c   possibly correct sample rate
c
            if(new_rate(i).gt.0.0)  
     *      write(chahead(37:43),'(f7.3)') new_rate(i)
c
            read(chahead(44:50),'(i8)') nsamp
c
c   put in possibly new channel names, could be the same if polarity fix
c
            chahead(1:5)=stat(i)
            chahead(6:9)=comp(i)
c
c  option for changing polarity by changing gain constant
c
            if(polarity_change.eq.'y'.and.chg_pol(i)) 
     *      then
                  chahead(76:76)='G'
                  chahead(148:159)='  -1.0      '
            endif
c
c option to mark uncertain time
c
            if (uncertain_time_change.eq.'y') then
                   if (chahead(29:29).eq.'E') then
                     chahead(29:29)=' '
                   else
                     chahead(29:29)='E'
                   endif
            endif
c
            write(2) chahead   ! write header
            if(chahead(77:77).eq.'4') then
               do k=1,nsamp
                  data4(k)=x(k)
               enddo
               write(2)(data4(k),k=1,nsamp)
            else
               do k=1,nsamp
                  data2(k)=x(k)
               enddo
               write(2)(data2(k),k=1,nsamp)
            endif
         enddo
         close(2)
         call sei close(delete$,read02,code)
c
c   rename temporary file if used
c
         if(same_file) then
            k=seiclen('wavfix.tmp')+seiclen(outfile)   
            if(sun.or.linux) call systemc('mv '//'wavfix.tmp'//
     *      ' '//outfile(1:seiclen(outfile)),k+4)
            if(pc) then
               call systemc('del '//outfile(1:seiclen(outfile)),
     *         seiclen(outfile)+4)
               call systemc('rename '//'wavfix.tmp'//
     *         ' '//outfile(1:seiclen(outfile)),k+8)
            endif
         endif
      endif       
c
c   get next file
c
      call write_out(write01,choice,line,outfile)
      if (in.eq.1.or.choice.eq.'2') goto 1
      if (choice.eq.'1') goto 225
c
 999  continue	  

      if (choice.eq.'2') then
         write(*,*) 'Nordic output file: nordic.fix'
         call sei close(close$,write01,code)
      endif
      stop
      end	  	  	 

      subroutine write_out(write01,choice,line,outfile)
c 
c write to nordic file
c
      implicit none
      integer write01,seiclen
      character*80 line,outfile
      character*1 choice

      if (choice.eq.'2') then
        line(1:40)='                                        '
        line(41:80)='                                       6'
        line(2:1+seiclen(outfile))=outfile(1:seiclen(outfile))
        write(write01,'(a80)') line
      endif

      return
      end

      

c
c   program to make data base directory structure, conssist of data base
c   specified and the DEL directory
c
c
c   updates
c   jh jan 95     : ************ version 5.0 ****************************
c      jan 20     : check for DEL
c     jan 31, 96  : make it possible to also make years 00 to 09
c   jan 6, 98 jh  : Year 2000 *******************************************
c   sep 98  jh    : ---------------  version7.0 check -----------------
c                    5 char base names
c   nov 5 98      : system_c to systemc
c   may 18  99    : blank to end of month
c   Jun 15 99  lo : also create WAV structure
c   Dec 06 99  lo : only ask once

      implicit none
c-- top dir
      character*60 top_directory
c-- text
      character*80 text
c-- base name
      character*5 base,save_base
c-- directory to make
      character*80 dir
c-- time interval
      character*6 time1,time2
      integer month1,month2,year1,year2,month,year
c-- dircetory character \ or /
      character*1 dchar
c-- switch for second runs
      logical second_run,both
c-- help variables
      integer id,i
c mode: REA or WAV
      character*4 mode
c is wav directory structure created
      logical wav_done

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call dir_char(dchar)
      second_run=.false.
      both = .false.

      wav_done = .false.

c
c  get input
c
  1   continue
      write(6,*)' Give 1-5 letter base name, UPPER CASE'
      read(5,'(a)') text
      i=index(text,' ')-1
      if(i.lt.2.or.i.gt.5) then
         write(6,*)' Base name MUST be 1-5 characters long'
         goto 1
      endif
      if(text(1:5).eq.'DELET') then
         write(6,*)' DELET is reserved for deleted events'
         goto 1
      endif
c
c   replace blanks with underscore
c
      do i=2,5
        if(text(i:i).eq.' ') text(i:i)='_'
      enddo
      base=text(1:5)
      save_base=base
      write(6,*)' Give start time, year month, e.g. 198302'
      read(5,'(a)') time1
      write(6,*)
     *' Give end time, year month, e.g. 198303, blank for one month'
      read(5,'(a)') time2
      if(time2.eq.' ') time2=time1
      read(time1,'(i4,i2)') year1,month1
      read(time2,'(i4,i2)') year2,month2
      write(6,*) ' Create REA or WAV structure or BOTH'
      read(5,'(a)') mode
      if (mode.eq.'rea') mode='REA'
      if (mode.eq.'wav') mode='WAV'
      if (mode.eq.'both') mode='BOTH'
      if (mode.ne.'WAV'.and.mode.ne.'REA'.and.mode.ne.'BOTH') then
         write(6,*) ' wrong input: ',mode
         stop
      endif
      if (mode.eq.'BOTH') then
        mode='REA'
        both = .true.
      endif
c
c   get top dir
c
      call topdir(top_directory)
      id=index(top_directory,' ')-1
c
c   from here there are two loops, one for the regular directory
c   and one for DELETE, which is the same for all bases
c
 500  continue
      if(second_run.and.mode.eq.'REA') base='DELET'    ! second time make DELET dirs
c
c   make start of dir name
c
      dir(1:id)=top_directory(1:id)
      dir(id+1:id+1)=dchar
      dir(id+2:id+4)=mode   ! lo
      dir(id+5:id+5)=dchar
      dir(id+6:id+10)=base
      dir(id+11:id+11)=dchar
c
c   make fixed directories although they might be there
c
      write(6,'(a,a,2x)')' Making directory ',dir(1:id+10)
      call systemc('mkdir '//dir(1:id+10),id+16)
      if (mode.eq.'REA') then
        dir(id+12:id+14)='LOG'
        write(6,'(a,a,2x)')' Making directory ',dir(1:id+14)
        call systemc('mkdir '//dir(1:id+14),id+20)
        dir(id+12:id+14)='CAT'
        write(6,'(a,a,2x)')' Making directory ',dir(1:id+14)
        call systemc('mkdir '//dir(1:id+14),id+20)
      endif
c
c  loop for making full dir names and creating directories
c
      year=year1
      month=month1
c
c   first make yearly directories
c
  5   continue
         if(year.gt.year2) goto 9
         write(dir(id+12:id+15),'(i4)') year
         if(dir(id+12:id+12).eq.' ') dir(id+12:id+12)='0'
         if(dir(id+13:id+13).eq.' ') dir(id+13:id+13)='0'
         write(6,'(a,a,2x)')' Making directory ',dir(1:id+15)
         call systemc('mkdir '//dir(1:id+15),id+21)
         year=year+1
      goto 5
c
c   make monthly directories
c
 9    continue
      year=year1
      month=month1
c  
 10   continue
      if((year.ge.year2.and.month.gt.month2).or.year.gt.year2) 
     *goto 99
      write(dir(id+12:id+15),'(i4)') year
      if(dir(id+12:id+12).eq.' ') dir(id+12:id+12)='0'
      if(dir(id+13:id+13).eq.' ') dir(id+13:id+13)='0'
      dir(id+16:id+16)=dchar
      write(dir(id+17:id+18),'(i2)') month
      if(dir(id+17:id+17).eq.' ') dir(id+17:id+17)='0'
      write(6,'(a,a,2x)')' Making directory ',dir(1:id+18)
      call systemc('mkdir '//dir(1:id+18),id+24)
      month=month+1
      if(month.eq.13) then
         month=1
         year=year+1
      endif
      goto 10

c
c
 99   continue

      if (mode.eq.'WAV') wav_done = .true.

      if(.not.second_run.and.mode.ne.'WAV') then
         second_run=.true.
         goto 500                ! make second run
      endif

      if (mode.eq.'REA'.and.second_run.and.both) then
          mode = 'WAV'
          base = save_base
          goto 500
      endif

      stop
      end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     PROGRAM EXFILTER
C
C     PROGRAM TO FLAG PROBABLE EXPLOSIONS IN A STANDARD
C     COMPRESSED FORMAT FILE, WRITTEN BY CONRAD D. LINDHOLM. JAN. 1991
C     IF A PROBABLE EXPLOSION IS FOUND, A 'P'
C     IS WRITTEN IN COLUMN 2. KNOWN EXPLOSIONS ARE NOT TOUCHED.
C
C     CRITICAL VALUES:
C     LHOUR,HHOUR:  HOUR-LIMITS
C     LMAG       :  LOWER MAGNITUDE FOR REAL EARTHQUAKES
C     LLAT,HLAT  :  LATITUDE-LIMITS
C     LLON,HLON  :  LONGITUDE-LIMITS
C     EXP        :  EXPLOSION INDICATOR
C     MAXDEPTH   :  MAXIMUM DEPTH POSSIBLE FOR AN EXPLOSION
C     NAREAS     :  NUMBER OF AREAS TO FILTER
C     NEXEPTIONS :  NUMBER OF AREAS EXCEPTED FROM THE FILTER
C
C     "E" IS PRECEEDING PARAMETERS FOR THE EXCEPTED REGIONS.
C     PRESENTLY THE EXCEPTION REGIONS ARE ONLY TESTED FOR
C     LATITUDE LONGITUDE AND YEAR AND MONTH OF VALIDITY.
C
C     8 HOURS ARE SUBTRACTED TO GO FROM GMT TO LOCAL TIME
C
C     PARAMETER INPUT FILE:     "~/seismo/DAT/EXFILTER.AREA"
c     Last update:
c
C 24.03.93 by K.Atakan :   new indata routine added
c 07 7 93  jh          :   verison 3.0 (new indata)
c sept. 95 jh          :   new program polygons by Lars Ottemuller
c aug 96   jh          :   use sei get reading routine
c                      :   put in sei get routine for file open
c sep 96   lo          :   use nortype to get file type 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c mar 99 lo : -----------version 7.0 ----------------------
c mar 18 99 lo dont filter events with fixed depth or star events
c oct 23 00 lo ------ events marked as quakes (q in col 23)
c
      include 'seidim.inc'        ! dimensions
      include 'libsei.inc'
c
      character*1 ctype,cexp
      CHARACTER*80 DATA(900)
      CHARACTER CARD*80
      CHARACTER PARAMFILE*80,filename*80
      LOGICAL EXP
      integer read1, code     ! unit to read parameter file from and er. code
      INTEGER LHOUR(100),HHOUR(100),TIME1(100),TIME2(100),NAREAS
      REAL LMAG(100),LLAT(100),LLON(100),HLAT(100),HLON(100)
      REAL MAXDEPTH(100)
      integer nprob    ! number of probable explosions found
      REAL ELMAG(100),ELLAT(100),ELLON(100),EHLAT(100),EHLON(100)
      INTEGER ELHOUR(100),EHHOUR(100),ETIME1(100),ETIME2(100)
      integer nexeptions
      real ypol(100,100,2)    ! array defining polygon
      integer npoints(100)
      REAL EMAXDEPTH(100)
      COMMON/A3/READ1
      COMMON/A2/ELMAG,ELLAT,ELLON,ELHOUR,EHLAT,EHLON,
     *          EHHOUR,ENAREAS,ETIME1,ETIME2,EMAXDEPTH,
     *          NEXEPTIONS
      COMMON/A1/LMAG,LLAT,LLON,LHOUR,HLAT,HLON,
     *          HHOUR,NAREAS,TIME1,TIME2,MAXDEPTH
      common/a4/npoints,ypol
c format compact or Nordic
      LOGICAL compact



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   get parameter file

        call sei get file( open$,             ! Open parameter  file.
     &                     read1,             ! On unit.
     &                     code,              ! Returned condition.
     &                     'DAT',             ! Alternative search directory.
     &                     'EXFILTER.PAR' )   ! For this filename.

      nprob=0
C
C---- Read the filter parameters from parameter file
C
      call get_areas
c
c     write(6,*) (npoints(i),i=1,nareas)
c     write(6,*) ypol
      WRITE(6,*)'NUMBER OF AREAS:',NAREAS
      WRITE(6,*)'     '
c     WRITE(6,*)' Two possible input formats:'
c     WRITE(6,*)' 1. Compressed Nordic format'
c     WRITE(6,*)' 2. Standard Nordic format'
c     WRITE(6,*)' What format has your file? (1/2)'
c     READ(5,*)NFORMAT
      WRITE(6,*)' FILENAME... ?'
      READ(5,'(A)')FILENAME
      OPEN(1,FILE=FILENAME,STATUS='OLD')
      call nortype(1,compact)
      if (compact) THEN
        NFORMAT=1
      ELSE 
        NFORMAT=2
      ENDIF
      CLOSE(1)
      OPEN(1,FILE=FILENAME,STATUS='OLD')
      OPEN(2,FILE='exfilter.out',STATUS='unknown')
C
C----- Do the filtering
C
10    IF(NFORMAT.EQ.2)THEN
        call indata(1,nstat,nphase,nhead,nrecord,ctype,cexp,data,k)
        IF(NRECORD.EQ.0) GO TO 20
        CALL FILTER(DATA(1),EXP)
        IF (EXP.AND.DATA(1)(23:23).NE.'E'.AND.DATA(1)(23:23).NE.'Q') 
     &      then 
           nprob=nprob+1
           DATA(1)(23:23)='P'
        endif
        DO I = 1,NRECORD
          WRITE(2,'(A80)')DATA(I)
        ENDDO
      ELSEIF(NFORMAT.EQ.1)THEN
        READ(1,'(A80)',END=20)CARD
        CALL FILTER(CARD,EXP)
        IF (EXP.AND.CARD(23:23).NE.'E') then 
          CARD(23:23)='P'
          nprob=nprob+1
        endif
        WRITE(2,'(A80)')CARD
      ENDIF

      GO TO 10


20    CONTINUE

      write(*,*)' ************************************'
      write(*,*)' Number of probable explosions found:', nprob
      write(*,*)' Output written on file: exfilter.out'
      write(*,*)' ************************************'

      END
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE FILTER(CARD,EXP)
C
C     EXP   : EXPLOSION INDICATOR
C
      include 'seidim.inc'
      REAL LAT,LON,DEPTH,MAG,amag,bmag,cmag
      INTEGER HOUR
      LOGICAL EXP
      CHARACTER CARD*80
      CHARACTER*1 NS,EW
      INTEGER LATDEG,LONDEG,LATMIN,LONMIN
      INTEGER LHOUR(100),HHOUR(100),TIME1(100),TIME2(100),NAREAS
      INTEGER YEAR,MONTH,TIME
      REAL LMAG(100),LLAT(100),LLON(100),HLAT(100),HLON(100)
      REAL MAXDEPTH(100)
      REAL ELMAG(100),ELLAT(100),ELLON(100),EHLAT(100),EHLON(100)
      INTEGER ELHOUR(100),EHHOUR(100),ETIME1(100),ETIME2(100)
      integer nexeptions
      REAL EMAXDEPTH(100)
      real ypol(100,100,2)    ! array defining polygon
      real yypol(max_polyn$,2)      ! -------------one-----
      integer npoints(100)   
      logical insidepol         ! true if point inside polygon
      COMMON/A2/ELMAG,ELLAT,ELLON,ELHOUR,EHLAT,EHLON,
     *          EHHOUR,ENAREAS,ETIME1,ETIME2,EMAXDEPTH,
     *          NEXEPTIONS
      COMMON/A1/LMAG,LLAT,LLON,LHOUR,HLAT,HLON,
     *          HHOUR,NAREAS,TIME1,TIME2,MAXDEPTH
      common/a4/npoints,ypol

C
c------ Read hypocenter parameters
c
      READ(CARD,5)YEAR,MONTH,HOUR,LAT,LON,DEPTH,AMAG,BMAG,CMAG
5     FORMAT(1X,I4,1X,I2,3X,I2,10X,F7.0,
     *         F8.0,f5.0,13X,F3.0,5X,F3.0,5X,F3.0)
      IF(AMAG.NE.0.)THEN
        MAG=AMAG
      ELSEIF(BMAG.NE.0.)THEN
        MAG=BMAG
      ELSEIF(CMAG.NE.0.)THEN
        MAG=CMAG
      ENDIF
c
c---- GMT time used in Norway ; 8 hours subtracted in Washington, USA
c
c      hour = hour - 8
      if(hour .le. 0) hour = hour + 24
c------------------------------------------------------

      TIME=YEAR*100+MONTH
      IF (HOUR.EQ.0)HOUR=24
C
      EXP=.FALSE.
C
c
c  skip if depth fixed
c
      if (card(44:44).eq.'F') goto 15
c
c  skip if star event
c
      if (card(23:23).eq.'*') goto 15

      DO 8 I=1,NAREAS
c     write(6,*)time,time1(i),time2(i)
      IF(TIME.LT.TIME1(I).OR.TIME.GT.TIME2(I)) GO TO 9
c     IF(LAT.LE.LLAT(I).OR.LAT.GE.HLAT(I)) GO TO 9
c     IF(LON.LE.LLON(I).OR.LON.GE.HLON(I)) GO TO 9
c
c   search inside polygon, first transfer polygon points
c
      do k=1,npoints(i)
        yypol(k,1)=ypol(i,k,1)
        yypol(k,2)=ypol(i,k,2)
      enddo

c     write(6,*)lat,lon
c     write(6,*) npoints(i)
c     write(6,*) (yypol(k,1),k=1,npoints(i))
c     write(6,*) (yypol(k,2),k=1,npoints(i))
      call polos(lat,lon,yypol,npoints(i),insidepol)
c     write(6,*)' sel',insidepol
      if(.not.insidepol) goto 9

      IF(DEPTH .GT. MAXDEPTH(I) )          GO TO 9
      IF(MAG.GT.LMAG(I)) GO TO 9
      IF(HOUR.GE.LHOUR(I).AND.HOUR.LE.HHOUR(I))THEN
c
c------- Explosion seem to bee true, but first check for exeptions------
c
         do 19 k=1,nexeptions
            IF(    TIME.GE.ETIME1(k)   .AND.
     *             TIME.LE.ETIME2(k)   .AND.
     *             LAT.GE.ELLAT(k)     .AND.
     *             LAT.LE.EHLAT(k)     .AND.
     *             LON.GE.ELLON(k)     .AND.
     *             LON.LE.EHLON(k)            )then 
                write(6,*)' exception' 
                GO TO 9
             endif
19       continue

c------- Explosion is true -----------------
         EXP=.TRUE.
         GO TO 15
      ENDIF
9     CONTINUE
8     CONTINUE
C
15    CONTINUE
      RETURN
      END
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine get_areas
      include 'seidim.inc'        ! dimensions
      include 'libsei.inc'
      character*80 incard
      integer  read1              ! unit for reading
      INTEGER LHOUR(100),HHOUR(100),TIME1(100),TIME2(100),NAREAS
      REAL LMAG(100),LLAT(100),LLON(100),HLAT(100),HLON(100)
      REAL MAXDEPTH(100)
      REAL ELMAG(100),ELLAT(100),ELLON(100),EHLAT(100),EHLON(100)
      INTEGER ELHOUR(100),EHHOUR(100),ETIME1(100),ETIME2(100)
      integer npoints(100),code
      integer nexeptions
      REAL EMAXDEPTH(100)
      real ypol(100,100,2)    ! array defining polygon
      COMMON/A3/READ1         ! unit for reading
      COMMON/A1/LMAG,LLAT,LLON,LHOUR,HLAT,HLON,
     *          HHOUR,NAREAS,TIME1,TIME2,MAXDEPTH
      COMMON/A2/ELMAG,ELLAT,ELLON,ELHOUR,EHLAT,EHLON,
     *          EHHOUR,ENAREAS,ETIME1,ETIME2,EMAXDEPTH,
     *          NEXEPTIONS
      common/a4/npoints,ypol

c
c------- Filter paramters are always found on the file: exp_filter.areas
c
      nareas = 0
      nexeptions = 0

1     read(read1,'(a)',end=999)incard
c     write(6,'(a)') incard
      if(incard(1:1) .eq. '#')then  ! first line for a new area
        nareas = nareas + 1
        read(incard,'(16x,2f8.3,5i8)')maxdepth(nareas),lmag(nareas),
     *        lhour(nareas),hhour(nareas),time1(nareas),time2(nareas),
     *        npoints(nareas)
c     write(6,*)' np',npoints(nareas)
c
c   read points of polygon
c
             read(read1,*) 
     *       (ypol(nareas,l,2),ypol(nareas,l,1),l=1,npoints(nareas))
      endif

      if(incard(1:1) .eq. '*')then
        nexeptions = nexeptions + 1
        call sei get values (11,incard(2:80),code)
        i=array$(1)
        emaxdepth(nexeptions)=array$(2)
        elmag(nexeptions)=array$(3)
        ellat(nexeptions)=array$(4)
        ehlat(nexeptions)=array$(5)
        ellon(nexeptions)=array$(6)
        ehlon(nexeptions)=array$(7)
        elhour(nexeptions)=array$(8)
        ehhour(nexeptions)=array$(9)
        etime1(nexeptions)=array$(10)
        etime2(nexeptions)=array$(11)
      endif

      go to 1

999   return
      end

      subroutine stat_loc(station,file_ind,slat,slon,elev)                            
c                                                                               
c     Routine to return coordinates of a given station in                       
c     degrees (and decimaldegrees) and elevation                                
c                                                                               
c    written by C. Lindholm May 1990                                            
c
c    updates:
c    mar 23,  92 by j.h. : unix adoption
c    Aug. 20 -93 c.l. topdirectory til charachter*60
c    Jan 95      j.h : ********** version 5.0 *******************
c    Feb 2           : bug
c    sep 16 98 jh    : ----------- version 7.0 check ------------
c    oct               changed for 5 char station
c    feb  2 99 lo    : bug fixed
c    feb 19 99 lo    : elev changed to f4.0
c    oct  16   jh    : posibility of reading coordinates with one more digit
      implicit none 
      include 'libsei.inc'
c-- latitude and longitude (output)                        
      real slat,slon			
c-- elevation (output)                                         
      real elev				
c-- station code (input)                              
      character*5 station 		
c-- station file indicator x in STATIONx.HYP
      character*1 file_ind
c-- string with data read from stationfile             
      character*80 string		
c-- station file name
      character*80 stat_file
c-- internal var.                       
      integer lat,lon
      real dlat,dlon
c-- unit and error code
      integer unit,code
c-- Direction indicators                               
      character*1 ns,ew				
                                     
      slat=0.
      slon=0.
      elev=0.
      stat_file(1:12)='STATION0.HYP'
      if(file_ind.ne.' ') stat_file(8:8)=file_ind ! check if alternative file
c
c  Search  file in current, then in DAT 
c
           call sei get file( open$+ignore$,   ! Check for  file.
     &                        unit,            ! Unit (n/a).
     &                        code,            ! Returned condition.
     &                        'DAT',           ! Alternative search directory.
     &                   stat_file )           ! For this filename.

                                                                                
c                                                                               
c---- read until station is found---                                            
c                                                                               
1     read(unit,'(a)',end=999)string
      if(station(5:5).eq.' ') then  ! 4 char station                                              
         if(string(3:6) .ne. station(1:4)) go to 1
      else                          ! 5 char station
         if(string(2:6) .ne. station(1:5)) go to 1
      endif                                              
c
c-------- station found ---
c
      read(string,10) lat,dlat,ns,lon,dlon,ew,elev                    
10    format(6x,i2,f5.3,a1,i3,f5.3,a1,f4.0)      
      slat = lat + dlat/60.  
      if(ns .eq. 'S') slat = -slat                                              
      slon = lon + dlon/60.                     
      if(ew .eq. 'W') slon = -slon                                              
      goto 20                                                                                
999   continue
      slat = 0.0
      slon = 0.0
      elev = 0.0
 20   continue                                                                
      call sei close(close$,unit,code)
      return
      end                                                                       

c
c   converts hypo71 summary cards to nordic format
c
c   jh june 1993
c
c   oct  29 94: add rms
c   nov 94   rem one space when reading
c   nov 30   put event type to L
c   feb 99 jh : ---------------   version 7.0 check ------------------
c
       IMPLICIT NONE
c  ARRAY WITH ORIGINAL READINGS
      CHARACTER*80 DATA(1)
      character*80 infile
      INTEGER YEAR,MONTH,DAY,HR,MIN
      REAL SEC
C  LATITUDE AND LONGITUDE IN DEGREES
      INTEGER LAT,LON
C  MINUTES OF ------------------
      REAL MLAT,MLON
C  DECIMAL LATITUDE AND LONGITUDE
      REAL DLAT,DLON
C  DEPTH, MAGNITUDE, RMS OF RESIDUALS
      REAL DEPTH,MAG,RMS
      INTEGER NPHASE
      character*3 agency
C  NUMBER OF DIFFERENT PHASE FOR EVENT
      character*2 cen         ! century
      INTEGER I


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

 
      agency=' '

      write(6,*)' Input file'
      read(5,'(a)') infile
 2    continue
      write(6,*)' Century(19 or 20) ?'
      read(5,'(a2)') cen
      if(cen.ne.'19'.and.cen.ne.'20') goto 2
      open(1,file=infile,status='old')
      open(2,file='hsumnor.out',status='unknown')
c
 50   continue 
      READ(1,100,end=99)YEAR,MONTH,DAY,HR,MIN,SEC,LAT,MLAT,LON,
     *    MLON,DEPTH,MAG,NPHASE,rms
 100  FORMAT(3I2,1X,2I2,F4.2,I3,F4.2,I3,
     *F4.2,F6.2,F4.2,I3,10x,f4.2)
C
      DLAT=LAT+MLAT/60.0
      DLON=-LON-MLON/60.0
C
         do i=1,80
           data(1)(i:i)=' '
         enddo
c        rms=0.0
         WRITE(DATA(1)(2:20),'(a2,I2,1X,2I2,1X,2I2,1X,F4.1)')
     *   cen,year,MONTH,DAY,HR,MIN,SEC
         WRITE(DATA(1)(24:43),'(F7.3,F8.3,F5.1)') DLAT,DLON,DEPTH
         WRITE(DATA(1)(46:71),202) AGENCY,Nphase,RMS
         write(data(1)(57:59),'(f3.1)') mag
         data(1)(60:60)='C'
         data(1)(22:22)='L'
 202     FORMAT(A3,I3,F4.1)
      write(2,'(a)') data(1)
      goto 50
99    continue
      stop
      end 

c###############################################################
c## Convert an output file (.CAT) of seisan built with collect
c## into a file that matches the input format of hypo71 program
c## F. Courboulex -CNRS- UMR Geosciences Azur FRANCE - March 98
c## e-mail : courboul@faille.unice.fr
c##
c## remark: If 2 picked times exist for one phase (P or S) the
c##         earlier time is kept
c###############################################################
c
c  changes
c
c  mar 1 99 by jh : --------------   version 7.0 check --------------
c                   5 char stations will be shortened to 4 chars
c                   output file to norhyp.out
c  jun 99   jh    : smal bug on pc with variable declaration
c
       IMPLICIT NONE

       STRUCTURE/pick/
             character*4 sta
             character*2 phase
             character*1 w
             character*1 pol
             integer  hh
             integer mn
             real   sec
             character*4 coda
       END STRUCTURE
	   integer NbMAX
       parameter(NbMAX=100)

       RECORD/pick/tab(NbMAX)
       RECORD/pick/tabtemp(NbMAX)
       character*4 sta,not1,sta_encours
       character separator*7
       character*80 input,output
       integer cptemp,y1,iy,id,ih,im,mn,cp
       integer indiceP,indiceS,l,i,j,m
       real sp,ss
       logical bool_pick


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

C
c
       write(*,*) 'INPUT FILE? '
       read(*,'(a)') input
       output='norhyp.out'
       open(unit=1,file=input,status='old')
       open(unit=2,file=output,status='unknown')

c      Loop on each event
       do while (.TRUE.)
         bool_pick=.FALSE.
         read(1,100,end=900) y1,iy,im,id,ih,mn
 100     format(1x,a2,i2,1x,i2,i2,1x,i2,i2)

   3      read(1,300,end=900) not1
 300      format(1x,a4)
          if(not1.ne.'STAT') goto 3

        sta='xxxx'
        cp=0
c       Treat the information of one event
        do while (sta.ne.'    ')
           cp=cp+1
           read(1,400,end=900) tab(cp).sta,tab(cp).phase,tab(cp).w,
     &     tab(cp).pol,tab(cp).hh,tab(cp).mn,tab(cp).sec,tab(cp).coda
           sta=tab(cp).sta
 400        format(1x,a4,4x,a2,3x,a1,x,a1,x,i2,i2,x,f5.2,x,a4)
        enddo
        do m=1,NbMAX
           tabtemp(m).sta='   '
           tabtemp(m).phase='  '
           tabtemp(m).w=' '
           tabtemp(m).pol=' '
           tabtemp(m).coda='    '
          enddo

       cp=cp-1
c       Treat the information of one event and one station
        do i=1,cp

          cptemp=0
         if (tab(i).sta.ne.'xxxx') then
             cptemp=cptemp+1
             sta_encours=tab(i).sta
             tabtemp(cptemp)=tab(i)
             tab(i).sta='xxxx'

           do j=i+1,cp
                 if (tab(j).sta.eq.sta_encours) then
                 cptemp=cptemp+1
                 tabtemp(cptemp)=tab(j)
                 tab(j).sta='xxxx'
                 endif
             enddo

              indiceP=0
              indiceS=0

           do l=1,cptemp
c          If 2 picked times exist for one phase (P or S) the
c          earlier time is kept
           if( ((tabtemp(l).phase.eq.'IP').OR.
     &      (tabtemp(l).phase.eq.'EP').OR.
     &      (tabtemp(l).phase.eq.' P')).AND.
     &      (indiceP.eq.0) ) then
              indiceP=l
           endif
           if(((tabtemp(l).phase.eq.'IP').OR.
     &      (tabtemp(l).phase.eq.'EP').OR.
     &      (tabtemp(l).phase.eq.' P'))
     &       .AND.(indiceP.ne.0)) then
             if(tabtemp(l).sec.lt.tabtemp(indiceP).sec) then
                  indiceP=l
             endif
            endif

          if(((tabtemp(l).phase.eq.'IS').OR.
     &      (tabtemp(l).phase.eq.'ES').OR.(tabtemp(l).phase.eq.' S'))
     &      .AND.(indiceS.eq.0)) then
            indiceS=l
          endif
          if(((tabtemp(l).phase.eq.'IS').OR.
     &     (tabtemp(l).phase.eq.'ES').OR.(tabtemp(l).phase.eq.' S'))
     &     .AND.(indiceS.ne.0)) then
             if(tabtemp(l).sec.lt.tabtemp(indiceS).sec) then
                    indiceS=l
               endif
           endif

              sp=tabtemp(indiceP).sec
              ss=tabtemp(indiceS).sec
              mn=tabtemp(indiceP).mn
             if(mn.ne.tabtemp(indiceS).mn) then
                ss =  tabtemp(indiceS).sec + 60.0
            endif
           enddo
              if(indiceP.eq.0)  sp=-9
              if(indiceS.eq.0) ss=-9
              if (sp.eq.-9) goto 550

             bool_pick=.TRUE.
             if (ss.ne.-9) then
               write(2,500) tabtemp(indiceP).sta,
     &              tabtemp(indiceP).phase,
     &              tabtemp(indiceP).pol,
     &              tabtemp(indiceP).w,
     &              iy,im,id,ih,mn,
     &              sp,ss,
     &              tabtemp(indiceS).phase,
     &              tabtemp(indiceS).w,
     &              tabtemp(indiceP).coda
              else
               write(2,700) tabtemp(indiceP).sta,
     &              tabtemp(indiceP).phase,
     &              tabtemp(indiceP).pol,
     &              tabtemp(indiceP).w,
     &              iy,im,id,ih,mn,
     &              sp,
     &              tabtemp(indiceP).coda
              endif

           endif
 550    enddo

 500   format(a4,a2,a1,a1,x,i2,i2,i2,i2,i2,f5.2,7x,f5.2,a2,x,a1,31x,a4)
 700   format(a4,a2,a1,a1,x,i2,i2,i2,i2,i2,f5.2,7x,40x,a4)

       separator='10  5.0'
       if(bool_pick) write(2,600) separator
 600   format(17x,a7)

       enddo

 900   continue
       close(1)
       close(2)
       write(6,*)' Output file name is norhyp.out'
       stop
       end

c#############################################################################

CJAB(BGS)Mar 23/95 : Solaris version pulling across 2 arguments when actioned
CJAB(BGS)Mar 23/95 : from eev, the second argument is blank!!, since 1st
CJAB(BGS)Mar 23/95 : argument is the one required, remove test for more than
CJAB(BGS)Mar 23/95 : item.
C                                                                               
C                       
C  Program to make a HYPOINVERSE file form a Nordic file                                  
C                                                                               
C  J. Havskov           1993                                                        
c  Updates:
c
CJAB(BGS)Mar95    : Solaris version pulling 2 arguments when supplied by "eev",
CJAB(BGS)Mar95    : the second being blank.
c  jan 95         ************** version 5.0 **********************
c  feb 99         ---------------version 7.0 ----------------------
c                 increase dimention of data to 2500, read century in year
c                 remove reference to computer type, PROGRAM CAN ONLY WORK
c                 WITH 4 CHAR STATION CODES
c  oct 25         read secs as f6.1
c
c                                                                               
c
c
      implicit none
      CHARACTER*80 DATA(2500)                                                  
      CHARACTER*80 infile                                                     
      CHARACTER*1 TYPE,EXP                                                      
      integer nstat,nphase,nhead,nrecord
c---number of arguments 
      integer nars
c-- arguments
      character*80 args(10)
      integer n,id
c--compact or not
      logical compact


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c 
c   check if input from file given in argument
        call get_arguments(nars,args)
        if(nars.eq.0) then
           write(6,*)' You must give input file as argument'
           stop
        endif
c
c   case with output on standard output
c
        if(nars.gt.2) then                   !JAB(BGS)Mar95. Definitely too many
          write(6,*)' Too many arguments'
          stop
        endif
c
c   output file
c
        open(2,file='norhin.out',status='unknown')
c
c   get input file name
c
        infile=args(1)
        open(1,file=infile,status='old')
c
c   check that not a compact file
c
        call nortype(1,compact)
        if(compact) then
           write(6,*)' Input file is compact, cannot be used'
           stop
        endif
c
c   read and write to end of file
c
        n=0
  10    continue
c
c   read one event in nordic format
c
           CALL INDATA(1,NSTAT,NPHASE,NHEAD,NRECORD,TYPE,EXP,DATA,ID)
           if(nrecord.eq.0) goto 99
c
c   convert to hypoinverse and write out 
c
           call norhin(2,nrecord,nhead,data)
           n=n+1
        goto 10
c
 99     continue
        write(6,*)
c        write(6,*)' The input file had ',n,' events'
c        stop
        end
                       

c
c
      subroutine norhin(unit,nrecord,nhead,data)
	  
c
c   gets one event in nordic format in array data and writes it to unit
c   in hypoinverse format
c
      implicit none
      character*80 data(*)
      integer nrecord,unit,nhead
      integer year,month,day,hour,min
      real sec
      double precision head_time,phase_time   ! abs times for header and phase
      integer k
c
c   write header
c
      write(unit,'(a2,a4,a4)') data(1)(4:5),data(1)(7:10),
     *data(1)(12:15)
c
c   read reference time, put sec to zero so all following times 
c   are referred to a whole minute
c
      sec=0.0
      read(data(1),'(1x,i4,1x,2i2,1x,2i2)') 
     *year,month,day,hour,min
c
c   get header abs time
c
      call timsec(year,month,day,hour,min,sec,head_time)
c
c   read phases to end of event
c
      do k=nhead+1,nrecord-1
         read(data(k)(19:28),'(i2,i2,f6.1)') hour,min,sec
         call timsec(year,month,day,hour,min,sec,phase_time)
         phase_time=phase_time-head_time      ! time relative to header
         write(unit,'(a4,a2,2a1,f5.1,a4)') data(k)(2:5),data(k)(10:11),
     *   data(k)(17:17),data(k)(15:15),phase_time,data(k)(30:33)
      enddo
c
c   write blank line
c
      write(unit,*)'       '
      return
      end

C$Debug
c
c  this program reads the seisan data base file content and prints
c  out relevant information
c
c
c  j havskov, march 1999
c
c  updates:
c  october 29, 99 jh: Better print out if many bases
c                     not case sensitive, always use upper case
c
      implicit none
      integer nevents                     ! number of events
      integer n_yr_base(150,100)          ! # of events pr year and data base 
      character*5 bases(100)              ! alll data base names
      character*6 out(100)                ! for output writing
      integer nbases                      ! number of bases in use
      character*5 base_wanted             ! base wanted
      logical events_ok                   ! true if data for one year      
      integer data_base(150,12,100)       ! the whole file
      integer nscreen                     ! number of screens to write out
      integer n1,n2                       ! counters
      integer i,k,l,m


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   read whole data base content file
c
      call get_all_bases(nbases,bases,data_base)
c
      open(3,file='base.out',status='unknown')
      write(6,*) ' Number of data bases', nbases
c
c
c   go through whole base and calculate number of events per year and base
c
       do i=1,150      ! years
         do l=1,nbases
            n_yr_base(i,l)=0
            do k=1,12     ! months
               nevents=data_base(i,k,l)      
               if(nevents.ne.0) then
c                 if(n_yr_base(i,l).eq.-1) nevents=nevents+1   ! do not add -1
                  n_yr_base(i,l)=n_yr_base(i,l)+nevents     ! sum events pr year
               endif
            enddo
         enddo
       enddo
c
c   print out yearly statistics, only print for years having data
c   in at least one of the data bases
c
      nscreen=(nbases-1)/12+1
      do m=1,nscreen
         n1=1+(m-1)*12
         n2=n1+11
         if(m.eq.nscreen) n2=nbases
         write(6,'(5x,12(1x,a5))') (bases(i),i=n1,n2)
         write(3,'(5x,12(1x,a5))') (bases(i),i=n1,n2)
         do i=1,150
           do l=n1,n2
             if(n_yr_base(i,l).ne.0) then
               do k=n1,n2
                  out(k)=' '
c                 if(n_yr_base(i,k).ne.-1)
                  if(n_yr_base(i,k).ne.0)
     *            write(out(k),'(i6)') n_yr_base(i,k)
               enddo     
               write(3,'(1x,i4,12a6)') i+1899,(out(k),k=n1,n2)
               write(6,'(1x,i4,12a6)') i+1899,(out(k),k=n1,n2)
               goto 50
             endif
           enddo
 50        continue
         enddo
         if(m.ne.nscreen) then
            write(6,*)' Return to continue'
            read(5,'(a)')out(1) 
         endif
      enddo
c
c   details of one data base
c
 60   continue
c
      write(6,*)
      write(6,*) ' More info on one base, give name, else return',
     *             ' to stop'
      read(5,'(a)') base_wanted
      if(base_wanted.ne.' ') then
c
c  find if available and which number
c
         do i=2,5
           if(base_wanted(i:i).eq.' ') base_wanted(i:i)='_'
         enddo
         l=0
         do i=1,nbases
           if(bases(i).eq.base_wanted) l=i
         enddo
         if(l.eq.0) then
            write(6,'(a,a)') ' Base ',base_wanted, ' not available'
            goto 60
         endif
c
c   header line
c
         write(6,'(9x,a,a)') 
     *   'Jan  Feb  Mar  Apr  May  Jun  ',
     *   'Jul  Aug  Sep  Oct  Nov  Dec'
         write(3,'(9x,a,a)') 
     *   'Jan  Feb  Mar  Apr  May  Jun  ',
     *   'Jul  Aug  Sep  Oct  Nov  Dec'
c
c   write statistics for base selected
c
          do i=1,150      ! years
            n_yr_base(i,l)=0
c
c   find if any events this year
c
            events_ok=.false.
            do k=1,12     ! months
               nevents=data_base(i,k,l)      
c              if(nevents.ne.-1) events_ok=.true.
               if(nevents.ne.0) events_ok=.true.
            enddo
c
c   if events, write out
c
            if(events_ok) then
               do k=1,12
                 out(k)=' '
                 if(data_base(i,k,l).ne.0)  
     *           write(out(k)(1:5),'(i5)') data_base(i,k,l)
               enddo
               write(6,'(1x,i4,2x,12a5)')i+1899,(out(k)(1:5),k=1,12)
               write(3,'(1x,i4,2x,12a5)')i+1899,(out(k)(1:5),k=1,12)
            endif
         enddo
c
c   back for another base
c
         goto 60
      endif
c
c     write(6,*)
      write(6,*)' Output file is base.out'
c
      stop
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


      subroutine get_all_bases(nbases,base,data_base)
c
c     read whole data base log file
c     nbases is the number of bases
c     data_base is the whole log file
c
      implicit none
      include 'libsei.inc'
      character*60 top_directory ! seisan top directory name
      character*800 bases     ! all bases in one string
      character*8   bas(100)  ! -----------
      character*5 base(100)   ! individual bases
      integer nbases          ! number of bases
      integer data_base(150,12,100) ! whole data base, year,month,base
      character*80 base_file  ! data base log file
      integer number(100)     ! number of events
      character*400 cnumber   ! ---------------
      integer pointer         ! pointer to data abse
      integer code            ! error code
      integer log_unit        ! unit to read and write from
      logical b_old           ! logical if file is old
      integer i,k,l
c
      equivalence (bases,bas)
      equivalence (number,cnumber)
c
c
c   get location of log file
c
      call topdir(top_directory)
      i=index(top_directory,' ')-1

      base_file = top_directory(1:i)//'/REA/REA.LOG'
c

c
c   open data base log file
c
      chr_f_access$='direct'
      f_recl$=800
c
      call sei open(old$+warn$,           ! Open a existing file.
     &             ' ',                   ! Prompt file name (n/a).
     &             base_file,             ! File name
     &             log_unit,              ! Read unit #1
     &             b_old,                 ! Already exists? (n/a).
     &             code)                  ! Returned condition
      if (code .ne. e_ok$) then
        write(6,*)' No data base log file'
        stop
      endif
c
c   read text part
c
      read(log_unit,rec=1) bases
c
c   find how many bases
c
      do i=1,100
        base(i)=bas(i)(1:5)
        if(base(i)(1:1).eq.' ') then
          nbases=i-1
          goto 2
        endif
      enddo
 2    continue
c
c
c   close to open with a new record length to read numbers
c
      call sei close(close$,log_unit,code)                       

      chr_f_access$='direct'
      f_recl$=400
      call sei open(old$+warn$,           ! Open a existing file.
     &             ' ',                   ! Prompt file name (n/a).
     &             base_file,             ! File name
     &             log_unit,              ! Read unit #1
     &             b_old,                 ! Already exists? (n/a).
     &             code)                  ! Returned condition
c
c   read all
c
      do i= 1,150
        do k=1,12
          pointer=(i-1)*12+k+2
           read(log_unit,rec=pointer) number       ! read 100 numbers
           do l=1, nbases
             data_base(i,k,l)=number(l)
           enddo
        enddo
      enddo
c
      call sei close(close$,log_unit,code)                       
c
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine get_base_data_year(base,n_yr)
c
c  find data for all years for base base   
c
      implicit none
      include 'libsei.inc'
      integer nevents
      character*5 base
      character*5 bases(100)
      integer n_yr(150)
      integer code            ! error code
      integer log_unit        ! unit to read and write from
      logical b_old           ! logical if file is old
      integer pointer         ! address of element with data base info
      integer ibase           ! number of the data base
      character*80 base_file  ! data base log fil name
      integer nbases          ! number of data bases
      integer i,k
c
c
      base_file='test.log'
c
c  get number of data bases
c
      call base_get_bases(nbases,bases)
      write(6,*)' Number of bases ',nbases
c
c  find the number of the data base to use
c
c
c  get number of data bases
c
      ibase=0
      do i=1,nbases
        if(base.eq.bases(i)) then
           ibase=i
           goto 1
        endif
      enddo
 1    continue
c
c   check if data base was registered in data base log file, if not, stop
c
      if(ibase.eq.0) then
         write(6,*)' Data base missing in log file'
         stop
      endif
c
c   open data base file 
c
       chr_f_access$='direct'
       f_recl$=4
       call sei open(old$+warn$,          ! Open a existing file.
     &             ' ',                   ! Prompt file name (n/a).
     &             base_file,             ! File name
     &             log_unit,              ! Read unit #1
     &             b_old,                 ! Already exists? (n/a).
     &             code)                  ! Returned condition
c
c   go through whole base
c
       do i=1,150      ! years
         n_yr(i)=0
         do k=1,12     ! months
c
c   calculate address to get info
c
            call base_address(i+1900-1,k,ibase,pointer)
c
c  read info
c
            read(log_unit,rec=pointer,err=99) nevents
            if(nevents.ne.0) then
c              if(n_yr(i).eq.-1) nevents=nevents+1   ! do not aff -1
               n_yr(i)=n_yr(i)+nevents               ! sum event pr year
            endif
         enddo
       enddo
       call sei close(close$,log_unit,code)
c
      return
c
 99   continue
      write(6,*)' Error in data base log file'
      return
      end

c$debug
c   program to check S-file data base
c 
c   jens havskov, oct 1999
C   uppdates:
c   oct  29 99 jh : able to do several data bases
c                   automatically find all bases, 
c                   posibility of only finding number of events

        implicit none	
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! File operations.
       include 'seidim.inc'                ! Dimentions
C
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error encoder.
C
C    ============= end of list ==========
C
c event data
       character*80	data(max_data)	
c exp indicator
       character*1	exp		
c event type
       character*1      type
c number of recors for event
       integer		nrecord		
c  number of header lines
       integer		nhead		 
c number of stations
       integer		nstat, nphas
c start and end time of select
       character*14     start_time,end_time 
       character*40	base_name(100)	
       character*5      bas(100)      ! real base names
c event file name
       character*80	evfile	
c select key
       character*10     key		
       integer		status,new_month,fstart,event_no 
       integer bad_id,no_id,bad_s   ! error counters 		
       integer 		id		
c logical for existing file or not
       logical          b_old
c returned code      
       integer          code
c units        
       integer          readu,printu, no_id_u,bad_id_u,bad_s_u
       integer nerr                  ! error indicator
       character*1      check        ! kind of check
       character*1      ucase        ! function
       integer ibase, nbase,nb,i
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   open output files
c
      call sei open(unknown$,              ! Open a unknown status file. 
     &              ' ',                   ! Prompt file name (n/a).
     &              'check_base.out',      ! File name
     &              printu,                ! Print unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.
      call sei open(unknown$,              ! Open a unknown status file. 
     &              ' ',                   ! Prompt file name (n/a).
     &              'index_no_id.out',     ! File name
     &              no_id_u,                ! Print unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.
      call sei open(unknown$,              ! Open a unknown status file. 
     &              ' ',                   ! Prompt file name (n/a).
     &              'index_bad_id.out',     ! File name
     &              bad_id_u,              ! Print unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.
      call sei open(unknown$,              ! Open a unknown status file. 
     &              ' ',                   ! Prompt file name (n/a).
     &              'index_bad_s.out',     ! File name
     &              bad_s_u,               ! Print unit
     &              b_old,                 ! Already exists? (n/a).
     &              code)                  ! Returned condition.
c
c   get possible data bases
c
       call get_base_names(nb,bas)
       write(6,*)' Number of data bases',nb
       write(6,'(13(1x,a5))')(bas(i),i=1,nb)
c
c   input base name and time interval
c
       nbase=1
       write(6,*)
       write(6,*)
     *' Base name(s), * is all, else, one pr line, return for no more'
  50   continue
       read(5,'(a40)') base_name(nbase)
       if(base_name(nbase)(1:1).eq.'*') then
         nbase=nb
         do i=1,nb
           base_name(i)=bas(i)
         enddo
         goto 60
       endif
       if(base_name(nbase).eq.' ') then
          nbase=nbase-1
       else
          nbase=nbase+1
          goto 50
       endif
 60    continue
       write(6,*)' Start time'
       read(5,'(a14)') start_time
       write(6,*)' End time, return for end of month'
       read(5,'(a14)') end_time
       write(6,*)
     *' Check data base (c) or',
     *' only update statistics for program base(u)'
       read(5,'(a)') check
       check=ucase(check)
c
 3     continue
       key='          '		 
       
c
c  reset counters for errors
c
       no_id=0
       bad_id=0
       bad_s=0
c
c  read and check loop
c
       do ibase=1,nbase
 5     continue
       CALL findevin	
     * (base_name(ibase),start_time,end_time,key,0,
     * event_no,evfile,fstart,new_month,status)
c
c  check for end
c
       if(status.ne.0) go to 99	 
       if(check.eq.'U') goto 5
c
       call sei open(old$,                          ! Open a existing file.
     &                       ' ',                   ! Prompt file name (n/a).
     &                       evfile,                ! File name
     &                       readu,                 ! Read unit #1
     &                       b_old,                 ! Already exists? (n/a).
     &                       code)                  ! Returned condition.
   
c
c   read file
c
       call indata
     * (readu,nstat,nphas,nhead,nrecord,type,exp,data,id)
c      write(6,'(a)') data(1)(1:60)
c
c   check if id line
c
       if(id.eq.0) then
          write(printu,*)' No id line'
          write(printu,'(a)') data(1)(1:60)
          write(no_id_u,'(7x,a)') evfile
          no_id=no_id+1
c         stop
       endif
c
c  check if id line and file name are the same
c
       call check_id(evfile,type,data(id),nerr)
       if(nerr.ne.0) then
          write(6,*)' File name and id different'
          write(printu,*)' File name and id different'
          write(printu,'(a)') data(1)(1:60)
          write(bad_id_u,'(7x,a)') evfile
          bad_id=bad_id+1
c         stop
       endif
c
c  check s-file
c
       call check_s(data,nrecord,evfile,nerr,2,printu)
       if(nerr.gt.0) then
          write(6,*)' Error in S-file'
          write(printu,'(a)') data(1)(1:60)
          write(bad_s_u,'(7x,a)') evfile
          bad_s=bad_s+1
c         stop
       endif
c
c   close file
c
       call sei close (close$,readu,code)
c
c   back to next event
c  
       goto 5			


 99    continue
       enddo              ! end of base check loop
c
c  print out statistics
c
       write(6,*)
       write(6,*)' Number of events without id-lines:  ', no_id
       write(6,*)' Number of events with wrong id   :  ', bad_id
       write(6,*)' Number of events with error in file:', bad_s
       

      write(6,*)
      write(6,*)
      write(6,*)' Output file name is check_base.out'
      write(6,*)
     *' Index file with events with no id lines:       index_no_id.out' 
      write(6,*)
     *' Index file with events with wrong id line:     index_bad_id.out' 
      write(6,*)
     *' Index file with events with error in S-file :  index_bad_s.out' 
      write(6,*)

      stop
      end
     

      subroutine get_base_names(nbase,base)
c
c     read all names from REA directory and sort out names 5 characters long
c    
c     
      implicit none
      character*60 top_dir     ! seisan path
      character*1 dchar        ! dir separation char
      logical sun,linux,pc     ! computer type
      character*5 base(*)       ! bases
      integer nbase            ! number of bases
      integer n,i,k
      character*80 all_files(500) ! all names in REA
      character*80 text
      integer seiclen          ! function


      call topdir(top_dir)
      call dir_char(dchar)
      call computer_type(sun,pc,linux)
c
      text=top_dir(1:seiclen(top_dir))//dchar//'REA' 
c
c   make a list of files
c
       call getfiles(text,seiclen(text),all_files,500,n)
c
c   find all with 5 chars and no .
c
       nbase=0
       do i=1,n
         if(seiclen(all_files(i)).ne.5) goto 100 
         do k=1,5
            if(all_files(i)(k:k).eq.'.') goto 100
         enddo
         nbase=nbase+1
         base(nbase)=all_files(i)(1:5)
 100     continue
       enddo
c
c     
      return
      end

C
C   PROGRAM TO CALCUALTE AND PLOT b-VALUE USING ONE FILE
C   IN NORDIC OR NORDIC COMPACT FORMAT
C
C   JENS HAVSKOV, DEC 90
C
c --------------------------------------------
c
c   feb 92 by rna:  first sun version
c   aug 92 by jh:   clean up and bugs fixed
c   sep 8 92 by jh: xscaling, make sure only one plot file
c   nov 12        : bug when writing out scaling
c   jun 14 93     : dimention to 50000
c   jun 21        : move posiiton of text in plot
c   aug 23 93     : filenames to 80
c   oct 17 94     : w magnitudes, read(end=1  instead of end=3
c   nov 3, 94     : do not accept no mag type, use indata routine
c   nov 7         : allow no magnitude type
c   dec 8         : include seidim
C   dec 8         : Installed file & error handling (libsei)
c   dec 14        : *************  version 5.0 ****************
c   feb 7         : close postscript file
c   apr 4, 95, jh : bad bugs
c   april 18, 95--: put vertical scaling back in in postscript, why taken out ?
c   jun 95  jh    : use fixed slope
c   jun 13        : normalizing
c   nov 9 98 jh   : -----------------  version 7.0 check -------------------
c                   one_line to oneline 
c   mar 22 99 bmt : include winplot.inc 
c   sep 17 99 jh  : set get routnes had a problem with plotunit, 
c                   use simple open
c   jun 20 05 jh  : plt to eps
c --------------------------------------------
         include 'winplot1.inc'

c     implicit none
      include 'seidim.inc'         ! dimensions
c
c  magnitude
      real          mag(50000),xmag
c  data
      character*80 data(max_data)
c  number of magnitudes each interval, cumulative and log of same
      integer nmag(100),cmag(100)
      real lnmag(100),lcmag(100)
c  magnitude step in summation
      real magstep
c  number magnitudes selected and used for b-value
      integer nm,nused
c  magnitude type selected
      character*1    magtype
c  a,b value and sd
      real a_value,b_value,b_sd,a_least,b_least
      real b_value_fixed    ! the fixed value to use
      real a_fixed,a_sdv    ! a with b fixed with sd
      real ax,bx            ! a and b-values plotted
      integer choice        ! choice of above
c  correlation coefficient and rms
      real cor,rms
c  input file name
      character*80 filename
c  magnitude range
      real m1,m2
c  magnitude from one event
      real mg(3)
c  magnitude type from one event
      character*1 mtyp(3)
c  number of values for least squares analysis
      integer kl
c  help variables for least squares,etc
      real x(100),y(100),x1,x2,x3
c  text
      character*80 text
c  answer
      character*80 answer
c  cvalues for indata, not used
      integer nstat,nphase,nhead,nrecord,id
      character*1 exp,evid
c  logical for file exist
      logical exist
      integer sei integer  ! a function
      integer year,month,day,hour    ! time and date
      real xyear,max_year,min_year   ! absolute years
c  file type indicator
      logical compact
      integer i,k 
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       integer  write01,                   ! Output unit 1.
     &          read01,                    ! Input unit1.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
C
C    ============= end of list ==========

c -----------------------------------------------------------------
       
      include 'version.inc'
      include 'seiplot.inc'
      include 'winplot2.inc'


c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c ----------------------------------------------------------------

c
c  check display type, can be x  or Microsoft (pc)
c
      call get_display(display_type)
c
c
c-- x-window size in % screen
c
      wsize=65
c
c  initialize year range
c
      max_year=0.0
      min_year=3000.0
c
c  graphic display not yet open
c
      disp_open=0

c  open input file
c
      write(6,*)
     *' Input file name, select.out or collect.out are defaults'
      read(5,'(a)') filename
      if(filename(1:1).eq.' ') then
         inquire(file='select.out', exist=exist)
         if(exist) then
            filename='select.out'
         else
            inquire(file='collect.out',exist=exist) 
            if(exist) then
              filename='collect.out'
            else
              write(6,*)' No default files available'
c             call sei close(close$+all$,read01, code)       
              stop
            endif
         endif
      endif
          call sei open( old$+warn$,       ! Open file & warn of erro.
     &                   ' ',              ! Prompt (n/a).
     &                   filename,         ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
          if (code .ne. e_ok$) go to 99
c
c   determine type of file
c
      call nortype(read01,compact)
      if(compact) write(6,*)' Input file compact'
c
c   open output file
c
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   'bvalue.out',     ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
c
c  magnitude type
c
 55   continue
      write(6,*)' Which magnitude type, C,L,B,W or S, ',
     *'return for no type'
      read(5,'(a)') magtype
      if(magtype.eq.'c') magtype='C'
      if(magtype.eq.'l') magtype='L'
      if(magtype.eq.'b') magtype='B'
      if(magtype.eq.'s') magtype='S'
      if(magtype.eq.'w') magtype='W'
      if(magtype.eq.' ') then
         write(6,*)' Sure you want no magnitude type(y/n)'
         read(5,'(a)') text
         if(text(1:1).ne.'y'.and.text(1:1).ne.'Y') goto 55
      endif
c
c  read magnitudes to end of file and select 
c  the right types, do not use zero mags
c
      nm=0
 1    continue
      if(compact) then
         read(read01,'(a)',end=10) data(1)
      else
         call indata
     *  (read01,nstat,nphase,nhead,nrecord,evid,exp,data,id)
        if(nrecord.eq.0) goto 10
      endif
      read(data(1),'(56x,3(f3.1,a1,4x))')(mg(i),mtyp(i),i=1,3)
 3    continue
      do 2 i=1,3
         if(magtype.eq.mtyp(i).and.mg(i).ne.0.0) then
           nm=nm+1
           mag(nm)=mg(i)
c
c   get time
c
           read(data(1),'(1x,i4,1x,2i2,1x,i2)') year,month,day,hour
           if(year.lt.100) year=year+1900   ! make sure century is put in
           xyear=year+(month-1)/12.0+(day-1)/365.0+(hour-1)/(24.0*365.0)
           if(xyear.gt.max_year) max_year=xyear
           if(xyear.lt.min_year) min_year=xyear
           goto 1
         endif
 2    continue
      goto 1
c
c end of read
c
 10   continue
      xyear=max_year-min_year
      write(6,*)' Number of events selected from file:   ',nm
      write(6,'(a,1x,f9.4)')'  Duration of catalog in years', xyear
      write(write01,*)' Number of events selected from file:   ',nm
      write(write01,'(a,1x,f8.4)')' Duration of catalog in years', xyear
      write(write01,*)' -------------------------------------------'
      write(write01,*)
      xyear=alog10(xyear)
c
c   if no events, stop
c
      if(nm.eq.0) then
         write(6,*) 'No event selected, STOP'
         stop
      endif
c------------------------------------------------------------------
c  back here for new choice of parameters, a new plot file is also made
c  deleting the previous one
c------------------------------------------------------------------
 50   continue
c
c  magnitude step in summation
c
      write(6,*)' Magnitude step 1.0, 0.5, 0.25, 0.2 or 0.1'
      read(5,*) magstep
c
c  magnitude range and fixed b-value
c
      write(6,*)' Magnitude range m1,m2 for b-value and fixed b-value'
      read(5,*) m1,m2,b_value_fixed

c
c  calculate b-value after max liklihood
c
      call b_max_like(nm,mag,m1,m2,b_value,b_sd,nused)
c
c
c   calculate cumulative numbers, assume max of 100 different
c   corresponding to magnitude 0-10 in 0.1 magstep intervals
c
      kl=0
c
c  blank arrays
c
      do 13 i=1,100
        nmag(i)=0
        cmag(i)=0
 13   continue
c
c  sum
c
      do 15 i=1,nm
         k=(mag(i)+0.01)/magstep+1
         nmag(k)=nmag(k)+1
 15   continue
c
c  cumulative sum
c
      cmag(100)=nmag(100)
      do 16 i=100,2,-1
         cmag(i-1)=cmag(i)+nmag(i-1)
         if(nmag(i-1).ne.0) then
            lnmag(i-1)=alog10(float(nmag(i-1)))
         else
            lnmag(i-1)=-1.0
         endif
         if(cmag(i-1).ne.0) then
            lcmag(i-1)=alog10(float(cmag(i-1)))
c
c   select for least squares
c
cold            xmag=(i-1)*magstep
            xmag=(i-2)*magstep
            if(xmag.ge.m1.and.xmag.le.m2) 
     *      then
               kl=kl+1
               x(kl)=xmag
cold               y(kl)=lcmag(i)
               y(kl)=lcmag(i-1)
            endif
         else
cold            lcmag(i)=-1.0
            lcmag(i-1)=-1.0
         endif
 16   continue
c
c   calculate max likelihood a_value
c
      a_value=0.0
      k=0
      do 18 i=1,100
         xmag=i*magstep
         if(xmag.ge.m1.and.xmag.le.m2.and.cmag(i).ne.0) then
            a_value=a_value+(lcmag(i)+b_value*xmag)
            k=k+1
         endif
 18   continue
      a_value=a_value/k
c
c  make least squares a and b-values
c
      call lsqlin(kl,x,y,a_least,b_least,cor,rms)
      b_least=-b_least
c
c  make a-value when b is fixed
c
      do i=1,kl
         y(i)=y(i)+b_value_fixed*x(i)
      enddo
      call sdv(kl,y,a_fixed,a_sdv)
c
c output
c
      write(6,200)
      write(write01,200)
 200  format('     n    m1    m2 mxl a mxl b    sd',
     *' lsq a lsq b   cor   rms  bfix  afix    sd')
      write(6,201) nused,m1,m2,a_value,b_value,b_sd,a_least,
     *b_least,cor,rms,b_value_fixed,a_fixed,a_sdv
      write(write01,201) nused,m1,m2,a_value,b_value,b_sd,a_least,
     *b_least,cor,rms,b_value_fixed,a_fixed,a_sdv
 201  format(i6,f6.1,f6.1,10f6.2)
c
c   normalized a values print out, zero mag
c
      x1=0.0
      x2=0.0
      x3=0.0
      if(a_value.ne.0.0) x1=a_value-xyear
      if(a_least.ne.0.0) x2=a_least-xyear
      if(a_fixed.ne.0.0) x3=a_fixed-xyear
      write(6,205)x1,x2,x3
 205  format(' Normalized ',f12.2,6x,f12.2,18x,f12.2) 
      write(write01,205)x1,x2,x3

      if(x1.ne.0.0) x1=x1-m1*b_value
      if(x2.ne.0.0) x2=x2-m1*b_least
      if(x3.ne.0.0) x3=x3-m1*b_value_fixed
      write(6,206)x1,x2,x3
 206  format(' Normalized m1',f10.2,6x,f12.2,18x,f12.2)
      write(write01,206)x1,x2,x3
      x1=10**x1
      x2=10**x2
      x3=10**x3
      if(x1.eq.1.0) x1=0.0 
      if(x2.eq.1.0) x2=0.0 
      if(x3.eq.1.0) x3=0.0 
      write(6,207)x1,x2,x3
 207  format(' Norm. lin. m1',f10.1,6x,f12.1,18x,f12.1)
      write(write01,207)x1,x2,x3
c
c  print sum and cumulative sum, only print non zero values
c
      write(6,*)
      write(6,*)'   mag  nmag  cmag'
      write(write01,*)'   mag  nmag  cmag'
      do 17 i=1,100
         if(nmag(i).ne.0) then
            write(6,202) float(i-1)*magstep,nmag(i),cmag(i)
            write(write01,202) float(i-1)*magstep,nmag(i),cmag(i)
 202        format(1x,f6.1,i6,i6)
         endif
 17   continue
c
c  plot
c
      write(6,*)' Plot(y/n)'
      read(5,'(a1)') answer(1:1)
      if(answer(1:1).eq.'y'.or.answer(1:1).eq.'Y') then
c
c   chose bvalue to plot
c
         write(6,*)' Which b-value: 1: Least squares (default)'
         write(6,*)'                2: Fixed bvalue'
         write(6,*)'                3: Maximum likelihood'
         read(5,'(a)') text
         if(text(1:2).eq.'  ') then 
            choice=1
         else
            choice=sei integer(text,code)
         endif
         if(choice.eq.1) then
            ax=a_least
            bx=b_least
         endif
         if(choice.eq.2) then
            ax=a_fixed
            bx=b_value_fixed
         endif
         if(choice.eq.3) then
            ax=a_value
            bx=b_value
         endif
c
c  set defaults for output on tek screen and one hardcopy file
c
         plotoption=1
         hctype=1
         plotunit=70
         open(70,file='bvalue.eps',status='unknown')
c
c   open plotter
c
         call open_display 
c
c set some postscipt scalings
c
         write(plotunit,*) ' 1.0 0.55 scale'
         call bval_tekplot(nmag,cmag,lnmag,lcmag,magstep,
     *   ax,bx,m1,m2,choice)
c
c  make sure plot buffer is empty
c
         call tsend
c
c   close postscript
c
         call close_post
c
c   close output plot file
c 
         close(plotunit)
c
c   redo if requested
c
      text(1:40)=' Run again with other parameters (y/n)  '
      call oneline(text,40,answer,20,200.0,50.0)
c
c   close display and back to alpha screen
c
         call clear_to_alpha
      else
         write(6,*)' Run again with other parameters (y/n) '
         read(5,'(a)') answer
      endif

      if(answer(1:1).eq.'y'.or.answer(1:1).eq.'Y') then
         goto 50
      endif
c
c   finished
c
      write(6,*)' Output file in bvalue.out'
      write(6,*)' Last plot in file bvalue.eps'
      goto 999
99    continue
      write(*,*) ' No such file!'
999   continue
      call sei close(close$+all$,read01, code)       ! Close all open files
      stop
      end
c
      subroutine b_max_like(nm,mag,m1,m2,b_value,b_sd,n)
c
c  calculate maximum likelihood method, after h. bungum
c
c  j. havskov dec 90
c
c
      implicit none
c  number of magnitudes
      integer nm
c  magnitudes
      real mag(*)
c  magnitude interval to use
      real m1,m2
c  a-value,b-value and sd
      real b_value,b_sd
c  help valiable
      real sum,mean,sqrsum,variance
c  number of events within magnitude limits
      integer n
c  counter
      integer i
c
c   find  sum
c
      sum=0.0
      n=0
      do 1 i=1,nm
c         write(6,*)'mag,m1,m2',mag(i),m1,m2
         if(mag(i).ge.m1.and.mag(i).le.m2) then
            sum=sum+mag(i)
            n=n+1
         endif
 1    continue
      if(n.ne.0) then
         mean=sum/n
      else
         b_value=0.0
         b_sd=0.0
         return
      endif
c
c  square sum
c
      sqrsum=0.0
      do 2 i=1,nm
         if(mag(i).ge.m1.and.mag(i).le.m2) then
            sqrsum=sqrsum+((mag(i)-mean)**2)
         endif
 2    continue
c
c  b-value
c
      variance=sqrsum/(n-1)
      b_sd=sqrt(variance)
      b_value=0.43429448/(mean-m1)
c
c  deviation after bullen and bolt
c
c      b_sd=2.30*(b_value**2)*b_sd
      return
      end
c###################################################################
c
      subroutine bval_tekplot(nmag,cmag,lnmag,lcmag,magstep,
     *a_value,b_value,m1,m2,choice)
c 
c   make a tektronics b-value plot
c
c   j. havskov, dec 90
c
c
c -------------------------
      implicit none
c   following variables, see main prog
      integer nmag(*),cmag(*)
      real lnmag(*),lcmag(*),magstep,a_value,b_value,m1,m2
c   text for plotting
      character*80 text
c   counters and help variables
      integer i,k,jmag
      integer mag
      integer choice
c   for xtek
      real iy, ix, x1, x2, y1, y2
c
      include 'seiplot.inc'            ! plotting parameters, colors etc
c
c   plot y-axis
c
      call xset_color(color_frame)
      ix=100
      iy=200
      k=1
      call xmovabs(200.0,200.0)
      do 1 i=1,4
        iy=iy+100
        call xdrwabs(200.0,iy)
        call xdrwabs(210.0,iy)
        call xmovabs(200.0,iy)
        write(text(1:4),'(i4)') k
        call xchars(text,4,130.0,iy-5)
        call xmovabs(200.0,iy)
        k=k*10
 1    continue
c
c   plot x-axis and data, but only as long as there is data
c
      ix=200
c
c   find how many values and scale x-axis
c
      do i=1,99
         if(cmag(i).eq.0) goto 22
      enddo
 22   continue	  
      k=500/i	  
      call xmovabs(ix,200.0)
      mag=0
      jmag=0
      do 2 i=1,99
         if(mag.eq.10) then
            jmag=jmag+1
            mag=0
            call xset_color(color_axis_not)
            write(text(1:1),'(i1)') jmag
            call xset_color(color_frame)
            call xchars(text(1:1),1,ix-10.0,170.0)
            call xmovabs(ix,200.0)
            call xdrwabs(ix,190.0)
            call xmovabs(ix,200.0)
         endif
c
c   plot number of events if gt 0
c
         call xset_color(color_bval_np)
         iy=300+lnmag(i)*100
         if(lnmag(i).ge.0.0) then 
            call xmovabs(ix-0.4*k,200.0)
            call xdrwabs(ix-0.4*k,iy)
            call xdrwabs(ix+0.4*k,iy)
            call xdrwabs(ix+0.4*k,200.0)
         endif			
c
c   plot cumulative number of events
c
         call xset_color(color_bval_ac)
         iy=300+lcmag(i)*100
         call xmovabs(ix-5,iy)
         call xdrwabs(ix+5,iy)
         call xmovabs(ix,iy-5)
         call xdrwabs(ix,iy+5)
         call xmovabs(ix,200.0)
c
c   check if there is more data
c
         if(cmag(i+1).eq.0) goto 3
         ix=ix+k
         mag=mag+magstep*10
         call xdrwabs(ix,200.0)
 2    continue
 3    continue
      call xdrwabs(ix+2*k,200.0)
c
c   plot regression line
c
      call xset_color(color_bval_line)
      x1=k*m1/magstep+200
      x2=k*m2/magstep+200
      y1=(a_value-b_value*m1)*100+300
      y2=(a_value-b_value*m2)*100+300
      call xmovabs(x1,y1)
      call xdrwabs(x2,y2)
c
c   plot b value
c
      call xset_color(color_title)
      if(choice.eq.1) text(1:34)='Least squares a and b-values:     '
      if(choice.eq.2) text(1:34)='Fixed b-value a and b-values:     '
      if(choice.eq.3) text(1:34)='Maximum likelihood and b-values:  '
      write(text(35:50),250) a_value,b_value
 250  format(2f8.2)
      call xchars(text,50,250.0,650.0)
      call xset_color(color_def)
      return
      end
c

        program rhfc10
c
c  may  99 by jh --------- verison 7.0 check --------------------
c                include mchdep70, numarg
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME VI                                                      c
c                                                                     c
c      PROGRAM: RHFOC10                                               c
c                                                                     c
c      COPYRIGHT 1985, 1992                                           c
c      R. B. Herrmann                                                 c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      parameter (LER=0, LIN=5, LOT=6)
c-----
c
c     rhfoc10 -f FILE [ -v  ] [ -t -o -p -i ] -a ALP -l L [ -D -V -A ]
c
c       This convolves output of rhwinvta with the
c       far-field displacement
c       pulses to yield velocity time
c       histories
c     The symmetric parabolic pulse ( -p )
c     of Wang and Herrmann (1980) is used.
c     A simple triangular pulse ( -t ) is also available.
c     as is the Ohnaka source time function ( -o )
c     The total duration of the pulse is 4L dt for the parabolic pulse
c     and 2L dt for the triangular pulse.
c
c     L is the number of dt's per tau, e.g.
c           tau = L dt . If -n is not specified,
c           then tau = dt by default
c     
c     ALP is the constant in the ohnaka time function whose
c     far field displacement is alpha*alpha*t*exp(-alpha*t)
c           and whose Fourier  spectrum is
c           [ ALP / ( j2pif + ALP ] ** 2
c           This has a corner frequency of fc=ALP/2pi
c
c     Other pulses might be able to be used. But this
c     one is stable. Note that for tau = dt,
c     -v indicates verby output on device LER
c
c     -i = impulse source
c     -D = output displacement time history
c     -V = output velocity time history (default)
c     -A = output acceleration time history
c
c     The pulses are such that the far-field dispacements would
c     have unit area
c
c     The pulses used correspond to the dislocation
c               far-field displacement to get velocity history
c
c
c-----
      parameter(NL=100)
      common/jout/jsrc(10),lsrc(10) 
      common/source/z(2048)
      common/model/d(NL),a(NL),b(NL),rho(NL),mmax,qa(NL),qb(NL) 
      complex data(1024),datas(513)
      dimension ar(10),ai(10)
      character*50 names , rfile
      character*4 icchar (11)
      integer idva
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c     
c-----
c     call machine dependent initialization
c-----
      call mchdep()
      call gcmdln(ntau,ipt,iverby,alp,ifile,names,idva,xmult,rfile)
        npuls=1 
      open(unit=3,file=names,access='sequential',form='unformatted' 
     1 ,status='old') 
      open(unit=4,status='scratch',form='unformatted')
      rewind 3
      rewind 4
   19 format(5f10.5) 
      do 99 i=1,n 
   99 z(i)=0.0 
      read(3) alpha,depth,fl,fu,dt,n,n1,n2,df,nyq2 
      read(3)jsrc 
      read(3)lsrc 
      read(3)d,a,b,rho,mmax,qa,qb 
      nyq=nyq2/2 
c default for filter
	if(ntau.le.0)then
		tau = dt
	else
		tau = ntau * dt
	endif
	if(ipt.eq.0)then
		call pultd(tau,dt,n,l)
	elseif(ipt.eq.1)then
		call pulpd(tau,dt,n,l)
	elseif(ipt.eq.2)then
		call pulod(alp,dt,n,l)
	elseif(ipt.eq.3)then
		call puldd(dt,n,l)
	else if(ipt.eq.4)then
		call pulud(rfile,n,tau)
	endif
	if(iverby.eq.1)write(LER,*)' tau=',tau,' dt=',dt
	if(iverby.eq.1)write(LER,*)' ipt=',ipt,' l=',ntau
	fmax = fu 
	inst = 0 
c-----
c	plot source pulse and spectra 
c	since omega is complex time series has to be damped 
c-----
      fac = 1.0 
      dfac = exp(-alpha*dt) 
      do 200 i = 1,n 
      data(i) = cmplx(fac*z(i)*xmult,0.0)
      fac = fac * dfac 
  200 continue
      call four(data,n,-1,dt,df) 
      do 310 i = 1,nyq 
      freq=(i-1)*df 
      if(freq.gt.fmax) go to 309 
      if(i.ge.n1.and.i.le.n2) go to 310 
  309 continue 
      data(i)=cmplx(0.0,0.0)
  310 continue 
      do 206 i = 1,nyq 
  206 datas(i) = data(i) 
c-----
c    beginning of distance loop
c-----
 9997 continue 
      read(3,err=9999,end=9999)r,t0
      if(r.lt.0.0) go to 9999 
c-----
c    set up output stream
c-----
      yr = 0.0
      write(LOT,110)r,yr,depth,n,t0,dt,tau
  110 format(3e16.9,i10/3e16.9)
      do 249 jj=1,10
  249 read(3,err=9999,end=9999)icchar(jj)
      rewind 4
      do 300 i=n1,n2
        do 305 j=1,10
        ar(j)=0.0
        ai(j)=0.0
        if(jsrc(lsrc(j)).eq.1)read(3,err=9999,end=9999)ar(j),ai(j)
  305   continue
        write(4)ar,ai
  300 continue
c-----
c     Now that all spectra for a given distance are in
c     make time history and output in desired order
c-----
      do 1300 jk=1,10
      do 1301 i=1,n
         data(i)=cmplx(0.0,0.0)
 1301 continue
      rewind 4
      do 1302 i=n1,n2
      read(4)ar,ai
      data(i)=cmplx(ar(jk),ai(jk)) * datas(i)
c-----
c	if integrate
c-----
	if(idva.eq.0)then
		omega = 6.2831853*(i-1)*df	
		data(i) = data(i) / cmplx(alpha,omega)
	elseif(idva.eq.2)then
		omega = 6.2831853*(i-1)*df
		data(i) = data(i) * cmplx(alpha,omega)
	endif
c-----
c    make a real time series
c-----
      if(i.ne.1)data(n+2-i)=conjg(data(i))
 1302 continue
      data(nyq)=cmplx(real(data(nyq)),0.0)
      call four(data,n,+1,dt,df)
c-----
c    output the time series
c-----
c     correct for damping 
      fac = exp(alpha*t0) 
      dfac = exp(alpha*dt) 
      do 425 i = 1,n 
      data(i)= data(i) * fac
      fac = fac * dfac 
  425 continue 
      write(LOT,111)(real(data(i)),i=1,n)
  111 format(5e16.9)
 1300 continue
 9000 continue 
      go to 9997 
 9999 continue 
      close(3) 
      close(4)
      stop 
      end 

      subroutine four(data,nn,isign,dt,df) 
      dimension data(*) 
      n = 2 * nn 
      if(dt.eq.0.0) dt = 1./(nn*df) 
      if(df.eq.0.0) df = 1./(nn*dt) 
      if(dt.ne.(nn*df)) df = 1./(nn*dt) 
      j = 1 
      do 5 i=1,n,2 
      if(i-j)1,2,2 
    1 tempr = data(j) 
      tempi = data(j+1) 
      data(j) = data(i) 
      data(j+1)=data(i+1) 
      data(i) = tempr 
      data(i+1) = tempi 
    2 m = n/2 
    3 if(j-m) 5,5,4 
    4 j = j-m 
      m = m/2 
      if(m-2)5,3,3 
    5 j=j+m 
      mmax = 2 
    6 if(mmax-n) 7,10,10 
    7 istep= 2 *mmax 
      theta = 6.283185307/float(isign*mmax) 
      sinth=sin(theta/2.) 
      wstpr=-2.*sinth*sinth 
      wstpi=sin(theta) 
      wr=1.0 
      wi=0.0 
      do 9 m=1,mmax,2 
      do 8 i=m,n,istep 
      j=i+mmax 
      tempr=wr*data(j)-wi*data(j+1) 
      tempi=wr*data(j+1)+wi*data(j) 
      data(j)=data(i)-tempr 
      data(j+1)=data(i+1)-tempi 
      data(i)=data(i)+tempr 
    8 data(i+1) = data(i+1)+tempi 
      tempr = wr 
      wr = wr*wstpr-wi*wstpi + wr 
    9 wi = wi*wstpr+tempr*wstpi + wi 
      mmax = istep 
      go to 6 
   10 continue 
      if(isign.lt.0) go to 1002 
c     frequency to time domain 
      do 1001 iiii = 1,n 
 1001 data(iiii) = data(iiii) * df 
      return 
 1002 continue 
c     time to frequency domain 
      do 1003 iiii = 1,n 
 1003 data(iiii) = data(iiii) * dt 
      return 
      end 

      subroutine pulpd(tau,dt,nt,l)
c     far field displacement
      common /source/ f(2048)
      ltest = 0
      tl = tau
      t1 = 0.01*dt
      t2 = t1 + tau
      t3 = t2 + tau
      t4 = t3 + tau
      t5 = t4 + tau
      do 100 i = 1,nt
      y=(i-1)*dt
      z = y - t1
      f(i) = 0.0
      if(y.gt.t1)go to 101
  101 if(y.gt.t2) go to 102
      f(i) = 0.5*(z/tl)**2
      go to 100
  102 if(y.gt.t3) go to 103
      f(i)= -0.5*(z/tl)**2 + 2.*(z/tl) - 1
      go to 100
  103 if(y.gt.t4) go to 104
      f(i)= -0.5*(z/tl)**2 + 2.*(z/tl) - 1.
      go to 100
  104 if(y.gt.t5) go to 105
      f(i)= 0.5*(z/tl)**2 - 4.*(z/tl) + 8.
      go to 100
  105 continue
      ltest = ltest + 1
      if(ltest.eq.1) l = i
  100 continue
c     pulse normalized so first integral has area of unity
      do 200 i = 1,nt
  200 f(i) = f(i)/(2.*tl)
      return
      end

      subroutine pulod(alp,dtt,nt,l)
c     far field displacement
c     for the ohnaka slip history
c     Harkrider (1976) Geophys J. 47, p 97.
      common/source/v(2048)
      ltest = 0
      do 100 i=1,nt
      t=(i-1)*dtt
      v(i)=0.0
      arg= alp*t
      al2=alp*alp
      v(i)=0.0
      if(arg.gt.25.)goto 101
        v(i)= al2*t*exp(-arg)
      goto 100
  101 continue
      ltest = ltest +1
      if(ltest.eq.1)l = i
  100 continue
      return
      end

      subroutine pultd(tau,dtt,nt,l)
c waveform is far-field displacement
c triangular pulse
c this is really a general trapezodal pulse, but only
c the symmetric triangular pulse is invoked
      common/source/d(2048)
      ltest = 0
      dt1=tau
      dt2=0.0
      dt3=tau
      t1=dt1
      t2=t1+dt2
      t3=t2+dt3
      fac = 0.5*dt1 + dt2 + 0.5*dt3
      fac = 1./fac
      v1 = fac/dt1
      v2 = 0.0
      v3 = - fac/dt3
      do 100 i=1,nt
      t = (i-1)*dtt
      d(i)=0.0
      if(t.le.t1)then
            dt = t - 0.0
            d(i) = dt*fac/dt1
      elseif(t.gt.t1.and.t.le.t2)then
            dt = t - t1
            d(i) = fac
      elseif(t.gt.t2.and.t.le.t3)then
            dt = t - t2
            d(i)= fac + v3*dt
      elseif(t.gt.t3)then
            d(i)=0.0
            ltest = ltest + 1
            if(ltest.eq.1)l = i
      endif
  100  continue
      return
      end

      subroutine puldd(dt,n,l)
      common/source/d(2048)
c-----
c	Dirac Delta Pulse
c-----
	do 100 i=1,n
		d(i) = 0.0
  100	continue
	d(1) = 1.0/dt
	return
	end

	subroutine pulud(rfile,n,tau)
	character rfile*(*)
	common/source/d(2048)
	do 100 i=1,n
		d(i) = 0.0
  100	continue
	open(1,file=rfile,status='unknown',form='formatted',
     1		access='sequential')
	rewind 1
	read(1,'(i5,f10.3)')np,dtt
	read(1,10)(d(i),i=1,np)
   10	format(4e15.7)
	close(1)
	tau = np*dtt
	return
	end

	subroutine gcmdln(ntau,ipt,iverby,alp,ifile,names,idva,
     1		xmult,rfile)
c-----
c     parse command line arguments
c     requires subroutine getarg() and function numarg()
c-----
	character*(*) names
	integer*4 numarg
	character*50 name, rfile
	integer idva 
	ntau = -1
	ipt = -1
	iverby = 0
	alp = -1.0
        ifile = -1
	idva = 1
	rfile = ' '
	xmult = 1.0
	nmarg=numarg()
   11	i = i + 1
		if(i.gt.nmarg)goto 13
		call getarg(i,name)
		if(name(1:2).eq.'-l')then
			i=i+1
			call getarg(i,name)
			read(name,'(i10)')ntau
		elseif(name(1:2).eq.'-f')then
			ifile=1
			i=i+1
			call getarg(i,names)
		else if(name(1:2).eq.'-a')then
			i=i+1
			call getarg(i,name)
			read(name,'(f10.0)')alp
		else if(name(1:2).eq.'-v')then
			iverby=1
		else if(name(1:2).eq.'-t')then
			ipt = 0
		else if(name(1:2).eq.'-p')then
			ipt = 1
		else if(name(1:2).eq.'-o')then
			ipt = 2
		else if(name(1:2).eq.'-i')then
			ipt = 3
		else if(name(1:2).eq.'-D')then
			idva = 0
		else if(name(1:2).eq.'-V')then
			idva = 1
		else if(name(1:2).eq.'-A')then
			idva = 2
		else if(name(1:2).eq.'-F')then
			ipt = 4
                        i=i+1
                        call getarg(i,rfile)
		else if(name(1:2).eq.'-m')then
			i=i+1
			call getarg(i,name)
			read(name,'(f20.0)')xmult
		else if(name(1:2).eq.'-?')then
			call usage('Help')
		endif
	goto 11
   13	continue
c-----
c     do some error checking, e.g., we cannot generate velocity
c     for triangular pulse
c-----
        if(ifile.lt.0)call usage('No binary data file')
	if(ipt.eq.2 .and. alp.lt.0.0)
     1		call usage('No alpha for Ohnaka pulse')
	if(ipt.lt.0)
     1		call usage('No pulse shape defined')
	return
	end

	subroutine usage(str)
	parameter (LER=0, LIN=5, LOT=6)
	character str*(*)
	write(LER,*)'rhfoc10:',str
        write(LER,*)'USAGE: ',
     1	'rhfoc10 -f FILE [ -v  ] [ -t -o -p -i ] -a alpha',
     2	' -l L [ -D -V -A]  [-F rfile ] [ -m mult]'
	write(LER,*)
     1	' -f FILE      Name of binary omega-r file'
	write(LER,*)
     1	' -v           Verbose output'
	write(LER,*)
     1	' -t           Triangular pulse of base 2L dt'
	write(LER,*)
     1	' -p           Parabolic Pulse of base  4L dt'
	write(LER,*)
     1	' -o           Ohnaka pulse with parameter alpha'
	write(LER,*)
     1	' -i           Impulse (this will some ripple'
	write(LER,*)
     1	' -a alpha     Shape parameter for Ohnaka pulse'
	write(LER,*)
     1	' -D           Output is ground displacment'
	write(LER,*)
     1	' -V           Output is ground velocity (default)'
	write(LER,*)
     1	' -A           Output is ground acceleration'
	write(LER,*)
     1	' -F rfile     User supplied pulse'
	write(LER,*)
     1	' -m mult      Multiplier (default 1.0)'
	write(LER,*)
     1	' -?           Write this help message'
        
	stop
	end

      subroutine mchdep()
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME VI                                                      c
c                                                                     c
c      PROGRAM: MCHDEP                                                c
c                                                                     c
c      COPYRIGHT 1985                                                 c
c      R. B. Herrmann                                                 c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      return
      end

	function numarg()
	integer numarg
	numarg = iargc()
	return
	end

c
c
c   Convert ISC  Fixed File format to Nordic format
c   J. Havskov, November 1993
c
c   changes:

c   sep 22, 94 by jh: add polarity and number of stations
c   dec 95          : many changes, complete overhaul
c   jan 21  96      : agency file separately
c   feb 18          : only write out isc format if selected, bug
c   jan 3   97      : adopt for cd rom, small fixes
c   feb 5           : use isc phases optionally
c   mar 5           : some error in phase selection
c   aug 98          : limit output on screen, bug with magnitude and
c                     area selection, skip events with ewrrros, seems to
c                     be erratic. Taking CD in and out might cure the problem.
c   sep 25  99       -----------------    version 7.0 ------------------------
c                    minor changes
c   sep 10  03      : read from both old and new cd structure 
c   nov 21  03      : seems like read of station coordinates was wrong
c                     secons were 10 times too large
c
c   to get output in isc format, set debug=1. the output file name is iscnor.isc
c 
      implicit none
      include 'libsei.inc'           ! for libsei.for
      integer readings
      parameter (readings=20000)     ! max number of number of lines, one event
      character*80 data(readings)    ! nordic format data        
      character*80 infile            ! input file name
      character*80 text              ! general text
      integer code                   ! error code
      integer nrecord,nrecord1,nhead   ! # records and headers in isc event
      character*96 iscd              ! one line in isc file
      character*96 isc(readings)     ! one event, isc format
      character*7  agency(readings)  ! agencies reporting hypocenter
      integer ilatmin,ilonmin        ! whole minutes of lat and lon
      logical wout                   ! if true, write out selected event on screen
      character*1 answer               
      real latmin,lonmin             ! minutes and seconds of lat and lon
      real minlat,maxlat,minlon,maxlon  ! range if selected
      real mindepth,maxdepth         ! range of depths to select in
      logical select                 ! true if in selection window
      integer in                     ! 0: single file, 1: from filenr.lis
                                     ! 2: from cdrom
      character*1 drive              ! cdrom drive letter
      integer year1,year2,month1,month2  ! time interval used on cdrom
      integer hypo                   ! 0: all event output, 1: only header line
      integer phase_select           ! selection of phases
      real minmag,maxmag             ! magnitude range
      integer i,nr,nevent,debug,k    ! counters etc
      logical pc,sun,linux                 ! computer type


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      call computer_type(sun,pc,linux)
	  
      debug=0                        ! set to 1 and more aoutput available
      nevent=0
      if(debug.eq.1) then 
         open(27,file='iscnor.dbg',status='unknown')
         open(20,file='iscnor.isc',status='unknown')
      endif
c
 22   continue
      write(6,*)' Phases selected can be:'
      write(6,*)'   User reported phases (default=return)          : 1'
      write(6,*)'   ISC identified phases only                     : 2'
      write(6,*)'   ISC identified phases and user reported phases    '
      write(6,*)'       when not identified by ISC                 : 3'
      read(5,'(a)') text
      if(text(1:2).ne.' ') then
             call sei get values(1,text,code)
             phase_select=array$(1)
      else
	         phase_select=1
      endif
      if(phase_select.gt.3.or.phase_select.lt.1) goto 22
c
c   set defaults
c
        mindepth=-10.0
        maxdepth=1000.0
        minlat=-99.0
        maxlat=99.0
        minlon=-500.0
        maxlon=500.0
        hypo=0
        minmag=-99
        maxmag=99
c
 11     continue
        write(6,*) ' Output: All hypocenters and phases : Return'
		write(6,*) '         All hypocenters            : 1'
        write(6,*) '         Prime hypocenter           : 2'
        read(5,'(a1)') answer
        if(answer.ne.' ') read(answer,'(i1)',err=11) hypo
        if(hypo.gt.2.or.hypo.lt.0) goto 11
c
c   get choises
c
        write(6,*)' Latitude range, return for all '
        read(5,'(a)') text
         if(text(1:2).ne.' ') then
             call sei get values(2,text,code)
             minlat=array$(1)
             maxlat=array$(2)
         endif
         write(6,*)' Longitude range, return for all'
         read(5,'(a)') text
         if(text(1:2).ne.' ') then
             call sei get values(2,text,code)
             minlon=array$(1)
             maxlon=array$(2)
         endif
         write(6,*)' Depth range, return for all'
         read(5,'(a)') text
         if(text(1:2).ne.' ') then
             call sei get values(2,text,code)
             mindepth=array$(1)
             maxdepth=array$(2)
         endif
         write(6,*)' Magnitude range, return for all'
         read(5,'(a)') text
         if(text(1:2).ne.' ') then
             call sei get values(2,text,code)
             minmag=array$(1)
             maxmag=array$(2)
         endif
         write(6,*)' Write selected events on screen (y/no=return)'
         read(5,'(a)') answer
         if(answer.eq.'y'.or.answer.eq.'Y') then
            wout=.true.
         else
            wout=.false.
         endif
c
c   output file in nordic format
c
      open(2,file='iscnor.out',status='unknown')
c
c   open station file
c
      open(3,file='isc.sta',status='unknown')
c
c   check if an agency file, if so read
c
      do i=1,readings
         agency(i)='       '
      enddo
      open(8,file='agency.isc',status='old',err=2233)
      write(6,*)' An agency file is present'
         k=0
 2220    continue
         read(8,'(a)',end=2299) iscd
         if(iscd(1:2).eq.'90') then
            read(iscd(11:13),'(i3)') i   ! agency number
            agency(i)=iscd(14:20)
            k=k+1
         endif
         goto 2220
 2299    continue
         write(6,*)' Number of agencies in agency.isc file',k
         goto 2240
 2233    continue
         write(6,*)' No agency.isc file present'
 2240 continue
      close(8)
c
c------------------------------------
c   get to here to read next file
c------------------------------------
c
      drive=' '
c
c   check for CD
c
      if(pc) then
         write(6,*)' If ISC CDROM, give drive letter, else return'
         read(5,'(a)') drive
      endif
      if(drive.ne.' ') then
         write(6,'(a,$)')' Give first year and month, e.g. 199501 '
         read(5,'(i4,i2)')year1,month1
         write(6,'(a,$)')' Give  last year and month, e.g. 199602 '
         read(5,'(i4,i2)')year2,month2
         in=2           ! input from cd room
         month1=month1-1 ! initialize for loop add
         if(month1.eq.0) then
            year1=year1-1
            month1=12
         endif
      endif
c
 500  continue
      if(in.eq.0) then                        ! interactive input or first time
         write(6,*)' Input file name, filenr.lis for a list of names'
         read(5,'(a)') infile
         if(infile(1:4).eq.'    ') goto 199   ! no more files, stop
      endif
c
c   check if a list of names
c
      if(infile(1:10).eq.'filenr.lis') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   go straight to read
c
      if(in.eq.0) then
         open(1,file=infile,status='old',err=505)
         goto 506
      endif
c
c   file loop if many files
c
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
         open(1,file=infile,status='old',err=505)
         goto 506
      endif
c
c   loop over cdrom
c
      if(in.eq.2) then
         month1=month1+1
         if(month1.gt.12) then
            month1=1
            year1=year1+1
         endif
         if(year1.gt.year2.or.
     *   year1.eq.year2.and.month1.gt.month2) then
             goto 199
         endif
c
c   make CD file name, two possibilities, old and new structure
c
c
c  old structure
c

         write(infile,'(a,a,a,i4,a,i4,i2,a)')
     *   drive,':',char(92),year1,char(92),year1,month1,'.FFB'
         do i=1,16
           if(infile(i:i).eq.' ') infile(i:i)='0'
         enddo
         open(1,file=infile,status='old',err=504)
         goto 506
c
c  new structure
c
 504     continue

         write(infile,'(a,a,a,a,a,i4,a,i4,i2,a)')
     *   drive,':',char(92),'ffb',char(92),year1,char(92),
     *   year1,month1,'.FFB'
          do i=1,20
           if(infile(i:i).eq.' ') infile(i:i)='0'
         enddo
         open(1,file=infile,status='old',err=505)
         goto 506
      endif
c
c   error condition
c

 505  continue


      write(6,'(a,a)')' No such file:  ', infile

      if(in.eq.1.or.in.eq.2) then             ! stop if error in list of files
         goto 199
      else
         goto 500
      endif

 506  continue
      write(6,'(1x,a,a)') 'Now reading from: ',infile
c
c   read agency names and stations from within parameter file, might be
c   read twice
c    
      k=0
      read(1,'(a)') iscd
      do while(iscd(1:2).ne.' 1')     ! continue until first hypocenter record
         read(1,'(a)',end=99) iscd
         if(iscd(1:2).eq.'90') then
            read(iscd(11:13),'(i3)') i   ! agency number
            agency(i)=iscd(14:20)
            k=k+1
         endif
         if(iscd(1:2).eq.'91') then
            read(iscd(64:68),'(i2,i3)') ilatmin,i
            latmin=ilatmin+i/600.0    ! was 60.0 before nov 03
            read(iscd(73:77),'(i2,i3)') ilonmin,i
            lonmin=ilonmin+i/600.0   !  was 60.0 before nov 03 
            write(3,'(2x,a4,a2,f5.2,a1,a3,f5.2,a5)')
     *      iscd(15:18),iscd(62:63),latmin,
     *      iscd(69:69),iscd(70:72),lonmin,iscd(78:82)
         endif
      enddo
c      write(6,*)' Number of agencies in input file',k
      backspace 1                        ! point again to first hypocenter line
c
c   event read loop
c
 10   continue
c
c   read one event in isc format
c
      call read_one_isc(1,isc,nrecord,nhead)
      if(nrecord.eq.0) goto 89           ! end of file
      if(nrecord.gt.readings) then
         write(6,*)' Too small dimension in program'
         stop
      endif
      nrecord1=nrecord                   ! save number of isc lines for output

c
c   convert to nordic format and write out
c
      call  read_isc(isc,nrecord,agency,nr,data,minlat,maxlat,
     *minlon,maxlon,mindepth,maxdepth,select,
     *minmag,maxmag,phase_select,debug)
c
c   only write out if event is selected
c
      if(select) then 
         if(hypo.eq.0) then
            write(2,'(a)') (data(i),i=1,nr)  ! whole event
         elseif(hypo.eq.1) then              ! hypocenter lines
            do i=1,nr
              if(data(i)(80:80).eq.'1') write(2,'(a)') data(i)    
              if(data(i)(80:80).eq.'7') goto 44
            enddo
            text=' '
  44        continue
			write(2,'(a)') text              ! blank line to separate events
         else                                ! only main hypocenter
              write(2,'(a)') data(1)
         endif
         nevent=nevent+1
         if(wout) write(6,'(a,i7,2x,a,1x,a,1x,i4)')
     *' # ',nevent, data(1)(1:15),'# lines ',nr
         if(debug.eq.1) then
            write(20,'(a)')(isc(i),i=1,nrecord1)
            write(20,*)
         endif
       else
c          write(6,'(a,a,i6)')data(1)(1:15),
c     *    ' not selected ',
c     *    nrecord1
       endif
         
      goto 10   ! next event
c
 89   continue
      close(1)
      write(6,*) ' Number of events selected: ',nevent
      goto 500  ! next input file
c
c   get here if an error
c
 99   continue
      write(6,*)' Missing data in input file'
      close(1)
      goto 500
c
    
 199  continue
c      write(6,*)nevent,' events converted'
      write(6,*)' Output file name is iscnor.out'
      write(6,*)' File with stations is isc.sta'
      stop
      end

      subroutine read_isc(isc,nrecord,agency,nr,data,minlat,maxlat,
     *minlon,maxlon,mindepth,maxdepth,
     *select,minmag,maxmag,phase_select,debug)
c
c    isc: data in isc format
c    nrecord: number of records in isc format
c    agency: agency list
c    nr: number of records in nordic format returned
c    data: nordic format data returned
c    ninlat ...: parameters for selection
c    select: true if event selected
c    phase_select: selection of phases, see main program
c    debug: if 1, more debug out
c	  
c
c   convert one event in Fixed file ISC format and returns event in Nordic 
c   format in array data
c
c   principles:
c
c   phases: user phase, isc numerical or both can be output
c           if users phases are used then:
c           parenthsis are removed, if P/PKP etc is give, it is replaced by
c           P etc
c   times:  if day is incremented relative to origin time day, it is carried 
c           into the hours, which can be more than 24
c   agency: it is assumed that it is the same agency for hypocenter and first
c           magnitude. 2. magnitude is checked for agency, if blank, assumed
c           also to be the same. only first 3 chars of code used.
c   depth:  if no error on depth, a depth fix flag is set.
c   first motion: only c or d, isc codes J an B are ignored.
c   hypocenter orders: isc put best solution last, here the order is reversed
c           and the prime estimate is first
c   duration magnitude: change D to C for type
c   event type: if station furthest away is 1000 km, L, 1000-3000 km. R and 
c           more than 3000 km , D
c
      implicit none
      character*80 data(*)          ! Nordic array of data
      integer nrecord               ! number of lines in input isc
      character*7  agency(*)        ! agency name
      character*96 isc(*)           ! one event in isc format
      character*8  phase            ! the phase id
      integer      isc_phase        ! isc numerical phase code
      character*8  phase_out        ! ------------
      integer      phase_select     ! types of phases selected
      character*4  oldstat          ! save station code to count stations
      integer      nstat            ! number of stations
      integer      id               ! line type of isc file
      character*1  type             ! event type e.g. E for exploson
      real         sec              ! secs
      integer      origin_day       ! day of origin
      integer      phase_day        ! day of phase
      integer      phase_hour       ! hour of phase
      real         lat,lon,depth    ! hypocenter
      real         oerror,laterror,lonerror,herror    ! hypocenter errors
      real         mag,mag1,mag2    ! magnitude
      real         amp              ! amplitude
      integer      iamp             ! amntissa of amplitude
      real         period           ! period
      character*4  aperiod          ! period
      real         distance         ! epicentral distance
      real         max_distance     ! maximum -----------
      real         min_distance     ! minimum -----------
      real         residual         ! isc residual
      character*1  ev_type          ! distance indicator
      integer      nr               ! number of output records
      integer      ihead            ! headers out
      integer      iphase           ! number of phases
      integer      iagency          ! agency number
      integer      debug            ! 0. no debug, 1: debug
      integer      i,k,ir           ! counters etc
      real         minlat,maxlat,minlon,maxlon  ! window to select
      real         mindepth,maxdepth ! range of depths to select
	  real         minmag,maxmag    ! magnitude range to select
      logical      select           ! true if inside lat lon window
      character*7  piphas               ! isc phases
      common /piphas2/ piphas (0:100)   ! define isc numeric phases
	  
c
c   define isc numerical phases 
c
      call setfis
c
      select=.true.
      iphase=0
      ihead=0
      nr=0
      ir=1
      nstat=0
      oldstat='    '
      max_distance=0.0
      min_distance=99999.0
      mag1=-99.0
      mag2=-99.0
c
  1   continue                      ! back here for another line
c
      read(isc(ir)(1:2),'(i2)',err=8000) id
c
c----------------------------------
c  first hypocenter line
c----------------------------------
c
      if(id.eq.1) then
         nr=nr+1
         ihead=ihead+1
         do i=1,79
            data(nr)(i:i)=' '
         enddo
         data(nr)(80:80)='1'
         data(nr)(22:22)='D'         ! assume initially all to be distant
c
         read(isc(ir)(23:25),'(i3)',err=8000)   iagency ! agency number
         if(nr.lt.1) goto 8000
         data(nr)(46:48)=agency(iagency)(1:3)
         data(nr)(2:5)=isc(ir)(5:8)     ! year
         data(nr)(7:8)=isc(ir)(9:10)    ! month
         data(nr)(9:10)=isc(ir)(11:12)  ! day
         read(isc(ir)(11:12),'(i2)',err=8000) origin_day  ! save to compare with phase day
         data(nr)(12:13)=isc(ir)(13:14) ! hour
         data(nr)(14:15)=isc(ir)(15:16) ! min
         read(isc(ir)(17:20),'(f4.2)',err=8000) sec 
         if(debug.eq.1) 
     *   write(27,'(a,1x,i6,a)')data(nr)(1:17),iagency,agency(iagency)
         write(data(nr)(17:20),'(f4.1)') sec
         read(isc(ir)(27:33),'(f7.4)',err=8000) lat
         write(data(nr)(24:30),'(f7.3)') lat
         read(isc(ir)(36:43),'(f8.4)',err=8000) lon
         write(data(nr)(31:38),'(f8.3)') lon
         read(isc(ir)(46:49),'(f4.1)',err=8000) depth
         write(data(nr)(39:43),'(f5.1)') depth
c
c   check for window
c
         if((lat.gt.maxlat.or.lat.lt.minlat.or.lon.lt.minlon.
     *   or.lon.gt.maxlon.or.depth.gt.maxdepth.
     *   or.depth.lt.mindepth).and.nr.eq.1) then
c
c   outside window, return
c
            select=.false.
            return
         endif
            
         if(isc(ir)(52:55).ne.'    ') then
            read(isc(ir)(52:55),'(f4.2)',err=8000) mag              ! first magnitude
            if(nr.eq.1) mag1=mag                           ! save for later check
            write(data(nr)(56:59),'(f4.1)') mag
            data(nr)(60:60)=isc(ir)(62:62)                  ! type of magnitude
c
c   if a duration magnitude, write as C, seisan style
c
            if(data(nr)(60:60).eq.'d'.or.data(nr)(60:60).eq.'D')
     *      data(nr)(60:60)='C'
            data(nr)(61:63)=data(nr)(46:48)               ! mag agency, same as
          endif                                         ! hypocenter agency
      endif
c
c------------------------------
c  hypocenter continuation line
c------------------------------
c
      if(id.eq.2) then
            if(isc(ir)(11:14).ne.'    ') then
               read(isc(ir)(11:14),'(f4.2)',err=8000) mag        ! second magnitude
               write(data(nr)(64:67),'(f4.1)') mag
               if(nr.eq.1)mag2=mag
               data(nr)(68:68)=isc(ir)(21:21)            ! type of magnitude
c
c   if a duration magnitude, write as C, seisan style
c
            if(data(nr)(68:68).eq.'d'.or.data(nr)(68:68).eq.'D')
     *      data(nr)(68:68)='C'
               if(isc(ir)(15:17).ne.'   ')then
                   data(nr)(69:71)=isc(ir)(15:17)            ! mag agency
               else
                   data(nr)(69:71)=data(nr)(46:48)
               endif
            endif


            read(isc(ir)(32:36),'(f5.3)',err=8000) oerror        ! origin time error
            read(isc(ir)(39:44),'(f6.4)',err=8000) laterror      ! latitude error
            read(isc(ir)(47:52),'(f6.4)',err=8000) lonerror      ! longitde error
            read(isc(ir)(55:58),'(f4.1)',err=8000) herror        ! depth error
c
c   make error line
c
            if(oerror.ne.0.0.or.laterror.ne.0.0) then
               nr=nr+1
               ihead=ihead+1
               data(nr)=' '
               write(data(nr)(15:20),'(f6.2)') oerror
               write(data(nr)(25:30),'(f6.1)') laterror*111.195
               write(data(nr)(33:38),'(f6.1)') 
     *         lonerror*111.195*cos(lat/57.3)   ! convert to km
               if(herror.ne.0.0) then
                   write(data(nr)(39:43),'(f5.1)') herror
               else
                   data(nr-1)(44:44)='F'        ! depth fixed
               endif
               data(nr)(80:80)='E'
            endif
c
            type=isc(ir)(61:61)
            if(type.eq.'N'.or.type.eq.'H') type='E' ! explosion
c
c   make felt line
c
           if(type.eq.'F') then
              type=' '
              nr=nr+1
              ihead=ihead+1
              data(nr)=' '
              data(nr)(28:29)=isc(ir)(86:87)
              data(nr)(31:31)=isc(ir)(88:88)
              data(nr)(80:80)='2'
           endif
c
c   put in event type
c
           data(nr)(23:23)=type
        endif

c
c------------------------------------------------
c   first comments line
c------------------------------------------------
c
      if(id.eq.3) then                            ! more hypocneter info
           nr=nr+1
           ihead=ihead+1
           read(isc(ir)(21:23),'(i3)',err=8000) i     ! agency number
           if(i.gt.0) then
              data(nr)(2:8)=agency(i)
           else
              data(nr)(2:8)='       '
           endif
           data(nr)(8:8)=isc(ir)(24:24)     ! quality
           data(nr)(9:9)=' '
           data(nr)(10:79)=isc(ir)(25:94)
           data(nr)(1:1)=' '
           data(nr)(80:80)='3'
c
c   if comments left, put on new line
c
           if(isc(ir)(95:96).ne.'  ') then
             nr=nr+1
             data(nr)(1:1)=' '
             data(nr)(2:3)=isc(ir)(95:96)
             do i=3,79
               data(nr)(i:i)=' '
             enddo
             data(nr)(80:80)='3'
           endif
       endif
c
c---------------------------------------
c  second comment line
c---------------------------------------
c
      if(id.eq.4) then                            ! more hypocneter info
           nr=nr+1
           ihead=ihead+1
           data(nr)(2:79)=isc(ir)(13:90)
           data(nr)(1:1)=' '
           data(nr)(80:80)='3'
c
c   if comments left, put on new line
c
           if(isc(ir)(91:96).ne.'      ') then
             nr=nr+1
             data(nr)(1:1)=' '
             data(nr)(2:7)=isc(ir)(91:96)
             do i=8,79
               data(nr)(i:i)=' '
             enddo
             data(nr)(80:80)='3'
           endif
      endif
c
c--------------------------------------------------
c  initial phase record
c--------------------------------------------------
c
      if(id.eq.5) then
         if(iphase.eq.0) then  ! write header line for first phase
            nr=nr+1
            write(data(nr),243)
 243        FORMAT(
     *     ' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO ',
c     *     'SNR AR TRES W  DIS CAZ7')
     *     'AIN AR TRES W  DIS CAZ7')
          endif
          iphase=iphase+1
c
         nr=nr+1
         do i=1,80
           data(nr)(i:i)=' '
         enddo
         data(nr)(2:5)=isc(ir)(11:14)               ! station
         if(isc(ir)(11:14).ne.oldstat) then
            nstat=nstat+1                        ! count stations
            oldstat=isc(ir)(11:14)
         endif
         data(nr)(8:8)=isc(ir)(70:70)               ! component
         read(isc(ir)(61:63),'(i3)',err=8000) isc_phase      ! isc numeric code
         phase=' '
c
c  select type and weight of phase
c 
         phase=isc(ir)(49:56)           ! user phase by default
         if(phase_select.gt.1) then     ! isc phase if defined
             if(isc_phase.le.100) then  ! isc defined
                phase(1:7)=piphas(isc_phase)
             endif
         endif
c
c  only isc phase, rest will get zero weight
c
         if(phase_select.eq.2) then     ! only isc 1. arrival
             if(isc_phase.gt.100) then
                if(phase(5:5).eq.' ') then
                   phase(5:5)='4'          ! weight in phase name
                else
                   data(nr)(9:9)='4'       ! weigh in alternativ position
                endif
              endif
         endif
c
c   check if any parenthesis, remove if there 
c
         k=1
         phase_out='       '
         do i=1,8
           if(phase(i:i).ne.'('.and.phase(i:i).ne.')') then
              phase_out(k:k)=phase(i:i)
              k=k+1
           endif
         enddo
         phase=phase_out
c
c   remove any phase id behind /
c

         k=index(phase,'/')
         if(k.gt.0) then
            do i=k,8
              phase(i:i)=' '
            enddo
         endif           
c
         data(nr)(10:10)=isc(ir)(71:71)             ! onset
         data(nr)(11:18)=phase
         data(nr)(19:22)=isc(ir)(36:39)             ! hour min
c
c   check if phase is from same day as origin time
c
         read(isc(ir)(34:35),'(i2)',err=8000) phase_day
         if(phase_day.ne.origin_day.and.phase_day.ne.0) then
           if(phase_day.eq.origin_day+1) then
              read(data(nr)(19:20),'(i2)',err=8000) phase_hour
              phase_hour=phase_hour+24
              write(data(nr)(19:20),'(i2)') phase_hour
              if(debug.eq.1) write(27,'(a,a,a)')
     *        ' add 24 hrs',data(1)(1:45), data(nr)(1:8)
           else
              if(debug.eq.1) then 
                 write(27,'(a,a,a)')
     *           ' error time',data(1)(1:45), data(nr)(1:8)
                 write(27,*)'phase_day',phase_day
                 write(27,*)'origin_day',origin_day
               endif
           endif
         endif
         if(isc(ir)(40:43).ne.'    ') then
            read(isc(ir)(40:43),'(f4.2)',err=8000) sec
            write(data(nr)(24:28),'(f5.2)') sec
         endif
c
c   residual
c
         if(isc(ir)(64:67).ne.'    '.and.isc(ir)(64:67).ne.
     &       '9999') then
            read(isc(ir)(64:67),'(f4.1)',err=8000) residual
            write(data(nr)(64:68),'(f5.1)') residual
         endif
c
c  amplitude and period
c
         if(isc(ir)(78:81).ne.'   '.and.isc(ir)(78:81).ne.'9999') then
            aperiod='    '
            read(isc(ir)(78:81),'(f4.3)',err=8000) amp  ! mantissa
            read(isc(ir)(82:83),'(i2)',err=8000) iamp   ! exponent
            amp=amp*(10**iamp)              ! amp in nm
            aperiod='    '
            if(isc(ir)(86:89).ne.'    ') then
               read(isc(ir)(86:89),'(f4.1)',err=8000) period
               write(aperiod,'(f4.1)') period
            endif
            if(amp.lt.100000.)                                                 
     +      write(data(nr)(34:45),'(f7.1,1x,a4)')
     +      amp,aperiod
            if(amp.ge.100000.)then
               amp=amp/10000.0                 
               write(data(nr)(34:45),'(f5.1,a,1x,a4)')
     +         amp,'e4',aperiod
            endif
            if(amp.ge.10000000.)then
               amp=amp/1000000.0                 
               write(data(nr)(34:45),'(f5.1,a,1x,a4)')
     +         amp,'e6',aperiod
            endif
          endif
c
c   distance
c
          distance=0.0
          if(isc(ir)(26:30).ne.'     ') then
             read(isc(ir)(26:30),'(f5.2)',err=8000) distance
             distance=distance*111.195 +0.5  ! convert to km, round off
             if(distance.gt.max_distance) max_distance=distance
             if(distance.lt.min_distance) min_distance=distance
             write(data(nr)(71:75),'(i5)') int(distance)
          endif
c
c   polarity
c
         if(isc(ir)(68:68).eq.'+'.or.isc(ir)(68:68).eq.'1'.or.
     *      isc(ir)(68:68).eq.'A'.or.isc(ir)(68:68).eq.'C')
     *      data(nr)(17:17)='C'
         if(isc(ir)(68:68).eq.'-'.or.isc(ir)(68:68).eq.'2'.or.
     *      isc(ir)(68:68).eq.'K'.or.isc(ir)(68:68).eq.'D')
     *      data(nr)(17:17)='D'
      endif
c
c      
c--------------------------------------
c    supplementry phase line
c--------------------------------------
c
      if(id.eq.6) then
         nr=nr+1
         do i=1,80
           data(nr)(i:i)=' '
         enddo
         data(nr)(2:5)=data(nr-1)(2:5)           ! station, same as before
         data(nr)(8:8)=isc(ir)(49:49)               ! component
         data(nr)(10:10)=isc(ir)(50:50)             ! onset
         read(isc(ir)(40:42),'(i3)',err=8000) isc_phase      ! isc numeric code
         phase=' '

c
c  select type and weight of phase
c 
         phase=isc(ir)(28:35)                       ! users phase
         if(phase_select.eq.3) then     ! isc first arrival and user 2. arrival
             if(isc_phase.le.100) then  ! isc defined
                phase(1:7)=piphas(isc_phase)
             endif
         endif
c
c  only isc first arrival, rest will get zero weight
c
         if(phase_select.eq.2) then     ! only isc 1. arrival
             if(isc_phase.gt.100) then
                if(phase(5:5).eq.' ') then
                   phase(5:5)='4'          ! weight in phase name
                else
                   data(nr)(9:9)='4'       ! weigh in alternativ position
                endif
              endif
         endif
c
c   check if any parenthesis, remove if there 
c
         k=1
         phase_out='       '
         do i=1,8
           if(phase(i:i).ne.'('.and.phase(i:i).ne.')') then
              phase_out(k:k)=phase(i:i)
              k=k+1
           endif
         enddo
         phase=phase_out
c
c   remove any phase id behind /
c

         k=index(phase,'/')
         if(k.gt.0) then
            do i=k,8
              phase(i:i)=' '
            enddo
         endif           
c
         data(nr)(11:18)=phase
         data(nr)(19:22)=isc(ir)(15:18)             ! hour min
         if(isc(ir)(19:22).ne.'    ') then
            read(isc(ir)(19:22),'(f4.2)',err=8000) sec
            write(data(nr)(24:28),'(f5.2)') sec
         endif
c
c   check if phase is from same day as origin time
c
         read(isc(ir)(13:14),'(i2)',err=8000) phase_day
         if(phase_day.ne.origin_day.and.phase_day.ne.0) then
           if(phase_day.eq.origin_day+1) then
              read(data(nr)(19:20),'(i2)',err=8000) phase_hour
              phase_hour=phase_hour+24
              write(data(nr)(19:20),'(i2)') phase_hour
              if(debug.eq.1) write(27,'(a,a,a)')
     *        ' add 24 hrs',data(1)(1:45), data(nr)(1:8)
           else
              if(debug.eq.1) then 
                write(27,'(a,a,a)') 
     *        ' error time',data(1)(1:45), data(nr)(1:8)
                 write(27,*)'phase_day',phase_day
                 write(27,*)'origin_day',origin_day
              endif
           endif
         endif
c
c   polarity
c
         if(isc(ir)(47:47).eq.'+'.or.isc(ir)(47:47).eq.'1'.or.
     *      isc(ir)(47:47).eq.'A'.or.isc(ir)(47:47).eq.'C')
     *      data(nr)(17:17)='C'
         if(isc(ir)(47:47).eq.'-'.or.isc(ir)(47:47).eq.'2'.or.
     *      isc(ir)(47:47).eq.'K'.or.isc(ir)(47:47).eq.'D')
     *      data(nr)(17:17)='D'
c
c   residual
c
         if(isc(ir)(43:46).ne.'    '.and.isc(ir)(43:46).ne.'9999') then
            read(isc(ir)(43:46),'(f4.1)',err=8000) residual
            write(data(nr)(64:68),'(f5.1)') residual
         endif
c
c  amplitude and period
c
         if(isc(ir)(57:60).ne.'   '.and.isc(ir)(57:60).ne.'9999') then
            aperiod='    '
            read(isc(ir)(57:60),'(f4.3)',err=8000) amp  ! mantissa
            read(isc(ir)(63:64),'(i2)',err=8000) iamp   ! exponent
            amp=amp*(10**iamp)              ! amp in nm
            aperiod='    '
            if(isc(ir)(65:68).ne.'    ') then
               read(isc(ir)(65:68),'(f4.1)',err=8000) period
               write(aperiod,'(f4.1)') period
            endif
            if(amp.lt.100000.)                                                 
     +      write(data(nr)(34:45),'(f7.1,1x,a4)')
     +      amp,aperiod
            if(amp.ge.100000.)then
               amp=amp/10000.0                 
               write(data(nr)(34:45),'(f5.1,a,1x,a4)')
     +         amp,'e4',aperiod
            endif
            if(amp.ge.10000000.)then
               amp=amp/1000000.0                 
               write(data(nr)(34:45),'(f5.1,a,1x,a4)')
     +         amp,'e6',aperiod
            endif
          endif
c
          if(distance.ne.0.0)write(data(nr)(71:75),'(i5)')int(distance)
      endif
c
c   next input
c
      ir=ir+1
      if(ir.gt.nrecord) then        ! end of event
          if(nstat.gt.1000) then
             if(debug.eq.1) write(27,*) 'nstat',nstat
             nstat=999                  ! there is only room for 3 digits
          endif
          if(nstat.gt.0) write(data(1)(49:51),'(i3)') nstat ! number of stations
c
c   find which distance for event, if no distance, leave event as
c   distant
c
         ev_type='D'
         if(max_distance.lt.3000.0.and.max_distance.ge.1000.0)
     *   ev_type='R'   ! regional
         if(max_distance.lt.1000.0.and.max_distance.gt.0.0)
     *   ev_type='L'   ! local
         do i=1,ihead
            if(data(i)(80:80).eq.'1') data(i)(22:22)=ev_type
         enddo
c
c   last blank line
c
         nr=nr+1
         do i=1,80
           data(nr)(i:i)=' '
         enddo
      else
         goto 1        ! get next line
      endif
c
c----------------------------------
c   check for magnitude selection
c----------------------------------
c
          if(minmag.ne.-99.and.maxmag.ne.99) then
                if((mag1.lt.minmag.and.mag2.lt.minmag)
     *         .or.(mag1.gt.maxmag.and.mag2.gt.maxmag)) then
                   select=.false.                        ! magnitude outside
                   return
                endif
          endif
      goto 8001

 8000 continue
      write(6,*)' Error in input data, event skipped'
      select=.false.
c
 8001 continue
      return
      end
cccccccccccccccccccccccccccccc
 
      subroutine read_one_isc(unit,isc,nrecord,nhead)
c
c   unit: unit to read from
c   isc : isc data lines
c   nrecord: number of lines one event
c   nhead: number of headers one isc event
c
c   reads one isc event in isc format, if nrecord=0 or nhead=0, end of file
c
      implicit none
      integer nhead              ! number if isc type 1 or 2 headers
      integer nrecord            ! number of records for event
      character*96 isc(*)        ! event records
      character*96 epihead(50,300)! lines for each estimate
      integer np(100)            ! # lines each estimate
      logical header_prime       ! true if prime header read
      integer unit               ! unit to read from
      integer nepi               ! number of estimates
      integer id                 ! line type
      integer i,k,l
      
      nhead=0
      nrecord=1
      header_prime=.false.
      nepi=0
      do i=1,50
        np(i)=0
      enddo
      
c
c   read loop
c
 1    continue
      read(unit,'(a)',end=99) isc(nrecord)
      read(isc(nrecord)(1:2),'(i2)',err=99) id
      if(id.gt.0.and.id.lt.5) then         ! a header record
c
c  catch a comment line within phases, throw it out
c
         if(header_prime.and.id.eq.3) goto 1
         if(id.eq.1) then
            if(header_prime) then          ! this was into next event
               backspace unit
               goto 99
            endif
            nepi=nepi+1                    ! a new epicenter estimate
            if(isc(nrecord)(26:26).eq.'A') then
               header_prime=.true.
            endif
         endif
         if(nepi.eq.0) then
           write(6,*)' No prime'
           nepi=1
         endif
c         write(6,*) id,nepi
         np(nepi)=np(nepi)+1               ! count lines for one estimate
         epihead(nepi,np(nepi))=isc(nrecord)  ! save estimate
         nhead=nhead+1
      endif
      nrecord=nrecord+1
      goto 1
c
c
 99   continue
      nrecord=nrecord-1
c
c  return if no data
c
      if(nrecord.eq.0) return
c
c  put prime estimates on top,  assume prime estimate is last
c
      l=1
      do k=nepi,1,-1
         do i=1,np(k)
           isc(l)=epihead(k,i)
           l=l+1
         enddo
      enddo
c
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine setfis

c set up ISC phase identifications with upper and lower case

      common /piphas2/ piphas (0:100)
      character*7 piphas
      
      piphas(  0) = 'P      '
      piphas(  1) = 'PP     '
      piphas(  2) = 'PPP    '
      piphas(  3) = 'PcP    '
      piphas(  4) = 'PKP    '
      piphas(  5) = 'PKP2   '
      piphas(  6) = 'PKPPKP '
      piphas(  7) = 'PcPPKP '
      piphas(  8) = 'PS     '
      piphas(  9) = 'PPS    '
      piphas( 10) = 'PcS    '
      piphas( 11) = 'PKS    '
      piphas( 12) = 'PKKS   '
      piphas( 13) = 'PcSPKP '
      piphas( 14) = 'PKPPKS '
      piphas( 15) = 'PKPSKS '
      piphas( 16) = 'PKKP   '
      piphas( 17) = '3PKP   '
      piphas( 18) = 'PKIKP  '
      piphas( 19) = 'PP2    '
      piphas( 20) = 'PPP2   '
      piphas( 21) = 'PKS2   '
      piphas( 22) = 'PSS    '
      piphas( 23) = 'PSS2   '
      piphas( 24) = 'SSP2   '
      piphas( 25) = 'PcPPKP2'
      piphas( 26) = 'PcSPKP2'
      piphas( 27) = 'SS2    '
      piphas( 28) = 'PKKP2  '
      piphas( 29) = 'PKKS2  '
      piphas( 30) = 'ScSPKP3'
      piphas( 31) = 'ScSPKP2'
      piphas( 32) = 'ScSP2  '
      piphas( 33) = 'SKSP2  '
      piphas( 34) = 'SSS2   '
      piphas( 35) = 'S      '
      piphas( 36) = 'SS     '
      piphas( 37) = 'SSS    '
      piphas( 38) = 'ScS    '
      piphas( 39) = 'SKS    '
      piphas( 40) = 'SKKS   '
      piphas( 41) = 'SKKKS  '
      piphas( 42) = 'ScSPKP '
      piphas( 43) = 'SKSSKS '
      piphas( 44) = 'ScSP   '
      piphas( 45) = 'SKSP   '
      piphas( 46) = 'ScP    '
      piphas( 47) = 'SP     '
      piphas( 48) = 'SKP    '
      piphas( 49) = 'SKKP   '
      piphas( 50) = 'SKPPKP '
      piphas( 51) = 'SSP    '
      piphas( 52) = 'SKP2   '
      piphas( 53) = 'SKS2   '
      piphas( 54) = 'SKKS2  '
      piphas( 55) = 'SKKS3  '
      piphas( 56) = 'SKKKS2 '
      piphas( 57) = 'sPKP2  '
      piphas( 58) = 'pPcP   '
      piphas( 59) = 'pPKP   '
      piphas( 60) = 'pP     '
      piphas( 61) = 'pPP    '
      piphas( 62) = 'sP     '
      piphas( 63) = 'sPKP   '
      piphas( 64) = 'sS     '
      piphas( 65) = 'sSS    '
      piphas( 66) = 'sPP    '
      piphas( 67) = 'sPcP   '
      piphas( 68) = 'sScS   '
      piphas( 69) = 'pPKP2  '
      piphas( 70) = 'P*     '
      piphas( 71) = 'S*     '
      piphas( 72) = 'Pg     '
      piphas( 73) = 'Sg     '
      piphas( 74) = 'Pn     '
      piphas( 75) = 'Sn     '
      piphas( 76) = 'PgPg   '
      piphas( 77) = 'SgSg   '
      piphas( 78) = 'LR     '
      piphas( 79) = 'LQ     '
      piphas( 80) = 'L      '
      piphas( 81) = 'PKKP3  '
      piphas( 82) = 'PKKS3  '
      piphas( 83) = 'SPP    '
      piphas( 84) = 'Phase84'
      piphas( 85) = 'P diff '
      piphas( 86) = 'QM     '
      piphas( 87) = 'RM     '
      piphas( 88) = 'T      '
      piphas( 89) = 'T(Max) '
      piphas( 90) = 'North  '
      piphas( 91) = 'South  '
      piphas( 92) = 'East   '
      piphas( 93) = 'West   '
      piphas( 94) = 'Up     '
      piphas( 95) = 'Down   '
      piphas( 96) = 'e      '
      piphas( 97) = 'i      '
      piphas( 98) = 'Maximum'
      piphas( 99) = 'Final  '
      piphas(100) = '       '
      return
      end

c
c program to: - invert for regional Q Lg 
c             - tomography inversion for QLg
c             - caclulate spectral ratios e.g. Lg/P 
c             - produe input for psxy distance plots
c
c
c by Lars Ottemoeller, Mexico City, July/August 2000
c
c email: larso@ifjf.uib.no
c
c

c
c changes:
c
c    Jul  7 2000 lo: work with horizontal components
c    Jul 11 2000 lo: Q tomography started
c    Jul 17 2000 lo: most bugs fixed
c    Jul 25 2000 lo: some more output
c    Jul 27      lo: add apriori values from regional inversion
c    Jul 31      lo: remove selected site terms from G matrix
c    Dec         lo: check if signal clipped
c    Dec 28 2000 lo: only plot traces if data selected for inversion
c    Jan 19 2001 lo: add checkerboard test, which sets synthetic data
c    Jan 01 2001 lo: routines spec_value and check_clipped moved out
c                    use r_m instead of m_2t, since same dim, no overlap,
c                    use h_m instead of m_2s, use h_m instead of rd_m
c    Mar 06 2001 lo: pass number of smooth into spec_values
c -------------------------------------- June 01,2001 moved to s2000
c    Jun 02 2001 lo: tested and fixed under Linux
c                    changed check for min time window
c    Jun 10 2001 lo: fix the damping constants
c    jul 3       jh: take out spec_values_old, crash on pc, wrong arguments
c                    change write01 to write1, did not work on pc
c    may 26 2005 lo: increased dimensions for grid and station number
c    jan 26 2006 lo: add file with lat,lon,slat,slon,ratio
c    feb 03 2007 lo: add fix_site and fix_source
c    mar 06 2007 lo: exclude data if either phase or waveform data have 
c                    uncertain time
c    jan 29 2008 lo: added correction for kappa to spectra
c    feb  8 2008 lo: changed term add to data for perturbation of source
c

      program qlg

      implicit none

      include 'libsei.inc'        ! Open file definitions
      include 'mulplt.inc'
      include 'qlg.inc'

      integer seiclen
      character*80 infile         ! waveform input file name
      integer a,i,j,ind,b,k       ! counters
      real sec_max,d_max       ! maximum seconds
c      real dist_min,dist_max         ! distance range
      real x,yy,x1,x2,y1,y2       ! x and y value
      real sum                    ! normalization factor
      real signal_lg(max_sample),signal_p(max_sample),
     &     signal_lg_e(max_sample),signal_lg_n(max_sample),
     &           signal_n(max_sample)  ! signal windows
      complex y_com(max_sample)   ! complex spectrum
      integer nsamp_lg,nsamp_lg_e,nsamp_lg_n,nsamp_p,nsamp_n
c      real max                    ! max amplitude
      real slat,slon,selev        ! station coords
      real lat,lon,dep            ! event coords
      real slat_rad,slon_rad,lat_rad,lon_rad
      real y_scale                ! scale for signal
      logical flag(max_trace)     ! flag
      logical good_signal         ! flag for signal
      character*50 epiline        ! epi info
      character*80 line           ! text
      real gv                     ! group velocity
      character*5 stat(max_trace) ! array with station names
      character*5 total_stat(max_trace) ! array with station names
      integer total_nstat         ! total number of stations
      integer swap_with           ! index
      integer n_lgmax(max_trace)  ! number of group velocitis for stat
      real gv_lgmax(max_trace)    ! group velocity of LG maximum
      real lg_max,lg_gv           ! max of lg amplitude
      integer nstat               ! number of stations
      logical new                 ! flag for new station
      logical clipped             ! true if signal clipped
c      real cbdelta                ! delta +/- apriror value
c      parameter (cbdelta=0.0004)

      real      cof(8)                  ! filter coefficients
      real      gain                    ! filter gain
c      integer npasses                   ! number of passes, 1 forward,

      integer year,month,day,hour,min ! time
      real sec
      double precision msec,rsec
      real pi,rearth,dist(max_trace),dedeg,az0 ! distance
      parameter (pi=3.141593)
c      real lg_low,lg_high,p_low,p_high
      real lg_p_ratio(max_trace)
      integer lg_nsamp,p_nsamp
      real lg_mean,p_mean
      integer path_unit
      integer npath(500)
      integer ipow

c      integer nfreq
c      parameter (nfreq=16)              ! number of frequencies
c      real freq_array(nfreq)            ! array of freq.
c      data freq_array /.2,.3,.4,.5,.65,.80,1.,1.25,1.60,2.,2.5,3.15,
c     &      4.,5.,6.3,8./
c      real alpha_array (nfreq)          ! array for Q-1
c
c CA
c
c      data alpha_array /4.56597E-02,1.43133E-02,7.68871E-03,5.18730E-03,
c     & 6.19911E-03,5.64579E-03,5.23922E-03,4.52463E-03,
c     & 4.12399E-03,3.53125E-03,
c     & 2.90813E-03,2.25682E-03,1.70294E-03,1.12286E-03,
c     & 6.17665E-04,2.59072E-04/

c
c Mexico
c
c      data alpha_array /2.78998E-03,2.64024E-03,2.63714E-03,2.91308E-03,
c     & 2.76488E-03,2.63947E-03,2.70083E-03,2.79560E-03,2.79123E-03,
c     & 2.60281E-03,2.38572E-03,2.15875E-03,1.71854E-03,1.33095E-03,
c     & 1.00949E-03,7.05749E-04/

      real alpha_apriori
      real level_lg(max_nfreq),level_p(max_nfreq),level_n(max_nfreq)
      real level_lg_n(max_nfreq),level_lg_e(max_nfreq)
      integer f_choice                  ! frequency choice
      character*1 option,ch    
      character*80 outfile
      integer write1

      integer station_counter

c-- number of stations
c      integer           nstat
c-- number of phases
      integer nphase
c-- number of header lines
c      integer           nhead
c-- number of records for event
c      integer           nrecord
c-- event type
      character*1      type
c-- exp indicator
      character*1       expl 
c-- id line number
      integer id
c event counter
      integer event_id
c response
      INTEGER NFILT,POLE(10)
      REAL FFILT(10)
      common /response/nfilt,pole,ffilt

c
c vectors and matrices for inversion d = G * m
c
c      integer min_stat        ! minimum number of stations
c      parameter (min_stat=4)  ! 
c      integer max_stat        ! max ----------------------
c      parameter (max_stat=200) ! used as start of source paramete in m
c      parameter (max_stat=200) ! used as start of source paramete in m
c      integer max_event       ! maximum number of events
c      parameter (max_event=150)
c      parameter (max_event=150)
c      integer xdim,ydim
c      parameter (xdim=1200)
c      parameter (xdim=1200)
c      parameter (ydim=2000)
c      parameter (ydim=2000)
      real d(ydim)
      integer d_index
      real m(xdim)
      real g(ydim,xdim)
      real f_m(xdim,xdim),h_m(xdim,xdim),c_m(ydim,ydim),q_m(xdim,xdim)
      real m_1(ydim,xdim),m_3(xdim,ydim),r_m(xdim,xdim)
c ,rd_m(xdim,xdim)
c      real m_2s(xdim,xdim),m_2t(xdim,xdim) ! lo
      real m_2(xdim,xdim),y_m(xdim,xdim)
      integer indx(xdim),dd
      character*80 event_line(ydim)
c      real lg_vel             ! lg max velocity in m/s ?
c      parameter(lg_vel=3350.) 
      real svel               ! s velocity
      parameter(svel=3500.) 
      real dens               ! density
      parameter (dens=2850.)
      real tol
      parameter (tol=1.E-5)
      real v(xdim,xdim),w(xdim)
      real cvm(xdim,xdim)
      real thresh,wmax
      integer mp,np
c      real moment
      real mmag
      real pol(max_polyn$,2)
      integer npol
      logical inst,inev
      character*1 polflag
      real geomsp                          ! geometrical spreading constant
c      real f_m_damping                     ! alpha
c      parameter (f_m_damping=500.)         ! Mexico
c      parameter (f_m_damping=0.)         ! 0=no smoothness 
c      parameter (f_m_damping=500.) 
c      real k0,sigma_k                      ! factors used to compute F
c      parameter (k0=1.)
c      parameter (sigma_k=100.)       ! Mexico 1 deg, 100
c      parameter (sigma_k=100.)         ! CA
      character*5 sel_stat_list(max_stat,2)! list of selected stations
      integer sel_stat_n
      logical sel_stat_flag,tflag
      logical event_id_fix(max_event)
      real magnitude
      integer statnobs(max_trace)  ! number of obs per station
      integer nstatobs
      character*5 statcode(max_trace)
      
c
c the grid
c
c      character*1 grid_flag                ! d if q for grid, else r
      integer max_grid                     ! maximum number of grid points
c      parameter (max_grid=25)
      parameter (max_grid=50)              ! lot 26/5/2005
c      integer xgrid_npts,ygrid_npts        ! number of grid points
c      real xgrid_delta,ygrid_delta         ! grid spacing
c      real xgrid_start,ygrid_start         ! start value for grid
      real xgrid(max_grid),ygrid(max_grid) ! the grid values
      real seg_length(max_grid**2)         ! length of segments
      real grid_xy(max_grid**2,2)          ! x and y of grid center
      real grid_len(max_grid,max_grid)     ! total path length in grid cell
      integer igrid                        ! flag
      integer ngrid                        ! number of cells in grid
      integer traces_per_event             ! counter per event
      real fin
      integer idum
      real gasdev
      real source1,source2                 ! source terms used in cb test

c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c read definition file
c
      call get_qlg_par

c
c initialize vectors and array
c
      do i=1,ydim
        d(i)=0.
        do j=1,xdim
          g(i,j)=0.
          if (i.eq.1) m(j)=0.
        enddo
      enddo
      d_index = 0
      do i=1,max_event
        event_id_fix(i)=.false.
      enddo

c
c set some consts
c
c      nsmooth=5   ! changed May 24, 2001, since smoothing should not be needed
      nsmooth=0
c      checkerboard = .true.
c      checkerboard = .false.
      geomsp=.5              ! .5 for Lg, 1.for Sn and Pn
      rearth=6371.
      total_nstat=0
      nstatobs=0
      do i=1,max_trace
        n_lgmax(i)=0
        gv_lgmax(i)=0.
        statnobs(i)=0
        statcode(i)=' '
      enddo
      event_id=0

      do j=1,100
        npath(j)=0
      enddo
      d_max=10.
      sec_max=10.
      write1=0
c      verbose=.false.
c      verbose=.true.

      do i=1,max_grid
        do j=1,max_grid
          grid_len(i,j)=0.
        enddo
      enddo
      do i=1,max_grid**2
        grid_xy(i,1)=0.
        grid_xy(i,2)=0.
      enddo
        
c
c set polygon, which can be used to use travel paths only inside or outside
c
      npol=0
c      npol=4
c      pol(1,2)=21.
c      pol(1,1)=-106.
c      pol(2,2)=14.
c      pol(2,1)=-90.
c      pol(3,2)=10.
c      pol(3,1)=-90.
c      pol(4,2)=16.5
c      pol(4,1)=-106.

c
c read list of selected stations
c
      do j=1,max_stat
        sel_stat_list(j,1)='     '
        sel_stat_list(j,2)='     '
      enddo
      sel_stat_flag=.false.
      inquire(file='qlg.stat',exist=sel_stat_flag)
      if (sel_stat_flag) then
        open(2,file='qlg.stat',status='old')
        sel_stat_n=0
5       continue
        read(2,'(a)',end=6) line
c not sure where this format comes from
        if (line(1:1).ne.'#'.and.line(16:16).eq.'1'.and.     
     &      line.ne.'') then
          sel_stat_n=sel_stat_n+1 
          sel_stat_list(sel_stat_n,1)=line(1:5)
          sel_stat_list(sel_stat_n,2)=line(11:14)
        endif
        goto 5
6       continue

        close(2)
      endif


c
c open output files
c
      open(2,file='psxy.inp',status='unknown')
      open(50,file='past.inp',status='unknown')
      open(51,file='paths_1.inp',status='unknown')
      open(52,file='paths_2.inp',status='unknown')
      open(53,file='paths_3.inp',status='unknown')
      open(54,file='paths_4.inp',status='unknown')
      open(55,file='paths_5.inp',status='unknown')
      open(56,file='paths_6.inp',status='unknown')
      open(57,file='paths_7.inp',status='unknown')
      open(58,file='paths_8.inp',status='unknown')
      open(48,file='paths.inp',status='unknown')
      open(67,file='stat_xy.inp',status='unknown')
      open(61,file='stat_1.inp',status='unknown')
      open(62,file='stat_2.inp',status='unknown')
      open(60,file='epi.inp',status='unknown')
      open(73,file='epi_xy.inp',status='unknown')
      open(74,file='res.out',status='unknown')
      open(75,file='dres.out',status='unknown')
      open(76,file='resp.out',status='unknown')
      open(77,file='cb_sm.out',status='unknown')
      open(59,file='lgmax.inp',status='unknown')
      open(15,file='spec.p.inp',status='unknown')
      open(16,file='spec.lg.inp',status='unknown')
      open(17,file='qlg.out',status='unknown')
      open(21,file='dens.out',status='unknown')
      open(22,file='adistr.out',status='unknown')
      open(23,file='qtomo.out',status='unknown')
      open(91,file='distances.out',status='unknown')
      open(92,file='recordings.out',status='unknown')
      open(93,file='path_eff.out',status='unknown')
      open(94,file='site.out',status='unknown')
      open(90,file='statnobs.out',status='unknown')

c
c open input file
c
      write(*,*) ' Nordic Input File '
      read(5,'(a)') s_file 
      open(1,file=s_file,status='old',err=22)
c
c input
c
      write(*,*) '   (i)nversion '
      write(*,*) '   (d)istance plots '
      write(*,*) '                        Choice: '
      read(5,'(a1)') option

      if (option.ne.'i'.and.option.ne.'d') then
        write(*,*) ' wrong choice '
        stop
      endif
      if (option.eq.'i') then
        f_low=0.001
        f_high=100.
      endif

c      write(*,*) ' Filter '
c      read(5,*) f_low,f_high

c      write(*,*) ' Minimum Distance '
c      read(5,*) dist_min

c      write(*,*) ' Maximum Distance '
c      read(5,*) dist_max

c      write(*,*) ' LG velocities '
c      read(5,*) lg_low,lg_high

c      write(*,*) ' PG velocities '
c      read(5,*) p_low,p_high

c      do j=1,nfreq
c        write(*,*) j,' - ',freq_array(j)
c      enddo
      write(*,*) ' Frequency choice '
      read(5,*) fin 
      f_choice=0
      do i=1,nfreq
        if (fin.eq.freq_array(i)) f_choice=i
      enddo
       
c read(5,*) f_choice 

c      write(*,*) ' regional Q (r) or Q for grid (g) ? '
c      read(5,*) grid_flag

c      write(*,*) ' Vertical (v) or horizontal (h) component ? '
c      read(5,*) orientation

c      write(*,*) ' Polygon in, out, both (i,o,b) '
c      read(5,*) polflag    
      polflag='b'

c      write(*,*) ' Use stations with phase picks only (y/n) '
c      read(5,'(a)') ch
c      phase_only_flag=.false.
c      if (ch.eq.'y'.or.ch.eq.'Y') phase_only_flag=.true.

      open(19,file='freq.inp',status='unknown')
      write(19,'(f5.2)') freq_array(f_choice)
      close(19)

c
c apriori alpha, from array
c
      if (tomo_flag) then
        if (nfreq.eq.0) then
          write(*,*) ' frequency not defined in qlg.par '
          stop
        endif
        alpha_apriori = q_1_array(f_choice) 
        if(verbose) write(*,*) ' alpha apriori = ',alpha_apriori
      endif

c
c set grid
c
      if (tomo_flag) then
        do i=1,xgrid_npts
          xgrid(i)= xgrid_start + (i-1) * xgrid_delta
        enddo
        do i=1,ygrid_npts
          ygrid(i)= ygrid_start + (i-1) * ygrid_delta
        enddo
        ngrid=(xgrid_npts-1)*(ygrid_npts-1)

c
c set center of grid cells
c
        b=0
        do i=1,ygrid_npts-1
          do j=1,xgrid_npts-1
            b=b+1
            grid_xy(b,1)=xgrid_start+(j-1)*xgrid_delta+xgrid_delta/2.
            grid_xy(b,2)=ygrid_start+(i-1)*ygrid_delta+ygrid_delta/2.
          enddo
        enddo

c
c compute F matrix
c
        do i=1,xdim
          do j=1,xdim
            f_m(i,j)=0.
          enddo
        enddo
          
        do i=1,ngrid
          sum=0.
          do j=1,ngrid
c
c first compute Vij (stored in f_m) and pj (stored in sum)
            if (i.eq.j) then
              f_m(i,j)=damp_alpha*1.
            else
              x1=grid_xy(i,1)
              y1=grid_xy(i,2)
              x2=grid_xy(j,1)
              y2=grid_xy(j,2)
              call delaz(y1*pi/180.,x1*pi/180.,yy,dedeg,az0,
     &             y2*pi/180.,x2*pi/180.)
c              f_m(i,j)=-damp_alpha*exp(-(yy**2)/(2.*(damp_sigma**2)))
c compute Vij
              f_m(i,j)=exp(-(yy**2)/(2.*(damp_sigma**2)))
c compute pj
              sum=sum+f_m(i,j)
            endif
          enddo
c
c now compute f_m
          do j=1,ngrid
            if (i.ne.j) then
              if (sum.ne.0.) then
c                 f_m(i,j)=100.*f_m(i,j)/abs(sum)
                 f_m(i,j)=-damp_alpha*f_m(i,j)/abs(sum)
              else
c
c check if this should be '0'
c
                 f_m(i,j)=0.
              endif
            endif
          enddo
        enddo  

c
c init matrices
c
        do i=1,xdim
          do j=1,xdim
            q_m(i,j)=0.
          enddo
        enddo
        do i=1,ydim
          do j=1,ydim
            c_m(i,j)=0.
          enddo
          c_m(i,i)=1.
        enddo
        do i=1,ydim
          do j=1,xdim
            m_1(i,j)=0.
          enddo
        enddo
        do i=1,xdim
          do j=1,xdim
            h_m(i,j)=0.
            m_2(i,j)=0.
c            m_2t(i,j)=0.
c            m_2s(i,j)=0.
            cvm(i,j)=0.
            r_m(i,j)=0.
c            rd_m(i,j)=0.
          enddo
        enddo
        do i=1,xdim
          do j=1,ydim
            m_3(i,j)=0.
          enddo
        enddo

      else
        ngrid=1
      endif

c
c write out input parameters
c
      write(17,*) 
      write(17,'(a)') ' LG1 RESULT OUTPUT '
      write(17,*) 
      if (option.eq.'d') write(17,'(a)') ' NO INVERSION !!! '
      if (tomo_flag) then
        write(17,'(a)') ' method: Q tomography '
      else
        write(17,'(a)') ' method: SVD '
      endif
      write(17,*) 
      write(17,*) ' filters ',f_low,f_high
      write(17,*) ' distances ',dist_min,dist_max
      write(17,*) ' lg vel ',lg_low,lg_high
      write(17,*) ' p vel ',p_low,p_high
      write(17,*) ' comp ',orientation
      write(17,*) ' picked stations only ',ch
      if (checkerboard) 
     &      write(17,*) ' checker-board test '
      write(17,*) 
      write(17,*) ' reading sfiles... '
      write(17,*) 
  
      goto 23

22    continue

      write(*,*) ' file not found'
      stop

23    continue

      nstat=0
      station_counter = 0      
c
c read Seisan Nordic parameter file
c
      call get_seisan_def
      call indata(1,nstat,nphase,nhead,nrecord,type,expl,data,id)
      nphase=nrecord-1-nhead

      traces_per_event = 0

c
c go out if end of file or empty file
c
      if (nrecord.eq.0.and.option.eq.'i') goto 900
      if (nrecord.eq.0.and.option.eq.'d') goto 999

      event_id=event_id+1
c      write(17,'(a,i4,1x,a)') ' sfile: ',event_id,
c     &      infile(1:seiclen(infile))

      write(99,*) ' event_id ',event_id
      if(verbose) write(*,'(i3,a60)') event_id,data(1)(1:60)

c
c open output file
c
      if (option.eq.'d') then
        outfile = ' '
        write(outfile,'(a8,i3,1x,f6.3)') 
     &  'lg_dist.',event_id,freq_array(f_choice)
        do i=1,16
           if (outfile(i:i).eq.' ') outfile(i:i)='_'
        enddo
        open(18,file=outfile,status='unknown')
      endif

      if (event_id.gt.max_event) then
        write(*,*) ' Too many events '
        stop
      endif
      event_line(event_id)=data(1)

c
c read parameter data
c
      epiline = ' '
   
      read(data(1),'(1x,i4,1x,i2,i2,1x,i2,i2,1x,f4.1)')
     &  year,month,day,hour,min,sec

      read(data(1)(24:43),'(f7.3,f8.3,f5.1)') lat,lon,dep

      write(epiline,'(a)') 'sfile: '//s_file(1:seiclen(s_file))
      write(60,'(f7.3,1x,f8.3,1x,a8,1x,a80)')
     &     80.,dist_min+80.,'8 0 11 5 ',epiline
      write(epiline,'("origin time: ",i4,"/",i2,"/",i2,
     &                1x,i4,":",i2)') year,month,day,
     &                hour,min
      write(60,'(f7.3,1x,f8.3,1x,a8,1x,a80)')
     &     80.,dist_min+60.,'8 0 11 5 ',epiline

      write(epiline,'("latitude/longitude: ",f7.3,"/",f8.3)')
     *     lat,lon
      write(60,'(f7.3,1x,f8.3,1x,a8,1x,a80)')
     &     80.,dist_min+40.,'8 0 11 5 ',epiline

      write(epiline,'("depth/magnitude: ",f5.1,"/",a3)')
     *     dep,data(1)(57:59)
      if (data(1)(57:59).eq.'   '.and.fix_source) then
        write(*,*) ' you need magnitude if source fixed '
        stop
      endif
      read(data(1)(57:59),'(f3.1)') magnitude
      write(60,'(f7.3,1x,f8.3,1x,a8,1x,a80)')
     &     80.,dist_min+20.,'8 0 11 5 ',epiline

      call polos(lat,lon,pol,npol,inev) ! check if event in polygon
      lon_rad =lon*pi/180.
      lat_rad =lat*pi/180.
      call timsec(year,month,day,hour,min,sec,msec)
c
c init wav_* variables
c
      call wav_init
      b=0
c
c read all headers
c
      do a=1,nhead
        if (data(a)(80:80).eq.'6') then

          b=b+1
          infile = ' '
          infile=data(a)(2:79)
          if (verbose)
     &      write(*,*) ' Waveform file: ',infile(1:seiclen(infile))

          call get_full_wav_name(infile(1:seiclen(infile)),
     &           wav_filename(b))
          
c
c   now read first header for one event
c
          call read_wav_header(b)
c          write(17,*) '       waveform file: ' // wav_filename(b)
c     &          (1:seiclen(wav_filename(b)))
          if(wav_error_message.ne.' ') then
             write(6,'(1x,a)') wav_error_message
c             goto 25
          endif
        endif
      enddo

  
c
c first loop over all traces
c
      do i=1,wav_nchan
c
c find distance
c
            flag(i)=.true.
            call stat_loc(wav_stat(i),' ',slat,slon,selev)
            if (slat.eq.0..and.slon.eq.0.) flag(i)=.false. 
c
c vertical
c
            if (wav_comp(i)(1:4).ne.'HH Z'.and.
     &          wav_comp(i)(1:4).ne.'S  Z'.and.
     &          wav_comp(i)(4:4).ne.'Z'.and.
     &          wav_comp(i)(1:4).ne.'B  Z'.and.
     &          wav_comp(i)(1:4).ne.'BH Z') flag(i)=.false.   


            call polos(slat,slon,pol,npol,inst)
c
c check that not uncertain time
c
            if (wav_time_error(i).ne.' ') flag(i)=.false.

c
c check if station wanted
c
            if (sel_stat_flag) then
                tflag=.false.
                do j=1,sel_stat_n
                  if (sel_stat_list(j,1).eq.wav_stat(i).and.
     &                (sel_stat_list(j,2).eq.wav_comp(i).or.
     &                 seiclen(sel_stat_list(j,2)).le.0)) then
                     tflag=.true.
c                    write(*,*) ' found on list: ',wav_stat(i),
c     &                   wav_comp(i)
                  endif
                enddo
                if (.not.tflag) flag(i)=.false.
            endif
c
c if phases given, check that station is selected
c
            if (phase_only_flag.and.flag(i).eqv..true.) then
                if (nphase.ne.0) then
                  tflag=.false.
                  do k=nhead+1,nhead+nphase
c                      if (data(k)(2:5).eq.wav_stat(i)) 
                      if (data(k)(2:5).eq.wav_stat(i).and.
     &                    data(k)(15:15).ne.'9') ! check for uncertain time
     &                   tflag=.true.
                  enddo
                  if (.not.tflag) flag(i)=.false.
                endif
            endif

c
c check if response
c
            if (flag(i)) then
              wav_resp_file = ' '
              wav_current_chan(1)=i
              call read_resp
              if(wav_resp_status(1:1).eq.'9') then
                if (verbose)
     &            write(*,*)' no response: ',wav_stat(i),' ',wav_comp(i)
                write(76,*)' No response file for: ',
     &              wav_stat(i),' ',wav_comp(i)
                flag(i)=.false.
              endif
              if(wav_resp_status(1:1).eq.'8') then
                if (verbose)
     &           write(*,*)' response from header: ',
     &             wav_stat(i),' ',wav_comp(i)
                write(76,*)' response from header: ',
     &              wav_stat(i),' ',wav_comp(i)
              endif
c
c get rid of channels with low low-pass
c
              do j=1,nfilt
                if (ffilt(j).lt.10.and.pole(j).gt.1) then
c                  flag(i)=.false.
                  write(751,*) wav_stat(i),ffilt(j),pole(j)
                endif
              enddo
            endif
              
c
c take out stations
c

           if (wav_stat(i)(1:4).eq.'TEIG') flag(i)=.false.

c
c check if path within polygon
c
            if (polflag.eq.'i'.and.flag(i)) then
              if (.not.inev.or..not.inst) then
                flag(i)=.false.
                write(*,*) ' path outside ',wav_stat(i)
              endif
            elseif (polflag.eq.'o'.and.flag(i)) then
              if (inev.and.inst) then
                flag(i)=.false.
                write(*,*) ' path outside ',wav_stat(i)
              endif
            endif

c
c check if station already done
c
            new=.true.
            do j=1,nstat
              if (wav_stat(i).eq.stat(j)) new=.false.
            enddo
            if (new.and.flag(i)) then
              nstat=nstat+1
              stat(nstat)=wav_stat(i)
            else
              flag(i)=.false.
            endif

            if (flag(i)) then
              slat_rad=slat*pi/180.
              slon_rad=slon*pi/180.
              call delaz(slat_rad,slon_rad,dist(i),dedeg,az0,
     &            lat_rad,lon_rad)
    
              if (dist(i).lt.dist_min) then
                 flag(i)=.false.
                 if (verbose)
     &            write(*,*) ' distance too short, ',wav_stat(i),dist(i)
              endif
              if (dist(i).gt.dist_max) then
                 if (verbose)
     &            write(*,*) ' distance too large, ',wav_stat(i),dist(i)
                 flag(i)=.false.
              endif
c
c check if trace goes beyond 2.9 km/s group velocity
c
              rsec=wav_abs_time(i)-msec    ! msec is OT
              gv=dist(i)/(rsec+wav_nsamp(i)/wav_rate(i))
c              if (gv.gt.2.9) then
              if (gv.gt.lg_low) then
                flag(i)=.false.
                if (verbose)
     &            write(*,*) wav_stat(i),' time window too short ! '
              endif

c
c check if path within grid
c
              if (ngrid.ne.1) then
                if (lon.ge.xgrid(1).and.
     &              lon.le.xgrid(xgrid_npts).and.
     &              lat.ge.ygrid(1).and.
     &              lat.le.ygrid(ygrid_npts).and.
     &              slon.ge.xgrid(1).and.
     &              slon.le.xgrid(xgrid_npts).and.
     &              slat.ge.ygrid(1).and.
     &              slat.le.ygrid(ygrid_npts)) then

                else
                  flag(i)=.false. 
                  if (verbose)
     &            write(*,*) ' Path outside grid: ',wav_stat(i)
                endif
              endif

c
c get max distance
c
              if (dist(i).gt.d_max.and.flag(i)) then
                d_max = dist(i)
              endif
c
c write out station code for use with pstext
c
              if (flag(i)) then
                write(62,'(f7.3,1x,f8.3,1x,i3,1x,a5,1x,a10)') 
     &              10.,dist(i),6,'0 8 5',wav_stat(i)// ' '//
     &              wav_comp(i)
              endif
            endif
      enddo  ! end of first loop over all traces

c
c check how many stations are flaged
c
      nstat=0
      do i=1,wav_nchan
          if (flag(i)) nstat=nstat+1
      enddo

c
c check if enough stations
c
      if (nstat.lt.min_stat.and.option.eq.'i') then
            if (verbose) write(*,*) ' Too few stations '    
            event_id = event_id -1
            if (option.eq.'d') then
              close(18)
            endif
            goto 23
      endif

c
c sety_scale, signal=signal/max*y_scale
c
      y_scale=d_max/wav_nchan
c      y_scale=d_max/15.   !  xxx remember to change back

c
c second loop over traces
c
      do i=1,wav_nchan
        if (flag(i)) then

c
c add new stations to array of all stations, and set ind
c
              new=.true.
              ind=0
              do j=1,total_nstat
                if (wav_stat(i).eq.total_stat(j)) then
                  new=.false.
                  ind=j
                endif
              enddo
              if (new) then
                total_nstat=total_nstat+1
                nstatobs=nstatobs+1
                total_stat(total_nstat)=wav_stat(i)
                ind=total_nstat
c
c write out new stations
c
                call stat_loc(wav_stat(i),' ',slat,slon,selev)
                write(67,'(f8.3,1x,f8.3)') slat,slon
                write(61,'(f7.3,1x,f8.3,1x,a,1x,a)') 
     &                  slat,slon,'10 0 1 7',wav_stat(i)
              endif
              if(total_nstat.gt.max_stat) then
                if (verbose) write(*,*) ' Too many stations '
                stop
              endif
        endif
      enddo ! end of second loop over all traces


c
c third loop over traces
c
      do i=1,wav_nchan
        if (flag(i)) then
c
c set station index
c
              do j=1,total_nstat
                if (wav_stat(i).eq.total_stat(j)) then
                  ind=j
                endif
              enddo

c
c get time since event origin
c
              rsec=wav_abs_time(i)-msec
              if (orientation.eq.'h') then
c
c read 3 components
c
                call wav_read_3channel(i)
              else
c
c read vertical component only
c
                if (verbose) write(*,*) wav_stat(i),wav_comp(i)
                call wav_read_channel(i)
              endif
c
c check if signal clipped
c
              call check_clipped(signal1,wav_nsamp(i),clipped)
              if (clipped) then
                 flag(i)=.false.
                 if (verbose)
     &           write(*,'(a)') ' channel clipped: ' // 
     &              wav_stat(i) // ' ' // wav_comp(i)
                 write(17,'(a)') ' channel clipped: ' // 
     &              wav_stat(i) // ' ' // wav_comp(i)
                 goto 24
              endif

c
c read response, will be removed when spectrum is calculated
c
              wav_resp_file = ' '
              wav_current_chan(1)=i
              call read_resp

c
c get time since event origin
c
              rsec=wav_abs_time(i)-msec

              if (orientation.eq.'h') then
c
c read 3 components
c
                call wav_read_3channel(i)

              else
c
c read vertical component only
c
                call wav_read_channel(i)
 
              endif

c
c read response, will be removed when spectrum is calculated
c
              wav_resp_file = ' '
              wav_current_chan(1)=i
              call read_resp

              if(wav_resp_status(1:1).eq.'9') then
                 flag(i)=.false.
              endif


c
c remove mean
c
              call rmean(signal1,wav_nsamp(i))


c
c extract lg, p and noise windows
c
              nsamp_lg=0
              nsamp_p=0
              nsamp_n=0

              do j=1,wav_nsamp(i)
                x=(rsec+j/wav_rate(i))
                if (dist(i)/x.le.lg_high.and.dist(i)/x.ge.lg_low) then
                  nsamp_lg=nsamp_lg+1
                  signal_lg(nsamp_lg)=signal1(j)
                endif
                if (dist(i)/x.le.p_high.and.dist(i)/x.ge.p_low) then
                  nsamp_p=nsamp_p+1
                  signal_p(nsamp_p)=signal1(j)
                endif
                if (dist(i)/x.le.10.0.and.dist(i)/x.gt.9.) then
                  nsamp_n=nsamp_n+1
                  signal_n(nsamp_n)=signal1(j)
                endif
              enddo

c
c extract horizontal compents if wanted, 2=ns, 3=ew
c
              nsamp_lg_e=0
              nsamp_lg_n=0
              if (orientation.eq.'h')  then
                do j=1,wav_nsamp(wav_current_chan(2))
                  x=(rsec+j/wav_rate(wav_current_chan(2)))
                  if (dist(i)/x.le.lg_high.and.dist(i)/x.ge.lg_low) then
                    nsamp_lg_e=nsamp_lg_e+1
                    signal_lg_e(nsamp_lg_e)=signal2(j)
                  endif
                enddo
                do j=1,wav_nsamp(wav_current_chan(3))
                  x=(rsec+j/wav_rate(wav_current_chan(3)))
                  if (dist(i)/x.le.lg_high.and.dist(i)/x.ge.lg_low) then
                    nsamp_lg_n=nsamp_lg_n+1
                    signal_lg_n(nsamp_lg_n)=signal3(j)
                  endif
                enddo
              endif

c
c write out lg samples to ascii files
c
c              outfile = ' '
c              write(outfile,'(a5,1x,a4,a3)')
c     &          wav_stat(i),wav_comp(i),'.lg'
c              do j=1,13
c                 if (outfile(j:j).eq.' ') outfile(j:j)='_'
c              enddo
c
c              open(101,file=outfile,status='unknown')
c              do j=1,nsamp_lg
c                write(101,'(f15.1)') signal_lg(j)
c              enddo
c              close(101)


c
c get lg spectral levels, it is assumed that response is the
c same as for vertical component
c
              write1=0
              if (option.eq.'d'.and.f_choice.eq.1)
     &        write1=16
              call spec_value(i,signal_lg,nsamp_lg,nsmooth,f_low,
     &    f_high,1,freq_array,nfreq,write1,level_lg,y_com,ipow)
c        write(*,*) ' xxx lg ',level_lg(f_choice)

              if (orientation.eq.'h')  then
                call spec_value(i,signal_lg_n,nsamp_lg_n,nsmooth,f_low,
     &          f_high,1,freq_array,nfreq,0,level_lg_n,y_com,ipow)
                call spec_value(i,signal_lg_e,nsamp_lg_e,nsmooth,f_low,
     &          f_high,1,freq_array,nfreq,0,level_lg_e,y_com,ipow)
c
c get sqrt of square levels
c
                do j=1,nfreq
                  if (level_lg_e(f_choice).gt.0..and.
     &         log10(level_lg_e(f_choice)).lt.30.and.
     &         level_lg_e(f_choice).gt.2.*level_n(f_choice).and.
     &         nsamp_lg_e/wav_rate(wav_current_chan(3)).gt.
     &         2./freq_array(f_choice).and.
     &         level_lg_n(f_choice).gt.0..and.
     &         log10(level_lg_n(f_choice)).lt.30.and.
     &         level_lg_n(f_choice).gt.2.*level_n(f_choice).and.
     &         nsamp_lg_n/wav_rate(wav_current_chan(2)).gt.
     &         2./freq_array(f_choice))
     &            then
                    level_lg(j) = sqrt(level_lg_e(j)**2 +
     &                               level_lg_n(j)**2 ) 
                  else
                    level_lg(j)=0.
                  endif
                enddo
              endif
c
c correct for kappa, this will not affect resulting Q-1, but will be
c seen in change to source term
c
              do j=1,nfreq
c                write(*,*)  ' before ',j,level_lg(j),freq_array(j),
c     &   level_lg(j)*exp(pi*qlgkappa*freq_array(j))/level_lg(j)
                level_lg(j)=level_lg(j)*exp(pi*qlgkappa*freq_array(j))
c                write(*,*)  ' after ',j,level_lg(j)
              enddo
c
c get noise spectral levels
c
              call spec_value(i,signal_n,nsamp_n,nsmooth,f_low,
     &    f_high,1,freq_array,nfreq,0,level_n,y_com,ipow)
c        write(*,*) ' xxx n ',level_n(f_choice)

c
c get p spectral levels
c
              if (option.eq.'d'.and.f_choice.eq.1) write1=15
                call spec_value(i,signal_p,nsamp_p,nsmooth,f_low,
     &    f_high,1,freq_array,nfreq,write1,level_p,y_com,ipow)
c
c correct for kappa
c
              do j=1,nfreq
                level_p(j)=level_p(j)*exp(pi*qlgkappa*freq_array(j))
              enddo

c        write(*,*) ' xxx p ',level_p(f_choice)

c
c write out Moment corrected for G but not for Q
c
              moment = 
     &          4.*pi*dens*(svel**3)*1.E-9*level_lg(f_choice) /
     &          (.55*2.*(1./sqrt(2.))) *
     &          sqrt(100.*1.E6*dist(i))
              if (option.eq.'d') then 
                if (moment.gt.0.) 
     &          write(18,'(f6.1,1x,f6.3)') dist(i),log10(moment)
              endif

c
c check if signal is ok
c
              good_signal = .false.
              if (level_lg(f_choice).gt.0..and.
     &          log10(level_lg(f_choice)).lt.30.and.
     &          level_lg(f_choice).gt.2.*level_n(f_choice).and.
     &          nsamp_lg/wav_rate(i).gt.2./freq_array(f_choice)) 
     &        then
                good_signal = .true.
              else
                if(verbose) write(*,*) ' bad signal !!! '
              endif

c
c set data vector and kernel matrix
c
              if (good_signal) then
c
c count observations per station
c
              statnobs(ind)=statnobs(ind)+1
              if (statcode(ind).eq.' ') statcode(ind)=wav_stat(i)

c
c get station coords
c
                call stat_loc(wav_stat(i),' ',slat,slon,selev)
                if(verbose) write(*,*)
                if (verbose)
     &          write(*,*) i,' ',wav_stat(i),' ',wav_comp(i),dist(i),
     &              slat,slon,lat,lon

c
c stop if too many paths
c
                if (d_index.ge.ydim) then
                  write(*,*) ' too many paths: ',d_index
                  stop
                endif
                d_index=d_index+1

c
c write out some statistics
c
                traces_per_event=traces_per_event+1
                write(91,'(f10.2)') dist(i)
 
                station_counter = station_counter + 1
 
                if (ngrid.eq.1) then
c                if (ngrid.eq.-1) then
c
c assume geometrical spreading as 1/R  for r < R0
c                       and       1/sqrt(100.*R) for r> R0
c
                  if (dist(i).le.100.) then
                    d(d_index)=log10(1.E-9*level_lg(f_choice))+
     &                      1.*log10(1000.*dist(i))
                  else
                    d(d_index)=log10(1.E-9*level_lg(f_choice))+
     &                      geomsp*log10(100.*1.E6*dist(i))
                  endif

c
c compute moment from spectral level, corrected for G and Q
c
          moment=4.*pi*dens*(svel**3)*1.E-9*level_lg(f_choice) /
     &          (.55*2.*(1./sqrt(2.))) *
     &          sqrt(100.*1.E6*dist(i)) *
     &          exp(pi*1000.*dist(i)*freq_array(f_choice)
     &          /(lg_vel*276.*freq_array(f_choice)**.66))

           if(verbose) write(*,*) ' Moment: ',moment

              if(verbose) write(*,*) event_id,dist(i),
     &               log10(level_lg(f_choice)),
     &               ' d(',d_index,') = ',d(d_index)


c
c set G for event (event_id) and station (ind)
c
                  g(d_index,1)=-pi*1000.*dist(i)*freq_array(f_choice)
     &                *log10(exp(1.))/lg_vel

                else
c
c get length of segments in grid cells
c
c                  call grid_seg(lat,lon,slat,slon,xgrid,ygrid,
c     &              max_grid,xgrid_npts,ygrid_npts,seg_length,
c     &              grid_len,dist_min,igrid)
                  call grid_seg(lat,lon,slat,slon,xgrid,ygrid,
     &              seg_length,grid_len,dist_min,igrid)

      
                  x = 0.
                  do j=1,ngrid
                    x=x+seg_length(j)
        if ((j.eq.78.or.j.eq.79).and.seg_length(j).gt.1.) 
     &      write(700,*)  ! xxx 
     &       wav_year(i),
     &             wav_month(i),wav_day(i),wav_hour(i),wav_min(i)
                  enddo
 
                  if (abs(x-dist(i)).gt.0.05*dist(i)) then
                    if (verbose)
     &                write(*,*) ' something wrong with path ... ',
     &                    x,dist(i)
                  endif
   
c
c add term from q apriori to data vector, invert for delta Q-1
c
                  if (dist(i).le.100.) then
                    d(d_index)=log10(1.E-9*level_lg(f_choice))+
     &                      1.*log10(1000.*dist(i)) +
     &                      pi*1000.*dist(i)*log10(exp(1.))*
     &                      freq_array(f_choice)*alpha_apriori/
     &                      lg_vel
                  else
                    d(d_index)=log10(1.E-9*level_lg(f_choice))+
     &                      geomsp*log10(100.*1.E6*dist(i)) +
     &                      pi*1000.*dist(i)*log10(exp(1.))*
     &                      freq_array(f_choice)*alpha_apriori/
     &                      lg_vel
                  endif

c
c set checkerboard values in case of cb test
c
                  j=0
                  if (checkerboard) then
                    d(d_index)=0.
                    do a=1,ygrid_npts-1
                      do b=1,xgrid_npts-1
                        j=j+1
                        if (float(int((a+b)/2.)).eq.(a+b)/2.) then
            write(101,*) a,' ',b,' + '
                          d(d_index)= d(d_index) -
     &                       pi*freq_array(f_choice)*log10(exp(1.))
     &                      *cbdelta*1000.*seg_length(j)/lg_vel
                        else
            write(101,*) a,' ',b,' - '
                           d(d_index)= d(d_index) +
     &                       pi*freq_array(f_choice)*log10(exp(1.))
     &                      *cbdelta*1000.*seg_length(j)/lg_vel
                        endif
                      enddo
                    enddo
                    if (source_perturb(event_id,1).eq.1.) then
c
c add source perturbation, see BSSA 96, 1131-1139, Menke(2006)
c
                      write(33,*) ' # ',event_id
                      write(33,*) ' before perturbation ',d(d_index)
c
c add differene to data due to magnitude perturbation:
c log moment ~ 3/2 MW, d() is in log units so change to magnitude
c is added times 3/2
c
              d(d_index)= d(d_index)+3./2.*source_perturb(event_id,2)

                      write(33,*) ' after perturbation  ',d(d_index)
                    endif
                  endif

c
c add gaussian noise, gasdev gives randum number between -1 and +1,
c gaussian noise gives noise to add in units of moment magnitude,
c log moment ~ 3/2 MW 
c
                  if (gaussian_noise.ne.0.) then
           write(88,*) ' event, station ',event_id,' ',wav_stat(i),' ',
     &        magnitude
           write(88,*) ' before noise ',d(d_index)
                      d(d_index)=d(d_index)+
     &                    gasdev(idum)*3./2.*gaussian_noise
           write(88,*) ' after noise ',d(d_index)
                  endif

                  do j=1,ngrid
                    g(d_index,j)=-pi*1000.*seg_length(j)
     &                   *freq_array(f_choice)
     &                   *log10(exp(1.))/lg_vel
                  enddo
                endif
c
c set source and site in G matrix for both regional and tomographic inversion
c
                if (ngrid+max_stat+event_id.gt.xdim) then
                  write(*,*) ' Too many sites/stations/cells !!! '
                  stop
                endif
                if (.not.checkerboard) then
                  if (.not.fix_site) then
                    g(d_index,ngrid+ind)=1.                  ! site term
                  endif
                  if (.not.fix_source) then
                    g(d_index,ngrid+max_stat+event_id)=1.    ! source term
                  else
c
c in checkerboard test do not invert for site term
c add equation to fix source, only once
c
                    if (.not.event_id_fix(event_id)) then
                      d_index=d_index+1
                      g(d_index,ngrid+max_stat+event_id)=1.    ! source term
c
c set data to expected model parameter
c
c           mmag=2./3.*log10(moment)-6.06
c           moment=4.*pi*dens*(svel**3)*(10**m(ngrid+total_nstat+i))
c     &        / (.55*2.*(1./sqrt(2.)))

                      d(d_index)=(magnitude+6.06)*3./2.
     &       -log10(4.*pi*dens*(svel**3))+log10(.55*2.*(1./sqrt(2.)))

                      event_id_fix(event_id)=.true. 
        write(*,*) ' fixed source, magnitude=',magnitude,d(d_index)
                    endif
                  endif
                endif
              endif

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c
c finished setting d and G, now prepare output for plots
c

c
c make sure that p level is above the noise, and p level gt 0.
c
              if (good_signal)
     &         lg_p_ratio(i)=level_lg(f_choice)/level_p(f_choice)

              if (good_signal.and.lg_p_ratio(i).lt.9999999.) then 

c
c set output unit
c

c
c ratio is for lg/pn
c
c                path_unit=int(lg_p_ratio(i)/2.)+51
                path_unit=int(lg_p_ratio(i)/3.)+51


                npath(int(lg_p_ratio(i))+1)=
     &              npath(int(lg_p_ratio(i))+1)+1
              else
                if (level_p(f_choice).lt.2.*level_n(f_choice)) then
                  if (verbose)
     &             write(*,*) ' p below noise level: ',
     &             level_p(f_choice),level_n(f_choice),wav_year(i),
     &             wav_month(i),wav_day(i),wav_hour(i),wav_min(i)
                endif
                path_unit=47
                lg_p_ratio(i)=0.
              endif
c              if (path_unit.gt.58) path_unit=58
              if (path_unit.gt.53) path_unit=53
              if (path_unit.le.0) path_unit=47

              if (lg_p_ratio(i).gt.0..and.good_signal) then
                if (verbose) 
     &          write(*,*) ' lg-p ratio: ',lg_p_ratio(i)
              endif

c
c write out paths
c
c               write(*,*) path_unit
                write(48,'(f7.3,1x,f8.3)') 
     *           lat,lon
                write(48,'(f7.3,1x,f8.3)') 
     *           slat,slon
                write(48,'(a1)') '>'

                write(path_unit,'(f7.3,1x,f8.3)') 
     *           lat,lon
                write(path_unit,'(f7.3,1x,f8.3)') 
     *           slat,slon
                write(path_unit,'(a1)') '>'
c
c write out path and efficency
c
                if (lg_p_ratio(i).gt.0..and.good_signal) then
                  write(93,'(f7.3,1x,f8.3,1x,f7.3,1x,f8.3,1x,f10.2)') 
     *              lat,lon,slat,slon,lg_p_ratio(i)
                endif
c
c seismogram distance plots
c
                if (option.eq.'d') then
c
c filter data
c

c-- calc. filt. cof.
                  call bndpas(f_low,f_high,1000.0/wav_rate(i),
     *              cof,gain)
c-- and filter
                  call filter(signal1,wav_nsamp(i),cof,gain,npasses)

c
c find max
c
                  max=0.
                  do j=1,wav_nsamp(i)
                    if (abs(signal1(j)).gt.max) max=abs(signal1(j))
                  enddo

                  lg_max=0.
                  lg_mean=0.
                  p_mean=0.
                  lg_nsamp=0
                  p_nsamp=0
                  lg_gv=0.

                  do j=1,wav_nsamp(i)

                    x=(rsec+j/wav_rate(i))
                    yy=signal1(j)/max*y_scale+dist(i)

c
c check for LG max
c
                    if (dist(i)/x.le.3.8.and.dist(i)/x.ge.2.5) then
                      if (abs(signal1(j)).gt.lg_max) then
                        lg_max=abs(signal1(j))
                        lg_gv=dist(i)/x
                      endif
                    endif

c
c write data, only if group velocity more than 2.5
c
                    if (dist(i)/x.gt.2.5) then
c                    if (x.lt.500.) then   ! xxx remember to change back
                      if (x.gt.sec_max) sec_max=x
                        if (yy.lt.1E20) then
                          write(2,'(f10.4,1x,f15.4)') x,yy
                        endif
                    endif
                  enddo

                  if (lg_gv.gt.0.) then
                    gv_lgmax(ind)=gv_lgmax(ind)+lg_gv
                    n_lgmax(ind)=n_lgmax(ind)+1
                  endif
c
c next trace
c
                  write(2,'(a1)') '>'
                endif
        endif

24      continue

      enddo   ! end of 3rd loop over all traces

      write(92,*) traces_per_event

c
c write out ratios
c
      if (option.eq.'d') then
            do i=1,wav_nchan
              if (flag(i)) then
                if (lg_p_ratio(i).gt.0.) then
                  write(62,'(f7.3,1x,f8.3,1x,i3,1x,a5,1x,f7.1)') 
     &              sec_max-25,dist(i),6,'0 1 5',lg_p_ratio(i)
                endif
              endif
            enddo
      endif
25    continue

c      enddo      ! end of reading waveform files

c
c make sure that event really has more than min_stat useful recordings
c
          
      if (station_counter.lt.min_stat) then
         event_id=event_id - 1       ! dont use event
         d_index=d_index - station_counter
         do b=d_index+1,d_index+station_counter
           d(b)=0.
           do j=1,xdim
             g(b,j)=0.
           enddo
         enddo
      endif
c
c needed by qlg.exp, to get the max distance
c

      write(*,*) ' maxdist ',d_max,' max_sec ',sec_max,' #'

      if (option.eq.'d') close(18)
      write(73,*) lat,lon
      goto 23

900   continue
c
c take out site terms if sites fixed
c
      if (fix_site) total_nstat=0

c
c add constraint that sum over log(site) = 1
c
      if (.not.checkerboard) then
        d_index=d_index+1
        d(d_index)=0.
        do i=1,total_nstat
          g(d_index,i+ngrid)=1.
        enddo
      endif

c
c for certain stations remove site term
c
      swap_with = total_nstat
      do b=1,total_nstat
         if (total_stat(b).eq.'TEIG') then
c     &       total_stat(b).eq.'LPIG'.or.
c     &       total_stat(b).eq.'ZAIG') then    

           write(*,*) ' removing site term for station ',total_stat(b) 
           do i=1,d_index
             g(i,ngrid+b)=g(i,ngrid+swap_with)
           enddo 
           total_stat(b)=total_stat(swap_with)
           swap_with=swap_with-1
         endif
      enddo
      total_nstat=swap_with
     
c
c remove empty columns for not defined sites
c
      do i=1,d_index
        do j=ngrid+total_nstat+1,ngrid+total_nstat+event_id
          g(i,j)=g(i,j+max_stat-total_nstat)
        enddo
      enddo
        
c
c now invert the data d = G * m
c
       if (ngrid.eq.1) then               ! regional Q
c
c call SVD
c
         mp=d_index
         if (.not.fix_site) then
           np=ngrid+total_nstat+event_id
         else
           np=ngrid+event_id
         endif

         write(*,*) ' calling svdcmp ... ',mp,np
         call svdcmpx(g,mp,np,ydim,xdim,w,v)

c
c edit w, remove small values
c
         wmax=0.
         do j=1,xdim
           if(w(j).gt.wmax)wmax=w(j)
         enddo
         thresh=tol*wmax
         do j=1,xdim
           if (w(j).lt.thresh)w(j)=0.
         enddo

c
c call svbksb
c
         write(*,*) ' calling svbksb ... '
         call svbksbx(g,w,v,mp,np,ydim,xdim,d,m)

c
c call svdvar to get variance
c
         write(*,*) ' calling svdvar ... '
         call svdvar(v,np,xdim,w,cvm,xdim)


c
c Q tomography
c
       else

         write(*,*) ' starting Q tomography ... '

c
c get H matrix
c
         call get_h(grid_len,xgrid_npts-1,ygrid_npts-1,
     &             max_grid,h_m,xdim)

c
c write out H matrix and checkerboard synth model
c
         b=0
         do i=1,ygrid_npts-1
           do j=1,xgrid_npts-1
             b=b+1
c             write(21,*) grid_xy(b,1),grid_xy(b,2),h_m(b,b)
             if (checkerboard) then
               if (float(int((i+j)/2.)).eq.(i+j)/2.) then
                 write(77,*) grid_xy(b,1),grid_xy(b,2),
     &             q_1_array(f_choice) + cbdelta
               else
                 write(77,*) grid_xy(b,1),grid_xy(b,2),
     &             q_1_array(f_choice) - cbdelta
               endif
             endif
           enddo
         enddo

c
c compute Q matrix, F-T*F + H-T * H
c
         do i=1,ngrid
           q_m(i,i)=h_m(i,i)**2
         enddo
         do i=1,ngrid
           do j=1,ngrid
             sum=0.
             do b=1,ngrid 
               sum=sum+f_m(b,i)*f_m(b,j)
             enddo
             q_m(i,j)=q_m(i,j)+sum
           enddo
         enddo
       
         mp=d_index
         if (.not.checkerboard) then
           np=ngrid+total_nstat+event_id
         else
           np=ngrid
         endif

c
c C-1 * G, which is G, since we assume C as I
c
         do i=1,mp
           do j=1,np
             m_1(i,j)=0.
             do b=1,mp
               m_1(i,j)=m_1(i,j) + c_m(i,b) * g(b,j)
             enddo
           enddo
         enddo

c
c G-T * m_1
c
         do i=1,np
           do j=1,np
             m_2(i,j)=0.
             do b=1,mp
               m_2(i,j)=m_2(i,j) + g(b,i) * m_1(b,j)
             enddo
           enddo
         enddo
c
c now add Q
c
         do i=1,np
           do j=1,np
             m_2(i,j)=m_2(i,j)+q_m(i,j)
c             m_2s(i,j)=m_2(i,j)    ! just to save m_2
             h_m(i,j)=m_2(i,j)    ! just to save m_2
           enddo
         enddo

c
c invert m_2, y_m is the inverted matrix
c
         do i=1,np
           do j=1,np
             y_m(i,j)=0.
           enddo
           y_m(i,i)=1. 
         enddo
         call ludcmpx(m_2,np,xdim,indx,dd)
         do j=1,np
           call lubksbx(m_2,np,xdim,indx,y_m(1,j))
         enddo
c
c check if m_2 * y_m is I
c
         x=0.
         do i=1,np
           do j=1,np
c             m_2t(i,j)=0.
             r_m(i,j)=0.
             do b=1,np
c               m_2t(i,j)=m_2t(i,j) + y_m(i,b) * m_2s(b,j)
               r_m(i,j)=r_m(i,j) + y_m(i,b) * h_m(b,j)
             enddo
             x=x+r_m(i,j)
           enddo
         enddo
         write(*,*) ' trend of GTG+Q * (GTG+Q)-1 = ',x/np
         write(17,*) ' trend of GTG+Q * (GTG+Q)-1 = ',x/np

         do i=1,xdim
           do j=1,xdim
             r_m(i,j)=0.
           enddo
         enddo
   
c
c y_m * G-T
c
         do i=1,np
           do j=1,mp
             m_3(i,j)=0.
             do b=1,mp
               m_3(i,j)=m_3(i,j) + y_m(i,b) * g(j,b)
             enddo
           enddo
         enddo

c
c covariance matrix cvm = m_3 * m_3-T
c
         do i=1,np
           do j=1,np
             cvm(i,j)=0.
             do b=1,mp
               cvm(i,j)=cvm(i,j) + m_3(i,b)*m_3(j,b)
             enddo
           enddo
         enddo

c
c resolution matrix r_m = m_3 * G
c
         do i=1,np
           do j=1,np
             r_m(i,j)=0.
             do b=1,mp
               r_m(i,j)=r_m(i,j) + m_3(i,b) * g(b,j)
             enddo
           enddo
         enddo
         b=0 

c
c compute rd_m matrix
c
        do i=1,xdim
          do j=1,xdim
            h_m(i,j)=0.
          enddo
        enddo

        do i=1,ngrid
          sum=0.
c          rd_m(i,i)=0.
          h_m(i,i)=0.   ! resolution matrix
          do j=1,ngrid
              x1=grid_xy(i,1)
              y1=grid_xy(i,2)
              x2=grid_xy(j,1)
              y2=grid_xy(j,2)
              call delaz(y1*pi/180.,x1*pi/180.,yy,dedeg,az0,
     &             y2*pi/180.,x2*pi/180.)
c              rd_m(i,i)=rd_m(i,i)+abs(r_m(i,j))*yy
              h_m(i,i)=h_m(i,i)+abs(r_m(i,j))*yy
              sum=sum+abs(r_m(i,j))
c              write(113,*) sum
          enddo
c          rd_m(i,i)=rd_m(i,i)/sum
          h_m(i,i)=h_m(i,i)/sum
        enddo

c
c write out resolution matrices
c
         do i=1,ygrid_npts-1
           do j=1,xgrid_npts-1
             b=b+1  
             write(74,*) grid_xy(b,1),grid_xy(b,2),r_m(b,b)
c             write(75,*) grid_xy(b,1),grid_xy(b,2),rd_m(b,b)
             write(75,*) grid_xy(b,1),grid_xy(b,2),h_m(b,b)
           enddo
         enddo
             

c
c m = m_3 * d
c
         do i=1,np
           m(i)=0.
           do j=1,mp
             m(i)=m(i)+m_3(i,j) * d(j)
           enddo
         enddo


         b=0
         do i=1,ygrid_npts-1
           do j=1,xgrid_npts-1
             b=b+1
             write(22,*) grid_xy(b,1),grid_xy(b,2)
           enddo
         enddo
              
       endif
999   continue

c
c output
c

c
c some statistics
c
        write(17,*) ' Total number of events: ',event_id
        write(17,*) ' Total number of paths : ',mp

         write(*,*) ' result ',freq_array(f_choice),m(1),
     &        sqrt(cvm(1,1)),' #'

         write(17,'(a,f5.2)')
     &     ' freq= ',freq_array(f_choice)

c
c write out the grid coordinates
c
         if (ngrid.ne.1) then
           write(17,*) ' The grid: '
           b=0
           do i=1,ygrid_npts-1
             do j=1,xgrid_npts-1
               b=b+1
               write(17,*) b,grid_xy(b,1),grid_xy(b,2)
             enddo
           enddo
         endif

c
c write out Q
c
         if (ngrid.ne.1) then
           write(17,'(a,g10.2)') ' Q-1 apriori: ',alpha_apriori
         endif
         do i=1,ngrid
           if (ngrid.ne.1) then
             m(i)=m(i)+alpha_apriori
           endif
           write(17,'(i5,a,g10.2,a,g10.2)')
     &       i,' Q-1 = ',m(i),' +/- ',sqrt(cvm(i,i))
           write(23,'(f10.3,1x,f10.3,1x,f8.6)') 
     &       grid_xy(i,1),grid_xy(i,2),m(i)
         enddo

         if (.not.fix_site) then
           write(17,'(a)') ' Site term '
           do i=1,total_nstat
             write(*,'(i3,1x,a5,1x,f6.2)') i,total_stat(i),m(i+ngrid)
             write(17,'(i3,1x,a5,1x,f6.2,1x,f6.2)')
     &           i,total_stat(i),m(ngrid+i),sqrt(cvm(i+ngrid,i+ngrid))
             call stat_loc(total_stat(i),' ',slat,slon,selev)
             write(94,'(f10.3,1x,f10.3,f10.3)') slat,slon,m(ngrid+i)
           enddo
         else
           write(17,'(a)') ' Site term fixed'
         endif
         write(17,'(a)') ' Source term '
         do i=1,event_id
c
c calculate moment in Nm
c
           moment=4.*pi*dens*(svel**3)*(10**m(ngrid+total_nstat+i))
     &        / (.55*2.*(1./sqrt(2.)))

c
c dyne cm
c           moment=4.*pi*dens*svel**3.*100*10.**m(ngrid+total_nstat+i) /
c     &            (.55*2.*(1./sqrt(2.)))

           mmag=2./3.*log10(moment)-6.06
           write(*,'(i3,1x,a60,f6.2)')
     &          i,event_line(i)(1:60),m(ngrid+total_nstat+i)
           write(17,'(i3,1x,a60,f6.2,1x,f6.2,1x,g8.2,1x,f5.2)')
     &          i,event_line(i)(1:60),m(ngrid+total_nstat+i),
     &          sqrt(cvm(ngrid+total_nstat+i,ngrid+total_nstat+i)),
     &          moment,mmag
         enddo


      

c
c write out lg group velocities
c
      lg_max=0.
      do i=1,total_nstat
        write(59,'(a5,1x,f4.2)') total_stat(i),
     &       gv_lgmax(i)/n_lgmax(i)
        lg_max=lg_max+gv_lgmax(i)/n_lgmax(i)
      enddo
      write(59,'(a7,f4.2)') 'total: ',lg_max/total_nstat

      do i=1,100
        write(50,'(i5)') npath(i)
      enddo
c
c write out observations per station
c
c      write(*,*) ' xxx nstatobs ',nstatobs
      do i=1,nstatobs
        write(90,*) statcode(i),statnobs(i)
c        write(*,*) statcode(i),statnobs(i)
      enddo
        
c
c close files
c
      close(1)
      close(2)
      close(15)
      close(16)
      close(17)
      close(20)
      close(21)
      close(22)
      close(23)
      close(91)
      close(92)
      close(50)
      close(51)
      close(52)
      close(53)
      close(54)
      close(55)
      close(56)
      close(48)
      close(61)
      close(62)
      close(67)
      close(73)
      close(74)
      close(75)
      close(76)
      close(77)
      close(60)
      close(59)
      close(93)
      close(94)
      close(90)

      stop
      end



      subroutine rmean(idata,nlen)
c
c simple routine to remove the mean
c
c input/output: idata - real array with nlen samples
c

      implicit none
C    Seisan library inserts and routines...
C    ======================================
C
      include 'libsei.inc'                ! Open file definitions
      include 'seidim.inc'

      real idata(max_sample)              ! data
      integer i                           ! counters
      integer nlen                        ! number of samples
      real dc                             ! average or DC level

c
c get dc
c
      dc=0.
      do i=1,nlen
        dc=dc+idata(i)
      enddo
      dc=dc/nlen

c
c remove dc
c
      do i=1,nlen
        idata(i)=idata(i)-int(dc)
      enddo

      return
      end



      subroutine grid_seg(lat,lon,slat,slon,xgrid,ygrid,
     &             seg_length,grid_len,min_dist,flag)
c
c routine to compute path length in grid cells
c
      implicit none
      include 'seidim.inc'
      include 'qlg.inc'
      integer i,j
      real lat,lon,slat,slon
      real ygrid(*),xgrid(*)
      integer max
c      parameter (max=25)
      parameter (max=50)
c      integer max,xmax,ymax
      real xinter(max,2),yinter(max,2)
      real seg_length(*)
      real grid_len(max,max)
      integer xint,yint
      real b,d1,d2,m,x,y,x1,x2,y1,y2,dist,dedeg,az0,np
      integer flag,ind
      real pi
      parameter (pi=3.141593)
      logical done
      real points(2*max+2,3)
      integer nseg
      real seg(max**2,7)
      real min
      real grid(max,max)
      logical inside
      real min_dist,mind

      flag=1
      xint=0
      yint=0

c
c min_dist in degree, just approximately
c
      mind = min_dist/111.

c
c initialize
c
      do i=1,max**2
        seg_length(i) = 0.
      enddo
      do i=1,2*max+2
        points(i,1)=0.
        points(i,2)=0.
        points(i,3)=0.
      enddo

c 
c get linear equation, y = mx+b
c
      m = (slat-lat)/(slon-lon)
      b = slat - m * slon
c
c get distance between the endpoints 
c
      x1=slon*pi/180.
      x2=lon*pi/180.
      y1=slat*pi/180.
      y2=lat*pi/180.
      call delaz(y1,x1,dist,dedeg,az0,y2,x2)

c
c get x intersections
c
      do i=1,xgrid_npts

        x=xgrid(i)
        y=m*xgrid(i)+b
        call delaz(y*pi/180.,x*pi/180.,d1,dedeg,az0,y1,x1)
        call delaz(y*pi/180.,x*pi/180.,d2,dedeg,az0,y2,x2)
c
c check if distance to both end points smaller than distance between the
c endpoints 
c
        if (d1.lt.dist.and.d2.lt.dist) then
c
c check that not start or endpoint
c
          if (.not.(x.eq.lon.and.y.eq.lat).and.
     &        .not.(x.eq.slon.and.y.eq.slat)) then
            xint=xint+1
            xinter(xint,1)=x
            xinter(xint,2)=y
          endif
        endif
      enddo
c
c get y intersections
c
      do i=1,ygrid_npts

        y=ygrid(i)
        x=(y-b)/m
        call delaz(y*pi/180.,x*pi/180.,d1,dedeg,az0,y1,x1)
        call delaz(y*pi/180.,x*pi/180.,d2,dedeg,az0,y2,x2)
c
c check that not already an x intersect
c
        done=.false.
        do j=1,xint
          if (x.eq.xinter(j,1).and.y.eq.xinter(j,2)) done=.true.
        enddo
c
c check if distance to both end points smaller than distance between the
c endpoints
c
        if (d1.lt.dist.and.d2.lt.dist.and..not.done) then
          if (.not.(x.eq.lon.and.y.eq.lat).and.
     &        .not.(x.eq.slon.and.y.eq.slat)) then
            yint=yint+1
            yinter(yint,1)=x
            yinter(yint,2)=y
          endif
        endif
      enddo

c
c put all points into one array
c
      np=2+xint+yint
      points(1,1)=lon
      points(1,2)=lat
      points(np,1)=slon
      points(np,2)=slat
      do i=1,xint
        points(i+1,1)=xinter(i,1)
        points(i+1,2)=xinter(i,2)
      enddo
      do i=1,yint
        points(i+1+xint,1)=yinter(i,1)
        points(i+1+xint,2)=yinter(i,2)
      enddo
     
c      do i=1,np
c        write(*,*) i,points(i,1),points(i,2)
c      enddo

c
c find segments starting mind from epicenter
c
      nseg=0
      x1=points(1,1)
      y1=points(1,2)
c      call delaz(y1*pi/180.,x1*pi/180.,d1,dedeg,az0,
c     &             points(1,2)*pi/180.,points(1,1)*pi/180.)
c      write(*,*) points(1,1),points(1,2),x,y,x1,y1,d1
      points(1,3)=1.
      d2=0.

150   continue
      min=99999.
c
c search for minimum path length between points
c
      do i=1,np
        x2=points(i,1)
        y2=points(i,2)
        call delaz(y1*pi/180.,x1*pi/180.,d1,dedeg,az0,
     &             y2*pi/180.,x2*pi/180.)
        if (d1.lt.min.and.points(i,3).ne.1..and.d1.ne.0.) then
          ind=i
          min=d1
        endif
      enddo
      if (min.eq.99999.) goto 160
  
c
c set segment
c
      nseg=nseg+1
      seg(nseg,1)=x1
      seg(nseg,2)=y1
      seg(nseg,3)=points(ind,1)
      seg(nseg,4)=points(ind,2)
      seg(nseg,5)=(x1+points(ind,1))/2.
      seg(nseg,6)=m*seg(nseg,5)+b
      seg(nseg,7)=min
      d2=d2+min

      points(ind,3)=1.
      x1=points(ind,1)
      y1=points(ind,2)

      goto 150

160   continue

c      do i=1,nseg
c        write(*,*) i,seg(i,1),seg(i,2),seg(i,3),seg(i,4),
c     &               seg(i,5),seg(i,6),seg(i,7)
c      enddo

c
c check in which grid box center of segment lies, and set length of segment
c
      do i=1,ygrid_npts
        do j=1,xgrid_npts
           grid(i,j)=0.
        enddo
      enddo
      do i=1,ygrid_npts-1
        do j=1,xgrid_npts-1
c          pol(1,1)=xgrid(j)
c          pol(1,2)=ygrid(i)
c          pol(2,1)=xgrid(j)
c          pol(2,2)=ygrid(i+1)
c          pol(3,1)=xgrid(j+1)
c          pol(3,2)=ygrid(i+1)
c          pol(4,1)=xgrid(j+1)
c          pol(4,2)=ygrid(i)
c
          do b=1,nseg
c            call polos(seg(b,6),seg(b,5),pol,4,inside) ! check if in polygon

c
c check if in grid cell, seg(,5) is lon, linear
c
            inside = .false.
            if (seg(b,5).ge.xgrid(j).and.
     &          seg(b,5).lt.xgrid(j+1).and.
     &          seg(b,6).ge.ygrid(i).and.
     &          seg(b,6).lt.ygrid(i+1)) then
                   inside = .true.
c                  write(*,*) b,i,j,seg(b,5),seg(b,6),xgrid(j),
c     &                      xgrid(j+1), ygrid(i),ygrid(i+1)

            endif

            if (inside) then
              grid(i,j)=seg(b,7)
c              write(*,*) ' found ',i,j,seg(b,7),seg(b,6),seg(b,5),
c     &              seg(b,1),seg(b,2),seg(b,3),seg(b,4)
            endif
          enddo
        enddo
      enddo
      b=0
      do i=1,ygrid_npts-1
        do j=1,xgrid_npts-1
          b=b+1
          seg_length(b)=grid(i,j)
c          write(*,*) i,j,b,seg_length(b)
          grid_len(i,j)=grid_len(i,j)+grid(i,j)
        enddo
      enddo

      return
      end


      subroutine get_h(len,xgrid,ygrid,maxg,h,hdim)
c
c compute weigthing matrix
c
      implicit none
      include 'qlg.inc'
      integer i,j,hdim,b,maxg,xgrid,ygrid
      real len(maxg,maxg)           ! seg_dim is physical dim
      real h(hdim,hdim)
c      real lambda
c      parameter (lambda=.001) ! Mexico
c      parameter (lambda=.001)
c      real damping
c      parameter (damping=250.) ! Mexico
c      parameter (damping=1000.) ! Mexico, changed
c      parameter (damping=500.) ! CA
      real x
      real min

      min=damp_beta * exp(-50.)
      b=0
      do i=1,ygrid
        do j=1,xgrid
          b=b+1
c      write(*,*) i,j,len(i,j)
          if (len(i,j).gt.0) then
            x=len(i,j)
          else
            x=0.
          endif
          h(b,b)= damp_beta * exp(-damp_lambda*x)
         write(666,*) b,' ',h(b,b),' ',x
c          if (h(b,b).lt.min) h(b,b)=0.
        enddo
      enddo
          
      return
      end


      subroutine check_clipped_old(x,nsamp,clipped)
c
c routine to check if signal is clipped
c
      implicit none
      include 'libsei.inc'                ! Open file definitions
      include 'seidim.inc'

      real x(max_sample)                  ! data
      integer nsamp,i,max_cnt
      real max
      logical clipped

      max=0.
      max_cnt=0.
      clipped=.false.
      do i=1,nsamp
        if (abs(x(i)).gt.max) then
          max=abs(x(i)) 
        elseif (abs(x(i)).eq.max) then
          max_cnt=max_cnt+1
        endif
      enddo
c
c if the max amplitude appears several times, the signal is considered
c to be clipped
c
      if (max_cnt.ge.25) then
        clipped=.true.
        write(*,*) ' signal clipped, max_cnt = ',max_cnt
      endif

      return
      end

      subroutine get_qlg_par
      implicit none

      include 'libsei.inc'                ! Seisan definitions
      include 'seidim.inc'                ! ------------------
      include 'seisan.inc'                ! ------------------
      include 'qlg.inc'                   ! ------------------
      external sei open,                  ! Open file routine.
     &         sei close,                 ! Close file routine.
     &         sei get file               ! Find files in diff dirs
      integer seiclen

      integer read1                       ! input unit
      integer code 
      character*80 line
      real var,mag
      integer i

      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   read1,           ! On unit.
     &                   code,            ! Returned condition.
     &                   'DAT',           ! Alternative search directory.
     &                   'qlg.par')       ! For this filename.

      if(code.ne.e_ok$) then
        write(*,*) ' definition file does not exist: qlg.par'
        stop
      endif

c
c init values
c
      f_low=0.
      f_high=0.
      dist_min=0.
      dist_max=5000.
      lg_low=3.
      lg_high=3.7 
      p_low=6.5
      p_high=8.0
      tomo_flag=.false.
      phase_only_flag=.false.
      orientation='v'
      nsmooth=0
      nfreq=0
      min_stat=4
      lg_vel=3350.
      damp_alpha=500.
      damp_beta=1000.
      damp_lambda=.001
      damp_sigma=100.
      checkerboard=.false.
      verbose=.false.
      xgrid_npts=0
      ygrid_npts=0
      xgrid_delta=0.
      ygrid_delta=0.
      xgrid_start=0.
      ygrid_start=0.
      fix_source=.false.
      fix_site=.false.
      gaussian_noise=0.
      qlgkappa=0.
      cbdelta=0.0
      do i=1,max_event
        source_perturb(i,1)=0.
        source_perturb(i,2)=0.
      enddo

10    continue
      read(read1,'(a80)',end=999) line
c
c read parameters
c
      if (line(1:10).eq.'INPUT FILE') then       
        s_file=line(41:seiclen(line))
      elseif (line(1:6).eq.'FILTER') then
        read(line(41:50),*) var
        if (var.ne.0.) f_low=var
        read(line(51:60),*) var
        if (var.ne.0.) f_high=var
      elseif (line(1:9).eq.'DISTANCES') then
        read(line(41:50),*) var
        if (var.ne.0.) dist_min=var
        read(line(51:60),*) var
        if (var.ne.0.) dist_max=var
      elseif (line(1:12).eq.'GROUP VEL LG') then
        read(line(41:50),*) var
        if (var.ne.0.) lg_low=var
        read(line(51:60),*) var
        if (var.ne.0.) lg_high=var
      elseif (line(1:11).eq.'GROUP VEL P') then
        read(line(41:50),*) var
        if (var.ne.0.) p_low=var
        read(line(51:60),*) var
        if (var.ne.0.) p_high=var
      elseif (line(1:14).eq.'INVERSION TYPE') then
        read(line(41:50),*) var
        if (var.ne.0.) tomo_flag=.true.
      elseif (line(1:11).eq.'ORIENTATION') then
        read(line(41:50),*) var
        if (var.ne.0.) orientation='h'
      elseif (line(1:10).eq.'PHASE ONLY') then
        read(line(41:50),*) var
        if (var.ne.0.) phase_only_flag=.true.
      elseif (line(1:10).eq.'FIX SOURCE') then
        read(line(41:50),*) var
        if (var.ne.0.) fix_source=.true.
      elseif (line(1:8).eq.'FIX SITE') then
        read(line(41:50),*) var
        if (var.ne.0.) fix_site=.true.
      elseif (line(1:5).eq.'KAPPA') then
        read(line(41:50),*) var
        if (var.gt.0.) qlgkappa=var
      elseif (line(1:10).eq.'FREQUENCY') then
        if (nfreq+1.le.max_nfreq) then
          read(line(41:50),*) var
          if (var.ne.0.) then
            nfreq=nfreq+1
            freq_array(nfreq)=var
          endif
          read(line(51:60),*) var
          q_1_array(nfreq)=var
        endif
      elseif (line(1:11).eq.'STATION MIN') then
        read(line(41:50),*) var
        if (var.ne.0.) min_stat=int(var)
      elseif (line(1:11).eq.'VELOCITY LG') then
        read(line(41:50),*) var
        if (var.ne.0.) lg_vel=var
      elseif (line(1:13).eq.'DAMPING ALPHA') then
        read(line(41:50),*) var
        if (var.ne.0.) damp_alpha=var
      elseif (line(1:12).eq.'DAMPING BETA') then
        read(line(41:50),*) var
        if (var.ne.0.) damp_beta=var
      elseif (line(1:13).eq.'DAMPING LAMBDA') then
        read(line(41:50),*) var
        if (var.ne.0.) damp_lambda=var
      elseif (line(1:12).eq.'DAMPING SIGMA') then
        read(line(41:50),*) var
        if (var.ne.0.) damp_sigma=var
      elseif (line(1:7).eq.'NSMOOTH') then
        read(line(41:50),*) var
        if (var.ne.0.) nsmooth=int(var)
      elseif (line(1:18).eq.'CHECKERBOARD DELTA') then
        read(line(41:50),*) var
        if (var.ne.0.) cbdelta=var
      elseif (line(1:14).eq.'CHECKERBOARD  ') then
        read(line(41:50),*) var
        if (var.ne.0.) checkerboard=.true.
c      elseif (line(1:16).eq.'CHECKERBOARD MAG') then
c        read(line(41:50),*) var
c        if (var.ne.0.) cbmag=var
      elseif (line(1:19).eq.'SOURCE PERTURBATION') then
        read(line(41:50),*) var
        source_perturb(int(var),1)=1. ! flag
        read(line(51:60),*) mag
        source_perturb(int(var),2)=mag ! magnitude
      elseif (line(1:14).eq.'GAUSSIAN NOISE') then
        read(line(41:50),*) var
        if (var.ne.0.) gaussian_noise=var
      elseif (line(1:7).eq.'VERBOSE') then
        read(line(41:50),*) var
        if (var.ne.0.) verbose=.true.
      elseif (line(1:7).eq.'X START') then
        read(line(41:50),*) var
        if (var.ne.0.) xgrid_start=var
      elseif (line(1:7).eq.'Y START') then
        read(line(41:50),*) var
        if (var.ne.0.) ygrid_start=var
      elseif (line(1:7).eq.'X DELTA') then
        read(line(41:50),*) var
        if (var.ne.0.) xgrid_delta=var
      elseif (line(1:7).eq.'Y DELTA') then
        read(line(41:50),*) var
        if (var.ne.0.) ygrid_delta=var
      elseif (line(1:9).eq.'X NPOINTS') then
        read(line(41:50),*) var
        if (var.ne.0.) xgrid_npts=int(var)
      elseif (line(1:9).eq.'Y NPOINTS') then
        read(line(41:50),*) var
        if (var.ne.0.) ygrid_npts=int(var)
      
      endif

      goto 10

999   continue
      call sei close( close$, read1, code)

      return
      end

      FUNCTION ran1(idum)
      INTEGER idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,
     *NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
      INTEGER j,k,iv(NTAB),iy
      SAVE iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do 11 j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
11      continue
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.

      FUNCTION gasdev(idum)
      INTEGER idum
      REAL gasdev
CU    USES ran1
      INTEGER iset
      REAL fac,gset,rsq,v1,v2,ran1
      SAVE iset,gset
      DATA iset/0/
      if (iset.eq.0) then
1       v1=2.*ran1(idum)-1.
        v2=2.*ran1(idum)-1.
        rsq=v1**2+v2**2
        if(rsq.ge.1..or.rsq.eq.0.)goto 1
        fac=sqrt(-2.*log(rsq)/rsq)
        gset=v1*fac
        gasdev=v2*fac
        iset=1
      else
        gasdev=gset
        iset=0
      endif
      return
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *Ko!63+16.

c
C   program to update data base with existing solutions from s-files
c
c   updates:
c
c   april 14, 1999 jh : -------- version 7.0 check ---------------------
c                       many changes
c   aug   24, 1999 lo : init logfile and epifile
c   nov 2 1999   jh   : recompiled to include new findevin and indata
c   nov 25 2001  jh   : def base (agecy_dir) was still 3 chars, changed to 5
c
      implicit none
      include 'seidim.inc'
c---name of top directory
      character*60 top_directory
c---one event in nordic format, one line of data  
c--- event type, indcator of explosion, indicator of fixing depth  
      character*1 typ,exp
c---directory separator character
      character*1 dchar
c---number of header lines, records, stations in nordic file, help variables
      integer nhead,nrecord,nstat,nphase,i,itp
c---id line indicator
      integer id
c---logfile name when updating
      character*80 logfile
c---flag for indicatin if first month  when updating
      integer first_month
c---line in log file
      character*80 logrecord
      character*80 data(max_data)   ! s-file
c---number of event in one month in data base
      integer nout
c---time of making update
      character*12 p_time
      character*14 proc_time
c---operator id
      character*4 operator
c---data base code
      CHARACTER*5 TBASE
c---first and last event used when updating
      character*12 first_event,last_event
C
C  next for data base operation
C
      character*10 keys                      !next choice key
      character*14 starttime,endtime         ! time interval for location
      character*40 basename                  ! data base or file name
      character*80 eventfile                 ! single event file name
      character*40 outname
      character*5  agency_dir                ! agency used for def. base
      integer status,eventno,newmonth,fstart ! 
c---name of epi file in data base
      CHARACTER*80 EPIFILE
c sei clen
      integer seiclen

c
c---number of arguments and function
c      integer nargs
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c                                                           
c   get computer specifics
c
      call dir_char(dchar)         ! dirctory delimiter character
      call get_def_base(agency_dir)

      epifile = ' '

c 
c   get directory structure
c
      call topdir(top_directory)
      itp=index(top_directory,' ')-1
c
c   input data base name and time interval
c
      write(6,*)'Give 1-5 letter data base name, return for default'
      read(*,'(a40)') basename                       
         tbase=basename(1:5)
         IF(TBASE.EQ.'     ') TBASE(1:5)= agency_dir
         WRITE(6,'(A,A)')
     * ' YOU ARE NOW GOING TO UPDATE THE SEISMIC DATA BASE ',TBASE
         WRITE(6,*)
     * 'ARE YOU SURE YOU KNOW WHAT YOU ARE DOING, IF SO, ENTER '
         WRITE(6,*)'OPERATOR ID (max 4 char):'
         READ(5,'(A4)') OPERATOR
         IF(OPERATOR.EQ.'    ') STOP
         WRITE(6,'(a,$)')
     *   ' START TIME(Year-Month)                          : '
         READ(5,'(A14)') STARTTIME
            IF(STARTTIME(7:7).NE.' ') THEN
            WRITE(*,*) ' YOU MUST START WITH BEGINNING OF MONTH'
            WRITE(*,*) ' THIS HAS NOW BEEN CORRECTED'
            STARTTIME(7:14)='        '
         ENDIF
         WRITE(6,'(a,$)')
     *   ' END TIME(Year-Month), RETURN IS TO END OF MONTH : '
         READ(5,'(A14)') ENDTIME
         IF(ENDTIME(7:7).NE.' ') THEN
            WRITE(*,*)' YOU MUST END WITH END OF MONTH'
            WRITE(*,*)' THIS HAS NOW BEEN CORRECTED'
            WRITE(*,*)' THIS HAS NOW BEEN CORRECTED'
            ENDTIME(7:14)='        '
         ENDIF
c
c   make shure base is 5 chars
c
         if(tbase(1:1).ne.',') then
            do i=2,5
              if(tbase(i:i).eq.' ') tbase(i:i)='_'
            enddo
         endif

C
C   open  output files
C
c
      keys(1:4)='NEXT'    ! start with next event

c
c---------------------------------------------------------------------
c  event loop starts here, always come back here after locating one event
c  or to make a new choice in interactive mode
c---------------------------------------------------------------------
c
 50   continue
c
C----------------------------------------------------------------------
C    next event 
C----------------------------------------------------------------------
C
C
C  GET FILENAME OF NEXT EVENT, save previous if any
C
         last_event=eventfile(fstart:fstart+11) ! for log file
         call findevin
     *   (basename,starttime,endtime,keys,0,eventno,
     *   eventfile,fstart,newmonth,status)
         outname(1:17)=eventfile(fstart:fstart+16)
C
C  CHECK FOR OUTPUT IN CAT DATA BASE IF NEW MONTH
c  or end of time period=end of month
C
      IF((NEWMONTH.EQ.1.or.status.eq.3)) THEN
c
c   get system time
c
         call systime(p_time,proc_time)
c
c   write in log file, latest information is on top
c   write when one month of locations is finished
c
         if(first_month.ne.0) then
c
c   first make log file name, assume that epifile (now cat file) name now known
c
            logfile(1:40) = '                                        '
            logfile(41:80)= '                                        '
            logfile(1:itp)=top_directory(1:itp)
            logfile(itp+1:itp+5)=dchar//'REA'//dchar
            logfile(itp+6:itp+10)=tbase
            logfile(itp+11:itp+15)=dchar//'LOG'//dchar
            logfile(itp+16:itp+28)='01-0000-00L.S'
            logfile(itp+29:itp+34)=epifile(1:6)
            write(6,*)
            write(6,'(1x,a)') logfile(1:seiclen(logfile))
c changed lo 13-08-2002
            open(13,file=logfile,status='unknown',access='append')
c            call indata(13,nstat,nphase,nhead,nrecord,typ,exp,data,id)
c            rewind 13
            do i=1,80
              logrecord(i:i)=' '
            enddo
            logrecord(2:5)=epifile(itp+16:itp+19)
            logrecord(7:8)=epifile(itp+20:itp+21)
            logrecord(10:13)=operator
            logrecord(15:28)=proc_time
            logrecord(30:41)=first_event
            logrecord(43:54)=last_event
            write(logrecord(56:60),'(i5)') nout
            write(13,'(a80)') logrecord

c            if(nrecord.eq.0) write(13,*)'        '
c            write(13,'(a80)')(data(i),i=1,nrecord)
            close(13)
            nout=0
          endif
          first_month=1
          first_event=outname(1:12)
          nout=0
c
c   if not at end of time period, open next epi file
c
          if(status.ne.3) then
c
C
C  CLOSE PREVIOUS EPI BASE FILE IF ANY
C
            CLOSE(31,ERR=3333)
 3333       CONTINUE
C
C  YEAR-MONTH
C
            IF(DATA(1)(2:3).EQ.'  ') DATA(1)(2:3)='19'
            EPIFILE(1:4)=eventfile(fstart-8:fstart-5)
            EPIFILE(5:6)=EVENTFILE(FSTART-3:FSTART-2)
            EPIFILE(7:10)= '.CAT'
            WRITE(6,'(1x,a,a10)') 'CATFILE IS ',EPIFILE(1:10)
C
C  OPEN NEW  cat file
C
            OPEN(UNIT=31,FILE=top_directory(1:itp)//
     &      dchar//'REA'//dchar//tbase//dchar//
     &      'CAT'//dchar//EPIFILE(1:10),STATUS='unknown')
c         
         endif
      endif
c
c   check if  errors or end of time interval, then stop
C     
         if(status.gt.0) then
            write(6,*)' STOP WITH STATUS=',status
            stop   ! stop
         endif
C
C   open data base input single event file and read it
c   set flag for single event nrecord= -1
c
         nrecord=-1
         open(21,file=eventfile,status='old')
         call indata(21,nstat,nphase,nhead,nrecord,typ,exp,data,id)
         close(21)
C
c   event is passed on with no modification to data base
c

C
c   output header line on screen
C
            write(6,2838) eventno,data(1)(1:71)
 2838       format(1x,'#',i5,1x,a71)
C
C
C   UPDATE ID LINE
C
         IF(ID.NE.0) THEN
c
c   check that id line has not changed since first read
c   could happen when adding a new error line
c
            do i=1,nhead+1   
              if(data(i)(80:80).eq.'I') id=i
            enddo
            WRITE(DATA(ID)(31:34),'(A)')OPERATOR
            WRITE(data(id)(13:26),'(A)')PROC_TIME
            WRITE(data(id)(9:11),'(A)')'UPD'
         ENDIF
C
c  write normal output file
C

c
c   write out
c
      WRITE(31,'(A80)') (DATA(i),i=1,nrecord)
      NOUT=NOUT+1

      keys='NEXT'

      go to 50                                        
C
c   this was the end
C
      
      stop
      end                                                               

c program rmsdep
c m. villagran
c 31/aug/94
c
c
c  updates:
c  jun 8 by jh     give range
c  oct 98 jh  :------------------------------------------------------------
c             :  ------------------   version 7.0 check, no change --------
c  nov 5 98   : system_c to systemc
c  jun 20 o5 jh: plt to eps
c
c include the following soubroutines
c ch_depth, change and fix depth step by step to all events
c get_results, get rms values and write gnuplot dat files
c fil_gnu write gnuplot command file
c
c Reliable variables in main program are:
c
c nev = number of events
c idep = depth running
c step = step in magnitude
c maxdep = maximun depth to reach
c nstep = number of steps to do ((maxdep-mindep)/step + 1) it includes 0.0 depth
c
c Reliable variables in subroutine get_results are:
c
c maxstep = it is a parameter to control max number of step in program
c maxev = it is a parameter to control max number of events in program
c output*6005 = char. variable to write matrix. 
c
c input is an s-file with one or many (1000 max) events, step and max depth
c
c outputs are:
c
c 1. rmsdep.out   (is a command file prepared for gnuplot)
c if the s-file exceed 10 events, no title for each curve.
c
c 2. rmsdep.dat including depth in the 1st. column and as many columns 
c as events (if less than 51) with the respective obtained rms's.
c
c 3. rmsdep.hst data for histogram, n of events with lower rms's per depth
c
c Number of events is restricted to 200 depths and 1000 events, 
c
c To increase them change the following:
c
c line of main program --> if(nstep.gt.200)then
c line in subroutine ch_depth: if(k.gt.1000)goto 80
c In subroutine get_results increase parameters maxstep and maxev
c and character variable output*6005 should be (nev*6+5)
c
c  mar 22 99 bmt : include winplot.inc
c
c      include 'pc.inc'        ! interface routines, dummy on sun                                                                               
       include 'winplot1.inc'
c      implicit none
c input file
      character infile*80,text,head*80
c loop, maximum depth and depth step variables
      integer i,idep,maxdep,step,mindep
c number of events,and number of step in process,length of the string
      integer nev,nstep,len,maxnminr
c the highest values
      real highrms
      logical from_eev    ! if from eev
c I honorably represent my name
      real dummy
c
      include 'version.inc'
      include 'winplot2.inc'


c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c   check if called from eev
c
      from_eev=.false.
      call get_env_event(infile)
      if(infile(1:1).ne.' '.and.ichar(infile(1:1)).ne.0) then
         from_eev=.true.
         text=' '
         call put_env_event(text)
      endif
c write(6,*) from_eev,infile
c
c ask for s-file, and input parameters
c
      if(.not.from_eev) then
         write(6,*)'name of s-file ??'
         read(5,'(a)')infile
      endif
c
c   get depth range
c
      write(6,*)'Depth range to use ??'
      read(5,*)mindep,maxdep
c     maxdep=dummy
      write(6,*)'step (example 1, 2, 3.. kms, must be integer)??'
      read(5,*)dummy
      step=dummy
c
c 
c test.out is a dummy file to avoid questions of hyp program.
c
      open(1,file='killme',status='unknown')
      write(1,'(a)') 'test.out'
      write(1,'(a1)')'n'
      close(1)
      nstep=((maxdep-mindep)/step)+1
      if(nstep.gt.200)then
         write(6,*)' Max. number of steps exceeded !!'
         write(6,*)' '
         stop
      endif
c
c------------------------------------------------------
c   if program is started from eev, go to section eev
c------------------------------------------------------
c
      if(from_eev) goto 2000
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      open(2,file='rmsdep.dat',status='unknown')
      open(4,file='rmsdep.out',status='unknown')
      open(5,file='rmsdep.hst',status='unknown')
c
      highrms=0.0
      maxnminr=0
c
c     LOOP STARTS HERE!!!
c
      do 10 i=1,nstep
         idep=(i-1)*step+mindep
         open(3,file=infile,status='old')                                   
c change depth to s-file
         call ch_depth (idep,infile,nev)
c locate events
         call systemc('hyp < killme',12)
         len=nev*6+5
c
c get rms's from the print.out and write in rmsdep.dat, get higher value 
c and number of events with lower value to write in rmsdep.hst 
c
         call get_results(idep,nev,highrms,len,step,nstep,maxnminr)
         rewind 3
10    continue
c
c create rmsdep.out file
c and screenout outputs of the program
c also writes statistics at the bottom of rmsdep.hst
c
      call fil_gnu (maxdep,highrms,nev,maxnminr,step)
      write(6,*)' '
      write(4,*)'#'
      write(6,'(a12,i3,a7)')'There are   ',nev,' events'
      write(4,'(a13,i3,a7)')'#There are   ',nev,' events'
      write(6,'(a12,i3,a13)')'Located at  ',nstep,' diff. depths'
      write(4,'(a12,i3,a13)')'#Located at  ',nstep,' diff. depths'
      write(6,'(a12,i3,a4)')'in steps of ',step,' kms'
      write(4,'(a13,i3,a4)')'#in steps of ',step,' kms'
      step=step*(nstep-1)
      write(6,'(a21,i3,a4)')'starting from 0.0 to ',step,' kms'
      write(4,'(a22,i3,a4)')'#starting from 0.0 to ',step,' kms'
      write(6,*)' '
      write(6,*)'output files are:'
      write(6,*)' '
      write(6,*)'  rmsdep.dat --> matrix: first column is the depth,'
      write(6,*)'                 the rest are the rmss per event.'
      if(nev.gt.50)then
      write(6,*)'                 NOT POSSIBLE TO DISPLAY IN GNUPLOT'
      endif
      write(6,*)' '
      write(6,*)'  rmsdep.out --> now invoke gnuplot and use'
      write(6,*)'                 the command load "rmsdep.out"'
      write(6,*)'    '
      write(6,*)'  rmsdep.hst --> histogram data'
      write(6,*)'    '
      goto 99
c
c-----------------------------------------------------------------
c   section when program is started from eev
c-----------------------------------------------------------------
c
 2000 continue
c
c   generate file with many depths
c
      call many_depths(infile,mindep,nstep,step,head)
c
c locate events
c
      call systemc('hyp < killme',12)
c
c   get rms and depths
c
      call get_depth_rms(head)


99    stop
      end
c
c that's it
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
c
      subroutine ch_depth(j,infile,k)
c
c fix depth=j for all events in the s-file
c m.v 31/aug/94
c
      implicit none
      character all*80,text*38,infile*30
      integer i,j,k
      k=1
      open(10,file='test.out',status='unknown')
c because the first event the same thing 2 times
      read(3,'(a80)',end=80)all(1:80)                                           
      write(all(40:45),'(i2,a4)')j,'.0F '
      write(10,'(a80)')all(1:80)
c big loop after the first line starts here
10    read(3,'(a80)',end=20)all(1:80)                                           
          if(all(1:12).eq.'            '.and.all(80:80).eq.' ')then
          write(10,'(a80)')all(1:80)
          read(3,'(a80)',end=20)all(1:80)   
          write(all(40:45),'(i2,a4)')j,'.0F '
          k=k+1
          if(k.gt.1000)goto 80
          endif
      write(10,'(a80)')all(1:80)
      goto 10                                                                   
20    close(1,status='delete') 
      close(10)
c      text(1:8)='mv test '
c      do i=1,30
c         if(infile(i:i).eq.' ')goto 30
c      enddo
c30    text(9:i+7)=infile(1:i-1)
c      call systemc(text(1:i+7),i+7)                                      
      goto 99
80    write(6,*)' '
      write(6,*)'empty s-file or more events than expected !!'
      write(6,*)' '
      stop
99    return                                                                    
      end                                                                       
c
      subroutine get_results(idep,nev,highrms,len,step,nstep,maxnminr)
c  
c capture y=rms from the print.out, get max and min rms value
c and create histogram file rmsdep.hst
c write the matrix in rmsdep.dat if n of events does not exceed 50
c m.v 31/aug/94
c
      implicit none
      integer maxstep,maxev
      parameter(maxev=1000)
      parameter(maxstep=200)
      character all*80,output*6005
      integer j,nev,len,k,i,idep,step,nstep
      integer a(maxstep),maxnminr
      real y(maxstep,maxev),highrms,x
      open(10,file='print.out',status='old')
      j=idep/step+1
      k=1
20    read(10,'(a80)',end=30)all(1:80)
          if(all(1:12).eq.'   date hrmn')then
          read(10,'(a80)',end=30)all(1:80)
          read(all(1:57),300,end=30)y(j,k)
          if(highrms.lt.y(j,k))highrms=y(j,k)
          k=k+1
          endif
      goto 20
30    close(10)
c
c writes data in rmsdep.dat
c
         k=6
         write(output(1:5),'(i4,1x)')idep
               do i=1,nev
               write(output(k:k+5),400)y(j,i)
               k=k+6
               enddo
         write(2,'(a)')output(1:len-1) 
c
c if last result, write in rmsdep.hst the histogram data
c
      if(j.eq.nstep)then
         do 50 k=1,nev
         x=100.0
            do i=1,nstep
            if(y(i,k).lt.x) x=y(i,k)
            enddo
            do i=1,nstep
            if(y(i,k).eq.x) a(i)=a(i)+1
            enddo
50       continue
         do i=1,nstep
            write(5,'(i4,1x,i4)')step*(i-1),a(i)
            if(a(i).gt.maxnminr)maxnminr=a(i)
         enddo
      endif
 300  format(52x,f5.2)
 400  format(f5.2,1x)
99    return
      end
c
      subroutine fil_gnu (maxdep,highrms,nev,maxnminr,step)
c
c writes rmsdep.out to be used by gnuplot
c m.v. 2 aug 94 
c 
      implicit none
      character output*1550
      integer i,j,k,nev,maxnminr,step
      integer maxdep
      real highrms
c
c write obligatory lines
c
      write(4,'(a)')'set xlabel " Depth Kms."'
      write(4,'(a15,i4,a1)')'set xrange [-1:',maxdep,']'
      write(4,'(a)')'set grid'
      write(4,'(a)')'set data style line'
      if(nev.gt.10)write(4,'(a)')'set nokey'
      write(4,'(a)')'#set term postscript'
      write(4,'(a)')'#set output "gnuplot.eps"'
      output(1:5)='plot '
c if rmsdep.dat
      if(nev.lt.51)then
      highrms=highrms+1
      i=highrms
      write(4,'(a14,i3,a1)')'set yrange [0:',i,']'
      write(4,'(a)')'set ylabel " RMS"'
      write(4,'(a)')'set title "RMS-Depth"'
      j=6
15       do k=1,nev+1
         if(k.lt.9)then
         write(output(j:j+18),500)k+1
         j=j+19
         if(k.eq.nev+1)j=j-21
         endif
         if(k.gt.8)then
         write(output(j:j+19),510)k+1
         j=j+20
         if(k.eq.nev+1)j=j-22
         endif
c        if(k.gt.98)then
c        write(output(j:j+20),520)k+1
c        j=j+21
c        if(k.eq.nev+1)j=j-23
c        endif
         enddo
      write(4,'(a)')output(1:j)
      write(4,'(a)')'pause -1 "Hit Return (Histogram next)"'
      endif
      if(nev.lt.11)write(4,'(a)')'set nokey'
      write(4,'(a13,f5.2)')'set boxwidth ',0.5*step
      write(4,'(a)')'set ylabel "Number of earthquakes"'
      write(4,'(a)')'set title "Minimum RMS of travel time residuals"'
      write(4,'(a14,i4,a1)')'set yrange [0:',maxnminr+1,']'
      write(4,'(a)')'plot "rmsdep.hst" w boxes'
      write(4,'(a)')'#----------STATISTICS----------'
 500  format('"rmsdep.dat" u 1:',i1,',')
 510  format('"rmsdep.dat" u 1:',i2,',')
c520  format('"rmsdep.dat" u 1:',i3,',')
99    return
      end
c
      subroutine many_depths(evfile,mindep,ndepth,step,text)
      
      include 'seidim.inc'
      integer step,nstep
      real depth
      integer nstat,nphase,nhead,nrecord,id
      character*1 evid,exp
      character*80 data(max_data),evfile
      character*80 text
c
c   read event file
c
      open(17,file=evfile,status='old')
      call indata
     *(17,nstat,nphase,nhead,nrecord,evid,exp,data,id)
      close(17)      
      text=data(1)
c
c   generate output file with all depths
c
      open(17,file='test.out',status='unknown')
      depth=mindep
      do i=1,ndepth
         write(data(1)(39:44),'(f5.0,a)')depth,'F'
         write(17,'(a)')(data(k),k=1,nrecord)
         depth=depth+step
      enddo
      close(17)
      return
      end
c
      subroutine get_depth_rms(head)
c
c  get depths and rms from print.out file
c
      implicit none
      include 'seiplot.inc'
      character*80 text                   ! general text
      real x(1000),y(1000)                ! depth and rms
      real xx(5),yy(5)                    ! dummy
      integer ndepth,i                    ! counters
      character*1 cha(10)                 ! dummy for xy_plot
      character*80 title,head             ! title for plot      
      character*30 xtext,ytext            ! axis title
      character*1  do_plot
c
      open(17,file='print.out',status='old')
c
c   read loop
c
      ndepth=1
c
 10   continue
      read(17,'(a)',end=99) text
      if(text(1:12).eq.'   date hrmn') then
          read(17,'(a)',end=99)text
          read(text(39:43),'(f5.1)') x(ndepth)
          read(text(53:57),'(f5.2)') y(ndepth)
          ndepth=ndepth+1
      endif
      goto 10
c
c   end of reading
c
  99  continue
      ndepth=ndepth-1
      do i=1,ndepth
        write(6,*) x(i),y(i)
      enddo
c
c   plot results
c
      write(6,*) 'Plot results (y/n)'
      read(5,'(a)') do_plot
      if(do_plot.eq.'y'.or.do_plot.eq.'Y') then
c
c  set defaults for output on tek screen and one hardcopy file
c
           open(65,file='rmsdep.eps',status='unknown')
           plotunit=65
           plotoption=1
           hctype=1
           wsize=50
c
c   open plotter
c
           call open_display 
           title=head
           xtext='              depth(km)  '
           ytext='              RMS(sec)   '
c
c   plot points
c
           text='q to quit'
           call tchars(text,9,750.0,700.0)
           call xy_plot
     *     (1,ndepth,x,y,title,xtext,ytext,
     *     600.0,600.0,100.0,100.0,3,1,10.0,
     *     1,cha,i,xx,yy)
           call clear_to_alpha
           call close_post
           write(6,*)' Plot file is rmsdep.eps'

c
c   clear
c
      endif

      return
      end
c      include 'pcplot.inc'

c
c  program to convert SEISAN files to Sesame Ascii files SAF
c  jh, april 2003
c
c  the 3 first channels in seisan file is read, no check if from same station
c  or order z,n,e
c  it is assumed that all 3 have the same start time, number of samples
c      and sample rate, these values are taken from the first trace
c
c   format description at end of program
c

      implicit none
      include 'seidim.inc'                    ! for giving dimensions
      include 'libsei.inc'                    ! for all seisan subroutines
      include 'waveform.inc'                  ! waveform data
      include 'seisan.inc'                    ! seisan general parameters
      character*80 question                   ! question
      character*80 text                       ! general text string
      integer k,i,in
      external seiclen                        ! lenght of string
      integer seiclen


c
c   get input file name
c
      in=0
      question=' File name, #, ? or filenr.lis for all'
      call filename(question,wav_filename(1))	    
      if(wav_filename(1).eq.'EOF') stop
      if(wav_filename(1)(1:10).eq.'filenr.lis'.or.
     *wav_filename(1)(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') wav_filename(1)
         if(wav_filename(1)(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') wav_filename(1)
c
c  open file 
c  
      wav_nfiles=1                   ! there is only one file in this case
c
c   read all headers of file 
c
      call read_wav_header(1)
c
c   output possible errors
c
       if(wav_error_message.ne.' ') write(6,'(1x,a)') 
     * wav_error_message
c
c   write out the format, can be seisan or GSE currently
c
       write(6,'(1x,a,a)') 'Format ',wav_file_format(1)

c
      write(6,*)' Total number of channels available:',wav_nchan
c
c   terminate if no channels
c
      if(wav_nchan.eq.0) stop
c
c   write some input info for each channnel on screen
c
      write(6,'(a,a)')'CHA STAT  COMP  YEAR MO DA HR MI    SEC NSAMP ',
     *                '    RATE    DELAY DURATION'
      do i=1,wav_nchan
         write(6,'(i3,1x,a,1x,a,1x,i5,4i3,f7.3,i6,3f9.3)')
     *   i, wav_stat(i),wav_comp(i),
     *   wav_year(i),wav_month(i),wav_day(i),wav_hour(i),wav_min(i),
     *   wav_sec(i),wav_nsamp(i),wav_rate(i),wav_delay(i),
     *   wav_duration(i)
      enddo

c
c   open output file, same as input with SAF at end
c
      open(2,file=wav_filename(1)(1:seiclen(wav_filename))
     *//'_SAF',status='unknown')
      write(6,'(a,a)') ' Output file name: ',
     *wav_filename(1)(1:seiclen(wav_filename))//'_SAF'
     
c
c   write headers
c

c
c   main header
c
      write(2,'(a,a)') 
     *'SESAME ASCII data format (saf) v. 1   ',
     *'(this line must not  be modified)'
c
c  info
c
      write(2,'(a)') 
     *'# Data converted from SEISAN with program SAFSEI'
      write(2,'(a,a)') '# Original file name: ',
     *wav_filename(1)(1:seiclen(wav_filename))
c
c
c  station code, only use code for first channel
c
      write(2,'(a,a)')'STA_CODE = ',wav_stat(1)
c
c   sampLE rate, assume same all
c
      write(2,'(a,f8.3)') 'SAMP_FREQ = ', wav_rate(1)

C
C   number of samples
c
      write(2,'(a,i8)')'NDAT = ', wav_nsamp(1)
c
c   start date and time
c
      write(2,'(a,i5,4i3,f8.3)') 'START_TIME = ', wav_year(1),
     *wav_month(1),wav_day(1),wav_hour(1),wav_min(1),wav_sec(1)
c
c   units
c
      write(2,'(a)')'UNITS = count'
c
c   componenets, GSE style
c
      
      write(2,'(a,a,1x,a)') 
     *'CH0_ID = ',wav_comp(1)(1:1),WAV_comp(1)(4:4) 
      write(2,'(a,a,1x,a)') 
     *'CH1_ID = ',wav_comp(2)(1:1),WAV_comp(2)(4:4) 
      write(2,'(a,a,1x,a)') 
     *'CH2_ID = ',wav_comp(3)(1:1),WAV_comp(3)(4:4) 

c
c   orientation
c
c      write(2,'(a,a)') 'NORTH_ROT = ', '  '
c
c   start of digitial data
c
      write(2,'(a)') 
     *'####-------------------------------------------'
 
c
c
c
c--------------------------------------------------------------------------
c  Data from first 3 channels, it is assumed that they are z,n,e
c  but any 3 channels will be read
c--------------------------------------------------------------------------
c

c
c   read one channel at the time
c
      call wav_read_channel(3)
      do i=1,wav_nsamp(3)
         signal3(i)=signal1(i)
      enddo 
      call wav_read_channel(2)
      do i=1,wav_nsamp(2)
         signal2(i)=signal1(i)
      enddo 
      call wav_read_channel(1)

c
c   write samples, assume number of samples are the same for all 3 as the first
c   channel, write as reals
c
      do i=1,wav_nsamp(1)
          write(2,'(3f13.3)')
     *    signal1(i),signal2(i),signal3(i)
      enddo
c
c  go for next file
c
      close(2)
      if(in.eq.1) goto 1000


      stop
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c
c
c   this routine not used, just added in case program should read the other way
c   in the future

        subroutine rsaf(fname,ndatma,iopt,datath,npts,sfre,ier)
c
c Read Sesame Ascii Format data
c
c a.tento 09/02 v. 2.0
c
c ARGUMENTS:
c -- input --
c fname   :  input file name 
c ndatma  :  row dimension of matrix "datath" as specified in the
c            dimension statement of the calling program
c iopt    :  option = 0 read header and data time histories
c                   = 1 read only header
c -- output -- 
c datath(ndatma,3) : time histories for 3 channels, must be dimensioned
c                     in the calling program
c npts    :  number of points of time histories
c sfre    :  sampling frequency in Hz
c ier     :  error code = 0 : no error
c          = 2 : or 3  problem in getting an unused fortran file unit
c          = 4 : problem in opening the file (e.g. permission denied or
c                                      the file does not already exist)
c          = 7 : the mandatory parameters have NOT been completely set
c          = 8 : number of time history points greater than "ndatma"
c          = 9 : error in reading time histories data
c          = 50 : the opened file is NOT a current version SAF file
c          > 1000 : problem header reading line : ier - 1000
c
c
        implicit none
c
c....... ARGUMENTS
        character  fname*(*)
        integer    ndatma, iopt, npts, ier
        real       datath, sfre
        dimension  datath(ndatma,3)
c
c....... IDENTIFIERS SAF v. 1
        integer   iver, ibeg
        parameter ( iver = 36, ibeg = 24)
        character version*(iver),  begdat*(ibeg), comment*1, sep*1
        parameter ( version = 'SESAME ASCII data format (saf) v. 1 ' )
        parameter ( begdat = '####--------------------' ) 
        parameter ( comment = '#' )
        parameter ( sep = '=' )
c
c....... /SAFHDR8/ 
        integer    length
        parameter ( length = 100 )
        integer    year,  month,  day,  hour,  minute, isec, msec, ndat
        real       second, samp_freq, north_rot 
        character*(length) sta_code, ch0_id, ch1_id, ch2_id, units
        common /safhdr8/  year,  month,  day,  hour,  minute, isec, 
     #         msec,  ndat, second, samp_freq, north_rot, sta_code, 
     #         ch0_id, ch1_id, ch2_id, units
c
c....... UNDEFINED 
        integer      iundef
        real         rundef
        character*8  cundef
        parameter ( iundef = -12345)
        parameter ( rundef = -12345.0e+00 )
        parameter ( cundef = '-12345')
c
c
c....... LOCAL VARIABLES
        integer      mheader, mmand
        parameter    ( mheader = 9, mmand = 8 )
        character*(length) header(mheader), row, argout(2),
     #                     headcod(mheader)
        data headcod / 'STA_CODE','SAMP_FREQ','NDAT','START_TIME',
     #                 'UNITS', 'CH0_ID', 'CH1_ID', 'CH2_ID',
     #                 'NORTH_ROT' /
c
        integer large
        parameter (large=2147483600)
c
        logical      free
        integer      i, nunit, j, ind, k
        integer      numax, numin
        parameter    ( numax=50, numin=31 )
c
c ....... first executable statement
c
        ier = 0
c
c ....... header initialization
c
        do 1 i = 1, mheader
        header(i) = cundef
1       continue
        year      =  iundef
        month     =  iundef
        day       =  iundef
        hour      =  iundef
        minute    =  iundef
        isec      =  iundef
        msec      =  iundef
        ndat      =  iundef
        second    =  rundef
        samp_freq =  rundef
        north_rot =  rundef
        sta_code  =  cundef 
        ch0_id    =  cundef 
        ch1_id    =  cundef 
        ch2_id    =  cundef 
        units     =  cundef
        sfre = samp_freq
        npts = ndat
c
c ....... get a currently unused fortran file unit
c
        do 4 i = numin, numax
        nunit = i
        inquire(unit=nunit,err=302,opened=free)
        if (.not.free) goto 5
4       continue
c
        goto 303
c
5       continue
c
c ....... open file and read first line
c
        open(nunit,file=fname,form='formatted',access='sequential',
     #  status='old', err=304) 
c
        k = 1
        read(nunit,100,err=305)row
        if ( row(1:iver)  .ne.  version ) goto 350
c
        do 6 i = 1, large
        k = i + 1
        read(nunit,100,err=305)row
        if ( row(1:ibeg)  .eq.  begdat ) goto 7
        if ( row(1:1)  .eq.  comment ) goto 6
        if ( row       .eq.  ' '     ) goto 6
        call spltct8(row,sep,argout,length)  
        call toups8(argout(1))
        do 8 j = 1, mheader
        ind = j
        if ( headcod(j)  .eq.  argout(1) ) goto 9
8       continue
        goto 306
9       continue
c
        header(ind)=argout(2)
c
6       continue
c
7       continue
c
        do 2 i = 1, mmand
        if ( header(i) .eq. cundef ) goto 307
2       continue
c
        sta_code = header(1)
        read(header(2),*)samp_freq
        sfre = samp_freq
        read(header(3),*)ndat
        npts = ndat
        read(header(4),*) year,  month,  day,  hour,  minute, second
        isec = int(second)
        msec = int((second - float(isec))*1000.0 + 0.5)
        units = header(5)
        ch0_id = header(6)
        ch1_id = header(7)
        ch2_id = header(8)
        read(header(9),*)north_rot
c
        if ( iopt  .eq.  1 ) goto 99
c
        if ( npts  .gt.  ndatma ) goto 308 
        do 10 i = 1, npts
        read(nunit,*,err=309)(datath(i,j),j=1,3)
10      continue
c
c
99      continue
        close(nunit)
        return
c
c ........ inquire error
302     ier = 2
        return
c
c ........ no units free
303     ier = 3
        return
c
c ........ cannot open
304     ier = 4
        return
c
c----------------------------------------------------------------------
c ........ cannot read at line : ier - 1000
305     ier = 1000 + k
        close(nunit)
        return
c
c ........ uncorrect key word found at line : ier - 1000
306     ier = 1000 + k
        close(nunit)
        return
c
c ........ problem in reading parameter values at line : ier - 1000
311     ier = 1000 + k
        close(nunit)
        return
c----------------------------------------------------------------------
c
c ........ not all the mandatory parameters are  set
307     ier =  7
        close(nunit)
        return
c
c ........ npts > ndatma
308     ier = 8
        close(nunit)
        return
c
c ........ error in reading time histories data
309     ier = 9
        close(nunit)
        return
c
c ........ the opened file is NOT a current version SAF file
350     ier = 50
        close(nunit)
        return
c
c
100     format(a100)
c
c
c
        end
        subroutine toups8(string)
c
c convert "string" to upper case 
c
c a.tento 05/02 v.1.0
c
c ARGUMENTS
c string  : 
c           -- input --
c           character variable to be converted in upper case
c           -- output --
c           upper case version of input string
c
c
c....... ARGUMENTS
        character  string*(*)
c
c....... LOCAL VARIABLES
        integer i, j, k, m
        character*1 upper(26), lower(26) 
        data upper / 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 
     #               'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 
     #               'U', 'V', 'W', 'X', 'Y', 'Z' /
        data lower / 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 
     #               'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 
     #               'u', 'v', 'w', 'x', 'y', 'z' /
c
c ....... first executable statement
c
        m = len(string)
c
        do 1 i = 1, m
        do 2 j = 1, 26
        k = j
        if ( string(i:i)  .eq.  lower(j) ) goto 3
2       continue
        goto 1
3       string(i:i) = upper(k)
1       continue
c
        return
c
        end
        
        subroutine spltct8(row,sep,argout,length)
c
c Split a character string ("row*(length)") in two parts 
c (i.e. keyword and its argument) and put them in  "argout*(length)".
c Separator is specified by  "sep" (character*1).
c Initial blank are removed.
c
c a.tento 5/02 v.1.0
c
c ARGUMENTS:
c -- input --
c row    :  character*length string to be split              [c]
c sep    :  character*1 separator                     [c]
c -- output --
c argout :  character*length vector(2) of parts found in "row" [c]
c length :  length of character string 
c
c
c....... ARGUMENTS
        integer length
c_g77__       character row*(length), sep*1, argout(2)*(length)
        character row*(*), sep*1, argout(2)*(*)
c
c....... LOCAL VARIABLES
        character cblank*1
        parameter (cblank = ' ' )
        integer k, j, i
c
c
        do 10 i = 1, length
        argout(1)(i:i) = cblank
        argout(2)(i:i) = cblank
10      continue
c
        k = 0
        j = 0 
        do 1 i = 1, length
        k = i
        if( row(i:i) .eq. cblank ) goto 1
        if( row(i:i) .eq. sep ) goto 2
        j = j + 1
        argout(1)(j:j) = row(i:i)
1       continue
        return
c
2       continue
        do 3 i = k+1, length
        j = i
        if( row(i:i) .eq. cblank ) goto 3
        goto 4
3       continue
c
4       continue
        argout(2) = row(j:length)
c
        return
c
        end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


c>====================================================================
c>The SESAME ASCII file is organized in 3-columns corresponding to 3
c>channels.
c>
c>Therefore  the structure of such SESAME data file is:
c>
c>- First line :  "SESAME ASCII data format (saf) v. 1  "
c>- Header information
c>    - Empty lines are allowed
c>    - Comments can be added provided that the first character in the row
c>is "#"
c>    - Keywords are not case sensitive
c>    - Separator between keywords and their values is "="
c>    - The order of the keywords is irrelevant
c>    - Blanks can be added everywhere
c>- Data begin after this separator  line : "####--------------------"
c>- Data are written in  three columns free format
c>- Column 1 must correspond to the Vertical channel, columns 2 and 3 to
c>the horizontal ones
c>
c>Mandatory keywords are :
c>- STA_CODE : station/site code (In the GSE2.0 format this parameter is
c>at most 5 characters long)
c>- START_TIME : start date and time - year month day hour minute second
c>(e.g. 1999 4 23 0 3 44.78 )
c>- SAMP_FREQ : sampling frequency in Hertz
c>- NDAT : number of samples
c>- CH0_ID : component 1 definition - It should be the vertical channel.
c>It is a label. (In the GSE2.0 format this parameter is  3 characters
c>long)
c>- CH1_ID : component 2 definition - horizontal
c>- CH2_ID : component 3 definition - horizontal
c>- UNITS : label (e.g. m/s)
c>the following keyword is optional:
c>-  NORTH_ROT : is the orientation of the first horizontal component
c>(channel 1 - column 2) from North clockwise (degrees)
c>
c>For the  data specifically prepared for WP04 (Nikos Theodulidis) it was
c>requested to add some specific comments (line in the header with "#" in
c>the first row), see Rome WP04 minutes for details. Of course these
c>comments do not affect at all the readibility of the file by J-SESAME.
c>

c$debug

      subroutine mfhead(year,month,day,hour,min,sec,window,nchan,
     *                 net_code,stat,comp,cstart,cinter,file,mainhead)
c
c   make a seisanr main header and file name, output is
c   filename file and main header
c
c
c   jan 95  ny jh   ***************** version 5.0 ************************
c   sep 98 jh       ------------ version 7.0 check ----------------------
c                   eliminate pc part
c                   change output file name to use century, 5 char network code,
c                   5 char station codes in header
c   oct 6   bmt     line 82 linux changed 
c   dec 20  jh      if blank net code, replace with _
c   may 2000 jh     alow time intervals up to 999999 secs
c
c   aug 22 by jh : filename to 80 chars
      implicit none
      include 'seidim.inc'
c-- main header
      character*80 mainhead(max_trace)
c-- output file name 
      character*80 file	  
c-- number of stations
      integer nchan	  
c-- total time window of file
      real window
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- main header date and time
      integer year,month,day,doy,hour,min
      integer year_seisan ! year - 1900
      real sec	  
c-- channel start time and interval
      real cstart(max_trace)
      real cinter(max_trace)
      integer i,j,k,l
c
c   make main header, clear first
c
      do i=1,max_trace
         do j=1,80
            mainhead(i)(j:j)=' '
         enddo
      enddo		 					 	  
c-- name or code
      mainhead(1)(2:6)=net_code
c-- number of channels
      write(mainhead(1)(31:33),'(i3)') nchan
c-- start time
c
c  calculate doy
c
      call date_doy(doy,day,month,year)
c	  
c      write(6,*) hour
c
c   subtract 1900 to be able to write year in 3 places
c
       year_seisan=year-1900
c
      if(window.gt.99999.0) then
         write(mainhead(1)(34:69),'(i3,1x,i3,1x,i2,1x,i2,1x,i2,1x,
     *   i2,1x,f6.3,1x,f9.2)',err=464) year_seisan,doy,month,
     *   day,hour,min,sec,window
      else
         write(mainhead(1)(34:69),'(i3,1x,i3,1x,i2,1x,i2,1x,i2,1x,
     *   i2,1x,f6.3,1x,f9.3)',err=464) year_seisan,doy,month,
     *   day,hour,min,sec,window
      endif
      goto 465
 464  continue
      write(6,*)' Something wrong with dates etc,'
     *,'yy,doy,mm,dd,hh,mm,ss,window'
      write(6,'(i4,1x,i3,1x,i2,1x,i2,1x,i2,1x,
     *i2,1x,f6.3,1x,f9.3)',err=464) year,doy,month,day,hour,min,sec,
     *window
      stop
 465  continue
 
c
      l=2
      k=3	  
      do j=1,nchan
        if(cinter(j).gt.99999.0) then
           write(mainhead(k)(l:l+24),'(2a4,a1,f7.2,1x,f8.1)')	  	 
     *     stat(j)(1:4),comp(j)(1:4),stat(j)(5:5),cstart(j),cinter(j)   
        else
           write(mainhead(k)(l:l+24),'(2a4,a1,f7.2,1x,f8.2)')	  	 
     *     stat(j)(1:4),comp(j)(1:4),stat(j)(5:5),cstart(j),cinter(j)   
        endif
        l=l+26
        if(l.gt.60) then
           l=2
           k=k+1
        endif
      enddo			
c                                                                               
c  make file name
c             
c-- year                          
         write(file(1:4),'(i4)') year
         file(5:5)='-'               
c-- month                                    
         file(6:7)=mainhead(1)(42:43)		
         file(8:8)='-'
c-- day                                      
         file(9:10)=mainhead(1)(45:46)		
         file(11:11)='-'
c-- hr                                       
         file(12:13)=mainhead(1)(48:49)		
c-- min                                    
         file(14:15)=mainhead(1)(51:52)		
         file(16:16)='-'
c-- sec                                    
         file(17:18)=mainhead(1)(54:55)		
         file(19:20)='S.'
c-- network or station code                  
         file(21:25)=mainhead(1)(2:6)		
         do i=21,25
           if(file(i:i).eq.' ') file(i:i)='_'
         enddo
         file(26:26)='_'
c-- number of channels
         file(27:29)=mainhead(1)(31:33)
c-- check for blanks                                        
         do i=1,29				
            if(file(i:i).eq.' ') file(i:i)='0'                            
         enddo                                                                  
c         write(6,200) file(1:29)                                             
c 200     format(/,' Output file name is: ',a23)                                
      return
      end

c
c   converts rsa bulletin files to nordic format
c   if a filenr.lis file present with old wav file references, it will
c   then try to make wav names if time is similar
c
c   jh august 2000
c
c   updates
c
c   oct 5, 2000 jh  : fix exp flag
c   nov 10          : put C for coda mag

c
       implicit none
C  array with original readings
      character*80 data(1000)
      integer wyear(20000),wmonth(20000),wday(20000),
     *whour(20000),wmin(20000),wsec(20000) ! s-file names to make wav-names
      character*80 text
      character*3 agency
      character*4 trms
      real erlt,erln,erz           ! errors
      integer gap
      real w                       ! weight used
      integer iw,iwav
      integer idist                ! distance
      real dist                    ! distance
      character*80 infile
      real mag1                    ! magnitude
c  number of different stations in data
      integer nstat
      integer year,month,day,hour,min
      real sec
c  decimal latitude and longitude
      real dlat,dlon
c  depth,  rms of residuals
      real depth,rms
      real coda    ! coda
      character*40 wavname     ! wav file name
      integer wav_used(20000)  ! wav files found
      double precision twav(20000), tsfil   ! absolute time of sfile and wav
      integer icoda
      integer i,NEVENT,ID,k
      integer nwav       ! number of wav files


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      nevent=0
      iwav=0   ! count files found
c
c  open and read s-file names for wav
c
      i=0
      open(1,file='filenr.lis',status='old',err=888)
 900  continue
      i=i+1
      read(1,'(7x,i4,1x,i2,1x,i2,1x,2i2,3x,i2)',end=905,err=888)
     *wyear(i),wmonth(i),wday(i),whour(i),wmin(i),wsec(i)
c
c   make abs time
c
      call timsec(wyear(i),wmonth(i),wday(i),whour(i),wmin(i),
     *float(wsec(i)),twav(i))

      if(wyear(i).eq.0) goto 905
      goto 900
 905  continue
      i=i-1
      write(6,*)' Number of wav-files', i
      nwav=i
      do i=1,nwav
        wav_used(i)=0   ! nothing found yet
      enddo
      close(1)
 888  continue
     
                                
      write(6,*)' Input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old')
      open(2,file='rsanor.out',status='unknown')
c
c   next event
c
 50   continue
c
c   find next header line
c
      read(1,'(a)',end=99) text
      if(text(17:17).ne.'/') goto 50
c
c   event reading loop
c

 51   continue
c
c  clean header
c
         do i=1,80
           data(1)(i:i)=' '
         enddo

      nevent=nevent+1
      read(text(15:16) ,'(i2)') year
      if(year.lt.2) then
         year=year+2000
      else
         year=year+1900
      endif
      if(text(69:69).eq.'E'.or.text(69:69).eq.'e') data(1)(23:23)='P'  ! explosion
      read(text(18:19),'(i2)') month
      read(text(21:22),'(i2)') day

      read(text(24:25),'(i2)') hour
      read(text(27:28),'(i2)') min
      read(text(30:34),'(f5.3)') sec
c   lat,lon,depth
c
      read(text(37:44), '(f8.4)') dlat
      read(text(46:54),'(f9.4)') dlon
      read(text(56:60),'(f5.1)') depth
c      write(6,*) dlat,dlon,depth
c
c   magnitude
c
      read(text(64:67),'(f4.2)') mag1
      read(1,'(a)') text 
c
c  rms
c
      read(text(1:5),'(f5.2)') rms
      read(text(6:23),'(3f6.2)') erlt,erln,erz
c      write(6,*) erlt
      read(text(31:33),'(i3)') gap
c      write(6,*) gap
c
c   one  input line
c
      read(1,'(a)',end=99) text
      read(text(4:6),'(i3)') nstat
c      write(6,*) nstat
c
c   write header line
c

         id=1

         agency='ADA'
         write(data(1)(2:20),'(i4,1x,2i2,1x,2i2,1x,f4.1)')
     *   year,month,day,hour,min,sec
         trms='    '
         if(rms.gt.0.0)write(trms,'(f4.1)') rms
         if(nstat.gt.999) nstat=999
         write(data(1)(46:55),'(a3,i3,A4)') agency,nstat,trms
         write(data(1)(24:43),'(f7.3,f8.3,f5.1)') dlat,dlon,depth
         write(data(1)(57:63),'(f3.1,a1,a3)')mag1,'C',agency 
         data(1)(22:22)='L'
         data(1)(80:80)='1'
         id=id+1
         data(id)=data(1)   ! save old location
         id=id+1
         data(id)=' '
         write(data(id)(6:8),'(i3)') gap
         write(data(id)(25:43),'(f6.1,f8.1,f5.1)') erlt,erln,erz
         data(id)(2:5)='GAP='
         data(id)(80:80)='E'
         id=id+1
         data(id)=data(id-1)
         data(id)(50:73)=' Old RSA error estimate'
         data(id)(80:80)='3'
c
c   make abs time
c
         call timsec(year,month,day,hour,min,sec,tsfil)
c
c   compare wav file refernces
c
         wavname=' '
         if(nwav.gt.0) then
            do i=1,nwav
               if(dabs(twav(i)-tsfil).lt.100) then
                  wav_used(i)=1    ! indicate this one used
                  id=id+1
                  write(wavname,'(i4,a,i2,a,i2,
     *             a1,2i2,a1,i2,a7)') wyear(i),'-',
     *            wmonth(i),'-',wday(i),'-',whour(i),wmin(i),'-',
     *            wsec(i),'S.REDSA'
                  do k=1,20
                     if(wavname(k:k).eq.' ') wavname(k:k)='0'
                  enddo
                  data(id)=' '
                  data(id)(2:26)=wavname(1:25)
                  data(id)(80:80)='6'
               endif
            enddo
            if(wavname.ne.' ') iwav=iwav+1
         endif
c
         id=id+1
         write(data(id),243)
 243     FORMAT(
     *   ' STAT SP IPHASW D HRMM SECON CODA AMPLIT PERI AZIMU VELO ',
c     *   'SNR AR TRES W  DIS CAZ7')
     *   'AIN AR TRES W  DIS CAZ7')
c
 20   continue
c
c   read phases
c
      read(1,'(a)',end=99) text
       if(text(1:15).eq.'               ') then ! end of phases
           write(6,'(a)') data(1)(1:79)
           write(2,'(a)') (data(i),i=1,id)
           write(2,*)'                                 '
           go to 50    ! next event
      endif
c
      id=id+1
      do i=1,80
        data(id)(i:i)=' '
      enddo
c
c   P- phase
c
      data(id)(2:5)=text(1:4)              ! station
c      if(data(id)(2:5).eq.'    ') data(id)(2:5)=data(id-1)(2:5)
      data(id)(7:8)='SZ'
      data(id)(10:11)=text(22:23)          ! phase
      data(id)(15:15)=text(20:20)          ! weight
      data(id)(17:17)=text(24:24)          ! polarity
      data(id)(19:20)=text(27:28)          ! hour
      data(id)(21:22)=text(30:31)          ! min
      data(id)(24:28)=text(33:37)          ! sec
      data(id)(64:68)=text(45:49)          ! residual
      read(text(7:12),'(f6.1)') dist       ! distance
      read(text(40:42),'(f3.1)')w
      iw=w*10
      if(iw.gt.99) iw=99
      write(data(id)(69:70),'(i2)') iw
      idist=dist+0.5
c
c
      write(data(id)(71:75),'(i5)') idist
      data(id)(77:79)=text(15:17)          ! azimuth
c
c  S-phase
c
      read(1,'(a)',end=99) text
c
      if(text(22:23).eq.' ') goto 20    ! next station
      id=id+1
      do i=1,80
        data(id)(i:i)=' '
      enddo
c
      data(id)(2:5)=data(id-1)(2:5)              ! station, same as before
      data(id)(7:8)='SZ'
      data(id)(10:11)=text(22:23)          ! phase
      data(id)(15:15)=text(20:20)          ! weight
      data(id)(17:17)=text(24:24)          ! polarity
      data(id)(19:20)=text(27:28)          ! hour
      data(id)(21:22)=text(30:31)          ! min
      data(id)(24:28)=text(33:37)          ! sec
      data(id)(64:68)=text(45:49)          ! residual
      read(text(7:12),'(f6.1)')coda         ! coda
      if(coda.gt.0.0) then
        icoda=coda+0.5
        write(data(id-1)(30:33),'(i4)') icoda
      endif
      read(text(40:42),'(f3.1)')w
      iw=w*10
      if(iw.gt.99) iw=99
      write(data(id)(69:70),'(i2)') iw
      idist=dist+0.5
c
c
      write(data(id)(71:75),'(i5)') idist
      data(id)(77:79)=data(id-1)(77:79)    ! azimuth same as before
c
c   next phase
c
      goto 20

 99   continue
c
c   list files not found
c
      if(nwav.ne.0) then
         write(6,*)
         write(6,*) ' Number of S-files with wav-files ', iwav
         write(6,*) ' Wav files not found'
         do i=1,nwav
            if(wav_used(i).eq.0) write(6,'(2x,i4,2x,5i3)')
     *      wyear(i),wmonth(i),wday(i),whour(i),wmin(i),wsec(i)
         enddo
         write(6,*)
      endif

      write(6,*)' Number of events converted', nevent
      write(6,*) 'Output file name is rsanor.out'
      stop
      end 

c     swap routines     j. havskov, 1998
c

      subroutine swap4(nsamp,data)
c
c   routine to swap 4 byte data
c
      implicit none
      integer*4 data(*)         ! data to be swapped
      integer nsamp             ! number of values
      character*1 swap(4),s(4)
      integer*4   x,i,k
      equivalence (x,swap)
c
      do i=1,nsamp
        x=data(i)
        do k=1,4
           s(k)=swap(k)
        enddo
        swap(1)=s(4)
        swap(2)=s(3)
        swap(3)=s(2)
        swap(4)=s(1)
        data(i)=x
      enddo
      return
      end



      subroutine swap4_one(data)
c
c   routine to swap 4 byte data, one value
c
      implicit none
      integer*4 data            ! data to be swapped
      character*1 swap(4),s(4)
      integer*4   x,k
      equivalence (x,swap)
c
        x=data
        do k=1,4
           s(k)=swap(k)
        enddo
        swap(1)=s(4)
        swap(2)=s(3)
        swap(3)=s(2)
        swap(4)=s(1)
        data=x
      return
      end
      
      
      subroutine swap2(nsamp,data)
c
c   routine to swap 2 byte data
c
      implicit none
      integer*2 data(*)         ! data to be swapped
      integer nsamp             ! number of values
      character*1 swap(2),s(2)
      integer*2   x,i,k
      equivalence (x,swap)
c
      do i=1,nsamp
        x=data(i)
        do k=1,2
           s(k)=swap(k)
        enddo
        swap(1)=s(2)
        swap(2)=s(1)
        data(i)=x
      enddo
      return
      end

      subroutine swap2_one(value)
c
c   swap two bytes
c
      implicit none
      integer*2 value,i
      character*2 a2
      character*1 a1
c
      equivalence (a2,i)
c
      i=value
      a1=a2(1:1)
      a2(1:1)=a2(2:2)
      a2(2:2)=a1
      value=i
      return
      end
        

      subroutine swap4r(nsamp,data)
c
c   routine to swap 4 byte data
c
      implicit none
      real*4 data(*),x          ! data to be swapped
      integer nsamp             ! number of values
      character*1 swap(4),s(4)
      integer*4   i,k
      equivalence (x,swap)
c
      do i=1,nsamp
        x=data(i)
        do k=1,4
           s(k)=swap(k)
        enddo
        swap(1)=s(4)
        swap(2)=s(3)
        swap(3)=s(2)
        swap(4)=s(1)
        data(i)=x
      enddo
      return
      end

c   program to pick in automatic mode several eventd from 
c   data base.                  
c                                                                      
c   jens havskov, mar 92                                             
c                                                                  
c   uppdates                                                      
c   jul 8 93 by jh: VERSION 3.0
c   aug 23        : filename to 80 char, data to 400
c   nov 24, 1994   : opening files changed
c   dec 7           ************    version 5.0 *****************
c   jan 11   95   : new find ev in
c   nov 16 98 jh  : --------------   version 7.0 check----------------------
c                   start_time to 14, system-c to systemc
c                                                                   
       implicit none	
C
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code                   ! Error handler.
       integer  code,                      ! Local condition.
     &          read1                      ! Read unit 1.
       logical  b_old                      ! File is old file?
C
C    ============= end of list ==========
C
       include 'seidim.inc'                                                
c-- event data                                     
       character*80	data(max_data)	
c-- exp indicator                                         
       character*1	exp		
c-- event type                                      
       character*1      type		
c-- number of recors for event                           
       integer		nrecord		
c-- number of header lines                                 
       integer		nhead		
c-- number of stations                                     
       integer		nstat		
c-- number of phases
       integer nphase
c-- start and end time of select      
       character*14    start_time,end_time 
c-- data base name if not rea (blank)               
       character*40	base_name	
c-- event file name                                   
       character*80	evfile		
c-- select key                                       
       character*10     key		
c-- see subroutine find...       
       integer		status,new_month,fstart,event_no 
c-- counters for events, records etc.      
       integer nr,nd,nl,records,nevent	
c-- id line 
       integer id
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c                                             
c   input base name and time interval                                      
c                                                                               
       write(6,*)' Base name, return for default'                               
       read(5,'(a40)') base_name                                                
       write(6,*)' Start time'                                                  
       read(5,'(a14)') start_time                                               
       write(6,*)' End time, return for end of month'                           
       read(5,'(a14)') end_time                                                 
 1     continue                                                                 
	                                                                    
c                                                                               
c  reset counters                                                               
c                                                                               
       nl=0                                                                     
       nr=0                                                                     
       nd=0                                                                     
       nevent=0                                                                 
       records=0                                                                
c                                                                               
c  start event loop                                                    
c                                                                               
 5     continue                                                                 
c-- always use next event                                
       key='          '		
       CALL findevin                                                       
     * (base_name,start_time,end_time,key,0,                                   
     * event_no,evfile,fstart,new_month,status)                                 
       if(status.eq.0) then                                                     
       call sei open(old$+warn$,            ! Open & warn of error.
     &               ' ',                   ! Prompt file name (n/a).
     &               evfile,                ! File name
     &               read1,                 ! Read unit #1
     &               b_old,                 ! Already exists? (n/a).
     &               code)                  ! Returned condition.
C
         if( b_old ) then                   ! File exists & is open.
         call indata(read1,nstat,nphase,
     &               nhead,nrecord,type,exp,data,id)              
c                                                                               
c   count events etc                                                            
c                                                                               
         if(type.eq.'L') nl=nl+1                                              
         if(type.eq.'R') nr=nr+1                                              
         if(type.eq.'D') nd=nd+1                                              
         records=records+nrecord                                              
         nevent=nevent+1                                                      
c
c   only process event if no readings from before
c          
           if(nstat.lt.1) then
           write(6,'(1x,a60,a)') evfile(1:60),' picking phases'
           call put_env_event(evfile)
           call systemc("autopic",7)
C
           else
           write(6,'(1x,a60)') evfile(1:60)                                      
           call sei close (close$,read1,code)
           endif
         endif                                                     
c-- back for next event                                         
         goto 5			
       else                                                                     
c-- 3 is end of time period                       
       if(status.ne.3)       
     * write(6,*)' ****** Something wrong, status= ', status                 
       endif                                                                    
c
c blank out name
c
       call put_env_event('     ')
c                                                                               
c  print out statistics                                                         
c                                                                               
      write(6,*)                                                                
c     write(6,200) outfile                                                      
c200  format(' Output file is:   ',a40)                                         
      write(6,*)                                                                
      write(6,201) nevent,nl,nr,nd,records                                      
 201  format(' Total number of events          ',i7,                            
     *     /,' Total number local events       ',i7                             
     *     /,' Total number of regional events ',i7                             
     *     /,' Total number of distant events  ',i7                             
     *     /,' Total number of records         ',i7)                            
      stop                                                                      
      end

C
C   PROGRAM TO DELTE FILES USING LIST OF FILE CREATED WITH DIRF
C
C   JENS HAVSKOV     LAST UPDATE AUGUST 14, 1987
c   
c   sep 11 92 by j.h. : unix version
c   jan 8, 2003 jh : also delete all files in filenr.lis or index file
C
C

      IMPLICIT NONE		
      CHARACTER*1	ANSWER	
      CHARACTER*80      FILE,file1
      CHARACTER*80	QUESTION
      logical 		del_all


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      del_all=.false.
      write(6,*) ' Give name of index file to delete all, else return'
      read(5,'(a)') file
      if(file.ne.' ') del_all=.true.


C
C   LOOP TO DELETE FILES
C

C
C     INPUT FILENAME TO DELETE if not all deleted
C
      if(.not.del_all) then
 1       continue
         QUESTION='  FILE NUMBER TO DELETE, ? TO GET LIST'
         CALL FILENAME(QUESTION,FILE)	
         IF(FILE.EQ.'EOF') GO TO 5		
         WRITE(6,*)
         WRITE(6,205)FILE
 205     FORMAT('  SURE YOU WANT TO DELETE FILE (Y/N): ',A60)
         READ(5,'(A1)') ANSWER
         IF(ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y') THEN
            OPEN(1,FILE=FILE,STATUS='OLD')
            CLOSE(1,STATUS='DELETE')
            WRITE(6,200) FILE
 200        FORMAT('  FILE DELETED: ',A60)
         ENDIF
         GO TO 1
      else                                  ! all deleted
         open(1,file=file,status='old')
 2       continue
         read(1,'(7x,a)',end=5) file1
         if(file1.eq.' ') goto 5
         open(2,file=file1,status='old',err=3)
         close(2,status='delete')
         write(6,'(1x,a,a)')'Deleted: ',file1(1:60)
         goto 4
 3       continue 		
         write(6,'(1x,a,a)')'Not present: ',file1
         stop
 4       continue
         goto 2
      endif
C
 5    CONTINUE
      ENd

c
c    transform Willy Lee binary files to seisan  data files
c
c    M. Villagran and J. Havskov, Dec 1991
c
c
c
c  this progrma has some problems on sun with what is written in bianry file
c
c    latest update
c    april 93 fix up, check on pc
c    august 93 by jh: filename to 80 chars
c    sep 99 jh change to 7, only change call to computer type
c    may 11  00    lo : use read_resp_head
c
       implicit none
c-- seisan  data file channel header
      character*1040    chahead
c-- -------------------main --------
      character*960     mainhead
c-- output file name
      character*80	outfile		
c-- save part of header
      character*50      save_head	
c-- data vector, input
      integer*2		data(50000)	
c-- input file name
      character*80 infile
c-- question
      character*80 question
c-- number of channels
      integer nchan
c-- total time window
      real              total_time	
c-- help variables
      integer		i,k,in,j
      logical pc,sun,linux
c
c special variables from old wl routine
c
      integer mblo,iscan,ichan,no,nblock,mi,me
      real srate,xrate
      integer imue,iblock
      CHARACTER*4   STAT(16)
      CHARACTER*20  fecha
      INTEGER*2     ZBU2(256)
      INTEGER*2     ILENGHT,SCAN,MAGIC
      character*512 buf
      character*2   sw2
      character*1 b1,b2	   
      character*4   sw4	  	  
      integer*2 i2
      integer*4 i4	  	  
      real re	  
      equivalence   (sw2,i2),(sw4,i4),(sw4,re),(buf,zbu2)	  


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

        call computer_type(sun,pc,linux)
c
C -------------------------------------------------------------------
C       Section to read w. lee files.
C
C        INPUT          The input file is a binary file with
C                       blocks of 512 bytes. This file is the
C                       Version 1.0 output file from Willie Lee
C                       seismic detection system.
C
C        OUTPUT         The output file is a seisan  
c                       binary file
C -------------------------------------------------------------------
c
c  get file name
c
       question='  Filename, ?, or number'
       call filename(question,infile)

c
c  check for no files 
c
      if(infile(1:3).eq.'EOF') stop
c
c   check which type of input file
c
      in=0
      if(infile(1:10).eq.'filenr.lis')then
         open(8,file='filenr.lis',status='old')
         in=1
      endif
c
c  back here if many binary files to convert using filenr.lis
c
 10   continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         write(6,'(1x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
c
c  open  binary willy lee file
c
c          i=index(infile,' ')-1
          OPEN(2,FILE=infile,ACCESS='DIRECT',
     +        RECL=512,STATUS='OLD')
C
C  question about the time of the earthquake in transform process.
C
        write(6,*)' Please give the date of the ',
     +  'earthquake'
        write(6,*)
     * 'YR MO DY HR MN SS.SS (91 12 24 23 59 11.21 is an example)'
        read(5,'(a20)')fecha
        write(6,*)' Sample rate, if 0, 100.81 is used'
        read(5,*) xrate
        srate=xrate
        if(xrate.eq.0.0) srate=100.81
c
c ----    Read first and second blocks
c
c
c   this section not really used since values are hardwired below
c
           sw2=buf(1:2)
           magic=i2
           sw2=buf(3:4)
           ilenght=i2
           sw2=buf(5:6)
           scan=i2
           sw4=buf(7:10)
c           srate=re
c           write(6,*)  magic,ilenght,scan,srate
           magic=255
c           ilenght=1024
c
c  this was different before
c
           ilenght=512
           scan=16
c
c   get stations
c		   
           k=139		   
           do i=1,16
             stat(i)=buf(k:k+3)		   		   
             k=k+24			 
           enddo			 
c
c   read next buffer of header
c		   
           read(2,rec=2) buf
C
C ---      STOP IF THE VERSION IS WRONG should be 1.0
C 255 is a parameter defined by the W. Lee data acquisition
C
           IF (MAGIC.NE.255) THEN
               PRINT*,'   ****   WRONG FORMAT VERSION  **** '
               PRINT*,'   ****      SKIP OR FINISH     **** '
            END IF
           IF(MAGIC.NE.255)stop
		   
c
c  make file name to pc or sun
c
        if(sun)then
c-- year
         outfile(1:2)=fecha(1:2)
c-- month
         outfile(3:4)=fecha(4:5)		
         outfile(5:5)='-'
c-- day
         outfile(6:7)=fecha(7:8)		
         outfile(8:8)='-'
c-- hr
         outfile(9:10)=fecha(10:11)		
c-- min
         outfile(11:12)=fecha(13:14)		
         outfile(13:13)='-'
c-- sec
         outfile(14:15)=fecha(16:17)		
         outfile(16:17)='S.'
c-- network or station code
         outfile(18:20)='UCR'		
         outfile(21:21)='_'
c-- number of channels
         outfile(22:23)='16'
c-- check for blanks
         do 188 i=1,23
            if(outfile(i:i).eq.' ') outfile(i:i)='0'
188      continue
         write(6,200) outfile(1:23)
 200     format(/,' Output file name is: ',a23)
      endif
c
c  make filename if on pc, is shorter than vax and sun
c
         if(pc) then
c-- year
            outfile(1:2)=fecha(1:2)
c-- month
            outfile(3:4)=fecha(4:5)		
c-- day
            outfile(5:6)=fecha(7:8)		
c-- hr
            outfile(7:8)=fecha(10:11)
	    outfile(9:9)='.'		
c-- min
            outfile(11:12)=fecha(13:14)		
c-- network or station code
            outfile(10:10)='L'		
c-- check for blanks
            do 189 i=1,12
               if(outfile(i:i).eq.' ')outfile(i:i)='0'
189         continue
            write(6,207) outfile(1:12)
 207        format(/,' Output file name is: ',a12)
         endif
c
        i=index(outfile,' ')-1
        open(9,file=outfile(1:i)
     * ,form='unformatted',status='unknown')
c
c   construct  main header
c
         do 190 i=1,960
           mainhead(i:i)=' '
190      continue
         mainhead(2:18)='                 '
         mainhead(1:23)=outfile(1:23)
c-- no of channels
         mainhead(32:33)='16'		
c-- year, date and time
         mainhead(35:36)=fecha(1:2)
         mainhead(42:43)=fecha(4:5)
         mainhead(45:46)=fecha(7:8)
         mainhead(48:49)=fecha(10:11)
         mainhead(51:52)=fecha(13:14)
         mainhead(55:59)=fecha(16:20)
         j=162
         k=51
         nchan=16
C
C --- CALCULATE PARAMETERS TO READ THE WAVE FORM DATA
C
C     MBLO  = BLOCKS OF 256 WORDS PER BUFFER
C     ISCAN = BLOCKS TO SKIP TO GET TO THE NEXT BUFFER OF SAME CHANNEL
C

        MBLO = ILENGHT/256
        ISCAN = SCAN*MBLO

C
C ---  get time inside binary Lee file
C
C               this step is missing until now,
C               the program only works if you
C               give the date
			 
C-----------------------------------------------------------------
C ----     Read seismic data and write out in loop
C-----------------------------------------------------------------
c
         do ichan=1,16
             imue = 0
             iblock = 3 + (ICHAN-1)*MBLO
             do 130 no = 1,1000
                nblock = iblock + (mblo-1)
                do 120 mi = iblock,nblock
                    read(2,rec=mi,err=140) buf
c
c   do byte swap if on sun
c	
                    if(sun) then
                       do i=1,511,2
                         b1=buf(i:i)
                         b2=buf(i+1:i+1)
                         buf(i:i)=b2
                         buf(i+1:i+1)=b1				   
                       enddo
                    endif					    						 
                    do 110 me = 1,256
                        imue = imue + 1
                        data(imue) = zbu2(me)-2048
 110                continue
 120             continue
                 iblock = iblock+iscan
 130          continue
 140          continue
c
c   write main header if this is first channel, must be done here since
c   number of samples is not given in wl main header
c
         if(ichan.eq.1) then
            total_time=imue/srate	
            write(mainhead(61:69),'(f9.3)') total_time
            do 191 i=1,nchan
c--  station and component
               mainhead(j:j+3)=stat(i)
               mainhead(j+4:j+7)='S  Z'	
               mainhead(j+8:j+8)=' '
c-- rel. start time of channel
               mainhead(j+9:j+15)='    0.0'	
               write(mainhead(j+17:j+24),'(f8.2)') total_time
               if(i.eq.3.or.i.eq.6.or.i.eq.9.or.i.eq.12.or.i.eq.15.
     *         or.i.eq.18.or.i.eq.21.or.i.eq.24.or.i.eq.27.or.i.eq.30)
     *         then
                 j=j+28
               else
                 j=j+26
               endif
               k=k+11
191         continue
c
c   write  main header
c
            k=1
            do 192 i=1,12
               write(9)mainhead(k:k+79)
               k=k+80
192         continue
          endif

 
c
c   make channel header and write
c
            do 196 i=1,1040
               chahead(i:i)=' '
196         continue
            j=(ichan-1)*11+51
c-- station code
            chahead(1:4)=stat(ichan)		
c-- component
            chahead(6:9)='S  Z'	
c-- year, date and time
            chahead(11:35)=mainhead(35:59)		
            write(chahead(37:43),'(f7.2)')srate
c-- number fo samples			
            write(chahead(45:50),'(i6)') IMUE
c
c   get response, save date etc since removed when calling read_resp
c
            call read_resp_head(chahead)
c
c   write header
c
             write(6,'(1x,a60)') chahead(1:60)
             write(9) chahead
c
c   write data
c
             write(9)(DATA(I),I=1,imue)
          enddo
    	close(9)
        close(2)

        if(in.eq.1)goto 10
c----------------------------------
c end channel loop
c-----------------c		  
c
c
        STOP
        end

                                                                                
********************************************************************
      subroutine auto_filename(filename,iport,sfile)
c
c     routine to get the tracedata filename from s-file
c     Filename is assumed to be in a type 6 line in the s-file.
c     The s-file to extract the filename from can either be found in
c     enviromental memory, or it can be read directly.
C     Input:
c       filename: normally blank, if '01' use first waveform file, no question
c       iport
c	if  iport = 0 the s-file is found in 'transfer.idx'
c	if  iport .ne. 0 the s-file is read on iport. It is then assumed
c                         that the s-file is opened outside this routine.
c       if no index.temp file is present, sfile is returned as 'NOINDEX'
c
c     Output:
c       filename
c       sfile name
c
c     written by C. Lindholm, Dec. 1988.
c     Updates:
c            Nov. 25; C. L. ; Change from next line indicator to this lien indicator in S file
c            Jul  20  jh    ; bug
c            nov 9          : filenames to 15
c            feb 21 93      : filenames to 80, only close nport if iport=0
c            aug 22         : fix some reads to make all 80 chars with filenames
C!JAB(BGS)Dec94             : Install error and file handling
c             jan 95        *************   version 5.0 ************
C!JAB(BGS)Mar95             : Prevent core crashing if invalid preference     
c jh aug 96                 : put in to select first wav file if many
c jan 97 jh                 : dimention of filenames from 15 to 50
c sep 98 jh                 : -------------- version 7.0 check -------------
c                             no change
c
c-- name of tracedatafile
      character*80 filename
c-- name of S file
      character*80 sfile
c-- name of tracedatafile
      character*80 filenames(50)
c-- record cards
      character*80 card(200)
c-- port to read from
      integer iport
c
      integer   kk, nport, j, number       ! Missing variables.
C
C    Seisan library inserts and routines...
C    ======================================
C
       include  'libsei.inc'               ! Library definitions & data defns.
       external  sei code,                 ! Error encoder.
     &           sei integer,              ! Get integer.
     &           sei close,                ! Close file opened by...
     &           sei open                  ! Open file handler.
       integer   sei integer               ! & function.
       integer   code                      ! local condition
       character chr_text *(10)            ! Local text string.
       logical   b_flag                    ! Flag end of file or existance.
C
C    ============= end of list ==========
C
c
c    Initialise...
C    =============
C
      kk=0
      nport = iport                         ! Working file unit.
c
      if(iport.eq.0) then 
         call get_env_event(sfile)
         if(sfile(1:3).eq.'   '.or.ichar(sfile(1:1)).eq.0) then
            sfile='NOINDEX'                    ! Flag for output.
            goto 9999                          ! & return to caller.
         endif
         write(*,*)sfile
         call sei open( old$,
     &                  ' ',
     &                  sfile,
     &                  nport,
     &                  b_flag,
     &                  code )
       endif
c
c   read the file
c
40     read(nport,'(a80)',iostat=code)card(200)   ! Read a card!
       call sei code(fort$,code,nport,b_flag)     ! Process the outcome.
       if( b_flag               .or.              ! End of file!.
     &     card(200) .eq. ' ' ) then              ! Or pulled a blank.
       continue                                   !
c
       else if( card(200)(80:80).eq.'6' ) then    !
       kk=kk+1                                    !
       card(kk) = card(200)                       !
       goto 40                                    ! Next card.
c
       else                                       ! Otherwise.
       goto 40                                    ! Next card.
       endif                                      !
c
c-- No file found
c
      if(kk.eq.0)then                             ! Flag for return.
      filename='EOF'                              !
c      call sei close(close$,nport,code)           !
      goto 9999                                   ! Return to caller.
      endif

c-- More files found
      if(kk.gt.1)then
         if(filename.eq.'01') then  ! if only one, skip
            filename(1:59)=card(1)(2:60)
            goto 900
         endif
         write(6,'(a)')' More than one datafile:'
        do j=1,kk
         filenames(j)=card(j)
         write(6,'(1x,i2,2x,a)')j,filenames(j)(2:60)
        enddo
c
1111     write(*,*)                                !JAB(BGS)Mar95.
         write(6,'(a)')' Which do you prefer?'    
         read(5,'(a)') chr_text                    !JAB(BGS)Mar95.
         number = sei integer( chr_text, code )    !JAB(BGS)Mar95.
c
c     Invalid...
c
            if( code .ne. e_ok$ ) then             !JAB(BGS)Mar95.
            write(*,*)'****       ... try again...'!JAB(BGS)Mar95.
            goto 1111                              !JAB(BGS)Mar95.
c
            else if( number .lt. 1    .or.         !JAB(BGS)Mar95.
     &               number .gt. kk ) then         !JAB(BGS)Mar95.
            write(*,*)                             !JAB(BGS)Mar95.
            write(*,*)                             !JAB(BGS)Mar95.
     &'**** WARN: your choice is out of range ...try again ****'
            goto 1111                              !JAB(BGS)Mar95.
            end if                                 !JAB(BGS)Mar95.
         filename(1:59)=card(number)(2:60)
c-- One file found
      else
        filename(1:78)=card(kk)(2:79)
      endif
 900  continue
c
c   Close file if opened inside the this subroutine...
c
      if(iport.eq.0) call sei close(close$,nport,code)
c
c    Return to Caller...
c    ===================
c
9999  return
      end

c
C WKBJ.PRG - program WKBJ
C
c  
c   updates
c   aug 94 by jh : fix input and output units, do not use 5 and 6
c   april 97 jh  : ---------   version 7.0 check, no change ------------
C
C-----------------------------------------------------------------------
C Program to compute WKBJ seismograms.
C-----------------------------------------------------------------------
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation numbers refer to that paper.  See also:
C
C         Chapman, C.H., 1978.  Geophys. J. R. astr. Soc., 54, 481-518.
C         A new method for computing synthetic seismograms.
C
C         Dey-Sarkar, S.K. and Chapman, C.H., 1978.  Bull. Seism.
C         Soc. Amer., 68, 1577-1593.  A simple method for the
C         computation of body-wave seismograms.
C
C         Chapman, C.H. and Orcutt, J.A., 1985. Rev. Geophys., 23,
C         105-163.  The computation of body wave synthetic seismograms
C         in laterally homogeneous media.
C
C
C
C         Note this is a very simple program intended only to illustrate
C         the use of the routines PXINT, COMPON, COEFF, THETAC and
C         CCSQRT.  The user will obviously need to add plotting
C         routines and many other features to make the program user
C         friendly and suitable for his/her application and computer
C         system.  Suggested modifications are:
C
C         (a) make input of model, ray definitions, seismogram ranges,
C             etc. more versatile and interactive.  Use format free
C             input.
C         (b) write travel-time tables to file to allow repeated use for
C             seismograms in a standard Earth model.
C         (c) write seismograms to file for repeated use with different
C             source functions, etc.
C         (d) plot model, travel-time tables and seismograms.
C         (e) include source/receiver convolutions in this program and
C             avoid using CCSQRT if its smoothing is too severe.
C         (f) interpolate slowly varying coefficients, e.g. transmission
C             coefficients, to make program more efficient (transmission
C             coefficients can already be set to unity by omitting from
C             ray definition).
C         (g) compute coefficients for all dynamic groups together to
C             avoid repeating calculations in COEFF.
C         (h) smooth ends of amplitude table to reduce end-point errors
C             (this is a cosmetic improvement and may not be real).
C         (i) include SH rays as option.
C         (j) give source and receiver in geographic coordinates and
C             include coordinate transformation, i.e. radiation pattern.
C         (k) include attenuation in model and apply as an approximate
C             convolution operator.
C
C         NOTE THIS PROGRAM DOES NOTHING USEFUL WITH THE SEISMOGRAMS.
C         AT THE VERY LEAST, THE USER WILL WANT TO PLOT OR WRITE THE
C         SEISMOGRAMS.
C
C Calls: RAYIN, PXINT, COMPON, COEFF, coefh, compoh, THETAC, CCSQRT
C
C Errors: None.  Note it is assumed that the input parameters are all
C         defined sensibly and are compatible.  The user should include
C         appropriate checks on the input parameters to make the program
C         user friendly.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: C.H.Chapman
C
C Date: revised version, 28 July 1986
C
C Local variables:
C
      parameter (nnrays=20,nnptst=40000,nndept=200,nnpp=200,nnstat=10)
      parameter (nnint=20,nncomp=29)
      INTEGER ITRAY(nnrays),IL(nnint),NPS(2,nnint),ID(10,nnint),
     & JMIN(2),JMID(2),
     1 JMAX(2),INM,INR,IMTH,NMOD,I,J,N,ILAY,II,IRAY,NN,MULT,ISS,IRR,
     2 IT,NUM,ICNR,ICNS,JMIN1,JMIN2,JMID1,JMID2,JMAX1,JMAX2,NUM1,K,IRTR,
     3 I1,I2,KK,NX,NT,NT5,IR,M
      REAL VEL(6,nndept),SEIS(nnptst),PT(nncomp,nnpp,nnrays),
     & FREE(3),ONE,PI2,RSUR,XCONV,
     1 Y,YI,X,XI,A,B,Z,ZI,T,PMIN,PMID,PMAX,DP1,DP2,RSOR,RREC,PP,XSTRT,
     2 DX,TSTRT(nnstat),DT,XST(nnstat),TST,RANGE,SYSCL,SMAXX
c    2 DX,TSTRT(nnstat),DT,UAPPR,XST(nnstat),TST,RANGE,SYSCL,SMAXX
      COMPLEX CSEIS(nnptst+5),COMP(13),COEFF,coefh,AMP,CAMP
      LOGICAL LSPHR,LDEPTH,LPM,LRAY,lsh(nnrays),lsh0
      EQUIVALENCE (JMIN(1),JMIN1),(JMIN(2),JMIN2),(JMID(1),JMID1),
     1 (JMID(2),JMID2),(JMAX(1),JMAX1),(JMAX(2),JMAX2)
      DATA ONE/1.0000001/,PI2/1.570796/,FREE/0.,0.,0./
c
c     output unit
      iout=4
      open(iout,file='wkbj.out',status='unknown')
C
C Read in model parameters
C
C***********************************************************************
C
C (1) FORMAT (312,I4,2L2,F10.2)
C
C INM    , I2    , data set number for model input (see input (2))
C INR    , I2    , data set number for ray input (see input (3))
C
C IMTH   , I2    , controls interpolation of velocity model
C                  IMTH = 1 , v(z)=1./sqrt(a-2*b*z) (fastest)
C                  IMTH = 2 , v(z)=a-b*z
C                  IMTH = 3 , v(z)=a*exp(-b*z) equivalent to v(r)=a*r**b
C                  (see equation (13))
C
C NMOD   , I4    , number of points in model (see input (2) - storage
C                  must be at least NMOD+1)
C LSPHR  , L2    , = T for spherical model
C                  = F for flat model
C LDEPTH , L2    , = T to convert input data of depths to radii if
C                  LSPHR=T, or convert input data of heights to
C                  depths if LSPHR=F , using RSUR.
C                  = F for no conversions.
C RSUR   , F10.2 , radius of Earth (used if LDEPTH=T) and/or reference
C                  radius in Earth Flattening Transformation (used if
C                  LSPHR=T).
C
C***********************************************************************
C
c
c   hardwire input and output units and open
c
      inm=2
      inr=2
      open(2,file='wkbj.inp',status='unknown')
      open(3,file='wkbj.tab',status='unknown')
      READ (inm,1000) Ibid,MIbid,IMTH,NMOD,LSPHR,LDEPTH,RSUR
      write(3,'(2l2)') lsphr,ldepth
C
C read in model
C
C***********************************************************************
C
C (2) FORMAT (4F10.5) - NMOD records on data set number INM
C                       (see input (1))
C
C VEL(1,I) , F10.5 , radius , depth or height ) (see input (1) and
C                                             )  LSPHR, LDEPTH)
C VEL(2,I) , F10.5 , P wave velocity          )
C VEL(3,I) , F10.5 , S wave velocity          ) I=1,NMOD
C VEL(4,I) , F10.5 , density                  )
C
C The model should be ordered from the free-surface downwards.
C
C***********************************************************************
C
      READ (INM,1001) ((VEL(J,I),J=1,4),I=1,NMOD)
C
C Convert model to internal format - see PXINT
C
C Change coordinate direction
C
      IF (.NOT.LDEPTH) GO TO 1
      DO 2 I=1,NMOD
2     VEL(1,I)=RSUR-VEL(1,I)
C
C Conversion factor for horizontal coordinate.
C
1     XCONV=1.
      IF (LSPHR) XCONV=RSUR/57.29578
C
C Remove r=0 in spherical model and add dummy interface at bottom
C
      IF (LSPHR.AND.VEL(1,NMOD).EQ.0.) NMOD=NMOD-1
      N=NMOD+1
      DO 3 J=1,4
3     VEL(J,N)=VEL(J,NMOD)
C
C Loop to do Earth flattening transformation, convert to slownesses,
C find interfaces, compute interpolation coefficients, and print model.
C
      ILAY=0
      WRITE (3,1004)
      YI=VEL(1,1)
      DO 4 I=1,N
          Y=YI
          YI=VEL(1,I)
          A=VEL(2,I)
          B=VEL(3,I)
          IF (.NOT.LSPHR) GO TO 5
          X=RSUR/YI
          VEL(1,I)=RSUR*ALOG(X)
          VEL(2,I)=X*A
          VEL(3,I)=X*B
5         VEL(2,I)=1./VEL(2,I)
          IF (VEL(3,I).NE.0.) VEL(3,I)=1./VEL(3,I)
          IF (Y.NE.YI) GO TO 6
          ILAY=ILAY+1
          IL(ILAY)=I
          WRITE (3,1005) ILAY
          ZI=VEL(1,I)
          GO TO 4
C
C Interpolation coefficients
C
6         II=I-1
          Z=ZI
          ZI=VEL(1,I)
          DO 10 J=2,3
               X=VEL(J,II)
               XI=VEL(J,I)
C
C This test is introduced for a fluid layer (X=XI=0) but is also
C good for any method with a homogeneous interval (X=XI)
C
              IF (X.EQ.XI) GO TO 11
              GO TO (11,12,13),IMTH
11            VEL(J+3,II)=.5*(X-XI)*(X+XI)/(Z-ZI)
              GO TO 10
12            VEL(J+3,II)=(XI-X)/(Z-ZI)/X/XI
              GO TO 10
13            VEL(J+3,II)=ALOG(XI/X)/(Z-ZI)
C
10        CONTINUE
C
4     WRITE (3,1010) I,YI,ZI,A,VEL(2,I),B,VEL(3,I),VEL(4,I)
C
C At this point the user may want to plot the model.
C
C
C Travel time section.
C
      IRAY=0
C
C read ray definition
C
C***********************************************************************
C
C (3) Read ray definition on data set number INR (see input (1))
C
C See subroutine RAYIN for FORMAT of record(s).
C
C***********************************************************************
C
100   CALL RAYIN (NPS,ID,NN,MULT,ISS,IRR,LRAY,lsh0,INR)
      IF (.NOT.LRAY) GO TO 130
C
C New kinematic group.
C
      IF (IRAY.EQ.0) GO TO 102
C
C Print previous travel-time table.
C
C Note we can only print this now as we have been summing the amplitude
C functions of dynamic groups.
C
C We print the first component of the amplitude function C(p) to
C allow simple check on gradients and discontinuities.
C
      IT=ITRAY(IRAY)
      IF (IT.EQ.0) GO TO 103
      WRITE (3,1103)
      DO 110 I=1,IT
          T=PT(2,I,IRAY)+PT(1,I,IRAY)*PT(3,I,IRAY)
          PT(3,I,IRAY)=PT(3,I,IRAY)/XCONV
          WRITE (3,1110) PT(1,I,IRAY),T,PT(3,I,IRAY),PT(2,I,IRAY),
     1    PT(4,I,IRAY),PT(5,I,IRAY)
110   CONTINUE
C
102   IRAY=IRAY+1
      lsh(iray)=lsh0
103   IF (NN.EQ.0) GO TO 200
C
C read ray parameters
C
C***********************************************************************
C
C (4) FORMAT (3I4,3(I2,I4),3F10.5)
C
C NUM     , I4    , number of ray parameters in travel-time table
C ICNR    , I4    , receiver depth model index
C ICNS    , I4    , source depth model index
C                   These are the indices of the source and receiver
C                   positions in the model i.e. for the free surface
C                   we would have ICNR = ICNS = 1.  They correspond to
C                   the index I in input (2).
C
C The next 6 variables specify the range of ray parameters using a
C minimum, intermediate (see below) and maximum value.  They must be
C in increasing order.
C
C 2 methods can be used:
C
C    (a) specify the ray parameter using the model indices
C    (b) specify the ray parameter in s/km
C
C Either method can be used for the minimum, intermediate and
C maximum ray parameters.
C For method (a), the variables JMIN(2), JMID(2) and/or JMAX(2) are used,
C and for method (b), PMIN, PMID and/or PMAX are specified (and JMIN,
C JMID and/or JMAX are set zero).
C Using method (a), the ray parameter is set equal to a slowness in the
C model.  This may be used to specify the exact ray parameter for a
C grazing turning ray or a head wave, etc. without needing to enter the
C exact numerical value.  It is necessary to specify the slowness type
C and model index (corresponding to the index I in input (2)) to give
C the ray parameter. Thus:
C
C JMIN(1) , I2    , slowness type for minimum ray parameter
C                   (1=P ray , 2=S ray , 0 if method (b) is used)
C JMIN(2) , I4    , model index for minimum ray parameter
C                   (if method (a) is used)
C                   Then PMIN=1/VEL(JMIN(1)+1,JMIN(2)) where VEL is
C                   the input array from input (2).
C JMID(1) , I2    , as JMIN(1) for intermediate ray parameter
C JMID(2) , I4    , as JMIN(2) for intermediate ray parameter
C JMAX(1) , I2    , as JMIN(1) for maximum ray parameter
C JMAX(2) , I4    , as JMIN(2) for maximum ray parameter
C
C PMIN    , F10.5 , minimum ray parameter in s/km (if (b) is used)
C PMID    , F10.5 , intermediate ray parameter in s/km (if (b) used)
C PMAX    , F10.5 , maximum ray parameter in s/km (if (b) is used)
C
C The following is a description of the algorithm used to distribute
C the NUM ray parameters and the reasons behind the choice.
C The range of ray parameters, PMIN to PMAX, is sub-divided to give
C NUM points.
C In general the density of points is increased (as an inverse
C square root) near the intermediate and maximum ray parameters, PMID
C and PMAX, to sample the singularities in the reflection coefficient
C and/or range function better. If the intermediate ray
C parameter is a critical value, this allows the square root
C discontinuities of the reflection coefficient to be sampled
C better (on both sides of the critical value), and if the
C maximum ray parameter is a grazing value, this allows the
C singularity of X'(p) to be sampled better. The NUM points are
C divided between the 2 intervals so that near the intermediate
C value, points are approximately symmetric. The algorithm remains
C valid if the intermediate and maximum ray parameters are equal, when
C the density is increased near the maximum value.  If the minimum and
C intermediate ray parameters are equal, then a different algorithm
C is used and the ray parameters are distributed uniformly from
C PMIN=PMID to PMAX.
C
C Note the ray parameters will determine the ray type (see subroutine
C RAYIN). For p = 0. to the grazing value we will have a reflection,
C for p = grazing value to the maximum slowness in layer we will have a
C turning ray, and if p is greater than the maximum layer
C slowness, the ray will not exist and will be omitted from table.
C It is important that the user chooses the range of ray parameters
C sensibly for the ray under consideration as no corrections are made
C by the program.
C
C
C Repeat inputs (3) and (4) as required for different rays.
C Omit input (4) if LRAY=F on input (3), i.e. a new dynamic group is
C defined which is kinematically equivalent to previous ray. The same
C ray parameters will be used for all dynamic groups in a kinematic
C group and the amplitudes are summed.
C
C
C (5) FORMAT (L1,I3) - to end travel-time calculations
C
C LRAY , L1 , must be T (.TRUE.)
C NN   , I3 , must be 0
C
C***********************************************************************
C
      READ (inm,1111) NUM,ICNR,ICNS,JMIN,JMID,JMAX,PMIN,PMID,PMAX
C
C p range - use ONE to avoid rounding errors putting limiting rays
C out of range.
C
      IF (JMIN1.NE.0) PMIN=VEL(JMIN1+1,JMIN2)*ONE
      IF (JMID1.NE.0) PMID=VEL(JMID1+1,JMID2)
      IF (JMAX1.NE.0) PMAX=VEL(JMAX1+1,JMAX2)/ONE
C
C Interpolation of p range.
C
      LPM=PMIN.GE.PMID
      IF (LPM) GO TO 111
C
C Cosine interpolation from PMIN to PMID , and PMID to PMAX (LPM=F)
C
      NUM1=IFIX(ONE*FLOAT(NUM-1)/(1.+SQRT(2.*AMAX1(0.,PMAX-PMID)/
     1 (PMID-PMIN))))+1
      NUM1=MIN0(NUM,MAX0(2,NUM1))
      DP1=PI2/FLOAT(NUM1-1)
      IF (NUM1.LT.NUM) DP2=PI2/FLOAT(NUM-NUM1)
      GO TO 120
C
C Linear interpolation from PMIN=PMID to PMAX (LPM=T)
C
111   DP1=(PMAX-PMIN)/FLOAT(NUM-1)
      NUM1=NUM
C
C Set up travel-time table - zero amplitude
C
120   ITRAY(IRAY)=NUM
      DO 121 I=1,nnpp
      DO 121 J=4,nncomp
          PT(J,I,IRAY)=0.
121   CONTINUE
      RSOR=VEL(1,ICNS)
      RREC=VEL(1,ICNR)
      IF (.NOT.LSPHR) GO TO 122
      RSOR=RSUR*EXP(-RSOR/RSUR)
      RREC=RSUR*EXP(-RREC/RSUR)
122   WRITE (3,1122) RSOR,ISS,RREC,IRR
C
C New kinematic or dynamic group set up - compute table
C
130   NUM=ITRAY(IRAY)
      IT=1
      WRITE (3,1130) LRAY,MULT,(K,NPS(1,K),NPS(2,K),(ID(J,K),J=1,10),
     1 K=1,NN)
      IF (NUM.EQ.0) GO TO 100
      DO 131 I=1,NUM
          IF (.NOT.LRAY) GO TO 140
C
C Compute p value
C
          IF (I.EQ.NUM) GO TO 132
          IF (LPM) GO TO 133
          IF (I.LT.NUM1) GO TO 134
          PP=PMID+(PMAX-PMID)*COS(FLOAT(NUM-I)*DP2)**2
          IF (I.EQ.NUM1) PP=PMID
          GO TO 135
134       PP=PMIN+(PMID-PMIN)*COS(FLOAT(NUM1-I)*DP1)
          IF (I.EQ.1) PP=PMIN
          GO TO 135
132       PP=PMAX
          GO TO 135
133       PP=PMIN+FLOAT(I-1)*DP1
C
C Compute tau(p) and X(p)
C
135       CALL PXINT (PP,VEL,6,IL,NPS,NN,IMTH,
     1                PT(2,IT,IRAY),PT(3,IT,IRAY),IRTR)
          PT(1,IT,IRAY)=PP
C
C Test return - note IT used to count rather than I
C
          GO TO (140,131),IRTR
C
C Now do dynamic properties
C
140       PP=PT(1,IT,IRAY)
c
c ...................P-SV waves
C
C Free surface coefficients and multiplicity
C
          AMP=COEFF(PP,FREE,VEL(2,1),ID)
          AMP=CMPLX(FLOAT(MULT)*REAL(AMP),FLOAT(MULT)*AIMAG(AMP))
C
C Loop over interface coefficients
C
          DO 141 J=2,NN
              I1=IL(J)
              I2=I1-1
              AMP=AMP*COEFF(PP,VEL(2,I2),VEL(2,I1),ID(1,J))
141       CONTINUE
C
C Source and receiver components.
C
          CALL COMPON (PP,VEL(2,ICNS),ISS,VEL(2,ICNR),IRR,COMP)
          KK=3
C
C Add to previous amplitude
C
          DO 142 K=1,10
              CAMP=AMP*COMP(K)
              KK=KK+1
              PT(KK,IT,IRAY)=PT(KK,IT,IRAY)+REAL(CAMP)
              KK=KK+1
              PT(KK,IT,IRAY)=PT(KK,IT,IRAY)+AIMAG(CAMP)
142       CONTINUE
c
c ...................  SH waves
          if (lsh(iray))  then
C
C Multiplicity (Free surface reflection=1.; no need to calculate)
C
          AMP=cmplx(1.,0.)
          AMP=CMPLX(FLOAT(MULT)*REAL(AMP),FLOAT(MULT)*AIMAG(AMP))
C
C Loop over interface coefficients
C
          DO 151 J=2,NN
              I1=IL(J)
              I2=I1-1
              AMP=AMP*COEFH(PP,VEL(2,I2),VEL(2,I1),ID(1,J))
151       CONTINUE
C
C Source and receiver components.
C
          CALL COMPOH (PP,VEL(2,ICNS),ISS,VEL(2,ICNR),IRR,COMP(11))
C
C Add to previous amplitude
C
          DO 152 K=11,13
              CAMP=AMP*COMP(K)
              KK=KK+1
              PT(KK,IT,IRAY)=PT(KK,IT,IRAY)+REAL(CAMP)
              KK=KK+1
              PT(KK,IT,IRAY)=PT(KK,IT,IRAY)+AIMAG(CAMP)
152       CONTINUE
c
          endif
C
C Increment table count
C
          IT=IT+1
C
131   CONTINUE
C
      ITRAY(IRAY)=IT-1
      GO TO 100
C
C Seismogram section.
C
C At this point the user may want to plot the travel-time tables or
C to write them to a file.
C
200   CONTINUE
C
C Input seismogram parameters
C
C**********************************************************************
C
C (6) FORMAT (2(2F8.2,I4),F10.5)
C
C The units of the variables are degrees if LSPHR=T and km if LSPHR=F
C
C XSTRT , F8.2  , initial range in degrees or km
C DX    , F8.2  , range step in degrees or km (should be non-zero
C                 even if NX=1)
C NX    , I4    , number of ranges
C TSTRT , F8.2  , initial time of seismogram at XSTRT in sec
C DT    , F8.2  , time step of discrete seismogram in sec
C NT    , I4    , number of points in time series
C UAPPR , F10.5 , reducing slowness in s/deg or s/km used to shift
C                 initial time point of successive seismograms by
C                 DX*UAPPR
C
C***********************************************************************
C
c     READ (5,1200) XSTRT,DX,NX,TSTRT,DT,NT,UAPPR
c  modif VM. to accomodate more varied source-station distances 
      READ (inm,1201) NX,(XST(I),I=1,NX)
      READ (inm,1202) (TSTRT(I),I=1,NX)
      READ (inm,1203) DT,NT
      NT5=NT+5
C
C Loop over ranges
C
      DO 201 I=1,NX
c         XST=XSTRT+FLOAT(I-1)*DX
c         TST=TSTRT+(XST-XSTRT)*UAPPR
          TST=TSTRT(I)
          RANGE=XST(I)*XCONV
C
C Loop over 13 components
C
          DO 210 K=1,13
              KK=K+K+2
C
C Zero seismogram
C
              DO 211 J=1,NT5
                  CSEIS(J)=CMPLX(0.,0.)
211           CONTINUE
C
C Loop over kinemtic groups
C
c  modif by V. Maupin, May 1994: changed IRAY into IRAY-1 in loop 212
              DO 212 IR=1,IRAY-1
                  CALL THETAC (PT(1,1,IR),PT(2,1,IR),PT(KK,1,IR),
     1                         ITRAY(IR),nncomp,RANGE,TST,DT,NT,CSEIS)
212           CONTINUE
C
C Hilbert transformation in spherical model - see
C Chapman, C.H., 1979. On impulsive wave propagation in a spherically
C symmetric model, Geophys. J. R. astr. Soc., 58, 229-234.
C
              IF (.NOT.LSPHR) GO TO 230
              M=MOD(IFIX(XST(I)/180.),4)
              IF (M.EQ.0) GO TO 230
              IF (M.EQ.2) GO TO 220
C
C Multiply by (0.,-1.) if M=1 or 3 .
C
              DO 221 J=1,NT5
                  CSEIS(J)=CMPLX(-AIMAG(CSEIS(J)),REAL(CSEIS(J)))
221           CONTINUE
              IF (M.EQ.1) GO TO 230
C
C Multiply by -1. if M=2 or 3 .
C
220           DO 222 J=1,NT5
                  CSEIS(J)=-CSEIS(J)
222           CONTINUE
C
C Do convolution with d/dt Im( 1/sqrt(t) *
C
230           CALL CCSQRT (CSEIS,NT,SEIS)
C
C Range, thetac, ccsqrt and constant factors.
C Normalize by 1/12/sqrt(DT*X) = DT/(6*SQRT(DT))/(2*DT)/SQRT(X).
C DT is to make pulse amplitude independent of DT (true amplitude
C inversely proportional to DT as pulse width proportional to DT).
C Factor 1/(6*SQRT(DT)) from subroutine CCSQRT.
C Factor 1/(2*DT) from subroutine THETAC.
C
              IF (.NOT.LSPHR) SYSCL=12.*SQRT(RANGE*DT)
C
C Additional normalization in spherical model:
C R**2                  from Legendre transform,
C 1/RSOR                from WKBJ at source,
C 1/R                   from WKBJ at receiver,
C 1/SQRT(R*SIN(THETA))  from Legendre function,
C (RSUR/RSOR)**3/2      from EFT of slowness at source,
C (RSUR/R)**1/2         from EFT of slowness at receiver,
C (RSUR/R)**3/2         from EFT of horizontal slowness in integral,
C SQRT(RSUR**7/RSOR**5/R**3/SQRT(THETA)) total.
C
C Note the force source only has:
C (RSUR/RSOR)**1/2      from EFT of slowness at source,
C SQRT(RSUR**5/RSOR/R**3/SQRT(THETA)) total.
C
C See Chapman, C.H. and Orcutt, J.A., 1985.  The computation of body
C wave synthetic seismograms in laterally homogeneous media, Rev.
C Geophys., 23, 105-163.
C
              IF (LSPHR) SYSCL=12.*(RSOR/RSUR)**2*RREC*
     1        SQRT(ABS(SIN(RANGE/RSUR))*RSOR*RREC*DT/RSUR)/RSUR
C
C Scale seismogram and find maximum
C
              SMAXX=0.
              DO 231 J=1,NT
                  SEIS(J)=SEIS(J)/SYSCL
                  SMAXX=AMAX1(SMAXX,ABS(SEIS(J)))
231           CONTINUE
              WRITE (3,1231) XST(I),K,TST,SMAXX
C
C At this point the user will want to plot the seismogram, write to
C a file, or combine various source components
C
              write (iout,1240) i,xst(i),k,tst,dt,nt,smaxx
              write (iout,1241) (seis(j),j=1,nt)
C
C End of loop over components
C
210       CONTINUE
C
C End of loop over ranges
C
201   CONTINUE
C
      STOP
C
1000  FORMAT (3I2,I4,2L2,F10.2)
1001  FORMAT (4F10.5)
1004  FORMAT ('1EARTH MODEL'/' INPUT DEPTH  INTERNAL  P VELOCITY P SLOWN
     1ESS S VELOCITY S SLOWNESS DENSITY'/' OR RADIUS KM DEPTH KM',8X,
     2 'KM/S',7X,'S/KM',7X,'KM/S',7X,'S/KM MG/M**3')
1005  FORMAT (' INTERFACE',I3)
1010  FORMAT (I4,F8.2,F10.2,F8.3,G14.6,F8.3,G14.6,F8.3)
1103  FORMAT ('0P S/KM',11X,'T(P) S',9X,'X(P) KM OR DEG TAU(P) S',
     1 7X,'AMPLITUDE')
1110  FORMAT (G13.5,3F15.4,2G11.3)
1111  FORMAT (3I4,3(I2,I4),3F10.5)
1122  FORMAT ('1RAY DEFINITION'/' SOURCE DEPTH/RADIUS',F10.2,' TYPE',
     1 I3,' RECEIVER DEPTH/RADIUS',F10.2,' TYPE',I3)
1130  FORMAT (' KINEMATIC GROUP',L2,' MULTIPLICITY',I3/15X,
     1 'NP NS P1P1 P1P2 P2P2 S1S1 S1S2 S2S2 P1S1 P1S2 P2S1 P2S2'/
     2 26X,'P2P1',11X,'S2S1',6X,'S1P1 S2P1 S1P2 S2P2'/
     3 (' INTERFACE',I4,2I3,10I5))
1200  FORMAT (2(2F8.2,I4),F10.5)
1201  FORMAT (i2,10f7.1)
1202  FORMAT (10f7.2)
1203  FORMAT (F8.2,I4)
1231  FORMAT (' SEIS RANGE',F8.2,' COMP',I3,' INIT TIME',F15.4,
     .' SEC, MAX AMP',G13.5)
1240  format (i3,f8.2,i3,2f15.4,i5,g13.5)
1241  format (5g13.5)
C
      END                                                               WKBJ



      SUBROUTINE RAYIN (NPS,ID,NN,MULT,IS,IR,LRAY,lsh0,IN)               RAYIN
C
C-----------------------------------------------------------------------
C Routine to read ray definition.
C-----------------------------------------------------------------------
C
C Input: IN         = input data set number
C
C Output: NPS(2,*)  = number of rays segments
C                     NPS(1,l) = number of P ray segments in l-th layer
C                     NPS(2,l) = number of SV ray segments in l-th layer
C                     i.e. n_Ìalpha lË and n_Ìbeta lË
C         ID(10,*)  = multiplicity of coefficients
C                     ID(k,l) = multiplicity of k-th coefficient at
C                               l-th interface, i.e. nu_ÌlkË
C         NN        = number of layers and interfaces to define ray
C         MULT      = multiplicity of ray in dynamic group
C         IS        = source type index
C         IR        = receiver type index
C         LRAY      = kinematic/dynamic group flag
C                     LRAY=.true. for new kinematic group
C                     LRAY=.false. for new dynamic group within old
C                     kinematic group.
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equations and figures refer to that paper.
C
C Calls: none
C
C Errors: It is assumed that the input data is correct.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: C.H.Chapman
C
C Date: revised version, 28 July 1986
C
C Arguments:
C
      INTEGER NPS(2,*),ID(10,*),NN,MULT,IS,IR,IN
      LOGICAL LRAY,lsh0
C
C Local variables:
C
      INTEGER NPX(2,5),IDX(10,5),N(5),I,J,K,L,KK,NI,NK
C
C Read ray in integer format
C
C***********************************************************************
C
C (3) FORMAT (L1,I3,3I2,5(I2,12I1))
C
C This record(s) defines the kinematic and dynamic properties of a
C dynamic group of rays.
C
C The record(s) has ray type identification in cols 1-10 and then each
C layer/interface is described by its index plus 12 integers (14
C columns per layer/interface).  The layer/interface index runs
C from 1 to NN (but see notes below about repeating or omitting
C a layer and continuing records).
C
C Note the l-th interface is at the top of the l-th layer.
C
C See figure 2.
C
C
C COL 1    (L1) LRAY=T new kinematic group
C                    F dynamic group within preceding kinematic group
C
C COL 2-4  (I3) NN=number of layers to define ray including 'half-space'
C               Note the ray will either turn in the (NN-1)-th layer
C               or be reflected by the NN-TH interface. Both the turning
C               ray and the reflection have the same specification, i.e.
c               both include the reflection coefficients at the NN-th
C               interface. The type of ray is controlled by the ray
C               parameter.
C
C COL 5-6  (I2) MULT=multiplicity of ray in dynamic group
C
C COL 7-8  (I2) IS=source index - 1 is P down, 2 S down, 5 P up, 6 S up
C COL 9-10 (I2) IR=receiver index - 1 is P up, 2 is S up, 5 is P down,
C                                   6 is S down (in material), 9 is P up
C                                   and 10 S up (at free surface)
C
C See subroutine COMPON and figure 4.
C
C
C The following 14 columns are repeated for l=1,NN (but see below).
C See subroutines PXINT and COEFF and figures 2 and 3.
C
C COL 11-12 (I2)   l layer/interface index
C
C COL 13    (I1)   NPS(1,l) number of P segments in l-th layer
C COL 14    (I1)   NPS(2,l) number of S segments in l-th layer
C                  See figure 2 - NPS(1,l) is n_Ìalpha lË and
C                                 NPS(2,l) is n_Ìbeta lË.
C
C COL 15-24 (10I1) (ID(k,l),k=1,10) multiplicity of coefficients at
C                  l-th interface.  First index, k, refers to coefficient
C                  type:
C                                    PP           PP      PP           PP
C                         k = 1 for R  , = 2 for T   and T  , = 3 for R
C                                    D            D       U            U
C
C                                    VV           VV      VV           VV
C                         k = 4 for R  , = 5 for T   and T  , = 6 for R
C                                    D            D       U            U
C
C                                    PV      VP           PV      VP
C                         k = 7 for R   and R  , = 8 for T   and T
C                                    D       D            D       U
C
C                                    PV      VP            PV      VP
C                         k = 9 for T   and T  , = 10 for R   and R
C                                    U       D             U       U
C
C                  See figures 2 and 3 - ID(k,l) is nu_ÌlkË.
C
C COLS 25-38, 39-52, 53-66, 67-80 repeat 11-24 with increasing
C values of l, the layer/interface index.
C
C Note identical layers can be omitted after the first one - the
C final layer will always be different as NP(NN)=NS(NN)=0 and
C all the coefficients are reflections.
C
C If the I1 FORMAT is insufficient a layer/interface can be
C repeated as necessary.  All numbers are added.
C
C Records can be continued as required (COLS 1-10 being identical
C and the layer/interface descriptions continuing in
C COLS 11-24, 25-38, 39-52, 53-66 and 67-80).
C Records are read until the final layer is encountered.  Therefore the
C final layer should not be repeated on a continuation record - this can
C be avoided by repeating another layer (with zero entries).
C
C Example:
C
C Consider the ray SKPP4KP in a model with 5 layers - the crust,
C a 3-layer mantle, and core.  This ray has a multiplicity of 4 -
C the dynamic analogues are S2KPP3KP, S3KPP2KP and S4KPPKP.
C We assume a receiver at the free surface.  The record would be
C (with column 1 T rather than C):
C
C  6 4 2 9 1310010000000 2310300100000 5800330000010 5200000000000 6005000000000
C
C This is kinematically equivalent to SCPP5KP and S5KPPCP which
C would be specified by (with column 1 F rather than C):
C
C  6 1 2 9 1310010000000 2310300100000 5800240001000 5200000000000 6005000000000
C  6 1 2 9 1310010000000 2310300100000 5801140000010 5200000000000 6005000000000
C
C***********************************************************************
C
      K=0
C
C Read record
C
1     READ (IN,1001) LRAY,NN,MULT,IS,IR,(N(I),(NPX(J,I),J=1,2),
     1 (IDX(J,I),J=1,10),I=1,5)
      IF (NN.EQ.0) RETURN
C
C Loop over 5 fields on record
C
      DO 2 I=1,5
          NI=N(I)
          IF (NI.EQ.0) goto 12
          IF (NI.EQ.K) GO TO 4
          NK=NI-1
C
C Test whether identical layers omitted. K is previous layer.
C
          IF (NK.EQ.K) GO TO 5
          KK=K+1
C
C Include identical layer(s).
C
          DO 6 L=KK,NK
              NPS(1,L)=NPS(1,K)
              NPS(2,L)=NPS(2,K)
          DO 6 J=1,10
              ID(J,L)=ID(J,K)
6         CONTINUE
C
C New layer.
C
5         K=NI
          NPS(1,K)=NPX(1,I)
          NPS(2,K)=NPX(2,I)
          DO 7 J=1,10
              ID(J,K)=IDX(J,I)
7         CONTINUE
C
      GO TO 2
C
C Sum parameters in repeat layer.
C
4          NPS(1,K)=NPS(1,K)+NPX(1,I)
           NPS(2,K)=NPS(2,K)+NPX(2,I)
           DO 8 J=1,10
               ID(J,K)=ID(J,K)+IDX(J,I)
8          CONTINUE
C
C End of loop for field on record
C
2     CONTINUE
C
      IF (K.NE.NN) GO TO 1
c
c Test if SH waves exist for this ray
c
 12   continue
      lsh0=.true.
      do i=1,nn
        if(nps(1,i).ne.0)   lsh0=.false.
      enddo
c
      RETURN
C
1001  FORMAT (L1,I3,3I2,5(I2,12I1))
C
      END                                                               RAYIN
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
C WKBJ.FOR - subroutines THETAC and CCSQRT
C
      SUBROUTINE THETAC (P,TAU,C,J,ICON,X,T0,DT,M,W)                    THETAC
C
C-----------------------------------------------------------------------
C Routine to compute WKBJ seismogram, i.e.
C w(m*DT+T0) = w(m*DT+T0) + sum( int PA to PB (C(p) dp))
C where the range of the integral (PA,PB) is defined by
C theta = (m-1)*DT+T0 to m*DT+T0 and the sum is over all such intervals
C with theta(p,X) = P(j)*X + TAU(j), see equation (16c).
C-----------------------------------------------------------------------
C
C Input: P(ICON,*)  = horizontal slownesses
C                     P(1,j) = pj (j=1 to J) in monotonically increasing
C                     order.
C        TAU(ICON,*)= delay times
C                     TAU(1,j) = tau(pj) (necessarily in decreasing
C                     order).
C        C(ICON,*)  = (C(1,j),C(2,j)) = Cj (complex integrand)
C        J          = number of tabulated points
C        ICON       = multiple array dimension to allow P, TAU and C to
C                     be stored in one multidimensional array in calling
C                     program.
C        X          = x (range)
C        T0         = t0 (initial time)
C        DT         = time step
C        M          = number of time points in final time series.
C                     Note output of this routine has (M+5) points -
C                     see CCSQRT.
C
C Input and output: W(*) = W(m+3) = w(m*DT+T0,X) (complex seismogram)
C                          Note m=-2 to M+2 to allow 2 point shift and
C                          1 point decrement in CCSQRT.
C                          Note result is added into W and W is not
C                          zeroed by this routine.  This allows many
C                          rays to be accumulated in the same buffer.
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation and figure numbers refer to that paper.
C
C Calls: none
C
C Errors: None.  It is assumed that the input parameters are all defined
C         sensibly and are compatible.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: C.H.Chapman
C
C Date: revised version, 28 July 1986
C
C Arguments:
C
      INTEGER J,ICON,M
      REAL P(ICON,*),TAU(ICON,*),C(ICON,*),X,T0,DT
      COMPLEX W(*)
C
C Local variables:
C
      COMPLEX PAMP,QAMP,BOT,TOP,Z,DIF
      REAL PJ,PB,P1,P2,P3,T,T1,T2,T3,TDIR,DP2,DP3,DT1,DT2,DT3,
     1 DTDP1,DTDP2,DTDP3,DQ
      INTEGER M5,JJ,J1,J2,J3,MM,MDIR,M0
C
C Total number of points in seismogram W.
C
C We have 2 extra points at each end to allow for 2 point shift in
C convolution operator in CCSQRT - equation (23).  The 3rd extra
C point at the top allows for decrement of the series - equation (19) -
C as this routine only computes the lower half of the boxcar -
C equation (16c).
C
      M5=M+5
C
C Find initial point
C
C T1+DT to T3 is window of seismogram (just in this loop).
C Note T1=T0-3*DT as T band is from T-DT to T.
C T1 < theta = P(1,JJ)*X+TAU(1,JJ) < T3 at end of loop - statement 10.
C
      T1=T0-3.*DT
      T3=T0+FLOAT(M+2)*DT
      DO 1 JJ=1,J
          T2=P(1,JJ)*X+TAU(1,JJ)
          IF (T2.GT.T1.AND.T2.LT.T3) GO TO 10
1     CONTINUE
C
C Table completely outside seismogram window - exit.
C
      RETURN
C
C Initialize values - see comments at statement 21 where we jump into
C main part of code for meaning of variables.  Effectively at this
C point before we jump into main code for a new interval, the current
C interval is P1=P(JJ-2) to P2=P(JJ-1) which is entirely outside
C seismogram window, and PB is P2 which will become PA (note we refer
C to PA in the interval PA to PB in the comments but it is not used
C explicitly as a variable).
C
10    J2=MAX0(1,JJ-1)
      J3=J2+1
      J1=MAX0(J2-1,1)
C
C PJ is end of table
C
      PJ=P(1,J)
      PB=P(1,J2)
      P2=PB
      P3=P(1,J3)
      P1=P(1,J1)
C
      T1=P1*X+TAU(1,J1)
      T2=P2*X+TAU(1,J2)
      T3=P3*X+TAU(1,J3)
C
C Index for first time point from table
C
      MM=INT((T2-T0)/DT)+3
      T=T0+FLOAT(MM-2)*DT
C
C Search direction indicators.
C
C These are set assuming current interval has a positive gradient.
C They will be reset at statement 23 - if the new interval, i.e. the
C first significant interval P2 to P3, has a negative gradient DTDP3.
C
      TDIR=DT
      MDIR=1
C
C Initializes integrals to zero.
C
C PAMP will be integral to P1 - figure (7b).
C QAMP will be integral to PB - figure (7a).
C
      PAMP=CMPLX(0.,0.)
      QAMP=CMPLX(0.,0.)
C
C Next interval, i.e. first significant interval
C
      DP3=P3-P2
      DT3=T3-T2
      DTDP3=DT3/DP3
C
C Current interval - if it is before table, i.e. JJ=J1=J2=1, then use
C same values as next interval.
C
      DT2=DT3
      DTDP2=DTDP3
      IF (J1.EQ.J2) GO TO 21
      DT2=T2-T1
      DTDP2=DT2/(P2-P1)
      GO TO 21
C
C End of introductory code.
C
C***********************************************************************
C
C The following code is the main part of the algorithm.
C
C The tightest loop is from statement 25 to the end of the code for new
C DT bands within the same p-interval, jumping out to statement 20
C whenever the DT band moves into a new p interval.
C
C***********************************************************************
C
C New p-interval section.
C
C Add in integral for interval P1 to P2 minus P1 to PA if PA within
C interval (QAMP will be zero from previous pass if PA outside interval)
C (note DP2=2*(P2-P1)) - figure (7b).
C
20    PAMP=.25*DP2*(BOT+TOP)-QAMP+PAMP
      QAMP=CMPLX(0.,0.)
C
C Get a new point from the P-TAU table
C
C Update interval from table - see figure (6).
C
C Previous interval: J1 end index
C                    P1 end p value
C                    T1 end theta value
C                    DT1 theta increment
C                    DTDP1 gradient
C
C Current interval: J1 and J2 indices
C                   P1 and P2 p values
C                   T1 and T2 theta values
C                   DT2 theta increment
C                   DP2 2 times p increment
C                   DTDP2 gradient
C
C Next interval: J2 and J3 indices
C                P2 and P3 p values
C                T2 and T3 theta values
C                DT3 theta increment
C                DP3 p increment
C                DTDP3 gradient
C
21    IF (J2.EQ.J) RETURN
      J1=J2
      J2=J3
      J3=MIN0(J3+1,J)
C
      P1=P2
      P2=P3
      P3=P(1,J3)
C
      T1=T2
      T2=T3
      T3=P3*X+TAU(1,J3)
C
      DT1=DT2
      DT2=DT3
      DT3=T3-T2
C
      DTDP1=DTDP2
      DTDP2=DTDP3
      DP2=DP3+DP3
      DP3=P3-P2
      IF (J2.NE.J) DTDP3=DT3/DP3
C
C Integrand at ends of current interval
C
      BOT=CMPLX(C(1,J1),C(2,J1))
      TOP=CMPLX(C(1,J2),C(2,J2))
C
C Modify integrand to make result continuous - equation (18)
C
      IF (ABS(DT2).LE.DT) GO TO 22
      IF (ABS(DT1).GT.DT) BOT=2.*ABS(DTDP2)/(ABS(DTDP1)+ABS(DTDP2))*BOT
      IF (ABS(DT3).GT.DT) TOP=2.*ABS(DTDP2)/(ABS(DTDP2)+ABS(DTDP3))*TOP
22    DIF=TOP-BOT
C
C Test whether direction in new current interval is still the same
C
      IF (DTDP2*TDIR) 23,20,24
C
C Gradient (DTDP2) and direction (TDIR) opposite sign so gradient has
C changed direction and we must change search direction.
C
23    MM=MM+MDIR
      TDIR=-TDIR
      MDIR=-MDIR
C
C End of new P-interval section.
C
C***********************************************************************
C
C New DT band section.
C
C Test old PB to exit if end
C
25    IF (PB.EQ.PJ) RETURN
C
C Increment T for new DT band to define new PB - figure (5b).
C
      T=T+TDIR
C
C Test whether new T is with current interval T1 to T2
C
C Note if the current interval is the last interval of the table (J=J2),
C then we end by putting PB=P2=PJ.
C
24    IF (((T-T2)*TDIR.GT.0.).AND.(J2.LT.J)) GO TO 20
C
C Solve for PB by linear interpolation in (P1,P2) interval between
C T1 and T2, i.e. theta(p,x) = T1 + DTDP2*(p-P1) - figure (6).
C
      PB=AMIN1(P1+(T-T1)/DTDP2,PJ)
C
C PAMP is integral from PA to P1 if P1>PA - statement 20 and
C         figure (7b),
C      is zero if P1<PA from previous pass here.
C QAMP is integral from P1 to PA if P1<PA from previous pass here when
C         PA was PB - figure (7a),
C      is zero if P1>PA - statement 20 and figure (7b).
C Z is integral from PA to P1 in either circumstance.
C
      Z=PAMP-QAMP
      PAMP=CMPLX(0.,0.)
C
C New QAMP is integral from P1 to PB by trapezoidal rule assuming
C linear interpolation of integrand between BOT and TOP at P1 and P2.
C
      DQ=PB-P1
      QAMP=DQ*(DQ/DP2*DIF+BOT)
C
C Increment time point index and find maximum of old and new index
C for top of DT band.
C
      M0=MM
      MM=MM+MDIR
      M0=MAX0(MM,M0)
C
C Sum integral from PA to PB into time point corresponding to top of
C interval - equation (16c).  Z is integral from PA to P1 and QAMP is
C integral from P1 to PB.
C
      IF (M0.GE.1.AND.M0.LE.M5) W(M0)=W(M0)+Z+QAMP
C
C End of DT band section.
C
C***********************************************************************
C
C Continue with next DT band.
C
      GO TO 25
C
      END                                                               THETAC





      SUBROUTINE CCSQRT (W,M,U)                                         CCSQRT
C
C-----------------------------------------------------------------------
C Routine to compute d/dt Im (1/sqrt(t) * w(t)) using a rational approx.
C The operator d/dt H(t)/sqrt(t) is smoothed by a boxcar 2*dt long, 3
C times.  The rational approximation for d/dt H(t)/sqrt(t) is given in
C the z-domain by
C
C          1    1+n1*z+n2*z**2+n3*z**3+n4*z**4+n5*z**5
C       ------  --------------------------------------
C       6*z**2    1+d1*z+d2*z**2+d3*z**3+d4*z**4
C
C e.g. equation (23).  The rational approximation is then applied as
C
C Y(i) = X(i)+N1*X(i-1)+N2*X(i-2)+N3*X(i-3)+N4*X(i-4)+N5*X(i-5)
C            -D1*Y(i-1)-D2*Y(i-2)-D3*Y(i-3)-D4*Y(i-4)
C
C where X(i) is the input series and Y(i) the output series.
C The operator is applied in the forward direction on the imaginary
C part, and backwards on the real part, see equation (21).
C The factor 1/6 is omitted and 1/z**2 shifts 2 points (in direction
C opposite to operator).
C The input data are decremented and added, i.e. v(m)=w(m)+w(m+1),
C equation (19) with 1/2*DT omitted, to compensate for the half-boxcar
C from t-dt to t used in THETAC.
C The input data are M+5 points from TSTRT-2*DT to TSTRT+(M+2)*DT, i.e.
C output of THETAC.  The 2 extra points allow the operator to run to end
C point of output time series with 2 point shift, z**2.  The 3rd extra
C point at the top is for the decrementing the input series.
C-----------------------------------------------------------------------
C
C Input: W(2,*)     = complex time series
C                     (W(1,m+3),W(2,m+3)) = w(m*dt+t0,x) (m=-2 to M+2)
C        M          = number of time points in output series
C
C Output: U(*)      = real time series - u(t)=d/dt Im (1/sqrt(t)*w(t))
C                     U(m) = u(m*dt-dt+t0,x) (m=1 to M)
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation numbers refer to that paper.
C
C Calls: none
C
C Errors: Note it is assumed that the input parameters are all defined
C         sensibly and are compatible.  It is assumed that M>2.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: C.H.Chapman
C
C Date: revised version, 25 July 1986
C
C
C Arguments:
C
      REAL W(2,*),U(*)
      INTEGER M
C
C Local variables:
C
      INTEGER M4,K,L,J,N,K1
      REAL X0,X1,X2,X3,X4,X5,Y0,Y1,Y2,Y3,Y4,N1,N2,N3,N4,N5,D1,D2,D3,D4
      DATA N1,N2,N3,N4,N5/1.265298,-1.508272,-2.047727,
     1 0.5205257,0.8033268/
      DATA D1,D2,D3,D4/-1.563129,0.7167736,-0.1569175,0.3977094E-1/
C
      M4=M+4
C
C Indices for doing operation on real part backwards,
C i.e. d/dt H(-t)/sqrt(-t).
C K counts through input series using K1 as increment.
C
      K=M+1
      K1=-1
C
C Test for non-zero real element and zero output series
C
      DO 1 N=5,M4
          K=K-1
          IF (W(1,K).NE.0.) GO TO 10
1     U(K)=0.
      N=M4
C
C Loop for backward (J=1) and forward (J=2) operations
C
10    DO 20 J=1,2
C
C Initialize X and Y's - see loop 30.
C
C Normally these will be zero unless series start immediately with
C non-zero values and loop 1 or 21 is left early.
C X4=0 as no attempt is made to extrapolate known series.
C Note decrement of input data.
C
          X0=W(J,K-K1)+W(J,K-K1+1)
          X1=W(J,K-2*K1)+W(J,K-2*K1+1)
          X2=W(J,K-3*K1)+W(J,K-3*K1+1)
          X3=W(J,K-4*K1)+W(J,K-4*K1+1)
          X4=0.
C
          Y3=X3
          Y2=X2+N1*X3-D1*Y3
          Y1=X1+N1*X2+N2*X3-D1*Y2-D2*Y3
          Y0=X0+N1*X1+N2*X2+N3*X3-D1*Y1-D2*Y2-D3*Y3
C
C Apply rational approximation, see equation (23).
C
C Note scalars Xn and Yn are used within loop for the input and output
C series to reduce index operations.
C
          DO 30 L=N,M4
C
C Update X and Y's.
C
              X5=X4
              X4=X3
              X3=X2
              X2=X1
              X1=X0
C
C Input series decremented and added, see equation (19).
C
              X0=W(J,K)+W(J,K+1)
C
              Y4=Y3
              Y3=Y2
              Y2=Y1
              Y1=Y0
C
              Y0=X0+N1*X1+N2*X2+N3*X3+N4*X4+N5*X5
     1             -D1*Y1-D2*Y2-D3*Y3-D4*Y4
C
C Branch for backward and forward operations.
C
              GO TO (31,32),J
C
C Backward operation - store result.
C
C Note 2 point shift and 2 extra points in input series cancel.
C d/dt is not backwards so negate result.
C
31            U(K)=-Y0
              GO TO 30
C
C Forward operation - add to previous result,
C
C Note 2 point shift and 2 extra points combine to give 4 point shift.
C
32            U(K-4)=U(K-4)+Y0
C
C End of loop running through time series.
C
30        K=K+K1
C
C If doing forward operation then this is the end.
C
          IF (J.EQ.2) RETURN
C
C Set parameters for forward operation and find starting point of
C imaginary part.
C
          K1=1
          DO 21 K=6,M4
              IF (W(2,K).NE.0.) GO TO 22
21        CONTINUE
          K=M4
C
C Reduce K as we decrement input series.
C
22        K=K-1
          N=K
C
C End of loop for backward operation.
C
20    CONTINUE
C
C No route through here.
C
      STOP
C
      END                                                               CCSQRT
c&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
C
C RAY1D.FOR - subroutines PXINT, COEFF and COMPON
C
      SUBROUTINE PXINT (P,VEL,IVEL,IL,NPS,L,IMTH,TAU,X,IRTR)            PXINT
C
C-----------------------------------------------------------------------
C Routine to compute TAU(p) and X(p), see equation (15).
C-----------------------------------------------------------------------
C
C Input: P           = horizontal slowness
C        VEL(IVEL,*) = model
C                      VEL(1,*) = depths in increasing order
C                      VEL(2,*) = P slownesses
C                      VEL(3,*) = S slownesses
C                                 For a fluid, this is irrelevant and
C                                 should be set zero for routine COEFF
C                      VEL(4,*) = densities (irrelevant)
C                      VEL(5,*) = b for interpolation of P velocity
C                      VEL(6,*) = b for interpolation of S velocity
C                                 (see equations (13) and (14))
C        IVEL        = multiple array dimension for VEL ( >= 6)
C        IL(*)       = interface indices i(l),
C                      i.e. VEL(1,IL(LL)-1) = VEL(1,IL(LL)) with IL(1)=1
C        NPS(2,*)    = numbers of ray segments
C                      NPS(1,*) = number of P ray segments
C                      NPS(2,*) = number of SV ray segments
C        L           = maximum layer with ray segments
C                      This can be larger, i.e. total number of layers,
C                      provided appropriate NPS(*,*) are zero.
C        IMTH        = interpolation method
C                      IMTH = 1,  v(z) = 1/sqrt(a - 2*b*z)
C                           = 2,  v(z) = a - b*z
C                           = 3,  v(z) = a*exp(-b*z)
C                                 (see equations (13) and (14))
C
C Output: TAU        = delay function tau(p)
C         X          = range function X(p)
C         IRTR       = return code
C                      IRTR = 1, normal return
C                           = 2, error return - TAU would be complex
C                                for ray definition
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation numbers refer to that paper.
C
C Calls: none
C
C Errors: see IRTR.
C         Note it is assumed that the input parameters are all defined
C         sensibly and are compatible.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: C.H.Chapman
C
C Date: revised version, 23 July 1986
C
C Arguments:
C
      INTEGER IVEL,IL(*),L,NPS(2,*),IMTH,IRTR
      REAL P,VEL(IVEL,*),TAU,X
C
C Local variables:
C
      REAL DTAU,DX,U,Y,Q,QS,QR,B,ETAU,EX,Z
      INTEGER LL,I1,I2,K,MULT,KU,KV,I,II
C
C Zero integrals
C
      TAU=0.
      X=0.
C
C Loop over layers - LL is l in equation (8)
C
      DO 100 LL=1,L
C
C Range of model indices in layer - IL(l) = i(l) in definition II.
C Layer is model points I1 to I2+1.
C
          I1=IL(LL)
          I2=IL(LL+1)-2
C
C Loop over ray types - K corresponds to alpha and beta in equation (8)
C
          DO 100 K=1,2
C
C Multiplicity of ray segments
C
              MULT=NPS(K,LL)
              IF (MULT.EQ.0) GO TO 100
C
C Zero contribution from layer.
C Note layer contributions to integral accumulated separately (DTAU and
C DX) so multiplicity can be used once at end of loop.
C
              DTAU=0.
              DX=0.
C
C KU = slowness index, KV = b index
C
              KU=K+1
              KV=K+4
C
C Initialize variables Q, QS and QR at top of layer
C
C Slowness and test whether vertical slowness real
C
              U=VEL(KU,I1)
              Y=U-P
              IF (Y) 900,100,110
C
C Vertical slowness
C
110           Q=Y*(U+P)
              QS=SQRT(Q)
C
C Special function needed for integral at top of layer.
C See loop 130 for details.
C
              GO TO (120,112,113),IMTH
C
112           Y=U+QS
              IF (P.NE.0.) Y=Y/P
              QR=ALOG(Y)
              GO TO 120
C
113           QR=ATAN2(QS,P)
C
C Loop over model points in layer
C
120           CONTINUE
              DO 130 I=I1,I2
                  II=I+1
C
C Interpolation parameter - b=0 is a constant velocity layer
C
                  B=VEL(KV,I)
                  IF (B.EQ.0.) GO TO 150
C
C Integral at upper limit - model point I.
C
C Factor 1/b omitted until end of loop (at 160).
C
C Note contributions between model points I and II evaluated separately
C (ETAU and EX) to reduce rounding errors (if ETAU is small compared
C with DTAU, etc.).
C
                  GO TO (131,132,133),IMTH
C
C IMTH=1, v(z) = 1/sqrt(a-2*b*z) - equation (13a)
C         tau(p) = -q**3/3/b - equation (15a)
C         x(p) = -p*q/b
C
131               ETAU=-Q*QS/3.
                  EX=-QS*P
                  GO TO 140
C
C IMTH=2, v(z) = a-b*z - equation (13b)
C         tau(p) = (log((1+v*q)/v/p)-v*q)/b - equation (15b)
C         x(p) = v*q/p
C
132               EX=QS/U
                  ETAU=QR-EX
                  IF (P.NE.0.) EX=EX/P
                  GO TO 140
C
C IMTH=3, v(z) = a*exp(-b*z) - equation (13c)
C         tau(p) = (q-p*atan(q/p))/b - equation (15c)
C         x(p) = atan(q/p)/b
C
133               ETAU=QS-P*QR
                  EX=QR
C
C Variables at lower limit - model point II
C
C Slowness and test whether vertical slowness real.  If vertical
C slowness is not real we have a turning point.  Integral at lower
C limit is then zero.
C
140               U=VEL(KU,II)
                  IF (U.LE.P) GO TO 160
                  Q=(U-P)*(U+P)
                  QS=SQRT(Q)
C
C Integral at lower limit
C
                  GO TO (141,142,143),IMTH
C
141               ETAU=ETAU+Q*QS/3.
                  EX=EX+QS*P
                  GO TO 160
C
142               Y=U+QS
                  Z=QS/U
                  ETAU=ETAU+Z
                  IF (P.EQ.0.) GO TO 144
                  Y=Y/P
                  Z=Z/P
144               QR=ALOG(Y)
                  ETAU=ETAU-QR
                  EX=EX-Z
                  GO TO 160
C
143               QR=ATAN2(QS,P)
                  ETAU=ETAU-QS+P*QR
                  EX=EX-QR
                  GO TO 160
C
C Special results if b=0 - homogeneous, 1/B = thickness
C
150               B=1./(VEL(1,II)-VEL(1,I))
                  ETAU=QS
                  EX=P/QS
C
C Contribution to layer sums from model points I to II
C
160               DTAU=DTAU+ETAU/B
                  DX=DX+EX/B
C
C Turning point condition
C
                  IF (U.LE.P) GO TO 170
C
C End of loop through model points in layer
C
130           CONTINUE
C
C Contribution from layer to total integral
C
170           TAU=TAU+FLOAT(MULT)*DTAU
              X=X+FLOAT(MULT)*DX
C
C End of loops though ray types and layers
C
100   CONTINUE
C
C Normal return condition
C
      IRTR=1
      RETURN
C
C Error return condition - tau(p) complex
C
900   IRTR=2
      RETURN
C
      END                                                               PXINT




      COMPLEX FUNCTION COEFF (P,VEL1,VEL2,ID)                           COEFF
C
C-----------------------------------------------------------------------
C Routine to compute product of reflection/transmission coefficients at
C interface, equation (7).
C-----------------------------------------------------------------------
C
C Input: P          = horizontal slowness
C        VEL1(*)    = parameters above interface
C                     VEL1(1) = P slowness
C                     VEL1(2) = S slowness (zero for a fluid)
C                     VEL1(3) = density (zero for a free surface)
C        VEL2(*)    = parameters below interface
C                     VEL2(1) = P slowness
C                     VEL2(2) = S slowness (zero for a fluid)
C                     VEL2(3) = density
C        ID(*)      = multiplicity of coefficients. ID(k) is nu_ÌlkË
C                     where
C                                PP           PP      PP           PP
C                     k = 1 for R  , = 2 for T   and T  , = 3 for R
C                                D            D       U            U
C
C                                VV           VV      VV           VV
C                     k = 4 for R  , = 5 for T   and T  , = 6 for R
C                                D            D       U            U
C
C                                PV      VP           PV      VP
C                     k = 7 for R   and R  , = 8 for T   and T
C                                D       D            D       U
C
C                                PV      VP            PV      VP
C                     k = 9 for T   and T  , = 10 for R   and R
C                                U       D             U       U
C
C                     See figures 2 and 3.
C
C Output: COEFF     = product of reflection/transmission coefficients,
C                     e.g. inner product in equation (6) with
C                     equation (7).
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation numbers refer to that paper.
C
C Calls: none
C
C Errors: Note it is assumed that the input parameters are all defined
C         sensibly and are compatible.  If for P1P1 or S1S1, the
C         incident ray is evanescent, a turning ray is assumed.  For
C         other coefficients, if an incident or generated ray is
C         evanescent, then it probably indicates an error in the input
C         parameters.  The coefficient may be correct or may be zero
C         as the slownesses of the incident and generated rays are
C         assumed real in some places.
C         Non-existent coefficients in fluid media are not set zero -
C         in fact they implicitly are unity.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: C.H.Chapman
C
C Date: revised version, 24 July 1986
C
C Arguments:
C
      REAL P,VEL1(*),VEL2(*)
      INTEGER ID(*)
C
C Local variables:
C
C The code has been written to reduce the amount of unnecessary complex
C arithmetic.  This may not be necessary with smart FORTRAN compilers.
C DUM is used to simplify zeroing many variables.
C
      REAL DUM(22),P1,P2,S1,S2,D1,D2,MU1,MU2,PP,PP4,QA1R,QA1I,QA2R,QA2I,
     1 QB1R,QB1I,QB2R,QB2I,D2QA1R,D2QA1I,D1QA2R,D1QA2I,D2QB1R,
     2 D2QB1I,D1QB2R,D1QB2I,QA1B1R,QA1B1I,QA2B2R,QA2B2I,B1,
     3 D,E1,E2,B1P2,X2,X1,X,Y
      COMPLEX DELTA,AAP,AAM,ABP,ABM,C1P,C1M,C2P,C2M
      INTEGER K
C
      EQUIVALENCE (DUM(1),QA1R),(DUM(2),QA1I),(DUM(3),QA2R),
     1 (DUM(4),QA2I),(DUM(5),QB1R),(DUM(6),QB1I),(DUM(7),QB2R),
     2 (DUM(8),QB2I),(DUM(9),D2QA1R),(DUM(10),D2QA1I),(DUM(11),D1QA2R),
     3 (DUM(12),D1QA2I),(DUM(13),D2QB1R),(DUM(14),D2QB1I),
     4 (DUM(15),D1QB2R),(DUM(16),D1QB2I),(DUM(17),QA1B1R),
     5 (DUM(18),QA1B1I),(DUM(19),QA2B2R),(DUM(20),QA2B2I),
     6 (DUM(21),MU1),(DUM(22),MU2)
C
C Initialize COEFF=1
C
      COEFF=CMPLX(1.,0.)
C
C Test for non-zero coefficients
C
      DO 1 K=1,10
          IF (ID(K).NE.0) GO TO 2
1     CONTINUE
C
C Return if no coefficients - note COEFF=1
C
      RETURN
C
C Initialize variables
C
2     PP=P*P
      PP4=4.*PP
      DO 3 K=1,22
          DUM(K)=0.
3     CONTINUE
      P1=VEL1(1)
      S1=VEL1(2)
      D1=VEL1(3)
      P2=VEL2(1)
      S2=VEL2(2)
      D2=VEL2(3)
C
C Set up real or imaginary parts of vertical slownesses.
C Note Reimann sheet is defined by Im(q) >= 0.
C
C qa2
C
      X2=(P2-P)*(P2+P)
      IF (X2) 11,20,12
11    QA2I=SQRT(-X2)
      D1QA2I=D1*QA2I
      GO TO 20
12    QA2R=SQRT(X2)
      D1QA2R=D1*QA2R
C
C qa1
C
20    IF (D1.EQ.0.) GO TO 500
      X1=(P1-P)*(P1+P)
      IF (X1) 21,30,22
21    QA1I=SQRT(-X1)
      D2QA1I=D2*QA1I
      GO TO 30
22    QA1R=SQRT(X1)
      D2QA1R=D2*QA1R
C
C Aa+ and Aa- - equation (7l)
C
30    AAP=CMPLX(D2QA1R+D1QA2R,D2QA1I+D1QA2I)
      AAM=CMPLX(D2QA1R-D1QA2R,D2QA1I-D1QA2I)
C
C Test for fluids
C
      IF (S1.EQ.0..AND.S2.EQ.0.) GO TO 400
      IF (S1.EQ.0.) GO TO 40
C
C qb1 and qa1*qb1
C
      MU1=D1/S1**2
      X=(S1-P)*(S1+P)
      IF (X) 31,40,32
31    QB1I=SQRT(-X)
      D2QB1I=D2*QB1I
      IF (X1) 33,40,34
33    QA1B1R=-QA1I*QB1I
      GO TO 40
34    QA1B1I=QA1R*QB1I
      GO TO 40
32    QB1R=SQRT(X)
      D2QB1R=D2*QB1R
      IF (X1) 35,40,36
35    QA1B1I=QB1R*QA1I
      GO TO 40
36    QA1B1R=QB1R*QA1R
C
C B1 - equation (7m)
C C1+ - equation (7n) (C1P = 2*p*C1+)
C C1- - equation (7n) (C1M = -2*p*C1-)
C
40    IF (S2.NE.0.) MU2=D2/S2**2
      B1=MU1-MU2
      X=PP4*B1*QA1B1I
      C1P=CMPLX(PP4*(B1*(QA1B1R+PP)-D1),X)
      C1M=CMPLX(PP4*(B1*(QA1B1R-PP)+D1),X)
C
C qb2 and qa2*qb2
C
      IF (S2.EQ.0.) GO TO 300
      X=(S2-P)*(S2+P)
      IF (X) 41,50,42
41    QB2I=SQRT(-X)
      D1QB2I=D1*QB2I
      IF (X2) 43,50,44
43    QA2B2R=-QA2I*QB2I
      GO TO 50
44    QA2B2I=QA2R*QB2I
      GO TO 50
42    QB2R=SQRT(X)
      D1QB2R=D1*QB2R
      IF (X2) 45,50,46
45    QA2B2I=QB2R*QA2I
      GO TO 50
46    QA2B2R=QB2R*QA2R
C
C C2+ - equation (7n) (C2P = -C2+/2/p)
C C2- - equation (7n) (C2M = C2-/2/p)
C D - equation (7o)
C E1 and E2 - equation (7p)
C Ab+ and Ab- - equation (7l)
C
50    X=B1*QA2B2I
      C2P=CMPLX(B1*(QA2B2R+PP)+D2,X)
      C2M=CMPLX(B1*(QA2B2R-PP)-D2,X)
      IF (S1.EQ.0.) GO TO 200
      D=PP*(D1+D2)**2
      B1P2=2.*PP*B1
      E1=D1-B1P2
      E2=D2+B1P2
      ABP=CMPLX(D2QB1R+D1QB2R,D2QB1I+D1QB2I)
      ABM=CMPLX(D2QB1R-D1QB2R,D2QB1I-D1QB2I)
C
C DELTA - equation (7k)
C
      DELTA=AAP*ABP+C1P*C2P+CMPLX(D,0.)
C
C P-SV reflection/transmission coefficients at solid-solid interface
C
100   CONTINUE
C
C P1P1 - equation (7a)
C
      K=ID(1)
      IF (K.EQ.0) GO TO 101
      IF (P.GE.P1) GO TO 110
      COEFF=COEFF*((AAM*ABP+C1M*C2P-CMPLX(D,0.))/DELTA)**K
C
C P1P2 and P2P1 - equation (7e)
C
101   K=ID(2)
      IF (K.EQ.0) GO TO 102
C
C Fa1*Fa2 - equation (7q)
C
      X=2.*SQRT(D2QA1R*D1QA2R)
      COEFF=COEFF*(CMPLX(X*(E2*QB1R+E1*QB2R),X*(E2*QB1I+E1*QB2I))/
     1 DELTA)**K
C
C P2P2 - equation (7c)
C
102   K=ID(3)
      IF (K.EQ.0) GO TO 103
      COEFF=COEFF*((C1P*C2M-AAM*ABP-CMPLX(D,0.))/DELTA)**K
C
C S1S1 - equation (7b)
C
103   K=ID(4)
      IF (K.EQ.0) GO TO 104
      IF (P.GE.S1) GO TO 111
      COEFF=COEFF*((CMPLX(D,0.)-AAP*ABM-C1M*C2P)/DELTA)**K
C
C S1S2 and S2S1 - equation (7f)
C
104   K=ID(5)
      IF (K.EQ.0) GO TO 105
C
C Fb1 * Fb2 - equation (7q)
C
      X=2.*SQRT(D2QB1R*D1QB2R)
      COEFF=COEFF*(CMPLX(X*(E2*QA1R+E1*QA2R),X*(E2*QA1I+E1*QA2I))/
     1 DELTA)**K
C
C S2S2 - equation (7d)
C
105   K=ID(6)
      IF (K.EQ.0) GO TO 106
      COEFF=COEFF*((AAP*ABM-C1P*C2M+CMPLX(D,0.))/DELTA)**K
C
C P1S1 and S1P1 - equation (7g)
C
106   K=ID(7)
      IF (K.EQ.0) GO TO 107
C
C -2*E1*B2 and p*Fa1*Fb1/rho1 - equations (7m,p,q)
C
      Y=2.*B1*E1
      X=SQRT(PP4*QA1B1R)
      COEFF=COEFF*(CMPLX(X*(Y*QA2B2R+(E1-D2)*E2),X*Y*QA2B2I)/
     1 DELTA)**K
C
C P1S2 and S2P1 - equation (7i)
C
107   K=ID(8)
      IF (K.EQ.0) GO TO 108
C
C -2*B2 and p*Fa1*Fb2 - equations (7m,q)
C
      Y=B1+B1
      X=SQRT(PP4*D2QA1R*D1QB2R)
      COEFF=COEFF*(CMPLX(X*(Y*(QB1R*QA2R-QB1I*QA2I)+E2-D1),
     1 X*Y*(QB1I*QA2R+QB1R*QA2I))/DELTA)**K
C
C P2S1 and S1P2 - equation (7j)
C
108   K=ID(9)
      IF (K.EQ.0) GO TO 109
C
C 2*B1 and -p*Fa2*Fb1 - equations (7m,q)
C
      Y=B1+B1
      X=-SQRT(PP4*D1QA2R*D2QB1R)
      COEFF=COEFF*(CMPLX(X*(Y*(QA1R*QB2R-QA1I*QB2I)+E2-D1),
     1 X*Y*(QA1R*QB2I+QA1I*QB2R))/DELTA)**K
C
C P2S2 and S2P2 - equation (7h)
C
109   K=ID(10)
      IF (K.EQ.0) GO TO 900
C
C 2*E2*B1 and -p*Fa2*Fb2/rho2 - equations (7m,p,q)
C
      Y=2.*E2*B1
      X=-SQRT(PP4*QA2B2R)
      COEFF=COEFF*(CMPLX(X*(Y*QA1B1R+(E1-D2)*E1),X*Y*QA1B1I)/DELTA)**K
      GO TO 900
C
C P1P1 turning point
C
110   COEFF=COEFF*CMPLX(0.,-1.)**K
      GO TO 101
C
C S1S1 turning point
C
111   COEFF=COEFF*CMPLX(0.,1.)**K
      GO TO 104
C
C P-SV reflection/transmission coefficients for fluid/solid
C
200   X1=4.*P/S2**2
      X=P*X1
      C1P=-CMPLX(X*QA1R,X*QA1I)
      DELTA=AAP+C1P*C2P
C
C P1P1
C
      K=ID(1)
      IF (K.EQ.0) GO TO 201
      IF (P.GE.P1) GO TO 210
      COEFF=COEFF*((DELTA-CMPLX(D1QA2R+D1QA2R,D1QA2I+D1QA2I))/DELTA)**K
C
C P1P2 and P2P1
C
201   K=ID(2)
      IF (K.EQ.0) GO TO 202
      COEFF=COEFF*(CMPLX((2.-X)*SQRT(D2QA1R*D1QA2R),0.)/DELTA)**K
C
C P2P2
C
202   K=ID(3)
      IF (K.EQ.0) GO TO 203
      COEFF=COEFF*((C1P*C2M-AAM)/DELTA)**K
C
C S2S2
C
203   K=ID(6)
      IF (K.EQ.0) GO TO 206
      COEFF=COEFF*((AAP-C1P*C2M)/DELTA)**K
C
C P1S2 and S2P1
C
206   K=ID(8)
      IF (K.EQ.0) GO TO 208
      Y=-X1*SQRT(D1*D2QA1R*QB2R)
      COEFF=COEFF*(CMPLX(Y*QA2R,Y*QA2I)/DELTA)**K
C
C P2S2 and S2P2
C
208   K=ID(10)
      IF (K.EQ.0) GO TO 900
      Y=X1*(D2-2.*PP*MU2)*SQRT(QA2B2R)
      COEFF=COEFF*(CMPLX(Y*QA1R,Y*QA1I)/DELTA)**K
      GO TO 900
C
C P1P1 turning point
C
210   COEFF=COEFF*CMPLX(0.,-1.)**K
      GO TO 201
C
C P-SV reflection/transmission coefficients for solid/fluid interface
C
300   X1=MU1/D1
      C2P=CMPLX(X1*QA2R,X1*QA2I)
      X=PP4*X1
      DELTA=AAP+C1P*C2P
C
C P1P1
C
      K=ID(1)
      IF (K.EQ.0) GO TO 301
      IF (P.GE.P1) GO TO 310
      COEFF=COEFF*((AAM+C2P*C1M)/DELTA)**K
C
C P1P2 and P2P1
C
301   K=ID(2)
      IF (K.EQ.0) GO TO 302
      COEFF=COEFF*(CMPLX((2.-X)*SQRT(D2QA1R*D1QA2R),0.)/DELTA)**K
C
C P2P2
C
302   K=ID(3)
      IF (K.EQ.0) GO TO 303
      COEFF=COEFF*((DELTA-CMPLX(D2QA1R+D2QA1R,D2QA1I+D2QA1I))/DELTA)**K
C
C S1S1
C
303   K=ID(4)
      IF (K.EQ.0) GO TO 304
      IF (P.GE.S1) GO TO 311
      COEFF=COEFF*((AAP-C2P*C1M)/DELTA)**K
C
C P1S1 and S1P1
C
304   K=ID(7)
      IF (K.EQ.0) GO TO 307
      Y=4.*P*X1*(D1-2.*PP*MU1)*SQRT(QA1B1R)
      COEFF=COEFF*(CMPLX(Y*QA2R,Y*QA2I)/DELTA)**K
C
C P2S1 and S1P2
C
307   K=ID(9)
      IF (K.EQ.0) GO TO 900
      Y=-4.*P*X1*SQRT(D2*D1QA2R*QB1R)
      COEFF=COEFF*(CMPLX(Y*QA1R,Y*QA1I)/DELTA)**K
      GO TO 900
C
C P1P1 turning point
C
310   COEFF=COEFF*CMPLX(0.,-1.)**K
      GO TO 301
C
C S1S1 turning point
C
311   COEFF=COEFF*CMPLX(0.,1.)**K
      GO TO 304
C
C P reflection/transmission coefficients for fluid/fluid interface
C
400   K=ID(1)
      IF (K.EQ.0) GO TO 401
      IF (P.GE.P1) GO TO 410
      COEFF=COEFF*(AAM/AAP)**K
C
C P1P2 and P2P1
C
401   K=ID(2)
      IF (K.EQ.0) GO TO 402
      COEFF=COEFF*(CMPLX(2.*SQRT(D2QA1R*D1QA2R),0.)/AAP)**K
C
C P2P2
C
402   K=ID(3)
      IF (K.EQ.0) GO TO 900
      COEFF=COEFF*(-AAM/AAP)**K
      GO TO 900
C
C P1P1 turning point
C
410   COEFF=COEFF*CMPLX(0.,-1.)**K
      GO TO 401
C
C P-SV reflection coefficients from a free solid surface
C
500   IF (S2.EQ.0.) GO TO 600
      X=(S2-P)*(S2+P)
      Y=X-PP
      X2=Y**2
      X=PP4*SQRT(X)
      QA2B2R=X*QA2R
      QA2B2I=X*QA2I
      DELTA=CMPLX(X2+QA2B2R,QA2B2I)
C
C P2S2 and S2P2
C
      K=ID(10)
      IF (K.EQ.0) GO TO 510
      COEFF=COEFF*(CMPLX(2.*Y*SQRT(QA2B2R),0.)/DELTA)**K
C
C -P2P2 and S2S2
C
510   K=ID(3)+ID(6)
      IF (K.EQ.0) GO TO 900
      COEFF=COEFF*(CMPLX(X2-QA2B2R,-QA2B2I)/DELTA)**K
C
C P2P2 from fluid free surface and correct P2P2 for solid surface
C
600   IF (MOD(ID(3),2).EQ.1) COEFF=-COEFF
C
900   RETURN
C
      END                                                               COEFF




      SUBROUTINE COMPON (P,VELS,ISS,VELR,IRR,COMP)                      COMPON
C
C-----------------------------------------------------------------------
C Routine to compute source and receiver component functions,
C equations (4) and (5) (see also equation (9)).
C-----------------------------------------------------------------------
C
C Input: P          = horizontal slowness
C        VELS(*)    = source parameters
C                     VELS(1) = P slowness at source
C                     VELS(2) = S slowness at source
C                                For a fluid, this is irrelevant and
C                                should be set zero for routine COEFF
C                     VELS(3) = density at source
C        ISS        = source type
C                     ISS = 1 for downgoing P source ray
C                         = 2 for downgoing SV source ray
C                         = 5 for upgoing P source ray
C                         = 6 for upgoing SV source ray
C        VELR(*)    = receiver parameters
C                     VELR(1) = P slowness at receiver
C                     VELR(2) = S slowness at receiver
C                                For a fluid, this is irrelevant and
C                                should be set zero for routine COEFF
C                     VELR(3) = density at receiver
C        IRR        = receiver type
C                     IRR = 1 for upgoing P receiver ray in medium
C                         = 2 for upgoing SV receiver ray in medium
C                         = 5 for downgoing P receiver ray in medium
C                         = 6 for downgoing SV receiver ray in medium
C                         = 9 for P receiver ray at free surface
C                         = 10 for SV receiver ray at free surface
C
C Output: COMP(*)   = components of M U and F U
C                     COMP(1) = Mzz Ux
C                     COMP(2) = Mxx Ux
C                     COMP(3) = (Mxz + Mzx) Ux
C                     COMP(4) = Mzz Uz
C                     COMP(5) = Mxx Uz
C                     COMP(6) = (Mxz + Mzx) Uz
C                     COMP(7) = Fz Ux
C                     COMP(8) = Fx Ux
C                     COMP(9) = Fz Uz
C                     COMP(10) = Fx Uz
C                     Note a factor of -sqrt(p/8)/pi**2 is included.
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation numbers refer to that paper.
C
C Calls: none
C
C Errors: Note it is assumed that the input parameters are all defined
C         sensibly and are compatible.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: C.H.Chapman
C
C Date: revised version, 24 July 1986
C
C Arguments:
C
      REAL P,VELS(*),VELR(*)
      INTEGER ISS,IRR
      COMPLEX COMP(*)
C
C Local variables:
C
      COMPLEX UX,UZ,QA,CC
      REAL QS(2),QR(2),C,FZ,FX,MZZ,MXX,MXZ,OMEGA
      INTEGER ISV,IRV,I
C
C Source and receiver types - 1 is P, 2 is SV
C
      ISV=MOD(ISS,4)
      IRV=MOD(IRR,4)
C
C Source and receiver vertical slownesses.
C
C Qalpha may be imaginary so include ABS.
C
      DO 100 I=1,2
          QS(I)=SQRT(ABS(VELS(I)-P)*(VELS(I)+P))
          QR(I)=SQRT(ABS(VELR(I)-P)*(VELR(I)+P))
100   CONTINUE
C
C Factor of -sqrt(p/8)/pi**2 * 1/sqrt(2*rho0*q0) * 1/sqrt(2*rho*q)
C from equations (9), (4) and (5).
C
      C=-1.791122E-2*SQRT(P/VELS(3)/VELR(3)/QS(ISV)/QR(IRV))
C
C Source components - equation (4)
C
      IF (ISV.EQ.2) GO TO 200
C
C P source.
C
C Body force source - equation (4b)
C
      FZ=QS(1)
      FX=P
C
C Moment tensor source - equation (4a)
C
      MZZ=FZ*FZ
      MXX=P*P
      MXZ=2.*FZ*P
      GO TO 210
C
C SV source.
C
C Body force source - equation (4d)
C
200   FZ=-P
      FX=QS(2)
C
C Moment tensor source - equation (4c)
C
      MZZ=-P*FX
      MXX=-MZZ
      MXZ=(FX-P)*(FX+P)
C
C Change source direction - equation (4)
C
210   IF (ISS.GE.5) GO TO 300
      FZ=-FZ
      MXZ=-MXZ
C
C Receiver components - equation (5)
C
300   IF (IRR.GE.9) GO TO 310
      IF (IRV.EQ.2) GO TO 320
C
C P receiver in medium - equation (5a)
C
      UX=CMPLX(C*P,0.)
      UZ=CMPLX(C*QR(1),0.)
      GO TO 330
C
C SV receiver in  medium - equation (5b)
C
320   UX=CMPLX(C*QR(2),0.)
      UZ=CMPLX(-C*P,0.)
C
C Change receiver ray direction - equation (5)
C
330   IF (IRR.GE.5) UZ=-UZ
      GO TO 400
C
C Receiver at free surface
C
C Test for fluid
C
310   IF (VELR(2).EQ.0.) GO TO 340
C
      OMEGA=(QR(2)-P)*(QR(2)+P)
      IF (IRR.EQ.10) GO TO 350
C
C P receiver at free surface - equation (5c)
C
      C=2.*C*VELR(2)**2*QR(1)/(4.*QR(1)*QR(2)*P**2+OMEGA**2)
      UX=CMPLX(2.*C*QR(2)*P,0.)
      UZ=CMPLX(C*OMEGA,0.)
      GO TO 400
C
C Fluid free surface
C
340   UX=CMPLX(0.,0.)
      UZ=CMPLX(2.*C*QR(1),0.)
      GO TO 400
C
C SV receiver at free surface - equation (5d)
C
C Note Qalpha can be imaginary
C
350   QA=CMPLX(QR(1),0.)
      IF (VELR(1).LT.P) QA=CMPLX(0.,QR(1))
      CC=2.*C*VELR(2)**2*QR(2)/(4.*QR(2)*QA*P**2+OMEGA**2)
      UX=CC*OMEGA
      UZ=-2.*P*CC*QA
C
C Combine source and receiver components
C
400   COMP(1)=MZZ*UX
      COMP(2)=MXX*UX
      COMP(3)=MXZ*UX
      COMP(4)=MZZ*UZ
      COMP(5)=MXX*UZ
      COMP(6)=MXZ*UZ
      COMP(7)=FZ*UX
      COMP(8)=FX*UX
      COMP(9)=FZ*UZ
      COMP(10)=FX*UZ
C
      RETURN
      END                                                               COMPON
c****************************************************************************
      COMPLEX FUNCTION COEFH (P,VEL1,VEL2,ID)                           COEFH
c        the same as function COEFF, but for SH waves
C
C-----------------------------------------------------------------------
C Routine to compute product of reflection/transmission coefficients at
C interface, equation (7).
C-----------------------------------------------------------------------
C
C Input: P          = horizontal slowness
C        VEL1(*)    = parameters above interface
C                     VEL1(1) = P slowness
C                     VEL1(2) = S slowness (zero for a fluid)
C                     VEL1(3) = density (zero for a free surface)
C        VEL2(*)    = parameters below interface
C                     VEL2(1) = P slowness
C                     VEL2(2) = S slowness (zero for a fluid)
C                     VEL2(3) = density
C        ID(*)      = multiplicity of coefficients. ID(k) is nu_ÌlkË
C                     where
C
C                                HH           HH      HH           HH
C                     k = 4 for R  , = 5 for T   and T  , = 6 for R
C                                D            D       U            U
C
C                     See figures 2 and 3.
C
C Output: COEFH     = product of reflection/transmission coefficients,
C                     e.g. inner product in equation (6) with
C                     equation (7).
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation numbers refer to that paper.
C
C Calls: none
C
C Errors: Note it is assumed that the input parameters are all defined
C         sensibly and are compatible.  If for S1S1, the
C         incident ray is evanescent, a turning ray is assumed.  For
C         other coefficients, if an incident or generated ray is
C         evanescent, then it probably indicates an error in the input
C         parameters.  The coefficient may be correct or may be zero
C         as the slownesses of the incident and generated rays are
C         assumed real in some places.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: V. Maupin, after subroutine COEFF of Chapman
C
C Date: July 1994
C
C Arguments:
C
      REAL P,VEL1(*),VEL2(*)
      INTEGER ID(*)
C
C Local variables:
C
C The code has been written to reduce the amount of unnecessary complex
C arithmetic.  This may not be necessary with smart FORTRAN compilers.
C DUM is used to simplify zeroing many variables.
C
      REAL DUM(12),P1,P2,S1,S2,D1,D2,eMU1,eMU2,PP,PP4,QA1R,QA1I,QA2R,QA2I,
     1 QB1R,QB1I,QB2R,QB2I,D2QA1R,D2QA1I,D1QA2R,D1QA2I
      COMPLEX AAP,AAM
      INTEGER K
C
      EQUIVALENCE (DUM(1),QA1R),(DUM(2),QA1I),(DUM(3),QA2R),
     1 (DUM(4),QA2I),(DUM(5),QB1R),(DUM(6),QB1I),(DUM(7),QB2R),
     2 (DUM(8),QB2I),(DUM(9),D1QA1R),(DUM(10),D1QA1I),(DUM(11),D2QA2R),
     3 (DUM(12),D2QA2I)
C
C Initialize COEFH=1
C
      COEFH=CMPLX(1.,0.)
C
C Test for non-zero coefficients
C
      DO 1 K=4,6
          IF (ID(K).NE.0) GO TO 2
1     CONTINUE
C
C Return if no coefficients - note COEFH=1
C
      RETURN
C
C Initialize variables
C
2     PP=P*P
      PP4=4.*PP
      DO 3 K=1,12
          DUM(K)=0.
3     CONTINUE
      S1=VEL1(2)
      D1=VEL1(3)
      emu1=d1/s1/s1
      S2=VEL2(2)
      D2=VEL2(3)
      emu2=d2/s2/s2
C
C Set up real or imaginary parts of vertical slownesses.
C Note Reimann sheet is defined by Im(q) >= 0.
C
C qa2
C
      X2=(S2-P)*(S2+P)
      IF (X2) 11,20,12
11    QA2I=SQRT(-X2)
      D2QA2I=emu2*QA2I
      GO TO 20
12    QA2R=SQRT(X2)
      D2QA2R=emu2*QA2R
C
C qa1
C
 20   continue
      X1=(S1-P)*(S1+P)
      IF (X1) 21,30,22
21    QA1I=SQRT(-X1)
      D1QA1I=emu1*QA1I
      GO TO 30
22    QA1R=SQRT(X1)
      D1QA1R=emu1*QA1R
C
C Aa+ and Aa- - equation (7l)
C
30    AAP=CMPLX(D1QA1R+D2QA2R,D1QA1I+D2QA2I)
      AAM=CMPLX(D1QA1R-D2QA2R,D1QA1I-D2QA2I)
C
C  reflection/transmission coefficients 
C
      K=ID(4)
      IF (K.EQ.0) GO TO 401
      IF (P.GE.S1) GO TO 410
      COEFH=COEFH*(AAM/AAP)**K
C
C H1H2 and H2H1
C
401   K=ID(5)
      IF (K.EQ.0) GO TO 402
      COEFH=COEFH*(CMPLX(2.*D2QA2R,2.*D2QA2I)/AAP)**K
C
C H2H2
C
402   K=ID(6)
      IF (K.EQ.0) GO TO 900
      COEFH=COEFH*(-AAM/AAP)**K
      GO TO 900
C
C H1H1 turning point
C
410   COEFH=COEFH*CMPLX(0.,-1.)**K
      GO TO 401
   
C
900   RETURN
C
      END                                                               COEFH

c*************************************************************************
      SUBROUTINE COMPOH (P,VELS,ISS,VELR,IRR,COMP)                      COMPON
C
C-----------------------------------------------------------------------
C Routine to compute source and receiver component functions,
C equations (4) and (5) (see also equation (9)).
C-----------------------------------------------------------------------
C
C Input: P          = horizontal slowness
C        VELS(*)    = source parameters
C                     VELS(1) = P slowness at source
C                     VELS(2) = S slowness at source
C                                For a fluid, this is irrelevant and
C                                should be set zero for routine COEFH
C                     VELS(3) = density at source
C        ISS        = source type
C                     ISS = 1 for downgoing P source ray
C                         = 2 for downgoing SV source ray
C                         = 5 for upgoing P source ray
C                         = 6 for upgoing SV source ray
C        VELR(*)    = receiver parameters
C                     VELR(1) = P slowness at receiver
C                     VELR(2) = S slowness at receiver
C                                For a fluid, this is irrelevant and
C                                should be set zero for routine COEFH
C                     VELR(3) = density at receiver
C        IRR        = receiver type
C                     IRR = 1 for upgoing P receiver ray in medium
C                         = 2 for upgoing SV receiver ray in medium
C                         = 5 for downgoing P receiver ray in medium
C                         = 6 for downgoing SV receiver ray in medium
C                         = 9 for P receiver ray at free surface
C                         = 10 for SV receiver ray at free surface
C
C Output: COMP(*)   = components of M U and F U
C                     COMP(1) = Mxy Uy
C                     COMP(2) = Mzy Uy
C                     COMP(3) = Fy Uy
C                     Note a factor of -sqrt(p/8)/pi**2 is included.
C
C Theory: See 'The WKBJ Seismogram Algorithm' by C.H.Chapman,
C         Chu Jen-yi and D.G.Lyness, in 'Seismological Algorithms',
C         Ed. D.J.Doornbos
C         Equation numbers refer to that paper.
C
C Calls: none
C
C Errors: Note it is assumed that the input parameters are all defined
C         sensibly and are compatible.
C
C Language: FORTRAN-77 (and other FORTRANs)
C
C Machine: VAX 11/750 (and many others)
C
C Author: V. Maupin, after subroutine COMPON of Chapman
C
C Date: July 1994
C
C Arguments:
C
      REAL P,VELS(*),VELR(*)
      INTEGER ISS,IRR
      COMPLEX COMP(*)
C
C Local variables:
C
      COMPLEX UY
      REAL QS,QR,C,FY,MXY,MZY
      INTEGER ISV,IRV,I
C
C Source and receiver vertical slownesses.
C
C Qbeta  may be imaginary so include ABS.
C
      DO 100 I=1,2
          QS=SQRT(ABS(VELS(2)-P)*(VELS(2)+P))
          QR=SQRT(ABS(VELR(2)-P)*(VELR(2)+P))
100   CONTINUE
C
C Factor of -sqrt(p/8)/pi**2 * 1/sqrt(2*rho0*q0) * 1/sqrt(2*rho*q)
C from equations (9), (4) and (5).
C
      C=-1.791122E-2*SQRT(P/VELS(3)/VELR(3)/QS/QR)
C
C Source components - equation (4)
C
C Body force source - equation (4b)
C
      FY=VELS(2)
C
C Moment tensor source - equation (4a)
C
      MXY=P*VELS(2)
      MZY=QS*VELS(2)
C
C Change source direction - equation (4)
C
      IF (ISS.GE.5) MZY=-MZY
C
C Receiver components - equation (5)
C
C receiver in medium - equation (5a)
C
      UY=C*CMPLX(1.,0.)*VELR(2)
C
C receiver at free surface - equation (5d)
C
      IF (IRR.EQ.10) UY=2.*UY 
C
C Combine source and receiver components
C
400   COMP(1)=MXY*UY
      COMP(2)=MZY*UY
      COMP(3)=FY *UY
C
      RETURN
      END                                                               COMPON

      subroutine findchan
     *(filehead,stat,com,chan,year,month,day,hour,min,sec,error)
c
c     Routine to find channel number corresponding to a station and component
c     Written by C. Lindholm  and j. havskov, Jan. - Apr -90
c
c     updates
c     oct 95 by jh    : do not read file directly 
c     nov 98 jh       : ----------   version 7.0 check --------------------
c                       5 char station
c     jan 26 lo         fixed bug with reading 5th station character
c     mar 2, 99 jh    : fix year also
c
c     input:       
c                  stat,com	   Station and component
c     output       chan            channel number
c                  year....        date and time of channel
c                  error           0: no error, 1: error, not found
c
       implicit none
       include 'seidim.inc'
c
c-- data file header
      character*80 filehead(max_trace)			
c-- Port and channel focused
      integer chan 				
c-- No. of channels in file
      integer number_of_channels		
c-- Time parameters of eventfile
      integer year,doy,month,day,hour,min	
c-- Time parameters of eventfile
      integer year1,month1,day1,hour1,min1	
c-- ----------------------------
      real    sec,sec1
c-- counters
      integer i,j,k		
c-- Station and component info
      character*5 station(max_trace),stat
      character*4 comp(max_trace),com	
c-- 1: error, 0: no error
      integer error				
c-- berit
      double precision sein(max_trace)
c
c

c
cccccc     read datafile headers     cccccc
c
ccccc     read fileheader info ccccccccccccccccccc
c
      read(filehead(1),50)number_of_channels,year,doy,
     +                            month,day,hour,min,sec
      year=year+1900
50    format(8x,22x,i3,i3,1x,i3,4(1x,i2),1x,f6.3)
      j = 1
c
c  read individual channel delays to calculate channel start times
c
      k=(number_of_channels-1)/3+1
      do i= 3,k+2
         read(filehead(i),100)
     *   station(j)  (1:4),comp(j),  station(j)(5:5),sein(j),  ! bugfix lo
     *   station(j+1)(1:4),comp(j+1),station(j+1)(5:5),sein(j+1),
     *   station(j+2)(1:4),comp(j+2),station(j+2)(5:5),sein(j+2)
100      format(1x,a4,a4,a1,f7.2,10x,a4,a4,a1,f7.2,10x,a4,a4,a1,f7.2)
C
ctest            write(6,201)station(j),sein(j),station(j+1),sein(j+1),
ctest     +      station(j+2),sein(j+2)
 201        format(3(1x,a4,1x,f8.2))
C
        j = j + 3
      enddo
c
c   find channel corresponding to station
c
      error=0
      do i=1,number_of_channels
         if(stat.eq.station(i).and.comp(i).eq.com) then
            chan=i
C
c       WRITE(*,*)year,month,day,hour,min,sec
C
c    berit
            call timadd(year,month,day,hour,min,sec,sein(i),
     +  year1,month1,day1,hour1,min1,sec1)

        year=year1
        month=month1
        day=day1
        hour=hour1
        min=min1
        sec=sec1
C
c      WRITE(6,*)year,month,day,hour,min,sec
C
            return
         endif
      enddo
c
      error=1
      return
      end

      subroutine azibazi(alats,alongs,alatr,alongr,delta,azim,bazim)
c
c
c   changes
c
c   sep 98 by jh ----------- version 7.0 check ------------------
c                no changes
c   feb 12, 2008, jh: check for range of acos
c    
c   INPUT:  alats, alongs: latitude and longitude of the source
c           alatr, alongr: latitude and longitude of the receiver
c   OUTPUT: delta: the epicentral distance
c           azim : the azimuth at the source
c           bazim: the back-azimuth at the station
c   Note: all the elements are angles given in degrees. 
c         this subroutine does not account for the Earth's ellipticity
c
c   There is no garantee that the subroutine will work in absolutely all
c   cases, but it has been tested and should work across the line of change
c   of day for example.
c   December 1994. Valerie Maupin.
c
      degpi = 180./3.14159
c
      alon = alongr-alongs
      if (alon.lt.-180.) alon=alon+360.
      if (alon.gt.180.) alon=alon-360.
      if (alon.ge.0.)  then
        c = alon/degpi
        aa = (90. - alats)/degpi
        bb = (90. - alatr)/degpi
      else
        c = -alon/degpi
        aa = (90. - alatr)/degpi
        bb = (90. - alats)/degpi
      endif
      cc = cos(aa)*cos(bb) + sin(aa)*sin(bb)*cos(c)
      if(cc.gt.1.0) then
        write(6,*) 'acos',cc
        cc=1.0
      endif
      if(cc.lt.-1.0) then
        write(6,*) 'acos',cc
        cc=-1.0
      endif
 
      cc = acos(cc)
      a = (cos(aa) - cos(bb)*cos(cc))/(sin(bb)*sin(cc))
      if(a.gt.1.0) then
        write(6,*) 'acos',a
        a=1.0
      endif
      if(a.lt.-1.0) then
        write(6,*) 'acos',a
        a=-1.0
      endif
      a = acos(a)
      b = (cos(bb) - cos(aa)*cos(cc))/(sin(aa)*sin(cc))
      if(b.gt.1.0) then
        write(6,*) 'acos',b
        b=1.0
      endif
      if(b.lt.-1.0) then
        write(6,*) 'acos',b
        b=-1.0
      endif
      b = acos(b)
c
c ... calculate the epicentral distance 
c                 you must choose between degrees or kilometers 
c                 and comment out one of these two lines 
      delta = cc*degpi
c     delta = cc*6371. 
c
c ... calculate the azimut and backazimuth
      if (alon.ge.0.)   then
        azim = b*degpi
        bazim = 360. - a*degpi
      else
        azim = 360. - a*degpi
        bazim = b*degpi
      endif
c
c.......calculate the coordinates of the mid-point
c                          (if this element is of interest to you,
c                          add (alat,along) in the argument list)
c
      cc=cc/2.
      dd = cos(aa)*cos(cc) + sin(aa)*sin(cc)*cos(b)
      if(dd.gt.1.0) then
        write(6,*) 'acos',dd
        dd=1.0
      endif
      if(dd.lt.-1.0) then
        write(6,*) 'acos',dd
        dd=-1.0
      endif
      dd = acos(dd)
      alat= 90. - dd*degpi
      c3 = (sin(bb)*cos(cc)- sin(cc)*cos(bb)*cos(a))/sin(dd)
      if(c3.gt.1.0) then
        write(6,*) 'acos',c3
        c3=1.0
      endif
      if(c3.lt.-1.0) then
        write(6,*) 'acos',c3
        c3=-1.0
      endif
      c3 = acos(c3)
      if (alon.ge.0.)  along = alongr - c3*degpi
      if (alon.lt.0.)  along = alongs - c3*degpi
      if (along.lt.-180.) along=along+360.
      if (along.gt.180.) along=along-360.
c
      return 
      end

c**************************************************************
c subroutine to find travel times for a given offset using a
c gradient model. Inputs are the same as for dtdx2          
c Presently, the routine only calculates the minimum
c travel time, regardless of ptype
c Refraction can also only occur in the bottom (half-space)
c layer               
c no phase ID is returned in phsid
c
c Barry Lienert June 1998
c
c changes
c
c sep 98 by jh : ----------- seisan version 7.0 check ----------------
c                no changes                         
c
c  oct 28 99 bmt : linux changed, save and *
c  nov 19 99 jh  : nl and parm in common block
c  may 15 00 jh  : fix bugs cause by above
c
      subroutine dtdxg(xh,x0,ptype,nmoho,nconrad,iulst,tmin,
     &delta,ann,iflag,phsid)
      save
      include 'hypparm.inc'  
      character*1 ptype
      character*8 phsid  
      dimension dcrit(200),z(200),grad(200),vr(200)
c      data pi2/1.57079/
      data pi2/1.57079633/
c get epicentral distance from event to station      
      call delaz(x0(2),x0(1),delta,dedeg,azz0,xh(2),xh(1))
      delta=abs(delta)
c calculate needed parameters
      nn=nl*2-1
      n_layer=nl
c      n_layer=(nn+1)/2   ! nov 19 jh            
      n_iter=20         !# iterations to find delta
      phi_incr=.001     !slowness increment in iterations
      sum=0.0
      do i=1,n_layer
cx       v(i)=parm(i)     !layer velocity
cx       d(i)=parm(nl+i)  !layer thickness
       z(i)=sum         !layer depth
       sum=sum+parm(n_layer+i)
      end do                                   

      z_hypo=xh(3)

c find n_hypo, the layer that the hypocenter is in
      n_hypo=n_layer
      do i=1,n_layer-1
       d(i)=z(i+1)-z(i)             
       vr(i)=v(i+1)/v(i)
       grad(i)=(v(i+1)-v(i))/d(i)
       if(z(i).le.z_hypo)n_hypo=i
      end do 
c now find v_hypo
      if(n_hypo.lt.n_layer)then
       v_hypo=v(n_hypo)+grad(n_hypo)*(z_hypo-z(n_hypo))
      else 
       v_hypo=v(n_layer)
      endif 
c find v_max, max vel above hypocenter
      v_max=0.0
      do i=1,n_hypo
       if(v(i).gt.v_max)v_max=v(i)
      end do 

      if(delta.gt.0.0)then
c find the critical distance, dcrt & time, tcrt
       pcrit=1./v(n_layer)
       phi=2.*pi2-asin(pcrit*v(n_hypo))
       call ttcal(n_layer,v,z,d,vr,grad,z_hypo,pcrit,phi,dcrt,tcrt,
     &  n_hypo,v_hypo,v_max,iflagd)                           
c extend the travel time from dcrt to delta using v(n_layer)
       if(delta.ge.dcrt)then
        tmin=tcrt+(delta-dcrt)/v(n_layer)
        iflagd=1
        return
       endif 
c find p for the ray that exits the hypocenter layer at a
c horizontal offset delta (see Lee & Stewart, 1981, p 93)
       eta=z_hypo-z(n_hypo)
       xc=0.5*(delta*delta-2.*eta*v(n_hypo)/grad(n_hypo)-eta*eta)/delta
c      zc=v(1)*d(1)/(v(2)-v(1))
       zc=v(n_hypo)/grad(n_hypo)
c phi is the ray direction measured clockwise from the upward vertical
       phi=atan2(-zc-eta,-xc)
       p=abs(sin(phi))/v(n_hypo)
c       phi=atan(2.*zc/delta)
      else
c zero delta case
       phi=2.*pi2
       p=0.0
       if(z_hypo.eq.0.0)then
        tmin=0.0
        return
       endif 
      endif  

      if(z_hypo.ne.0.0)then
       if(delta.eq.0.0)then
        call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tmin,
     &   n_hypo,v_hypo,v_max,iflagd)
c p=0: don't need to iterate here
        return
       else 
c try a ray at the p calculated to make the ray leave the
c hypocenter layer at distance delta
        phi0=phi
        p0=p
        call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tmin,
     &   n_hypo,v_hypo,v_max,iflagd)
c ray did not come out: try smaller phi's        
        if(iflagd.eq.0)then 
         itr=0 
         phi=phi0
         do while(iflagd.eq.0.and.itr.lt.n_iter)
          phi=phi-phi_incr
          p=abs(sin(phi))/v(n_hypo) 
          call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tmin,
     &     n_hypo,v_hypo,v_max,iflagd)
          itr=itr+1
         end do    
         if(iflagd.eq.0)then !try other direction
          itr=0
          phi=phi0
          do while(iflagd.eq.0.and.itr.lt.niter)
           phi=phi+phi_incr
           p=abs(sin(phi))/v(n_hypo) 
           call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tmin,
     &      n_hypo,v_hypo,v_max,iflagd)
           itr=itr+1
          end do
         endif
        else
c         dist0=dist
         phi=phi0
         do while(iflagd.eq.0.and.itr.lt.niter)
          phi=phi-phi_incr
          p=abs(sin(phi))/v(n_hypo) 
          call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tmin,
     &     n_hypo,v_hypo,v_max,iflagd)
c         write(iulst,'(3f12.4)')delta,dist0,dist
         end do
         if(iflagd.eq.0)then
          do while(iflagd.eq.0.and.itr.lt.niter)
           phi=phi+phi_incr
           p=abs(sin(phi))/v(n_hypo) 
           call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tmin,
     &     n_hypo,v_hypo,v_max,iflagd)
          end do
         endif
         itr=0
         do while (abs(dist-delta).gt.0.01.and.itr.lt.niter)
          if(dist.ne.dist0)then
           slope=(phi-phi0)/(dist-dist0) 
           if(slope.gt..1)slope=.1
           if(slope.lt.-.1)slope=-.1
          endif 
          phi0=phi
          p0=p
          phi=phi0+slope*(delta-dist)
          p=abs(sin(phi))/v(n_hypo)
          dist0=dist
          call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,
     &     tmin,n_hypo,v_hypo,v_max,iflagd)
c          write(iulst,'(i3,4f10.4)')itr,p,phi,dist0,dist
          itr=itr+1
         end do
        endif                            
       endif
      else
       call ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tmin,n_hypo,
     &  v_hypo,v_max,iflagd)
      endif                            
c      write(iulst,*)p,delta,dist,itr
      return
      end

c********************************************************************
c  calculates distance and travel time as a function of ray parameter
c  for a gradient model
c  modified from Fred Klein's TTCAL routine by Barry Lienert, June 98
c********************************************************************
      subroutine ttcal(n_layer,v,z,d,vr,grad,z_hypo,p,phi,dist,tp,
     & n_hypo,v_hypo,v_max,iflagd)
c     Inputs: n_layer=number of layers in velocity model
c             v(i)=velocities in km/s
c             z(i)=layer top positions in km
c             z_hypo=hypocentral depth in km
c             p=ray parameter in s/km
c
c     Outputs: dist=delta in km
c              tp=travel time in s
c              iflagd=1 for valid arrival, zero otherwise
c
      save
      parameter (maxlayer=200)
      real cp(maxlayer),vr(maxlayer)
      real v(maxlayer),z(maxlayer),d(maxlayer),grad(maxlayer)
c      data pi2/1.57079/
      data pi2/1.57079633/
c--case of a ray travelling straight up (p=0)
      if(p.eq.0.0)then
       phid=0.
       dist=0.
       tp=(z_hypo-z(n_hypo))/v(n_hypo)
       if (grad(n_hypo).ne.0.)then
        tp=alog(v_hypo/v(n_hypo))/grad(n_hypo)
       endif 
       if (n_hypo.gt.1)then
        do i=1,n_hypo-1
         temp=d(i)/v(i)
         if (grad(i).ne.0.) temp=alog(vr(i))/grad(i)
         tp=tp+temp
        end do 
       endif
       tr=tp
       iflagd=1
       return
      endif 

c sph is sin(phi) where phi is angle at which ray leaves the hypocenter
      sph=sin(phi)
      cph=cos(phi)                                       
      p=sph/v_hypo
      
c case of no upward ray
      if(p.ge.1./v_hypo)then
       tp=-1.
       dist=-1.
       iflagd=0
       return
      endif 

c vb is the bottoming velocity
      vb=1./p
c--n_bottom is the layer in which downgoing ray bottoms
      n_bottom=1
      do while (v(n_bottom+1).lt. vb.and.n_bottom.lt.n_layer)
       n_bottom=n_bottom+1
      end do 
c--calc depth at ray bottom, zb
      zb=z(n_bottom)
      if (grad(n_bottom).ne.0.) zb=zb+(vb-v(n_bottom))/grad(n_bottom)

c++++++++++++ ray lost to waveguide ++++++++++++
c--now have case of ray going into waveguide formed by a lvz
c--flag the nonexistent time and dist for this case
      if (vb.le.v_max .and. v_hypo.lt.v_max)then
       tp=-1.
       dp=-1.
       tr=-1.
       n_bottom=0
       iflagd=0
       return
      endif 

c++++++++++++ calculate time and distance ++++++++++++
c--calc t and d since it is valid to do so. consider all 3 cases:
c  1 ray nearly horiz in layer of zero gradient
c  2 upgoing ray
c  3 downgoing ray
c--for each term must consider zero and non-zero gradients as sep cases

c--case 1. nearly horiz non-curving ray+++++++++++
      if (grad(n_hypo).eq.0..and.phi.le.0.001)then
c--set dist to be some arbitrary but large no
       dist=100000.
       tp=100000./v(n_hypo)
       iflagd=1
       return
      endif 

c--case 2.   upgoing ray+++++++++++++++++++++++++++
c      if (phi.le.pi2+.0005)then
      if (phi.le.pi2)then
c--calc cosines of emergence angles at each interface
       ss=1.0
       if(phi.gt.pi2.and.phi.le.2.*pi2)ss=-1.
       if(phi.gt.2.*pi2.and.phi.le.3.*pi2)ss=-1.
       if(phi.gt.3.*pi2.and.phi.le.4.*pi2)ss=1.
       
       do i=1,n_hypo
        cp(i)=ss*sqrt(abs(1.-(v(i)*p)**2))
       end do 

c--contribution to tp and dist of layer in which hypo lies
       if (grad(n_hypo).gt.0.)then
        dist=(cp(n_hypo)-cph)/(p*grad(n_hypo))
        if(cph.gt.-1.0)then
         tp=alog(v_hypo*(1.+cp(n_hypo))/(v(n_hypo)
     &    *(1.+cph)))/grad(n_hypo)
        else
         tmin=-1.0
         dist=-1.0
         iflagd=0
         return
        endif 
       else
        dist=(z_hypo-z(n_hypo))*sph/cph
        tp=(z_hypo-z(n_hypo))/(cph*v_hypo)
       endif

c--add contributions from layers above hypo
       if (n_hypo.gt.1)then
        do i=1,n_hypo-1
         if (grad(i).gt.0.)then
          dist=dist+(cp(i)-cp(i+1))/(p*grad(i))
          tp=tp+alog(vr(i)*(1.+cp(i))/(1.+cp(i+1)))/grad(i)
         else
          dist=dist+d(i)*p*v(i)/cp(i)
          tp=tp+d(i)/(cp(i)*v(i))
         endif
        end do
       endif  
       iflagd=1
       return
      
      else
       
c case 3  downgoing ray +++++++++++++++++++++++++++++
c--calc cosines of emergence angles at layer interfaces
       do i=1,n_bottom
        cp(i)=sqrt(1.-(v(i)*p)**2)
       end do 
c--contribution to t and d from layer in which ray bottoms
       if (grad(n_bottom).gt.0.)then
        dist=2.*cp(n_bottom)/(p*grad(n_bottom))
        tp=2.*alog((1.+cp(n_bottom))/(v(n_bottom)*p))/grad(n_bottom)
       else
c--a ray can't bottom in a homogeneous layer
c--if this case should arise, reflect ray from top of the layer
        dist=0.
        tp=0.
       endif 
c--subtract contribution from path immed above hypo in its layer
       if (grad(n_hypo).gt.0.)then
        dist=dist-(cp(n_hypo)-cph)/(p*grad(n_hypo))
        tp=tp-alog(v_hypo*(1.+cp(n_hypo))/(v(n_hypo)
     &   *(1.+cph)))/grad(n_hypo)
       else
        dist=dist-(z_hypo-z(n_hypo))*sph/cph
        tp=tp-(z_hypo-z(n_hypo))/(cph*v_hypo)
       endif 
c--sum terms over layers above hypo
       if (n_hypo.gt.1)then
        do i=1,n_hypo-1
         if (grad(i).gt.0.)then
          dist=dist+(cp(i)-cp(i+1))/(p*grad(i))
          tp=tp+alog(vr(i)*(1.+cp(i))/(1.+cp(i+1)))/grad(i)
         else
          dist=dist+d(i)*p*v(i)/cp(i)
          tp=tp+d(i)/(cp(i)*v(i))
         endif
        end do
       endif   
c--sum terms over layers between hypo and ray bottom (if any)
c--include layer in which hypo lies
       if (n_hypo.ne.n_bottom)then 
        do i=n_hypo,n_bottom-1
         if (grad(i).ne.0.)then
          dist=dist+2.*(cp(i)-cp(i+1))/(p*grad(i))
          tp=tp+2.*alog(vr(i)*(1.+cp(i))/(1.+cp(i+1)))/grad(i)
         else
          dist=dist+2.*d(i)*p*v(i)/cp(i)
          tp=tp+2.*d(i)/(cp(i)*v(i))
         endif
        end do
       endif
       iflagd=1
       return  
      endif 
      end

c
c   Program to resample seisan waveform files jh, dec 95
c
c   The program uses an filenr.lis input file. All files are read,
c   filtered and resampled. Then written out as one new file.
c   The maximum number of channels handles is max_chan_out which
c   is set as a parameter. Only the first max_chan_out channels
c   are used or less if fewer channels in file.
c   A blank line followed by a new group of file will make a new 
c   output file.
c
c   It is assued that all channels have the same start and end times
c   and that the sample rate is the same. The decimation MUST be a number
c   which can be divided up in rate. E.g. for rate 75, it can be 75,25,15,
c   5 or 3.
c
c   The files are checked for time consistency. If the the time calculated
c   from the last header time of a file and the last sample does not agree 
c   the header time of the following file within an error set in the program
c   (variable err_samp) two cases are considered:
c
c   The next file starts later: Could be becuse there has been a stop and 
c                               zeros are filled in
c   The next file starts earlier: There must be a serious timing error in the
c                                data. The user gets the choice to stop.
c
c
c   The sample rate for the resmapled file, if more than one input file, is 
c   calculated from the header times of the first and last files. Zeros put
c   in will be then into account
c   updates
c
c   The DC value must be removed to avoid problem when doing antialias
c   filtering. In order to avoid steps in the data, the dc level from
c   the first file is used throughtout the whole resample process.
c
c   resamp.out gives info on each file
c
c
c   oct 15 97 by jh: bug when missing files
c   dec 11         : remove dc before filtering
c   jun 8, 98      : fix problem of format error in sample rate write
c   april 7 99  jh :  --------------  version 7.0 upgrade------------
c   march 13 00 jh : err_samp increased from 70 to 300
c   oct 3    00 jh : possibel to write a time larger than 100 000
c
      implicit none
      include 'seidim.inc'                     ! dimensions
C
C    Seisan library details...
C    -------------------------
C
      INCLUDE   'libsei.inc'                   ! Definitions and data defns.
      external  sei open,                      ! Open file handler.
     &          sei close,                     ! Close file handler.
     &          sei code,                      ! Error handler.
     &          sei clen                       ! String length
      integer   sei clen                       ! Function.
      real      sei real num   
c
      integer   code,                          ! Local error condition.
     &          read1                          ! Read unit 1.
      logical   b_flag                         ! Flag existance.?
C
C    -------- end ------------
c                                                                               
c                                                                               
c   local variables                                                             
c                                                          
      integer max_chan_out                ! max number of channels out
      parameter (max_chan_out=7)   
      character*80 mainhead(12)           ! main header
      character*80 mainhead_out(12)       ! output ----
      character*1040 chead                ! channel header                     
      character*1040 chead_out(max_chan_out)         ! output channel header
      integer isamp(max_chan_out)         ! output sample counter                                                                                
      character*5 net_code                ! code for resampled file
      integer skip                        ! skipping for resampling
      integer ifile                       ! file counter
      integer nfile                       ! number of files in one sequence
      integer ichan                       ! channel counter
      integer passes                      ! number of passes through filter
      integer npoles                      ! number of poles
      integer numb_samp                   ! number of samples, one trace
      integer numb_samp_total             ! -------------------------, all
      integer unit_wave                   ! unit to read waveform file from
      integer write01                     ! unit for writing
      integer nmiss                       ! number of files missing in a series
      real err_samp                       ! number of samples tolerated as error
      real time_shift                     ! accumulated time shift, one output f
                                          ! between two files
      real rate                           ! sample rate from header
      real rate_out                       ! sample rate calculated
      logical more_files                  ! there could be more files
c-- plotting string                                      
      character*80 files(200)             ! waveform file name
      character*80 out_file               ! resampled file name
c-- dc value                                                      
      real 	dc		
      integer nchan                          ! number of channels in file
      integer nchan_out                      ! number of channels out
      double precision   file_start_time     ! abs file start time
      double precision   file_end_time       ! abs file end time
      double precision   first_file_time     ! abs file time, first file
      character*80       text                ! help text
      character*2        new_comp            ! first 2 letters of comp code in
                                             ! decimated output
      real total_time
      integer year1,month1,day1,hour1,min1    ! time etc
      real sec1
c-- counters and help varibales
      integer	i		
      real x
      integer data_out(max_chan_out,max_sample)  ! resampled data
      real filt                  ! anti alias filter frequency
c
c  for seisin common block
c
      real data(max_sample)
      real baz(max_trace)
      real        del_rot       ! delay rotated trace
      character*1 rot_comp(max_trace)  ! T or R
      logical rotate

      common /signalx/data,rotate,baz,rot_comp,del_rot !for seisinc


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c
c
c   assume for the time filter and skip, used with 75 hz data to 1 hz data
c
      npoles=6
      filt=0.1 
      skip=75
      err_samp=300    ! max number of samples error between two files
      new_comp='L '  ! assuming decimaiton to LP
      write(6,'(a,3x,i7)')      ' Decimation is:', skip
      write(6,'(a,3x,f7.1)')    ' Filter is    :',filt
      write(6,'(a,8x,a)')       ' New component:', new_comp
      write(6,*)
     *' If ok, return, else enter new value for decimation'
      read(5,'(a)') text
      if(text(1:3).ne.'   ') then
         x=seirealnum(text,code)
         skip=x
         write(6,*)' Enter filter frequency'
         read(5,*) filt
         write(6,*)' Enter new component code, max 2 chars'
         read(5,'(a)') new_comp
      endif
      write(6,*)
     *' Enter new network code, default is channel one station'
      read(5,'(a5)') net_code
c
c  open logging file
c
      open(27,file='resamp.out',status='unknown')
c
c    open file containing list of files numbered                                
c    -------------------------------------------
c                                                                               
      call sei open( old$+warn$,           ! Open & warn of errors.
     &               ' ',                  ! No prompt.
     &               'filenr.lis',         ! Filename.
     &               read1,                ! Open on unit.
     &               b_filenr$,            ! Flag existance & usage?.
     &               code )                ! Condition.
      chr_err_msg$ = 
     &'**** FATAL: problem opening "filenr.lis"'
      call sei code( stop$, code, 0, b_flag ) ! Force an abort on error.
c
c   get  here for another set of files to convert
c
 500  continue
c
c   set some defaults
c
      time_shift=0.0
      ifile=1
      do i=1,max_chan_out
         isamp(i)=0                               ! reset output sample counter
      enddo
      numb_samp_total=0
c
c  file read loop
c
 1000 continue
c
c   get next file name
c
      read(read1,'(7x,a)',iostat=code) files(ifile)           ! Read a record.
      call sei code( fort$, code, read1, b_flag )             ! Process outcome.
      if( b_flag ) goto 1999                                  ! On end of file.
c-- no more files                        
      if(files(ifile)(1:5).eq.'     ') then ! if blank, ind. new group or eof
         more_files=.true.                ! there could be more files
         nfile=ifile-1                    ! the last was blank
         if(nfile.eq.0) goto 1000         ! could be more blanks
         goto 1200
      endif
      ifile=ifile+1
      goto 1000                           ! read next file
c
c   read filenames of one group, now process
c
 1200 continue
c
c   open and read first file to get specifics
c
      write(6,*)'*********************************************'
      write(6,*) ' Number of files to resample:', nfile
      write(6,*)
      chr_f_access$ = 'direct'            ! Type of file.
      f_recl$=2048                        ! Record length
      call sei get file( open$+ignore$,   ! Open waveform file.
     &                   unit_wave,       ! On unit.
     &                   code,            ! Returned condition.
     &                   'WAV',           ! Alternative search directory.
     &                   files(1))        ! For this filename.
 
         if( code .ne. e_ok$ ) then       ! File does not exist
            write(*,*)
            write(*,*)
     &'**** WARN: ',files(ifile)(:seiclen(files(ifile)))
     &,' does not exist ****'
            write(*,*)
            call sei code(stop$,e_misf$,0,b_flag) ! & stop.
         end if                                   !
c
c   read main header 
c
      call seisinc                                                           
     *(unit_wave,0,nchan,0,
     *mainhead,chead,0.0,0.0)
      call sei close( close$, unit_wave, code )       ! Close down file
c
c   check for error
c
      if(nchan.lt.0) then
         write(6,*)' Something wrong with first file in a sequence'
         stop
      endif
c
c   save header and file name
c
         do i=1,12
            mainhead_out(i)=mainhead(i)
         enddo
c
c   if more than max_chan_out channels, cut down to max_chan_out 
c
      if(nchan.gt.max_chan_out) then
         write(6,*)' Input file has ',nchan,' channels'
         write(6,*)' The output will only use ',max_chan_out
         nchan_out=max_chan_out
      else
         nchan_out=nchan
      endif
      write(6,*)' Number of channels to resample:',nchan_out
c
c-------------------------------------------
c   loop for channels
c-------------------------------------------
c                           
      do 1600 ichan=1,nchan_out
c
c   loop for files
c
      do 1500 ifile=1,nfile
         write(6,'(1x,a)') files(ifile)
         write(27,'(1x,a)') files(ifile)
         chr_f_access$ = 'direct'            ! Type of file.
         f_recl$=2048                        ! Record length
         call sei get file( open$+ignore$,   ! Open waveform file.
     &                      unit_wave,       ! On unit.
     &                      code,            ! Returned condition.
     &                      'WAV',           ! Alternative search directory.
     &                      files(ifile))    ! For this filename.
 
         if( code .ne. e_ok$ ) then       ! File does not exist
            write(*,*)
            write(*,*)
     &      '**** WARN: ',files(ifile)
     &      (:seiclen(files(ifile))),' does not exist ****'
            write(*,*)
            call sei code(stop$,e_misf$,0,b_flag) ! & stop.
         end if                                   !
         call seisinc                                                           
     *   (unit_wave,ichan,nchan,2,
     *   MAINHEAD,chead,0.0,0.0)
         write(6,'(1x,a)')mainhead(1)(1:79)            
         write(27,'(1x,a)')mainhead(1)(1:79)            
         write(6,'(1x,a)') chead(1:79) 
c
c   check for error
c
         if(nchan.lt.0) then
            write(6,*)' Something wrong with input file'
            stop
         endif
c
c   if first file, save channel header
c
         if(ifile.eq.1) then
           chead_out(ichan)=chead
         endif           
c                                                    
c   get srate and number of samples                                               
c                                                                               
         read(chead(37:50),'(f7.2,1x,i6)') rate,numb_samp                       
         if(ichan.eq.1) numb_samp_total=numb_samp_total+numb_samp
c
c   get times
c
         read(chead(10:12),'(i3)') year1
         year1=year1+1900
         read(chead(18:35),'(4(i2,1x),f6.3)')month1,day1,hour1,min1,sec1
         call timsec(year1,month1,day1,hour1,min1,sec1,file_start_time)
c
c   save start time an dmake output file name if first file
c
         if(ifile.eq.1) then
           first_file_time=file_start_time
c-- year
           write(out_file(1:4),'(i4)') year1
           out_file(5:5)='-'
c-- month
           write(out_file(6:7),'(i2)') month1
           out_file(8:8)='-'
c-- day
           write(out_file(9:10),'(i2)') day1
           out_file(11:11)='-'
c-- hr
           write(out_file(12:13),'(i2)') hour1
c-- min
           write(out_file(14:15),'(i2)') min1
           out_file(16:16)='-'
c-- sec
           write(out_file(17:18),'(i2)') int(sec1)
           out_file(19:20)='R.'
c-- network or station code
           if(net_code.eq.' ') then
              out_file(21:25)=chead(1:5)
           else
              out_file(21:25)=net_code
           endif
           out_file(26:26)='_'
c-- number of channels
           write(out_file(27:29),'(i3)') nchan
c-- check for blanks
           do i=1,20
              if(out_file(i:i).eq.' ') out_file(i:i)='0'
           enddo
           do i=21,29
              if(out_file(i:i).eq.' '.or.ichar(out_file(i:i)).eq.0) 
     *        out_file(i:i)='_'
           enddo

         endif
c
c   check if start time is what to be expected, allow for a few samples 
c   error, only check if not the first file
c
         if(ifile.gt.1) then
c
c   check for next file starting before end of previous file
c   for the time being, let the error be 3 times larger than positive
c   errors
c
            if(file_start_time+3*err_samp/rate.lt.file_end_time) 
     *      then
               write(27,*)' Next file starts before end of previous',
     *                   ' file with the amount:', (file_end_time-
     *                   file_start_time)
                         write(27,'(a)') files(ifile)
                         write(27,*)
     *                   ' Next file starts before end of previous',
     *                   ' file with the amount:', (file_end_time-
     *                   file_start_time)
               write(27,*)
               write(6,*)' Next file starts before end of previous',
     *                   ' file with the amount:', (file_end_time-
     *                   file_start_time)
                         write(27,'(a)') files(ifile)
                         write(27,*)
     *                   ' Next file starts before end of previous',
     *                   ' file with the amount:', (file_end_time-
     *                   file_start_time)
               write(27,*)
               write(6,*)'Continue (y/n)'
c              read(5,'(a)') answer
c              if(answer.ne.'y'.and.answer.ne.'Y') stop 
            endif
c
c   check for next file starting after previous file, if only a few samples
c   assume problems with sample rate and continue since this can be fixed later
c
            write(27,*)'file start time',file_start_time
            write(27,*)'file end   time',file_end_time
            write(27,'(a,f20.3)') ' time difference start - end  ',
     *      file_start_time-file_end_time
            time_shift=time_shift+ (file_start_time-file_end_time)
            write(27,*)
            if(file_start_time.gt.file_end_time+err_samp/rate) then
               write(6,*)' Data missing for time interval: ',
     *         file_start_time-file_end_time
               write(6,*)' Will be filled out with zeroes'
               write(27,*)' Data missing for time interval: ',
     *         file_start_time-file_end_time
               write(27,*)' Will be filled out with zeroes'
c
c   find out how many samples are missing, assume the same 
c   sample rate as last file, round off to nearest sample
c
               nmiss=(file_start_time-file_end_time+0.5/rate)*rate
               write(6,*)' Number of samples missing: ',nmiss
               write(27,*) ' Sample rate',rate
               write(27,*)' Number of samples missing: ',nmiss
c
c   add to total number of samples
c
               if(ichan.eq.1) numb_samp_total=numb_samp_total+nmiss
c
c   put in zeroes
c
                  do i=1,nmiss,skip
                     isamp(ichan)=isamp(ichan)+1
                     data_out(ichan,isamp(ichan))=0
                  enddo
            endif
         endif
c
c   remove dc and filter
c
        passes=-1                    ! overlap filter
        if(ifile.eq.1)then 
           dc=0.0
           do i=1,numb_samp
              dc=dc+data(i)
           enddo
           dc=dc/numb_samp
           passes=1      ! first time, reset filter buffers
        endif
c
c   same dc for all files
c
        do i=1,numb_samp
           data(i)=data(i)-dc
        enddo
c
        call recfil(data,numb_samp,data,'BU      ',0.0,0.0,npoles,
     *  'LP      ',0.0,filt,1.0/rate,passes)

c
c  resample
c
         do i=1,numb_samp,skip
           isamp(ichan)=isamp(ichan)+1
           data_out(ichan,isamp(ichan))=data(i)
         enddo
c
         call sei close( close$, unit_wave, code )       ! Close down file
         file_end_time=file_start_time+(numb_samp)/rate ! start of next file
c
c  end of file loop
c
 1500 continue
c
c   end of channel loop
c
 1600 continue
c
c-----------------------------------------------------------------------
c   enter here when all files read for one sequence
c-----------------------------------------------------------------------
c
c
 1700 continue
c
c   calculate observed sample rate if more than one file read, assume
c   file follow each other
c
      if(nfile.gt.1) then
         rate_out=
     *   (file_start_time-first_file_time)/(numb_samp_total-numb_samp)
         rate_out=1.0/rate_out
         write(6,*) 'Sample rate from header times:', rate_out
         write(27,*) 'Sample rate from header times:', rate_out
         write(6,*)  'Accumulated time shift',time_shift
         rate=rate_out
      endif
c
c  calculate new sample rate
c
      rate=rate/float(skip)
c
c   finish making main header and write it out, assume max 30 channels
c
      total_time=float(isamp(1))/rate       ! assume all channels same isamp
      write(mainhead_out(1)(61:69),'(f9.2)') total_time
      write(mainhead_out(1)(31:33),'(i3)') nchan_out
      do i=3,(nchan_out-1)/3+3
         if(total_time.lt.100000.0) then
            write(mainhead_out(i)(19:26),'(f8.2)') total_time
            write(mainhead_out(i)(45:52),'(f8.2)') total_time
            write(mainhead_out(i)(71:78),'(f8.2)') total_time
         endif
         if(total_time.ge.100000.0) then
            write(mainhead_out(i)(19:26),'(f8.1)') total_time
            write(mainhead_out(i)(45:52),'(f8.1)') total_time
            write(mainhead_out(i)(71:78),'(f8.1)') total_time
         endif
         mainhead_out(i)(6:7)=new_comp
         mainhead_out(i)(32:33)=new_comp
         mainhead_out(i)(58:59)=new_comp
      enddo
      write(6,'(a,1x,a)') ' Output file name is: ',out_file(1:40)
c
c   open file and write main header
c
      chr_f_form$ = 'unformatted'
      call sei open( unknown$,             ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   out_file,         ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
      do i=1,12
         write(write01)mainhead_out(i)
         if(i.lt.4) write(6,'(a79)') mainhead_out(i)(1:79)		 
      enddo
c
c   write channels, 99999945 to round off
c
      do ichan=1,nchan_out
         chead_out(ichan)(6:7)=new_comp
         write(chead_out(ichan)(37:50),'(f7.3,i7)')rate,isamp(ichan)
         if(rate.lt.99.999945)
     *   write(chead_out(ichan)(37:50),'(f7.4,i7)')rate,isamp(ichan)
         if(rate.lt.9.9999945)
     *   write(chead_out(ichan)(37:50),'(f7.5,i7)')rate,isamp(ichan)
         if(rate.lt.0.99999945)
     *   write(chead_out(ichan)(37:50),'(f7.6,i7)')rate,isamp(ichan)
         chead_out(ichan)(77:77)='4'    ! always store as 4 byte
         write(write01) chead_out(ichan)
         write(6,'(1x,a)') chead_out(ichan)(1:79)
         write(write01) (data_out(ichan,i),i=1,isamp(ichan))
      enddo
      call sei close( close$, write01, code )       ! Close down file
c
c  check if more files to convert
c
      goto 500
c
c
 1999 continue
      stop
      end

c
c   program to make tests signals in SEISAN format
c   j. havskov  jan 2001
c
c   program makes several traces, all have same length and sample rate
c   trace 1 is the sum of all traces
c   each trace can set parameters frequency, amplitude (remember this is
c   integer numbers in file so use at least 1000), phase, delay (delay time
c   when the signal appears, data before is zero) and damping (to simulate
c   seismometer damping, same meaning as of damping constant, but period is
c   not recalcualated to simualte changing period with damping)
c
c   an additional trace can be made with a brune displacement pulse generated
c   with prameters corner frequency (f0), q and kappa (see mulplt) and travel
c   time. Travel time is used for Q-correction and also places the pulse
c   at travel time distance from the origin, so length of trace must be
c   longer than travel time
c
c   latest update:
c
c   jh June 22 2001 : small clean up
c
      implicit none
      include 'seidim.inc'
      include 'libsei.inc'
      real x(200000)         ! signal vector
      real y(10,200000)      ! --------------
      integer n              ! number of points
      character*80 mhead(12) ! main seisan header
      character*1040 chead   ! channel header
      character*80 text      ! general text
      real damping(100)      ! damping like for a seismometer
      integer i,j,k          ! counters
      real freq(100)         ! frequencies to use
      real amp(100)          ! amplitudes
      real phase(100)        ! phase
      real delay(100)        ! delay in seconds before start of signal
      integer nsignal        ! number of signals in same trace
      real time,rate         ! length of signal and sample rate
      real f0,q0,qalpha,kappa ! spectral parmeters
      logical spec           ! if true, make brune signal
      real ph                ! phase to calculate in radians
      real pi                ! phi
      real travel_time       ! p travel time
      integer code           ! error code
      real fs,brune


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      pi=3.1415927


      write(6,*)' Duration of signal in sec and sample rate (hz)'
      read(5,*) time,rate
c
c loop for reading the signal parameters
c
      i=0
 10   continue
      write(6,*) 'Frequency, amplitude(counts), phase(deg), delay,',
     *' damping,  enter to end'
      i=i+1
      read(5,'(a)') text
      if(text.eq.' ') goto 20
      call sei get values(5,text,code)
      code=e_ok$
      freq(i)=array$(1)
      amp(i)=array$(2)
      phase(i)=array$(3)
      delay(i)=array$(4)
      damping(i)=array$(5)
      goto 10
c
c   get Brune parameters, optional
c
 20   continue
      nsignal=i-1
      if(nsignal.eq.0) stop
      write(6,*) 'Number of signals',nsignal
      write(6,*) 'Spectral values f0,q0,qalpha,kappa, travel time,',
     *' enter for none'
      read(5,'(a)') text
      if(text.eq.' ') then
         spec=.false.
      else
         spec=.true.   ! brune signal
         call sei get values(5,text,code)
         code=e_ok$
         f0=array$(1)
         q0=array$(2)
         qalpha=array$(3)
         kappa=array$(4)
         travel_time=array$(5)
      endif
c
c   generate test signals
c
      n=time*rate+1
      do i=1,n
         x(i)=0.0
      enddo
c
      do j=1,nsignal
         do k=1,n
            y(j,k)=0
         enddo
         do k=1,n
            i=delay(j)*rate+k        
            ph=2.0*pi*freq(j)*(k-1)/rate+phase(j)/(180.0/pi)
            if(damping(j).ne.0.0) then
               y(j,i)=exp(-2.0*pi*freq(j)*(k-1)*damping(j)/rate)*
     *         amp(j)*sin(ph)
            else
               y(j,i)=amp(j)*sin(ph)
            endif
            x(i)=x(i)+y(j,i)
         enddo
      enddo
c
c   add if spectrum
c
      if(spec) nsignal=nsignal+1

c
c   write out, first make headers
c
      do i=1,12             ! clear main heades
         mhead(i)=' '
      enddo
      chead=' '             ! clear channel header
c
c  fill in parameters in main header
c
      mhead(1)(34:59)='100   1  1  1  1  1    0.0'  ! fictive data and time
      write(mhead(1)(32:33),'(i2)') nsignal+1       ! add summed channel
      write(mhead(1)(61:69),'(f9.3)')n-1/rate
      mhead(2)(2:9)='TESTS  Z'
c
c  parameters in channel header
c
      chead(1:9)='TEST S  Z'
      chead(10:35)=mhead(1)(34:59)
      write(chead(37:43),'(f7.2)') rate
      write(chead(45:50),'(i6)') n
      chead(77:77)='4'
c
c   open binary SEISAN output file
c
      open(1,file='tsig.out',status='unknown',
     *form='unformatted')
c
c   write main header
c
      do i=1,12
         write(1) mhead(i)
      enddo
c
c   write sum first
c
      write(1) chead             ! write channel header
      write(1)(int(x(i)),i=1,n)  ! SEISAN file only use integers
c
c   write each signal
c
      if(spec) nsignal=nsignal-1  ! one less since Brune sigal is additional to traces
c
      do j=1,nsignal
         write(chead(1:9),'(f5.2,1x,i3)') freq(j),int(phase(j))
         write(1) chead
         write(1)(int(y(j,i)),i=1,n)
      enddo

c
c  make Brune spectrum
c
      if(spec) then
         call make_brune(f0,q0,qalpha,kappa,travel_time,n,rate,x)
         chead(1:9)='BruneS  Z'
         write(1) chead
         write(1)(int(x(i)),i=1,n)
      endif
c
c   make an s-file
c
      open(2,file='tsigs.out',status='unknown')
      text=' '
      text(1:22)=' 2000 0101 0101 00.0 L'
      text(80:80)=' '
      write(2,'(a)') text
      text=' '
      text(2:9)='tsig.out'
      text(80:80)='6'
      write(2,'(a)') text
      text=' '
      text(1:)=' BruneSZ IP       0101'
      write(text(24:28),'(f5.1)') travel_time
      write(2,'(a)') text
      write(2,*)'   '

      close(1)
c
c
      write(6,*)'Output wave form file name is tsig.out'
      write(6,*)'Output s-file name is         tsigs.out'
      stop
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine make_brune(f0,q0,qalpha,kappa,travel_time,n,rate,y)
c
c  make the time signal from a brune spectrum
c
      implicit none
      real y(*)
      real rate               ! sample rate
      complex y_com(100000)
      real f                  ! frequency
      real f0                 ! corner frequency
      integer n               ! number of sample in
      integer nsamp           ! number of samples after padding
      real q0,qalpha,kappa    ! attenuation parameters
      real travel_time        ! p travel time
      integer i,exp2,k



c
c   find nearest 2**i
c
      do i=1,20
        if(2**i.gt.n) goto 10
      enddo
 10   continue

      nsamp=2**i
      exp2=i
c      write(6,*)'exp',exp2


      y_com(1)=0.0

      do i=2,nsamp/2+1
        f=(i-1)/(nsamp/rate)
        y_com(i)=1000000.0/(1.0+(f/f0)**2)
c
c   attenuation
c
        if(q0.gt.0.0) then
           y_com(i)=y_com(i)*exp(-3.1415*f*travel_time/(q0*f**qalpha))
        endif
        if(kappa.gt.0.0) then
           y_com(i)=y_com(i)*exp(-3.1415*f*kappa)
        endif
      enddo
c
c  make the inverse spectrum
c
      call fft(exp2,1.0,y_com)
c
c   normalize, only use same number of samples as put in
c   displace by travel time
c
      k=travel_time*rate
      do i=1,n
         y(i+k) = 1./real(nsamp) * real(y_com(i))
      enddo
      do i=1,k
         y(i)=0
      enddo
      
      return
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      real function brune(f,f0)
c
c   calculates the level of the Brune displacement spectrum at 
c   at frequency f . The spectrum has corner frequency f0. Spectral
c   level is 1.0

      implicit none
      real f,f0

      brune=1.0/(1.0+(f/f0)**2)
      return
      end

      program travel_times
c
c read P arrival times from Nordic file and write out as station, dist,
c observed travel time and calculated travel time
c
c program will have to be improved
c
c Lars Ottemoeller, June 06, 2000
c
c  oct 25 jh : read secs as f6.2

      implicit none
      include 'seidim.inc'
      integer nstat,read01,nphase,nhead,nrecord,id,i,write01
      integer year,mon,day,hour1,min1,sec1,hour2,min2,sec2
      double precision msec1,msec2,res
      character*1 evid,exp
      character*80 data(max_data),infile,outfile


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      read01=1
      write01=2
      outfile='tt.out'
      write(*,*) ' file name '
      read(*,'(a)') infile
      open(read01,file=infile,status='old')
      open(write01,file=outfile,status='unknown')
      write(write01,'(a)') ' STAT  DIST  OBSTT   THTT '
 10   continue
      call indata
     *  (read01,nstat,nphase,nhead,nrecord,evid,exp,data,id)      

      if (nrecord.eq.0) goto 999
      write(*,*) data(1)(2:20)
      read(data(1)(2:20),'(i4,1x,i2,i2,1x,i2,i2,1x,f4.1)')
     *  year,mon,day,hour1,min1,sec1
      call timsec(year,mon,day,hour1,min1,sec1,msec1)
      do i=nhead+1,nrecord
         if (data(i)(11:11).eq.'P'.and.
     *          data(i)(65:68).ne.'    ') then
           read(data(i)(19:28),'(2i2,f6.2)') hour2,min2,sec2
           call timsec(year,mon,day,hour2,min2,sec2,msec2)
           read(data(i)(65:68),'(f4.1)') res
           write(write01,'(1x,a5,1x,a5,1x,f7.2,1x,f7.2)')
     *      data(i)(2:6),data(i)(71:75),msec2-msec1,msec2-msec1-res
         endif

      enddo

      goto 10
999   continue
      close(read01)
      close(write01)
      write(*,*) ' output file: ',outfile
      stop
      end

      subroutine systime(t,t1)
c
c   routines returns system date and time in string t in a simple form
c   and in t1 nicely arranged    	  	  
c
c   updates
c
c   sep 98 by jh : ---------- version 7.0 check -----------------
c                  change for year 2000
c   nov 4 ,98 jh : linux logic
c   jan 3 2000   : wrong year for year 2000
c   jan 26       : above was only fixed on sun !!
c                  
      implicit none
c
      character*12 t
      character*14 t1
      integer*2 hr,min,sec,year,mon,day,sec100
      integer time(3),date(3),i
      logical sun,pc,linux
      call computer_type(sun,pc,linux)
c
c   get system time on pc
c
      if(pc) then
         call gettim(hr,min,sec,sec100)
         call getdat(year,mon,day)	  	  	  
         if(year.ge.2000) then
            year=year-2000
         else
            year=year-1900
         endif	  
         write(t,'(6i2)') year,mon,day,hr,min,sec
      endif
c
c   get system time on sun
c
       if(sun.or.linux) then
         call itime(time)
         call idate(date)
c
c   assume 1900
c
         if(date(3).ge.2000) then
            date(3)=date(3)-2000
         else
            date(3)=date(3)-1900
         endif
         write(t,'(6i2)') 
     *   date(3),date(2),date(1),time(1),time(2),time(3)
       endif
c
c   check for blanks
c
       do i=1,12
          if(t(i:i).eq.' ') t(i:i)='0'
       enddo
c
c   set up nicely
c
       t1(1:2)=t(1:2)
       t1(3:3)='-'
       t1(4:5)=t(3:4)
       t1(6:6)='-'
       t1(7:8)=t(5:6)
       t1(9:9)=' '
       t1(10:11)=t(7:8)
       t1(12:12)=':'
       t1(13:14)=t(9:10)
       
      return
      end	  	  	  

      subroutine datetimex(dattim)
c
c routine to give data and time, replaces routine in velest
c
      implicit none
      character*12 time1
      character*14 time2
      character*20 dattim
     
      dattim = ' '
      call systime(time1,time2)
      dattim(1:14) = time2

      return
      end

c  program to convert any miniseed file to s nicer  miniseed,
c needed when seisan cannot read miniseed files, mar 07 jh
c  it uses chad's program msrepack
c
c           not tested much
c
c  aug 16 07 jh : fix pc bug


      implicit none
      character*80 infile                   ! input filename
      character*80 outfile                 
      character*80 question
      integer seiclen
      integer i,in
c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

 10   continue
c
c input file names
c
      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)
      if (infile(1:3).eq.'EOF') stop

      in=0
      if (infile(1:10).eq.'filenr.lis') then
        in=1
        open(60,file=infile,status='old',err=9999)
      endif

 20   continue

      if (in.eq.1) then 
         read(60,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif

      write(6,'(1x,a13,a)') ' input file: ',infile
      write(*,*) 
c
c   convert binary file to ascii
c
      i=seiclen(infile)   ! length of file name
c
c   make new output file name
c
      outfile(1:i+1)=infile(1:i)//'c'
      write(6,*)' Output file name: ', outfile
c
c   rewrite file using program msrepack, write steim1
c
      call systemc
     *('msrepack '//infile(1:i)//' -i -E 10 -o '//outfile(1:i+1),23+2*i)
c
c   go for next file
c
      if(in.eq.1) goto 20
      write(6,*)' Output file name: ', outfile

      goto 10
c
9999  continue

      stop
      end

c
c program to convert SIL ASCII data to Seisan, lo June 01, 2001
c
c comments: hardwired to comp 'B..."
c           not tested much

      program silsei

      implicit none
      include  'seidim.inc'                 ! Dimensions.
      include  'libsei.inc'                 ! Library defns.

      integer idata (max_sample)            ! integer data
      integer nchan,nsamp,i
      character*80      filehead(max_trace)
      character*1040    tracehead
      character*80 infile                   ! input filename
      character*80 outfile                 
      real srate                             ! sample rate
      integer year,month,day,hour,min        !time
      real sec
      character*5 station                    ! station name
      character*4 comp                       ! component SEISAN
      integer in                             ! 1 for filenr.lis
      integer seiclen
      character*80 question,line
      character*40 text
      character*29 mainhead_text 
      character*5 net_code
      character*1 cbyte(max_trace)
      double precision cinter(max_trace),cstart(max_trace)



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

 10   continue
c
c input file names
c
      question=' Filename or number, filenr.lis for all'
      call filename(question,infile)
      if (infile(1:3).eq.'EOF') stop

      in=0
      if (infile(1:10).eq.'filenr.lis') then
        in=1
        open(60,file=infile,status='old',err=9999)
      endif

 20   continue

      if (in.eq.1) then 
         read(60,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif

      write(6,'(1x,a13,a)') ' input file: ',infile
      write(*,*) 

c
c read header
c
      open(1,file=infile,status='old')
      read(1,'(a)',end=333,err=333) line
c arn  2001
      station=line(1:4)
      call CASEFOLD(station)
      read(line(6:9),'(i4)') year
c              12345678901234567890
c /usr/sil/net/may/07/09:44:00.00E00
      read(1,'(a)',end=333,err=333) line
      text=' '
      text= line(seiclen(line)-20:seiclen(line))
      if (text(1:3).eq.'jan') then 
        month=1
      elseif (text(1:3).eq.'feb') then
        month=2
      elseif (text(1:3).eq.'mar') then
        month=3
      elseif (text(1:3).eq.'apr') then
        month=4
      elseif (text(1:3).eq.'may') then
        month=5
      elseif (text(1:3).eq.'jun') then
        month=6
      elseif (text(1:3).eq.'jul') then
        month=7
      elseif (text(1:3).eq.'aug') then
        month=8
      elseif (text(1:3).eq.'sep') then
        month=9
      elseif (text(1:3).eq.'oct') then
        month=10
      elseif (text(1:3).eq.'nov') then
        month=11
      elseif (text(1:3).eq.'dec') then
        month=12
      endif
      read (text(5:6),'(i2)') day
      read (text(8:9),'(i2)') hour
      read (text(11:12),'(i2)') min
      read (text(14:18),'(f5.2)') sec
      comp='B   '
      comp(4:4)=text(19:19)
c 100
      read(1,'(a)',end=333,err=333) line
      read(line,'(f5.0)') srate
c T3795 D0395
c aut
c o/s=   600 drift=     0 pwm=  3484   4 Auto 9
      read(1,'(a)',end=333,err=333) line
      read(1,'(a)',end=333,err=333) line
      read(1,'(a)',end=333,err=333) line
c +data+
      read(1,'(a)',end=333,err=333) line
      if (line(1:6).ne.'+data+') then
         goto 333 
      endif
c  36000
      read(1,'(a)',end=333,err=333) line
      read(line,'(i10)') nsamp
c -117874
      do i=1,nsamp
         read(1,'(a)',end=333,err=333) line
         read(line,'(i14)') idata(i)
      enddo
c
c input done
c

      goto 334
    
 333  continue
      close(1)
      write(*,*) ' error reading SIL file '
      stop
 334  continue
      close(1)

c
c SEISAN output
c

      call timsec(year,month,day,hour,min,sec,cstart(1))
      cinter(1)=(nsamp-1)/srate
c
c  make file name and main header
c             
      nchan=1

      net_code = station(1:3)
      cbyte(1) = '4'

      call sheads(year,month,day,hour,min,sec,nchan,1,
     *                 net_code,mainhead_text,station,comp,
     *                 nsamp,srate,cbyte,
     *                 outfile,filehead,tracehead)

      outfile = outfile(1:29) // '_' // comp
      do i=30,33
        if (outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo

      write(6,'(a,a)') ' Outfile name: ',outfile(1:60)
c
c open file and write header   
c
      open(2,file=outfile,status='unknown',form='unformatted')
      do i=1,12
         write(2) filehead(i)
      enddo
      write(2)tracehead                                                     
      write(6,'(1x,a70)') tracehead(1:70)                                   

c  
c   write data
c
      write(2) (idata(i),i=1,nsamp)
      close(2)
c
c   back for next file
c

      if(in.eq.1) goto 20                                                           
      goto 10 

9999  continue
      close(60)

      stop
      end

c
c  Converts public seismic network files to SEISAN format
c  channels can be defined using the psnsei.def definition file
c  
c  simple version 
c
c  j. havskov, feb 98
c
c
c  Program assumes that input file only has one channel. Station and
c  componenet name is from standard def file. However, if component is 
c  given as part of the file name, that overrides the componenet given
c  by the def file. The coponenet must be S, L, I or B for type and
c  Z,N or E for orientation and given in input file name in position 10 and 11,
c  repectively. The output file name is standard with component added and
c  also a number for easy sorting to merge with seisei. 
c  
c
c  updates:
c  mar 9, 99 by jh : fix bug with time
c  mar 21          : special fix to get componenet name from file name
c  may 9           : --------------   verision 7.0 ------------------
c                    year 2000, 5 char station, seisna dimension
c  july 9          : use component from suffix
c  may 11  00   lo : use read_resp_head
c  aug 12       lo : read files with more than 65000 samples
c  apr 19  01   jh : accept instrument type in column 12, change it to
c                    upper case if in lowe case
c

      implicit none
      include 'seidim.inc' ! dimensions
c-- output data vector	  
      integer*2  data(max_sample)
      character*1 cdata(max_sample*2)
      character*107 block  ! input file header
      integer*4 nsmp         ! number of samples 
c
c-----------------------------------------------------------------------
c   start block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c
c--end block of definitions most conversion programs
c---------------------------------------------------------------------


      integer year2,month2,day2,hour2,min2
      real sec2
      character*80 text      ! general text
      real time_interval     ! length of file in seconds 
      character*1 o

c------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
          integer i,ndef_stat,x
c-- computer type
      logical pc,sun,linux
c---------------------------
c-- help for swap
       character*2 xs
       character*4 xxs
       integer*2 ixs
       integer*4 ixxs
c -- suffix which is type of instrument
       character*1 com
       integer seiclen

c
      equivalence (ixs,xs)
      equivalence (ixxs,xxs)
      equivalence (cdata,data)


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       text='psnsei.def'
       call read_def_chan(text,mainhead_text,net_code)

c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old',access='direct',recl=207)
c
c   read header block to get start time etc
c
c
 1     continue
       read(1,rec=1,err=99) block
       close(1)

c       do x=0,106,2
c         xs=block(x:x+1)
c         if (x.eq.0) block(x:x) = ' '
c         if(sun) call swap2_one(ixs)
c         write(*,*) x,ixs
c         if (x/10.eq.int(x/10)) read(*,*)
c       enddo

c
c   number of channels, not given in input file, assume 1
c
       nchan=1
c
c   get file start time
c
c   seconds
       xs=block(20:21)
       if(sun) call swap2_one(ixs)
       sec(1)=ixs
c
       xs=block(22:23)
       if(sun) call swap2_one(ixs)
       sec(1)=sec(1)+ixs/10.0
c   minutes
       xs=block(18:19)
       if(sun) call swap2_one(ixs)
       min(1)=ixs
c   hour
       xs=block(16:17)
       if(sun) call swap2_one(ixs)
       hour(1)=ixs       
c   day
       xs=block(14:15)
       if(sun) call swap2_one(ixs)
       day(1)=ixs
c   month
       xs=block(12:13)
       if(sun) call swap2_one(ixs)
       month(1)=ixs
c   year
       xs=block(10:11)
       if(sun) call swap2_one(ixs)
       year(1)=ixs


c
c   get file end time
c
c   seconds
c
       xs=block(28:29)
       if(sun) call swap2_one(ixs)
       sec2=ixs
       xs=block(30:31)
       if(sun) call swap2_one(ixs)
       sec2=sec2+ixs/10.0
c
c   minutes
c
       xs=block(26:27)
       if(sun) call swap2_one(ixs)
       min2=ixs
c
c   hour
c
       xs=block(24:25)
       if(sun) call swap2_one(ixs)
       hour2=ixs
  
       day2=day(1)
       month2=month(1)
       year2=year(1)       
c
c   get file length
c
       xs=block(32:33)
       if(sun) call swap2_one(ixs)
       nsmp=ixs-100
       
c
c check if more than 65000 samples
c
       if (nsmp.lt.-101) then
         xs(1:2)=block(32:33)
         if(sun) call swap2_one(ixs)
         ixxs=ixs 
         xs(1:2)=block(6:7)
         if(sun) call swap2_one(ixs)
         ixxs=ixs-ixxs
         nsmp=ixxs-100
       elseif (nsmp.eq.-101) then
         xs(1:2)=block(2:3)
         if(sun) call swap2_one(ixs)
         ixxs=ixs
         xs(1:2)=block(4:5)
         if(sun) call swap2_one(ixs)
         ixxs=ixs*65536+ixxs
         nsmp=ixxs-100
       endif
c
c get orientation
c
       comp(1) = '    '
       comp(1)(4:4) = block(40:40)

c
c get location name ( first 4 out of 15 )
c
       stat(1) = '     '
       stat(1)(1:1) = block(58:58)
       stat(1)(2:2) = block(60:60)
       stat(1)(3:3) = block(62:62)
       stat(1)(4:4) = block(64:64)
c       stat(1)(5:5) = block(66:66)

c
c   open again with record length equal to lenght of file
c
       
      open(1,file=infile,status='old',access='direct',
     *recl=nsmp*2+207)
c
c   calculate interval in secs
c
       if(hour2.lt.hour(1)) hour2=hour2+24

       time_interval=(hour2-hour(1))*3600+(min2-min(1))*60+sec2-sec(1)
c 
       write(6,'(a,1x,i4,4i3,f6.3)')' yy,mm,dd,hh,mm,sec',
     * year(1),month(1),day(1),hour(1),min(1),sec(1)
c
       write(6,*)' Data time interval', time_interval
       write(6,*)' Number of samples as given in header', nsmp
c
c   assume same start time etc. for all channels, although right now only
c   one channel
c
       if (infile(8:8).eq.'.') com=infile(9:9)
       if (infile(9:9).eq.'.') com=infile(10:10)
       if (infile(11:11).eq.'.') com=infile(12:12)
       if (infile(27:27).eq.'_') com=infile(29:29)
       if(com.eq.'l') com='L'
       if(com.eq.'b') com='B'
       if(com.eq.'s') com='S'
       if(com.eq.'a') com='A'

       write(comp(1)(1:1),'(a1)') com(1:1)

       do i=1,nchan
          year(i)=year(1)
          month(i)=month(1)
          day(i)=day(1)
          hour(i)=hour(1)
          min(i)=min(1)
          sec(i)=sec(1)
          cbyte(i)=' '
       enddo

c
c change station or component names according to def file
c
       call set_def_chan(1,stat(1),comp(1))

c
c   read all data
c


        read(1,rec=1)   (cdata(i),i=1,nsmp*2+207)
c
c   shuffle bytes
c
        do i=1, nsmp*2
          cdata(i)=cdata(i+207)
        enddo
c
c   swap
c
        if(sun) call swap2(nsmp,data)

        nsamp(1)=nsmp
c
c   calculate sample rate
c
        rate(1)=(nsamp(1)-1)/time_interval        
        write(6,*)' Sample rate     ', rate(1)

c
c   make seisan headers
c
      ichan=1

      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   fix name
c
      outfile(30:30)='_'
      outfile(31:34)=comp(1)
      do i=31,34
         if(outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo        
      write(6,'(a,a)')' Output file name is: ',outfile
c
c   open output file
c
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c

      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo
c
C-----------------------------------------
C   enter channel  loop, for the moment one
c-----------------------------------------
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,stat,comp,
     *                    nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
c
c   write rate a bit more accurate
c
         write(chahead(37:43),'(f7.3)') rate(1)
         if(rate(1).lt.100.0) write(chahead(37:43),'(f7.4)') rate(1)
         if(rate(1).lt.10.0) write(chahead(37:43),'(f7.5)') rate(1)
         write(6,'(1x,a)') chahead(1:78)
c                                                                               
c   get response, save date etc since removed when calling read_resp            
c                                                                               
         call read_resp_head(chahead)                                            
c
c   write data
c
         write(2)chahead
         write(2) (data(i),i=1,nsmp)
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  
c

c   program to  make event statistics                  
c                                                                      
c   jens havskov, apr 93                                             
c                                                                  
c   uppdates                                                      
c   may 21, 93 by jh: count all phases
c   july 8  93      : version 3.0 ***********
c   nov 93          : upgrade
c   nov 14          : count more, more things
c   dec 1   94      : total phases
c   dec 1           : seidim.inc
C  dec 8        : Installed file & error handling (libsei)
c                   **********  version 5.0 ***********************
c   jan 10  95      : new fin ev in
c   jan 20          : bugs
c   sep 02, 96    lo: setting of default stations, 
c                     new output file (statab.out),
c                     calculation of LOCAL S corrected 
c   sep 07  98      : stations added (tron,rund,arcess,noress,svaess,norsar
c   march 99   jh   : -----------------   version 7.0  check -------------
c   march 23 99 bmt : add one argument to computer_type call (linux)                                                                  
c   oct 5       jh  : times were not 14 but 12 chars
c   may 10 2000 lo  : init file_input, was linux problem
c   apr 21 2004 jh  : fix so 5 char stations can be used
c may 23        jh  : add STOK  and remove NRA0 
c
       implicit 	none
                                                
       include 'seidim.inc'        ! dimentions
c-- event data                                     
       character*80	data(max_data)	
c-- exp indicator, answer                                         
       character*1	exp,answer		
c-- event type                                      
       character*1      type		
c-- number of recors for event                           
       integer		nrecord		
c-- number of header lines                                 
       integer		nhead		
c-- number of stations                                     
       integer		nstat		
c-- number of phases
       integer nphase
c-- start and end time of select      
       character*14    start_time,end_time 
c-- data base name if not rea (blank)               
       character*40	base_name	
c-- event file name                                   
       character*80	evfile		
c-- select key                                       
       character*10     key		
c-- see subroutine find...       
       integer		status,new_month,fstart,event_no 
c-- switch for file or data base
       logical file_input
c-- counters for events, records etc.      
       integer nr,nd,nl,records,nevent	
c-- counters,etc                                                   
       integer 		i,k,irec,iwaw_more,istat,iwaw
c-- event type
       integer evtype
c-- true if file exists              
       logical          exist           
c-- stations to use in statistics
       character*5 station(500)
       character*80 stat_text
c-- wave form codes
       character*3 waw_code(100)
       integer nwaw_code(100)
       integer nwcode
c-- total number of phases local and tele
       integer nphases1,nphases2
c-- length of wave form file code
       integer wlen
c-- one station code
       character*5 stat,stat_single
c-- number of stations to use in statistics
       integer kstat
c-- counter of single station detections
       integer nsingle(2,500)
c-- counter for number of detections at each station
       integer nstation(2,500)
c-- counts number of detection for one event
       integer nevent_station
c-- conts number of event with one ore more stations
       integer nevent_sel
c-- detecting stations for one event
       character*5 event_station(500)
c-- old station
       logical  oldstat
c-- count all phases
       integer count_all
c-- number of events with no phases
       integer nophase
c-- number of events with one or several waveform files
       integer nwaw
c-- total number of wave form files
       integer nwaw_total
c-- number of events with only waveform files
       integer only_waw
c--number of events with 2 or more waveform files
       integer waw_2
c-- number of selected events which had more stations than used to select with
       integer nstat_more
c-- Machine type
       logical pc,sun,linux
C    Seisan library inserts and routines...
C    ======================================
C
       include 'libsei.inc'                ! Library definitions & data defns.
       external sei open,                  ! Open file routine.
     &          sei close,                 ! Close file routine.
     &          sei code,                  ! Error encoder.
     &          sei real num               ! Get real number
C
       integer  write01,                   ! Output unit 1.
     &          write02,                   ! Output unit 2.
     &          write03,                   ! Output unit 3.
     &          read01,                    ! Input unit1.
     &          read02,                    ! Ditto 2.
     &          code                       ! Local condition.
       logical  b_flag                     ! Flag end of file?.
       real sei real num                   ! Real number


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c
C
      call computer_type(sun,pc,linux)
      file_input=.false.

c
c  clear arrays
c
      do i=1,500
        station(i)='     '
        do k=1,2
           nstation(k,i)=0
           nsingle(k,i)=0
        enddo
      enddo
      do i=1,100
        waw_code(i)='   '
        nwaw_code(i)=0
      enddo
c
c  get stations
c
      write(6,*)' Give file name with stations to use, must have a .'
      write(6,*)'                    or'
      write(6,*)' Give stations, one pr line, return to finish'
     *,' return for default'
      read(5,'(a)') stat_text
      if(stat_text(1:5).eq.'    ') then 
        goto 59
      endif
c
c   check if a file
c
      k=index(stat_text,'.')
      if(k.gt.1) then
         i=1
          call sei open( old$+warn$,       ! Open file & warn of erro.
     &                   ' ',              ! Prompt (n/a).
     &                   stat_text,        ! Filename.
     &                   read01,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
  55     continue
         read(read01,'(a5)',end=60) station(i)
         i=i+1
         goto 55
      endif         
c
c  Read stations
c
      i=1
      station(1)=stat_text(1:5)
  56  continue
      i=i+1
      read(5,'(a)') stat_text
      if (stat_text(1:5).eq.'    ') then
        station(i)='    '
        goto 60
      endif 
      station(i)=stat_text(1:5) 
      if (i.GT.500) then 
        goto 60
      endif
      goto 56
c 
c  set default stations for Norway
c
  59  continue
        station(1)='ASK  '
        station(2)='BER  '
        station(3)='BJO1 '
        station(4)='BLS5 '
        station(5)='DOMB '
        station(6)='EGD  '
        station(7)='FLOS '
        station(8)='FOO  '
        station(9)='HOPEN'
        station(10)='HYA  '
        station(11)='JMI  ' 
        station(12)='JMIC '
        station(13)='JNE  '
        station(14)='JNW  '
        station(15)='KBS  '
        station(16)='KMY  '
        station(17)='KONO '
        station(18)='KONS '
        station(19)='KTK1 '
        station(20)='LOF  '
        station(21)='MOL  '
        station(22)='MOR8 '
        station(23)='NSS  '
        station(24)='ODD1 '
        station(25)='OSL  '
        station(26)='RUND '
        station(27)='SNART'
        station(28)='STAV '
        station(29)='STEI '
        station(30)='STOK '
        station(31)='STOK1'
        station(32)='STOK2'
        station(33)='SUE  '
        station(34)='TRO  '
        station(35)='TRON '
        station(36)='NB2  '
        station(37)='ARA0 '
        station(38)='SPA0 '
        station(39)='     '
c
c   count stations
c
 60    do i=1,500
          if(station(i).eq.'     ') goto 20
       enddo
 20    continue
       kstat=i-1
c                                             
c   input base name and time interval                                      
c                                                                               
       write(6,*)' Base name or file name, return for default'                 
       read(5,'(a40)') base_name                                                
       i=index(base_name,'.')
       if(i.gt.1.and.
     * base_name(1:5).ne.'index'.and.base_name(1:5).ne.'INDEX') then
          file_input=.true.
       else
          write(6,*)' Start time'                                              
          read(5,'(a14)') start_time                                           
          write(6,*)' End time, return for end of month'                       
          read(5,'(a14)') end_time                                              
       endif
       count_all=0
       write(6,*)' Count all phases(y/n)'
       read(5,'(a1)') answer
       if(answer.eq.'y'.or.answer.eq.'Y') count_all=1
	                                                                    
c                                                                               
c  reset counters                                                               
c                                                                               
50     nl=0                                                                     
       nr=0                                                                     
       nd=0                                                                     
       nophase=0
       nevent=0                                                                 
       records=0                                                                
       nevent_sel=0
       nwaw=0
       nwaw_total=0
       only_waw=0
       waw_2=0
       nwcode=0
       nstat_more=0
c                                                                               
c   open output files                                                            
c                                                                               
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   'statis.out',     ! Filename.
     &                   write01,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   'sta2waw.out',    ! Filename.
     &                   write02,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
          call sei open( unknown$,         ! Open file (default=stop on error)
     &                   ' ',              ! Prompt (n/a).
     &                   'statab.out',     ! Filename.
     &                   write03,          ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
c   open input file if  file input
c
       if(file_input) then 
          write(*,*) 'xxx'
          call sei open( old$+warn$,       ! Open file & warn of erro.
     &                   ' ',              ! Prompt (n/a).
     &                   base_name,        ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
       endif
                                           
c                                                                               
c  start read and write loop                                                    
c                                                                               
 5     continue                                                                 
       if(file_input) goto 8
c-- always use next event                                
       key='          '		
       CALL findevin                                                       
     * (base_name,start_time,end_time,key,0,                                    
     * event_no,evfile,fstart,new_month,status)                                 
c
c   check for end of data set or errors
c
       if(status.ne.0) goto 999                                                
c
       inquire(file=evfile,exist=exist)                         
       if (.not.exist) then                                          
          write(6,'(1x,a60,a)') evfile,' doesn''t exist.'         
          goto 5
       endif
c
c--------------------------------------------------------------------------
c now make statistics
c--------------------------------------------------------------------------
c
          call sei open( old$+warn$,       ! Open file & warn of erro.
     &                   ' ',              ! Prompt (n/a).
     &                   evfile,           ! Filename.
     &                   read02,           ! Unit opened on.
     &                   b_flag,           ! Flag.
     &                   code )            ! Returned condition.
 8     continue
       call indata
     * (read02,nstat,nphase,nhead,nrecord,type,exp,data,i)              
       if(nrecord.eq.0) goto 999
c      write(6,'(a)') data(1)(1:60)
c
c   find if any waveform files, and how many
c
       iwaw=0
       iwaw_more=0
       wlen=3
       if(pc) wlen=1                         ! only one letter on pc
       do irec=2,nhead
          if(data(irec)(80:80).eq.'6') then
c
c   find network codes
c
             k=index(data(irec),'.')+1
             do i=1,nwcode                   ! record and count wave form codes
                if(data(irec)(k:k+wlen-1).eq.waw_code(i)(1:1+wlen-1)) 
     *          then
                  nwaw_code(i)=nwaw_code(i)+1
                  goto 45
                endif
             enddo
c
c   if here, code was not in register, add
c
             nwcode=nwcode+1
             waw_code(nwcode)(1:1+wlen-1)=data(irec)(k:k+wlen-1)
             nwaw_code(nwcode)=1             ! count that this was the first
 45          continue
c
             iwaw_more=iwaw_more+1
             nwaw_total=nwaw_total+1
             if(iwaw.eq.0) nwaw=nwaw+1
             iwaw=1                          ! do not count anymore this event
          endif
       enddo
c
c   count events with 2 or more wave form files and write out
c
       if(iwaw_more.gt.1) then
          waw_2=waw_2+1
          write(write02,'(a)')(data(i),i=1,nrecord)
       endif
c
c   count if event only has waveforms
c
       if(iwaw.eq.1.and.nstat.eq.0) only_waw=only_waw+1
c
       evtype=1
       if(type.eq.'D') evtype=2
c
c   find which stations are used for this events
c
       nevent_station=0
       do irec=nhead+1,nrecord - 1
          read(data(irec),'(1x,a5)') stat
c
c  make sure stations is only used once if that is the choice
c
          oldstat=.false.
          do i=1,nevent_station
             if(event_station(i).eq.stat) oldstat = .true.
          enddo
c
c   count all occurences of stations if count_all is 1
c
          if(.not.oldstat.or.count_all.eq.1) then
             do istat=1,kstat
                if(stat.eq.station(istat)) then
                   nstation(evtype,istat)=
     *             nstation(evtype,istat)+1
                   nevent_station=nevent_station+1
                   stat_single=stat
c
c   save stations found for this event for later write out and check for 
c   several occurences of station
c
                   event_station(nevent_station)=stat
                endif
             enddo
          endif
       enddo
c
c   check and record if a single station detection
c
c       if(nevent_station.eq.1) then    ! single station among selected
       if(nstat.eq.1) then             ! single station among any
          stat=data(nhead+1)(2:6)
          do i=1, kstat
             if(stat.eq.station(i)) 
     *       nsingle(evtype,i)=nsingle(evtype,i)+1
          enddo
       endif
c
c   count events selected with one or several of the stations asked for
c
       if(nevent_station.ge.1) nevent_sel=nevent_sel+1            
c
c   count events which had more stations than asked for
c
       if(nstat.gt.nevent_station.and.nevent_station.ge.1) 
     * nstat_more=nstat_more+1
c                                                                               
c   count total events etc                                                            
c                                                                               
       if(type.eq.'L') nl=nl+1                                              
       if(type.eq.'R') nr=nr+1                                              
       if(type.eq.'D') nd=nd+1
c
c   count stations with no phases
c                                  
       if(nstat.eq.0) nophase=nophase+1
       records=records+nrecord                                              
       nevent=nevent+1                                                      
c                                                                               
c  check event                            
c                                                                               
c                                                                               
c  print event name                                                             
c                                                                               
       write(6,'(1x,a60)') evfile                                           
       write(write01,'(a,1x,30a5)') evfile(fstart:fstart+16),
     *(event_station(i),
     * i=1,nevent_station)
      if(.not.file_input) call sei close(close$,read02,code)

c-- back for next event                                         
      goto 5
c
c  end
c
 999  continue
c                                                                               
c  print out statistics                                                         
c
c  statab.out:  table with station statistics only
c
      write(6,*)
      write(6,'(1x,5a11)')'Station    ',' Local Ev. ',
     *' Local S. ',' Distant E ', ' Distant S '
      write(write01,*)
      write(write01,'(1x,5a11)')'Station    ',' Local Ev. ',
     *' Local S. ',' Distant E ', ' Distant S '
      write(write03,'(a19)') 'Station,LM,LS,D,DS '

c
c   total number of event-stations, can be number of phases
c
      nphases1=0
      nphases2=0
      do i=1,kstat
         write(6,'(4x,a5,4i11)')station(i),nstation(1,i),
     *   nsingle(1,i),nstation(2,i),nsingle(2,i)
         nphases1=nphases1+nstation(1,i)
         nphases2=nphases2+nstation(2,i)
      enddo
      write(6,'(4x,a,i10,11x,i11)')'Total',nphases1,nphases2
      write(6,*)
      do i=1,kstat
         write(write01,'(4x,a5,4i11)')station(i),nstation(1,i),
     *   nsingle(1,i),nstation(2,i),nsingle(2,i)
         write(write03,'(a5,a1,i6,a1,i6,a1,i6,a1,i6)')
     *     station(i),',',nstation(1,i)-nsingle(1,i),',',
     *     nsingle(1,i),',',nstation(2,i),',',nsingle(2,i)
      enddo
      write(write01,'(4x,a,i10,11x,i11)')'Total',nphases1,nphases2
      write(write01,*)
c
c   wave for file statistics
c
       write(6,*)
       write(6,'(1x,a3,1x,a5)')'NET',' NWAW'
       do i=1,nwcode
          write(6,'(1x,a3,1x,i5)') waw_code(i),nwaw_code(i)
       enddo
       write(write01,*)
       write(write01,'(1x,a3,1x,a5)')'NET',' NWAW'
       do i=1,nwcode
          write(write01,'(1x,a3,1x,i5)') waw_code(i),nwaw_code(i)
       enddo
c
c   summary statistics
c
       write(6,*)
       write(6,201) nevent_sel,nstat_more,nophase,nwaw,only_waw,
     * waw_2,nwaw_total,nl,nr,nd,nevent,records                                      
       write(write01,*)
       write(write01,201) nevent_sel,nstat_more,nophase,nwaw,only_waw,
     * waw_2,nwaw_total,nl,nr,nd,nevent,records                                      
 201  format(
     *       ' Number of events selected with given stations ',i7,                            
     *     /,' Number of events selected with more than ---  ',i7,                            
     *     /,' Number of events with no phases               ',i7,
     *     /,' Number of events with waveforms               ',i7,
     *     /,' Number of events with only waveforms          ',i7,
     *     /,' Number of events with 2 or more waveforms     ',i7,
     *     /,' Total number of waveform files                ',i7,
     *     /,' Total number of local events                  ',i7                             
     *     /,' Total number of regional events               ',i7                             
     *     /,' Total number of distant events                ',i7                             
     *     /,' Total number of events                        ',i7                             
     *     /,' Total number of records                       ',i7)                            
      write(6,*)                                                                
      write(6,*)' Output files are: statis.out'                                   
      write(6,*)'                   statab.out ',
     *          '(station statistics only)'
      call sei close(close$+all$,read01, code)       ! Close all open files.
      stop                                                                      
      end                                                                       
                                                                                
                                                                               

c--------------------------------------------------------------------------
c  Sample program for reading one s-file at a time in a loop and put
c  all parameters into the rea common block.
c
c  Some parameters are then modified and the modified event is written
c  to the output file.
c--------------------------------------------------------------------------c
c
c  For detail on parameters and variables naames, see rea.inc
c
c  To compile this program, use command make sample_read_write_s on sun
c  and nmake sample_read_write_s on pc
c
c
      implicit none                       ! force delcaration of all variables
      include 'seidim.inc'                ! dimensions for rea block
      include 'rea.inc'                   ! parameter common bliock

      character*80 data(5000)             ! s-file with data in text array
      character*80 err_text               ! error text
      character*80 infile                 ! input file

      logical all                         ! true: read all data, false: headers
      integer code                        ! error return code
      integer nevent                      ! number of events in file
      integer i                           ! counter
c
c   open output file

       open(2,file='sample_read_write_s.out',status='unknown')
    
c
c   get input file name, check if exist
c

 9    continue
      write(6,*) 'Give input file'
      read(5,'(a)') infile
      open(1,file=infile,status='old',err=10)
      goto 11
 10    continue
      write(6,*)' No such input file'
      goto 9
 11   continue
c
      all=.true.                  ! read all parameters
      nevent=0                    ! initialize counter

c
c-----------------------------------------------------------------
c  Loop to read events start here
c-----------------------------------------------------------------
c

  50  continue
c
c   read all parameters for one event form file unit 1
c
      call rea_event_in(1,all,data,code)
c
c   check if end of file (code=1), if so jump out of loop
c
      if(code.eq.1) goto 1000
c
      nevent=nevent+1               ! count events
c     
c   write on screen a bit info on event, number of headers and
c   total number of records
c
      write(6,*)' Number of headers and number of records',
     *rea_nhead,rea_nrecord

c
c   write the whole first header line
c
      write(6,'(a)') data(1)(1:79)
c
c   some example of modifying event
c
c----------------------------------------------------
c - remove lines with waveform file names
c----------------------------------------------------
c
      rea_nwav=0
c
c----------------------------------------------------
c - add 1 sec to all s-readings, no no check fo rchange
c   hour unless option abslute time used, see routiene
c   rea_phase:_out
c
c   delete p-phases
c----------------------------------------------------
c
      do i=1,rea_nphase
        if(rea_phase(i)(1:1).eq.'S') rea_sec(i)=rea_sec(i)+1.0
        if(rea_phase(i)(1:1).eq.'P') rea_phase(i)(1:6)='DELETE'
      enddo
c
c---------------------------------------------------------
c   select all traces with s-wave spectral values, print
c   on screen station, time and log moment
c----------------------------------------------------------
c
      do i=1,rea_nphase
          if(rea_phase(i)(1:5).eq.'SPECS') then
              write(6,'(1x,a4,1x,a5,2i2,f6.1,f6.2)')
     *        rea_stat(i), rea_comp(i), rea_hour(i),
     *        rea_min(i),rea_sec(i),rea_moment(i)
          endif
      enddo
c
c------------------------------------------------
c   write out all magnitudes form all hypocneters
c------------------------------------------------
c
      write(6,'(1x,6(f4.1,a1,a4,1x))') (hyp_mag_all(i),
     *hyp_mag_type_all(i),hyp_mag_agency_all(i),i=1,rea_nmag)
c
c   write out modified event, the array data has also been modified
c
       call rea_event_out(2,all,data,code)
c
c   get next event
c
      goto 50
c
c     end of file
c
 1000 continue
c
      write(6,*)            ! blank line
      close(2)              ! close output file
      write(6,*) 'Number of events in input file', nevent
      write(6,*) 'Output file name is sample_read_write_s.out'

      stop
      end

c$debug
c     Program to read macro seismic information into a nordic file
c
c     C. Lindholm, April 1993
c     jul 9 1993 by jh: version 3.0*******
c     jul 14          : to pc
c     aug cl some changes ??
c     aug 29 93 by jh: use subroutine get_agency instead of getenv
c     jan 94       ********** version 5.0 ************************
c     feb 21 99    -----------verison 7.0 check------------------
c
c
      implicit none
      include 'seidim.inc'
      character*80 data(max_data),macrocard
      character*80 input,sfile
      character*3 agency
      character*2 intscale
      character*1 diastrophism,tsunami,cult,unusual
      character*1 ucase,qualifier,quality
      character*1 type,exp
      real maclat,maclon,macmag,radfelt,intarea1,intarea2
      integer int1,int2,maxint
      integer i,nbend,macronr
      integer nhead,nrecord,nphas,nstat
      integer newcard



c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c------ Initialize
c
      quality = ' '
      qualifier = ' '
c     macrocard = ' '
      do i=1,80
        macrocard(i:i)=' '
      enddo
      diastrophism = ' '
      tsunami = ' '
      cult = ' '
      unusual = ' '
      maxint = 0
      intscale = 'MM'
      maclat = 0.0
      maclon = 0.0
      radfelt = 0.0
      int1 = 0
      intarea1 = 0.
      int2 = 0
      intarea2 = 0.
      call get_agency(agency)
c      agency = 'BER'


c      write(6,'(a,$)')' This will prevent carriage return'

      write(*,*)
     +'You will now enter macroseismic information into ',
     +'the S-file in the database'
      write(*,*)' '
      write(*,*)
     +'     A carriage return ==> Proceed to next question'
      write(*,*)
     +'     A /  ==> Input is finished, and written to S-file'
      write(*,*)' '

c      write(*,*)
c     +'Remember that any text that you want ',
c     +'to appear in the bulletin can be written directly ',
c     +'in the S-file!'
c      write(*,*)' ==========Syntax:'
c      write(*,*)
c     +'The first column blank and the next 4 ',
c     +'columns = Bul:, and a linetype 3 indicator'
c
c---- Quality rank of the report
c
      input = ' '
      write(6,'(a,$)')' Quality of this report (A, B, C or D)?:'
      read(*,'(a)')input
      i = NBEND(input)
      if(input(i:i) .eq. '/') go to 99
      quality = ucase(input(i:i)) 
c
c---- Diastrophism code;Only F(aulting) or blank
c
      input = ' '
      write(6,'(a,$)')' Surface Faulting? (y/n=default):'
      read(*,'(a)')input
      i = NBEND(input)
      if(ucase(input(i:i)) .eq. 'Y')diastrophism = 'F'
      if(input(i:i) .eq. '/') go to 99
c
c--- Tsunami or Seiches
c
      input = ' '
      write(6,'(a,$)')' Tsunami(T) or Seiches(S)? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      if(ucase(input(i:i)) .eq. 'T')tsunami = 'T'
      if(ucase(input(i:i)) .eq. 'S')tsunami = 'S'
c
c---- Cultural effects
c
      input = ' '
      write(6,'(a,$)')' C(asualties) or D(amage)? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      if(ucase(input(i:i)) .eq. 'C')cult = 'C'
      if(ucase(input(i:i)) .eq. 'D')cult = 'D'
c
c---- Unusual events
c
      write(*,*)' Possible unusual effects are:'
      write(*,*)' L == Liquefaction'
      write(*,*)' G == Geysir/Fumerol'
      write(*,*)' S == Landslides/Avalanches'
      write(*,*)' B == Sand blows'
      write(*,*)' V == Visual phenomena'
      write(*,*)' M == More than one of the above'

      input = ' '
      write(6,'(a,$)')' Enter code for unusual effect? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      if(ucase(input(i:i)) .eq. 'L')unusual = 'L'
      if(ucase(input(i:i)) .eq. 'G')unusual = 'G'
      if(ucase(input(i:i)) .eq. 'S')unusual = 'S'
      if(ucase(input(i:i)) .eq. 'B')unusual = 'B'
      if(ucase(input(i:i)) .eq. 'V')unusual = 'V'
      if(ucase(input(i:i)) .eq. 'M')unusual = 'M'
c
c---- Maximum intensity
c
      input = ' '
      write(6,'(a,$)')' Maximum intensity (integer)? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      open(77,status='scratch')
      write(77,'(a)') input
      rewind 77      
c      if(i .ge. 1)read(77,*)maxint
      if(input(1:3).ne.'   ') read(77,*) maxint
      rewind 77

      input = ' '
      write(6,'(a,$)')' Intensity qualifier (+/-)? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      read(input(1:i),'(a)')qualifier
c
c---- Intensity scale
c
 30   input = ' '
      write(*,*)' The following intensity scales are accepted:'
      write(*,*)' MM == Modified Mercalli (default)'
      write(*,*)' RF == Rossi Forel'
      write(*,*)' CS == Mercalli Cancani Seberg'
      write(*,*)' SK == Medevev Sponheur Karnik'

      write(6,'(a,$)')' Intensity scale? (default=MM):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      if(i .gt. 2)then
        write(*,*)' Only two characters are accepted'
        go to 30
      endif
      intscale = ucase(input(1:i))
      if(i .eq. 1)intscale = 'MM'
c
c---- Macroseismic epicenter and magnitude
c
      input = ' '
      write(6,'(a,$)')' Macroseismic latitude? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      read(input(1:i),'(f10.0)')maclat

      input = ' '
      write(6,'(a,$)')' Macroseismic longitude? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      read(input(1:i),'(f10.0)')maclon

      input = ' '
      write(6,'(a,$)')' Macroseismic magnitude? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      read(input(1:i),'(f10.0)')macmag
c
c---- Radius of felt area
c     
      input = ' '
      write(6,'(a,$)')' Radius of felt area (km)? (default=none):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      read(input(1:i),'(f10.0)')radfelt
c
c---- Intensity and area pairs
c
      input = ' '
      write(*,'(2a,$)')
     +' Area 1 where the earthquake was felt at ',
     +'a minimum intensity:'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      read(input(1:i),'(f10.0)')intarea1
      input = ' '
      write(*,'(a,$)')' Intensity bordering that area (integer):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      write(77,'(a)')input
      rewind 77
      if(input(1:3).ne.'   ') read(77,*) int1
      rewind 77
c      read(input(1:i),'(i)')int1

      input = ' '
      write(*,'(2a,$)')
     +' Area 2 where the earthquake was felt at ',
     +'a minimum intensity:'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      read(input(1:i),'(f10.0)')intarea2
      input = ' '
      write(*,'(a,$)')' Intensity bordering that area (integer):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      write(77,'(a)') input
      rewind 77
      if(input(1:3).ne.'   ') read(77,*) int2
c      read(input(1:i),'(i)')int2
c
c---- Agency for macroseismic report
c
      input = ' '
      write(*,'(4a,$)')' Agency for macroseismic report ',
     +'(default = ',agency,'):'
      read(*,'(a)')input
      i = NBEND(input) 
      if(input(i:i) .eq. '/') go to 99
      if(i .gt. 1)read(input(1:i),'(a)')agency

 99   continue
c
c-------- Now write the input on the S-file
c
      call get_env_event(sfile)
      open(18,file=sfile,status='old')
      
      call indata(18,nstat,nphas,NHEAD,NRECORD,TYPE,EXP,DATA,i)
c
c---- First find preexisting Type 2 line
c
      macronr = 0
      do i = 1,nhead
       if(data(i)(80:80) .eq. '2')then
         write(*,*)' Macroseismic information already exists....'
         write(*,'(a)')data(i)
         write(*,*)' 1 ==> Overwrite the existing information'
         write(*,*)' 2 ==> Create a new additional card'
         write(*,'(a,$)')' Enter your choice:'
         read(*,*)newcard
         if(newcard .eq. 1)then
           macrocard = data(i)
           macronr = i
         endif
       endif
      enddo

      write(macrocard(22:22),'(a)')diastrophism
      if(tsunami .eq. 'T')write(macrocard(23:23),'(a)')tsunami
      if(tsunami .eq. 'S')write(macrocard(24:24),'(a)')tsunami
      write(macrocard(25:25),'(a)')cult
      write(macrocard(26:26),'(a)')unusual
      write(macrocard(28:30),'(i2,a1)')maxint,qualifier
      write(macrocard(31:32),'(a)')intscale
      if(maclat .ne. 0.)then
         write(macrocard(34:39),'(f6.2)')maclat
         write(macrocard(41:47),'(f7.2)')maclon
      endif
      if(macmag .ne. 0.)write(macrocard(49:51),'(f3.1)')macmag
      if(radfelt .gt. 1.)then
        radfelt = log10(radfelt)
        write(macrocard(53:56),'(f4.2)')radfelt
      endif
      if(int1 .gt. 0)then
        intarea1 = log10(intarea1)
        write(macrocard(57:63),'(f5.2,i2)')intarea1,int1
      endif

      if(int2 .gt. 0)then
        intarea2 = log10(intarea2)
        write(macrocard(64:70),'(f5.2,i2)')intarea2,int2
      endif

      write(macrocard(72:75),'(a1,a3)')quality,agency
      write(macrocard(80:80),'(a)')'2'

      rewind (18)
      write(18,'(a)')data(1)
c---- New macroseisic card
      if(newcard .eq. 2 .or. macronr .eq. 0)then
        do i = 2,nhead-1
          write(18,'(a)')data(i)
        enddo
        write(18,'(a)')macrocard
        write(18,'(a)')data(nhead)
        do i = nhead+1,nrecord
          write(18,'(a)')data(i)
        enddo
      endif
c---- Overwrite old macroseismic card
      if(newcard .eq. 1)then        
        write(18,'(a)')macrocard
        do i = 2,nrecord
          if(i .ne. macronr)write(18,'(a)')data(i)
        enddo
      endif
c
c---  Finished puh!!!
c      
c      write(*,*)macrocard

c      write(*,*)' Diastrophism:',diastrophism
c      write(*,*)' Tsunami:',tsunami
c      write(*,*)' Cultural:',cult
c      write(*,*)' Unusual:',unusual
c      write(*,*)' Maxint:',maxint
c      write(*,*)' Intscale:',intscale
c      write(*,*) maclat,maclon,macmag
c      write(*,*)radfelt
c      write(*,*)int1,intarea1,int2,intarea2
c      write(*,*)agency


      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C NBEND    UT-F-U   Created: 8/11/89 Copied : 08/28/89 Made at NORSAR
      INTEGER FUNCTION NBEND(STRING)
      CHARACTER*(*) STRING
C.======================================================================
C.    PURPOSE
C     find_Non_Blank_END_of_string                                  UT<<
C.----------------------------------------------------------------------
C.    KEYWORDS
C.----------------------------------------------------------------------
C.    INPUT
C..   STRING - Character string
C
C.    OUTPUT
C..   NBEND  - Position of last non blank character in string
C.----------------------------------------------------------------------
C.    PROGRAMMER    Stein Holger Pettersen
C.    CREATION_DATE 19 Jun 1989
C.    MADE_AT  NTNF/NORSAR
C     Pb. 51
C     N-2007 Kjeller
C
C.    MODIFICATION
C.    CORRECTION
C.======================================================================
 
      LS = LEN(STRING)
      DO 10 I = LS,1,-1
         IF (STRING(I:I).NE.' ') GO TO 20
   10 CONTINUE
      I = 1
 
   20 NBEND = I
      RETURN
      END
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      character*1 function ucase(a)
c     convert lower case single char to upper case - machine independent
      
      character*1 chr(26),ucchr(26),a
      data chr/'a','b','c','d','e','f','g','h','i','j','k','l','m',
     &'n','o','p','q','r','s','t','u','v','w','x','y','z'/
      data ucchr/'A','B','C','D','E','F','G','H','I','J','K','L','M',
     &'N','O','P','Q','R','S','T','U','V','W','X','Y','Z'/
      do 10 i=1,26
        if(a.eq.chr(i))then
          ucase=ucchr(i)
          return
        endif
10    continue
      ucase=a
      return
      end

CSTART**************************************************************************
c----------------------------------------------------------------------         
c   feb 13 
c-------------------                                                                            
c   updates
c   apr 2 91 by j.h. : bugs
c   oct              : adoption to sun , scursr form tektronics has been
c                      replaced by cursor, a c routine, in order to read
c                      one char form x-windows keyboard, a bug in the tek
c                      imulation that it cannot be set up to read without
c                      a CR. In order to make it work, system calls 
c                      stty cbreak must be issued, stty -cbreak to get
c                      keyboard back to normal. 
c    nov 13          : cursor is disabled again, gave some buffer 
c                      problems. Problem solved by using a new c-routine
c                      readn in inout.f, so to read one char from keyboard.
c    aug 29 92       : add xt and vt routines
c    jul 93          : add xy_plot
c    aug 93          : new symbol
c    aug 29          : pc adoption
c    sep 6 93        : put a tsend in xcursr to fix cursor problem on pc
c    nov  25 93 by jh: check for ( and ) in xchars, move title a bit in xy_plot
c    jul 94          : add X capability
CJAB(BGS)Jan95       : Add JAB's symbol generator.
CJAB(BGS)Jan95       : Install use of parameters in SEIPLOT.INC
c mar 29, 95 by jh   : none option in input_box
c apr 11 95 by jh    : put in %! in start of poscript file, where did it go ???
c may 95             : new routines pmovabs and pdrwabs, change to xdrwvec
c                      change initial postscript statement
C!JAB(BGS)Jun95      : Problem when PostScript element formats are filled, so
C!JAB(BGS)Jun95        removing white spaces so that 2 elements required to
C!JAB(BGS)Jun95        operated on, merge into 1, so confusing PostScript.
C!JAB(BGS)Jun95        ...change all formats to ensure a white space between
C!JAB(BGS)Jun95        all fields.
c aug 22, 95 jh      : fix colors in  postscript, black was not set
c nov 20  95         : return in drwvec if less than 2 points
c aug 8   96         : set linewidth to 0.1 everywhere, also in init_post
c nov 6   96         : add color_syn
c feb     97         : do not link to tektronics anymore
c may 22             : change write statement for ps initiation so no blank
c oct                : do not open display in input_box
c sep 98 by jh       : ---------------   version 7.0 check -----------------
c                      no change
c nov 4              : linux logic
c nov 5              : remove '_' form c routine calls because of linux
c mar 22 99 bmt      : add oneline subroutine
c apr 14 99 bmt      : online modified
c apr 20    bmt      : oneline modified 
c may 6     bmt      : oneline modified 
c sep 20    bmt      : oneline modified 
c dec 12    lo       : inbox routine, dont return after 'all'
c mar 16 01 jh       : set def color station
c apr 24 03 jh       : put option to select all z-channels in input_box
c may  7 03 lo       : add myxfont to xopen call
c june 22   jh       : increase title in input_box
c may 26    lo       : deselect all non-Z channels when selecting All Z
c

c
c   Subroutines for making hard copy files when using screen         
c   plot. The calls will plot on either an X-screen, on PC using microsoft
c   fortran graphics and can at the same time make PostScript files.               
c   The screen coordinate system is tectronics (1024*780) since the first
c   version was made for Tektronics. The numbers are reals so higher 
c   resolution can be used.           
c 
c   When making postscript files and using many xdrwabs and xmovabs             
c   might give too many postscript commands without using a STROKE              
c   (postscript for making the bitmap). There is currently no check             
c   of how many lines are drawn except in the routine for drawing               
c   traces of data (XDRWVEC), so be careful.
c
c   The basic routines on PC are called the same as the original
c   Tektroncis routines. On PC they are linked with Microsoft graphics 
c   while on Sun they can be linked with Tektronics routines, but are
c   from version seisan 6.0 linked to dummy tektronics calls.                  
c                                                          
c                                                                               
c   All routines have common block tekout with the variables:                   
c                                                                               
c   plotoption: 0: only screen plot                                         
c               1: screen + hc file                                             
c               2: only hc file                                                 
c
c   display_type 0: microsoft graphics on pc
c                1: x
c
c   plotunit:   logical file unit for hc file                                   
c   hctype:     0: tektronics file                                              
c               1: postscript                                                   
c                                                                               
c   The parameters in common block must be set in main program.                 
c   Most routines make both a screen plot and               
c   a plot file (routine name start with x). For plotting characters,           
c   scaling might be different since postscript has more font sizes             
c   and separate routines are provided: pchars: for post script                 
c   tchars: for screen                                                      
c--------------------------------------------------------------------------     
c                                                                               
      subroutine xmovabs(x,y)                                                   
c                                                                               
c   emulate tek movabs                                                          
c                                                                               
      implicit none                                                             
      real x,y                                                                  
      integer ix,iy,ixold,iyold
      include 'seiplot.inc'
      common /movdrw/ixold,iyold
c                                                                               
c   check if tek plot                                                           
c                                                                               
	 if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x                                                                   
	 iy=y                                                                   
	 if(display_type.eq.0) then
	    call movabs(ix,iy)
	 else
	    call xmoveto(ix,iy)
	    ixold=ix
	    iyold=iy
	 endif
  
      endif                                                                     
c                                                                               
c   postscript                                                                  
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 write(plotunit,200) x,y                                                
 200     format(2(f7.1,1x),'moveto')              !JAB(BGS)Jun95.
      endif                                                                     
      return                                                                    
      end                                                                       
cccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pmovabs(x,y)                                                   
c                                                                               
c   same as xmovabs without postscript                                                          
c                                                                               
      implicit none                                                             
      real x,y                                                                  
      integer ix,iy,ixold,iyold
      include 'seiplot.inc'
      common /movdrw/ixold,iyold
c                                                                               
c                                                              
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x                                                                   
	 iy=y                                                                   
	 if(display_type.eq.0) then
	    call movabs(ix,iy)
	 else
	    call xmoveto(ix,iy)
	    ixold=ix
	    iyold=iy
	 endif
  
      endif                                                                     
      return
      end
c                                                                               
cc---------------------------------------------------------------------         
      subroutine xout(x,y)                                                      
c                                                                               
c   makes a stroke and move pen to x,y, post script only                        
c                                                                               
      implicit none                                                             
      real x,y                                                                  
      include 'seiplot.inc'
c                                                                               
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
      endif                                                                     
c                                                                               
c   postscript                                                                  
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 write(plotunit,*)'0.1 setlinewidth'                                    
	 write(plotunit,*)'stroke'                                              
	 write(plotunit,200) x,y                                                
 200     format(2(f7.1,1x),'moveto')            !JAB(BGS)Jun95.
      endif                                                                     
      return                                                                    
      end                                                                       
c----------------------------------------------------------------------         
      subroutine xdrwabs(x,y)                                                   
c                                                                               
c   emulate tek drwabs                                                          
c               
      implicit none                                                                
      real x,y                                                                  
      integer ix,iy,ixold,iyold
      include 'seiplot.inc'
      common /movdrw/ ixold,iyold
c
c                                                                               
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x                                                                   
	 iy=y                                                                   
	 if(display_type.eq.0) then
	     call drwabs(ix,iy)
	 else
	     call xlineto(ixold,iyold,ix,iy)
	     ixold=ix
	     iyold=iy
	 endif
      endif                                                                     
c                                                                               
c   postscript                                                                  
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 write(plotunit,200) x,y                                                
c200     format(2(f7.1,1x),'lineto stroke')       !JAB(BGS)Jun95.
 200     format(2(f7.1,1x),'lineto')              !JAB(BGS)Jun95.
      endif                                                                     
      return                                                                    
      end                                                                       
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pdrwabs(x,y)                                                   
c                                                                               
c   emulate tek drwabs, same as xdrwabs without postscript                                                          
c               
      implicit none                                                                
      real x,y                                                                  
      integer ix,iy,ixold,iyold
      include 'seiplot.inc'
      common /movdrw/ ixold,iyold
c
c                                                                               
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x                                                                   
	 iy=y                                                                   
	 if(display_type.eq.0) then
	     call drwabs(ix,iy)
	 else
	     call xlineto(ixold,iyold,ix,iy)
	     ixold=ix
	     iyold=iy
	 endif
      endif                                                                     
      return
      end
c                                                                               
c----------------------------------------------------------------------         
      subroutine xdrwvec(n,x0,y,step)
c 
c   draw a vector of n points, special for equally spaced points
c
c  sep 25 by jh : modified for pc to use less memory, step in call
c  may 95       : use pmovabs and pdrwabs for screen plot to avoid
c                 double plotting in plotoption 1
c  nov 20 95    : retuen if less than 2 points
c
      implicit none
      integer n                         ! number of points to plot
	  real x0                                               ! first x-value
      real x                            ! x-value to plot
	  real y(1)                                                     ! y-values to plot
      integer i,i1,i2                           ! counters
      real step                                                 ! distance between points, x-axis
      include 'seiplot.inc'
c
c   do not plot if less than 2 points
c
      if(n.lt.2) return
c
c   check if tek plot 
c
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then
	 x=x0
	 call pmovabs(x0,y(1))
	 do 1 i=2,n
	    x=x+step
	    if(x.gt.screen_sizex$) x=screen_sizex$
	    call pdrwabs(x,y(i))
1        continue
      endif
c
c   postscript, print out 200 points at a time, put y values in stack
c   and then plot in a loop using lineto
c   remember that points must be put in stack in reverse order
c
      if(plotoption.gt.0.and.hctype.eq.1) then
	 i1=1
	 i2=200
	 if(i2.gt.n) i2=n
	 if(n.eq.1) n=2
	 write(plotunit,200) x0,y(1)            
c
 10      continue
	 write(plotunit,'(16i5)') (int(10*y(i)),i=i2,i1,-1)     
c
c   multiply upper loop number with 1.0001 to ensure that exactly
c   200 numbers are read form the stack, rela number inaccuracy
c   did somtimes result in only 199 numbers were read
c
	 write(plotunit,201) 
     *   x0+(i1-1)*step,step,x0+(i2-1)*step*1.0001
 201     format(3(f12.7,1x),'{exch 0.1 mul lineto} for') !JAB(BGS)Jun95.
	 write(plotunit,*)'0.1 setlinewidth'
	 write(plotunit,*)'stroke'
	 i1=i1+200
	 i2=i2+200
	 if(i2.gt.n) i2=n
	 if(i1.gt.n) return                             
cvax         write(plotunit,200) x(i1-1),y(i1-1)
	 write(plotunit,200) x0+(i1-2)*step,y(i1-1) 
 200     format(2(f7.1,1x),'moveto')                 !JAB(BGS)Jun95.
	 goto 10         
      endif
      return
      end
c----------------------------------------------------------------------
      subroutine xdrwvec_old(n,x,y)                                                 
c                                                                               
c   draw a vector of n points, special for equally spaced points                
c                                                                               
      implicit none                                                             
c-- number of points to plot              
      integer n                         
c-- data to plot                          
      real x(1),y(1)                    
c-- counters                                         
      integer ix,iy,i,i1,i2             
c-- distance between points, x-axis                            
      real step                         
      include 'seiplot.inc'
c                                                                               
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x(1)                                                                
	 iy=y(1)                                                                
	 call movabs(ix,iy)                                                     
	 do 1 i=2,n                                                             
	    ix=x(i)                                                             
	    iy=y(i)                                                             
	    call drwabs(ix,iy)                                                  
1        continue                                                               
      endif                                                                     
c                                                                               
c   postscript, print out 200 points at a time, put y values in stack           
c   and then plot in a loop using lineto                                        
c   remeber that points must be put in stack in reverse order                   
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 i1=1                                                                   
	 i2=200                                                                 
	 if(i2.gt.n) i2=n                                                       
	 if(n.eq.1) n=2                                                         
	 step=(x(n)-x(1))/(n-1)                                                 
c-- move to first point of trace          
	 write(plotunit,200) x(1),y(1)          
c                                                                               
 10      continue                                                               
c-- y-values to stack 
	 write(plotunit,'(16i5)') (int(10*y(i)),i=i2,i1,-1)     
c-- loop values                    
	 write(plotunit,201) x(i1),step,x(i2)           
 201     format(f9.3,1x,f12.7,1x,f9.3,1x,'{exch 0.1 mul lineto} for') !JAB(BGS)Jun95.
	 write(plotunit,*)'0.1 setlinewidth'                                    
	 write(plotunit,*)'stroke'                                              
	 i1=i1+200                                                              
	 i2=i2+200                                                              
	 if(i2.gt.n) i2=n                                                       
c-- check if more poits                            
	 if(i1.gt.n) return                             
c-- move to last point              
	 write(plotunit,200) x(i1-1),y(i1-1)            
 200     format(2(f7.1,1x),'moveto')                !JAB(BGS)Jun95.                              
	 goto 10                                                                
      endif                                                                     
      return                                                                    
      end                                                                       
c----------------------------------------------------------------------         
      subroutine xdrwlin(n,x,y)                                                 
c                                                                               
c   draw a vector of n points                                                   
c                                                                               
      implicit none                                                             
c-- number of points to plot              
      integer n                         
c-- data to plot                          
      real x(1),y(1)                    
c-- counters                                         
      integer ix,iy,i,i1,i2             
      include 'seiplot.inc'
c                                                                               

c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 call xmovabs(x(1),y(1))                                                     
	 do 1 i=2,n                                                             
	    ix=x(i)                                                             
	    iy=y(i)                                                             
	    call xdrwabs(x(i),y(i))                                                  
1        continue                                                               
      endif                                                                     
c                                                                               
c   postscript, print out 100 points at a time, put y values in stack           
c   and then plot in a loop using lineto                                        
c   remeber that points must be put in stack in reverse order                   
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 i1=1                                                                   
	 i2=100                                                                 
	 if(i2.gt.n) i2=n                                                       
	 if(n.eq.1) n=2                                                         
c-- move to first point of trace          
	 write(plotunit,200) x(1),y(1)          
c                                                                               
 10      continue                                                               
	 do i=i1,i2                                                             
	    write(plotunit,201) x(i),y(i)                                             
 201        format(2(f7.1,1x),'lineto')         !JAB(BGS)Jun95.
	 enddo                                                                  
	 write(plotunit,*)'0.1 setlinewidth'                                    
	 write(plotunit,*)'stroke'                                              
	 i1=i1+100                                                              
	 i2=i2+100                                                              
	 if(i2.gt.n) i2=n                                                       
c-- check if more poits                            
	 if(i1.gt.n) return                             
c-- move to last point              
	 write(plotunit,200) x(i1-1),y(i1-1)            
 200     format(2(f7.1,1x),'moveto')             !JAB(BGS)Jun95.                                 
	 goto 10                                                                
      endif                                                                     
      return                                                                    
      end                                                                       
c#############################################################################  
										       
      SUBROUTINE XCHARS(STRING,NSTR,X,Y)                                        
C                                                                               
C   PLOTS NSTR CHARACTERS FROM STRING STRING ON                                 
C   POSITION X,Y ON A TECTRONICS SCREEN AND A POSTSCRIPT PRINTER                
C                                                                               
c   J. Havskov, sometimes in 1985                                               
c   1991 by j.h. : adopted to postscript and tektronics                         
c   nov  25 93 by jh: check for ( and )
CJAB(BGS)Feb95   : Put double spacing if non-proportional font (eg. T.Roman)
CJAB(BGS)Feb95     and required by calling program
c                                                                               
      implicit none
      CHARACTER*90 STRING                                                       
      CHARACTER*1 SINGLE(90)                                                    
      REAL X,Y                                                                  
      INTEGER CHAR(90)                                                          
      INTEGER IX,IY,i,nstr                                                             
c
      external     sei clen                     ! String length.
      integer      sei clen,                    ! Function.
     &             copy_n,                      ! # chars in string copy.
     &             string_n                     ! # chars in string.
      character    chr_string *(90),            ! Working string.
     &             chr_copy   *(90),            ! & copy.
     &             chr_temp   *(90)             ! & working copy.
      equivalence (chr_string,single)           ! Byte by byte.
c
      logical sun,pc,linux
      include 'seiplot.inc'
      call computer_type(sun,pc,linux)
c
c   Prepare the string...
c   ======================
c
      string_n   = nstr                         ! Input length of string.
      chr_string = string                       ! Copy string.
c
c   Remove parenthesis...
c   ---------------------
c
1000  ix = index(chr_string,'(')                !
      if( ix .gt. 0 ) then                      !
      chr_string(ix:ix) = ' '                   !
      goto 1000                                 !
      end if                                    !
c
1100  ix = index(chr_string,')')                !
      if( ix .gt. 0 ) then                      !
      chr_string(ix:ix) = ' '                   !
      goto 1100                                 !
      end if                                    !
c
c    Force double spacing when forced and non-proportional font...
c    -------------------------------------------------------------
c    Do this because, space is about half-space of proportional font...
c
      copy_n     = nstr                         ! & copy.
      chr_copy = chr_string                         ! Make a copy.
c
      if( b_force_space$ ) then                     ! Look at spacing.
      b_force_space$ = .false.                      ! Re-set.
c
      ix = 0                                        ! Pointer.
100   ix = ix + 1                                   ! & increment.
c
         if( ix .eq. string_n ) then                ! Finished.
         continue                                   !
c
         else if( chr_string(ix:ix) .eq. ' ' ) then ! Found a space.
         ix = ix + 1                                ! Increment pointer.
         string_n = string_n + 1                    ! & length.
         chr_temp = ' ' // chr_string(ix:)          ! Padded remainder.
         chr_string(ix:) = chr_temp                 ! & add insert.
         goto 100                                   ! Next character.
c
         else                                       ! No space.
         goto 100                                   ! Next character.
         end if                                     !
      end if                                        !
c
c  PostScript...
c  =============
c
      if(plotoption.gt.0.and.hctype.eq.1) then
         write(plotunit,200) x,y
 200     format(2(f7.1,1x),'moveto')               !JAB(BGS)Jun95.
c
            if( b_prop_psfont$ ) then
            write(plotunit,201) chr_copy(1:copy_n)        
            else
            write(plotunit,201) chr_string(1:string_n)
            end if
c
 201     format('(',a,') show')
      endif
c
c   check if tek plot...
c   ====================
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x                                                                   
	 iy=y                                                                   
	 if(display_type.eq.1) then
            if( b_prop_font$ ) then
	    call xtext(chr_copy,copy_n,ix,iy)
            else
            call xtext(chr_string,string_n,ix,iy)
            end if
	 else
C
C   PLOT CHARACTERS AT POSITION IX,IY
C
         if(sun.or.linux)CALL MOVABS(IX,IY)
         if(pc) CALL ANSTRPC(string_n,string,IX,IY+18)

cc	   CALL MOVABS(IX,IY+15)
C                                                                               
C   FIND ASCII VALUES OF EACH CHARACTER & plot...
C                                                                               
         if( b_prop_font$ ) then                ! Use non-amended copy.
         string_n = copy_n                      !
         chr_string = chr_copy                  !
         end if                                 !
c
	 DO 10 I=1,string_n 
	 CHAR(I)=ICHAR(SINGLE(I))                                            
 10      CONTINUE                                                               
	 CALL ANSTR(string_n,CHAR)
	 endif
      endif                                                                     
c                                                                               
      RETURN                                                                    
      END                                                                       
c#############################################################################  
										       
      SUBROUTINE XCHARSWIN(STRING,NSTR,X,Y)                                        
c
c XCHARSWIN is the same as XCHARS, but calls xtextwin instead of xwin
c
c lo 18.03.2002                                  
c
      implicit none
      CHARACTER*90 STRING                                                       
      CHARACTER*1 SINGLE(90)                                                    
      REAL X,Y                                                                  
      INTEGER CHAR(90)                                                          
      INTEGER IX,IY,i,nstr                                                             
c
      external     sei clen                     ! String length.
      integer      sei clen,                    ! Function.
     &             copy_n,                      ! # chars in string copy.
     &             string_n                     ! # chars in string.
      character    chr_string *(90),            ! Working string.
     &             chr_copy   *(90),            ! & copy.
     &             chr_temp   *(90)             ! & working copy.
      equivalence (chr_string,single)           ! Byte by byte.
c
      logical sun,pc,linux
      include 'seiplot.inc'
      call computer_type(sun,pc,linux)
c
c   Prepare the string...
c   ======================
c
      string_n   = nstr                         ! Input length of string.
      chr_string = string                       ! Copy string.
c
c   Remove parenthesis...
c   ---------------------
c
1000  ix = index(chr_string,'(')                !
      if( ix .gt. 0 ) then                      !
      chr_string(ix:ix) = ' '                   !
      goto 1000                                 !
      end if                                    !
c
1100  ix = index(chr_string,')')                !
      if( ix .gt. 0 ) then                      !
      chr_string(ix:ix) = ' '                   !
      goto 1100                                 !
      end if                                    !
c
c    Force double spacing when forced and non-proportional font...
c    -------------------------------------------------------------
c    Do this because, space is about half-space of proportional font...
c
      copy_n     = nstr                         ! & copy.
      chr_copy = chr_string                         ! Make a copy.
c
      if( b_force_space$ ) then                     ! Look at spacing.
      b_force_space$ = .false.                      ! Re-set.
c
      ix = 0                                        ! Pointer.
100   ix = ix + 1                                   ! & increment.
c
         if( ix .eq. string_n ) then                ! Finished.
         continue                                   !
c
         else if( chr_string(ix:ix) .eq. ' ' ) then ! Found a space.
         ix = ix + 1                                ! Increment pointer.
         string_n = string_n + 1                    ! & length.
         chr_temp = ' ' // chr_string(ix:)          ! Padded remainder.
         chr_string(ix:) = chr_temp                 ! & add insert.
         goto 100                                   ! Next character.
c
         else                                       ! No space.
         goto 100                                   ! Next character.
         end if                                     !
      end if                                        !
c
c  PostScript...
c  =============
c
      if(plotoption.gt.0.and.hctype.eq.1) then
         write(plotunit,200) x,y
 200     format(2(f7.1,1x),'moveto')               !JAB(BGS)Jun95.
c
            if( b_prop_psfont$ ) then
            write(plotunit,201) chr_copy(1:copy_n)        
            else
            write(plotunit,201) chr_string(1:string_n)
            end if
c
 201     format('(',a,') show')
      endif
c
c   check if tek plot...
c   ====================
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x                                                                   
	 iy=y                                                                   
	 if(display_type.eq.1) then
            if( b_prop_font$ ) then
	    call xtextwin(chr_copy,copy_n,ix,iy)
            else
            call xtextwin(chr_string,string_n,ix,iy)
            end if
	 else
C
C   PLOT CHARACTERS AT POSITION IX,IY
C
         if(sun.or.linux)CALL MOVABS(IX,IY)
         if(pc) CALL ANSTRPC(string_n,string,IX,IY+18)

cc	   CALL MOVABS(IX,IY+15)
C                                                                               
C   FIND ASCII VALUES OF EACH CHARACTER & plot...
C                                                                               
         if( b_prop_font$ ) then                ! Use non-amended copy.
         string_n = copy_n                      !
         chr_string = chr_copy                  !
         end if                                 !
c
	 DO 10 I=1,string_n 
	 CHAR(I)=ICHAR(SINGLE(I))                                            
 10      CONTINUE                                                               
	 CALL ANSTR(string_n,CHAR)
	 endif
      endif                                                                     
c                                                                               
      RETURN                                                                    
      END                                                                       
c#############################################################################  
      SUBROUTINE PCHARS(STRING,NSTR,X,Y)                                        
C                                                                               
C   PLOTS NSTR CHARACTERS FROM STRING STRING ON                                 
C   POSITION X,Y ON A POSTSCRIPT LASER                                          
C                                                                               
c   J. Havskov, sometimes in 1985                                               
c   1991 by j.h. : adopted to postscript                                        
      implicit none
      CHARACTER*80 STRING                                                       
      REAL X,Y                                                                  
      INTEGER nstr,i                                                          
C                                                                               
      include 'seiplot.inc'
c
c   check for parenthesis
c
      do i=1,nstr
	if(string(i:i).eq.'(') string(i:i)=' '
	if(string(i:i).eq.')') string(i:i)=' '
      enddo
c                                                                               
c  postscript                                                                   
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 write(plotunit,200) x,y                                                
 200     format(2(f7.1,1x),'moveto')            !JAB(BGS)Jun95.
	 write(plotunit,201) string(1:nstr)                                     
 201     format('(',a,') show')                                                 
      endif                                                                     
c                                                                               
      RETURN                                                                    
      END                                                                       
c#############################################################################  
										       
      SUBROUTINE TCHARS(STRING,NSTR,X,Y)                                        
C                                                                               
C   PLOTS NSTR CHARACTERS FROM STRING STRING ON                                 
C   POSITION X,Y ON A TECTRONICS SCREEN                                         
C                                                                               
c   J. Havskov, sometimes in 1985                                               
c   1991 by j.h. : adopted to tektronics with real numbers                      
c                                                                               
      implicit none
      CHARACTER*80 STRING                                                       
      CHARACTER*1 SINGLE(80)                                                    
      REAL X,Y                                                                  
      INTEGER CHAR(80)                                                          
      INTEGER IX,IY,nstr,i                                                             
      logical sun,pc,linux
C                                                                               
      include 'seiplot.inc'
c
      call computer_type(sun,pc,linux)
c   check for parenthesis
c
      do i=1,nstr
	if(string(i:i).eq.'(') string(i:i)=' '
	if(string(i:i).eq.')') string(i:i)=' '
      enddo
c                                                                               
      READ(STRING,'(80A1)') SINGLE                                              
c                                                                               
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 ix=x                                                                   
	 iy=y                                                                   
	 if(display_type.eq.1) then
	    call xtext(string,nstr,ix,iy)
	 else
C           
C   FIND ASCI VALUES OF EACH CHARACTER
C           
	 DO 10 I=1,NSTR
	    CHAR(I)=ICHAR(SINGLE(I))
 10      CONTINUE
C           
C   PLOT CHARACTERS AT POSITION IX,IY
C           
	 if(sun.or.linux)CALL MOVABS(IX,IY)
	 if(pc) call ANSTRPC(NSTR,STRING,IX,IY+15)

c	 CALL MOVABS(IX,IY+15)
	 CALL ANSTR(NSTR,CHAR)
	 endif
      endif                                                                     
c                                                                               
      RETURN                                                                    
      END                                                                       
										
c------------------------------------------------------------------------------ 
      subroutine xnewpag                                                        
      implicit none
      include 'seiplot.inc'
c
      character  chr_text *(80)                        ! Local text string.
c
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 call clear_display                                                            
      endif                                                                     
c                                                                               
c   postscript                                                                  
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 write(plotunit,*)'0.1 setlinewidth'                                    
c        write(plotunit,*)'0.2 setlinewidth'                                    
	 write(plotunit,*)'stroke'                                              
	 write(plotunit,*)'showpage'                                            
c                                                                               
c  move plot a bit so it fits                                                   
c                                                                               
	 write(chr_text(1:10),'(2F5.1)') PLOT_TRANSX$,
     &                                   PLOT_TRANSY$
	 chr_text = chr_text(1:10) // ' translate'
	 write(plotunit,'(a)') chr_text
c                                                                               
c   scale to fit tektronics coordinate system                                   
c                                                                               
         call get_env_psscale(PLOT_SCALEX$,PLOT_SCALEY$) ! lo
	 write(chr_text(1:9),'(F5.2,F4.1)') PLOT_SCALEX$,
     &                                      PLOT_SCALEY$
	 chr_text = chr_text(1:9) // ' scale'
	 write(plotunit,'(a)') chr_text
c                                                                               
c        initialize one font                                                    
c                                                                               
	 write(plotunit,*)'/Times-Roman findfont'                               
c                                                                               
c   scale font so that they are not deformed                                    
c   from scale                                                                  
c                                                                               
	 write(plotunit,*)'[20 0 0 15 0 0] makefont'                            
	 write(plotunit,*)'setfont'                                             
c                                                                                
      endif                                                                     
c                                                                               
      return                                                                    
      end                                                                       
c----------------------------------------------------------------------------   
										
      subroutine open_display
      implicit none                                                             
      integer baud              ! baud rate for tectronics
      integer color_type        ! 1: a color x screen, 0; bw
      include 'seiplot.inc'
      include 'libsei.inc'      !JAB(BGS)Jul95 Library definitions.
      include 'seisan.inc'      
c
      external     computer_type !JAB(BGS)Jul95 Get platform type.
      logical      b_sun,linux !JAB(BGS)Jul95 Sun platform?.
c
c
c get seisan def
c
      call get_seisan_def

      baud=9600    ! dummy value

c
c   set color array
c
      data xblue  / blue$   /,
     &     xgreen / green$  /,
     &     xred   / red$    /,
     &     xyellow/ yellow$ /,
     &     xwhite / white$  /,
     &     xblack / black$  /
c
c   read and set object colors
c
            call set_color_object
c
c   find display type
c
      call get_display(display_type)
c
c   Get platform details...
c   -----------------------
c
      call computer_type( b_sun, B_F_PC$,linux )     !JAB(BGS)Jul95 Computer platform.
c
c  in version 6.0, stop if attempt to use Tektronics
c
       if((b_sun.or.linux).and.display_type.eq.0) then
          write(6,*)' Xdisplay not ready'
          stop
       endif
c                                                                               
c   check if tek plot, if only hardcopy, jump next section                     
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 if(disp_open.eq.0) then ! display not already open
	    if(display_type.eq.0) then
	       call initt(baud)   ! pc 
	    else
	       call xopen(wsize,color_type,cursortype,myxfont)   ! x windows
	       if(color_type.eq.0) color_screen=0 ! if not c. screen, turn off col.
	       call xgetabsposition()     ! get position of initial text window
	       call xmovetographics()     ! move to graphics window
	    endif
	    call set_background(color_back) ! set background color
	    disp_open=1          ! indicate display has been opened
	 else                    ! display already open, just clear
	    call clear_display
c
c   display might have been changed since last call, reajust
c
	    if(display_type.eq.1) call updatewindowsize()
	 endif
      endif                                                                     
c
c   Determine if messages can be written...
c   ---------------------------------------
c
      B_F_GRAPH$   = disp_open .gt. 0           !JAB(BGS)Jul95 Graphics open?.
      B_F_MESSAGE$ = .not.(B_F_PC$ .and.        !JAB(BGS)Jul95 Can write?.
     &                     B_F_GRAPH$)          !JAB(BGS)Jul95.
c                                                                               
c   postscript, assume always initialize when calling open display   
c
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
	 call init_post
      endif                                                                     
c
c   set def color
c
c     call xset_color(color_def)
c                                                                               
      return                                                                    
      end                                                                       
c-----------------------------------------------------------------------------  
      subroutine init_post                                                   
c
c   just for initializing a post script file
c
      implicit none                                                             
      include 'seiplot.inc'
c
      character  chr_text *(80)                        ! Local text string.
c
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
c
c-- open plotter for postscript                   
         write(plotunit,'(a)')'%!PS-Adobe-2.0 EPSF-2.0'    ! start of postscript
	 write(plotunit,'(a)')'%%BoundingBox: 0 0 595 841' ! A4 page size.
	 write(plotunit,'(a)')'newpath'                                             
c                                                                               
c  move plot a bit so it fits                                                   
c                                                                               
	 write(chr_text(1:10),'(2F5.1)') PLOT_TRANSX$,
     &                                   PLOT_TRANSY$
	 chr_text = chr_text(1:10) // ' translate'
	 write(plotunit,'(a)') chr_text
c                                                                               
c   scale to fit tektronics coordinate system                                   
c                                                                               
         call get_env_psscale(PLOT_SCALEX$,PLOT_SCALEY$) ! lo
	 write(chr_text(1:9),'(F5.2,F4.1)') PLOT_SCALEX$,
     &                                      PLOT_SCALEY$
	 chr_text = chr_text(1:9) // ' scale'
	 write(plotunit,'(a)') chr_text
c                                                                               
c        initialize one font                                                    
c                                                                               
	 write(plotunit,*)'/Times-Roman findfont'                               
c                                                                               
c   scale font so that they are not deformed                                    
c   from scale                                                                  
c                                                                               
	 write(plotunit,*)'[20 0 0 15 0 0] makefont'                            
	 write(plotunit,*)'setfont'                                             
c
c   set def color
c
c        call xset_color(color_def)
c
c   set line size
c
	 write(plotunit,*)'0.1 setlinewidth'                                    
      endif                                                                     
c                                                                               
      return                                                                    
      end                                                                       
c-----------------------------------------------------------------------------  
      subroutine fontsize(font,size)                                            
c                                                                               
c   set postscript font and size                   
c                                                                               
c      if font is zero, use standard font                                       
c      if size is zero, use standard size                                       
										
      implicit none                                                             
c-- font multiplication factor                                 
      real scale                        
      integer font                                                              
      real size                                                                 
      include 'seiplot.inc'
c                                                                               
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
      endif                                                                     
c                                                                               
c   postscript                                                                  
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
c                                                                               
c   set size in mm (hopefully)                                                  
c                                                                               
	 if(size.eq.0.0) then                                                   
	    scale=1.0                                                           
	 else                                                                   
	    scale=size/3.5                                                      
	 endif                                                                  
c                                                                               
c        initialize font                                                        
c                                                                               
	 if(font.eq.0) write(plotunit,*)'/Times-Roman findfont'                 
	 write(plotunit,*)'[20 0 0 15 0 0] makefont'                            
c                                                                               
	 write(plotunit,201)scale                                               
 201     format(f8.2,1x,' scalefont')                                           
	 write(plotunit,*)'setfont'                                             
      endif                                                                     
c                                                                               
      return                                                                    
      end                                                                       
										
										
c      subroutine xfinitt(k,j)                                                   
c      implicit none
c      integer k,j                                                               
c      character*1 ctld                                                          
c      include 'seiplot.inc'
cc                                                                               
c   check if tek plot                                                           
c                                                                               
c      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
c         call finitt(k,j)                                                      
c         if(display_type.eq.0) then
c         call finitt(k,j)
c         else
c            call xclose()
c         endif
c
c      endif                                                                     
c                                                                               
c   postscript                                                                  
c                                                                               
c      if(plotoption.gt.0.and.hctype.eq.1) then                                  
c         write(plotunit,*)'0.2 setlinewidth'                                    
c         write(plotunit,*)'stroke'                                              
c         write(plotunit,*)'showpage'                                            
c         ctld=char(4)                                                           
c         write(plotunit,'(a)') ctld                                             
c      endif                                                                     
c                                                                               
c      return                                                                    
c      end
								       
      subroutine close_post                                                   
c
c   put closing lines in postscript file
c
      implicit none
      character*1 ctld                                                          
      include 'seiplot.inc'
c                                                                               
c   postscript                                                                  
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
c        write(plotunit,*)'0.2 setlinewidth'                                    
	 write(plotunit,*)'0.1 setlinewidth'                                    
	 write(plotunit,*)'stroke'                                              
	 write(plotunit,*)'showpage'                                            
	 ctld=char(4)                                                           
	 write(plotunit,'(a)') ctld                                             
      endif                                                                     
c                                                                               
      return                                                                    
      end                                                                       
c------------------------------------------------------------------------------ 
      subroutine clear_display                                                         
c                                                                               
c   tek routine erase                                                           
c               
      implicit none                                                                
      include 'seiplot.inc'
c                                                                               
c   check if tek plot                                                           
c                                                                               
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 if(display_type.eq.0) then
	    call erase    ! pc 
	 else
	    call xclear   ! xterminal clear
	 endif
      endif                                                                     
c                                                                               
c   postscript                                                                  
c                                                                               
      if(plotoption.gt.0.and.hctype.eq.1) then                                  
      endif                                                                     
c                                                                               
      return                                                                    
      end                                                                       
c---------------------------------------------------------------------          
      subroutine xscursr(ich,x,y)                                               
      implicit none
c                                                                               
c   tek routine scursr                                                          
c
      real x,y                                                                               
      integer ix,iy                                                             
      integer ich                                                              
      character*4 key
      include 'seiplot.inc'
      logical pc,sun,linux
      call computer_type(sun,pc,linux)
c                                                                               
c   check if tek plot                                                           
c                                                                               
      call tsend    ! fix cursor problems on pc
      if(hctype.eq.0.or.(hctype.gt.0.and.plotoption.lt.2)) then                 
	 if(display_type.eq.0) then
	    if(sun.or.linux) call scursr(ich,ix,iy)                                         
	    if(pc)  call sscursr(ich,ix,iy)
	 else
	    call xcursr(key,ix,iy)
	    ich=ichar(key(1:1))
	 endif
    
	 x=ix                                                                   
	 y=iy                                                                   
      endif                                                                     
c                                                                               
      return                                                                    
      end                                                                       

      subroutine vt
c
c   go to vt  window in X
c
      implicit none
      include 'seiplot.inc'
      logical sun,pc,linux
      call computer_type(sun,pc,linux)
      if(display_type.eq.1) return
      if(sun.or.linux) write(6,*) ' '
      return
      end
c----------------------------------------------------------------
c
c  the escape sequences in routines xt and vt are not what
c  they look like, you cannot just plainly write them. They have
c  been read directly in from ~/COM/xt and vt and must have some
c  hidden stuff inside, see xt and vt on COM
c     
      subroutine xt
c
c  go to tek window in X
c 
      implicit none
      include 'seiplot.inc'
      logical sun,pc,linux
      call computer_type(sun,pc,linux)
      if(display_type.eq.1) return
      if(sun.or.linux) then
	 write(6,*) '[?38h'
	 write(6,*) '8'
      endif
      return
      end

      subroutine xsymbol(symbol,size,x,y)
c
c
c   plot a symbol centered
c
c     symbol: symbol number
c     size:   size across in tek units
c     x,y:    position in tek units
c
c  aug 93 by jh : add triangel
cJAB(BGS)Jan95  : Convert to using symbol generator...
c
      implicit none
      external   draw_symbol
      integer    draw_symbol
c
      real x,y,size
      integer symbol     
c
      integer    code                       ! Dummy.
c
c    Use symbol generator...
c    -----------------------
c
      code = draw_symbol( symbol, x, y, size ) ! Draw the symbol.
c
c    Return to Caller...
c    ===================
c
       return
       end
c


      subroutine clear_to_alpha
c
c  clears from graphics and returns to the alpha screen
c
      include 'seiplot.inc'
      include 'libsei.inc'                 !JAB(BGS)Jul95 Library definitions.
      logical pc,sun,linux
c
c   Messages can be written...
c   --------------------------
c
      B_F_GRAPH$   = .false.                    !JAB(BGS)Jul95 Graphics closed!
      B_F_MESSAGE$ = .true.                     !JAB(BGS)Jul95 Can write!!.
c
c   if display is not open, just return
c
      if(disp_open.eq.0) return
c
      call computer_type(sun,pc,linux)
      B_F_PC$ = pc                     !JAB(BGS)Jul 95 Install computer type.
      if(pc) call clear_to_text
      if(sun.or.linux) then
	 if(display_type.eq.1) then
	    call xmovetoalpha()        ! move cursor to alpha window
	    call xclose                ! close x window
	 endif
      else
	 call finitt(1,1)    ! tek clear
	 call vt             ! back to vt window
      endif
c
c  indicate graphics window closed
c
      disp_open=0
c
c   Return to caller...
c   -------------------
c
      return
      end
c
c
      subroutine xset_color(color)
c
c   sets the color to color for following operations
c
      implicit none
      logical pc,sun,linux
      integer color    ! different colors
      integer color_to_set ! the actual color set
      include 'seiplot.inc'
      color_to_set=color   ! transfer variable since it might be changed
c
c  if color not in valid range, return
c
      if( color .lt. 1            .or.        ! Invalid.
     &    color .gt. xcolour_n$)  then
c          write(6,*) 'invalid color ',color
      return
      endif
c
c   if no colors are set, make sure the drawing and background are different
c   if no color background is chosen, make it white. If call comes from
c   set_box, black and white is already set, so jump.
c
      if(color_screen.eq.0.and.from_input_box.ne.1) then
	 if(color_back.eq.xblack) then 
	    color_to_set=xwhite
	 else
	    color_to_set=xblack   
	    color_back=xwhite
	 endif
      endif
c
      if(from_input_box.eq.1) color_to_set=color

c
c                                                                               
c   check which plot                                                           
c
      call computer_type(sun,pc,linux)
      if(plotoption.lt.2) then  ! check if only hc plot                 
	 if(display_type.eq.0) then  ! tektronics
	 endif
	 if(display_type.eq.1) then  ! x
	   call setcolorx(color_to_set)
	 endif
	 if(pc) then  ! pc
	   call set_color_pc(color_to_set)
	 endif
      endif
c                                                                               
c   postscript, if not hc colors return since background here is
c   always white                                                                  
c               
      if(color_hard_copy.ne.1) return                                                                
      color_to_set=color
      if(plotoption.gt.0) then
	 write(plotunit,*)'stroke'
	 write(plotunit,*)'newpath'
         if(color_to_set.eq.xblue)
     *   write(plotunit,*) '0. 0. 1. setrgbcolor'
         if(color_to_set.eq.xred)
     *   write(plotunit,*) '1. 0. 0. setrgbcolor'
         if(color_to_set.eq.xgreen)
     *   write(plotunit,*) '0. 1. 0. setrgbcolor'
         if(color_to_set.eq.xyellow)
     *   write(plotunit,*) '0. 1. 1. setrgbcolor'
         if(color_to_set.eq.xwhite)
     *   write(plotunit,*) '1. 1. 1. setrgbcolor'
         if(color_to_set.eq.xblack)
     *   write(plotunit,*) '0. 0. 0. setrgbcolor'
	 write(plotunit,*)'stroke'
      endif
c
      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine set_color_object
c
c   sets the color for different objects
c
      implicit none
      include 'seiplot.inc'
c                                                                               
c   set default colors                                                         
c
c
c   default is no colors
c
       color_screen=0
       color_hard_copy=0
c
c   no call from set_input_box yet
c
       from_input_box=0
c
       color_trace=xyellow
       color_station=xblue
       color_pic=xred
       color_syn=xblue
       color_def=xwhite
       color_frame=xgreen
       color_title=xyellow
       color_spec=xred
       color_axis_not=xyellow
       color_epi=xred
       color_map_contour=xyellow
       color_map_grid=xgreen
       color_symbol_key=xred
       color_prompt=xblack
       color_label_grid=xgreen
       color_section=xgreen
       color_bval_np=xgreen
       color_bval_ac=xred
       color_bval_line=xblue
       color_back=xwhite
       color_box=xyellow
       color_box_letter=xblack
       color_zoom=xred
       color_foc_dilat=xred
       color_foc_comp=xgreen
       color_foc_p=xred
       color_foc_t=xblue
       color_foc_plane=xblue
c
c  check if color definition file and possibly reset
c
       call get_colors      
c
c   if black and white, make sure toggling with set_box is correct
c
       if(color_screen.eq.0) then
	  if((color_box.ne.xblack.and.color_box.ne.xwhite).or.
     *    (color_box_letter.ne.xwhite.and.color_box_letter.ne.xblack).
     *    or.color_box_letter.eq.color_box) then
	     color_box=xwhite
	     color_box_letter=xblack
	  endif
       endif

       return
       end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine get_colors
c
c   reads colors from color.def file
c
      implicit none
      include 'seiplot.inc'
	  include 'libsei.inc'
      character*80 colors(60)   ! max number of color objects
      integer in                ! input file unit
      integer n                 ! number of lines in def file
      integer c                 ! color number
      integer i,code
c
c   get def file
c
	   call sei get file( open$+ignore$,  ! Check for file.
     &                        in,              ! Unit 
     &                        code,            ! Returned condition.
     &                        'DAT',           ! Alternative search directory.
     &                        'COLOR.DEF' )    ! For this filename.
c
c  if it does not exist, return
c
      if( code .ne. e_ok$ ) return
c
c   read file
c
      i=1
  1   continue
      read(in,'(a)',end=2) colors(i)
      i=i+1
      goto 1
c
c   end of file, find and set object colors
c
  2   continue
      n=i
c
      do i=1,n
	 read(colors(i)(25:25),'(i1)',err=5) c
  5      continue
	 if(colors(i)(1:20).eq.'color_screen        ') color_screen=c
	 if(colors(i)(1:20).eq.'color_hard_copy     ') color_hard_copy=c
	 if(colors(i)(1:20).eq.'color_trace         ') color_trace=c
	 if(colors(i)(1:20).eq.'color_pic           ') color_pic=c
	 if(colors(i)(1:20).eq.'color_syn           ') color_syn=c
	 if(colors(i)(1:20).eq.'color_def           ') color_def=c
	 if(colors(i)(1:20).eq.'color_frame         ') color_frame=c
	 if(colors(i)(1:20).eq.'color_title         ') color_title=c
	 if(colors(i)(1:20).eq.'color_spec          ') color_spec=c
	 if(colors(i)(1:20).eq.'color_axis_not      ') color_axis_not=c
	 if(colors(i)(1:20).eq.'color_epi           ') color_epi=c
	 if(colors(i)(1:20).eq.'color_station       ') color_station=c
	 if(colors(i)(1:20).eq.'color_map_contour   ') 
     *      color_map_contour=c
	 if(colors(i)(1:20).eq.'color_map_grid      ')
     *      color_map_grid=c
	 if(colors(i)(1:20).eq.'color_label_grid    ')
     *      color_label_grid=c
	 if(colors(i)(1:20).eq.'color_symbol_key    ')
     *      color_symbol_key=c
	 if(colors(i)(1:20).eq.'color_prompt        ')
     *      color_prompt=c
	 if(colors(i)(1:20).eq.'color_section       ') color_section=c
	 if(colors(i)(1:20).eq.'color_bval_np       ') color_bval_np=c
	 if(colors(i)(1:20).eq.'color_bval_ac       ') color_bval_ac=c
	 if(colors(i)(1:20).eq.'color_bval_line     ') color_bval_line=c
	 if(colors(i)(1:20).eq.'color_box           ') color_box=c
	 if(colors(i)(1:20).eq.'color_box_letter    ')color_box_letter=c
	 if(colors(i)(1:20).eq.'color_back          ') color_back=c
	 if(colors(i)(1:20).eq.'color_zoom          ') color_zoom=c
	 if(colors(i)(1:20).eq.'color_foc_dilat     ') color_foc_dilat=c
	 if(colors(i)(1:20).eq.'color_foc_comp      ') color_foc_comp=c
	 if(colors(i)(1:20).eq.'color_foc_p         ')color_foc_p=c
	 if(colors(i)(1:20).eq.'color_foc_t         ') color_foc_t=c
	 if(colors(i)(1:20).eq.'color_foc_plane     ') color_foc_plane=c

      enddo
c
c   close file
c
      call sei close( close$, in, code ) ! Close (default stop on error).
      return
      end
c
c   
      subroutine set_background(color)
      include 'seiplot.inc'
c
c  set the background color to color
c
      integer color,color_to_set
      logical pc,sun,linux
      call computer_type(sun,pc,linux)
      color_to_set=color
c
c   if no colors are used, make sure background is not a color
c   and set to white if not black or white has been specified.
c
      if(color_screen.eq.0.and.
     *(color_back.ne.xblack.or.color_back.ne.xwhite))
     *color_to_set=xwhite
      if(pc) call set_back_pc(color_to_set)
      if(sun.or.linux) then
         call setbackx(color_to_set)
	 call xclear

      endif
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
      subroutine input_box(nbox,on,nx,xsize,ysize,text,ntext,
     *                     x0,y0,title,last_char,opendisp,
     *                     option)
c
c   displays a series of boxes, by clicking with the mouse
c   the value canbe set or unset show by inverse video. 
c
CJAB(BGS)Jan95   : Treat "ALL" box correctly; allocate an input colour
C                  when not set and allocate character before returning to
C                  caller (not after) and note that in limit the "on" array
C                  is "nbox" long and cannot accomodate the "ALL" and "OK"
C                  situations. Change code to reflect this..
c mar 29, 95 by jh: add option NONE
C nov 6   96      : add more dimentions to number of boxes
C
      implicit none
      include 'seiplot.inc'
      include 'seidim.inc'
      integer nbox,cbox  ! number of boxes
      integer on(*)      ! 0: box not selected, 1:box selected
      integer nx         ! --------------- in x and y directions
      real xsize,ysize   ! box size
      character*80 text(*)   ! text in box
      integer  ntext         ! number of characters to plot
      real x0,y0             ! upper left hand cornor
      character*120 title     ! title on top of plot
      character*1  last_char ! last character clicked
      integer opendisp       ! 0: do not open display, 1:open display
      real x1(max_trace+5),y1(max_trace+5),
     *x2(max_trace+5),y2(max_trace+5) ! cornors in squares of boxes
      real x,y,del
      integer ix,iy,i,k,ib,ich,l
      integer color_in       ! color when routine called
      integer color_fr       ! color of frame
      integer hc_old         ! hard copy type
      integer plotoption_old ! save plot option
      integer option         ! 0: default with NONE, ALL and OK
                             ! 1: only single choice, not NONE, ALL and OK
c
      logical  b_all,        !JAB(BGS)Jan95 All set on?.
     &         b_none        !JAB(BGS)Mar95 All set off?.
c
c    Initialise...
c    =============
c
      color_in=color_current ! save current color
c
c   save hc setting, since hc must be turned off in this routine
c
      hc_old=hctype
      plotoption_old=plotoption
      hctype=0
      plotoption=0
      if (option.gt.1.or.option.lt.0) option=0
c
c   open display
c
      if(opendisp.eq.1) call open_display
      x=x0
      y=y0
      del=13      ! distance between boxes
c
c   title
c 
      call xset_color(color_title)
      call xchars(title(1:80),80,x0,y0+20+ysize)
      call xchars(title(81:120),40,x0+700.0,y0+20+ysize)
c
c   text in last boxes
c
      text(nbox+3) = 'NONE'
      text(nbox+2) = 'OK'      
      text(nbox+1) = 'ALL'
c
c   Determine if all or no boxes are turned on...
c
      b_all = .true.                       ! Assume that all are on.
      b_none= .true.                       ! And off.
      do i = 1, nbox                       ! Loop boxes.
      b_all = b_all .and.                  ! Still all on?.
     &        on(i) .eq.  1                !
      b_none= b_none.and.                  ! Still all off?.
     &        on(i) .eq.  0                !
      end do                               !
c
c   indicate that color changes come from this routine, since
c   black and white must be togled when changing selection
c
	 from_input_box=1
c
c   draw, the frame must always contrast the background, so it is either
c   black or white
c
	 color_fr=xblack
	 if(color_screen.eq.0) then    ! no color screen
	    if(color_back.eq.xblack) color_fr=xwhite
	    if(color_back.eq.xwhite) color_fr=xblack
	 endif
c
c
 1    continue             ! from selection of z-channels
c
c   draw boxes...
c
      x=x0
      y=y0
      ix=1
c
c if option 1 dont plot boxes for ALL, NONE and OK
c
      cbox=nbox+3
      if (option.eq.1) cbox=nbox
c      do ib=1,nbox+3
      do ib=1,cbox
c
c   cornors in box
c
	 x1(ib)=x
	 y1(ib)=y
	 x2(ib)=x+xsize
	 y2(ib)=y+ysize
c
	 call xset_color(color_fr)
	 call xmovabs(x1(ib)-3,y1(ib)-3)
	 call xdrwabs(x2(ib)+3,y1(ib)-3)
	 call xdrwabs(x2(ib)+3,y2(ib)+3)
	 call xdrwabs(x1(ib)-3,y2(ib)+3)
	 call xdrwabs(x1(ib)-3,y1(ib)-3)
c
c   -------------------------------
c   Allocate and set the colours...
c   -------------------------------
c   Display boxes on or off...
c   --------------------------
c   On...
c
      if( ib .le. nbox ) then                       ! A valid box.
	 if( on(ib) .eq. 1 ) then                   ! Is on.
	 call xset_color(color_box_letter)          ! Interior fill colour.
	 call fillbox(x1(ib),y1(ib),x2(ib),y2(ib)) ! & fill.
	 call xset_color(color_box)                 ! Text colour.
	 call xchars(text(ib),ntext,x1(ib)+5.0,     ! Write text.
     &                              y2(ib)-14.0)    !
c
c   Off...
c
	 else                                       ! Otherwise off.
	 call xset_color(color_box)                 ! Interior fill colour.
	 call fillbox(x1(ib),y1(ib),x2(ib),y2(ib)) ! & fill.
	 call xset_color(color_box_letter)          ! Text colour.
	 call xchars(text(ib),ntext,x1(ib)+5.0,     ! Write text.
     &                              y2(ib)-15.0)    !
	 end if                                     !
c
c   The "OK" box is off...
c   ----------------------
c
      else if( ib .eq. nbox+2 ) then                     ! Ok box is off.      
      call xset_color(color_box)                         ! Interior fill colour.
      call fillbox(x1(ib),y1(ib),x2(ib),y2(ib))         ! & fill.
      call xset_color(color_box_letter)                  ! Text colour.
      call xchars(text(ib),ntext,x1(ib)+5.0,y2(ib)-15.0) ! & write text.
c
c   The "None" box is on...
c   -----------------------
c
      else if( ib .eq. nbox+3 .and. b_none ) then        ! None box on.
      call xset_color(color_box_letter)                  ! Interior fill colour.
      call fillbox(x1(ib),y1(ib),x2(ib),y2(ib))         ! & fill.
      call xset_color(color_box)                         ! Text colour.
      call xchars(text(ib),ntext,x1(ib)+5.0,y2(ib)-15.0) ! & write text.
c
c   The "None" box is off...
c   ------------------------
c
      else if( ib .eq. nbox+3 .and. (.not.b_none) ) then ! None box off.
      call xset_color(color_box)                         ! Interior fill colour.
      call fillbox(x1(ib),y1(ib),x2(ib),y2(ib))         ! & fill.
      call xset_color(color_box_letter)                  ! Text colour.
      call xchars(text(ib),ntext,x1(ib)+5.0,y2(ib)-15.0) ! & write text.
c
c   The "ALL" box is on...
c   ----------------------
c
      else if( b_all ) then                              ! All are on.
      call xset_color(color_box_letter)                  ! Interior fill colour.
      call fillbox(x1(ib),y1(ib),x2(ib),y2(ib))         ! & fill.
      call xset_color(color_box)                         ! Text colour.
      call xchars(text(ib),ntext,x1(ib)+5.0,y2(ib)-15.0) ! & write text.
c
c   The "ALL" box is off...
c   -----------------------
c
      else                                               ! Otherwise off.
      call xset_color(color_box)                         ! Interior fill colour.
      call fillbox(x1(ib),y1(ib),x2(ib),y2(ib))         ! & fill.
      call xset_color(color_box_letter)                  ! Text colour.
      call xchars(text(ib),ntext,x1(ib)+5.0,y2(ib)-15.0) ! & write text.
      end if                                             !
c
c---------------------------------
c
c   check if box on other line
c
	 ix=ix+1
	 x=x+xsize+del
	 if(ix.gt.nx) then
	    ix=1
	    x=x0
	    y=y-ysize-del
	 endif
      enddo
c
c   get up cursor...
c   ================
c
 10   continue
      call xscursr(ich,x,y)
      last_char=char(ich)
c
c   Return...
c   ---------
c
      if( last_char.eq.'q'  .or.
     &    last_char.eq.'Q'  .or.
     &    last_char.eq.'f'  .or.
     &    last_char.eq.'F') goto 99  ! return

c
c   check if a click in a box
c
c      do i=1,nbox+3
      do i=1,cbox
	 if(x.gt.x1(i).and.x.lt.x2(i).and.y.gt.y1(i).and.y.lt.y2(i))
     *   then                    
c
c   -----------------------------
c   Proceed on the box located...
c   -----------------------------
c   "OK" box selected...Exit...
c   ---------------------------
c
	    if( i .eq. nbox+2 ) then          ! Exit.
	    goto 99                           ! Return to caller.
c
c   "ALL" box selected...
c   ---------------------
c
	    else if( i .eq. nbox+1 ) then     ! select all
	    do k=1,nbox                       ! Loop boxes.
	      on(k)=1                         ! & turn on.
	      call xset_color(color_box_letter)
	      call fillbox(x1(k),y1(k),
     *                    x2(k),y2(k))
	      call xset_color(color_box)
	      call xchars(text(k),ntext,x1(k)+5.0,y2(k)-15.0)
	    enddo                          !
c           goto 99                        ! return to caller., comment out lo

c
c   "NONE" box selected...
c   ---------------------
c
            else if( i .eq. nbox+3 ) then     ! deselect all
            do k=1,nbox                       ! Loop boxes.
            on(k)=0                           ! & turn off.
            call xset_color(color_box)
            call fillbox(x1(k),y1(k),
     *                    x2(k),y2(k))
            call xset_color(color_box_letter)
            call xchars(text(k),ntext,x1(k)+5.0,y2(k)-15.0)
            enddo
c
c   check for last input box to be all Z, used in mulplt
c
c           elseif( i.eq.nbox) then
c
c   select all z-cahnnels (if used in mulplt)
c
c              if(text(i)(1:5).eq.'All Z') then
c                 do l=1,nbox
c                   if(text(l)(9:9).eq.'Z') on(l)=1
c                 enddo
c                 goto 1
c              endif 
c
c   Turn an "off" box "on"...
c   -------------------------
c
	    else if( on(i) .eq. 0 ) then      ! Turn on.
	    on(i)=1
	    call xset_color(color_box_letter)
	    call fillbox(x1(i),y1(i),
     *                    x2(i),y2(i))
	    call xset_color(color_box)
	    call xchars(text(i),ntext,x1(i)+5.0,y2(i)-15.0)

c 
c return if option is 1
c
            if (option.eq.1) goto 99
c
c    Turn an "on" box "off"...
c    -------------------------
c
	    else                              !
	    on(i)=0
	    call xset_color(color_box)
	    call fillbox(x1(i),y1(i),
     *                    x2(i),y2(i))
	    call xset_color(color_box_letter)
	    call xchars(text(i),ntext,x1(i)+5.0,y2(i)-15.0)
	    endif


c
c   check for last input box to be all Z, used in mulplt
c
           if( i.eq.nbox) then
c
c   select all z-cahnnels (if used in mulplt)
c
              if(text(i)(1:5).eq.'All Z') then
                 do l=1,nbox
c                   if(text(l)(9:9).eq.'Z') on(l)=1
c lot 26/5/2005
                   if(text(l)(9:9).eq.'Z') then
                     on(l)=1
                   else
                     on(l)=0
                   endif  
                 enddo
                 goto 1
              endif 
            endif
c
c    Check if all are on...
c    ----------------------
c
	 b_all = .true.                    ! Assume that all are on.
         b_none= .true.                    ! And all are off.
	 do iy = 1, nbox                   ! Loop boxes.
	 b_all = b_all .and.               ! Still all on?.
     &           on(iy) .eq.  1            !
         b_none= b_none.and.               ! Still all off?.
     &           on(iy) .eq.  0            !
	 end do                            !
c
c   The "ALL" box is on...
c   ----------------------
c
	 iy = nbox + 1                                 ! Point to "ALL" box.
	    if( b_all ) then                           ! All are on.
	    call xset_color(color_box_letter)          ! Interior fill colour.
	    call fillbox(x1(iy),y1(iy),x2(iy),y2(iy)) ! & fill.
	    call xset_color(color_box)                 ! Text colour.
	    call xchars(text(iy),ntext,x1(iy)+5.0,y2(iy)-15.0) ! & write text.
c
c   The "ALL" box is off...
c   -----------------------
c
	    else                                       ! Otherwise off.
	    call xset_color(color_box)                 ! Interior fill colour.
	    call fillbox(x1(iy),y1(iy),x2(iy),y2(iy)) ! & fill.
	    call xset_color(color_box_letter)          ! Text colour.
	    call xchars(text(iy),ntext,x1(iy)+5.0,y2(iy)-15.0) ! & write text.
	    end if                                             !
c
c   The "NONE" box is on...
c   -----------------------
c
         iy = nbox + 3                                 ! Point to "NONE" box.
            if( b_none ) then                          ! All are off.
            call xset_color(color_box_letter)          ! Interior fill colour.
            call fillbox(x1(iy),y1(iy),x2(iy),y2(iy)) ! & fill.
            call xset_color(color_box)                 ! Text colour.
            call xchars(text(iy),ntext,x1(iy)+5.0,y2(iy)-15.0) ! & write text.
c
c   The "NONE" box is off...
c   -----------------------
c
            else                                       ! Otherwise off.
            call xset_color(color_box)                 ! Interior fill colour.
            call fillbox(x1(iy),y1(iy),x2(iy),y2(iy)) ! & fill.
            call xset_color(color_box_letter)          ! Text colour.
            call xchars(text(iy),ntext,x1(iy)+5.0,y2(iy)-15.0) ! & write text.
            end if                                             !
	 endif                             !
      enddo
c
c   back for next click
c
      goto 10
c
99    continue
c
      from_input_box=0
c
c   reset color and hc type
c
      if( color_in .eq. 0 ) then                ! No colour installed.
      call xset_color(color_def)                ! Put in default.
      else                                      ! Otherwise.
      call xset_color(color_in)                 ! Put back colour.
      end if                                    !
c
      hctype=hc_old
      plotoption=plotoption_old
c
c   close display if only hc plotting 
c
      if(plotoption.eq.3) call clear_to_alpha
      return
      end

      subroutine xmessage(message,nlines,nchar,x,y)
c
c  put nlines messages message on the screen, all nchar long,
c  starting in lower left hand cornor x,y
c
      implicit none
      include 'seiplot.inc'
      character*80 message(*)
      real x,y
      integer nlines,nchar
      real yy,ydel         ! y coordinate for line and distance between lines
      real xdel            ! distance between chars
      real xlength,ylength ! size of box
      integer i
c
c   calculate are to blank out
c
c
c   indicate that set color must follow instruction irrespective of
c   background
c
      from_input_box=1
      xdel=13.0
      ydel=20.0
c
      xlength=nchar*xdel
      ylength=nlines*ydel
c
c   blank out area, set background to white
c
      call xset_color(xwhite)
      call fillbox(x,y,x+xlength,y+ylength)
c
c   write text in black
c
      yy=y+ylength-12.0
      call xset_color(xblack)
      do i=1,nlines
	 call tchars(message(i),nchar,x+5.0,yy)
	 yy=yy-ydel
      enddo
      from_input_box=0
c
c   set color back to what it was
c
c     call xset_color(color_current)
      return
      end
c
      INTEGER FUNCTION DRAW_SYMBOL( SYM, X, Y, SIZE )
CSTART*************************************************************************
C                                                                             *
C                         BGS/GSRG Programming Unit                           *
C                         =========================                           *
C                                                                             *
C    System           : SEISAN                                                *
C    Module Name      : DRAW_SYMBOL                                           *
C    Purpose          : Primitive to draw a symbol                            *
C    Arguments -input : SYM        (I) Drawing instruction function index     *
C                                      add FILL$ to infill open symbols       *
C                     : SIZE       (R) Size of symbol in Tektronix units      *
C                     : X, Y       (R) Location of centre of symbol box in    *
C                                      Tektronix units.                       *
C             -output : function value is dummy condition                     *
C                                                                             *
C    Note             : Based on a routine of the same name for a development *
C                       GKS version of EQANAL (BGS Edinburgh - same author)   *
C    Author           : J. A. Bolton                                          *
C    Date             : 26 January 1995                                       *
C    Version          : V01                                                   *
C                                                                             *
CEND***************************************************************************
C
C    Arguments....
C    =============
C
      INTEGER     SYM                            ! Function to perform.
      REAL        SIZE,                          ! Size of symbol.
     &            X, Y                           ! & location of box centre. 
C
C    Local variables...
C    ==================
C
      INTEGER     CODE,                          ! local condition.
     &            IY,                            ! Very local.
     &            RADII,                         ! # radii.
     &            VERTEX,                        ! # vertices.
     &            RFRACT,                        ! Internal angle fraction
     &            VFRACT                         ! & for vertices.
     &           ,SYMBOL                         ! Primitive symbol.
      REAL        SCALE,                         ! Scaling of chord set.
     &            ANGLE,                         ! internal chord angle.
     &            DISPLACE,                      ! Initial angle displacme
     &            THETA                          ! Working angle.
      INTEGER     SYMBOL_C                       ! Length of symbol instruction.
      PARAMETER  (SYMBOL_C = 20)                 ! Larger than required!!
      CHARACTER   CHR_SYMBOL *(SYMBOL_C)         ! Symbol length
      LOGICAL     B_RADII,                       ! Draw a radius?.
     &            B_CHORD,                       ! or chord.?.
     &            B_FILL                         ! & fill it?.
C
C    Closed Polylines used for BASIC symbols...
C    ------------------------------------------
C
      INTEGER     POLY_N                         ! # points.
      PARAMETER  (POLY_N = 1000)                 ! & value.
      REAL        XX(POLY_N), YY(POLY_N)         ! & arrays.
C
C    Angular conversion...
C    =====================
C
      REAL       PI$,                           ! Radians in semi-circle.
     &           DEG_TO_RAD                     ! Degrees to radians.
      PARAMETER (PI$        = 3.141592654)      ! & values.
      PARAMETER (DEG_TO_RAD = PI$ / 180.0)      ! Degrees to radians.
C
C    System variables...(here since "symbol.inc" contains data)...
C    =============================================================
C
      INCLUDE     'libsei.inc'
      INCLUDE     'seiplot.inc'
      INCLUDE     'symbol.inc'
C
C    =============
C    Initialise...
C    =============
C
      CODE = E_OK$                             ! Initial condition.
      SYMBOL = MOD(SYM,FILL$)                  ! Primitive.
      B_FILL = SYM .GE. FILL$                  ! Infilled?.
C
C    Decode the instructions...
C    ==========================
C
      CHR_SYMBOL = CHR_SYMBOL$( SYMBOL )       ! Get symbol.
      B_RADII = CHR_SYMBOL(1:1) .EQ. 'T'       ! Radii required?.
      B_CHORD = CHR_SYMBOL(7:7) .EQ. 'T'       ! Draw chords?.
      B_FILL  = B_CHORD .AND. B_FILL           ! & area fill?.
C
      READ(CHR_SYMBOL(2:2),  '(I1)') RADII     ! # radii.
      READ(CHR_SYMBOL(3:4),  '(I2)') RFRACT    ! % displacement.
      READ(CHR_SYMBOL(5:6),  '(I2)') IY        ! Change in scale of radii.
      SCALE = 1.0 / (1.0 + FLOAT(IY)*.01)      ! Scale chord so radii fits box.
      READ(CHR_SYMBOL(8:10), '(I3)') VERTEX    ! # vertices.
      READ(CHR_SYMBOL(11:13),'(I3)') VFRACT    ! Vertex % displacment.
C
C    =============
C    Draw radii...
C    =============
C
      IF( B_RADII ) THEN                         ! Radii required!
      ANGLE = (360.0/RADII) * DEG_TO_RAD         ! Internal angle.
      DISPLACE = ANGLE * RFRACT*0.01             ! Displacement angle.
C
      THETA = DISPLACE                           ! initialise angle.
      DO 1000 IY = 1, RADII                      ! Loop radii.
      THETA = THETA + ANGLE                      ! vertex angle.
      XX(2) = X + SIZE*0.5*COS(THETA)            ! Other end.
      YY(2) = Y + SIZE*0.5*SIN(THETA)            !
C
      CALL XMOVABS(X,    Y)                      ! Move to 1st point.
      CALL XDRWABS(XX(2),YY(2))                  ! & draw to next.
1000  CONTINUE                                   !
      END IF                                     !
C
C    ==============
C    Draw chords...
C    ==============
C    Set up PostScript filling...
C    ----------------------------
C 
      IF( B_CHORD ) THEN                         ! Chords required.!
         if( b_fill             .and.
     &       plotoption .gt. 0  .and.
     &       hctype     .eq. 1 )
     &   write(plotunit,*)' stroke newpath'
c
      ANGLE = (360.0/VERTEX) * DEG_TO_RAD        ! Internal angle.
      DISPLACE = ANGLE * VFRACT*0.01             ! Displacement angle.
      VERTEX = VERTEX + 1                        ! Ensure polygon closure.
C
      THETA = DISPLACE                           ! initialise angle.
      DO 1200 IY = 1, VERTEX                     ! Loop vertices.
      THETA = THETA + ANGLE                      ! vertex angle.
      XX(IY) = X                                 ! X location is offset.
     &       + SIZE*0.5*SCALE*COS(THETA)         ! + scaled radius vector.
      YY(IY) = Y                                 ! Ditto y location.
     &       + SIZE*0.5*SCALE*SIN(THETA)         !
C
C    Draw outline...
C
	 IF( IY .EQ. 1 ) THEN                    ! Move to 1st point.
	 CALL XMOVABS(XX(1),YY(1))               !
	 ELSE                                    ! Otherwise displace.
	 CALL XDRWABS(XX(IY),YY(IY))             !
	 END IF                                  !
1200  CONTINUE                                   !
      CALL XDRWABS(XX(1),YY(1))                  ! & draw to 1st point.
C
C    Fill the polygon...
C    -------------------
C
	 IF( B_FILL ) THEN                       ! Area fill.
         if( plotoption .gt. 0  .and.            ! PostScript fill completion.
     &       hctype     .eq. 1 )                 ! Ditto.
     &   write(plotunit,*)' closepath fill'      ! Et ditto.
c
	 CONTINUE                                ! X fill not installed.
	 END IF                                  !
      END IF                                     !
C
C    ===================
C    Return to caller...
C    ===================
C
9999  CALL XMOVABS( X, Y )                  ! Move back to centre of symbol.
      DRAW_SYMBOL = CODE
      RETURN
       END

	  
c**********************************************************
  
c**********************************************************


	subroutine oneline(question,nq,answer,na,x,y)

c

c   Puts the question with nq characters at position x,y on the screen,

c   reads the answer answer with a maximum of na characters. The whole

c   string has a frame. The answer is terminated by a CR. 

c 

c      implicit none

      

      character*80 question           ! question

      integer nq

      character*80 answer

      integer na

      real  x,y               

      include 'seiplot.inc'           ! seisan parameters

      integer ix,iy                 ! for plotting

      character*1  key                ! character form one key press

      integer j,nchar

      integer ia

      real ix1,iy1,ix2,iy2



 

c      type (xycoord) xy

	

	integer flag,kchar,flagkey,flagMouse

        real xmouse,ymouse

 	common /mousekey/flag,xmouse,ymouse,kchar,flagkey,flagMouse

	real xfirst,yfirst,xscale,yscale,ymin,ymax,xmin,xmax

	common /xy_plot_common/xfirst,yfirst,xscale, 

     * yscale,ymin,ymax,xmin,xmax

	character*80 text

c

      ix=int(x) 

      iy=int(y) 

   	nchar = na

c

c   blank variables

c

      key=' '

      do i=1,na

         text(i:i)=' '

      enddo

c

c   make rectangel

c

      ix1=ix

      iy1=iy-3

      ix2=ix+(nq+na)*11+42

      iy2=iy+25

	call clearwindow(int(ix1),int(iy1),int(ix2),int(iy2))
      call DrawBox(int(ix1),int(iy1),int(ix2),int(iy2))

c

      call xset_color(6)



c

	call xchars(question,nq,real(ix+5),real(iy+7))



c   move to end of question

c

      ix=ix+nq*11+30

	ia=0



c    clear answer



c      j=1 

c	do while ( (answer(j:j) .ne. ' ') .and. (answer(j:j) .ne. char(0)) 

c     * .and. (j .le. na))

c	 j=j+1

c	enddo

	do i=1,na

	   answer(i:i) = ' '

	enddo

c	call xchars(text,na,real(ix+5),real(iy+7)) 

cc	do j=1,na

cc	 text(1:1) = answer(j:j)

cc	 if (text(1:1) .ne. ' ') then

cc	 call xchars(text,1,real(ix),real(iy+7)) 

cc	 ix=ix+10

cc	 ia = ia + 1

cc	 endif

cc	enddo 

  

c

c   go in a loop until a CR is hit 

c

        flagMouse = 0

	do while((ichar(key).ne.13) )

c	     dummy =setcolor(2)   ! background for text, blank

cc	     dummy =setcolor(color_box)   ! background for text, blank

c		 dummy=setcolor(4)

cc         dummy=setcolor(color_box_letter)

 50      continue

	   
 	   call DrawBox(ix,iy+4,ix+6,iy+21) ! draw cursor

	   
c

c	

         call xscursr(j,xmouse,ymouse)

         kchar = j

         if (j .eq.32)  flagMouse = 1 !global flag defined in winplot.for

         if (j .eq. 13) flagkey = 1   !activate key or mouse event
	   
         key = char(j)

cc		 call moveto(ix,iy,xy)

c

c   check for BS or DEL in which case cursor is moved back one char and the

c   character already put out is blanked out

c

c         write(1,'(1X,I5,1x,A20)') IA,ANSWER(1:20)

		 if((ichar(key).eq.8) .or. (ichar(key).eq.127)) then     

	      if(ia.eq.0) goto 50

		    ix=ix-11

c			dummy=setcolor(2)    ! set color for blanking out

cc			dummy=setcolor(color_box)    ! set color for blanking out

                    call clearwindow(ix,iy,ix+21,iy+22)

cc		    dummy=setcolor(color_box_letter)    ! color back for characters

cc			call moveto(ix,iy,xy)

            if(ia.gt.0) answer(ia:ia)=' '   ! blank out deleted char

               ia=ia-1

cc               na=ia

			goto 50

		 endif

c

c   plot out the character entered

c

	if((ia.lt.nchar) .and. (ichar(key).ne.13)) then

	text(1:1) = key

 	call clearwindow(ix,iy,ix+11,iy+22) 

	call xchars(text,1,real(ix),real(iy+7))

         ix=ix+11

cc		 call outgtext(key)

	  ia=ia+1

         answer(ia:ia)=key

cc        na=ia

	endif

	  enddo

c

 99   continue

c

c   reset color

c

c	  dummy=setcolor(2)

c

	ix = int(x)

	iy = int(y)

        call clearwindow(ix,iy-6,ix+(na+nq)*11+45,iy+28)

	flag = 0

cc        na = ia

      return

      end

  
     

      program hspec8 
c
c  may  999 by jh -----------  verison 7.0 check ---------------
c                 include routines numarg and mchdep70
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME VI                                                      c
c                                                                     c
c      PROGRAM: HSPEC8                                                c
c                                                                     c
c      COPYRIGHT 1985                                                 c
c      R. B. Herrmann                                                 c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      parameter(LER=0, LIN=5, LOT=6)
      parameter(NL=100)
      common/source/depth,lmax,dph  ,vamin,vamax,vbmin,vbmax,hvert
      common/damp/alpha 
      common/model/d(NL),a(NL),b(NL),rho(NL),mmax,qa(NL),qb(NL) 
      common/jout/jsrc(10) , jbdry
      character*50 name2 
      character*3 istat2
      dimension ffreq(8) 


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
c
c-----
c     call machine dependent initialization
c-----
      call mchdep()
   59 format(' ',a) 
   60 format(a) 
      read(LIN,18)name2
      read(LIN,18)istat2
      read(LIN,19)ierr,ifreq
   18 format(a)
   19 format(2i5)
      read(LIN,20) alpha,depth,fl,fu,dt,n,n1,n2,df,nyq2 ,mmax
   20 format(5e15.7/3i10,e15.7,i10,i10)
      read(LIN,21)jsrc , jbdry
   21 format(11i5)
      read(LIN,22)(d(i),a(i),b(i),rho(i),qa(i),qb(i),i=1,mmax)
   22 format(6e11.4)
      read(LIN,23)lmax,dph,vamin,vamax,vbmin,vbmax,hvert
   23 format(i10,6e11.4)
      read(LIN,24)xleng, xfac
   24 format(2e15.7)
c-----
      open(unit=2,file=name2,status=istat2,access='sequential', 
     1 form='unformatted') 
      rewind 2 
      if(ierr.eq.0)write(LOT,*)' file exists and is complete'
      if(ierr.eq.0)goto 9999
      df = 1./(n*dt) 
      nyq = nyq2/2
      write(LOT,2)  fl,fu,df,n1,n2,depth,n 
    2 format(1h ,4hfl =,f10.5,5x,4hfu =,f10.5,5x,4hdf =,f10.5,/ 
     1       5x,4hn1 =,i4,5x,4hn2 =,i4,5x,7hdepth =,f10.2,4h n =,i5) 
      write(LOT,5)alpha,dt 
    5 format(1h ,7halpha =,f10.5,5x,4hdt =,f10.3) 
      write(LOT,4) 
    4 format(1h ,39hfrequencies for which response computed     ) 
      rewind 2 
      if(ierr .lt. 4)then
         write(2) alpha,depth,fl,fu,dt,n,n1,n2,df,nyq2 
         write(2)jsrc 
         write(2)d,a,b,rho,mmax,qa,qb 
      else
         read(2)alpha,depth,fl,fu,dt,n,n1,n2,df,nyq2
         read(2)jsrc
         read(2)d,a,b,rho,mmax,qa,qb
         call skip(n1,ifreq,jsrc)
      endif
      ilow=mod(n1,8) 
       if(ilow.eq.0)ilow=8 
      iup=mod(n2,8) 
      if(iup.eq.0)iup=8 
      do 101 i=1,8 
  101 ffreq(i)=-1.0 
      n11 = n1
      if(ifreq.gt.n1)n11 = ifreq + 1
      do 100 i = n11,n2 
      freq=(i-1)*df 
      if(freq.lt.0.001) freq = 0.001 
      call excit(freq,xleng,xfac) 
      index=mod(i,8) 
      if(index.eq.0)index=8 
      ffreq(index)=freq 
      if (index.eq.8) then 
                write(LOT,3)ffreq 
                do 102 ii=1,8 
  102   ffreq(ii)=-1. 
        endif 
    3 format(1h ,8f10.5) 
  100 continue 
      write(LOT,3)ffreq 
 9999 continue
      close(2) 
      stop 
      end 
     
      subroutine aten(omega,qa,qb,xka,xkb,alpha,a,b,atna,atnb)
       real*4 qa,qb,alpha,a,b
      double complex omega,at,atna,atnb,xka,xkb
      real*8 pi, om1, oml, fac
c     reference frequency is 1.0 hz
      om1=6.2831853d+00
c     low frequency cutoff is 0.01 hz
      oml=0.062831853d+00
      pi=3.1415927d+00
      at=dcmplx(0.0d+00,0.0d+00)
      if(zabs(omega).gt.oml) at=zlog(omega/om1)/pi
      if(zabs(omega).gt.oml) go to 40
      fac=dsqrt(oml*oml + dble(alpha*alpha))/oml
      at=zlog(dcmplx(dble(oml),-dble(alpha))/(om1*fac))/pi
   40 continue
      atna=dcmplx(1.0d+00,0.0d+00)
      atnb=dcmplx(1.0d+00,0.0d+00)
      if(qa.gt.0.0) atna=(1.+dble(qa)*at+dcmplx(0.0d+00,dble(qa/2.)))
      if(qb.gt.0.0) atnb=(1.+dble(qb)*at+dcmplx(0.0d+00,dble(qb/2.)))
      xka=omega/(dble(a)*atna)
      xkb=omega/(dble(b)*atnb)
      return
      end
     
      subroutine cmult(e,ca,exa)
      double complex ca(5,5)
      real*8 exa
      real *8 xnorm
      double complex e(5)
      double complex c, ee(5)
      do 1350 i=1,5
	c = dcmplx(0.0d+00,0.0d+00)
      do 1349 j=1,5
      c=c+ e(j) * ca(j,i)
 1349 continue
      ee(i)=c
 1350 continue
      call normc(ee,exa,xnorm)
      do 1351 i=1,5
            e(i) = ee(i)*xnorm
 1351 continue
      return
      end
     
      subroutine dmult(da,aa)
      double complex aa(4,4)
      double complex sumd,ea(4,4),da(4,4)
      do 1360 i=1,4
      	do 1361 j=1,4
      		sumd = dcmplx(0.0d+00,0.0d+00)
      		do 1362 jj=1,4
      			sumd=sumd+da(i,jj) * aa(jj,j)
 1362 		continue
      		ea(i,j)=sumd
 1361 	continue
 1360 continue
      do 1363 j=1,4
      do 1364 i=1,4
            da(i,j)=ea(i,j)
 1364 continue
 1363 continue
      return
      end
     
      subroutine dnka(ca,wvno2,gam,rho)
      double complex gam,ca,cpcq,cpy,cpz,cqw,cqx,xy,xz,wy,wz,gam2,
     1 gamm1,gamm2,a0c,xz2,wy2,temp
      common/ ovrflw / a0,cpcq,cpy,cpz,cqw,cqx,xy,xz,wy,wz
      real *8 a0
      double complex wvno2
	double complex cqww2, cqxw2, g1wy2, gxz2, g2wy2, g2xz2
	double complex gg1, a0cgg1
      dimension ca(5,5)
      double complex zrho, zrho2
      zrho = dcmplx(dble(rho),0.0d+00)
      zrho2= dcmplx(dble(rho*rho),0.0d+00)
      gam2  = gam*gam
      gamm1 = gam-1.
      gamm2 = gamm1*gamm1
	cqww2 = cqw * wvno2
	cqxw2 = cqx / wvno2
	gg1 = gam*gamm1
      a0c  = dcmplx(2.0d+00,0.0d+00)*(dcmplx(a0,0.0d+00)-cpcq)
      xz2  = xz/wvno2
	gxz2 = gam*xz2
	g2xz2 = gam2 * xz2
	a0cgg1 = a0c*(gam+gamm1)
      wy2  = wy*wvno2
	g2wy2 = gamm2 * wy2
	g1wy2 = gamm1 * wy2
	temp = wvno2*(a0c + wy2) + xz
      ca(1,5) = -temp/zrho2
	temp = dcmplx(0.5d+00,0.0d+00)*a0cgg1 + gxz2 + g1wy2
      ca(1,3) = -temp/zrho
	temp = a0c*gg1 + g2xz2 + g2wy2
      ca(3,3) = a0 + temp + temp
      ca(1,1) = cpcq-temp
      temp =dcmplx(0.5d+00,0.0d+00)*a0cgg1*gg1 + gam2*gxz2 + gamm2*g1wy2
      ca(3,1) = dcmplx(2.0d+00,0.0d+00)*temp*zrho
	temp = gamm2*(a0c*gam2 + g2wy2) + gam2*g2xz2
      ca(5,1) = -zrho2*temp/wvno2
	ca(1,4) = (-cqww2+cpz)/zrho
      ca(2,1) = (-gamm2*cqw + gam2*cpz/wvno2)*zrho
	ca(2,3) = -(gamm1*cqww2 - gam*cpz)/wvno2
      ca(1,2) = (-cqx + wvno2*cpy)/zrho
	ca(3,2) = wvno2*(gam*cqxw2 - gamm1*cpy)*dcmplx(2.0d+00,0.0d+00)
	ca(4,1) = (-gam2*cqxw2 + gamm2*cpy)*zrho
      ca(2,2) = cpcq
      ca(2,4) = -wz
      ca(4,2) = -xy
      ca(2,5)=ca(1,4)
      ca(5,5)=ca(1,1)
      ca(5,4)=ca(2,1)
      ca(5,3)=-ca(3,1)/(dcmplx(2.0d+00,00d+00)*wvno2)
      ca(5,2)=ca(4,1)
      ca(4,3)= -ca(3,2)/(dcmplx(2.0d+00,00d+00)*wvno2)
      ca(4,5)=ca(1,2)
      ca(4,4)=ca(2,2)
      ca(3,4)=-dcmplx(2.0d+00,00d+00)*wvno2*ca(2,3)
      ca(3,5)=-dcmplx(2.0d+00,00d+00)*wvno2*ca(1,3)
      return
      end
     
      subroutine excit(freq,xleng,xfac)
c-----
c     sample response for all wavenumbers at a given frequency
c     using Bouchon equal wavenumber sampling = dk
c     with offset of 0.218dk
c-----
      parameter(LER=0,LIN=5,LOT=6)
      parameter(NL=100)
      complex gg(10)
      common/source/depth,lmax,dph ,vamin,vamax,vbmin,vbmax,hvert
      common/model/d(NL),a(NL),b(NL),rho(NL),mmax,qa(NL),qb(NL)
      common/jout/jsrc(10) , jbdry
      common/damp/alpha
      double complex wvn,om
c-----
c     setup wavenumber sampling, choosing two large values to
c     control the low frequency asymptotic integration technique
c
c     we will permit a depth = 0, and change the sampling in this
c     case as a fraction of thickness of the first layer
c-----
      do 10 i=mmax-1,1,-1
            if(d(i).gt.0.0)deep=d(i)
   10 continue
      if(depth.lt. 0.1*deep)then
           dpth = 0.1*deep
      else
           dpth = depth
      endif
      omega=6.2831853*freq
      wvbm = omega/vbmin
      dk = 6.2831853/xleng
      wvmm = (5.0/dpth) + xfac*wvbm
      wvzmx = wvmm * depth
      nk = wvmm / dk
      mk=nk+2
      mk1=nk+1
      write(2)omega,mk
c-----output wavenumber in reverse order
c     also output first two wavenumbers to control
c     low frequency asymptotic integration
c-----to save space in sequential i/o buffer output stream
      call bufini(1,ierr)
      do 3998 ii=mk,1,-1
            if(ii.eq.mk)then
                  if(wvzmx.gt.5.0)then
                       wv = 6.0/dpth
                  else
                       wv = wvmm + 10.0*dk
                  endif
            elseif(ii.eq.mk1)then
                  if(wvzmx.gt.5.0)then
                       wv = 2.5/dpth
                  else
                       wv = wvmm + 5.0*dk
                  endif
            else
                  wv = (ii-1)*dk + 0.218*dk
            endif
            wvn=dcmplx(dble(wv),0.0d+00)
            om=dcmplx(dble(omega),-dble(alpha))
            call rshof(gg,om,wvn,jbdry)
            call bufwr(wv)
            do 3998 j=1,10
                  if(jsrc(j).eq.1)then
                  call bufwr(real(gg(j)))
                  call bufwr(aimag(gg(j)))
            endif
 3998             continue
      call buflsh
      return
      end
     
      subroutine hska(aa,w,x,y,z,cosp,cosq,wvno2,gam,gamm1,rho)
      double complex wvno2
      double complex aa(4,4),w,x,y,z,cosp,cosq,gam,gamm1
	double complex cpq, gcpq, zw2, gzw2, g1w, g1y, gx
      real*8 drho
        drho = dble(rho)
	cpq = cosp-cosq
	gcpq = gam*cpq
	zw2 = z/wvno2
	gzw2 = gam*zw2
	g1w = gamm1*w
	g1y = gamm1*y
	gx = gam*x
	aa(1,1) = gcpq + cosq
        aa(1,3) = -cpq/dcmplx(drho,0.0d+00)
	aa(1,2)=-g1w+gzw2
      aa(1,4)=(wvno2*w-z)/dcmplx(drho,0.0d+00)
	aa(2,1)= gx - wvno2*g1y
	aa(2,2) = -gcpq + cosp
      aa(2,3)=(-x+wvno2*y)/dcmplx(drho,0.0d+00)
      aa(2,4)= - wvno2*aa(1,3)
	aa(3,1)= dcmplx(drho,0.0d+00)*gamm1*gcpq
	aa(3,2)=dcmplx(drho,0.0d+00)*((-gamm1*g1w)+(gam*gzw2))
      aa(3,4)=-wvno2*aa(1,2)
      aa(3,3)=aa(2,2)
	aa(4,1)=dcmplx(drho,0.0d+00)*(((gam*gx)/wvno2) - (gamm1*g1y))
      aa(4,2)=-aa(3,1)/wvno2
      aa(4,3)=-aa(2,1)/wvno2
      aa(4,4)=aa(1,1)
      return
      end
     
      subroutine lmult(d11,d12,cosql,yl,zl,rho,b,atnb)
      double complex d11,d12,cosql,yl,zl,atnb,h,e1,e2
      h= dcmplx(dble(rho*b*b),0.0d+00)*atnb*atnb
      yl=yl/h
      zl=zl*h
      e1=d11
      e2=d12
      d11=e1*cosql + e2*zl
      d12=e1*yl + e2*cosql
      return
      end
     
      subroutine normc(e,ex,xnorm)
      real*8 ex
      real *8 test,testt,x,y,fac,xnorm
      double complex e(*)
      test = 0.0D+00
      testt = 0.0D+00
      do 2 i = 1,5
      if(dabs(dreal(e(i))).gt.testt) testt =dabs(dreal(e(i)))
      if(dabs(dimag(e(i))).gt.testt) testt =dabs(dimag(e(i)))
    2 continue
      if(testt.lt.1.0e-30)testt=1.0
      do 1 i =1,5
      x=dreal(e(i))/testt
      y=dimag(e(i))/testt
      fac = x*x + y*y
      if(test.lt.fac) test = fac
    1 continue
      test = testt*dsqrt(test)
      if(test.lt.1.0d-30) test=1.0
      xnorm = 1./test
      ex =-dlog(xnorm)
      return
      end
     
      subroutine rshof(gg,om,wvno,jbdry)
      parameter(NL=100)
      common/model/d(NL),a(NL),b(NL),rho(NL),mmax,qa(NL),qb(NL)
      common/source/depth,lmax,dph ,vamin,vamax,vbmin,vbmax,hvert
      common/damp/alpha
        double complex ggg(10)
      double complex wvno,wvno2,wvno3
      double complex cd(5),da(4,4),fr,y(4,2)
      complex gg(10)
      double complex om,fourpi,ka2,kb2
      double complex d11,d12,fl
      double complex s12,s21,s32,s14,s23,s34,s32e,s34e
      double complex atna,atnb
	double complex wv4pi
      real *8 fact,facx,exe,exl,exel,exll,elj
      fourpi=12.5663706d+00*om*om
      if(zabs(wvno).lt.1.0d-8) go to 100
	wv4pi = 2.0d+00 * wvno / fourpi
      wvno2=wvno*wvno
      wvno3 = wvno2*wvno
      call aten(om,qa(lmax),qb(lmax),ka2,kb2,alpha,a(lmax),b(lmax),
     1 atna,atnb)
      ka2=ka2*ka2
      kb2=kb2*kb2
c     for frequencies less than 0.02 hz, use haskell formulation
c     otherwise use the dunkin formulation
      ifreq=1
      call scoef(cd,da,fr,om,wvno,exe,exl,
     1 fl,d11,d12,exel,exll,ifreq,jbdry)
      do 50 j=1,2
      y(1,j)= cd(1)*da(2,j) + cd(2)*da(3,j) - wvno2*(cd(3)*da(4,j))
      y(2,j)=-cd(1)*da(1,j) + cd(3)*da(3,j) + cd(4)*da(4,j)
      y(3,j)=-cd(2)*da(1,j) - cd(3)*da(2,j) + cd(5)*da(4,j)
      y(4,j)= wvno2*(cd(3)*da(1,j)) - cd(4)*da(2,j) - cd(5)*da(3,j)
   50 continue
      s12=dcmplx(0.0d+00,0.0d+00)
      s14=-wv4pi
      s21=2.0d+00*kb2/(dble(rho(lmax))*fourpi)
      s23=s12
      s32=wv4pi*2.*ka2/dble(rho(lmax))
      s34=wv4pi*dble( (2.*b(lmax)/a(lmax))**2 - 3.)
      s32e=ka2*wv4pi/dble(rho(lmax))
      s34e=2.0d+00*wv4pi*(ka2/kb2)
      do 60 j=1,2
           ggg(j)=s32*y(2,j) + s34*y(4,j)
           ggg(j+2)=s21*y(1,j) + s23*y(3,j)
           ggg(j+4)=s12*y(2,j) + s14*y(4,j)
           ggg(j+6)=s32e*y(2,j)+s34e*y(4,j)
   60 continue
      fact = 0.0D+00
      elj=exe-exl
      if(elj.lt.55.) fact=dexp(-elj)
      do 70 j=1,8
   70 gg(j) = (-ggg(j) * fact/fr)
      facx = 1./(12.5663706*b(lmax)*b(lmax))
      gg(9) = 2.0d+00*d11/dble(rho(lmax))
      gg(10) = -2.0d+00*wvno*d12*atnb*atnb*dble(b(lmax)*b(lmax))
      elj=exll-exel
      fact = 0.0
      if(elj.gt.-40.) fact = dexp(elj)
      facx = fact*facx
      gg(9) =(gg(9)*facx) /(fl*(atnb*atnb))
      gg(10)=(gg(10)*facx)/(fl*(atnb*atnb))
      return
  100 continue
      do 101 i = 1,10
  101 gg(i) = cmplx(0.0,0.0)
      return
      end
     
      subroutine scoef(cd,da,fr,omega,wvno,exe,exl,
     1 fl,d11,d12,exel,exll,ifreq,jbdry)
      parameter(NL=100)
      common/model/d(NL),a(NL),b(NL),rho(NL),mmax,qa(NL),qb(NL)
      common/source/depth,lmax,dph ,vamin,vamax,vbmin,vbmax,hvert
      common/damp/alpha
      double complex omega,xka,xkb,ra,rb,gam,gamm1,p,q,w,x,y
      double complex cosq,z,cosp
      double complex  da,ca,aa
            dimension da(4,4),ca(5,5),aa(4,4)
      double complex   cd(5),e(5),fr
      double complex atna,atnb
      double complex d11,d12,e1,e2,fl
      double complex yl,zl,cosql
      real *8 exe,exl,exel,exll,ex,exa,exb
      double complex wvno,wvno2
c-----
c     initialize matrices
c-----
      exe=0.0
      exl=0.0
      do 2 i = 1,4
            do 3 j = 1,4
                  da(i,j)=dcmplx(0.0d+00,0.0d+00)
    3       continue
            da(i,i) = dcmplx(1.0d+00,0.0d+00)
    2 continue
      exel = 0.0
      exll = 0.0
c-----
c     set up halfspace conditions
c-----
      wvno2=wvno*wvno
      call aten(omega,qa(mmax),qb(mmax),xka,xkb,alpha,a(mmax),
     1 b(mmax),atna,atnb)
      ra=zsqrt(wvno2-xka*xka)
      rb=zsqrt(wvno2-xkb*xkb)
      gam = dble(b(mmax))*wvno/omega
      gam = gam * atnb
      gam = 2.0d+00 * (gam * gam)
      gamm1 = gam - dcmplx(1.0d+00,0.0d+00)
c-----
c     set up halfspace boundary conditions
c
c     jbdry = -1  RIGID
c           =  0  ELASTIC
c           = +1  FREE SURFACE
c
c-----
      if(jbdry.eq.0)then
            e(1)=dble(rho(mmax)*rho(mmax))*
     1                  (-gam*gam*ra*rb+wvno2*gamm1*gamm1)
            e(2)=-dble(rho(mmax))*(wvno2*ra)
            e(3)=dble(rho(mmax))*(-gam*ra*rb+wvno2*gamm1)
            e(4)=dble(rho(mmax))*(wvno2*rb)
            e(5)=wvno2*(wvno2-ra*rb)
            e1 = dble(rho(mmax))*rb
            e2 = dcmplx(1.0d+00,0.0d+00)
     1		/(dble(b(mmax)*b(mmax))*atnb*atnb)
      elseif(jbdry.lt.0)then
            e(1) = dcmplx(1.0d+00,0.0d+00)
            e(2) = dcmplx(0.0d+00,0.0d+00)
            e(3) = dcmplx(0.0d+00,0.0d+00)
            e(4) = dcmplx(0.0d+00,0.0d+00)
            e(5) = dcmplx(0.0d+00,0.0d+00)
            e1 = dcmplx(1.0d+00,0.0d+00)
            e2 = dcmplx(0.0d+00,0.0d+00)
      elseif(jbdry.gt.0)then
            e(1) = dcmplx(0.0d+00,0.0d+00)
            e(2) = dcmplx(0.0d+00,0.0d+00)
            e(3) = dcmplx(0.0d+00,0.0d+00)
            e(4) = dcmplx(0.0d+00,0.0d+00)
            e(5) = dcmplx(1.0d+00,0.0d+00)
            e1 = dcmplx(0.0d+00,0.0d+00)
            e2 = dcmplx(1.0d+00,0.0d+00)
      endif
      do 11 i=1,5
            cd(i)=e(i)
   11 continue
      d11=e1
      d12=e2
c-----
c     matrix multiplication from bottom layer upward
c-----
      mmm1 = mmax - 1
      do 1340 k = 1,mmm1
            m = mmax - k
            call aten(omega,qa(m),qb(m),xka,xkb,alpha,a(m),b(m),
     1       atna,atnb)
            gam=dble(b(m))*(wvno/omega)
            gam = gam * atnb
            gam = dcmplx(2.0d+00,0.0d+00)*gam*gam
            gamm1 = gam - dcmplx(1.0d+00,0.0d+00)
            ra=zsqrt(wvno2-xka*xka)
            rb=zsqrt(wvno2-xkb*xkb)
            p=ra*dble(d(m))
            q=rb*dble(d(m))
            dpth=d(m)
            call var(p,q,ra,rb,w,x,y,z,
     1            cosp,cosq,ex,exa,exb,yl,zl,cosql)
            call dnka(ca,wvno2,gam,rho(m))
            exe=exe+exa
            call cmult(e,ca,exa)
            exe=exe + exa
            exel = exel + exb
            call lmult(e1,e2,cosql,yl,zl,rho(m),b(m),atnb)
            l1=lmax+1
            if(l1.eq.m) then
                  do 1352 i=1,5
                        cd(i)=e(i)
 1352             continue
                  exl=exe
                  exll = exel
                  d11=e1
                  d12=e2
            endif
c-----
c     source layer contributions
c-----
            if(m.eq.lmax)then
                  dpth=dph
                  p=ra*dble(dpth)
                  q=rb*dble(dpth)
                  call var(p,q,ra,rb,w,x,y,z,
     1                  cosp,cosq,ex,exa,exb,yl,zl,cosql)
                  call dnka(ca,wvno2,gam,rho(lmax))
                  exl=exl+exa
                  call cmult(cd,ca,exa)
                  exl=exl+exa
                  call lmult(d11,d12,cosql,yl,zl,rho(lmax),b(lmax),atnb)
                  exll=exll+exb
                  dpth=d(lmax)-dph
                  p=ra*dble(dpth)
                  q=rb*dble(dpth)
                  call var(p,q,ra,rb,w,x,y,z,
     1                  cosp,cosq,ex,exa,exb,yl,zl,cosql)
                  call hska(aa,w,x,y,z,cosp,cosq,wvno2,gam,
     1                  gamm1,rho(lmax))
                  call dmult(da,aa)
                  exl=exl+ex
            endif
            if(m.lt.lmax) then
                  call hska(aa,w,x,y,z,cosp,cosq,wvno2,gam,gamm1,rho(m))
                  call dmult(da,aa)
                  exl=exl+ex
            endif
 1340 continue
      fl=e1
      fr=e(1)
      return
      end
     
      subroutine skip(n1,ifreq,jsrc)
      complex gg(10)
      dimension jsrc(10)
      do 1300 i=n1,ifreq
          read(2)omega,nk
      call bufini(0,ierr)
          do 1400 mk=1,nk
            call bufrd(wvno,ierr)
             do 1500 j=1,10
                 if(jsrc(j).eq.1)then
            call bufrd(xr,ierr)
            call bufrd(xi,ierr)
            gg(j)=cmplx(xr,xi)
      endif
 1500        continue
 1400     continue
 1300 continue
      return
      end
     
      subroutine var(p,q,ra,rb,w,x,y,z,cosp,cosq,ex,
     1exa,exl,yl,zl,cosql)
c     not modified for negative p,q
c     this assumes that real p and real q have same signs
      common/ovrflw/a0,cpcq,cpy,cpz,cqw,cqx,xy,xz,wy,wz
      double complex cpcq,cpy,cpz,cqw,cqx,xy,xz,wy,wz
      double complex p,q,ra,rb,w,x,y,z,cosp,cosq
      double complex yl,zl,cosql
      double complex eqp,eqm,epp,epm,sinp,sinq
      real *8 a0,pr,pi,qr,qi,fac,qmp,ex,exa,exl
      ex=0.0d+00
      exl = 0.0d+00
      a0=0.0d+00
      pr=real(p)
      pi=dimag(p)
      qr=real(q)
      qi=dimag(q)
      epp=dcmplx(dcos(pi),dsin(pi))/2.
      epm=dconjg(epp)
      eqp=dcmplx(dcos(qi),dsin(qi))/2.
      eqm=dconjg(eqp)
      ex=pr
      exl=qr
      fac=0.0
      if(pr.lt.15.) fac=dexp(-2.*pr)
      cosp=epp + fac*epm
      sinp=epp - fac*epm
      w=sinp/ra
      x=ra*sinp
      fac=0.0d+00
      if(qr.lt.15.) fac=dexp(-2.*qr)
      cosql=eqp + fac*eqm
      sinq=eqp - fac*eqm
      yl=sinq/rb
      zl=rb*sinq
      exa=pr + qr
      cpcq=cosp*cosql
      cpy=cosp*yl
      cpz=cosp*zl
      cqw=cosql*w
      cqx=cosql*x
      xy=x*yl
      xz=x*zl
      wy=w*yl
      wz=w*zl
      fac=0.0d+00
      qmp=qr-pr
      if(qmp.gt.-40.) fac=dexp(qmp)
      cosq=cosql*fac
      y=fac*yl
      z=fac*zl
      fac=0.0d+00
      if(exa.lt.60.) a0=dexp(-exa)
      return
      end
     
      subroutine bufini(irdwr,ierr)
c------initialize buffer pointer
c------irdwr = 0 read initialize
c------irdwr = 1 write initialize
      integer BUFMAX
       parameter(BUFMAX=2000)
       common/buf/iptr,max,buffer(BUFMAX)
c       save /buf/
      iptr = 1
      if(irdwr.eq.0)call getbuf(ierr)
      return
      end
     
        subroutine buflsh
c------flush output buffer
      integer BUFMAX
      parameter(BUFMAX=2000)
        common/buf/iptr,max,buffer(BUFMAX)
c     save /buf/
      ipt = iptr -1
      if(ipt.gt.0)write(2)ipt,(buffer(i),i=1,ipt)
        iptr = 1
      return
      end
     
        subroutine bufwr(x)
c------fill buffer with floating point variable x,
c------flush buffer as necessary
      integer BUFMAX
      parameter(BUFMAX=2000)
      common/buf/iptr,max,buffer(BUFMAX)
c     save /buf/
      buffer(iptr) = x
      iptr = iptr + 1
      if(iptr.gt.BUFMAX)call buflsh
      return
      end
     
        subroutine getbuf(ierr)
c------read in file contents into buffer, taking care not to
c------read beyond the contents of the file
      integer BUFMAX
      parameter(BUFMAX=2000)
      common/buf/iptr,max,buffer(BUFMAX)
c     save /buf/
c------ierr = 0 successful read
c------     = 1 read error
c------     = 2 end of file
c------
      read(2,err=1000,end=2000)max,(buffer(i),i=1,max)
      iptr = 1
      ierr = 0
      return
 1000 ierr = 1
      return
 2000 ierr = 2
      return
      end
     
      subroutine bufrd(x,ierr)
c-----retrieve a value from buffer array, red in new array
c-----as necessary
c-----iptr is here the next array element to be read
c-----it is always >= 1. We do not worry the upper limit
c-----since the calling program must worry about this
c-----because read always follows a complete write
      integer BUFMAX
      parameter(BUFMAX=2000)
      common/buf/iptr,max,buffer(BUFMAX)
c     save /buf/
c       only yank in new data if actually required
      if(iptr.gt.max)call getbuf(ierr)
      x = buffer(iptr)
      iptr = iptr + 1
      return
      end

	function numarg()
	integer numarg
	numarg = iargc()
	return
	end

      subroutine mchdep()
c---------------------------------------------------------------------c
c                                                                     c
c      COMPUTER PROGRAMS IN SEISMOLOGY                                c
c      VOLUME VI                                                      c
c                                                                     c
c      PROGRAM: MCHDEP                                                c
c                                                                     c
c      COPYRIGHT 1985                                                 c
c      R. B. Herrmann                                                 c
c      Department of Earth and Atmospheric Sciences                   c
c      Saint Louis University                                         c
c      221 North Grand Boulevard                                      c
c      St. Louis, Missouri 63103                                      c
c      U. S. A.                                                       c
c                                                                     c
c---------------------------------------------------------------------c
      return
      end

c
c  Converts Guralp GCF files to SEISAN format, only works with one channel
c  data. Maximum number of samples as defined in seisan, at least 500 000,
c  channels codes can be defined using the gursei.def definition file. If
c  no definition file, the station name is GURAL and the component is taken
c  the gcf header.
c  
c
c  j. havskov, sep 2000
c
c  updates:
c
c  nov 14 2001 jh : also check for linux, logical *1 cannot be used on sus linux
c                   put in first 4 letters from stream as station

      implicit none
      include 'seidim.inc' ! dimensions
c-- output data vector	  
      integer*4  data(max_sample)
c
c-----------------------------------------------------------------------
c   start block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- times since epoch for checking that blocks are contiguous (RL 03/2006)
      double precision start_time
      double precision prev_end_time
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c
c--end block of definitions most conversion programs
c---------------------------------------------------------------------

      integer yr,mo,da,hr,mn    ! date and time any block
      real se,ra                ! second and sample rate, any block
      character*80 text         ! general text

c------------------------------------------------------------------
c-- input file name	  
      character*80 infile
c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c--Counters etc
      integer i,j
c-- computer type
      logical pc,sun,linux
      integer nsmp            ! sample counter
      integer nrecord         ! records in following data section
      integer comp_code       ! guralp compression code
      character*6 system_id,stream_id  ! guralp data identifiers
      integer x4(256)         ! 4 byte integers in a block
      character*1 block(1024) ! corresponding string
      integer*2 x2(512)       ! 2 byte integers in a block
c      integer*1 x1(1024)      ! one byte intger, for linux or pc
cfor sun or pc     logical*1 x1(1024)      ! one byte intger
      logical*1 x1(1024)      ! one byte intger
      integer*4 xlast         ! last value in block, used for control
      integer max24           ! largest 24 bit value
      integer nsamp_block     ! number of samples in one block
      integer sample          ! one sample
      character*4 csample     ! same as string
      equivalence (x4,block)
      equivalence (x2,block)
      equivalence (x1,block)
      equivalence (sample,csample)
c


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      max24=2**23

c
      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       text='gursei.def'
       call read_def_chan(text,mainhead_text,net_code)

c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.
     *infile(1:10).eq.'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c   file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file 
c
       open(1,file=infile,status='old',access='direct',recl=1024)
c
c   read header block to get start time etc
c
c
       read(1,rec=1,err=99) block

c
c   number of channels, not given in input file, assume 1
c
       nchan=1
c
c   get file start time etc
c
       call read_guralp_head(block,year(1),month(1),day(1),hour(1),
     *    min(1),sec(1),rate(1),nrecord,comp_code)

       write(6,*) 'ymdhms',year(1),month(1),day(1),hour(1),min(1),sec(1)
       write(6,*) 'rate,nr,for',rate(1),nrecord,comp_code
c
c   get system id and stream id
c
       call get_36_string(x4(1),system_id)
       call get_36_string(x4(2),stream_id)
       write(6,*) 'System and stream id ',system_id,'  ',stream_id
c
c---------------------------------------------------------------
c   read file and decode numbers, one block at a time
c---------------------------------------------------------------
c
      i=1
      nsmp=1
c
c   back here after reading and decoding one block
c
 30   continue
c
      read(1,rec=i,err=50) x4
c
c  read header
c
      call read_guralp_head(block,yr,mo,da,hr,
     *    mn,se,ra,nrecord,comp_code)

c
c   this could be a status block indicated by sample rate zero, if so skip it
c
      if(ra.eq.0.0) then
          i=i+1
          goto 30
      endif

c   Check for missing data between previous block and this one.
c   If there is a gap then fill space with 0s                          (RL 03/2006)
c      start_time = (((hr*60)+mn)*60)+se
      call timsec(yr,mo,da,hr,mn,se,start_time)
      if (nsmp .ne. 1 .and. start_time .ne. prev_end_time) then
          nsamp_block = (start_time - prev_end_time) * ra
          do j=1,nsamp_block
              data(nsmp)=0
              nsmp=nsmp+1
          enddo	  
      endif
	 
c
c   samples in block
c
      nsamp_block=comp_code*nrecord
c
c   first sample in block, possibly swap
c
      if(pc.or.linux) call swap4_one(x4(5))
c
c   save last sample in block, possibly swap
c
      xlast=x4(nrecord+6)
      if(pc.or.linux) call swap4_one(xlast)
c
c   put into output data vector
c
      data(nsmp)=x4(5)
      nsmp=nsmp+1
c
c   get remaining compressed values and  find differences
c   depending on compression
c
c
c   one byte data
c
      if(comp_code.eq.4) then
         do j=2,nsamp_block
            data(nsmp)=x1(j+20)+data(nsmp-1)
            nsmp=nsmp+1
         enddo
      endif
c
c   two byte data
c
      if(comp_code.eq.2) then
         if(pc.or.linux) call swap2(512,x2)
         do j=2,nsamp_block
           data(nsmp)=x2(j+10)+data(nsmp-1)
           nsmp=nsmp+1
         enddo
      endif
      
c
c   4 byte data
c
      if(comp_code.eq.1) then
         if(pc.or.linux) call swap4(256,x4)
         do j=2,nsamp_block
           if(x4(j+5)+data(nsmp-1).gt.max24) then  ! check 24 bit overflow
              sample=x4(j+5)+data(nsmp-1)         ! save sample
              if(sun) then
                 csample(1:1)=char(256)            ! add sign
              else
                 csample(4:4)=char(256)
              endif
              data(nsmp)=sample
           else
              data(nsmp)=data(nsmp-1)+x4(j+5)
           endif
           nsmp=nsmp+1
         enddo
      endif
c
c   check that last value is correct
c
      if(data(nsmp-1).ne.xlast) then
        write(6,*)' Something wrong with decompression'
        write(6,*)' Block #', i
        write(6,*) ' Last decompressed ',data(nsmp-1)
        write(6,*) ' Last correct value ',xlast
        stop
      endif

c
c   Remember time of end of block so can check for missing data
c
      prev_end_time = start_time + nsamp_block/ra

c
c   go back to read next block
c
      i=i+1   

      goto 30
c
c------------------------------------------------------
c  all data decoded
c------------------------------------------------------
c
 50   continue
      close(1)
      write(6,*) 'Number of samples', nsmp
c      nsamp(1)=nsmp-1
      nsamp(1) = nsmp         ! RL
      cbyte(1)='4'            ! always assume 4 byte data
      stat(1)=stream_id(1:4)//' '
c
c   default station and channel names
c
      comp(1)='B  Z'
      comp(1)(4:4)=stream_id(5:5)
c
c change station or component names according to def file
c
      call set_def_chan(1,stat(1),comp(1))

c
c   make seisan headers
c
      ichan=1
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,
     *                 nsamp,rate,cbyte,
     *                 outfile,mainhead,chahead)
c
c   fix name so component is added
c
      outfile(30:30)='_'
      outfile(31:34)=comp(1)
      do i=31,34
         if(outfile(i:i).eq.' ') outfile(i:i)='_'
      enddo        
      write(6,'(a,a)')' Output file name is: ',outfile
c
c   open output file
c
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   write main head
c

      do i=1,12
         write(2)mainhead(i)
         write(6,'(a80)') mainhead(i)
      enddo
c
C-----------------------------------------
C   enter channel  loop, for the moment one
c-----------------------------------------
c
      do ichan=1,nchan
c
c   make channel header	
c
         call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                    net_code,mainhead_text,stat,comp,
     *                    nsamp,rate,cbyte,
     *                    outfile,mainhead,chahead)
c
c   write rate a bit more accurate
c
c         write(chahead(37:43),'(f7.3)') rate(1)
         if(rate(1).lt.100.0) write(chahead(37:43),'(f7.4)') rate(1)
         if(rate(1).lt.10.0) write(chahead(37:43),'(f7.5)') rate(1)
         write(6,'(1x,a)') chahead(1:78)
c                                                                               
c   get response            
c                                                                               
         call read_resp_head(chahead)
c
c   write data
c
         write(2)chahead
         write(2) (data(i),i=1,nsmp)
c
c   end of channels loop
c
      enddo
      write(6,*)
c
c  back for next file if many
c
      goto 101
 99   continue
      write(6,*)' Error with file'
 101  continue
      close(2)
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  
c
       subroutine get_36_string(val,string6)
c
c   decode guralp base 36 number
c
c      val: input integer
c      string6: 6 char output string
c
       implicit none
       character*6 string6
       integer val
       character*1 st(36)
       logical sun,pc,linux    ! computer type
       integer i,j,k
       data st/'0','1','2','3','4','5','6','7','8','9',
     *         'A','B','C','D','E','F','G','H','I','J',
     *         'K','L','M','N','O','P','Q','R','S','T',
     *         'U','V','W','X','Y','Z'/

        string6=' '      ! initialize with blanks
c
        call computer_type(sun,pc,linux)

c
c   swap if on pc
c
       if(pc.or.linux) call swap4_one(val)
c
       do i=1,6
          j=val/36
          k=val-j*36
          if(k.ge.0) string6(7-i:7-i)=st(k+1)
          val=j
       enddo

       return
       end

      
      subroutine read_guralp_head(block,year,month,day,hour,min,sec,
     *                            rate,nrecord,comp_code)

c
c  read part of one 16 byte guralp gcf header
c
      implicit none
      character*1 block(1024)   ! guralp data block
      integer year,month,day,doy,hour,min
      real sec
      real rate           ! sample rate
      integer nrecord     ! number of records in data block
      integer comp_code   ! compression code, see guralp format description
      integer i,k
      integer seconds_day ! seconds since midnight
      integer day_89      ! days since 17 nov 1989
      double precision  time89  ! for time conversion
c
c  date and time
c
      day_89=ichar(block(9))*256+ichar(block(10))
      k=day_89          ! save
      day_89=day_89/2   ! lowest bit is part of 17 bit second number
      seconds_day    =ichar(block(11))*256+ichar(block(12))
c
c  check if bit 17 is used
c
      i=k-day_89*2
      if(i.eq.1) seconds_day=seconds_day+65536 ! 17 bit is used
      call timsec(1989,11,17,0,0,0.0,time89)   ! time from 1900 in secs
      time89=time89+day_89*24*3600.0+seconds_day     ! time till now
      call sectim(time89,year,doy,month,day,hour,min,sec) ! data now
c
c  sample rate
c
      rate=ichar(block(14))
c
c  compression code
c
      comp_code=ichar(block(15))
c
c   number of records
c
      nrecord=ichar(block(16))

      return
      end

C
c
c     changes
c
c     jun 99  jh   --------------- version 7.0 -------------------------
c                  add version call
c
C     PROGRAM EQRISK(INPUT,OUTPUT,TAPE5=INPUT,TAPE6=OUTPUT)                A   1
C     ******************************************************************   A   2
C     NO RESPONSIBILITY IS ASSUMED BY THE AUTHORS OR BY THE UNIVERSITY     A   3
C     OF CALIFORNIA FOR ANY ERRORS, MISTAKES, OR MISREPRESENTATIONS        A   4
C     THAT MAY OCCUR FROM THE USE OF THIS COMPUTER PROGRAM.  ALL           A   5
C     SOFTWARE PROVIDED ARE IN 'AS IS' CONDITION. NO WARRANTIES OF ANY     A   6
C     KIND, WHETHER STATUTORY, WRITTEN, ORAL, EXPRESSED, OR IMPLIED        A   7
C     (INCLUDING WARRANTIES OF FITNESS AND MERCHANTABILITY) SHALL APPLY.   A   8
C                                                                          A   9
C     PUBLIC DISTRIBUTION OF THIS PROGRAM THROUGH NISEE WAS MADE POSSI-    A  10
C     BLE BY THE AUTHORS AND THE NATIONAL SCIENCE FOUNDATION WITH THE      A  11
C     STIPULATION THAT THE PROGRAM NEITHER BE SOLD IN WHOLE OR IN PART     A  12
C     FOR DIRECT PROFIT NOR ROYALTIES OR DEVELOPMENT CHARGES MADE FOR      A  13
C     ITS USE.  BY ACCEPTANCE OF DELIVERY OF THIS PROGRAM PACKAGE, THE     A  14
C     PURCHASER UNDERSTANDS THE RESTRICTIONS ON THE USE AND DISTRIBU-      A  15
C     TION OF THE PROGRAM.  THE FEE PAID TO NISEE REPRESENTS A CHARGE      A  16
C     FOR DUPLICATION, MAILING, AND DOCUMENTATION.  THE LEGAL OWNERSHIP    A  17
C     OF THE PROGRAM REMAINS WITH THE DEVELOPER.                           A  18
C                                                                          A  19
C     IF THIS PROGRAM HAS GIVEN YOU NEW ANALYSIS CAPABILITY RESULTING      A  20
C     IN INDIRECT PROFITS, YOU MAY WISH TO SUPPORT FURTHER WORK IN THIS    A  21
C     AREA BY GIVING AN UNRESTRICTED GRANT TO THE AUTHORS' UNIVERSITY.     A  22
C     ******************************************************************   A  23
C        MAINROUTINE                                                       A  24
C        R K MCGUIRE   U.S.G.S. JANUARY 1975                               A  25
C       PLANAR VERSION (CARTESIAN COORDINATES)                             A  26
C                                                                          A  27
C   INTERNAL SOURCE AREA SIDE AND CORNER NOTATION FOLLOWS......            A  28
C                                                                          A  29
C                  SIDE 4                                                  A  30
C     (X3,Y3)------------------(X4,Y4)                                     A  31
C        '                        '                                        A  32
C        '                        '                                        A  33
C        '                        '                                        A  34
C        '                        '                                        A  35
C SIDE 3 '                        ' SIDE 2                                 A  36
C        '                        '                                        A  37
C        '                        '                                        A  38
C        '                        '                                        A  39
C        '                        '                                        A  40
C     (X1,Y1)------------------(X2,Y2)                                     A  41
C                  SIDE 1                                                  A  42
C                                                                          A  43
C                                                                          A  44
      COMMON NRD,NWR,NLEI,TI(12),RSKTI(12)                                 A  45
      COMMON C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                               A  46
      COMMON NGS,NRS(20),AM0(21),AM1(21),LORS(21)                          A  47
      COMMON BETA(21),RATE(21),COEF(21),FDEPTH(21)                         A  48
      COMMON NSTEPO,NSTEPI,JCALC,JPRNT                                     A  49
      COMMON INDIC(4),AREA(20,11),X(20,11,2),Y(20,11,2)                    A  50
C..Attenuation choice in risk2 subroutine                                  t0000
      COMMON /atten/ IATTE                                                 t0001
      DIMENSION TITLE(20)                                                  A  51
      DIMENSION RISKS(9),ATI(12),BRISK(12),TIF(8)                          A  52
C         TO MODIFY LIMITS AS STATED IN PROGRAM DOCUMENTATION, CHANGE      A  53
C         COMMON DIMENSION STATEMENTS IN MAIN PROGRAM AND SUBROUTINES AS   A  54
C         FOLLOWS=                                                         A  55
C         (1) TO CHANGE MAX. NO. OF GROSS SOURCES (PRESENTLY 10)=          A  56
C             (A) CHANGE ALL 10'S TO NEW MAX.                              A  57
C             (B) CHANGE ALL 11'S IN SINGLE DIMENSION ARRAYS TO            A  58
C                   NEW MAXIMUM + 1.                                       A  59
C         (2) TO CHANGE MAX. NO. OF SUBSOURCES IN EACH GROSS SOURCE        A  60
C                 (PRESENTLY 10)=                                          A  61
C             (A) CHANGE ALL 11'S IN DOUBLE- AND TRIPLE-DIENSION ARRAYS    A  62
C                 TO NEW MAXIMUM + 1.                                      A  63
C         (3) TO CHANGE MAX. NO. IN THE LIST OF EXAMINED INTENSITIES       A  64
C                 (PRESENTLY 12)=                                          A  65
C             (A) CHANGE ALL 12'S TO NEW MAXIMUM.                          A  66
C         (4) TO CHANGE MAX. NO. OF INPUT RISK LEVELS (PRESENTLY 8)=       A  67
C             (A) CHANGE 9 TO NEW MAX. + 1                                 A  68
C             (B) CHANGE STATEMENT BELOW= 'RISKS(9)=0.0'                   A  69
C                 TO 'RISKS(NEW MAX. + 1) = 0.0'.                          A  70


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      NRD=9                                                                A  71
      NWR=7                                                                A  72
  	  OPEN(NRD,FILE='DATA')
 	  OPEN(NWR,FILE='eqrisk.out',status='unknown')
C        READ TITLE                                                        A  73
      READ (NRD,900) (TITLE(I),I=1,20)                                     A  74
 900  FORMAT (20A4)                                                        A  75
      WRITE (NWR,910) (TITLE(I),I=1,20)                                    A  76
 910  FORMAT (10X,20A4)                                                    A  77
C          READ STEP SIZE AND SWITCH VALUES.                               A  78
      READ (NRD,921) NSTEP,JCALC,JPRNT,IATTE                               A  79
 921  FORMAT (4I10)                                                        A  80
      WRITE(NWR,922) NSTEP,JCALC,JPRNT,IATTE                               A  81
 922  FORMAT (/' NSTEP =',I5,' JCALC =',I5,' JPRNT =',I5,' IATTE =',I5)    A  82
C          NSTEPO IS STEP SIZE USED WHEN SITE IS OUTSIDE                   A  83
C                 (QUADRILATERAL) SOURCE BEING CONSIDERED.                 A  84
C          NSTEPI IS STEP SIZE USED WHEN SITE IS INSIDE                    A  85
C                 (QUADRILATERAL) SOURCE BEING CONSIDERED.                 A  86
      NSTEPO=NSTEP                                                         A  87
      NSTEPI=NSTEP                                                         A  88
C          READ NUMBER AND LIST OF EXAMINED INTENSITIES.                   A  89
      READ (NRD,901) NLEI,(TI(I),I=1,NLEI)                                 A  90
 901  FORMAT(I5,12F5.3)                                                    A  91
      WRITE (NWR,902) (TI(I),I=1,NLEI)                                     A  92
 902  FORMAT (/' LIST OF EXAMINED INTENSITIES ',12F8.2)                    A  93
 903  FORMAT(8F10.2)                                                       A  94
      DO 90 I=1,NLEI                                                       A  95
      ATI(I)=EXP(TI(I))                                                    A  96
  90  BRISK(I)=0.0                                                         A  97
C         READ LIFETIME AND RISKS DESIRED.                                 A  98
      READ (NRD,903) (RISKS(I),I=1,8)                                      A  99
      WRITE(NWR,919) (RISKS(I),I=1,8)                                      A 100
 919  FORMAT(/' RISKS DESIRED ',8F8.4)                                     A 101
C        READ ATTENUATION DATA                                             A 102
      READ (NRD,920) C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                       A 103
 920  FORMAT (8F10.2)                                                      A 104
      WRITE (NWR,905)C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                       A 105
 905  FORMAT(/' ATTENUATION DATA=   C1      C2      C3    '                A 106
     1,'SIGMA   RZERO    RONE     AAA     BBB',/16X,8F8.2)                 A 107
      IF (BBB+0.00001) 101,102,102                                         A 108
 101  WRITE (NWR,924)                                                      A 109
 924  FORMAT(//' INPUT ERROR=  THE VALUE OF BBB MUST BE POSITIVE,'         A 110
     1 ' BETWEEN 0.0 AND THE VALUE OF C2. EXECUTION STOPPED.')             A 111
      GO TO 890                                                            A 112
 102  IF (C2-BBB) 101,103,103                                              A 113
C         IF BBB=0.0, SET EQUAL TO A SMALL NUMBER                          A 114
 103  IF (BBB-0.00001) 104,105,105                                         A 115
 104  BBB=0.0000000001                                                     A 116
C        READ SOURCE DATA                                                  A 117
 105  READ (NRD,906) NGS,(NRS(I),I=1,NGS)                                  A 118
 906  FORMAT (24I3)                                                        A 119
      WRITE (NWR,907) NGS,(NRS(I),I=1,NGS)                                 A 120
 907  FORMAT(/' NO. OF GROSS SOURCES ',I5/' NO. OF SUBSOURCES IN GROSS S   A 121
     1OURCES ',16I5)                                                       A 122
      WRITE (NWR,918)                                                      A 123
 918  FORMAT (/' GROSS SOURCE   L/S',5X,'COEF',7X,                         A 124
     1'M0',8X,'M1',6X,'BETA',5X,'RATE/YR',3X,'FDEPTH')                     A 125
      NGS1=NGS+1                                                           A 126
      DO 110 I=1,NGS1                                                      A 127
      READ(NRD,904)LORS(I),COEF(I),AM0(I),AM1(I),BETA(I),RATE(I),          A 128
     1 FDEPTH(I)                                                           A 129
 904  FORMAT(I10,6F10.2)                                                   A 130
      IF (I-NGS1) 110,120,120                                              A 131
 110  WRITE (NWR,908)I,LORS(I),COEF(I),AM0(I),AM1(I),BETA(I),RATE(I),      A 132
     1 FDEPTH(I)                                                           A 133
 908  FORMAT (1X,I7,3X,I7,3F10.2,3F10.4)                                   A 134
C         WRITE BACKGROUND SEISMICITY                                      A 135
 120  WRITE (NWR,925) LORS(I),COEF(I),AM0(I),AM1(I),BETA(I),RATE(I),       A 136
     1 FDEPTH(I)                                                           A 137
 925  FORMAT(' (BACKGROUND)',I5,3F10.2,3F10.4/)                            A 138
      DO 200 II=1,NGS                                                      A 139
      NRSII=NRS(II)+1                                                      A 140
      DO 150 JJ=1,NRSII                                                    A 141
      READ (NRD,903) X(II,JJ,1),Y(II,JJ,1),X(II,JJ,2),Y(II,JJ,2)           A 142
      WRITE (NWR,909) II,X(II,JJ,1),Y(II,JJ,1),X(II,JJ,2),Y(II,JJ,2)       A 143
 909  FORMAT(' GROSS SOURCE',I3,' SUBSOURCE COORDINATE DATA ',4F10.2)      A 144
 150  CONTINUE                                                             A 145
 200  WRITE (NWR,932)                                                      A 146
 932  FORMAT(1X)                                                           A 147
C        CALCULATE AREA OF EACH SUBSOURCE AND GROSS SOURCE.                A 148
C        IF ARRAYS X( ) AND Y( ) CONTAIN LONGITUDE                         A 149
C          AND LATITUDE, CHANGE SUBROUTINE 'AREAS' TO                      A 150
C          CALCULATE CORRECT AREAS USING THESE PARAMETERS.                 A 151
C          SEE ALSO REQUIRED CHANGES BELOW.                                A 152
      DO 400 II=1,NGS                                                      A 153
      NTOT=NRS(II)+1                                                       A 154
      AREA(II,NTOT)=0.0                                                    A 155
      JJNRS=NRS(II)                                                        A 156
      DO 300 JJ=1,JJNRS                                                    A 157
	  CALL AREAS(X(II,JJ,1),Y(II,JJ,1),X(II,JJ,2),Y(II,JJ,2),
     @ X(II,JJ+1,1),Y(II,JJ+1,1),X(II,JJ+1,2),Y(II,JJ+1,2),AREA(II,JJ))
      WRITE (NWR,911) II,JJ, AREA(II,JJ)                                   A 160
 911  FORMAT(' GROSS SOURCE',I3,' SUBSOURCE',I3,' EXACT AREA',F10.1)       A 161
 300  AREA(II,NTOT)=AREA(II,NTOT)+AREA(II,JJ)                              A 162
 400  WRITE (NWR,913) II,AREA(II,NTOT)                                     A 163
 913  FORMAT(' GROSS SOURCE',I3,13X,' TOTAL AREA',F10.1/)                  A 164
C         COMPUTE BACKGROUND SEISMICITY                                    A 165
      IF(RATE(NGS1)-0.0000000001) 420,420,405                              A 166
C         RBACK IS RADIUS OUT TO WHICH RISK FROM                           A 167
C           BACKGROUND SEISMICITY IS CALCULATED.                           A 168
 405  RBACK=150.                                                           A 169
C        FOR BACKGROUND SEISMICITY, NSTEPI IS DOUBLED (AND                 A 170
C           THEN HALVED AFTER CALCULATIONS).                               A 171
      NSTEPI=2*NSTEPI                                                      A 172
      CALL CIRCLE(RBACK,NGS1,1.,BRISK)                                     A 173
      NSTEPI=NSTEPI/2                                                      A 174
      DO 410 I=1,NLEI                                                      A 175
 410  BRISK(I)=COEF(NGS1)*BRISK(I)/10000.                                  A 176
      WRITE(NWR,926)(TI(I),I=1,NLEI)                                       A 177
 926  FORMAT(/' RESULTS FOR BACKGROUND SEISMICITY'/13X,'INTENSITY=  ',     A 178
     1 F7.2,11(2X,F7.2))                                                   A 179
      WRITE(NWR,923)(ATI(I),I=1,NLEI)                                      A 180
      WRITE(NWR,927)(BRISK(I),I=1,NLEI)                                    A 181
 927  FORMAT(' (BACKGROUND) E(NO/YR)= ',12E9.3)                            A 182
C         LOOP ON SETS OF SITES FOR ANALYSIS                               A 183
 420  READ (NRD,914) NX,NY,XZERO,YZERO,XDELTA,YDELTA                       A 184
 914  FORMAT (2I5,4F10.2)                                                  A 185
      IF (NX) 850,850,430                                                  A 186
 430  DO 800 IY=1,NY                                                       A 187
      YNOT=YZERO+(IY-1)*YDELTA                                             A 188
      DO 700 IX=1,NX                                                       A 189
      XNOT=XZERO+(IX-1)*XDELTA                                             A 190
      DO 450 I=1,NLEI                                                      A 191
 450  RSKTI(I)=BRISK(I)                                                    A 192
      WRITE (NWR,915) XNOT,YNOT,(TI(I),I=1,NLEI)                           A 193
 915  FORMAT(///' RESULTS FOR SITE LOCATION ',2F10.2/                      A 194
     1 /13X,'INTENSITY=  ',F7.2,11(2X,F7.2))                               A 195
      WRITE (NWR,923) (ATI(I),I=1,NLEI)                                    A 196
 923  FORMAT (4X,'ANTILOG(INTENSITY)=  ',F7.2,11(2X,F7.2))                 A 197
      DO 600 II=1,NGS                                                      A 198
      JJNRS=NRS(II)                                                        A 199
      DO 500 JJ=1,JJNRS                                                    A 200
      INGS=II                                                              A 201
      INSS=JJ                                                              A 202
C         IF THE USER WISHES THIS PROGRAM TO WORK ON LONGITUDE AND         A 203
C         LATITUDE COORDINATES, SIMPLY INPUT THESE COORDINATES AS IN THE   A 204
C         CARTESIAN CASE' AT THIS POINT CALCULATE (IN UNITS                A 205
C         CONSISTENT WITH THE ATTENUATION FUNCTION) THE CARTESIAN          A 206
C         LOCATION OF X(II,JJ,1),Y(II,JJ,1) WITH RESPECT TO XNOT,YNOT,     A 207
C         AND SIMILARLY WITH THE OTHER 3 POINTS DESCRIBING THE SOURCE      A 208
C         AREA UNDER CONSIDERATION, AND PLACE THESE CALCULATED CARTESIAN   A 209
C         COORDINATES IN THE ARGUMENT LIST OF THE FOLLOWING CALL STATE-    A 210
C         MENT (WITH XNOT AND YNOT AS THE ORIGIN, I.E. (0.0,0.0)).         A 211
C         SEE ALSO CHANGES REQUIRED ABOVE FOR SUBROUTINE 'AREAS'.          A 212
       CALL RRISK(XNOT,YNOT,INGS,INSS,X(II,JJ,1),Y(II,JJ,1),X(II,JJ,
     @2),Y(II,JJ,2),X(II,JJ+1,1),Y(II,JJ+1,1),X(II,JJ+1,2),Y(II,JJ+1,2))
 500  CONTINUE                                                             A 215
 600  CONTINUE                                                             A 216
      IF (JPRNT) 615,615,610                                               A 217
 610  WRITE(NWR,927)(BRISK(I),I=1,NLEI)                                    A 218
 615  WRITE (NWR,916) (RSKTI(I),I=1,NLEI)                                  A 219
 916  FORMAT (' ALL SOURCES  E(NO/YR)= ',12E15.3)                          A 220
      DO 620 I=1,NLEI                                                      A 221
 620  RSKTI(I)=1.-EXP(-RSKTI(I))                                           A 222
      WRITE (NWR,931) (RSKTI(I),I=1,NLEI)                                  A 223
 931  FORMAT(' ALL SOURCES      RISK= ',12E15.3)                           A 224
	write(6,309) rskti(2),rskti(4)
309	format(2e12.6)
C         ESTIMATE INTENSITIES AT RISKS DESIRED.                           A 225
      RISKS(9)=0.0                                                         A 226
      IA=0                                                                 A 227
      IF(RISKS(1)-0.0000000001) 700,700,625                                A 228
 625  DO 630 IRK=1,8                                                       A 229
      IF (RISKS(IRK)-RSKTI(1)) 640,640,630                                 A 230
 630  TIF(IRK)=1000000.                                                    A 231
      GO TO 700                                                            A 232
 640  IA=IA+1                                                              A 233
      IF (IA-NLEI) 650,645,645                                             A 234
 645  TIF(IRK)=1000000.                                                    A 235
      IRK=IRK+1                                                            A 236
      IF (RISKS(IRK)-0.0000000001)680,680,645                              A 237
 650  IF(RISKS(IRK)-RSKTI(IA+1))640,655,655                                A 238
 655  TIF(IRK)=(ALOG(RSKTI(IA)/RISKS(IRK)))                                A 239
     1  /(ALOG(RSKTI(IA)/RSKTI(IA+1)))                                     A 240
      TIF(IRK)=TI(IA)+TIF(IRK)*(TI(IA+1)-TI(IA))                           A 241
 658  IRK=IRK+1                                                            A 242
      IF (RISKS(IRK)-0.0000000001)680,680,660                              A 243
 660  IF(RISKS(IRK)-RSKTI(IA+1)) 640,655,655                               A 244
 680  IRK=IRK-1                                                            A 245
      WRITE(NWR,928)(RISKS(I),I=1,IRK)                                     A 246
 928  FORMAT(/16X,' RISKS= ',8F9.6)                                        A 247
      WRITE(NWR,929)(TIF(I),I=1,IRK)                                       A 248
 929  FORMAT(13X,'INTENSITY= ',8F9.2)                                      A 249
      DO 685 I=1,IRK                                                       A 250
      IF (TIF(I)-999999.)683,685,685                                       A 251
 683  TIF(I)=EXP(TIF(I))                                                   A 252
 685  CONTINUE                                                             A 253
      WRITE (NWR,930)(TIF(I),I=1,IRK)                                      A 254
 930  FORMAT(4X,'ANTILOG(INTENSITY)= ',8F9.2)                              A 255
 700  CONTINUE                                                             A 256
 800  CONTINUE                                                             A 257
C     GO TO 420                                                            A 258
 850  WRITE (NWR,917)                                                      A 259
 917  FORMAT (/////'       END OF JOB ' //)                                A 260
 890  STOP 
      END                                                                  A 262
      SUBROUTINE RRISK(XNOT,YNOT,INGS,INSS,                                B   1
     1 X1,Y1,X2,Y2,X3,Y3,X4,Y4)                                            B   2
      COMMON NRD,NWR,NLEI,TI(12),RSKTI(12)                                 B   3
      COMMON C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                               B   4
      COMMON NGS,NRS(20),AM0(21),AM1(21),LORS(21)                          B   5
      COMMON BETA(21),RATE(21),COEF(21),FDEPTH(21)                         B   6
      COMMON NSTEPO,NSTEPI,JCALC,JPRNT                                     B   7
      COMMON INDIC(4),AREA(20,11)                                          B   8
      DIMENSION XL(4),YL(4),XR(4),YR(4),AA(4),BB(4)                        B   9
C         SUBROUTINE WHICH LOADS TEMPORARY ARRAYS WITH THIS                B  10
C           SUBSOURCE'S CORNERS AND DETERMINES IF THIS SITE IS             B  11
C           WITHIN OR WITHOUT THE SUBSOURCE.                               B  12
      XL(1)=X1                                                             B  13
      YL(1)=Y1                                                             B  14
      XR(1)=X2                                                             B  15
      YR(1)=Y2                                                             B  16
      XL(2)=X2                                                             B  17
      YL(2)=Y2                                                             B  18
      XR(2)=X4                                                             B  19
      YR(2)=Y4                                                             B  20
      XL(3)=X3                                                             B  21
      YL(3)=Y3                                                             B  22
      XR(3)=X1                                                             B  23
      YR(3)=Y1                                                             B  24
      XL(4)=X4                                                             B  25
      YL(4)=Y4                                                             B  26
      XR(4)=X3                                                             B  27
      YR(4)=Y3                                                             B  28
C        DETERMINE IF ANY SIDES ARE VERTICAL LINES                         B  29
      DO 200 II=1,4                                                        B  30
      DIF=XL(II)-XR(II)                                                    B  31
      IF (DIF) 140,180,160                                                 B  32
 140  IF (DIF+0.01) 190,190,180                                            B  33
 160  IF (DIF-0.01) 180,190,190                                            B  34
C        INDIC(I)=1  IMPLIES NOT A VERTICAL LINE                           B  35
C        INDIC(I)=2  IMPLIES A VERTICAL LINE (INFINITE SLOPE).             B  36
 180  INDIC(II)=2                                                          B  37
      AA(II)=0.                                                            B  38
      BB(II)=0.                                                            B  39
      GO TO 200                                                            B  40
 190  INDIC(II)=1                                                          B  41
      AA(II)=(YL(II)-YR(II))/(XL(II)-XR(II))                               B  42
      BB(II)=YL(II)-AA(II)*XL(II)                                          B  43
C          AA(II) IS SLOPE OF II'TH SIDE                                   B  44
C          BB(II) IS INTERCEPT OF II'TH SIDE                               B  45
  200  CONTINUE                                                            B  46
C        DETERMINE IF SITE IS INSIDE SOURCE AREA.                          B  47
      DO 220 II=1,4                                                        B  48
      IJ=5-II                                                              B  49
      IINDIC=INDIC(II)                                                     B  50
C                                                                          B  51
      IF(IINDIC.EQ.2)GO TO 215                                             B  52
C                                                                          B  53
 210  DIFNOT=YNOT-AA(II)*XNOT-BB(II)                                       B  54
      DIF=YL(IJ)-AA(II)*XL(IJ)-BB(II)                                      B  55
 211  IF (DIF) 214,214,212                                                 B  56
 212  IF (DIFNOT) 400,400,220                                              B  57
 214  IF (DIFNOT) 220,400,400                                              B  58
 215  DIF=XL(IJ)-XL(II)                                                    B  59
      DIFNOT=XNOT-XL(II)                                                   B  60
      GO TO 211                                                            B  61
 220  CONTINUE                                                             B  62
C        IF DO LOOP FINISHED, POINT LIES WITHIN AREA.                      B  63
      CALL INSIDE(XNOT,YNOT,INGS,INSS,XL,YL,XR,YR,AA,BB)                   B  64
      GO TO 900                                                            B  65
 400  CALL OUTSID(XNOT,YNOT,INGS,INSS,XL,YL,XR,YR,AA,BB)                   B  66
 900  RETURN                                                               B  67
      END                                                                  B  68
      SUBROUTINE OUTSID(XNOT,YNOT,INGS,INSS,XL,YL,XR,YR,AA,BB)             C   1
      COMMON NRD,NWR,NLEI,TI(12),RSKTI(12)                                 C   2
      COMMON C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                               C   3
      COMMON NGS,NRS(20),AM0(21),AM1(21),LORS(21)                          C   4
      COMMON BETA(21),RATE(21),COEF(21),FDEPTH(21)                         C   5
      COMMON NSTEPO,NSTEPI,JCALC,JPRNT                                     C   6
      COMMON INDIC(4),AREA(20,11)                                          C   7
      DIMENSION XL(4),YL(4),XR(4),YR(4),AA(4),BB(4),XC(4),YC(4)            C   8
      DIMENSION RSK(12)                                                    C   9
C         SUBROUTINE FOR CALCULATING RISK WHEN SITE IS OUTSIDE             C  10
C          (QUADRILATERAL) SOURCE AREA.                                    C  11
C          DEFINE DISTANCE VALUES TO SELECT STEP SIZE.                     C  12
C          (RC IS CLOSEST DISTANCE BETWEEN SITE AND SOURCE.)               C  13
C          RC BETWEEN 0.0 AND RZ1 INPLIES STEP SIZE = NSTEPO.              C  14
C          RC BETWEEN RZ1 AND RZ2 IMPLIES STEP SIZE = NSTEPO/2.            C  15
C          RC BETWEEN RZ2 AND RZ3 IMPLIES LUMP RISK                        C  16
C                AT CENTER OF SOURCE (DEFINED BY AVERAGING LOCATIONS       C  17
C                OF CORNER POINTS).                                        C  18
C          RC GREATER THAN RZ3 IMPLIES IGNORE SOURCE.                      C  19
      RZ1=100.0                                                            C  20
      RZ2=300.0                                                            C  21
      RZ3=500.0                                                            C  22
C          TO BY-PASS THIS ALGORITHM, SET RZ1 TO A LARGE NUMBER.           C  23
C          TO PRODUCE 0-1 ALGORITHM (DISREGARD, OR CALCULATE USING         C  24
C          NSTEPO), SET RZ1=RZ2=RZ3=DISTANCE WITHIN WHICH YOU              C  25
C          WISH TO CONSIDER RISK.                                          C  26
C      FIND CLOSEST (IC,RC) AND FARTHEST (IFAR,RF) POINTS AND DISTANCES.   C  27
      RC2=10000000000.                                                     C  28
      RF2=0.                                                               C  29
      DO 108 II=1,4                                                        C  30
      DIST=(XNOT-XL(II))*(XNOT-XL(II))+(YNOT-YL(II))*(YNOT-YL(II))         C  31
      IF (RC2-DIST) 104,104,102                                            C  32
 102  RC=SQRT(DIST)                                                        C  33
      RC2=DIST                                                             C  34
      IC=II                                                                C  35
 104  IF (DIST-RF2) 108,108,106                                            C  36
 106  RF=SQRT(DIST)                                                        C  37
      RF2=DIST                                                             C  38
      IFAR=II                                                              C  39
 108  CONTINUE                                                             C  40
      ICS=0                                                                C  41
C        SEE IF ANY SIDE LIES CLOSER THAN CLOSEST POINT                    C  42
      DO 150 II=1,4                                                        C  43
C       IS SLOPE INFINITEf                                                 C  44
      IINDIC=INDIC(II)                                                     C  45
C                                                                          C  46
      IF(IINDIC.EQ.1) GO TO 130                                            C  47
C                                                                          C  48
 121  XS=XL(II)                                                            C  49
      YS=YNOT                                                              C  50
      GO TO 145                                                            C  51
C       IS SLOPE ZEROf                                                     C  52
 130  IF (AA(II)-0.001) 131,140,140                                        C  53
 131  IF (AA(II)+0.001) 140,140,132                                        C  54
 132  XS=XNOT                                                              C  55
      YS=YL(II)                                                            C  56
      GO TO 145                                                            C  57
C        SLOPE IS NOT ZERO, SO CALCULATE NEAREST POINT.                    C  58
 140  XS=(YNOT+(XNOT/AA(II))-BB(II))/(AA(II)+(1./AA(II)))                  C  59
      YS=((XNOT-XS)/AA(II))+YNOT                                           C  60
 145  CALL BETWEN(XL(II),YL(II),XR(II),YR(II),XS,YS,INDIC(II),IANS)        C  61
      IF (IANS) 150,146,148                                                C  62
 146  NERROR=1                                                             C  63
      GO TO 800                                                            C  64
 148  DIST=(XNOT-XS)*(XNOT-XS)+(YNOT-YS)*(YNOT-YS)                         C  65
      IF (DIST-RC2) 149,150,150                                            C  66
 149  RC2=DIST                                                             C  67
      RC=SQRT(DIST)                                                        C  68
      ICS=II                                                               C  69
 150  CONTINUE                                                             C  70
      APPROX=0.0                                                           C  71
      DO 290 II=1,NLEI                                                     C  72
 290  RSK(II)=0.                                                           C  73
C         DETERMINE STEP SIZE FROM RZ1,RZ2, AND RZ3.                       C  74
      IF (RC-RZ1) 308,308,292                                              C  75
 292  IF (RC-RZ2) 294,294,296                                              C  76
 294  NSTEPX=NSTEPO/2                                                      C  77
      GO TO 310                                                            C  78
 296  IF (RC-RZ3) 298,298,850                                              C  79
C          IF RC IS BETWEEN RZ2 AND RZ3, CALCULATE RISK                    C  80
C          ASSUMING SEISMICITY IS LUMPED AT CENTER (AVERAGE                C  81
C          OF CORNER POINTS).                                              C  82
 298  XAVE=(XL(1)+XL(2)+XL(3)+XL(4))/4.                                    C  83
      YAVE=(YL(1)+YL(2)+YL(3)+YL(4))/4.                                    C  84
      R=SQRT((XAVE-XNOT)*(XAVE-XNOT)+(YAVE-YNOT)*(YAVE-YNOT))              C  85
      NTOT=NRS(INGS)+1                                                     C  86
      RATEI=RATE(INGS)*AREA(INGS,INSS)/AREA(INGS,NTOT)                     C  87
      DO 306 JJ=1,NLEI                                                     C  88
      IF (JCALC) 300,302,302                                               C  89
 300  CALL RISK1(TI(JJ),R,INGS,RISK)                                       C  90
      GO TO 304                                                            C  91
 302  CALL RISK2(TI(JJ),R,INGS,RISK)                                       C  92
 304  IF (RISK-0.0000000001) 600,600,305                                   C  93
 305  RSK(JJ)=COEF(INGS)*RISK*RATEI                                        C  94
 306  RSKTI(JJ)=RSKTI(JJ) + RSK(JJ)                                        C  95
      GO TO 600                                                            C  96
 308  NSTEPX=NSTEPO                                                        C  97
 310  AN=NSTEPX                                                            C  98
      STSIZE=(RF-RC)/AN                                                    C  99
C        STEP THRU SOURCE AREA.                                            C 100
      DO 500 ISTEP=1,NSTEPX                                                C 101
      AI=ISTEP                                                             C 102
      R=RC+(AI-0.5)*STSIZE                                                 C 103
      NPT=0                                                                C 104
      ANGLE=0.                                                             C 105
      SIGNAL=1.                                                            C 106
C        LOOP ON EACH SIDE                                                 C 107
      DO 400 II=1,4                                                        C 108
      IINDIC=INDIC(II)                                                     C 109
C                                                                          C 110
      IF(IINDIC.EQ.1) GO TO 330                                            C 111
C                                                                          C 112
C          SIDE II IS A VERTICAL LINE                                      C 113
C          DOES CIRCLE (RADIUS R) INTERSECT ITf                            C 114
 320  A=XL(II)-XNOT                                                        C 115
      IF (A) 322,322,323                                                   C 116
 322  IF (R+A) 400,400,324                                                 C 117
 323  IF (R-A) 400,400,324                                                 C 118
C          COMPUTE TWO INTERSECTION POINTS                                 C 119
 324  X1=XL(II)                                                            C 120
      B=SQRT(R*R-(X1-XNOT)*(X1-XNOT))                                      C 121
      Y1=YNOT+B                                                            C 122
      X2=XL(II)                                                            C 123
      Y2=YNOT-B                                                            C 124
      GO TO 341                                                            C 125
 330  A=1.+AA(II)*AA(II)                                                   C 126
      B=2.*(-XNOT+AA(II)*(BB(II)-YNOT))                                    C 127
      C=XNOT*XNOT+YNOT*YNOT+BB(II)*(BB(II)-2.*YNOT)-R*R                    C 128
      D=B*B-4.*A*C                                                         C 129
      IF (D) 400,400,340                                                   C 130
C        TWO INTERSECTIONS, CALCULATE FIRST INTERSECTION POINT.            C 131
 340  D=SQRT(D)                                                            C 132
      X1=(-B+D)/(2.*A)                                                     C 133
      Y1=AA(II)*X1 + BB(II)                                                C 134
      X2=(-B-D)/(2.*A)                                                     C 135
      Y2=AA(II)*X2+BB(II)                                                  C 136
C        SEE IF (X1,Y1) IS ON BOUNDARY                                     C 137
 341  CALL BETWEN(XL(II),YL(II),XR(II),YR(II),X1,Y1,INDIC(II),IANS)        C 138
      IF (IANS) 360,342,345                                                C 139
 342  NERROR=4                                                             C 140
      GO TO 800                                                            C 141
C        CALCULATE OTHER POINT, SEE IF IS ON BOUNDARY.                     C 142
 345  CALL BETWEN(XL(II),YL(II),XR(II),YR(II),X2,Y2,INDIC(II),IANS)        C 143
      IF (IANS) 348,346,350                                                C 144
 346  NERROR=5                                                             C 145
      GO TO 800                                                            C 146
C        STORE FIRST POINT                                                 C 147
 348  NPT=NPT+1                                                            C 148
      XC(NPT)=X1                                                           C 149
      YC(NPT)=Y1                                                           C 150
      GO TO 400                                                            C 151
C        SEE IF THIS SIDE IS CLOSEST TO POINT, IF SO, TREAT SPECIALLY.     C 152
 350  IF (II-ICS) 352,355,352                                              C 153
C          BOTH POINTS ARE ON BOUNDARY, CALCULATE ANGLE BETWEN THEM.       C 154
 352  SIGN=-1.                                                             C 155
      GO TO 357                                                            C 156
 355  SIGN=1.                                                              C 157
      SIGNAL=-1.                                                           C 158
 357  AD=SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))                             C 159
      IF (AD-2.*R) 358,359,359                                             C 160
 358  ANGLE=SIGN*2.*ASIN(AD/(2.*R)) + ANGLE                               C 161
      GO TO 400                                                            C 162
 359  ANGLE=3.1415926536 +ANGLE                                            C 163
      GO TO 400                                                            C 164
C        SEE IF SECOND POINT ONLY IS ON BOUNDARY                           C 165
 360  CALL BETWEN(XL(II),YL(II),XR(II),YR(II),X2,Y2,INDIC(II),IANS)        C 166
      IF (IANS) 400,362,370                                                C 167
 362  NERROR=6                                                             C 168
      GO TO 800                                                            C 169
 370  NPT=NPT+1                                                            C 170
      XC(NPT)=X2                                                           C 171
      YC(NPT)=Y2                                                           C 172
 400  CONTINUE                                                             C 173
      IF(NPT.LT.1.OR.NPT.GT.4)GO TO 402                                    C 174
      GO TO (410,420,410,440),NPT                                          C 175
 402  CONTINUE                                                             C 176
      IF(SIGNAL)460,405,405                                                C 177
 405  NERROR=7                                                             C 178
      GO TO 800                                                            C 179
 410  NERROR=8                                                             C 180
      GO TO 800                                                            C 181
 420  AD=SQRT((XC(1)-XC(2))*(XC(1)-XC(2))+(YC(1)-YC(2))*(YC(1)-YC(2)))     C 182
      ANGLE=ANGLE + SIGNAL*2.*ASIN(AD/(2.*R))                             C 183
      GO TO 460                                                            C 184
C          FOUR INTERSECTION POINTS (EACH ON A DIFFERENT SIDE).            C 185
C          DETERMINE ANGLE BY FINDING CLOSEST 2 INTERSECTIONS TO           C 186
C          FARTHEST CORNER, CALCULATE ANGLE BETWEEN, AND ADD ANGLE         C 187
C          BETWEEN OTHER TWO INTERSECTIONS.                                C 188
 440  DIST1=10000000000.                                                   C 189
      I1=0                                                                 C 190
      I2=0                                                                 C 191
      I3=0                                                                 C 192
      I4=0                                                                 C 193
      DO 450 JJ=1,4                                                        C 194
      DIST=(XL(IFAR)-XC(JJ))*(XL(IFAR)-XC(JJ))                             C 195
     1  +(YL(IFAR)-YC(JJ))*(YL(IFAR)-YC(JJ))                               C 196
      IF (DIST-DIST1) 442,444,444                                          C 197
 442  DIST2=DIST1                                                          C 198
      DIST1=DIST                                                           C 199
      I4=I3                                                                C 200
      I3=I2                                                                C 201
      I2=I1                                                                C 202
      I1=JJ                                                                C 203
      GO TO 450                                                            C 204
 444  IF (DIST-DIST2) 445,446,446                                          C 205
 445  DIST2=DIST                                                           C 206
      I4=I3                                                                C 207
      I3=I2                                                                C 208
      I2=JJ                                                                C 209
      GO TO 450                                                            C 210
 446  I4=I3                                                                C 211
      I3=JJ                                                                C 212
 450  CONTINUE                                                             C 213
C           CALCULATE ANGLE BETWEEN 2 CLOSEST POINTS TO FARTHEST CORNER.   C 214
      AD=SQRT((XC(I1)-XC(I2))*(XC(I1)-XC(I2))                              C 215
     1  + (YC(I1)-YC(I2))*(YC(I1)-YC(I2)))                                 C 216
      ANGLE=2.*ASIN(AD/(2.*R))                                            C 217
C         CALCULATE ANGLE BETWEEN 2 POINTS FARTHEST FROM                   C 218
C         FARTHEST CORNER AND ADD TO PREVIOUS ANGLE.                       C 219
      AD=SQRT((XC(I3)-XC(I4))*(XC(I3)-XC(I4))                              C 220
     1  +(YC(I3)-YC(I4))*(YC(I3)-YC(I4)))                                  C 221
      ANGLE=2.*ASIN(AD/(2.*R)) + ANGLE                                    C 222
 460  CONTINUE                                                             C 223
C        ANGLE FOR THIS RADIUS NOW KNOWN, CALCULATE RISK.                  C 224
C        COMPUTE RATE OF EARTHQUAKES IN THIS ANNULAR SOURCE                C 225
      ANAREA=ANGLE*R*STSIZE                                                C 226
      APPROX=APPROX+ANAREA                                                 C 227
      NTOT=NRS(INGS)+1                                                     C 228
      RATEI=RATE(INGS)*ANAREA*AREA(INGS,INSS)/AREA(INGS,NTOT)              C 229
C        CALCULATE CONTRIBUTION TO RISK                                    C 230
      DO 480 JJ=1,NLEI                                                     C 231
      IF (JCALC) 470,470,475                                               C 232
 470  CALL RISK1(TI(JJ),R,INGS,RISK)                                       C 233
      GO TO 478                                                            C 234
 475  CALL RISK2(TI(JJ),R,INGS,RISK)                                       C 235
 478  IF (RISK-0.0000000001) 500,490,490                                   C 236
 490  RSK(JJ)=RSK(JJ)+RISK*RATEI                                           C 237
 480  CONTINUE                                                             C 238
 500  CONTINUE                                                             C 239
      ARERR=((APPROX-AREA(INGS,INSS))/AREA(INGS,INSS))*100.                C 240
      IF (ARERR-5.) 510,520,520                                            C 241
 510  IF (ARERR+5.) 520,520,540                                            C 242
 520  WRITE(NWR,903) ARERR,INGS,INSS                                       C 243
 903  FORMAT(10X,'CAUTION= NUMERICAL INTEGRATION ERROR IN AREA IS ',       C 244
     1 F6.2,' ( FOR (OUTSIDE) SOURCE ',2I3)                                C 245
C          NORMALIZE BY COMPUTED (APPROXIMATE) AREA                        C 246
 540  DO 550 JJ=1,NLEI                                                     C 247
      RSK(JJ)=COEF(INGS)*RSK(JJ)/APPROX                                    C 248
 550  RSKTI(JJ)=RSKTI(JJ)+RSK(JJ)                                          C 249
 600  IF (JPRNT) 850,850,610                                               C 250
C         PRINT RISKS FOR THIS SOURCE                                      C 251
 610  WRITE(NWR,902) INGS,INSS,(RSK(I),I=1,NLEI)                           C 252
 902  FORMAT(' SOURCE',2I3,' E(NO/YR)= ',12E15.3)                          C 253
      GO TO 850                                                            C 254
C        ERROR PRINTOUT                                                    C 255
 800  WRITE(NWR,901)NERROR,INGS,INSS,IC,RC,XNOT,YNOT,(XL(I),YL(I),I=1,4)   C 256
     1 , R,ANGLE,RC,RF,(XC(I),YC(I),I=1,4)                                 C 257
 901  FORMAT(' ***** ERROR',I4,' IN SUBROUTINE OUTSID. SOURCE NO.',2I3,    C 258
     1' DEBUG VALUES FOLLOW.....',/10X,2I5,5(/10X,4F14.6))                 C 259
 850  RETURN                                                               C 260
      END                                                                  C 261
      SUBROUTINE RISK1(TIC,REPIS,INGS,RISK)                                D   1
      COMMON NRD,NWR,NLEI,TI(12),RSKTI(12)                                 D   2
      COMMON C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                               D   3
      COMMON NGS,NRS(20),AM0(21),AM1(21),LORS(21)                          D   4
      COMMON BETA(21),RATE(21),COEF(21),FDEPTH(21)                         D   5
      COMMON NSTEPO,NSTEPI,JCALC,JPRNT                                     D   6
      COMMON INDIC(4),AREA(20,11)                                          D   7
C                                                                          D   8
C          SUBROUTINE TO CALCULATE RISK WHEN THE FOLLOWING SPECIAL         D   9
C          FORM OF ATTENUATION FUNCTION IS USED=                           D  10
C               I = C1 + C2*M + C3*ALOG(R+RZERO)                           D  11
C                                                                          D  12
      SIGG=SIG                                                             D  13
      RFOC=SQRT(REPIS*REPIS + FDEPTH(INGS)*FDEPTH(INGS))                   D  14
      IF (RFOC-RONE) 10,10,20                                              D  15
  10  R=RONE                                                               D  16
C         IF DIFFERENT STANDARD DEVIATION INSIDE RADIUS RONE IS            D  17
C         DESIRED, SET SIGG TO THIS STANDARD DEVIATION HERE.               D  18
      GO TO 30                                                             D  19
  20  R=RFOC                                                               D  20
  30  RLN=ALOG(R+RZERO)                                                    D  21
C                                                                          D  22
C          IS THIS LOOSE OR STRICT SOURCEf                                 D  23
C          IF STRICT, RISK COMPUTED IS THAT FOR A SINGLE EARTHQUAKE        D  24
C          WITH (EXPONENTIALLY-DISTRIBUTED) RANDOM MAGNITUDE               D  25
C          (OR INTENSITY) BETWEEN AM0 AND AM1.  IF A LOOSE                 D  26
C          SOURCE, RISK COMPUTED IS THAT FOR 'ANEQ' EARTHQUAKES            D  27
C          WITH (EXPONENTIALLY-DISTRIBUTED) RANDOM MAGNITUDE               D  28
C          (OR INTENSITY) BETWEEN 0.0 AND AM1, WITH 'ANEQ' CALCULATED      D  29
C          SO THAT THE EXPECTED NUMBER OF EVENTS BETWEEN AM0 AND AM1       D  30
C          IS UNITY.                                                       D  31
C                                                                          D  32
      IF (LORS(INGS)) 40,40,50                                             D  33
  40  AK=1./(1.-EXP(-BETA(INGS)*AM1(INGS)))                                D  34
      ANEQ=1./(1.-AK+AK*EXP(-BETA(INGS)*AM0(INGS)))                        D  35
      AMZ=0.0                                                              D  36
      GO TO 60                                                             D  37
  50  AK=1./(1.-EXP(-BETA(INGS)*(AM1(INGS)-AM0(INGS))))                    D  38
      ANEQ=1.                                                              D  39
      AMZ=AM0(INGS)                                                        D  40
C          CALCULATE MAGNITUDE 'AMSTAR' ASSOCIATED WITH MAX. INTENSITY     D  41
C          AT THIS DISTANCE (R)' IF LESS THAN AM1, EVALUATE RISK           D  42
C          FOR MAGNITUDES BETWEEN AMSTAR AND AM1 SEPARATELY.               D  43
  60  AMSTAR=(AAA-C1-C3*RLN)/(C2-BBB)                                      D  44
      IF (AM1(INGS)-AMSTAR) 65,65,70                                       D  45
C         NONE OF MAGNITUDE INTEGRATION LIES ABOVE AMSTAR.                 D  46
  65  CALL ERISK(AMZ,AM1(INGS),C1,C2,C3,RLN,SIGG,BETA(INGS),TIC,           D  47
     1 G1,G2,G3,G4,CON1,CON2,CON3)                                         D  48
      GO TO 77                                                             D  49
  70  IF (AMZ-AMSTAR) 80,75,75                                             D  50
C         ALL OF MAGNITUDE INTEGRATION LIES ABOVE AMSTAR.                  D  51
  75  CALL ERISK(AMZ,AM1(INGS),AAA,BBB,0.,RLN,SIGG,BETA(INGS),TIC,         D  52
     1  G1,G2,G3,G4,CON1,CON2,CON3)                                        D  53
  77  RISK=((1.-AK)*G1 + AK*G2 + AK*(G3-G4)*CON1*CON2)*ANEQ                D  54
      GO TO 100                                                            D  55
C         SOME OF MAGNITUDE INTEGRATION LIES ABOVE MSTAR, SOME BELOW.      D  56
  80  CALL ERISK(AMZ,AMSTAR,C1,C2,C3,RLN,SIGG,BETA(INGS),TIC,              D  57
     1  G1,G2,G3,G4,CON1,CON2,CON3)                                        D  58
      CALL ERISK(AMSTAR,AM1(INGS),AAA,BBB,0.,RLN,SIGG,BETA(INGS),TIC,      D  59
     1  GG1,GG2,GG3,GG4,CCON1,CCON2,CCON3)                                 D  60
      RISK=((1.-AK)*G1 +AK*G2 +AK*(G3-G4)*CON1*CON2                        D  61
     1  +(1.-AK)*(GG1-GG2) + AK*(GG3-GG4)*CCON1*CCON2                      D  62
     2  *EXP(+BETA(INGS)*(AMZ-AMSTAR)))*ANEQ                               D  63
 100  RETURN                                                               D  64
      END                                                                  D  65
      SUBROUTINE ERISK(AMZ,AMM,C1,C2,C3,RLN,SIG,BETA,TIC,                  E   1
     1  G1,G2,G3,G4,CON1,CON2,CON3)                                        E   2
C         EVALUATE RISK ASSOCIATED WITH EXPONENTIAL MAGNITUDE LAW          E   3
C             FOR MAGNITUDES BETWEEN AMZ AND AMM.                          E   4
      Z=(TIC-C1-C2*AMM-C3*RLN)/SIG                                         E   5
      CALL NDTR(Z,G1,D)                                                    E   6
      Z=Z-BETA*SIG/C2                                                      E   7
      CALL NDTR(Z,G3,D)                                                    E   8
      Z=(TIC-C1-C2*AMZ-C3*RLN)/SIG                                         E   9
      CALL NDTR(Z,G2,D)                                                    E  10
      Z=Z-BETA*SIG/C2                                                      E  11
      CALL NDTR(Z,G4,D)                                                    E  12
      IF (C2-0.001) 10,10,20                                               E  13
  10  CON1=100000000.                                                      E  14
      CON3=CON1                                                            E  15
      GO TO 30                                                             E  16
  20  CON1=((BETA*BETA*SIG*SIG)/(2.*C2*C2))+(BETA*AMZ)                     E  17
     1 +((C1-TIC)*BETA/C2)                                                 E  18
      CON3=CON1+BETA*(AMM-AMZ)                                             E  19
      CON1=EXP(CON1)                                                       E  20
      CON3=EXP(CON3)                                                       E  21
  30  CON2=BETA*C3/C2                                                      E  22
      R=EXP(RLN)                                                           E  23
      CON2=R**CON2                                                         E  24
      RETURN                                                               E  25
      END                                                                  E  26
      SUBROUTINE RISK2(TIC,REPIS,INGS,RISK)                                F   1
      COMMON NRD,NWR,NLEI,TI(12),RSKTI(12)                                 F   2
      COMMON C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                               F   3
      COMMON NGS,NRS(20),AM0(21),AM1(21),LORS(21)                          F   4
      COMMON BETA(21),RATE(21),COEF(21),FDEPTH(21)                         F   5
      COMMON NSTEPO,NSTEPI,JCALC,JPRNT                                     F   6
      COMMON INDIC(4),AREA(20,11)                                          F   7
C  Attenuation choice:                                                     t0000
      COMMON /atten/ IATTE                                                 t0001
C                                                                          F   8
C         SUBROUTINE TO CALCULATE RISK WHEN AN ATTENUATION FUNCTION        F   9
C         NON-SEPARABLE IN M AND R IS USED, OR WHEN NON-EXPONENTIAL        F  10
C         DENSITY FUNCTION ON EARTHQUAKE SIZE IS USED, REQUIRING           F  11
C         NUMERICAL INTEGRATION ON MAGNITUDE.                              F  12
C                                                                          F  13
C         THE EXAMPLE GIVEN HERE IS A SEPARABLE FUNCTION OF M AND R,       F  14
C         FOR WHICH SUBROUTINE RISK1 WOULD ACTUALLY BE USED IN             F  15
C         CALCULATIONS.  IT IS USED HERE FOR DEMONSTRATION PURPOSES        F  16
C         ONLY.                                                            F  17
C                                                                          F  18
C         AMINT IS MAGNITUDE INTERVAL USED FOR NUMERICAL INTEGRATION.      F  19
C         NO. OF MAGNITUDE STEPS (E.G.(AM1-AM0)/AMINT) MUST BE             F  20
C         A WHOLE NUMBER.                                                  F  21
C                                                                          F  22
      AMINT=0.05                                                           F  23
      RISK=0.0                                                             F  24
      SIGG=SIG                                                             F  25
      RFOC=SQRT(REPIS*REPIS + FDEPTH(INGS)*FDEPTH(INGS))                   F  26
      IF (RFOC-RONE) 80,80,90                                              F  27
  80  R=RONE                                                               F  28
C         IF DIFFERENT STANDARD DEVVIATION INSIDE RADIUS RONE IS           F  29
C          DESIRED, SET SIGG TO THIS STANDARD DEVIATION HERE.              F  30
      GO TO 100                                                            F  31
  90  R=RFOC                                                               F  32
 100  IF (LORS(INGS)) 110,110,150                                          F  33
C         LOOSE SOURCE, COMPUTE APPROPRIATE RATE, ASSUMING                 F  34
C         LOWEST MAGNITUDE = 4.0.                                          F  35
 110  AK=1./(1.-EXP(-BETA(INGS)*(AM1(INGS)-4.0)))                          F  36
      ANEQ=1./(1.-AK+AK*EXP(-BETA(INGS)*(AM0(INGS)-4.0)))                  F  37
      AMZ=4.0                                                              F  38
      GO TO 200                                                            F  39
 150  AMZ=AM0(INGS)                                                        F  40
      ANEQ=1.                                                              F  41
      AK=1./(1.-EXP(-BETA(INGS)*(AM1(INGS)-AM0(INGS))))                    F  42
C            COMPUTE NUMBER OF INTEGRATION STEPS                           F  43
C            (STEPSIZE = AMINT MAGNITUDE UNITS).                           F  44
 200  NMAGS=(AM1(INGS)-AMZ)/AMINT +0.1                                     F  45
C           LOOP ON MAGNITUDE, IN STEPS OF AMINT MAGNITUDE UNITS           F  46
      DO 500 IMAG=1,NMAGS                                                  F  47
      AM=IMAG                                                              F  48
      AMAG=AMZ+AM*AMINT-(AMINT/2.)                                         F  49
C         CALCULATE PROBABILITY OF EARTHQUAKE IN THIS MAGNITUDE STEP       F  50
      AMAGP=AMAG + (AMINT/2.)                                              F  51
      AMAGM=AMAG - (AMINT/2.)                                              F  52
      PROB=AK*(EXP(-BETA(INGS)*(AMAGM-AMZ))                                F  53
     1  -EXP(-BETA(INGS)*(AMAGP-AMZ)))                                     F  54
C           CALCULATE MEAN INTENSITY FOR THIS MAGNITUDE (AND DISTANCE).    F  55
C                                                                          F  56
C----------  USER=  INSERT YOUR MEAN FUNCTION HERE -------                 F  57
      go to (11,12,13) IATTE                                               t1000
 11   AMEAN = C1 + C2*AMAG + C3*ALOG(R+RZERO)                              F  58
	  go to 111
C..Joyner and Boore attenuation relation                                   t0000
 12     AMEAN1 = -1.02 + 0.249 * AMAG - ALOG10(R) - 0.00255*R 
  	amean2 = 10 ** (amean1)
 	amean = alog (amean2)
      go to 111
C..Campbell (1985) relation (see Walt Silva, 1986)                         t0011
C       AMEAN = -3.327 + 0.75 * AMAG - 1.14 *                              t0012
C    +          ALOG(R + 0.0531 * EXP(0.658 * AMAG))                       t0013
C..Campbell (1988) relation (see Joyner and Boore, 1988)                   t0021
 13     AMEAN = -2.817 + 0.702 * AMAG - 1.20 *                             t0022
     +          ALOG(R + 0.0921 * EXP (0.584 * AMAG))                      t0023
        go to 111
C..Correction 1: 6.88 = log (973)  ; conversion to cm/sec**2               t0002
 111    AMEAN = AMEAN + 6.88                                               t0003
      IF (AMEAN-AAA-BBB*AMAG) 220,220,210                                  F  59
 210  AMEAN=AAA+BBB*AMAG                                                   F  60
 220  CONTINUE                                                             F  61
C         CALCULATE STANDARDIZED VARIABLE                                  F  62
      Z = (TIC-AMEAN)/SIGG                                                 F  63
C           CALCULATE PROBABILITY OF EXCEEDING INTENSITY OF INTEREST       F  64
C --------  USER = INSERT YOUR (COMPLEMENTARY CUMULATIVE)                  F  65
C                  PROBABILITY FUNCTION HERE -------                       F  66
      CALL NDTR (Z,G,D)                                                    F  67
C           ACCUMULATE RISK                                                F  68
 500  RISK = RISK + G*PROB                                                 F  69
      RISK=RISK*ANEQ                                                       F  70
      RETURN                                                               F  71
      END                                                                  F  72
      SUBROUTINE BETWEN(X1,Y1,X2,Y2,XP,YP,INDIC,IANS)                      G   1
C         SUBROUTINE TO DETERMINE IF (XP,YP) LIES BETWEEN                  G   2
C            (X1,Y1) AND (X2,Y2).                                          G   3
C                                                                          G   4
      IF(INDIC.LT.1.OR.INDIC.GT.2)GO TO 300                                G   5
C                                                                          G   6
      GO TO (100,200),INDIC                                                G   7
 100  IF (X1-XP) 110,410,120                                               G   8
 110  IF (X2-XP) 420,420,410                                               G   9
 120  IF (X2-XP) 410,420,420                                               G  10
 200  IF (Y1-YP) 210,410,220                                               G  11
 210  IF (Y2-YP) 420,420,410                                               G  12
 220  IF (Y2-YP) 410,420,420                                               G  13
C        ERROR RETURN                                                      G  14
 300  IANS=0                                                               G  15
      GO TO 500                                                            G  16
C        (XP,YP) LIES BETWEEN END POINTS, I.E. ON SOURCE BOUNDARY          G  17
 410  IANS=1                                                               G  18
      GO TO 500                                                            G  19
C        (XP,YP) DOESN'T LIE BETWEEN END POINTS, I.E. IT'S OUTSIDE SOURC   G  20
 420  IANS=-1                                                              G  21
 500  RETURN                                                               G  22
      END                                                                  G  23
      SUBROUTINE NDTR(X,P,D)                                               H   1
C         X  IS NO. OF STANDARDIZED NORMAL DEVIATES.                       H   2
C         P  IS COMP. CUMULATIVE VALUE (OUTPUT).                           H   3
C         D  IS DENSITY VALUE (OUTPUT)                                     H   4
      IF (X) 1,2,2                                                         H   5
   1  AX=-X                                                                H   6
      GO TO 3                                                              H   7
   2  AX=X                                                                 H   8
   3  IF (AX-6.0) 5,4,4                                                    H   9
   4  P=1.                                                                 H  10
      D=0.                                                                 H  11
      GO TO 6                                                              H  12
   5  T=1./(1.0+.2316419*AX)                                               H  13
      D=0.3989423*EXP(-X*X/2.0)                                            H  14
      P = 1.0 - D*T*((((1.330274*T - 1.821256)*T + 1.781478)*T -           H  15
     1  0.3565638)*T + 0.3193815)                                          H  16
   6  IF (X) 8,7,7                                                         H  17
   7  P=1.0-P                                                              H  18
   8  RETURN                                                               H  19
      END                                                                  H  20
      SUBROUTINE AREAS(X1,Y1,X2,Y2,X3,Y3,X4,Y4,AREA)                       I   1
C      SUBROUTINE TO CALCULATE AREA OF ARBITRARY QUADRILATERAL,            I   2
C      WHERE (X1,Y1) AND X4,Y4) ARE OPPOSITE CORNERS.                      I   3
C         LOCATE INTERSECTIONS OF DIAGONALS=                               I   4
      IF (X4-X1-0.001) 20,30,30                                            I   5
  20  IF (X4-X1+0.001) 30,30,25                                            I   6
  25  XX=X1                                                                I   7
      A2=(Y3-Y2)/(X3-X2)                                                   I   8
      YY=(XX-X3)*A2 +Y3                                                    I   9
      DIST1=Y4-Y1                                                          I  10
      IF (DIST1) 26,27,27                                                  I  11
  26  DIST1=-DIST1                                                         I  12
  27  DIST2=SQRT((X3-X2)*(X3-X2) + (Y3-Y2)*(Y3-Y2))                        I  13
      GO TO 100                                                            I  14
  30  IF (X3-X2-0.001) 50,70,70                                            I  15
  50  IF (X3-X2+0.001) 70,70,65                                            I  16
  65  XX=X3                                                                I  17
      A1=(Y4-Y1)/(X4-X1)                                                   I  18
      YY=(XX-X4)*A1+Y4                                                     I  19
      DIST2=Y3-Y2                                                          I  20
      IF (DIST2) 66,67,67                                                  I  21
  66  DIST2=-DIST2                                                         I  22
  67  DIST1=SQRT((X4-X1)*(X4-X1) + (Y4-Y1)*(Y4-Y1))                        I  23
      GO TO 100                                                            I  24
  70  A1=(Y4-Y1)/(X4-X1)                                                   I  25
      A2=(Y3-Y2)/(X3-X2)                                                   I  26
      XX=(Y2-Y1+A1*X1-A2*X2)/(A1-A2)                                       I  27
      YY=A1*(XX-X1) + Y1                                                   I  28
      DIST1=SQRT((X4-X1)*(X4-X1) + (Y4-Y1)*(Y4-Y1))                        I  29
      DIST2=SQRT((X3-X2)*(X3-X2) + (Y3-Y2)*(Y3-Y2))                        I  30
C          CALCULATE LENGTH OF SIDES OF SUB-TRIANGLE                       I  31
 100  SIDE1=SQRT((XX-X1)*(XX-X1) + (YY-Y1)*(YY-Y1))                        I  32
      SIDE2=SQRT((XX-X2)*(XX-X2) + (YY-Y2)*(YY-Y2))                        I  33
      SIDE3=SQRT((X1-X2)*(X1-X2) + (Y1-Y2)*(Y1-Y2))                        I  34
C          SOLUTION ACCORDING TO C.R.C. HANDBOOK UNDER                     I  35
C               'MENSURATION FORMULAE' AND 'TRIGONOMETRIC FORMULAE'        I  36
      SS=(SIDE1+SIDE2+SIDE3)/2.                                            I  37
      SINANG=2.*SQRT(SS*(SS-SIDE1)*(SS-SIDE2)*(SS-SIDE3))/(SIDE1*SIDE2)    I  38
      AREA=0.5*DIST1*DIST2*SINANG                                          I  39
      RETURN                                                               I  40
      END                                                                  I  41
      SUBROUTINE CIRCLE(RC,INGS,FRAREA,RSK)                                J   1
      COMMON NRD,NWR,NLEI,TI(12),RSKTI(12)                                 J   2
      COMMON C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                               J   3
      COMMON NGS,NRS(20),AM0(21),AM1(21),LORS(21)                          J   4
      COMMON BETA(21),RATE(21),COEF(21),FDEPTH(21)                         J   5
      COMMON NSTEPO,NSTEPI,JCALC,JPRNT                                     J   6
      COMMON INDIC(4),AREA(20,11)                                          J   7
      DIMENSION RSK(12)                                                    J   8
C         SUBROUTINE TO CALCULATE RISK FROM A CIRCULAR                     J   9
C         SOURCE WITH CENTER AR SITE, RADIUS RC.                           J  10
      NRC=RC                                                               J  11
C         CHOOSE STEP SIZE=                                                J  12
C              STEP SIZE = NSTEPI ULESS RESULTING STEP SIZE IS             J  13
C              LESS THAN ONE KILOMETRE, IN WHICH CASE RC+1                 J  14
C              STEPS ARE USED.                                             J  15
      IF (NRC-NSTEPI) 10,12,12                                             J  16
  10  NSTEPX=NRC+1                                                         J  17
      GO TO 14                                                             J  18
  12  NSTEPX=NSTEPI                                                        J  19
  14  ANSTEP=NSTEPX                                                        J  20
      DO 90 II=1,NSTEPX                                                    J  21
      AI=II                                                                J  22
      R=((AI-0.5)*RC)/ANSTEP                                               J  23
      ANAREA=6.2831853072 *R*RC/ANSTEP                                     J  24
      RATEI=RATE(INGS)*ANAREA*FRAREA                                       J  25
      DO 80 JJ=1,NLEI                                                      J  26
      IF (JCALC) 50,50,60                                                  J  27
  50  CALL RISK1(TI(JJ),R,INGS,RISK)                                       J  28
      GO TO 70                                                             J  29
  60  CALL RISK2(TI(JJ),R,INGS,RISK)                                       J  30
  70  RSK(JJ)=RSK(JJ)+RISK*RATEI                                           J  31
  80  CONTINUE                                                             J  32
  90  CONTINUE                                                             J  33
      RETURN                                                               J  34
      END                                                                  J  35
      SUBROUTINE INSIDE(XNOT,YNOT,INGS,INSS,XL,YL,XR,YR,AA,BB)             K   1
      COMMON NRD,NWR,NLEI,TI(12),RSKTI(12)                                 K   2
      COMMON C1,C2,C3,SIG,RZERO,RONE,AAA,BBB                               K   3
      COMMON NGS,NRS(20),AM0(21),AM1(21),LORS(21)                          K   4
      COMMON BETA(21),RATE(21),COEF(21),FDEPTH(21)                         K   5
      COMMON NSTEPO,NSTEPI,JCALC,JPRNT                                     K   6
      COMMON INDIC(4),AREA(20,11)                                          K   7
      DIMENSION XL(4),YL(4),XR(4),YR(4),AA(4),BB(4),XC(4),YC(4)            K   8
      DIMENSION RSK(10)                                                    K   9
C         SUBROUTINE FOR CALCULATING RISK WHEN SITE IS INSIDE              K  10
C                 SOURCE AREA.                                             K  11
C           REFER TO DOCUMENTATION FOR ALGORITHM USED TO CHOOSE            K  12
C                 NUMBER OF INTEGRATION STEPS.                             K  13
      DO 50 II=1,NLEI                                                      K  14
  50  RSK(II)=0.                                                           K  15
      APPROX=0.                                                            K  16
      RC2=10000000000.                                                     K  17
      RF2=0.                                                               K  18
C          FIND CLOSEST SIDE AND FARTHEST POINT                            K  19
      DO 160 II=1,4                                                        K  20
      IINDIC=INDIC(II)                                                     K  21
C                                                                          K  22
      IF(IINDIC.EQ.1) GO TO 120                                            K  23
C                                                                          K  24
 110  XS=XL(II)                                                            K  25
      YS=YNOT                                                              K  26
      GO TO 140                                                            K  27
C          IS SLOPE ZEROf                                                  K  28
 120  IF (AA(II)-0.001) 121,125,125                                        K  29
 121  IF (AA(II)+0.001) 125,125,122                                        K  30
 122  XS=XNOT                                                              K  31
      YS=YL(II)                                                            K  32
      GO TO 140                                                            K  33
C        SLOPE NOT ZERO                                                    K  34
 125  XS=(YNOT+(XNOT/AA(II))-BB(II))/(AA(II)+1./AA(II))                    K  35
      YS=((XNOT-XS)/AA(II))+YNOT                                           K  36
C          CALCULATE SQUARE OF DISTANCE BETWEEN SITE AND CLOSEST POINT.    K  37
 140  DIST=(XNOT-XS)*(XNOT-XS)+(YNOT-YS)*(YNOT-YS)                         K  38
      IF (DIST-RC2) 151,152,152                                            K  39
 151  RC=SQRT(DIST)                                                        K  40
      RC2=DIST                                                             K  41
      ICLO=II                                                              K  42
C          CALCULATE DISTANCE BETWEEN SITE AND LEFT HAND POINT ON SIDE     K  43
 152  DIST=(XNOT-XL(II))*(XNOT-XL(II))+(YNOT-YL(II))*(YNOT-YL(II))         K  44
      IF (RF2-DIST) 154,160,160                                            K  45
 154  RF=SQRT(DIST)                                                        K  46
      RF2=DIST                                                             K  47
      IFAR=II                                                              K  48
 160  CONTINUE                                                             K  49
C          DETERMINE AZIMUTH OF FARTHEST POINT WITH RESPECT TO SITE        K  50
      AZIMF=ACOS((XL(IFAR)-XNOT)/RF)                                      K  51
      IF (YL(IFAR)-YNOT) 162,164,164                                       K  52
 162  AZIMF=6.2831853072 - AZIMF                                           K  53
 164  CONTINUE                                                             K  54
C      RC IS NOW DISTANCE FROM SITE TO CLOSEST SIDE.                       K  55
C      RF IS NOW DISTANCE FROM SITE TO FARTHEST CORNER.                    K  56
      IF (RC-0.01) 200,200,170                                             K  57
C        CALL SUBROUTINE CIRCLE TO CALCULATE RISK FROM CIRCULAR            K  58
C            SOURCE WITH RADIUS RC                                         K  59
 170  NTOT=NRS(INGS)+1                                                     K  60
      FRAREA=AREA(INGS,INSS)/AREA(INGS,NTOT)                               K  61
      CALL CIRCLE(RC,INGS,FRAREA,RSK)                                      K  62
      APPROX=3.1415926536*RC*RC                                            K  63
C       LOOP ON R TO CALCULATE RISK FROM RC TO RF                          K  64
 200  AN=NSTEPI                                                            K  65
C        PICK STEP SIZE BASED ON FRACTION OF AREA LEFT                     K  66
      FRLEFT=(AREA(INGS,INSS)-APPROX)/AREA(INGS,INSS)                      K  67
      NSTEPX=FRLEFT*AN + 1.                                                K  68
      AN=NSTEPX                                                            K  69
      STSIZE=(RF-RC)/AN                                                    K  70
      DO 500 ISTEP=1,NSTEPX                                                K  71
      AI=ISTEP                                                             K  72
      R=RC+(AI-0.5)*STSIZE                                                 K  73
      NPT=0                                                                K  74
      ANGLE=0.                                                             K  75
C         LOOP ON EACH SIDE                                                K  76
      DO 400 II=1,4                                                        K  77
      IINDIC=INDIC(II)                                                     K  78
C                                                                          K  79
      IF(IINDIC.EQ.1) GO TO 330                                            K  80
C                                                                          K  81
C         SIDE II IS VERTICAL, DOES CIRCLE (RADIUS R) INTERSECT ITf        K  82
 320  A=XL(II)-XNOT                                                        K  83
      IF (A) 322,322,323                                                   K  84
 322  IF (R+A) 400,400,324                                                 K  85
 323  IF (R-A) 400,400,324                                                 K  86
C         COMPUTE 2 INTERSECTION POINTS                                    K  87
 324  X1=XL(II)                                                            K  88
      B=SQRT(R*R-(X1-XNOT)*(X1-XNOT))                                      K  89
      Y1=YNOT+B                                                            K  90
      X2=XL(II)                                                            K  91
      Y2=YNOT-B                                                            K  92
      GO TO 341                                                            K  93
 330  A=1.+AA(II)*AA(II)                                                   K  94
      B=2.*(-XNOT+AA(II)*(BB(II)-YNOT))                                    K  95
      C=XNOT*XNOT+YNOT*YNOT+BB(II)*(BB(II)-2.*YNOT)-R*R                    K  96
      D=B*B-4.*A*C                                                         K  97
      IF (D) 400,400,340                                                   K  98
C          THERE ARE 2 INTERSECTION, CALCULATE THEIR COORDINATES.          K  99
 340  D=SQRT(D)                                                            K 100
      X1=(-B+D)/(2.*A)                                                     K 101
      Y1=AA(II)*X1+BB(II)                                                  K 102
      X2=(-B-D)/(2.*A)                                                     K 103
      Y2=AA(II)*X2+BB(II)                                                  K 104
C          SEE IF (X1,Y1) IS ON BOUNDARY                                   K 105
 341  CALL BETWEN(XL(II),YL(II),XR(II),YR(II),X1,Y1,INDIC(II),IANS)        K 106
      IF (IANS) 350,342,345                                                K 107
 342  NERROR=4                                                             K 108
      GO TO 800                                                            K 109
C       IS SECOND POINT ALSO ON BOUNDARYf                                  K 110
 345  CALL BETWEN(XL(II),YL(II),XR(II),YR(II),X2,Y2,INDIC(II),IANS)        K 111
      IF (IANS) 348,346,360                                                K 112
 346  NERROR=5                                                             K 113
      GO TO 800                                                            K 114
C         STORE FIRST POINT ONLY                                           K 115
 348  NPT=NPT+1                                                            K 116
      XC(NPT)=X1                                                           K 117
      YC(NPT)=Y1                                                           K 118
      GO TO 400                                                            K 119
C        SEE IF SECOND POINT ONLY IS ON BOUNDARY                           K 120
 350  CALL BETWEN(XL(II),YL(II),XR(II),YR(II),X2,Y2,INDIC(II),IANS)        K 121
      IF (IANS) 400,352,354                                                K 122
 352  NERROR=6                                                             K 123
      GO TO 800                                                            K 124
 354  NPT=NPT+1                                                            K 125
      XC(NPT)=X2                                                           K 126
      YC(NPT)=Y2                                                           K 127
      GO TO 400                                                            K 128
C         TWO INTERSECTION POINTS ON ONE SIDE BOTH LIE ON BOUNDARY,        K 129
C          CALCULATE ANGLE BETWEEN THEM.                                   K 130
 360  CONTINUE                                                             K 131
 380  AD=SQRT((X1-X2)*(X1-X2)+(Y1-Y2)*(Y1-Y2))                             K 132
      ANGLE=2.*ASIN(AD/(2.*R))+ANGLE                                      K 133
 400  CONTINUE                                                             K 134
      IF (NPT) 402,404,408                                                 K 135
 402  NERROR=7                                                             K 136
      GO TO 800                                                            K 137
 404  IF (ANGLE-0.001) 402,406,406                                         K 138
C        FOLLOWING IS FOR CASE OF NO SINGLE INTERSECTION POINTS'           K 139
C        ANGLE IS 2 * PI - ANGLE CALCULATED SO FAR.                        K 140
 406  PANGLE=6.2831853072-ANGLE                                            K 141
      GO TO 460                                                            K 142
 408  IF(NPT.LT.1.OR.NPT.GT.4) GO TO 409                                   K 143
      GO TO(402,410,402,440),NPT                                           K 144
 409  CONTINUE                                                             K 145
      NERROR=8                                                             K 146
      GO TO 800                                                            K 147
C         2 INTERSECTION POINTS' DETERMINE AZIMUTHS.                       K 148
 410  IF (XC(1)-XNOT-R) 414,413,411                                        K 149
 411  IF (XC(1)-XNOT-R-0.001) 413,413,412                                  K 150
 412  NERROR=18                                                            K 151
      GO TO 800                                                            K 152
 413  AZIM1=0.0                                                            K 153
      GO TO 418                                                            K 154
 414  IF (XC(1)-XNOT+R) 415,416,417                                        K 155
 415  IF (XC(1)-XNOT+R+0.001) 412,416,416                                  K 156
 416  AZIM1=3.1415926536                                                   K 157
      GO TO 420                                                            K 158
 417  AZIM1=ACOS((XC(1)-XNOT)/R)                                          K 159
 418  IF (YC(1)-YNOT) 419,420,420                                          K 160
 419  AZIM1=6.2831853072  - AZIM1                                          K 161
 420  IF (XC(2)-XNOT-R) 424,423,421                                        K 162
 421  IF (XC(2)-XNOT-R-0.001) 423,423,422                                  K 163
 422  NERROR=19                                                            K 164
      GO TO 800                                                            K 165
 423  AZIM2=0.0                                                            K 166
      GO TO 428                                                            K 167
 424  IF (XC(2)-XNOT+R) 425,426,427                                        K 168
 425  IF (XC(2)-XNOT+R+0.001) 422,426,426                                  K 169
 426  AZIM2=3.1415926536                                                   K 170
      GO TO 430                                                            K 171
 427  AZIM2=ACOS((XC(2)-XNOT)/R)                                          K 172
 428  IF (YC(2)-YNOT) 429,430,430                                          K 173
 429  AZIM2=6.2831853072 -AZIM2                                            K 174
 430  PANGLE=AZIM2-AZIM1                                                   K 175
      IF (PANGLE) 431,439,435                                              K 176
 431  IF (AZIM1-AZIMF) 432,439,433                                         K 177
 432  PANGLE=6.2831853072 +PANGLE -ANGLE                                   K 178
      GO TO 460                                                            K 179
 433  IF (AZIMF-AZIM2) 432,439,434                                         K 180
 434  PANGLE=-PANGLE-ANGLE                                                 K 181
      GO TO 460                                                            K 182
 435  IF (AZIM2-AZIMF) 436,439,437                                         K 183
 436  PANGLE=6.2831853072 -PANGLE -ANGLE                                   K 184
      GO TO 460                                                            K 185
 437  IF (AZIMF-AZIM1) 436,439,438                                         K 186
 438  PANGLE=PANGLE-ANGLE                                                  K 187
      GO TO 460                                                            K 188
 439  NERROR=9                                                             K 189
      GO TO 800                                                            K 190
C        FOUR INTERSECTION POINTS (EACH ON A DIFFERENT SIDE).              K 191
C        DETERMINE ANGLE BY FINDING CLOSEST 2 INTERSECTIONS TO             K 192
C        FARTHEST CORNER, CALCULATE ANGLE BETWEN, AND ADD ANGLE            K 193
C        BETWEEN OTHER TWO INTERSECTIONS.                                  K 194
 440  DIST1=10000000000.                                                   K 195
      I1=0                                                                 K 196
      I2=0                                                                 K 197
      I3=0                                                                 K 198
      I4=0                                                                 K 199
      DO 450 JJ=1,4                                                        K 200
      DIST=(XL(IFAR)-XC(JJ))*(XL(IFAR)-XC(JJ))                             K 201
     1   +(YL(IFAR)-YC(JJ))*(YL(IFAR)-YC(JJ))                              K 202
      IF (DIST-DIST1) 442,444,444                                          K 203
 442  DIST2=DIST1                                                          K 204
      DIST1=DIST                                                           K 205
      I4=I3                                                                K 206
      I3=I2                                                                K 207
      I2=I1                                                                K 208
      I1=JJ                                                                K 209
      GO TO 450                                                            K 210
 444  IF (DIST-DIST2) 445,446,446                                          K 211
 445  DIST2=DIST                                                           K 212
      I4=I3                                                                K 213
      I3=I2                                                                K 214
      I2=JJ                                                                K 215
      GO TO 450                                                            K 216
 446  I4=I3                                                                K 217
      I3=JJ                                                                K 218
 450  CONTINUE                                                             K 219
C        CALCULATE ANGLE BETWEEN 2 CLOSEST POINTS TO FARTHEST CORNER       K 220
      AD=SQRT((XC(I1)-XC(I2))*(XC(I1)-XC(I2))                              K 221
     1  + (YC(I1)-YC(I2))*(YC(I1)-YC(I2)))                                 K 222
      PANGLE=2.*ASIN(AD/(2.*R))                                           K 223
C         CALCULATE ANGLE BETWEEN 2 FARTHEST POINTS FROM                   K 224
C         FARTHEST CORNER AND ADD TO PREVIOUS ANGLE.                       K 225
      AD=SQRT((XC(I3)-XC(I4))*(XC(I3)-XC(I4))                              K 226
     1 + (YC(I3)-YC(I4))*(YC(I3)-YC(I4)))                                  K 227
      PANGLE=2.*ASIN(AD/(2.*R))+PANGLE                                    K 228
C       ANGLE FOR THIS RADIUS IS NOW KNOWN, CALCULATE RISK                 K 229
 460  CONTINUE                                                             K 230
      ANAREA=PANGLE*R*STSIZE                                               K 231
      APPROX=APPROX+ANAREA                                                 K 232
      NTOT=NRS(INGS)+1                                                     K 233
      RATEI=RATE(INGS)*ANAREA*AREA(INGS,INSS)/AREA(INGS,NTOT)              K 234
C       CALCULATE CONTRIBUTION TO RISK                                     K 235
      DO 480 JJ=1,NLEI                                                     K 236
      IF (JCALC) 470,470,475                                               K 237
 470  CALL RISK1(TI(JJ),R,INGS,RISK)                                       K 238
      GO TO 478                                                            K 239
 475  CALL RISK2(TI(JJ),R,INGS,RISK)                                       K 240
 478  IF (RISK-0.0000000001) 500,490,490                                   K 241
 490  RSK(JJ)=RSK(JJ) +RISK*RATEI                                          K 242
 480  CONTINUE                                                             K 243
 500  CONTINUE                                                             K 244
      ARERR=((APPROX-AREA(INGS,INSS))/AREA(INGS,INSS))*100.                K 245
      IF (ARERR-5.) 510,520,520                                            K 246
 510  IF (ARERR+5.) 520,520,540                                            K 247
 520  WRITE (NWR,903) ARERR,INGS,INSS                                      K 248
 903  FORMAT(10X,'CAUTION= NUMERICAL INTEGRATION ERROR IN AREA IS ',       K 249
     1 F6.2,' ( FOR (INSIDE) SOURCE ',2I3)                                 K 250
 540  DO 550 JJ=1,NLEI                                                     K 251
      RSK(JJ)=COEF(INGS)*RSK(JJ)/APPROX                                    K 252
 550  RSKTI(JJ)=RSKTI(JJ)+RSK(JJ)                                          K 253
      IF (JPRNT) 850,850,610                                               K 254
C         PRINT RISKS FOR THIS SOURCE.                                     K 255
 610  WRITE(NWR,902) INGS,INSS,(RSK(I),I=1,NLEI)                           K 256
 902  FORMAT(' SOURCE',2I3,' E(NO/YR)= ',12E10.3)                          K 257
      GO TO 850                                                            K 258
C          ERROR PRINTOUT                                                  K 259
 800  WRITE(NWR,901)NERROR,INGS,INSS,IFAR,NPT,XNOT,YNOT,(XL(I),YL(I),      K 260
     1 I=1,4),RC,RF,R,PANGLE,(XC(I),YC(I),I=1,4)                           K 261
 901  FORMAT (' ***** ERROR',I4,' IN SUBROUTINE INSIDE. SOURCE NO.',       K 262
     1 2I3,' DEBUG VALUES FOLLOW......',/10X,2I10,10(/10X,2F12.6))         K 263
 850  RETURN                                                               K 264
      END                                                                  K 265

C***********************************888888888********************************* 
C                                                                               
c       PROGRAM  codaq                                                          
c                                                                               
c       By  Jens Havskov, 1985                                                        
c                                                                               
c       Calculates coda q and plots the filtered traces with envelope fits 
c                                                                               
c       Latest uppdate:                                                         
c       April 85: last uw version                                               
c       apr 90   by j.h. : uib adaption                                         
c       jul 92           : tektronics adoption                                  
c       aug 92           : combine qplot and invq to codaq, cut out
c                          multiple envelope inversion
c       nov 12 92        : dimension to 50000
c       nov 26           : increase dimension of q to 1000
c       jul 8 93 by jh   : version 3.0 ********************* 
c       jul 21           : xdrwvec to xdrwvec_old, use routines xt and vt
c       aug 23 93        : filenames to 80 char
c       oct 93           : moved to pc, bugs: wrong arg in call to timadd
c       nov 16           : error check s, enable use of all components
c       nov 17           ; error of s/n when plotting
c       jun 94           : remove dc before filter, fix weighting
c       dec 7            : include seidim
c       feb 95           :  ************** version 5.0*********************
c       may 95           : new seisinc common block
c                          new wsize
c       nov 1 95         : new seisinc routine
c       mar 25, 96       : adjust call filter to one or 2 passes
c       mar 26           : calculate average lapse times
c       aug 96           : only look for first wav file
c       aug 30           : write also filer codaq1.out
c       sep 5 96         : error when sending plot to laser
c       mar 1 97         : fix so components also used in mode with
c                          stations selected pr event, clean up a few things
c                          related to output and check for non blank input
c       mar 4            : more output fixing
c       dec 19           : fix so all waveform files can be used
c       mar 30, 1998     : reject data over a max count value to reject 
c                          clipped data, check in coda window, increase to 30
c                          stations, calculate average correlation coeffecient
c       nov 98 jh        :   -----------   version 7.0 check ---------------
c                          year 2000, one_line to oneline, 5 char stat
C                                                                               
C      mar 22 99  bmt     : include winplot.inc                                                                            
c      sep 7 99 jh       : bug in graphics error message
c      sep 15            : pause before stop on pc
c      may 2000 jh       : new waveform struecture
c      may 18            : small bug
c      oct 25            : high accuracy, still one 4 char station
c      jan 5, 2001       : variable time scale, SEISAN.DEF was not read in,
c                          remove dc before plot
c      mar19             : variable cof was not an array, crash on pc
c      april 26          : optinally use center frequecy, new clipping routine
c      jun 20 2005  jh   : plt tp eps
C
c       implicit none  ! comment for pc 
       include 'winplot1.inc'
       include 'seidim.inc'
       include 'waveform.inc'
       include 'seiplot.inc'
c--- event name from SEISAN data base
	character*80 eventid  
        character*80   trace_file  ! trace file name                                                  
c--- help strings
	character*80 head80                                         
	character*120 headp                                                     
	character*80 head                                                       
c-- text from control file
	character*39 text
c-- min s/n ratio 
	real minratio
	character*5 station(30)
	character*4 component(30),dummy                                     
c-- dc level
	real dc
c-- date and time
	character*18 date,date1                                                      
	real flag(3),mincorr                                                    
c-- number of good q values each frequency
	integer nq(10)
	real av_corr(10),sd_corr(10)
c-- q-values saved at each frequency
	real qall(10,500)
      real tcoda_all(5000)   ! lapse times
      real corr_all(10,5000) ! correlation coefficient
      integer ntcoda         ! number of lapse times
      real av, sd            ! average and standard deviation
c-- noise and signals used
      dimension xnoise(5000),xsignal(max_sample)                                  
      character*80 message(5)   ! messages in graphics
      CHARACTER NAME*80                                                       
      REAL WLEN                                                
      REAL FRE(10),BAND(10)                                             
      real noctave              ! ovtave width of filter
      REAL RR,FQ1,FQ2                                                       
      INTEGER nrate                                                           
      INTEGER NN,K                                                              
      logical clipped     ! true if clipped signals
	logical sun,pc,linux
	integer check                                                           
c--parameters used in xtek library                                              
	integer ny,nx,nstep,i,nfreq,ndefsta,nsta,ista,ierr,
     *  idepth,
     *  ifr,ntotal,nnoise,nss,irms,iratio,iq,isec,nsignal,nstart
      real start,absstart,cs,wout,tp,tcoda,tstart,depth,t0,
     *  x0,y0,s,q,tnoise,del,rms,corr,trms,ratio,tt,g,xsignal,       
     *  xnoise,smag,cof(8)
c
        real xsc      ! xscale in tek units/sec
        integer maxcount  ! max count to use trace
	  character*80 answer

										
      include 'version.inc'
c -----------------------------------------------------------------             
         include 'winplot2.inc'


c
c print version
c
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

      call computer_type(sun,pc,linux)
      call get_seisan_def

c                                                                               
c       Definition of some variables:                                           
c                                                                               
c       NN:      counter of points in various arrays                            
c       nx:      number of plots in x direction                                 
c       ny:      number of plots in y direction                                 
c       nstep:   every nstep samples are plotted                                
c                                                                               
										
c                                                                               
c set plotter to postscript                                                     
c                                                                               
										
c--- set plotter to postscript                                                     
       hctype=1                                                                
c---unit for plot file
       plotunit=65
c---initial xwindow size
      wsize=70
c---display not yet open
      disp_open=0
c                                                                               
	ny=1                                                                   
	nx=1                                                                    
	nstep=4                                                                 
        check=0                       
      ntcoda=0                                          
c
c  initialize counter for q
c
	do i=1,10
	  nq(i)=0
	enddo
c                                                                               
       write(6,*)' No plot, only Q-calculation (0) '                            
       write(6,*)' Plot on screen              (1) '                            
       write(6,*)' Plot on screen+laser        (2) '                            
       write(6,*)' Plot on laser               (3) '                            
       read(5,*) plotoption                                                     
       plotoption=plotoption-1                                                  
       if(plotoption.gt.0) then                                                  
	      open(65,file='codaq.eps',status='unknown')                            
	      plotunit=65                                                           
       endif                                                                    
										
c
c   open output file with results and error messages
c
       open(3,file='codaq.out',status='unknown')
       open(4,file='codaq1.out',status='unknown')
       WRITE(6,*)'Parameter file, codaq.par is default (return)'                
       READ (*,'(a)') NAME                                                    
       if(name(1:2).eq.'  ') name='codaq.par'                                  
C                                                                               
c   open parameter filer giving specs for processing                           
C                                                                               
	OPEN(UNIT=1,FILE=NAME,STATUS='OLD')                                     
c                                                                               
c   read parameters shared by all data sets                                     
c   each data line is separated by a comment line read by text                
c                                                                               
	read(1,'(a)') text
	read(1,*) start
	write(3,'(1x,a39,f10.2)') text,start
	write(4,'(1x,a39,f10.2)') text,start
	read(1,'(a)') text
	read(1,*) absstart
	write(3,'(1x,a39,f10.2)') text,absstart
	write(4,'(1x,a39,f10.2)') text,absstart
	read(1,'(a)') text
	read(1,*) wlen
	write(3,'(1x,a39,f10.2)') text,wlen
	write(4,'(1x,a39,f10.2)') text,wlen
	read(1,'(a)') text
	read(1,*) rr
	write(3,'(1x,a39,f10.2)') text,rr
	write(4,'(1x,a39,f10.2)') text,rr
	read(1,'(a)') text
	read(1,*) cs
	write(3,'(1x,a39,f10.2)') text,cs
	write(4,'(1x,a39,f10.2)') text,cs
	read(1,'(a)') text
	read(1,*) minratio
	write(3,'(1x,a39,f10.2)') text,minratio
	write(4,'(1x,a39,f10.2)') text,minratio
	read(1,'(a)') text
	read(1,*) tnoise,trms
	write(3,'(1x,a39,2f10.2)') text,tnoise,trms
	write(4,'(1x,a39,2f10.2)') text,tnoise,trms
	read(1,'(a)') text
	read(1,*) mincorr
	write(3,'(1x,a39,f10.2)') text,mincorr
	write(4,'(1x,a39,f10.2)') text,mincorr
	read(1,'(a)') text
	read(1,*) maxcount
	write(3,'(1x,a39,i10)') text,maxcount
	write(4,'(1x,a39,i10)') text,maxcount
	read(1,'(a)') text
	read(1,*) nfreq
	read(1,'(a)') text
	do 2 i=1,nfreq
	   read(1,*) fre(i),band(i)
 2      continue
	read(1,'(a)') dummy
c                                                                               
c   read line containing up to 30 default stations to use with all events,      
c   used only if no station names are supplied with the                
c   pick file names. Components can be given in next line, if not there
c   use default S  Z                                                             
c               
c   MAKE SURE ALL ARRAYS CONTAIN BLANKS IF NO STATIONS OR COMPONENTS
C
	do i=1,30
	   station(i)=  '     '
	   component(i)='    '
	enddo
	read(1,'(30a5)',end=363)     (station(i),i=1,30)                                    
	read(1,'(30(a4,1x))',end=364) (component(i),i=1,30)
        goto 365
c
 363    continue
        do i=1,30
          station(i)='     '
          component(i)='    '
        enddo
 364    continue
        do i=1,30
          component(i)='    '
        enddo
 365    continue
c                                                                               
c   find how many default stations there are, check for non printable
c   characters, particular ctl z soemtimes seem to sneek in on pc's                                    
c                                                                               
	 ndefsta=0                                                               
	 do i=1,30   
       do k=1,5
          if(ichar(station(i)(k:k)).lt.32) station(i)(k:k)=' '
       enddo 
       do k=1,4
          if(ichar(component(i)(k:k)).lt.32) component(i)(k:k)=' '
       enddo                                                            
	   if(station(i).eq.'     ') go to 177                                    
	   ndefsta=ndefsta+1                                                     
	  enddo                                                                   
 177  continue                                                                
	  close(1)                                                      
      if(ndefsta.gt.0) then          
c
c   check for component
c
        do i=1,ndefsta
           if(component(i).eq.'    ') component(i)='S  Z'
        enddo
        write(4,'(30a5)') (station(i),i=1,30)                                 
        write(3,'(30a5)') (station(i),i=1,30)                                 
        write(3,'(30(a4,1x))') (component(i),i=1,30)
        write(4,'(30(a4,1x))') (component(i),i=1,30)
      endif
c
c   set x-scale as a function of window length
c                                                                               
       xsc=60.0/wlen

c   open file with specs of event station combinations                          
c   read until eof                                                              
c                                                                               
	write(6,*)                                                              
     *  'File with event-stations, name codaq.inp is default (return)'         
	read(5,'(a)') name                                                      
	if(name(1:2).eq.' ') name='codaq.inp'                                   
	open(2,file=name,status='old')                                          
c                                                                               
c   open and position plot                                                      
c                                                                               
	if(plotoption.ge.0)  then 
	    call open_display
	endif

C-----------------------------------------------------------------------
C
C   reading loop for events to process starts her **********************        
C                                                                               
c-----------------------------------------------------------------------
c
 3      CONTINUE                                                                     
C                                                                               
C   Read new event ID from file until eof.                                      
C   The event ID might be followed by up to 30 station                          
C   names (next line), if no station name, use default stations given           
C   in parameter file                                                          
C                                                                               
	nsta=ndefsta                                                            
	read(2,'(7x,a80)',end=99) eventid                                       
	if(eventid(1:10).eq.'          ') goto 99 ! trap blank line
        if(check.eq.1) write(3,*)'ndefsta',ndefsta
	if(ndefsta.eq.0) then                                                   
  	   do i=1,30
	      station(i)='     '
	      component(i)='    '
	   enddo
	   read(2,'(30a5))',end=99) (station(i),i=1,30)                         
	   read(2,'(30(a4,1x)))',end=99) (component(i),i=1,30)                         
c                                                                               
c   find how many stations there are for that event                             
c                                                                               
	   nsta=0                                                               
	   do 6 i=1,30                                                          
	     if(station(i).eq.'     ') go to 7                                   
             if(component(i).eq.'    ') component(i)='S  Z'
	     nsta=nsta+1                                                        
 6         continue                                                              
 7         continue                                                             
           if(check.eq.1) write(3,'(i5,1x,30a5)') nsta,station                  
	endif                                                                   
c                                                                               
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc              
c                                                                c              
c   station loop for this event starts here   DO 21              c              
c                                                                c              
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc              
c                                                                               
	do 21 ista=1,nsta                                                       
	nn=0                                                                    
C                                                                               
C   now enter data in seisan format, first increase window length              
C   by 2 secs since last 2 secs can give problems, are cut out later            
C   anyway.                                                                     
C                                                                               
	wout=wlen+2                                                             
	call codaselect                                                         
     *  (eventid,station(ista),component(ista),
     *  start,absstart,wout,3,date,tp,             
     *  tcoda,tstart,nn,nrate,ierr,6,plotoption,trace_file)

        if(check.eq.1) write(3,*)'codaselect',trace_file
        if(check.eq.1) write(3,*)'nrate',nrate
C                                                                               
c                                                                               
c   check for errors                                                            
C              
      if(check.eq.1) write(3,*)' errors after calling codaselect',ierr
      if(ierr.ne.0) then                                                      
	    if(plotoption.eq.0.or.plotoption.eq.1) then
	       write(message(1),700) ' Data missing ',
     *         eventid(1:50),station(ista)                              
               call xmessage(message,1,80,50.0,50.0)
	    else
	      write(6,700) ' Data mising ',eventid(1:80),station(ista)
 700          format(1x,a,1x,a,1x,a5)                                     
	    endif
	    write(3,700) ' Data missing ',eventid,station(ista)                              
	    go to 21                                                             
	  endif
c
      ierr=0
c
c  check if no data saturation in coda window, check max value first                            
c
      k=0
      do i=tstart*nrate+1,(tstart+wlen)*nrate
         k=k+1
         wav_y1(k)=signal1(i)                  ! save for second clip test
         if(abs(signal1(i)).ge.maxcount) then
	       if(plotoption.eq.0.or.plotoption.eq.1) then
	          write(message(1),700) ' Data clipped ',
     *        eventid(1:50),station(ista)                              
	          call xmessage(message,1,80,50.0,50.0)
	        else
	          write(6,700) ' Data clipped ',
     *        eventid,station(ista)
  	        endif
	        write(3,700) ' Data clipped ',eventid,station(ista)         
	        go to 21
         endif
      enddo                                                             
c
c   second clip test
c
         call check_clipped(wav_y1,k,clipped)
         if(clipped) then
               if(plotoption.eq.0.or.plotoption.eq.1) then
                  write(message(1),700) ' Data clipped ',
     *            eventid(1:50),station(ista)
                  call xmessage(message,1,80,50.0,50.0)
                else
                  write(6,700) ' Data clipped ',
     *            eventid,station(ista)
                endif
                write(3,700) ' Data clipped ',eventid,station(ista)
                go to 21
         endif

c
c   first plot unfiltered data with coda window indicated,                      
c   here always start at left hand side, nx=1                                   
c                                                                               
	 nx=1                                                                   
	 if(plotoption.ge.0) then                                               
	    if(ny.gt.9) then                                                    
	                                                                        
	      ny=1                                                              
	     if(plotoption.ne.2.and.plotoption.ne.-1) then 
 		    text(1:39)=' Return to get next plot, q to quit    '
		    call oneline(text,39,answer,2,300.0,50.0)
		    if(answer(1:1).eq.'q'.or.answer(1:1).eq.'Q') goto 199
	     endif
         if(plotoption.ge.1) then
  	         call close_post
		     close(65)
			 if(plotoption.ne.2.and.plotoption.ne.-1) 
     *       call clear_to_alpha
		     call send_plot('codaq.eps',9)
		     open(65,file='codaq.eps',status='unknown')
	      endif
		 
	     call open_display
	    endif                                                               
	  endif                                        
c
c   output which wav file
c
      if(plotoption.eq.1.or.plotoption.eq.0) then
	    write(message(1),'(1x,a)')trace_file(1:70)
	    call xmessage(message,1,80,50.0,50.0)
      else
	    write(6,'(1x,a)')trace_file
      endif
      write(3,'(1x,a)')trace_file
                         
c                                                                               
c   extract origin time t0 relative to time of first sample                     
c                                                                               
	 t0=tstart-tcoda                                                        
c                                                                               
c   get depth and magnitude from pick file                                      
c                                                                               
	 open(17,file=eventid,status='old')                                     
	 read(17,'(38x,f5.2,13x,f3.1)') depth,smag                              
	 close(17)                                                              
	 idepth=depth                                                           
	 do i=1,80                                                              
	    head80(i:i)=' '                                                     
	 enddo
	 do i=1,120
	    headp(i:i)=' '                                                      
	 enddo                                                                  
	 write(head80,207)                                                      
     *   station(ista),component(ista),
     *   date(1:14),idepth,smag,                                  
     *   tp,tcoda,wlen,start                                                    
 207     format(a5,a4,1x,a14,1x,'H=',i3,2x,'M=',f3.1,1x,                     
     *   1x,'TP=',f5.1,2x,'TC=',                                                
     *   f6.1,2x,'WIN=',f6.1,2x,'ST=',f4.1)                                     
c                                                                               
c   small tricks to make post script header nicer                                
c                                                                               
	 write(headp,217)                                                       
     *   station(ista),component(ista),date(1:4),
     *    date(5:8),date(9:12),date(13:14)               
     *   ,idepth,smag,                                                          
     *   tp,tcoda,wlen,start                                                    
 217     format(a5,a4,1x,a4,2x,a4,2x,a4,
     *   2x,a2,4x,'H=',i3,4x,'M=',f3.1,4x,          
     *   4x,'TP=',f5.1,4x,'TC=',                                                
     *   f6.1,4x,'WIN=',f6.1,4x,'START=',f4.1)                                  
	 if(plotoption.eq.2.or.plotoption.eq.-1)                                
     *   write(6,'(/,1x,a)') head80                                             
	 flag(1)=tstart                                                         
	 flag(2)=tstart+wlen                                                    
	 flag(3)=t0                                                             
         if(check.eq.1) write(3,*)'call trace plot first time'          
	 x0=1
	 x0=10.0+(nx-1)*350                                                     
	 y0=780.0-ny*85.0                                                       
c
c   remove dc
c
c         call remove_dc(signal1,nn,dc,nn)
c                                                                               
c   now plot                                                                    
c                                                                               
	 if(plotoption.ge.0) call traceplot                                     
     *   (x0,y0,0.0,1000.0,0.0,58.0,nn-2*nrate,                                 
     *   signal1,0.0,xsc,nrate,nstep,head80,headp,3,flag,                      
     *   0,s,tcoda,rr,1.0,q,date)                                               
c
	 ny=ny+1   ! next plot posiiton one down
c
         if(check.eq.1)write(3,*)' traceplot called'                            
	 nnoise=tnoise*nrate                                                    
	 nsignal=(wlen+2)*nrate                                                 
	 nstart=tstart*nrate                                                    
c
c   check that not too much data has been selected
c
      if(nstart+nsignal.gt.nn) then
	 if(plotoption.eq.0.or.plotoption.eq.1) then
	    write(message(1),'(a)')' Window too long, skip trace'
	    call xmessage(message,1,80,50.0,50.0)
	 else
	    write(6,*)' Window too long, skip trace'
	 endif
	 write(3,*)' Window too long, skip trace'
	 
	 goto 21 
      endif
c
	 nn=nnoise+nsignal                                                      
	 del=1000.0/float(nrate)                                                
	 y0=y0-150.0                                                            
c                                                                               
c   position new series of  filtered plots                                      
c                                                                               
	   if(plotoption.ge.0) then                                             
	      if(ny.gt.9) then                                                  
		nx=1                                                            
		ny=1                                                            
		if(plotoption.ne.2.and.plotoption.ne.-1) then 
		   text(1:39)=' Return to get next plot, q to quit    '
		   call oneline(text,39,answer,2,300.0,50.0)
		   if(answer(1:1).eq.'q'.or.answer(1:1).eq.'Q') goto 199
		endif

                if(plotoption.ge.1) then
                  call close_post
                  close(65)
                  if(plotoption.ne.2.and.plotoption.ne.-1) 
     *            call clear_to_alpha
                  call send_plot('codaq.eps',9)
                  open(65,file='codaq.eps',status='unknown')
               endif
               call open_display
             endif                                                             
	  endif                                                                 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc               
c                                                               c               
c   go through filter and plotting loop                         c               
c                                                               c               
	  do 30 ifr=1,nfreq                                                     
c                                                               c               
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc               
C                                                                               
C   CALCULATE FILTER COEFFICIENTS                                               
C                                                                               
c
c   linear band, if band is negative 
c
       if(band(ifr).lt.0.0) then
          FQ2=FRE(ifr)-BAND(ifr)/2.                                            
          FQ1=FRE(ifr)+BAND(ifr)/2.  
       else
          FQ1=FRE(ifr)-BAND(ifr)/2.                                            
          FQ2=FRE(ifr)+BAND(ifr)/2.  
       endif
c
c
c   geometric center frequncy is FRE, only use if band is positive
c
       if(band(ifr).gt.0.0) then
          noctave= (alog10(fq2)-alog10(fq1))/alog10(2.0)
          fq1=(-band(ifr)+sqrt(band(ifr)*band(ifr)+4.0*fre(ifr)*
     *         fre(ifr)))/2.0
          fq2=fq1+band(ifr)
c           write(3,*) fq1,fq2
       endif
c
c   check if frequency too high
c
       if(fq2.ge.nrate/2.0) then
	   write(6,*)' Too high filter frequncy ****** ',fq2
	   write(3,*)' Too high filter frequncy ****** ',fq2
	   goto 30
       endif                                          
       CALL BNDPAS(FQ1,FQ2,DEL,COF,G)                                       
c                                                                               
c   now filter whole signal 
c                                                                               
	  ntotal=nstart+nsignal                                                 
	     do 12 i=1,ntotal                                                   
		xsignal(i)=signal1(i) ! put in new array to not overwrite                                            
 12          continue
             if(check.eq.1)write(3,*)'xsig',(xsignal(i),i=1,10)
	     call remove_dc(xsignal,ntotal,dc,ntotal)
             if(check.eq.1)write(3,*)'dc',(xsignal(i),i=1,10)
             call filter(xsignal,ntotal,cof,g,2)
             if(check.eq.1) write(3,*)'signal selected,ntotal',ntotal
             if(check.eq.1)write(3,*)'filt',(xsignal(i),i=1,10)
c
c   save noise
c
	     do 13 i=1,nnoise                                                   
		xnoise(i)=xsignal(i)                                            
 13          continue
c
c   save coda signal
c                                                           
	     do 14 i=1,nsignal                                                  
		xsignal(i)=xsignal(i+nstart)                                    
 14          continue                                                           
c                                                                               
c   calculate q                                                                 
c
	   nss=nsignal-nrate*2
           if(check.eq.1) write(3,*) 'call codaq,nss',nss
           if(check.eq.1) write(3,*)(xsignal(i),i=1,10)
	   call codaq                                                           
     *     (nss,1,tcoda,xsignal,nrate,fre(ifr),rr,s,q,rms,corr)                 
	   iq=q+0.5
           if(check.eq.1) write(3,*)'codaq called',q
c                                                                               
c   determine signal to noise raa trms  ec ris sec window                       
c   using the first trms secs of noise and last trms secs of the                   
c   coda signal                                                                 
c                                                                               
c           trms=5.0                                                             
	   irms=trms*nrate
c                  check=9
c                  if(check.eq.9) then
c                      write(19,*)'irms',irms,'nsignal=',nsignal
c                          write(19,*) 'signal'
c                          write(19,*)(xsignal(i),i=1,100)                                                      
c                          write(19,*)'noise'
c                          write(19,*) (xnoise(i),i=1,100)
c                  endif
	   call sn                                                              
     *     (irms,nsignal-2*nrate-irms,xsignal,1,xnoise,ratio)                 
c                                                                               
c   join noise and coda signals for plotting
c             
	   do i=nsignal,1,-1
	      xsignal(i+nnoise)=xsignal(i)
	   enddo
	   do i=1,nnoise
	      xsignal(i)=xnoise(i)
	   enddo                                                                  
c           do 17 i=1,nsignal
c              xnoise(i+nnoise)=xsignal(i)                                       
c 17        continue                                                             
c                                                                               
c   plot trace, first position plot window                                      
c                                                                               
	 if(plotoption.ge.0) then                                               
	     if(nx.eq.4) then                                                   
	     nx=1                                                               
	     ny=ny+1                                                    
      
	     if(ny.gt.9) then                                                   
		nx=1                                                            
		ny=1                                                            
		 call close_post
c   new page                                                             
c		if(plotoption.ge.1)then
c		   close(65)
c		   call send_plot('codaq.eps',9)
c		   open(65,file='codaq.eps',status='unknown')
c		endif
		if(plotoption.ne.2.and.plotoption.ne.-1) then
		   text(1:39)=' Return to get next plot, q to quit    '
		   call oneline(text,39,answer,2,300.0,50.0)
		   if(answer(1:1).eq.'q'.or.answer(1:1).eq.'Q') goto 199
c		   call open_display
		endif
c
         if(plotoption.ge.1) then
  	         call close_post
		     close(65)
			 if(plotoption.ne.2.and.plotoption.ne.-1) 
     *       call clear_to_alpha
		     call send_plot('codaq.eps',9)
		     open(65,file='codaq.eps',status='unknown')
	      endif
  	      call open_display
	     endif                                                              
	   endif                                                                
	 endif                                                                  
	 iratio=ratio                                                           
	 if(iq.ge.9999.or.iq.lt.0) iq=0                                         
	 do 333 i=1,80                                                          
	    head(i:i)=' '                                                       
	    headp(i:i)=' '                                                      
 333     continue                                                               
	 write(head,202)fre(ifr),iq,corr,iratio                                 
 202     format(f4.1,1x,'Q=',i4,1x,'C',f4.2,' SN',i3)                           
	 write(headp,292)fre(ifr),iq,corr,iratio                                
 292     format('F=',f4.1,4x,'Q=',i4,4x,'CO=',f4.2,4x,' S/N=',i3,'  ')          
	 flag(1)=tnoise                                                         
c
c   save good q-values
c
	 if((q.gt.0.1.and.q.lt.10000).and.abs(corr).ge.mincorr.
     *       and.ratio.ge.minratio) then
         ntcoda=ntcoda+1
         tcoda_all(ntcoda)=tcoda             ! save lapse time
	     nq(ifr)=nq(ifr)+1
	     qall(ifr,nq(ifr))=q
         corr_all(ifr,nq(ifr))=abs(corr)     ! save correlation coefficient
	     write(3,270)date(1:14),station(ista),tcoda,
     *       fre(ifr),ratio,
     *       iq,corr,rms
 270         format(2x,a14,1x,a5,
     *       ' tc',f6.1,2x,'f ',f4.1,2x,
     *       's/n',f5.1,2x,'Q ',i4,2x,'corr ',
     *       f5.2,2x,'rms ',f4.2)
	 endif 
	 if(plotoption.eq.2.or.plotoption.eq.-1)                                
     *   write(6,'(1x,a40)') headp(1:40)                                        
c                                                                               
         if(check.eq.1) write(3,*)' traceplot called, noise:',nnoise            
	 x0=10.0+(nx-1)*350                                                     
	 y0=780.0-ny*85.0                                                       
c                                                                               
c   fix sec in date so plot axis time is ok, find second value                  
c   of plot start time remebering to correct for noise in front                 
c   note ,hr and min might not be right                                         
c                                                                               
	 if(ifr.eq.1) then                                                      
	    date1=date
	    read(date,'(12x,f6.3)') tt                                          
ctest            write(37,*)tt                                                  
	    tt=tt+tstart-tnoise                                                 
	    isec=tt                                                             
	    tt=tt-isec                                                          
	    isec=mod(isec,60)                                                 
	    tt=tt+isec                                                          
	    write(date1(13:18),'(f6.3)') tt                                    
ctest            write(37,*) tt,tstart,tnoise                                   
	 endif                                                                  
	 if(plotoption.ge.0) call traceplot                                     
     *   (x0,y0,0.0,300.0,0.0,58.0,nn-2*nrate,                                  
     *   xsignal,0.0,xsc,nrate,nstep,head,headp,1,flag,                       
     *   nnoise,s,tcoda,rr,fre(ifr),q,date1)                                    
	 nx=nx+1                                                                
c
c                                                                               
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc                  
c                                                            c                  
c                      END OF FREQUENCY LOOP                 c                  
 30     continue                                                                
c                                                            c                  
c                                                                               
c  move down one trace                                                          
c                                                                               
      ny=ny+1                                                                   
c                                                                               
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc                  
c                                                                               
c                      END OF STATION LOOP                   c                  
 21     continue                                                                
c                                                            c                  
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc                  
c                                                                               
										
										
c                                                                               
c   back for next event station combination,                                    
c   make sure that next event starts on a new page                              
c                                                                               
	 ny=10                                                                  
	 go to 3                                                                
c                                                                               
c   here after all loops                                                       
c
 99   continue										
	if(plotoption.ne.2.and.plotoption.ne.-1) then 
	    text(1:39)=' Return to continue                    '
	    call oneline(text,39,answer,2,300.0,50.0)
	endif
 199     continue                                                                
c
c   write frequencies and bands used in output file
c
	write(3,*)
	write(3,*)
	write(3,'(a6,8f9.2)')' Freq ',(fre(i),i=1,nfreq)
	write(3,'(a6,8f9.2)')' Band ',(band(i),i=1,nfreq)
	write(4,*)
	write(4,*)
	write(4,'(a6,8f9.2)')' Freq ',(fre(i),i=1,nfreq)
	write(4,'(a6,8f9.2)')' Band ',(band(i),i=1,nfreq)
c
c   close plot
c

	if(plotoption.ge.0) then 
	   if(plotoption.ne.2) call clear_to_alpha
c	   if(plotoption.eq.2) call close_post
	   if(plotoption.ge.1) then 
	     call close_post
	     close(65)
	     call send_plot('codaq.eps',9)
	  endif
	endif
c
c   calculate average q
c
	call output(0,nq,qall,nfreq,fre,cs)

c
c  averasge correlation coefficients
c

      write(6,*)
      write(4,*)
      write(3,*)
c
      do k=1,nfreq
        do i=1,nq(k)
           xsignal(i)=corr_all(k,i)
        enddo
        call sdv(nq(k),xsignal,av_corr(k),sd_corr(k)) 
      enddo
c
      write(6,'(a,8(f5.2,f4.2))')'  Corr:',
     *(av_corr(i),sd_corr(i),i=1,nfreq)
      write(3,'(a,8(f5.2,f4.2))')'  Corr:',
     *(av_corr(i),sd_corr(i),i=1,nfreq)
      write(4,'(a,8(f5.2,f4.2))')'  Corr:',
     *(av_corr(i),sd_corr(i),i=1,nfreq)
c
c  calculate average lapse time
c
      call sdv(ntcoda,tcoda_all,av,sd)
      write(3,*)
      write(4,*)
      write(6,*)
      write(3,*)' Average lapse time with sd', av,sd
      write(4,*)' Average lapse time with sd', av,sd
      write(6,*)' Average lapse time with sd', av,sd
c
c
      write(3,*)
      write(4,*)
      write(6,*)

	write(6,*)' Output of whole run in codaq.out'
	write(6,*)' Output of results in codaq1.out'
	close(3)
	close(4)
      if(pc) then
        write(6,*)' Return to stop'
        read(5,'(a)') text
      endif
	STOP
	END                                                                            

c




	subroutine qzero
     *  (nfreq,fre,q,nq,cs,cq,crms,sdcq,q0,sdq0,ss,sdss,corr,rms)
c
c   calculates the parameters in the relationship
c   q = q0*f**ss with ss variable or ss fixed
c 
c   input:
c   nfreq:      number of frequencies
c   fre:        the frequencies
c   q:          q - values
c   nq:         number of q values for that frequncy
c   cs:         constant ss value
c
c   output:
c   crms        rms when using a constant ss
c   sdqc:       standard deviation in qc
c   cq          q0 whan using a constant ss
c   q0:         q0
c   sdq0        standard deviation in q0
c   ss:         ss
c   sdss:       standard deviation in ss
c   corr:       correlation coefficient
c   rms:        rms error of fit
c
	dimension q(1000),fre(10),nq(10),x(1000),y(1000),z(1000)
	dimension sigmay(1000)
	integer check
   
	check=0
	nn=0
	ndif=0
	cq=0.0
c
c   weight by using each value nq times jun 94, now use weight by number
c
	do 20 i=1,nfreq
	   number=nq(i)
	   if(q(i).gt.0.0) then
	      ndif=ndif+1
c             do 5 k=1,number
		 nn=nn+1
		 if(check.eq.1) 
     *           write(3,*)' qzero: fre(i),q(i)',fre(i),q(i)
		 x(nn)=alog10(fre(i))
		 y(nn)=alog10(q(i))
		 sigmay(nn)=1.0/sqrt(float(number))
		 cq=cq+y(nn)-cs*x(nn)
c5             continue
	   endif
 20      continue
	 if(ndif.gt.1) then
c            call lsqlin(nn,x,y,q0,ss,corr,rms)
            if(check.eq.1) write(3,*)' call linfit'
	    call linfit(x,y,sigmay,nn,1,q0,sigmaq0,ss,sdss,corr)
            if(check.eq.1)write(3,*)' linfit called,q0,ss',q0,ss
c           write(6,*)'q0=',10**aq,'sq',sigmaa,'b=',bq,'sb=',sigmab,rcor
c           write(3,*)'q0=',10**aq,'sq',sigmaa,'b=',bq,'sb=',sigmab,rcor
c           if(check.eq.1) write(6,*)' calculate z(i)'
c           do 25 i=1,nn
c             z(i)=10**(y(i)-ss*x(i))
c25         continue
c           if(check.eq.1) write(6,*)' now call sdv for q0 '
c           call sdv(nn,z,av,sdq0)
c           if(check.eq.1) write(6,*)' sdv called, av,sd=', av,sdq0
c           do 26 i=1,nn
c             if(x(i).ne.0.0) then
c                z(i)=(y(i)-q0)/x(i)
c             else
c                z(i)=ss
c             endif
c26         continue
c           if(check.eq.1) write(6,*)' call sdv for ss'
c           call sdv(nn,z,av,sdss)
	    q0=10.0**q0
	    sdq0=(10**sigmaq0-1.0)*q0
	 else
	    q0=0.0
	    sdq0=0.0
	    ss=0.0
	    sdss=0.0
	    corr=0.0
	    rms=0.0
	 endif
	 if(nn.gt.0) then
	    q1=cq/float(nn)
	    cq=10.0**q1
	    do 30 l=1,nn
	       crms=crms+(y(l)-q1-cs*x(l))*(y(l)-q1-cs*x(l))
	       z(l)= 10**(y(l)-cs*x(l))
 30         continue
	    if(check.eq.1)  write(6,*)' call sdv for cq'
	    call sdv(nn,z,av,sdcq)
	    crms=sqrt(crms/float(nn)) 
	 else
	    cq=0.0
	    sdcq=0.0
	    crms=0.0
	 endif
	 return
	 end
c
c
c
	 subroutine output(in,nq,q,nf,f,cc)
c 
c   from a vector of q values at differenat frequencies
c   the routine will calculate the different averages and
c   sums and print out in a file
c
c   in:     1: only one data set, don't calculate inverse averages
c           any other number: more than one data set
c   nq:     number of values at each frequncy
c   q:      q val nf:     number onumber of frequncies
c   f:      the frequncies
c   cc:     value for fixed q frequncy dependence
c   head:   group name
c
      character*80 text(2)
      dimension iav(10),isd(10),av(10),sd(10)
      dimension q(10,*),nq(10),f(10)
      dimension x(1000)
      integer check
      check=0
c
c   check if any data at all
c
      ntotal=0
      do 9 i=1,nf
	 ntotal=ntotal+nq(i)
 9    continue
      if(ntotal.lt.1)then 
	    write(3,*) 'No results'
	    write(4,*) 'No results'
	    return
      endif
c
c   write header
c
      text(1)(1:9)=' AV Q  SD'
      write(3,205)(text(1)(1:9),i=1,nf)
      write(4,205)(text(1)(1:9),i=1,nf)
 205  format(/,'       ',8a9)
c
c  first calculate average q and standard deviation
c
      ntotal=0
      do 1 if=1,nf
	    n=nq(if)
c
c   check if any values at all
c
	    if(n.eq.0) then
	    av(if)=0.0
	    sd(if)=0.0
	    goto 1
	 endif
	 if(in.eq.1) n=1
	  do 2 k=1,n
	     ntotal=ntotal+1
             if(check.eq.1) write(3,*) 'k,if',k,if
	     x(k)=q(if,k)
 2    continue
         if(check.eq.1) write(3,*)' output,call sdv q,ntotal',ntotal
	 call sdv(n,x,av(if),sd(if))
         if(check.eq.1) write(3,*)' output: avq=',av(if)
	 iav(if)=av(if)+0.5
	 isd(if)=sd(if)+0.5
 1    continue
       
      if(check.eq.1) write(3,*)' output: call qzero av'
      call qzero
     *(nf,f,av,nq,cc,cq,crms,sdcq,q0,sdq0,ss,sdss,corr,rms)
      icq=cq+0.5
      isdcq=sdcq+0.5
      iq0=q0+0.5
      isdq0=sdq0+0.5
c
c  write first header line with number of values
c
      if(in.ne.1) then
	 write(3,200) ntotal,(nq(l),l=1,nf)
	 write(4,200) ntotal,(nq(l),l=1,nf)
 200     format(/,1x,'NT=',i3,8(4x,'N=',i3))
      endif
c
      if(isdq0.gt.999) isdq0=999
      write(3,201)
     *(iav(i),isd(i),i=1,nf)
      write(4,201)
     *(iav(i),isd(i),i=1,nf)
 201  format('    q  ',8(i5,i4))
      write(text(1),233)'    q  ',icq,isdcq,iq0,isdq0,ss,sdss,corr
 233  format(a7,' cq0=',i3,2x,'sd=',i3,2x,
     *'q0=',i3,2x,'sd=',i3,2x,'v=',f5.2,2x,
     *'sd=',f5.2,2x,'cor=',f5.2)
c
c  calculate average of inverse values
c
      if(in.eq.1) return
      do 3 if=1,nf
	 n=nq(if)
	 if(n.ne.0) then
	    do 4 k=1,n
               if(check.eq.1) write(3,*)' q,if,k',q(if,k),if,k
	       x(k)=1.0/q(if,k)
 4          continue
            if(check.eq.1) write(3,*)' call sdv for 1/q, n=',n
	    call sdv(n,x,av(if),sd(if))
	    av(if)=1.0/av(if)
	    iav(if)=av(if)+0.5
	    sd(if)=av(if)*av(if)*sd(if)
	    isd(if)=sd(if)+0.5
	  else
	    iav(if)=0
	    isd(if)=0
	  endif
 3       continue
      if(check.eq.1) write(3,*)' cal qzero, 1/q, av=',av
      call qzero
     *(nf,f,av,nq,cc,cq,crms,sdcq,q0,sdq0,ss,sdss,corr,rms)
      icq=cq+0.5
      isdcq=sdcq+0.5
      iq0=q0+0.5
      isdq0=sdq0+0.5
      write(3,202)
     *(iav(i),isd(i),i=1,nf)
      write(4,202)
     *(iav(i),isd(i),i=1,nf)
 202  format('  1/q  ',8(i5,i4))
      write(text(2),233)'  1/q  ',icq,isdcq,iq0,isdq0,ss,sdss,corr
c
c   calculate q at given frequencies from q = q0*f**ss
c
      if(q0.gt.0.00001) then
	 do 6 i=1,nf
	    av(i)=q0*f(i)**ss
	    iav(i)=av(i)+0.5
	    isd(i)=av(i)*sdq0/q0
 6       continue
      else
	 do 7 i=1,nf
	    iav(i)=0
	    isd(i)=0
 7       continue
      endif
      write(3,203)
     *(iav(i),isd(i),i=1,nf)
      write(4,203)
     *(iav(i),isd(i),i=1,nf)
 203  format('f:1/q  ',8(i5,i4))
c
c  write regresion results
c
      write(3,*)'  '
      write(3,'(a)') text(1)
      write(3,'(a)') text(2)
      write(4,*)'  '
      write(4,'(a)') text(1)
      write(4,'(a)') text(2)
c
c   write on screen
c
      do i=1,13
	     backspace 3
      enddo
      do i=1,13
	     read(3,'(a)')text(1)
	     write(6,'(a)') text(1)
      enddo
      return
      end
c
c
c
C  SUBROUTINE LINFIT
C  
C  PURPOSE
C   MAKE A LEAST-SQUARES FIT TO DATA WITH A STRAIGHT LINE
C       Y = A + B*X
C
C  USAGE
C    CALL LINFIT (X, Y, SIGMAY, NPTS, MODE, A, SIGMAA, B, SIGMAB ,R)
C
C  DESCRIPTIONMETERS
C      
C       X       - ARRAY OF DATA POINTS FOR INDEPENDENT VARIABLE 
C       Y       - ARRAY OF DATA POINTS FOR DEPENDENT VARIABLE
C       SIGMAY  - ARRAY OF STANDARD DEVIATIONS FOR Y DATA POINTS
C       NPTS    - NUMBER OF PAIRS OF DATA POINTS
C       MODE    - DETERMINES METHOD OF WEIGHTING LEAST-SQUARES FIT
C                 +1 (INSTRUMENTAL) WEIGHT(I)=1./SIGMAY(I)**2
C                  0 (NO WEIGHTING) WEIGHT(I)=1.
C                 -1 (STATISTICAL)  WEIGHT(I)=1./Y(I)
C       A       - Y INTERCEPT OF FITTED STRAIGHT LINE
C       SIGMAA  - STANDARD DEVIATION OF A
C       B       - SLOPE OF FITTED STRAIGHT LINE 
C       SIBMAB  - STANDARD DEVIATION OF B
C       R       - LINEAR CORRELATION COEFFICIENT
C
C  SUBROUTINES AND FUNCTION SUBPROGRAMS REQUIRED
C    NONE
C  
C  MODIFICATIONS FOR FORTRAN II
C    OMIT DOUBLE PRECISION SPECIFICATIONS
C    CHANGE DSQRT TO SQRTF IN STATEMENTS 67,68, AND 71

      subroutine linfit(x,y,sigmay,npts,mode,a,sigmaa,b,sigmab,r)
      dimension x(1),y(1),sigmay(1)
c
c   accumulate weighed sums
c
 11   sum=0.0
      sumx=0.0
      sumy=0.0
      sumx2=0.0
      sumxy=0.0
      sumy2=0.0
 21   continue
      do 50 i=1,npts
	x1=x(i)
	y1=y(i)
	if(mode) 31,36,38
 31     if(y1) 34,36,32
 32     weight=1.0/y1
	go to 41
 34     weight=1.0/(-y1)
	go to 41
 36     weight=1.0
	go to 41
 38     weight=1.0/sigmay(i)**2
 41     sum=sum+weight
	sumx=sumx+weight*x1
	sumy=sumy+weight*y1
	sumx2=sumx2+weight*x1*x1
	sumxy=sumxy+weight*x1*y1
	sumy2=sumy2+weight*y1*y1
 50   continue
c
c   calculate coefficients and standard deviations
c
 51   delta=sum*sumx2-sumx*sumx
      a=(sumx2*sumy-sumx*sumxy)/delta
 53   b=(sumxy*sum-sumx*sumy)/delta
c
c  patched up to use same varnce at all times jh jun 94
c
c61   if(mode) 62,64,62 
c62   varnce=1.0
c     go to 67
 64   c=npts-2
c
c   modified to not crash with only 2 points
c
      if(c.gt.0) then
	 varnce=(sumy2+a*a*sum+b*b*sumx2
     *   -2.0*(a*sumy+b*sumxy-a*b*sumx))/c
      else
	 varnce=0.0
      endif
 67   sigmaa=sqrt(varnce*sumx2/delta)
 68   sigmab=sqrt(varnce*sum/delta)
 71   r=(sum*sumxy-sumx*sumy)/
     *sqrt(delta*(sum*sumy2-sumy*sumy))
      return
      end

C############################################################################
C
c
      subroutine codaselect(eventid,station,component,start,absstart,
     *           window,select,date,tp,tcoda,tstart,n,rate,error,
     *           out,plotoption,trace_file)           
c                                                                               
c                                                                               
c   select a window for coda Q analysis                                         
c                                                                               
c   input:  eventid:  eventid (file name)                                       
c           station:  station to use                                            
c           start:    start time from origin time in units of                   
c                     s-travel times, usually 2. See below.                     
c           absstart: absolute start time from origin in secs. If               
c                     less than what is determined by start, return             
c                     with error. If = 0, only user parameter start as          
c                     criteria.                                                 
c           window:   time window (secs)                                        
c           select:   1: only the coda window is selected                       
c                     2: the trace to end of coda window                        
c                     3: the whole trace                                        
c           out:      logical unit number for written output                    
c                                                                               
c   output: date:     date of event y-m-d-h-m-sec.xxx                           
c           signal:   trace data                                                
c           tp:       P travel time                                             
c           tcoda:    time from origin (secs) of first sample in window         
c           tstart:   time of first sample in window relative to start          
c                     of data file                                              
c           n:        number of points in window                                
c           rate:     samples pr sec                                            
c           error:    number of errors found, should be zero                    
c           plotoption: see main prog
c           trace-file: trace file name
c                                                                               
      implicit none                                                             
      include 'seidim.inc'
      include 'waveform.inc'
      include 'seisan.inc'
      character*80 eventid                                                      
c-- trace file name                                
      character*80 trace_file
c-- dummy                                               
c     character*80 dummy                
c-- station code                                  
      character*5  station,sta          
      integer plotoption
c-- component                                           
      character*4  comp,component                       
c-- date and time                                       
      character*18 date                 
c-- phase                                               
      character*1  phase                
c-- selector, see above                                    
      integer select                    
c-- see above                             
      real tcoda,start,tstart,window    
c-- ---------                                            
      real absstart,tp                  
c-- ---------                             
      integer n                         
c-- number of samples in one channel      
      integer nsamp                     
c-- 1: test output, 0: no output                            
      integer check                     
c-- origin date                                  
      integer oyear,omonth,oday         
c-- origin time                                         
      integer ohour,omin                
c-- origin time                                              
      real    osec                      
c-- ptime                                               
      integer phour,pmin                
c-- -----                                 
      real    psec                      
c-- abs times                            
      double precision ptime,wtime,otime        
c-- print out logical unit                                    
      integer out                       
c-- sample rate                                              
      integer rate                      
c-- ------------                                            
      real    rrate                     
c-- error variables                                     
      integer error                
c-- channel number to select
      integer chan                      
c-- start time and window(secs) selected                    
      real t1,windo                     
c-- help variables                                
      integer   i,j,k,n1,n2     
c-- seismic signal                                         
      character*80 message(2)    ! ERROR MESSAGES
c-- output from remove_padding,not usedB  
c     double precision  pfsec           
      integer   n_trace_file     ! number of trace files for one event
      character*80 data(max_data)     ! number of header lines in s-file
c                            
						   
      error=0                                                                   
      check=0                                                                   
c                                                                               
c   open and read data from pick file                                           
c                                                                               
      open(15,file=eventid,status='old',err=66)
      goto 67
 66   continue
	 error=error+1
	 if(plotoption.eq.1.or.plotoption.eq.0) then
	    write(message(1),'(a,a)')'No such file: ',eventid(1:60)
	    call xmessage(message,1,80,50.0,50.0)
	 else
	    write(6,'(a,a)')'No such file: ',eventid
	 endif
	 write(3,'(a,a)')'No such file: ',eventid
	 return
 67   continue
      read(15,'(1x,i4,1x,2i2,1x,2i2,f5.1)')                                     
     *oyear,omonth,oday,ohour,omin,osec                                         
c                                                                               
c   get absolute origin time in secs                                            
c                                                                               
      call timsec(oyear,omonth,oday,ohour,omin,osec,otime)                      
c                                                                               
c   find station and read p-time                                                
c                                                                               
 4    continue                                                                  
	 read(15,'(1x,a4,5x,a1)',end=5)                                         
     *   sta,phase                                                              
	 if(sta.eq.station.and.phase.eq.'P') go to  6                           
	 go to 4                                                                
 5    continue                                                                  
      if(plotoption.eq.0.or.plotoption.eq.1) then
	     write(message(1),200) station,eventid(1:40)                                      
	     call xmessage(message,1,80,50.0,50.0)
      else
	     write(out,200) station,eventid(1:40)                                      
 200     format('P for station ',a5,' not found for event',a40)                  
      endif
      write(3,200) station,eventid(1:40)                                      
      error=error+1                                                             
      close(15)                                                                 
      return                                                                    
c                                                                               
c   station and p-phase found, now read it                                      
c                                                                               
 6    continue                                                                  
      backspace 15                                                              
      read(15,'(1x,a5,4x,a1,7x,2i2,f6.1)',end=5)                                
     *sta,phase,phour,pmin,psec                                                 
c                                                                               
c   calculate abs ptime                                                         
c                                                                               
      call timsec(oyear,omonth,oday,phour,pmin,psec,ptime)                      
c                                                                               
c   calculate start of coda from origin                                         
c                                                                               
      tcoda=(ptime-otime)*start*1.78                                            
c                                                                               
c   calculate P travel time                                                     
c                                                                               
      tp= ptime-otime                                                           
c                                                                               
c   check if absolut start time is used                                         
c                                                                               
      if(absstart.gt.0.0) then                                                  
 	   if(absstart.lt.tcoda) then                                             
	    if(plotoption.eq.0.or.plotoption.eq.1) then
		   write(message(1),202) sta,eventid(1:50)                           
		   call xmessage(message,1,80,50.0,50.0)
	    else
		   write(out,202) sta,eventid                                          
 202       format(1x,'abs time too early', 2x,a4,2x,a50)                         
	    endif
        write(3,202) sta,eventid                                          
	    error=error+1                                                       
	    close(15) 
	    return                                                              
	 else                                                                   
	    tcoda=absstart                                                      
	 endif                                                                  
      endif                                                                    
c                                                                               
c   get trace data file names, first read header lines    
c                                                                               
      rewind 15                                                                 
      read(15,'(a)') data(1)
      read(15,'(a)') data(2)
      i=2
      do while(data(i)(80:80).ne.' ')
         i=i+1
         read(15,'(a)',end=777) data(i)
      enddo
 777  continue
      close(15)
      i=i-1

      call auto_tr(data,i,n_trace_file,wav_filename)
c
c   check if files exist and where
c
       k=0
       do i=1,n_trace_file
          call  get_full_wav_name(wav_filename(i),trace_file)
          if (trace_file.eq.' ') then
             if(plotoption.eq.0.or.plotoption.eq.1) then
                write(message(1),'(a,1x,a)') ' Missing file: ',
     *          wav_filename(i)(1:60)
                call xmessage(message,1,80,50.0,50.0)
             else
                write(6,'(a,1x,a)') ' Missing file: ', 
     *          wav_filename(i)
             endif
             write(3,'(a,1x,a)') ' Missing file: ', 
     *       wav_filename(i)
         else
            k=k+1
            wav_filename(k)=trace_file
         endif
       enddo
       n_trace_file=k
       write(6,*)' Number of wav files', n_trace_file  
       if(check.eq.1) write(6,*)' Number of wav files', n_trace_file
c
c   check if any name given
c
      if(n_trace_file.eq.0) then
         error=error+1
         call clear_to_alpha
         write(6,'(a,a)')
     * ' No waveform file given for event', data(1)(1:20)
         error=error+1
         if(plotoption.eq.0.or.plotoption.eq.1) call open_display
         return
      endif

c          
c   initialize waveform file info
c
      call wav_init
c         
c   read all header information from all files
c         
      wav_nfiles=n_trace_file
       if(check.eq.1) write(6,'(a,a)')' Read headers from files:'
       do i=1,wav_nfiles
          if(check.eq.1)write(6,'(1x,a)') wav_filename(i)(1:80)
          call read_wav_header(i)
       enddo

c   find channel number corresponding to station and                            
c   component, assume SP Z if component is blank, also get header time                                
c            
      comp=component                                                        
      if(component.eq.'    ') comp='S  Z'                                   
      call wav_find_chan(station,comp,chan)

      if(chan.eq.0) then
         error=error+1                                                  
        if(plotoption.eq.1.or.plotoption.eq.0) then
           write(message(1),'(a,a,a)')
     *     ' Station and component not found in trace file(s)  ',
     *     station,comp
           call xmessage(message,1,80,50.0,50.0)
        else
           write(6,'(a50,a5,1x,a4)')
     *     ' Station and component not found in trace file(s): ',
     *     station,comp
        endif
        write(3,'(a50,a5,1x,a4)')
     *      ' Station and component not found in trace file(s)  ',
     *      station,comp
	    return
       endif
c                                                                               
c   save date                                                                   
c                                                                               
      write(date,'(i4,4i2,f6.3)') 
     *wav_year(chan),wav_month(chan),wav_day(chan),
     *wav_hour(chan),wav_min(chan),wav_sec(chan)                
c                                                                               
c   calculate start time for coda window relative to first                      
c   sample in trace data                                                        
c                                                                               
      wtime=wav_abs_time(chan)
      tstart=tcoda-(wtime-otime)                                                
c                                                                               
      if(check.eq.1)                                                            
     *write(3,*)'check: ptime,otime,tcoda,tstart,wtime',                      
     * ptime,otime,tcoda,tstart,wtime                                           
c                                                                               
c  get trace data, first check how much should be selected                      
c                                                                               
      t1=tstart                                                                 
      if(select.eq.2) then                                                      
          t1=0.0                                                                 
          windo=window+tstart                                                    
      endif                                                                     
      if(select.eq.3) then                                                      
	     t1=0.0                                                          
c-- indicating whole trace                                    
	     windo=0.0              
      endif                                                                     
c                                                                               
c   read whole trace                      
c                                                                               
      call wav_read_channel(chan)
       rrate=wav_rate(chan)
       nsamp=wav_nsamp(chan)
      if(windo.eq.0.0) windo=(nsamp-1)/rrate                                    
c                                                                               
c   select window                                                               
c                                                                               
      n1=t1*rrate+1                                                             
      n2=(t1+windo)*rrate+1                                                     
      j=0                                                                       
      do i=n1,n2                                                                
        j=j+1                                                                   
        signal1(j)=signal1(i)                                                     
      enddo                                                                     
      n=j                                                                       
c                                                                               
      rate=rrate                                                                
c                                                                               
      if(check.eq.1)write(3,*)'signal1',(signal1(i),i=1,20)                     
      if(check.eq.1)write(3,*)' rate,t1,n',rate,t1,n                           
c                                                                               
      return                                                                    
      end                                                                       
										
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc    
										
										
										
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc   
      subroutine codaq(n,n1,t1,signal,nrate,f,v,s,q,rms,corr)                   
c                                                                               
c   calculates codaq from a filtered signal                                     
c                                                                               
c   input:   n:      number of points to analyze                                
c            n1:     first point to use in data vector signal                   
c            t1:     time form origin of point n1                               
c            signal: the filtered trace data                                    
c            nrate:  sample rate                                                
c            f:      frequncy of bandpass filter                                
c            v:      spreading parameter                                        
c                                                                               
c   output:     s:   envelope amplitude at t=0                                  
c               q:   q                                                          
c             rms:   rms of the coda q fit                                      
c            corr:   correlation coefficient of fit                             
c
       implicit none
       real signal(*),env(10000)                                       
       real x(10000)
       integer ismo,nrms,i,n1,n,nenv,nrate
       integer check
       real f,v,s,q,rms,corr,a,b,delt,t1
       common /work/x,env
c                                                                               
c   some variables and parameters                                               
c                                                                               
c   ismo:  number of times envelope is smoothed                                 
c   nenv:  number of points in evevelope                                        
c   nrms:  number of points in sliding 5 cycle rms window                       
c   x   :  work array                                                           
c
       check=0
       if(check.eq.1) write(3,*)'n,n1,t1,nrate',n,n1,t1,nrate
       ismo=4                                                                   
       nrms=nrate*5.0/f                                                         
c                                                                               
c   find envelope                                                               
c                                                                               
       do 1 i=1,n                                                               
	  x(i)=signal(i+n1-1)                                                   
 1     continue
       if(check.eq.1) write(3,*)' call erms,nrms=',nrms
       call erms(x,n,nrms,ismo,env,nenv)
       if(check.eq.1) write(6,*) 'erms called'
c                                                                               
c   genearate time trace                                                        
c                                                                               
	delt=1.0/float(nrate)                                                   
	x(1)=t1+float(nrms)*delt/2.0                                             
	do 2 i=2,nenv                                                           
	   x(i)=x(i-1)+delt                                                     
 2      continue
        if(check.eq.1) write(3,*)'delt',delt
c                                                                               
c   calculate q                                                                 
c                                                                               
	 do 3 i=1,nenv                                                          
	    if(x(i).le.0.0 .or. env(i).le.0.0) then                             
	       x(i)=0.1                                                         
	       env(i)=0.1                                                       
C               write(6,*)' x(i) zero or negative *******'                      
	    endif                                                               
	    env(i)=alog(env(i))+v*alog(x(i))                                    
 3       continue                                                               
	 call lsqlin(nenv,x,env,a,b,corr,rms)                                   
	 q=-3.1416*f/b                                                          
	 if(abs(a).gt.20.) then                                                 
	   a=20.0                                                               
c           write(6,'(a,a,a)')
c     *      ' Station and component not found in trace file  ',
c     *      station,comp
	   write(6,*)' Very large envelope **********'                          
	   write(3,*)' Very large envelope **********'                          
	 endif                                                                  
	 s=exp(a)                                                               
	 return                                                                 
	 end                                                                    
										
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc   
      subroutine sn(n,n1,x1,n2,x2,ratio)                                        
c                                                                               
c   calculates rms signal to noise ratioes between two                          
c   data sets                                                                   
c                                                                               
c   input:  n:     number of points used for rms calculation                    
c           n1:    index of first point to use in data set 1                    
c           x1:    data set 1                                                   
c           n2:    index of first point to use in data set 2                    
c           x2:    data set 2                                                   
c           ratio: rms ratio between data set 1 and 2                           
c                                                                               
c                                                                               
      dimension x1(*),x2(*)                                                     
      integer check                                                             
      check=0                                                                   
      rms1=0                                                                    
      rms2=0                                                                    
      do 1 i=1,n                                                                
	 rms1=rms1+x1(i+n1-1)*x1(i+n1-1)                                        
	 rms2=rms2+x2(i+n2-1)*x2(i+n2-1)                                        
 1    continue                                                                  
      if(check.eq.1)write(3,*)                                                  
     *'rms1,rms2,n,n1,n2',rms1,rms2,n,n1,n2                                     
      if(rms2.eq.0.0)then                                                              
	    rms2=10000.0                                                            
	    write(6,*)' zero rms ****************'                                  
	    write(3,*)' zero rms ****************'                           
      endif                                                                     
      ratio=rms1/rms2                                                           
      ratio=sqrt(ratio)                                                         
      return                                                                    
      end                                                                       
										
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc    
      subroutine traceplot                                                      
     *(x0,y0,x1,x2,y1,y2,n,y,xo,xsc,rate,nstep,head,headp,                      
     *nflag,flag,noise,s,tcoda,rr,f,q,date)                                  
c                                                                               
c                                                                               
c   jul 92 by jh   changed to tektronics                                        
c                                                                               
c   plots a trace of data in a fixed frame                                      
c   note: plot is rotated 90 deg counter clockwise                              
c                                                                               
c   input:   x1,x2,y1,y2: frame and size of plot                                
c            n:     number of points  in input vector y                         
c            y:     n samples                                                   
c            xo:    time of first sample (sec)                                  
c            xsc:   x-scale in tek units/sec                                           
c            nstep: steps between samples to be plotted, 1 plots all            
c            rate:  sample rate                                                 
c            head:  header information to be plotted above trace                
c            headp: ---------------------- on post script                       
c            nflag: number of flags to be plotted along trace                   
c            flag:  time of flags to plotted along trace, in same               
c                   time scale as xo.                                           
c            noise: number of noise samples in front of signal, if              
c                   zero, do not plot following relation                        
c            s,tcoda,rr,f,q : parameters in the theoretical coda                
c                   decay curve  a = s*(tcoda**-rr)*exp(-pi*tcoda*f/q)          
c                   to be plotted on top of trace                               
c            date   date and time                                               
c                   
      include 'seiplot.inc'                                                            
      integer n,rate,nflag,check                                                
      dimension env(10000)
      real y(*)                                                                 
      integer delsec                                                            
      character*18 date                                                         
      character*120 headp                                                       
      real x0,y0,xo,ym,xsc,flag(1)                                              
      character*80 head,text                                                    
										
       dimension yy(10000)                                                       
       common /work/yy,env
c -----------------------------------------------------------------             
       check=0                                                                    
c                                                                               
c   plot frame, define size by x1,x2,y1,y2                                      
c                                                                               
      ym=(y2-y1)/2.0      
      call xset_color(color_frame)                    
      call xmovabs(x1+x0,y1+y0)                                                 
      call xdrwabs(x1+x0,y2+y0)                                                 
      call xdrwabs(x2+x0,y2+y0)                                                 
      call xdrwabs(x2+x0,y1+y0)                                                 
      call xdrwabs(x1+x0,y1+y0)                                                 
c                                                                               
c   find how much data there is room for, scale and plot it                     
c                                                                               
      dx=xsc/(float(rate))                                                      
      nx=(x2-x1)/dx                                                             
c      write(6,*)'n,nx',n,nx                                                    
c      write(6,*)(y(i),i=1,20000)                                               
      if(nx.gt.n) nx=n                                                          
      ymax=0.0                                                                  
      do 1 i=1,nx                                                               
	 if(abs(y(i)).gt.ymax) ymax=abs(y(i))                                   
 1    continue                                                                  
c      write(6,*)'ymax',ymax                                                    
c                                                                               
c   check for ymax equal zero                                                   
c                                                                               
      if(ymax.lt.10e-20) ymax=10e-20                                            
      factor=(y2-y1)/(ymax*2.0)                                                 
c                                                                               
c   plot ymax at end of trace                                                   
c                                 
      call xset_color(color_axis_not)         
      i=ymax+0.5
      write(text,'(i10)') i                                                
      call tchars(text,10,x2-140.0+x0,y2-25+y0)                                 
c                                                                               
c  not standard fontsize and location for post script                           
c                                                                               
      call fontsize(0,2.0)                                                      
      call pchars(text,10,x2-60.0+x0,y2-10+y0)                                  
										
c                                                                               
c   plot trace and calculate envelope values                                    
c                                                                               
      dd=1.0/float(rate)                                                        
c      x=x1                                                                      
      t=tcoda                                                                   
      if(check.eq.1) write(3,*)'env(1)',env(1)                                  
      j=0                                                                       
      do 3 i=1,nx,nstep                                                         
	 j=j+1                                                                  
c         x=x+dx*nstep                                                           
	 if(i.ge.noise.and.noise.ne.0) then                             
      
	    env(i)=s*t**(-rr)*exp(-3.1416*f*t/q)                                
	    t=t+dd*nstep                                                        
	 endif                                                                  
	 yy(j)=y(i)*factor+ym+y0                                                
 3    continue                       
      call xset_color(color_trace)         
      call xdrwvec(j,x1+x0,yy,dx*nstep)
c                                                                               
c   plot envelope fit, skip some values                                         
c                                                                               
       if(check.eq.1) write(3,*)' traceplot: env',(env(i),i=1,10)               
       if(noise.gt.0) then                                                      
	  newstep=nstep*5                                                       
c          x=x1+x0+dx*noise                                                               
	  j=0                                                                   
	  do 7 i=1,nx,newstep                                                   
	     if(i.ge.noise) then                                                
		j=j+1                                                           
		yy(j)=env(i)*factor+ym+y0                                       
	     endif                                                              
 7        continue                
	  call xset_color(color_spec)         
	  call xdrwvec(j,x1+x0+dx*noise,yy,dx*newstep)
	endif                                                                   
c                                                                               
c   plot header, different for tek and postscript                               
c                                                                               
      continue                       
      call xset_color(color_title)         
      call tchars(head,80,x1+x0,y2+1+y0)                                        
      call fontsize(0,2.7)                                                      
      call pchars(headp,120,x1+x0,y2+5+y0)                                   
c                                                                               
c   plot flags                                                                  
c                                                                               
      if (nflag.ne.0) then        
	 call xset_color(color_pic)           
	 do 4 i=1,nflag                                                         
	    x=(flag(i)-xo)*float(rate)*dx+x1                                    
	    call xmovabs(x+x0,y1+y0)                                            
	    call xdrwabs(x+x0,y2+y0)                                            
	    call xdrwabs(x-9.0+x0,y2-9.0+y0)                                    
	    call xmovabs(x+x0,y2+y0)                                            
	    call xdrwabs(x+9+x0,y2-9.0+y0)                                      
 4       continue                                                               
       endif                                                                    
c                                                                               
c   plot tics on axis                                                           
c                                                                               
      read(date,'(12x,f6.3)') sec                                               
c                                                                               
c   find distance in secs between tics assuming min 100 tectronics              
c   units between tics                                                          
c                                                                               
	 i=50.0/xsc                                                             
c                                                                               
c  find distance between points to nearest 1,2,5,10 or 20 sec                   
c                                                                               
	 if(i.le.1) delsec=1                                                    
	 if(i.gt.1) delsec=2                                                    
	 if(i.gt.2) delsec=5                                                    
	 if(i.gt.5) delsec=10                                                   
	 if(i.gt.10) delsec=20                                                  
	 if(i.ge.20) delsec=30                                                  
c-- number of secs of axis                            
	 nsec=(x2-x1)/xsc                       
c-- first whole sec on axis                          
	 isec=sec/delsec+1                      
c-- time of first tic                                 
	 isec=isec*delsec                       
c-- x position first tic                           
	 x=(isec-sec)*xsc+x0                    
c-- find second tic value below 60                   
	 isec=mod(isec,60)                      
c                                                                       
	 call fontsize(0,1.5)                                                   
	 call xset_color(color_axis_not)                                        
	 do 5 i=1,nsec/delsec                                                   
	    if(x.gt.1010) goto 5                                                
	    write(text,'(i2)') isec                                             
	    call pchars(text,2,x-6.0,y1+y0-8.0)                                 
	    tsize=5                                                                 
	    if(isec.eq.60.or.isec.eq.0) then                                    
	      tsize=10                                                          
	      isec=0                                                            
	    endif                                                               
	       call xmovabs(x,y1+y0)                                            
	       call xdrwabs(x,y1+y0+tsize)                                      
	    isec=isec+delsec                                                    
	    x=x+xsc*delsec                                                      
 5       continue                                                               
										
       return                                                                   
       end                                                                      
										
C@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ 
C                                                                               
      SUBROUTINE ERMS(DATA,N,NRMS,ISMO,ENV,NENV)                                
C                                                                               
C   ROUTINE MAKES AN RMS RUNNING WINDOW ENVELOPE                                
C                                                                               
C   DATA: INPUT DATA                                                            
C   N   : NUMBER OF INPUT DATA                                                  
C   NRMS: NUMBER OF POINTS IN SLIDING RMS WINDOW                                
C   ISMO: NUMBER OF TIMES ENVELOPE IS SMOOTHED                                  
C   ENV : ENVELOPE                                                              
C   NENV: NUMBER OF POINTS IN ENVELOPE = N-NRMS                                 
C
      implicit none
      real DATA(*),ENV(*)
      integer n,nrms,ismo,nenv,k,i,check
      real rms
      check=0
c
      NENV=N-NRMS                                                               
      
      if(check.eq.1) then
         write(3,*)'nrms inside,nenv',nrms,nenv
         write(3,*)(data(i),i=1,10)
      endif

      DO 10 I=1,NENV
         RMS=0.0                                                                   
C                                                                               
C   RMS VALUE OVER NRMS POINTS                                          
C                                                                                       
         DO 5 K=1,NRMS                                                             
            RMS=RMS+DATA(K+I-1)*DATA(K+I-1)                                           
 5       CONTINUE                                                                  
         ENV(I)=SQRT(RMS/FLOAT(NRMS))                                              
 10   CONTINUE                                                                  
C                                                                               
C   SMOOTHE ENVELOPE                                                            
C                                                                               
      CALL SMOOTH(ENV,NENV,ISMO)                                                
      RETURN                                                                    
      END                                                                       
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC        

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
      SUBROUTINE MAXLIK(FMX,FMY,NP,FLA,FKA,SLA,SKA)
C
C     REF.: U. ERICSON: MAXIMUM LIKELIHOOD LINEAR FITTING WHEN BOTH
C                       VARIABLES HAVE NORMAL AND CORRELATED ERRORS,
C                       FOA 4 REPORT C 4474-A1, SEPTEMBER 1971.
C     H. BUNGUM
C
c     mar, 08 99 : simplified for use in seisan
c

C
C     INPUT:
C
C     FMX(I),I=1,NP  MAGNITUDES IN X DIRECTIONS
C     FMY(I),I=1,NP  MAGNITUDES IN NG Y-AXIS
C     NP             NO OF POINTS
C
C     RO (=0)        CORRELATION BETWEEN Y AND X
C     GE (=1.0)      RATIO BETWEEN VARIANCES IN Y AND X
C
C     OUTPUT, not all put output:
C
C     XBAR,YBAR      AVERAGES IN X AND Y DIRECTIONS
C     AX,BX          REGRESSION COEFFICIENTS IN Y=AX*X+BX
C     AY,BY          REGRESSION COEFFICIENTS IN X=AY*Y+BY
C     SBX,SBY        STANDARD DEVIATIONS IN BX AND BY
C     FLA,FKA        MAXIMUM-LIKELIHOOD COEFFICIENTS
C     SLA,SKA        STANDARD DEVIATIONS IN FLA AND FKA
C     SS             SUM OF SQUARES AROUND MAX-LIK REGRESSION
C     SX,SY          SIGMA VALUES IN X AND Y FOR MAX-LIK SOLUTION
C
C
C
      real*4 FMX(*),FMY(*)
C
      GE=1.0
      RO=0.0
C
      JB=0
      XBAR=0.0
      YBAR=0.0
      DO 500  I=1,NP
      JB=JB+1
      XBAR=XBAR+FMX(I)
      YBAR=YBAR+FMY(I)
  500 CONTINUE
      XBAR=XBAR/JB
      YBAR=YBAR/JB
C
      SU2=0.0
      SV2=0.0
      SUV=0.0
      DO 501  I=1,NP
      SU2=SU2+(FMX(I)-XBAR)**2
      SV2=SV2+(FMY(I)-YBAR)**2
      SUV=SUV+(FMX(I)-XBAR)*(FMY(I)-YBAR)
  501 CONTINUE
      BX=SUV/SU2
      AX=YBAR-BX*XBAR
      BY=SUV/SV2
      AY=XBAR-BY*YBAR
      ARG1=(1./(BX*BY)-1.)/(JB-2.)
      IF(ARG1.GE.0.0)  then
         SBX=BX*SQRT(ARG1)
         SBY=BY*SQRT(ARG1)
      else
         sbx=0.
         sby=0. 
      endif
      S0=-GE*GE+RO*GE/BY
      S1=GE*GE/BX-1./BY
      S2=1.-RO*GE/BX
      ARG2=S1*S1-4.*S0*S2
      IF(ARG2.GE.0.0)  then
         FKA=(-S1+SQRT(ARG2))/(2.*S2)
      else
         fka=0.
      endif
      FLA=YBAR-FKA*XBAR
C
      SS=0.0
      DO 502  I=1,NP
      SS=SS+(FMY(I)-FLA-FKA*FMX(I))**2
  502 CONTINUE
      ARG3=SS/((GE*GE+FKA*FKA-2.*FKA*GE)*(JB-2.))
      IF(ARG3.GE.0.0)  then
         SX=SQRT(ARG3)
      else
         sx=0.
      endif  
      SY=GE*SX
      ARG4=(GE*GE+BX/BY)*(1./(BX*BY)-1.)/((JB-2.)*(GE*GE+FKA*FKA))
      IF(ARG4.GE.0.0)  then
         SKA=SQRT(ARG4)
      else
         ska=0.
      endif
      ARG5=SV2/(JB*(JB-2.))+XBAR*XBAR*SKA*SKA
      IF(ARG5.GE.0.0)  then
         SLA=SQRT(ARG5)
      else
         sla=0.
      endif
C
c     WRITE(2,503)  JB
c 503 FORMAT(//' LEAST-SQUARES AND MAXIMUM LIKELIHOOD LINEAR FITTING OF 
c    *MAGNITUDE DISTRIBUTIONS'//' NUMBER OF EVENTS',I7)
c     write(2,'(a,i7)') ' NUMBER OF EVENTS',jb
c     WRITE(2,504) AX,BX,SBX,AY,BY,SBY,FLA,FKA
c 504 FORMAT(' Y AS A FUNCTION OF X',2F10.3/,5X,'STD',23X,F10.3/
c    *        ' X AS A FUNCTION OF Y',2F10.3/,5X,'STD',23X,F10.3/
c    *        ' MAXIMUM-LIKELIHOOD  ',2F10.3)
C
c     IF(RO.EQ.0.0)  WRITE(2,16) SLA,SKA
c  16 FORMAT(5X,'STD',13X,2F10.3)
c     WRITE(2,505) XBAR,YBAR,SS,SX,SY
c 505 FORMAT(' XBAR, YBAR',2F8.3,5X,
c    *' SS',F8.3,5X,'SX, SY',2F8.3)
C
      RETURN
      END
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c$DEBUG
c
c  convert SEIS89 files to seisan format
c
c
c  j. havskov, sep 97
c
c  updates:
c  oct 9 by jh      : new file name
c  oct  20          : bug with day and hour
c  mar 4    lo      : bug with SUN filenames
c  mar 17 99 by jh  : ------------ version 7.0 changes --------------------
c                     stat to 5, new general structure
c  may 11  00    lo : use read_resp_head
c
c  
      implicit none
      include 'seidim.inc'
c-- input data vector	  
      integer*2 data(max_sample)
c-- input file name	  
      character*80 infile
      character*80 text
c
c-----------------------------------------------------------------------
c   start block of definitions for most conversion programs
c
c-- main header------------------------------------------
      character*80 mainhead(max_trace)
      character*29 mainhead_text   ! text to be put into main header
c-- channel header
      character*1040 chahead
c-- output file name 
      character*80 outfile	  
c-- number of stations
      integer nchan	  
c-- channel to calculate channel header for
      integer ichan
c-- network code
      character*5 net_code	  
c-- stations and components
      character*5 stat(max_trace)
      character*4 comp(max_trace)	  
c-- channel 2 or 4 byte
      character*1 cbyte(max_trace)
c--channel header date and times	  
      integer year(max_trace),month(max_trace),day(max_trace),
     *hour(max_trace),min(max_trace)
      real sec(max_trace)
c-- channel samples and sample rate
      integer nsamp(max_trace)
      real rate(max_trace)	  
c
c--end block of definitions most conversion programs
c---------------------------------------------------------------------
c

c-- infile indicator; in=0: one file, in=1: many files
      integer in	  
c-- question
      character*80 question	  
c-- input file header
      character*512 head,head1
      integer*2 i256(256)
      integer*4 i128(128)
      real f(20),gain(20),phase(20)  ! response function, gain is nm/count
c--Counters etc
	  integer i,j,k,j1,j2,i1,i2,i3,i4,i5,i6
c-- computer type
      logical pc,sun,linux	  
      equivalence(head1,i256)
      equivalence(head1,i128)


c
c print version
c
      include 'version.inc'
      out_version_date='July 23, 2001'
      if (version_new) out_version_date=version_date
      call print_ver

c
      call computer_type(sun,pc,linux)
c
c   get def file for station codes, give file name
c
       text='s89sei.def'
       call read_def_chan(text,mainhead_text,net_code)
c
c   get file name
c
      in=0
      question=' File name, # or filenr.lis for all'
      call filename(question,infile)	    
      if(infile.eq.'EOF') stop
      if(infile(1:10).eq.'filenr.lis'.or.infile(1:10).eq.
     *'FILENR.LIS') then
         open(8,file='filenr.lis',status='old',err=20)
         goto 21
 20      continue
         write(6,*)' No filenr.lis'
         stop
 21      continue
         in=1
      endif
c
c  file loop if many files
c
 1000 continue
      if(in.eq.1) then
         read(8,'(7x,a)') infile
         if(infile(1:4).eq.'    ') stop
      endif
      write(6,'(1x,a)') infile
c
c  open file and read header
c
       open(1,file=infile,status='old',access='direct',recl=512)
       read(1,rec=1) head
       head1=head
       close(1)
c
c   extract information
c
       stat(1)(1:4)=head(5:8)
       stat(1)(5:5)=' '
       comp(1)=head(21:24)             ! component, often Z, N or E in first column
c
c   assume something about component
c
       if(comp(1)(1:1).eq.'Z'.or.comp(1)(1:1).eq.'N'.
     *or.comp(1)(1:1).eq.'E') then
          comp(1)(4:4)=comp(1)(1:1)
          comp(1)(2:3)='  '
          comp(1)(1:1)='S'
       endif
c
c   put in definition from def file
c
        call set_def_chan(1,stat(1),comp(1))
c
c   number of samples 
c
       if(sun) call swap4_one(i128(114))
       nsamp(1)=i128(114)-256

c
c   swap remaining 2 byte if on sun
c
       if(sun) call swap2(256,i256)
c
c   extract response info
c
c       write(6,*) (i256(i),i=15,40)
       k=1
       do i=1,20
          f(i)=i256(14+k)+i256(15+k)/10000.0
          gain(i)=i256(16+k)*10.0**i256(17+k)
          phase(i)=i256(18+k)+i256(19+k)/10000.0
          k=k+6
c          write(6,*)f(i),gain(i),phase(i)
       enddo

c
       rate(1)=i256(13)+i256(14)/10000.0  ! sample rate
c
       year(1)=i256(135)
       month(1)=i256(136)
       day(1)=i256(137)
       hour(1)=i256(139)
       min(1)=i256(140)
       sec(1)=i256(142)+i256(143)/10000.0
c
c       write(6,'(1x,a,1x,a4)') stat(1),comp(1)
c       write(6,*)' rate',rate(1)
c       write(6,*) year(1),month(1),day(1),hour(1),min(1),sec(1)
 
c
c   make seisan headers
c
      ichan=1
      nchan=1
      cbyte(1)=' '   ! 2 byte data
      call sheads(year,month,day,hour,min,sec,nchan,ichan,
     *                 net_code,mainhead_text,stat,comp,nsamp,
     *                 rate,cbyte,
     *                 outfile,mainhead,chahead)

      write(6,200) outfile(1:29)                                             
 200  format(/,' Output file name is: ',a29)                                
c
c   write response from header if there
c
       if(f(1).ne.0.and.gain(1).ne.0.0) then
          chahead(201:208)= ' 1.00e9 '   ! factor is 10**9 counts/m
          chahead(78:78)='T'             ! use table only
          do i=1,2
            j1=(i-1)*10 + 1
            j2=j1+9
            i1=320+(i-1)*240+1
            i2=i1+79
            i3=400+(i-1)*240+1
            i4=i3+79
            i5=480+(i-1)*240+1
            i6=i5+79
            write(chahead(i1:i2),'(10g8.3)')(f(j),j=j1,j2)
            write(chahead(i3:i4),'(10g8.3)')(1.0/gain(j),j=j1,j2)
            write(chahead(i5:i6),'(10f8.3)')(phase(j),j=j1,j2)
         enddo
       else
         write(6,*)' No response info in input file, will try CAL'
c
c   read response curve into header
c

           call read_resp_head(chahead)                         
       endif
c
c   open output file
c
      open(2,file=outfile,status='unknown',form='unformatted')	  
c
c   read data
c
      open(1,file=infile,access='direct',recl=2)
c
      do i=1,nsamp(1)
         read(1,rec=i+256) data(i)
      enddo
c
c   write data
c
      write(6,'(1x,a)')mainhead(1)(1:79)
      write(6,'(1x,a)')chahead(1:79)
      do i=1,12
         write(2)mainhead(i)
      enddo
      write(2) chahead
c
c   swap if on sun
c
      if(sun) call swap2(nsamp(1),data)
c
      write(2)(data(i),i=1,nsamp(1))
      write(6,*)
c
c  back for next file if many
c
      if(in.eq.1) goto 1000	  	  	  	  		 	     	  
      stop
      end	   	  	  	         	  	  
								  
